"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var a1=["require","exports","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/arraysFind","vs/base/common/charCode","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/platform","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/cache","vs/base/common/types","vs/base/common/objects","vs/base/common/uint","vs/base/common/strings","vs/base/common/worker/simpleWorker"],g1=function(n1){for(var e=[],b=0,t=n1.length;b<t;b++)e[b]=a1[n1[b]];return e};define(a1[6],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=b,e.$jb=t,e.$kb=B,e.$lb=A,e.$mb=Q,e.$nb=z,e.$ob=O,e.$qb=S,e.$rb=F,e.$sb=G,e.$tb=i1,e.$ub=l1;function b(k,K){const N=t(k,K);if(N!==-1)return k[N]}function t(k,K,N=k.length-1){for(let g=N;g>=0;g--){const m=k[g];if(K(m))return g}return-1}function B(k,K){const N=A(k,K);return N===-1?void 0:k[N]}function A(k,K,N=0,g=k.length){let m=N,w=g;for(;m<w;){const o=Math.floor((m+w)/2);K(k[o])?m=o+1:w=o}return m-1}function Q(k,K){const N=z(k,K);return N===k.length?void 0:k[N]}function z(k,K,N=0,g=k.length){let m=N,w=g;for(;m<w;){const o=Math.floor((m+w)/2);K(k[o])?w=o:m=o+1}return m}function O(k,K,N=0,g=k.length){const m=z(k,K,N,g);return m===k.length?-1:m}class U{constructor(K){this.e=K,this.c=0}findLastMonotonous(K){if(U.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!K(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=K}const N=A(this.e,K,this.c);return this.c=N+1,N===-1?void 0:this.e[N]}}e.$pb=U,U.assertInvariants=!1;function S(k,K){if(k.length===0)return;let N=k[0];for(let g=1;g<k.length;g++){const m=k[g];K(m,N)>0&&(N=m)}return N}function F(k,K){if(k.length===0)return;let N=k[0];for(let g=1;g<k.length;g++){const m=k[g];K(m,N)>=0&&(N=m)}return N}function G(k,K){return S(k,(N,g)=>-K(N,g))}function i1(k,K){if(k.length===0)return-1;let N=0;for(let g=1;g<k.length;g++){const m=k[g];K(m,k[N])>0&&(N=g)}return N}function l1(k,K){for(const N of k){const g=K(N);if(g!==void 0)return g}}}),define(a1[7],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var b;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(b||(e.CharCode=b={}))}),define(a1[8],g1([0,1]),function(n1,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$I=void 0,e.$E=t,e.$F=B,e.$G=A,e.$H=Q;function t(O,U){const S=Object.create(null);for(const F of O){const G=U(F);let i1=S[G];i1||(i1=S[G]=[]),i1.push(F)}return S}function B(O,U){const S=[],F=[];for(const G of O)U.has(G)||S.push(G);for(const G of U)O.has(G)||F.push(G);return{removed:S,added:F}}function A(O,U){const S=[],F=[];for(const[G,i1]of O)U.has(G)||S.push(i1);for(const[G,i1]of U)O.has(G)||F.push(i1);return{removed:S,added:F}}function Q(O,U){const S=new Set;for(const F of U)O.has(F)&&S.add(F);return S}class z{constructor(U,S){this.b=S,this.a=new Map,this[b]="SetWithKey";for(const F of U)this.add(F)}get size(){return this.a.size}add(U){const S=this.b(U);return this.a.set(S,U),this}delete(U){return this.a.delete(this.b(U))}has(U){return this.a.has(this.b(U))}*entries(){for(const U of this.a.values())yield[U,U]}keys(){return this.values()}*values(){for(const U of this.a.values())yield U}clear(){this.a.clear()}forEach(U,S){this.a.forEach(F=>U.call(S,F,F,this))}[Symbol.iterator](){return this.values()}}e.$I=z,b=Symbol.toStringTag}),define(a1[2],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=t,e.$2=B,e.$3=A,e.$4=Q,e.$5=z,e.$6=O,e.$7=S,e.$9=G,e.$0=i1,e.$$=l1,e.$ab=K;class b{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?w.isErrorNoTelemetry(s)?new w(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(l=>{l(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$Y=b,e.$Z=new b;function t(n){e.$Z.setUnexpectedErrorHandler(n)}function B(n){if(!n||typeof n!="object")return!1;const s=n;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}function A(n){S(n)||e.$Z.onUnexpectedError(n)}function Q(n){S(n)||e.$Z.onUnexpectedExternalError(n)}function z(n){if(n instanceof Error){const{name:s,message:l}=n,u=n.stacktrace||n.stack;return{$isError:!0,name:s,message:l,stack:u,noTelemetry:w.isErrorNoTelemetry(n)}}return n}function O(n){let s;return n.noTelemetry?s=new w:(s=new Error,s.name=n.name),s.message=n.message,s.stack=n.stack,s}const U="Canceled";function S(n){return n instanceof F?!0:n instanceof Error&&n.name===U&&n.message===U}class F extends Error{constructor(){super(U),this.name=this.message}}e.$8=F;function G(){const n=new Error(U);return n.name=n.message,n}function i1(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function l1(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class k extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=k;function K(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class N extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$bb=N;class g extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$cb=g;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=m;class w extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof w)return s;const l=new w;return l.message=s.message,l.stack=s.stack,l}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$eb=w;class o extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$fb=o}),define(a1[9],g1([0,1,2,6]),function(n1,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=B,e.$wb=A,e.$xb=Q,e.$yb=z,e.$zb=O,e.$Ab=U,e.$Bb=S,e.$Cb=F,e.$Db=G,e.$Eb=i1,e.$Fb=l1,e.$Gb=k,e.$Hb=K,e.top=N,e.$Jb=g,e.$Kb=w,e.$Lb=o,e.$Mb=n,e.$Nb=s,e.$Ob=l,e.$Pb=u,e.$Qb=L,e.$Rb=D,e.$Sb=J,e.$Tb=E1,e.$Ub=W,e.$Vb=_1,e.$Wb=T,e.$Xb=a,e.$Yb=M,e.$Zb=j,e.$1b=v,e.$2b=E,e.$3b=p,e.$4b=x,e.$5b=Y,e.$6b=t1,e.$7b=s1,e.$8b=X,e.$9b=I1,e.$0b=w1,e.$ac=P1;function B(c,_=0){return c[c.length-(1+_)]}function A(c){if(c.length===0)throw new Error("Invalid tail call");return[c.slice(0,c.length-1),c[c.length-1]]}function Q(c,_,f=(d,R)=>d===R){if(c===_)return!0;if(!c||!_||c.length!==_.length)return!1;for(let d=0,R=c.length;d<R;d++)if(!f(c[d],_[d]))return!1;return!0}function z(c,_){const f=c.length-1;_<f&&(c[_]=c[f]),c.pop()}function O(c,_,f){return U(c.length,d=>f(c[d],_))}function U(c,_){let f=0,d=c-1;for(;f<=d;){const R=(f+d)/2|0,Z=_(R);if(Z<0)f=R+1;else if(Z>0)d=R-1;else return R}return-(f+1)}function S(c,_,f){if(c=c|0,c>=_.length)throw new TypeError("invalid index");const d=_[Math.floor(_.length*Math.random())],R=[],Z=[],c1=[];for(const d1 of _){const $1=f(d1,d);$1<0?R.push(d1):$1>0?Z.push(d1):c1.push(d1)}return c<R.length?S(c,R,f):c<R.length+c1.length?c1[0]:S(c-(R.length+c1.length),Z,f)}function F(c,_){const f=[];let d;for(const R of c.slice(0).sort(_))!d||_(d[0],R)!==0?(d=[R],f.push(d)):d.push(R);return f}function*G(c,_){let f,d;for(const R of c)d!==void 0&&_(d,R)?f.push(R):(f&&(yield f),f=[R]),d=R;f&&(yield f)}function i1(c,_){for(let f=0;f<=c.length;f++)_(f===0?void 0:c[f-1],f===c.length?void 0:c[f])}function l1(c,_){for(let f=0;f<c.length;f++)_(f===0?void 0:c[f-1],c[f],f+1===c.length?void 0:c[f+1])}function k(c,_,f){const d=[];function R(d1,$1,U1){if($1===0&&U1.length===0)return;const y=d[d.length-1];y&&y.start+y.deleteCount===d1?(y.deleteCount+=$1,y.toInsert.push(...U1)):d.push({start:d1,deleteCount:$1,toInsert:U1})}let Z=0,c1=0;for(;;){if(Z===c.length){R(Z,0,_.slice(c1));break}if(c1===_.length){R(Z,c.length-Z,[]);break}const d1=c[Z],$1=_[c1],U1=f(d1,$1);U1===0?(Z+=1,c1+=1):U1<0?(R(Z,1,[]),Z+=1):U1>0&&(R(Z,0,[$1]),c1+=1)}return d}function K(c,_,f){const d=k(c,_,f),R=[],Z=[];for(const c1 of d)R.push(...c.slice(c1.start,c1.start+c1.deleteCount)),Z.push(...c1.toInsert);return{removed:R,added:Z}}function N(c,_,f){if(f===0)return[];const d=c.slice(0,f).sort(_);return m(c,_,d,f,c.length),d}function g(c,_,f,d,R){return f===0?Promise.resolve([]):new Promise((Z,c1)=>{(async()=>{const d1=c.length,$1=c.slice(0,f).sort(_);for(let U1=f,y=Math.min(f+d,d1);U1<d1;U1=y,y=Math.min(y+d,d1)){if(U1>f&&await new Promise(I=>setTimeout(I)),R&&R.isCancellationRequested)throw new b.$8;m(c,_,$1,U1,y)}return $1})().then(Z,c1)})}function m(c,_,f,d,R){for(const Z=f.length;d<R;d++){const c1=c[d];if(_(c1,f[Z-1])<0){f.pop();const d1=(0,t.$nb)(f,$1=>_(c1,$1)<0);f.splice(d1,0,c1)}}}function w(c){return c.filter(_=>!!_)}function o(c){let _=0;for(let f=0;f<c.length;f++)c[f]&&(c[_]=c[f],_+=1);c.length=_}function n(c,_,f){c.splice(f,0,c.splice(_,1)[0])}function s(c){return!Array.isArray(c)||c.length===0}function l(c){return Array.isArray(c)&&c.length>0}function u(c,_=f=>f){const f=new Set;return c.filter(d=>{const R=_(d);return f.has(R)?!1:(f.add(R),!0)})}function L(c){const _=new Set;return f=>{const d=c(f);return _.has(d)?!1:(_.add(d),!0)}}function D(c,_){return c.length>0?c[0]:_}function J(c,_){return c.length>0?c[c.length-1]:_}function E1(c,_,f=(d,R)=>d===R){let d=0;for(let R=0,Z=Math.min(c.length,_.length);R<Z&&f(c[R],_[R]);R++)d++;return d}function W(c,_){let f=typeof _=="number"?c:0;typeof _=="number"?f=c:(f=0,_=c);const d=[];if(f<=_)for(let R=f;R<_;R++)d.push(R);else for(let R=f;R>_;R--)d.push(R);return d}function _1(c,_,f){return c.reduce((d,R)=>(d[_(R)]=f?f(R):R,d),Object.create(null))}function T(c,_){return c.push(_),()=>a(c,_)}function a(c,_){const f=c.indexOf(_);if(f>-1)return c.splice(f,1),_}function M(c,_,f){const d=c.slice(0,_),R=c.slice(_);return d.concat(f,R)}function j(c,_){let f;if(typeof _=="number"){let d=_;f=()=>{const R=Math.sin(d++)*179426549;return R-Math.floor(R)}}else f=Math.random;for(let d=c.length-1;d>0;d-=1){const R=Math.floor(f()*(d+1)),Z=c[d];c[d]=c[R],c[R]=Z}}function v(c,_){const f=c.indexOf(_);f>-1&&(c.splice(f,1),c.unshift(_))}function E(c,_){const f=c.indexOf(_);f>-1&&(c.splice(f,1),c.push(_))}function p(c,_){for(const f of _)c.push(f)}function x(c,_){return Array.isArray(c)?c.map(_):_(c)}function Y(c){return Array.isArray(c)?c:[c]}function t1(c){return c[Math.floor(Math.random()*c.length)]}function s1(c,_,f){const d=C(c,_),R=c.length,Z=f.length;c.length=R+Z;for(let c1=R-1;c1>=d;c1--)c[c1+Z]=c[c1];for(let c1=0;c1<Z;c1++)c[c1+d]=f[c1]}function X(c,_,f,d){const R=C(c,_);let Z=c.splice(R,f);return Z===void 0&&(Z=[]),s1(c,R,d),Z}function C(c,_){return _<0?Math.max(_+c.length,0):Math.min(_,c.length)}var o1;(function(c){function _(Z){return Z<0}c.isLessThan=_;function f(Z){return Z<=0}c.isLessThanOrEqual=f;function d(Z){return Z>0}c.isGreaterThan=d;function R(Z){return Z===0}c.isNeitherLessOrGreaterThan=R,c.greaterThan=1,c.lessThan=-1,c.neitherLessOrGreaterThan=0})(o1||(e.CompareResult=o1={}));function I1(c,_){return(f,d)=>_(c(f),c(d))}function w1(...c){return(_,f)=>{for(const d of c){const R=d(_,f);if(!o1.isNeitherLessOrGreaterThan(R))return R}return o1.neitherLessOrGreaterThan}}const L1=(c,_)=>c-_;e.$$b=L1;const S1=(c,_)=>(0,e.$$b)(c?1:0,_?1:0);e.$_b=S1;function P1(c){return(_,f)=>-c(_,f)}class B1{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let f=this.c;for(;f<this.g.length&&_(this.g[f]);)f++;const d=f===this.c?null:this.g.slice(this.c,f);return this.c=f,d}takeFromEndWhile(_){let f=this.d;for(;f>=0&&_(this.g[f]);)f--;const d=f===this.d?null:this.g.slice(f+1,this.d+1);return this.d=f,d}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const f=this.g.slice(this.c,this.c+_);return this.c+=_,f}}e.$bc=B1;class O1{constructor(_){this.iterate=_}forEach(_){this.iterate(f=>(_(f),!0))}toArray(){const _=[];return this.iterate(f=>(_.push(f),!0)),_}filter(_){return new O1(f=>this.iterate(d=>_(d)?f(d):!0))}map(_){return new O1(f=>this.iterate(d=>f(_(d))))}some(_){let f=!1;return this.iterate(d=>(f=_(d),!f)),f}findFirst(_){let f;return this.iterate(d=>_(d)?(f=d,!1):!0),f}findLast(_){let f;return this.iterate(d=>(_(d)&&(f=d),!0)),f}findLastMaxBy(_){let f,d=!0;return this.iterate(R=>((d||o1.isGreaterThan(_(R,f)))&&(d=!1,f=R),!0)),f}}e.$cc=O1,O1.empty=new O1(c=>{});class T1{constructor(_){this.c=_}static createSortPermutation(_,f){const d=Array.from(_.keys()).sort((R,Z)=>f(_[R],_[Z]));return new T1(d)}apply(_){return _.map((f,d)=>_[this.c[d]])}inverse(){const _=this.c.slice();for(let f=0;f<this.c.length;f++)_[this.c[f]]=f;return new T1(_)}}e.$dc=T1}),define(a1[3],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=b;function b(t,B){const A=this;let Q=!1,z;return function(){if(Q)return z;if(Q=!0,B)try{z=t.apply(A,arguments)}finally{B()}else z=t.apply(A,arguments);return z}}}),define(a1[10],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(t){function B(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}t.is=B;const A=Object.freeze([]);function Q(){return A}t.empty=Q;function*z(s){yield s}t.single=z;function O(s){return B(s)?s:z(s)}t.wrap=O;function U(s){return s||A}t.from=U;function*S(s){for(let l=s.length-1;l>=0;l--)yield s[l]}t.reverse=S;function F(s){return!s||s[Symbol.iterator]().next().done===!0}t.isEmpty=F;function G(s){return s[Symbol.iterator]().next().value}t.first=G;function i1(s,l){let u=0;for(const L of s)if(l(L,u++))return!0;return!1}t.some=i1;function l1(s,l){for(const u of s)if(l(u))return u}t.find=l1;function*k(s,l){for(const u of s)l(u)&&(yield u)}t.filter=k;function*K(s,l){let u=0;for(const L of s)yield l(L,u++)}t.map=K;function*N(s,l){let u=0;for(const L of s)yield*l(L,u++)}t.flatMap=N;function*g(...s){for(const l of s)yield*l}t.concat=g;function m(s,l,u){let L=u;for(const D of s)L=l(L,D);return L}t.reduce=m;function*w(s,l,u=s.length){for(l<0&&(l+=s.length),u<0?u+=s.length:u>s.length&&(u=s.length);l<u;l++)yield s[l]}t.slice=w;function o(s,l=Number.POSITIVE_INFINITY){const u=[];if(l===0)return[u,s];const L=s[Symbol.iterator]();for(let D=0;D<l;D++){const J=L.next();if(J.done)return[u,t.empty()];u.push(J.value)}return[u,{[Symbol.iterator](){return L}}]}t.consume=o;async function n(s){const l=[];for await(const u of s)l.push(u);return Promise.resolve(l)}t.asyncToArray=n})(b||(e.Iterable=b={}))}),define(a1[11],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class b{constructor(B){this.d=B,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(B){this.c=B}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=b}),define(a1[12],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class b{constructor(A){this.element=A,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class t{constructor(){this.a=b.Undefined,this.b=b.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===b.Undefined}clear(){let A=this.a;for(;A!==b.Undefined;){const Q=A.next;A.prev=b.Undefined,A.next=b.Undefined,A=Q}this.a=b.Undefined,this.b=b.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,Q){const z=new b(A);if(this.a===b.Undefined)this.a=z,this.b=z;else if(Q){const U=this.b;this.b=z,z.prev=U,U.next=z}else{const U=this.a;this.a=z,z.next=U,U.prev=z}this.c+=1;let O=!1;return()=>{O||(O=!0,this.e(z))}}shift(){if(this.a!==b.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==b.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==b.Undefined&&A.next!==b.Undefined){const Q=A.prev;Q.next=A.next,A.next.prev=Q}else A.prev===b.Undefined&&A.next===b.Undefined?(this.a=b.Undefined,this.b=b.Undefined):A.next===b.Undefined?(this.b=this.b.prev,this.b.next=b.Undefined):A.prev===b.Undefined&&(this.a=this.a.next,this.a.prev=b.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==b.Undefined;)yield A.element,A=A.next}}e.$8c=t}),define(a1[13],g1([0,1]),function(n1,e){"use strict";var b,t,B;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=A,e.$Bc=Q,e.$Cc=z,e.$Lc=w;function A(o,n,s){let l=o.get(n);return l===void 0&&(l=s,o.set(n,l)),l}function Q(o){const n=[];return o.forEach((s,l)=>{n.push(`${l} => ${s}`)}),`Map(${o.size}) {${n.join(", ")}}`}function z(o){const n=[];return o.forEach(s=>{n.push(s)}),`Set(${o.size}) {${n.join(", ")}}`}class O{constructor(n,s){this.uri=n,this.value=s}}function U(o){return Array.isArray(o)}class S{constructor(n,s){if(this[b]="ResourceMap",n instanceof S)this.d=new Map(n.d),this.e=s??S.c;else if(U(n)){this.d=new Map,this.e=s??S.c;for(const[l,u]of n)this.set(l,u)}else this.d=new Map,this.e=n??S.c}set(n,s){return this.d.set(this.e(n),new O(n,s)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[l,u]of this.d)n(u.value,u.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Dc=S,S.c=o=>o.toString();class F{constructor(n,s){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new S(n):(this.c=new S(s),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,s){this.c.forEach((l,u)=>n.call(s,u,u,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=F;var G;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(G||(e.Touch=G={}));class i1{constructor(){this[B]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,s=G.None){const l=this.c.get(n);if(l)return s!==G.None&&this.m(l,s),l.value}set(n,s,l=G.None){let u=this.c.get(n);if(u)u.value=s,l!==G.None&&this.m(u,l);else{switch(u={key:n,value:s,next:void 0,previous:void 0},l){case G.None:this.k(u);break;case G.AsOld:this.j(u);break;case G.AsNew:this.k(u);break;default:this.k(u);break}this.c.set(n,u),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this.c.get(n);if(s)return this.c.delete(n),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,s){const l=this.g;let u=this.d;for(;u;){if(s?n.bind(s)(u.value,u.key,this):n(u.value,u.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,s=this.g;let l=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const L={value:l.key,done:!1};return l=l.next,L}else return{value:void 0,done:!0}}};return u}values(){const n=this,s=this.g;let l=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const L={value:l.value,done:!1};return l=l.next,L}else return{value:void 0,done:!0}}};return u}entries(){const n=this,s=this.g;let l=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const L={value:[l.key,l.value],done:!1};return l=l.next,L}else return{value:void 0,done:!0}}};return u}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.d,l=this.size;for(;s&&l>n;)this.c.delete(s.key),s=s.next,l--;this.d=s,this.f=l,s&&(s.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this.e,l=this.size;for(;s&&l>n;)this.c.delete(s.key),s=s.previous,l--;this.e=s,this.f=l,s&&(s.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const s=n.next,l=n.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}n.next=void 0,n.previous=void 0,this.g++}m(n,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==G.AsOld&&s!==G.AsNew)){if(s===G.AsOld){if(n===this.d)return;const l=n.next,u=n.previous;n===this.e?(u.next=void 0,this.e=u):(l.previous=u,u.next=l),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(s===G.AsNew){if(n===this.e)return;const l=n.next,u=n.previous;n===this.d?(l.previous=void 0,this.d=l):(l.previous=u,u.next=l),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((s,l)=>{n.push([l,s])}),n}fromJSON(n){this.clear();for(const[s,l]of n)this.set(s,l)}}e.$Fc=i1;class l1 extends i1{constructor(n,s=1){super(),this.n=n,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,s=G.AsNew){return super.get(n,s)}peek(n){return super.get(n,G.None)}set(n,s){return super.set(n,s,G.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class k extends l1{constructor(n,s=1){super(n,s)}q(n){this.h(n)}set(n,s){return super.set(n,s),this.p(),this}}e.$Gc=k;class K extends l1{constructor(n,s=1){super(n,s)}q(n){this.i(n)}set(n,s){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,s),this}}e.$Hc=K;class N{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let s=this.c.get(n)||0;return s===0?!1:(s--,s===0?this.c.delete(n):this.c.set(n,s),!0)}has(n){return this.c.has(n)}}e.$Ic=N;class g{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[s,l]of n)this.set(s,l)}clear(){this.c.clear(),this.d.clear()}set(n,s){this.c.set(n,s),this.d.set(s,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const s=this.c.get(n);return s===void 0?!1:(this.c.delete(n),this.d.delete(s),!0)}forEach(n,s){this.c.forEach((l,u)=>{n.call(s,l,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=g;class m{constructor(){this.c=new Map}add(n,s){let l=this.c.get(n);l||(l=new Set,this.c.set(n,l)),l.add(s)}delete(n,s){const l=this.c.get(n);l&&(l.delete(s),l.size===0&&this.c.delete(n))}forEach(n,s){const l=this.c.get(n);l&&l.forEach(s)}get(n){const s=this.c.get(n);return s||new Set}}e.$Kc=m;function w(o,n){if(o===n)return!0;if(o.size!==n.size)return!1;for(const[s,l]of o)if(!n.has(s)||n.get(s)!==l)return!1;for(const[s]of n)if(!o.has(s))return!1;return!0}}),define(a1[4],g1([0,1,9,8,13,3,10]),function(n1,e,b,t,B,A,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=S,e.$Oc=F,e.$Pc=G,e.$Qc=k,e.$Rc=K,e.$Sc=N,e.$Tc=g,e.$Uc=m,e.$Vc=w,e.$6c=W;const z=!1;let O=null;class U{constructor(){this.b=new Map}c(a){let M=this.b.get(a);return M||(M={parent:null,source:null,isSingleton:!1,value:a,idx:U.a++},this.b.set(a,M)),M}trackDisposable(a){const M=this.c(a);M.source||(M.source=new Error().stack)}setParent(a,M){const j=this.c(a);j.parent=M}markAsDisposed(a){this.b.delete(a)}markAsSingleton(a){this.c(a).isSingleton=!0}f(a,M){const j=M.get(a);if(j)return j;const v=a.parent?this.f(this.c(a.parent),M):a;return M.set(a,v),v}getTrackedDisposables(){const a=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,a).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(a=10,M){let j;if(M)j=M;else{const Y=new Map,t1=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,Y).isSingleton);if(t1.length===0)return;const s1=new Set(t1.map(X=>X.value));if(j=t1.filter(X=>!(X.parent&&s1.has(X.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function v(Y){function t1(X,C){for(;X.length>0&&C.some(o1=>typeof o1=="string"?o1===X[0]:X[0].match(o1));)X.shift()}const s1=Y.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return t1(s1,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),s1.reverse()}const E=new B.$Kc;for(const Y of j){const t1=v(Y);for(let s1=0;s1<=t1.length;s1++)E.add(t1.slice(0,s1).join(`
`),Y)}j.sort((0,b.$9b)(Y=>Y.idx,b.$$b));let p="",x=0;for(const Y of j.slice(0,a)){x++;const t1=v(Y),s1=[];for(let X=0;X<t1.length;X++){let C=t1[X];C=`(shared with ${E.get(t1.slice(0,X+1).join(`
`)).size}/${j.length} leaks) at ${C}`;const I1=E.get(t1.slice(0,X).join(`
`)),w1=(0,t.$E)([...I1].map(L1=>v(L1)[X]),L1=>L1);delete w1[t1[X]];for(const[L1,S1]of Object.entries(w1))s1.unshift(`    - stacktraces of ${S1.length} other leaks continue with ${L1}`);s1.unshift(C)}p+=`


==================== Leaking disposable ${x}/${j.length}: ${Y.value.constructor.name} ====================
${s1.join(`
`)}
============================================================

`}return j.length>a&&(p+=`


... and ${j.length-a} more leaking disposables

`),{leaks:j,details:p}}}e.$Mc=U,U.a=0;function S(T){O=T}if(z){const T="__is_disposable_tracked__";S(new class{trackDisposable(a){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[T]||console.log(M)},3e3)}setParent(a,M){if(a&&a!==n.None)try{a[T]=!0}catch{}}markAsDisposed(a){if(a&&a!==n.None)try{a[T]=!0}catch{}}markAsSingleton(a){}})}function F(T){return O?.trackDisposable(T),T}function G(T){O?.markAsDisposed(T)}function i1(T,a){O?.setParent(T,a)}function l1(T,a){if(O)for(const M of T)O.setParent(M,a)}function k(T){return O?.markAsSingleton(T),T}function K(T){return typeof T=="object"&&T!==null&&typeof T.dispose=="function"&&T.dispose.length===0}function N(T){if(Q.Iterable.is(T)){const a=[];for(const M of T)if(M)try{M.dispose()}catch(j){a.push(j)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(T)?[]:T}else if(T)return T.dispose(),T}function g(T){for(const a of T)K(a)&&a.dispose();return[]}function m(...T){const a=w(()=>N(T));return l1(T,a),a}function w(T){const a=F({dispose:(0,A.$gb)(()=>{G(a),T()})});return a}class o{constructor(){this.f=new Set,this.g=!1,F(this)}dispose(){this.g||(G(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{N(this.f)}finally{this.f.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return i1(a,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(a),a}delete(a){if(a){if(a===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(a),a.dispose()}}deleteAndLeak(a){a&&this.f.has(a)&&(this.f.delete(a),i1(a,null))}}e.$Wc=o,o.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this.q=new o,F(this),i1(this.q,this)}dispose(){G(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.$Xc=n,n.None=Object.freeze({dispose(){}});class s{constructor(){this.b=!1,F(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&i1(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,G(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&i1(a,null),a}}e.$Yc=s;class l{constructor(a){this.a=new s,this.b=!1,this.a.value=a}get value(){return this.a.value}set value(a){this.b||a===this.a.value||(this.a.value=a)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=l;class u{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=u;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,F(this)}set(a){let M=a;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,G(this))},this}}e.$2c=L;class D{constructor(){this.a=new Map}acquire(a,...M){let j=this.a.get(a);j||(j={counter:0,object:this.b(a,...M)},this.a.set(a,j));const{object:v}=j,E=(0,A.$gb)(()=>{--j.counter===0&&(this.c(a,j.object),this.a.delete(a))});return j.counter++,{object:v,dispose:E}}}e.$3c=D;class J{constructor(a){this.a=a}async acquire(a,...M){const j=this.a.acquire(a,...M);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(v){throw j.dispose(),v}}}e.$4c=J;class E1{constructor(a){this.object=a}dispose(){}}e.$5c=E1;function W(T){const a=new o;try{T(a)}finally{a.dispose()}}class _1{constructor(){this.a=new Map,this.b=!1,F(this)}dispose(){G(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{N(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get size(){return this.a.size}get(a){return this.a.get(a)}set(a,M,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(a)?.dispose(),this.a.set(a,M)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}deleteAndLeak(a){const M=this.a.get(a);return this.a.delete(a),M}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=_1}),define(a1[14],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=n,e.$x=J,e.$D=E1,e.$a="en";let b=!1,t=!1,B=!1,A=!1,Q=!1,z=!1,O=!1,U=!1,S=!1,F=!1,G,i1=e.$a,l1=e.$a,k,K;const N=globalThis;let g;typeof N.vscode<"u"&&typeof N.vscode.process<"u"?g=N.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(g=process);const m=typeof g?.versions?.electron=="string",w=m&&g?.type==="renderer";if(typeof g=="object"){b=g.platform==="win32",t=g.platform==="darwin",B=g.platform==="linux",A=B&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,O=m,S=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,G=e.$a,i1=e.$a;const W=g.env.VSCODE_NLS_CONFIG;if(W)try{const _1=JSON.parse(W),T=_1.availableLanguages["*"];G=_1.locale,l1=_1.osLocale,i1=T||e.$a,k=_1._translationsConfigFile}catch{}Q=!0}else if(typeof navigator=="object"&&!w){K=navigator.userAgent,b=K.indexOf("Windows")>=0,t=K.indexOf("Macintosh")>=0,U=(K.indexOf("Macintosh")>=0||K.indexOf("iPad")>=0||K.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,B=K.indexOf("Linux")>=0,F=K?.indexOf("Mobi")>=0,z=!0,G=e.$a,i1=G,l1=navigator.language;const W=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),_1=W&&W.getAttribute("data-settings");if(_1)try{const T=JSON.parse(_1),a=T.availableLanguages["*"];G=T.locale,l1=T.osLocale,i1=a||e.$a,k=T._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var o;(function(W){W[W.Web=0]="Web",W[W.Mac=1]="Mac",W[W.Linux=2]="Linux",W[W.Windows=3]="Windows"})(o||(e.Platform=o={}));function n(W){switch(W){case o.Web:return"Web";case o.Mac:return"Mac";case o.Linux:return"Linux";case o.Windows:return"Windows"}}let s=o.Web;t?s=o.Mac:b?s=o.Windows:B&&(s=o.Linux),e.$c=b,e.$d=t,e.$e=B,e.$f=A,e.$g=Q,e.$h=O,e.$i=z,e.$j=z&&typeof N.importScripts=="function",e.$k=e.$j?N.origin:void 0,e.$l=U,e.$m=F,e.$n=S,e.$o=s,e.$p=K,e.$q=i1;var l;(function(W){function _1(){return e.$q}W.value=_1;function T(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}W.isDefaultVariant=T;function a(){return e.$q==="en"}W.isDefault=a})(l||(e.Language=l={})),e.$r=G,e.$s=l1,e.$t=k,e.$u=typeof N.postMessage=="function"&&!N.importScripts,e.$v=(()=>{if(e.$u){const W=[];N.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let a=0,M=W.length;a<M;a++){const j=W[a];if(j.id===T.data.vscodeScheduleAsyncWork){W.splice(a,1),j.callback();return}}});let _1=0;return T=>{const a=++_1;W.push({id:a,callback:T}),N.postMessage({vscodeScheduleAsyncWork:a},"*")}}return W=>setTimeout(W)})();var u;(function(W){W[W.Windows=1]="Windows",W[W.Macintosh=2]="Macintosh",W[W.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=t||U?u.Macintosh:b?u.Windows:u.Linux;let L=!0,D=!1;function J(){if(!D){D=!0;const W=new Uint8Array(2);W[0]=1,W[1]=2,L=new Uint16Array(W.buffer)[0]===513}return L}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function E1(W){return parseFloat(W)>=20}}),define(a1[15],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const b=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(A){return new t(A)}constructor(A){this.c=b&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=t}),define(a1[5],g1([0,1,2,3,4,12,15]),function(n1,e,b,t,B,A,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=i1;const z=!1,O=!1,U=!1;var S;(function(v){v.None=()=>B.$Xc.None;function E(y){if(U){const{onDidAddListener:I}=y,H=k.create();let P=0;y.onDidAddListener=()=>{++P===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),H.print()),I?.()}}}function p(y,I){return L1(y,()=>{},0,void 0,!0,void 0,I)}v.defer=p;function x(y){return(I,H=null,P)=>{let V=!1,e1;return e1=y(f1=>{if(!V)return e1?e1.dispose():V=!0,I.call(H,f1)},null,P),V&&e1.dispose(),e1}}v.once=x;function Y(y,I,H){return I1((P,V=null,e1)=>y(f1=>P.call(V,I(f1)),null,e1),H)}v.map=Y;function t1(y,I,H){return I1((P,V=null,e1)=>y(f1=>{I(f1),P.call(V,f1)},null,e1),H)}v.forEach=t1;function s1(y,I,H){return I1((P,V=null,e1)=>y(f1=>I(f1)&&P.call(V,f1),null,e1),H)}v.filter=s1;function X(y){return y}v.signal=X;function C(...y){return(I,H=null,P)=>{const V=(0,B.$Uc)(...y.map(e1=>e1(f1=>I.call(H,f1))));return w1(V,P)}}v.any=C;function o1(y,I,H,P){let V=H;return Y(y,e1=>(V=I(V,e1),V),P)}v.reduce=o1;function I1(y,I){let H;const P={onWillAddFirstListener(){H=y(V.fire,V)},onDidRemoveLastListener(){H?.dispose()}};I||E(P);const V=new s(P);return I?.add(V),V.event}function w1(y,I){return I instanceof Array?I.push(y):I&&I.add(y),y}function L1(y,I,H=100,P=!1,V=!1,e1,f1){let b1,m1,N1,k1=0,y1;const r1={leakWarningThreshold:e1,onWillAddFirstListener(){b1=y(j1=>{k1++,m1=I(m1,j1),P&&!N1&&(R1.fire(m1),m1=void 0),y1=()=>{const H1=m1;m1=void 0,N1=void 0,(!P||k1>1)&&R1.fire(H1),k1=0},typeof H=="number"?(clearTimeout(N1),N1=setTimeout(y1,H)):N1===void 0&&(N1=0,queueMicrotask(y1))})},onWillRemoveListener(){V&&k1>0&&y1?.()},onDidRemoveLastListener(){y1=void 0,b1.dispose()}};f1||E(r1);const R1=new s(r1);return f1?.add(R1),R1.event}v.debounce=L1;function S1(y,I=0,H){return v.debounce(y,(P,V)=>P?(P.push(V),P):[V],I,void 0,!0,void 0,H)}v.accumulate=S1;function P1(y,I=(P,V)=>P===V,H){let P=!0,V;return s1(y,e1=>{const f1=P||!I(e1,V);return P=!1,V=e1,f1},H)}v.latch=P1;function B1(y,I,H){return[v.filter(y,I,H),v.filter(y,P=>!I(P),H)]}v.split=B1;function O1(y,I=!1,H=[],P){let V=H.slice(),e1=y(m1=>{V?V.push(m1):b1.fire(m1)});P&&P.add(e1);const f1=()=>{V?.forEach(m1=>b1.fire(m1)),V=null},b1=new s({onWillAddFirstListener(){e1||(e1=y(m1=>b1.fire(m1)),P&&P.add(e1))},onDidAddFirstListener(){V&&(I?setTimeout(f1):f1())},onDidRemoveLastListener(){e1&&e1.dispose(),e1=null}});return P&&P.add(b1),b1.event}v.buffer=O1;function T1(y,I){return(P,V,e1)=>{const f1=I(new _);return y(function(b1){const m1=f1.evaluate(b1);m1!==c&&P.call(V,m1)},void 0,e1)}}v.chain=T1;const c=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(I){return this.f.push(I),this}forEach(I){return this.f.push(H=>(I(H),H)),this}filter(I){return this.f.push(H=>I(H)?H:c),this}reduce(I,H){let P=H;return this.f.push(V=>(P=I(P,V),P)),this}latch(I=(H,P)=>H===P){let H=!0,P;return this.f.push(V=>{const e1=H||!I(V,P);return H=!1,P=V,e1?V:c}),this}evaluate(I){for(const H of this.f)if(I=H(I),I===c)break;return I}}function f(y,I,H=P=>P){const P=(...b1)=>f1.fire(H(...b1)),V=()=>y.on(I,P),e1=()=>y.removeListener(I,P),f1=new s({onWillAddFirstListener:V,onDidRemoveLastListener:e1});return f1.event}v.fromNodeEventEmitter=f;function d(y,I,H=P=>P){const P=(...b1)=>f1.fire(H(...b1)),V=()=>y.addEventListener(I,P),e1=()=>y.removeEventListener(I,P),f1=new s({onWillAddFirstListener:V,onDidRemoveLastListener:e1});return f1.event}v.fromDOMEventEmitter=d;function R(y){return new Promise(I=>x(y)(I))}v.toPromise=R;function Z(y){const I=new s;return y.then(H=>{I.fire(H)},()=>{I.fire(void 0)}).finally(()=>{I.dispose()}),I.event}v.fromPromise=Z;function c1(y,I,H){return I(H),y(P=>I(P))}v.runAndSubscribe=c1;class d1{constructor(I,H){this._observable=I,this.f=0,this.g=!1;const P={onWillAddFirstListener:()=>{I.addObserver(this)},onDidRemoveLastListener:()=>{I.removeObserver(this)}};H||E(P),this.emitter=new s(P),H&&H.add(this.emitter)}beginUpdate(I){this.f++}handlePossibleChange(I){}handleChange(I,H){this.g=!0}endUpdate(I){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $1(y,I){return new d1(y,I).emitter.event}v.fromObservable=$1;function U1(y){return(I,H,P)=>{let V=0,e1=!1;const f1={beginUpdate(){V++},endUpdate(){V--,V===0&&(y.reportChanges(),e1&&(e1=!1,I.call(H)))},handlePossibleChange(){},handleChange(){e1=!0}};y.addObserver(f1),y.reportChanges();const b1={dispose(){y.removeObserver(f1)}};return P instanceof B.$Wc?P.add(b1):Array.isArray(P)&&P.push(b1),b1}}v.fromObservableLight=U1})(S||(e.Event=S={}));class F{constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${F.f++}`,F.all.add(this)}start(E){this.g=new Q.$he,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$je=F,F.all=new Set,F.f=0;let G=-1;function i1(v){const E=G;return G=v,{dispose(){G=E}}}class l1{constructor(E,p,x=(l1.f++).toString(16).padStart(3,"0")){this.j=E,this.threshold=p,this.name=x,this.h=0}dispose(){this.g?.clear()}check(E,p){const x=this.threshold;if(x<=0||p<x)return;this.g||(this.g=new Map);const Y=this.g.get(E.value)||0;if(this.g.set(E.value,Y+1),this.h-=1,this.h<=0){this.h=x*.5;const[t1,s1]=this.getMostFrequentStack(),X=`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${s1}):`;console.warn(X),console.warn(t1);const C=new K(X,t1);this.j(C)}return()=>{const t1=this.g.get(E.value)||0;this.g.set(E.value,t1-1)}}getMostFrequentStack(){if(!this.g)return;let E,p=0;for(const[x,Y]of this.g)(!E||p<Y)&&(E=[x,Y],p=Y);return E}}l1.f=1;class k{static create(){const E=new Error;return new k(E.stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class K extends Error{constructor(E,p){super(E),this.name="ListenerLeakError",this.stack=p}}e.$le=K;class N extends Error{constructor(E,p){super(E),this.name="ListenerRefusalError",this.stack=p}}e.$me=N;let g=0;class m{constructor(E){this.value=E,this.id=g++}}const w=2,o=(v,E)=>{if(v instanceof m)E(v);else for(let p=0;p<v.length;p++){const x=v[p];x&&E(x)}};let n;if(z){const v=[];setInterval(()=>{v.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(v.join(`
`)),v.length=0)},3e3),n=new FinalizationRegistry(E=>{typeof E=="string"&&v.push(E)})}class s{constructor(E){this.z=0,this.f=E,this.g=G>0||this.f?.leakWarningThreshold?new l1(E?.onListenerError??b.$3,this.f?.leakWarningThreshold??G):void 0,this.j=this.f?._profName?new F(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(O){const E=this.u;queueMicrotask(()=>{o(E,p=>p.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(E,p,x)=>{if(this.g&&this.z>this.g.threshold**2){const C=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(C);const o1=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],I1=new N(`${C}. HINT: Stack shows most frequent listener (${o1[1]}-times)`,o1[0]);return(this.f?.onListenerError||b.$3)(I1),B.$Xc.None}if(this.m)return B.$Xc.None;p&&(E=E.bind(p));const Y=new m(E);let t1,s1;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Y.stack=k.create(),t1=this.g.check(Y.stack,this.z+1)),O&&(Y.stack=s1??k.create()),this.u?this.u instanceof m?(this.w??(this.w=new u),this.u=[this.u,Y]):this.u.push(Y):(this.f?.onWillAddFirstListener?.(this),this.u=Y,this.f?.onDidAddFirstListener?.(this)),this.z++;const X=(0,B.$Vc)(()=>{n?.unregister(X),t1?.(),this.A(Y)});if(x instanceof B.$Wc?x.add(X):Array.isArray(x)&&x.push(X),n){const C=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),o1=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(C);n.register(X,o1?.[2]??C,X)}return X}),this.q}A(E){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const p=this.u,x=p.indexOf(E);if(x===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,p[x]=void 0;const Y=this.w.current===this;if(this.z*w<=p.length){let t1=0;for(let s1=0;s1<p.length;s1++)p[s1]?p[t1++]=p[s1]:Y&&(this.w.end--,t1<this.w.i&&this.w.i--);p.length=t1}}B(E,p){if(!E)return;const x=this.f?.onListenerError||b.$3;if(!x){E.value(p);return}try{E.value(p)}catch(Y){x(Y)}}C(E){const p=E.current.u;for(;E.i<E.end;)this.B(p[E.i++],E.value);E.reset()}fire(E){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof m)this.B(this.u,E);else{const p=this.w;p.enqueue(this,E,this.u.length),this.C(p)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=s;const l=()=>new u;e.$oe=l;class u{constructor(){this.i=-1,this.end=0}enqueue(E,p,x){this.i=0,this.end=x,this.current=E,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class L extends s{async fireAsync(E,p,x){if(this.u)for(this.h||(this.h=new A.$8c),o(this.u,Y=>this.h.push([Y.value,E]));this.h.size>0&&!p.isCancellationRequested;){const[Y,t1]=this.h.shift(),s1=[],X={...t1,token:p,waitUntil:C=>{if(Object.isFrozen(s1))throw new Error("waitUntil can NOT be called asynchronous");x&&(C=x(C,Y)),s1.push(C)}};try{Y(X)}catch(C){(0,b.$3)(C);continue}Object.freeze(s1),await Promise.allSettled(s1).then(C=>{for(const o1 of C)o1.status==="rejected"&&(0,b.$3)(o1.reason)})}}}e.$pe=L;class D extends s{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new A.$8c,this.t=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.t(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.z&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$qe=D;class J extends D{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$re=J;class E1 extends s{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$se=E1;class W{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const p={event:E,listener:null};this.h.push(p),this.g&&this.m(p);const x=()=>{this.g&&this.o(p);const Y=this.h.indexOf(p);this.h.splice(Y,1)};return(0,B.$Vc)((0,t.$gb)(x))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(p=>this.f.fire(p))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$te=W;class _1{constructor(E,p,x,Y){this.f=new B.$Wc;const t1=this.f.add(new W),s1=this.f.add(new B.$7c);function X(C){s1.set(C,t1.add(Y(C)))}for(const C of E)X(C);this.f.add(p(C=>{X(C)})),this.f.add(x(C=>{s1.deleteAndDispose(C)})),this.event=t1.event}dispose(){this.f.dispose()}}e.$ue=_1;class T{constructor(){this.f=[]}wrapEvent(E,p,x){return(Y,t1,s1)=>E(X=>{const C=this.f[this.f.length-1];if(!p){C?C.buffers.push(()=>Y.call(t1,X)):Y.call(t1,X);return}const o1=C;if(!o1){Y.call(t1,p(x,X));return}o1.items??(o1.items=[]),o1.items.push(X),o1.buffers.length===0&&C.buffers.push(()=>{o1.reducedResult??(o1.reducedResult=x?o1.items.reduce(p,x):o1.items.reduce(p)),Y.call(t1,o1.reducedResult)})},void 0,s1)}bufferEvents(E){const p={buffers:new Array};this.f.push(p);const x=E();return this.f.pop(),p.buffers.forEach(Y=>Y()),x}}e.$ve=T;class a{constructor(){this.f=!1,this.g=S.None,this.h=B.$Xc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=a;class M{static const(E){return new j(E)}constructor(E){this.g=E,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(E){E!==this.g&&(this.g=E,this.f.fire(void 0))}}e.$xe=M;class j{constructor(E){this.value=E,this.onDidChange=S.None}}}),define(a1[16],g1([0,1,5]),function(n1,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=z;const t=Object.freeze(function(O,U){const S=setTimeout(O.bind(U),0);return{dispose(){clearTimeout(S)}}});var B;(function(O){function U(S){return S===O.None||S===O.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}O.isCancellationToken=U,O.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),O.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(B||(e.CancellationToken=B={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new b.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class Q{constructor(U){this.f=void 0,this.g=void 0,this.g=U&&U.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=B.Cancelled}dispose(U=!1){U&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=B.None}}e.$ye=Q;function z(O){const U=new Q;return O.add({dispose(){U.cancel()}}),U.token}}),define(a1[17],g1([0,1,16]),function(n1,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=B;class t{constructor(O){this.b=O,this.a=null}get(){if(this.a)return this.a;const O=new b.$ye,U=this.b(O.token);return this.a={promise:U,dispose:()=>{this.a=null,O.cancel(),O.dispose()}},this.a}}e.$$e=t;function B(z){return z}class A{constructor(O,U){this.a=void 0,this.b=void 0,typeof O=="function"?(this.c=O,this.d=B):(this.c=U,this.d=O.getCacheKey)}get(O){const U=this.d(O);return this.b!==U&&(this.b=U,this.a=this.c(O)),this.a}}e.$af=A;class Q{get cachedValues(){return this.a}constructor(O,U){this.a=new Map,this.b=new Map,typeof O=="function"?(this.c=O,this.d=B):(this.c=U,this.d=O.getCacheKey)}get(O){const U=this.d(O);if(this.b.has(U))return this.b.get(U);const S=this.c(O);return this.a.set(O,S),this.b.set(U,S),S}}e.$bf=Q}),define(a1[18],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=b,e.$hg=t,e.$ig=B,e.$jg=A,e.$kg=Q,e.$lg=z,e.$mg=O,e.$ng=U,e.$og=S,e.$pg=F,e.$qg=G,e.$rg=i1,e.$sg=l1,e.$tg=K,e.$ug=N,e.$vg=g,e.$wg=m,e.$xg=w;function b(o){return typeof o=="string"}function t(o){return Array.isArray(o)&&o.every(n=>b(n))}function B(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function A(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}function Q(o){return typeof o=="number"&&!isNaN(o)}function z(o){return!!o&&typeof o[Symbol.iterator]=="function"}function O(o){return o===!0||o===!1}function U(o){return typeof o>"u"}function S(o){return!F(o)}function F(o){return U(o)||o===null}function G(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function i1(o){if(F(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function l1(...o){const n=[];for(let s=0;s<o.length;s++){const l=o[s];if(F(l))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(l)}return n}const k=Object.prototype.hasOwnProperty;function K(o){if(!B(o))return!1;for(const n in o)if(k.call(o,n))return!1;return!0}function N(o){return typeof o=="function"}function g(...o){return o.length>0&&o.every(N)}function m(o,n){const s=Math.min(o.length,n.length);for(let l=0;l<s;l++)w(o[l],n[l])}function w(o,n){if(b(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(N(n)){try{if(o instanceof n)return}catch{}if(!F(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(a1[19],g1([0,1,18]),function(n1,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=t,e.$go=B,e.$ho=Q,e.$io=O,e.$jo=U,e.$ko=S,e.$lo=F,e.$mo=G,e.$no=i1,e.$oo=l1,e.$po=k,e.$qo=K,e.$ro=N;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const m=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([w,o])=>{m[w]=o&&typeof o=="object"?t(o):o}),m}function B(g){if(!g||typeof g!="object")return g;const m=[g];for(;m.length>0;){const w=m.shift();Object.freeze(w);for(const o in w)if(A.call(w,o)){const n=w[o];typeof n=="object"&&!Object.isFrozen(n)&&!(0,b.$jg)(n)&&m.push(n)}}return g}const A=Object.prototype.hasOwnProperty;function Q(g,m){return z(g,m,new Set)}function z(g,m,w){if((0,b.$pg)(g))return g;const o=m(g);if(typeof o<"u")return o;if(Array.isArray(g)){const n=[];for(const s of g)n.push(z(s,m,w));return n}if((0,b.$ig)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const n={};for(const s in g)A.call(g,s)&&(n[s]=z(g[s],m,w));return w.delete(g),n}return g}function O(g,m,w=!0){return(0,b.$ig)(g)?((0,b.$ig)(m)&&Object.keys(m).forEach(o=>{o in g?w&&((0,b.$ig)(g[o])&&(0,b.$ig)(m[o])?O(g[o],m[o],w):g[o]=m[o]):g[o]=m[o]}),g):m}function U(g,m){if(g===m)return!0;if(g==null||m===null||m===void 0||typeof g!=typeof m||typeof g!="object"||Array.isArray(g)!==Array.isArray(m))return!1;let w,o;if(Array.isArray(g)){if(g.length!==m.length)return!1;for(w=0;w<g.length;w++)if(!U(g[w],m[w]))return!1}else{const n=[];for(o in g)n.push(o);n.sort();const s=[];for(o in m)s.push(o);if(s.sort(),!U(n,s))return!1;for(w=0;w<n.length;w++)if(!U(g[n[w]],m[n[w]]))return!1}return!0}function S(g){const m=new Set;return JSON.stringify(g,(w,o)=>{if((0,b.$ig)(o)||Array.isArray(o)){if(m.has(o))return"[Circular]";m.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function F(g,m){const w=Object.create(null);return!g||!m||Object.keys(m).forEach(n=>{const s=g[n],l=m[n];U(s,l)||(w[n]=l)}),w}function G(g,m){const w=m.toLowerCase(),o=Object.keys(g).find(n=>n.toLowerCase()===w);return o?g[o]:g[m]}function i1(g,m){const w=Object.create(null);for(const[o,n]of Object.entries(g))m(o,n)&&(w[o]=n);return w}function l1(g){let m=[];for(;Object.prototype!==g;)m=m.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return m}function k(g){const m=[];for(const w of l1(g))typeof g[w]=="function"&&m.push(w);return m}function K(g,m){const w=n=>function(){const s=Array.prototype.slice.call(arguments,0);return m(n,s)},o={};for(const n of g)o[n]=w(n);return o}function N(g,m){const w={};for(const[o,n]of Object.entries(g))w[o]=m(n,o);return w}}),define(a1[20],g1([0,1]),function(n1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=t,e.$df=B;var b;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b||(e.Constants=b={}));function t(A){return A<0?0:A>b.MAX_UINT_8?b.MAX_UINT_8:A|0}function B(A){return A<0?0:A>b.MAX_UINT_32?b.MAX_UINT_32:A|0}}),define(a1[21],g1([0,1,17,7,11,20]),function(n1,e,b,t,B,A){"use strict";var Q;Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=z,e.$ff=U,e.$gf=F,e.$hf=G,e.$if=i1,e.$jf=l1,e.$kf=k,e.$lf=K,e.$mf=N,e.$nf=g,e.$of=m,e.$pf=w,e.$qf=o,e.$rf=n,e.$sf=s,e.$tf=l,e.$uf=u,e.$vf=L,e.$wf=D,e.$xf=J,e.$yf=E1,e.$zf=W,e.$Af=_1,e.$Bf=T,e.$Cf=a,e.$Df=M,e.$Ef=j,e.$Ff=v,e.$Gf=E,e.$Hf=p,e.$If=x,e.$Jf=Y,e.$Kf=t1,e.$Lf=s1,e.$Mf=X,e.$Nf=C,e.$Of=o1,e.$Rf=S1,e.$Sf=P1,e.$Tf=B1,e.$Uf=O1,e.$Vf=_,e.$Wf=d,e.$Yf=R,e.$Zf=Z,e.$1f=c1,e.$2f=d1,e.$3f=U1,e.$4f=y,e.$5f=H,e.$7f=P,e.$8f=V,e.$9f=e1,e.$0f=f1,e.$$f=b1,e.$_f=m1,e.$ag=N1,e.$bg=k1,e.$cg=H1;function z(i){return!i||typeof i!="string"?!0:i.trim().length===0}const O=/{(\d+)}/g;function U(i,...r){return r.length===0?i:i.replace(O,function(h,$){const q=parseInt($,10);return isNaN(q)||q<0||q>=r.length?h:r[q]})}const S=/{([^}]+)}/g;function F(i,r){return Object.keys(r).length===0?i:i.replace(S,(h,$)=>r[$]??h)}function G(i){return i.replace(/[<>"'&]/g,r=>{switch(r){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return r})}function i1(i){return i.replace(/[<>&]/g,function(r){switch(r){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return r}})}function l1(i){return i.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(i,r){let h=0,$=i.indexOf(r);for(;$!==-1;)h++,$=i.indexOf(r,$+r.length);return h}function K(i,r,h="\u2026"){return i.length<=r?i:`${i.substr(0,r)}${h}`}function N(i,r,h="\u2026"){if(i.length<=r)return i;const $=Math.ceil(r/2)-h.length/2,q=Math.floor(r/2)-h.length/2;return`${i.substr(0,$)}${h}${i.substr(i.length-q)}`}function g(i,r=" "){const h=m(i,r);return w(h,r)}function m(i,r){if(!i||!r)return i;const h=r.length;if(h===0||i.length===0)return i;let $=0;for(;i.indexOf(r,$)===$;)$=$+h;return i.substring($)}function w(i,r){if(!i||!r)return i;const h=r.length,$=i.length;if(h===0||$===0)return i;let q=$,u1=-1;for(;u1=i.lastIndexOf(r,q-1),!(u1===-1||u1+h!==q);){if(u1===0)return"";q=u1}return i.substring(0,q)}function o(i){return i.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(i){return i.replace(/\*/g,"")}function s(i,r,h={}){if(!i)throw new Error("Cannot create regex from empty string");r||(i=l1(i)),h.wholeWord&&(/\B/.test(i.charAt(0))||(i="\\b"+i),/\B/.test(i.charAt(i.length-1))||(i=i+"\\b"));let $="";return h.global&&($+="g"),h.matchCase||($+="i"),h.multiline&&($+="m"),h.unicode&&($+="u"),new RegExp(i,$)}function l(i){return i.source==="^"||i.source==="^$"||i.source==="$"||i.source==="^\\s*$"?!1:!!(i.exec("")&&i.lastIndex===0)}function u(i){return i.split(/\r\n|\r|\n/)}function L(i){const r=[],h=i.split(/(\r\n|\r|\n)/);for(let $=0;$<Math.ceil(h.length/2);$++)r.push(h[2*$]+(h[2*$+1]??""));return r}function D(i){for(let r=0,h=i.length;r<h;r++){const $=i.charCodeAt(r);if($!==t.CharCode.Space&&$!==t.CharCode.Tab)return r}return-1}function J(i,r=0,h=i.length){for(let $=r;$<h;$++){const q=i.charCodeAt($);if(q!==t.CharCode.Space&&q!==t.CharCode.Tab)return i.substring(r,$)}return i.substring(r,h)}function E1(i,r=i.length-1){for(let h=r;h>=0;h--){const $=i.charCodeAt(h);if($!==t.CharCode.Space&&$!==t.CharCode.Tab)return h}return-1}function W(i,r,h){const $=[];let q=0;for(const u1 of i.matchAll(r)){if($.push(i.slice(q,u1.index)),u1.index===void 0)throw new Error("match.index should be defined");q=u1.index+u1[0].length,$.push(h(u1[0],...u1.slice(1),u1.index,i,u1.groups))}return $.push(i.slice(q)),Promise.all($).then(u1=>u1.join(""))}function _1(i,r){return i<r?-1:i>r?1:0}function T(i,r,h=0,$=i.length,q=0,u1=r.length){for(;h<$&&q<u1;h++,q++){const D1=i.charCodeAt(h),h1=r.charCodeAt(q);if(D1<h1)return-1;if(D1>h1)return 1}const A1=$-h,p1=u1-q;return A1<p1?-1:A1>p1?1:0}function a(i,r){return M(i,r,0,i.length,0,r.length)}function M(i,r,h=0,$=i.length,q=0,u1=r.length){for(;h<$&&q<u1;h++,q++){let D1=i.charCodeAt(h),h1=r.charCodeAt(q);if(D1===h1)continue;if(D1>=128||h1>=128)return T(i.toLowerCase(),r.toLowerCase(),h,$,q,u1);v(D1)&&(D1-=32),v(h1)&&(h1-=32);const v1=D1-h1;if(v1!==0)return v1}const A1=$-h,p1=u1-q;return A1<p1?-1:A1>p1?1:0}function j(i){return i>=t.CharCode.Digit0&&i<=t.CharCode.Digit9}function v(i){return i>=t.CharCode.a&&i<=t.CharCode.z}function E(i){return i>=t.CharCode.A&&i<=t.CharCode.Z}function p(i,r){return i.length===r.length&&M(i,r)===0}function x(i,r){const h=r.length;return r.length>i.length?!1:M(i,r,0,h)===0}function Y(i,r){const h=Math.min(i.length,r.length);let $;for($=0;$<h;$++)if(i.charCodeAt($)!==r.charCodeAt($))return $;return h}function t1(i,r){const h=Math.min(i.length,r.length);let $;const q=i.length-1,u1=r.length-1;for($=0;$<h;$++)if(i.charCodeAt(q-$)!==r.charCodeAt(u1-$))return $;return h}function s1(i){return 55296<=i&&i<=56319}function X(i){return 56320<=i&&i<=57343}function C(i,r){return(i-55296<<10)+(r-56320)+65536}function o1(i,r,h){const $=i.charCodeAt(h);if(s1($)&&h+1<r){const q=i.charCodeAt(h+1);if(X(q))return C($,q)}return $}function I1(i,r){const h=i.charCodeAt(r-1);if(X(h)&&r>1){const $=i.charCodeAt(r-2);if(s1($))return C($,h)}return h}class w1{get offset(){return this.e}constructor(r,h=0){this.c=r,this.d=r.length,this.e=h}setOffset(r){this.e=r}prevCodePoint(){const r=I1(this.c,this.e);return this.e-=r>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}nextCodePoint(){const r=o1(this.c,this.d,this.e);return this.e+=r>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,r}eol(){return this.e>=this.d}}e.$Pf=w1;class L1{get offset(){return this.c.offset}constructor(r,h=0){this.c=new w1(r,h)}nextGraphemeLength(){const r=R1.getInstance(),h=this.c,$=h.offset;let q=r.getGraphemeBreakType(h.nextCodePoint());for(;!h.eol();){const u1=h.offset,A1=r.getGraphemeBreakType(h.nextCodePoint());if(y1(q,A1)){h.setOffset(u1);break}q=A1}return h.offset-$}prevGraphemeLength(){const r=R1.getInstance(),h=this.c,$=h.offset;let q=r.getGraphemeBreakType(h.prevCodePoint());for(;h.offset>0;){const u1=h.offset,A1=r.getGraphemeBreakType(h.prevCodePoint());if(y1(A1,q)){h.setOffset(u1);break}q=A1}return $-h.offset}eol(){return this.c.eol()}}e.$Qf=L1;function S1(i,r){return new L1(i,r).nextGraphemeLength()}function P1(i,r){return new L1(i,r).prevGraphemeLength()}function B1(i,r){r>0&&X(i.charCodeAt(r))&&r--;const h=r+S1(i,r);return[h-P1(i,h),h]}function O1(i){const r=new L1(i);let h=0;for(;!r.eol();)h++,r.nextGraphemeLength();return h}let T1;function c(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(i){return T1||(T1=c()),T1.test(i)}const f=/^[\t\n\r\x20-\x7E]*$/;function d(i){return f.test(i)}e.$Xf=/[\u2028\u2029]/;function R(i){return e.$Xf.test(i)}function Z(i){return i>=11904&&i<=55215||i>=63744&&i<=64255||i>=65281&&i<=65374}function c1(i){return i>=127462&&i<=127487||i===8986||i===8987||i===9200||i===9203||i>=9728&&i<=10175||i===11088||i===11093||i>=127744&&i<=128591||i>=128640&&i<=128764||i>=128992&&i<=129008||i>=129280&&i<=129535||i>=129648&&i<=129782}function d1(i,r,h=""){const $=i.trimStart();if($.length<r)return $;const q=/\b/g;let u1=0;for(;q.test($)&&!($.length-q.lastIndex<r);)u1=q.lastIndex,q.lastIndex+=1;return u1===0?$:h+$.substring(u1).trimStart()}const $1=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*U1(i){let r=0;for(const h of i.matchAll($1))r!==h.index&&(yield{isCode:!1,str:i.substring(r,h.index)}),yield{isCode:!0,str:h[0]},r=h.index+h[0].length;r!==i.length&&(yield{isCode:!1,str:i.substring(r)})}function y(i){return i&&(i=i.replace($1,"")),i}const I=/\\\[.*?\\\]/g;function H(i){return y(i).replace(I,"")}e.$6f=String.fromCharCode(t.CharCode.UTF8_BOM);function P(i){return!!(i&&i.length>0&&i.charCodeAt(0)===t.CharCode.UTF8_BOM)}function V(i){return P(i)?i.substr(1):i}function e1(i,r){if(!i||!r||i.length<r.length)return!1;const h=r.length,$=i.toLowerCase();let q=0,u1=-1;for(;q<h;){const A1=$.indexOf(r[q],u1+1);if(A1<0)return!1;u1=A1,q++}return!0}function f1(i,r=!1){return i?(r&&(i=i.replace(/\\./g,"")),i.toLowerCase()!==i):!1}function b1(i){return i.charAt(0).toUpperCase()+i.slice(1)}function m1(i,r=1){if(r===0)return"";let h=-1;do h=i.indexOf(`
`,h+1),r--;while(r>0&&h>=0);return h===-1?i:(i[h-1]==="\r"&&h--,i.substr(0,h))}function N1(i){const r=t.CharCode.Z-t.CharCode.A+1;return i=i%(2*r),i<r?String.fromCharCode(t.CharCode.a+i):String.fromCharCode(t.CharCode.A+i-r)}function k1(i){return R1.getInstance().getGraphemeBreakType(i)}function y1(i,r){return i===r1.Other?r!==r1.Extend&&r!==r1.SpacingMark:i===r1.CR&&r===r1.LF?!1:i===r1.Control||i===r1.CR||i===r1.LF||r===r1.Control||r===r1.CR||r===r1.LF?!0:!(i===r1.L&&(r===r1.L||r===r1.V||r===r1.LV||r===r1.LVT)||(i===r1.LV||i===r1.V)&&(r===r1.V||r===r1.T)||(i===r1.LVT||i===r1.T)&&r===r1.T||r===r1.Extend||r===r1.ZWJ||r===r1.SpacingMark||i===r1.Prepend||i===r1.ZWJ&&r===r1.Extended_Pictographic||i===r1.Regional_Indicator&&r===r1.Regional_Indicator)}var r1;(function(i){i[i.Other=0]="Other",i[i.Prepend=1]="Prepend",i[i.CR=2]="CR",i[i.LF=3]="LF",i[i.Control=4]="Control",i[i.Extend=5]="Extend",i[i.Regional_Indicator=6]="Regional_Indicator",i[i.SpacingMark=7]="SpacingMark",i[i.L=8]="L",i[i.V=9]="V",i[i.T=10]="T",i[i.LV=11]="LV",i[i.LVT=12]="LVT",i[i.ZWJ=13]="ZWJ",i[i.Extended_Pictographic=14]="Extended_Pictographic"})(r1||(e.GraphemeBreakType=r1={}));class R1{static getInstance(){return R1.c||(R1.c=new R1),R1.c}constructor(){this.d=j1()}getGraphemeBreakType(r){if(r<32)return r===t.CharCode.LineFeed?r1.LF:r===t.CharCode.CarriageReturn?r1.CR:r1.Control;if(r<127)return r1.Other;const h=this.d,$=h.length/3;let q=1;for(;q<=$;)if(r<h[3*q])q=2*q;else if(r>h[3*q+1])q=2*q+1;else return h[3*q+2];return r1.Other}}R1.c=null;function j1(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function H1(i,r){if(i===0)return 0;const h=Y1(i,r);if(h!==void 0)return h;const $=new w1(r,i);return $.prevCodePoint(),$.offset}function Y1(i,r){const h=new w1(r,i);let $=h.prevCodePoint();for(;J1($)||$===W1.emojiVariantSelector||$===W1.enclosingKeyCap;){if(h.offset===0)return;$=h.prevCodePoint()}if(!c1($))return;let q=h.offset;return q>0&&h.prevCodePoint()===W1.zwj&&(q=h.offset),q}function J1(i){return 127995<=i&&i<=127999}var W1;(function(i){i[i.zwj=8205]="zwj",i[i.emojiVariantSelector=65039]="emojiVariantSelector",i[i.enclosingKeyCap=8419]="enclosingKeyCap"})(W1||(W1={})),e.$dg="\xA0";class G1{static getInstance(r){return Q.d.get(Array.from(r))}static getLocales(){return Q.e.value}constructor(r){this.f=r}isAmbiguous(r){return this.f.has(r)}containsAmbiguousCharacter(r){for(let h=0;h<r.length;h++){const $=r.codePointAt(h);if(typeof $=="number"&&this.isAmbiguous($))return!0}return!1}getPrimaryConfusable(r){return this.f.get(r)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=G1,Q=G1,G1.c=new B.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),G1.d=new b.$af({getCacheKey:JSON.stringify},i=>{function r(h1){const v1=new Map;for(let M1=0;M1<h1.length;M1+=2)v1.set(h1[M1],h1[M1+1]);return v1}function h(h1,v1){const M1=new Map(h1);for(const[q1,K1]of v1)M1.set(q1,K1);return M1}function $(h1,v1){if(!h1)return v1;const M1=new Map;for(const[q1,K1]of h1)v1.has(q1)&&M1.set(q1,K1);return M1}const q=Q.c.value;let u1=i.filter(h1=>!h1.startsWith("_")&&h1 in q);u1.length===0&&(u1=["_default"]);let A1;for(const h1 of u1){const v1=r(q[h1]);A1=$(A1,v1)}const p1=r(q._common),D1=h(p1,A1);return new Q(D1)}),G1.e=new B.$X(()=>Object.keys(Q.c.value).filter(i=>!i.startsWith("_")));class F1{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(F1.c())),this.d}static isInvisibleCharacter(r){return F1.e().has(r)}static containsInvisibleCharacter(r){for(let h=0;h<r.length;h++){const $=r.codePointAt(h);if(typeof $=="number"&&F1.isInvisibleCharacter($))return!0}return!1}static get codePoints(){return F1.e()}}e.$fg=F1,F1.d=void 0});var z1=this&&this.__createBinding||(Object.create?function(n1,e,b,t){t===void 0&&(t=b);var B=Object.getOwnPropertyDescriptor(e,b);(!B||("get"in B?!e.__esModule:B.writable||B.configurable))&&(B={enumerable:!0,get:function(){return e[b]}}),Object.defineProperty(n1,t,B)}:function(n1,e,b,t){t===void 0&&(t=b),n1[t]=e[b]}),V1=this&&this.__setModuleDefault||(Object.create?function(n1,e){Object.defineProperty(n1,"default",{enumerable:!0,value:e})}:function(n1,e){n1.default=e}),X1=this&&this.__importStar||function(n1){if(n1&&n1.__esModule)return n1;var e={};if(n1!=null)for(var b in n1)b!=="default"&&Object.prototype.hasOwnProperty.call(n1,b)&&z1(e,n1,b);return V1(e,n1),e};define(a1[22],g1([0,1,2,5,4,19,14,21]),function(n1,e,b,t,B,A,Q,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SimpleWorkerServer=e.SimpleWorkerClient=void 0,e.logOnceWebWorkerWarning=S,e.create=s,z=X1(z);const O="$initialize";let U=!1;function S(l){Q.$i&&(U||(U=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}var F;(function(l){l[l.Request=0]="Request",l[l.Reply=1]="Reply",l[l.SubscribeEvent=2]="SubscribeEvent",l[l.Event=3]="Event",l[l.UnsubscribeEvent=4]="UnsubscribeEvent"})(F||(F={}));class G{constructor(u,L,D,J){this.vsWorker=u,this.req=L,this.method=D,this.args=J,this.type=F.Request}}class i1{constructor(u,L,D,J){this.vsWorker=u,this.seq=L,this.res=D,this.err=J,this.type=F.Reply}}class l1{constructor(u,L,D,J){this.vsWorker=u,this.req=L,this.eventName=D,this.arg=J,this.type=F.SubscribeEvent}}class k{constructor(u,L,D){this.vsWorker=u,this.req=L,this.event=D,this.type=F.Event}}class K{constructor(u,L){this.vsWorker=u,this.req=L,this.type=F.UnsubscribeEvent}}class N{constructor(u){this.a=-1,this.g=u,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(u){this.a=u}sendMessage(u,L){const D=String(++this.b);return new Promise((J,E1)=>{this.c[D]={resolve:J,reject:E1},this.o(new G(this.a,D,u,L))})}listen(u,L){let D=null;const J=new t.$ne({onWillAddFirstListener:()=>{D=String(++this.b),this.d.set(D,J),this.o(new l1(this.a,D,u,L))},onDidRemoveLastListener:()=>{this.d.delete(D),this.o(new K(this.a,D)),D=null}});return J.event}handleMessage(u){!u||!u.vsWorker||this.a!==-1&&u.vsWorker!==this.a||this.h(u)}h(u){switch(u.type){case F.Reply:return this.j(u);case F.Request:return this.k(u);case F.SubscribeEvent:return this.l(u);case F.Event:return this.m(u);case F.UnsubscribeEvent:return this.n(u)}}j(u){if(!this.c[u.seq]){console.warn("Got reply to unknown seq");return}const L=this.c[u.seq];if(delete this.c[u.seq],u.err){let D=u.err;u.err.$isError&&(D=new Error,D.name=u.err.name,D.message=u.err.message,D.stack=u.err.stack),L.reject(D);return}L.resolve(u.res)}k(u){const L=u.req;this.g.handleMessage(u.method,u.args).then(J=>{this.o(new i1(this.a,L,J,void 0))},J=>{J.detail instanceof Error&&(J.detail=(0,b.$5)(J.detail)),this.o(new i1(this.a,L,void 0,(0,b.$5)(J)))})}l(u){const L=u.req,D=this.g.handleEvent(u.eventName,u.arg)(J=>{this.o(new k(this.a,L,J))});this.f.set(L,D)}m(u){if(!this.d.has(u.req)){console.warn("Got event for unknown req");return}this.d.get(u.req).fire(u.event)}n(u){if(!this.f.has(u.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(u.req).dispose(),this.f.delete(u.req)}o(u){const L=[];if(u.type===F.Request)for(let D=0;D<u.args.length;D++)u.args[D]instanceof ArrayBuffer&&L.push(u.args[D]);else u.type===F.Reply&&u.res instanceof ArrayBuffer&&L.push(u.res);this.g.sendMessage(u,L)}}class g extends B.$Xc{constructor(u,L,D){super();let J=null;this.a=this.B(u.create("vs/base/common/worker/simpleWorker",M=>{this.c.handleMessage(M)},M=>{J?.(M)})),this.c=new N({sendMessage:(M,j)=>{this.a.postMessage(M,j)},handleMessage:(M,j)=>{if(typeof D[M]!="function")return Promise.reject(new Error("Missing method "+M+" on main thread host."));try{return Promise.resolve(D[M].apply(D,j))}catch(v){return Promise.reject(v)}},handleEvent:(M,j)=>{if(w(M)){const v=D[M].call(D,j);if(typeof v!="function")throw new Error(`Missing dynamic event ${M} on main thread host.`);return v}if(m(M)){const v=D[M];if(typeof v!="function")throw new Error(`Missing event ${M} on main thread host.`);return v}throw new Error(`Malformed event name ${M}`)}}),this.c.setWorkerId(this.a.getId());let E1=null;const W=globalThis.require;typeof W<"u"&&typeof W.getConfig=="function"?E1=W.getConfig():typeof globalThis.requirejs<"u"&&(E1=globalThis.requirejs.s.contexts._.config);const _1=(0,A.$po)(D);this.b=this.c.sendMessage(O,[this.a.getId(),JSON.parse(JSON.stringify(E1)),L,_1]);const T=(M,j)=>this.g(M,j),a=(M,j)=>this.c.listen(M,j);this.f=new Promise((M,j)=>{J=j,this.b.then(v=>{M(o(v,T,a))},v=>{j(v),this.h("Worker failed to load "+L,v)})})}getProxyObject(){return this.f}g(u,L){return new Promise((D,J)=>{this.b.then(()=>{this.c.sendMessage(u,L).then(D,J)},J)})}h(u,L){console.error(u),console.info(L)}}e.SimpleWorkerClient=g;function m(l){return l[0]==="o"&&l[1]==="n"&&z.$Gf(l.charCodeAt(2))}function w(l){return/^onDynamic/.test(l)&&z.$Gf(l.charCodeAt(9))}function o(l,u,L){const D=W=>function(){const _1=Array.prototype.slice.call(arguments,0);return u(W,_1)},J=W=>function(_1){return L(W,_1)},E1={};for(const W of l){if(w(W)){E1[W]=J(W);continue}if(m(W)){E1[W]=L(W,void 0);continue}E1[W]=D(W)}return E1}class n{constructor(u,L){this.a=L,this.b=null,this.c=new N({sendMessage:(D,J)=>{u(D,J)},handleMessage:(D,J)=>this.d(D,J),handleEvent:(D,J)=>this.f(D,J)})}onmessage(u){this.c.handleMessage(u)}d(u,L){if(u===O)return this.g(L[0],L[1],L[2],L[3]);if(!this.b||typeof this.b[u]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+u));try{return Promise.resolve(this.b[u].apply(this.b,L))}catch(D){return Promise.reject(D)}}f(u,L){if(!this.b)throw new Error("Missing requestHandler");if(w(u)){const D=this.b[u].call(this.b,L);if(typeof D!="function")throw new Error(`Missing dynamic event ${u} on request handler.`);return D}if(m(u)){const D=this.b[u];if(typeof D!="function")throw new Error(`Missing event ${u} on request handler.`);return D}throw new Error(`Malformed event name ${u}`)}g(u,L,D,J){this.c.setWorkerId(u);const _1=o(J,(T,a)=>this.c.sendMessage(T,a),(T,a)=>this.c.listen(T,a));return this.a?(this.b=this.a(_1),Promise.resolve((0,A.$po)(this.b))):(L&&(typeof L.baseUrl<"u"&&delete L.baseUrl,typeof L.paths<"u"&&typeof L.paths.vs<"u"&&delete L.paths.vs,typeof L.trustedTypesPolicy<"u"&&delete L.trustedTypesPolicy,L.catchError=!0,globalThis.require.config(L)),new Promise((T,a)=>{(globalThis.require||n1)([D],j=>{if(this.b=j.create(_1),!this.b){a(new Error("No RequestHandler!"));return}T((0,A.$po)(this.b))},a)}))}}e.SimpleWorkerServer=n;function s(l){return new n(l,null)}})}).call(this);

//# sourceMappingURL=simpleWorker.js.map
