"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(x){for(var i=[],t=0,n=x.length;t<n;t++)i[t]=ie[x[t]];return i};const Ye=this,Qe=typeof global=="object"?global:{};var Ne;(function(x){x.global=Ye;class i{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=i._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof x.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}x.Environment=i})(Ne||(Ne={}));var Ne;(function(x){class i{constructor(g,w,d){this.type=g,this.detail=w,this.timestamp=d}}x.LoaderEvent=i;class t{constructor(g){this._events=[new i(1,"",g)]}record(g,w){this._events.push(new i(g,w,x.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}x.LoaderEventRecorder=t;class n{record(g,w){}getEvents(){return[]}}n.INSTANCE=new n,x.NullLoaderEventRecorder=n})(Ne||(Ne={}));var Ne;(function(x){class i{static fileUriToFilePath(n,p){if(p=decodeURI(p).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(p))return p.substr(8);if(/^file:\/\//.test(p))return p.substr(5)}else if(/^file:\/\//.test(p))return p.substr(7);return p}static startsWith(n,p){return n.length>=p.length&&n.substr(0,p.length)===p}static endsWith(n,p){return n.length>=p.length&&n.substr(n.length-p.length)===p}static containsQueryString(n){return/^[^\#]*\?/gi.test(n)}static isAbsolutePath(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)}static forEachProperty(n,p){if(n){let g;for(g in n)n.hasOwnProperty(g)&&p(g,n[g])}}static isEmpty(n){let p=!0;return i.forEachProperty(n,()=>{p=!1}),p}static recursiveClone(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;let p=Array.isArray(n)?[]:{};return i.forEachProperty(n,(g,w)=>{w&&typeof w=="object"?p[g]=i.recursiveClone(w):p[g]=w}),p}static generateAnonymousModule(){return"===anonymous"+i.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(n){return i.startsWith(n,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=x.global.performance&&typeof x.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?x.global.performance.now():Date.now()}}i.NEXT_ANONYMOUS_ID=1,i.PERFORMANCE_NOW_PROBED=!1,i.HAS_PERFORMANCE_NOW=!1,x.Utilities=i})(Ne||(Ne={}));var Ne;(function(x){function i(p){if(p instanceof Error)return p;const g=new Error(p.message||String(p)||"Unknown Error");return p.stack&&(g.stack=p.stack),g}x.ensureError=i;class t{static validateConfigurationOptions(g){function w(d){if(d.phase==="loading"){console.error('Loading "'+d.moduleId+'" failed'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}if(d.phase==="factory"){console.error('The factory function of "'+d.moduleId+'" has thrown an exception'),console.error(d),console.error("Here are the modules that depend on it:"),console.error(d.neededBy);return}}if(g=g||{},typeof g.baseUrl!="string"&&(g.baseUrl=""),typeof g.isBuild!="boolean"&&(g.isBuild=!1),typeof g.paths!="object"&&(g.paths={}),typeof g.config!="object"&&(g.config={}),typeof g.catchError>"u"&&(g.catchError=!1),typeof g.recordStats>"u"&&(g.recordStats=!1),typeof g.urlArgs!="string"&&(g.urlArgs=""),typeof g.onError!="function"&&(g.onError=w),Array.isArray(g.ignoreDuplicateModules)||(g.ignoreDuplicateModules=[]),g.baseUrl.length>0&&(x.Utilities.endsWith(g.baseUrl,"/")||(g.baseUrl+="/")),typeof g.cspNonce!="string"&&(g.cspNonce=""),typeof g.preferScriptTags>"u"&&(g.preferScriptTags=!1),g.nodeCachedData&&typeof g.nodeCachedData=="object"&&(typeof g.nodeCachedData.seed!="string"&&(g.nodeCachedData.seed="seed"),(typeof g.nodeCachedData.writeDelay!="number"||g.nodeCachedData.writeDelay<0)&&(g.nodeCachedData.writeDelay=1e3*7),!g.nodeCachedData.path||typeof g.nodeCachedData.path!="string")){const d=i(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",g.onError(d),g.nodeCachedData=void 0}return g}static mergeConfigurationOptions(g=null,w=null){let d=x.Utilities.recursiveClone(w||{});return x.Utilities.forEachProperty(g,(a,l)=>{a==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules<"u"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(l):a==="paths"&&typeof d.paths<"u"?x.Utilities.forEachProperty(l,(f,$)=>d.paths[f]=$):a==="config"&&typeof d.config<"u"?x.Utilities.forEachProperty(l,(f,$)=>d.config[f]=$):d[a]=x.Utilities.recursiveClone(l)}),t.validateConfigurationOptions(d)}}x.ConfigurationOptionsUtil=t;class n{constructor(g,w){if(this._env=g,this.options=t.mergeConfigurationOptions(w),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let d=this.options.nodeRequire.main.filename,a=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let g=0;g<this.options.ignoreDuplicateModules.length;g++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[g]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],x.Utilities.forEachProperty(this.options.paths,(g,w)=>{Array.isArray(w)?this.sortedPathsRules.push({from:g,to:w}):this.sortedPathsRules.push({from:g,to:[w]})}),this.sortedPathsRules.sort((g,w)=>w.from.length-g.from.length)}cloneAndMerge(g){return new n(this._env,t.mergeConfigurationOptions(g,this.options))}getOptionsLiteral(){return this.options}_applyPaths(g){let w;for(let d=0,a=this.sortedPathsRules.length;d<a;d++)if(w=this.sortedPathsRules[d],x.Utilities.startsWith(g,w.from)){let l=[];for(let f=0,$=w.to.length;f<$;f++)l.push(w.to[f]+g.substr(w.from.length));return l}return[g]}_addUrlArgsToUrl(g){return x.Utilities.containsQueryString(g)?g+"&"+this.options.urlArgs:g+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(g){return this.options.urlArgs?this._addUrlArgsToUrl(g):g}_addUrlArgsIfNecessaryToUrls(g){if(this.options.urlArgs)for(let w=0,d=g.length;w<d;w++)g[w]=this._addUrlArgsToUrl(g[w]);return g}moduleIdToPaths(g){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(g))return this.isBuild()?["empty:"]:["node|"+g];let w=g,d;if(!x.Utilities.endsWith(w,".js")&&!x.Utilities.isAbsolutePath(w)){d=this._applyPaths(w);for(let a=0,l=d.length;a<l;a++)this.isBuild()&&d[a]==="empty:"||(x.Utilities.isAbsolutePath(d[a])||(d[a]=this.options.baseUrl+d[a]),!x.Utilities.endsWith(d[a],".js")&&!x.Utilities.containsQueryString(d[a])&&(d[a]=d[a]+".js"))}else!x.Utilities.endsWith(w,".js")&&!x.Utilities.containsQueryString(w)&&(w=w+".js"),d=[w];return this._addUrlArgsIfNecessaryToUrls(d)}requireToUrl(g){let w=g;return x.Utilities.isAbsolutePath(w)||(w=this._applyPaths(w)[0],x.Utilities.isAbsolutePath(w)||(w=this.options.baseUrl+w)),this._addUrlArgsIfNecessaryToUrl(w)}isBuild(){return this.options.isBuild}shouldInvokeFactory(g){return!!(!this.options.isBuild||x.Utilities.isAnonymousModule(g)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[g])}isDuplicateMessageIgnoredFor(g){return this.ignoreDuplicateModulesMap.hasOwnProperty(g)}getConfigForModule(g){if(this.options.config)return this.options.config[g]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(g){this.options.onError(g)}}x.Configuration=n})(Ne||(Ne={}));var Ne;(function(x){class i{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,f,$,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new t:this._scriptLoader=new g(this._env)}else this._env.isNode?this._scriptLoader=new g(this._env):this._scriptLoader=new t;let N={callback:$,errorback:m};if(this._callbackMap.hasOwnProperty(f)){this._callbackMap[f].push(N);return}this._callbackMap[f]=[N],this._scriptLoader.load(l,f,()=>this.triggerCallback(f),e=>this.triggerErrorback(f,e))}triggerCallback(l){let f=this._callbackMap[l];delete this._callbackMap[l];for(let $=0;$<f.length;$++)f[$].callback()}triggerErrorback(l,f){let $=this._callbackMap[l];delete this._callbackMap[l];for(let m=0;m<$.length;m++)$[m].errorback(f)}}class t{attachListeners(l,f,$){let m=()=>{l.removeEventListener("load",N),l.removeEventListener("error",e)},N=b=>{m(),f()},e=b=>{m(),$(b)};l.addEventListener("load",N),l.addEventListener("error",e)}load(l,f,$,m){if(/^node\|/.test(f)){let N=l.getConfig().getOptionsLiteral(),e=w(l.getRecorder(),N.nodeRequire||x.global.nodeRequire),b=f.split("|"),L=null;try{L=e(b[1])}catch(_){m(_);return}l.enqueueDefineAnonymousModule([],()=>L),$()}else{let N=document.createElement("script");N.setAttribute("async","async"),N.setAttribute("type","text/javascript"),this.attachListeners(N,$,m);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(f=e.createScriptURL(f)),N.setAttribute("src",f);const{cspNonce:b}=l.getConfig().getOptionsLiteral();b&&N.setAttribute("nonce",b),document.getElementsByTagName("head")[0].appendChild(N)}}}function n(a){const{trustedTypesPolicy:l}=a.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class p{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(l)),this._cachedCanUseEval}load(l,f,$,m){if(/^node\|/.test(f)){const N=l.getConfig().getOptionsLiteral(),e=w(l.getRecorder(),N.nodeRequire||x.global.nodeRequire),b=f.split("|");let L=null;try{L=e(b[1])}catch(_){m(_);return}l.enqueueDefineAnonymousModule([],function(){return L}),$()}else{const{trustedTypesPolicy:N}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(f).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${f}`,(N?self.eval(N.createScript("",b)):new Function(b)).call(self),$()}).then(void 0,m);return}try{N&&(f=N.createScriptURL(f)),importScripts(f),$()}catch(b){m(b)}}}}class g{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,f){const{nodeCachedData:$}=f.getConfig().getOptionsLiteral();if(!$||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,N=l("module");function e(b){const L=b.constructor;let _=function(E){try{return b.require(E)}finally{}};return _.resolve=function(E,v){return L._resolveFilename(E,b,!1,v)},_.resolve.paths=function(E){return L._resolveLookupPaths(E,b)},_.main=process.mainModule,_.extensions=L._extensions,_.cache=L._cache,_}N.prototype._compile=function(b,L){const _=N.wrap(b.replace(/^#!.*/,"")),A=f.getRecorder(),E=m._getCachedDataPath($,L),v={filename:L};let h;try{const j=m._fs.readFileSync(E);h=j.slice(0,16),v.cachedData=j.slice(16),A.record(60,E)}catch{A.record(61,E)}const u=new m._vm.Script(_,v),r=u.runInThisContext(v),o=m._path.dirname(L),c=e(this),T=[this.exports,c,this,L,o,process,Qe,Buffer],R=r.apply(this.exports,T);return m._handleCachedData(u,_,E,!v.cachedData,f),m._verifyCachedData(u,_,E,h,f),R}}load(l,f,$,m){const N=l.getConfig().getOptionsLiteral(),e=w(l.getRecorder(),N.nodeRequire||x.global.nodeRequire),b=N.nodeInstrumenter||function(_){return _};this._init(e),this._initNodeRequire(e,l);let L=l.getRecorder();if(/^node\|/.test(f)){let _=f.split("|"),A=null;try{A=e(_[1])}catch(E){m(E);return}l.enqueueDefineAnonymousModule([],()=>A),$()}else{f=x.Utilities.fileUriToFilePath(this._env.isWindows,f);const _=this._path.normalize(f),A=this._getElectronRendererScriptPathOrUri(_),E=!!N.nodeCachedData,v=E?this._getCachedDataPath(N.nodeCachedData,f):void 0;this._readSourceAndCachedData(_,v,L,(h,u,r,o)=>{if(h){m(h);return}let c;u.charCodeAt(0)===g._BOM?c=g._PREFIX+u.substring(1)+g._SUFFIX:c=g._PREFIX+u+g._SUFFIX,c=b(c,_);const T={filename:A,cachedData:r},R=this._createAndEvalScript(l,c,T,$,m);this._handleCachedData(R,c,v,E&&!r,l),this._verifyCachedData(R,c,v,o,l)})}}_createAndEvalScript(l,f,$,m,N){const e=l.getRecorder();e.record(31,$.filename);const b=new this._vm.Script(f,$),L=b.runInThisContext($),_=l.getGlobalAMDDefineFunc();let A=!1;const E=function(){return A=!0,_.apply(null,arguments)};return E.amd=_.amd,L.call(x.global,l.getGlobalAMDRequireFunc(),E,$.filename,this._path.dirname($.filename)),e.record(32,$.filename),A?m():N(new Error(`Didn't receive define call in ${$.filename}!`)),b}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let f=l.match(/^([a-z])\:(.*)/i);return f?`file:///${(f[1].toUpperCase()+":"+f[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,f){const $=this._crypto.createHash("md5").update(f,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(f).replace(/\.js$/,"");return this._path.join(l.path,`${m}-${$}.code`)}_handleCachedData(l,f,$,m,N){l.cachedDataRejected?this._fs.unlink($,e=>{N.getRecorder().record(62,$),this._createAndWriteCachedData(l,f,$,N),e&&N.getConfig().onError(e)}):m&&this._createAndWriteCachedData(l,f,$,N)}_createAndWriteCachedData(l,f,$,m){let N=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,b=0,L;const _=()=>{setTimeout(()=>{L||(L=this._crypto.createHash("md5").update(f,"utf8").digest());const A=l.createCachedData();if(!(A.length===0||A.length===e||b>=5)){if(A.length<e){_();return}e=A.length,this._fs.writeFile($,Buffer.concat([L,A]),E=>{E&&m.getConfig().onError(E),m.getRecorder().record(63,$),_()})}},N*Math.pow(4,b++))};_()}_readSourceAndCachedData(l,f,$,m){if(!f)this._fs.readFile(l,{encoding:"utf8"},m);else{let N,e,b,L=2;const _=A=>{A?m(A):--L===0&&m(void 0,N,e,b)};this._fs.readFile(l,{encoding:"utf8"},(A,E)=>{N=E,_(A)}),this._fs.readFile(f,(A,E)=>{!A&&E&&E.length>0?(b=E.slice(0,16),e=E.slice(16),$.record(60,f)):$.record(61,f),_()})}}_verifyCachedData(l,f,$,m,N){m&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(f,"utf8").digest();m.equals(e)||(N.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${$}' now, but a RESTART IS REQUIRED`)),this._fs.unlink($,b=>{b&&N.getConfig().onError(b)}))},Math.ceil(5e3*(1+Math.random()))))}}g._BOM=65279,g._PREFIX="(function (require, define, __filename, __dirname) { ",g._SUFFIX=`
});`;function w(a,l){if(l.__$__isRecorded)return l;const f=function(m){a.record(33,m);try{return l(m)}finally{a.record(34,m)}};return f.__$__isRecorded=!0,f}x.ensureRecordedNodeRequire=w;function d(a){return new i(a)}x.createScriptLoader=d})(Ne||(Ne={}));var Ne;(function(x){class i{constructor(a){let l=a.lastIndexOf("/");l!==-1?this.fromModulePath=a.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(a){let l=a,f;for(f=/\/\.\//;f.test(l);)l=l.replace(f,"/");for(l=l.replace(/^\.\//g,""),f=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;f.test(l);)l=l.replace(f,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(a){let l=a;return x.Utilities.isAbsolutePath(l)||(x.Utilities.startsWith(l,"./")||x.Utilities.startsWith(l,"../"))&&(l=i._normalizeModuleId(this.fromModulePath+l)),l}}i.ROOT=new i(""),x.ModuleIdResolver=i;class t{constructor(a,l,f,$,m,N){this.id=a,this.strId=l,this.dependencies=f,this._callback=$,this._errorback=m,this.moduleIdResolver=N,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,l){try{return{returnedValue:a.apply(x.global,l),producedError:null}}catch(f){return{returnedValue:null,producedError:f}}}static _invokeFactory(a,l,f,$){return a.shouldInvokeFactory(l)?a.shouldCatchError()?this._safeInvokeFunction(f,$):{returnedValue:f.apply(x.global,$),producedError:null}:{returnedValue:null,producedError:null}}complete(a,l,f,$){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let N=t._invokeFactory(l,this.strId,this._callback,f);m=N.producedError,a.record(22,this.strId),!m&&typeof N.returnedValue<"u"&&(!this.exportsPassedIn||x.Utilities.isEmpty(this.exports))&&(this.exports=N.returnedValue)}else this.exports=this._callback;if(m){let N=x.ensureError(m);N.phase="factory",N.moduleId=this.strId,N.neededBy=$(this.id),this.error=N,l.onError(N)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}x.Module=t;class n{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let l=this._strModuleIdToIntModuleId.get(a);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(a,l),this._intModuleIdToStrModuleId[l]=a),l}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class p{constructor(a){this.id=a}}p.EXPORTS=new p(0),p.MODULE=new p(1),p.REQUIRE=new p(2),x.RegularDependency=p;class g{constructor(a,l,f){this.id=a,this.pluginId=l,this.pluginParam=f}}x.PluginDependency=g;class w{constructor(a,l,f,$,m=0){this._env=a,this._scriptLoader=l,this._loaderAvailableTimestamp=m,this._defineFunc=f,this._requireFunc=$,this._moduleIdProvider=new n,this._config=new x.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new w(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,l){let f=N=>N.replace(/\\/g,"/"),$=f(a),m=l.split(/\n/);for(let N=0;N<m.length;N++){let e=m[N].match(/(.*):(\d+):(\d+)\)?$/);if(e){let b=e[1],L=e[2],_=e[3],A=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(A),b=f(b),b===$){let E={line:parseInt(L,10),col:parseInt(_,10)};return E.line===1&&(E.col-=53),E}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],l=0;for(let f=0,$=this._modules2.length;f<$;f++){let m=this._modules2[f];if(!m)continue;let N=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,b=this._buildInfoDependencies[m.id];a[l++]={id:m.strId,path:N,defineLocation:N&&e?w._findRelevantLocationInStack(N,e):null,dependencies:b,shim:null,exports:m.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new x.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=x.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let f=null;this._config.isBuild()&&(f=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:f,dependencies:a,callback:l}}defineModule(a,l,f,$,m,N=new i(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let b=new t(e,a,this._normalizeDependencies(l,N),f,$,N);this._modules2[e]=b,this._config.isBuild()&&(this._buildInfoDefineStack[e]=m,this._buildInfoDependencies[e]=(b.dependencies||[]).map(L=>this._moduleIdProvider.getStrModuleId(L.id))),this._resolve(b)}_normalizeDependency(a,l){if(a==="exports")return p.EXPORTS;if(a==="module")return p.MODULE;if(a==="require")return p.REQUIRE;let f=a.indexOf("!");if(f>=0){let $=l.resolveModule(a.substr(0,f)),m=l.resolveModule(a.substr(f+1)),N=this._moduleIdProvider.getModuleId($+"!"+m),e=this._moduleIdProvider.getModuleId($);return new g(N,e,m)}return new p(this._moduleIdProvider.getModuleId(l.resolveModule(a)))}_normalizeDependencies(a,l){let f=[],$=0;for(let m=0,N=a.length;m<N;m++)f[$++]=this._normalizeDependency(a[m],l);return f}_relativeRequire(a,l,f,$){if(typeof l=="string")return this.synchronousRequire(l,a);this.defineModule(x.Utilities.generateAnonymousModule(),l,f,$,null,a)}synchronousRequire(a,l=new i(a)){let f=this._normalizeDependency(a,l),$=this._modules2[f.id];if(!$)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!$.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if($.error)throw $.error;return $.exports}configure(a,l){let f=this._config.shouldRecordStats();l?this._config=new x.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!f&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),l.dependencies,l.callback,null,l.stack)}}_createLoadError(a,l){let f=this._moduleIdProvider.getStrModuleId(a),$=(this._inverseDependencies2[a]||[]).map(N=>this._moduleIdProvider.getStrModuleId(N));const m=x.ensureError(l);return m.phase="loading",m.moduleId=f,m.neededBy=$,m}_onLoadError(a,l){const f=this._createLoadError(a,l);this._modules2[a]||(this._modules2[a]=new t(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let $=[];for(let e=0,b=this._moduleIdProvider.getMaxModuleId();e<b;e++)$[e]=!1;let m=!1,N=[];for(N.push(a),$[a]=!0;N.length>0;){let e=N.shift(),b=this._modules2[e];b&&(m=b.onDependencyError(f)||m);let L=this._inverseDependencies2[e];if(L)for(let _=0,A=L.length;_<A;_++){let E=L[_];$[E]||(N.push(E),$[E]=!0)}}m||this._config.onError(f)}_hasDependencyPath(a,l){let f=this._modules2[a];if(!f)return!1;let $=[];for(let N=0,e=this._moduleIdProvider.getMaxModuleId();N<e;N++)$[N]=!1;let m=[];for(m.push(f),$[a]=!0;m.length>0;){let e=m.shift().dependencies;if(e)for(let b=0,L=e.length;b<L;b++){let _=e[b];if(_.id===l)return!0;let A=this._modules2[_.id];A&&!$[_.id]&&($[_.id]=!0,m.push(A))}}return!1}_findCyclePath(a,l,f){if(a===l||f===50)return[a];let $=this._modules2[a];if(!$)return null;let m=$.dependencies;if(m)for(let N=0,e=m.length;N<e;N++){let b=this._findCyclePath(m[N].id,l,f+1);if(b!==null)return b.push(a),b}return null}_createRequire(a){let l=(f,$,m)=>this._relativeRequire(a,f,$,m);return l.toUrl=f=>this._config.requireToUrl(a.resolveModule(f)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(f,$=!1)=>{this.configure(f,$)},l.__$__nodeRequire=x.global.nodeRequire,l}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let l=this._moduleIdProvider.getStrModuleId(a),f=this._config.moduleIdToPaths(l),$=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||$.test(l))&&f.push("node|"+l);let m=-1,N=e=>{if(m++,m>=f.length)this._onLoadError(a,e);else{let b=f[m],L=this.getRecorder();if(this._config.isBuild()&&b==="empty:"){this._buildInfoPath[a]=b,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}L.record(10,b),this._scriptLoader.load(this,b,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=b),L.record(11,b),this._onLoad(a)},_=>{L.record(12,b),N(_)})}};N(null)}_loadPluginDependency(a,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let f=$=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],$,null,null)};f.error=$=>{this._config.onError(this._createLoadError(l.id,$))},a.load(l.pluginParam,this._createRequire(i.ROOT),f,this._config.getOptionsLiteral())}_resolve(a){let l=a.dependencies;if(l)for(let f=0,$=l.length;f<$;f++){let m=l[f];if(m===p.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(m===p.MODULE){a.unresolvedDependenciesCount--;continue}if(m===p.REQUIRE){a.unresolvedDependenciesCount--;continue}let N=this._modules2[m.id];if(N&&N.isComplete()){if(N.error){a.onDependencyError(N.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(m.id,a.id,0)||[];e.reverse(),e.push(m.id),console.warn(e.map(b=>this._moduleIdProvider.getStrModuleId(b)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(a.id),m instanceof g){let e=this._modules2[m.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,m);continue}let b=this._inversePluginDependencies2.get(m.pluginId);b||(b=[],this._inversePluginDependencies2.set(m.pluginId,b)),b.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let l=this.getRecorder();if(a.isComplete())return;let f=a.dependencies,$=[];if(f)for(let b=0,L=f.length;b<L;b++){let _=f[b];if(_===p.EXPORTS){$[b]=a.exports;continue}if(_===p.MODULE){$[b]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(_===p.REQUIRE){$[b]=this._createRequire(a.moduleIdResolver);continue}let A=this._modules2[_.id];if(A){$[b]=A.exports;continue}$[b]=null}const m=b=>(this._inverseDependencies2[b]||[]).map(L=>this._moduleIdProvider.getStrModuleId(L));a.complete(l,this._config,$,m);let N=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,N)for(let b=0,L=N.length;b<L;b++){let _=N[b],A=this._modules2[_];A.unresolvedDependenciesCount--,A.unresolvedDependenciesCount===0&&this._onModuleComplete(A)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let b=0,L=e.length;b<L;b++)this._loadPluginDependency(a.exports,e[b])}}}x.ModuleManager=w})(Ne||(Ne={}));var ne,Ne;(function(x){const i=new x.Environment;let t=null;const n=function(d,a,l){typeof d!="string"&&(l=a,a=d,d=null),(typeof a!="object"||!Array.isArray(a))&&(l=a,a=null),a||(a=["require","exports","module"]),d?t.defineModule(d,a,l,null,null):t.enqueueDefineAnonymousModule(a,l)};n.amd={jQuery:!0};const p=function(d,a=!1){t.configure(d,a)},g=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){p(arguments[0]);return}if(typeof arguments[0]=="string")return t.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){t.defineModule(x.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};g.config=p,g.getConfig=function(){return t.getConfig().getOptionsLiteral()},g.reset=function(){t=t.reset()},g.getBuildInfo=function(){return t.getBuildInfo()},g.getStats=function(){return t.getLoaderEvents()},g.define=n;function w(){if(typeof x.global.require<"u"||typeof require<"u"){const d=x.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){const a=x.ensureRecordedNodeRequire(t.getRecorder(),d);x.global.nodeRequire=a,g.nodeRequire=a,g.__$__nodeRequire=a}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=g:(i.isElectronRenderer||(x.global.define=n),x.global.require=g)}x.init=w,(typeof x.global.define!="function"||!x.global.define.amd)&&(t=new x.ModuleManager(i,x.createScriptLoader(i),n,g,x.Utilities.getHighPerformanceTimestamp()),typeof x.global.require<"u"&&typeof x.global.require!="function"&&g.config(x.global.require),ne=function(){return n.apply(null,arguments)},ne.amd=n.amd,typeof doNotInitLoader>"u"&&w())})(Ne||(Ne={})),ne(ie[75],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=t;function t(d,a,l,f){if(f=f||{},(f["vs/css"]||{}).disabled){l({});return}const m=a.toUrl(d+".css");n(d,m,()=>{l({})},N=>{typeof l.error=="function"&&l.error("Could not find "+m+".")})}function n(d,a,l,f){if(p(d,a)){l();return}g(d,a,l,f)}function p(d,a){const l=window.document.getElementsByTagName("link");for(let f=0,$=l.length;f<$;f++){const m=l[f].getAttribute("data-name"),N=l[f].getAttribute("href");if(m===d||N===a)return!0}return!1}function g(d,a,l,f){const $=document.createElement("link");$.setAttribute("rel","stylesheet"),$.setAttribute("type","text/css"),$.setAttribute("data-name",d),w(d,$,l,f),$.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild($)}function w(d,a,l,f){const $=()=>{a.removeEventListener("load",m),a.removeEventListener("error",N)},m=e=>{$(),l()},N=e=>{$(),f(e)};a.addEventListener("load",m),a.addEventListener("error",N)}}),ne("vs/nls",["require","exports"],function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localize=f,i.localize2=$,i.getConfiguredDefaultLocale=m,i.setPseudoTranslation=N,i.create=e,i.load=b;let t=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const n="i-default";function p(L,_){let A;return _.length===0?A=L:A=L.replace(/\{(\d+)\}/g,(E,v)=>{const h=v[0],u=_[h];let r=E;return typeof u=="string"?r=u:(typeof u=="number"||typeof u=="boolean"||u===void 0||u===null)&&(r=String(u)),r}),t&&(A="\uFF3B"+A.replace(/[aouei]/g,"$&$&")+"\uFF3D"),A}function g(L,_){let A=L[_];return A||(A=L["*"],A)?A:null}function w(L){return L.charAt(L.length-1)==="/"?L:L+"/"}async function d(L,_,A){const E=w(L)+w(_)+"vscode/"+w(A),v=await fetch(E);if(v.ok)return await v.json();throw new Error(`${v.status} - ${v.statusText}`)}function a(L){return function(_,A){const E=Array.prototype.slice.call(arguments,2);return p(L[_],E)}}function l(L){return(_,A,...E)=>({value:p(L[_],E),original:p(A,E)})}function f(L,_,...A){return p(_,A)}function $(L,_,...A){const E=p(_,A);return{value:E,original:E}}function m(L){}function N(L){t=L}function e(L,_){return{localize:a(_[L]),localize2:l(_[L]),getConfiguredDefaultLocale:_.getConfiguredDefaultLocale??(A=>{})}}function b(L,_,A,E){const v=E["vs/nls"]??{};if(!L||L.length===0)return A({localize:f,localize2:$,getConfiguredDefaultLocale:()=>v.availableLanguages?.["*"]});const h=v.availableLanguages?g(v.availableLanguages,L):null,u=h===null||h===n;let r=".nls";u||(r=r+"."+h);const o=c=>{Array.isArray(c)?(c.localize=a(c),c.localize2=l(c)):(c.localize=a(c[L]),c.localize2=l(c[L])),c.getConfiguredDefaultLocale=()=>v.availableLanguages?.["*"],A(c)};typeof v.loadBundle=="function"?v.loadBundle(L,h,(c,T)=>{c?_([L+".nls"],o):o(T)}):v.translationServiceUrl&&!u?(async()=>{try{const c=await d(v.translationServiceUrl,h,L);return o(c)}catch(c){if(!h.includes("-"))return console.error(c),_([L+".nls"],o);try{const T=h.split("-")[0],R=await d(v.translationServiceUrl,T,L);return v.availableLanguages??(v.availableLanguages={}),v.availableLanguages["*"]=T,o(R)}catch(T){return console.error(T),_([L+".nls"],o)}}})():_([L+r],o,c=>{if(r===".nls"){console.error("Failed trying to load default language strings",c);return}console.error(`Failed to load message bundle for language ${h}. Falling back to the default language:`,c),_([L+".nls"],o)})}}),function(){const x=globalThis.MonacoEnvironment,i=x&&x.baseUrl?x.baseUrl:"../../../";function t(f,$){if(x?.createTrustedTypesPolicy)try{return x.createTrustedTypesPolicy(f,$)}catch(m){console.warn(m);return}try{return self.trustedTypes?.createPolicy(f,$)}catch(m){console.warn(m);return}}const n=t("amdLoader",{createScriptURL:f=>f,createScript:(f,...$)=>{const m=$.slice(0,-1).join(","),N=$.pop().toString();return`(function anonymous(${m}) { ${N}
})`}});function p(){try{return(n?globalThis.eval(n.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function g(){return new Promise((f,$)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return f();const m=i+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&p()){fetch(m).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${m}`,(n?globalThis.eval(n.createScript("",e)):new Function(e)).call(globalThis),f()}).then(void 0,$);return}n?importScripts(n.createScriptURL(m)):importScripts(m),f()})}function w(){require.config({baseUrl:i,catchError:!0,trustedTypesPolicy:n,amdModulesPattern:/^vs\//})}function d(f){g().then(()=>{w(),require([f],function($){setTimeout(function(){const m=$.create((N,e)=>{globalThis.postMessage(N,e)},null);for(globalThis.onmessage=N=>m.onmessage(N.data,N.ports);l.length>0;){const N=l.shift();m.onmessage(N.data,N.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&w();let a=!0;const l=[];globalThis.onmessage=f=>{if(!a){l.push(f);return}a=!1,d(f.data)}}(),ne(ie[9],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$pb=void 0,i.$ib=t,i.$jb=n,i.$kb=p,i.$lb=g,i.$mb=w,i.$nb=d,i.$ob=a,i.$qb=f,i.$rb=$,i.$sb=m,i.$tb=N,i.$ub=e;function t(b,L){const _=n(b,L);if(_!==-1)return b[_]}function n(b,L,_=b.length-1){for(let A=_;A>=0;A--){const E=b[A];if(L(E))return A}return-1}function p(b,L){const _=g(b,L);return _===-1?void 0:b[_]}function g(b,L,_=0,A=b.length){let E=_,v=A;for(;E<v;){const h=Math.floor((E+v)/2);L(b[h])?E=h+1:v=h}return E-1}function w(b,L){const _=d(b,L);return _===b.length?void 0:b[_]}function d(b,L,_=0,A=b.length){let E=_,v=A;for(;E<v;){const h=Math.floor((E+v)/2);L(b[h])?v=h:E=h+1}return E}function a(b,L,_=0,A=b.length){const E=d(b,L,_,A);return E===b.length?-1:E}class l{constructor(L){this.e=L,this.c=0}findLastMonotonous(L){if(l.assertInvariants){if(this.d){for(const A of this.e)if(this.d(A)&&!L(A))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=L}const _=g(this.e,L,this.c);return this.c=_+1,_===-1?void 0:this.e[_]}}i.$pb=l,l.assertInvariants=!1;function f(b,L){if(b.length===0)return;let _=b[0];for(let A=1;A<b.length;A++){const E=b[A];L(E,_)>0&&(_=E)}return _}function $(b,L){if(b.length===0)return;let _=b[0];for(let A=1;A<b.length;A++){const E=b[A];L(E,_)>=0&&(_=E)}return _}function m(b,L){return f(b,(_,A)=>-L(_,A))}function N(b,L){if(b.length===0)return-1;let _=0;for(let A=1;A<b.length;A++){const E=b[A];L(E,b[_])>0&&(_=A)}return _}function e(b,L){for(const _ of b){const A=L(_);if(A!==void 0)return A}}}),ne(ie[3],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharCode=void 0;var t;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(i.CharCode=t={}))}),ne(ie[37],re([0,1]),function(x,i){"use strict";var t;Object.defineProperty(i,"__esModule",{value:!0}),i.$I=void 0,i.$E=n,i.$F=p,i.$G=g,i.$H=w;function n(a,l){const f=Object.create(null);for(const $ of a){const m=l($);let N=f[m];N||(N=f[m]=[]),N.push($)}return f}function p(a,l){const f=[],$=[];for(const m of a)l.has(m)||f.push(m);for(const m of l)a.has(m)||$.push(m);return{removed:f,added:$}}function g(a,l){const f=[],$=[];for(const[m,N]of a)l.has(m)||f.push(N);for(const[m,N]of l)a.has(m)||$.push(N);return{removed:f,added:$}}function w(a,l){const f=new Set;for(const $ of l)a.has($)&&f.add($);return f}class d{constructor(l,f){this.b=f,this.a=new Map,this[t]="SetWithKey";for(const $ of l)this.add($)}get size(){return this.a.size}add(l){const f=this.b(l);return this.a.set(f,l),this}delete(l){return this.a.delete(this.b(l))}has(l){return this.a.has(this.b(l))}*entries(){for(const l of this.a.values())yield[l,l]}keys(){return this.values()}*values(){for(const l of this.a.values())yield l}clear(){this.a.clear()}forEach(l,f){this.a.forEach($=>l.call(f,$,$,this))}[Symbol.iterator](){return this.values()}}i.$I=d,t=Symbol.toStringTag}),ne(ie[38],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$mu=i.$lu=i.$ku=i.$ju=void 0;function n(a,l){const f=Math.pow(10,l);return Math.round(a*f)/f}class p{constructor(l,f,$,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=n(Math.max(Math.min(1,m),0),3)}static equals(l,f){return l.r===f.r&&l.g===f.g&&l.b===f.b&&l.a===f.a}}i.$ju=p;class g{constructor(l,f,$,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.l=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,m),0),3)}static equals(l,f){return l.h===f.h&&l.s===f.s&&l.l===f.l&&l.a===f.a}static fromRGBA(l){const f=l.r/255,$=l.g/255,m=l.b/255,N=l.a,e=Math.max(f,$,m),b=Math.min(f,$,m);let L=0,_=0;const A=(b+e)/2,E=e-b;if(E>0){switch(_=Math.min(A<=.5?E/(2*A):E/(2-2*A),1),e){case f:L=($-m)/E+($<m?6:0);break;case $:L=(m-f)/E+2;break;case m:L=(f-$)/E+4;break}L*=60,L=Math.round(L)}return new g(L,_,A,N)}static i(l,f,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?l+(f-l)*6*$:$<1/2?f:$<2/3?l+(f-l)*(2/3-$)*6:l}static toRGBA(l){const f=l.h/360,{s:$,l:m,a:N}=l;let e,b,L;if($===0)e=b=L=m;else{const _=m<.5?m*(1+$):m+$-m*$,A=2*m-_;e=g.i(A,_,f+1/3),b=g.i(A,_,f),L=g.i(A,_,f-1/3)}return new p(Math.round(e*255),Math.round(b*255),Math.round(L*255),N)}}i.$ku=g;class w{constructor(l,f,$,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.v=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,m),0),3)}static equals(l,f){return l.h===f.h&&l.s===f.s&&l.v===f.v&&l.a===f.a}static fromRGBA(l){const f=l.r/255,$=l.g/255,m=l.b/255,N=Math.max(f,$,m),e=Math.min(f,$,m),b=N-e,L=N===0?0:b/N;let _;return b===0?_=0:N===f?_=(($-m)/b%6+6)%6:N===$?_=(m-f)/b+2:_=(f-$)/b+4,new w(Math.round(_*60),L,N,l.a)}static toRGBA(l){const{h:f,s:$,v:m,a:N}=l,e=m*$,b=e*(1-Math.abs(f/60%2-1)),L=m-e;let[_,A,E]=[0,0,0];return f<60?(_=e,A=b):f<120?(_=b,A=e):f<180?(A=e,E=b):f<240?(A=b,E=e):f<300?(_=b,E=e):f<=360&&(_=e,E=b),_=Math.round((_+L)*255),A=Math.round((A+L)*255),E=Math.round((E+L)*255),new p(_,A,E,N)}}i.$lu=w;class d{static fromHex(l){return d.Format.CSS.parseHex(l)||d.red}static equals(l,f){return!l&&!f?!0:!l||!f?!1:l.equals(f)}get hsla(){return this.i?this.i:g.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:w.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof p)this.rgba=l;else if(l instanceof g)this.i=l,this.rgba=g.toRGBA(l);else if(l instanceof w)this.j=l,this.rgba=w.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&p.equals(this.rgba,l.rgba)&&g.equals(this.hsla,l.hsla)&&w.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=d.k(this.rgba.r),f=d.k(this.rgba.g),$=d.k(this.rgba.b),m=.2126*l+.7152*f+.0722*$;return n(m,4)}static k(l){const f=l/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(l){const f=this.getRelativeLuminance(),$=l.getRelativeLuminance();return f>$?(f+.05)/($+.05):($+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const f=this.getRelativeLuminance(),$=l.getRelativeLuminance();return f>$}isDarkerThan(l){const f=this.getRelativeLuminance(),$=l.getRelativeLuminance();return f<$}lighten(l){return new d(new g(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new d(new g(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:f,g:$,b:m,a:N}=this.rgba;return new d(new p(f,$,m,N*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new d(new p(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const f=l.rgba,$=this.rgba.a,m=f.a,N=$+m*(1-$);if(N<1e-6)return d.transparent;const e=this.rgba.r*$/N+f.r*m*(1-$)/N,b=this.rgba.g*$/N+f.g*m*(1-$)/N,L=this.rgba.b*$/N+f.b*m*(1-$)/N;return new d(new p(e,b,L,N))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:f,g:$,b:m,a:N}=this.rgba;return new d(new p(l.rgba.r-N*(l.rgba.r-f),l.rgba.g-N*(l.rgba.g-$),l.rgba.b-N*(l.rgba.b-m),1))}flatten(...l){const f=l.reduceRight(($,m)=>d.o(m,$));return d.o(this,f)}static o(l,f){const $=1-l.rgba.a;return new d(new p($*f.rgba.r+l.rgba.a*l.rgba.r,$*f.rgba.g+l.rgba.a*l.rgba.g,$*f.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=d.Format.CSS.format(this)),this.u}static getLighterColor(l,f,$){if(l.isLighterThan(f))return l;$=$||.5;const m=l.getRelativeLuminance(),N=f.getRelativeLuminance();return $=$*(N-m)/N,l.lighten($)}static getDarkerColor(l,f,$){if(l.isDarkerThan(f))return l;$=$||.5;const m=l.getRelativeLuminance(),N=f.getRelativeLuminance();return $=$*(m-N)/m,l.darken($)}}i.$mu=d,d.white=new d(new p(255,255,255,1)),d.black=new d(new p(0,0,0,1)),d.red=new d(new p(255,0,0,1)),d.blue=new d(new p(0,0,255,1)),d.green=new d(new p(0,255,0,1)),d.cyan=new d(new p(0,255,255,1)),d.lightgrey=new d(new p(211,211,211,1)),d.transparent=new d(new p(0,0,0,0)),function(a){let l;(function(f){let $;(function(m){function N(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:a.Format.CSS.formatRGBA(r)}m.formatRGB=N;function e(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}m.formatRGBA=e;function b(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:a.Format.CSS.formatHSLA(r)}m.formatHSL=b;function L(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}m.formatHSLA=L;function _(r){const o=r.toString(16);return o.length!==2?"0"+o:o}function A(r){return`#${_(r.rgba.r)}${_(r.rgba.g)}${_(r.rgba.b)}`}m.formatHex=A;function E(r,o=!1){return o&&r.rgba.a===1?a.Format.CSS.formatHex(r):`#${_(r.rgba.r)}${_(r.rgba.g)}${_(r.rgba.b)}${_(Math.round(r.rgba.a*255))}`}m.formatHexA=E;function v(r){return r.isOpaque()?a.Format.CSS.formatHex(r):a.Format.CSS.formatRGBA(r)}m.format=v;function h(r){const o=r.length;if(o===0||r.charCodeAt(0)!==t.CharCode.Hash)return null;if(o===7){const c=16*u(r.charCodeAt(1))+u(r.charCodeAt(2)),T=16*u(r.charCodeAt(3))+u(r.charCodeAt(4)),R=16*u(r.charCodeAt(5))+u(r.charCodeAt(6));return new a(new p(c,T,R,1))}if(o===9){const c=16*u(r.charCodeAt(1))+u(r.charCodeAt(2)),T=16*u(r.charCodeAt(3))+u(r.charCodeAt(4)),R=16*u(r.charCodeAt(5))+u(r.charCodeAt(6)),j=16*u(r.charCodeAt(7))+u(r.charCodeAt(8));return new a(new p(c,T,R,j/255))}if(o===4){const c=u(r.charCodeAt(1)),T=u(r.charCodeAt(2)),R=u(r.charCodeAt(3));return new a(new p(16*c+c,16*T+T,16*R+R))}if(o===5){const c=u(r.charCodeAt(1)),T=u(r.charCodeAt(2)),R=u(r.charCodeAt(3)),j=u(r.charCodeAt(4));return new a(new p(16*c+c,16*T+T,16*R+R,(16*j+j)/255))}return null}m.parseHex=h;function u(r){switch(r){case t.CharCode.Digit0:return 0;case t.CharCode.Digit1:return 1;case t.CharCode.Digit2:return 2;case t.CharCode.Digit3:return 3;case t.CharCode.Digit4:return 4;case t.CharCode.Digit5:return 5;case t.CharCode.Digit6:return 6;case t.CharCode.Digit7:return 7;case t.CharCode.Digit8:return 8;case t.CharCode.Digit9:return 9;case t.CharCode.a:return 10;case t.CharCode.A:return 10;case t.CharCode.b:return 11;case t.CharCode.B:return 11;case t.CharCode.c:return 12;case t.CharCode.C:return 12;case t.CharCode.d:return 13;case t.CharCode.D:return 13;case t.CharCode.e:return 14;case t.CharCode.E:return 14;case t.CharCode.f:return 15;case t.CharCode.F:return 15}return 0}})($=f.CSS||(f.CSS={}))})(l=a.Format||(a.Format={}))}(d||(i.$mu=d={}))}),ne(ie[39],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Qt=void 0;class t{constructor(p,g,w,d){this.originalStart=p,this.originalLength=g,this.modifiedStart=w,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.$Qt=t}),ne(ie[4],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$fb=i.$eb=i.$db=i.$cb=i.$bb=i.$_=i.$8=i.$Z=i.$Y=void 0,i.setUnexpectedErrorHandler=n,i.$2=p,i.$3=g,i.$4=w,i.$5=d,i.$6=a,i.$7=f,i.$9=m,i.$0=N,i.$$=e,i.$ab=L;class t{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(o=>{o(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}i.$Y=t,i.$Z=new t;function n(u){i.$Z.setUnexpectedErrorHandler(u)}function p(u){if(!u||typeof u!="object")return!1;const r=u;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function g(u){f(u)||i.$Z.onUnexpectedError(u)}function w(u){f(u)||i.$Z.onUnexpectedExternalError(u)}function d(u){if(u instanceof Error){const{name:r,message:o}=u,c=u.stacktrace||u.stack;return{$isError:!0,name:r,message:o,stack:c,noTelemetry:v.isErrorNoTelemetry(u)}}return u}function a(u){let r;return u.noTelemetry?r=new v:(r=new Error,r.name=u.name),r.message=u.message,r.stack=u.stack,r}const l="Canceled";function f(u){return u instanceof $?!0:u instanceof Error&&u.name===l&&u.message===l}class $ extends Error{constructor(){super(l),this.name=this.message}}i.$8=$;function m(){const u=new Error(l);return u.name=u.message,u}function N(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function e(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class b extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}i.$_=b;function L(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class _ extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}i.$bb=_;class A extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}i.$cb=A;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}i.$db=E;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const o=new v;return o.message=r.message,o.stack=r.stack,o}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}i.$eb=v;class h extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}i.$fb=h}),ne(ie[7],re([0,1,4,9]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$dc=i.$cc=i.$bc=i.$_b=i.$$b=i.CompareResult=void 0,i.$vb=p,i.$wb=g,i.$xb=w,i.$yb=d,i.$zb=a,i.$Ab=l,i.$Bb=f,i.$Cb=$,i.$Db=m,i.$Eb=N,i.$Fb=e,i.$Gb=b,i.$Hb=L,i.top=_,i.$Jb=A,i.$Kb=v,i.$Lb=h,i.$Mb=u,i.$Nb=r,i.$Ob=o,i.$Pb=c,i.$Qb=T,i.$Rb=R,i.$Sb=j,i.$Tb=D,i.$Ub=M,i.$Vb=S,i.$Wb=y,i.$Xb=F,i.$Yb=q,i.$Zb=X,i.$1b=B,i.$2b=P,i.$3b=Y,i.$4b=Q,i.$5b=H,i.$6b=K,i.$7b=C,i.$8b=k,i.$9b=ce,i.$0b=we,i.$ac=De;function p(U,V=0){return U[U.length-(1+V)]}function g(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function w(U,V,W=(Z,ee)=>Z===ee){if(U===V)return!0;if(!U||!V||U.length!==V.length)return!1;for(let Z=0,ee=U.length;Z<ee;Z++)if(!W(U[Z],V[Z]))return!1;return!0}function d(U,V){const W=U.length-1;V<W&&(U[V]=U[W]),U.pop()}function a(U,V,W){return l(U.length,Z=>W(U[Z],V))}function l(U,V){let W=0,Z=U-1;for(;W<=Z;){const ee=(W+Z)/2|0,he=V(ee);if(he<0)W=ee+1;else if(he>0)Z=ee-1;else return ee}return-(W+1)}function f(U,V,W){if(U=U|0,U>=V.length)throw new TypeError("invalid index");const Z=V[Math.floor(V.length*Math.random())],ee=[],he=[],de=[];for(const ve of V){const Ae=W(ve,Z);Ae<0?ee.push(ve):Ae>0?he.push(ve):de.push(ve)}return U<ee.length?f(U,ee,W):U<ee.length+de.length?de[0]:f(U-(ee.length+de.length),he,W)}function $(U,V){const W=[];let Z;for(const ee of U.slice(0).sort(V))!Z||V(Z[0],ee)!==0?(Z=[ee],W.push(Z)):Z.push(ee);return W}function*m(U,V){let W,Z;for(const ee of U)Z!==void 0&&V(Z,ee)?W.push(ee):(W&&(yield W),W=[ee]),Z=ee;W&&(yield W)}function N(U,V){for(let W=0;W<=U.length;W++)V(W===0?void 0:U[W-1],W===U.length?void 0:U[W])}function e(U,V){for(let W=0;W<U.length;W++)V(W===0?void 0:U[W-1],U[W],W+1===U.length?void 0:U[W+1])}function b(U,V,W){const Z=[];function ee(ve,Ae,pe){if(Ae===0&&pe.length===0)return;const se=Z[Z.length-1];se&&se.start+se.deleteCount===ve?(se.deleteCount+=Ae,se.toInsert.push(...pe)):Z.push({start:ve,deleteCount:Ae,toInsert:pe})}let he=0,de=0;for(;;){if(he===U.length){ee(he,0,V.slice(de));break}if(de===V.length){ee(he,U.length-he,[]);break}const ve=U[he],Ae=V[de],pe=W(ve,Ae);pe===0?(he+=1,de+=1):pe<0?(ee(he,1,[]),he+=1):pe>0&&(ee(he,0,[Ae]),de+=1)}return Z}function L(U,V,W){const Z=b(U,V,W),ee=[],he=[];for(const de of Z)ee.push(...U.slice(de.start,de.start+de.deleteCount)),he.push(...de.toInsert);return{removed:ee,added:he}}function _(U,V,W){if(W===0)return[];const Z=U.slice(0,W).sort(V);return E(U,V,Z,W,U.length),Z}function A(U,V,W,Z,ee){return W===0?Promise.resolve([]):new Promise((he,de)=>{(async()=>{const ve=U.length,Ae=U.slice(0,W).sort(V);for(let pe=W,se=Math.min(W+Z,ve);pe<ve;pe=se,se=Math.min(se+Z,ve)){if(pe>W&&await new Promise(te=>setTimeout(te)),ee&&ee.isCancellationRequested)throw new t.$8;E(U,V,Ae,pe,se)}return Ae})().then(he,de)})}function E(U,V,W,Z,ee){for(const he=W.length;Z<ee;Z++){const de=U[Z];if(V(de,W[he-1])<0){W.pop();const ve=(0,n.$nb)(W,Ae=>V(de,Ae)<0);W.splice(ve,0,de)}}}function v(U){return U.filter(V=>!!V)}function h(U){let V=0;for(let W=0;W<U.length;W++)U[W]&&(U[V]=U[W],V+=1);U.length=V}function u(U,V,W){U.splice(W,0,U.splice(V,1)[0])}function r(U){return!Array.isArray(U)||U.length===0}function o(U){return Array.isArray(U)&&U.length>0}function c(U,V=W=>W){const W=new Set;return U.filter(Z=>{const ee=V(Z);return W.has(ee)?!1:(W.add(ee),!0)})}function T(U){const V=new Set;return W=>{const Z=U(W);return V.has(Z)?!1:(V.add(Z),!0)}}function R(U,V){return U.length>0?U[0]:V}function j(U,V){return U.length>0?U[U.length-1]:V}function D(U,V,W=(Z,ee)=>Z===ee){let Z=0;for(let ee=0,he=Math.min(U.length,V.length);ee<he&&W(U[ee],V[ee]);ee++)Z++;return Z}function M(U,V){let W=typeof V=="number"?U:0;typeof V=="number"?W=U:(W=0,V=U);const Z=[];if(W<=V)for(let ee=W;ee<V;ee++)Z.push(ee);else for(let ee=W;ee>V;ee--)Z.push(ee);return Z}function S(U,V,W){return U.reduce((Z,ee)=>(Z[V(ee)]=W?W(ee):ee,Z),Object.create(null))}function y(U,V){return U.push(V),()=>F(U,V)}function F(U,V){const W=U.indexOf(V);if(W>-1)return U.splice(W,1),V}function q(U,V,W){const Z=U.slice(0,V),ee=U.slice(V);return Z.concat(W,ee)}function X(U,V){let W;if(typeof V=="number"){let Z=V;W=()=>{const ee=Math.sin(Z++)*179426549;return ee-Math.floor(ee)}}else W=Math.random;for(let Z=U.length-1;Z>0;Z-=1){const ee=Math.floor(W()*(Z+1)),he=U[Z];U[Z]=U[ee],U[ee]=he}}function B(U,V){const W=U.indexOf(V);W>-1&&(U.splice(W,1),U.unshift(V))}function P(U,V){const W=U.indexOf(V);W>-1&&(U.splice(W,1),U.push(V))}function Y(U,V){for(const W of V)U.push(W)}function Q(U,V){return Array.isArray(U)?U.map(V):V(U)}function H(U){return Array.isArray(U)?U:[U]}function K(U){return U[Math.floor(Math.random()*U.length)]}function C(U,V,W){const Z=G(U,V),ee=U.length,he=W.length;U.length=ee+he;for(let de=ee-1;de>=Z;de--)U[de+he]=U[de];for(let de=0;de<he;de++)U[de+Z]=W[de]}function k(U,V,W,Z){const ee=G(U,V);let he=U.splice(ee,W);return he===void 0&&(he=[]),C(U,ee,Z),he}function G(U,V){return V<0?Math.max(V+U.length,0):Math.min(V,U.length)}var oe;(function(U){function V(he){return he<0}U.isLessThan=V;function W(he){return he<=0}U.isLessThanOrEqual=W;function Z(he){return he>0}U.isGreaterThan=Z;function ee(he){return he===0}U.isNeitherLessOrGreaterThan=ee,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(oe||(i.CompareResult=oe={}));function ce(U,V){return(W,Z)=>V(U(W),U(Z))}function we(...U){return(V,W)=>{for(const Z of U){const ee=Z(V,W);if(!oe.isNeitherLessOrGreaterThan(ee))return ee}return oe.neitherLessOrGreaterThan}}const s=(U,V)=>U-V;i.$$b=s;const Te=(U,V)=>(0,i.$$b)(U?1:0,V?1:0);i.$_b=Te;function De(U){return(V,W)=>-U(V,W)}class Ue{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let W=this.c;for(;W<this.g.length&&V(this.g[W]);)W++;const Z=W===this.c?null:this.g.slice(this.c,W);return this.c=W,Z}takeFromEndWhile(V){let W=this.d;for(;W>=0&&V(this.g[W]);)W--;const Z=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const W=this.g.slice(this.c,this.c+V);return this.c+=V,W}}i.$bc=Ue;class Fe{constructor(V){this.iterate=V}forEach(V){this.iterate(W=>(V(W),!0))}toArray(){const V=[];return this.iterate(W=>(V.push(W),!0)),V}filter(V){return new Fe(W=>this.iterate(Z=>V(Z)?W(Z):!0))}map(V){return new Fe(W=>this.iterate(Z=>W(V(Z))))}some(V){let W=!1;return this.iterate(Z=>(W=V(Z),!W)),W}findFirst(V){let W;return this.iterate(Z=>V(Z)?(W=Z,!1):!0),W}findLast(V){let W;return this.iterate(Z=>(V(Z)&&(W=Z),!0)),W}findLastMaxBy(V){let W,Z=!0;return this.iterate(ee=>((Z||oe.isGreaterThan(V(ee,W)))&&(Z=!1,W=ee),!0)),W}}i.$cc=Fe,Fe.empty=new Fe(U=>{});class ke{constructor(V){this.c=V}static createSortPermutation(V,W){const Z=Array.from(V.keys()).sort((ee,he)=>W(V[ee],V[he]));return new ke(Z)}apply(V){return V.map((W,Z)=>V[this.c[Z]])}inverse(){const V=this.c.slice();for(let W=0;W<this.c.length;W++)V[this.c[W]]=W;return new ke(V)}}i.$dc=ke}),ne(ie[11],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=n,i.$hd=p,i.$id=g,i.$jd=w,i.$kd=d,i.$ld=a;function n(l,f){if(!l)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function p(l,f="Unreachable"){throw new Error(f)}function g(l,f="unexpected state"){if(!l)throw new t.$fb(`Assertion Failed: ${f}`)}function w(l){l||(0,t.$3)(new t.$fb("Soft Assertion Failed"))}function d(l){if(!l()){debugger;l(),(0,t.$3)(new t.$fb("Assertion Failed"))}}function a(l,f){let $=0;for(;$<l.length-1;){const m=l[$],N=l[$+1];if(!f(m,N))return!1;$++}return!0}}),ne(ie[22],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gb=t;function t(n,p){const g=this;let w=!1,d;return function(){if(w)return d;if(w=!0,p)try{d=n.apply(g,arguments)}finally{p()}else d=n.apply(g,arguments);return d}}}),ne(ie[23],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var t;(function(n){function p(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=p;const g=Object.freeze([]);function w(){return g}n.empty=w;function*d(r){yield r}n.single=d;function a(r){return p(r)?r:d(r)}n.wrap=a;function l(r){return r||g}n.from=l;function*f(r){for(let o=r.length-1;o>=0;o--)yield r[o]}n.reverse=f;function $(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=$;function m(r){return r[Symbol.iterator]().next().value}n.first=m;function N(r,o){let c=0;for(const T of r)if(o(T,c++))return!0;return!1}n.some=N;function e(r,o){for(const c of r)if(o(c))return c}n.find=e;function*b(r,o){for(const c of r)o(c)&&(yield c)}n.filter=b;function*L(r,o){let c=0;for(const T of r)yield o(T,c++)}n.map=L;function*_(r,o){let c=0;for(const T of r)yield*o(T,c++)}n.flatMap=_;function*A(...r){for(const o of r)yield*o}n.concat=A;function E(r,o,c){let T=c;for(const R of r)T=o(T,R);return T}n.reduce=E;function*v(r,o,c=r.length){for(o<0&&(o+=r.length),c<0?c+=r.length:c>r.length&&(c=r.length);o<c;o++)yield r[o]}n.slice=v;function h(r,o=Number.POSITIVE_INFINITY){const c=[];if(o===0)return[c,r];const T=r[Symbol.iterator]();for(let R=0;R<o;R++){const j=T.next();if(j.done)return[c,n.empty()];c.push(j.value)}return[c,{[Symbol.iterator](){return T}}]}n.consume=h;async function u(r){const o=[];for await(const c of r)o.push(c);return Promise.resolve(o)}n.asyncToArray=u})(t||(i.Iterable=t={}))}),ne(ie[40],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=i.KeyCodeUtils=i.$Wr=i.$Vr=i.$Ur=i.$Tr=i.$Sr=i.ScanCode=i.KeyCode=void 0,i.$Xr=N;var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(t||(i.KeyCode=t={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(i.ScanCode=n={}));class p{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(b,L){this._keyCodeToStr[b]=L,this._strToKeyCode[L.toLowerCase()]=b}keyCodeToStr(b){return this._keyCodeToStr[b]}strToKeyCode(b){return this._strToKeyCode[b.toLowerCase()]||t.Unknown}}const g=new p,w=new p,d=new p;i.$Sr=new Array(230),i.$Tr={};const a=[],l=Object.create(null),f=Object.create(null);i.$Ur={lowerCaseToEnum:e=>f[e]||n.None,toEnum:e=>l[e]||n.None,toString:e=>a[e]||"None"},i.$Vr=[],i.$Wr=[];for(let e=0;e<=n.MAX_VALUE;e++)i.$Vr[e]=t.DependsOnKbLayout;for(let e=0;e<=t.MAX_VALUE;e++)i.$Wr[e]=n.DependsOnKbLayout;(function(){const e="",b=[[1,n.None,"None",t.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",t.Unknown,e,0,e,e,e],[1,n.Super,"Super",t.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",t.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",t.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",t.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",t.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",t.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",t.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",t.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",t.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",t.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",t.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",t.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",t.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",t.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",t.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",t.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",t.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",t.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",t.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",t.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",t.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",t.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",t.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",t.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",t.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",t.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",t.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",t.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",t.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",t.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",t.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",t.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",t.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",t.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",t.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",t.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",t.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",t.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",t.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",t.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",t.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",t.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",t.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",t.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",t.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",t.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",t.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",t.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",t.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",t.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",t.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",t.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",t.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",t.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",t.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",t.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",t.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",t.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",t.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",t.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",t.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",t.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",t.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",t.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",t.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",t.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",t.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",t.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",t.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",t.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",t.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",t.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",t.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",t.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",t.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",t.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",t.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",t.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",t.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",t.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",t.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",t.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",t.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",t.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",t.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",t.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",t.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",t.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",t.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",t.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",t.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",t.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",t.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",t.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",t.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",t.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",t.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",t.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",t.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",t.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",t.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",t.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",t.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",t.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",t.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",t.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",t.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",t.Unknown,e,0,e,e,e],[1,n.F13,"F13",t.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",t.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",t.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",t.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",t.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",t.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",t.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",t.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",t.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",t.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",t.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",t.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",t.Unknown,e,0,e,e,e],[1,n.Help,"Help",t.Unknown,e,0,e,e,e],[1,n.Select,"Select",t.Unknown,e,0,e,e,e],[1,n.Again,"Again",t.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",t.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",t.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",t.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",t.Unknown,e,0,e,e,e],[1,n.Find,"Find",t.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",t.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",t.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",t.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",t.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",t.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",t.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",t.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",t.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",t.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",t.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",t.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",t.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",t.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",t.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",t.Unknown,e,0,e,e,e],[1,n.Props,"Props",t.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",t.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",t.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",t.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",t.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",t.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",t.Unknown,e,0,e,e,e],[1,n.None,e,t.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,t.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,t.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,t.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",t.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",t.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",t.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",t.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",t.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",t.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",t.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",t.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",t.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",t.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",t.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",t.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",t.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",t.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",t.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",t.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",t.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",t.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",t.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",t.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",t.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",t.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",t.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",t.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",t.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",t.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",t.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",t.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",t.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",t.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",t.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",t.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",t.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",t.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",t.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",t.Unknown,e,0,e,e,e],[1,n.None,e,t.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,t.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,t.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,t.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,t.Unknown,e,0,"VK_OEM_CLEAR",e,e]],L=[],_=[];for(const A of b){const[E,v,h,u,r,o,c,T,R]=A;if(_[v]||(_[v]=!0,a[v]=h,l[h]=v,f[h.toLowerCase()]=v,E&&(i.$Vr[v]=u,u!==t.Unknown&&u!==t.Enter&&u!==t.Ctrl&&u!==t.Shift&&u!==t.Alt&&u!==t.Meta&&(i.$Wr[u]=v))),!L[u]){if(L[u]=!0,!r)throw new Error(`String representation missing for key code ${u} around scan code ${h}`);g.define(u,r),w.define(u,T||r),d.define(u,R||T||r)}o&&(i.$Sr[o]=u),c&&(i.$Tr[c]=u)}i.$Wr[t.Enter]=n.Enter})();var $;(function(e){function b(h){return g.keyCodeToStr(h)}e.toString=b;function L(h){return g.strToKeyCode(h)}e.fromString=L;function _(h){return w.keyCodeToStr(h)}e.toUserSettingsUS=_;function A(h){return d.keyCodeToStr(h)}e.toUserSettingsGeneral=A;function E(h){return w.strToKeyCode(h)||d.strToKeyCode(h)}e.fromUserSettings=E;function v(h){if(h>=t.Numpad0&&h<=t.NumpadDivide)return null;switch(h){case t.UpArrow:return"Up";case t.DownArrow:return"Down";case t.LeftArrow:return"Left";case t.RightArrow:return"Right"}return g.keyCodeToStr(h)}e.toElectronAccelerator=v})($||(i.KeyCodeUtils=$={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m||(i.KeyMod=m={}));function N(e,b){const L=(b&65535)<<16>>>0;return(e|L)>>>0}}),ne(ie[41],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$X=void 0;class t{constructor(p){this.d=p,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(p){this.c=p}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}i.$X=t}),ne(ie[24],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8c=void 0;class t{constructor(g){this.element=g,this.next=t.Undefined,this.prev=t.Undefined}}t.Undefined=new t(void 0);class n{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let g=this.a;for(;g!==t.Undefined;){const w=g.next;g.prev=t.Undefined,g.next=t.Undefined,g=w}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(g){return this.d(g,!1)}push(g){return this.d(g,!0)}d(g,w){const d=new t(g);if(this.a===t.Undefined)this.a=d,this.b=d;else if(w){const l=this.b;this.b=d,d.prev=l,l.next=d}else{const l=this.a;this.a=d,d.next=l,l.prev=d}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(d))}}shift(){if(this.a!==t.Undefined){const g=this.a.element;return this.e(this.a),g}}pop(){if(this.b!==t.Undefined){const g=this.b.element;return this.e(this.b),g}}e(g){if(g.prev!==t.Undefined&&g.next!==t.Undefined){const w=g.prev;w.next=g.next,g.next.prev=w}else g.prev===t.Undefined&&g.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):g.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):g.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let g=this.a;for(;g!==t.Undefined;)yield g.element,g=g.next}}i.$8c=n}),ne(ie[16],re([0,1]),function(x,i){"use strict";var t,n,p;Object.defineProperty(i,"__esModule",{value:!0}),i.$Kc=i.$Jc=i.$Ic=i.$Hc=i.$Gc=i.$Fc=i.Touch=i.$Ec=i.$Dc=void 0,i.$Ac=g,i.$Bc=w,i.$Cc=d,i.$Lc=v;function g(h,u,r){let o=h.get(u);return o===void 0&&(o=r,h.set(u,o)),o}function w(h){const u=[];return h.forEach((r,o)=>{u.push(`${o} => ${r}`)}),`Map(${h.size}) {${u.join(", ")}}`}function d(h){const u=[];return h.forEach(r=>{u.push(r)}),`Set(${h.size}) {${u.join(", ")}}`}class a{constructor(u,r){this.uri=u,this.value=r}}function l(h){return Array.isArray(h)}class f{constructor(u,r){if(this[t]="ResourceMap",u instanceof f)this.d=new Map(u.d),this.e=r??f.c;else if(l(u)){this.d=new Map,this.e=r??f.c;for(const[o,c]of u)this.set(o,c)}else this.d=new Map,this.e=u??f.c}set(u,r){return this.d.set(this.e(u),new a(u,r)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,r){typeof r<"u"&&(u=u.bind(r));for(const[o,c]of this.d)u(c.value,c.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}i.$Dc=f,f.c=h=>h.toString();class ${constructor(u,r){this[n]="ResourceSet",!u||typeof u=="function"?this.c=new f(u):(this.c=new f(r),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,r){this.c.forEach((o,c)=>u.call(r,c,c,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}i.$Ec=$;var m;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(m||(i.Touch=m={}));class N{constructor(){this[p]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,r=m.None){const o=this.c.get(u);if(o)return r!==m.None&&this.m(o,r),o.value}set(u,r,o=m.None){let c=this.c.get(u);if(c)c.value=r,o!==m.None&&this.m(c,o);else{switch(c={key:u,value:r,next:void 0,previous:void 0},o){case m.None:this.k(c);break;case m.AsOld:this.j(c);break;case m.AsNew:this.k(c);break;default:this.k(c);break}this.c.set(u,c),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const r=this.c.get(u);if(r)return this.c.delete(u),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,r){const o=this.g;let c=this.d;for(;c;){if(r?u.bind(r)(c.value,c.key,this):u(c.value,c.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const u=this,r=this.g;let o=this.d;const c={[Symbol.iterator](){return c},next(){if(u.g!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const T={value:o.key,done:!1};return o=o.next,T}else return{value:void 0,done:!0}}};return c}values(){const u=this,r=this.g;let o=this.d;const c={[Symbol.iterator](){return c},next(){if(u.g!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const T={value:o.value,done:!1};return o=o.next,T}else return{value:void 0,done:!0}}};return c}entries(){const u=this,r=this.g;let o=this.d;const c={[Symbol.iterator](){return c},next(){if(u.g!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const T={value:[o.key,o.value],done:!1};return o=o.next,T}else return{value:void 0,done:!0}}};return c}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let r=this.d,o=this.size;for(;r&&o>u;)this.c.delete(r.key),r=r.next,o--;this.d=r,this.f=o,r&&(r.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let r=this.e,o=this.size;for(;r&&o>u;)this.c.delete(r.key),r=r.previous,o--;this.e=r,this.f=o,r&&(r.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const r=u.next,o=u.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}u.next=void 0,u.previous=void 0,this.g++}m(u,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==m.AsOld&&r!==m.AsNew)){if(r===m.AsOld){if(u===this.d)return;const o=u.next,c=u.previous;u===this.e?(c.next=void 0,this.e=c):(o.previous=c,c.next=o),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(r===m.AsNew){if(u===this.e)return;const o=u.next,c=u.previous;u===this.d?(o.previous=void 0,this.d=o):(o.previous=c,c.next=o),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((r,o)=>{u.push([o,r])}),u}fromJSON(u){this.clear();for(const[r,o]of u)this.set(r,o)}}i.$Fc=N;class e extends N{constructor(u,r=1){super(),this.n=u,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,r=m.AsNew){return super.get(u,r)}peek(u){return super.get(u,m.None)}set(u,r){return super.set(u,r,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class b extends e{constructor(u,r=1){super(u,r)}q(u){this.h(u)}set(u,r){return super.set(u,r),this.p(),this}}i.$Gc=b;class L extends e{constructor(u,r=1){super(u,r)}q(u){this.i(u)}set(u,r){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,r),this}}i.$Hc=L;class _{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let r=this.c.get(u)||0;return r===0?!1:(r--,r===0?this.c.delete(u):this.c.set(u,r),!0)}has(u){return this.c.has(u)}}i.$Ic=_;class A{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[r,o]of u)this.set(r,o)}clear(){this.c.clear(),this.d.clear()}set(u,r){this.c.set(u,r),this.d.set(r,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const r=this.c.get(u);return r===void 0?!1:(this.c.delete(u),this.d.delete(r),!0)}forEach(u,r){this.c.forEach((o,c)=>{u.call(r,o,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}i.$Jc=A;class E{constructor(){this.c=new Map}add(u,r){let o=this.c.get(u);o||(o=new Set,this.c.set(u,o)),o.add(r)}delete(u,r){const o=this.c.get(u);o&&(o.delete(r),o.size===0&&this.c.delete(u))}forEach(u,r){const o=this.c.get(u);o&&o.forEach(r)}get(u){const r=this.c.get(u);return r||new Set}}i.$Kc=E;function v(h,u){if(h===u)return!0;if(h.size!==u.size)return!1;for(const[r,o]of h)if(!u.has(r)||u.get(r)!==o)return!1;for(const[r]of u)if(!h.has(r))return!1;return!0}}),ne(ie[12],re([0,1,7,37,16,22,23]),function(x,i,t,n,p,g,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$7c=i.$5c=i.$4c=i.$3c=i.$2c=i.$1c=i.$Zc=i.$Yc=i.$Xc=i.$Wc=i.$Mc=void 0,i.$Nc=f,i.$Oc=$,i.$Pc=m,i.$Qc=b,i.$Rc=L,i.$Sc=_,i.$Tc=A,i.$Uc=E,i.$Vc=v,i.$6c=M;const d=!1;let a=null;class l{constructor(){this.b=new Map}c(F){let q=this.b.get(F);return q||(q={parent:null,source:null,isSingleton:!1,value:F,idx:l.a++},this.b.set(F,q)),q}trackDisposable(F){const q=this.c(F);q.source||(q.source=new Error().stack)}setParent(F,q){const X=this.c(F);X.parent=q}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,q){const X=q.get(F);if(X)return X;const B=F.parent?this.f(this.c(F.parent),q):F;return q.set(F,B),B}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,X])=>X.source!==null&&!this.f(X,F).isSingleton).flatMap(([X])=>X)}computeLeakingDisposables(F=10,q){let X;if(q)X=q;else{const H=new Map,K=[...this.b.values()].filter(k=>k.source!==null&&!this.f(k,H).isSingleton);if(K.length===0)return;const C=new Set(K.map(k=>k.value));if(X=K.filter(k=>!(k.parent&&C.has(k.parent))),X.length===0)throw new Error("There are cyclic diposable chains!")}if(!X)return;function B(H){function K(k,G){for(;k.length>0&&G.some(oe=>typeof oe=="string"?oe===k[0]:k[0].match(oe));)k.shift()}const C=H.source.split(`
`).map(k=>k.trim().replace("at ","")).filter(k=>k!=="");return K(C,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),C.reverse()}const P=new p.$Kc;for(const H of X){const K=B(H);for(let C=0;C<=K.length;C++)P.add(K.slice(0,C).join(`
`),H)}X.sort((0,t.$9b)(H=>H.idx,t.$$b));let Y="",Q=0;for(const H of X.slice(0,F)){Q++;const K=B(H),C=[];for(let k=0;k<K.length;k++){let G=K[k];G=`(shared with ${P.get(K.slice(0,k+1).join(`
`)).size}/${X.length} leaks) at ${G}`;const ce=P.get(K.slice(0,k).join(`
`)),we=(0,n.$E)([...ce].map(s=>B(s)[k]),s=>s);delete we[K[k]];for(const[s,Te]of Object.entries(we))C.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${s}`);C.unshift(G)}Y+=`


==================== Leaking disposable ${Q}/${X.length}: ${H.value.constructor.name} ====================
${C.join(`
`)}
============================================================

`}return X.length>F&&(Y+=`


... and ${X.length-F} more leaking disposables

`),{leaks:X,details:Y}}}i.$Mc=l,l.a=0;function f(y){a=y}if(d){const y="__is_disposable_tracked__";f(new class{trackDisposable(F){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[y]||console.log(q)},3e3)}setParent(F,q){if(F&&F!==u.None)try{F[y]=!0}catch{}}markAsDisposed(F){if(F&&F!==u.None)try{F[y]=!0}catch{}}markAsSingleton(F){}})}function $(y){return a?.trackDisposable(y),y}function m(y){a?.markAsDisposed(y)}function N(y,F){a?.setParent(y,F)}function e(y,F){if(a)for(const q of y)a.setParent(q,F)}function b(y){return a?.markAsSingleton(y),y}function L(y){return typeof y=="object"&&y!==null&&typeof y.dispose=="function"&&y.dispose.length===0}function _(y){if(w.Iterable.is(y)){const F=[];for(const q of y)if(q)try{q.dispose()}catch(X){F.push(X)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function A(y){for(const F of y)L(F)&&F.dispose();return[]}function E(...y){const F=v(()=>_(y));return e(y,F),F}function v(y){const F=$({dispose:(0,g.$gb)(()=>{m(F),y()})});return F}class h{constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{_(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return N(F,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),N(F,null))}}i.$Wc=h,h.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this.q=new h,$(this),N(this.q,this)}dispose(){m(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}i.$Xc=u,u.None=Object.freeze({dispose(){}});class r{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&N(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&N(F,null),F}}i.$Yc=r;class o{constructor(F){this.a=new r,this.b=!1,this.a.value=F}get value(){return this.a.value}set value(F){this.b||F===this.a.value||(this.a.value=F)}dispose(){this.b=!0,this.a.dispose()}}i.$Zc=o;class c{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}i.$1c=c;class T{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(F){let q=F;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,m(this))},this}}i.$2c=T;class R{constructor(){this.a=new Map}acquire(F,...q){let X=this.a.get(F);X||(X={counter:0,object:this.b(F,...q)},this.a.set(F,X));const{object:B}=X,P=(0,g.$gb)(()=>{--X.counter===0&&(this.c(F,X.object),this.a.delete(F))});return X.counter++,{object:B,dispose:P}}}i.$3c=R;class j{constructor(F){this.a=F}async acquire(F,...q){const X=this.a.acquire(F,...q);try{return{object:await X.object,dispose:()=>X.dispose()}}catch(B){throw X.dispose(),B}}}i.$4c=j;class D{constructor(F){this.object=F}dispose(){}}i.$5c=D;function M(y){const F=new h;try{y(F)}finally{F.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{_(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,q,X=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),X||this.a.get(F)?.dispose(),this.a.set(F,q)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}deleteAndLeak(F){const q=this.a.get(F);return this.a.delete(F),q}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}i.$7c=S}),ne(ie[42],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MarshalledId=void 0;var t;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(i.MarshalledId=t={}))}),ne(ie[17],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$C=i.$B=i.$A=i.$z=i.$y=i.OS=i.OperatingSystem=i.$v=i.$u=i.$t=i.$s=i.$r=i.Language=i.$q=i.$p=i.$o=i.$n=i.$m=i.$l=i.$k=i.$j=i.$i=i.$h=i.$g=i.$f=i.$e=i.$d=i.$c=i.Platform=i.$a=void 0,i.$b=u,i.$x=j,i.$D=D,i.$a="en";let t=!1,n=!1,p=!1,g=!1,w=!1,d=!1,a=!1,l=!1,f=!1,$=!1,m,N=i.$a,e=i.$a,b,L;const _=globalThis;let A;typeof _.vscode<"u"&&typeof _.vscode.process<"u"?A=_.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(A=process);const E=typeof A?.versions?.electron=="string",v=E&&A?.type==="renderer";if(typeof A=="object"){t=A.platform==="win32",n=A.platform==="darwin",p=A.platform==="linux",g=p&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,a=E,f=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=i.$a,N=i.$a;const M=A.env.VSCODE_NLS_CONFIG;if(M)try{const S=JSON.parse(M),y=S.availableLanguages["*"];m=S.locale,e=S.osLocale,N=y||i.$a,b=S._translationsConfigFile}catch{}w=!0}else if(typeof navigator=="object"&&!v){L=navigator.userAgent,t=L.indexOf("Windows")>=0,n=L.indexOf("Macintosh")>=0,l=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,p=L.indexOf("Linux")>=0,$=L?.indexOf("Mobi")>=0,d=!0,m=i.$a,N=m,e=navigator.language;const M=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),S=M&&M.getAttribute("data-settings");if(S)try{const y=JSON.parse(S),F=y.availableLanguages["*"];m=y.locale,e=y.osLocale,N=F||i.$a,b=y._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var h;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(h||(i.Platform=h={}));function u(M){switch(M){case h.Web:return"Web";case h.Mac:return"Mac";case h.Linux:return"Linux";case h.Windows:return"Windows"}}let r=h.Web;n?r=h.Mac:t?r=h.Windows:p&&(r=h.Linux),i.$c=t,i.$d=n,i.$e=p,i.$f=g,i.$g=w,i.$h=a,i.$i=d,i.$j=d&&typeof _.importScripts=="function",i.$k=i.$j?_.origin:void 0,i.$l=l,i.$m=$,i.$n=f,i.$o=r,i.$p=L,i.$q=N;var o;(function(M){function S(){return i.$q}M.value=S;function y(){return i.$q.length===2?i.$q==="en":i.$q.length>=3?i.$q[0]==="e"&&i.$q[1]==="n"&&i.$q[2]==="-":!1}M.isDefaultVariant=y;function F(){return i.$q==="en"}M.isDefault=F})(o||(i.Language=o={})),i.$r=m,i.$s=e,i.$t=b,i.$u=typeof _.postMessage=="function"&&!_.importScripts,i.$v=(()=>{if(i.$u){const M=[];_.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let F=0,q=M.length;F<q;F++){const X=M[F];if(X.id===y.data.vscodeScheduleAsyncWork){M.splice(F,1),X.callback();return}}});let S=0;return y=>{const F=++S;M.push({id:F,callback:y}),_.postMessage({vscodeScheduleAsyncWork:F},"*")}}return M=>setTimeout(M)})();var c;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(c||(i.OperatingSystem=c={})),i.OS=n||l?c.Macintosh:t?c.Windows:c.Linux;let T=!0,R=!1;function j(){if(!R){R=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,T=new Uint16Array(M.buffer)[0]===513}return T}i.$y=!!(i.$p&&i.$p.indexOf("Chrome")>=0),i.$z=!!(i.$p&&i.$p.indexOf("Firefox")>=0),i.$A=!!(!i.$y&&i.$p&&i.$p.indexOf("Safari")>=0),i.$B=!!(i.$p&&i.$p.indexOf("Edg/")>=0),i.$C=!!(i.$p&&i.$p.indexOf("Android")>=0);function D(M){return parseFloat(M)>=20}}),ne(ie[43],re([0,1,17]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$hc=i.$gc=i.env=i.cwd=void 0;let n;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.process<"u"){const g=p.process;n={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return t.$c?"win32":t.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=n.cwd,i.env=n.env,i.$gc=n.platform,i.$hc=n.arch});var Ze=this&&this.__createBinding||(Object.create?function(x,i,t,n){n===void 0&&(n=t);var p=Object.getOwnPropertyDescriptor(i,t);(!p||("get"in p?!i.__esModule:p.writable||p.configurable))&&(p={enumerable:!0,get:function(){return i[t]}}),Object.defineProperty(x,n,p)}:function(x,i,t,n){n===void 0&&(n=t),x[n]=i[t]}),Je=this&&this.__setModuleDefault||(Object.create?function(x,i){Object.defineProperty(x,"default",{enumerable:!0,value:i})}:function(x,i){x.default=i}),ye=this&&this.__importStar||function(x){if(x&&x.__esModule)return x;var i={};if(x!=null)for(var t in x)t!=="default"&&Object.prototype.hasOwnProperty.call(x,t)&&Ze(i,x,t);return Je(i,x),i};ne(ie[44],re([0,1,43]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$wc=i.sep=i.$uc=i.$tc=i.$sc=i.$rc=i.$qc=i.$pc=i.$oc=i.$nc=i.$mc=i.$lc=i.$kc=i.$jc=i.$ic=void 0,t=ye(t);const n=65,p=97,g=90,w=122,d=46,a=47,l=92,f=58,$=63;class m extends Error{constructor(r,o,c){let T;typeof o=="string"&&o.indexOf("not ")===0?(T="must not be",o=o.replace(/^not /,"")):T="must be";const R=r.indexOf(".")!==-1?"property":"argument";let j=`The "${r}" ${R} ${T} of type ${o}`;j+=`. Received type ${typeof c}`,super(j),this.code="ERR_INVALID_ARG_TYPE"}}function N(u,r){if(u===null||typeof u!="object")throw new m(r,"Object",u)}function e(u,r){if(typeof u!="string")throw new m(r,"string",u)}const b=t.$gc==="win32";function L(u){return u===a||u===l}function _(u){return u===a}function A(u){return u>=n&&u<=g||u>=p&&u<=w}function E(u,r,o,c){let T="",R=0,j=-1,D=0,M=0;for(let S=0;S<=u.length;++S){if(S<u.length)M=u.charCodeAt(S);else{if(c(M))break;M=a}if(c(M)){if(!(j===S-1||D===1))if(D===2){if(T.length<2||R!==2||T.charCodeAt(T.length-1)!==d||T.charCodeAt(T.length-2)!==d){if(T.length>2){const y=T.lastIndexOf(o);y===-1?(T="",R=0):(T=T.slice(0,y),R=T.length-1-T.lastIndexOf(o)),j=S,D=0;continue}else if(T.length!==0){T="",R=0,j=S,D=0;continue}}r&&(T+=T.length>0?`${o}..`:"..",R=2)}else T.length>0?T+=`${o}${u.slice(j+1,S)}`:T=u.slice(j+1,S),R=S-j-1;j=S,D=0}else M===d&&D!==-1?++D:D=-1}return T}function v(u,r){N(r,"pathObject");const o=r.dir||r.root,c=r.base||`${r.name||""}${r.ext||""}`;return o?o===r.root?`${o}${c}`:`${o}${u}${c}`:c}i.$ic={resolve(...u){let r="",o="",c=!1;for(let T=u.length-1;T>=-1;T--){let R;if(T>=0){if(R=u[T],e(R,"path"),R.length===0)continue}else r.length===0?R=t.cwd():(R=t.env[`=${r}`]||t.cwd(),(R===void 0||R.slice(0,2).toLowerCase()!==r.toLowerCase()&&R.charCodeAt(2)===l)&&(R=`${r}\\`));const j=R.length;let D=0,M="",S=!1;const y=R.charCodeAt(0);if(j===1)L(y)&&(D=1,S=!0);else if(L(y))if(S=!0,L(R.charCodeAt(1))){let F=2,q=F;for(;F<j&&!L(R.charCodeAt(F));)F++;if(F<j&&F!==q){const X=R.slice(q,F);for(q=F;F<j&&L(R.charCodeAt(F));)F++;if(F<j&&F!==q){for(q=F;F<j&&!L(R.charCodeAt(F));)F++;(F===j||F!==q)&&(M=`\\\\${X}\\${R.slice(q,F)}`,D=F)}}}else D=1;else A(y)&&R.charCodeAt(1)===f&&(M=R.slice(0,2),D=2,j>2&&L(R.charCodeAt(2))&&(S=!0,D=3));if(M.length>0)if(r.length>0){if(M.toLowerCase()!==r.toLowerCase())continue}else r=M;if(c){if(r.length>0)break}else if(o=`${R.slice(D)}\\${o}`,c=S,S&&r.length>0)break}return o=E(o,!c,"\\",L),c?`${r}\\${o}`:`${r}${o}`||"."},normalize(u){e(u,"path");const r=u.length;if(r===0)return".";let o=0,c,T=!1;const R=u.charCodeAt(0);if(r===1)return _(R)?"\\":u;if(L(R))if(T=!0,L(u.charCodeAt(1))){let D=2,M=D;for(;D<r&&!L(u.charCodeAt(D));)D++;if(D<r&&D!==M){const S=u.slice(M,D);for(M=D;D<r&&L(u.charCodeAt(D));)D++;if(D<r&&D!==M){for(M=D;D<r&&!L(u.charCodeAt(D));)D++;if(D===r)return`\\\\${S}\\${u.slice(M)}\\`;D!==M&&(c=`\\\\${S}\\${u.slice(M,D)}`,o=D)}}}else o=1;else A(R)&&u.charCodeAt(1)===f&&(c=u.slice(0,2),o=2,r>2&&L(u.charCodeAt(2))&&(T=!0,o=3));let j=o<r?E(u.slice(o),!T,"\\",L):"";return j.length===0&&!T&&(j="."),j.length>0&&L(u.charCodeAt(r-1))&&(j+="\\"),c===void 0?T?`\\${j}`:j:T?`${c}\\${j}`:`${c}${j}`},isAbsolute(u){e(u,"path");const r=u.length;if(r===0)return!1;const o=u.charCodeAt(0);return L(o)||r>2&&A(o)&&u.charCodeAt(1)===f&&L(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let r,o;for(let R=0;R<u.length;++R){const j=u[R];e(j,"path"),j.length>0&&(r===void 0?r=o=j:r+=`\\${j}`)}if(r===void 0)return".";let c=!0,T=0;if(typeof o=="string"&&L(o.charCodeAt(0))){++T;const R=o.length;R>1&&L(o.charCodeAt(1))&&(++T,R>2&&(L(o.charCodeAt(2))?++T:c=!1))}if(c){for(;T<r.length&&L(r.charCodeAt(T));)T++;T>=2&&(r=`\\${r.slice(T)}`)}return i.$ic.normalize(r)},relative(u,r){if(e(u,"from"),e(r,"to"),u===r)return"";const o=i.$ic.resolve(u),c=i.$ic.resolve(r);if(o===c||(u=o.toLowerCase(),r=c.toLowerCase(),u===r))return"";let T=0;for(;T<u.length&&u.charCodeAt(T)===l;)T++;let R=u.length;for(;R-1>T&&u.charCodeAt(R-1)===l;)R--;const j=R-T;let D=0;for(;D<r.length&&r.charCodeAt(D)===l;)D++;let M=r.length;for(;M-1>D&&r.charCodeAt(M-1)===l;)M--;const S=M-D,y=j<S?j:S;let F=-1,q=0;for(;q<y;q++){const B=u.charCodeAt(T+q);if(B!==r.charCodeAt(D+q))break;B===l&&(F=q)}if(q!==y){if(F===-1)return c}else{if(S>y){if(r.charCodeAt(D+q)===l)return c.slice(D+q+1);if(q===2)return c.slice(D+q)}j>y&&(u.charCodeAt(T+q)===l?F=q:q===2&&(F=3)),F===-1&&(F=0)}let X="";for(q=T+F+1;q<=R;++q)(q===R||u.charCodeAt(q)===l)&&(X+=X.length===0?"..":"\\..");return D+=F,X.length>0?`${X}${c.slice(D,M)}`:(c.charCodeAt(D)===l&&++D,c.slice(D,M))},toNamespacedPath(u){if(typeof u!="string"||u.length===0)return u;const r=i.$ic.resolve(u);if(r.length<=2)return u;if(r.charCodeAt(0)===l){if(r.charCodeAt(1)===l){const o=r.charCodeAt(2);if(o!==$&&o!==d)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(A(r.charCodeAt(0))&&r.charCodeAt(1)===f&&r.charCodeAt(2)===l)return`\\\\?\\${r}`;return u},dirname(u){e(u,"path");const r=u.length;if(r===0)return".";let o=-1,c=0;const T=u.charCodeAt(0);if(r===1)return L(T)?u:".";if(L(T)){if(o=c=1,L(u.charCodeAt(1))){let D=2,M=D;for(;D<r&&!L(u.charCodeAt(D));)D++;if(D<r&&D!==M){for(M=D;D<r&&L(u.charCodeAt(D));)D++;if(D<r&&D!==M){for(M=D;D<r&&!L(u.charCodeAt(D));)D++;if(D===r)return u;D!==M&&(o=c=D+1)}}}}else A(T)&&u.charCodeAt(1)===f&&(o=r>2&&L(u.charCodeAt(2))?3:2,c=o);let R=-1,j=!0;for(let D=r-1;D>=c;--D)if(L(u.charCodeAt(D))){if(!j){R=D;break}}else j=!1;if(R===-1){if(o===-1)return".";R=o}return u.slice(0,R)},basename(u,r){r!==void 0&&e(r,"ext"),e(u,"path");let o=0,c=-1,T=!0,R;if(u.length>=2&&A(u.charCodeAt(0))&&u.charCodeAt(1)===f&&(o=2),r!==void 0&&r.length>0&&r.length<=u.length){if(r===u)return"";let j=r.length-1,D=-1;for(R=u.length-1;R>=o;--R){const M=u.charCodeAt(R);if(L(M)){if(!T){o=R+1;break}}else D===-1&&(T=!1,D=R+1),j>=0&&(M===r.charCodeAt(j)?--j===-1&&(c=R):(j=-1,c=D))}return o===c?c=D:c===-1&&(c=u.length),u.slice(o,c)}for(R=u.length-1;R>=o;--R)if(L(u.charCodeAt(R))){if(!T){o=R+1;break}}else c===-1&&(T=!1,c=R+1);return c===-1?"":u.slice(o,c)},extname(u){e(u,"path");let r=0,o=-1,c=0,T=-1,R=!0,j=0;u.length>=2&&u.charCodeAt(1)===f&&A(u.charCodeAt(0))&&(r=c=2);for(let D=u.length-1;D>=r;--D){const M=u.charCodeAt(D);if(L(M)){if(!R){c=D+1;break}continue}T===-1&&(R=!1,T=D+1),M===d?o===-1?o=D:j!==1&&(j=1):o!==-1&&(j=-1)}return o===-1||T===-1||j===0||j===1&&o===T-1&&o===c+1?"":u.slice(o,T)},format:v.bind(null,"\\"),parse(u){e(u,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return r;const o=u.length;let c=0,T=u.charCodeAt(0);if(o===1)return L(T)?(r.root=r.dir=u,r):(r.base=r.name=u,r);if(L(T)){if(c=1,L(u.charCodeAt(1))){let F=2,q=F;for(;F<o&&!L(u.charCodeAt(F));)F++;if(F<o&&F!==q){for(q=F;F<o&&L(u.charCodeAt(F));)F++;if(F<o&&F!==q){for(q=F;F<o&&!L(u.charCodeAt(F));)F++;F===o?c=F:F!==q&&(c=F+1)}}}}else if(A(T)&&u.charCodeAt(1)===f){if(o<=2)return r.root=r.dir=u,r;if(c=2,L(u.charCodeAt(2))){if(o===3)return r.root=r.dir=u,r;c=3}}c>0&&(r.root=u.slice(0,c));let R=-1,j=c,D=-1,M=!0,S=u.length-1,y=0;for(;S>=c;--S){if(T=u.charCodeAt(S),L(T)){if(!M){j=S+1;break}continue}D===-1&&(M=!1,D=S+1),T===d?R===-1?R=S:y!==1&&(y=1):R!==-1&&(y=-1)}return D!==-1&&(R===-1||y===0||y===1&&R===D-1&&R===j+1?r.base=r.name=u.slice(j,D):(r.name=u.slice(j,R),r.base=u.slice(j,D),r.ext=u.slice(R,D))),j>0&&j!==c?r.dir=u.slice(0,j-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(b){const u=/\\/g;return()=>{const r=t.cwd().replace(u,"/");return r.slice(r.indexOf("/"))}}return()=>t.cwd()})();i.$jc={resolve(...u){let r="",o=!1;for(let c=u.length-1;c>=-1&&!o;c--){const T=c>=0?u[c]:h();e(T,"path"),T.length!==0&&(r=`${T}/${r}`,o=T.charCodeAt(0)===a)}return r=E(r,!o,"/",_),o?`/${r}`:r.length>0?r:"."},normalize(u){if(e(u,"path"),u.length===0)return".";const r=u.charCodeAt(0)===a,o=u.charCodeAt(u.length-1)===a;return u=E(u,!r,"/",_),u.length===0?r?"/":o?"./":".":(o&&(u+="/"),r?`/${u}`:u)},isAbsolute(u){return e(u,"path"),u.length>0&&u.charCodeAt(0)===a},join(...u){if(u.length===0)return".";let r;for(let o=0;o<u.length;++o){const c=u[o];e(c,"path"),c.length>0&&(r===void 0?r=c:r+=`/${c}`)}return r===void 0?".":i.$jc.normalize(r)},relative(u,r){if(e(u,"from"),e(r,"to"),u===r||(u=i.$jc.resolve(u),r=i.$jc.resolve(r),u===r))return"";const o=1,c=u.length,T=c-o,R=1,j=r.length-R,D=T<j?T:j;let M=-1,S=0;for(;S<D;S++){const F=u.charCodeAt(o+S);if(F!==r.charCodeAt(R+S))break;F===a&&(M=S)}if(S===D)if(j>D){if(r.charCodeAt(R+S)===a)return r.slice(R+S+1);if(S===0)return r.slice(R+S)}else T>D&&(u.charCodeAt(o+S)===a?M=S:S===0&&(M=0));let y="";for(S=o+M+1;S<=c;++S)(S===c||u.charCodeAt(S)===a)&&(y+=y.length===0?"..":"/..");return`${y}${r.slice(R+M)}`},toNamespacedPath(u){return u},dirname(u){if(e(u,"path"),u.length===0)return".";const r=u.charCodeAt(0)===a;let o=-1,c=!0;for(let T=u.length-1;T>=1;--T)if(u.charCodeAt(T)===a){if(!c){o=T;break}}else c=!1;return o===-1?r?"/":".":r&&o===1?"//":u.slice(0,o)},basename(u,r){r!==void 0&&e(r,"ext"),e(u,"path");let o=0,c=-1,T=!0,R;if(r!==void 0&&r.length>0&&r.length<=u.length){if(r===u)return"";let j=r.length-1,D=-1;for(R=u.length-1;R>=0;--R){const M=u.charCodeAt(R);if(M===a){if(!T){o=R+1;break}}else D===-1&&(T=!1,D=R+1),j>=0&&(M===r.charCodeAt(j)?--j===-1&&(c=R):(j=-1,c=D))}return o===c?c=D:c===-1&&(c=u.length),u.slice(o,c)}for(R=u.length-1;R>=0;--R)if(u.charCodeAt(R)===a){if(!T){o=R+1;break}}else c===-1&&(T=!1,c=R+1);return c===-1?"":u.slice(o,c)},extname(u){e(u,"path");let r=-1,o=0,c=-1,T=!0,R=0;for(let j=u.length-1;j>=0;--j){const D=u.charCodeAt(j);if(D===a){if(!T){o=j+1;break}continue}c===-1&&(T=!1,c=j+1),D===d?r===-1?r=j:R!==1&&(R=1):r!==-1&&(R=-1)}return r===-1||c===-1||R===0||R===1&&r===c-1&&r===o+1?"":u.slice(r,c)},format:v.bind(null,"/"),parse(u){e(u,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return r;const o=u.charCodeAt(0)===a;let c;o?(r.root="/",c=1):c=0;let T=-1,R=0,j=-1,D=!0,M=u.length-1,S=0;for(;M>=c;--M){const y=u.charCodeAt(M);if(y===a){if(!D){R=M+1;break}continue}j===-1&&(D=!1,j=M+1),y===d?T===-1?T=M:S!==1&&(S=1):T!==-1&&(S=-1)}if(j!==-1){const y=R===0&&o?1:R;T===-1||S===0||S===1&&T===j-1&&T===R+1?r.base=r.name=u.slice(y,j):(r.name=u.slice(y,T),r.base=u.slice(y,j),r.ext=u.slice(T,j))}return R>0?r.dir=u.slice(0,R-1):o&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},i.$jc.win32=i.$ic.win32=i.$ic,i.$jc.posix=i.$ic.posix=i.$jc,i.$kc=b?i.$ic.normalize:i.$jc.normalize,i.$lc=b?i.$ic.isAbsolute:i.$jc.isAbsolute,i.$mc=b?i.$ic.join:i.$jc.join,i.$nc=b?i.$ic.resolve:i.$jc.resolve,i.$oc=b?i.$ic.relative:i.$jc.relative,i.$pc=b?i.$ic.dirname:i.$jc.dirname,i.$qc=b?i.$ic.basename:i.$jc.basename,i.$rc=b?i.$ic.extname:i.$jc.extname,i.$sc=b?i.$ic.format:i.$jc.format,i.$tc=b?i.$ic.parse:i.$jc.parse,i.$uc=b?i.$ic.toNamespacedPath:i.$jc.toNamespacedPath,i.sep=b?i.$ic.sep:i.$jc.sep,i.$wc=b?i.$ic.delimiter:i.$jc.delimiter}),ne(ie[25],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$he=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(g){return new n(g)}constructor(g){this.c=t&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}i.$he=n}),ne(ie[13],re([0,1,4,22,12,24,25]),function(x,i,t,n,p,g,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$xe=i.$we=i.$ve=i.$ue=i.$te=i.$se=i.$re=i.$qe=i.$pe=i.$oe=i.$ne=i.$me=i.$le=i.$je=i.Event=void 0,i.$ke=N;const d=!1,a=!1,l=!1;var f;(function(B){B.None=()=>p.$Xc.None;function P(se){if(l){const{onDidAddListener:te}=se,ae=b.create();let ue=0;se.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),te?.()}}}function Y(se,te){return s(se,()=>{},0,void 0,!0,void 0,te)}B.defer=Y;function Q(se){return(te,ae=null,ue)=>{let fe=!1,ge;return ge=se($e=>{if(!fe)return ge?ge.dispose():fe=!0,te.call(ae,$e)},null,ue),fe&&ge.dispose(),ge}}B.once=Q;function H(se,te,ae){return ce((ue,fe=null,ge)=>se($e=>ue.call(fe,te($e)),null,ge),ae)}B.map=H;function K(se,te,ae){return ce((ue,fe=null,ge)=>se($e=>{te($e),ue.call(fe,$e)},null,ge),ae)}B.forEach=K;function C(se,te,ae){return ce((ue,fe=null,ge)=>se($e=>te($e)&&ue.call(fe,$e),null,ge),ae)}B.filter=C;function k(se){return se}B.signal=k;function G(...se){return(te,ae=null,ue)=>{const fe=(0,p.$Uc)(...se.map(ge=>ge($e=>te.call(ae,$e))));return we(fe,ue)}}B.any=G;function oe(se,te,ae,ue){let fe=ae;return H(se,ge=>(fe=te(fe,ge),fe),ue)}B.reduce=oe;function ce(se,te){let ae;const ue={onWillAddFirstListener(){ae=se(fe.fire,fe)},onDidRemoveLastListener(){ae?.dispose()}};te||P(ue);const fe=new r(ue);return te?.add(fe),fe.event}function we(se,te){return te instanceof Array?te.push(se):te&&te.add(se),se}function s(se,te,ae=100,ue=!1,fe=!1,ge,$e){let Ee,_e,Pe,qe=0,Oe;const me={leakWarningThreshold:ge,onWillAddFirstListener(){Ee=se(Ge=>{qe++,_e=te(_e,Ge),ue&&!Pe&&(je.fire(_e),_e=void 0),Oe=()=>{const ze=_e;_e=void 0,Pe=void 0,(!ue||qe>1)&&je.fire(ze),qe=0},typeof ae=="number"?(clearTimeout(Pe),Pe=setTimeout(Oe,ae)):Pe===void 0&&(Pe=0,queueMicrotask(Oe))})},onWillRemoveListener(){fe&&qe>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,Ee.dispose()}};$e||P(me);const je=new r(me);return $e?.add(je),je.event}B.debounce=s;function Te(se,te=0,ae){return B.debounce(se,(ue,fe)=>ue?(ue.push(fe),ue):[fe],te,void 0,!0,void 0,ae)}B.accumulate=Te;function De(se,te=(ue,fe)=>ue===fe,ae){let ue=!0,fe;return C(se,ge=>{const $e=ue||!te(ge,fe);return ue=!1,fe=ge,$e},ae)}B.latch=De;function Ue(se,te,ae){return[B.filter(se,te,ae),B.filter(se,ue=>!te(ue),ae)]}B.split=Ue;function Fe(se,te=!1,ae=[],ue){let fe=ae.slice(),ge=se(_e=>{fe?fe.push(_e):Ee.fire(_e)});ue&&ue.add(ge);const $e=()=>{fe?.forEach(_e=>Ee.fire(_e)),fe=null},Ee=new r({onWillAddFirstListener(){ge||(ge=se(_e=>Ee.fire(_e)),ue&&ue.add(ge))},onDidAddFirstListener(){fe&&(te?setTimeout($e):$e())},onDidRemoveLastListener(){ge&&ge.dispose(),ge=null}});return ue&&ue.add(Ee),Ee.event}B.buffer=Fe;function ke(se,te){return(ue,fe,ge)=>{const $e=te(new V);return se(function(Ee){const _e=$e.evaluate(Ee);_e!==U&&ue.call(fe,_e)},void 0,ge)}}B.chain=ke;const U=Symbol("HaltChainable");class V{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(ae=>(te(ae),ae)),this}filter(te){return this.f.push(ae=>te(ae)?ae:U),this}reduce(te,ae){let ue=ae;return this.f.push(fe=>(ue=te(ue,fe),ue)),this}latch(te=(ae,ue)=>ae===ue){let ae=!0,ue;return this.f.push(fe=>{const ge=ae||!te(fe,ue);return ae=!1,ue=fe,ge?fe:U}),this}evaluate(te){for(const ae of this.f)if(te=ae(te),te===U)break;return te}}function W(se,te,ae=ue=>ue){const ue=(...Ee)=>$e.fire(ae(...Ee)),fe=()=>se.on(te,ue),ge=()=>se.removeListener(te,ue),$e=new r({onWillAddFirstListener:fe,onDidRemoveLastListener:ge});return $e.event}B.fromNodeEventEmitter=W;function Z(se,te,ae=ue=>ue){const ue=(...Ee)=>$e.fire(ae(...Ee)),fe=()=>se.addEventListener(te,ue),ge=()=>se.removeEventListener(te,ue),$e=new r({onWillAddFirstListener:fe,onDidRemoveLastListener:ge});return $e.event}B.fromDOMEventEmitter=Z;function ee(se){return new Promise(te=>Q(se)(te))}B.toPromise=ee;function he(se){const te=new r;return se.then(ae=>{te.fire(ae)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}B.fromPromise=he;function de(se,te,ae){return te(ae),se(ue=>te(ue))}B.runAndSubscribe=de;class ve{constructor(te,ae){this._observable=te,this.f=0,this.g=!1;const ue={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ae||P(ue),this.emitter=new r(ue),ae&&ae.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,ae){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ae(se,te){return new ve(se,te).emitter.event}B.fromObservable=Ae;function pe(se){return(te,ae,ue)=>{let fe=0,ge=!1;const $e={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(se.reportChanges(),ge&&(ge=!1,te.call(ae)))},handlePossibleChange(){},handleChange(){ge=!0}};se.addObserver($e),se.reportChanges();const Ee={dispose(){se.removeObserver($e)}};return ue instanceof p.$Wc?ue.add(Ee):Array.isArray(ue)&&ue.push(Ee),Ee}}B.fromObservableLight=pe})(f||(i.Event=f={}));class ${constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${$.f++}`,$.all.add(this)}start(P){this.g=new w.$he,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}i.$je=$,$.all=new Set,$.f=0;let m=-1;function N(B){const P=m;return m=B,{dispose(){m=P}}}class e{constructor(P,Y,Q=(e.f++).toString(16).padStart(3,"0")){this.j=P,this.threshold=Y,this.name=Q,this.h=0}dispose(){this.g?.clear()}check(P,Y){const Q=this.threshold;if(Q<=0||Y<Q)return;this.g||(this.g=new Map);const H=this.g.get(P.value)||0;if(this.g.set(P.value,H+1),this.h-=1,this.h<=0){this.h=Q*.5;const[K,C]=this.getMostFrequentStack(),k=`[${this.name}] potential listener LEAK detected, having ${Y} listeners already. MOST frequent listener (${C}):`;console.warn(k),console.warn(K);const G=new L(k,K);this.j(G)}return()=>{const K=this.g.get(P.value)||0;this.g.set(P.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let P,Y=0;for(const[Q,H]of this.g)(!P||Y<H)&&(P=[Q,H],Y=H);return P}}e.f=1;class b{static create(){const P=new Error;return new b(P.stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class L extends Error{constructor(P,Y){super(P),this.name="ListenerLeakError",this.stack=Y}}i.$le=L;class _ extends Error{constructor(P,Y){super(P),this.name="ListenerRefusalError",this.stack=Y}}i.$me=_;let A=0;class E{constructor(P){this.value=P,this.id=A++}}const v=2,h=(B,P)=>{if(B instanceof E)P(B);else for(let Y=0;Y<B.length;Y++){const Q=B[Y];Q&&P(Q)}};let u;if(d){const B=[];setInterval(()=>{B.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(B.join(`
`)),B.length=0)},3e3),u=new FinalizationRegistry(P=>{typeof P=="string"&&B.push(P)})}class r{constructor(P){this.z=0,this.f=P,this.g=m>0||this.f?.leakWarningThreshold?new e(P?.onListenerError??t.$3,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(a){const P=this.u;queueMicrotask(()=>{h(P,Y=>Y.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(P,Y,Q)=>{if(this.g&&this.z>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(G);const oe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ce=new _(`${G}. HINT: Stack shows most frequent listener (${oe[1]}-times)`,oe[0]);return(this.f?.onListenerError||t.$3)(ce),p.$Xc.None}if(this.m)return p.$Xc.None;Y&&(P=P.bind(Y));const H=new E(P);let K,C;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(H.stack=b.create(),K=this.g.check(H.stack,this.z+1)),a&&(H.stack=C??b.create()),this.u?this.u instanceof E?(this.w??(this.w=new c),this.u=[this.u,H]):this.u.push(H):(this.f?.onWillAddFirstListener?.(this),this.u=H,this.f?.onDidAddFirstListener?.(this)),this.z++;const k=(0,p.$Vc)(()=>{u?.unregister(k),K?.(),this.A(H)});if(Q instanceof p.$Wc?Q.add(k):Array.isArray(Q)&&Q.push(k),u){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),oe=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);u.register(k,oe?.[2]??G,k)}return k}),this.q}A(P){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Y=this.u,Q=Y.indexOf(P);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Y[Q]=void 0;const H=this.w.current===this;if(this.z*v<=Y.length){let K=0;for(let C=0;C<Y.length;C++)Y[C]?Y[K++]=Y[C]:H&&(this.w.end--,K<this.w.i&&this.w.i--);Y.length=K}}B(P,Y){if(!P)return;const Q=this.f?.onListenerError||t.$3;if(!Q){P.value(Y);return}try{P.value(Y)}catch(H){Q(H)}}C(P){const Y=P.current.u;for(;P.i<P.end;)this.B(Y[P.i++],P.value);P.reset()}fire(P){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof E)this.B(this.u,P);else{const Y=this.w;Y.enqueue(this,P,this.u.length),this.C(Y)}this.j?.stop()}hasListeners(){return this.z>0}}i.$ne=r;const o=()=>new c;i.$oe=o;class c{constructor(){this.i=-1,this.end=0}enqueue(P,Y,Q){this.i=0,this.end=Q,this.current=P,this.value=Y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class T extends r{async fireAsync(P,Y,Q){if(this.u)for(this.h||(this.h=new g.$8c),h(this.u,H=>this.h.push([H.value,P]));this.h.size>0&&!Y.isCancellationRequested;){const[H,K]=this.h.shift(),C=[],k={...K,token:Y,waitUntil:G=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");Q&&(G=Q(G,H)),C.push(G)}};try{H(k)}catch(G){(0,t.$3)(G);continue}Object.freeze(C),await Promise.allSettled(C).then(G=>{for(const oe of G)oe.status==="rejected"&&(0,t.$3)(oe.reason)})}}}i.$pe=T;class R extends r{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new g.$8c,this.t=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.t(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.z&&(this.h!==0?this.s.push(P):super.fire(P))}}i.$qe=R;class j extends R{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}i.$re=j;class D extends r{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Y=>super.fire(Y)),this.h=[]}))}}i.$se=D;class M{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const Y={event:P,listener:null};this.h.push(Y),this.g&&this.m(Y);const Q=()=>{this.g&&this.o(Y);const H=this.h.indexOf(Y);this.h.splice(H,1)};return(0,p.$Vc)((0,n.$gb)(Q))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(Y=>this.f.fire(Y))}o(P){P.listener?.dispose(),P.listener=null}dispose(){this.f.dispose();for(const P of this.h)P.listener?.dispose();this.h=[]}}i.$te=M;class S{constructor(P,Y,Q,H){this.f=new p.$Wc;const K=this.f.add(new M),C=this.f.add(new p.$7c);function k(G){C.set(G,K.add(H(G)))}for(const G of P)k(G);this.f.add(Y(G=>{k(G)})),this.f.add(Q(G=>{C.deleteAndDispose(G)})),this.event=K.event}dispose(){this.f.dispose()}}i.$ue=S;class y{constructor(){this.f=[]}wrapEvent(P,Y,Q){return(H,K,C)=>P(k=>{const G=this.f[this.f.length-1];if(!Y){G?G.buffers.push(()=>H.call(K,k)):H.call(K,k);return}const oe=G;if(!oe){H.call(K,Y(Q,k));return}oe.items??(oe.items=[]),oe.items.push(k),oe.buffers.length===0&&G.buffers.push(()=>{oe.reducedResult??(oe.reducedResult=Q?oe.items.reduce(Y,Q):oe.items.reduce(Y)),H.call(K,oe.reducedResult)})},void 0,C)}bufferEvents(P){const Y={buffers:new Array};this.f.push(Y);const Q=P();return this.f.pop(),Y.buffers.forEach(H=>H()),Q}}i.$ve=y;class F{constructor(){this.f=!1,this.g=f.None,this.h=p.$Xc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}i.$we=F;class q{static const(P){return new X(P)}constructor(P){this.g=P,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(P){P!==this.g&&(this.g=P,this.f.fire(void 0))}}i.$xe=q;class X{constructor(P){this.value=P,this.onDidChange=f.None}}}),ne(ie[26],re([0,1,13]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ye=i.CancellationToken=void 0,i.$ze=d;const n=Object.freeze(function(a,l){const f=setTimeout(a.bind(l),0);return{dispose(){clearTimeout(f)}}});var p;(function(a){function l(f){return f===a.None||f===a.Cancelled||f instanceof g?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}a.isCancellationToken=l,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(p||(i.CancellationToken=p={}));class g{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new t.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new g),this.f}cancel(){this.f?this.f instanceof g&&this.f.cancel():this.f=p.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof g&&this.f.dispose():this.f=p.None}}i.$ye=w;function d(a){const l=new w;return a.add({dispose(){l.cancel()}}),l.token}}),ne(ie[45],re([0,1,26]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$bf=i.$af=i.$$e=void 0,i.$_e=p;class n{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new t.$ye,l=this.b(a.token);return this.a={promise:l,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}i.$$e=n;function p(d){return d}class g{constructor(a,l){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=p):(this.c=l,this.d=a.getCacheKey)}get(a){const l=this.d(a);return this.b!==l&&(this.b=l,this.a=this.c(a)),this.a}}i.$af=g;class w{get cachedValues(){return this.a}constructor(a,l){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=p):(this.c=l,this.d=a.getCacheKey)}get(a){const l=this.d(a);if(this.b.has(l))return this.b.get(l);const f=this.c(a);return this.a.set(a,f),this.b.set(l,f),f}}i.$bf=w}),ne(ie[27],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gg=t,i.$hg=n,i.$ig=p,i.$jg=g,i.$kg=w,i.$lg=d,i.$mg=a,i.$ng=l,i.$og=f,i.$pg=$,i.$qg=m,i.$rg=N,i.$sg=e,i.$tg=L,i.$ug=_,i.$vg=A,i.$wg=E,i.$xg=v;function t(h){return typeof h=="string"}function n(h){return Array.isArray(h)&&h.every(u=>t(u))}function p(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function g(h){const u=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof u}function w(h){return typeof h=="number"&&!isNaN(h)}function d(h){return!!h&&typeof h[Symbol.iterator]=="function"}function a(h){return h===!0||h===!1}function l(h){return typeof h>"u"}function f(h){return!$(h)}function $(h){return l(h)||h===null}function m(h,u){if(!h)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function N(h){if($(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function e(...h){const u=[];for(let r=0;r<h.length;r++){const o=h[r];if($(o))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);u.push(o)}return u}const b=Object.prototype.hasOwnProperty;function L(h){if(!p(h))return!1;for(const u in h)if(b.call(h,u))return!1;return!0}function _(h){return typeof h=="function"}function A(...h){return h.length>0&&h.every(_)}function E(h,u){const r=Math.min(h.length,u.length);for(let o=0;o<r;o++)v(h[o],u[o])}function v(h,u){if(t(u)){if(typeof h!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(_(u)){try{if(h instanceof u)return}catch{}if(!$(h)&&h.constructor===u||u.length===1&&u.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(ie[28],re([0,1,27]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$1j=p,i.$2j=g;const n=Object.create(null);function p(w,d){if((0,t.$gg)(d)){const a=n[d];if(a===void 0)throw new Error(`${w} references an unknown codicon: ${d}`);d=a}return n[w]=d,{id:w}}function g(){return n}}),ne(ie[46],re([0,1,28]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$3j=void 0,i.$3j={add:(0,t.$1j)("add",6e4),plus:(0,t.$1j)("plus",6e4),gistNew:(0,t.$1j)("gist-new",6e4),repoCreate:(0,t.$1j)("repo-create",6e4),lightbulb:(0,t.$1j)("lightbulb",60001),lightBulb:(0,t.$1j)("light-bulb",60001),repo:(0,t.$1j)("repo",60002),repoDelete:(0,t.$1j)("repo-delete",60002),gistFork:(0,t.$1j)("gist-fork",60003),repoForked:(0,t.$1j)("repo-forked",60003),gitPullRequest:(0,t.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,t.$1j)("record-keys",60005),keyboard:(0,t.$1j)("keyboard",60005),tag:(0,t.$1j)("tag",60006),gitPullRequestLabel:(0,t.$1j)("git-pull-request-label",60006),tagAdd:(0,t.$1j)("tag-add",60006),tagRemove:(0,t.$1j)("tag-remove",60006),person:(0,t.$1j)("person",60007),personFollow:(0,t.$1j)("person-follow",60007),personOutline:(0,t.$1j)("person-outline",60007),personFilled:(0,t.$1j)("person-filled",60007),gitBranch:(0,t.$1j)("git-branch",60008),gitBranchCreate:(0,t.$1j)("git-branch-create",60008),gitBranchDelete:(0,t.$1j)("git-branch-delete",60008),sourceControl:(0,t.$1j)("source-control",60008),mirror:(0,t.$1j)("mirror",60009),mirrorPublic:(0,t.$1j)("mirror-public",60009),star:(0,t.$1j)("star",60010),starAdd:(0,t.$1j)("star-add",60010),starDelete:(0,t.$1j)("star-delete",60010),starEmpty:(0,t.$1j)("star-empty",60010),comment:(0,t.$1j)("comment",60011),commentAdd:(0,t.$1j)("comment-add",60011),alert:(0,t.$1j)("alert",60012),warning:(0,t.$1j)("warning",60012),search:(0,t.$1j)("search",60013),searchSave:(0,t.$1j)("search-save",60013),logOut:(0,t.$1j)("log-out",60014),signOut:(0,t.$1j)("sign-out",60014),logIn:(0,t.$1j)("log-in",60015),signIn:(0,t.$1j)("sign-in",60015),eye:(0,t.$1j)("eye",60016),eyeUnwatch:(0,t.$1j)("eye-unwatch",60016),eyeWatch:(0,t.$1j)("eye-watch",60016),circleFilled:(0,t.$1j)("circle-filled",60017),primitiveDot:(0,t.$1j)("primitive-dot",60017),closeDirty:(0,t.$1j)("close-dirty",60017),debugBreakpoint:(0,t.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,t.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,t.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,t.$1j)("primitive-square",60018),edit:(0,t.$1j)("edit",60019),pencil:(0,t.$1j)("pencil",60019),info:(0,t.$1j)("info",60020),issueOpened:(0,t.$1j)("issue-opened",60020),gistPrivate:(0,t.$1j)("gist-private",60021),gitForkPrivate:(0,t.$1j)("git-fork-private",60021),lock:(0,t.$1j)("lock",60021),mirrorPrivate:(0,t.$1j)("mirror-private",60021),close:(0,t.$1j)("close",60022),removeClose:(0,t.$1j)("remove-close",60022),x:(0,t.$1j)("x",60022),repoSync:(0,t.$1j)("repo-sync",60023),sync:(0,t.$1j)("sync",60023),clone:(0,t.$1j)("clone",60024),desktopDownload:(0,t.$1j)("desktop-download",60024),beaker:(0,t.$1j)("beaker",60025),microscope:(0,t.$1j)("microscope",60025),vm:(0,t.$1j)("vm",60026),deviceDesktop:(0,t.$1j)("device-desktop",60026),file:(0,t.$1j)("file",60027),fileText:(0,t.$1j)("file-text",60027),more:(0,t.$1j)("more",60028),ellipsis:(0,t.$1j)("ellipsis",60028),kebabHorizontal:(0,t.$1j)("kebab-horizontal",60028),mailReply:(0,t.$1j)("mail-reply",60029),reply:(0,t.$1j)("reply",60029),organization:(0,t.$1j)("organization",60030),organizationFilled:(0,t.$1j)("organization-filled",60030),organizationOutline:(0,t.$1j)("organization-outline",60030),newFile:(0,t.$1j)("new-file",60031),fileAdd:(0,t.$1j)("file-add",60031),newFolder:(0,t.$1j)("new-folder",60032),fileDirectoryCreate:(0,t.$1j)("file-directory-create",60032),trash:(0,t.$1j)("trash",60033),trashcan:(0,t.$1j)("trashcan",60033),history:(0,t.$1j)("history",60034),clock:(0,t.$1j)("clock",60034),folder:(0,t.$1j)("folder",60035),fileDirectory:(0,t.$1j)("file-directory",60035),symbolFolder:(0,t.$1j)("symbol-folder",60035),logoGithub:(0,t.$1j)("logo-github",60036),markGithub:(0,t.$1j)("mark-github",60036),github:(0,t.$1j)("github",60036),terminal:(0,t.$1j)("terminal",60037),console:(0,t.$1j)("console",60037),repl:(0,t.$1j)("repl",60037),zap:(0,t.$1j)("zap",60038),symbolEvent:(0,t.$1j)("symbol-event",60038),error:(0,t.$1j)("error",60039),stop:(0,t.$1j)("stop",60039),variable:(0,t.$1j)("variable",60040),symbolVariable:(0,t.$1j)("symbol-variable",60040),array:(0,t.$1j)("array",60042),symbolArray:(0,t.$1j)("symbol-array",60042),symbolModule:(0,t.$1j)("symbol-module",60043),symbolPackage:(0,t.$1j)("symbol-package",60043),symbolNamespace:(0,t.$1j)("symbol-namespace",60043),symbolObject:(0,t.$1j)("symbol-object",60043),symbolMethod:(0,t.$1j)("symbol-method",60044),symbolFunction:(0,t.$1j)("symbol-function",60044),symbolConstructor:(0,t.$1j)("symbol-constructor",60044),symbolBoolean:(0,t.$1j)("symbol-boolean",60047),symbolNull:(0,t.$1j)("symbol-null",60047),symbolNumeric:(0,t.$1j)("symbol-numeric",60048),symbolNumber:(0,t.$1j)("symbol-number",60048),symbolStructure:(0,t.$1j)("symbol-structure",60049),symbolStruct:(0,t.$1j)("symbol-struct",60049),symbolParameter:(0,t.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,t.$1j)("symbol-type-parameter",60050),symbolKey:(0,t.$1j)("symbol-key",60051),symbolText:(0,t.$1j)("symbol-text",60051),symbolReference:(0,t.$1j)("symbol-reference",60052),goToFile:(0,t.$1j)("go-to-file",60052),symbolEnum:(0,t.$1j)("symbol-enum",60053),symbolValue:(0,t.$1j)("symbol-value",60053),symbolRuler:(0,t.$1j)("symbol-ruler",60054),symbolUnit:(0,t.$1j)("symbol-unit",60054),activateBreakpoints:(0,t.$1j)("activate-breakpoints",60055),archive:(0,t.$1j)("archive",60056),arrowBoth:(0,t.$1j)("arrow-both",60057),arrowDown:(0,t.$1j)("arrow-down",60058),arrowLeft:(0,t.$1j)("arrow-left",60059),arrowRight:(0,t.$1j)("arrow-right",60060),arrowSmallDown:(0,t.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,t.$1j)("arrow-small-left",60062),arrowSmallRight:(0,t.$1j)("arrow-small-right",60063),arrowSmallUp:(0,t.$1j)("arrow-small-up",60064),arrowUp:(0,t.$1j)("arrow-up",60065),bell:(0,t.$1j)("bell",60066),bold:(0,t.$1j)("bold",60067),book:(0,t.$1j)("book",60068),bookmark:(0,t.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$1j)("briefcase",60076),broadcast:(0,t.$1j)("broadcast",60077),browser:(0,t.$1j)("browser",60078),bug:(0,t.$1j)("bug",60079),calendar:(0,t.$1j)("calendar",60080),caseSensitive:(0,t.$1j)("case-sensitive",60081),check:(0,t.$1j)("check",60082),checklist:(0,t.$1j)("checklist",60083),chevronDown:(0,t.$1j)("chevron-down",60084),chevronLeft:(0,t.$1j)("chevron-left",60085),chevronRight:(0,t.$1j)("chevron-right",60086),chevronUp:(0,t.$1j)("chevron-up",60087),chromeClose:(0,t.$1j)("chrome-close",60088),chromeMaximize:(0,t.$1j)("chrome-maximize",60089),chromeMinimize:(0,t.$1j)("chrome-minimize",60090),chromeRestore:(0,t.$1j)("chrome-restore",60091),circleOutline:(0,t.$1j)("circle-outline",60092),circle:(0,t.$1j)("circle",60092),debugBreakpointUnverified:(0,t.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$1j)("circle-slash",60093),circuitBoard:(0,t.$1j)("circuit-board",60094),clearAll:(0,t.$1j)("clear-all",60095),clippy:(0,t.$1j)("clippy",60096),closeAll:(0,t.$1j)("close-all",60097),cloudDownload:(0,t.$1j)("cloud-download",60098),cloudUpload:(0,t.$1j)("cloud-upload",60099),code:(0,t.$1j)("code",60100),collapseAll:(0,t.$1j)("collapse-all",60101),colorMode:(0,t.$1j)("color-mode",60102),commentDiscussion:(0,t.$1j)("comment-discussion",60103),creditCard:(0,t.$1j)("credit-card",60105),dash:(0,t.$1j)("dash",60108),dashboard:(0,t.$1j)("dashboard",60109),database:(0,t.$1j)("database",60110),debugContinue:(0,t.$1j)("debug-continue",60111),debugDisconnect:(0,t.$1j)("debug-disconnect",60112),debugPause:(0,t.$1j)("debug-pause",60113),debugRestart:(0,t.$1j)("debug-restart",60114),debugStart:(0,t.$1j)("debug-start",60115),debugStepInto:(0,t.$1j)("debug-step-into",60116),debugStepOut:(0,t.$1j)("debug-step-out",60117),debugStepOver:(0,t.$1j)("debug-step-over",60118),debugStop:(0,t.$1j)("debug-stop",60119),debug:(0,t.$1j)("debug",60120),deviceCameraVideo:(0,t.$1j)("device-camera-video",60121),deviceCamera:(0,t.$1j)("device-camera",60122),deviceMobile:(0,t.$1j)("device-mobile",60123),diffAdded:(0,t.$1j)("diff-added",60124),diffIgnored:(0,t.$1j)("diff-ignored",60125),diffModified:(0,t.$1j)("diff-modified",60126),diffRemoved:(0,t.$1j)("diff-removed",60127),diffRenamed:(0,t.$1j)("diff-renamed",60128),diff:(0,t.$1j)("diff",60129),diffSidebyside:(0,t.$1j)("diff-sidebyside",60129),discard:(0,t.$1j)("discard",60130),editorLayout:(0,t.$1j)("editor-layout",60131),emptyWindow:(0,t.$1j)("empty-window",60132),exclude:(0,t.$1j)("exclude",60133),extensions:(0,t.$1j)("extensions",60134),eyeClosed:(0,t.$1j)("eye-closed",60135),fileBinary:(0,t.$1j)("file-binary",60136),fileCode:(0,t.$1j)("file-code",60137),fileMedia:(0,t.$1j)("file-media",60138),filePdf:(0,t.$1j)("file-pdf",60139),fileSubmodule:(0,t.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,t.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$1j)("file-symlink-file",60142),fileZip:(0,t.$1j)("file-zip",60143),files:(0,t.$1j)("files",60144),filter:(0,t.$1j)("filter",60145),flame:(0,t.$1j)("flame",60146),foldDown:(0,t.$1j)("fold-down",60147),foldUp:(0,t.$1j)("fold-up",60148),fold:(0,t.$1j)("fold",60149),folderActive:(0,t.$1j)("folder-active",60150),folderOpened:(0,t.$1j)("folder-opened",60151),gear:(0,t.$1j)("gear",60152),gift:(0,t.$1j)("gift",60153),gistSecret:(0,t.$1j)("gist-secret",60154),gist:(0,t.$1j)("gist",60155),gitCommit:(0,t.$1j)("git-commit",60156),gitCompare:(0,t.$1j)("git-compare",60157),compareChanges:(0,t.$1j)("compare-changes",60157),gitMerge:(0,t.$1j)("git-merge",60158),githubAction:(0,t.$1j)("github-action",60159),githubAlt:(0,t.$1j)("github-alt",60160),globe:(0,t.$1j)("globe",60161),grabber:(0,t.$1j)("grabber",60162),graph:(0,t.$1j)("graph",60163),gripper:(0,t.$1j)("gripper",60164),heart:(0,t.$1j)("heart",60165),home:(0,t.$1j)("home",60166),horizontalRule:(0,t.$1j)("horizontal-rule",60167),hubot:(0,t.$1j)("hubot",60168),inbox:(0,t.$1j)("inbox",60169),issueReopened:(0,t.$1j)("issue-reopened",60171),issues:(0,t.$1j)("issues",60172),italic:(0,t.$1j)("italic",60173),jersey:(0,t.$1j)("jersey",60174),json:(0,t.$1j)("json",60175),kebabVertical:(0,t.$1j)("kebab-vertical",60176),key:(0,t.$1j)("key",60177),law:(0,t.$1j)("law",60178),lightbulbAutofix:(0,t.$1j)("lightbulb-autofix",60179),linkExternal:(0,t.$1j)("link-external",60180),link:(0,t.$1j)("link",60181),listOrdered:(0,t.$1j)("list-ordered",60182),listUnordered:(0,t.$1j)("list-unordered",60183),liveShare:(0,t.$1j)("live-share",60184),loading:(0,t.$1j)("loading",60185),location:(0,t.$1j)("location",60186),mailRead:(0,t.$1j)("mail-read",60187),mail:(0,t.$1j)("mail",60188),markdown:(0,t.$1j)("markdown",60189),megaphone:(0,t.$1j)("megaphone",60190),mention:(0,t.$1j)("mention",60191),milestone:(0,t.$1j)("milestone",60192),gitPullRequestMilestone:(0,t.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,t.$1j)("mortar-board",60193),move:(0,t.$1j)("move",60194),multipleWindows:(0,t.$1j)("multiple-windows",60195),mute:(0,t.$1j)("mute",60196),noNewline:(0,t.$1j)("no-newline",60197),note:(0,t.$1j)("note",60198),octoface:(0,t.$1j)("octoface",60199),openPreview:(0,t.$1j)("open-preview",60200),package:(0,t.$1j)("package",60201),paintcan:(0,t.$1j)("paintcan",60202),pin:(0,t.$1j)("pin",60203),play:(0,t.$1j)("play",60204),run:(0,t.$1j)("run",60204),plug:(0,t.$1j)("plug",60205),preserveCase:(0,t.$1j)("preserve-case",60206),preview:(0,t.$1j)("preview",60207),project:(0,t.$1j)("project",60208),pulse:(0,t.$1j)("pulse",60209),question:(0,t.$1j)("question",60210),quote:(0,t.$1j)("quote",60211),radioTower:(0,t.$1j)("radio-tower",60212),reactions:(0,t.$1j)("reactions",60213),references:(0,t.$1j)("references",60214),refresh:(0,t.$1j)("refresh",60215),regex:(0,t.$1j)("regex",60216),remoteExplorer:(0,t.$1j)("remote-explorer",60217),remote:(0,t.$1j)("remote",60218),remove:(0,t.$1j)("remove",60219),replaceAll:(0,t.$1j)("replace-all",60220),replace:(0,t.$1j)("replace",60221),repoClone:(0,t.$1j)("repo-clone",60222),repoForcePush:(0,t.$1j)("repo-force-push",60223),repoPull:(0,t.$1j)("repo-pull",60224),repoPush:(0,t.$1j)("repo-push",60225),report:(0,t.$1j)("report",60226),requestChanges:(0,t.$1j)("request-changes",60227),rocket:(0,t.$1j)("rocket",60228),rootFolderOpened:(0,t.$1j)("root-folder-opened",60229),rootFolder:(0,t.$1j)("root-folder",60230),rss:(0,t.$1j)("rss",60231),ruby:(0,t.$1j)("ruby",60232),saveAll:(0,t.$1j)("save-all",60233),saveAs:(0,t.$1j)("save-as",60234),save:(0,t.$1j)("save",60235),screenFull:(0,t.$1j)("screen-full",60236),screenNormal:(0,t.$1j)("screen-normal",60237),searchStop:(0,t.$1j)("search-stop",60238),server:(0,t.$1j)("server",60240),settingsGear:(0,t.$1j)("settings-gear",60241),settings:(0,t.$1j)("settings",60242),shield:(0,t.$1j)("shield",60243),smiley:(0,t.$1j)("smiley",60244),sortPrecedence:(0,t.$1j)("sort-precedence",60245),splitHorizontal:(0,t.$1j)("split-horizontal",60246),splitVertical:(0,t.$1j)("split-vertical",60247),squirrel:(0,t.$1j)("squirrel",60248),starFull:(0,t.$1j)("star-full",60249),starHalf:(0,t.$1j)("star-half",60250),symbolClass:(0,t.$1j)("symbol-class",60251),symbolColor:(0,t.$1j)("symbol-color",60252),symbolConstant:(0,t.$1j)("symbol-constant",60253),symbolEnumMember:(0,t.$1j)("symbol-enum-member",60254),symbolField:(0,t.$1j)("symbol-field",60255),symbolFile:(0,t.$1j)("symbol-file",60256),symbolInterface:(0,t.$1j)("symbol-interface",60257),symbolKeyword:(0,t.$1j)("symbol-keyword",60258),symbolMisc:(0,t.$1j)("symbol-misc",60259),symbolOperator:(0,t.$1j)("symbol-operator",60260),symbolProperty:(0,t.$1j)("symbol-property",60261),wrench:(0,t.$1j)("wrench",60261),wrenchSubaction:(0,t.$1j)("wrench-subaction",60261),symbolSnippet:(0,t.$1j)("symbol-snippet",60262),tasklist:(0,t.$1j)("tasklist",60263),telescope:(0,t.$1j)("telescope",60264),textSize:(0,t.$1j)("text-size",60265),threeBars:(0,t.$1j)("three-bars",60266),thumbsdown:(0,t.$1j)("thumbsdown",60267),thumbsup:(0,t.$1j)("thumbsup",60268),tools:(0,t.$1j)("tools",60269),triangleDown:(0,t.$1j)("triangle-down",60270),triangleLeft:(0,t.$1j)("triangle-left",60271),triangleRight:(0,t.$1j)("triangle-right",60272),triangleUp:(0,t.$1j)("triangle-up",60273),twitter:(0,t.$1j)("twitter",60274),unfold:(0,t.$1j)("unfold",60275),unlock:(0,t.$1j)("unlock",60276),unmute:(0,t.$1j)("unmute",60277),unverified:(0,t.$1j)("unverified",60278),verified:(0,t.$1j)("verified",60279),versions:(0,t.$1j)("versions",60280),vmActive:(0,t.$1j)("vm-active",60281),vmOutline:(0,t.$1j)("vm-outline",60282),vmRunning:(0,t.$1j)("vm-running",60283),watch:(0,t.$1j)("watch",60284),whitespace:(0,t.$1j)("whitespace",60285),wholeWord:(0,t.$1j)("whole-word",60286),window:(0,t.$1j)("window",60287),wordWrap:(0,t.$1j)("word-wrap",60288),zoomIn:(0,t.$1j)("zoom-in",60289),zoomOut:(0,t.$1j)("zoom-out",60290),listFilter:(0,t.$1j)("list-filter",60291),listFlat:(0,t.$1j)("list-flat",60292),listSelection:(0,t.$1j)("list-selection",60293),selection:(0,t.$1j)("selection",60293),listTree:(0,t.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$1j)("circle-small-filled",60298),debugStackframeDot:(0,t.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,t.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,t.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$1j)("symbol-string",60301),debugReverseContinue:(0,t.$1j)("debug-reverse-continue",60302),debugStepBack:(0,t.$1j)("debug-step-back",60303),debugRestartFrame:(0,t.$1j)("debug-restart-frame",60304),debugAlt:(0,t.$1j)("debug-alt",60305),callIncoming:(0,t.$1j)("call-incoming",60306),callOutgoing:(0,t.$1j)("call-outgoing",60307),menu:(0,t.$1j)("menu",60308),expandAll:(0,t.$1j)("expand-all",60309),feedback:(0,t.$1j)("feedback",60310),gitPullRequestReviewer:(0,t.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,t.$1j)("ungroup-by-ref-type",60312),account:(0,t.$1j)("account",60313),gitPullRequestAssignee:(0,t.$1j)("git-pull-request-assignee",60313),bellDot:(0,t.$1j)("bell-dot",60314),debugConsole:(0,t.$1j)("debug-console",60315),library:(0,t.$1j)("library",60316),output:(0,t.$1j)("output",60317),runAll:(0,t.$1j)("run-all",60318),syncIgnored:(0,t.$1j)("sync-ignored",60319),pinned:(0,t.$1j)("pinned",60320),githubInverted:(0,t.$1j)("github-inverted",60321),serverProcess:(0,t.$1j)("server-process",60322),serverEnvironment:(0,t.$1j)("server-environment",60323),pass:(0,t.$1j)("pass",60324),issueClosed:(0,t.$1j)("issue-closed",60324),stopCircle:(0,t.$1j)("stop-circle",60325),playCircle:(0,t.$1j)("play-circle",60326),record:(0,t.$1j)("record",60327),debugAltSmall:(0,t.$1j)("debug-alt-small",60328),vmConnect:(0,t.$1j)("vm-connect",60329),cloud:(0,t.$1j)("cloud",60330),merge:(0,t.$1j)("merge",60331),export:(0,t.$1j)("export",60332),graphLeft:(0,t.$1j)("graph-left",60333),magnet:(0,t.$1j)("magnet",60334),notebook:(0,t.$1j)("notebook",60335),redo:(0,t.$1j)("redo",60336),checkAll:(0,t.$1j)("check-all",60337),pinnedDirty:(0,t.$1j)("pinned-dirty",60338),passFilled:(0,t.$1j)("pass-filled",60339),circleLargeFilled:(0,t.$1j)("circle-large-filled",60340),circleLarge:(0,t.$1j)("circle-large",60341),circleLargeOutline:(0,t.$1j)("circle-large-outline",60341),combine:(0,t.$1j)("combine",60342),gather:(0,t.$1j)("gather",60342),table:(0,t.$1j)("table",60343),variableGroup:(0,t.$1j)("variable-group",60344),typeHierarchy:(0,t.$1j)("type-hierarchy",60345),typeHierarchySub:(0,t.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$1j)("git-pull-request-create",60348),runAbove:(0,t.$1j)("run-above",60349),runBelow:(0,t.$1j)("run-below",60350),notebookTemplate:(0,t.$1j)("notebook-template",60351),debugRerun:(0,t.$1j)("debug-rerun",60352),workspaceTrusted:(0,t.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,t.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,t.$1j)("workspace-unknown",60355),terminalCmd:(0,t.$1j)("terminal-cmd",60356),terminalDebian:(0,t.$1j)("terminal-debian",60357),terminalLinux:(0,t.$1j)("terminal-linux",60358),terminalPowershell:(0,t.$1j)("terminal-powershell",60359),terminalTmux:(0,t.$1j)("terminal-tmux",60360),terminalUbuntu:(0,t.$1j)("terminal-ubuntu",60361),terminalBash:(0,t.$1j)("terminal-bash",60362),arrowSwap:(0,t.$1j)("arrow-swap",60363),copy:(0,t.$1j)("copy",60364),personAdd:(0,t.$1j)("person-add",60365),filterFilled:(0,t.$1j)("filter-filled",60366),wand:(0,t.$1j)("wand",60367),debugLineByLine:(0,t.$1j)("debug-line-by-line",60368),inspect:(0,t.$1j)("inspect",60369),layers:(0,t.$1j)("layers",60370),layersDot:(0,t.$1j)("layers-dot",60371),layersActive:(0,t.$1j)("layers-active",60372),compass:(0,t.$1j)("compass",60373),compassDot:(0,t.$1j)("compass-dot",60374),compassActive:(0,t.$1j)("compass-active",60375),azure:(0,t.$1j)("azure",60376),issueDraft:(0,t.$1j)("issue-draft",60377),gitPullRequestClosed:(0,t.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$1j)("git-pull-request-draft",60379),debugAll:(0,t.$1j)("debug-all",60380),debugCoverage:(0,t.$1j)("debug-coverage",60381),runErrors:(0,t.$1j)("run-errors",60382),folderLibrary:(0,t.$1j)("folder-library",60383),debugContinueSmall:(0,t.$1j)("debug-continue-small",60384),beakerStop:(0,t.$1j)("beaker-stop",60385),graphLine:(0,t.$1j)("graph-line",60386),graphScatter:(0,t.$1j)("graph-scatter",60387),pieChart:(0,t.$1j)("pie-chart",60388),bracket:(0,t.$1j)("bracket",60175),bracketDot:(0,t.$1j)("bracket-dot",60389),bracketError:(0,t.$1j)("bracket-error",60390),lockSmall:(0,t.$1j)("lock-small",60391),azureDevops:(0,t.$1j)("azure-devops",60392),verifiedFilled:(0,t.$1j)("verified-filled",60393),newline:(0,t.$1j)("newline",60394),layout:(0,t.$1j)("layout",60395),layoutActivitybarLeft:(0,t.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,t.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,t.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,t.$1j)("layout-panel-right",60401),layoutPanel:(0,t.$1j)("layout-panel",60402),layoutSidebarLeft:(0,t.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$1j)("layout-statusbar",60405),layoutMenubar:(0,t.$1j)("layout-menubar",60406),layoutCentered:(0,t.$1j)("layout-centered",60407),target:(0,t.$1j)("target",60408),indent:(0,t.$1j)("indent",60409),recordSmall:(0,t.$1j)("record-small",60410),errorSmall:(0,t.$1j)("error-small",60411),terminalDecorationError:(0,t.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,t.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,t.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$1j)("layout-sidebar-left-off",60418),blank:(0,t.$1j)("blank",60419),heartFilled:(0,t.$1j)("heart-filled",60420),map:(0,t.$1j)("map",60421),mapHorizontal:(0,t.$1j)("map-horizontal",60421),foldHorizontal:(0,t.$1j)("fold-horizontal",60421),mapFilled:(0,t.$1j)("map-filled",60422),mapHorizontalFilled:(0,t.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$1j)("fold-horizontal-filled",60422),circleSmall:(0,t.$1j)("circle-small",60423),bellSlash:(0,t.$1j)("bell-slash",60424),bellSlashDot:(0,t.$1j)("bell-slash-dot",60425),commentUnresolved:(0,t.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$1j)("search-fuzzy",60429),commentDraft:(0,t.$1j)("comment-draft",60430),send:(0,t.$1j)("send",60431),sparkle:(0,t.$1j)("sparkle",60432),insert:(0,t.$1j)("insert",60433),mic:(0,t.$1j)("mic",60434),thumbsdownFilled:(0,t.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$1j)("thumbsup-filled",60436),coffee:(0,t.$1j)("coffee",60437),snake:(0,t.$1j)("snake",60438),game:(0,t.$1j)("game",60439),vr:(0,t.$1j)("vr",60440),chip:(0,t.$1j)("chip",60441),piano:(0,t.$1j)("piano",60442),music:(0,t.$1j)("music",60443),micFilled:(0,t.$1j)("mic-filled",60444),repoFetch:(0,t.$1j)("repo-fetch",60445),copilot:(0,t.$1j)("copilot",60446),lightbulbSparkle:(0,t.$1j)("lightbulb-sparkle",60447),robot:(0,t.$1j)("robot",60448),sparkleFilled:(0,t.$1j)("sparkle-filled",60449),diffSingle:(0,t.$1j)("diff-single",60450),diffMultiple:(0,t.$1j)("diff-multiple",60451),surroundWith:(0,t.$1j)("surround-with",60452),share:(0,t.$1j)("share",60453),gitStash:(0,t.$1j)("git-stash",60454),gitStashApply:(0,t.$1j)("git-stash-apply",60455),gitStashPop:(0,t.$1j)("git-stash-pop",60456),vscode:(0,t.$1j)("vscode",60457),vscodeInsiders:(0,t.$1j)("vscode-insiders",60458),codeOss:(0,t.$1j)("code-oss",60459),runCoverage:(0,t.$1j)("run-coverage",60460),runAllCoverage:(0,t.$1j)("run-all-coverage",60461),coverage:(0,t.$1j)("coverage",60462),githubProject:(0,t.$1j)("github-project",60463),mapVertical:(0,t.$1j)("map-vertical",60464),foldVertical:(0,t.$1j)("fold-vertical",60464),mapVerticalFilled:(0,t.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$1j)("fold-vertical-filled",60465),goToSearch:(0,t.$1j)("go-to-search",60466),percentage:(0,t.$1j)("percentage",60467),sortPercentage:(0,t.$1j)("sort-percentage",60467),attach:(0,t.$1j)("attach",60468)}}),ne(ie[47],re([0,1,28,46]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$6j=i.$5j=void 0,i.$4j=p;function p(){return Object.values(i.$6j)}i.$5j={dialogError:(0,t.$1j)("dialog-error","error"),dialogWarning:(0,t.$1j)("dialog-warning","warning"),dialogInfo:(0,t.$1j)("dialog-info","info"),dialogClose:(0,t.$1j)("dialog-close","close"),treeItemExpanded:(0,t.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$1j)("tree-filter-clear","close"),treeItemLoading:(0,t.$1j)("tree-item-loading","loading"),menuSelection:(0,t.$1j)("menu-selection","check"),menuSubmenu:(0,t.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,t.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,t.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$1j)("toolbar-more","more"),quickInputBack:(0,t.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,t.$1j)("drop-down-button",60084),symbolCustomColor:(0,t.$1j)("symbol-customcolor",60252),exportIcon:(0,t.$1j)("export",60332),workspaceUnspecified:(0,t.$1j)("workspace-unspecified",60355),newLine:(0,t.$1j)("newline",60394),thumbsDownFilled:(0,t.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$1j)("thumbsup-filled",60436),gitFetch:(0,t.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$1j)("debug-breakpoint-pending",60377)},i.$6j={...n.$3j,...i.$5j}}),ne(ie[18],re([0,1,27]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$fo=n,i.$go=p,i.$ho=w,i.$io=a,i.$jo=l,i.$ko=f,i.$lo=$,i.$mo=m,i.$no=N,i.$oo=e,i.$po=b,i.$qo=L,i.$ro=_;function n(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const E=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([v,h])=>{E[v]=h&&typeof h=="object"?n(h):h}),E}function p(A){if(!A||typeof A!="object")return A;const E=[A];for(;E.length>0;){const v=E.shift();Object.freeze(v);for(const h in v)if(g.call(v,h)){const u=v[h];typeof u=="object"&&!Object.isFrozen(u)&&!(0,t.$jg)(u)&&E.push(u)}}return A}const g=Object.prototype.hasOwnProperty;function w(A,E){return d(A,E,new Set)}function d(A,E,v){if((0,t.$pg)(A))return A;const h=E(A);if(typeof h<"u")return h;if(Array.isArray(A)){const u=[];for(const r of A)u.push(d(r,E,v));return u}if((0,t.$ig)(A)){if(v.has(A))throw new Error("Cannot clone recursive data-structure");v.add(A);const u={};for(const r in A)g.call(A,r)&&(u[r]=d(A[r],E,v));return v.delete(A),u}return A}function a(A,E,v=!0){return(0,t.$ig)(A)?((0,t.$ig)(E)&&Object.keys(E).forEach(h=>{h in A?v&&((0,t.$ig)(A[h])&&(0,t.$ig)(E[h])?a(A[h],E[h],v):A[h]=E[h]):A[h]=E[h]}),A):E}function l(A,E){if(A===E)return!0;if(A==null||E===null||E===void 0||typeof A!=typeof E||typeof A!="object"||Array.isArray(A)!==Array.isArray(E))return!1;let v,h;if(Array.isArray(A)){if(A.length!==E.length)return!1;for(v=0;v<A.length;v++)if(!l(A[v],E[v]))return!1}else{const u=[];for(h in A)u.push(h);u.sort();const r=[];for(h in E)r.push(h);if(r.sort(),!l(u,r))return!1;for(v=0;v<u.length;v++)if(!l(A[u[v]],E[u[v]]))return!1}return!0}function f(A){const E=new Set;return JSON.stringify(A,(v,h)=>{if((0,t.$ig)(h)||Array.isArray(h)){if(E.has(h))return"[Circular]";E.add(h)}return typeof h=="bigint"?`[BigInt ${h.toString()}]`:h})}function $(A,E){const v=Object.create(null);return!A||!E||Object.keys(E).forEach(u=>{const r=A[u],o=E[u];l(r,o)||(v[u]=o)}),v}function m(A,E){const v=E.toLowerCase(),h=Object.keys(A).find(u=>u.toLowerCase()===v);return h?A[h]:A[E]}function N(A,E){const v=Object.create(null);for(const[h,u]of Object.entries(A))E(h,u)&&(v[h]=u);return v}function e(A){let E=[];for(;Object.prototype!==A;)E=E.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return E}function b(A){const E=[];for(const v of e(A))typeof A[v]=="function"&&E.push(v);return E}function L(A,E){const v=u=>function(){const r=Array.prototype.slice.call(arguments,0);return E(u,r)},h={};for(const u of A)h[u]=v(u);return h}function _(A,E){const v={};for(const[h,u]of Object.entries(A))v[h]=E(u,h);return v}}),ne(ie[14],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Constants=void 0,i.$cf=n,i.$df=p;var t;(function(g){g[g.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",g[g.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",g[g.MAX_UINT_8=255]="MAX_UINT_8",g[g.MAX_UINT_16=65535]="MAX_UINT_16",g[g.MAX_UINT_32=4294967295]="MAX_UINT_32",g[g.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(i.Constants=t={}));function n(g){return g<0?0:g>t.MAX_UINT_8?t.MAX_UINT_8:g|0}function p(g){return g<0?0:g>t.MAX_UINT_32?t.MAX_UINT_32:g|0}}),ne(ie[8],re([0,1,45,3,41,14]),function(x,i,t,n,p,g){"use strict";var w;Object.defineProperty(i,"__esModule",{value:!0}),i.$fg=i.$eg=i.$dg=i.GraphemeBreakType=i.$6f=i.$Xf=i.$Qf=i.$Pf=void 0,i.$ef=d,i.$ff=l,i.$gf=$,i.$hf=m,i.$if=N,i.$jf=e,i.$kf=b,i.$lf=L,i.$mf=_,i.$nf=A,i.$of=E,i.$pf=v,i.$qf=h,i.$rf=u,i.$sf=r,i.$tf=o,i.$uf=c,i.$vf=T,i.$wf=R,i.$xf=j,i.$yf=D,i.$zf=M,i.$Af=S,i.$Bf=y,i.$Cf=F,i.$Df=q,i.$Ef=X,i.$Ff=B,i.$Gf=P,i.$Hf=Y,i.$If=Q,i.$Jf=H,i.$Kf=K,i.$Lf=C,i.$Mf=k,i.$Nf=G,i.$Of=oe,i.$Rf=Te,i.$Sf=De,i.$Tf=Ue,i.$Uf=Fe,i.$Vf=V,i.$Wf=Z,i.$Yf=ee,i.$Zf=he,i.$1f=de,i.$2f=ve,i.$3f=pe,i.$4f=se,i.$5f=ae,i.$7f=ue,i.$8f=fe,i.$9f=ge,i.$0f=$e,i.$$f=Ee,i.$_f=_e,i.$ag=Pe,i.$bg=qe,i.$cg=ze;function d(I){return!I||typeof I!="string"?!0:I.trim().length===0}const a=/{(\d+)}/g;function l(I,...O){return O.length===0?I:I.replace(a,function(z,J){const le=parseInt(J,10);return isNaN(le)||le<0||le>=O.length?z:O[le]})}const f=/{([^}]+)}/g;function $(I,O){return Object.keys(O).length===0?I:I.replace(f,(z,J)=>O[J]??z)}function m(I){return I.replace(/[<>"'&]/g,O=>{switch(O){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return O})}function N(I){return I.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}function e(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(I,O){let z=0,J=I.indexOf(O);for(;J!==-1;)z++,J=I.indexOf(O,J+O.length);return z}function L(I,O,z="\u2026"){return I.length<=O?I:`${I.substr(0,O)}${z}`}function _(I,O,z="\u2026"){if(I.length<=O)return I;const J=Math.ceil(O/2)-z.length/2,le=Math.floor(O/2)-z.length/2;return`${I.substr(0,J)}${z}${I.substr(I.length-le)}`}function A(I,O=" "){const z=E(I,O);return v(z,O)}function E(I,O){if(!I||!O)return I;const z=O.length;if(z===0||I.length===0)return I;let J=0;for(;I.indexOf(O,J)===J;)J=J+z;return I.substring(J)}function v(I,O){if(!I||!O)return I;const z=O.length,J=I.length;if(z===0||J===0)return I;let le=J,be=-1;for(;be=I.lastIndexOf(O,le-1),!(be===-1||be+z!==le);){if(be===0)return"";le=be}return I.substring(0,le)}function h(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(I){return I.replace(/\*/g,"")}function r(I,O,z={}){if(!I)throw new Error("Cannot create regex from empty string");O||(I=e(I)),z.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let J="";return z.global&&(J+="g"),z.matchCase||(J+="i"),z.multiline&&(J+="m"),z.unicode&&(J+="u"),new RegExp(I,J)}function o(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}function c(I){return I.split(/\r\n|\r|\n/)}function T(I){const O=[],z=I.split(/(\r\n|\r|\n)/);for(let J=0;J<Math.ceil(z.length/2);J++)O.push(z[2*J]+(z[2*J+1]??""));return O}function R(I){for(let O=0,z=I.length;O<z;O++){const J=I.charCodeAt(O);if(J!==n.CharCode.Space&&J!==n.CharCode.Tab)return O}return-1}function j(I,O=0,z=I.length){for(let J=O;J<z;J++){const le=I.charCodeAt(J);if(le!==n.CharCode.Space&&le!==n.CharCode.Tab)return I.substring(O,J)}return I.substring(O,z)}function D(I,O=I.length-1){for(let z=O;z>=0;z--){const J=I.charCodeAt(z);if(J!==n.CharCode.Space&&J!==n.CharCode.Tab)return z}return-1}function M(I,O,z){const J=[];let le=0;for(const be of I.matchAll(O)){if(J.push(I.slice(le,be.index)),be.index===void 0)throw new Error("match.index should be defined");le=be.index+be[0].length,J.push(z(be[0],...be.slice(1),be.index,I,be.groups))}return J.push(I.slice(le)),Promise.all(J).then(be=>be.join(""))}function S(I,O){return I<O?-1:I>O?1:0}function y(I,O,z=0,J=I.length,le=0,be=O.length){for(;z<J&&le<be;z++,le++){const Ie=I.charCodeAt(z),Le=O.charCodeAt(le);if(Ie<Le)return-1;if(Ie>Le)return 1}const Re=J-z,xe=be-le;return Re<xe?-1:Re>xe?1:0}function F(I,O){return q(I,O,0,I.length,0,O.length)}function q(I,O,z=0,J=I.length,le=0,be=O.length){for(;z<J&&le<be;z++,le++){let Ie=I.charCodeAt(z),Le=O.charCodeAt(le);if(Ie===Le)continue;if(Ie>=128||Le>=128)return y(I.toLowerCase(),O.toLowerCase(),z,J,le,be);B(Ie)&&(Ie-=32),B(Le)&&(Le-=32);const Me=Ie-Le;if(Me!==0)return Me}const Re=J-z,xe=be-le;return Re<xe?-1:Re>xe?1:0}function X(I){return I>=n.CharCode.Digit0&&I<=n.CharCode.Digit9}function B(I){return I>=n.CharCode.a&&I<=n.CharCode.z}function P(I){return I>=n.CharCode.A&&I<=n.CharCode.Z}function Y(I,O){return I.length===O.length&&q(I,O)===0}function Q(I,O){const z=O.length;return O.length>I.length?!1:q(I,O,0,z)===0}function H(I,O){const z=Math.min(I.length,O.length);let J;for(J=0;J<z;J++)if(I.charCodeAt(J)!==O.charCodeAt(J))return J;return z}function K(I,O){const z=Math.min(I.length,O.length);let J;const le=I.length-1,be=O.length-1;for(J=0;J<z;J++)if(I.charCodeAt(le-J)!==O.charCodeAt(be-J))return J;return z}function C(I){return 55296<=I&&I<=56319}function k(I){return 56320<=I&&I<=57343}function G(I,O){return(I-55296<<10)+(O-56320)+65536}function oe(I,O,z){const J=I.charCodeAt(z);if(C(J)&&z+1<O){const le=I.charCodeAt(z+1);if(k(le))return G(J,le)}return J}function ce(I,O){const z=I.charCodeAt(O-1);if(k(z)&&O>1){const J=I.charCodeAt(O-2);if(C(J))return G(J,z)}return z}class we{get offset(){return this.e}constructor(O,z=0){this.c=O,this.d=O.length,this.e=z}setOffset(O){this.e=O}prevCodePoint(){const O=ce(this.c,this.e);return this.e-=O>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,O}nextCodePoint(){const O=oe(this.c,this.d,this.e);return this.e+=O>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,O}eol(){return this.e>=this.d}}i.$Pf=we;class s{get offset(){return this.c.offset}constructor(O,z=0){this.c=new we(O,z)}nextGraphemeLength(){const O=je.getInstance(),z=this.c,J=z.offset;let le=O.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const be=z.offset,Re=O.getGraphemeBreakType(z.nextCodePoint());if(Oe(le,Re)){z.setOffset(be);break}le=Re}return z.offset-J}prevGraphemeLength(){const O=je.getInstance(),z=this.c,J=z.offset;let le=O.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const be=z.offset,Re=O.getGraphemeBreakType(z.prevCodePoint());if(Oe(Re,le)){z.setOffset(be);break}le=Re}return J-z.offset}eol(){return this.c.eol()}}i.$Qf=s;function Te(I,O){return new s(I,O).nextGraphemeLength()}function De(I,O){return new s(I,O).prevGraphemeLength()}function Ue(I,O){O>0&&k(I.charCodeAt(O))&&O--;const z=O+Te(I,O);return[z-De(I,z),z]}function Fe(I){const O=new s(I);let z=0;for(;!O.eol();)z++,O.nextGraphemeLength();return z}let ke;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function V(I){return ke||(ke=U()),ke.test(I)}const W=/^[\t\n\r\x20-\x7E]*$/;function Z(I){return W.test(I)}i.$Xf=/[\u2028\u2029]/;function ee(I){return i.$Xf.test(I)}function he(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}function de(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}function ve(I,O,z=""){const J=I.trimStart();if(J.length<O)return J;const le=/\b/g;let be=0;for(;le.test(J)&&!(J.length-le.lastIndex<O);)be=le.lastIndex,le.lastIndex+=1;return be===0?J:z+J.substring(be).trimStart()}const Ae=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(I){let O=0;for(const z of I.matchAll(Ae))O!==z.index&&(yield{isCode:!1,str:I.substring(O,z.index)}),yield{isCode:!0,str:z[0]},O=z.index+z[0].length;O!==I.length&&(yield{isCode:!1,str:I.substring(O)})}function se(I){return I&&(I=I.replace(Ae,"")),I}const te=/\\\[.*?\\\]/g;function ae(I){return se(I).replace(te,"")}i.$6f=String.fromCharCode(n.CharCode.UTF8_BOM);function ue(I){return!!(I&&I.length>0&&I.charCodeAt(0)===n.CharCode.UTF8_BOM)}function fe(I){return ue(I)?I.substr(1):I}function ge(I,O){if(!I||!O||I.length<O.length)return!1;const z=O.length,J=I.toLowerCase();let le=0,be=-1;for(;le<z;){const Re=J.indexOf(O[le],be+1);if(Re<0)return!1;be=Re,le++}return!0}function $e(I,O=!1){return I?(O&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}function Ee(I){return I.charAt(0).toUpperCase()+I.slice(1)}function _e(I,O=1){if(O===0)return"";let z=-1;do z=I.indexOf(`
`,z+1),O--;while(O>0&&z>=0);return z===-1?I:(I[z-1]==="\r"&&z--,I.substr(0,z))}function Pe(I){const O=n.CharCode.Z-n.CharCode.A+1;return I=I%(2*O),I<O?String.fromCharCode(n.CharCode.a+I):String.fromCharCode(n.CharCode.A+I-O)}function qe(I){return je.getInstance().getGraphemeBreakType(I)}function Oe(I,O){return I===me.Other?O!==me.Extend&&O!==me.SpacingMark:I===me.CR&&O===me.LF?!1:I===me.Control||I===me.CR||I===me.LF||O===me.Control||O===me.CR||O===me.LF?!0:!(I===me.L&&(O===me.L||O===me.V||O===me.LV||O===me.LVT)||(I===me.LV||I===me.V)&&(O===me.V||O===me.T)||(I===me.LVT||I===me.T)&&O===me.T||O===me.Extend||O===me.ZWJ||O===me.SpacingMark||I===me.Prepend||I===me.ZWJ&&O===me.Extended_Pictographic||I===me.Regional_Indicator&&O===me.Regional_Indicator)}var me;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(me||(i.GraphemeBreakType=me={}));class je{static getInstance(){return je.c||(je.c=new je),je.c}constructor(){this.d=Ge()}getGraphemeBreakType(O){if(O<32)return O===n.CharCode.LineFeed?me.LF:O===n.CharCode.CarriageReturn?me.CR:me.Control;if(O<127)return me.Other;const z=this.d,J=z.length/3;let le=1;for(;le<=J;)if(O<z[3*le])le=2*le;else if(O>z[3*le+1])le=2*le+1;else return z[3*le+2];return me.Other}}je.c=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(I,O){if(I===0)return 0;const z=Ke(I,O);if(z!==void 0)return z;const J=new we(O,I);return J.prevCodePoint(),J.offset}function Ke(I,O){const z=new we(O,I);let J=z.prevCodePoint();for(;Ce(J)||J===We.emojiVariantSelector||J===We.enclosingKeyCap;){if(z.offset===0)return;J=z.prevCodePoint()}if(!de(J))return;let le=z.offset;return le>0&&z.prevCodePoint()===We.zwj&&(le=z.offset),le}function Ce(I){return 127995<=I&&I<=127999}var We;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),i.$dg="\xA0";class Ve{static getInstance(O){return w.d.get(Array.from(O))}static getLocales(){return w.e.value}constructor(O){this.f=O}isAmbiguous(O){return this.f.has(O)}containsAmbiguousCharacter(O){for(let z=0;z<O.length;z++){const J=O.codePointAt(z);if(typeof J=="number"&&this.isAmbiguous(J))return!0}return!1}getPrimaryConfusable(O){return this.f.get(O)}getConfusableCodePoints(){return new Set(this.f.keys())}}i.$eg=Ve,w=Ve,Ve.c=new p.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ve.d=new t.$af({getCacheKey:JSON.stringify},I=>{function O(Le){const Me=new Map;for(let Se=0;Se<Le.length;Se+=2)Me.set(Le[Se],Le[Se+1]);return Me}function z(Le,Me){const Se=new Map(Le);for(const[He,Xe]of Me)Se.set(He,Xe);return Se}function J(Le,Me){if(!Le)return Me;const Se=new Map;for(const[He,Xe]of Le)Me.has(He)&&Se.set(He,Xe);return Se}const le=w.c.value;let be=I.filter(Le=>!Le.startsWith("_")&&Le in le);be.length===0&&(be=["_default"]);let Re;for(const Le of be){const Me=O(le[Le]);Re=J(Re,Me)}const xe=O(le._common),Ie=z(xe,Re);return new w(Ie)}),Ve.e=new p.$X(()=>Object.keys(w.c.value).filter(I=>!I.startsWith("_")));class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(O){return Be.e().has(O)}static containsInvisibleCharacter(O){for(let z=0;z<O.length;z++){const J=O.codePointAt(z);if(typeof J=="number"&&Be.isInvisibleCharacter(J))return!0}return!1}static get codePoints(){return Be.e()}}i.$fg=Be,Be.d=void 0}),ne(ie[48],re([0,1,8]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Aj=i.$yj=void 0,i.$uj=n,i.$vj=p,i.$wj=g,i.$xj=d,i.$zj=b,t=ye(t);function n(_){return p(_,0)}function p(_,A){switch(typeof _){case"object":return _===null?g(349,A):Array.isArray(_)?a(_,A):l(_,A);case"string":return d(_,A);case"boolean":return w(_,A);case"number":return g(_,A);case"undefined":return g(937,A);default:return g(617,A)}}function g(_,A){return(A<<5)-A+_|0}function w(_,A){return g(_?433:863,A)}function d(_,A){A=g(149417,A);for(let E=0,v=_.length;E<v;E++)A=g(_.charCodeAt(E),A);return A}function a(_,A){return A=g(104579,A),_.reduce((E,v)=>p(v,E),A)}function l(_,A){return A=g(181387,A),Object.keys(_).sort().reduce((E,v)=>(E=d(v,E),p(_[v],E)),A)}class f{constructor(){this.g=0}get value(){return this.g}hash(A){return this.g=p(A,this.g),this.g}}i.$yj=f;var $;(function(_){_[_.BLOCK_SIZE=64]="BLOCK_SIZE",_[_.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function m(_,A,E=32){const v=E-A,h=~((1<<v)-1);return(_<<A|(h&_)>>>v)>>>0}function N(_,A=0,E=_.byteLength,v=0){for(let h=0;h<E;h++)_[A+h]=v}function e(_,A,E="0"){for(;_.length<A;)_=E+_;return _}function b(_,A=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(E=>E.toString(16).padStart(2,"0")).join(""):e((_>>>0).toString(16),A/4)}class L{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(A){const E=A.length;if(E===0)return;const v=this.p;let h=this.r,u=this.u,r,o;for(u!==0?(r=u,o=-1,u=0):(r=A.charCodeAt(0),o=0);;){let c=r;if(t.$Lf(r))if(o+1<E){const T=A.charCodeAt(o+1);t.$Mf(T)?(o++,c=t.$Nf(r,T)):c=$.UNICODE_REPLACEMENT}else{u=r;break}else t.$Mf(r)&&(c=$.UNICODE_REPLACEMENT);if(h=this.w(v,h,c),o++,o<E)r=A.charCodeAt(o);else break}this.r=h,this.u=u}w(A,E,v){return v<128?A[E++]=v:v<2048?(A[E++]=192|(v&1984)>>>6,A[E++]=128|(v&63)>>>0):v<65536?(A[E++]=224|(v&61440)>>>12,A[E++]=128|(v&4032)>>>6,A[E++]=128|(v&63)>>>0):(A[E++]=240|(v&1835008)>>>18,A[E++]=128|(v&258048)>>>12,A[E++]=128|(v&4032)>>>6,A[E++]=128|(v&63)>>>0),E>=$.BLOCK_SIZE&&(this.y(),E-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,A[0]=A[$.BLOCK_SIZE+0],A[1]=A[$.BLOCK_SIZE+1],A[2]=A[$.BLOCK_SIZE+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,N(this.p,this.r),this.r>56&&(this.y(),N(this.p));const A=8*this.t;this.q.setUint32(56,Math.floor(A/4294967296),!1),this.q.setUint32(60,A%4294967296,!1),this.y()}y(){const A=L.g,E=this.q;for(let j=0;j<64;j+=4)A.setUint32(j,E.getUint32(j,!1),!1);for(let j=64;j<320;j+=4)A.setUint32(j,m(A.getUint32(j-12,!1)^A.getUint32(j-32,!1)^A.getUint32(j-56,!1)^A.getUint32(j-64,!1),1),!1);let v=this.h,h=this.l,u=this.m,r=this.n,o=this.o,c,T,R;for(let j=0;j<80;j++)j<20?(c=h&u|~h&r,T=1518500249):j<40?(c=h^u^r,T=1859775393):j<60?(c=h&u|h&r|u&r,T=2400959708):(c=h^u^r,T=3395469782),R=m(v,5)+c+o+T+A.getUint32(j*4,!1)&4294967295,o=r,r=u,u=m(h,30),h=v,v=R;this.h=this.h+v&4294967295,this.l=this.l+h&4294967295,this.m=this.m+u&4294967295,this.n=this.n+r&4294967295,this.o=this.o+o&4294967295}}i.$Aj=L,L.g=new DataView(new ArrayBuffer(320))}),ne(ie[29],re([0,1,39,48,14]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Tt=i.$Rt=void 0,i.$St=w;class g{constructor(N){this.a=N}getElements(){const N=this.a,e=new Int32Array(N.length);for(let b=0,L=N.length;b<L;b++)e[b]=N.charCodeAt(b);return e}}i.$Rt=g;function w(m,N,e){return new $(new g(m),new g(N)).ComputeDiff(e).changes}class d{static Assert(N,e){if(!N)throw new Error(e)}}class a{static Copy(N,e,b,L,_){for(let A=0;A<_;A++)b[L+A]=N[e+A]}static Copy2(N,e,b,L,_){for(let A=0;A<_;A++)b[L+A]=N[e+A]}}var l;(function(m){m[m.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class f{constructor(){this.a=[],this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new t.$Qt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(N,e){this.b=Math.min(this.b,N),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(N,e){this.b=Math.min(this.b,N),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class ${constructor(N,e,b=null){this.a=b,this.b=N,this.c=e;const[L,_,A]=$.o(N),[E,v,h]=$.o(e);this.d=A&&h,this.e=L,this.f=_,this.g=E,this.h=v,this.k=[],this.m=[]}static n(N){return N.length>0&&typeof N[0]=="string"}static o(N){const e=N.getElements();if($.n(e)){const b=new Int32Array(e.length);for(let L=0,_=e.length;L<_;L++)b[L]=(0,n.$xj)(e[L],0);return[e,b,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(N,e){return this.f[N]!==this.h[e]?!1:this.d?this.e[N]===this.g[e]:!0}q(N,e){if(!this.p(N,e))return!1;const b=$.r(this.b,N),L=$.r(this.c,e);return b===L}static r(N,e){return typeof N.getStrictElement=="function"?N.getStrictElement(e):null}s(N,e){return this.f[N]!==this.f[e]?!1:this.d?this.e[N]===this.e[e]:!0}u(N,e){return this.h[N]!==this.h[e]?!1:this.d?this.g[N]===this.g[e]:!0}ComputeDiff(N){return this.v(0,this.f.length-1,0,this.h.length-1,N)}v(N,e,b,L,_){const A=[!1];let E=this.w(N,e,b,L,A);return _&&(E=this.z(E)),{quitEarly:A[0],changes:E}}w(N,e,b,L,_){for(_[0]=!1;N<=e&&b<=L&&this.p(N,b);)N++,b++;for(;e>=N&&L>=b&&this.p(e,L);)e--,L--;if(N>e||b>L){let r;return b<=L?(d.Assert(N===e+1,"originalStart should only be one more than originalEnd"),r=[new t.$Qt(N,0,b,L-b+1)]):N<=e?(d.Assert(b===L+1,"modifiedStart should only be one more than modifiedEnd"),r=[new t.$Qt(N,e-N+1,b,0)]):(d.Assert(N===e+1,"originalStart should only be one more than originalEnd"),d.Assert(b===L+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const A=[0],E=[0],v=this.y(N,e,b,L,A,E,_),h=A[0],u=E[0];if(v!==null)return v;if(!_[0]){const r=this.w(N,h,b,u,_);let o=[];return _[0]?o=[new t.$Qt(h+1,e-(h+1)+1,u+1,L-(u+1)+1)]:o=this.w(h+1,e,u+1,L,_),this.H(r,o)}return[new t.$Qt(N,e-N+1,b,L-b+1)]}x(N,e,b,L,_,A,E,v,h,u,r,o,c,T,R,j,D,M){let S=null,y=null,F=new f,q=e,X=b,B=c[0]-j[0]-L,P=p.Constants.MIN_SAFE_SMALL_INTEGER,Y=this.k.length-1;do{const Q=B+N;Q===q||Q<X&&h[Q-1]<h[Q+1]?(r=h[Q+1],T=r-B-L,r<P&&F.MarkNextChange(),P=r,F.AddModifiedElement(r+1,T),B=Q+1-N):(r=h[Q-1]+1,T=r-B-L,r<P&&F.MarkNextChange(),P=r-1,F.AddOriginalElement(r,T+1),B=Q-1-N),Y>=0&&(h=this.k[Y],N=h[0],q=1,X=h.length-1)}while(--Y>=-1);if(S=F.getReverseChanges(),M[0]){let Q=c[0]+1,H=j[0]+1;if(S!==null&&S.length>0){const K=S[S.length-1];Q=Math.max(Q,K.getOriginalEnd()),H=Math.max(H,K.getModifiedEnd())}y=[new t.$Qt(Q,o-Q+1,H,R-H+1)]}else{F=new f,q=A,X=E,B=c[0]-j[0]-v,P=p.Constants.MAX_SAFE_SMALL_INTEGER,Y=D?this.m.length-1:this.m.length-2;do{const Q=B+_;Q===q||Q<X&&u[Q-1]>=u[Q+1]?(r=u[Q+1]-1,T=r-B-v,r>P&&F.MarkNextChange(),P=r+1,F.AddOriginalElement(r+1,T+1),B=Q+1-_):(r=u[Q-1],T=r-B-v,r>P&&F.MarkNextChange(),P=r,F.AddModifiedElement(r+1,T+1),B=Q-1-_),Y>=0&&(u=this.m[Y],_=u[0],q=1,X=u.length-1)}while(--Y>=-1);y=F.getChanges()}return this.H(S,y)}y(N,e,b,L,_,A,E){let v=0,h=0,u=0,r=0,o=0,c=0;N--,b--,_[0]=0,A[0]=0,this.k=[],this.m=[];const T=e-N+(L-b),R=T+1,j=new Int32Array(R),D=new Int32Array(R),M=L-b,S=e-N,y=N-b,F=e-L,X=(S-M)%2===0;j[M]=N,D[S]=e,E[0]=!1;for(let B=1;B<=T/2+1;B++){let P=0,Y=0;u=this.J(M-B,B,M,R),r=this.J(M+B,B,M,R);for(let H=u;H<=r;H+=2){H===u||H<r&&j[H-1]<j[H+1]?v=j[H+1]:v=j[H-1]+1,h=v-(H-M)-y;const K=v;for(;v<e&&h<L&&this.p(v+1,h+1);)v++,h++;if(j[H]=v,v+h>P+Y&&(P=v,Y=h),!X&&Math.abs(H-S)<=B-1&&v>=D[H])return _[0]=v,A[0]=h,K<=D[H]&&l.MaxDifferencesHistory>0&&B<=l.MaxDifferencesHistory+1?this.x(M,u,r,y,S,o,c,F,j,D,v,e,_,h,L,A,X,E):null}const Q=(P-N+(Y-b)-B)/2;if(this.a!==null&&!this.a(P,Q))return E[0]=!0,_[0]=P,A[0]=Y,Q>0&&l.MaxDifferencesHistory>0&&B<=l.MaxDifferencesHistory+1?this.x(M,u,r,y,S,o,c,F,j,D,v,e,_,h,L,A,X,E):(N++,b++,[new t.$Qt(N,e-N+1,b,L-b+1)]);o=this.J(S-B,B,S,R),c=this.J(S+B,B,S,R);for(let H=o;H<=c;H+=2){H===o||H<c&&D[H-1]>=D[H+1]?v=D[H+1]-1:v=D[H-1],h=v-(H-S)-F;const K=v;for(;v>N&&h>b&&this.p(v,h);)v--,h--;if(D[H]=v,X&&Math.abs(H-M)<=B&&v<=j[H])return _[0]=v,A[0]=h,K>=j[H]&&l.MaxDifferencesHistory>0&&B<=l.MaxDifferencesHistory+1?this.x(M,u,r,y,S,o,c,F,j,D,v,e,_,h,L,A,X,E):null}if(B<=l.MaxDifferencesHistory){let H=new Int32Array(r-u+2);H[0]=M-u+1,a.Copy2(j,u,H,1,r-u+1),this.k.push(H),H=new Int32Array(c-o+2),H[0]=S-o+1,a.Copy2(D,o,H,1,c-o+1),this.m.push(H)}}return this.x(M,u,r,y,S,o,c,F,j,D,v,e,_,h,L,A,X,E)}z(N){for(let e=0;e<N.length;e++){const b=N[e],L=e<N.length-1?N[e+1].originalStart:this.f.length,_=e<N.length-1?N[e+1].modifiedStart:this.h.length,A=b.originalLength>0,E=b.modifiedLength>0;for(;b.originalStart+b.originalLength<L&&b.modifiedStart+b.modifiedLength<_&&(!A||this.s(b.originalStart,b.originalStart+b.originalLength))&&(!E||this.u(b.modifiedStart,b.modifiedStart+b.modifiedLength));){const h=this.q(b.originalStart,b.modifiedStart);if(this.q(b.originalStart+b.originalLength,b.modifiedStart+b.modifiedLength)&&!h)break;b.originalStart++,b.modifiedStart++}const v=[null];if(e<N.length-1&&this.I(N[e],N[e+1],v)){N[e]=v[0],N.splice(e+1,1),e--;continue}}for(let e=N.length-1;e>=0;e--){const b=N[e];let L=0,_=0;if(e>0){const r=N[e-1];L=r.originalStart+r.originalLength,_=r.modifiedStart+r.modifiedLength}const A=b.originalLength>0,E=b.modifiedLength>0;let v=0,h=this.G(b.originalStart,b.originalLength,b.modifiedStart,b.modifiedLength);for(let r=1;;r++){const o=b.originalStart-r,c=b.modifiedStart-r;if(o<L||c<_||A&&!this.s(o,o+b.originalLength)||E&&!this.u(c,c+b.modifiedLength))break;const R=(o===L&&c===_?5:0)+this.G(o,b.originalLength,c,b.modifiedLength);R>h&&(h=R,v=r)}b.originalStart-=v,b.modifiedStart-=v;const u=[null];if(e>0&&this.I(N[e-1],N[e],u)){N[e-1]=u[0],N.splice(e,1),e++;continue}}if(this.d)for(let e=1,b=N.length;e<b;e++){const L=N[e-1],_=N[e],A=_.originalStart-L.originalStart-L.originalLength,E=L.originalStart,v=_.originalStart+_.originalLength,h=v-E,u=L.modifiedStart,r=_.modifiedStart+_.modifiedLength,o=r-u;if(A<5&&h<20&&o<20){const c=this.A(E,h,u,o,A);if(c){const[T,R]=c;(T!==L.originalStart+L.originalLength||R!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=T-L.originalStart,L.modifiedLength=R-L.modifiedStart,_.originalStart=T+A,_.modifiedStart=R+A,_.originalLength=v-_.originalStart,_.modifiedLength=r-_.modifiedStart)}}}return N}A(N,e,b,L,_){if(e<_||L<_)return null;const A=N+e-_+1,E=b+L-_+1;let v=0,h=0,u=0;for(let r=N;r<A;r++)for(let o=b;o<E;o++){const c=this.B(r,o,_);c>0&&c>v&&(v=c,h=r,u=o)}return v>0?[h,u]:null}B(N,e,b){let L=0;for(let _=0;_<b;_++){if(!this.p(N+_,e+_))return 0;L+=this.e[N+_].length}return L}C(N){return N<=0||N>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[N])}D(N,e){if(this.C(N)||this.C(N-1))return!0;if(e>0){const b=N+e;if(this.C(b-1)||this.C(b))return!0}return!1}E(N){return N<=0||N>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[N])}F(N,e){if(this.E(N)||this.E(N-1))return!0;if(e>0){const b=N+e;if(this.E(b-1)||this.E(b))return!0}return!1}G(N,e,b,L){const _=this.D(N,e)?1:0,A=this.F(b,L)?1:0;return _+A}H(N,e){const b=[];if(N.length===0||e.length===0)return e.length>0?e:N;if(this.I(N[N.length-1],e[0],b)){const L=new Array(N.length+e.length-1);return a.Copy(N,0,L,0,N.length-1),L[N.length-1]=b[0],a.Copy(e,1,L,N.length,e.length-1),L}else{const L=new Array(N.length+e.length);return a.Copy(N,0,L,0,N.length),a.Copy(e,0,L,N.length,e.length),L}}I(N,e,b){if(d.Assert(N.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),d.Assert(N.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),N.originalStart+N.originalLength>=e.originalStart||N.modifiedStart+N.modifiedLength>=e.modifiedStart){const L=N.originalStart;let _=N.originalLength;const A=N.modifiedStart;let E=N.modifiedLength;return N.originalStart+N.originalLength>=e.originalStart&&(_=e.originalStart+e.originalLength-N.originalStart),N.modifiedStart+N.modifiedLength>=e.modifiedStart&&(E=e.modifiedStart+e.modifiedLength-N.modifiedStart),b[0]=new t.$Qt(L,_,A,E),!0}else return b[0]=null,!1}J(N,e,b,L){if(N>=0&&N<L)return N;const _=b,A=L-b-1,E=e%2===0;if(N<0){const v=_%2===0;return E===v?0:1}else{const v=A%2===0;return E===v?L-1:L-2}}}i.$Tt=$}),ne(ie[19],re([0,1,3,42,44,17]),function(x,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.URI=void 0,i.$yc=L,i.$zc=u,p=ye(p);const w=/^\w[\w\d+.-]*$/,d=/^\//,a=/^\/\//;function l(R,j){if(!R.scheme&&j)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!w.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!d.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(a.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(R,j){return!R&&!j?"file":R}function $(R,j){switch(R){case"https":case"http":case"file":j?j[0]!==N&&(j=N+j):j=N;break}return j}const m="",N="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(j){return j instanceof b?!0:j?typeof j.authority=="string"&&typeof j.fragment=="string"&&typeof j.path=="string"&&typeof j.query=="string"&&typeof j.scheme=="string"&&typeof j.fsPath=="string"&&typeof j.with=="function"&&typeof j.toString=="function":!1}constructor(j,D,M,S,y,F=!1){typeof j=="object"?(this.scheme=j.scheme||m,this.authority=j.authority||m,this.path=j.path||m,this.query=j.query||m,this.fragment=j.fragment||m):(this.scheme=f(j,F),this.authority=D||m,this.path=$(this.scheme,M||m),this.query=S||m,this.fragment=y||m,l(this,F))}get fsPath(){return u(this,!1)}with(j){if(!j)return this;let{scheme:D,authority:M,path:S,query:y,fragment:F}=j;return D===void 0?D=this.scheme:D===null&&(D=m),M===void 0?M=this.authority:M===null&&(M=m),S===void 0?S=this.path:S===null&&(S=m),y===void 0?y=this.query:y===null&&(y=m),F===void 0?F=this.fragment:F===null&&(F=m),D===this.scheme&&M===this.authority&&S===this.path&&y===this.query&&F===this.fragment?this:new A(D,M,S,y,F)}static parse(j,D=!1){const M=e.exec(j);return M?new A(M[2]||m,T(M[4]||m),T(M[5]||m),T(M[7]||m),T(M[9]||m),D):new A(m,m,m,m,m)}static file(j){let D=m;if(g.$c&&(j=j.replace(/\\/g,N)),j[0]===N&&j[1]===N){const M=j.indexOf(N,2);M===-1?(D=j.substring(2),j=N):(D=j.substring(2,M),j=j.substring(M)||N)}return new A("file",D,j,m,m)}static from(j,D){return new A(j.scheme,j.authority,j.path,j.query,j.fragment,D)}static joinPath(j,...D){if(!j.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return g.$c&&j.scheme==="file"?M=b.file(p.$ic.join(u(j,!0),...D)).path:M=p.$jc.join(j.path,...D),j.with({path:M})}toString(j=!1){return r(this,j)}toJSON(){return this}static revive(j){if(j){if(j instanceof b)return j;{const D=new A(j);return D._formatted=j.external??null,D._fsPath=j._sep===_?j.fsPath??null:null,D}}else return j}}i.URI=b;function L(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}const _=g.$c?1:void 0;class A extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(j=!1){return j?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const j={$mid:n.MarshalledId.Uri};return this._fsPath&&(j.fsPath=this._fsPath,j._sep=_),this._formatted&&(j.external=this._formatted),this.path&&(j.path=this.path),this.scheme&&(j.scheme=this.scheme),this.authority&&(j.authority=this.authority),this.query&&(j.query=this.query),this.fragment&&(j.fragment=this.fragment),j}}const E={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function v(R,j,D){let M,S=-1;for(let y=0;y<R.length;y++){const F=R.charCodeAt(y);if(F>=t.CharCode.a&&F<=t.CharCode.z||F>=t.CharCode.A&&F<=t.CharCode.Z||F>=t.CharCode.Digit0&&F<=t.CharCode.Digit9||F===t.CharCode.Dash||F===t.CharCode.Period||F===t.CharCode.Underline||F===t.CharCode.Tilde||j&&F===t.CharCode.Slash||D&&F===t.CharCode.OpenSquareBracket||D&&F===t.CharCode.CloseSquareBracket||D&&F===t.CharCode.Colon)S!==-1&&(M+=encodeURIComponent(R.substring(S,y)),S=-1),M!==void 0&&(M+=R.charAt(y));else{M===void 0&&(M=R.substr(0,y));const q=E[F];q!==void 0?(S!==-1&&(M+=encodeURIComponent(R.substring(S,y)),S=-1),M+=q):S===-1&&(S=y)}}return S!==-1&&(M+=encodeURIComponent(R.substring(S))),M!==void 0?M:R}function h(R){let j;for(let D=0;D<R.length;D++){const M=R.charCodeAt(D);M===t.CharCode.Hash||M===t.CharCode.QuestionMark?(j===void 0&&(j=R.substr(0,D)),j+=E[M]):j!==void 0&&(j+=R[D])}return j!==void 0?j:R}function u(R,j){let D;return R.authority&&R.path.length>1&&R.scheme==="file"?D=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===t.CharCode.Slash&&(R.path.charCodeAt(1)>=t.CharCode.A&&R.path.charCodeAt(1)<=t.CharCode.Z||R.path.charCodeAt(1)>=t.CharCode.a&&R.path.charCodeAt(1)<=t.CharCode.z)&&R.path.charCodeAt(2)===t.CharCode.Colon?j?D=R.path.substr(1):D=R.path[1].toLowerCase()+R.path.substr(2):D=R.path,g.$c&&(D=D.replace(/\//g,"\\")),D}function r(R,j){const D=j?h:v;let M="",{scheme:S,authority:y,path:F,query:q,fragment:X}=R;if(S&&(M+=S,M+=":"),(y||S==="file")&&(M+=N,M+=N),y){let B=y.indexOf("@");if(B!==-1){const P=y.substr(0,B);y=y.substr(B+1),B=P.lastIndexOf(":"),B===-1?M+=D(P,!1,!1):(M+=D(P.substr(0,B),!1,!1),M+=":",M+=D(P.substr(B+1),!1,!0)),M+="@"}y=y.toLowerCase(),B=y.lastIndexOf(":"),B===-1?M+=D(y,!1,!0):(M+=D(y.substr(0,B),!1,!0),M+=y.substr(B))}if(F){if(F.length>=3&&F.charCodeAt(0)===t.CharCode.Slash&&F.charCodeAt(2)===t.CharCode.Colon){const B=F.charCodeAt(1);B>=t.CharCode.A&&B<=t.CharCode.Z&&(F=`/${String.fromCharCode(B+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===t.CharCode.Colon){const B=F.charCodeAt(0);B>=t.CharCode.A&&B<=t.CharCode.Z&&(F=`${String.fromCharCode(B+32)}:${F.substr(2)}`)}M+=D(F,!0,!1)}return q&&(M+="?",M+=D(q,!1,!1)),X&&(M+="#",M+=j?X:v(X,!1,!1)),M}function o(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+o(R.substr(3)):R}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function T(R){return R.match(c)?R.replace(c,j=>o(j)):R}}),ne(ie[76],re([0,1,4,13,12,18,17,8]),function(x,i,t,n,p,g,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SimpleWorkerServer=i.SimpleWorkerClient=void 0,i.logOnceWebWorkerWarning=f,i.create=r,d=ye(d);const a="$initialize";let l=!1;function f(o){w.$i&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}var $;(function(o){o[o.Request=0]="Request",o[o.Reply=1]="Reply",o[o.SubscribeEvent=2]="SubscribeEvent",o[o.Event=3]="Event",o[o.UnsubscribeEvent=4]="UnsubscribeEvent"})($||($={}));class m{constructor(c,T,R,j){this.vsWorker=c,this.req=T,this.method=R,this.args=j,this.type=$.Request}}class N{constructor(c,T,R,j){this.vsWorker=c,this.seq=T,this.res=R,this.err=j,this.type=$.Reply}}class e{constructor(c,T,R,j){this.vsWorker=c,this.req=T,this.eventName=R,this.arg=j,this.type=$.SubscribeEvent}}class b{constructor(c,T,R){this.vsWorker=c,this.req=T,this.event=R,this.type=$.Event}}class L{constructor(c,T){this.vsWorker=c,this.req=T,this.type=$.UnsubscribeEvent}}class _{constructor(c){this.a=-1,this.g=c,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(c){this.a=c}sendMessage(c,T){const R=String(++this.b);return new Promise((j,D)=>{this.c[R]={resolve:j,reject:D},this.o(new m(this.a,R,c,T))})}listen(c,T){let R=null;const j=new n.$ne({onWillAddFirstListener:()=>{R=String(++this.b),this.d.set(R,j),this.o(new e(this.a,R,c,T))},onDidRemoveLastListener:()=>{this.d.delete(R),this.o(new L(this.a,R)),R=null}});return j.event}handleMessage(c){!c||!c.vsWorker||this.a!==-1&&c.vsWorker!==this.a||this.h(c)}h(c){switch(c.type){case $.Reply:return this.j(c);case $.Request:return this.k(c);case $.SubscribeEvent:return this.l(c);case $.Event:return this.m(c);case $.UnsubscribeEvent:return this.n(c)}}j(c){if(!this.c[c.seq]){console.warn("Got reply to unknown seq");return}const T=this.c[c.seq];if(delete this.c[c.seq],c.err){let R=c.err;c.err.$isError&&(R=new Error,R.name=c.err.name,R.message=c.err.message,R.stack=c.err.stack),T.reject(R);return}T.resolve(c.res)}k(c){const T=c.req;this.g.handleMessage(c.method,c.args).then(j=>{this.o(new N(this.a,T,j,void 0))},j=>{j.detail instanceof Error&&(j.detail=(0,t.$5)(j.detail)),this.o(new N(this.a,T,void 0,(0,t.$5)(j)))})}l(c){const T=c.req,R=this.g.handleEvent(c.eventName,c.arg)(j=>{this.o(new b(this.a,T,j))});this.f.set(T,R)}m(c){if(!this.d.has(c.req)){console.warn("Got event for unknown req");return}this.d.get(c.req).fire(c.event)}n(c){if(!this.f.has(c.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(c.req).dispose(),this.f.delete(c.req)}o(c){const T=[];if(c.type===$.Request)for(let R=0;R<c.args.length;R++)c.args[R]instanceof ArrayBuffer&&T.push(c.args[R]);else c.type===$.Reply&&c.res instanceof ArrayBuffer&&T.push(c.res);this.g.sendMessage(c,T)}}class A extends p.$Xc{constructor(c,T,R){super();let j=null;this.a=this.B(c.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{j?.(q)})),this.c=new _({sendMessage:(q,X)=>{this.a.postMessage(q,X)},handleMessage:(q,X)=>{if(typeof R[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(R[q].apply(R,X))}catch(B){return Promise.reject(B)}},handleEvent:(q,X)=>{if(v(q)){const B=R[q].call(R,X);if(typeof B!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return B}if(E(q)){const B=R[q];if(typeof B!="function")throw new Error(`Missing event ${q} on main thread host.`);return B}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let D=null;const M=globalThis.require;typeof M<"u"&&typeof M.getConfig=="function"?D=M.getConfig():typeof globalThis.requirejs<"u"&&(D=globalThis.requirejs.s.contexts._.config);const S=(0,g.$po)(R);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(D)),T,S]);const y=(q,X)=>this.g(q,X),F=(q,X)=>this.c.listen(q,X);this.f=new Promise((q,X)=>{j=X,this.b.then(B=>{q(h(B,y,F))},B=>{X(B),this.h("Worker failed to load "+T,B)})})}getProxyObject(){return this.f}g(c,T){return new Promise((R,j)=>{this.b.then(()=>{this.c.sendMessage(c,T).then(R,j)},j)})}h(c,T){console.error(c),console.info(T)}}i.SimpleWorkerClient=A;function E(o){return o[0]==="o"&&o[1]==="n"&&d.$Gf(o.charCodeAt(2))}function v(o){return/^onDynamic/.test(o)&&d.$Gf(o.charCodeAt(9))}function h(o,c,T){const R=M=>function(){const S=Array.prototype.slice.call(arguments,0);return c(M,S)},j=M=>function(S){return T(M,S)},D={};for(const M of o){if(v(M)){D[M]=j(M);continue}if(E(M)){D[M]=T(M,void 0);continue}D[M]=R(M)}return D}class u{constructor(c,T){this.a=T,this.b=null,this.c=new _({sendMessage:(R,j)=>{c(R,j)},handleMessage:(R,j)=>this.d(R,j),handleEvent:(R,j)=>this.f(R,j)})}onmessage(c){this.c.handleMessage(c)}d(c,T){if(c===a)return this.g(T[0],T[1],T[2],T[3]);if(!this.b||typeof this.b[c]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+c));try{return Promise.resolve(this.b[c].apply(this.b,T))}catch(R){return Promise.reject(R)}}f(c,T){if(!this.b)throw new Error("Missing requestHandler");if(v(c)){const R=this.b[c].call(this.b,T);if(typeof R!="function")throw new Error(`Missing dynamic event ${c} on request handler.`);return R}if(E(c)){const R=this.b[c];if(typeof R!="function")throw new Error(`Missing event ${c} on request handler.`);return R}throw new Error(`Malformed event name ${c}`)}g(c,T,R,j){this.c.setWorkerId(c);const S=h(j,(y,F)=>this.c.sendMessage(y,F),(y,F)=>this.c.listen(y,F));return this.a?(this.b=this.a(S),Promise.resolve((0,g.$po)(this.b))):(T&&(typeof T.baseUrl<"u"&&delete T.baseUrl,typeof T.paths<"u"&&typeof T.paths.vs<"u"&&delete T.paths.vs,typeof T.trustedTypesPolicy<"u"&&delete T.trustedTypesPolicy,T.catchError=!0,globalThis.require.config(T)),new Promise((y,F)=>{(globalThis.require||x)([R],X=>{if(this.b=X.create(S),!this.b){F(new Error("No RequestHandler!"));return}y((0,g.$po)(this.b))},F)}))}}i.SimpleWorkerServer=u;function r(o){return new u(o,null)}}),ne(ie[30],re([0,1,14]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gu=i.$fu=void 0;class n{constructor(d){const a=(0,t.$cf)(d);this.c=a,this.a=n.d(a),this.b=new Map}static d(d){const a=new Uint8Array(256);return a.fill(d),a}set(d,a){const l=(0,t.$cf)(a);d>=0&&d<256?this.a[d]=l:this.b.set(d,l)}get(d){return d>=0&&d<256?this.a[d]:this.b.get(d)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}i.$fu=n;var p;(function(w){w[w.False=0]="False",w[w.True=1]="True"})(p||(p={}));class g{constructor(){this.a=new n(p.False)}add(d){this.a.set(d,p.True)}has(d){return this.a.get(d)===p.True}clear(){return this.a.clear()}}i.$gu=g}),ne(ie[6],re([0,1,4]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Vt=i.$Ut=void 0;class n{static addRange(w,d){let a=0;for(;a<d.length&&d[a].endExclusive<w.start;)a++;let l=a;for(;l<d.length&&d[l].start<=w.endExclusive;)l++;if(a===l)d.splice(a,0,w);else{const f=Math.min(w.start,d[a].start),$=Math.max(w.endExclusive,d[l-1].endExclusive);d.splice(a,l-a,new n(f,$))}}static tryCreate(w,d){if(!(w>d))return new n(w,d)}static ofLength(w){return new n(0,w)}static ofStartAndLength(w,d){return new n(w,w+d)}constructor(w,d){if(this.start=w,this.endExclusive=d,w>d)throw new t.$fb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(w){return new n(this.start+w,this.endExclusive+w)}deltaStart(w){return new n(this.start+w,this.endExclusive)}deltaEnd(w){return new n(this.start,this.endExclusive+w)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(w){return this.start===w.start&&this.endExclusive===w.endExclusive}containsRange(w){return this.start<=w.start&&w.endExclusive<=this.endExclusive}contains(w){return this.start<=w&&w<this.endExclusive}join(w){return new n(Math.min(this.start,w.start),Math.max(this.endExclusive,w.endExclusive))}intersect(w){const d=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);if(d<=a)return new n(d,a)}intersects(w){const d=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);return d<a}intersectsOrTouches(w){const d=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);return d<=a}isBefore(w){return this.endExclusive<=w.start}isAfter(w){return this.start>=w.endExclusive}slice(w){return w.slice(this.start,this.endExclusive)}substring(w){return w.substring(this.start,this.endExclusive)}clip(w){if(this.isEmpty)throw new t.$fb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,w))}clipCyclic(w){if(this.isEmpty)throw new t.$fb(`Invalid clipping range: ${this.toString()}`);return w<this.start?this.endExclusive-(this.start-w)%this.length:w>=this.endExclusive?this.start+(w-this.start)%this.length:w}map(w){const d=[];for(let a=this.start;a<this.endExclusive;a++)d.push(w(a));return d}forEach(w){for(let d=this.start;d<this.endExclusive;d++)w(d)}}i.$Ut=n;class p{constructor(){this.a=[]}addRange(w){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<w.start;)d++;let a=d;for(;a<this.a.length&&this.a[a].start<=w.endExclusive;)a++;if(d===a)this.a.splice(d,0,w);else{const l=Math.min(w.start,this.a[d].start),f=Math.max(w.endExclusive,this.a[a-1].endExclusive);this.a.splice(d,a-d,new n(l,f))}}toString(){return this.a.map(w=>w.toString()).join(", ")}intersectsStrict(w){let d=0;for(;d<this.a.length&&this.a[d].endExclusive<=w.start;)d++;return d<this.a.length&&this.a[d].start<w.endExclusive}intersectWithRange(w){const d=new p;for(const a of this.a){const l=a.intersect(w);l&&d.addRange(l)}return d}intersectWithRangeLength(w){return this.intersectWithRange(w).length}get length(){return this.a.reduce((w,d)=>w+d.length,0)}}i.$Vt=p}),ne(ie[5],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Mt=void 0;class t{constructor(p,g){this.lineNumber=p,this.column=g}with(p=this.lineNumber,g=this.column){return p===this.lineNumber&&g===this.column?this:new t(p,g)}delta(p=0,g=0){return this.with(this.lineNumber+p,this.column+g)}equals(p){return t.equals(this,p)}static equals(p,g){return!p&&!g?!0:!!p&&!!g&&p.lineNumber===g.lineNumber&&p.column===g.column}isBefore(p){return t.isBefore(this,p)}static isBefore(p,g){return p.lineNumber<g.lineNumber?!0:g.lineNumber<p.lineNumber?!1:p.column<g.column}isBeforeOrEqual(p){return t.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,g){return p.lineNumber<g.lineNumber?!0:g.lineNumber<p.lineNumber?!1:p.column<=g.column}static compare(p,g){const w=p.lineNumber|0,d=g.lineNumber|0;if(w===d){const a=p.column|0,l=g.column|0;return a-l}return w-d}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new t(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}i.$Mt=t}),ne(ie[2],re([0,1,5]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Nt=void 0;class n{constructor(g,w,d,a){g>d||g===d&&w>a?(this.startLineNumber=d,this.startColumn=a,this.endLineNumber=g,this.endColumn=w):(this.startLineNumber=g,this.startColumn=w,this.endLineNumber=d,this.endColumn=a)}isEmpty(){return n.isEmpty(this)}static isEmpty(g){return g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn}containsPosition(g){return n.containsPosition(this,g)}static containsPosition(g,w){return!(w.lineNumber<g.startLineNumber||w.lineNumber>g.endLineNumber||w.lineNumber===g.startLineNumber&&w.column<g.startColumn||w.lineNumber===g.endLineNumber&&w.column>g.endColumn)}static strictContainsPosition(g,w){return!(w.lineNumber<g.startLineNumber||w.lineNumber>g.endLineNumber||w.lineNumber===g.startLineNumber&&w.column<=g.startColumn||w.lineNumber===g.endLineNumber&&w.column>=g.endColumn)}containsRange(g){return n.containsRange(this,g)}static containsRange(g,w){return!(w.startLineNumber<g.startLineNumber||w.endLineNumber<g.startLineNumber||w.startLineNumber>g.endLineNumber||w.endLineNumber>g.endLineNumber||w.startLineNumber===g.startLineNumber&&w.startColumn<g.startColumn||w.endLineNumber===g.endLineNumber&&w.endColumn>g.endColumn)}strictContainsRange(g){return n.strictContainsRange(this,g)}static strictContainsRange(g,w){return!(w.startLineNumber<g.startLineNumber||w.endLineNumber<g.startLineNumber||w.startLineNumber>g.endLineNumber||w.endLineNumber>g.endLineNumber||w.startLineNumber===g.startLineNumber&&w.startColumn<=g.startColumn||w.endLineNumber===g.endLineNumber&&w.endColumn>=g.endColumn)}plusRange(g){return n.plusRange(this,g)}static plusRange(g,w){let d,a,l,f;return w.startLineNumber<g.startLineNumber?(d=w.startLineNumber,a=w.startColumn):w.startLineNumber===g.startLineNumber?(d=w.startLineNumber,a=Math.min(w.startColumn,g.startColumn)):(d=g.startLineNumber,a=g.startColumn),w.endLineNumber>g.endLineNumber?(l=w.endLineNumber,f=w.endColumn):w.endLineNumber===g.endLineNumber?(l=w.endLineNumber,f=Math.max(w.endColumn,g.endColumn)):(l=g.endLineNumber,f=g.endColumn),new n(d,a,l,f)}intersectRanges(g){return n.intersectRanges(this,g)}static intersectRanges(g,w){let d=g.startLineNumber,a=g.startColumn,l=g.endLineNumber,f=g.endColumn;const $=w.startLineNumber,m=w.startColumn,N=w.endLineNumber,e=w.endColumn;return d<$?(d=$,a=m):d===$&&(a=Math.max(a,m)),l>N?(l=N,f=e):l===N&&(f=Math.min(f,e)),d>l||d===l&&a>f?null:new n(d,a,l,f)}equalsRange(g){return n.equalsRange(this,g)}static equalsRange(g,w){return!g&&!w?!0:!!g&&!!w&&g.startLineNumber===w.startLineNumber&&g.startColumn===w.startColumn&&g.endLineNumber===w.endLineNumber&&g.endColumn===w.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(g){return new t.$Mt(g.endLineNumber,g.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(g){return new t.$Mt(g.startLineNumber,g.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(g,w){return new n(this.startLineNumber,this.startColumn,g,w)}setStartPosition(g,w){return new n(g,w,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(g){return new n(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn)}collapseToEnd(){return n.collapseToEnd(this)}static collapseToEnd(g){return new n(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn)}delta(g){return new n(this.startLineNumber+g,this.startColumn,this.endLineNumber+g,this.endColumn)}static fromPositions(g,w=g){return new n(g.lineNumber,g.column,w.lineNumber,w.column)}static lift(g){return g?new n(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):null}static isIRange(g){return g&&typeof g.startLineNumber=="number"&&typeof g.startColumn=="number"&&typeof g.endLineNumber=="number"&&typeof g.endColumn=="number"}static areIntersectingOrTouching(g,w){return!(g.endLineNumber<w.startLineNumber||g.endLineNumber===w.startLineNumber&&g.endColumn<w.startColumn||w.endLineNumber<g.startLineNumber||w.endLineNumber===g.startLineNumber&&w.endColumn<g.startColumn)}static areIntersecting(g,w){return!(g.endLineNumber<w.startLineNumber||g.endLineNumber===w.startLineNumber&&g.endColumn<=w.startColumn||w.endLineNumber<g.startLineNumber||w.endLineNumber===g.startLineNumber&&w.endColumn<=g.startColumn)}static compareRangesUsingStarts(g,w){if(g&&w){const l=g.startLineNumber|0,f=w.startLineNumber|0;if(l===f){const $=g.startColumn|0,m=w.startColumn|0;if($===m){const N=g.endLineNumber|0,e=w.endLineNumber|0;if(N===e){const b=g.endColumn|0,L=w.endColumn|0;return b-L}return N-e}return $-m}return l-f}return(g?1:0)-(w?1:0)}static compareRangesUsingEnds(g,w){return g.endLineNumber===w.endLineNumber?g.endColumn===w.endColumn?g.startLineNumber===w.startLineNumber?g.startColumn-w.startColumn:g.startLineNumber-w.startLineNumber:g.endColumn-w.endColumn:g.endLineNumber-w.endLineNumber}static spansMultipleLines(g){return g.endLineNumber>g.startLineNumber}toJSON(){return this}}i.$Nt=n}),ne(ie[49],re([0,1,2]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Ot=void 0;class n{static insert(g,w){return{range:new t.$Nt(g.lineNumber,g.column,g.lineNumber,g.column),text:w,forceMoveMarkers:!0}}static delete(g){return{range:g,text:null}}static replace(g,w){return{range:g,text:w}}static replaceMove(g,w){return{range:g,text:w,forceMoveMarkers:!0}}}i.$Ot=n}),ne(ie[15],re([0,1,4,6,2,9]),function(x,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Xt=i.$Wt=void 0;class w{static fromRange(l){return new w(l.startLineNumber,l.endLineNumber)}static fromRangeInclusive(l){return new w(l.startLineNumber,l.endLineNumber+1)}static subtract(l,f){return f?l.startLineNumber<f.startLineNumber&&f.endLineNumberExclusive<l.endLineNumberExclusive?[new w(l.startLineNumber,f.startLineNumber),new w(f.endLineNumberExclusive,l.endLineNumberExclusive)]:f.startLineNumber<=l.startLineNumber&&l.endLineNumberExclusive<=f.endLineNumberExclusive?[]:f.endLineNumberExclusive<l.endLineNumberExclusive?[new w(Math.max(f.endLineNumberExclusive,l.startLineNumber),l.endLineNumberExclusive)]:[new w(l.startLineNumber,Math.min(f.startLineNumber,l.endLineNumberExclusive))]:[l]}static joinMany(l){if(l.length===0)return[];let f=new d(l[0].slice());for(let $=1;$<l.length;$++)f=f.getUnion(new d(l[$].slice()));return f.ranges}static join(l){if(l.length===0)throw new t.$fb("lineRanges cannot be empty");let f=l[0].startLineNumber,$=l[0].endLineNumberExclusive;for(let m=1;m<l.length;m++)f=Math.min(f,l[m].startLineNumber),$=Math.max($,l[m].endLineNumberExclusive);return new w(f,$)}static ofLength(l,f){return new w(l,l+f)}static deserialize(l){return new w(l[0],l[1])}constructor(l,f){if(l>f)throw new t.$fb(`startLineNumber ${l} cannot be after endLineNumberExclusive ${f}`);this.startLineNumber=l,this.endLineNumberExclusive=f}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new w(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new w(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new w(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const f=Math.max(this.startLineNumber,l.startLineNumber),$=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(f<=$)return new w(f,$)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new p.$Nt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new p.$Nt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const f=[];for(let $=this.startLineNumber;$<this.endLineNumberExclusive;$++)f.push(l($));return f}forEach(l){for(let f=this.startLineNumber;f<this.endLineNumberExclusive;f++)l(f)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new n.$Ut(this.startLineNumber-1,this.endLineNumberExclusive-1)}}i.$Wt=w;class d{constructor(l=[]){this.c=l}get ranges(){return this.c}addRange(l){if(l.length===0)return;const f=(0,g.$nb)(this.c,m=>m.endLineNumberExclusive>=l.startLineNumber),$=(0,g.$lb)(this.c,m=>m.startLineNumber<=l.endLineNumberExclusive)+1;if(f===$)this.c.splice(f,0,l);else if(f===$-1){const m=this.c[f];this.c[f]=m.join(l)}else{const m=this.c[f].join(this.c[$-1]).join(l);this.c.splice(f,$-f,m)}}contains(l){const f=(0,g.$kb)(this.c,$=>$.startLineNumber<=l);return!!f&&f.endLineNumberExclusive>l}intersects(l){const f=(0,g.$kb)(this.c,$=>$.startLineNumber<l.endLineNumberExclusive);return!!f&&f.endLineNumberExclusive>l.startLineNumber}getUnion(l){if(this.c.length===0)return l;if(l.c.length===0)return this;const f=[];let $=0,m=0,N=null;for(;$<this.c.length||m<l.c.length;){let e=null;if($<this.c.length&&m<l.c.length){const b=this.c[$],L=l.c[m];b.startLineNumber<L.startLineNumber?(e=b,$++):(e=L,m++)}else $<this.c.length?(e=this.c[$],$++):(e=l.c[m],m++);N===null?N=e:N.endLineNumberExclusive>=e.startLineNumber?N=new w(N.startLineNumber,Math.max(N.endLineNumberExclusive,e.endLineNumberExclusive)):(f.push(N),N=e)}return N!==null&&f.push(N),new d(f)}subtractFrom(l){const f=(0,g.$nb)(this.c,e=>e.endLineNumberExclusive>=l.startLineNumber),$=(0,g.$lb)(this.c,e=>e.startLineNumber<=l.endLineNumberExclusive)+1;if(f===$)return new d([l]);const m=[];let N=l.startLineNumber;for(let e=f;e<$;e++){const b=this.c[e];b.startLineNumber>N&&m.push(new w(N,b.startLineNumber)),N=b.endLineNumberExclusive}return N<l.endLineNumberExclusive&&m.push(new w(N,l.endLineNumberExclusive)),new d(m)}toString(){return this.c.map(l=>l.toString()).join(", ")}getIntersection(l){const f=[];let $=0,m=0;for(;$<this.c.length&&m<l.c.length;){const N=this.c[$],e=l.c[m],b=N.intersect(e);b&&!b.isEmpty&&f.push(b),N.endLineNumberExclusive<e.endLineNumberExclusive?$++:m++}return new d(f)}getWithDelta(l){return new d(this.c.map(f=>f.delta(l)))}}i.$Xt=d}),ne(ie[50],re([0,1,5,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Pt=i.SelectionDirection=void 0;var p;(function(w){w[w.LTR=0]="LTR",w[w.RTL=1]="RTL"})(p||(i.SelectionDirection=p={}));class g extends n.$Nt{constructor(d,a,l,f){super(d,a,l,f),this.selectionStartLineNumber=d,this.selectionStartColumn=a,this.positionLineNumber=l,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return g.selectionsEqual(this,d)}static selectionsEqual(d,a){return d.selectionStartLineNumber===a.selectionStartLineNumber&&d.selectionStartColumn===a.selectionStartColumn&&d.positionLineNumber===a.positionLineNumber&&d.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?p.LTR:p.RTL}setEndPosition(d,a){return this.getDirection()===p.LTR?new g(this.startLineNumber,this.startColumn,d,a):new g(d,a,this.startLineNumber,this.startColumn)}getPosition(){return new t.$Mt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new t.$Mt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,a){return this.getDirection()===p.LTR?new g(d,a,this.endLineNumber,this.endColumn):new g(this.endLineNumber,this.endColumn,d,a)}static fromPositions(d,a=d){return new g(d.lineNumber,d.column,a.lineNumber,a.column)}static fromRange(d,a){return a===p.LTR?new g(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new g(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new g(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,a){if(d&&!a||!d&&a)return!1;if(!d&&!a)return!0;if(d.length!==a.length)return!1;for(let l=0,f=d.length;l<f;l++)if(!this.selectionsEqual(d[l],a[l]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,a,l,f,$){return $===p.LTR?new g(d,a,l,f):new g(l,f,d,a)}}i.$Pt=g}),ne(ie[31],re([0,1,5,2]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Yt=void 0;class p{static lengthDiffNonNegative(w,d){return d.isLessThan(w)?p.zero:w.lineCount===d.lineCount?new p(0,d.columnCount-w.columnCount):new p(d.lineCount-w.lineCount,d.columnCount)}static betweenPositions(w,d){return w.lineNumber===d.lineNumber?new p(0,d.column-w.column):new p(d.lineNumber-w.lineNumber,d.column-1)}static ofRange(w){return p.betweenPositions(w.getStartPosition(),w.getEndPosition())}static ofText(w){let d=0,a=0;for(const l of w)l===`
`?(d++,a=0):a++;return new p(d,a)}constructor(w,d){this.lineCount=w,this.columnCount=d}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(w){return this.lineCount!==w.lineCount?this.lineCount<w.lineCount:this.columnCount<w.columnCount}isGreaterThan(w){return this.lineCount!==w.lineCount?this.lineCount>w.lineCount:this.columnCount>w.columnCount}isGreaterThanOrEqualTo(w){return this.lineCount!==w.lineCount?this.lineCount>w.lineCount:this.columnCount>=w.columnCount}equals(w){return this.lineCount===w.lineCount&&this.columnCount===w.columnCount}compare(w){return this.lineCount!==w.lineCount?this.lineCount-w.lineCount:this.columnCount-w.columnCount}add(w){return w.lineCount===0?new p(this.lineCount,this.columnCount+w.columnCount):new p(this.lineCount+w.lineCount,w.columnCount)}createRange(w){return this.lineCount===0?new n.$Nt(w.lineNumber,w.column,w.lineNumber,w.column+this.columnCount):new n.$Nt(w.lineNumber,w.column,w.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new n.$Nt(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(w){return this.lineCount===0?new t.$Mt(w.lineNumber,w.column+this.columnCount):new t.$Mt(w.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}i.$Yt=p,p.zero=new p(0,0)}),ne(ie[51],re([0,1,9,6,5,2,31]),function(x,i,t,n,p,g,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Zt=void 0;class d{constructor(l){this.text=l,this.a=[],this.a.push(0);for(let f=0;f<l.length;f++)l.charAt(f)===`
`&&this.a.push(f+1)}getOffset(l){return this.a[l.lineNumber-1]+l.column-1}getOffsetRange(l){return new n.$Ut(this.getOffset(l.getStartPosition()),this.getOffset(l.getEndPosition()))}getPosition(l){const f=(0,t.$lb)(this.a,N=>N<=l),$=f+1,m=l-this.a[f]+1;return new p.$Mt($,m)}getRange(l){return g.$Nt.fromPositions(this.getPosition(l.start),this.getPosition(l.endExclusive))}getTextLength(l){return w.$Yt.ofRange(this.getRange(l))}get textLength(){const l=this.a.length-1;return new w.$Yt(l,this.text.length-this.a[l])}}i.$Zt=d}),ne(ie[52],re([0,1,11,4,5,51,2,31]),function(x,i,t,n,p,g,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$5t=i.$4t=i.$3t=i.$2t=i.$1t=void 0;class a{static single(b,L){return new a([new l(b,L)])}constructor(b){this.edits=b,(0,t.$kd)(()=>(0,t.$ld)(b,(L,_)=>L.range.getEndPosition().isBeforeOrEqual(_.range.getStartPosition())))}normalize(){const b=[];for(const L of this.edits)if(b.length>0&&b[b.length-1].range.getEndPosition().equals(L.range.getStartPosition())){const _=b[b.length-1];b[b.length-1]=new l(_.range.plusRange(L.range),_.text+L.text)}else L.isEmpty||b.push(L);return new a(b)}mapPosition(b){let L=0,_=0,A=0;for(const E of this.edits){const v=E.range.getStartPosition(),h=E.range.getEndPosition();if(b.isBeforeOrEqual(v))break;const u=d.$Yt.ofText(E.text);if(b.isBefore(h)){const r=new p.$Mt(v.lineNumber+L,v.column+(v.lineNumber+L===_?A:0)),o=u.addToPosition(r);return f(r,o)}L+=u.lineCount-(E.range.endLineNumber-E.range.startLineNumber),u.lineCount===0?h.lineNumber!==v.lineNumber?A+=u.columnCount-(h.column-1):A+=u.columnCount-(h.column-v.column):A=u.columnCount,_=h.lineNumber+L}return new p.$Mt(b.lineNumber+L,b.column+(b.lineNumber+L===_?A:0))}mapRange(b){function L(v){return v instanceof p.$Mt?v:v.getStartPosition()}function _(v){return v instanceof p.$Mt?v:v.getEndPosition()}const A=L(this.mapPosition(b.getStartPosition())),E=_(this.mapPosition(b.getEndPosition()));return f(A,E)}inverseMapPosition(b,L){return this.inverse(L).mapPosition(b)}inverseMapRange(b,L){return this.inverse(L).mapRange(b)}apply(b){let L="",_=new p.$Mt(1,1);for(const E of this.edits){const v=E.range,h=v.getStartPosition(),u=v.getEndPosition(),r=f(_,h);r.isEmpty()||(L+=b.getValueOfRange(r)),L+=E.text,_=u}const A=f(_,b.endPositionExclusive);return A.isEmpty()||(L+=b.getValueOfRange(A)),L}applyToString(b){const L=new N(b);return this.apply(L)}inverse(b){const L=this.getNewRanges();return new a(this.edits.map((_,A)=>new l(L[A],b.getValueOfRange(_.range))))}getNewRanges(){const b=[];let L=0,_=0,A=0;for(const E of this.edits){const v=d.$Yt.ofText(E.text),h=p.$Mt.lift({lineNumber:E.range.startLineNumber+_,column:E.range.startColumn+(E.range.startLineNumber===L?A:0)}),u=v.createRange(h);b.push(u),_=u.endLineNumber-E.range.endLineNumber,A=u.endColumn-E.range.endColumn,L=E.range.endLineNumber}return b}}i.$1t=a;class l{constructor(b,L){this.range=b,this.text=L}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(b,L){return b.range.equalsRange(L.range)&&b.text===L.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}i.$2t=l;function f(e,b){if(e.lineNumber===b.lineNumber&&e.column===Number.MAX_SAFE_INTEGER)return w.$Nt.fromPositions(b,b);if(!e.isBeforeOrEqual(b))throw new n.$fb("start must be before end");return new w.$Nt(e.lineNumber,e.column,b.lineNumber,b.column)}class ${get endPositionExclusive(){return this.length.addToPosition(new p.$Mt(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}i.$3t=$;class m extends ${constructor(b,L){(0,t.$id)(L>=1),super(),this.c=b,this.d=L}getValueOfRange(b){if(b.startLineNumber===b.endLineNumber)return this.c(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);let L=this.c(b.startLineNumber).substring(b.startColumn-1);for(let _=b.startLineNumber+1;_<b.endLineNumber;_++)L+=`
`+this.c(_);return L+=`
`+this.c(b.endLineNumber).substring(0,b.endColumn-1),L}get length(){const b=this.c(this.d);return new d.$Yt(this.d-1,b.length)}}i.$4t=m;class N extends ${constructor(b){super(),this.value=b,this.c=new g.$Zt(this.value)}getValueOfRange(b){return this.c.getOffsetRange(b).substring(this.value)}get length(){return this.c.textLength}}i.$5t=N}),ne(ie[53],re([0,1,3,16,30]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$hu=i.WordCharacterClass=void 0,i.$iu=a;var g;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(g||(i.WordCharacterClass=g={}));class w extends p.$fu{constructor(f,$){super(g.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=$,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let m=0,N=f.length;m<N;m++)this.set(f.charCodeAt(m),g.WordSeparator);this.set(t.CharCode.Space,g.Whitespace),this.set(t.CharCode.Tab,g.Whitespace)}findPrevIntlWordBeforeOrAtOffset(f,$){let m=null;for(const N of this.h(f)){if(N.index>$)break;m=N}return m}findNextIntlWordAtOrAfterOffset(f,$){for(const m of this.h(f))if(!(m.index<$))return m;return null}h(f){return this.e?this.f===f?this.g:(this.f=f,this.g=this.j(this.e.segment(f)),this.g):[]}j(f){const $=[];for(const m of f)this.k(m)&&$.push(m);return $}k(f){return!!f.isWordLike}}i.$hu=w;const d=new n.$Gc(10);function a(l,f){const $=`${l}/${f.join(",")}`;let m=d.get($);return m||(m=new w(l,f),d.set($,m)),m}}),ne(ie[32],re([0,1,23,12,24]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$mt=i.$lt=void 0,i.$nt=w,i.$ot=a,i.$pt=l,i.$lt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g($=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const N of i.$lt)$.indexOf(N)>=0||(m+="\\"+N);return m+="\\s]+)",new RegExp(m,"g")}i.$mt=g();function w($){let m=i.$mt;if($&&$ instanceof RegExp)if($.global)m=$;else{let N="g";$.ignoreCase&&(N+="i"),$.multiline&&(N+="m"),$.unicode&&(N+="u"),m=new RegExp($.source,N)}return m.lastIndex=0,m}const d=new p.$8c;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a($){const m=d.unshift($);return(0,n.$Vc)(m)}function l($,m,N,e,b){if(m=w(m),b||(b=t.Iterable.first(d)),N.length>b.maxLen){let v=$-b.maxLen/2;return v<0?v=0:e+=v,N=N.substring(v,$+b.maxLen/2),l($,m,N,e,b)}const L=Date.now(),_=$-1-e;let A=-1,E=null;for(let v=1;!(Date.now()-L>=b.timeBudget);v++){const h=_-b.windowSize*v;m.lastIndex=Math.max(0,h);const u=f(m,N,_,A);if(!u&&E||(E=u,h<=0))break;A=h}if(E){const v={word:E[0],startColumn:e+1+E.index,endColumn:e+1+E.index+E[0].length};return m.lastIndex=0,v}return null}function f($,m,N,e){let b;for(;b=$.exec(m);){const L=b.index||0;if(L<=N&&$.lastIndex>=N)return b;if(e>0&&L>e)return null}return null}}),ne(ie[10],re([0,1,7,4,6]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$F4=i.$E4=i.$D4=i.$C4=i.$B4=void 0;class g{static trivial($,m){return new g([new w(p.$Ut.ofLength($.length),p.$Ut.ofLength(m.length))],!1)}static trivialTimedOut($,m){return new g([new w(p.$Ut.ofLength($.length),p.$Ut.ofLength(m.length))],!0)}constructor($,m){this.diffs=$,this.hitTimeout=m}}i.$B4=g;class w{static invert($,m){const N=[];return(0,t.$Eb)($,(e,b)=>{N.push(w.fromOffsetPairs(e?e.getEndExclusives():d.zero,b?b.getStarts():new d(m,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+m)))}),N}static fromOffsetPairs($,m){return new w(new p.$Ut($.offset1,m.offset1),new p.$Ut($.offset2,m.offset2))}constructor($,m){this.seq1Range=$,this.seq2Range=m}swap(){return new w(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join($){return new w(this.seq1Range.join($.seq1Range),this.seq2Range.join($.seq2Range))}delta($){return $===0?this:new w(this.seq1Range.delta($),this.seq2Range.delta($))}deltaStart($){return $===0?this:new w(this.seq1Range.deltaStart($),this.seq2Range.deltaStart($))}deltaEnd($){return $===0?this:new w(this.seq1Range.deltaEnd($),this.seq2Range.deltaEnd($))}intersectsOrTouches($){return this.seq1Range.intersectsOrTouches($.seq1Range)||this.seq2Range.intersectsOrTouches($.seq2Range)}intersect($){const m=this.seq1Range.intersect($.seq1Range),N=this.seq2Range.intersect($.seq2Range);if(!(!m||!N))return new w(m,N)}getStarts(){return new d(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new d(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}i.$C4=w;class d{constructor($,m){this.offset1=$,this.offset2=m}toString(){return`${this.offset1} <-> ${this.offset2}`}delta($){return $===0?this:new d(this.offset1+$,this.offset2+$)}equals($){return this.offset1===$.offset1&&this.offset2===$.offset2}}i.$D4=d,d.zero=new d(0,0),d.max=new d(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class a{isValid(){return!0}}i.$E4=a,a.instance=new a;class l{constructor($){if(this.e=$,this.c=Date.now(),this.d=!0,$<=0)throw new n.$fb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}i.$F4=l}),ne(ie[33],re([0,1,6,10]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$K4=void 0;class p{compute(l,f,$=n.$E4.instance){if(l.length===0||f.length===0)return n.$B4.trivial(l,f);const m=l,N=f;function e(r,o){for(;r<m.length&&o<N.length&&m.getElement(r)===N.getElement(o);)r++,o++;return r}let b=0;const L=new w;L.set(0,e(0,0));const _=new d;_.set(0,L.get(0)===0?null:new g(null,0,0,L.get(0)));let A=0;e:for(;;){if(b++,!$.isValid())return n.$B4.trivialTimedOut(m,N);const r=-Math.min(b,N.length+b%2),o=Math.min(b,m.length+b%2);for(A=r;A<=o;A+=2){let c=0;const T=A===o?-1:L.get(A+1),R=A===r?-1:L.get(A-1)+1;c++;const j=Math.min(Math.max(T,R),m.length),D=j-A;if(c++,j>m.length||D>N.length)continue;const M=e(j,D);L.set(A,M);const S=j===T?_.get(A+1):_.get(A-1);if(_.set(A,M!==j?new g(S,j,D,M-j):S),L.get(A)===m.length&&L.get(A)-A===N.length)break e}}let E=_.get(A);const v=[];let h=m.length,u=N.length;for(;;){const r=E?E.x+E.length:0,o=E?E.y+E.length:0;if((r!==h||o!==u)&&v.push(new n.$C4(new t.$Ut(r,h),new t.$Ut(o,u))),!E)break;h=E.x,u=E.y,E=E.prev}return v.reverse(),new n.$B4(v,!1)}}i.$K4=p;class g{constructor(l,f,$,m){this.prev=l,this.x=f,this.y=$,this.length=m}}class w{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,f){if(l<0){if(l=-l-1,l>=this.b.length){const $=this.b;this.b=new Int32Array($.length*2),this.b.set($)}this.b[l]=f}else{if(l>=this.a.length){const $=this.a;this.a=new Int32Array($.length*2),this.a.set($)}this.a[l]=f}}}class d{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,f){l<0?(l=-l-1,this.b[l]=f):this.a[l]=f}}}),ne(ie[54],re([0,1,7,6,10]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$O4=g,i.$P4=l,i.$Q4=f,i.$R4=m,i.$S4=N;function g(e,b,L){let _=L;return _=w(e,b,_),_=w(e,b,_),_=d(e,b,_),_}function w(e,b,L){if(L.length===0)return L;const _=[];_.push(L[0]);for(let E=1;E<L.length;E++){const v=_[_.length-1];let h=L[E];if(h.seq1Range.isEmpty||h.seq2Range.isEmpty){const u=h.seq1Range.start-v.seq1Range.endExclusive;let r;for(r=1;r<=u&&!(e.getElement(h.seq1Range.start-r)!==e.getElement(h.seq1Range.endExclusive-r)||b.getElement(h.seq2Range.start-r)!==b.getElement(h.seq2Range.endExclusive-r));r++);if(r--,r===u){_[_.length-1]=new p.$C4(new n.$Ut(v.seq1Range.start,h.seq1Range.endExclusive-u),new n.$Ut(v.seq2Range.start,h.seq2Range.endExclusive-u));continue}h=h.delta(-r)}_.push(h)}const A=[];for(let E=0;E<_.length-1;E++){const v=_[E+1];let h=_[E];if(h.seq1Range.isEmpty||h.seq2Range.isEmpty){const u=v.seq1Range.start-h.seq1Range.endExclusive;let r;for(r=0;r<u&&!(!e.isStronglyEqual(h.seq1Range.start+r,h.seq1Range.endExclusive+r)||!b.isStronglyEqual(h.seq2Range.start+r,h.seq2Range.endExclusive+r));r++);if(r===u){_[E+1]=new p.$C4(new n.$Ut(h.seq1Range.start+u,v.seq1Range.endExclusive),new n.$Ut(h.seq2Range.start+u,v.seq2Range.endExclusive));continue}r>0&&(h=h.delta(r))}A.push(h)}return _.length>0&&A.push(_[_.length-1]),A}function d(e,b,L){if(!e.getBoundaryScore||!b.getBoundaryScore)return L;for(let _=0;_<L.length;_++){const A=_>0?L[_-1]:void 0,E=L[_],v=_+1<L.length?L[_+1]:void 0,h=new n.$Ut(A?A.seq1Range.endExclusive+1:0,v?v.seq1Range.start-1:e.length),u=new n.$Ut(A?A.seq2Range.endExclusive+1:0,v?v.seq2Range.start-1:b.length);E.seq1Range.isEmpty?L[_]=a(E,e,b,h,u):E.seq2Range.isEmpty&&(L[_]=a(E.swap(),b,e,u,h).swap())}return L}function a(e,b,L,_,A){let v=1;for(;e.seq1Range.start-v>=_.start&&e.seq2Range.start-v>=A.start&&L.isStronglyEqual(e.seq2Range.start-v,e.seq2Range.endExclusive-v)&&v<100;)v++;v--;let h=0;for(;e.seq1Range.start+h<_.endExclusive&&e.seq2Range.endExclusive+h<A.endExclusive&&L.isStronglyEqual(e.seq2Range.start+h,e.seq2Range.endExclusive+h)&&h<100;)h++;if(v===0&&h===0)return e;let u=0,r=-1;for(let o=-v;o<=h;o++){const c=e.seq2Range.start+o,T=e.seq2Range.endExclusive+o,R=e.seq1Range.start+o,j=b.getBoundaryScore(R)+L.getBoundaryScore(c)+L.getBoundaryScore(T);j>r&&(r=j,u=o)}return e.delta(u)}function l(e,b,L){const _=[];for(const A of L){const E=_[_.length-1];if(!E){_.push(A);continue}A.seq1Range.start-E.seq1Range.endExclusive<=2||A.seq2Range.start-E.seq2Range.endExclusive<=2?_[_.length-1]=new p.$C4(E.seq1Range.join(A.seq1Range),E.seq2Range.join(A.seq2Range)):_.push(A)}return _}function f(e,b,L){const _=p.$C4.invert(L,e.length),A=[];let E=new p.$D4(0,0);function v(u,r){if(u.offset1<E.offset1||u.offset2<E.offset2)return;const o=e.findWordContaining(u.offset1),c=b.findWordContaining(u.offset2);if(!o||!c)return;let T=new p.$C4(o,c);const R=T.intersect(r);let j=R.seq1Range.length,D=R.seq2Range.length;for(;_.length>0;){const M=_[0];if(!(M.seq1Range.intersects(T.seq1Range)||M.seq2Range.intersects(T.seq2Range)))break;const y=e.findWordContaining(M.seq1Range.start),F=b.findWordContaining(M.seq2Range.start),q=new p.$C4(y,F),X=q.intersect(M);if(j+=X.seq1Range.length,D+=X.seq2Range.length,T=T.join(q),T.seq1Range.endExclusive>=M.seq1Range.endExclusive)_.shift();else break}j+D<(T.seq1Range.length+T.seq2Range.length)*2/3&&A.push(T),E=T.getEndExclusives()}for(;_.length>0;){const u=_.shift();u.seq1Range.isEmpty||(v(u.getStarts(),u),v(u.getEndExclusives().delta(-1),u))}return $(L,A)}function $(e,b){const L=[];for(;e.length>0||b.length>0;){const _=e[0],A=b[0];let E;_&&(!A||_.seq1Range.start<A.seq1Range.start)?E=e.shift():E=b.shift(),L.length>0&&L[L.length-1].seq1Range.endExclusive>=E.seq1Range.start?L[L.length-1]=L[L.length-1].join(E):L.push(E)}return L}function m(e,b,L){let _=L;if(_.length===0)return _;let A=0,E;do{E=!1;const v=[_[0]];for(let h=1;h<_.length;h++){let o=function(T,R){const j=new n.$Ut(r.seq1Range.endExclusive,u.seq1Range.start);return e.getText(j).replace(/\s/g,"").length<=4&&(T.seq1Range.length+T.seq2Range.length>5||R.seq1Range.length+R.seq2Range.length>5)};const u=_[h],r=v[v.length-1];o(r,u)?(E=!0,v[v.length-1]=v[v.length-1].join(u)):v.push(u)}_=v}while(A++<10&&E);return _}function N(e,b,L){let _=L;if(_.length===0)return _;let A=0,E;do{E=!1;const h=[_[0]];for(let u=1;u<_.length;u++){let c=function(R,j){const D=new n.$Ut(o.seq1Range.endExclusive,r.seq1Range.start);if(e.countLinesIn(D)>5||D.length>500)return!1;const S=e.getText(D).trim();if(S.length>20||S.split(/\r\n|\r|\n/).length>1)return!1;const y=e.countLinesIn(R.seq1Range),F=R.seq1Range.length,q=b.countLinesIn(R.seq2Range),X=R.seq2Range.length,B=e.countLinesIn(j.seq1Range),P=j.seq1Range.length,Y=b.countLinesIn(j.seq2Range),Q=j.seq2Range.length,H=2*40+50;function K(C){return Math.min(C,H)}return Math.pow(Math.pow(K(y*40+F),1.5)+Math.pow(K(q*40+X),1.5),1.5)+Math.pow(Math.pow(K(B*40+P),1.5)+Math.pow(K(Y*40+Q),1.5),1.5)>(H**1.5)**1.5*1.3};const r=_[u],o=h[h.length-1];c(o,r)?(E=!0,h[h.length-1]=h[h.length-1].join(r)):h.push(r)}_=h}while(A++<10&&E);const v=[];return(0,t.$Fb)(_,(h,u,r)=>{let o=u;function c(S){return S.length>0&&S.trim().length<=3&&u.seq1Range.length+u.seq2Range.length>100}const T=e.extendToFullLines(u.seq1Range),R=e.getText(new n.$Ut(T.start,u.seq1Range.start));c(R)&&(o=o.deltaStart(-R.length));const j=e.getText(new n.$Ut(u.seq1Range.endExclusive,T.endExclusive));c(j)&&(o=o.deltaEnd(j.length));const D=p.$C4.fromOffsetPairs(h?h.getEndExclusives():p.$D4.zero,r?r.getStarts():p.$D4.max),M=o.intersect(D);v.length>0&&M.getStarts().equals(v[v.length-1].getEndExclusives())?v[v.length-1]=v[v.length-1].join(M):v.push(M)}),v}}),ne(ie[55],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$N4=void 0;class n{constructor(w,d){this.a=w,this.b=d}getElement(w){return this.a[w]}get length(){return this.a.length}getBoundaryScore(w){const d=w===0?0:p(this.b[w-1]),a=w===this.b.length?0:p(this.b[w]);return 1e3-(d+a)}getText(w){return this.b.slice(w.start,w.endExclusive).join(`
`)}isStronglyEqual(w,d){return this.b[w]===this.b[d]}}i.$N4=n;function p(g){let w=0;for(;w<g.length&&(g.charCodeAt(w)===t.CharCode.Space||g.charCodeAt(w)===t.CharCode.Tab);)w++;return w}}),ne(ie[20],re([0,1,3]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$I4=i.$G4=void 0,i.$H4=p;class n{constructor(d,a){this.width=d,this.height=a,this.a=[],this.a=new Array(d*a)}get(d,a){return this.a[d+a*this.width]}set(d,a,l){this.a[d+a*this.width]=l}}i.$G4=n;function p(w){return w===t.CharCode.Space||w===t.CharCode.Tab}class g{static b(d){let a=this.a.get(d);return a===void 0&&(a=this.a.size,this.a.set(d,a)),a}constructor(d,a,l){this.range=d,this.lines=a,this.source=l,this.d=[];let f=0;for(let $=d.startLineNumber-1;$<d.endLineNumberExclusive-1;$++){const m=a[$];for(let e=0;e<m.length;e++){f++;const b=m[e],L=g.b(b);this.d[L]=(this.d[L]||0)+1}f++;const N=g.b(`
`);this.d[N]=(this.d[N]||0)+1}this.c=f}computeSimilarity(d){let a=0;const l=Math.max(this.d.length,d.d.length);for(let f=0;f<l;f++)a+=Math.abs((this.d[f]??0)-(d.d[f]??0));return 1-a/(this.c+d.c)}}i.$I4=g,g.a=new Map}),ne(ie[56],re([0,1,6,10,20]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$J4=void 0;class g{compute(d,a,l=n.$E4.instance,f){if(d.length===0||a.length===0)return n.$B4.trivial(d,a);const $=new p.$G4(d.length,a.length),m=new p.$G4(d.length,a.length),N=new p.$G4(d.length,a.length);for(let v=0;v<d.length;v++)for(let h=0;h<a.length;h++){if(!l.isValid())return n.$B4.trivialTimedOut(d,a);const u=v===0?0:$.get(v-1,h),r=h===0?0:$.get(v,h-1);let o;d.getElement(v)===a.getElement(h)?(v===0||h===0?o=0:o=$.get(v-1,h-1),v>0&&h>0&&m.get(v-1,h-1)===3&&(o+=N.get(v-1,h-1)),o+=f?f(v,h):1):o=-1;const c=Math.max(u,r,o);if(c===o){const T=v>0&&h>0?N.get(v-1,h-1):0;N.set(v,h,T+1),m.set(v,h,3)}else c===u?(N.set(v,h,0),m.set(v,h,1)):c===r&&(N.set(v,h,0),m.set(v,h,2));$.set(v,h,c)}const e=[];let b=d.length,L=a.length;function _(v,h){(v+1!==b||h+1!==L)&&e.push(new n.$C4(new t.$Ut(v+1,b),new t.$Ut(h+1,L))),b=v,L=h}let A=d.length-1,E=a.length-1;for(;A>=0&&E>=0;)m.get(A,E)===3?(_(A,E),A--,E--):m.get(A,E)===1?A--:E--;return _(-1,-1),e.reverse(),new n.$B4(e,!1)}}i.$J4=g}),ne(ie[34],re([0,1,9,3,6,5,2,20]),function(x,i,t,n,p,g,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$L4=void 0;class a{constructor(b,L,_){this.lines=b,this.considerWhitespaceChanges=_,this.b=[],this.c=[],this.d=[];let A=!1;L.start>0&&L.endExclusive>=b.length&&(L=new p.$Ut(L.start-1,L.endExclusive),A=!0),this.lineRange=L,this.c[0]=0;for(let E=this.lineRange.start;E<this.lineRange.endExclusive;E++){let v=b[E],h=0;if(A)h=v.length,v="",A=!1;else if(!_){const u=v.trimStart();h=v.length-u.length,v=u.trimEnd()}this.d.push(h);for(let u=0;u<v.length;u++)this.b.push(v.charCodeAt(u));E<b.length-1&&(this.b.push(10),this.c[E-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new p.$Ut(0,this.length))}getText(b){return this.b.slice(b.start,b.endExclusive).map(L=>String.fromCharCode(L)).join("")}getElement(b){return this.b[b]}get length(){return this.b.length}getBoundaryScore(b){const L=N(b>0?this.b[b-1]:-1),_=N(b<this.b.length?this.b[b]:-1);if(L===f.LineBreakCR&&_===f.LineBreakLF)return 0;if(L===f.LineBreakLF)return 150;let A=0;return L!==_&&(A+=10,L===f.WordLower&&_===f.WordUpper&&(A+=1)),A+=m(L),A+=m(_),A}translateOffset(b){if(this.lineRange.isEmpty)return new g.$Mt(this.lineRange.start+1,1);const L=(0,t.$lb)(this.c,_=>_<=b);return new g.$Mt(this.lineRange.start+L+1,b-this.c[L]+this.d[L]+1)}translateRange(b){return w.$Nt.fromPositions(this.translateOffset(b.start),this.translateOffset(b.endExclusive))}findWordContaining(b){if(b<0||b>=this.b.length||!l(this.b[b]))return;let L=b;for(;L>0&&l(this.b[L-1]);)L--;let _=b;for(;_<this.b.length&&l(this.b[_]);)_++;return new p.$Ut(L,_)}countLinesIn(b){return this.translateOffset(b.endExclusive).lineNumber-this.translateOffset(b.start).lineNumber}isStronglyEqual(b,L){return this.b[b]===this.b[L]}extendToFullLines(b){const L=(0,t.$kb)(this.c,A=>A<=b.start)??0,_=(0,t.$mb)(this.c,A=>b.endExclusive<=A)??this.b.length;return new p.$Ut(L,_)}}i.$L4=a;function l(e){return e>=n.CharCode.a&&e<=n.CharCode.z||e>=n.CharCode.A&&e<=n.CharCode.Z||e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9}var f;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(f||(f={}));const $={[f.WordLower]:0,[f.WordUpper]:0,[f.WordNumber]:0,[f.End]:10,[f.Other]:2,[f.Separator]:30,[f.Space]:3,[f.LineBreakCR]:10,[f.LineBreakLF]:10};function m(e){return $[e]}function N(e){return e===n.CharCode.LineFeed?f.LineBreakLF:e===n.CharCode.CarriageReturn?f.LineBreakCR:(0,d.$H4)(e)?f.Space:e>=n.CharCode.a&&e<=n.CharCode.z?f.WordLower:e>=n.CharCode.A&&e<=n.CharCode.Z?f.WordUpper:e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9?f.WordNumber:e===-1?f.End:e===n.CharCode.Comma||e===n.CharCode.Semicolon?f.Separator:f.Other}}),ne(ie[35],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$0t=i.$9t=void 0;class t{constructor(g,w,d){this.changes=g,this.moves=w,this.hitTimeout=d}}i.$9t=t;class n{constructor(g,w){this.lineRangeMapping=g,this.changes=w}flip(){return new n(this.lineRangeMapping.flip(),this.changes.map(g=>g.flip()))}}i.$0t=n}),ne(ie[21],re([0,1,4,15,2,52]),function(x,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8t=i.$7t=i.$6t=void 0;class w{static inverse(f,$,m){const N=[];let e=1,b=1;for(const _ of f){const A=new w(new n.$Wt(e,_.original.startLineNumber),new n.$Wt(b,_.modified.startLineNumber));A.modified.isEmpty||N.push(A),e=_.original.endLineNumberExclusive,b=_.modified.endLineNumberExclusive}const L=new w(new n.$Wt(e,$+1),new n.$Wt(b,m+1));return L.modified.isEmpty||N.push(L),N}static clip(f,$,m){const N=[];for(const e of f){const b=e.original.intersect($),L=e.modified.intersect(m);b&&!b.isEmpty&&L&&!L.isEmpty&&N.push(new w(b,L))}return N}constructor(f,$){this.original=f,this.modified=$}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new w(this.modified,this.original)}join(f){return new w(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const f=this.original.toInclusiveRange(),$=this.modified.toInclusiveRange();if(f&&$)return new a(f,$);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new t.$fb("not a valid diff");return new a(new p.$Nt(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new p.$Nt(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new a(new p.$Nt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new p.$Nt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}i.$6t=w;class d extends w{static fromRangeMappings(f){const $=n.$Wt.join(f.map(N=>n.$Wt.fromRangeInclusive(N.originalRange))),m=n.$Wt.join(f.map(N=>n.$Wt.fromRangeInclusive(N.modifiedRange)));return new d($,m,f)}constructor(f,$,m){super(f,$),this.innerChanges=m}flip(){return new d(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}withInnerChangesFromLineRanges(){return new d(this.original,this.modified,[this.toRangeMapping()])}}i.$7t=d;class a{constructor(f,$){this.originalRange=f,this.modifiedRange=$}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}toTextEdit(f){const $=f.getValueOfRange(this.modifiedRange);return new g.$2t(this.originalRange,$)}}i.$8t=a}),ne(ie[57],re([0,1,10,21,7,9,16,15,6,34,20,33]),function(x,i,t,n,p,g,w,d,a,l,f,$){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$M4=m;function m(E,v,h,u,r,o){let{moves:c,excludedChanges:T}=e(E,v,h,o);if(!o.isValid())return[];const R=E.filter(D=>!T.has(D)),j=b(R,u,r,v,h,o);return(0,p.$3b)(c,j),c=_(c),c=c.filter(D=>{const M=D.original.toOffsetRange().slice(v).map(y=>y.trim());return M.join(`
`).length>=15&&N(M,y=>y.length>=2)>=2}),c=A(E,c),c}function N(E,v){let h=0;for(const u of E)v(u)&&h++;return h}function e(E,v,h,u){const r=[],o=E.filter(R=>R.modified.isEmpty&&R.original.length>=3).map(R=>new f.$I4(R.original,v,R)),c=new Set(E.filter(R=>R.original.isEmpty&&R.modified.length>=3).map(R=>new f.$I4(R.modified,h,R))),T=new Set;for(const R of o){let j=-1,D;for(const M of c){const S=R.computeSimilarity(M);S>j&&(j=S,D=M)}if(j>.9&&D&&(c.delete(D),r.push(new n.$6t(R.range,D.range)),T.add(R.source),T.add(D.source)),!u.isValid())return{moves:r,excludedChanges:T}}return{moves:r,excludedChanges:T}}function b(E,v,h,u,r,o){const c=[],T=new w.$Kc;for(const S of E)for(let y=S.original.startLineNumber;y<S.original.endLineNumberExclusive-2;y++){const F=`${v[y-1]}:${v[y+1-1]}:${v[y+2-1]}`;T.add(F,{range:new d.$Wt(y,y+3)})}const R=[];E.sort((0,p.$9b)(S=>S.modified.startLineNumber,p.$$b));for(const S of E){let y=[];for(let F=S.modified.startLineNumber;F<S.modified.endLineNumberExclusive-2;F++){const q=`${h[F-1]}:${h[F+1-1]}:${h[F+2-1]}`,X=new d.$Wt(F,F+3),B=[];T.forEach(q,({range:P})=>{for(const Q of y)if(Q.originalLineRange.endLineNumberExclusive+1===P.endLineNumberExclusive&&Q.modifiedLineRange.endLineNumberExclusive+1===X.endLineNumberExclusive){Q.originalLineRange=new d.$Wt(Q.originalLineRange.startLineNumber,P.endLineNumberExclusive),Q.modifiedLineRange=new d.$Wt(Q.modifiedLineRange.startLineNumber,X.endLineNumberExclusive),B.push(Q);return}const Y={modifiedLineRange:X,originalLineRange:P};R.push(Y),B.push(Y)}),y=B}if(!o.isValid())return[]}R.sort((0,p.$ac)((0,p.$9b)(S=>S.modifiedLineRange.length,p.$$b)));const j=new d.$Xt,D=new d.$Xt;for(const S of R){const y=S.modifiedLineRange.startLineNumber-S.originalLineRange.startLineNumber,F=j.subtractFrom(S.modifiedLineRange),q=D.subtractFrom(S.originalLineRange).getWithDelta(y),X=F.getIntersection(q);for(const B of X.ranges){if(B.length<3)continue;const P=B,Y=B.delta(-y);c.push(new n.$6t(Y,P)),j.addRange(P),D.addRange(Y)}}c.sort((0,p.$9b)(S=>S.original.startLineNumber,p.$$b));const M=new g.$pb(E);for(let S=0;S<c.length;S++){const y=c[S],F=M.findLastMonotonous(K=>K.original.startLineNumber<=y.original.startLineNumber),q=(0,g.$kb)(E,K=>K.modified.startLineNumber<=y.modified.startLineNumber),X=Math.max(y.original.startLineNumber-F.original.startLineNumber,y.modified.startLineNumber-q.modified.startLineNumber),B=M.findLastMonotonous(K=>K.original.startLineNumber<y.original.endLineNumberExclusive),P=(0,g.$kb)(E,K=>K.modified.startLineNumber<y.modified.endLineNumberExclusive),Y=Math.max(B.original.endLineNumberExclusive-y.original.endLineNumberExclusive,P.modified.endLineNumberExclusive-y.modified.endLineNumberExclusive);let Q;for(Q=0;Q<X;Q++){const K=y.original.startLineNumber-Q-1,C=y.modified.startLineNumber-Q-1;if(K>u.length||C>r.length||j.contains(C)||D.contains(K)||!L(u[K-1],r[C-1],o))break}Q>0&&(D.addRange(new d.$Wt(y.original.startLineNumber-Q,y.original.startLineNumber)),j.addRange(new d.$Wt(y.modified.startLineNumber-Q,y.modified.startLineNumber)));let H;for(H=0;H<Y;H++){const K=y.original.endLineNumberExclusive+H,C=y.modified.endLineNumberExclusive+H;if(K>u.length||C>r.length||j.contains(C)||D.contains(K)||!L(u[K-1],r[C-1],o))break}H>0&&(D.addRange(new d.$Wt(y.original.endLineNumberExclusive,y.original.endLineNumberExclusive+H)),j.addRange(new d.$Wt(y.modified.endLineNumberExclusive,y.modified.endLineNumberExclusive+H))),(Q>0||H>0)&&(c[S]=new n.$6t(new d.$Wt(y.original.startLineNumber-Q,y.original.endLineNumberExclusive+H),new d.$Wt(y.modified.startLineNumber-Q,y.modified.endLineNumberExclusive+H)))}return c}function L(E,v,h){if(E.trim()===v.trim())return!0;if(E.length>300&&v.length>300)return!1;const r=new $.$K4().compute(new l.$L4([E],new a.$Ut(0,1),!1),new l.$L4([v],new a.$Ut(0,1),!1),h);let o=0;const c=t.$C4.invert(r.diffs,E.length);for(const D of c)D.seq1Range.forEach(M=>{(0,f.$H4)(E.charCodeAt(M))||o++});function T(D){let M=0;for(let S=0;S<E.length;S++)(0,f.$H4)(D.charCodeAt(S))||M++;return M}const R=T(E.length>v.length?E:v);return o/R>.6&&R>10}function _(E){if(E.length===0)return E;E.sort((0,p.$9b)(h=>h.original.startLineNumber,p.$$b));const v=[E[0]];for(let h=1;h<E.length;h++){const u=v[v.length-1],r=E[h],o=r.original.startLineNumber-u.original.endLineNumberExclusive,c=r.modified.startLineNumber-u.modified.endLineNumberExclusive;if(o>=0&&c>=0&&o+c<=2){v[v.length-1]=u.join(r);continue}v.push(r)}return v}function A(E,v){const h=new g.$pb(E);return v=v.filter(u=>{const r=h.findLastMonotonous(T=>T.original.startLineNumber<u.original.endLineNumberExclusive)||new n.$6t(new d.$Wt(1,1),new d.$Wt(1,1)),o=(0,g.$kb)(E,T=>T.modified.startLineNumber<u.modified.endLineNumberExclusive);return r!==o}),v}}),ne(ie[58],re([0,1,7,11,15,6,2,10,56,33,57,54,55,34,35,21]),function(x,i,t,n,p,g,w,d,a,l,f,$,m,N,e,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$T4=void 0,i.$U4=_,i.$V4=A;class L{constructor(){this.e=new a.$J4,this.f=new l.$K4}computeDiff(v,h,u){if(v.length<=1&&(0,t.$xb)(v,h,(H,K)=>H===K))return new e.$9t([],[],!1);if(v.length===1&&v[0].length===0||h.length===1&&h[0].length===0)return new e.$9t([new b.$7t(new p.$Wt(1,v.length+1),new p.$Wt(1,h.length+1),[new b.$8t(new w.$Nt(1,1,v.length,v[v.length-1].length+1),new w.$Nt(1,1,h.length,h[h.length-1].length+1))])],[],!1);const r=u.maxComputationTimeMs===0?d.$E4.instance:new d.$F4(u.maxComputationTimeMs),o=!u.ignoreTrimWhitespace,c=new Map;function T(H){let K=c.get(H);return K===void 0&&(K=c.size,c.set(H,K)),K}const R=v.map(H=>T(H.trim())),j=h.map(H=>T(H.trim())),D=new m.$N4(R,v),M=new m.$N4(j,h),S=D.length+M.length<1700?this.e.compute(D,M,r,(H,K)=>v[H]===h[K]?h[K].length===0?.1:1+Math.log(1+h[K].length):.99):this.f.compute(D,M,r);let y=S.diffs,F=S.hitTimeout;y=(0,$.$O4)(D,M,y),y=(0,$.$R4)(D,M,y);const q=[],X=H=>{if(o)for(let K=0;K<H;K++){const C=B+K,k=P+K;if(v[C]!==h[k]){const G=this.j(v,h,new d.$C4(new g.$Ut(C,C+1),new g.$Ut(k,k+1)),r,o);for(const oe of G.mappings)q.push(oe);G.hitTimeout&&(F=!0)}}};let B=0,P=0;for(const H of y){(0,n.$kd)(()=>H.seq1Range.start-B===H.seq2Range.start-P);const K=H.seq1Range.start-B;X(K),B=H.seq1Range.endExclusive,P=H.seq2Range.endExclusive;const C=this.j(v,h,H,r,o);C.hitTimeout&&(F=!0);for(const k of C.mappings)q.push(k)}X(v.length-B);const Y=_(q,v,h);let Q=[];return u.computeMoves&&(Q=this.h(Y,v,h,R,j,r,o)),(0,n.$kd)(()=>{function H(C,k){if(C.lineNumber<1||C.lineNumber>k.length)return!1;const G=k[C.lineNumber-1];return!(C.column<1||C.column>G.length+1)}function K(C,k){return!(C.startLineNumber<1||C.startLineNumber>k.length+1||C.endLineNumberExclusive<1||C.endLineNumberExclusive>k.length+1)}for(const C of Y){if(!C.innerChanges)return!1;for(const k of C.innerChanges)if(!(H(k.modifiedRange.getStartPosition(),h)&&H(k.modifiedRange.getEndPosition(),h)&&H(k.originalRange.getStartPosition(),v)&&H(k.originalRange.getEndPosition(),v)))return!1;if(!K(C.modified,h)||!K(C.original,v))return!1}return!0}),new e.$9t(Y,Q,F)}h(v,h,u,r,o,c,T){return(0,f.$M4)(v,h,u,r,o,c).map(D=>{const M=this.j(h,u,new d.$C4(D.original.toOffsetRange(),D.modified.toOffsetRange()),c,T),S=_(M.mappings,h,u,!0);return new e.$0t(D,S)})}j(v,h,u,r,o){const c=new N.$L4(v,u.seq1Range,o),T=new N.$L4(h,u.seq2Range,o),R=c.length+T.length<500?this.e.compute(c,T,r):this.f.compute(c,T,r);let j=R.diffs;return j=(0,$.$O4)(c,T,j),j=(0,$.$Q4)(c,T,j),j=(0,$.$P4)(c,T,j),j=(0,$.$S4)(c,T,j),{mappings:j.map(M=>new b.$8t(c.translateRange(M.seq1Range),T.translateRange(M.seq2Range))),hitTimeout:R.hitTimeout}}}i.$T4=L;function _(E,v,h,u=!1){const r=[];for(const o of(0,t.$Db)(E.map(c=>A(c,v,h)),(c,T)=>c.original.overlapOrTouch(T.original)||c.modified.overlapOrTouch(T.modified))){const c=o[0],T=o[o.length-1];r.push(new b.$7t(c.original.join(T.original),c.modified.join(T.modified),o.map(R=>R.innerChanges[0])))}return(0,n.$kd)(()=>!u&&r.length>0&&(r[0].modified.startLineNumber!==r[0].original.startLineNumber||h.length-r[r.length-1].modified.endLineNumberExclusive!==v.length-r[r.length-1].original.endLineNumberExclusive)?!1:(0,n.$ld)(r,(o,c)=>c.original.startLineNumber-o.original.endLineNumberExclusive===c.modified.startLineNumber-o.modified.endLineNumberExclusive&&o.original.endLineNumberExclusive<c.original.startLineNumber&&o.modified.endLineNumberExclusive<c.modified.startLineNumber)),r}function A(E,v,h){let u=0,r=0;E.modifiedRange.endColumn===1&&E.originalRange.endColumn===1&&E.originalRange.startLineNumber+u<=E.originalRange.endLineNumber&&E.modifiedRange.startLineNumber+u<=E.modifiedRange.endLineNumber&&(r=-1),E.modifiedRange.startColumn-1>=h[E.modifiedRange.startLineNumber-1].length&&E.originalRange.startColumn-1>=v[E.originalRange.startLineNumber-1].length&&E.originalRange.startLineNumber<=E.originalRange.endLineNumber+r&&E.modifiedRange.startLineNumber<=E.modifiedRange.endLineNumber+r&&(u=1);const o=new p.$Wt(E.originalRange.startLineNumber+u,E.originalRange.endLineNumber+1+r),c=new p.$Wt(E.modifiedRange.startLineNumber+u,E.modifiedRange.endLineNumber+1+r);return new b.$7t(o,c,[E])}}),ne(ie[36],re([0,1,3,29,35,21,8,2,11,15]),function(x,i,t,n,p,g,w,d,a,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$_t=i.$$t=void 0,w=ye(w);const f=3;class ${computeDiff(r,o,c){const R=new A(r,o,{maxComputationTime:c.maxComputationTimeMs,shouldIgnoreTrimWhitespace:c.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),j=[];let D=null;for(const M of R.changes){let S;M.originalEndLineNumber===0?S=new l.$Wt(M.originalStartLineNumber+1,M.originalStartLineNumber+1):S=new l.$Wt(M.originalStartLineNumber,M.originalEndLineNumber+1);let y;M.modifiedEndLineNumber===0?y=new l.$Wt(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):y=new l.$Wt(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let F=new g.$7t(S,y,M.charChanges?.map(q=>new g.$8t(new d.$Nt(q.originalStartLineNumber,q.originalStartColumn,q.originalEndLineNumber,q.originalEndColumn),new d.$Nt(q.modifiedStartLineNumber,q.modifiedStartColumn,q.modifiedEndLineNumber,q.modifiedEndColumn))));D&&(D.modified.endLineNumberExclusive===F.modified.startLineNumber||D.original.endLineNumberExclusive===F.original.startLineNumber)&&(F=new g.$7t(D.original.join(F.original),D.modified.join(F.modified),D.innerChanges&&F.innerChanges?D.innerChanges.concat(F.innerChanges):void 0),j.pop()),j.push(F),D=F}return(0,a.$kd)(()=>(0,a.$ld)(j,(M,S)=>S.original.startLineNumber-M.original.endLineNumberExclusive===S.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<S.original.startLineNumber&&M.modified.endLineNumberExclusive<S.modified.startLineNumber)),new p.$9t(j,[],R.quitEarly)}}i.$$t=$;function m(u,r,o,c){return new n.$Tt(u,r,o).ComputeDiff(c)}class N{constructor(r){const o=[],c=[];for(let T=0,R=r.length;T<R;T++)o[T]=E(r[T],1),c[T]=v(r[T],1);this.lines=r,this.a=o,this.b=c}getElements(){const r=[];for(let o=0,c=this.lines.length;o<c;o++)r[o]=this.lines[o].substring(this.a[o]-1,this.b[o]-1);return r}getStrictElement(r){return this.lines[r]}getStartLineNumber(r){return r+1}getEndLineNumber(r){return r+1}createCharSequence(r,o,c){const T=[],R=[],j=[];let D=0;for(let M=o;M<=c;M++){const S=this.lines[M],y=r?this.a[M]:1,F=r?this.b[M]:S.length+1;for(let q=y;q<F;q++)T[D]=S.charCodeAt(q-1),R[D]=M+1,j[D]=q,D++;!r&&M<c&&(T[D]=t.CharCode.LineFeed,R[D]=M+1,j[D]=S.length+1,D++)}return new e(T,R,j)}}class e{constructor(r,o,c){this.a=r,this.b=o,this.d=c}toString(){return"["+this.a.map((r,o)=>(r===t.CharCode.LineFeed?"\\n":String.fromCharCode(r))+`-(${this.b[o]},${this.d[o]})`).join(", ")+"]"}e(r,o){if(r<0||r>=o.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(r){return r>0&&r===this.b.length?this.getEndLineNumber(r-1):(this.e(r,this.b),this.b[r])}getEndLineNumber(r){return r===-1?this.getStartLineNumber(r+1):(this.e(r,this.b),this.a[r]===t.CharCode.LineFeed?this.b[r]+1:this.b[r])}getStartColumn(r){return r>0&&r===this.d.length?this.getEndColumn(r-1):(this.e(r,this.d),this.d[r])}getEndColumn(r){return r===-1?this.getStartColumn(r+1):(this.e(r,this.d),this.a[r]===t.CharCode.LineFeed?1:this.d[r]+1)}}class b{constructor(r,o,c,T,R,j,D,M){this.originalStartLineNumber=r,this.originalStartColumn=o,this.originalEndLineNumber=c,this.originalEndColumn=T,this.modifiedStartLineNumber=R,this.modifiedStartColumn=j,this.modifiedEndLineNumber=D,this.modifiedEndColumn=M}static createFromDiffChange(r,o,c){const T=o.getStartLineNumber(r.originalStart),R=o.getStartColumn(r.originalStart),j=o.getEndLineNumber(r.originalStart+r.originalLength-1),D=o.getEndColumn(r.originalStart+r.originalLength-1),M=c.getStartLineNumber(r.modifiedStart),S=c.getStartColumn(r.modifiedStart),y=c.getEndLineNumber(r.modifiedStart+r.modifiedLength-1),F=c.getEndColumn(r.modifiedStart+r.modifiedLength-1);return new b(T,R,j,D,M,S,y,F)}}function L(u){if(u.length<=1)return u;const r=[u[0]];let o=r[0];for(let c=1,T=u.length;c<T;c++){const R=u[c],j=R.originalStart-(o.originalStart+o.originalLength),D=R.modifiedStart-(o.modifiedStart+o.modifiedLength);Math.min(j,D)<f?(o.originalLength=R.originalStart+R.originalLength-o.originalStart,o.modifiedLength=R.modifiedStart+R.modifiedLength-o.modifiedStart):(r.push(R),o=R)}return r}class _{constructor(r,o,c,T,R){this.originalStartLineNumber=r,this.originalEndLineNumber=o,this.modifiedStartLineNumber=c,this.modifiedEndLineNumber=T,this.charChanges=R}static createFromDiffResult(r,o,c,T,R,j,D){let M,S,y,F,q;if(o.originalLength===0?(M=c.getStartLineNumber(o.originalStart)-1,S=0):(M=c.getStartLineNumber(o.originalStart),S=c.getEndLineNumber(o.originalStart+o.originalLength-1)),o.modifiedLength===0?(y=T.getStartLineNumber(o.modifiedStart)-1,F=0):(y=T.getStartLineNumber(o.modifiedStart),F=T.getEndLineNumber(o.modifiedStart+o.modifiedLength-1)),j&&o.originalLength>0&&o.originalLength<20&&o.modifiedLength>0&&o.modifiedLength<20&&R()){const X=c.createCharSequence(r,o.originalStart,o.originalStart+o.originalLength-1),B=T.createCharSequence(r,o.modifiedStart,o.modifiedStart+o.modifiedLength-1);if(X.getElements().length>0&&B.getElements().length>0){let P=m(X,B,R,!0).changes;D&&(P=L(P)),q=[];for(let Y=0,Q=P.length;Y<Q;Y++)q.push(b.createFromDiffChange(P[Y],X,B))}}return new _(M,S,y,F,q)}}class A{constructor(r,o,c){this.a=c.shouldComputeCharChanges,this.b=c.shouldPostProcessCharChanges,this.d=c.shouldIgnoreTrimWhitespace,this.e=c.shouldMakePrettyDiff,this.f=r,this.g=o,this.h=new N(r),this.j=new N(o),this.k=h(c.maxComputationTime),this.l=h(c.maxComputationTime===0?0:Math.min(c.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const r=m(this.h,this.j,this.k,this.e),o=r.changes,c=r.quitEarly;if(this.d){const D=[];for(let M=0,S=o.length;M<S;M++)D.push(_.createFromDiffResult(this.d,o[M],this.h,this.j,this.l,this.a,this.b));return{quitEarly:c,changes:D}}const T=[];let R=0,j=0;for(let D=-1,M=o.length;D<M;D++){const S=D+1<M?o[D+1]:null,y=S?S.originalStart:this.f.length,F=S?S.modifiedStart:this.g.length;for(;R<y&&j<F;){const q=this.f[R],X=this.g[j];if(q!==X){{let B=E(q,1),P=E(X,1);for(;B>1&&P>1;){const Y=q.charCodeAt(B-2),Q=X.charCodeAt(P-2);if(Y!==Q)break;B--,P--}(B>1||P>1)&&this.m(T,R+1,1,B,j+1,1,P)}{let B=v(q,1),P=v(X,1);const Y=q.length+1,Q=X.length+1;for(;B<Y&&P<Q;){const H=q.charCodeAt(B-1),K=q.charCodeAt(P-1);if(H!==K)break;B++,P++}(B<Y||P<Q)&&this.m(T,R+1,B,Y,j+1,P,Q)}}R++,j++}S&&(T.push(_.createFromDiffResult(this.d,S,this.h,this.j,this.l,this.a,this.b)),R+=S.originalLength,j+=S.modifiedLength)}return{quitEarly:c,changes:T}}m(r,o,c,T,R,j,D){if(this.n(r,o,c,T,R,j,D))return;let M;this.a&&(M=[new b(o,c,o,T,R,j,R,D)]),r.push(new _(o,o,R,R,M))}n(r,o,c,T,R,j,D){const M=r.length;if(M===0)return!1;const S=r[M-1];return S.originalEndLineNumber===0||S.modifiedEndLineNumber===0?!1:S.originalEndLineNumber===o&&S.modifiedEndLineNumber===R?(this.a&&S.charChanges&&S.charChanges.push(new b(o,c,o,T,R,j,R,D)),!0):S.originalEndLineNumber+1===o&&S.modifiedEndLineNumber+1===R?(S.originalEndLineNumber=o,S.modifiedEndLineNumber=R,this.a&&S.charChanges&&S.charChanges.push(new b(o,c,o,T,R,j,R,D)),!0):!1}}i.$_t=A;function E(u,r){const o=w.$wf(u);return o===-1?r:o+1}function v(u,r){const o=w.$yf(u);return o===-1?r:o+2}function h(u){if(u===0)return()=>!0;const r=Date.now();return()=>Date.now()-r<u}}),ne(ie[59],re([0,1,36,58]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$W4=void 0,i.$W4={getLegacy:()=>new t.$$t,getDefault:()=>new n.$T4}}),ne(ie[60],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$tu=i.MetadataConsts=i.StandardTokenType=i.ColorId=i.FontStyle=i.LanguageId=void 0;var t;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(t||(i.LanguageId=t={}));var n;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(n||(i.FontStyle=n={}));var p;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(p||(i.ColorId=p={}));var g;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(g||(i.StandardTokenType=g={}));var w;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",a[a.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(w||(i.MetadataConsts=w={}));class d{static getLanguageId(l){return(l&w.LANGUAGEID_MASK)>>>w.LANGUAGEID_OFFSET}static getTokenType(l){return(l&w.TOKEN_TYPE_MASK)>>>w.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&w.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&w.FONT_STYLE_MASK)>>>w.FONT_STYLE_OFFSET}static getForeground(l){return(l&w.FOREGROUND_MASK)>>>w.FOREGROUND_OFFSET}static getBackground(l){return(l&w.BACKGROUND_MASK)>>>w.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let $="mtk"+this.getForeground(l);const m=this.getFontStyle(l);return m&n.Italic&&($+=" mtki"),m&n.Bold&&($+=" mtkb"),m&n.Underline&&($+=" mtku"),m&n.Strikethrough&&($+=" mtks"),$}static getInlineStyleFromMetadata(l,f){const $=this.getForeground(l),m=this.getFontStyle(l);let N=`color: ${f[$]};`;m&n.Italic&&(N+="font-style: italic;"),m&n.Bold&&(N+="font-weight: bold;");let e="";return m&n.Underline&&(e+=" underline"),m&n.Strikethrough&&(e+=" line-through"),e&&(N+=`text-decoration:${e};`),N}static getPresentationFromMetadata(l){const f=this.getForeground(l),$=this.getFontStyle(l);return{foreground:f,italic:!!($&n.Italic),bold:!!($&n.Bold),underline:!!($&n.Underline),strikethrough:!!($&n.Strikethrough)}}}i.$tu=d}),ne(ie[61],re([0,1,38]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$X4=$;function n(m){const N=[];for(const e of m){const b=Number(e);(b||b===0&&e.replace(/\s/g,"")!=="")&&N.push(b)}return N}function p(m,N,e,b){return{red:m/255,blue:e/255,green:N/255,alpha:b}}function g(m,N){const e=N.index,b=N[0].length;if(!e)return;const L=m.positionAt(e);return{startLineNumber:L.lineNumber,startColumn:L.column,endLineNumber:L.lineNumber,endColumn:L.column+b}}function w(m,N){if(!m)return;const e=t.$mu.Format.CSS.parseHex(N);if(e)return{range:m,color:p(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function d(m,N,e){if(!m||N.length!==1)return;const L=N[0].values(),_=n(L);return{range:m,color:p(_[0],_[1],_[2],e?_[3]:1)}}function a(m,N,e){if(!m||N.length!==1)return;const L=N[0].values(),_=n(L),A=new t.$mu(new t.$ku(_[0],_[1]/100,_[2]/100,e?_[3]:1));return{range:m,color:p(A.rgba.r,A.rgba.g,A.rgba.b,A.rgba.a)}}function l(m,N){return typeof m=="string"?[...m.matchAll(N)]:m.findMatches(N)}function f(m){const N=[],b=l(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(b.length>0)for(const L of b){const _=L.filter(h=>h!==void 0),A=_[1],E=_[2];if(!E)continue;let v;if(A==="rgb"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;v=d(g(m,L),l(E,h),!1)}else if(A==="rgba"){const h=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;v=d(g(m,L),l(E,h),!0)}else if(A==="hsl"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;v=a(g(m,L),l(E,h),!1)}else if(A==="hsla"){const h=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;v=a(g(m,L),l(E,h),!0)}else A==="#"&&(v=w(g(m,L),A+E));v&&N.push(v)}return N}function $(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:f(m)}}),ne(ie[62],re([0,1,3,30]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$w4=i.$v4=i.State=void 0,i.$x4=N;var p;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(p||(i.State=p={}));class g{constructor(b,L,_){const A=new Uint8Array(b*L);for(let E=0,v=b*L;E<v;E++)A[E]=_;this.a=A,this.rows=b,this.cols=L}get(b,L){return this.a[b*this.cols+L]}set(b,L,_){this.a[b*this.cols+L]=_}}class w{constructor(b){let L=0,_=p.Invalid;for(let E=0,v=b.length;E<v;E++){const[h,u,r]=b[E];u>L&&(L=u),h>_&&(_=h),r>_&&(_=r)}L++,_++;const A=new g(_,L,p.Invalid);for(let E=0,v=b.length;E<v;E++){const[h,u,r]=b[E];A.set(h,u,r)}this.a=A,this.b=L}nextState(b,L){return L<0||L>=this.b?p.Invalid:this.a.get(b,L)}}i.$v4=w;let d=null;function a(){return d===null&&(d=new w([[p.Start,t.CharCode.h,p.H],[p.Start,t.CharCode.H,p.H],[p.Start,t.CharCode.f,p.F],[p.Start,t.CharCode.F,p.F],[p.H,t.CharCode.t,p.HT],[p.H,t.CharCode.T,p.HT],[p.HT,t.CharCode.t,p.HTT],[p.HT,t.CharCode.T,p.HTT],[p.HTT,t.CharCode.p,p.HTTP],[p.HTT,t.CharCode.P,p.HTTP],[p.HTTP,t.CharCode.s,p.BeforeColon],[p.HTTP,t.CharCode.S,p.BeforeColon],[p.HTTP,t.CharCode.Colon,p.AfterColon],[p.F,t.CharCode.i,p.FI],[p.F,t.CharCode.I,p.FI],[p.FI,t.CharCode.l,p.FIL],[p.FI,t.CharCode.L,p.FIL],[p.FIL,t.CharCode.e,p.BeforeColon],[p.FIL,t.CharCode.E,p.BeforeColon],[p.BeforeColon,t.CharCode.Colon,p.AfterColon],[p.AfterColon,t.CharCode.Slash,p.AlmostThere],[p.AlmostThere,t.CharCode.Slash,p.End]])),d}var l;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let f=null;function $(){if(f===null){f=new n.$fu(l.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<e.length;L++)f.set(e.charCodeAt(L),l.ForceTermination);const b=".,;:";for(let L=0;L<b.length;L++)f.set(b.charCodeAt(L),l.CannotEndIn)}return f}class m{static a(b,L,_,A,E){let v=E-1;do{const h=L.charCodeAt(v);if(b.get(h)!==l.CannotEndIn)break;v--}while(v>A);if(A>0){const h=L.charCodeAt(A-1),u=L.charCodeAt(v);(h===t.CharCode.OpenParen&&u===t.CharCode.CloseParen||h===t.CharCode.OpenSquareBracket&&u===t.CharCode.CloseSquareBracket||h===t.CharCode.OpenCurlyBrace&&u===t.CharCode.CloseCurlyBrace)&&v--}return{range:{startLineNumber:_,startColumn:A+1,endLineNumber:_,endColumn:v+2},url:L.substring(A,v+1)}}static computeLinks(b,L=a()){const _=$(),A=[];for(let E=1,v=b.getLineCount();E<=v;E++){const h=b.getLineContent(E),u=h.length;let r=0,o=0,c=0,T=p.Start,R=!1,j=!1,D=!1,M=!1;for(;r<u;){let S=!1;const y=h.charCodeAt(r);if(T===p.Accept){let F;switch(y){case t.CharCode.OpenParen:R=!0,F=l.None;break;case t.CharCode.CloseParen:F=R?l.None:l.ForceTermination;break;case t.CharCode.OpenSquareBracket:D=!0,j=!0,F=l.None;break;case t.CharCode.CloseSquareBracket:D=!1,F=j?l.None:l.ForceTermination;break;case t.CharCode.OpenCurlyBrace:M=!0,F=l.None;break;case t.CharCode.CloseCurlyBrace:F=M?l.None:l.ForceTermination;break;case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.BackTick:c===y?F=l.ForceTermination:c===t.CharCode.SingleQuote||c===t.CharCode.DoubleQuote||c===t.CharCode.BackTick?F=l.None:F=l.ForceTermination;break;case t.CharCode.Asterisk:F=c===t.CharCode.Asterisk?l.ForceTermination:l.None;break;case t.CharCode.Pipe:F=c===t.CharCode.Pipe?l.ForceTermination:l.None;break;case t.CharCode.Space:F=D?l.None:l.ForceTermination;break;default:F=_.get(y)}F===l.ForceTermination&&(A.push(m.a(_,h,E,o,r)),S=!0)}else if(T===p.End){let F;y===t.CharCode.OpenSquareBracket?(j=!0,F=l.None):F=_.get(y),F===l.ForceTermination?S=!0:T=p.Accept}else T=L.nextState(T,y),T===p.Invalid&&(S=!0);S&&(T=p.Start,R=!1,j=!1,M=!1,o=r+1,c=y),r++}T===p.Accept&&A.push(m.a(_,h,E,o,u))}return A}}i.$w4=m;function N(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:m.computeLinks(e)}}),ne(ie[63],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$y4=void 0;class t{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(p,g,w,d,a){if(p&&g){const l=this.a(g,a);if(l)return{range:p,value:l}}if(w&&d){const l=this.a(d,a);if(l)return{range:w,value:l}}return null}a(p,g){const w=this.b(p,g);return w!==null?w:this.d(p,g)}b(p,g){const w=Math.pow(10,p.length-(p.lastIndexOf(".")+1));let d=Number(p);const a=parseFloat(p);return!isNaN(d)&&!isNaN(a)&&d===a?d===0&&!g?null:(d=Math.floor(d*w),d+=g?w:-w,String(d/w)):null}d(p,g){return this.e(this.c,p,g)}e(p,g,w){let d=null;for(let a=0,l=p.length;d===null&&a<l;a++)d=this.f(p[a],g,w);return d}f(p,g,w){let d=p.indexOf(g);return d>=0?(d+=w?1:-1,d<0?d=p.length-1:d%=p.length,p[d]):null}}i.$y4=t,t.INSTANCE=new t}),ne(ie[64],re([0,1,18]),function(x,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gw=i.$fw=i.$ew=i.ModelConstants=i.PositionAffinity=i.TrackedRangeStickiness=i.$cw=i.$bw=i.EndOfLineSequence=i.DefaultEndOfLine=i.EndOfLinePreference=i.InjectedTextCursorStops=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.GlyphMarginLane=i.OverviewRulerLane=void 0,i.$dw=e,i.$hw=v;var n;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(n||(i.OverviewRulerLane=n={}));var p;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=3]="Right"})(p||(i.GlyphMarginLane=p={}));var g;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(g||(i.MinimapPosition=g={}));var w;(function(h){h[h.Normal=1]="Normal",h[h.Underlined=2]="Underlined"})(w||(i.MinimapSectionHeaderStyle=w={}));var d;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(d||(i.InjectedTextCursorStops=d={}));var a;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(a||(i.EndOfLinePreference=a={}));var l;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(l||(i.DefaultEndOfLine=l={}));var f;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(f||(i.EndOfLineSequence=f={}));class ${get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,t.$jo)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}i.$bw=$;class m{constructor(u,r){this._findMatchBrand=void 0,this.range=u,this.matches=r}}i.$cw=m;var N;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(N||(i.TrackedRangeStickiness=N={}));function e(h){return h&&typeof h.read=="function"}var b;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(b||(i.PositionAffinity=b={}));var L;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(L||(i.ModelConstants=L={}));class _{constructor(u,r,o,c,T,R){this.identifier=u,this.range=r,this.text=o,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=T,this._isTracked=R}}i.$ew=_;class A{constructor(u,r,o){this.regex=u,this.wordSeparators=r,this.simpleSearch=o}}i.$fw=A;class E{constructor(u,r,o){this.reverseEdits=u,this.changes=r,this.trimAutoWhitespaceLineNumbers=o}}i.$gw=E;function v(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}}),ne(ie[65],re([0,1,7,14]),function(x,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$mw=i.$lw=i.$kw=void 0;class p{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,l){a=(0,n.$df)(a);const f=this.a,$=this.b,m=l.length;return m===0?!1:(this.a=new Uint32Array(f.length+m),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a),a+m),this.a.set(l,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}setValue(a,l){return a=(0,n.$df)(a),l=(0,n.$df)(l),this.a[a]===l?!1:(this.a[a]=l,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,l){a=(0,n.$df)(a),l=(0,n.$df)(l);const f=this.a,$=this.b;if(a>=f.length)return!1;const m=f.length-a;return l>=m&&(l=m),l===0?!1:(this.a=new Uint32Array(f.length-l),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a+l),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,n.$df)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),a>=this.a.length&&(a=this.a.length-1);for(let f=l;f<=a;f++)this.b[f]=this.b[f-1]+this.a[f];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let l=0,f=this.a.length-1,$=0,m=0,N=0;for(;l<=f;)if($=l+(f-l)/2|0,m=this.b[$],N=m-this.a[$],a<N)f=$-1;else if(a>=m)l=$+1;else break;return new w($,a-N)}}i.$kw=p;class g{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const l=this.e[a],f=l>0?this.d[l-1]:0;return new w(l,a-f)}removeValues(a,l){this.a.splice(a,l),this.f(a)}insertValues(a,l){this.a=(0,t.$Yb)(this.a,a,l),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,l=this.a.length;a<l;a++){const f=this.a[a],$=a>0?this.d[a-1]:0;this.d[a]=$+f;for(let m=0;m<f;m++)this.e[$+m]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,l){this.a[a]!==l&&(this.a[a]=l,this.f(a))}}i.$lw=g;class w{constructor(a,l){this.index=a,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=l}}i.$mw=w}),ne(ie[66],re([0,1,8,5,65]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$nw=void 0;class g{constructor(d,a,l,f){this.d=d,this.f=a,this.g=l,this.h=f,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(d){d.eol&&d.eol!==this.g&&(this.g=d.eol,this.j=null);const a=d.changes;for(const l of a)this.o(l.range),this.p(new n.$Mt(l.range.startLineNumber,l.range.startColumn),l.text);this.h=d.versionId,this.k=null}l(){if(!this.j){const d=this.g.length,a=this.f.length,l=new Uint32Array(a);for(let f=0;f<a;f++)l[f]=this.f[f].length+d;this.j=new p.$kw(l)}}n(d,a){this.f[d]=a,this.j&&this.j.setValue(d,this.f[d].length+this.g.length)}o(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.startLineNumber-1].substring(d.endColumn-1));return}this.n(d.startLineNumber-1,this.f[d.startLineNumber-1].substring(0,d.startColumn-1)+this.f[d.endLineNumber-1].substring(d.endColumn-1)),this.f.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this.j&&this.j.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}p(d,a){if(a.length===0)return;const l=(0,t.$uf)(a);if(l.length===1){this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+l[0]+this.f[d.lineNumber-1].substring(d.column-1));return}l[l.length-1]+=this.f[d.lineNumber-1].substring(d.column-1),this.n(d.lineNumber-1,this.f[d.lineNumber-1].substring(0,d.column-1)+l[0]);const f=new Uint32Array(l.length-1);for(let $=1;$<l.length;$++)this.f.splice(d.lineNumber+$-1,0,l[$]),f[$-1]=l[$].length+this.g.length;this.j&&this.j.insertValues(d.lineNumber,f)}}i.$nw=g}),ne(ie[67],re([0,1,3,8,53,5,2,64]),function(x,i,t,n,p,g,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gD=i.$eD=i.$bD=void 0,i.$cD=f,i.$dD=$,i.$fD=L,n=ye(n);const a=999;class l{constructor(E,v,h,u){this.searchString=E,this.isRegex=v,this.matchCase=h,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let E;this.isRegex?E=f(this.searchString):E=this.searchString.indexOf(`
`)>=0;let v=null;try{v=n.$sf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:E,global:!0,unicode:!0})}catch{return null}if(!v)return null;let h=!this.isRegex&&!E;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new d.$fw(v,this.wordSeparators?(0,p.$iu)(this.wordSeparators,[]):null,h?this.searchString:null)}}i.$bD=l;function f(A){if(!A||A.length===0)return!1;for(let E=0,v=A.length;E<v;E++){const h=A.charCodeAt(E);if(h===t.CharCode.LineFeed)return!0;if(h===t.CharCode.Backslash){if(E++,E>=v)break;const u=A.charCodeAt(E);if(u===t.CharCode.n||u===t.CharCode.r||u===t.CharCode.W)return!0}}return!1}function $(A,E,v){if(!v)return new d.$cw(A,null);const h=[];for(let u=0,r=E.length;u<r;u++)h[u]=E[u];return new d.$cw(A,h)}class m{constructor(E){const v=[];let h=0;for(let u=0,r=E.length;u<r;u++)E.charCodeAt(u)===t.CharCode.LineFeed&&(v[h++]=u);this.a=v}findLineFeedCountBeforeOffset(E){const v=this.a;let h=0,u=v.length-1;if(u===-1||E<=v[0])return 0;for(;h<u;){const r=h+((u-h)/2>>0);v[r]>=E?u=r-1:v[r+1]>=E?(h=r,u=r):h=r+1}return h+1}}class N{static findMatches(E,v,h,u,r){const o=v.parseSearchRequest();return o?o.regex.multiline?this.b(E,h,new _(o.wordSeparators,o.regex),u,r):this.c(E,h,o,u,r):[]}static a(E,v,h,u,r,o){let c,T=0;u?(T=u.findLineFeedCountBeforeOffset(r),c=v+r+T):c=v+r;let R;if(u){const S=u.findLineFeedCountBeforeOffset(r+o.length)-T;R=c+o.length+S}else R=c+o.length;const j=E.getPositionAt(c),D=E.getPositionAt(R);return new w.$Nt(j.lineNumber,j.column,D.lineNumber,D.column)}static b(E,v,h,u,r){const o=E.getOffsetAt(v.getStartPosition()),c=E.getValueInRange(v,d.EndOfLinePreference.LF),T=E.getEOL()===`\r
`?new m(c):null,R=[];let j=0,D;for(h.reset(0);D=h.next(c);)if(R[j++]=$(this.a(E,o,c,T,D.index,D[0]),D,u),j>=r)return R;return R}static c(E,v,h,u,r){const o=[];let c=0;if(v.startLineNumber===v.endLineNumber){const R=E.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return c=this.d(h,R,v.startLineNumber,v.startColumn-1,c,o,u,r),o}const T=E.getLineContent(v.startLineNumber).substring(v.startColumn-1);c=this.d(h,T,v.startLineNumber,v.startColumn-1,c,o,u,r);for(let R=v.startLineNumber+1;R<v.endLineNumber&&c<r;R++)c=this.d(h,E.getLineContent(R),R,0,c,o,u,r);if(c<r){const R=E.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);c=this.d(h,R,v.endLineNumber,0,c,o,u,r)}return o}static d(E,v,h,u,r,o,c,T){const R=E.wordSeparators;if(!c&&E.simpleSearch){const M=E.simpleSearch,S=M.length,y=v.length;let F=-S;for(;(F=v.indexOf(M,F+S))!==-1;)if((!R||L(R,v,y,F,S))&&(o[r++]=new d.$cw(new w.$Nt(h,F+1+u,h,F+1+S+u),null),r>=T))return r;return r}const j=new _(E.wordSeparators,E.regex);let D;j.reset(0);do if(D=j.next(v),D&&(o[r++]=$(new w.$Nt(h,D.index+1+u,h,D.index+1+D[0].length+u),D,c),r>=T))return r;while(D);return r}static findNextMatch(E,v,h,u){const r=v.parseSearchRequest();if(!r)return null;const o=new _(r.wordSeparators,r.regex);return r.regex.multiline?this.e(E,h,o,u):this.f(E,h,o,u)}static e(E,v,h,u){const r=new g.$Mt(v.lineNumber,1),o=E.getOffsetAt(r),c=E.getLineCount(),T=E.getValueInRange(new w.$Nt(r.lineNumber,r.column,c,E.getLineMaxColumn(c)),d.EndOfLinePreference.LF),R=E.getEOL()===`\r
`?new m(T):null;h.reset(v.column-1);const j=h.next(T);return j?$(this.a(E,o,T,R,j.index,j[0]),j,u):v.lineNumber!==1||v.column!==1?this.e(E,new g.$Mt(1,1),h,u):null}static f(E,v,h,u){const r=E.getLineCount(),o=v.lineNumber,c=E.getLineContent(o),T=this.g(h,c,o,v.column,u);if(T)return T;for(let R=1;R<=r;R++){const j=(o+R-1)%r,D=E.getLineContent(j+1),M=this.g(h,D,j+1,1,u);if(M)return M}return null}static g(E,v,h,u,r){E.reset(u-1);const o=E.next(v);return o?$(new w.$Nt(h,o.index+1,h,o.index+1+o[0].length),o,r):null}static findPreviousMatch(E,v,h,u){const r=v.parseSearchRequest();if(!r)return null;const o=new _(r.wordSeparators,r.regex);return r.regex.multiline?this.h(E,h,o,u):this.j(E,h,o,u)}static h(E,v,h,u){const r=this.b(E,new w.$Nt(1,1,v.lineNumber,v.column),h,u,10*a);if(r.length>0)return r[r.length-1];const o=E.getLineCount();return v.lineNumber!==o||v.column!==E.getLineMaxColumn(o)?this.h(E,new g.$Mt(o,E.getLineMaxColumn(o)),h,u):null}static j(E,v,h,u){const r=E.getLineCount(),o=v.lineNumber,c=E.getLineContent(o).substring(0,v.column-1),T=this.k(h,c,o,u);if(T)return T;for(let R=1;R<=r;R++){const j=(r+o-R-1)%r,D=E.getLineContent(j+1),M=this.k(h,D,j+1,u);if(M)return M}return null}static k(E,v,h,u){let r=null,o;for(E.reset(0);o=E.next(v);)r=$(new w.$Nt(h,o.index+1,h,o.index+1+o[0].length),o,u);return r}}i.$eD=N;function e(A,E,v,h,u){if(h===0)return!0;const r=E.charCodeAt(h-1);if(A.get(r)!==p.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(u>0){const o=E.charCodeAt(h);if(A.get(o)!==p.WordCharacterClass.Regular)return!0}return!1}function b(A,E,v,h,u){if(h+u===v)return!0;const r=E.charCodeAt(h+u);if(A.get(r)!==p.WordCharacterClass.Regular||r===t.CharCode.CarriageReturn||r===t.CharCode.LineFeed)return!0;if(u>0){const o=E.charCodeAt(h+u-1);if(A.get(o)!==p.WordCharacterClass.Regular)return!0}return!1}function L(A,E,v,h,u){return e(A,E,v,h,u)&&b(A,E,v,h,u)}class _{constructor(E,v){this._wordSeparators=E,this.a=v,this.b=-1,this.c=0}reset(E){this.a.lastIndex=E,this.b=-1,this.c=0}next(E){const v=E.length;let h;do{if(this.b+this.c===v||(h=this.a.exec(E),!h))return null;const u=h.index,r=h[0].length;if(u===this.b&&r===this.c){if(r===0){n.$Of(E,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=r,!this._wordSeparators||L(this._wordSeparators,E,v,u,r))return h}while(h);return null}}i.$gD=_}),ne(ie[68],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Y4=p;const t=new RegExp("\\bMARK:\\s*(.*)$","d"),n=/^-+|-+$/g;function p(l,f){let $=[];if(f.findRegionSectionHeaders&&f.foldingRules?.markers){const m=g(l,f);$=$.concat(m)}if(f.findMarkSectionHeaders){const m=w(l);$=$.concat(m)}return $}function g(l,f){const $=[],m=l.getLineCount();for(let N=1;N<=m;N++){const e=l.getLineContent(N),b=e.match(f.foldingRules.markers.start);if(b){const L={startLineNumber:N,startColumn:b[0].length+1,endLineNumber:N,endColumn:e.length+1};if(L.endColumn>L.startColumn){const _={range:L,...a(e.substring(b[0].length)),shouldBeInComments:!1};(_.text||_.hasSeparatorLine)&&$.push(_)}}}return $}function w(l){const f=[],$=l.getLineCount();for(let m=1;m<=$;m++){const N=l.getLineContent(m);d(N,m,f)}return f}function d(l,f,$){t.lastIndex=0;const m=t.exec(l);if(m){const N=m.indices[1][0]+1,e=m.indices[1][1]+1,b={startLineNumber:f,startColumn:N,endLineNumber:f,endColumn:e};if(b.endColumn>b.startColumn){const L={range:b,...a(m[1]),shouldBeInComments:!0};(L.text||L.hasSeparatorLine)&&$.push(L)}}}function a(l){l=l.trim();const f=l.startsWith("-");return l=l.replace(n,""),{text:l,hasSeparatorLine:f}}}),ne(ie[69],re([0,1,2,67,8,11,32]),function(x,i,t,n,p,g,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeHighlighterReasonKind=i.$u4=void 0,p=ye(p);class d{static computeUnicodeHighlights(e,b,L){const _=L?L.startLineNumber:1,A=L?L.endLineNumber:e.getLineCount(),E=new f(b),v=E.getCandidateCodePoints();let h;v==="allNonBasicAscii"?h=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):h=new RegExp(`${a(Array.from(v))}`,"g");const u=new n.$gD(null,h),r=[];let o=!1,c,T=0,R=0,j=0;e:for(let D=_,M=A;D<=M;D++){const S=e.getLineContent(D),y=S.length;u.reset(0);do if(c=u.next(S),c){let F=c.index,q=c.index+c[0].length;if(F>0){const Y=S.charCodeAt(F-1);p.$Lf(Y)&&F--}if(q+1<y){const Y=S.charCodeAt(q-1);p.$Lf(Y)&&q++}const X=S.substring(F,q);let B=(0,w.$pt)(F+1,w.$mt,S,0);B&&B.endColumn<=F+1&&(B=null);const P=E.shouldHighlightNonBasicASCII(X,B?B.word:null);if(P!==m.None){if(P===m.Ambiguous?T++:P===m.Invisible?R++:P===m.NonBasicASCII?j++:(0,g.$hd)(P),r.length>=1e3){o=!0;break e}r.push(new t.$Nt(D,F+1,D,q+1))}}while(c)}return{ranges:r,hasMore:o,ambiguousCharacterCount:T,invisibleCharacterCount:R,nonBasicAsciiCharacterCount:j}}static computeUnicodeHighlightReason(e,b){const L=new f(b);switch(L.shouldHighlightNonBasicASCII(e,null)){case m.None:return null;case m.Invisible:return{kind:l.Invisible};case m.Ambiguous:{const A=e.codePointAt(0),E=L.ambiguousCharacters.getPrimaryConfusable(A),v=p.$eg.getLocales().filter(h=>!p.$eg.getInstance(new Set([...b.allowedLocales,h])).isAmbiguous(A));return{kind:l.Ambiguous,confusableWith:String.fromCodePoint(E),notAmbiguousInLocales:v}}case m.NonBasicASCII:return{kind:l.NonBasicAscii}}}}i.$u4=d;function a(N,e){return`[${p.$jf(N.map(L=>String.fromCodePoint(L)).join(""))}]`}var l;(function(N){N[N.Ambiguous=0]="Ambiguous",N[N.Invisible=1]="Invisible",N[N.NonBasicAscii=2]="NonBasicAscii"})(l||(i.UnicodeHighlighterReasonKind=l={}));class f{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=p.$eg.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const b of p.$fg.codePoints)$(String.fromCodePoint(b))||e.add(b);if(this.b.ambiguousCharacters)for(const b of this.ambiguousCharacters.getConfusableCodePoints())e.add(b);for(const b of this.a)e.delete(b);return e}shouldHighlightNonBasicASCII(e,b){const L=e.codePointAt(0);if(this.a.has(L))return m.None;if(this.b.nonBasicASCII)return m.NonBasicASCII;let _=!1,A=!1;if(b)for(const E of b){const v=E.codePointAt(0),h=p.$Wf(E);_=_||h,!h&&!this.ambiguousCharacters.isAmbiguous(v)&&!p.$fg.isInvisibleCharacter(v)&&(A=!0)}return!_&&A?m.None:this.b.invisibleCharacters&&!$(e)&&p.$fg.isInvisibleCharacter(L)?m.Invisible:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(L)?m.Ambiguous:m.None}}function $(N){return N===" "||N===`
`||N==="	"}var m;(function(N){N[N.None=0]="None",N[N.NonBasicASCII=1]="NonBasicASCII",N[N.Invisible=2]="Invisible",N[N.Ambiguous=3]="Ambiguous"})(m||(m={}))}),ne(ie[70],re([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.ShowLightbulbIconMode=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.PartialAcceptTriggerKind=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.MouseTargetType=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineEditTriggerKind=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.HoverVerbosityAction=i.GlyphMarginLane=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var t;(function(s){s[s.Unknown=0]="Unknown",s[s.Disabled=1]="Disabled",s[s.Enabled=2]="Enabled"})(t||(i.AccessibilitySupport=t={}));var n;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(n||(i.CodeActionTriggerType=n={}));var p;(function(s){s[s.None=0]="None",s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(p||(i.CompletionItemInsertTextRule=p={}));var g;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(g||(i.CompletionItemKind=g={}));var w;(function(s){s[s.Deprecated=1]="Deprecated"})(w||(i.CompletionItemTag=w={}));var d;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(i.CompletionTriggerKind=d={}));var a;(function(s){s[s.EXACT=0]="EXACT",s[s.ABOVE=1]="ABOVE",s[s.BELOW=2]="BELOW"})(a||(i.ContentWidgetPositionPreference=a={}));var l;(function(s){s[s.NotSet=0]="NotSet",s[s.ContentFlush=1]="ContentFlush",s[s.RecoverFromMarkers=2]="RecoverFromMarkers",s[s.Explicit=3]="Explicit",s[s.Paste=4]="Paste",s[s.Undo=5]="Undo",s[s.Redo=6]="Redo"})(l||(i.CursorChangeReason=l={}));var f;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(f||(i.DefaultEndOfLine=f={}));var $;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})($||(i.DocumentHighlightKind=$={}));var m;(function(s){s[s.None=0]="None",s[s.Keep=1]="Keep",s[s.Brackets=2]="Brackets",s[s.Advanced=3]="Advanced",s[s.Full=4]="Full"})(m||(i.EditorAutoIndentStrategy=m={}));var N;(function(s){s[s.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",s[s.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",s[s.accessibilitySupport=2]="accessibilitySupport",s[s.accessibilityPageSize=3]="accessibilityPageSize",s[s.ariaLabel=4]="ariaLabel",s[s.ariaRequired=5]="ariaRequired",s[s.autoClosingBrackets=6]="autoClosingBrackets",s[s.autoClosingComments=7]="autoClosingComments",s[s.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",s[s.autoClosingDelete=9]="autoClosingDelete",s[s.autoClosingOvertype=10]="autoClosingOvertype",s[s.autoClosingQuotes=11]="autoClosingQuotes",s[s.autoIndent=12]="autoIndent",s[s.automaticLayout=13]="automaticLayout",s[s.autoSurround=14]="autoSurround",s[s.bracketPairColorization=15]="bracketPairColorization",s[s.guides=16]="guides",s[s.codeLens=17]="codeLens",s[s.codeLensFontFamily=18]="codeLensFontFamily",s[s.codeLensFontSize=19]="codeLensFontSize",s[s.colorDecorators=20]="colorDecorators",s[s.colorDecoratorsLimit=21]="colorDecoratorsLimit",s[s.columnSelection=22]="columnSelection",s[s.comments=23]="comments",s[s.contextmenu=24]="contextmenu",s[s.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",s[s.cursorBlinking=26]="cursorBlinking",s[s.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",s[s.cursorStyle=28]="cursorStyle",s[s.cursorSurroundingLines=29]="cursorSurroundingLines",s[s.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",s[s.cursorWidth=31]="cursorWidth",s[s.disableLayerHinting=32]="disableLayerHinting",s[s.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",s[s.domReadOnly=34]="domReadOnly",s[s.dragAndDrop=35]="dragAndDrop",s[s.dropIntoEditor=36]="dropIntoEditor",s[s.emptySelectionClipboard=37]="emptySelectionClipboard",s[s.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",s[s.extraEditorClassName=39]="extraEditorClassName",s[s.fastScrollSensitivity=40]="fastScrollSensitivity",s[s.find=41]="find",s[s.fixedOverflowWidgets=42]="fixedOverflowWidgets",s[s.folding=43]="folding",s[s.foldingStrategy=44]="foldingStrategy",s[s.foldingHighlight=45]="foldingHighlight",s[s.foldingImportsByDefault=46]="foldingImportsByDefault",s[s.foldingMaximumRegions=47]="foldingMaximumRegions",s[s.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",s[s.fontFamily=49]="fontFamily",s[s.fontInfo=50]="fontInfo",s[s.fontLigatures=51]="fontLigatures",s[s.fontSize=52]="fontSize",s[s.fontWeight=53]="fontWeight",s[s.fontVariations=54]="fontVariations",s[s.formatOnPaste=55]="formatOnPaste",s[s.formatOnType=56]="formatOnType",s[s.glyphMargin=57]="glyphMargin",s[s.gotoLocation=58]="gotoLocation",s[s.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",s[s.hover=60]="hover",s[s.inDiffEditor=61]="inDiffEditor",s[s.inlineSuggest=62]="inlineSuggest",s[s.inlineEdit=63]="inlineEdit",s[s.letterSpacing=64]="letterSpacing",s[s.lightbulb=65]="lightbulb",s[s.lineDecorationsWidth=66]="lineDecorationsWidth",s[s.lineHeight=67]="lineHeight",s[s.lineNumbers=68]="lineNumbers",s[s.lineNumbersMinChars=69]="lineNumbersMinChars",s[s.linkedEditing=70]="linkedEditing",s[s.links=71]="links",s[s.matchBrackets=72]="matchBrackets",s[s.minimap=73]="minimap",s[s.mouseStyle=74]="mouseStyle",s[s.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",s[s.mouseWheelZoom=76]="mouseWheelZoom",s[s.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",s[s.multiCursorModifier=78]="multiCursorModifier",s[s.multiCursorPaste=79]="multiCursorPaste",s[s.multiCursorLimit=80]="multiCursorLimit",s[s.occurrencesHighlight=81]="occurrencesHighlight",s[s.overviewRulerBorder=82]="overviewRulerBorder",s[s.overviewRulerLanes=83]="overviewRulerLanes",s[s.padding=84]="padding",s[s.pasteAs=85]="pasteAs",s[s.parameterHints=86]="parameterHints",s[s.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",s[s.placeholder=88]="placeholder",s[s.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",s[s.quickSuggestions=90]="quickSuggestions",s[s.quickSuggestionsDelay=91]="quickSuggestionsDelay",s[s.readOnly=92]="readOnly",s[s.readOnlyMessage=93]="readOnlyMessage",s[s.renameOnType=94]="renameOnType",s[s.renderControlCharacters=95]="renderControlCharacters",s[s.renderFinalNewline=96]="renderFinalNewline",s[s.renderLineHighlight=97]="renderLineHighlight",s[s.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",s[s.renderValidationDecorations=99]="renderValidationDecorations",s[s.renderWhitespace=100]="renderWhitespace",s[s.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",s[s.roundedSelection=102]="roundedSelection",s[s.rulers=103]="rulers",s[s.scrollbar=104]="scrollbar",s[s.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",s[s.scrollBeyondLastLine=106]="scrollBeyondLastLine",s[s.scrollPredominantAxis=107]="scrollPredominantAxis",s[s.selectionClipboard=108]="selectionClipboard",s[s.selectionHighlight=109]="selectionHighlight",s[s.selectOnLineNumbers=110]="selectOnLineNumbers",s[s.showFoldingControls=111]="showFoldingControls",s[s.showUnused=112]="showUnused",s[s.snippetSuggestions=113]="snippetSuggestions",s[s.smartSelect=114]="smartSelect",s[s.smoothScrolling=115]="smoothScrolling",s[s.stickyScroll=116]="stickyScroll",s[s.stickyTabStops=117]="stickyTabStops",s[s.stopRenderingLineAfter=118]="stopRenderingLineAfter",s[s.suggest=119]="suggest",s[s.suggestFontSize=120]="suggestFontSize",s[s.suggestLineHeight=121]="suggestLineHeight",s[s.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",s[s.suggestSelection=123]="suggestSelection",s[s.tabCompletion=124]="tabCompletion",s[s.tabIndex=125]="tabIndex",s[s.unicodeHighlighting=126]="unicodeHighlighting",s[s.unusualLineTerminators=127]="unusualLineTerminators",s[s.useShadowDOM=128]="useShadowDOM",s[s.useTabStops=129]="useTabStops",s[s.wordBreak=130]="wordBreak",s[s.wordSegmenterLocales=131]="wordSegmenterLocales",s[s.wordSeparators=132]="wordSeparators",s[s.wordWrap=133]="wordWrap",s[s.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",s[s.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",s[s.wordWrapColumn=136]="wordWrapColumn",s[s.wordWrapOverride1=137]="wordWrapOverride1",s[s.wordWrapOverride2=138]="wordWrapOverride2",s[s.wrappingIndent=139]="wrappingIndent",s[s.wrappingStrategy=140]="wrappingStrategy",s[s.showDeprecated=141]="showDeprecated",s[s.inlayHints=142]="inlayHints",s[s.editorClassName=143]="editorClassName",s[s.pixelRatio=144]="pixelRatio",s[s.tabFocusMode=145]="tabFocusMode",s[s.layoutInfo=146]="layoutInfo",s[s.wrappingInfo=147]="wrappingInfo",s[s.defaultColorDecorators=148]="defaultColorDecorators",s[s.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",s[s.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(N||(i.EditorOption=N={}));var e;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(e||(i.EndOfLinePreference=e={}));var b;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(b||(i.EndOfLineSequence=b={}));var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(L||(i.GlyphMarginLane=L={}));var _;(function(s){s[s.Increase=0]="Increase",s[s.Decrease=1]="Decrease"})(_||(i.HoverVerbosityAction=_={}));var A;(function(s){s[s.None=0]="None",s[s.Indent=1]="Indent",s[s.IndentOutdent=2]="IndentOutdent",s[s.Outdent=3]="Outdent"})(A||(i.IndentAction=A={}));var E;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(E||(i.InjectedTextCursorStops=E={}));var v;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(v||(i.InlayHintKind=v={}));var h;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(h||(i.InlineCompletionTriggerKind=h={}));var u;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(u||(i.InlineEditTriggerKind=u={}));var r;(function(s){s[s.DependsOnKbLayout=-1]="DependsOnKbLayout",s[s.Unknown=0]="Unknown",s[s.Backspace=1]="Backspace",s[s.Tab=2]="Tab",s[s.Enter=3]="Enter",s[s.Shift=4]="Shift",s[s.Ctrl=5]="Ctrl",s[s.Alt=6]="Alt",s[s.PauseBreak=7]="PauseBreak",s[s.CapsLock=8]="CapsLock",s[s.Escape=9]="Escape",s[s.Space=10]="Space",s[s.PageUp=11]="PageUp",s[s.PageDown=12]="PageDown",s[s.End=13]="End",s[s.Home=14]="Home",s[s.LeftArrow=15]="LeftArrow",s[s.UpArrow=16]="UpArrow",s[s.RightArrow=17]="RightArrow",s[s.DownArrow=18]="DownArrow",s[s.Insert=19]="Insert",s[s.Delete=20]="Delete",s[s.Digit0=21]="Digit0",s[s.Digit1=22]="Digit1",s[s.Digit2=23]="Digit2",s[s.Digit3=24]="Digit3",s[s.Digit4=25]="Digit4",s[s.Digit5=26]="Digit5",s[s.Digit6=27]="Digit6",s[s.Digit7=28]="Digit7",s[s.Digit8=29]="Digit8",s[s.Digit9=30]="Digit9",s[s.KeyA=31]="KeyA",s[s.KeyB=32]="KeyB",s[s.KeyC=33]="KeyC",s[s.KeyD=34]="KeyD",s[s.KeyE=35]="KeyE",s[s.KeyF=36]="KeyF",s[s.KeyG=37]="KeyG",s[s.KeyH=38]="KeyH",s[s.KeyI=39]="KeyI",s[s.KeyJ=40]="KeyJ",s[s.KeyK=41]="KeyK",s[s.KeyL=42]="KeyL",s[s.KeyM=43]="KeyM",s[s.KeyN=44]="KeyN",s[s.KeyO=45]="KeyO",s[s.KeyP=46]="KeyP",s[s.KeyQ=47]="KeyQ",s[s.KeyR=48]="KeyR",s[s.KeyS=49]="KeyS",s[s.KeyT=50]="KeyT",s[s.KeyU=51]="KeyU",s[s.KeyV=52]="KeyV",s[s.KeyW=53]="KeyW",s[s.KeyX=54]="KeyX",s[s.KeyY=55]="KeyY",s[s.KeyZ=56]="KeyZ",s[s.Meta=57]="Meta",s[s.ContextMenu=58]="ContextMenu",s[s.F1=59]="F1",s[s.F2=60]="F2",s[s.F3=61]="F3",s[s.F4=62]="F4",s[s.F5=63]="F5",s[s.F6=64]="F6",s[s.F7=65]="F7",s[s.F8=66]="F8",s[s.F9=67]="F9",s[s.F10=68]="F10",s[s.F11=69]="F11",s[s.F12=70]="F12",s[s.F13=71]="F13",s[s.F14=72]="F14",s[s.F15=73]="F15",s[s.F16=74]="F16",s[s.F17=75]="F17",s[s.F18=76]="F18",s[s.F19=77]="F19",s[s.F20=78]="F20",s[s.F21=79]="F21",s[s.F22=80]="F22",s[s.F23=81]="F23",s[s.F24=82]="F24",s[s.NumLock=83]="NumLock",s[s.ScrollLock=84]="ScrollLock",s[s.Semicolon=85]="Semicolon",s[s.Equal=86]="Equal",s[s.Comma=87]="Comma",s[s.Minus=88]="Minus",s[s.Period=89]="Period",s[s.Slash=90]="Slash",s[s.Backquote=91]="Backquote",s[s.BracketLeft=92]="BracketLeft",s[s.Backslash=93]="Backslash",s[s.BracketRight=94]="BracketRight",s[s.Quote=95]="Quote",s[s.OEM_8=96]="OEM_8",s[s.IntlBackslash=97]="IntlBackslash",s[s.Numpad0=98]="Numpad0",s[s.Numpad1=99]="Numpad1",s[s.Numpad2=100]="Numpad2",s[s.Numpad3=101]="Numpad3",s[s.Numpad4=102]="Numpad4",s[s.Numpad5=103]="Numpad5",s[s.Numpad6=104]="Numpad6",s[s.Numpad7=105]="Numpad7",s[s.Numpad8=106]="Numpad8",s[s.Numpad9=107]="Numpad9",s[s.NumpadMultiply=108]="NumpadMultiply",s[s.NumpadAdd=109]="NumpadAdd",s[s.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",s[s.NumpadSubtract=111]="NumpadSubtract",s[s.NumpadDecimal=112]="NumpadDecimal",s[s.NumpadDivide=113]="NumpadDivide",s[s.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",s[s.ABNT_C1=115]="ABNT_C1",s[s.ABNT_C2=116]="ABNT_C2",s[s.AudioVolumeMute=117]="AudioVolumeMute",s[s.AudioVolumeUp=118]="AudioVolumeUp",s[s.AudioVolumeDown=119]="AudioVolumeDown",s[s.BrowserSearch=120]="BrowserSearch",s[s.BrowserHome=121]="BrowserHome",s[s.BrowserBack=122]="BrowserBack",s[s.BrowserForward=123]="BrowserForward",s[s.MediaTrackNext=124]="MediaTrackNext",s[s.MediaTrackPrevious=125]="MediaTrackPrevious",s[s.MediaStop=126]="MediaStop",s[s.MediaPlayPause=127]="MediaPlayPause",s[s.LaunchMediaPlayer=128]="LaunchMediaPlayer",s[s.LaunchMail=129]="LaunchMail",s[s.LaunchApp2=130]="LaunchApp2",s[s.Clear=131]="Clear",s[s.MAX_VALUE=132]="MAX_VALUE"})(r||(i.KeyCode=r={}));var o;(function(s){s[s.Hint=1]="Hint",s[s.Info=2]="Info",s[s.Warning=4]="Warning",s[s.Error=8]="Error"})(o||(i.MarkerSeverity=o={}));var c;(function(s){s[s.Unnecessary=1]="Unnecessary",s[s.Deprecated=2]="Deprecated"})(c||(i.MarkerTag=c={}));var T;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(T||(i.MinimapPosition=T={}));var R;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(R||(i.MinimapSectionHeaderStyle=R={}));var j;(function(s){s[s.UNKNOWN=0]="UNKNOWN",s[s.TEXTAREA=1]="TEXTAREA",s[s.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",s[s.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",s[s.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",s[s.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",s[s.CONTENT_TEXT=6]="CONTENT_TEXT",s[s.CONTENT_EMPTY=7]="CONTENT_EMPTY",s[s.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",s[s.CONTENT_WIDGET=9]="CONTENT_WIDGET",s[s.OVERVIEW_RULER=10]="OVERVIEW_RULER",s[s.SCROLLBAR=11]="SCROLLBAR",s[s.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",s[s.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(j||(i.MouseTargetType=j={}));var D;(function(s){s[s.AIGenerated=1]="AIGenerated"})(D||(i.NewSymbolNameTag=D={}));var M;(function(s){s[s.Invoke=0]="Invoke",s[s.Automatic=1]="Automatic"})(M||(i.NewSymbolNameTriggerKind=M={}));var S;(function(s){s[s.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",s[s.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",s[s.TOP_CENTER=2]="TOP_CENTER"})(S||(i.OverlayWidgetPositionPreference=S={}));var y;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(y||(i.OverviewRulerLane=y={}));var F;(function(s){s[s.Word=0]="Word",s[s.Line=1]="Line",s[s.Suggest=2]="Suggest"})(F||(i.PartialAcceptTriggerKind=F={}));var q;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(q||(i.PositionAffinity=q={}));var X;(function(s){s[s.Off=0]="Off",s[s.On=1]="On",s[s.Relative=2]="Relative",s[s.Interval=3]="Interval",s[s.Custom=4]="Custom"})(X||(i.RenderLineNumbersType=X={}));var B;(function(s){s[s.None=0]="None",s[s.Text=1]="Text",s[s.Blocks=2]="Blocks"})(B||(i.RenderMinimap=B={}));var P;(function(s){s[s.Smooth=0]="Smooth",s[s.Immediate=1]="Immediate"})(P||(i.ScrollType=P={}));var Y;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(Y||(i.ScrollbarVisibility=Y={}));var Q;(function(s){s[s.LTR=0]="LTR",s[s.RTL=1]="RTL"})(Q||(i.SelectionDirection=Q={}));var H;(function(s){s.Off="off",s.OnCode="onCode",s.On="on"})(H||(i.ShowLightbulbIconMode=H={}));var K;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(K||(i.SignatureHelpTriggerKind=K={}));var C;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(C||(i.SymbolKind=C={}));var k;(function(s){s[s.Deprecated=1]="Deprecated"})(k||(i.SymbolTag=k={}));var G;(function(s){s[s.Hidden=0]="Hidden",s[s.Blink=1]="Blink",s[s.Smooth=2]="Smooth",s[s.Phase=3]="Phase",s[s.Expand=4]="Expand",s[s.Solid=5]="Solid"})(G||(i.TextEditorCursorBlinkingStyle=G={}));var oe;(function(s){s[s.Line=1]="Line",s[s.Block=2]="Block",s[s.Underline=3]="Underline",s[s.LineThin=4]="LineThin",s[s.BlockOutline=5]="BlockOutline",s[s.UnderlineThin=6]="UnderlineThin"})(oe||(i.TextEditorCursorStyle=oe={}));var ce;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ce||(i.TrackedRangeStickiness=ce={}));var we;(function(s){s[s.None=0]="None",s[s.Same=1]="Same",s[s.Indent=2]="Indent",s[s.DeepIndent=3]="DeepIndent"})(we||(i.WrappingIndent=we={}))}),ne(ie[71],re([0,1,13,12,60]),function(x,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$wu=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$ne,this.onDidChange=this.c.event,this.d=null}handleChange(a){this.c.fire({changedLanguages:a,changedColorMap:!1})}register(a,l){return this.a.set(a,l),this.handleChange([a]),(0,n.$Vc)(()=>{this.a.get(a)===l&&(this.a.delete(a),this.handleChange([a]))})}get(a){return this.a.get(a)||null}registerFactory(a,l){this.b.get(a)?.dispose();const f=new w(this,a,l);return this.b.set(a,f),(0,n.$Vc)(()=>{const $=this.b.get(a);!$||$!==f||(this.b.delete(a),$.dispose())})}async getOrCreate(a){const l=this.get(a);if(l)return l;const f=this.b.get(a);return!f||f.isResolved?null:(await f.resolve(),this.get(a))}isResolved(a){if(this.get(a))return!0;const f=this.b.get(a);return!!(!f||f.isResolved)}setColorMap(a){this.d=a,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>p.ColorId.DefaultBackground?this.d[p.ColorId.DefaultBackground]:null}}i.$wu=g;class w extends n.$Xc{get isResolved(){return this.c}constructor(a,l,f){super(),this.f=a,this.g=l,this.h=f,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const a=await this.h.tokenizationSupport;this.c=!0,a&&!this.a&&this.B(this.f.register(this.g,a))}}}),ne(ie[72],re([77,78]),function(x,i){return x.create("vs/editor/common/languages",i)}),ne(ie[73],re([0,1,47,19,49,2,71,72]),function(x,i,t,n,p,g,w,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InlineEditTriggerKind=i.ExternalUriOpenerPriority=i.$Pu=i.$Ou=i.InlayHintKind=i.CommentState=i.CommentMode=i.CommentThreadApplicability=i.CommentThreadState=i.CommentThreadCollapsibleState=i.Command=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.$Nu=i.$Mu=i.SymbolKinds=i.SymbolTag=i.$Ku=i.SymbolKind=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.DocumentPasteTriggerKind=i.CodeActionTriggerType=i.$Iu=i.InlineCompletionTriggerKind=i.CompletionTriggerKind=i.PartialAcceptTriggerKind=i.CompletionItemInsertTextRule=i.CompletionItemTag=i.CompletionItemKinds=i.CompletionItemKind=i.HoverVerbosityAction=i.$Hu=i.$Gu=i.$Fu=void 0,i.$Ju=o,i.$Lu=T;class a{constructor(G,oe,ce){this.offset=G,this.type=oe,this.language=ce,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}i.$Fu=a;class l{constructor(G,oe){this.tokens=G,this.endState=oe,this._tokenizationResultBrand=void 0}}i.$Gu=l;class f{constructor(G,oe){this.tokens=G,this.endState=oe,this._encodedTokenizationResultBrand=void 0}}i.$Hu=f;var $;(function(k){k[k.Increase=0]="Increase",k[k.Decrease=1]="Decrease"})($||(i.HoverVerbosityAction=$={}));var m;(function(k){k[k.Method=0]="Method",k[k.Function=1]="Function",k[k.Constructor=2]="Constructor",k[k.Field=3]="Field",k[k.Variable=4]="Variable",k[k.Class=5]="Class",k[k.Struct=6]="Struct",k[k.Interface=7]="Interface",k[k.Module=8]="Module",k[k.Property=9]="Property",k[k.Event=10]="Event",k[k.Operator=11]="Operator",k[k.Unit=12]="Unit",k[k.Value=13]="Value",k[k.Constant=14]="Constant",k[k.Enum=15]="Enum",k[k.EnumMember=16]="EnumMember",k[k.Keyword=17]="Keyword",k[k.Text=18]="Text",k[k.Color=19]="Color",k[k.File=20]="File",k[k.Reference=21]="Reference",k[k.Customcolor=22]="Customcolor",k[k.Folder=23]="Folder",k[k.TypeParameter=24]="TypeParameter",k[k.User=25]="User",k[k.Issue=26]="Issue",k[k.Snippet=27]="Snippet"})(m||(i.CompletionItemKind=m={}));var N;(function(k){const G=new Map;G.set(m.Method,t.$6j.symbolMethod),G.set(m.Function,t.$6j.symbolFunction),G.set(m.Constructor,t.$6j.symbolConstructor),G.set(m.Field,t.$6j.symbolField),G.set(m.Variable,t.$6j.symbolVariable),G.set(m.Class,t.$6j.symbolClass),G.set(m.Struct,t.$6j.symbolStruct),G.set(m.Interface,t.$6j.symbolInterface),G.set(m.Module,t.$6j.symbolModule),G.set(m.Property,t.$6j.symbolProperty),G.set(m.Event,t.$6j.symbolEvent),G.set(m.Operator,t.$6j.symbolOperator),G.set(m.Unit,t.$6j.symbolUnit),G.set(m.Value,t.$6j.symbolValue),G.set(m.Enum,t.$6j.symbolEnum),G.set(m.Constant,t.$6j.symbolConstant),G.set(m.Enum,t.$6j.symbolEnum),G.set(m.EnumMember,t.$6j.symbolEnumMember),G.set(m.Keyword,t.$6j.symbolKeyword),G.set(m.Snippet,t.$6j.symbolSnippet),G.set(m.Text,t.$6j.symbolText),G.set(m.Color,t.$6j.symbolColor),G.set(m.File,t.$6j.symbolFile),G.set(m.Reference,t.$6j.symbolReference),G.set(m.Customcolor,t.$6j.symbolCustomColor),G.set(m.Folder,t.$6j.symbolFolder),G.set(m.TypeParameter,t.$6j.symbolTypeParameter),G.set(m.User,t.$6j.account),G.set(m.Issue,t.$6j.issues);function oe(s){let Te=G.get(s);return Te||(console.info("No codicon found for CompletionItemKind "+s),Te=t.$6j.symbolProperty),Te}k.toIcon=oe;const ce=new Map;ce.set("method",m.Method),ce.set("function",m.Function),ce.set("constructor",m.Constructor),ce.set("field",m.Field),ce.set("variable",m.Variable),ce.set("class",m.Class),ce.set("struct",m.Struct),ce.set("interface",m.Interface),ce.set("module",m.Module),ce.set("property",m.Property),ce.set("event",m.Event),ce.set("operator",m.Operator),ce.set("unit",m.Unit),ce.set("value",m.Value),ce.set("constant",m.Constant),ce.set("enum",m.Enum),ce.set("enum-member",m.EnumMember),ce.set("enumMember",m.EnumMember),ce.set("keyword",m.Keyword),ce.set("snippet",m.Snippet),ce.set("text",m.Text),ce.set("color",m.Color),ce.set("file",m.File),ce.set("reference",m.Reference),ce.set("customcolor",m.Customcolor),ce.set("folder",m.Folder),ce.set("type-parameter",m.TypeParameter),ce.set("typeParameter",m.TypeParameter),ce.set("account",m.User),ce.set("issue",m.Issue);function we(s,Te){let De=ce.get(s);return typeof De>"u"&&!Te&&(De=m.Property),De}k.fromString=we})(N||(i.CompletionItemKinds=N={}));var e;(function(k){k[k.Deprecated=1]="Deprecated"})(e||(i.CompletionItemTag=e={}));var b;(function(k){k[k.None=0]="None",k[k.KeepWhitespace=1]="KeepWhitespace",k[k.InsertAsSnippet=4]="InsertAsSnippet"})(b||(i.CompletionItemInsertTextRule=b={}));var L;(function(k){k[k.Word=0]="Word",k[k.Line=1]="Line",k[k.Suggest=2]="Suggest"})(L||(i.PartialAcceptTriggerKind=L={}));var _;(function(k){k[k.Invoke=0]="Invoke",k[k.TriggerCharacter=1]="TriggerCharacter",k[k.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(i.CompletionTriggerKind=_={}));var A;(function(k){k[k.Automatic=0]="Automatic",k[k.Explicit=1]="Explicit"})(A||(i.InlineCompletionTriggerKind=A={}));class E{constructor(G,oe,ce,we){this.range=G,this.text=oe,this.completionKind=ce,this.isSnippetText=we}equals(G){return g.$Nt.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}i.$Iu=E;var v;(function(k){k[k.Invoke=1]="Invoke",k[k.Auto=2]="Auto"})(v||(i.CodeActionTriggerType=v={}));var h;(function(k){k[k.Automatic=0]="Automatic",k[k.PasteAs=1]="PasteAs"})(h||(i.DocumentPasteTriggerKind=h={}));var u;(function(k){k[k.Invoke=1]="Invoke",k[k.TriggerCharacter=2]="TriggerCharacter",k[k.ContentChange=3]="ContentChange"})(u||(i.SignatureHelpTriggerKind=u={}));var r;(function(k){k[k.Text=0]="Text",k[k.Read=1]="Read",k[k.Write=2]="Write"})(r||(i.DocumentHighlightKind=r={}));function o(k){return k&&n.URI.isUri(k.uri)&&g.$Nt.isIRange(k.range)&&(g.$Nt.isIRange(k.originSelectionRange)||g.$Nt.isIRange(k.targetSelectionRange))}var c;(function(k){k[k.File=0]="File",k[k.Module=1]="Module",k[k.Namespace=2]="Namespace",k[k.Package=3]="Package",k[k.Class=4]="Class",k[k.Method=5]="Method",k[k.Property=6]="Property",k[k.Field=7]="Field",k[k.Constructor=8]="Constructor",k[k.Enum=9]="Enum",k[k.Interface=10]="Interface",k[k.Function=11]="Function",k[k.Variable=12]="Variable",k[k.Constant=13]="Constant",k[k.String=14]="String",k[k.Number=15]="Number",k[k.Boolean=16]="Boolean",k[k.Array=17]="Array",k[k.Object=18]="Object",k[k.Key=19]="Key",k[k.Null=20]="Null",k[k.EnumMember=21]="EnumMember",k[k.Struct=22]="Struct",k[k.Event=23]="Event",k[k.Operator=24]="Operator",k[k.TypeParameter=25]="TypeParameter"})(c||(i.SymbolKind=c={})),i.$Ku={[c.Array]:(0,d.localize)(0,null),[c.Boolean]:(0,d.localize)(1,null),[c.Class]:(0,d.localize)(2,null),[c.Constant]:(0,d.localize)(3,null),[c.Constructor]:(0,d.localize)(4,null),[c.Enum]:(0,d.localize)(5,null),[c.EnumMember]:(0,d.localize)(6,null),[c.Event]:(0,d.localize)(7,null),[c.Field]:(0,d.localize)(8,null),[c.File]:(0,d.localize)(9,null),[c.Function]:(0,d.localize)(10,null),[c.Interface]:(0,d.localize)(11,null),[c.Key]:(0,d.localize)(12,null),[c.Method]:(0,d.localize)(13,null),[c.Module]:(0,d.localize)(14,null),[c.Namespace]:(0,d.localize)(15,null),[c.Null]:(0,d.localize)(16,null),[c.Number]:(0,d.localize)(17,null),[c.Object]:(0,d.localize)(18,null),[c.Operator]:(0,d.localize)(19,null),[c.Package]:(0,d.localize)(20,null),[c.Property]:(0,d.localize)(21,null),[c.String]:(0,d.localize)(22,null),[c.Struct]:(0,d.localize)(23,null),[c.TypeParameter]:(0,d.localize)(24,null),[c.Variable]:(0,d.localize)(25,null)};function T(k,G){return(0,d.localize)(26,null,k,i.$Ku[G])}var R;(function(k){k[k.Deprecated=1]="Deprecated"})(R||(i.SymbolTag=R={}));var j;(function(k){const G=new Map;G.set(c.File,t.$6j.symbolFile),G.set(c.Module,t.$6j.symbolModule),G.set(c.Namespace,t.$6j.symbolNamespace),G.set(c.Package,t.$6j.symbolPackage),G.set(c.Class,t.$6j.symbolClass),G.set(c.Method,t.$6j.symbolMethod),G.set(c.Property,t.$6j.symbolProperty),G.set(c.Field,t.$6j.symbolField),G.set(c.Constructor,t.$6j.symbolConstructor),G.set(c.Enum,t.$6j.symbolEnum),G.set(c.Interface,t.$6j.symbolInterface),G.set(c.Function,t.$6j.symbolFunction),G.set(c.Variable,t.$6j.symbolVariable),G.set(c.Constant,t.$6j.symbolConstant),G.set(c.String,t.$6j.symbolString),G.set(c.Number,t.$6j.symbolNumber),G.set(c.Boolean,t.$6j.symbolBoolean),G.set(c.Array,t.$6j.symbolArray),G.set(c.Object,t.$6j.symbolObject),G.set(c.Key,t.$6j.symbolKey),G.set(c.Null,t.$6j.symbolNull),G.set(c.EnumMember,t.$6j.symbolEnumMember),G.set(c.Struct,t.$6j.symbolStruct),G.set(c.Event,t.$6j.symbolEvent),G.set(c.Operator,t.$6j.symbolOperator),G.set(c.TypeParameter,t.$6j.symbolTypeParameter);function oe(ce){let we=G.get(ce);return we||(console.info("No codicon found for SymbolKind "+ce),we=t.$6j.symbolProperty),we}k.toIcon=oe})(j||(i.SymbolKinds=j={}));class D{static asEditOperation(G){return p.$Ot.replace(g.$Nt.lift(G.range),G.text)}}i.$Mu=D;class M{static fromValue(G){switch(G){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(G)}constructor(G){this.value=G}}i.$Nu=M,M.Comment=new M("comment"),M.Imports=new M("imports"),M.Region=new M("region");var S;(function(k){k[k.AIGenerated=1]="AIGenerated"})(S||(i.NewSymbolNameTag=S={}));var y;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(y||(i.NewSymbolNameTriggerKind=y={}));var F;(function(k){function G(oe){return!oe||typeof oe!="object"?!1:typeof oe.id=="string"&&typeof oe.title=="string"}k.is=G})(F||(i.Command=F={}));var q;(function(k){k[k.Collapsed=0]="Collapsed",k[k.Expanded=1]="Expanded"})(q||(i.CommentThreadCollapsibleState=q={}));var X;(function(k){k[k.Unresolved=0]="Unresolved",k[k.Resolved=1]="Resolved"})(X||(i.CommentThreadState=X={}));var B;(function(k){k[k.Current=0]="Current",k[k.Outdated=1]="Outdated"})(B||(i.CommentThreadApplicability=B={}));var P;(function(k){k[k.Editing=0]="Editing",k[k.Preview=1]="Preview"})(P||(i.CommentMode=P={}));var Y;(function(k){k[k.Published=0]="Published",k[k.Draft=1]="Draft"})(Y||(i.CommentState=Y={}));var Q;(function(k){k[k.Type=1]="Type",k[k.Parameter=2]="Parameter"})(Q||(i.InlayHintKind=Q={}));class H{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}i.$Ou=H,i.$Pu=new w.$wu;var K;(function(k){k[k.None=0]="None",k[k.Option=1]="Option",k[k.Default=2]="Default",k[k.Preferred=3]="Preferred"})(K||(i.ExternalUriOpenerPriority=K={}));var C;(function(k){k[k.Invoke=0]="Invoke",k[k.Automatic=1]="Automatic"})(C||(i.InlineEditTriggerKind=C={}))}),ne(ie[74],re([0,1,26,13,40,19,5,2,50,73,70]),function(x,i,t,n,p,g,w,d,a,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$z4=void 0,i.$A4=m,f=ye(f);class ${static chord(e,b){return(0,p.$Xr)(e,b)}}i.$z4=$,$.CtrlCmd=p.KeyMod.CtrlCmd,$.Shift=p.KeyMod.Shift,$.Alt=p.KeyMod.Alt,$.WinCtrl=p.KeyMod.WinCtrl;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.$ye,Emitter:n.$ne,KeyCode:f.KeyCode,KeyMod:$,Position:w.$Mt,Range:d.$Nt,Selection:a.$Pt,SelectionDirection:f.SelectionDirection,MarkerSeverity:f.MarkerSeverity,MarkerTag:f.MarkerTag,Uri:g.URI,Token:l.$Fu}}}),ne(ie[79],re([0,1,29,19,5,2,66,32,62,63,74,25,69,36,59,18,4,61,68]),function(x,i,t,n,p,g,w,d,a,l,f,$,m,N,e,b,L,_,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditorSimpleWorker=void 0,i.create=h;class E extends w.$nw{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const o=[];for(let c=0;c<this.f.length;c++){const T=this.f[c],R=this.offsetAt(new p.$Mt(c+1,1)),j=T.matchAll(r);for(const D of j)(D.index||D.index===0)&&(D.index=D.index+R),o.push(D)}return o}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,o){const c=(0,d.$pt)(r.column,(0,d.$nt)(o),this.f[r.lineNumber-1],0);return c?new g.$Nt(r.lineNumber,c.startColumn,r.lineNumber,c.endColumn):null}getWordUntilPosition(r,o){const c=this.getWordAtPosition(r,o);return c?{word:this.f[r.lineNumber-1].substring(c.startColumn-1,r.column-1),startColumn:c.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const o=this.f,c=this.q.bind(this);let T=0,R="",j=0,D=[];return{*[Symbol.iterator](){for(;;)if(j<D.length){const M=R.substring(D[j].start,D[j].end);j+=1,yield M}else if(T<o.length)R=o[T],D=c(R,r),j=0,T+=1;else break}}}getLineWords(r,o){const c=this.f[r-1],T=this.q(c,o),R=[];for(const j of T)R.push({word:c.substring(j.start,j.end),startColumn:j.start+1,endColumn:j.end+1});return R}q(r,o){const c=[];let T;for(o.lastIndex=0;(T=o.exec(r))&&T[0].length!==0;)c.push({start:T.index,end:T.index+T[0].length});return c}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const o=this.g,c=r.startLineNumber-1,T=r.endLineNumber-1,R=[];R.push(this.f[c].substring(r.startColumn-1));for(let j=c+1;j<T;j++)R.push(this.f[j]);return R.push(this.f[T].substring(0,r.endColumn-1)),R.join(o)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),c=this.f[o.index].length;return{lineNumber:1+o.index,column:1+Math.min(o.remainder,c)}}r(r){const o=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),c=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return o.lineNumber!==r.startLineNumber||o.column!==r.startColumn||c.lineNumber!==r.endLineNumber||c.column!==r.endColumn?{startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:c.lineNumber,endColumn:c.column}:r}s(r){if(!p.$Mt.isIPosition(r))throw new Error("bad position");let{lineNumber:o,column:c}=r,T=!1;if(o<1)o=1,c=1,T=!0;else if(o>this.f.length)o=this.f.length,c=this.f[o-1].length+1,T=!0;else{const R=this.f[o-1].length+1;c<1?(c=1,T=!0):c>R&&(c=R,T=!0)}return T?{lineNumber:o,column:c}:r}}class v{constructor(r,o){this.d=r,this.f=Object.create(null),this.g=o,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(o=>r.push(this.f[o])),r}acceptNewModel(r){this.f[r.url]=new E(n.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,o){if(!this.f[r])return;this.f[r].onEvents(o)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,o,c){const T=this.j(r);return T?m.$u4.computeUnicodeHighlights(T,o,c):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(r,o){const c=this.j(r);return c?(0,A.$Y4)(c,o):[]}async computeDiff(r,o,c,T){const R=this.j(r),j=this.j(o);return!R||!j?null:v.l(R,j,c,T)}static l(r,o,c,T){const R=T==="advanced"?e.$W4.getDefault():e.$W4.getLegacy(),j=r.getLinesContent(),D=o.getLinesContent(),M=R.computeDiff(j,D,c),S=M.changes.length>0?!1:this.n(r,o);function y(F){return F.map(q=>[q.original.startLineNumber,q.original.endLineNumberExclusive,q.modified.startLineNumber,q.modified.endLineNumberExclusive,q.innerChanges?.map(X=>[X.originalRange.startLineNumber,X.originalRange.startColumn,X.originalRange.endLineNumber,X.originalRange.endColumn,X.modifiedRange.startLineNumber,X.modifiedRange.startColumn,X.modifiedRange.endLineNumber,X.modifiedRange.endColumn])])}return{identical:S,quitEarly:M.hitTimeout,changes:y(M.changes),moves:M.moves.map(F=>[F.lineRangeMapping.original.startLineNumber,F.lineRangeMapping.original.endLineNumberExclusive,F.lineRangeMapping.modified.startLineNumber,F.lineRangeMapping.modified.endLineNumberExclusive,y(F.changes)])}}static n(r,o){const c=r.getLineCount(),T=o.getLineCount();if(c!==T)return!1;for(let R=1;R<=c;R++){const j=r.getLineContent(R),D=o.getLineContent(R);if(j!==D)return!1}return!0}async computeDirtyDiff(r,o,c){const T=this.j(r),R=this.j(o);if(!T||!R)return null;const j=T.getLinesContent(),D=R.getLinesContent();return new N.$_t(j,D,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:c,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(r,o,c){const T=this.j(r);if(!T)return o;const R=[];let j;o=o.slice(0).sort((M,S)=>{if(M.range&&S.range)return g.$Nt.compareRangesUsingStarts(M.range,S.range);const y=M.range?0:1,F=S.range?0:1;return y-F});let D=0;for(let M=1;M<o.length;M++)g.$Nt.getEndPosition(o[D].range).equals(g.$Nt.getStartPosition(o[M].range))?(o[D].range=g.$Nt.fromPositions(g.$Nt.getStartPosition(o[D].range),g.$Nt.getEndPosition(o[M].range)),o[D].text+=o[M].text):(D++,o[D]=o[M]);o.length=D+1;for(let{range:M,text:S,eol:y}of o){if(typeof y=="number"&&(j=y),g.$Nt.isEmpty(M)&&!S)continue;const F=T.getValueInRange(M);if(S=S.replace(/\r\n|\n|\r/g,T.eol),F===S)continue;if(Math.max(S.length,F.length)>v.o){R.push({range:M,text:S});continue}const q=(0,t.$St)(F,S,c),X=T.offsetAt(g.$Nt.lift(M).getStartPosition());for(const B of q){const P=T.positionAt(X+B.originalStart),Y=T.positionAt(X+B.originalStart+B.originalLength),Q={text:S.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:P.lineNumber,startColumn:P.column,endLineNumber:Y.lineNumber,endColumn:Y.column}};T.getValueInRange(Q.range)!==Q.text&&R.push(Q)}}return typeof j=="number"&&R.push({eol:j,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}computeHumanReadableDiff(r,o,c){const T=this.j(r);if(!T)return o;const R=[];let j;o=o.slice(0).sort((D,M)=>{if(D.range&&M.range)return g.$Nt.compareRangesUsingStarts(D.range,M.range);const S=D.range?0:1,y=M.range?0:1;return S-y});for(let{range:D,text:M,eol:S}of o){let P=function(Q,H){return new p.$Mt(Q.lineNumber+H.lineNumber-1,H.lineNumber===1?Q.column+H.column-1:H.column)},Y=function(Q,H){const K=[];for(let C=H.startLineNumber;C<=H.endLineNumber;C++){const k=Q[C-1];C===H.startLineNumber&&C===H.endLineNumber?K.push(k.substring(H.startColumn-1,H.endColumn-1)):C===H.startLineNumber?K.push(k.substring(H.startColumn-1)):C===H.endLineNumber?K.push(k.substring(0,H.endColumn-1)):K.push(k)}return K};if(typeof S=="number"&&(j=S),g.$Nt.isEmpty(D)&&!M)continue;const y=T.getValueInRange(D);if(M=M.replace(/\r\n|\n|\r/g,T.eol),y===M)continue;if(Math.max(M.length,y.length)>v.o){R.push({range:D,text:M});continue}const F=y.split(/\r\n|\n|\r/),q=M.split(/\r\n|\n|\r/),X=e.$W4.getDefault().computeDiff(F,q,c),B=g.$Nt.lift(D).getStartPosition();for(const Q of X.changes)if(Q.innerChanges)for(const H of Q.innerChanges)R.push({range:g.$Nt.fromPositions(P(B,H.originalRange.getStartPosition()),P(B,H.originalRange.getEndPosition())),text:Y(q,H.modifiedRange).join(T.eol)});else throw new L.$fb("The experimental diff algorithm always produces inner changes")}return typeof j=="number"&&R.push({eol:j,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}async computeLinks(r){const o=this.j(r);return o?(0,a.$x4)(o):null}async computeDefaultDocumentColors(r){const o=this.j(r);return o?(0,_.$X4)(o):null}async textualSuggest(r,o,c,T){const R=new $.$he,j=new RegExp(c,T),D=new Set;e:for(const M of r){const S=this.j(M);if(S){for(const y of S.words(j))if(!(y===o||!isNaN(Number(y)))&&(D.add(y),D.size>v.p))break e}}return{words:Array.from(D),duration:R.elapsed()}}async computeWordRanges(r,o,c,T){const R=this.j(r);if(!R)return Object.create(null);const j=new RegExp(c,T),D=Object.create(null);for(let M=o.startLineNumber;M<o.endLineNumber;M++){const S=R.getLineWords(M,j);for(const y of S){if(!isNaN(Number(y.word)))continue;let F=D[y.word];F||(F=[],D[y.word]=F),F.push({startLineNumber:M,startColumn:y.startColumn,endLineNumber:M,endColumn:y.endColumn})}}return D}async navigateValueSet(r,o,c,T,R){const j=this.j(r);if(!j)return null;const D=new RegExp(T,R);o.startColumn===o.endColumn&&(o={startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn+1});const M=j.getValueInRange(o),S=j.getWordAtPosition({lineNumber:o.startLineNumber,column:o.startColumn},D);if(!S)return null;const y=j.getValueInRange(S);return l.$y4.INSTANCE.navigateValueSet(o,M,S,y,c)}loadForeignModule(r,o,c){const T=(D,M)=>this.d.fhr(D,M),j={host:(0,b.$qo)(c,T),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(j,o),Promise.resolve((0,b.$po)(this.h))):new Promise((D,M)=>{x([r],S=>{this.h=S.create(j,o),D((0,b.$po)(this.h))},M)})}fmr(r,o){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,o))}catch(c){return Promise.reject(c)}}}i.EditorSimpleWorker=v,v.o=1e5,v.p=1e4;function h(u){return new v(u,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,f.$A4)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
