"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var _e=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/event","vs/base/common/strings","vs/base/common/async","vs/base/common/errors","vs/base/common/types","vs/base/common/charCode","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/extpath","vs/base/common/lazy","vs/base/common/buffer","fs","vs/platform/files/common/files","vs/platform/files/common/watcher","vs/base/common/map","vs/base/common/normalization","vs/base/common/resources","vs/base/common/glob","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/processes","vs/base/common/ternarySearchTree","vs/base/common/network","vs/base/node/extpath","vs/base/parts/sandbox/node/electronTypes","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/console","vs/base/common/marshalling","os","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/common/errorMessage","vs/nls","vs/nls!vs/platform/files/node/watcher/watcherMain","vs/base/common/errorMessage","vs/nls!vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcher","vs/platform/files/node/watcher/watcherStats","vs/platform/files/node/watcher/watcher","util","child_process","@parcel/watcher","vs/platform/files/node/watcher/watcherMain"],Ee=function(ae){for(var e=[],g=0,t=ae.length;g<t;g++)e[g]=_e[ae[g]];return e};define(_e[36],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=g,e.$jb=t,e.$kb=q,e.$lb=M,e.$mb=Y,e.$nb=F,e.$ob=U,e.$qb=N,e.$rb=_,e.$sb=v,e.$tb=k,e.$ub=o;function g(r,d){const b=t(r,d);if(b!==-1)return r[b]}function t(r,d,b=r.length-1){for(let f=b;f>=0;f--){const y=r[f];if(d(y))return f}return-1}function q(r,d){const b=M(r,d);return b===-1?void 0:r[b]}function M(r,d,b=0,f=r.length){let y=b,A=f;for(;y<A;){const s=Math.floor((y+A)/2);d(r[s])?y=s+1:A=s}return y-1}function Y(r,d){const b=F(r,d);return b===r.length?void 0:r[b]}function F(r,d,b=0,f=r.length){let y=b,A=f;for(;y<A;){const s=Math.floor((y+A)/2);d(r[s])?A=s:y=s+1}return y}function U(r,d,b=0,f=r.length){const y=F(r,d,b,f);return y===r.length?-1:y}class P{constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(P.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!d(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const b=M(this.e,d,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$pb=P,P.assertInvariants=!1;function N(r,d){if(r.length===0)return;let b=r[0];for(let f=1;f<r.length;f++){const y=r[f];d(y,b)>0&&(b=y)}return b}function _(r,d){if(r.length===0)return;let b=r[0];for(let f=1;f<r.length;f++){const y=r[f];d(y,b)>=0&&(b=y)}return b}function v(r,d){return N(r,(b,f)=>-d(b,f))}function k(r,d){if(r.length===0)return-1;let b=0;for(let f=1;f<r.length;f++){const y=r[f];d(y,r[b])>0&&(b=f)}return b}function o(r,d){for(const b of r){const f=d(b);if(f!==void 0)return f}}}),define(_e[11],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var g;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(g||(e.CharCode=g={}))}),define(_e[37],Ee([0,1]),function(ae,e){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$I=void 0,e.$E=t,e.$F=q,e.$G=M,e.$H=Y;function t(U,P){const N=Object.create(null);for(const _ of U){const v=P(_);let k=N[v];k||(k=N[v]=[]),k.push(_)}return N}function q(U,P){const N=[],_=[];for(const v of U)P.has(v)||N.push(v);for(const v of P)U.has(v)||_.push(v);return{removed:N,added:_}}function M(U,P){const N=[],_=[];for(const[v,k]of U)P.has(v)||N.push(k);for(const[v,k]of P)U.has(v)||_.push(k);return{removed:N,added:_}}function Y(U,P){const N=new Set;for(const _ of P)U.has(_)&&N.add(_);return N}class F{constructor(P,N){this.b=N,this.a=new Map,this[g]="SetWithKey";for(const _ of P)this.add(_)}get size(){return this.a.size}add(P){const N=this.b(P);return this.a.set(N,P),this}delete(P){return this.a.delete(this.b(P))}has(P){return this.a.has(this.b(P))}*entries(){for(const P of this.a.values())yield[P,P]}keys(){return this.values()}*values(){for(const P of this.a.values())yield P}clear(){this.a.clear()}forEach(P,N){this.a.forEach(_=>P.call(N,_,_,this))}[Symbol.iterator](){return this.values()}}e.$I=F,g=Symbol.toStringTag}),define(_e[38],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=t,e.$_h=q,e.$ai=M;function g(Y){return(F,U,P)=>{let N=null,_=null;if(typeof P.value=="function"?(N="value",_=P.value):typeof P.get=="function"&&(N="get",_=P.get),!_)throw new Error("not supported");P[N]=Y(_,U)}}function t(Y,F,U){let P=null,N=null;if(typeof U.value=="function"?(P="value",N=U.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof U.get=="function"&&(P="get",N=U.get),!N)throw new Error("not supported");const _=`$memoize$${F}`;U[P]=function(...v){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,v)}),this[_]}}function q(Y,F,U){return g((P,N)=>{const _=`$debounce$${N}`,v=`$debounce$result$${N}`;return function(...k){this[v]||(this[v]=U?U():void 0),clearTimeout(this[_]),F&&(this[v]=F(this[v],...k),k=[this[v]]),this[_]=setTimeout(()=>{P.apply(this,k),this[v]=U?U():void 0},Y)}})}function M(Y,F,U){return g((P,N)=>{const _=`$throttle$timer$${N}`,v=`$throttle$result$${N}`,k=`$throttle$lastRun$${N}`,o=`$throttle$pending$${N}`;return function(...r){if(this[v]||(this[v]=U?U():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),F&&(this[v]=F(this[v],...r)),this[o])return;const d=this[k]+Y;d<=Date.now()?(this[k]=Date.now(),P.apply(this,[this[v]]),this[v]=U?U():void 0):(this[o]=!0,this[_]=setTimeout(()=>{this[o]=!1,this[k]=Date.now(),P.apply(this,[this[v]]),this[v]=U?U():void 0},d-Date.now()))}})}}),define(_e[9],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=t,e.$2=q,e.$3=M,e.$4=Y,e.$5=F,e.$6=U,e.$7=N,e.$9=v,e.$0=k,e.$$=o,e.$ab=d;class g{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?A.isErrorNoTelemetry(i)?new A(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Y=g,e.$Z=new g;function t(n){e.$Z.setUnexpectedErrorHandler(n)}function q(n){if(!n||typeof n!="object")return!1;const i=n;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function M(n){N(n)||e.$Z.onUnexpectedError(n)}function Y(n){N(n)||e.$Z.onUnexpectedExternalError(n)}function F(n){if(n instanceof Error){const{name:i,message:l}=n,c=n.stacktrace||n.stack;return{$isError:!0,name:i,message:l,stack:c,noTelemetry:A.isErrorNoTelemetry(n)}}return n}function U(n){let i;return n.noTelemetry?i=new A:(i=new Error,i.name=n.name),i.message=n.message,i.stack=n.stack,i}const P="Canceled";function N(n){return n instanceof _?!0:n instanceof Error&&n.name===P&&n.message===P}class _ extends Error{constructor(){super(P),this.name=this.message}}e.$8=_;function v(){const n=new Error(P);return n.name=n.message,n}function k(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function o(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class r extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=r;function d(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$bb=b;class f extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$cb=f;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=y;class A extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof A)return i;const l=new A;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$eb=A;class s extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,s.prototype)}}e.$fb=s}),define(_e[12],Ee([0,1,9,36]),function(ae,e,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=q,e.$wb=M,e.$xb=Y,e.$yb=F,e.$zb=U,e.$Ab=P,e.$Bb=N,e.$Cb=_,e.$Db=v,e.$Eb=k,e.$Fb=o,e.$Gb=r,e.$Hb=d,e.top=b,e.$Jb=f,e.$Kb=A,e.$Lb=s,e.$Mb=n,e.$Nb=i,e.$Ob=l,e.$Pb=c,e.$Qb=T,e.$Rb=h,e.$Sb=w,e.$Tb=u,e.$Ub=R,e.$Vb=S,e.$Wb=m,e.$Xb=$,e.$Yb=V,e.$Zb=se,e.$1b=ee,e.$2b=K,e.$3b=re,e.$4b=X,e.$5b=te,e.$6b=ue,e.$7b=ce,e.$8b=I,e.$9b=B,e.$0b=Z,e.$ac=C;function q(p,W=0){return p[p.length-(1+W)]}function M(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}function Y(p,W,G=(j,E)=>j===E){if(p===W)return!0;if(!p||!W||p.length!==W.length)return!1;for(let j=0,E=p.length;j<E;j++)if(!G(p[j],W[j]))return!1;return!0}function F(p,W){const G=p.length-1;W<G&&(p[W]=p[G]),p.pop()}function U(p,W,G){return P(p.length,j=>G(p[j],W))}function P(p,W){let G=0,j=p-1;for(;G<=j;){const E=(G+j)/2|0,H=W(E);if(H<0)G=E+1;else if(H>0)j=E-1;else return E}return-(G+1)}function N(p,W,G){if(p=p|0,p>=W.length)throw new TypeError("invalid index");const j=W[Math.floor(W.length*Math.random())],E=[],H=[],Q=[];for(const ne of W){const $e=G(ne,j);$e<0?E.push(ne):$e>0?H.push(ne):Q.push(ne)}return p<E.length?N(p,E,G):p<E.length+Q.length?Q[0]:N(p-(E.length+Q.length),H,G)}function _(p,W){const G=[];let j;for(const E of p.slice(0).sort(W))!j||W(j[0],E)!==0?(j=[E],G.push(j)):j.push(E);return G}function*v(p,W){let G,j;for(const E of p)j!==void 0&&W(j,E)?G.push(E):(G&&(yield G),G=[E]),j=E;G&&(yield G)}function k(p,W){for(let G=0;G<=p.length;G++)W(G===0?void 0:p[G-1],G===p.length?void 0:p[G])}function o(p,W){for(let G=0;G<p.length;G++)W(G===0?void 0:p[G-1],p[G],G+1===p.length?void 0:p[G+1])}function r(p,W,G){const j=[];function E(ne,$e,De){if($e===0&&De.length===0)return;const he=j[j.length-1];he&&he.start+he.deleteCount===ne?(he.deleteCount+=$e,he.toInsert.push(...De)):j.push({start:ne,deleteCount:$e,toInsert:De})}let H=0,Q=0;for(;;){if(H===p.length){E(H,0,W.slice(Q));break}if(Q===W.length){E(H,p.length-H,[]);break}const ne=p[H],$e=W[Q],De=G(ne,$e);De===0?(H+=1,Q+=1):De<0?(E(H,1,[]),H+=1):De>0&&(E(H,0,[$e]),Q+=1)}return j}function d(p,W,G){const j=r(p,W,G),E=[],H=[];for(const Q of j)E.push(...p.slice(Q.start,Q.start+Q.deleteCount)),H.push(...Q.toInsert);return{removed:E,added:H}}function b(p,W,G){if(G===0)return[];const j=p.slice(0,G).sort(W);return y(p,W,j,G,p.length),j}function f(p,W,G,j,E){return G===0?Promise.resolve([]):new Promise((H,Q)=>{(async()=>{const ne=p.length,$e=p.slice(0,G).sort(W);for(let De=G,he=Math.min(G+j,ne);De<ne;De=he,he=Math.min(he+j,ne)){if(De>G&&await new Promise(fe=>setTimeout(fe)),E&&E.isCancellationRequested)throw new g.$8;y(p,W,$e,De,he)}return $e})().then(H,Q)})}function y(p,W,G,j,E){for(const H=G.length;j<E;j++){const Q=p[j];if(W(Q,G[H-1])<0){G.pop();const ne=(0,t.$nb)(G,$e=>W(Q,$e)<0);G.splice(ne,0,Q)}}}function A(p){return p.filter(W=>!!W)}function s(p){let W=0;for(let G=0;G<p.length;G++)p[G]&&(p[W]=p[G],W+=1);p.length=W}function n(p,W,G){p.splice(G,0,p.splice(W,1)[0])}function i(p){return!Array.isArray(p)||p.length===0}function l(p){return Array.isArray(p)&&p.length>0}function c(p,W=G=>G){const G=new Set;return p.filter(j=>{const E=W(j);return G.has(E)?!1:(G.add(E),!0)})}function T(p){const W=new Set;return G=>{const j=p(G);return W.has(j)?!1:(W.add(j),!0)}}function h(p,W){return p.length>0?p[0]:W}function w(p,W){return p.length>0?p[p.length-1]:W}function u(p,W,G=(j,E)=>j===E){let j=0;for(let E=0,H=Math.min(p.length,W.length);E<H&&G(p[E],W[E]);E++)j++;return j}function R(p,W){let G=typeof W=="number"?p:0;typeof W=="number"?G=p:(G=0,W=p);const j=[];if(G<=W)for(let E=G;E<W;E++)j.push(E);else for(let E=G;E>W;E--)j.push(E);return j}function S(p,W,G){return p.reduce((j,E)=>(j[W(E)]=G?G(E):E,j),Object.create(null))}function m(p,W){return p.push(W),()=>$(p,W)}function $(p,W){const G=p.indexOf(W);if(G>-1)return p.splice(G,1),W}function V(p,W,G){const j=p.slice(0,W),E=p.slice(W);return j.concat(G,E)}function se(p,W){let G;if(typeof W=="number"){let j=W;G=()=>{const E=Math.sin(j++)*179426549;return E-Math.floor(E)}}else G=Math.random;for(let j=p.length-1;j>0;j-=1){const E=Math.floor(G()*(j+1)),H=p[j];p[j]=p[E],p[E]=H}}function ee(p,W){const G=p.indexOf(W);G>-1&&(p.splice(G,1),p.unshift(W))}function K(p,W){const G=p.indexOf(W);G>-1&&(p.splice(G,1),p.push(W))}function re(p,W){for(const G of W)p.push(G)}function X(p,W){return Array.isArray(p)?p.map(W):W(p)}function te(p){return Array.isArray(p)?p:[p]}function ue(p){return p[Math.floor(Math.random()*p.length)]}function ce(p,W,G){const j=a(p,W),E=p.length,H=G.length;p.length=E+H;for(let Q=E-1;Q>=j;Q--)p[Q+H]=p[Q];for(let Q=0;Q<H;Q++)p[Q+j]=G[Q]}function I(p,W,G,j){const E=a(p,W);let H=p.splice(E,G);return H===void 0&&(H=[]),ce(p,E,j),H}function a(p,W){return W<0?Math.max(W+p.length,0):Math.min(W,p.length)}var O;(function(p){function W(H){return H<0}p.isLessThan=W;function G(H){return H<=0}p.isLessThanOrEqual=G;function j(H){return H>0}p.isGreaterThan=j;function E(H){return H===0}p.isNeitherLessOrGreaterThan=E,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(O||(e.CompareResult=O={}));function B(p,W){return(G,j)=>W(p(G),p(j))}function Z(...p){return(W,G)=>{for(const j of p){const E=j(W,G);if(!O.isNeitherLessOrGreaterThan(E))return E}return O.neitherLessOrGreaterThan}}const D=(p,W)=>p-W;e.$$b=D;const J=(p,W)=>(0,e.$$b)(p?1:0,W?1:0);e.$_b=J;function C(p){return(W,G)=>-p(W,G)}class ie{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let G=this.c;for(;G<this.g.length&&W(this.g[G]);)G++;const j=G===this.c?null:this.g.slice(this.c,G);return this.c=G,j}takeFromEndWhile(W){let G=this.d;for(;G>=0&&W(this.g[G]);)G--;const j=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,j}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const G=this.g.slice(this.c,this.c+W);return this.c+=W,G}}e.$bc=ie;class le{constructor(W){this.iterate=W}forEach(W){this.iterate(G=>(W(G),!0))}toArray(){const W=[];return this.iterate(G=>(W.push(G),!0)),W}filter(W){return new le(G=>this.iterate(j=>W(j)?G(j):!0))}map(W){return new le(G=>this.iterate(j=>G(W(j))))}some(W){let G=!1;return this.iterate(j=>(G=W(j),!G)),G}findFirst(W){let G;return this.iterate(j=>W(j)?(G=j,!1):!0),G}findLast(W){let G;return this.iterate(j=>(W(j)&&(G=j),!0)),G}findLastMaxBy(W){let G,j=!0;return this.iterate(E=>((j||O.isGreaterThan(W(E,G)))&&(j=!1,G=E),!0)),G}}e.$cc=le,le.empty=new le(p=>{});class de{constructor(W){this.c=W}static createSortPermutation(W,G){const j=Array.from(W.keys()).sort((E,H)=>G(W[E],W[H]));return new de(j)}apply(W){return W.map((G,j)=>W[this.c[j]])}inverse(){const W=this.c.slice();for(let G=0;G<this.c.length;G++)W[this.c[G]]=G;return new de(W)}}e.$dc=de}),define(_e[26],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=g;function g(t,q){const M=this;let Y=!1,F;return function(){if(Y)return F;if(Y=!0,q)try{F=t.apply(M,arguments)}finally{q()}else F=t.apply(M,arguments);return F}}}),define(_e[39],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(t){function q(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=q;const M=Object.freeze([]);function Y(){return M}t.empty=Y;function*F(i){yield i}t.single=F;function U(i){return q(i)?i:F(i)}t.wrap=U;function P(i){return i||M}t.from=P;function*N(i){for(let l=i.length-1;l>=0;l--)yield i[l]}t.reverse=N;function _(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=_;function v(i){return i[Symbol.iterator]().next().value}t.first=v;function k(i,l){let c=0;for(const T of i)if(l(T,c++))return!0;return!1}t.some=k;function o(i,l){for(const c of i)if(l(c))return c}t.find=o;function*r(i,l){for(const c of i)l(c)&&(yield c)}t.filter=r;function*d(i,l){let c=0;for(const T of i)yield l(T,c++)}t.map=d;function*b(i,l){let c=0;for(const T of i)yield*l(T,c++)}t.flatMap=b;function*f(...i){for(const l of i)yield*l}t.concat=f;function y(i,l,c){let T=c;for(const h of i)T=l(T,h);return T}t.reduce=y;function*A(i,l,c=i.length){for(l<0&&(l+=i.length),c<0?c+=i.length:c>i.length&&(c=i.length);l<c;l++)yield i[l]}t.slice=A;function s(i,l=Number.POSITIVE_INFINITY){const c=[];if(l===0)return[c,i];const T=i[Symbol.iterator]();for(let h=0;h<l;h++){const w=T.next();if(w.done)return[c,t.empty()];c.push(w.value)}return[c,{[Symbol.iterator](){return T}}]}t.consume=s;async function n(i){const l=[];for await(const c of i)l.push(c);return Promise.resolve(l)}t.asyncToArray=n})(g||(e.Iterable=g={}))}),define(_e[15],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class g{constructor(q){this.d=q,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(q){this.c=q}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=g}),define(_e[40],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class g{constructor(M){this.element=M,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class t{constructor(){this.a=g.Undefined,this.b=g.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===g.Undefined}clear(){let M=this.a;for(;M!==g.Undefined;){const Y=M.next;M.prev=g.Undefined,M.next=g.Undefined,M=Y}this.a=g.Undefined,this.b=g.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,Y){const F=new g(M);if(this.a===g.Undefined)this.a=F,this.b=F;else if(Y){const P=this.b;this.b=F,F.prev=P,P.next=F}else{const P=this.a;this.a=F,F.next=P,P.prev=F}this.c+=1;let U=!1;return()=>{U||(U=!0,this.e(F))}}shift(){if(this.a!==g.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==g.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==g.Undefined&&M.next!==g.Undefined){const Y=M.prev;Y.next=M.next,M.next.prev=Y}else M.prev===g.Undefined&&M.next===g.Undefined?(this.a=g.Undefined,this.b=g.Undefined):M.next===g.Undefined?(this.b=this.b.prev,this.b.next=g.Undefined):M.prev===g.Undefined&&(this.a=this.a.next,this.a.prev=g.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==g.Undefined;)yield M.element,M=M.next}}e.$8c=t}),define(_e[20],Ee([0,1]),function(ae,e){"use strict";var g,t,q;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=M,e.$Bc=Y,e.$Cc=F,e.$Lc=A;function M(s,n,i){let l=s.get(n);return l===void 0&&(l=i,s.set(n,l)),l}function Y(s){const n=[];return s.forEach((i,l)=>{n.push(`${l} => ${i}`)}),`Map(${s.size}) {${n.join(", ")}}`}function F(s){const n=[];return s.forEach(i=>{n.push(i)}),`Set(${s.size}) {${n.join(", ")}}`}class U{constructor(n,i){this.uri=n,this.value=i}}function P(s){return Array.isArray(s)}class N{constructor(n,i){if(this[g]="ResourceMap",n instanceof N)this.d=new Map(n.d),this.e=i??N.c;else if(P(n)){this.d=new Map,this.e=i??N.c;for(const[l,c]of n)this.set(l,c)}else this.d=new Map,this.e=n??N.c}set(n,i){return this.d.set(this.e(n),new U(n,i)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[l,c]of this.d)n(c.value,c.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Dc=N,N.c=s=>s.toString();class _{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new N(n):(this.c=new N(i),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,i){this.c.forEach((l,c)=>n.call(i,c,c,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=_;var v;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class k{constructor(){this[q]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,i=v.None){const l=this.c.get(n);if(l)return i!==v.None&&this.m(l,i),l.value}set(n,i,l=v.None){let c=this.c.get(n);if(c)c.value=i,l!==v.None&&this.m(c,l);else{switch(c={key:n,value:i,next:void 0,previous:void 0},l){case v.None:this.k(c);break;case v.AsOld:this.j(c);break;case v.AsNew:this.k(c);break;default:this.k(c);break}this.c.set(n,c),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this.c.get(n);if(i)return this.c.delete(n),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,i){const l=this.g;let c=this.d;for(;c;){if(i?n.bind(i)(c.value,c.key,this):n(c.value,c.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,i=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const T={value:l.key,done:!1};return l=l.next,T}else return{value:void 0,done:!0}}};return c}values(){const n=this,i=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const T={value:l.value,done:!1};return l=l.next,T}else return{value:void 0,done:!0}}};return c}entries(){const n=this,i=this.g;let l=this.d;const c={[Symbol.iterator](){return c},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const T={value:[l.key,l.value],done:!1};return l=l.next,T}else return{value:void 0,done:!0}}};return c}[(q=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.d,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.next,l--;this.d=i,this.f=l,i&&(i.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.e,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.previous,l--;this.e=i,this.f=l,i&&(i.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const i=n.next,l=n.previous;if(!i||!l)throw new Error("Invalid list");i.previous=l,l.next=i}n.next=void 0,n.previous=void 0,this.g++}m(n,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==v.AsOld&&i!==v.AsNew)){if(i===v.AsOld){if(n===this.d)return;const l=n.next,c=n.previous;n===this.e?(c.next=void 0,this.e=c):(l.previous=c,c.next=l),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(i===v.AsNew){if(n===this.e)return;const l=n.next,c=n.previous;n===this.d?(l.previous=void 0,this.d=l):(l.previous=c,c.next=l),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((i,l)=>{n.push([l,i])}),n}fromJSON(n){this.clear();for(const[i,l]of n)this.set(i,l)}}e.$Fc=k;class o extends k{constructor(n,i=1){super(),this.n=n,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,i=v.AsNew){return super.get(n,i)}peek(n){return super.get(n,v.None)}set(n,i){return super.set(n,i,v.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class r extends o{constructor(n,i=1){super(n,i)}q(n){this.h(n)}set(n,i){return super.set(n,i),this.p(),this}}e.$Gc=r;class d extends o{constructor(n,i=1){super(n,i)}q(n){this.i(n)}set(n,i){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,i),this}}e.$Hc=d;class b{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let i=this.c.get(n)||0;return i===0?!1:(i--,i===0?this.c.delete(n):this.c.set(n,i),!0)}has(n){return this.c.has(n)}}e.$Ic=b;class f{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[i,l]of n)this.set(i,l)}clear(){this.c.clear(),this.d.clear()}set(n,i){this.c.set(n,i),this.d.set(i,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const i=this.c.get(n);return i===void 0?!1:(this.c.delete(n),this.d.delete(i),!0)}forEach(n,i){this.c.forEach((l,c)=>{n.call(i,l,c,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=f;class y{constructor(){this.c=new Map}add(n,i){let l=this.c.get(n);l||(l=new Set,this.c.set(n,l)),l.add(i)}delete(n,i){const l=this.c.get(n);l&&(l.delete(i),l.size===0&&this.c.delete(n))}forEach(n,i){const l=this.c.get(n);l&&l.forEach(i)}get(n){const i=this.c.get(n);return i||new Set}}e.$Kc=y;function A(s,n){if(s===n)return!0;if(s.size!==n.size)return!1;for(const[i,l]of s)if(!n.has(i)||n.get(i)!==l)return!1;for(const[i]of n)if(!s.has(i))return!1;return!0}}),define(_e[4],Ee([0,1,12,37,20,26,39]),function(ae,e,g,t,q,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=N,e.$Oc=_,e.$Pc=v,e.$Qc=r,e.$Rc=d,e.$Sc=b,e.$Tc=f,e.$Uc=y,e.$Vc=A,e.$6c=R;const F=!1;let U=null;class P{constructor(){this.b=new Map}c($){let V=this.b.get($);return V||(V={parent:null,source:null,isSingleton:!1,value:$,idx:P.a++},this.b.set($,V)),V}trackDisposable($){const V=this.c($);V.source||(V.source=new Error().stack)}setParent($,V){const se=this.c($);se.parent=V}markAsDisposed($){this.b.delete($)}markAsSingleton($){this.c($).isSingleton=!0}f($,V){const se=V.get($);if(se)return se;const ee=$.parent?this.f(this.c($.parent),V):$;return V.set($,ee),ee}getTrackedDisposables(){const $=new Map;return[...this.b.entries()].filter(([,se])=>se.source!==null&&!this.f(se,$).isSingleton).flatMap(([se])=>se)}computeLeakingDisposables($=10,V){let se;if(V)se=V;else{const te=new Map,ue=[...this.b.values()].filter(I=>I.source!==null&&!this.f(I,te).isSingleton);if(ue.length===0)return;const ce=new Set(ue.map(I=>I.value));if(se=ue.filter(I=>!(I.parent&&ce.has(I.parent))),se.length===0)throw new Error("There are cyclic diposable chains!")}if(!se)return;function ee(te){function ue(I,a){for(;I.length>0&&a.some(O=>typeof O=="string"?O===I[0]:I[0].match(O));)I.shift()}const ce=te.source.split(`
`).map(I=>I.trim().replace("at ","")).filter(I=>I!=="");return ue(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const K=new q.$Kc;for(const te of se){const ue=ee(te);for(let ce=0;ce<=ue.length;ce++)K.add(ue.slice(0,ce).join(`
`),te)}se.sort((0,g.$9b)(te=>te.idx,g.$$b));let re="",X=0;for(const te of se.slice(0,$)){X++;const ue=ee(te),ce=[];for(let I=0;I<ue.length;I++){let a=ue[I];a=`(shared with ${K.get(ue.slice(0,I+1).join(`
`)).size}/${se.length} leaks) at ${a}`;const B=K.get(ue.slice(0,I).join(`
`)),Z=(0,t.$E)([...B].map(D=>ee(D)[I]),D=>D);delete Z[ue[I]];for(const[D,J]of Object.entries(Z))ce.unshift(`    - stacktraces of ${J.length} other leaks continue with ${D}`);ce.unshift(a)}re+=`


==================== Leaking disposable ${X}/${se.length}: ${te.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return se.length>$&&(re+=`


... and ${se.length-$} more leaking disposables

`),{leaks:se,details:re}}}e.$Mc=P,P.a=0;function N(m){U=m}if(F){const m="__is_disposable_tracked__";N(new class{trackDisposable($){const V=new Error("Potentially leaked disposable").stack;setTimeout(()=>{$[m]||console.log(V)},3e3)}setParent($,V){if($&&$!==n.None)try{$[m]=!0}catch{}}markAsDisposed($){if($&&$!==n.None)try{$[m]=!0}catch{}}markAsSingleton($){}})}function _(m){return U?.trackDisposable(m),m}function v(m){U?.markAsDisposed(m)}function k(m,$){U?.setParent(m,$)}function o(m,$){if(U)for(const V of m)U.setParent(V,$)}function r(m){return U?.markAsSingleton(m),m}function d(m){return typeof m=="object"&&m!==null&&typeof m.dispose=="function"&&m.dispose.length===0}function b(m){if(Y.Iterable.is(m)){const $=[];for(const V of m)if(V)try{V.dispose()}catch(se){$.push(se)}if($.length===1)throw $[0];if($.length>1)throw new AggregateError($,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}function f(m){for(const $ of m)d($)&&$.dispose();return[]}function y(...m){const $=A(()=>b(m));return o(m,$),$}function A(m){const $=_({dispose:(0,M.$gb)(()=>{v($),m()})});return $}class s{constructor(){this.f=new Set,this.g=!1,_(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add($){if(!$)return $;if($===this)throw new Error("Cannot register a disposable on itself!");return k($,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add($),$}delete($){if($){if($===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete($),$.dispose()}}deleteAndLeak($){$&&this.f.has($)&&(this.f.delete($),k($,null))}}e.$Wc=s,s.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this.q=new s,_(this),k(this.q,this)}dispose(){v(this),this.q.dispose()}B($){if($===this)throw new Error("Cannot register a disposable on itself!");return this.q.add($)}}e.$Xc=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this.b=!1,_(this)}get value(){return this.b?void 0:this.a}set value($){this.b||$===this.a||(this.a?.dispose(),$&&k($,this),this.a=$)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const $=this.a;return this.a=void 0,$&&k($,null),$}}e.$Yc=i;class l{constructor($){this.a=new i,this.b=!1,this.a.value=$}get value(){return this.a.value}set value($){this.b||$===this.a.value||(this.a.value=$)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=l;class c{constructor($){this.b=$,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=c;class T{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,_(this)}set($){let V=$;return this.unset=()=>V=void 0,this.isset=()=>V!==void 0,this.dispose=()=>{V&&(V(),V=void 0,v(this))},this}}e.$2c=T;class h{constructor(){this.a=new Map}acquire($,...V){let se=this.a.get($);se||(se={counter:0,object:this.b($,...V)},this.a.set($,se));const{object:ee}=se,K=(0,M.$gb)(()=>{--se.counter===0&&(this.c($,se.object),this.a.delete($))});return se.counter++,{object:ee,dispose:K}}}e.$3c=h;class w{constructor($){this.a=$}async acquire($,...V){const se=this.a.acquire($,...V);try{return{object:await se.object,dispose:()=>se.dispose()}}catch(ee){throw se.dispose(),ee}}}e.$4c=w;class u{constructor($){this.object=$}dispose(){}}e.$5c=u;function R(m){const $=new s;try{m($)}finally{$.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,_(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has($){return this.a.has($)}get size(){return this.a.size}get($){return this.a.get($)}set($,V,se=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),se||this.a.get($)?.dispose(),this.a.set($,V)}deleteAndDispose($){this.a.get($)?.dispose(),this.a.delete($)}deleteAndLeak($){const V=this.a.get($);return this.a.delete($),V}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=S}),define(_e[27],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var g;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(g||(e.MarshalledId=g={}))}),define(_e[21],Ee([0,1,20]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=q,e.$om=Y;const t=new g.$Gc(1e4);function q(P){return U(P,"NFC",t)}const M=new g.$Gc(1e4);function Y(P){return U(P,"NFD",M)}const F=/[^\u0000-\u0080]/;function U(P,N,_){if(!P)return P;const v=_.get(P);if(v)return v;let k;return F.test(P)?k=P.normalize(N):k=P,_.set(P,k),k}e.$pm=function(){const P=/[\u0300-\u036f]/g;return function(N){return Y(N).replace(P,"")}}()}),define(_e[2],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=n,e.$x=w,e.$D=u,e.$a="en";let g=!1,t=!1,q=!1,M=!1,Y=!1,F=!1,U=!1,P=!1,N=!1,_=!1,v,k=e.$a,o=e.$a,r,d;const b=globalThis;let f;typeof b.vscode<"u"&&typeof b.vscode.process<"u"?f=b.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const y=typeof f?.versions?.electron=="string",A=y&&f?.type==="renderer";if(typeof f=="object"){g=f.platform==="win32",t=f.platform==="darwin",q=f.platform==="linux",M=q&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,U=y,N=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$a,k=e.$a;const R=f.env.VSCODE_NLS_CONFIG;if(R)try{const S=JSON.parse(R),m=S.availableLanguages["*"];v=S.locale,o=S.osLocale,k=m||e.$a,r=S._translationsConfigFile}catch{}Y=!0}else if(typeof navigator=="object"&&!A){d=navigator.userAgent,g=d.indexOf("Windows")>=0,t=d.indexOf("Macintosh")>=0,P=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,q=d.indexOf("Linux")>=0,_=d?.indexOf("Mobi")>=0,F=!0,v=e.$a,k=v,o=navigator.language;const R=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),S=R&&R.getAttribute("data-settings");if(S)try{const m=JSON.parse(S),$=m.availableLanguages["*"];v=m.locale,o=m.osLocale,k=$||e.$a,r=m._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var s;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(s||(e.Platform=s={}));function n(R){switch(R){case s.Web:return"Web";case s.Mac:return"Mac";case s.Linux:return"Linux";case s.Windows:return"Windows"}}let i=s.Web;t?i=s.Mac:g?i=s.Windows:q&&(i=s.Linux),e.$c=g,e.$d=t,e.$e=q,e.$f=M,e.$g=Y,e.$h=U,e.$i=F,e.$j=F&&typeof b.importScripts=="function",e.$k=e.$j?b.origin:void 0,e.$l=P,e.$m=_,e.$n=N,e.$o=i,e.$p=d,e.$q=k;var l;(function(R){function S(){return e.$q}R.value=S;function m(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}R.isDefaultVariant=m;function $(){return e.$q==="en"}R.isDefault=$})(l||(e.Language=l={})),e.$r=v,e.$s=o,e.$t=r,e.$u=typeof b.postMessage=="function"&&!b.importScripts,e.$v=(()=>{if(e.$u){const R=[];b.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let $=0,V=R.length;$<V;$++){const se=R[$];if(se.id===m.data.vscodeScheduleAsyncWork){R.splice($,1),se.callback();return}}});let S=0;return m=>{const $=++S;R.push({id:$,callback:m}),b.postMessage({vscodeScheduleAsyncWork:$},"*")}}return R=>setTimeout(R)})();var c;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=t||P?c.Macintosh:g?c.Windows:c.Linux;let T=!0,h=!1;function w(){if(!h){h=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,T=new Uint16Array(R.buffer)[0]===513}return T}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function u(R){return parseFloat(R)>=20}}),define(_e[28],Ee([0,1,2]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let t;const q=globalThis.vscode;if(typeof q<"u"&&typeof q.process<"u"){const M=q.process;t={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return g.$c?"win32":g.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$gc=t.platform,e.$hc=t.arch});var Ke=this&&this.__createBinding||(Object.create?function(ae,e,g,t){t===void 0&&(t=g);var q=Object.getOwnPropertyDescriptor(e,g);(!q||("get"in q?!e.__esModule:q.writable||q.configurable))&&(q={enumerable:!0,get:function(){return e[g]}}),Object.defineProperty(ae,t,q)}:function(ae,e,g,t){t===void 0&&(t=g),ae[t]=e[g]}),Xe=this&&this.__setModuleDefault||(Object.create?function(ae,e){Object.defineProperty(ae,"default",{enumerable:!0,value:e})}:function(ae,e){ae.default=e}),Ie=this&&this.__importStar||function(ae){if(ae&&ae.__esModule)return ae;var e={};if(ae!=null)for(var g in ae)g!=="default"&&Object.prototype.hasOwnProperty.call(ae,g)&&Ke(e,ae,g);return Xe(e,ae),e};define(_e[3],Ee([0,1,28]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,g=Ie(g);const t=65,q=97,M=90,Y=122,F=46,U=47,P=92,N=58,_=63;class v extends Error{constructor(i,l,c){let T;typeof l=="string"&&l.indexOf("not ")===0?(T="must not be",l=l.replace(/^not /,"")):T="must be";const h=i.indexOf(".")!==-1?"property":"argument";let w=`The "${i}" ${h} ${T} of type ${l}`;w+=`. Received type ${typeof c}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function k(n,i){if(n===null||typeof n!="object")throw new v(i,"Object",n)}function o(n,i){if(typeof n!="string")throw new v(i,"string",n)}const r=g.$gc==="win32";function d(n){return n===U||n===P}function b(n){return n===U}function f(n){return n>=t&&n<=M||n>=q&&n<=Y}function y(n,i,l,c){let T="",h=0,w=-1,u=0,R=0;for(let S=0;S<=n.length;++S){if(S<n.length)R=n.charCodeAt(S);else{if(c(R))break;R=U}if(c(R)){if(!(w===S-1||u===1))if(u===2){if(T.length<2||h!==2||T.charCodeAt(T.length-1)!==F||T.charCodeAt(T.length-2)!==F){if(T.length>2){const m=T.lastIndexOf(l);m===-1?(T="",h=0):(T=T.slice(0,m),h=T.length-1-T.lastIndexOf(l)),w=S,u=0;continue}else if(T.length!==0){T="",h=0,w=S,u=0;continue}}i&&(T+=T.length>0?`${l}..`:"..",h=2)}else T.length>0?T+=`${l}${n.slice(w+1,S)}`:T=n.slice(w+1,S),h=S-w-1;w=S,u=0}else R===F&&u!==-1?++u:u=-1}return T}function A(n,i){k(i,"pathObject");const l=i.dir||i.root,c=i.base||`${i.name||""}${i.ext||""}`;return l?l===i.root?`${l}${c}`:`${l}${n}${c}`:c}e.$ic={resolve(...n){let i="",l="",c=!1;for(let T=n.length-1;T>=-1;T--){let h;if(T>=0){if(h=n[T],o(h,"path"),h.length===0)continue}else i.length===0?h=g.cwd():(h=g.env[`=${i}`]||g.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==i.toLowerCase()&&h.charCodeAt(2)===P)&&(h=`${i}\\`));const w=h.length;let u=0,R="",S=!1;const m=h.charCodeAt(0);if(w===1)d(m)&&(u=1,S=!0);else if(d(m))if(S=!0,d(h.charCodeAt(1))){let $=2,V=$;for(;$<w&&!d(h.charCodeAt($));)$++;if($<w&&$!==V){const se=h.slice(V,$);for(V=$;$<w&&d(h.charCodeAt($));)$++;if($<w&&$!==V){for(V=$;$<w&&!d(h.charCodeAt($));)$++;($===w||$!==V)&&(R=`\\\\${se}\\${h.slice(V,$)}`,u=$)}}}else u=1;else f(m)&&h.charCodeAt(1)===N&&(R=h.slice(0,2),u=2,w>2&&d(h.charCodeAt(2))&&(S=!0,u=3));if(R.length>0)if(i.length>0){if(R.toLowerCase()!==i.toLowerCase())continue}else i=R;if(c){if(i.length>0)break}else if(l=`${h.slice(u)}\\${l}`,c=S,S&&i.length>0)break}return l=y(l,!c,"\\",d),c?`${i}\\${l}`:`${i}${l}`||"."},normalize(n){o(n,"path");const i=n.length;if(i===0)return".";let l=0,c,T=!1;const h=n.charCodeAt(0);if(i===1)return b(h)?"\\":n;if(d(h))if(T=!0,d(n.charCodeAt(1))){let u=2,R=u;for(;u<i&&!d(n.charCodeAt(u));)u++;if(u<i&&u!==R){const S=n.slice(R,u);for(R=u;u<i&&d(n.charCodeAt(u));)u++;if(u<i&&u!==R){for(R=u;u<i&&!d(n.charCodeAt(u));)u++;if(u===i)return`\\\\${S}\\${n.slice(R)}\\`;u!==R&&(c=`\\\\${S}\\${n.slice(R,u)}`,l=u)}}}else l=1;else f(h)&&n.charCodeAt(1)===N&&(c=n.slice(0,2),l=2,i>2&&d(n.charCodeAt(2))&&(T=!0,l=3));let w=l<i?y(n.slice(l),!T,"\\",d):"";return w.length===0&&!T&&(w="."),w.length>0&&d(n.charCodeAt(i-1))&&(w+="\\"),c===void 0?T?`\\${w}`:w:T?`${c}\\${w}`:`${c}${w}`},isAbsolute(n){o(n,"path");const i=n.length;if(i===0)return!1;const l=n.charCodeAt(0);return d(l)||i>2&&f(l)&&n.charCodeAt(1)===N&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,l;for(let h=0;h<n.length;++h){const w=n[h];o(w,"path"),w.length>0&&(i===void 0?i=l=w:i+=`\\${w}`)}if(i===void 0)return".";let c=!0,T=0;if(typeof l=="string"&&d(l.charCodeAt(0))){++T;const h=l.length;h>1&&d(l.charCodeAt(1))&&(++T,h>2&&(d(l.charCodeAt(2))?++T:c=!1))}if(c){for(;T<i.length&&d(i.charCodeAt(T));)T++;T>=2&&(i=`\\${i.slice(T)}`)}return e.$ic.normalize(i)},relative(n,i){if(o(n,"from"),o(i,"to"),n===i)return"";const l=e.$ic.resolve(n),c=e.$ic.resolve(i);if(l===c||(n=l.toLowerCase(),i=c.toLowerCase(),n===i))return"";let T=0;for(;T<n.length&&n.charCodeAt(T)===P;)T++;let h=n.length;for(;h-1>T&&n.charCodeAt(h-1)===P;)h--;const w=h-T;let u=0;for(;u<i.length&&i.charCodeAt(u)===P;)u++;let R=i.length;for(;R-1>u&&i.charCodeAt(R-1)===P;)R--;const S=R-u,m=w<S?w:S;let $=-1,V=0;for(;V<m;V++){const ee=n.charCodeAt(T+V);if(ee!==i.charCodeAt(u+V))break;ee===P&&($=V)}if(V!==m){if($===-1)return c}else{if(S>m){if(i.charCodeAt(u+V)===P)return c.slice(u+V+1);if(V===2)return c.slice(u+V)}w>m&&(n.charCodeAt(T+V)===P?$=V:V===2&&($=3)),$===-1&&($=0)}let se="";for(V=T+$+1;V<=h;++V)(V===h||n.charCodeAt(V)===P)&&(se+=se.length===0?"..":"\\..");return u+=$,se.length>0?`${se}${c.slice(u,R)}`:(c.charCodeAt(u)===P&&++u,c.slice(u,R))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$ic.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===P){if(i.charCodeAt(1)===P){const l=i.charCodeAt(2);if(l!==_&&l!==F)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(f(i.charCodeAt(0))&&i.charCodeAt(1)===N&&i.charCodeAt(2)===P)return`\\\\?\\${i}`;return n},dirname(n){o(n,"path");const i=n.length;if(i===0)return".";let l=-1,c=0;const T=n.charCodeAt(0);if(i===1)return d(T)?n:".";if(d(T)){if(l=c=1,d(n.charCodeAt(1))){let u=2,R=u;for(;u<i&&!d(n.charCodeAt(u));)u++;if(u<i&&u!==R){for(R=u;u<i&&d(n.charCodeAt(u));)u++;if(u<i&&u!==R){for(R=u;u<i&&!d(n.charCodeAt(u));)u++;if(u===i)return n;u!==R&&(l=c=u+1)}}}}else f(T)&&n.charCodeAt(1)===N&&(l=i>2&&d(n.charCodeAt(2))?3:2,c=l);let h=-1,w=!0;for(let u=i-1;u>=c;--u)if(d(n.charCodeAt(u))){if(!w){h=u;break}}else w=!1;if(h===-1){if(l===-1)return".";h=l}return n.slice(0,h)},basename(n,i){i!==void 0&&o(i,"ext"),o(n,"path");let l=0,c=-1,T=!0,h;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===N&&(l=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let w=i.length-1,u=-1;for(h=n.length-1;h>=l;--h){const R=n.charCodeAt(h);if(d(R)){if(!T){l=h+1;break}}else u===-1&&(T=!1,u=h+1),w>=0&&(R===i.charCodeAt(w)?--w===-1&&(c=h):(w=-1,c=u))}return l===c?c=u:c===-1&&(c=n.length),n.slice(l,c)}for(h=n.length-1;h>=l;--h)if(d(n.charCodeAt(h))){if(!T){l=h+1;break}}else c===-1&&(T=!1,c=h+1);return c===-1?"":n.slice(l,c)},extname(n){o(n,"path");let i=0,l=-1,c=0,T=-1,h=!0,w=0;n.length>=2&&n.charCodeAt(1)===N&&f(n.charCodeAt(0))&&(i=c=2);for(let u=n.length-1;u>=i;--u){const R=n.charCodeAt(u);if(d(R)){if(!h){c=u+1;break}continue}T===-1&&(h=!1,T=u+1),R===F?l===-1?l=u:w!==1&&(w=1):l!==-1&&(w=-1)}return l===-1||T===-1||w===0||w===1&&l===T-1&&l===c+1?"":n.slice(l,T)},format:A.bind(null,"\\"),parse(n){o(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.length;let c=0,T=n.charCodeAt(0);if(l===1)return d(T)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(d(T)){if(c=1,d(n.charCodeAt(1))){let $=2,V=$;for(;$<l&&!d(n.charCodeAt($));)$++;if($<l&&$!==V){for(V=$;$<l&&d(n.charCodeAt($));)$++;if($<l&&$!==V){for(V=$;$<l&&!d(n.charCodeAt($));)$++;$===l?c=$:$!==V&&(c=$+1)}}}}else if(f(T)&&n.charCodeAt(1)===N){if(l<=2)return i.root=i.dir=n,i;if(c=2,d(n.charCodeAt(2))){if(l===3)return i.root=i.dir=n,i;c=3}}c>0&&(i.root=n.slice(0,c));let h=-1,w=c,u=-1,R=!0,S=n.length-1,m=0;for(;S>=c;--S){if(T=n.charCodeAt(S),d(T)){if(!R){w=S+1;break}continue}u===-1&&(R=!1,u=S+1),T===F?h===-1?h=S:m!==1&&(m=1):h!==-1&&(m=-1)}return u!==-1&&(h===-1||m===0||m===1&&h===u-1&&h===w+1?i.base=i.name=n.slice(w,u):(i.name=n.slice(w,h),i.base=n.slice(w,u),i.ext=n.slice(h,u))),w>0&&w!==c?i.dir=n.slice(0,w-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(r){const n=/\\/g;return()=>{const i=g.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>g.cwd()})();e.$jc={resolve(...n){let i="",l=!1;for(let c=n.length-1;c>=-1&&!l;c--){const T=c>=0?n[c]:s();o(T,"path"),T.length!==0&&(i=`${T}/${i}`,l=T.charCodeAt(0)===U)}return i=y(i,!l,"/",b),l?`/${i}`:i.length>0?i:"."},normalize(n){if(o(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===U,l=n.charCodeAt(n.length-1)===U;return n=y(n,!i,"/",b),n.length===0?i?"/":l?"./":".":(l&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return o(n,"path"),n.length>0&&n.charCodeAt(0)===U},join(...n){if(n.length===0)return".";let i;for(let l=0;l<n.length;++l){const c=n[l];o(c,"path"),c.length>0&&(i===void 0?i=c:i+=`/${c}`)}return i===void 0?".":e.$jc.normalize(i)},relative(n,i){if(o(n,"from"),o(i,"to"),n===i||(n=e.$jc.resolve(n),i=e.$jc.resolve(i),n===i))return"";const l=1,c=n.length,T=c-l,h=1,w=i.length-h,u=T<w?T:w;let R=-1,S=0;for(;S<u;S++){const $=n.charCodeAt(l+S);if($!==i.charCodeAt(h+S))break;$===U&&(R=S)}if(S===u)if(w>u){if(i.charCodeAt(h+S)===U)return i.slice(h+S+1);if(S===0)return i.slice(h+S)}else T>u&&(n.charCodeAt(l+S)===U?R=S:S===0&&(R=0));let m="";for(S=l+R+1;S<=c;++S)(S===c||n.charCodeAt(S)===U)&&(m+=m.length===0?"..":"/..");return`${m}${i.slice(h+R)}`},toNamespacedPath(n){return n},dirname(n){if(o(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===U;let l=-1,c=!0;for(let T=n.length-1;T>=1;--T)if(n.charCodeAt(T)===U){if(!c){l=T;break}}else c=!1;return l===-1?i?"/":".":i&&l===1?"//":n.slice(0,l)},basename(n,i){i!==void 0&&o(i,"ext"),o(n,"path");let l=0,c=-1,T=!0,h;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let w=i.length-1,u=-1;for(h=n.length-1;h>=0;--h){const R=n.charCodeAt(h);if(R===U){if(!T){l=h+1;break}}else u===-1&&(T=!1,u=h+1),w>=0&&(R===i.charCodeAt(w)?--w===-1&&(c=h):(w=-1,c=u))}return l===c?c=u:c===-1&&(c=n.length),n.slice(l,c)}for(h=n.length-1;h>=0;--h)if(n.charCodeAt(h)===U){if(!T){l=h+1;break}}else c===-1&&(T=!1,c=h+1);return c===-1?"":n.slice(l,c)},extname(n){o(n,"path");let i=-1,l=0,c=-1,T=!0,h=0;for(let w=n.length-1;w>=0;--w){const u=n.charCodeAt(w);if(u===U){if(!T){l=w+1;break}continue}c===-1&&(T=!1,c=w+1),u===F?i===-1?i=w:h!==1&&(h=1):i!==-1&&(h=-1)}return i===-1||c===-1||h===0||h===1&&i===c-1&&i===l+1?"":n.slice(i,c)},format:A.bind(null,"/"),parse(n){o(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.charCodeAt(0)===U;let c;l?(i.root="/",c=1):c=0;let T=-1,h=0,w=-1,u=!0,R=n.length-1,S=0;for(;R>=c;--R){const m=n.charCodeAt(R);if(m===U){if(!u){h=R+1;break}continue}w===-1&&(u=!1,w=R+1),m===F?T===-1?T=R:S!==1&&(S=1):T!==-1&&(S=-1)}if(w!==-1){const m=h===0&&l?1:h;T===-1||S===0||S===1&&T===w-1&&T===h+1?i.base=i.name=n.slice(m,w):(i.name=n.slice(m,T),i.base=n.slice(m,w),i.ext=n.slice(T,w))}return h>0?i.dir=n.slice(0,h-1):l&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=r?e.$ic.normalize:e.$jc.normalize,e.$lc=r?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=r?e.$ic.join:e.$jc.join,e.$nc=r?e.$ic.resolve:e.$jc.resolve,e.$oc=r?e.$ic.relative:e.$jc.relative,e.$pc=r?e.$ic.dirname:e.$jc.dirname,e.$qc=r?e.$ic.basename:e.$jc.basename,e.$rc=r?e.$ic.extname:e.$jc.extname,e.$sc=r?e.$ic.format:e.$jc.format,e.$tc=r?e.$ic.parse:e.$jc.parse,e.$uc=r?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=r?e.$ic.sep:e.$jc.sep,e.$wc=r?e.$ic.delimiter:e.$jc.delimiter}),define(_e[29],Ee([0,1,2]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=M,e.$mm=Y;var t;(function(F){F[F.stdout=0]="stdout",F[F.stderr=1]="stderr"})(t||(e.Source=t={}));var q;(function(F){F[F.Success=0]="Success",F[F.Unknown=1]="Unknown",F[F.AccessDenied=2]="AccessDenied",F[F.ProcessNotFound=3]="ProcessNotFound"})(q||(e.TerminateResponseCode=q={}));function M(F,...U){const P=U.reduce((v,k)=>(v[k]=!0,v),{}),N=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(F).filter(v=>!P[v]).forEach(v=>{for(let k=0;k<N.length;k++)if(v.search(N[k])!==-1){delete F[v];break}})}function Y(F){F&&(delete F.DEBUG,g.$d&&delete F.DYLD_LIBRARY_PATH,g.$e&&delete F.LD_PRELOAD)}}),define(_e[41],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const g=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(M){return new t(M)}constructor(M){this.c=g&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=t}),define(_e[6],Ee([0,1,9,26,4,40,41]),function(ae,e,g,t,q,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=k;const F=!1,U=!1,P=!1;var N;(function(ee){ee.None=()=>q.$Xc.None;function K(he){if(P){const{onDidAddListener:fe}=he,be=r.create();let ge=0;he.onDidAddListener=()=>{++ge===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),fe?.()}}}function re(he,fe){return D(he,()=>{},0,void 0,!0,void 0,fe)}ee.defer=re;function X(he){return(fe,be=null,ge)=>{let we=!1,Ae;return Ae=he(Re=>{if(!we)return Ae?Ae.dispose():we=!0,fe.call(be,Re)},null,ge),we&&Ae.dispose(),Ae}}ee.once=X;function te(he,fe,be){return B((ge,we=null,Ae)=>he(Re=>ge.call(we,fe(Re)),null,Ae),be)}ee.map=te;function ue(he,fe,be){return B((ge,we=null,Ae)=>he(Re=>{fe(Re),ge.call(we,Re)},null,Ae),be)}ee.forEach=ue;function ce(he,fe,be){return B((ge,we=null,Ae)=>he(Re=>fe(Re)&&ge.call(we,Re),null,Ae),be)}ee.filter=ce;function I(he){return he}ee.signal=I;function a(...he){return(fe,be=null,ge)=>{const we=(0,q.$Uc)(...he.map(Ae=>Ae(Re=>fe.call(be,Re))));return Z(we,ge)}}ee.any=a;function O(he,fe,be,ge){let we=be;return te(he,Ae=>(we=fe(we,Ae),we),ge)}ee.reduce=O;function B(he,fe){let be;const ge={onWillAddFirstListener(){be=he(we.fire,we)},onDidRemoveLastListener(){be?.dispose()}};fe||K(ge);const we=new i(ge);return fe?.add(we),we.event}function Z(he,fe){return fe instanceof Array?fe.push(he):fe&&fe.add(he),he}function D(he,fe,be=100,ge=!1,we=!1,Ae,Re){let Ue,Oe,Fe,Be=0,pe;const ye={leakWarningThreshold:Ae,onWillAddFirstListener(){Ue=he(He=>{Be++,Oe=fe(Oe,He),ge&&!Fe&&(Pe.fire(Oe),Oe=void 0),pe=()=>{const ze=Oe;Oe=void 0,Fe=void 0,(!ge||Be>1)&&Pe.fire(ze),Be=0},typeof be=="number"?(clearTimeout(Fe),Fe=setTimeout(pe,be)):Fe===void 0&&(Fe=0,queueMicrotask(pe))})},onWillRemoveListener(){we&&Be>0&&pe?.()},onDidRemoveLastListener(){pe=void 0,Ue.dispose()}};Re||K(ye);const Pe=new i(ye);return Re?.add(Pe),Pe.event}ee.debounce=D;function J(he,fe=0,be){return ee.debounce(he,(ge,we)=>ge?(ge.push(we),ge):[we],fe,void 0,!0,void 0,be)}ee.accumulate=J;function C(he,fe=(ge,we)=>ge===we,be){let ge=!0,we;return ce(he,Ae=>{const Re=ge||!fe(Ae,we);return ge=!1,we=Ae,Re},be)}ee.latch=C;function ie(he,fe,be){return[ee.filter(he,fe,be),ee.filter(he,ge=>!fe(ge),be)]}ee.split=ie;function le(he,fe=!1,be=[],ge){let we=be.slice(),Ae=he(Oe=>{we?we.push(Oe):Ue.fire(Oe)});ge&&ge.add(Ae);const Re=()=>{we?.forEach(Oe=>Ue.fire(Oe)),we=null},Ue=new i({onWillAddFirstListener(){Ae||(Ae=he(Oe=>Ue.fire(Oe)),ge&&ge.add(Ae))},onDidAddFirstListener(){we&&(fe?setTimeout(Re):Re())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return ge&&ge.add(Ue),Ue.event}ee.buffer=le;function de(he,fe){return(ge,we,Ae)=>{const Re=fe(new W);return he(function(Ue){const Oe=Re.evaluate(Ue);Oe!==p&&ge.call(we,Oe)},void 0,Ae)}}ee.chain=de;const p=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(be=>(fe(be),be)),this}filter(fe){return this.f.push(be=>fe(be)?be:p),this}reduce(fe,be){let ge=be;return this.f.push(we=>(ge=fe(ge,we),ge)),this}latch(fe=(be,ge)=>be===ge){let be=!0,ge;return this.f.push(we=>{const Ae=be||!fe(we,ge);return be=!1,ge=we,Ae?we:p}),this}evaluate(fe){for(const be of this.f)if(fe=be(fe),fe===p)break;return fe}}function G(he,fe,be=ge=>ge){const ge=(...Ue)=>Re.fire(be(...Ue)),we=()=>he.on(fe,ge),Ae=()=>he.removeListener(fe,ge),Re=new i({onWillAddFirstListener:we,onDidRemoveLastListener:Ae});return Re.event}ee.fromNodeEventEmitter=G;function j(he,fe,be=ge=>ge){const ge=(...Ue)=>Re.fire(be(...Ue)),we=()=>he.addEventListener(fe,ge),Ae=()=>he.removeEventListener(fe,ge),Re=new i({onWillAddFirstListener:we,onDidRemoveLastListener:Ae});return Re.event}ee.fromDOMEventEmitter=j;function E(he){return new Promise(fe=>X(he)(fe))}ee.toPromise=E;function H(he){const fe=new i;return he.then(be=>{fe.fire(be)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}ee.fromPromise=H;function Q(he,fe,be){return fe(be),he(ge=>fe(ge))}ee.runAndSubscribe=Q;class ne{constructor(fe,be){this._observable=fe,this.f=0,this.g=!1;const ge={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};be||K(ge),this.emitter=new i(ge),be&&be.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,be){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(he,fe){return new ne(he,fe).emitter.event}ee.fromObservable=$e;function De(he){return(fe,be,ge)=>{let we=0,Ae=!1;const Re={beginUpdate(){we++},endUpdate(){we--,we===0&&(he.reportChanges(),Ae&&(Ae=!1,fe.call(be)))},handlePossibleChange(){},handleChange(){Ae=!0}};he.addObserver(Re),he.reportChanges();const Ue={dispose(){he.removeObserver(Re)}};return ge instanceof q.$Wc?ge.add(Ue):Array.isArray(ge)&&ge.push(Ue),Ue}}ee.fromObservableLight=De})(N||(e.Event=N={}));class _{constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${_.f++}`,_.all.add(this)}start(K){this.g=new Y.$he,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}e.$je=_,_.all=new Set,_.f=0;let v=-1;function k(ee){const K=v;return v=ee,{dispose(){v=K}}}class o{constructor(K,re,X=(o.f++).toString(16).padStart(3,"0")){this.j=K,this.threshold=re,this.name=X,this.h=0}dispose(){this.g?.clear()}check(K,re){const X=this.threshold;if(X<=0||re<X)return;this.g||(this.g=new Map);const te=this.g.get(K.value)||0;if(this.g.set(K.value,te+1),this.h-=1,this.h<=0){this.h=X*.5;const[ue,ce]=this.getMostFrequentStack(),I=`[${this.name}] potential listener LEAK detected, having ${re} listeners already. MOST frequent listener (${ce}):`;console.warn(I),console.warn(ue);const a=new d(I,ue);this.j(a)}return()=>{const ue=this.g.get(K.value)||0;this.g.set(K.value,ue-1)}}getMostFrequentStack(){if(!this.g)return;let K,re=0;for(const[X,te]of this.g)(!K||re<te)&&(K=[X,te],re=te);return K}}o.f=1;class r{static create(){const K=new Error;return new r(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(K,re){super(K),this.name="ListenerLeakError",this.stack=re}}e.$le=d;class b extends Error{constructor(K,re){super(K),this.name="ListenerRefusalError",this.stack=re}}e.$me=b;let f=0;class y{constructor(K){this.value=K,this.id=f++}}const A=2,s=(ee,K)=>{if(ee instanceof y)K(ee);else for(let re=0;re<ee.length;re++){const X=ee[re];X&&K(X)}};let n;if(F){const ee=[];setInterval(()=>{ee.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(ee.join(`
`)),ee.length=0)},3e3),n=new FinalizationRegistry(K=>{typeof K=="string"&&ee.push(K)})}class i{constructor(K){this.z=0,this.f=K,this.g=v>0||this.f?.leakWarningThreshold?new o(K?.onListenerError??g.$3,this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new _(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(U){const K=this.u;queueMicrotask(()=>{s(K,re=>re.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(K,re,X)=>{if(this.g&&this.z>this.g.threshold**2){const a=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(a);const O=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],B=new b(`${a}. HINT: Stack shows most frequent listener (${O[1]}-times)`,O[0]);return(this.f?.onListenerError||g.$3)(B),q.$Xc.None}if(this.m)return q.$Xc.None;re&&(K=K.bind(re));const te=new y(K);let ue,ce;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(te.stack=r.create(),ue=this.g.check(te.stack,this.z+1)),U&&(te.stack=ce??r.create()),this.u?this.u instanceof y?(this.w??(this.w=new c),this.u=[this.u,te]):this.u.push(te):(this.f?.onWillAddFirstListener?.(this),this.u=te,this.f?.onDidAddFirstListener?.(this)),this.z++;const I=(0,q.$Vc)(()=>{n?.unregister(I),ue?.(),this.A(te)});if(X instanceof q.$Wc?X.add(I):Array.isArray(X)&&X.push(I),n){const a=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),O=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(a);n.register(I,O?.[2]??a,I)}return I}),this.q}A(K){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const re=this.u,X=re.indexOf(K);if(X===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,re[X]=void 0;const te=this.w.current===this;if(this.z*A<=re.length){let ue=0;for(let ce=0;ce<re.length;ce++)re[ce]?re[ue++]=re[ce]:te&&(this.w.end--,ue<this.w.i&&this.w.i--);re.length=ue}}B(K,re){if(!K)return;const X=this.f?.onListenerError||g.$3;if(!X){K.value(re);return}try{K.value(re)}catch(te){X(te)}}C(K){const re=K.current.u;for(;K.i<K.end;)this.B(re[K.i++],K.value);K.reset()}fire(K){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof y)this.B(this.u,K);else{const re=this.w;re.enqueue(this,K,this.u.length),this.C(re)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=i;const l=()=>new c;e.$oe=l;class c{constructor(){this.i=-1,this.end=0}enqueue(K,re,X){this.i=0,this.end=X,this.current=K,this.value=re}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class T extends i{async fireAsync(K,re,X){if(this.u)for(this.h||(this.h=new M.$8c),s(this.u,te=>this.h.push([te.value,K]));this.h.size>0&&!re.isCancellationRequested;){const[te,ue]=this.h.shift(),ce=[],I={...ue,token:re,waitUntil:a=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");X&&(a=X(a,te)),ce.push(a)}};try{te(I)}catch(a){(0,g.$3)(a);continue}Object.freeze(ce),await Promise.allSettled(ce).then(a=>{for(const O of a)O.status==="rejected"&&(0,g.$3)(O.reason)})}}}e.$pe=T;class h extends i{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new M.$8c,this.t=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.t(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.z&&(this.h!==0?this.s.push(K):super.fire(K))}}e.$qe=h;class w extends h{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}e.$re=w;class u extends i{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(re=>super.fire(re)),this.h=[]}))}}e.$se=u;class R{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const re={event:K,listener:null};this.h.push(re),this.g&&this.m(re);const X=()=>{this.g&&this.o(re);const te=this.h.indexOf(re);this.h.splice(te,1)};return(0,q.$Vc)((0,t.$gb)(X))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(re=>this.f.fire(re))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}e.$te=R;class S{constructor(K,re,X,te){this.f=new q.$Wc;const ue=this.f.add(new R),ce=this.f.add(new q.$7c);function I(a){ce.set(a,ue.add(te(a)))}for(const a of K)I(a);this.f.add(re(a=>{I(a)})),this.f.add(X(a=>{ce.deleteAndDispose(a)})),this.event=ue.event}dispose(){this.f.dispose()}}e.$ue=S;class m{constructor(){this.f=[]}wrapEvent(K,re,X){return(te,ue,ce)=>K(I=>{const a=this.f[this.f.length-1];if(!re){a?a.buffers.push(()=>te.call(ue,I)):te.call(ue,I);return}const O=a;if(!O){te.call(ue,re(X,I));return}O.items??(O.items=[]),O.items.push(I),O.buffers.length===0&&a.buffers.push(()=>{O.reducedResult??(O.reducedResult=X?O.items.reduce(re,X):O.items.reduce(re)),te.call(ue,O.reducedResult)})},void 0,ce)}bufferEvents(K){const re={buffers:new Array};this.f.push(re);const X=K();return this.f.pop(),re.buffers.forEach(te=>te()),X}}e.$ve=m;class ${constructor(){this.f=!1,this.g=N.None,this.h=q.$Xc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=$;class V{static const(K){return new se(K)}constructor(K){this.g=K,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}e.$xe=V;class se{constructor(K){this.value=K,this.onDidChange=N.None}}}),define(_e[13],Ee([0,1,6]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=F;const t=Object.freeze(function(U,P){const N=setTimeout(U.bind(P),0);return{dispose(){clearTimeout(N)}}});var q;(function(U){function P(N){return N===U.None||N===U.Cancelled||N instanceof M?!0:!N||typeof N!="object"?!1:typeof N.isCancellationRequested=="boolean"&&typeof N.onCancellationRequested=="function"}U.isCancellationToken=P,U.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),U.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(q||(e.CancellationToken=q={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new g.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class Y{constructor(P){this.f=void 0,this.g=void 0,this.g=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=q.Cancelled}dispose(P=!1){P&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=q.None}}e.$ye=Y;function F(U){const P=new Y;return U.add({dispose(){P.cancel()}}),P.token}}),define(_e[42],Ee([0,1,13]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=q;class t{constructor(U){this.b=U,this.a=null}get(){if(this.a)return this.a;const U=new g.$ye,P=this.b(U.token);return this.a={promise:P,dispose:()=>{this.a=null,U.cancel(),U.dispose()}},this.a}}e.$$e=t;function q(F){return F}class M{constructor(U,P){this.a=void 0,this.b=void 0,typeof U=="function"?(this.c=U,this.d=q):(this.c=P,this.d=U.getCacheKey)}get(U){const P=this.d(U);return this.b!==P&&(this.b=P,this.a=this.c(U)),this.a}}e.$af=M;class Y{get cachedValues(){return this.a}constructor(U,P){this.a=new Map,this.b=new Map,typeof U=="function"?(this.c=U,this.d=q):(this.c=P,this.d=U.getCacheKey)}get(U){const P=this.d(U);if(this.b.has(P))return this.b.get(P);const N=this.c(U);return this.a.set(U,N),this.b.set(P,N),N}}e.$bf=Y}),define(_e[43],Ee([0,1,9,4]),function(ae,e,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=q,e.$Be=M,e.$Ce=Y,e.$De=F,e.$Ee=P,e.$Fe=N,e.$Ge=_,e.$He=v,e.$Ie=k,e.$Je=o,e.$Ke=r,e.$Le=d,e.$Me=b,e.$Ne=f,e.$Oe=y;function q(A){const s=A;return s?typeof s.read=="function":!1}function M(A){const s=A;return s?[s.on,s.pause,s.resume,s.destroy].every(n=>typeof n=="function"):!1}function Y(A){const s=A;return s?M(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function F(A,s){return new U(A,s)}class U{constructor(s,n){this.e=s,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(n=>n(s))}h(s){this.c.error.length===0?(0,g.$3)(s):this.c.error.slice(0).forEach(n=>n(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,n){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(s,n){if(this.a.destroyed)return;let i;switch(s){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const l=i.indexOf(n);l>=0&&i.splice(l,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function P(A,s){const n=[];let i;for(;(i=A.read())!==null;)n.push(i);return s(n)}function N(A,s,n){const i=[];let l;for(;(l=A.read())!==null&&i.length<n;)i.push(l);return l===null&&i.length>0?s(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l<"u"){const c=l;return l=void 0,c}return A.read()}}}function _(A,s){return new Promise((n,i)=>{const l=[];v(A,{onData:c=>{s&&l.push(c)},onError:c=>{s?i(c):n(void 0)},onEnd:()=>{n(s?s(l):void 0)}})})}function v(A,s,n){A.on("error",i=>{n?.isCancellationRequested||s.onError(i)}),A.on("end",()=>{n?.isCancellationRequested||s.onEnd()}),A.on("data",i=>{n?.isCancellationRequested||s.onData(i)})}function k(A,s){return new Promise((n,i)=>{const l=new t.$Wc,c=[],T=u=>{if(c.push(u),c.length>s)return l.dispose(),A.pause(),n({stream:A,buffer:c,ended:!1})},h=u=>(l.dispose(),i(u)),w=()=>(l.dispose(),n({stream:A,buffer:c,ended:!0}));l.add((0,t.$Vc)(()=>A.removeListener("error",h))),A.on("error",h),l.add((0,t.$Vc)(()=>A.removeListener("end",w))),A.on("end",w),l.add((0,t.$Vc)(()=>A.removeListener("data",T))),A.on("data",T)})}function o(A,s){const n=F(s);return n.end(A),n}function r(){const A=F(()=>{throw new Error("not supported")});return A.end(),A}function d(A){let s=!1;return{read:()=>s?null:(s=!0,A)}}function b(A,s,n){const i=F(n);return v(A,{onData:l=>i.write(s.data(l)),onError:l=>i.error(s.error?s.error(l):l),onEnd:()=>i.end()}),i}function f(A,s,n){let i=!1;return{read:()=>{const l=s.read();return i?l:(i=!0,l!==null?n([A,l]):A)}}}function y(A,s,n){let i=!1;const l=F(n);return v(s,{onData:c=>i?l.write(c):(i=!0,l.write(n([A,c]))),onError:c=>l.error(c),onEnd:()=>{i||(i=!0,l.write(A)),l.end()}}),l}}),define(_e[16],Ee([0,1,15,43]),function(ae,e,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=P,e.$Re=N,e.$Se=_,e.$Te=v,e.$Ue=k,e.$Ve=o,e.$We=r,e.$Xe=d,e.$Ye=b,e.$Ze=f,e.$1e=y,e.$2e=A,e.$3e=s,e.$4e=n,e.$5e=i,e.$6e=l,e.$7e=c,e.$8e=T,e.$9e=h,e.$0e=R,t=Ie(t);const q=typeof Buffer<"u",M=new g.$X(()=>new Uint8Array(256));let Y,F;class U{static alloc(m){return q?new U(Buffer.allocUnsafe(m)):new U(new Uint8Array(m))}static wrap(m){return q&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new U(m)}static fromString(m,$){return!($?.dontUseNodeBuffer||!1)&&q?new U(Buffer.from(m)):(Y||(Y=new TextEncoder),new U(Y.encode(m)))}static fromByteArray(m){const $=U.alloc(m.length);for(let V=0,se=m.length;V<se;V++)$.buffer[V]=m[V];return $}static concat(m,$){if(typeof $>"u"){$=0;for(let ee=0,K=m.length;ee<K;ee++)$+=m[ee].byteLength}const V=U.alloc($);let se=0;for(let ee=0,K=m.length;ee<K;ee++){const re=m[ee];V.set(re,se),se+=re.byteLength}return V}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=U.alloc(this.byteLength);return m.set(this),m}toString(){return q?this.buffer.toString():(F||(F=new TextDecoder),F.decode(this.buffer))}slice(m,$){return new U(this.buffer.subarray(m,$))}set(m,$){if(m instanceof U)this.buffer.set(m.buffer,$);else if(m instanceof Uint8Array)this.buffer.set(m,$);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),$);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),$);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return v(this.buffer,m)}writeUInt32BE(m,$){k(this.buffer,m,$)}readUInt32LE(m){return o(this.buffer,m)}writeUInt32LE(m,$){r(this.buffer,m,$)}readUInt8(m){return d(this.buffer,m)}writeUInt8(m,$){b(this.buffer,m,$)}indexOf(m,$=0){return P(this.buffer,m instanceof U?m.buffer:m,$)}}e.$Pe=U;function P(S,m,$=0){const V=m.byteLength,se=S.byteLength;if(V===0)return 0;if(V===1)return S.indexOf(m[0]);if(V>se-$)return-1;const ee=M.value;ee.fill(m.length);for(let te=0;te<m.length;te++)ee[m[te]]=m.length-te-1;let K=$+m.length-1,re=K,X=-1;for(;K<se;)if(S[K]===m[re]){if(re===0){X=K;break}K--,re--}else K+=Math.max(m.length-re,ee[S[K]]),re=m.length-1;return X}function N(S,m){return S[m+0]<<0>>>0|S[m+1]<<8>>>0}function _(S,m,$){S[$+0]=m&255,m=m>>>8,S[$+1]=m&255}function v(S,m){return S[m]*2**24+S[m+1]*2**16+S[m+2]*2**8+S[m+3]}function k(S,m,$){S[$+3]=m,m=m>>>8,S[$+2]=m,m=m>>>8,S[$+1]=m,m=m>>>8,S[$]=m}function o(S,m){return S[m+0]<<0>>>0|S[m+1]<<8>>>0|S[m+2]<<16>>>0|S[m+3]<<24>>>0}function r(S,m,$){S[$+0]=m&255,m=m>>>8,S[$+1]=m&255,m=m>>>8,S[$+2]=m&255,m=m>>>8,S[$+3]=m&255}function d(S,m){return S[m]}function b(S,m,$){S[$]=m}function f(S){return t.$Ee(S,m=>U.concat(m))}function y(S){return t.$Le(S)}function A(S){return t.$Ge(S,m=>U.concat(m))}async function s(S){return S.ended?U.concat(S.buffer):U.concat([...S.buffer,await A(S.stream)])}function n(S){return t.$Je(S,m=>U.concat(m))}function i(S){return t.$Me(S,{data:m=>typeof m=="string"?U.fromString(m):U.wrap(m)},m=>U.concat(m))}function l(S){return t.$De(m=>U.concat(m),S)}function c(S,m){return t.$Ne(S,m,$=>U.concat($))}function T(S,m){return t.$Oe(S,m,$=>U.concat($))}function h(S){let m=0,$=0,V=0;const se=new Uint8Array(Math.floor(S.length/4*3)),ee=re=>{switch($){case 3:se[V++]=m|re,$=0;break;case 2:se[V++]=m|re>>>2,m=re<<6,$=3;break;case 1:se[V++]=m|re>>>4,m=re<<4,$=2;break;default:m=re<<2,$=1}};for(let re=0;re<S.length;re++){const X=S.charCodeAt(re);if(X>=65&&X<=90)ee(X-65);else if(X>=97&&X<=122)ee(X-97+26);else if(X>=48&&X<=57)ee(X-48+52);else if(X===43||X===45)ee(62);else if(X===47||X===95)ee(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${S[re]}`)}}const K=V;for(;$>0;)ee(0);return U.wrap(se).slice(0,K)}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:S},m=!0,$=!1){const V=$?u:w;let se="";const ee=S.byteLength%3;let K=0;for(;K<S.byteLength-ee;K+=3){const re=S[K+0],X=S[K+1],te=S[K+2];se+=V[re>>>2],se+=V[(re<<4|X>>>4)&63],se+=V[(X<<2|te>>>6)&63],se+=V[te&63]}if(ee===1){const re=S[K+0];se+=V[re>>>2],se+=V[re<<4&63],m&&(se+="==")}else if(ee===2){const re=S[K+0],X=S[K+1];se+=V[re>>>2],se+=V[(re<<4|X>>>4)&63],se+=V[X<<2&63],m&&(se+="=")}return se}}),define(_e[44],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(_e[10],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=g,e.$hg=t,e.$ig=q,e.$jg=M,e.$kg=Y,e.$lg=F,e.$mg=U,e.$ng=P,e.$og=N,e.$pg=_,e.$qg=v,e.$rg=k,e.$sg=o,e.$tg=d,e.$ug=b,e.$vg=f,e.$wg=y,e.$xg=A;function g(s){return typeof s=="string"}function t(s){return Array.isArray(s)&&s.every(n=>g(n))}function q(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function M(s){const n=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof n}function Y(s){return typeof s=="number"&&!isNaN(s)}function F(s){return!!s&&typeof s[Symbol.iterator]=="function"}function U(s){return s===!0||s===!1}function P(s){return typeof s>"u"}function N(s){return!_(s)}function _(s){return P(s)||s===null}function v(s,n){if(!s)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function k(s){if(_(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function o(...s){const n=[];for(let i=0;i<s.length;i++){const l=s[i];if(_(l))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(l)}return n}const r=Object.prototype.hasOwnProperty;function d(s){if(!q(s))return!1;for(const n in s)if(r.call(s,n))return!1;return!0}function b(s){return typeof s=="function"}function f(...s){return s.length>0&&s.every(b)}function y(s,n){const i=Math.min(s.length,n.length);for(let l=0;l<i;l++)A(s[l],n[l])}function A(s,n){if(g(n)){if(typeof s!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(b(n)){try{if(s instanceof n)return}catch{}if(!_(s)&&s.constructor===n||n.length===1&&n.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(_e[45],Ee([0,1,10]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=t,e.$go=q,e.$ho=Y,e.$io=U,e.$jo=P,e.$ko=N,e.$lo=_,e.$mo=v,e.$no=k,e.$oo=o,e.$po=r,e.$qo=d,e.$ro=b;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const y=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([A,s])=>{y[A]=s&&typeof s=="object"?t(s):s}),y}function q(f){if(!f||typeof f!="object")return f;const y=[f];for(;y.length>0;){const A=y.shift();Object.freeze(A);for(const s in A)if(M.call(A,s)){const n=A[s];typeof n=="object"&&!Object.isFrozen(n)&&!(0,g.$jg)(n)&&y.push(n)}}return f}const M=Object.prototype.hasOwnProperty;function Y(f,y){return F(f,y,new Set)}function F(f,y,A){if((0,g.$pg)(f))return f;const s=y(f);if(typeof s<"u")return s;if(Array.isArray(f)){const n=[];for(const i of f)n.push(F(i,y,A));return n}if((0,g.$ig)(f)){if(A.has(f))throw new Error("Cannot clone recursive data-structure");A.add(f);const n={};for(const i in f)M.call(f,i)&&(n[i]=F(f[i],y,A));return A.delete(f),n}return f}function U(f,y,A=!0){return(0,g.$ig)(f)?((0,g.$ig)(y)&&Object.keys(y).forEach(s=>{s in f?A&&((0,g.$ig)(f[s])&&(0,g.$ig)(y[s])?U(f[s],y[s],A):f[s]=y[s]):f[s]=y[s]}),f):y}function P(f,y){if(f===y)return!0;if(f==null||y===null||y===void 0||typeof f!=typeof y||typeof f!="object"||Array.isArray(f)!==Array.isArray(y))return!1;let A,s;if(Array.isArray(f)){if(f.length!==y.length)return!1;for(A=0;A<f.length;A++)if(!P(f[A],y[A]))return!1}else{const n=[];for(s in f)n.push(s);n.sort();const i=[];for(s in y)i.push(s);if(i.sort(),!P(n,i))return!1;for(A=0;A<n.length;A++)if(!P(f[n[A]],y[n[A]]))return!1}return!0}function N(f){const y=new Set;return JSON.stringify(f,(A,s)=>{if((0,g.$ig)(s)||Array.isArray(s)){if(y.has(s))return"[Circular]";y.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function _(f,y){const A=Object.create(null);return!f||!y||Object.keys(y).forEach(n=>{const i=f[n],l=y[n];P(i,l)||(A[n]=l)}),A}function v(f,y){const A=y.toLowerCase(),s=Object.keys(f).find(n=>n.toLowerCase()===A);return s?f[s]:f[y]}function k(f,y){const A=Object.create(null);for(const[s,n]of Object.entries(f))y(s,n)&&(A[s]=n);return A}function o(f){let y=[];for(;Object.prototype!==f;)y=y.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return y}function r(f){const y=[];for(const A of o(f))typeof f[A]=="function"&&y.push(A);return y}function d(f,y){const A=n=>function(){const i=Array.prototype.slice.call(arguments,0);return y(n,i)},s={};for(const n of f)s[n]=A(n);return s}function b(f,y){const A={};for(const[s,n]of Object.entries(f))A[s]=y(n,s);return A}}),define(_e[46],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=t,e.$df=q;var g;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g||(e.Constants=g={}));function t(M){return M<0?0:M>g.MAX_UINT_8?g.MAX_UINT_8:M|0}function q(M){return M<0?0:M>g.MAX_UINT_32?g.MAX_UINT_32:M|0}}),define(_e[7],Ee([0,1,42,11,15,46]),function(ae,e,g,t,q,M){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=F,e.$ff=P,e.$gf=_,e.$hf=v,e.$if=k,e.$jf=o,e.$kf=r,e.$lf=d,e.$mf=b,e.$nf=f,e.$of=y,e.$pf=A,e.$qf=s,e.$rf=n,e.$sf=i,e.$tf=l,e.$uf=c,e.$vf=T,e.$wf=h,e.$xf=w,e.$yf=u,e.$zf=R,e.$Af=S,e.$Bf=m,e.$Cf=$,e.$Df=V,e.$Ef=se,e.$Ff=ee,e.$Gf=K,e.$Hf=re,e.$If=X,e.$Jf=te,e.$Kf=ue,e.$Lf=ce,e.$Mf=I,e.$Nf=a,e.$Of=O,e.$Rf=J,e.$Sf=C,e.$Tf=ie,e.$Uf=le,e.$Vf=W,e.$Wf=j,e.$Yf=E,e.$Zf=H,e.$1f=Q,e.$2f=ne,e.$3f=De,e.$4f=he,e.$5f=be,e.$7f=ge,e.$8f=we,e.$9f=Ae,e.$0f=Re,e.$$f=Ue,e.$_f=Oe,e.$ag=Fe,e.$bg=Be,e.$cg=ze;function F(L){return!L||typeof L!="string"?!0:L.trim().length===0}const U=/{(\d+)}/g;function P(L,...z){return z.length===0?L:L.replace(U,function(x,oe){const me=parseInt(oe,10);return isNaN(me)||me<0||me>=z.length?x:z[me]})}const N=/{([^}]+)}/g;function _(L,z){return Object.keys(z).length===0?L:L.replace(N,(x,oe)=>z[oe]??x)}function v(L){return L.replace(/[<>"'&]/g,z=>{switch(z){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return z})}function k(L){return L.replace(/[<>&]/g,function(z){switch(z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return z}})}function o(L){return L.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function r(L,z){let x=0,oe=L.indexOf(z);for(;oe!==-1;)x++,oe=L.indexOf(z,oe+z.length);return x}function d(L,z,x="\u2026"){return L.length<=z?L:`${L.substr(0,z)}${x}`}function b(L,z,x="\u2026"){if(L.length<=z)return L;const oe=Math.ceil(z/2)-x.length/2,me=Math.floor(z/2)-x.length/2;return`${L.substr(0,oe)}${x}${L.substr(L.length-me)}`}function f(L,z=" "){const x=y(L,z);return A(x,z)}function y(L,z){if(!L||!z)return L;const x=z.length;if(x===0||L.length===0)return L;let oe=0;for(;L.indexOf(z,oe)===oe;)oe=oe+x;return L.substring(oe)}function A(L,z){if(!L||!z)return L;const x=z.length,oe=L.length;if(x===0||oe===0)return L;let me=oe,ve=-1;for(;ve=L.lastIndexOf(z,me-1),!(ve===-1||ve+x!==me);){if(ve===0)return"";me=ve}return L.substring(0,me)}function s(L){return L.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(L){return L.replace(/\*/g,"")}function i(L,z,x={}){if(!L)throw new Error("Cannot create regex from empty string");z||(L=o(L)),x.wholeWord&&(/\B/.test(L.charAt(0))||(L="\\b"+L),/\B/.test(L.charAt(L.length-1))||(L=L+"\\b"));let oe="";return x.global&&(oe+="g"),x.matchCase||(oe+="i"),x.multiline&&(oe+="m"),x.unicode&&(oe+="u"),new RegExp(L,oe)}function l(L){return L.source==="^"||L.source==="^$"||L.source==="$"||L.source==="^\\s*$"?!1:!!(L.exec("")&&L.lastIndex===0)}function c(L){return L.split(/\r\n|\r|\n/)}function T(L){const z=[],x=L.split(/(\r\n|\r|\n)/);for(let oe=0;oe<Math.ceil(x.length/2);oe++)z.push(x[2*oe]+(x[2*oe+1]??""));return z}function h(L){for(let z=0,x=L.length;z<x;z++){const oe=L.charCodeAt(z);if(oe!==t.CharCode.Space&&oe!==t.CharCode.Tab)return z}return-1}function w(L,z=0,x=L.length){for(let oe=z;oe<x;oe++){const me=L.charCodeAt(oe);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return L.substring(z,oe)}return L.substring(z,x)}function u(L,z=L.length-1){for(let x=z;x>=0;x--){const oe=L.charCodeAt(x);if(oe!==t.CharCode.Space&&oe!==t.CharCode.Tab)return x}return-1}function R(L,z,x){const oe=[];let me=0;for(const ve of L.matchAll(z)){if(oe.push(L.slice(me,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");me=ve.index+ve[0].length,oe.push(x(ve[0],...ve.slice(1),ve.index,L,ve.groups))}return oe.push(L.slice(me)),Promise.all(oe).then(ve=>ve.join(""))}function S(L,z){return L<z?-1:L>z?1:0}function m(L,z,x=0,oe=L.length,me=0,ve=z.length){for(;x<oe&&me<ve;x++,me++){const Ne=L.charCodeAt(x),Le=z.charCodeAt(me);if(Ne<Le)return-1;if(Ne>Le)return 1}const Te=oe-x,je=ve-me;return Te<je?-1:Te>je?1:0}function $(L,z){return V(L,z,0,L.length,0,z.length)}function V(L,z,x=0,oe=L.length,me=0,ve=z.length){for(;x<oe&&me<ve;x++,me++){let Ne=L.charCodeAt(x),Le=z.charCodeAt(me);if(Ne===Le)continue;if(Ne>=128||Le>=128)return m(L.toLowerCase(),z.toLowerCase(),x,oe,me,ve);ee(Ne)&&(Ne-=32),ee(Le)&&(Le-=32);const Se=Ne-Le;if(Se!==0)return Se}const Te=oe-x,je=ve-me;return Te<je?-1:Te>je?1:0}function se(L){return L>=t.CharCode.Digit0&&L<=t.CharCode.Digit9}function ee(L){return L>=t.CharCode.a&&L<=t.CharCode.z}function K(L){return L>=t.CharCode.A&&L<=t.CharCode.Z}function re(L,z){return L.length===z.length&&V(L,z)===0}function X(L,z){const x=z.length;return z.length>L.length?!1:V(L,z,0,x)===0}function te(L,z){const x=Math.min(L.length,z.length);let oe;for(oe=0;oe<x;oe++)if(L.charCodeAt(oe)!==z.charCodeAt(oe))return oe;return x}function ue(L,z){const x=Math.min(L.length,z.length);let oe;const me=L.length-1,ve=z.length-1;for(oe=0;oe<x;oe++)if(L.charCodeAt(me-oe)!==z.charCodeAt(ve-oe))return oe;return x}function ce(L){return 55296<=L&&L<=56319}function I(L){return 56320<=L&&L<=57343}function a(L,z){return(L-55296<<10)+(z-56320)+65536}function O(L,z,x){const oe=L.charCodeAt(x);if(ce(oe)&&x+1<z){const me=L.charCodeAt(x+1);if(I(me))return a(oe,me)}return oe}function B(L,z){const x=L.charCodeAt(z-1);if(I(x)&&z>1){const oe=L.charCodeAt(z-2);if(ce(oe))return a(oe,x)}return x}class Z{get offset(){return this.e}constructor(z,x=0){this.c=z,this.d=z.length,this.e=x}setOffset(z){this.e=z}prevCodePoint(){const z=B(this.c,this.e);return this.e-=z>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,z}nextCodePoint(){const z=O(this.c,this.d,this.e);return this.e+=z>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,z}eol(){return this.e>=this.d}}e.$Pf=Z;class D{get offset(){return this.c.offset}constructor(z,x=0){this.c=new Z(z,x)}nextGraphemeLength(){const z=Pe.getInstance(),x=this.c,oe=x.offset;let me=z.getGraphemeBreakType(x.nextCodePoint());for(;!x.eol();){const ve=x.offset,Te=z.getGraphemeBreakType(x.nextCodePoint());if(pe(me,Te)){x.setOffset(ve);break}me=Te}return x.offset-oe}prevGraphemeLength(){const z=Pe.getInstance(),x=this.c,oe=x.offset;let me=z.getGraphemeBreakType(x.prevCodePoint());for(;x.offset>0;){const ve=x.offset,Te=z.getGraphemeBreakType(x.prevCodePoint());if(pe(Te,me)){x.setOffset(ve);break}me=Te}return oe-x.offset}eol(){return this.c.eol()}}e.$Qf=D;function J(L,z){return new D(L,z).nextGraphemeLength()}function C(L,z){return new D(L,z).prevGraphemeLength()}function ie(L,z){z>0&&I(L.charCodeAt(z))&&z--;const x=z+J(L,z);return[x-C(L,x),x]}function le(L){const z=new D(L);let x=0;for(;!z.eol();)x++,z.nextGraphemeLength();return x}let de;function p(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(L){return de||(de=p()),de.test(L)}const G=/^[\t\n\r\x20-\x7E]*$/;function j(L){return G.test(L)}e.$Xf=/[\u2028\u2029]/;function E(L){return e.$Xf.test(L)}function H(L){return L>=11904&&L<=55215||L>=63744&&L<=64255||L>=65281&&L<=65374}function Q(L){return L>=127462&&L<=127487||L===8986||L===8987||L===9200||L===9203||L>=9728&&L<=10175||L===11088||L===11093||L>=127744&&L<=128591||L>=128640&&L<=128764||L>=128992&&L<=129008||L>=129280&&L<=129535||L>=129648&&L<=129782}function ne(L,z,x=""){const oe=L.trimStart();if(oe.length<z)return oe;const me=/\b/g;let ve=0;for(;me.test(oe)&&!(oe.length-me.lastIndex<z);)ve=me.lastIndex,me.lastIndex+=1;return ve===0?oe:x+oe.substring(ve).trimStart()}const $e=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*De(L){let z=0;for(const x of L.matchAll($e))z!==x.index&&(yield{isCode:!1,str:L.substring(z,x.index)}),yield{isCode:!0,str:x[0]},z=x.index+x[0].length;z!==L.length&&(yield{isCode:!1,str:L.substring(z)})}function he(L){return L&&(L=L.replace($e,"")),L}const fe=/\\\[.*?\\\]/g;function be(L){return he(L).replace(fe,"")}e.$6f=String.fromCharCode(t.CharCode.UTF8_BOM);function ge(L){return!!(L&&L.length>0&&L.charCodeAt(0)===t.CharCode.UTF8_BOM)}function we(L){return ge(L)?L.substr(1):L}function Ae(L,z){if(!L||!z||L.length<z.length)return!1;const x=z.length,oe=L.toLowerCase();let me=0,ve=-1;for(;me<x;){const Te=oe.indexOf(z[me],ve+1);if(Te<0)return!1;ve=Te,me++}return!0}function Re(L,z=!1){return L?(z&&(L=L.replace(/\\./g,"")),L.toLowerCase()!==L):!1}function Ue(L){return L.charAt(0).toUpperCase()+L.slice(1)}function Oe(L,z=1){if(z===0)return"";let x=-1;do x=L.indexOf(`
`,x+1),z--;while(z>0&&x>=0);return x===-1?L:(L[x-1]==="\r"&&x--,L.substr(0,x))}function Fe(L){const z=t.CharCode.Z-t.CharCode.A+1;return L=L%(2*z),L<z?String.fromCharCode(t.CharCode.a+L):String.fromCharCode(t.CharCode.A+L-z)}function Be(L){return Pe.getInstance().getGraphemeBreakType(L)}function pe(L,z){return L===ye.Other?z!==ye.Extend&&z!==ye.SpacingMark:L===ye.CR&&z===ye.LF?!1:L===ye.Control||L===ye.CR||L===ye.LF||z===ye.Control||z===ye.CR||z===ye.LF?!0:!(L===ye.L&&(z===ye.L||z===ye.V||z===ye.LV||z===ye.LVT)||(L===ye.LV||L===ye.V)&&(z===ye.V||z===ye.T)||(L===ye.LVT||L===ye.T)&&z===ye.T||z===ye.Extend||z===ye.ZWJ||z===ye.SpacingMark||L===ye.Prepend||L===ye.ZWJ&&z===ye.Extended_Pictographic||L===ye.Regional_Indicator&&z===ye.Regional_Indicator)}var ye;(function(L){L[L.Other=0]="Other",L[L.Prepend=1]="Prepend",L[L.CR=2]="CR",L[L.LF=3]="LF",L[L.Control=4]="Control",L[L.Extend=5]="Extend",L[L.Regional_Indicator=6]="Regional_Indicator",L[L.SpacingMark=7]="SpacingMark",L[L.L=8]="L",L[L.V=9]="V",L[L.T=10]="T",L[L.LV=11]="LV",L[L.LVT=12]="LVT",L[L.ZWJ=13]="ZWJ",L[L.Extended_Pictographic=14]="Extended_Pictographic"})(ye||(e.GraphemeBreakType=ye={}));class Pe{static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=He()}getGraphemeBreakType(z){if(z<32)return z===t.CharCode.LineFeed?ye.LF:z===t.CharCode.CarriageReturn?ye.CR:ye.Control;if(z<127)return ye.Other;const x=this.d,oe=x.length/3;let me=1;for(;me<=oe;)if(z<x[3*me])me=2*me;else if(z>x[3*me+1])me=2*me+1;else return x[3*me+2];return ye.Other}}Pe.c=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(L,z){if(L===0)return 0;const x=Qe(L,z);if(x!==void 0)return x;const oe=new Z(z,L);return oe.prevCodePoint(),oe.offset}function Qe(L,z){const x=new Z(z,L);let oe=x.prevCodePoint();for(;Ze(oe)||oe===qe.emojiVariantSelector||oe===qe.enclosingKeyCap;){if(x.offset===0)return;oe=x.prevCodePoint()}if(!Q(oe))return;let me=x.offset;return me>0&&x.prevCodePoint()===qe.zwj&&(me=x.offset),me}function Ze(L){return 127995<=L&&L<=127999}var qe;(function(L){L[L.zwj=8205]="zwj",L[L.emojiVariantSelector=65039]="emojiVariantSelector",L[L.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$dg="\xA0";class We{static getInstance(z){return Y.d.get(Array.from(z))}static getLocales(){return Y.e.value}constructor(z){this.f=z}isAmbiguous(z){return this.f.has(z)}containsAmbiguousCharacter(z){for(let x=0;x<z.length;x++){const oe=z.codePointAt(x);if(typeof oe=="number"&&this.isAmbiguous(oe))return!0}return!1}getPrimaryConfusable(z){return this.f.get(z)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=We,Y=We,We.c=new q.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),We.d=new g.$af({getCacheKey:JSON.stringify},L=>{function z(Le){const Se=new Map;for(let ke=0;ke<Le.length;ke+=2)Se.set(Le[ke],Le[ke+1]);return Se}function x(Le,Se){const ke=new Map(Le);for(const[Ge,Ve]of Se)ke.set(Ge,Ve);return ke}function oe(Le,Se){if(!Le)return Se;const ke=new Map;for(const[Ge,Ve]of Le)Se.has(Ge)&&ke.set(Ge,Ve);return ke}const me=Y.c.value;let ve=L.filter(Le=>!Le.startsWith("_")&&Le in me);ve.length===0&&(ve=["_default"]);let Te;for(const Le of ve){const Se=z(me[Le]);Te=oe(Te,Se)}const je=z(me._common),Ne=x(je,Te);return new Y(Ne)}),We.e=new q.$X(()=>Object.keys(Y.c.value).filter(L=>!L.startsWith("_")));class Me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Me.c())),this.d}static isInvisibleCharacter(z){return Me.e().has(z)}static containsInvisibleCharacter(z){for(let x=0;x<z.length;x++){const oe=z.codePointAt(x);if(typeof oe=="number"&&Me.isInvisibleCharacter(oe))return!0}return!1}static get codePoints(){return Me.e()}}e.$fg=Me,Me.d=void 0}),define(_e[14],Ee([0,1,11,3,2,7,10]),function(ae,e,g,t,q,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=F,e.$zg=U,e.$Ag=P,e.$Bg=N,e.$Cg=_,e.$Dg=r,e.$Eg=d,e.$Fg=b,e.$Gg=f,e.$Hg=y,e.$Ig=A,e.$Jg=s,e.$Kg=n,e.$Lg=i,e.$Mg=l,e.$Ng=c,e.$Og=w;function F(u){return u===g.CharCode.Slash||u===g.CharCode.Backslash}function U(u){return u.replace(/[\\/]/g,t.$jc.sep)}function P(u){return u.indexOf("/")===-1&&(u=U(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function N(u,R=t.$jc.sep){if(!u)return"";const S=u.length,m=u.charCodeAt(0);if(F(m)){if(F(u.charCodeAt(1))&&!F(u.charCodeAt(2))){let V=3;const se=V;for(;V<S&&!F(u.charCodeAt(V));V++);if(se!==V&&!F(u.charCodeAt(V+1))){for(V+=1;V<S;V++)if(F(u.charCodeAt(V)))return u.slice(0,V+1).replace(/[\\/]/g,R)}}return R}else if(f(m)&&u.charCodeAt(1)===g.CharCode.Colon)return F(u.charCodeAt(2))?u.slice(0,2)+R:u.slice(0,2);let $=u.indexOf("://");if($!==-1){for($+=3;$<S;$++)if(F(u.charCodeAt($)))return u.slice(0,$+1)}return""}function _(u){if(!q.$c||!u||u.length<5)return!1;let R=u.charCodeAt(0);if(R!==g.CharCode.Backslash||(R=u.charCodeAt(1),R!==g.CharCode.Backslash))return!1;let S=2;const m=S;for(;S<u.length&&(R=u.charCodeAt(S),R!==g.CharCode.Backslash);S++);return!(m===S||(R=u.charCodeAt(S+1),isNaN(R)||R===g.CharCode.Backslash))}const v=/[\\/:\*\?"<>\|]/g,k=/[/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(u,R=q.$c){const S=R?v:k;return!(!u||u.length===0||/^\s+$/.test(u)||(S.lastIndex=0,S.test(u))||R&&o.test(u)||u==="."||u===".."||R&&u[u.length-1]==="."||R&&u.length!==u.trim().length||u.length>255)}function d(u,R,S){const m=u===R;return!S||m?m:!u||!R?!1:(0,M.$Hf)(u,R)}function b(u,R,S,m=t.sep){if(u===R)return!0;if(!u||!R||R.length>u.length)return!1;if(S){if(!(0,M.$If)(u,R))return!1;if(R.length===u.length)return!0;let V=R.length;return R.charAt(R.length-1)===m&&V--,u.charAt(V)===m}return R.charAt(R.length-1)!==m&&(R+=m),u.indexOf(R)===0}function f(u){return u>=g.CharCode.A&&u<=g.CharCode.Z||u>=g.CharCode.a&&u<=g.CharCode.z}function y(u,R){return q.$c&&u.endsWith(":")&&(u+=t.sep),(0,t.$lc)(u)||(u=(0,t.$mc)(R,u)),u=(0,t.$kc)(u),A(u)}function A(u){return q.$c?(u=(0,M.$pf)(u,t.sep),u.endsWith(":")&&(u+=t.sep)):(u=(0,M.$pf)(u,t.sep),u||(u=t.sep)),u}function s(u){const R=(0,t.$kc)(u);return q.$c?u.length>3?!1:n(R)&&(u.length===2||R.charCodeAt(2)===g.CharCode.Backslash):R===t.$jc.sep}function n(u,R=q.$c){return R?f(u.charCodeAt(0))&&u.charCodeAt(1)===g.CharCode.Colon:!1}function i(u,R=q.$c){return n(u,R)?u[0]:void 0}function l(u,R,S){return R.length>u.length?-1:u===R?0:(S&&(u=u.toLowerCase(),R=R.toLowerCase()),u.indexOf(R))}function c(u){const R=u.split(":");let S,m,$;for(const V of R){const se=Number(V);(0,Y.$kg)(se)?m===void 0?m=se:$===void 0&&($=se):S=S?[S,V].join(":"):V}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:m!==void 0?m:void 0,column:$!==void 0?$:m!==void 0?1:void 0}}const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(u,R,S=8){let m="";for(let V=0;V<S;V++){let se;V===0&&q.$c&&!R&&(S===3||S===4)?se=h:se=T,m+=se.charAt(Math.floor(Math.random()*se.length))}let $;return R?$=`${R}-${m}`:$=m,u?(0,t.$mc)(u,$):$}}),define(_e[30],Ee([0,1,12,11,7]),function(ae,e,g,t,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class M{constructor(){this.b="",this.c=0}reset(o){return this.b=o,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(o){const r=o.charCodeAt(0),d=this.b.charCodeAt(this.c);return r-d}value(){return this.b[this.c]}}e.$Ii=M;class Y{constructor(o=!0){this.e=o}reset(o){return this.b=o,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let o=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(o)this.c++;else break;else o=!1;return this}cmp(o){return this.e?(0,q.$Bf)(o,this.b,0,o.length,this.c,this.d):(0,q.$Df)(o,this.b,0,o.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=Y;class F{constructor(o=!0,r=!0){this.f=o,this.g=r}reset(o){this.d=0,this.e=0,this.b=o,this.c=o.length;for(let r=o.length-1;r>=0;r--,this.c--){const d=this.b.charCodeAt(r);if(!(d===t.CharCode.Slash||this.f&&d===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let o=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===t.CharCode.Slash||this.f&&r===t.CharCode.Backslash)if(o)this.d++;else break;else o=!1}return this}cmp(o){return this.g?(0,q.$Bf)(o,this.b,0,o.length,this.d,this.e):(0,q.$Df)(o,this.b,0,o.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=F;var U;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(U||(U={}));class P{constructor(o,r){this.f=o,this.g=r,this.d=[],this.e=0}reset(o){return this.c=o,this.d=[],this.c.scheme&&this.d.push(U.Scheme),this.c.authority&&this.d.push(U.Authority),this.c.path&&(this.b=new F(!1,!this.f(o)),this.b.reset(o.path),this.b.value()&&this.d.push(U.Path)),this.g(o)||(this.c.query&&this.d.push(U.Query),this.c.fragment&&this.d.push(U.Fragment)),this.e=0,this}next(){return this.d[this.e]===U.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===U.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(o){if(this.d[this.e]===U.Scheme)return(0,q.$Cf)(o,this.c.scheme);if(this.d[this.e]===U.Authority)return(0,q.$Cf)(o,this.c.authority);if(this.d[this.e]===U.Path)return this.b.cmp(o);if(this.d[this.e]===U.Query)return(0,q.$Af)(o,this.c.query);if(this.d[this.e]===U.Fragment)return(0,q.$Af)(o,this.c.fragment);throw new Error}value(){if(this.d[this.e]===U.Scheme)return this.c.scheme;if(this.d[this.e]===U.Authority)return this.c.authority;if(this.d[this.e]===U.Path)return this.b.value();if(this.d[this.e]===U.Query)return this.c.query;if(this.d[this.e]===U.Fragment)return this.c.fragment;throw new Error}}e.$Li=P;class N{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(_||(_={}));class v{static forUris(o=()=>!1,r=()=>!1){return new v(new P(o,r))}static forPaths(o=!1){return new v(new F(void 0,!o))}static forStrings(){return new v(new M)}static forConfigKeys(){return new v(new Y)}constructor(o){this.b=o}clear(){this.c=void 0}fill(o,r){if(r){const d=r.slice(0);(0,g.$Zb)(d);for(const b of d)this.set(b,o)}else{const d=o.slice(0);(0,g.$Zb)(d);for(const b of d)this.set(b[0],b[1])}}set(o,r){const d=this.b.reset(o);let b;this.c||(this.c=new N,this.c.segment=d.value());const f=[];for(b=this.c;;){const A=d.cmp(b.segment);if(A>0)b.left||(b.left=new N,b.left.segment=d.value()),f.push([_.Left,b]),b=b.left;else if(A<0)b.right||(b.right=new N,b.right.segment=d.value()),f.push([_.Right,b]),b=b.right;else if(d.hasNext())d.next(),b.mid||(b.mid=new N,b.mid.segment=d.value()),f.push([_.Mid,b]),b=b.mid;else break}const y=b.value;b.value=r,b.key=o;for(let A=f.length-1;A>=0;A--){const s=f[A][1];s.updateHeight();const n=s.balanceFactor();if(n<-1||n>1){const i=f[A][0],l=f[A+1][0];if(i===_.Right&&l===_.Right)f[A][1]=s.rotateLeft();else if(i===_.Left&&l===_.Left)f[A][1]=s.rotateRight();else if(i===_.Right&&l===_.Left)s.right=f[A+1][1]=f[A+1][1].rotateRight(),f[A][1]=s.rotateLeft();else if(i===_.Left&&l===_.Right)s.left=f[A+1][1]=f[A+1][1].rotateLeft(),f[A][1]=s.rotateRight();else throw new Error;if(A>0)switch(f[A-1][0]){case _.Left:f[A-1][1].left=f[A][1];break;case _.Right:f[A-1][1].right=f[A][1];break;case _.Mid:f[A-1][1].mid=f[A][1];break}else this.c=f[0][1]}}return y}get(o){return this.d(o)?.value}d(o){const r=this.b.reset(o);let d=this.c;for(;d;){const b=r.cmp(d.segment);if(b>0)d=d.left;else if(b<0)d=d.right;else if(r.hasNext())r.next(),d=d.mid;else break}return d}has(o){const r=this.d(o);return!(r?.value===void 0&&r?.mid===void 0)}delete(o){return this.e(o,!1)}deleteSuperstr(o){return this.e(o,!0)}e(o,r){const d=this.b.reset(o),b=[];let f=this.c;for(;f;){const y=d.cmp(f.segment);if(y>0)b.push([_.Left,f]),f=f.left;else if(y<0)b.push([_.Right,f]),f=f.right;else if(d.hasNext())d.next(),b.push([_.Mid,f]),f=f.mid;else break}if(f){if(r?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const y=this.f(f.right);if(y.key){const{key:A,value:s,segment:n}=y;this.e(y.key,!1),f.key=A,f.value=s,f.segment=n}}else{const y=f.left??f.right;if(b.length>0){const[A,s]=b[b.length-1];switch(A){case _.Left:s.left=y;break;case _.Mid:s.mid=y;break;case _.Right:s.right=y;break}}else this.c=y}for(let y=b.length-1;y>=0;y--){const A=b[y][1];A.updateHeight();const s=A.balanceFactor();if(s>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),b[y][1]=A.rotateLeft()):s<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),b[y][1]=A.rotateRight()),y>0)switch(b[y-1][0]){case _.Left:b[y-1][1].left=b[y][1];break;case _.Right:b[y-1][1].right=b[y][1];break;case _.Mid:b[y-1][1].mid=b[y][1];break}else this.c=b[0][1]}}}f(o){for(;o.left;)o=o.left;return o}findSubstr(o){const r=this.b.reset(o);let d=this.c,b;for(;d;){const f=r.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(r.hasNext())r.next(),b=d.value||b,d=d.mid;else break}return d&&d.value||b}findSuperstr(o){return this.g(o,!1)}g(o,r){const d=this.b.reset(o);let b=this.c;for(;b;){const f=d.cmp(b.segment);if(f>0)b=b.left;else if(f<0)b=b.right;else if(d.hasNext())d.next(),b=b.mid;else return b.mid?this.h(b.mid):r?b.value:void 0}}hasElementOrSubtree(o){return this.g(o,!0)!==void 0}forEach(o){for(const[r,d]of this)o(d,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(o){const r=[];return this.j(o,r),r[Symbol.iterator]()}j(o,r){o&&(o.left&&this.j(o.left,r),o.value&&r.push([o.key,o.value]),o.mid&&this.j(o.mid,r),o.right&&this.j(o.right,r))}_isBalanced(){const o=r=>{if(!r)return!0;const d=r.balanceFactor();return d<-1||d>1?!1:o(r.left)&&o(r.right)};return o(this.c)}}e.$Mi=v}),define(_e[5],Ee([0,1,11,27,3,2]),function(ae,e,g,t,q,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=d,e.$zc=n,q=Ie(q);const Y=/^\w[\w\d+.-]*$/,F=/^\//,U=/^\/\//;function P(h,w){if(!h.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!Y.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!F.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function N(h,w){return!h&&!w?"file":h}function _(h,w){switch(h){case"https":case"http":case"file":w?w[0]!==k&&(w=k+w):w=k;break}return w}const v="",k="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(w){return w instanceof r?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,u,R,S,m,$=!1){typeof w=="object"?(this.scheme=w.scheme||v,this.authority=w.authority||v,this.path=w.path||v,this.query=w.query||v,this.fragment=w.fragment||v):(this.scheme=N(w,$),this.authority=u||v,this.path=_(this.scheme,R||v),this.query=S||v,this.fragment=m||v,P(this,$))}get fsPath(){return n(this,!1)}with(w){if(!w)return this;let{scheme:u,authority:R,path:S,query:m,fragment:$}=w;return u===void 0?u=this.scheme:u===null&&(u=v),R===void 0?R=this.authority:R===null&&(R=v),S===void 0?S=this.path:S===null&&(S=v),m===void 0?m=this.query:m===null&&(m=v),$===void 0?$=this.fragment:$===null&&($=v),u===this.scheme&&R===this.authority&&S===this.path&&m===this.query&&$===this.fragment?this:new f(u,R,S,m,$)}static parse(w,u=!1){const R=o.exec(w);return R?new f(R[2]||v,T(R[4]||v),T(R[5]||v),T(R[7]||v),T(R[9]||v),u):new f(v,v,v,v,v)}static file(w){let u=v;if(M.$c&&(w=w.replace(/\\/g,k)),w[0]===k&&w[1]===k){const R=w.indexOf(k,2);R===-1?(u=w.substring(2),w=k):(u=w.substring(2,R),w=w.substring(R)||k)}return new f("file",u,w,v,v)}static from(w,u){return new f(w.scheme,w.authority,w.path,w.query,w.fragment,u)}static joinPath(w,...u){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return M.$c&&w.scheme==="file"?R=r.file(q.$ic.join(n(w,!0),...u)).path:R=q.$jc.join(w.path,...u),w.with({path:R})}toString(w=!1){return i(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof r)return w;{const u=new f(w);return u._formatted=w.external??null,u._fsPath=w._sep===b?w.fsPath??null:null,u}}else return w}}e.URI=r;function d(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const b=M.$c?1:void 0;class f extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(w=!1){return w?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const w={$mid:t.MarshalledId.Uri};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=b),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const y={[g.CharCode.Colon]:"%3A",[g.CharCode.Slash]:"%2F",[g.CharCode.QuestionMark]:"%3F",[g.CharCode.Hash]:"%23",[g.CharCode.OpenSquareBracket]:"%5B",[g.CharCode.CloseSquareBracket]:"%5D",[g.CharCode.AtSign]:"%40",[g.CharCode.ExclamationMark]:"%21",[g.CharCode.DollarSign]:"%24",[g.CharCode.Ampersand]:"%26",[g.CharCode.SingleQuote]:"%27",[g.CharCode.OpenParen]:"%28",[g.CharCode.CloseParen]:"%29",[g.CharCode.Asterisk]:"%2A",[g.CharCode.Plus]:"%2B",[g.CharCode.Comma]:"%2C",[g.CharCode.Semicolon]:"%3B",[g.CharCode.Equals]:"%3D",[g.CharCode.Space]:"%20"};function A(h,w,u){let R,S=-1;for(let m=0;m<h.length;m++){const $=h.charCodeAt(m);if($>=g.CharCode.a&&$<=g.CharCode.z||$>=g.CharCode.A&&$<=g.CharCode.Z||$>=g.CharCode.Digit0&&$<=g.CharCode.Digit9||$===g.CharCode.Dash||$===g.CharCode.Period||$===g.CharCode.Underline||$===g.CharCode.Tilde||w&&$===g.CharCode.Slash||u&&$===g.CharCode.OpenSquareBracket||u&&$===g.CharCode.CloseSquareBracket||u&&$===g.CharCode.Colon)S!==-1&&(R+=encodeURIComponent(h.substring(S,m)),S=-1),R!==void 0&&(R+=h.charAt(m));else{R===void 0&&(R=h.substr(0,m));const V=y[$];V!==void 0?(S!==-1&&(R+=encodeURIComponent(h.substring(S,m)),S=-1),R+=V):S===-1&&(S=m)}}return S!==-1&&(R+=encodeURIComponent(h.substring(S))),R!==void 0?R:h}function s(h){let w;for(let u=0;u<h.length;u++){const R=h.charCodeAt(u);R===g.CharCode.Hash||R===g.CharCode.QuestionMark?(w===void 0&&(w=h.substr(0,u)),w+=y[R]):w!==void 0&&(w+=h[u])}return w!==void 0?w:h}function n(h,w){let u;return h.authority&&h.path.length>1&&h.scheme==="file"?u=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===g.CharCode.Slash&&(h.path.charCodeAt(1)>=g.CharCode.A&&h.path.charCodeAt(1)<=g.CharCode.Z||h.path.charCodeAt(1)>=g.CharCode.a&&h.path.charCodeAt(1)<=g.CharCode.z)&&h.path.charCodeAt(2)===g.CharCode.Colon?w?u=h.path.substr(1):u=h.path[1].toLowerCase()+h.path.substr(2):u=h.path,M.$c&&(u=u.replace(/\//g,"\\")),u}function i(h,w){const u=w?s:A;let R="",{scheme:S,authority:m,path:$,query:V,fragment:se}=h;if(S&&(R+=S,R+=":"),(m||S==="file")&&(R+=k,R+=k),m){let ee=m.indexOf("@");if(ee!==-1){const K=m.substr(0,ee);m=m.substr(ee+1),ee=K.lastIndexOf(":"),ee===-1?R+=u(K,!1,!1):(R+=u(K.substr(0,ee),!1,!1),R+=":",R+=u(K.substr(ee+1),!1,!0)),R+="@"}m=m.toLowerCase(),ee=m.lastIndexOf(":"),ee===-1?R+=u(m,!1,!0):(R+=u(m.substr(0,ee),!1,!0),R+=m.substr(ee))}if($){if($.length>=3&&$.charCodeAt(0)===g.CharCode.Slash&&$.charCodeAt(2)===g.CharCode.Colon){const ee=$.charCodeAt(1);ee>=g.CharCode.A&&ee<=g.CharCode.Z&&($=`/${String.fromCharCode(ee+32)}:${$.substr(3)}`)}else if($.length>=2&&$.charCodeAt(1)===g.CharCode.Colon){const ee=$.charCodeAt(0);ee>=g.CharCode.A&&ee<=g.CharCode.Z&&($=`${String.fromCharCode(ee+32)}:${$.substr(2)}`)}R+=u($,!0,!1)}return V&&(R+="?",R+=u(V,!1,!1)),se&&(R+="#",R+=w?se:A(se,!1,!1)),R}function l(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+l(h.substr(3)):h}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function T(h){return h.match(c)?h.replace(c,w=>l(w)):h}}),define(_e[47],Ee([0,1,5]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=t,e.$dr=q,e.$er=M,e.log=F;function t(P){const N=P;return N&&typeof N.type=="string"&&typeof N.severity=="string"}function q(P){const N=[];let _;try{const v=JSON.parse(P.arguments),k=v[v.length-1];k&&k.__$stack&&(v.pop(),_=k.__$stack),N.push(...v)}catch{N.push("Unable to log remote console arguments",P.arguments)}return{args:N,stack:_}}function M(P){if(typeof P!="string")return M(q(P).stack);const N=P;if(N){const _=Y(N),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(_||"");if(v&&v.length===4)return{uri:g.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function Y(P){if(!P)return P;const N=P.indexOf(`
`);return N===-1?P:P.substring(0,N)}function F(P,N){const{args:_,stack:v}=q(P),k=typeof _[0]=="string"&&_.length===1;let o=Y(v);o&&(o=`(${o.trim()})`);let r=[];if(typeof _[0]=="string"?o&&k?r=[`%c[${N}] %c${_[0]} %c${o}`,U("blue"),U(""),U("grey")]:r=[`%c[${N}] %c${_[0]}`,U("blue"),U(""),..._.slice(1)]:r=[`%c[${N}]%`,U("blue"),..._],o&&!k&&r.push(o),typeof console[P.severity]!="function")throw new Error("Unknown console method");console[P.severity].apply(console,r)}function U(P){return`color: ${P}`}}),define(_e[48],Ee([0,1,16,5,27]),function(ae,e,g,t,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=M,e.$ci=Y,e.$di=U;function M(P){return JSON.stringify(P,F)}function Y(P){let N=JSON.parse(P);return N=U(N),N}function F(P,N){return N instanceof RegExp?{$mid:q.MarshalledId.Regexp,source:N.source,flags:N.flags}:N}function U(P,N=0){if(!P||N>200)return P;if(typeof P=="object"){switch(P.$mid){case q.MarshalledId.Uri:return t.URI.revive(P);case q.MarshalledId.Regexp:return new RegExp(P.source,P.flags);case q.MarshalledId.Date:return new Date(P.source)}if(P instanceof g.$Pe||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let _=0;_<P.length;++_)P[_]=U(P[_],N+1);else for(const _ in P)Object.hasOwnProperty.call(P,_)&&(P[_]=U(P[_],N+1))}return P}}),define(_e[31],Ee([0,1,9,2,7,5,3]),function(ae,e,g,t,q,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=U,e.$Qg=P,e.$Ug=_,g=Ie(g),t=Ie(t),Y=Ie(Y);var F;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatCodeBlock="vscode-chat-code-block",o.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",o.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm",o.commentsInput="comment",o.codeSetting="code-setting"})(F||(e.Schemas=F={}));function U(o,r){return M.URI.isUri(o)?(0,q.$Hf)(o.scheme,r):(0,q.$If)(o,r+":")}function P(o,...r){return r.some(d=>U(o,d))}e.$Rg="vscode-tkn",e.$Sg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,d){this.f=_(r,d)}getServerRootPath(){return this.f}get g(){return Y.$jc.join(this.f,F.vscodeRemoteResource)}set(r,d,b){this.a[r]=d,this.b[r]=b}setConnectionToken(r,d){this.c[r]=d}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(s){return g.$3(s),r}const d=r.authority;let b=this.a[d];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const f=this.b[d],y=this.c[d];let A=`path=${encodeURIComponent(r.path)}`;return typeof y=="string"&&(A+=`&${e.$Sg}=${encodeURIComponent(y)}`),M.URI.from({scheme:t.$i?this.d:F.vscodeRemoteResource,authority:`${b}:${f}`,path:t.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:A})}}e.$Tg=new N;function _(o,r){return Y.$jc.join(r??"/",`${o.quality??"oss"}-${o.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class v{asBrowserUri(r){const d=this.b(r,ae);return this.uriToBrowserUri(d)}uriToBrowserUri(r){return r.scheme===F.vscodeRemote?e.$Tg.rewrite(r):r.scheme===F.file&&(t.$g||t.$k===`${F.vscodeFileResource}://${v.a}`)?r.with({scheme:F.vscodeFileResource,authority:r.authority||v.a,query:null,fragment:null}):r}asFileUri(r){const d=this.b(r,ae);return this.uriToFileUri(d)}uriToFileUri(r){return r.scheme===F.vscodeFileResource?r.with({scheme:F.file,authority:r.authority!==v.a?r.authority:null,query:null,fragment:null}):r}b(r,d){return M.URI.isUri(r)?r:M.URI.parse(d.toUrl(r))}}v.a=e.$Zg,e.$1g=new v;var k;(function(o){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(r.get("3"));const d="vscode-coi";function b(y){let A;typeof y=="string"?A=new URL(y).searchParams:y instanceof URL?A=y.searchParams:M.URI.isUri(y)&&(A=new URL(y.toString(!0)).searchParams);const s=A?.get(d);if(s)return r.get(s)}o.getHeadersFromQuery=b;function f(y,A,s){if(!globalThis.crossOriginIsolated)return;const n=A&&s?"3":s?"2":"1";y instanceof URLSearchParams?y.set(d,n):y[d]=n}o.addSearchParam=f})(k||(e.COI=k={}))}),define(_e[22],Ee([0,1,11,14,31,3,2,7,5]),function(ae,e,g,t,q,M,Y,F,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=P,e.$qh=_,e.$rh=k,t=Ie(t),M=Ie(M);function P(o){return(0,U.$zc)(o,!0)}class N{constructor(r){this.a=r}compare(r,d,b=!1){return r===d?0:(0,F.$Af)(this.getComparisonKey(r,b),this.getComparisonKey(d,b))}isEqual(r,d,b=!1){return r===d?!0:!r||!d?!1:this.getComparisonKey(r,b)===this.getComparisonKey(d,b)}getComparisonKey(r,d=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,d,b=!1){if(r.scheme===d.scheme){if(r.scheme===q.Schemas.file)return t.$Fg(P(r),P(d),this.a(r))&&r.query===d.query&&(b||r.fragment===d.fragment);if((0,e.$mh)(r.authority,d.authority))return t.$Fg(r.path,d.path,this.a(r),"/")&&r.query===d.query&&(b||r.fragment===d.fragment)}return!1}joinPath(r,...d){return U.URI.joinPath(r,...d)}basenameOrAuthority(r){return(0,e.$eh)(r)||r.authority}basename(r){return M.$jc.basename(r.path)}extname(r){return M.$jc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let d;return r.scheme===q.Schemas.file?d=U.URI.file(M.$pc(P(r))).path:(d=M.$jc.dirname(r.path),r.authority&&d.length&&d.charCodeAt(0)!==g.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),d="/")),r.with({path:d})}normalizePath(r){if(!r.path.length)return r;let d;return r.scheme===q.Schemas.file?d=U.URI.file(M.$kc(P(r))).path:d=M.$jc.normalize(r.path),r.with({path:d})}relativePath(r,d){if(r.scheme!==d.scheme||!(0,e.$mh)(r.authority,d.authority))return;if(r.scheme===q.Schemas.file){const y=M.$oc(P(r),P(d));return Y.$c?t.$zg(y):y}let b=r.path||"/";const f=d.path||"/";if(this.a(r)){let y=0;for(const A=Math.min(b.length,f.length);y<A&&!(b.charCodeAt(y)!==f.charCodeAt(y)&&b.charAt(y).toLowerCase()!==f.charAt(y).toLowerCase());y++);b=f.substr(0,y)+b.substr(y)}return M.$jc.relative(b,f)}resolvePath(r,d){if(r.scheme===q.Schemas.file){const b=U.URI.file(M.$nc(P(r),d));return r.with({authority:b.authority,path:b.path})}return d=t.$Ag(d),r.with({path:M.$jc.resolve(r.path,d)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,d){return r===d||r!==void 0&&d!==void 0&&(0,F.$Hf)(r,d)}hasTrailingPathSeparator(r,d=M.sep){if(r.scheme===q.Schemas.file){const b=P(r);return b.length>t.$Bg(b).length&&b[b.length-1]===d}else{const b=r.path;return b.length>1&&b.charCodeAt(b.length-1)===g.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,d=M.sep){return(0,e.$nh)(r,d)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,d=M.sep){let b=!1;if(r.scheme===q.Schemas.file){const f=P(r);b=f!==void 0&&f.length===t.$Bg(f).length&&f[f.length-1]===d}else{d="/";const f=r.path;b=f.length===1&&f.charCodeAt(f.length-1)===g.CharCode.Slash}return!b&&!(0,e.$nh)(r,d)?r.with({path:r.path+"/"}):r}}e.$9g=N,e.$0g=new N(()=>!1),e.$$g=new N(o=>o.scheme===q.Schemas.file?!Y.$e:!0),e.$_g=new N(o=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function _(o,r){const d=[];for(let b=0;b<o.length;b++){const f=r(o[b]);o.some((y,A)=>A===b?!1:(0,e.$bh)(f,r(y)))||d.push(o[b])}return d}var v;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function r(d){const b=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(A=>{const[s,n]=A.split(":");s&&n&&b.set(s,n)});const y=d.path.substring(0,d.path.indexOf(";"));return y&&b.set(o.META_DATA_MIME,y),b}o.parseMetaData=r})(v||(e.DataUri=v={}));function k(o,r,d){if(r){let b=o.path;return b&&b[0]!==M.$jc.sep&&(b=M.$jc.sep+b),o.with({scheme:d,authority:r,path:b})}return o.with({scheme:d})}}),define(_e[8],Ee([0,1,13,9,6,4,22,2,44,15]),function(ae,e,g,t,q,M,Y,F,U,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=N,e.$th=_,e.$uh=v,e.$vh=k,e.$wh=o,e.$xh=r,e.$yh=d,e.$zh=b,e.$Hh=h,e.$Ih=w,e.$Jh=u,e.$Kh=R,e.$Lh=S,e.$1h=a,e.$9h=W;function N(j){return!!j&&typeof j.then=="function"}function _(j){const E=new g.$ye,H=j(E.token),Q=new Promise((ne,$e)=>{const De=E.token.onCancellationRequested(()=>{De.dispose(),$e(new t.$8)});Promise.resolve(H).then(he=>{De.dispose(),E.dispose(),ne(he)},he=>{De.dispose(),E.dispose(),$e(he)})});return new class{cancel(){E.cancel(),E.dispose()}then(ne,$e){return Q.then(ne,$e)}catch(ne){return this.then(void 0,ne)}finally(ne){return Q.finally(ne)}}}function v(j,E,H){return new Promise((Q,ne)=>{const $e=E.onCancellationRequested(()=>{$e.dispose(),Q(H)});j.then(Q,ne).finally(()=>$e.dispose())})}function k(j,E){return new Promise((H,Q)=>{const ne=E.onCancellationRequested(()=>{ne.dispose(),Q(new t.$8)});j.then(H,Q).finally(()=>ne.dispose())})}async function o(j){let E=-1;const H=j.map((Q,ne)=>Q.then($e=>(E=ne,$e)));try{return await Promise.race(H)}finally{j.forEach((Q,ne)=>{ne!==E&&Q.cancel()})}}function r(j,E,H){let Q;const ne=setTimeout(()=>{Q?.(void 0),H?.()},E);return Promise.race([j.finally(()=>clearTimeout(ne)),new Promise($e=>Q=$e)])}function d(j){return new Promise((E,H)=>{const Q=j();N(Q)?Q.then(E,H):E(Q)})}function b(){let j,E;return{promise:new Promise((Q,ne)=>{j=Q,E=ne}),resolve:j,reject:E}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(E){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=E,!this.b){const H=()=>{if(this.b=null,this.f)return;const Q=this.queue(this.d);return this.d=null,Q};this.b=new Promise(Q=>{this.a.then(H,H).then(Q)})}return new Promise((H,Q)=>{this.b.then(H,Q)})}return this.a=E(),new Promise((H,Q)=>{this.a.then(ne=>{this.a=null,H(ne)},ne=>{this.a=null,Q(ne)})})}dispose(){this.f=!0}}e.$Ah=f;class y{constructor(){this.a=Promise.resolve(null)}queue(E){return this.a=this.a.then(()=>E(),()=>E())}}e.$Bh=y;class A{constructor(){this.a=new Map}queue(E,H){const ne=(this.a.get(E)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(E)===ne&&this.a.delete(E)});return this.a.set(E,ne),ne}}e.$Ch=A;const s=(j,E)=>{let H=!0;const Q=setTimeout(()=>{H=!1,E()},j);return{isTriggered:()=>H,dispose:()=>{clearTimeout(Q),H=!1}}},n=j=>{let E=!0;return queueMicrotask(()=>{E&&(E=!1,j())}),{isTriggered:()=>E,dispose:()=>{E=!1}}};class i{constructor(E){this.defaultDelay=E,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(E,H=this.defaultDelay){this.g=E,this.h(),this.b||(this.b=new Promise((ne,$e)=>{this.d=ne,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const Q=()=>{this.a=null,this.d?.(null)};return this.a=H===U.$ie?n(Q):s(H,Q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=i;class l{constructor(E){this.a=new i(E),this.b=new f}trigger(E,H){return this.a.trigger(()=>this.b.queue(E),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=l;class c{constructor(){this.a=!1,this.b=new Promise((E,H)=>{this.d=E})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=c;class T extends c{constructor(E){super(),this.f=setTimeout(()=>this.open(),E)}open(){clearTimeout(this.f),super.open()}}e.$Gh=T;function h(j,E){return E?new Promise((H,Q)=>{const ne=setTimeout(()=>{$e.dispose(),H()},j),$e=E.onCancellationRequested(()=>{clearTimeout(ne),$e.dispose(),Q(new t.$8)})}):_(H=>h(j,H))}function w(j,E=0,H){const Q=setTimeout(()=>{j(),H&&ne.dispose()},E),ne=(0,M.$Vc)(()=>{clearTimeout(Q),H?.deleteAndLeak(ne)});return H?.add(ne),ne}function u(j){const E=[];let H=0;const Q=j.length;function ne(){return H<Q?j[H++]():null}function $e(De){De!=null&&E.push(De);const he=ne();return he?he.then($e):Promise.resolve(E)}return Promise.resolve(null).then($e)}function R(j,E=Q=>!!Q,H=null){let Q=0;const ne=j.length,$e=()=>{if(Q>=ne)return Promise.resolve(H);const De=j[Q++];return Promise.resolve(De()).then(fe=>E(fe)?Promise.resolve(fe):$e())};return $e()}function S(j,E=Q=>!!Q,H=null){if(j.length===0)return Promise.resolve(H);let Q=j.length;const ne=()=>{Q=-1;for(const $e of j)$e.cancel?.()};return new Promise(($e,De)=>{for(const he of j)he.then(fe=>{--Q>=0&&E(fe)?(ne(),$e(fe)):Q===0&&$e(H)}).catch(fe=>{--Q>=0&&(ne(),De(fe))})})}class m{constructor(E){this.a=0,this.b=!1,this.f=E,this.g=[],this.d=0,this.h=new q.$ne}whenIdle(){return this.size>0?q.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(E){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((H,Q)=>{this.g.push({factory:E,c:H,e:Q}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const E=this.g.shift();this.d++;const H=E.factory();H.then(E.c,E.e),H.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=m;class $ extends m{constructor(){super(1)}}e.$Nh=$;class V{constructor(){this.a=new O,this.b=0}queue(E){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,E())):this.a.run(this.b++,E())}}e.$Oh=V;class se{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const E=new D;return this.b.add(E),E.p}g(){for(const[,E]of this.a)if(E.size>0)return!1;return!0}queueSize(E,H=Y.$0g){const Q=H.getComparisonKey(E);return this.a.get(Q)?.size??0}queueFor(E,H,Q=Y.$0g){const ne=Q.getComparisonKey(E);let $e=this.a.get(ne);if(!$e){$e=new $;const De=this.f++,he=q.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ne),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$7c),this.d.set(De,he),this.a.set(ne,$e)}return $e.queue(H)}h(){this.g()&&this.j()}j(){for(const E of this.b)E.complete();this.b.clear()}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=se;class ee{constructor(E,H){this.b=!1,this.a=-1,typeof E=="function"&&typeof H=="number"&&this.setIfNotSet(E,H)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(E,H){if(this.b)throw new t.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,E()},H)}setIfNotSet(E,H){if(this.b)throw new t.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,E()},H))}}e.$Qh=ee;class K{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(E,H,Q=globalThis){if(this.f)throw new t.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=Q.setInterval(()=>{E()},H);this.d=(0,M.$Vc)(()=>{Q.clearInterval(ne),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=K;class re{constructor(E,H){this.b=-1,this.a=E,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(E=this.d){this.cancel(),this.b=setTimeout(this.f,E)}get delay(){return this.d}set delay(E){this.d=E}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=re;class X{constructor(E,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=E,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(E=this.b){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(E/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=X;class te extends re{constructor(E,H){super(E,H),this.j=[]}work(E){this.j.push(E),this.isScheduled()||this.schedule()}h(){const E=this.j;this.j=[],this.a?.(E)}dispose(){this.j=[],super.dispose()}}e.$Uh=te;class ue extends M.$Xc{constructor(E,H){super(),this.g=E,this.h=H,this.a=[],this.b=this.B(new M.$Yc),this.f=!1}get pending(){return this.a.length}work(E){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+E.length>this.g.maxBufferedWork)return!1}else if(this.pending+E.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of E)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new re(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(j,E)=>{(0,F.$v)(()=>{if(H)return;const Q=Date.now()+15;E(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$Xh=(j,E,H)=>{const Q=j.requestIdleCallback(E,typeof H=="number"?{timeout:H}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,j.cancelIdleCallback(Q))}}},e.$Wh=j=>(0,e.$Xh)(globalThis,j)}();class ce{constructor(E,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(Q){this.l=Q}finally{this.g=!0}},this.f=(0,e.$Xh)(E,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ce;class I extends ce{constructor(E){super(globalThis,E)}}e.$Zh=I;async function a(j,E,H){let Q;for(let ne=0;ne<H;ne++)try{return await j()}catch($e){Q=$e,await h(E)}throw Q}class O{isRunning(E){return typeof E=="number"?this.a?.taskId===E:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(E,H,Q){return this.a={taskId:E,cancel:()=>Q?.(),promise:H},H.then(()=>this.d(E),()=>this.d(E)),H}d(E){this.a&&E===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const E=this.b;this.b=void 0,E.run().then(E.promiseResolve,E.promiseReject)}}queue(E){if(this.b)this.b.run=E;else{const{promise:H,resolve:Q,reject:ne}=b();this.b={run:E,promise:H,promiseResolve:Q,promiseReject:ne}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=O;class B{constructor(E,H=()=>Date.now()){this.d=E,this.f=H,this.a=0,this.b=0}increment(){const E=this.f();return E-this.a>this.d&&(this.a=E,this.b=0),this.b++,this.b}}e.$3h=B;var Z;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(Z||(Z={}));class D{get isRejected(){return this.d?.outcome===Z.Rejected}get isResolved(){return this.d?.outcome===Z.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Z.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((E,H)=>{this.a=E,this.b=H})}complete(E){return new Promise(H=>{this.a(E),this.d={outcome:Z.Resolved,value:E},H()})}error(E){return new Promise(H=>{this.b(E),this.d={outcome:Z.Rejected,value:E},H()})}cancel(){return this.error(new t.$8)}}e.$4h=D;var J;(function(j){async function E(Q){let ne;const $e=await Promise.all(Q.map(De=>De.then(he=>he,he=>{ne||(ne=he)})));if(typeof ne<"u")throw ne;return $e}j.settled=E;function H(Q){return new Promise(async(ne,$e)=>{try{await Q(ne,$e)}catch(De){$e(De)}})}j.withAsyncBody=H})(J||(e.Promises=J={}));class C{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(E){this.a=void 0,this.b=void 0,this.d=!1,this.promise=E.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new t.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=C;class ie{constructor(E){this.b=E,this.a=new P.$X(()=>new C(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=ie;var le;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(le||(le={}));class de{static fromArray(E){return new de(H=>{H.emitMany(E)})}static fromPromise(E){return new de(async H=>{H.emitMany(await E)})}static fromPromises(E){return new de(async H=>{await Promise.all(E.map(async Q=>H.emitOne(await Q)))})}static merge(E){return new de(async H=>{await Promise.all(E.map(async Q=>{for await(const ne of Q)H.emitOne(ne)}))})}constructor(E,H){this.a=le.Initial,this.b=[],this.d=null,this.f=H,this.g=new q.$ne,queueMicrotask(async()=>{const Q={emitOne:ne=>this.h(ne),emitMany:ne=>this.j(ne),reject:ne=>this.l(ne)};try{await Promise.resolve(E(Q)),this.k()}catch(ne){this.l(ne)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let E=0;return{next:async()=>{do{if(this.a===le.DoneError)throw this.d;if(E<this.b.length)return{done:!1,value:this.b[E++]};if(this.a===le.DoneOK)return{done:!0,value:void 0};await q.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(E,H){return new de(async Q=>{for await(const ne of E)Q.emitOne(H(ne))})}map(E){return de.map(this,E)}static filter(E,H){return new de(async Q=>{for await(const ne of E)H(ne)&&Q.emitOne(ne)})}filter(E){return de.filter(this,E)}static coalesce(E){return de.filter(E,H=>!!H)}coalesce(){return de.coalesce(this)}static async toPromise(E){const H=[];for await(const Q of E)H.push(Q);return H}toPromise(){return de.toPromise(this)}h(E){this.a===le.Initial&&(this.b.push(E),this.g.fire())}j(E){this.a===le.Initial&&(this.b=this.b.concat(E),this.g.fire())}k(){this.a===le.Initial&&(this.a=le.DoneOK,this.g.fire())}l(E){this.a===le.Initial&&(this.a=le.DoneError,this.d=E,this.g.fire())}}e.$7h=de,de.EMPTY=de.fromArray([]);class p extends de{constructor(E,H){super(H),this.m=E}cancel(){this.m.cancel()}}e.$8h=p;function W(j){const E=new g.$ye,H=j(E.token);return new p(E,async Q=>{const ne=E.token.onCancellationRequested(()=>{ne.dispose(),E.dispose(),Q.reject(new t.$8)});try{for await(const $e of H){if(E.token.isCancellationRequested)return;Q.emitOne($e)}ne.dispose(),E.dispose()}catch($e){ne.dispose(),E.dispose(),Q.reject($e)}})}class G{constructor(E){this.a=new D,this.b=new de(ne=>{if(H){ne.reject(H);return}return Q&&ne.emitMany(Q),this.d=$e=>ne.reject($e),this.f=$e=>ne.emitOne($e),this.a.p},E);let H,Q;this.f=ne=>{Q||(Q=[]),Q.push(ne)},this.d=ne=>{H||(H=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(E){this.d(E),this.a.complete()}emitOne(E){this.f(E)}}e.$0h=G}),define(_e[23],Ee([0,1,12,8,11,14,20,3,2,7]),function(ae,e,g,t,q,M,Y,F,U,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=N,e.$yk=r,e.$zk=V,e.$Ak=se,e.$Bk=ee,e.$Ck=K,e.$Dk=re,e.$Ek=ce;function N(){return Object.create(null)}e.$wk="**",e.$xk="/";const _="[/\\\\]",v="[^/\\\\]",k=/\//g;function o(I,a){switch(I){case 0:return"";case 1:return`${v}*?`;default:return`(?:${_}|${v}+${_}${a?`|${_}${v}+`:""})*?`}}function r(I,a){if(!I)return[];const O=[];let B=!1,Z=!1,D="";for(const J of I){switch(J){case a:if(!B&&!Z){O.push(D),D="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}D+=J}return D&&O.push(D),O}function d(I){if(!I)return"";let a="";const O=r(I,e.$xk);if(O.every(B=>B===e.$wk))a=".*";else{let B=!1;O.forEach((Z,D)=>{if(Z===e.$wk){if(B)return;a+=o(2,D===O.length-1)}else{let J=!1,C="",ie=!1,le="";for(const de of Z){if(de!=="}"&&J){C+=de;continue}if(ie&&(de!=="]"||!le)){let p;de==="-"?p=de:(de==="^"||de==="!")&&!le?p="^":de===e.$xk?p="":p=(0,P.$jf)(de),le+=p;continue}switch(de){case"{":J=!0;continue;case"[":ie=!0;continue;case"}":{const W=`(?:${r(C,",").map(G=>d(G)).join("|")})`;a+=W,J=!1,C="";break}case"]":{a+="["+le+"]",ie=!1,le="";break}case"?":a+=v;continue;case"*":a+=o(1);continue;default:a+=(0,P.$jf)(de)}}D<O.length-1&&(O[D+1]!==e.$wk||D+2<O.length)&&(a+=_)}B=Z===e.$wk})}return a}const b=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,A=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new Y.$Gc(1e4),l=function(){return!1},c=function(){return null};function T(I,a){if(!I)return c;let O;typeof I!="string"?O=I.pattern:O=I,O=O.trim();const B=`${O}_${!!a.trimForExclusions}`;let Z=i.get(B);if(Z)return h(Z,I);let D;return b.test(O)?Z=u(O.substr(4),O):(D=f.exec(w(O,a)))?Z=R(D[1],O):(a.trimForExclusions?A:y).test(O)?Z=S(O,a):(D=s.exec(w(O,a)))?Z=m(D[1].substr(1),O,!0):(D=n.exec(w(O,a)))?Z=m(D[1],O,!1):Z=$(O),i.set(B,Z),h(Z,I)}function h(I,a){if(typeof a=="string")return I;const O=function(B,Z){return(0,M.$Fg)(B,a.base,!U.$e)?I((0,P.$of)(B.substr(a.base.length),F.sep),Z):null};return O.allBasenames=I.allBasenames,O.allPaths=I.allPaths,O.basenames=I.basenames,O.patterns=I.patterns,O}function w(I,a){return a.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function u(I,a){return function(O,B){return typeof O=="string"&&O.endsWith(I)?a:null}}function R(I,a){const O=`/${I}`,B=`\\${I}`,Z=function(J,C){return typeof J!="string"?null:C?C===I?a:null:J===I||J.endsWith(O)||J.endsWith(B)?a:null},D=[I];return Z.basenames=D,Z.patterns=[a],Z.allBasenames=D,Z}function S(I,a){const O=ue(I.slice(1,-1).split(",").map(C=>T(C,a)).filter(C=>C!==c),I),B=O.length;if(!B)return c;if(B===1)return O[0];const Z=function(C,ie){for(let le=0,de=O.length;le<de;le++)if(O[le](C,ie))return I;return null},D=O.find(C=>!!C.allBasenames);D&&(Z.allBasenames=D.allBasenames);const J=O.reduce((C,ie)=>ie.allPaths?C.concat(ie.allPaths):C,[]);return J.length&&(Z.allPaths=J),Z}function m(I,a,O){const B=F.sep===F.$jc.sep,Z=B?I:I.replace(k,F.sep),D=F.sep+Z,J=F.$jc.sep+I;let C;return O?C=function(ie,le){return typeof ie=="string"&&(ie===Z||ie.endsWith(D)||!B&&(ie===I||ie.endsWith(J)))?a:null}:C=function(ie,le){return typeof ie=="string"&&(ie===Z||!B&&ie===I)?a:null},C.allPaths=[(O?"*/":"./")+I],C}function $(I){try{const a=new RegExp(`^${d(I)}$`);return function(O){return a.lastIndex=0,typeof O=="string"&&a.test(O)?I:null}}catch{return c}}function V(I,a,O){return!I||typeof a!="string"?!1:se(I)(a,void 0,O)}function se(I,a={}){if(!I)return l;if(typeof I=="string"||ee(I)){const O=T(I,a);if(O===c)return l;const B=function(Z,D){return!!O(Z,D)};return O.allBasenames&&(B.allBasenames=O.allBasenames),O.allPaths&&(B.allPaths=O.allPaths),B}return X(I,a)}function ee(I){const a=I;return a?typeof a.base=="string"&&typeof a.pattern=="string":!1}function K(I){return I.allBasenames||[]}function re(I){return I.allPaths||[]}function X(I,a){const O=ue(Object.getOwnPropertyNames(I).map(C=>te(C,I[C],a)).filter(C=>C!==c)),B=O.length;if(!B)return c;if(!O.some(C=>!!C.requiresSiblings)){if(B===1)return O[0];const C=function(de,p){let W;for(let G=0,j=O.length;G<j;G++){const E=O[G](de,p);if(typeof E=="string")return E;(0,t.$sh)(E)&&(W||(W=[]),W.push(E))}return W?(async()=>{for(const G of W){const j=await G;if(typeof j=="string")return j}return null})():null},ie=O.find(de=>!!de.allBasenames);ie&&(C.allBasenames=ie.allBasenames);const le=O.reduce((de,p)=>p.allPaths?de.concat(p.allPaths):de,[]);return le.length&&(C.allPaths=le),C}const Z=function(C,ie,le){let de,p;for(let W=0,G=O.length;W<G;W++){const j=O[W];j.requiresSiblings&&le&&(ie||(ie=(0,F.$qc)(C)),de||(de=ie.substr(0,ie.length-(0,F.$rc)(C).length)));const E=j(C,ie,de,le);if(typeof E=="string")return E;(0,t.$sh)(E)&&(p||(p=[]),p.push(E))}return p?(async()=>{for(const W of p){const G=await W;if(typeof G=="string")return G}return null})():null},D=O.find(C=>!!C.allBasenames);D&&(Z.allBasenames=D.allBasenames);const J=O.reduce((C,ie)=>ie.allPaths?C.concat(ie.allPaths):C,[]);return J.length&&(Z.allPaths=J),Z}function te(I,a,O){if(a===!1)return c;const B=T(I,O);if(B===c)return c;if(typeof a=="boolean")return B;if(a){const Z=a.when;if(typeof Z=="string"){const D=(J,C,ie,le)=>{if(!le||!B(J,C))return null;const de=Z.replace("$(basename)",()=>ie),p=le(de);return(0,t.$sh)(p)?p.then(W=>W?I:null):p?I:null};return D.requiresSiblings=!0,D}}return B}function ue(I,a){const O=I.filter(C=>!!C.basenames);if(O.length<2)return I;const B=O.reduce((C,ie)=>{const le=ie.basenames;return le?C.concat(le):C},[]);let Z;if(a){Z=[];for(let C=0,ie=B.length;C<ie;C++)Z.push(a)}else Z=O.reduce((C,ie)=>{const le=ie.patterns;return le?C.concat(le):C},[]);const D=function(C,ie){if(typeof C!="string")return null;if(!ie){let de;for(de=C.length;de>0;de--){const p=C.charCodeAt(de-1);if(p===q.CharCode.Slash||p===q.CharCode.Backslash)break}ie=C.substr(de)}const le=B.indexOf(ie);return le!==-1?Z[le]:null};D.basenames=B,D.patterns=Z,D.allBasenames=B;const J=I.filter(C=>!C.basenames);return J.push(D),J}function ce(I,a){return(0,g.$xb)(I,a,(O,B)=>typeof O=="string"&&typeof B=="string"?O===B:typeof O!="string"&&typeof B!="string"?O.base===B.base&&O.pattern===B.pattern:!1)}}),define(_e[24],Ee([0,1,17,49,63,8,14,21,3,2,22,5]),function(ae,e,g,t,q,M,Y,F,U,P,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=y,e.whenDeleted=n,e.configureFlushOnWrite=h,e.writeFileSync=u,g=Ie(g);var v;(function(X){X[X.UNLINK=0]="UNLINK",X[X.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function k(X,te=v.UNLINK,ue){if((0,Y.$Jg)(X))throw new Error("rimraf - will refuse to recursively delete root");return te===v.UNLINK?r(X):o(X,ue)}async function o(X,te=(0,Y.$Og)((0,t.tmpdir)())){try{try{await g.promises.rename(X,te)}catch(ue){return ue.code==="ENOENT"?void 0:r(X)}r(te).catch(ue=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function r(X){return g.promises.rm(X,{recursive:!0,force:!0,maxRetries:3})}function d(X){if((0,Y.$Jg)(X))throw new Error("rimraf - will refuse to recursively delete root");g.rmSync(X,{recursive:!0,force:!0,maxRetries:3})}async function b(X,te){return A(await(te?f(X):g.promises.readdir(X)))}async function f(X){try{return await g.promises.readdir(X,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const te=[],ue=await b(X);for(const ce of ue){let I=!1,a=!1,O=!1;try{const B=await e.Promises.lstat((0,U.$mc)(X,ce));I=B.isFile(),a=B.isDirectory(),O=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}te.push({name:ce,isFile:()=>I,isDirectory:()=>a,isSymbolicLink:()=>O})}return te}function y(X){return A(g.readdirSync(X))}function A(X){return X.map(te=>typeof te=="string"?P.$d?(0,F.$nm)(te):te:(te.name=P.$d?(0,F.$nm)(te.name):te.name,te))}async function s(X){const te=await b(X),ue=[];for(const ce of te)await i.existsDirectory((0,U.$mc)(X,ce))&&ue.push(ce);return ue}function n(X,te=1e3){return new Promise(ue=>{let ce=!1;const I=setInterval(()=>{ce||(ce=!0,g.access(X,a=>{ce=!1,a&&(clearInterval(I),ue(void 0))}))},te)})}var i;(function(X){async function te(I){let a;try{if(a=await e.Promises.lstat(I),!a.isSymbolicLink())return{stat:a}}catch{}try{return{stat:await e.Promises.stat(I),symbolicLink:a?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&a)return{stat:a,symbolicLink:{dangling:!0}};if(P.$c&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(I)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&a)return{stat:a,symbolicLink:{dangling:!0}};throw B}throw O}}X.stat=te;async function ue(I){try{const{stat:a,symbolicLink:O}=await X.stat(I);return a.isFile()&&O?.dangling!==!0}catch{}return!1}X.existsFile=ue;async function ce(I){try{const{stat:a,symbolicLink:O}=await X.stat(I);return a.isDirectory()&&O?.dangling!==!0}catch{}return!1}X.existsDirectory=ce})(i||(e.SymlinkSupport=i={}));const l=new M.$Ph;function c(X,te,ue){return l.queueFor(_.URI.file(X),()=>{const ce=R(ue);return new Promise((I,a)=>w(X,te,ce,O=>O?a(O):I()))},N.$$g)}let T=!0;function h(X){T=X}function w(X,te,ue,ce){if(!T)return g.writeFile(X,te,{mode:ue.mode,flag:ue.flag},ce);g.open(X,ue.flag,ue.mode,(I,a)=>{if(I)return ce(I);g.writeFile(a,te,O=>{if(O)return g.close(a,()=>ce(O));g.fdatasync(a,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),h(!1)),g.close(a,Z=>ce(Z))))})})}function u(X,te,ue){const ce=R(ue);if(!T)return g.writeFileSync(X,te,{mode:ce.mode,flag:ce.flag});const I=g.openSync(X,ce.flag,ce.mode);try{g.writeFileSync(I,te);try{g.fdatasyncSync(I)}catch(a){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",a),h(!1)}}finally{g.closeSync(I)}}function R(X){return X?{mode:typeof X.mode=="number"?X.mode:438,flag:typeof X.flag=="string"?X.flag:"w"}:{mode:438,flag:"w"}}async function S(X,te,ue=6e4){if(X!==te)try{P.$c&&typeof ue=="number"?await m(X,te,Date.now(),ue):await g.promises.rename(X,te)}catch(ce){if(X.toLowerCase()!==te.toLowerCase()&&ce.code==="EXDEV"||X.endsWith("."))await $(X,te,{preserveSymlinks:!1}),await k(X,v.MOVE);else throw ce}}async function m(X,te,ue,ce,I=0){try{return await g.promises.rename(X,te)}catch(a){if(a.code!=="EACCES"&&a.code!=="EPERM"&&a.code!=="EBUSY")throw a;if(Date.now()-ue>=ce)throw console.error(`[node.js fs] rename failed after ${I} retries with error: ${a}`),a;if(I===0){let O=!1;try{const{stat:B}=await i.stat(te);B.isFile()||(O=!0)}catch{}if(O)throw a}return await(0,M.$Hh)(Math.min(100,I*10)),m(X,te,ue,ce,I+1)}}async function $(X,te,ue){return se(X,te,{root:{source:X,target:te},options:ue,handledSourcePaths:new Set})}const V=511;async function se(X,te,ue){if(ue.handledSourcePaths.has(X))return;ue.handledSourcePaths.add(X);const{stat:ce,symbolicLink:I}=await i.stat(X);if(I){if(ue.options.preserveSymlinks)try{return await re(X,te,ue)}catch{}if(I.dangling)return}return ce.isDirectory()?ee(X,te,ce.mode&V,ue):K(X,te,ce.mode&V)}async function ee(X,te,ue,ce){await e.Promises.mkdir(te,{recursive:!0,mode:ue});const I=await b(X);for(const a of I)await se((0,U.$mc)(X,a),(0,U.$mc)(te,a),ce)}async function K(X,te,ue){await e.Promises.copyFile(X,te),await e.Promises.chmod(te,ue)}async function re(X,te,ue){let ce=await e.Promises.readlink(X);(0,Y.$Fg)(ce,ue.root.source,!P.$e)&&(ce=(0,U.$mc)(ue.root.target,ce.substr(ue.root.source.length+1))),await e.Promises.symlink(ce,te)}e.Promises=new class{get access(){return g.promises.access}get stat(){return g.promises.stat}get lstat(){return g.promises.lstat}get utimes(){return g.promises.utimes}get read(){return(X,te,ue,ce,I)=>new Promise((a,O)=>{g.read(X,te,ue,ce,I,(B,Z,D)=>B?O(B):a({bytesRead:Z,buffer:D}))})}get readFile(){return g.promises.readFile}get write(){return(X,te,ue,ce,I)=>new Promise((a,O)=>{g.write(X,te,ue,ce,I,(B,Z,D)=>B?O(B):a({bytesWritten:Z,buffer:D}))})}get appendFile(){return g.promises.appendFile}get fdatasync(){return(0,q.promisify)(g.fdatasync)}get truncate(){return g.promises.truncate}get copyFile(){return g.promises.copyFile}get open(){return(0,q.promisify)(g.open)}get close(){return(0,q.promisify)(g.close)}get symlink(){return g.promises.symlink}get readlink(){return g.promises.readlink}get chmod(){return g.promises.chmod}get mkdir(){return g.promises.mkdir}get unlink(){return g.promises.unlink}get rmdir(){return g.promises.rmdir}get realpath(){return(0,q.promisify)(g.realpath)}async exists(X){try{return await e.Promises.access(X),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return s}get writeFile(){return c}get rm(){return k}get rename(){return S}get copy(){return $}}}),define(_e[32],Ee([0,1,17,3,2,7,24]),function(ae,e,g,t,q,M,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=F,e.$lr=U,e.$mr=P,e.$nr=N,g=Ie(g);function F(v){if(q.$e)return v;const k=(0,t.$pc)(v);if(v===k)return v;const o=((0,t.$qc)(v)||v).toLowerCase();try{const d=(0,Y.readdirSync)(k).filter(b=>b.toLowerCase()===o);if(d.length===1){const b=F(k);if(b)return(0,t.$mc)(b,d[0])}else if(d.length>1){const b=d.indexOf(o);if(b>=0){const f=F(k);if(f)return(0,t.$mc)(f,d[b])}}}catch{}return null}async function U(v,k){if(q.$e)return v;const o=(0,t.$pc)(v);if(v===o)return v;const r=((0,t.$qc)(v)||v).toLowerCase();try{if(k?.isCancellationRequested)return null;const b=(await Y.Promises.readdir(o)).filter(f=>f.toLowerCase()===r);if(b.length===1){const f=await U(o,k);if(f)return(0,t.$mc)(f,b[0])}else if(b.length>1){const f=b.indexOf(r);if(f>=0){const y=await U(o,k);if(y)return(0,t.$mc)(y,b[f])}}}catch{}return null}async function P(v){try{return await Y.Promises.realpath(v)}catch{const o=_(v);return await Y.Promises.access(o,g.constants.R_OK),o}}function N(v){try{return g.realpathSync(v)}catch{const o=_(v);return g.accessSync(o,g.constants.R_OK),o}}function _(v){return(0,M.$pf)((0,t.$kc)(v),t.sep)}}),define(_e[50],Ee([0,1,3,2,28,29,10,24]),function(ae,e,g,t,q,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=U,e.$zm=P,g=Ie(g),t=Ie(t),q=Ie(q),Y=Ie(Y),F=Ie(F),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function U(_=q.env){return _.comspec||"cmd.exe"}function P(_){let v=[],k=!1;const o=function(r){if(k){v.push(r);return}(!_.send(r,b=>{if(b&&console.error(b),k=!1,v.length>0){const f=v.slice(0);v=[],f.forEach(y=>o(y))}})||t.$c)&&(k=!0)};return{send:o}}var N;(function(_){async function v(k,o,r){if(g.$lc(k))return k;if(o===void 0&&(o=q.cwd()),g.$pc(k)!=="."||(r===void 0&&Y.$gg(q.env.PATH)&&(r=q.env.PATH.split(g.$wc)),r===void 0||r.length===0))return g.$mc(o,k);async function b(f){if(await F.Promises.exists(f)){let y;try{y=await F.Promises.stat(f)}catch(A){A.message.startsWith("EACCES")&&(y=await F.Promises.lstat(f))}return y?!y.isDirectory():!1}return!1}for(const f of r){let y;if(g.$lc(f)?y=g.$mc(f,k):y=g.$mc(o,f,k),await b(y))return y;let A=y+".com";if(await b(A)||(A=y+".exe",await b(A)))return A}return g.$mc(o,k)}_.findExecutable=v})(N||(e.win32=N={}))});var Ye=this&&this.__decorate||function(ae,e,g,t){var q=arguments.length,M=q<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,g):t,Y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ae,e,g,t);else for(var F=ae.length-1;F>=0;F--)(Y=ae[F])&&(M=(q<3?Y(M):q>3?Y(e,g,M):Y(e,g))||M);return q>3&&M&&Object.defineProperty(e,g,M),M};define(_e[25],Ee([0,1,12,8,16,13,38,9,6,4,48,7,10]),function(ae,e,g,t,q,M,Y,F,U,P,N,_,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=h,e.$hi=w,e.$mi=V,e.$ni=se,_=Ie(_);var k;(function(I){I[I.Promise=100]="Promise",I[I.PromiseCancel=101]="PromiseCancel",I[I.EventListen=102]="EventListen",I[I.EventDispose=103]="EventDispose"})(k||(k={}));function o(I){switch(I){case k.Promise:return"req";case k.PromiseCancel:return"cancel";case k.EventListen:return"subscribe";case k.EventDispose:return"unsubscribe"}}var r;(function(I){I[I.Initialize=200]="Initialize",I[I.PromiseSuccess=201]="PromiseSuccess",I[I.PromiseError=202]="PromiseError",I[I.PromiseErrorObj=203]="PromiseErrorObj",I[I.EventFire=204]="EventFire"})(r||(r={}));function d(I){switch(I){case r.Initialize:return"init";case r.PromiseSuccess:return"reply:";case r.PromiseError:case r.PromiseErrorObj:return"replyErr:";case r.EventFire:return"event:"}}var b;(function(I){I[I.Uninitialized=0]="Uninitialized",I[I.Idle=1]="Idle"})(b||(b={}));function f(I){let a=0;for(let O=0;;O+=7){const B=I.read(1);if(a|=(B.buffer[0]&127)<<O,!(B.buffer[0]&128))return a}}const y=l(0);function A(I,a){if(a===0){I.write(y);return}let O=0;for(let Z=a;Z!==0;Z=Z>>>7)O++;const B=q.$Pe.alloc(O);for(let Z=0;a!==0;Z++)B.buffer[Z]=a&127,a=a>>>7,a>0&&(B.buffer[Z]|=128);I.write(B)}class s{constructor(a){this.b=a,this.a=0}read(a){const O=this.b.slice(this.a,this.a+a);return this.a+=O.byteLength,O}}e.$ei=s;class n{constructor(){this.a=[]}get buffer(){return q.$Pe.concat(this.a)}write(a){this.a.push(a)}}e.$fi=n;var i;(function(I){I[I.Undefined=0]="Undefined",I[I.String=1]="String",I[I.Buffer=2]="Buffer",I[I.VSBuffer=3]="VSBuffer",I[I.Array=4]="Array",I[I.Object=5]="Object",I[I.Int=6]="Int"})(i||(i={}));function l(I){const a=q.$Pe.alloc(1);return a.writeUInt8(I,0),a}const c={Undefined:l(i.Undefined),String:l(i.String),Buffer:l(i.Buffer),VSBuffer:l(i.VSBuffer),Array:l(i.Array),Object:l(i.Object),Uint:l(i.Int)},T=typeof Buffer<"u";function h(I,a){if(typeof a>"u")I.write(c.Undefined);else if(typeof a=="string"){const O=q.$Pe.fromString(a);I.write(c.String),A(I,O.byteLength),I.write(O)}else if(T&&Buffer.isBuffer(a)){const O=q.$Pe.wrap(a);I.write(c.Buffer),A(I,O.byteLength),I.write(O)}else if(a instanceof q.$Pe)I.write(c.VSBuffer),A(I,a.byteLength),I.write(a);else if(Array.isArray(a)){I.write(c.Array),A(I,a.length);for(const O of a)h(I,O)}else if(typeof a=="number"&&(a|0)===a)I.write(c.Uint),A(I,a);else{const O=q.$Pe.fromString(JSON.stringify(a));I.write(c.Object),A(I,O.byteLength),I.write(O)}}function w(I){switch(I.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return I.read(f(I)).toString();case i.Buffer:return I.read(f(I)).buffer;case i.VSBuffer:return I.read(f(I));case i.Array:{const O=f(I),B=[];for(let Z=0;Z<O;Z++)B.push(w(I));return B}case i.Object:return JSON.parse(I.read(f(I)).toString());case i.Int:return f(I)}}class u{constructor(a,O,B=null,Z=1e3){this.h=a,this.j=O,this.k=B,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(D=>this.q(D)),this.m({type:r.Initialize})}registerChannel(a,O){this.b.set(a,O),setTimeout(()=>this.w(a),0)}m(a){switch(a.type){case r.Initialize:{const O=this.o([a.type]);this.k?.logOutgoing(O,0,R.OtherSide,d(a.type));return}case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:{const O=this.o([a.type,a.id],a.data);this.k?.logOutgoing(O,a.id,R.OtherSide,d(a.type),a.data);return}}}o(a,O=void 0){const B=new n;return h(B,a),h(B,O),this.p(B.buffer)}p(a){try{return this.h.send(a),a.byteLength}catch{return 0}}q(a){const O=new s(a),B=w(O),Z=w(O),D=B[0];switch(D){case k.Promise:return this.k?.logIncoming(a.byteLength,B[1],R.OtherSide,`${o(D)}: ${B[2]}.${B[3]}`,Z),this.s({type:D,id:B[1],channelName:B[2],name:B[3],arg:Z});case k.EventListen:return this.k?.logIncoming(a.byteLength,B[1],R.OtherSide,`${o(D)}: ${B[2]}.${B[3]}`,Z),this.t({type:D,id:B[1],channelName:B[2],name:B[3],arg:Z});case k.PromiseCancel:return this.k?.logIncoming(a.byteLength,B[1],R.OtherSide,`${o(D)}`),this.u({type:D,id:B[1]});case k.EventDispose:return this.k?.logIncoming(a.byteLength,B[1],R.OtherSide,`${o(D)}`),this.u({type:D,id:B[1]})}}s(a){const O=this.b.get(a.channelName);if(!O){this.v(a);return}const B=new M.$ye;let Z;try{Z=O.call(this.j,a.name,a.arg,B.token)}catch(C){Z=Promise.reject(C)}const D=a.id;Z.then(C=>{this.m({id:D,data:C,type:r.PromiseSuccess})},C=>{C instanceof Error?this.m({id:D,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split(`
`):void 0},type:r.PromiseError}):this.m({id:D,data:C,type:r.PromiseErrorObj})}).finally(()=>{J.dispose(),this.d.delete(a.id)});const J=(0,P.$Vc)(()=>B.cancel());this.d.set(a.id,J)}t(a){const O=this.b.get(a.channelName);if(!O){this.v(a);return}const B=a.id,D=O.listen(this.j,a.name,a.arg)(J=>this.m({id:B,data:J,type:r.EventFire}));this.d.set(a.id,D)}u(a){const O=this.d.get(a.id);O&&(O.dispose(),this.d.delete(a.id))}v(a){let O=this.g.get(a.channelName);O||(O=[],this.g.set(a.channelName,O));const B=setTimeout(()=>{console.error(`Unknown channel: ${a.channelName}`),a.type===k.Promise&&this.m({id:a.id,data:{name:"Unknown channel",message:`Channel name '${a.channelName}' timed out after ${this.l}ms`,stack:void 0},type:r.PromiseError})},this.l);O.push({request:a,timeoutTimer:B})}w(a){const O=this.g.get(a);if(O){for(const B of O)switch(clearTimeout(B.timeoutTimer),B.request.type){case k.Promise:this.s(B.request);break;case k.EventListen:this.t(B.request);break}this.g.delete(a)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,P.$Sc)(this.d.values()),this.d.clear()}}e.$ii=u;var R;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class S{constructor(a,O=null){this.l=a,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new U.$ne,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(B=>this.s(B)),this.j=O}getChannel(a){const O=this;return{call(B,Z,D){return O.a?Promise.reject(new F.$8):O.m(a,B,Z,D)},listen(B,Z){return O.a?U.Event.None:O.o(a,B,Z)}}}m(a,O,B,Z=M.CancellationToken.None){const D=this.g++,J=k.Promise,C={id:D,type:J,channelName:a,name:O,arg:B};if(Z.isCancellationRequested)return Promise.reject(new F.$8);let ie;return new Promise((de,p)=>{if(Z.isCancellationRequested)return p(new F.$8);const W=()=>{const H=Q=>{switch(Q.type){case r.PromiseSuccess:this.f.delete(D),de(Q.data);break;case r.PromiseError:{this.f.delete(D);const ne=new Error(Q.data.message);ne.stack=Array.isArray(Q.data.stack)?Q.data.stack.join(`
`):Q.data.stack,ne.name=Q.data.name,p(ne);break}case r.PromiseErrorObj:this.f.delete(D),p(Q.data);break}};this.f.set(D,H),this.p(C)};let G=null;this.b===b.Idle?W():(G=(0,t.$th)(H=>this.u()),G.then(()=>{G=null,W()}));const j=()=>{G?(G.cancel(),G=null):this.p({id:D,type:k.PromiseCancel}),p(new F.$8)},E=Z.onCancellationRequested(j);ie=(0,P.$Uc)((0,P.$Vc)(j),E),this.d.add(ie)}).finally(()=>{ie.dispose(),this.d.delete(ie)})}o(a,O,B){const Z=this.g++,D=k.EventListen,J={id:Z,type:D,channelName:a,name:O,arg:B};let C=null;const ie=new U.$ne({onWillAddFirstListener:()=>{C=(0,t.$th)(de=>this.u()),C.then(()=>{C=null,this.d.add(ie),this.p(J)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(ie),this.p({id:Z,type:k.EventDispose}))}}),le=de=>ie.fire(de.data);return this.f.set(Z,le),ie.event}p(a){switch(a.type){case k.Promise:case k.EventListen:{const O=this.q([a.type,a.id,a.channelName,a.name],a.arg);this.j?.logOutgoing(O,a.id,R.LocalSide,`${o(a.type)}: ${a.channelName}.${a.name}`,a.arg);return}case k.PromiseCancel:case k.EventDispose:{const O=this.q([a.type,a.id]);this.j?.logOutgoing(O,a.id,R.LocalSide,o(a.type));return}}}q(a,O=void 0){const B=new n;return h(B,a),h(B,O),this.r(B.buffer)}r(a){try{return this.l.send(a),a.byteLength}catch{return 0}}s(a){const O=new s(a),B=w(O),Z=w(O),D=B[0];switch(D){case r.Initialize:return this.j?.logIncoming(a.byteLength,0,R.LocalSide,d(D)),this.t({type:B[0]});case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:return this.j?.logIncoming(a.byteLength,B[1],R.LocalSide,d(D),Z),this.t({type:B[0],id:B[1],data:Z})}}t(a){if(a.type===r.Initialize){this.b=b.Idle,this.k.fire();return}this.f.get(a.id)?.(a)}get onDidInitializePromise(){return U.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,P.$Sc)(this.d.values()),this.d.clear()}}e.$ji=S,Ye([Y.$$h],S.prototype,"onDidInitializePromise",null);class m{get connections(){const a=[];return this.f.forEach(O=>a.push(O)),a}constructor(a,O,B){this.a=new Map,this.f=new Set,this.g=new U.$ne,this.onDidAddConnection=this.g.event,this.h=new U.$ne,this.onDidRemoveConnection=this.h.event,this.j=new P.$Wc,this.j.add(a(({protocol:Z,onDidClientDisconnect:D})=>{const J=U.Event.once(Z.onMessage);this.j.add(J(C=>{const ie=new s(C),le=w(ie),de=new u(Z,le,O,B),p=new S(Z,O);this.a.forEach((G,j)=>de.registerChannel(j,G));const W={channelServer:de,channelClient:p,ctx:le};this.f.add(W),this.g.fire(W),this.j.add(D(()=>{de.dispose(),p.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(a,O){const B=this;return{call(Z,D,J){let C;if((0,v.$ug)(O)){const le=(0,g.$6b)(B.connections.filter(O));C=le?Promise.resolve(le):U.Event.toPromise(U.Event.filter(B.onDidAddConnection,O))}else C=O.routeCall(B,Z,D);const ie=C.then(le=>le.channelClient.getChannel(a));return V(ie).call(Z,D,J)},listen(Z,D){if((0,v.$ug)(O))return B.k(a,O,Z,D);const J=O.routeEvent(B,Z,D).then(C=>C.channelClient.getChannel(a));return V(J).listen(Z,D)}}}k(a,O,B,Z){const D=this;let J;const C=new U.$ne({onWillAddFirstListener:()=>{J=new P.$Wc;const ie=new U.$te,le=new Map,de=W=>{const j=W.channelClient.getChannel(a).listen(B,Z),E=ie.add(j);le.set(W,E)},p=W=>{const G=le.get(W);G&&(G.dispose(),le.delete(W))};D.connections.filter(O).forEach(de),U.Event.filter(D.onDidAddConnection,O)(de,void 0,J),D.onDidRemoveConnection(p,void 0,J),ie.event(C.fire,C,J),J.add(ie)},onDidRemoveLastListener:()=>{J?.dispose(),J=void 0}});return C.event}registerChannel(a,O){this.a.set(a,O);for(const B of this.f)B.channelServer.registerChannel(a,O)}dispose(){this.j.dispose();for(const a of this.f)a.channelClient.dispose(),a.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=m;class ${constructor(a,O,B=null){const Z=new n;h(Z,O),a.send(Z.buffer),this.a=new S(a,B),this.d=new u(a,O,B)}getChannel(a){return this.a.getChannel(a)}registerChannel(a,O){this.d.registerChannel(a,O)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=$;function V(I){return{call(a,O,B){return I.then(Z=>Z.call(a,O,B))},listen(a,O){const B=new U.$we;return I.then(Z=>B.input=Z.listen(a,O)),B.event}}}function se(I){let a=!1;return{call(O,B,Z){return a?I.call(O,B,Z):(0,t.$Hh)(0).then(()=>a=!0).then(()=>I.call(O,B,Z))},listen(O,B){if(a)return I.listen(O,B);const Z=new U.$we;return(0,t.$Hh)(0).then(()=>a=!0).then(()=>Z.input=I.listen(O,B)),Z.event}}}class ee{constructor(a){this.a=a}routeCall(a){return this.b(a)}routeEvent(a){return this.b(a)}async b(a){for(const O of a.connections)if(await Promise.resolve(this.a(O.ctx)))return Promise.resolve(O);return await U.Event.toPromise(a.onDidAddConnection),await this.b(a)}}e.$oi=ee;var K;(function(I){function a(D,J,C){const ie=D,le=C&&C.disableMarshalling,de=new Map;for(const p in ie)B(p)&&de.set(p,U.Event.buffer(ie[p],!0,void 0,J));return new class{listen(p,W,G){const j=de.get(W);if(j)return j;const E=ie[W];if(typeof E=="function"){if(Z(W))return E.call(ie,G);if(B(W))return de.set(W,U.Event.buffer(ie[W],!0,void 0,J)),de.get(W)}throw new F.$eb(`Event not found: ${W}`)}call(p,W,G){const j=ie[W];if(typeof j=="function"){if(!le&&Array.isArray(G))for(let H=0;H<G.length;H++)G[H]=(0,N.$di)(G[H]);let E=j.apply(ie,G);return E instanceof Promise||(E=Promise.resolve(E)),E}throw new F.$eb(`Method not found: ${W}`)}}}I.fromService=a;function O(D,J){const C=J&&J.disableMarshalling;return new Proxy({},{get(ie,le){if(typeof le=="string")return J?.properties?.has(le)?J.properties.get(le):Z(le)?function(de){return D.listen(le,de)}:B(le)?D.listen(le):async function(...de){let p;J&&!(0,v.$pg)(J.context)?p=[J.context,...de]:p=de;const W=await D.call(le,p);return C?W:(0,N.$di)(W)};throw new F.$eb(`Property not found: ${String(le)}`)}})}I.toService=O;function B(D){return D[0]==="o"&&D[1]==="n"&&_.$Gf(D.charCodeAt(2))}function Z(D){return/^onDynamic/.test(D)&&_.$Gf(D.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(I){if(Array.isArray(I))return I;if(I&&typeof I=="object"&&typeof I.toString=="function"){const a=I.toString();if(a!=="[object Object]")return a}return I}function te(I){return Array.isArray(I)?I.map(X):X(I)}function ue(I,a,O,B,Z,D,J){J=te(J);const C=re[Z],ie=C[B%C.length];let le=[`%c[${I}]%c[${String(a).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${D}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(D)?(le=le.concat(J),le.push(")")):le.push(J),console.log.apply(console,le)}class ce{constructor(a,O){this.d=a,this.f=O,this.a=0,this.b=0}logOutgoing(a,O,B,Z,D){this.b+=a,ue(this.d,this.b,a,O,B,Z,D)}logIncoming(a,O,B,Z,D){this.a+=a,ue(this.f,this.a,a,O,B,Z,D)}}e.$pi=ce}),define(_e[51],Ee([0,1,64,8,16,13,47,9,6,4,45,50,29,25]),function(ae,e,g,t,q,M,Y,F,U,P,N,_,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0,F=Ie(F);class o extends k.$ii{constructor(b){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:U.Event.fromNodeEventEmitter(process,"message",f=>q.$Pe.wrap(Buffer.from(f,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$gr=o;class r{constructor(b,f){this.i=b,this.j=f,this.c=new Set,this.g=new Map,this.h=new U.$ne,this.onDidProcessExit=this.h.event;const y=f&&f.timeout?f.timeout:6e4;this.b=new t.$Dh(y),this.d=null,this.f=null}getChannel(b){const f=this;return{call(y,A,s){return f.k(b,y,A,s)},listen(y,A){return f.l(b,y,A)}}}k(b,f,y,A=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(A.isCancellationRequested)return Promise.reject(F.$9());this.b.cancel();const s=this.n(b),n=(0,t.$th)(c=>s.call(f,y,c)),i=A.onCancellationRequested(()=>n.cancel()),l=(0,P.$Vc)(()=>n.cancel());return this.c.add(l),n.finally(()=>{i.dispose(),this.c.delete(l),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(b,f,y){if(!this.b)return U.Event.None;this.b.cancel();let A;const s=new U.$ne({onWillAddFirstListener:()=>{A=this.n(b).listen(f,y)(s.fire,s),this.c.add(A)},onDidRemoveLastListener:()=>{this.c.delete(A),A.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,N.$fo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,v.$mm)(f.env),this.d=(0,g.fork)(this.i,b,f);const y=new U.$ne,s=U.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,Y.$cr)(h)){(0,Y.log)(h,`IPC Library: ${this.j.serverName}`);return}y.fire(q.$Pe.wrap(Buffer.from(h,"base64")))}),n=this.j.useQueue?(0,_.$zm)(this.d):this.d,i=h=>this.d&&this.d.connected&&n.send(h.buffer.toString("base64")),l=y.event,c={send:i,onMessage:l};this.f=new k.$ji(c);const T=()=>this.o();process.once("exit",T),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,w)=>{process.removeListener("exit",T),s.dispose(),this.c.forEach(u=>(0,P.$Sc)(u)),this.c.clear(),h!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+w),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:w})})}return this.f}n(b){let f=this.g.get(b);return f||(f=this.m.getChannel(b),this.g.set(b,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$hr=r}),define(_e[33],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XX=g;function g(t){return!!t.parentPort}}),define(_e[52],Ee([0,1,33,16,25,6,10,12]),function(ae,e,g,t,q,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YX=void 0,e.$ZX=N;class U{constructor(v){this.a=v,this.onMessage=M.Event.fromNodeEventEmitter(this.a,"message",k=>k.data?t.$Pe.wrap(k.data):t.$Pe.alloc(0)),v.start()}send(v){this.a.postMessage(v.buffer)}disconnect(){this.a.close()}}class P extends q.$ki{static b(v){(0,Y.$qg)((0,g.$XX)(process),"Electron Utility Process");const k=new M.$ne;return process.parentPort.on("message",o=>{if(v?.handledClientConnection(o))return;const r=(0,F.$Rb)(o.ports);r&&k.fire(r)}),M.Event.map(k.event,o=>({protocol:new U(o),onDidClientDisconnect:M.Event.fromNodeEventEmitter(o,"close")}))}constructor(v){super(P.b(v))}}e.$YX=P;function N(_,v,k){const o=r=>{r.data===v&&(_.removeListener("message",o),k())};_.on("message",o)}}),define(_e[53],Ee([54,55]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(_e[56],Ee([0,1,12,10,53]),function(ae,e,g,t,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=U,e.$sj=P,e.$tj=N,g=Ie(g),t=Ie(t),q=Ie(q);function M(_,v){return v&&(_.stack||_.stacktrace)?q.localize(0,null,F(_),Y(_.stack)||Y(_.stacktrace)):F(_)}function Y(_){return Array.isArray(_)?_.join(`
`):_}function F(_){return _.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${_.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof _.code=="string"&&typeof _.errno=="number"&&typeof _.syscall=="string"?q.localize(1,null,_.message):_.message||q.localize(2,null)}function U(_=null,v=!1){if(!_)return q.localize(3,null);if(Array.isArray(_)){const k=g.$Kb(_),o=U(k[0],v);return k.length>1?q.localize(4,null,o,k.length):o}if(t.$gg(_))return _;if(_.detail){const k=_.detail;if(k.error)return M(k.error,v);if(k.exception)return M(k.exception,v)}return _.stack?M(_,v):_.message?_.message:q.localize(5,null)}function P(_){const v=_;return v instanceof Error&&Array.isArray(v.actions)}function N(_,v){let k;return typeof _=="string"?k=new Error(_):k=_,k.actions=v,k}}),define(_e[57],Ee([54,55]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(_e[58],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=q,e.$Hi=M;var g;(function(Y){Y.serviceIds=new Map,Y.DI_TARGET="$di$target",Y.DI_DEPENDENCIES="$di$dependencies";function F(U){return U[Y.DI_DEPENDENCIES]||[]}Y.getServiceDependencies=F})(g||(e._util=g={})),e.$Fi=q("instantiationService");function t(Y,F,U){F[g.DI_TARGET]===F?F[g.DI_DEPENDENCIES].push({id:Y,index:U}):(F[g.DI_DEPENDENCIES]=[{id:Y,index:U}],F[g.DI_TARGET]=F)}function q(Y){if(g.serviceIds.has(Y))return g.serviceIds.get(Y);const F=function(U,P,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(F,U,N)};return F.toString=()=>Y,g.serviceIds.set(Y,F),F}function M(Y){return Y}}),define(_e[18],Ee([0,1,30,3,7,10,5,57,58,2,31,15]),function(ae,e,g,t,q,M,Y,F,U,P,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=v,e.$cl=d,e.$dl=f,e.$el=y,e.$fl=A,e.$gl=s,e.$hl=n,e.$il=i,e.$jl=l,e.$kl=c,e.$ll=T,e.$nl=u,e.$ol=R,e.$pl=S,e.$ql=m,e.$rl=$,e.$ul=re,e.$Gl=a,e.$Hl=O,e.$Jl=Z,e.$al=(0,U.$Gi)("fileService");function v(D){return D.create===!0}var k;(function(D){D[D.Unknown=0]="Unknown",D[D.File=1]="File",D[D.Directory=2]="Directory",D[D.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var o;(function(D){D[D.Readonly=1]="Readonly",D[D.Locked=2]="Locked"})(o||(e.FilePermission=o={}));var r;(function(D){D[D.UPDATED=2]="UPDATED",D[D.ADDED=4]="ADDED",D[D.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function d(D){const J=D;return!!J&&typeof J.onDidChange=="function"}var b;(function(D){D[D.None=0]="None",D[D.FileReadWrite=2]="FileReadWrite",D[D.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",D[D.FileReadStream=16]="FileReadStream",D[D.FileFolderCopy=8]="FileFolderCopy",D[D.PathCaseSensitive=1024]="PathCaseSensitive",D[D.Readonly=2048]="Readonly",D[D.Trash=4096]="Trash",D[D.FileWriteUnlock=8192]="FileWriteUnlock",D[D.FileAtomicRead=16384]="FileAtomicRead",D[D.FileAtomicWrite=32768]="FileAtomicWrite",D[D.FileAtomicDelete=65536]="FileAtomicDelete",D[D.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function f(D){return!!(D.capabilities&b.FileReadWrite)}function y(D){return!!(D.capabilities&b.FileFolderCopy)}function A(D){return!!(D.capabilities&b.FileClone)}function s(D){return!!(D.capabilities&b.FileOpenReadWriteClose)}function n(D){return!!(D.capabilities&b.FileReadStream)}function i(D){return f(D)?!!(D.capabilities&b.FileAtomicRead):!1}function l(D){return f(D)?!!(D.capabilities&b.FileAtomicWrite):!1}function c(D){return!!(D.capabilities&b.FileAtomicDelete)}function T(D){return!!(D.capabilities&b.Readonly)}var h;(function(D){D.FileExists="EntryExists",D.FileNotFound="EntryNotFound",D.FileNotADirectory="EntryNotADirectory",D.FileIsADirectory="EntryIsADirectory",D.FileExceedsStorageQuota="EntryExceedsStorageQuota",D.FileTooLarge="EntryTooLarge",D.FileWriteLocked="EntryWriteLocked",D.NoPermissions="NoPermissions",D.Unavailable="Unavailable",D.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class w extends Error{static create(J,C){const ie=new w(J.toString(),C);return S(ie,C),ie}constructor(J,C){super(J),this.code=C}}e.$ml=w;function u(D,J){return w.create(D,J)}function R(D){return D||u((0,F.localize)(0,null),h.Unknown)}function S(D,J){return D.name=J?`${J} (FileSystemError)`:"FileSystemError",D}function m(D){if(!D)return h.Unknown;if(D instanceof w)return D.code;const J=/^(.+) \(FileSystemError\)$/.exec(D.name);if(!J)return h.Unknown;switch(J[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function $(D){if(D instanceof X)return D.fileOperationResult;switch(m(D)){case h.FileNotFound:return ce.FILE_NOT_FOUND;case h.FileIsADirectory:return ce.FILE_IS_DIRECTORY;case h.FileNotADirectory:return ce.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return ce.FILE_WRITE_LOCKED;case h.NoPermissions:return ce.FILE_PERMISSION_DENIED;case h.FileExists:return ce.FILE_MOVE_CONFLICT;case h.FileTooLarge:return ce.FILE_TOO_LARGE;default:return ce.FILE_OTHER_ERROR}}var V;(function(D){D[D.CREATE=0]="CREATE",D[D.DELETE=1]="DELETE",D[D.MOVE=2]="MOVE",D[D.COPY=3]="COPY",D[D.WRITE=4]="WRITE"})(V||(e.FileOperation=V={}));class se{constructor(J,C,ie){this.resource=J,this.operation=C,this.target=ie}isOperation(J){return this.operation===J}}e.$sl=se;var ee;(function(D){D[D.UPDATED=0]="UPDATED",D[D.ADDED=1]="ADDED",D[D.DELETED=2]="DELETED"})(ee||(e.FileChangeType=ee={}));class K{constructor(J,C){this.c=C,this.b=void 0,this.d=new _.$X(()=>{const ie=g.$Mi.forUris(()=>this.c);return ie.fill(this.rawAdded.map(le=>[le,!0])),ie}),this.f=new _.$X(()=>{const ie=g.$Mi.forUris(()=>this.c);return ie.fill(this.rawUpdated.map(le=>[le,!0])),ie}),this.g=new _.$X(()=>{const ie=g.$Mi.forUris(()=>this.c);return ie.fill(this.rawDeleted.map(le=>[le,!0])),ie}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ie of J){switch(ie.type){case ee.ADDED:this.rawAdded.push(ie.resource);break;case ee.UPDATED:this.rawUpdated.push(ie.resource);break;case ee.DELETED:this.rawDeleted.push(ie.resource);break}this.b!==K.a&&(typeof ie.cId=="number"?this.b===void 0?this.b=ie.cId:this.b!==ie.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(J,...C){return this.h(J,{includeChildren:!1},...C)}affects(J,...C){return this.h(J,{includeChildren:!0},...C)}h(J,C,...ie){if(!J)return!1;const le=ie.length>0;return!!((!le||ie.includes(ee.ADDED))&&(this.d.value.get(J)||C.includeChildren&&this.d.value.findSuperstr(J))||(!le||ie.includes(ee.UPDATED))&&(this.f.value.get(J)||C.includeChildren&&this.f.value.findSuperstr(J))||(!le||ie.includes(ee.DELETED))&&(this.g.value.findSubstr(J)||C.includeChildren&&this.g.value.findSuperstr(J)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(J){return this.b===J}hasCorrelation(){return typeof this.b=="number"}}e.$tl=K,K.a=null;function re(D,J,C){return!D||!J||D===J||J.length>D.length?!1:(J.charAt(J.length-1)!==t.sep&&(J+=t.sep),C?(0,q.$If)(D,J):D.indexOf(J)===0)}class X extends Error{constructor(J,C,ie){super(J),this.fileOperationResult=C,this.options=ie}}e.$vl=X;class te extends X{constructor(J,C,ie,le){super(J,C,le),this.fileOperationResult=C,this.size=ie}}e.$wl=te;class ue extends X{constructor(J,C,ie){super(J,ce.FILE_NOT_MODIFIED_SINCE,ie),this.stat=C}}e.$xl=ue;var ce;(function(D){D[D.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",D[D.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",D[D.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",D[D.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",D[D.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",D[D.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",D[D.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",D[D.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",D[D.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",D[D.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",D[D.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var I;(function(D){D[D.FILE=0]="FILE",D[D.FOLDER=1]="FOLDER",D[D.ROOT_FOLDER=2]="ROOT_FOLDER"})(I||(e.FileKind=I={})),e.$Fl="";function a(D){if(!(typeof D.size!="number"||typeof D.mtime!="number"))return D.mtime.toString(29)+D.size.toString(31)}async function O(D,J){if(!J.hasProvider(Y.URI.from({scheme:D.scheme})))return new Promise(C=>{const ie=J.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===D.scheme&&le.added&&(ie.dispose(),C())})})}class B{static formatSize(J){return(0,M.$kg)(J)||(J=0),J<B.KB?(0,F.localize)(1,null,J.toFixed(0)):J<B.MB?(0,F.localize)(2,null,(J/B.KB).toFixed(2)):J<B.GB?(0,F.localize)(3,null,(J/B.MB).toFixed(2)):J<B.TB?(0,F.localize)(4,null,(J/B.GB).toFixed(2)):(0,F.localize)(5,null,(J/B.TB).toFixed(2))}}e.$Il=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;function Z(D){const J=typeof D=="string"||D?.scheme===N.Schemas.vscodeRemote;return typeof D!="string"&&D?.scheme===N.Schemas.file?1024*B.MB:J?10*B.MB:P.$i?50*B.MB:1024*B.MB}}),define(_e[19],Ee([0,1,23,4,3,2,5,18]),function(ae,e,g,t,q,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0,e.$3q=U,e.$4q=P,e.$8q=k,e.$9q=o,e.$0q=r,e.$$q=d,e.$_q=f,e.$ar=y;function U(A){return typeof A.correlationId=="number"}function P(A){return A.recursive===!0}class N extends t.$Xc{constructor(s,n,i,l){super(),this.h=s,this.j=n,this.m=i,this.n=l,this.c=this.B(new t.$Yc),this.f=void 0,this.g=0}s(){const s=new t.$Wc;this.c.value=s,this.b=this.r(s),this.b.setVerboseLogging(this.m),s.add(this.b.onDidChangeFile(n=>this.h(n))),s.add(this.b.onDidLogMessage(n=>this.j(n))),s.add(this.b.onDidError(n=>this.t(n.error,n.request)))}t(s,n){this.u(s,n)?this.g<N.a&&this.f?(this.y(`restarting watcher after unexpected error: ${s}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${s}`):this.y(s)}u(s,n){return!(!this.n.restartOnError||n||s.indexOf("No space left on device")!==-1||s.indexOf("EMFILE")!==-1)}w(s){this.g++,this.s(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.m=s,await this.b?.setVerboseLogging(s)}y(s){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${s}`})}z(s){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$5q=N,N.a=5;class _ extends N{constructor(s,n,i){super(s,n,i,{type:"node.js",restartOnError:!1})}}e.$6q=_;class v extends N{constructor(s,n,i){super(s,n,i,{type:"universal",restartOnError:!0})}}e.$7q=v;function k(A){return A.map(s=>({type:s.type,resource:Y.URI.revive(s.resource),cId:s.cId}))}function o(A){const s=new b;for(const n of A)s.processEvent(n);return s.coalesce()}function r(A,s){return typeof s=="string"&&!s.startsWith(g.$wk)&&!(0,q.$lc)(s)?{base:A,pattern:s}:s}function d(A,s){const n=[];for(const i of s)n.push((0,g.$Ak)(r(A,i)));return n}class b{constructor(){this.a=new Set,this.b=new Map}c(s){return M.$e?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const n=this.b.get(this.c(s));let i=!1;if(n){const l=n.type,c=s.type;n.resource.fsPath!==s.resource.fsPath&&(s.type===F.FileChangeType.DELETED||s.type===F.FileChangeType.ADDED)?i=!0:l===F.FileChangeType.ADDED&&c===F.FileChangeType.DELETED?(this.b.delete(this.c(s)),this.a.delete(n)):l===F.FileChangeType.DELETED&&c===F.FileChangeType.ADDED?n.type=F.FileChangeType.UPDATED:l===F.FileChangeType.ADDED&&c===F.FileChangeType.UPDATED||(n.type=c)}else i=!0;i&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],n=[];return Array.from(this.a).filter(i=>i.type!==F.FileChangeType.DELETED?(s.push(i),!1):!0).sort((i,l)=>i.resource.fsPath.length-l.resource.fsPath.length).filter(i=>n.some(l=>(0,F.$ul)(i.resource.fsPath,l,!M.$e))?!1:(n.push(i.resource.fsPath),!0)).concat(s)}}function f(A,s){if(typeof s=="number")switch(A.type){case F.FileChangeType.ADDED:return(s&F.FileChangeFilter.ADDED)===0;case F.FileChangeType.DELETED:return(s&F.FileChangeFilter.DELETED)===0;case F.FileChangeType.UPDATED:return(s&F.FileChangeFilter.UPDATED)===0}return!1}function y(A){if(typeof A=="number"){const s=[];return A&F.FileChangeFilter.ADDED&&s.push("Added"),A&F.FileChangeFilter.DELETED&&s.push("Deleted"),A&F.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(_e[34],Ee([0,1,17,4,19,6,18,5,8]),function(ae,e,g,t,q,M,Y,F,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class P extends t.$Xc{constructor(){super(),this.a=this.B(new M.$ne),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$ne),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$ne),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new t.$7c),this.m=new Set,this.n=this.B(new U.$Eh(this.y())),this.r=5007,this.s=new U.$4h,this.R=!1,this.B(this.f(_=>this.t(_)))}t(_){this.u(_)&&this.z(_)}u(_){return(0,q.$3q)(_)}async watch(_){this.s.isSettled||this.s.complete(),this.s=new U.$4h;try{this.h.clear(),this.g.clear();for(const v of _)this.u(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.w(!1)}finally{this.s.complete()}}w(_){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(v=>!this.j.has(v.correlationId))]),_?this.y():0)}y(){return 800}isSuspended(_){return typeof _.correlationId!="number"?!1:this.m.has(_.correlationId)?"polling":this.j.has(_.correlationId)}async z(_){if(this.j.has(_.correlationId))return;const v=new t.$Wc;this.j.set(_.correlationId,v),await this.s.p,!v.isDisposed&&(this.D(_,v),this.w(!0))}C(_){this.j.deleteAndDispose(_.correlationId),this.m.delete(_.correlationId),this.w(!1)}D(_,v){this.F(_,v)?(this.P(`reusing an existing recursive watcher to monitor ${_.path}`),this.m.delete(_.correlationId)):(this.G(_,v),this.m.add(_.correlationId))}F(_,v){const k=this.O?.subscribe(_.path,(o,r)=>{v.isDisposed||(o?this.D(_,v):r?.type===Y.FileChangeType.ADDED&&this.H(_))});return k?(v.add(k),!0):!1}G(_,v){let k=!1;const o=(r,d)=>{if(v.isDisposed)return;const b=this.I(r),f=this.I(d),y=k;k=b,!b&&(f||y)&&this.H(_)};this.P(`starting fs.watchFile() on ${_.path} (correlationId: ${_.correlationId})`);try{(0,g.watchFile)(_.path,{persistent:!1,interval:this.r},o)}catch(r){this.Q(`fs.watchFile() failed with error ${r} on path ${_.path} (correlationId: ${_.correlationId})`)}v.add((0,t.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${_.path} (correlationId: ${_.correlationId})`);try{(0,g.unwatchFile)(_.path,o)}catch(r){this.Q(`fs.unwatchFile() failed with error ${r} on path ${_.path} (correlationId: ${_.correlationId})`)}}))}H(_){this.P(`detected ${_.path} exists again, resuming watcher (correlationId: ${_.correlationId})`);const v={resource:F.URI.file(_.path),type:Y.FileChangeType.ADDED,cId:_.correlationId};this.a.fire([v]),this.J(v,_),this.C(_)}I(_){return _.ctimeMs===0&&_.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(_,v){if(this.R){const k=` >> normalized ${_.type===Y.FileChangeType.ADDED?"[ADDED]":_.type===Y.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${_.resource.fsPath}`;this.L(k,v)}}L(_,v){this.R&&this.P(`${_}${typeof v.correlationId=="number"?` <${v.correlationId}> `:""}`)}M(_){return`${_.path} (excludes: ${_.excludes.length>0?_.excludes:"<none>"}, includes: ${_.includes&&_.includes.length>0?JSON.stringify(_.includes):"<all>"}, filter: ${(0,q.$ar)(_.filter)}, correlationId: ${typeof _.correlationId=="number"?_.correlationId:"<none>"})`}async setVerboseLogging(_){this.R=_}}e.$jr=P}),define(_e[35],Ee([0,1,17,8,13,14,4,21,3,2,22,5,32,24,18,19]),function(ae,e,g,t,q,M,Y,F,U,P,N,_,v,k,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0,e.$pr=b;class d extends Y.$Xc{get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(y,A,s,n,i,l){super(),this.s=y,this.t=A,this.u=s,this.w=n,this.y=i,this.z=l,this.c=this.B(new t.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.u(c))),this.f=this.B(new t.$Uh(c=>this.M(c),d.b)),this.g=(0,r.$$q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,r.$$q)(this.s.path,this.s.includes):void 0,this.j=(0,r.$3q)(this.s)?this.s.filter:void 0,this.m=new q.$ye,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const y=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const A=await k.Promises.stat(y);if(this.m.token.isCancellationRequested)return;this.B(await this.G(y,A.isDirectory()))}catch(y){y.code!=="ENOENT"?this.O(y):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${y})`),this.D()}}D(){this.r=!0,this.w?.()}async F(y){let A=y.path;try{A=await k.Promises.realpath(y.path),y.path===A&&(A=await(0,v.$lr)(y.path,this.m.token)??y.path),y.path!==A&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${A})`)}catch{}return A}async G(y,A){const s=new Y.$Wc;return this.H(y,A,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(y,A,s)),s}H(y,A,s){if(A)return!1;const n=_.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(l,c)=>{if(!s.isDisposed)if(l){const T=await this.G(y,A);s.isDisposed?T.dispose():s.add(T)}else c&&(typeof c.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:n,type:c.type,cId:this.s.correlationId},!0)});return i?(s.add(i),!0):!1}async I(y,A,s){if(P.$d&&(0,M.$Fg)(y,"/Volumes/",!0)){this.O(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new q.$ye(this.m.token);s.add((0,Y.$Vc)(()=>n.dispose(!0)));const i=new Y.$Wc;s.add(i);try{const l=_.URI.file(this.s.path),c=(0,U.$qc)(y),T=(0,g.watch)(y);i.add((0,Y.$Vc)(()=>{T.removeAllListeners(),T.close()})),this.Q(`Started watching: '${y}'`);const h=new Set;if(A)try{for(const u of await k.Promises.readdir(y))h.add(u)}catch(u){this.O(u)}if(n.token.isCancellationRequested)return;const w=new Map;i.add((0,Y.$Vc)(()=>{for(const[,u]of w)u.dispose();w.clear()})),T.on("error",(u,R)=>{n.token.isCancellationRequested||(this.O(`Failed to watch ${y} for changes using fs.watch() (${u}, ${R})`),this.D())}),T.on("change",(u,R)=>{if(n.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${u}"] ${R}`);let S="";if(R&&(S=R.toString(),P.$d&&(S=(0,F.$nm)(S))),!(!S||u!=="change"&&u!=="rename"))if(A)if(u==="rename"){w.get(S)?.dispose();const m=setTimeout(async()=>{if(w.delete(S),S===c&&!await k.Promises.exists(y)){this.J(l);return}if(n.token.isCancellationRequested)return;const $=await this.N((0,U.$mc)(y,S));if(n.token.isCancellationRequested)return;let V;$?h.has(S)?V=o.FileChangeType.UPDATED:(V=o.FileChangeType.ADDED,h.add(S)):(h.delete(S),V=o.FileChangeType.DELETED),this.L({resource:(0,N.$hh)(l,S),type:V,cId:this.s.correlationId})},d.a);w.set(S,(0,Y.$Vc)(()=>clearTimeout(m)))}else{let m;h.has(S)?m=o.FileChangeType.UPDATED:(m=o.FileChangeType.ADDED,h.add(S)),this.L({resource:(0,N.$hh)(l,S),type:m,cId:this.s.correlationId})}else if(u==="rename"||S!==c){const m=setTimeout(async()=>{const $=await k.Promises.exists(y);n.token.isCancellationRequested||($?(this.L({resource:l,type:o.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(y,!1))):this.J(l))},d.a);i.clear(),i.add((0,Y.$Vc)(()=>clearTimeout(m)))}else this.L({resource:l,type:o.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(l){n.token.isCancellationRequested||this.O(`Failed to watch ${y} for changes using fs.watch() (${l.toString()})`),this.D()}}J(y){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:y,type:o.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(y,A=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${y.type===o.FileChangeType.ADDED?"[ADDED]":y.type===o.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`),!A&&this.g.some(s=>s(y.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${y.resource.fsPath}`):!A&&this.h&&this.h.length>0&&!this.h.some(s=>s(y.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${y.resource.fsPath}`):this.f.work(y))}M(y){const A=(0,r.$9q)(y),s=[];for(const i of A){if((0,r.$_q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}s.push(i)}if(s.length===0)return;if(this.z)for(const i of s)this.R(` >> normalized ${i.type===o.FileChangeType.ADDED?"[ADDED]":i.type===o.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(y){if(P.$e)return k.Promises.exists(y);try{const A=(0,U.$qc)(y);return(await k.Promises.readdir((0,U.$pc)(y))).some(n=>n===A)}catch(A){return this.Q(A),!1}}setVerboseLogging(y){this.z=y}O(y){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}P(y){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}Q(y){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}R(y){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${y}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$or=d,d.a=100,d.b=75;async function b(f,y,A,s,n=512){const i=await k.Promises.open(f,"r"),l=Buffer.allocUnsafe(n),c=new q.$ye(s);let T,h=!1;const w={path:f,excludes:[],recursive:!1},u=new d(w,void 0,R=>{(async()=>{for(const{type:S}of R)if(S===o.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:m}=await k.Promises.read(i,l,0,n,null);if(!m||c.token.isCancellationRequested)break;y(l.slice(0,m))}}catch(m){T=new Error(m),c.dispose(!0)}finally{h=!1}}})()});return await u.ready,A(),new Promise((R,S)=>{c.token.onCancellationRequested(async()=>{u.dispose();try{await k.Promises.close(i)}catch(m){T=new Error(m)}T?S(T):R()})})}}),define(_e[59],Ee([0,1,6,23,34,2,35,14]),function(ae,e,g,t,q,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class U extends q.$jr{constructor(N){super(),this.O=N,this.onDidError=g.Event.None,this.watchers=new Set}async N(N){N=this.Z(N);const _=[],v=new Set(Array.from(this.watchers));for(const k of N){const o=this.W(k);o&&(0,t.$Ek)(o.request.excludes,k.excludes)&&(0,t.$Ek)(o.request.includes,k.includes)?v.delete(o):_.push(k)}_.length&&this.P(`Request to start watching: ${_.map(k=>this.M(k)).join(",")}`),v.size&&this.P(`Request to stop watching: ${Array.from(v).map(k=>this.M(k.request)).join(",")}`);for(const k of v)this.Y(k);for(const k of _)this.X(k)}W(N){for(const _ of this.watchers)if(typeof N.correlationId=="number"||typeof _.request.correlationId=="number"){if(_.request.correlationId===N.correlationId)return _}else if((0,F.$Eg)(_.request.path,N.path,!M.$e))return _}X(N){const _=new Y.$or(N,this.O,k=>this.a.fire(k),()=>this.c.fire(N),k=>this.b.fire(k),this.R),v={request:N,instance:_};this.watchers.add(v)}async stop(){await super.stop();for(const N of this.watchers)this.Y(N)}Y(N){this.P("stopping file watcher",N),this.watchers.delete(N),N.instance.dispose()}Z(N){const _=new Map;for(const v of N){const k=M.$e?v.path:v.path.toLowerCase();let o=_.get(v.correlationId);o||(o=new Map,_.set(v.correlationId,o)),o.has(k)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(v)}`),o.set(k,v)}return Array.from(_.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(N){super.setVerboseLogging(N);for(const _ of this.watchers)_.instance.setVerboseLogging(N)}P(N,_){this.R&&this.b.fire({type:"trace",message:this.bb(N,_)})}Q(N){this.b.fire({type:"warn",message:this.bb(N)})}bb(N,_){return _?`[File Watcher (node.js)] ${N} (${this.M(_.request)})`:`[File Watcher (node.js)] ${N}`}}e.$qr=U}),define(_e[60],Ee([0,1,65,17,49,5,8,13,56,6,14,23,34,30,21,3,2,32,35,18,19,4]),function(ae,e,g,t,q,M,Y,F,U,P,N,_,v,k,o,r,d,b,f,y,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0,g=Ie(g);class n extends s.$Xc{get failed(){return this.c}get stopped(){return this.f}constructor(c,T,h,w,u,R){super(),this.ready=c,this.request=T,this.restarts=h,this.token=w,this.worker=u,this.m=R,this.a=this.B(new P.$ne),this.onDidStop=this.a.event,this.b=this.B(new P.$ne),this.onDidFail=this.b.event,this.c=!1,this.f=!1,this.g=this.request.includes?(0,A.$$q)(this.request.path,this.request.includes):void 0,this.h=this.request.excludes?(0,A.$$q)(this.request.path,this.request.excludes):void 0,this.j=new Map,this.B((0,s.$Vc)(()=>this.j.clear()))}subscribe(c,T){c=M.URI.file(c).fsPath;let h=this.j.get(c);return h||(h=new Set,this.j.set(c,h)),h.add(T),(0,s.$Vc)(()=>{const w=this.j.get(c);w&&(w.delete(T),w.size===0&&this.j.delete(c))})}get subscriptionsCount(){return this.j.size}notifyFileChange(c,T){const h=this.j.get(c);if(h)for(const w of h)w(T)}notifyWatchFailed(){this.c=!0,this.b.fire()}include(c){return!this.g||this.g.length===0?!0:this.g.some(T=>T(c))}exclude(c){return!!this.h?.some(T=>T(c))}async stop(c){this.f=!0;try{await this.m()}finally{this.a.fire({joinRestart:c}),this.dispose()}}}e.$Clc=n;class i extends v.$jr{constructor(){super(),this.W=this.B(new P.$ne),this.onDidError=this.W.event,this.watchers=new Set,this.Y=this.B(new Y.$Vh({maxWorkChunkSize:500,throttleDelay:200,maxBufferedWork:3e4},c=>this.a.fire(c))),this.Z=!1,this.$()}$(){process.on("uncaughtException",c=>this.nb(c)),process.on("unhandledRejection",c=>this.nb(c))}async N(c){c=this.qb(c);const T=[],h=new Set(Array.from(this.watchers));for(const w of c){const u=this.bb(w);u&&(0,_.$Ek)(u.request.excludes,w.excludes)&&(0,_.$Ek)(u.request.includes,w.includes)&&u.request.pollingInterval===w.pollingInterval?h.delete(u):T.push(w)}T.length&&this.P(`Request to start watching: ${T.map(w=>this.M(w)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map(w=>this.M(w.request)).join(",")}`);for(const w of h)await this.pb(w);for(const w of T)w.pollingInterval?this.cb(w,w.pollingInterval):await this.db(w)}bb(c){for(const T of this.watchers)if(this.u(c)||this.u(T.request)){if(T.request.correlationId===c.correlationId)return T}else if((0,N.$Eg)(T.request.path,c.path,!d.$e))return T}cb(c,T,h=0){const w=new F.$ye,u=new Y.$4h,R=(0,N.$Og)((0,q.tmpdir)(),"vscode-watcher-snapshot"),S=new n(u.p,c,h,w.token,new Y.$Uh(K=>this.gb(K,S),i.X),async()=>{w.dispose(!0),S.worker.flush(),S.worker.dispose(),ee.dispose(),(0,t.unlinkSync)(R)});this.watchers.add(S);const{realPath:m,realPathDiffers:$,realPathLength:V}=this.ib(c);this.P(`Started watching: '${m}' with polling interval '${T}'`);let se=0;const ee=new Y.$Sh(async()=>{if(se++,!w.token.isCancellationRequested){if(se>1){const K=await g.getEventsSince(m,R,{ignore:c.excludes,backend:i.U});if(w.token.isCancellationRequested)return;this.eb(K,S,$,V)}await g.writeSnapshot(m,R,{ignore:c.excludes,backend:i.U}),se===1&&u.complete(),!w.token.isCancellationRequested&&ee.schedule()}},T);ee.schedule(0)}async db(c,T=0){const h=new F.$ye,w=new Y.$4h,u=new n(w.p,c,T,h.token,new Y.$Uh($=>this.gb($,u),i.X),async()=>{h.dispose(!0),u.worker.flush(),u.worker.dispose(),await(await w.p)?.unsubscribe()});this.watchers.add(u);const{realPath:R,realPathDiffers:S,realPathLength:m}=this.ib(c);try{const $=await g.subscribe(R,(V,se)=>{u.token.isCancellationRequested||(V&&this.nb(V,c),this.eb(se,u,S,m))},{backend:i.U,ignore:u.request.excludes});this.P(`Started watching: '${R}' with backend '${i.U}'`),w.complete($)}catch($){this.nb($,c),w.complete(void 0),u.notifyWatchFailed(),this.c.fire(c)}}eb(c,T,h,w){if(c.length===0)return;this.jb(c,T.request,h,w);const u=this.fb(T,c);for(const R of u)T.worker.work(R)}fb(c,T){const h=[];for(const{path:w,type:u}of T){const R=i.S.get(u);this.R&&this.L(`${R===y.FileChangeType.ADDED?"[ADDED]":R===y.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${w}`,c.request),c.include(w)?h.push({type:R,resource:M.URI.file(w),cId:c.request.correlationId}):this.R&&this.L(` >> ignored (not included) ${w}`,c.request)}return h}gb(c,T){const h=(0,A.$9q)(c),{events:w,rootDeleted:u}=this.kb(h,T);this.hb(w,T),u&&this.lb(T)}hb(c,T){if(c.length===0)return;this.Y.work(c)?this.Y.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.Y.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`,T):this.Q(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}ib(c){let T=c.path,h=!1,w=c.path.length;try{T=(0,b.$nr)(c.path),c.path===T&&(T=(0,b.$kr)(c.path)??c.path),c.path!==T&&(w=T.length,h=!0,this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${T})`))}catch{}return{realPath:T,realPathDiffers:h,realPathLength:w}}jb(c,T,h,w){for(const u of c)d.$d&&(u.path=(0,o.$nm)(u.path)),d.$c&&T.path.length<=3&&(u.path=(0,r.$kc)(u.path)),h&&(u.path=T.path+u.path.substr(w))}kb(c,T){const h=[];let w=!1;const u=this.u(T.request)?T.request.filter:void 0;for(const R of c){if(T.subscriptionsCount>0&&T.notifyFileChange(R.resource.fsPath,R),w=R.type===y.FileChangeType.DELETED&&(0,N.$Eg)(R.resource.fsPath,T.request.path,!d.$e),(0,A.$_q)(R,u)||w&&!this.u(T.request)){this.R&&this.L(` >> ignored (filtered) ${R.resource.fsPath}`,T.request);continue}this.J(R,T.request),h.push(R)}return{events:h,rootDeleted:w}}lb(c){this.Q("Watcher shutdown because watched path got deleted",c);let T=!1;this.u(c.request)||(T=this.mb(c)),T||(c.notifyWatchFailed(),this.c.fire(c.request))}mb(c){const T=(0,r.$pc)(c.request.path);if((0,t.existsSync)(T)){this.P("Trying to watch on the parent path to restart the watcher...",c);const h=new f.$or({path:T,excludes:[],recursive:!1,correlationId:c.request.correlationId},void 0,w=>{if(!c.token.isCancellationRequested){for(const{resource:u,type:R}of w)if((0,N.$Eg)(u.fsPath,c.request.path,!d.$e)&&(R===y.FileChangeType.ADDED||R===y.FileChangeType.UPDATED)&&this.rb(c.request.path)){this.Q("Watcher restarts because watched path got created again",c),h.dispose(),this.ob(c);break}}},void 0,w=>this.b.fire(w),this.R);return c.token.onCancellationRequested(()=>h.dispose()),!0}return!1}nb(c,T){const h=(0,U.$rj)(c);h.indexOf("No space left on device")!==-1?this.Z||(this.ub("Inotify limit reached (ENOSPC)",T),this.Z=!0):(this.ub(`Unexpected error: ${h} (EUNKNOWN)`,T),this.W.fire({request:T,error:h}))}async stop(){await super.stop();for(const c of this.watchers)await this.pb(c)}ob(c,T=800){const h=new Y.$Sh(async()=>{if(c.token.isCancellationRequested)return;const w=new Y.$4h;try{await this.pb(c,w.p),c.request.pollingInterval?this.cb(c.request,c.request.pollingInterval,c.restarts+1):await this.db(c.request,c.restarts+1)}finally{w.complete()}},T);h.schedule(),c.token.onCancellationRequested(()=>h.dispose())}async pb(c,T){this.P("stopping file watcher",c),this.watchers.delete(c);try{await c.stop(T)}catch(h){this.ub(`Unexpected error stopping watcher: ${(0,U.$rj)(h)}`,c.request)}}qb(c,T=!0){c.sort((u,R)=>u.path.length-R.path.length);const h=new Map;for(const u of c){if(u.excludes.includes(_.$wk))continue;const R=d.$e?u.path:u.path.toLowerCase();let S=h.get(u.correlationId);S||(S=new Map,h.set(u.correlationId,S)),S.has(R)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),S.set(R,u)}const w=[];for(const u of h.values()){const R=k.$Mi.forPaths(!d.$e);for(const S of u.values()){if(R.findSubstr(S.path))try{if((0,b.$nr)(S.path)===S.path){this.P(`ignoring a request for watching who's parent is already watched: ${this.M(S)}`);continue}}catch(m){this.P(`ignoring a request for watching who's realpath failed to resolve: ${this.M(S)} (error: ${m})`),this.c.fire(S);continue}if(T&&!this.rb(S.path)){this.c.fire(S);continue}R.set(S.path,S)}w.push(...Array.from(R).map(([,S])=>S))}return w}rb(c){try{if(!(0,t.statSync)(c).isDirectory())return this.P(`ignoring a path for watching that is a file and not a folder: ${c}`),!1}catch(T){return this.P(`ignoring a path for watching who's stat info failed to resolve: ${c} (error: ${T})`),!1}return!0}subscribe(c,T){for(const h of this.watchers){if(h.failed||!(0,N.$Fg)(c,h.request.path,!d.$e)||h.exclude(c)||!h.include(c))continue;const w=new s.$Wc;return w.add(P.Event.once(h.onDidStop)(async u=>{await u.joinRestart,!w.isDisposed&&T(!0)})),w.add(P.Event.once(h.onDidFail)(()=>T(!0))),w.add(h.subscribe(c,u=>T(null,u))),w}}P(c,T){this.R&&this.b.fire({type:"trace",message:this.vb(c,T?.request)})}Q(c,T){this.b.fire({type:"warn",message:this.vb(c,T?.request)})}ub(c,T){this.b.fire({type:"error",message:this.vb(c,T)})}vb(c,T){return T?`[File Watcher (parcel)] ${c} (path: ${T.path})`:`[File Watcher (parcel)] ${c}`}get O(){return this}}e.$Dlc=i,i.S=new Map([["create",y.FileChangeType.ADDED],["update",y.FileChangeType.UPDATED],["delete",y.FileChangeType.DELETED]]),i.U=d.$c?"windows":d.$e?"inotify":"fs-events",i.X=75}),define(_e[61],Ee([0,1,19]),function(ae,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=t;function t(o,r,d){const b=[],f=U(o.filter(V=>V.recursive)),y=f.filter(V=>r.isSuspended(V)===!1),A=f.filter(V=>r.isSuspended(V)==="polling"),s=f.filter(V=>r.isSuspended(V)===!0),n=M(f,r),i=Y(r),l=U(o.filter(V=>!V.recursive)),c=l.filter(V=>d.isSuspended(V)===!1),T=l.filter(V=>d.isSuspended(V)==="polling"),h=l.filter(V=>d.isSuspended(V)===!0),w=M(l,d),u=F(d);b.push("[Summary]"),b.push(`- Recursive Requests:     total: ${f.length}, suspended: ${n.suspended}, polling: ${n.polling}`),b.push(`- Non-Recursive Requests: total: ${l.length}, suspended: ${w.suspended}, polling: ${w.polling}`),b.push(`- Recursive Watchers:     total: ${r.watchers.size}, active: ${i.active}, failed: ${i.failed}, stopped: ${i.stopped}`),b.push(`- Non-Recursive Watchers: total: ${d.watchers.size}, active: ${u.active}, failed: ${u.failed}, reusing: ${u.reusing}`),b.push(`- I/O Handles Impact:     total: ${n.polling+w.polling+i.active+u.active}`),b.push(`
[Recursive Requests (${f.length}, suspended: ${n.suspended}, polling: ${n.polling})]:`);const R=[];for(const V of[y,A,s].flat())N(R,V,r);b.push(...q(R));const S=[];v(S,r),b.push(...q(S)),b.push(`
[Non-Recursive Requests (${l.length}, suspended: ${w.suspended}, polling: ${w.polling})]:`);const m=[];for(const V of[c,T,h].flat())N(m,V,d);b.push(...q(m));const $=[];return k($,d),b.push(...q($)),`

[File Watcher] request stats:

${b.join(`
`)}

`}function q(o){let r=0;for(const d of o)r=Math.max(r,d.split("	")[0].length);for(let d=0;d<o.length;d++){const f=o[d].split("	");if(f.length===2){const y=" ".repeat(r-f[0].length);o[d]=`${f[0]}${y}	${f[1]}`}}return o}function M(o,r){let d=0,b=0;for(const f of o){const y=r.isSuspended(f);y!==!1&&(b++,y==="polling"&&d++)}return{suspended:b,polling:d}}function Y(o){let r=0,d=0,b=0;for(const f of o.watchers.values())!f.failed&&!f.stopped&&r++,f.failed&&d++,f.stopped&&b++;return{active:r,failed:d,stopped:b}}function F(o){let r=0,d=0,b=0;for(const f of o.watchers)!f.instance.failed&&!f.instance.isReusingRecursiveWatcher&&r++,f.instance.failed&&d++,f.instance.isReusingRecursiveWatcher&&b++;return{active:r,failed:d,reusing:b}}function U(o){return o.sort((r,d)=>{const b=P(r)?r.path:r.request.path,f=P(d)?d.path:d.request.path,y=Math.min(b.length,f.length);for(let A=0;A<y;A++)if(b[A]!==f[A])return b[A]<f[A]?-1:1;return b.length-f.length}),o}function P(o){return typeof o?.path=="string"}function N(o,r,d){const b=[],f=d.isSuspended(r);f!==!1&&(f==="polling"?b.push("[SUSPENDED <polling>]"):b.push("[SUSPENDED <non-polling>]")),o.push(` ${r.path}	${b.length>0?b.join(" ")+" ":""}(${_(r)})`)}function _(o){return`excludes: ${o.excludes.length>0?o.excludes:"<none>"}, includes: ${o.includes&&o.includes.length>0?JSON.stringify(o.includes):"<all>"}, filter: ${(0,g.$ar)(o.filter)}, correlationId: ${typeof o.correlationId=="number"?o.correlationId:"<none>"}`}function v(o,r){const d=U(Array.from(r.watchers.values())),{active:b,failed:f,stopped:y}=Y(r);o.push(`
[Recursive Watchers (${d.length}, active: ${b}, failed: ${f}, stopped: ${y})]:`);for(const A of d){const s=[];A.failed&&s.push("[FAILED]"),A.stopped&&s.push("[STOPPED]"),A.subscriptionsCount>0&&s.push(`[SUBSCRIBED:${A.subscriptionsCount}]`),A.restarts>0&&s.push(`[RESTARTED:${A.restarts}]`),o.push(` ${A.request.path}	${s.length>0?s.join(" ")+" ":""}(${_(A.request)})`)}}function k(o,r){const d=U(Array.from(r.watchers.values())),b=d.filter(i=>!i.instance.failed&&!i.instance.isReusingRecursiveWatcher),f=d.filter(i=>i.instance.failed),y=d.filter(i=>i.instance.isReusingRecursiveWatcher),{active:A,failed:s,reusing:n}=F(r);o.push(`
[Non-Recursive Watchers (${d.length}, active: ${A}, failed: ${s}, reusing: ${n})]:`);for(const i of[b,f,y].flat()){const l=[];i.instance.failed&&l.push("[FAILED]"),i.instance.isReusingRecursiveWatcher&&l.push("[REUSING]"),o.push(` ${i.request.path}	${l.length>0?l.join(" ")+" ":""}(${_(i.request)})`)}}}),define(_e[62],Ee([0,1,4,6,60,59,8,61]),function(ae,e,g,t,q,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class U extends g.$Xc{constructor(){super(...arguments),this.a=this.B(new q.$Dlc),this.b=this.B(new M.$qr(this.a)),this.onDidChangeFile=t.Event.any(this.a.onDidChangeFile,this.b.onDidChangeFile),this.onDidError=t.Event.any(this.a.onDidError,this.b.onDidError),this.c=this.B(new t.$ne),this.onDidLogMessage=t.Event.any(this.c.event,this.a.onDidLogMessage,this.b.onDidLogMessage),this.f=[]}async watch(N){this.f=N;let _;try{await this.a.watch(N.filter(v=>v.recursive))}catch(v){_=v}try{await this.b.watch(N.filter(v=>!v.recursive))}catch(v){_||(_=v)}if(_)throw _}async setVerboseLogging(N){N&&this.f.length>0&&this.c.fire({type:"trace",message:(0,F.$Elc)(this.f,this.a,this.b)}),await Y.Promises.settled([this.a.setVerboseLogging(N),this.b.setVerboseLogging(N)])}async stop(){await Y.Promises.settled([this.a.stop(),this.b.stop()])}}e.$Flc=U}),define(_e[66],Ee([0,1,4,25,51,52,33,62]),function(ae,e,g,t,q,M,Y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;(0,Y.$XX)(process)?U=new M.$YX:U=new q.$gr("watcher");const P=new F.$Flc;U.registerChannel("watcher",t.ProxyChannel.fromService(P,new g.$Wc))})}).call(this);

//# sourceMappingURL=watcherMain.js.map
