"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/charCode","vs/base/common/errors","vs/base/common/extpath","vs/base/common/strings","vs/base/common/uri","vs/base/common/async","vs/base/common/functional","vs/base/common/lazy","vs/base/common/map","vs/base/common/lifecycle","vs/base/common/process","vs/base/common/event","vs/base/common/cancellation","vs/base/common/resources","fs","os","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/symbols","vs/base/common/types","vs/base/common/uint","vs/base/common/network","vs/base/node/pfs","vs/base/node/terminalEncoding","child_process","vs/nls!vs/platform/environment/node/argv","vs/platform/environment/node/argv","vs/platform/environment/node/stdin","vs/platform/environment/node/wait","util","vs/nls","vs/nls!vs/server/node/server.cli","minimist","vs/server/node/server.cli","url","http"],Ee=function(le){for(var e=[],a=0,t=le.length;a<t;a++)e[a]=$e[le[a]];return e};define($e[20],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=a,e.$jb=t,e.$kb=A,e.$lb=O,e.$mb=ie,e.$nb=X,e.$ob=F,e.$qb=q,e.$rb=x,e.$sb=j,e.$tb=te,e.$ub=D;function a(c,g){const w=t(c,g);if(w!==-1)return c[w]}function t(c,g,w=c.length-1){for(let M=w;M>=0;M--){const K=c[M];if(g(K))return M}return-1}function A(c,g){const w=O(c,g);return w===-1?void 0:c[w]}function O(c,g,w=0,M=c.length){let K=w,ne=M;for(;K<ne;){const L=Math.floor((K+ne)/2);g(c[L])?K=L+1:ne=L}return K-1}function ie(c,g){const w=X(c,g);return w===c.length?void 0:c[w]}function X(c,g,w=0,M=c.length){let K=w,ne=M;for(;K<ne;){const L=Math.floor((K+ne)/2);g(c[L])?ne=L:K=L+1}return K}function F(c,g,w=0,M=c.length){const K=X(c,g,w,M);return K===c.length?-1:K}class p{constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(p.assertInvariants){if(this.d){for(const M of this.e)if(this.d(M)&&!g(M))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const w=O(this.e,g,this.c);return this.c=w+1,w===-1?void 0:this.e[w]}}e.$pb=p,p.assertInvariants=!1;function q(c,g){if(c.length===0)return;let w=c[0];for(let M=1;M<c.length;M++){const K=c[M];g(K,w)>0&&(w=K)}return w}function x(c,g){if(c.length===0)return;let w=c[0];for(let M=1;M<c.length;M++){const K=c[M];g(K,w)>=0&&(w=K)}return w}function j(c,g){return q(c,(w,M)=>-g(w,M))}function te(c,g){if(c.length===0)return-1;let w=0;for(let M=1;M<c.length;M++){const K=c[M];g(K,c[w])>0&&(w=M)}return w}function D(c,g){for(const w of c){const M=g(w);if(M!==void 0)return M}}}),define($e[4],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var a;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(a||(e.CharCode=a={}))}),define($e[21],Ee([0,1]),function(le,e){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$I=void 0,e.$E=t,e.$F=A,e.$G=O,e.$H=ie;function t(F,p){const q=Object.create(null);for(const x of F){const j=p(x);let te=q[j];te||(te=q[j]=[]),te.push(x)}return q}function A(F,p){const q=[],x=[];for(const j of F)p.has(j)||q.push(j);for(const j of p)F.has(j)||x.push(j);return{removed:q,added:x}}function O(F,p){const q=[],x=[];for(const[j,te]of F)p.has(j)||q.push(te);for(const[j,te]of p)F.has(j)||x.push(te);return{removed:q,added:x}}function ie(F,p){const q=new Set;for(const x of p)F.has(x)&&q.add(x);return q}class X{constructor(p,q){this.b=q,this.a=new Map,this[a]="SetWithKey";for(const x of p)this.add(x)}get size(){return this.a.size}add(p){const q=this.b(p);return this.a.set(q,p),this}delete(p){return this.a.delete(this.b(p))}has(p){return this.a.has(this.b(p))}*entries(){for(const p of this.a.values())yield[p,p]}keys(){return this.values()}*values(){for(const p of this.a.values())yield p}clear(){this.a.clear()}forEach(p,q){this.a.forEach(x=>p.call(q,x,x,this))}[Symbol.iterator](){return this.values()}}e.$I=X,a=Symbol.toStringTag}),define($e[5],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=t,e.$2=A,e.$3=O,e.$4=ie,e.$5=X,e.$6=F,e.$7=q,e.$9=j,e.$0=te,e.$$=D,e.$ab=g;class a{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?ne.isErrorNoTelemetry(i)?new ne(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Y=a,e.$Z=new a;function t(n){e.$Z.setUnexpectedErrorHandler(n)}function A(n){if(!n||typeof n!="object")return!1;const i=n;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function O(n){q(n)||e.$Z.onUnexpectedError(n)}function ie(n){q(n)||e.$Z.onUnexpectedExternalError(n)}function X(n){if(n instanceof Error){const{name:i,message:l}=n,_=n.stacktrace||n.stack;return{$isError:!0,name:i,message:l,stack:_,noTelemetry:ne.isErrorNoTelemetry(n)}}return n}function F(n){let i;return n.noTelemetry?i=new ne:(i=new Error,i.name=n.name),i.message=n.message,i.stack=n.stack,i}const p="Canceled";function q(n){return n instanceof x?!0:n instanceof Error&&n.name===p&&n.message===p}class x extends Error{constructor(){super(p),this.name=this.message}}e.$8=x;function j(){const n=new Error(p);return n.name=n.message,n}function te(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function D(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class c extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=c;function g(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$bb=w;class M extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$cb=M;class K extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=K;class ne extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof ne)return i;const l=new ne;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$eb=ne;class L extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype)}}e.$fb=L}),define($e[22],Ee([0,1,5,20]),function(le,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=A,e.$wb=O,e.$xb=ie,e.$yb=X,e.$zb=F,e.$Ab=p,e.$Bb=q,e.$Cb=x,e.$Db=j,e.$Eb=te,e.$Fb=D,e.$Gb=c,e.$Hb=g,e.top=w,e.$Jb=M,e.$Kb=ne,e.$Lb=L,e.$Mb=n,e.$Nb=i,e.$Ob=l,e.$Pb=_,e.$Qb=y,e.$Rb=f,e.$Sb=d,e.$Tb=s,e.$Ub=h,e.$Vb=P,e.$Wb=I,e.$Xb=u,e.$Yb=B,e.$Zb=W,e.$1b=G,e.$2b=T,e.$3b=Q,e.$4b=S,e.$5b=v,e.$6b=H,e.$7b=V,e.$8b=J,e.$9b=be,e.$0b=ye,e.$ac=fe;function A(m,R=0){return m[m.length-(1+R)]}function O(m){if(m.length===0)throw new Error("Invalid tail call");return[m.slice(0,m.length-1),m[m.length-1]]}function ie(m,R,U=($,r)=>$===r){if(m===R)return!0;if(!m||!R||m.length!==R.length)return!1;for(let $=0,r=m.length;$<r;$++)if(!U(m[$],R[$]))return!1;return!0}function X(m,R){const U=m.length-1;R<U&&(m[R]=m[U]),m.pop()}function F(m,R,U){return p(m.length,$=>U(m[$],R))}function p(m,R){let U=0,$=m-1;for(;U<=$;){const r=(U+$)/2|0,E=R(r);if(E<0)U=r+1;else if(E>0)$=r-1;else return r}return-(U+1)}function q(m,R,U){if(m=m|0,m>=R.length)throw new TypeError("invalid index");const $=R[Math.floor(R.length*Math.random())],r=[],E=[],N=[];for(const z of R){const oe=U(z,$);oe<0?r.push(z):oe>0?E.push(z):N.push(z)}return m<r.length?q(m,r,U):m<r.length+N.length?N[0]:q(m-(r.length+N.length),E,U)}function x(m,R){const U=[];let $;for(const r of m.slice(0).sort(R))!$||R($[0],r)!==0?($=[r],U.push($)):$.push(r);return U}function*j(m,R){let U,$;for(const r of m)$!==void 0&&R($,r)?U.push(r):(U&&(yield U),U=[r]),$=r;U&&(yield U)}function te(m,R){for(let U=0;U<=m.length;U++)R(U===0?void 0:m[U-1],U===m.length?void 0:m[U])}function D(m,R){for(let U=0;U<m.length;U++)R(U===0?void 0:m[U-1],m[U],U+1===m.length?void 0:m[U+1])}function c(m,R,U){const $=[];function r(z,oe,we){if(oe===0&&we.length===0)return;const ee=$[$.length-1];ee&&ee.start+ee.deleteCount===z?(ee.deleteCount+=oe,ee.toInsert.push(...we)):$.push({start:z,deleteCount:oe,toInsert:we})}let E=0,N=0;for(;;){if(E===m.length){r(E,0,R.slice(N));break}if(N===R.length){r(E,m.length-E,[]);break}const z=m[E],oe=R[N],we=U(z,oe);we===0?(E+=1,N+=1):we<0?(r(E,1,[]),E+=1):we>0&&(r(E,0,[oe]),N+=1)}return $}function g(m,R,U){const $=c(m,R,U),r=[],E=[];for(const N of $)r.push(...m.slice(N.start,N.start+N.deleteCount)),E.push(...N.toInsert);return{removed:r,added:E}}function w(m,R,U){if(U===0)return[];const $=m.slice(0,U).sort(R);return K(m,R,$,U,m.length),$}function M(m,R,U,$,r){return U===0?Promise.resolve([]):new Promise((E,N)=>{(async()=>{const z=m.length,oe=m.slice(0,U).sort(R);for(let we=U,ee=Math.min(U+$,z);we<z;we=ee,ee=Math.min(ee+$,z)){if(we>U&&await new Promise(C=>setTimeout(C)),r&&r.isCancellationRequested)throw new a.$8;K(m,R,oe,we,ee)}return oe})().then(E,N)})}function K(m,R,U,$,r){for(const E=U.length;$<r;$++){const N=m[$];if(R(N,U[E-1])<0){U.pop();const z=(0,t.$nb)(U,oe=>R(N,oe)<0);U.splice(z,0,N)}}}function ne(m){return m.filter(R=>!!R)}function L(m){let R=0;for(let U=0;U<m.length;U++)m[U]&&(m[R]=m[U],R+=1);m.length=R}function n(m,R,U){m.splice(U,0,m.splice(R,1)[0])}function i(m){return!Array.isArray(m)||m.length===0}function l(m){return Array.isArray(m)&&m.length>0}function _(m,R=U=>U){const U=new Set;return m.filter($=>{const r=R($);return U.has(r)?!1:(U.add(r),!0)})}function y(m){const R=new Set;return U=>{const $=m(U);return R.has($)?!1:(R.add($),!0)}}function f(m,R){return m.length>0?m[0]:R}function d(m,R){return m.length>0?m[m.length-1]:R}function s(m,R,U=($,r)=>$===r){let $=0;for(let r=0,E=Math.min(m.length,R.length);r<E&&U(m[r],R[r]);r++)$++;return $}function h(m,R){let U=typeof R=="number"?m:0;typeof R=="number"?U=m:(U=0,R=m);const $=[];if(U<=R)for(let r=U;r<R;r++)$.push(r);else for(let r=U;r>R;r--)$.push(r);return $}function P(m,R,U){return m.reduce(($,r)=>($[R(r)]=U?U(r):r,$),Object.create(null))}function I(m,R){return m.push(R),()=>u(m,R)}function u(m,R){const U=m.indexOf(R);if(U>-1)return m.splice(U,1),R}function B(m,R,U){const $=m.slice(0,R),r=m.slice(R);return $.concat(U,r)}function W(m,R){let U;if(typeof R=="number"){let $=R;U=()=>{const r=Math.sin($++)*179426549;return r-Math.floor(r)}}else U=Math.random;for(let $=m.length-1;$>0;$-=1){const r=Math.floor(U()*($+1)),E=m[$];m[$]=m[r],m[r]=E}}function G(m,R){const U=m.indexOf(R);U>-1&&(m.splice(U,1),m.unshift(R))}function T(m,R){const U=m.indexOf(R);U>-1&&(m.splice(U,1),m.push(R))}function Q(m,R){for(const U of R)m.push(U)}function S(m,R){return Array.isArray(m)?m.map(R):R(m)}function v(m){return Array.isArray(m)?m:[m]}function H(m){return m[Math.floor(Math.random()*m.length)]}function V(m,R,U){const $=Z(m,R),r=m.length,E=U.length;m.length=r+E;for(let N=r-1;N>=$;N--)m[N+E]=m[N];for(let N=0;N<E;N++)m[N+$]=U[N]}function J(m,R,U,$){const r=Z(m,R);let E=m.splice(r,U);return E===void 0&&(E=[]),V(m,r,$),E}function Z(m,R){return R<0?Math.max(R+m.length,0):Math.min(R,m.length)}var se;(function(m){function R(E){return E<0}m.isLessThan=R;function U(E){return E<=0}m.isLessThanOrEqual=U;function $(E){return E>0}m.isGreaterThan=$;function r(E){return E===0}m.isNeitherLessOrGreaterThan=r,m.greaterThan=1,m.lessThan=-1,m.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function be(m,R){return(U,$)=>R(m(U),m($))}function ye(...m){return(R,U)=>{for(const $ of m){const r=$(R,U);if(!se.isNeitherLessOrGreaterThan(r))return r}return se.neitherLessOrGreaterThan}}const Re=(m,R)=>m-R;e.$$b=Re;const pe=(m,R)=>(0,e.$$b)(m?1:0,R?1:0);e.$_b=pe;function fe(m){return(R,U)=>-m(R,U)}class ve{constructor(R){this.g=R,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(R){let U=this.c;for(;U<this.g.length&&R(this.g[U]);)U++;const $=U===this.c?null:this.g.slice(this.c,U);return this.c=U,$}takeFromEndWhile(R){let U=this.d;for(;U>=0&&R(this.g[U]);)U--;const $=U===this.d?null:this.g.slice(U+1,this.d+1);return this.d=U,$}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const R=this.g[this.c];return this.c++,R}removeLast(){const R=this.g[this.d];return this.d--,R}takeCount(R){const U=this.g.slice(this.c,this.c+R);return this.c+=R,U}}e.$bc=ve;class de{constructor(R){this.iterate=R}forEach(R){this.iterate(U=>(R(U),!0))}toArray(){const R=[];return this.iterate(U=>(R.push(U),!0)),R}filter(R){return new de(U=>this.iterate($=>R($)?U($):!0))}map(R){return new de(U=>this.iterate($=>U(R($))))}some(R){let U=!1;return this.iterate($=>(U=R($),!U)),U}findFirst(R){let U;return this.iterate($=>R($)?(U=$,!1):!0),U}findLast(R){let U;return this.iterate($=>(R($)&&(U=$),!0)),U}findLastMaxBy(R){let U,$=!0;return this.iterate(r=>(($||se.isGreaterThan(R(r,U)))&&($=!1,U=r),!0)),U}}e.$cc=de,de.empty=new de(m=>{});class ge{constructor(R){this.c=R}static createSortPermutation(R,U){const $=Array.from(R.keys()).sort((r,E)=>U(R[r],R[E]));return new ge($)}apply(R){return R.map((U,$)=>R[this.c[$]])}inverse(){const R=this.c.slice();for(let U=0;U<this.c.length;U++)R[this.c[U]]=U;return new ge(R)}}e.$dc=ge}),define($e[10],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=a;function a(t,A){const O=this;let ie=!1,X;return function(){if(ie)return X;if(ie=!0,A)try{X=t.apply(O,arguments)}finally{A()}else X=t.apply(O,arguments);return X}}}),define($e[23],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function A(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=A;const O=Object.freeze([]);function ie(){return O}t.empty=ie;function*X(i){yield i}t.single=X;function F(i){return A(i)?i:X(i)}t.wrap=F;function p(i){return i||O}t.from=p;function*q(i){for(let l=i.length-1;l>=0;l--)yield i[l]}t.reverse=q;function x(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=x;function j(i){return i[Symbol.iterator]().next().value}t.first=j;function te(i,l){let _=0;for(const y of i)if(l(y,_++))return!0;return!1}t.some=te;function D(i,l){for(const _ of i)if(l(_))return _}t.find=D;function*c(i,l){for(const _ of i)l(_)&&(yield _)}t.filter=c;function*g(i,l){let _=0;for(const y of i)yield l(y,_++)}t.map=g;function*w(i,l){let _=0;for(const y of i)yield*l(y,_++)}t.flatMap=w;function*M(...i){for(const l of i)yield*l}t.concat=M;function K(i,l,_){let y=_;for(const f of i)y=l(y,f);return y}t.reduce=K;function*ne(i,l,_=i.length){for(l<0&&(l+=i.length),_<0?_+=i.length:_>i.length&&(_=i.length);l<_;l++)yield i[l]}t.slice=ne;function L(i,l=Number.POSITIVE_INFINITY){const _=[];if(l===0)return[_,i];const y=i[Symbol.iterator]();for(let f=0;f<l;f++){const d=y.next();if(d.done)return[_,t.empty()];_.push(d.value)}return[_,{[Symbol.iterator](){return y}}]}t.consume=L;async function n(i){const l=[];for await(const _ of i)l.push(_);return Promise.resolve(l)}t.asyncToArray=n})(a||(e.Iterable=a={}))}),define($e[11],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class a{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=a}),define($e[24],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class a{constructor(O){this.element=O,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class t{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let O=this.a;for(;O!==a.Undefined;){const ie=O.next;O.prev=a.Undefined,O.next=a.Undefined,O=ie}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,ie){const X=new a(O);if(this.a===a.Undefined)this.a=X,this.b=X;else if(ie){const p=this.b;this.b=X,X.prev=p,p.next=X}else{const p=this.a;this.a=X,X.next=p,p.prev=X}this.c+=1;let F=!1;return()=>{F||(F=!0,this.e(X))}}shift(){if(this.a!==a.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==a.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==a.Undefined&&O.next!==a.Undefined){const ie=O.prev;ie.next=O.next,O.next.prev=ie}else O.prev===a.Undefined&&O.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):O.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):O.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==a.Undefined;)yield O.element,O=O.next}}e.$8c=t}),define($e[12],Ee([0,1]),function(le,e){"use strict";var a,t,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=O,e.$Bc=ie,e.$Cc=X,e.$Lc=ne;function O(L,n,i){let l=L.get(n);return l===void 0&&(l=i,L.set(n,l)),l}function ie(L){const n=[];return L.forEach((i,l)=>{n.push(`${l} => ${i}`)}),`Map(${L.size}) {${n.join(", ")}}`}function X(L){const n=[];return L.forEach(i=>{n.push(i)}),`Set(${L.size}) {${n.join(", ")}}`}class F{constructor(n,i){this.uri=n,this.value=i}}function p(L){return Array.isArray(L)}class q{constructor(n,i){if(this[a]="ResourceMap",n instanceof q)this.d=new Map(n.d),this.e=i??q.c;else if(p(n)){this.d=new Map,this.e=i??q.c;for(const[l,_]of n)this.set(l,_)}else this.d=new Map,this.e=n??q.c}set(n,i){return this.d.set(this.e(n),new F(n,i)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[l,_]of this.d)n(_.value,_.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Dc=q,q.c=L=>L.toString();class x{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new q(n):(this.c=new q(i),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,i){this.c.forEach((l,_)=>n.call(i,_,_,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=x;var j;(function(L){L[L.None=0]="None",L[L.AsOld=1]="AsOld",L[L.AsNew=2]="AsNew"})(j||(e.Touch=j={}));class te{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,i=j.None){const l=this.c.get(n);if(l)return i!==j.None&&this.m(l,i),l.value}set(n,i,l=j.None){let _=this.c.get(n);if(_)_.value=i,l!==j.None&&this.m(_,l);else{switch(_={key:n,value:i,next:void 0,previous:void 0},l){case j.None:this.k(_);break;case j.AsOld:this.j(_);break;case j.AsNew:this.k(_);break;default:this.k(_);break}this.c.set(n,_),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this.c.get(n);if(i)return this.c.delete(n),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,i){const l=this.g;let _=this.d;for(;_;){if(i?n.bind(i)(_.value,_.key,this):n(_.value,_.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");_=_.next}}keys(){const n=this,i=this.g;let l=this.d;const _={[Symbol.iterator](){return _},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.key,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return _}values(){const n=this,i=this.g;let l=this.d;const _={[Symbol.iterator](){return _},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:l.value,done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return _}entries(){const n=this,i=this.g;let l=this.d;const _={[Symbol.iterator](){return _},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const y={value:[l.key,l.value],done:!1};return l=l.next,y}else return{value:void 0,done:!0}}};return _}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.d,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.next,l--;this.d=i,this.f=l,i&&(i.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.e,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.previous,l--;this.e=i,this.f=l,i&&(i.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const i=n.next,l=n.previous;if(!i||!l)throw new Error("Invalid list");i.previous=l,l.next=i}n.next=void 0,n.previous=void 0,this.g++}m(n,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==j.AsOld&&i!==j.AsNew)){if(i===j.AsOld){if(n===this.d)return;const l=n.next,_=n.previous;n===this.e?(_.next=void 0,this.e=_):(l.previous=_,_.next=l),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(i===j.AsNew){if(n===this.e)return;const l=n.next,_=n.previous;n===this.d?(l.previous=void 0,this.d=l):(l.previous=_,_.next=l),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((i,l)=>{n.push([l,i])}),n}fromJSON(n){this.clear();for(const[i,l]of n)this.set(i,l)}}e.$Fc=te;class D extends te{constructor(n,i=1){super(),this.n=n,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,i=j.AsNew){return super.get(n,i)}peek(n){return super.get(n,j.None)}set(n,i){return super.set(n,i,j.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends D{constructor(n,i=1){super(n,i)}q(n){this.h(n)}set(n,i){return super.set(n,i),this.p(),this}}e.$Gc=c;class g extends D{constructor(n,i=1){super(n,i)}q(n){this.i(n)}set(n,i){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,i),this}}e.$Hc=g;class w{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let i=this.c.get(n)||0;return i===0?!1:(i--,i===0?this.c.delete(n):this.c.set(n,i),!0)}has(n){return this.c.has(n)}}e.$Ic=w;class M{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[i,l]of n)this.set(i,l)}clear(){this.c.clear(),this.d.clear()}set(n,i){this.c.set(n,i),this.d.set(i,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const i=this.c.get(n);return i===void 0?!1:(this.c.delete(n),this.d.delete(i),!0)}forEach(n,i){this.c.forEach((l,_)=>{n.call(i,l,_,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=M;class K{constructor(){this.c=new Map}add(n,i){let l=this.c.get(n);l||(l=new Set,this.c.set(n,l)),l.add(i)}delete(n,i){const l=this.c.get(n);l&&(l.delete(i),l.size===0&&this.c.delete(n))}forEach(n,i){const l=this.c.get(n);l&&l.forEach(i)}get(n){const i=this.c.get(n);return i||new Set}}e.$Kc=K;function ne(L,n){if(L===n)return!0;if(L.size!==n.size)return!1;for(const[i,l]of L)if(!n.has(i)||n.get(i)!==l)return!1;for(const[i]of n)if(!L.has(i))return!1;return!0}}),define($e[13],Ee([0,1,22,21,12,10,23]),function(le,e,a,t,A,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=q,e.$Oc=x,e.$Pc=j,e.$Qc=c,e.$Rc=g,e.$Sc=w,e.$Tc=M,e.$Uc=K,e.$Vc=ne,e.$6c=h;const X=!1;let F=null;class p{constructor(){this.b=new Map}c(u){let B=this.b.get(u);return B||(B={parent:null,source:null,isSingleton:!1,value:u,idx:p.a++},this.b.set(u,B)),B}trackDisposable(u){const B=this.c(u);B.source||(B.source=new Error().stack)}setParent(u,B){const W=this.c(u);W.parent=B}markAsDisposed(u){this.b.delete(u)}markAsSingleton(u){this.c(u).isSingleton=!0}f(u,B){const W=B.get(u);if(W)return W;const G=u.parent?this.f(this.c(u.parent),B):u;return B.set(u,G),G}getTrackedDisposables(){const u=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,u).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(u=10,B){let W;if(B)W=B;else{const v=new Map,H=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,v).isSingleton);if(H.length===0)return;const V=new Set(H.map(J=>J.value));if(W=H.filter(J=>!(J.parent&&V.has(J.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function G(v){function H(J,Z){for(;J.length>0&&Z.some(se=>typeof se=="string"?se===J[0]:J[0].match(se));)J.shift()}const V=v.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return H(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const T=new A.$Kc;for(const v of W){const H=G(v);for(let V=0;V<=H.length;V++)T.add(H.slice(0,V).join(`
`),v)}W.sort((0,a.$9b)(v=>v.idx,a.$$b));let Q="",S=0;for(const v of W.slice(0,u)){S++;const H=G(v),V=[];for(let J=0;J<H.length;J++){let Z=H[J];Z=`(shared with ${T.get(H.slice(0,J+1).join(`
`)).size}/${W.length} leaks) at ${Z}`;const be=T.get(H.slice(0,J).join(`
`)),ye=(0,t.$E)([...be].map(Re=>G(Re)[J]),Re=>Re);delete ye[H[J]];for(const[Re,pe]of Object.entries(ye))V.unshift(`    - stacktraces of ${pe.length} other leaks continue with ${Re}`);V.unshift(Z)}Q+=`


==================== Leaking disposable ${S}/${W.length}: ${v.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return W.length>u&&(Q+=`


... and ${W.length-u} more leaking disposables

`),{leaks:W,details:Q}}}e.$Mc=p,p.a=0;function q(I){F=I}if(X){const I="__is_disposable_tracked__";q(new class{trackDisposable(u){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[I]||console.log(B)},3e3)}setParent(u,B){if(u&&u!==n.None)try{u[I]=!0}catch{}}markAsDisposed(u){if(u&&u!==n.None)try{u[I]=!0}catch{}}markAsSingleton(u){}})}function x(I){return F?.trackDisposable(I),I}function j(I){F?.markAsDisposed(I)}function te(I,u){F?.setParent(I,u)}function D(I,u){if(F)for(const B of I)F.setParent(B,u)}function c(I){return F?.markAsSingleton(I),I}function g(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function w(I){if(ie.Iterable.is(I)){const u=[];for(const B of I)if(B)try{B.dispose()}catch(W){u.push(W)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function M(I){for(const u of I)g(u)&&u.dispose();return[]}function K(...I){const u=ne(()=>w(I));return D(I,u),u}function ne(I){const u=x({dispose:(0,O.$gb)(()=>{j(u),I()})});return u}class L{constructor(){this.f=new Set,this.g=!1,x(this)}dispose(){this.g||(j(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{w(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return te(u,this),this.g?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}delete(u){if(u){if(u===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(u),u.dispose()}}deleteAndLeak(u){u&&this.f.has(u)&&(this.f.delete(u),te(u,null))}}e.$Wc=L,L.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this.q=new L,x(this),te(this.q,this)}dispose(){j(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}e.$Xc=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this.b=!1,x(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&te(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,j(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&te(u,null),u}}e.$Yc=i;class l{constructor(u){this.a=new i,this.b=!1,this.a.value=u}get value(){return this.a.value}set value(u){this.b||u===this.a.value||(this.a.value=u)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=l;class _{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=_;class y{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,x(this)}set(u){let B=u;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,j(this))},this}}e.$2c=y;class f{constructor(){this.a=new Map}acquire(u,...B){let W=this.a.get(u);W||(W={counter:0,object:this.b(u,...B)},this.a.set(u,W));const{object:G}=W,T=(0,O.$gb)(()=>{--W.counter===0&&(this.c(u,W.object),this.a.delete(u))});return W.counter++,{object:G,dispose:T}}}e.$3c=f;class d{constructor(u){this.a=u}async acquire(u,...B){const W=this.a.acquire(u,...B);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(G){throw W.dispose(),G}}}e.$4c=d;class s{constructor(u){this.object=u}dispose(){}}e.$5c=s;function h(I){const u=new L;try{I(u)}finally{u.dispose()}}class P{constructor(){this.a=new Map,this.b=!1,x(this)}dispose(){j(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{w(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get size(){return this.a.size}get(u){return this.a.get(u)}set(u,B,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(u)?.dispose(),this.a.set(u,B)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}deleteAndLeak(u){const B=this.a.get(u);return this.a.delete(u),B}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=P}),define($e[25],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var a;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(a||(e.MarshalledId=a={}))}),define($e[26],Ee([0,1,12]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=A,e.$om=ie;const t=new a.$Gc(1e4);function A(p){return F(p,"NFC",t)}const O=new a.$Gc(1e4);function ie(p){return F(p,"NFD",O)}const X=/[^\u0000-\u0080]/;function F(p,q,x){if(!p)return p;const j=x.get(p);if(j)return j;let te;return X.test(p)?te=p.normalize(q):te=p,x.set(p,te),te}e.$pm=function(){const p=/[\u0300-\u036f]/g;return function(q){return ie(q).replace(p,"")}}()}),define($e[2],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=n,e.$x=d,e.$D=s,e.$a="en";let a=!1,t=!1,A=!1,O=!1,ie=!1,X=!1,F=!1,p=!1,q=!1,x=!1,j,te=e.$a,D=e.$a,c,g;const w=globalThis;let M;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?M=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(M=process);const K=typeof M?.versions?.electron=="string",ne=K&&M?.type==="renderer";if(typeof M=="object"){a=M.platform==="win32",t=M.platform==="darwin",A=M.platform==="linux",O=A&&!!M.env.SNAP&&!!M.env.SNAP_REVISION,F=K,q=!!M.env.CI||!!M.env.BUILD_ARTIFACTSTAGINGDIRECTORY,j=e.$a,te=e.$a;const h=M.env.VSCODE_NLS_CONFIG;if(h)try{const P=JSON.parse(h),I=P.availableLanguages["*"];j=P.locale,D=P.osLocale,te=I||e.$a,c=P._translationsConfigFile}catch{}ie=!0}else if(typeof navigator=="object"&&!ne){g=navigator.userAgent,a=g.indexOf("Windows")>=0,t=g.indexOf("Macintosh")>=0,p=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,x=g?.indexOf("Mobi")>=0,X=!0,j=e.$a,te=j,D=navigator.language;const h=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),P=h&&h.getAttribute("data-settings");if(P)try{const I=JSON.parse(P),u=I.availableLanguages["*"];j=I.locale,D=I.osLocale,te=u||e.$a,c=I._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var L;(function(h){h[h.Web=0]="Web",h[h.Mac=1]="Mac",h[h.Linux=2]="Linux",h[h.Windows=3]="Windows"})(L||(e.Platform=L={}));function n(h){switch(h){case L.Web:return"Web";case L.Mac:return"Mac";case L.Linux:return"Linux";case L.Windows:return"Windows"}}let i=L.Web;t?i=L.Mac:a?i=L.Windows:A&&(i=L.Linux),e.$c=a,e.$d=t,e.$e=A,e.$f=O,e.$g=ie,e.$h=F,e.$i=X,e.$j=X&&typeof w.importScripts=="function",e.$k=e.$j?w.origin:void 0,e.$l=p,e.$m=x,e.$n=q,e.$o=i,e.$p=g,e.$q=te;var l;(function(h){function P(){return e.$q}h.value=P;function I(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}h.isDefaultVariant=I;function u(){return e.$q==="en"}h.isDefault=u})(l||(e.Language=l={})),e.$r=j,e.$s=D,e.$t=c,e.$u=typeof w.postMessage=="function"&&!w.importScripts,e.$v=(()=>{if(e.$u){const h=[];w.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let u=0,B=h.length;u<B;u++){const W=h[u];if(W.id===I.data.vscodeScheduleAsyncWork){h.splice(u,1),W.callback();return}}});let P=0;return I=>{const u=++P;h.push({id:u,callback:I}),w.postMessage({vscodeScheduleAsyncWork:u},"*")}}return h=>setTimeout(h)})();var _;(function(h){h[h.Windows=1]="Windows",h[h.Macintosh=2]="Macintosh",h[h.Linux=3]="Linux"})(_||(e.OperatingSystem=_={})),e.OS=t||p?_.Macintosh:a?_.Windows:_.Linux;let y=!0,f=!1;function d(){if(!f){f=!0;const h=new Uint8Array(2);h[0]=1,h[1]=2,y=new Uint16Array(h.buffer)[0]===513}return y}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function s(h){return parseFloat(h)>=20}}),define($e[14],Ee([0,1,2]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let t;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const O=A.process;t={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.$c?"win32":a.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$gc=t.platform,e.$hc=t.arch});var Ke=this&&this.__createBinding||(Object.create?function(le,e,a,t){t===void 0&&(t=a);var A=Object.getOwnPropertyDescriptor(e,a);(!A||("get"in A?!e.__esModule:A.writable||A.configurable))&&(A={enumerable:!0,get:function(){return e[a]}}),Object.defineProperty(le,t,A)}:function(le,e,a,t){t===void 0&&(t=a),le[t]=e[a]}),Xe=this&&this.__setModuleDefault||(Object.create?function(le,e){Object.defineProperty(le,"default",{enumerable:!0,value:e})}:function(le,e){le.default=e}),De=this&&this.__importStar||function(le){if(le&&le.__esModule)return le;var e={};if(le!=null)for(var a in le)a!=="default"&&Object.prototype.hasOwnProperty.call(le,a)&&Ke(e,le,a);return Xe(e,le),e};define($e[3],Ee([0,1,14]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,a=De(a);const t=65,A=97,O=90,ie=122,X=46,F=47,p=92,q=58,x=63;class j extends Error{constructor(i,l,_){let y;typeof l=="string"&&l.indexOf("not ")===0?(y="must not be",l=l.replace(/^not /,"")):y="must be";const f=i.indexOf(".")!==-1?"property":"argument";let d=`The "${i}" ${f} ${y} of type ${l}`;d+=`. Received type ${typeof _}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function te(n,i){if(n===null||typeof n!="object")throw new j(i,"Object",n)}function D(n,i){if(typeof n!="string")throw new j(i,"string",n)}const c=a.$gc==="win32";function g(n){return n===F||n===p}function w(n){return n===F}function M(n){return n>=t&&n<=O||n>=A&&n<=ie}function K(n,i,l,_){let y="",f=0,d=-1,s=0,h=0;for(let P=0;P<=n.length;++P){if(P<n.length)h=n.charCodeAt(P);else{if(_(h))break;h=F}if(_(h)){if(!(d===P-1||s===1))if(s===2){if(y.length<2||f!==2||y.charCodeAt(y.length-1)!==X||y.charCodeAt(y.length-2)!==X){if(y.length>2){const I=y.lastIndexOf(l);I===-1?(y="",f=0):(y=y.slice(0,I),f=y.length-1-y.lastIndexOf(l)),d=P,s=0;continue}else if(y.length!==0){y="",f=0,d=P,s=0;continue}}i&&(y+=y.length>0?`${l}..`:"..",f=2)}else y.length>0?y+=`${l}${n.slice(d+1,P)}`:y=n.slice(d+1,P),f=P-d-1;d=P,s=0}else h===X&&s!==-1?++s:s=-1}return y}function ne(n,i){te(i,"pathObject");const l=i.dir||i.root,_=i.base||`${i.name||""}${i.ext||""}`;return l?l===i.root?`${l}${_}`:`${l}${n}${_}`:_}e.$ic={resolve(...n){let i="",l="",_=!1;for(let y=n.length-1;y>=-1;y--){let f;if(y>=0){if(f=n[y],D(f,"path"),f.length===0)continue}else i.length===0?f=a.cwd():(f=a.env[`=${i}`]||a.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==i.toLowerCase()&&f.charCodeAt(2)===p)&&(f=`${i}\\`));const d=f.length;let s=0,h="",P=!1;const I=f.charCodeAt(0);if(d===1)g(I)&&(s=1,P=!0);else if(g(I))if(P=!0,g(f.charCodeAt(1))){let u=2,B=u;for(;u<d&&!g(f.charCodeAt(u));)u++;if(u<d&&u!==B){const W=f.slice(B,u);for(B=u;u<d&&g(f.charCodeAt(u));)u++;if(u<d&&u!==B){for(B=u;u<d&&!g(f.charCodeAt(u));)u++;(u===d||u!==B)&&(h=`\\\\${W}\\${f.slice(B,u)}`,s=u)}}}else s=1;else M(I)&&f.charCodeAt(1)===q&&(h=f.slice(0,2),s=2,d>2&&g(f.charCodeAt(2))&&(P=!0,s=3));if(h.length>0)if(i.length>0){if(h.toLowerCase()!==i.toLowerCase())continue}else i=h;if(_){if(i.length>0)break}else if(l=`${f.slice(s)}\\${l}`,_=P,P&&i.length>0)break}return l=K(l,!_,"\\",g),_?`${i}\\${l}`:`${i}${l}`||"."},normalize(n){D(n,"path");const i=n.length;if(i===0)return".";let l=0,_,y=!1;const f=n.charCodeAt(0);if(i===1)return w(f)?"\\":n;if(g(f))if(y=!0,g(n.charCodeAt(1))){let s=2,h=s;for(;s<i&&!g(n.charCodeAt(s));)s++;if(s<i&&s!==h){const P=n.slice(h,s);for(h=s;s<i&&g(n.charCodeAt(s));)s++;if(s<i&&s!==h){for(h=s;s<i&&!g(n.charCodeAt(s));)s++;if(s===i)return`\\\\${P}\\${n.slice(h)}\\`;s!==h&&(_=`\\\\${P}\\${n.slice(h,s)}`,l=s)}}}else l=1;else M(f)&&n.charCodeAt(1)===q&&(_=n.slice(0,2),l=2,i>2&&g(n.charCodeAt(2))&&(y=!0,l=3));let d=l<i?K(n.slice(l),!y,"\\",g):"";return d.length===0&&!y&&(d="."),d.length>0&&g(n.charCodeAt(i-1))&&(d+="\\"),_===void 0?y?`\\${d}`:d:y?`${_}\\${d}`:`${_}${d}`},isAbsolute(n){D(n,"path");const i=n.length;if(i===0)return!1;const l=n.charCodeAt(0);return g(l)||i>2&&M(l)&&n.charCodeAt(1)===q&&g(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,l;for(let f=0;f<n.length;++f){const d=n[f];D(d,"path"),d.length>0&&(i===void 0?i=l=d:i+=`\\${d}`)}if(i===void 0)return".";let _=!0,y=0;if(typeof l=="string"&&g(l.charCodeAt(0))){++y;const f=l.length;f>1&&g(l.charCodeAt(1))&&(++y,f>2&&(g(l.charCodeAt(2))?++y:_=!1))}if(_){for(;y<i.length&&g(i.charCodeAt(y));)y++;y>=2&&(i=`\\${i.slice(y)}`)}return e.$ic.normalize(i)},relative(n,i){if(D(n,"from"),D(i,"to"),n===i)return"";const l=e.$ic.resolve(n),_=e.$ic.resolve(i);if(l===_||(n=l.toLowerCase(),i=_.toLowerCase(),n===i))return"";let y=0;for(;y<n.length&&n.charCodeAt(y)===p;)y++;let f=n.length;for(;f-1>y&&n.charCodeAt(f-1)===p;)f--;const d=f-y;let s=0;for(;s<i.length&&i.charCodeAt(s)===p;)s++;let h=i.length;for(;h-1>s&&i.charCodeAt(h-1)===p;)h--;const P=h-s,I=d<P?d:P;let u=-1,B=0;for(;B<I;B++){const G=n.charCodeAt(y+B);if(G!==i.charCodeAt(s+B))break;G===p&&(u=B)}if(B!==I){if(u===-1)return _}else{if(P>I){if(i.charCodeAt(s+B)===p)return _.slice(s+B+1);if(B===2)return _.slice(s+B)}d>I&&(n.charCodeAt(y+B)===p?u=B:B===2&&(u=3)),u===-1&&(u=0)}let W="";for(B=y+u+1;B<=f;++B)(B===f||n.charCodeAt(B)===p)&&(W+=W.length===0?"..":"\\..");return s+=u,W.length>0?`${W}${_.slice(s,h)}`:(_.charCodeAt(s)===p&&++s,_.slice(s,h))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$ic.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===p){if(i.charCodeAt(1)===p){const l=i.charCodeAt(2);if(l!==x&&l!==X)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(M(i.charCodeAt(0))&&i.charCodeAt(1)===q&&i.charCodeAt(2)===p)return`\\\\?\\${i}`;return n},dirname(n){D(n,"path");const i=n.length;if(i===0)return".";let l=-1,_=0;const y=n.charCodeAt(0);if(i===1)return g(y)?n:".";if(g(y)){if(l=_=1,g(n.charCodeAt(1))){let s=2,h=s;for(;s<i&&!g(n.charCodeAt(s));)s++;if(s<i&&s!==h){for(h=s;s<i&&g(n.charCodeAt(s));)s++;if(s<i&&s!==h){for(h=s;s<i&&!g(n.charCodeAt(s));)s++;if(s===i)return n;s!==h&&(l=_=s+1)}}}}else M(y)&&n.charCodeAt(1)===q&&(l=i>2&&g(n.charCodeAt(2))?3:2,_=l);let f=-1,d=!0;for(let s=i-1;s>=_;--s)if(g(n.charCodeAt(s))){if(!d){f=s;break}}else d=!1;if(f===-1){if(l===-1)return".";f=l}return n.slice(0,f)},basename(n,i){i!==void 0&&D(i,"ext"),D(n,"path");let l=0,_=-1,y=!0,f;if(n.length>=2&&M(n.charCodeAt(0))&&n.charCodeAt(1)===q&&(l=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let d=i.length-1,s=-1;for(f=n.length-1;f>=l;--f){const h=n.charCodeAt(f);if(g(h)){if(!y){l=f+1;break}}else s===-1&&(y=!1,s=f+1),d>=0&&(h===i.charCodeAt(d)?--d===-1&&(_=f):(d=-1,_=s))}return l===_?_=s:_===-1&&(_=n.length),n.slice(l,_)}for(f=n.length-1;f>=l;--f)if(g(n.charCodeAt(f))){if(!y){l=f+1;break}}else _===-1&&(y=!1,_=f+1);return _===-1?"":n.slice(l,_)},extname(n){D(n,"path");let i=0,l=-1,_=0,y=-1,f=!0,d=0;n.length>=2&&n.charCodeAt(1)===q&&M(n.charCodeAt(0))&&(i=_=2);for(let s=n.length-1;s>=i;--s){const h=n.charCodeAt(s);if(g(h)){if(!f){_=s+1;break}continue}y===-1&&(f=!1,y=s+1),h===X?l===-1?l=s:d!==1&&(d=1):l!==-1&&(d=-1)}return l===-1||y===-1||d===0||d===1&&l===y-1&&l===_+1?"":n.slice(l,y)},format:ne.bind(null,"\\"),parse(n){D(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.length;let _=0,y=n.charCodeAt(0);if(l===1)return g(y)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(g(y)){if(_=1,g(n.charCodeAt(1))){let u=2,B=u;for(;u<l&&!g(n.charCodeAt(u));)u++;if(u<l&&u!==B){for(B=u;u<l&&g(n.charCodeAt(u));)u++;if(u<l&&u!==B){for(B=u;u<l&&!g(n.charCodeAt(u));)u++;u===l?_=u:u!==B&&(_=u+1)}}}}else if(M(y)&&n.charCodeAt(1)===q){if(l<=2)return i.root=i.dir=n,i;if(_=2,g(n.charCodeAt(2))){if(l===3)return i.root=i.dir=n,i;_=3}}_>0&&(i.root=n.slice(0,_));let f=-1,d=_,s=-1,h=!0,P=n.length-1,I=0;for(;P>=_;--P){if(y=n.charCodeAt(P),g(y)){if(!h){d=P+1;break}continue}s===-1&&(h=!1,s=P+1),y===X?f===-1?f=P:I!==1&&(I=1):f!==-1&&(I=-1)}return s!==-1&&(f===-1||I===0||I===1&&f===s-1&&f===d+1?i.base=i.name=n.slice(d,s):(i.name=n.slice(d,f),i.base=n.slice(d,s),i.ext=n.slice(f,s))),d>0&&d!==_?i.dir=n.slice(0,d-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(c){const n=/\\/g;return()=>{const i=a.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>a.cwd()})();e.$jc={resolve(...n){let i="",l=!1;for(let _=n.length-1;_>=-1&&!l;_--){const y=_>=0?n[_]:L();D(y,"path"),y.length!==0&&(i=`${y}/${i}`,l=y.charCodeAt(0)===F)}return i=K(i,!l,"/",w),l?`/${i}`:i.length>0?i:"."},normalize(n){if(D(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===F,l=n.charCodeAt(n.length-1)===F;return n=K(n,!i,"/",w),n.length===0?i?"/":l?"./":".":(l&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return D(n,"path"),n.length>0&&n.charCodeAt(0)===F},join(...n){if(n.length===0)return".";let i;for(let l=0;l<n.length;++l){const _=n[l];D(_,"path"),_.length>0&&(i===void 0?i=_:i+=`/${_}`)}return i===void 0?".":e.$jc.normalize(i)},relative(n,i){if(D(n,"from"),D(i,"to"),n===i||(n=e.$jc.resolve(n),i=e.$jc.resolve(i),n===i))return"";const l=1,_=n.length,y=_-l,f=1,d=i.length-f,s=y<d?y:d;let h=-1,P=0;for(;P<s;P++){const u=n.charCodeAt(l+P);if(u!==i.charCodeAt(f+P))break;u===F&&(h=P)}if(P===s)if(d>s){if(i.charCodeAt(f+P)===F)return i.slice(f+P+1);if(P===0)return i.slice(f+P)}else y>s&&(n.charCodeAt(l+P)===F?h=P:P===0&&(h=0));let I="";for(P=l+h+1;P<=_;++P)(P===_||n.charCodeAt(P)===F)&&(I+=I.length===0?"..":"/..");return`${I}${i.slice(f+h)}`},toNamespacedPath(n){return n},dirname(n){if(D(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===F;let l=-1,_=!0;for(let y=n.length-1;y>=1;--y)if(n.charCodeAt(y)===F){if(!_){l=y;break}}else _=!1;return l===-1?i?"/":".":i&&l===1?"//":n.slice(0,l)},basename(n,i){i!==void 0&&D(i,"ext"),D(n,"path");let l=0,_=-1,y=!0,f;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let d=i.length-1,s=-1;for(f=n.length-1;f>=0;--f){const h=n.charCodeAt(f);if(h===F){if(!y){l=f+1;break}}else s===-1&&(y=!1,s=f+1),d>=0&&(h===i.charCodeAt(d)?--d===-1&&(_=f):(d=-1,_=s))}return l===_?_=s:_===-1&&(_=n.length),n.slice(l,_)}for(f=n.length-1;f>=0;--f)if(n.charCodeAt(f)===F){if(!y){l=f+1;break}}else _===-1&&(y=!1,_=f+1);return _===-1?"":n.slice(l,_)},extname(n){D(n,"path");let i=-1,l=0,_=-1,y=!0,f=0;for(let d=n.length-1;d>=0;--d){const s=n.charCodeAt(d);if(s===F){if(!y){l=d+1;break}continue}_===-1&&(y=!1,_=d+1),s===X?i===-1?i=d:f!==1&&(f=1):i!==-1&&(f=-1)}return i===-1||_===-1||f===0||f===1&&i===_-1&&i===l+1?"":n.slice(i,_)},format:ne.bind(null,"/"),parse(n){D(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.charCodeAt(0)===F;let _;l?(i.root="/",_=1):_=0;let y=-1,f=0,d=-1,s=!0,h=n.length-1,P=0;for(;h>=_;--h){const I=n.charCodeAt(h);if(I===F){if(!s){f=h+1;break}continue}d===-1&&(s=!1,d=h+1),I===X?y===-1?y=h:P!==1&&(P=1):y!==-1&&(P=-1)}if(d!==-1){const I=f===0&&l?1:f;y===-1||P===0||P===1&&y===d-1&&y===f+1?i.base=i.name=n.slice(I,d):(i.name=n.slice(I,y),i.base=n.slice(I,d),i.ext=n.slice(y,d))}return f>0?i.dir=n.slice(0,f-1):l&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=c?e.$ic.normalize:e.$jc.normalize,e.$lc=c?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=c?e.$ic.join:e.$jc.join,e.$nc=c?e.$ic.resolve:e.$jc.resolve,e.$oc=c?e.$ic.relative:e.$jc.relative,e.$pc=c?e.$ic.dirname:e.$jc.dirname,e.$qc=c?e.$ic.basename:e.$jc.basename,e.$rc=c?e.$ic.extname:e.$jc.extname,e.$sc=c?e.$ic.format:e.$jc.format,e.$tc=c?e.$ic.parse:e.$jc.parse,e.$uc=c?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=c?e.$ic.sep:e.$jc.sep,e.$wc=c?e.$ic.delimiter:e.$jc.delimiter}),define($e[27],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const a=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(O){return new t(O)}constructor(O){this.c=a&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=t}),define($e[15],Ee([0,1,5,10,13,24,27]),function(le,e,a,t,A,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=te;const X=!1,F=!1,p=!1;var q;(function(G){G.None=()=>A.$Xc.None;function T(ee){if(p){const{onDidAddListener:C}=ee,ue=c.create();let re=0;ee.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),C?.()}}}function Q(ee,C){return Re(ee,()=>{},0,void 0,!0,void 0,C)}G.defer=Q;function S(ee){return(C,ue=null,re)=>{let ae=!1,he;return he=ee(Ae=>{if(!ae)return he?he.dispose():ae=!0,C.call(ue,Ae)},null,re),ae&&he.dispose(),he}}G.once=S;function v(ee,C,ue){return be((re,ae=null,he)=>ee(Ae=>re.call(ae,C(Ae)),null,he),ue)}G.map=v;function H(ee,C,ue){return be((re,ae=null,he)=>ee(Ae=>{C(Ae),re.call(ae,Ae)},null,he),ue)}G.forEach=H;function V(ee,C,ue){return be((re,ae=null,he)=>ee(Ae=>C(Ae)&&re.call(ae,Ae),null,he),ue)}G.filter=V;function J(ee){return ee}G.signal=J;function Z(...ee){return(C,ue=null,re)=>{const ae=(0,A.$Uc)(...ee.map(he=>he(Ae=>C.call(ue,Ae))));return ye(ae,re)}}G.any=Z;function se(ee,C,ue,re){let ae=ue;return v(ee,he=>(ae=C(ae,he),ae),re)}G.reduce=se;function be(ee,C){let ue;const re={onWillAddFirstListener(){ue=ee(ae.fire,ae)},onDidRemoveLastListener(){ue?.dispose()}};C||T(re);const ae=new i(re);return C?.add(ae),ae.event}function ye(ee,C){return C instanceof Array?C.push(ee):C&&C.add(ee),ee}function Re(ee,C,ue=100,re=!1,ae=!1,he,Ae){let Le,Ie,Me,Be=0,ke;const _e={leakWarningThreshold:he,onWillAddFirstListener(){Le=ee(Ge=>{Be++,Ie=C(Ie,Ge),re&&!Me&&(Te.fire(Ie),Ie=void 0),ke=()=>{const He=Ie;Ie=void 0,Me=void 0,(!re||Be>1)&&Te.fire(He),Be=0},typeof ue=="number"?(clearTimeout(Me),Me=setTimeout(ke,ue)):Me===void 0&&(Me=0,queueMicrotask(ke))})},onWillRemoveListener(){ae&&Be>0&&ke?.()},onDidRemoveLastListener(){ke=void 0,Le.dispose()}};Ae||T(_e);const Te=new i(_e);return Ae?.add(Te),Te.event}G.debounce=Re;function pe(ee,C=0,ue){return G.debounce(ee,(re,ae)=>re?(re.push(ae),re):[ae],C,void 0,!0,void 0,ue)}G.accumulate=pe;function fe(ee,C=(re,ae)=>re===ae,ue){let re=!0,ae;return V(ee,he=>{const Ae=re||!C(he,ae);return re=!1,ae=he,Ae},ue)}G.latch=fe;function ve(ee,C,ue){return[G.filter(ee,C,ue),G.filter(ee,re=>!C(re),ue)]}G.split=ve;function de(ee,C=!1,ue=[],re){let ae=ue.slice(),he=ee(Ie=>{ae?ae.push(Ie):Le.fire(Ie)});re&&re.add(he);const Ae=()=>{ae?.forEach(Ie=>Le.fire(Ie)),ae=null},Le=new i({onWillAddFirstListener(){he||(he=ee(Ie=>Le.fire(Ie)),re&&re.add(he))},onDidAddFirstListener(){ae&&(C?setTimeout(Ae):Ae())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return re&&re.add(Le),Le.event}G.buffer=de;function ge(ee,C){return(re,ae,he)=>{const Ae=C(new R);return ee(function(Le){const Ie=Ae.evaluate(Le);Ie!==m&&re.call(ae,Ie)},void 0,he)}}G.chain=ge;const m=Symbol("HaltChainable");class R{constructor(){this.f=[]}map(C){return this.f.push(C),this}forEach(C){return this.f.push(ue=>(C(ue),ue)),this}filter(C){return this.f.push(ue=>C(ue)?ue:m),this}reduce(C,ue){let re=ue;return this.f.push(ae=>(re=C(re,ae),re)),this}latch(C=(ue,re)=>ue===re){let ue=!0,re;return this.f.push(ae=>{const he=ue||!C(ae,re);return ue=!1,re=ae,he?ae:m}),this}evaluate(C){for(const ue of this.f)if(C=ue(C),C===m)break;return C}}function U(ee,C,ue=re=>re){const re=(...Le)=>Ae.fire(ue(...Le)),ae=()=>ee.on(C,re),he=()=>ee.removeListener(C,re),Ae=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:he});return Ae.event}G.fromNodeEventEmitter=U;function $(ee,C,ue=re=>re){const re=(...Le)=>Ae.fire(ue(...Le)),ae=()=>ee.addEventListener(C,re),he=()=>ee.removeEventListener(C,re),Ae=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:he});return Ae.event}G.fromDOMEventEmitter=$;function r(ee){return new Promise(C=>S(ee)(C))}G.toPromise=r;function E(ee){const C=new i;return ee.then(ue=>{C.fire(ue)},()=>{C.fire(void 0)}).finally(()=>{C.dispose()}),C.event}G.fromPromise=E;function N(ee,C,ue){return C(ue),ee(re=>C(re))}G.runAndSubscribe=N;class z{constructor(C,ue){this._observable=C,this.f=0,this.g=!1;const re={onWillAddFirstListener:()=>{C.addObserver(this)},onDidRemoveLastListener:()=>{C.removeObserver(this)}};ue||T(re),this.emitter=new i(re),ue&&ue.add(this.emitter)}beginUpdate(C){this.f++}handlePossibleChange(C){}handleChange(C,ue){this.g=!0}endUpdate(C){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function oe(ee,C){return new z(ee,C).emitter.event}G.fromObservable=oe;function we(ee){return(C,ue,re)=>{let ae=0,he=!1;const Ae={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(ee.reportChanges(),he&&(he=!1,C.call(ue)))},handlePossibleChange(){},handleChange(){he=!0}};ee.addObserver(Ae),ee.reportChanges();const Le={dispose(){ee.removeObserver(Ae)}};return re instanceof A.$Wc?re.add(Le):Array.isArray(re)&&re.push(Le),Le}}G.fromObservableLight=we})(q||(e.Event=q={}));class x{constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${x.f++}`,x.all.add(this)}start(T){this.g=new ie.$he,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}e.$je=x,x.all=new Set,x.f=0;let j=-1;function te(G){const T=j;return j=G,{dispose(){j=T}}}class D{constructor(T,Q,S=(D.f++).toString(16).padStart(3,"0")){this.j=T,this.threshold=Q,this.name=S,this.h=0}dispose(){this.g?.clear()}check(T,Q){const S=this.threshold;if(S<=0||Q<S)return;this.g||(this.g=new Map);const v=this.g.get(T.value)||0;if(this.g.set(T.value,v+1),this.h-=1,this.h<=0){this.h=S*.5;const[H,V]=this.getMostFrequentStack(),J=`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${V}):`;console.warn(J),console.warn(H);const Z=new g(J,H);this.j(Z)}return()=>{const H=this.g.get(T.value)||0;this.g.set(T.value,H-1)}}getMostFrequentStack(){if(!this.g)return;let T,Q=0;for(const[S,v]of this.g)(!T||Q<v)&&(T=[S,v],Q=v);return T}}D.f=1;class c{static create(){const T=new Error;return new c(T.stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g extends Error{constructor(T,Q){super(T),this.name="ListenerLeakError",this.stack=Q}}e.$le=g;class w extends Error{constructor(T,Q){super(T),this.name="ListenerRefusalError",this.stack=Q}}e.$me=w;let M=0;class K{constructor(T){this.value=T,this.id=M++}}const ne=2,L=(G,T)=>{if(G instanceof K)T(G);else for(let Q=0;Q<G.length;Q++){const S=G[Q];S&&T(S)}};let n;if(X){const G=[];setInterval(()=>{G.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(G.join(`
`)),G.length=0)},3e3),n=new FinalizationRegistry(T=>{typeof T=="string"&&G.push(T)})}class i{constructor(T){this.z=0,this.f=T,this.g=j>0||this.f?.leakWarningThreshold?new D(T?.onListenerError??a.$3,this.f?.leakWarningThreshold??j):void 0,this.j=this.f?._profName?new x(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(F){const T=this.u;queueMicrotask(()=>{L(T,Q=>Q.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(T,Q,S)=>{if(this.g&&this.z>this.g.threshold**2){const Z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(Z);const se=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],be=new w(`${Z}. HINT: Stack shows most frequent listener (${se[1]}-times)`,se[0]);return(this.f?.onListenerError||a.$3)(be),A.$Xc.None}if(this.m)return A.$Xc.None;Q&&(T=T.bind(Q));const v=new K(T);let H,V;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(v.stack=c.create(),H=this.g.check(v.stack,this.z+1)),F&&(v.stack=V??c.create()),this.u?this.u instanceof K?(this.w??(this.w=new _),this.u=[this.u,v]):this.u.push(v):(this.f?.onWillAddFirstListener?.(this),this.u=v,this.f?.onDidAddFirstListener?.(this)),this.z++;const J=(0,A.$Vc)(()=>{n?.unregister(J),H?.(),this.A(v)});if(S instanceof A.$Wc?S.add(J):Array.isArray(S)&&S.push(J),n){const Z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),se=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(Z);n.register(J,se?.[2]??Z,J)}return J}),this.q}A(T){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Q=this.u,S=Q.indexOf(T);if(S===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Q[S]=void 0;const v=this.w.current===this;if(this.z*ne<=Q.length){let H=0;for(let V=0;V<Q.length;V++)Q[V]?Q[H++]=Q[V]:v&&(this.w.end--,H<this.w.i&&this.w.i--);Q.length=H}}B(T,Q){if(!T)return;const S=this.f?.onListenerError||a.$3;if(!S){T.value(Q);return}try{T.value(Q)}catch(v){S(v)}}C(T){const Q=T.current.u;for(;T.i<T.end;)this.B(Q[T.i++],T.value);T.reset()}fire(T){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof K)this.B(this.u,T);else{const Q=this.w;Q.enqueue(this,T,this.u.length),this.C(Q)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=i;const l=()=>new _;e.$oe=l;class _{constructor(){this.i=-1,this.end=0}enqueue(T,Q,S){this.i=0,this.end=S,this.current=T,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class y extends i{async fireAsync(T,Q,S){if(this.u)for(this.h||(this.h=new O.$8c),L(this.u,v=>this.h.push([v.value,T]));this.h.size>0&&!Q.isCancellationRequested;){const[v,H]=this.h.shift(),V=[],J={...H,token:Q,waitUntil:Z=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");S&&(Z=S(Z,v)),V.push(Z)}};try{v(J)}catch(Z){(0,a.$3)(Z);continue}Object.freeze(V),await Promise.allSettled(V).then(Z=>{for(const se of Z)se.status==="rejected"&&(0,a.$3)(se.reason)})}}}e.$pe=y;class f extends i{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new O.$8c,this.t=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.t(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.z&&(this.h!==0?this.s.push(T):super.fire(T))}}e.$qe=f;class d extends f{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}e.$re=d;class s extends i{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}e.$se=s;class h{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const Q={event:T,listener:null};this.h.push(Q),this.g&&this.m(Q);const S=()=>{this.g&&this.o(Q);const v=this.h.indexOf(Q);this.h.splice(v,1)};return(0,A.$Vc)((0,t.$gb)(S))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(Q=>this.f.fire(Q))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}e.$te=h;class P{constructor(T,Q,S,v){this.f=new A.$Wc;const H=this.f.add(new h),V=this.f.add(new A.$7c);function J(Z){V.set(Z,H.add(v(Z)))}for(const Z of T)J(Z);this.f.add(Q(Z=>{J(Z)})),this.f.add(S(Z=>{V.deleteAndDispose(Z)})),this.event=H.event}dispose(){this.f.dispose()}}e.$ue=P;class I{constructor(){this.f=[]}wrapEvent(T,Q,S){return(v,H,V)=>T(J=>{const Z=this.f[this.f.length-1];if(!Q){Z?Z.buffers.push(()=>v.call(H,J)):v.call(H,J);return}const se=Z;if(!se){v.call(H,Q(S,J));return}se.items??(se.items=[]),se.items.push(J),se.buffers.length===0&&Z.buffers.push(()=>{se.reducedResult??(se.reducedResult=S?se.items.reduce(Q,S):se.items.reduce(Q)),v.call(H,se.reducedResult)})},void 0,V)}bufferEvents(T){const Q={buffers:new Array};this.f.push(Q);const S=T();return this.f.pop(),Q.buffers.forEach(v=>v()),S}}e.$ve=I;class u{constructor(){this.f=!1,this.g=q.None,this.h=A.$Xc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=u;class B{static const(T){return new W(T)}constructor(T){this.g=T,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(T){T!==this.g&&(this.g=T,this.f.fire(void 0))}}e.$xe=B;class W{constructor(T){this.value=T,this.onDidChange=q.None}}}),define($e[16],Ee([0,1,15]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=X;const t=Object.freeze(function(F,p){const q=setTimeout(F.bind(p),0);return{dispose(){clearTimeout(q)}}});var A;(function(F){function p(q){return q===F.None||q===F.Cancelled||q instanceof O?!0:!q||typeof q!="object"?!1:typeof q.isCancellationRequested=="boolean"&&typeof q.onCancellationRequested=="function"}F.isCancellationToken=p,F.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),F.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(A||(e.CancellationToken=A={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new a.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class ie{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=A.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=A.None}}e.$ye=ie;function X(F){const p=new ie;return F.add({dispose(){p.cancel()}}),p.token}}),define($e[28],Ee([0,1,16]),function(le,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=A;class t{constructor(F){this.b=F,this.a=null}get(){if(this.a)return this.a;const F=new a.$ye,p=this.b(F.token);return this.a={promise:p,dispose:()=>{this.a=null,F.cancel(),F.dispose()}},this.a}}e.$$e=t;function A(X){return X}class O{constructor(F,p){this.a=void 0,this.b=void 0,typeof F=="function"?(this.c=F,this.d=A):(this.c=p,this.d=F.getCacheKey)}get(F){const p=this.d(F);return this.b!==p&&(this.b=p,this.a=this.c(F)),this.a}}e.$af=O;class ie{get cachedValues(){return this.a}constructor(F,p){this.a=new Map,this.b=new Map,typeof F=="function"?(this.c=F,this.d=A):(this.c=p,this.d=F.getCacheKey)}get(F){const p=this.d(F);if(this.b.has(p))return this.b.get(p);const q=this.c(F);return this.a.set(F,q),this.b.set(p,q),q}}e.$bf=ie}),define($e[29],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define($e[30],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=a,e.$hg=t,e.$ig=A,e.$jg=O,e.$kg=ie,e.$lg=X,e.$mg=F,e.$ng=p,e.$og=q,e.$pg=x,e.$qg=j,e.$rg=te,e.$sg=D,e.$tg=g,e.$ug=w,e.$vg=M,e.$wg=K,e.$xg=ne;function a(L){return typeof L=="string"}function t(L){return Array.isArray(L)&&L.every(n=>a(n))}function A(L){return typeof L=="object"&&L!==null&&!Array.isArray(L)&&!(L instanceof RegExp)&&!(L instanceof Date)}function O(L){const n=Object.getPrototypeOf(Uint8Array);return typeof L=="object"&&L instanceof n}function ie(L){return typeof L=="number"&&!isNaN(L)}function X(L){return!!L&&typeof L[Symbol.iterator]=="function"}function F(L){return L===!0||L===!1}function p(L){return typeof L>"u"}function q(L){return!x(L)}function x(L){return p(L)||L===null}function j(L,n){if(!L)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function te(L){if(x(L))throw new Error("Assertion Failed: argument is undefined or null");return L}function D(...L){const n=[];for(let i=0;i<L.length;i++){const l=L[i];if(x(l))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(l)}return n}const c=Object.prototype.hasOwnProperty;function g(L){if(!A(L))return!1;for(const n in L)if(c.call(L,n))return!1;return!0}function w(L){return typeof L=="function"}function M(...L){return L.length>0&&L.every(w)}function K(L,n){const i=Math.min(L.length,n.length);for(let l=0;l<i;l++)ne(L[l],n[l])}function ne(L,n){if(a(n)){if(typeof L!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(w(n)){try{if(L instanceof n)return}catch{}if(!x(L)&&L.constructor===n||n.length===1&&n.call(void 0,L)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define($e[31],Ee([0,1]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=t,e.$df=A;var a;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a||(e.Constants=a={}));function t(O){return O<0?0:O>a.MAX_UINT_8?a.MAX_UINT_8:O|0}function A(O){return O<0?0:O>a.MAX_UINT_32?a.MAX_UINT_32:O|0}}),define($e[7],Ee([0,1,28,4,11,31]),function(le,e,a,t,A,O){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=X,e.$ff=p,e.$gf=x,e.$hf=j,e.$if=te,e.$jf=D,e.$kf=c,e.$lf=g,e.$mf=w,e.$nf=M,e.$of=K,e.$pf=ne,e.$qf=L,e.$rf=n,e.$sf=i,e.$tf=l,e.$uf=_,e.$vf=y,e.$wf=f,e.$xf=d,e.$yf=s,e.$zf=h,e.$Af=P,e.$Bf=I,e.$Cf=u,e.$Df=B,e.$Ef=W,e.$Ff=G,e.$Gf=T,e.$Hf=Q,e.$If=S,e.$Jf=v,e.$Kf=H,e.$Lf=V,e.$Mf=J,e.$Nf=Z,e.$Of=se,e.$Rf=pe,e.$Sf=fe,e.$Tf=ve,e.$Uf=de,e.$Vf=R,e.$Wf=$,e.$Yf=r,e.$Zf=E,e.$1f=N,e.$2f=z,e.$3f=we,e.$4f=ee,e.$5f=ue,e.$7f=re,e.$8f=ae,e.$9f=he,e.$0f=Ae,e.$$f=Le,e.$_f=Ie,e.$ag=Me,e.$bg=Be,e.$cg=He;function X(o){return!o||typeof o!="string"?!0:o.trim().length===0}const F=/{(\d+)}/g;function p(o,...b){return b.length===0?o:o.replace(F,function(k,Y){const ce=parseInt(Y,10);return isNaN(ce)||ce<0||ce>=b.length?k:b[ce]})}const q=/{([^}]+)}/g;function x(o,b){return Object.keys(b).length===0?o:o.replace(q,(k,Y)=>b[Y]??k)}function j(o){return o.replace(/[<>"'&]/g,b=>{switch(b){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return b})}function te(o){return o.replace(/[<>&]/g,function(b){switch(b){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return b}})}function D(o){return o.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(o,b){let k=0,Y=o.indexOf(b);for(;Y!==-1;)k++,Y=o.indexOf(b,Y+b.length);return k}function g(o,b,k="\u2026"){return o.length<=b?o:`${o.substr(0,b)}${k}`}function w(o,b,k="\u2026"){if(o.length<=b)return o;const Y=Math.ceil(b/2)-k.length/2,ce=Math.floor(b/2)-k.length/2;return`${o.substr(0,Y)}${k}${o.substr(o.length-ce)}`}function M(o,b=" "){const k=K(o,b);return ne(k,b)}function K(o,b){if(!o||!b)return o;const k=b.length;if(k===0||o.length===0)return o;let Y=0;for(;o.indexOf(b,Y)===Y;)Y=Y+k;return o.substring(Y)}function ne(o,b){if(!o||!b)return o;const k=b.length,Y=o.length;if(k===0||Y===0)return o;let ce=Y,me=-1;for(;me=o.lastIndexOf(b,ce-1),!(me===-1||me+k!==ce);){if(me===0)return"";ce=me}return o.substring(0,ce)}function L(o){return o.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(o){return o.replace(/\*/g,"")}function i(o,b,k={}){if(!o)throw new Error("Cannot create regex from empty string");b||(o=D(o)),k.wholeWord&&(/\B/.test(o.charAt(0))||(o="\\b"+o),/\B/.test(o.charAt(o.length-1))||(o=o+"\\b"));let Y="";return k.global&&(Y+="g"),k.matchCase||(Y+="i"),k.multiline&&(Y+="m"),k.unicode&&(Y+="u"),new RegExp(o,Y)}function l(o){return o.source==="^"||o.source==="^$"||o.source==="$"||o.source==="^\\s*$"?!1:!!(o.exec("")&&o.lastIndex===0)}function _(o){return o.split(/\r\n|\r|\n/)}function y(o){const b=[],k=o.split(/(\r\n|\r|\n)/);for(let Y=0;Y<Math.ceil(k.length/2);Y++)b.push(k[2*Y]+(k[2*Y+1]??""));return b}function f(o){for(let b=0,k=o.length;b<k;b++){const Y=o.charCodeAt(b);if(Y!==t.CharCode.Space&&Y!==t.CharCode.Tab)return b}return-1}function d(o,b=0,k=o.length){for(let Y=b;Y<k;Y++){const ce=o.charCodeAt(Y);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return o.substring(b,Y)}return o.substring(b,k)}function s(o,b=o.length-1){for(let k=b;k>=0;k--){const Y=o.charCodeAt(k);if(Y!==t.CharCode.Space&&Y!==t.CharCode.Tab)return k}return-1}function h(o,b,k){const Y=[];let ce=0;for(const me of o.matchAll(b)){if(Y.push(o.slice(ce,me.index)),me.index===void 0)throw new Error("match.index should be defined");ce=me.index+me[0].length,Y.push(k(me[0],...me.slice(1),me.index,o,me.groups))}return Y.push(o.slice(ce)),Promise.all(Y).then(me=>me.join(""))}function P(o,b){return o<b?-1:o>b?1:0}function I(o,b,k=0,Y=o.length,ce=0,me=b.length){for(;k<Y&&ce<me;k++,ce++){const Pe=o.charCodeAt(k),Ue=b.charCodeAt(ce);if(Pe<Ue)return-1;if(Pe>Ue)return 1}const Oe=Y-k,je=me-ce;return Oe<je?-1:Oe>je?1:0}function u(o,b){return B(o,b,0,o.length,0,b.length)}function B(o,b,k=0,Y=o.length,ce=0,me=b.length){for(;k<Y&&ce<me;k++,ce++){let Pe=o.charCodeAt(k),Ue=b.charCodeAt(ce);if(Pe===Ue)continue;if(Pe>=128||Ue>=128)return I(o.toLowerCase(),b.toLowerCase(),k,Y,ce,me);G(Pe)&&(Pe-=32),G(Ue)&&(Ue-=32);const Se=Pe-Ue;if(Se!==0)return Se}const Oe=Y-k,je=me-ce;return Oe<je?-1:Oe>je?1:0}function W(o){return o>=t.CharCode.Digit0&&o<=t.CharCode.Digit9}function G(o){return o>=t.CharCode.a&&o<=t.CharCode.z}function T(o){return o>=t.CharCode.A&&o<=t.CharCode.Z}function Q(o,b){return o.length===b.length&&B(o,b)===0}function S(o,b){const k=b.length;return b.length>o.length?!1:B(o,b,0,k)===0}function v(o,b){const k=Math.min(o.length,b.length);let Y;for(Y=0;Y<k;Y++)if(o.charCodeAt(Y)!==b.charCodeAt(Y))return Y;return k}function H(o,b){const k=Math.min(o.length,b.length);let Y;const ce=o.length-1,me=b.length-1;for(Y=0;Y<k;Y++)if(o.charCodeAt(ce-Y)!==b.charCodeAt(me-Y))return Y;return k}function V(o){return 55296<=o&&o<=56319}function J(o){return 56320<=o&&o<=57343}function Z(o,b){return(o-55296<<10)+(b-56320)+65536}function se(o,b,k){const Y=o.charCodeAt(k);if(V(Y)&&k+1<b){const ce=o.charCodeAt(k+1);if(J(ce))return Z(Y,ce)}return Y}function be(o,b){const k=o.charCodeAt(b-1);if(J(k)&&b>1){const Y=o.charCodeAt(b-2);if(V(Y))return Z(Y,k)}return k}class ye{get offset(){return this.e}constructor(b,k=0){this.c=b,this.d=b.length,this.e=k}setOffset(b){this.e=b}prevCodePoint(){const b=be(this.c,this.e);return this.e-=b>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,b}nextCodePoint(){const b=se(this.c,this.d,this.e);return this.e+=b>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,b}eol(){return this.e>=this.d}}e.$Pf=ye;class Re{get offset(){return this.c.offset}constructor(b,k=0){this.c=new ye(b,k)}nextGraphemeLength(){const b=Te.getInstance(),k=this.c,Y=k.offset;let ce=b.getGraphemeBreakType(k.nextCodePoint());for(;!k.eol();){const me=k.offset,Oe=b.getGraphemeBreakType(k.nextCodePoint());if(ke(ce,Oe)){k.setOffset(me);break}ce=Oe}return k.offset-Y}prevGraphemeLength(){const b=Te.getInstance(),k=this.c,Y=k.offset;let ce=b.getGraphemeBreakType(k.prevCodePoint());for(;k.offset>0;){const me=k.offset,Oe=b.getGraphemeBreakType(k.prevCodePoint());if(ke(Oe,ce)){k.setOffset(me);break}ce=Oe}return Y-k.offset}eol(){return this.c.eol()}}e.$Qf=Re;function pe(o,b){return new Re(o,b).nextGraphemeLength()}function fe(o,b){return new Re(o,b).prevGraphemeLength()}function ve(o,b){b>0&&J(o.charCodeAt(b))&&b--;const k=b+pe(o,b);return[k-fe(o,k),k]}function de(o){const b=new Re(o);let k=0;for(;!b.eol();)k++,b.nextGraphemeLength();return k}let ge;function m(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function R(o){return ge||(ge=m()),ge.test(o)}const U=/^[\t\n\r\x20-\x7E]*$/;function $(o){return U.test(o)}e.$Xf=/[\u2028\u2029]/;function r(o){return e.$Xf.test(o)}function E(o){return o>=11904&&o<=55215||o>=63744&&o<=64255||o>=65281&&o<=65374}function N(o){return o>=127462&&o<=127487||o===8986||o===8987||o===9200||o===9203||o>=9728&&o<=10175||o===11088||o===11093||o>=127744&&o<=128591||o>=128640&&o<=128764||o>=128992&&o<=129008||o>=129280&&o<=129535||o>=129648&&o<=129782}function z(o,b,k=""){const Y=o.trimStart();if(Y.length<b)return Y;const ce=/\b/g;let me=0;for(;ce.test(Y)&&!(Y.length-ce.lastIndex<b);)me=ce.lastIndex,ce.lastIndex+=1;return me===0?Y:k+Y.substring(me).trimStart()}const oe=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(o){let b=0;for(const k of o.matchAll(oe))b!==k.index&&(yield{isCode:!1,str:o.substring(b,k.index)}),yield{isCode:!0,str:k[0]},b=k.index+k[0].length;b!==o.length&&(yield{isCode:!1,str:o.substring(b)})}function ee(o){return o&&(o=o.replace(oe,"")),o}const C=/\\\[.*?\\\]/g;function ue(o){return ee(o).replace(C,"")}e.$6f=String.fromCharCode(t.CharCode.UTF8_BOM);function re(o){return!!(o&&o.length>0&&o.charCodeAt(0)===t.CharCode.UTF8_BOM)}function ae(o){return re(o)?o.substr(1):o}function he(o,b){if(!o||!b||o.length<b.length)return!1;const k=b.length,Y=o.toLowerCase();let ce=0,me=-1;for(;ce<k;){const Oe=Y.indexOf(b[ce],me+1);if(Oe<0)return!1;me=Oe,ce++}return!0}function Ae(o,b=!1){return o?(b&&(o=o.replace(/\\./g,"")),o.toLowerCase()!==o):!1}function Le(o){return o.charAt(0).toUpperCase()+o.slice(1)}function Ie(o,b=1){if(b===0)return"";let k=-1;do k=o.indexOf(`
`,k+1),b--;while(b>0&&k>=0);return k===-1?o:(o[k-1]==="\r"&&k--,o.substr(0,k))}function Me(o){const b=t.CharCode.Z-t.CharCode.A+1;return o=o%(2*b),o<b?String.fromCharCode(t.CharCode.a+o):String.fromCharCode(t.CharCode.A+o-b)}function Be(o){return Te.getInstance().getGraphemeBreakType(o)}function ke(o,b){return o===_e.Other?b!==_e.Extend&&b!==_e.SpacingMark:o===_e.CR&&b===_e.LF?!1:o===_e.Control||o===_e.CR||o===_e.LF||b===_e.Control||b===_e.CR||b===_e.LF?!0:!(o===_e.L&&(b===_e.L||b===_e.V||b===_e.LV||b===_e.LVT)||(o===_e.LV||o===_e.V)&&(b===_e.V||b===_e.T)||(o===_e.LVT||o===_e.T)&&b===_e.T||b===_e.Extend||b===_e.ZWJ||b===_e.SpacingMark||o===_e.Prepend||o===_e.ZWJ&&b===_e.Extended_Pictographic||o===_e.Regional_Indicator&&b===_e.Regional_Indicator)}var _e;(function(o){o[o.Other=0]="Other",o[o.Prepend=1]="Prepend",o[o.CR=2]="CR",o[o.LF=3]="LF",o[o.Control=4]="Control",o[o.Extend=5]="Extend",o[o.Regional_Indicator=6]="Regional_Indicator",o[o.SpacingMark=7]="SpacingMark",o[o.L=8]="L",o[o.V=9]="V",o[o.T=10]="T",o[o.LV=11]="LV",o[o.LVT=12]="LVT",o[o.ZWJ=13]="ZWJ",o[o.Extended_Pictographic=14]="Extended_Pictographic"})(_e||(e.GraphemeBreakType=_e={}));class Te{static getInstance(){return Te.c||(Te.c=new Te),Te.c}constructor(){this.d=Ge()}getGraphemeBreakType(b){if(b<32)return b===t.CharCode.LineFeed?_e.LF:b===t.CharCode.CarriageReturn?_e.CR:_e.Control;if(b<127)return _e.Other;const k=this.d,Y=k.length/3;let ce=1;for(;ce<=Y;)if(b<k[3*ce])ce=2*ce;else if(b>k[3*ce+1])ce=2*ce+1;else return k[3*ce+2];return _e.Other}}Te.c=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(o,b){if(o===0)return 0;const k=Ze(o,b);if(k!==void 0)return k;const Y=new ye(b,o);return Y.prevCodePoint(),Y.offset}function Ze(o,b){const k=new ye(b,o);let Y=k.prevCodePoint();for(;Je(Y)||Y===qe.emojiVariantSelector||Y===qe.enclosingKeyCap;){if(k.offset===0)return;Y=k.prevCodePoint()}if(!N(Y))return;let ce=k.offset;return ce>0&&k.prevCodePoint()===qe.zwj&&(ce=k.offset),ce}function Je(o){return 127995<=o&&o<=127999}var qe;(function(o){o[o.zwj=8205]="zwj",o[o.emojiVariantSelector=65039]="emojiVariantSelector",o[o.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$dg="\xA0";class ze{static getInstance(b){return ie.d.get(Array.from(b))}static getLocales(){return ie.e.value}constructor(b){this.f=b}isAmbiguous(b){return this.f.has(b)}containsAmbiguousCharacter(b){for(let k=0;k<b.length;k++){const Y=b.codePointAt(k);if(typeof Y=="number"&&this.isAmbiguous(Y))return!0}return!1}getPrimaryConfusable(b){return this.f.get(b)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=ze,ie=ze,ze.c=new A.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ze.d=new a.$af({getCacheKey:JSON.stringify},o=>{function b(Ue){const Se=new Map;for(let Ne=0;Ne<Ue.length;Ne+=2)Se.set(Ue[Ne],Ue[Ne+1]);return Se}function k(Ue,Se){const Ne=new Map(Ue);for(const[We,Ve]of Se)Ne.set(We,Ve);return Ne}function Y(Ue,Se){if(!Ue)return Se;const Ne=new Map;for(const[We,Ve]of Ue)Se.has(We)&&Ne.set(We,Ve);return Ne}const ce=ie.c.value;let me=o.filter(Ue=>!Ue.startsWith("_")&&Ue in ce);me.length===0&&(me=["_default"]);let Oe;for(const Ue of me){const Se=b(ce[Ue]);Oe=Y(Oe,Se)}const je=b(ce._common),Pe=k(je,Oe);return new ie(Pe)}),ze.e=new A.$X(()=>Object.keys(ie.c.value).filter(o=>!o.startsWith("_")));class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(b){return Fe.e().has(b)}static containsInvisibleCharacter(b){for(let k=0;k<b.length;k++){const Y=b.codePointAt(k);if(typeof Y=="number"&&Fe.isInvisibleCharacter(Y))return!0}return!1}static get codePoints(){return Fe.e()}}e.$fg=Fe,Fe.d=void 0}),define($e[6],Ee([0,1,4,3,2,7,30]),function(le,e,a,t,A,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=X,e.$zg=F,e.$Ag=p,e.$Bg=q,e.$Cg=x,e.$Dg=c,e.$Eg=g,e.$Fg=w,e.$Gg=M,e.$Hg=K,e.$Ig=ne,e.$Jg=L,e.$Kg=n,e.$Lg=i,e.$Mg=l,e.$Ng=_,e.$Og=d;function X(s){return s===a.CharCode.Slash||s===a.CharCode.Backslash}function F(s){return s.replace(/[\\/]/g,t.$jc.sep)}function p(s){return s.indexOf("/")===-1&&(s=F(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}function q(s,h=t.$jc.sep){if(!s)return"";const P=s.length,I=s.charCodeAt(0);if(X(I)){if(X(s.charCodeAt(1))&&!X(s.charCodeAt(2))){let B=3;const W=B;for(;B<P&&!X(s.charCodeAt(B));B++);if(W!==B&&!X(s.charCodeAt(B+1))){for(B+=1;B<P;B++)if(X(s.charCodeAt(B)))return s.slice(0,B+1).replace(/[\\/]/g,h)}}return h}else if(M(I)&&s.charCodeAt(1)===a.CharCode.Colon)return X(s.charCodeAt(2))?s.slice(0,2)+h:s.slice(0,2);let u=s.indexOf("://");if(u!==-1){for(u+=3;u<P;u++)if(X(s.charCodeAt(u)))return s.slice(0,u+1)}return""}function x(s){if(!A.$c||!s||s.length<5)return!1;let h=s.charCodeAt(0);if(h!==a.CharCode.Backslash||(h=s.charCodeAt(1),h!==a.CharCode.Backslash))return!1;let P=2;const I=P;for(;P<s.length&&(h=s.charCodeAt(P),h!==a.CharCode.Backslash);P++);return!(I===P||(h=s.charCodeAt(P+1),isNaN(h)||h===a.CharCode.Backslash))}const j=/[\\/:\*\?"<>\|]/g,te=/[/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,h=A.$c){const P=h?j:te;return!(!s||s.length===0||/^\s+$/.test(s)||(P.lastIndex=0,P.test(s))||h&&D.test(s)||s==="."||s===".."||h&&s[s.length-1]==="."||h&&s.length!==s.trim().length||s.length>255)}function g(s,h,P){const I=s===h;return!P||I?I:!s||!h?!1:(0,O.$Hf)(s,h)}function w(s,h,P,I=t.sep){if(s===h)return!0;if(!s||!h||h.length>s.length)return!1;if(P){if(!(0,O.$If)(s,h))return!1;if(h.length===s.length)return!0;let B=h.length;return h.charAt(h.length-1)===I&&B--,s.charAt(B)===I}return h.charAt(h.length-1)!==I&&(h+=I),s.indexOf(h)===0}function M(s){return s>=a.CharCode.A&&s<=a.CharCode.Z||s>=a.CharCode.a&&s<=a.CharCode.z}function K(s,h){return A.$c&&s.endsWith(":")&&(s+=t.sep),(0,t.$lc)(s)||(s=(0,t.$mc)(h,s)),s=(0,t.$kc)(s),ne(s)}function ne(s){return A.$c?(s=(0,O.$pf)(s,t.sep),s.endsWith(":")&&(s+=t.sep)):(s=(0,O.$pf)(s,t.sep),s||(s=t.sep)),s}function L(s){const h=(0,t.$kc)(s);return A.$c?s.length>3?!1:n(h)&&(s.length===2||h.charCodeAt(2)===a.CharCode.Backslash):h===t.$jc.sep}function n(s,h=A.$c){return h?M(s.charCodeAt(0))&&s.charCodeAt(1)===a.CharCode.Colon:!1}function i(s,h=A.$c){return n(s,h)?s[0]:void 0}function l(s,h,P){return h.length>s.length?-1:s===h?0:(P&&(s=s.toLowerCase(),h=h.toLowerCase()),s.indexOf(h))}function _(s){const h=s.split(":");let P,I,u;for(const B of h){const W=Number(B);(0,ie.$kg)(W)?I===void 0?I=W:u===void 0&&(u=W):P=P?[P,B].join(":"):B}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:I!==void 0?I:void 0,column:u!==void 0?u:I!==void 0?1:void 0}}const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function d(s,h,P=8){let I="";for(let B=0;B<P;B++){let W;B===0&&A.$c&&!h&&(P===3||P===4)?W=f:W=y,I+=W.charAt(Math.floor(Math.random()*W.length))}let u;return h?u=`${h}-${I}`:u=I,s?(0,t.$mc)(s,u):u}}),define($e[8],Ee([0,1,4,25,3,2]),function(le,e,a,t,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=g,e.$zc=n,A=De(A);const ie=/^\w[\w\d+.-]*$/,X=/^\//,F=/^\/\//;function p(f,d){if(!f.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!ie.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!X.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(F.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function q(f,d){return!f&&!d?"file":f}function x(f,d){switch(f){case"https":case"http":case"file":d?d[0]!==te&&(d=te+d):d=te;break}return d}const j="",te="/",D=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(d){return d instanceof c?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,s,h,P,I,u=!1){typeof d=="object"?(this.scheme=d.scheme||j,this.authority=d.authority||j,this.path=d.path||j,this.query=d.query||j,this.fragment=d.fragment||j):(this.scheme=q(d,u),this.authority=s||j,this.path=x(this.scheme,h||j),this.query=P||j,this.fragment=I||j,p(this,u))}get fsPath(){return n(this,!1)}with(d){if(!d)return this;let{scheme:s,authority:h,path:P,query:I,fragment:u}=d;return s===void 0?s=this.scheme:s===null&&(s=j),h===void 0?h=this.authority:h===null&&(h=j),P===void 0?P=this.path:P===null&&(P=j),I===void 0?I=this.query:I===null&&(I=j),u===void 0?u=this.fragment:u===null&&(u=j),s===this.scheme&&h===this.authority&&P===this.path&&I===this.query&&u===this.fragment?this:new M(s,h,P,I,u)}static parse(d,s=!1){const h=D.exec(d);return h?new M(h[2]||j,y(h[4]||j),y(h[5]||j),y(h[7]||j),y(h[9]||j),s):new M(j,j,j,j,j)}static file(d){let s=j;if(O.$c&&(d=d.replace(/\\/g,te)),d[0]===te&&d[1]===te){const h=d.indexOf(te,2);h===-1?(s=d.substring(2),d=te):(s=d.substring(2,h),d=d.substring(h)||te)}return new M("file",s,d,j,j)}static from(d,s){return new M(d.scheme,d.authority,d.path,d.query,d.fragment,s)}static joinPath(d,...s){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return O.$c&&d.scheme==="file"?h=c.file(A.$ic.join(n(d,!0),...s)).path:h=A.$jc.join(d.path,...s),d.with({path:h})}toString(d=!1){return i(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof c)return d;{const s=new M(d);return s._formatted=d.external??null,s._fsPath=d._sep===w?d.fsPath??null:null,s}}else return d}}e.URI=c;function g(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}const w=O.$c?1:void 0;class M extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(d=!1){return d?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const d={$mid:t.MarshalledId.Uri};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=w),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const K={[a.CharCode.Colon]:"%3A",[a.CharCode.Slash]:"%2F",[a.CharCode.QuestionMark]:"%3F",[a.CharCode.Hash]:"%23",[a.CharCode.OpenSquareBracket]:"%5B",[a.CharCode.CloseSquareBracket]:"%5D",[a.CharCode.AtSign]:"%40",[a.CharCode.ExclamationMark]:"%21",[a.CharCode.DollarSign]:"%24",[a.CharCode.Ampersand]:"%26",[a.CharCode.SingleQuote]:"%27",[a.CharCode.OpenParen]:"%28",[a.CharCode.CloseParen]:"%29",[a.CharCode.Asterisk]:"%2A",[a.CharCode.Plus]:"%2B",[a.CharCode.Comma]:"%2C",[a.CharCode.Semicolon]:"%3B",[a.CharCode.Equals]:"%3D",[a.CharCode.Space]:"%20"};function ne(f,d,s){let h,P=-1;for(let I=0;I<f.length;I++){const u=f.charCodeAt(I);if(u>=a.CharCode.a&&u<=a.CharCode.z||u>=a.CharCode.A&&u<=a.CharCode.Z||u>=a.CharCode.Digit0&&u<=a.CharCode.Digit9||u===a.CharCode.Dash||u===a.CharCode.Period||u===a.CharCode.Underline||u===a.CharCode.Tilde||d&&u===a.CharCode.Slash||s&&u===a.CharCode.OpenSquareBracket||s&&u===a.CharCode.CloseSquareBracket||s&&u===a.CharCode.Colon)P!==-1&&(h+=encodeURIComponent(f.substring(P,I)),P=-1),h!==void 0&&(h+=f.charAt(I));else{h===void 0&&(h=f.substr(0,I));const B=K[u];B!==void 0?(P!==-1&&(h+=encodeURIComponent(f.substring(P,I)),P=-1),h+=B):P===-1&&(P=I)}}return P!==-1&&(h+=encodeURIComponent(f.substring(P))),h!==void 0?h:f}function L(f){let d;for(let s=0;s<f.length;s++){const h=f.charCodeAt(s);h===a.CharCode.Hash||h===a.CharCode.QuestionMark?(d===void 0&&(d=f.substr(0,s)),d+=K[h]):d!==void 0&&(d+=f[s])}return d!==void 0?d:f}function n(f,d){let s;return f.authority&&f.path.length>1&&f.scheme==="file"?s=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===a.CharCode.Slash&&(f.path.charCodeAt(1)>=a.CharCode.A&&f.path.charCodeAt(1)<=a.CharCode.Z||f.path.charCodeAt(1)>=a.CharCode.a&&f.path.charCodeAt(1)<=a.CharCode.z)&&f.path.charCodeAt(2)===a.CharCode.Colon?d?s=f.path.substr(1):s=f.path[1].toLowerCase()+f.path.substr(2):s=f.path,O.$c&&(s=s.replace(/\//g,"\\")),s}function i(f,d){const s=d?L:ne;let h="",{scheme:P,authority:I,path:u,query:B,fragment:W}=f;if(P&&(h+=P,h+=":"),(I||P==="file")&&(h+=te,h+=te),I){let G=I.indexOf("@");if(G!==-1){const T=I.substr(0,G);I=I.substr(G+1),G=T.lastIndexOf(":"),G===-1?h+=s(T,!1,!1):(h+=s(T.substr(0,G),!1,!1),h+=":",h+=s(T.substr(G+1),!1,!0)),h+="@"}I=I.toLowerCase(),G=I.lastIndexOf(":"),G===-1?h+=s(I,!1,!0):(h+=s(I.substr(0,G),!1,!0),h+=I.substr(G))}if(u){if(u.length>=3&&u.charCodeAt(0)===a.CharCode.Slash&&u.charCodeAt(2)===a.CharCode.Colon){const G=u.charCodeAt(1);G>=a.CharCode.A&&G<=a.CharCode.Z&&(u=`/${String.fromCharCode(G+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===a.CharCode.Colon){const G=u.charCodeAt(0);G>=a.CharCode.A&&G<=a.CharCode.Z&&(u=`${String.fromCharCode(G+32)}:${u.substr(2)}`)}h+=s(u,!0,!1)}return B&&(h+="?",h+=s(B,!1,!1)),W&&(h+="#",h+=d?W:ne(W,!1,!1)),h}function l(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+l(f.substr(3)):f}}const _=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function y(f){return f.match(_)?f.replace(_,d=>l(d)):f}}),define($e[32],Ee([0,1,5,2,7,8,3]),function(le,e,a,t,A,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=F,e.$Qg=p,e.$Ug=x,a=De(a),t=De(t),ie=De(ie);var X;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeManagedRemoteResource="vscode-managed-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.vscodeChatCodeBlock="vscode-chat-code-block",D.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",D.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",D.vscodeChatSesssion="vscode-chat-editor",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls",D.vscodeSourceControl="vscode-scm",D.commentsInput="comment",D.codeSetting="code-setting"})(X||(e.Schemas=X={}));function F(D,c){return O.URI.isUri(D)?(0,A.$Hf)(D.scheme,c):(0,A.$If)(D,c+":")}function p(D,...c){return c.some(g=>F(D,g))}e.$Rg="vscode-tkn",e.$Sg="tkn";class q{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,g){this.f=x(c,g)}getServerRootPath(){return this.f}get g(){return ie.$jc.join(this.f,X.vscodeRemoteResource)}set(c,g,w){this.a[c]=g,this.b[c]=w}setConnectionToken(c,g){this.c[c]=g}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(L){return a.$3(L),c}const g=c.authority;let w=this.a[g];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const M=this.b[g],K=this.c[g];let ne=`path=${encodeURIComponent(c.path)}`;return typeof K=="string"&&(ne+=`&${e.$Sg}=${encodeURIComponent(K)}`),O.URI.from({scheme:t.$i?this.d:X.vscodeRemoteResource,authority:`${w}:${M}`,path:t.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:ne})}}e.$Tg=new q;function x(D,c){return ie.$jc.join(c??"/",`${D.quality??"oss"}-${D.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class j{asBrowserUri(c){const g=this.b(c,le);return this.uriToBrowserUri(g)}uriToBrowserUri(c){return c.scheme===X.vscodeRemote?e.$Tg.rewrite(c):c.scheme===X.file&&(t.$g||t.$k===`${X.vscodeFileResource}://${j.a}`)?c.with({scheme:X.vscodeFileResource,authority:c.authority||j.a,query:null,fragment:null}):c}asFileUri(c){const g=this.b(c,le);return this.uriToFileUri(g)}uriToFileUri(c){return c.scheme===X.vscodeFileResource?c.with({scheme:X.file,authority:c.authority!==j.a?c.authority:null,query:null,fragment:null}):c}b(c,g){return O.URI.isUri(c)?c:O.URI.parse(g.toUrl(c))}}j.a=e.$Zg,e.$1g=new j;var te;(function(D){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);D.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function w(K){let ne;typeof K=="string"?ne=new URL(K).searchParams:K instanceof URL?ne=K.searchParams:O.URI.isUri(K)&&(ne=new URL(K.toString(!0)).searchParams);const L=ne?.get(g);if(L)return c.get(L)}D.getHeadersFromQuery=w;function M(K,ne,L){if(!globalThis.crossOriginIsolated)return;const n=ne&&L?"3":L?"2":"1";K instanceof URLSearchParams?K.set(g,n):K[g]=n}D.addSearchParam=M})(te||(e.COI=te={}))}),define($e[17],Ee([0,1,4,6,32,3,2,7,8]),function(le,e,a,t,A,O,ie,X,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=p,e.$qh=x,e.$rh=te,t=De(t),O=De(O);function p(D){return(0,F.$zc)(D,!0)}class q{constructor(c){this.a=c}compare(c,g,w=!1){return c===g?0:(0,X.$Af)(this.getComparisonKey(c,w),this.getComparisonKey(g,w))}isEqual(c,g,w=!1){return c===g?!0:!c||!g?!1:this.getComparisonKey(c,w)===this.getComparisonKey(g,w)}getComparisonKey(c,g=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,g,w=!1){if(c.scheme===g.scheme){if(c.scheme===A.Schemas.file)return t.$Fg(p(c),p(g),this.a(c))&&c.query===g.query&&(w||c.fragment===g.fragment);if((0,e.$mh)(c.authority,g.authority))return t.$Fg(c.path,g.path,this.a(c),"/")&&c.query===g.query&&(w||c.fragment===g.fragment)}return!1}joinPath(c,...g){return F.URI.joinPath(c,...g)}basenameOrAuthority(c){return(0,e.$eh)(c)||c.authority}basename(c){return O.$jc.basename(c.path)}extname(c){return O.$jc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let g;return c.scheme===A.Schemas.file?g=F.URI.file(O.$pc(p(c))).path:(g=O.$jc.dirname(c.path),c.authority&&g.length&&g.charCodeAt(0)!==a.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),g="/")),c.with({path:g})}normalizePath(c){if(!c.path.length)return c;let g;return c.scheme===A.Schemas.file?g=F.URI.file(O.$kc(p(c))).path:g=O.$jc.normalize(c.path),c.with({path:g})}relativePath(c,g){if(c.scheme!==g.scheme||!(0,e.$mh)(c.authority,g.authority))return;if(c.scheme===A.Schemas.file){const K=O.$oc(p(c),p(g));return ie.$c?t.$zg(K):K}let w=c.path||"/";const M=g.path||"/";if(this.a(c)){let K=0;for(const ne=Math.min(w.length,M.length);K<ne&&!(w.charCodeAt(K)!==M.charCodeAt(K)&&w.charAt(K).toLowerCase()!==M.charAt(K).toLowerCase());K++);w=M.substr(0,K)+w.substr(K)}return O.$jc.relative(w,M)}resolvePath(c,g){if(c.scheme===A.Schemas.file){const w=F.URI.file(O.$nc(p(c),g));return c.with({authority:w.authority,path:w.path})}return g=t.$Ag(g),c.with({path:O.$jc.resolve(c.path,g)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,g){return c===g||c!==void 0&&g!==void 0&&(0,X.$Hf)(c,g)}hasTrailingPathSeparator(c,g=O.sep){if(c.scheme===A.Schemas.file){const w=p(c);return w.length>t.$Bg(w).length&&w[w.length-1]===g}else{const w=c.path;return w.length>1&&w.charCodeAt(w.length-1)===a.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,g=O.sep){return(0,e.$nh)(c,g)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,g=O.sep){let w=!1;if(c.scheme===A.Schemas.file){const M=p(c);w=M!==void 0&&M.length===t.$Bg(M).length&&M[M.length-1]===g}else{g="/";const M=c.path;w=M.length===1&&M.charCodeAt(M.length-1)===a.CharCode.Slash}return!w&&!(0,e.$nh)(c,g)?c.with({path:c.path+"/"}):c}}e.$9g=q,e.$0g=new q(()=>!1),e.$$g=new q(D=>D.scheme===A.Schemas.file?!ie.$e:!0),e.$_g=new q(D=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function x(D,c){const g=[];for(let w=0;w<D.length;w++){const M=c(D[w]);D.some((K,ne)=>ne===w?!1:(0,e.$bh)(M,c(K)))||g.push(D[w])}return g}var j;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function c(g){const w=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(ne=>{const[L,n]=ne.split(":");L&&n&&w.set(L,n)});const K=g.path.substring(0,g.path.indexOf(";"));return K&&w.set(D.META_DATA_MIME,K),w}D.parseMetaData=c})(j||(e.DataUri=j={}));function te(D,c,g){if(c){let w=D.path;return w&&w[0]!==O.$jc.sep&&(w=O.$jc.sep+w),D.with({scheme:g,authority:c,path:w})}return D.with({scheme:g})}}),define($e[9],Ee([0,1,16,5,15,13,17,2,29,11]),function(le,e,a,t,A,O,ie,X,F,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=q,e.$th=x,e.$uh=j,e.$vh=te,e.$wh=D,e.$xh=c,e.$yh=g,e.$zh=w,e.$Hh=f,e.$Ih=d,e.$Jh=s,e.$Kh=h,e.$Lh=P,e.$1h=Z,e.$9h=R;function q($){return!!$&&typeof $.then=="function"}function x($){const r=new a.$ye,E=$(r.token),N=new Promise((z,oe)=>{const we=r.token.onCancellationRequested(()=>{we.dispose(),oe(new t.$8)});Promise.resolve(E).then(ee=>{we.dispose(),r.dispose(),z(ee)},ee=>{we.dispose(),r.dispose(),oe(ee)})});return new class{cancel(){r.cancel(),r.dispose()}then(z,oe){return N.then(z,oe)}catch(z){return this.then(void 0,z)}finally(z){return N.finally(z)}}}function j($,r,E){return new Promise((N,z)=>{const oe=r.onCancellationRequested(()=>{oe.dispose(),N(E)});$.then(N,z).finally(()=>oe.dispose())})}function te($,r){return new Promise((E,N)=>{const z=r.onCancellationRequested(()=>{z.dispose(),N(new t.$8)});$.then(E,N).finally(()=>z.dispose())})}async function D($){let r=-1;const E=$.map((N,z)=>N.then(oe=>(r=z,oe)));try{return await Promise.race(E)}finally{$.forEach((N,z)=>{z!==r&&N.cancel()})}}function c($,r,E){let N;const z=setTimeout(()=>{N?.(void 0),E?.()},r);return Promise.race([$.finally(()=>clearTimeout(z)),new Promise(oe=>N=oe)])}function g($){return new Promise((r,E)=>{const N=$();q(N)?N.then(r,E):r(N)})}function w(){let $,r;return{promise:new Promise((N,z)=>{$=N,r=z}),resolve:$,reject:r}}class M{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(r){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=r,!this.b){const E=()=>{if(this.b=null,this.f)return;const N=this.queue(this.d);return this.d=null,N};this.b=new Promise(N=>{this.a.then(E,E).then(N)})}return new Promise((E,N)=>{this.b.then(E,N)})}return this.a=r(),new Promise((E,N)=>{this.a.then(z=>{this.a=null,E(z)},z=>{this.a=null,N(z)})})}dispose(){this.f=!0}}e.$Ah=M;class K{constructor(){this.a=Promise.resolve(null)}queue(r){return this.a=this.a.then(()=>r(),()=>r())}}e.$Bh=K;class ne{constructor(){this.a=new Map}queue(r,E){const z=(this.a.get(r)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(r)===z&&this.a.delete(r)});return this.a.set(r,z),z}}e.$Ch=ne;const L=($,r)=>{let E=!0;const N=setTimeout(()=>{E=!1,r()},$);return{isTriggered:()=>E,dispose:()=>{clearTimeout(N),E=!1}}},n=$=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,$())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class i{constructor(r){this.defaultDelay=r,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(r,E=this.defaultDelay){this.g=r,this.h(),this.b||(this.b=new Promise((z,oe)=>{this.d=z,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const N=()=>{this.a=null,this.d?.(null)};return this.a=E===F.$ie?n(N):L(E,N),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=i;class l{constructor(r){this.a=new i(r),this.b=new M}trigger(r,E){return this.a.trigger(()=>this.b.queue(r),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=l;class _{constructor(){this.a=!1,this.b=new Promise((r,E)=>{this.d=r})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=_;class y extends _{constructor(r){super(),this.f=setTimeout(()=>this.open(),r)}open(){clearTimeout(this.f),super.open()}}e.$Gh=y;function f($,r){return r?new Promise((E,N)=>{const z=setTimeout(()=>{oe.dispose(),E()},$),oe=r.onCancellationRequested(()=>{clearTimeout(z),oe.dispose(),N(new t.$8)})}):x(E=>f($,E))}function d($,r=0,E){const N=setTimeout(()=>{$(),E&&z.dispose()},r),z=(0,O.$Vc)(()=>{clearTimeout(N),E?.deleteAndLeak(z)});return E?.add(z),z}function s($){const r=[];let E=0;const N=$.length;function z(){return E<N?$[E++]():null}function oe(we){we!=null&&r.push(we);const ee=z();return ee?ee.then(oe):Promise.resolve(r)}return Promise.resolve(null).then(oe)}function h($,r=N=>!!N,E=null){let N=0;const z=$.length,oe=()=>{if(N>=z)return Promise.resolve(E);const we=$[N++];return Promise.resolve(we()).then(C=>r(C)?Promise.resolve(C):oe())};return oe()}function P($,r=N=>!!N,E=null){if($.length===0)return Promise.resolve(E);let N=$.length;const z=()=>{N=-1;for(const oe of $)oe.cancel?.()};return new Promise((oe,we)=>{for(const ee of $)ee.then(C=>{--N>=0&&r(C)?(z(),oe(C)):N===0&&oe(E)}).catch(C=>{--N>=0&&(z(),we(C))})})}class I{constructor(r){this.a=0,this.b=!1,this.f=r,this.g=[],this.d=0,this.h=new A.$ne}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(r){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((E,N)=>{this.g.push({factory:r,c:E,e:N}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const r=this.g.shift();this.d++;const E=r.factory();E.then(r.c,r.e),E.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=I;class u extends I{constructor(){super(1)}}e.$Nh=u;class B{constructor(){this.a=new se,this.b=0}queue(r){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,r())):this.a.run(this.b++,r())}}e.$Oh=B;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const r=new Re;return this.b.add(r),r.p}g(){for(const[,r]of this.a)if(r.size>0)return!1;return!0}queueSize(r,E=ie.$0g){const N=E.getComparisonKey(r);return this.a.get(N)?.size??0}queueFor(r,E,N=ie.$0g){const z=N.getComparisonKey(r);let oe=this.a.get(z);if(!oe){oe=new u;const we=this.f++,ee=A.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.a.delete(z),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$7c),this.d.set(we,ee),this.a.set(z,oe)}return oe.queue(E)}h(){this.g()&&this.j()}j(){for(const r of this.b)r.complete();this.b.clear()}dispose(){for(const[,r]of this.a)r.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=W;class G{constructor(r,E){this.b=!1,this.a=-1,typeof r=="function"&&typeof E=="number"&&this.setIfNotSet(r,E)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(r,E){if(this.b)throw new t.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,r()},E)}setIfNotSet(r,E){if(this.b)throw new t.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,r()},E))}}e.$Qh=G;class T{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(r,E,N=globalThis){if(this.f)throw new t.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const z=N.setInterval(()=>{r()},E);this.d=(0,O.$Vc)(()=>{N.clearInterval(z),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=T;class Q{constructor(r,E){this.b=-1,this.a=r,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(r=this.d){this.cancel(),this.b=setTimeout(this.f,r)}get delay(){return this.d}set delay(r){this.d=r}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=Q;class S{constructor(r,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=r,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(r=this.b){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(r/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=S;class v extends Q{constructor(r,E){super(r,E),this.j=[]}work(r){this.j.push(r),this.isScheduled()||this.schedule()}h(){const r=this.j;this.j=[],this.a?.(r)}dispose(){this.j=[],super.dispose()}}e.$Uh=v;class H extends O.$Xc{constructor(r,E){super(),this.g=r,this.h=E,this.a=[],this.b=this.B(new O.$Yc),this.f=!1}get pending(){return this.a.length}work(r){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+r.length>this.g.maxBufferedWork)return!1}else if(this.pending+r.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of r)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=($,r)=>{(0,X.$v)(()=>{if(E)return;const N=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let E=!1;return{dispose(){E||(E=!0)}}}:e.$Xh=($,r,E)=>{const N=$.requestIdleCallback(r,typeof E=="number"?{timeout:E}:void 0);let z=!1;return{dispose(){z||(z=!0,$.cancelIdleCallback(N))}}},e.$Wh=$=>(0,e.$Xh)(globalThis,$)}();class V{constructor(r,E){this.g=!1,this.d=()=>{try{this.j=E()}catch(N){this.l=N}finally{this.g=!0}},this.f=(0,e.$Xh)(r,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=V;class J extends V{constructor(r){super(globalThis,r)}}e.$Zh=J;async function Z($,r,E){let N;for(let z=0;z<E;z++)try{return await $()}catch(oe){N=oe,await f(r)}throw N}class se{isRunning(r){return typeof r=="number"?this.a?.taskId===r:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(r,E,N){return this.a={taskId:r,cancel:()=>N?.(),promise:E},E.then(()=>this.d(r),()=>this.d(r)),E}d(r){this.a&&r===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const r=this.b;this.b=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this.b)this.b.run=r;else{const{promise:E,resolve:N,reject:z}=w();this.b={run:r,promise:E,promiseResolve:N,promiseReject:z}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=se;class be{constructor(r,E=()=>Date.now()){this.d=r,this.f=E,this.a=0,this.b=0}increment(){const r=this.f();return r-this.a>this.d&&(this.a=r,this.b=0),this.b++,this.b}}e.$3h=be;var ye;(function($){$[$.Resolved=0]="Resolved",$[$.Rejected=1]="Rejected"})(ye||(ye={}));class Re{get isRejected(){return this.d?.outcome===ye.Rejected}get isResolved(){return this.d?.outcome===ye.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ye.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((r,E)=>{this.a=r,this.b=E})}complete(r){return new Promise(E=>{this.a(r),this.d={outcome:ye.Resolved,value:r},E()})}error(r){return new Promise(E=>{this.b(r),this.d={outcome:ye.Rejected,value:r},E()})}cancel(){return this.error(new t.$8)}}e.$4h=Re;var pe;(function($){async function r(N){let z;const oe=await Promise.all(N.map(we=>we.then(ee=>ee,ee=>{z||(z=ee)})));if(typeof z<"u")throw z;return oe}$.settled=r;function E(N){return new Promise(async(z,oe)=>{try{await N(z,oe)}catch(we){oe(we)}})}$.withAsyncBody=E})(pe||(e.Promises=pe={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(r){this.a=void 0,this.b=void 0,this.d=!1,this.promise=r.then(E=>(this.a=E,this.d=!0,E),E=>{throw this.b=E,this.d=!0,E})}requireValue(){if(!this.d)throw new t.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=fe;class ve{constructor(r){this.b=r,this.a=new p.$X(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=ve;var de;(function($){$[$.Initial=0]="Initial",$[$.DoneOK=1]="DoneOK",$[$.DoneError=2]="DoneError"})(de||(de={}));class ge{static fromArray(r){return new ge(E=>{E.emitMany(r)})}static fromPromise(r){return new ge(async E=>{E.emitMany(await r)})}static fromPromises(r){return new ge(async E=>{await Promise.all(r.map(async N=>E.emitOne(await N)))})}static merge(r){return new ge(async E=>{await Promise.all(r.map(async N=>{for await(const z of N)E.emitOne(z)}))})}constructor(r,E){this.a=de.Initial,this.b=[],this.d=null,this.f=E,this.g=new A.$ne,queueMicrotask(async()=>{const N={emitOne:z=>this.h(z),emitMany:z=>this.j(z),reject:z=>this.l(z)};try{await Promise.resolve(r(N)),this.k()}catch(z){this.l(z)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this.a===de.DoneError)throw this.d;if(r<this.b.length)return{done:!1,value:this.b[r++]};if(this.a===de.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(r,E){return new ge(async N=>{for await(const z of r)N.emitOne(E(z))})}map(r){return ge.map(this,r)}static filter(r,E){return new ge(async N=>{for await(const z of r)E(z)&&N.emitOne(z)})}filter(r){return ge.filter(this,r)}static coalesce(r){return ge.filter(r,E=>!!E)}coalesce(){return ge.coalesce(this)}static async toPromise(r){const E=[];for await(const N of r)E.push(N);return E}toPromise(){return ge.toPromise(this)}h(r){this.a===de.Initial&&(this.b.push(r),this.g.fire())}j(r){this.a===de.Initial&&(this.b=this.b.concat(r),this.g.fire())}k(){this.a===de.Initial&&(this.a=de.DoneOK,this.g.fire())}l(r){this.a===de.Initial&&(this.a=de.DoneError,this.d=r,this.g.fire())}}e.$7h=ge,ge.EMPTY=ge.fromArray([]);class m extends ge{constructor(r,E){super(E),this.m=r}cancel(){this.m.cancel()}}e.$8h=m;function R($){const r=new a.$ye,E=$(r.token);return new m(r,async N=>{const z=r.token.onCancellationRequested(()=>{z.dispose(),r.dispose(),N.reject(new t.$8)});try{for await(const oe of E){if(r.token.isCancellationRequested)return;N.emitOne(oe)}z.dispose(),r.dispose()}catch(oe){z.dispose(),r.dispose(),N.reject(oe)}})}class U{constructor(r){this.a=new Re,this.b=new ge(z=>{if(E){z.reject(E);return}return N&&z.emitMany(N),this.d=oe=>z.reject(oe),this.f=oe=>z.emitOne(oe),this.a.p},r);let E,N;this.f=z=>{N||(N=[]),N.push(z)},this.d=z=>{E||(E=z)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(r){this.d(r),this.a.complete()}emitOne(r){this.f(r)}}e.$0h=U}),define($e[33],Ee([0,1,18,19,40,9,6,26,3,2,17,8]),function(le,e,a,t,A,O,ie,X,F,p,q,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=K,e.whenDeleted=n,e.configureFlushOnWrite=f,e.writeFileSync=s,a=De(a);var j;(function(S){S[S.UNLINK=0]="UNLINK",S[S.MOVE=1]="MOVE"})(j||(e.RimRafMode=j={}));async function te(S,v=j.UNLINK,H){if((0,ie.$Jg)(S))throw new Error("rimraf - will refuse to recursively delete root");return v===j.UNLINK?c(S):D(S,H)}async function D(S,v=(0,ie.$Og)((0,t.tmpdir)())){try{try{await a.promises.rename(S,v)}catch(H){return H.code==="ENOENT"?void 0:c(S)}c(v).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function c(S){return a.promises.rm(S,{recursive:!0,force:!0,maxRetries:3})}function g(S){if((0,ie.$Jg)(S))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(S,{recursive:!0,force:!0,maxRetries:3})}async function w(S,v){return ne(await(v?M(S):a.promises.readdir(S)))}async function M(S){try{return await a.promises.readdir(S,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const v=[],H=await w(S);for(const V of H){let J=!1,Z=!1,se=!1;try{const be=await e.Promises.lstat((0,F.$mc)(S,V));J=be.isFile(),Z=be.isDirectory(),se=be.isSymbolicLink()}catch(be){console.warn("[node.js fs] unexpected error from lstat after readdir: ",be)}v.push({name:V,isFile:()=>J,isDirectory:()=>Z,isSymbolicLink:()=>se})}return v}function K(S){return ne(a.readdirSync(S))}function ne(S){return S.map(v=>typeof v=="string"?p.$d?(0,X.$nm)(v):v:(v.name=p.$d?(0,X.$nm)(v.name):v.name,v))}async function L(S){const v=await w(S),H=[];for(const V of v)await i.existsDirectory((0,F.$mc)(S,V))&&H.push(V);return H}function n(S,v=1e3){return new Promise(H=>{let V=!1;const J=setInterval(()=>{V||(V=!0,a.access(S,Z=>{V=!1,Z&&(clearInterval(J),H(void 0))}))},v)})}var i;(function(S){async function v(J){let Z;try{if(Z=await e.Promises.lstat(J),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(se){if(se.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(p.$c&&se.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(be){if(be.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw be}throw se}}S.stat=v;async function H(J){try{const{stat:Z,symbolicLink:se}=await S.stat(J);return Z.isFile()&&se?.dangling!==!0}catch{}return!1}S.existsFile=H;async function V(J){try{const{stat:Z,symbolicLink:se}=await S.stat(J);return Z.isDirectory()&&se?.dangling!==!0}catch{}return!1}S.existsDirectory=V})(i||(e.SymlinkSupport=i={}));const l=new O.$Ph;function _(S,v,H){return l.queueFor(x.URI.file(S),()=>{const V=h(H);return new Promise((J,Z)=>d(S,v,V,se=>se?Z(se):J()))},q.$$g)}let y=!0;function f(S){y=S}function d(S,v,H,V){if(!y)return a.writeFile(S,v,{mode:H.mode,flag:H.flag},V);a.open(S,H.flag,H.mode,(J,Z)=>{if(J)return V(J);a.writeFile(Z,v,se=>{if(se)return a.close(Z,()=>V(se));a.fdatasync(Z,be=>(be&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",be),f(!1)),a.close(Z,ye=>V(ye))))})})}function s(S,v,H){const V=h(H);if(!y)return a.writeFileSync(S,v,{mode:V.mode,flag:V.flag});const J=a.openSync(S,V.flag,V.mode);try{a.writeFileSync(J,v);try{a.fdatasyncSync(J)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),f(!1)}}finally{a.closeSync(J)}}function h(S){return S?{mode:typeof S.mode=="number"?S.mode:438,flag:typeof S.flag=="string"?S.flag:"w"}:{mode:438,flag:"w"}}async function P(S,v,H=6e4){if(S!==v)try{p.$c&&typeof H=="number"?await I(S,v,Date.now(),H):await a.promises.rename(S,v)}catch(V){if(S.toLowerCase()!==v.toLowerCase()&&V.code==="EXDEV"||S.endsWith("."))await u(S,v,{preserveSymlinks:!1}),await te(S,j.MOVE);else throw V}}async function I(S,v,H,V,J=0){try{return await a.promises.rename(S,v)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-H>=V)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${Z}`),Z;if(J===0){let se=!1;try{const{stat:be}=await i.stat(v);be.isFile()||(se=!0)}catch{}if(se)throw Z}return await(0,O.$Hh)(Math.min(100,J*10)),I(S,v,H,V,J+1)}}async function u(S,v,H){return W(S,v,{root:{source:S,target:v},options:H,handledSourcePaths:new Set})}const B=511;async function W(S,v,H){if(H.handledSourcePaths.has(S))return;H.handledSourcePaths.add(S);const{stat:V,symbolicLink:J}=await i.stat(S);if(J){if(H.options.preserveSymlinks)try{return await Q(S,v,H)}catch{}if(J.dangling)return}return V.isDirectory()?G(S,v,V.mode&B,H):T(S,v,V.mode&B)}async function G(S,v,H,V){await e.Promises.mkdir(v,{recursive:!0,mode:H});const J=await w(S);for(const Z of J)await W((0,F.$mc)(S,Z),(0,F.$mc)(v,Z),V)}async function T(S,v,H){await e.Promises.copyFile(S,v),await e.Promises.chmod(v,H)}async function Q(S,v,H){let V=await e.Promises.readlink(S);(0,ie.$Fg)(V,H.root.source,!p.$e)&&(V=(0,F.$mc)(H.root.target,V.substr(H.root.source.length+1))),await e.Promises.symlink(V,v)}e.Promises=new class{get access(){return a.promises.access}get stat(){return a.promises.stat}get lstat(){return a.promises.lstat}get utimes(){return a.promises.utimes}get read(){return(S,v,H,V,J)=>new Promise((Z,se)=>{a.read(S,v,H,V,J,(be,ye,Re)=>be?se(be):Z({bytesRead:ye,buffer:Re}))})}get readFile(){return a.promises.readFile}get write(){return(S,v,H,V,J)=>new Promise((Z,se)=>{a.write(S,v,H,V,J,(be,ye,Re)=>be?se(be):Z({bytesWritten:ye,buffer:Re}))})}get appendFile(){return a.promises.appendFile}get fdatasync(){return(0,A.promisify)(a.fdatasync)}get truncate(){return a.promises.truncate}get copyFile(){return a.promises.copyFile}get open(){return(0,A.promisify)(a.open)}get close(){return(0,A.promisify)(a.close)}get symlink(){return a.promises.symlink}get readlink(){return a.promises.readlink}get chmod(){return a.promises.chmod}get mkdir(){return a.promises.mkdir}get unlink(){return a.promises.unlink}get rmdir(){return a.promises.rmdir}get realpath(){return(0,A.promisify)(a.realpath)}async exists(S){try{return await e.Promises.access(S),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return L}get writeFile(){return _}get rm(){return te}get rename(){return P}get copy(){return u}}}),define($e[34],Ee([0,1,35,2]),function(le,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IX=F;const A={437:"cp437",850:"cp850",852:"cp852",855:"cp855",857:"cp857",860:"cp860",861:"cp861",863:"cp863",865:"cp865",866:"cp866",869:"cp869",936:"cp936",1252:"cp1252"};function O(p){const q=p.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return ie[q]||q}const ie={ibm866:"cp866",big5:"cp950"},X="utf8";async function F(p){let q;const x=process.env.VSCODE_CLI_ENCODING;x?(p&&console.log(`Found VSCODE_CLI_ENCODING variable: ${x}`),q=Promise.resolve(x)):t.$c?q=new Promise(te=>{p&&console.log('Running "chcp" to detect terminal encoding...'),(0,a.exec)("chcp",(D,c,g)=>{if(c){p&&console.log(`Output from "chcp" command is: ${c}`);const w=Object.keys(A);for(const M of w)if(c.indexOf(M)>=0)return te(A[M])}return te(void 0)})}):q=new Promise(te=>{p&&console.log('Running "locale charmap" to detect terminal encoding...'),(0,a.exec)("locale charmap",(D,c,g)=>te(c))});const j=await q;return p&&console.log(`Detected raw terminal encoding: ${j}`),!j||j.toLowerCase()==="utf-8"||j.toLowerCase()===X?X:O(j)}}),define($e[36],Ee([41,42]),function(le,e){return le.create("vs/platform/environment/node/argv",e)});var Ye=this&&this.__importDefault||function(le){return le&&le.__esModule?le:{default:le}};define($e[37],Ee([0,1,43,2,36]),function(le,e,a,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=X,e.$Em=p,e.$Fm=te,e.$Gm=D,a=Ye(a);const O={o:(0,A.localize)(0,null),e:(0,A.localize)(1,null),t:(0,A.localize)(2,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,A.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,A.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,A.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,A.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,A.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,A.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,A.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,A.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,A.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,A.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,A.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,A.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,A.localize)(15,null)},"stdin-to-clipboard":{type:"boolean",cat:"o",alias:"c",description:(0,A.localize)(16,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,A.localize)(17,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(18,null)},"show-versions":{type:"boolean",cat:"e",description:(0,A.localize)(19,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,A.localize)(20,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,A.localize)(21,null)},"pre-release":{type:"boolean",cat:"e",description:(0,A.localize)(22,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,A.localize)(23,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(24,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,A.localize)(25,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,A.localize)(26,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,A.localize)(27,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,A.localize)(28,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,A.localize)(29,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,A.localize)(30,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,A.localize)(31,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,A.localize)(32,null)},sync:{type:"string",cat:"t",description:(0,A.localize)(33,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,A.localize)(34,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,A.localize)(35,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,A.localize)(36,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,A.localize)(37,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,A.localize)(38,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,A.localize)(39,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const ie={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function X(c,g,w=ie){const M=c.find(f=>f.length>0&&f[0]!=="-"),K={},ne=["_"],L=[],n={};let i;for(const f in g){const d=g[f];d.type==="subcommand"?f===M&&(i=d):(d.alias&&(K[f]=d.alias),d.type==="string"||d.type==="string[]"?(ne.push(f),d.deprecates&&ne.push(...d.deprecates)):d.type==="boolean"&&(L.push(f),d.deprecates&&L.push(...d.deprecates)),d.global&&(n[f]=d))}if(i&&M){const f=n;for(const P in i.options)f[P]=i.options[P];const d=c.filter(P=>P!==M),s=w.getSubcommandReporter?w.getSubcommandReporter(M):void 0,h=X(d,f,s);return{[M]:h,_:[]}}const l=(0,a.default)(c,{string:ne,boolean:L,alias:K}),_={},y=l;_._=l._.map(f=>String(f)).filter(f=>f.length>0),delete y._;for(const f in g){const d=g[f];if(d.type==="subcommand")continue;d.alias&&delete y[d.alias];let s=y[f];if(d.deprecates)for(const h of d.deprecates)y.hasOwnProperty(h)&&(s||(s=y[h],s&&w.onDeprecatedOption(h,d.deprecationMessage||(0,A.localize)(40,null,f))),delete y[h]);if(typeof s<"u"){if(d.type==="string[]"){if(Array.isArray(s)||(s=[s]),!d.allowEmptyValue){const h=s.filter(P=>P.length>0);h.length!==s.length&&(w.onEmptyValue(f),s=h.length>0?h:void 0)}}else d.type==="string"&&(Array.isArray(s)?(s=s.pop(),w.onMultipleValues(f,s)):!s&&!d.allowEmptyValue&&(w.onEmptyValue(f),s=void 0));_[f]=s,d.deprecationMessage&&w.onDeprecatedOption(f,d.deprecationMessage)}delete y[f]}for(const f in y)w.onUnknownOption(f);return _}function F(c,g){let w="";return g.args&&(Array.isArray(g.args)?w=` <${g.args.join("> <")}>`:w=` <${g.args}>`),g.alias?`-${g.alias} --${c}${w}`:`--${c}${w}`}function p(c,g){const w=[];for(const M in c){const K=c[M],ne=F(M,K);w.push([ne,K.description])}return q(w,g)}function q(c,g){const M=c.reduce((L,n)=>Math.max(L,n[0].length),12)+2+1;if(g-M<25)return c.reduce((L,n)=>L.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const K=g-M-1,ne=[];for(const L of c){const n=L[0],i=j(L[1],K),l=x(M-n.length-2);ne.push("  "+n+l+i[0]);for(let _=1;_<i.length;_++)ne.push(x(M)+i[_])}return ne}function x(c){return" ".repeat(c)}function j(c,g){const w=[];for(;c.length;){const M=c.length<g?c.length:c.lastIndexOf(" ",g),K=c.slice(0,M).trim();c=c.slice(M),w.push(K)}return w}function te(c,g,w,M,K){const ne=process.stdout.isTTY&&process.stdout.columns||80,L=K?.noInputFiles!==!0?`[${(0,A.localize)(41,null)}...]`:"",n=[`${c} ${w}`];n.push(""),n.push(`${(0,A.localize)(42,null)}: ${g} [${(0,A.localize)(43,null)}]${L}`),n.push(""),K?.noPipe!==!0&&(t.$c?n.push((0,A.localize)(44,null,g)):n.push((0,A.localize)(45,null,g)),n.push(""));const i={},l=[];for(const _ in M){const y=M[_];if(y.type==="subcommand")y.description&&l.push({command:_,description:y.description});else if(y.description&&y.cat){let f=i[y.cat];f||(i[y.cat]=f={}),f[_]=y}}for(const _ in i){const y=_,f=i[y];f&&(n.push(O[y]),n.push(...p(f,ne)),n.push(""))}return l.length&&(n.push((0,A.localize)(46,null)),n.push(...q(l.map(_=>[_.command,_.description]),ne)),n.push("")),n.join(`
`)}function D(c,g){return`${c||(0,A.localize)(47,null)}
${g||(0,A.localize)(48,null)}
${process.arch}`}}),define($e[38],Ee([0,1,19,9,6,33,34]),function(le,e,a,t,A,O,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=X,e.$ihc=F,e.$jhc=p,e.$khc=q;function X(){try{return!process.stdin.isTTY}catch{}return!1}function F(x){return new Promise(j=>{const te=()=>j(!0);setTimeout(()=>{process.stdin.removeListener("data",te),j(!1)},x),process.stdin.once("data",te)})}function p(){return(0,A.$Og)((0,a.tmpdir)(),"code-stdin",3)}async function q(x,j,te){let[D,c]=await Promise.all([(0,ie.$IX)(j),new Promise((M,K)=>{le(["@vscode/iconv-lite-umd"],M,K)}).then(De),O.Promises.appendFile(x,"")]);c.encodingExists(D)||(console.log(`Unsupported terminal encoding: ${D}, falling back to UTF-8.`),D="utf8");const g=new t.$Nh,w=c.getDecoder(D);process.stdin.on("data",M=>{const K=w.write(M);g.queue(()=>O.Promises.appendFile(x,K))}),process.stdin.on("end",()=>{const M=w.end();g.queue(async()=>{try{typeof M=="string"&&await O.Promises.appendFile(x,M)}finally{te?.()}})})}}),define($e[39],Ee([0,1,18,19,6]),function(le,e,a,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=O;function O(ie){const X=(0,A.$Og)((0,t.tmpdir)());try{return(0,a.writeFileSync)(X,""),ie&&console.log(`Marker file for --wait created: ${X}`),X}catch(F){ie&&console.error(`Failed to create marker file for --wait: ${F}`);return}}}),define($e[44],Ee([0,1,18,45,35,46,14,3,37,39,38,9]),function(le,e,a,t,A,O,ie,X,F,p,q,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=K,a=De(a),t=De(t),A=De(A),O=De(O);const j=W=>{switch(W){case"user-data-dir":case"extensions-dir":case"export-default-configuration":case"install-source":case"enable-smoke-test-driver":case"extensions-download-dir":case"builtin-extensions-dir":case"telemetry":return!1;default:return!0}},te=W=>{switch(W){case"version":case"help":case"folder-uri":case"file-uri":case"add":case"diff":case"merge":case"wait":case"goto":case"reuse-window":case"new-window":case"status":case"install-extension":case"uninstall-extension":case"update-extensions":case"list-extensions":case"force":case"show-versions":case"category":case"verbose":case"remote":case"locate-shell-integration-path":case"stdin-to-clipboard":return!0;default:return!1}},D=process.env.VSCODE_IPC_HOOK_CLI,c=process.env.VSCODE_CLIENT_COMMAND,g=process.env.VSCODE_CLIENT_COMMAND_CWD,w=process.env.VSCODE_CLI_AUTHORITY,M=process.env.VSCODE_STDIN_FILE_PATH;async function K(W,G){if(!D&&!c){console.log("Command is only available in WSL or inside a Visual Studio Code terminal.");return}const T={...F.$Cm,gitCredential:{type:"string"},openExternal:{type:"boolean"}},Q=c?j:te;for(const fe in F.$Cm){const ve=fe;Q(ve)||delete T[ve]}D&&(T.openExternal={type:"boolean"});const S={onMultipleValues:(fe,ve)=>{console.error(`Option '${fe}' can only be defined once. Using value ${ve}.`)},onEmptyValue:fe=>{console.error(`Ignoring option '${fe}': Value must not be empty.`)},onUnknownOption:fe=>{console.error(`Ignoring option '${fe}': not supported for ${W.executableName}.`)},onDeprecatedOption:(fe,ve)=>{console.warn(`Option '${fe}' is deprecated: ${ve}`)}},v=(0,F.$Dm)(G,T,S),H=w?s:fe=>fe,V=!!v.verbose;if(v.help){console.log((0,F.$Fm)(W.productName,W.executableName,W.version,T));return}if(v.version){console.log((0,F.$Gm)(W.version,W.commit));return}if(v["locate-shell-integration-path"]){let fe;switch(v["locate-shell-integration-path"]){case"bash":fe="shellIntegration-bash.sh";break;case"pwsh":fe="shellIntegration.ps1";break;case"zsh":fe="shellIntegration-rc.zsh";break;case"fish":fe="fish_xdg_data/fish/vendor_conf.d/shellIntegration.fish";break;default:throw new Error("Error using --locate-shell-integration-path: Invalid shell type")}console.log((0,X.$nc)(__dirname,"../..","workbench","contrib","terminal","browser","media",fe));return}if(D&&v.openExternal){n(v._,V);return}let J=v.remote;(J==="local"||J==="false"||J==="")&&(J=null);const Z=(v["folder-uri"]||[]).map(H);v["folder-uri"]=Z;const se=(v["file-uri"]||[]).map(H);v["file-uri"]=se;const be=v._;let ye=!1;for(const fe of be)fe==="-"?ye=!0:d(fe,H,Z,se);v._=[];let Re;if(ye&&(0,q.$hhc)())try{let fe=M;if(!fe){fe=(0,q.$jhc)();const ve=new x.$4h;await(0,q.$khc)(fe,V,()=>ve.complete()),v.wait||(Re=ve.p)}d(fe,H,Z,se),v["skip-add-to-recently-opened"]=!0,console.log(`Reading from stdin via: ${fe}`)}catch(fe){console.log(`Failed to create file to read via stdin: ${fe.toString()}`)}v.extensionDevelopmentPath&&(v.extensionDevelopmentPath=v.extensionDevelopmentPath.map(fe=>H(f(fe).href))),v.extensionTestsPath&&(v.extensionTestsPath=H(f(v.extensionTestsPath).href));const pe=v["crash-reporter-directory"];if(pe!==void 0&&!pe.match(/^([a-zA-Z]:[\\\/])/)){console.log(`The crash reporter directory '${pe}' must be an absolute Windows path (e.g. c:/crashes)`);return}if(c){if(v["install-extension"]!==void 0||v["uninstall-extension"]!==void 0||v["list-extensions"]||v["update-extensions"]){const de=[];v["install-extension"]?.forEach(m=>de.push("--install-extension",m)),v["uninstall-extension"]?.forEach(m=>de.push("--uninstall-extension",m)),["list-extensions","force","show-versions","category"].forEach(m=>{const R=v[m];R!==void 0&&de.push(`--${m}=${R}`)}),v["update-extensions"]&&de.push("--update-extensions"),A.fork((0,X.$mc)(__dirname,"../../../server-main.js"),de,{stdio:"inherit"}).on("error",m=>console.log(m));return}const fe=[];for(const de in v){const ge=v[de];if(typeof ge=="boolean")ge&&fe.push("--"+de);else if(Array.isArray(ge))for(const m of ge)fe.push(`--${de}=${m.toString()}`);else ge&&fe.push(`--${de}=${ge.toString()}`)}J!==null&&fe.push(`--remote=${J||w}`);const ve=(0,X.$rc)(c);if(ve===".bat"||ve===".cmd"){const de=g||(0,ie.cwd)();V&&console.log(`Invoking: cmd.exe /C ${c} ${fe.join(" ")} in ${de}`),A.spawn("cmd.exe",["/C",c,...fe],{stdio:"inherit",cwd:de})}else{const de=(0,X.$pc)(c),ge={...process.env,ELECTRON_RUN_AS_NODE:"1"};if(fe.unshift("resources/app/out/cli.js"),V&&console.log(`Invoking: cd "${de}" && ELECTRON_RUN_AS_NODE=1 "${c}" "${fe.join('" "')}"`),ne()){V&&console.log("Using pipes for output.");const m=A.spawn(c,fe,{cwd:de,env:ge,stdio:["inherit","pipe","pipe"]});m.stdout.on("data",R=>process.stdout.write(R)),m.stderr.on("data",R=>process.stderr.write(R))}else A.spawn(c,fe,{cwd:de,env:ge,stdio:"inherit"})}}else{if(v["stdin-to-clipboard"]){if(!(0,q.$hhc)()){console.error("stdin has a tty.");return}const ge=le("fs").readFileSync(0).toString();i({type:"clipboard",content:ge},V).catch(m=>{console.error("Error when requesting status:",m)});return}if(v.status){i({type:"status"},V).then(ve=>{console.log(ve)}).catch(ve=>{console.error("Error when requesting status:",ve)});return}if(v["install-extension"]!==void 0||v["uninstall-extension"]!==void 0||v["list-extensions"]||v["update-extensions"]){i({type:"extensionManagement",list:v["list-extensions"]?{showVersions:v["show-versions"],category:v.category}:void 0,install:l(v["install-extension"]),uninstall:l(v["uninstall-extension"]),force:v.force},V).then(ve=>{console.log(ve)}).catch(ve=>{console.error("Error when invoking the extension management command:",ve)});return}let fe;if(v.wait){if(!se.length){console.log("At least one file must be provided to wait for.");return}fe=(0,p.$Ygc)(V)}i({type:"open",fileURIs:se,folderURIs:Z,diffMode:v.diff,mergeMode:v.merge,addMode:v.add,gotoLineMode:v.goto,forceReuseWindow:v["reuse-window"],forceNewWindow:v["new-window"],waitMarkerFilePath:fe,remoteAuthority:J},V).catch(ve=>{console.error("Error when invoking the open command:",ve)}),fe&&L(fe),Re&&await Re}}function ne(){if(process.env.WSL_DISTRO_NAME)try{return A.execSync("uname -r",{encoding:"utf8"}).includes("-microsoft-")}catch{}return!1}async function L(W){for(;a.existsSync(W);)await new Promise(G=>setTimeout(G,1e3))}function n(W,G){const T=[];for(const Q of W)try{/^(http|https|file):\/\//.test(Q)?T.push(t.parse(Q).href):T.push(f(Q).href)}catch{console.log(`Invalid url: ${Q}`)}T.length&&i({type:"openExternal",uris:T},G).catch(Q=>{console.error("Error when invoking the open external command:",Q)})}function i(W,G){return G&&console.log(JSON.stringify(W,null,"  ")),new Promise((T,Q)=>{const S=JSON.stringify(W);if(!D){console.log("Message "+S),T("");return}const v={socketPath:D,path:"/",method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},H=O.request(v,V=>{if(V.headers["content-type"]!=="application/json"){Q("Error in response: Invalid content type: Expected 'application/json', is: "+V.headers["content-type"]);return}const J=[];V.setEncoding("utf8"),V.on("data",Z=>{J.push(Z)}),V.on("error",Z=>_("Error in response.",Z)),V.on("end",()=>{const Z=J.join("");try{const se=JSON.parse(Z);V.statusCode===200?T(se):Q(se)}catch{Q("Error in response: Unable to parse response as JSON: "+Z)}})});H.on("error",V=>_("Error in request.",V)),H.write(S),H.end()})}function l(W){return W?.map(G=>/\.vsix$/i.test(G)?f(G).href:G)}function _(W,G){console.error("Unable to connect to VS Code server: "+W),console.error(G),process.exit(1)}const y=process.env.PWD||(0,ie.cwd)();function f(W){return W=W.trim(),W=(0,X.$nc)(y,W),t.pathToFileURL(W)}function d(W,G,T,Q){const S=f(W),v=G(S.href);try{const H=a.lstatSync(a.realpathSync(W));H.isFile()?Q.push(v):H.isDirectory()?T.push(v):W==="/dev/null"&&Q.push(v)}catch(H){H.code==="ENOENT"?Q.push(v):console.log(`Problem accessing file ${W}. Ignoring file`,H)}}function s(W){return W.replace(/^file:\/\//,"vscode-remote://"+w)}const[,,h,P,I,u,...B]=process.argv;K({productName:h,version:P,commit:I,executableName:u},B).then(null,W=>{console.error(W.message||W.stack||W)})})}).call(this);

//# sourceMappingURL=server.cli.js.map
