"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","os","vs/base/common/process","fs","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/charCode","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/iterator","vs/platform/telemetry/common/telemetryUtils","vs/platform/contextkey/common/contextkey","vs/base/common/json","vs/base/common/performance","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stopwatch","vs/base/common/marshalling","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/files/common/watcher","vs/platform/terminal/common/terminal","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uriIpc","child_process","vs/base/parts/ipc/common/ipc.net","vs/platform/product/common/product","vs/base/common/semver/semver","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/mime","vs/base/common/processes","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/themables","vs/base/common/glob","path","net","vs/editor/common/core/position","vs/base/node/zip","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/storage/common/storage","vs/server/node/remoteLanguagePacks","vs/server/node/serverConnectionToken","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/uint","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/encodedTokenAttributes","vs/platform/environment/node/environmentService","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/terminal/common/remote/terminal","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/config/editorOptions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/chat/common/languageModels","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","@microsoft/1ds-core-js","vs/server/node/server.main"],ke=function(se){for(var e=[],n=0,r=se.length;n<r;n++)e[n]=Se[se[n]];return e};define(Se[105],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var n;(function(E){E[E.LoaderAvailable=1]="LoaderAvailable",E[E.BeginLoadingScript=10]="BeginLoadingScript",E[E.EndLoadingScriptOK=11]="EndLoadingScriptOK",E[E.EndLoadingScriptError=12]="EndLoadingScriptError",E[E.BeginInvokeFactory=21]="BeginInvokeFactory",E[E.EndInvokeFactory=22]="EndInvokeFactory",E[E.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",E[E.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",E[E.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",E[E.NodeEndNativeRequire=34]="NodeEndNativeRequire",E[E.CachedDataFound=60]="CachedDataFound",E[E.CachedDataMissed=61]="CachedDataMissed",E[E.CachedDataRejected=62]="CachedDataRejected",E[E.CachedDataCreated=63]="CachedDataCreated"})(n||(e.LoaderEventType=n={}));class r{static get(){const I=new Map,R=new Map,A=new Map,y=new Map;function o(a,h){a.has(h.detail)||a.set(h.detail,-h.timestamp)}function S(a,h){const m=a.get(h.detail);m&&(m>=0||a.set(h.detail,m+h.timestamp))}let v=[];typeof se=="function"&&typeof se.getStats=="function"&&(v=se.getStats().slice(0).sort((a,h)=>a.timestamp-h.timestamp));for(const a of v)switch(a.type){case n.BeginLoadingScript:o(I,a);break;case n.EndLoadingScriptOK:case n.EndLoadingScriptError:S(I,a);break;case n.BeginInvokeFactory:o(R,a);break;case n.EndInvokeFactory:S(R,a);break;case n.NodeBeginNativeRequire:o(A,a);break;case n.NodeEndNativeRequire:S(A,a);break;case n.NodeBeginEvaluatingScript:o(y,a);break;case n.NodeEndEvaluatingScript:S(y,a);break}let f=0;A.forEach(a=>f+=a);function w(a){const h=[];return a.forEach((m,$)=>h.push([$,m])),h}return{amdLoad:w(I),amdInvoke:w(R),nodeRequire:w(A),nodeEval:w(y),nodeRequireTotal:f}}static toMarkdownTable(I,R){let A="";const y=[];return I.forEach((o,S)=>{y[S]=o.length}),R.forEach(o=>{o.forEach((S,v)=>{typeof S>"u"&&(S=o[v]="-");const f=S.toString().length;y[v]=Math.max(f,y[v])})}),I.forEach((o,S)=>{A+=`| ${o+" ".repeat(y[S]-o.toString().length)} `}),A+=`|
`,I.forEach((o,S)=>{A+=`| ${"-".repeat(y[S])} `}),A+=`|
`,R.forEach(o=>{o.forEach((S,v)=>{typeof S<"u"&&(A+=`| ${S+" ".repeat(y[v]-S.toString().length)} `)}),A+=`|
`}),A}}e.$W=r}),define(Se[106],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=n,e.$jb=r,e.$kb=E,e.$lb=I,e.$mb=R,e.$nb=A,e.$ob=y,e.$qb=S,e.$rb=v,e.$sb=f,e.$tb=w,e.$ub=a;function n(h,m){const $=r(h,m);if($!==-1)return h[$]}function r(h,m,$=h.length-1){for(let p=$;p>=0;p--){const d=h[p];if(m(d))return p}return-1}function E(h,m){const $=I(h,m);return $===-1?void 0:h[$]}function I(h,m,$=0,p=h.length){let d=$,b=p;for(;d<b;){const t=Math.floor((d+b)/2);m(h[t])?d=t+1:b=t}return d-1}function R(h,m){const $=A(h,m);return $===h.length?void 0:h[$]}function A(h,m,$=0,p=h.length){let d=$,b=p;for(;d<b;){const t=Math.floor((d+b)/2);m(h[t])?b=t:d=t+1}return d}function y(h,m,$=0,p=h.length){const d=A(h,m,$,p);return d===h.length?-1:d}class o{constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(o.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!m(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const $=I(this.e,m,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$pb=o,o.assertInvariants=!1;function S(h,m){if(h.length===0)return;let $=h[0];for(let p=1;p<h.length;p++){const d=h[p];m(d,$)>0&&($=d)}return $}function v(h,m){if(h.length===0)return;let $=h[0];for(let p=1;p<h.length;p++){const d=h[p];m(d,$)>=0&&($=d)}return $}function f(h,m){return S(h,($,p)=>-m($,p))}function w(h,m){if(h.length===0)return-1;let $=0;for(let p=1;p<h.length;p++){const d=h[p];m(d,h[$])>0&&($=p)}return $}function a(h,m){for(const $ of h){const p=m($);if(p!==void 0)return p}}}),define(Se[35],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(Se[157],ke([1,0]),function(se,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$I=void 0,e.$E=r,e.$F=E,e.$G=I,e.$H=R;function r(y,o){const S=Object.create(null);for(const v of y){const f=o(v);let w=S[f];w||(w=S[f]=[]),w.push(v)}return S}function E(y,o){const S=[],v=[];for(const f of y)o.has(f)||S.push(f);for(const f of o)y.has(f)||v.push(f);return{removed:S,added:v}}function I(y,o){const S=[],v=[];for(const[f,w]of y)o.has(f)||S.push(w);for(const[f,w]of o)y.has(f)||v.push(w);return{removed:S,added:v}}function R(y,o){const S=new Set;for(const v of o)y.has(v)&&S.add(v);return S}class A{constructor(o,S){this.b=S,this.a=new Map,this[n]="SetWithKey";for(const v of o)this.add(v)}get size(){return this.a.size}add(o){const S=this.b(o);return this.a.set(S,o),this}delete(o){return this.a.delete(this.b(o))}has(o){return this.a.has(this.b(o))}*entries(){for(const o of this.a.values())yield[o,o]}keys(){return this.values()}*values(){for(const o of this.a.values())yield o}clear(){this.a.clear()}forEach(o,S){this.a.forEach(v=>o.call(S,v,v,this))}[Symbol.iterator](){return this.values()}}e.$I=A,n=Symbol.toStringTag}),define(Se[78],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=r,e.$_h=E,e.$ai=I;function n(R){return(A,y,o)=>{let S=null,v=null;if(typeof o.value=="function"?(S="value",v=o.value):typeof o.get=="function"&&(S="get",v=o.get),!v)throw new Error("not supported");o[S]=R(v,y)}}function r(R,A,y){let o=null,S=null;if(typeof y.value=="function"?(o="value",S=y.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(o="get",S=y.get),!S)throw new Error("not supported");const v=`$memoize$${A}`;y[o]=function(...f){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,f)}),this[v]}}function E(R,A,y){return n((o,S)=>{const v=`$debounce$${S}`,f=`$debounce$result$${S}`;return function(...w){this[f]||(this[f]=y?y():void 0),clearTimeout(this[v]),A&&(this[f]=A(this[f],...w),w=[this[f]]),this[v]=setTimeout(()=>{o.apply(this,w),this[f]=y?y():void 0},R)}})}function I(R,A,y){return n((o,S)=>{const v=`$throttle$timer$${S}`,f=`$throttle$result$${S}`,w=`$throttle$lastRun$${S}`,a=`$throttle$pending$${S}`;return function(...h){if(this[f]||(this[f]=y?y():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),A&&(this[f]=A(this[f],...h)),this[a])return;const m=this[w]+R;m<=Date.now()?(this[w]=Date.now(),o.apply(this,[this[f]]),this[f]=y?y():void 0):(this[a]=!0,this[v]=setTimeout(()=>{this[a]=!1,this[w]=Date.now(),o.apply(this,[this[f]]),this[f]=y?y():void 0},m-Date.now()))}})}}),define(Se[10],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=r,e.$2=E,e.$3=I,e.$4=R,e.$5=A,e.$6=y,e.$7=S,e.$9=f,e.$0=w,e.$$=a,e.$ab=m;class n{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?b.isErrorNoTelemetry(i)?new b(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(g=>{g(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$Y=n,e.$Z=new n;function r(l){e.$Z.setUnexpectedErrorHandler(l)}function E(l){if(!l||typeof l!="object")return!1;const i=l;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function I(l){S(l)||e.$Z.onUnexpectedError(l)}function R(l){S(l)||e.$Z.onUnexpectedExternalError(l)}function A(l){if(l instanceof Error){const{name:i,message:g}=l,s=l.stacktrace||l.stack;return{$isError:!0,name:i,message:g,stack:s,noTelemetry:b.isErrorNoTelemetry(l)}}return l}function y(l){let i;return l.noTelemetry?i=new b:(i=new Error,i.name=l.name),i.message=l.message,i.stack=l.stack,i}const o="Canceled";function S(l){return l instanceof v?!0:l instanceof Error&&l.name===o&&l.message===o}class v extends Error{constructor(){super(o),this.name=this.message}}e.$8=v;function f(){const l=new Error(o);return l.name=l.message,l}function w(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function a(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class h extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=h;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class $ extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$bb=$;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$cb=p;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=d;class b extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof b)return i;const g=new b;return g.message=i.message,g.stack=i.stack,g}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$eb=b;class t extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$fb=t}),define(Se[18],ke([1,0,10,106]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=E,e.$wb=I,e.$xb=R,e.$yb=A,e.$zb=y,e.$Ab=o,e.$Bb=S,e.$Cb=v,e.$Db=f,e.$Eb=w,e.$Fb=a,e.$Gb=h,e.$Hb=m,e.top=$,e.$Jb=p,e.$Kb=b,e.$Lb=t,e.$Mb=l,e.$Nb=i,e.$Ob=g,e.$Pb=s,e.$Qb=c,e.$Rb=u,e.$Sb=D,e.$Tb=P,e.$Ub=T,e.$Vb=z,e.$Wb=C,e.$Xb=k,e.$Yb=q,e.$Zb=Y,e.$1b=J,e.$2b=ne,e.$3b=Z,e.$4b=x,e.$5b=le,e.$6b=K,e.$7b=ae,e.$8b=M,e.$9b=ce,e.$0b=pe,e.$ac=_;function E(V,j=0){return V[V.length-(1+j)]}function I(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}function R(V,j,G=(Q,N)=>Q===N){if(V===j)return!0;if(!V||!j||V.length!==j.length)return!1;for(let Q=0,N=V.length;Q<N;Q++)if(!G(V[Q],j[Q]))return!1;return!0}function A(V,j){const G=V.length-1;j<G&&(V[j]=V[G]),V.pop()}function y(V,j,G){return o(V.length,Q=>G(V[Q],j))}function o(V,j){let G=0,Q=V-1;for(;G<=Q;){const N=(G+Q)/2|0,H=j(N);if(H<0)G=N+1;else if(H>0)Q=N-1;else return N}return-(G+1)}function S(V,j,G){if(V=V|0,V>=j.length)throw new TypeError("invalid index");const Q=j[Math.floor(j.length*Math.random())],N=[],H=[],oe=[];for(const fe of j){const Ee=G(fe,Q);Ee<0?N.push(fe):Ee>0?H.push(fe):oe.push(fe)}return V<N.length?S(V,N,G):V<N.length+oe.length?oe[0]:S(V-(N.length+oe.length),H,G)}function v(V,j){const G=[];let Q;for(const N of V.slice(0).sort(j))!Q||j(Q[0],N)!==0?(Q=[N],G.push(Q)):Q.push(N);return G}function*f(V,j){let G,Q;for(const N of V)Q!==void 0&&j(Q,N)?G.push(N):(G&&(yield G),G=[N]),Q=N;G&&(yield G)}function w(V,j){for(let G=0;G<=V.length;G++)j(G===0?void 0:V[G-1],G===V.length?void 0:V[G])}function a(V,j){for(let G=0;G<V.length;G++)j(G===0?void 0:V[G-1],V[G],G+1===V.length?void 0:V[G+1])}function h(V,j,G){const Q=[];function N(fe,Ee,Ne){if(Ee===0&&Ne.length===0)return;const de=Q[Q.length-1];de&&de.start+de.deleteCount===fe?(de.deleteCount+=Ee,de.toInsert.push(...Ne)):Q.push({start:fe,deleteCount:Ee,toInsert:Ne})}let H=0,oe=0;for(;;){if(H===V.length){N(H,0,j.slice(oe));break}if(oe===j.length){N(H,V.length-H,[]);break}const fe=V[H],Ee=j[oe],Ne=G(fe,Ee);Ne===0?(H+=1,oe+=1):Ne<0?(N(H,1,[]),H+=1):Ne>0&&(N(H,0,[Ee]),oe+=1)}return Q}function m(V,j,G){const Q=h(V,j,G),N=[],H=[];for(const oe of Q)N.push(...V.slice(oe.start,oe.start+oe.deleteCount)),H.push(...oe.toInsert);return{removed:N,added:H}}function $(V,j,G){if(G===0)return[];const Q=V.slice(0,G).sort(j);return d(V,j,Q,G,V.length),Q}function p(V,j,G,Q,N){return G===0?Promise.resolve([]):new Promise((H,oe)=>{(async()=>{const fe=V.length,Ee=V.slice(0,G).sort(j);for(let Ne=G,de=Math.min(G+Q,fe);Ne<fe;Ne=de,de=Math.min(de+Q,fe)){if(Ne>G&&await new Promise($e=>setTimeout($e)),N&&N.isCancellationRequested)throw new n.$8;d(V,j,Ee,Ne,de)}return Ee})().then(H,oe)})}function d(V,j,G,Q,N){for(const H=G.length;Q<N;Q++){const oe=V[Q];if(j(oe,G[H-1])<0){G.pop();const fe=(0,r.$nb)(G,Ee=>j(oe,Ee)<0);G.splice(fe,0,oe)}}}function b(V){return V.filter(j=>!!j)}function t(V){let j=0;for(let G=0;G<V.length;G++)V[G]&&(V[j]=V[G],j+=1);V.length=j}function l(V,j,G){V.splice(G,0,V.splice(j,1)[0])}function i(V){return!Array.isArray(V)||V.length===0}function g(V){return Array.isArray(V)&&V.length>0}function s(V,j=G=>G){const G=new Set;return V.filter(Q=>{const N=j(Q);return G.has(N)?!1:(G.add(N),!0)})}function c(V){const j=new Set;return G=>{const Q=V(G);return j.has(Q)?!1:(j.add(Q),!0)}}function u(V,j){return V.length>0?V[0]:j}function D(V,j){return V.length>0?V[V.length-1]:j}function P(V,j,G=(Q,N)=>Q===N){let Q=0;for(let N=0,H=Math.min(V.length,j.length);N<H&&G(V[N],j[N]);N++)Q++;return Q}function T(V,j){let G=typeof j=="number"?V:0;typeof j=="number"?G=V:(G=0,j=V);const Q=[];if(G<=j)for(let N=G;N<j;N++)Q.push(N);else for(let N=G;N>j;N--)Q.push(N);return Q}function z(V,j,G){return V.reduce((Q,N)=>(Q[j(N)]=G?G(N):N,Q),Object.create(null))}function C(V,j){return V.push(j),()=>k(V,j)}function k(V,j){const G=V.indexOf(j);if(G>-1)return V.splice(G,1),j}function q(V,j,G){const Q=V.slice(0,j),N=V.slice(j);return Q.concat(G,N)}function Y(V,j){let G;if(typeof j=="number"){let Q=j;G=()=>{const N=Math.sin(Q++)*179426549;return N-Math.floor(N)}}else G=Math.random;for(let Q=V.length-1;Q>0;Q-=1){const N=Math.floor(G()*(Q+1)),H=V[Q];V[Q]=V[N],V[N]=H}}function J(V,j){const G=V.indexOf(j);G>-1&&(V.splice(G,1),V.unshift(j))}function ne(V,j){const G=V.indexOf(j);G>-1&&(V.splice(G,1),V.push(j))}function Z(V,j){for(const G of j)V.push(G)}function x(V,j){return Array.isArray(V)?V.map(j):j(V)}function le(V){return Array.isArray(V)?V:[V]}function K(V){return V[Math.floor(Math.random()*V.length)]}function ae(V,j,G){const Q=B(V,j),N=V.length,H=G.length;V.length=N+H;for(let oe=N-1;oe>=Q;oe--)V[oe+H]=V[oe];for(let oe=0;oe<H;oe++)V[oe+Q]=G[oe]}function M(V,j,G,Q){const N=B(V,j);let H=V.splice(N,G);return H===void 0&&(H=[]),ae(V,N,Q),H}function B(V,j){return j<0?Math.max(j+V.length,0):Math.min(j,V.length)}var re;(function(V){function j(H){return H<0}V.isLessThan=j;function G(H){return H<=0}V.isLessThanOrEqual=G;function Q(H){return H>0}V.isGreaterThan=Q;function N(H){return H===0}V.isNeitherLessOrGreaterThan=N,V.greaterThan=1,V.lessThan=-1,V.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function ce(V,j){return(G,Q)=>j(V(G),V(Q))}function pe(...V){return(j,G)=>{for(const Q of V){const N=Q(j,G);if(!re.isNeitherLessOrGreaterThan(N))return N}return re.neitherLessOrGreaterThan}}const W=(V,j)=>V-j;e.$$b=W;const ue=(V,j)=>(0,e.$$b)(V?1:0,j?1:0);e.$_b=ue;function _(V){return(j,G)=>-V(j,G)}class U{constructor(j){this.g=j,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(j){let G=this.c;for(;G<this.g.length&&j(this.g[G]);)G++;const Q=G===this.c?null:this.g.slice(this.c,G);return this.c=G,Q}takeFromEndWhile(j){let G=this.d;for(;G>=0&&j(this.g[G]);)G--;const Q=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const j=this.g[this.c];return this.c++,j}removeLast(){const j=this.g[this.d];return this.d--,j}takeCount(j){const G=this.g.slice(this.c,this.c+j);return this.c+=j,G}}e.$bc=U;class O{constructor(j){this.iterate=j}forEach(j){this.iterate(G=>(j(G),!0))}toArray(){const j=[];return this.iterate(G=>(j.push(G),!0)),j}filter(j){return new O(G=>this.iterate(Q=>j(Q)?G(Q):!0))}map(j){return new O(G=>this.iterate(Q=>G(j(Q))))}some(j){let G=!1;return this.iterate(Q=>(G=j(Q),!G)),G}findFirst(j){let G;return this.iterate(Q=>j(Q)?(G=Q,!1):!0),G}findLast(j){let G;return this.iterate(Q=>(j(Q)&&(G=Q),!0)),G}findLastMaxBy(j){let G,Q=!0;return this.iterate(N=>((Q||re.isGreaterThan(j(N,G)))&&(Q=!1,G=N),!0)),G}}e.$cc=O,O.empty=new O(V=>{});class te{constructor(j){this.c=j}static createSortPermutation(j,G){const Q=Array.from(j.keys()).sort((N,H)=>G(j[N],j[H]));return new te(Q)}apply(j){return j.map((G,Q)=>j[this.c[Q]])}inverse(){const j=this.c.slice();for(let G=0;G<this.c.length;G++)j[this.c[G]]=G;return new te(j)}}e.$dc=te}),define(Se[107],ke([1,0,10]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$hd=E,e.$id=I,e.$jd=R,e.$kd=A,e.$ld=y;function r(o,S){if(!o)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function E(o,S="Unreachable"){throw new Error(S)}function I(o,S="unexpected state"){if(!o)throw new n.$fb(`Assertion Failed: ${S}`)}function R(o){o||(0,n.$3)(new n.$fb("Soft Assertion Failed"))}function A(o){if(!o()){debugger;o(),(0,n.$3)(new n.$fb("Assertion Failed"))}}function y(o,S){let v=0;for(;v<o.length-1;){const f=o[v],w=o[v+1];if(!S(f,w))return!1;v++}return!0}});var ji=this&&this.__createBinding||(Object.create?function(se,e,n,r){r===void 0&&(r=n);var E=Object.getOwnPropertyDescriptor(e,n);(!E||("get"in E?!e.__esModule:E.writable||E.configurable))&&(E={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(se,r,E)}:function(se,e,n,r){r===void 0&&(r=n),se[r]=e[n]}),Mi=this&&this.__setModuleDefault||(Object.create?function(se,e){Object.defineProperty(se,"default",{enumerable:!0,value:e})}:function(se,e){se.default=e}),Be=this&&this.__importStar||function(se){if(se&&se.__esModule)return se;var e={};if(se!=null)for(var n in se)n!=="default"&&Object.prototype.hasOwnProperty.call(se,n)&&ji(e,se,n);return Mi(e,se),e};define(Se[158],ke([1,0,18]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=E,e.$$c=I,e.$_c=R,e.$ad=A,e.$bd=y,e.$cd=o,n=Be(n);const r=(w,a)=>w===a;e.$9c=r;function E(w=e.$9c){return(a,h)=>n.$xb(a,h,w)}function I(){return(w,a)=>JSON.stringify(w)===JSON.stringify(a)}function R(){return(w,a)=>w.equals(a)}function A(w,a,h){if(h!==void 0){const m=w;return m==null||a===void 0||a===null?a===m:h(m,a)}else{const m=w;return($,p)=>$==null||p===void 0||p===null?p===$:m($,p)}}function y(w,a){if(w===a)return!0;if(Array.isArray(w)&&Array.isArray(a)){if(w.length!==a.length)return!1;for(let h=0;h<w.length;h++)if(!y(w[h],a[h]))return!1;return!0}if(w&&typeof w=="object"&&a&&typeof a=="object"&&Object.getPrototypeOf(w)===Object.prototype&&Object.getPrototypeOf(a)===Object.prototype){const h=w,m=a,$=Object.keys(h),p=Object.keys(m),d=new Set(p);if($.length!==p.length)return!1;for(const b of $)if(!d.has(b)||!y(h[b],m[b]))return!1;return!0}return!1}function o(w){return JSON.stringify(f(w))}let S=0;const v=new WeakMap;function f(w){if(Array.isArray(w))return w.map(f);if(w&&typeof w=="object")if(Object.getPrototypeOf(w)===Object.prototype){const a=w,h=Object.create(null);for(const m of Object.keys(a).sort())h[m]=f(a[m]);return h}else{let a=v.get(w);return a===void 0&&(a=S++,v.set(w,a)),a+"----2b76a038c20c4bcc"}return w}}),define(Se[79],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=n;function n(r,E){const I=this;let R=!1,A;return function(){if(R)return A;if(R=!0,E)try{A=r.apply(I,arguments)}finally{E()}else A=r.apply(I,arguments);return A}}}),define(Se[40],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function E(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}r.is=E;const I=Object.freeze([]);function R(){return I}r.empty=R;function*A(i){yield i}r.single=A;function y(i){return E(i)?i:A(i)}r.wrap=y;function o(i){return i||I}r.from=o;function*S(i){for(let g=i.length-1;g>=0;g--)yield i[g]}r.reverse=S;function v(i){return!i||i[Symbol.iterator]().next().done===!0}r.isEmpty=v;function f(i){return i[Symbol.iterator]().next().value}r.first=f;function w(i,g){let s=0;for(const c of i)if(g(c,s++))return!0;return!1}r.some=w;function a(i,g){for(const s of i)if(g(s))return s}r.find=a;function*h(i,g){for(const s of i)g(s)&&(yield s)}r.filter=h;function*m(i,g){let s=0;for(const c of i)yield g(c,s++)}r.map=m;function*$(i,g){let s=0;for(const c of i)yield*g(c,s++)}r.flatMap=$;function*p(...i){for(const g of i)yield*g}r.concat=p;function d(i,g,s){let c=s;for(const u of i)c=g(c,u);return c}r.reduce=d;function*b(i,g,s=i.length){for(g<0&&(g+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);g<s;g++)yield i[g]}r.slice=b;function t(i,g=Number.POSITIVE_INFINITY){const s=[];if(g===0)return[s,i];const c=i[Symbol.iterator]();for(let u=0;u<g;u++){const D=c.next();if(D.done)return[s,r.empty()];s.push(D.value)}return[s,{[Symbol.iterator](){return c}}]}r.consume=t;async function l(i){const g=[];for await(const s of i)g.push(s);return Promise.resolve(g)}r.asyncToArray=l})(n||(e.Iterable=n={}))}),define(Se[43],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Xn=R,e.$Yn=v,e.$Zn=f,e.$1n=w,e.$2n=a,e.$3n=h,e.$4n=m,e.$5n=$,e.$6n=p,e.$7n=d,e.$8n=b;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var E;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function R(t,l=!1){let i=0;const g=t.length;let s="",c=0,u=r.Unknown,D=n.None;function P(J){let ne=0,Z=0;for(;ne<J;){const x=t.charCodeAt(i);if(x>=S._0&&x<=S._9)Z=Z*16+x-S._0;else if(x>=S.A&&x<=S.F)Z=Z*16+x-S.A+10;else if(x>=S.a&&x<=S.f)Z=Z*16+x-S.a+10;else break;i++,ne++}return ne<J&&(Z=-1),Z}function T(J){i=J,s="",c=0,u=r.Unknown,D=n.None}function z(){const J=i;if(t.charCodeAt(i)===S._0)i++;else for(i++;i<t.length&&o(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===S.dot)if(i++,i<t.length&&o(t.charCodeAt(i)))for(i++;i<t.length&&o(t.charCodeAt(i));)i++;else return D=n.UnexpectedEndOfNumber,t.substring(J,i);let ne=i;if(i<t.length&&(t.charCodeAt(i)===S.E||t.charCodeAt(i)===S.e))if(i++,(i<t.length&&t.charCodeAt(i)===S.plus||t.charCodeAt(i)===S.minus)&&i++,i<t.length&&o(t.charCodeAt(i))){for(i++;i<t.length&&o(t.charCodeAt(i));)i++;ne=i}else D=n.UnexpectedEndOfNumber;return t.substring(J,ne)}function C(){let J="",ne=i;for(;;){if(i>=g){J+=t.substring(ne,i),D=n.UnexpectedEndOfString;break}const Z=t.charCodeAt(i);if(Z===S.doubleQuote){J+=t.substring(ne,i),i++;break}if(Z===S.backslash){if(J+=t.substring(ne,i),i++,i>=g){D=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case S.doubleQuote:J+='"';break;case S.backslash:J+="\\";break;case S.slash:J+="/";break;case S.b:J+="\b";break;case S.f:J+="\f";break;case S.n:J+=`
`;break;case S.r:J+="\r";break;case S.t:J+="	";break;case S.u:{const le=P(4);le>=0?J+=String.fromCharCode(le):D=n.InvalidUnicode;break}default:D=n.InvalidEscapeCharacter}ne=i;continue}if(Z>=0&&Z<=31)if(y(Z)){J+=t.substring(ne,i),D=n.UnexpectedEndOfString;break}else D=n.InvalidCharacter;i++}return J}function k(){if(s="",D=n.None,c=i,i>=g)return c=g,u=r.EOF;let J=t.charCodeAt(i);if(A(J)){do i++,s+=String.fromCharCode(J),J=t.charCodeAt(i);while(A(J));return u=r.Trivia}if(y(J))return i++,s+=String.fromCharCode(J),J===S.carriageReturn&&t.charCodeAt(i)===S.lineFeed&&(i++,s+=`
`),u=r.LineBreakTrivia;switch(J){case S.openBrace:return i++,u=r.OpenBraceToken;case S.closeBrace:return i++,u=r.CloseBraceToken;case S.openBracket:return i++,u=r.OpenBracketToken;case S.closeBracket:return i++,u=r.CloseBracketToken;case S.colon:return i++,u=r.ColonToken;case S.comma:return i++,u=r.CommaToken;case S.doubleQuote:return i++,s=C(),u=r.StringLiteral;case S.slash:{const ne=i-1;if(t.charCodeAt(i+1)===S.slash){for(i+=2;i<g&&!y(t.charCodeAt(i));)i++;return s=t.substring(ne,i),u=r.LineCommentTrivia}if(t.charCodeAt(i+1)===S.asterisk){i+=2;const Z=g-1;let x=!1;for(;i<Z;){if(t.charCodeAt(i)===S.asterisk&&t.charCodeAt(i+1)===S.slash){i+=2,x=!0;break}i++}return x||(i++,D=n.UnexpectedEndOfComment),s=t.substring(ne,i),u=r.BlockCommentTrivia}return s+=String.fromCharCode(J),i++,u=r.Unknown}case S.minus:if(s+=String.fromCharCode(J),i++,i===g||!o(t.charCodeAt(i)))return u=r.Unknown;case S._0:case S._1:case S._2:case S._3:case S._4:case S._5:case S._6:case S._7:case S._8:case S._9:return s+=z(),u=r.NumericLiteral;default:for(;i<g&&q(J);)i++,J=t.charCodeAt(i);if(c!==i){switch(s=t.substring(c,i),s){case"true":return u=r.TrueKeyword;case"false":return u=r.FalseKeyword;case"null":return u=r.NullKeyword}return u=r.Unknown}return s+=String.fromCharCode(J),i++,u=r.Unknown}}function q(J){if(A(J)||y(J))return!1;switch(J){case S.closeBrace:case S.closeBracket:case S.openBrace:case S.openBracket:case S.doubleQuote:case S.colon:case S.comma:case S.slash:return!1}return!0}function Y(){let J;do J=k();while(J>=r.LineCommentTrivia&&J<=r.Trivia);return J}return{setPosition:T,getPosition:()=>i,scan:l?Y:k,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>D}}function A(t){return t===S.space||t===S.tab||t===S.verticalTab||t===S.formFeed||t===S.nonBreakingSpace||t===S.ogham||t>=S.enQuad&&t<=S.zeroWidthSpace||t===S.narrowNoBreakSpace||t===S.mathematicalSpace||t===S.ideographicSpace||t===S.byteOrderMark}function y(t){return t===S.lineFeed||t===S.carriageReturn||t===S.lineSeparator||t===S.paragraphSeparator}function o(t){return t>=S._0&&t<=S._9}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function v(t,l){const i=[],g=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function D(P,T,z,C){c.value=P,c.offset=T,c.length=z,c.type=C,c.colonOffset=void 0,s=c}try{d(t,{onObjectBegin:(P,T)=>{if(l<=P)throw g;s=void 0,u=l>P,i.push("")},onObjectProperty:(P,T,z)=>{if(l<T||(D(P,T,z,"property"),i[i.length-1]=P,l<=T+z))throw g},onObjectEnd:(P,T)=>{if(l<=P)throw g;s=void 0,i.pop()},onArrayBegin:(P,T)=>{if(l<=P)throw g;s=void 0,i.push(0)},onArrayEnd:(P,T)=>{if(l<=P)throw g;s=void 0,i.pop()},onLiteralValue:(P,T,z)=>{if(l<T||(D(P,T,z,b(P)),l<=T+z))throw g},onSeparator:(P,T,z)=>{if(l<=T)throw g;if(P===":"&&s&&s.type==="property")s.colonOffset=T,u=!1,s=void 0;else if(P===","){const C=i[i.length-1];typeof C=="number"?i[i.length-1]=C+1:(u=!0,i[i.length-1]=""),s=void 0}}})}catch(P){if(P!==g)throw P}return{path:i,previousNode:s,isAtPropertyKey:u,matches:P=>{let T=0;for(let z=0;T<P.length&&z<i.length;z++)if(P[T]===i[z]||P[T]==="*")T++;else if(P[T]!=="**")return!1;return T===P.length}}}function f(t,l=[],i=I.DEFAULT){let g=null,s=[];const c=[];function u(P){Array.isArray(s)?s.push(P):g!==null&&(s[g]=P)}return d(t,{onObjectBegin:()=>{const P={};u(P),c.push(s),s=P,g=null},onObjectProperty:P=>{g=P},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const P=[];u(P),c.push(s),s=P,g=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:u,onError:(P,T,z)=>{l.push({error:P,offset:T,length:z})}},i),s[0]}function w(t,l=[],i=I.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(P){g.type==="property"&&(g.length=P-g.offset,g=g.parent)}function c(P){return g.children.push(P),P}d(t,{onObjectBegin:P=>{g=c({type:"object",offset:P,length:-1,parent:g,children:[]})},onObjectProperty:(P,T,z)=>{g=c({type:"property",offset:T,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:P,offset:T,length:z,parent:g})},onObjectEnd:(P,T)=>{g.length=P+T-g.offset,g=g.parent,s(P+T)},onArrayBegin:(P,T)=>{g=c({type:"array",offset:P,length:-1,parent:g,children:[]})},onArrayEnd:(P,T)=>{g.length=P+T-g.offset,g=g.parent,s(P+T)},onLiteralValue:(P,T,z)=>{c({type:b(P),offset:T,length:z,parent:g,value:P}),s(T+z)},onSeparator:(P,T,z)=>{g.type==="property"&&(P===":"?g.colonOffset=T:P===","&&s(T))},onError:(P,T,z)=>{l.push({error:P,offset:T,length:z})}},i);const D=g.children[0];return D&&delete D.parent,D}function a(t,l){if(!t)return;let i=t;for(const g of l)if(typeof g=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===g){i=c.children[1],s=!0;break}if(!s)return}else{const s=g;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function h(t){if(!t.parent||!t.parent.children)return[];const l=h(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;l.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&l.push(i)}return l}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const l=Object.create(null);for(const i of t.children){const g=i.children[1];g&&(l[i.children[0].value]=m(g))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,l,i=!1){return l>=t.offset&&l<t.offset+t.length||i&&l===t.offset+t.length}function p(t,l,i=!1){if($(t,l,i)){const g=t.children;if(Array.isArray(g))for(let s=0;s<g.length&&g[s].offset<=l;s++){const c=p(g[s],l,i);if(c)return c}return t}}function d(t,l,i=I.DEFAULT){const g=R(t,!1);function s(ce){return ce?()=>ce(g.getTokenOffset(),g.getTokenLength()):()=>!0}function c(ce){return ce?pe=>ce(pe,g.getTokenOffset(),g.getTokenLength()):()=>!0}const u=s(l.onObjectBegin),D=c(l.onObjectProperty),P=s(l.onObjectEnd),T=s(l.onArrayBegin),z=s(l.onArrayEnd),C=c(l.onLiteralValue),k=c(l.onSeparator),q=s(l.onComment),Y=c(l.onError),J=i&&i.disallowComments,ne=i&&i.allowTrailingComma;function Z(){for(;;){const ce=g.scan();switch(g.getTokenError()){case n.InvalidUnicode:x(E.InvalidUnicode);break;case n.InvalidEscapeCharacter:x(E.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:x(E.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:J||x(E.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:x(E.UnexpectedEndOfString);break;case n.InvalidCharacter:x(E.InvalidCharacter);break}switch(ce){case r.LineCommentTrivia:case r.BlockCommentTrivia:J?x(E.InvalidCommentToken):q();break;case r.Unknown:x(E.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return ce}}}function x(ce,pe=[],W=[]){if(Y(ce),pe.length+W.length>0){let ue=g.getToken();for(;ue!==r.EOF;){if(pe.indexOf(ue)!==-1){Z();break}else if(W.indexOf(ue)!==-1)break;ue=Z()}}}function le(ce){const pe=g.getTokenValue();return ce?C(pe):D(pe),Z(),!0}function K(){switch(g.getToken()){case r.NumericLiteral:{let ce=0;try{ce=JSON.parse(g.getTokenValue()),typeof ce!="number"&&(x(E.InvalidNumberFormat),ce=0)}catch{x(E.InvalidNumberFormat)}C(ce);break}case r.NullKeyword:C(null);break;case r.TrueKeyword:C(!0);break;case r.FalseKeyword:C(!1);break;default:return!1}return Z(),!0}function ae(){return g.getToken()!==r.StringLiteral?(x(E.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(le(!1),g.getToken()===r.ColonToken?(k(":"),Z(),re()||x(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):x(E.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function M(){u(),Z();let ce=!1;for(;g.getToken()!==r.CloseBraceToken&&g.getToken()!==r.EOF;){if(g.getToken()===r.CommaToken){if(ce||x(E.ValueExpected,[],[]),k(","),Z(),g.getToken()===r.CloseBraceToken&&ne)break}else ce&&x(E.CommaExpected,[],[]);ae()||x(E.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),ce=!0}return P(),g.getToken()!==r.CloseBraceToken?x(E.CloseBraceExpected,[r.CloseBraceToken],[]):Z(),!0}function B(){T(),Z();let ce=!1;for(;g.getToken()!==r.CloseBracketToken&&g.getToken()!==r.EOF;){if(g.getToken()===r.CommaToken){if(ce||x(E.ValueExpected,[],[]),k(","),Z(),g.getToken()===r.CloseBracketToken&&ne)break}else ce&&x(E.CommaExpected,[],[]);re()||x(E.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),ce=!0}return z(),g.getToken()!==r.CloseBracketToken?x(E.CloseBracketExpected,[r.CloseBracketToken],[]):Z(),!0}function re(){switch(g.getToken()){case r.OpenBracketToken:return B();case r.OpenBraceToken:return M();case r.StringLiteral:return le(!0);default:return K()}}return Z(),g.getToken()===r.EOF?i.allowEmptyContent?!0:(x(E.ValueExpected,[],[]),!1):re()?(g.getToken()!==r.EOF&&x(E.EndOfFileExpected,[],[]),!0):(x(E.ValueExpected,[],[]),!1)}function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Se[159],ke([1,0,43]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=r,e.$0n=E,e.$$n=A,e.$_n=y;function r(o,S,v){let f,w,a,h,m;if(S){for(h=S.offset,m=h+S.length,a=h;a>0&&!y(o,a-1);)a--;let D=m;for(;D<o.length&&!y(o,D);)D++;w=o.substring(a,D),f=R(w,v)}else w=o,f=0,a=0,h=0,m=o.length;const $=A(v,o);let p=!1,d=0,b;v.insertSpaces?b=I(" ",v.tabSize||4):b="	";const t=(0,n.$Xn)(w,!1);let l=!1;function i(){return $+I(b,f+d)}function g(){let D=t.scan();for(p=!1;D===n.SyntaxKind.Trivia||D===n.SyntaxKind.LineBreakTrivia;)p=p||D===n.SyntaxKind.LineBreakTrivia,D=t.scan();return l=D===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,D}const s=[];function c(D,P,T){!l&&P<m&&T>h&&o.substring(P,T)!==D&&s.push({offset:P,length:T-P,content:D})}let u=g();if(u!==n.SyntaxKind.EOF){const D=t.getTokenOffset()+a,P=I(b,f);c(P,a,D)}for(;u!==n.SyntaxKind.EOF;){let D=t.getTokenOffset()+t.getTokenLength()+a,P=g(),T="";for(;!p&&(P===n.SyntaxKind.LineCommentTrivia||P===n.SyntaxKind.BlockCommentTrivia);){const C=t.getTokenOffset()+a;c(" ",D,C),D=t.getTokenOffset()+t.getTokenLength()+a,T=P===n.SyntaxKind.LineCommentTrivia?i():"",P=g()}if(P===n.SyntaxKind.CloseBraceToken)u!==n.SyntaxKind.OpenBraceToken&&(d--,T=i());else if(P===n.SyntaxKind.CloseBracketToken)u!==n.SyntaxKind.OpenBracketToken&&(d--,T=i());else{switch(u){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:d++,T=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:T=i();break;case n.SyntaxKind.BlockCommentTrivia:p?T=i():T=" ";break;case n.SyntaxKind.ColonToken:T=" ";break;case n.SyntaxKind.StringLiteral:if(P===n.SyntaxKind.ColonToken){T="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:P===n.SyntaxKind.LineCommentTrivia||P===n.SyntaxKind.BlockCommentTrivia?T=" ":P!==n.SyntaxKind.CommaToken&&P!==n.SyntaxKind.EOF&&(l=!0);break;case n.SyntaxKind.Unknown:l=!0;break}p&&(P===n.SyntaxKind.LineCommentTrivia||P===n.SyntaxKind.BlockCommentTrivia)&&(T=i())}const z=t.getTokenOffset()+a;c(T,D,z),u=P}return s}function E(o,S){const v=JSON.stringify(o,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?v.replace(/\r\n|\r|\n/g,S.eol):v}function I(o,S){let v="";for(let f=0;f<S;f++)v+=o;return v}function R(o,S){let v=0,f=0;const w=S.tabSize||4;for(;v<o.length;){const a=o.charAt(v);if(a===" ")f++;else if(a==="	")f+=w;else break;v++}return Math.floor(f/w)}function A(o,S){for(let v=0;v<S.length;v++){const f=S.charAt(v);if(f==="\r")return v+1<S.length&&S.charAt(v+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return o&&o.eol||`
`}function y(o,S){return`\r
`.indexOf(o.charAt(S))!==-1}}),define(Se[160],ke([1,0,43,159]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=E,e.$bo=I,e.$co=R,e.$do=A,e.$eo=y;function E(o,S,v){return I(o,S,void 0,v)}function I(o,S,v,f,w){const a=S.slice(),h=[],m=(0,n.$1n)(o,h);let $,p;for(;a.length>0&&(p=a.pop(),$=(0,n.$2n)(m,a),$===void 0&&v!==void 0);)typeof p=="string"?v={[p]:v}:v=[v];if($)if($.type==="object"&&typeof p=="string"&&Array.isArray($.children)){const d=(0,n.$2n)($,[p]);if(d!==void 0)if(v===void 0){if(!d.parent)throw new Error("Malformed AST");const b=$.children.indexOf(d.parent);let t,l=d.parent.offset+d.parent.length;if(b>0){const i=$.children[b-1];t=i.offset+i.length}else t=$.offset+1,$.children.length>1&&(l=$.children[1].offset);return R(o,{offset:t,length:l-t,content:""},f)}else return R(o,{offset:d.offset,length:d.length,content:JSON.stringify(v)},f);else{if(v===void 0)return[];const b=`${JSON.stringify(p)}: ${JSON.stringify(v)}`,t=w?w($.children.map(i=>i.children[0].value)):$.children.length;let l;if(t>0){const i=$.children[t-1];l={offset:i.offset+i.length,length:0,content:","+b}}else $.children.length===0?l={offset:$.offset+1,length:0,content:b}:l={offset:$.offset+1,length:0,content:b+","};return R(o,l,f)}}else if($.type==="array"&&typeof p=="number"&&Array.isArray($.children))if(v!==void 0){const d=`${JSON.stringify(v)}`;let b;if($.children.length===0||p===0)b={offset:$.offset+1,length:0,content:$.children.length===0?d:d+","};else{const t=p===-1||p>$.children.length?$.children.length:p,l=$.children[t-1];b={offset:l.offset+l.length,length:0,content:","+d}}return R(o,b,f)}else{const d=p,b=$.children[d];let t;if($.children.length===1)t={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===d){const l=$.children[d-1],i=l.offset+l.length,g=$.offset+$.length;t={offset:i,length:g-2-i,content:""}}else t={offset:b.offset,length:$.children[d+1].offset-b.offset,content:""};return R(o,t,f)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${$.type}`);else return v===void 0?[]:R(o,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(v)},f)}function R(o,S,v){let f=A(o,S),w=S.offset,a=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;w>0&&!(0,r.$_n)(f,w-1);)w--;for(;a<f.length&&!(0,r.$_n)(f,a);)a++}const h=(0,r.$9n)(f,{offset:w,length:a-w},v);for(let $=h.length-1;$>=0;$--){const p=h[$];f=A(f,p),w=Math.min(w,p.offset),a=Math.max(a,p.offset+p.length),a+=p.content.length-p.length}const m=o.length-(f.length-a)-w;return[{offset:w,length:m,content:f.substring(w,a)}]}function A(o,S){return o.substring(0,S.offset)+S.content+o.substring(S.offset+S.length)}function y(o,S){const v=S.slice(0).sort((w,a)=>{const h=w.offset-a.offset;return h===0?w.length-a.length:h});let f=o.length;for(let w=v.length-1;w>=0;w--){const a=v[w];if(a.offset+a.length<=f)o=A(o,a);else throw new Error("Overlapping edit");f=a.offset}return o}}),define(Se[65],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class n{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=n}),define(Se[80],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class n{constructor(I){this.element=I,this.next=n.Undefined,this.prev=n.Undefined}}n.Undefined=new n(void 0);class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let I=this.a;for(;I!==n.Undefined;){const R=I.next;I.prev=n.Undefined,I.next=n.Undefined,I=R}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,R){const A=new n(I);if(this.a===n.Undefined)this.a=A,this.b=A;else if(R){const o=this.b;this.b=A,A.prev=o,o.next=A}else{const o=this.a;this.a=A,A.next=o,o.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==n.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==n.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==n.Undefined&&I.next!==n.Undefined){const R=I.prev;R.next=I.next,I.next.prev=R}else I.prev===n.Undefined&&I.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):I.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):I.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==n.Undefined;)yield I.element,I=I.next}}e.$8c=r}),define(Se[26],ke([1,0]),function(se,e){"use strict";var n,r,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=I,e.$Bc=R,e.$Cc=A,e.$Lc=b;function I(t,l,i){let g=t.get(l);return g===void 0&&(g=i,t.set(l,g)),g}function R(t){const l=[];return t.forEach((i,g)=>{l.push(`${g} => ${i}`)}),`Map(${t.size}) {${l.join(", ")}}`}function A(t){const l=[];return t.forEach(i=>{l.push(i)}),`Set(${t.size}) {${l.join(", ")}}`}class y{constructor(l,i){this.uri=l,this.value=i}}function o(t){return Array.isArray(t)}class S{constructor(l,i){if(this[n]="ResourceMap",l instanceof S)this.d=new Map(l.d),this.e=i??S.c;else if(o(l)){this.d=new Map,this.e=i??S.c;for(const[g,s]of l)this.set(g,s)}else this.d=new Map,this.e=l??S.c}set(l,i){return this.d.set(this.e(l),new y(l,i)),this}get(l){return this.d.get(this.e(l))?.value}has(l){return this.d.has(this.e(l))}get size(){return this.d.size}clear(){this.d.clear()}delete(l){return this.d.delete(this.e(l))}forEach(l,i){typeof i<"u"&&(l=l.bind(i));for(const[g,s]of this.d)l(s.value,s.uri,this)}*values(){for(const l of this.d.values())yield l.value}*keys(){for(const l of this.d.values())yield l.uri}*entries(){for(const l of this.d.values())yield[l.uri,l.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.d)yield[l.uri,l.value]}}e.$Dc=S,S.c=t=>t.toString();class v{constructor(l,i){this[r]="ResourceSet",!l||typeof l=="function"?this.c=new S(l):(this.c=new S(i),l.forEach(this.add,this))}get size(){return this.c.size}add(l){return this.c.set(l,l),this}clear(){this.c.clear()}delete(l){return this.c.delete(l)}forEach(l,i){this.c.forEach((g,s)=>l.call(i,s,s,this))}has(l){return this.c.has(l)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=v;var f;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class w{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(l){return this.c.has(l)}get(l,i=f.None){const g=this.c.get(l);if(g)return i!==f.None&&this.m(g,i),g.value}set(l,i,g=f.None){let s=this.c.get(l);if(s)s.value=i,g!==f.None&&this.m(s,g);else{switch(s={key:l,value:i,next:void 0,previous:void 0},g){case f.None:this.k(s);break;case f.AsOld:this.j(s);break;case f.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(l,s),this.f++}return this}delete(l){return!!this.remove(l)}remove(l){const i=this.c.get(l);if(i)return this.c.delete(l),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const l=this.d;return this.c.delete(l.key),this.l(l),this.f--,l.value}forEach(l,i){const g=this.g;let s=this.d;for(;s;){if(i?l.bind(i)(s.value,s.key,this):l(s.value,s.key,this),this.g!==g)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const l=this,i=this.g;let g=this.d;const s={[Symbol.iterator](){return s},next(){if(l.g!==i)throw new Error("LinkedMap got modified during iteration.");if(g){const c={value:g.key,done:!1};return g=g.next,c}else return{value:void 0,done:!0}}};return s}values(){const l=this,i=this.g;let g=this.d;const s={[Symbol.iterator](){return s},next(){if(l.g!==i)throw new Error("LinkedMap got modified during iteration.");if(g){const c={value:g.value,done:!1};return g=g.next,c}else return{value:void 0,done:!0}}};return s}entries(){const l=this,i=this.g;let g=this.d;const s={[Symbol.iterator](){return s},next(){if(l.g!==i)throw new Error("LinkedMap got modified during iteration.");if(g){const c={value:[g.key,g.value],done:!1};return g=g.next,c}else return{value:void 0,done:!0}}};return s}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(l){if(l>=this.size)return;if(l===0){this.clear();return}let i=this.d,g=this.size;for(;i&&g>l;)this.c.delete(i.key),i=i.next,g--;this.d=i,this.f=g,i&&(i.previous=void 0),this.g++}i(l){if(l>=this.size)return;if(l===0){this.clear();return}let i=this.e,g=this.size;for(;i&&g>l;)this.c.delete(i.key),i=i.previous,g--;this.e=i,this.f=g,i&&(i.next=void 0),this.g++}j(l){if(!this.d&&!this.e)this.e=l;else if(this.d)l.next=this.d,this.d.previous=l;else throw new Error("Invalid list");this.d=l,this.g++}k(l){if(!this.d&&!this.e)this.d=l;else if(this.e)l.previous=this.e,this.e.next=l;else throw new Error("Invalid list");this.e=l,this.g++}l(l){if(l===this.d&&l===this.e)this.d=void 0,this.e=void 0;else if(l===this.d){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.d=l.next}else if(l===this.e){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.e=l.previous}else{const i=l.next,g=l.previous;if(!i||!g)throw new Error("Invalid list");i.previous=g,g.next=i}l.next=void 0,l.previous=void 0,this.g++}m(l,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==f.AsOld&&i!==f.AsNew)){if(i===f.AsOld){if(l===this.d)return;const g=l.next,s=l.previous;l===this.e?(s.next=void 0,this.e=s):(g.previous=s,s.next=g),l.previous=void 0,l.next=this.d,this.d.previous=l,this.d=l,this.g++}else if(i===f.AsNew){if(l===this.e)return;const g=l.next,s=l.previous;l===this.d?(g.previous=void 0,this.d=g):(g.previous=s,s.next=g),l.next=void 0,l.previous=this.e,this.e.next=l,this.e=l,this.g++}}}toJSON(){const l=[];return this.forEach((i,g)=>{l.push([g,i])}),l}fromJSON(l){this.clear();for(const[i,g]of l)this.set(i,g)}}e.$Fc=w;class a extends w{constructor(l,i=1){super(),this.n=l,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(l){this.n=l,this.p()}get ratio(){return this.o}set ratio(l){this.o=Math.min(Math.max(0,l),1),this.p()}get(l,i=f.AsNew){return super.get(l,i)}peek(l){return super.get(l,f.None)}set(l,i){return super.set(l,i,f.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class h extends a{constructor(l,i=1){super(l,i)}q(l){this.h(l)}set(l,i){return super.set(l,i),this.p(),this}}e.$Gc=h;class m extends a{constructor(l,i=1){super(l,i)}q(l){this.i(l)}set(l,i){return this.n<=this.size&&!this.has(l)&&this.q(Math.round(this.n*this.o)-1),super.set(l,i),this}}e.$Hc=m;class ${constructor(){this.c=new Map}add(l){return this.c.set(l,(this.c.get(l)||0)+1),this}delete(l){let i=this.c.get(l)||0;return i===0?!1:(i--,i===0?this.c.delete(l):this.c.set(l,i),!0)}has(l){return this.c.has(l)}}e.$Ic=$;class p{constructor(l){if(this.c=new Map,this.d=new Map,l)for(const[i,g]of l)this.set(i,g)}clear(){this.c.clear(),this.d.clear()}set(l,i){this.c.set(l,i),this.d.set(i,l)}get(l){return this.c.get(l)}getKey(l){return this.d.get(l)}delete(l){const i=this.c.get(l);return i===void 0?!1:(this.c.delete(l),this.d.delete(i),!0)}forEach(l,i){this.c.forEach((g,s)=>{l.call(i,g,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=p;class d{constructor(){this.c=new Map}add(l,i){let g=this.c.get(l);g||(g=new Set,this.c.set(l,g)),g.add(i)}delete(l,i){const g=this.c.get(l);g&&(g.delete(i),g.size===0&&this.c.delete(l))}forEach(l,i){const g=this.c.get(l);g&&g.forEach(i)}get(l){const i=this.c.get(l);return i||new Set}}e.$Kc=d;function b(t,l){if(t===l)return!0;if(t.size!==l.size)return!1;for(const[i,g]of t)if(!l.has(i)||l.get(i)!==g)return!1;for(const[i]of l)if(!t.has(i))return!1;return!0}}),define(Se[2],ke([1,0,18,157,26,79,40]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=S,e.$Oc=v,e.$Pc=f,e.$Qc=h,e.$Rc=m,e.$Sc=$,e.$Tc=p,e.$Uc=d,e.$Vc=b,e.$6c=T;const A=!1;let y=null;class o{constructor(){this.b=new Map}c(k){let q=this.b.get(k);return q||(q={parent:null,source:null,isSingleton:!1,value:k,idx:o.a++},this.b.set(k,q)),q}trackDisposable(k){const q=this.c(k);q.source||(q.source=new Error().stack)}setParent(k,q){const Y=this.c(k);Y.parent=q}markAsDisposed(k){this.b.delete(k)}markAsSingleton(k){this.c(k).isSingleton=!0}f(k,q){const Y=q.get(k);if(Y)return Y;const J=k.parent?this.f(this.c(k.parent),q):k;return q.set(k,J),J}getTrackedDisposables(){const k=new Map;return[...this.b.entries()].filter(([,Y])=>Y.source!==null&&!this.f(Y,k).isSingleton).flatMap(([Y])=>Y)}computeLeakingDisposables(k=10,q){let Y;if(q)Y=q;else{const le=new Map,K=[...this.b.values()].filter(M=>M.source!==null&&!this.f(M,le).isSingleton);if(K.length===0)return;const ae=new Set(K.map(M=>M.value));if(Y=K.filter(M=>!(M.parent&&ae.has(M.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function J(le){function K(M,B){for(;M.length>0&&B.some(re=>typeof re=="string"?re===M[0]:M[0].match(re));)M.shift()}const ae=le.source.split(`
`).map(M=>M.trim().replace("at ","")).filter(M=>M!=="");return K(ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ae.reverse()}const ne=new E.$Kc;for(const le of Y){const K=J(le);for(let ae=0;ae<=K.length;ae++)ne.add(K.slice(0,ae).join(`
`),le)}Y.sort((0,n.$9b)(le=>le.idx,n.$$b));let Z="",x=0;for(const le of Y.slice(0,k)){x++;const K=J(le),ae=[];for(let M=0;M<K.length;M++){let B=K[M];B=`(shared with ${ne.get(K.slice(0,M+1).join(`
`)).size}/${Y.length} leaks) at ${B}`;const ce=ne.get(K.slice(0,M).join(`
`)),pe=(0,r.$E)([...ce].map(W=>J(W)[M]),W=>W);delete pe[K[M]];for(const[W,ue]of Object.entries(pe))ae.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${W}`);ae.unshift(B)}Z+=`


==================== Leaking disposable ${x}/${Y.length}: ${le.value.constructor.name} ====================
${ae.join(`
`)}
============================================================

`}return Y.length>k&&(Z+=`


... and ${Y.length-k} more leaking disposables

`),{leaks:Y,details:Z}}}e.$Mc=o,o.a=0;function S(C){y=C}if(A){const C="__is_disposable_tracked__";S(new class{trackDisposable(k){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{k[C]||console.log(q)},3e3)}setParent(k,q){if(k&&k!==l.None)try{k[C]=!0}catch{}}markAsDisposed(k){if(k&&k!==l.None)try{k[C]=!0}catch{}}markAsSingleton(k){}})}function v(C){return y?.trackDisposable(C),C}function f(C){y?.markAsDisposed(C)}function w(C,k){y?.setParent(C,k)}function a(C,k){if(y)for(const q of C)y.setParent(q,k)}function h(C){return y?.markAsSingleton(C),C}function m(C){return typeof C=="object"&&C!==null&&typeof C.dispose=="function"&&C.dispose.length===0}function $(C){if(R.Iterable.is(C)){const k=[];for(const q of C)if(q)try{q.dispose()}catch(Y){k.push(Y)}if(k.length===1)throw k[0];if(k.length>1)throw new AggregateError(k,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}function p(C){for(const k of C)m(k)&&k.dispose();return[]}function d(...C){const k=b(()=>$(C));return a(C,k),k}function b(C){const k=v({dispose:(0,I.$gb)(()=>{f(k),C()})});return k}class t{constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(k){if(!k)return k;if(k===this)throw new Error("Cannot register a disposable on itself!");return w(k,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(k),k}delete(k){if(k){if(k===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(k),k.dispose()}}deleteAndLeak(k){k&&this.f.has(k)&&(this.f.delete(k),w(k,null))}}e.$Wc=t,t.DISABLE_DISPOSED_WARNING=!1;class l{constructor(){this.q=new t,v(this),w(this.q,this)}dispose(){f(this),this.q.dispose()}B(k){if(k===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(k)}}e.$Xc=l,l.None=Object.freeze({dispose(){}});class i{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(k){this.b||k===this.a||(this.a?.dispose(),k&&w(k,this),this.a=k)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const k=this.a;return this.a=void 0,k&&w(k,null),k}}e.$Yc=i;class g{constructor(k){this.a=new i,this.b=!1,this.a.value=k}get value(){return this.a.value}set value(k){this.b||k===this.a.value||(this.a.value=k)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=g;class s{constructor(k){this.b=k,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=s;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(k){let q=k;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,f(this))},this}}e.$2c=c;class u{constructor(){this.a=new Map}acquire(k,...q){let Y=this.a.get(k);Y||(Y={counter:0,object:this.b(k,...q)},this.a.set(k,Y));const{object:J}=Y,ne=(0,I.$gb)(()=>{--Y.counter===0&&(this.c(k,Y.object),this.a.delete(k))});return Y.counter++,{object:J,dispose:ne}}}e.$3c=u;class D{constructor(k){this.a=k}async acquire(k,...q){const Y=this.a.acquire(k,...q);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(J){throw Y.dispose(),J}}}e.$4c=D;class P{constructor(k){this.object=k}dispose(){}}e.$5c=P;function T(C){const k=new t;try{C(k)}finally{k.dispose()}}class z{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(k){return this.a.has(k)}get size(){return this.a.size}get(k){return this.a.get(k)}set(k,q,Y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this.a.get(k)?.dispose(),this.a.set(k,q)}deleteAndDispose(k){this.a.get(k)?.dispose(),this.a.delete(k)}deleteAndLeak(k){const q=this.a.get(k);return this.a.delete(k),q}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=z}),function(se,e){typeof define=="function"&&define.amd?define(Se[161],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(se=typeof globalThis<"u"?globalThis:se||self,e(se.marked={}))}(this,function(se){"use strict";function e(j,G){for(var Q=0;Q<G.length;Q++){var N=G[Q];N.enumerable=N.enumerable||!1,N.configurable=!0,"value"in N&&(N.writable=!0),Object.defineProperty(j,N.key,N)}}function n(j,G,Q){return G&&e(j.prototype,G),Q&&e(j,Q),Object.defineProperty(j,"prototype",{writable:!1}),j}function r(j,G){if(j){if(typeof j=="string")return E(j,G);var Q=Object.prototype.toString.call(j).slice(8,-1);if(Q==="Object"&&j.constructor&&(Q=j.constructor.name),Q==="Map"||Q==="Set")return Array.from(j);if(Q==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Q))return E(j,G)}}function E(j,G){(G==null||G>j.length)&&(G=j.length);for(var Q=0,N=new Array(G);Q<G;Q++)N[Q]=j[Q];return N}function I(j,G){var Q=typeof Symbol<"u"&&j[Symbol.iterator]||j["@@iterator"];if(Q)return(Q=Q.call(j)).next.bind(Q);if(Array.isArray(j)||(Q=r(j))||G&&j&&typeof j.length=="number"){Q&&(j=Q);var N=0;return function(){return N>=j.length?{done:!0}:{done:!1,value:j[N++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=R();function A(j){se.defaults=j}var y=/[&<>"']/,o=/[&<>"']/g,S=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(G){return f[G]};function a(j,G){if(G){if(y.test(j))return j.replace(o,w)}else if(S.test(j))return j.replace(v,w);return j}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(j){return j.replace(h,function(G,Q){return Q=Q.toLowerCase(),Q==="colon"?":":Q.charAt(0)==="#"?Q.charAt(1)==="x"?String.fromCharCode(parseInt(Q.substring(2),16)):String.fromCharCode(+Q.substring(1)):""})}var $=/(^|[^\[])\^/g;function p(j,G){j=typeof j=="string"?j:j.source,G=G||"";var Q={replace:function(H,oe){return oe=oe.source||oe,oe=oe.replace($,"$1"),j=j.replace(H,oe),Q},getRegex:function(){return new RegExp(j,G)}};return Q}var d=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(j,G,Q){if(j){var N;try{N=decodeURIComponent(m(Q)).replace(d,"").toLowerCase()}catch{return null}if(N.indexOf("javascript:")===0||N.indexOf("vbscript:")===0||N.indexOf("data:")===0)return null}G&&!b.test(Q)&&(Q=c(G,Q));try{Q=encodeURI(Q).replace(/%25/g,"%")}catch{return null}return Q}var l={},i=/^[^:]+:\/*[^/]*$/,g=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(j,G){l[" "+j]||(i.test(j)?l[" "+j]=j+"/":l[" "+j]=T(j,"/",!0)),j=l[" "+j];var Q=j.indexOf(":")===-1;return G.substring(0,2)==="//"?Q?G:j.replace(g,"$1")+G:G.charAt(0)==="/"?Q?G:j.replace(s,"$1")+G:j+G}var u={exec:function(){}};function D(j){for(var G=1,Q,N;G<arguments.length;G++){Q=arguments[G];for(N in Q)Object.prototype.hasOwnProperty.call(Q,N)&&(j[N]=Q[N])}return j}function P(j,G){var Q=j.replace(/\|/g,function(oe,fe,Ee){for(var Ne=!1,de=fe;--de>=0&&Ee[de]==="\\";)Ne=!Ne;return Ne?"|":" |"}),N=Q.split(/ \|/),H=0;if(N[0].trim()||N.shift(),N.length>0&&!N[N.length-1].trim()&&N.pop(),N.length>G)N.splice(G);else for(;N.length<G;)N.push("");for(;H<N.length;H++)N[H]=N[H].trim().replace(/\\\|/g,"|");return N}function T(j,G,Q){var N=j.length;if(N===0)return"";for(var H=0;H<N;){var oe=j.charAt(N-H-1);if(oe===G&&!Q)H++;else if(oe!==G&&Q)H++;else break}return j.slice(0,N-H)}function z(j,G){if(j.indexOf(G[1])===-1)return-1;for(var Q=j.length,N=0,H=0;H<Q;H++)if(j[H]==="\\")H++;else if(j[H]===G[0])N++;else if(j[H]===G[1]&&(N--,N<0))return H;return-1}function C(j){j&&j.sanitize&&!j.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(j,G){if(G<1)return"";for(var Q="";G>1;)G&1&&(Q+=j),G>>=1,j+=j;return Q+j}function q(j,G,Q,N){var H=G.href,oe=G.title?a(G.title):null,fe=j[1].replace(/\\([\[\]])/g,"$1");if(j[0].charAt(0)!=="!"){N.state.inLink=!0;var Ee={type:"link",raw:Q,href:H,title:oe,text:fe,tokens:N.inlineTokens(fe)};return N.state.inLink=!1,Ee}return{type:"image",raw:Q,href:H,title:oe,text:a(fe)}}function Y(j,G){var Q=j.match(/^(\s+)(?:```)/);if(Q===null)return G;var N=Q[1];return G.split(`
`).map(function(H){var oe=H.match(/^\s+/);if(oe===null)return H;var fe=oe[0];return fe.length>=N.length?H.slice(N.length):H}).join(`
`)}var J=function(){function j(Q){this.options=Q||se.defaults}var G=j.prototype;return G.space=function(N){var H=this.rules.block.newline.exec(N);if(H&&H[0].length>0)return{type:"space",raw:H[0]}},G.code=function(N){var H=this.rules.block.code.exec(N);if(H){var oe=H[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:H[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:T(oe,`
`)}}},G.fences=function(N){var H=this.rules.block.fences.exec(N);if(H){var oe=H[0],fe=Y(oe,H[3]||"");return{type:"code",raw:oe,lang:H[2]?H[2].trim():H[2],text:fe}}},G.heading=function(N){var H=this.rules.block.heading.exec(N);if(H){var oe=H[2].trim();if(/#$/.test(oe)){var fe=T(oe,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(oe=fe.trim())}return{type:"heading",raw:H[0],depth:H[1].length,text:oe,tokens:this.lexer.inline(oe)}}},G.hr=function(N){var H=this.rules.block.hr.exec(N);if(H)return{type:"hr",raw:H[0]}},G.blockquote=function(N){var H=this.rules.block.blockquote.exec(N);if(H){var oe=H[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:H[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},G.list=function(N){var H=this.rules.block.list.exec(N);if(H){var oe,fe,Ee,Ne,de,$e,Re,Ce,me,Ie,Ae,Me,qe=H[1].trim(),Qe=qe.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+qe.slice(0,-1):"",loose:!1,items:[]};qe=Qe?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=Qe?qe:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");N&&(Me=!1,!(!(H=Ye.exec(N))||this.rules.block.hr.test(N)));){if(oe=H[0],N=N.substring(oe.length),Ce=H[2].split(`
`,1)[0],me=N.split(`
`,1)[0],this.options.pedantic?(Ne=2,Ae=Ce.trimLeft()):(Ne=H[2].search(/[^ ]/),Ne=Ne>4?1:Ne,Ae=Ce.slice(Ne),Ne+=H[1].length),$e=!1,!Ce&&/^ *$/.test(me)&&(oe+=me+`
`,N=N.substring(me.length+1),Me=!0),!Me)for(var We=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ne-1)+"}#");N&&(Ie=N.split(`
`,1)[0],Ce=Ie,this.options.pedantic&&(Ce=Ce.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(Ce)||nt.test(Ce)||We.test(Ce)||rt.test(N)));){if(Ce.search(/[^ ]/)>=Ne||!Ce.trim())Ae+=`
`+Ce.slice(Ne);else if(!$e)Ae+=`
`+Ce;else break;!$e&&!Ce.trim()&&($e=!0),oe+=Ie+`
`,N=N.substring(Ie.length+1)}Ge.loose||(Re?Ge.loose=!0:/\n *\n *$/.test(oe)&&(Re=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(Ae),fe&&(Ee=fe[0]!=="[ ] ",Ae=Ae.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:oe,task:!!fe,checked:Ee,loose:!1,text:Ae}),Ge.raw+=oe}Ge.items[Ge.items.length-1].raw=oe.trimRight(),Ge.items[Ge.items.length-1].text=Ae.trimRight(),Ge.raw=Ge.raw.trimRight();var ct=Ge.items.length;for(de=0;de<ct;de++){this.lexer.state.top=!1,Ge.items[de].tokens=this.lexer.blockTokens(Ge.items[de].text,[]);var it=Ge.items[de].tokens.filter(function(Je){return Je.type==="space"}),_e=it.every(function(Je){for(var et=Je.raw.split(""),be=0,Le=I(et),ve;!(ve=Le()).done;){var ye=ve.value;if(ye===`
`&&(be+=1),be>1)return!0}return!1});!Ge.loose&&it.length&&_e&&(Ge.loose=!0,Ge.items[de].loose=!0)}return Ge}},G.html=function(N){var H=this.rules.block.html.exec(N);if(H){var oe={type:"html",raw:H[0],pre:!this.options.sanitizer&&(H[1]==="pre"||H[1]==="script"||H[1]==="style"),text:H[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(H[0]):a(H[0]);oe.type="paragraph",oe.text=fe,oe.tokens=this.lexer.inline(fe)}return oe}},G.def=function(N){var H=this.rules.block.def.exec(N);if(H){H[3]&&(H[3]=H[3].substring(1,H[3].length-1));var oe=H[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:H[0],href:H[2],title:H[3]}}},G.table=function(N){var H=this.rules.block.table.exec(N);if(H){var oe={type:"table",header:P(H[1]).map(function(Re){return{text:Re}}),align:H[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:H[3]&&H[3].trim()?H[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=H[0];var fe=oe.align.length,Ee,Ne,de,$e;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(oe.align[Ee])?oe.align[Ee]="right":/^ *:-+: *$/.test(oe.align[Ee])?oe.align[Ee]="center":/^ *:-+ *$/.test(oe.align[Ee])?oe.align[Ee]="left":oe.align[Ee]=null;for(fe=oe.rows.length,Ee=0;Ee<fe;Ee++)oe.rows[Ee]=P(oe.rows[Ee],oe.header.length).map(function(Re){return{text:Re}});for(fe=oe.header.length,Ne=0;Ne<fe;Ne++)oe.header[Ne].tokens=this.lexer.inline(oe.header[Ne].text);for(fe=oe.rows.length,Ne=0;Ne<fe;Ne++)for($e=oe.rows[Ne],de=0;de<$e.length;de++)$e[de].tokens=this.lexer.inline($e[de].text);return oe}}},G.lheading=function(N){var H=this.rules.block.lheading.exec(N);if(H)return{type:"heading",raw:H[0],depth:H[2].charAt(0)==="="?1:2,text:H[1],tokens:this.lexer.inline(H[1])}},G.paragraph=function(N){var H=this.rules.block.paragraph.exec(N);if(H){var oe=H[1].charAt(H[1].length-1)===`
`?H[1].slice(0,-1):H[1];return{type:"paragraph",raw:H[0],text:oe,tokens:this.lexer.inline(oe)}}},G.text=function(N){var H=this.rules.block.text.exec(N);if(H)return{type:"text",raw:H[0],text:H[0],tokens:this.lexer.inline(H[0])}},G.escape=function(N){var H=this.rules.inline.escape.exec(N);if(H)return{type:"escape",raw:H[0],text:a(H[1])}},G.tag=function(N){var H=this.rules.inline.tag.exec(N);if(H)return!this.lexer.state.inLink&&/^<a /i.test(H[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(H[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:H[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):a(H[0]):H[0]}},G.link=function(N){var H=this.rules.inline.link.exec(N);if(H){var oe=H[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var fe=T(oe.slice(0,-1),"\\");if((oe.length-fe.length)%2===0)return}else{var Ee=z(H[2],"()");if(Ee>-1){var Ne=H[0].indexOf("!")===0?5:4,de=Ne+H[1].length+Ee;H[2]=H[2].substring(0,Ee),H[0]=H[0].substring(0,de).trim(),H[3]=""}}var $e=H[2],Re="";if(this.options.pedantic){var Ce=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec($e);Ce&&($e=Ce[1],Re=Ce[3])}else Re=H[3]?H[3].slice(1,-1):"";return $e=$e.trim(),/^</.test($e)&&(this.options.pedantic&&!/>$/.test(oe)?$e=$e.slice(1):$e=$e.slice(1,-1)),q(H,{href:$e&&$e.replace(this.rules.inline._escapes,"$1"),title:Re&&Re.replace(this.rules.inline._escapes,"$1")},H[0],this.lexer)}},G.reflink=function(N,H){var oe;if((oe=this.rules.inline.reflink.exec(N))||(oe=this.rules.inline.nolink.exec(N))){var fe=(oe[2]||oe[1]).replace(/\s+/g," ");if(fe=H[fe.toLowerCase()],!fe||!fe.href){var Ee=oe[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return q(oe,fe,oe[0],this.lexer)}},G.emStrong=function(N,H,oe){oe===void 0&&(oe="");var fe=this.rules.inline.emStrong.lDelim.exec(N);if(fe&&!(fe[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=fe[1]||fe[2]||"";if(!Ee||Ee&&(oe===""||this.rules.inline.punctuation.exec(oe))){var Ne=fe[0].length-1,de,$e,Re=Ne,Ce=0,me=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,H=H.slice(-1*N.length+Ne);(fe=me.exec(H))!=null;)if(de=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!de){if($e=de.length,fe[3]||fe[4]){Re+=$e;continue}else if((fe[5]||fe[6])&&Ne%3&&!((Ne+$e)%3)){Ce+=$e;continue}if(Re-=$e,!(Re>0)){if($e=Math.min($e,$e+Re+Ce),Math.min(Ne,$e)%2){var Ie=N.slice(1,Ne+fe.index+$e);return{type:"em",raw:N.slice(0,Ne+fe.index+$e+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}var Ae=N.slice(2,Ne+fe.index+$e-1);return{type:"strong",raw:N.slice(0,Ne+fe.index+$e+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}}}}},G.codespan=function(N){var H=this.rules.inline.code.exec(N);if(H){var oe=H[2].replace(/\n/g," "),fe=/[^ ]/.test(oe),Ee=/^ /.test(oe)&&/ $/.test(oe);return fe&&Ee&&(oe=oe.substring(1,oe.length-1)),oe=a(oe,!0),{type:"codespan",raw:H[0],text:oe}}},G.br=function(N){var H=this.rules.inline.br.exec(N);if(H)return{type:"br",raw:H[0]}},G.del=function(N){var H=this.rules.inline.del.exec(N);if(H)return{type:"del",raw:H[0],text:H[2],tokens:this.lexer.inlineTokens(H[2])}},G.autolink=function(N,H){var oe=this.rules.inline.autolink.exec(N);if(oe){var fe,Ee;return oe[2]==="@"?(fe=a(this.options.mangle?H(oe[1]):oe[1]),Ee="mailto:"+fe):(fe=a(oe[1]),Ee=fe),{type:"link",raw:oe[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},G.url=function(N,H){var oe;if(oe=this.rules.inline.url.exec(N)){var fe,Ee;if(oe[2]==="@")fe=a(this.options.mangle?H(oe[0]):oe[0]),Ee="mailto:"+fe;else{var Ne;do Ne=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(Ne!==oe[0]);fe=a(oe[0]),oe[1]==="www."?Ee="http://"+fe:Ee=fe}return{type:"link",raw:oe[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},G.inlineText=function(N,H){var oe=this.rules.inline.text.exec(N);if(oe){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):a(oe[0]):oe[0]:fe=a(this.options.smartypants?H(oe[0]):oe[0]),{type:"text",raw:oe[0],text:fe}}},j}(),ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=p(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=p(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=p(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=p(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=p(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=p(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=D({},ne),ne.gfm=D({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=p(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.paragraph=p(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ne.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=D({},ne.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:p(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Z.punctuation=p(Z.punctuation).replace(/punctuation/g,Z._punctuation).getRegex(),Z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Z.escapedEmSt=/\\\*|\\_/g,Z._comment=p(ne._comment).replace("(?:-->|$)","-->").getRegex(),Z.emStrong.lDelim=p(Z.emStrong.lDelim).replace(/punct/g,Z._punctuation).getRegex(),Z.emStrong.rDelimAst=p(Z.emStrong.rDelimAst,"g").replace(/punct/g,Z._punctuation).getRegex(),Z.emStrong.rDelimUnd=p(Z.emStrong.rDelimUnd,"g").replace(/punct/g,Z._punctuation).getRegex(),Z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Z.autolink=p(Z.autolink).replace("scheme",Z._scheme).replace("email",Z._email).getRegex(),Z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Z.tag=p(Z.tag).replace("comment",Z._comment).replace("attribute",Z._attribute).getRegex(),Z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Z.link=p(Z.link).replace("label",Z._label).replace("href",Z._href).replace("title",Z._title).getRegex(),Z.reflink=p(Z.reflink).replace("label",Z._label).replace("ref",ne._label).getRegex(),Z.nolink=p(Z.nolink).replace("ref",ne._label).getRegex(),Z.reflinkSearch=p(Z.reflinkSearch,"g").replace("reflink",Z.reflink).replace("nolink",Z.nolink).getRegex(),Z.normal=D({},Z),Z.pedantic=D({},Z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",Z._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Z._label).getRegex()}),Z.gfm=D({},Z.normal,{escape:p(Z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Z.gfm.url=p(Z.gfm.url,"i").replace("email",Z.gfm._extended_email).getRegex(),Z.breaks=D({},Z.gfm,{br:p(Z.br).replace("{2,}","*").getRegex(),text:p(Z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(j){return j.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function le(j){var G="",Q,N,H=j.length;for(Q=0;Q<H;Q++)N=j.charCodeAt(Q),Math.random()>.5&&(N="x"+N.toString(16)),G+="&#"+N+";";return G}var K=function(){function j(Q){this.tokens=[],this.tokens.links=Object.create(null),this.options=Q||se.defaults,this.options.tokenizer=this.options.tokenizer||new J,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var N={block:ne.normal,inline:Z.normal};this.options.pedantic?(N.block=ne.pedantic,N.inline=Z.pedantic):this.options.gfm&&(N.block=ne.gfm,this.options.breaks?N.inline=Z.breaks:N.inline=Z.gfm),this.tokenizer.rules=N}j.lex=function(N,H){var oe=new j(H);return oe.lex(N)},j.lexInline=function(N,H){var oe=new j(H);return oe.inlineTokens(N)};var G=j.prototype;return G.lex=function(N){N=N.replace(/\r\n|\r/g,`
`),this.blockTokens(N,this.tokens);for(var H;H=this.inlineQueue.shift();)this.inlineTokens(H.src,H.tokens);return this.tokens},G.blockTokens=function(N,H){var oe=this;H===void 0&&(H=[]),this.options.pedantic?N=N.replace(/\t/g,"    ").replace(/^ +$/gm,""):N=N.replace(/^( *)(\t+)/gm,function(Re,Ce,me){return Ce+"    ".repeat(me.length)});for(var fe,Ee,Ne,de;N;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Re){return(fe=Re.call({lexer:oe},N,H))?(N=N.substring(fe.raw.length),H.push(fe),!0):!1}))){if(fe=this.tokenizer.space(N)){N=N.substring(fe.raw.length),fe.raw.length===1&&H.length>0?H[H.length-1].raw+=`
`:H.push(fe);continue}if(fe=this.tokenizer.code(N)){N=N.substring(fe.raw.length),Ee=H[H.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+fe.raw,Ee.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):H.push(fe);continue}if(fe=this.tokenizer.fences(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.heading(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.hr(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.blockquote(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.list(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.html(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.def(N)){N=N.substring(fe.raw.length),Ee=H[H.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+fe.raw,Ee.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.lheading(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(Ne=N,this.options.extensions&&this.options.extensions.startBlock&&function(){var Re=1/0,Ce=N.slice(1),me=void 0;oe.options.extensions.startBlock.forEach(function(Ie){me=Ie.call({lexer:this},Ce),typeof me=="number"&&me>=0&&(Re=Math.min(Re,me))}),Re<1/0&&Re>=0&&(Ne=N.substring(0,Re+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(Ne))){Ee=H[H.length-1],de&&Ee.type==="paragraph"?(Ee.raw+=`
`+fe.raw,Ee.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):H.push(fe),de=Ne.length!==N.length,N=N.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(N)){N=N.substring(fe.raw.length),Ee=H[H.length-1],Ee&&Ee.type==="text"?(Ee.raw+=`
`+fe.raw,Ee.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):H.push(fe);continue}if(N){var $e="Infinite loop on byte: "+N.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return this.state.top=!0,H},G.inline=function(N,H){return H===void 0&&(H=[]),this.inlineQueue.push({src:N,tokens:H}),H},G.inlineTokens=function(N,H){var oe=this;H===void 0&&(H=[]);var fe,Ee,Ne,de=N,$e,Re,Ce;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;($e=this.tokenizer.rules.inline.reflinkSearch.exec(de))!=null;)me.includes($e[0].slice($e[0].lastIndexOf("[")+1,-1))&&(de=de.slice(0,$e.index)+"["+k("a",$e[0].length-2)+"]"+de.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;($e=this.tokenizer.rules.inline.blockSkip.exec(de))!=null;)de=de.slice(0,$e.index)+"["+k("a",$e[0].length-2)+"]"+de.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;($e=this.tokenizer.rules.inline.escapedEmSt.exec(de))!=null;)de=de.slice(0,$e.index)+"++"+de.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;N;)if(Re||(Ce=""),Re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ae){return(fe=Ae.call({lexer:oe},N,H))?(N=N.substring(fe.raw.length),H.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.tag(N)){N=N.substring(fe.raw.length),Ee=H[H.length-1],Ee&&fe.type==="text"&&Ee.type==="text"?(Ee.raw+=fe.raw,Ee.text+=fe.text):H.push(fe);continue}if(fe=this.tokenizer.link(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.reflink(N,this.tokens.links)){N=N.substring(fe.raw.length),Ee=H[H.length-1],Ee&&fe.type==="text"&&Ee.type==="text"?(Ee.raw+=fe.raw,Ee.text+=fe.text):H.push(fe);continue}if(fe=this.tokenizer.emStrong(N,de,Ce)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.codespan(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.br(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.del(N)){N=N.substring(fe.raw.length),H.push(fe);continue}if(fe=this.tokenizer.autolink(N,le)){N=N.substring(fe.raw.length),H.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(N,le))){N=N.substring(fe.raw.length),H.push(fe);continue}if(Ne=N,this.options.extensions&&this.options.extensions.startInline&&function(){var Ae=1/0,Me=N.slice(1),qe=void 0;oe.options.extensions.startInline.forEach(function(Qe){qe=Qe.call({lexer:this},Me),typeof qe=="number"&&qe>=0&&(Ae=Math.min(Ae,qe))}),Ae<1/0&&Ae>=0&&(Ne=N.substring(0,Ae+1))}(),fe=this.tokenizer.inlineText(Ne,x)){N=N.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Ce=fe.raw.slice(-1)),Re=!0,Ee=H[H.length-1],Ee&&Ee.type==="text"?(Ee.raw+=fe.raw,Ee.text+=fe.text):H.push(fe);continue}if(N){var Ie="Infinite loop on byte: "+N.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return H},n(j,null,[{key:"rules",get:function(){return{block:ne,inline:Z}}}]),j}(),ae=function(){function j(Q){this.options=Q||se.defaults}var G=j.prototype;return G.code=function(N,H,oe){var fe=(H||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(N,fe);Ee!=null&&Ee!==N&&(oe=!0,N=Ee)}return N=N.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+a(fe,!0)+'">'+(oe?N:a(N,!0))+`</code></pre>
`:"<pre><code>"+(oe?N:a(N,!0))+`</code></pre>
`},G.blockquote=function(N){return`<blockquote>
`+N+`</blockquote>
`},G.html=function(N){return N},G.heading=function(N,H,oe,fe){if(this.options.headerIds){var Ee=this.options.headerPrefix+fe.slug(oe);return"<h"+H+' id="'+Ee+'">'+N+"</h"+H+`>
`}return"<h"+H+">"+N+"</h"+H+`>
`},G.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},G.list=function(N,H,oe){var fe=H?"ol":"ul",Ee=H&&oe!==1?' start="'+oe+'"':"";return"<"+fe+Ee+`>
`+N+"</"+fe+`>
`},G.listitem=function(N){return"<li>"+N+`</li>
`},G.checkbox=function(N){return"<input "+(N?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},G.paragraph=function(N){return"<p>"+N+`</p>
`},G.table=function(N,H){return H&&(H="<tbody>"+H+"</tbody>"),`<table>
<thead>
`+N+`</thead>
`+H+`</table>
`},G.tablerow=function(N){return`<tr>
`+N+`</tr>
`},G.tablecell=function(N,H){var oe=H.header?"th":"td",fe=H.align?"<"+oe+' align="'+H.align+'">':"<"+oe+">";return fe+N+("</"+oe+`>
`)},G.strong=function(N){return"<strong>"+N+"</strong>"},G.em=function(N){return"<em>"+N+"</em>"},G.codespan=function(N){return"<code>"+N+"</code>"},G.br=function(){return this.options.xhtml?"<br/>":"<br>"},G.del=function(N){return"<del>"+N+"</del>"},G.link=function(N,H,oe){if(N=t(this.options.sanitize,this.options.baseUrl,N),N===null)return oe;var fe='<a href="'+a(N)+'"';return H&&(fe+=' title="'+H+'"'),fe+=">"+oe+"</a>",fe},G.image=function(N,H,oe){if(N=t(this.options.sanitize,this.options.baseUrl,N),N===null)return oe;var fe='<img src="'+N+'" alt="'+oe+'"';return H&&(fe+=' title="'+H+'"'),fe+=this.options.xhtml?"/>":">",fe},G.text=function(N){return N},j}(),M=function(){function j(){}var G=j.prototype;return G.strong=function(N){return N},G.em=function(N){return N},G.codespan=function(N){return N},G.del=function(N){return N},G.html=function(N){return N},G.text=function(N){return N},G.link=function(N,H,oe){return""+oe},G.image=function(N,H,oe){return""+oe},G.br=function(){return""},j}(),B=function(){function j(){this.seen={}}var G=j.prototype;return G.serialize=function(N){return N.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},G.getNextSafeSlug=function(N,H){var oe=N,fe=0;if(this.seen.hasOwnProperty(oe)){fe=this.seen[N];do fe++,oe=N+"-"+fe;while(this.seen.hasOwnProperty(oe))}return H||(this.seen[N]=fe,this.seen[oe]=0),oe},G.slug=function(N,H){H===void 0&&(H={});var oe=this.serialize(N);return this.getNextSafeSlug(oe,H.dryrun)},j}(),re=function(){function j(Q){this.options=Q||se.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new M,this.slugger=new B}j.parse=function(N,H){var oe=new j(H);return oe.parse(N)},j.parseInline=function(N,H){var oe=new j(H);return oe.parseInline(N)};var G=j.prototype;return G.parse=function(N,H){H===void 0&&(H=!0);var oe="",fe,Ee,Ne,de,$e,Re,Ce,me,Ie,Ae,Me,qe,Qe,Ge,Ye,We,rt,at,nt,ct=N.length;for(fe=0;fe<ct;fe++){if(Ae=N[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(nt=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ae.type))){oe+=nt||"";continue}switch(Ae.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Ae.tokens),Ae.depth,m(this.parseInline(Ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Ae.text,Ae.lang,Ae.escaped);continue}case"table":{for(me="",Ce="",de=Ae.header.length,Ee=0;Ee<de;Ee++)Ce+=this.renderer.tablecell(this.parseInline(Ae.header[Ee].tokens),{header:!0,align:Ae.align[Ee]});for(me+=this.renderer.tablerow(Ce),Ie="",de=Ae.rows.length,Ee=0;Ee<de;Ee++){for(Re=Ae.rows[Ee],Ce="",$e=Re.length,Ne=0;Ne<$e;Ne++)Ce+=this.renderer.tablecell(this.parseInline(Re[Ne].tokens),{header:!1,align:Ae.align[Ne]});Ie+=this.renderer.tablerow(Ce)}oe+=this.renderer.table(me,Ie);continue}case"blockquote":{Ie=this.parse(Ae.tokens),oe+=this.renderer.blockquote(Ie);continue}case"list":{for(Me=Ae.ordered,qe=Ae.start,Qe=Ae.loose,de=Ae.items.length,Ie="",Ee=0;Ee<de;Ee++)Ye=Ae.items[Ee],We=Ye.checked,rt=Ye.task,Ge="",Ye.task&&(at=this.renderer.checkbox(We),Qe?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=at+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=at+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:at}):Ge+=at),Ge+=this.parse(Ye.tokens,Qe),Ie+=this.renderer.listitem(Ge,rt,We);oe+=this.renderer.list(Ie,Me,qe);continue}case"html":{oe+=this.renderer.html(Ae.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Ae.tokens));continue}case"text":{for(Ie=Ae.tokens?this.parseInline(Ae.tokens):Ae.text;fe+1<ct&&N[fe+1].type==="text";)Ae=N[++fe],Ie+=`
`+(Ae.tokens?this.parseInline(Ae.tokens):Ae.text);oe+=H?this.renderer.paragraph(Ie):Ie;continue}default:{var it='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(it);return}else throw new Error(it)}}}return oe},G.parseInline=function(N,H){H=H||this.renderer;var oe="",fe,Ee,Ne,de=N.length;for(fe=0;fe<de;fe++){if(Ee=N[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(Ne=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),Ne!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ee.type))){oe+=Ne||"";continue}switch(Ee.type){case"escape":{oe+=H.text(Ee.text);break}case"html":{oe+=H.html(Ee.text);break}case"link":{oe+=H.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,H));break}case"image":{oe+=H.image(Ee.href,Ee.title,Ee.text);break}case"strong":{oe+=H.strong(this.parseInline(Ee.tokens,H));break}case"em":{oe+=H.em(this.parseInline(Ee.tokens,H));break}case"codespan":{oe+=H.codespan(Ee.text);break}case"br":{oe+=H.br();break}case"del":{oe+=H.del(this.parseInline(Ee.tokens,H));break}case"text":{oe+=H.text(Ee.text);break}default:{var $e='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return oe},j}();function ce(j,G,Q){if(typeof j>"u"||j===null)throw new Error("marked(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");if(typeof G=="function"&&(Q=G,G=null),G=D({},ce.defaults,G||{}),C(G),Q){var N=G.highlight,H;try{H=K.lex(j,G)}catch(de){return Q(de)}var oe=function($e){var Re;if(!$e)try{G.walkTokens&&ce.walkTokens(H,G.walkTokens),Re=re.parse(H,G)}catch(Ce){$e=Ce}return G.highlight=N,$e?Q($e):Q(null,Re)};if(!N||N.length<3||(delete G.highlight,!H.length))return oe();var fe=0;ce.walkTokens(H,function(de){de.type==="code"&&(fe++,setTimeout(function(){N(de.text,de.lang,function($e,Re){if($e)return oe($e);Re!=null&&Re!==de.text&&(de.text=Re,de.escaped=!0),fe--,fe===0&&oe()})},0))}),fe===0&&oe();return}function Ee(de){if(de.message+=`
Please report this to https://github.com/markedjs/marked.`,G.silent)return"<p>An error occurred:</p><pre>"+a(de.message+"",!0)+"</pre>";throw de}try{var Ne=K.lex(j,G);if(G.walkTokens){if(G.async)return Promise.all(ce.walkTokens(Ne,G.walkTokens)).then(function(){return re.parse(Ne,G)}).catch(Ee);ce.walkTokens(Ne,G.walkTokens)}return re.parse(Ne,G)}catch(de){Ee(de)}}ce.options=ce.setOptions=function(j){return D(ce.defaults,j),A(ce.defaults),ce},ce.getDefaults=R,ce.defaults=se.defaults,ce.use=function(){for(var j=arguments.length,G=new Array(j),Q=0;Q<j;Q++)G[Q]=arguments[Q];var N=D.apply(void 0,[{}].concat(G)),H=ce.defaults.extensions||{renderers:{},childTokens:{}},oe;G.forEach(function(fe){if(fe.extensions&&(oe=!0,fe.extensions.forEach(function(Ne){if(!Ne.name)throw new Error("extension name required");if(Ne.renderer){var de=H.renderers?H.renderers[Ne.name]:null;de?H.renderers[Ne.name]=function(){for(var $e=arguments.length,Re=new Array($e),Ce=0;Ce<$e;Ce++)Re[Ce]=arguments[Ce];var me=Ne.renderer.apply(this,Re);return me===!1&&(me=de.apply(this,Re)),me}:H.renderers[Ne.name]=Ne.renderer}if(Ne.tokenizer){if(!Ne.level||Ne.level!=="block"&&Ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");H[Ne.level]?H[Ne.level].unshift(Ne.tokenizer):H[Ne.level]=[Ne.tokenizer],Ne.start&&(Ne.level==="block"?H.startBlock?H.startBlock.push(Ne.start):H.startBlock=[Ne.start]:Ne.level==="inline"&&(H.startInline?H.startInline.push(Ne.start):H.startInline=[Ne.start]))}Ne.childTokens&&(H.childTokens[Ne.name]=Ne.childTokens)})),fe.renderer&&function(){var Ne=ce.defaults.renderer||new ae,de=function(Ce){var me=Ne[Ce];Ne[Ce]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),Me=0;Me<Ie;Me++)Ae[Me]=arguments[Me];var qe=fe.renderer[Ce].apply(Ne,Ae);return qe===!1&&(qe=me.apply(Ne,Ae)),qe}};for(var $e in fe.renderer)de($e);N.renderer=Ne}(),fe.tokenizer&&function(){var Ne=ce.defaults.tokenizer||new J,de=function(Ce){var me=Ne[Ce];Ne[Ce]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),Me=0;Me<Ie;Me++)Ae[Me]=arguments[Me];var qe=fe.tokenizer[Ce].apply(Ne,Ae);return qe===!1&&(qe=me.apply(Ne,Ae)),qe}};for(var $e in fe.tokenizer)de($e);N.tokenizer=Ne}(),fe.walkTokens){var Ee=ce.defaults.walkTokens;N.walkTokens=function(Ne){var de=[];return de.push(fe.walkTokens.call(this,Ne)),Ee&&(de=de.concat(Ee.call(this,Ne))),de}}oe&&(N.extensions=H),ce.setOptions(N)})},ce.walkTokens=function(j,G){for(var Q=[],N=function(){var Ee=oe.value;switch(Q=Q.concat(G.call(ce,Ee)),Ee.type){case"table":{for(var Ne=I(Ee.header),de;!(de=Ne()).done;){var $e=de.value;Q=Q.concat(ce.walkTokens($e.tokens,G))}for(var Re=I(Ee.rows),Ce;!(Ce=Re()).done;)for(var me=Ce.value,Ie=I(me),Ae;!(Ae=Ie()).done;){var Me=Ae.value;Q=Q.concat(ce.walkTokens(Me.tokens,G))}break}case"list":{Q=Q.concat(ce.walkTokens(Ee.items,G));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ee.type]?ce.defaults.extensions.childTokens[Ee.type].forEach(function(qe){Q=Q.concat(ce.walkTokens(Ee[qe],G))}):Ee.tokens&&(Q=Q.concat(ce.walkTokens(Ee.tokens,G)))}},H=I(j),oe;!(oe=H()).done;)N();return Q},ce.parseInline=function(j,G){if(typeof j>"u"||j===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");G=D({},ce.defaults,G||{}),C(G);try{var Q=K.lexInline(j,G);return G.walkTokens&&ce.walkTokens(Q,G.walkTokens),re.parseInline(Q,G)}catch(N){if(N.message+=`
Please report this to https://github.com/markedjs/marked.`,G.silent)return"<p>An error occurred:</p><pre>"+a(N.message+"",!0)+"</pre>";throw N}},ce.Parser=re,ce.parser=re.parse,ce.Renderer=ae,ce.TextRenderer=M,ce.Lexer=K,ce.lexer=K.lex,ce.Tokenizer=J,ce.Slugger=B,ce.parse=ce;var pe=ce.options,W=ce.setOptions,ue=ce.use,_=ce.walkTokens,U=ce.parseInline,O=ce,te=re.parse,V=K.lex;se.Lexer=K,se.Parser=re,se.Renderer=ae,se.Slugger=B,se.TextRenderer=M,se.Tokenizer=J,se.getDefaults=R,se.lexer=V,se.marked=ce,se.options=pe,se.parse=O,se.parseInline=U,se.parser=te,se.setOptions=W,se.use=ue,se.walkTokens=_,Object.defineProperty(se,"__esModule",{value:!0})}),define(Se[81],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(Se[162],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=n;function n(h){const m=I(h);if(m&&m.length>0)return new Uint32Array(m)}let r=0;const E=new Uint32Array(10);function I(h){if(r=0,R(h,v,y.InitialConsonant),r>0||(R(h,f,y.Vowel),r>0)||(R(h,w,y.FinalConsonant),r>0)||(R(h,a,y.CompatibilityJamo),r))return E.subarray(0,r);if(h>=44032&&h<=55203){const m=h-44032,$=m%588,p=Math.floor(m/588),d=Math.floor($/28),b=$%28-1;if(p<v.length?R(p,v,0):y.InitialConsonant+p-y.CompatibilityJamo<a.length&&R(y.InitialConsonant+p,a,y.CompatibilityJamo),d<f.length?R(d,f,0):y.Vowel+d-y.CompatibilityJamo<a.length&&R(y.Vowel+d-y.CompatibilityJamo,a,y.CompatibilityJamo),b>=0&&(b<w.length?R(b,w,0):y.FinalConsonant+b-y.CompatibilityJamo<a.length&&R(y.FinalConsonant+b-y.CompatibilityJamo,a,y.CompatibilityJamo)),r>0)return E.subarray(0,r)}}function R(h,m,$){h>=$&&h<$+m.length&&A(m[h-$])}function A(h){h!==o.NUL&&(E[r++]=h&255,h>>8&&(E[r++]=h>>8&255),h>>16&&(E[r++]=h>>16&255))}var y;(function(h){h[h.InitialConsonant=4352]="InitialConsonant",h[h.Vowel=4449]="Vowel",h[h.FinalConsonant=4520]="FinalConsonant",h[h.CompatibilityJamo=12593]="CompatibilityJamo"})(y||(y={}));var o;(function(h){h[h.NUL=0]="NUL",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z"})(o||(o={}));var S;(function(h){h[h.fa=24934]="fa",h[h.fg=26470]="fg",h[h.fq=29030]="fq",h[h.fr=29286]="fr",h[h.ft=29798]="ft",h[h.fv=30310]="fv",h[h.fx=30822]="fx",h[h.hk=27496]="hk",h[h.hl=27752]="hl",h[h.ho=28520]="ho",h[h.ml=27757]="ml",h[h.nj=27246]="nj",h[h.nl=27758]="nl",h[h.np=28782]="np",h[h.qt=29809]="qt",h[h.rt=29810]="rt",h[h.sg=26483]="sg",h[h.sw=30579]="sw"})(S||(S={}));const v=new Uint8Array([o.r,o.R,o.s,o.e,o.E,o.f,o.a,o.q,o.Q,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g]),f=new Uint16Array([o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,S.hk,S.ho,S.hl,o.y,o.n,S.nj,S.np,S.nl,o.b,o.m,S.ml,o.l]),w=new Uint16Array([o.r,o.R,S.rt,o.s,S.sw,S.sg,o.e,o.f,S.fr,S.fa,S.fq,S.ft,S.fx,S.fv,S.fg,o.a,o.q,S.qt,o.t,o.T,o.d,o.w,o.c,o.z,o.x,o.v,o.g]),a=new Uint16Array([o.r,o.R,S.rt,o.s,S.sw,S.sg,o.e,o.E,o.f,S.fr,S.fa,S.fq,S.ft,S.fx,S.fv,S.fg,o.a,o.q,o.Q,S.qt,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g,o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,S.hk,S.ho,S.hl,o.y,o.n,S.nj,S.np,S.nl,o.b,o.m,S.ml,o.l])}),define(Se[108],ke([1,0,26]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=E,e.$om=R;const r=new n.$Gc(1e4);function E(o){return y(o,"NFC",r)}const I=new n.$Gc(1e4);function R(o){return y(o,"NFD",I)}const A=/[^\u0000-\u0080]/;function y(o,S,v){if(!o)return o;const f=v.get(o);if(f)return f;let w;return A.test(o)?w=o.normalize(S):w=o,v.set(o,w),w}e.$pm=function(){const o=/[\u0300-\u036f]/g;return function(S){return R(S).replace(o,"")}}()}),define(Se[163],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=n,e.rot=r,e.$Qm=A;function n(y,o,S){return Math.min(Math.max(y,o),S)}function r(y,o){return(o+y%o)%o}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=E;class I{constructor(){this.a=1,this.b=0}update(o){return this.b=this.b+(o-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=I;class R{constructor(o){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(o),this.c.fill(0,0,o)}update(o){const S=this.c[this.d];return this.c[this.d]=o,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=o,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=R;function A(y,o,S,v,f,w,a,h){const m=a-S,$=h-v,p=f-S,d=w-v,b=y-S,t=o-v,l=m*m+$*$,i=m*p+$*d,g=m*b+$*t,s=p*p+d*d,c=p*b+d*t,u=1/(l*s-i*i),D=(s*g-i*c)*u,P=(l*c-i*g)*u;return D>=0&&P>=0&&D+P<1}}),define(Se[164],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=I,e.$fd=f;class n{constructor(a,h,m){this.owner=a,this.debugNameSource=h,this.referenceFn=m}getDebugName(a){return I(a,this)}}e.$dd=n;const r=new Map,E=new WeakMap;function I(w,a){const h=E.get(w);if(h)return h;const m=R(w,a);if(m){let $=r.get(m)??0;$++,r.set(m,$);const p=$===1?m:`${m}#${$}`;return E.set(w,p),p}}function R(w,a){const h=E.get(w);if(h)return h;const m=a.owner?S(a.owner)+".":"";let $;const p=a.debugNameSource;if(p!==void 0)if(typeof p=="function"){if($=p(),$!==void 0)return m+$}else return m+p;const d=a.referenceFn;if(d!==void 0&&($=f(d),$!==void 0))return m+$;if(a.owner!==void 0){const b=A(a.owner,w);if(b!==void 0)return m+b}}function A(w,a){for(const h in w)if(w[h]===a)return h}const y=new Map,o=new WeakMap;function S(w){const a=o.get(w);if(a)return a;const h=v(w);let m=y.get(h)??0;m++,y.set(h,m);const $=m===1?h:`${h}#${m}`;return o.set(w,$),$}function v(w){const a=w.constructor;return a?a.name:"Object"}function f(w){const a=w.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(m?m[1]:void 0)?.trim()}}),define(Se[165],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Md=r,e.$Nd=E;let n;function r(h){n=h}function E(){return n}class I{constructor(){this.a=0,this.d=new WeakMap}b(m){return R([A(w("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[A(" "),o(S(m.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),o(S(m.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),o(S(m.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(m,$){console.log(...this.b([y("observable value changed"),o(m.debugName,{color:"BlueViolet"}),...this.c($)]))}formatChanges(m){if(m.size!==0)return o(" (changed deps: "+[...m].map($=>$.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(p,d)=>(this.d.get(m).add(p),$.apply(m,[p,d]))}handleDerivedRecomputed(m,$){const p=this.d.get(m);console.log(...this.b([y("derived recomputed"),o(m.debugName,{color:"BlueViolet"}),...this.c($),this.formatChanges(p),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),p.clear()}handleFromEventObservableTriggered(m,$){console.log(...this.b([y("observable from event triggered"),o(m.debugName,{color:"BlueViolet"}),...this.c($),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const $=m.handleChange;this.d.set(m,new Set),m.handleChange=(p,d)=>(this.d.get(m).add(p),$.apply(m,[p,d]))}handleAutorunTriggered(m){const $=this.d.get(m);console.log(...this.b([y("autorun"),o(m.debugName,{color:"BlueViolet"}),this.formatChanges($),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),$.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let $=m.getDebugName();$===void 0&&($=""),console.log(...this.b([y("transaction"),o($,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Od=I;function R(h){const m=new Array,$=[];let p="";function d(t){if("length"in t)for(const l of t)l&&d(l);else"text"in t?(p+=`%c${t.text}`,m.push(t.style),t.data&&$.push(...t.data)):"data"in t&&$.push(...t.data)}d(h);const b=[p,...m];return b.push(...$),b}function A(h){return o(h,{color:"black"})}function y(h){return o(a(`${h}: `,10),{color:"black",bold:!0})}function o(h,m={color:"black"}){function $(d){return Object.entries(d).reduce((b,[t,l])=>`${b}${t}:${l};`,"")}const p={color:m.color};return m.strikeThrough&&(p["text-decoration"]="line-through"),m.bold&&(p["font-weight"]="bold"),{text:h,style:$(p)}}function S(h,m){switch(typeof h){case"number":return""+h;case"string":return h.length+2<=m?`"${h}"`:`"${h.substr(0,m-7)}"+...`;case"boolean":return h?"true":"false";case"undefined":return"undefined";case"object":return h===null?"null":Array.isArray(h)?v(h,m):f(h,m);case"symbol":return h.toString();case"function":return`[[Function${h.name?" "+h.name:""}]]`;default:return""+h}}function v(h,m){let $="[ ",p=!0;for(const d of h){if(p||($+=", "),$.length-5>m){$+="...";break}p=!1,$+=`${S(d,m-$.length)}`}return $+=" ]",$}function f(h,m){let $="{ ",p=!0;for(const[d,b]of Object.entries(h)){if(p||($+=", "),$.length-5>m){$+="...";break}p=!1,$+=`${d}: ${S(b,m-$.length)}`}return $+=" }",$}function w(h,m){let $="";for(let p=1;p<=m;p++)$+=h;return $}function a(h,m){for(;h.length<m;)h+=" ";return h}}),define(Se[166],ke([1,0,158,164,165]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$9d=e.$7d=e.$2d=e.$1d=void 0,e.$Xd=R,e.$Yd=y,e.$Zd=S,e.$3d=w,e.$4d=h,e.$5d=m,e.$6d=$,e.$8d=d,e.$0d=t;let I;function R(i){I=i}let A;function y(i){A=i}let o;function S(i){o=i}class v{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,s){const c=s===void 0?void 0:g,u=s===void 0?g:s;return o({owner:c,debugName:()=>{const D=(0,r.$fd)(u);if(D!==void 0)return D;const T=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(u.toString());if(T)return`${this.debugName}.${T[2]}`;if(!c)return`${this.debugName} (mapped)`},debugReferenceFn:u},D=>u(this.read(D),D))}recomputeInitiallyAndOnChange(g,s){return g.add(I(this,s)),this}keepObserved(g){return g.add(A(this)),this}get a(){return this.get()}}e.$1d=v;class f extends v{constructor(){super(...arguments),this.b=new Set}addObserver(g){const s=this.b.size;this.b.add(g),s===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$2d=f;function w(i,g){const s=new p(i,g);try{i(s)}finally{s.finish()}}let a;function h(i){if(a)i(a);else{const g=new p(i,void 0);a=g;try{i(g)}finally{g.finish(),a=void 0}}}async function m(i,g){const s=new p(i,g);try{await i(s)}finally{s.finish()}}function $(i,g,s){i?g(i):w(g,s)}class p{constructor(g,s){this._fn=g,this.b=s,this.a=[],(0,E.$Nd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,r.$fd)(this._fn)}updateObserver(g,s){this.a.push({observer:g,observable:s}),g.beginUpdate(s)}finish(){const g=this.a;for(let s=0;s<g.length;s++){const{observer:c,observable:u}=g[s];c.endUpdate(u)}this.a=null,(0,E.$Nd)()?.handleEndTransaction()}}e.$7d=p;function d(i,g){let s;return typeof i=="string"?s=new r.$dd(void 0,i,void 0):s=new r.$dd(i,void 0,void 0),new b(s,g,n.$9c)}class b extends f{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,s,c){super(),this.e=g,this.g=c,this.d=s}get(){return this.d}set(g,s,c){if(c===void 0&&this.g(this.d,g))return;let u;s||(s=u=new p(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(g),(0,E.$Nd)()?.handleObservableChanged(this,{oldValue:D,newValue:g,change:c,didChange:!0,hadValue:!0});for(const P of this.b)s.updateObserver(P,this),P.handleChange(this,c)}finally{u&&u.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$9d=b;function t(i,g){let s;return typeof i=="string"?s=new r.$dd(void 0,i,void 0):s=new r.$dd(i,void 0,void 0),new l(s,g,n.$9c)}class l extends b{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$$d=l}),function(){function se(E){const I=[];typeof E=="number"&&I.push("code/timeOrigin",E);function R(y){I.push(y,Date.now())}function A(){const y=[];for(let o=0;o<I.length;o+=2)y.push({name:I[o],startTime:I[o+1]});return y}return{mark:R,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const R of performance.getEntriesByType("mark"))I.push({name:R.name,startTime:Math.round(E+R.startTime)});return I}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function n(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(Se[3],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=l,e.$x=D,e.$D=P,e.$a="en";let n=!1,r=!1,E=!1,I=!1,R=!1,A=!1,y=!1,o=!1,S=!1,v=!1,f,w=e.$a,a=e.$a,h,m;const $=globalThis;let p;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?p=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const d=typeof p?.versions?.electron=="string",b=d&&p?.type==="renderer";if(typeof p=="object"){n=p.platform==="win32",r=p.platform==="darwin",E=p.platform==="linux",I=E&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,y=d,S=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$a,w=e.$a;const T=p.env.VSCODE_NLS_CONFIG;if(T)try{const z=JSON.parse(T),C=z.availableLanguages["*"];f=z.locale,a=z.osLocale,w=C||e.$a,h=z._translationsConfigFile}catch{}R=!0}else if(typeof navigator=="object"&&!b){m=navigator.userAgent,n=m.indexOf("Windows")>=0,r=m.indexOf("Macintosh")>=0,o=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=m.indexOf("Linux")>=0,v=m?.indexOf("Mobi")>=0,A=!0,f=e.$a,w=f,a=navigator.language;const T=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),z=T&&T.getAttribute("data-settings");if(z)try{const C=JSON.parse(z),k=C.availableLanguages["*"];f=C.locale,a=C.osLocale,w=k||e.$a,h=C._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var t;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(t||(e.Platform=t={}));function l(T){switch(T){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let i=t.Web;r?i=t.Mac:n?i=t.Windows:E&&(i=t.Linux),e.$c=n,e.$d=r,e.$e=E,e.$f=I,e.$g=R,e.$h=y,e.$i=A,e.$j=A&&typeof $.importScripts=="function",e.$k=e.$j?$.origin:void 0,e.$l=o,e.$m=v,e.$n=S,e.$o=i,e.$p=m,e.$q=w;var g;(function(T){function z(){return e.$q}T.value=z;function C(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}T.isDefaultVariant=C;function k(){return e.$q==="en"}T.isDefault=k})(g||(e.Language=g={})),e.$r=f,e.$s=a,e.$t=h,e.$u=typeof $.postMessage=="function"&&!$.importScripts,e.$v=(()=>{if(e.$u){const T=[];$.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let k=0,q=T.length;k<q;k++){const Y=T[k];if(Y.id===C.data.vscodeScheduleAsyncWork){T.splice(k,1),Y.callback();return}}});let z=0;return C=>{const k=++z;T.push({id:k,callback:C}),$.postMessage({vscodeScheduleAsyncWork:k},"*")}}return T=>setTimeout(T)})();var s;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=r||o?s.Macintosh:n?s.Windows:s.Linux;let c=!0,u=!1;function D(){if(!u){u=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,c=new Uint16Array(T.buffer)[0]===513}return c}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function P(T){return parseFloat(T)>=20}}),define(Se[167],ke([1,0,40]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=void 0;const r=Symbol("unset");class E{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||n.Iterable.empty()}insert(y,o,S){this.d(y,v=>v._value=o,S)}mutate(y,o){this.d(y,S=>S._value=o(S._value===r?void 0:S._value))}mutatePath(y,o){this.d(y,()=>{},S=>o(S))}delete(y){const o=this.c(y);if(!o)return;let S=o.length-1;const v=o[S].node._value;if(v!==r){for(this.b--,o[S].node._value=r;S>0;S--){const{node:f,part:w}=o[S];if(f.children?.size||f._value!==r)break;o[S-1].node.children.delete(w)}return v}}*deleteRecursive(y){const o=this.c(y);if(!o)return;const S=o[o.length-1].node;for(let v=o.length-1;v>0;v--){const f=o[v-1];if(f.node.children.delete(o[v].part),f.node.children.size>0||f.node._value!==r)break}for(const v of I(S))v._value!==r&&(this.b--,yield v._value)}find(y){let o=this.a;for(const S of y){const v=o.children?.get(S);if(!v)return;o=v}return o._value===r?void 0:o._value}hasKeyOrParent(y){let o=this.a;for(const S of y){const v=o.children?.get(S);if(!v)return!1;if(v._value!==r)return!0;o=v}return!1}hasKeyOrChildren(y){let o=this.a;for(const S of y){const v=o.children?.get(S);if(!v)return!1;o=v}return!0}hasKey(y){let o=this.a;for(const S of y){const v=o.children?.get(S);if(!v)return!1;o=v}return o._value!==r}c(y){const o=[{part:"",node:this.a}];let S=0;for(const v of y){const f=o[S].node.children?.get(v);if(!f)return;o.push({part:v,node:f}),S++}return o}d(y,o,S){let v=this.a;for(const a of y){if(v.children)if(v.children.has(a))v=v.children.get(a);else{const h=new R;v.children.set(a,h),v=h}else{const h=new R;v.children=new Map([[a,h]]),v=h}S?.(v)}const f=v._value===r?0:1;o(v);const w=v._value===r?0:1;this.b+=w-f}*values(){for(const{_value:y}of I(this.a))y!==r&&(yield y)}}e.$TI=E;function*I(A){const y=[A];for(;y.length>0;){const o=y.pop();if(yield o,o.children)for(const S of o.children.values())y.push(S)}}class R{constructor(){this._value=r}get value(){return this._value===r?void 0:this._value}set value(y){this._value=y===void 0?r:y}}}),define(Se[32],ke([1,0,3]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const I=E.process;r={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$c?"win32":n.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$gc=r.platform,e.$hc=r.arch}),define(Se[9],ke([1,0,32]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,n=Be(n);const r=65,E=97,I=90,R=122,A=46,y=47,o=92,S=58,v=63;class f extends Error{constructor(i,g,s){let c;typeof g=="string"&&g.indexOf("not ")===0?(c="must not be",g=g.replace(/^not /,"")):c="must be";const u=i.indexOf(".")!==-1?"property":"argument";let D=`The "${i}" ${u} ${c} of type ${g}`;D+=`. Received type ${typeof s}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function w(l,i){if(l===null||typeof l!="object")throw new f(i,"Object",l)}function a(l,i){if(typeof l!="string")throw new f(i,"string",l)}const h=n.$gc==="win32";function m(l){return l===y||l===o}function $(l){return l===y}function p(l){return l>=r&&l<=I||l>=E&&l<=R}function d(l,i,g,s){let c="",u=0,D=-1,P=0,T=0;for(let z=0;z<=l.length;++z){if(z<l.length)T=l.charCodeAt(z);else{if(s(T))break;T=y}if(s(T)){if(!(D===z-1||P===1))if(P===2){if(c.length<2||u!==2||c.charCodeAt(c.length-1)!==A||c.charCodeAt(c.length-2)!==A){if(c.length>2){const C=c.lastIndexOf(g);C===-1?(c="",u=0):(c=c.slice(0,C),u=c.length-1-c.lastIndexOf(g)),D=z,P=0;continue}else if(c.length!==0){c="",u=0,D=z,P=0;continue}}i&&(c+=c.length>0?`${g}..`:"..",u=2)}else c.length>0?c+=`${g}${l.slice(D+1,z)}`:c=l.slice(D+1,z),u=z-D-1;D=z,P=0}else T===A&&P!==-1?++P:P=-1}return c}function b(l,i){w(i,"pathObject");const g=i.dir||i.root,s=i.base||`${i.name||""}${i.ext||""}`;return g?g===i.root?`${g}${s}`:`${g}${l}${s}`:s}e.$ic={resolve(...l){let i="",g="",s=!1;for(let c=l.length-1;c>=-1;c--){let u;if(c>=0){if(u=l[c],a(u,"path"),u.length===0)continue}else i.length===0?u=n.cwd():(u=n.env[`=${i}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==i.toLowerCase()&&u.charCodeAt(2)===o)&&(u=`${i}\\`));const D=u.length;let P=0,T="",z=!1;const C=u.charCodeAt(0);if(D===1)m(C)&&(P=1,z=!0);else if(m(C))if(z=!0,m(u.charCodeAt(1))){let k=2,q=k;for(;k<D&&!m(u.charCodeAt(k));)k++;if(k<D&&k!==q){const Y=u.slice(q,k);for(q=k;k<D&&m(u.charCodeAt(k));)k++;if(k<D&&k!==q){for(q=k;k<D&&!m(u.charCodeAt(k));)k++;(k===D||k!==q)&&(T=`\\\\${Y}\\${u.slice(q,k)}`,P=k)}}}else P=1;else p(C)&&u.charCodeAt(1)===S&&(T=u.slice(0,2),P=2,D>2&&m(u.charCodeAt(2))&&(z=!0,P=3));if(T.length>0)if(i.length>0){if(T.toLowerCase()!==i.toLowerCase())continue}else i=T;if(s){if(i.length>0)break}else if(g=`${u.slice(P)}\\${g}`,s=z,z&&i.length>0)break}return g=d(g,!s,"\\",m),s?`${i}\\${g}`:`${i}${g}`||"."},normalize(l){a(l,"path");const i=l.length;if(i===0)return".";let g=0,s,c=!1;const u=l.charCodeAt(0);if(i===1)return $(u)?"\\":l;if(m(u))if(c=!0,m(l.charCodeAt(1))){let P=2,T=P;for(;P<i&&!m(l.charCodeAt(P));)P++;if(P<i&&P!==T){const z=l.slice(T,P);for(T=P;P<i&&m(l.charCodeAt(P));)P++;if(P<i&&P!==T){for(T=P;P<i&&!m(l.charCodeAt(P));)P++;if(P===i)return`\\\\${z}\\${l.slice(T)}\\`;P!==T&&(s=`\\\\${z}\\${l.slice(T,P)}`,g=P)}}}else g=1;else p(u)&&l.charCodeAt(1)===S&&(s=l.slice(0,2),g=2,i>2&&m(l.charCodeAt(2))&&(c=!0,g=3));let D=g<i?d(l.slice(g),!c,"\\",m):"";return D.length===0&&!c&&(D="."),D.length>0&&m(l.charCodeAt(i-1))&&(D+="\\"),s===void 0?c?`\\${D}`:D:c?`${s}\\${D}`:`${s}${D}`},isAbsolute(l){a(l,"path");const i=l.length;if(i===0)return!1;const g=l.charCodeAt(0);return m(g)||i>2&&p(g)&&l.charCodeAt(1)===S&&m(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let i,g;for(let u=0;u<l.length;++u){const D=l[u];a(D,"path"),D.length>0&&(i===void 0?i=g=D:i+=`\\${D}`)}if(i===void 0)return".";let s=!0,c=0;if(typeof g=="string"&&m(g.charCodeAt(0))){++c;const u=g.length;u>1&&m(g.charCodeAt(1))&&(++c,u>2&&(m(g.charCodeAt(2))?++c:s=!1))}if(s){for(;c<i.length&&m(i.charCodeAt(c));)c++;c>=2&&(i=`\\${i.slice(c)}`)}return e.$ic.normalize(i)},relative(l,i){if(a(l,"from"),a(i,"to"),l===i)return"";const g=e.$ic.resolve(l),s=e.$ic.resolve(i);if(g===s||(l=g.toLowerCase(),i=s.toLowerCase(),l===i))return"";let c=0;for(;c<l.length&&l.charCodeAt(c)===o;)c++;let u=l.length;for(;u-1>c&&l.charCodeAt(u-1)===o;)u--;const D=u-c;let P=0;for(;P<i.length&&i.charCodeAt(P)===o;)P++;let T=i.length;for(;T-1>P&&i.charCodeAt(T-1)===o;)T--;const z=T-P,C=D<z?D:z;let k=-1,q=0;for(;q<C;q++){const J=l.charCodeAt(c+q);if(J!==i.charCodeAt(P+q))break;J===o&&(k=q)}if(q!==C){if(k===-1)return s}else{if(z>C){if(i.charCodeAt(P+q)===o)return s.slice(P+q+1);if(q===2)return s.slice(P+q)}D>C&&(l.charCodeAt(c+q)===o?k=q:q===2&&(k=3)),k===-1&&(k=0)}let Y="";for(q=c+k+1;q<=u;++q)(q===u||l.charCodeAt(q)===o)&&(Y+=Y.length===0?"..":"\\..");return P+=k,Y.length>0?`${Y}${s.slice(P,T)}`:(s.charCodeAt(P)===o&&++P,s.slice(P,T))},toNamespacedPath(l){if(typeof l!="string"||l.length===0)return l;const i=e.$ic.resolve(l);if(i.length<=2)return l;if(i.charCodeAt(0)===o){if(i.charCodeAt(1)===o){const g=i.charCodeAt(2);if(g!==v&&g!==A)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(p(i.charCodeAt(0))&&i.charCodeAt(1)===S&&i.charCodeAt(2)===o)return`\\\\?\\${i}`;return l},dirname(l){a(l,"path");const i=l.length;if(i===0)return".";let g=-1,s=0;const c=l.charCodeAt(0);if(i===1)return m(c)?l:".";if(m(c)){if(g=s=1,m(l.charCodeAt(1))){let P=2,T=P;for(;P<i&&!m(l.charCodeAt(P));)P++;if(P<i&&P!==T){for(T=P;P<i&&m(l.charCodeAt(P));)P++;if(P<i&&P!==T){for(T=P;P<i&&!m(l.charCodeAt(P));)P++;if(P===i)return l;P!==T&&(g=s=P+1)}}}}else p(c)&&l.charCodeAt(1)===S&&(g=i>2&&m(l.charCodeAt(2))?3:2,s=g);let u=-1,D=!0;for(let P=i-1;P>=s;--P)if(m(l.charCodeAt(P))){if(!D){u=P;break}}else D=!1;if(u===-1){if(g===-1)return".";u=g}return l.slice(0,u)},basename(l,i){i!==void 0&&a(i,"ext"),a(l,"path");let g=0,s=-1,c=!0,u;if(l.length>=2&&p(l.charCodeAt(0))&&l.charCodeAt(1)===S&&(g=2),i!==void 0&&i.length>0&&i.length<=l.length){if(i===l)return"";let D=i.length-1,P=-1;for(u=l.length-1;u>=g;--u){const T=l.charCodeAt(u);if(m(T)){if(!c){g=u+1;break}}else P===-1&&(c=!1,P=u+1),D>=0&&(T===i.charCodeAt(D)?--D===-1&&(s=u):(D=-1,s=P))}return g===s?s=P:s===-1&&(s=l.length),l.slice(g,s)}for(u=l.length-1;u>=g;--u)if(m(l.charCodeAt(u))){if(!c){g=u+1;break}}else s===-1&&(c=!1,s=u+1);return s===-1?"":l.slice(g,s)},extname(l){a(l,"path");let i=0,g=-1,s=0,c=-1,u=!0,D=0;l.length>=2&&l.charCodeAt(1)===S&&p(l.charCodeAt(0))&&(i=s=2);for(let P=l.length-1;P>=i;--P){const T=l.charCodeAt(P);if(m(T)){if(!u){s=P+1;break}continue}c===-1&&(u=!1,c=P+1),T===A?g===-1?g=P:D!==1&&(D=1):g!==-1&&(D=-1)}return g===-1||c===-1||D===0||D===1&&g===c-1&&g===s+1?"":l.slice(g,c)},format:b.bind(null,"\\"),parse(l){a(l,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return i;const g=l.length;let s=0,c=l.charCodeAt(0);if(g===1)return m(c)?(i.root=i.dir=l,i):(i.base=i.name=l,i);if(m(c)){if(s=1,m(l.charCodeAt(1))){let k=2,q=k;for(;k<g&&!m(l.charCodeAt(k));)k++;if(k<g&&k!==q){for(q=k;k<g&&m(l.charCodeAt(k));)k++;if(k<g&&k!==q){for(q=k;k<g&&!m(l.charCodeAt(k));)k++;k===g?s=k:k!==q&&(s=k+1)}}}}else if(p(c)&&l.charCodeAt(1)===S){if(g<=2)return i.root=i.dir=l,i;if(s=2,m(l.charCodeAt(2))){if(g===3)return i.root=i.dir=l,i;s=3}}s>0&&(i.root=l.slice(0,s));let u=-1,D=s,P=-1,T=!0,z=l.length-1,C=0;for(;z>=s;--z){if(c=l.charCodeAt(z),m(c)){if(!T){D=z+1;break}continue}P===-1&&(T=!1,P=z+1),c===A?u===-1?u=z:C!==1&&(C=1):u!==-1&&(C=-1)}return P!==-1&&(u===-1||C===0||C===1&&u===P-1&&u===D+1?i.base=i.name=l.slice(D,P):(i.name=l.slice(D,u),i.base=l.slice(D,P),i.ext=l.slice(u,P))),D>0&&D!==s?i.dir=l.slice(0,D-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(h){const l=/\\/g;return()=>{const i=n.cwd().replace(l,"/");return i.slice(i.indexOf("/"))}}return()=>n.cwd()})();e.$jc={resolve(...l){let i="",g=!1;for(let s=l.length-1;s>=-1&&!g;s--){const c=s>=0?l[s]:t();a(c,"path"),c.length!==0&&(i=`${c}/${i}`,g=c.charCodeAt(0)===y)}return i=d(i,!g,"/",$),g?`/${i}`:i.length>0?i:"."},normalize(l){if(a(l,"path"),l.length===0)return".";const i=l.charCodeAt(0)===y,g=l.charCodeAt(l.length-1)===y;return l=d(l,!i,"/",$),l.length===0?i?"/":g?"./":".":(g&&(l+="/"),i?`/${l}`:l)},isAbsolute(l){return a(l,"path"),l.length>0&&l.charCodeAt(0)===y},join(...l){if(l.length===0)return".";let i;for(let g=0;g<l.length;++g){const s=l[g];a(s,"path"),s.length>0&&(i===void 0?i=s:i+=`/${s}`)}return i===void 0?".":e.$jc.normalize(i)},relative(l,i){if(a(l,"from"),a(i,"to"),l===i||(l=e.$jc.resolve(l),i=e.$jc.resolve(i),l===i))return"";const g=1,s=l.length,c=s-g,u=1,D=i.length-u,P=c<D?c:D;let T=-1,z=0;for(;z<P;z++){const k=l.charCodeAt(g+z);if(k!==i.charCodeAt(u+z))break;k===y&&(T=z)}if(z===P)if(D>P){if(i.charCodeAt(u+z)===y)return i.slice(u+z+1);if(z===0)return i.slice(u+z)}else c>P&&(l.charCodeAt(g+z)===y?T=z:z===0&&(T=0));let C="";for(z=g+T+1;z<=s;++z)(z===s||l.charCodeAt(z)===y)&&(C+=C.length===0?"..":"/..");return`${C}${i.slice(u+T)}`},toNamespacedPath(l){return l},dirname(l){if(a(l,"path"),l.length===0)return".";const i=l.charCodeAt(0)===y;let g=-1,s=!0;for(let c=l.length-1;c>=1;--c)if(l.charCodeAt(c)===y){if(!s){g=c;break}}else s=!1;return g===-1?i?"/":".":i&&g===1?"//":l.slice(0,g)},basename(l,i){i!==void 0&&a(i,"ext"),a(l,"path");let g=0,s=-1,c=!0,u;if(i!==void 0&&i.length>0&&i.length<=l.length){if(i===l)return"";let D=i.length-1,P=-1;for(u=l.length-1;u>=0;--u){const T=l.charCodeAt(u);if(T===y){if(!c){g=u+1;break}}else P===-1&&(c=!1,P=u+1),D>=0&&(T===i.charCodeAt(D)?--D===-1&&(s=u):(D=-1,s=P))}return g===s?s=P:s===-1&&(s=l.length),l.slice(g,s)}for(u=l.length-1;u>=0;--u)if(l.charCodeAt(u)===y){if(!c){g=u+1;break}}else s===-1&&(c=!1,s=u+1);return s===-1?"":l.slice(g,s)},extname(l){a(l,"path");let i=-1,g=0,s=-1,c=!0,u=0;for(let D=l.length-1;D>=0;--D){const P=l.charCodeAt(D);if(P===y){if(!c){g=D+1;break}continue}s===-1&&(c=!1,s=D+1),P===A?i===-1?i=D:u!==1&&(u=1):i!==-1&&(u=-1)}return i===-1||s===-1||u===0||u===1&&i===s-1&&i===g+1?"":l.slice(i,s)},format:b.bind(null,"/"),parse(l){a(l,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return i;const g=l.charCodeAt(0)===y;let s;g?(i.root="/",s=1):s=0;let c=-1,u=0,D=-1,P=!0,T=l.length-1,z=0;for(;T>=s;--T){const C=l.charCodeAt(T);if(C===y){if(!P){u=T+1;break}continue}D===-1&&(P=!1,D=T+1),C===A?c===-1?c=T:z!==1&&(z=1):c!==-1&&(z=-1)}if(D!==-1){const C=u===0&&g?1:u;c===-1||z===0||z===1&&c===D-1&&c===u+1?i.base=i.name=l.slice(C,D):(i.name=l.slice(C,c),i.base=l.slice(C,D),i.ext=l.slice(c,D))}return u>0?i.dir=l.slice(0,u-1):g&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=h?e.$ic.normalize:e.$jc.normalize,e.$lc=h?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=h?e.$ic.join:e.$jc.join,e.$nc=h?e.$ic.resolve:e.$jc.resolve,e.$oc=h?e.$ic.relative:e.$jc.relative,e.$pc=h?e.$ic.dirname:e.$jc.dirname,e.$qc=h?e.$ic.basename:e.$jc.basename,e.$rc=h?e.$ic.extname:e.$jc.extname,e.$sc=h?e.$ic.format:e.$jc.format,e.$tc=h?e.$ic.parse:e.$jc.parse,e.$uc=h?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=h?e.$ic.sep:e.$jc.sep,e.$wc=h?e.$ic.delimiter:e.$jc.delimiter}),define(Se[66],ke([1,0,9]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$$s=I,e.$_s=R,e.$at=A,e.$bt=o,e.$0s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(S){const v=(0,n.$rc)(S),f=r[v.toLowerCase()];return f!==void 0?f:R(S)}function R(S){const v=(0,n.$rc)(S);return E[v.toLowerCase()]}function A(S){for(const v in E)if(E[v]===S)return v}const y=/^(.+)\/(.+?)(;.+)?$/;function o(S,v){const f=y.exec(S);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:v?void 0:S}}),define(Se[67],ke([1,0,3]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=I,e.$mm=R;var r;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(r||(e.Source=r={}));var E;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function I(A,...y){const o=y.reduce((f,w)=>(f[w]=!0,f),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(A).filter(f=>!o[f]).forEach(f=>{for(let w=0;w<S.length;w++)if(f.search(S[w])!==-1){delete A[f];break}})}function R(A){A&&(delete A.DEBUG,n.$d&&delete A.DYLD_LIBRARY_PATH,n.$e&&delete A.LD_PRELOAD)}}),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:se)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function n(r){if(e[r])return e[r].exports;var E=e[r]={i:r,l:!1,exports:{}};return se[r].call(E.exports,E,E.exports,n),E.l=!0,E.exports}return n.m=se,n.c=e,n.d=function(r,E,I){n.o(r,E)||Object.defineProperty(r,E,{enumerable:!0,get:I})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,E){if(1&E&&(r=n(r)),8&E||4&E&&typeof r=="object"&&r&&r.__esModule)return r;var I=Object.create(null);if(n.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:r}),2&E&&typeof r!="string")for(var R in r)n.d(I,R,function(A){return r[A]}.bind(null,R));return I},n.n=function(r){var E=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(E,"a",E),E},n.o=function(r,E){return Object.prototype.hasOwnProperty.call(r,E)},n.p="",n(n.s=0)}([function(se,e,n){(function(r){var E;e=se.exports=ue,E=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],o=0,S=o++;y[S]="0|[1-9]\\d*";var v=o++;y[v]="[0-9]+";var f=o++;y[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=o++;y[w]="("+y[S]+")\\.("+y[S]+")\\.("+y[S]+")";var a=o++;y[a]="("+y[v]+")\\.("+y[v]+")\\.("+y[v]+")";var h=o++;y[h]="(?:"+y[S]+"|"+y[f]+")";var m=o++;y[m]="(?:"+y[v]+"|"+y[f]+")";var $=o++;y[$]="(?:-("+y[h]+"(?:\\."+y[h]+")*))";var p=o++;y[p]="(?:-?("+y[m]+"(?:\\."+y[m]+")*))";var d=o++;y[d]="[0-9A-Za-z-]+";var b=o++;y[b]="(?:\\+("+y[d]+"(?:\\."+y[d]+")*))";var t=o++,l="v?"+y[w]+y[$]+"?"+y[b]+"?";y[t]="^"+l+"$";var i="[v=\\s]*"+y[a]+y[p]+"?"+y[b]+"?",g=o++;y[g]="^"+i+"$";var s=o++;y[s]="((?:<|>)?=?)";var c=o++;y[c]=y[v]+"|x|X|\\*";var u=o++;y[u]=y[S]+"|x|X|\\*";var D=o++;y[D]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[$]+")?"+y[b]+"?)?)?";var P=o++;y[P]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[p]+")?"+y[b]+"?)?)?";var T=o++;y[T]="^"+y[s]+"\\s*"+y[D]+"$";var z=o++;y[z]="^"+y[s]+"\\s*"+y[P]+"$";var C=o++;y[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var k=o++;y[k]="(?:~>?)";var q=o++;y[q]="(\\s*)"+y[k]+"\\s+",A[q]=new RegExp(y[q],"g");var Y=o++;y[Y]="^"+y[k]+y[D]+"$";var J=o++;y[J]="^"+y[k]+y[P]+"$";var ne=o++;y[ne]="(?:\\^)";var Z=o++;y[Z]="(\\s*)"+y[ne]+"\\s+",A[Z]=new RegExp(y[Z],"g");var x=o++;y[x]="^"+y[ne]+y[D]+"$";var le=o++;y[le]="^"+y[ne]+y[P]+"$";var K=o++;y[K]="^"+y[s]+"\\s*("+i+")$|^$";var ae=o++;y[ae]="^"+y[s]+"\\s*("+l+")$|^$";var M=o++;y[M]="(\\s*)"+y[s]+"\\s*("+i+"|"+y[D]+")",A[M]=new RegExp(y[M],"g");var B=o++;y[B]="^\\s*("+y[D]+")\\s+-\\s+("+y[D]+")\\s*$";var re=o++;y[re]="^\\s*("+y[P]+")\\s+-\\s+("+y[P]+")\\s*$";var ce=o++;y[ce]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)E(pe,y[pe]),A[pe]||(A[pe]=new RegExp(y[pe]));function W(me,Ie){if(me instanceof ue)return me;if(typeof me!="string"||me.length>I||!(Ie?A[g]:A[t]).test(me))return null;try{return new ue(me,Ie)}catch{return null}}function ue(me,Ie){if(me instanceof ue){if(me.loose===Ie)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof ue))return new ue(me,Ie);E("SemVer",me,Ie),this.loose=Ie;var Ae=me.trim().match(Ie?A[g]:A[t]);if(!Ae)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+Ae[1],this.minor=+Ae[2],this.patch=+Ae[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Ae[4]?this.prerelease=Ae[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var qe=+Me;if(qe>=0&&qe<R)return qe}return Me}):this.prerelease=[],this.build=Ae[5]?Ae[5].split("."):[],this.format()}e.parse=W,e.valid=function(me,Ie){var Ae=W(me,Ie);return Ae?Ae.version:null},e.clean=function(me,Ie){var Ae=W(me.trim().replace(/^[=v]+/,""),Ie);return Ae?Ae.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(me){return E("SemVer.compare",this.version,this.loose,me),me instanceof ue||(me=new ue(me,this.loose)),this.compareMain(me)||this.comparePre(me)},ue.prototype.compareMain=function(me){return me instanceof ue||(me=new ue(me,this.loose)),U(this.major,me.major)||U(this.minor,me.minor)||U(this.patch,me.patch)},ue.prototype.comparePre=function(me){if(me instanceof ue||(me=new ue(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var Ie=0;do{var Ae=this.prerelease[Ie],Me=me.prerelease[Ie];if(E("prerelease compare",Ie,Ae,Me),Ae===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(Ae===void 0)return-1;if(Ae!==Me)return U(Ae,Me)}while(++Ie)},ue.prototype.inc=function(me,Ie){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ie),this.inc("pre",Ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ie),this.inc("pre",Ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ae=this.prerelease.length;--Ae>=0;)typeof this.prerelease[Ae]=="number"&&(this.prerelease[Ae]++,Ae=-2);Ae===-1&&this.prerelease.push(0)}Ie&&(this.prerelease[0]===Ie?isNaN(this.prerelease[1])&&(this.prerelease=[Ie,0]):this.prerelease=[Ie,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,Ie,Ae,Me){typeof Ae=="string"&&(Me=Ae,Ae=void 0);try{return new ue(me,Ae).inc(Ie,Me).version}catch{return null}},e.diff=function(me,Ie){if(j(me,Ie))return null;var Ae=W(me),Me=W(Ie);if(Ae.prerelease.length||Me.prerelease.length){for(var qe in Ae)if((qe==="major"||qe==="minor"||qe==="patch")&&Ae[qe]!==Me[qe])return"pre"+qe;return"prerelease"}for(var qe in Ae)if((qe==="major"||qe==="minor"||qe==="patch")&&Ae[qe]!==Me[qe])return qe},e.compareIdentifiers=U;var _=/^[0-9]+$/;function U(me,Ie){var Ae=_.test(me),Me=_.test(Ie);return Ae&&Me&&(me=+me,Ie=+Ie),Ae&&!Me?-1:Me&&!Ae?1:me<Ie?-1:me>Ie?1:0}function O(me,Ie,Ae){return new ue(me,Ae).compare(new ue(Ie,Ae))}function te(me,Ie,Ae){return O(me,Ie,Ae)>0}function V(me,Ie,Ae){return O(me,Ie,Ae)<0}function j(me,Ie,Ae){return O(me,Ie,Ae)===0}function G(me,Ie,Ae){return O(me,Ie,Ae)!==0}function Q(me,Ie,Ae){return O(me,Ie,Ae)>=0}function N(me,Ie,Ae){return O(me,Ie,Ae)<=0}function H(me,Ie,Ae,Me){var qe;switch(Ie){case"===":typeof me=="object"&&(me=me.version),typeof Ae=="object"&&(Ae=Ae.version),qe=me===Ae;break;case"!==":typeof me=="object"&&(me=me.version),typeof Ae=="object"&&(Ae=Ae.version),qe=me!==Ae;break;case"":case"=":case"==":qe=j(me,Ae,Me);break;case"!=":qe=G(me,Ae,Me);break;case">":qe=te(me,Ae,Me);break;case">=":qe=Q(me,Ae,Me);break;case"<":qe=V(me,Ae,Me);break;case"<=":qe=N(me,Ae,Me);break;default:throw new TypeError("Invalid operator: "+Ie)}return qe}function oe(me,Ie){if(me instanceof oe){if(me.loose===Ie)return me;me=me.value}if(!(this instanceof oe))return new oe(me,Ie);E("comparator",me,Ie),this.loose=Ie,this.parse(me),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(me,Ie){return U(Ie,me)},e.major=function(me,Ie){return new ue(me,Ie).major},e.minor=function(me,Ie){return new ue(me,Ie).minor},e.patch=function(me,Ie){return new ue(me,Ie).patch},e.compare=O,e.compareLoose=function(me,Ie){return O(me,Ie,!0)},e.rcompare=function(me,Ie,Ae){return O(Ie,me,Ae)},e.sort=function(me,Ie){return me.sort(function(Ae,Me){return e.compare(Ae,Me,Ie)})},e.rsort=function(me,Ie){return me.sort(function(Ae,Me){return e.rcompare(Ae,Me,Ie)})},e.gt=te,e.lt=V,e.eq=j,e.neq=G,e.gte=Q,e.lte=N,e.cmp=H,e.Comparator=oe;var fe={};function Ee(me,Ie){if(me instanceof Ee)return me.loose===Ie?me:new Ee(me.raw,Ie);if(me instanceof oe)return new Ee(me.value,Ie);if(!(this instanceof Ee))return new Ee(me,Ie);if(this.loose=Ie,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(Ae){return this.parseRange(Ae.trim())},this).filter(function(Ae){return Ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function Ne(me){return!me||me.toLowerCase()==="x"||me==="*"}function de(me,Ie,Ae,Me,qe,Qe,Ge,Ye,We,rt,at,nt,ct){return((Ie=Ne(Ae)?"":Ne(Me)?">="+Ae+".0.0":Ne(qe)?">="+Ae+"."+Me+".0":">="+Ie)+" "+(Ye=Ne(We)?"":Ne(rt)?"<"+(+We+1)+".0.0":Ne(at)?"<"+We+"."+(+rt+1)+".0":nt?"<="+We+"."+rt+"."+at+"-"+nt:"<="+Ye)).trim()}function $e(me,Ie){for(var Ae=0;Ae<me.length;Ae++)if(!me[Ae].test(Ie))return!1;if(Ie.prerelease.length){for(Ae=0;Ae<me.length;Ae++)if(E(me[Ae].semver),me[Ae].semver!==fe&&me[Ae].semver.prerelease.length>0){var Me=me[Ae].semver;if(Me.major===Ie.major&&Me.minor===Ie.minor&&Me.patch===Ie.patch)return!0}return!1}return!0}function Re(me,Ie,Ae){try{Ie=new Ee(Ie,Ae)}catch{return!1}return Ie.test(me)}function Ce(me,Ie,Ae,Me){var qe,Qe,Ge,Ye,We;switch(me=new ue(me,Me),Ie=new Ee(Ie,Me),Ae){case">":qe=te,Qe=N,Ge=V,Ye=">",We=">=";break;case"<":qe=V,Qe=Q,Ge=te,Ye="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(me,Ie,Me))return!1;for(var rt=0;rt<Ie.set.length;++rt){var at=Ie.set[rt],nt=null,ct=null;if(at.forEach(function(it){it.semver===fe&&(it=new oe(">=0.0.0")),nt=nt||it,ct=ct||it,qe(it.semver,nt.semver,Me)?nt=it:Ge(it.semver,ct.semver,Me)&&(ct=it)}),nt.operator===Ye||nt.operator===We||(!ct.operator||ct.operator===Ye)&&Qe(me,ct.semver)||ct.operator===We&&Ge(me,ct.semver))return!1}return!0}oe.prototype.parse=function(me){var Ie=this.loose?A[K]:A[ae],Ae=me.match(Ie);if(!Ae)throw new TypeError("Invalid comparator: "+me);this.operator=Ae[1],this.operator==="="&&(this.operator=""),Ae[2]?this.semver=new ue(Ae[2],this.loose):this.semver=fe},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(me){return E("Comparator.test",me,this.loose),this.semver===fe||(typeof me=="string"&&(me=new ue(me,this.loose)),H(me,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(me,Ie){if(!(me instanceof oe))throw new TypeError("a Comparator is required");var Ae;if(this.operator==="")return Ae=new Ee(me.value,Ie),Re(this.value,Ae,Ie);if(me.operator==="")return Ae=new Ee(this.value,Ie),Re(me.semver,Ae,Ie);var Me=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Qe=this.semver.version===me.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ye=H(this.semver,"<",me.semver,Ie)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),We=H(this.semver,">",me.semver,Ie)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Me||qe||Qe&&Ge||Ye||We},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(me){var Ie=this.loose;me=me.trim(),E("range",me,Ie);var Ae=Ie?A[re]:A[B];me=me.replace(Ae,de),E("hyphen replace",me),me=me.replace(A[M],"$1$2$3"),E("comparator trim",me,A[M]),me=(me=(me=me.replace(A[q],"$1~")).replace(A[Z],"$1^")).split(/\s+/).join(" ");var Me=Ie?A[K]:A[ae],qe=me.split(" ").map(function(Qe){return function(Ge,Ye){return E("comp",Ge),Ge=function(We,rt){return We.trim().split(/\s+/).map(function(at){return function(nt,ct){E("caret",nt,ct);var it=ct?A[le]:A[x];return nt.replace(it,function(_e,Je,et,be,Le){var ve;return E("caret",nt,_e,Je,et,be,Le),Ne(Je)?ve="":Ne(et)?ve=">="+Je+".0.0 <"+(+Je+1)+".0.0":Ne(be)?ve=Je==="0"?">="+Je+"."+et+".0 <"+Je+"."+(+et+1)+".0":">="+Je+"."+et+".0 <"+(+Je+1)+".0.0":Le?(E("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),ve=Je==="0"?et==="0"?">="+Je+"."+et+"."+be+Le+" <"+Je+"."+et+"."+(+be+1):">="+Je+"."+et+"."+be+Le+" <"+Je+"."+(+et+1)+".0":">="+Je+"."+et+"."+be+Le+" <"+(+Je+1)+".0.0"):(E("no pr"),ve=Je==="0"?et==="0"?">="+Je+"."+et+"."+be+" <"+Je+"."+et+"."+(+be+1):">="+Je+"."+et+"."+be+" <"+Je+"."+(+et+1)+".0":">="+Je+"."+et+"."+be+" <"+(+Je+1)+".0.0"),E("caret return",ve),ve})}(at,rt)}).join(" ")}(Ge,Ye),E("caret",Ge),Ge=function(We,rt){return We.trim().split(/\s+/).map(function(at){return function(nt,ct){var it=ct?A[J]:A[Y];return nt.replace(it,function(_e,Je,et,be,Le){var ve;return E("tilde",nt,_e,Je,et,be,Le),Ne(Je)?ve="":Ne(et)?ve=">="+Je+".0.0 <"+(+Je+1)+".0.0":Ne(be)?ve=">="+Je+"."+et+".0 <"+Je+"."+(+et+1)+".0":Le?(E("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),ve=">="+Je+"."+et+"."+be+Le+" <"+Je+"."+(+et+1)+".0"):ve=">="+Je+"."+et+"."+be+" <"+Je+"."+(+et+1)+".0",E("tilde return",ve),ve})}(at,rt)}).join(" ")}(Ge,Ye),E("tildes",Ge),Ge=function(We,rt){return E("replaceXRanges",We,rt),We.split(/\s+/).map(function(at){return function(nt,ct){nt=nt.trim();var it=ct?A[z]:A[T];return nt.replace(it,function(_e,Je,et,be,Le,ve){E("xRange",nt,_e,Je,et,be,Le,ve);var ye=Ne(et),ee=ye||Ne(be),ie=ee||Ne(Le);return Je==="="&&ie&&(Je=""),ye?_e=Je===">"||Je==="<"?"<0.0.0":"*":Je&&ie?(ee&&(be=0),ie&&(Le=0),Je===">"?(Je=">=",ee?(et=+et+1,be=0,Le=0):ie&&(be=+be+1,Le=0)):Je==="<="&&(Je="<",ee?et=+et+1:be=+be+1),_e=Je+et+"."+be+"."+Le):ee?_e=">="+et+".0.0 <"+(+et+1)+".0.0":ie&&(_e=">="+et+"."+be+".0 <"+et+"."+(+be+1)+".0"),E("xRange return",_e),_e})}(at,rt)}).join(" ")}(Ge,Ye),E("xrange",Ge),Ge=function(We,rt){return E("replaceStars",We,rt),We.trim().replace(A[ce],"")}(Ge,Ye),E("stars",Ge),Ge}(Qe,Ie)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(Qe){return!!Qe.match(Me)})),qe=qe.map(function(Qe){return new oe(Qe,Ie)})},Ee.prototype.intersects=function(me,Ie){if(!(me instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(Ae){return Ae.every(function(Me){return me.set.some(function(qe){return qe.every(function(Qe){return Me.intersects(Qe,Ie)})})})})},e.toComparators=function(me,Ie){return new Ee(me,Ie).set.map(function(Ae){return Ae.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new ue(me,this.loose));for(var Ie=0;Ie<this.set.length;Ie++)if($e(this.set[Ie],me))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(me,Ie,Ae){var Me=null,qe=null;try{var Qe=new Ee(Ie,Ae)}catch{return null}return me.forEach(function(Ge){Qe.test(Ge)&&(Me&&qe.compare(Ge)!==-1||(qe=new ue(Me=Ge,Ae)))}),Me},e.minSatisfying=function(me,Ie,Ae){var Me=null,qe=null;try{var Qe=new Ee(Ie,Ae)}catch{return null}return me.forEach(function(Ge){Qe.test(Ge)&&(Me&&qe.compare(Ge)!==1||(qe=new ue(Me=Ge,Ae)))}),Me},e.validRange=function(me,Ie){try{return new Ee(me,Ie).range||"*"}catch{return null}},e.ltr=function(me,Ie,Ae){return Ce(me,Ie,"<",Ae)},e.gtr=function(me,Ie,Ae){return Ce(me,Ie,">",Ae)},e.outside=Ce,e.prerelease=function(me,Ie){var Ae=W(me,Ie);return Ae&&Ae.prerelease.length?Ae.prerelease:null},e.intersects=function(me,Ie,Ae){return me=new Ee(me,Ae),Ie=new Ee(Ie,Ae),me.intersects(Ie)},e.coerce=function(me){if(me instanceof ue)return me;if(typeof me!="string")return null;var Ie=me.match(A[C]);return Ie==null?null:W((Ie[1]||"0")+"."+(Ie[2]||"0")+"."+(Ie[3]||"0"))}}).call(this,n(1))},function(se,e){var n,r,E=se.exports={};function I(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function A(m){if(n===setTimeout)return setTimeout(m,0);if((n===I||!n)&&setTimeout)return n=setTimeout,setTimeout(m,0);try{return n(m,0)}catch{try{return n.call(null,m,0)}catch{return n.call(this,m,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:I}catch{n=I}try{r=typeof clearTimeout=="function"?clearTimeout:R}catch{r=R}})();var y,o=[],S=!1,v=-1;function f(){S&&y&&(S=!1,y.length?o=y.concat(o):v=-1,o.length&&w())}function w(){if(!S){var m=A(f);S=!0;for(var $=o.length;$;){for(y=o,o=[];++v<$;)y&&y[v].run();v=-1,$=o.length}y=null,S=!1,function(p){if(r===clearTimeout)return clearTimeout(p);if((r===R||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(p);try{r(p)}catch{try{return r.call(null,p)}catch{return r.call(this,p)}}}(m)}}function a(m,$){this.fun=m,this.array=$}function h(){}E.nextTick=function(m){var $=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)$[p-1]=arguments[p];o.push(new a(m,$)),o.length!==1||S||A(w)},a.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=h,E.addListener=h,E.once=h,E.off=h,E.removeListener=h,E.removeAllListeners=h,E.emit=h,E.prependListener=h,E.prependOnceListener=h,E.listeners=function(m){return[]},E.binding=function(m){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(m){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(Se[168],ke([1,0]),function(se,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class r{constructor(A,y,o){this.level=A,this.key=y,this.value=o,this.forward=[]}}const E=void 0;class I{constructor(A,y=2**16){this.comparator=A,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(y)|0),this.e=new r(this.c,E,E)}get size(){return this.f}clear(){this.e=new r(this.c,E,E),this.f=0}has(A){return!!I.g(this,A,this.comparator)}get(A){return I.g(this,A,this.comparator)?.value}set(A,y){return I.h(this,A,y,this.comparator)&&(this.f+=1),this}delete(A){const y=I.k(this,A,this.comparator);return y&&(this.f-=1),y}forEach(A,y){let o=this.e.forward[0];for(;o;)A.call(y,o.value,o.key,this),o=o.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",y=this.e.forward[0];for(;y;)A+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return A}static g(A,y,o){let S=A.e;for(let v=A.d-1;v>=0;v--)for(;S.forward[v]&&o(S.forward[v].key,y)<0;)S=S.forward[v];if(S=S.forward[0],S&&o(S.key,y)===0)return S}static h(A,y,o,S){const v=[];let f=A.e;for(let w=A.d-1;w>=0;w--){for(;f.forward[w]&&S(f.forward[w].key,y)<0;)f=f.forward[w];v[w]=f}if(f=f.forward[0],f&&S(f.key,y)===0)return f.value=o,!1;{const w=I.j(A);if(w>A.d){for(let a=A.d;a<w;a++)v[a]=A.e;A.d=w}f=new r(w,y,o);for(let a=0;a<w;a++)f.forward[a]=v[a].forward[a],v[a].forward[a]=f;return!0}}static j(A,y=.5){let o=1;for(;Math.random()<y&&o<A.c;)o+=1;return o}static k(A,y,o){const S=[];let v=A.e;for(let f=A.d-1;f>=0;f--){for(;v.forward[f]&&o(v.forward[f].key,y)<0;)v=v.forward[f];S[f]=v}if(v=v.forward[0],!v||o(v.key,y)!==0)return!1;for(let f=0;f<A.d&&S[f].forward[f]===v;f++)S[f].forward[f]=v.forward[f];for(;A.d>0&&A.e.forward[A.d-1]===E;)A.d-=1;return!0}}e.$Ss=I}),define(Se[48],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(I){return new r(I)}constructor(I){this.c=n&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=r}),define(Se[6],ke([1,0,10,79,2,80,48]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=w;const A=!1,y=!1,o=!1;var S;(function(J){J.None=()=>E.$Xc.None;function ne(de){if(o){const{onDidAddListener:$e}=de,Re=h.create();let Ce=0;de.onDidAddListener=()=>{++Ce===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),$e?.()}}}function Z(de,$e){return W(de,()=>{},0,void 0,!0,void 0,$e)}J.defer=Z;function x(de){return($e,Re=null,Ce)=>{let me=!1,Ie;return Ie=de(Ae=>{if(!me)return Ie?Ie.dispose():me=!0,$e.call(Re,Ae)},null,Ce),me&&Ie.dispose(),Ie}}J.once=x;function le(de,$e,Re){return ce((Ce,me=null,Ie)=>de(Ae=>Ce.call(me,$e(Ae)),null,Ie),Re)}J.map=le;function K(de,$e,Re){return ce((Ce,me=null,Ie)=>de(Ae=>{$e(Ae),Ce.call(me,Ae)},null,Ie),Re)}J.forEach=K;function ae(de,$e,Re){return ce((Ce,me=null,Ie)=>de(Ae=>$e(Ae)&&Ce.call(me,Ae),null,Ie),Re)}J.filter=ae;function M(de){return de}J.signal=M;function B(...de){return($e,Re=null,Ce)=>{const me=(0,E.$Uc)(...de.map(Ie=>Ie(Ae=>$e.call(Re,Ae))));return pe(me,Ce)}}J.any=B;function re(de,$e,Re,Ce){let me=Re;return le(de,Ie=>(me=$e(me,Ie),me),Ce)}J.reduce=re;function ce(de,$e){let Re;const Ce={onWillAddFirstListener(){Re=de(me.fire,me)},onDidRemoveLastListener(){Re?.dispose()}};$e||ne(Ce);const me=new i(Ce);return $e?.add(me),me.event}function pe(de,$e){return $e instanceof Array?$e.push(de):$e&&$e.add(de),de}function W(de,$e,Re=100,Ce=!1,me=!1,Ie,Ae){let Me,qe,Qe,Ge=0,Ye;const We={leakWarningThreshold:Ie,onWillAddFirstListener(){Me=de(at=>{Ge++,qe=$e(qe,at),Ce&&!Qe&&(rt.fire(qe),qe=void 0),Ye=()=>{const nt=qe;qe=void 0,Qe=void 0,(!Ce||Ge>1)&&rt.fire(nt),Ge=0},typeof Re=="number"?(clearTimeout(Qe),Qe=setTimeout(Ye,Re)):Qe===void 0&&(Qe=0,queueMicrotask(Ye))})},onWillRemoveListener(){me&&Ge>0&&Ye?.()},onDidRemoveLastListener(){Ye=void 0,Me.dispose()}};Ae||ne(We);const rt=new i(We);return Ae?.add(rt),rt.event}J.debounce=W;function ue(de,$e=0,Re){return J.debounce(de,(Ce,me)=>Ce?(Ce.push(me),Ce):[me],$e,void 0,!0,void 0,Re)}J.accumulate=ue;function _(de,$e=(Ce,me)=>Ce===me,Re){let Ce=!0,me;return ae(de,Ie=>{const Ae=Ce||!$e(Ie,me);return Ce=!1,me=Ie,Ae},Re)}J.latch=_;function U(de,$e,Re){return[J.filter(de,$e,Re),J.filter(de,Ce=>!$e(Ce),Re)]}J.split=U;function O(de,$e=!1,Re=[],Ce){let me=Re.slice(),Ie=de(qe=>{me?me.push(qe):Me.fire(qe)});Ce&&Ce.add(Ie);const Ae=()=>{me?.forEach(qe=>Me.fire(qe)),me=null},Me=new i({onWillAddFirstListener(){Ie||(Ie=de(qe=>Me.fire(qe)),Ce&&Ce.add(Ie))},onDidAddFirstListener(){me&&($e?setTimeout(Ae):Ae())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return Ce&&Ce.add(Me),Me.event}J.buffer=O;function te(de,$e){return(Ce,me,Ie)=>{const Ae=$e(new j);return de(function(Me){const qe=Ae.evaluate(Me);qe!==V&&Ce.call(me,qe)},void 0,Ie)}}J.chain=te;const V=Symbol("HaltChainable");class j{constructor(){this.f=[]}map($e){return this.f.push($e),this}forEach($e){return this.f.push(Re=>($e(Re),Re)),this}filter($e){return this.f.push(Re=>$e(Re)?Re:V),this}reduce($e,Re){let Ce=Re;return this.f.push(me=>(Ce=$e(Ce,me),Ce)),this}latch($e=(Re,Ce)=>Re===Ce){let Re=!0,Ce;return this.f.push(me=>{const Ie=Re||!$e(me,Ce);return Re=!1,Ce=me,Ie?me:V}),this}evaluate($e){for(const Re of this.f)if($e=Re($e),$e===V)break;return $e}}function G(de,$e,Re=Ce=>Ce){const Ce=(...Me)=>Ae.fire(Re(...Me)),me=()=>de.on($e,Ce),Ie=()=>de.removeListener($e,Ce),Ae=new i({onWillAddFirstListener:me,onDidRemoveLastListener:Ie});return Ae.event}J.fromNodeEventEmitter=G;function Q(de,$e,Re=Ce=>Ce){const Ce=(...Me)=>Ae.fire(Re(...Me)),me=()=>de.addEventListener($e,Ce),Ie=()=>de.removeEventListener($e,Ce),Ae=new i({onWillAddFirstListener:me,onDidRemoveLastListener:Ie});return Ae.event}J.fromDOMEventEmitter=Q;function N(de){return new Promise($e=>x(de)($e))}J.toPromise=N;function H(de){const $e=new i;return de.then(Re=>{$e.fire(Re)},()=>{$e.fire(void 0)}).finally(()=>{$e.dispose()}),$e.event}J.fromPromise=H;function oe(de,$e,Re){return $e(Re),de(Ce=>$e(Ce))}J.runAndSubscribe=oe;class fe{constructor($e,Re){this._observable=$e,this.f=0,this.g=!1;const Ce={onWillAddFirstListener:()=>{$e.addObserver(this)},onDidRemoveLastListener:()=>{$e.removeObserver(this)}};Re||ne(Ce),this.emitter=new i(Ce),Re&&Re.add(this.emitter)}beginUpdate($e){this.f++}handlePossibleChange($e){}handleChange($e,Re){this.g=!0}endUpdate($e){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(de,$e){return new fe(de,$e).emitter.event}J.fromObservable=Ee;function Ne(de){return($e,Re,Ce)=>{let me=0,Ie=!1;const Ae={beginUpdate(){me++},endUpdate(){me--,me===0&&(de.reportChanges(),Ie&&(Ie=!1,$e.call(Re)))},handlePossibleChange(){},handleChange(){Ie=!0}};de.addObserver(Ae),de.reportChanges();const Me={dispose(){de.removeObserver(Ae)}};return Ce instanceof E.$Wc?Ce.add(Me):Array.isArray(Ce)&&Ce.push(Me),Me}}J.fromObservableLight=Ne})(S||(e.Event=S={}));class v{constructor(ne){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${ne}_${v.f++}`,v.all.add(this)}start(ne){this.g=new R.$he,this.listenerCount=ne}stop(){if(this.g){const ne=this.g.elapsed();this.durations.push(ne),this.elapsedOverall+=ne,this.invocationCount+=1,this.g=void 0}}}e.$je=v,v.all=new Set,v.f=0;let f=-1;function w(J){const ne=f;return f=J,{dispose(){f=ne}}}class a{constructor(ne,Z,x=(a.f++).toString(16).padStart(3,"0")){this.j=ne,this.threshold=Z,this.name=x,this.h=0}dispose(){this.g?.clear()}check(ne,Z){const x=this.threshold;if(x<=0||Z<x)return;this.g||(this.g=new Map);const le=this.g.get(ne.value)||0;if(this.g.set(ne.value,le+1),this.h-=1,this.h<=0){this.h=x*.5;const[K,ae]=this.getMostFrequentStack(),M=`[${this.name}] potential listener LEAK detected, having ${Z} listeners already. MOST frequent listener (${ae}):`;console.warn(M),console.warn(K);const B=new m(M,K);this.j(B)}return()=>{const K=this.g.get(ne.value)||0;this.g.set(ne.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let ne,Z=0;for(const[x,le]of this.g)(!ne||Z<le)&&(ne=[x,le],Z=le);return ne}}a.f=1;class h{static create(){const ne=new Error;return new h(ne.stack??"")}constructor(ne){this.value=ne}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(ne,Z){super(ne),this.name="ListenerLeakError",this.stack=Z}}e.$le=m;class $ extends Error{constructor(ne,Z){super(ne),this.name="ListenerRefusalError",this.stack=Z}}e.$me=$;let p=0;class d{constructor(ne){this.value=ne,this.id=p++}}const b=2,t=(J,ne)=>{if(J instanceof d)ne(J);else for(let Z=0;Z<J.length;Z++){const x=J[Z];x&&ne(x)}};let l;if(A){const J=[];setInterval(()=>{J.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(J.join(`
`)),J.length=0)},3e3),l=new FinalizationRegistry(ne=>{typeof ne=="string"&&J.push(ne)})}class i{constructor(ne){this.z=0,this.f=ne,this.g=f>0||this.f?.leakWarningThreshold?new a(ne?.onListenerError??n.$3,this.f?.leakWarningThreshold??f):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(y){const ne=this.u;queueMicrotask(()=>{t(ne,Z=>Z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(ne,Z,x)=>{if(this.g&&this.z>this.g.threshold**2){const B=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(B);const re=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ce=new $(`${B}. HINT: Stack shows most frequent listener (${re[1]}-times)`,re[0]);return(this.f?.onListenerError||n.$3)(ce),E.$Xc.None}if(this.m)return E.$Xc.None;Z&&(ne=ne.bind(Z));const le=new d(ne);let K,ae;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(le.stack=h.create(),K=this.g.check(le.stack,this.z+1)),y&&(le.stack=ae??h.create()),this.u?this.u instanceof d?(this.w??(this.w=new s),this.u=[this.u,le]):this.u.push(le):(this.f?.onWillAddFirstListener?.(this),this.u=le,this.f?.onDidAddFirstListener?.(this)),this.z++;const M=(0,E.$Vc)(()=>{l?.unregister(M),K?.(),this.A(le)});if(x instanceof E.$Wc?x.add(M):Array.isArray(x)&&x.push(M),l){const B=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),re=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(B);l.register(M,re?.[2]??B,M)}return M}),this.q}A(ne){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Z=this.u,x=Z.indexOf(ne);if(x===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Z[x]=void 0;const le=this.w.current===this;if(this.z*b<=Z.length){let K=0;for(let ae=0;ae<Z.length;ae++)Z[ae]?Z[K++]=Z[ae]:le&&(this.w.end--,K<this.w.i&&this.w.i--);Z.length=K}}B(ne,Z){if(!ne)return;const x=this.f?.onListenerError||n.$3;if(!x){ne.value(Z);return}try{ne.value(Z)}catch(le){x(le)}}C(ne){const Z=ne.current.u;for(;ne.i<ne.end;)this.B(Z[ne.i++],ne.value);ne.reset()}fire(ne){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof d)this.B(this.u,ne);else{const Z=this.w;Z.enqueue(this,ne,this.u.length),this.C(Z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=i;const g=()=>new s;e.$oe=g;class s{constructor(){this.i=-1,this.end=0}enqueue(ne,Z,x){this.i=0,this.end=x,this.current=ne,this.value=Z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends i{async fireAsync(ne,Z,x){if(this.u)for(this.h||(this.h=new I.$8c),t(this.u,le=>this.h.push([le.value,ne]));this.h.size>0&&!Z.isCancellationRequested;){const[le,K]=this.h.shift(),ae=[],M={...K,token:Z,waitUntil:B=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");x&&(B=x(B,le)),ae.push(B)}};try{le(M)}catch(B){(0,n.$3)(B);continue}Object.freeze(ae),await Promise.allSettled(ae).then(B=>{for(const re of B)re.status==="rejected"&&(0,n.$3)(re.reason)})}}}e.$pe=c;class u extends i{get isPaused(){return this.h!==0}constructor(ne){super(ne),this.h=0,this.s=new I.$8c,this.t=ne?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const ne=Array.from(this.s);this.s.clear(),super.fire(this.t(ne))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(ne){this.z&&(this.h!==0?this.s.push(ne):super.fire(ne))}}e.$qe=u;class D extends u{constructor(ne){super(ne),this.k=ne.delay??100}fire(ne){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(ne)}}e.$re=D;class P extends i{constructor(ne){super(ne),this.h=[],this.k=ne?.merge}fire(ne){this.hasListeners()&&(this.h.push(ne),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Z=>super.fire(Z)),this.h=[]}))}}e.$se=P;class T{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(ne){const Z={event:ne,listener:null};this.h.push(Z),this.g&&this.m(Z);const x=()=>{this.g&&this.o(Z);const le=this.h.indexOf(Z);this.h.splice(le,1)};return(0,E.$Vc)((0,r.$gb)(x))}j(){this.g=!0,this.h.forEach(ne=>this.m(ne))}k(){this.g=!1,this.h.forEach(ne=>this.o(ne))}m(ne){ne.listener=ne.event(Z=>this.f.fire(Z))}o(ne){ne.listener?.dispose(),ne.listener=null}dispose(){this.f.dispose();for(const ne of this.h)ne.listener?.dispose();this.h=[]}}e.$te=T;class z{constructor(ne,Z,x,le){this.f=new E.$Wc;const K=this.f.add(new T),ae=this.f.add(new E.$7c);function M(B){ae.set(B,K.add(le(B)))}for(const B of ne)M(B);this.f.add(Z(B=>{M(B)})),this.f.add(x(B=>{ae.deleteAndDispose(B)})),this.event=K.event}dispose(){this.f.dispose()}}e.$ue=z;class C{constructor(){this.f=[]}wrapEvent(ne,Z,x){return(le,K,ae)=>ne(M=>{const B=this.f[this.f.length-1];if(!Z){B?B.buffers.push(()=>le.call(K,M)):le.call(K,M);return}const re=B;if(!re){le.call(K,Z(x,M));return}re.items??(re.items=[]),re.items.push(M),re.buffers.length===0&&B.buffers.push(()=>{re.reducedResult??(re.reducedResult=x?re.items.reduce(Z,x):re.items.reduce(Z)),le.call(K,re.reducedResult)})},void 0,ae)}bufferEvents(ne){const Z={buffers:new Array};this.f.push(Z);const x=ne();return this.f.pop(),Z.buffers.forEach(le=>le()),x}}e.$ve=C;class k{constructor(){this.f=!1,this.g=S.None,this.h=E.$Xc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(ne){this.g=ne,this.f&&(this.h.dispose(),this.h=ne(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=k;class q{static const(ne){return new Y(ne)}constructor(ne){this.g=ne,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(ne){ne!==this.g&&(this.g=ne,this.f.fire(void 0))}}e.$xe=q;class Y{constructor(ne){this.value=ne,this.onDidChange=S.None}}}),define(Se[19],ke([1,0,6]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=A;const r=Object.freeze(function(y,o){const S=setTimeout(y.bind(o),0);return{dispose(){clearTimeout(S)}}});var E;(function(y){function o(S){return S===y.None||S===y.Cancelled||S instanceof I?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}y.isCancellationToken=o,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(E||(e.CancellationToken=E={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(o){this.f=void 0,this.g=void 0,this.g=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=E.Cancelled}dispose(o=!1){o&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=E.None}}e.$ye=R;function A(y){const o=new R;return y.add({dispose(){o.cancel()}}),o.token}}),define(Se[169],ke([1,0,19]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=E;class r{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new n.$ye,o=this.b(y.token);return this.a={promise:o,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}e.$$e=r;function E(A){return A}class I{constructor(y,o){this.a=void 0,this.b=void 0,typeof y=="function"?(this.c=y,this.d=E):(this.c=o,this.d=y.getCacheKey)}get(y){const o=this.d(y);return this.b!==o&&(this.b=o,this.a=this.c(y)),this.a}}e.$af=I;class R{get cachedValues(){return this.a}constructor(y,o){this.a=new Map,this.b=new Map,typeof y=="function"?(this.c=y,this.d=E):(this.c=o,this.d=y.getCacheKey)}get(y){const o=this.d(y);if(this.b.has(o))return this.b.get(o);const S=this.c(y);return this.a.set(y,S),this.b.set(o,S),S}}e.$bf=R}),define(Se[170],ke([1,0,6,2]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=e.$ct=e.ScrollbarVisibility=void 0;var E;(function(w){w[w.Auto=1]="Auto",w[w.Hidden=2]="Hidden",w[w.Visible=3]="Visible"})(E||(e.ScrollbarVisibility=E={}));class I{constructor(a,h,m,$,p,d,b){this.c=a,this._scrollStateBrand=void 0,this.c&&(h=h|0,m=m|0,$=$|0,p=p|0,d=d|0,b=b|0),this.rawScrollLeft=$,this.rawScrollTop=b,h<0&&(h=0),$+h>m&&($=m-h),$<0&&($=0),p<0&&(p=0),b+p>d&&(b=d-p),b<0&&(b=0),this.width=h,this.scrollWidth=m,this.scrollLeft=$,this.height=p,this.scrollHeight=d,this.scrollTop=b}equals(a){return this.rawScrollLeft===a.rawScrollLeft&&this.rawScrollTop===a.rawScrollTop&&this.width===a.width&&this.scrollWidth===a.scrollWidth&&this.scrollLeft===a.scrollLeft&&this.height===a.height&&this.scrollHeight===a.scrollHeight&&this.scrollTop===a.scrollTop}withScrollDimensions(a,h){return new I(this.c,typeof a.width<"u"?a.width:this.width,typeof a.scrollWidth<"u"?a.scrollWidth:this.scrollWidth,h?this.rawScrollLeft:this.scrollLeft,typeof a.height<"u"?a.height:this.height,typeof a.scrollHeight<"u"?a.scrollHeight:this.scrollHeight,h?this.rawScrollTop:this.scrollTop)}withScrollPosition(a){return new I(this.c,this.width,this.scrollWidth,typeof a.scrollLeft<"u"?a.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof a.scrollTop<"u"?a.scrollTop:this.rawScrollTop)}createScrollEvent(a,h){const m=this.width!==a.width,$=this.scrollWidth!==a.scrollWidth,p=this.scrollLeft!==a.scrollLeft,d=this.height!==a.height,b=this.scrollHeight!==a.scrollHeight,t=this.scrollTop!==a.scrollTop;return{inSmoothScrolling:h,oldWidth:a.width,oldScrollWidth:a.scrollWidth,oldScrollLeft:a.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:a.height,oldScrollHeight:a.scrollHeight,oldScrollTop:a.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:$,scrollLeftChanged:p,heightChanged:d,scrollHeightChanged:b,scrollTopChanged:t}}}e.$ct=I;class R extends r.$Xc{constructor(a){super(),this._scrollableBrand=void 0,this.j=this.B(new n.$ne),this.onScroll=this.j.event,this.c=a.smoothScrollDuration,this.f=a.scheduleAtNextAnimationFrame,this.g=new I(a.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(a){this.c=a}validateScrollPosition(a){return this.g.withScrollPosition(a)}getScrollDimensions(){return this.g}setScrollDimensions(a,h){const m=this.g.withScrollDimensions(a,h);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(a){const h=this.g.withScrollPosition(a);this.h&&(this.h.dispose(),this.h=null),this.n(h,!1)}setScrollPositionSmooth(a,h){if(this.c===0)return this.setScrollPositionNow(a);if(this.h){a={scrollLeft:typeof a.scrollLeft>"u"?this.h.to.scrollLeft:a.scrollLeft,scrollTop:typeof a.scrollTop>"u"?this.h.to.scrollTop:a.scrollTop};const m=this.g.withScrollPosition(a);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let $;h?$=new S(this.h.from,m,this.h.startTime,this.h.duration):$=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=$}else{const m=this.g.withScrollPosition(a);this.h=S.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const a=this.h.tick(),h=this.g.withScrollPosition(a);if(this.n(h,!0),!!this.h){if(a.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(a,h){const m=this.g;m.equals(a)||(this.g=a,this.j.fire(this.g.createScrollEvent(m,h)))}}e.$dt=R;class A{constructor(a,h,m){this.scrollLeft=a,this.scrollTop=h,this.isDone=m}}e.$et=A;function y(w,a){const h=a-w;return function(m){return w+h*f(m)}}function o(w,a,h){return function(m){return m<h?w(m/h):a((m-h)/(1-h))}}class S{constructor(a,h,m,$){this.from=a,this.to=h,this.duration=$,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(a,h,m){if(Math.abs(a-h)>2.5*m){let p,d;return a<h?(p=a+.75*m,d=h-.75*m):(p=a-.75*m,d=h+.75*m),o(y(a,p),y(d,h),.33)}return y(a,h)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(a){this.to=a.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(a){const h=(a-this.startTime)/this.duration;if(h<1){const m=this.c(h),$=this.d(h);return new A(m,$,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(a,h,m){return S.start(a,h,m)}static start(a,h,m){m=m+10;const $=Date.now()-10;return new S(a,h,$,m)}}e.$ft=S;function v(w){return Math.pow(w,3)}function f(w){return 1-v(1-w)}}),define(Se[56],ke([1,0,10,2]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=E,e.$Be=I,e.$Ce=R,e.$De=A,e.$Ee=o,e.$Fe=S,e.$Ge=v,e.$He=f,e.$Ie=w,e.$Je=a,e.$Ke=h,e.$Le=m,e.$Me=$,e.$Ne=p,e.$Oe=d;function E(b){const t=b;return t?typeof t.read=="function":!1}function I(b){const t=b;return t?[t.on,t.pause,t.resume,t.destroy].every(l=>typeof l=="function"):!1}function R(b){const t=b;return t?I(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function A(b,t){return new y(b,t)}class y{constructor(t,l){this.e=t,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(l=>l(t))}h(t){this.c.error.length===0?(0,n.$3)(t):this.c.error.slice(0).forEach(l=>l(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,l){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(t,l){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const g=i.indexOf(l);g>=0&&i.splice(g,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function o(b,t){const l=[];let i;for(;(i=b.read())!==null;)l.push(i);return t(l)}function S(b,t,l){const i=[];let g;for(;(g=b.read())!==null&&i.length<l;)i.push(g);return g===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof g<"u"){const s=g;return g=void 0,s}return b.read()}}}function v(b,t){return new Promise((l,i)=>{const g=[];f(b,{onData:s=>{t&&g.push(s)},onError:s=>{t?i(s):l(void 0)},onEnd:()=>{l(t?t(g):void 0)}})})}function f(b,t,l){b.on("error",i=>{l?.isCancellationRequested||t.onError(i)}),b.on("end",()=>{l?.isCancellationRequested||t.onEnd()}),b.on("data",i=>{l?.isCancellationRequested||t.onData(i)})}function w(b,t){return new Promise((l,i)=>{const g=new r.$Wc,s=[],c=P=>{if(s.push(P),s.length>t)return g.dispose(),b.pause(),l({stream:b,buffer:s,ended:!1})},u=P=>(g.dispose(),i(P)),D=()=>(g.dispose(),l({stream:b,buffer:s,ended:!0}));g.add((0,r.$Vc)(()=>b.removeListener("error",u))),b.on("error",u),g.add((0,r.$Vc)(()=>b.removeListener("end",D))),b.on("end",D),g.add((0,r.$Vc)(()=>b.removeListener("data",c))),b.on("data",c)})}function a(b,t){const l=A(t);return l.end(b),l}function h(){const b=A(()=>{throw new Error("not supported")});return b.end(),b}function m(b){let t=!1;return{read:()=>t?null:(t=!0,b)}}function $(b,t,l){const i=A(l);return f(b,{onData:g=>i.write(t.data(g)),onError:g=>i.error(t.error?t.error(g):g),onEnd:()=>i.end()}),i}function p(b,t,l){let i=!1;return{read:()=>{const g=t.read();return i?g:(i=!0,g!==null?l([b,g]):b)}}}function d(b,t,l){let i=!1;const g=A(l);return f(t,{onData:s=>i?g.write(s):(i=!0,g.write(l([b,s]))),onError:s=>g.error(s),onEnd:()=>{i||(i=!0,g.write(b)),g.end()}}),g}}),define(Se[15],ke([1,0,65,56]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=o,e.$Re=S,e.$Se=v,e.$Te=f,e.$Ue=w,e.$Ve=a,e.$We=h,e.$Xe=m,e.$Ye=$,e.$Ze=p,e.$1e=d,e.$2e=b,e.$3e=t,e.$4e=l,e.$5e=i,e.$6e=g,e.$7e=s,e.$8e=c,e.$9e=u,e.$0e=T,r=Be(r);const E=typeof Buffer<"u",I=new n.$X(()=>new Uint8Array(256));let R,A;class y{static alloc(C){return E?new y(Buffer.allocUnsafe(C)):new y(new Uint8Array(C))}static wrap(C){return E&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new y(C)}static fromString(C,k){return!(k?.dontUseNodeBuffer||!1)&&E?new y(Buffer.from(C)):(R||(R=new TextEncoder),new y(R.encode(C)))}static fromByteArray(C){const k=y.alloc(C.length);for(let q=0,Y=C.length;q<Y;q++)k.buffer[q]=C[q];return k}static concat(C,k){if(typeof k>"u"){k=0;for(let J=0,ne=C.length;J<ne;J++)k+=C[J].byteLength}const q=y.alloc(k);let Y=0;for(let J=0,ne=C.length;J<ne;J++){const Z=C[J];q.set(Z,Y),Y+=Z.byteLength}return q}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=y.alloc(this.byteLength);return C.set(this),C}toString(){return E?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(C,k){return new y(this.buffer.subarray(C,k))}set(C,k){if(C instanceof y)this.buffer.set(C.buffer,k);else if(C instanceof Uint8Array)this.buffer.set(C,k);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),k);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return f(this.buffer,C)}writeUInt32BE(C,k){w(this.buffer,C,k)}readUInt32LE(C){return a(this.buffer,C)}writeUInt32LE(C,k){h(this.buffer,C,k)}readUInt8(C){return m(this.buffer,C)}writeUInt8(C,k){$(this.buffer,C,k)}indexOf(C,k=0){return o(this.buffer,C instanceof y?C.buffer:C,k)}}e.$Pe=y;function o(z,C,k=0){const q=C.byteLength,Y=z.byteLength;if(q===0)return 0;if(q===1)return z.indexOf(C[0]);if(q>Y-k)return-1;const J=I.value;J.fill(C.length);for(let le=0;le<C.length;le++)J[C[le]]=C.length-le-1;let ne=k+C.length-1,Z=ne,x=-1;for(;ne<Y;)if(z[ne]===C[Z]){if(Z===0){x=ne;break}ne--,Z--}else ne+=Math.max(C.length-Z,J[z[ne]]),Z=C.length-1;return x}function S(z,C){return z[C+0]<<0>>>0|z[C+1]<<8>>>0}function v(z,C,k){z[k+0]=C&255,C=C>>>8,z[k+1]=C&255}function f(z,C){return z[C]*2**24+z[C+1]*2**16+z[C+2]*2**8+z[C+3]}function w(z,C,k){z[k+3]=C,C=C>>>8,z[k+2]=C,C=C>>>8,z[k+1]=C,C=C>>>8,z[k]=C}function a(z,C){return z[C+0]<<0>>>0|z[C+1]<<8>>>0|z[C+2]<<16>>>0|z[C+3]<<24>>>0}function h(z,C,k){z[k+0]=C&255,C=C>>>8,z[k+1]=C&255,C=C>>>8,z[k+2]=C&255,C=C>>>8,z[k+3]=C&255}function m(z,C){return z[C]}function $(z,C,k){z[k]=C}function p(z){return r.$Ee(z,C=>y.concat(C))}function d(z){return r.$Le(z)}function b(z){return r.$Ge(z,C=>y.concat(C))}async function t(z){return z.ended?y.concat(z.buffer):y.concat([...z.buffer,await b(z.stream)])}function l(z){return r.$Je(z,C=>y.concat(C))}function i(z){return r.$Me(z,{data:C=>typeof C=="string"?y.fromString(C):y.wrap(C)},C=>y.concat(C))}function g(z){return r.$De(C=>y.concat(C),z)}function s(z,C){return r.$Ne(z,C,k=>y.concat(k))}function c(z,C){return r.$Oe(z,C,k=>y.concat(k))}function u(z){let C=0,k=0,q=0;const Y=new Uint8Array(Math.floor(z.length/4*3)),J=Z=>{switch(k){case 3:Y[q++]=C|Z,k=0;break;case 2:Y[q++]=C|Z>>>2,C=Z<<6,k=3;break;case 1:Y[q++]=C|Z>>>4,C=Z<<4,k=2;break;default:C=Z<<2,k=1}};for(let Z=0;Z<z.length;Z++){const x=z.charCodeAt(Z);if(x>=65&&x<=90)J(x-65);else if(x>=97&&x<=122)J(x-97+26);else if(x>=48&&x<=57)J(x-48+52);else if(x===43||x===45)J(62);else if(x===47||x===95)J(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${z[Z]}`)}}const ne=q;for(;k>0;)J(0);return y.wrap(Y).slice(0,ne)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function T({buffer:z},C=!0,k=!1){const q=k?P:D;let Y="";const J=z.byteLength%3;let ne=0;for(;ne<z.byteLength-J;ne+=3){const Z=z[ne+0],x=z[ne+1],le=z[ne+2];Y+=q[Z>>>2],Y+=q[(Z<<4|x>>>4)&63],Y+=q[(x<<2|le>>>6)&63],Y+=q[le&63]}if(J===1){const Z=z[ne+0];Y+=q[Z>>>2],Y+=q[Z<<4&63],C&&(Y+="==")}else if(J===2){const Z=z[ne+0],x=z[ne+1];Y+=q[Z>>>2],Y+=q[(Z<<4|x>>>4)&63],Y+=q[x<<2&63],C&&(Y+="=")}return Y}}),define(Se[171],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(Se[11],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=n,e.$hg=r,e.$ig=E,e.$jg=I,e.$kg=R,e.$lg=A,e.$mg=y,e.$ng=o,e.$og=S,e.$pg=v,e.$qg=f,e.$rg=w,e.$sg=a,e.$tg=m,e.$ug=$,e.$vg=p,e.$wg=d,e.$xg=b;function n(t){return typeof t=="string"}function r(t){return Array.isArray(t)&&t.every(l=>n(l))}function E(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function I(t){const l=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof l}function R(t){return typeof t=="number"&&!isNaN(t)}function A(t){return!!t&&typeof t[Symbol.iterator]=="function"}function y(t){return t===!0||t===!1}function o(t){return typeof t>"u"}function S(t){return!v(t)}function v(t){return o(t)||t===null}function f(t,l){if(!t)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}function w(t){if(v(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function a(...t){const l=[];for(let i=0;i<t.length;i++){const g=t[i];if(v(g))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);l.push(g)}return l}const h=Object.prototype.hasOwnProperty;function m(t){if(!E(t))return!1;for(const l in t)if(h.call(t,l))return!1;return!0}function $(t){return typeof t=="function"}function p(...t){return t.length>0&&t.every($)}function d(t,l){const i=Math.min(t.length,l.length);for(let g=0;g<i;g++)b(t[g],l[g])}function b(t,l){if(n(l)){if(typeof t!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if($(l)){try{if(t instanceof l)return}catch{}if(!v(t)&&t.constructor===l||l.length===1&&l.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Se[109],ke([1,0,11]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=E,e.$2j=I;const r=Object.create(null);function E(R,A){if((0,n.$gg)(A)){const y=r[A];if(y===void 0)throw new Error(`${R} references an unknown codicon: ${A}`);A=y}return r[R]=A,{id:R}}function I(){return r}}),define(Se[172],ke([1,0,109]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0,e.$3j={add:(0,n.$1j)("add",6e4),plus:(0,n.$1j)("plus",6e4),gistNew:(0,n.$1j)("gist-new",6e4),repoCreate:(0,n.$1j)("repo-create",6e4),lightbulb:(0,n.$1j)("lightbulb",60001),lightBulb:(0,n.$1j)("light-bulb",60001),repo:(0,n.$1j)("repo",60002),repoDelete:(0,n.$1j)("repo-delete",60002),gistFork:(0,n.$1j)("gist-fork",60003),repoForked:(0,n.$1j)("repo-forked",60003),gitPullRequest:(0,n.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,n.$1j)("record-keys",60005),keyboard:(0,n.$1j)("keyboard",60005),tag:(0,n.$1j)("tag",60006),gitPullRequestLabel:(0,n.$1j)("git-pull-request-label",60006),tagAdd:(0,n.$1j)("tag-add",60006),tagRemove:(0,n.$1j)("tag-remove",60006),person:(0,n.$1j)("person",60007),personFollow:(0,n.$1j)("person-follow",60007),personOutline:(0,n.$1j)("person-outline",60007),personFilled:(0,n.$1j)("person-filled",60007),gitBranch:(0,n.$1j)("git-branch",60008),gitBranchCreate:(0,n.$1j)("git-branch-create",60008),gitBranchDelete:(0,n.$1j)("git-branch-delete",60008),sourceControl:(0,n.$1j)("source-control",60008),mirror:(0,n.$1j)("mirror",60009),mirrorPublic:(0,n.$1j)("mirror-public",60009),star:(0,n.$1j)("star",60010),starAdd:(0,n.$1j)("star-add",60010),starDelete:(0,n.$1j)("star-delete",60010),starEmpty:(0,n.$1j)("star-empty",60010),comment:(0,n.$1j)("comment",60011),commentAdd:(0,n.$1j)("comment-add",60011),alert:(0,n.$1j)("alert",60012),warning:(0,n.$1j)("warning",60012),search:(0,n.$1j)("search",60013),searchSave:(0,n.$1j)("search-save",60013),logOut:(0,n.$1j)("log-out",60014),signOut:(0,n.$1j)("sign-out",60014),logIn:(0,n.$1j)("log-in",60015),signIn:(0,n.$1j)("sign-in",60015),eye:(0,n.$1j)("eye",60016),eyeUnwatch:(0,n.$1j)("eye-unwatch",60016),eyeWatch:(0,n.$1j)("eye-watch",60016),circleFilled:(0,n.$1j)("circle-filled",60017),primitiveDot:(0,n.$1j)("primitive-dot",60017),closeDirty:(0,n.$1j)("close-dirty",60017),debugBreakpoint:(0,n.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,n.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,n.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,n.$1j)("primitive-square",60018),edit:(0,n.$1j)("edit",60019),pencil:(0,n.$1j)("pencil",60019),info:(0,n.$1j)("info",60020),issueOpened:(0,n.$1j)("issue-opened",60020),gistPrivate:(0,n.$1j)("gist-private",60021),gitForkPrivate:(0,n.$1j)("git-fork-private",60021),lock:(0,n.$1j)("lock",60021),mirrorPrivate:(0,n.$1j)("mirror-private",60021),close:(0,n.$1j)("close",60022),removeClose:(0,n.$1j)("remove-close",60022),x:(0,n.$1j)("x",60022),repoSync:(0,n.$1j)("repo-sync",60023),sync:(0,n.$1j)("sync",60023),clone:(0,n.$1j)("clone",60024),desktopDownload:(0,n.$1j)("desktop-download",60024),beaker:(0,n.$1j)("beaker",60025),microscope:(0,n.$1j)("microscope",60025),vm:(0,n.$1j)("vm",60026),deviceDesktop:(0,n.$1j)("device-desktop",60026),file:(0,n.$1j)("file",60027),fileText:(0,n.$1j)("file-text",60027),more:(0,n.$1j)("more",60028),ellipsis:(0,n.$1j)("ellipsis",60028),kebabHorizontal:(0,n.$1j)("kebab-horizontal",60028),mailReply:(0,n.$1j)("mail-reply",60029),reply:(0,n.$1j)("reply",60029),organization:(0,n.$1j)("organization",60030),organizationFilled:(0,n.$1j)("organization-filled",60030),organizationOutline:(0,n.$1j)("organization-outline",60030),newFile:(0,n.$1j)("new-file",60031),fileAdd:(0,n.$1j)("file-add",60031),newFolder:(0,n.$1j)("new-folder",60032),fileDirectoryCreate:(0,n.$1j)("file-directory-create",60032),trash:(0,n.$1j)("trash",60033),trashcan:(0,n.$1j)("trashcan",60033),history:(0,n.$1j)("history",60034),clock:(0,n.$1j)("clock",60034),folder:(0,n.$1j)("folder",60035),fileDirectory:(0,n.$1j)("file-directory",60035),symbolFolder:(0,n.$1j)("symbol-folder",60035),logoGithub:(0,n.$1j)("logo-github",60036),markGithub:(0,n.$1j)("mark-github",60036),github:(0,n.$1j)("github",60036),terminal:(0,n.$1j)("terminal",60037),console:(0,n.$1j)("console",60037),repl:(0,n.$1j)("repl",60037),zap:(0,n.$1j)("zap",60038),symbolEvent:(0,n.$1j)("symbol-event",60038),error:(0,n.$1j)("error",60039),stop:(0,n.$1j)("stop",60039),variable:(0,n.$1j)("variable",60040),symbolVariable:(0,n.$1j)("symbol-variable",60040),array:(0,n.$1j)("array",60042),symbolArray:(0,n.$1j)("symbol-array",60042),symbolModule:(0,n.$1j)("symbol-module",60043),symbolPackage:(0,n.$1j)("symbol-package",60043),symbolNamespace:(0,n.$1j)("symbol-namespace",60043),symbolObject:(0,n.$1j)("symbol-object",60043),symbolMethod:(0,n.$1j)("symbol-method",60044),symbolFunction:(0,n.$1j)("symbol-function",60044),symbolConstructor:(0,n.$1j)("symbol-constructor",60044),symbolBoolean:(0,n.$1j)("symbol-boolean",60047),symbolNull:(0,n.$1j)("symbol-null",60047),symbolNumeric:(0,n.$1j)("symbol-numeric",60048),symbolNumber:(0,n.$1j)("symbol-number",60048),symbolStructure:(0,n.$1j)("symbol-structure",60049),symbolStruct:(0,n.$1j)("symbol-struct",60049),symbolParameter:(0,n.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,n.$1j)("symbol-type-parameter",60050),symbolKey:(0,n.$1j)("symbol-key",60051),symbolText:(0,n.$1j)("symbol-text",60051),symbolReference:(0,n.$1j)("symbol-reference",60052),goToFile:(0,n.$1j)("go-to-file",60052),symbolEnum:(0,n.$1j)("symbol-enum",60053),symbolValue:(0,n.$1j)("symbol-value",60053),symbolRuler:(0,n.$1j)("symbol-ruler",60054),symbolUnit:(0,n.$1j)("symbol-unit",60054),activateBreakpoints:(0,n.$1j)("activate-breakpoints",60055),archive:(0,n.$1j)("archive",60056),arrowBoth:(0,n.$1j)("arrow-both",60057),arrowDown:(0,n.$1j)("arrow-down",60058),arrowLeft:(0,n.$1j)("arrow-left",60059),arrowRight:(0,n.$1j)("arrow-right",60060),arrowSmallDown:(0,n.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,n.$1j)("arrow-small-left",60062),arrowSmallRight:(0,n.$1j)("arrow-small-right",60063),arrowSmallUp:(0,n.$1j)("arrow-small-up",60064),arrowUp:(0,n.$1j)("arrow-up",60065),bell:(0,n.$1j)("bell",60066),bold:(0,n.$1j)("bold",60067),book:(0,n.$1j)("book",60068),bookmark:(0,n.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$1j)("briefcase",60076),broadcast:(0,n.$1j)("broadcast",60077),browser:(0,n.$1j)("browser",60078),bug:(0,n.$1j)("bug",60079),calendar:(0,n.$1j)("calendar",60080),caseSensitive:(0,n.$1j)("case-sensitive",60081),check:(0,n.$1j)("check",60082),checklist:(0,n.$1j)("checklist",60083),chevronDown:(0,n.$1j)("chevron-down",60084),chevronLeft:(0,n.$1j)("chevron-left",60085),chevronRight:(0,n.$1j)("chevron-right",60086),chevronUp:(0,n.$1j)("chevron-up",60087),chromeClose:(0,n.$1j)("chrome-close",60088),chromeMaximize:(0,n.$1j)("chrome-maximize",60089),chromeMinimize:(0,n.$1j)("chrome-minimize",60090),chromeRestore:(0,n.$1j)("chrome-restore",60091),circleOutline:(0,n.$1j)("circle-outline",60092),circle:(0,n.$1j)("circle",60092),debugBreakpointUnverified:(0,n.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$1j)("circle-slash",60093),circuitBoard:(0,n.$1j)("circuit-board",60094),clearAll:(0,n.$1j)("clear-all",60095),clippy:(0,n.$1j)("clippy",60096),closeAll:(0,n.$1j)("close-all",60097),cloudDownload:(0,n.$1j)("cloud-download",60098),cloudUpload:(0,n.$1j)("cloud-upload",60099),code:(0,n.$1j)("code",60100),collapseAll:(0,n.$1j)("collapse-all",60101),colorMode:(0,n.$1j)("color-mode",60102),commentDiscussion:(0,n.$1j)("comment-discussion",60103),creditCard:(0,n.$1j)("credit-card",60105),dash:(0,n.$1j)("dash",60108),dashboard:(0,n.$1j)("dashboard",60109),database:(0,n.$1j)("database",60110),debugContinue:(0,n.$1j)("debug-continue",60111),debugDisconnect:(0,n.$1j)("debug-disconnect",60112),debugPause:(0,n.$1j)("debug-pause",60113),debugRestart:(0,n.$1j)("debug-restart",60114),debugStart:(0,n.$1j)("debug-start",60115),debugStepInto:(0,n.$1j)("debug-step-into",60116),debugStepOut:(0,n.$1j)("debug-step-out",60117),debugStepOver:(0,n.$1j)("debug-step-over",60118),debugStop:(0,n.$1j)("debug-stop",60119),debug:(0,n.$1j)("debug",60120),deviceCameraVideo:(0,n.$1j)("device-camera-video",60121),deviceCamera:(0,n.$1j)("device-camera",60122),deviceMobile:(0,n.$1j)("device-mobile",60123),diffAdded:(0,n.$1j)("diff-added",60124),diffIgnored:(0,n.$1j)("diff-ignored",60125),diffModified:(0,n.$1j)("diff-modified",60126),diffRemoved:(0,n.$1j)("diff-removed",60127),diffRenamed:(0,n.$1j)("diff-renamed",60128),diff:(0,n.$1j)("diff",60129),diffSidebyside:(0,n.$1j)("diff-sidebyside",60129),discard:(0,n.$1j)("discard",60130),editorLayout:(0,n.$1j)("editor-layout",60131),emptyWindow:(0,n.$1j)("empty-window",60132),exclude:(0,n.$1j)("exclude",60133),extensions:(0,n.$1j)("extensions",60134),eyeClosed:(0,n.$1j)("eye-closed",60135),fileBinary:(0,n.$1j)("file-binary",60136),fileCode:(0,n.$1j)("file-code",60137),fileMedia:(0,n.$1j)("file-media",60138),filePdf:(0,n.$1j)("file-pdf",60139),fileSubmodule:(0,n.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,n.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$1j)("file-symlink-file",60142),fileZip:(0,n.$1j)("file-zip",60143),files:(0,n.$1j)("files",60144),filter:(0,n.$1j)("filter",60145),flame:(0,n.$1j)("flame",60146),foldDown:(0,n.$1j)("fold-down",60147),foldUp:(0,n.$1j)("fold-up",60148),fold:(0,n.$1j)("fold",60149),folderActive:(0,n.$1j)("folder-active",60150),folderOpened:(0,n.$1j)("folder-opened",60151),gear:(0,n.$1j)("gear",60152),gift:(0,n.$1j)("gift",60153),gistSecret:(0,n.$1j)("gist-secret",60154),gist:(0,n.$1j)("gist",60155),gitCommit:(0,n.$1j)("git-commit",60156),gitCompare:(0,n.$1j)("git-compare",60157),compareChanges:(0,n.$1j)("compare-changes",60157),gitMerge:(0,n.$1j)("git-merge",60158),githubAction:(0,n.$1j)("github-action",60159),githubAlt:(0,n.$1j)("github-alt",60160),globe:(0,n.$1j)("globe",60161),grabber:(0,n.$1j)("grabber",60162),graph:(0,n.$1j)("graph",60163),gripper:(0,n.$1j)("gripper",60164),heart:(0,n.$1j)("heart",60165),home:(0,n.$1j)("home",60166),horizontalRule:(0,n.$1j)("horizontal-rule",60167),hubot:(0,n.$1j)("hubot",60168),inbox:(0,n.$1j)("inbox",60169),issueReopened:(0,n.$1j)("issue-reopened",60171),issues:(0,n.$1j)("issues",60172),italic:(0,n.$1j)("italic",60173),jersey:(0,n.$1j)("jersey",60174),json:(0,n.$1j)("json",60175),kebabVertical:(0,n.$1j)("kebab-vertical",60176),key:(0,n.$1j)("key",60177),law:(0,n.$1j)("law",60178),lightbulbAutofix:(0,n.$1j)("lightbulb-autofix",60179),linkExternal:(0,n.$1j)("link-external",60180),link:(0,n.$1j)("link",60181),listOrdered:(0,n.$1j)("list-ordered",60182),listUnordered:(0,n.$1j)("list-unordered",60183),liveShare:(0,n.$1j)("live-share",60184),loading:(0,n.$1j)("loading",60185),location:(0,n.$1j)("location",60186),mailRead:(0,n.$1j)("mail-read",60187),mail:(0,n.$1j)("mail",60188),markdown:(0,n.$1j)("markdown",60189),megaphone:(0,n.$1j)("megaphone",60190),mention:(0,n.$1j)("mention",60191),milestone:(0,n.$1j)("milestone",60192),gitPullRequestMilestone:(0,n.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,n.$1j)("mortar-board",60193),move:(0,n.$1j)("move",60194),multipleWindows:(0,n.$1j)("multiple-windows",60195),mute:(0,n.$1j)("mute",60196),noNewline:(0,n.$1j)("no-newline",60197),note:(0,n.$1j)("note",60198),octoface:(0,n.$1j)("octoface",60199),openPreview:(0,n.$1j)("open-preview",60200),package:(0,n.$1j)("package",60201),paintcan:(0,n.$1j)("paintcan",60202),pin:(0,n.$1j)("pin",60203),play:(0,n.$1j)("play",60204),run:(0,n.$1j)("run",60204),plug:(0,n.$1j)("plug",60205),preserveCase:(0,n.$1j)("preserve-case",60206),preview:(0,n.$1j)("preview",60207),project:(0,n.$1j)("project",60208),pulse:(0,n.$1j)("pulse",60209),question:(0,n.$1j)("question",60210),quote:(0,n.$1j)("quote",60211),radioTower:(0,n.$1j)("radio-tower",60212),reactions:(0,n.$1j)("reactions",60213),references:(0,n.$1j)("references",60214),refresh:(0,n.$1j)("refresh",60215),regex:(0,n.$1j)("regex",60216),remoteExplorer:(0,n.$1j)("remote-explorer",60217),remote:(0,n.$1j)("remote",60218),remove:(0,n.$1j)("remove",60219),replaceAll:(0,n.$1j)("replace-all",60220),replace:(0,n.$1j)("replace",60221),repoClone:(0,n.$1j)("repo-clone",60222),repoForcePush:(0,n.$1j)("repo-force-push",60223),repoPull:(0,n.$1j)("repo-pull",60224),repoPush:(0,n.$1j)("repo-push",60225),report:(0,n.$1j)("report",60226),requestChanges:(0,n.$1j)("request-changes",60227),rocket:(0,n.$1j)("rocket",60228),rootFolderOpened:(0,n.$1j)("root-folder-opened",60229),rootFolder:(0,n.$1j)("root-folder",60230),rss:(0,n.$1j)("rss",60231),ruby:(0,n.$1j)("ruby",60232),saveAll:(0,n.$1j)("save-all",60233),saveAs:(0,n.$1j)("save-as",60234),save:(0,n.$1j)("save",60235),screenFull:(0,n.$1j)("screen-full",60236),screenNormal:(0,n.$1j)("screen-normal",60237),searchStop:(0,n.$1j)("search-stop",60238),server:(0,n.$1j)("server",60240),settingsGear:(0,n.$1j)("settings-gear",60241),settings:(0,n.$1j)("settings",60242),shield:(0,n.$1j)("shield",60243),smiley:(0,n.$1j)("smiley",60244),sortPrecedence:(0,n.$1j)("sort-precedence",60245),splitHorizontal:(0,n.$1j)("split-horizontal",60246),splitVertical:(0,n.$1j)("split-vertical",60247),squirrel:(0,n.$1j)("squirrel",60248),starFull:(0,n.$1j)("star-full",60249),starHalf:(0,n.$1j)("star-half",60250),symbolClass:(0,n.$1j)("symbol-class",60251),symbolColor:(0,n.$1j)("symbol-color",60252),symbolConstant:(0,n.$1j)("symbol-constant",60253),symbolEnumMember:(0,n.$1j)("symbol-enum-member",60254),symbolField:(0,n.$1j)("symbol-field",60255),symbolFile:(0,n.$1j)("symbol-file",60256),symbolInterface:(0,n.$1j)("symbol-interface",60257),symbolKeyword:(0,n.$1j)("symbol-keyword",60258),symbolMisc:(0,n.$1j)("symbol-misc",60259),symbolOperator:(0,n.$1j)("symbol-operator",60260),symbolProperty:(0,n.$1j)("symbol-property",60261),wrench:(0,n.$1j)("wrench",60261),wrenchSubaction:(0,n.$1j)("wrench-subaction",60261),symbolSnippet:(0,n.$1j)("symbol-snippet",60262),tasklist:(0,n.$1j)("tasklist",60263),telescope:(0,n.$1j)("telescope",60264),textSize:(0,n.$1j)("text-size",60265),threeBars:(0,n.$1j)("three-bars",60266),thumbsdown:(0,n.$1j)("thumbsdown",60267),thumbsup:(0,n.$1j)("thumbsup",60268),tools:(0,n.$1j)("tools",60269),triangleDown:(0,n.$1j)("triangle-down",60270),triangleLeft:(0,n.$1j)("triangle-left",60271),triangleRight:(0,n.$1j)("triangle-right",60272),triangleUp:(0,n.$1j)("triangle-up",60273),twitter:(0,n.$1j)("twitter",60274),unfold:(0,n.$1j)("unfold",60275),unlock:(0,n.$1j)("unlock",60276),unmute:(0,n.$1j)("unmute",60277),unverified:(0,n.$1j)("unverified",60278),verified:(0,n.$1j)("verified",60279),versions:(0,n.$1j)("versions",60280),vmActive:(0,n.$1j)("vm-active",60281),vmOutline:(0,n.$1j)("vm-outline",60282),vmRunning:(0,n.$1j)("vm-running",60283),watch:(0,n.$1j)("watch",60284),whitespace:(0,n.$1j)("whitespace",60285),wholeWord:(0,n.$1j)("whole-word",60286),window:(0,n.$1j)("window",60287),wordWrap:(0,n.$1j)("word-wrap",60288),zoomIn:(0,n.$1j)("zoom-in",60289),zoomOut:(0,n.$1j)("zoom-out",60290),listFilter:(0,n.$1j)("list-filter",60291),listFlat:(0,n.$1j)("list-flat",60292),listSelection:(0,n.$1j)("list-selection",60293),selection:(0,n.$1j)("selection",60293),listTree:(0,n.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$1j)("circle-small-filled",60298),debugStackframeDot:(0,n.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,n.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,n.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$1j)("symbol-string",60301),debugReverseContinue:(0,n.$1j)("debug-reverse-continue",60302),debugStepBack:(0,n.$1j)("debug-step-back",60303),debugRestartFrame:(0,n.$1j)("debug-restart-frame",60304),debugAlt:(0,n.$1j)("debug-alt",60305),callIncoming:(0,n.$1j)("call-incoming",60306),callOutgoing:(0,n.$1j)("call-outgoing",60307),menu:(0,n.$1j)("menu",60308),expandAll:(0,n.$1j)("expand-all",60309),feedback:(0,n.$1j)("feedback",60310),gitPullRequestReviewer:(0,n.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,n.$1j)("ungroup-by-ref-type",60312),account:(0,n.$1j)("account",60313),gitPullRequestAssignee:(0,n.$1j)("git-pull-request-assignee",60313),bellDot:(0,n.$1j)("bell-dot",60314),debugConsole:(0,n.$1j)("debug-console",60315),library:(0,n.$1j)("library",60316),output:(0,n.$1j)("output",60317),runAll:(0,n.$1j)("run-all",60318),syncIgnored:(0,n.$1j)("sync-ignored",60319),pinned:(0,n.$1j)("pinned",60320),githubInverted:(0,n.$1j)("github-inverted",60321),serverProcess:(0,n.$1j)("server-process",60322),serverEnvironment:(0,n.$1j)("server-environment",60323),pass:(0,n.$1j)("pass",60324),issueClosed:(0,n.$1j)("issue-closed",60324),stopCircle:(0,n.$1j)("stop-circle",60325),playCircle:(0,n.$1j)("play-circle",60326),record:(0,n.$1j)("record",60327),debugAltSmall:(0,n.$1j)("debug-alt-small",60328),vmConnect:(0,n.$1j)("vm-connect",60329),cloud:(0,n.$1j)("cloud",60330),merge:(0,n.$1j)("merge",60331),export:(0,n.$1j)("export",60332),graphLeft:(0,n.$1j)("graph-left",60333),magnet:(0,n.$1j)("magnet",60334),notebook:(0,n.$1j)("notebook",60335),redo:(0,n.$1j)("redo",60336),checkAll:(0,n.$1j)("check-all",60337),pinnedDirty:(0,n.$1j)("pinned-dirty",60338),passFilled:(0,n.$1j)("pass-filled",60339),circleLargeFilled:(0,n.$1j)("circle-large-filled",60340),circleLarge:(0,n.$1j)("circle-large",60341),circleLargeOutline:(0,n.$1j)("circle-large-outline",60341),combine:(0,n.$1j)("combine",60342),gather:(0,n.$1j)("gather",60342),table:(0,n.$1j)("table",60343),variableGroup:(0,n.$1j)("variable-group",60344),typeHierarchy:(0,n.$1j)("type-hierarchy",60345),typeHierarchySub:(0,n.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$1j)("git-pull-request-create",60348),runAbove:(0,n.$1j)("run-above",60349),runBelow:(0,n.$1j)("run-below",60350),notebookTemplate:(0,n.$1j)("notebook-template",60351),debugRerun:(0,n.$1j)("debug-rerun",60352),workspaceTrusted:(0,n.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,n.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,n.$1j)("workspace-unknown",60355),terminalCmd:(0,n.$1j)("terminal-cmd",60356),terminalDebian:(0,n.$1j)("terminal-debian",60357),terminalLinux:(0,n.$1j)("terminal-linux",60358),terminalPowershell:(0,n.$1j)("terminal-powershell",60359),terminalTmux:(0,n.$1j)("terminal-tmux",60360),terminalUbuntu:(0,n.$1j)("terminal-ubuntu",60361),terminalBash:(0,n.$1j)("terminal-bash",60362),arrowSwap:(0,n.$1j)("arrow-swap",60363),copy:(0,n.$1j)("copy",60364),personAdd:(0,n.$1j)("person-add",60365),filterFilled:(0,n.$1j)("filter-filled",60366),wand:(0,n.$1j)("wand",60367),debugLineByLine:(0,n.$1j)("debug-line-by-line",60368),inspect:(0,n.$1j)("inspect",60369),layers:(0,n.$1j)("layers",60370),layersDot:(0,n.$1j)("layers-dot",60371),layersActive:(0,n.$1j)("layers-active",60372),compass:(0,n.$1j)("compass",60373),compassDot:(0,n.$1j)("compass-dot",60374),compassActive:(0,n.$1j)("compass-active",60375),azure:(0,n.$1j)("azure",60376),issueDraft:(0,n.$1j)("issue-draft",60377),gitPullRequestClosed:(0,n.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$1j)("git-pull-request-draft",60379),debugAll:(0,n.$1j)("debug-all",60380),debugCoverage:(0,n.$1j)("debug-coverage",60381),runErrors:(0,n.$1j)("run-errors",60382),folderLibrary:(0,n.$1j)("folder-library",60383),debugContinueSmall:(0,n.$1j)("debug-continue-small",60384),beakerStop:(0,n.$1j)("beaker-stop",60385),graphLine:(0,n.$1j)("graph-line",60386),graphScatter:(0,n.$1j)("graph-scatter",60387),pieChart:(0,n.$1j)("pie-chart",60388),bracket:(0,n.$1j)("bracket",60175),bracketDot:(0,n.$1j)("bracket-dot",60389),bracketError:(0,n.$1j)("bracket-error",60390),lockSmall:(0,n.$1j)("lock-small",60391),azureDevops:(0,n.$1j)("azure-devops",60392),verifiedFilled:(0,n.$1j)("verified-filled",60393),newline:(0,n.$1j)("newline",60394),layout:(0,n.$1j)("layout",60395),layoutActivitybarLeft:(0,n.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,n.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,n.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,n.$1j)("layout-panel-right",60401),layoutPanel:(0,n.$1j)("layout-panel",60402),layoutSidebarLeft:(0,n.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$1j)("layout-statusbar",60405),layoutMenubar:(0,n.$1j)("layout-menubar",60406),layoutCentered:(0,n.$1j)("layout-centered",60407),target:(0,n.$1j)("target",60408),indent:(0,n.$1j)("indent",60409),recordSmall:(0,n.$1j)("record-small",60410),errorSmall:(0,n.$1j)("error-small",60411),terminalDecorationError:(0,n.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,n.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,n.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$1j)("layout-sidebar-left-off",60418),blank:(0,n.$1j)("blank",60419),heartFilled:(0,n.$1j)("heart-filled",60420),map:(0,n.$1j)("map",60421),mapHorizontal:(0,n.$1j)("map-horizontal",60421),foldHorizontal:(0,n.$1j)("fold-horizontal",60421),mapFilled:(0,n.$1j)("map-filled",60422),mapHorizontalFilled:(0,n.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$1j)("fold-horizontal-filled",60422),circleSmall:(0,n.$1j)("circle-small",60423),bellSlash:(0,n.$1j)("bell-slash",60424),bellSlashDot:(0,n.$1j)("bell-slash-dot",60425),commentUnresolved:(0,n.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$1j)("search-fuzzy",60429),commentDraft:(0,n.$1j)("comment-draft",60430),send:(0,n.$1j)("send",60431),sparkle:(0,n.$1j)("sparkle",60432),insert:(0,n.$1j)("insert",60433),mic:(0,n.$1j)("mic",60434),thumbsdownFilled:(0,n.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$1j)("thumbsup-filled",60436),coffee:(0,n.$1j)("coffee",60437),snake:(0,n.$1j)("snake",60438),game:(0,n.$1j)("game",60439),vr:(0,n.$1j)("vr",60440),chip:(0,n.$1j)("chip",60441),piano:(0,n.$1j)("piano",60442),music:(0,n.$1j)("music",60443),micFilled:(0,n.$1j)("mic-filled",60444),repoFetch:(0,n.$1j)("repo-fetch",60445),copilot:(0,n.$1j)("copilot",60446),lightbulbSparkle:(0,n.$1j)("lightbulb-sparkle",60447),robot:(0,n.$1j)("robot",60448),sparkleFilled:(0,n.$1j)("sparkle-filled",60449),diffSingle:(0,n.$1j)("diff-single",60450),diffMultiple:(0,n.$1j)("diff-multiple",60451),surroundWith:(0,n.$1j)("surround-with",60452),share:(0,n.$1j)("share",60453),gitStash:(0,n.$1j)("git-stash",60454),gitStashApply:(0,n.$1j)("git-stash-apply",60455),gitStashPop:(0,n.$1j)("git-stash-pop",60456),vscode:(0,n.$1j)("vscode",60457),vscodeInsiders:(0,n.$1j)("vscode-insiders",60458),codeOss:(0,n.$1j)("code-oss",60459),runCoverage:(0,n.$1j)("run-coverage",60460),runAllCoverage:(0,n.$1j)("run-all-coverage",60461),coverage:(0,n.$1j)("coverage",60462),githubProject:(0,n.$1j)("github-project",60463),mapVertical:(0,n.$1j)("map-vertical",60464),foldVertical:(0,n.$1j)("fold-vertical",60464),mapVerticalFilled:(0,n.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$1j)("fold-vertical-filled",60465),goToSearch:(0,n.$1j)("go-to-search",60466),percentage:(0,n.$1j)("percentage",60467),sortPercentage:(0,n.$1j)("sort-percentage",60467),attach:(0,n.$1j)("attach",60468)}}),define(Se[57],ke([1,0,109,172]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=void 0,e.$4j=E;function E(){return Object.values(e.$6j)}e.$5j={dialogError:(0,n.$1j)("dialog-error","error"),dialogWarning:(0,n.$1j)("dialog-warning","warning"),dialogInfo:(0,n.$1j)("dialog-info","info"),dialogClose:(0,n.$1j)("dialog-close","close"),treeItemExpanded:(0,n.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$1j)("tree-filter-clear","close"),treeItemLoading:(0,n.$1j)("tree-item-loading","loading"),menuSelection:(0,n.$1j)("menu-selection","check"),menuSubmenu:(0,n.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,n.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,n.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$1j)("toolbar-more","more"),quickInputBack:(0,n.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,n.$1j)("drop-down-button",60084),symbolCustomColor:(0,n.$1j)("symbol-customcolor",60252),exportIcon:(0,n.$1j)("export",60332),workspaceUnspecified:(0,n.$1j)("workspace-unspecified",60355),newLine:(0,n.$1j)("newline",60394),thumbsDownFilled:(0,n.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$1j)("thumbsup-filled",60436),gitFetch:(0,n.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$1j)("debug-breakpoint-pending",60377)},e.$6j={...r.$3j,...e.$5j}}),define(Se[21],ke([1,0,11]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=r,e.$go=E,e.$ho=R,e.$io=y,e.$jo=o,e.$ko=S,e.$lo=v,e.$mo=f,e.$no=w,e.$oo=a,e.$po=h,e.$qo=m,e.$ro=$;function r(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const d=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([b,t])=>{d[b]=t&&typeof t=="object"?r(t):t}),d}function E(p){if(!p||typeof p!="object")return p;const d=[p];for(;d.length>0;){const b=d.shift();Object.freeze(b);for(const t in b)if(I.call(b,t)){const l=b[t];typeof l=="object"&&!Object.isFrozen(l)&&!(0,n.$jg)(l)&&d.push(l)}}return p}const I=Object.prototype.hasOwnProperty;function R(p,d){return A(p,d,new Set)}function A(p,d,b){if((0,n.$pg)(p))return p;const t=d(p);if(typeof t<"u")return t;if(Array.isArray(p)){const l=[];for(const i of p)l.push(A(i,d,b));return l}if((0,n.$ig)(p)){if(b.has(p))throw new Error("Cannot clone recursive data-structure");b.add(p);const l={};for(const i in p)I.call(p,i)&&(l[i]=A(p[i],d,b));return b.delete(p),l}return p}function y(p,d,b=!0){return(0,n.$ig)(p)?((0,n.$ig)(d)&&Object.keys(d).forEach(t=>{t in p?b&&((0,n.$ig)(p[t])&&(0,n.$ig)(d[t])?y(p[t],d[t],b):p[t]=d[t]):p[t]=d[t]}),p):d}function o(p,d){if(p===d)return!0;if(p==null||d===null||d===void 0||typeof p!=typeof d||typeof p!="object"||Array.isArray(p)!==Array.isArray(d))return!1;let b,t;if(Array.isArray(p)){if(p.length!==d.length)return!1;for(b=0;b<p.length;b++)if(!o(p[b],d[b]))return!1}else{const l=[];for(t in p)l.push(t);l.sort();const i=[];for(t in d)i.push(t);if(i.sort(),!o(l,i))return!1;for(b=0;b<l.length;b++)if(!o(p[l[b]],d[l[b]]))return!1}return!0}function S(p){const d=new Set;return JSON.stringify(p,(b,t)=>{if((0,n.$ig)(t)||Array.isArray(t)){if(d.has(t))return"[Circular]";d.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function v(p,d){const b=Object.create(null);return!p||!d||Object.keys(d).forEach(l=>{const i=p[l],g=d[l];o(i,g)||(b[l]=g)}),b}function f(p,d){const b=d.toLowerCase(),t=Object.keys(p).find(l=>l.toLowerCase()===b);return t?p[t]:p[d]}function w(p,d){const b=Object.create(null);for(const[t,l]of Object.entries(p))d(t,l)&&(b[t]=l);return b}function a(p){let d=[];for(;Object.prototype!==p;)d=d.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return d}function h(p){const d=[];for(const b of a(p))typeof p[b]=="function"&&d.push(b);return d}function m(p,d){const b=l=>function(){const i=Array.prototype.slice.call(arguments,0);return d(l,i)},t={};for(const l of p)t[l]=b(l);return t}function $(p,d){const b={};for(const[t,l]of Object.entries(p))b[t]=d(l,t);return b}}),define(Se[82],ke([1,0,57]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=E;var r;(function(R){function A(y){return y&&typeof y=="object"&&typeof y.id=="string"}R.isThemeColor=A})(r||(e.ThemeColor=r={}));function E(R){return{id:R}}var I;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function y(p){const d=A.exec(p.id);if(!d)return y(n.$6j.error);const[,b,t]=d,l=["codicon","codicon-"+b];return t&&l.push("codicon-modifier-"+t.substring(1)),l}R.asClassNameArray=y;function o(p){return y(p).join(" ")}R.asClassName=o;function S(p){return"."+y(p).join(".")}R.asCSSSelector=S;function v(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||r.isThemeColor(p.color))}R.isThemeIcon=v;const f=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function w(p){const d=f.exec(p);if(!d)return;const[,b]=d;return{id:b}}R.fromString=w;function a(p){return{id:p}}R.fromId=a;function h(p,d){let b=p.id;const t=b.lastIndexOf("~");return t!==-1&&(b=b.substring(0,t)),d&&(b=`${b}~${d}`),{id:b}}R.modify=h;function m(p){const d=p.id.lastIndexOf("~");if(d!==-1)return p.id.substring(d+1)}R.getModifier=m;function $(p,d){return p.id===d.id&&p.color?.id===d.color?.id}R.isEqual=$})(I||(e.ThemeIcon=I={}))}),define(Se[110],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=r,e.$df=E;var n;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(I){return I<0?0:I>n.MAX_UINT_8?n.MAX_UINT_8:I|0}function E(I){return I<0?0:I>n.MAX_UINT_32?n.MAX_UINT_32:I|0}}),define(Se[17],ke([1,0,169,35,65,110]),function(se,e,n,r,E,I){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=A,e.$ff=o,e.$gf=v,e.$hf=f,e.$if=w,e.$jf=a,e.$kf=h,e.$lf=m,e.$mf=$,e.$nf=p,e.$of=d,e.$pf=b,e.$qf=t,e.$rf=l,e.$sf=i,e.$tf=g,e.$uf=s,e.$vf=c,e.$wf=u,e.$xf=D,e.$yf=P,e.$zf=T,e.$Af=z,e.$Bf=C,e.$Cf=k,e.$Df=q,e.$Ef=Y,e.$Ff=J,e.$Gf=ne,e.$Hf=Z,e.$If=x,e.$Jf=le,e.$Kf=K,e.$Lf=ae,e.$Mf=M,e.$Nf=B,e.$Of=re,e.$Rf=ue,e.$Sf=_,e.$Tf=U,e.$Uf=O,e.$Vf=j,e.$Wf=Q,e.$Yf=N,e.$Zf=H,e.$1f=oe,e.$2f=fe,e.$3f=Ne,e.$4f=de,e.$5f=Re,e.$7f=Ce,e.$8f=me,e.$9f=Ie,e.$0f=Ae,e.$$f=Me,e.$_f=qe,e.$ag=Qe,e.$bg=Ge,e.$cg=nt;function A(be){return!be||typeof be!="string"?!0:be.trim().length===0}const y=/{(\d+)}/g;function o(be,...Le){return Le.length===0?be:be.replace(y,function(ve,ye){const ee=parseInt(ye,10);return isNaN(ee)||ee<0||ee>=Le.length?ve:Le[ee]})}const S=/{([^}]+)}/g;function v(be,Le){return Object.keys(Le).length===0?be:be.replace(S,(ve,ye)=>Le[ye]??ve)}function f(be){return be.replace(/[<>"'&]/g,Le=>{switch(Le){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Le})}function w(be){return be.replace(/[<>&]/g,function(Le){switch(Le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Le}})}function a(be){return be.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function h(be,Le){let ve=0,ye=be.indexOf(Le);for(;ye!==-1;)ve++,ye=be.indexOf(Le,ye+Le.length);return ve}function m(be,Le,ve="\u2026"){return be.length<=Le?be:`${be.substr(0,Le)}${ve}`}function $(be,Le,ve="\u2026"){if(be.length<=Le)return be;const ye=Math.ceil(Le/2)-ve.length/2,ee=Math.floor(Le/2)-ve.length/2;return`${be.substr(0,ye)}${ve}${be.substr(be.length-ee)}`}function p(be,Le=" "){const ve=d(be,Le);return b(ve,Le)}function d(be,Le){if(!be||!Le)return be;const ve=Le.length;if(ve===0||be.length===0)return be;let ye=0;for(;be.indexOf(Le,ye)===ye;)ye=ye+ve;return be.substring(ye)}function b(be,Le){if(!be||!Le)return be;const ve=Le.length,ye=be.length;if(ve===0||ye===0)return be;let ee=ye,ie=-1;for(;ie=be.lastIndexOf(Le,ee-1),!(ie===-1||ie+ve!==ee);){if(ie===0)return"";ee=ie}return be.substring(0,ee)}function t(be){return be.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(be){return be.replace(/\*/g,"")}function i(be,Le,ve={}){if(!be)throw new Error("Cannot create regex from empty string");Le||(be=a(be)),ve.wholeWord&&(/\B/.test(be.charAt(0))||(be="\\b"+be),/\B/.test(be.charAt(be.length-1))||(be=be+"\\b"));let ye="";return ve.global&&(ye+="g"),ve.matchCase||(ye+="i"),ve.multiline&&(ye+="m"),ve.unicode&&(ye+="u"),new RegExp(be,ye)}function g(be){return be.source==="^"||be.source==="^$"||be.source==="$"||be.source==="^\\s*$"?!1:!!(be.exec("")&&be.lastIndex===0)}function s(be){return be.split(/\r\n|\r|\n/)}function c(be){const Le=[],ve=be.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(ve.length/2);ye++)Le.push(ve[2*ye]+(ve[2*ye+1]??""));return Le}function u(be){for(let Le=0,ve=be.length;Le<ve;Le++){const ye=be.charCodeAt(Le);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return Le}return-1}function D(be,Le=0,ve=be.length){for(let ye=Le;ye<ve;ye++){const ee=be.charCodeAt(ye);if(ee!==r.CharCode.Space&&ee!==r.CharCode.Tab)return be.substring(Le,ye)}return be.substring(Le,ve)}function P(be,Le=be.length-1){for(let ve=Le;ve>=0;ve--){const ye=be.charCodeAt(ve);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ve}return-1}function T(be,Le,ve){const ye=[];let ee=0;for(const ie of be.matchAll(Le)){if(ye.push(be.slice(ee,ie.index)),ie.index===void 0)throw new Error("match.index should be defined");ee=ie.index+ie[0].length,ye.push(ve(ie[0],...ie.slice(1),ie.index,be,ie.groups))}return ye.push(be.slice(ee)),Promise.all(ye).then(ie=>ie.join(""))}function z(be,Le){return be<Le?-1:be>Le?1:0}function C(be,Le,ve=0,ye=be.length,ee=0,ie=Le.length){for(;ve<ye&&ee<ie;ve++,ee++){const Ke=be.charCodeAt(ve),xe=Le.charCodeAt(ee);if(Ke<xe)return-1;if(Ke>xe)return 1}const we=ye-ve,He=ie-ee;return we<He?-1:we>He?1:0}function k(be,Le){return q(be,Le,0,be.length,0,Le.length)}function q(be,Le,ve=0,ye=be.length,ee=0,ie=Le.length){for(;ve<ye&&ee<ie;ve++,ee++){let Ke=be.charCodeAt(ve),xe=Le.charCodeAt(ee);if(Ke===xe)continue;if(Ke>=128||xe>=128)return C(be.toLowerCase(),Le.toLowerCase(),ve,ye,ee,ie);J(Ke)&&(Ke-=32),J(xe)&&(xe-=32);const tt=Ke-xe;if(tt!==0)return tt}const we=ye-ve,He=ie-ee;return we<He?-1:we>He?1:0}function Y(be){return be>=r.CharCode.Digit0&&be<=r.CharCode.Digit9}function J(be){return be>=r.CharCode.a&&be<=r.CharCode.z}function ne(be){return be>=r.CharCode.A&&be<=r.CharCode.Z}function Z(be,Le){return be.length===Le.length&&q(be,Le)===0}function x(be,Le){const ve=Le.length;return Le.length>be.length?!1:q(be,Le,0,ve)===0}function le(be,Le){const ve=Math.min(be.length,Le.length);let ye;for(ye=0;ye<ve;ye++)if(be.charCodeAt(ye)!==Le.charCodeAt(ye))return ye;return ve}function K(be,Le){const ve=Math.min(be.length,Le.length);let ye;const ee=be.length-1,ie=Le.length-1;for(ye=0;ye<ve;ye++)if(be.charCodeAt(ee-ye)!==Le.charCodeAt(ie-ye))return ye;return ve}function ae(be){return 55296<=be&&be<=56319}function M(be){return 56320<=be&&be<=57343}function B(be,Le){return(be-55296<<10)+(Le-56320)+65536}function re(be,Le,ve){const ye=be.charCodeAt(ve);if(ae(ye)&&ve+1<Le){const ee=be.charCodeAt(ve+1);if(M(ee))return B(ye,ee)}return ye}function ce(be,Le){const ve=be.charCodeAt(Le-1);if(M(ve)&&Le>1){const ye=be.charCodeAt(Le-2);if(ae(ye))return B(ye,ve)}return ve}class pe{get offset(){return this.e}constructor(Le,ve=0){this.c=Le,this.d=Le.length,this.e=ve}setOffset(Le){this.e=Le}prevCodePoint(){const Le=ce(this.c,this.e);return this.e-=Le>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Le}nextCodePoint(){const Le=re(this.c,this.d,this.e);return this.e+=Le>=I.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Le}eol(){return this.e>=this.d}}e.$Pf=pe;class W{get offset(){return this.c.offset}constructor(Le,ve=0){this.c=new pe(Le,ve)}nextGraphemeLength(){const Le=rt.getInstance(),ve=this.c,ye=ve.offset;let ee=Le.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const ie=ve.offset,we=Le.getGraphemeBreakType(ve.nextCodePoint());if(Ye(ee,we)){ve.setOffset(ie);break}ee=we}return ve.offset-ye}prevGraphemeLength(){const Le=rt.getInstance(),ve=this.c,ye=ve.offset;let ee=Le.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const ie=ve.offset,we=Le.getGraphemeBreakType(ve.prevCodePoint());if(Ye(we,ee)){ve.setOffset(ie);break}ee=we}return ye-ve.offset}eol(){return this.c.eol()}}e.$Qf=W;function ue(be,Le){return new W(be,Le).nextGraphemeLength()}function _(be,Le){return new W(be,Le).prevGraphemeLength()}function U(be,Le){Le>0&&M(be.charCodeAt(Le))&&Le--;const ve=Le+ue(be,Le);return[ve-_(be,ve),ve]}function O(be){const Le=new W(be);let ve=0;for(;!Le.eol();)ve++,Le.nextGraphemeLength();return ve}let te;function V(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(be){return te||(te=V()),te.test(be)}const G=/^[\t\n\r\x20-\x7E]*$/;function Q(be){return G.test(be)}e.$Xf=/[\u2028\u2029]/;function N(be){return e.$Xf.test(be)}function H(be){return be>=11904&&be<=55215||be>=63744&&be<=64255||be>=65281&&be<=65374}function oe(be){return be>=127462&&be<=127487||be===8986||be===8987||be===9200||be===9203||be>=9728&&be<=10175||be===11088||be===11093||be>=127744&&be<=128591||be>=128640&&be<=128764||be>=128992&&be<=129008||be>=129280&&be<=129535||be>=129648&&be<=129782}function fe(be,Le,ve=""){const ye=be.trimStart();if(ye.length<Le)return ye;const ee=/\b/g;let ie=0;for(;ee.test(ye)&&!(ye.length-ee.lastIndex<Le);)ie=ee.lastIndex,ee.lastIndex+=1;return ie===0?ye:ve+ye.substring(ie).trimStart()}const Ee=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Ne(be){let Le=0;for(const ve of be.matchAll(Ee))Le!==ve.index&&(yield{isCode:!1,str:be.substring(Le,ve.index)}),yield{isCode:!0,str:ve[0]},Le=ve.index+ve[0].length;Le!==be.length&&(yield{isCode:!1,str:be.substring(Le)})}function de(be){return be&&(be=be.replace(Ee,"")),be}const $e=/\\\[.*?\\\]/g;function Re(be){return de(be).replace($e,"")}e.$6f=String.fromCharCode(r.CharCode.UTF8_BOM);function Ce(be){return!!(be&&be.length>0&&be.charCodeAt(0)===r.CharCode.UTF8_BOM)}function me(be){return Ce(be)?be.substr(1):be}function Ie(be,Le){if(!be||!Le||be.length<Le.length)return!1;const ve=Le.length,ye=be.toLowerCase();let ee=0,ie=-1;for(;ee<ve;){const we=ye.indexOf(Le[ee],ie+1);if(we<0)return!1;ie=we,ee++}return!0}function Ae(be,Le=!1){return be?(Le&&(be=be.replace(/\\./g,"")),be.toLowerCase()!==be):!1}function Me(be){return be.charAt(0).toUpperCase()+be.slice(1)}function qe(be,Le=1){if(Le===0)return"";let ve=-1;do ve=be.indexOf(`
`,ve+1),Le--;while(Le>0&&ve>=0);return ve===-1?be:(be[ve-1]==="\r"&&ve--,be.substr(0,ve))}function Qe(be){const Le=r.CharCode.Z-r.CharCode.A+1;return be=be%(2*Le),be<Le?String.fromCharCode(r.CharCode.a+be):String.fromCharCode(r.CharCode.A+be-Le)}function Ge(be){return rt.getInstance().getGraphemeBreakType(be)}function Ye(be,Le){return be===We.Other?Le!==We.Extend&&Le!==We.SpacingMark:be===We.CR&&Le===We.LF?!1:be===We.Control||be===We.CR||be===We.LF||Le===We.Control||Le===We.CR||Le===We.LF?!0:!(be===We.L&&(Le===We.L||Le===We.V||Le===We.LV||Le===We.LVT)||(be===We.LV||be===We.V)&&(Le===We.V||Le===We.T)||(be===We.LVT||be===We.T)&&Le===We.T||Le===We.Extend||Le===We.ZWJ||Le===We.SpacingMark||be===We.Prepend||be===We.ZWJ&&Le===We.Extended_Pictographic||be===We.Regional_Indicator&&Le===We.Regional_Indicator)}var We;(function(be){be[be.Other=0]="Other",be[be.Prepend=1]="Prepend",be[be.CR=2]="CR",be[be.LF=3]="LF",be[be.Control=4]="Control",be[be.Extend=5]="Extend",be[be.Regional_Indicator=6]="Regional_Indicator",be[be.SpacingMark=7]="SpacingMark",be[be.L=8]="L",be[be.V=9]="V",be[be.T=10]="T",be[be.LV=11]="LV",be[be.LVT=12]="LVT",be[be.ZWJ=13]="ZWJ",be[be.Extended_Pictographic=14]="Extended_Pictographic"})(We||(e.GraphemeBreakType=We={}));class rt{static getInstance(){return rt.c||(rt.c=new rt),rt.c}constructor(){this.d=at()}getGraphemeBreakType(Le){if(Le<32)return Le===r.CharCode.LineFeed?We.LF:Le===r.CharCode.CarriageReturn?We.CR:We.Control;if(Le<127)return We.Other;const ve=this.d,ye=ve.length/3;let ee=1;for(;ee<=ye;)if(Le<ve[3*ee])ee=2*ee;else if(Le>ve[3*ee+1])ee=2*ee+1;else return ve[3*ee+2];return We.Other}}rt.c=null;function at(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(be,Le){if(be===0)return 0;const ve=ct(be,Le);if(ve!==void 0)return ve;const ye=new pe(Le,be);return ye.prevCodePoint(),ye.offset}function ct(be,Le){const ve=new pe(Le,be);let ye=ve.prevCodePoint();for(;it(ye)||ye===_e.emojiVariantSelector||ye===_e.enclosingKeyCap;){if(ve.offset===0)return;ye=ve.prevCodePoint()}if(!oe(ye))return;let ee=ve.offset;return ee>0&&ve.prevCodePoint()===_e.zwj&&(ee=ve.offset),ee}function it(be){return 127995<=be&&be<=127999}var _e;(function(be){be[be.zwj=8205]="zwj",be[be.emojiVariantSelector=65039]="emojiVariantSelector",be[be.enclosingKeyCap=8419]="enclosingKeyCap"})(_e||(_e={})),e.$dg="\xA0";class Je{static getInstance(Le){return R.d.get(Array.from(Le))}static getLocales(){return R.e.value}constructor(Le){this.f=Le}isAmbiguous(Le){return this.f.has(Le)}containsAmbiguousCharacter(Le){for(let ve=0;ve<Le.length;ve++){const ye=Le.codePointAt(ve);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(Le){return this.f.get(Le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=Je,R=Je,Je.c=new E.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Je.d=new n.$af({getCacheKey:JSON.stringify},be=>{function Le(xe){const tt=new Map;for(let lt=0;lt<xe.length;lt+=2)tt.set(xe[lt],xe[lt+1]);return tt}function ve(xe,tt){const lt=new Map(xe);for(const[pt,yt]of tt)lt.set(pt,yt);return lt}function ye(xe,tt){if(!xe)return tt;const lt=new Map;for(const[pt,yt]of xe)tt.has(pt)&&lt.set(pt,yt);return lt}const ee=R.c.value;let ie=be.filter(xe=>!xe.startsWith("_")&&xe in ee);ie.length===0&&(ie=["_default"]);let we;for(const xe of ie){const tt=Le(ee[xe]);we=ye(we,tt)}const He=Le(ee._common),Ke=ve(He,we);return new R(Ke)}),Je.e=new E.$X(()=>Object.keys(R.c.value).filter(be=>!be.startsWith("_")));class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Le){return et.e().has(Le)}static containsInvisibleCharacter(Le){for(let ve=0;ve<Le.length;ve++){const ye=Le.codePointAt(ve);if(typeof ye=="number"&&et.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return et.e()}}e.$fg=et,et.d=void 0}),define(Se[37],ke([1,0,35,9,3,17,11]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=A,e.$zg=y,e.$Ag=o,e.$Bg=S,e.$Cg=v,e.$Dg=h,e.$Eg=m,e.$Fg=$,e.$Gg=p,e.$Hg=d,e.$Ig=b,e.$Jg=t,e.$Kg=l,e.$Lg=i,e.$Mg=g,e.$Ng=s,e.$Og=D;function A(P){return P===n.CharCode.Slash||P===n.CharCode.Backslash}function y(P){return P.replace(/[\\/]/g,r.$jc.sep)}function o(P){return P.indexOf("/")===-1&&(P=y(P)),/^[a-zA-Z]:(\/|$)/.test(P)&&(P="/"+P),P}function S(P,T=r.$jc.sep){if(!P)return"";const z=P.length,C=P.charCodeAt(0);if(A(C)){if(A(P.charCodeAt(1))&&!A(P.charCodeAt(2))){let q=3;const Y=q;for(;q<z&&!A(P.charCodeAt(q));q++);if(Y!==q&&!A(P.charCodeAt(q+1))){for(q+=1;q<z;q++)if(A(P.charCodeAt(q)))return P.slice(0,q+1).replace(/[\\/]/g,T)}}return T}else if(p(C)&&P.charCodeAt(1)===n.CharCode.Colon)return A(P.charCodeAt(2))?P.slice(0,2)+T:P.slice(0,2);let k=P.indexOf("://");if(k!==-1){for(k+=3;k<z;k++)if(A(P.charCodeAt(k)))return P.slice(0,k+1)}return""}function v(P){if(!E.$c||!P||P.length<5)return!1;let T=P.charCodeAt(0);if(T!==n.CharCode.Backslash||(T=P.charCodeAt(1),T!==n.CharCode.Backslash))return!1;let z=2;const C=z;for(;z<P.length&&(T=P.charCodeAt(z),T!==n.CharCode.Backslash);z++);return!(C===z||(T=P.charCodeAt(z+1),isNaN(T)||T===n.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,w=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(P,T=E.$c){const z=T?f:w;return!(!P||P.length===0||/^\s+$/.test(P)||(z.lastIndex=0,z.test(P))||T&&a.test(P)||P==="."||P===".."||T&&P[P.length-1]==="."||T&&P.length!==P.trim().length||P.length>255)}function m(P,T,z){const C=P===T;return!z||C?C:!P||!T?!1:(0,I.$Hf)(P,T)}function $(P,T,z,C=r.sep){if(P===T)return!0;if(!P||!T||T.length>P.length)return!1;if(z){if(!(0,I.$If)(P,T))return!1;if(T.length===P.length)return!0;let q=T.length;return T.charAt(T.length-1)===C&&q--,P.charAt(q)===C}return T.charAt(T.length-1)!==C&&(T+=C),P.indexOf(T)===0}function p(P){return P>=n.CharCode.A&&P<=n.CharCode.Z||P>=n.CharCode.a&&P<=n.CharCode.z}function d(P,T){return E.$c&&P.endsWith(":")&&(P+=r.sep),(0,r.$lc)(P)||(P=(0,r.$mc)(T,P)),P=(0,r.$kc)(P),b(P)}function b(P){return E.$c?(P=(0,I.$pf)(P,r.sep),P.endsWith(":")&&(P+=r.sep)):(P=(0,I.$pf)(P,r.sep),P||(P=r.sep)),P}function t(P){const T=(0,r.$kc)(P);return E.$c?P.length>3?!1:l(T)&&(P.length===2||T.charCodeAt(2)===n.CharCode.Backslash):T===r.$jc.sep}function l(P,T=E.$c){return T?p(P.charCodeAt(0))&&P.charCodeAt(1)===n.CharCode.Colon:!1}function i(P,T=E.$c){return l(P,T)?P[0]:void 0}function g(P,T,z){return T.length>P.length?-1:P===T?0:(z&&(P=P.toLowerCase(),T=T.toLowerCase()),P.indexOf(T))}function s(P){const T=P.split(":");let z,C,k;for(const q of T){const Y=Number(q);(0,R.$kg)(Y)?C===void 0?C=Y:k===void 0&&(k=Y):z=z?[z,q].join(":"):q}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:C!==void 0?C:void 0,column:k!==void 0?k:C!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(P,T,z=8){let C="";for(let q=0;q<z;q++){let Y;q===0&&E.$c&&!T&&(z===3||z===4)?Y=u:Y=c,C+=Y.charAt(Math.floor(Math.random()*Y.length))}let k;return T?k=`${T}-${C}`:k=C,P?(0,r.$mc)(P,k):k}}),define(Se[173],ke([1,0,35,26,162,17]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.FuzzyScore=e.$Ik=e.$Hk=void 0,e.or=R,e.$Jk=y,e.$Kk=o,e.$Lk=f,e.$Mk=D,e.$Nk=P,e.$Ok=Y,e.$Pk=J,e.$Qk=ne,e.$Rk=Z,e.$Sk=te,e.$Uk=Q,e.$Vk=oe,e.$Wk=fe,I=Be(I);function R(...de){return function($e,Re){for(let Ce=0,me=de.length;Ce<me;Ce++){const Ie=de[Ce]($e,Re);if(Ie)return Ie}return null}}e.$Hk=A.bind(void 0,!1),e.$Ik=A.bind(void 0,!0);function A(de,$e,Re){if(!Re||Re.length<$e.length)return null;let Ce;return de?Ce=I.$If(Re,$e):Ce=Re.indexOf($e)===0,Ce?$e.length>0?[{start:0,end:$e.length}]:[]:null}function y(de,$e){const Re=$e.toLowerCase().indexOf(de.toLowerCase());return Re===-1?null:[{start:Re,end:Re+de.length}]}function o(de,$e){return S(de.toLowerCase(),$e.toLowerCase(),0,0)}function S(de,$e,Re,Ce){if(Re===de.length)return[];if(Ce===$e.length)return null;if(de[Re]===$e[Ce]){let me=null;return(me=S(de,$e,Re+1,Ce+1))?t({start:Ce,end:Ce+1},me):null}return S(de,$e,Re,Ce+1)}function v(de){return n.CharCode.a<=de&&de<=n.CharCode.z}function f(de){return n.CharCode.A<=de&&de<=n.CharCode.Z}function w(de){return n.CharCode.Digit0<=de&&de<=n.CharCode.Digit9}function a(de){return de===n.CharCode.Space||de===n.CharCode.Tab||de===n.CharCode.LineFeed||de===n.CharCode.CarriageReturn}const h=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>h.add(de.charCodeAt(0)));function m(de){return a(de)||h.has(de)}function $(de,$e){return de===$e||m(de)&&m($e)}const p=new Map;function d(de){if(p.has(de))return p.get(de);let $e;const Re=(0,E.$Fk)(de);return Re&&($e=Re),p.set(de,$e),$e}function b(de){return v(de)||f(de)||w(de)}function t(de,$e){return $e.length===0?$e=[de]:de.end===$e[0].start?$e[0].start=de.start:$e.unshift(de),$e}function l(de,$e){for(let Re=$e;Re<de.length;Re++){const Ce=de.charCodeAt(Re);if(f(Ce)||w(Ce)||Re>0&&!b(de.charCodeAt(Re-1)))return Re}return de.length}function i(de,$e,Re,Ce){if(Re===de.length)return[];if(Ce===$e.length)return null;if(de[Re]!==$e[Ce].toLowerCase())return null;{let me=null,Ie=Ce+1;for(me=i(de,$e,Re+1,Ce+1);!me&&(Ie=l($e,Ie))<$e.length;)me=i(de,$e,Re+1,Ie),Ie++;return me===null?null:t({start:Ce,end:Ce+1},me)}}function g(de){let $e=0,Re=0,Ce=0,me=0,Ie=0;for(let Ge=0;Ge<de.length;Ge++)Ie=de.charCodeAt(Ge),f(Ie)&&$e++,v(Ie)&&Re++,b(Ie)&&Ce++,w(Ie)&&me++;const Ae=$e/de.length,Me=Re/de.length,qe=Ce/de.length,Qe=me/de.length;return{upperPercent:Ae,lowerPercent:Me,alphaPercent:qe,numericPercent:Qe}}function s(de){const{upperPercent:$e,lowerPercent:Re}=de;return Re===0&&$e>.6}function c(de){const{upperPercent:$e,lowerPercent:Re,alphaPercent:Ce,numericPercent:me}=de;return Re>.2&&$e<.8&&Ce>.6&&me<.2}function u(de){let $e=0,Re=0,Ce=0,me=0;for(let Ie=0;Ie<de.length;Ie++)Ce=de.charCodeAt(Ie),f(Ce)&&$e++,v(Ce)&&Re++,a(Ce)&&me++;return($e===0||Re===0)&&me===0?de.length<=30:$e<=5}function D(de,$e){if(!$e||($e=$e.trim(),$e.length===0)||!u(de))return null;$e.length>60&&($e=$e.substring(0,60));const Re=g($e);if(!c(Re)){if(!s(Re))return null;$e=$e.toLowerCase()}let Ce=null,me=0;for(de=de.toLowerCase();me<$e.length&&(Ce=i(de,$e,0,me))===null;)me=l($e,me+1);return Ce}function P(de,$e,Re=!1){if(!$e||$e.length===0)return null;let Ce=null,me=0;for(de=de.toLowerCase(),$e=$e.toLowerCase();me<$e.length&&(Ce=T(de,$e,0,me,Re),Ce===null);)me=z($e,me+1);return Ce}function T(de,$e,Re,Ce,me){let Ie=0;if(Re===de.length)return[];if(Ce===$e.length)return null;if(!$(de.charCodeAt(Re),$e.charCodeAt(Ce))){const qe=d(de.charCodeAt(Re));if(!qe)return null;for(let Qe=0;Qe<qe.length;Qe++)if(!$(qe[Qe],$e.charCodeAt(Ce+Qe)))return null;Ie+=qe.length-1}let Ae=null,Me=Ce+Ie+1;if(Ae=T(de,$e,Re+1,Me,me),!me)for(;!Ae&&(Me=z($e,Me))<$e.length;)Ae=T(de,$e,Re+1,Me,me),Me++;if(!Ae)return null;if(de.charCodeAt(Re)!==$e.charCodeAt(Ce)){const qe=d(de.charCodeAt(Re));if(!qe)return Ae;for(let Qe=0;Qe<qe.length;Qe++)if(qe[Qe]!==$e.charCodeAt(Ce+Qe))return Ae}return t({start:Ce,end:Ce+Ie+1},Ae)}function z(de,$e){for(let Re=$e;Re<de.length;Re++)if(m(de.charCodeAt(Re))||Re>0&&m(de.charCodeAt(Re-1)))return Re;return de.length}const C=R(e.$Ik,D,y),k=R(e.$Ik,D,o),q=new r.$Gc(1e4);function Y(de,$e,Re=!1){if(typeof de!="string"||typeof $e!="string")return null;let Ce=q.get(de);Ce||(Ce=new RegExp(I.$qf(de),"i"),q.set(de,Ce));const me=Ce.exec($e);return me?[{start:me.index,end:me.index+me[0].length}]:Re?k(de,$e):C(de,$e)}function J(de,$e){const Re=Q(de,de.toLowerCase(),0,$e,$e.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?Z(Re):null}function ne(de,$e,Re,Ce,me,Ie){const Ae=Math.min(13,de.length);for(;Re<Ae;Re++){const Me=Q(de,$e,Re,Ce,me,Ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Me)return Me}return[0,Ie]}function Z(de){if(typeof de>"u")return[];const $e=[],Re=de[1];for(let Ce=de.length-1;Ce>1;Ce--){const me=de[Ce]+Re,Ie=$e[$e.length-1];Ie&&Ie.end===me?Ie.end=me+1:$e.push({start:me,end:me+1})}return $e}const x=128;function le(){const de=[],$e=[];for(let Re=0;Re<=x;Re++)$e[Re]=0;for(let Re=0;Re<=x;Re++)de.push($e.slice(0));return de}function K(de){const $e=[];for(let Re=0;Re<=de;Re++)$e[Re]=0;return $e}const ae=K(2*x),M=K(2*x),B=le(),re=le(),ce=le(),pe=!1;function W(de,$e,Re,Ce,me){function Ie(Me,qe,Qe=" "){for(;Me.length<qe;)Me=Qe+Me;return Me}let Ae=` |   |${Ce.split("").map(Me=>Ie(Me,3)).join("|")}
`;for(let Me=0;Me<=Re;Me++)Me===0?Ae+=" |":Ae+=`${$e[Me-1]}|`,Ae+=de[Me].slice(0,me+1).map(qe=>Ie(qe.toString(),3)).join("|")+`
`;return Ae}function ue(de,$e,Re,Ce){de=de.substr($e),Re=Re.substr(Ce),console.log(W(re,de,de.length,Re,Re.length)),console.log(W(ce,de,de.length,Re,Re.length)),console.log(W(B,de,de.length,Re,Re.length))}function _(de,$e){if($e<0||$e>=de.length)return!1;const Re=de.codePointAt($e);switch(Re){case n.CharCode.Underline:case n.CharCode.Dash:case n.CharCode.Period:case n.CharCode.Space:case n.CharCode.Slash:case n.CharCode.Backslash:case n.CharCode.SingleQuote:case n.CharCode.DoubleQuote:case n.CharCode.Colon:case n.CharCode.DollarSign:case n.CharCode.LessThan:case n.CharCode.GreaterThan:case n.CharCode.OpenParen:case n.CharCode.CloseParen:case n.CharCode.OpenSquareBracket:case n.CharCode.CloseSquareBracket:case n.CharCode.OpenCurlyBrace:case n.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!I.$1f(Re)}}function U(de,$e){if($e<0||$e>=de.length)return!1;switch(de.charCodeAt($e)){case n.CharCode.Space:case n.CharCode.Tab:return!0;default:return!1}}function O(de,$e,Re){return $e[de]!==Re[de]}function te(de,$e,Re,Ce,me,Ie,Ae=!1){for(;$e<Re&&me<Ie;)de[$e]===Ce[me]&&(Ae&&(ae[$e]=me),$e+=1),me+=1;return $e===Re}var V;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(V||(V={}));var j;(function(de){de.Default=[-100,0];function $e(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}de.isDefault=$e})(j||(e.FuzzyScore=j={}));class G{constructor($e,Re){this.firstMatchCanBeWeak=$e,this.boostFullMatch=Re}}e.$Tk=G,G.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Q(de,$e,Re,Ce,me,Ie,Ae=G.default){const Me=de.length>x?x:de.length,qe=Ce.length>x?x:Ce.length;if(Re>=Me||Ie>=qe||Me-Re>qe-Ie||!te($e,Re,Me,me,Ie,qe,!0))return;N(Me,qe,Re,Ie,$e,me);let Qe=1,Ge=1,Ye=Re,We=Ie;const rt=[!1];for(Qe=1,Ye=Re;Ye<Me;Qe++,Ye++){const _e=ae[Ye],Je=M[Ye],et=Ye+1<Me?M[Ye+1]:qe;for(Ge=_e-Ie+1,We=_e;We<et;Ge++,We++){let be=Number.MIN_SAFE_INTEGER,Le=!1;We<=Je&&(be=H(de,$e,Ye,Re,Ce,me,We,qe,Ie,B[Qe-1][Ge-1]===0,rt));let ve=0;be!==Number.MAX_SAFE_INTEGER&&(Le=!0,ve=be+re[Qe-1][Ge-1]);const ye=We>_e,ee=ye?re[Qe][Ge-1]+(B[Qe][Ge-1]>0?-5:0):0,ie=We>_e+1&&B[Qe][Ge-1]>0,we=ie?re[Qe][Ge-2]+(B[Qe][Ge-2]>0?-5:0):0;if(ie&&(!ye||we>=ee)&&(!Le||we>=ve))re[Qe][Ge]=we,ce[Qe][Ge]=V.LeftLeft,B[Qe][Ge]=0;else if(ye&&(!Le||ee>=ve))re[Qe][Ge]=ee,ce[Qe][Ge]=V.Left,B[Qe][Ge]=0;else if(Le)re[Qe][Ge]=ve,ce[Qe][Ge]=V.Diag,B[Qe][Ge]=B[Qe-1][Ge-1]+1;else throw new Error("not possible")}}if(pe&&ue(de,Re,Ce,Ie),!rt[0]&&!Ae.firstMatchCanBeWeak)return;Qe--,Ge--;const at=[re[Qe][Ge],Ie];let nt=0,ct=0;for(;Qe>=1;){let _e=Ge;do{const Je=ce[Qe][_e];if(Je===V.LeftLeft)_e=_e-2;else if(Je===V.Left)_e=_e-1;else break}while(_e>=1);nt>1&&$e[Re+Qe-1]===me[Ie+Ge-1]&&!O(_e+Ie-1,Ce,me)&&nt+1>B[Qe][_e]&&(_e=Ge),_e===Ge?nt++:nt=1,ct||(ct=_e),Qe--,Ge=_e-1,at.push(Ge)}qe-Ie===Me&&Ae.boostFullMatch&&(at[0]+=2);const it=ct-Me;return at[0]-=it,at}function N(de,$e,Re,Ce,me,Ie){let Ae=de-1,Me=$e-1;for(;Ae>=Re&&Me>=Ce;)me[Ae]===Ie[Me]&&(M[Ae]=Me,Ae--),Me--}function H(de,$e,Re,Ce,me,Ie,Ae,Me,qe,Qe,Ge){if($e[Re]!==Ie[Ae])return Number.MIN_SAFE_INTEGER;let Ye=1,We=!1;return Ae===Re-Ce?Ye=de[Re]===me[Ae]?7:5:O(Ae,me,Ie)&&(Ae===0||!O(Ae-1,me,Ie))?(Ye=de[Re]===me[Ae]?7:5,We=!0):_(Ie,Ae)&&(Ae===0||!_(Ie,Ae-1))?Ye=5:(_(Ie,Ae-1)||U(Ie,Ae-1))&&(Ye=5,We=!0),Ye>1&&Re===Ce&&(Ge[0]=!0),We||(We=O(Ae,me,Ie)||_(Ie,Ae-1)||U(Ie,Ae-1)),Re===Ce?Ae>qe&&(Ye-=We?3:5):Qe?Ye+=We?2:0:Ye+=We?0:1,Ae+1===Me&&(Ye-=We?3:5),Ye}function oe(de,$e,Re,Ce,me,Ie,Ae){return Ee(de,$e,Re,Ce,me,Ie,!0,Ae)}function fe(de,$e,Re,Ce,me,Ie,Ae){return Ee(de,$e,Re,Ce,me,Ie,!1,Ae)}function Ee(de,$e,Re,Ce,me,Ie,Ae,Me){let qe=Q(de,$e,Re,Ce,me,Ie,Me);if(qe&&!Ae)return qe;if(de.length>=3){const Qe=Math.min(7,de.length-1);for(let Ge=Re+1;Ge<Qe;Ge++){const Ye=Ne(de,Ge);if(Ye){const We=Q(Ye,Ye.toLowerCase(),Re,Ce,me,Ie,Me);We&&(We[0]-=3,(!qe||We[0]>qe[0])&&(qe=We))}}}return qe}function Ne(de,$e){if($e+1>=de.length)return;const Re=de[$e],Ce=de[$e+1];if(Re!==Ce)return de.slice(0,$e)+Ce+Re+de.slice($e+2)}}),define(Se[68],ke([1,0,17]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=r,e.$vj=E,e.$wj=I,e.$xj=A,e.$zj=h,n=Be(n);function r($){return E($,0)}function E($,p){switch(typeof $){case"object":return $===null?I(349,p):Array.isArray($)?y($,p):o($,p);case"string":return A($,p);case"boolean":return R($,p);case"number":return I($,p);case"undefined":return I(937,p);default:return I(617,p)}}function I($,p){return(p<<5)-p+$|0}function R($,p){return I($?433:863,p)}function A($,p){p=I(149417,p);for(let d=0,b=$.length;d<b;d++)p=I($.charCodeAt(d),p);return p}function y($,p){return p=I(104579,p),$.reduce((d,b)=>E(b,d),p)}function o($,p){return p=I(181387,p),Object.keys($).sort().reduce((d,b)=>(d=A(b,d),E($[b],d)),p)}class S{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=E(p,this.g),this.g}}e.$yj=S;var v;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function f($,p,d=32){const b=d-p,t=~((1<<b)-1);return($<<p|(t&$)>>>b)>>>0}function w($,p=0,d=$.byteLength,b=0){for(let t=0;t<d;t++)$[p+t]=b}function a($,p,d="0"){for(;$.length<p;)$=d+$;return $}function h($,p=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(d=>d.toString(16).padStart(2,"0")).join(""):a(($>>>0).toString(16),p/4)}class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(v.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const d=p.length;if(d===0)return;const b=this.p;let t=this.r,l=this.u,i,g;for(l!==0?(i=l,g=-1,l=0):(i=p.charCodeAt(0),g=0);;){let s=i;if(n.$Lf(i))if(g+1<d){const c=p.charCodeAt(g+1);n.$Mf(c)?(g++,s=n.$Nf(i,c)):s=v.UNICODE_REPLACEMENT}else{l=i;break}else n.$Mf(i)&&(s=v.UNICODE_REPLACEMENT);if(t=this.w(b,t,s),g++,g<d)i=p.charCodeAt(g);else break}this.r=t,this.u=l}w(p,d,b){return b<128?p[d++]=b:b<2048?(p[d++]=192|(b&1984)>>>6,p[d++]=128|(b&63)>>>0):b<65536?(p[d++]=224|(b&61440)>>>12,p[d++]=128|(b&4032)>>>6,p[d++]=128|(b&63)>>>0):(p[d++]=240|(b&1835008)>>>18,p[d++]=128|(b&258048)>>>12,p[d++]=128|(b&4032)>>>6,p[d++]=128|(b&63)>>>0),d>=v.BLOCK_SIZE&&(this.y(),d-=v.BLOCK_SIZE,this.t+=v.BLOCK_SIZE,p[0]=p[v.BLOCK_SIZE+0],p[1]=p[v.BLOCK_SIZE+1],p[2]=p[v.BLOCK_SIZE+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,v.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=m.g,d=this.q;for(let D=0;D<64;D+=4)p.setUint32(D,d.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)p.setUint32(D,f(p.getUint32(D-12,!1)^p.getUint32(D-32,!1)^p.getUint32(D-56,!1)^p.getUint32(D-64,!1),1),!1);let b=this.h,t=this.l,l=this.m,i=this.n,g=this.o,s,c,u;for(let D=0;D<80;D++)D<20?(s=t&l|~t&i,c=1518500249):D<40?(s=t^l^i,c=1859775393):D<60?(s=t&l|t&i|l&i,c=2400959708):(s=t^l^i,c=3395469782),u=f(b,5)+s+g+c+p.getUint32(D*4,!1)&4294967295,g=i,i=l,l=f(t,30),t=b,b=u;this.h=this.h+b&4294967295,this.l=this.l+t&4294967295,this.m=this.m+l&4294967295,this.n=this.n+i&4294967295,this.o=this.o+g&4294967295}}e.$Aj=m,m.g=new DataView(new ArrayBuffer(320))}),define(Se[174],ke([1,0,173,17,82]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=y,e.$Yk=S,e.$Zk=f,e.$1k=w,e.$2k=h,e.$3k=m;const I="$(",R=new RegExp(`\\$\\(${E.ThemeIcon.iconNameExpression}(?:${E.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${R.source}`,"g");function y($){return $.replace(A,(p,d)=>d?p:`\\${p}`)}const o=new RegExp(`\\\\${R.source}`,"g");function S($){return $.replace(o,p=>`\\${p}`)}const v=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function f($){return $.indexOf(I)===-1?$:$.replace(v,(p,d,b,t)=>b?p:d||t||"")}function w($){return $?$.replace(/\$\((.*?)\)/g,(p,d)=>` ${d} `).trim():""}const a=new RegExp(`\\$\\(${E.ThemeIcon.iconNameCharacter}+\\)`,"g");function h($){a.lastIndex=0;let p="";const d=[];let b=0;for(;;){const t=a.lastIndex,l=a.exec($),i=$.substring(t,l?.index);if(i.length>0){p+=i;for(let g=0;g<i.length;g++)d.push(b)}if(!l)break;b+=l[0].length}return{text:p,iconOffsets:d}}function m($,p,d=!1){const{text:b,iconOffsets:t}=p;if(!t||t.length===0)return(0,n.$Ok)($,b,d);const l=(0,r.$of)(b," "),i=b.length-l.length,g=(0,n.$Ok)($,l,d);if(g)for(const s of g){const c=t[s.start+i]+i;s.start+=c,s.end+=c}return g}}),define(Se[58],ke([1,0,17]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=Be(n);var r;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(r||(r={})),function(E){const I="error",R="warning",A="warn",y="info",o="ignore";function S(f){return f?n.$Hf(I,f)?E.Error:n.$Hf(R,f)||n.$Hf(A,f)?E.Warning:n.$Hf(y,f)?E.Info:E.Ignore:E.Ignore}E.fromValue=S;function v(f){switch(f){case E.Error:return I;case E.Warning:return R;case E.Info:return y;default:return o}}E.toString=v}(r||(r={})),e.default=r}),define(Se[69],ke([1,0,18,35,17]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class I{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const h=a.charCodeAt(0),m=this.b.charCodeAt(this.c);return h-m}value(){return this.b[this.c]}}e.$Ii=I;class R{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,E.$Bf)(a,this.b,0,a.length,this.c,this.d):(0,E.$Df)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=R;class A{constructor(a=!0,h=!0){this.f=a,this.g=h}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let h=a.length-1;h>=0;h--,this.c--){const m=this.b.charCodeAt(h);if(!(m===r.CharCode.Slash||this.f&&m===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===r.CharCode.Slash||this.f&&h===r.CharCode.Backslash)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,E.$Bf)(a,this.b,0,a.length,this.d,this.e):(0,E.$Df)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=A;var y;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(y||(y={}));class o{constructor(a,h){this.f=a,this.g=h,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(y.Scheme),this.c.authority&&this.d.push(y.Authority),this.c.path&&(this.b=new A(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(y.Path)),this.g(a)||(this.c.query&&this.d.push(y.Query),this.c.fragment&&this.d.push(y.Fragment)),this.e=0,this}next(){return this.d[this.e]===y.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===y.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===y.Scheme)return(0,E.$Cf)(a,this.c.scheme);if(this.d[this.e]===y.Authority)return(0,E.$Cf)(a,this.c.authority);if(this.d[this.e]===y.Path)return this.b.cmp(a);if(this.d[this.e]===y.Query)return(0,E.$Af)(a,this.c.query);if(this.d[this.e]===y.Fragment)return(0,E.$Af)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===y.Scheme)return this.c.scheme;if(this.d[this.e]===y.Authority)return this.c.authority;if(this.d[this.e]===y.Path)return this.b.value();if(this.d[this.e]===y.Query)return this.c.query;if(this.d[this.e]===y.Fragment)return this.c.fragment;throw new Error}}e.$Li=o;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(v||(v={}));class f{static forUris(a=()=>!1,h=()=>!1){return new f(new o(a,h))}static forPaths(a=!1){return new f(new A(void 0,!a))}static forStrings(){return new f(new I)}static forConfigKeys(){return new f(new R)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,h){if(h){const m=h.slice(0);(0,n.$Zb)(m);for(const $ of m)this.set($,a)}else{const m=a.slice(0);(0,n.$Zb)(m);for(const $ of m)this.set($[0],$[1])}}set(a,h){const m=this.b.reset(a);let $;this.c||(this.c=new S,this.c.segment=m.value());const p=[];for($=this.c;;){const b=m.cmp($.segment);if(b>0)$.left||($.left=new S,$.left.segment=m.value()),p.push([v.Left,$]),$=$.left;else if(b<0)$.right||($.right=new S,$.right.segment=m.value()),p.push([v.Right,$]),$=$.right;else if(m.hasNext())m.next(),$.mid||($.mid=new S,$.mid.segment=m.value()),p.push([v.Mid,$]),$=$.mid;else break}const d=$.value;$.value=h,$.key=a;for(let b=p.length-1;b>=0;b--){const t=p[b][1];t.updateHeight();const l=t.balanceFactor();if(l<-1||l>1){const i=p[b][0],g=p[b+1][0];if(i===v.Right&&g===v.Right)p[b][1]=t.rotateLeft();else if(i===v.Left&&g===v.Left)p[b][1]=t.rotateRight();else if(i===v.Right&&g===v.Left)t.right=p[b+1][1]=p[b+1][1].rotateRight(),p[b][1]=t.rotateLeft();else if(i===v.Left&&g===v.Right)t.left=p[b+1][1]=p[b+1][1].rotateLeft(),p[b][1]=t.rotateRight();else throw new Error;if(b>0)switch(p[b-1][0]){case v.Left:p[b-1][1].left=p[b][1];break;case v.Right:p[b-1][1].right=p[b][1];break;case v.Mid:p[b-1][1].mid=p[b][1];break}else this.c=p[0][1]}}return d}get(a){return this.d(a)?.value}d(a){const h=this.b.reset(a);let m=this.c;for(;m;){const $=h.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(h.hasNext())h.next(),m=m.mid;else break}return m}has(a){const h=this.d(a);return!(h?.value===void 0&&h?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,h){const m=this.b.reset(a),$=[];let p=this.c;for(;p;){const d=m.cmp(p.segment);if(d>0)$.push([v.Left,p]),p=p.left;else if(d<0)$.push([v.Right,p]),p=p.right;else if(m.hasNext())m.next(),$.push([v.Mid,p]),p=p.mid;else break}if(p){if(h?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const d=this.f(p.right);if(d.key){const{key:b,value:t,segment:l}=d;this.e(d.key,!1),p.key=b,p.value=t,p.segment=l}}else{const d=p.left??p.right;if($.length>0){const[b,t]=$[$.length-1];switch(b){case v.Left:t.left=d;break;case v.Mid:t.mid=d;break;case v.Right:t.right=d;break}}else this.c=d}for(let d=$.length-1;d>=0;d--){const b=$[d][1];b.updateHeight();const t=b.balanceFactor();if(t>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),$[d][1]=b.rotateLeft()):t<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),$[d][1]=b.rotateRight()),d>0)switch($[d-1][0]){case v.Left:$[d-1][1].left=$[d][1];break;case v.Right:$[d-1][1].right=$[d][1];break;case v.Mid:$[d-1][1].mid=$[d][1];break}else this.c=$[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const h=this.b.reset(a);let m=this.c,$;for(;m;){const p=h.cmp(m.segment);if(p>0)m=m.left;else if(p<0)m=m.right;else if(h.hasNext())h.next(),$=m.value||$,m=m.mid;else break}return m&&m.value||$}findSuperstr(a){return this.g(a,!1)}g(a,h){const m=this.b.reset(a);let $=this.c;for(;$;){const p=m.cmp($.segment);if(p>0)$=$.left;else if(p<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else return $.mid?this.h($.mid):h?$.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[h,m]of this)a(m,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const h=[];return this.j(a,h),h[Symbol.iterator]()}j(a,h){a&&(a.left&&this.j(a.left,h),a.value&&h.push([a.key,a.value]),a.mid&&this.j(a.mid,h),a.right&&this.j(a.right,h))}_isBalanced(){const a=h=>{if(!h)return!0;const m=h.balanceFactor();return m<-1||m>1?!1:a(h.left)&&a(h.right)};return a(this.c)}}e.$Mi=f}),define(Se[4],ke([1,0,35,81,9,3]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=m,e.$zc=l,E=Be(E);const R=/^\w[\w\d+.-]*$/,A=/^\//,y=/^\/\//;function o(u,D){if(!u.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!R.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!A.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(u,D){return!u&&!D?"file":u}function v(u,D){switch(u){case"https":case"http":case"file":D?D[0]!==w&&(D=w+D):D=w;break}return D}const f="",w="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(D){return D instanceof h?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,P,T,z,C,k=!1){typeof D=="object"?(this.scheme=D.scheme||f,this.authority=D.authority||f,this.path=D.path||f,this.query=D.query||f,this.fragment=D.fragment||f):(this.scheme=S(D,k),this.authority=P||f,this.path=v(this.scheme,T||f),this.query=z||f,this.fragment=C||f,o(this,k))}get fsPath(){return l(this,!1)}with(D){if(!D)return this;let{scheme:P,authority:T,path:z,query:C,fragment:k}=D;return P===void 0?P=this.scheme:P===null&&(P=f),T===void 0?T=this.authority:T===null&&(T=f),z===void 0?z=this.path:z===null&&(z=f),C===void 0?C=this.query:C===null&&(C=f),k===void 0?k=this.fragment:k===null&&(k=f),P===this.scheme&&T===this.authority&&z===this.path&&C===this.query&&k===this.fragment?this:new p(P,T,z,C,k)}static parse(D,P=!1){const T=a.exec(D);return T?new p(T[2]||f,c(T[4]||f),c(T[5]||f),c(T[7]||f),c(T[9]||f),P):new p(f,f,f,f,f)}static file(D){let P=f;if(I.$c&&(D=D.replace(/\\/g,w)),D[0]===w&&D[1]===w){const T=D.indexOf(w,2);T===-1?(P=D.substring(2),D=w):(P=D.substring(2,T),D=D.substring(T)||w)}return new p("file",P,D,f,f)}static from(D,P){return new p(D.scheme,D.authority,D.path,D.query,D.fragment,P)}static joinPath(D,...P){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let T;return I.$c&&D.scheme==="file"?T=h.file(E.$ic.join(l(D,!0),...P)).path:T=E.$jc.join(D.path,...P),D.with({path:T})}toString(D=!1){return i(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof h)return D;{const P=new p(D);return P._formatted=D.external??null,P._fsPath=D._sep===$?D.fsPath??null:null,P}}else return D}}e.URI=h;function m(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const $=I.$c?1:void 0;class p extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(D=!1){return D?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const D={$mid:r.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=$),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const d={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function b(u,D,P){let T,z=-1;for(let C=0;C<u.length;C++){const k=u.charCodeAt(C);if(k>=n.CharCode.a&&k<=n.CharCode.z||k>=n.CharCode.A&&k<=n.CharCode.Z||k>=n.CharCode.Digit0&&k<=n.CharCode.Digit9||k===n.CharCode.Dash||k===n.CharCode.Period||k===n.CharCode.Underline||k===n.CharCode.Tilde||D&&k===n.CharCode.Slash||P&&k===n.CharCode.OpenSquareBracket||P&&k===n.CharCode.CloseSquareBracket||P&&k===n.CharCode.Colon)z!==-1&&(T+=encodeURIComponent(u.substring(z,C)),z=-1),T!==void 0&&(T+=u.charAt(C));else{T===void 0&&(T=u.substr(0,C));const q=d[k];q!==void 0?(z!==-1&&(T+=encodeURIComponent(u.substring(z,C)),z=-1),T+=q):z===-1&&(z=C)}}return z!==-1&&(T+=encodeURIComponent(u.substring(z))),T!==void 0?T:u}function t(u){let D;for(let P=0;P<u.length;P++){const T=u.charCodeAt(P);T===n.CharCode.Hash||T===n.CharCode.QuestionMark?(D===void 0&&(D=u.substr(0,P)),D+=d[T]):D!==void 0&&(D+=u[P])}return D!==void 0?D:u}function l(u,D){let P;return u.authority&&u.path.length>1&&u.scheme==="file"?P=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===n.CharCode.Slash&&(u.path.charCodeAt(1)>=n.CharCode.A&&u.path.charCodeAt(1)<=n.CharCode.Z||u.path.charCodeAt(1)>=n.CharCode.a&&u.path.charCodeAt(1)<=n.CharCode.z)&&u.path.charCodeAt(2)===n.CharCode.Colon?D?P=u.path.substr(1):P=u.path[1].toLowerCase()+u.path.substr(2):P=u.path,I.$c&&(P=P.replace(/\//g,"\\")),P}function i(u,D){const P=D?t:b;let T="",{scheme:z,authority:C,path:k,query:q,fragment:Y}=u;if(z&&(T+=z,T+=":"),(C||z==="file")&&(T+=w,T+=w),C){let J=C.indexOf("@");if(J!==-1){const ne=C.substr(0,J);C=C.substr(J+1),J=ne.lastIndexOf(":"),J===-1?T+=P(ne,!1,!1):(T+=P(ne.substr(0,J),!1,!1),T+=":",T+=P(ne.substr(J+1),!1,!0)),T+="@"}C=C.toLowerCase(),J=C.lastIndexOf(":"),J===-1?T+=P(C,!1,!0):(T+=P(C.substr(0,J),!1,!0),T+=C.substr(J))}if(k){if(k.length>=3&&k.charCodeAt(0)===n.CharCode.Slash&&k.charCodeAt(2)===n.CharCode.Colon){const J=k.charCodeAt(1);J>=n.CharCode.A&&J<=n.CharCode.Z&&(k=`/${String.fromCharCode(J+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===n.CharCode.Colon){const J=k.charCodeAt(0);J>=n.CharCode.A&&J<=n.CharCode.Z&&(k=`${String.fromCharCode(J+32)}:${k.substr(2)}`)}T+=P(k,!0,!1)}return q&&(T+="?",T+=P(q,!1,!1)),Y&&(T+="#",T+=D?Y:b(Y,!1,!1)),T}function g(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+g(u.substr(3)):u}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(u){return u.match(s)?u.replace(s,D=>g(D)):u}}),define(Se[175],ke([1,0,4]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=r,e.$dr=E,e.$er=I,e.log=A;function r(o){const S=o;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function E(o){const S=[];let v;try{const f=JSON.parse(o.arguments),w=f[f.length-1];w&&w.__$stack&&(f.pop(),v=w.__$stack),S.push(...f)}catch{S.push("Unable to log remote console arguments",o.arguments)}return{args:S,stack:v}}function I(o){if(typeof o!="string")return I(E(o).stack);const S=o;if(S){const v=R(S),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(f&&f.length===4)return{uri:n.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function R(o){if(!o)return o;const S=o.indexOf(`
`);return S===-1?o:o.substring(0,S)}function A(o,S){const{args:v,stack:f}=E(o),w=typeof v[0]=="string"&&v.length===1;let a=R(f);a&&(a=`(${a.trim()})`);let h=[];if(typeof v[0]=="string"?a&&w?h=[`%c[${S}] %c${v[0]} %c${a}`,y("blue"),y(""),y("grey")]:h=[`%c[${S}] %c${v[0]}`,y("blue"),y(""),...v.slice(1)]:h=[`%c[${S}]%`,y("blue"),...v],a&&!w&&h.push(a),typeof console[o.severity]!="function")throw new Error("Unknown console method");console[o.severity].apply(console,h)}function y(o){return`color: ${o}`}}),define(Se[49],ke([1,0,15,4,81]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=I,e.$ci=R,e.$di=y;function I(o){return JSON.stringify(o,A)}function R(o){let S=JSON.parse(o);return S=y(S),S}function A(o,S){return S instanceof RegExp?{$mid:E.MarshalledId.Regexp,source:S.source,flags:S.flags}:S}function y(o,S=0){if(!o||S>200)return o;if(typeof o=="object"){switch(o.$mid){case E.MarshalledId.Uri:return r.URI.revive(o);case E.MarshalledId.Regexp:return new RegExp(o.source,o.flags);case E.MarshalledId.Date:return new Date(o.source)}if(o instanceof n.$Pe||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let v=0;v<o.length;++v)o[v]=y(o[v],S+1);else for(const v in o)Object.hasOwnProperty.call(o,v)&&(o[v]=y(o[v],S+1))}return o}}),define(Se[13],ke([1,0,10,3,17,4,9]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=y,e.$Qg=o,e.$Ug=v,n=Be(n),r=Be(r),R=Be(R);var A;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(A||(e.Schemas=A={}));function y(a,h){return I.URI.isUri(a)?(0,E.$Hf)(a.scheme,h):(0,E.$If)(a,h+":")}function o(a,...h){return h.some(m=>y(a,m))}e.$Rg="vscode-tkn",e.$Sg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,m){this.f=v(h,m)}getServerRootPath(){return this.f}get g(){return R.$jc.join(this.f,A.vscodeRemoteResource)}set(h,m,$){this.a[h]=m,this.b[h]=$}setConnectionToken(h,m){this.c[h]=m}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(t){return n.$3(t),h}const m=h.authority;let $=this.a[m];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const p=this.b[m],d=this.c[m];let b=`path=${encodeURIComponent(h.path)}`;return typeof d=="string"&&(b+=`&${e.$Sg}=${encodeURIComponent(d)}`),I.URI.from({scheme:r.$i?this.d:A.vscodeRemoteResource,authority:`${$}:${p}`,path:r.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:b})}}e.$Tg=new S;function v(a,h){return R.$jc.join(h??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class f{asBrowserUri(h){const m=this.b(h,se);return this.uriToBrowserUri(m)}uriToBrowserUri(h){return h.scheme===A.vscodeRemote?e.$Tg.rewrite(h):h.scheme===A.file&&(r.$g||r.$k===`${A.vscodeFileResource}://${f.a}`)?h.with({scheme:A.vscodeFileResource,authority:h.authority||f.a,query:null,fragment:null}):h}asFileUri(h){const m=this.b(h,se);return this.uriToFileUri(m)}uriToFileUri(h){return h.scheme===A.vscodeFileResource?h.with({scheme:A.file,authority:h.authority!==f.a?h.authority:null,query:null,fragment:null}):h}b(h,m){return I.URI.isUri(h)?h:I.URI.parse(m.toUrl(h))}}f.a=e.$Zg,e.$1g=new f;var w;(function(a){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(h.get("3"));const m="vscode-coi";function $(d){let b;typeof d=="string"?b=new URL(d).searchParams:d instanceof URL?b=d.searchParams:I.URI.isUri(d)&&(b=new URL(d.toString(!0)).searchParams);const t=b?.get(m);if(t)return h.get(t)}a.getHeadersFromQuery=$;function p(d,b,t){if(!globalThis.crossOriginIsolated)return;const l=b&&t?"3":t?"2":"1";d instanceof URLSearchParams?d.set(m,l):d[m]=l}a.addSearchParam=p})(w||(e.COI=w={}))}),define(Se[176],ke([1,0,105,13,3,4]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tE=S,E=Be(E);class R{constructor(f,w,a){this.id=f,this.dependencies=w,this.callback=a}}class A{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,w,a)=>{typeof f!="string"&&(a=w,w=f,f=null),(typeof w!="object"||!Array.isArray(w))&&(a=w,w=null),this.c.push(new R(f,w,a))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const w=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!w)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(f){return new Promise((w,a)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const m=()=>{h.removeEventListener("load",$),h.removeEventListener("error",p)},$=d=>{m(),w(this.c.pop())},p=d=>{m(),a(d)};h.addEventListener("load",$),h.addEventListener("error",p),this.f&&(f=this.f.createScriptURL(f)),h.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(f){return new Promise((w,a)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),w(this.c.pop())}catch(h){a(h)}})}async j(f){try{const w=globalThis._VSCODE_NODE_MODULES.fs,a=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,m=I.URI.parse(f).fsPath,$=w.readFileSync(m).toString(),p=h.wrap($.replace(/^#!.*/,""));return new a.Script(p).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}A.INSTANCE=new A;const y=new Map;let o={};typeof globalThis.require=="object"&&(o=globalThis.require.paths??{});async function S(v,f,w){if(n.$V){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),o[v]&&(v=o[v]);const a=`${v}/${f}`;if(y.has(a))return y.get(a);let h;if(/^\w[\w\d+.-]*:\/\//.test(a))h=a;else{const d=`${w&&!E.$i?r.$Xg:r.$Wg}/${a}`;h=r.$1g.asBrowserUri(d).toString(!0)}const m=A.INSTANCE.load(h);return y.set(a,m),m}else return await new Promise((a,h)=>{se([v],a,h)}).then(Be)}}),define(Se[20],ke([1,0,35,37,13,9,3,17,4]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=o,e.$qh=v,e.$rh=w,r=Be(r),I=Be(I);function o(a){return(0,y.$zc)(a,!0)}class S{constructor(h){this.a=h}compare(h,m,$=!1){return h===m?0:(0,A.$Af)(this.getComparisonKey(h,$),this.getComparisonKey(m,$))}isEqual(h,m,$=!1){return h===m?!0:!h||!m?!1:this.getComparisonKey(h,$)===this.getComparisonKey(m,$)}getComparisonKey(h,m=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,m,$=!1){if(h.scheme===m.scheme){if(h.scheme===E.Schemas.file)return r.$Fg(o(h),o(m),this.a(h))&&h.query===m.query&&($||h.fragment===m.fragment);if((0,e.$mh)(h.authority,m.authority))return r.$Fg(h.path,m.path,this.a(h),"/")&&h.query===m.query&&($||h.fragment===m.fragment)}return!1}joinPath(h,...m){return y.URI.joinPath(h,...m)}basenameOrAuthority(h){return(0,e.$eh)(h)||h.authority}basename(h){return I.$jc.basename(h.path)}extname(h){return I.$jc.extname(h.path)}dirname(h){if(h.path.length===0)return h;let m;return h.scheme===E.Schemas.file?m=y.URI.file(I.$pc(o(h))).path:(m=I.$jc.dirname(h.path),h.authority&&m.length&&m.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${h.toString})) resulted in a relative path`),m="/")),h.with({path:m})}normalizePath(h){if(!h.path.length)return h;let m;return h.scheme===E.Schemas.file?m=y.URI.file(I.$kc(o(h))).path:m=I.$jc.normalize(h.path),h.with({path:m})}relativePath(h,m){if(h.scheme!==m.scheme||!(0,e.$mh)(h.authority,m.authority))return;if(h.scheme===E.Schemas.file){const d=I.$oc(o(h),o(m));return R.$c?r.$zg(d):d}let $=h.path||"/";const p=m.path||"/";if(this.a(h)){let d=0;for(const b=Math.min($.length,p.length);d<b&&!($.charCodeAt(d)!==p.charCodeAt(d)&&$.charAt(d).toLowerCase()!==p.charAt(d).toLowerCase());d++);$=p.substr(0,d)+$.substr(d)}return I.$jc.relative($,p)}resolvePath(h,m){if(h.scheme===E.Schemas.file){const $=y.URI.file(I.$nc(o(h),m));return h.with({authority:$.authority,path:$.path})}return m=r.$Ag(m),h.with({path:I.$jc.resolve(h.path,m)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,m){return h===m||h!==void 0&&m!==void 0&&(0,A.$Hf)(h,m)}hasTrailingPathSeparator(h,m=I.sep){if(h.scheme===E.Schemas.file){const $=o(h);return $.length>r.$Bg($).length&&$[$.length-1]===m}else{const $=h.path;return $.length>1&&$.charCodeAt($.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,m=I.sep){return(0,e.$nh)(h,m)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,m=I.sep){let $=!1;if(h.scheme===E.Schemas.file){const p=o(h);$=p!==void 0&&p.length===r.$Bg(p).length&&p[p.length-1]===m}else{m="/";const p=h.path;$=p.length===1&&p.charCodeAt(p.length-1)===n.CharCode.Slash}return!$&&!(0,e.$nh)(h,m)?h.with({path:h.path+"/"}):h}}e.$9g=S,e.$0g=new S(()=>!1),e.$$g=new S(a=>a.scheme===E.Schemas.file?!R.$e:!0),e.$_g=new S(a=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function v(a,h){const m=[];for(let $=0;$<a.length;$++){const p=h(a[$]);a.some((d,b)=>b===$?!1:(0,e.$bh)(p,h(d)))||m.push(a[$])}return m}var f;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function h(m){const $=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(b=>{const[t,l]=b.split(":");t&&l&&$.set(t,l)});const d=m.path.substring(0,m.path.indexOf(";"));return d&&$.set(a.META_DATA_MIME,d),$}a.parseMetaData=h})(f||(e.DataUri=f={}));function w(a,h,m){if(h){let $=a.path;return $&&$[0]!==I.$jc.sep&&($=I.$jc.sep+$),a.with({scheme:m,authority:h,path:$})}return a.with({scheme:m})}}),define(Se[14],ke([1,0,19,10,6,2,20,3,171,65]),function(se,e,n,r,E,I,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=S,e.$th=v,e.$uh=f,e.$vh=w,e.$wh=a,e.$xh=h,e.$yh=m,e.$zh=$,e.$Hh=u,e.$Ih=D,e.$Jh=P,e.$Kh=T,e.$Lh=z,e.$1h=B,e.$9h=j;function S(Q){return!!Q&&typeof Q.then=="function"}function v(Q){const N=new n.$ye,H=Q(N.token),oe=new Promise((fe,Ee)=>{const Ne=N.token.onCancellationRequested(()=>{Ne.dispose(),Ee(new r.$8)});Promise.resolve(H).then(de=>{Ne.dispose(),N.dispose(),fe(de)},de=>{Ne.dispose(),N.dispose(),Ee(de)})});return new class{cancel(){N.cancel(),N.dispose()}then(fe,Ee){return oe.then(fe,Ee)}catch(fe){return this.then(void 0,fe)}finally(fe){return oe.finally(fe)}}}function f(Q,N,H){return new Promise((oe,fe)=>{const Ee=N.onCancellationRequested(()=>{Ee.dispose(),oe(H)});Q.then(oe,fe).finally(()=>Ee.dispose())})}function w(Q,N){return new Promise((H,oe)=>{const fe=N.onCancellationRequested(()=>{fe.dispose(),oe(new r.$8)});Q.then(H,oe).finally(()=>fe.dispose())})}async function a(Q){let N=-1;const H=Q.map((oe,fe)=>oe.then(Ee=>(N=fe,Ee)));try{return await Promise.race(H)}finally{Q.forEach((oe,fe)=>{fe!==N&&oe.cancel()})}}function h(Q,N,H){let oe;const fe=setTimeout(()=>{oe?.(void 0),H?.()},N);return Promise.race([Q.finally(()=>clearTimeout(fe)),new Promise(Ee=>oe=Ee)])}function m(Q){return new Promise((N,H)=>{const oe=Q();S(oe)?oe.then(N,H):N(oe)})}function $(){let Q,N;return{promise:new Promise((oe,fe)=>{Q=oe,N=fe}),resolve:Q,reject:N}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(N){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=N,!this.b){const H=()=>{if(this.b=null,this.f)return;const oe=this.queue(this.d);return this.d=null,oe};this.b=new Promise(oe=>{this.a.then(H,H).then(oe)})}return new Promise((H,oe)=>{this.b.then(H,oe)})}return this.a=N(),new Promise((H,oe)=>{this.a.then(fe=>{this.a=null,H(fe)},fe=>{this.a=null,oe(fe)})})}dispose(){this.f=!0}}e.$Ah=p;class d{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.$Bh=d;class b{constructor(){this.a=new Map}queue(N,H){const fe=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(N)===fe&&this.a.delete(N)});return this.a.set(N,fe),fe}}e.$Ch=b;const t=(Q,N)=>{let H=!0;const oe=setTimeout(()=>{H=!1,N()},Q);return{isTriggered:()=>H,dispose:()=>{clearTimeout(oe),H=!1}}},l=Q=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,Q())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class i{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,H=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((fe,Ee)=>{this.d=fe,this.f=Ee}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const oe=()=>{this.a=null,this.d?.(null)};return this.a=H===y.$ie?l(oe):t(H,oe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=i;class g{constructor(N){this.a=new i(N),this.b=new p}trigger(N,H){return this.a.trigger(()=>this.b.queue(N),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=g;class s{constructor(){this.a=!1,this.b=new Promise((N,H)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=s;class c extends s{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.$Gh=c;function u(Q,N){return N?new Promise((H,oe)=>{const fe=setTimeout(()=>{Ee.dispose(),H()},Q),Ee=N.onCancellationRequested(()=>{clearTimeout(fe),Ee.dispose(),oe(new r.$8)})}):v(H=>u(Q,H))}function D(Q,N=0,H){const oe=setTimeout(()=>{Q(),H&&fe.dispose()},N),fe=(0,I.$Vc)(()=>{clearTimeout(oe),H?.deleteAndLeak(fe)});return H?.add(fe),fe}function P(Q){const N=[];let H=0;const oe=Q.length;function fe(){return H<oe?Q[H++]():null}function Ee(Ne){Ne!=null&&N.push(Ne);const de=fe();return de?de.then(Ee):Promise.resolve(N)}return Promise.resolve(null).then(Ee)}function T(Q,N=oe=>!!oe,H=null){let oe=0;const fe=Q.length,Ee=()=>{if(oe>=fe)return Promise.resolve(H);const Ne=Q[oe++];return Promise.resolve(Ne()).then($e=>N($e)?Promise.resolve($e):Ee())};return Ee()}function z(Q,N=oe=>!!oe,H=null){if(Q.length===0)return Promise.resolve(H);let oe=Q.length;const fe=()=>{oe=-1;for(const Ee of Q)Ee.cancel?.()};return new Promise((Ee,Ne)=>{for(const de of Q)de.then($e=>{--oe>=0&&N($e)?(fe(),Ee($e)):oe===0&&Ee(H)}).catch($e=>{--oe>=0&&(fe(),Ne($e))})})}class C{constructor(N){this.a=0,this.b=!1,this.f=N,this.g=[],this.d=0,this.h=new E.$ne}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(N){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((H,oe)=>{this.g.push({factory:N,c:H,e:oe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const N=this.g.shift();this.d++;const H=N.factory();H.then(N.c,N.e),H.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=C;class k extends C{constructor(){super(1)}}e.$Nh=k;class q{constructor(){this.a=new re,this.b=0}queue(N){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,N())):this.a.run(this.b++,N())}}e.$Oh=q;class Y{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const N=new W;return this.b.add(N),N.p}g(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueSize(N,H=R.$0g){const oe=H.getComparisonKey(N);return this.a.get(oe)?.size??0}queueFor(N,H,oe=R.$0g){const fe=oe.getComparisonKey(N);let Ee=this.a.get(fe);if(!Ee){Ee=new k;const Ne=this.f++,de=E.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(Ne),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$7c),this.d.set(Ne,de),this.a.set(fe,Ee)}return Ee.queue(H)}h(){this.g()&&this.j()}j(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=Y;class J{constructor(N,H){this.b=!1,this.a=-1,typeof N=="function"&&typeof H=="number"&&this.setIfNotSet(N,H)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,H){if(this.b)throw new r.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},H)}setIfNotSet(N,H){if(this.b)throw new r.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},H))}}e.$Qh=J;class ne{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(N,H,oe=globalThis){if(this.f)throw new r.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const fe=oe.setInterval(()=>{N()},H);this.d=(0,I.$Vc)(()=>{oe.clearInterval(fe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=ne;class Z{constructor(N,H){this.b=-1,this.a=N,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=Z;class x{constructor(N,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=N,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=x;class le extends Z{constructor(N,H){super(N,H),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.$Uh=le;class K extends I.$Xc{constructor(N,H){super(),this.g=N,this.h=H,this.a=[],this.b=this.B(new I.$Yc),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of N)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(Q,N)=>{(0,A.$v)(()=>{if(H)return;const oe=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$Xh=(Q,N,H)=>{const oe=Q.requestIdleCallback(N,typeof H=="number"?{timeout:H}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,Q.cancelIdleCallback(oe))}}},e.$Wh=Q=>(0,e.$Xh)(globalThis,Q)}();class ae{constructor(N,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(oe){this.l=oe}finally{this.g=!0}},this.f=(0,e.$Xh)(N,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ae;class M extends ae{constructor(N){super(globalThis,N)}}e.$Zh=M;async function B(Q,N,H){let oe;for(let fe=0;fe<H;fe++)try{return await Q()}catch(Ee){oe=Ee,await u(N)}throw oe}class re{isRunning(N){return typeof N=="number"?this.a?.taskId===N:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(N,H,oe){return this.a={taskId:N,cancel:()=>oe?.(),promise:H},H.then(()=>this.d(N),()=>this.d(N)),H}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}queue(N){if(this.b)this.b.run=N;else{const{promise:H,resolve:oe,reject:fe}=$();this.b={run:N,promise:H,promiseResolve:oe,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=re;class ce{constructor(N,H=()=>Date.now()){this.d=N,this.f=H,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.$3h=ce;var pe;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(pe||(pe={}));class W{get isRejected(){return this.d?.outcome===pe.Rejected}get isResolved(){return this.d?.outcome===pe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===pe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((N,H)=>{this.a=N,this.b=H})}complete(N){return new Promise(H=>{this.a(N),this.d={outcome:pe.Resolved,value:N},H()})}error(N){return new Promise(H=>{this.b(N),this.d={outcome:pe.Rejected,value:N},H()})}cancel(){return this.error(new r.$8)}}e.$4h=W;var ue;(function(Q){async function N(oe){let fe;const Ee=await Promise.all(oe.map(Ne=>Ne.then(de=>de,de=>{fe||(fe=de)})));if(typeof fe<"u")throw fe;return Ee}Q.settled=N;function H(oe){return new Promise(async(fe,Ee)=>{try{await oe(fe,Ee)}catch(Ne){Ee(Ne)}})}Q.withAsyncBody=H})(ue||(e.Promises=ue={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(N){this.a=void 0,this.b=void 0,this.d=!1,this.promise=N.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new r.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=_;class U{constructor(N){this.b=N,this.a=new o.$X(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=U;var O;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(O||(O={}));class te{static fromArray(N){return new te(H=>{H.emitMany(N)})}static fromPromise(N){return new te(async H=>{H.emitMany(await N)})}static fromPromises(N){return new te(async H=>{await Promise.all(N.map(async oe=>H.emitOne(await oe)))})}static merge(N){return new te(async H=>{await Promise.all(N.map(async oe=>{for await(const fe of oe)H.emitOne(fe)}))})}constructor(N,H){this.a=O.Initial,this.b=[],this.d=null,this.f=H,this.g=new E.$ne,queueMicrotask(async()=>{const oe={emitOne:fe=>this.h(fe),emitMany:fe=>this.j(fe),reject:fe=>this.l(fe)};try{await Promise.resolve(N(oe)),this.k()}catch(fe){this.l(fe)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===O.DoneError)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===O.DoneOK)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(N,H){return new te(async oe=>{for await(const fe of N)oe.emitOne(H(fe))})}map(N){return te.map(this,N)}static filter(N,H){return new te(async oe=>{for await(const fe of N)H(fe)&&oe.emitOne(fe)})}filter(N){return te.filter(this,N)}static coalesce(N){return te.filter(N,H=>!!H)}coalesce(){return te.coalesce(this)}static async toPromise(N){const H=[];for await(const oe of N)H.push(oe);return H}toPromise(){return te.toPromise(this)}h(N){this.a===O.Initial&&(this.b.push(N),this.g.fire())}j(N){this.a===O.Initial&&(this.b=this.b.concat(N),this.g.fire())}k(){this.a===O.Initial&&(this.a=O.DoneOK,this.g.fire())}l(N){this.a===O.Initial&&(this.a=O.DoneError,this.d=N,this.g.fire())}}e.$7h=te,te.EMPTY=te.fromArray([]);class V extends te{constructor(N,H){super(H),this.m=N}cancel(){this.m.cancel()}}e.$8h=V;function j(Q){const N=new n.$ye,H=Q(N.token);return new V(N,async oe=>{const fe=N.token.onCancellationRequested(()=>{fe.dispose(),N.dispose(),oe.reject(new r.$8)});try{for await(const Ee of H){if(N.token.isCancellationRequested)return;oe.emitOne(Ee)}fe.dispose(),N.dispose()}catch(Ee){fe.dispose(),N.dispose(),oe.reject(Ee)}})}class G{constructor(N){this.a=new W,this.b=new te(fe=>{if(H){fe.reject(H);return}return oe&&fe.emitMany(oe),this.d=Ee=>fe.reject(Ee),this.f=Ee=>fe.emitOne(Ee),this.a.p},N);let H,oe;this.f=fe=>{oe||(oe=[]),oe.push(fe)},this.d=fe=>{H||(H=fe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(N){this.d(N),this.a.complete()}emitOne(N){this.f(N)}}e.$0h=G}),define(Se[83],ke([1,0,18,14,35,37,26,9,3,17]),function(se,e,n,r,E,I,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=S,e.$yk=h,e.$zk=q,e.$Ak=Y,e.$Bk=J,e.$Ck=ne,e.$Dk=Z,e.$Ek=ae;function S(){return Object.create(null)}e.$wk="**",e.$xk="/";const v="[/\\\\]",f="[^/\\\\]",w=/\//g;function a(M,B){switch(M){case 0:return"";case 1:return`${f}*?`;default:return`(?:${v}|${f}+${v}${B?`|${v}${f}+`:""})*?`}}function h(M,B){if(!M)return[];const re=[];let ce=!1,pe=!1,W="";for(const ue of M){switch(ue){case B:if(!ce&&!pe){re.push(W),W="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}W+=ue}return W&&re.push(W),re}function m(M){if(!M)return"";let B="";const re=h(M,e.$xk);if(re.every(ce=>ce===e.$wk))B=".*";else{let ce=!1;re.forEach((pe,W)=>{if(pe===e.$wk){if(ce)return;B+=a(2,W===re.length-1)}else{let ue=!1,_="",U=!1,O="";for(const te of pe){if(te!=="}"&&ue){_+=te;continue}if(U&&(te!=="]"||!O)){let V;te==="-"?V=te:(te==="^"||te==="!")&&!O?V="^":te===e.$xk?V="":V=(0,o.$jf)(te),O+=V;continue}switch(te){case"{":ue=!0;continue;case"[":U=!0;continue;case"}":{const j=`(?:${h(_,",").map(G=>m(G)).join("|")})`;B+=j,ue=!1,_="";break}case"]":{B+="["+O+"]",U=!1,O="";break}case"?":B+=f;continue;case"*":B+=a(1);continue;default:B+=(0,o.$jf)(te)}}W<re.length-1&&(re[W+1]!==e.$wk||W+2<re.length)&&(B+=v)}ce=pe===e.$wk})}return B}const $=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.$Gc(1e4),g=function(){return!1},s=function(){return null};function c(M,B){if(!M)return s;let re;typeof M!="string"?re=M.pattern:re=M,re=re.trim();const ce=`${re}_${!!B.trimForExclusions}`;let pe=i.get(ce);if(pe)return u(pe,M);let W;return $.test(re)?pe=P(re.substr(4),re):(W=p.exec(D(re,B)))?pe=T(W[1],re):(B.trimForExclusions?b:d).test(re)?pe=z(re,B):(W=t.exec(D(re,B)))?pe=C(W[1].substr(1),re,!0):(W=l.exec(D(re,B)))?pe=C(W[1],re,!1):pe=k(re),i.set(ce,pe),u(pe,M)}function u(M,B){if(typeof B=="string")return M;const re=function(ce,pe){return(0,I.$Fg)(ce,B.base,!y.$e)?M((0,o.$of)(ce.substr(B.base.length),A.sep),pe):null};return re.allBasenames=M.allBasenames,re.allPaths=M.allPaths,re.basenames=M.basenames,re.patterns=M.patterns,re}function D(M,B){return B.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function P(M,B){return function(re,ce){return typeof re=="string"&&re.endsWith(M)?B:null}}function T(M,B){const re=`/${M}`,ce=`\\${M}`,pe=function(ue,_){return typeof ue!="string"?null:_?_===M?B:null:ue===M||ue.endsWith(re)||ue.endsWith(ce)?B:null},W=[M];return pe.basenames=W,pe.patterns=[B],pe.allBasenames=W,pe}function z(M,B){const re=K(M.slice(1,-1).split(",").map(_=>c(_,B)).filter(_=>_!==s),M),ce=re.length;if(!ce)return s;if(ce===1)return re[0];const pe=function(_,U){for(let O=0,te=re.length;O<te;O++)if(re[O](_,U))return M;return null},W=re.find(_=>!!_.allBasenames);W&&(pe.allBasenames=W.allBasenames);const ue=re.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return ue.length&&(pe.allPaths=ue),pe}function C(M,B,re){const ce=A.sep===A.$jc.sep,pe=ce?M:M.replace(w,A.sep),W=A.sep+pe,ue=A.$jc.sep+M;let _;return re?_=function(U,O){return typeof U=="string"&&(U===pe||U.endsWith(W)||!ce&&(U===M||U.endsWith(ue)))?B:null}:_=function(U,O){return typeof U=="string"&&(U===pe||!ce&&U===M)?B:null},_.allPaths=[(re?"*/":"./")+M],_}function k(M){try{const B=new RegExp(`^${m(M)}$`);return function(re){return B.lastIndex=0,typeof re=="string"&&B.test(re)?M:null}}catch{return s}}function q(M,B,re){return!M||typeof B!="string"?!1:Y(M)(B,void 0,re)}function Y(M,B={}){if(!M)return g;if(typeof M=="string"||J(M)){const re=c(M,B);if(re===s)return g;const ce=function(pe,W){return!!re(pe,W)};return re.allBasenames&&(ce.allBasenames=re.allBasenames),re.allPaths&&(ce.allPaths=re.allPaths),ce}return x(M,B)}function J(M){const B=M;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function ne(M){return M.allBasenames||[]}function Z(M){return M.allPaths||[]}function x(M,B){const re=K(Object.getOwnPropertyNames(M).map(_=>le(_,M[_],B)).filter(_=>_!==s)),ce=re.length;if(!ce)return s;if(!re.some(_=>!!_.requiresSiblings)){if(ce===1)return re[0];const _=function(te,V){let j;for(let G=0,Q=re.length;G<Q;G++){const N=re[G](te,V);if(typeof N=="string")return N;(0,r.$sh)(N)&&(j||(j=[]),j.push(N))}return j?(async()=>{for(const G of j){const Q=await G;if(typeof Q=="string")return Q}return null})():null},U=re.find(te=>!!te.allBasenames);U&&(_.allBasenames=U.allBasenames);const O=re.reduce((te,V)=>V.allPaths?te.concat(V.allPaths):te,[]);return O.length&&(_.allPaths=O),_}const pe=function(_,U,O){let te,V;for(let j=0,G=re.length;j<G;j++){const Q=re[j];Q.requiresSiblings&&O&&(U||(U=(0,A.$qc)(_)),te||(te=U.substr(0,U.length-(0,A.$rc)(_).length)));const N=Q(_,U,te,O);if(typeof N=="string")return N;(0,r.$sh)(N)&&(V||(V=[]),V.push(N))}return V?(async()=>{for(const j of V){const G=await j;if(typeof G=="string")return G}return null})():null},W=re.find(_=>!!_.allBasenames);W&&(pe.allBasenames=W.allBasenames);const ue=re.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return ue.length&&(pe.allPaths=ue),pe}function le(M,B,re){if(B===!1)return s;const ce=c(M,re);if(ce===s)return s;if(typeof B=="boolean")return ce;if(B){const pe=B.when;if(typeof pe=="string"){const W=(ue,_,U,O)=>{if(!O||!ce(ue,_))return null;const te=pe.replace("$(basename)",()=>U),V=O(te);return(0,r.$sh)(V)?V.then(j=>j?M:null):V?M:null};return W.requiresSiblings=!0,W}}return ce}function K(M,B){const re=M.filter(_=>!!_.basenames);if(re.length<2)return M;const ce=re.reduce((_,U)=>{const O=U.basenames;return O?_.concat(O):_},[]);let pe;if(B){pe=[];for(let _=0,U=ce.length;_<U;_++)pe.push(B)}else pe=re.reduce((_,U)=>{const O=U.patterns;return O?_.concat(O):_},[]);const W=function(_,U){if(typeof _!="string")return null;if(!U){let te;for(te=_.length;te>0;te--){const V=_.charCodeAt(te-1);if(V===E.CharCode.Slash||V===E.CharCode.Backslash)break}U=_.substr(te)}const O=ce.indexOf(U);return O!==-1?pe[O]:null};W.basenames=ce,W.patterns=pe,W.allBasenames=ce;const ue=M.filter(_=>!_.basenames);return ue.push(W),ue}function ae(M,B){return(0,n.$xb)(M,B,(re,ce)=>typeof re=="string"&&typeof ce=="string"?re===ce:typeof re!="string"&&typeof ce!="string"?re.base===ce.base&&re.pattern===ce.pattern:!1)}}),define(Se[111],ke([1,0,10,174,20,17,4]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.MarkdownStringTextNewlineStyle=void 0,e.$5k=o,e.$6k=S,e.$7k=v,e.$8k=f,e.$9k=w,e.$0k=a,e.$$k=h,e.$_k=m;var A;(function($){$[$.Paragraph=0]="Paragraph",$[$.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class y{constructor(p="",d=!1){if(this.value=p,typeof this.value!="string")throw(0,n.$0)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(p,d=A.Paragraph){return this.value+=f(this.supportThemeIcons?(0,r.$Xk)(p):p).replace(/([ \t]+)/g,(b,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===A.Break?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,d){return this.value+=`
${w(d,p)}
`,this}appendLink(p,d,b){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(p),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(p,d){const b=new RegExp((0,I.$jf)(d),"g");return p.replace(b,(t,l)=>p.charAt(l-1)!=="\\"?`\\${t}`:t)}}e.$4k=y;function o($){return S($)?!$.value:Array.isArray($)?$.every(o):!0}function S($){return $ instanceof y?!0:$&&typeof $=="object"?typeof $.value=="string"&&(typeof $.isTrusted=="boolean"||typeof $.isTrusted=="object"||$.isTrusted===void 0)&&(typeof $.supportThemeIcons=="boolean"||$.supportThemeIcons===void 0):!1}function v($,p){return $===p?!0:!$||!p?!1:$.value===p.value&&$.isTrusted===p.isTrusted&&$.supportThemeIcons===p.supportThemeIcons&&$.supportHtml===p.supportHtml&&($.baseUri===p.baseUri||!!$.baseUri&&!!p.baseUri&&(0,E.$ah)(R.URI.from($.baseUri),R.URI.from(p.baseUri)))}function f($){return $.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w($,p){const d=$.match(/^`+/gm)?.reduce((t,l)=>t.length>l.length?t:l).length??0,b=d>=3?d+1:3;return[`${"`".repeat(b)}${p}`,$,`${"`".repeat(b)}`].join(`
`)}function a($){return $.replace(/"/g,"&quot;")}function h($){return $&&$.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m($){const p=[],d=$.split("|").map(t=>t.trim());$=d[0];const b=d[1];if(b){const t=/height=(\d+)/.exec(b),l=/width=(\d+)/.exec(b),i=t?t[1]:"",g=l?l[1]:"",s=isFinite(parseInt(g)),c=isFinite(parseInt(i));s&&p.push(`width="${g}"`),c&&p.push(`height="${i}"`)}return{href:$,dimensions:p}}}),define(Se[177],ke([1,0,18,37,9,3,20,17]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=y,e.$Yw=S,e.$Zw=f,e.$1w=w,e.$2w=$,e.$3w=d,e.$4w=b,e.$5w=t,e.$6w=l,e.$7w=i;function y(s,c){const{os:u,tildify:D,relative:P}=c;if(P){const C=o(s,P,u);if(typeof C=="string")return C}let T=s.fsPath;if(u===I.OperatingSystem.Windows&&!I.$c?T=T.replace(/\//g,"\\"):u!==I.OperatingSystem.Windows&&I.$c&&(T=T.replace(/\\/g,"/")),u!==I.OperatingSystem.Windows&&D?.userHome){const C=D.userHome.fsPath;let k;s.scheme!==D.userHome.scheme&&s.path[0]===E.$jc.sep&&s.path[1]!==E.$jc.sep?k=D.userHome.with({path:s.path}).fsPath:k=T,T=f(k,C,u)}return(u===I.OperatingSystem.Windows?E.$ic:E.$jc).normalize(S(T,u===I.OperatingSystem.Windows))}function o(s,c,u){const D=u===I.OperatingSystem.Windows?E.$ic:E.$jc,P=u===I.OperatingSystem.Linux?R.$0g:R.$_g,T=c.getWorkspace(),z=(0,n.$Rb)(T.folders);if(!z)return;s.scheme!==z.uri.scheme&&s.path[0]===E.$jc.sep&&s.path[1]!==E.$jc.sep&&(s=z.uri.with({path:s.path}));const C=c.getWorkspaceFolder(s);if(!C)return;let k;if(P.isEqual(C.uri,s)?k="":k=P.relativePath(C.uri,s)??"",k&&(k=D.normalize(k)),T.folders.length>1&&!c.noPrefix){const q=C.name?C.name:P.basenameOrAuthority(C.uri);k=k?`${q} \u2022 ${k}`:q}return k}function S(s,c=I.$c){return(0,r.$Kg)(s,c)?s.charAt(0).toUpperCase()+s.slice(1):s}let v=Object.create(null);function f(s,c,u=I.OS){if(u===I.OperatingSystem.Windows||!s||!c)return s;let D=v.original===c?v.normalized:void 0;D||(D=c,I.$c&&(D=(0,r.$zg)(D)),D=`${(0,A.$pf)(D,E.$jc.sep)}${E.$jc.sep}`,v={original:c,normalized:D});let P=s;return I.$c&&(P=(0,r.$zg)(P)),(u===I.OperatingSystem.Linux?P.startsWith(D):(0,A.$If)(P,D))?`~/${P.substr(D.length)}`:s}function w(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}const a="\u2026",h="\\\\",m="~";function $(s,c=E.sep){const u=new Array(s.length);let D=!1;for(let P=0;P<s.length;P++){const T=s[P];if(T===""){u[P]=`.${c}`;continue}if(!T){u[P]=T;continue}D=!0;let z="",C=T;C.indexOf(h)===0?(z=C.substr(0,C.indexOf(h)+h.length),C=C.substr(C.indexOf(h)+h.length)):C.indexOf(c)===0?(z=C.substr(0,C.indexOf(c)+c.length),C=C.substr(C.indexOf(c)+c.length)):C.indexOf(m)===0&&(z=C.substr(0,C.indexOf(m)+m.length),C=C.substr(C.indexOf(m)+m.length));const k=C.split(c);for(let q=1;D&&q<=k.length;q++)for(let Y=k.length-q;D&&Y>=0;Y--){D=!1;let J=k.slice(Y,Y+q).join(c);for(let ne=0;!D&&ne<s.length;ne++)if(ne!==P&&s[ne]&&s[ne].indexOf(J)>-1){const Z=Y+q===k.length,x=Y>0&&s[ne].indexOf(c)>-1?c+J:J,le=s[ne].endsWith(x);D=!Z||le}if(!D){let ne="";(k[0].endsWith(":")||z!=="")&&(Y===1&&(Y=0,q++,J=k[0]+c+J),Y>0&&(ne=k[0]+c),ne=z+ne),Y>0&&(ne=ne+a+c),ne=ne+J,Y+q<k.length&&(ne=ne+c+a),u[P]=ne}}D&&(u[P]=T)}return u}var p;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function d(s,c=Object.create(null)){const u=[];let D=!1,P="";for(const T of s)if(T==="$"||D&&T==="{")P&&u.push({value:P,type:p.TEXT}),P="",D=!0;else if(T==="}"&&D){const z=c[P];if(typeof z=="string")z.length&&u.push({value:z,type:p.VARIABLE});else if(z){const C=u[u.length-1];(!C||C.type!==p.SEPARATOR)&&u.push({value:z.label,type:p.SEPARATOR})}P="",D=!1}else P+=T;return P&&!D&&u.push({value:P,type:p.TEXT}),u.filter((T,z)=>{if(T.type===p.SEPARATOR){const C=u[z-1],k=u[z+1];return[C,k].every(q=>q&&(q.type===p.VARIABLE||q.type===p.TEXT)&&q.value.length>0)}return!0}).map(T=>T.value).join("")}function b(s,c){return I.$d||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$d?"&":"&&"):s.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function t(s,c){return I.$d||c?s.replace(/\(&&\w\)|&&/g,""):I.$c?s.replace(/&&|&/g,u=>u==="&"?"&&":"&"):s.replace(/&&/g,"_")}function l(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const c=s.lastIndexOf(" [",s.length-2);if(c!==-1){const u=g(s.substring(0,c)),D=s.substring(c);return{name:u.name+D,parentPath:u.parentPath}}}return g(s)}function g(s){const c=s.indexOf("/")!==-1?E.$jc:E.$ic,u=c.basename(s),D=c.dirname(s);return u.length?{name:u,parentPath:D}:{name:D,parentPath:""}}}),define(Se[59],ke([1,0,15,81,4]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=void 0,e.$Pn=y,e.$Qn=S,e.$Rn=v;function I(f){return f.toJSON()}class R{constructor(w){this.a=w}transformIncoming(w){const a=this.a.transformIncoming(w);return a===w?w:I(E.URI.from(a))}transformOutgoing(w){const a=this.a.transformOutgoing(w);return a===w?w:I(E.URI.from(a))}transformOutgoingURI(w){const a=this.a.transformOutgoing(w);return a===w?w:E.URI.from(a)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Nn=R,e.$On=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function A(f,w,a){if(!f||a>200)return null;if(typeof f=="object"){if(f instanceof E.URI)return w.transformOutgoing(f);for(const h in f)if(Object.hasOwnProperty.call(f,h)){const m=A(f[h],w,a+1);m!==null&&(f[h]=m)}}return null}function y(f,w){const a=A(f,w,0);return a===null?f:a}function o(f,w,a,h){if(!f||h>200)return null;if(typeof f=="object"){if(f.$mid===r.MarshalledId.Uri)return a?E.URI.revive(w.transformIncoming(f)):w.transformIncoming(f);if(f instanceof n.$Pe)return null;for(const m in f)if(Object.hasOwnProperty.call(f,m)){const $=o(f[m],w,a,h+1);$!==null&&(f[m]=$)}}return null}function S(f,w){const a=o(f,w,!1,0);return a===null?f:a}function v(f,w){const a=o(f,w,!0,0);return a===null?f:a}}),define(Se[23],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(E){return n.test(E)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const I=new Uint8Array(16),R=[];for(let A=0;A<256;A++)R.push(A.toString(16).padStart(2,"0"));return function(){E(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let y=0,o="";return o+=R[I[y++]],o+=R[I[y++]],o+=R[I[y++]],o+=R[I[y++]],o+="-",o+=R[I[y++]],o+=R[I[y++]],o+="-",o+=R[I[y++]],o+=R[I[y++]],o+="-",o+=R[I[y++]],o+=R[I[y++]],o+="-",o+=R[I[y++]],o+=R[I[y++]],o+=R[I[y++]],o+=R[I[y++]],o+=R[I[y++]],o+=R[I[y++]],o}}()}),define(Se[178],ke([1,0,18,40,23]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.$pu=void 0,e.$nu=I,e.$ou=R,e.$qu=o;function I(v){return{asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}function R(v,f,w){const a={id:(0,E.$3g)(),name:v,uri:f,data:w};return{asString:async()=>"",asFile:()=>a,value:void 0}}class A{constructor(){this.a=new Map}get size(){let f=0;for(const w of this.a)f++;return f}has(f){return this.a.has(this.b(f))}matches(f){const w=[...this.a.keys()];return r.Iterable.some(this,([a,h])=>h.asFile())&&w.push("files"),S(y(f),w)}get(f){return this.a.get(this.b(f))?.[0]}append(f,w){const a=this.a.get(f);a?a.push(w):this.a.set(this.b(f),[w])}replace(f,w){this.a.set(this.b(f),[w])}delete(f){this.a.delete(this.b(f))}*[Symbol.iterator](){for(const[f,w]of this.a)for(const a of w)yield[f,a]}b(f){return y(f)}}e.$pu=A;function y(v){return v.toLowerCase()}function o(v,f){return S(y(v),f.map(y))}function S(v,f){if(v==="*/*")return f.length>0;if(f.includes(v))return!0;const w=v.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[a,h,m]=w;return m==="*"?f.some($=>$.startsWith(h+"/")):!1}e.$ru=Object.freeze({create:v=>(0,n.$Pb)(v.map(f=>f.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.$ru.split(v).filter(f=>!f.startsWith("#"))})}),function(){"use strict";function se(e,n,r){function E(w){return new Promise(a=>n.exists(w,a))}function I(w){return new Promise((a,h)=>{const m=new Date;n.utimes(w,m,m,$=>$?h($):a())})}function R(w){return new Promise((a,h)=>n.mkdir(w,{recursive:!0},m=>m&&m.code!=="EEXIST"?h(m):a(w)))}function A(w){return new Promise((a,h)=>n.rm(w,{recursive:!0,force:!0,maxRetries:3},m=>m?h(m):a()))}function y(w){return new Promise((a,h)=>n.readFile(w,"utf8",(m,$)=>m?h(m):a($)))}function o(w,a){return new Promise((h,m)=>n.writeFile(w,a,"utf8",$=>$?m($):h()))}async function S(w){const a=e.join(w,"languagepacks.json");try{return JSON.parse(await y(a))}catch{}}function v(w,a){try{for(;a;){if(w[a])return a;{const h=a.lastIndexOf("-");if(h>0)a=a.substring(0,h);else return}}}catch(h){console.error("Resolving language pack configuration failed.",h)}}function f(w,a,h,m,$){const p=function(b){return r.mark("code/didGenerateNls"),Promise.resolve({locale:b,osLocale:$,availableLanguages:{}})};if(r.mark("code/willGenerateNls"),m==="pseudo")return Promise.resolve({locale:m,osLocale:$,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:m,osLocale:$,availableLanguages:{}});if(m&&(m==="en"||m==="en-us"))return Promise.resolve({locale:m,osLocale:$,availableLanguages:{}});const d=m;try{return w?S(a).then(b=>{if(!b)return p(d);const t=v(b,m);if(!t)return p(d);m=t;const l=b[m];let i;return!l||typeof l.hash!="string"||!l.translations||typeof(i=l.translations.vscode)!="string"?p(d):E(i).then(g=>{if(!g)return p(d);const s=l.hash+"."+m,c=e.join(a,"clp",s),u=e.join(c,w),D=e.join(c,"tcf.json"),P=e.join(c,"corrupted.info"),T={locale:d,osLocale:$,availableLanguages:{"*":m},_languagePackId:s,_translationsConfigFile:D,_cacheRoot:c,_resolvedLanguagePackCoreLocation:u,_corruptedFile:P};return E(P).then(z=>{let C;return z?C=A(c):C=Promise.resolve(void 0),C.then(()=>E(u).then(k=>k?(I(u).catch(()=>{}),r.mark("code/didGenerateNls"),T):R(u).then(()=>Promise.all([y(h),y(i)])).then(q=>{const Y=JSON.parse(q[0]),J=JSON.parse(q[1]).contents,ne=Object.keys(Y.bundles),Z=[];for(const x of ne){const le=Y.bundles[x],K=Object.create(null);for(const ae of le){const M=Y.keys[ae],B=Y.messages[ae],re=J[ae];let ce;if(re){ce=[];for(let pe=0;pe<M.length;pe++){const W=M[pe],ue=typeof W=="string"?W:W.key;let _=re[ue];_===void 0&&(_=B[pe]),ce.push(_)}}else ce=B;K[ae]=ce}Z.push(o(e.join(u,x.replace(/\//g,"!")+".nls.json"),JSON.stringify(K)))}return Z.push(o(D,JSON.stringify(l.translations))),Promise.all(Z)}).then(()=>(r.mark("code/didGenerateNls"),T)).catch(q=>(console.error("Generating translation files failed.",q),p(m)))))})})}):p(d)}catch(b){return console.error("Generating translation files failed.",b),p(m)}}return{getNLSConfiguration:f}}if(typeof define=="function")define(Se[179],ke([84,33,44]),function(e,n,r){return se(e,n,r)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("fs"),r=require("../common/performance");module.exports=se(e,n,r)}else throw new Error("Unknown context")}(),define(Se[180],ke([1,0,31]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=I;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(R){const A=R.replace(/\-/g,":").toLowerCase();return!r.has(A)}function I(){const R=(0,n.networkInterfaces)();for(const A in R){const y=R[A];if(y){for(const{mac:o}of y)if(E(o))return o}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(Se[112],ke([1,0,31,69,23,180,3]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0,e.$Un=y,e.$Vn=v,e.$Wn=f,E=Be(E),e.$Tn=new class{c(w){return this.a||(this.a=r.$Mi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,a=0;const h=(0,n.networkInterfaces)();for(const m in h){const $=h[m];if($)for(const{mac:p,internal:d}of $)d||(a+=1,this.c(p.toUpperCase())&&(w+=1))}this.b=a>0?w/a:0}return this.b}};let A;async function y(w){return A||(A=(async()=>await o(w)||E.$3g())()),A}async function o(w){try{const a=await new Promise((m,$)=>{se(["crypto"],m,$)}).then(Be),h=(0,I.$Sn)();return a.createHash("sha256").update(h,"utf8").digest("hex")}catch(a){w(a);return}}const S="Software\\Microsoft\\SQMClient";async function v(w){if(R.$c){const a=await new Promise((h,m)=>{se(["@vscode/windows-registry"],h,m)}).then(Be);try{return a.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(h){return w(h),""}}return""}async function f(w){try{return await(await new Promise((m,$)=>{se(["@vscode/deviceid"],m,$)}).then(Be)).getDeviceId()}catch(a){return w(a),""}}}),define(Se[181],ke([1,0,33,333,334,3]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=R,I=Be(I);async function R(A){if(I.$d||I.$c)return;let y;for(const o of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{y=await(0,r.open)(o,n.constants.R_OK);break}catch{}if(!y){A("Unable to retrieve release information from known identifier paths.");return}try{const o=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),S={id:"unknown"};for await(const v of(0,E.createInterface)({input:y.createReadStream(),crlfDelay:1/0})){if(!v.includes("="))continue;const f=v.split("=")[0].toUpperCase().trim();if(o.has(f)){const w=v.split("=")[1].replace(/"/g,"").toLowerCase().trim();f==="ID"||f==="DISTRIB_ID"?S.id=w:f==="ID_LIKE"?S.id_like=w:(f==="VERSION_ID"||f==="DISTRIB_RELEASE")&&(S.version_id=w)}}return S}catch(o){A(o)}}}),define(Se[25],ke([1,0,33,31,335,14,37,108,9,3,20,4]),function(se,e,n,r,E,I,R,A,y,o,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=d,e.whenDeleted=l,e.configureFlushOnWrite=u,e.writeFileSync=P,n=Be(n);var f;(function(x){x[x.UNLINK=0]="UNLINK",x[x.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function w(x,le=f.UNLINK,K){if((0,R.$Jg)(x))throw new Error("rimraf - will refuse to recursively delete root");return le===f.UNLINK?h(x):a(x,K)}async function a(x,le=(0,R.$Og)((0,r.tmpdir)())){try{try{await n.promises.rename(x,le)}catch(K){return K.code==="ENOENT"?void 0:h(x)}h(le).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function h(x){return n.promises.rm(x,{recursive:!0,force:!0,maxRetries:3})}function m(x){if((0,R.$Jg)(x))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(x,{recursive:!0,force:!0,maxRetries:3})}async function $(x,le){return b(await(le?p(x):n.promises.readdir(x)))}async function p(x){try{return await n.promises.readdir(x,{withFileTypes:!0})}catch(ae){console.warn("[node.js fs] readdir with filetypes failed with error: ",ae)}const le=[],K=await $(x);for(const ae of K){let M=!1,B=!1,re=!1;try{const ce=await e.Promises.lstat((0,y.$mc)(x,ae));M=ce.isFile(),B=ce.isDirectory(),re=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}le.push({name:ae,isFile:()=>M,isDirectory:()=>B,isSymbolicLink:()=>re})}return le}function d(x){return b(n.readdirSync(x))}function b(x){return x.map(le=>typeof le=="string"?o.$d?(0,A.$nm)(le):le:(le.name=o.$d?(0,A.$nm)(le.name):le.name,le))}async function t(x){const le=await $(x),K=[];for(const ae of le)await i.existsDirectory((0,y.$mc)(x,ae))&&K.push(ae);return K}function l(x,le=1e3){return new Promise(K=>{let ae=!1;const M=setInterval(()=>{ae||(ae=!0,n.access(x,B=>{ae=!1,B&&(clearInterval(M),K(void 0))}))},le)})}var i;(function(x){async function le(M){let B;try{if(B=await e.Promises.lstat(M),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(M),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(re){if(re.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(o.$c&&re.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ce}throw re}}x.stat=le;async function K(M){try{const{stat:B,symbolicLink:re}=await x.stat(M);return B.isFile()&&re?.dangling!==!0}catch{}return!1}x.existsFile=K;async function ae(M){try{const{stat:B,symbolicLink:re}=await x.stat(M);return B.isDirectory()&&re?.dangling!==!0}catch{}return!1}x.existsDirectory=ae})(i||(e.SymlinkSupport=i={}));const g=new I.$Ph;function s(x,le,K){return g.queueFor(v.URI.file(x),()=>{const ae=T(K);return new Promise((M,B)=>D(x,le,ae,re=>re?B(re):M()))},S.$$g)}let c=!0;function u(x){c=x}function D(x,le,K,ae){if(!c)return n.writeFile(x,le,{mode:K.mode,flag:K.flag},ae);n.open(x,K.flag,K.mode,(M,B)=>{if(M)return ae(M);n.writeFile(B,le,re=>{if(re)return n.close(B,()=>ae(re));n.fdatasync(B,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),u(!1)),n.close(B,pe=>ae(pe))))})})}function P(x,le,K){const ae=T(K);if(!c)return n.writeFileSync(x,le,{mode:ae.mode,flag:ae.flag});const M=n.openSync(x,ae.flag,ae.mode);try{n.writeFileSync(M,le);try{n.fdatasyncSync(M)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),u(!1)}}finally{n.closeSync(M)}}function T(x){return x?{mode:typeof x.mode=="number"?x.mode:438,flag:typeof x.flag=="string"?x.flag:"w"}:{mode:438,flag:"w"}}async function z(x,le,K=6e4){if(x!==le)try{o.$c&&typeof K=="number"?await C(x,le,Date.now(),K):await n.promises.rename(x,le)}catch(ae){if(x.toLowerCase()!==le.toLowerCase()&&ae.code==="EXDEV"||x.endsWith("."))await k(x,le,{preserveSymlinks:!1}),await w(x,f.MOVE);else throw ae}}async function C(x,le,K,ae,M=0){try{return await n.promises.rename(x,le)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-K>=ae)throw console.error(`[node.js fs] rename failed after ${M} retries with error: ${B}`),B;if(M===0){let re=!1;try{const{stat:ce}=await i.stat(le);ce.isFile()||(re=!0)}catch{}if(re)throw B}return await(0,I.$Hh)(Math.min(100,M*10)),C(x,le,K,ae,M+1)}}async function k(x,le,K){return Y(x,le,{root:{source:x,target:le},options:K,handledSourcePaths:new Set})}const q=511;async function Y(x,le,K){if(K.handledSourcePaths.has(x))return;K.handledSourcePaths.add(x);const{stat:ae,symbolicLink:M}=await i.stat(x);if(M){if(K.options.preserveSymlinks)try{return await Z(x,le,K)}catch{}if(M.dangling)return}return ae.isDirectory()?J(x,le,ae.mode&q,K):ne(x,le,ae.mode&q)}async function J(x,le,K,ae){await e.Promises.mkdir(le,{recursive:!0,mode:K});const M=await $(x);for(const B of M)await Y((0,y.$mc)(x,B),(0,y.$mc)(le,B),ae)}async function ne(x,le,K){await e.Promises.copyFile(x,le),await e.Promises.chmod(le,K)}async function Z(x,le,K){let ae=await e.Promises.readlink(x);(0,R.$Fg)(ae,K.root.source,!o.$e)&&(ae=(0,y.$mc)(K.root.target,ae.substr(K.root.source.length+1))),await e.Promises.symlink(ae,le)}e.Promises=new class{get access(){return n.promises.access}get stat(){return n.promises.stat}get lstat(){return n.promises.lstat}get utimes(){return n.promises.utimes}get read(){return(x,le,K,ae,M)=>new Promise((B,re)=>{n.read(x,le,K,ae,M,(ce,pe,W)=>ce?re(ce):B({bytesRead:pe,buffer:W}))})}get readFile(){return n.promises.readFile}get write(){return(x,le,K,ae,M)=>new Promise((B,re)=>{n.write(x,le,K,ae,M,(ce,pe,W)=>ce?re(ce):B({bytesWritten:pe,buffer:W}))})}get appendFile(){return n.promises.appendFile}get fdatasync(){return(0,E.promisify)(n.fdatasync)}get truncate(){return n.promises.truncate}get copyFile(){return n.promises.copyFile}get open(){return(0,E.promisify)(n.open)}get close(){return(0,E.promisify)(n.close)}get symlink(){return n.promises.symlink}get readlink(){return n.promises.readlink}get chmod(){return n.promises.chmod}get mkdir(){return n.promises.mkdir}get unlink(){return n.promises.unlink}get rmdir(){return n.promises.rmdir}get realpath(){return(0,E.promisify)(n.realpath)}async exists(x){try{return await e.Promises.access(x),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return w}get rename(){return z}get copy(){return k}}}),define(Se[182],ke([1,0,33,9,3,17,25]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=A,e.$lr=y,e.$mr=o,e.$nr=S,n=Be(n);function A(f){if(E.$e)return f;const w=(0,r.$pc)(f);if(f===w)return f;const a=((0,r.$qc)(f)||f).toLowerCase();try{const m=(0,R.readdirSync)(w).filter($=>$.toLowerCase()===a);if(m.length===1){const $=A(w);if($)return(0,r.$mc)($,m[0])}else if(m.length>1){const $=m.indexOf(a);if($>=0){const p=A(w);if(p)return(0,r.$mc)(p,m[$])}}}catch{}return null}async function y(f,w){if(E.$e)return f;const a=(0,r.$pc)(f);if(f===a)return f;const h=((0,r.$qc)(f)||f).toLowerCase();try{if(w?.isCancellationRequested)return null;const $=(await R.Promises.readdir(a)).filter(p=>p.toLowerCase()===h);if($.length===1){const p=await y(a,w);if(p)return(0,r.$mc)(p,$[0])}else if($.length>1){const p=$.indexOf(h);if(p>=0){const d=await y(a,w);if(d)return(0,r.$mc)(d,$[p])}}}catch{}return null}async function o(f){try{return await R.Promises.realpath(f)}catch{const a=v(f);return await R.Promises.access(a,n.constants.R_OK),a}}function S(f){try{return n.realpathSync(f)}catch{const a=v(f);return n.accessSync(a,n.constants.R_OK),a}}function v(f){return(0,I.$pf)((0,r.$kc)(f),r.sep)}}),define(Se[183],ke([1,0,85]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=r,e.$7g=I,n=Be(n);function r(A,y,o,S=1){let v=!1;return new Promise(f=>{const w=setTimeout(()=>{if(!v)return v=!0,f(0)},o);E(A,y,S,a=>{if(!v)return v=!0,clearTimeout(w),f(a)})})}function E(A,y,o,S){if(y===0)return S(0);const v=new n.Socket;v.once("connect",()=>(R(v),E(A+o,y-1,o,S))),v.once("data",()=>{}),v.once("error",f=>(R(v),f.code!=="ECONNREFUSED"?E(A+o,y-1,o,S):S(A))),v.connect(A,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(A,y,o,S="127.0.0.1"){let v=!1,f,w=1;const a=n.createServer({pauseOnConnect:!0});function h(m,$){v||(v=!0,a.removeAllListeners(),a.close(),f&&clearTimeout(f),$(m))}return new Promise(m=>{f=setTimeout(()=>{h(0,m)},o),a.on("listening",()=>{h(A,m)}),a.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&w<y?(A++,w++,a.listen(A,S)):h(0,m)}),a.on("close",()=>{h(0,m)}),a.listen(A,S)})}function R(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(y){console.error(y)}}}),define(Se[113],ke([1,0,31,9,25]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=p,e.$xm=d,n=Be(n),r=Be(r),E=Be(E);const I=/^\d+$/,R=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var y;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(y||(y={}));let o;switch(process.arch){case"ia32":o=y.x86;break;case"arm":case"arm64":o=y.ARM;break;default:o=y.x64;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?y.ARM:y.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=y.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=y.x86:S=y.x64;class v{constructor(t,l,i){this.exePath=t,this.displayName=l,this.a=i}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function f({useAlternateBitness:b=!1}={}){return b?o===y.x64?process.env["ProgramFiles(x86)"]||null:S===y.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:b=!1,findPreview:t=!1}={}){const l=f({useAlternateBitness:b});if(!l)return null;const i=r.$mc(l,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(i))return null;let g=-1,s=null;for(const D of await E.Promises.readdir(i)){let P=-1;if(t){const z=D.indexOf("-");if(z<0)continue;const C=D.substring(0,z);if(!I.test(C)||D.substring(z+1)!=="preview")continue;P=parseInt(C,10)}else{if(!I.test(D))continue;P=parseInt(D,10)}if(P<=g)continue;const T=r.$mc(i,D,"pwsh.exe");await E.SymlinkSupport.existsFile(T)&&(s=T,g=P)}if(!s)return null;const c=l.includes("x86")?" (x86)":"",u=t?" Preview":"";return new v(s,`PowerShell${u}${c}`,!0)}async function a({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const t=r.$mc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:l,pwshMsixName:i}=b?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const g of await E.Promises.readdir(t))if(l.test(g)){const s=r.$mc(t,g,"pwsh.exe");return new v(s,i)}return null}function h(){const b=r.$mc(n.homedir(),".dotnet","tools","pwsh.exe");return new v(b,".NET Core PowerShell Global Tool")}function m(){const b=r.$mc(process.env.windir,o===y.x86&&S!==y.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(b,"Windows PowerShell",!0)}async function*$(){let b=await w();b&&(yield b),b=await w({useAlternateBitness:!0}),b&&(yield b),b=await a(),b&&(yield b),b=h(),b&&(yield b),b=await w({findPreview:!0}),b&&(yield b),b=await a({findPreview:!0}),b&&(yield b),b=await w({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=m(),b&&(yield b)}async function*p(){for await(const b of $())await b.exists()&&(yield b)}async function d(){for await(const b of p())return b;return null}}),define(Se[114],ke([1,0,9,3,32,67,11,25]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=y,e.$zm=o,n=Be(n),r=Be(r),E=Be(E),R=Be(R),A=Be(A),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function y(v=E.env){return v.comspec||"cmd.exe"}function o(v){let f=[],w=!1;const a=function(h){if(w){f.push(h);return}(!v.send(h,$=>{if($&&console.error($),w=!1,f.length>0){const p=f.slice(0);f=[],p.forEach(d=>a(d))}})||r.$c)&&(w=!0)};return{send:a}}var S;(function(v){async function f(w,a,h){if(n.$lc(w))return w;if(a===void 0&&(a=E.cwd()),n.$pc(w)!=="."||(h===void 0&&R.$gg(E.env.PATH)&&(h=E.env.PATH.split(n.$wc)),h===void 0||h.length===0))return n.$mc(a,w);async function $(p){if(await A.Promises.exists(p)){let d;try{d=await A.Promises.stat(p)}catch(b){b.message.startsWith("EACCES")&&(d=await A.Promises.lstat(p))}return d?!d.isDirectory():!1}return!1}for(const p of h){let d;if(n.$lc(p)?d=n.$mc(p,w):d=n.$mc(a,p,w),await $(d))return d;let b=d+".com";if(await $(b)||(b=d+".exe",await $(b)))return b}return n.$mc(a,w)}v.findExecutable=f})(S||(e.win32=S={}))}),define(Se[115],ke([1,0,60,13]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=E;function E(R){return new Promise((A,y)=>{let o;const S=new Map;function v(w,a,h,m,$){const p=S.get(a);if(w===R||p){const d={name:f(h),cmd:h,pid:w,ppid:a,load:m,mem:$};S.set(w,d),w===R&&(o=d),p&&(p.children||(p.children=[]),p.children.push(d),p.children.length>1&&(p.children=p.children.sort((b,t)=>b.pid-t.pid)))}}function f(w){const a=/--utility-sub-type=network/i,h=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(h.exec(w))return"electron-crash-reporter";if(m.exec(w))return"winpty-agent";if($.exec(w))return"conpty-agent";let d=p.exec(w);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?a.exec(w)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const b=/[a-zA-Z-]+\.js/g;let t="";do d=b.exec(w),d&&(t+=d+" ");while(d);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${t})`:w}if(process.platform==="win32"){const w=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,h)=>{se(["@vscode/windows-process-tree"],a,h)}).then(Be).then(a=>{a.getProcessList(R,h=>{if(!h){y(new Error(`Root process ${R} not found`));return}a.getProcessCpuUsage(h,m=>{const $=new Map;m.forEach(p=>{const d=w(p.commandLine||"");$.set(p.pid,{name:f(d),cmd:d,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),o=$.get(R),o?($.forEach(p=>{const d=$.get(p.ppid);d&&(d.children||(d.children=[]),d.children.push(p))}),$.forEach(p=>{p.children&&(p.children=p.children.sort((d,b)=>d.pid-b.pid))}),A(o)):y(new Error(`Root process ${R} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let w=function(){let a=[o];const h=[];for(;a.length;){const $=a.shift();$&&(h.push($.pid),$.children&&(a=a.concat($.children)))}let m=JSON.stringify(r.$1g.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+h.join(" "),(0,n.exec)(m,{},($,p,d)=>{if($||d)y($||new Error(d.toString()));else{const b=p.toString().split(`
`);for(let t=0;t<h.length;t++){const l=S.get(h[t]);l.load=parseFloat(b[t])}if(!o){y(new Error(`Root process ${R} not found`));return}A(o)}})};(0,n.exec)("which ps",{},(a,h,m)=>{if(a||m)if(process.platform!=="linux")y(a||new Error(m.toString()));else{const $=JSON.stringify(r.$1g.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)($,{},(p,d,b)=>{p||b?y(p||new Error(b.toString())):(I(d,v),w())})}else{const $=h.toString().trim();(0,n.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,b,t)=>{d||t&&!t.includes("screen size is bogus")?y(d||new Error(t.toString())):(I(b,v),process.platform==="linux"?w():o?A(o):y(new Error(`Root process ${R} not found`)))})}})}})}function I(R,A){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,o=R.toString().split(`
`);for(const S of o){const v=y.exec(S.trim());v&&v.length===6&&A(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(Se[116],ke([1,0,31,3,113,114]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=R,r=Be(r),I=Be(I);async function R(v,f){return v===r.OperatingSystem.Windows?r.$c?S():I.$ym(f):y(v,f)}let A=null;function y(v,f){if(r.$e&&v===r.OperatingSystem.Macintosh||r.$d&&v===r.OperatingSystem.Linux)return"/bin/bash";if(!A){let w;if(r.$c)w="/bin/bash";else{if(w=f.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}A=w}return A}let o=null;async function S(){return o||(o=(await(0,E.$xm)()).exePath),o}}),function(){function se(){function e(){return process.uncHostAllowlist}function n(y){const o=new Set;if(Array.isArray(y))for(const S of y)typeof S=="string"&&o.add(S);return Array.from(o)}function r(){const y=e();return y?Array.from(y):[]}function E(y){if(process.platform!=="win32")return;const o=e();if(o)if(typeof y=="string")o.add(y.toLowerCase());else for(const S of n(y))E(S)}function I(y){if(typeof y!="string")return;const o=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let S;for(const v of o){if(y.indexOf(v)!==0)continue;const w=y.indexOf("\\",v.length);if(w===-1)continue;const a=y.substring(v.length,w);if(a){S=a;break}}return S}function R(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function A(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:E,getUNCHost:I,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:A}}typeof define=="function"?define("vs/base/node/unc",[],function(){return se()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=se():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var ze=this&&this.__decorate||function(se,e,n,r){var E=arguments.length,I=E<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(se,e,n,r);else for(var A=se.length-1;A>=0;A--)(R=se[A])&&(I=(E<3?R(I):E>3?R(e,n,I):R(e,n))||I);return E>3&&I&&Object.defineProperty(e,n,I),I};define(Se[50],ke([1,0,18,14,15,19,78,10,6,2,49,17,11]),function(se,e,n,r,E,I,R,A,y,o,S,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=u,e.$hi=D,e.$mi=q,e.$ni=Y,v=Be(v);var w;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(w||(w={}));function a(M){switch(M){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var h;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(h||(h={}));function m(M){switch(M){case h.Initialize:return"init";case h.PromiseSuccess:return"reply:";case h.PromiseError:case h.PromiseErrorObj:return"replyErr:";case h.EventFire:return"event:"}}var $;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})($||($={}));function p(M){let B=0;for(let re=0;;re+=7){const ce=M.read(1);if(B|=(ce.buffer[0]&127)<<re,!(ce.buffer[0]&128))return B}}const d=g(0);function b(M,B){if(B===0){M.write(d);return}let re=0;for(let pe=B;pe!==0;pe=pe>>>7)re++;const ce=E.$Pe.alloc(re);for(let pe=0;B!==0;pe++)ce.buffer[pe]=B&127,B=B>>>7,B>0&&(ce.buffer[pe]|=128);M.write(ce)}class t{constructor(B){this.b=B,this.a=0}read(B){const re=this.b.slice(this.a,this.a+B);return this.a+=re.byteLength,re}}e.$ei=t;class l{constructor(){this.a=[]}get buffer(){return E.$Pe.concat(this.a)}write(B){this.a.push(B)}}e.$fi=l;var i;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(i||(i={}));function g(M){const B=E.$Pe.alloc(1);return B.writeUInt8(M,0),B}const s={Undefined:g(i.Undefined),String:g(i.String),Buffer:g(i.Buffer),VSBuffer:g(i.VSBuffer),Array:g(i.Array),Object:g(i.Object),Uint:g(i.Int)},c=typeof Buffer<"u";function u(M,B){if(typeof B>"u")M.write(s.Undefined);else if(typeof B=="string"){const re=E.$Pe.fromString(B);M.write(s.String),b(M,re.byteLength),M.write(re)}else if(c&&Buffer.isBuffer(B)){const re=E.$Pe.wrap(B);M.write(s.Buffer),b(M,re.byteLength),M.write(re)}else if(B instanceof E.$Pe)M.write(s.VSBuffer),b(M,B.byteLength),M.write(B);else if(Array.isArray(B)){M.write(s.Array),b(M,B.length);for(const re of B)u(M,re)}else if(typeof B=="number"&&(B|0)===B)M.write(s.Uint),b(M,B);else{const re=E.$Pe.fromString(JSON.stringify(B));M.write(s.Object),b(M,re.byteLength),M.write(re)}}function D(M){switch(M.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return M.read(p(M)).toString();case i.Buffer:return M.read(p(M)).buffer;case i.VSBuffer:return M.read(p(M));case i.Array:{const re=p(M),ce=[];for(let pe=0;pe<re;pe++)ce.push(D(M));return ce}case i.Object:return JSON.parse(M.read(p(M)).toString());case i.Int:return p(M)}}class P{constructor(B,re,ce=null,pe=1e3){this.h=B,this.j=re,this.k=ce,this.l=pe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(W=>this.q(W)),this.m({type:h.Initialize})}registerChannel(B,re){this.b.set(B,re),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case h.Initialize:{const re=this.o([B.type]);this.k?.logOutgoing(re,0,T.OtherSide,m(B.type));return}case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:{const re=this.o([B.type,B.id],B.data);this.k?.logOutgoing(re,B.id,T.OtherSide,m(B.type),B.data);return}}}o(B,re=void 0){const ce=new l;return u(ce,B),u(ce,re),this.p(ce.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const re=new t(B),ce=D(re),pe=D(re),W=ce[0];switch(W){case w.Promise:return this.k?.logIncoming(B.byteLength,ce[1],T.OtherSide,`${a(W)}: ${ce[2]}.${ce[3]}`,pe),this.s({type:W,id:ce[1],channelName:ce[2],name:ce[3],arg:pe});case w.EventListen:return this.k?.logIncoming(B.byteLength,ce[1],T.OtherSide,`${a(W)}: ${ce[2]}.${ce[3]}`,pe),this.t({type:W,id:ce[1],channelName:ce[2],name:ce[3],arg:pe});case w.PromiseCancel:return this.k?.logIncoming(B.byteLength,ce[1],T.OtherSide,`${a(W)}`),this.u({type:W,id:ce[1]});case w.EventDispose:return this.k?.logIncoming(B.byteLength,ce[1],T.OtherSide,`${a(W)}`),this.u({type:W,id:ce[1]})}}s(B){const re=this.b.get(B.channelName);if(!re){this.v(B);return}const ce=new I.$ye;let pe;try{pe=re.call(this.j,B.name,B.arg,ce.token)}catch(_){pe=Promise.reject(_)}const W=B.id;pe.then(_=>{this.m({id:W,data:_,type:h.PromiseSuccess})},_=>{_ instanceof Error?this.m({id:W,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split(`
`):void 0},type:h.PromiseError}):this.m({id:W,data:_,type:h.PromiseErrorObj})}).finally(()=>{ue.dispose(),this.d.delete(B.id)});const ue=(0,o.$Vc)(()=>ce.cancel());this.d.set(B.id,ue)}t(B){const re=this.b.get(B.channelName);if(!re){this.v(B);return}const ce=B.id,W=re.listen(this.j,B.name,B.arg)(ue=>this.m({id:ce,data:ue,type:h.EventFire}));this.d.set(B.id,W)}u(B){const re=this.d.get(B.id);re&&(re.dispose(),this.d.delete(B.id))}v(B){let re=this.g.get(B.channelName);re||(re=[],this.g.set(B.channelName,re));const ce=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===w.Promise&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:h.PromiseError})},this.l);re.push({request:B,timeoutTimer:ce})}w(B){const re=this.g.get(B);if(re){for(const ce of re)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case w.Promise:this.s(ce.request);break;case w.EventListen:this.t(ce.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,o.$Sc)(this.d.values()),this.d.clear()}}e.$ii=P;var T;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(T||(e.RequestInitiator=T={}));class z{constructor(B,re=null){this.l=B,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$ne,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=re}getChannel(B){const re=this;return{call(ce,pe,W){return re.a?Promise.reject(new A.$8):re.m(B,ce,pe,W)},listen(ce,pe){return re.a?y.Event.None:re.o(B,ce,pe)}}}m(B,re,ce,pe=I.CancellationToken.None){const W=this.g++,ue=w.Promise,_={id:W,type:ue,channelName:B,name:re,arg:ce};if(pe.isCancellationRequested)return Promise.reject(new A.$8);let U;return new Promise((te,V)=>{if(pe.isCancellationRequested)return V(new A.$8);const j=()=>{const H=oe=>{switch(oe.type){case h.PromiseSuccess:this.f.delete(W),te(oe.data);break;case h.PromiseError:{this.f.delete(W);const fe=new Error(oe.data.message);fe.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,fe.name=oe.data.name,V(fe);break}case h.PromiseErrorObj:this.f.delete(W),V(oe.data);break}};this.f.set(W,H),this.p(_)};let G=null;this.b===$.Idle?j():(G=(0,r.$th)(H=>this.u()),G.then(()=>{G=null,j()}));const Q=()=>{G?(G.cancel(),G=null):this.p({id:W,type:w.PromiseCancel}),V(new A.$8)},N=pe.onCancellationRequested(Q);U=(0,o.$Uc)((0,o.$Vc)(Q),N),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(B,re,ce){const pe=this.g++,W=w.EventListen,ue={id:pe,type:W,channelName:B,name:re,arg:ce};let _=null;const U=new y.$ne({onWillAddFirstListener:()=>{_=(0,r.$th)(te=>this.u()),_.then(()=>{_=null,this.d.add(U),this.p(ue)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(U),this.p({id:pe,type:w.EventDispose}))}}),O=te=>U.fire(te.data);return this.f.set(pe,O),U.event}p(B){switch(B.type){case w.Promise:case w.EventListen:{const re=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(re,B.id,T.LocalSide,`${a(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case w.PromiseCancel:case w.EventDispose:{const re=this.q([B.type,B.id]);this.j?.logOutgoing(re,B.id,T.LocalSide,a(B.type));return}}}q(B,re=void 0){const ce=new l;return u(ce,B),u(ce,re),this.r(ce.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const re=new t(B),ce=D(re),pe=D(re),W=ce[0];switch(W){case h.Initialize:return this.j?.logIncoming(B.byteLength,0,T.LocalSide,m(W)),this.t({type:ce[0]});case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:return this.j?.logIncoming(B.byteLength,ce[1],T.LocalSide,m(W),pe),this.t({type:ce[0],id:ce[1],data:pe})}}t(B){if(B.type===h.Initialize){this.b=$.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,o.$Sc)(this.d.values()),this.d.clear()}}e.$ji=z,ze([R.$$h],z.prototype,"onDidInitializePromise",null);class C{get connections(){const B=[];return this.f.forEach(re=>B.push(re)),B}constructor(B,re,ce){this.a=new Map,this.f=new Set,this.g=new y.$ne,this.onDidAddConnection=this.g.event,this.h=new y.$ne,this.onDidRemoveConnection=this.h.event,this.j=new o.$Wc,this.j.add(B(({protocol:pe,onDidClientDisconnect:W})=>{const ue=y.Event.once(pe.onMessage);this.j.add(ue(_=>{const U=new t(_),O=D(U),te=new P(pe,O,re,ce),V=new z(pe,re);this.a.forEach((G,Q)=>te.registerChannel(Q,G));const j={channelServer:te,channelClient:V,ctx:O};this.f.add(j),this.g.fire(j),this.j.add(W(()=>{te.dispose(),V.dispose(),this.f.delete(j),this.h.fire(j)}))}))}))}getChannel(B,re){const ce=this;return{call(pe,W,ue){let _;if((0,f.$ug)(re)){const O=(0,n.$6b)(ce.connections.filter(re));_=O?Promise.resolve(O):y.Event.toPromise(y.Event.filter(ce.onDidAddConnection,re))}else _=re.routeCall(ce,pe,W);const U=_.then(O=>O.channelClient.getChannel(B));return q(U).call(pe,W,ue)},listen(pe,W){if((0,f.$ug)(re))return ce.k(B,re,pe,W);const ue=re.routeEvent(ce,pe,W).then(_=>_.channelClient.getChannel(B));return q(ue).listen(pe,W)}}}k(B,re,ce,pe){const W=this;let ue;const _=new y.$ne({onWillAddFirstListener:()=>{ue=new o.$Wc;const U=new y.$te,O=new Map,te=j=>{const Q=j.channelClient.getChannel(B).listen(ce,pe),N=U.add(Q);O.set(j,N)},V=j=>{const G=O.get(j);G&&(G.dispose(),O.delete(j))};W.connections.filter(re).forEach(te),y.Event.filter(W.onDidAddConnection,re)(te,void 0,ue),W.onDidRemoveConnection(V,void 0,ue),U.event(_.fire,_,ue),ue.add(U)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return _.event}registerChannel(B,re){this.a.set(B,re);for(const ce of this.f)ce.channelServer.registerChannel(B,re)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=C;class k{constructor(B,re,ce=null){const pe=new l;u(pe,re),B.send(pe.buffer),this.a=new z(B,ce),this.d=new P(B,re,ce)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,re){this.d.registerChannel(B,re)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=k;function q(M){return{call(B,re,ce){return M.then(pe=>pe.call(B,re,ce))},listen(B,re){const ce=new y.$we;return M.then(pe=>ce.input=pe.listen(B,re)),ce.event}}}function Y(M){let B=!1;return{call(re,ce,pe){return B?M.call(re,ce,pe):(0,r.$Hh)(0).then(()=>B=!0).then(()=>M.call(re,ce,pe))},listen(re,ce){if(B)return M.listen(re,ce);const pe=new y.$we;return(0,r.$Hh)(0).then(()=>B=!0).then(()=>pe.input=M.listen(re,ce)),pe.event}}}class J{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const re of B.connections)if(await Promise.resolve(this.a(re.ctx)))return Promise.resolve(re);return await y.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$oi=J;var ne;(function(M){function B(W,ue,_){const U=W,O=_&&_.disableMarshalling,te=new Map;for(const V in U)ce(V)&&te.set(V,y.Event.buffer(U[V],!0,void 0,ue));return new class{listen(V,j,G){const Q=te.get(j);if(Q)return Q;const N=U[j];if(typeof N=="function"){if(pe(j))return N.call(U,G);if(ce(j))return te.set(j,y.Event.buffer(U[j],!0,void 0,ue)),te.get(j)}throw new A.$eb(`Event not found: ${j}`)}call(V,j,G){const Q=U[j];if(typeof Q=="function"){if(!O&&Array.isArray(G))for(let H=0;H<G.length;H++)G[H]=(0,S.$di)(G[H]);let N=Q.apply(U,G);return N instanceof Promise||(N=Promise.resolve(N)),N}throw new A.$eb(`Method not found: ${j}`)}}}M.fromService=B;function re(W,ue){const _=ue&&ue.disableMarshalling;return new Proxy({},{get(U,O){if(typeof O=="string")return ue?.properties?.has(O)?ue.properties.get(O):pe(O)?function(te){return W.listen(O,te)}:ce(O)?W.listen(O):async function(...te){let V;ue&&!(0,f.$pg)(ue.context)?V=[ue.context,...te]:V=te;const j=await W.call(O,V);return _?j:(0,S.$di)(j)};throw new A.$eb(`Property not found: ${String(O)}`)}})}M.toService=re;function ce(W){return W[0]==="o"&&W[1]==="n"&&v.$Gf(W.charCodeAt(2))}function pe(W){return/^onDynamic/.test(W)&&v.$Gf(W.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const B=M.toString();if(B!=="[object Object]")return B}return M}function le(M){return Array.isArray(M)?M.map(x):x(M)}function K(M,B,re,ce,pe,W,ue){ue=le(ue);const _=Z[pe],U=_[ce%_.length];let O=[`%c[${M}]%c[${String(B).padStart(7," ")}]%c[len: ${String(re).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(W)?(O=O.concat(ue),O.push(")")):O.push(ue),console.log.apply(console,O)}class ae{constructor(B,re){this.d=B,this.f=re,this.a=0,this.b=0}logOutgoing(B,re,ce,pe,W){this.b+=B,K(this.d,this.b,B,re,ce,pe,W)}logIncoming(B,re,ce,pe,W){this.a+=B,K(this.f,this.a,B,re,ce,pe,W)}}e.$pi=ae}),define(Se[61],ke([1,0,15,6,2,50]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var A;(function(s){s.enableDiagnostics=!1,s.records=[];const c=new WeakMap;let u=0;function D(T,z){if(!c.has(T)){const C=String(++u);c.set(T,C)}return c.get(T)}function P(T,z,C,k){if(!s.enableDiagnostics)return;const q=D(T,z);if(k instanceof n.$Pe||k instanceof Uint8Array||k instanceof ArrayBuffer||ArrayBuffer.isView(k)){const Y=n.$Pe.alloc(k.byteLength);Y.set(k),s.records.push({timestamp:Date.now(),id:q,label:z,type:C,buff:Y})}else s.records.push({timestamp:Date.now(),id:q,label:z,type:C,data:k})}s.traceSocketEvent=P})(A||(e.SocketDiagnostics=A={}));var y;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let o=null;function S(){return o||(o=n.$Pe.alloc(0)),o}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,u){if(c===0)return S();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const z=this.a[0];return u&&(this.a.shift(),this.b-=c),z}if(this.a[0].byteLength>c){const z=this.a[0].slice(0,c);return u&&(this.a[0]=this.a[0].slice(c),this.b-=c),z}const D=n.$Pe.alloc(c);let P=0,T=0;for(;c>0;){const z=this.a[T];if(z.byteLength>c){const C=z.slice(0,c);D.set(C,P),P+=c,u&&(this.a[T]=z.slice(c),this.b-=c),c-=c}else D.set(z,P),P+=z.byteLength,u?(this.a.shift(),this.b-=z.byteLength):T++,c-=z.byteLength}return D}}e.$qi=v;var f;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(f||(f={}));function w(s){switch(s){case f.None:return"None";case f.Regular:return"Regular";case f.Control:return"Control";case f.Ack:return"Ack";case f.Disconnect:return"Disconnect";case f.ReplayRequest:return"ReplayRequest";case f.Pause:return"PauseWriting";case f.Resume:return"ResumeWriting";case f.KeepAlive:return"KeepAlive"}}var a;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(a||(e.ProtocolConstants=a={}));class h{constructor(c,u,D,P){this.type=c,this.id=u,this.ack=D,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends E.$Xc{constructor(c){super(),this.f=this.B(new r.$ne),this.onMessage=this.f.event,this.g={readHead:!0,readLen:a.HeaderLength,messageType:f.None,id:0,ack:0},this.a=c,this.b=!1,this.c=new v,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent(R.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,P=this.g.id,T=this.g.ack;if(this.g.readHead=!0,this.g.readLen=a.HeaderLength,this.g.messageType=f.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(R.ProtocolMessageRead,u),this.f.fire(new h(D,P,T,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$Pe.alloc(a.HeaderLength);u.writeUInt8(c.type,0),u.writeUInt32BE(c.id,1),u.writeUInt32BE(c.ack,5),u.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent(R.ProtocolHeaderWrite,{messageType:w(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent(R.ProtocolMessageWrite,c.data),this.j(u,c.data)}g(c,u){const D=this.f===0;return this.d.push(c,u),this.f+=c.byteLength+u.byteLength,D}h(){const c=n.$Pe.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,u){this.g(c,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent(R.ProtocolWrite,{byteLength:c.byteLength}),this.c.write(c)}}class p extends E.$Xc{constructor(c){super(),this.f=new r.$ne,this.onMessage=this.f.event,this.g=new r.$ne,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new $(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(u=>{u.type===f.Regular&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new h(f.Regular,0,0,c))}}e.$ri=p;class d extends I.$li{static fromSocket(c,u){return new d(new p(c),u)}get onDidDispose(){return this.b.onDidDispose}constructor(c,u,D=null){super(c,u,D),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$si=d;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$ne({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$ti=b;class t{constructor(c){this.data=c,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let c=0,u=this.a;for(;u;)u=u.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let u=0,D=this.a;for(;D;)c[u++]=D.data,D=D.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const u=new t(c);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const c=Date.now();for(let u=0;u<i.a;u++)this.c[u]=c-1e3*u;setInterval(()=>{for(let u=i.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),u=(1+i.a)*1e3;let D=0;for(let P=0;P<i.a;P++)c-this.c[P]<=u&&D++;return 1-D/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;class g{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new b,this.onControlMessage=this.u.event,this.v=new b,this.onMessage=this.v.event,this.w=new b,this.onDidDispose=this.w.event,this.x=new b,this.onSocketClose=this.x.event,this.y=new b,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??i.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new l,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new E.$Wc,this.o=c.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},a.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new h(f.Disconnect,0,0,S());this.p.write(c),this.p.flush()}sendPause(){const c=new h(f.Pause,0,0,S());this.p.write(c)}sendResume(){const c=new h(f.Resume,0,0,S());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,u){this.a=!0,this.r.dispose(),this.r=new E.$Wc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(D=>this.z(D))),this.r.add(this.o.onClose(D=>this.x.fire(D))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new h(f.Ack,0,this.h,S());this.p.write(c);const u=this.b.toArray();for(let D=0,P=u.length;D<P;D++)this.p.write(u[D]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const u=this.b.peek();if(u&&u.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case f.None:break;case f.Regular:{if(c.id>this.g)if(c.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new h(f.ReplayRequest,0,0,S())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case f.Control:{this.u.fire(c.data);break}case f.Ack:break;case f.Disconnect:{this.w.fire();break}case f.ReplayRequest:{const u=this.b.toArray();for(let D=0,P=u.length;D<P;D++)this.p.write(u[D]);this.B();break}case f.Pause:{this.p.pause();break}case f.Resume:{this.p.resume();break}case f.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const u=++this.c;this.h=this.g;const D=new h(f.Regular,u,this.h,c);this.b.push(D),this.a||(this.p.write(D),this.B())}sendControl(c){const u=new h(f.Control,0,0,c);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=a.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},a.AcknowledgeTime-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),u=Date.now()-c.writtenTime,D=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(u>=a.TimeoutTime&&D>=a.TimeoutTime&&P>=a.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:D});return}const T=Math.max(a.TimeoutTime-u,a.TimeoutTime-D,a.TimeoutTime-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},T)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new h(f.Ack,0,this.h,S());this.p.write(c)}D(){this.h=this.g;const c=new h(f.KeepAlive,0,this.h,S());this.p.write(c)}}e.$ui=g}),define(Se[117],ke([1,0,60,14,15,19,175,10,6,2,21,114,67,50]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0,A=Be(A);class a extends w.$ii{constructor($){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",p=>E.$Pe.wrap(Buffer.from(p,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$gr=a;class h{constructor($,p){this.i=$,this.j=p,this.c=new Set,this.g=new Map,this.h=new y.$ne,this.onDidProcessExit=this.h.event;const d=p&&p.timeout?p.timeout:6e4;this.b=new r.$Dh(d),this.d=null,this.f=null}getChannel($){const p=this;return{call(d,b,t){return p.k($,d,b,t)},listen(d,b){return p.l($,d,b)}}}k($,p,d,b=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(A.$9());this.b.cancel();const t=this.n($),l=(0,r.$th)(s=>t.call(p,d,s)),i=b.onCancellationRequested(()=>l.cancel()),g=(0,o.$Vc)(()=>l.cancel());return this.c.add(g),l.finally(()=>{i.dispose(),this.c.delete(g),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),l}l($,p,d){if(!this.b)return y.Event.None;this.b.cancel();let b;const t=new y.$ne({onWillAddFirstListener:()=>{b=this.n($).listen(p,d)(t.fire,t),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,S.$fo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,f.$mm)(p.env),this.d=(0,n.fork)(this.i,$,p);const d=new y.$ne,t=y.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,R.$cr)(u)){(0,R.log)(u,`IPC Library: ${this.j.serverName}`);return}d.fire(E.$Pe.wrap(Buffer.from(u,"base64")))}),l=this.j.useQueue?(0,v.$zm)(this.d):this.d,i=u=>this.d&&this.d.connected&&l.send(u.buffer.toString("base64")),g=d.event,s={send:i,onMessage:g};this.f=new w.$ji(s);const c=()=>this.o();process.once("exit",c),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,D)=>{process.removeListener("exit",c),t.dispose(),this.c.forEach(P=>(0,o.$Sc)(P)),this.c.clear(),u!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:D})})}return this.f}n($){let p=this.g.get($);return p||(p=this.m.getChannel($),this.g.set($,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$hr=h}),define(Se[184],ke([1,0,14,6,2,49,11]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.StorageState=e.StorageHint=void 0,e.$cq=y;var A;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function y(f){const w=f;return w?.changed instanceof Map||w?.deleted instanceof Set}var o;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(o||(e.StorageState=o={}));class S extends E.$Xc{constructor(w,a=Object.create(null)){super(),this.r=w,this.s=a,this.b=this.B(new r.$qe),this.onDidChangeStorage=this.b.event,this.c=o.None,this.f=new Map,this.g=this.B(new n.$Eh(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((a,h)=>this.w(h,a)),w.deleted?.forEach(a=>this.w(a,void 0))}finally{this.b.resume()}}w(w,a){if(this.c===o.Closed)return;let h=!1;(0,R.$pg)(a)?h=this.f.delete(w):this.f.get(w)!==a&&(this.f.set(w,a),h=!0),h&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===o.None&&(this.c=o.Initialized,this.s.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,a){const h=this.f.get(w);return(0,R.$pg)(h)?a:h}getBoolean(w,a){const h=this.get(w);return(0,R.$pg)(h)?a:h==="true"}getNumber(w,a){const h=this.get(w);return(0,R.$pg)(h)?a:parseInt(h,10)}getObject(w,a){const h=this.get(w);return(0,R.$pg)(h)?a:(0,I.$ci)(h)}async set(w,a,h=!1){if(this.c===o.Closed)return;if((0,R.$pg)(a))return this.delete(w,h);const m=(0,R.$ig)(a)||Array.isArray(a)?(0,I.$bi)(a):String(a);if(this.f.get(w)!==m)return this.f.set(w,m),this.j.set(w,m),this.h.delete(w),this.b.fire({key:w,external:h}),this.D()}async delete(w,a=!1){if(!(this.c===o.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:a}),this.D()}async optimize(){if(this.c!==o.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=o.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===o.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===A.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===A.STORAGE_IN_MEMORY}}e.$dq=S,S.a=100;class v{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((a,h)=>this.a.set(h,a)),w.delete?.forEach(a=>this.a.delete(a))}async optimize(){}async close(){}}e.$eq=v}),define(Se[86],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class n{constructor(E,I){this.lineNumber=E,this.column=I}with(E=this.lineNumber,I=this.column){return E===this.lineNumber&&I===this.column?this:new n(E,I)}delta(E=0,I=0){return this.with(this.lineNumber+E,this.column+I)}equals(E){return n.equals(this,E)}static equals(E,I){return!E&&!I?!0:!!E&&!!I&&E.lineNumber===I.lineNumber&&E.column===I.column}isBefore(E){return n.isBefore(this,E)}static isBefore(E,I){return E.lineNumber<I.lineNumber?!0:I.lineNumber<E.lineNumber?!1:E.column<I.column}isBeforeOrEqual(E){return n.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,I){return E.lineNumber<I.lineNumber?!0:I.lineNumber<E.lineNumber?!1:E.column<=I.column}static compare(E,I){const R=E.lineNumber|0,A=I.lineNumber|0;if(R===A){const y=E.column|0,o=I.column|0;return y-o}return R-A}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new n(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Mt=n}),define(Se[51],ke([1,0,86]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class r{constructor(I,R,A,y){I>A||I===A&&R>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=I,this.endColumn=R):(this.startLineNumber=I,this.startColumn=R,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return r.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return r.containsPosition(this,I)}static containsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<I.startColumn||R.lineNumber===I.endLineNumber&&R.column>I.endColumn)}static strictContainsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<=I.startColumn||R.lineNumber===I.endLineNumber&&R.column>=I.endColumn)}containsRange(I){return r.containsRange(this,I)}static containsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>I.endColumn)}strictContainsRange(I){return r.strictContainsRange(this,I)}static strictContainsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<=I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>=I.endColumn)}plusRange(I){return r.plusRange(this,I)}static plusRange(I,R){let A,y,o,S;return R.startLineNumber<I.startLineNumber?(A=R.startLineNumber,y=R.startColumn):R.startLineNumber===I.startLineNumber?(A=R.startLineNumber,y=Math.min(R.startColumn,I.startColumn)):(A=I.startLineNumber,y=I.startColumn),R.endLineNumber>I.endLineNumber?(o=R.endLineNumber,S=R.endColumn):R.endLineNumber===I.endLineNumber?(o=R.endLineNumber,S=Math.max(R.endColumn,I.endColumn)):(o=I.endLineNumber,S=I.endColumn),new r(A,y,o,S)}intersectRanges(I){return r.intersectRanges(this,I)}static intersectRanges(I,R){let A=I.startLineNumber,y=I.startColumn,o=I.endLineNumber,S=I.endColumn;const v=R.startLineNumber,f=R.startColumn,w=R.endLineNumber,a=R.endColumn;return A<v?(A=v,y=f):A===v&&(y=Math.max(y,f)),o>w?(o=w,S=a):o===w&&(S=Math.min(S,a)),A>o||A===o&&y>S?null:new r(A,y,o,S)}equalsRange(I){return r.equalsRange(this,I)}static equalsRange(I,R){return!I&&!R?!0:!!I&&!!R&&I.startLineNumber===R.startLineNumber&&I.startColumn===R.startColumn&&I.endLineNumber===R.endLineNumber&&I.endColumn===R.endColumn}getEndPosition(){return r.getEndPosition(this)}static getEndPosition(I){return new n.$Mt(I.endLineNumber,I.endColumn)}getStartPosition(){return r.getStartPosition(this)}static getStartPosition(I){return new n.$Mt(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,R){return new r(this.startLineNumber,this.startColumn,I,R)}setStartPosition(I,R){return new r(I,R,this.endLineNumber,this.endColumn)}collapseToStart(){return r.collapseToStart(this)}static collapseToStart(I){return new r(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return r.collapseToEnd(this)}static collapseToEnd(I){return new r(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new r(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,R=I){return new r(I.lineNumber,I.column,R.lineNumber,R.column)}static lift(I){return I?new r(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn)}static areIntersecting(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,R){if(I&&R){const o=I.startLineNumber|0,S=R.startLineNumber|0;if(o===S){const v=I.startColumn|0,f=R.startColumn|0;if(v===f){const w=I.endLineNumber|0,a=R.endLineNumber|0;if(w===a){const h=I.endColumn|0,m=R.endColumn|0;return h-m}return w-a}return v-f}return o-S}return(I?1:0)-(R?1:0)}static compareRangesUsingEnds(I,R){return I.endLineNumber===R.endLineNumber?I.endColumn===R.endColumn?I.startLineNumber===R.startLineNumber?I.startColumn-R.startColumn:I.startLineNumber-R.startLineNumber:I.endColumn-R.endColumn:I.endLineNumber-R.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Nt=r}),define(Se[185],ke([1,0,51]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class r{static insert(I,R){return{range:new n.$Nt(I.lineNumber,I.column,I.lineNumber,I.column),text:R,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,R){return{range:I,text:R}}static replaceMove(I,R){return{range:I,text:R,forceMoveMarkers:!0}}}e.$Ot=r}),define(Se[186],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0,e.$kt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[187],ke([1,0,40,2,80]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.$lt=void 0,e.$nt=R,e.$ot=y,e.$pt=o,e.$lt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(v=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const w of e.$lt)v.indexOf(w)>=0||(f+="\\"+w);return f+="\\s]+)",new RegExp(f,"g")}e.$mt=I();function R(v){let f=e.$mt;if(v&&v instanceof RegExp)if(v.global)f=v;else{let w="g";v.ignoreCase&&(w+="i"),v.multiline&&(w+="m"),v.unicode&&(w+="u"),f=new RegExp(v.source,w)}return f.lastIndex=0,f}const A=new E.$8c;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(v){const f=A.unshift(v);return(0,r.$Vc)(f)}function o(v,f,w,a,h){if(f=R(f),h||(h=n.Iterable.first(A)),w.length>h.maxLen){let b=v-h.maxLen/2;return b<0?b=0:a+=b,w=w.substring(b,v+h.maxLen/2),o(v,f,w,a,h)}const m=Date.now(),$=v-1-a;let p=-1,d=null;for(let b=1;!(Date.now()-m>=h.timeBudget);b++){const t=$-h.windowSize*b;f.lastIndex=Math.max(0,t);const l=S(f,w,$,p);if(!l&&d||(d=l,t<=0))break;p=t}if(d){const b={word:d[0],startColumn:a+1+d.index,endColumn:a+1+d.index+d[0].length};return f.lastIndex=0,b}return null}function S(v,f,w,a){let h;for(;h=v.exec(f);){const m=h.index||0;if(m<=w&&v.lastIndex>=w)return h;if(a>0&&m>a)return null}return null}}),define(Se[118],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var n;(function(y){y[y.Null=0]="Null",y[y.PlainText=1]="PlainText"})(n||(e.LanguageId=n={}));var r;(function(y){y[y.NotSet=-1]="NotSet",y[y.None=0]="None",y[y.Italic=1]="Italic",y[y.Bold=2]="Bold",y[y.Underline=4]="Underline",y[y.Strikethrough=8]="Strikethrough"})(r||(e.FontStyle=r={}));var E;(function(y){y[y.None=0]="None",y[y.DefaultForeground=1]="DefaultForeground",y[y.DefaultBackground=2]="DefaultBackground"})(E||(e.ColorId=E={}));var I;(function(y){y[y.Other=0]="Other",y[y.Comment=1]="Comment",y[y.String=2]="String",y[y.RegEx=3]="RegEx"})(I||(e.StandardTokenType=I={}));var R;(function(y){y[y.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",y[y.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",y[y.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",y[y.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",y[y.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",y[y.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",y[y.ITALIC_MASK=2048]="ITALIC_MASK",y[y.BOLD_MASK=4096]="BOLD_MASK",y[y.UNDERLINE_MASK=8192]="UNDERLINE_MASK",y[y.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",y[y.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",y[y.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",y[y.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",y[y.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",y[y.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",y[y.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",y[y.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",y[y.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",y[y.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",y[y.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",y[y.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",y[y.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(R||(e.MetadataConsts=R={}));class A{static getLanguageId(o){return(o&R.LANGUAGEID_MASK)>>>R.LANGUAGEID_OFFSET}static getTokenType(o){return(o&R.TOKEN_TYPE_MASK)>>>R.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(o){return(o&R.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(o){return(o&R.FONT_STYLE_MASK)>>>R.FONT_STYLE_OFFSET}static getForeground(o){return(o&R.FOREGROUND_MASK)>>>R.FOREGROUND_OFFSET}static getBackground(o){return(o&R.BACKGROUND_MASK)>>>R.BACKGROUND_OFFSET}static getClassNameFromMetadata(o){let v="mtk"+this.getForeground(o);const f=this.getFontStyle(o);return f&r.Italic&&(v+=" mtki"),f&r.Bold&&(v+=" mtkb"),f&r.Underline&&(v+=" mtku"),f&r.Strikethrough&&(v+=" mtks"),v}static getInlineStyleFromMetadata(o,S){const v=this.getForeground(o),f=this.getFontStyle(o);let w=`color: ${S[v]};`;f&r.Italic&&(w+="font-style: italic;"),f&r.Bold&&(w+="font-weight: bold;");let a="";return f&r.Underline&&(a+=" underline"),f&r.Strikethrough&&(a+=" line-through"),a&&(w+=`text-decoration:${a};`),w}static getPresentationFromMetadata(o){const S=this.getForeground(o),v=this.getFontStyle(o);return{foreground:S,italic:!!(v&r.Italic),bold:!!(v&r.Bold),underline:!!(v&r.Underline),strikethrough:!!(v&r.Strikethrough)}}}e.$tu=A}),define(Se[188],ke([1,0,21]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$ew=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$cw=e.$bw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$dw=a,e.$hw=b;var r;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(r||(e.OverviewRulerLane=r={}));var E;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(E||(e.GlyphMarginLane=E={}));var I;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var R;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var A;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var y;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(y||(e.EndOfLinePreference=y={}));var o;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(o||(e.DefaultEndOfLine=o={}));var S;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(S||(e.EndOfLineSequence=S={}));class v{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,n.$jo)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.$bw=v;class f{constructor(l,i){this._findMatchBrand=void 0,this.range=l,this.matches=i}}e.$cw=f;var w;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function a(t){return t&&typeof t.read=="function"}var h;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(h||(e.PositionAffinity=h={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class ${constructor(l,i,g,s,c,u){this.identifier=l,this.range=i,this.text=g,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=c,this._isTracked=u}}e.$ew=$;class p{constructor(l,i,g){this.regex=l,this.wordSeparators=i,this.simpleSearch=g}}e.$fw=p;class d{constructor(l,i,g){this.reverseEdits=l,this.changes=i,this.trimAutoWhitespaceLineNumbers=g}}e.$gw=d;function b(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(Se[189],ke([1,0,6,2,118]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=void 0;class I{constructor(){this.a=new Map,this.b=new Map,this.c=new n.$ne,this.onDidChange=this.c.event,this.d=null}handleChange(y){this.c.fire({changedLanguages:y,changedColorMap:!1})}register(y,o){return this.a.set(y,o),this.handleChange([y]),(0,r.$Vc)(()=>{this.a.get(y)===o&&(this.a.delete(y),this.handleChange([y]))})}get(y){return this.a.get(y)||null}registerFactory(y,o){this.b.get(y)?.dispose();const S=new R(this,y,o);return this.b.set(y,S),(0,r.$Vc)(()=>{const v=this.b.get(y);!v||v!==S||(this.b.delete(y),v.dispose())})}async getOrCreate(y){const o=this.get(y);if(o)return o;const S=this.b.get(y);return!S||S.isResolved?null:(await S.resolve(),this.get(y))}isResolved(y){if(this.get(y))return!0;const S=this.b.get(y);return!!(!S||S.isResolved)}setColorMap(y){this.d=y,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>E.ColorId.DefaultBackground?this.d[E.ColorId.DefaultBackground]:null}}e.$wu=I;class R extends r.$Xc{get isResolved(){return this.c}constructor(y,o,S){super(),this.f=y,this.g=o,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const y=await this.h.tokenizationSupport;this.c=!0,y&&!this.a&&this.B(this.f.register(this.g,y))}}}),define(Se[190],ke([7,8]),function(se,e){return se.create("vs/base/common/actions",e)}),define(Se[191],ke([1,0,6,2,190]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0,e.$qj=S,E=Be(E);class I extends r.$Xc{constructor(f,w="",a="",h=!0,m){super(),this.j=this.B(new n.$ne),this.onDidChange=this.j.event,this.z=!0,this.m=f,this.n=w,this.w=a,this.z=h,this.D=m}get id(){return this.m}get label(){return this.n}set label(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.j.fire({label:f}))}get tooltip(){return this.u||""}set tooltip(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.j.fire({tooltip:f}))}get class(){return this.w}set class(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.j.fire({class:f}))}get enabled(){return this.z}set enabled(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.j.fire({enabled:f}))}get checked(){return this.C}set checked(f){this.J(f)}J(f){this.C!==f&&(this.C=f,this.j.fire({checked:f}))}async run(f,w){this.D&&await this.D(f)}}e.$lj=I;class R extends r.$Xc{constructor(){super(...arguments),this.f=this.B(new n.$ne),this.onWillRun=this.f.event,this.m=this.B(new n.$ne),this.onDidRun=this.m.event}async run(f,w){if(!f.enabled)return;this.f.fire({action:f});let a;try{await this.u(f,w)}catch(h){a=h}this.m.fire({action:f,error:a})}async u(f,w){await f.run(w)}}e.$mj=R;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let w=[];for(const a of f)a.length&&(w.length?w=[...w,new A,...a]:w=a);return w}async run(){}}e.$nj=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(f,w,a,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=w,this.class=h,this.a=a}async run(){}}e.$oj=y;class o extends I{constructor(){super(o.ID,E.localize(0,null),void 0,!1)}}e.$pj=o,o.ID="vs.actions.empty";function S(v){return{id:v.id,label:v.label,tooltip:v.tooltip??v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...f)=>v.run(...f)}}}),define(Se[192],ke([7,8]),function(se,e){return se.create("vs/base/common/date",e)}),define(Se[193],ke([1,0,192]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=o,e.$4m=S,e.$5m=v;const r=60,E=r*60,I=E*24,R=I*7,A=I*30,y=I*365;function o(f,w,a,h){typeof f!="number"&&(f=f.getTime());const m=Math.round((new Date().getTime()-f)/1e3);if(m<-30)return(0,n.localize)(0,null,o(new Date().getTime()+m*1e3,!1));if(!h&&m<30)return(0,n.localize)(1,null);let $;return m<r?($=m,w?$===1?a?(0,n.localize)(2,null,$):(0,n.localize)(3,null,$):a?(0,n.localize)(4,null,$):(0,n.localize)(5,null,$):$===1?a?(0,n.localize)(6,null,$):(0,n.localize)(7,null,$):a?(0,n.localize)(8,null,$):(0,n.localize)(9,null,$)):m<E?($=Math.floor(m/r),w?$===1?a?(0,n.localize)(10,null,$):(0,n.localize)(11,null,$):a?(0,n.localize)(12,null,$):(0,n.localize)(13,null,$):$===1?a?(0,n.localize)(14,null,$):(0,n.localize)(15,null,$):a?(0,n.localize)(16,null,$):(0,n.localize)(17,null,$)):m<I?($=Math.floor(m/E),w?$===1?a?(0,n.localize)(18,null,$):(0,n.localize)(19,null,$):a?(0,n.localize)(20,null,$):(0,n.localize)(21,null,$):$===1?a?(0,n.localize)(22,null,$):(0,n.localize)(23,null,$):a?(0,n.localize)(24,null,$):(0,n.localize)(25,null,$)):m<R?($=Math.floor(m/I),w?$===1?(0,n.localize)(26,null,$):(0,n.localize)(27,null,$):$===1?(0,n.localize)(28,null,$):(0,n.localize)(29,null,$)):m<A?($=Math.floor(m/R),w?$===1?a?(0,n.localize)(30,null,$):(0,n.localize)(31,null,$):a?(0,n.localize)(32,null,$):(0,n.localize)(33,null,$):$===1?a?(0,n.localize)(34,null,$):(0,n.localize)(35,null,$):a?(0,n.localize)(36,null,$):(0,n.localize)(37,null,$)):m<y?($=Math.floor(m/A),w?$===1?a?(0,n.localize)(38,null,$):(0,n.localize)(39,null,$):a?(0,n.localize)(40,null,$):(0,n.localize)(41,null,$):$===1?a?(0,n.localize)(42,null,$):(0,n.localize)(43,null,$):a?(0,n.localize)(44,null,$):(0,n.localize)(45,null,$)):($=Math.floor(m/y),w?$===1?a?(0,n.localize)(46,null,$):(0,n.localize)(47,null,$):a?(0,n.localize)(48,null,$):(0,n.localize)(49,null,$):$===1?a?(0,n.localize)(50,null,$):(0,n.localize)(51,null,$):a?(0,n.localize)(52,null,$):(0,n.localize)(53,null,$))}function S(f,w){const a=Math.abs(f/1e3);return a<1?w?(0,n.localize)(54,null,f):(0,n.localize)(55,null,f):a<r?w?(0,n.localize)(56,null,Math.round(f)/1e3):(0,n.localize)(57,null,Math.round(f)/1e3):a<E?w?(0,n.localize)(58,null,Math.round(f/(1e3*r))):(0,n.localize)(59,null,Math.round(f/(1e3*r))):a<I?w?(0,n.localize)(60,null,Math.round(f/(1e3*E))):(0,n.localize)(61,null,Math.round(f/(1e3*E))):(0,n.localize)(62,null,Math.round(f/(1e3*I)))}function v(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[194],ke([7,8]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(Se[45],ke([1,0,18,11,194]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=y,e.$sj=o,e.$tj=S,n=Be(n),r=Be(r),E=Be(E);function I(v,f){return f&&(v.stack||v.stacktrace)?E.localize(0,null,A(v),R(v.stack)||R(v.stacktrace)):A(v)}function R(v){return Array.isArray(v)?v.join(`
`):v}function A(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?E.localize(1,null,v.message):v.message||E.localize(2,null)}function y(v=null,f=!1){if(!v)return E.localize(3,null);if(Array.isArray(v)){const w=n.$Kb(v),a=y(w[0],f);return w.length>1?E.localize(4,null,a,w.length):a}if(r.$gg(v))return v;if(v.detail){const w=v.detail;if(w.error)return I(w.error,f);if(w.exception)return I(w.exception,f)}return v.stack?I(v,f):v.message?v.message:E.localize(5,null)}function o(v){const f=v;return f instanceof Error&&Array.isArray(f.actions)}function S(v,f){let w;return typeof v=="string"?w=new Error(v):w=v,w.actions=f,w}}),define(Se[195],ke([7,8]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(Se[196],ke([1,0,195,43]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=E;function E(I){switch(I){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(0,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(1,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(2,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(3,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(4,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(5,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(6,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(7,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(8,null);default:return""}}}),define(Se[197],ke([7,8]),function(se,e){return se.create("vs/base/node/zip",e)}),define(Se[87],ke([1,0,33,14,9,11,25,197]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0,e.zip=m,e.$Cq=$,e.$Dq=d,E=Be(E),A=Be(A),e.$zq="end of central directory record signature not found";const y=new RegExp(e.$zq);class o extends Error{constructor(t,l){let i=l.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=l}}e.$Aq=o;function S(b){const t=b.externalFileAttributes>>16||33188;return[448,56,7].map(l=>t&l).reduce((l,i)=>l+i,t&61440)}function v(b){if(b instanceof o)return b;let t;return y.test(b.message)&&(t="CorruptZip"),new o(t,b)}function f(b,t,l,i,g,s){const c=E.$pc(t),u=E.$mc(i,c);if(!u.startsWith(i))return Promise.reject(new Error(A.localize(0,null,t)));const D=E.$mc(i,t);let P;return s.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(R.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((T,z)=>{if(!s.isCancellationRequested)try{P=(0,n.createWriteStream)(D,{mode:l}),P.once("close",()=>T()),P.once("error",z),b.once("error",z),b.pipe(P)}catch(C){z(C)}}))}function w(b,t,l,i){let g=(0,r.$th)(()=>Promise.resolve()),s=0;const c=i.onCancellationRequested(()=>{g.cancel(),b.close()});return new Promise((u,D)=>{const P=new r.$Bh,T=z=>{z.isCancellationRequested||(s++,b.readEntry())};b.once("error",D),b.once("close",()=>g.then(()=>{i.isCancellationRequested||b.entryCount===s?u():D(new o("Incomplete",new Error(A.localize(1,null,s,b.entryCount))))},D)),b.readEntry(),b.on("entry",z=>{if(i.isCancellationRequested)return;if(!l.sourcePathRegex.test(z.fileName)){T(i);return}const C=z.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(C)){const Y=E.$mc(t,C);g=(0,r.$th)(J=>R.Promises.mkdir(Y,{recursive:!0}).then(()=>T(J)).then(void 0,D));return}const k=h(b,z),q=S(z);g=(0,r.$th)(Y=>P.queue(()=>k.then(J=>f(J,C,q,t,l,Y).then(()=>T(Y)))).then(null,D))})}).finally(()=>c.dispose())}async function a(b,t=!1){const{open:l}=await new Promise((i,g)=>{se(["yauzl"],i,g)}).then(Be);return new Promise((i,g)=>{l(b,t?{lazyEntries:!0}:void 0,(s,c)=>{s?g(v(s)):i((0,I.$rg)(c))})})}function h(b,t){return new Promise((l,i)=>{b.openReadStream(t,(g,s)=>{g?i(v(g)):l((0,I.$rg)(s))})})}async function m(b,t){const{ZipFile:l}=await new Promise((i,g)=>{se(["yazl"],i,g)}).then(Be);return new Promise((i,g)=>{const s=new l;t.forEach(u=>{u.contents?s.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&s.addFile(u.localPath,u.path)}),s.end();const c=(0,n.createWriteStream)(b);s.outputStream.pipe(c),s.outputStream.once("error",g),c.once("error",g),c.once("finish",()=>i(b))})}function $(b,t,l={},i){const g=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let s=a(b,!0);return l.overwrite&&(s=s.then(c=>R.Promises.rm(t).then(()=>c))),s.then(c=>w(c,t,{sourcePathRegex:g},i))}function p(b,t){return a(b).then(l=>new Promise((i,g)=>{l.on("entry",s=>{s.fileName===t&&h(l,s).then(c=>i(c),c=>g(c))}),l.once("close",()=>g(new Error(A.localize(2,null,t))))}))}function d(b,t){return p(b,t).then(l=>new Promise((i,g)=>{const s=[];l.once("error",g),l.on("data",c=>s.push(c)),l.on("end",()=>i(Buffer.concat(s)))}))}}),define(Se[198],ke([7,8]),function(se,e){return se.create("vs/editor/common/config/editorOptions",e)}),define(Se[199],ke([7,8]),function(se,e){return se.create("vs/editor/common/languages",e)}),define(Se[200],ke([1,0,57,4,185,51,189,199]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Pu=e.$Ou=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Nu=e.$Mu=e.SymbolKinds=e.SymbolTag=e.$Ku=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Iu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Hu=e.$Gu=e.$Fu=void 0,e.$Ju=g,e.$Lu=c;class y{constructor(B,re,ce){this.offset=B,this.type=re,this.language=ce,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Fu=y;class o{constructor(B,re){this.tokens=B,this.endState=re,this._tokenizationResultBrand=void 0}}e.$Gu=o;class S{constructor(B,re){this.tokens=B,this.endState=re,this._encodedTokenizationResultBrand=void 0}}e.$Hu=S;var v;(function(M){M[M.Increase=0]="Increase",M[M.Decrease=1]="Decrease"})(v||(e.HoverVerbosityAction=v={}));var f;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(f||(e.CompletionItemKind=f={}));var w;(function(M){const B=new Map;B.set(f.Method,n.$6j.symbolMethod),B.set(f.Function,n.$6j.symbolFunction),B.set(f.Constructor,n.$6j.symbolConstructor),B.set(f.Field,n.$6j.symbolField),B.set(f.Variable,n.$6j.symbolVariable),B.set(f.Class,n.$6j.symbolClass),B.set(f.Struct,n.$6j.symbolStruct),B.set(f.Interface,n.$6j.symbolInterface),B.set(f.Module,n.$6j.symbolModule),B.set(f.Property,n.$6j.symbolProperty),B.set(f.Event,n.$6j.symbolEvent),B.set(f.Operator,n.$6j.symbolOperator),B.set(f.Unit,n.$6j.symbolUnit),B.set(f.Value,n.$6j.symbolValue),B.set(f.Enum,n.$6j.symbolEnum),B.set(f.Constant,n.$6j.symbolConstant),B.set(f.Enum,n.$6j.symbolEnum),B.set(f.EnumMember,n.$6j.symbolEnumMember),B.set(f.Keyword,n.$6j.symbolKeyword),B.set(f.Snippet,n.$6j.symbolSnippet),B.set(f.Text,n.$6j.symbolText),B.set(f.Color,n.$6j.symbolColor),B.set(f.File,n.$6j.symbolFile),B.set(f.Reference,n.$6j.symbolReference),B.set(f.Customcolor,n.$6j.symbolCustomColor),B.set(f.Folder,n.$6j.symbolFolder),B.set(f.TypeParameter,n.$6j.symbolTypeParameter),B.set(f.User,n.$6j.account),B.set(f.Issue,n.$6j.issues);function re(W){let ue=B.get(W);return ue||(console.info("No codicon found for CompletionItemKind "+W),ue=n.$6j.symbolProperty),ue}M.toIcon=re;const ce=new Map;ce.set("method",f.Method),ce.set("function",f.Function),ce.set("constructor",f.Constructor),ce.set("field",f.Field),ce.set("variable",f.Variable),ce.set("class",f.Class),ce.set("struct",f.Struct),ce.set("interface",f.Interface),ce.set("module",f.Module),ce.set("property",f.Property),ce.set("event",f.Event),ce.set("operator",f.Operator),ce.set("unit",f.Unit),ce.set("value",f.Value),ce.set("constant",f.Constant),ce.set("enum",f.Enum),ce.set("enum-member",f.EnumMember),ce.set("enumMember",f.EnumMember),ce.set("keyword",f.Keyword),ce.set("snippet",f.Snippet),ce.set("text",f.Text),ce.set("color",f.Color),ce.set("file",f.File),ce.set("reference",f.Reference),ce.set("customcolor",f.Customcolor),ce.set("folder",f.Folder),ce.set("type-parameter",f.TypeParameter),ce.set("typeParameter",f.TypeParameter),ce.set("account",f.User),ce.set("issue",f.Issue);function pe(W,ue){let _=ce.get(W);return typeof _>"u"&&!ue&&(_=f.Property),_}M.fromString=pe})(w||(e.CompletionItemKinds=w={}));var a;(function(M){M[M.Deprecated=1]="Deprecated"})(a||(e.CompletionItemTag=a={}));var h;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(h||(e.CompletionItemInsertTextRule=h={}));var m;(function(M){M[M.Word=0]="Word",M[M.Line=1]="Line",M[M.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var $;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($||(e.CompletionTriggerKind=$={}));var p;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(p||(e.InlineCompletionTriggerKind=p={}));class d{constructor(B,re,ce,pe){this.range=B,this.text=re,this.completionKind=ce,this.isSnippetText=pe}equals(B){return I.$Nt.lift(this.range).equalsRange(B.range)&&this.text===B.text&&this.completionKind===B.completionKind&&this.isSnippetText===B.isSnippetText}}e.$Iu=d;var b;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(b||(e.CodeActionTriggerType=b={}));var t;(function(M){M[M.Automatic=0]="Automatic",M[M.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var l;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var i;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(i||(e.DocumentHighlightKind=i={}));function g(M){return M&&r.URI.isUri(M.uri)&&I.$Nt.isIRange(M.range)&&(I.$Nt.isIRange(M.originSelectionRange)||I.$Nt.isIRange(M.targetSelectionRange))}var s;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(s||(e.SymbolKind=s={})),e.$Ku={[s.Array]:(0,A.localize)(0,null),[s.Boolean]:(0,A.localize)(1,null),[s.Class]:(0,A.localize)(2,null),[s.Constant]:(0,A.localize)(3,null),[s.Constructor]:(0,A.localize)(4,null),[s.Enum]:(0,A.localize)(5,null),[s.EnumMember]:(0,A.localize)(6,null),[s.Event]:(0,A.localize)(7,null),[s.Field]:(0,A.localize)(8,null),[s.File]:(0,A.localize)(9,null),[s.Function]:(0,A.localize)(10,null),[s.Interface]:(0,A.localize)(11,null),[s.Key]:(0,A.localize)(12,null),[s.Method]:(0,A.localize)(13,null),[s.Module]:(0,A.localize)(14,null),[s.Namespace]:(0,A.localize)(15,null),[s.Null]:(0,A.localize)(16,null),[s.Number]:(0,A.localize)(17,null),[s.Object]:(0,A.localize)(18,null),[s.Operator]:(0,A.localize)(19,null),[s.Package]:(0,A.localize)(20,null),[s.Property]:(0,A.localize)(21,null),[s.String]:(0,A.localize)(22,null),[s.Struct]:(0,A.localize)(23,null),[s.TypeParameter]:(0,A.localize)(24,null),[s.Variable]:(0,A.localize)(25,null)};function c(M,B){return(0,A.localize)(26,null,M,e.$Ku[B])}var u;(function(M){M[M.Deprecated=1]="Deprecated"})(u||(e.SymbolTag=u={}));var D;(function(M){const B=new Map;B.set(s.File,n.$6j.symbolFile),B.set(s.Module,n.$6j.symbolModule),B.set(s.Namespace,n.$6j.symbolNamespace),B.set(s.Package,n.$6j.symbolPackage),B.set(s.Class,n.$6j.symbolClass),B.set(s.Method,n.$6j.symbolMethod),B.set(s.Property,n.$6j.symbolProperty),B.set(s.Field,n.$6j.symbolField),B.set(s.Constructor,n.$6j.symbolConstructor),B.set(s.Enum,n.$6j.symbolEnum),B.set(s.Interface,n.$6j.symbolInterface),B.set(s.Function,n.$6j.symbolFunction),B.set(s.Variable,n.$6j.symbolVariable),B.set(s.Constant,n.$6j.symbolConstant),B.set(s.String,n.$6j.symbolString),B.set(s.Number,n.$6j.symbolNumber),B.set(s.Boolean,n.$6j.symbolBoolean),B.set(s.Array,n.$6j.symbolArray),B.set(s.Object,n.$6j.symbolObject),B.set(s.Key,n.$6j.symbolKey),B.set(s.Null,n.$6j.symbolNull),B.set(s.EnumMember,n.$6j.symbolEnumMember),B.set(s.Struct,n.$6j.symbolStruct),B.set(s.Event,n.$6j.symbolEvent),B.set(s.Operator,n.$6j.symbolOperator),B.set(s.TypeParameter,n.$6j.symbolTypeParameter);function re(ce){let pe=B.get(ce);return pe||(console.info("No codicon found for SymbolKind "+ce),pe=n.$6j.symbolProperty),pe}M.toIcon=re})(D||(e.SymbolKinds=D={}));class P{static asEditOperation(B){return E.$Ot.replace(I.$Nt.lift(B.range),B.text)}}e.$Mu=P;class T{static fromValue(B){switch(B){case"comment":return T.Comment;case"imports":return T.Imports;case"region":return T.Region}return new T(B)}constructor(B){this.value=B}}e.$Nu=T,T.Comment=new T("comment"),T.Imports=new T("imports"),T.Region=new T("region");var z;(function(M){M[M.AIGenerated=1]="AIGenerated"})(z||(e.NewSymbolNameTag=z={}));var C;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(C||(e.NewSymbolNameTriggerKind=C={}));var k;(function(M){function B(re){return!re||typeof re!="object"?!1:typeof re.id=="string"&&typeof re.title=="string"}M.is=B})(k||(e.Command=k={}));var q;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(q||(e.CommentThreadCollapsibleState=q={}));var Y;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(Y||(e.CommentThreadState=Y={}));var J;(function(M){M[M.Current=0]="Current",M[M.Outdated=1]="Outdated"})(J||(e.CommentThreadApplicability=J={}));var ne;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(ne||(e.CommentMode=ne={}));var Z;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(Z||(e.CommentState=Z={}));var x;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(x||(e.InlayHintKind=x={}));class le{constructor(B){this.b=B,this.a=null}dispose(){this.a&&this.a.then(B=>{B&&B.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Ou=le,e.$Pu=new R.$wu;var K;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(K||(e.ExternalUriOpenerPriority=K={}));var ae;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(ae||(e.InlineEditTriggerKind=ae={}))}),define(Se[201],ke([7,8]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[202],ke([7,8]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[203],ke([7,8]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(Se[204],ke([7,8]),function(se,e){return se.create("vs/platform/environment/node/argv",e)}),define(Se[205],ke([7,8]),function(se,e){return se.create("vs/platform/environment/node/argvHelper",e)}),define(Se[206],ke([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Se[207],ke([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[208],ke([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Se[209],ke([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Se[210],ke([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Se[211],ke([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Se[212],ke([7,8]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Se[213],ke([7,8]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[214],ke([7,8]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(Se[215],ke([7,8]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(Se[216],ke([7,8]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(Se[217],ke([7,8]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[218],ke([7,8]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Se[219],ke([7,8]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(Se[220],ke([7,8]),function(se,e){return se.create("vs/platform/markers/common/markers",e)}),define(Se[221],ke([7,8]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(Se[222],ke([7,8]),function(se,e){return se.create("vs/platform/shell/node/shellEnv",e)}),define(Se[223],ke([7,8]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(Se[224],ke([7,8]),function(se,e){return se.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Se[225],ke([7,8]),function(se,e){return se.create("vs/platform/terminal/common/terminalProfiles",e)}),define(Se[226],ke([7,8]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[227],ke([7,8]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(Se[228],ke([7,8]),function(se,e){return se.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(Se[229],ke([7,8]),function(se,e){return se.create("vs/server/node/serverEnvironmentService",e)}),define(Se[230],ke([7,8]),function(se,e){return se.create("vs/server/node/serverServices",e)}),define(Se[231],ke([7,8]),function(se,e){return se.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[232],ke([7,8]),function(se,e){return se.create("vs/workbench/common/editor",e)}),define(Se[233],ke([7,8]),function(se,e){return se.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[234],ke([7,8]),function(se,e){return se.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Se[235],ke([7,8]),function(se,e){return se.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[236],ke([7,8]),function(se,e){return se.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[237],ke([7,8]),function(se,e){return se.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[238],ke([7,8]),function(se,e){return se.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(Se[239],ke([1,0,35,10,203]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var I;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(I||(e.TokenType=I={}));function R(...S){switch(S.length){case 1:return(0,E.localize)(0,null,S[0]);case 2:return(0,E.localize)(1,null,S[0],S[1]);case 3:return(0,E.localize)(2,null,S[0],S[1],S[2]);default:return}}const A=(0,E.localize)(3,null),y=(0,E.localize)(4,null);class o{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case I.LParen:return"(";case I.RParen:return")";case I.Neg:return"!";case I.Eq:return v.isTripleEq?"===":"==";case I.NotEq:return v.isTripleEq?"!==":"!=";case I.Lt:return"<";case I.LtEq:return"<=";case I.Gt:return">=";case I.GtEq:return">=";case I.RegexOp:return"=~";case I.RegexStr:return v.lexeme;case I.True:return"true";case I.False:return"false";case I.In:return"in";case I.Not:return"not";case I.And:return"&&";case I.Or:return"||";case I.Str:return v.lexeme;case I.QuotedStr:return v.lexeme;case I.Error:return v.lexeme;case I.EOF:return"EOF";default:throw(0,r.$$)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(I.LParen);break;case n.CharCode.CloseParen:this.k(I.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const f=this.h(n.CharCode.Equals);this.f.push({type:I.NotEq,offset:this.d,isTripleEq:f})}else this.k(I.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const f=this.h(n.CharCode.Equals);this.f.push({type:I.Eq,offset:this.d,isTripleEq:f})}else this.h(n.CharCode.Tilde)?this.k(I.RegexOp):this.l(R("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?I.LtEq:I.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?I.GtEq:I.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(I.And):this.l(R("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(I.Or):this.l(R("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(I.EOF),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const f=this.d,w=this.c.substring(this.d,this.e),a={type:I.Error,offset:this.d,lexeme:w};this.g.push({offset:f,lexeme:w,additionalInfo:v}),this.f.push(a)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const f=this.c.substring(this.d,this.e),w=o.b.get(f);w?this.k(w):this.f.push({type:I.Str,lexeme:f,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:I.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,f=!1,w=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(y);return}const h=this.c.charCodeAt(v);if(f)f=!1;else if(h===n.CharCode.Slash&&!w){v++;break}else h===n.CharCode.OpenSquareBracket?w=!0:h===n.CharCode.Backslash?f=!0:h===n.CharCode.CloseSquareBracket&&(w=!1);v++}for(;v<this.c.length&&o.a.has(this.c.charCodeAt(v));)v++;this.e=v;const a=this.c.substring(this.d,this.e);this.f.push({type:I.RegexStr,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=o,o.a=new Set(["i","g","s","m","y","u"].map(S=>S.charCodeAt(0))),o.b=new Map([["not",I.Not],["in",I.In],["false",I.False],["true",I.True]])}),define(Se[240],ke([1,0,6,2]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=void 0;class E{constructor(){this.a=new n.$ne,this.b=new n.$ne,this.c=new n.$ne,this.d=new n.$ne}call(A,y,o){switch(y){case"close":return Promise.resolve(this.a.fire({sessionId:o[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:o[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:o[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:o[0],port:o[1],subId:o[2]}))}throw new Error("Method not implemented.")}listen(A,y,o){switch(y){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Yo=E,E.ChannelName="extensionhostdebugservice";class I extends r.$Xc{constructor(A){super(),this.b=A}reload(A){this.b.call("reload",[A])}get onReload(){return this.b.listen("reload")}close(A){this.b.call("close",[A])}get onClose(){return this.b.listen("close")}attachSession(A,y,o){this.b.call("attach",[A,y,o])}get onAttachSession(){return this.b.listen("attach")}terminateSession(A,y){this.b.call("terminate",[A,y])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(A,y){return this.b.call("openExtensionDevelopmentHostWindow",[A,y])}}e.$Zo=I}),define(Se[241],ke([1,0,4]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=void 0;class r{constructor(R){this.a=R}listen(R,A,y){throw new Error("Invalid listen")}call(R,A,y){switch(A){case"download":return this.a.download(n.URI.revive(y[0]),n.URI.revive(y[1]))}throw new Error("Invalid call")}}e.$2o=r;class E{constructor(R,A){this.a=R,this.b=A}async download(R,A){const y=this.b();y&&(R=y.transformOutgoingURI(R),A=y.transformOutgoingURI(A)),await this.a.call("download",[R,A])}}e.$3o=E}),define(Se[242],ke([1,0,193,78,13,9,32,20,4]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=void 0,e.$8m=S,e.$9m=v,e.$6m=/^([^.]+\..+)[:=](.+)$/;class o{get appRoot(){return(0,I.$pc)(E.$1g.asFileUri("").fsPath)}get userHome(){return y.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return y.URI.file((0,I.$mc)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.b.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get stateResource(){return(0,A.$hh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,A.$hh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.$mc)(this.userDataPath,"logs",w)}return y.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.$hh)(y.URI.file((0,I.$mc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.$hh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.$hh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.$hh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=R.env.VSCODE_PORTABLE;return w?y.URI.file((0,I.$mc)(w,"argv.json")):(0,A.$hh)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,I.$mc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,I.$nc)(w):(0,I.$kc)((0,I.$mc)(E.$1g.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?y.URI.file((0,I.$nc)(w)):y.URI.file((0,I.$mc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,I.$nc)(w);const a=R.env.VSCODE_EXTENSIONS;if(a)return a;const h=R.env.VSCODE_PORTABLE;return h?(0,I.$mc)(h,"extensions"):(0,A.$hh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(a=>/^[^:/?#]+?:\/\//.test(a)?y.URI.parse(a):y.URI.file((0,I.$kc)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?y.URI.parse(w):y.URI.file((0,I.$kc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$6m.test(w))}get extensionLogLevel(){const w=[];for(const a of this.args.log||[]){const h=e.$6m.exec(a);h&&h[1]&&h[2]&&w.push([h[1],h[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,A.$hh)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=R.env.VSCODE_PORTABLE;return w?y.URI.file((0,I.$mc)(w,"policy.json")):(0,A.$hh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,a,h){this.a=w,this.b=a,this.c=h,this.editSessionId=this.args.editSessionId}}e.$7m=o,ze([r.$$h],o.prototype,"appRoot",null),ze([r.$$h],o.prototype,"userHome",null),ze([r.$$h],o.prototype,"userDataPath",null),ze([r.$$h],o.prototype,"appSettingsHome",null),ze([r.$$h],o.prototype,"tmpDir",null),ze([r.$$h],o.prototype,"cacheHome",null),ze([r.$$h],o.prototype,"stateResource",null),ze([r.$$h],o.prototype,"userRoamingDataHome",null),ze([r.$$h],o.prototype,"userDataSyncHome",null),ze([r.$$h],o.prototype,"sync",null),ze([r.$$h],o.prototype,"machineSettingsResource",null),ze([r.$$h],o.prototype,"workspaceStorageHome",null),ze([r.$$h],o.prototype,"localHistoryHome",null),ze([r.$$h],o.prototype,"keyboardLayoutResource",null),ze([r.$$h],o.prototype,"argvResource",null),ze([r.$$h],o.prototype,"isExtensionDevelopment",null),ze([r.$$h],o.prototype,"untitledWorkspacesHome",null),ze([r.$$h],o.prototype,"builtinExtensionsPath",null),ze([r.$$h],o.prototype,"extensionsPath",null),ze([r.$$h],o.prototype,"extensionDevelopmentLocationURI",null),ze([r.$$h],o.prototype,"extensionDevelopmentKind",null),ze([r.$$h],o.prototype,"extensionTestsLocationURI",null),ze([r.$$h],o.prototype,"debugExtensionHost",null),ze([r.$$h],o.prototype,"logLevel",null),ze([r.$$h],o.prototype,"extensionLogLevel",null),ze([r.$$h],o.prototype,"serviceMachineIdResource",null),ze([r.$$h],o.prototype,"disableTelemetry",null),ze([r.$$h],o.prototype,"disableWorkspaceTrust",null),ze([r.$$h],o.prototype,"useInMemorySecretStorage",null),ze([r.$$h],o.prototype,"policyFile",null);function S(f,w){return v(f["inspect-extensions"],f["inspect-brk-extensions"],5870,w,f.debugId,f.extensionEnvironment)}function v(f,w,a,h,m,$){const d=Number(w||f)||(h?null:a),b=d?!!w:!1;let t;if($)try{t=JSON.parse($)}catch{}return{port:d,break:b,debugId:m,env:t}}});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[70],ke([1,0,336,3,204]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=void 0,e.$Dm=A,e.$Em=o,e.$Fm=w,e.$Gm=a,n=$t(n);const I={o:(0,E.localize)(0,null),e:(0,E.localize)(1,null),t:(0,E.localize)(2,null)};e.$Bm=["tunnel","serve-web"],e.$Cm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(15,null)},"stdin-to-clipboard":{type:"boolean",cat:"o",alias:"c",description:(0,E.localize)(16,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(17,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(18,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(19,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(20,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(21,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(22,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(23,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(24,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(25,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(26,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(27,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(28,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(29,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(30,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(31,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(32,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(33,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(34,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(35,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,E.localize)(36,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(37,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(38,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(39,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(h,m,$=R){const p=h.find(u=>u.length>0&&u[0]!=="-"),d={},b=["_"],t=[],l={};let i;for(const u in m){const D=m[u];D.type==="subcommand"?u===p&&(i=D):(D.alias&&(d[u]=D.alias),D.type==="string"||D.type==="string[]"?(b.push(u),D.deprecates&&b.push(...D.deprecates)):D.type==="boolean"&&(t.push(u),D.deprecates&&t.push(...D.deprecates)),D.global&&(l[u]=D))}if(i&&p){const u=l;for(const z in i.options)u[z]=i.options[z];const D=h.filter(z=>z!==p),P=$.getSubcommandReporter?$.getSubcommandReporter(p):void 0,T=A(D,u,P);return{[p]:T,_:[]}}const g=(0,n.default)(h,{string:b,boolean:t,alias:d}),s={},c=g;s._=g._.map(u=>String(u)).filter(u=>u.length>0),delete c._;for(const u in m){const D=m[u];if(D.type==="subcommand")continue;D.alias&&delete c[D.alias];let P=c[u];if(D.deprecates)for(const T of D.deprecates)c.hasOwnProperty(T)&&(P||(P=c[T],P&&$.onDeprecatedOption(T,D.deprecationMessage||(0,E.localize)(40,null,u))),delete c[T]);if(typeof P<"u"){if(D.type==="string[]"){if(Array.isArray(P)||(P=[P]),!D.allowEmptyValue){const T=P.filter(z=>z.length>0);T.length!==P.length&&($.onEmptyValue(u),P=T.length>0?T:void 0)}}else D.type==="string"&&(Array.isArray(P)?(P=P.pop(),$.onMultipleValues(u,P)):!P&&!D.allowEmptyValue&&($.onEmptyValue(u),P=void 0));s[u]=P,D.deprecationMessage&&$.onDeprecatedOption(u,D.deprecationMessage)}delete c[u]}for(const u in c)$.onUnknownOption(u);return s}function y(h,m){let $="";return m.args&&(Array.isArray(m.args)?$=` <${m.args.join("> <")}>`:$=` <${m.args}>`),m.alias?`-${m.alias} --${h}${$}`:`--${h}${$}`}function o(h,m){const $=[];for(const p in h){const d=h[p],b=y(p,d);$.push([b,d.description])}return S($,m)}function S(h,m){const p=h.reduce((t,l)=>Math.max(t,l[0].length),12)+2+1;if(m-p<25)return h.reduce((t,l)=>t.concat([`  ${l[0]}`,`      ${l[1]}`]),[]);const d=m-p-1,b=[];for(const t of h){const l=t[0],i=f(t[1],d),g=v(p-l.length-2);b.push("  "+l+g+i[0]);for(let s=1;s<i.length;s++)b.push(v(p)+i[s])}return b}function v(h){return" ".repeat(h)}function f(h,m){const $=[];for(;h.length;){const p=h.length<m?h.length:h.lastIndexOf(" ",m),d=h.slice(0,p).trim();h=h.slice(p),$.push(d)}return $}function w(h,m,$,p,d){const b=process.stdout.isTTY&&process.stdout.columns||80,t=d?.noInputFiles!==!0?`[${(0,E.localize)(41,null)}...]`:"",l=[`${h} ${$}`];l.push(""),l.push(`${(0,E.localize)(42,null)}: ${m} [${(0,E.localize)(43,null)}]${t}`),l.push(""),d?.noPipe!==!0&&(r.$c?l.push((0,E.localize)(44,null,m)):l.push((0,E.localize)(45,null,m)),l.push(""));const i={},g=[];for(const s in p){const c=p[s];if(c.type==="subcommand")c.description&&g.push({command:s,description:c.description});else if(c.description&&c.cat){let u=i[c.cat];u||(i[c.cat]=u={}),u[s]=c}}for(const s in i){const c=s,u=i[c];u&&(l.push(I[c]),l.push(...o(u,b)),l.push(""))}return g.length&&(l.push((0,E.localize)(46,null)),l.push(...S(g.map(s=>[s.command,s.description]),b)),l.push("")),l.join(`
`)}function a(h,m){return`${h||(0,E.localize)(47,null)}
${m||(0,E.localize)(48,null)}
${process.arch}`}});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[243],ke([1,0,337,205,70]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=A,e.$Im=y,e.$Jm=o,e.$Km=S,n=$t(n);function I(v,f){const w=(d,b)=>{console.warn((0,r.localize)(0,null,d,b))},a=d=>{console.warn((0,r.localize)(1,null,d))},h=(d,b)=>{console.warn((0,r.localize)(2,null,d,b))},m=d=>({onUnknownOption:b=>{E.$Bm.includes(d)||console.warn((0,r.localize)(3,null,b,d))},onMultipleValues:w,onEmptyValue:a,onDeprecatedOption:h,getSubcommandReporter:E.$Bm.includes(d)?m:void 0}),$={onUnknownOption:d=>{console.warn((0,r.localize)(4,null,d))},onMultipleValues:w,onEmptyValue:a,onDeprecatedOption:h,getSubcommandReporter:m},p=(0,E.$Dm)(v,E.$Cm,f?$:void 0);return p.goto&&p._.forEach(d=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(d),(0,r.localize)(5,null))),p}function R(v){const f=v.findIndex(w=>!/^-/.test(w));if(f>-1)return[...v.slice(0,f),...v.slice(f+1)]}function A(v){let[,...f]=v;process.env.VSCODE_DEV&&(f=R(f)||[]);const w=!S(process.env);return I(f,w)}function y(v){let[,,...f]=v;return process.env.VSCODE_DEV&&(f=R(f)||[]),I(f,!0)}function o(v,...f){const w=v.indexOf("--");return w===-1?v.push(...f):v.splice(w,0,...f),v}function S(v){return v.VSCODE_CLI==="1"}}),function(){"use strict";function se(e,n,r){function E(R,A){const y=I(R,A),o=[y];return e.isAbsolute(y)||o.unshift(r),e.resolve(...o)}function I(R,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let o=process.env.VSCODE_APPDATA;if(o)return e.join(o,A);const S=R["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(o=process.env.APPDATA,!o){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");o=e.join(v,"AppData","Roaming")}break;case"darwin":o=e.join(n.homedir(),"Library","Application Support");break;case"linux":o=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(o,A)}return{getUserDataPath:E}}if(typeof define=="function")define(Se[244],ke([84,31,32]),function(e,n,r){return se(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=se(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Se[119],ke([1,0,31,242,244]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0,e.$$m=R,e.$_m=A;class I extends r.$7m{constructor(o,S){super(o,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,E.getUserDataPath)(o,S.nameShort)},S)}}e.$0m=I;function R(y,o){return(0,r.$9m)(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,o,y.extensionEnvironment)}function A(y,o){return(0,r.$9m)(y["inspect-sharedprocess"],y["inspect-brk-sharedprocess"],5879,o,y.extensionEnvironment)}}),define(Se[245],ke([1,0,11,209]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=E;function E(R,A,y,o){try{I(R,A,y,o)}catch(S){R.error(S?.message??S)}return A}function I(R,A,y,o){const S=(v,f,w)=>{const a=v[f];if((0,n.$gg)(a)){const h=a,m=h.length;if(m>1&&h[0]==="%"&&h[m-1]==="%"){const $=h.substr(1,m-2);let p=y[$];p===void 0&&o&&(p=o[$]);const d=typeof p=="string"?p:p?.message,b=o?.[$],t=typeof b=="string"?b:b?.message;if(!d){t||R.warn(`[${A.name}]: ${(0,r.localize)(0,null,$)}`);return}if(w&&(f==="title"||f==="category")&&t&&t!==d){const l={value:d,original:t};v[f]=l}else v[f]=d}}else if((0,n.$ig)(a))for(const h in a)a.hasOwnProperty(h)&&(h==="commands"?S(a,h,!0):S(a,h,w));else if(Array.isArray(a))for(let h=0;h<a.length;h++)S(a,h,w)};for(const v in A)A.hasOwnProperty(v)&&S(A,v)}}),define(Se[120],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(Se[71],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class n{constructor(E,I=[],R=!1){this.ctor=E,this.staticArguments=I,this.supportsDelayedInstantiation=R}}e.$Di=n}),define(Se[121],ke([1,0,71]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Qs=I,e.$Rs=R;const r=[];var E;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function I(A,y,o){y instanceof n.$Di||(y=new n.$Di(y,[],!!o)),r.push([A,y])}function R(){return r}}),define(Se[246],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;class n{constructor(I,R){this.key=I,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$tr=n;class r{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const R of this.a.values())R.outgoing.size===0&&I.push(R);return I}insertEdge(I,R){const A=this.lookupOrInsertNode(I),y=this.lookupOrInsertNode(R);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(I){const R=this.b(I);this.a.delete(R);for(const A of this.a.values())A.outgoing.delete(R),A.incoming.delete(R)}lookupOrInsertNode(I){const R=this.b(I);let A=this.a.get(R);return A||(A=new n(R,I),this.a.set(R,A)),A}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[R,A]of this.a)I.push(`${R}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,R]of this.a){const A=new Set([I]),y=this.c(R,A);if(y)return y}}c(I,R){for(const[A,y]of I.outgoing){if(R.has(A))return[...R,A].join(" -> ");R.add(A);const o=this.c(y,R);if(o)return o;R.delete(A)}}}e.$ur=r}),define(Se[5],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=E,e.$Hi=I;var n;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=A})(n||(e._util=n={})),e.$Fi=E("instantiationService");function r(R,A,y){A[n.DI_TARGET]===A?A[n.DI_DEPENDENCIES].push({id:R,index:y}):(A[n.DI_DEPENDENCIES]=[{id:R,index:y}],A[n.DI_TARGET]=A)}function E(R){if(n.serviceIds.has(R))return n.serviceIds.get(R);const A=function(y,o,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(A,y,S)};return A.toString=()=>R,n.serviceIds.set(R,A),A}function I(R){return R}}),define(Se[27],ke([1,0,11,4,5]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=I,e.$cj=R,e.$dj=y,e.$ej=o,e.$fj=S,e.$gj=v,e.$hj=f,e.$ij=a,e.$jj=h,e.$kj=m,n=Be(n),e.$aj=(0,E.$Gi)("configurationService");function I($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof r.URI)}function R($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof r.URI)}var A;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function y($){switch($){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function o($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function S($,p){const d=Object.create(null);for(const b in $)v(d,b,$[b],p);return d}function v($,p,d,b){const t=p.split("."),l=t.pop();let i=$;for(let g=0;g<t.length;g++){const s=t[g];let c=i[s];switch(typeof c){case"undefined":c=i[s]=Object.create(null);break;case"object":if(c===null){b(`Ignoring ${p} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:b(`Ignoring ${p} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify(c)}`);return}i=c}if(typeof i=="object"&&i!==null)try{i[l]=d}catch{b(`Ignoring ${p} as ${t.join(".")} is ${JSON.stringify(i)}`)}else b(`Ignoring ${p} as ${t.join(".")} is ${JSON.stringify(i)}`)}function f($,p){const d=p.split(".");w($,d)}function w($,p){const d=p.shift();if(p.length===0){delete $[d];return}if(Object.keys($).indexOf(d)!==-1){const b=$[d];typeof b=="object"&&!Array.isArray(b)&&(w(b,p),Object.keys(b).length===0&&delete $[d])}}function a($,p,d){function b(i,g){let s=i;for(const c of g){if(typeof s!="object"||s===null)return;s=s[c]}return s}const t=p.split("."),l=b($,t);return typeof l>"u"?d:l}function h($,p,d){Object.keys(p).forEach(b=>{b!=="__proto__"&&(b in $?n.$ig($[b])&&n.$ig(p[b])?h($[b],p[b],d):d&&($[b]=p[b]):$[b]=p[b])})}function m($){return $.replace(/[\[\]]/g,"")}}),define(Se[42],ke([1,0,35,3,17,239,5,202,10]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=S,e.$Fj=g,e.$Gj=s,e.$Zj=W;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",r.$d),o.set("isLinux",r.$e),o.set("isWindows",r.$c),o.set("isWeb",r.$i),o.set("isMacNative",r.$d&&!r.$i),o.set("isEdge",r.$B),o.set("isFirefox",r.$z),o.set("isChrome",r.$y),o.set("isSafari",r.$A);function S(U,O){if(o.get(U)!==void 0)throw(0,y.$0)("contextkey.setConstant(k, v) invoked with already set constant `k`");o.set(U,O)}const v=Object.prototype.hasOwnProperty;var f;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const w={regexParsingWithErrorRecovery:!0},a=(0,A.localize)(0,null),h=(0,A.localize)(1,null),m=(0,A.localize)(2,null),$=(0,A.localize)(3,null),p=(0,A.localize)(4,null),d=(0,A.localize)(5,null),b=(0,A.localize)(6,null),t=(0,A.localize)(7,null);class l{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=w){this.k=O,this.d=new I.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:h});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const te=this.l();if(!this.E()){const V=this.D(),j=V.type===I.TokenType.Str?d:void 0;throw this.h.push({message:p,offset:V.offset,lexeme:I.$Bj.getLexeme(V),additionalInfo:j}),l.c}return te}catch(te){if(te!==l.c)throw te;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(I.TokenType.Or);){const te=this.o();O.push(te)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(I.TokenType.And);){const te=this.s();O.push(te)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(I.TokenType.Neg)){const O=this.D();switch(O.type){case I.TokenType.True:return this.z(),u.INSTANCE;case I.TokenType.False:return this.z(),D.INSTANCE;case I.TokenType.LParen:{this.z();const te=this.l();return this.A(I.TokenType.RParen,$),te?.negate()}case I.TokenType.Str:return this.z(),q.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case I.TokenType.True:return this.z(),i.true();case I.TokenType.False:return this.z(),i.false();case I.TokenType.LParen:{this.z();const te=this.l();return this.A(I.TokenType.RParen,$),te}case I.TokenType.Str:{const te=O.lexeme;if(this.z(),this.y(I.TokenType.RegexOp)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==I.TokenType.RegexStr)throw this.B("REGEX",j);const G=j.lexeme,Q=G.lastIndexOf("/"),N=Q===G.length-1?void 0:this.w(G.substring(Q+1));let H;try{H=new RegExp(G.substring(1,Q),N)}catch{throw this.B("REGEX",j)}return le.create(te,H)}switch(j.type){case I.TokenType.RegexStr:case I.TokenType.Error:{const G=[j.lexeme];this.z();let Q=this.D(),N=0;for(let Ne=0;Ne<j.lexeme.length;Ne++)j.lexeme.charCodeAt(Ne)===n.CharCode.OpenParen?N++:j.lexeme.charCodeAt(Ne)===n.CharCode.CloseParen&&N--;for(;!this.E()&&Q.type!==I.TokenType.And&&Q.type!==I.TokenType.Or;){switch(Q.type){case I.TokenType.LParen:N++;break;case I.TokenType.RParen:N--;break;case I.TokenType.RegexStr:case I.TokenType.QuotedStr:for(let Ne=0;Ne<Q.lexeme.length;Ne++)Q.lexeme.charCodeAt(Ne)===n.CharCode.OpenParen?N++:j.lexeme.charCodeAt(Ne)===n.CharCode.CloseParen&&N--}if(N<0)break;G.push(I.$Bj.getLexeme(Q)),this.z(),Q=this.D()}const H=G.join(""),oe=H.lastIndexOf("/"),fe=oe===H.length-1?void 0:this.w(H.substring(oe+1));let Ee;try{Ee=new RegExp(H.substring(1,oe),fe)}catch{throw this.B("REGEX",j)}return i.regex(te,Ee)}case I.TokenType.QuotedStr:{const G=j.lexeme;this.z();let Q=null;if(!(0,E.$ef)(G)){const N=G.indexOf("/"),H=G.lastIndexOf("/");if(N!==H&&N>=0){const oe=G.slice(N+1,H),fe=G[H+1]==="i"?"i":"";try{Q=new RegExp(oe,fe)}catch{throw this.B("REGEX",j)}}}if(Q===null)throw this.B("REGEX",j);return le.create(te,Q)}default:throw this.B("REGEX",this.D())}}if(this.y(I.TokenType.Not)){this.A(I.TokenType.In,m);const j=this.u();return i.notIn(te,j)}switch(this.D().type){case I.TokenType.Eq:{this.z();const j=this.u();if(this.x().type===I.TokenType.QuotedStr)return i.equals(te,j);switch(j){case"true":return i.has(te);case"false":return i.not(te);default:return i.equals(te,j)}}case I.TokenType.NotEq:{this.z();const j=this.u();if(this.x().type===I.TokenType.QuotedStr)return i.notEquals(te,j);switch(j){case"true":return i.not(te);case"false":return i.has(te);default:return i.notEquals(te,j)}}case I.TokenType.Lt:return this.z(),Z.create(te,this.u());case I.TokenType.LtEq:return this.z(),x.create(te,this.u());case I.TokenType.Gt:return this.z(),J.create(te,this.u());case I.TokenType.GtEq:return this.z(),ne.create(te,this.u());case I.TokenType.In:return this.z(),i.in(te,this.u());default:return i.has(te)}}case I.TokenType.EOF:throw this.h.push({message:b,offset:O.offset,lexeme:"",additionalInfo:t}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case I.TokenType.Str:case I.TokenType.QuotedStr:return this.z(),O.lexeme;case I.TokenType.True:return this.z(),"true";case I.TokenType.False:return this.z(),"false";case I.TokenType.In:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,te){if(this.C(O))return this.z();throw this.B(te,this.D())}B(O,te,V){const j=(0,A.localize)(8,null,O,I.$Bj.getLexeme(te)),G=te.offset,Q=I.$Bj.getLexeme(te);return this.h.push({message:j,offset:G,lexeme:Q,additionalInfo:V}),l.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===I.TokenType.EOF}}e.$Dj=l,l.c=new Error;class i{static false(){return u.INSTANCE}static true(){return D.INSTANCE}static has(O){return P.create(O)}static equals(O,te){return T.create(O,te)}static notEquals(O,te){return k.create(O,te)}static regex(O,te){return le.create(O,te)}static in(O,te){return z.create(O,te)}static notIn(O,te){return C.create(O,te)}static not(O){return q.create(O)}static and(...O){return M.create(O,null,!0)}static or(...O){return B.create(O,null,!0)}static greater(O,te){return J.create(O,te)}static greaterEquals(O,te){return ne.create(O,te)}static smaller(O,te){return Z.create(O,te)}static smallerEquals(O,te){return x.create(O,te)}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Ej=i,i.c=new l({regexParsingWithErrorRecovery:!1});function g(U){const O=new l({regexParsingWithErrorRecovery:!1});return U.map(te=>(O.parse(te),O.lexingErrors.length>0?O.lexingErrors.map(V=>({errorMessage:V.additionalInfo?(0,A.localize)(9,null,V.additionalInfo):(0,A.localize)(10,null),offset:V.offset,length:V.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(V=>({errorMessage:V.additionalInfo?`${V.message}. ${V.additionalInfo}`:V.message,offset:V.offset,length:V.lexeme.length})):[]))}function s(U,O){const te=U?U.substituteConstants():void 0,V=O?O.substituteConstants():void 0;return!te&&!V?!0:!te||!V?!1:te.equals(V)}function c(U,O){return U.cmp(O)}class u{constructor(){this.type=f.False}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return D.INSTANCE}}e.$Hj=u,u.INSTANCE=new u;class D{constructor(){this.type=f.True}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return u.INSTANCE}}e.$Ij=D,D.INSTANCE=new D;class P{static create(O,te=null){const V=o.get(O);return typeof V=="boolean"?V?D.INSTANCE:u.INSTANCE:new P(O,te)}constructor(O,te){this.key=O,this.c=te,this.type=f.Defined}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=o.get(this.key);return typeof O=="boolean"?O?D.INSTANCE:u.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$Jj=P;class T{static create(O,te,V=null){if(typeof te=="boolean")return te?P.create(O,V):q.create(O,V);const j=o.get(O);return typeof j=="boolean"?te===(j?"true":"false")?D.INSTANCE:u.INSTANCE:new T(O,te,V)}constructor(O,te,V){this.c=O,this.d=te,this.f=V,this.type=f.Equals}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=o.get(this.c);if(typeof O=="boolean"){const te=O?"true":"false";return this.d===te?D.INSTANCE:u.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Kj=T;class z{static create(O,te){return new z(O,te)}constructor(O,te){this.d=O,this.f=te,this.type=f.In,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const te=O.getValue(this.f),V=O.getValue(this.d);return Array.isArray(te)?te.includes(V):typeof V=="string"&&typeof te=="object"&&te!==null?v.call(te,V):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=C.create(this.d,this.f)),this.c}}e.$Lj=z;class C{static create(O,te){return new C(O,te)}constructor(O,te){this.d=O,this.f=te,this.type=f.NotIn,this.c=z.create(O,te)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=C;class k{static create(O,te,V=null){if(typeof te=="boolean")return te?q.create(O,V):P.create(O,V);const j=o.get(O);return typeof j=="boolean"?te===(j?"true":"false")?u.INSTANCE:D.INSTANCE:new k(O,te,V)}constructor(O,te,V){this.c=O,this.d=te,this.f=V,this.type=f.NotEquals}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=o.get(this.c);if(typeof O=="boolean"){const te=O?"true":"false";return this.d===te?u.INSTANCE:D.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Nj=k;class q{static create(O,te=null){const V=o.get(O);return typeof V=="boolean"?V?u.INSTANCE:D.INSTANCE:new q(O,te)}constructor(O,te){this.c=O,this.d=te,this.type=f.Not}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=o.get(this.c);return typeof O=="boolean"?O?u.INSTANCE:D.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=P.create(this.c,this)),this.d}}e.$Oj=q;function Y(U,O){if(typeof U=="string"){const te=parseFloat(U);isNaN(te)||(U=te)}return typeof U=="string"||typeof U=="number"?O(U):u.INSTANCE}class J{static create(O,te,V=null){return Y(te,j=>new J(O,j,V))}constructor(O,te,V){this.c=O,this.d=te,this.f=V,this.type=f.Greater}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Pj=J;class ne{static create(O,te,V=null){return Y(te,j=>new ne(O,j,V))}constructor(O,te,V){this.c=O,this.d=te,this.f=V,this.type=f.GreaterEquals}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Qj=ne;class Z{static create(O,te,V=null){return Y(te,j=>new Z(O,j,V))}constructor(O,te,V){this.c=O,this.d=te,this.f=V,this.type=f.Smaller}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Rj=Z;class x{static create(O,te,V=null){return Y(te,j=>new x(O,j,V))}constructor(O,te,V){this.c=O,this.d=te,this.f=V,this.type=f.SmallerEquals}cmp(O){return O.type!==this.type?this.type-O.type:pe(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Sj=x;class le{static create(O,te){return new le(O,te)}constructor(O,te){this.d=O,this.f=te,this.type=f.Regex,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const te=this.f?this.f.source:"",V=O.f?O.f.source:"";return te<V?-1:te>V?1:0}equals(O){if(O.type===this.type){const te=this.f?this.f.source:"",V=O.f?O.f.source:"";return this.d===O.d&&te===V}return!1}substituteConstants(){return this}evaluate(O){const te=O.getValue(this.d);return this.f?this.f.test(te):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Tj=le;class K{static create(O){return new K(O)}constructor(O){this.c=O,this.type=f.NotRegex}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new K(this.c.map(O))}negate(){return this.c}}e.$Uj=K;function ae(U){let O=null;for(let te=0,V=U.length;te<V;te++){const j=U[te].substituteConstants();if(U[te]!==j&&O===null){O=[];for(let G=0;G<te;G++)O[G]=U[G]}O!==null&&(O[te]=j)}return O===null?U:O}class M{static create(O,te,V){return M.d(O,te,V)}constructor(O,te){this.expr=O,this.c=te,this.type=f.And}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let te=0,V=this.expr.length;te<V;te++){const j=c(this.expr[te],O.expr[te]);if(j!==0)return j}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let te=0,V=this.expr.length;te<V;te++)if(!this.expr[te].equals(O.expr[te]))return!1;return!0}return!1}substituteConstants(){const O=ae(this.expr);return O===this.expr?this:M.create(O,this.c,!1)}evaluate(O){for(let te=0,V=this.expr.length;te<V;te++)if(!this.expr[te].evaluate(O))return!1;return!0}static d(O,te,V){const j=[];let G=!1;for(const Q of O)if(Q){if(Q.type===f.True){G=!0;continue}if(Q.type===f.False)return u.INSTANCE;if(Q.type===f.And){j.push(...Q.expr);continue}j.push(Q)}if(j.length===0&&G)return D.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(c);for(let Q=1;Q<j.length;Q++)j[Q-1].equals(j[Q])&&(j.splice(Q,1),Q--);if(j.length===1)return j[0];for(;j.length>1;){const Q=j[j.length-1];if(Q.type!==f.Or)break;j.pop();const N=j.pop(),H=j.length===0,oe=B.create(Q.expr.map(fe=>M.create([fe,N],null,V)),null,H);oe&&(j.push(oe),j.sort(c))}if(j.length===1)return j[0];if(V){for(let Q=0;Q<j.length;Q++)for(let N=Q+1;N<j.length;N++)if(j[Q].negate().equals(j[N]))return u.INSTANCE;if(j.length===1)return j[0]}return new M(j,te)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const te of this.expr)O.push(...te.keys());return O}map(O){return new M(this.expr.map(te=>te.map(O)),null)}negate(){if(!this.c){const O=[];for(const te of this.expr)O.push(te.negate());this.c=B.create(O,this,!0)}return this.c}}e.$Vj=M;class B{static create(O,te,V){return B.d(O,te,V)}constructor(O,te){this.expr=O,this.c=te,this.type=f.Or}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let te=0,V=this.expr.length;te<V;te++){const j=c(this.expr[te],O.expr[te]);if(j!==0)return j}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let te=0,V=this.expr.length;te<V;te++)if(!this.expr[te].equals(O.expr[te]))return!1;return!0}return!1}substituteConstants(){const O=ae(this.expr);return O===this.expr?this:B.create(O,this.c,!1)}evaluate(O){for(let te=0,V=this.expr.length;te<V;te++)if(this.expr[te].evaluate(O))return!0;return!1}static d(O,te,V){let j=[],G=!1;if(O){for(let Q=0,N=O.length;Q<N;Q++){const H=O[Q];if(H){if(H.type===f.False){G=!0;continue}if(H.type===f.True)return D.INSTANCE;if(H.type===f.Or){j=j.concat(H.expr);continue}j.push(H)}}if(j.length===0&&G)return u.INSTANCE;j.sort(c)}if(j.length!==0){if(j.length===1)return j[0];for(let Q=1;Q<j.length;Q++)j[Q-1].equals(j[Q])&&(j.splice(Q,1),Q--);if(j.length===1)return j[0];if(V){for(let Q=0;Q<j.length;Q++)for(let N=Q+1;N<j.length;N++)if(j[Q].negate().equals(j[N]))return D.INSTANCE;if(j.length===1)return j[0]}return new B(j,te)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const te of this.expr)O.push(...te.keys());return O}map(O){return new B(this.expr.map(te=>te.map(O)),null)}negate(){if(!this.c){const O=[];for(const te of this.expr)O.push(te.negate());for(;O.length>1;){const te=O.shift(),V=O.shift(),j=[];for(const G of _(te))for(const Q of _(V))j.push(M.create([G,Q],null,!1));O.unshift(B.create(j,null,!1))}this.c=B.create(O,this,!0)}return this.c}}e.$Wj=B;class re extends P{static all(){return re.d.values()}constructor(O,te,V){super(O,null),this.f=te,typeof V=="object"?re.d.push({...V,key:O}):V!==!0&&re.d.push({key:O,description:V,type:te!=null?typeof te:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return T.create(this.key,O)}notEqualsTo(O){return k.create(this.key,O)}}e.$Xj=re,re.d=[],e.$Yj=(0,R.$Gi)("contextKeyService");function ce(U,O){return U<O?-1:U>O?1:0}function pe(U,O,te,V){return U<te?-1:U>te?1:O<V?-1:O>V?1:0}function W(U,O){if(U.type===f.False||O.type===f.True)return!0;if(U.type===f.Or)return O.type===f.Or?ue(U.expr,O.expr):!1;if(O.type===f.Or){for(const te of O.expr)if(W(U,te))return!0;return!1}if(U.type===f.And){if(O.type===f.And)return ue(O.expr,U.expr);for(const te of U.expr)if(W(te,O))return!0;return!1}return U.equals(O)}function ue(U,O){let te=0,V=0;for(;te<U.length&&V<O.length;){const j=U[te].cmp(O[V]);if(j<0)return!1;j===0&&te++,V++}return te===U.length}function _(U){return U.type===f.Or?U.expr:[U]}}),define(Se[247],ke([1,0,42,5]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$rt=e.AccessibilitySupport=e.$qt=void 0,e.$st=I,e.$qt=(0,r.$Gi)("accessibilityService");var E;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(E||(e.AccessibilitySupport=E={})),e.$rt=new n.$Xj("accessibilityModeEnabled",!1);function I(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$tt="ACCESSIBLE_VIEW_SHOWN_"}),define(Se[248],ke([1,0,18,21,3,170,110,186,187,198,247]),function(se,e,n,r,E,I,R,A,y,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=d,e.clampedInt=t,e.clampedFloat=i,e.stringSet=c,e.cursorStyleToString=Y,e.filterValidationDecorations=$e,n=Be(n),r=Be(r),E=Be(E),o=Be(o);var v;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(v||(e.EditorAutoIndentStrategy=v={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(ie){this.c=ie}hasChanged(ie){return this.c[ie]}}e.ConfigurationChangedEvent=f;class w{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=w;class a{constructor(ie,we,He,Ke){this.id=ie,this.name=we,this.defaultValue=He,this.schema=Ke}applyUpdate(ie,we){return m(ie,we)}compute(ie,we,He){return He}}class h{constructor(ie,we){this.newValue=ie,this.didChange=we}}e.ApplyUpdateResult=h;function m(ee,ie){if(typeof ee!="object"||typeof ie!="object"||!ee||!ie)return new h(ie,ee!==ie);if(Array.isArray(ee)||Array.isArray(ie)){const He=Array.isArray(ee)&&Array.isArray(ie)&&n.$xb(ee,ie);return new h(ie,!He)}let we=!1;for(const He in ie)if(ie.hasOwnProperty(He)){const Ke=m(ee[He],ie[He]);Ke.didChange&&(ee[He]=Ke.newValue,we=!0)}return new h(ee,we)}class ${constructor(ie){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0}applyUpdate(ie,we){return m(ie,we)}validate(ie){return this.defaultValue}}class p{constructor(ie,we,He,Ke){this.id=ie,this.name=we,this.defaultValue=He,this.schema=Ke}applyUpdate(ie,we){return m(ie,we)}validate(ie){return typeof ie>"u"?this.defaultValue:ie}compute(ie,we,He){return He}}function d(ee,ie){return typeof ee>"u"?ie:ee==="false"?!1:!!ee}class b extends p{constructor(ie,we,He,Ke=void 0){typeof Ke<"u"&&(Ke.type="boolean",Ke.default=He),super(ie,we,He,Ke)}validate(ie){return d(ie,this.defaultValue)}}function t(ee,ie,we,He){if(typeof ee>"u")return ie;let Ke=parseInt(ee,10);return isNaN(Ke)?ie:(Ke=Math.max(we,Ke),Ke=Math.min(He,Ke),Ke|0)}class l extends p{static clampedInt(ie,we,He,Ke){return t(ie,we,He,Ke)}constructor(ie,we,He,Ke,xe,tt=void 0){typeof tt<"u"&&(tt.type="integer",tt.default=He,tt.minimum=Ke,tt.maximum=xe),super(ie,we,He,tt),this.minimum=Ke,this.maximum=xe}validate(ie){return l.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}function i(ee,ie,we,He){if(typeof ee>"u")return ie;const Ke=g.float(ee,ie);return g.clamp(Ke,we,He)}class g extends p{static clamp(ie,we,He){return ie<we?we:ie>He?He:ie}static float(ie,we){if(typeof ie=="number")return ie;if(typeof ie>"u")return we;const He=parseFloat(ie);return isNaN(He)?we:He}constructor(ie,we,He,Ke,xe){typeof xe<"u"&&(xe.type="number",xe.default=He),super(ie,we,He,xe),this.validationFn=Ke}validate(ie){return this.validationFn(g.float(ie,this.defaultValue))}}class s extends p{static string(ie,we){return typeof ie!="string"?we:ie}constructor(ie,we,He,Ke=void 0){typeof Ke<"u"&&(Ke.type="string",Ke.default=He),super(ie,we,He,Ke)}validate(ie){return s.string(ie,this.defaultValue)}}function c(ee,ie,we,He){return typeof ee!="string"?ie:He&&ee in He?He[ee]:we.indexOf(ee)===-1?ie:ee}class u extends p{constructor(ie,we,He,Ke,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=Ke,xe.default=He),super(ie,we,He,xe),this.c=Ke}validate(ie){return c(ie,this.defaultValue,this.c)}}class D extends a{constructor(ie,we,He,Ke,xe,tt,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=xe,lt.default=Ke),super(ie,we,He,lt),this.c=xe,this.d=tt}validate(ie){return typeof ie!="string"?this.defaultValue:this.c.indexOf(ie)===-1?this.defaultValue:this.d(ie)}}function P(ee){switch(ee){case"none":return v.None;case"keep":return v.Keep;case"brackets":return v.Brackets;case"advanced":return v.Advanced;case"full":return v.Full}}class T extends a{constructor(){super(ye.accessibilitySupport,"accessibilitySupport",S.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate(ie){switch(ie){case"auto":return S.AccessibilitySupport.Unknown;case"off":return S.AccessibilitySupport.Disabled;case"on":return S.AccessibilitySupport.Enabled}return this.defaultValue}compute(ie,we,He){return He===S.AccessibilitySupport.Unknown?ie.accessibilitySupport:He}}class z extends a{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(ye.comments,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:o.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{insertSpace:d(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function k(ee){switch(ee){case"blink":return C.Blink;case"smooth":return C.Smooth;case"phase":return C.Phase;case"expand":return C.Expand;case"solid":return C.Solid}}var q;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(q||(e.TextEditorCursorStyle=q={}));function Y(ee){switch(ee){case q.Line:return"line";case q.Block:return"block";case q.Underline:return"underline";case q.LineThin:return"line-thin";case q.BlockOutline:return"block-outline";case q.UnderlineThin:return"underline-thin"}}function J(ee){switch(ee){case"line":return q.Line;case"block":return q.Block;case"underline":return q.Underline;case"line-thin":return q.LineThin;case"block-outline":return q.BlockOutline;case"underline-thin":return q.UnderlineThin}}class ne extends ${constructor(){super(ye.editorClassName)}compute(ie,we,He){const Ke=["monaco-editor"];return we.get(ye.extraEditorClassName)&&Ke.push(we.get(ye.extraEditorClassName)),ie.extraEditorClassName&&Ke.push(ie.extraEditorClassName),we.get(ye.mouseStyle)==="default"?Ke.push("mouse-default"):we.get(ye.mouseStyle)==="copy"&&Ke.push("mouse-copy"),we.get(ye.showUnused)&&Ke.push("showUnused"),we.get(ye.showDeprecated)&&Ke.push("showDeprecated"),Ke.join(" ")}}class Z extends b{constructor(){super(ye.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(ie,we,He){return He&&ie.emptySelectionClipboard}}class x extends a{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(ye.find,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:o.localize(16,null),included:E.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:o.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{cursorMoveOnType:d(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":c(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":c(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(we.loop,this.defaultValue.loop)}}}class le extends a{constructor(){super(ye.fontLigatures,"fontLigatures",le.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(ie){return typeof ie>"u"?this.defaultValue:typeof ie=="string"?ie==="false"||ie.length===0?le.OFF:ie==="true"?le.ON:ie:ie?le.ON:le.OFF}}e.EditorFontLigatures=le,le.OFF='"liga" off, "calt" off',le.ON='"liga" on, "calt" on';class K extends a{constructor(){super(ye.fontVariations,"fontVariations",K.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate(ie){return typeof ie>"u"?this.defaultValue:typeof ie=="string"?ie==="false"?K.OFF:ie==="true"?K.TRANSLATE:ie:ie?K.TRANSLATE:K.OFF}compute(ie,we,He){return ie.fontInfo.fontVariationSettings}}e.EditorFontVariations=K,K.OFF="normal",K.TRANSLATE="translate";class ae extends ${constructor(){super(ye.fontInfo)}compute(ie,we,He){return ie.fontInfo}}class M extends p{constructor(){super(ye.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate(ie){const we=g.float(ie,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(we,6,100)}compute(ie,we,He){return ie.fontInfo.fontSize}}class B extends a{constructor(){super(ye.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(l.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}B.c=["normal","bold","100","200","300","400","500","600","700","800","900"],B.d=1,B.e=1e3;class re extends a{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(ye.gotoLocation,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:He,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:He,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:He,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:He,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:He,description:o.localize(41,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{multiple:c(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??c(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??c(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??c(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??c(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??c(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends a{constructor(){const ie={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(ye.hover,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:ie.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:o.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ie.hidingDelay,description:o.localize(45,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:o.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{enabled:d(we.enabled,this.defaultValue.enabled),delay:l.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:d(we.sticky,this.defaultValue.sticky),hidingDelay:l.clampedInt(we.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d(we.above,this.defaultValue.above)}}}var pe;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(pe||(e.RenderMinimap=pe={}));class W extends ${constructor(){super(ye.layoutInfo)}compute(ie,we,He){return W.computeLayout(we,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio,glyphMarginDecorationLaneCount:ie.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ie){const we=ie.height/ie.lineHeight,He=Math.floor(ie.paddingTop/ie.lineHeight);let Ke=Math.floor(ie.paddingBottom/ie.lineHeight);ie.scrollBeyondLastLine&&(Ke=Math.max(Ke,we-1));const xe=(He+ie.viewLineCount+Ke)/(ie.pixelRatio*ie.height),tt=Math.floor(ie.viewLineCount/xe);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Ke,desiredRatio:xe,minimapLineCount:tt}}static c(ie,we){const He=ie.outerWidth,Ke=ie.outerHeight,xe=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:pe.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ke};const tt=we.stableMinimapLayoutInput,lt=tt&&ie.outerHeight===tt.outerHeight&&ie.lineHeight===tt.lineHeight&&ie.typicalHalfwidthCharacterWidth===tt.typicalHalfwidthCharacterWidth&&ie.pixelRatio===tt.pixelRatio&&ie.scrollBeyondLastLine===tt.scrollBeyondLastLine&&ie.paddingTop===tt.paddingTop&&ie.paddingBottom===tt.paddingBottom&&ie.minimap.enabled===tt.minimap.enabled&&ie.minimap.side===tt.minimap.side&&ie.minimap.size===tt.minimap.size&&ie.minimap.showSlider===tt.minimap.showSlider&&ie.minimap.renderCharacters===tt.minimap.renderCharacters&&ie.minimap.maxColumn===tt.minimap.maxColumn&&ie.minimap.scale===tt.minimap.scale&&ie.verticalScrollbarWidth===tt.verticalScrollbarWidth&&ie.isViewportWrapping===tt.isViewportWrapping,pt=ie.lineHeight,yt=ie.typicalHalfwidthCharacterWidth,Ht=ie.scrollBeyondLastLine,Mt=ie.minimap.renderCharacters;let dt=xe>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const Et=ie.minimap.maxColumn,vt=ie.minimap.size,Kt=ie.minimap.side,zt=ie.verticalScrollbarWidth,St=ie.viewLineCount,Bt=ie.remainingWidth,Ot=ie.isViewportWrapping,ut=Mt?2:3;let mt=Math.floor(xe*Ke);const bt=mt/xe;let Pt=!1,Xt=!1,Lt=ut*dt,Nt=dt/xe,Ut=1;if(vt==="fill"||vt==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:At,extraLinesBeyondLastLine:tn,desiredRatio:qt,minimapLineCount:Tt}=W.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:Ht,paddingTop:ie.paddingTop,paddingBottom:ie.paddingBottom,height:Ke,lineHeight:pt,pixelRatio:xe});if(St/Tt>1)Pt=!0,Xt=!0,dt=1,Lt=1,Nt=dt/xe;else{let wt=!1,Yt=dt+1;if(vt==="fit"){const It=Math.ceil((At+St+tn)*Lt);Ot&&lt&&Bt<=we.stableFitRemainingWidth?(wt=!0,Yt=we.stableFitMaxMinimapScale):wt=It>mt}if(vt==="fill"||wt){Pt=!0;const It=dt;Lt=Math.min(pt*xe,Math.max(1,Math.floor(1/qt))),Ot&&lt&&Bt<=we.stableFitRemainingWidth&&(Yt=we.stableFitMaxMinimapScale),dt=Math.min(Yt,Math.max(1,Math.floor(Lt/ut))),dt>It&&(Ut=Math.min(2,dt/It)),Nt=dt/xe/Ut,mt=Math.ceil(Math.max(Qt,At+St+tn)*Lt),Ot?(we.stableMinimapLayoutInput=ie,we.stableFitRemainingWidth=Bt,we.stableFitMaxMinimapScale=dt):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const Jt=Math.floor(Et*Nt),Ft=Math.min(Jt,Math.max(0,Math.floor((Bt-zt-2)*Nt/(yt+Nt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(xe*Ft);const kt=Rt/xe;Rt=Math.floor(Rt*Ut);const rn=Mt?pe.Text:pe.Blocks,Wt=Kt==="left"?0:He-Ft-zt;return{renderMinimap:rn,minimapLeft:Wt,minimapWidth:Ft,minimapHeightIsEditorHeight:Pt,minimapIsSampling:Xt,minimapScale:dt,minimapLineHeight:Lt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:mt,minimapCanvasOuterWidth:kt,minimapCanvasOuterHeight:bt}}static computeLayout(ie,we){const He=we.outerWidth|0,Ke=we.outerHeight|0,xe=we.lineHeight|0,tt=we.lineNumbersDigitCount|0,lt=we.typicalHalfwidthCharacterWidth,pt=we.maxDigitWidth,yt=we.pixelRatio,Ht=we.viewLineCount,Mt=ie.get(ye.wordWrapOverride2),dt=Mt==="inherit"?ie.get(ye.wordWrapOverride1):Mt,Et=dt==="inherit"?ie.get(ye.wordWrap):dt,vt=ie.get(ye.wordWrapColumn),Kt=we.isDominatedByLongLines,zt=ie.get(ye.glyphMargin),St=ie.get(ye.lineNumbers).renderType!==Ne.Off,Bt=ie.get(ye.lineNumbersMinChars),Ot=ie.get(ye.scrollBeyondLastLine),ut=ie.get(ye.padding),mt=ie.get(ye.minimap),bt=ie.get(ye.scrollbar),Pt=bt.verticalScrollbarSize,Xt=bt.verticalHasArrows,Lt=bt.arrowSize,Nt=bt.horizontalScrollbarSize,Ut=ie.get(ye.folding),Jt=ie.get(ye.showFoldingControls)!=="never";let Ft=ie.get(ye.lineDecorationsWidth);Ut&&Jt&&(Ft+=16);let Rt=0;if(St){const cn=Math.max(tt,Bt);Rt=Math.round(cn*pt)}let kt=0;zt&&(kt=xe*we.glyphMarginDecorationLaneCount);let rn=0,Wt=rn+kt,Qt=Wt+Rt,At=Qt+Ft;const tn=He-kt-Rt-Ft;let qt=!1,Tt=!1,Vt=-1;dt==="inherit"&&Kt?(qt=!0,Tt=!0):Et==="on"||Et==="bounded"?Tt=!0:Et==="wordWrapColumn"&&(Vt=vt);const wt=W.c({outerWidth:He,outerHeight:Ke,lineHeight:xe,typicalHalfwidthCharacterWidth:lt,pixelRatio:yt,scrollBeyondLastLine:Ot,paddingTop:ut.top,paddingBottom:ut.bottom,minimap:mt,verticalScrollbarWidth:Pt,viewLineCount:Ht,remainingWidth:tn,isViewportWrapping:Tt},we.memory||new w);wt.renderMinimap!==pe.None&&wt.minimapLeft===0&&(rn+=wt.minimapWidth,Wt+=wt.minimapWidth,Qt+=wt.minimapWidth,At+=wt.minimapWidth);const Yt=tn-wt.minimapWidth,It=Math.max(1,Math.floor((Yt-Pt-2)/lt)),sn=Xt?Lt:0;return Tt&&(Vt=Math.max(1,It),Et==="bounded"&&(Vt=Math.min(Vt,vt))),{width:He,height:Ke,glyphMarginLeft:rn,glyphMarginWidth:kt,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:Wt,lineNumbersWidth:Rt,decorationsLeft:Qt,decorationsWidth:Ft,contentLeft:At,contentWidth:Yt,minimap:wt,viewportColumn:It,isWordWrapMinified:qt,isViewportWrapping:Tt,wrappingColumn:Vt,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Nt,overviewRuler:{top:sn,width:Pt,height:Ke-2*sn,right:0}}}}e.EditorLayoutInfoComputer=W;class ue extends a{constructor(){super(ye.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(47,null),o.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(49,null)}})}validate(ie){return c(ie,"simple",["simple","advanced"])}compute(ie,we,He){return we.get(ye.accessibilitySupport)===S.AccessibilitySupport.Enabled?"advanced":He}}var _;(function(ee){ee.Off="off",ee.OnCode="onCode",ee.On="on"})(_||(e.ShowLightbulbIconMode=_={}));class U extends a{constructor(){const ie={enabled:_.On};super(ye.lightbulb,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[_.Off,_.OnCode,_.On],default:ie.enabled,enumDescriptions:[o.localize(50,null),o.localize(51,null),o.localize(52,null)],description:o.localize(53,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:c(ie.enabled,this.defaultValue.enabled,[_.Off,_.OnCode,_.On])}}}class O extends a{constructor(){const ie={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(ye.stickyScroll,"stickyScroll",ie,{"editor.stickyScroll.enabled":{type:"boolean",default:ie.enabled,description:o.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ie.maxLineCount,minimum:1,maximum:20,description:o.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ie.defaultModel,description:o.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ie.scrollWithEditor,description:o.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{enabled:d(we.enabled,this.defaultValue.enabled),maxLineCount:l.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:c(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d(we.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends a{constructor(){const ie={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(ye.inlayHints,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"string",default:ie.enabled,description:o.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(59,null),o.localize(60,null,E.$d?"Ctrl+Option":"Ctrl+Alt"),o.localize(61,null,E.$d?"Ctrl+Option":"Ctrl+Alt"),o.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:o.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:o.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ie.padding,description:o.localize(65,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:c(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:l.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(we.fontFamily,this.defaultValue.fontFamily),padding:d(we.padding,this.defaultValue.padding)}}}class V extends a{constructor(){super(ye.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(ie){return typeof ie=="string"&&/^\d+(\.\d+)?ch$/.test(ie)?-parseFloat(ie.substring(0,ie.length-2)):l.clampedInt(ie,this.defaultValue,0,1e3)}compute(ie,we,He){return He<0?l.clampedInt(-He*ie.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class j extends g{constructor(){super(ye.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>g.clamp(ie,0,150),{markdownDescription:o.localize(66,null)})}compute(ie,we,He){return ie.fontInfo.lineHeight}}class G extends a{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(ye.minimap,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:o.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ie.autohide,description:o.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(69,null),o.localize(70,null),o.localize(71,null)],default:ie.size,description:o.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:o.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:o.localize(74,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:o.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:o.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ie.showRegionSectionHeaders,description:o.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ie.showMarkSectionHeaders,description:o.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ie.sectionHeaderFontSize,description:o.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:ie.sectionHeaderLetterSpacing,description:o.localize(81,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{enabled:d(we.enabled,this.defaultValue.enabled),autohide:d(we.autohide,this.defaultValue.autohide),size:c(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:c(we.side,this.defaultValue.side,["right","left"]),showSlider:c(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(we.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(we.scale,1,1,3),maxColumn:l.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:d(we.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:d(we.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(we.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(we.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function Q(ee){return ee==="ctrlCmd"?E.$d?"metaKey":"ctrlKey":"altKey"}class N extends a{constructor(){super(ye.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(83,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{top:l.clampedInt(we.top,0,0,1e3),bottom:l.clampedInt(we.bottom,0,0,1e3)}}}class H extends a{constructor(){const ie={enabled:!0,cycle:!0};super(ye.parameterHints,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:o.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:o.localize(85,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{enabled:d(we.enabled,this.defaultValue.enabled),cycle:d(we.cycle,this.defaultValue.cycle)}}}class oe extends ${constructor(){super(ye.pixelRatio)}compute(ie,we,He){return ie.pixelRatio}}class fe extends a{constructor(){super(ye.placeholder,"placeholder",void 0)}validate(ie){return typeof ie>"u"?this.defaultValue:typeof ie=="string"?ie:this.defaultValue}}class Ee extends a{constructor(){const ie={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(86,null),o.localize(87,null),o.localize(88,null)]}];super(ye.quickSuggestions,"quickSuggestions",ie,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:ie.strings,description:o.localize(89,null)},comments:{anyOf:we,default:ie.comments,description:o.localize(90,null)},other:{anyOf:we,default:ie.other,description:o.localize(91,null)}},default:ie,markdownDescription:o.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=ie}validate(ie){if(typeof ie=="boolean"){const yt=ie?"on":"off";return{comments:yt,strings:yt,other:yt}}if(!ie||typeof ie!="object")return this.defaultValue;const{other:we,comments:He,strings:Ke}=ie,xe=["on","inline","off"];let tt,lt,pt;return typeof we=="boolean"?tt=we?"on":"off":tt=c(we,this.defaultValue.other,xe),typeof He=="boolean"?lt=He?"on":"off":lt=c(He,this.defaultValue.comments,xe),typeof Ke=="boolean"?pt=Ke?"on":"off":pt=c(Ke,this.defaultValue.strings,xe),{other:tt,comments:lt,strings:pt}}}var Ne;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(Ne||(e.RenderLineNumbersType=Ne={}));class de extends a{constructor(){super(ye.lineNumbers,"lineNumbers",{renderType:Ne.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(93,null),o.localize(94,null),o.localize(95,null),o.localize(96,null)],default:"on",description:o.localize(97,null)})}validate(ie){let we=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof ie<"u"&&(typeof ie=="function"?(we=Ne.Custom,He=ie):ie==="interval"?we=Ne.Interval:ie==="relative"?we=Ne.Relative:ie==="on"?we=Ne.On:we=Ne.Off),{renderType:we,renderFn:He}}}function $e(ee){const ie=ee.get(ye.renderValidationDecorations);return ie==="editable"?ee.get(ye.readOnly):ie!=="on"}class Re extends a{constructor(){const ie=[],we={type:"number",description:o.localize(98,null)};super(ye.rulers,"rulers",ie,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:o.localize(99,null),format:"color-hex"}}}]},default:ie,description:o.localize(100,null)})}validate(ie){if(Array.isArray(ie)){const we=[];for(const He of ie)if(typeof He=="number")we.push({column:l.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ke=He;we.push({column:l.clampedInt(Ke.column,0,0,1e4),color:Ke.color})}return we.sort((He,Ke)=>He.column-Ke.column),we}return this.defaultValue}}class Ce extends a{constructor(){super(ye.readOnlyMessage,"readOnlyMessage",void 0)}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:ie}}function me(ee,ie){if(typeof ee!="string")return ie;switch(ee){case"hidden":return I.ScrollbarVisibility.Hidden;case"visible":return I.ScrollbarVisibility.Visible;default:return I.ScrollbarVisibility.Auto}}class Ie extends a{constructor(){const ie={vertical:I.ScrollbarVisibility.Auto,horizontal:I.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(ye.scrollbar,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(101,null),o.localize(102,null),o.localize(103,null)],default:"auto",description:o.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(105,null),o.localize(106,null),o.localize(107,null)],default:"auto",description:o.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:o.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:o.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:o.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ie.ignoreHorizontalScrollbarInContentHeight,description:o.localize(112,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie,He=l.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ke=l.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:me(we.vertical,this.defaultValue.vertical),horizontal:me(we.horizontal,this.defaultValue.horizontal),useShadows:d(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:l.clampedInt(we.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ke,verticalSliderSize:l.clampedInt(we.verticalSliderSize,Ke,0,1e3),scrollByPage:d(we.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d(we.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ae extends a{constructor(){const ie={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(ye.unicodeHighlighting,"unicodeHighlight",ie,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.nonBasicASCII,description:o.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ie.invisibleCharacters,description:o.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ie.ambiguousCharacters,description:o.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeComments,description:o.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeStrings,description:o.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ie.allowedCharacters,description:o.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ie.allowedLocales,description:o.localize(119,null)}})}applyUpdate(ie,we){let He=!1;we.allowedCharacters&&ie&&(r.$jo(ie.allowedCharacters,we.allowedCharacters)||(ie={...ie,allowedCharacters:we.allowedCharacters},He=!0)),we.allowedLocales&&ie&&(r.$jo(ie.allowedLocales,we.allowedLocales)||(ie={...ie,allowedLocales:we.allowedLocales},He=!0));const Ke=super.applyUpdate(ie,we);return He?new h(Ke.newValue,!0):Ke}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{nonBasicASCII:Ye(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ye(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ye(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ie.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ie.allowedLocales,this.defaultValue.allowedLocales)}}c(ie,we){if(typeof ie!="object"||!ie)return we;const He={};for(const[Ke,xe]of Object.entries(ie))xe===!0&&(He[Ke]=!0);return He}}class Me extends a{constructor(){const ie={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(ye.inlineSuggest,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:o.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ie.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(121,null),o.localize(122,null),o.localize(123,null)],description:o.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ie.suppressSuggestions,description:o.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ie.fontFamily,description:o.localize(126,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{enabled:d(we.enabled,this.defaultValue.enabled),mode:c(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:c(we.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:d(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d(we.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:s.string(we.fontFamily,this.defaultValue.fontFamily)}}}class qe extends a{constructor(){const ie={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(ye.inlineEdit,"experimentalInlineEdit",ie,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ie.enabled,description:o.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ie.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(128,null),o.localize(129,null),o.localize(130,null)],description:o.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ie.fontFamily,description:o.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ie.backgroundColoring,description:o.localize(133,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{enabled:d(we.enabled,this.defaultValue.enabled),showToolbar:c(we.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:s.string(we.fontFamily,this.defaultValue.fontFamily),keepOnBlur:d(we.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:d(we.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Qe extends a{constructor(){const ie={enabled:A.$kt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$kt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(ye.bracketPairColorization,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,markdownDescription:o.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ie.independentColorPoolPerBracketType,description:o.localize(135,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{enabled:d(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ge extends a{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(ye.guides,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(136,null),o.localize(137,null),o.localize(138,null)],default:ie.bracketPairs,description:o.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(140,null),o.localize(141,null),o.localize(142,null)],default:ie.bracketPairsHorizontal,description:o.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:o.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:o.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(146,null),o.localize(147,null),o.localize(148,null)],default:ie.highlightActiveIndentation,description:o.localize(149,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{bracketPairs:Ye(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ye(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ye(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ye(ee,ie,we){const He=we.indexOf(ee);return He===-1?ie:we[He]}class We extends a{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(ye.suggest,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(150,null),o.localize(151,null)],default:ie.insertMode,description:o.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:o.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:o.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:o.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(156,null),o.localize(157,null),o.localize(158,null),o.localize(159,null)],default:ie.selectionMode,markdownDescription:o.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:o.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:o.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:o.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:o.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:o.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(197,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{insertMode:c(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:c(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(we.showIcons,this.defaultValue.showIcons),showStatusBar:d(we.showStatusBar,this.defaultValue.showStatusBar),preview:d(we.preview,this.defaultValue.preview),previewMode:c(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(we.showMethods,this.defaultValue.showMethods),showFunctions:d(we.showFunctions,this.defaultValue.showFunctions),showConstructors:d(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(we.showFields,this.defaultValue.showFields),showVariables:d(we.showVariables,this.defaultValue.showVariables),showClasses:d(we.showClasses,this.defaultValue.showClasses),showStructs:d(we.showStructs,this.defaultValue.showStructs),showInterfaces:d(we.showInterfaces,this.defaultValue.showInterfaces),showModules:d(we.showModules,this.defaultValue.showModules),showProperties:d(we.showProperties,this.defaultValue.showProperties),showEvents:d(we.showEvents,this.defaultValue.showEvents),showOperators:d(we.showOperators,this.defaultValue.showOperators),showUnits:d(we.showUnits,this.defaultValue.showUnits),showValues:d(we.showValues,this.defaultValue.showValues),showConstants:d(we.showConstants,this.defaultValue.showConstants),showEnums:d(we.showEnums,this.defaultValue.showEnums),showEnumMembers:d(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(we.showKeywords,this.defaultValue.showKeywords),showWords:d(we.showWords,this.defaultValue.showWords),showColors:d(we.showColors,this.defaultValue.showColors),showFiles:d(we.showFiles,this.defaultValue.showFiles),showReferences:d(we.showReferences,this.defaultValue.showReferences),showFolders:d(we.showFolders,this.defaultValue.showFolders),showTypeParameters:d(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(we.showSnippets,this.defaultValue.showSnippets),showUsers:d(we.showUsers,this.defaultValue.showUsers),showIssues:d(we.showIssues,this.defaultValue.showIssues)}}}class rt extends a{constructor(){super(ye.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:o.localize(199,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(ie.selectSubwords,this.defaultValue.selectSubwords)}}}class at extends a{constructor(){const ie=[];super(ye.wordSegmenterLocales,"wordSegmenterLocales",ie,{anyOf:[{description:o.localize(200,null),type:"string"},{description:o.localize(201,null),type:"array",items:{type:"string"}}]})}validate(ie){if(typeof ie=="string"&&(ie=[ie]),Array.isArray(ie)){const we=[];for(const He of ie)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&we.push(He)}catch{}return we}return this.defaultValue}}var nt;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class ct extends a{constructor(){super(ye.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(202,null),o.localize(203,null),o.localize(204,null),o.localize(205,null)],description:o.localize(206,null),default:"same"}})}validate(ie){switch(ie){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(ie,we,He){return we.get(ye.accessibilitySupport)===S.AccessibilitySupport.Enabled?nt.None:He}}class it extends ${constructor(){super(ye.wrappingInfo)}compute(ie,we,He){const Ke=we.get(ye.layoutInfo);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Ke.isWordWrapMinified,isViewportWrapping:Ke.isViewportWrapping,wrappingColumn:Ke.wrappingColumn}}}class _e extends a{constructor(){const ie={enabled:!0,showDropSelector:"afterDrop"};super(ye.dropIntoEditor,"dropIntoEditor",ie,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ie.enabled,markdownDescription:o.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(209,null),o.localize(210,null)],default:"afterDrop"}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{enabled:d(we.enabled,this.defaultValue.enabled),showDropSelector:c(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Je extends a{constructor(){const ie={enabled:!0,showPasteSelector:"afterPaste"};super(ye.pasteAs,"pasteAs",ie,{"editor.pasteAs.enabled":{type:"boolean",default:ie.enabled,markdownDescription:o.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:o.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[o.localize(213,null),o.localize(214,null)],default:"afterPaste"}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const we=ie;return{enabled:d(we.enabled,this.defaultValue.enabled),showPasteSelector:c(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",be="Menlo, Monaco, 'Courier New', monospace",Le="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:E.$d?be:E.$e?Le:et,fontWeight:"normal",fontSize:E.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ve(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var ye;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.inlineEdit=63]="inlineEdit",ee[ee.letterSpacing=64]="letterSpacing",ee[ee.lightbulb=65]="lightbulb",ee[ee.lineDecorationsWidth=66]="lineDecorationsWidth",ee[ee.lineHeight=67]="lineHeight",ee[ee.lineNumbers=68]="lineNumbers",ee[ee.lineNumbersMinChars=69]="lineNumbersMinChars",ee[ee.linkedEditing=70]="linkedEditing",ee[ee.links=71]="links",ee[ee.matchBrackets=72]="matchBrackets",ee[ee.minimap=73]="minimap",ee[ee.mouseStyle=74]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=76]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=78]="multiCursorModifier",ee[ee.multiCursorPaste=79]="multiCursorPaste",ee[ee.multiCursorLimit=80]="multiCursorLimit",ee[ee.occurrencesHighlight=81]="occurrencesHighlight",ee[ee.overviewRulerBorder=82]="overviewRulerBorder",ee[ee.overviewRulerLanes=83]="overviewRulerLanes",ee[ee.padding=84]="padding",ee[ee.pasteAs=85]="pasteAs",ee[ee.parameterHints=86]="parameterHints",ee[ee.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ee[ee.placeholder=88]="placeholder",ee[ee.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=90]="quickSuggestions",ee[ee.quickSuggestionsDelay=91]="quickSuggestionsDelay",ee[ee.readOnly=92]="readOnly",ee[ee.readOnlyMessage=93]="readOnlyMessage",ee[ee.renameOnType=94]="renameOnType",ee[ee.renderControlCharacters=95]="renderControlCharacters",ee[ee.renderFinalNewline=96]="renderFinalNewline",ee[ee.renderLineHighlight=97]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=99]="renderValidationDecorations",ee[ee.renderWhitespace=100]="renderWhitespace",ee[ee.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ee[ee.roundedSelection=102]="roundedSelection",ee[ee.rulers=103]="rulers",ee[ee.scrollbar=104]="scrollbar",ee[ee.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=106]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=107]="scrollPredominantAxis",ee[ee.selectionClipboard=108]="selectionClipboard",ee[ee.selectionHighlight=109]="selectionHighlight",ee[ee.selectOnLineNumbers=110]="selectOnLineNumbers",ee[ee.showFoldingControls=111]="showFoldingControls",ee[ee.showUnused=112]="showUnused",ee[ee.snippetSuggestions=113]="snippetSuggestions",ee[ee.smartSelect=114]="smartSelect",ee[ee.smoothScrolling=115]="smoothScrolling",ee[ee.stickyScroll=116]="stickyScroll",ee[ee.stickyTabStops=117]="stickyTabStops",ee[ee.stopRenderingLineAfter=118]="stopRenderingLineAfter",ee[ee.suggest=119]="suggest",ee[ee.suggestFontSize=120]="suggestFontSize",ee[ee.suggestLineHeight=121]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ee[ee.suggestSelection=123]="suggestSelection",ee[ee.tabCompletion=124]="tabCompletion",ee[ee.tabIndex=125]="tabIndex",ee[ee.unicodeHighlighting=126]="unicodeHighlighting",ee[ee.unusualLineTerminators=127]="unusualLineTerminators",ee[ee.useShadowDOM=128]="useShadowDOM",ee[ee.useTabStops=129]="useTabStops",ee[ee.wordBreak=130]="wordBreak",ee[ee.wordSegmenterLocales=131]="wordSegmenterLocales",ee[ee.wordSeparators=132]="wordSeparators",ee[ee.wordWrap=133]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=136]="wordWrapColumn",ee[ee.wordWrapOverride1=137]="wordWrapOverride1",ee[ee.wordWrapOverride2=138]="wordWrapOverride2",ee[ee.wrappingIndent=139]="wrappingIndent",ee[ee.wrappingStrategy=140]="wrappingStrategy",ee[ee.showDeprecated=141]="showDeprecated",ee[ee.inlayHints=142]="inlayHints",ee[ee.editorClassName=143]="editorClassName",ee[ee.pixelRatio=144]="pixelRatio",ee[ee.tabFocusMode=145]="tabFocusMode",ee[ee.layoutInfo=146]="layoutInfo",ee[ee.wrappingInfo=147]="wrappingInfo",ee[ee.defaultColorDecorators=148]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(ye||(e.EditorOption=ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new b(ye.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(215,null)})),acceptSuggestionOnEnter:ve(new u(ye.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(216,null),""],markdownDescription:o.localize(217,null)})),accessibilitySupport:ve(new T),accessibilityPageSize:ve(new l(ye.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(218,null),tags:["accessibility"]})),ariaLabel:ve(new s(ye.ariaLabel,"ariaLabel",o.localize(219,null))),ariaRequired:ve(new b(ye.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ve(new b(ye.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:o.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:ve(new u(ye.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(221,null),o.localize(222,null),""],description:o.localize(223,null)})),autoClosingComments:ve(new u(ye.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(224,null),o.localize(225,null),""],description:o.localize(226,null)})),autoClosingDelete:ve(new u(ye.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(227,null),""],description:o.localize(228,null)})),autoClosingOvertype:ve(new u(ye.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(229,null),""],description:o.localize(230,null)})),autoClosingQuotes:ve(new u(ye.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(231,null),o.localize(232,null),""],description:o.localize(233,null)})),autoIndent:ve(new D(ye.autoIndent,"autoIndent",v.Full,"full",["none","keep","brackets","advanced","full"],P,{enumDescriptions:[o.localize(234,null),o.localize(235,null),o.localize(236,null),o.localize(237,null),o.localize(238,null)],description:o.localize(239,null)})),automaticLayout:ve(new b(ye.automaticLayout,"automaticLayout",!1)),autoSurround:ve(new u(ye.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(240,null),o.localize(241,null),o.localize(242,null),""],description:o.localize(243,null)})),bracketPairColorization:ve(new Qe),bracketPairGuides:ve(new Ge),stickyTabStops:ve(new b(ye.stickyTabStops,"stickyTabStops",!1,{description:o.localize(244,null)})),codeLens:ve(new b(ye.codeLens,"codeLens",!0,{description:o.localize(245,null)})),codeLensFontFamily:ve(new s(ye.codeLensFontFamily,"codeLensFontFamily","",{description:o.localize(246,null)})),codeLensFontSize:ve(new l(ye.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(247,null)})),colorDecorators:ve(new b(ye.colorDecorators,"colorDecorators",!0,{description:o.localize(248,null)})),colorDecoratorActivatedOn:ve(new u(ye.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[o.localize(249,null),o.localize(250,null),o.localize(251,null)],description:o.localize(252,null)})),colorDecoratorsLimit:ve(new l(ye.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(253,null)})),columnSelection:ve(new b(ye.columnSelection,"columnSelection",!1,{description:o.localize(254,null)})),comments:ve(new z),contextmenu:ve(new b(ye.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new b(ye.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:o.localize(255,null)})),cursorBlinking:ve(new D(ye.cursorBlinking,"cursorBlinking",C.Blink,"blink",["blink","smooth","phase","expand","solid"],k,{description:o.localize(256,null)})),cursorSmoothCaretAnimation:ve(new u(ye.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(257,null),o.localize(258,null),o.localize(259,null)],description:o.localize(260,null)})),cursorStyle:ve(new D(ye.cursorStyle,"cursorStyle",q.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],J,{description:o.localize(261,null)})),cursorSurroundingLines:ve(new l(ye.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(262,null)})),cursorSurroundingLinesStyle:ve(new u(ye.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(263,null),o.localize(264,null)],markdownDescription:o.localize(265,null)})),cursorWidth:ve(new l(ye.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(266,null)})),disableLayerHinting:ve(new b(ye.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new b(ye.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new b(ye.domReadOnly,"domReadOnly",!1)),dragAndDrop:ve(new b(ye.dragAndDrop,"dragAndDrop",!0,{description:o.localize(267,null)})),emptySelectionClipboard:ve(new Z),dropIntoEditor:ve(new _e),stickyScroll:ve(new O),experimentalWhitespaceRendering:ve(new u(ye.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(268,null),o.localize(269,null),o.localize(270,null)],description:o.localize(271,null)})),extraEditorClassName:ve(new s(ye.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:ve(new g(ye.fastScrollSensitivity,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:o.localize(272,null)})),find:ve(new x),fixedOverflowWidgets:ve(new b(ye.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:ve(new b(ye.folding,"folding",!0,{description:o.localize(273,null)})),foldingStrategy:ve(new u(ye.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(274,null),o.localize(275,null)],description:o.localize(276,null)})),foldingHighlight:ve(new b(ye.foldingHighlight,"foldingHighlight",!0,{description:o.localize(277,null)})),foldingImportsByDefault:ve(new b(ye.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:o.localize(278,null)})),foldingMaximumRegions:ve(new l(ye.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(279,null)})),unfoldOnClickAfterEndOfLine:ve(new b(ye.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(280,null)})),fontFamily:ve(new s(ye.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(281,null)})),fontInfo:ve(new ae),fontLigatures2:ve(new le),fontSize:ve(new M),fontWeight:ve(new B),fontVariations:ve(new K),formatOnPaste:ve(new b(ye.formatOnPaste,"formatOnPaste",!1,{description:o.localize(282,null)})),formatOnType:ve(new b(ye.formatOnType,"formatOnType",!1,{description:o.localize(283,null)})),glyphMargin:ve(new b(ye.glyphMargin,"glyphMargin",!0,{description:o.localize(284,null)})),gotoLocation:ve(new re),hideCursorInOverviewRuler:ve(new b(ye.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:o.localize(285,null)})),hover:ve(new ce),inDiffEditor:ve(new b(ye.inDiffEditor,"inDiffEditor",!1)),letterSpacing:ve(new g(ye.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>g.clamp(ee,-5,20),{description:o.localize(286,null)})),lightbulb:ve(new U),lineDecorationsWidth:ve(new V),lineHeight:ve(new j),lineNumbers:ve(new de),lineNumbersMinChars:ve(new l(ye.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new b(ye.linkedEditing,"linkedEditing",!1,{description:o.localize(287,null)})),links:ve(new b(ye.links,"links",!0,{description:o.localize(288,null)})),matchBrackets:ve(new u(ye.matchBrackets,"matchBrackets","always",["always","near","never"],{description:o.localize(289,null)})),minimap:ve(new G),mouseStyle:ve(new u(ye.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new g(ye.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:o.localize(290,null)})),mouseWheelZoom:ve(new b(ye.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:E.$d?o.localize(291,null):o.localize(292,null)})),multiCursorMergeOverlapping:ve(new b(ye.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:o.localize(293,null)})),multiCursorModifier:ve(new D(ye.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[o.localize(294,null),o.localize(295,null)],markdownDescription:o.localize(296,null)})),multiCursorPaste:ve(new u(ye.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(297,null),o.localize(298,null)],markdownDescription:o.localize(299,null)})),multiCursorLimit:ve(new l(ye.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(300,null)})),occurrencesHighlight:ve(new u(ye.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[o.localize(301,null),o.localize(302,null),o.localize(303,null)],markdownDescription:o.localize(304,null)})),overviewRulerBorder:ve(new b(ye.overviewRulerBorder,"overviewRulerBorder",!0,{description:o.localize(305,null)})),overviewRulerLanes:ve(new l(ye.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:ve(new N),pasteAs:ve(new Je),parameterHints:ve(new H),peekWidgetDefaultFocus:ve(new u(ye.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(306,null),o.localize(307,null)],description:o.localize(308,null)})),placeholder:ve(new fe),definitionLinkOpensInPeek:ve(new b(ye.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:o.localize(309,null)})),quickSuggestions:ve(new Ee),quickSuggestionsDelay:ve(new l(ye.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(310,null)})),readOnly:ve(new b(ye.readOnly,"readOnly",!1)),readOnlyMessage:ve(new Ce),renameOnType:ve(new b(ye.renameOnType,"renameOnType",!1,{description:o.localize(311,null),markdownDeprecationMessage:o.localize(312,null)})),renderControlCharacters:ve(new b(ye.renderControlCharacters,"renderControlCharacters",!0,{description:o.localize(313,null),restricted:!0})),renderFinalNewline:ve(new u(ye.renderFinalNewline,"renderFinalNewline",E.$e?"dimmed":"on",["off","on","dimmed"],{description:o.localize(314,null)})),renderLineHighlight:ve(new u(ye.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(315,null)],description:o.localize(316,null)})),renderLineHighlightOnlyWhenFocus:ve(new b(ye.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(317,null)})),renderValidationDecorations:ve(new u(ye.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new u(ye.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(318,null),o.localize(319,null),o.localize(320,null),""],description:o.localize(321,null)})),revealHorizontalRightPadding:ve(new l(ye.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ve(new b(ye.roundedSelection,"roundedSelection",!0,{description:o.localize(322,null)})),rulers:ve(new Re),scrollbar:ve(new Ie),scrollBeyondLastColumn:ve(new l(ye.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(323,null)})),scrollBeyondLastLine:ve(new b(ye.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:o.localize(324,null)})),scrollPredominantAxis:ve(new b(ye.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:o.localize(325,null)})),selectionClipboard:ve(new b(ye.selectionClipboard,"selectionClipboard",!0,{description:o.localize(326,null),included:E.$e})),selectionHighlight:ve(new b(ye.selectionHighlight,"selectionHighlight",!0,{description:o.localize(327,null)})),selectOnLineNumbers:ve(new b(ye.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:ve(new u(ye.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(328,null),o.localize(329,null),o.localize(330,null)],description:o.localize(331,null)})),showUnused:ve(new b(ye.showUnused,"showUnused",!0,{description:o.localize(332,null)})),showDeprecated:ve(new b(ye.showDeprecated,"showDeprecated",!0,{description:o.localize(333,null)})),inlayHints:ve(new te),snippetSuggestions:ve(new u(ye.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(334,null),o.localize(335,null),o.localize(336,null),o.localize(337,null)],description:o.localize(338,null)})),smartSelect:ve(new rt),smoothScrolling:ve(new b(ye.smoothScrolling,"smoothScrolling",!1,{description:o.localize(339,null)})),stopRenderingLineAfter:ve(new l(ye.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:ve(new We),inlineSuggest:ve(new Me),inlineEdit:ve(new qe),inlineCompletionsAccessibilityVerbose:ve(new b(ye.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:o.localize(340,null)})),suggestFontSize:ve(new l(ye.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ve(new l(ye.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ve(new b(ye.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:o.localize(343,null)})),suggestSelection:ve(new u(ye.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(344,null),o.localize(345,null),o.localize(346,null)],description:o.localize(347,null)})),tabCompletion:ve(new u(ye.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(348,null),o.localize(349,null),o.localize(350,null)],description:o.localize(351,null)})),tabIndex:ve(new l(ye.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:ve(new Ae),unusualLineTerminators:ve(new u(ye.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(352,null),o.localize(353,null),o.localize(354,null)],description:o.localize(355,null)})),useShadowDOM:ve(new b(ye.useShadowDOM,"useShadowDOM",!0)),useTabStops:ve(new b(ye.useTabStops,"useTabStops",!0,{description:o.localize(356,null)})),wordBreak:ve(new u(ye.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(357,null),o.localize(358,null)],description:o.localize(359,null)})),wordSegmenterLocales:ve(new at),wordSeparators:ve(new s(ye.wordSeparators,"wordSeparators",y.$lt,{description:o.localize(360,null)})),wordWrap:ve(new u(ye.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(361,null),o.localize(362,null),o.localize(363,null),o.localize(364,null)],description:o.localize(365,null)})),wordWrapBreakAfterCharacters:ve(new s(ye.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new s(ye.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new l(ye.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(366,null)})),wordWrapOverride1:ve(new u(ye.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new u(ye.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ve(new ne),defaultColorDecorators:ve(new b(ye.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:o.localize(367,null)})),pixelRatio:ve(new oe),tabFocusMode:ve(new b(ye.tabFocusMode,"tabFocusMode",!1,{markdownDescription:o.localize(368,null)})),layoutInfo:ve(new W),wrappingInfo:ve(new it),wrappingIndent:ve(new ct),wrappingStrategy:ve(new ue)}}),define(Se[249],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Tm=e.ID=void 0,e.$Um=r,e.ID="diagnosticsService",e.$Tm=(0,n.$Gi)(e.ID);function r(I){return!!I.hostName&&!!I.errorMessage}class E{async getPerformanceInfo(R,A){return{}}async getSystemInfo(R,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,A){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.$Vm=E}),define(Se[88],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0,e.$1o=(0,n.$Gi)("downloadService")}),define(Se[28],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,n.$Gi)("environmentService"),e.$Oi=(0,n.$Hi)(e.$Ni)}),define(Se[16],ke([1,0,69,9,17,11,4,215,5,3,13,65]),function(se,e,n,r,E,I,R,A,y,o,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=f,e.$cl=m,e.$dl=p,e.$el=d,e.$fl=b,e.$gl=t,e.$hl=l,e.$il=i,e.$jl=g,e.$kl=s,e.$ll=c,e.$nl=P,e.$ol=T,e.$pl=z,e.$ql=C,e.$rl=k,e.$ul=Z,e.$Gl=B,e.$Hl=re,e.$Jl=pe,e.$al=(0,y.$Gi)("fileService");function f(W){return W.create===!0}var w;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var a;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var h;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function m(W){const ue=W;return!!ue&&typeof ue.onDidChange=="function"}var $;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function p(W){return!!(W.capabilities&$.FileReadWrite)}function d(W){return!!(W.capabilities&$.FileFolderCopy)}function b(W){return!!(W.capabilities&$.FileClone)}function t(W){return!!(W.capabilities&$.FileOpenReadWriteClose)}function l(W){return!!(W.capabilities&$.FileReadStream)}function i(W){return p(W)?!!(W.capabilities&$.FileAtomicRead):!1}function g(W){return p(W)?!!(W.capabilities&$.FileAtomicWrite):!1}function s(W){return!!(W.capabilities&$.FileAtomicDelete)}function c(W){return!!(W.capabilities&$.Readonly)}var u;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class D extends Error{static create(ue,_){const U=new D(ue.toString(),_);return z(U,_),U}constructor(ue,_){super(ue),this.code=_}}e.$ml=D;function P(W,ue){return D.create(W,ue)}function T(W){return W||P((0,A.localize)(0,null),u.Unknown)}function z(W,ue){return W.name=ue?`${ue} (FileSystemError)`:"FileSystemError",W}function C(W){if(!W)return u.Unknown;if(W instanceof D)return W.code;const ue=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ue)return u.Unknown;switch(ue[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function k(W){if(W instanceof x)return W.fileOperationResult;switch(C(W)){case u.FileNotFound:return ae.FILE_NOT_FOUND;case u.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case u.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case u.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case u.NoPermissions:return ae.FILE_PERMISSION_DENIED;case u.FileExists:return ae.FILE_MOVE_CONFLICT;case u.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var q;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(q||(e.FileOperation=q={}));class Y{constructor(ue,_,U){this.resource=ue,this.operation=_,this.target=U}isOperation(ue){return this.operation===ue}}e.$sl=Y;var J;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class ne{constructor(ue,_){this.c=_,this.b=void 0,this.d=new v.$X(()=>{const U=n.$Mi.forUris(()=>this.c);return U.fill(this.rawAdded.map(O=>[O,!0])),U}),this.f=new v.$X(()=>{const U=n.$Mi.forUris(()=>this.c);return U.fill(this.rawUpdated.map(O=>[O,!0])),U}),this.g=new v.$X(()=>{const U=n.$Mi.forUris(()=>this.c);return U.fill(this.rawDeleted.map(O=>[O,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of ue){switch(U.type){case J.ADDED:this.rawAdded.push(U.resource);break;case J.UPDATED:this.rawUpdated.push(U.resource);break;case J.DELETED:this.rawDeleted.push(U.resource);break}this.b!==ne.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=ne.a):this.b!==void 0&&(this.b=ne.a))}}contains(ue,..._){return this.h(ue,{includeChildren:!1},..._)}affects(ue,..._){return this.h(ue,{includeChildren:!0},..._)}h(ue,_,...U){if(!ue)return!1;const O=U.length>0;return!!((!O||U.includes(J.ADDED))&&(this.d.value.get(ue)||_.includeChildren&&this.d.value.findSuperstr(ue))||(!O||U.includes(J.UPDATED))&&(this.f.value.get(ue)||_.includeChildren&&this.f.value.findSuperstr(ue))||(!O||U.includes(J.DELETED))&&(this.g.value.findSubstr(ue)||_.includeChildren&&this.g.value.findSuperstr(ue)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ue){return this.b===ue}hasCorrelation(){return typeof this.b=="number"}}e.$tl=ne,ne.a=null;function Z(W,ue,_){return!W||!ue||W===ue||ue.length>W.length?!1:(ue.charAt(ue.length-1)!==r.sep&&(ue+=r.sep),_?(0,E.$If)(W,ue):W.indexOf(ue)===0)}class x extends Error{constructor(ue,_,U){super(ue),this.fileOperationResult=_,this.options=U}}e.$vl=x;class le extends x{constructor(ue,_,U,O){super(ue,_,O),this.fileOperationResult=_,this.size=U}}e.$wl=le;class K extends x{constructor(ue,_,U){super(ue,ae.FILE_NOT_MODIFIED_SINCE,U),this.stat=_}}e.$xl=K;var ae;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var M;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(M||(e.FileKind=M={})),e.$Fl="";function B(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function re(W,ue){if(!ue.hasProvider(R.URI.from({scheme:W.scheme})))return new Promise(_=>{const U=ue.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===W.scheme&&O.added&&(U.dispose(),_())})})}class ce{static formatSize(ue){return(0,I.$kg)(ue)||(ue=0),ue<ce.KB?(0,A.localize)(1,null,ue.toFixed(0)):ue<ce.MB?(0,A.localize)(2,null,(ue/ce.KB).toFixed(2)):ue<ce.GB?(0,A.localize)(3,null,(ue/ce.MB).toFixed(2)):ue<ce.TB?(0,A.localize)(4,null,(ue/ce.GB).toFixed(2)):(0,A.localize)(5,null,(ue/ce.TB).toFixed(2))}}e.$Il=ce,ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB;function pe(W){const ue=typeof W=="string"||W?.scheme===S.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===S.Schemas.file?1024*ce.MB:ue?10*ce.MB:o.$i?50*ce.MB:1024*ce.MB}}),define(Se[122],ke([1,0,15,10,216,16]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=R;async function R(S,v,f,w,a,h){let m;try{await A(S,v,f,w,a,h)}catch($){m=$}finally{m&&a.errorTransformer&&(m=a.errorTransformer(m)),typeof m<"u"&&f.error(m),f.end()}}async function A(S,v,f,w,a,h){y(h);const m=await S.open(v,{create:!1});try{y(h);let $=0,p=0,d=a&&typeof a.length=="number"?a.length:void 0,b=n.$Pe.alloc(Math.min(a.bufferSize,typeof d=="number"?d:a.bufferSize)),t=a&&typeof a.position=="number"?a.position:0,l=0;do p=await S.read(m,t,b.buffer,l,b.byteLength-l),t+=p,l+=p,$+=p,typeof d=="number"&&(d-=p),l===b.byteLength&&(await f.write(w(b)),b=n.$Pe.alloc(Math.min(a.bufferSize,typeof d=="number"?d:a.bufferSize)),l=0);while(p>0&&(typeof d!="number"||d>0)&&y(h)&&o($,a));if(l>0){let i=l;typeof d=="number"&&(i=Math.min(l,d)),f.write(w(b.slice(0,i)))}}catch($){throw(0,I.$ol)($)}finally{await S.close(m)}}function y(S){if(S.isCancellationRequested)throw(0,r.$9)();return!0}function o(S,v){if(typeof v?.limits?.size=="number"&&S>v.limits.size)throw(0,I.$nl)((0,E.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[52],ke([1,0,83,2,9,3,4,16]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0,e.$3q=y,e.$4q=o,e.$8q=w,e.$9q=a,e.$0q=h,e.$$q=m,e.$_q=p,e.$ar=d;function y(b){return typeof b.correlationId=="number"}function o(b){return b.recursive===!0}class S extends r.$Xc{constructor(t,l,i,g){super(),this.h=t,this.j=l,this.m=i,this.n=g,this.c=this.B(new r.$Yc),this.f=void 0,this.g=0}s(){const t=new r.$Wc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(l=>this.h(l))),t.add(this.b.onDidLogMessage(l=>this.j(l))),t.add(this.b.onDidError(l=>this.t(l.error,l.request)))}t(t,l){this.u(t,l)?this.g<S.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,l){return!(!this.n.restartOnError||l||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$5q=S,S.a=5;class v extends S{constructor(t,l,i){super(t,l,i,{type:"node.js",restartOnError:!1})}}e.$6q=v;class f extends S{constructor(t,l,i){super(t,l,i,{type:"universal",restartOnError:!0})}}e.$7q=f;function w(b){return b.map(t=>({type:t.type,resource:R.URI.revive(t.resource),cId:t.cId}))}function a(b){const t=new $;for(const l of b)t.processEvent(l);return t.coalesce()}function h(b,t){return typeof t=="string"&&!t.startsWith(n.$wk)&&!(0,E.$lc)(t)?{base:b,pattern:t}:t}function m(b,t){const l=[];for(const i of t)l.push((0,n.$Ak)(h(b,i)));return l}class ${constructor(){this.a=new Set,this.b=new Map}c(t){return I.$e?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const l=this.b.get(this.c(t));let i=!1;if(l){const g=l.type,s=t.type;l.resource.fsPath!==t.resource.fsPath&&(t.type===A.FileChangeType.DELETED||t.type===A.FileChangeType.ADDED)?i=!0:g===A.FileChangeType.ADDED&&s===A.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(l)):g===A.FileChangeType.DELETED&&s===A.FileChangeType.ADDED?l.type=A.FileChangeType.UPDATED:g===A.FileChangeType.ADDED&&s===A.FileChangeType.UPDATED||(l.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],l=[];return Array.from(this.a).filter(i=>i.type!==A.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,g)=>i.resource.fsPath.length-g.resource.fsPath.length).filter(i=>l.some(g=>(0,A.$ul)(i.resource.fsPath,g,!I.$e))?!1:(l.push(i.resource.fsPath),!0)).concat(t)}}function p(b,t){if(typeof t=="number")switch(b.type){case A.FileChangeType.ADDED:return(t&A.FileChangeFilter.ADDED)===0;case A.FileChangeType.DELETED:return(t&A.FileChangeFilter.DELETED)===0;case A.FileChangeType.UPDATED:return(t&A.FileChangeFilter.UPDATED)===0}return!1}function d(b){if(typeof b=="number"){const t=[];return b&A.FileChangeFilter.ADDED&&t.push("Added"),b&A.FileChangeFilter.DELETED&&t.push("Deleted"),b&A.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(Se[250],ke([1,0,15,45,10,6,2,56,23,16,52]),function(se,e,n,r,E,I,R,A,y,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Q=e.$0Q=void 0,e.$0Q="localFilesystem";class v extends R.$Xc{constructor(w,a){super(),this.a=w,this.b=a,this.onDidChangeCapabilities=I.Event.None,this.f=this.B(new I.$ne),this.onDidChangeFile=this.f.event,this.g=this.B(new I.$ne),this.onDidWatchError=this.g.event,this.h=(0,y.$3g)(),this.j()}get capabilities(){return this.c||(this.c=o.FileSystemProviderCapabilities.FileReadWrite|o.FileSystemProviderCapabilities.FileOpenReadWriteClose|o.FileSystemProviderCapabilities.FileReadStream|o.FileSystemProviderCapabilities.FileFolderCopy|o.FileSystemProviderCapabilities.FileWriteUnlock|o.FileSystemProviderCapabilities.FileAtomicRead|o.FileSystemProviderCapabilities.FileAtomicWrite|o.FileSystemProviderCapabilities.FileAtomicDelete|o.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=o.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=o.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,a){const{buffer:h}=await this.a.call("readFile",[w,a]);return h}readFileStream(w,a,h){const m=(0,A.$De)(p=>n.$Pe.concat(p.map(d=>n.$Pe.wrap(d))).buffer),$=new R.$Wc;return $.add(this.a.listen("readFileStream",[w,a])(p=>{if(p instanceof n.$Pe)m.write(p.buffer);else{if(p==="end")m.end();else{let d;if(p instanceof Error)d=p;else{const b=p;d=(0,o.$nl)(b.message??(0,r.$rj)(b),b.code??o.FileSystemProviderErrorCode.Unknown)}m.error(d),m.end()}$.dispose()}})),$.add(h.onCancellationRequested(()=>{m.error((0,E.$9)()),m.end(),$.dispose()})),m}writeFile(w,a,h){return this.a.call("writeFile",[w,n.$Pe.wrap(a),h])}open(w,a){return this.a.call("open",[w,a])}close(w){return this.a.call("close",[w])}async read(w,a,h,m,$){const[p,d]=await this.a.call("read",[w,a,$]);return h.set(p.buffer.slice(0,d),m),d}write(w,a,h,m,$){return this.a.call("write",[w,a,n.$Pe.wrap(h),m,$])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,a){return this.a.call("delete",[w,a])}rename(w,a,h){return this.a.call("rename",[w,a,h])}copy(w,a,h){return this.a.call("copy",[w,a,h])}cloneFile(w,a){return this.a.call("cloneFile",[w,a])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const a=w;this.f.fire((0,S.$8q)(a))}else{const a=w;this.g.fire(a)}}))}watch(w,a){const h=(0,y.$3g)();return this.a.call("watch",[this.h,h,w,a]),(0,R.$Vc)(()=>this.a.call("unwatch",[this.h,h]))}}e.$$Q=v}),define(Se[251],ke([1,0,33,2,52,6,16,4,14]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class o extends r.$Xc{constructor(){super(),this.a=this.B(new I.$ne),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$ne),this.onDidLogMessage=this.b.event,this.c=this.B(new I.$ne),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$7c),this.m=new Set,this.n=this.B(new y.$Eh(this.y())),this.r=5007,this.s=new y.$4h,this.R=!1,this.B(this.f(v=>this.t(v)))}t(v){this.u(v)&&this.z(v)}u(v){return(0,E.$3q)(v)}async watch(v){this.s.isSettled||this.s.complete(),this.s=new y.$4h;try{this.h.clear(),this.g.clear();for(const f of v)this.u(f)?this.h.set(f.correlationId,f):this.g.add(f);for(const[f]of this.j)this.h.has(f)||(this.j.deleteAndDispose(f),this.m.delete(f));return await this.w(!1)}finally{this.s.complete()}}w(v){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(f=>!this.j.has(f.correlationId))]),v?this.y():0)}y(){return 800}isSuspended(v){return typeof v.correlationId!="number"?!1:this.m.has(v.correlationId)?"polling":this.j.has(v.correlationId)}async z(v){if(this.j.has(v.correlationId))return;const f=new r.$Wc;this.j.set(v.correlationId,f),await this.s.p,!f.isDisposed&&(this.D(v,f),this.w(!0))}C(v){this.j.deleteAndDispose(v.correlationId),this.m.delete(v.correlationId),this.w(!1)}D(v,f){this.F(v,f)?(this.P(`reusing an existing recursive watcher to monitor ${v.path}`),this.m.delete(v.correlationId)):(this.G(v,f),this.m.add(v.correlationId))}F(v,f){const w=this.O?.subscribe(v.path,(a,h)=>{f.isDisposed||(a?this.D(v,f):h?.type===R.FileChangeType.ADDED&&this.H(v))});return w?(f.add(w),!0):!1}G(v,f){let w=!1;const a=(h,m)=>{if(f.isDisposed)return;const $=this.I(h),p=this.I(m),d=w;w=$,!$&&(p||d)&&this.H(v)};this.P(`starting fs.watchFile() on ${v.path} (correlationId: ${v.correlationId})`);try{(0,n.watchFile)(v.path,{persistent:!1,interval:this.r},a)}catch(h){this.Q(`fs.watchFile() failed with error ${h} on path ${v.path} (correlationId: ${v.correlationId})`)}f.add((0,r.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${v.path} (correlationId: ${v.correlationId})`);try{(0,n.unwatchFile)(v.path,a)}catch(h){this.Q(`fs.unwatchFile() failed with error ${h} on path ${v.path} (correlationId: ${v.correlationId})`)}}))}H(v){this.P(`detected ${v.path} exists again, resuming watcher (correlationId: ${v.correlationId})`);const f={resource:A.URI.file(v.path),type:R.FileChangeType.ADDED,cId:v.correlationId};this.a.fire([f]),this.J(f,v),this.C(v)}I(v){return v.ctimeMs===0&&v.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(v,f){if(this.R){const w=` >> normalized ${v.type===R.FileChangeType.ADDED?"[ADDED]":v.type===R.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`;this.L(w,f)}}L(v,f){this.R&&this.P(`${v}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}M(v){return`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, filter: ${(0,E.$ar)(v.filter)}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`}async setVerboseLogging(v){this.R=v}}e.$jr=o}),define(Se[252],ke([1,0,33,14,19,37,2,108,9,3,20,4,182,25,16,52]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0,e.$pr=$;class m extends R.$Xc{get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(d,b,t,l,i,g){super(),this.s=d,this.t=b,this.u=t,this.w=l,this.y=i,this.z=g,this.c=this.B(new r.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Uh(s=>this.M(s),m.b)),this.g=(0,h.$$q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,h.$$q)(this.s.path,this.s.includes):void 0,this.j=(0,h.$3q)(this.s)?this.s.filter:void 0,this.m=new E.$ye,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const d=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const b=await w.Promises.stat(d);if(this.m.token.isCancellationRequested)return;this.B(await this.G(d,b.isDirectory()))}catch(d){d.code!=="ENOENT"?this.O(d):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${d})`),this.D()}}D(){this.r=!0,this.w?.()}async F(d){let b=d.path;try{b=await w.Promises.realpath(d.path),d.path===b&&(b=await(0,f.$lr)(d.path,this.m.token)??d.path),d.path!==b&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${b})`)}catch{}return b}async G(d,b){const t=new R.$Wc;return this.H(d,b,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(d,b,t)),t}H(d,b,t){if(b)return!1;const l=v.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(g,s)=>{if(!t.isDisposed)if(g){const c=await this.G(d,b);t.isDisposed?c.dispose():t.add(c)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:l,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(d,b,t){if(o.$d&&(0,I.$Fg)(d,"/Volumes/",!0)){this.O(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const l=new E.$ye(this.m.token);t.add((0,R.$Vc)(()=>l.dispose(!0)));const i=new R.$Wc;t.add(i);try{const g=v.URI.file(this.s.path),s=(0,y.$qc)(d),c=(0,n.watch)(d);i.add((0,R.$Vc)(()=>{c.removeAllListeners(),c.close()})),this.Q(`Started watching: '${d}'`);const u=new Set;if(b)try{for(const P of await w.Promises.readdir(d))u.add(P)}catch(P){this.O(P)}if(l.token.isCancellationRequested)return;const D=new Map;i.add((0,R.$Vc)(()=>{for(const[,P]of D)P.dispose();D.clear()})),c.on("error",(P,T)=>{l.token.isCancellationRequested||(this.O(`Failed to watch ${d} for changes using fs.watch() (${P}, ${T})`),this.D())}),c.on("change",(P,T)=>{if(l.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${P}"] ${T}`);let z="";if(T&&(z=T.toString(),o.$d&&(z=(0,A.$nm)(z))),!(!z||P!=="change"&&P!=="rename"))if(b)if(P==="rename"){D.get(z)?.dispose();const C=setTimeout(async()=>{if(D.delete(z),z===s&&!await w.Promises.exists(d)){this.J(g);return}if(l.token.isCancellationRequested)return;const k=await this.N((0,y.$mc)(d,z));if(l.token.isCancellationRequested)return;let q;k?u.has(z)?q=a.FileChangeType.UPDATED:(q=a.FileChangeType.ADDED,u.add(z)):(u.delete(z),q=a.FileChangeType.DELETED),this.L({resource:(0,S.$hh)(g,z),type:q,cId:this.s.correlationId})},m.a);D.set(z,(0,R.$Vc)(()=>clearTimeout(C)))}else{let C;u.has(z)?C=a.FileChangeType.UPDATED:(C=a.FileChangeType.ADDED,u.add(z)),this.L({resource:(0,S.$hh)(g,z),type:C,cId:this.s.correlationId})}else if(P==="rename"||z!==s){const C=setTimeout(async()=>{const k=await w.Promises.exists(d);l.token.isCancellationRequested||(k?(this.L({resource:g,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(d,!1))):this.J(g))},m.a);i.clear(),i.add((0,R.$Vc)(()=>clearTimeout(C)))}else this.L({resource:g,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(g){l.token.isCancellationRequested||this.O(`Failed to watch ${d} for changes using fs.watch() (${g.toString()})`),this.D()}}J(d){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:d,type:a.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(d,b=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${d.type===a.FileChangeType.ADDED?"[ADDED]":d.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!b&&this.g.some(t=>t(d.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${d.resource.fsPath}`):!b&&this.h&&this.h.length>0&&!this.h.some(t=>t(d.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}M(d){const b=(0,h.$9q)(d),t=[];for(const i of b){if((0,h.$_q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===a.FileChangeType.ADDED?"[ADDED]":i.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(d){if(o.$e)return w.Promises.exists(d);try{const b=(0,y.$qc)(d);return(await w.Promises.readdir((0,y.$pc)(d))).some(l=>l===b)}catch(b){return this.Q(b),!1}}setVerboseLogging(d){this.z=d}O(d){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}P(d){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}Q(d){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}R(d){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${d}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$or=m,m.a=100,m.b=75;async function $(p,d,b,t,l=512){const i=await w.Promises.open(p,"r"),g=Buffer.allocUnsafe(l),s=new E.$ye(t);let c,u=!1;const D={path:p,excludes:[],recursive:!1},P=new m(D,void 0,T=>{(async()=>{for(const{type:z}of T)if(z===a.FileChangeType.UPDATED){if(u)return;u=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:C}=await w.Promises.read(i,g,0,l,null);if(!C||s.token.isCancellationRequested)break;d(g.slice(0,C))}}catch(C){c=new Error(C),s.dispose(!0)}finally{u=!1}}})()});return await P.ready,b(),new Promise((T,z)=>{s.token.onCancellationRequested(async()=>{P.dispose();try{await w.Promises.close(i)}catch(C){c=new Error(C)}c?z(c):T()})})}}),define(Se[253],ke([1,0,6,83,251,3,252,37]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class y extends E.$jr{constructor(S){super(),this.O=S,this.onDidError=n.Event.None,this.watchers=new Set}async N(S){S=this.Z(S);const v=[],f=new Set(Array.from(this.watchers));for(const w of S){const a=this.W(w);a&&(0,r.$Ek)(a.request.excludes,w.excludes)&&(0,r.$Ek)(a.request.includes,w.includes)?f.delete(a):v.push(w)}v.length&&this.P(`Request to start watching: ${v.map(w=>this.M(w)).join(",")}`),f.size&&this.P(`Request to stop watching: ${Array.from(f).map(w=>this.M(w.request)).join(",")}`);for(const w of f)this.Y(w);for(const w of v)this.X(w)}W(S){for(const v of this.watchers)if(typeof S.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===S.correlationId)return v}else if((0,A.$Eg)(v.request.path,S.path,!I.$e))return v}X(S){const v=new R.$or(S,this.O,w=>this.a.fire(w),()=>this.c.fire(S),w=>this.b.fire(w),this.R),f={request:S,instance:v};this.watchers.add(f)}async stop(){await super.stop();for(const S of this.watchers)this.Y(S)}Y(S){this.P("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}Z(S){const v=new Map;for(const f of S){const w=I.$e?f.path:f.path.toLowerCase();let a=v.get(f.correlationId);a||(a=new Map,v.set(f.correlationId,a)),a.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(f)}`),a.set(w,f)}return Array.from(v.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(S){super.setVerboseLogging(S);for(const v of this.watchers)v.instance.setVerboseLogging(S)}P(S,v){this.R&&this.b.fire({type:"trace",message:this.bb(S,v)})}Q(S){this.b.fire({type:"warn",message:this.bb(S)})}bb(S,v){return v?`[File Watcher (node.js)] ${S} (${this.M(v.request)})`:`[File Watcher (node.js)] ${S}`}}e.$qr=y}),define(Se[254],ke([1,0,52,253]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class E extends n.$6q{constructor(R,A,y){super(R,A,y),this.s()}r(R){return R.add(new r.$qr(void 0))}}e.$rr=E}),define(Se[255],ke([1,0,13,50,117,52]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class R extends I.$7q{constructor(y,o,S){super(y,o,S),this.s()}r(y){const o=y.add(new E.$hr(n.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(o.onDidProcessExit(({code:S,signal:v})=>this.t(`terminated by itself with code ${S}, signal: ${v} (ETERM)`))),r.ProxyChannel.toService((0,r.$ni)(o.getChannel("watcher")))}}e.$ir=R}),define(Se[89],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class n{constructor(...E){this.a=new Map;for(const[I,R]of E)this.set(I,R)}set(E,I){const R=this.a.get(E);return this.a.set(E,I),R}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$Ei=n}),define(Se[123],ke([1,0,14,10,2,71,246,5,89,80]),function(se,e,n,r,E,I,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;const S=!1;class v extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class f{constructor(m=new y.$Ei,$=!1,p,d=S){this.i=m,this.j=$,this.k=p,this.l=d,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(A.$Fi,this),this._globalGraph=d?p?._globalGraph??new R.$ur(b=>b):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Sc)(this.h),this.h.clear();for(const m of this.g)(0,E.$Rc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,$){this.m();const p=this,d=new class extends f{dispose(){p.h.delete(d),super.dispose()}}(m,this.j,this,this.l);return this.h.add(d),$?.add(d),d}invokeFunction(m,...$){this.m();const p=a.traceInvocation(this.l,m);let d=!1;try{return m({get:t=>{if(d)throw(0,r.$$)("service accessor is only valid during the invocation of its target method");const l=this.s(t,p);if(!l)throw new Error(`[invokeFunction] unknown service '${t}'`);return l}},...$)}finally{d=!0,p.stop()}}createInstance(m,...$){this.m();let p,d;return m instanceof I.$Di?(p=a.traceCreation(this.l,m.ctor),d=this.o(m.ctor,m.staticArguments.concat($),p)):(p=a.traceCreation(this.l,m),d=this.o(m,$,p)),p.stop(),d}o(m,$=[],p){const d=A._util.getServiceDependencies(m).sort((l,i)=>l.index-i.index),b=[];for(const l of d){const i=this.s(l.id,p);i||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${l.id}.`,!1),b.push(i)}const t=d.length>0?d[0].index:$.length;if($.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${$.length} static arguments`);const l=t-$.length;l>0?$=$.concat(new Array(l)):$=$.slice(0,t)}return Reflect.construct(m,$.concat(b))}q(m,$){if(this.i.get(m)instanceof I.$Di)this.i.set(m,$);else if(this.k)this.k.q(m,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const $=this.i.get(m);return!$&&this.k?this.k.r(m):$}s(m,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const p=this.r(m);return p instanceof I.$Di?this.u(m,p,$.branch(m,!0)):($.branch(m,!1),p)}u(m,$,p){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,$,p)}finally{this.t.delete(m)}}v(m,$,p){const d=new R.$ur(l=>l.id.toString());let b=0;const t=[{id:m,desc:$,_trace:p}];for(;t.length;){const l=t.pop();if(d.lookupOrInsertNode(l),b++>1e3)throw new v(d);for(const i of A._util.getServiceDependencies(l.desc.ctor)){const g=this.r(i.id);if(g||this.y(`[createInstance] ${m} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(i.id)),g instanceof I.$Di){const s={id:i.id,desc:g,_trace:l._trace.branch(i.id,!0)};d.insertEdge(l,s),t.push(s)}}}for(;;){const l=d.roots();if(l.length===0){if(!d.isEmpty())throw new v(d);break}for(const{data:i}of l){if(this.r(i.id)instanceof I.$Di){const s=this.w(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.q(i.id,s)}d.removeNode(i)}}return this.r(m)}w(m,$,p=[],d,b){if(this.i.get(m)instanceof I.$Di)return this.x(m,$,p,d,b,this.g);if(this.k)return this.k.w(m,$,p,d,b);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(m,$,p=[],d,b,t){if(d){const l=new f(void 0,this.j,this,this.l);l.c=String(m);const i=new Map,g=new n.$Zh(()=>{const s=l.o($,p,b);for(const[c,u]of i){const D=s[c];if(typeof D=="function")for(const P of u)P.disposable=D.apply(s,P.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,c){if(!g.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let P=i.get(c);return P||(P=new o.$8c,i.set(c,P)),(z,C,k)=>{if(g.isInitialized)return g.value[c](z,C,k);{const q={listener:[z,C,k],disposable:void 0},Y=P.push(q);return(0,E.$Vc)(()=>{Y(),q.disposable?.dispose()})}}}if(c in s)return s[c];const u=g.value;let D=u[c];return typeof D!="function"||(D=D.bind(u),s[c]=D),D},set(s,c,u){return g.value[c]=u,!0},getPrototypeOf(s){return $.prototype}})}else{const l=this.o($,p,b);return t.add(l),l}}y(m,$){if($&&console.warn(m),this.j)throw new Error(m)}}e.$vr=f;var w;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(w||(w={}));class a{static traceInvocation(m,$){return m?new a(w.Invocation,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):a.c}static traceCreation(m,$){return m?new a(w.Creation,$.name):a.c}constructor(m,$){this.type=m,this.name=$,this.g=Date.now(),this.h=[]}branch(m,$){const p=new a(w.Branch,m.toString());return this.h.push([m,$,p]),p}stop(){const m=Date.now()-this.g;a.f+=m;let $=!1;function p(b,t){const l=[],i=new Array(b+1).join("	");for(const[g,s,c]of t.h)if(s&&c){$=!0,l.push(`${i}CREATES -> ${g}`);const u=p(b+1,c);u&&l.push(u)}else l.push(`${i}uses -> ${g}`);return l.join(`
`)}const d=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${a.f.toFixed(2)}ms)`];(m>2||$)&&a.all.add(d.join(`
`))}}e.$wr=a,a.all=new Set,a.c=new class extends a{constructor(){super(w.None,null)}stop(){}branch(){return this}},a.f=0}),define(Se[256],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$qw=void 0,e.$qw=(0,n.$Gi)("labelService");var r;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(r||(e.Verbosity=r={}))}),define(Se[12],ke([1,0,219,45,6,68,2,26,3,20,11,4,42,5]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=h,e.log=$,e.$ok=D,e.$pk=P,e.$qk=T,e.$rk=z,n=Be(n),e.$ak=(0,w.$Gi)("logService"),e.$bk=(0,w.$Gi)("loggerService");function a(){return new Date().toISOString()}function h(C){return(0,S.$kg)(C)}var m;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$dk=m.Info;function $(C,k,q){switch(k){case m.Trace:C.trace(q);break;case m.Debug:C.debug(q);break;case m.Info:C.info(q);break;case m.Warning:C.warn(q);break;case m.Error:C.error(q);break;case m.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function p(C,k=!1){let q="";for(let Y=0;Y<C.length;Y++){let J=C[Y];if(J instanceof Error&&(J=(0,r.$rj)(J,k)),typeof J=="object")try{J=JSON.stringify(J)}catch{}q+=(Y>0?" ":"")+J}return q}class d extends R.$Xc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new E.$ne),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==m.Off&&this.b<=k}}e.$fk=d;class b extends d{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...q){this.f(m.Trace)&&this.g(m.Trace,p([k,...q],!0))}debug(k,...q){this.f(m.Debug)&&this.g(m.Debug,p([k,...q]))}info(k,...q){this.f(m.Info)&&this.g(m.Info,p([k,...q]))}warn(k,...q){this.f(m.Warning)&&this.g(m.Warning,p([k,...q]))}error(k,...q){if(this.f(m.Error))if(k instanceof Error){const Y=Array.prototype.slice.call(arguments);Y[0]=k.stack,this.g(m.Error,p(Y))}else this.g(m.Error,p([k,...q]))}flush(){}}e.$gk=b;class t extends d{constructor(k=e.$dk){super(),this.setLevel(k),this.g=!y.$c}trace(k,...q){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,k,...q):console.log(`[main ${a()}]`,k,...q))}debug(k,...q){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,k,...q):console.log(`[main ${a()}]`,k,...q))}info(k,...q){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,k,...q):console.log(`[main ${a()}]`,k,...q))}warn(k,...q){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,k,...q):console.warn(`[main ${a()}]`,k,...q))}error(k,...q){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,k,...q):console.error(`[main ${a()}]`,k,...q))}flush(){}}e.$hk=t;class l extends d{constructor(k=e.$dk,q=!0){super(),this.g=q,this.setLevel(k)}trace(k,...q){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...q):console.log(k,...q))}debug(k,...q){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...q):console.log(k,...q))}info(k,...q){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...q):console.log(k,...q))}warn(k,...q){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...q):console.log(k,...q))}error(k,...q){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...q):console.error(k,...q))}flush(){}}e.$ik=l;class i extends d{constructor(k,q=e.$dk){super(),this.g=k,this.setLevel(q)}trace(k,...q){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(k),...q])}debug(k,...q){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(k),...q])}info(k,...q){this.f(m.Info)&&this.g.log(m.Info,[this.h(k),...q])}warn(k,...q){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(k),...q])}error(k,...q){this.f(m.Error)&&this.g.log(m.Error,[this.h(k),...q])}h(k){return typeof k=="string"?k:(0,r.$rj)(k,this.f(m.Trace))}flush(){}}e.$jk=i;class g extends d{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const q of this.g)q.setLevel(k);super.setLevel(k)}trace(k,...q){for(const Y of this.g)Y.trace(k,...q)}debug(k,...q){for(const Y of this.g)Y.debug(k,...q)}info(k,...q){for(const Y of this.g)Y.info(k,...q)}warn(k,...q){for(const Y of this.g)Y.warn(k,...q)}error(k,...q){for(const Y of this.g)Y.error(k,...q)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose();super.dispose()}}e.$kk=g;class s extends R.$Xc{constructor(k,q,Y){if(super(),this.h=k,this.j=q,this.b=new A.$Dc,this.c=this.B(new E.$ne),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$ne),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$ne),this.onDidChangeVisibility=this.g.event,Y)for(const J of Y)this.b.set(J.resource,{logger:void 0,info:J})}m(k){return(0,S.$gg)(k)?[...this.b.values()].find(q=>q.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,q){const Y=this.n(k),J=(0,S.$gg)(k)?k:q?.id??(0,I.$uj)(Y.toString()).toString(16);let ne=this.b.get(Y)?.logger;const Z=q?.logLevel==="always"?m.Trace:q?.logLevel;ne||(ne=this.s(Y,Z??this.getLogLevel(Y)??this.h,{...q,id:J}));const x={logger:ne,info:{resource:Y,id:J,logLevel:Z,name:q?.name,hidden:q?.hidden,extensionId:q?.extensionId,when:q?.when}};return this.registerLogger(x.info),this.b.set(Y,x),ne}n(k){return(0,S.$gg)(k)?(0,o.$hh)(this.j,`${k}.log`):k}setLogLevel(k,q){if(v.URI.isUri(k)){const Y=k,J=q,ne=this.b.get(Y);ne&&J!==ne.info.logLevel&&(ne.info.logLevel=J===this.h?void 0:J,ne.logger?.setLevel(J),this.b.set(ne.info.resource,ne),this.f.fire([Y,J]))}else{this.h=k;for(const[Y,J]of this.b.entries())this.b.get(Y)?.info.logLevel===void 0&&J.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,q){const Y=this.m(k);Y&&q!==!Y.info.hidden&&(Y.info.hidden=!q,this.b.set(Y.info.resource,Y),this.g.fire([Y.info.resource,q]))}getLogLevel(k){let q;return k&&(q=this.b.get(k)?.info.logLevel),q??this.h}registerLogger(k){const q=this.b.get(k.resource);q?q.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const q=this.b.get(k);q&&(q.logger&&q.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[q.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=s;class c{constructor(){this.onDidChangeLogLevel=new E.$ne().event}setLevel(k){}getLevel(){return m.Info}trace(k,...q){}debug(k,...q){}info(k,...q){}warn(k,...q){}error(k,...q){}critical(k,...q){}dispose(){}flush(){}}e.$mk=c;class u extends c{}e.$nk=u;function D(C){if(C.verbose)return m.Trace;if(typeof C.logLevel=="string"){const k=z(C.logLevel.toLowerCase());if(k!==void 0)return k}return e.$dk}function P(C){switch(C){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function T(C){switch(C){case m.Trace:return{original:"Trace",value:n.localize(0,null)};case m.Debug:return{original:"Debug",value:n.localize(1,null)};case m.Info:return{original:"Info",value:n.localize(2,null)};case m.Warning:return{original:"Warning",value:n.localize(3,null)};case m.Error:return{original:"Error",value:n.localize(4,null)};case m.Off:return{original:"Off",value:n.localize(5,null)}}}function z(C){switch(C){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$sk=new f.$Xj("logLevel",P(m.Info))}),define(Se[257],ke([1,0,18,14,10,6,37,2,9,52,12]),function(se,e,n,r,E,I,R,A,y,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class v extends A.$Xc{constructor(w,a){super(),this.a=w,this.b=a,this.c=this.B(new I.$ne),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$ne),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Eh(0)),this.w=[],this.y=this.B(new r.$Eh(0))}watch(w,a){return a.recursive||this.b?.watcher?.forceUniversal?this.n(w,a):this.z(w,a)}n(w,a){const h={path:this.J(w),excludes:a.excludes,includes:a.includes,recursive:a.recursive,filter:a.filter,correlationId:a.correlationId},m=(0,n.$Wb)(this.j,h);return this.r(),(0,A.$Vc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,E.$3)(w))}s(){this.h||(this.h=this.B(this.t(a=>this.c.fire((0,o.$8q)(a)),a=>this.G(a),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const a of this.j)(0,o.$4q)(a)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const a of this.j)(0,o.$4q)(a)&&w.includes(a.path)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,a){const h={path:this.J(w),excludes:a.excludes,includes:a.includes,recursive:!1,filter:a.filter,correlationId:a.correlationId},m=(0,n.$Wb)(this.w,h);return this.C(),(0,A.$Vc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,E.$3)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,o.$8q)(w)),w=>this.G(w),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,y.$kc)(w.fsPath)}J(w){const a=this.I(w);return(0,R.$Ig)(a)}}e.$br=v});var Fe=this&&this.__param||function(se,e){return function(n,r){e(n,r,se)}};define(Se[124],ke([1,0,18,14,15,19,6,68,40,2,69,13,44,20,56,214,16,122,12,10]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let t=b=class extends o.$Xc{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new R.$ne),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.$ne),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.$ne),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new R.$ne),this.onDidRunOperation=this.r.event,this.X=this.B(new R.$ne),this.Y=this.B(new R.$ne),this.onDidFilesChange=this.Y.event,this.Z=this.B(new R.$ne),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Ph)}registerProvider(i,g){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${i}`);const s=new o.$Wc;return this.h.set(i,g),this.c.fire({added:!0,scheme:i,provider:g}),s.add(g.onDidChangeFile(c=>{const u=new m.$tl(c,!this.S(g));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof g.onDidWatchError=="function"&&s.add(g.onDidWatchError(c=>this.Z.fire(new Error(c)))),s.add(g.onDidChangeCapabilities(()=>this.g.fire({provider:g,scheme:i}))),(0,o.$Vc)(()=>{this.c.fire({added:!1,scheme:i,provider:g}),this.h.delete(i),(0,o.$Sc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const g=[];this.f.fire({scheme:i,join(s){g.push(s)}}),!this.h.has(i)&&await r.Promises.settled(g)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,g){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&g)}listCapabilities(){return y.Iterable.map(this.h,([i,g])=>({scheme:i,capabilities:g.capabilities}))}async j(i){if(!(0,w.$lh)(i))throw new m.$vl((0,h.localize)(0,null,this.sb(i)),m.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const g=this.h.get(i.scheme);if(!g){const s=new d.$eb;throw s.message=(0,h.localize)(1,null,i.toString()),s}return g}async m(i){const g=await this.j(i);if((0,m.$gl)(g)||(0,m.$dl)(g)||(0,m.$hl)(g))return g;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const g=await this.j(i);if((0,m.$gl)(g)||(0,m.$dl)(g))return g;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,g){try{return await this.s(i,g)}catch(s){throw(0,m.$ql)(s)===m.FileSystemProviderErrorCode.FileNotFound?new m.$vl((0,h.localize)(2,null,this.sb(i)),m.FileOperationResult.FILE_NOT_FOUND):(0,m.$ol)(s)}}async s(i,g){const s=await this.j(i),c=this.S(s),u=g?.resolveTo,D=g?.resolveSingleChildDescendants,P=g?.resolveMetadata,T=await s.stat(i);let z;return this.t(s,i,T,void 0,!!P,(C,k)=>(z||(z=S.$Mi.forUris(()=>!c),z.set(i,!0),u&&z.fill(!0,u)),z.get(C.resource)||z.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&D?k===1:!1))}async t(i,g,s,c,u,D){const{providerExtUri:P}=this.R(i),T={resource:g,name:P.basename(g),isFile:(s.type&m.FileType.File)!==0,isDirectory:(s.type&m.FileType.Directory)!==0,isSymbolicLink:(s.type&m.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&m.FilePermission.Readonly)||!!(i.capabilities&m.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Gl)({mtime:s.mtime,size:s.size}),children:void 0};if(T.isDirectory&&D(T,c)){try{const z=await i.readdir(g),C=await r.Promises.settled(z.map(async([k,q])=>{try{const Y=P.joinPath(g,k),J=u?await i.stat(Y):{type:q};return await this.t(i,Y,J,z.length,u,D)}catch(Y){return this.b.trace(Y),null}}));T.children=(0,n.$Kb)(C)}catch(z){this.b.trace(z),T.children=[]}return T}return T}async resolveAll(i){return r.Promises.settled(i.map(async g=>{try{return{stat:await this.s(g.resource,g.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const g=await this.j(i),s=await g.stat(i);return this.t(g,i,s,void 0,!0,()=>!1)}async exists(i){const g=await this.j(i);try{return!!await g.stat(i)}catch{return!1}}async canCreateFile(i,g){try{await this.u(i,g)}catch(s){return s}return!0}async u(i,g){if(!g?.overwrite&&await this.exists(i))throw new m.$vl((0,h.localize)(3,null,this.sb(i)),m.FileOperationResult.FILE_MODIFIED_SINCE,g)}async createFile(i,g=E.$Pe.fromString(""),s){await this.u(i,s);const c=await this.writeFile(i,g);return this.r.fire(new m.$sl(i,m.FileOperation.CREATE,c)),c}async writeFile(i,g,s){const c=this.qb(await this.n(i),i),{providerExtUri:u}=this.R(c);let D=s;if((0,m.$jl)(c)&&!D?.atomic){const P=c.enforceAtomicWriteFile?.(i);P&&(D={...s,atomic:P})}try{await this.w(c,i,D)||await this.U(c,u.dirname(i));let T;if((0,m.$dl)(c)&&!(g instanceof E.$Pe))if((0,a.$Be)(g)){const z=await(0,a.$Ie)(g,3);z.ended?T=E.$Pe.concat(z.buffer):T=z}else T=(0,a.$Fe)(g,z=>E.$Pe.concat(z),3);else T=g;!(0,m.$gl)(c)||(0,m.$dl)(c)&&T instanceof E.$Pe||(0,m.$dl)(c)&&(0,m.$jl)(c)&&D?.atomic?await this.hb(c,i,D,T):await this.db(c,i,D,T instanceof E.$Pe?(0,E.$1e)(T):T),this.r.fire(new m.$sl(i,m.FileOperation.WRITE))}catch(P){throw new m.$vl((0,h.localize)(4,null,this.sb(i),(0,m.$ol)(P).toString()),(0,m.$rl)(P),D)}return this.resolve(i,{resolveMetadata:!0})}async w(i,g,s){const c=!!s?.unlock;if(c&&!(i.capabilities&m.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,h.localize)(5,null,this.sb(g)));if(!!s?.atomic){if(!(i.capabilities&m.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,h.localize)(6,null,this.sb(g)));if(!(i.capabilities&m.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,h.localize)(7,null,this.sb(g)));if(c)throw new Error((0,h.localize)(8,null,this.sb(g)))}let D;try{D=await i.stat(g)}catch{return}if(D.type&m.FileType.Directory)throw new m.$vl((0,h.localize)(9,null,this.sb(g)),m.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(g,D),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==m.$Fl&&typeof D.mtime=="number"&&typeof D.size=="number"&&s.mtime<D.mtime&&s.etag!==(0,m.$Gl)({mtime:s.mtime,size:D.size}))throw new m.$vl((0,h.localize)(10,null),m.FileOperationResult.FILE_MODIFIED_SINCE,s);return D}async readFile(i,g,s){const c=await this.m(i);return g?.atomic?this.z(c,i,g,s):this.C(c,i,g,s)}async z(i,g,s,c){return new Promise((u,D)=>{this.cb.queueFor(g,async()=>{try{const P=await this.C(i,g,s,c);u(P)}catch(P){D(P)}},this.R(i).providerExtUri)})}async C(i,g,s,c){const u=await this.D(i,g,{...s,preferUnbuffered:!0},c);return{...u,value:await(0,E.$2e)(u.value)}}async readFileStream(i,g,s){const c=await this.m(i);return this.D(c,i,g,s)}async D(i,g,s,c){const u=new I.$ye(c);let D=s;(0,m.$il)(i)&&i.enforceAtomicReadFile?.(g)&&(D={...s,atomic:!0});const P=this.J(g,D).then(z=>z,z=>{throw u.dispose(!0),z});let T;try{return typeof D?.etag=="string"&&D.etag!==m.$Fl&&await P,D?.atomic&&(0,m.$il)(i)||!((0,m.$gl)(i)||(0,m.$hl)(i))||(0,m.$dl)(i)&&D?.preferUnbuffered?T=this.I(i,g,D):(0,m.$hl)(i)?T=this.G(i,g,u.token,D):T=this.H(i,g,u.token,D),T.on("end",()=>u.dispose()),T.on("error",()=>u.dispose()),{...await P,value:T}}catch(z){throw T&&await(0,a.$Ge)(T),this.F(z,g,D)}}F(i,g,s){const c=(0,h.localize)(11,null,this.sb(g),(0,m.$ol)(i).toString());return i instanceof m.$xl?new m.$xl(c,i.stat,s):i instanceof m.$wl?new m.$wl(c,i.fileOperationResult,i.size,i.options):new m.$vl(c,(0,m.$rl)(i),s)}G(i,g,s,c=Object.create(null)){const u=i.readFileStream(g,c,s);return(0,a.$Me)(u,{data:D=>D instanceof E.$Pe?D:E.$Pe.wrap(D),error:D=>this.F(D,g,c)},D=>E.$Pe.concat(D))}H(i,g,s,c=Object.create(null)){const u=(0,E.$6e)();return(0,$.$1q)(i,g,u,D=>D,{...c,bufferSize:this.a,errorTransformer:D=>this.F(D,g,c)},s),u}I(i,g,s){const c=(0,a.$De)(u=>E.$Pe.concat(u));return(async()=>{try{let u;s?.atomic&&(0,m.$il)(i)?u=await i.readFile(g,{atomic:!0}):u=await i.readFile(g),typeof s?.position=="number"&&(u=u.slice(s.position)),typeof s?.length=="number"&&(u=u.slice(0,s.length)),this.L(g,u.byteLength,s),c.end(E.$Pe.wrap(u))}catch(u){c.error(u),c.end()}})(),c}async J(i,g){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new m.$vl((0,h.localize)(12,null,this.sb(i)),m.FileOperationResult.FILE_IS_DIRECTORY,g);if(typeof g?.etag=="string"&&g.etag!==m.$Fl&&g.etag===s.etag)throw new m.$xl((0,h.localize)(13,null),s,g);return this.L(i,s.size,g),s}L(i,g,s){if(typeof s?.limits?.size=="number"&&g>s.limits.size)throw new m.$wl((0,h.localize)(14,null,this.sb(i)),m.FileOperationResult.FILE_TOO_LARGE,g,s)}async canMove(i,g,s){return this.M(i,g,"move",s)}async canCopy(i,g,s){return this.M(i,g,"copy",s)}async M(i,g,s,c){if(i.toString()!==g.toString())try{const u=s==="move"?this.qb(await this.n(i),i):await this.m(i),D=this.qb(await this.n(g),g);await this.Q(u,i,D,g,s,c)}catch(u){return u}return!0}async move(i,g,s){const c=this.qb(await this.n(i),i),u=this.qb(await this.n(g),g),D=await this.N(c,i,u,g,"move",!!s),P=await this.resolve(g,{resolveMetadata:!0});return this.r.fire(new m.$sl(i,D==="move"?m.FileOperation.MOVE:m.FileOperation.COPY,P)),P}async copy(i,g,s){const c=await this.m(i),u=this.qb(await this.n(g),g),D=await this.N(c,i,u,g,"copy",!!s),P=await this.resolve(g,{resolveMetadata:!0});return this.r.fire(new m.$sl(i,D==="copy"?m.FileOperation.COPY:m.FileOperation.MOVE,P)),P}async N(i,g,s,c,u,D){if(g.toString()===c.toString())return u;const{exists:P,isSameResourceWithDifferentPathCase:T}=await this.Q(i,g,s,c,u,D);if(P&&!T&&D&&await this.del(c,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(c)),u==="copy"){if(i===s&&(0,m.$el)(i))await i.copy(g,c,{overwrite:D});else{const z=await this.resolve(g);z.isDirectory?await this.P(i,z,s,c):await this.O(i,g,s,c)}return u}else return i===s?(await i.rename(g,c,{overwrite:D}),u):(await this.N(i,g,s,c,"copy",D),await this.del(g,{recursive:!0}),"copy")}async O(i,g,s,c){if((0,m.$gl)(i)&&(0,m.$gl)(s))return this.jb(i,g,s,c);if((0,m.$gl)(i)&&(0,m.$dl)(s))return this.pb(i,g,s,c);if((0,m.$dl)(i)&&(0,m.$gl)(s))return this.nb(i,g,s,c);if((0,m.$dl)(i)&&(0,m.$dl)(s))return this.lb(i,g,s,c)}async P(i,g,s,c){await s.mkdir(c),Array.isArray(g.children)&&await r.Promises.settled(g.children.map(async u=>{const D=this.R(s).providerExtUri.joinPath(c,u.name);return u.isDirectory?this.P(i,await this.resolve(u.resource),s,D):this.O(i,u.resource,s,D)}))}async Q(i,g,s,c,u,D){let P=!1;if(i===s){const{providerExtUri:z,isPathCaseSensitive:C}=this.R(i);if(C||(P=z.isEqual(g,c)),P&&u==="copy")throw new Error((0,h.localize)(15,null,this.sb(g),this.sb(c)));if(!P&&z.isEqualOrParent(c,g))throw new Error((0,h.localize)(16,null,this.sb(g),this.sb(c)))}const T=await this.exists(c);if(T&&!P){if(!D)throw new m.$vl((0,h.localize)(17,null,this.sb(g),this.sb(c)),m.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:z}=this.R(i);if(z.isEqualOrParent(g,c))throw new Error((0,h.localize)(18,null,this.sb(g),this.sb(c)))}}return{exists:T,isSameResourceWithDifferentPathCase:P}}R(i){const g=this.S(i);return{providerExtUri:g?w.$0g:w.$_g,isPathCaseSensitive:g}}S(i){return!!(i.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const g=this.qb(await this.j(i),i);await this.U(g,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new m.$sl(i,m.FileOperation.CREATE,s)),s}async U(i,g){const s=[],{providerExtUri:c}=this.R(i);for(;!c.isEqual(g,c.dirname(g));)try{if(!((await i.stat(g)).type&m.FileType.Directory))throw new Error((0,h.localize)(19,null,this.sb(g)));break}catch(u){if((0,m.$ql)(u)!==m.FileSystemProviderErrorCode.FileNotFound)throw u;s.push(c.basename(g)),g=c.dirname(g)}for(let u=s.length-1;u>=0;u--){g=c.joinPath(g,s[u]);try{await i.mkdir(g)}catch(D){if((0,m.$ql)(D)!==m.FileSystemProviderErrorCode.FileExists)throw D}}}async canDelete(i,g){try{await this.W(i,g)}catch(s){return s}return!0}async W(i,g){const s=this.qb(await this.j(i),i),c=!!g?.useTrash;if(c&&!(s.capabilities&m.FileSystemProviderCapabilities.Trash))throw new Error((0,h.localize)(20,null,this.sb(i)));const u=g?.atomic;if(u&&!(s.capabilities&m.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,h.localize)(21,null,this.sb(i)));if(c&&u)throw new Error((0,h.localize)(22,null,this.sb(i)));let D;try{D=await s.stat(i)}catch{}if(D)this.rb(i,D);else throw new m.$vl((0,h.localize)(23,null,this.sb(i)),m.FileOperationResult.FILE_NOT_FOUND);if(!!!g?.recursive){const T=await this.resolve(i);if(T.isDirectory&&Array.isArray(T.children)&&T.children.length>0)throw new Error((0,h.localize)(24,null,this.sb(i)))}return s}async del(i,g){const s=await this.W(i,g);let c=g;if((0,m.$kl)(s)&&!c?.atomic){const T=s.enforceAtomicDelete?.(i);T&&(c={...g,atomic:T})}const u=!!c?.useTrash,D=!!c?.recursive,P=c?.atomic??!1;await s.delete(i,{recursive:D,useTrash:u,atomic:P}),this.r.fire(new m.$sl(i,m.FileOperation.DELETE))}async cloneFile(i,g){const s=await this.j(i),c=this.qb(await this.n(g),g);if(!(s===c&&this.R(s).providerExtUri.isEqual(i,g)))return s===c&&(0,m.$fl)(s)?s.cloneFile(i,g):(await this.U(c,this.R(c).providerExtUri.dirname(g)),s===c&&(0,m.$el)(s)?this.cb.queueFor(i,()=>s.copy(i,g,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,c,g),this.R(s).providerExtUri))}createWatcher(i,g){return this.watch(i,{...g,correlationId:b.ab++})}watch(i,g={recursive:!1,excludes:[]}){const s=new o.$Wc;let c=!1,u=()=>{c=!0};s.add((0,o.$Vc)(()=>u())),(async()=>{try{const P=await this.bb(i,g);c?(0,o.$Sc)(P):u=()=>(0,o.$Sc)(P)}catch(P){this.b.error(P)}})();const D=g.correlationId;if(typeof D=="number"){const P=s.add(new R.$ne);return s.add(this.X.event(z=>{z.correlates(D)&&P.fire(z)})),{onDidChange:P.event,dispose:()=>s.dispose()}}return s}async bb(i,g){const s=await this.j(i),c=(0,A.$uj)([this.R(s).providerExtUri.getComparisonKey(i),g]);let u=this.$.get(c);return u||(u={count:0,disposable:s.watch(i,g)},this.$.set(c,u)),u.count+=1,(0,o.$Vc)(()=>{u&&(u.count--,u.count===0&&((0,o.$Sc)(u.disposable),this.$.delete(c)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,o.$Sc)(i.disposable);this.$.clear()}async db(i,g,s,c){return this.cb.queueFor(g,async()=>{const u=await i.open(g,{create:!0,unlock:s?.unlock??!1});try{(0,a.$Be)(c)||(0,a.$Ce)(c)?await this.eb(i,u,c):await this.fb(i,u,c)}catch(D){throw(0,m.$ol)(D)}finally{await i.close(u)}},this.R(i).providerExtUri)}async eb(i,g,s){let c=0,u;if((0,a.$Ce)(s)){if(s.buffer.length>0){const D=E.$Pe.concat(s.buffer);await this.gb(i,g,D,D.byteLength,c,0),c+=D.byteLength}if(s.ended)return;u=s.stream}else u=s;return new Promise((D,P)=>{(0,a.$He)(u,{onData:async T=>{u.pause();try{await this.gb(i,g,T,T.byteLength,c,0)}catch(z){return P(z)}c+=T.byteLength,setTimeout(()=>u.resume())},onError:T=>P(T),onEnd:()=>D()})})}async fb(i,g,s){let c=0,u;for(;(u=s.read())!==null;)await this.gb(i,g,u,u.byteLength,c,0),c+=u.byteLength}async gb(i,g,s,c,u,D){let P=0;for(;P<c;){const T=await i.write(g,u+P,s.buffer,D+P,c-P);P+=T}}async hb(i,g,s,c){return this.cb.queueFor(g,()=>this.ib(i,g,s,c),this.R(i).providerExtUri)}async ib(i,g,s,c){let u;c instanceof E.$Pe?u=c:(0,a.$Be)(c)?u=await(0,E.$2e)(c):(0,a.$Ce)(c)?u=await(0,E.$3e)(c):u=(0,E.$Ze)(c),await i.writeFile(g,u.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,g,s,c){return this.cb.queueFor(c,()=>this.kb(i,g,s,c),this.R(s).providerExtUri)}async kb(i,g,s,c){let u,D;try{u=await i.open(g,{create:!1}),D=await s.open(c,{create:!0,unlock:!1});const P=E.$Pe.alloc(this.a);let T=0,z=0,C=0;do C=await i.read(u,T,P.buffer,z,P.byteLength-z),await this.gb(s,D,P,C,T,z),T+=C,z+=C,z===P.byteLength&&(z=0);while(C>0)}catch(P){throw(0,m.$ol)(P)}finally{await r.Promises.settled([typeof u=="number"?i.close(u):Promise.resolve(),typeof D=="number"?s.close(D):Promise.resolve()])}}async lb(i,g,s,c){return this.cb.queueFor(c,()=>this.mb(i,g,s,c),this.R(s).providerExtUri)}async mb(i,g,s,c){return s.writeFile(c,await i.readFile(g),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,g,s,c){return this.cb.queueFor(c,()=>this.ob(i,g,s,c),this.R(s).providerExtUri)}async ob(i,g,s,c){const u=await s.open(c,{create:!0,unlock:!1});try{const D=await i.readFile(g);await this.gb(s,u,E.$Pe.wrap(D),D.byteLength,0,0)}catch(D){throw(0,m.$ol)(D)}finally{await s.close(u)}}async pb(i,g,s,c){const u=await(0,E.$2e)(this.H(i,g,I.CancellationToken.None));await this.hb(s,c,void 0,u)}qb(i,g){if(i.capabilities&m.FileSystemProviderCapabilities.Readonly)throw new m.$vl((0,h.localize)(25,null,this.sb(g)),m.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,g){if((g.permissions??0)&m.FilePermission.Readonly)throw new m.$vl((0,h.localize)(26,null,this.sb(i)),m.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===v.Schemas.file?i.fsPath:i.toString(!0)}};e.$2q=t,t.ab=0,e.$2q=t=b=ze([Fe(0,p.$ak)],t)}),define(Se[72],ke([1,0,14,26,15,6,37,2,9,3,20,56,25,217,16,122,257,255,254]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class d extends m.$br{constructor(t,l){super(t,l),this.onDidChangeCapabilities=I.Event.None,this.P=new r.$Dc(i=>S.$$g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=a.FileSystemProviderCapabilities.FileReadWrite|a.FileSystemProviderCapabilities.FileOpenReadWriteClose|a.FileSystemProviderCapabilities.FileReadStream|a.FileSystemProviderCapabilities.FileFolderCopy|a.FileSystemProviderCapabilities.FileWriteUnlock|a.FileSystemProviderCapabilities.FileAtomicRead|a.FileSystemProviderCapabilities.FileAtomicWrite|a.FileSystemProviderCapabilities.FileAtomicDelete|a.FileSystemProviderCapabilities.FileClone,o.$e&&(this.M|=a.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:l,symbolicLink:i}=await f.SymlinkSupport.stat(this.I(t));return{type:this.O(l,i),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:a.FilePermission.Locked}}catch(l){throw this.hb(l)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const l=await f.Promises.readdir(this.I(t),{withFileTypes:!0}),i=[];return await Promise.all(l.map(async g=>{try{let s;g.isSymbolicLink()?s=(await this.stat((0,S.$hh)(t,g.name))).type:s=this.O(g),i.push([g.name,s])}catch(s){this.a.trace(s)}})),i}catch(l){throw this.hb(l)}}O(t,l){let i;return l?.dangling?i=a.FileType.Unknown:t.isFile()?i=a.FileType.File:t.isDirectory()?i=a.FileType.Directory:i=a.FileType.Unknown,l&&(i|=a.FileType.SymbolicLink),i}async Q(t){const l=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let i;for(;i=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await i.wait();const g=new n.$Fh;return this.P.set(t,g),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,A.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.P.get(t)===g&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),g.open()})}async readFile(t,l){let i;try{l?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),i=await this.Q(t));const g=this.I(t);return await f.Promises.readFile(g)}catch(g){throw this.hb(g)}finally{i?.dispose()}}R(t){d.L&&this.a.trace(t)}readFileStream(t,l,i){const g=(0,v.$De)(s=>E.$Pe.concat(s.map(c=>E.$Pe.wrap(c))).buffer);return(0,h.$1q)(this,t,g,s=>s.buffer,{...l,bufferSize:256*1024},i),g}async writeFile(t,l,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(t)?this.U(t,(0,S.$hh)((0,S.$gh)(t),`${(0,S.$eh)(t)}${i.atomic.postfix}`),l,i):this.W(t,l,i)}async S(t){try{const l=this.I(t),{symbolicLink:i}=await f.SymlinkSupport.stat(l);if(i)return!1}catch{}return!0}async U(t,l,i,g){const s=new A.$Wc;try{s.add(await this.Q(t)),s.add(await this.Q(l)),await this.W(l,i,g,!0);try{await this.rename(l,t,{overwrite:!0})}catch(c){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw c}}finally{s.dispose()}}async W(t,l,i,g){let s;try{const c=this.I(t);if(!i.create||!i.overwrite){if(await f.Promises.exists(c)){if(!i.overwrite)throw(0,a.$nl)((0,w.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,a.$nl)((0,w.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(t,{create:!0,unlock:i.unlock},g),await this.write(s,0,l,0,l.byteLength)}catch(c){throw await this.ib(t,c)}finally{typeof s=="number"&&await this.close(s)}}static configureFlushOnWrite(t){d.$=t}async open(t,l,i){const g=this.I(t);let s;(0,a.$bl)(l)&&!i&&(s=await this.Q(t));let c;try{if((0,a.$bl)(l)&&l.unlock)try{const{stat:D}=await f.SymlinkSupport.stat(g);D.mode&128||await f.Promises.chmod(g,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let u;if((0,a.$bl)(l)){if(o.$c)try{await f.Promises.truncate(g,0),u="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}u||(u="w")}else u="r";c=await f.Promises.open(g,u)}catch(u){throw s?.dispose(),(0,a.$bl)(l)?await this.ib(t,u):this.hb(u)}if(this.X.set(c,0),(0,a.$bl)(l)&&this.Z.set(c,t),s){const u=this.Y.get(c);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${g})`),this.Y.set(c,s),u&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${g})`),u.dispose())}return c}async close(t){const l=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&d.$)try{await f.Promises.fdatasync(t)}catch(i){d.configureFlushOnWrite(!1),this.a.error(i)}return await f.Promises.close(t)}catch(i){throw this.hb(i)}finally{l&&(this.Y.get(t)===l&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),l.dispose())}}async read(t,l,i,g,s){const c=this.ab(t,l);let u=null;try{u=(await f.Promises.read(t,i,g,s,c)).bytesRead}catch(D){throw this.hb(D)}finally{this.bb(t,c,u)}return u}ab(t,l){return l===this.X.get(t)?null:l}bb(t,l,i){const g=this.X.get(t);typeof g=="number"&&(typeof l=="number"||(typeof i=="number"?this.X.set(t,g+i):this.X.delete(t)))}async write(t,l,i,g,s){return(0,n.$1h)(()=>this.cb(t,l,i,g,s),100,3)}async cb(t,l,i,g,s){const c=this.ab(t,l);let u=null;try{u=(await f.Promises.write(t,i,g,s,c)).bytesWritten}catch(D){throw await this.ib(this.Z.get(t),D)}finally{this.bb(t,c,u)}return u}async mkdir(t){try{await f.Promises.mkdir(this.I(t))}catch(l){throw this.hb(l)}}async delete(t,l){try{const i=this.I(t);if(l.recursive){let g;l?.atomic!==!1&&l.atomic.postfix&&(g=(0,y.$mc)((0,y.$pc)(i),`${(0,y.$qc)(i)}${l.atomic.postfix}`)),await f.Promises.rm(i,f.RimRafMode.MOVE,g)}else try{await f.Promises.unlink(i)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let s=!1;try{const{stat:c,symbolicLink:u}=await f.SymlinkSupport.stat(i);s=c.isDirectory()&&!u}catch{}if(s)await f.Promises.rmdir(i);else throw g}else throw g}}catch(i){throw this.hb(i)}}async rename(t,l,i){const g=this.I(t),s=this.I(l);if(g!==s)try{await this.db(t,l,"move",i.overwrite),await f.Promises.rename(g,s)}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,w.localize)(2,null,(0,y.$qc)(g),(0,y.$qc)((0,y.$pc)(s)),c.toString()))),this.hb(c)}}async copy(t,l,i){const g=this.I(t),s=this.I(l);if(g!==s)try{await this.db(t,l,"copy",i.overwrite),await f.Promises.copy(g,s,{preserveSymlinks:!0})}catch(c){throw(c.code==="EINVAL"||c.code==="EBUSY"||c.code==="ENAMETOOLONG")&&(c=new Error((0,w.localize)(3,null,(0,y.$qc)(g),(0,y.$qc)((0,y.$pc)(s)),c.toString()))),this.hb(c)}}async db(t,l,i,g){const s=this.I(t),c=this.I(l);let u=!1;if(!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,R.$Eg)(s,c,!0)),u){if(i==="copy")throw(0,a.$nl)((0,w.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const P=await this.N(t);if(!P)throw(0,a.$nl)((0,w.localize)(5,null),a.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(l);if(T){if(!g)throw(0,a.$nl)((0,w.localize)(6,null),a.FileSystemProviderErrorCode.FileExists);P.type&a.FileType.File&&T.type&a.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,l){return this.eb(t,l,!1)}async eb(t,l,i){const g=this.I(t),s=this.I(l),c=!!(this.capabilities&a.FileSystemProviderCapabilities.PathCaseSensitive);if((0,R.$Eg)(g,s,!c))return;const u=new A.$Wc;try{u.add(await this.Q(t)),u.add(await this.Q(l)),i&&await f.Promises.mkdir((0,y.$pc)(s),{recursive:!0}),await f.Promises.copyFile(g,s)}catch(D){if(D.code==="ENOENT"&&!i)return this.eb(t,l,!0);throw this.hb(D)}finally{u.dispose()}}t(t,l,i){return new $.$ir(g=>t(g),g=>l(g),i)}F(t,l,i){return new p.$rr(g=>t(g),g=>l(g),i)}hb(t){if(t instanceof a.$ml)return t;let l=t,i;switch(t.code){case"ENOENT":i=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=a.FileSystemProviderErrorCode.Unknown;break;default:i=a.FileSystemProviderErrorCode.Unknown}return(0,a.$nl)(l,i)}async ib(t,l){let i=this.hb(l);if(t&&i.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await f.SymlinkSupport.stat(this.I(t));g.mode&128||(i=(0,a.$nl)(l,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return i}}e.$sr=d,d.L=!1,d.$=!0}),define(Se[258],ke([1,0,6,72,2,15,56,19]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=void 0;class y extends E.$Xc{constructor(v,f){super(),this.a=v,this.b=f,this.F=new Map,this.G=new Map}call(v,f,w){const a=this.c(v);switch(f){case"stat":return this.g(a,w[0]);case"readdir":return this.h(a,w[0]);case"open":return this.r(a,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(a,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(a,w[0],w[1],w[2]);case"rename":return this.z(a,w[0],w[1],w[2]);case"copy":return this.C(a,w[0],w[1],w[2]);case"cloneFile":return this.D(a,w[0],w[1]);case"mkdir":return this.w(a,w[0]);case"delete":return this.y(a,w[0],w[1]);case"watch":return this.I(a,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${f} not found`)}listen(v,f,w){const a=this.c(v);switch(f){case"fileChange":return this.H(a,w[0]);case"readFileStream":return this.m(a,w[0],w[1])}throw new Error(`Unknown event ${f}`)}g(v,f){const w=this.f(v,f,!0);return this.a.stat(w)}h(v,f){const w=this.f(v,f);return this.a.readdir(w)}async j(v,f,w){const a=this.f(v,f,!0);this.b.trace(`File action: readFile ${a.path}`);const h=await this.a.readFile(a,w);return I.$Pe.wrap(h)}m(v,f,w){const a=this.f(v,f,!0),h=new A.$ye,m=new n.$ne({onDidRemoveLastListener:()=>{h.cancel()}});this.b.trace(`File action: readFileStream ${a.path}`);const $=this.a.readFileStream(a,w,h.token);return(0,R.$He)($,{onData:p=>m.fire(I.$Pe.wrap(p)),onError:p=>m.fire(p),onEnd:()=>{m.fire("end"),m.dispose(),h.dispose()}}),m.event}n(v,f,w,a){const h=this.f(v,f);return this.b.trace(`File action: writeFile ${h.path}`),this.a.writeFile(h,w.buffer,a)}r(v,f,w){const a=this.f(v,f,!0);return this.a.open(a,w)}s(v){return this.a.close(v)}async t(v,f,w){const a=I.$Pe.alloc(w),m=await this.a.read(v,f,a.buffer,0,w);return[a,m]}u(v,f,w,a,h){return this.a.write(v,f,w.buffer,a,h)}w(v,f){const w=this.f(v,f);return this.a.mkdir(w)}y(v,f,w){const a=this.f(v,f);return this.a.delete(a,w)}z(v,f,w,a){const h=this.f(v,f),m=this.f(v,w);return this.a.rename(h,m,a)}C(v,f,w,a){const h=this.f(v,f),m=this.f(v,w);return this.a.copy(h,m,a)}D(v,f,w){const a=this.f(v,f),h=this.f(v,w);return this.a.cloneFile(a,h)}H(v,f){const w=new n.$ne({onWillAddFirstListener:()=>{this.F.set(f,this.L(v,w))},onDidRemoveLastListener:()=>{(0,E.$Sc)(this.F.get(f)),this.F.delete(f)}});return w.event}async I(v,f,w,a,h){const m=this.F.get(f);if(m){const $=this.f(v,a),p=m.watch(w,$,h);this.G.set(f+w,p)}}async J(v,f){const w=v+f,a=this.G.get(w);a&&((0,E.$Sc)(a),this.G.delete(w))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$3s=y;class o extends E.$Xc{constructor(v,f,w,a){super(),this.c=v,this.f=w,this.g=a,this.a=new Map,this.b=this.B(new r.$sr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(f)}h(v){const f=this.B(new n.$ne);this.B(f.event(w=>{v.fire(w.map(a=>({resource:this.c.transformOutgoingURI(a.resource),type:a.type,cId:a.cId})))})),this.B(this.b.onDidChangeFile(w=>f.fire(w))),this.B(this.b.onDidWatchError(w=>v.fire(w)))}j(v){}m(v){}watch(v,f,w){const a=this.m(this.g);return Array.isArray(a)&&(w.excludes=[...w.excludes,...a]),this.a.set(v,this.b.watch(f,w)),(0,E.$Vc)(()=>{(0,E.$Sc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$4s=o}),define(Se[125],ke([1,0,4,6,12,2]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=e.$ts=e.$ss=void 0;class R extends E.$lk{constructor(v,f,w,a,h){super(f,w,a),this.r=v,this.t=h,this.B(h.listen("onDidChangeLogLevel",v)(m=>{(0,E.$ck)(m)?super.setLogLevel(m):super.setLogLevel(n.URI.revive(m[0]),m[1])})),this.B(h.listen("onDidChangeVisibility",v)(([m,$])=>super.setVisibility(n.URI.revive(m),$))),this.B(h.listen("onDidChangeLoggers",v)(({added:m,removed:$})=>{for(const p of m)super.registerLogger({...p,resource:n.URI.revive(p.resource)});for(const p of $)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new E.$jk({log:(v,f)=>{this.t.call("consoleLog",[v,f])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,f){super.setLogLevel(v,f),this.t.call("setLogLevel",[v,f])}setVisibility(v,f){super.setVisibility(v,f),this.t.call("setVisibility",[this.n(v),f])}s(v,f,w){return new A(this.t,v,f,w,this.r)}static setLogLevel(v,f,w){return v.call("setLogLevel",[f,w])}}e.$ss=R;class A extends E.$gk{constructor(v,f,w,a,h){super(a?.logLevel==="always"),this.r=v,this.s=f,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[f,a,h]).then(()=>{this.u(this.n),this.m=!0})}g(v,f){const w=[[v,f]];this.m?this.u(w):this.n.push(...w)}u(v){this.r.call("log",[this.s,v])}}class y{constructor(v,f){this.a=v,this.b=f}listen(v,f){const w=this.b(v);switch(f){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(h=>this.c(h,w)),removed:[...a.removed].map(h=>this.c(h,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,a=>[w.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,a=>(0,E.$ck)(a)?a:[w.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${f}`)}async call(v,f,w){const a=this.b(v);switch(f){case"setLogLevel":return(0,E.$ck)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(a.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(h=>this.c(h,a)))}throw new Error(`Call not found: ${f}`)}c(v,f){return{...v,resource:f.transformOutgoingURI(v.resource)}}}e.$ts=y;class o extends I.$Xc{constructor(v,f){super(),f.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(w=>f.call("setLogLevel",[w]))),f.call("getRegisteredLoggers").then(w=>{for(const a of w)v.registerLogger({...a,resource:n.URI.revive(a.resource)})}),this.B(f.listen("onDidChangeVisibility")(([w,a])=>v.setVisibility(n.URI.revive(w),a))),this.B(f.listen("onDidChangeLoggers")(({added:w,removed:a})=>{for(const h of w)v.registerLogger({...h,resource:n.URI.revive(h.resource)});for(const h of a)v.deregisterLogger(h.resource)}))}}e.$us=o}),define(Se[126],ke([1,0,2,12]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qR=void 0;class E extends n.$Xc{constructor(R,A=[]){super(),this.a=new r.$kk([R,...A]),this.B(R.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...A){this.a.trace(R,...A)}debug(R,...A){this.a.debug(R,...A)}info(R,...A){this.a.info(R,...A)}warn(R,...A){this.a.warn(R,...A)}error(R,...A){this.a.error(R,...A)}flush(){this.a.flush()}}e.$qR=E}),define(Se[259],ke([1,0,16,12]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fR=void 0;var E;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(E||(E={}));async function I(o,S,v,f,w){try{const a=await new Promise((m,$)=>{se(["@vscode/spdlog"],m,$)}).then(Be);a.setFlushOn(E.Trace);const h=await a.createAsyncRotatingLogger(o,S,v,f);return w?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(a){console.error(a)}return null}function R(o,S,v){switch(S){case r.LogLevel.Trace:o.trace(v);break;case r.LogLevel.Debug:o.debug(v);break;case r.LogLevel.Info:o.info(v);break;case r.LogLevel.Warning:o.warn(v);break;case r.LogLevel.Error:o.error(v);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${S}`)}}function A(o,S){switch(S){case r.LogLevel.Trace:o.setLevel(E.Trace);break;case r.LogLevel.Debug:o.setLevel(E.Debug);break;case r.LogLevel.Info:o.setLevel(E.Info);break;case r.LogLevel.Warning:o.setLevel(E.Warning);break;case r.LogLevel.Error:o.setLevel(E.Error);break;case r.LogLevel.Off:o.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${S}`)}}class y extends r.$gk{constructor(S,v,f,w,a){super(),this.m=[],this.setLevel(a),this.n=this.s(S,v,f,w),this.B(this.onDidChangeLogLevel(h=>{this.r&&A(this.r,h)}))}async s(S,v,f,w){const a=f?6:1,h=30/a*n.$Il.MB,m=await I(S,v,h,a,w);if(m){this.r=m,A(this.r,this.getLevel());for(const{level:$,message:p}of this.m)R(this.r,$,p);this.m=[]}}g(S,v){this.r?R(this.r,S,v):this.getLevel()<=S&&this.m.push({level:S,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$fR=y}),define(Se[127],ke([1,0,23,12,259]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=void 0;class I extends r.$lk{s(A,y,o){return new E.$fR((0,n.$3g)(),A.fsPath,!o?.donotRotate,!!o?.donotUseFormatters,y)}}e.$gR=I});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[260],ke([1,0,58,220,5]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,n=$t(n);var I;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(y){function o(a,h){return h-a}y.compare=o;const S=Object.create(null);S[y.Error]=(0,r.localize)(0,null),S[y.Warning]=(0,r.localize)(1,null),S[y.Info]=(0,r.localize)(2,null);function v(a){return S[a]||""}y.toString=v;function f(a){switch(a){case n.default.Error:return y.Error;case n.default.Warning:return y.Warning;case n.default.Info:return y.Info;case n.default.Ignore:return y.Hint}}y.fromSeverity=f;function w(a){switch(a){case y.Error:return n.default.Error;case y.Warning:return n.default.Warning;case y.Info:return n.default.Info;case y.Hint:return n.default.Ignore}}y.toSeverity=w}(R||(e.MarkerSeverity=R={}));var A;(function(y){const o="";function S(f){return v(f,!0)}y.makeKey=S;function v(f,w){const a=[o];return f.source?a.push(f.source.replace("\xA6","\\\xA6")):a.push(o),f.code?typeof f.code=="string"?a.push(f.code.replace("\xA6","\\\xA6")):a.push(f.code.value.replace("\xA6","\\\xA6")):a.push(o),f.severity!==void 0&&f.severity!==null?a.push(R.toString(f.severity)):a.push(o),f.message&&w?a.push(f.message.replace("\xA6","\\\xA6")):a.push(o),f.startLineNumber!==void 0&&f.startLineNumber!==null?a.push(f.startLineNumber.toString()):a.push(o),f.startColumn!==void 0&&f.startColumn!==null?a.push(f.startColumn.toString()):a.push(o),f.endLineNumber!==void 0&&f.endLineNumber!==null?a.push(f.endLineNumber.toString()):a.push(o),f.endColumn!==void 0&&f.endColumn!==null?a.push(f.endColumn.toString()):a.push(o),a.push(o),a.join("\xA6")}y.makeKeyOptionalMessage=v})(A||(e.IMarkerData=A={})),e.$Eu=(0,E.$Gi)("markerService")}),define(Se[73],ke([1,0,6,40,2,5]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=void 0,e.$uo=(0,I.$Gi)("policy");class R extends E.$Xc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$ne),this.onDidChange=this.h.event}async updatePolicyDefinitions(o){const S=Object.keys(this.f).length;return this.f={...o,...this.f},S!==Object.keys(this.f).length&&await this.j(o),r.Iterable.reduce(this.g.entries(),(v,[f,w])=>({...v,[f]:w}),{})}getPolicyValue(o){return this.g.get(o)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(o,[S,v])=>({...o,[S]:{definition:v,value:this.g.get(S)}}),{})}}e.$vo=R;class A{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$wo=A}),define(Se[62],ke([1,0,32]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const I=E.context.configuration();if(I)r=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:I.version})}Object.assign(r,{extensionsGallery:n.env.EXTENSIONS_GALLERY?JSON.parse(n.env.EXTENSIONS_GALLERY):r.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""},telemetryEndpoint:n.env.CS_TELEMETRY_URL||r.telemetryEndpoint||"https://v1.telemetry.coder.com/track"})}else r={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.91.0",sha256:"53b99146c7fa280f00c74414e09721530c622bf3e5eac2c967ddfb9906b51c80",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.91.0",commit:"090e0fad76152d6a0c10903a3bbf8a83d09e93d0",date:"2024-07-08T22:14:43.429Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(Se[29],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,n.$Gi)("productService"),e.$uk="vscode://schemas/vscode-product"}),define(Se[261],ke([1,0,14,19,2,5]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.ProgressLocation=e.$vw=void 0,e.$vw=(0,I.$Gi)("progressService");var R;(function(v){v[v.Explorer=1]="Explorer",v[v.Scm=3]="Scm",v[v.Extensions=5]="Extensions",v[v.Window=10]="Window",v[v.Notification=15]="Notification",v[v.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$ww=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(f){this.b=f}report(f){this.a=f,this.b(this.a)}}e.$xw=A,A.None=Object.freeze({report(){}});class y{get value(){return this.a}constructor(f){this.e=f}report(f){this.b?this.b.push(f):this.b=[f],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const f=this.b.shift();this.a=f,await this.e(this.a)}}finally{this.c=!1;const f=this.d;this.d=void 0,f?.()}}drain(){return this.c?new Promise(f=>{const w=this.d;this.d=()=>{w?.(),f()}}):Promise.resolve()}}e.$yw=y;let o=class extends E.$Xc{constructor(f,w){super(),this.a=new n.$4h,w.withProgress(f,a=>(this.b=a,this.c&&a.report(this.c),this.a.p)),this.B((0,E.$Vc)(()=>this.a.complete()))}report(f){this.b?this.b.report(f):this.c=f}};e.$zw=o,e.$zw=o=ze([Fe(1,e.$vw)],o);class S extends E.$Xc{constructor(f){super(),this.g=f,this.a=0,this.b=this.B(new E.$Wc)}start(f){this.stop();const w=++this.a,a=new r.$ye;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},f),this.b.add((0,E.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,E.$Vc)(()=>a.cancel())),this.b.add((0,E.$Vc)(()=>this.c?this.c.done():void 0)),{id:w,token:a.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(f){this.a===f&&this.b.clear()}}e.$Aw=S,e.$Bw=(0,I.$Gi)("editorProgressService")}),define(Se[38],ke([1,0,107,11]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,n=Be(n),r=Be(r);class E{constructor(){this.a=new Map}add(R,A){n.ok(r.$gg(R)),n.ok(r.$ig(A)),n.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,A)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$so=new E}),define(Se[128],ke([1,0,6,38]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,r=Be(r),e.$to={JSONContribution:"base.contributions.json"};function E(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class I{constructor(){this.b=new n.$ne,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,o){this.a[E(y)]=o,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const R=new I;r.$so.add(e.$to.JSONContribution,R)}),define(Se[46],ke([1,0,18,6,11,201,27,128,38]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ConfigurationScope=e.$xo=e.EditPresentationTypes=void 0,e.$Io=h,e.$Jo=m,e.$Ko=$,e.$Lo=d,e.$Mo=b,E=Be(E),I=Be(I);var o;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(o||(e.EditPresentationTypes=o={})),e.$xo={Configuration:"base.contributions.configuration"};var S;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo="vscode://schemas/settings/resourceLanguage",e.$Fo="vscode://schemas/settings/configurationDefaults";const v=y.$so.as(A.$to.JSONContribution);class f{constructor(){this.h=new Set,this.i=new r.$ne,this.onDidSchemaChange=this.i.event,this.j=new r.$ne,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$Eo,this.g),this.v()}registerConfiguration(l,i=!0){this.registerConfigurations([l],i)}registerConfigurations(l,i=!0){const g=new Set;this.n(l,i,g),v.registerSchema(e.$Eo,this.g),this.i.fire(),this.j.fire({properties:g})}deregisterConfigurations(l){const i=new Set;this.o(l,i),v.registerSchema(e.$Eo,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:l,remove:i}){const g=new Set;this.o(i,g),this.n(l,!1,g),v.registerSchema(e.$Eo,this.g),this.i.fire(),this.j.fire({properties:g})}registerDefaultConfigurations(l){const i=new Set;this.k(l,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(l,i){const g=[];for(const{overrides:s,source:c}of l)for(const u in s)if(i.add(u),e.$Ho.test(u)){const D=this.a.get(u),P=D?.valuesSources??new Map,T=D?.value||{};for(const k of Object.keys(s[u])){const q=s[u][k];if(E.$ig(q)&&(E.$ng(T[k])||E.$ig(T[k]))){if(T[k]={...T[k]??{},...q},c){let J=P.get(k);if(J||(J=new Map,P.set(k,J)),!(J instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const ne in q)J.set(ne,c)}}else T[k]=q,c&&P.set(k,c)}this.a.set(u,{source:c,value:T,valuesSources:P});const z=(0,R.$kj)(u),C={type:"object",default:T,description:I.localize(1,null,z),$ref:e.$Eo,defaultDefaultValue:T,source:E.$gg(c)?void 0:c,defaultValueSource:c};g.push(...h(u)),this.d[u]=C,this.b.properties[u]=C}else{const D=this.d[u],P=this.a.get(u);let T=P?.value??D?.defaultDefaultValue,z=s[u],C=c;if(E.$ig(z)&&(D!==void 0&&D.type==="object"||D===void 0&&(E.$ng(T)||E.$ig(T)))){if(E.$ig(T)||(T={}),z={...T,...z},C=P?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const q in s[u])c?C.set(q,c):C.delete(q)}this.a.set(u,{value:z,source:C}),D&&(this.w(u,D),this.r(u,D))}this.m(g)}deregisterDefaultConfigurations(l){const i=new Set;this.l(l,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(l,i){for(const{overrides:g,source:s}of l)for(const c in g){const u=E.$gg(s)?s:s?.id,D=this.a.get(c);if(D){if(e.$Ho.test(c)){for(const T of Object.keys(g[c])){const z=g[c][T];if(E.$ig(z)){const C=D.valuesSources?.get(T);for(const k of Object.keys(z)){const q=C?.get(k);(E.$gg(q)?q:q?.id)===u&&(C?.delete(k),delete D.value[T][k])}Object.keys(D.value[T]).length===0&&(delete D.value[T],D.valuesSources?.delete(T))}else{const C=D.valuesSources?.get(T);(E.$gg(C)?C:C?.id)===u&&(D.valuesSources?.delete(T),delete D.value[T])}}const P=this.a.get(c);P&&Object.keys(P.value).length===0&&(this.a.delete(c),delete this.d[c],delete this.b.properties[c])}else{if(D.source instanceof Map){const T=D.source;for(const z in g[c]){const C=T.get(z);(E.$gg(C)?C:C?.id)===u&&(T.delete(z),delete D.value[z])}T.size===0&&this.a.delete(c)}else{const T=E.$gg(D.source)?D.source:D.source?.id;if(u!==T)continue;this.a.delete(c)}const P=this.d[c];P&&(this.w(c,P),this.r(c,P))}i.add(c)}}this.u()}deltaConfiguration(l){let i=!1;const g=new Set;l.removedDefaults&&(this.l(l.removedDefaults,g),i=!0),l.addedDefaults&&(this.k(l.addedDefaults,g),i=!0),l.removedConfigurations&&this.o(l.removedConfigurations,g),l.addedConfigurations&&this.n(l.addedConfigurations,!1,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...l){this.i.fire()}registerOverrideIdentifiers(l){this.m(l),this.i.fire()}m(l){for(const i of l)this.h.add(i);this.u()}n(l,i,g){l.forEach(s=>{this.p(s,i,s.extensionInfo,s.restrictedProperties,void 0,g),this.c.push(s),this.q(s)})}o(l,i){const g=s=>{if(s.properties)for(const c in s.properties){i.add(c);const u=this.d[c];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[c],this.s(c,s.properties[c])}s.allOf?.forEach(c=>g(c))};for(const s of l){g(s);const c=this.c.indexOf(s);c!==-1&&this.c.splice(c,1)}}p(l,i=!0,g,s,c=S.WINDOW,u){c=E.$pg(l.scope)?c:l.scope;const D=l.properties;if(D)for(const T in D){const z=D[T];if(i&&d(T,z)){delete D[T];continue}if(z.source=g,z.defaultDefaultValue=D[T].default,this.w(T,z),e.$Ho.test(T)?z.scope=void 0:(z.scope=E.$pg(z.scope)?c:z.scope,z.restricted=E.$pg(z.restricted)?!!s?.includes(T):z.restricted),D[T].hasOwnProperty("included")&&!D[T].included){this.f[T]=D[T],delete D[T];continue}else this.d[T]=D[T],D[T].policy?.name&&this.e.set(D[T].policy.name,T);!D[T].deprecationMessage&&D[T].markdownDeprecationMessage&&(D[T].deprecationMessage=D[T].markdownDeprecationMessage),u.add(T)}const P=l.allOf;if(P)for(const T of P)this.p(T,i,g,s,c,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(l){const i=g=>{const s=g.properties;if(s)for(const u in s)this.r(u,s[u]);g.allOf?.forEach(i)};i(l)}r(l,i){switch(e.$yo.properties[l]=i,i.scope){case S.APPLICATION:e.$zo.properties[l]=i;break;case S.MACHINE:e.$Ao.properties[l]=i;break;case S.MACHINE_OVERRIDABLE:e.$Bo.properties[l]=i;break;case S.WINDOW:e.$Co.properties[l]=i;break;case S.RESOURCE:e.$Do.properties[l]=i;break;case S.LANGUAGE_OVERRIDABLE:e.$Do.properties[l]=i,this.g.properties[l]=i;break}}s(l,i){switch(delete e.$yo.properties[l],i.scope){case S.APPLICATION:delete e.$zo.properties[l];break;case S.MACHINE:delete e.$Ao.properties[l];break;case S.MACHINE_OVERRIDABLE:delete e.$Bo.properties[l];break;case S.WINDOW:delete e.$Co.properties[l];break;case S.RESOURCE:case S.LANGUAGE_OVERRIDABLE:delete e.$Do.properties[l],delete this.g.properties[l];break}}u(){for(const l of this.h.values()){const i=`[${l}]`,g={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$Eo};this.w(i,g),e.$yo.properties[i]=g,e.$zo.properties[i]=g,e.$Ao.properties[i]=g,e.$Bo.properties[i]=g,e.$Co.properties[i]=g,e.$Do.properties[i]=g}}v(){const l={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$Eo};e.$yo.patternProperties[e.$Go]=l,e.$zo.patternProperties[e.$Go]=l,e.$Ao.patternProperties[e.$Go]=l,e.$Bo.patternProperties[e.$Go]=l,e.$Co.patternProperties[e.$Go]=l,e.$Do.patternProperties[e.$Go]=l,this.i.fire()}w(l,i){const g=this.a.get(l);let s=g?.value,c=g?.source;E.$ng(s)&&(s=i.defaultDefaultValue,c=void 0),E.$ng(s)&&(s=$(i.type)),i.default=s,i.defaultValueSource=c}}const w="\\[([^\\]]+)\\]",a=new RegExp(w,"g");e.$Go=`^(${w})+$`,e.$Ho=new RegExp(e.$Go);function h(t){const l=[];if(e.$Ho.test(t)){let i=a.exec(t);for(;i?.length;){const g=i[1].trim();g&&l.push(g),i=a.exec(t)}}return(0,n.$Pb)(l)}function m(t){return t.reduce((l,i)=>`${l}[${i}]`,"")}function $(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new f;y.$so.add(e.$xo.Configuration,p);function d(t,l){return t.trim()?e.$Ho.test(t)?I.localize(7,null,t):p.getConfigurationProperties()[t]!==void 0?I.localize(8,null,t):l.policy?.name&&p.getPolicyConfigurations().get(l.policy?.name)!==void 0?I.localize(9,null,t,l.policy?.name,p.getPolicyConfigurations().get(l.policy?.name)):null:I.localize(6,null)}function b(){const t=[],l=p.getConfigurationProperties();for(const i of Object.keys(l))t.push([i,l[i].scope]);return t.push(["launch",S.RESOURCE]),t.push(["task",S.RESOURCE]),t}}),define(Se[129],ke([1,0,18,6,43,2,26,21,11,4,27,46,16,38]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$Ro=b,n=Be(n),E=Be(E),A=Be(A),y=Be(y);function a(g){return Object.isFrozen(g)?g:A.$go(g)}class h{static createEmptyModel(s){return new h({},[],[],void 0,s)}constructor(s,c,u,D,P){this.b=s,this.c=c,this.d=u,this.raw=D,this.f=P,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(c=>{if(c instanceof h)return c;const u=new m("",this.f);return u.parseRaw(c),u.configurationModel});this.g=s.reduce((c,u)=>u===c?u:c.merge(u),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,S.$ij)(this.contents,s):this.contents}inspect(s,c){const u=this;return{get value(){return a(u.rawConfiguration.getValue(s))},get override(){return c?a(u.rawConfiguration.getOverrideValue(s,c)):void 0},get merged(){return a(c?u.rawConfiguration.override(c).getValue(s):u.rawConfiguration.getValue(s))},get overrides(){const D=[];for(const{contents:P,identifiers:T,keys:z}of u.rawConfiguration.overrides){const C=new h(P,z,[],void 0,u.f).getValue(s);C!==void 0&&D.push({identifiers:T,value:C})}return D.length?a(D):void 0}}}getOverrideValue(s,c){const u=this.j(c);return u?s?(0,S.$ij)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const c=[];for(const u of this.overrides)u.identifiers.includes(s)&&c.push(...u.keys);return n.$Pb(c)}getAllOverrideIdentifiers(){const s=[];for(const c of this.overrides)s.push(...c.identifiers);return n.$Pb(s)}override(s){let c=this.a.get(s);return c||(c=this.h(s),this.a.set(s,c)),c}merge(...s){const c=A.$fo(this.contents),u=A.$fo(this.overrides),D=[...this.keys],P=this.raw?.length?[...this.raw]:[this];for(const T of s)if(P.push(...T.raw?.length?T.raw:[T]),!T.isEmpty()){this.i(c,T.contents);for(const z of T.overrides){const[C]=u.filter(k=>n.$xb(k.identifiers,z.identifiers));C?(this.i(C.contents,z.contents),C.keys.push(...z.keys),C.keys=n.$Pb(C.keys)):u.push(A.$fo(z))}for(const z of T.keys)D.indexOf(z)===-1&&D.push(z)}return new h(c,D,u,P.every(T=>T instanceof h)?void 0:P,this.f)}h(s){const c=this.j(s);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const u={};for(const D of n.$Pb([...Object.keys(this.contents),...Object.keys(c)])){let P=this.contents[D];const T=c[D];T&&(typeof P=="object"&&typeof T=="object"?(P=A.$fo(P),this.i(P,T)):P=T),u[D]=P}return new h(u,this.keys,this.overrides,void 0,this.f)}i(s,c){for(const u of Object.keys(c)){if(u in s&&y.$ig(s[u])&&y.$ig(c[u])){this.i(s[u],c[u]);continue}s[u]=A.$fo(c[u])}}j(s){let c=null,u=null;const D=P=>{P&&(u?this.i(u,P):u=A.$fo(P))};for(const P of this.overrides)P.identifiers.length===1&&P.identifiers[0]===s?c=P.contents:P.identifiers.includes(s)&&D(P.contents);return D(c),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,c){this.k(s,c,!0)}setValue(s,c){this.k(s,c,!1)}removeValue(s){const c=this.keys.indexOf(s);c!==-1&&(this.keys.splice(c,1),(0,S.$hj)(this.contents,s),v.$Ho.test(s)&&this.overrides.splice(this.overrides.findIndex(u=>n.$xb(u.identifiers,(0,v.$Io)(s))),1))}k(s,c,u){(0,S.$gj)(this.contents,s,c,D=>this.f.error(D)),u=u||this.keys.indexOf(s)===-1,u&&this.keys.push(s),v.$Ho.test(s)&&this.overrides.push({identifiers:(0,v.$Io)(s),keys:Object.keys(this.contents[s]),contents:(0,S.$fj)(this.contents[s],D=>this.f.error(D))})}}e.$No=h;class m{constructor(s,c){this.f=s,this.g=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||h.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,c){if(!y.$pg(s)){const u=this.h(s);this.parseRaw(u,c)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,c){this.a=s;const{contents:u,keys:D,overrides:P,restricted:T,hasExcludedProperties:z}=this.i(s,c);this.b=new h(u,D,P,z?[s]:void 0,this.g),this.c=T||[]}h(s){let c={},u=null,D=[];const P=[],T=[];function z(k){Array.isArray(D)?D.push(k):u!==null&&(D[u]=k)}const C={onObjectBegin:()=>{const k={};z(k),P.push(D),D=k,u=null},onObjectProperty:k=>{u=k},onObjectEnd:()=>{D=P.pop()},onArrayBegin:()=>{const k=[];z(k),P.push(D),D=k,u=null},onArrayEnd:()=>{D=P.pop()},onLiteralValue:z,onError:(k,q,Y)=>{T.push({error:k,offset:q,length:Y})}};if(s)try{E.$7n(s,C),c=D[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return c}i(s,c){const u=w.$so.as(v.$xo.Configuration).getConfigurationProperties(),D=this.j(s,u,!0,c);s=D.raw;const P=(0,S.$fj)(s,C=>this.g.error(`Conflict in settings file ${this.f}: ${C}`)),T=Object.keys(s),z=this.l(s,C=>this.g.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:P,keys:T,overrides:z,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(s,c,u,D){let P=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:P};const T={},z=[];for(const C in s)if(v.$Ho.test(C)&&u){const k=this.j(s[C],c,!1,D);T[C]=k.raw,P=P||k.hasExcludedProperties,z.push(...k.restricted)}else{const k=c[C],q=k?typeof k.scope<"u"?k.scope:v.ConfigurationScope.WINDOW:void 0;k?.restricted&&z.push(C),!D.exclude?.includes(C)&&(D.include?.includes(C)||(q===void 0||D.scopes===void 0||D.scopes.includes(q))&&!(D.skipRestricted&&k?.restricted))?T[C]=s[C]:P=!0}return{raw:T,restricted:z,hasExcludedProperties:P}}l(s,c){const u=[];for(const D of Object.keys(s))if(v.$Ho.test(D)){const P={};for(const T in s[D])P[T]=s[D][T];u.push({identifiers:(0,v.$Io)(D),keys:Object.keys(P),contents:(0,S.$fj)(P,c)})}return u}}e.$Oo=m;class $ extends I.$Xc{constructor(s,c,u,D,P){super(),this.c=s,this.f=c,this.g=D,this.h=P,this.b=this.B(new r.$ne),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),P),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,T=>T.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,T=>(T.isOperation(f.FileOperation.CREATE)||T.isOperation(f.FileOperation.COPY)||T.isOperation(f.FileOperation.DELETE)||T.isOperation(f.FileOperation.WRITE))&&u.isEqual(T.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return h.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Po=$;class p{constructor(s,c,u,D,P,T,z,C,k,q,Y,J,ne){this.a=s,this.b=c,this.c=u,this.overrideIdentifiers=D,this.d=P,this.f=T,this.g=z,this.h=C,this.i=k,this.j=q,this.k=Y,this.l=J,this.m=ne}get value(){return a(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(s,c,u,D,P,T,z,C,k,q){this.j=s,this.l=c,this.m=u,this.n=D,this.p=P,this.q=T,this.r=z,this.s=C,this.t=k,this.u=q,this.h=null,this.i=new R.$Dc,this.v=null}getValue(s,c,u){return this.w(s,c,u).getValue(s)}updateValue(s,c,u={}){let D;u.resource?(D=this.t.get(u.resource),D||(D=h.createEmptyModel(this.u),this.t.set(u.resource,D))):D=this.s,c===void 0?D.removeValue(s):D.setValue(s,c),u.resource||(this.h=null)}inspect(s,c,u){const D=this.w(s,c,u),P=this.A(c.resource,u),T=c.resource?this.t.get(c.resource)||this.s:this.s,z=new Set;for(const C of D.overrides)for(const k of C.identifiers)D.getOverrideValue(s,k)!==void 0&&z.add(k);return new p(s,c,D.getValue(s),z.size?[...z]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,P||void 0,T)}keys(s){const c=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,c){this.r.set(s,c),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,c){const u=[];if(!c){const{added:D,updated:P,removed:T}=l(this.j,s);c=[...D,...P,...T]}for(const D of c)for(const P of(0,v.$Io)(D)){const T=this.j.getKeysForOverrideIdentifier(P),z=s.getKeysForOverrideIdentifier(P),C=[...z.filter(k=>T.indexOf(k)===-1),...T.filter(k=>z.indexOf(k)===-1),...T.filter(k=>!A.$jo(this.j.override(P).getValue(k),s.override(P).getValue(k)))];u.push([P,C])}return this.updateDefaultConfiguration(s),{keys:c,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:c,updated:u,removed:D}=l(this.l,s),P=[...c,...u,...D];return P.length&&this.updatePolicyConfiguration(s),{keys:P,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:c,updated:u,removed:D,overrides:P}=l(this.applicationConfiguration,s),T=[...c,...u,...D];return T.length&&this.updateApplicationConfiguration(s),{keys:T,overrides:P}}compareAndUpdateLocalUserConfiguration(s){const{added:c,updated:u,removed:D,overrides:P}=l(this.localUserConfiguration,s),T=[...c,...u,...D];return T.length&&this.updateLocalUserConfiguration(s),{keys:T,overrides:P}}compareAndUpdateRemoteUserConfiguration(s){const{added:c,updated:u,removed:D,overrides:P}=l(this.remoteUserConfiguration,s),T=[...c,...u,...D];return T.length&&this.updateRemoteUserConfiguration(s),{keys:T,overrides:P}}compareAndUpdateWorkspaceConfiguration(s){const{added:c,updated:u,removed:D,overrides:P}=l(this.workspaceConfiguration,s),T=[...c,...u,...D];return T.length&&this.updateWorkspaceConfiguration(s),{keys:T,overrides:P}}compareAndUpdateFolderConfiguration(s,c){const u=this.folderConfigurations.get(s),{added:D,updated:P,removed:T,overrides:z}=l(u,c),C=[...D,...P,...T];return(C.length||!u)&&this.updateFolderConfiguration(s,c),{keys:C,overrides:z}}compareAndDeleteFolderConfiguration(s){const c=this.folderConfigurations.get(s);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:D,removed:P,overrides:T}=l(c,void 0);return{keys:[...u,...D,...P],overrides:T}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,c,u){let D=this.x(c,u);return c.overrideIdentifier&&(D=D.override(c.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(D=D.merge(this.l)),D}x({resource:s},c){let u=this.y();if(c&&s){const D=c.getFolder(s);D&&(u=this.z(D.uri)||u);const P=this.t.get(s);P&&(u=u.merge(P))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let c=this.i.get(s);if(!c){const u=this.y(),D=this.r.get(s);D?(c=u.merge(D),this.i.set(s,c)):c=u}return c}A(s,c){if(c&&s){const u=c.getFolder(s);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,c)=>{const{contents:u,overrides:D,keys:P}=this.r.get(c);return s.push([c,{contents:u,overrides:D,keys:P}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(c=>s.add(c)),this.userConfiguration.keys.forEach(c=>s.add(c)),this.q.keys.forEach(c=>s.add(c)),this.r.forEach(c=>c.keys.forEach(u=>s.add(u))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.q.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.r.forEach(c=>c.getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}D(s){const c=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(u=>c.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>c.add(u)),this.q.getKeysForOverrideIdentifier(s).forEach(u=>c.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(D=>c.add(D))),[...c.values()]}static parse(s,c){const u=this.E(s.defaults,c),D=this.E(s.policy,c),P=this.E(s.application,c),T=this.E(s.user,c),z=this.E(s.workspace,c),C=s.folders.reduce((k,q)=>(k.set(o.URI.revive(q[0]),this.E(q[1],c)),k),new R.$Dc);return new d(u,D,P,T,h.createEmptyModel(c),z,C,h.createEmptyModel(c),new R.$Dc,c)}static E(s,c){return new h(s.contents,s.keys,s.overrides,void 0,c)}}e.$Qo=d;function b(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const s=new Set,c=new Map;for(const D of g)D.keys.forEach(P=>s.add(P)),D.overrides.forEach(([P,T])=>{const z=(0,R.$Ac)(c,P,new Set);T.forEach(C=>z.add(C))});const u=[];return c.forEach((D,P)=>u.push([P,[...D.values()]])),{keys:[...s.values()],overrides:u}}class t{constructor(s,c,u,D,P){this.change=s,this.f=c,this.g=u,this.h=D,this.i=P,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const T of s.keys)this.affectedKeys.add(T);for(const[,T]of s.overrides)for(const z of T)this.affectedKeys.add(z);this.d=this.a;for(const T of this.affectedKeys)this.d+=T+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=d.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,c){const u=this.a+s,D=this.d.indexOf(u);if(D<0)return!1;const P=D+u.length;if(P>=this.d.length)return!1;const T=this.d.charCodeAt(P);if(T!==this.b&&T!==this.c)return!1;if(c){const z=this.previousConfiguration?this.previousConfiguration.getValue(s,c,this.f?.workspace):void 0,C=this.g.getValue(s,c,this.h);return!A.$jo(z,C)}return!0}}e.$So=t;function l(g,s){const{added:c,removed:u,updated:D}=i(s?.rawConfiguration,g?.rawConfiguration),P=[],T=g?.getAllOverrideIdentifiers()||[],z=s?.getAllOverrideIdentifiers()||[];if(s){const C=z.filter(k=>!T.includes(k));for(const k of C)P.push([k,s.getKeysForOverrideIdentifier(k)])}if(g){const C=T.filter(k=>!z.includes(k));for(const k of C)P.push([k,g.getKeysForOverrideIdentifier(k)])}if(s&&g){for(const C of T)if(z.includes(C)){const k=i({contents:g.getOverrideValue(void 0,C)||{},keys:g.getKeysForOverrideIdentifier(C)},{contents:s.getOverrideValue(void 0,C)||{},keys:s.getKeysForOverrideIdentifier(C)});P.push([C,[...k.added,...k.removed,...k.updated]])}}return{added:c,removed:u,updated:D,overrides:P}}function i(g,s){const c=g?s?g.keys.filter(P=>s.keys.indexOf(P)===-1):[...g.keys]:[],u=s?g?s.keys.filter(P=>g.keys.indexOf(P)===-1):[...s.keys]:[],D=[];if(g&&s){for(const P of s.keys)if(g.keys.indexOf(P)!==-1){const T=(0,S.$ij)(s.contents,P),z=(0,S.$ij)(g.contents,P);A.$jo(T,z)||D.push(P)}}return{added:c,removed:u,updated:D}}}),define(Se[262],ke([1,0,18,6,2,21,11,129,46,12,73,38]),function(se,e,n,r,E,I,R,A,y,o,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=void 0;class f extends E.$Xc{get configurationModel(){return this.b}constructor(m){super(),this.c=m,this.a=this.B(new r.$ne),this.onDidChangeConfiguration=this.a.event,this.b=A.$No.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(v.$so.as(y.$xo.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:$})=>this.f(Array.from(m),$))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(m,$){this.j(m,v.$so.as(y.$xo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}g(){return{}}h(){this.b=A.$No.createEmptyModel(this.c);const m=v.$so.as(y.$xo.Configuration).getConfigurationProperties();this.j(Object.keys(m),m)}j(m,$){const p=this.g();for(const d of m){const b=p[d],t=$[d];b!==void 0?this.b.addValue(d,b):t?this.b.addValue(d,t.default):this.b.removeValue(d)}}}e.$To=f;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=A.$No.createEmptyModel(new o.$nk)}async initialize(){return this.configurationModel}}e.$Uo=w;let a=class extends E.$Xc{get configurationModel(){return this.b}constructor(m,$,p){super(),this.c=m,this.f=$,this.g=p,this.a=this.B(new r.$ne),this.onDidChangeConfiguration=this.a.event,this.b=A.$No.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const $={},p=[],d=v.$so.as(y.$xo.Configuration).getConfigurationProperties();for(const b of m){const t=d[b];if(!t){p.push(b);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}p.push(b),$[t.policy.name]={type:t.type}}}return(0,R.$tg)($)||await this.f.updatePolicyDefinitions($),p}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const $=v.$so.as(y.$xo.Configuration).getPolicyConfigurations(),p=(0,n.$Kb)(m.map(d=>$.get(d)));this.m(p,!0)}m(m,$){this.g.trace("PolicyConfiguration#update",m);const p=v.$so.as(y.$xo.Configuration).getConfigurationProperties(),d=[],b=this.b.isEmpty();for(const t of m){const l=p[t]?.policy?.name;if(l){const i=this.f.getPolicyValue(l);(b?i!==void 0:!(0,I.$jo)(this.b.getValue(t),i))&&d.push([t,i])}else this.b.getValue(t)!==void 0&&d.push([t,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const t=this.b;this.b=A.$No.createEmptyModel(this.g);for(const l of t.keys)this.b.setValue(l,t.getValue(l));for(const[l,i]of d)i===void 0?this.b.removeValue(l):this.b.setValue(l,i);$&&this.a.fire(this.b)}}};e.$Vo=a,e.$Vo=a=ze([Fe(1,S.$uo),Fe(2,o.$ak)],a)}),define(Se[130],ke([1,0,18,14,15,6,43,160,2,26,21,3,20,27,129,46,262,16,73]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=void 0;class d extends y.$Xc{constructor(l,i,g,s){super(),this.m=l,this.n=s,this.h=this.B(new I.$ne),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.$To(s)),this.c=g instanceof p.$wo?new m.$Uo:this.B(new m.$Vo(this.b,g,s)),this.f=this.B(new a.$Po(this.m,{},f.$$g,i,s)),this.a=new a.$Qo(this.b.configurationModel,this.c.configurationModel,a.$No.createEmptyModel(s),a.$No.createEmptyModel(s),a.$No.createEmptyModel(s),a.$No.createEmptyModel(s),new o.$Dc,a.$No.createEmptyModel(s),new o.$Dc,s),this.j=new b(l,i,this),this.g=this.B(new r.$Sh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.s(c,u))),this.B(this.c.onDidChangeConfiguration(c=>this.t(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,i,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new a.$Qo(l,i,a.$No.createEmptyModel(this.n),g,a.$No.createEmptyModel(this.n),a.$No.createEmptyModel(this.n),new o.$Dc,a.$No.createEmptyModel(this.n),new o.$Dc,this.n)}getConfigurationData(){return this.a.toData()}getValue(l,i){const g=typeof l=="string"?l:void 0,s=(0,w.$bj)(l)?l:(0,w.$bj)(i)?i:{};return this.a.getValue(g,s,void 0)}async updateValue(l,i,g,s,c){const u=(0,w.$cj)(g)?g:(0,w.$bj)(g)?{resource:g.resource,overrideIdentifiers:g.overrideIdentifier?[g.overrideIdentifier]:void 0}:void 0,D=u?s:g;if(D!==void 0&&D!==w.ConfigurationTarget.USER_LOCAL&&D!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${D}.`);u?.overrideIdentifiers&&(u.overrideIdentifiers=(0,n.$Pb)(u.overrideIdentifiers),u.overrideIdentifiers=u.overrideIdentifiers.length?u.overrideIdentifiers:void 0);const P=this.inspect(l,{resource:u?.resource,overrideIdentifier:u?.overrideIdentifiers?u.overrideIdentifiers[0]:void 0});if(P.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,S.$jo)(i,P.defaultValue)&&(i=void 0),u?.overrideIdentifiers?.length&&u.overrideIdentifiers.length>1){const z=u.overrideIdentifiers.sort(),C=this.a.localUserConfiguration.overrides.find(k=>(0,n.$xb)([...k.identifiers].sort(),z));C&&(u.overrideIdentifiers=C.identifiers)}const T=u?.overrideIdentifiers?.length?[(0,h.$Jo)(u.overrideIdentifiers),l]:[l];await this.j.write(T,i),await this.reloadConfiguration()}inspect(l,i={}){return this.a.inspect(l,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.r(l)}r(l){const i=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(l);this.u(g,i,w.ConfigurationTarget.USER)}s(l,i){const g=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(l,i);this.u(s,g,w.ConfigurationTarget.DEFAULT)}t(l){const i=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(l);this.u(g,i,w.ConfigurationTarget.DEFAULT)}u(l,i,g){const s=new a.$So(l,{data:i},this.a,void 0,this.n);s.source=g,this.h.fire(s)}}e.$Wo=d;class b{constructor(l,i,g){this.b=l,this.c=i,this.d=g,this.a=new r.$Nh}write(l,i){return this.a.queue(()=>this.e(l,i))}async e(l,i){let g;try{g=(await this.c.readFile(this.b)).value.toString()}catch(u){if(u.fileOperationResult===$.FileOperationResult.FILE_NOT_FOUND)g="{}";else throw u}const s=[];if((0,R.$Zn)(g,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const c=this.f(g,l,i);g=(0,A.$eo)(g,c),await this.c.writeFile(this.b,E.$Pe.fromString(g))}f(l,i,g){const{tabSize:s,insertSpaces:c,eol:u}=this.h;if(!i.length){const D=JSON.stringify(g,null,c?" ".repeat(s):"	");return[{content:D,length:D.length,offset:0}]}return(0,A.$bo)(l,i,g,{tabSize:s,insertSpaces:c,eol:u})}get h(){if(!this.g){let l=v.OS===v.OperatingSystem.Linux||v.OS===v.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(l=i),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(Se[90],ke([1,0,10,5]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=o,e.$Rl=(0,r.$Gi)("remoteAuthorityResolverService");var E;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class I{constructor(v){this.id=v,this.type=E.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=I;class R{constructor(v,f){this.host=v,this.port=f,this.type=E.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=R;var A;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class y extends n.$eb{static isNotAvailable(v){return v instanceof y&&v._code===A.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof y&&v._code===A.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof y&&v._code===A.NoResolverFound}static isInvalidAuthority(v){return v instanceof y&&v._code===A.InvalidAuthority}static isHandled(v){return v instanceof y&&v.isHandled}constructor(v,f=A.Unknown,w){super(v),this._message=v,this._code=f,this._detail=w,this.isHandled=f===A.NotAvailable&&w===!0,Object.setPrototypeOf(this,y.prototype)}}e.$Ul=y;function o(S){const v=S.indexOf("+");return v===-1?S:S.substring(0,v)}}),define(Se[263],ke([1,0,14,15,19,10,6,2,13,44,48,23,61,90]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=P,e.$2l=T,e.$3l=C,o=Be(o);const a=30*1e3;var h;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(h||(e.ConnectionType=h={}));function m(_){switch(_){case h.Management:return"Management";case h.ExtensionHost:return"ExtensionHost";case h.Tunnel:return"Tunnel"}}function $(_){const U=new E.$ye;return setTimeout(()=>U.cancel(),_),U.token}function p(_,U){if(_.isCancellationRequested||U.isCancellationRequested)return E.CancellationToken.Cancelled;const O=new E.$ye;return _.onCancellationRequested(()=>O.cancel()),U.onCancellationRequested(()=>O.cancel()),O.token}class d{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new A.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$zh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function b(_,U){const O=new d(U);return O.registerDisposable(_.onControlMessage(te=>{const V=JSON.parse(te.toString()),j=B(V);j?O.reject(j):O.resolve(V)})),O.promise}function t(_,U,O,te,V,j,G,Q){const N=new d(Q),H=S.$he.create(!1);return _.info(`Creating a socket (${G})...`),o.mark(`code/willCreateSocket/${j}`),U.connect(O,te,V,G).then(oe=>{N.didTimeout?(o.mark(`code/didCreateSocketError/${j}`),_.info(`Creating a socket (${G}) finished after ${H.elapsed()} ms, but this is too late and has timed out already.`),oe?.dispose()):(o.mark(`code/didCreateSocketOK/${j}`),_.info(`Creating a socket (${G}) was successful after ${H.elapsed()} ms.`),N.resolve(oe))},oe=>{o.mark(`code/didCreateSocketError/${j}`),_.info(`Creating a socket (${G}) returned an error after ${H.elapsed()} ms.`),_.error(oe),N.reject(oe)}),N.promise}function l(_,U){const O=new d(U);return _.then(te=>{O.didTimeout||O.resolve(te)},te=>{O.didTimeout||O.reject(te)}),O.promise}async function i(_,U,O,te){const V=W(_,U);_.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let j;try{j=await t(_.logService,_.remoteSocketFactoryService,_.connectTo,y.$Tg.getServerRootPath(),`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${_.reconnectionToken}`,te)}catch(oe){throw _.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),_.logService.error(oe),oe}_.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let G,Q;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(j,null),G=_.reconnectionProtocol,Q=!1):(G=new f.$ui({socket:j}),Q=!0),_.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const N=await l(_.signService.createNewMessage((0,v.$3g)()),te),H={type:"auth",auth:_.connectionToken||"00000000000000000000",data:N.data};G.sendControl(r.$Pe.fromString(JSON.stringify(H)));try{const oe=await b(G,p(te,$(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}if(_.logService.trace(`${V} 4/6. received SignRequest control message.`),!await l(_.signService.validate(N,oe.signedData),te)){const de=new Error("Refused to connect to unsupported server");throw de.code="VSCODE_CONNECTION_ERROR",de}const Ee=await l(_.signService.sign(oe.data),te),Ne={type:"connectionType",commit:_.commit,signedData:Ee,desiredConnectionType:U};return O&&(Ne.args=O),_.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(r.$Pe.fromString(JSON.stringify(Ne))),{protocol:G,ownsProtocol:Q}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(_.logService.error(`${V} the handshake timed out. Error:`),_.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${V} received error control message when negotiating connection. Error:`),_.logService.error(oe)),Q&&M(G),oe}}async function g(_,U,O,te){const V=Date.now(),j=W(_,U),{protocol:G,ownsProtocol:Q}=await i(_,U,O,te),N=new d(te);return N.registerDisposable(G.onControlMessage(H=>{const oe=JSON.parse(H.toString()),fe=B(oe);fe?(_.logService.error(`${j} received error control message when negotiating connection. Error:`),_.logService.error(fe),Q&&M(G),N.reject(fe)):(_.reconnectionProtocol?.endAcceptReconnection(),_.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ue(V)}!`),N.resolve({protocol:G,firstMessage:oe}))})),N.promise}async function s(_,U){const{protocol:O}=await g(_,h.Management,void 0,U);return{protocol:O}}async function c(_,U,O){const{protocol:te,firstMessage:V}=await g(_,h.ExtensionHost,U,O),j=V&&V.debugPort;return{protocol:te,debugPort:j}}async function u(_,U,O){const te=Date.now(),V=W(_,h.Tunnel),{protocol:j}=await i(_,h.Tunnel,U,O);return _.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ue(te)}!`),j}async function D(_,U,O){const{connectTo:te,connectionToken:V}=await _.addressProvider.getAddress();return{commit:_.commit,quality:_.quality,connectTo:te,connectionToken:V,reconnectionToken:U,reconnectionProtocol:O,remoteSocketFactoryService:_.remoteSocketFactoryService,signService:_.signService,logService:_.logService}}async function P(_,U,O){return z(_,async te=>{const{protocol:V}=await s(te,E.CancellationToken.None);return new K(_,U,O,te.reconnectionToken,V)})}async function T(_,U){return z(_,async O=>{const{protocol:te,debugPort:V}=await c(O,U,E.CancellationToken.None);return new ae(_,U,O.reconnectionToken,te,V)})}async function z(_,U){for(let te=1;;te++)try{const V=(0,v.$3g)(),j=await D(_,V,null);return await U(j)}catch(V){if(te<5)_.logService.error(`[remote-connection][attempt ${te}] An error occurred in initial connection! Will retry... Error:`),_.logService.error(V);else throw _.logService.error(`[remote-connection][attempt ${te}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),_.logService.error(V),le.triggerPermanentFailure(0,0,w.$Ul.isHandled(V)),V}}async function C(_,U,O){const te=await D(_,(0,v.$3g)(),null);return await u(te,{host:U,port:O},E.CancellationToken.None)}function k(_){return(0,n.$th)(U=>new Promise((O,te)=>{const V=setTimeout(O,_*1e3);U.onCancellationRequested(()=>{clearTimeout(V),O()})}))}var q;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(q||(e.PersistentConnectionEventType=q={}));class Y{constructor(U,O){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.type=q.ConnectionLost}}e.$4l=Y;class J{constructor(U,O,te,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.durationSeconds=te,this.c=V,this.type=q.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=J;class ne{constructor(U,O,te){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.attempt=te,this.type=q.ReconnectionRunning}}e.$6l=ne;class Z{constructor(U,O,te){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.attempt=te,this.type=q.ConnectionGain}}e.$7l=Z;class x{constructor(U,O,te,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=O,this.attempt=te,this.handled=V,this.type=q.ReconnectionPermanentFailure}}e.$8l=x;class le extends A.$Xc{static triggerPermanentFailure(U,O,te){this._permanentFailure=!0,this.f=U,this.g=O,this.h=te,this.j.forEach(V=>V.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}get n(){return this.c||le._permanentFailure}constructor(U,O,te,V,j){super(),this.t=U,this.u=O,this.reconnectionToken=te,this.protocol=V,this.w=j,this.m=this.B(new R.$ne),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(V.onSocketClose(G=>{const Q=pe(this.t,this.reconnectionToken,!0);G?G.type===f.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${Q} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${Q} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${Q} received socket close event.`),this.y()})),this.B(V.onSocketTimeout(G=>{const Q=pe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Q} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),le.j.push(this),this.B((0,A.$Vc)(()=>{const G=le.j.indexOf(this);G>=0&&le.j.splice(G,1)})),this.n&&this.D(le.f,le.g,le.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=pe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let te=-1;do{te++;const V=te<O.length?O[te]:O[O.length-1];try{if(V>0){const G=k(V);this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,G)),this.u.logService.info(`${U} waiting for ${V} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),te+1)),this.u.logService.info(`${U} resolving connection...`);const j=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${j.connectTo}...`),await this.G(j,$(a)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),te+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),te+1,!1);break}if(te>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),te+1,!1);break}if(w.$Ul.isTemporarilyNotAvailable(j)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if((0,I.$7)(j)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(j);continue}if(j instanceof w.$Ul){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),te+1,w.$Ul.isHandled(j));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(j),this.C(this.protocol.getMillisSinceLastIncomingData(),te+1,!1);break}}while(!this.n&&!this.s)}C(U,O,te){this.w?le.triggerPermanentFailure(U,O,te):this.D(U,O,te)}D(U,O,te){this.m.fire(new x(this.reconnectionToken,U,O,te)),M(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=le,le._permanentFailure=!1,le.f=0,le.g=0,le.h=!1,le.j=[];class K extends le{constructor(U,O,te,V,j){super(h.Management,U,V,j,!0),this.client=this.B(new f.$si(j,{remoteAuthority:O,clientId:te},U.ipcLogger))}async G(U,O){await s(U,O)}}e.$0l=K;class ae extends le{constructor(U,O,te,V,j){super(h.ExtensionHost,U,te,V,!1),this.H=O,this.debugPort=j}async G(U,O){await c(U,this.H,O)}}e.$$l=ae;function M(_){try{_.acceptDisconnect();const U=_.getSocket();_.dispose(),U.dispose()}catch(U){(0,I.$3)(U)}}function B(_){if(_&&_.type==="error"){const U=new Error(`Connection error: ${_.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function re(_,U){for(;_.length<U;)_+=" ";return _}function ce(_,U){return`[remote-connection][${re(m(_),13)}][${U.substr(0,5)}\u2026]`}function pe(_,U,O){return`${ce(_,U)}[${O?"reconnect":"initial"}]`}function W(_,U){return`${pe(U,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.connectTo}]`}function ue(_){return`${Date.now()-_} ms`}}),define(Se[264],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tR=e.$sR=void 0,e.$sR=(0,n.$Gi)("IRemoteExtensionsScannerService"),e.$tR="remoteExtensionsScanner"}),define(Se[91],ke([1,0,13]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=r,e.$jn=E,e.$kn=I,e.$ln=R;function r(y){return y.scheme===n.Schemas.vscodeRemote?y.authority:void 0}function E(y){if(!y)return;const o=y.indexOf("+");return o<0?y:y.substr(0,o)}function I(y){const{host:o,port:S}=A(y);if(typeof S>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:o,port:S}}function R(y,o){let{host:S,port:v}=A(y);return typeof v>"u"&&(v=o),{host:S,port:v}}function A(y){const o=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(o)return{host:o[1],port:parseInt(o[2],10)};const S=y.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const v=y.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:y,port:void 0}}}),define(Se[22],ke([1,0,17,5,91]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$un=e.$tn=e.$sn=e.TargetPlatform=e.ExtensionType=e.$rn=e.$pn=e.$on=e.$nn=e.$mn=void 0,e.$qn=I,e.$vn=v,e.$wn=f,e.$xn=w,e.$yn=a,e.$zn=h,e.$An=m,n=Be(n),e.$mn="extensions.user.cache",e.$nn="extensions.builtin.cache",e.$on="undefined_publisher",e.$pn=["ui","workspace","web"];function I($){if(typeof $=="object"&&$!==null&&$.supported!==!0)return $.description}e.$rn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function($){$[$.System=0]="System",$[$.User=1]="User"})(R||(e.ExtensionType=R={}));var A;(function($){$.WIN32_X64="win32-x64",$.WIN32_ARM64="win32-arm64",$.LINUX_X64="linux-x64",$.LINUX_ARM64="linux-arm64",$.LINUX_ARMHF="linux-armhf",$.ALPINE_X64="alpine-x64",$.ALPINE_ARM64="alpine-arm64",$.DARWIN_X64="darwin-x64",$.DARWIN_ARM64="darwin-arm64",$.WEB="web",$.UNIVERSAL="universal",$.UNKNOWN="unknown",$.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class y{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,d){if(typeof p>"u"||p===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof p=="string"||typeof d=="string"){const b=typeof p=="string"?p:p.value,t=typeof d=="string"?d:d.value;return n.$Hf(b,t)}return p._lower===d._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$sn=y;class o{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const d of p)this.add(d)}add(p){this.c.add(y.toKey(p))}delete(p){return this.c.delete(y.toKey(p))}has(p){return this.c.has(y.toKey(p))}}e.$tn=o;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(y.toKey(p))}get(p){return this.c.get(y.toKey(p))}has(p){return this.c.has(y.toKey(p))}set(p,d){this.c.set(y.toKey(p),d)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$un=S;function v($){return f($)}function f($){return $.contributes&&$.contributes.localizations?$.contributes.localizations.length>0:!1}function w($){return $.contributes&&$.contributes.authentication?$.contributes.authentication.length>0:!1}function a($,p){if(p){const d=`onResolveRemoteAuthority:${(0,E.$jn)(p)}`;return!!$.activationEvents?.includes(d)}return!1}function h($){return $.map(p=>{const[d,b]=p.split("@");return{proposalName:d,version:b?parseInt(b):void 0}})}function m($){return $.map(p=>p.split("@")[0])}e.$Bn=(0,r.$Gi)("IBuiltinExtensionsScannerService")}),define(Se[30],ke([1,0,3,207,22,5]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.ExtensionManagementErrorCode=e.$lp=e.ExtensionGalleryErrorCode=e.$kp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0,e.$ep=A,e.$fp=y,e.$gp=o,e.$hp=S,e.$ip=v,e.$jp=f,e.$0o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$o=new RegExp(e.$0o),e.$_o="__web_extension",e.$ap="skipWalkthrough",e.$bp="extensionInstallSource",e.$cp="dependecyOrPackExtensionInstall",e.$dp="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function A(t){switch(t){case E.TargetPlatform.WIN32_X64:return"Windows 64 bit";case E.TargetPlatform.WIN32_ARM64:return"Windows ARM";case E.TargetPlatform.LINUX_X64:return"Linux 64 bit";case E.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case E.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case E.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case E.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case E.TargetPlatform.DARWIN_X64:return"Mac";case E.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case E.TargetPlatform.WEB:return"Web";case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;case E.TargetPlatform.UNKNOWN:return E.TargetPlatform.UNKNOWN;case E.TargetPlatform.UNDEFINED:return E.TargetPlatform.UNDEFINED}}function y(t){switch(t){case E.TargetPlatform.WIN32_X64:return E.TargetPlatform.WIN32_X64;case E.TargetPlatform.WIN32_ARM64:return E.TargetPlatform.WIN32_ARM64;case E.TargetPlatform.LINUX_X64:return E.TargetPlatform.LINUX_X64;case E.TargetPlatform.LINUX_ARM64:return E.TargetPlatform.LINUX_ARM64;case E.TargetPlatform.LINUX_ARMHF:return E.TargetPlatform.LINUX_ARMHF;case E.TargetPlatform.ALPINE_X64:return E.TargetPlatform.ALPINE_X64;case E.TargetPlatform.ALPINE_ARM64:return E.TargetPlatform.ALPINE_ARM64;case E.TargetPlatform.DARWIN_X64:return E.TargetPlatform.DARWIN_X64;case E.TargetPlatform.DARWIN_ARM64:return E.TargetPlatform.DARWIN_ARM64;case E.TargetPlatform.WEB:return E.TargetPlatform.WEB;case E.TargetPlatform.UNIVERSAL:return E.TargetPlatform.UNIVERSAL;default:return E.TargetPlatform.UNKNOWN}}function o(t,l){switch(t){case n.Platform.Windows:return l==="x64"?E.TargetPlatform.WIN32_X64:l==="arm64"?E.TargetPlatform.WIN32_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Linux:return l==="x64"?E.TargetPlatform.LINUX_X64:l==="arm64"?E.TargetPlatform.LINUX_ARM64:l==="arm"?E.TargetPlatform.LINUX_ARMHF:E.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?E.TargetPlatform.ALPINE_X64:l==="arm64"?E.TargetPlatform.ALPINE_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Mac:return l==="x64"?E.TargetPlatform.DARWIN_X64:l==="arm64"?E.TargetPlatform.DARWIN_ARM64:E.TargetPlatform.UNKNOWN;case n.Platform.Web:return E.TargetPlatform.WEB}}function S(t,l){return l===E.TargetPlatform.WEB&&!t.includes(E.TargetPlatform.WEB)}function v(t,l,i){return S(l,i)?!1:t===E.TargetPlatform.UNDEFINED||t===E.TargetPlatform.UNIVERSAL?!0:t===E.TargetPlatform.UNKNOWN?!1:t===i}function f(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var w;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var a;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var h;(function(t){t.Install="install",t.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$kp=(0,I.$Gi)("extensionGalleryService");var $;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class p extends Error{constructor(l,i){super(l),this.code=i,this.name=i}}e.$lp=p;var d;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));class b extends Error{constructor(l,i){super(l),this.code=i,this.name=i}}e.$mp=b,e.$np=(0,I.$Gi)("extensionManagementService"),e.$op="extensionsIdentifiers/disabled",e.$pp="extensionsIdentifiers/enabled",e.$qp=(0,I.$Gi)("IGlobalExtensionEnablementService"),e.$rp=(0,I.$Gi)("IExtensionTipsService"),e.$sp=(0,r.localize2)(0,"Extensions"),e.$tp=(0,r.localize2)(1,"Preferences")}),define(Se[265],ke([1,0,6,2,21,4,59,30]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=void 0;function y(m,$){return m?I.URI.revive($?$.transformIncoming(m):m):void 0}function o(m,$){return $?$.transformOutgoingURI(m):m}function S(m,$){$=$||R.$On;const p=m.manifest;return{...(0,R.$Rn)({...m,manifest:void 0},$),manifest:p}}function v(m,$){return m?.profileLocation?(0,R.$Rn)(m,$??R.$On):m}function f(m,$){return $?(0,E.$ho)(m,p=>p instanceof I.URI?$.transformOutgoingURI(p):void 0):m}class w{constructor($,p){this.a=$,this.b=p,this.onInstallExtension=n.Event.buffer($.onInstallExtension,!0),this.onDidInstallExtensions=n.Event.buffer($.onDidInstallExtensions,!0),this.onUninstallExtension=n.Event.buffer($.onUninstallExtension,!0),this.onDidUninstallExtension=n.Event.buffer($.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=n.Event.buffer($.onDidUpdateExtensionMetadata,!0)}listen($,p){const d=this.b($);switch(p){case"onInstallExtension":return n.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?o(b.profileLocation,d):b.profileLocation}));case"onDidInstallExtensions":return n.Event.map(this.onDidInstallExtensions,b=>b.map(t=>({...t,local:t.local?f(t.local,d):t.local,profileLocation:t.profileLocation?o(t.profileLocation,d):t.profileLocation})));case"onUninstallExtension":return n.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?o(b.profileLocation,d):b.profileLocation}));case"onDidUninstallExtension":return n.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?o(b.profileLocation,d):b.profileLocation}));case"onDidUpdateExtensionMetadata":return n.Event.map(this.onDidUpdateExtensionMetadata,b=>({local:f(b.local,d),profileLocation:o(b.profileLocation,d)}))}throw new Error("Invalid listen")}async call($,p,d){const b=this.b($);switch(p){case"zip":{const t=S(d[0],b),l=await this.a.zip(t);return o(l,b)}case"unzip":return this.a.unzip(y(d[0],b));case"install":return this.a.install(y(d[0],b),v(d[1],b));case"installFromLocation":return this.a.installFromLocation(y(d[0],b),y(d[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],y(d[1],b),y(d[2],b));case"getManifest":return this.a.getManifest(y(d[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],v(d[1],b));case"installGalleryExtensions":{const t=d[0];return this.a.installGalleryExtensions(t.map(({extension:l,options:i})=>({extension:l,options:v(i,b)??{}})))}case"uninstall":return this.a.uninstall(S(d[0],b),v(d[1],b));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(d[0],b));case"getInstalled":return(await this.a.getInstalled(d[0],y(d[1],b),d[2])).map(l=>f(l,b));case"toggleAppliationScope":{const t=await this.a.toggleAppliationScope(S(d[0],b),y(d[1],b));return f(t,b)}case"copyExtensions":return this.a.copyExtensions(y(d[0],b),y(d[1],b));case"updateMetadata":{const t=await this.a.updateMetadata(S(d[0],b),d[1],y(d[2],b));return f(t,b)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$wq=w;class a extends r.$Xc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor($){super(),this.m=$,this.c=this.B(new n.$ne),this.f=this.B(new n.$ne),this.g=this.B(new n.$ne),this.h=this.B(new n.$ne),this.j=this.B(new n.$ne),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?I.URI.revive(p.source):p.source,profileLocation:I.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(d=>({...d,local:d.local?S(d.local,null):d.local,source:this.r(d.source)?I.URI.revive(d.source):d.source,profileLocation:I.URI.revive(d.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:I.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:I.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.n(this.j,{profileLocation:I.URI.revive(p.profileLocation),local:S(p.local,null)})))}n($,p){$.fire(p)}r($){return $?typeof $.path=="string"&&typeof $.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall($){const p=await this.getTargetPlatform();return $.allTargetPlatforms.some(d=>(0,A.$ip)(d,$.allTargetPlatforms,p))}zip($){return Promise.resolve(this.m.call("zip",[$]).then(p=>I.URI.revive(p)))}unzip($){return Promise.resolve(this.m.call("unzip",[$]))}install($,p){return Promise.resolve(this.m.call("install",[$,p])).then(d=>S(d,null))}installFromLocation($,p){return Promise.resolve(this.m.call("installFromLocation",[$,p])).then(d=>S(d,null))}async installExtensionsFromProfile($,p,d){return(await this.m.call("installExtensionsFromProfile",[$,p,d])).map(t=>S(t,null))}getManifest($){return Promise.resolve(this.m.call("getManifest",[$]))}installFromGallery($,p){return Promise.resolve(this.m.call("installFromGallery",[$,p])).then(d=>S(d,null))}async installGalleryExtensions($){return(await this.m.call("installGalleryExtensions",[$])).map(d=>({...d,local:d.local?S(d.local,null):d.local,source:this.r(d.source)?I.URI.revive(d.source):d.source,profileLocation:I.URI.revive(d.profileLocation)}))}uninstall($,p){if($.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[$,p]))}reinstallFromGallery($){return Promise.resolve(this.m.call("reinstallFromGallery",[$])).then(p=>S(p,null))}getInstalled($=null,p,d){return Promise.resolve(this.m.call("getInstalled",[$,p,d])).then(b=>b.map(t=>S(t,null)))}updateMetadata($,p,d){return Promise.resolve(this.m.call("updateMetadata",[$,p,d])).then(b=>S(b,null))}toggleAppliationScope($,p){return this.m.call("toggleAppliationScope",[$,p]).then(d=>S(d,null))}copyExtensions($,p){return this.m.call("copyExtensions",[$,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download($,p,d){const b=await this.m.call("download",[$,p,d]);return I.URI.revive(b)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$xq=a;class h{constructor($){this.a=$}listen($,p){throw new Error("Invalid listen")}call($,p,d){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(I.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$yq=h}),define(Se[131],ke([1,0,10,22]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NG=e.$MG=void 0;class E{constructor(){this.a=new Map,this.b=new WeakMap}register(R,A){this.a.set(R,A)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const A=Object.create(null);for(const y of R){const o=this.readActivationEvents(y);o.length>0&&(A[r.$sn.toKey(y.identifier)]=o)}return A}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const A=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let y=0;y<A.length;y++)A[y]==="onUri"&&(A[y]=`onUri:${r.$sn.toKey(R.identifier)}`);if(!R.contributes)return A;for(const y in R.contributes){const o=this.a.get(y);if(!o)continue;const S=R.contributes[y],v=Array.isArray(S)?S:[S];try{o(v,A)}catch(f){(0,n.$3)(f)}}return A}}e.$MG=E,e.$NG=new E}),define(Se[266],ke([1,0,2,22,16]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class I extends n.$Xc{constructor(A,y,o,S,v){super(),this.a=A,this.b=y,this.c=o,this.f=v,this.B(S.onDidInstallExtensions(f=>this.g(f))),this.B(S.onDidUninstallExtension(f=>this.h(f)))}g(A){for(const y of A)y.local&&this.invalidate(y.profileLocation)}h(A){A.error||this.invalidate(A.profileLocation)}async invalidate(A){if(A)for(const y of this.a.profiles)this.c.extUri.isEqual(y.extensionsResource,A)&&await this.j(y);else await this.j(this.a.defaultProfile)}async j(A){try{await this.b.del(this.c.extUri.joinPath(A.cacheHome,r.$mn))}catch(y){(0,E.$rl)(y)!==E.FileOperationResult.FILE_NOT_FOUND&&this.f.error(y)}}}e.$Vq=I});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[74],ke([1,0,20,58,213,63,22,120]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=S,e.$Zp=v,e.$1p=f,e.$2p=w,e.$3p=a,e.$4p=h,e.$5p=m,e.$6p=$,r=$t(r),E=Be(E),I=Be(I);const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,o=/^-(\d{4})(\d{2})(\d{2})$/;function S(b){return b=b.trim(),b==="*"||y.test(b)}function v(b){if(!S(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=b.match(y);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function f(b){if(!b)return null;const t=b.majorBase,l=b.majorMustEqual,i=b.minorBase;let g=b.minorMustEqual;const s=b.patchBase;let c=b.patchMustEqual;b.hasCaret&&(t===0||(g=!1),c=!1);let u=0;if(b.preRelease){const D=o.exec(b.preRelease);if(D){const[,P,T,z]=D;u=Date.UTC(Number(P),Number(T)-1,Number(z))}}return{majorBase:t,majorMustEqual:l,minorBase:i,minorMustEqual:g,patchBase:s,patchMustEqual:c,isMinimum:b.hasGreaterEquals,notBefore:u}}function w(b,t,l){let i;typeof b=="string"?i=f(v(b)):i=b;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let s;if(typeof l=="string"?s=f(v(l)):s=l,!i||!s)return!1;const c=i.majorBase,u=i.minorBase,D=i.patchBase;let P=s.majorBase,T=s.minorBase,z=s.patchBase;const C=s.notBefore;let k=s.majorMustEqual,q=s.minorMustEqual,Y=s.patchMustEqual;return s.isMinimum?c>P?!0:c<P?!1:u>T?!0:u<T||g&&g<C?!1:D>=z:(c===1&&P===0&&(!k||!q||!Y)&&(P=1,T=0,z=0,k=!0,q=!1,Y=!1),c<P?!1:c>P?!k:u<T?!1:u>T?!q:D<z?!1:D>z?!Y:!(g&&g<C))}function a(b,t,l,i,g,s){const c=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return c.push([r.default.Error,E.localize(0,null)]),c;if(typeof i.name!="string")return c.push([r.default.Error,E.localize(1,null,"name")]),c;if(typeof i.version!="string")return c.push([r.default.Error,E.localize(2,null,"version")]),c;if(!i.engines)return c.push([r.default.Error,E.localize(3,null,"engines")]),c;if(typeof i.engines.vscode!="string")return c.push([r.default.Error,E.localize(4,null,"engines.vscode")]),c;if(typeof i.extensionDependencies<"u"&&!d(i.extensionDependencies))return c.push([r.default.Error,E.localize(5,null,"extensionDependencies")]),c;if(typeof i.activationEvents<"u"){if(!d(i.activationEvents))return c.push([r.default.Error,E.localize(6,null,"activationEvents")]),c;if(typeof i.main>"u"&&typeof i.browser>"u")return c.push([r.default.Error,E.localize(7,null,"activationEvents","main","browser")]),c}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&c.push([r.default.Warning,E.localize(8,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return c.push([r.default.Error,E.localize(9,null,"main")]),c;{const P=(0,n.$hh)(l,i.main);(0,n.$bh)(P,l)||c.push([r.default.Warning,E.localize(10,null,P.path,l.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return c.push([r.default.Error,E.localize(11,null,"browser")]),c;{const P=(0,n.$hh)(l,i.browser);(0,n.$bh)(P,l)||c.push([r.default.Warning,E.localize(12,null,P.path,l.path)])}}if(!I.valid(i.version))return c.push([r.default.Error,E.localize(13,null)]),c;const u=[];if(!h(b,t,i,g,u))for(const P of u)c.push([r.default.Error,P]);if(s&&i.enabledApiProposals?.length){const P=[];if(!$([...i.enabledApiProposals],P))for(const T of P)c.push([r.default.Error,T])}return c}function h(b,t,l,i,g){return i||typeof l.main>"u"&&typeof l.browser>"u"?!0:p(b,t,l.engines.vscode,g)}function m(b,t,l){return b==="*"||p(t,l,b)}function $(b,t){if(b.length===0)return!0;const l=Array.isArray(t)?t:void 0,i=(l?void 0:t)??A.allApiProposals,g=[],s=(0,R.$zn)(b);for(const{proposalName:c,version:u}of s){const D=i[c];D&&u&&D.version!==u&&g.push(E.localize(14,null,c))}return l?.push(...g),g.length===0}function p(b,t,l,i=[]){const g=f(v(l));if(!g)return i.push(E.localize(15,null,l)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return i.push(E.localize(16,null,l)),!1}else if(!g.majorMustEqual)return i.push(E.localize(17,null,l)),!1;return w(b,t,g)?!0:(i.push(E.localize(18,null,b,l)),!1)}function d(b){if(!Array.isArray(b))return!1;for(let t=0,l=b.length;t<l;t++)if(typeof b[t]!="string")return!1;return!0}}),define(Se[92],ke([1,0,19,2,3,218,30,5]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=void 0,e.$0r=y;function y(S){return S.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$$r=(0,A.$Gi)("languagePackService");let o=class extends r.$Xc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new n.$ye;setTimeout(()=>v.cancel(),1e3);let f;try{f=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const a=f.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(m=>m.startsWith("lp-"))).map(h=>{const m=h.properties.localizedLanguages?.[0],$=y(h);return{...this.f($,m,h),extensionId:h.identifier.id,galleryExtension:h}});return a.push(this.f("en","English")),a}f(v,f,w){const a=f??v;let h;if(a!==v&&(h=`(${v})`),v.toLowerCase()===E.$q.toLowerCase()&&(h??(h=""),h+=(0,I.localize)(0,null)),w?.installCount){h??(h="");const m=w.installCount;let $;m>1e6?$=`${Math.floor(m/1e5)/10}M`:m>1e3?$=`${Math.floor(m/1e3)}K`:$=String(m),h+=` $(cloud-download) ${$}`}return{id:v,label:a,description:h}}};e.$_r=o,e.$_r=o=ze([Fe(0,R.$kp)],o)}),define(Se[47],ke([1,0,15,10,2,221,46,5,12,38]),function(se,e,n,r,E,I,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$9p=f,e.$0p=w,e.$$p=a,e.$_p=h,e.$aq=m,e.$bq=$,e.$7p=(0,A.$Gi)("requestService");class S{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const l in this.b)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?t[l]="*****":t[l]=this.b[l];this.a=t}return this.a}}class v extends E.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,I.localize)(0,null),when:y.$sk.isEqualTo((0,y.$pk)(y.LogLevel.Trace)).serialize()})}async c(t,l,i){const g=`${t} #${++this.b}: ${l.url}`;this.a.trace(`${g} - begin`,l.type,new S(l.headers??{}));try{const s=await i();return this.a.trace(`${g} - end`,l.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${g} - error`,l.type,(0,r.$ab)(s)),s}}}e.$8p=v;function f(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}function w(b){return b.res.statusCode===204}async function a(b){return w(b)?null:(await(0,n.$2e)(b.stream)).toString()}async function h(b){if(!f(b))throw new Error("Server returned "+b.res.statusCode);return a(b)}async function m(b){if(!f(b))throw new Error("Server returned "+b.res.statusCode);if(w(b))return null;const l=(await(0,n.$2e)(b.stream)).toString();try{return JSON.parse(l)}catch(i){throw i.message+=`:
`+l,i}}function $(b){d(b)}let p;function d(b){const t=o.$so.as(R.$xo.Configuration),l=p;p={id:"http",order:15,title:(0,I.localize)(1,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,I.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,I.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(7,null),(0,I.localize)(8,null),(0,I.localize)(9,null),(0,I.localize)(10,null)],default:"override",description:(0,I.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,I.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[p],remove:l?[l]:[]})}d(R.ConfigurationScope.APPLICATION)}),define(Se[267],ke([1,0,19,13,16,47]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=void 0;let R=class{constructor(y,o){this.a=y,this.b=o}async download(y,o,S=n.CancellationToken.None){if(y.scheme===r.Schemas.file||y.scheme===r.Schemas.vscodeRemote){await this.b.copy(y,o);return}const v={type:"GET",url:y.toString(!0)},f=await this.a.request(v,S);if(f.res.statusCode===200)await this.b.writeFile(o,f.stream);else{const w=await(0,I.$_p)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${w}`)}}};e.$JR=R,e.$JR=R=ze([Fe(0,I.$7p),Fe(1,E.$al)],R)}),define(Se[268],ke([1,0,15,19]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=void 0;class E{constructor(A){this.a=A}listen(A,y){throw new Error("Invalid listen")}call(A,y,o,S=r.CancellationToken.None){switch(y){case"request":return this.a.request(o[0],S).then(async({res:v,stream:f})=>{const w=await(0,n.$2e)(f);return[{statusCode:v.statusCode,headers:v.headers},w]});case"resolveProxy":return this.a.resolveProxy(o[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$bs=E;class I{constructor(A){this.a=A}async request(A,y){const[o,S]=await this.a.call("request",[A],y);return{res:o,stream:(0,n.$4e)(S)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$cs=I}),define(Se[269],ke([1,0,93,11]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=I;function E(R,A){return R.protocol==="http:"?A.HTTP_PROXY||A.http_proxy||null:R.protocol==="https:"&&(A.HTTPS_PROXY||A.https_proxy||A.HTTP_PROXY||A.http_proxy)||null}async function I(R,A,y={}){const o=(0,n.parse)(R),S=y.proxyUrl||E(o,A);if(!S)return null;const v=(0,n.parse)(S);if(!/^https?:$/.test(v.protocol||""))return null;const f={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,r.$mg)(y.strictSSL)?y.strictSSL:!0,keepAlive:!0};return o.protocol==="http:"?new(await new Promise((w,a)=>{se(["http-proxy-agent"],w,a)}).then(Be)).HttpProxyAgent(S,f):new(await new Promise((w,a)=>{se(["https-proxy-agent"],w,a)}).then(Be)).HttpsProxyAgent(S,f)}}),define(Se[94],ke([1,0,60,9,222,19,45,10,3,23,116,243,14,163]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=h;let a;async function h($,p,d,b){return d["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.$c?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$Km)(b)&&!d["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$Km)(b)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),a||(a=f.Promises.withAsyncBody(async(t,l)=>{const i=new I.$ye;let g=1e4;const s=$.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(g=(0,w.$Lm)(s,1,120)*1e3);const c=setTimeout(()=>{i.dispose(!0),l(new Error((0,E.localize)(0,null)))},g);try{t(await m(p,i.token))}catch(u){!(0,A.$7)(u)&&!i.token.isCancellationRequested?l(new Error((0,E.localize)(1,null,(0,R.$rj)(u)))):t({})}finally{clearTimeout(c),i.dispose()}})),a)}async function m($,p){const d=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",d);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",b);const t=(0,o.$3g)().replace(/-/g,"").substr(0,12),l=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",i);const g=await(0,S.$Am)(y.OS,i);return $.trace("getUnixShellEnvironment#shell",g),new Promise((s,c)=>{if(p.isCancellationRequested)return c(new A.$8);const u=(0,r.$qc)(g);let D,P;const T="";/^pwsh(-preview)?$/.test(u)?(D=`& '${process.execPath}' ${T} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,P=["-Login","-Command"]):u==="nu"?(D=`^'${process.execPath}' ${T} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,P=["-i","-l","-c"]):u==="xonsh"?(D=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,P=["-i","-l","-c"]):(D=`'${process.execPath}' ${T} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,u==="tcsh"||u==="csh"?P=["-ic"]:P=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),D);const z=(0,n.spawn)(g,[...P,D],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});p.onCancellationRequested(()=>(z.kill(),c(new A.$8))),z.on("error",q=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,R.$rj)(q)),c(q)});const C=[];z.stdout.on("data",q=>C.push(q));const k=[];z.stderr.on("data",q=>k.push(q)),z.on("close",(q,Y)=>{const J=Buffer.concat(C).toString("utf8");$.trace("getUnixShellEnvironment#raw",J);const ne=Buffer.concat(k).toString("utf8");if(ne.trim()&&$.trace("getUnixShellEnvironment#stderr",ne),q||Y)return c(new Error((0,E.localize)(2,null,q,Y)));const Z=l.exec(J),x=Z?Z[1]:"{}";try{const le=JSON.parse(x);d?le.ELECTRON_RUN_AS_NODE=d:delete le.ELECTRON_RUN_AS_NODE,b?le.ELECTRON_NO_ATTACH_CONSOLE=b:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",le),s(le)}catch(le){$.error("getUnixShellEnvironment#errorCaught",(0,R.$rj)(le)),c(le)}})})}}),define(Se[270],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iR=e.$hR=void 0,e.$hR=(0,n.$Gi)("stateReadService"),e.$iR=(0,n.$Gi)("stateService")}),define(Se[271],ke([1,0,14,15,2,11,28,16,12]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=e.$kR=e.$jR=e.SaveStrategy=void 0;var o;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(o||(e.SaveStrategy=o={}));class S extends E.$Xc{constructor(a,h,m,$){super(),this.h=a,this.j=h,this.m=m,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Eh(this.j===o.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(a){a.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.m.error(a)}}getItem(a,h){const m=this.a[a];return(0,I.$pg)(m)?h:m}setItem(a,h){this.setItems([{key:a,data:h}])}setItems(a){let h=!1;for(const{key:m,data:$}of a)this.a[m]!==$&&((0,I.$pg)($)?(0,I.$ng)(this.a[m])||(this.a[m]=void 0,h=!0):(this.a[m]=$,h=!0));h&&this.s()}removeItem(a){(0,I.$ng)(this.a[a])||(this.a[a]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const a=JSON.stringify(this.a,null,4);if(a!==this.b)try{await this.n.writeFile(this.h,r.$Pe.fromString(a),{atomic:{postfix:".vsctmp"}}),this.b=a}catch(h){this.m.error(h)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$jR=S;let v=class extends E.$Xc{constructor(a,h,m,$){super(),this.a=this.B(new S(h.stateResource,a,m,$))}async init(){await this.a.init()}getItem(a,h){return this.a.getItem(a,h)}};e.$kR=v,e.$kR=v=ze([Fe(1,R.$Ni),Fe(2,y.$ak),Fe(3,A.$al)],v);class f extends v{setItem(a,h){this.a.setItem(a,h)}setItems(a){this.a.setItems(a)}removeItem(a){this.a.removeItem(a)}close(){return this.a.close()}}e.$lR=f}),define(Se[132],ke([1,0,3,32,23]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=R,e.$vp=A;function I(y){if(n.$o===n.Platform.Linux&&/^penguin(\.|$)/i.test(y))return"chromebook"}function R(y,o,S,v,f,w,a,h,m,$){const p=Object.create(null);p["common.machineId"]=w,p["common.sqmId"]=a,p["common.devDeviceId"]=h,p.sessionID=(0,E.$3g)()+Date.now(),p.commitHash=v,p.version=f,p["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,n.$b)(n.$o),p["common.nodePlatform"]=r.$gc,p["common.nodeArch"]=S,p["common.product"]=$||"desktop",m&&(p["common.msftInternal"]=m);let d=0;const b=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),n.$f&&(p["common.snap"]="true");const t=I(o);return t&&(p["common.platformDetail"]=t),p}function A(y){const o=r.env.USERDNSDOMAIN;if(!o)return!1;const S=o.toLowerCase();return y.some(v=>S===v)}}),define(Se[272],ke([1,0,18,10,2,21,16]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(o){function S(v,f){return v.callstack<f.callstack?-1:v.callstack>f.callstack?1:0}o.compare=S})(A||(e.ErrorEvent=A={}));class y{constructor(S,v=y.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new E.$Wc,this.c=S,this.d=v;const f=r.$Z.addListener(w=>this.j(w));this.h.add((0,E.$Vc)(f)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(S){if(!S||S.code||(S.detail&&S.detail.stack&&(S=S.detail),r.$eb.isErrorNoTelemetry(S)||S instanceof R.$vl||typeof S?.message=="string"&&S.message.includes("Unable to read file")))return;const v=Array.isArray(S.stack)?S.stack.join(`
`):S.stack,f=S.message?S.message:(0,I.$ko)(S);v&&this.k({msg:f,callstack:v})}k(S){const v=(0,n.$zb)(this.g,S,A.compare);v<0?(S.count=1,this.g.splice(~v,0,S)):(this.g[v].count||(this.g[v].count=0),this.g[v].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const S of this.g)this.c.publicLogError2("UnhandledError",S);this.g.length=0}}y.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=y}),define(Se[24],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,n.$Gi)("telemetryService"),e.$am=(0,n.$Gi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var r;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var E;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(Se[273],ke([1,0,31,14,43,13,9,3,48,4,112,25,115,249,16,29,24]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0,e.$Xs=p,e.$Ys=b,e.$Zs=t,n=Be(n);const $=new Map;async function p(i,g){const s=`${i}::${g.join(":")}`,c=$.get(s);if(c)return c;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],D=new Map,P=new Map,T=2e4;function z(k,q,Y,J){const ne=q.substring(k.length+1);return r.Promises.withAsyncBody(async Z=>{let x;J.readdirCount++;try{x=await v.Promises.readdir(q,{withFileTypes:!0})}catch{Z();return}if(J.count>=T){J.count+=x.length,J.maxReached=!0,Z();return}let le=x.length;if(le===0){Z();return}let K=x;J.count+x.length>T&&(J.maxReached=!0,le=T-J.count,K=x.slice(0,le)),J.count+=x.length;for(const ae of K)if(ae.isDirectory()){if(Y.includes(ae.name)||await z(k,(0,R.$mc)(q,ae.name),Y,J),--le===0){Z();return}}else{const M=ae.name.lastIndexOf(".");if(M>=0){const B=ae.name.substring(M+1);B&&D.set(B,(D.get(B)??0)+1)}for(const B of u)B.relativePathPattern?.test(ne)!==!1&&B.filePattern.test(ae.name)&&P.set(B.tag,(P.get(B.tag)??0)+1);if(--le===0){Z();return}}})}const C=r.Promises.withAsyncBody(async k=>{const q={count:0,maxReached:!1,readdirCount:0},Y=new y.$he(!0);await z(i,i,g,q);const J=await t(i);k({configFiles:d(P),fileTypes:d(D),fileCount:q.count,maxFilesReached:q.maxReached,launchConfigFiles:J,totalScanTime:Y.elapsed(),totalReaddirCount:q.readdirCount})});return $.set(s,C),C}function d(i){return Array.from(i.entries(),([g,s])=>({name:g,count:s})).sort((g,s)=>s.count-g.count)}function b(){const i={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/a.$Il.GB).toFixed(2)}GB (${(n.freemem()/a.$Il.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.$Tn.value()*100)}%`},g=n.cpus();return g&&g.length>0&&(i.cpus=`${g[0].model} (${g.length} x ${g[0].speed})`),i}async function t(i){try{const g=new Map,s=(0,R.$mc)(i,".vscode","launch.json"),c=await v.Promises.readFile(s),u=[],D=(0,E.$Zn)(c.toString(),u);if(u.length)return console.log(`Unable to parse ${s}`),[];if((0,E.$8n)(D)==="object"&&D.configurations)for(const P of D.configurations){const T=P.type;T&&(g.has(T)?g.set(T,g.get(T)+1):g.set(T,1))}return d(g)}catch{return[]}}let l=class{constructor(g,s){this.c=g,this.d=s}f(g){const s=[];return s.push(`OS Version:       ${g.os}`),s.push(`CPUs:             ${g.cpus}`),s.push(`Memory (System):  ${g.memory}`),s.push(`VM:               ${g.vmHint}`),s.join(`
`)}g(g){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const c=n.cpus();return c&&c.length>0&&s.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/a.$Il.GB).toFixed(2)}GB (${(n.freemem()/a.$Il.GB).toFixed(2)}GB free)`),A.$c||s.push(`Load (avg):       ${n.loadavg().map(u=>Math.round(u)).join(", ")}`),s.push(`VM:               ${Math.round(S.$Tn.value()*100)}%`),s.push(`Screen Reader:    ${g.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${g.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(g.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(g,s){return Promise.all([(0,f.$Ws)(g.mainPID),this.k(g)]).then(async c=>{let[u,D]=c,P=this.m(g,u);return s.forEach(T=>{if((0,w.$Um)(T))P+=`
${T.errorMessage}`,D+=`
${T.errorMessage}`;else if(P+=`

Remote: ${T.hostName}`,T.processes&&(P+=`
${this.m(g,T.processes)}`),T.workspaceMetadata){D+=`
|  Remote: ${T.hostName}`;for(const z of Object.keys(T.workspaceMetadata)){const C=T.workspaceMetadata[z];let k=`${C.fileCount} files`;C.maxFilesReached&&(k=`more than ${k}`),D+=`|    Folder (${z}): ${k}`,D+=this.h(C)}}}),{processInfo:P,workspaceInfo:D}})}async getSystemInfo(g,s){const{memory:c,vmHint:u,os:D,cpus:P}=b(),T={os:D,memory:c,cpus:P,vmHint:u,processArgs:`${g.mainArguments.join(" ")}`,gpuStatus:g.gpuFeatureStatus,screenReader:`${g.screenReader?"yes":"no"}`,remoteData:s};return A.$c||(T.load=`${n.loadavg().map(z=>Math.round(z)).join(", ")}`),A.$e&&(T.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(T)}async getDiagnostics(g,s){const c=[];return(0,f.$Ws)(g.mainPID).then(async u=>(c.push(""),c.push(this.g(g)),c.push(""),c.push(this.m(g,u)),g.windows.some(D=>D.folderURIs&&D.folderURIs.length>0&&!D.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.k(g))),s.forEach(D=>{if((0,w.$Um)(D))c.push(`
${D.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${D.hostName}`),c.push(this.f(D.machineInfo)),D.processes&&c.push(this.m(g,D.processes)),D.workspaceMetadata)for(const P of Object.keys(D.workspaceMetadata)){const T=D.workspaceMetadata[P];let z=`${T.fileCount} files`;T.maxFilesReached&&(z=`more than ${z}`),c.push(`Folder (${P}): ${z}`),c.push(this.h(T))}}),c.push(""),c.push(""),c.join(`
`)))}h(g){const s=[];let u=0;const D=(C,k)=>{const q=` ${C}(${k})`;u+q.length>60?(s.push(P),P="|                 ",u=P.length):u+=q.length,P+=q};let P="|      File types:";const T=10,z=g.fileTypes.length>T?T:g.fileTypes.length;for(let C=0;C<z;C++){const k=g.fileTypes[C];D(k.name,k.count)}if(s.push(P),g.configFiles.length>=0&&(P="|      Conf files:",u=0,g.configFiles.forEach(C=>{D(C.name,C.count)}),s.push(P)),g.launchConfigFiles.length>0){let C="|      Launch Configs:";g.launchConfigFiles.forEach(k=>{const q=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;C+=q}),s.push(C)}return s.join(`
`)}j(g){const s=Math.max(...Object.keys(g).map(c=>c.length));return Object.keys(g).map(c=>`${c}:  ${" ".repeat(s-c.length)}  ${g[c]}`).join(`
                  `)}k(g){const s=[],c=[];return g.windows.forEach(u=>{u.folderURIs.length===0||u.remoteAuthority||(s.push(`|  Window (${u.title})`),u.folderURIs.forEach(D=>{const P=o.URI.revive(D);if(P.scheme===I.Schemas.file){const T=P.fsPath;c.push(p(T,["node_modules",".git"]).then(z=>{let C=`${z.fileCount} files`;z.maxFilesReached&&(C=`more than ${C}`),s.push(`|    Folder (${(0,R.$qc)(T)}): ${C}`),s.push(this.h(z))}).catch(z=>{s.push(`|      Error: Unable to collect workspace stats for folder ${T} (${z.toString()})`)}))}else s.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(u=>s.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}m(g,s){const c=new Map;g.windows.forEach(D=>c.set(D.pid,`window [${D.id}] (${D.title})`)),g.pidToNames.forEach(({pid:D,name:P})=>c.set(D,P));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),s&&this.n(g.mainPID,c,u,s,0),u.join(`
`)}n(g,s,c,u,D){const P=D===0;let T;P?T=u.pid===g?`${this.d.applicationName} main`:"remote agent":s.has(u.pid)?T=s.get(u.pid):T=`${"  ".repeat(D)} ${u.name}`;const z=process.platform==="win32"?u.mem:n.totalmem()*(u.mem/100);c.push(`${u.load.toFixed(0).padStart(5," ")}	${(z/a.$Il.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${T}`),Array.isArray(u.children)&&u.children.forEach(C=>this.n(g,s,c,C,D+1))}async getWorkspaceFileExtensions(g){const s=new Set;for(const{uri:c}of g.folders){const u=o.URI.revive(c);if(u.scheme!==I.Schemas.file)continue;const D=u.fsPath;try{(await p(D,["node_modules",".git"])).fileTypes.forEach(T=>s.add(T.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(g){for(const{uri:s}of g.folders){const c=o.URI.revive(s);if(c.scheme!==I.Schemas.file)continue;const u=c.fsPath;try{const D=await p(u,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":g.telemetryId,rendererSessionId:g.rendererSessionId}),D.fileTypes.forEach(P=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:g.rendererSessionId,type:P.name,count:P.count})}),D.launchConfigFiles.forEach(P=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:g.rendererSessionId,type:P.name,count:P.count})}),D.configFiles.forEach(P=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:g.rendererSessionId,type:P.name,count:P.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:D.totalScanTime,reachedLimit:D.maxFilesReached,fileCount:D.fileCount,readdirCount:D.totalReaddirCount})}catch{}}}};e.$1s=l,e.$1s=l=ze([Fe(0,m.$_l),Fe(1,h.$tk)],l)}),define(Se[95],ke([1,0,10,5,12,24]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.ExtensionSignatureVerificationCode=e.$sq=void 0,e.$sq=(0,r.$Gi)("IExtensionSignatureVerificationService");var R;(function(o){o.Success="Success",o.RequiredArgumentMissing="RequiredArgumentMissing",o.InvalidArgument="InvalidArgument",o.PackageIsUnreadable="PackageIsUnreadable",o.UnhandledException="UnhandledException",o.SignatureManifestIsMissing="SignatureManifestIsMissing",o.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",o.SignatureIsMissing="SignatureIsMissing",o.SignatureIsUnreadable="SignatureIsUnreadable",o.CertificateIsUnreadable="CertificateIsUnreadable",o.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",o.FileAlreadyExists="FileAlreadyExists",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",o.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",o.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",o.SignatureIsInvalid="SignatureIsInvalid",o.SignatureManifestIsInvalid="SignatureManifestIsInvalid",o.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",o.EntryIsMissing="EntryIsMissing",o.EntryIsTampered="EntryIsTampered",o.Untrusted="Untrusted",o.CertificateRevoked="CertificateRevoked",o.SignatureIsNotValid="SignatureIsNotValid",o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(R||(e.ExtensionSignatureVerificationCode=R={}));class A extends Error{constructor(S){super(S),this.code=S}}e.$tq=A;let y=class{constructor(S,v){this.b=S,this.c=v}d(){return this.a||(this.a=new Promise((S,v)=>se(["@vscode/vsce-sign"],async f=>S(f),v))),this.a}async verify(S,v,f,w){let a;const h=S.identifier.id;try{a=await this.d()}catch(d){return this.b.error("Could not load vsce-sign module",(0,n.$ab)(d)),this.b.info(`Extension signature verification is not done: ${h}`),!1}const m=new Date().getTime();let $;try{this.b.trace(`Verifying extension signature for ${h}...`),$=await a.verify(v,f,this.b.getLevel()===E.LogLevel.Trace)}catch(d){$={code:R.UnknownError,didExecute:!1,output:(0,n.$ab)(d)}}const p=new Date().getTime()-m;if(this.b.info(`Extension signature verification result for ${h}: ${$.code}. Executed: ${$.didExecute}. Duration: ${p}ms.`),this.b.trace(`Extension signature verification output for ${h}:
${$.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:h,extensionVersion:S.version,code:$.code,internalCode:$.internalCode,duration:p,didExecute:$.didExecute,clientTargetPlatform:w}),$.code===R.Success)return!0;throw new A($.code)}};e.$uq=y,e.$uq=y=ze([Fe(0,E.$ak),Fe(1,I.$_l)],y)}),define(Se[274],ke([1,0,2,24]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0;class E extends n.$Xc{constructor(R,A){super(),this.a=R,this.b=A}async call(R,A,y){switch(A){case"updateTelemetryLevel":{const{telemetryLevel:o}=y;return this.a.updateInjectedTelemetryLevel(o)}case"logTelemetry":{const{eventName:o,data:S}=y;return this.b?this.b.log(o,S):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${A} not found`)}listen(R,A,y){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(r.TelemetryLevel.NONE),super.dispose()}}e.$9s=E}),define(Se[41],ke([1,0,21,11,91,132,24]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$Dp=S,e.$Ep=v,e.$Fp=f,e.$Gp=w,e.$Hp=h,e.$Ip=$,e.$Jp=p,e.$Kp=t;class A{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$wp=A;class y{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xp=y,e.$yp=new y;class o{async publicLog(i,g,s){}async publicLogError(i,g,s){}}e.$zp=o,e.$Ap="telemetry",e.$Bp="extensionTelemetryLog",e.$Cp={log:()=>null,flush:()=>Promise.resolve(null)};function S(l,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!l.enableTelemetry)}function v(l,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function f(l){const i=l.getValue(R.$im),g=l.getValue(R.$jm);if(l.getValue(R.$km)===!1||g===!1)return R.TelemetryLevel.NONE;switch(i??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function w(l){const i={},g={},s={};m(l,s);for(let c in s){c=c.length>150?c.substr(c.length-149):c;const u=s[c];typeof u=="number"?g[c]=u:typeof u=="boolean"?g[c]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${u.length}`),i[c]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(i[c]=u)}return{properties:i,measurements:g}}const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(l){if(!l)return"none";const i=(0,E.$jn)(l);return a.has(i)?i:"other"}function m(l,i,g=0,s){if(l)for(const c of Object.getOwnPropertyNames(l)){const u=l[c],D=s?s+c:c;Array.isArray(u)?i[D]=(0,n.$ko)(u):u instanceof Date?i[D]=u.toISOString():(0,r.$ig)(u)?g<2?m(u,i,g+1,D+"."):i[D]=(0,n.$ko)(u):i[D]=u}}function $(l,i){const g=l.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,I.$vp)(g)||s}function p(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function d(l,i){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let g=l;const s=[];for(const P of i)for(;;){const T=P.exec(l);if(!T)break;s.push([T.index,P.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(g="";;){const P=u.exec(l);if(!P)break;const T=s.some(([z,C])=>P.index<C&&z<u.lastIndex);!c.test(P[0])&&!T&&(g+=l.substring(D,P.index)+"<REDACTED: user-file-path>",D=u.lastIndex)}return D<l.length&&(g+=l.substr(D)),g}function b(l){if(!l)return l;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of i)if(g.regex.test(l))return`<REDACTED: ${g.label}>`;return l}function t(l,i){return(0,n.$ho)(l,g=>{if(g instanceof A||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let s=g.replaceAll("%20"," ");s=d(s,i);for(const c of i)s=s.replace(c,"");return s=b(s),s}})}}),define(Se[39],ke([1,0,17,30,22,3,4,10,32,41]),function(se,e,n,r,E,I,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Mp=void 0,e.$Lp=S,e.$Np=a,e.$Op=h,e.$Pp=m,e.$Qp=$,e.$Rp=p,e.$Sp=d,e.$Tp=b,e.$Vp=t,e.$Wp=i;function S(g,s){return g.uuid&&s.uuid?g.uuid===s.uuid:g.id===s.id?!0:(0,n.$Cf)(g.id,s.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(s){const c=s.manifest?s.manifest.version:s.version,u=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new f(s.identifier,c,u)}static parse(s){const c=v.exec(s);return c&&c[1]&&c[2]?new f({id:c[1]},c[2],c[4]||void 0):null}constructor(s,c,u=E.TargetPlatform.UNDEFINED){this.identifier=s,this.version=c,this.targetPlatform=u,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==E.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof f?S(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Mp=f;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function a(g){const s=w.exec(g);return s&&s[1]?[m(s[1]),s[2]]:[m(g),void 0]}function h(g,s){return`${g}.${s}`}function m(g){return g.toLowerCase()}function $(g,s){return m(h(g??E.$on,s))}function p(g,s){const c=[],u=D=>{for(const P of c)if(P.some(T=>S(s(T),s(D))))return P;return null};for(const D of g){const P=u(D);P?P.push(D):c.push([D])}return c}function d(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function b(g){return{id:new o.$wp(g.identifier.id),name:new o.$wp(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.$Up=new E.$sn("pprice.better-merge");function t(g,s){const c=[],u=s.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const D=u.shift();if(D&&c.every(P=>!S(P.identifier,{id:D}))){const P=g.filter(T=>S(T.identifier,{id:D}));P.length===1&&(c.push(P[0]),u.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function l(g,s){if(!I.$e)return!1;let c;try{c=(await g.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await g.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){s.debug("Error while getting the os-release file.",(0,A.$ab)(D))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(g,s){const c=await l(g,s),u=(0,r.$gp)(c?"alpine":I.$o,y.$hc);return s.debug("ComputeTargetPlatform:",u),u}}),define(Se[133],ke([1,0,19,10,13,20,63,4,208,30,39,22]),function(se,e,n,r,E,I,R,A,y,o,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;const f=h=>(0,y.localize)(0,null,h),w=(0,y.localize)(1,null,"ms-dotnettools.csharp");let a=class{constructor(m,$,p){this.a=m,this.b=$,this.d=p}get f(){}async listExtensions(m,$,p){let d=await this.b.getInstalled(v.ExtensionType.User,p);const b=v.$rn.map(l=>l.toLowerCase());if($&&$!==""){if(b.indexOf($.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}d=d.filter(l=>l.manifest.categories?l.manifest.categories.map(g=>g.toLowerCase()).indexOf($.toLowerCase())>-1:!1)}else if($===""){this.a.info("Possible Categories: "),b.forEach(l=>{this.a.info(l)});return}this.f&&this.a.info((0,y.localize)(2,null,this.f)),d=d.sort((l,i)=>l.identifier.id.localeCompare(i.identifier.id));let t;for(const l of d)t!==l.identifier.id&&(t=l.identifier.id,this.a.info(m?`${t}@${l.manifest.version}`:t))}async installExtensions(m,$,p,d){const b=[];try{m.length&&this.a.info(this.f?(0,y.localize)(3,null,this.f):(0,y.localize)(4,null));const t=[],l=[],i=(s,c,u)=>{l.push({id:s,version:c!=="prerelease"?c:void 0,installOptions:{...p,isBuiltin:u,installPreReleaseVersion:c==="prerelease"||p.installPreReleaseVersion}})};for(const s of m)if(s instanceof A.URI)t.push({vsix:s,installOptions:p});else{const[c,u]=(0,S.$Np)(s);i(c,u,!1)}for(const s of $)if(s instanceof A.URI)t.push({vsix:s,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[c,u]=(0,S.$Np)(s);i(c,u,!0)}const g=await this.b.getInstalled(void 0,p.profileLocation);if(t.length&&await Promise.all(t.map(async({vsix:s,installOptions:c})=>{try{await this.h(s,c,d,g)}catch(u){this.a.error(u),b.push(s.toString())}})),l.length){const s=await this.g(l,g,d);b.push(...s)}}catch(t){throw this.a.error((0,y.localize)(5,null,(0,r.$ab)(t))),t}if(b.length)throw new Error((0,y.localize)(6,null,b.join(", ")))}async updateExtensions(m){const $=await this.b.getInstalled(v.ExtensionType.User,m),p=[];for(const l of $)l.identifier.uuid&&p.push({...l.identifier,preRelease:l.preRelease});this.a.trace((0,y.localize)(7,null,p.length));const d=await this.d.getExtensions(p,{compatible:!0},n.CancellationToken.None),b=[];for(const l of d)for(const i of $)(0,S.$Lp)(i.identifier,l.identifier)&&(0,R.gt)(l.version,i.manifest.version)&&b.push({extension:l,options:{operation:o.InstallOperation.Update,installPreReleaseVersion:i.preRelease,profileLocation:m,isApplicationScoped:i.isApplicationScoped}});if(!b.length){this.a.info((0,y.localize)(8,null));return}this.a.info((0,y.localize)(9,null,b.map(l=>l.extension.identifier.id).join(", ")));const t=await this.b.installGalleryExtensions(b);for(const l of t)l.error?this.a.error((0,y.localize)(10,null,l.identifier.id,(0,r.$ab)(l.error))):this.a.info((0,y.localize)(11,null,l.identifier.id,l.local?.manifest.version))}async g(m,$,p){if(m=m.filter(({id:l,version:i})=>{const g=$.find(s=>(0,S.$Lp)(s.identifier,{id:l}));if(g){if(!p&&(!i||i==="prerelease"&&g.preRelease))return this.a.info((0,y.localize)(12,null,l,g.manifest.version,l)),!1;if(i&&g.manifest.version===i)return this.a.info((0,y.localize)(13,null,`${l}@${i}`)),!1}return!0}),!m.length)return[];const d=[],b=[],t=await this.j(m);if(await Promise.all(m.map(async({id:l,version:i,installOptions:g})=>{const s=t.get(l.toLowerCase());if(!s){this.a.error(`${f(i?`${l}@${i}`:l)}
${w}`),d.push(l);return}try{const u=await this.d.getManifest(s,n.CancellationToken.None);if(u&&!this.k(u))return}catch(u){this.a.error(u.message||u.stack||u),d.push(l);return}const c=$.find(u=>(0,S.$Lp)(u.identifier,s.identifier));if(c){if(s.version===c.manifest.version){this.a.info((0,y.localize)(14,null,i?`${l}@${i}`:l));return}this.a.info((0,y.localize)(15,null,l,s.version))}g.isBuiltin?this.a.info(i?(0,y.localize)(16,null,l,i):(0,y.localize)(17,null,l)):this.a.info(i?(0,y.localize)(18,null,l,i):(0,y.localize)(19,null,l)),b.push({extension:s,options:{...g,installGivenVersion:!!i,isApplicationScoped:c?.isApplicationScoped}})})),b.length){const l=await this.b.installGalleryExtensions(b);for(const i of l)i.error?(this.a.error((0,y.localize)(20,null,i.identifier.id,(0,r.$ab)(i.error))),d.push(i.identifier.id)):this.a.info((0,y.localize)(21,null,i.identifier.id,i.local?.manifest.version))}return d}async h(m,$,p,d){const b=await this.b.getManifest(m);if(!b)throw new Error("Invalid vsix");if(await this.l(b,p,$.profileLocation,d))try{await this.b.install(m,$),this.a.info((0,y.localize)(22,null,(0,I.$eh)(m)))}catch(l){if((0,r.$7)(l))this.a.info((0,y.localize)(23,null,(0,I.$eh)(m)));else throw l}}async j(m){const $=new Map,p=m.some(t=>t.installOptions.installPreReleaseVersion),d=await this.b.getTargetPlatform(),b=[];for(const t of m)o.$$o.test(t.id)&&b.push({...t,preRelease:p});if(b.length){const t=await this.d.getExtensions(b,{targetPlatform:d},n.CancellationToken.None);for(const l of t)$.set(l.identifier.id.toLowerCase(),l)}return $}k(m){return!0}async l(m,$,p,d){if(!$){const b={id:(0,S.$Qp)(m.publisher,m.name)},t=d.find(l=>(0,S.$Lp)(b,l.identifier)&&(0,R.gt)(l.manifest.version,m.version));if(t)return this.a.info((0,y.localize)(24,null,t.identifier.id,t.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,$,p){const d=async t=>{if(t instanceof A.URI){const l=await this.b.getManifest(t);return(0,S.$Op)(l.publisher,l.name)}return t},b=[];for(const t of m){const l=await d(t),g=(await this.b.getInstalled(void 0,p)).filter(s=>(0,S.$Lp)(s.identifier,{id:l}));if(!g.length)throw new Error(`${this.m(l)}
${w}`);if(g.some(s=>s.type===v.ExtensionType.System)){this.a.info((0,y.localize)(25,null,l));return}if(!$&&g.some(s=>s.isBuiltin)){this.a.info((0,y.localize)(26,null,l));return}this.a.info((0,y.localize)(27,null,l));for(const s of g)await this.b.uninstall(s,{profileLocation:p}),b.push(s);this.f?this.a.info((0,y.localize)(28,null,l,this.f)):this.a.info((0,y.localize)(29,null,l))}}async locateExtension(m){const $=await this.b.getInstalled();m.forEach(p=>{$.forEach(d=>{if(d.identifier.id===p&&d.location.scheme===E.Schemas.file){this.a.info(d.location.fsPath);return}})})}m(m){return this.f?(0,y.localize)(30,null,m,this.f):(0,y.localize)(31,null,m)}};e.$vq=a,e.$vq=a=ze([Fe(1,o.$np),Fe(2,o.$kp)],a)}),define(Se[275],ke([1,0,6,2,26,39,22,16]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;class y extends r.$Xc{constructor(S,v,f,w,a,h,m){super(),this.f=S,this.g=v,this.h=f,this.j=w,this.m=a,this.n=h,this.r=m,this.a=this.B(new n.$ne),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new r.$7c),this.s().then(null,$=>m.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(S=>this.u(S.added))),this.B(this.j.onAddExtensions(S=>this.w(S))),this.B(this.j.onDidAddExtensions(S=>this.y(S))),this.B(this.j.onRemoveExtensions(S=>this.z(S))),this.B(this.j.onDidRemoveExtensions(S=>this.C(S))),this.B(this.n.onDidFilesChange(S=>this.D(S)))}async u(S){try{S.length&&await Promise.all(S.map(v=>(this.c.set(v.id,(0,r.$Uc)(this.n.watch(this.m.extUri.dirname(v.extensionsResource)),this.n.watch(v.extensionsResource))),this.G(v.extensionsResource))))}catch(v){throw this.r.error(v),v}}async w(S){for(const v of S.extensions)this.I(this.L(v.identifier,v.version),S.profileLocation)}async y(S){for(const v of S.extensions){const f=this.L(v.identifier,v.version);S.error?this.J(f,S.profileLocation):this.I(f,S.profileLocation)}}async z(S){for(const v of S.extensions)this.J(this.L(v.identifier,v.version),S.profileLocation)}async C(S){const v=[],f=[];for(const w of S.extensions){const a=this.L(w.identifier,w.version);S.error?this.I(a,S.profileLocation):(this.J(a,S.profileLocation),this.b.has(a)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),f.push(this.f.scanInstalledExtensionAtLocation(w.location).then(h=>{h?v.push(h):this.r.info("Extension not found at the location",w.location.toString())},h=>this.r.error(h)))))}try{await Promise.all(f),v.length&&await this.H(v)}catch(w){this.r.error(w)}}D(S){for(const v of this.h.profiles)S.contains(v.extensionsResource,A.FileChangeType.UPDATED,A.FileChangeType.ADDED)&&this.F(v.extensionsResource)}async F(S){const v=[],f=[],w=await this.j.scanProfileExtensions(S),a=new Set,h=new Set;for(const[m,$]of this.b)$.has(S)&&h.add(m);for(const m of w){const $=this.L(m.identifier,m.version);a.add($),h.has($)||(v.push(m.identifier),this.I($,S))}for(const m of h)if(!a.has(m)){const $=this.M(m);$&&(f.push($.identifier),this.J(m,S))}(v.length||f.length)&&this.a.fire({added:v.length?{extensions:v,profileLocation:S}:void 0,removed:f.length?{extensions:f,profileLocation:S}:void 0})}async G(S){const v=await this.j.scanProfileExtensions(S);for(const f of v)this.I(this.L(f.identifier,f.version),S)}async H(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(f=>!this.b.has(this.L(f.identifier,f.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}I(S,v){let f=this.b.get(S);f||this.b.set(S,f=new E.$Ec(w=>this.m.extUri.getComparisonKey(w))),f.add(v)}J(S,v){const f=this.b.get(S);f&&f.delete(v),f?.size||this.b.delete(S)}L(S,v){return`${R.$sn.toKey(S.id)}@${v}`}M(S){const[v,f]=(0,I.$Np)(S);return f?{identifier:{id:v},version:f}:void 0}}e.$Wq=y}),define(Se[134],ke([1,0,96,18,14,2,13,9,25,28,30,39,12,92,4]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0;let h=class extends w.$_r{constructor(d,b,t,l){super(t),this.h=d,this.j=l,this.g=this.B(new m(b,l)),this.h.registerParticipant({postInstall:async i=>this.m(i),postUninstall:async i=>this.n(i)})}async getBuiltInExtensionTranslationsUri(d,b){const l=(await this.g.getLanguagePacks())[b];if(!l){this.j.warn(`No language pack found for ${b}`);return}const i=l.translations[d];return i?a.URI.file(i):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),b=Object.keys(d).map(t=>{const l=d[t];return{...this.f(t,l.label),extensionId:l.extensions[0].extensionIdentifier.id}});return b.push(this.f("en","English")),b.sort((t,l)=>t.label.localeCompare(l.label)),b}async m(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",d.identifier.id),await this.update())}async n(d){const b=await this.g.getLanguagePacks();Object.keys(b).some(t=>b[t]&&b[t].extensions.some(l=>(0,v.$Lp)(l.extensionIdentifier,d.identifier)))&&(this.j.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,b]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(b);return!(0,r.$xb)(Object.keys(d),Object.keys(t))}};e.$as=h,e.$as=h=ze([Fe(0,S.$np),Fe(1,o.$Oi),Fe(2,S.$kp),Fe(3,f.$ak)],h);let m=class extends I.$Xc{constructor(d,b){super(),this.j=b,this.c={},this.f=(0,A.$mc)(d.userDataPath,"languagepacks.json"),this.g=new E.$Nh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.s(b=>{Object.keys(b).forEach(t=>delete b[t]),this.m(b,...d)}).then(()=>this.c)}m(d,...b){for(const t of b)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.n(d,t);Object.keys(d).forEach(t=>this.r(d[t]))}n(d,b){const t=b.identifier,l=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const i of l)if(b.location.scheme===R.Schemas.file&&$(i)){let g=d[i.languageId];g||(g={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},d[i.languageId]=g);const s=g.extensions.filter(c=>(0,v.$Lp)(c.extensionIdentifier,t))[0];s?s.version=b.manifest.version:g.extensions.push({extensionIdentifier:t,version:b.manifest.version});for(const c of i.translations)g.translations[c.id]=(0,A.$mc)(b.location.fsPath,c.path)}}r(d){if(d){const b=(0,n.createHash)("md5");for(const t of d.extensions)b.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);d.hash=b.digest("hex")}}s(d=()=>null){return this.g.queue(()=>{let b=null;return y.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(b=d(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const l=JSON.stringify(this.c);return this.j.debug("Writing language packs",l),y.Promises.writeFile(this.f,l)}).then(()=>b,t=>this.j.error(t))})}};m=ze([Fe(0,o.$Oi),Fe(1,f.$ak)],m);function $(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const d of p.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(Se[276],ke([1,0,176,10,21,41]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function y(S,v,f){const w=await(0,n.$tE)("@microsoft/1ds-core-js","dist/ms.core.js"),a=await(0,n.$tE)("@microsoft/1ds-post-js","dist/ms.post.js"),h=new w.AppInsightsCore,m=new a.PostChannel,$={instrumentationKey:S,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(f){$.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:f};$.extensionConfig[m.identifier]=p}return h.initialize($,[]),h.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),h}class o{constructor(v,f,w,a,h){this.e=v,this.f=f,this.g=w,this.h=h,this.c=R,this.d=A,this.g||(this.g={}),typeof a=="function"?this.a=a():this.a=a,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=y(this.a,this.e,this.h)),this.b.then(f=>{v(f)},f=>{(0,r.$3)(f),console.error(f)})}}log(v,f){if(!this.a)return;f=(0,E.$io)(f,this.g),f=(0,I.$Gp)(f);const w=this.f+"/"+v;try{this.i(a=>{a.pluginVersionString=f?.properties.version??"Unknown",a.track({name:w,baseData:{name:w,properties:f?.properties,measurements:f?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(f=>{f.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$dR=o});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[277],ke([1,0,2,21,3,17,223,27,46,62,29,38,24,41]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0,o=$t(o);let a=class{constructor($,p,d){this.k=p,this.l=d,this.d={},this.i=new n.$Wc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=f.TelemetryLevel.USAGE,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,I.$jf)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.$jf)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration(f.$im)||b.affectsConfiguration(f.$km)||b.affectsConfiguration(f.$jm))&&this.m()}))}setExperimentProperty($,p){this.d[$]=p}m(){let $=(0,w.$Fp)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const d=p.usage?f.TelemetryLevel.USAGE:p.error?f.TelemetryLevel.ERROR:f.TelemetryLevel.NONE;$=Math.min($,d)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,p,d){this.g<p||(d=(0,r.$io)(d,this.d),d=(0,w.$Kp)(d,this.j),d=(0,r.$io)(d,this.c),this.b.forEach(b=>b.log($,d)))}publicLog($,p){this.n($,f.TelemetryLevel.USAGE,p)}publicLog2($,p){this.publicLog($,p)}publicLogError($,p){this.h&&this.n($,f.TelemetryLevel.ERROR,p)}publicLogError2($,p){this.publicLogError($,p)}};e.$gs=a,a.IDLE_START_EVENT_NAME="UserIdleStart",a.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$gs=a=ze([Fe(1,A.$aj),Fe(2,S.$tk)],a);function h(){const m=(0,R.localize)(0,null,o.default.nameLong),$=o.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",o.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=E.$i?"":(0,R.localize)(3,null),d=(0,R.localize)(4,null),b=(0,R.localize)(5,null),t=(0,R.localize)(6,null),l=(0,R.localize)(7,null),i=`
|       | ${d} | ${b} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,g=(0,R.localize)(8,null);return`
${m} ${$} ${p}

&nbsp;

${l}
${i}

&nbsp;

${g}
`}v.$so.as(y.$xo.Configuration).registerConfiguration({id:f.$hm,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[f.$im]:{type:"string",enum:[f.TelemetryConfiguration.ON,f.TelemetryConfiguration.ERROR,f.TelemetryConfiguration.CRASH,f.TelemetryConfiguration.OFF],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:h(),default:f.TelemetryConfiguration.ON,restricted:!0,scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),v.$so.as(y.$xo.Configuration).registerConfiguration({id:f.$hm,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[f.$km]:{type:"boolean",markdownDescription:o.default.privacyStatementUrl?(0,R.localize)(16,null,o.default.nameLong,o.default.privacyStatementUrl):(0,R.localize)(15,null,o.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${f.$im}#\``),scope:y.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(Se[278],ke([1,0,27,5,29,24,277,41]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.$7s=e.$6s=void 0;let y=class extends R.$gs{constructor(S,v,f,w){super(S,f,w),this.o=v}publicLog(S,v){if(!(this.o<I.TelemetryLevel.USAGE))return super.publicLog(S,v)}publicLog2(S,v){return this.publicLog(S,v)}publicLogError(S,v){return this.o<I.TelemetryLevel.ERROR?Promise.resolve(void 0):super.publicLogError(S,v)}publicLogError2(S,v){return this.publicLogError(S,v)}async updateInjectedTelemetryLevel(S){if(S===void 0)throw this.o=I.TelemetryLevel.NONE,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,S):S,this.o===I.TelemetryLevel.NONE&&this.dispose()}};e.$6s=y,e.$6s=y=ze([Fe(2,n.$aj),Fe(3,E.$tk)],y),e.$7s=new class extends A.$xp{async updateInjectedTelemetryLevel(){}},e.$8s=(0,r.$Hi)(I.$_l)}),define(Se[279],ke([1,0,15,19,280,276]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=void 0,E=Be(E);async function R(S,v){const f=await v.request(S,r.CancellationToken.None),w=(await(0,n.$2e)(f.stream)).toString(),a=f.res.statusCode??200;return{headers:f.res.headers,statusCode:a,responseData:w}}async function A(S){const v={method:S.type,headers:S.headers};return new Promise((w,a)=>{const h=E.request(S.url??"",v,m=>{m.on("data",function($){w({headers:m.headers,statusCode:m.statusCode??200,responseData:$.toString()})}),m.on("error",function($){a($)})});h.write(S.data,m=>{m&&a(m)}),h.end()})}async function y(S,v,f){const w=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),a={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:w};try{const h=S?await R(a,S):await A(a);f(h.statusCode,h.headers,h.responseData)}catch{f(0,{})}}class o extends I.$dR{constructor(v,f,w,a,h){const m={sendPOST:($,p)=>{y(v,$,p)}};super(f,w,a,h,m)}}e.$eR=o});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[281],ke([1,0,10,272]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=$t(r);class E extends r.default{i(){(0,n.setUnexpectedErrorHandler)(A=>console.error(A));const R=[];process.on("unhandledRejection",(A,y)=>{R.push(y),setTimeout(()=>{const o=R.indexOf(y);o>=0&&y.catch(S=>{R.splice(o,1),(0,n.$7)(S)||(console.warn(`rejected promise not handled within 1 second: ${S}`),S.stack&&console.warn(`stack trace: ${S.stack}`),A&&(0,n.$3)(A))})},1e3)}),process.on("rejectionHandled",A=>{const y=R.indexOf(A);y>=0&&R.splice(y,1)}),process.on("uncaughtException",A=>{(0,n.$2)(A)||(0,n.$3)(A)})}}e.default=E}),define(Se[135],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(Se[136],ke([1,0,3,135]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0;const E=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class I{constructor(S){this.collections=S,this.a=new Map,this.b=new Map,S.forEach((v,f)=>{this.d(v,f);const w=v.map.entries();let a=w.next();for(;!a.done;){const h=a.value[1],m=a.value[0];let $=this.a.get(m);if($||($=[],this.a.set(m,$)),$.length>0&&$[0].type===r.EnvironmentVariableMutatorType.Replace){a=w.next();continue}const p={extensionIdentifier:f,value:h.value,type:h.type,scope:h.scope,variable:h.variable,options:h.options};p.scope||delete p.scope,$.unshift(p),a=w.next()}})}async applyToProcessEnvironment(S,v,f){let w;n.$c&&(w={},Object.keys(S).forEach(a=>w[a.toLowerCase()]=a));for(const[a,h]of this.getVariableMap(v)){const m=n.$c&&w[a.toLowerCase()]||a;for(const $ of h){const p=f?await f($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case r.EnvironmentVariableMutatorType.Append:S[m]=(S[m]||"")+p;break;case r.EnvironmentVariableMutatorType.Prepend:S[m]=p+(S[m]||"");break;case r.EnvironmentVariableMutatorType.Replace:S[m]=p;break}if($.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${E.get($.type)}`;S[d]=(S[d]?S[d]+":":"")+a+"="+this.c(p)}}}}c(S){return S.replaceAll(":","\\x3a")}diff(S,v){const f=new Map,w=new Map,a=new Map;if(S.getVariableMap(v).forEach((h,m)=>{const $=this.getVariableMap(v).get(m),p=A(h,$);p&&f.set(m,p)}),this.getVariableMap(v).forEach((h,m)=>{const $=S.getVariableMap(v).get(m),p=A(h,$);p&&a.set(m,p)}),this.getVariableMap(v).forEach((h,m)=>{const $=S.getVariableMap(v).get(m),p=y(h,$);p&&w.set(m,p)}),!(f.size===0&&w.size===0&&a.size===0))return{added:f,changed:w,removed:a}}getVariableMap(S){const v=new Map;for(const f of this.a.values()){const w=f.filter(a=>R(a,S));w.length>0&&v.set(w[0].variable,w)}return v}getDescriptionMap(S){const v=new Map;for(const f of this.b.values()){const w=f.filter(a=>R(a,S,!0));for(const a of w)v.set(a.extensionIdentifier,a.description)}return v}d(S,v){if(!S.descriptionMap)return;const f=S.descriptionMap.entries();let w=f.next();for(;!w.done;){const a=w.value[1],h=w.value[0];let m=this.b.get(h);m||(m=[],this.b.set(h,m));const $={extensionIdentifier:v,scope:a.scope,description:a.description};$.scope||delete $.scope,m.push($),w=f.next()}}}e.$Ks=I;function R(o,S,v=!1){return o.scope?!!(o.scope.workspaceFolder&&S?.workspaceFolder&&o.scope.workspaceFolder.index===S.workspaceFolder.index):v?S===o.scope:!0}function A(o,S){if(!S)return o;const v=new Set;S.forEach(w=>v.add(w.extensionIdentifier));const f=[];return o.forEach(w=>{v.has(w.extensionIdentifier)||f.push(w)}),f.length===0?void 0:f}function y(o,S){if(!S)return;const v=new Map;S.forEach(w=>v.set(w.extensionIdentifier,w));const f=[];return o.forEach(w=>{const a=v.get(w.extensionIdentifier);a&&(w.type!==a.type||w.value!==a.value||w.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&f.push(a)}),f.length===0?void 0:f}}),define(Se[97],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=n,e.$Fs=r,e.$Gs=E,e.$Hs=I,e.$Is=R,e.$Js=A;function n(y){return[...y.entries()]}function r(y){return y?[...y.entries()]:[]}function E(y){return new Map(y)}function I(y){return new Map(y??[])}function R(y){return Array.from(y.entries()).map(o=>[o[0],n(o[1].map),r(o[1].descriptionMap)])}function A(y){return new Map(y.map(o=>[o[0],{map:E(o[1]),descriptionMap:I(o[2])}]))}}),define(Se[282],ke([1,0,14,19,6,2,12]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;let A=class extends I.$Xc{constructor(o,S){super(),this.h=S,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$ne),this.onCreateRequest=this.g.event,this.b=o===void 0?15e3:o,this.B((0,I.$Vc)(()=>{for(const v of this.f.values())(0,I.$Sc)(v)}))}createRequest(o){return new Promise((S,v)=>{const f=++this.a;this.c.set(f,S),this.g.fire({requestId:f,...o});const w=new r.$ye;(0,n.$Hh)(this.b,w.token).then(()=>v(`Request ${f} timed out (${this.b}ms)`)),this.f.set(f,[(0,I.$Vc)(()=>w.cancel())])})}acceptReply(o,S){const v=this.c.get(o);v?(this.c.delete(o),(0,I.$Sc)(this.f.get(o)||[]),this.f.delete(o),v(S)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${o}`)}};e.$vs=A,e.$vs=A=ze([Fe(1,R.$ak)],A)}),define(Se[53],ke([1,0,5,42,38]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$os=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ns=void 0,e.$ns=new r.$Xj("terminalTabFocusMode",!1,!0);var I;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(I||(e.TerminalSettingPrefix=I={}));var R;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var A;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(A||(e.PosixShellType=A={}));var y;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(y||(e.WindowsShellType=y={}));var o;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(o||(e.TitleEventSource=o={}));var S;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(S||(e.TerminalIpcChannels=S={}));var v;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$os=(0,n.$Gi)("ptyService");var f;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(f||(e.HeartbeatConstants=f={}));var w;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var a;(function(t){t.TerminalView="view",t.Editor="editor"})(a||(e.TerminalLocationString=a={}));var h;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(h||(e.LocalReconnectConstants=h={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var $;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var p;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(p||(e.ShellIntegrationStatus=p={}));var d;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$ps={Backend:"workbench.contributions.terminal.processBackend"};class b{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(l){const i=this.b(l.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,l)}getTerminalBackend(l){return this.a.get(this.b(l))}b(l){return l?.toLowerCase()??""}}E.$so.add(e.$ps.Backend,new b),e.$qs=(0,n.$Gi)("localPtyService"),e.$rs=(0,n.$Gi)("terminalLogService")}),define(Se[137],ke([1,0,3]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RQ=r,e.$SQ=E,e.$TQ=I,e.$UQ=R;function r(A){let y=A;y.includes("\\")&&(y=y.replace(/\\/g,"\\\\"));const o=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return y=y.replace(o,""),`'${y}'`}function E(A,y,o){if(!A)return"";if(!y)return A;y.match(/[\/\\]$/)&&(y=y.slice(0,y.length-1));const S=A.replace(/\\/g,"/").toLowerCase(),v=y.replace(/\\/g,"/").toLowerCase();return S.includes(v)?`~${o}${A.slice(y.length+1)}`:A}function I(A){return A.match(/^['"].*['"]$/)&&(A=A.substring(1,A.length-1)),n.OS===n.OperatingSystem.Windows&&A&&A[1]===":"?A[0].toUpperCase()+A.substring(1):A}function R(A){return!A.strictEnv}}),define(Se[283],ke([1,0,57,4,225,82]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=R,e.$xs=o,e.$ys=S,e.$zs=v;function R(f,w){const a=[{name:null,description:(0,E.localize)(0,null)}];return a.push(...f.map(h=>({name:h.profileName,description:A(h)}))),w&&a.push(...w.map(h=>({name:h.title,description:y(h)}))),{values:a.map(h=>h.name),markdownDescriptions:a.map(h=>h.description)}}function A(f){let w=`$(${I.ThemeIcon.isThemeIcon(f.icon)?f.icon.id:f.icon?f.icon:n.$6j.terminal.id}) ${f.profileName}
- path: ${f.path}`;return f.args&&(typeof f.args=="string"?w+=`
- args: "${f.args}"`:w+=`
- args: [${f.args.length===0?"":`'${f.args.join("','")}'`}]`),f.overrideName!==void 0&&(w+=`
- overrideName: ${f.overrideName}`),f.color&&(w+=`
- color: ${f.color}`),f.env&&(w+=`
- env: ${JSON.stringify(f.env)}`),w}function y(f){return`$(${I.ThemeIcon.isThemeIcon(f.icon)?f.icon.id:f.icon?f.icon:n.$6j.terminal.id}) ${f.title}
- extensionIdentifier: ${f.extensionIdentifier}`}function o(f,w){if(!f&&!w)return!0;if(typeof f=="string"&&typeof w=="string")return f===w;if(Array.isArray(f)&&Array.isArray(w)){if(f.length!==w.length)return!1;for(let a=0;a<f.length;a++)if(f[a]!==w[a])return!1;return!0}return!1}function S(f,w){if(!f&&!w)return!0;if(!f||!w)return!1;if(I.ThemeIcon.isThemeIcon(f)&&I.ThemeIcon.isThemeIcon(w))return f.id===w.id&&f.color===w.color;if(typeof f=="object"&&"light"in f&&"dark"in f&&typeof w=="object"&&"light"in w&&"dark"in w){const a=f,h=w;if((r.URI.isUri(a.light)||v(a.light))&&(r.URI.isUri(a.dark)||v(a.dark))&&(r.URI.isUri(h.light)||v(h.light))&&(r.URI.isUri(h.dark)||v(h.dark)))return a.light.path===h.light.path&&a.dark.path===h.dark.path}if(r.URI.isUri(f)&&r.URI.isUri(w)||v(f)||v(w)){const a=f,h=w;return a.path===h.path&&a.scheme===h.scheme}return!1}function v(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}}),define(Se[284],ke([1,0,57,3,224,46,38,53,283]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=e.$As=void 0,e.$Cs=a,e.$Ds=m,e.$As={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Bs={type:"string",enum:Array.from((0,n.$4j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,n.$4j)(),$=>`$(${$.id})`)};const o={args:{description:(0,E.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(1,null),type:"boolean"},icon:{description:(0,E.localize)(2,null),...e.$Bs},color:{description:(0,E.localize)(3,null),...e.$As},env:{markdownDescription:(0,E.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(5,null),type:["string","array"],items:{type:"string"}},...o}},v={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(6,null),type:["string"],items:{type:"string"}},...o}};function f($){const p=$===r.Platform.Linux?"linux":$===r.Platform.Mac?"osx":"windows";return(0,E.localize)(7,null,(0,r.$b)($),'```json\n"terminal.integrated.profile.'+p+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,E.localize)(8,null),type:"object",properties:{[A.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:f(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(12,null),enum:["PowerShell","Git Bash"]},...o}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(13,null),type:"string"},id:{description:(0,E.localize)(14,null),type:"string"},title:{description:(0,E.localize)(15,null),type:"string"},...o}},{type:"null"},S]}},[A.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:f(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(16,null),type:"string"},id:{description:(0,E.localize)(17,null),type:"string"},title:{description:(0,E.localize)(18,null),type:"string"},...o}},{type:"null"},S]}},[A.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:f(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(19,null),type:"string"},id:{description:(0,E.localize)(20,null),type:"string"},title:{description:(0,E.localize)(21,null),type:"string"},...o}},{type:"null"},S]}},[A.TerminalSettingId.UseWslProfiles]:{description:(0,E.localize)(22,null),type:"boolean",default:!0},[A.TerminalSettingId.InheritEnv]:{scope:I.ConfigurationScope.APPLICATION,description:(0,E.localize)(23,null),type:"boolean",default:!0},[A.TerminalSettingId.PersistentSessionScrollback]:{scope:I.ConfigurationScope.APPLICATION,markdownDescription:(0,E.localize)(24,null),type:"number",default:100},[A.TerminalSettingId.ShowLinkHover]:{scope:I.ConfigurationScope.APPLICATION,description:(0,E.localize)(25,null),type:"boolean",default:!0},[A.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,E.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function a(){R.$so.as(I.$xo.Configuration).registerConfiguration(w),m()}let h;function m($,p){const d=R.$so.as(I.$xo.Configuration);let b;$&&(b=(0,y.$ws)($?.profiles,p));const t=h;h={id:"terminal",order:100,title:(0,E.localize)(27,null),type:"object",properties:{[A.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,E.localize)(28,null),type:["string","null"],default:null,enum:$?.os===r.OperatingSystem.Linux?b?.values:void 0,markdownEnumDescriptions:$?.os===r.OperatingSystem.Linux?b?.markdownDescriptions:void 0},[A.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,E.localize)(29,null),type:["string","null"],default:null,enum:$?.os===r.OperatingSystem.Macintosh?b?.values:void 0,markdownEnumDescriptions:$?.os===r.OperatingSystem.Macintosh?b?.markdownDescriptions:void 0},[A.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,E.localize)(30,null),type:["string","null"],default:null,enum:$?.os===r.OperatingSystem.Windows?b?.values:void 0,markdownEnumDescriptions:$?.os===r.OperatingSystem.Windows?b?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[h],remove:t?[t]:[]})}}),define(Se[285],ke([1,0,2,13,117,28,119]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yR=void 0;let A=class extends n.$Xc{constructor(o,S){super(),this.a=o,this.b=S}start(){const o={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:r.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},S=(0,R.$$m)(this.b.args,this.b.isBuilt);S&&(S.break&&S.port?o.debugBrk=S.port:!S.break&&S.port&&(o.debug=S.port));const v=new E.$hr(r.$1g.asFileUri("bootstrap-fork").fsPath,o),f=new n.$Wc;return f.add(v),{client:v,store:f,onDidProcessExit:v.onDidProcessExit}}};e.$yR=A,e.$yR=A=ze([Fe(1,I.$Ni)],A)}),define(Se[286],ke([1,0,31,13,21,9,3,32,17,11,25,135,97,136]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=a,e.$Ms=h,e.$Ns=m,n=Be(n),I=Be(I),A=Be(A),S=Be(S);function a(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let D=0;return u&&u.length===4&&(D=parseInt(u[3])),D}async function h(u,D,P,T=A.env,z=S.Promises.exists){if(I.$lc(u))return await z(u)?u:void 0;if(D===void 0&&(D=A.cwd()),I.$pc(u)!=="."){const Y=I.$mc(D,u);return await z(Y)?Y:void 0}const k=(0,E.$mo)(T,"PATH");if(P===void 0&&(0,o.$gg)(k)&&(P=k.split(I.$wc)),P===void 0||P.length===0){const Y=I.$mc(D,u);return await z(Y)?Y:void 0}for(const Y of P){let J;if(I.$lc(Y)?J=I.$mc(Y,u):J=I.$mc(D,Y,u),await z(J))return J;if(R.$c){let ne=J+".com";if(await z(ne)||(ne=J+".exe",await z(ne)))return ne}}const q=I.$mc(D,u);return await z(q)?q:void 0}function m(u,D,P,T,z){const C=R.$c&&(!D.windowsEnableConpty||a()<18309);if(!D.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||C)return;const k=u.args,q=A.$gc==="win32"?I.$qc(u.executable).toLowerCase():I.$qc(u.executable),Y=I.$pc(r.$1g.asFileUri("").fsPath);let J;const ne={VSCODE_INJECTION:"1"};if(D.shellIntegration.nonce&&(ne.VSCODE_NONCE=D.shellIntegration.nonce),R.$c){if(q==="pwsh.exe"||q==="powershell.exe")return!k||s(k)?J=d.get(p.WindowsPwsh):g(k)&&(J=d.get(p.WindowsPwshLogin)),J?(J=[...J],J[J.length-1]=(0,y.$ff)(J[J.length-1],Y,""),ne.VSCODE_STABLE=z.quality==="stable"?"1":"0",D.shellIntegration.suggestEnabled&&(ne.VSCODE_SUGGEST="1"),{newArgs:J,envMixin:ne}):void 0;if(q==="bash.exe")return!k||k.length===0?J=d.get(p.Bash):c(k)&&(ne.VSCODE_SHELL_LOGIN="1",$(D,ne),J=d.get(p.Bash)),J?(J=[...J],J[J.length-1]=(0,y.$ff)(J[J.length-1],Y),ne.VSCODE_STABLE=z.quality==="stable"?"1":"0",{newArgs:J,envMixin:ne}):void 0;T.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(q){case"bash":return!k||k.length===0?J=d.get(p.Bash):c(k)&&(ne.VSCODE_SHELL_LOGIN="1",$(D,ne),J=d.get(p.Bash)),J?(J=[...J],J[J.length-1]=(0,y.$ff)(J[J.length-1],Y),ne.VSCODE_STABLE=z.quality==="stable"?"1":"0",{newArgs:J,envMixin:ne}):void 0;case"fish":{const Z=P?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",x=I.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return ne.XDG_DATA_DIRS=`${Z}:${x}`,$(D,ne),{newArgs:void 0,envMixin:ne}}case"pwsh":return!k||s(k)?J=d.get(p.Pwsh):g(k)&&(J=d.get(p.PwshLogin)),J?(D.shellIntegration.suggestEnabled&&(ne.VSCODE_SUGGEST="1"),J=[...J],J[J.length-1]=(0,y.$ff)(J[J.length-1],Y,""),ne.VSCODE_STABLE=z.quality==="stable"?"1":"0",{newArgs:J,envMixin:ne}):void 0;case"zsh":{if(!k||k.length===0?J=d.get(p.Zsh):c(k)?(J=d.get(p.ZshLogin),$(D,ne)):(k===d.get(p.Zsh)||k===d.get(p.ZshLogin))&&(J=k),!J)return;J=[...J],J[J.length-1]=(0,y.$ff)(J[J.length-1],Y);let Z;try{Z=n.userInfo().username}catch{Z="unknown"}const x=I.$mc(n.tmpdir(),`${Z}-${z.applicationName}-zsh`);ne.ZDOTDIR=x;const le=P?.ZDOTDIR??n.homedir()??"~";ne.USER_ZDOTDIR=le;const K=[];return K.push({source:I.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.$mc(x,".zshrc")}),K.push({source:I.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.$mc(x,".zprofile")}),K.push({source:I.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.$mc(x,".zshenv")}),K.push({source:I.$mc(Y,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.$mc(x,".zlogin")}),{newArgs:J,envMixin:ne,filesToCopy:K}}}T.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function $(u,D){if(R.$d&&u.environmentVariableCollections){const P=(0,f.$Js)(u.environmentVariableCollections),z=new w.$Ks(P).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),C=[];if(z)for(const k of z)k.type===v.EnvironmentVariableMutatorType.Prepend&&C.push(k.value);C.length>0&&(D.VSCODE_PATH_PREFIX=C.join(""))}}var p;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(p||(p={}));const d=new Map;d.set(p.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(p.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(p.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(p.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(p.Zsh,["-i"]),d.set(p.ZshLogin,["-il"]),d.set(p.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],t=["--login","-l"],l=["-i","--interactive"],i=["-nol","-nologo"];function g(u){return typeof u=="string"?b.includes(u.toLowerCase()):u.length===1&&b.includes(u[0].toLowerCase())||u.length===2&&(b.includes(u[0].toLowerCase())||b.includes(u[1].toLowerCase()))&&(i.includes(u[0].toLowerCase())||i.includes(u[1].toLowerCase()))}function s(u){return typeof u=="string"?i.includes(u.toLowerCase()):u.length===0||u?.length===1&&i.includes(u[0].toLowerCase())}function c(u){return typeof u!="string"&&(u=u.filter(D=>!l.includes(D.toLowerCase()))),u==="string"&&t.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&t.includes(u[0].toLowerCase())}}),define(Se[287],ke([1,0,60,57,9,3,11,25,113,53,286,84]),function(se,e,n,r,E,I,R,A,y,o,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=h,n=Be(n),A=Be(A);var f;(function(D){D.UnixShellsPath="/etc/shells"})(f||(f={}));let w,a=!0;function h(D,P,T,z,C=process.env,k,q,Y,J){return k=k||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},I.$c?m(T,k,C,q,z.getValue(o.TerminalSettingId.UseWslProfiles)!==!1,D&&typeof D=="object"?{...D}:z.getValue(o.TerminalSettingId.ProfilesWindows),typeof P=="string"?P:z.getValue(o.TerminalSettingId.DefaultProfileWindows),J,Y):s(k,q,T,D&&typeof D=="object"?{...D}:z.getValue(I.$e?o.TerminalSettingId.ProfilesLinux:o.TerminalSettingId.ProfilesMacOs),typeof P=="string"?P:z.getValue(I.$e?o.TerminalSettingId.DefaultProfileLinux:o.TerminalSettingId.DefaultProfileMacOs),J,Y,C)}async function m(D,P,T,z,C,k,q,Y,J){const ne=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Z=`${process.env.windir}\\${ne?"Sysnative":"System32"}`;let x=!1;(0,S.$Ls)()>=16299&&(x=!0),await b(Y);const le=new Map;if(D){le.set("PowerShell",{source:o.ProfileSource.Pwsh,icon:r.$6j.terminalPowershell,isAutoDetected:!0}),le.set("Windows PowerShell",{path:`${Z}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.$6j.terminalPowershell,isAutoDetected:!0}),le.set("Git Bash",{source:o.ProfileSource.GitBash,isAutoDetected:!0}),le.set("Command Prompt",{path:`${Z}\\cmd.exe`,icon:r.$6j.terminalCmd,isAutoDetected:!0}),le.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),le.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:r.$6j.terminalBash,isAutoDetected:!0});const ae=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;le.set("Cmder",{path:`${Z}\\cmd.exe`,args:["/K",ae],requiresPath:process.env.CMDER_ROOT?ae:{path:ae,isUnsafe:!0},isAutoDetected:!0})}c(k,le);const K=await $(le.entries(),q,P,T,z,J);if(D&&C)try{const ae=await i(`${Z}\\${x?"wsl":"bash"}.exe`,q);for(const M of ae)(!k||!(M.profileName in k))&&K.push(M)}catch{a&&(z?.trace("WSL is not installed, so could not detect WSL profiles"),a=!1)}return K}async function $(D,P,T,z=process.env,C,k){const q=[];for(const[Y,J]of D)q.push(p(Y,J,P,T,z,C,k));return(await Promise.all(q)).filter(Y=>!!Y)}async function p(D,P,T,z,C=process.env,k,q){if(P===null)return;let Y,J,ne;if("source"in P&&!("path"in P)){const K=w?.get(P.source);if(!K)return;Y=K.paths,J=P.args||K.args,P.icon?ne=d(P.icon):K.icon&&(ne=K.icon)}else Y=Array.isArray(P.path)?P.path:[P.path],J=I.$c||Array.isArray(P.args)?P.args:void 0,ne=d(P.icon);let Z;if(q){const K=Y.map(M=>typeof M=="string"?M:M.path),ae=await q(K);Z=new Array(Y.length);for(let M=0;M<Y.length;M++)typeof Y[M]=="string"?Z[M]=ae[M]:Z[M]={path:ae[M],isUnsafe:!0}}else Z=Y.slice();let x;if(P.requiresPath){let K;if((0,R.$gg)(P.requiresPath)?K=P.requiresPath:(K=P.requiresPath.path,P.requiresPath.isUnsafe&&(x=K)),!await z.existsFile(K))return}const le=await u(D,T,Z,z,C,J,P.env,P.overrideName,P.isAutoDetected,x);if(!le){k?.debug("Terminal profile not validated",D,Y);return}return le.isAutoDetected=P.isAutoDetected,le.icon=ne,le.color=P.color,le}function d(D){return typeof D=="string"?{id:D}:D}async function b(D){if(w&&!D)return;const[P,T]=await Promise.all([t(),D||l()]);w=new Map,w.set(o.ProfileSource.GitBash,{profileName:"Git Bash",paths:P,args:["--login","-i"]}),w.set(o.ProfileSource.Pwsh,{profileName:"PowerShell",paths:T,icon:r.$6j.terminalPowershell})}async function t(){const D=new Set,P=await(0,S.$Ms)("git.exe");if(P){const C=(0,v.dirname)(P);D.add((0,v.resolve)(C,"../.."))}function T(C,k){k&&C.add(k)}T(D,process.env.ProgramW6432),T(D,process.env.ProgramFiles),T(D,process.env["ProgramFiles(X86)"]),T(D,`${process.env.LocalAppData}\\Program`);const z=[];for(const C of D)z.push(`${C}\\Git\\bin\\bash.exe`,`${C}\\Git\\usr\\bin\\bash.exe`,`${C}\\usr\\bin\\bash.exe`);return z.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),z.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),z}async function l(){const D=[];for await(const P of(0,y.$wm)())D.push(P.exePath);return D}async function i(D,P){const T=[],z=await new Promise((q,Y)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(J,ne)=>{if(J)return Y("Problem occurred when getting wsl distros");q(ne)})});if(!z)return[];const C=new RegExp(/[\r?\n]/),k=z.split(C).filter(q=>q.trim().length>0&&q!=="");for(const q of k){if(q===""||q.startsWith("docker-desktop"))continue;const Y=`${q} (WSL)`,J={profileName:Y,path:D,args:["-d",`${q}`],isDefault:Y===P,icon:g(q),isAutoDetected:!1};T.push(J)}return T}function g(D){return D.includes("Ubuntu")?r.$6j.terminalUbuntu:D.includes("Debian")?r.$6j.terminalDebian:r.$6j.terminalLinux}async function s(D,P,T,z,C,k,q,Y){const J=new Map;if(T&&await D.existsFile(f.UnixShellsPath)){const ne=(await D.readFile(f.UnixShellsPath)).toString(),Z=(k||ne.split(`
`)).map(le=>{const K=le.indexOf("#");return K===-1?le:le.substring(0,K)}).filter(le=>le.trim().length>0),x=new Map;for(const le of Z){let K=(0,E.$qc)(le),ae=x.get(K)||0;ae++,ae>1&&(K=`${K} (${ae})`),x.set(K,ae),J.set(K,{path:le,isAutoDetected:!0})}}return c(z,J),await $(J.entries(),C,D,Y,P,q)}function c(D,P){if(D)for(const[T,z]of Object.entries(D))z===null||typeof z!="object"||!("path"in z)&&!("source"in z)?P.delete(T):(z.icon=z.icon||P.get(T)?.icon,P.set(T,z))}async function u(D,P,T,z,C,k,q,Y,J,ne){if(T.length===0)return Promise.resolve(void 0);const Z=T.shift();if(Z==="")return u(D,P,T,z,C,k,q,Y,J);const x=typeof Z!="string"&&Z.isUnsafe,le=typeof Z=="string"?Z:Z.path,K={profileName:D,path:le,args:k,env:q,overrideName:Y,isAutoDetected:J,isDefault:D===P,isUnsafePath:x,requiresUnsafePath:ne};if((0,E.$qc)(le)===le){const M=C.PATH?C.PATH.split(E.$wc):void 0,B=await(0,S.$Ms)(le,void 0,M,void 0,z.existsFile);return B?(K.path=B,K.isFromPath=!0,K):u(D,P,T,z,C,k)}return await z.existsFile((0,E.$kc)(le))?K:u(D,P,T,z,C,k,q,Y,J)}}),define(Se[288],ke([1,0,6,2,3,50,27,12,125,94,282,53,284,287,116,48]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0;var m;(function(p){p[p.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let $=class extends r.$Xc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(d,b,t,l){super(),this.M=d,this.N=b,this.O=t,this.P=l,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$ne),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$ne),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$ne),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$ne),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$ne),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$ne),this.onProcessData=this.D.event,this.F=this.B(new n.$ne),this.onProcessReady=this.F.event,this.G=this.B(new n.$ne),this.onProcessReplay=this.G.event,this.H=this.B(new n.$ne),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$ne),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$ne),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$ne),this.onProcessExit=this.L.event,(0,f.$Cs)(),this.B(this.M),this.B((0,r.$Vc)(()=>this.W())),this.j=this.B(new S.$vs(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(v.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$c)return process.env;try{return await(0,o.$Rm)(this.N,this.O,{_:[]},process.env)}catch(d){return this.O.error("ptyHost was unable to resolve shell environment",d),{}}}U(){const d=this.M.start(),b=d.client;this.O.getLevel()===A.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),I.ProxyChannel.toService(b.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(d.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=m.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const l=I.ProxyChannel.toService(b.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(l.onProcessData(i=>this.D.fire(i))),this.B(l.onProcessReady(i=>this.F.fire(i))),this.B(l.onProcessExit(i=>this.L.fire(i))),this.B(l.onDidChangeProperty(i=>this.J.fire(i))),this.B(l.onProcessReplay(i=>this.G.fire(i))),this.B(l.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(l.onDidRequestDetach(i=>this.I.fire(i))),this.B(new y.$us(this.P,b.getChannel(v.TerminalIpcChannels.Logger))),this.a=d,this.b=l,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(v.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[d,l]}async createProcess(d,b,t,l,i,g,s,c,u,D,P){const T=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),z=await this.f.createProcess(d,b,t,l,i,g,s,c,u,D,P);return clearTimeout(T),z}updateTitle(d,b,t){return this.f.updateTitle(d,b,t)}updateIcon(d,b,t,l){return this.f.updateIcon(d,b,t,l)}attachToProcess(d){return this.f.attachToProcess(d)}detachFromProcess(d,b){return this.f.detachFromProcess(d,b)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(d){return this.f.start(d)}shutdown(d,b){return this.f.shutdown(d,b)}input(d,b){return this.f.input(d,b)}processBinary(d,b){return this.f.processBinary(d,b)}resize(d,b,t){return this.f.resize(d,b,t)}clearBuffer(d){return this.f.clearBuffer(d)}acknowledgeDataEvent(d,b){return this.f.acknowledgeDataEvent(d,b)}setUnicodeVersion(d,b){return this.f.setUnicodeVersion(d,b)}getInitialCwd(d){return this.f.getInitialCwd(d)}getCwd(d){return this.f.getCwd(d)}async getLatency(){const d=new h.$he,b=await this.f.getLatency();return d.stop(),[{label:"ptyhostservice<->ptyhost",latency:d.elapsed()},...b]}orphanQuestionReply(d){return this.f.orphanQuestionReply(d)}installAutoReply(d,b){return this.f.installAutoReply(d,b)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(d){return this.f.uninstallAutoReply(d)}getDefaultSystemShell(d){return this.g?.getDefaultSystemShell(d)??(0,a.$Am)(d??E.OS,process.env)}async getProfiles(d,b,t,l=!1){const i=await this.S();return(0,w.$Os)(b,t,l,this.N,i,void 0,this.O,this.bb.bind(this,d))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(d,b){return this.f.getWslPath(d,b)}getRevivedPtyNewId(d,b){return this.f.getRevivedPtyNewId(d,b)}setTerminalLayoutInfo(d){return this.f.setTerminalLayoutInfo(d)}async getTerminalLayoutInfo(d){return this.g?.getTerminalLayoutInfo(d)}async requestDetachInstance(d,b){return this.f.requestDetachInstance(d,b)}async acceptDetachInstanceReply(d,b){return this.f.acceptDetachInstanceReply(d,b)}async freePortKillProcess(d){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(d)}async serializeTerminalState(d){return this.f.serializeTerminalState(d)}async reviveTerminalProcesses(d,b,t){return this.f.reviveTerminalProcesses(d,b,t)}async refreshProperty(d,b){return this.f.refreshProperty(d,b)}async updateProperty(d,b,t){return this.f.updateProperty(d,b,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(d){this.ab(),this.s=setTimeout(()=>this.Y(),d?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(d,b){return this.j.createRequest({workspaceId:d,originalText:b})}async acceptPtyHostResolvedVariables(d,b){this.j.acceptReply(d,b)}};e.$Ps=$,e.$Ps=$=ze([Fe(1,R.$aj),Fe(2,A.$ak),Fe(3,A.$bk)],$)}),define(Se[36],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,n.$Gi)("IUriIdentityService")}),define(Se[138],ke([1,0,36,121,16,20,168,6,2]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class o{constructor(f){this.uri=f,this.time=o._clock++}touch(){return this.time=o._clock++,this}}o._clock=0;let S=class{constructor(f){this.g=f,this.c=new y.$Wc,this.f=2**16;const w=new Map,a=h=>{let m=w.get(h.scheme);return m===void 0&&(m=f.hasProvider(h)&&!this.g.hasCapability(h,E.FileSystemProviderCapabilities.PathCaseSensitive),w.set(h.scheme,m)),m};this.c.add(A.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(h=>{w.delete(h.scheme)})),this.extUri=new I.$9g(a),this.d=new R.$Ss((h,m)=>this.extUri.compare(h,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(f){this.g.hasProvider(f)&&(f=(0,I.$ih)(f));const w=this.d.get(f);return w?w.touch().uri.with({fragment:f.fragment}):(this.d.set(f,new o(f)),this.h(),f)}h(){if(this.d.size<this.f)return;const f=[...this.d.entries()].sort((a,h)=>a[1].time<h[1].time?1:a[1].time>h[1].time?-1:0);o._clock=0,this.d.clear();const w=this.f*.5;for(let a=0;a<w;a++)this.d.set(f[a][0],f[a][1].touch())}};e.$Ts=S,e.$Ts=S=ze([Fe(0,E.$al)],S),(0,r.$Qs)(n.$Kl,S,r.InstantiationType.Delayed)}),define(Se[98],ke([1,0,227,9,69,20,4,5,13]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=o,e.$Ri=S,e.$Ui=v,e.$Vi=f,e.$Wi=w,e.$Xi=h,e.$Yi=m,e.$2i=d,e.$7i=b,e.$8i=t,e.$0i=l,e.$$i=i,e.$_i=g,e.$Pi=(0,A.$Gi)("contextService");function o(s){const c=s;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}function S(s){return typeof s?.id=="string"&&!o(s)&&!f(s)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function v(s,c){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$qc)(s)}:c?e.$Si:e.$Ti;const u=s;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function f(s){const c=s;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}function w(s){const c=s;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const u=s;if(u?.configPath)return{id:u.id,configPath:R.URI.revive(u.configPath)};if(s?.id)return{id:s.id}}var a;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(a||(e.WorkbenchState=a={}));function h(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function m(s){const c=s;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class ${constructor(c,u,D,P,T){this.h=c,this.j=D,this.k=P,this.l=T,this.c=E.$Mi.forUris(this.l,()=>!0),this.folders=u}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=E.$Mi.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=$;class p{constructor(c,u){this.raw=u,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,I.$hh)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=p;function d(s){return new p({uri:s,index:0,name:(0,I.$dh)(s)},{uri:s.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,n.localize)(0,null),extensions:[e.$3i]}],e.$6i="workspace.json";function b(s,c){return I.$$g.isEqualOrParent(s,c.untitledWorkspacesHome)}function t(s){let c;return R.URI.isUri(s)?c=s:c=s.configuration,c?.scheme===y.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(s){return s.id===e.$9i}function i(s,c){return!b(s,c)&&!t(s)}function g(s){return(typeof s=="string"?(0,r.$rc)(s):(0,I.$fh)(s))===e.$4i}}),define(Se[34],ke([1,0,68,6,2,20,4,226,28,16,5,12,98,26,36,14,23,17,11]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=b,e.$Nl=t,e.$Ol=l;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function b(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$Ml=(0,S.$Gi)("IUserDataProfilesService");function t(s,c){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:R.URI.revive(s.location).with({scheme:c}),globalStorageHome:R.URI.revive(s.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(s.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(s.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(s.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(s.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(s.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(s.cacheHome).with({scheme:c}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function l(s,c,u,D,P,T){return{id:s,name:c,location:u,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:T&&P?.useDefaultFlags?.globalState?T.globalStorageHome:(0,I.$hh)(u,"globalStorage"),settingsResource:T&&P?.useDefaultFlags?.settings?T.settingsResource:(0,I.$hh)(u,"settings.json"),keybindingsResource:T&&P?.useDefaultFlags?.keybindings?T.keybindingsResource:(0,I.$hh)(u,"keybindings.json"),tasksResource:T&&P?.useDefaultFlags?.tasks?T.tasksResource:(0,I.$hh)(u,"tasks.json"),snippetsHome:T&&P?.useDefaultFlags?.snippets?T.snippetsHome:(0,I.$hh)(u,"snippets"),extensionsResource:T&&P?.useDefaultFlags?.extensions?T.extensionsResource:(0,I.$hh)(u,"extensions.json"),cacheHome:(0,I.$hh)(D,s),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let i=class extends E.$Xc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,u,D,P){super(),this.t=c,this.u=u,this.w=D,this.y=P,this.f=!0,this.h=this.B(new r.$ne),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$ne),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$ne),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$ne),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Dc,workspaces:new w.$Dc,emptyWindows:new Map},this.profilesHome=(0,I.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),u=[c];if(this.f)try{for(const T of this.O()){if(!T.name||!(0,p.$gg)(T.name)||!T.location){this.y.warn("Skipping the invalid stored profile",T.location||T.name);continue}u.push(l((0,I.$eh)(T.location),T.name,T.location,this.g,{shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags},c))}}catch(T){this.y.error(T)}const D=new w.$Dc,P=new Map;if(u.length)try{const T=this.Q();if(T.workspaces)for(const[z,C]of Object.entries(T.workspaces)){const k=R.URI.parse(z),q=u.find(Y=>Y.id===C);q&&D.set(k,q)}if(T.emptyWindows)for(const[z,C]of Object.entries(T.emptyWindows)){const k=u.find(q=>q.id===C);k&&P.set(z,k)}}catch(T){this.y.error(T)}this.z={profiles:u,workspaces:D,emptyWindows:P}}return this.z}D(){const c=l("__default__profile__",(0,A.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const u="Temp",D=new RegExp(`${(0,$.$jf)(u)}\\s(\\d+)`);let P=0;for(const z of this.profiles){const C=D.exec(z.name),k=C?parseInt(C[1]):0;P=k>P?k:P}const T=`${u} ${P+1}`;return this.createProfile((0,n.$uj)((0,m.$3g)()).toString(16),T,{transient:!0},c)}async createNamedProfile(c,u,D){return this.createProfile((0,n.$uj)((0,m.$3g)()).toString(16),c,u,D)}async createProfile(c,u,D,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const T=await this.F(c,u,D);return P&&await this.setProfileForWorkspace(P,T),T}async F(c,u,D){if(!(0,p.$gg)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(u);return P||(P=(async()=>{try{if(this.profiles.find(k=>k.name===u||k.id===c))throw new Error(`Profile with ${u} name already exists`);const z=l(c,u,(0,I.$hh)(this.profilesHome,c),this.g,D,this.defaultProfile);await this.u.createFolder(z.location);const C=[];return this.j.fire({profile:z,join(k){C.push(k)}}),await h.Promises.settled(C),this.I([z],[],[]),z}finally{this.r.delete(u)}})(),this.r.set(u,P)),P}async updateProfile(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(P=>P.id===c.id);if(!D)throw new Error(`Profile '${c.name}' does not exist`);return D=l(D.id,u.name??D.name,D.location,this.g,{shortName:u.shortName??D.shortName,icon:u.icon===null?void 0:u.icon??D.icon,transient:u.transient??D.isTransient,useDefaultFlags:u.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(P=>P.id===c.id);if(!u)throw new Error(`Profile '${c.name}' does not exist`);const D=[];this.m.fire({profile:u,join(P){D.push(P)}});try{await Promise.allSettled(D)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(P){(0,o.$rl)(P)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.error(P)}}async setProfileForWorkspace(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(P=>P.id===u.id);if(!D)throw new Error(`Profile '${u.name}' does not exist`);this.L(c,D)}unsetWorkspace(c,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,u)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(u=>u.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(c.map(u=>this.removeProfile(u)))}getProfileForWorkspace(c){const u=this.G(c),D=R.URI.isUri(u)?this.C.workspaces.get(u):this.C.emptyWindows.get(u);return D||((0,f.$Qi)(c)?this.s.folders.get(c.uri):(0,f.$Vi)(c)?this.s.workspaces.get(c.configPath):this.s.emptyWindows.get(c.id))}G(c){return(0,f.$Qi)(c)?c.uri:(0,f.$Vi)(c)?c.configPath:c.id}H(c){return!!([...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,c.location))||[...this.s.folders.values()].some(u=>this.w.extUri.isEqual(u.location,c.location)))}I(c,u,D){const P=[...this.profiles,...c],T=[],z=this.s.profiles;this.s.profiles=[];for(let C of P){if(C.isDefault||u.some(q=>C.id===q.id))continue;C=D.find(q=>C.id===q.id)??C;const k=z.find(q=>C.id===q.id);if(C.isTransient)this.s.profiles.push(C);else{if(k){for(const[q,Y]of this.s.emptyWindows.entries())if(C.id===Y.id){this.L({id:q},C);break}for(const[q,Y]of this.s.workspaces.entries())if(C.id===Y.id){this.L({id:"",configPath:q},C);break}for(const[q,Y]of this.s.folders.entries())if(C.id===Y.id){this.L({id:"",uri:q},C);break}}T.push({location:C.location,name:C.name,shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags})}}this.P(T),this.z=void 0,this.J(c,u,D)}J(c,u,D){this.h.fire({added:c,removed:u,updated:D,all:this.profiles})}L(c,u,D){if(D=u?.isTransient?!0:D,D)(0,f.$Qi)(c)?(this.s.folders.delete(c.uri),u&&this.s.folders.set(c.uri,u)):(0,f.$Vi)(c)?(this.s.workspaces.delete(c.configPath),u&&this.s.workspaces.set(c.configPath,u)):(this.s.emptyWindows.delete(c.id),u&&this.s.emptyWindows.set(c.id,u));else{this.L(c,void 0,!0);const P=this.G(c);R.URI.isUri(P)?(this.C.workspaces.delete(P),u&&this.C.workspaces.set(P,u)):(this.C.emptyWindows.delete(P),u&&this.C.emptyWindows.set(P,u)),this.M()}}M(){const c={};for(const[D,P]of this.C.workspaces.entries())c[D.toString()]=P.id;const u={};for(const[D,P]of this.C.emptyWindows.entries())u[D.toString()]=P.id;this.R({workspaces:c,emptyWindows:u}),this.z=void 0}N(c){const u={},D=this.D();if(c.workspaces)for(const[T,z]of Object.entries(c.workspaces)){const C=R.URI.parse(z);u[T]=this.w.extUri.isEqual(C,D.location)?D.id:this.w.extUri.basename(C)}const P={};if(c.emptyWindows)for(const[T,z]of Object.entries(c.emptyWindows)){const C=R.URI.parse(z);P[T]=this.w.extUri.isEqual(C,D.location)?D.id:this.w.extUri.basename(C)}return{workspaces:u,emptyWindows:P}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Pl=i,i.b="userDataProfiles",i.c="profileAssociations",e.$Pl=i=ze([Fe(0,y.$Ni),Fe(1,o.$al),Fe(2,a.$Kl),Fe(3,v.$ak)],i);class g extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Ql=g}),define(Se[99],ke([1,0,18,14,19,10,6,2,3,11,4,206,30,39,22,74,12,29,24,36,34]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Eq=void 0,e.$Fq=l,v=Be(v);let t=class extends A.$Xc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(c,u,D,P,T,z){super(),this.z=c,this.C=u,this.D=D,this.F=P,this.G=T,this.H=z,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new R.$ne),this.s=this.B(new R.$ne),this.t=this.B(new R.$ne),this.u=this.B(new R.$ne),this.w=this.B(new R.$ne),this.y=[],this.B((0,A.$Vc)(()=>{this.j.forEach(({task:C})=>C.cancel()),this.m.forEach(C=>C.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(c){const u=await this.getTargetPlatform();return c.allTargetPlatforms.some(D=>(0,f.$ip)(D,c.allTargetPlatforms,u))}async installFromGallery(c,u={}){try{const P=(await this.installGalleryExtensions([{extension:c,options:u}])).find(({identifier:T})=>(0,w.$Lp)(T,c.identifier));if(P?.local)return P?.local;throw P?.error?P.error:new f.$mp(`Unknown error while installing extension ${c.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(D){throw l(D)}}async installGalleryExtensions(c){if(!this.z.isEnabled())throw new f.$mp(v.localize(0,null),f.ExtensionManagementErrorCode.NotAllowed);const u=[],D=[];return await Promise.allSettled(c.map(async({extension:P,options:T})=>{try{const z=await this.N(P,!!T?.installGivenVersion,!!T?.installPreReleaseVersion,T.productVersion??{version:this.G.version,date:this.G.date});D.push({...z,options:T})}catch(z){u.push({identifier:P.identifier,operation:f.InstallOperation.Install,source:P,error:z,profileLocation:T.profileLocation??this.X()})}})),D.length&&u.push(...await this.I(D)),u}async uninstall(c,u={}){return this.F.trace("ExtensionManagementService#uninstall",c.identifier.id),this.P(c,u)}async toggleAppliationScope(c,u){if((0,a.$vn)(c.manifest)||c.isBuiltin)return c;if(c.isApplicationScoped){let D=await this.updateMetadata(c,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(u,this.H.defaultProfile.extensionsResource)||(D=await this.$(c,this.H.defaultProfile.extensionsResource,u));for(const P of this.H.profiles){const T=(await this.getInstalled(a.ExtensionType.User,P.extensionsResource)).find(z=>(0,w.$Lp)(z.identifier,c.identifier));T?this.w.fire({local:T,profileLocation:P.extensionsResource}):this.u.fire({identifier:c.identifier,profileLocation:P.extensionsResource})}return D}else{const D=this.D.extUri.isEqual(u,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(c,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(c,u,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:D.identifier,operation:f.InstallOperation.Install,local:D,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),D}}getExtensionsControlManifest(){const c=new Date().getTime();return(!this.g||c-this.h>1e3*60*5)&&(this.g=this.W(),this.h=c),this.g}registerParticipant(c){this.y.push(c)}async I(c){const u=new Map,D=new Map,P=[],T=(C,k)=>`${w.$Mp.create(C).toString()}-${k.toString()}`,z=(C,k,q,Y)=>{const J=this.Y(C,k,q),ne=`${(0,w.$Qp)(C.publisher,C.name)}-${q.profileLocation.toString()}`;D.set(ne,{task:J,root:Y}),this.n.fire({identifier:J.identifier,source:k,profileLocation:q.profileLocation}),this.F.info("Installing extension:",J.identifier.id,q),S.URI.isUri(k)||this.j.set(T(k,q.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:C,extension:k,options:q}of c){const Y=q.isApplicationScoped||q.isBuiltin||(0,a.$vn)(C),J={...q,installOnlyNewlyAddedFromExtensionPack:q.installOnlyNewlyAddedFromExtensionPack??!S.URI.isUri(k),isApplicationScoped:Y,profileLocation:Y?this.H.defaultProfile.extensionsResource:q.profileLocation??this.X(),productVersion:q.productVersion??{version:this.G.version,date:this.G.date}},ne=S.URI.isUri(k)?void 0:this.j.get(T(k,J.profileLocation));ne?(this.F.info("Extension is already requested to install",ne.task.identifier.id,J.profileLocation.toString()),P.push(ne.task.waitUntilTaskIsFinished())):z(C,k,J,void 0)}return await Promise.all([...D.values()].map(async({task:C})=>{if(C.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",C.identifier.id);else try{const k=await this.M(C.identifier,C.manifest,!!C.options.installOnlyNewlyAddedFromExtensionPack,!!C.options.installPreReleaseVersion,C.options.profileLocation,C.options.productVersion),q=await this.getInstalled(void 0,C.options.profileLocation,C.options.productVersion),Y={...C.options,context:{...C.options.context,[f.$cp]:!0}};for(const{gallery:J,manifest:ne}of(0,n.$Pb)(k,({gallery:Z})=>Z.identifier.id)){if(D.has(`${J.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const Z=this.j.get(T(J,Y.profileLocation));if(Z){if(this.J(C,Z.task)){const x=Z.task.identifier;this.F.info("Waiting for already requested installing extension",x.id,C.identifier.id,Y.profileLocation.toString()),Z.waitingTasks.push(C),P.push(R.Event.toPromise(R.Event.filter(this.onDidInstallExtensions,le=>le.some(K=>(0,w.$Lp)(K.identifier,x)))).then(le=>{if(this.F.info("Finished waiting for already requested installing extension",x.id,C.identifier.id,Y.profileLocation.toString()),!le.find(ae=>(0,w.$Lp)(ae.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else q.some(({identifier:x})=>(0,w.$Lp)(x,J.identifier))||z(ne,J,Y,C)}}catch(k){if(S.URI.isUri(C.source))(0,n.$Ob)(C.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",C.identifier.id,k.message),(0,n.$Ob)(C.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",C.identifier.id,k.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",C.identifier.id),k}})),await this.L([...D.entries()].map(async([C,{task:k}])=>{const q=new Date().getTime();let Y;try{Y=await k.run(),await this.L(this.y.map(J=>J.postInstall(Y,k.source,k.options,E.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(J){const ne=l(J);throw S.URI.isUri(k.source)||i(this.C,k.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Tp)(k.source),error:ne,source:k.options.context?.[f.$bp]}),u.set(C,{error:ne,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.options.profileLocation,applicationScoped:k.options.isApplicationScoped}),this.F.error("Error while installing the extension",k.identifier.id,(0,I.$ab)(ne),k.options.profileLocation.toString()),ne}if(!S.URI.isUri(k.source)){const J=k.operation===f.InstallOperation.Update,ne=J?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(i(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Tp)(k.source),verificationStatus:k.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:ne,source:k.options.context?.[f.$bp]}),y.$i&&k.operation!==f.InstallOperation.Update)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,f.StatisticType.Install)}catch{}}u.set(C,{local:Y,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),P.length&&await this.L(P),[...u.values()]}catch(C){const k=(J,ne,Z)=>{const x=[];J.manifest.extensionDependencies?.length&&x.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&x.push(...J.manifest.extensionPack);for(const le of x){if(Z.includes(le.toLowerCase()))continue;Z.push(le.toLowerCase());const K=u.get(`${le.toLowerCase()}-${ne.toString()}`);K?.local&&(Z=k(K.local,ne,Z))}return Z},q=J=>({identifier:J.identifier,operation:f.InstallOperation.Install,source:J.source,context:J.options.context,profileLocation:J.options.profileLocation,error:C}),Y=[];for(const[J,{task:ne,root:Z}]of D){const x=u.get(J);x?x.local&&Z&&!u.get(`${Z.identifier.id.toLowerCase()}-${ne.options.profileLocation.toString()}`)?.local&&(Y.push(this.Z(x.local,{versionOnly:!0,profileLocation:ne.options.profileLocation})),u.set(J,q(ne))):(ne.cancel(),u.set(J,q(ne)))}for(const[J,{task:ne}]of D){const Z=u.get(J);if(!Z?.local||ne.options.donotIncludePackAndDependencies)continue;k(Z.local,ne.options.profileLocation,[Z.local.identifier.id.toLowerCase()]).slice(1).some(le=>D.has(`${le.toLowerCase()}-${ne.options.profileLocation.toString()}`)&&!u.get(`${le.toLowerCase()}-${ne.options.profileLocation.toString()}`)?.local)&&(Y.push(this.Z(Z.local,{versionOnly:!0,profileLocation:ne.options.profileLocation})),u.set(J,q(ne)))}throw Y.length&&await Promise.allSettled(Y.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(ne){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,I.$ab)(ne))}})),C}finally{for(const{task:C}of D.values())C.source&&!S.URI.isUri(C.source)&&this.j.delete(T(C.source,C.options.profileLocation));if(u.size){const C=[...u.values()];for(const k of C)k.local&&this.F.info("Extension installed successfully:",k.identifier.id,k.profileLocation.toString());this.s.fire(C)}}}J(c,u){for(const[,{task:D,waitingTasks:P}]of this.j.entries())if(D===c&&(P.includes(u)||P.some(T=>this.J(T,u)))||D===u&&P[0]&&!this.J(c,P[0]))return!1;return!0}async L(c,u){const D=[],P=[],T=await Promise.allSettled(c);for(const C of T)C.status==="fulfilled"?D.push(C.value):P.push(l(C.reason,u));if(!P.length)return D;if(P.length===1)throw P[0];let z=new f.$mp("",f.ExtensionManagementErrorCode.Unknown);for(const C of P)z=new f.$mp(z.message?`${z.message}, ${C.message}`:C.message,C.code!==f.ExtensionManagementErrorCode.Unknown&&C.code!==f.ExtensionManagementErrorCode.Internal?C.code:z.code);throw z}async M(c,u,D,P,T,z){if(!this.z.isEnabled())return[];const C=await this.getInstalled(void 0,T,z),k=[],q=[],Y=async(J,ne)=>{k.push(J);const Z=ne.extensionDependencies||[],x=[...Z];if(ne.extensionPack){const le=D?C.find(K=>(0,w.$Lp)(K.identifier,J)):void 0;for(const K of ne.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(ae=>(0,w.$Lp)({id:ae},{id:K}))||x.every(ae=>!(0,w.$Lp)({id:ae},{id:K}))&&x.push(K)}if(x.length){const le=x.filter(K=>k.every(ae=>!(0,w.$Lp)(ae,{id:K})));if(le.length){const K=await this.z.getExtensions(le.map(ae=>({id:ae,preRelease:P})),E.CancellationToken.None);for(const ae of K){if(k.find(re=>(0,w.$Lp)(re,ae.identifier)))continue;const M=Z.some(re=>(0,w.$Lp)({id:re},ae.identifier));let B;try{B=await this.N(ae,!1,P,z)}catch(re){if(M)throw re;this.F.info("Skipping the packed extension as it cannot be installed",ae.identifier.id,(0,I.$ab)(re));continue}q.push({gallery:B.extension,manifest:B.manifest}),await Y(B.extension.identifier,B.manifest)}}}};return await Y(c,u),q}async N(c,u,D,P){let T;const z=await this.getExtensionsControlManifest();if(z.malicious.some(q=>(0,w.$Lp)(c.identifier,q)))throw new f.$mp(v.localize(1,null,c.identifier.id),f.ExtensionManagementErrorCode.Malicious);const C=z.deprecated[c.identifier.id.toLowerCase()];if(C?.extension?.autoMigrate){if(this.F.info(`The '${c.identifier.id}' extension is deprecated, fetching the compatible '${C.extension.id}' extension instead.`),T=(await this.z.getExtensions([{id:C.extension.id,preRelease:C.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:P},E.CancellationToken.None))[0],!T)throw new f.$mp(v.localize(2,null,c.identifier.id,C.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(c)){const q=await this.getTargetPlatform();throw new f.$mp(v.localize(3,null,c.identifier.id,this.G.nameLong,(0,f.$ep)(q)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(T=await this.O(c,u,D,P),!T){const q=[];throw(0,h.$6p)(c.properties.enabledApiProposals??[],q)?!D&&c.properties.isPreReleaseVersion&&(await this.z.getExtensions([c.identifier],E.CancellationToken.None))[0]?new f.$mp(v.localize(5,null,c.displayName??c.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.$mp(v.localize(6,null,c.identifier.id,this.G.nameLong,this.G.version),f.ExtensionManagementErrorCode.Incompatible):new f.$mp(v.localize(4,null,c.displayName??c.identifier.id,q[0]),f.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",T.identifier.id);const k=await this.z.getManifest(T,E.CancellationToken.None);if(k===null)throw new f.$mp(`Missing manifest for extension ${T.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(k.version!==T.version)throw new f.$mp(`Cannot install '${T.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:T,manifest:k}}async O(c,u,D,P){const T=await this.getTargetPlatform();let z=null;return!u&&c.hasPreReleaseVersion&&c.properties.isPreReleaseVersion!==D&&(z=(await this.z.getExtensions([{...c.identifier,preRelease:D}],{targetPlatform:T,compatible:!0,productVersion:P},E.CancellationToken.None))[0]||null),!z&&await this.z.isExtensionCompatible(c,D,T,P)&&(z=c),z||(u?z=(await this.z.getExtensions([{...c.identifier,version:c.version}],{targetPlatform:T,compatible:!0,productVersion:P},E.CancellationToken.None))[0]||null:z=await this.z.getCompatibleExtension(c,D,T,P)),z}async P(c,u){const D={...u,profileLocation:c.isApplicationScoped?this.H.defaultProfile.extensionsResource:u.profileLocation??this.X()},P=Y=>`${Y.id.toLowerCase()}${D.versionOnly?`-${c.manifest.version}`:""}${D.profileLocation?`@${D.profileLocation.toString()}`:""}`,T=this.m.get(P(c.identifier));if(T)return this.F.info("Extensions is already requested to uninstall",c.identifier.id),T.waitUntilTaskIsFinished();const z=Y=>{const J=this.Z(Y,D);return this.m.set(P(J.extension.identifier),J),D.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,D.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.t.fire({identifier:Y.identifier,profileLocation:D.profileLocation,applicationScoped:Y.isApplicationScoped}),J},C=(Y,J)=>{J?D.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,D.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,J.message):D.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,D.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Sp)(Y),error:J}),this.u.fire({identifier:Y.identifier,error:J?.code,profileLocation:D.profileLocation,applicationScoped:Y.isApplicationScoped})},k=[],q=[];try{k.push(z(c));const Y=await this.getInstalled(a.ExtensionType.User,D.profileLocation);if(D.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${c.identifier.id}@${c.manifest.version}`);else{const J=this.S(c,Y);for(const ne of J)this.m.has(P(ne.identifier))?this.F.info("Extensions is already requested to uninstall",ne.identifier.id):k.push(z(ne))}D.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${c.identifier.id}@${c.manifest.version}`):this.Q(k.map(J=>J.extension),Y,c),await this.L(k.map(async J=>{try{if(await J.run(),await this.L(this.y.map(ne=>ne.postUninstall(J.extension,D,E.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,f.StatisticType.Uninstall)}catch{}C(J.extension)}catch(ne){const Z=l(ne);throw C(J.extension,Z),Z}finally{q.push(J)}}))}catch(Y){const J=l(Y);for(const ne of k){try{ne.cancel()}catch{}q.includes(ne)||C(ne.extension,J)}throw J}finally{for(const Y of k)this.m.delete(P(Y.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}Q(c,u,D){for(const P of c){const T=this.U(P,u);if(T.length){const z=T.filter(C=>!c.some(k=>(0,w.$Lp)(k.identifier,C.identifier)));if(z.length)throw new Error(this.R(P,z,D))}}}R(c,u,D){return D===c?u.length===1?v.localize(7,null,D.manifest.displayName||D.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?v.localize(8,null,D.manifest.displayName||D.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):v.localize(9,null,D.manifest.displayName||D.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):u.length===1?v.localize(10,null,D.manifest.displayName||D.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?v.localize(11,null,D.manifest.displayName||D.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):v.localize(12,null,D.manifest.displayName||D.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name)}S(c,u,D=[]){if(D.indexOf(c)!==-1)return[];D.push(c);const P=c.manifest.extensionPack?c.manifest.extensionPack:[];if(P.length){const T=u.filter(C=>!C.isBuiltin&&P.some(k=>(0,w.$Lp)({id:k},C.identifier))),z=[];for(const C of T)z.push(...this.S(C,u,D));return[...T,...z]}return[]}U(c,u){return u.filter(D=>D.manifest.extensionDependencies&&D.manifest.extensionDependencies.some(P=>(0,w.$Lp)({id:P},c.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(c){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,I.$ab)(c)),{malicious:[],deprecated:{},search:[]}}}};e.$Eq=t,e.$Eq=t=ze([Fe(0,f.$kp),Fe(1,p.$_l),Fe(2,d.$Kl),Fe(3,m.$ak),Fe(4,$.$tk),Fe(5,b.$Ml)],t);function l(s,c){if(s instanceof f.$mp)return s;let u;return s instanceof f.$lp?u=new f.$mp(s.message,s.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):u=new f.$mp(s.message,(0,I.$7)(s)?f.ExtensionManagementErrorCode.Cancelled:c??f.ExtensionManagementErrorCode.Internal),u.stack=s.stack,u}function i(s,c,{extensionData:u,verificationStatus:D,duration:P,error:T,source:z,durationSinceUpdate:C}){let k,q;(0,o.$og)(D)&&(D===!0?D="Verified":(D===!1||(k=f.ExtensionManagementErrorCode.Signature,q=D),D="Unverified")),T&&(k=T.code,T.code===f.ExtensionManagementErrorCode.Signature&&(q=T.message)),s.publicLog(c,{...u,verificationStatus:D,success:!T,duration:P,errorcode:k,errorcodeDetail:q,durationSinceUpdate:C,source:z})}class g{constructor(){this.d=new r.$Fh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,r.$th)(c=>this.h(c))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,r.$th)(c=>new Promise((u,D)=>{const P=c.onCancellationRequested(()=>{P.dispose(),D(new I.$8)})})),this.d.open()),this.g.cancel()}}e.$Gq=g}),define(Se[54],ke([1,0,14,15,2,6,26,4,30,39,16,5,12,34,36,11,10,24]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class d extends Error{constructor(g,s){super(g),this.code=s}}e.$Hq=d,e.$Iq=(0,v.$Gi)("IExtensionsProfileScannerService");let b=class extends E.$Xc{constructor(g,s,c,u,D,P){super(),this.j=g,this.m=s,this.n=c,this.r=u,this.s=D,this.t=P,this.b=this.B(new I.$ne),this.onAddExtensions=this.b.event,this.c=this.B(new I.$ne),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.$ne),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.$ne),this.onDidRemoveExtensions=this.g.event,this.h=new R.$Dc}scanProfileExtensions(g,s){return this.u(g,void 0,s)}async addExtensionsToProfile(g,s,c){const u=[],D=[];try{return await this.u(s,P=>{const T=[];if(c)T.push(...P);else for(const z of P)g.some(([C])=>(0,o.$Lp)(C.identifier,z.identifier)&&C.manifest.version!==z.version)?u.push(z):T.push(z);for(const[z,C]of g){const k=T.findIndex(Y=>(0,o.$Lp)(Y.identifier,z.identifier)&&Y.version===z.manifest.version),q={identifier:z.identifier,version:z.manifest.version,location:z.location,metadata:C};k===-1?(D.push(q),T.push(q)):T.splice(k,1,q)}return D.length&&this.b.fire({extensions:D,profileLocation:s}),u.length&&this.f.fire({extensions:u,profileLocation:s}),T}),D.length&&this.c.fire({extensions:D,profileLocation:s}),u.length&&this.g.fire({extensions:u,profileLocation:s}),D}catch(P){throw D.length&&this.c.fire({extensions:D,error:P,profileLocation:s}),u.length&&this.g.fire({extensions:u,error:P,profileLocation:s}),P}}async updateMetadata(g,s){const c=[];return await this.u(s,u=>{const D=[];for(const P of u){const T=g.find(([z])=>(0,o.$Lp)(z.identifier,P.identifier)&&z.manifest.version===P.version);T&&(P.metadata={...P.metadata,...T[1]},c.push(P)),D.push(P)}return D}),c}async removeExtensionFromProfile(g,s){const c=[];try{await this.u(s,u=>{const D=[];for(const P of u)(0,o.$Lp)(P.identifier,g.identifier)?c.push(P):D.push(P);return c.length&&this.f.fire({extensions:c,profileLocation:s}),D}),c.length&&this.g.fire({extensions:c,profileLocation:s})}catch(u){throw c.length&&this.g.fire({extensions:c,error:u,profileLocation:s}),u}}async u(g,s,c){return this.F(g).queue(async()=>{let u=[],D;try{const P=await this.m.readFile(g);D=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,S.$rl)(P)!==S.FileOperationResult.FILE_NOT_FOUND)throw P;if(this.r.extUri.isEqual(g,this.n.defaultProfile.extensionsResource)&&(D=await this.D()),!D&&c?.bailOutWhenFileNotFound)throw new d((0,m.$ab)(P),p.ERROR_PROFILE_NOT_FOUND)}if(D){Array.isArray(D)||this.w(g);let P=!1;for(const T of D){t(T)||this.w(g);let z;if((0,h.$gg)(T.relativeLocation)&&T.relativeLocation)z=this.z(T.relativeLocation);else if((0,h.$gg)(T.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${T.location}`);continue}else{z=A.URI.revive(T.location);const C=this.y(z);C&&(P=!0,T.relativeLocation=C)}(0,h.$ng)(T.metadata?.hasPreReleaseVersion)&&T.metadata?.preRelease&&(P=!0,T.metadata.hasPreReleaseVersion=!0),u.push({identifier:T.identifier,location:z,version:T.version,metadata:T.metadata})}P&&await this.m.writeFile(g,r.$Pe.fromString(JSON.stringify(D)))}if(s){u=s(u);const P=u.map(T=>({identifier:T.identifier,version:T.version,location:T.location.toJSON(),relativeLocation:this.y(T.location),metadata:T.metadata}));await this.m.writeFile(g,r.$Pe.fromString(JSON.stringify(P)))}return u})}w(g){const s=new d(`Invalid extensions content in ${g.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(g){return this.r.extUri.isEqual(this.r.extUri.dirname(g),this.j)?this.r.extUri.basename(g):void 0}z(g){return this.r.extUri.joinPath(this.j,g)}async D(){return this.C||(this.C=(async()=>{const g=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let c;try{c=(await this.m.readFile(g)).value.toString()}catch(D){if((0,S.$rl)(D)===S.FileOperationResult.FILE_NOT_FOUND)return;throw D}this.t.info("Migrating extensions from old default profile location",g.toString());let u;try{const D=JSON.parse(c);Array.isArray(D)&&D.every(P=>t(P))?u=D:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",D)}catch(D){this.t.error(D)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Pe.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",g.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(D){if((0,S.$rl)(D)===S.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",g.toString(),this.n.defaultProfile.extensionsResource.toString());else throw D}try{await this.m.del(g)}catch(D){(0,S.$rl)(D)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(D)}try{await this.m.del(s)}catch(D){(0,S.$rl)(D)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(D)}return u})()),this.C}F(g){let s=this.h.get(g);return s||(s=new n.$Nh,this.h.set(g,s)),s}};e.$Jq=b,e.$Jq=b=ze([Fe(1,S.$al),Fe(2,w.$Ml),Fe(3,a.$Kl),Fe(4,$.$_l),Fe(5,f.$ak)],b);function t(i){return(0,h.$ig)(i)&&(0,y.$jp)(i.identifier)&&(l(i.location)||(0,h.$gg)(i.location)&&i.location)&&((0,h.$ng)(i.relativeLocation)||(0,h.$gg)(i.relativeLocation))&&i.version&&(0,h.$gg)(i.version)}function l(i){return i?(0,h.$gg)(i.path)&&(0,h.$gg)(i.scheme):!1}});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[64],ke([1,0,18,14,21,15,10,43,196,2,13,9,3,20,63,58,11,4,210,28,39,22,74,16,5,12,29,6,49,54,34,36,245]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t,l,i,g,s,c,u,D,P,T,z,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Oq=e.$Nq=e.$Mq=e.Translations=void 0,e.$Pq=Z,E=Be(E),v=Be(v),f=Be(f),a=Be(a),h=$t(h);var k;(function(le){function K(ae,M){if(ae===M)return!0;const B=Object.keys(ae),re=new Set;for(const ce of Object.keys(M))re.add(ce);if(B.length!==re.size)return!1;for(const ce of B){if(ae[ce]!==M[ce])return!1;re.delete(ce)}return re.size===0}le.equals=K})(k||(e.Translations=k={})),e.$Mq=(0,g.$Gi)("IExtensionsScannerService");let q=class extends o.$Xc{constructor(K,ae,M,B,re,ce,pe,W,ue,_,U,O){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=ae,this.r=M,this.s=B,this.t=re,this.u=ce,this.w=pe,this.y=W,this.z=ue,this.C=_,this.D=U,this.F=O,this.g=this.B(new u.$ne),this.onDidChangeCache=this.g.event,this.h=(0,w.$hh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ne,this.s,this.h)),this.m=this.B(this.F.createInstance(ne,this.s,this.h)),this.n=this.B(this.F.createInstance(J,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,b.$Wp)(this.w,this.y)),this.G}async scanAllExtensions(K,ae,M){const[B,re]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(ae)]),ce=M?await this.scanExtensionsUnderDevelopment(K,[...B,...re]):[];return this.L(B,re,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const ae=[];ae.push(this.M(!!K.useCache,K.language)),ae.push(this.N(K.language,!!K.checkControlFile));const[M,B]=await Promise.all(ae);return this.J([...M,...B],t.ExtensionType.System,K,!1)}async scanUserExtensions(K){const ae=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ae);const M=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(ae,!!K.profileLocation,t.ExtensionType.User,!K.includeUninstalled,K.language,!0,M,K.productVersion??this.R()),re=K.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let ce;try{ce=await re.scanExtensions(B)}catch(pe){if(pe instanceof P.$Hq&&pe.code===P.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ce=await re.scanExtensions(B);else throw pe}return ce=await this.J(ce,t.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",ce.length),ce}async scanExtensionsUnderDevelopment(K,ae){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===S.Schemas.file).map(async B=>{const re=await this.P(B,!1,t.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(re)).map(pe=>(pe.type=ae.find(W=>(0,b.$Lp)(W.identifier,pe.identifier))?.type??pe.type,this.n.validate(pe,re)))}))).flat();return this.J(M,"development",K,!0)}return[]}async scanExistingExtension(K,ae,M){const B=await this.P(K,!1,ae,!0,M.language,!0,void 0,M.productVersion??this.R()),re=await this.n.scanExtension(B);return!re||!M.includeInvalid&&!re.isValid?null:re}async scanOneOrMultipleExtensions(K,ae,M){const B=await this.P(K,!1,ae,!0,M.language,!0,void 0,M.productVersion??this.R()),re=await this.n.scanOneOrMultipleExtensions(B);return this.J(re,ae,M,!0)}async scanMultipleExtensions(K,ae,M){const B=[];return await Promise.all(K.map(async re=>{const ce=await this.scanOneOrMultipleExtensions(re,ae,M);B.push(...ce)})),this.J(B,ae,M,!0)}async scanMetadata(K){const ae=(0,w.$hh)(K,"package.json"),M=(await this.w.readFile(ae)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(K,ae){const M=(0,w.$hh)(K,"package.json"),B=(await this.w.readFile(M)).value.toString(),re=JSON.parse(B);ae.isMachineScoped===!1&&delete ae.isMachineScoped,ae.isBuiltin===!1&&delete ae.isBuiltin,re.__metadata={...re.__metadata,...ae},await this.w.writeFile((0,w.$hh)(K,"package.json"),I.$Pe.fromString(JSON.stringify(re,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof P.$Hq&&K.code===P.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(ae=>[ae,ae.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,I.$Pe.fromString(JSON.stringify([])))}catch(ae){(0,i.$rl)(ae)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.$ab)(ae))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,ae,M,B){return M.includeAllVersions||(K=this.L(ae===t.ExtensionType.System?K:void 0,ae===t.ExtensionType.User?K:void 0,ae==="development"?K:void 0,await this.getTargetPlatform(),B)),M.includeInvalid||(K=K.filter(re=>re.isValid)),K.sort((re,ce)=>{const pe=v.$qc(re.location.fsPath),W=v.$qc(ce.location.fsPath);return pe<W?-1:pe>W?1:0})}L(K,ae,M,B,re){const ce=(W,ue,_)=>{if(W.isValid&&!ue.isValid)return!1;if(W.isValid===ue.isValid){if(re&&a.gt(W.manifest.version,ue.manifest.version))return this.y.debug(`Skipping extension ${ue.location.path} with lower version ${ue.manifest.version} in favour of ${W.location.path} with version ${W.manifest.version}`),!1;if(a.eq(W.manifest.version,ue.manifest.version)){if(W.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${ue.location.path} in favour of system extension ${W.location.path} with same version`),!1;if(W.targetPlatform===B)return this.y.debug(`Skipping extension ${ue.location.path} from different target platform ${ue.targetPlatform}`),!1}}return _?this.y.warn(`Overwriting user extension ${W.location.path} with ${ue.location.path}.`):this.y.debug(`Overwriting user extension ${W.location.path} with ${ue.location.path}.`),!0},pe=new t.$un;return K?.forEach(W=>{const ue=pe.get(W.identifier.id);(!ue||ce(ue,W,!1))&&pe.set(W.identifier.id,W)}),ae?.forEach(W=>{const ue=pe.get(W.identifier.id);if(!ue&&K&&W.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${W.location.path}.`);return}(!ue||ce(ue,W,!1))&&pe.set(W.identifier.id,W)}),M?.forEach(W=>{const ue=pe.get(W.identifier.id);(!ue||ce(ue,W,!0))&&pe.set(W.identifier.id,W),pe.set(W.identifier.id,W)}),[...pe.values()]}async M(K,ae){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,ae,!0,void 0,this.R()),re=await(K&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",re.length),re}async N(K,ae){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const B=ae?await this.O():{},re=[],ce=$.URI.file(v.$kc(v.$mc(S.$1g.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const W of M){const ue=B[W.name]||"marketplace";switch(ue){case"disabled":break;case"marketplace":re.push((0,w.$hh)(ce,W.name));break;default:re.push($.URI.file(ue));break}}const pe=await Promise.all(re.map(async W=>this.n.scanExtension(await this.P(W,!1,t.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",pe.length),(0,n.$Kb)(pe)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,ae,M,B,re,ce,pe,W){const ue=await this.f(re??f.$q),_=await this.Q(K),U=ae&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=U?await this.Q(U):void 0;return new Y(K,_,U,O,ae,pe,M,B,ce,W.version,W.date,this.C.commit,!this.z.isBuilt,re,ue)}async Q(K){try{const ae=await this.w.stat(K);if(typeof ae.mtime=="number")return ae.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Nq=q,e.$Nq=q=ze([Fe(4,T.$Ml),Fe(5,P.$Iq),Fe(6,i.$al),Fe(7,s.$ak),Fe(8,d.$Ni),Fe(9,c.$tk),Fe(10,z.$Kl),Fe(11,g.$Fi)],q);class Y{constructor(K,ae,M,B,re,ce,pe,W,ue,_,U,O,te,V,j){this.location=K,this.mtime=ae,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=B,this.profile=re,this.profileScanOptions=ce,this.type=pe,this.excludeObsolete=W,this.validate=ue,this.productVersion=_,this.productDate=U,this.productCommit=O,this.devMode=te,this.language=V,this.translations=j}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,ae){return(0,w.$ah)(K.location,ae.location)&&K.mtime===ae.mtime&&(0,w.$ah)(K.applicationExtensionslocation,ae.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===ae.applicationExtensionslocationMtime&&K.profile===ae.profile&&E.$jo(K.profileScanOptions,ae.profileScanOptions)&&K.type===ae.type&&K.excludeObsolete===ae.excludeObsolete&&K.validate===ae.validate&&K.productVersion===ae.productVersion&&K.productDate===ae.productDate&&K.productCommit===ae.productCommit&&K.devMode===ae.devMode&&K.language===ae.language&&k.equals(K.translations,ae.translations)}}e.$Oq=Y;let J=class extends o.$Xc{constructor(K,ae,M,B,re,ce){super(),this.g=K,this.h=ae,this.j=M,this.m=B,this.n=ce,this.f=re.extensionsEnabledWithApiProposalVersion?.map(pe=>pe.toLowerCase())??[]}async scanExtensions(K){const ae=K.profile?await this.s(K):await this.r(K);let M={};if(K.excludeObsolete&&K.type===t.ExtensionType.User)try{const B=(await this.m.readFile(this.g)).value.toString();M=JSON.parse(B)}catch{}return(0,m.$tg)(M)?ae:ae.filter(B=>!M[b.$Mp.create(B).toString()])}async r(K){const ae=await this.m.resolve(K.location);if(!ae.children?.length)return[];const M=await Promise.all(ae.children.map(async B=>{if(!B.isDirectory||K.type===t.ExtensionType.User&&(0,w.$eh)(B.resource).indexOf(".")===0)return null;const re=new Y(B.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(re)}));return(0,n.$Kb)(M).sort((B,re)=>B.location.path<re.location.path?-1:1)}async s(K){let ae=await this.t(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.j.extUri.isEqual(K.location,K.applicationExtensionslocation)){ae=ae.filter(B=>!B.metadata?.isApplicationScoped);const M=await this.t(K.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,K);ae.push(...M)}return ae}async t(K,ae,M){const B=await this.h.scanProfileExtensions(K,M.profileScanOptions);if(!B.length)return[];const re=await Promise.all(B.map(async ce=>{if(ae(ce)){const pe=new Y(ce.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(pe,ce.metadata)}return null}));return(0,n.$Kb)(re)}async scanOneOrMultipleExtensions(K){try{if(await this.m.exists((0,w.$hh)(K.location,"package.json"))){const ae=await this.scanExtension(K);return ae?[ae]:[]}else return await this.scanExtensions(K)}catch(ae){return this.n.error(`Error scanning extensions at ${K.location.path}:`,(0,R.$ab)(ae)),[]}}async scanExtension(K,ae){try{let M=await this.u(K.location);if(M){M.publisher||(M.publisher=t.$on),ae=ae??M.__metadata,delete M.__metadata;const B=(0,b.$Qp)(M.publisher,M.name),re=ae?.id?{id:B,uuid:ae.id}:{id:B},ce=ae?.isSystem?t.ExtensionType.System:K.type,pe=ce===t.ExtensionType.System||!!ae?.isBuiltin;M=await this.w(K.location,M,Y.createNlsConfiguration(K));let W={type:ce,identifier:re,manifest:M,location:K.location,isBuiltin:pe,targetPlatform:ae?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:ae?.publisherDisplayName,metadata:ae,isValid:!0,validations:[]};return K.validate&&(W=this.validate(W,K)),M.enabledApiProposals&&this.f.includes(B.toLowerCase())&&(M.enabledApiProposals=(0,t.$An)([...M.enabledApiProposals])),W}}catch(M){K.type!==t.ExtensionType.System&&this.n.error(M)}return null}validate(K,ae){let M=!0;const B=this.f.includes(K.identifier.id.toLowerCase()),re=(0,l.$3p)(ae.productVersion,ae.productDate,ae.location,K.manifest,K.isBuiltin,B);for(const[ce,pe]of re)ce===h.default.Error&&(M=!1,this.n.error(this.D(ae.location,pe)));return K.isValid=M,K.validations=re,K}async u(K){const ae=(0,w.$hh)(K,"package.json");let M;try{M=(await this.m.readFile(ae)).value.toString()}catch(re){return(0,i.$rl)(re)!==i.FileOperationResult.FILE_NOT_FOUND&&this.n.error(this.D(K,(0,p.localize)(0,null,ae.path,re.message))),null}let B;try{B=JSON.parse(M)}catch{const ce=[];(0,A.$Zn)(M,ce);for(const pe of ce)this.n.error(this.D(K,(0,p.localize)(1,null,ae.path,pe.offset,pe.length,(0,y.$Kq)(pe.error))));return null}return(0,A.$8n)(B)!=="object"?(this.n.error(this.D(K,(0,p.localize)(2,null,ae.path))),null):B}async w(K,ae,M){const B=await this.y(K,ae,M);if(B)try{const re=[],ce=await this.z(B.default,re);if(re.length>0)return re.forEach(W=>{this.n.error(this.D(K,(0,p.localize)(3,null,B.default?.path,(0,y.$Kq)(W.error))))}),ae;if((0,A.$8n)(B)!=="object")return this.n.error(this.D(K,(0,p.localize)(4,null,B.default?.path))),ae;const pe=B.values||Object.create(null);return(0,C.$Lq)(this.n,ae,pe,ce)}catch{}return ae}async y(K,ae,M){const B=(0,w.$hh)(K,"package.nls.json"),re=(ue,_)=>{_.forEach(U=>{this.n.error(this.D(K,(0,p.localize)(5,null,ue?.path,(0,y.$Kq)(U.error))))})},ce=ue=>{this.n.error(this.D(K,(0,p.localize)(6,null,ue?.path)))},pe=`${ae.publisher}.${ae.name}`,W=M.translations[pe];if(W)try{const ue=$.URI.file(W),_=(await this.m.readFile(ue)).value.toString(),U=[],O=(0,A.$Zn)(_,U);return U.length>0?(re(ue,U),{values:void 0,default:B}):(0,A.$8n)(O)!=="object"?(ce(ue),{values:void 0,default:B}):{values:O.contents?O.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.m.exists(B))return;let _;try{_=await this.C(K,M)}catch{return}if(!_.localized)return{values:void 0,default:_.original};try{const U=(await this.m.readFile(_.localized)).value.toString(),O=[],te=(0,A.$Zn)(U,O);return O.length>0?(re(_.localized,O),{values:void 0,default:_.original}):(0,A.$8n)(te)!=="object"?(ce(_.localized),{values:void 0,default:_.original}):{values:te,default:_.original}}catch{return{values:void 0,default:_.original}}}}async z(K,ae){if(K)try{const M=(await this.m.readFile(K)).value.toString();return(0,A.$Zn)(M,ae)}catch{}}C(K,ae){return new Promise((M,B)=>{const re=ce=>{const pe=(0,w.$hh)(K,`package.nls.${ce}.json`);this.m.exists(pe).then(W=>{W&&M({localized:pe,original:(0,w.$hh)(K,"package.nls.json")});const ue=ce.lastIndexOf("-");ue===-1?M({localized:(0,w.$hh)(K,"package.nls.json"),original:null}):(ce=ce.substring(0,ue),re(ce))})};if(ae.devMode||ae.pseudo||!ae.language)return M({localized:(0,w.$hh)(K,"package.nls.json"),original:null});re(ae.language)})}D(K,ae){return`[${K.path}]: ${ae}`}};J=ze([Fe(1,P.$Iq),Fe(2,z.$Kl),Fe(3,i.$al),Fe(4,c.$tk),Fe(5,s.$ak)],J);let ne=class extends J{constructor(K,ae,M,B,re,ce,pe,W){super(ae,B,re,ce,pe,W),this.I=K,this.J=M,this.G=this.B(new r.$Eh(3e3)),this.H=this.B(new u.$ne),this.onDidChangeCache=this.H.event}async scanExtensions(K){const ae=this.O(K),M=await this.L(ae);if(this.F=K,M&&M.input&&Y.equals(M.input,this.F))return this.n.debug("Using cached extensions scan result",K.type===t.ExtensionType.System?"system":"user",K.location.toString()),this.G.trigger(()=>this.N()),M.result.map(re=>(re.location=$.URI.revive(re.location),re));const B=await super.scanExtensions(K);return await this.M(ae,{input:K,result:B}),B}async L(K){try{const ae=await this.m.readFile(K),M=JSON.parse(ae.value.toString());return{result:M.result,input:(0,D.$di)(M.input)}}catch(ae){this.n.debug("Error while reading the extension cache file:",K.path,(0,R.$ab)(ae))}return null}async M(K,ae){try{await this.m.writeFile(K,I.$Pe.fromString(JSON.stringify(ae)))}catch(M){this.n.debug("Error while writing the extension cache file:",K.path,(0,R.$ab)(M))}}async N(){if(!this.F)return;const K=this.O(this.F),ae=await this.L(K);if(!ae)return;const M=ae.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.F)));if(!E.$jo(B,M))try{this.n.info("Invalidating Cache",M,B),await this.m.del(K),this.H.fire()}catch(re){this.n.error(re)}}O(K){const ae=this.P(K);return this.j.extUri.joinPath(ae.cacheHome,K.type===t.ExtensionType.System?t.$nn:t.$mn)}P(K){return K.type===t.ExtensionType.System?this.J.defaultProfile:K.profile?this.j.extUri.isEqual(K.location,this.I.extensionsResource)?this.I:this.J.profiles.find(ae=>this.j.extUri.isEqual(K.location,ae.extensionsResource))??this.I:this.J.defaultProfile}};ne=ze([Fe(2,T.$Ml),Fe(3,P.$Iq),Fe(4,z.$Kl),Fe(5,i.$al),Fe(6,c.$tk),Fe(7,s.$ak)],ne);function Z(le,K){const ae=(0,b.$Op)(le.manifest.publisher,le.manifest.name);return{id:ae,identifier:new t.$sn(ae),isBuiltin:le.type===t.ExtensionType.System,isUserBuiltin:le.type===t.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:K,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class x extends q{constructor(K,ae,M,B,re,ce,pe,W,ue,_,U,O){super(K,ae,(0,w.$hh)(M,".vscode-oss-dev","extensions","control.json"),B,re,ce,pe,W,ue,_,U,O),this.S=(async()=>{if(f.$t)try{const te=await this.w.readFile($.URI.file(f.$t));return JSON.parse(te.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Qq=x}),define(Se[289],ke([1,0,60,14,45,6,2,13,9,25,12,34]),function(se,e,n,r,E,I,R,A,y,o,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;let f=class extends R.$Xc{constructor(a,h){super(),this.b=a,this.f=h,this.a=new r.$Mh(5)}async postUninstall(a){const h=this.g(a,"uninstall");h&&(this.f.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(h.script,"uninstall",h.args,!0,a),this.f.info("Finished running post uninstall script",a.identifier.id,a.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",a.identifier.id,a.manifest.version),this.f.error(m)}}));try{await o.Promises.rm(this.m(a))}catch(m){this.f.error("Error while removing extension storage path",a.identifier.id),this.f.error(m)}}g(a,h){const m=`vscode:${h}`;if(a.location.scheme===A.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[m]=="string"){const $=a.manifest.scripts[m].split(" ");return $.length<2||$[0]!=="node"||!$[1]?(this.f.warn(a.identifier.id,a.manifest.version,`${m} should be a node script`),null):{script:(0,y.$mc)(a.location.fsPath,$[1]),args:$.slice(2)||[]}}return null}h(a,h,m,$,p){return new Promise((d,b)=>{const t=this.j(a,h,m,p);let l;const i=g=>{l&&(clearTimeout(l),l=null),g?b(g):d(void 0)};t.on("error",g=>{i((0,E.$rj)(g)||"Unknown")}),t.on("exit",(g,s)=>{i(g?`post-${h} process exited with code ${g}`:void 0)}),$&&(l=setTimeout(()=>{l=null,t.kill(),b("timed out")},5e3))})}j(a,h,m,$){const p={silent:!0,execArgv:void 0},d=(0,n.fork)(a,[`--type=extension-post-${h}`,...m],p);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const b=I.Event.fromNodeEventEmitter(d.stdout,"data"),t=I.Event.fromNodeEventEmitter(d.stderr,"data");this.B(b(g=>this.f.info($.identifier.id,$.manifest.version,`post-${h}`,g))),this.B(t(g=>this.f.error($.identifier.id,$.manifest.version,`post-${h}`,g)));const l=I.Event.any(I.Event.map(b,g=>({data:`%c${g}`,format:[""]}),this.q),I.Event.map(t,g=>({data:`%c${g}`,format:["color: red"]}),this.q));return I.Event.debounce(l,(g,s)=>g?{data:g.data+s.data,format:[...g.format,...s.format]}:{data:s.data,format:s.format},100,void 0,void 0,void 0,this.q)(g=>{console.group($.identifier.id),console.log(g.data,...g.format),console.groupEnd()}),d}m(a){return(0,y.$mc)(this.b.defaultProfile.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};e.$Uq=f,e.$Uq=f=ze([Fe(0,v.$Ml),Fe(1,S.$ak)],f)}),define(Se[139],ke([1,0,87,212,99,30]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=R,e.$Sq=A;function R(y){let o=I.ExtensionManagementErrorCode.Extract;return y instanceof n.$Aq&&(y.type==="CorruptZip"?o=I.ExtensionManagementErrorCode.CorruptZip:y.type==="Incomplete"&&(o=I.ExtensionManagementErrorCode.IncompleteZip)),(0,E.$Fq)(y,o)}async function A(y){let o;try{o=await(0,n.$Dq)(y,"extension/package.json")}catch(S){throw R(S)}try{return JSON.parse(o.toString("utf8"))}catch{throw new I.$mp((0,r.localize)(0,null),I.ExtensionManagementErrorCode.Invalid)}}}),define(Se[290],ke([1,0,14,10,2,13,20,63,11,23,25,87,27,28,99,30,39,139,95,16,12,24]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0,A=Be(A);let i=l=class extends E.$Xc{constructor(s,c,u,D,P,T,z){super(),this.h=c,this.j=u,this.m=D,this.n=P,this.r=T,this.t=z,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(s,c,u,D){await this.g;const P=await this.w(s,c);let T=!1;if(u&&this.u(s)){let z;try{z=await this.y(s)}catch(C){try{await this.delete(P)}catch(k){this.t.error(k)}throw C}try{T=await this.n.verify(s,P.fsPath,z.fsPath,D)}catch(C){if(T=C.code,T===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||T===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(P)}catch(k){this.t.error(k)}throw new h.$mp(v.$zq,h.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(z)}catch(C){this.t.error(C)}}}return{location:P,verificationStatus:T}}u(s){return s.isSigned||this.t.info(`Extension is not signed: ${s.identifier.id}`),!1}async w(s,c){try{const u=(0,R.$hh)(this.extensionsDownloadDir,this.G(s)),D=await this.C(s,"vsix",async()=>{await this.z(s,u,P=>this.j.download(s,P,c));try{await this.D(u.fsPath,"extension/package.json")}catch(P){try{await this.h.del(u)}catch(T){this.t.warn(`Error while deleting: ${u.path}`,(0,r.$ab)(T))}throw P}},2);return D>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:s.identifier.id,attempts:D}),u}catch(u){throw(0,a.$Fq)(u,h.ExtensionManagementErrorCode.Download)}}async y(s){try{const c=(0,R.$hh)(this.extensionsDownloadDir,`.${(0,o.$3g)()}`),u=await this.C(s,"sigzip",async()=>{await this.j.downloadSignatureArchive(s,c);try{await this.D(c.fsPath,".signature.p7s")}catch(D){try{await this.h.del(c)}catch(P){this.t.warn(`Error while deleting: ${c.path}`,(0,r.$ab)(P))}throw D}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:s.identifier.id,attempts:u}),c}catch(c){throw(0,a.$Fq)(c,h.ExtensionManagementErrorCode.DownloadSignature)}}async z(s,c,u){if(await this.h.exists(c))return;if(c.scheme!==I.Schemas.file){await u(c);return}const D=(0,R.$hh)(this.extensionsDownloadDir,`.${(0,o.$3g)()}`);try{await u(D)}catch(P){try{await this.h.del(D)}catch{}throw P}try{await S.Promises.rename(D.fsPath,c.fsPath,2*60*1e3)}catch(P){try{await this.h.del(D)}catch{}let T=!1;try{T=await this.h.exists(c)}catch{}if(T)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,c.path);else throw this.t.info(`Rename failed because of ${(0,r.$ab)(P)}. Deleted the file from downloaded location`,D.path),P}}async C(s,c,u,D){let P=1;for(;;)try{return await u(),P}catch(T){if(P++>D)throw T;this.t.warn(`Failed downloading ${c}. ${(0,r.$ab)(T)}. Retry again...`,s.identifier.id)}}async D(s,c){try{await(0,v.$Dq)(s,c)}catch(u){throw(0,$.$Rq)(u)}}async delete(s){await this.g,await this.h.del(s)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const c=[],u=[],D=[];for(const z of s.children)if(z.name.endsWith(l.c))D.push(z.resource);else{const C=m.$Mp.parse(z.name);C&&u.push([C,z])}const P=(0,m.$Rp)(u,([z])=>z),T=[];for(const z of P)z.sort((C,k)=>A.rcompare(C[0].version,k[0].version)),c.push(...z.slice(1).map(C=>C[1].resource)),T.push(z[0][1]);T.sort((z,C)=>z.mtime-C.mtime),c.push(...T.slice(0,Math.max(0,T.length-this.f)).map(z=>z.resource)),c.push(...D),await n.Promises.settled(c.map(z=>(this.t.trace("Deleting from cache",z.path),this.h.del(z))))}}catch(s){this.t.error(s)}}G(s){return this.f?m.$Mp.create(s).toString().toLowerCase():(0,o.$3g)()}};e.$Tq=i,i.c=".sigzip",e.$Tq=i=l=ze([Fe(0,w.$Oi),Fe(1,d.$al),Fe(2,h.$kp),Fe(3,f.$aj),Fe(4,p.$sq),Fe(5,t.$_l),Fe(6,b.$ak)],i)}),define(Se[140],ke([1,0,14,15,19,45,10,6,68,2,26,13,9,20,63,11,4,23,25,87,211,88,28,99,30,39,54,64,290,289,139,266,275,22,74,16,5,12,29,24,36,34]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t,l,i,g,s,c,u,D,P,T,z,C,k,q,Y,J,ne,Z,x,le,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=void 0,f=Be(f),a=Be(a),p=Be(p),b=Be(b),e.$Xq=(0,J.$Hi)(g.$np);const ae=".vsctmp";let M=class extends i.$Eq{constructor(W,ue,_,U,O,te,V,j,G,Q,N,H){super(W,ue,N,_,Q,H),this.eb=O,this.fb=te,this.gb=V,this.hb=j,this.ib=G,this.db=new Map,this.tb=new S.$Ec;const oe=this.B(j.createInstance(P.$Uq));this.ab=this.B(j.createInstance(B,Ee=>oe.postUninstall(Ee))),this.bb=this.B(new z.$Vq(H,G,N,this,this.F)),this.cb=this.B(j.createInstance(D.$Tq));const fe=this.B(new C.$Wq(this,this.eb,H,te,N,G,_));this.B(fe.onDidChangeExtensionsByAnotherSource(Ee=>this.sb(Ee))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Wp)(this.ib,this.F)),this.jb}async zip(W){this.F.trace("ExtensionManagementService#zip",W.identifier.id);const ue=await this.rb(W),_=await(0,d.zip)((0,w.$hh)(this.cb.extensionsDownloadDir,(0,$.$3g)()).fsPath,ue);return m.URI.file(_)}async unzip(W){return this.F.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:ue,cleanup:_}=await this.lb(W),U=f.$nc(ue.fsPath);try{return await(0,T.$Sq)(U)}finally{await _()}}getInstalled(W,ue=this.H.defaultProfile.extensionsResource,_={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(W??null,ue,_)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(W){return this.ab.scanUserExtensionAtLocation(W)}async install(W,ue={}){this.F.trace("ExtensionManagementService#install",W.toString());const{location:_,cleanup:U}=await this.lb(W);try{const O=await(0,T.$Sq)(f.$nc(_.fsPath)),te=(0,s.$Qp)(O.publisher,O.name);if(O.engines&&O.engines.vscode&&!(0,q.$5p)(O.engines.vscode,this.G.version,this.G.date))throw new Error(b.localize(0,null,te,this.G.version));const j=(await this.I([{manifest:O,extension:_,options:ue}])).find(({identifier:G})=>(0,s.$Lp)(G,{id:te}));if(j?.local)return j.local;throw j?.error?j.error:(0,i.$Fq)(new Error(`Unknown error while installing extension ${te}`))}finally{await U()}}async installFromLocation(W,ue){this.F.trace("ExtensionManagementService#installFromLocation",W.toString());const _=await this.ab.scanUserExtensionAtLocation(W);if(!_||!_.manifest.name||!_.manifest.version)throw new Error(`Cannot find a valid extension from the location ${W.toString()}`);return await this.wb([[_,{source:"resource"}]],ue),this.F.info("Successfully installed extension",_.identifier.id,ue.toString()),_}async installExtensionsFromProfile(W,ue,_){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",W,ue.toString(),_.toString());const U=(await this.getInstalled(k.ExtensionType.User,ue)).filter(O=>W.some(te=>(0,s.$Lp)(te,O.identifier)));if(U.length){const O=await Promise.all(U.map(te=>this.ab.scanMetadata(te,ue)));await this.wb(U.map((te,V)=>[te,O[V]]),_),this.F.info("Successfully installed extensions",U.map(te=>te.identifier.id),_.toString())}return U}async updateMetadata(W,ue,_){return this.F.trace("ExtensionManagementService#updateMetadata",W.identifier.id),ue.isPreReleaseVersion&&(ue.preRelease=!0,ue.hasPreReleaseVersion=!0),ue.isMachineScoped===!1&&(ue.isMachineScoped=void 0),ue.isBuiltin===!1&&(ue.isBuiltin=void 0),ue.pinned===!1&&(ue.pinned=void 0),W=await this.ab.updateMetadata(W,ue,_),this.bb.invalidate(_),this.w.fire({local:W,profileLocation:_}),W}async reinstallFromGallery(W){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",W.identifier.id),!this.z.isEnabled())throw new Error(b.localize(1,null));const ue=await this.getTargetPlatform(),[_]=await this.z.getExtensions([{...W.identifier,preRelease:W.preRelease}],{targetPlatform:ue,compatible:!0},E.CancellationToken.None);if(!_)throw new Error(b.localize(2,null));await this.ab.setUninstalled(W);try{await this.ab.removeUninstalledExtension(W)}catch(U){throw new Error(b.localize(3,null,(0,I.$rj)(U)))}return this.installFromGallery(_)}$(W,ue,_,U){return this.ab.copyExtension(W,ue,_,U)}copyExtensions(W,ue){return this.ab.copyExtensions(W,ue,{version:this.G.version,date:this.G.date})}markAsUninstalled(...W){return this.ab.setUninstalled(...W)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(W){this.F.error(W)}}async download(W,ue,_){const{location:U}=await this.cb.download(W,ue,!_);return U}async lb(W){if(W.scheme===v.Schemas.file)return{location:W,async cleanup(){}};this.F.trace("Downloading extension from",W.toString());const ue=(0,w.$hh)(this.cb.extensionsDownloadDir,(0,$.$3g)());return await this.gb.download(W,ue),this.F.info("Downloaded extension to",ue.toString()),{location:ue,cleanup:async()=>{try{await this.ib.del(ue)}catch(U){this.F.error(U)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(W,ue,_){const U=ue instanceof m.URI?new s.$Mp({id:(0,s.$Qp)(W.publisher,W.name)},W.version):s.$Mp.create(ue);return this.hb.createInstance(re,U,W,ue,_,(O,te)=>{if(ue instanceof m.URI)return this.qb(U,ue,_,te);let V=this.db.get(U.toString());return V||(this.db.set(U.toString(),V=this.pb(U,ue,O,_,te)),V.finally(()=>this.db.delete(U.toString()))),V},this.ab)}Z(W,ue){return new ce(W,ue.profileLocation,this.fb)}async pb(W,ue,_,U,O){const{verificationStatus:te,location:V}=await this.cb.download(ue,_,!U.donotVerifySignature,U.context?.[g.$dp]);try{if(O.isCancellationRequested)throw new R.$8;return await(0,T.$Sq)(V.fsPath),{local:await this.ab.extractUserExtension(W,V.fsPath,{id:ue.identifier.uuid,publisherId:ue.publisherId,publisherDisplayName:ue.publisherDisplayName,targetPlatform:ue.properties.targetPlatform,isApplicationScoped:U.isApplicationScoped,isMachineScoped:U.isMachineScoped,isBuiltin:U.isBuiltin,isPreReleaseVersion:ue.properties.isPreReleaseVersion,hasPreReleaseVersion:ue.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:U.installGivenVersion?!0:!!U.pinned,preRelease:(0,h.$mg)(U.preRelease)?U.preRelease:U.installPreReleaseVersion||ue.properties.isPreReleaseVersion,source:"gallery"},!1,O),verificationStatus:te}}catch(j){try{await this.cb.delete(V)}catch(G){this.F.warn("Error while deleting the downloaded file",V.toString(),(0,R.$ab)(G))}throw(0,i.$Fq)(j)}}async qb(W,ue,_,U){return{local:await this.ab.extractUserExtension(W,f.$nc(ue.fsPath),{isApplicationScoped:_.isApplicationScoped,isMachineScoped:_.isMachineScoped,isBuiltin:_.isBuiltin,installedTimestamp:Date.now(),pinned:_.installGivenVersion?!0:!!_.pinned,source:"vsix"},!0,U)}}async rb(W){const ue=async U=>{let O=await p.Promises.readdir(U);O=O.map(j=>f.$mc(U,j));const te=await Promise.all(O.map(j=>p.Promises.stat(j)));let V=Promise.resolve([]);return te.forEach((j,G)=>{const Q=O[G];j.isFile()&&(V=V.then(N=>[...N,Q])),j.isDirectory()&&(V=V.then(N=>ue(Q).then(H=>[...N,...H])))}),V};return(await ue(W.location.fsPath)).map(U=>({path:`extension/${f.$oc(W.location.fsPath,U)}`,localPath:U}))}async sb({added:W,removed:ue}){if(ue){const _=W&&this.D.extUri.isEqual(ue.profileLocation,W.profileLocation)?ue.extensions.filter(U=>W.extensions.every(O=>!(0,s.$Lp)(O,U))):ue.extensions;for(const U of _)this.F.info("Extensions removed from another source",U.id,ue.profileLocation.toString()),this.u.fire({identifier:U,profileLocation:ue.profileLocation})}if(W){const U=(await this.getInstalled(k.ExtensionType.User,W.profileLocation)).filter(O=>W.extensions.some(te=>(0,s.$Lp)(te,O.identifier)));this.s.fire(U.map(O=>(this.F.info("Extensions added from another source",O.identifier.id,W.profileLocation.toString()),{identifier:O.identifier,local:O,profileLocation:W.profileLocation,operation:g.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(ue=>this.tb.add(ue)));const W=await this.ib.resolve(this.eb.userExtensionsLocation);for(const ue of W.children??[])ue.isDirectory&&this.tb.add(ue.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(ue=>this.vb(ue)))}async vb(W){if(!W.affects(this.eb.userExtensionsLocation,Y.FileChangeType.ADDED))return;const ue=[];for(const _ of W.rawAdded){if(this.tb.has(_)||!this.D.extUri.isEqual(this.D.extUri.dirname(_),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(_,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(_).startsWith(".")||!(await this.ib.stat(_)).isDirectory)continue;const U=await this.ab.scanUserExtensionAtLocation(_);U&&U.installedTimestamp===void 0&&(this.tb.add(_),ue.push(U))}ue.length&&(await this.wb(ue.map(_=>[_,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",ue.map(_=>_.identifier.id)))}async wb(W,ue){const _=W.map(U=>U[0]);await this.xb(_),await this.fb.addExtensionsToProfile(W,ue),this.s.fire(_.map(U=>({local:U,identifier:U.identifier,operation:g.InstallOperation.None,profileLocation:ue})))}async xb(W){const ue=await this.ab.getUninstalledExtensions();for(const _ of W){const U=s.$Mp.create(_);ue[U.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",U.id),await this.ab.setInstalled(U),this.F.info("Removed the extension from uninstalled list:",U.id))}}};e.$Yq=M,e.$Yq=M=ze([Fe(0,g.$kp),Fe(1,x.$_l),Fe(2,ne.$ak),Fe(3,l.$Oi),Fe(4,u.$Mq),Fe(5,c.$Iq),Fe(6,t.$1o),Fe(7,J.$Fi),Fe(8,Y.$al),Fe(9,Z.$tk),Fe(10,le.$Kl),Fe(11,K.$Ml)],M);let B=class extends o.$Xc{constructor(W,ue,_,U,O,te,V){super(),this.n=W,this.s=ue,this.t=_,this.u=U,this.w=O,this.y=te,this.z=V,this.h=this.B(new A.$ne),this.onExtract=this.h.event,this.j=new S.$Dc,this.m=new S.$Dc,this.c=(0,w.$hh)(this.t.userExtensionsLocation,".obsolete"),this.g=new n.$Nh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(W,ue,_){try{const U={includeInvalid:!0,profileLocation:ue,productVersion:_};let O=[];if(W===null||W===k.ExtensionType.System){let te=this.j.get(ue);te||(te=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},U,!1).finally(()=>this.j.delete(ue)),this.j.set(ue,te)),O.push(...await te)}else if(W===k.ExtensionType.User){let te=this.m.get(ue);te||(te=this.t.scanUserExtensions(U).finally(()=>this.m.delete(ue)),this.m.set(ue,te)),O.push(...await te)}return O=W!==null?O.filter(te=>te.type===W):O,await Promise.all(O.map(te=>this.H(te)))}catch(U){throw(0,i.$Fq)(U,g.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(W){try{const ue=await this.t.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return await Promise.all(ue.map(_=>this.H(_)))}catch(ue){throw(0,i.$Fq)(ue,g.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(W){try{const ue=await this.t.scanExistingExtension(W,k.ExtensionType.User,{includeInvalid:!0});if(ue)return await this.H(ue)}catch(ue){this.z.error(ue)}return null}async extractUserExtension(W,ue,_,U,O){const te=W.toString(),V=m.URI.file(f.$mc(this.t.userExtensionsLocation.fsPath,`.${(0,$.$3g)()}`)),j=m.URI.file(f.$mc(this.t.userExtensionsLocation.fsPath,te));let G=await this.s.exists(j);if(G&&U){try{await this.D(W.id,j,"removeExisting")}catch{throw new g.$mp(b.localize(4,null,j.fsPath,W.id),g.ExtensionManagementErrorCode.Delete)}G=!1}if(G)try{await this.t.updateMetadata(j,_)}catch(Q){throw this.y.publicLog2("extension:extract",{extensionId:W.id,code:`${(0,Y.$rl)(Q)}`}),(0,i.$Fq)(Q,g.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(O.isCancellationRequested)throw new R.$8;try{this.z.trace(`Started extracting the extension from ${ue} to ${j.fsPath}`),await(0,d.$Cq)(ue,V.fsPath,{sourcePath:"extension",overwrite:!0},O),this.z.info(`Extracted extension to ${j}:`,W.id)}catch(Q){throw(0,T.$Rq)(Q)}try{await this.t.updateMetadata(V,_)}catch(Q){throw this.y.publicLog2("extension:extract",{extensionId:W.id,code:`${(0,Y.$rl)(Q)}`}),(0,i.$Fq)(Q,g.ExtensionManagementErrorCode.UpdateMetadata)}if(O.isCancellationRequested)throw new R.$8;try{this.z.trace(`Started renaming the extension from ${V.fsPath} to ${j.fsPath}`),await this.G(V.fsPath,j.fsPath),this.z.info("Renamed to",j.fsPath)}catch(Q){if(Q.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);try{await this.s.del(V,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,R.$ab)(Q)}. Deleted from extracted location`,V),Q}this.h.fire(j)}catch(Q){try{await this.s.del(V,{recursive:!0})}catch{}throw Q}return this.scanLocalExtension(j,k.ExtensionType.User)}async scanMetadata(W,ue){return ue?(await this.C(W,ue))?.metadata:this.t.scanMetadata(W.location)}async C(W,ue){return(await this.u.scanProfileExtensions(ue)).find(U=>(0,s.$Lp)(U.identifier,W.identifier))}async updateMetadata(W,ue,_){try{_?await this.u.updateMetadata([[W,ue]],_):await this.t.updateMetadata(W.location,ue)}catch(U){throw this.y.publicLog2("extension:extract",{extensionId:W.identifier.id,code:`${(0,Y.$rl)(U)}`}),(0,i.$Fq)(U,g.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(W.location,W.type,_)}async getUninstalledExtensions(){try{return await this.F()}catch(W){throw(0,i.$Fq)(W,g.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...W){const ue=W.map(_=>s.$Mp.create(_));await this.F(_=>ue.forEach(U=>{_[U.toString()]=!0,this.z.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(W){try{await this.F(ue=>delete ue[W.toString()])}catch(ue){throw(0,i.$Fq)(ue,g.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(W,ue){if(this.w.extUri.isEqualOrParent(W.location,this.t.userExtensionsLocation))return this.D(W.identifier.id,W.location,ue)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.F(ue=>delete ue[s.$Mp.create(W).toString()])}async copyExtension(W,ue,_,U){const O=await this.C(W,ue),te=await this.C(W,_);if(U={...O?.metadata,...U},te)if(this.w.extUri.isEqual(te.location,W.location))await this.u.updateMetadata([[W,{...te.metadata,...U}]],_);else{const V=await this.scanLocalExtension(te.location,W.type,_);await this.u.removeExtensionFromProfile(V,_),await this.u.addExtensionsToProfile([[W,{...te.metadata,...U}]],_)}else await this.u.addExtensionsToProfile([[W,U]],_);return this.scanLocalExtension(W.location,W.type,_)}async copyExtensions(W,ue,_){const U=await this.scanExtensions(k.ExtensionType.User,W,_),O=await Promise.all(U.filter(te=>!te.isApplicationScoped).map(async te=>[te,await this.scanMetadata(te,W)]));await this.u.addExtensionsToProfile(O,ue)}async D(W,ue,_){this.z.trace(`Deleting ${_} extension from disk`,W,ue.fsPath);const U=this.w.extUri.joinPath(this.w.extUri.dirname(ue),`${this.w.extUri.basename(ue)}.${(0,y.$uj)((0,$.$3g)()).toString(16)}${ae}`);await this.G(ue.fsPath,U.fsPath),await this.s.del(U,{recursive:!0}),this.z.info(`Deleted ${_} extension from disk`,W,ue.fsPath)}F(W){return this.g.queue(async()=>{let ue;try{ue=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(U){if((0,Y.$rl)(U)!==Y.FileOperationResult.FILE_NOT_FOUND)throw U}let _={};if(ue)try{_=JSON.parse(ue)}catch{}return W&&(W(_),Object.keys(_).length?await this.s.writeFile(this.c,r.$Pe.fromString(JSON.stringify(_))):await this.s.del(this.c)),_})}async G(W,ue){try{await p.Promises.rename(W,ue,2*60*1e3)}catch(_){throw(0,i.$Fq)(_,g.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(W,ue,_){try{if(_){const O=(await this.t.scanUserExtensions({profileLocation:_})).find(te=>this.w.extUri.isEqual(te.location,W));if(O)return await this.H(O)}else{const U=await this.t.scanExistingExtension(W,ue,{includeInvalid:!0});if(U)return await this.H(U)}throw new g.$mp(b.localize(5,null,W.path),g.ExtensionManagementErrorCode.ScanningExtension)}catch(U){throw(0,i.$Fq)(U,g.ExtensionManagementErrorCode.ScanningExtension)}}async H(W){const ue=await this.s.resolve(W.location);let _,U;return ue.children&&(_=ue.children.find(({name:O})=>/^readme(\.txt|\.md|)$/i.test(O))?.resource,U=ue.children.find(({name:O})=>/^changelog(\.txt|\.md|)$/i.test(O))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:_,changelogUrl:U,publisherDisplayName:W.metadata?.publisherDisplayName,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!W.metadata?.hasPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated,pinned:!!W.metadata?.pinned,isWorkspaceScoped:!1,source:W.metadata?.source??(W.identifier.uuid?"gallery":"vsix")}}async I(){const W=await this.getUninstalledExtensions();if(Object.keys(W).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(W));const ue=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const O of ue)W[s.$Mp.create(O).toString()]||_.add(O.identifier.id.toLowerCase());try{const O=(0,s.$Rp)(ue,te=>te.identifier);await n.Promises.settled(O.map(async te=>{const V=te.sort((j,G)=>a.rcompare(j.manifest.version,G.manifest.version))[0];_.has(V.identifier.id.toLowerCase())||await this.n(await this.H(V))}))}catch(O){this.z.error(O)}const U=ue.filter(O=>O.metadata&&W[s.$Mp.create(O).toString()]);await Promise.allSettled(U.map(O=>this.removeUninstalledExtension(O)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let W;try{W=await this.s.resolve(this.t.userExtensionsLocation)}catch(ue){(0,Y.$rl)(ue)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(ue);return}if(W?.children)try{await Promise.allSettled(W.children.map(async ue=>{if(!(!ue.isDirectory||!ue.name.endsWith(ae))){this.z.trace("Deleting the temporarily deleted folder",ue.resource.toString());try{await this.s.del(ue.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",ue.resource.toString())}catch(_){(0,Y.$rl)(_)!==Y.FileOperationResult.FILE_NOT_FOUND&&this.z.error(_)}}}))}catch{}}};e.$Zq=B,e.$Zq=B=ze([Fe(1,Y.$al),Fe(2,u.$Mq),Fe(3,c.$Iq),Fe(4,le.$Kl),Fe(5,x.$_l),Fe(6,ne.$ak)],B);let re=class extends i.$Gq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(W,ue,_,U,O,te,V,j,G,Q,N,H){super(),this.l=W,this.manifest=ue,this.source=_,this.options=U,this.m=O,this.n=te,this.o=V,this.p=j,this.q=G,this.s=Q,this.t=N,this.u=H,this.j=g.InstallOperation.Install,this.identifier=this.l.identifier}async h(W){const _=(await this.n.scanExtensions(k.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(V=>(0,s.$Lp)(V.identifier,this.identifier));_&&(this.j=g.InstallOperation.Update);const U={isApplicationScoped:this.options.isApplicationScoped||_?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===k.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??_?.pinned,source:this.source instanceof m.URI?"vsix":"gallery"};let O;if(this.source instanceof m.URI){if(_&&this.l.equals(new s.$Mp(_.identifier,_.manifest.version)))try{await this.n.removeExtension(_,"existing")}catch{throw new Error(b.localize(6,null,this.manifest.displayName||this.manifest.name))}const V=await this.w(this.l);if(V)try{await this.n.removeExtension(V,"existing")}catch{throw new Error(b.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(U.id=this.source.identifier.uuid,U.publisherId=this.source.publisherId,U.publisherDisplayName=this.source.publisherDisplayName,U.targetPlatform=this.source.properties.targetPlatform,U.updated=!!_,U.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,U.hasPreReleaseVersion=_?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,U.preRelease=(0,h.$mg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||_?.preRelease,_&&_.type!==k.ExtensionType.System&&_.manifest.version===this.source.version)return this.n.updateMetadata(_,U,this.options.profileLocation);O=await this.w(this.l)}if(W.isCancellationRequested)throw(0,i.$Fq)(new R.$8);if(!O){const V=await this.m(this.operation,W);O=V.local,this.k=V.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(V){throw(0,i.$Fq)(V,g.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(W.isCancellationRequested)throw(0,i.$Fq)(new R.$8);try{await this.t.addExtensionsToProfile([[O,U]],this.options.profileLocation,!O.isValid)}catch(V){throw(0,i.$Fq)(V,g.ExtensionManagementErrorCode.AddToProfile)}const te=await this.n.scanLocalExtension(O.location,k.ExtensionType.User,this.options.profileLocation);if(!te)throw new g.$mp("Cannot find the installed extension",g.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof m.URI&&this.x(O,W),te}async w(W){return(await this.n.getUninstalledExtensions())[W.toString()]?(this.u.trace("Removing the extension from uninstalled list:",W.id),await this.n.setInstalled(W),this.u.info("Removed the extension from uninstalled list:",W.id),(await this.n.scanAllUserExtensions(!0)).find(U=>s.$Mp.create(U).equals(W))):void 0}async x(W,ue){try{let[_]=await this.p.getExtensions([{id:W.identifier.id,version:W.manifest.version}],ue);if(_||([_]=await this.p.getExtensions([{id:W.identifier.id}],ue)),_){const U={id:_.identifier.uuid,publisherDisplayName:_.publisherDisplayName,publisherId:_.publisherId,isPreReleaseVersion:_.properties.isPreReleaseVersion,hasPreReleaseVersion:W.hasPreReleaseVersion||_.properties.isPreReleaseVersion,preRelease:_.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(W,U,this.options.profileLocation)}}catch{}}};re=ze([Fe(6,le.$Kl),Fe(7,g.$kp),Fe(8,K.$Ml),Fe(9,u.$Mq),Fe(10,c.$Iq),Fe(11,ne.$ak)],re);class ce extends i.$Gq{constructor(W,ue,_){super(),this.extension=W,this.j=ue,this.k=_}async h(W){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Se[141],ke([1,0,12,34,36,24,54,16,28,4]),function(se,e,n,r,E,I,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pR=void 0;let S=class extends R.$Jq{constructor(f,w,a,h,m,$){super(o.URI.file(f.extensionsPath),w,a,h,m,$)}};e.$pR=S,e.$pR=S=ze([Fe(0,y.$Oi),Fe(1,A.$al),Fe(2,r.$Ml),Fe(3,E.$Kl),Fe(4,I.$_l),Fe(5,n.$ak)],S)}),define(Se[100],ke([1,0,14,6,2,44,11,184,5,34]),function(se,e,n,r,E,I,R,A,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$jq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hq=e.$gq=e.$fq=void 0,e.$iq=w,e.$kq=h,e.$mq=$,e.$fq="__$__isNewStorageMarker",e.$gq="__$__targetStorageMarker",e.$hq=(0,y.$Gi)("storageService");var S;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var v;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var f;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function w(p){const d=p.get(e.$gq);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}class a extends E.$Xc{constructor(d={flushInterval:a.a}){super(),this.m=d,this.b=this.B(new r.$qe),this.c=this.B(new r.$qe),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$ne),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,b,t){return r.Event.filter(this.b.event,l=>l.scope===d&&(b===void 0||l.key===b),t)}n(){this.j.value=(0,n.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,b){const{key:t,external:l}=b;if(t===e.$gq){switch(d){case v.APPLICATION:this.H=void 0;break;case v.PROFILE:this.F=void 0;break;case v.WORKSPACE:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:t,target:this.J(d)[t],external:l})}w(d){this.f.fire({reason:d})}get(d,b,t){return this.P(b)?.get(d,t)}getBoolean(d,b,t){return this.P(b)?.getBoolean(d,t)}getNumber(d,b,t){return this.P(b)?.getNumber(d,t)}getObject(d,b,t){return this.P(b)?.getObject(d,t)}storeAll(d,b){this.y(()=>{for(const t of d)this.store(t.key,t.value,t.scope,t.target,b)})}store(d,b,t,l,i=!1){if((0,R.$pg)(b)){this.remove(d,t,i);return}this.y(()=>{this.z(d,t,l),this.P(t)?.set(d,b,i)})}remove(d,b,t=!1){this.y(()=>{this.z(d,b,void 0),this.P(b)?.delete(d,t)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,b){const t=[],l=this.J(d);for(const i of Object.keys(l))l[i]===b&&t.push(i);return t}z(d,b,t,l=!1){const i=this.J(b);typeof t=="number"?i[d]!==t&&(i[d]=t,this.P(b)?.set(e.$gq,JSON.stringify(i),l)):typeof i[d]=="number"&&(delete i[d],this.P(b)?.set(e.$gq,JSON.stringify(i),l))}get D(){return this.C||(this.C=this.L(v.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(v.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(v.APPLICATION)),this.H}J(d){switch(d){case v.APPLICATION:return this.I;case v.PROFILE:return this.G;default:return this.D}}L(d){const b=this.P(d);return b?w(b):Object.create(null)}isNew(d){return this.getBoolean(e.$fq,d)===!0}async flush(d=S.NONE){this.f.fire({reason:d});const b=this.P(v.APPLICATION),t=this.P(v.PROFILE),l=this.P(v.WORKSPACE);switch(d){case S.NONE:await n.Promises.settled([b?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await n.Promises.settled([b?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(v.APPLICATION)?.items??new Map,b=this.P(v.PROFILE)?.items??new Map,t=this.P(v.WORKSPACE)?.items??new Map;return $(d,b,t,this.Q(v.APPLICATION)??"",this.Q(v.PROFILE)??"",this.Q(v.WORKSPACE)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,b){return this.w(S.NONE),(0,o.$Ll)(d)?this.R(d,b):this.S(d,b)}M(d,b){return!(d.id===b.id||h(b)&&h(d))}N(d,b,t){this.y(()=>{const l=new Set;for(const[i,g]of d)l.add(i),b.get(i)!==g&&this.u(t,{key:i,external:!0});for(const[i]of b.items)l.has(i)||this.u(t,{key:i,external:!0})})}}e.$jq=a,a.a=60*1e3;function h(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class m extends a{constructor(){super(),this.U=this.B(new A.$dq(new A.$eq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new A.$dq(new A.$eq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new A.$dq(new A.$eq,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(v.WORKSPACE,d))),this.B(this.W.onDidChangeStorage(d=>this.u(v.PROFILE,d))),this.B(this.U.onDidChangeStorage(d=>this.u(v.APPLICATION,d)))}P(d){switch(d){case v.APPLICATION:return this.U;case v.PROFILE:return this.W;default:return this.X}}Q(d){switch(d){case v.APPLICATION:return"inMemory (application)";case v.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$lq=m;async function $(p,d,b,t,l,i){const g=k=>{try{return JSON.parse(k)}catch{return k}},s=new Map,c=new Map;p.forEach((k,q)=>{s.set(q,k),c.set(q,g(k))});const u=new Map,D=new Map;d.forEach((k,q)=>{u.set(q,k),D.set(q,g(k))});const P=new Map,T=new Map;b.forEach((k,q)=>{P.set(q,k),T.set(q,g(k))}),console.group(t!==l?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const z=[];if(s.forEach((k,q)=>{z.push({key:q,value:k})}),console.table(z),console.groupEnd(),console.log(c),t!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const k=[];u.forEach((q,Y)=>{k.push({key:Y,value:q})}),console.table(k),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${i})`);const C=[];P.forEach((k,q)=>{C.push({key:q,value:k})}),console.table(C),console.groupEnd(),console.log(T)}}),define(Se[291],ke([1,0,15,23,100]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=I;async function I(R,A,y){let o=y&&y.get("storage.serviceMachineId",E.StorageScope.APPLICATION)||null;if(o)return o;try{const v=(await A.readFile(R.serviceMachineIdResource)).value.toString();o=(0,r.$2g)(v)?v:null}catch{o=null}if(!o){o=(0,r.$3g)();try{await A.writeFile(R.serviceMachineIdResource,n.$Pe.fromString(o))}catch{}}return y?.store("storage.serviceMachineId",o,E.StorageScope.APPLICATION,E.StorageTarget.MACHINE),o}}),define(Se[292],ke([1,0,291,24,41]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=I;async function I(R,A,y,o,S,v,f){const w={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${A.nameShort})`};if((0,E.$Dp)(A,y)&&(0,E.$Fp)(o)===r.TelemetryLevel.USAGE){const a=await(0,n.$nq)(y,S,v);w["X-Market-User-Id"]=a,w["VSCode-SessionId"]=f.machineId||a}return w}}),define(Se[142],ke([1,0,18,19,10,3,32,11,4,27,28,30,39,22,74,16,12,29,47,292,100,24,48]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0,e.$pq=W;const i=I.$i?w.TargetPlatform.WEB:(0,v.$gp)(I.$o,R.$hc),g="X-Market-Search-Activity-Id";var s;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished",V[V.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function c(...V){return String(V.reduce((j,G)=>j|G,0))}var u;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(u||(u={}));const D={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},P={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},z={pageNumber:1,pageSize:10,sortBy:v.SortBy.NoneOrRelevance,sortOrder:v.SortOrder.Default,flags:s.None,criteria:[],assetTypes:[]};class C{constructor(j=z){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,G=this.d.pageSize){return new C({...this.d,pageNumber:j,pageSize:G})}withFilter(j,...G){const Q=[...this.d.criteria,...G.length?G.map(N=>({filterType:j,value:N})):[{filterType:j}]];return new C({...this.d,criteria:Q})}withSortBy(j){return new C({...this.d,sortBy:j})}withSortOrder(j){return new C({...this.d,sortOrder:j})}withFlags(...j){return new C({...this.d,flags:j.reduce((G,Q)=>G|Q,0)})}withAssetTypes(...j){return new C({...this.d,assetTypes:j})}withSource(j){return new C({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:G,pageSize:Q,sortBy:N,sortOrder:H,flags:oe,assetTypes:fe}=this.d;return{filters:[{criteria:j,pageNumber:G,pageSize:Q,sortBy:N,sortOrder:H}],assetTypes:fe,flags:oe}}get searchText(){const j=this.d.criteria.filter(G=>G.filterType===u.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(V,j){const G=(V||[]).filter(Q=>Q.statisticName===j)[0];return G?G.value:0}function q(V){const j="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(Q=>Q.assetType.indexOf(j)===0).reduce((Q,N)=>{const H=ne(V,N.assetType);return H&&Q.push([N.assetType.substring(j.length),H]),Q},[])}function Y(V){if(V.properties){const j=V.properties.filter(N=>N.key===D.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=j.filter(N=>G.test(N.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return ne(V,D.Repository)}function J(V){return{uri:`${V.fallbackAssetUri}/${D.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${D.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function ne(V,j){return V.files.filter(Q=>Q.assetType===j)[0]?{uri:`${V.assetUri}/${j}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${j}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}:null}function Z(V,j){const G=V.properties?V.properties.filter(N=>N.key===j):[],Q=G.length>0&&G[0].value;return Q?Q.split(",").map(N=>(0,f.$Pp)(N)):[]}function x(V){const j=V.properties?V.properties.filter(G=>G.key===P.Engine):[];return j.length>0&&j[0].value||""}function le(V){const j=V.properties?V.properties.filter(G=>G.key===P.PreRelease):[];return j.length>0&&j[0].value==="true"}function K(V){const j=V.properties?V.properties.filter(Q=>Q.key===P.EnabledApiProposals):[],G=j.length>0&&j[0].value||"";return G?G.split(","):[]}function ae(V){const j=V.properties?V.properties.filter(Q=>Q.key===P.LocalizedLanguages):[],G=j.length>0&&j[0].value||"";return G?G.split(","):[]}function M(V){return V.properties?.find(j=>j.key===P.SponsorLink)?.value}function B(V){return V.properties?.find(j=>j.key===P.SupportLink)?.value}function re(V){return V.indexOf("preview")!==-1}function ce(V){return V.targetPlatform?(0,v.$fp)(V.targetPlatform):w.TargetPlatform.UNDEFINED}function pe(V){const j=(0,n.$Pb)(V.versions.map(ce)),G=!!V.tags?.includes(v.$_o),Q=j.indexOf(w.TargetPlatform.WEB);return G?Q===-1&&j.push(w.TargetPlatform.WEB):Q!==-1&&j.splice(Q,1),j}function W(V,j){for(let G=0;G<V.length;G++){const Q=V[G];if(Q.version===V[G-1]?.version){let N=G;if(ce(Q)===j)for(;N>0&&V[N-1].version===Q.version;)N--;N!==G&&(V.splice(G,1),V.splice(N,0,Q))}}return V}function ue(V,j,G){V.telemetryData={index:j,querySource:G,queryActivityId:V.queryContext?.[g]}}function _(V,j,G,Q){const N=V.versions[0],H={manifest:ne(j,D.Manifest),readme:ne(j,D.Details),changelog:ne(j,D.Changelog),license:ne(j,D.License),repository:Y(j),download:J(j),icon:ne(j,D.Icon),signature:ne(j,D.Signature),coreTranslations:q(j)};return{type:"gallery",identifier:{id:(0,f.$Qp)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:j.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,publisherDomain:V.publisher.domain?{link:V.publisher.domain,verified:!!V.publisher.isDomainVerified}:void 0,publisherSponsorLink:M(N),description:V.shortDescription??"",installCount:k(V.statistics,"install"),rating:k(V.statistics,"averagerating"),ratingCount:k(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:G,assets:H,properties:{dependencies:Z(j,P.Dependency),extensionPack:Z(j,P.ExtensionPack),engine:x(j),enabledApiProposals:K(j),localizedLanguages:ae(j),targetPlatform:ce(j),isPreReleaseVersion:le(j)},hasPreReleaseVersion:le(N),hasReleaseVersion:!0,preview:re(V.flags),isSigned:!!H.signature,queryContext:Q,supportLink:B(N)}}let U=class{constructor(j,G,Q,N,H,oe,fe,Ee){this.l=G,this.n=Q,this.o=N,this.q=H,this.u=oe,this.w=fe,this.x=Ee;const Ne=fe.extensionsGallery,de=Ne?.servicePPEUrl&&Ee.getValue("_extensionsGallery.enablePPE");this.d=de?Ne.servicePPEUrl:Ne?.serviceUrl,this.g=de?void 0:Ne?.searchUrl,this.h=Ne?.controlUrl,this.k=fe.extensionsEnabledWithApiProposalVersion?.map($e=>$e.toLowerCase())??[],this.j=(0,d.$oq)(fe.version,fe,this.o,this.x,this.u,j,this.q)}y(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,G,Q){const N=r.CancellationToken.isCancellationToken(G)?{}:G,H=r.CancellationToken.isCancellationToken(G)?G:Q,oe=[],fe=[],Ee=[],Ne=[];let de=!0;for(const Ce of j){Ce.uuid?fe.push(Ce.uuid):oe.push(Ce.id);const me=!!(Ce.version||Ce.preRelease);Ee.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:me}),Ce.version&&Ne.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),de=de&&!!Ce.hasPreRelease&&!me}if(!fe.length&&!oe.length)return[];let $e=new C().withPage(1,j.length);fe.length&&($e=$e.withFilter(u.ExtensionId,...fe)),oe.length&&($e=$e.withFilter(u.ExtensionName,...oe)),(N.queryAllVersions||de)&&($e=$e.withFlags($e.flags,s.IncludeVersions)),N.source&&($e=$e.withSource(N.source));const{extensions:Re}=await this.B($e,{targetPlatform:N.targetPlatform??i,includePreRelease:Ee,versions:Ne,compatible:!!N.compatible,productVersion:N.productVersion??{version:this.w.version,date:this.w.date}},H);return N.source&&Re.forEach((Ce,me)=>ue(Ce,me,N.source)),Re}async getCompatibleExtension(j,G,Q,N={version:this.w.version,date:this.w.date}){if((0,v.$hp)(j.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(j,G,Q))return j;const H=new C().withFlags(s.IncludeVersions).withPage(1,1).withFilter(u.ExtensionId,j.identifier.uuid),{extensions:oe}=await this.B(H,{targetPlatform:Q,compatible:!0,includePreRelease:G,productVersion:N},r.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(j,G,Q,N={version:this.w.version,date:this.w.date}){if(!(0,v.$ip)(j.properties.targetPlatform,j.allTargetPlatforms,Q)||!G&&j.properties.isPreReleaseVersion)return!1;let H=j.properties.engine;if(!H){const oe=await this.getManifest(j,r.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");H=oe.engines.vscode}return!(!(0,a.$5p)(H,N.version,N.date)||!this.z(j.identifier,j.properties.enabledApiProposals))}z(j,G){return!G||!this.k.includes(j.id.toLowerCase())?!0:(0,a.$6p)(G)}async A(j,G,Q,N,H,oe,fe={version:this.w.version,date:this.w.date}){if(!(0,v.$ip)(ce(G),H,oe)||Q!=="any"&&le(G)!==(Q==="prerelease"))return!1;if(N)try{const Ee=await this.G(j,G);if(!(0,a.$5p)(Ee,fe.version,fe.date))return!1}catch(Ee){return this.n.error(`Error while getting the engine for the version ${G.version}.`,(0,E.$ab)(Ee)),!1}return!0}async query(j,G){let Q=j.text||"";const N=j.pageSize??50;let H=new C().withPage(1,N);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,$e,Re)=>(H=H.withFilter(u.Category,Re||$e),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,$e,Re)=>(H=H.withFilter(u.Tag,Re||$e),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(u.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),H=H.withFilter(u.SearchText,Q)),H=H.withSortBy(v.SortBy.NoneOrRelevance)):j.ids?H=H.withFilter(u.ExtensionId,...j.ids):j.names?H=H.withFilter(u.ExtensionName,...j.names):H=H.withSortBy(v.SortBy.InstallCount),typeof j.sortBy=="number"&&(H=H.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(H=H.withSortOrder(j.sortOrder)),j.source&&(H=H.withSource(j.source));const oe=async(de,$e)=>{const{extensions:Re,total:Ce}=await this.B(de,{targetPlatform:i,compatible:!1,includePreRelease:!!j.includePreRelease,productVersion:j.productVersion??{version:this.w.version,date:this.w.date}},$e);return Re.forEach((me,Ie)=>ue(me,(de.pageNumber-1)*de.pageSize+Ie,j.source)),{extensions:Re,total:Ce}},{extensions:fe,total:Ee}=await oe(H,G),Ne=async(de,$e)=>{if($e.isCancellationRequested)throw new E.$8;const{extensions:Re}=await oe(H.withPage(de+1),$e);return Re};return{firstPage:fe,total:Ee,pageSize:H.pageSize,getPage:Ne}}async B(j,G,Q){const N=j.flags;j.flags&s.IncludeLatestVersionOnly&&j.flags&s.IncludeVersions&&(j=j.withFlags(j.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(j.flags&s.IncludeLatestVersionOnly)&&!(j.flags&s.IncludeVersions)&&(j=j.withFlags(j.flags,s.IncludeLatestVersionOnly)),G.versions?.length&&(j=j.withFlags(j.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),j=j.withFlags(j.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:H,total:oe,context:fe}=await this.D(j,Q);if(!(j.flags&s.IncludeLatestVersionOnly)){const $e=[];for(const Re of H){const Ce=await this.C(Re,G,fe);Ce&&$e.push(Ce)}return{extensions:$e,total:oe}}const Ne=[],de=new Map;for(let $e=0;$e<H.length;$e++){const Re=H[$e],Ce={id:(0,f.$Qp)(Re.publisher.publisherName,Re.extensionName),uuid:Re.extensionId},me=(0,A.$mg)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Ae=>(0,f.$Lp)(Ae,Ce))?.includePreRelease;if(G.compatible&&(0,v.$hp)(pe(Re),G.targetPlatform))continue;const Ie=await this.C(Re,G,fe);!Ie||Ie.properties.isPreReleaseVersion&&(!me||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==G.targetPlatform&&Ie.hasPreReleaseVersion?de.set(Re.extensionId,$e):Ne.push([$e,Ie])}if(de.size){const $e=new l.$he,Re=new C().withFlags(N&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,de.size).withFilter(u.ExtensionId,...de.keys()),{extensions:Ce}=await this.B(Re,G,Q);this.q.publicLog2("galleryService:additionalQuery",{duration:$e.elapsed(),count:de.size});for(const me of Ce){const Ie=de.get(me.identifier.uuid);Ne.push([Ie,me])}}return{extensions:Ne.sort(($e,Re)=>$e[0]-Re[0]).map(([,$e])=>$e),total:oe}}async C(j,G,Q){const N={id:(0,f.$Qp)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},H=G.versions?.find(Ne=>(0,f.$Lp)(Ne,N))?.version,oe=(0,A.$mg)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Ne=>(0,f.$Lp)(Ne,N))?.includePreRelease,fe=pe(j),Ee=W(j.versions,G.targetPlatform);if(G.compatible&&(0,v.$hp)(fe,G.targetPlatform))return null;for(let Ne=0;Ne<Ee.length;Ne++){const de=Ee[Ne];if(!(H&&de.version!==H)){if(await this.A(N.id,de,oe?"any":"release",G.compatible,fe,G.targetPlatform,G.productVersion))return G.compatible&&!this.z(N,K(de))?null:_(j,de,fe,Q);if(H&&de.version===H)return null}}return H||G.compatible?null:_(j,j.versions[0],fe)}async D(j,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,s.ExcludeNonValidated).withFilter(u.Target,"Microsoft.VisualStudio.Code").withFilter(u.ExcludeWithFlags,c(s.Unpublished));const Q=await this.j,N=JSON.stringify(j.raw),H={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)},oe=new l.$he;let fe,Ee,Ne=0;try{if(fe=await this.l.request({type:"POST",url:this.g&&j.criteria.some($e=>$e.filterType===u.SearchText)?this.g:this.y("/extensionquery"),data:N,headers:H},G),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:Ne};const de=await(0,p.$aq)(fe);if(de){const $e=de.results[0],Re=$e.extensions,Ce=$e.resultMetadata&&$e.resultMetadata.filter(me=>me.metadataType==="ResultCount")[0];return Ne=Ce&&Ce.metadataItems.filter(me=>me.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:Ne,context:{[g]:fe.res.headers.activityid}}}return{galleryExtensions:[],total:Ne}}catch(de){if((0,E.$7)(de))throw Ee=v.ExtensionGalleryErrorCode.Cancelled,de;{const $e=(0,E.$ab)(de);throw Ee=$e.startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed,new v.$lp($e,Ee)}}finally{this.q.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(N.length),duration:oe.elapsed(),success:!!fe&&(0,p.$9p)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:Ee,count:String(Ne)})}}async reportStatistic(j,G,Q,N){if(!this.isEnabled())return;const H=I.$i?this.y(`/itemName/${j}.${G}/version/${Q}/statType/${N===v.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${j}/extensions/${G}/${Q}/stats?statType=${N}`),oe=I.$i?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.j,Accept:oe};try{await this.l.request({type:"POST",url:H,headers:Ee},r.CancellationToken.None)}catch{}}async download(j,G,Q){this.n.trace("ExtensionGalleryService#download",j.identifier.id);const N=(0,f.$Tp)(j),H=new Date().getTime(),oe=Q===v.InstallOperation.Install?"install":Q===v.InstallOperation.Update?"update":"",fe=oe?{uri:`${j.assets.download.uri}${y.URI.parse(j.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${j.assets.download.fallbackUri}${y.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:j.assets.download,Ee=j.queryContext?.[g]?{[g]:j.queryContext[g]}:void 0,Ne=await this.F(j.identifier.id,fe,D.VSIX,Ee?{headers:Ee}:void 0);try{await this.u.writeFile(G,Ne.stream)}catch(de){try{await this.u.del(G)}catch($e){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,E.$ab)($e))}throw new v.$lp((0,E.$ab)(de),v.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...N,duration:new Date().getTime()-H})}async downloadSignatureArchive(j,G){if(!j.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const Q=await this.F(j.identifier.id,j.assets.signature,D.Signature);try{await this.u.writeFile(G,Q.stream)}catch(N){try{await this.u.del(G)}catch(H){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,E.$ab)(H))}throw new v.$lp((0,E.$ab)(N),v.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(j,G){if(j.assets.readme){const Q=await this.F(j.identifier.id,j.assets.readme,D.Details,{},G);return await(0,p.$_p)(Q)||""}return""}async getManifest(j,G){if(j.assets.manifest){const Q=await this.F(j.identifier.id,j.assets.manifest,D.Manifest,{},G),N=await(0,p.$_p)(Q);return N?JSON.parse(N):null}return null}async E(j,G,Q){const N=ne(G,D.Manifest);if(!N)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},oe=await this.F(j,N,D.Manifest,{headers:H});return await(0,p.$aq)(oe)}async getCoreTranslation(j,G){const Q=j.assets.coreTranslations.filter(N=>N[0]===G.toUpperCase())[0];if(Q){const N=await this.F(j.identifier.id,Q[1],Q[0]),H=await(0,p.$_p)(N);return H?JSON.parse(H):null}return null}async getChangelog(j,G){if(j.assets.changelog){const Q=await this.F(j.identifier.id,j.assets.changelog,D.Changelog,{},G);return await(0,p.$_p)(Q)||""}return""}async getAllCompatibleVersions(j,G,Q){let N=new C().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);j.uuid?N=N.withFilter(u.ExtensionId,j.uuid):N=N.withFilter(u.ExtensionName,j.id);const{galleryExtensions:H}=await this.D(N,r.CancellationToken.None);if(!H.length)return[];const oe=pe(H[0]);if((0,v.$hp)(oe,Q))return[];const fe=[];await Promise.all(H[0].versions.map(async de=>{try{await this.A(j.id,de,G?"any":"release",!0,oe,Q)&&this.z(j,K(de))&&fe.push(de)}catch{}}));const Ee=[],Ne=new Set;for(const de of W(fe,Q))Ne.has(de.version)||(Ne.add(de.version),Ee.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:le(de)}));return Ee}async F(j,G,Q,N={},H=r.CancellationToken.None){const oe=await this.j,fe={type:"GET"},Ee={...oe,...N.headers||{}};N={...N,...fe,headers:Ee};const Ne=G.uri,de=G.fallbackUri,$e={...N,url:Ne};try{const Re=await this.l.request($e,H);if(Re.res.statusCode===200)return Re;const Ce=await(0,p.$_p)(Re);throw new Error(`Expected 200, got back ${Re.res.statusCode} instead.

${Ce}`)}catch(Re){if((0,E.$7)(Re))throw Re;const Ce=(0,E.$ab)(Re);this.q.publicLog2("galleryService:cdnFallback",{extension:j,assetType:Q,message:Ce});const me={...N,url:de};return this.l.request(me,H)}}async G(j,G){let Q=x(G);if(!Q){this.q.publicLog2("galleryService:engineFallback",{extension:j,version:G.version});const N=await this.E(j,G,r.CancellationToken.None);if(!N)throw new Error("Manifest was not found");Q=N.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.l.request({type:"GET",url:this.h},r.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,p.$aq)(j),Q=[],N={},H=[],oe=[];if(G){for(const fe of G.malicious)Q.push({id:fe});if(G.migrateToPreRelease)for(const[fe,Ee]of Object.entries(G.migrateToPreRelease))(!Ee.engine||(0,a.$5p)(Ee.engine,this.w.version,this.w.date))&&(N[fe.toLowerCase()]={disallowInstall:!0,extension:{id:Ee.id,displayName:Ee.displayName,autoMigrate:{storage:!!Ee.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[fe,Ee]of Object.entries(G.deprecated))Ee&&(N[fe.toLowerCase()]=(0,A.$mg)(Ee)?{}:Ee);if(G.search)for(const fe of G.search)H.push(fe);if(Array.isArray(G.extensionsEnabledWithPreRelease))for(const fe of G.extensionsEnabledWithPreRelease)oe.push(fe.toLowerCase())}return{malicious:Q,deprecated:N,search:H,extensionsEnabledWithPreRelease:oe}}};U=ze([Fe(1,p.$7p),Fe(2,m.$ak),Fe(3,S.$Ni),Fe(4,t.$_l),Fe(5,h.$al),Fe(6,$.$tk),Fe(7,o.$aj)],U);let O=class extends U{constructor(j,G,Q,N,H,oe,fe,Ee){super(j,G,Q,N,H,oe,fe,Ee)}};e.$qq=O,e.$qq=O=ze([Fe(0,b.$hq),Fe(1,p.$7p),Fe(2,m.$ak),Fe(3,S.$Ni),Fe(4,t.$_l),Fe(5,h.$al),Fe(6,$.$tk),Fe(7,o.$aj)],O);let te=class extends U{constructor(j,G,Q,N,H,oe,fe){super(void 0,j,G,Q,N,H,oe,fe)}};e.$rq=te,e.$rq=te=ze([Fe(0,p.$7p),Fe(1,m.$ak),Fe(2,S.$Ni),Fe(3,t.$_l),Fe(4,h.$al),Fe(5,$.$tk),Fe(6,o.$aj)],te)}),define(Se[293],ke([1,0,6,2,34,59]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xR=e.$wR=void 0;class R{constructor(o,S){this.a=o,this.b=S}listen(o,S){const v=this.b(o);switch(S){case"onDidChangeProfiles":return n.Event.map(this.a.onDidChangeProfiles,f=>({all:f.all.map(w=>(0,I.$Pn)({...w},v)),added:f.added.map(w=>(0,I.$Pn)({...w},v)),removed:f.removed.map(w=>(0,I.$Pn)({...w},v)),updated:f.updated.map(w=>(0,I.$Pn)({...w},v))}))}throw new Error(`Invalid listen ${S}`)}async call(o,S,v){const f=this.b(o);switch(S){case"createProfile":{const w=await this.a.createProfile(v[0],v[1],v[2]);return(0,I.$Pn)({...w},f)}case"updateProfile":{let w=(0,E.$Nl)((0,I.$Qn)(v[0],f),this.a.profilesHome.scheme);return w=await this.a.updateProfile(w,v[1]),(0,I.$Pn)({...w},f)}case"removeProfile":{const w=(0,E.$Nl)((0,I.$Qn)(v[0],f),this.a.profilesHome.scheme);return this.a.removeProfile(w)}}throw new Error(`Invalid call ${S}`)}}e.$wR=R;class A extends r.$Xc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(o,S,v){super(),this.profilesHome=S,this.f=v,this.a=[],this.b=this.B(new n.$ne),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=o.map(f=>(0,E.$Nl)(f,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(f=>{const w=f.added.map(m=>(0,E.$Nl)(m,this.profilesHome.scheme)),a=f.removed.map(m=>(0,E.$Nl)(m,this.profilesHome.scheme)),h=f.updated.map(m=>(0,E.$Nl)(m,this.profilesHome.scheme));this.a=f.all.map(m=>(0,E.$Nl)(m,this.profilesHome.scheme)),this.b.fire({added:w,removed:a,updated:h,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(o){this.c=o}isEnabled(){return this.c}async createNamedProfile(o,S,v){const f=await this.f.call("createNamedProfile",[o,S,v]);return(0,E.$Nl)(f,this.profilesHome.scheme)}async createProfile(o,S,v,f){const w=await this.f.call("createProfile",[o,S,v,f]);return(0,E.$Nl)(w,this.profilesHome.scheme)}async createTransientProfile(o){const S=await this.f.call("createTransientProfile",[o]);return(0,E.$Nl)(S,this.profilesHome.scheme)}async setProfileForWorkspace(o,S){await this.f.call("setProfileForWorkspace",[o,S])}removeProfile(o){return this.f.call("removeProfile",[o])}async updateProfile(o,S){const v=await this.f.call("updateProfile",[o,S]);return(0,E.$Nl)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$xR=A}),define(Se[143],ke([1,0,4,28,16,12,270,36,34,11,271]),function(se,e,n,r,E,I,R,A,y,o,S){"use strict";var v,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=e.$nR=e.$mR=void 0;let w=v=class extends y.$Pl{constructor($,p,d,b,t){super(d,b,p,t),this.U=$,this.W=d}O(){return this.U.getItem(v.b,[]).map(p=>({...p,location:(0,o.$gg)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):n.URI.revive(p.location)}))}Q(){const $=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$mR=w,w.a="profileAssociationsMigration",e.$mR=w=v=ze([Fe(0,R.$hR),Fe(1,A.$Kl),Fe(2,r.$Oi),Fe(3,E.$al),Fe(4,I.$ak)],w);let a=f=class extends w{constructor($,p,d,b,t){super($,p,d,b,t),this.$=$}P($){$.length?this.$.setItem(f.b,$.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(f.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(f.c,$):this.$.removeItem(f.c)}Q(){const $="workspaceAndProfileInfo",p=this.$.getItem($,void 0);if(p){this.$.removeItem($);const b=p.reduce((t,{workspace:l,profile:i})=>(t[n.URI.revive(l).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(f.c,{workspaces:b})}const d=super.Q();return this.$.getItem(f.a,!1)||(this.R(d),this.$.setItem(f.a,!0)),d}};e.$nR=a,e.$nR=a=f=ze([Fe(0,R.$iR),Fe(1,A.$Kl),Fe(2,r.$Oi),Fe(3,E.$al),Fe(4,I.$ak)],a);let h=class extends a{constructor($,p,d,b){super(new S.$lR(S.SaveStrategy.IMMEDIATE,p,b,d),$,p,d,b)}async init(){return await this.$.init(),super.init()}};e.$oR=h,e.$oR=h=ze([Fe(0,A.$Kl),Fe(1,r.$Oi),Fe(2,E.$al),Fe(3,I.$ak)],h)}),define(Se[144],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=void 0,e.$Ym=(0,n.$Gi)("extensionHostStatusService");class r{constructor(){this.a=new Map}setExitInfo(I,R){this.a.set(I,R)}getExitInfo(I){return this.a.get(I)||null}}e.$Zm=r}),define(Se[294],ke([1,0,61,6,14]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0;function I(A){let y=0,o=0,S=0;A>=1e3&&(S=Math.floor(A/1e3),A-=S*1e3),S>=60&&(o=Math.floor(S/60),S-=o*60),o>=60&&(y=Math.floor(o/60),o-=y*60);const v=y?`${y}h`:"",f=o?`${o}m`:"",w=S?`${S}s`:"",a=A?`${A}ms`:"";return`${v}${f}${w}${a}`}class R{constructor(y,o,S,v){this.i=y,this.j=o,this.a=new r.$ne,this.onClose=this.a.event,this.b=n.ProtocolConstants.ReconnectionGraceTime,this.c=n.ProtocolConstants.ReconnectionShortGraceTime,this.d=S,this.protocol=v,this.e=!1,this.f=new E.$Th(()=>{this.k(`The reconnection grace time of ${I(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new E.$Th(()=>{this.k(`The reconnection short grace time of ${I(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${I(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(y){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${y}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${I(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const y=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),y.end(),this.a.fire(void 0)}acceptReconnection(y,o,S){this.d=y,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(o,S),this.protocol.endAcceptReconnection()}}e.$Gn=R});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[101],ke([1,0,33,13,9,179,62]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.InternalNLSConfiguration=void 0,e.$1m=S,n=Be(n),E=Be(E),I=Be(I),R=$t(R);const A=E.$mc(r.$1g.asFileUri("").fsPath,"nls.metadata.json"),y=new Map;function o(a){return new Promise(h=>n.exists(a,h))}function S(a,h){return o(A).then(m=>{if(!m||!R.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const $=`${a}||${h}`;let p=y.get($);return p||(p=I.getNLSConfiguration(R.default.commit,h,A,a,a).then(d=>(v.is(d)&&(d._languagePackSupport=!0),d.locale!=="en"&&d.locale!=="en-us"&&Object.keys(d.availableLanguages).length===0&&y.delete($),d)),y.set($,p)),p})}var v;(function(a){function h(m){const $=m;return $&&typeof $._languagePackId=="string"}a.is=h})(v||(e.InternalNLSConfiguration=v={}));const f=async a=>{try{const h=w(await n.promises.readFile(a,"utf8"));return JSON.parse(h).locale}catch(h){return h.code!=="ENOENT"&&console.warn(h),"en"}};e.$2m=f;const w=a=>{const h=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return a.replace(h,(m,$,p,d,b)=>{if(d)return"";if(b){const t=b.length;return t>2&&b[t-1]===`
`?b[t-2]==="\r"?`\r
`:`
`:""}else return m})}}),define(Se[145],ke([1,0,20,4,28,54,64,16,5,12,29,36,34,101]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bR=void 0;let a=class extends R.$Nq{constructor(m,$,p,d,b,t,l,i){super(r.URI.file(b.builtinExtensionsPath),r.URI.file(b.extensionsPath),(0,n.$hh)(b.userHome,".vscode-oss-dev","extensions","control.json"),m.defaultProfile,m,$,p,d,b,t,l,i),this.S=b}async f(m){const $=await(0,w.$1m)(m,this.S.userDataPath);if(w.InternalNLSConfiguration.is($))try{const p=await this.w.readFile(r.URI.file($._translationsConfigFile));return JSON.parse(p.value.toString())}catch{}return Object.create(null)}};e.$bR=a,e.$bR=a=ze([Fe(0,f.$Ml),Fe(1,I.$Iq),Fe(2,A.$al),Fe(3,o.$ak),Fe(4,E.$Oi),Fe(5,S.$tk),Fe(6,v.$Kl),Fe(7,y.$Fi)],a)}),define(Se[102],ke([1,0,295,33,9,23,13,25]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.ServerConnectionTokenType=void 0,e.$Kn=w,e.$Ln=a,e.$Mn=h,n=Be(n),r=Be(r),E=Be(E);const y=/^[0-9A-Za-z_-]+$/;var o;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(o||(e.ServerConnectionTokenType=o={}));class S{constructor(){this.type=o.None}validate($){return!0}}e.$Hn=S;class v{constructor($){this.value=$,this.type=o.Mandatory}validate($){return $===this.value}}e.$In=v;class f{constructor($){this.message=$}}e.$Jn=f;async function w(m,$){const p=m["without-connection-token"],d=m["connection-token"],b=m["connection-token-file"];if(p)return typeof d<"u"||typeof b<"u"?new f("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new S;if(typeof b<"u"){if(typeof d<"u")return new f("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let t;try{t=r.readFileSync(b).toString().replace(/\r?\n$/,"")}catch{return new f(`Unable to read the connection token file at '${b}'.`)}return y.test(t)?new v(t):new f(`The connection token defined in '${b} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof d<"u"?y.test(d)?new v(d):new f(`The connection token '${d} does not adhere to the characters 0-9, a-z, A-Z or -.`):new v(await $())}async function a(m){return w(m,async()=>{if(!m["user-data-dir"])return(0,I.$3g)();const p=E.$mc(m["user-data-dir"],"token");try{const t=(await A.Promises.readFile(p)).toString().replace(/\r?\n$/,"");if(y.test(t))return t}catch{}const d=(0,I.$3g)();try{await A.Promises.writeFile(p,d,{mode:384})}catch{}return d})}function h(m,$,p){if(m.validate(p.query[R.$Sg]))return!0;const d=n.parse($.headers.cookie||"");return m.validate(d[R.$Rg])}}),define(Se[55],ke([1,0,229,119,70,5,28,78]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=void 0,n=Be(n),e.$an={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},"disable-file-uploads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:n.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:n.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:n.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:n.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:n.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:n.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:n.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:n.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:n.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:n.localize(9,null)},"user-data-dir":E.$Cm["user-data-dir"],"enable-smoke-test-driver":E.$Cm["enable-smoke-test-driver"],"disable-telemetry":E.$Cm["disable-telemetry"],"disable-workspace-trust":E.$Cm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:E.$Cm.log,logsPath:E.$Cm.logsPath,"force-disable-user-env":E.$Cm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:n.localize(10,null)},"default-workspace":{type:"string",description:n.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":E.$Cm["extensions-dir"],"extensions-download-dir":E.$Cm["extensions-download-dir"],"builtin-extensions-dir":E.$Cm["builtin-extensions-dir"],"install-extension":E.$Cm["install-extension"],"install-builtin-extension":E.$Cm["install-builtin-extension"],"update-extensions":E.$Cm["update-extensions"],"uninstall-extension":E.$Cm["uninstall-extension"],"list-extensions":E.$Cm["list-extensions"],"locate-extension":E.$Cm["locate-extension"],"show-versions":E.$Cm["show-versions"],category:E.$Cm.category,force:E.$Cm.force,"do-not-sync":E.$Cm["do-not-sync"],"pre-release":E.$Cm["pre-release"],"start-server":{type:"boolean",cat:"e",description:n.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:E.$Cm.help,version:E.$Cm.version,"locate-shell-integration-path":E.$Cm["locate-shell-integration-path"],compatibility:{type:"string"},_:E.$Cm._},e.$bn=(0,I.$Hi)(R.$Ni);class y extends r.$0m{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$cn=y,ze([A.$$h],y.prototype,"userRoamingDataHome",null)}),define(Se[296],ke([1,0,338,280,297,31]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=void 0,r=Be(r),E=Be(E),I=Be(I);class R extends n.AppInsightsCore{constructor(y,o,S){super(),this.b=y,this.a={measurements:{},properties:{}};try{const v=I.cpus();this.a.measurements.cores=v.length,this.a.properties["common.cpuModel"]=v[0].model}catch{}try{this.a.properties["common.shell"]=I.userInfo().shell,this.a.properties["common.release"]=I.release(),this.a.properties["common.arch"]=I.arch()}catch{}this.a.properties["common.remoteMachineId"]=o,this.a.properties["common.isContainer"]=S}track(y){const o=y.baseData||{};o.measurements={...o.measurements||{},...this.a.measurements},o.properties={...o.properties||{},...this.a.properties};try{o.measurements.memoryFree=I.freemem(),o.measurements.memoryTotal=I.totalmem()}catch{}try{const S=(/^http:/.test(this.b)?E:r).request(this.b,{method:"POST",headers:{"Content-Type":"application/json"}});S.on("error",()=>{}),S.write(JSON.stringify(o)),S.end()}catch{}}}e.$cR=R}),define(Se[298],ke([1,0,33,25,84,93,295,96,37,66,3,12,55,9,13,23,29,102,47,19,4,15,11,101,35]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t,l,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=e.$GR=e.$FR=e.$ER=e.$DR=e.CacheControl=void 0,e.$BR=c,e.$CR=D,E=Be(E),I=Be(I),R=Be(R),A=Be(A);const s={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function c(Y,J,ne,Z){J.writeHead(ne,{"Content-Type":"text/plain"}),J.end(Z)}var u;(function(Y){Y[Y.NO_CACHING=0]="NO_CACHING",Y[Y.ETAG=1]="ETAG",Y[Y.NO_EXPIRY=2]="NO_EXPIRY"})(u||(e.CacheControl=u={}));async function D(Y,J,ne,Z,x,le){try{const K=await r.Promises.stat(Y);if(J===u.ETAG){const ae=`W/"${[K.ino,K.size,K.mtime.getTime()].join("-")}"`;if(Z.headers["if-none-match"]===ae)return x.writeHead(304),void x.end();le.Etag=ae}else J===u.NO_EXPIRY?le["Cache-Control"]="public, max-age=31536000":J===u.NO_CACHING&&(le["Cache-Control"]="no-store");le["Content-Type"]=s[(0,w.$rc)(Y)]||(0,o.$_s)(Y)||"text/plain",x.writeHead(200,le),(0,n.createReadStream)(Y).pipe(x)}catch(K){return K.code!=="ENOENT"?(ne.error(K),console.error(K.toString())):console.error(`File not found: ${Y}`),x.writeHead(404,{"Content-Type":"text/plain"}),void x.end("Not found")}}const P=(0,w.$pc)(a.$1g.asFileUri("").fsPath);let T=class{constructor(J,ne,Z,x,le,K,ae){this.f=J,this.g=ne,this.serverRootPath=Z,this.h=x,this.i=le,this.j=K,this.k=ae,this.a=this.k.extensionsGallery?.resourceUrlTemplate?b.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${Z}/static`,this.c=`${Z}/callback`,this.d="/web-extension-resource"}async handle(J,ne,Z){try{const x=Z.pathname;return x.startsWith(this.b)&&x.charCodeAt(this.b.length)===g.CharCode.Slash?this.l(J,ne,Z):x===this.g?this.o(J,ne,Z):x===this.c?this.q(ne):x.startsWith(this.d)&&x.charCodeAt(this.d.length)===g.CharCode.Slash?this.n(J,ne,Z):c(J,ne,404,"Not found.")}catch(x){return this.i.error(x),console.error(x.toString()),c(J,ne,500,"Internal Server Error.")}}async l(J,ne,Z){const x=Object.create(null),K=decodeURIComponent(Z.pathname).substring(this.b.length+1),ae=(0,w.$mc)(P,K);return(0,y.$Fg)(ae,P,!S.$e)?D(ae,this.h.isBuilt?u.NO_EXPIRY:u.ETAG,this.i,J,ne,x):c(J,ne,400,"Bad request.")}m(J){const ne=J.authority.indexOf(".");return ne!==-1?J.authority.substring(ne+1):void 0}async n(J,ne,Z){if(!this.a)return c(J,ne,500,"No extension gallery service configured.");const x=decodeURIComponent(Z.pathname),le=(0,w.$kc)(x.substring(this.d.length+1)),K=b.URI.parse(le).with({scheme:this.a.scheme,authority:le.substring(0,le.indexOf("/")),path:le.substring(le.indexOf("/")+1)});if(this.m(this.a)!==this.m(K))return c(J,ne,403,"Request Forbidden");const ae={},M=ue=>{const _=J.headers[ue];_&&((0,l.$gg)(_)||_[0])?ae[ue]=(0,l.$gg)(_)?_:_[0]:ue!==ue.toLowerCase()&&M(ue.toLowerCase())};M("X-Client-Name"),M("X-Client-Version"),M("X-Machine-Id"),M("X-Client-Commit");const B=await this.j.request({type:"GET",url:K.toString(!0),headers:ae},d.CancellationToken.None),re=B.res.statusCode||500;if(re!==200){let ue=null;try{ue=await(0,p.$_p)(B)}catch{}return c(J,ne,re,ue||`Request failed with status ${re}`)}const ce=Object.create(null),pe=ue=>{const _=B.res.headers[ue];_?ce[ue]=_:ue!==ue.toLowerCase()&&pe(ue.toLowerCase())};pe("Cache-Control"),pe("Content-Type"),ne.writeHead(200,ce);const W=await(0,t.$2e)(B.stream);return void ne.end(W.buffer)}async o(J,ne,Z){const x=Z.query[a.$Sg];if(typeof x=="string"){const H=Object.create(null);H["Set-Cookie"]=R.serialize(a.$Rg,x,{sameSite:"lax",maxAge:60*60*24*7});const oe=Object.create(null);for(const Ee in Z.query)Ee!==a.$Sg&&(oe[Ee]=Z.query[Ee]);const fe=I.format({pathname:Z.pathname,query:oe});return H.Location=fe,ne.writeHead(302,H),void ne.end()}const le=!this.h.isBuilt&&this.h.args["use-test-resolver"],K=le?"test+test":"remote";if(!K)return c(J,ne,400,"Bad request.");function ae(H){return JSON.stringify(H).replace(/"/g,"&quot;")}let M;this.h.args["enable-smoke-test-driver"]&&(M=!1);const B=H=>H&&b.URI.file(E.resolve(H)).with({scheme:a.Schemas.vscodeRemote,authority:K}),re=a.$1g.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,ce=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,h.$3g)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,pe=(0,e.$FR)((0,e.$HR)(J)),W=(0,e.$GR)((0,e.$HR)(J)),ue={codeServerVersion:this.k.codeServerVersion,rootEndpoint:pe,updateEndpoint:this.h.args["disable-update-check"]?void 0:pe+"/update/check",logoutEndpoint:this.h.args.auth&&this.h.args.auth!=="none"?pe+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??pe+"/proxy/{{port}}/",serviceWorker:{scope:W+"/",path:pe+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.k.enableTelemetry,telemetryEndpoint:this.k.telemetryEndpoint,embedderIdentifier:"server-distro",extensionsGallery:this.k.extensionsGallery};if(!this.h.isBuilt)try{const H=JSON.parse((await r.Promises.readFile((0,w.$mc)(P,"product.overrides.json"))).toString());Object.assign(ue,H)}catch{}const _={remoteAuthority:K,serverBasePath:this.g,webviewEndpoint:W+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.h.userDataPath,isEnabledFileDownloads:!this.h.args["disable-file-downloads"],isEnabledFileUploads:!this.h.args["disable-file-uploads"],isEnabledCoderGettingStarted:!this.h.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:M,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:B(this.h.args["default-folder"]),workspaceUri:B(this.h.args["default-workspace"]),productConfiguration:ue,callbackRoute:this.c},U=this.h.args.locale||await(0,i.$2m)(this.h.argvResource.fsPath),O=await(0,i.$1m)(U,this.h.userDataPath),te=this.k.extensionsGallery?.nlsBaseUrl,V={WORKBENCH_WEB_CONFIGURATION:ae(_),WORKBENCH_AUTH_SESSION:ce?ae(ce):"",WORKBENCH_WEB_BASE_URL:W+this.b,WORKBENCH_NLS_BASE_URL:W+(te?`${te}${te.endsWith("/")?"":"/"}${this.k.commit}/${this.k.version}/`:""),BASE:pe,VS_BASE:W,NLS_CONFIGURATION:ae(O)};if(le){const H=[];for(const oe of["vscode-test-resolver","github-authentication"]){const fe=JSON.parse((await r.Promises.readFile(a.$1g.asFileUri(`${a.$Vg}/${oe}/package.json`).fsPath)).toString());H.push({extensionPath:oe,packageJSON:fe})}V.WORKBENCH_BUILTIN_EXTENSIONS=ae(H)}let j;try{j=(await r.Promises.readFile(re)).toString().replace(/\{\{([^}]+)\}\}/g,(oe,fe)=>V[fe]??"undefined")}catch{return ne.writeHead(404,{"Content-Type":"text/plain"}),void ne.end("Not found")}const N={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.p(j).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==$.ServerConnectionTokenType.None&&(N["Set-Cookie"]=R.serialize(a.$Rg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),ne.writeHead(200,N),void ne.end(j)}p(J){const ne=/<script>([\s\S]+?)<\/script>/img,Z=[];let x;for(;x=ne.exec(J);){const le=A.createHash("sha256"),K=x[1].replace(/\r\n/g,`
`),ae=le.update(Buffer.from(K)).digest().toString("base64");Z.push(`'sha256-${ae}'`)}return Z}async q(J){const ne=a.$1g.asFileUri("vs/code/browser/workbench/callback.html").fsPath,Z=(await r.Promises.readFile(ne)).toString(),x=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(Z).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return J.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":x}),void J.end(Z)}};e.$DR=T,e.$DR=T=ze([Fe(3,f.$bn),Fe(4,v.$ak),Fe(5,p.$7p),Fe(6,m.$tk)],T);const z=(Y,J=!1)=>Y.replace(/\/\/+/g,"/").replace(/\/+$/,J?"/":"");e.$ER=z;const C=Y=>{const J=(Y.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$ER)("./"+(J>1?"../".repeat(J-1):""))};e.$FR=C;const k=Y=>{const J=Y.split("?",1)[0].split("/");return(0,e.$ER)("./"+J[J.length-1])};e.$GR=k;const q=Y=>Y.originalUrl||Y.url;e.$HR=q}),define(Se[299],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0,e.$fQ=(0,n.$Gi)("IExtHostInitDataService")}),define(Se[300],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.$2P=void 0,e.$2P=(0,n.$Gi)("IExtHostRpcService");class r{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$3P=r}),define(Se[75],ke([1,0,59]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=E;function r(I){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:I,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function E(I){return new n.$Nn(r(I))}}),define(Se[301],ke([1,0,3,44,4,75,59,115,273,9,102,20]),function(se,e,n,r,E,I,R,A,y,o,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0,n=Be(n),r=Be(r);class f{constructor(a,h,m,$){this.b=a,this.c=h,this.d=m,this.e=$}async call(a,h,m){switch(h){case"getEnvironmentData":{const $=m,p=(0,I.$Us)($.remoteAuthority);let d=await this.f($.profile);return d=(0,R.$Pn)(d,p),d}case"getExtensionHostExitInfo":{const $=m;return this.e.getExitInfo($.reconnectionToken)}case"getDiagnosticInfo":{const $=m,p={machineInfo:(0,y.$Ys)()},d=$.includeProcesses?(0,A.$Ws)(process.pid):Promise.resolve();let b=[];const t={};if($.folders){const l=(0,I.$Us)("");b=$.folders.map(g=>E.URI.revive(l.transformIncoming(g))).filter(g=>g.scheme==="file").map(g=>(0,y.$Xs)(g.fsPath,["node_modules",".git"]).then(s=>{t[(0,o.$qc)(g.fsPath)]=s}))}return Promise.all([d,...b]).then(([l,i])=>(p.processes=l||void 0,p.workspaceMetadata=$.folders?t:void 0,p))}}throw new Error(`IPC Command ${h} not found`)}listen(a,h,m){throw new Error("Not supported")}async f(a){a&&!this.d.profiles.some(m=>m.id===a)&&await this.d.createProfile(a,a);let h=!1;if(process.platform==="linux"){const m=process.glibcVersion;h=(m?parseInt(m.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==S.ServerConnectionTokenType.None?this.b.value:"",appRoot:E.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,v.$hh)(this.c.logsHome,`exthost${f.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:n.OS,arch:process.arch,marks:r.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(m=>({...m}))},isUnsupportedGlibc:h}}}e.$2s=f,f.a=1}),define(Se[302],ke([1,0,4,75,72,9,258]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0;class A extends R.$3s{constructor(S,v){super(new E.$sr(S),S),this.N=v,this.M=new Map,this.B(this.a)}c(S){let v=this.M.get(S.remoteAuthority);return v||(v=(0,r.$Us)(S.remoteAuthority),this.M.set(S.remoteAuthority,v)),v}f(S,v,f=!1){if(f&&v.path==="/vscode-resource"&&v.query){const w=JSON.parse(v.query).requestResourcePath;return n.URI.from({scheme:"file",path:w})}return n.URI.revive(S.transformIncoming(v))}L(S,v){return new y(S,v,this.b,this.N)}}e.$5s=A;class y extends R.$4s{constructor(S,v,f,w){super(S,v,f,w)}j(S){const v=S.args["file-watcher-polling"];if(v){const f=v.split(I.$wc),w=Number(f[0]);if(w>0)return{usePolling:f.length>1?f.slice(1):!0,pollingInterval:w}}}m(S){if(S.extensionsPath)return[I.$jc.join(S.extensionsPath,"**")]}}});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[103],ke([1,0,232,11,4,2,5,38,16,13,45,191,58]),function(se,e,n,r,E,I,R,A,y,o,S,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$fG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$8F=e.EditorInputCapabilities=e.$7F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0,e.$XF=h,e.$YF=m,e.$ZF=$,e.$1F=p,e.$2F=d,e.$3F=b,e.$4F=t,e.$5F=l,e.$6F=i,e.$9F=P,e.$0F=z,e.$$F=C,e.$_F=k,e.$aG=q,e.$bG=Y,e.$cG=J,e.$dG=ne,e.$eG=M,e.$gG=ce,e.$hG=W,e.$iG=ue,e.$jG=_,f=$t(f),e.$SF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TF={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.$UF="workbench.editor.sidebysideEditor",e.$VF="workbench.editors.textDiffEditor",e.$WF="workbench.editors.binaryResourceDiffEditor";var w;(function(U){U[U.PROGRAMMATIC=1]="PROGRAMMATIC",U[U.USER=2]="USER",U[U.EDIT=3]="EDIT",U[U.NAVIGATION=4]="NAVIGATION",U[U.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var a;(function(U){U[U.IDENTICAL=1]="IDENTICAL",U[U.SIMILAR=2]="SIMILAR",U[U.DIFFERENT=3]="DIFFERENT"})(a||(e.EditorPaneSelectionCompareResult=a={}));function h(U){const O=U;return!!O&&typeof O.getSelection=="function"&&!!O.onDidChangeSelection}function m(U){const O=U;return!!O&&typeof O.getScrollPosition=="function"&&typeof O.setScrollPosition=="function"&&!!O.onDidChangeScroll}function $(U,O,te){for(const V of te.visibleEditorPanes)if(V.group.id===O&&U.matches(V.input))return V.getViewState()}function p(U){if(P(U))return!1;const O=U;return E.URI.isUri(O?.resource)}function d(U){if(P(U))return!1;const O=U;return O?.original!==void 0&&O.modified!==void 0}function b(U){if(P(U))return!1;const O=U;return!O||O.resources&&!Array.isArray(O.resources)?!1:!!O.resources||!!O.multiDiffSource}function t(U){if(P(U)||d(U))return!1;const O=U;return O?.primary!==void 0&&O.secondary!==void 0}function l(U){if(P(U))return!1;const O=U;return O?O.resource===void 0||O.resource.scheme===o.Schemas.untitled||O.forceUntitled===!0:!1}function i(U){if(P(U))return!1;const O=U;return E.URI.isUri(O?.base?.resource)&&E.URI.isUri(O?.input1?.resource)&&E.URI.isUri(O?.input2?.resource)&&E.URI.isUri(O?.result?.resource)}var g;(function(U){U[U.SHORT=0]="SHORT",U[U.MEDIUM=1]="MEDIUM",U[U.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var s;(function(U){U[U.EXPLICIT=1]="EXPLICIT",U[U.AUTO=2]="AUTO",U[U.FOCUS_CHANGE=3]="FOCUS_CHANGE",U[U.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class c{constructor(){this.a=new Map}registerSource(O,te){let V=this.a.get(O);return V||(V={source:O,label:te},this.a.set(O,V)),V.source}getSourceLabel(O){return this.a.get(O)?.label??O}}e.$7F=new c;var u;(function(U){U[U.None=0]="None",U[U.Readonly=2]="Readonly",U[U.Untitled=4]="Untitled",U[U.Singleton=8]="Singleton",U[U.RequiresTrust=16]="RequiresTrust",U[U.CanSplitInGroup=32]="CanSplitInGroup",U[U.ForceDescription=64]="ForceDescription",U[U.CanDropIntoEditor=128]="CanDropIntoEditor",U[U.MultipleEditors=256]="MultipleEditors",U[U.Scratchpad=512]="Scratchpad"})(u||(e.EditorInputCapabilities=u={}));class D extends I.$Xc{}e.$8F=D;function P(U){return U instanceof D}function T(U){const O=U;return E.URI.isUri(O?.preferredResource)}function z(U){const O=U;return P(O?.primary)&&P(O?.secondary)}function C(U){const O=U;return P(O?.modified)&&P(O?.original)}function k(U,O,te,V,j){return _(V,[(0,v.$qj)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const G={...te,limits:{size:Number.MAX_VALUE}};U.openEditor(O,G)}}),(0,v.$qj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>j.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}function q(U){return P(U?.editor)}function Y(U){const O=U;return q(U)&&O?.group!==void 0}function J(U){const O=U;return typeof O?.groupId=="number"&&P(O.editor)}function ne(U){return typeof U?.groupId=="number"}var Z;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.REPLACE=1]="REPLACE",U[U.MOVE=2]="MOVE",U[U.UNPIN=3]="UNPIN"})(Z||(e.EditorCloseContext=Z={}));var x;(function(U){U[U.GROUP_ACTIVE=0]="GROUP_ACTIVE",U[U.GROUP_INDEX=1]="GROUP_INDEX",U[U.GROUP_LABEL=2]="GROUP_LABEL",U[U.GROUP_LOCKED=3]="GROUP_LOCKED",U[U.EDITORS_SELECTION=4]="EDITORS_SELECTION",U[U.EDITOR_OPEN=5]="EDITOR_OPEN",U[U.EDITOR_CLOSE=6]="EDITOR_CLOSE",U[U.EDITOR_MOVE=7]="EDITOR_MOVE",U[U.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",U[U.EDITOR_LABEL=9]="EDITOR_LABEL",U[U.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",U[U.EDITOR_PIN=11]="EDITOR_PIN",U[U.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",U[U.EDITOR_STICKY=13]="EDITOR_STICKY",U[U.EDITOR_DIRTY=14]="EDITOR_DIRTY",U[U.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(x||(e.GroupModelChangeKind=x={}));var le;(function(U){U[U.PRIMARY=1]="PRIMARY",U[U.SECONDARY=2]="SECONDARY",U[U.BOTH=3]="BOTH",U[U.ANY=4]="ANY"})(le||(e.SideBySideEditor=le={}));class K{getOriginalUri(O,te){if(!O)return;if(i(O))return e.$fG.getOriginalUri(O.result,te);if(te?.supportSideBySide){const{primary:j,secondary:G}=this.a(O);if(j&&G){if(te?.supportSideBySide===le.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:te.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===le.ANY)return this.getOriginalUri(j,{filterByScheme:te.filterByScheme})??this.getOriginalUri(G,{filterByScheme:te.filterByScheme});O=te.supportSideBySide===le.PRIMARY?j:G}}if(d(O)||b(O)||t(O)||i(O))return;const V=T(O)?O.preferredResource:O.resource;return!V||!te||!te.filterByScheme?V:this.b(V,te.filterByScheme)}a(O){return z(O)||t(O)?{primary:O.primary,secondary:O.secondary}:C(O)||d(O)?{primary:O.modified,secondary:O.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(O,te){if(!O)return;if(i(O))return e.$fG.getCanonicalUri(O.result,te);if(te?.supportSideBySide){const{primary:j,secondary:G}=this.a(O);if(j&&G){if(te?.supportSideBySide===le.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:te.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:te.filterByScheme})};if(te?.supportSideBySide===le.ANY)return this.getCanonicalUri(j,{filterByScheme:te.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:te.filterByScheme});O=te.supportSideBySide===le.PRIMARY?j:G}}if(d(O)||b(O)||t(O)||i(O))return;const V=O.resource;return!V||!te||!te.filterByScheme?V:this.b(V,te.filterByScheme)}b(O,te){if(Array.isArray(te)){if(te.some(V=>O.scheme===V))return O}else if(te===O.scheme)return O}}var ae;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.KEYBOARD=1]="KEYBOARD",U[U.MOUSE=2]="MOUSE"})(ae||(e.EditorCloseMethod=ae={}));function M(U,O,te,V){if(!U.isSticky(O))return!1;switch(V.preventPinnedEditorClose){case"keyboardAndMouse":return te===ae.MOUSE||te===ae.KEYBOARD;case"mouse":return te===ae.MOUSE;case"keyboard":return te===ae.KEYBOARD}return!1}e.$fG=new K;var B;(function(U){U[U.LEFT=0]="LEFT",U[U.RIGHT=1]="RIGHT"})(B||(e.CloseDirection=B={}));class re{constructor(){this.c=new Map,this.d=new Map}start(O){const te=this.a=O.get(R.$Fi);for(const[V,j]of this.c)this.e(V,j,te);this.c.clear()}e(O,te,V){const j=V.createInstance(te);this.d.set(O,j)}registerFileEditorFactory(O){if(this.b)throw new Error("Can only register one file editor factory.");this.b=O}getFileEditorFactory(){return(0,r.$rg)(this.b)}registerEditorSerializer(O,te){if(this.c.has(O)||this.d.has(O))throw new Error(`A editor serializer with type ID '${O}' was already registered.`);return this.a?this.e(O,te,this.a):this.c.set(O,te),(0,I.$Vc)(()=>{this.c.delete(O),this.d.delete(O)})}getEditorSerializer(O){return this.d.get(typeof O=="string"?O:O.typeId)}}A.$so.add(e.$SF.EditorFactory,new re);async function ce(U,O,te){return!U||!U.length?[]:await Promise.all(U.map(async V=>{const j=E.URI.revive(V.fileUri);if(!j){te.info("Cannot resolve the path because it is not valid.",V);return}if(!await O.canHandleResource(j)){te.info("Cannot resolve the path because it cannot be handled",V);return}let Q=V.exists,N=V.type;if(typeof Q!="boolean"||typeof N!="number")try{N=(await O.stat(j)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Q=!0}catch(oe){te.error(oe),Q=!1}if(!Q&&V.openOnlyIfExists){te.info("Cannot resolve the path because it does not exist",V);return}if(N===y.FileType.Directory){te.info("Cannot resolve the path because it is a directory",V);return}const H={...V.options,pinned:!0};return Q?{resource:j,options:H}:{resource:j,options:H,forceUntitled:!0}}))}var pe;(function(U){U[U.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",U[U.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function W(U){const O=U;if(!O)return!1;const te=O;if(te.modified)return W(te.modified);const V=O;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}function ue(U){return(0,S.$sj)(U)}function _(U,O,te){const V=(0,S.$tj)(U,O);return V.forceMessage=te?.forceMessage,V.forceSeverity=te?.forceSeverity,V.allowDialog=te?.allowDialog,V}}),define(Se[303],ke([1,0,233,42]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=void 0,e.$vG=new r.$Xj("chatSessionResponseVote","",{type:"string",description:(0,n.localize)(0,null)}),e.$wG=new r.$Xj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,n.localize)(1,null)}),e.$xG=new r.$Xj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,n.localize)(2,null)}),e.$yG=new r.$Xj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,n.localize)(3,null)}),e.$zG=new r.$Xj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,n.localize)(4,null)}),e.$AG=new r.$Xj("chatResponse",!1,{type:"boolean",description:(0,n.localize)(5,null)}),e.$BG=new r.$Xj("chatRequest",!1,{type:"boolean",description:(0,n.localize)(6,null)}),e.$CG=new r.$Xj("chatEditApplied",!1,{type:"boolean",description:(0,n.localize)(7,null)}),e.$DG=new r.$Xj("chatInputHasText",!1,{type:"boolean",description:(0,n.localize)(8,null)}),e.$EG=new r.$Xj("chatInputHasFocus",!1,{type:"boolean",description:(0,n.localize)(9,null)}),e.$FG=new r.$Xj("inChatInput",!1,{type:"boolean",description:(0,n.localize)(10,null)}),e.$GG=new r.$Xj("inChat",!1,{type:"boolean",description:(0,n.localize)(11,null)}),e.$HG=new r.$Xj("chatIsEnabled",!1,{type:"boolean",description:(0,n.localize)(12,null)}),e.$IG=new r.$Xj("chatCursorAtTop",!1),e.$JG=new r.$Xj("chatInputHasAgent",!1),e.$KG=new r.$Xj("chatLocation",void 0),e.$LG=new r.$Xj("quickChatHasFocus",!1,{type:"boolean",description:(0,n.localize)(13,null)})}),define(Se[304],ke([1,0,106,14,19,6,40,2,49,166,17,42,22,5,12,29,47,100,303]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.ChatAgentLocation=void 0,e.$PH=g,e.$QH=s;var b;(function(c){c.Panel="panel",c.Terminal="terminal",c.Notebook="notebook",c.Editor="editor"})(b||(e.ChatAgentLocation=b={})),function(c){function u(D){switch(D){case"panel":return c.Panel;case"terminal":return c.Terminal;case"notebook":return c.Notebook;case"editor":return c.Editor}return c.Panel}c.fromRaw=u}(b||(e.ChatAgentLocation=b={})),e.$KH=(0,w.$Gi)("chatAgentService");let t=class{constructor(u){this.f=u,this.b=new Map,this.d=new I.$ne,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=p.$HG.bindTo(this.f)}registerAgent(u,D){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const T=this,z=D.slashCommands;D={...D,get slashCommands(){return z.filter(k=>!k.when||T.f.contextMatchesRules(v.$Ej.deserialize(k.when)))}};const C={data:D};return this.b.set(u,C),(0,A.$Vc)(()=>{this.b.delete(u),this.d.fire(void 0)})}registerAgentImplementation(u,D){const P=this.b.get(u);if(!P)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(P.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return P.data.isDefault&&this.e.set(!0),P.impl=D,this.d.fire(new l(P.data,D)),(0,A.$Vc)(()=>{P.impl=void 0,this.d.fire(void 0),P.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,D){u.isDynamic=!0;const P={data:u,impl:D};return this.b.set(u.id,P),this.d.fire(new l(u,D)),(0,A.$Vc)(()=>{this.b.delete(u.id),this.d.fire(void 0)})}registerAgentCompletionProvider(u,D){return this.g.set(u,D),{dispose:()=>{this.g.delete(u)}}}async getAgentCompletionItems(u,D,P){return await this.g.get(u)?.(D,P)??[]}updateAgent(u,D){const P=this.b.get(u);if(!P?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);P.data.metadata={...P.data.metadata,...D},this.d.fire(new l(P.data,P.impl))}getDefaultAgent(u){return(0,n.$ib)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(u))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}getAgent(u){if(this.h(u))return this.b.get(u)?.data}h(u){const D=this.b.get(u);return!D?.data.when||this.f.contextMatchesRules(v.$Ej.deserialize(D.data.when))}getAgentByFullyQualifiedId(u){const D=R.Iterable.find(this.b.values(),P=>g(P.data)===u)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(u=>u.data).filter(u=>this.h(u.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).filter(u=>this.h(u.data.id)).map(u=>new l(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(D=>D.name===u)}agentHasDupeName(u){const D=this.getAgent(u);return D?this.getAgentsByName(D.name).filter(P=>P.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(u,D,P,T,z){const C=this.b.get(u);if(!C?.impl)throw new Error(`No activated agent with id "${u}"`);return await C.impl.invoke(D,P,T,z)}async getFollowups(u,D,P,T,z){const C=this.b.get(u);if(!C?.impl)throw new Error(`No activated agent with id "${u}"`);return C.impl?.provideFollowups?C.impl.provideFollowups(D,P,T,z):[]}};e.$LH=t,t.AGENT_LEADER="@",e.$LH=t=ze([Fe(0,v.$Yj)],t);class l{constructor(u,D){this.b=u,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,D,P,T){return this.d.invoke(u,D,P,T)}async provideFollowups(u,D,P,T){return this.d.provideFollowups?this.d.provideFollowups(u,D,P,T):[]}provideWelcomeMessage(u,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u,D)}provideSampleQuestions(u,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u,D)}}e.$MH=l,e.$NH=(0,w.$Gi)("chatAgentNameService");let i=d=class{constructor(u,D,P,T){if(this.g=D,this.h=P,this.i=T,this.e=(0,o.$8d)(this,Object.create(null)),this.f=!1,!u.chatParticipantRegistry)return;this.d=u.chatParticipantRegistry;const z=T.get(d.b,$.StorageScope.APPLICATION);try{this.e.set(JSON.parse(z??"{}"),void 0)}catch{T.remove(d.b,$.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(u=>this.h.warn("Failed to fetch chat participant registry",u)).then(()=>(0,r.$Hh)(5*60*1e3)).then(()=>this.j())}async k(){const u=await this.g.request({type:"GET",url:this.d},E.CancellationToken.None);if(u.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.$aq)(u);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const P=D.restrictedChatParticipants;this.e.set(P,void 0),this.i.store(d.b,JSON.stringify(P),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE)}getAgentNameRestriction(u){const D=this.l(u.name,u).get(),P=!u.fullName||this.l(u.fullName.replace(/\s/g,""),u).get();return D&&P}l(u,D){return this.e.map(T=>T[u.toLowerCase()]).map(T=>T?T.some(z=>(0,S.$Hf)(z,z.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$OH=i,i.b="chat.participantNameRegistry",e.$OH=i=d=ze([Fe(0,h.$tk),Fe(1,m.$7p),Fe(2,a.$ak),Fe(3,$.$hq)],i);function g(c){return`${c.extensionId.value}.${c.id}`}function s(c){const u="name"in c?c:{...c,name:c.id};return"extensionPublisherId"in u||(u.extensionPublisherId=u.extensionPublisher??""),"extensionDisplayName"in u||(u.extensionDisplayName=""),"extensionId"in u||(u.extensionId=new f.$sn("")),(0,y.$di)(u)}}),define(Se[305],ke([1,0,4,235,42,5]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$DK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$BK=e.MemoryRangeType=e.State=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=void 0,e.$AK=y,e.$CK=S,r=Be(r),e.$oJ="workbench.view.debug",e.$pJ="workbench.debug.variablesView",e.$qJ="workbench.debug.watchExpressionsView",e.$rJ="workbench.debug.callStackView",e.$sJ="workbench.debug.loadedScriptsView",e.$tJ="workbench.debug.breakPointsView",e.$uJ="workbench.debug.disassemblyView",e.$vJ="workbench.panel.repl",e.$wJ="workbench.panel.repl.view",e.$xJ=new E.$Xj("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.$yJ=new E.$Xj("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.$zJ=new E.$Xj("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.$AJ="debugUx",e.$BJ=new E.$Xj(e.$AJ,"default",{type:"string",description:r.localize(3,null)}),e.$CJ=new E.$Xj("hasDebugged",!1,{type:"boolean",description:r.localize(4,null)}),e.$DJ=new E.$Xj("inDebugMode",!1,{type:"boolean",description:r.localize(5,null)}),e.$EJ=new E.$Xj("inDebugRepl",!1,{type:"boolean",description:r.localize(6,null)}),e.$FJ=new E.$Xj("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(7,null)}),e.$GJ=new E.$Xj("inBreakpointWidget",!1,{type:"boolean",description:r.localize(8,null)}),e.$HJ=new E.$Xj("breakpointsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.$IJ=new E.$Xj("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(10,null)}),e.$JJ=new E.$Xj("watchExpressionsExist",!1,{type:"boolean",description:r.localize(11,null)}),e.$KJ=new E.$Xj("variablesFocused",!0,{type:"boolean",description:r.localize(12,null)}),e.$LJ=new E.$Xj("expressionSelected",!1,{type:"boolean",description:r.localize(13,null)}),e.$MJ=new E.$Xj("breakpointInputFocused",!1,{type:"boolean",description:r.localize(14,null)}),e.$NJ=new E.$Xj("callStackItemType",void 0,{type:"string",description:r.localize(15,null)}),e.$OJ=new E.$Xj("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(16,null)}),e.$PJ=new E.$Xj("callStackItemStopped",!1,{type:"boolean",description:r.localize(17,null)}),e.$QJ=new E.$Xj("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(18,null)}),e.$RJ=new E.$Xj("watchItemType",void 0,{type:"string",description:r.localize(19,null)}),e.$SJ=new E.$Xj("canViewMemory",void 0,{type:"boolean",description:r.localize(20,null)}),e.$TJ=new E.$Xj("breakpointItemType",void 0,{type:"string",description:r.localize(21,null)}),e.$UJ=new E.$Xj("breakpointItemBytes",void 0,{type:"boolean",description:r.localize(22,null)}),e.$VJ=new E.$Xj("breakpointHasModes",!1,{type:"boolean",description:r.localize(23,null)}),e.$WJ=new E.$Xj("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(24,null)}),e.$XJ=new E.$Xj("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(25,null)}),e.$YJ=new E.$Xj("loadedScriptsItemType",void 0,{type:"string",description:r.localize(26,null)}),e.$ZJ=new E.$Xj("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(27,null)}),e.$1J=new E.$Xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:r.localize(28,null)}),e.$2J=new E.$Xj("stepBackSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.$3J=new E.$Xj("restartFrameSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.$4J=new E.$Xj("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(31,null)}),e.$5J=new E.$Xj("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(32,null)}),e.$6J=new E.$Xj("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(33,null)}),e.$7J=new E.$Xj("breakpointsExist",!1,{type:"boolean",description:r.localize(34,null)}),e.$8J=new E.$Xj("debuggersAvailable",!1,{type:"boolean",description:r.localize(35,null)}),e.$9J=new E.$Xj("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(36,null)}),e.$0J=new E.$Xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(37,null)}),e.$$J=new E.$Xj("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.$_J=new E.$Xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.$aK=new E.$Xj("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.$bK=new E.$Xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.$cK=new E.$Xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(42,null)}),e.$dK=new E.$Xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(43,null)}),e.$eK=new E.$Xj("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(44,null)}),e.$fK=new E.$Xj("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(45,null)}),e.$gK=new E.$Xj("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(46,null)}),e.$hK=new E.$Xj("variableIsReadonly",!1,{type:"boolean",description:r.localize(47,null)}),e.$iK=new E.$Xj("variableValue",!1,{type:"string",description:r.localize(48,null)}),e.$jK=new E.$Xj("variableType",!1,{type:"string",description:r.localize(49,null)}),e.$kK=new E.$Xj("variableInterfaces",!1,{type:"array",description:r.localize(50,null)}),e.$lK=new E.$Xj("variableName",!1,{type:"string",description:r.localize(51,null)}),e.$mK=new E.$Xj("variableLanguage",!1,{type:"string",description:r.localize(52,null)}),e.$nK=new E.$Xj("variableExtensionId",!1,{type:"string",description:r.localize(53,null)}),e.$oK=new E.$Xj("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(54,null)}),e.$pK=new E.$Xj("multiSessionRepl",!1,{type:"boolean",description:r.localize(55,null)}),e.$qK=new E.$Xj("multiSessionDebug",!1,{type:"boolean",description:r.localize(56,null)}),e.$rK=new E.$Xj("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(57,null)}),e.$sK=new E.$Xj("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(58,null)}),e.$tK=new E.$Xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(59,null)}),e.$uK=new E.$Xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(60,null)});const R=d=>r.localize(61,null,d);e.$vK=R,e.$wK="editor.contrib.debug",e.$xK="editor.contrib.breakpoint",e.$yK="debug",e.$zK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(62,null)};var A;(function(d){d[d.Inactive=0]="Inactive",d[d.Initializing=1]="Initializing",d[d.Stopped=2]="Stopped",d[d.Running=3]="Running"})(A||(e.State=A={}));function y(d){switch(d){case A.Initializing:return"initializing";case A.Stopped:return"stopped";case A.Running:return"running";default:return"inactive"}}var o;(function(d){d[d.Valid=0]="Valid",d[d.Unreadable=1]="Unreadable",d[d.Error=2]="Error"})(o||(e.MemoryRangeType=o={})),e.$BK="vscode-debug-memory";function S(d){const b=d.presentationHint??d.source.presentationHint;return b==="deemphasize"||b==="subtle"}var v;(function(d){d[d.Variable=0]="Variable",d[d.Address=1]="Address"})(v||(e.DataBreakpointSetType=v={}));var f;(function(d){d[d.Initial=1]="Initial",d[d.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var w;(function(d){d.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$DK=(0,I.$Gi)("debugService");var a;(function(d){d[d.CONDITION=0]="CONDITION",d[d.HIT_COUNT=1]="HIT_COUNT",d[d.LOG_MESSAGE=2]="LOG_MESSAGE",d[d.TRIGGER_POINT=3]="TRIGGER_POINT"})(a||(e.BreakpointWidgetContext=a={}));var h;(function(d){d[d.Command=0]="Command",d[d.Tree=1]="Tree"})(h||(e.DebugVisualizationType=h={}));var m;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var $;(function(d){d.deserialize=b=>b,d.serialize=b=>b})($||(e.IDebugVisualizationTreeItem=$={}));var p;(function(d){d.deserialize=b=>({id:b.id,name:b.name,iconPath:b.iconPath&&{light:n.URI.revive(b.iconPath.light),dark:n.URI.revive(b.iconPath.dark)},iconClass:b.iconClass,visualization:b.visualization}),d.serialize=b=>b})(p||(e.IDebugVisualization=p={}))}),define(Se[306],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0,e.$sQ=(0,n.$Gi)("environmentVariableService")}),define(Se[146],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelRequest=e.RemoteTerminalChannelEvent=e.$OQ=void 0,e.$OQ="remoteterminal";var n;(function(E){E.OnPtyHostExitEvent="$onPtyHostExitEvent",E.OnPtyHostStartEvent="$onPtyHostStartEvent",E.OnPtyHostUnresponsiveEvent="$onPtyHostUnresponsiveEvent",E.OnPtyHostResponsiveEvent="$onPtyHostResponsiveEvent",E.OnPtyHostRequestResolveVariablesEvent="$onPtyHostRequestResolveVariablesEvent",E.OnProcessDataEvent="$onProcessDataEvent",E.OnProcessReadyEvent="$onProcessReadyEvent",E.OnProcessExitEvent="$onProcessExitEvent",E.OnProcessReplayEvent="$onProcessReplayEvent",E.OnProcessOrphanQuestion="$onProcessOrphanQuestion",E.OnExecuteCommand="$onExecuteCommand",E.OnDidRequestDetach="$onDidRequestDetach",E.OnDidChangeProperty="$onDidChangeProperty"})(n||(e.RemoteTerminalChannelEvent=n={}));var r;(function(E){E.RestartPtyHost="$restartPtyHost",E.CreateProcess="$createProcess",E.AttachToProcess="$attachToProcess",E.DetachFromProcess="$detachFromProcess",E.ListProcesses="$listProcesses",E.GetLatency="$getLatency",E.GetPerformanceMarks="$getPerformanceMarks",E.OrphanQuestionReply="$orphanQuestionReply",E.AcceptPtyHostResolvedVariables="$acceptPtyHostResolvedVariables",E.Start="$start",E.Input="$input",E.AcknowledgeDataEvent="$acknowledgeDataEvent",E.Shutdown="$shutdown",E.Resize="$resize",E.ClearBuffer="$clearBuffer",E.GetInitialCwd="$getInitialCwd",E.GetCwd="$getCwd",E.ProcessBinary="$processBinary",E.SendCommandResult="$sendCommandResult",E.InstallAutoReply="$installAutoReply",E.UninstallAllAutoReplies="$uninstallAllAutoReplies",E.GetDefaultSystemShell="$getDefaultSystemShell",E.GetProfiles="$getProfiles",E.GetEnvironment="$getEnvironment",E.GetWslPath="$getWslPath",E.GetTerminalLayoutInfo="$getTerminalLayoutInfo",E.SetTerminalLayoutInfo="$setTerminalLayoutInfo",E.SerializeTerminalState="$serializeTerminalState",E.ReviveTerminalProcesses="$reviveTerminalProcesses",E.GetRevivedPtyNewId="$getRevivedPtyNewId",E.SetUnicodeVersion="$setUnicodeVersion",E.ReduceConnectionGraceTime="$reduceConnectionGraceTime",E.UpdateIcon="$updateIcon",E.UpdateTitle="$updateTitle",E.UpdateProperty="$updateProperty",E.RefreshProperty="$refreshProperty",E.RequestDetachInstance="$requestDetachInstance",E.AcceptDetachInstanceReply="$acceptDetachInstanceReply",E.AcceptDetachedInstance="$acceptDetachedInstance",E.FreePortKillProcess="$freePortKillProcess"})(r||(e.RemoteTerminalChannelRequest=r={}))}),define(Se[307],ke([1,0,9,4,67,53,3,137,11]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WQ=o,e.$XQ=v,e.$YQ=a,e.$ZQ=h,e.$1Q=m,e.$2Q=p,e.$3Q=d,e.$4Q=b,e.$5Q=t,n=Be(n);function o(l,i){if(i)if(R.$c)for(const g in i){let s=g;for(const u in l)if(g.toLowerCase()===u.toLowerCase()){s=u;break}const c=i[g];c!==void 0&&S(l,s,c)}else Object.keys(i).forEach(g=>{const s=i[g];s!==void 0&&S(l,g,s)})}function S(l,i,g){typeof g=="string"?l[i]=g:delete l[i]}function v(l,i,g,s){l.TERM_PROGRAM="vscode",i&&(l.TERM_PROGRAM_VERSION=i),a(l,s)&&(l.LANG=h(g)),l.COLORTERM="truecolor"}function f(l,i){if(i)for(const g of Object.keys(i)){const s=i[g];s!=null&&(l[g]=s)}}async function w(l,i){return await Promise.all(Object.entries(i).map(async([g,s])=>{if(typeof s=="string")try{i[g]=await l(s)}catch{i[g]=s}})),i}function a(l,i){if(i==="on")return!0;if(i==="auto"){const g=l.LANG;return!g||g.search(/\.UTF\-8$/)===-1&&g.search(/\.utf8$/)===-1&&g.search(/\.euc.+/)===-1}return!1}function h(l){const i=l?l.split("-"):[],g=i.length;if(g===0)return"en_US.UTF-8";if(g===1){const s={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};i[0]in s&&i.push(s[i[0]])}else i[1]=i[1].toUpperCase();return i.join("_")+".UTF-8"}async function m(l,i,g,s,c,u){if(l.cwd){const P=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,T=await $(P,g);return(0,A.$TQ)(T||P)}let D;return!l.ignoreConfigurationCwd&&c&&(g&&(c=await $(c,g,u)),c&&(n.$lc(c)?D=c:s&&(D=n.$mc(s.fsPath,c)))),D||(D=s?s.fsPath:i||""),(0,A.$TQ)(D)}async function $(l,i,g){if(i)try{return await i(l)}catch(s){g?.error("Could not resolve terminal cwd",s);return}return l}function p(l,i,g){if(g)return s=>g.resolveWithEnvironment(i,l,s)}async function d(l,i,g,s,c,u){const D={};if(l.strictEnv)f(D,l.env);else{f(D,u);const P={...i};g&&(P&&await w(g,P),l.env&&await w(g,l.env)),R.$d&&(D.VSCODE_NODE_OPTIONS&&(D.NODE_OPTIONS=D.VSCODE_NODE_OPTIONS,delete D.VSCODE_NODE_OPTIONS),D.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(D.NODE_REPL_EXTERNAL_MODULE=D.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete D.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,E.$lm)(D,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),o(D,P),o(D,l.env),v(D,s,R.$q,c)}return D}async function b(l,i,g,s,c,u,D=R.$c){let P;if((0,y.$gg)(l)?P=l:(P=l.fsPath,D&&u!==R.OperatingSystem.Windows?P=P.replace(/\\/g,"/"):!D&&u===R.OperatingSystem.Windows&&(P=P.replace(/\//g,"\\"))),!i)return P;const T=P.includes(" "),z=P.includes("(")||P.includes(")"),C=n.$qc(i,".exe"),k=C==="pwsh"||g==="pwsh"||C==="powershell"||g==="powershell";if(k&&(T||P.includes("'")))return`& '${P.replace(/'/g,"''")}'`;if(z&&k)return`& '${P}'`;if(u===R.OperatingSystem.Windows){if(s!==void 0)return s===I.WindowsShellType.GitBash?(0,A.$RQ)(P.replace(/\\/g,"/")):s===I.WindowsShellType.Wsl?c?.getWslPath(P,"win-to-unix")||P:T?`"${P}"`:P;const q=i.toLowerCase();return q.includes("wsl")||q.includes("bash.exe")&&!q.toLowerCase().includes("git")?c?.getWslPath(P,"win-to-unix")||P:T?`"${P}"`:P}return(0,A.$RQ)(P)}function t(l,i,g){const s=typeof l=="string"?r.URI.parse(l):l;let c=s?i.getWorkspaceFolder(s)??void 0:void 0;if(!c){const u=g.getLastActiveWorkspaceRoot();c=u?i.getWorkspaceFolder(u)??void 0:void 0}return c}}),define(Se[76],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(I){I.Delimiter="\0"})(n||(e.TestIdPathParts=n={}));var r;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(r||(e.TestPosition=r={}));class E{static fromExtHostTestItem(R,A,y=R.parent){if(R._isRoot)return new E([A]);const o=[R.id];for(let S=y;S&&S.id!==A;S=S.parent)o.push(S.id);return o.push(A),new E(o.reverse())}static isRoot(R){return!R.includes(n.Delimiter)}static root(R){const A=R.indexOf(n.Delimiter);return A===-1?R:R.slice(0,A)}static fromString(R){return new E(R.split(n.Delimiter))}static join(R,A){return new E([...R.path,A])}static joinToString(R,A){return R.toString()+n.Delimiter+A}static parentId(R){const A=R.lastIndexOf(n.Delimiter);return A===-1?void 0:R.slice(0,A)}static localId(R){const A=R.lastIndexOf(n.Delimiter);return A===-1?R:R.slice(A+n.Delimiter.length)}static isChild(R,A){return A.startsWith(R)&&A[R.length]===n.Delimiter}static compare(R,A){return R===A?r.IsSame:E.isChild(R,A)?r.IsChild:E.isChild(A,R)?r.IsParent:r.Disconnected}static getLengthOfCommonPrefix(R,A){if(R===0)return 0;let y=0;for(;y<R-1;){for(let o=1;o<R;o++){const S=A(o-1),v=A(o);if(S.path[y]!==v.path[y])return y}y++}return y}constructor(R,A=R.length){if(this.path=R,this.d=A,R.length===0||A<1)throw new Error("cannot create test with empty path")}get rootId(){return new E(this.path,1)}get parentId(){return this.d>1?new E(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new E(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new E(this.path,R)}compare(R){if(typeof R=="string")return E.compare(this.toString(),R);for(let A=0;A<R.d&&A<this.d;A++)if(R.path[A]!==this.path[A])return r.Disconnected;return R.d>this.d?r.IsChild:R.d<this.d?r.IsParent:r.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=n.Delimiter,this.c+=this.path[R]}return this.c}}e.$UI=E}),define(Se[104],ke([1,0,4,86,51,76]),function(se,e,n,r,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$3I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$2I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$1I=e.$ZI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$YI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$XI=e.$WI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$VI=e.TestResultState=void 0;var R;(function(Z){Z[Z.Unset=0]="Unset",Z[Z.Queued=1]="Queued",Z[Z.Running=2]="Running",Z[Z.Passed=3]="Passed",Z[Z.Failed=4]="Failed",Z[Z.Skipped=5]="Skipped",Z[Z.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$VI={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var A;(function(Z){Z[Z.Run=1]="Run",Z[Z.Debug=2]="Debug",Z[Z.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var y;(function(Z){Z[Z.Run=2]="Run",Z[Z.Debug=4]="Debug",Z[Z.Coverage=8]="Coverage",Z[Z.HasNonDefaultProfile=16]="HasNonDefaultProfile",Z[Z.HasConfigurable=32]="HasConfigurable",Z[Z.SupportsContinuousRun=64]="SupportsContinuousRun"})(y||(e.TestRunProfileBitset=y={})),e.$WI=[y.Run,y.Debug,y.Coverage,y.HasNonDefaultProfile,y.HasConfigurable,y.SupportsContinuousRun];const o=Z=>"runId"in Z;e.$XI=o;var S;(function(Z){Z.serialize=x=>({range:x.range.toJSON(),uri:x.uri.toJSON()}),Z.deserialize=(x,le)=>({range:E.$Nt.lift(le.range),uri:x.asCanonicalUri(n.URI.revive(le.uri))})})(S||(e.IRichLocation=S={}));var v;(function(Z){Z[Z.Error=0]="Error",Z[Z.Output=1]="Output"})(v||(e.TestMessageType=v={}));var f;(function(Z){Z.serialize=x=>({message:x.message,type:v.Error,expected:x.expected,actual:x.actual,contextValue:x.contextValue,location:x.location&&S.serialize(x.location)}),Z.deserialize=(x,le)=>({message:le.message,type:v.Error,expected:le.expected,actual:le.actual,contextValue:le.contextValue,location:le.location&&S.deserialize(x,le.location)})})(f||(e.ITestErrorMessage=f={}));const w=(Z,x)=>`${x?"s":"e"}${Z}`;e.$YI=w;var a;(function(Z){Z.serialize=x=>({message:x.message,type:v.Output,offset:x.offset,length:x.length,location:x.location&&S.serialize(x.location)}),Z.deserialize=(x,le)=>({message:le.message,type:v.Output,offset:le.offset,length:le.length,location:le.location&&S.deserialize(x,le.location)})})(a||(e.ITestOutputMessage=a={}));var h;(function(Z){Z.serialize=x=>x.type===v.Error?f.serialize(x):a.serialize(x),Z.deserialize=(x,le)=>le.type===v.Error?f.deserialize(x,le):a.deserialize(x,le)})(h||(e.ITestMessage=h={}));var m;(function(Z){Z.serializeWithoutMessages=x=>({state:x.state,duration:x.duration,messages:[]}),Z.serialize=x=>({state:x.state,duration:x.duration,messages:x.messages.map(h.serialize)}),Z.deserialize=(x,le)=>({state:le.state,duration:le.duration,messages:le.messages.map(K=>h.deserialize(x,K))})})(m||(e.ITestTaskState=m={}));const $="\0",p=(Z,x)=>Z+$+x;e.$ZI=p;const d=Z=>{const x=Z.indexOf($);return{ctrlId:Z.slice(0,x),tagId:Z.slice(x+1)}};e.$1I=d;var b;(function(Z){Z.serialize=x=>({extId:x.extId,label:x.label,tags:x.tags,busy:x.busy,children:void 0,uri:x.uri?.toJSON(),range:x.range?.toJSON()||null,description:x.description,error:x.error,sortText:x.sortText}),Z.deserialize=(x,le)=>({extId:le.extId,label:le.label,tags:le.tags,busy:le.busy,children:void 0,uri:le.uri?x.asCanonicalUri(n.URI.revive(le.uri)):void 0,range:le.range?E.$Nt.lift(le.range):null,description:le.description,error:le.error,sortText:le.sortText})})(b||(e.ITestItem=b={}));var t;(function(Z){Z[Z.NotExpandable=0]="NotExpandable",Z[Z.Expandable=1]="Expandable",Z[Z.BusyExpanding=2]="BusyExpanding",Z[Z.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var l;(function(Z){Z.serialize=x=>({expand:x.expand,item:b.serialize(x.item)}),Z.deserialize=(x,le)=>({controllerId:I.$UI.root(le.item.extId),expand:le.expand,item:b.deserialize(x,le.item)})})(l||(e.InternalTestItem=l={}));var i;(function(Z){Z.serialize=x=>{let le;return x.item&&(le={},x.item.label!==void 0&&(le.label=x.item.label),x.item.tags!==void 0&&(le.tags=x.item.tags),x.item.busy!==void 0&&(le.busy=x.item.busy),x.item.uri!==void 0&&(le.uri=x.item.uri?.toJSON()),x.item.range!==void 0&&(le.range=x.item.range?.toJSON()),x.item.description!==void 0&&(le.description=x.item.description),x.item.error!==void 0&&(le.error=x.item.error),x.item.sortText!==void 0&&(le.sortText=x.item.sortText)),{extId:x.extId,expand:x.expand,item:le}},Z.deserialize=x=>{let le;return x.item&&(le={},x.item.label!==void 0&&(le.label=x.item.label),x.item.tags!==void 0&&(le.tags=x.item.tags),x.item.busy!==void 0&&(le.busy=x.item.busy),x.item.range!==void 0&&(le.range=x.item.range?E.$Nt.lift(x.item.range):null),x.item.description!==void 0&&(le.description=x.item.description),x.item.error!==void 0&&(le.error=x.item.error),x.item.sortText!==void 0&&(le.sortText=x.item.sortText)),{extId:x.extId,expand:x.expand,item:le}}})(i||(e.ITestItemUpdate=i={}));const g=(Z,x)=>{x.expand!==void 0&&(Z.expand=x.expand),x.item!==void 0&&(Z.item=Z.item?Object.assign(Z.item,x.item):x.item)};e.$2I=g;var s;(function(Z){Z.serializeWithoutMessages=x=>({...l.serialize(x),ownComputedState:x.ownComputedState,computedState:x.computedState,tasks:x.tasks.map(m.serializeWithoutMessages)}),Z.serialize=x=>({...l.serialize(x),ownComputedState:x.ownComputedState,computedState:x.computedState,tasks:x.tasks.map(m.serialize)}),Z.deserialize=(x,le)=>({...l.deserialize(x,le),ownComputedState:le.ownComputedState,computedState:le.computedState,tasks:le.tasks.map(K=>m.deserialize(x,K)),retired:!0})})(s||(e.TestResultItem=s={}));var c;(function(Z){Z.empty=()=>({covered:0,total:0}),Z.sum=(x,le)=>{x.covered+=le.covered,x.total+=le.total}})(c||(e.ICoverageCount=c={}));var u;(function(Z){Z.serialize=x=>({id:x.id,statement:x.statement,branch:x.branch,declaration:x.declaration,testIds:x.testIds,uri:x.uri.toJSON()}),Z.deserialize=(x,le)=>({id:le.id,statement:le.statement,branch:le.branch,declaration:le.declaration,testIds:le.testIds,uri:x.asCanonicalUri(n.URI.revive(le.uri))}),Z.empty=(x,le)=>({id:x,uri:le,statement:c.empty()})})(u||(e.IFileCoverage=u={}));function D(Z){return{...Z,location:Z.location?.toJSON()}}function P(Z){return Z.location=Z.location?r.$Mt.isIPosition(Z.location)?r.$Mt.lift(Z.location):E.$Nt.lift(Z.location):void 0,Z}e.$3I=3;var T;(function(Z){Z[Z.Declaration=0]="Declaration",Z[Z.Statement=1]="Statement",Z[Z.Branch=2]="Branch"})(T||(e.DetailType=T={}));var z;(function(Z){Z.serialize=x=>x.type===T.Declaration?k.serialize(x):q.serialize(x),Z.deserialize=x=>x.type===T.Declaration?k.deserialize(x):q.deserialize(x)})(z||(e.CoverageDetails=z={}));var C;(function(Z){Z.serialize=D,Z.deserialize=P})(C||(e.IBranchCoverage=C={}));var k;(function(Z){Z.serialize=D,Z.deserialize=P})(k||(e.IDeclarationCoverage=k={}));var q;(function(Z){Z.serialize=x=>({...D(x),branches:x.branches?.map(C.serialize)}),Z.deserialize=x=>({...P(x),branches:x.branches?.map(C.deserialize)})})(q||(e.IStatementCoverage=q={}));var Y;(function(Z){Z[Z.Add=0]="Add",Z[Z.Update=1]="Update",Z[Z.DocumentSynced=2]="DocumentSynced",Z[Z.Remove=3]="Remove",Z[Z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",Z[Z.Retire=5]="Retire",Z[Z.AddTag=6]="AddTag",Z[Z.RemoveTag=7]="RemoveTag"})(Y||(e.TestDiffOpType=Y={}));var J;(function(Z){Z.deserialize=(x,le)=>le.op===Y.Add?{op:le.op,item:l.deserialize(x,le.item)}:le.op===Y.Update?{op:le.op,item:i.deserialize(le.item)}:le.op===Y.DocumentSynced?{op:le.op,uri:x.asCanonicalUri(n.URI.revive(le.uri)),docv:le.docv}:le,Z.serialize=x=>x.op===Y.Add?{op:x.op,item:l.serialize(x.item)}:x.op===Y.Update?{op:x.op,item:i.serialize(x.item)}:x})(J||(e.TestsDiffOp=J={}));class ne{constructor(x){this.k=x,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(x){const le=this.w();for(const K of x)switch(K.op){case Y.Add:this.l(l.deserialize(this.k,K.item),le);break;case Y.Update:this.p(i.deserialize(K.item),le);break;case Y.Remove:this.q(K.itemId,le);break;case Y.Retire:this.v(K.itemId);break;case Y.IncrementPendingExtHosts:this.updatePendingRoots(K.amount);break;case Y.AddTag:this.c.set(K.tag.id,K.tag);break;case Y.RemoveTag:this.c.delete(K.id);break}le.complete?.()}l(x,le){const K=I.$UI.parentId(x.item.extId)?.toString();let ae;if(!K)ae=this.x(x),this.g.add(ae),this.f.set(x.item.extId,ae);else if(this.f.has(K)){const M=this.f.get(K);M.children.add(x.item.extId),ae=this.x(x,M),this.f.set(x.item.extId,ae)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(x)}`);return}return le.add?.(ae),x.expand===t.BusyExpanding&&this.h++,ae}p(x,le){const K=this.f.get(x.extId);if(K)return x.expand!==void 0&&(K.expand===t.BusyExpanding&&this.h--,x.expand===t.BusyExpanding&&this.h++),(0,e.$2I)(K,x),le.update?.(K),K}q(x,le){const K=this.f.get(x);if(!K)return;const ae=I.$UI.parentId(K.item.extId)?.toString();ae?this.f.get(ae).children.delete(K.item.extId):this.g.delete(K);const M=[[x]];for(;M.length;)for(const B of M.pop()){const re=this.f.get(B);re&&(M.push(re.children),this.f.delete(B),le.remove?.(re,re!==K),re.expand===t.BusyExpanding&&this.h--)}}v(x){}updatePendingRoots(x){this.j+=x}w(){return{}}}e.$4I=ne}),define(Se[147],ke([1,0,14,6,2,107,104,76]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.TestItemEventOp=void 0;var y;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const o=(p,d)=>p===d,v=Object.entries({range:(p,d)=>p===d?!0:!p||!d?!1:p.equalsRange(d),busy:o,label:o,description:o,error:o,sortText:o,tags:(p,d)=>!(p.length!==d.length||p.some(b=>!d.includes(b)))}),f=(p,d)=>{let b;for(const[t,l]of v)l(p[t],d[t])||(b?b[t]=d[t]:b={[t]:d[t]});return b};class w extends E.$Xc{get root(){return this.s.root}constructor(d){super(),this.s=d,this.f=this.B(new n.$Sh(()=>this.flushDiff(),200)),this.g=this.B(new r.$ne),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(d){this.h=d;for(const b of this.tree.values())this.J(b)}get resolveHandler(){return this.h}collectDiff(){const d=this.m;return this.m=[],d}pushDiff(d){switch(d.op){case R.TestDiffOpType.DocumentSynced:{for(const b of this.m)if(b.op===R.TestDiffOpType.DocumentSynced&&b.uri===d.uri){b.docv=d.docv;return}break}case R.TestDiffOpType.Update:{const b=this.m[this.m.length-1];if(b){if(b.op===R.TestDiffOpType.Update&&b.item.extId===d.item.extId){(0,R.$2I)(b.item,d.item);return}if(b.op===R.TestDiffOpType.Add&&b.item.item.extId===d.item.extId){(0,R.$2I)(b.item,d.item);return}}break}}this.m.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,b){const t=this.tree.get(d);if(t){if((t.expandLevels===void 0||b>t.expandLevels)&&(t.expandLevels=b),t.expand===R.TestItemExpandState.Expandable){const l=this.M(t);return l.isOpen()?this.L(t,b-1):l.wait().then(()=>this.L(t,b-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,b-1)):this.L(t,b-1)}}dispose(){for(const d of this.tree.values())this.s.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(d,b){switch(b.op){case y.RemoveChild:this.O(A.$UI.joinToString(d.fullId,b.id));break;case y.Upsert:this.z(b.item,d);break;case y.Bulk:for(const t of b.ops)this.w(d,t);break;case y.SetTags:this.C(b.new,b.old,d.fullId.toString());break;case y.UpdateCanResolveChildren:this.J(d);break;case y.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:d.fullId.toString(),item:b.update}});break;case y.DocumentSynced:this.y(d.actual.uri);break;default:(0,I.$hd)(b)}}y(d){d&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:d,docv:this.s.getDocumentVersion(d)})}z(d,b){const t=A.$UI.fromExtHostTestItem(d,this.root.id,b?.actual),l=this.s.getApiFor(d);l.parent&&l.parent!==b?.actual&&this.s.getChildren(l.parent).delete(d.id);let i=this.tree.get(t.toString());if(!i){i={fullId:t,actual:d,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},d.tags.forEach(this.D,this),this.tree.set(i.fullId.toString(),i),this.G(d,b),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:i.expand,item:this.s.toITestItem(d)}}),this.I(d,i,b);return}if(i.actual===d){this.H(d,i,b);return}if(i.actual.uri?.toString()!==d.uri?.toString())return this.O(t.toString()),this.z(d,b);const g=this.s.getChildren(i.actual),s=i.actual,c=f(this.s.toITestItem(s),this.s.toITestItem(d));this.s.getApiFor(s).listener=void 0,i.actual=d,i.resolveBarrier=void 0,i.expand=R.TestItemExpandState.NotExpandable,c&&(c.hasOwnProperty("tags")&&(this.C(d.tags,s.tags,t.toString()),delete c.tags),this.w(i,{op:y.SetProp,update:c})),this.I(d,i,b);for(const[D,P]of g)this.s.getChildren(d).get(P.id)||this.O(A.$UI.joinToString(t,P.id));const u=i.expandLevels;u!==void 0&&queueMicrotask(()=>{i.expand===R.TestItemExpandState.Expandable&&(i.expandLevels=void 0,this.expand(t.toString(),u))}),this.y(i.actual.uri)}C(d,b,t){const l=new Set(b.map(i=>i.id));for(const i of d)l.delete(i.id)||this.D(i);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:d.map(i=>(0,R.$ZI)(this.s.controllerId,i.id))}}}),l.forEach(this.F,this)}D(d){const b=this.j.get(d.id);b?b.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$ZI)(this.s.controllerId,d.id)}}))}F(d){const b=this.j.get(d);b&&!--b.refCount&&(this.j.delete(d),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$ZI)(this.s.controllerId,d)}))}G(d,b){this.s.getApiFor(d).parent=b&&b.actual!==this.root?b.actual:void 0}H(d,b,t){this.G(d,t);const l=this.s.getApiFor(d);l.parent=t?.actual,l.listener=i=>this.w(b,i),this.J(b)}I(d,b,t){this.H(d,b,t);for(const[l,i]of this.s.getChildren(d))this.z(i,b)}J(d){let b;this.h?d.resolveBarrier?b=d.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:b=d.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:b=R.TestItemExpandState.NotExpandable,b!==d.expand&&(d.expand=b,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:d.fullId.toString(),expand:b}}),b===R.TestItemExpandState.Expandable&&d.expandLevels!==void 0&&this.M(d))}L(d,b){if(b<0)return;const t=[];for(const[l,i]of this.s.getChildren(d.actual)){const g=this.expand(A.$UI.joinToString(d.fullId,i.id),b);(0,n.$sh)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}M(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const i=new n.$Fh;return i.open(),i}d.expand=R.TestItemExpandState.BusyExpanding,this.N(d);const b=d.resolveBarrier=new n.$Fh,t=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,i)};let l;try{l=this.h(d.actual===this.root?void 0:d.actual)}catch(i){t(i)}return(0,n.$sh)(l)?l.catch(t).then(()=>{b.open(),this.J(d)}):(b.open(),this.J(d)),d.resolveBarrier}N(d){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:d.fullId.toString(),expand:d.expand}})}O(d){const b=this.tree.get(d);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:d});const t=[b];for(;t.length;){const l=t.pop();if(l){this.s.getApiFor(l.actual).listener=void 0;for(const i of l.actual.tags)this.F(i.id);this.tree.delete(l.fullId.toString());for(const[i,g]of this.s.getChildren(l.actual))t.push(this.tree.get(A.$UI.joinToString(l.fullId,g.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.$RP=w;class a extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.$SP=a;class h extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$TP=h;class m extends Error{constructor(d,b,t){super(`TestItem with ID "${d}" is from controller "${b}" and cannot be added as a child of an item from controller "${t}".`)}}e.$UP=m;const $=(p,d,b)=>{let t=new Map;return{get size(){return t.size},forEach(l,i){for(const g of t.values())l.call(i,g,this)},[Symbol.iterator](){return t.entries()},replace(l){const i=new Map,g=new Set(t.keys()),s={op:y.Bulk,ops:[]};for(const c of l){if(!(c instanceof b))throw new h(c.id);const u=d(c).controllerId;if(u!==p.controllerId)throw new m(c.id,u,p.controllerId);if(i.has(c.id))throw new a(c.id);i.set(c.id,c),g.delete(c.id),s.ops.push({op:y.Upsert,item:c})}for(const c of g.keys())s.ops.push({op:y.RemoveChild,id:c});p.listener?.(s),t=i},add(l){if(!(l instanceof b))throw new h(l.id);t.set(l.id,l),p.listener?.({op:y.Upsert,item:l})},delete(l){t.delete(l)&&p.listener?.({op:y.RemoveChild,id:l})},get(l){return t.get(l)},toJSON(){return Array.from(t.values())}}};e.$VP=$}),define(Se[148],ke([1,0,147]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=void 0;const r=new WeakMap,E=(R,A)=>{const y={controllerId:A};return r.set(R,y),y};e.$WP=E;const I=R=>{const A=r.get(R);if(!A)throw new n.$TP(R?.id||"<unknown>");return A};e.$XP=I}),define(Se[308],ke([1,0,46,27,5]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=void 0,e.$cF=".vscode",e.$dF="settings",e.$eF=`${e.$cF}/${e.$dF}.json`,e.$fF="vscode://schemas/settings/default",e.$gF="vscode://schemas/settings/user",e.$hF="vscode://schemas/settings/profile",e.$iF="vscode://schemas/settings/machine",e.$jF="vscode://schemas/settings/workspace",e.$kF="vscode://schemas/settings/folder",e.$lF="vscode://schemas/launch",e.$mF="vscode://schemas/tasks",e.$nF=[n.ConfigurationScope.APPLICATION],e.$oF=[n.ConfigurationScope.MACHINE,n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$pF=[n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE],e.$qF=[n.ConfigurationScope.APPLICATION,...e.$pF],e.$rF=[n.ConfigurationScope.MACHINE,n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$sF=[n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$tF=[n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$uF="tasks",e.$vF="launch",e.$wF=Object.create(null),e.$wF[e.$uF]=`${e.$cF}/${e.$uF}.json`,e.$wF[e.$vF]=`${e.$cF}/${e.$vF}.json`,e.$xF=Object.create(null),e.$xF[e.$uF]=`${e.$uF}.json`,e.$yF=(0,E.$Hi)(r.$aj),e.$zF=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$AF="workbench.settings.applyToAllProfiles"}),define(Se[149],ke([1,0,5]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QQ=e.VariableKind=e.$PQ=void 0,e.$PQ=(0,n.$Gi)("configurationResolverService");var r;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator",I.PathSeparatorAlias="/"})(r||(e.VariableKind=r={}));class E extends Error{constructor(R,A){super(A),this.variable=R}}e.$QQ=E}),define(Se[309],ke([1,0,9,32,11,21,3,177,236,149,17]),function(se,e,n,r,E,I,R,A,y,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Q=void 0,n=Be(n),r=Be(r),E=Be(E),I=Be(I);class v{constructor(w,a,h,m){this.h=new Map,this.a=w,this.b=a,this.g=h,m&&(this.c=m.then($=>this.i($)))}i(w){if(R.$c){const a=Object.create(null);return Object.keys(w).forEach(h=>{a[h.toLowerCase()]=w[h]}),a}return w}resolveWithEnvironment(w,a,h){return this.l({env:this.i(w),userHome:void 0},a?a.uri:void 0,h)}async resolveAsync(w,a){const h={env:await this.c,userHome:await this.g};return this.l(h,w?w.uri:void 0,a)}async j(w,a,h,m){const $=I.$fo(a);R.$c&&$.windows?Object.keys($.windows).forEach(d=>$[d]=$.windows[d]):R.$d&&$.osx?Object.keys($.osx).forEach(d=>$[d]=$.osx[d]):R.$e&&$.linux&&Object.keys($.linux).forEach(d=>$[d]=$.linux[d]),delete $.windows,delete $.osx,delete $.linux;const p={env:await this.c,userHome:await this.g};return this.l(p,w?w.uri:void 0,$,h,m)}async resolveAnyAsync(w,a,h){return this.j(w,a,h)}async resolveAnyMap(w,a,h){const m=new Map;return{newConfig:await this.j(w,a,h,m),resolvedVariables:m}}resolveWithInteractionReplace(w,a,h,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,a,h,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,a){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,a)}async l(w,a,h,m,$){if(E.$gg(h))return this.m(w,a,h,m,$);if(Array.isArray(h))return Promise.all(h.map(p=>this.l(w,a,p,m,$)));if(E.$ig(h)){const p=Object.create(null),d=await Promise.all(Object.keys(h).map(async b=>[await this.m(w,a,b,m,$),await this.l(w,a,h[b],m,$)]));for(const[b,t]of d)p[b]=t;return p}return h}m(w,a,h,m,$){return(0,S.$zf)(h,v.VARIABLE_REGEXP,async(p,d)=>{if(d.includes(v.VARIABLE_LHS))return p;let b=await this.o(w,p,d,a,m);return $?.set(d,b),b!==p&&E.$gg(b)&&b.match(v.VARIABLE_REGEXP)&&(b=await this.m(w,a,b,m,$)),b})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,a,h,m,$){let p;const d=h.split(":");d.length>1&&(h=d[0],p=d[1]);const b=i=>{const g=this.a.getFilePath();if(g)return(0,A.$Yw)(g);throw new o.$QQ(i,(0,y.localize)(0,null,a))},t=i=>{const g=b(i);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,A.$Yw)(s)}throw new o.$QQ(i,(0,y.localize)(1,null,a,n.$qc(g)))},l=i=>{if(p){const g=this.a.getFolderUri(p);if(g)return g;throw new o.$QQ(i,(0,y.localize)(2,null,a,p))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new o.$QQ(i,(0,y.localize)(3,null,a)):new o.$QQ(i,(0,y.localize)(4,null,a))};switch(h){case"env":if(p){if(w.env){const i=w.env[R.$c?p.toLowerCase():p];if(E.$gg(i))return i}return""}throw new o.$QQ(o.VariableKind.Env,(0,y.localize)(5,null,a));case"config":if(p){const i=this.a.getConfigurationValue(m,p);if(E.$pg(i))throw new o.$QQ(o.VariableKind.Config,(0,y.localize)(6,null,a,p));if(E.$ig(i))throw new o.$QQ(o.VariableKind.Config,(0,y.localize)(7,null,a,p));return i}throw new o.$QQ(o.VariableKind.Config,(0,y.localize)(8,null,a));case"command":return this.p(o.VariableKind.Command,a,p,$,"command");case"input":return this.p(o.VariableKind.Input,a,p,$,"input");case"extensionInstallFolder":if(p){const i=await this.a.getExtension(p);if(!i)throw new o.$QQ(o.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,a,p));return this.n(i.extensionLocation)}throw new o.$QQ(o.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,a));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,A.$Yw)(this.n(l(o.VariableKind.WorkspaceFolder)));case"cwd":return m||p?(0,A.$Yw)(this.n(l(o.VariableKind.Cwd))):r.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.$Yw)(n.$qc(this.n(l(o.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new o.$QQ(o.VariableKind.UserHome,(0,y.localize)(11,null,a))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new o.$QQ(o.VariableKind.LineNumber,(0,y.localize)(12,null,a))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new o.$QQ(o.VariableKind.SelectedText,(0,y.localize)(13,null,a))}case"file":return b(o.VariableKind.File);case"fileWorkspaceFolder":return t(o.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return n.$qc(t(o.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||p?n.$oc(this.n(l(o.VariableKind.RelativeFile)),b(o.VariableKind.RelativeFile)):b(o.VariableKind.RelativeFile);case"relativeFileDirname":{const i=n.$pc(b(o.VariableKind.RelativeFileDirname));if(m||p){const g=n.$oc(this.n(l(o.VariableKind.RelativeFileDirname)),i);return g.length===0?".":g}return i}case"fileDirname":return n.$pc(b(o.VariableKind.FileDirname));case"fileExtname":return n.$rc(b(o.VariableKind.FileExtname));case"fileBasename":return n.$qc(b(o.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=n.$qc(b(o.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-n.$rc(i).length)}case"fileDirnameBasename":return n.$qc(n.$pc(b(o.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||a}case"execInstallFolder":{const i=this.a.getAppRoot();return i||a}case"pathSeparator":case"/":return n.sep;default:try{const i=p?`${h}:${p}`:h;return this.p(o.VariableKind.Unknown,a,i,$,void 0)}catch{return a}}}}p(w,a,h,m,$){if(h&&m){const p=$===void 0?m[h]:m[$+":"+h];if(typeof p=="string")return p;throw new o.$QQ(w,(0,y.localize)(14,null,a))}return a}}e.$6Q=v,v.VARIABLE_LHS="${",v.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[310],ke([1,0,5,103]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$kE=void 0,e.$lE=o,e.$mE=f,e.$nE=w,e.$kE=(0,n.$Gi)("editorGroupsService");var E;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(E||(e.GroupDirection=E={}));var I;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var R;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var A;(function(a){a[a.MAXIMIZE=0]="MAXIMIZE",a[a.EXPAND=1]="EXPAND",a[a.EVEN=2]="EVEN"})(A||(e.GroupsArrangement=A={}));var y;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function o(a){const h=a;return(0,r.$9F)(h?.editor)&&(0,r.$9F)(h?.replacement)}var S;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S||(e.GroupsOrder=S={}));var v;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(v||(e.OpenEditorContext=v={}));function f(a){const h=a;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}function w(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?E.DOWN:E.RIGHT}}),define(Se[150],ke([1,0,5,310]),function(se,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rE=e.$qE=e.$pE=e.$oE=void 0,e.$sE=E,e.$oE=(0,n.$Gi)("editorService"),e.$pE=-1,e.$qE=-2,e.$rE=-3;function E(I){const R=I;return typeof I=="number"||(0,r.$mE)(R)}}),define(Se[311],ke([1,0,308,90,98,97,149,103,150,13,256,306,53,146]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Q=e.$8Q=void 0,e.$8Q="remoteterminal";let a=class{get onPtyHostExit(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostExitEvent)}get onPtyHostStart(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostStartEvent)}get onPtyHostUnresponsive(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent)}get onPtyHostResponsive(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent)}get onPtyHostRequestResolveVariables(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent)}get onProcessData(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessDataEvent)}get onProcessExit(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessExitEvent)}get onProcessReady(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessReadyEvent)}get onProcessReplay(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessReplayEvent)}get onProcessOrphanQuestion(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessOrphanQuestion)}get onExecuteCommand(){return this.b.listen(w.RemoteTerminalChannelEvent.OnExecuteCommand)}get onDidRequestDetach(){return this.b.listen(w.RemoteTerminalChannelEvent.OnDidRequestDetach)}get onDidChangeProperty(){return this.b.listen(w.RemoteTerminalChannelEvent.OnDidChangeProperty)}constructor(m,$,p,d,b,t,l,i,g,s){this.a=m,this.b=$,this.c=p,this.d=d,this.e=b,this.f=t,this.g=l,this.h=i,this.i=g,this.j=s}restartPtyHost(){return this.b.call(w.RemoteTerminalChannelRequest.RestartPtyHost,[])}async createProcess(m,$,p,d,b,t,l,i){await this.c.whenRemoteConfigurationLoaded();const g=Object.create(null),s=p?this.d.getWorkspaceFolder(p)??void 0:void 0;let c;try{c=(await this.e.resolveAnyMap(s,{shellLaunchConfig:m,configuration:$})).resolvedVariables}catch(Y){this.h.error(Y)}if(c)for(const[Y,J]of c.entries())(/^config:/.test(Y)||Y==="selectedText"||Y==="lineNumber")&&(g[Y]=J);const u=[];for(const[Y,J]of this.f.collections.entries())u.push([Y,(0,I.$Es)(J.map),(0,I.$Fs)(J.descriptionMap)]);const D=await this.g.resolveAuthority(this.a),P=D.options&&D.options.extensionHostEnv,T=this.d.getWorkspace(),z=T.folders,C=p?this.d.getWorkspaceFolder(p):null,k=A.$fG.getOriginalUri(this.i.activeEditor,{supportSideBySide:A.SideBySideEditor.PRIMARY,filterByScheme:[o.Schemas.file,o.Schemas.vscodeUserData,o.Schemas.vscodeRemote]}),q={configuration:$,resolvedVariables:g,envVariableCollections:u,shellLaunchConfig:m,workspaceId:T.id,workspaceName:this.j.getWorkspaceLabel(T),workspaceFolders:z,activeWorkspaceFolder:C,activeFileResource:k,shouldPersistTerminal:b,options:d,cols:t,rows:l,unicodeVersion:i,resolverEnv:P};return await this.b.call(w.RemoteTerminalChannelRequest.CreateProcess,q)}requestDetachInstance(m,$){return this.b.call(w.RemoteTerminalChannelRequest.RequestDetachInstance,[m,$])}acceptDetachInstanceReply(m,$){return this.b.call(w.RemoteTerminalChannelRequest.AcceptDetachInstanceReply,[m,$])}attachToProcess(m){return this.b.call(w.RemoteTerminalChannelRequest.AttachToProcess,[m])}detachFromProcess(m,$){return this.b.call(w.RemoteTerminalChannelRequest.DetachFromProcess,[m,$])}listProcesses(){return this.b.call(w.RemoteTerminalChannelRequest.ListProcesses)}getLatency(){return this.b.call(w.RemoteTerminalChannelRequest.GetLatency)}getPerformanceMarks(){return this.b.call(w.RemoteTerminalChannelRequest.GetPerformanceMarks)}reduceConnectionGraceTime(){return this.b.call(w.RemoteTerminalChannelRequest.ReduceConnectionGraceTime)}processBinary(m,$){return this.b.call(w.RemoteTerminalChannelRequest.ProcessBinary,[m,$])}start(m){return this.b.call(w.RemoteTerminalChannelRequest.Start,[m])}input(m,$){return this.b.call(w.RemoteTerminalChannelRequest.Input,[m,$])}acknowledgeDataEvent(m,$){return this.b.call(w.RemoteTerminalChannelRequest.AcknowledgeDataEvent,[m,$])}setUnicodeVersion(m,$){return this.b.call(w.RemoteTerminalChannelRequest.SetUnicodeVersion,[m,$])}shutdown(m,$){return this.b.call(w.RemoteTerminalChannelRequest.Shutdown,[m,$])}resize(m,$,p){return this.b.call(w.RemoteTerminalChannelRequest.Resize,[m,$,p])}clearBuffer(m){return this.b.call(w.RemoteTerminalChannelRequest.ClearBuffer,[m])}getInitialCwd(m){return this.b.call(w.RemoteTerminalChannelRequest.GetInitialCwd,[m])}getCwd(m){return this.b.call(w.RemoteTerminalChannelRequest.GetCwd,[m])}orphanQuestionReply(m){return this.b.call(w.RemoteTerminalChannelRequest.OrphanQuestionReply,[m])}sendCommandResult(m,$,p){return this.b.call(w.RemoteTerminalChannelRequest.SendCommandResult,[m,$,p])}freePortKillProcess(m){return this.b.call(w.RemoteTerminalChannelRequest.FreePortKillProcess,[m])}installAutoReply(m,$){return this.b.call(w.RemoteTerminalChannelRequest.InstallAutoReply,[m,$])}uninstallAllAutoReplies(){return this.b.call(w.RemoteTerminalChannelRequest.UninstallAllAutoReplies,[])}getDefaultSystemShell(m){return this.b.call(w.RemoteTerminalChannelRequest.GetDefaultSystemShell,[m])}getProfiles(m,$,p){return this.b.call(w.RemoteTerminalChannelRequest.GetProfiles,[this.d.getWorkspace().id,m,$,p])}acceptPtyHostResolvedVariables(m,$){return this.b.call(w.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables,[m,$])}getEnvironment(){return this.b.call(w.RemoteTerminalChannelRequest.GetEnvironment)}getWslPath(m,$){return this.b.call(w.RemoteTerminalChannelRequest.GetWslPath,[m,$])}setTerminalLayoutInfo(m){const p={workspaceId:this.d.getWorkspace().id,tabs:m?m.tabs:[]};return this.b.call(w.RemoteTerminalChannelRequest.SetTerminalLayoutInfo,p)}updateTitle(m,$,p){return this.b.call(w.RemoteTerminalChannelRequest.UpdateTitle,[m,$,p])}updateIcon(m,$,p,d){return this.b.call(w.RemoteTerminalChannelRequest.UpdateIcon,[m,$,p,d])}refreshProperty(m,$){return this.b.call(w.RemoteTerminalChannelRequest.RefreshProperty,[m,$])}updateProperty(m,$,p){return this.b.call(w.RemoteTerminalChannelRequest.UpdateProperty,[m,$,p])}getTerminalLayoutInfo(){const $={workspaceId:this.d.getWorkspace().id};return this.b.call(w.RemoteTerminalChannelRequest.GetTerminalLayoutInfo,$)}reviveTerminalProcesses(m,$,p){return this.b.call(w.RemoteTerminalChannelRequest.ReviveTerminalProcesses,[m,$,p])}getRevivedPtyNewId(m){return this.b.call(w.RemoteTerminalChannelRequest.GetRevivedPtyNewId,[m])}serializeTerminalState(m){return this.b.call(w.RemoteTerminalChannelRequest.SerializeTerminalState,[m])}};e.$9Q=a,e.$9Q=a=ze([Fe(2,n.$yF),Fe(3,E.$Pi),Fe(4,R.$PQ),Fe(5,v.$sQ),Fe(6,r.$Rl),Fe(7,f.$rs),Fe(8,y.$oE),Fe(9,S.$qw)],a)}),define(Se[312],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.ExtHostConnectionType=void 0,e.$gn=A,e.$hn=y;var n;(function(S){S[S.IPC=1]="IPC",S[S.Socket=2]="Socket",S[S.MessagePort=3]="MessagePort"})(n||(e.ExtHostConnectionType=n={}));class r{constructor(v){this.pipeName=v,this.type=n.IPC}serialize(v){v[r.ENV_KEY]=this.pipeName}}e.$dn=r,r.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class E{constructor(){this.type=n.Socket}serialize(v){v[E.ENV_KEY]="1"}}e.$en=E,E.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class I{constructor(){this.type=n.MessagePort}serialize(v){v[I.ENV_KEY]="1"}}e.$fn=I,I.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function R(S){delete S[r.ENV_KEY],delete S[E.ENV_KEY],delete S[I.ENV_KEY]}function A(S,v){R(v),S.serialize(v)}function y(S){if(S[r.ENV_KEY])return o(S,new r(S[r.ENV_KEY]));if(S[E.ENV_KEY])return o(S,new E);if(S[I.ENV_KEY])return o(S,new I);throw new Error("No connection information defined in environment!")}function o(S,v){return R(S),v}}),define(Se[313],ke([1,0,15]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Cn=R,e.$Dn=A;var r;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(r||(e.UIKind=r={}));var E;(function(o){o[o.VersionMismatch=55]="VersionMismatch",o[o.UnexpectedError=81]="UnexpectedError"})(E||(e.ExtensionHostExitCode=E={}));var I;(function(o){o[o.Initialized=0]="Initialized",o[o.Ready=1]="Ready",o[o.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function R(o){const S=n.$Pe.alloc(1);switch(o){case I.Initialized:S.writeUInt8(1,0);break;case I.Ready:S.writeUInt8(2,0);break;case I.Terminate:S.writeUInt8(3,0);break}return S}function A(o,S){if(o.byteLength!==1)return!1;switch(o.readUInt8(0)){case 1:return S===I.Initialized;case 2:return S===I.Ready;case 3:return S===I.Terminate;default:return!1}}var y;(function(o){o.Start="START_NATIVE_LOG",o.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(Se[314],ke([1,0,5,6,24,12,299,313,91,41,21,4,2,231]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.$hQ=e.$gQ=void 0,e.$iQ=m;let a=class extends f.$Xc{constructor(p,d){super(),this.s=p,this.t=d,this.a=this.B(new r.$ne),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new r.$ne),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=E.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=v.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=d.createLogger(this.m,{id:o.$Bp,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(d.onDidChangeLogLevel(b=>{(0,I.$ck)(b)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===E.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=E.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=E.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=E.TelemetryLevel.USAGE:!1}}instantiateLogger(p,d,b){const t=this.getTelemetryDetails(),l=new h(d,b,p,this.n,this.j,this.getBuiltInCommonProperties(p),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),i=this.r.get(p.identifier.value)??[];return this.r.set(p.identifier.value,[...i,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(p,d,b){this.f=p,this.g=d,this.c=b??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(p){const d=Object.create(null);switch(d["common.extname"]=`${p.publisher}.${p.name}`,d["common.extversion"]=p.version,d["common.vscodemachineid"]=this.s.telemetryInfo.machineId,d["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,d["common.sqmid"]=this.s.telemetryInfo.sqmId,d["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,d["common.vscodeversion"]=this.s.version,d["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),d["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:d["common.uikind"]="web";break;case A.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,y.$jn)((0,o.$Hp)(this.s.remote.authority)),d}$onDidChangeTelemetryLevel(p){this.h=this.getTelemetryConfiguration(),this.f=p;const d=this.getTelemetryDetails();this.r.forEach((b,t)=>{const l=b.filter(i=>!i.isDisposed);l.length===0?this.r.delete(t):this.r.set(t,l)}),this.r.forEach(b=>{for(const t of b)t.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(p,d){const t=this.r.get(p.value)?.filter(i=>!i.isDisposed);if(!t)return this.r.delete(p.value),!1;let l=!1;for(const i of t)i.ignoreUnhandledExtHostErrors||(i.logError(d),l=!0);return l}};e.$gQ=a,e.$gQ=a=ze([Fe(0,R.$fQ),Fe(1,I.$bk)],a);class h{static validateSender(p){if(typeof p!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof p.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof p.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof p.flush<"u"&&typeof p.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(p,d,b,t,l,i,g){this.g=b,this.h=t,this.i=l,this.j=i,this.a=new r.$ne,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=p,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(p,d){this.e&&(this.d={isUsageEnabled:p,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(p){let d="properties"in p?p.properties??{}:p;return d=(0,o.$Kp)(d,[]),this.c&&(d=(0,S.$io)(d,this.c)),this.b||(d=(0,S.$io)(d,this.j)),"properties"in p?p.properties=d:p=d,p}k(p,d){this.f&&(this.g.publisher==="vscode"?p=this.g.name+"/"+p:p=this.g.identifier.value+"/"+p,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(p,d),this.h.trace(p,d))}logUsage(p,d){this.d.isUsageEnabled&&this.k(p,d)}logError(p,d){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof p=="string")this.k(p,d);else{const b={name:p.name,message:p.message,stack:p.stack,cause:p.cause},t=(0,o.$Kp)(b,[]),l=new Error(t.message,{cause:t.cause});l.stack=t.stack,l.name=t.name,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f.sendErrorData(l,d),this.h.trace("exception",d)}}get apiTelemetryLogger(){if(!this.e){const p=this,d={logUsage:p.logUsage.bind(p),get isUsageEnabled(){return p.d.isUsageEnabled},get isErrorsEnabled(){return p.d.isErrorsEnabled},logError:p.logError.bind(p),dispose:p.dispose.bind(p),onDidChangeEnableStates:p.a.event.bind(p)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let p=this.f;this.f=void 0,Promise.resolve(p.flush()).then(p=void 0),this.e=void 0}else this.f=void 0}}e.$hQ=h;function m($){const p=Date.now()-new Date($).getTime();return isNaN(p)?!1:p<1e3*60*60*24}e.$jQ=(0,n.$Gi)("IExtHostTelemetry")}),define(Se[315],ke([1,0,6,4,39,131,22,5]),function(se,e,n,r,E,I,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.ActivationKind=e.$0G=e.$9G=e.$6G=e.ExtensionHostStartup=e.$5G=e.$4G=e.$3G=e.$2G=void 0,e.$7G=f,e.$8G=w,e.$$G=$,e.$_G=p,e.$2G=Object.freeze({identifier:new R.$sn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:r.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$3G="extensions.webWorker",e.$4G=(0,A.$Gi)("extensionService");class y{constructor(t){this.dependency=t}}e.$5G=y;var o;(function(b){b[b.EagerAutoStart=1]="EagerAutoStart",b[b.EagerManualStart=2]="EagerManualStart",b[b.Lazy=3]="Lazy"})(o||(e.ExtensionHostStartup=o={}));class S{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,l,i){this.c=t,this.d=l.slice(0),this.e=i.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$NG.createActivationEventsMap(this.d)}}set(t,l,i){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const g=[],s=[],c=[],u=[],D=v(this.d),P=v(l),T=(Y,J)=>Y.extensionLocation.toString()===J.extensionLocation.toString()||Y.isBuiltin===J.isBuiltin||Y.isUserBuiltin===J.isUserBuiltin||Y.isUnderDevelopment===J.isUnderDevelopment;for(const Y of this.d){const J=P.get(Y.identifier);if(!J){g.push(Y.identifier),D.delete(Y.identifier);continue}if(!T(Y,J)){g.push(Y.identifier),D.delete(Y.identifier);continue}}for(const Y of l){const J=D.get(Y.identifier);if(!J){s.push(Y);continue}if(!T(J,Y)){g.push(J.identifier),D.delete(J.identifier);continue}}const z=new R.$tn(this.e),C=new R.$tn(i);for(const Y of this.e)C.has(Y)||c.push(Y);for(const Y of i)z.has(Y)||u.push(Y);const k=I.$NG.createActivationEventsMap(s),q={versionId:t,toRemove:g,toAdd:s,addActivationEvents:k,myToRemove:c,myToAdd:u};return this.delta(q),q}delta(t){if(this.c>=t.versionId)return null;const{toRemove:l,toAdd:i,myToRemove:g,myToAdd:s}=t,c=new R.$tn(l),u=new R.$tn(g);for(let D=0;D<this.d.length;D++)c.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)u.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of i)this.d.push(D);for(const D of s)this.e.push(D);return this.f=null,t}containsExtension(t){for(const l of this.e)if(R.$sn.equals(l,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const l of this.d){if(!this.containsExtension(l.identifier))continue;const i=I.$NG.readActivationEvents(l);for(const g of i)t.add(g)}return t}}e.$6G=S;function v(b){const t=new R.$un;for(const l of b)t.set(l.identifier,l);return t}function f(b,t){return!0}function w(b,t){if(!f(b,t))throw new Error(`Extension '${b.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${b.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${b.identifier.value}`)}class a{constructor(t,l,i,g){this.codeLoadingTime=t,this.activateCallTime=l,this.activateResolvedTime=i,this.activationReason=g}}e.$9G=a;class h{constructor(t,l){this.description=t,this.value=l}}e.$0G=h;var m;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function $(b){return{type:b.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,E.$Qp)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation,targetPlatform:b.targetPlatform,validations:[],isValid:!0}}function p(b,t){const l=(0,E.$Op)(b.manifest.publisher,b.manifest.name);return{id:l,identifier:new R.$sn(l),isBuiltin:b.type===R.ExtensionType.System,isUserBuiltin:b.type===R.ExtensionType.User&&b.isBuiltin,isUnderDevelopment:!!t,extensionLocation:b.location,uuid:b.identifier.uuid,targetPlatform:b.targetPlatform,publisherDisplayName:b.publisherDisplayName,...b.manifest}}class d{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.onWillStop=n.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,l){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,l){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$aH=d});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[316],ke([1,0,237,10,58,30,128,38,22,29,131,120]),function(se,e,n,r,E,I,R,A,y,o,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=void 0,n=Be(n),E=$t(E);const f=A.$so.as(R.$to.JSONContribution);class w{constructor(t,l,i){this.a=t,this.b=l,this.c=i}d(t,l){this.a({type:t,message:l,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(E.default.Error,t)}warn(t){this.d(E.default.Warning,t)}info(t){this.d(E.default.Info,t)}}e.$VG=w;class a{static a(t){const l=new y.$tn;for(let i=0,g=t.length;i<g;i++)l.add(t[i].description.identifier);return l}static compute(t,l){if(!t||!t.length)return new a(l,[]);if(!l||!l.length)return new a([],t);const i=this.a(t),g=this.a(l),s=l.filter(u=>!i.has(u.description.identifier)),c=t.filter(u=>!g.has(u.description.identifier));return new a(s,c)}constructor(t,l){this.added=t,this.removed=l}}e.$WG=a;class h{constructor(t,l){this.name=t,this.defaultExtensionKind=l,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=a.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,r.$3)(t)}}}e.$XG=h;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},$="vscode://schemas/vscode-extensions";e.$YG={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.$rn},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals).map(b=>b),markdownEnumDescriptions:Object.values(v.allApiProposals).map(b=>b.proposal)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:n.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:n.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:n.localize(44,null)},{label:"*",description:n.localize(45,null),body:"*"}]}},badges:{type:"array",description:n.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(47,null)},href:{type:"string",description:n.localize(48,null)},description:{type:"string",description:n.localize(49,null)}}}},markdown:{type:"string",description:n.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$0o}},extensionPack:{description:n.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$0o}},extensionKind:{description:n.localize(54,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(55,null)},{body:["workspace"],description:n.localize(56,null)},{body:["ui","workspace"],description:n.localize(57,null)},{body:["workspace","ui"],description:n.localize(58,null)},{body:[],description:n.localize(59,null)}]},capabilities:{description:n.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)]},description:{type:"string",markdownDescription:n.localize(66,null)}}},untrustedWorkspaces:{description:n.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(69,null),n.localize(70,null),n.localize(71,null)]},restrictedConfigurations:{description:n.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(73,null)}}}}},sponsor:{description:n.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(76,null),type:"string"},"vscode:uninstall":{description:n.localize(77,null),type:"string"}}},icon:{type:"string",description:n.localize(78,null)},l10n:{type:"string",description:n.localize(79,null)},pricing:{type:"string",markdownDescription:n.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class p{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const l=new h(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,l),t.activationEventsGenerator&&S.$NG.register(t.extensionPoint,t.activationEventsGenerator),e.$YG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,f.registerSchema($,e.$YG),l}getExtensionPoints(){return Array.from(this.a.values())}}e.$ZG=p;const d={ExtensionsRegistry:"ExtensionsRegistry"};A.$so.add(d.ExtensionsRegistry,new p),e.$1G=A.$so.as(d.ExtensionsRegistry),f.registerSchema($,e.$YG),f.registerSchema(o.$uk,{properties:{extensionEnabledApiProposals:{description:n.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals).map(b=>b.proposal)}}]}}}})}),define(Se[317],ke([1,0,6,40,2,17,234,22,5,12,315,316]),function(se,e,n,r,E,I,R,A,y,o,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=e.$cH=e.$bH=e.ChatMessageRole=void 0;var f;(function(h){h[h.System=0]="System",h[h.User=1]="User",h[h.Assistant=2]="Assistant"})(f||(e.ChatMessageRole=f={})),e.$bH=(0,y.$Gi)("ILanguageModelsService");const w={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(0,null)}}};e.$cH=v.$1G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(1,null),oneOf:[w,{type:"array",items:w}]},activationEventsGenerator:(h,m)=>{for(const $ of h)m.push(`onLanguageModelChat:${$.vendor}`)}});let a=class{constructor(m,$){this.e=m,this.f=$,this.a=new E.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new n.$ne),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$cH.setHandler(p=>{this.c.clear();for(const b of p){if(!(0,S.$7G)(b.description,"chatProvider")){b.collector.error((0,R.localize)(2,null));continue}for(const t of r.Iterable.wrap(b.value)){if(this.c.has(t.vendor)){b.collector.error((0,R.localize)(3,null,t.vendor));continue}if((0,I.$ef)(t.vendor)){b.collector.error((0,R.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){b.collector.error((0,R.localize)(5,null));continue}this.c.add(t.vendor)}}const d=[];for(const[b,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(b),d.push(b));d.length>0&&this.d.fire({removed:d})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const p=Array.from(this.c).map(d=>this.e.activateByEvent(`onLanguageModelChat:${d}`));await Promise.all(p)}const $=[];for(const[p,d]of this.b)(m.vendor===void 0||d.metadata.vendor===m.vendor)&&(m.family===void 0||d.metadata.family===m.family)&&(m.version===void 0||d.metadata.version===m.version)&&(m.identifier===void 0||d.metadata.id===m.identifier)&&(!d.metadata.targetExtensions||d.metadata.targetExtensions.some(b=>A.$sn.equals(b,m.extension)))&&$.push(p);return this.f.trace("[LM] selected language models",m,$),$}registerLanguageModelChat(m,$){if(this.f.trace("[LM] registering language model chat",m,$.metadata),!this.c.has($.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${$.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,$),this.d.fire({added:[{identifier:m,metadata:$.metadata}]}),(0,E.$Vc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,$.metadata))})}async sendChatRequest(m,$,p,d,b){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest(p,$,d,b)}computeTokenLength(m,$,p){const d=this.b.get(m);if(!d)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return d.provideTokenCount($,p)}};e.$dH=a,e.$dH=a=ze([Fe(0,S.$4G),Fe(1,o.$ak)],a)}),define(Se[318],ke([1,0,22,238,63]),function(se,e,n,r,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rR=I,E=Be(E);function I(R,A,y,o,S){const v=new n.$un;return R.forEach(f=>{const w=v.get(f.identifier);w&&S.warn((0,r.localize)(0,null,w.extensionLocation.fsPath,f.extensionLocation.fsPath)),v.set(f.identifier,f)}),A.forEach(f=>{const w=v.get(f.identifier);if(w)if(w.isBuiltin){if(E.gte(w.version,f.version)){S.warn(`Skipping extension ${f.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}f.isBuiltin=!0}else S.warn((0,r.localize)(1,null,w.extensionLocation.fsPath,f.extensionLocation.fsPath));else if(f.isBuiltin){S.warn(`Skipping obsolete builtin extension ${f.extensionLocation.path}`);return}v.set(f.identifier,f)}),y.forEach(f=>{const w=v.get(f.identifier);w&&S.warn((0,r.localize)(2,null,w.extensionLocation.fsPath,f.extensionLocation.fsPath)),v.set(f.identifier,f)}),o.forEach(f=>{S.info((0,r.localize)(3,null,f.extensionLocation.fsPath));const w=v.get(f.identifier);w&&w.isBuiltin&&(f.isBuiltin=!0),v.set(f.identifier,f)}),Array.from(v.values())}}),define(Se[319],ke([1,0,9,3,32,4,44,59,42,64,22,318,13]),function(se,e,n,r,E,I,R,A,y,o,S,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vR=e.$uR=void 0,r=Be(r),R=Be(R);class w{constructor(m,$,p,d,b,t,l){this.c=m,this.d=p,this.f=d,this.g=b,this.h=t,this.i=l,this.a=Promise.resolve(),this.b=Promise.resolve();const i=$.args["install-builtin-extension"];if(i){b.trace("Installing builtin extensions passed via args...");const s={isMachineScoped:!!$.args["do-not-sync"],installPreReleaseVersion:!!$.args["pre-release"]};R.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=m.installExtensions([],this.j(i),s,!!$.args.force).then(()=>{R.mark("code/server/didInstallBuiltinExtensions"),b.trace("Finished installing builtin extensions")},c=>{b.error(c)})}const g=$.args["install-extension"];g&&(b.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>m.installExtensions(this.j(g),[],{isMachineScoped:!!$.args["do-not-sync"],installPreReleaseVersion:!!$.args["pre-release"],isApplicationScoped:!0},!!$.args.force)).then(()=>{b.trace("Finished installing extensions")},s=>{b.error(s)}))}j(m){return m.map($=>/\.vsix$/i.test($)?I.URI.file((0,n.$lc)($)?$:(0,n.$mc)((0,E.cwd)(),$)):$)}whenExtensionsReady(){return this.b}async scanExtensions(m,$,p,d,b){R.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${m}`),await this.a;const t=d?d.filter(i=>i.scheme===f.Schemas.file).map(i=>i.fsPath):void 0;$=$??this.d.defaultProfile.extensionsResource;const l=await this.k($,m??r.$q,p,t,b);return this.g.trace("Scanned Extensions",l),this.r(l),R.mark("code/server/didScanExtensions"),l}async k(m,$,p,d,b){await this.q($,b);const[t,l,i,g]=await Promise.all([this.n($),this.o(m,$),this.m($,p),this.l($,d)]);return(0,v.$rR)(t,l,i,g,this.g)}async l(m,$){return $?(await Promise.all($.map(p=>this.f.scanOneOrMultipleExtensions(I.URI.file((0,n.$nc)(p)),S.ExtensionType.User,{language:m})))).flat().map(p=>(0,o.$Pq)(p,!0)):[]}async m(m,$){const p=[];if($?.length){const d=await Promise.all($.map(b=>this.f.scanExistingExtension(b,S.ExtensionType.User,{language:m})));for(const b of d)b&&p.push((0,o.$Pq)(b,!1))}return p}async n(m){return(await this.f.scanSystemExtensions({language:m,useCache:!0})).map(p=>(0,o.$Pq)(p,!1))}async o(m,$){return(await this.f.scanUserExtensions({profileLocation:m,language:$,useCache:!0})).map(d=>(0,o.$Pq)(d,!1))}async q(m,$){if(!(m===r.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(d=>d.id===m)){this.g.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(p){this.g.error(p)}if(!$){this.g.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${$} for language ${m} is not installed. It will be installed now.`);try{await this.c.installExtensions([$],[],{isMachineScoped:!0},!0)}catch(p){this.g.error(p)}}}r(m){const $=(i,g)=>i.replace(/file/g,"vscode-remote"),p=i=>{let g="";return g+=i.global?"g":"",g+=i.ignoreCase?"i":"",g+=i.multiline?"m":"",new RegExp($(i.source,!0),g)},d=new class{mapDefined(i){return y.$Jj.create(i)}mapNot(i){return y.$Oj.create(i)}mapEquals(i,g){return i==="resourceScheme"&&typeof g=="string"?y.$Kj.create(i,$(g,!1)):y.$Kj.create(i,g)}mapNotEquals(i,g){return i==="resourceScheme"&&typeof g=="string"?y.$Nj.create(i,$(g,!1)):y.$Nj.create(i,g)}mapGreater(i,g){return y.$Pj.create(i,g)}mapGreaterEquals(i,g){return y.$Qj.create(i,g)}mapSmaller(i,g){return y.$Rj.create(i,g)}mapSmallerEquals(i,g){return y.$Sj.create(i,g)}mapRegex(i,g){return i==="resourceScheme"&&g?y.$Tj.create(i,p(g)):y.$Tj.create(i,g)}mapIn(i,g){return y.$Lj.create(i,g)}mapNotIn(i,g){return y.$Mj.create(i,g)}},b=i=>{if(!i||!i.when||!/resourceScheme/.test(i.when))return;const g=y.$Ej.deserialize(i.when);if(!g)return;const s=g.map(d);i.when=s.serialize()},t=i=>{if(Array.isArray(i))for(const g of i)b(g);else b(i)},l=i=>{for(const g in i)t(i[g])};m.forEach(i=>{i.contributes&&(i.contributes.menus&&l(i.contributes.menus),i.contributes.keybindings&&t(i.contributes.keybindings),i.contributes.views&&l(i.contributes.views))})}}e.$uR=w;class a{constructor(m,$){this.a=m,this.b=$}listen(m,$){throw new Error("Invalid listen")}async call(m,$,p){const d=this.b(m);switch($){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const b=p[0],t=p[1]?I.URI.revive(d.transformIncoming(p[1])):void 0,l=Array.isArray(p[2])?p[2].map(c=>I.URI.revive(d.transformIncoming(c))):void 0,i=Array.isArray(p[3])?p[3].map(c=>I.URI.revive(d.transformIncoming(c))):void 0,g=p[4];return(await this.a.scanExtensions(b,t,l,i,g)).map(c=>(0,A.$Pn)(c,d))}}throw new Error("Invalid call")}}e.$vR=a}),define(Se[151],ke([1,0]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=e.$Sw=void 0,e.$Tw=E,e.$Uw=I;class n{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++n.count}}e.$Sw=n,n.count=0;const r=[];function E(A){const y=new n(A);return r[y.nid]=y,y}function I(A){return r[A].sid}class R{constructor(y){this.value=y}}e.$Vw=R}),define(Se[320],ke([1,0,151]),function(se,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$uN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var r;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(r||(e.TextEditorRevealType=r={}));var E;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput",h[h.ChatEditorInput=10]="ChatEditorInput",h[h.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(E||(e.TabInputKind=E={}));var I;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var R;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var A;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var y;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var o;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(o||(e.NotebookEditorRevealType=o={}));var S;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output",h[h.Hybrid=3]="Hybrid"})(S||(e.CandidatePortSource=S={}));class v{static mixin(m){return m._id=v.a++,m}}e.$uN=v,v.a=0;var f;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(f||(e.ISuggestDataDtoField=f={}));var w;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var a;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(a||(e.ExtHostTestingResource=a={})),e.$vN={MainThreadAuthentication:(0,n.$Tw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.$Tw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,n.$Tw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,n.$Tw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,n.$Tw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,n.$Tw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,n.$Tw)("MainThreadChatSkills"),MainThreadClipboard:(0,n.$Tw)("MainThreadClipboard"),MainThreadCommands:(0,n.$Tw)("MainThreadCommands"),MainThreadComments:(0,n.$Tw)("MainThreadComments"),MainThreadConfiguration:(0,n.$Tw)("MainThreadConfiguration"),MainThreadConsole:(0,n.$Tw)("MainThreadConsole"),MainThreadDebugService:(0,n.$Tw)("MainThreadDebugService"),MainThreadDecorations:(0,n.$Tw)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.$Tw)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.$Tw)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.$Tw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.$Tw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.$Tw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.$Tw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.$Tw)("MainThreadEditorTabs"),MainThreadErrors:(0,n.$Tw)("MainThreadErrors"),MainThreadTreeViews:(0,n.$Tw)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.$Tw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,n.$Tw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.$Tw)("MainThreadLanguages"),MainThreadLogger:(0,n.$Tw)("MainThreadLogger"),MainThreadMessageService:(0,n.$Tw)("MainThreadMessageService"),MainThreadOutputService:(0,n.$Tw)("MainThreadOutputService"),MainThreadProgress:(0,n.$Tw)("MainThreadProgress"),MainThreadQuickDiff:(0,n.$Tw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.$Tw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.$Tw)("MainThreadStatusBar"),MainThreadSecretState:(0,n.$Tw)("MainThreadSecretState"),MainThreadStorage:(0,n.$Tw)("MainThreadStorage"),MainThreadSpeech:(0,n.$Tw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,n.$Tw)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.$Tw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,n.$Tw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,n.$Tw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.$Tw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.$Tw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.$Tw)("MainThreadCustomEditors"),MainThreadUrls:(0,n.$Tw)("MainThreadUrls"),MainThreadUriOpeners:(0,n.$Tw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.$Tw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.$Tw)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.$Tw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,n.$Tw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,n.$Tw)("MainThreadExtensionService"),MainThreadSCM:(0,n.$Tw)("MainThreadSCM"),MainThreadSearch:(0,n.$Tw)("MainThreadSearch"),MainThreadShare:(0,n.$Tw)("MainThreadShare"),MainThreadTask:(0,n.$Tw)("MainThreadTask"),MainThreadWindow:(0,n.$Tw)("MainThreadWindow"),MainThreadLabelService:(0,n.$Tw)("MainThreadLabelService"),MainThreadNotebook:(0,n.$Tw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.$Tw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.$Tw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.$Tw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.$Tw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.$Tw)("MainThreadInteractive"),MainThreadTheming:(0,n.$Tw)("MainThreadTheming"),MainThreadTunnelService:(0,n.$Tw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,n.$Tw)("MainThreadManagedSockets"),MainThreadTimeline:(0,n.$Tw)("MainThreadTimeline"),MainThreadTesting:(0,n.$Tw)("MainThreadTesting"),MainThreadLocalization:(0,n.$Tw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,n.$Tw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,n.$Tw)("MainThreadAiEmbeddingVector")},e.$wN={ExtHostCommands:(0,n.$Tw)("ExtHostCommands"),ExtHostConfiguration:(0,n.$Tw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.$Tw)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.$Tw)("ExtHostDebugService"),ExtHostDecorations:(0,n.$Tw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.$Tw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.$Tw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.$Tw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.$Tw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.$Tw)("ExtHostEditors"),ExtHostTreeViews:(0,n.$Tw)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.$Tw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.$Tw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.$Tw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.$Tw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.$Tw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.$Tw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.$Tw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,n.$Tw)("ExtHostStatusBar"),ExtHostShare:(0,n.$Tw)("ExtHostShare"),ExtHostExtensionService:(0,n.$Tw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.$Tw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.$Tw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,n.$Tw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,n.$Tw)("ExtHostSCM"),ExtHostSearch:(0,n.$Tw)("ExtHostSearch"),ExtHostTask:(0,n.$Tw)("ExtHostTask"),ExtHostWorkspace:(0,n.$Tw)("ExtHostWorkspace"),ExtHostWindow:(0,n.$Tw)("ExtHostWindow"),ExtHostWebviews:(0,n.$Tw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.$Tw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.$Tw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.$Tw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.$Tw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.$Tw)("ExtHostEditorTabs"),ExtHostProgress:(0,n.$Tw)("ExtHostProgress"),ExtHostComments:(0,n.$Tw)("ExtHostComments"),ExtHostSecretState:(0,n.$Tw)("ExtHostSecretState"),ExtHostStorage:(0,n.$Tw)("ExtHostStorage"),ExtHostUrls:(0,n.$Tw)("ExtHostUrls"),ExtHostUriOpeners:(0,n.$Tw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.$Tw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.$Tw)("ExtHostOutputService"),ExtHostLabelService:(0,n.$Tw)("ExtHostLabelService"),ExtHostNotebook:(0,n.$Tw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.$Tw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.$Tw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.$Tw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.$Tw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,n.$Tw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,n.$Tw)("ExtHostInteractive"),ExtHostChatAgents2:(0,n.$Tw)("ExtHostChatAgents"),ExtHostChatVariables:(0,n.$Tw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,n.$Tw)("ExtHostChatSkills"),ExtHostChatProvider:(0,n.$Tw)("ExtHostChatProvider"),ExtHostSpeech:(0,n.$Tw)("ExtHostSpeech"),ExtHostEmbeddings:(0,n.$Tw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,n.$Tw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,n.$Tw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,n.$Tw)("ExtHostTheming"),ExtHostTunnelService:(0,n.$Tw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,n.$Tw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,n.$Tw)("ExtHostAuthentication"),ExtHostTimeline:(0,n.$Tw)("ExtHostTimeline"),ExtHostTesting:(0,n.$Tw)("ExtHostTesting"),ExtHostTelemetry:(0,n.$Tw)("ExtHostTelemetry"),ExtHostLocalization:(0,n.$Tw)("ExtHostLocalization")}}),define(Se[321],ke([1,0,15,26,13,121,5]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.$fL=void 0,e.$gL=S,e.$hL=v,e.$fL=(0,R.$Gi)("notebookDocumentService");const A=["W","X","Y","Z","a","b","c","d","e","f"],y=new RegExp(`^[${A.join("")}]+`),o=7;function S(w){if(w.scheme!==E.Schemas.vscodeNotebookCell)return;const a=w.fragment.indexOf("s");if(a<0)return;const h=parseInt(w.fragment.substring(0,a).replace(y,""),o),m=(0,n.$9e)(w.fragment.substring(a+1)).toString();if(!isNaN(h))return{handle:h,notebook:w.with({scheme:m,fragment:null})}}function v(w,a){const h=a.toString(o),$=`${h.length<A.length?A[h.length-1]:"z"}${h}s${(0,n.$0e)(n.$Pe.fromString(w.scheme),!0,!0)}`;return w.with({scheme:E.Schemas.vscodeNotebookCell,fragment:$})}class f{constructor(){this.a=new r.$Dc}getNotebook(a){if(a.scheme===E.Schemas.vscodeNotebookCell){const h=S(a);if(h){const m=this.a.get(h.notebook);if(m)return m}}return this.a.get(a)}addNotebookDocument(a){this.a.set(a.uri,a)}removeNotebookDocument(a){this.a.delete(a.uri)}}e.$iL=f,(0,I.$Qs)(e.$fL,f,I.InstantiationType.Delayed)}),define(Se[152],ke([1,0,15,83,40,66,13,9,3,42,321]),function(se,e,n,r,E,I,R,A,y,o,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$zL=e.CellStatusbarAlignment=e.$yL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$vL=e.$uL=e.$sL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$rL=e.$qL=e.$pL=e.$oL=e.CellKind=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=void 0,e.$tL=i,e.$wL=c,e.$xL=u,e.$AL=T,e.$BL=C,r=Be(r),e.$jL="workbench.editor.notebook",e.$kL="workbench.editor.notebookTextDiffEditor",e.$lL="workbench.editor.interactive",e.$mL="workbench.editor.repl",e.$nL="replNotebook.input.execute";var v;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(v||(e.CellKind=v={})),e.$oL=["application/json","application/javascript","text/html","image/svg+xml",I.$0s.latex,I.$0s.markdown,"image/png","image/jpeg",I.$0s.text],e.$pL=[I.$0s.latex,I.$0s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$0s.text],e.$qL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$rL="_notAvailable";var f;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(f||(e.NotebookRunState=f={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var a;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(a||(e.NotebookExecutionState=a={}));var h;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(h||(e.NotebookRendererMatch=h={}));var m;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var $;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})($||(e.NotebookCellsChangeType=$={}));var p;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(p||(e.SelectionStateType=p={}));var d;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var b;(function(K){K.scheme=R.Schemas.vscodeNotebookCell;function ae(W,ue){return(0,S.$hL)(W,ue)}K.generate=ae;function M(W){return(0,S.$gL)(W)}K.parse=M;function B(W,ue){return W.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${W.scheme!==R.Schemas.file?W.scheme:""}`})}K.generateCellOutputUri=B;function re(W){if(W.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(W.fragment);if(!ue)return;const _=ue[1]&&ue[1]!==""?ue[1]:void 0,U=ue[2];return{outputId:_,notebook:W.with({scheme:U||R.Schemas.file,fragment:null})}}K.parseCellOutputUri=re;function ce(W,ue,_){return K.generate(W,ue).with({scheme:_})}K.generateCellPropertyUri=ce;function pe(W,ue){if(W.scheme===ue)return K.parse(W.with({scheme:K.scheme}))}K.parseCellPropertyUri=pe})(b||(e.CellUri=b={}));const t=K=>y.$c?K.replace(/\//g,"\\"):K;class l{constructor(ae=[],M=e.$oL){this.e=M,this.d=[...new Set(ae)].map(B=>({pattern:B,matches:r.$Ak(t(B))}))}sort(ae){const M=new Map(E.Iterable.map(ae,re=>[re,t(re)]));let B=[];for(const{matches:re}of this.d)for(const[ce,pe]of M)if(re(pe)){B.push(ce),M.delete(ce);break}return M.size&&(B=B.concat([...M.keys()].sort((re,ce)=>this.e.indexOf(re)-this.e.indexOf(ce)))),B}prioritize(ae,M){const B=this.f(ae);if(B===-1){this.d.unshift({pattern:ae,matches:r.$Ak(t(ae))});return}const re=new Set(M.map(pe=>this.f(pe,B)));re.delete(-1);const ce=Array.from(re).sort();this.d.splice(B+1,0,...ce.map(pe=>this.d[pe]));for(let pe=ce.length-1;pe>=0;pe--)this.d.splice(ce[pe],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,M=this.d.length){const B=t(ae);for(let re=0;re<M;re++)if(this.d[re].matches(B))return re;return-1}}e.$sL=l;function i(K,ae,M,B=(re,ce)=>re===ce){const re=[];function ce(ue,_,U){if(_===0&&U.length===0)return;const O=re[re.length-1];O&&O.start+O.deleteCount===ue?(O.deleteCount+=_,O.toInsert.push(...U)):re.push({start:ue,deleteCount:_,toInsert:U})}let pe=0,W=0;for(;;){if(pe===K.length){ce(pe,0,ae.slice(W));break}if(W===ae.length){ce(pe,K.length-pe,[]);break}const ue=K[pe],_=ae[W];if(B(ue,_)){pe+=1,W+=1;continue}M(_)?(ce(pe,1,[]),pe+=1):(ce(pe,0,[_]),W+=1)}return re}e.$uL=new o.$Xj("notebookEditorCursorAtBoundary","none"),e.$vL=new o.$Xj("notebookEditorCursorAtLineBoundary","none");var g;(function(K){K.default="default",K.option="option"})(g||(e.NotebookEditorPriority=g={}));var s;(function(K){K.Cells="cells",K.Text="text",K.None="none"})(s||(e.NotebookFindScopeType=s={}));function c(K){const ae=K;return!!((typeof ae.include=="string"||r.$Bk(ae.include))&&(typeof ae.exclude=="string"||r.$Bk(ae.exclude)))}function u(K,ae,M){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ae)>=0||K.viewType===ae)return!0;if(K.filenamePattern){const B=c(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,re=c(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(r.$zk(B,(0,A.$qc)(M.fsPath).toLowerCase()))return!(re&&r.$zk(re,(0,A.$qc)(M.fsPath).toLowerCase()))}return!1}e.$yL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class P{static create(ae){return`${P.d}${ae}`}static parse(ae){if(ae.startsWith(P.d))return ae.substring(P.d.length)}}e.$zL=P,P.d="notebook/";function T(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const z=new TextDecoder;function C(K){const ae=[];let M=!1;for(const pe of K)(ae.length===0||M)&&(ae.push(pe),M=!0);let B=Y(ae);const re=n.$Pe.concat(ae.map(pe=>n.$Pe.wrap(pe))),ce=le(re);return B=B||ce.byteLength!==re.byteLength,{data:ce,didCompression:B}}e.$CL="\x1B[A";const k=e.$CL.split("").map(K=>K.charCodeAt(0)),q=10;function Y(K){let ae=!1;return K.forEach((M,B)=>{if(B===0||M.length<e.$CL.length)return;const re=K[B-1],ce=M.subarray(0,e.$CL.length);if(ce[0]===k[0]&&ce[1]===k[1]&&ce[2]===k[2]){const pe=re.lastIndexOf(q);if(pe===-1)return;ae=!0,K[B-1]=re.subarray(0,pe),K[B]=M.subarray(e.$CL.length)}}),ae}function J(K){let ae=K;do K=ae,ae=K.replace(/[^\n]\x08/gm,"");while(ae.length<K.length);return K}function ne(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ae=K.match(/^(.*)\r+/m)[1];let M=K.match(/\r+(.*)$/m)[1];M=M+ae.slice(M.length,ae.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,M)}return K}const Z=8,x=13;function le(K){return!K.buffer.includes(Z)&&!K.buffer.includes(x)?K:n.$Pe.fromString(ne(J(z.decode(K.buffer))))}});var ln=this&&this.__classPrivateFieldSet||function(se,e,n,r,E){if(r==="m")throw new TypeError("Private method is not writable");if(r==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return r==="a"?E.call(se,n):E?E.value=n:e.set(se,n),n},ft=this&&this.__classPrivateFieldGet||function(se,e,n,r){if(n==="a"&&!r)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!r:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?r:n==="a"?r.call(se):r?r.value:e.get(se)};define(Se[153],ke([1,0,18,10,111,26,66,17,11,4,23,22,16,90,152]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a){"use strict";var h,m,$,p,d,b,t,l,i,g,s,c,u,D,P,T,z,C,k,q,Y,J,ne,Z,x;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$QP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$tP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$sP=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$gP=e.$fP=e.$eP=e.$dP=e.$bP=e.$aP=e.$_O=e.$$O=e.TestRunProfileKind=e.TestResultState=e.$0O=e.$9O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$8O=e.NotebookVariablesRequestKind=e.$7O=e.$6O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$5O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.ColorThemeKind=e.$YO=e.$XO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$WO=e.$VO=e.DebugConsoleMode=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PO=e.$OO=e.FileChangeType=e.$NO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$MO=e.$LO=e.$KO=e.$JO=e.InlineCompletionTriggerKind=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$wO=e.ConfigurationTarget=e.$vO=e.$uO=e.$tO=e.$sO=e.DocumentPasteTriggerKind=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$lO=e.ViewBadge=e.ProgressLocation=e.$kO=e.$jO=e.TaskScope=e.ShellQuoting=e.$iO=e.$hO=e.$gO=e.TaskPanelKind=e.TaskRevealKind=e.$fO=e.TerminalLocation=e.$eO=e.$dO=e.$cO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$bO=e.$aO=e.$_N=e.$$N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$9N=e.$8N=e.$7N=e.$6N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$5N=e.$4N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.LanguageStatusSeverity=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.CodeActionTriggerKind=e.$RN=e.$QN=e.SymbolTag=e.SymbolKind=e.$PN=e.$ON=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.DiagnosticSeverity=e.DiagnosticTag=e.$IN=e.$HN=e.FileEditType=e.$GN=e.$FN=e.$EN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$0N=dt,e.$xO=Te,e.$cP=vi;function le(F){return Object.assign(F,{apply:function(...he){if(he.length===0)return Reflect.construct(F,[]);{const Pe=he.length===1?[]:he[1];return Reflect.construct(F,Pe,he[0].constructor)}},call:function(...he){if(he.length===0)return Reflect.construct(F,[]);{const[Pe,...Ve]=he;return Reflect.construct(F,Ve,Pe.constructor)}}})}var K;(function(F){F[F.Top=0]="Top",F[F.Bottom=1]="Bottom"})(K||(e.TerminalOutputAnchor=K={}));var ae;(function(F){F[F.TerminalCommand=0]="TerminalCommand",F[F.Opener=1]="Opener",F[F.Command=3]="Command"})(ae||(e.TerminalQuickFixType=ae={}));let M=i=class{static from(...L){let he=L;return new i(function(){if(he){for(const Pe of he)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();he=void 0}})}constructor(L){h.set(this,void 0),ln(this,h,L,"f")}dispose(){typeof ft(this,h,"f")=="function"&&(ft(this,h,"f").call(this),ln(this,h,void 0,"f"))}};e.$xN=M,h=new WeakMap,e.$xN=M=i=ze([le],M);let B=g=class{static Min(...L){if(L.length===0)throw new TypeError;let he=L[0];for(let Pe=1;Pe<L.length;Pe++){const Ve=L[Pe];Ve.isBefore(he)&&(he=Ve)}return he}static Max(...L){if(L.length===0)throw new TypeError;let he=L[0];for(let Pe=1;Pe<L.length;Pe++){const Ve=L[Pe];Ve.isAfter(he)&&(he=Ve)}return he}static isPosition(L){if(!L)return!1;if(L instanceof g)return!0;const{line:he,character:Pe}=L;return typeof he=="number"&&typeof Pe=="number"}static of(L){if(L instanceof g)return L;if(this.isPosition(L))return new g(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,he){if(L<0)throw(0,r.$0)("line must be non-negative");if(he<0)throw(0,r.$0)("character must be non-negative");this.c=L,this.e=he}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,he=0){if(L===null||he===null)throw(0,r.$0)();let Pe;return typeof L>"u"?Pe=0:typeof L=="number"?Pe=L:(Pe=typeof L.lineDelta=="number"?L.lineDelta:0,he=typeof L.characterDelta=="number"?L.characterDelta:0),Pe===0&&he===0?this:new g(this.line+Pe,this.character+he)}with(L,he=this.character){if(L===null||he===null)throw(0,r.$0)();let Pe;return typeof L>"u"?Pe=this.line:typeof L=="number"?Pe=L:(Pe=typeof L.line=="number"?L.line:this.line,he=typeof L.character=="number"?L.character:this.character),Pe===this.line&&he===this.character?this:new g(Pe,he)}toJSON(){return{line:this.line,character:this.character}}};e.$yN=B,e.$yN=B=g=ze([le],B);let re=s=class{static isRange(L){return L instanceof s?!0:L?B.isPosition(L.start)&&B.isPosition(L.end):!1}static of(L){if(L instanceof s)return L;if(this.isRange(L))return new s(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,he,Pe,Ve){let Ze,ot;if(typeof L=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ve=="number"?(Ze=new B(L,he),ot=new B(Pe,Ve)):B.isPosition(L)&&B.isPosition(he)&&(Ze=B.of(L),ot=B.of(he)),!Ze||!ot)throw new Error("Invalid arguments");Ze.isBefore(ot)?(this.c=Ze,this.e=ot):(this.c=ot,this.e=Ze)}contains(L){return s.isRange(L)?this.contains(L.start)&&this.contains(L.end):B.isPosition(L)?!(B.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const he=B.Max(L.start,this.c),Pe=B.Min(L.end,this.e);if(!he.isAfter(Pe))return new s(he,Pe)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const he=B.Min(L.start,this.c),Pe=B.Max(L.end,this.end);return new s(he,Pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,he=this.end){if(L===null||he===null)throw(0,r.$0)();let Pe;return L?B.isPosition(L)?Pe=L:(Pe=L.start||this.start,he=L.end||this.end):Pe=this.start,Pe.isEqual(this.c)&&he.isEqual(this.end)?this:new s(Pe,he)}toJSON(){return[this.start,this.end]}};e.$zN=re,e.$zN=re=s=ze([le],re);let ce=c=class extends re{static isSelection(L){return L instanceof c?!0:L?re.isRange(L)&&B.isPosition(L.anchor)&&B.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,he,Pe,Ve){let Ze,ot;if(typeof L=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ve=="number"?(Ze=new B(L,he),ot=new B(Pe,Ve)):B.isPosition(L)&&B.isPosition(he)&&(Ze=B.of(L),ot=B.of(he)),!Ze||!ot)throw new Error("Invalid arguments");super(Ze,ot),this.f=Ze,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$AN=ce,e.$AN=ce=c=ze([le],ce);const pe=F=>{if(typeof F!="string"||F.length===0||!/^[0-9A-Za-z_\-]+$/.test(F))throw(0,r.$0)("connectionToken")};class W{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,he,Pe){if(typeof L!="string"||L.length===0)throw(0,r.$0)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,r.$0)("port");typeof Pe<"u"&&pe(Pe),this.host=L,this.port=Math.round(he),this.connectionToken=Pe}}e.$BN=W;class ue{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,he){this.makeConnection=L,this.connectionToken=he,typeof he<"u"&&pe(he)}}e.$CN=ue;class _ extends Error{static NotAvailable(L,he){return new _(L,w.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(L){return new _(L,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,he=w.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(L),this._message=L,this._code=he,this._detail=Pe,Object.setPrototypeOf(this,_.prototype)}}e.$DN=_;var U;(function(F){F[F.LF=1]="LF",F[F.CRLF=2]="CRLF"})(U||(e.EndOfLine=U={}));var O;(function(F){F[F.Replace=1]="Replace",F[F.Append=2]="Append",F[F.Prepend=3]="Prepend"})(O||(e.EnvironmentVariableMutatorType=O={}));let te=u=class{static isTextEdit(L){return L instanceof u?!0:L?re.isRange(L)&&typeof L.newText=="string":!1}static replace(L,he){return new u(L,he)}static insert(L,he){return u.replace(new re(L,L),he)}static delete(L){return u.replace(L,"")}static setEndOfLine(L){const he=new u(new re(new B(0,0),new B(0,0)),"");return he.newEol=L,he}get range(){return this.c}set range(L){if(L&&!re.isRange(L))throw(0,r.$0)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,r.$0)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,r.$0)("newEol");this.f=L}constructor(L,he){this.c=L,this.e=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$EN=te,e.$EN=te=u=ze([le],te);let V=D=class{static isNotebookCellEdit(L){return L instanceof D?!0:L?dn.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,he){return new D(L,he)}static insertCells(L,he){return new D(new dn(L,L),he)}static deleteCells(L){return new D(L,[])}static updateCellMetadata(L,he){const Pe=new D(new dn(L,L),[]);return Pe.newCellMetadata=he,Pe}static updateNotebookMetadata(L){const he=new D(new dn(0,0),[]);return he.newNotebookMetadata=L,he}constructor(L,he){this.range=L,this.newCells=he}};e.$FN=V,e.$FN=V=D=ze([le],V);class j{static isSnippetTextEdit(L){return L instanceof j?!0:L?re.isRange(L.range)&&N.isSnippetString(L.snippet):!1}static replace(L,he){return new j(L,he)}static insert(L,he){return j.replace(new re(L,L),he)}constructor(L,he){this.range=L,this.snippet=he}}e.$GN=j;var G;(function(F){F[F.File=1]="File",F[F.Text=2]="Text",F[F.Cell=3]="Cell",F[F.CellReplace=5]="CellReplace",F[F.Snippet=6]="Snippet"})(G||(e.FileEditType=G={}));let Q=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,he,Pe,Ve){this.c.push({_type:G.File,from:L,to:he,options:Pe,metadata:Ve})}createFile(L,he,Pe){this.c.push({_type:G.File,from:void 0,to:L,options:he,metadata:Pe})}deleteFile(L,he,Pe){this.c.push({_type:G.File,from:L,to:void 0,options:he,metadata:Pe})}e(L,he,Pe){this.c.push({_type:G.Cell,metadata:Pe,uri:L,edit:{editType:a.CellEditType.DocumentMetadata,metadata:he},notebookMetadata:he})}f(L,he,Pe,Ve){const Ze=he.start,ot=he.end;(Ze!==ot||Pe.length>0)&&this.c.push({_type:G.CellReplace,uri:L,index:Ze,count:ot-Ze,cells:Pe,metadata:Ve})}g(L,he,Pe,Ve){this.c.push({_type:G.Cell,metadata:Ve,uri:L,edit:{editType:a.CellEditType.Metadata,index:he,metadata:Pe}})}replace(L,he,Pe,Ve){this.c.push({_type:G.Text,uri:L,edit:new te(he,Pe),metadata:Ve})}insert(L,he,Pe,Ve){this.replace(L,new re(he,he),Pe,Ve)}delete(L,he,Pe){this.replace(L,he,"",Pe)}has(L){return this.c.some(he=>he._type===G.Text&&he.uri.toString()===L.toString())}set(L,he){if(he)for(const Pe of he){if(!Pe)continue;let Ve,Ze;Array.isArray(Pe)?(Ve=Pe[0],Ze=Pe[1]):Ve=Pe,V.isNotebookCellEdit(Ve)?Ve.newCellMetadata?this.g(L,Ve.range.start,Ve.newCellMetadata,Ze):Ve.newNotebookMetadata?this.e(L,Ve.newNotebookMetadata,Ze):this.f(L,Ve.range,Ve.newCells,Ze):j.isSnippetTextEdit(Ve)?this.c.push({_type:G.Snippet,uri:L,range:Ve.range,edit:Ve.snippet,metadata:Ze}):this.c.push({_type:G.Text,uri:L,edit:Ve,metadata:Ze})}else{for(let Pe=0;Pe<this.c.length;Pe++){const Ve=this.c[Pe];switch(Ve._type){case G.Text:case G.Snippet:case G.Cell:case G.CellReplace:Ve.uri.toString()===L.toString()&&(this.c[Pe]=void 0);break}}(0,n.$Lb)(this.c)}}get(L){const he=[];for(const Pe of this.c)Pe._type===G.Text&&Pe.uri.toString()===L.toString()&&he.push(Pe.edit);return he}entries(){const L=new I.$Dc;for(const he of this.c)if(he._type===G.Text){let Pe=L.get(he.uri);Pe||(Pe=[he.uri,[]],L.set(he.uri,Pe)),Pe[1].push(he.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$HN=Q,e.$HN=Q=ze([le],Q);let N=P=class{static isSnippetString(L){return L instanceof P?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=P.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,he=this.e++){if(typeof L=="function"){const Pe=new P;Pe.e=this.e,L(Pe),this.e=Pe.e,L=Pe.value}else L=P.c(L);return this.value+="${",this.value+=he,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,he=this.e++){const Pe=L.map(Ve=>Ve.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(L,he){if(typeof he=="function"){const Pe=new P;Pe.e=this.e,he(Pe),this.e=Pe.e,he=Pe.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,he&&(this.value+=":",this.value+=he),this.value+="}",this}};e.$IN=N,e.$IN=N=P=ze([le],N);var H;(function(F){F[F.Unnecessary=1]="Unnecessary",F[F.Deprecated=2]="Deprecated"})(H||(e.DiagnosticTag=H={}));var oe;(function(F){F[F.Hint=3]="Hint",F[F.Information=2]="Information",F[F.Warning=1]="Warning",F[F.Error=0]="Error"})(oe||(e.DiagnosticSeverity=oe={}));let fe=T=class{static isLocation(L){return L instanceof T?!0:L?re.isRange(L.range)&&o.URI.isUri(L.uri):!1}constructor(L,he){if(this.uri=L,he)if(re.isRange(he))this.range=re.of(he);else if(B.isPosition(he))this.range=new re(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$JN=fe,e.$JN=fe=T=ze([le],fe);let Ee=class{static is(L){return L?typeof L.message=="string"&&L.location&&re.isRange(L.location.range)&&o.URI.isUri(L.location.uri):!1}constructor(L,he){this.location=L,this.message=he}static isEqual(L,he){return L===he?!0:!L||!he?!1:L.message===he.message&&L.location.range.isEqual(he.location.range)&&L.location.uri.toString()===he.location.uri.toString()}};e.$KN=Ee,e.$KN=Ee=ze([le],Ee);let Ne=class{constructor(L,he,Pe=oe.Error){if(!re.isRange(L))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=L,this.message=he,this.severity=Pe}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,he){return L===he?!0:!L||!he?!1:L.message===he.message&&L.severity===he.severity&&L.code===he.code&&L.severity===he.severity&&L.source===he.source&&L.range.isEqual(he.range)&&(0,n.$xb)(L.tags,he.tags)&&(0,n.$xb)(L.relatedInformation,he.relatedInformation,Ee.isEqual)}};e.$LN=Ne,e.$LN=Ne=ze([le],Ne);let de=class{constructor(L,he){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=he}};e.$MN=de,e.$MN=de=ze([le],de);let $e=class extends de{constructor(L,he,Pe,Ve){super(L,he),this.canIncreaseHover=Pe,this.canDecreaseHover=Ve}};e.$NN=$e,e.$NN=$e=ze([le],$e);var Re;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(Re||(e.HoverVerbosityAction=Re={}));var Ce;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(Ce||(e.DocumentHighlightKind=Ce={}));let me=class{constructor(L,he=Ce.Text){this.range=L,this.kind=he}toJSON(){return{range:this.range,kind:Ce[this.kind]}}};e.$ON=me,e.$ON=me=ze([le],me);let Ie=class{constructor(L,he){this.uri=L,this.highlights=he}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$PN=Ie,e.$PN=Ie=ze([le],Ie);var Ae;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(Ae||(e.SymbolKind=Ae={}));var Me;(function(F){F[F.Deprecated=1]="Deprecated"})(Me||(e.SymbolTag=Me={}));let qe=z=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,he,Pe,Ve,Ze){this.name=L,this.kind=he,this.containerName=Ze,typeof Pe=="string"&&(this.containerName=Pe),Ve instanceof fe?this.location=Ve:Pe instanceof re&&(this.location=new fe(Ve,Pe)),z.validate(this)}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};e.$QN=qe,e.$QN=qe=z=ze([le],qe);let Qe=C=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(C.validate)}constructor(L,he,Pe,Ve,Ze){this.name=L,this.detail=he,this.kind=Pe,this.range=Ve,this.selectionRange=Ze,this.children=[],C.validate(this)}};e.$RN=Qe,e.$RN=Qe=C=ze([le],Qe);var Ge;(function(F){F[F.Invoke=1]="Invoke",F[F.Automatic=2]="Automatic"})(Ge||(e.CodeActionTriggerKind=Ge={}));let Ye=class{constructor(L,he){this.title=L,this.kind=he}};e.$SN=Ye,e.$SN=Ye=ze([le],Ye);let We=k=class{constructor(L){this.value=L}append(L){return new k(this.value?this.value+k.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+k.c)}};e.$TN=We,We.c=".",e.$TN=We=k=ze([le],We),We.Empty=new We(""),We.QuickFix=We.Empty.append("quickfix"),We.Refactor=We.Empty.append("refactor"),We.RefactorExtract=We.Refactor.append("extract"),We.RefactorInline=We.Refactor.append("inline"),We.RefactorMove=We.Refactor.append("move"),We.RefactorRewrite=We.Refactor.append("rewrite"),We.Source=We.Empty.append("source"),We.SourceOrganizeImports=We.Source.append("organizeImports"),We.SourceFixAll=We.Source.append("fixAll"),We.Notebook=We.Empty.append("notebook");let rt=class{constructor(L,he){if(this.range=L,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$UN=rt,e.$UN=rt=ze([le],rt);class at{constructor(L,he,Pe,Ve,Ze,ot){this.kind=L,this.name=he,this.detail=Pe,this.uri=Ve,this.range=Ze,this.selectionRange=ot}}e.$VN=at;class nt{constructor(L,he){this.fromRanges=he,this.from=L}}e.$WN=nt;class ct{constructor(L,he){this.fromRanges=he,this.to=L}}e.$XN=ct;var it;(function(F){F[F.Information=0]="Information",F[F.Warning=1]="Warning",F[F.Error=2]="Error"})(it||(e.LanguageStatusSeverity=it={}));let _e=class{constructor(L,he){this.range=L,this.command=he}get isResolved(){return!!this.command}};e.$YN=_e,e.$YN=_e=ze([le],_e);let Je=q=class{static isMarkdownString(L){return L instanceof q?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,he=!1){m.set(this,void 0),ln(this,m,new E.$4k(L,{supportThemeIcons:he}),"f")}get value(){return ft(this,m,"f").value}set value(L){ft(this,m,"f").value=L}get isTrusted(){return ft(this,m,"f").isTrusted}set isTrusted(L){ft(this,m,"f").isTrusted=L}get supportThemeIcons(){return ft(this,m,"f").supportThemeIcons}set supportThemeIcons(L){ft(this,m,"f").supportThemeIcons=L}get supportHtml(){return ft(this,m,"f").supportHtml}set supportHtml(L){ft(this,m,"f").supportHtml=L}get baseUri(){return ft(this,m,"f").baseUri}set baseUri(L){ft(this,m,"f").baseUri=L}appendText(L){return ft(this,m,"f").appendText(L),this}appendMarkdown(L){return ft(this,m,"f").appendMarkdown(L),this}appendCodeblock(L,he){return ft(this,m,"f").appendCodeblock(he??"",L),this}};e.$ZN=Je,m=new WeakMap,e.$ZN=Je=q=ze([le],Je);let et=class{constructor(L,he){this.label=L,this.documentation=he}};e.$1N=et,e.$1N=et=ze([le],et);let be=class{constructor(L,he){this.label=L,this.documentation=he,this.parameters=[]}};e.$2N=be,e.$2N=be=ze([le],be);let Le=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$3N=Le,e.$3N=Le=ze([le],Le);var ve;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(ve||(e.SignatureHelpTriggerKind=ve={}));var ye;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(ye||(e.InlayHintKind=ye={}));let ee=class{constructor(L){this.value=L}};e.$4N=ee,e.$4N=ee=ze([le],ee);let ie=class{constructor(L,he,Pe){this.position=L,this.label=he,this.kind=Pe}};e.$5N=ie,e.$5N=ie=ze([le],ie);var we;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(we||(e.CompletionTriggerKind=we={}));var He;(function(F){F[F.Text=0]="Text",F[F.Method=1]="Method",F[F.Function=2]="Function",F[F.Constructor=3]="Constructor",F[F.Field=4]="Field",F[F.Variable=5]="Variable",F[F.Class=6]="Class",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Unit=10]="Unit",F[F.Value=11]="Value",F[F.Enum=12]="Enum",F[F.Keyword=13]="Keyword",F[F.Snippet=14]="Snippet",F[F.Color=15]="Color",F[F.File=16]="File",F[F.Reference=17]="Reference",F[F.Folder=18]="Folder",F[F.EnumMember=19]="EnumMember",F[F.Constant=20]="Constant",F[F.Struct=21]="Struct",F[F.Event=22]="Event",F[F.Operator=23]="Operator",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue"})(He||(e.CompletionItemKind=He={}));var Ke;(function(F){F[F.Deprecated=1]="Deprecated"})(Ke||(e.CompletionItemTag=Ke={}));let xe=class{constructor(L,he){this.label=L,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$6N=xe,e.$6N=xe=ze([le],xe);let tt=class{constructor(L=[],he=!1){this.items=L,this.isIncomplete=he}};e.$7N=tt,e.$7N=tt=ze([le],tt);let lt=class{constructor(L,he,Pe){this.insertText=L,this.range=he,this.command=Pe}};e.$8N=lt,e.$8N=lt=ze([le],lt);let pt=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$9N=pt,e.$9N=pt=ze([le],pt);var yt;(function(F){F[F.Unknown=0]="Unknown",F[F.Word=1]="Word",F[F.Line=2]="Line",F[F.Suggest=3]="Suggest"})(yt||(e.PartialAcceptTriggerKind=yt={}));var Ht;(function(F){F[F.Active=-1]="Active",F[F.Beside=-2]="Beside",F[F.One=1]="One",F[F.Two=2]="Two",F[F.Three=3]="Three",F[F.Four=4]="Four",F[F.Five=5]="Five",F[F.Six=6]="Six",F[F.Seven=7]="Seven",F[F.Eight=8]="Eight",F[F.Nine=9]="Nine"})(Ht||(e.ViewColumn=Ht={}));var Mt;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(Mt||(e.StatusBarAlignment=Mt={}));function dt(F,L){return`${v.$sn.toKey(F)}.${L}`}var Et;(function(F){F[F.Off=0]="Off",F[F.On=1]="On",F[F.Relative=2]="Relative",F[F.Interval=3]="Interval"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var vt;(function(F){F[F.Manual=1]="Manual",F[F.AfterDelay=2]="AfterDelay",F[F.FocusOut=3]="FocusOut"})(vt||(e.TextDocumentSaveReason=vt={}));var Kt;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var zt;(function(F){F[F.Keyboard=1]="Keyboard",F[F.Mouse=2]="Mouse",F[F.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var St;(function(F){F[F.Undo=1]="Undo",F[F.Redo=2]="Redo"})(St||(e.TextDocumentChangeReason=St={}));var Bt;(function(F){F[F.OpenOpen=0]="OpenOpen",F[F.ClosedClosed=1]="ClosedClosed",F[F.OpenClosed=2]="OpenClosed",F[F.ClosedOpen=3]="ClosedOpen"})(Bt||(e.DecorationRangeBehavior=Bt={})),function(F){function L(he){switch(he){case"keyboard":return F.Keyboard;case"mouse":return F.Mouse;case"api":return F.Command}}F.fromValue=L}(zt||(e.TextEditorSelectionChangeKind=zt={}));var Ot;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(F){function L(he){switch(he){case F.Other:return"other";case F.Comment:return"comment";case F.String:return"string";case F.RegEx:return"regex"}return"other"}F.toString=L}(Ot||(e.SyntaxTokenType=Ot={}));let ut=class{constructor(L,he){if(he&&!o.URI.isUri(he))throw(0,r.$0)("target");if(!re.isRange(L)||L.isEmpty)throw(0,r.$0)("range");this.range=L,this.target=he}};e.$$N=ut,e.$$N=ut=ze([le],ut);let mt=class{constructor(L,he,Pe,Ve){this.red=L,this.green=he,this.blue=Pe,this.alpha=Ve}};e.$_N=mt,e.$_N=mt=ze([le],mt);let bt=class{constructor(L,he){if(he&&!(he instanceof mt))throw(0,r.$0)("color");if(!re.isRange(L)||L.isEmpty)throw(0,r.$0)("range");this.range=L,this.color=he}};e.$aO=bt,e.$aO=bt=ze([le],bt);let Pt=class{constructor(L){if(!L||typeof L!="string")throw(0,r.$0)("label");this.label=L}};e.$bO=Pt,e.$bO=Pt=ze([le],Pt);var Xt;(function(F){F[F.RGB=0]="RGB",F[F.HEX=1]="HEX",F[F.HSL=2]="HSL"})(Xt||(e.ColorFormat=Xt={}));var Lt;(function(F){F[F.Error=0]="Error",F[F.Warning=1]="Warning",F[F.Information=2]="Information"})(Lt||(e.SourceControlInputBoxValidationType=Lt={}));var Nt;(function(F){F[F.Unknown=0]="Unknown",F[F.Shutdown=1]="Shutdown",F[F.Process=2]="Process",F[F.User=3]="User",F[F.Extension=4]="Extension"})(Nt||(e.TerminalExitReason=Nt={}));var Ut;(function(F){F[F.Low=0]="Low",F[F.Medium=1]="Medium",F[F.High=2]="High"})(Ut||(e.TerminalShellExecutionCommandLineConfidence=Ut={}));class Jt{constructor(L,he,Pe){if(this.startIndex=L,this.length=he,this.tooltip=Pe,typeof L!="number"||L<0)throw(0,r.$0)("startIndex");if(typeof he!="number"||he<1)throw(0,r.$0)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,r.$0)("tooltip")}}e.$cO=Jt;class Ft{constructor(L){this.uri=L}}e.$dO=Ft;class Rt{constructor(L){this.terminalCommand=L}}e.$eO=Rt;var kt;(function(F){F[F.Panel=1]="Panel",F[F.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class rn{constructor(L){if(this.options=L,typeof L!="object")throw(0,r.$0)("options")}}e.$fO=rn;var Wt;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(Wt||(e.TaskRevealKind=Wt={}));var Qt;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(Qt||(e.TaskPanelKind=Qt={}));let At=Y=class{static from(L){switch(L){case"clean":return Y.Clean;case"build":return Y.Build;case"rebuild":return Y.Rebuild;case"test":return Y.Test;default:return}}constructor(L,he){if(this.label=he,typeof L!="string"||typeof he!="string")throw(0,r.$0)("name");this.c=L}get id(){return this.c}};e.$gO=At,At.Clean=new Y("clean","Clean"),At.Build=new Y("build","Build"),At.Rebuild=new Y("rebuild","Rebuild"),At.Test=new Y("test","Test"),e.$gO=At=Y=ze([le],At);function tn(F){let L="";for(let he=0;he<F.length;he++)L+=F[he].replace(/,/g,",,")+",";return L}let qt=class{constructor(L,he,Pe){if(typeof L!="string")throw(0,r.$0)("process");this.e=[],this.c=L,he!==void 0&&(Array.isArray(he)?(this.e=he,this.f=Pe):this.f=he)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,r.$0)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const he of this.e)L.push(he);return tn(L)}};e.$hO=qt,e.$hO=qt=ze([le],qt);let Tt=class{constructor(L,he,Pe){if(this.f=[],Array.isArray(he)){if(!L)throw(0,r.$0)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,r.$0)("command");this.e=L,this.f=he,this.g=Pe}else{if(typeof L!="string")throw(0,r.$0)("commandLine");this.c=L,this.g=he}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,r.$0)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,r.$0)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const he of this.f)L.push(typeof he=="string"?he:he.value);return tn(L)}};e.$iO=Tt,e.$iO=Tt=ze([le],Tt);var Vt;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(Vt||(e.ShellQuoting=Vt={}));var wt;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace"})(wt||(e.TaskScope=wt={}));class Yt{constructor(L){this.c=L}computeId(){return"customExecution"+(0,S.$3g)()}set callback(L){this.c=L}get callback(){return this.c}}e.$jO=Yt;let It=J=class{constructor(L,he,Pe,Ve,Ze,ot){this.k=!1,this.l=this.definition=L;let ht;typeof he=="string"?(this.o=this.name=he,this.w=this.source=Pe,this.execution=Ve,ht=Ze,this.k=!0):he===wt.Global||he===wt.Workspace?(this.target=he,this.o=this.name=Pe,this.w=this.source=Ve,this.execution=Ze,ht=ot):(this.target=he,this.o=this.name=Pe,this.w=this.source=Ve,this.execution=Ze,ht=ot),typeof ht=="string"?(this.r=[ht],this.t=!0):Array.isArray(ht)?(this.r=ht,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof qt?this.l={type:J.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:J.f,id:this.q.computeId()}:this.q instanceof Yt?this.l={type:J.c,id:this.q.computeId()}:this.l={type:J.g,id:(0,S.$3g)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,r.$0)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,r.$0)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const he=this.l.type;(J.g===he||J.e===he||J.f===he||J.c===he)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,r.$0)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$kO=It,It.c="customExecution",It.e="process",It.f="shell",It.g="$empty",e.$kO=It=J=ze([le],It);var sn;(function(F){F[F.SourceControl=1]="SourceControl",F[F.Window=10]="Window",F[F.Notification=15]="Notification"})(sn||(e.ProgressLocation=sn={}));var cn;(function(F){function L(he){const Pe=he;return(0,y.$kg)(Pe.value)?Pe.tooltip&&!(0,y.$gg)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}F.isViewBadge=L})(cn||(e.ViewBadge=cn={}));let un=ne=class{static isTreeItem(L,he){const Pe=L;if(Pe.checkboxState!==void 0){const Ve=(0,y.$kg)(Pe.checkboxState)?Pe.checkboxState:(0,y.$ig)(Pe.checkboxState)&&(0,y.$kg)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,Ze=!(0,y.$kg)(Pe.checkboxState)&&(0,y.$ig)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(Ve===void 0||Ve!==gn.Checked&&Ve!==gn.Unchecked||Ze!==void 0&&!(0,y.$gg)(Ze))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}if(L instanceof ne)return!0;if(Pe.label!==void 0&&!(0,y.$gg)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,y.$gg)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,y.$gg)(Pe.iconPath)&&!o.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,y.$gg)(Pe.iconPath.id))){const Ve=Pe.iconPath;if(!Ve||!(0,y.$gg)(Ve.light)&&!o.URI.isUri(Ve.light)&&!(0,y.$gg)(Ve.dark)&&!o.URI.isUri(Ve.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}return Pe.description!==void 0&&!(0,y.$gg)(Pe.description)&&typeof Pe.description!="boolean"?(console.log("INVALID tree item, invalid description",Pe.description),!1):Pe.resourceUri!==void 0&&!o.URI.isUri(Pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1):Pe.tooltip!==void 0&&!(0,y.$gg)(Pe.tooltip)&&!(Pe.tooltip instanceof Je)?(console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1):Pe.command!==void 0&&!Pe.command.command?(console.log("INVALID tree item, invalid command",Pe.command),!1):Pe.collapsibleState!==void 0&&Pe.collapsibleState<hn.None&&Pe.collapsibleState>hn.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1):Pe.contextValue!==void 0&&!(0,y.$gg)(Pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1):Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1):!0}constructor(L,he=hn.None){this.collapsibleState=he,o.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$lO=un,e.$lO=un=ne=ze([le],un);var hn;(function(F){F[F.None=0]="None",F[F.Collapsed=1]="Collapsed",F[F.Expanded=2]="Expanded"})(hn||(e.TreeItemCollapsibleState=hn={}));var gn;(function(F){F[F.Unchecked=0]="Unchecked",F[F.Checked=1]="Checked"})(gn||(e.TreeItemCheckboxState=gn={}));let fn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$mO=fn,e.$mO=fn=ze([le],fn);class $n extends fn{}e.$nO=$n;class Sn extends $n{constructor(L){super(""),$.set(this,void 0),ln(this,$,L,"f")}asFile(){return ft(this,$,"f")}}e.$oO=Sn,$=new WeakMap;class wn{constructor(L,he,Pe,Ve){this.name=L,this.uri=he,this._itemId=Pe,this.c=Ve}data(){return this.c()}}e.$pO=wn;let pn=class{constructor(L){p.add(this),d.set(this,new Map);for(const[he,Pe]of L??[]){const Ve=ft(this,d,"f").get(ft(this,p,"m",b).call(this,he));Ve?Ve.push(Pe):ft(this,d,"f").set(ft(this,p,"m",b).call(this,he),[Pe])}}get(L){return ft(this,d,"f").get(ft(this,p,"m",b).call(this,L))?.[0]}set(L,he){ft(this,d,"f").set(ft(this,p,"m",b).call(this,L),[he])}forEach(L,he){for(const[Pe,Ve]of ft(this,d,"f"))for(const Ze of Ve)L.call(he,Ze,Pe,this)}*[(d=new WeakMap,p=new WeakSet,Symbol.iterator)](){for(const[L,he]of ft(this,d,"f"))for(const Pe of he)yield[L,Pe]}};e.$qO=pn,b=function(L){return L.toLowerCase()},e.$qO=pn=ze([le],pn);let bn=class{constructor(L,he,Pe){this.insertText=L,this.title=he,this.kind=Pe}};e.$rO=bn,e.$rO=bn=ze([le],bn);var vn;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(vn||(e.DocumentPasteTriggerKind=vn={}));class Zt{constructor(L){this.value=L}append(...L){return new Zt((this.value?[this.value,...L]:L).join(Zt.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+Zt.c)}}e.$sO=Zt,Zt.c=".",Zt.Empty=new Zt("");class Dn{constructor(L,he,Pe){this.title=he,this.insertText=L,this.kind=Pe}}e.$tO=Dn;let xt=class{constructor(L,he){this.id=L,this.color=he}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$uO=xt,e.$uO=xt=ze([le],xt),xt.File=new xt("file"),xt.Folder=new xt("folder");let De=class{constructor(L){this.id=L}};e.$vO=De,e.$vO=De=ze([le],De);var Oe;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.WorkspaceFolder=3]="WorkspaceFolder"})(Oe||(e.ConfigurationTarget=Oe={}));let ge=class{get base(){return this.c}set base(L){this.c=L,this.e=o.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,he){if(typeof L!="string"&&(!L||!o.URI.isUri(L)&&!o.URI.isUri(L.uri)))throw(0,r.$0)("base");if(typeof he!="string")throw(0,r.$0)("pattern");typeof L=="string"?this.baseUri=o.URI.file(L):o.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wO=ge,e.$wO=ge=ze([le],ge);const X=new WeakMap;function Te(F,L){X.set(F,L)}let je=class{constructor(L,he,Pe,Ve,Ze){this.enabled=typeof L=="boolean"?L:!0,typeof he=="string"&&(this.condition=he),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ve=="string"&&(this.logMessage=Ve),typeof Ze=="string"&&(this.mode=Ze)}get id(){return this.c||(this.c=X.get(this)??(0,S.$3g)()),this.c}};e.$yO=je,e.$yO=je=ze([le],je);let Xe=class extends je{constructor(L,he,Pe,Ve,Ze,ot){if(super(he,Pe,Ve,Ze,ot),L===null)throw(0,r.$0)("location");this.location=L}};e.$zO=Xe,e.$zO=Xe=ze([le],Xe);let Ue=class extends je{constructor(L,he,Pe,Ve,Ze,ot){super(he,Pe,Ve,Ze,ot),this.functionName=L}};e.$AO=Ue,e.$AO=Ue=ze([le],Ue);let st=class extends je{constructor(L,he,Pe,Ve,Ze,ot,ht,Ct){if(super(Ve,Ze,ot,ht,Ct),!he)throw(0,r.$0)("dataId");this.label=L,this.dataId=he,this.canPersist=Pe}};e.$BO=st,e.$BO=st=ze([le],st);let gt=class{constructor(L,he,Pe){this.command=L,this.args=he||[],this.options=Pe}};e.$CO=gt,e.$CO=gt=ze([le],gt);let jt=class{constructor(L,he){this.port=L,this.host=he}};e.$DO=jt,e.$DO=jt=ze([le],jt);let Gt=class{constructor(L){this.path=L}};e.$EO=Gt,e.$EO=Gt=ze([le],Gt);let Dt=class{constructor(L){this.implementation=L}};e.$FO=Dt,e.$FO=Dt=ze([le],Dt);class _t{constructor(L,he,Pe){this.session=L,this.threadId=he,this.frameId=Pe}}e.$GO=_t;class zi{constructor(L,he){this.session=L,this.threadId=he}}e.$HO=zi;let Cn=class{constructor(L,he){this.range=L,this.expression=he}};e.$IO=Cn,e.$IO=Cn=ze([le],Cn);var Kn;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Kn||(e.InlineCompletionTriggerKind=Kn={}));let On=class{constructor(L,he){this.range=L,this.text=he}};e.$JO=On,e.$JO=On=ze([le],On);let Ln=class{constructor(L,he,Pe=!0){this.range=L,this.variableName=he,this.caseSensitiveLookup=Pe}};e.$KO=Ln,e.$KO=Ln=ze([le],Ln);let Nn=class{constructor(L,he){this.range=L,this.expression=he}};e.$LO=Nn,e.$LO=Nn=ze([le],Nn);let Fn=class{constructor(L,he){this.frameId=L,this.stoppedLocation=he}};e.$MO=Fn,e.$MO=Fn=ze([le],Fn);var Xn;(function(F){F[F.AIGenerated=1]="AIGenerated"})(Xn||(e.NewSymbolNameTag=Xn={}));var Jn;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Jn||(e.NewSymbolNameTriggerKind=Jn={}));class Bi{constructor(L,he){this.newSymbolName=L,this.tags=he}}e.$NO=Bi;var Qn;(function(F){F[F.Changed=1]="Changed",F[F.Created=2]="Created",F[F.Deleted=3]="Deleted"})(Qn||(e.FileChangeType=Qn={}));let jn=Z=class extends Error{static FileExists(L){return new Z(L,f.FileSystemProviderErrorCode.FileExists,Z.FileExists)}static FileNotFound(L){return new Z(L,f.FileSystemProviderErrorCode.FileNotFound,Z.FileNotFound)}static FileNotADirectory(L){return new Z(L,f.FileSystemProviderErrorCode.FileNotADirectory,Z.FileNotADirectory)}static FileIsADirectory(L){return new Z(L,f.FileSystemProviderErrorCode.FileIsADirectory,Z.FileIsADirectory)}static NoPermissions(L){return new Z(L,f.FileSystemProviderErrorCode.NoPermissions,Z.NoPermissions)}static Unavailable(L){return new Z(L,f.FileSystemProviderErrorCode.Unavailable,Z.Unavailable)}constructor(L,he=f.FileSystemProviderErrorCode.Unknown,Pe){super(o.URI.isUri(L)?L.toString(!0):L),this.code=Pe?.name??"Unknown",(0,f.$pl)(this,he),Object.setPrototypeOf(this,Z.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};e.$OO=jn,e.$OO=jn=Z=ze([le],jn);let Mn=class{constructor(L,he,Pe){this.start=L,this.end=he,this.kind=Pe}};e.$PO=Mn,e.$PO=Mn=ze([le],Mn);var Yn;(function(F){F[F.Comment=1]="Comment",F[F.Imports=2]="Imports",F[F.Region=3]="Region"})(Yn||(e.FoldingRangeKind=Yn={}));var Zn;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(Zn||(e.CommentThreadCollapsibleState=Zn={}));var xn;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(xn||(e.CommentMode=xn={}));var _n;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(_n||(e.CommentState=_n={}));var ei;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(ei||(e.CommentThreadState=ei={}));var ti;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(ti||(e.CommentThreadApplicability=ti={}));class Ui{constructor(L,he=[]){this.tokenTypes=L,this.tokenModifiers=he}}e.$QO=Ui;function qi(F){return typeof F>"u"||(0,y.$hg)(F)}class zn{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let he=0,Pe=L.tokenTypes.length;he<Pe;he++)this.k.set(L.tokenTypes[he],he);for(let he=0,Pe=L.tokenModifiers.length;he<Pe;he++)this.l.set(L.tokenModifiers[he],he)}}push(L,he,Pe,Ve,Ze){if(typeof L=="number"&&typeof he=="number"&&typeof Pe=="number"&&typeof Ve=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.q(L,he,Pe,Ve,Ze);if(re.isRange(L)&&typeof he=="string"&&qi(Pe))return this.o(L,he,Pe);throw(0,r.$0)()}o(L,he,Pe){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(he))throw new Error("`tokenType` is not in the provided legend");const Ve=L.start.line,Ze=L.start.character,ot=L.end.character-L.start.character,ht=this.k.get(he);let Ct=0;if(Pe)for(const en of Pe){if(!this.l.has(en))throw new Error("`tokenModifier` is not in the provided legend");const nn=this.l.get(en);Ct|=1<<nn>>>0}this.q(Ve,Ze,ot,ht,Ct)}q(L,he,Pe,Ve,Ze){if(this.f&&(L<this.c||L===this.c&&he<this.e)){this.f=!1;const Ct=this.g.length/5|0;let en=0,nn=0;for(let on=0;on<Ct;on++){let an=this.g[5*on],yn=this.g[5*on+1];an===0?(an=en,yn+=nn):an+=en,this.g[5*on]=an,this.g[5*on+1]=yn,en=an,nn=yn}}let ot=L,ht=he;this.f&&this.j>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.j++]=ot,this.g[this.j++]=ht,this.g[this.j++]=Pe,this.g[this.j++]=Ve,this.g[this.j++]=Ze,this.c=L,this.e=he}static r(L){const he=[],Pe=L.length/5|0;for(let ht=0;ht<Pe;ht++)he[ht]=ht;he.sort((ht,Ct)=>{const en=L[5*ht],nn=L[5*Ct];if(en===nn){const on=L[5*ht+1],an=L[5*Ct+1];return on-an}return en-nn});const Ve=new Uint32Array(L.length);let Ze=0,ot=0;for(let ht=0;ht<Pe;ht++){const Ct=5*he[ht],en=L[Ct+0],nn=L[Ct+1],on=L[Ct+2],an=L[Ct+3],yn=L[Ct+4],Fi=en-Ze,Fr=Fi===0?nn-ot:nn,En=5*ht;Ve[En+0]=Fi,Ve[En+1]=Fr,Ve[En+2]=on,Ve[En+3]=an,Ve[En+4]=yn,Ze=en,ot=nn}return Ve}build(L){return this.f?new Bn(new Uint32Array(this.g),L):new Bn(zn.r(this.g),L)}}e.$RO=zn;class Bn{constructor(L,he){this.resultId=he,this.data=L}}e.$SO=Bn;class Hi{constructor(L,he,Pe){this.start=L,this.deleteCount=he,this.data=Pe}}e.$TO=Hi;class Wi{constructor(L,he){this.resultId=he,this.edits=L}}e.$UO=Wi;var ni;(function(F){F[F.Separate=0]="Separate",F[F.MergeWithParent=1]="MergeWithParent"})(ni||(e.DebugConsoleMode=ni={}));class Vi{constructor(L){this.name=L}}e.$VO=Vi;let kn=class{constructor(){}};e.$WO=kn,kn.Back={iconPath:new xt("arrow-left")},e.$WO=kn=ze([le],kn);var ii;(function(F){F[F.Separator=-1]="Separator",F[F.Default=0]="Default"})(ii||(e.QuickPickItemKind=ii={}));var ri;(function(F){F[F.Info=1]="Info",F[F.Warning=2]="Warning",F[F.Error=3]="Error"})(ri||(e.InputBoxValidationSeverity=ri={}));var si;(function(F){F[F.UI=1]="UI",F[F.Workspace=2]="Workspace"})(si||(e.ExtensionKind=si={}));class Gi{static validate(L){if(typeof L.badge=="string"){let he=(0,A.$Rf)(L.badge,0);if(he<L.badge.length&&(he+=(0,A.$Rf)(L.badge,he)),L.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!xt.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,he,Pe){this.badge=L,this.tooltip=he,this.color=Pe}}e.$XO=Gi;let Un=class{constructor(L){this.kind=L}};e.$YO=Un,e.$YO=Un=ze([le],Un);var oi;(function(F){F[F.Light=1]="Light",F[F.Dark=2]="Dark",F[F.HighContrast=3]="HighContrast",F[F.HighContrastLight=4]="HighContrastLight"})(oi||(e.ColorThemeKind=oi={}));class dn{static isNotebookRange(L){return L instanceof dn?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,he){if(L<0)throw(0,r.$0)("start must be positive");if(he<0)throw(0,r.$0)("end must be positive");L<=he?(this.c=L,this.e=he):(this.c=he,this.e=L)}with(L){let he=this.c,Pe=this.e;return L.start!==void 0&&(he=L.start),L.end!==void 0&&(Pe=L.end),he===this.c&&Pe===this.e?this:new dn(he,Pe)}}e.$ZO=dn;class In{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(he=>In.isNotebookCellData(he))}static isNotebookCellData(L){return!0}constructor(L,he,Pe,Ve,Ze,ot,ht){this.kind=L,this.value=he,this.languageId=Pe,this.mime=Ve,this.outputs=Ze??[],this.metadata=ot,this.executionSummary=ht,In.validate(this)}}e.$1O=In;class Ki{constructor(L){this.cells=L}}e.$2O=Ki;class ai{static isNotebookCellOutputItem(L){return L instanceof t?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const he={name:L.name,message:L.message,stack:L.stack};return t.json(he,"application/vnd.code.notebook.error")}static stdout(L){return t.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return t.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,he="application/octet-stream"){return new t(L,he)}static text(L,he=R.$0s.text){const Pe=ft(t,t,"f",l).encode(String(L));return new t(Pe,he)}static json(L,he="text/x-json"){const Pe=JSON.stringify(L,void 0,"	");return t.text(Pe,he)}constructor(L,he){this.data=L,this.mime=he;const Pe=(0,R.$bt)(he,!0);if(!Pe)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}e.$3O=ai,t=ai,l={value:new TextEncoder};class Pn{static isNotebookCellOutput(L){return L instanceof Pn?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,he=!1){const Pe=new Set,Ve=new Set;for(let Ze=0;Ze<L.length;Ze++){const ot=L[Ze],ht=(0,R.$bt)(ot.mime);if(!Pe.has(ht)||(0,a.$AL)(ht)){Pe.add(ht);continue}Ve.add(Ze),he&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ve.size===0?L:L.filter((Ze,ot)=>!Ve.has(ot))}constructor(L,he,Pe){this.items=Pn.ensureUniqueMimeTypes(L,!0),typeof he=="string"?(this.id=he,this.metadata=Pe):(this.id=(0,S.$3g)(),this.metadata=he??Pe)}}e.$4O=Pn;var li;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var ci;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(ci||(e.NotebookCellExecutionState=ci={}));var ui;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(ui||(e.NotebookCellStatusBarAlignment=ui={}));var hi;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(hi||(e.NotebookEditorRevealType=hi={}));class Xi{constructor(L,he){this.text=L,this.alignment=he}}e.$5O=Xi;var fi;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred"})(fi||(e.NotebookControllerAffinity=fi={}));var di;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred",F[F.Hidden=-1]="Hidden"})(di||(e.NotebookControllerAffinity2=di={}));class Ji{constructor(L,he=[]){this.uri=L,this.provides=(0,n.$5b)(he)}}e.$6O=Ji;class Qi{constructor(L){this.label=L}}e.$7O=Qi;var mi;(function(F){F[F.Named=1]="Named",F[F.Indexed=2]="Indexed"})(mi||(e.NotebookVariablesRequestKind=mi={}));let qn=class{constructor(L,he){this.label=L,this.timestamp=he}};e.$8O=qn,e.$8O=qn=ze([le],qn);var gi;(function(F){F[F.Production=1]="Production",F[F.Development=2]="Development",F[F.Test=3]="Test"})(gi||(e.ExtensionMode=gi={}));var $i;(function(F){F[F.Node=1]="Node",F[F.Webworker=2]="Webworker"})($i||(e.ExtensionRuntime=$i={}));var pi;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(pi||(e.StandardTokenType=pi={}));class Yi{constructor(L,he){this.ranges=L,this.wordPattern=he}}e.$9O=Yi;class Zi{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$0O=Zi;var bi;(function(F){F[F.Queued=1]="Queued",F[F.Running=2]="Running",F[F.Passed=3]="Passed",F[F.Failed=4]="Failed",F[F.Skipped=5]="Skipped",F[F.Errored=6]="Errored"})(bi||(e.TestResultState=bi={}));var wi;(function(F){F[F.Run=1]="Run",F[F.Debug=2]="Debug",F[F.Coverage=3]="Coverage"})(wi||(e.TestRunProfileKind=wi={}));let Hn=class{constructor(L=void 0,he=void 0,Pe=void 0,Ve=!1,Ze=!0){this.include=L,this.exclude=he,this.profile=Pe,this.continuous=Ve,this.preserveFocus=Ze}};e.$$O=Hn,e.$$O=Hn=ze([le],Hn);let Wn=x=class{static diff(L,he,Pe){const Ve=new x(L);return Ve.expectedOutput=he,Ve.actualOutput=Pe,Ve}constructor(L){this.message=L}};e.$_O=Wn,e.$_O=Wn=x=ze([le],Wn);let Vn=class{constructor(L){this.id=L}};e.$aP=Vn,e.$aP=Vn=ze([le],Vn);class Rn{constructor(L,he){this.covered=L,this.total=he,vi(this)}}e.$bP=Rn;function vi(F){if(F){if(F.covered>F.total)throw new Error(`The total number of covered items (${F.covered}) cannot be greater than the total (${F.total})`);if(F.total<0)throw new Error(`The number of covered items (${F.total}) cannot be negative`)}}class Gn{static fromDetails(L,he){const Pe=new Rn(0,0),Ve=new Rn(0,0),Ze=new Rn(0,0);for(const ht of he)if("branches"in ht){Pe.total+=1,Pe.covered+=ht.executed?1:0;for(const Ct of ht.branches)Ve.total+=1,Ve.covered+=Ct.executed?1:0}else Ze.total+=1,Ze.covered+=ht.executed?1:0;const ot=new Gn(L,Pe,Ve.total>0?Ve:void 0,Ze.total>0?Ze:void 0);return ot.detailedCoverage=he,ot}constructor(L,he,Pe,Ve,Ze=[]){this.uri=L,this.statementCoverage=he,this.branchCoverage=Pe,this.declarationCoverage=Ve,this.fromTests=Ze}}e.$dP=Gn;class xi{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,he,Pe=[]){this.executed=L,this.location=he,this.branches=Pe}}e.$eP=xi;class _i{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,he,Pe){this.executed=L,this.location=he,this.label=Pe}}e.$fP=_i;class er{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,he,Pe){this.name=L,this.executed=he,this.location=Pe}}e.$gP=er;var yi;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(yi||(e.ExternalUriOpenerPriority=yi={}));var Ei;(function(F){F[F.Untrusted=0]="Untrusted",F[F.Trusted=1]="Trusted",F[F.Unspecified=2]="Unspecified"})(Ei||(e.WorkspaceTrustState=Ei={}));var Si;(function(F){F[F.Notify=1]="Notify",F[F.OpenBrowser=2]="OpenBrowser",F[F.OpenPreview=3]="OpenPreview",F[F.Silent=4]="Silent",F[F.Ignore=5]="Ignore",F[F.OpenBrowserOnce=6]="OpenBrowserOnce"})(Si||(e.PortAutoForwardAction=Si={}));class tr{constructor(L,he,Pe,Ve,Ze,ot){this.kind=L,this.name=he,this.detail=Pe,this.uri=Ve,this.range=Ze,this.selectionRange=ot}}e.$hP=tr;class nr{constructor(L){this.uri=L}}e.$iP=nr;class ir{constructor(L,he){this.original=L,this.modified=he}}e.$jP=ir;class rr{constructor(L,he,Pe,Ve){this.base=L,this.input1=he,this.input2=Pe,this.result=Ve}}e.$kP=rr;class sr{constructor(L,he){this.uri=L,this.viewType=he}}e.$lP=sr;class or{constructor(L){this.viewType=L}}e.$mP=or;class ar{constructor(L,he){this.uri=L,this.notebookType=he}}e.$nP=ar;class lr{constructor(L,he,Pe){this.original=L,this.modified=he,this.notebookType=Pe}}e.$oP=lr;class cr{constructor(){}}e.$pP=cr;class ur{constructor(L,he){this.uri=L,this.inputBoxUri=he}}e.$qP=ur;class hr{constructor(){}}e.$rP=hr;class fr{constructor(L){this.textDiffs=L}}e.$sP=fr;var Di;(function(F){F[F.Down=0]="Down",F[F.Up=1]="Up"})(Di||(e.InteractiveSessionVoteDirection=Di={}));var ki;(function(F){F[F.Action=1]="Action",F[F.Toolbar=2]="Toolbar"})(ki||(e.ChatCopyKind=ki={}));var Ii;(function(F){F[F.Short=1]="Short",F[F.Medium=2]="Medium",F[F.Full=3]="Full"})(Ii||(e.ChatVariableLevel=Ii={}));class dr{constructor(L,he,Pe){this.id=L,this.label=he,this.values=Pe}}e.$tP=dr;var Pi;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful",F[F.Undone=2]="Undone",F[F.Accepted=3]="Accepted",F[F.Bug=4]="Bug"})(Pi||(e.InteractiveEditorResponseFeedbackKind=Pi={}));var Ri;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful"})(Ri||(e.ChatResultFeedbackKind=Ri={}));class mr{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Je(L):L}}e.$uP=mr;class gr{constructor(L,he){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Je(L):L,this.vulnerabilities=he}}e.$vP=gr;class $r{constructor(L,he){this.participant=L,this.command=he}}e.$wP=$r;class pr{constructor(L,he,Pe){this.title=L,this.message=he,this.data=Pe}}e.$xP=pr;class br{constructor(L,he){this.value=L,this.baseUri=he}}e.$yP=br;class wr{constructor(L,he){this.value=L,this.title=he}}e.$zP=wr;class vr{constructor(L){this.value=L}}e.$AP=vr;class yr{constructor(L,he){this.value=L,this.task=he}}e.$BP=yr;class Er{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Je(L):L}}e.$CP=Er;class Sr{constructor(L){this.value=L}}e.$DP=Sr;class Dr{constructor(L,he){this.value=L,this.iconPath=he}}e.$EP=Dr;class kr{constructor(L,he){this.uri=L,this.edits=Array.isArray(he)?he:[he]}}e.$FP=kr;class Ir{constructor(L,he,Pe,Ve){this.prompt=L,this.command=he,this.references=Pe,this.participant=Ve}}e.$GP=Ir;class Pr{constructor(L,he,Pe,Ve){this.response=L,this.result=he,this.participant=Pe,this.command=Ve}}e.$HP=Pr;var Ai;(function(F){F[F.Panel=1]="Panel",F[F.Terminal=2]="Terminal",F[F.Notebook=3]="Notebook",F[F.Editor=4]="Editor"})(Ai||(e.ChatLocation=Ai={}));var An;(function(F){F[F.User=1]="User",F[F.Assistant=2]="Assistant",F[F.System=3]="System"})(An||(e.LanguageModelChatMessageRole=An={}));class Rr{constructor(L,he,Pe){this.name=L,this.content=he,this.isError=Pe??!1}}e.$IP=Rr;class Tn{static User(L,he){const Pe=new Tn(An.User,typeof L=="string"?L:"",he);return Pe.content2=L,Pe}static Assistant(L,he){return new Tn(An.Assistant,L,he)}constructor(L,he,Pe){this.role=L,this.content=he,this.content2=he,this.name=Pe}}e.$JP=Tn;class Ar{constructor(L,he){this.name=L,this.parameters=he}}e.$KP=Ar;class Tr{constructor(L){this.value=L}}e.$LP=Tr;class Cr{constructor(L){this.content=L}}e.$MP=Cr;class Or{constructor(L,he){this.content=L,this.name=he}}e.$NP=Or;class Lr{constructor(L,he){this.content=L,this.name=he}}e.$OP=Lr;class mn extends Error{static NotFound(L){return new mn(L,mn.NotFound.name)}static NoPermissions(L){return new mn(L,mn.NoPermissions.name)}static Blocked(L){return new mn(L,mn.Blocked.name)}constructor(L,he,Pe){super(L,{cause:Pe}),this.name="LanguageModelError",this.code=he??""}}e.$PP=mn;var Ti;(function(F){F[F.SymbolInformation=1]="SymbolInformation",F[F.CommandInformation=2]="CommandInformation",F[F.SearchInformation=3]="SearchInformation",F[F.SettingInformation=4]="SettingInformation"})(Ti||(e.RelatedInformationType=Ti={}));var Ci;(function(F){F[F.Started=1]="Started",F[F.Recognizing=2]="Recognizing",F[F.Recognized=3]="Recognized",F[F.Stopped=4]="Stopped",F[F.Error=5]="Error"})(Ci||(e.SpeechToTextStatus=Ci={}));var Oi;(function(F){F[F.Started=1]="Started",F[F.Stopped=2]="Stopped",F[F.Error=3]="Error"})(Oi||(e.TextToSpeechStatus=Oi={}));var Li;(function(F){F[F.Recognized=1]="Recognized",F[F.Stopped=2]="Stopped"})(Li||(e.KeywordRecognitionStatus=Li={}));class Nr{constructor(L,he){this.text=L,this.range=he}}e.$QP=Nr;var Ni;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Ni||(e.InlineEditTriggerKind=Ni={}))}),define(Se[154],ke([1,0,18,15,178,79,111,26,161,49,66,21,167,20,82,11,4,248,51,118,200,188,260,261,148,103,304,317,305,152,76,104,150,153]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t,l,i,g,s,c,u,D,P,T,z,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$YP=ce,e.$ZP=W,e.$1P=ue,R=Be(R),p=Be(p),d=Be(d),b=Be(b),u=Be(u),P=Be(P),k=Be(k);var q;(function(De){function Oe(X){const{selectionStartLineNumber:Te,selectionStartColumn:je,positionLineNumber:Xe,positionColumn:Ue}=X,st=new k.$yN(Te-1,je-1),gt=new k.$yN(Xe-1,Ue-1);return new k.$AN(st,gt)}De.to=Oe;function ge(X){const{anchor:Te,active:je}=X;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}De.from=ge})(q||(e.Selection=q={}));var Y;(function(De){function Oe(X){if(!X)return;const{start:Te,end:je}=X;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}De.from=Oe;function ge(X){if(!X)return;const{startLineNumber:Te,startColumn:je,endLineNumber:Xe,endColumn:Ue}=X;return new k.$zN(Te-1,je-1,Xe-1,Ue-1)}De.to=ge})(Y||(e.Range=Y={}));var J;(function(De){function Oe(X){return{uri:X.uri,range:Y.from(X.range)}}De.from=Oe;function ge(X){return new k.$JN(m.URI.revive(X.uri),Y.to(X.range))}De.to=ge})(J||(e.Location=J={}));var ne;(function(De){function Oe(ge){switch(ge){case d.StandardTokenType.Comment:return k.StandardTokenType.Comment;case d.StandardTokenType.Other:return k.StandardTokenType.Other;case d.StandardTokenType.RegEx:return k.StandardTokenType.RegEx;case d.StandardTokenType.String:return k.StandardTokenType.String}}De.to=Oe})(ne||(e.TokenType=ne={}));var Z;(function(De){function Oe(X){return new k.$yN(X.lineNumber-1,X.column-1)}De.to=Oe;function ge(X){return{lineNumber:X.line+1,column:X.character+1}}De.from=ge})(Z||(e.Position=Z={}));var x;(function(De){function Oe(Te,je,Xe){return(0,n.$Kb)((0,n.$5b)(Te).map(Ue=>ge(Ue,je,Xe)))}De.from=Oe;function ge(Te,je,Xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:X(Te.scheme,je),pattern:Ke.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Xe?.isBuiltin}}function X(Te,je){return je&&typeof Te=="string"?je.transformOutgoingScheme(Te):Te}})(x||(e.DocumentSelector=x={}));var le;(function(De){function Oe(X){switch(X){case k.DiagnosticTag.Unnecessary:return l.MarkerTag.Unnecessary;case k.DiagnosticTag.Deprecated:return l.MarkerTag.Deprecated}}De.from=Oe;function ge(X){switch(X){case l.MarkerTag.Unnecessary:return k.DiagnosticTag.Unnecessary;case l.MarkerTag.Deprecated:return k.DiagnosticTag.Deprecated;default:return}}De.to=ge})(le||(e.DiagnosticTag=le={}));var K;(function(De){function Oe(X){let Te;return X.code&&((0,h.$gg)(X.code)||(0,h.$kg)(X.code)?Te=String(X.code):Te={value:String(X.code.value),target:X.code.target}),{...Y.from(X.range),message:X.message,source:X.source,code:Te,severity:M.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(ae.from),tags:Array.isArray(X.tags)?(0,n.$Kb)(X.tags.map(le.from)):void 0}}De.from=Oe;function ge(X){const Te=new k.$LN(Y.to(X),X.message,M.to(X.severity));return Te.source=X.source,Te.code=(0,h.$gg)(X.code)?X.code:X.code?.value,Te.relatedInformation=X.relatedInformation&&X.relatedInformation.map(ae.to),Te.tags=X.tags&&(0,n.$Kb)(X.tags.map(le.to)),Te}De.to=ge})(K||(e.Diagnostic=K={}));var ae;(function(De){function Oe(X){return{...Y.from(X.location.range),message:X.message,resource:X.location.uri}}De.from=Oe;function ge(X){return new k.$KN(new k.$JN(X.resource,Y.to(X)),X.message)}De.to=ge})(ae||(e.DiagnosticRelatedInformation=ae={}));var M;(function(De){function Oe(X){switch(X){case k.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case k.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case k.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case k.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}De.from=Oe;function ge(X){switch(X){case l.MarkerSeverity.Info:return k.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return k.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return k.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return k.DiagnosticSeverity.Hint;default:return k.DiagnosticSeverity.Error}}De.to=ge})(M||(e.DiagnosticSeverity=M={}));var B;(function(De){function Oe(X){return typeof X=="number"&&X>=k.ViewColumn.One?X-1:X===k.ViewColumn.Beside?C.$qE:C.$pE}De.from=Oe;function ge(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=ge})(B||(e.ViewColumn=B={}));function re(De){return typeof De.range<"u"}function ce(De){return De.length===0?!0:!!re(De[0])}var pe;(function(De){function Oe(Ue){return Ue.map(De.from)}De.fromMany=Oe;function ge(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function X(Ue){let st;if(ge(Ue)){const{language:Dt,value:_t}=Ue;st={value:"```"+Dt+`
`+_t+"\n```\n"}}else k.$ZN.isMarkdownString(Ue)?st={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?st={value:Ue}:st={value:""};const gt=Object.create(null);st.uris=gt;const jt=Dt=>{try{let _t=m.URI.parse(Dt,!0);_t=_t.with({query:Te(_t.query,gt)}),gt[Dt]=_t}catch{}return""},Gt=new y.marked.Renderer;return Gt.link=jt,Gt.image=Dt=>typeof Dt=="string"?jt(R.$_k(Dt).href):"",(0,y.marked)(st.value,{renderer:Gt}),st}De.from=X;function Te(Ue,st){if(!Ue)return Ue;let gt;try{gt=(0,o.$ci)(Ue)}catch{}if(!gt)return Ue;let jt=!1;return gt=(0,v.$ho)(gt,Gt=>{if(m.URI.isUri(Gt)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[Dt]=Gt,jt=!0,Dt}else return}),jt?JSON.stringify(gt):Ue}function je(Ue){const st=new k.$ZN(Ue.value,Ue.supportThemeIcons);return st.isTrusted=Ue.isTrusted,st.supportHtml=Ue.supportHtml,st.baseUri=Ue.baseUri?m.URI.from(Ue.baseUri):void 0,st}De.to=je;function Xe(Ue){if(Ue)return typeof Ue=="string"?Ue:De.from(Ue)}De.fromStrict=Xe})(pe||(e.MarkdownString=pe={}));function W(De){return ce(De)?De.map(Oe=>({range:Y.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?pe.fromMany(Oe.hoverMessage):Oe.hoverMessage?pe.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):De.map(Oe=>({range:Y.from(Oe)}))}function ue(De){return typeof De>"u"?De:typeof De=="string"?m.URI.file(De):De}var _;(function(De){function Oe(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?ue(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}De.from=Oe})(_||(e.ThemableDecorationAttachmentRenderOptions=_={}));var U;(function(De){function Oe(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?ue(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?_.from(ge.before):void 0,after:ge.after?_.from(ge.after):void 0}}De.from=Oe})(U||(e.ThemableDecorationRenderOptions=U={}));var O;(function(De){function Oe(ge){if(typeof ge>"u")return ge;switch(ge){case k.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case k.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case k.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case k.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}De.from=Oe})(O||(e.DecorationRangeBehavior=O={}));var te;(function(De){function Oe(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?O.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?U.from(ge.light):void 0,dark:ge.dark?U.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?ue(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?_.from(ge.before):void 0,after:ge.after?_.from(ge.after):void 0}}De.from=Oe})(te||(e.DecorationRenderOptions=te={}));var V;(function(De){function Oe(X){return{text:X.newText,eol:X.newEol&&ye.from(X.newEol),range:Y.from(X.range)}}De.from=Oe;function ge(X){const Te=new k.$EN(Y.to(X.range),X.text);return Te.newEol=typeof X.eol>"u"?void 0:ye.to(X.eol),Te}De.to=ge})(V||(e.TextEdit=V={}));var j;(function(De){function Oe(X,Te){const je={edits:[]};if(X instanceof k.$HN){const Xe=new A.$Ec;for(const Ue of X._allEntries())Ue._type===k.FileEditType.File&&m.URI.isUri(Ue.to)&&Ue.from===void 0&&Xe.add(Ue.to);for(const Ue of X._allEntries())if(Ue._type===k.FileEditType.File){let st;Ue.options?.contents&&(ArrayBuffer.isView(Ue.options.contents)?st={type:"base64",value:(0,r.$0e)(r.$Pe.wrap(Ue.options.contents))}:st={type:"dataTransferItem",id:Ue.options.contents._itemId}),je.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contents:st},metadata:Ue.metadata})}else Ue._type===k.FileEditType.Text?je.edits.push({resource:Ue.uri,textEdit:V.from(Ue.edit),versionId:Xe.has(Ue.uri)?void 0:Te?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===k.FileEditType.Snippet?je.edits.push({resource:Ue.uri,textEdit:{range:Y.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ue.uri)?void 0:Te?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===k.FileEditType.Cell?je.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===k.FileEditType.CellReplace&&je.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:P.CellEditType.Replace,index:Ue.index,count:Ue.count,cells:Ue.cells.map(dt.from)}})}return je}De.from=Oe;function ge(X){const Te=new k.$HN,je=new A.$Dc;for(const Xe of X.edits)if(Xe.textEdit){const Ue=Xe,st=m.URI.revive(Ue.resource),gt=Y.to(Ue.textEdit.range),jt=Ue.textEdit.text,Gt=Ue.textEdit.insertAsSnippet;let Dt;Gt?Dt=k.$GN.replace(gt,new k.$IN(jt)):Dt=k.$EN.replace(gt,jt);const _t=je.get(st);_t?_t.push(Dt):je.set(st,[Dt])}else Te.renameFile(m.URI.revive(Xe.oldResource),m.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ue]of je)Te.set(Xe,Ue);return Te}De.to=ge})(j||(e.WorkspaceEdit=j={}));var G;(function(De){const Oe=Object.create(null);Oe[k.SymbolKind.File]=b.SymbolKind.File,Oe[k.SymbolKind.Module]=b.SymbolKind.Module,Oe[k.SymbolKind.Namespace]=b.SymbolKind.Namespace,Oe[k.SymbolKind.Package]=b.SymbolKind.Package,Oe[k.SymbolKind.Class]=b.SymbolKind.Class,Oe[k.SymbolKind.Method]=b.SymbolKind.Method,Oe[k.SymbolKind.Property]=b.SymbolKind.Property,Oe[k.SymbolKind.Field]=b.SymbolKind.Field,Oe[k.SymbolKind.Constructor]=b.SymbolKind.Constructor,Oe[k.SymbolKind.Enum]=b.SymbolKind.Enum,Oe[k.SymbolKind.Interface]=b.SymbolKind.Interface,Oe[k.SymbolKind.Function]=b.SymbolKind.Function,Oe[k.SymbolKind.Variable]=b.SymbolKind.Variable,Oe[k.SymbolKind.Constant]=b.SymbolKind.Constant,Oe[k.SymbolKind.String]=b.SymbolKind.String,Oe[k.SymbolKind.Number]=b.SymbolKind.Number,Oe[k.SymbolKind.Boolean]=b.SymbolKind.Boolean,Oe[k.SymbolKind.Array]=b.SymbolKind.Array,Oe[k.SymbolKind.Object]=b.SymbolKind.Object,Oe[k.SymbolKind.Key]=b.SymbolKind.Key,Oe[k.SymbolKind.Null]=b.SymbolKind.Null,Oe[k.SymbolKind.EnumMember]=b.SymbolKind.EnumMember,Oe[k.SymbolKind.Struct]=b.SymbolKind.Struct,Oe[k.SymbolKind.Event]=b.SymbolKind.Event,Oe[k.SymbolKind.Operator]=b.SymbolKind.Operator,Oe[k.SymbolKind.TypeParameter]=b.SymbolKind.TypeParameter;function ge(Te){return typeof Oe[Te]=="number"?Oe[Te]:b.SymbolKind.Property}De.from=ge;function X(Te){for(const je in Oe)if(Oe[je]===Te)return Number(je);return k.SymbolKind.Property}De.to=X})(G||(e.SymbolKind=G={}));var Q;(function(De){function Oe(X){switch(X){case k.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}De.from=Oe;function ge(X){switch(X){case b.SymbolTag.Deprecated:return k.SymbolTag.Deprecated}}De.to=ge})(Q||(e.SymbolTag=Q={}));var N;(function(De){function Oe(X){return{name:X.name,kind:G.from(X.kind),tags:X.tags&&X.tags.map(Q.from),containerName:X.containerName,location:Ne.from(X.location)}}De.from=Oe;function ge(X){const Te=new k.$QN(X.name,G.to(X.kind),X.containerName,Ne.to(X.location));return Te.tags=X.tags&&X.tags.map(Q.to),Te}De.to=ge})(N||(e.WorkspaceSymbol=N={}));var H;(function(De){function Oe(X){const Te={name:X.name||"!!MISSING: name!!",detail:X.detail,range:Y.from(X.range),selectionRange:Y.from(X.selectionRange),kind:G.from(X.kind),tags:X.tags?.map(Q.from)??[]};return X.children&&(Te.children=X.children.map(Oe)),Te}De.from=Oe;function ge(X){const Te=new k.$RN(X.name,X.detail,G.to(X.kind),Y.to(X.range),Y.to(X.selectionRange));return(0,n.$Ob)(X.tags)&&(Te.tags=X.tags.map(Q.to)),X.children&&(Te.children=X.children.map(ge)),Te}De.to=ge})(H||(e.DocumentSymbol=H={}));var oe;(function(De){function Oe(X){const Te=new k.$VN(G.to(X.kind),X.name,X.detail||"",m.URI.revive(X.uri),Y.to(X.range),Y.to(X.selectionRange));return Te._sessionId=X._sessionId,Te._itemId=X._itemId,Te}De.to=Oe;function ge(X,Te,je){if(Te=Te??X._sessionId,je=je??X._itemId,Te===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:je,name:X.name,detail:X.detail,kind:G.from(X.kind),uri:X.uri,range:Y.from(X.range),selectionRange:Y.from(X.selectionRange),tags:X.tags?.map(Q.from)}}De.from=ge})(oe||(e.CallHierarchyItem=oe={}));var fe;(function(De){function Oe(ge){return new k.$WN(oe.to(ge.from),ge.fromRanges.map(X=>Y.to(X)))}De.to=Oe})(fe||(e.CallHierarchyIncomingCall=fe={}));var Ee;(function(De){function Oe(ge){return new k.$XN(oe.to(ge.to),ge.fromRanges.map(X=>Y.to(X)))}De.to=Oe})(Ee||(e.CallHierarchyOutgoingCall=Ee={}));var Ne;(function(De){function Oe(X){return{range:X.range&&Y.from(X.range),uri:X.uri}}De.from=Oe;function ge(X){return new k.$JN(m.URI.revive(X.uri),Y.to(X.range))}De.to=ge})(Ne||(e.location=Ne={}));var de;(function(De){function Oe(X){const Te=X,je=X;return{originSelectionRange:Te.originSelectionRange?Y.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:je.uri,range:Y.from(Te.targetRange?Te.targetRange:je.range),targetSelectionRange:Te.targetSelectionRange?Y.from(Te.targetSelectionRange):void 0}}De.from=Oe;function ge(X){return{targetUri:m.URI.revive(X.uri),targetRange:Y.to(X.range),targetSelectionRange:X.targetSelectionRange?Y.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?Y.to(X.originSelectionRange):void 0}}De.to=ge})(de||(e.DefinitionLink=de={}));var $e;(function(De){function Oe(X){return{range:Y.from(X.range),contents:pe.fromMany(X.contents),canIncreaseVerbosity:X.canIncreaseVerbosity,canDecreaseVerbosity:X.canDecreaseVerbosity}}De.from=Oe;function ge(X){const Te=X.contents.map(pe.to),je=Y.to(X.range),Xe=X.canIncreaseVerbosity,Ue=X.canDecreaseVerbosity;return new k.$NN(Te,je,Xe,Ue)}De.to=ge})($e||(e.Hover=$e={}));var Re;(function(De){function Oe(X){return{range:Y.from(X.range),expression:X.expression}}De.from=Oe;function ge(X){return new k.$IO(Y.to(X.range),X.expression)}De.to=ge})(Re||(e.EvaluatableExpression=Re={}));var Ce;(function(De){function Oe(X){if(X instanceof k.$JO)return{type:"text",range:Y.from(X.range),text:X.text};if(X instanceof k.$KO)return{type:"variable",range:Y.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof k.$LO)return{type:"expression",range:Y.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Oe;function ge(X){switch(X.type){case"text":return{range:Y.to(X.range),text:X.text};case"variable":return{range:Y.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:Y.to(X.range),expression:X.expression}}}De.to=ge})(Ce||(e.InlineValue=Ce={}));var me;(function(De){function Oe(X){return{frameId:X.frameId,stoppedLocation:Y.from(X.stoppedLocation)}}De.from=Oe;function ge(X){return new k.$MO(X.frameId,Y.to(X.stoppedLocation))}De.to=ge})(me||(e.InlineValueContext=me={}));var Ie;(function(De){function Oe(X){return{range:Y.from(X.range),kind:X.kind}}De.from=Oe;function ge(X){return new k.$ON(Y.to(X.range),X.kind)}De.to=ge})(Ie||(e.DocumentHighlight=Ie={}));var Ae;(function(De){function Oe(X){return{uri:X.uri,highlights:X.highlights.map(Ie.from)}}De.from=Oe;function ge(X){return new k.$PN(m.URI.revive(X.uri),X.highlights.map(Ie.to))}De.to=ge})(Ae||(e.MultiDocumentHighlight=Ae={}));var Me;(function(De){function Oe(ge){switch(ge){case b.CompletionTriggerKind.TriggerCharacter:return k.CompletionTriggerKind.TriggerCharacter;case b.CompletionTriggerKind.TriggerForIncompleteCompletions:return k.CompletionTriggerKind.TriggerForIncompleteCompletions;case b.CompletionTriggerKind.Invoke:default:return k.CompletionTriggerKind.Invoke}}De.to=Oe})(Me||(e.CompletionTriggerKind=Me={}));var qe;(function(De){function Oe(ge){return{triggerKind:Me.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}De.to=Oe})(qe||(e.CompletionContext=qe={}));var Qe;(function(De){function Oe(X){switch(X){case k.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}De.from=Oe;function ge(X){switch(X){case b.CompletionItemTag.Deprecated:return k.CompletionItemTag.Deprecated}}De.to=ge})(Qe||(e.CompletionItemTag=Qe={}));var Ge;(function(De){const Oe=new Map([[k.CompletionItemKind.Method,b.CompletionItemKind.Method],[k.CompletionItemKind.Function,b.CompletionItemKind.Function],[k.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[k.CompletionItemKind.Field,b.CompletionItemKind.Field],[k.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[k.CompletionItemKind.Class,b.CompletionItemKind.Class],[k.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[k.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[k.CompletionItemKind.Module,b.CompletionItemKind.Module],[k.CompletionItemKind.Property,b.CompletionItemKind.Property],[k.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[k.CompletionItemKind.Value,b.CompletionItemKind.Value],[k.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[k.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[k.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[k.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[k.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[k.CompletionItemKind.Text,b.CompletionItemKind.Text],[k.CompletionItemKind.Color,b.CompletionItemKind.Color],[k.CompletionItemKind.File,b.CompletionItemKind.File],[k.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[k.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[k.CompletionItemKind.Event,b.CompletionItemKind.Event],[k.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[k.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[k.CompletionItemKind.Issue,b.CompletionItemKind.Issue],[k.CompletionItemKind.User,b.CompletionItemKind.User]]);function ge(je){return Oe.get(je)??b.CompletionItemKind.Property}De.from=ge;const X=new Map([[b.CompletionItemKind.Method,k.CompletionItemKind.Method],[b.CompletionItemKind.Function,k.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,k.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,k.CompletionItemKind.Field],[b.CompletionItemKind.Variable,k.CompletionItemKind.Variable],[b.CompletionItemKind.Class,k.CompletionItemKind.Class],[b.CompletionItemKind.Interface,k.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,k.CompletionItemKind.Struct],[b.CompletionItemKind.Module,k.CompletionItemKind.Module],[b.CompletionItemKind.Property,k.CompletionItemKind.Property],[b.CompletionItemKind.Unit,k.CompletionItemKind.Unit],[b.CompletionItemKind.Value,k.CompletionItemKind.Value],[b.CompletionItemKind.Constant,k.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,k.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,k.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,k.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,k.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,k.CompletionItemKind.Text],[b.CompletionItemKind.Color,k.CompletionItemKind.Color],[b.CompletionItemKind.File,k.CompletionItemKind.File],[b.CompletionItemKind.Reference,k.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,k.CompletionItemKind.Folder],[b.CompletionItemKind.Event,k.CompletionItemKind.Event],[b.CompletionItemKind.Operator,k.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,k.CompletionItemKind.TypeParameter],[b.CompletionItemKind.User,k.CompletionItemKind.User],[b.CompletionItemKind.Issue,k.CompletionItemKind.Issue]]);function Te(je){return X.get(je)??k.CompletionItemKind.Property}De.to=Te})(Ge||(e.CompletionItemKind=Ge={}));var Ye;(function(De){function Oe(ge,X){const Te=new k.$6N(ge.label);return Te.insertText=ge.insertText,Te.kind=Ge.to(ge.kind),Te.tags=ge.tags?.map(Qe.to),Te.detail=ge.detail,Te.documentation=R.$6k(ge.documentation)?pe.to(ge.documentation):ge.documentation,Te.sortText=ge.sortText,Te.filterText=ge.filterText,Te.preselect=ge.preselect,Te.commitCharacters=ge.commitCharacters,p.$Nt.isIRange(ge.range)?Te.range=Y.to(ge.range):typeof ge.range=="object"&&(Te.range={inserting:Y.to(ge.range.insert),replacing:Y.to(ge.range.replace)}),Te.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&b.CompletionItemInsertTextRule.KeepWhitespace),typeof ge.insertTextRules<"u"&&ge.insertTextRules&b.CompletionItemInsertTextRule.InsertAsSnippet?Te.insertText=new k.$IN(ge.insertText):(Te.insertText=ge.insertText,Te.textEdit=Te.range instanceof k.$zN?new k.$EN(Te.range,Te.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Te.additionalTextEdits=ge.additionalTextEdits.map(je=>V.to(je))),Te.command=X&&ge.command?X.fromInternal(ge.command):void 0,Te}De.to=Oe})(Ye||(e.CompletionItem=Ye={}));var We;(function(De){function Oe(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:pe.fromStrict(X.documentation)}}De.from=Oe;function ge(X){return{label:X.label,documentation:R.$6k(X.documentation)?pe.to(X.documentation):X.documentation}}De.to=ge})(We||(e.ParameterInformation=We={}));var rt;(function(De){function Oe(X){return{label:X.label,documentation:pe.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(We.from):[],activeParameter:X.activeParameter}}De.from=Oe;function ge(X){return{label:X.label,documentation:R.$6k(X.documentation)?pe.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(We.to):[],activeParameter:X.activeParameter}}De.to=ge})(rt||(e.SignatureInformation=rt={}));var at;(function(De){function Oe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(rt.from):[]}}De.from=Oe;function ge(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(rt.to):[]}}De.to=ge})(at||(e.SignatureHelp=at={}));var nt;(function(De){function Oe(ge,X){const Te=new k.$5N(Z.to(X.position),typeof X.label=="string"?X.label:X.label.map(ct.to.bind(void 0,ge)),X.kind&&it.to(X.kind));return Te.textEdits=X.textEdits&&X.textEdits.map(V.to),Te.tooltip=R.$6k(X.tooltip)?pe.to(X.tooltip):X.tooltip,Te.paddingLeft=X.paddingLeft,Te.paddingRight=X.paddingRight,Te}De.to=Oe})(nt||(e.InlayHint=nt={}));var ct;(function(De){function Oe(ge,X){const Te=new k.$4N(X.label);return Te.tooltip=R.$6k(X.tooltip)?pe.to(X.tooltip):X.tooltip,b.Command.is(X.command)&&(Te.command=ge.fromInternal(X.command)),X.location&&(Te.location=Ne.to(X.location)),Te}De.to=Oe})(ct||(e.InlayHintLabelPart=ct={}));var it;(function(De){function Oe(X){return X}De.from=Oe;function ge(X){return X}De.to=ge})(it||(e.InlayHintKind=it={}));var _e;(function(De){function Oe(X){return{range:Y.from(X.range),url:X.target,tooltip:X.tooltip}}De.from=Oe;function ge(X){let Te;if(X.url)try{Te=typeof X.url=="string"?m.URI.parse(X.url,!0):m.URI.revive(X.url)}catch{}const je=new k.$$N(Y.to(X.range),Te);return je.tooltip=X.tooltip,je}De.to=ge})(_e||(e.DocumentLink=_e={}));var Je;(function(De){function Oe(X){const Te=new k.$bO(X.label);return X.textEdit&&(Te.textEdit=V.to(X.textEdit)),X.additionalTextEdits&&(Te.additionalTextEdits=X.additionalTextEdits.map(je=>V.to(je))),Te}De.to=Oe;function ge(X){return{label:X.label,textEdit:X.textEdit?V.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Te=>V.from(Te)):void 0}}De.from=ge})(Je||(e.ColorPresentation=Je={}));var et;(function(De){function Oe(X){return new k.$_N(X[0],X[1],X[2],X[3])}De.to=Oe;function ge(X){return[X.red,X.green,X.blue,X.alpha]}De.from=ge})(et||(e.Color=et={}));var be;(function(De){function Oe(X){return{range:Y.from(X.range)}}De.from=Oe;function ge(X){return new k.$UN(Y.to(X.range))}De.to=ge})(be||(e.SelectionRange=be={}));var Le;(function(De){function Oe(ge){switch(ge){case s.SaveReason.AUTO:return k.TextDocumentSaveReason.AfterDelay;case s.SaveReason.EXPLICIT:return k.TextDocumentSaveReason.Manual;case s.SaveReason.FOCUS_CHANGE:case s.SaveReason.WINDOW_CHANGE:return k.TextDocumentSaveReason.FocusOut}}De.to=Oe})(Le||(e.TextDocumentSaveReason=Le={}));var ve;(function(De){function Oe(X){switch(X){case k.TextEditorLineNumbersStyle.Off:return $.RenderLineNumbersType.Off;case k.TextEditorLineNumbersStyle.Relative:return $.RenderLineNumbersType.Relative;case k.TextEditorLineNumbersStyle.Interval:return $.RenderLineNumbersType.Interval;case k.TextEditorLineNumbersStyle.On:default:return $.RenderLineNumbersType.On}}De.from=Oe;function ge(X){switch(X){case $.RenderLineNumbersType.Off:return k.TextEditorLineNumbersStyle.Off;case $.RenderLineNumbersType.Relative:return k.TextEditorLineNumbersStyle.Relative;case $.RenderLineNumbersType.Interval:return k.TextEditorLineNumbersStyle.Interval;case $.RenderLineNumbersType.On:default:return k.TextEditorLineNumbersStyle.On}}De.to=ge})(ve||(e.TextEditorLineNumbersStyle=ve={}));var ye;(function(De){function Oe(X){if(X===k.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(X===k.EndOfLine.LF)return t.EndOfLineSequence.LF}De.from=Oe;function ge(X){if(X===t.EndOfLineSequence.CRLF)return k.EndOfLine.CRLF;if(X===t.EndOfLineSequence.LF)return k.EndOfLine.LF}De.to=ge})(ye||(e.EndOfLine=ye={}));var ee;(function(De){function Oe(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case k.ProgressLocation.SourceControl:return i.ProgressLocation.Scm;case k.ProgressLocation.Window:return i.ProgressLocation.Window;case k.ProgressLocation.Notification:return i.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}De.from=Oe})(ee||(e.ProgressLocation=ee={}));var ie;(function(De){function Oe(X){const Te={start:X.start+1,end:X.end+1};return X.kind&&(Te.kind=we.from(X.kind)),Te}De.from=Oe;function ge(X){const Te={start:X.start-1,end:X.end-1};return X.kind&&(Te.kind=we.to(X.kind)),Te}De.to=ge})(ie||(e.FoldingRange=ie={}));var we;(function(De){function Oe(X){if(X)switch(X){case k.FoldingRangeKind.Comment:return b.$Nu.Comment;case k.FoldingRangeKind.Imports:return b.$Nu.Imports;case k.FoldingRangeKind.Region:return b.$Nu.Region}}De.from=Oe;function ge(X){if(X)switch(X.value){case b.$Nu.Comment.value:return k.FoldingRangeKind.Comment;case b.$Nu.Imports.value:return k.FoldingRangeKind.Imports;case b.$Nu.Region.value:return k.FoldingRangeKind.Region}}De.to=ge})(we||(e.FoldingRangeKind=we={}));var He;(function(De){function Oe(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?Y.from(ge.selection):void 0,override:typeof ge.override=="boolean"?s.$TF.id:void 0}}De.from=Oe})(He||(e.TextEditorOpenOptions=He={}));var Ke;(function(De){function Oe(je){return je instanceof k.$wO?je.toJSON():typeof je=="string"?je:ge(je)||X(je)?new k.$wO(je.baseUri??je.base,je.pattern).toJSON():je}De.from=Oe;function ge(je){const Xe=je;return Xe?m.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function X(je){const Xe=je;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Te(je){return typeof je=="string"?je:new k.$wO(m.URI.revive(je.baseUri),je.pattern)}De.to=Te})(Ke||(e.GlobPattern=Ke={}));var xe;(function(De){function Oe(ge){if(ge){if(Array.isArray(ge))return ge.map(Oe);if(typeof ge=="string")return ge;{const X=ge;return{language:X.language,scheme:X.scheme,pattern:Ke.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}De.from=Oe})(xe||(e.LanguageSelector=xe={}));var tt;(function(De){function Oe(X){return!!X&&typeof X=="object"&&"documents"in X&&Array.isArray(X.documents)&&X.documents.every(Te=>Array.isArray(Te)&&Te.every(je=>je&&typeof je=="object"&&"uri"in je&&m.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Xe=>Xe instanceof k.$zN)))}De.is=Oe;function ge(X){return{documents:X.documents.map(Te=>Te.map(je=>({uri:m.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Xe=>Y.from(Xe))})))}}De.from=ge})(tt||(e.MappedEditsContext=tt={}));var lt;(function(De){function Oe(X){return{start:X.start,end:X.end}}De.from=Oe;function ge(X){return new k.$ZO(X.start,X.end)}De.to=ge})(lt||(e.NotebookRange=lt={}));var pt;(function(De){function Oe(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}De.to=Oe;function ge(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}De.from=ge})(pt||(e.NotebookCellExecutionSummary=pt={}));var yt;(function(De){function Oe(ge){if(ge===P.NotebookCellExecutionState.Unconfirmed)return k.NotebookCellExecutionState.Pending;if(ge===P.NotebookCellExecutionState.Pending)return;if(ge===P.NotebookCellExecutionState.Executing)return k.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}De.to=Oe})(yt||(e.NotebookCellExecutionState=yt={}));var Ht;(function(De){function Oe(X){switch(X){case k.NotebookCellKind.Markup:return P.CellKind.Markup;case k.NotebookCellKind.Code:default:return P.CellKind.Code}}De.from=Oe;function ge(X){switch(X){case P.CellKind.Markup:return k.NotebookCellKind.Markup;case P.CellKind.Code:default:return k.NotebookCellKind.Code}}De.to=ge})(Ht||(e.NotebookCellKind=Ht={}));var Mt;(function(De){function Oe(X){const Te={metadata:X.metadata??Object.create(null),cells:[]};for(const je of X.cells)k.$1O.validate(je),Te.cells.push(dt.from(je));return Te}De.from=Oe;function ge(X){const Te=new k.$2O(X.cells.map(dt.to));return(0,h.$tg)(X.metadata)||(Te.metadata=X.metadata),Te}De.to=ge})(Mt||(e.NotebookData=Mt={}));var dt;(function(De){function Oe(X){return{cellKind:Ht.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:pt.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(vt.from):[]}}De.from=Oe;function ge(X){return new k.$1O(Ht.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(vt.to):void 0,X.metadata,X.internalMetadata?pt.to(X.internalMetadata):void 0)}De.to=ge})(dt||(e.NotebookCellData=dt={}));var Et;(function(De){function Oe(X){return{mime:X.mime,valueBytes:r.$Pe.wrap(X.data)}}De.from=Oe;function ge(X){return new k.$3O(X.valueBytes.buffer,X.mime)}De.to=ge})(Et||(e.NotebookCellOutputItem=Et={}));var vt;(function(De){function Oe(X){return{outputId:X.id,items:X.items.map(Et.from),metadata:X.metadata}}De.from=Oe;function ge(X){const Te=X.items.map(Et.to);return new k.$4O(Te,X.outputId,X.metadata)}De.to=ge})(vt||(e.NotebookCellOutput=vt={}));var Kt;(function(De){function Oe(Te){return X(Te)?{include:Ke.from(Te.include)??void 0,exclude:Ke.from(Te.exclude)??void 0}:Ke.from(Te)??void 0}De.from=Oe;function ge(Te){return X(Te)?{include:Ke.to(Te.include),exclude:Ke.to(Te.exclude)}:Ke.to(Te)}De.to=ge;function X(Te){const je=Te;return je?!(0,h.$pg)(je.include)&&!(0,h.$pg)(je.exclude):!1}})(Kt||(e.NotebookExclusiveDocumentPattern=Kt={}));var zt;(function(De){function Oe(ge,X,Te){const je=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===k.NotebookCellStatusBarAlignment.Left?P.CellStatusbarAlignment.Left:P.CellStatusbarAlignment.Right,command:X.toInternal(je,Te),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}De.from=Oe})(zt||(e.NotebookStatusBarItem=zt={}));var St;(function(De){function Oe(ge,X,Te){const je=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:X.toInternal(je,Te),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}De.from=Oe})(St||(e.NotebookKernelSourceAction=St={}));var Bt;(function(De){function Oe(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}De.from=Oe})(Bt||(e.NotebookDocumentContentOptions=Bt={}));var Ot;(function(De){function Oe(X){return{uri:X.uri,provides:X.provides}}De.from=Oe;function ge(X){return new k.$6O(m.URI.revive(X.uri),X.provides)}De.to=ge})(Ot||(e.NotebookRendererScript=Ot={}));var ut;(function(De){function Oe(X){return{message:pe.fromStrict(X.message)||"",type:z.TestMessageType.Error,expected:X.expectedOutput,actual:X.actualOutput,contextValue:X.contextValue,location:X.location&&{range:Y.from(X.location.range),uri:X.location.uri}}}De.from=Oe;function ge(X){const Te=new k.$_O(typeof X.message=="string"?X.message:pe.to(X.message));return Te.actualOutput=X.actual,Te.expectedOutput=X.expected,Te.contextValue=X.contextValue,Te.location=X.location?Ne.to(X.location):void 0,Te}De.to=ge})(ut||(e.TestMessage=ut={}));var mt;(function(De){De.namespace=z.$ZI,De.denamespace=z.$1I})(mt||(e.TestTag=mt={}));var bt;(function(De){function Oe(X){const Te=(0,g.$XP)(X).controllerId;return{extId:T.$UI.fromExtHostTestItem(X,Te).toString(),label:X.label,uri:m.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(je=>mt.namespace(Te,je.id)),range:p.$Nt.lift(Y.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&pe.fromStrict(X.error)||null}}De.from=Oe;function ge(X){return{parent:void 0,error:void 0,id:T.$UI.fromString(X.extId).localId,label:X.label,uri:m.URI.revive(X.uri),tags:(X.tags||[]).map(Te=>{const{tagId:je}=mt.denamespace(Te);return new k.$aP(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:Y.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}De.toPlain=ge})(bt||(e.TestItem=bt={})),function(De){function Oe(X){return{id:X.id}}De.from=Oe;function ge(X){return new k.$aP(X.id)}De.to=ge}(mt||(e.TestTag=mt={}));var Pt;(function(De){const Oe=(X,Te)=>{const je=X.value;if(!je)return;const Xe={...bt.toPlain(je.item),parent:Te,taskStates:je.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(st=>st.type===z.TestMessageType.Error).map(ut.to)})),children:[]};if(X.children)for(const Ue of X.children.values()){const st=Oe(Ue,Xe);st&&Xe.children.push(st)}return Xe};function ge(X){const Te=new f.$TI;for(const Ue of X.items)Te.insert(T.$UI.fromString(Ue.item.extId).path,Ue);const je=[Te.nodes],Xe=[];for(;je.length;)for(const Ue of je.pop())Ue.value?Xe.push(Ue):Ue.children&&je.push(Ue.children.values());return{completedAt:X.completedAt,results:Xe.map(Ue=>Oe(Ue)).filter(h.$og)}}De.to=ge})(Pt||(e.TestResults=Pt={}));var Xt;(function(De){function Oe(je){return{covered:je.covered,total:je.total}}function ge(je){return"line"in je?Z.from(je):Y.from(je)}function X(je){if(typeof je.executed=="number"&&je.executed<0)throw new Error(`Invalid coverage count ${je.executed}`);return"branches"in je?{count:je.executed,location:ge(je.location),type:z.DetailType.Statement,branches:je.branches.length?je.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ge(Xe.location),label:Xe.label})):void 0}:{type:z.DetailType.Declaration,name:je.name,count:je.executed,location:ge(je.location)}}De.fromDetails=X;function Te(je,Xe,Ue){return k.$cP(Ue.statementCoverage),k.$cP(Ue.branchCoverage),k.$cP(Ue.declarationCoverage),{id:Xe,uri:Ue.uri,statement:Oe(Ue.statementCoverage),branch:Ue.branchCoverage&&Oe(Ue.branchCoverage),declaration:Ue.declarationCoverage&&Oe(Ue.declarationCoverage),testIds:Ue instanceof k.$dP&&Ue.fromTests.length?Ue.fromTests.map(st=>T.$UI.fromExtHostTestItem(st,je).toString()):void 0}}De.fromFile=Te})(Xt||(e.TestCoverage=Xt={}));var Lt;(function(De){function Oe(ge){switch(ge){case b.CodeActionTriggerType.Invoke:return k.CodeActionTriggerKind.Invoke;case b.CodeActionTriggerType.Auto:return k.CodeActionTriggerKind.Automatic}}De.to=Oe})(Lt||(e.CodeActionTriggerKind=Lt={}));var Nt;(function(De){function Oe(X){const Te=new k.$hP(G.to(X.kind),X.name,X.detail||"",m.URI.revive(X.uri),Y.to(X.range),Y.to(X.selectionRange));return Te._sessionId=X._sessionId,Te._itemId=X._itemId,Te}De.to=Oe;function ge(X,Te,je){if(Te=Te??X._sessionId,je=je??X._itemId,Te===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:je,kind:G.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:Y.from(X.range),selectionRange:Y.from(X.selectionRange),tags:X.tags?.map(Q.from)}}De.from=ge})(Nt||(e.TypeHierarchyItem=Nt={}));var Ut;(function(De){function Oe(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}De.from=Oe})(Ut||(e.ViewBadge=Ut={}));var Jt;(function(De){function Oe(je,Xe,Ue){const st=Xe.fileData;return st?new k.$oO(new k.$pO(st.name,m.URI.revive(st.uri),st.id,(0,I.$gb)(()=>Ue(st.id)))):je===S.$0s.uriList&&Xe.uriListData?new k.$nO(Te(Xe.uriListData)):new k.$nO(Xe.asString)}De.to=Oe;async function ge(je,Xe){const Ue=await Xe.asString();if(je===S.$0s.uriList)return{asString:Ue,fileData:void 0,uriListData:X(Ue)};const st=Xe.asFile();return{asString:Ue,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}De.from=ge;function X(je){return E.$ru.split(je).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return m.URI.parse(Xe)}catch{}return Xe})}function Te(je){return E.$ru.create(je.map(Xe=>typeof Xe=="string"?Xe:m.URI.revive(Xe)))}})(Jt||(e.DataTransferItem=Jt={}));var Ft;(function(De){function Oe(X,Te){const je=X.items.map(([Xe,Ue])=>[Xe,Jt.to(Xe,Ue,Te)]);return new k.$qO(je)}De.toDataTransfer=Oe;async function ge(X){const Te={items:[]},je=[];for(const[Xe,Ue]of X)je.push((async()=>{Te.items.push([Xe,await Jt.from(Xe,Ue)])})());return await Promise.all(je),Te}De.from=ge})(Ft||(e.DataTransfer=Ft={}));var Rt;(function(De){function Oe(X,Te){return{kind:"reply",agentId:X.participant??Te?.agentId??"",subCommand:X.command??Te?.command,message:X.prompt,title:X.label}}De.from=Oe;function ge(X){return{prompt:X.message,label:X.title,participant:X.agentId,command:X.subCommand}}De.to=ge})(Rt||(e.ChatFollowup=Rt={}));var kt;(function(De){function Oe(X){switch(X){case u.ChatMessageRole.System:return k.LanguageModelChatMessageRole.System;case u.ChatMessageRole.User:return k.LanguageModelChatMessageRole.User;case u.ChatMessageRole.Assistant:return k.LanguageModelChatMessageRole.Assistant}}De.to=Oe;function ge(X){switch(X){case k.LanguageModelChatMessageRole.System:return u.ChatMessageRole.System;case k.LanguageModelChatMessageRole.User:return u.ChatMessageRole.User;case k.LanguageModelChatMessageRole.Assistant:return u.ChatMessageRole.Assistant}return u.ChatMessageRole.User}De.from=ge})(kt||(e.LanguageModelChatMessageRole=kt={}));var rn;(function(De){function Oe(X){let Te="",je;X.content.type==="text"?Te=X.content.value:je=new k.$IP(X.content.name,X.content.value,X.content.isError);const Xe=kt.to(X.role),Ue=new k.$JP(Xe,Te,X.name);return je!==void 0&&(Ue.content2=je),Ue}De.to=Oe;function ge(X){const Te=kt.from(X.role),je=X.name;let Xe;return X.content2 instanceof k.$IP?Xe={type:"function_result",name:X.content2.name,value:X.content2.content,isError:X.content2.isError}:Xe={type:"text",value:X.content},{role:Te,name:je,content:Xe}}De.from=ge})(rn||(e.LanguageModelChatMessage=rn={}));var Wt;(function(De){function Oe(X){return{kind:"markdownContent",content:pe.from(X.value)}}De.from=Oe;function ge(X){return new k.$uP(pe.to(X.content))}De.to=ge})(Wt||(e.ChatResponseMarkdownPart=Wt={}));var Qt;(function(De){function Oe(X){return{kind:"markdownVuln",content:pe.from(X.value),vulnerabilities:X.vulnerabilities}}De.from=Oe;function ge(X){return new k.$vP(pe.to(X.content),X.vulnerabilities)}De.to=ge})(Qt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Qt={}));var At;(function(De){function Oe(X){return{kind:"agentDetection",agentId:X.participant,command:X.command}}De.from=Oe;function ge(X){return new k.$wP(X.agentId,X.command)}De.to=ge})(At||(e.ChatResponseDetectedParticipantPart=At={}));var tn;(function(De){function Oe(ge){return{kind:"confirmation",title:ge.title,message:ge.message,data:ge.data}}De.from=Oe})(tn||(e.ChatResponseConfirmationPart=tn={}));var qt;(function(De){function Oe(X){const{value:Te,baseUri:je}=X;function Xe(Ue,st){return Ue.map(gt=>{const jt=m.URI.joinPath(st,gt.name);return{label:gt.name,uri:jt,children:gt.children&&Xe(gt.children,jt)}})}return{kind:"treeData",treeData:{label:(0,w.$eh)(je),uri:je,children:Xe(Te,je)}}}De.from=Oe;function ge(X){const Te=(0,o.$di)(X.treeData);function je(st){return st.map(gt=>({name:gt.label,children:gt.children&&je(gt.children)}))}const Xe=Te.uri,Ue=Te.children?je(Te.children):[];return new k.$yP(Ue,Xe)}De.to=ge})(qt||(e.ChatResponseFilesPart=qt={}));var Tt;(function(De){function Oe(X){const Te=je=>m.URI.isUri(je);return{kind:"inlineReference",name:X.title,inlineReference:Te(X.value)?X.value:J.from(X.value)}}De.from=Oe;function ge(X){const Te=(0,o.$di)(X);return new k.$zP(m.URI.isUri(Te.inlineReference)?Te.inlineReference:J.to(Te.inlineReference),X.name)}De.to=ge})(Tt||(e.ChatResponseAnchorPart=Tt={}));var Vt;(function(De){function Oe(X){return{kind:"progressMessage",content:pe.from(X.value)}}De.from=Oe;function ge(X){return new k.$AP(X.content.value)}De.to=ge})(Vt||(e.ChatResponseProgressPart=Vt={}));var wt;(function(De){function Oe(X){return{kind:"warning",content:pe.from(X.value)}}De.from=Oe;function ge(X){return new k.$CP(X.content.value)}De.to=ge})(wt||(e.ChatResponseWarningPart=wt={}));var Yt;(function(De){function Oe(ge){return{kind:"progressTask",content:pe.from(ge.value)}}De.from=Oe})(Yt||(e.ChatTask=Yt={}));var It;(function(De){function Oe(ge){return{kind:"progressTaskResult",content:typeof ge=="string"?pe.from(ge):void 0}}De.from=Oe})(It||(e.ChatTaskResult=It={}));var sn;(function(De){function Oe(X,Te,je){return{kind:"command",command:Te.toInternal(X.value,je)??{command:X.value.command,title:X.value.title}}}De.from=Oe;function ge(X,Te){return new k.$DP(Te.fromInternal(X.command)??{command:X.command.id,title:X.command.title})}De.to=ge})(sn||(e.ChatResponseCommandButtonPart=sn={}));var cn;(function(De){function Oe(X){return{kind:"textEdit",uri:X.uri,edits:X.edits.map(Te=>V.from(Te))}}De.from=Oe;function ge(X){return new k.$FP(m.URI.revive(X.uri),X.edits.map(Te=>V.to(Te)))}De.to=ge})(cn||(e.ChatResponseTextEditPart=cn={}));var un;(function(De){function Oe(X){const Te=a.ThemeIcon.isThemeIcon(X.iconPath)?X.iconPath:m.URI.isUri(X.iconPath)?{light:m.URI.revive(X.iconPath)}:X.iconPath&&"light"in X.iconPath&&"dark"in X.iconPath&&m.URI.isUri(X.iconPath.light)&&m.URI.isUri(X.iconPath.dark)?{light:m.URI.revive(X.iconPath.light),dark:m.URI.revive(X.iconPath.dark)}:void 0;return"variableName"in X.value?{kind:"reference",reference:{variableName:X.value.variableName,value:m.URI.isUri(X.value.value)||!X.value.value?X.value.value:J.from(X.value.value)},iconPath:Te}:{kind:"reference",reference:m.URI.isUri(X.value)?X.value:J.from(X.value),iconPath:Te}}De.from=Oe;function ge(X){const Te=(0,o.$di)(X),je=Xe=>m.URI.isUri(Xe)?Xe:J.to(Xe);return new k.$EP("variableName"in Te.reference?{variableName:Te.reference.variableName,value:Te.reference.value&&je(Te.reference.value)}:je(Te.reference))}De.to=ge})(un||(e.ChatResponseReferencePart=un={}));var hn;(function(De){function Oe(Te,je,Xe){return Te instanceof k.$uP?Wt.from(Te):Te instanceof k.$zP?Tt.from(Te):Te instanceof k.$EP?un.from(Te):Te instanceof k.$AP?Vt.from(Te):Te instanceof k.$yP?qt.from(Te):Te instanceof k.$DP?sn.from(Te,je,Xe):Te instanceof k.$FP?cn.from(Te):Te instanceof k.$vP?Qt.from(Te):Te instanceof k.$wP?At.from(Te):Te instanceof k.$CP?wt.from(Te):{kind:"markdownContent",content:pe.from("")}}De.from=Oe;function ge(Te,je){switch(Te.kind){case"reference":return un.to(Te);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return X(Te,je)}}De.to=ge;function X(Te,je){switch(Te.kind){case"markdownContent":return Wt.to(Te);case"inlineReference":return Tt.to(Te);case"progressMessage":return;case"treeData":return qt.to(Te);case"command":return sn.to(Te,je)}}De.toContent=X})(hn||(e.ChatResponsePart=hn={}));var gn;(function(De){function Oe(ge){return{prompt:ge.message,command:ge.command,attempt:ge.attempt??0,enableCommandDetection:ge.enableCommandDetection??!0,references:ge.variables.variables.map($n.to),location:fn.to(ge.location),acceptedConfirmationData:ge.acceptedConfirmationData,rejectedConfirmationData:ge.rejectedConfirmationData}}De.to=Oe})(gn||(e.ChatAgentRequest=gn={}));var fn;(function(De){function Oe(X){switch(X){case c.ChatAgentLocation.Notebook:return k.ChatLocation.Notebook;case c.ChatAgentLocation.Terminal:return k.ChatLocation.Terminal;case c.ChatAgentLocation.Panel:return k.ChatLocation.Panel;case c.ChatAgentLocation.Editor:return k.ChatLocation.Editor}}De.to=Oe;function ge(X){switch(X){case k.ChatLocation.Notebook:return c.ChatAgentLocation.Notebook;case k.ChatLocation.Terminal:return c.ChatAgentLocation.Terminal;case k.ChatLocation.Panel:return c.ChatAgentLocation.Panel;case k.ChatLocation.Editor:return c.ChatAgentLocation.Editor}}De.from=ge})(fn||(e.ChatLocation=fn={}));var $n;(function(De){function Oe(ge){const X=ge.value;if(!X)throw new Error("Invalid value reference");return{id:ge.id,name:ge.name,range:ge.range&&[ge.range.start,ge.range.endExclusive],value:(0,m.$yc)(X)?m.URI.revive(X):X&&typeof X=="object"&&"uri"in X&&"range"in X&&(0,m.$yc)(X.uri)?J.to((0,o.$di)(X)):X,modelDescription:ge.modelDescription}}De.to=Oe})($n||(e.ChatAgentValueReference=$n={}));var Sn;(function(De){function Oe(ge,X,Te){return{id:ge.id,label:ge.label,fullName:ge.fullName,icon:ge.icon?.id,value:ge.values[0].value,insertText:ge.insertText,detail:ge.detail,documentation:ge.documentation,command:X.toInternal(ge.command,Te)}}De.from=Oe})(Sn||(e.ChatAgentCompletionItem=Sn={}));var wn;(function(De){function Oe(ge){return{errorDetails:ge.errorDetails,metadata:ge.metadata}}De.to=Oe})(wn||(e.ChatAgentResult=wn={}));var pn;(function(De){function Oe(ge,X,Te){if(X.action.kind==="vote")return;const je=wn.to(ge);if(X.action.kind==="command"){const Xe=X.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Te.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:je}}else return X.action.kind==="followUp"?{action:{kind:"followUp",followup:Rt.to(X.action.followup)},result:je}:X.action.kind==="inlineChat"?{action:{kind:"editor",accepted:X.action.action==="accepted"},result:je}:{action:X.action,result:je}}De.to=Oe})(pn||(e.ChatAgentUserActionEvent=pn={}));var bn;(function(De){function Oe(ge,X,Te){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand,shouldExecute:ge.shouldExecute}:"uri"in ge?{uri:ge.uri}:X.toInternal(ge,Te)}De.from=Oe})(bn||(e.TerminalQuickFix=bn={}));var vn;(function(De){function Oe(ge){return{kind:Zt.to(ge.kind)}}De.to=Oe})(vn||(e.PartialAcceptInfo=vn={}));var Zt;(function(De){function Oe(ge){switch(ge){case b.PartialAcceptTriggerKind.Word:return k.PartialAcceptTriggerKind.Word;case b.PartialAcceptTriggerKind.Line:return k.PartialAcceptTriggerKind.Line;case b.PartialAcceptTriggerKind.Suggest:return k.PartialAcceptTriggerKind.Suggest;default:return k.PartialAcceptTriggerKind.Unknown}}De.to=Oe})(Zt||(e.PartialAcceptTriggerKind=Zt={}));var Dn;(function(De){function Oe(ge,X){return{id:X,label:ge.label,description:ge.description,canEdit:ge.canEdit,collapsibleState:ge.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ge.contextValue}}De.from=Oe})(Dn||(e.DebugTreeItem=Dn={}));var xt;(function(De){function Oe(ge){return{name:ge.name,description:ge.description,parametersSchema:ge.parametersSchema}}De.to=Oe})(xt||(e.LanguageModelToolDescription=xt={}))}),define(Se[322],ke([1,0,51,148,76,147,104,154,4]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=e.$cQ=e.$bQ=void 0,n=Be(n),A=Be(A);const o=(d,b,t,l)=>{let i=b;return{enumerable:!0,configurable:!1,get(){return i},set(g){if(!t(i,g)){const s=i;i=g,d.listener?.(l(g,s))}}}},S=(d,b)=>d===b,v={range:(d,b)=>d===b?!0:!d||!b?!1:d.isEqual(b),label:S,description:S,sortText:S,busy:S,error:S,canResolveChildren:S,tags:(d,b)=>!(d.length!==b.length||d.some(t=>!b.find(l=>t.id===l.id)))},f=d=>b=>({op:I.TestItemEventOp.SetProp,update:d(b)}),w=(d,b)=>({range:(()=>{let t;const l=f(i=>({range:n.$Nt.lift(A.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return t},set(i){d.listener?.({op:I.TestItemEventOp.DocumentSynced}),v.range(t,i)||(t=i,d.listener?.(l(i)))}}})(),label:o(d,b,v.label,f(t=>({label:t}))),description:o(d,void 0,v.description,f(t=>({description:t}))),sortText:o(d,void 0,v.sortText,f(t=>({sortText:t}))),canResolveChildren:o(d,!1,v.canResolveChildren,t=>({op:I.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:o(d,!1,v.busy,f(t=>({busy:t}))),error:o(d,void 0,v.error,f(t=>({error:A.MarkdownString.fromStrict(t)||null}))),tags:o(d,[],v.tags,(t,l)=>({op:I.TestItemEventOp.SetTags,new:t.map(A.TestTag.from),old:l.map(A.TestTag.from)}))}),a=d=>{const b=E.$UI.fromString(d.extId),t=new m(b.controllerId,b.localId,d.label,y.URI.revive(d.uri)||void 0);return t.range=A.Range.to(d.range||void 0),t.description=d.description||void 0,t.sortText=d.sortText||void 0,t.tags=d.tags.map(l=>A.TestTag.to({id:(0,R.$1I)(l).tagId})),t},h=d=>{let b;for(const t of d.tests){const l=a(t.item);(0,r.$XP)(l).parent=b,b=l}return b};e.$bQ=h;class m{constructor(b,t,l,i){if(t.includes(E.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,r.$WP)(this,b);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof $?void 0:g.parent}},children:{value:(0,I.$VP)(g,r.$XP,m),enumerable:!0,writable:!1},...w(g,l)})}}e.$cQ=m;class $ extends m{constructor(b,t){super(b,b,t,void 0),this._isRoot=!0}}e.$dQ=$;class p extends I.$RP{constructor(b,t,l){super({controllerId:b,getDocumentVersion:i=>i&&l.getDocument(i)?.version,getApiFor:r.$XP,getChildren:i=>i.children,root:new $(b,t),toITestItem:A.TestItem.from})}}e.$eQ=p});var ln=this&&this.__classPrivateFieldSet||function(se,e,n,r,E){if(r==="m")throw new TypeError("Private method is not writable");if(r==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?se!==e||!E:!e.has(se))throw new TypeError("Cannot write private member to an object whose class did not declare it");return r==="a"?E.call(se,n):E?E.value=n:e.set(se,n),n},ft=this&&this.__classPrivateFieldGet||function(se,e,n,r){if(n==="a"&&!r)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?se!==e||!r:!e.has(se))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?r:n==="a"?r.call(se):r?r.value:e.get(se)};define(Se[323],ke([1,0,11,153,154,21,320,18,12,49,51,86,4,2,5,300,322,15,151,45,48,41,314,23]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t,l,i){"use strict";var g,s,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=void 0,r=Be(r),E=Be(E);let u=class{constructor(k,q,Y){g.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),c.set(this,void 0),ln(this,g,k.getProxy(R.$vN.MainThreadCommands),"f"),this.d=q,ln(this,c,Y,"f"),ln(this,s,k.getProxy(R.$vN.MainThreadTelemetry),"f"),this.converter=new D(this,J=>{const ne=this.c.get(J);return ne?.result===T.Void?ne:void 0},q),this.f=[{processArgument(J){return(0,o.$di)(J)}},{processArgument(J){return(0,I.$ho)(J,function(ne){if(S.$Nt.isIRange(ne))return E.Range.to(ne);if(v.$Mt.isIPosition(ne))return E.Position.to(ne);if(S.$Nt.isIRange(ne.range)&&f.URI.isUri(ne.uri))return E.location.to(ne);if(ne instanceof $.$Pe)return ne.buffer.buffer;if(!Array.isArray(ne))return ne})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const q=this.registerCommand(!1,k.id,async(...Y)=>{const J=k.args.map((Z,x)=>{if(!Z.validate(Y[x]))throw new Error(`Invalid argument '${Z.name}' when running '${k.id}', received: ${typeof Y[x]=="object"?JSON.stringify(Y[x],null,"	"):Y[x]} `);return Z.convert(Y[x])}),ne=await this.executeCommand(k.internalId,...J);return k.result.convert(ne,Y,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new r.$xN(()=>{q.dispose(),this.c.delete(k.id)})}registerCommand(k,q,Y,J,ne,Z){if(this.d.trace("ExtHostCommands#registerCommand",q),!q.trim().length)throw new Error("invalid id");if(this.b.has(q))throw new Error(`command '${q}' already exists`);return this.b.set(q,{callback:Y,thisArg:J,metadata:ne,extension:Z}),k&&ft(this,g,"f").$registerCommand(q),new r.$xN(()=>{this.b.delete(q)&&k&&ft(this,g,"f").$unregisterCommand(q)})}executeCommand(k,...q){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,q,!0)}async g(k,q,Y){if(this.b.has(k))return ft(this,g,"f").$fireCommandActivationEvent(k),this.h(k,q,!1);{let J=!1;const ne=(0,I.$ho)(q,function(Z){if(Z instanceof r.$yN)return E.Position.from(Z);if(Z instanceof r.$zN)return E.Range.from(Z);if(Z instanceof r.$JN)return E.location.from(Z);if(r.$ZO.isNotebookRange(Z))return E.NotebookRange.from(Z);if(Z instanceof ArrayBuffer)return J=!0,$.$Pe.wrap(new Uint8Array(Z));if(Z instanceof Uint8Array)return J=!0,$.$Pe.wrap(Z);if(Z instanceof $.$Pe)return J=!0,Z;if(!Array.isArray(Z))return Z});try{const Z=await ft(this,g,"f").$executeCommand(k,J?new p.$Vw(ne):ne,Y);return(0,o.$di)(Z)}catch(Z){if(Z instanceof Error&&Z.message==="$executeCommand:retry")return this.g(k,q,!1);throw Z}}}async h(k,q,Y){const J=this.b.get(k);if(!J)throw new Error("Unknown command");const{callback:ne,thisArg:Z,metadata:x}=J;if(x?.args)for(let K=0;K<x.args.length;K++)try{(0,n.$xg)(q[K],x.args[K].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${x.args[K].name}' - ${x.args[K].description}`)}const le=b.$he.create();try{return await ne.apply(Z,q)}catch(K){if(k===this.converter.delegatingCommandId){const ae=this.converter.getActualCommand(...q);ae&&(k=ae.command)}if(this.d.error(K,k,J.extension?.identifier),!Y)throw K;if(J.extension?.identifier){const ae=ft(this,c,"f").onExtensionError(J.extension.identifier,K);this.d.trace("forwarded error to extension?",ae,J.extension?.identifier)}throw new class extends Error{constructor(){super((0,d.$rj)(K)),this.id=k,this.source=J.extension?.displayName??J.extension?.name}}}finally{this.j(J,k,le.elapsed())}}j(k,q,Y){k.extension&&ft(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new t.$wp(q),duration:Y})}$executeContributedCommand(k,...q){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const Y=this.b.get(k);return Y?(q=q.map(J=>this.f.reduce((ne,Z)=>Z.processArgument(ne,Y.extension?.identifier),J)),this.h(k,q,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),ft(this,g,"f").$getCommands().then(q=>(k&&(q=q.filter(Y=>Y[0]!=="_")),q))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[q,Y]of this.b){const{metadata:J}=Y;J&&(k[q]=J)}return Promise.resolve(k)}};e.$kQ=u,g=new WeakMap,s=new WeakMap,c=new WeakMap,e.$kQ=u=ze([Fe(0,h.$2P),Fe(1,y.$ak),Fe(2,l.$jQ)],u),e.$lQ=(0,a.$Gi)("IExtHostCommands");class D{constructor(k,q,Y){this.d=k,this.f=q,this.g=Y,this.delegatingCommandId=`__vsc${(0,i.$3g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,q){if(!k)return;const Y={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return Y;const J=this.f(k.command);if(J)Y.id=J.internalId,Y.arguments=J.args.map((ne,Z)=>ne.convert(k.arguments&&k.arguments[Z]));else if((0,A.$Ob)(k.arguments)){const ne=`${k.command} /${++this.c}`;this.b.set(ne,k),q.add((0,w.$Vc)(()=>{this.b.delete(ne),this.g.trace("CommandsConverter#DISPOSE",ne)})),Y.$ident=ne,Y.id=this.delegatingCommandId,Y.arguments=[ne],this.g.trace("CommandsConverter#CREATE",k.command,ne)}return Y}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const q=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],q?q.command:"MISSING"),q?this.d.executeCommand(q.command,...q.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$mQ=D;class P{static Arr(k){return new P(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,q=>Array.isArray(q)&&q.every(Y=>k.validate(Y)),q=>q.map(Y=>k.convert(Y)))}constructor(k,q,Y,J){this.name=k,this.description=q,this.validate=Y,this.convert=J}optional(){return new P(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,q){return new P(k??this.name,q??this.description,this.validate,this.convert)}}e.$nQ=P,P.Uri=new P("uri","Uri of a text document",C=>f.URI.isUri(C),C=>C),P.Position=new P("position","A position in a text document",C=>r.$yN.isPosition(C),E.Position.from),P.Range=new P("range","A range in a text document",C=>r.$zN.isRange(C),E.Range.from),P.Selection=new P("selection","A selection in a text document",C=>r.$AN.isSelection(C),E.Selection.from),P.Number=new P("number","",C=>typeof C=="number",C=>C),P.String=new P("string","",C=>typeof C=="string",C=>C),P.StringArray=P.Arr(P.String),P.CallHierarchyItem=new P("item","A call hierarchy item",C=>C instanceof r.$VN,E.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",C=>C instanceof r.$hP,E.TypeHierarchyItem.from),P.TestItem=new P("testItem","A VS Code TestItem",C=>C instanceof m.$cQ,E.TestItem.from);class T{constructor(k,q){this.description=k,this.convert=q}}e.$oQ=T,T.Void=new T("no result",C=>C);class z{constructor(k,q,Y,J,ne){this.id=k,this.internalId=q,this.description=Y,this.args=J,this.result=ne}}e.$pQ=z}),define(Se[324],ke([1,0,10,2,13,3,250]),function(se,e,n,r,E,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aR=e.$_Q=void 0,e.$_Q="remoteFilesystem";class A extends R.$$Q{static register(o,S,v){const f=o.getConnection();if(!f)return r.$Xc.None;const w=new r.$Wc,a=(async()=>{try{const h=await o.getRawEnvironment();h?S.registerProvider(E.Schemas.vscodeRemote,w.add(new A(h,f))):v.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(h){v.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,n.$ab)(h))}})();return w.add(S.onWillActivateFileSystemProvider(h=>{h.scheme===E.Schemas.vscodeRemote&&h.join(a)})),w}constructor(o,S){super(S.getChannel(e.$_Q),{pathCaseSensitive:o.os===I.OperatingSystem.Linux})}}e.$aR=A}),define(Se[77],ke([1,0,96,85,31,325,15,10,6,2,9,3,23,50,61]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=s,e.$zi=c,e.$Bi=P,e.$Ci=T;const h=3e4;class m{traceSocketEvent(C,k){a.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,k)}constructor(C,k=""){this.f=!0,this.debugLabel=k,this.socket=C,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=Y=>{if(this.traceSocketEvent(a.SocketDiagnosticsEventType.Error,{code:Y?.code,message:Y?.message}),Y){if(Y.code==="EPIPE")return;(0,A.$3)(Y)}},this.socket.on("error",this.a);let q;this.b=Y=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Close,{hadError:Y}),this.f=!1,q&&clearTimeout(q)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,q=setTimeout(()=>C.destroy(),h)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(C){const k=q=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Read,q),C(R.$Pe.wrap(q))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(C){const k=q=>{C({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:q,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(C){const k=()=>{C()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(C){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(a.SocketDiagnosticsEventType.Write,C),this.socket.write(C.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,A.$3)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,A.$3)(k)}}end(){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((C,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),C();return}const q=()=>{this.socket.off("close",q),this.socket.off("end",q),this.socket.off("error",q),this.socket.off("timeout",q),this.socket.off("drain",q),this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),C()};this.socket.on("close",q),this.socket.on("end",q),this.socket.on("error",q),this.socket.on("timeout",q),this.socket.on("drain",q)})}}e.$vi=m;var $;(function(z){z[z.MinHeaderByteSize=2]="MinHeaderByteSize",z[z.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var p;(function(z){z[z.PeekHeader=1]="PeekHeader",z[z.ReadHeader=2]="ReadHeader",z[z.ReadBody=3]="ReadBody",z[z.Fin=4]="Fin"})(p||(p={}));class d extends o.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(C,k){this.socket.traceSocketEvent(C,k)}constructor(C,k,q,Y){super(),this.f=this.B(new y.$ne),this.g=this.B(new y.$ne),this.h=!1,this.j={state:p.PeekHeader,readLen:$.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=C,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:q?.byteLength||0,recordInflateBytes:Y}),this.a=this.B(new b(this,k,q,Y,this.f,(J,ne)=>this.m(J,ne))),this.B(this.a.onError(J=>{console.error(J),(0,A.$3)(J),this.g.fire({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:J})})),this.b=new a.$qi,this.B(this.socket.onData(J=>this.n(J))),this.B(this.socket.onClose(async J=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(J)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this.f.event(C)}onClose(C){return this.g.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let k=0;for(;k<C.byteLength;)this.a.writeMessage(C.slice(k,Math.min(k+$.MaxWebSocketMessageLength,C.byteLength)),{compressed:!0,opcode:2}),k+=$.MaxWebSocketMessageLength}m(C,{compressed:k,opcode:q}){if(this.h)return;this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,C);let Y=$.MinHeaderByteSize;C.byteLength<126?Y+=0:C.byteLength<2**16?Y+=2:Y+=8;const J=R.$Pe.alloc(Y),ne=k?64:0,Z=q&15;if(J.writeUInt8(128|ne|Z,0),C.byteLength<126)J.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){J.writeUInt8(126,1);let x=1;J.writeUInt8(C.byteLength>>>8&255,++x),J.writeUInt8(C.byteLength>>>0&255,++x)}else{J.writeUInt8(127,1);let x=1;J.writeUInt8(0,++x),J.writeUInt8(0,++x),J.writeUInt8(0,++x),J.writeUInt8(0,++x),J.writeUInt8(C.byteLength>>>24&255,++x),J.writeUInt8(C.byteLength>>>16&255,++x),J.writeUInt8(C.byteLength>>>8&255,++x),J.writeUInt8(C.byteLength>>>0&255,++x)}this.socket.write(R.$Pe.concat([J,C]))}end(){this.h=!0,this.socket.end()}n(C){if(C.byteLength!==0){for(this.b.acceptChunk(C);this.b.byteLength>=this.j.readLen;)if(this.j.state===p.PeekHeader){const k=this.b.peek(this.j.readLen),q=k.readUInt8(0),Y=(q&128)>>>7,J=(q&64)>>>6,ne=q&15,Z=k.readUInt8(1),x=(Z&128)>>>7,le=Z&127;this.j.state=p.ReadHeader,this.j.readLen=$.MinHeaderByteSize+(x?4:0)+(le===126?2:0)+(le===127?8:0),this.j.fin=Y,this.j.firstFrameOfMessage&&(this.j.compressed=!!J),this.j.firstFrameOfMessage=!!Y,this.j.mask=0,this.j.opcode=ne,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===p.ReadHeader){const k=this.b.read(this.j.readLen),q=k.readUInt8(1),Y=(q&128)>>>7;let J=q&127,ne=1;J===126?J=k.readUInt8(++ne)*2**8+k.readUInt8(++ne):J===127&&(J=k.readUInt8(++ne)*0+k.readUInt8(++ne)*0+k.readUInt8(++ne)*0+k.readUInt8(++ne)*0+k.readUInt8(++ne)*2**24+k.readUInt8(++ne)*2**16+k.readUInt8(++ne)*2**8+k.readUInt8(++ne));let Z=0;Y&&(Z=k.readUInt8(++ne)*2**24+k.readUInt8(++ne)*2**16+k.readUInt8(++ne)*2**8+k.readUInt8(++ne)),this.j.state=p.ReadBody,this.j.readLen=J,this.j.mask=Z,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===p.ReadBody){const k=this.b.read(this.j.readLen);this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,k),i(k,this.j.mask),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,k),this.j.state=p.PeekHeader,this.j.readLen=$.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=d;class b extends o.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Pe.alloc(0)}constructor(C,k,q,Y,J,ne){super(),this.n=C,this.r=J,this.s=ne,this.a=this.B(new y.$ne),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new y.$ne),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new y.$ne),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new t(this.n,Y,q,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(Z=>this.a.fire(Z))),this.B(this.f.onError(Z=>this.a.fire(Z)))):(this.b=null,this.f=null)}writeMessage(C,k){this.g.push({data:C,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:C,options:k}=this.g.shift();if(this.f&&k.compressed){const q=await this.w(this.f,C);this.s(q,k)}else this.s(C,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(C,k){return new Promise((q,Y)=>{C.write(k),C.flush(J=>q(J))})}acceptFrame(C,k,q){this.h.push({data:C,isCompressed:k,isLastFrameOfMessage:q}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const C=this.h.shift();if(this.b&&C.isCompressed){const k=await this.C(this.b,C.data,C.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(C.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(C,k,q){return new Promise((Y,J)=>{C.write(k),q&&C.write(R.$Pe.fromByteArray([0,0,255,255])),C.flush(ne=>Y(ne))})}}class t extends o.$Xc{get recordedInflateBytes(){return this.j?R.$Pe.concat(this.f):R.$Pe.alloc(0)}constructor(C,k,q,Y){super(),this.h=C,this.j=k,this.a=this.B(new y.$ne),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(Y),this.b.on("error",J=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateError,{message:J?.message,code:J?.code}),this.a.fire(J)}),this.b.on("data",J=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateData,J),this.g.push(R.$Pe.wrap(J))}),q&&(this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialWrite,q.buffer),this.b.write(q.buffer),this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(C){this.j&&this.f.push(C.clone()),this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateWrite,C),this.b.write(C.buffer)}flush(C){this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateFlushFired);const k=R.$Pe.concat(this.g);this.g.length=0,C(k)})}}class l extends o.$Xc{constructor(C,k){super(),this.g=C,this.a=this.B(new y.$ne),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",q=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateError,{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateData,q),this.f.push(R.$Pe.wrap(q))})}write(C){this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateWrite,C.buffer),this.b.write(C.buffer)}flush(C){this.b.flush(2,()=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateFlushFired);let k=R.$Pe.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),C(k)})}}function i(z,C){if(C===0)return;const k=z.byteLength>>>2;for(let x=0;x<k;x++){const le=z.readUInt32BE(x*4);z.writeUInt32BE(le^C,x*4)}const q=k*4,Y=z.byteLength-q,J=C>>>24&255,ne=C>>>16&255,Z=C>>>8&255;Y>=1&&z.writeUInt8(z.readUInt8(q)^J,q),Y>=2&&z.writeUInt8(z.readUInt8(q+1)^ne,q+1),Y>=3&&z.writeUInt8(z.readUInt8(q+2)^Z,q+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const g={[v.Platform.Linux]:107,[v.Platform.Mac]:103};function s(){const z=(0,f.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${z}-sock`;const C=process.platform!=="darwin"&&e.$xi?e.$xi:(0,E.tmpdir)(),k=(0,S.$mc)(C,`vscode-ipc-${z}.sock`);return u(k),k}function c(z,C,k){const Y=(0,n.createHash)("sha256").update(z).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${Y}-${k}-${C}-sock`;const J=k.substr(0,4),ne=C.substr(0,6);let Z;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?Z=(0,S.$mc)(e.$xi,`vscode-${Y}-${J}-${ne}.sock`):Z=(0,S.$mc)(z,`${J}-${ne}.sock`),u(Z),Z}function u(z){const C=g[v.$o];typeof C=="number"&&z.length>=C&&console.warn(`WARNING: IPC handle "${z}" is longer than ${C} chars, try a shorter --user-data-dir`)}class D extends w.$ki{static b(C){const k=y.Event.fromNodeEventEmitter(C,"connection");return y.Event.map(k,q=>({protocol:new a.$ri(new m(q,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(q,"close"))}))}constructor(C){super(D.b(C)),this.d=C}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=D;function P(z){return new Promise((C,k)=>{const q=(0,r.createServer)();q.on("error",k),q.listen(z,()=>{q.removeListener("error",k),C(new D(q))})})}function T(z,C){return new Promise((k,q)=>{const Y=(0,r.createConnection)(z,()=>{Y.removeListener("error",q),k(a.$si.fromSocket(new m(Y,`ipc-client${C}`),C))});Y.once("error",q)})}}),define(Se[155],ke([1,0,93,14,15,10,11,27,28,94,12,47,269,325]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,e.$fs=m;let a=class extends v.$8p{constructor(p,d,b,t){super(t),this.m=p,this.n=d,this.r=b,this.s(),this.B(p.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,d){const{f:b,g:t}=this;let l;try{l=await(0,o.$Rm)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,I.$ab)(s)))}const i={...process.env,...l},g=p.agent?p.agent:await(0,f.$ds)(p.url||"",i,{proxyUrl:b,strictSSL:t});return p.agent=g,p.strictSSL=t,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>m(p,d))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((d,b)=>{se(["@vscode/proxy-agent"],d,b)}).then(Be)).loadSystemCertificates({log:this.r})}};e.$es=a,e.$es=a=ze([Fe(0,A.$aj),Fe(1,y.$Oi),Fe(2,S.$ak),Fe(3,S.$bk)],a);async function h($){return((0,n.parse)($.url).protocol==="https:"?await new Promise((b,t)=>{se(["https"],b,t)}).then(Be):await new Promise((b,t)=>{se(["http"],b,t)}).then(Be)).request}async function m($,p){return r.Promises.withAsyncBody(async(d,b)=>{const t=(0,n.parse)($.url),l=$.getRawRequest?$.getRawRequest($):await h($),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,R.$mg)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(i.auth=$.user+":"+$.password);const g=l(i,s=>{const c=(0,R.$kg)($.followRedirects)?$.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&c>0&&s.headers.location)m({...$,url:s.headers.location,followRedirects:c-1},p).then(d,b);else{let u=s;!$.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(u=s.pipe((0,w.createGunzip)())),d({res:s,stream:(0,E.$5e)(u)})}});g.on("error",b),$.timeout&&g.setTimeout($.timeout),$.isChromiumNetwork&&g.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&g.write($.data),g.end(),p.onCancellationRequested(()=>{g.abort(),b(new I.$8)})})}}),define(Se[156],ke([1,0,60,85,15,6,2,13,9,3,67,77,27,12,94,144,101,55,312]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=void 0,e.$En=d,n=Be(n),r=Be(r);async function d(s={},c,u,D,P,T){const z=await(0,m.$1m)(u,D.userDataPath);let C={};if(c)try{C=await(0,a.$Rm)(T,P,D.args,process.env)}catch(Z){P.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",Z)}const q={...process.env,...C,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(z,void 0,0),...s},Y=D.isBuilt?(0,y.$mc)(D.appRoot,"bin"):(0,y.$mc)(D.appRoot,"resources","server","bin-dev"),J=(0,y.$mc)(Y,"remote-cli");let ne=l(q,"PATH");return ne?ne=J+y.$wc+ne:ne=J,i(q,"PATH",ne),D.args["without-browser-env-var"]||(q.BROWSER=(0,y.$mc)(Y,"helpers",o.$c?"browser.cmd":"browser.sh")),g(q),q}class b{constructor(c,u){this.socket=c,this.initialDataChunk=u}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let c,u,D;return this.socket instanceof v.$vi?(c=!0,u=!1,D=E.$Pe.alloc(0)):(c=!1,u=this.socket.permessageDeflate,D=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:c,permessageDeflate:u,inflateBytes:D.buffer.toString("base64")}}}let t=class extends R.$Xc{constructor(c,u,D,P,T,z,C,k){super(),this.m=c,this.n=T,this.r=z,this.s=C,this.t=k,this.b=new I.$ne,this.onClose=this.b.event,this.c=!o.$c||!this.n.args["socket-path"],this.f=!1,this.g=u,this.h=null,this.j=new b(D,P),this.w("New connection established.")}dispose(){this.D(),super.dispose()}get u(){return`[${this.g}][${this.m.substr(0,8)}][ExtensionHostConnection] `}w(c){this.r.info(`${this.u}${c}`)}y(c){this.r.error(`${this.u}${c}`)}async z(c,u){const D=new R.$Wc;D.add(u.socket),D.add((0,R.$Vc)(()=>{c.destroy()}));const P=()=>{D.dispose()};D.add(u.socket.onEnd(P)),D.add(u.socket.onClose(P)),D.add(I.Event.fromNodeEventEmitter(c,"end")(P)),D.add(I.Event.fromNodeEventEmitter(c,"close")(P)),D.add(I.Event.fromNodeEventEmitter(c,"error")(P)),D.add(u.socket.onData(T=>c.write(T.buffer))),D.add(I.Event.fromNodeEventEmitter(c,"data")(T=>{u.socket.write(E.$Pe.wrap(T))})),u.initialDataChunk.byteLength>0&&c.write(u.initialDataChunk.buffer)}async C(c,u){await u.socketDrain();const D=u.toIExtHostSocketMessage();let P;u.socket instanceof v.$vi?P=u.socket.socket:P=u.socket.socket.socket,c.send(D,P)}shortenReconnectionGraceTimeIfNecessary(){if(!this.h)return;const c={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.h.send(c)}acceptReconnection(c,u,D){this.g=c,this.w("The client has reconnected.");const P=new b(u,D);if(!this.h){this.j=P;return}this.C(this.h,P)}D(){this.f||(this.f=!0,this.j&&(this.j.socket.end(),this.j=null),this.h&&(this.h.kill(),this.h=null),this.b.fire(void 0))}async start(c){try{let u=process.execArgv?process.execArgv.filter(J=>!/^--inspect(-brk)?=/.test(J)):[];c.port&&!process.pkg&&(u=[`--inspect${c.break?"-brk":""}=${c.port}`]);const D=await d(c.env,!0,c.language,this.n,this.r,this.t);(0,S.$mm)(D);let P;if(this.c)(0,p.$gn)(new p.$en,D),P=null;else{const{namedPipeServer:J,pipeName:ne}=await this.F();(0,p.$gn)(new p.$dn(ne),D),P=J}const T={env:D,execArgv:u,silent:!0};T.execArgv.unshift("--dns-result-order=ipv4first");const z=["--type=extensionHost","--transformURIs"],C=this.n.args["use-host-proxy"];z.push(`--useHostProxy=${C?"true":"false"}`),this.h=n.fork(A.$1g.asFileUri("bootstrap-fork").fsPath,z,T);const k=this.h.pid;this.w(`<${k}> Launched Extension Host Process.`),this.h.stdout.setEncoding("utf8"),this.h.stderr.setEncoding("utf8");const q=I.Event.fromNodeEventEmitter(this.h.stdout,"data"),Y=I.Event.fromNodeEventEmitter(this.h.stderr,"data");if(this.B(q(J=>this.w(`<${k}> ${J}`))),this.B(Y(J=>this.w(`<${k}><stderr> ${J}`))),this.h.on("error",J=>{this.y(`<${k}> Extension Host Process had an error`),this.r.error(J),this.D()}),this.h.on("exit",(J,ne)=>{this.s.setExitInfo(this.m,{code:J,signal:ne}),this.w(`<${k}> Extension Host Process exited with code: ${J}, signal: ${ne}.`),this.D()}),P)P.on("connection",J=>{P.close(),this.z(J,this.j)});else{const J=ne=>{ne.type==="VSCODE_EXTHOST_IPC_READY"&&(this.h.removeListener("message",J),this.C(this.h,this.j),this.j=null)};this.h.on("message",J)}}catch(u){console.error("ExtensionHostConnection errored"),u&&console.error(u)}}F(){return new Promise((c,u)=>{const D=(0,v.$yi)(),P=r.createServer();P.on("error",u),P.listen(D,()=>{P?.removeListener("error",u),c({pipeName:D,namedPipeServer:P})})})}};e.$Fn=t,e.$Fn=t=ze([Fe(4,$.$bn),Fe(5,w.$ak),Fe(6,h.$Ym),Fe(7,f.$aj)],t);function l(s,c){const u=Object.keys(s).filter(P=>P.toLowerCase()===c.toLowerCase()),D=u.length>0?u[0]:c;return s[D]}function i(s,c,u){const D=Object.keys(s).filter(T=>T.toLowerCase()===c.toLowerCase()),P=D.length>0?D[0]:c;s[P]=u}function g(s){for(const c of Object.keys(s))s[c]===null&&delete s[c]}});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[326],ke([1,0,89,12,71,130,27,47,155,41,24,30,142,140,95,123,62,2,124,72,13,16,29,55,133,92,134,10,4,9,32,267,88,36,138,70,3,64,145,34,54,73,143,141,126,127,228,327]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t,l,i,g,s,c,u,D,P,T,z,C,k,q,Y,J,ne,Z,x,le,K,ae,M,B,re,ce,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=_,m=$t(m);class W extends $.$Xc{constructor(O,te){super(),this.a=O,this.b=te,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const O=await this.f();await O.invokeFunction(async te=>{const V=te.get(R.$aj),j=te.get(r.$ak);J.$c&&(V.getValue("security.restrictUNCAccess")===!1?(0,pe.disableUNCAccessRestrictions)():(0,pe.addUNCHostToAllowlist)(V.getValue("security.allowedUNCHosts")));try{await this.g(O.createInstance(g.$vq,new r.$ik(j.getLevel(),!1)))}catch(G){throw j.error(G),console.error((0,u.$ab)(G)),G}})}async f(){const O=new n.$Ei,te={_serviceBrand:void 0,...m.default};O.set(l.$tk,te);const V=new i.$cn(this.a,te);O.set(i.$bn,V);const j=new re.$gR((0,r.$ok)(V),V.logsHome);O.set(r.$bk,j);const G=new B.$qR(this.B(j.createLogger("remoteCLI",{name:(0,ce.localize)(0,null)})));O.set(r.$ak,G),G.trace(`Remote configuration data at ${this.b}`),G.trace("process arguments:",this.a);const Q=this.B(new p.$2q(G));O.set(t.$al,Q),Q.registerProvider(b.Schemas.file,this.B(new d.$sr(G)));const N=new q.$Ts(Q);O.set(k.$Kl,N);const H=this.B(new ae.$oR(N,V,Q,G));O.set(x.$Ml,H);const oe=this.B(new I.$Wo(H.defaultProfile.settingsResource,Q,new K.$wo,G));return O.set(R.$aj,oe),await Promise.all([oe.initialize(),H.init()]),O.set(A.$7p,new E.$Di(y.$es)),O.set(C.$1o,new E.$Di(z.$JR)),O.set(S.$_l,o.$yp),O.set(v.$kp,new E.$Di(f.$rq)),O.set(le.$Iq,new E.$Di(M.$pR)),O.set(ne.$Mq,new E.$Di(Z.$bR)),O.set(a.$sq,new E.$Di(a.$uq)),O.set(w.$Xq,new E.$Di(w.$Yq)),O.set(s.$$r,new E.$Di(c.$as)),new h.$vr(O)}async g(O){if(this.a["list-extensions"])return O.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const te={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return O.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),te,!!this.a.force)}else{if(this.a["uninstall-extension"])return O.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return O.updateExtensions();if(this.a["locate-extension"])return O.locateExtension(this.a["locate-extension"])}}h(O){return O.map(te=>/\.vsix$/i.test(te)?D.URI.file((0,P.$lc)(te)?te:(0,P.$mc)((0,T.cwd)(),te)):te)}}function ue(U){setTimeout(()=>process.exit(U),0)}async function _(U,O,te){if(U.help){const j=m.default.serverApplicationName+(J.$c?".cmd":"");console.log((0,Y.$Fm)(m.default.nameLong,j,m.default.version,te,{noInputFiles:!0,noPipe:!0}));return}if(U.version){console.log((0,Y.$Gm)(m.default.version,m.default.commit));return}const V=new W(U,O);try{await V.run(),ue(0)}catch{ue(1)}finally{V.dispose()}}}),define(Se[328],ke([1,0,77,297,33,323,4,12,98]),function(se,e,n,r,E,I,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rQ=e.$qQ=void 0,r=Be(r),E=Be(E);class o{constructor(f,w,a){this.b=f,this.c=w,this.f=a,this.a=r.createServer((h,m)=>this.h(h,m)),this.g().catch(h=>(w.error(h),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",f=>this.c.error(f))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(f,w){const a=(m,$)=>{w.writeHead(m,{"content-type":"application/json"}),w.end(JSON.stringify($||null),p=>p&&this.c.error(p))},h=[];f.setEncoding("utf8"),f.on("data",m=>h.push(m)),f.on("end",async()=>{try{const m=JSON.parse(h.join(""));let $;switch(m.type){case"open":$=await this.i(m);break;case"openExternal":$=await this.j(m);break;case"status":$=await this.l(m);break;case"extensionManagement":$=await this.k(m);break;case"clipboard":$=await this.m(m);break;default:a(404,`Unknown message type: ${m.type}`);break}a(200,$)}catch(m){const $=m instanceof Error?m.message:JSON.stringify(m);a(500,$),this.c.error("Error while processing pipe request",m)}})}async i(f){const{fileURIs:w,folderURIs:a,forceNewWindow:h,diffMode:m,mergeMode:$,addMode:p,forceReuseWindow:d,gotoLineMode:b,waitMarkerFilePath:t,remoteAuthority:l}=f,i=[];if(Array.isArray(a))for(const u of a)try{i.push({folderUri:R.URI.parse(u)})}catch{}if(Array.isArray(w))for(const u of w)try{(0,y.$_i)(u)?i.push({workspaceUri:R.URI.parse(u)}):i.push({fileUri:R.URI.parse(u)})}catch{}const g=t?R.URI.file(t):void 0,c={forceNewWindow:h,diffMode:m,mergeMode:$,addMode:p,gotoLineMode:b,forceReuseWindow:d,preferNewWindow:!d&&!g&&!p,waitMarkerFileURI:g,remoteAuthority:l};this.b.executeCommand("_remoteCLI.windowOpen",i,c)}async j(f){for(const w of f.uris){const a=R.URI.parse(w),h=a.scheme==="file"?a:w;await this.b.executeCommand("_remoteCLI.openExternal",h)}}async k(f){const w=h=>h?.map(m=>/\.vsix$/i.test(m)?R.URI.parse(m):m),a={list:f.list,install:w(f.install),uninstall:w(f.uninstall),force:f.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",a)}async l(f){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}async m(f){return await this.b.executeCommand("_remoteCLI.setClipboard",f.content)}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&E.existsSync(this.f)&&E.unlinkSync(this.f)}}e.$qQ=o;let S=class extends o{constructor(f,w){super(f,w,(0,n.$yi)())}};e.$rQ=S,e.$rQ=S=ze([Fe(0,I.$lQ),Fe(1,A.$ak)],S)}),define(Se[329],ke([1,0,31,6,21,2,9,3,4,77,75,328,136,97,146,307,309,156,14,137]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Q=void 0,n=Be(n),R=Be(R),A=Be(A),h=Be(h);class b extends m.$6Q{constructor(i,g,s,c,u){super({getFolderUri:D=>{const P=g.filter(T=>T.name===D);if(P&&P.length>0)return P[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(D,P)=>c[`config:${P}`],getExecPath:()=>i.VSCODE_EXEC_PATH,getAppRoot:()=>i.VSCODE_CWD,getFilePath:()=>{if(s)return R.$kc(s.fsPath)},getSelectedText:()=>c.selectedText,getLineNumber:()=>c.lineNumber,getExtension:async D=>{const T=(await u.getInstalled()).find(z=>z.identifier.id===D);return T&&{extensionLocation:T.location}}},void 0,Promise.resolve(n.homedir()),Promise.resolve(i))}}class t extends I.$Xc{constructor(i,g,s,c,u,D){super(),this.g=i,this.h=g,this.j=s,this.m=c,this.n=u,this.r=D,this.a=0,this.b=new Map,this.c=this.B(new r.$ne),this.onExecuteCommand=this.c.event}async call(i,g,s){switch(g){case a.RemoteTerminalChannelRequest.RestartPtyHost:return this.j.restartPtyHost.apply(this.j,s);case a.RemoteTerminalChannelRequest.CreateProcess:{const c=(0,S.$Us)(i.remoteAuthority);return this.s(c,s)}case a.RemoteTerminalChannelRequest.AttachToProcess:return this.j.attachToProcess.apply(this.j,s);case a.RemoteTerminalChannelRequest.DetachFromProcess:return this.j.detachFromProcess.apply(this.j,s);case a.RemoteTerminalChannelRequest.ListProcesses:return this.j.listProcesses.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetLatency:return this.j.getLatency.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetPerformanceMarks:return this.j.getPerformanceMarks.apply(this.j,s);case a.RemoteTerminalChannelRequest.OrphanQuestionReply:return this.j.orphanQuestionReply.apply(this.j,s);case a.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables:return this.j.acceptPtyHostResolvedVariables.apply(this.j,s);case a.RemoteTerminalChannelRequest.Start:return this.j.start.apply(this.j,s);case a.RemoteTerminalChannelRequest.Input:return this.j.input.apply(this.j,s);case a.RemoteTerminalChannelRequest.AcknowledgeDataEvent:return this.j.acknowledgeDataEvent.apply(this.j,s);case a.RemoteTerminalChannelRequest.Shutdown:return this.j.shutdown.apply(this.j,s);case a.RemoteTerminalChannelRequest.Resize:return this.j.resize.apply(this.j,s);case a.RemoteTerminalChannelRequest.ClearBuffer:return this.j.clearBuffer.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetInitialCwd:return this.j.getInitialCwd.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetCwd:return this.j.getCwd.apply(this.j,s);case a.RemoteTerminalChannelRequest.ProcessBinary:return this.j.processBinary.apply(this.j,s);case a.RemoteTerminalChannelRequest.SendCommandResult:return this.u(s[0],s[1],s[2]);case a.RemoteTerminalChannelRequest.InstallAutoReply:return this.j.installAutoReply.apply(this.j,s);case a.RemoteTerminalChannelRequest.UninstallAllAutoReplies:return this.j.uninstallAllAutoReplies.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetDefaultSystemShell:return this.w.apply(this,s);case a.RemoteTerminalChannelRequest.GetProfiles:return this.y.apply(this,s);case a.RemoteTerminalChannelRequest.GetEnvironment:return this.z();case a.RemoteTerminalChannelRequest.GetWslPath:return this.C(s[0],s[1]);case a.RemoteTerminalChannelRequest.GetTerminalLayoutInfo:return this.j.getTerminalLayoutInfo(s);case a.RemoteTerminalChannelRequest.SetTerminalLayoutInfo:return this.j.setTerminalLayoutInfo(s);case a.RemoteTerminalChannelRequest.SerializeTerminalState:return this.j.serializeTerminalState.apply(this.j,s);case a.RemoteTerminalChannelRequest.ReviveTerminalProcesses:return this.j.reviveTerminalProcesses.apply(this.j,s);case a.RemoteTerminalChannelRequest.GetRevivedPtyNewId:return this.j.getRevivedPtyNewId.apply(this.j,s);case a.RemoteTerminalChannelRequest.SetUnicodeVersion:return this.j.setUnicodeVersion.apply(this.j,s);case a.RemoteTerminalChannelRequest.ReduceConnectionGraceTime:return this.D();case a.RemoteTerminalChannelRequest.UpdateIcon:return this.j.updateIcon.apply(this.j,s);case a.RemoteTerminalChannelRequest.UpdateTitle:return this.j.updateTitle.apply(this.j,s);case a.RemoteTerminalChannelRequest.UpdateProperty:return this.j.updateProperty.apply(this.j,s);case a.RemoteTerminalChannelRequest.RefreshProperty:return this.j.refreshProperty.apply(this.j,s);case a.RemoteTerminalChannelRequest.RequestDetachInstance:return this.j.requestDetachInstance(s[0],s[1]);case a.RemoteTerminalChannelRequest.AcceptDetachedInstance:return this.j.acceptDetachInstanceReply(s[0],s[1]);case a.RemoteTerminalChannelRequest.FreePortKillProcess:return this.j.freePortKillProcess.apply(this.j,s);case a.RemoteTerminalChannelRequest.AcceptDetachInstanceReply:return this.j.acceptDetachInstanceReply.apply(this.j,s)}throw new Error(`IPC Command ${g} not found`)}listen(i,g,s){switch(g){case a.RemoteTerminalChannelEvent.OnPtyHostExitEvent:return this.j.onPtyHostExit||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostStartEvent:return this.j.onPtyHostStart||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent:return this.j.onPtyHostUnresponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent:return this.j.onPtyHostResponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent:return this.j.onPtyHostRequestResolveVariables||r.Event.None;case a.RemoteTerminalChannelEvent.OnProcessDataEvent:return this.j.onProcessData;case a.RemoteTerminalChannelEvent.OnProcessReadyEvent:return this.j.onProcessReady;case a.RemoteTerminalChannelEvent.OnProcessExitEvent:return this.j.onProcessExit;case a.RemoteTerminalChannelEvent.OnProcessReplayEvent:return this.j.onProcessReplay;case a.RemoteTerminalChannelEvent.OnProcessOrphanQuestion:return this.j.onProcessOrphanQuestion;case a.RemoteTerminalChannelEvent.OnExecuteCommand:return this.onExecuteCommand;case a.RemoteTerminalChannelEvent.OnDidRequestDetach:return this.j.onDidRequestDetach||r.Event.None;case a.RemoteTerminalChannelEvent.OnDidChangeProperty:return this.j.onDidChangeProperty}throw new Error(`IPC Command ${g} not found`)}async s(i,g){const s={name:g.shellLaunchConfig.name,executable:g.shellLaunchConfig.executable,args:g.shellLaunchConfig.args,cwd:typeof g.shellLaunchConfig.cwd=="string"||typeof g.shellLaunchConfig.cwd>"u"?g.shellLaunchConfig.cwd:y.URI.revive(i.transformIncoming(g.shellLaunchConfig.cwd)),env:g.shellLaunchConfig.env,useShellEnvironment:g.shellLaunchConfig.useShellEnvironment,reconnectionProperties:g.shellLaunchConfig.reconnectionProperties,type:g.shellLaunchConfig.type,isFeatureTerminal:g.shellLaunchConfig.isFeatureTerminal},c=await(0,$.$En)(g.resolverEnv,!!g.shellLaunchConfig.useShellEnvironment,A.$q,this.g,this.h,this.r);this.h.trace("baseEnv",c);const u=K=>({uri:y.URI.revive(i.transformIncoming(K.uri)),name:K.name,index:K.index,toResource:()=>{throw new Error("Not implemented")}}),D=g.workspaceFolders.map(u),P=g.activeWorkspaceFolder?u(g.activeWorkspaceFolder):void 0,T=g.activeFileResource?y.URI.revive(i.transformIncoming(g.activeFileResource)):void 0,z=new b(c,D,T,g.resolvedVariables,this.n),C=h.$2Q(P,process.env,z),k=await h.$1Q(s,n.homedir(),C,P?.uri,g.configuration["terminal.integrated.cwd"],this.h);s.cwd=k;const q=A.$c?"terminal.integrated.env.windows":A.$d?"terminal.integrated.env.osx":"terminal.integrated.env.linux",Y=g.configuration[q],J=await h.$3Q(s,Y,C,this.m.version,g.configuration["terminal.integrated.detectLocale"],c);if((0,d.$UQ)(s)){const K=[];for(const[re,ce,pe]of g.envVariableCollections)K.push([re,{map:(0,w.$Gs)(ce),descriptionMap:(0,w.$Hs)(pe)}]);const ae=new Map(K),M=new f.$Ks(ae),B=P?P??void 0:void 0;await M.applyToProcessEnvironment(J,{workspaceFolder:B},C)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:s,initialCwd:k,cols:g.cols,rows:g.rows,env:J});const ne=(0,o.$yi)();J.VSCODE_IPC_HOOK_CLI=ne;const Z=await this.j.createProcess(s,k,g.cols,g.rows,g.unicodeVersion,J,c,g.options,g.shouldPersistTerminal,g.workspaceId,g.workspaceName),x={executeCommand:(K,...ae)=>this.t(Z,K,ae,i)},le=new v.$qQ(x,this.h,ne);return this.j.onProcessExit(K=>K.id===Z&&le.dispose()),{persistentTerminalId:Z,resolvedShellLaunchConfig:s}}t(i,g,s,c){const{resolve:u,reject:D,promise:P}=(0,p.$zh)(),T=++this.a;this.b.set(T,{resolve:u,reject:D,uriTransformer:c});const z=(0,E.$ho)(s,C=>{if(C&&C.$mid===1)return c.transformOutgoing(C);if(C&&C instanceof y.URI)return c.transformOutgoingURI(C)});return this.c.fire({reqId:T,persistentProcessId:i,commandId:g,commandArgs:z}),P}u(i,g,s){const c=this.b.get(i);if(!c)return;this.b.delete(i);const u=(0,E.$ho)(s,D=>{if(D&&D.$mid===1)return c.uriTransformer.transformIncoming(D)});g?c.reject(u):c.resolve(u)}w(i){return this.j.getDefaultSystemShell(i)}async y(i,g,s,c){return this.j.getProfiles(i,g,s,c)||[]}z(){return{...process.env}}C(i,g){return this.j.getWslPath(i,g)}D(){return this.j.reduceConnectionGraceTime()}}e.$7Q=t});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[330],ke([1,0,31,6,2,13,9,112,25,50,61,27,130,240,88,241,28,142,30,95,133,265,140,16,124,72,71,123,89,92,134,12,62,29,47,268,155,132,24,41,281,53,288,36,138,301,302,274,278,329,75,55,311,324,144,64,145,54,34,296,73,279,127,143,141,126,125,230,319,264,293,285]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t,l,i,g,s,c,u,D,P,T,z,C,k,q,Y,J,ne,Z,x,le,K,ae,M,B,re,ce,pe,W,ue,_,U,O,te,V,j,G,Q,N,H,oe,fe,Ee,Ne,de,$e,Re,Ce,me,Ie,Ae,Me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AR=void 0,e.$zR=Qe,R=Be(R),C=$t(C),le=$t(le);const qe="monacoworkbench";async function Qe(it,_e,Je,et){const be=new D.$Ei,Le=new We,ve={_serviceBrand:void 0,...C.default};be.set(k.$tk,ve);const ye=new U.$cn(_e,ve);be.set(m.$Ni,ye),be.set(m.$Oi,ye);const ee=new Ee.$gR((0,z.$ok)(ye),ye.logsHome);be.set(z.$bk,ee),Le.registerChannel("logger",new Re.$ts(ee,ut=>Ye(ut.remoteAuthority)));const ie=ee.createLogger("remoteagent",{name:(0,Ce.localize)(0,null)}),we=new $e.$qR(ie,[new rt((0,z.$ok)(ye))]);be.set(z.$ak,we),setTimeout(()=>ct(ye.logsHome.with({scheme:I.Schemas.file}).fsPath).then(null,ut=>we.error(ut)),1e4),we.onDidChangeLogLevel(ut=>(0,z.log)(we,ut,`Log level changed to ${(0,z.$pk)(we.getLevel())}`)),we.trace(`Remote configuration data at ${Je}`),we.trace("process arguments:",ye.args),Array.isArray(ve.serverGreeting)&&we.info(`

${ve.serverGreeting.join(`
`)}

`),Le.registerChannel(w.$Yo.ChannelName,new w.$Yo);const He=new o.$oi(ut=>ut.clientId==="renderer"),Ke=et.add(new g.$2q(we));be.set(i.$al,Ke),Ke.registerProvider(I.Schemas.file,et.add(new s.$sr(we)));const xe=new B.$Ts(Ke);be.set(M.$Kl,xe);const tt=new f.$Wo(ye.machineSettingsResource,Ke,new oe.$wo,we);be.set(v.$aj,tt);const lt=new Ne.$oR(xe,ye,Ke,we);be.set(N.$Ml,lt),Le.registerChannel("userDataProfiles",new Ae.$wR(lt,ut=>Ye(ut.remoteAuthority)));const[,,pt,yt,Ht]=await Promise.all([tt.initialize(),lt.init(),(0,A.$Un)(we.error.bind(we)),(0,A.$Vn)(we.error.bind(we)),(0,A.$Wn)(we.error.bind(we))]),Mt=new V.$Zm;be.set(V.$Ym,Mt);const dt=new J.$es(tt,ye,we,ee);be.set(q.$7p,dt);let Et;try{await y.Promises.stat("/run/.containerenv"),Et=!0}catch{}if(!Et)try{Et=(await y.Promises.readFile("/proc/self/cgroup","utf8")).includes("docker")}catch{}let vt=x.$Cp;const Kt=(0,x.$Ip)(ve,tt);if((0,x.$Dp)(ve,ye)){!(0,x.$Ep)(ve,ye)&&ve.telemetryEndpoint&&(vt=new fe.$eR(dt,Kt,qe,null,()=>new H.$cR(ve.telemetryEndpoint,pt,Et)),et.add((0,E.$Vc)(()=>vt?.flush())));const ut={appenders:[vt],commonProperties:(0,ne.$up)((0,n.release)(),(0,n.hostname)(),process.arch,ve.commit,ve.version+"-remote",pt,yt,Ht,Kt,"remoteAgent"),piiPaths:(0,x.$Jp)(ye)},mt=ye.args["telemetry-level"];let bt=Z.TelemetryLevel.USAGE;mt==="all"?bt=Z.TelemetryLevel.USAGE:mt==="error"?bt=Z.TelemetryLevel.ERROR:mt==="crash"?bt=Z.TelemetryLevel.CRASH:mt!==void 0&&(bt=Z.TelemetryLevel.NONE),be.set(W.$8s,new c.$Di(W.$6s,[ut,bt]))}else be.set(W.$8s,W.$7s);be.set(p.$kp,new c.$Di($.$rq));const zt=Le.getChannel("download",He);be.set(a.$1o,new h.$3o(zt,()=>Ye("renderer"))),be.set(Q.$Iq,new c.$Di(de.$pR)),be.set(j.$Mq,new c.$Di(G.$bR)),be.set(d.$sq,new c.$Di(d.$uq)),be.set(l.$Xq,new c.$Di(l.$Yq));const St=new u.$vr(be);be.set(P.$$r,St.createInstance(T.$as));const Bt=St.createInstance(Me.$yR,{graceTime:S.ProtocolConstants.ReconnectionGraceTime,shortGraceTime:S.ProtocolConstants.ReconnectionShortGraceTime,scrollback:tt.getValue(K.TerminalSettingId.PersistentSessionScrollback)??100}),Ot=St.createInstance(ae.$Ps,Bt);return be.set(K.$os,Ot),St.invokeFunction(ut=>{const mt=ut.get(l.$Xq),bt=ut.get(j.$Mq),Pt=ut.get(p.$kp),Xt=ut.get(P.$$r),Lt=new re.$2s(it,ye,lt,Mt);Le.registerChannel("remoteextensionsenvironment",Lt);const Nt=new pe.$9s(ut.get(W.$8s),vt);Le.registerChannel("telemetry",Nt),Le.registerChannel(O.$8Q,new ue.$7Q(ye,we,Ot,ve,mt,tt));const Ut=new me.$uR(St.createInstance(b.$vq,we),ye,lt,bt,we,Pt,Xt);Le.registerChannel(Ie.$tR,new me.$vR(Ut,kt=>Ye(kt.remoteAuthority)));const Jt=et.add(new ce.$5s(we,ye));Le.registerChannel(te.$_Q,Jt),Le.registerChannel("request",new Y.$bs(ut.get(q.$7p)));const Ft=new t.$wq(mt,kt=>Ye(kt.remoteAuthority));Le.registerChannel("extensions",Ft);const Rt=o.ProxyChannel.fromService(ut.get(P.$$r),et);return Le.registerChannel("languagePacks",Rt),Ut.whenExtensionsReady().then(()=>mt.cleanUp()),et.add(new le.default(ut.get(Z.$_l))),{telemetryService:ut.get(Z.$_l)}}),{socketServer:Le,instantiationService:St}}const Ge=Object.create(null);function Ye(it){return Ge[it]||(Ge[it]=(0,_.$Us)(it)),Ge[it]}class We extends o.$ki{constructor(){const _e=new r.$ne;super(_e.event),this.b=_e}acceptConnection(_e,Je){this.b.fire({protocol:_e,onDidClientDisconnect:Je})}}e.$AR=We;class rt extends z.$fk{constructor(_e=z.$dk){super(),this.setLevel(_e),this.g=!!process.stdout.isTTY}trace(_e,...Je){this.f(z.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${at()}]\x1B[0m`,_e,...Je):console.log(`[${at()}]`,_e,...Je))}debug(_e,...Je){this.f(z.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${at()}]\x1B[0m`,_e,...Je):console.log(`[${at()}]`,_e,...Je))}info(_e,...Je){this.f(z.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${at()}]\x1B[0m`,_e,...Je):console.log(`[${at()}]`,_e,...Je))}warn(_e,...Je){this.f(z.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${at()}]\x1B[0m`,_e,...Je):console.warn(`[${at()}]`,_e,...Je))}error(_e,...Je){this.f(z.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${at()}]\x1B[0m`,_e,...Je):console.error(`[${at()}]`,_e,...Je))}flush(){}}function at(){const it=new Date;return`${nt(it.getHours())}:${nt(it.getMinutes())}:${nt(it.getSeconds())}`}function nt(it){return it<10?`0${it}`:String(it)}async function ct(it){const _e=R.$qc(it),Je=R.$pc(it),Le=(await y.Promises.readdir(Je)).filter(ye=>/^\d{8}T\d{6}$/.test(ye)).sort().filter(ye=>ye!==_e),ve=Le.slice(0,Math.max(0,Le.length-9));await Promise.all(ve.map(ye=>y.Promises.rm(R.$mc(Je,ye))))}}),define(Se[331],ke([1,0,96,33,85,332,93,105,15,35,10,37,2,13,9,44,3,17,4,23,181,183,327,61,77,27,5,12,29,263,24,156,294,102,55,330,298]),function(se,e,n,r,E,I,R,A,y,o,S,v,f,w,a,h,m,$,p,d,b,t,l,i,g,s,c,u,D,P,T,z,C,k,q,Y,J){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IR=x,n=Be(n),r=Be(r),E=Be(E),R=Be(R),h=Be(h),m=Be(m);const ne=5*60*1e3;let Z=class extends f.$Xc{constructor(ae,M,B,re,ce,pe,W,ue,_){super(),this.n=ae,this.r=M,this.s=B,this.t=pe,this.u=W,this.w=ue,this.y=_,this.h=le.create(this.u),this.j=(0,w.$Ug)(W,ce),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=re?this.y.createInstance(J.$DR,this.r,ce??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(ae,M){if(ae.method!=="GET")return(0,J.$BR)(ae,M,405,`Unsupported method ${ae.method}`);if(!ae.url)return(0,J.$BR)(ae,M,400,"Bad request.");const B=R.parse(ae.url,!0);let re=B.pathname;if(!re)return(0,J.$BR)(ae,M,400,"Bad request.");if(re.startsWith(this.j)&&re.charCodeAt(this.j.length)===o.CharCode.Slash&&(re=re.substring(this.j.length)),re==="/version")return M.writeHead(200,{"Content-Type":"text/plain"}),void M.end(this.u.commit||"");if(re==="/delay-shutdown")return this.N(),M.writeHead(200),void M.end("OK");if(!(0,k.$Mn)(this.r,ae,B))return(0,J.$BR)(ae,M,403,"Forbidden.");if(re==="/vscode-remote-resource"){const ce=B.query.path;if(typeof ce!="string")return(0,J.$BR)(ae,M,400,"Bad request.");let pe;try{pe=p.URI.from({scheme:w.Schemas.file,path:ce}).fsPath}catch{return(0,J.$BR)(ae,M,400,"Bad request.")}const W=Object.create(null);this.t.isBuilt&&((0,v.$Fg)(pe,this.t.builtinExtensionsPath,!m.$e)||(0,v.$Fg)(pe,this.t.extensionsPath,!m.$e))&&(W["Cache-Control"]="public, max-age=31536000"),W.Vary="Origin";const ue=ae.headers.origin;return ue&&this.h.matches(ue)&&(W["Access-Control-Allow-Origin"]=ue),(0,J.$CR)(pe,J.CacheControl.ETAG,this.w,ae,M,W)}if(this.g){this.g.handle(ae,M,B);return}return M.writeHead(404,{"Content-Type":"text/plain"}),void M.end("Not found")}handleUpgrade(ae,M){let B=(0,d.$3g)(),re=!1,ce=!1;if(ae.url){const O=R.parse(ae.url,!0).query;typeof O.reconnectionToken=="string"&&(B=O.reconnectionToken),O.reconnection==="true"&&(re=!0),O.skipWebSocketFrames==="true"&&(ce=!0)}if(ae.headers.upgrade===void 0||ae.headers.upgrade.toLowerCase()!=="websocket"){M.end("HTTP/1.1 400 Bad Request");return}const pe=ae.headers["sec-websocket-key"],W=n.createHash("sha1");W.update(pe+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const _=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${W.digest("base64")}`];let U=!1;if(!ce&&!this.t.args["disable-websocket-compression"]&&ae.headers["sec-websocket-extensions"]){const O=Array.isArray(ae.headers["sec-websocket-extensions"])?ae.headers["sec-websocket-extensions"]:[ae.headers["sec-websocket-extensions"]];for(const te of O)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(te)){if(/\b(permessage-deflate)\b/.test(te)){U=!0,_.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(te)){U=!0,_.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}M.write(_.join(`\r
`)+`\r
\r
`),M.setTimeout(0),M.setNoDelay(!0),ce?this.D(new g.$vi(M,`server-connection-${B}`),re,B):this.D(new g.$wi(new g.$vi(M,`server-connection-${B}`),U,null,!0),re,B)}handleServerError(ae){this.w.error("Error occurred in server"),this.w.error(ae)}z(ae){let M;return ae instanceof g.$vi?M=ae.socket:M=ae.socket.socket,M.remoteAddress||"<unknown>"}async C(ae,M,B){const re=M.getSocket();this.w.error(`${ae} ${B}.`);const ce={type:"error",reason:B};M.sendControl(y.$Pe.fromString(JSON.stringify(ce))),M.dispose(),await re.drain(),re.dispose()}D(ae,M,B){const re=this.z(ae),ce=`[${re}][${B.substr(0,8)}]`,pe=new i.$ui({socket:ae}),W=this.s?new this.s.validator:null,ue=this.s?new this.s.signer:null;let _;(function(V){V[V.WaitingForAuth=0]="WaitingForAuth",V[V.WaitingForConnectionType=1]="WaitingForConnectionType",V[V.Done=2]="Done",V[V.Error=3]="Error"})(_||(_={}));let U=_.WaitingForAuth;const O=V=>{U=_.Error,te.dispose(),this.C(ce,pe,V)},te=pe.onControlMessage(V=>{if(U===_.WaitingForAuth){let j;try{j=JSON.parse(V.toString())}catch{return O("Malformed first message")}if(j.type!=="auth")return O("Invalid first message");if(this.r.type===k.ServerConnectionTokenType.Mandatory&&!this.r.validate(j.auth))return O("Unauthorized client refused: auth mismatch");let G=(0,d.$3g)();if(ue)try{G=ue.sign(j.data)}catch{}let Q=(0,d.$3g)();if(W)try{Q=W.createNewMessage(Q)}catch{}const N={type:"sign",data:Q,signedData:G};pe.sendControl(y.$Pe.fromString(JSON.stringify(N))),U=_.WaitingForConnectionType}else if(U===_.WaitingForConnectionType){let j;try{j=JSON.parse(V.toString())}catch{return O("Malformed second message")}if(j.type!=="connectionType")return O("Invalid second message");if(typeof j.signedData!="string")return O("Invalid second message field type");const G=j.commit,Q=this.u.commit;if(G&&Q&&G!==Q)return O("Client refused: version mismatch");let N=!1;if(!W)N=!0;else if(this.r.validate(j.signedData))N=!0;else try{N=W.validate(j.signedData)==="ok"}catch{}if(!N){if(this.t.isBuilt)return O("Unauthorized client refused");this.w.error(`${ce} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const H in this.b)this.b[H].shortenReconnectionGraceTimeIfNecessary();for(const H in this.a)this.a[H].shortenReconnectionGraceTimeIfNecessary();U=_.Done,te.dispose(),this.F(re,ce,pe,ae,M,B,j)}})}async F(ae,M,B,re,ce,pe,W){const ue=W.desiredConnectionType===P.ConnectionType.Management?`${M}[ManagementConnection]`:W.desiredConnectionType===P.ConnectionType.ExtensionHost?`${M}[ExtensionHostConnection]`:M;if(W.desiredConnectionType===P.ConnectionType.Management)if(ce){if(!this.b[pe])return this.f.has(pe)?this.C(ue,B,"Unknown reconnection token (seen before)"):this.C(ue,B,"Unknown reconnection token (never seen)");B.sendControl(y.$Pe.fromString(JSON.stringify({type:"ok"})));const _=B.readEntireBuffer();B.dispose(),this.b[pe].acceptReconnection(ae,re,_)}else{if(this.b[pe])return this.C(ue,B,"Duplicate reconnection token");B.sendControl(y.$Pe.fromString(JSON.stringify({type:"ok"})));const _=new C.$Gn(this.w,pe,ae,B);this.n.acceptConnection(_.protocol,_.onClose),this.b[pe]=_,this.f.add(pe),_.onClose(()=>{delete this.b[pe]})}else if(W.desiredConnectionType===P.ConnectionType.ExtensionHost){const _=W.args||{language:"en"},U=await this.I(_);if(U.port&&this.w.trace(`${ue} - startParams debug port ${U.port}`),this.w.trace(`${ue} - startParams language: ${U.language}`),this.w.trace(`${ue} - startParams env: ${JSON.stringify(U.env)}`),ce){if(!this.a[pe])return this.f.has(pe)?this.C(ue,B,"Unknown reconnection token (seen before)"):this.C(ue,B,"Unknown reconnection token (never seen)");B.sendPause(),B.sendControl(y.$Pe.fromString(JSON.stringify(U.port?{debugPort:U.port}:{})));const O=B.readEntireBuffer();B.dispose(),this.a[pe].acceptReconnection(ae,re,O)}else{if(this.a[pe])return this.C(ue,B,"Duplicate reconnection token");B.sendPause(),B.sendControl(y.$Pe.fromString(JSON.stringify(U.port?{debugPort:U.port}:{})));const O=B.readEntireBuffer();B.dispose();const te=this.y.createInstance(z.$Fn,pe,ae,re,O);this.a[pe]=te,this.f.add(pe),te.onClose(()=>{te.dispose(),delete this.a[pe],this.J()}),te.start(U)}}else if(W.desiredConnectionType===P.ConnectionType.Tunnel){const _=W.args;this.G(B,_)}else return this.C(ue,B,"Unknown initial data received")}async G(ae,M){const B=ae.getSocket().socket,re=ae.readEntireBuffer();ae.dispose(),B.pause();const ce=await this.H(M.host,M.port);re.byteLength>0&&ce.write(re.buffer),ce.on("end",()=>B.end()),ce.on("close",()=>B.end()),ce.on("error",()=>B.destroy()),B.on("end",()=>ce.end()),B.on("close",()=>ce.end()),B.on("error",()=>ce.destroy()),ce.pipe(B),B.pipe(ce)}H(ae,M){return new Promise((B,re)=>{const ce=E.createConnection({host:ae,port:M,autoSelectFamily:!0},()=>{ce.removeListener("error",re),ce.pause(),B(ce)});ce.once("error",re)})}I(ae){return typeof ae.port=="number"?(0,t.$5g)(ae.port,10,5e3).then(M=>(ae.port=M,ae)):(ae.debugId=void 0,ae.port=void 0,ae.break=void 0,Promise.resolve(ae))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(ae=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!ae?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},ne))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};Z=ze([Fe(5,q.$bn),Fe(6,D.$tk),Fe(7,u.$ak),Fe(8,c.$Fi)],Z);async function x(K,ae,M){const B=await(0,k.$Ln)(ae);B instanceof k.$Jn&&(console.warn(B.message),process.exit(1));function re(H){(0,S.setUnexpectedErrorHandler)(oe=>{(0,S.$2)(oe)&&oe.stack&&/unexpectedErrorHandler/.test(oe.stack)||H(oe)})}const ce=[];re(H=>{ce.push(H),console.error(H)});let pe=!1;process.on("SIGPIPE",()=>{pe||(pe=!0,(0,S.$3)(new Error("Unexpected SIGPIPE")))});const W=new f.$Wc,{socketServer:ue,instantiationService:_}=await(0,Y.$zR)(B,ae,M,W);_.invokeFunction(H=>{const oe=H.get(u.$ak);ce.forEach(fe=>oe.error(fe)),ce.length=0,re(fe=>oe.error(fe))}),_.invokeFunction(H=>{const oe=H.get(s.$aj);m.$c&&(oe.getValue("security.restrictUNCAccess")===!1?(0,l.disableUNCAccessRestrictions)():(0,l.addUNCHostToAllowlist)(oe.getValue("security.allowedUNCHosts")))}),_.invokeFunction(H=>{const oe=H.get(u.$ak);if(m.$c&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const fe=(0,a.$mc)(process.env.HOMEDRIVE,"node_modules"),Ee=(0,a.$pc)((0,a.$mc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Ne=(0,a.$mc)(Ee,"node_modules");if(r.existsSync(fe)||r.existsSync(Ne)){const de=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${fe}
* ${Ne}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;oe.warn(de),console.warn(de),process.exit(0)}}});const U=_.invokeFunction(H=>{const oe=H.get(u.$ak);if(r.existsSync((0,a.$mc)(w.$1g.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Ee){oe.error(Ee)}return null});let O=ae["server-base-path"];O&&!O.startsWith("/")&&(O=`/${O}`);const te=r.existsSync(w.$1g.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(te&&K&&typeof K!="string"){const H=B.type!==k.ServerConnectionTokenType.None?`?${w.$Sg}=${B.value}`:"";console.log(`Web UI available at http://localhost${K.port===80?"":`:${K.port}`}${O??""}${H}`)}const V=_.createInstance(Z,ue,B,U,te,O);h.mark("code/server/ready");const j=I.performance.now(),G=global.vscodeServerStartTime,Q=global.vscodeServerListenTime,N=global.vscodeServerCodeLoadedTime;if(_.invokeFunction(async H=>{const oe=H.get(T.$_l);if(oe.publicLog2("serverStart",{startTime:G,startedTime:Q,codeLoadedTime:N,readyTime:j}),m.$e){const fe=H.get(u.$ak),Ee=await(0,b.$4g)(fe.error.bind(fe));Ee&&oe.publicLog2("serverPlatformInfo",{platformId:Ee.id,platformVersionId:Ee.version_id,platformIdLike:Ee.id_like})}}),ae["print-startup-performance"]){const H=A.$W.get();let oe="";oe+=`

### Load AMD-module
`,oe+=A.$W.toMarkdownTable(["Module","Duration"],H.amdLoad),oe+=`

### Load commonjs-module
`,oe+=A.$W.toMarkdownTable(["Module","Duration"],H.nodeRequire),oe+=`

### Invoke AMD-module factory
`,oe+=A.$W.toMarkdownTable(["Module","Duration"],H.amdInvoke),oe+=`

### Invoke commonjs-module
`,oe+=A.$W.toMarkdownTable(["Module","Duration"],H.nodeEval),oe+=`Start-up time: ${Q-G}
`,oe+=`Code loading time: ${N-G}
`,oe+=`Initialized time: ${j-G}
`,oe+=`
`,console.log(oe)}return V}class le{static create(ae){const M=ae.webEndpointUrlTemplate,B=ae.commit,re=ae.quality;if(!M||!B||!re)return new le(null);const ce=(0,d.$3g)(),W=new URL(M.replace("{{uuid}}",ce).replace("{{commit}}",B).replace("{{quality}}",re)).origin,ue=(0,$.$jf)(W).replace(ce,"[a-zA-Z0-9\\-]+");try{const _=(0,$.$sf)(`^${ue}$`,!0,{matchCase:!1});return new le(_)}catch{return new le(null)}}constructor(ae){this.a=ae}matches(ae){return this.a?this.a.test(ae):!1}}});var $t=this&&this.__importDefault||function(se){return se&&se.__esModule?se:{default:se}};define(Se[339],ke([1,0,31,33,13,326,331,70,9,332,55,62,44]),function(se,e,n,r,E,I,R,A,y,o,S,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=m,e.createServer=$,n=Be(n),r=Be(r),v=$t(v),f=Be(f),f.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=o.performance.now();const w={onMultipleValues:(p,d)=>{console.error(`Option '${p}' can only be defined once. Using value ${d}.`)},onEmptyValue:p=>{console.error(`Ignoring option '${p}': Value must not be empty.`)},onUnknownOption:p=>{console.error(`Ignoring option '${p}': not supported for server.`)},onDeprecatedOption:(p,d)=>{console.warn(`Option '${p}' is deprecated: ${d}`)}};function a(){return(0,A.$Dm)(process.argv.slice(2),S.$an,w)}function h(p){const d=p["server-data-dir"]||p["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,y.$mc)(n.homedir(),v.default.serverDataFolderName||".vscode-remote"),b=p["user-data-dir"]||(0,y.$mc)(d,"data"),t=(0,y.$mc)(b,"User"),l=(0,y.$mc)(t,"globalStorage"),i=(0,y.$mc)(t,"History"),g=(0,y.$mc)(b,"Machine");p["user-data-dir"]=b;const s=(0,y.$pc)(E.$1g.asFileUri("").fsPath),c=p["builtin-extensions-dir"]||(0,y.$mc)(s,"extensions");return p["builtin-extensions-dir"]=c,p["extensions-dir"]=p["extensions-dir"]||(0,y.$mc)(d,"extensions"),[d,p["extensions-dir"],b,t,g,l,i].forEach(u=>{try{r.existsSync(u)||r.mkdirSync(u,{mode:448})}catch(D){console.error(D)}}),d}function m(p=a()){return(0,I.run)(p,h(p),S.$an)}function $(p,d=a()){return(0,R.$IR)(p,d,h(d))}})}).call(this);

//# sourceMappingURL=server.main.js.map
