"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/marshalling","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/decorators","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(ie){for(var e=[],r=0,a=ie.length;r<a;r++)e[r]=Se[ie[r]];return e};define(Se[175],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var r;(function(k){k[k.LoaderAvailable=1]="LoaderAvailable",k[k.BeginLoadingScript=10]="BeginLoadingScript",k[k.EndLoadingScriptOK=11]="EndLoadingScriptOK",k[k.EndLoadingScriptError=12]="EndLoadingScriptError",k[k.BeginInvokeFactory=21]="BeginInvokeFactory",k[k.EndInvokeFactory=22]="EndInvokeFactory",k[k.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",k[k.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",k[k.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",k[k.NodeEndNativeRequire=34]="NodeEndNativeRequire",k[k.CachedDataFound=60]="CachedDataFound",k[k.CachedDataMissed=61]="CachedDataMissed",k[k.CachedDataRejected=62]="CachedDataRejected",k[k.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class a{static get(){const A=new Map,O=new Map,R=new Map,p=new Map;function c(w,l){w.has(l.detail)||w.set(l.detail,-l.timestamp)}function I(w,l){const m=w.get(l.detail);m&&(m>=0||w.set(l.detail,m+l.timestamp))}let S=[];typeof ie=="function"&&typeof ie.getStats=="function"&&(S=ie.getStats().slice(0).sort((w,l)=>w.timestamp-l.timestamp));for(const w of S)switch(w.type){case r.BeginLoadingScript:c(A,w);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(A,w);break;case r.BeginInvokeFactory:c(O,w);break;case r.EndInvokeFactory:I(O,w);break;case r.NodeBeginNativeRequire:c(R,w);break;case r.NodeEndNativeRequire:I(R,w);break;case r.NodeBeginEvaluatingScript:c(p,w);break;case r.NodeEndEvaluatingScript:I(p,w);break}let h=0;R.forEach(w=>h+=w);function P(w){const l=[];return w.forEach((m,g)=>l.push([g,m])),l}return{amdLoad:P(A),amdInvoke:P(O),nodeRequire:P(R),nodeEval:P(p),nodeRequireTotal:h}}static toMarkdownTable(A,O){let R="";const p=[];return A.forEach((c,I)=>{p[I]=c.length}),O.forEach(c=>{c.forEach((I,S)=>{typeof I>"u"&&(I=c[S]="-");const h=I.toString().length;p[S]=Math.max(h,p[S])})}),A.forEach((c,I)=>{R+=`| ${c+" ".repeat(p[I]-c.toString().length)} `}),R+=`|
`,A.forEach((c,I)=>{R+=`| ${"-".repeat(p[I])} `}),R+=`|
`,O.forEach(c=>{c.forEach((I,S)=>{typeof I<"u"&&(R+=`| ${I+" ".repeat(p[S]-I.toString().length)} `)}),R+=`|
`}),R}}e.$W=a}),define(Se[133],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=void 0,e.$ib=r,e.$jb=a,e.$kb=k,e.$lb=A,e.$mb=O,e.$nb=R,e.$ob=p,e.$qb=I,e.$rb=S,e.$sb=h,e.$tb=P,e.$ub=w;function r(l,m){const g=a(l,m);if(g!==-1)return l[g]}function a(l,m,g=l.length-1){for(let $=g;$>=0;$--){const n=l[$];if(m(n))return $}return-1}function k(l,m){const g=A(l,m);return g===-1?void 0:l[g]}function A(l,m,g=0,$=l.length){let n=g,o=$;for(;n<o;){const t=Math.floor((n+o)/2);m(l[t])?n=t+1:o=t}return n-1}function O(l,m){const g=R(l,m);return g===l.length?void 0:l[g]}function R(l,m,g=0,$=l.length){let n=g,o=$;for(;n<o;){const t=Math.floor((n+o)/2);m(l[t])?o=t:n=t+1}return n}function p(l,m,g=0,$=l.length){const n=R(l,m,g,$);return n===l.length?-1:n}class c{constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(c.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!m($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const g=A(this.e,m,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$pb=c,c.assertInvariants=!1;function I(l,m){if(l.length===0)return;let g=l[0];for(let $=1;$<l.length;$++){const n=l[$];m(n,g)>0&&(g=n)}return g}function S(l,m){if(l.length===0)return;let g=l[0];for(let $=1;$<l.length;$++){const n=l[$];m(n,g)>=0&&(g=n)}return g}function h(l,m){return I(l,(g,$)=>-m(g,$))}function P(l,m){if(l.length===0)return-1;let g=0;for(let $=1;$<l.length;$++){const n=l[$];m(n,l[g])>0&&(g=$)}return g}function w(l,m){for(const g of l){const $=m(g);if($!==void 0)return $}}}),define(Se[27],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(Se[79],De([1,0]),function(ie,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$I=void 0,e.$E=a,e.$F=k,e.$G=A,e.$H=O;function a(p,c){const I=Object.create(null);for(const S of p){const h=c(S);let P=I[h];P||(P=I[h]=[]),P.push(S)}return I}function k(p,c){const I=[],S=[];for(const h of p)c.has(h)||I.push(h);for(const h of c)p.has(h)||S.push(h);return{removed:I,added:S}}function A(p,c){const I=[],S=[];for(const[h,P]of p)c.has(h)||I.push(P);for(const[h,P]of c)p.has(h)||S.push(P);return{removed:I,added:S}}function O(p,c){const I=new Set;for(const S of c)p.has(S)&&I.add(S);return I}class R{constructor(c,I){this.b=I,this.a=new Map,this[r]="SetWithKey";for(const S of c)this.add(S)}get size(){return this.a.size}add(c){const I=this.b(c);return this.a.set(I,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,I){this.a.forEach(S=>c.call(I,S,S,this))}[Symbol.iterator](){return this.values()}}e.$I=R,r=Symbol.toStringTag}),define(Se[59],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=a,e.$_h=k,e.$ai=A;function r(O){return(R,p,c)=>{let I=null,S=null;if(typeof c.value=="function"?(I="value",S=c.value):typeof c.get=="function"&&(I="get",S=c.get),!S)throw new Error("not supported");c[I]=O(S,p)}}function a(O,R,p){let c=null,I=null;if(typeof p.value=="function"?(c="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",I=p.get),!I)throw new Error("not supported");const S=`$memoize$${R}`;p[c]=function(...h){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,h)}),this[S]}}function k(O,R,p){return r((c,I)=>{const S=`$debounce$${I}`,h=`$debounce$result$${I}`;return function(...P){this[h]||(this[h]=p?p():void 0),clearTimeout(this[S]),R&&(this[h]=R(this[h],...P),P=[this[h]]),this[S]=setTimeout(()=>{c.apply(this,P),this[h]=p?p():void 0},O)}})}function A(O,R,p){return r((c,I)=>{const S=`$throttle$timer$${I}`,h=`$throttle$result$${I}`,P=`$throttle$lastRun$${I}`,w=`$throttle$pending$${I}`;return function(...l){if(this[h]||(this[h]=p?p():void 0),(this[P]===null||this[P]===void 0)&&(this[P]=-Number.MAX_VALUE),R&&(this[h]=R(this[h],...l)),this[w])return;const m=this[P]+O;m<=Date.now()?(this[P]=Date.now(),c.apply(this,[this[h]]),this[h]=p?p():void 0):(this[w]=!0,this[S]=setTimeout(()=>{this[w]=!1,this[P]=Date.now(),c.apply(this,[this[h]]),this[h]=p?p():void 0},m-Date.now()))}})}}),define(Se[14],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=e.$eb=e.$db=e.$cb=e.$bb=e.$_=e.$8=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=a,e.$2=k,e.$3=A,e.$4=O,e.$5=R,e.$6=p,e.$7=I,e.$9=h,e.$0=P,e.$$=w,e.$ab=m;class r{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?o.isErrorNoTelemetry(s)?new o(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(d=>{d(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.$Y=r,e.$Z=new r;function a(i){e.$Z.setUnexpectedErrorHandler(i)}function k(i){if(!i||typeof i!="object")return!1;const s=i;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}function A(i){I(i)||e.$Z.onUnexpectedError(i)}function O(i){I(i)||e.$Z.onUnexpectedExternalError(i)}function R(i){if(i instanceof Error){const{name:s,message:d}=i,u=i.stacktrace||i.stack;return{$isError:!0,name:s,message:d,stack:u,noTelemetry:o.isErrorNoTelemetry(i)}}return i}function p(i){let s;return i.noTelemetry?s=new o:(s=new Error,s.name=i.name),s.message=i.message,s.stack=i.stack,s}const c="Canceled";function I(i){return i instanceof S?!0:i instanceof Error&&i.name===c&&i.message===c}class S extends Error{constructor(){super(c),this.name=this.message}}e.$8=S;function h(){const i=new Error(c);return i.name=i.message,i}function P(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function w(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class l extends TypeError{constructor(s){super(s?`${s} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$_=l;function m(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class g extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.$bb=g;class $ extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.$cb=$;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$db=n;class o extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof o)return s;const d=new o;return d.message=s.message,d.stack=s.stack,d}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.$eb=o;class t extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$fb=t}),define(Se[19],De([1,0,14,133]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.$bc=e.$_b=e.$$b=e.CompareResult=void 0,e.$vb=k,e.$wb=A,e.$xb=O,e.$yb=R,e.$zb=p,e.$Ab=c,e.$Bb=I,e.$Cb=S,e.$Db=h,e.$Eb=P,e.$Fb=w,e.$Gb=l,e.$Hb=m,e.top=g,e.$Jb=$,e.$Kb=o,e.$Lb=t,e.$Mb=i,e.$Nb=s,e.$Ob=d,e.$Pb=u,e.$Qb=b,e.$Rb=E,e.$Sb=D,e.$Tb=y,e.$Ub=T,e.$Vb=C,e.$Wb=v,e.$Xb=f,e.$Yb=N,e.$Zb=F,e.$1b=j,e.$2b=z,e.$3b=M,e.$4b=L,e.$5b=B,e.$6b=W,e.$7b=ae,e.$8b=q,e.$9b=re,e.$0b=ge,e.$ac=fe;function k(te,_=0){return te[te.length-(1+_)]}function A(te){if(te.length===0)throw new Error("Invalid tail call");return[te.slice(0,te.length-1),te[te.length-1]]}function O(te,_,ne=(le,J)=>le===J){if(te===_)return!0;if(!te||!_||te.length!==_.length)return!1;for(let le=0,J=te.length;le<J;le++)if(!ne(te[le],_[le]))return!1;return!0}function R(te,_){const ne=te.length-1;_<ne&&(te[_]=te[ne]),te.pop()}function p(te,_,ne){return c(te.length,le=>ne(te[le],_))}function c(te,_){let ne=0,le=te-1;for(;ne<=le;){const J=(ne+le)/2|0,ce=_(J);if(ce<0)ne=J+1;else if(ce>0)le=J-1;else return J}return-(ne+1)}function I(te,_,ne){if(te=te|0,te>=_.length)throw new TypeError("invalid index");const le=_[Math.floor(_.length*Math.random())],J=[],ce=[],me=[];for(const we of _){const Me=ne(we,le);Me<0?J.push(we):Me>0?ce.push(we):me.push(we)}return te<J.length?I(te,J,ne):te<J.length+me.length?me[0]:I(te-(J.length+me.length),ce,ne)}function S(te,_){const ne=[];let le;for(const J of te.slice(0).sort(_))!le||_(le[0],J)!==0?(le=[J],ne.push(le)):le.push(J);return ne}function*h(te,_){let ne,le;for(const J of te)le!==void 0&&_(le,J)?ne.push(J):(ne&&(yield ne),ne=[J]),le=J;ne&&(yield ne)}function P(te,_){for(let ne=0;ne<=te.length;ne++)_(ne===0?void 0:te[ne-1],ne===te.length?void 0:te[ne])}function w(te,_){for(let ne=0;ne<te.length;ne++)_(ne===0?void 0:te[ne-1],te[ne],ne+1===te.length?void 0:te[ne+1])}function l(te,_,ne){const le=[];function J(we,Me,qe){if(Me===0&&qe.length===0)return;const ke=le[le.length-1];ke&&ke.start+ke.deleteCount===we?(ke.deleteCount+=Me,ke.toInsert.push(...qe)):le.push({start:we,deleteCount:Me,toInsert:qe})}let ce=0,me=0;for(;;){if(ce===te.length){J(ce,0,_.slice(me));break}if(me===_.length){J(ce,te.length-ce,[]);break}const we=te[ce],Me=_[me],qe=ne(we,Me);qe===0?(ce+=1,me+=1):qe<0?(J(ce,1,[]),ce+=1):qe>0&&(J(ce,0,[Me]),me+=1)}return le}function m(te,_,ne){const le=l(te,_,ne),J=[],ce=[];for(const me of le)J.push(...te.slice(me.start,me.start+me.deleteCount)),ce.push(...me.toInsert);return{removed:J,added:ce}}function g(te,_,ne){if(ne===0)return[];const le=te.slice(0,ne).sort(_);return n(te,_,le,ne,te.length),le}function $(te,_,ne,le,J){return ne===0?Promise.resolve([]):new Promise((ce,me)=>{(async()=>{const we=te.length,Me=te.slice(0,ne).sort(_);for(let qe=ne,ke=Math.min(ne+le,we);qe<we;qe=ke,ke=Math.min(ke+le,we)){if(qe>ne&&await new Promise(Ie=>setTimeout(Ie)),J&&J.isCancellationRequested)throw new r.$8;n(te,_,Me,qe,ke)}return Me})().then(ce,me)})}function n(te,_,ne,le,J){for(const ce=ne.length;le<J;le++){const me=te[le];if(_(me,ne[ce-1])<0){ne.pop();const we=(0,a.$nb)(ne,Me=>_(me,Me)<0);ne.splice(we,0,me)}}}function o(te){return te.filter(_=>!!_)}function t(te){let _=0;for(let ne=0;ne<te.length;ne++)te[ne]&&(te[_]=te[ne],_+=1);te.length=_}function i(te,_,ne){te.splice(ne,0,te.splice(_,1)[0])}function s(te){return!Array.isArray(te)||te.length===0}function d(te){return Array.isArray(te)&&te.length>0}function u(te,_=ne=>ne){const ne=new Set;return te.filter(le=>{const J=_(le);return ne.has(J)?!1:(ne.add(J),!0)})}function b(te){const _=new Set;return ne=>{const le=te(ne);return _.has(le)?!1:(_.add(le),!0)}}function E(te,_){return te.length>0?te[0]:_}function D(te,_){return te.length>0?te[te.length-1]:_}function y(te,_,ne=(le,J)=>le===J){let le=0;for(let J=0,ce=Math.min(te.length,_.length);J<ce&&ne(te[J],_[J]);J++)le++;return le}function T(te,_){let ne=typeof _=="number"?te:0;typeof _=="number"?ne=te:(ne=0,_=te);const le=[];if(ne<=_)for(let J=ne;J<_;J++)le.push(J);else for(let J=ne;J>_;J--)le.push(J);return le}function C(te,_,ne){return te.reduce((le,J)=>(le[_(J)]=ne?ne(J):J,le),Object.create(null))}function v(te,_){return te.push(_),()=>f(te,_)}function f(te,_){const ne=te.indexOf(_);if(ne>-1)return te.splice(ne,1),_}function N(te,_,ne){const le=te.slice(0,_),J=te.slice(_);return le.concat(ne,J)}function F(te,_){let ne;if(typeof _=="number"){let le=_;ne=()=>{const J=Math.sin(le++)*179426549;return J-Math.floor(J)}}else ne=Math.random;for(let le=te.length-1;le>0;le-=1){const J=Math.floor(ne()*(le+1)),ce=te[le];te[le]=te[J],te[J]=ce}}function j(te,_){const ne=te.indexOf(_);ne>-1&&(te.splice(ne,1),te.unshift(_))}function z(te,_){const ne=te.indexOf(_);ne>-1&&(te.splice(ne,1),te.push(_))}function M(te,_){for(const ne of _)te.push(ne)}function L(te,_){return Array.isArray(te)?te.map(_):_(te)}function B(te){return Array.isArray(te)?te:[te]}function W(te){return te[Math.floor(Math.random()*te.length)]}function ae(te,_,ne){const le=K(te,_),J=te.length,ce=ne.length;te.length=J+ce;for(let me=J-1;me>=le;me--)te[me+ce]=te[me];for(let me=0;me<ce;me++)te[me+le]=ne[me]}function q(te,_,ne,le){const J=K(te,_);let ce=te.splice(J,ne);return ce===void 0&&(ce=[]),ae(te,J,le),ce}function K(te,_){return _<0?Math.max(_+te.length,0):Math.min(_,te.length)}var ee;(function(te){function _(ce){return ce<0}te.isLessThan=_;function ne(ce){return ce<=0}te.isLessThanOrEqual=ne;function le(ce){return ce>0}te.isGreaterThan=le;function J(ce){return ce===0}te.isNeitherLessOrGreaterThan=J,te.greaterThan=1,te.lessThan=-1,te.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function re(te,_){return(ne,le)=>_(te(ne),te(le))}function ge(...te){return(_,ne)=>{for(const le of te){const J=le(_,ne);if(!ee.isNeitherLessOrGreaterThan(J))return J}return ee.neitherLessOrGreaterThan}}const Z=(te,_)=>te-_;e.$$b=Z;const $e=(te,_)=>(0,e.$$b)(te?1:0,_?1:0);e.$_b=$e;function fe(te){return(_,ne)=>-te(_,ne)}class oe{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let ne=this.c;for(;ne<this.g.length&&_(this.g[ne]);)ne++;const le=ne===this.c?null:this.g.slice(this.c,ne);return this.c=ne,le}takeFromEndWhile(_){let ne=this.d;for(;ne>=0&&_(this.g[ne]);)ne--;const le=ne===this.d?null:this.g.slice(ne+1,this.d+1);return this.d=ne,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const ne=this.g.slice(this.c,this.c+_);return this.c+=_,ne}}e.$bc=oe;class H{constructor(_){this.iterate=_}forEach(_){this.iterate(ne=>(_(ne),!0))}toArray(){const _=[];return this.iterate(ne=>(_.push(ne),!0)),_}filter(_){return new H(ne=>this.iterate(le=>_(le)?ne(le):!0))}map(_){return new H(ne=>this.iterate(le=>ne(_(le))))}some(_){let ne=!1;return this.iterate(le=>(ne=_(le),!ne)),ne}findFirst(_){let ne;return this.iterate(le=>_(le)?(ne=le,!1):!0),ne}findLast(_){let ne;return this.iterate(le=>(_(le)&&(ne=le),!0)),ne}findLastMaxBy(_){let ne,le=!0;return this.iterate(J=>((le||ee.isGreaterThan(_(J,ne)))&&(le=!1,ne=J),!0)),ne}}e.$cc=H,H.empty=new H(te=>{});class ue{constructor(_){this.c=_}static createSortPermutation(_,ne){const le=Array.from(_.keys()).sort((J,ce)=>ne(_[J],_[ce]));return new ue(le)}apply(_){return _.map((ne,le)=>_[this.c[le]])}inverse(){const _=this.c.slice();for(let ne=0;ne<this.c.length;ne++)_[this.c[ne]]=ne;return new ue(_)}}e.$dc=ue}),define(Se[66],De([1,0,14]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$hd=k,e.$id=A,e.$jd=O,e.$kd=R,e.$ld=p;function a(c,I){if(!c)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function k(c,I="Unreachable"){throw new Error(I)}function A(c,I="unexpected state"){if(!c)throw new r.$fb(`Assertion Failed: ${I}`)}function O(c){c||(0,r.$3)(new r.$fb("Soft Assertion Failed"))}function R(c){if(!c()){debugger;c(),(0,r.$3)(new r.$fb("Assertion Failed"))}}function p(c,I){let S=0;for(;S<c.length-1;){const h=c[S],P=c[S+1];if(!I(h,P))return!1;S++}return!0}});var Yn=this&&this.__createBinding||(Object.create?function(ie,e,r,a){a===void 0&&(a=r);var k=Object.getOwnPropertyDescriptor(e,r);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(ie,a,k)}:function(ie,e,r,a){a===void 0&&(a=r),ie[a]=e[r]}),Zn=this&&this.__setModuleDefault||(Object.create?function(ie,e){Object.defineProperty(ie,"default",{enumerable:!0,value:e})}:function(ie,e){ie.default=e}),Ue=this&&this.__importStar||function(ie){if(ie&&ie.__esModule)return ie;var e={};if(ie!=null)for(var r in ie)r!=="default"&&Object.prototype.hasOwnProperty.call(ie,r)&&Yn(e,ie,r);return Zn(e,ie),e};define(Se[176],De([1,0,19]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=k,e.$$c=A,e.$_c=O,e.$ad=R,e.$bd=p,e.$cd=c,r=Ue(r);const a=(P,w)=>P===w;e.$9c=a;function k(P=e.$9c){return(w,l)=>r.$xb(w,l,P)}function A(){return(P,w)=>JSON.stringify(P)===JSON.stringify(w)}function O(){return(P,w)=>P.equals(w)}function R(P,w,l){if(l!==void 0){const m=P;return m==null||w===void 0||w===null?w===m:l(m,w)}else{const m=P;return(g,$)=>g==null||$===void 0||$===null?$===g:m(g,$)}}function p(P,w){if(P===w)return!0;if(Array.isArray(P)&&Array.isArray(w)){if(P.length!==w.length)return!1;for(let l=0;l<P.length;l++)if(!p(P[l],w[l]))return!1;return!0}if(P&&typeof P=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(P)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const l=P,m=w,g=Object.keys(l),$=Object.keys(m),n=new Set($);if(g.length!==$.length)return!1;for(const o of g)if(!n.has(o)||!p(l[o],m[o]))return!1;return!0}return!1}function c(P){return JSON.stringify(h(P))}let I=0;const S=new WeakMap;function h(P){if(Array.isArray(P))return P.map(h);if(P&&typeof P=="object")if(Object.getPrototypeOf(P)===Object.prototype){const w=P,l=Object.create(null);for(const m of Object.keys(w).sort())l[m]=h(w[m]);return l}else{let w=S.get(P);return w===void 0&&(w=I++,S.set(P,w)),w+"----2b76a038c20c4bcc"}return P}}),define(Se[80],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gb=r;function r(a,k){const A=this;let O=!1,R;return function(){if(O)return R;if(O=!0,k)try{R=a.apply(A,arguments)}finally{k()}else R=a.apply(A,arguments);return R}}}),define(Se[134],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=e.$7P=void 0;class r{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.$7P=r,e.$8P=new r("id#")}),define(Se[40],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(a){function k(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}a.is=k;const A=Object.freeze([]);function O(){return A}a.empty=O;function*R(s){yield s}a.single=R;function p(s){return k(s)?s:R(s)}a.wrap=p;function c(s){return s||A}a.from=c;function*I(s){for(let d=s.length-1;d>=0;d--)yield s[d]}a.reverse=I;function S(s){return!s||s[Symbol.iterator]().next().done===!0}a.isEmpty=S;function h(s){return s[Symbol.iterator]().next().value}a.first=h;function P(s,d){let u=0;for(const b of s)if(d(b,u++))return!0;return!1}a.some=P;function w(s,d){for(const u of s)if(d(u))return u}a.find=w;function*l(s,d){for(const u of s)d(u)&&(yield u)}a.filter=l;function*m(s,d){let u=0;for(const b of s)yield d(b,u++)}a.map=m;function*g(s,d){let u=0;for(const b of s)yield*d(b,u++)}a.flatMap=g;function*$(...s){for(const d of s)yield*d}a.concat=$;function n(s,d,u){let b=u;for(const E of s)b=d(b,E);return b}a.reduce=n;function*o(s,d,u=s.length){for(d<0&&(d+=s.length),u<0?u+=s.length:u>s.length&&(u=s.length);d<u;d++)yield s[d]}a.slice=o;function t(s,d=Number.POSITIVE_INFINITY){const u=[];if(d===0)return[u,s];const b=s[Symbol.iterator]();for(let E=0;E<d;E++){const D=b.next();if(D.done)return[u,a.empty()];u.push(D.value)}return[u,{[Symbol.iterator](){return b}}]}a.consume=t;async function i(s){const d=[];for await(const u of s)d.push(u);return Promise.resolve(d)}a.asyncToArray=i})(r||(e.Iterable=r={}))}),define(Se[177],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Xn=O,e.$Yn=S,e.$Zn=h,e.$1n=P,e.$2n=w,e.$3n=l,e.$4n=m,e.$5n=g,e.$6n=$,e.$7n=n,e.$8n=o;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var a;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(t,i=!1){let s=0;const d=t.length;let u="",b=0,E=a.Unknown,D=r.None;function y(j){let z=0,M=0;for(;z<j;){const L=t.charCodeAt(s);if(L>=I._0&&L<=I._9)M=M*16+L-I._0;else if(L>=I.A&&L<=I.F)M=M*16+L-I.A+10;else if(L>=I.a&&L<=I.f)M=M*16+L-I.a+10;else break;s++,z++}return z<j&&(M=-1),M}function T(j){s=j,u="",b=0,E=a.Unknown,D=r.None}function C(){const j=s;if(t.charCodeAt(s)===I._0)s++;else for(s++;s<t.length&&c(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===I.dot)if(s++,s<t.length&&c(t.charCodeAt(s)))for(s++;s<t.length&&c(t.charCodeAt(s));)s++;else return D=r.UnexpectedEndOfNumber,t.substring(j,s);let z=s;if(s<t.length&&(t.charCodeAt(s)===I.E||t.charCodeAt(s)===I.e))if(s++,(s<t.length&&t.charCodeAt(s)===I.plus||t.charCodeAt(s)===I.minus)&&s++,s<t.length&&c(t.charCodeAt(s))){for(s++;s<t.length&&c(t.charCodeAt(s));)s++;z=s}else D=r.UnexpectedEndOfNumber;return t.substring(j,z)}function v(){let j="",z=s;for(;;){if(s>=d){j+=t.substring(z,s),D=r.UnexpectedEndOfString;break}const M=t.charCodeAt(s);if(M===I.doubleQuote){j+=t.substring(z,s),s++;break}if(M===I.backslash){if(j+=t.substring(z,s),s++,s>=d){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(s++)){case I.doubleQuote:j+='"';break;case I.backslash:j+="\\";break;case I.slash:j+="/";break;case I.b:j+="\b";break;case I.f:j+="\f";break;case I.n:j+=`
`;break;case I.r:j+="\r";break;case I.t:j+="	";break;case I.u:{const B=y(4);B>=0?j+=String.fromCharCode(B):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}z=s;continue}if(M>=0&&M<=31)if(p(M)){j+=t.substring(z,s),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;s++}return j}function f(){if(u="",D=r.None,b=s,s>=d)return b=d,E=a.EOF;let j=t.charCodeAt(s);if(R(j)){do s++,u+=String.fromCharCode(j),j=t.charCodeAt(s);while(R(j));return E=a.Trivia}if(p(j))return s++,u+=String.fromCharCode(j),j===I.carriageReturn&&t.charCodeAt(s)===I.lineFeed&&(s++,u+=`
`),E=a.LineBreakTrivia;switch(j){case I.openBrace:return s++,E=a.OpenBraceToken;case I.closeBrace:return s++,E=a.CloseBraceToken;case I.openBracket:return s++,E=a.OpenBracketToken;case I.closeBracket:return s++,E=a.CloseBracketToken;case I.colon:return s++,E=a.ColonToken;case I.comma:return s++,E=a.CommaToken;case I.doubleQuote:return s++,u=v(),E=a.StringLiteral;case I.slash:{const z=s-1;if(t.charCodeAt(s+1)===I.slash){for(s+=2;s<d&&!p(t.charCodeAt(s));)s++;return u=t.substring(z,s),E=a.LineCommentTrivia}if(t.charCodeAt(s+1)===I.asterisk){s+=2;const M=d-1;let L=!1;for(;s<M;){if(t.charCodeAt(s)===I.asterisk&&t.charCodeAt(s+1)===I.slash){s+=2,L=!0;break}s++}return L||(s++,D=r.UnexpectedEndOfComment),u=t.substring(z,s),E=a.BlockCommentTrivia}return u+=String.fromCharCode(j),s++,E=a.Unknown}case I.minus:if(u+=String.fromCharCode(j),s++,s===d||!c(t.charCodeAt(s)))return E=a.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return u+=C(),E=a.NumericLiteral;default:for(;s<d&&N(j);)s++,j=t.charCodeAt(s);if(b!==s){switch(u=t.substring(b,s),u){case"true":return E=a.TrueKeyword;case"false":return E=a.FalseKeyword;case"null":return E=a.NullKeyword}return E=a.Unknown}return u+=String.fromCharCode(j),s++,E=a.Unknown}}function N(j){if(R(j)||p(j))return!1;switch(j){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function F(){let j;do j=f();while(j>=a.LineCommentTrivia&&j<=a.Trivia);return j}return{setPosition:T,getPosition:()=>s,scan:i?F:f,getToken:()=>E,getTokenValue:()=>u,getTokenOffset:()=>b,getTokenLength:()=>s-b,getTokenError:()=>D}}function R(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function c(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function S(t,i){const s=[],d=new Object;let u;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(y,T,C,v){b.value=y,b.offset=T,b.length=C,b.type=v,b.colonOffset=void 0,u=b}try{n(t,{onObjectBegin:(y,T)=>{if(i<=y)throw d;u=void 0,E=i>y,s.push("")},onObjectProperty:(y,T,C)=>{if(i<T||(D(y,T,C,"property"),s[s.length-1]=y,i<=T+C))throw d},onObjectEnd:(y,T)=>{if(i<=y)throw d;u=void 0,s.pop()},onArrayBegin:(y,T)=>{if(i<=y)throw d;u=void 0,s.push(0)},onArrayEnd:(y,T)=>{if(i<=y)throw d;u=void 0,s.pop()},onLiteralValue:(y,T,C)=>{if(i<T||(D(y,T,C,o(y)),i<=T+C))throw d},onSeparator:(y,T,C)=>{if(i<=T)throw d;if(y===":"&&u&&u.type==="property")u.colonOffset=T,E=!1,u=void 0;else if(y===","){const v=s[s.length-1];typeof v=="number"?s[s.length-1]=v+1:(E=!0,s[s.length-1]=""),u=void 0}}})}catch(y){if(y!==d)throw y}return{path:s,previousNode:u,isAtPropertyKey:E,matches:y=>{let T=0;for(let C=0;T<y.length&&C<s.length;C++)if(y[T]===s[C]||y[T]==="*")T++;else if(y[T]!=="**")return!1;return T===y.length}}}function h(t,i=[],s=A.DEFAULT){let d=null,u=[];const b=[];function E(y){Array.isArray(u)?u.push(y):d!==null&&(u[d]=y)}return n(t,{onObjectBegin:()=>{const y={};E(y),b.push(u),u=y,d=null},onObjectProperty:y=>{d=y},onObjectEnd:()=>{u=b.pop()},onArrayBegin:()=>{const y=[];E(y),b.push(u),u=y,d=null},onArrayEnd:()=>{u=b.pop()},onLiteralValue:E,onError:(y,T,C)=>{i.push({error:y,offset:T,length:C})}},s),u[0]}function P(t,i=[],s=A.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(y){d.type==="property"&&(d.length=y-d.offset,d=d.parent)}function b(y){return d.children.push(y),y}n(t,{onObjectBegin:y=>{d=b({type:"object",offset:y,length:-1,parent:d,children:[]})},onObjectProperty:(y,T,C)=>{d=b({type:"property",offset:T,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:y,offset:T,length:C,parent:d})},onObjectEnd:(y,T)=>{d.length=y+T-d.offset,d=d.parent,u(y+T)},onArrayBegin:(y,T)=>{d=b({type:"array",offset:y,length:-1,parent:d,children:[]})},onArrayEnd:(y,T)=>{d.length=y+T-d.offset,d=d.parent,u(y+T)},onLiteralValue:(y,T,C)=>{b({type:o(y),offset:T,length:C,parent:d,value:y}),u(T+C)},onSeparator:(y,T,C)=>{d.type==="property"&&(y===":"?d.colonOffset=T:y===","&&u(T))},onError:(y,T,C)=>{i.push({error:y,offset:T,length:C})}},s);const D=d.children[0];return D&&delete D.parent,D}function w(t,i){if(!t)return;let s=t;for(const d of i)if(typeof d=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const b of s.children)if(Array.isArray(b.children)&&b.children[0].value===d){s=b.children[1],u=!0;break}if(!u)return}else{const u=d;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}function l(t){if(!t.parent||!t.parent.children)return[];const i=l(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const i=Object.create(null);for(const s of t.children){const d=s.children[1];d&&(i[s.children[0].value]=m(d))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function g(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}function $(t,i,s=!1){if(g(t,i,s)){const d=t.children;if(Array.isArray(d))for(let u=0;u<d.length&&d[u].offset<=i;u++){const b=$(d[u],i,s);if(b)return b}return t}}function n(t,i,s=A.DEFAULT){const d=O(t,!1);function u(re){return re?()=>re(d.getTokenOffset(),d.getTokenLength()):()=>!0}function b(re){return re?ge=>re(ge,d.getTokenOffset(),d.getTokenLength()):()=>!0}const E=u(i.onObjectBegin),D=b(i.onObjectProperty),y=u(i.onObjectEnd),T=u(i.onArrayBegin),C=u(i.onArrayEnd),v=b(i.onLiteralValue),f=b(i.onSeparator),N=u(i.onComment),F=b(i.onError),j=s&&s.disallowComments,z=s&&s.allowTrailingComma;function M(){for(;;){const re=d.scan();switch(d.getTokenError()){case r.InvalidUnicode:L(k.InvalidUnicode);break;case r.InvalidEscapeCharacter:L(k.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:L(k.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:j||L(k.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:L(k.UnexpectedEndOfString);break;case r.InvalidCharacter:L(k.InvalidCharacter);break}switch(re){case a.LineCommentTrivia:case a.BlockCommentTrivia:j?L(k.InvalidCommentToken):N();break;case a.Unknown:L(k.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return re}}}function L(re,ge=[],Z=[]){if(F(re),ge.length+Z.length>0){let $e=d.getToken();for(;$e!==a.EOF;){if(ge.indexOf($e)!==-1){M();break}else if(Z.indexOf($e)!==-1)break;$e=M()}}}function B(re){const ge=d.getTokenValue();return re?v(ge):D(ge),M(),!0}function W(){switch(d.getToken()){case a.NumericLiteral:{let re=0;try{re=JSON.parse(d.getTokenValue()),typeof re!="number"&&(L(k.InvalidNumberFormat),re=0)}catch{L(k.InvalidNumberFormat)}v(re);break}case a.NullKeyword:v(null);break;case a.TrueKeyword:v(!0);break;case a.FalseKeyword:v(!1);break;default:return!1}return M(),!0}function ae(){return d.getToken()!==a.StringLiteral?(L(k.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(B(!1),d.getToken()===a.ColonToken?(f(":"),M(),ee()||L(k.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):L(k.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function q(){E(),M();let re=!1;for(;d.getToken()!==a.CloseBraceToken&&d.getToken()!==a.EOF;){if(d.getToken()===a.CommaToken){if(re||L(k.ValueExpected,[],[]),f(","),M(),d.getToken()===a.CloseBraceToken&&z)break}else re&&L(k.CommaExpected,[],[]);ae()||L(k.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),re=!0}return y(),d.getToken()!==a.CloseBraceToken?L(k.CloseBraceExpected,[a.CloseBraceToken],[]):M(),!0}function K(){T(),M();let re=!1;for(;d.getToken()!==a.CloseBracketToken&&d.getToken()!==a.EOF;){if(d.getToken()===a.CommaToken){if(re||L(k.ValueExpected,[],[]),f(","),M(),d.getToken()===a.CloseBracketToken&&z)break}else re&&L(k.CommaExpected,[],[]);ee()||L(k.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),re=!0}return C(),d.getToken()!==a.CloseBracketToken?L(k.CloseBracketExpected,[a.CloseBracketToken],[]):M(),!0}function ee(){switch(d.getToken()){case a.OpenBracketToken:return K();case a.OpenBraceToken:return q();case a.StringLiteral:return B(!0);default:return W()}}return M(),d.getToken()===a.EOF?s.allowEmptyContent?!0:(L(k.ValueExpected,[],[]),!1):ee()?(d.getToken()!==a.EOF&&L(k.EndOfFileExpected,[],[]),!0):(L(k.ValueExpected,[],[]),!1)}function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Se[49],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class r{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=r}),define(Se[81],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0;class r{constructor(A){this.element=A,this.next=r.Undefined,this.prev=r.Undefined}}r.Undefined=new r(void 0);class a{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let A=this.a;for(;A!==r.Undefined;){const O=A.next;A.prev=r.Undefined,A.next=r.Undefined,A=O}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const R=new r(A);if(this.a===r.Undefined)this.a=R,this.b=R;else if(O){const c=this.b;this.b=R,R.prev=c,c.next=R}else{const c=this.a;this.a=R,R.next=c,c.prev=R}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(R))}}shift(){if(this.a!==r.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==r.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==r.Undefined&&A.next!==r.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===r.Undefined&&A.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):A.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):A.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==r.Undefined;)yield A.element,A=A.next}}e.$8c=a}),define(Se[29],De([1,0]),function(ie,e){"use strict";var r,a,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.Touch=e.$Ec=e.$Dc=void 0,e.$Ac=A,e.$Bc=O,e.$Cc=R,e.$Lc=o;function A(t,i,s){let d=t.get(i);return d===void 0&&(d=s,t.set(i,d)),d}function O(t){const i=[];return t.forEach((s,d)=>{i.push(`${d} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}function R(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}class p{constructor(i,s){this.uri=i,this.value=s}}function c(t){return Array.isArray(t)}class I{constructor(i,s){if(this[r]="ResourceMap",i instanceof I)this.d=new Map(i.d),this.e=s??I.c;else if(c(i)){this.d=new Map,this.e=s??I.c;for(const[d,u]of i)this.set(d,u)}else this.d=new Map,this.e=i??I.c}set(i,s){return this.d.set(this.e(i),new p(i,s)),this}get(i){return this.d.get(this.e(i))?.value}has(i){return this.d.has(this.e(i))}get size(){return this.d.size}clear(){this.d.clear()}delete(i){return this.d.delete(this.e(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[d,u]of this.d)i(u.value,u.uri,this)}*values(){for(const i of this.d.values())yield i.value}*keys(){for(const i of this.d.values())yield i.uri}*entries(){for(const i of this.d.values())yield[i.uri,i.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.d)yield[i.uri,i.value]}}e.$Dc=I,I.c=t=>t.toString();class S{constructor(i,s){this[a]="ResourceSet",!i||typeof i=="function"?this.c=new I(i):(this.c=new I(s),i.forEach(this.add,this))}get size(){return this.c.size}add(i){return this.c.set(i,i),this}clear(){this.c.clear()}delete(i){return this.c.delete(i)}forEach(i,s){this.c.forEach((d,u)=>i.call(s,u,u,this))}has(i){return this.c.has(i)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ec=S;var h;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(h||(e.Touch=h={}));class P{constructor(){this[k]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(i){return this.c.has(i)}get(i,s=h.None){const d=this.c.get(i);if(d)return s!==h.None&&this.m(d,s),d.value}set(i,s,d=h.None){let u=this.c.get(i);if(u)u.value=s,d!==h.None&&this.m(u,d);else{switch(u={key:i,value:s,next:void 0,previous:void 0},d){case h.None:this.k(u);break;case h.AsOld:this.j(u);break;case h.AsNew:this.k(u);break;default:this.k(u);break}this.c.set(i,u),this.f++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this.c.get(i);if(s)return this.c.delete(i),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const i=this.d;return this.c.delete(i.key),this.l(i),this.f--,i.value}forEach(i,s){const d=this.g;let u=this.d;for(;u;){if(s?i.bind(s)(u.value,u.key,this):i(u.value,u.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,s=this.g;let d=this.d;const u={[Symbol.iterator](){return u},next(){if(i.g!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const b={value:d.key,done:!1};return d=d.next,b}else return{value:void 0,done:!0}}};return u}values(){const i=this,s=this.g;let d=this.d;const u={[Symbol.iterator](){return u},next(){if(i.g!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const b={value:d.value,done:!1};return d=d.next,b}else return{value:void 0,done:!0}}};return u}entries(){const i=this,s=this.g;let d=this.d;const u={[Symbol.iterator](){return u},next(){if(i.g!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const b={value:[d.key,d.value],done:!1};return d=d.next,b}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this.d,d=this.size;for(;s&&d>i;)this.c.delete(s.key),s=s.next,d--;this.d=s,this.f=d,s&&(s.previous=void 0),this.g++}i(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this.e,d=this.size;for(;s&&d>i;)this.c.delete(s.key),s=s.previous,d--;this.e=s,this.f=d,s&&(s.next=void 0),this.g++}j(i){if(!this.d&&!this.e)this.e=i;else if(this.d)i.next=this.d,this.d.previous=i;else throw new Error("Invalid list");this.d=i,this.g++}k(i){if(!this.d&&!this.e)this.d=i;else if(this.e)i.previous=this.e,this.e.next=i;else throw new Error("Invalid list");this.e=i,this.g++}l(i){if(i===this.d&&i===this.e)this.d=void 0,this.e=void 0;else if(i===this.d){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.d=i.next}else if(i===this.e){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.e=i.previous}else{const s=i.next,d=i.previous;if(!s||!d)throw new Error("Invalid list");s.previous=d,d.next=s}i.next=void 0,i.previous=void 0,this.g++}m(i,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==h.AsOld&&s!==h.AsNew)){if(s===h.AsOld){if(i===this.d)return;const d=i.next,u=i.previous;i===this.e?(u.next=void 0,this.e=u):(d.previous=u,u.next=d),i.previous=void 0,i.next=this.d,this.d.previous=i,this.d=i,this.g++}else if(s===h.AsNew){if(i===this.e)return;const d=i.next,u=i.previous;i===this.d?(d.previous=void 0,this.d=d):(d.previous=u,u.next=d),i.next=void 0,i.previous=this.e,this.e.next=i,this.e=i,this.g++}}}toJSON(){const i=[];return this.forEach((s,d)=>{i.push([d,s])}),i}fromJSON(i){this.clear();for(const[s,d]of i)this.set(s,d)}}e.$Fc=P;class w extends P{constructor(i,s=1){super(),this.n=i,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(i){this.n=i,this.p()}get ratio(){return this.o}set ratio(i){this.o=Math.min(Math.max(0,i),1),this.p()}get(i,s=h.AsNew){return super.get(i,s)}peek(i){return super.get(i,h.None)}set(i,s){return super.set(i,s,h.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class l extends w{constructor(i,s=1){super(i,s)}q(i){this.h(i)}set(i,s){return super.set(i,s),this.p(),this}}e.$Gc=l;class m extends w{constructor(i,s=1){super(i,s)}q(i){this.i(i)}set(i,s){return this.n<=this.size&&!this.has(i)&&this.q(Math.round(this.n*this.o)-1),super.set(i,s),this}}e.$Hc=m;class g{constructor(){this.c=new Map}add(i){return this.c.set(i,(this.c.get(i)||0)+1),this}delete(i){let s=this.c.get(i)||0;return s===0?!1:(s--,s===0?this.c.delete(i):this.c.set(i,s),!0)}has(i){return this.c.has(i)}}e.$Ic=g;class ${constructor(i){if(this.c=new Map,this.d=new Map,i)for(const[s,d]of i)this.set(s,d)}clear(){this.c.clear(),this.d.clear()}set(i,s){this.c.set(i,s),this.d.set(s,i)}get(i){return this.c.get(i)}getKey(i){return this.d.get(i)}delete(i){const s=this.c.get(i);return s===void 0?!1:(this.c.delete(i),this.d.delete(s),!0)}forEach(i,s){this.c.forEach((d,u)=>{i.call(s,d,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Jc=$;class n{constructor(){this.c=new Map}add(i,s){let d=this.c.get(i);d||(d=new Set,this.c.set(i,d)),d.add(s)}delete(i,s){const d=this.c.get(i);d&&(d.delete(s),d.size===0&&this.c.delete(i))}forEach(i,s){const d=this.c.get(i);d&&d.forEach(s)}get(i){const s=this.c.get(i);return s||new Set}}e.$Kc=n;function o(t,i){if(t===i)return!0;if(t.size!==i.size)return!1;for(const[s,d]of t)if(!i.has(s)||i.get(s)!==d)return!1;for(const[s]of i)if(!t.has(s))return!1;return!0}}),define(Se[3],De([1,0,19,79,29,80,40]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$5c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Mc=void 0,e.$Nc=I,e.$Oc=S,e.$Pc=h,e.$Qc=l,e.$Rc=m,e.$Sc=g,e.$Tc=$,e.$Uc=n,e.$Vc=o,e.$6c=T;const R=!1;let p=null;class c{constructor(){this.b=new Map}c(f){let N=this.b.get(f);return N||(N={parent:null,source:null,isSingleton:!1,value:f,idx:c.a++},this.b.set(f,N)),N}trackDisposable(f){const N=this.c(f);N.source||(N.source=new Error().stack)}setParent(f,N){const F=this.c(f);F.parent=N}markAsDisposed(f){this.b.delete(f)}markAsSingleton(f){this.c(f).isSingleton=!0}f(f,N){const F=N.get(f);if(F)return F;const j=f.parent?this.f(this.c(f.parent),N):f;return N.set(f,j),j}getTrackedDisposables(){const f=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,f).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(f=10,N){let F;if(N)F=N;else{const B=new Map,W=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,B).isSingleton);if(W.length===0)return;const ae=new Set(W.map(q=>q.value));if(F=W.filter(q=>!(q.parent&&ae.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function j(B){function W(q,K){for(;q.length>0&&K.some(ee=>typeof ee=="string"?ee===q[0]:q[0].match(ee));)q.shift()}const ae=B.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return W(ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ae.reverse()}const z=new k.$Kc;for(const B of F){const W=j(B);for(let ae=0;ae<=W.length;ae++)z.add(W.slice(0,ae).join(`
`),B)}F.sort((0,r.$9b)(B=>B.idx,r.$$b));let M="",L=0;for(const B of F.slice(0,f)){L++;const W=j(B),ae=[];for(let q=0;q<W.length;q++){let K=W[q];K=`(shared with ${z.get(W.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${K}`;const re=z.get(W.slice(0,q).join(`
`)),ge=(0,a.$E)([...re].map(Z=>j(Z)[q]),Z=>Z);delete ge[W[q]];for(const[Z,$e]of Object.entries(ge))ae.unshift(`    - stacktraces of ${$e.length} other leaks continue with ${Z}`);ae.unshift(K)}M+=`


==================== Leaking disposable ${L}/${F.length}: ${B.value.constructor.name} ====================
${ae.join(`
`)}
============================================================

`}return F.length>f&&(M+=`


... and ${F.length-f} more leaking disposables

`),{leaks:F,details:M}}}e.$Mc=c,c.a=0;function I(v){p=v}if(R){const v="__is_disposable_tracked__";I(new class{trackDisposable(f){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[v]||console.log(N)},3e3)}setParent(f,N){if(f&&f!==i.None)try{f[v]=!0}catch{}}markAsDisposed(f){if(f&&f!==i.None)try{f[v]=!0}catch{}}markAsSingleton(f){}})}function S(v){return p?.trackDisposable(v),v}function h(v){p?.markAsDisposed(v)}function P(v,f){p?.setParent(v,f)}function w(v,f){if(p)for(const N of v)p.setParent(N,f)}function l(v){return p?.markAsSingleton(v),v}function m(v){return typeof v=="object"&&v!==null&&typeof v.dispose=="function"&&v.dispose.length===0}function g(v){if(O.Iterable.is(v)){const f=[];for(const N of v)if(N)try{N.dispose()}catch(F){f.push(F)}if(f.length===1)throw f[0];if(f.length>1)throw new AggregateError(f,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}function $(v){for(const f of v)m(f)&&f.dispose();return[]}function n(...v){const f=o(()=>g(v));return w(v,f),f}function o(v){const f=S({dispose:(0,A.$gb)(()=>{h(f),v()})});return f}class t{constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return P(f,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(f),f}delete(f){if(f){if(f===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(f),f.dispose()}}deleteAndLeak(f){f&&this.f.has(f)&&(this.f.delete(f),P(f,null))}}e.$Wc=t,t.DISABLE_DISPOSED_WARNING=!1;class i{constructor(){this.q=new t,S(this),P(this.q,this)}dispose(){h(this),this.q.dispose()}B(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(f)}}e.$Xc=i,i.None=Object.freeze({dispose(){}});class s{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(f){this.b||f===this.a||(this.a?.dispose(),f&&P(f,this),this.a=f)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const f=this.a;return this.a=void 0,f&&P(f,null),f}}e.$Yc=s;class d{constructor(f){this.a=new s,this.b=!1,this.a.value=f}get value(){return this.a.value}set value(f){this.b||f===this.a.value||(this.a.value=f)}dispose(){this.b=!0,this.a.dispose()}}e.$Zc=d;class u{constructor(f){this.b=f,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$1c=u;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(f){let N=f;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,h(this))},this}}e.$2c=b;class E{constructor(){this.a=new Map}acquire(f,...N){let F=this.a.get(f);F||(F={counter:0,object:this.b(f,...N)},this.a.set(f,F));const{object:j}=F,z=(0,A.$gb)(()=>{--F.counter===0&&(this.c(f,F.object),this.a.delete(f))});return F.counter++,{object:j,dispose:z}}}e.$3c=E;class D{constructor(f){this.a=f}async acquire(f,...N){const F=this.a.acquire(f,...N);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(j){throw F.dispose(),j}}}e.$4c=D;class y{constructor(f){this.object=f}dispose(){}}e.$5c=y;function T(v){const f=new t;try{v(f)}finally{f.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(f){return this.a.has(f)}get size(){return this.a.size}get(f){return this.a.get(f)}set(f,N,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(f)?.dispose(),this.a.set(f,N)}deleteAndDispose(f){this.a.get(f)?.dispose(),this.a.delete(f)}deleteAndLeak(f){const N=this.a.get(f);return this.a.delete(f),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$7c=C}),function(ie,e){typeof define=="function"&&define.amd?define(Se[178],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(_,ne){for(var le=0;le<ne.length;le++){var J=ne[le];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(_,J.key,J)}}function r(_,ne,le){return ne&&e(_.prototype,ne),le&&e(_,le),Object.defineProperty(_,"prototype",{writable:!1}),_}function a(_,ne){if(_){if(typeof _=="string")return k(_,ne);var le=Object.prototype.toString.call(_).slice(8,-1);if(le==="Object"&&_.constructor&&(le=_.constructor.name),le==="Map"||le==="Set")return Array.from(_);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return k(_,ne)}}function k(_,ne){(ne==null||ne>_.length)&&(ne=_.length);for(var le=0,J=new Array(ne);le<ne;le++)J[le]=_[le];return J}function A(_,ne){var le=typeof Symbol<"u"&&_[Symbol.iterator]||_["@@iterator"];if(le)return(le=le.call(_)).next.bind(le);if(Array.isArray(_)||(le=a(_))||ne&&_&&typeof _.length=="number"){le&&(_=le);var J=0;return function(){return J>=_.length?{done:!0}:{done:!1,value:_[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function O(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=O();function R(_){ie.defaults=_}var p=/[&<>"']/,c=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},P=function(ne){return h[ne]};function w(_,ne){if(ne){if(p.test(_))return _.replace(c,P)}else if(I.test(_))return _.replace(S,P);return _}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(_){return _.replace(l,function(ne,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var g=/(^|[^\[])\^/g;function $(_,ne){_=typeof _=="string"?_:_.source,ne=ne||"";var le={replace:function(ce,me){return me=me.source||me,me=me.replace(g,"$1"),_=_.replace(ce,me),le},getRegex:function(){return new RegExp(_,ne)}};return le}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(_,ne,le){if(_){var J;try{J=decodeURIComponent(m(le)).replace(n,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ne&&!o.test(le)&&(le=b(ne,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var i={},s=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(_,ne){i[" "+_]||(s.test(_)?i[" "+_]=_+"/":i[" "+_]=T(_,"/",!0)),_=i[" "+_];var le=_.indexOf(":")===-1;return ne.substring(0,2)==="//"?le?ne:_.replace(d,"$1")+ne:ne.charAt(0)==="/"?le?ne:_.replace(u,"$1")+ne:_+ne}var E={exec:function(){}};function D(_){for(var ne=1,le,J;ne<arguments.length;ne++){le=arguments[ne];for(J in le)Object.prototype.hasOwnProperty.call(le,J)&&(_[J]=le[J])}return _}function y(_,ne){var le=_.replace(/\|/g,function(me,we,Me){for(var qe=!1,ke=we;--ke>=0&&Me[ke]==="\\";)qe=!qe;return qe?"|":" |"}),J=le.split(/ \|/),ce=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ne)J.splice(ne);else for(;J.length<ne;)J.push("");for(;ce<J.length;ce++)J[ce]=J[ce].trim().replace(/\\\|/g,"|");return J}function T(_,ne,le){var J=_.length;if(J===0)return"";for(var ce=0;ce<J;){var me=_.charAt(J-ce-1);if(me===ne&&!le)ce++;else if(me!==ne&&le)ce++;else break}return _.slice(0,J-ce)}function C(_,ne){if(_.indexOf(ne[1])===-1)return-1;for(var le=_.length,J=0,ce=0;ce<le;ce++)if(_[ce]==="\\")ce++;else if(_[ce]===ne[0])J++;else if(_[ce]===ne[1]&&(J--,J<0))return ce;return-1}function v(_){_&&_.sanitize&&!_.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function f(_,ne){if(ne<1)return"";for(var le="";ne>1;)ne&1&&(le+=_),ne>>=1,_+=_;return le+_}function N(_,ne,le,J){var ce=ne.href,me=ne.title?w(ne.title):null,we=_[1].replace(/\\([\[\]])/g,"$1");if(_[0].charAt(0)!=="!"){J.state.inLink=!0;var Me={type:"link",raw:le,href:ce,title:me,text:we,tokens:J.inlineTokens(we)};return J.state.inLink=!1,Me}return{type:"image",raw:le,href:ce,title:me,text:w(we)}}function F(_,ne){var le=_.match(/^(\s+)(?:```)/);if(le===null)return ne;var J=le[1];return ne.split(`
`).map(function(ce){var me=ce.match(/^\s+/);if(me===null)return ce;var we=me[0];return we.length>=J.length?ce.slice(J.length):ce}).join(`
`)}var j=function(){function _(le){this.options=le||ie.defaults}var ne=_.prototype;return ne.space=function(J){var ce=this.rules.block.newline.exec(J);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},ne.code=function(J){var ce=this.rules.block.code.exec(J);if(ce){var me=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?me:T(me,`
`)}}},ne.fences=function(J){var ce=this.rules.block.fences.exec(J);if(ce){var me=ce[0],we=F(me,ce[3]||"");return{type:"code",raw:me,lang:ce[2]?ce[2].trim():ce[2],text:we}}},ne.heading=function(J){var ce=this.rules.block.heading.exec(J);if(ce){var me=ce[2].trim();if(/#$/.test(me)){var we=T(me,"#");(this.options.pedantic||!we||/ $/.test(we))&&(me=we.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:me,tokens:this.lexer.inline(me)}}},ne.hr=function(J){var ce=this.rules.block.hr.exec(J);if(ce)return{type:"hr",raw:ce[0]}},ne.blockquote=function(J){var ce=this.rules.block.blockquote.exec(J);if(ce){var me=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},ne.list=function(J){var ce=this.rules.block.list.exec(J);if(ce){var me,we,Me,qe,ke,Ie,Ce,U,V,X,x,de,ve=ce[1].trim(),Fe=ve.length>1,Ge={type:"list",raw:"",ordered:Fe,start:Fe?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Fe?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Fe?ve:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(de=!1,!(!(ce=Xe.exec(J))||this.rules.block.hr.test(J)));){if(me=ce[0],J=J.substring(me.length),U=ce[2].split(`
`,1)[0],V=J.split(`
`,1)[0],this.options.pedantic?(qe=2,x=U.trimLeft()):(qe=ce[2].search(/[^ ]/),qe=qe>4?1:qe,x=U.slice(qe),qe+=ce[1].length),Ie=!1,!U&&/^ *$/.test(V)&&(me+=V+`
`,J=J.substring(V.length+1),de=!0),!de)for(var Qe=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,qe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ct=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,qe-1)+"}#");J&&(X=J.split(`
`,1)[0],U=X,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ct.test(U)||rt.test(U)||Qe.test(U)||nt.test(J)));){if(U.search(/[^ ]/)>=qe||!U.trim())x+=`
`+U.slice(qe);else if(!Ie)x+=`
`+U;else break;!Ie&&!U.trim()&&(Ie=!0),me+=X+`
`,J=J.substring(X.length+1)}Ge.loose||(Ce?Ge.loose=!0:/\n *\n *$/.test(me)&&(Ce=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(x),we&&(Me=we[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:me,task:!!we,checked:Me,loose:!1,text:x}),Ge.raw+=me}Ge.items[Ge.items.length-1].raw=me.trimRight(),Ge.items[Ge.items.length-1].text=x.trimRight(),Ge.raw=Ge.raw.trimRight();var lt=Ge.items.length;for(ke=0;ke<lt;ke++){this.lexer.state.top=!1,Ge.items[ke].tokens=this.lexer.blockTokens(Ge.items[ke].text,[]);var bt=Ge.items[ke].tokens.filter(function(at){return at.type==="space"}),ft=bt.every(function(at){for(var dt=at.raw.split(""),Pe=0,ze=A(dt),Re;!(Re=ze()).done;){var Ne=Re.value;if(Ne===`
`&&(Pe+=1),Pe>1)return!0}return!1});!Ge.loose&&bt.length&&ft&&(Ge.loose=!0,Ge.items[ke].loose=!0)}return Ge}},ne.html=function(J){var ce=this.rules.block.html.exec(J);if(ce){var me={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(ce[0]):w(ce[0]);me.type="paragraph",me.text=we,me.tokens=this.lexer.inline(we)}return me}},ne.def=function(J){var ce=this.rules.block.def.exec(J);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var me=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:ce[0],href:ce[2],title:ce[3]}}},ne.table=function(J){var ce=this.rules.block.table.exec(J);if(ce){var me={type:"table",header:y(ce[1]).map(function(Ce){return{text:Ce}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=ce[0];var we=me.align.length,Me,qe,ke,Ie;for(Me=0;Me<we;Me++)/^ *-+: *$/.test(me.align[Me])?me.align[Me]="right":/^ *:-+: *$/.test(me.align[Me])?me.align[Me]="center":/^ *:-+ *$/.test(me.align[Me])?me.align[Me]="left":me.align[Me]=null;for(we=me.rows.length,Me=0;Me<we;Me++)me.rows[Me]=y(me.rows[Me],me.header.length).map(function(Ce){return{text:Ce}});for(we=me.header.length,qe=0;qe<we;qe++)me.header[qe].tokens=this.lexer.inline(me.header[qe].text);for(we=me.rows.length,qe=0;qe<we;qe++)for(Ie=me.rows[qe],ke=0;ke<Ie.length;ke++)Ie[ke].tokens=this.lexer.inline(Ie[ke].text);return me}}},ne.lheading=function(J){var ce=this.rules.block.lheading.exec(J);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},ne.paragraph=function(J){var ce=this.rules.block.paragraph.exec(J);if(ce){var me=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:me,tokens:this.lexer.inline(me)}}},ne.text=function(J){var ce=this.rules.block.text.exec(J);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},ne.escape=function(J){var ce=this.rules.inline.escape.exec(J);if(ce)return{type:"escape",raw:ce[0],text:w(ce[1])}},ne.tag=function(J){var ce=this.rules.inline.tag.exec(J);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):w(ce[0]):ce[0]}},ne.link=function(J){var ce=this.rules.inline.link.exec(J);if(ce){var me=ce[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var we=T(me.slice(0,-1),"\\");if((me.length-we.length)%2===0)return}else{var Me=C(ce[2],"()");if(Me>-1){var qe=ce[0].indexOf("!")===0?5:4,ke=qe+ce[1].length+Me;ce[2]=ce[2].substring(0,Me),ce[0]=ce[0].substring(0,ke).trim(),ce[3]=""}}var Ie=ce[2],Ce="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);U&&(Ie=U[1],Ce=U[3])}else Ce=ce[3]?ce[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(me)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),N(ce,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ne.reflink=function(J,ce){var me;if((me=this.rules.inline.reflink.exec(J))||(me=this.rules.inline.nolink.exec(J))){var we=(me[2]||me[1]).replace(/\s+/g," ");if(we=ce[we.toLowerCase()],!we||!we.href){var Me=me[0].charAt(0);return{type:"text",raw:Me,text:Me}}return N(me,we,me[0],this.lexer)}},ne.emStrong=function(J,ce,me){me===void 0&&(me="");var we=this.rules.inline.emStrong.lDelim.exec(J);if(we&&!(we[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=we[1]||we[2]||"";if(!Me||Me&&(me===""||this.rules.inline.punctuation.exec(me))){var qe=we[0].length-1,ke,Ie,Ce=qe,U=0,V=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,ce=ce.slice(-1*J.length+qe);(we=V.exec(ce))!=null;)if(ke=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!ke){if(Ie=ke.length,we[3]||we[4]){Ce+=Ie;continue}else if((we[5]||we[6])&&qe%3&&!((qe+Ie)%3)){U+=Ie;continue}if(Ce-=Ie,!(Ce>0)){if(Ie=Math.min(Ie,Ie+Ce+U),Math.min(qe,Ie)%2){var X=J.slice(1,qe+we.index+Ie);return{type:"em",raw:J.slice(0,qe+we.index+Ie+1),text:X,tokens:this.lexer.inlineTokens(X)}}var x=J.slice(2,qe+we.index+Ie-1);return{type:"strong",raw:J.slice(0,qe+we.index+Ie+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ne.codespan=function(J){var ce=this.rules.inline.code.exec(J);if(ce){var me=ce[2].replace(/\n/g," "),we=/[^ ]/.test(me),Me=/^ /.test(me)&&/ $/.test(me);return we&&Me&&(me=me.substring(1,me.length-1)),me=w(me,!0),{type:"codespan",raw:ce[0],text:me}}},ne.br=function(J){var ce=this.rules.inline.br.exec(J);if(ce)return{type:"br",raw:ce[0]}},ne.del=function(J){var ce=this.rules.inline.del.exec(J);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},ne.autolink=function(J,ce){var me=this.rules.inline.autolink.exec(J);if(me){var we,Me;return me[2]==="@"?(we=w(this.options.mangle?ce(me[1]):me[1]),Me="mailto:"+we):(we=w(me[1]),Me=we),{type:"link",raw:me[0],text:we,href:Me,tokens:[{type:"text",raw:we,text:we}]}}},ne.url=function(J,ce){var me;if(me=this.rules.inline.url.exec(J)){var we,Me;if(me[2]==="@")we=w(this.options.mangle?ce(me[0]):me[0]),Me="mailto:"+we;else{var qe;do qe=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(qe!==me[0]);we=w(me[0]),me[1]==="www."?Me="http://"+we:Me=we}return{type:"link",raw:me[0],text:we,href:Me,tokens:[{type:"text",raw:we,text:we}]}}},ne.inlineText=function(J,ce){var me=this.rules.inline.text.exec(J);if(me){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):w(me[0]):me[0]:we=w(this.options.smartypants?ce(me[0]):me[0]),{type:"text",raw:me[0],text:we}}},_}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=$(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=$(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=$(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=$(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=$(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=$(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=D({},z),z.gfm=D({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=$(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=$(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=D({},z.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:$(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=$(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=$(z._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=$(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=$(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=$(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=$(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=$(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=$(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=$(M.reflink).replace("label",M._label).replace("ref",z._label).getRegex(),M.nolink=$(M.nolink).replace("ref",z._label).getRegex(),M.reflinkSearch=$(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=D({},M),M.pedantic=D({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=D({},M.normal,{escape:$(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=$(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=D({},M.gfm,{br:$(M.br).replace("{2,}","*").getRegex(),text:$(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(_){return _.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(_){var ne="",le,J,ce=_.length;for(le=0;le<ce;le++)J=_.charCodeAt(le),Math.random()>.5&&(J="x"+J.toString(16)),ne+="&#"+J+";";return ne}var W=function(){function _(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||ie.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:z.normal,inline:M.normal};this.options.pedantic?(J.block=z.pedantic,J.inline=M.pedantic):this.options.gfm&&(J.block=z.gfm,this.options.breaks?J.inline=M.breaks:J.inline=M.gfm),this.tokenizer.rules=J}_.lex=function(J,ce){var me=new _(ce);return me.lex(J)},_.lexInline=function(J,ce){var me=new _(ce);return me.inlineTokens(J)};var ne=_.prototype;return ne.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ne.blockTokens=function(J,ce){var me=this;ce===void 0&&(ce=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(Ce,U,V){return U+"    ".repeat(V.length)});for(var we,Me,qe,ke;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(we=Ce.call({lexer:me},J,ce))?(J=J.substring(we.raw.length),ce.push(we),!0):!1}))){if(we=this.tokenizer.space(J)){J=J.substring(we.raw.length),we.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(we);continue}if(we=this.tokenizer.code(J)){J=J.substring(we.raw.length),Me=ce[ce.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ce.push(we);continue}if(we=this.tokenizer.fences(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.heading(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.hr(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.blockquote(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.list(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.html(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.def(J)){J=J.substring(we.raw.length),Me=ce[ce.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.lheading(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(qe=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,U=J.slice(1),V=void 0;me.options.extensions.startBlock.forEach(function(X){V=X.call({lexer:this},U),typeof V=="number"&&V>=0&&(Ce=Math.min(Ce,V))}),Ce<1/0&&Ce>=0&&(qe=J.substring(0,Ce+1))}(),this.state.top&&(we=this.tokenizer.paragraph(qe))){Me=ce[ce.length-1],ke&&Me.type==="paragraph"?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ce.push(we),ke=qe.length!==J.length,J=J.substring(we.raw.length);continue}if(we=this.tokenizer.text(J)){J=J.substring(we.raw.length),Me=ce[ce.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+we.raw,Me.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ce.push(we);continue}if(J){var Ie="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ce},ne.inline=function(J,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:J,tokens:ce}),ce},ne.inlineTokens=function(J,ce){var me=this;ce===void 0&&(ce=[]);var we,Me,qe,ke=J,Ie,Ce,U;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)V.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ie.index)+"["+f("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"["+f("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(Ce||(U=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(we=x.call({lexer:me},J,ce))?(J=J.substring(we.raw.length),ce.push(we),!0):!1}))){if(we=this.tokenizer.escape(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.tag(J)){J=J.substring(we.raw.length),Me=ce[ce.length-1],Me&&we.type==="text"&&Me.type==="text"?(Me.raw+=we.raw,Me.text+=we.text):ce.push(we);continue}if(we=this.tokenizer.link(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(we.raw.length),Me=ce[ce.length-1],Me&&we.type==="text"&&Me.type==="text"?(Me.raw+=we.raw,Me.text+=we.text):ce.push(we);continue}if(we=this.tokenizer.emStrong(J,ke,U)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.codespan(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.br(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.del(J)){J=J.substring(we.raw.length),ce.push(we);continue}if(we=this.tokenizer.autolink(J,B)){J=J.substring(we.raw.length),ce.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(J,B))){J=J.substring(we.raw.length),ce.push(we);continue}if(qe=J,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,de=J.slice(1),ve=void 0;me.options.extensions.startInline.forEach(function(Fe){ve=Fe.call({lexer:this},de),typeof ve=="number"&&ve>=0&&(x=Math.min(x,ve))}),x<1/0&&x>=0&&(qe=J.substring(0,x+1))}(),we=this.tokenizer.inlineText(qe,L)){J=J.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(U=we.raw.slice(-1)),Ce=!0,Me=ce[ce.length-1],Me&&Me.type==="text"?(Me.raw+=we.raw,Me.text+=we.text):ce.push(we);continue}if(J){var X="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return ce},r(_,null,[{key:"rules",get:function(){return{block:z,inline:M}}}]),_}(),ae=function(){function _(le){this.options=le||ie.defaults}var ne=_.prototype;return ne.code=function(J,ce,me){var we=(ce||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(J,we);Me!=null&&Me!==J&&(me=!0,J=Me)}return J=J.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+w(we,!0)+'">'+(me?J:w(J,!0))+`</code></pre>
`:"<pre><code>"+(me?J:w(J,!0))+`</code></pre>
`},ne.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ne.html=function(J){return J},ne.heading=function(J,ce,me,we){if(this.options.headerIds){var Me=this.options.headerPrefix+we.slug(me);return"<h"+ce+' id="'+Me+'">'+J+"</h"+ce+`>
`}return"<h"+ce+">"+J+"</h"+ce+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(J,ce,me){var we=ce?"ol":"ul",Me=ce&&me!==1?' start="'+me+'"':"";return"<"+we+Me+`>
`+J+"</"+we+`>
`},ne.listitem=function(J){return"<li>"+J+`</li>
`},ne.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(J){return"<p>"+J+`</p>
`},ne.table=function(J,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+ce+`</table>
`},ne.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ne.tablecell=function(J,ce){var me=ce.header?"th":"td",we=ce.align?"<"+me+' align="'+ce.align+'">':"<"+me+">";return we+J+("</"+me+`>
`)},ne.strong=function(J){return"<strong>"+J+"</strong>"},ne.em=function(J){return"<em>"+J+"</em>"},ne.codespan=function(J){return"<code>"+J+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(J){return"<del>"+J+"</del>"},ne.link=function(J,ce,me){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return me;var we='<a href="'+w(J)+'"';return ce&&(we+=' title="'+ce+'"'),we+=">"+me+"</a>",we},ne.image=function(J,ce,me){if(J=t(this.options.sanitize,this.options.baseUrl,J),J===null)return me;var we='<img src="'+J+'" alt="'+me+'"';return ce&&(we+=' title="'+ce+'"'),we+=this.options.xhtml?"/>":">",we},ne.text=function(J){return J},_}(),q=function(){function _(){}var ne=_.prototype;return ne.strong=function(J){return J},ne.em=function(J){return J},ne.codespan=function(J){return J},ne.del=function(J){return J},ne.html=function(J){return J},ne.text=function(J){return J},ne.link=function(J,ce,me){return""+me},ne.image=function(J,ce,me){return""+me},ne.br=function(){return""},_}(),K=function(){function _(){this.seen={}}var ne=_.prototype;return ne.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(J,ce){var me=J,we=0;if(this.seen.hasOwnProperty(me)){we=this.seen[J];do we++,me=J+"-"+we;while(this.seen.hasOwnProperty(me))}return ce||(this.seen[J]=we,this.seen[me]=0),me},ne.slug=function(J,ce){ce===void 0&&(ce={});var me=this.serialize(J);return this.getNextSafeSlug(me,ce.dryrun)},_}(),ee=function(){function _(le){this.options=le||ie.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new K}_.parse=function(J,ce){var me=new _(ce);return me.parse(J)},_.parseInline=function(J,ce){var me=new _(ce);return me.parseInline(J)};var ne=_.prototype;return ne.parse=function(J,ce){ce===void 0&&(ce=!0);var me="",we,Me,qe,ke,Ie,Ce,U,V,X,x,de,ve,Fe,Ge,Xe,Qe,nt,ct,rt,lt=J.length;for(we=0;we<lt;we++){if(x=J[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(rt=this.options.extensions.renderers[x.type].call({parser:this},x),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){me+=rt||"";continue}switch(x.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(x.tokens),x.depth,m(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(V="",U="",ke=x.header.length,Me=0;Me<ke;Me++)U+=this.renderer.tablecell(this.parseInline(x.header[Me].tokens),{header:!0,align:x.align[Me]});for(V+=this.renderer.tablerow(U),X="",ke=x.rows.length,Me=0;Me<ke;Me++){for(Ce=x.rows[Me],U="",Ie=Ce.length,qe=0;qe<Ie;qe++)U+=this.renderer.tablecell(this.parseInline(Ce[qe].tokens),{header:!1,align:x.align[qe]});X+=this.renderer.tablerow(U)}me+=this.renderer.table(V,X);continue}case"blockquote":{X=this.parse(x.tokens),me+=this.renderer.blockquote(X);continue}case"list":{for(de=x.ordered,ve=x.start,Fe=x.loose,ke=x.items.length,X="",Me=0;Me<ke;Me++)Xe=x.items[Me],Qe=Xe.checked,nt=Xe.task,Ge="",Xe.task&&(ct=this.renderer.checkbox(Qe),Fe?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=ct+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=ct+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:ct}):Ge+=ct),Ge+=this.parse(Xe.tokens,Fe),X+=this.renderer.listitem(Ge,nt,Qe);me+=this.renderer.list(X,de,ve);continue}case"html":{me+=this.renderer.html(x.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(X=x.tokens?this.parseInline(x.tokens):x.text;we+1<lt&&J[we+1].type==="text";)x=J[++we],X+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);me+=ce?this.renderer.paragraph(X):X;continue}default:{var bt='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(bt);return}else throw new Error(bt)}}}return me},ne.parseInline=function(J,ce){ce=ce||this.renderer;var me="",we,Me,qe,ke=J.length;for(we=0;we<ke;we++){if(Me=J[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(qe=this.options.extensions.renderers[Me.type].call({parser:this},Me),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){me+=qe||"";continue}switch(Me.type){case"escape":{me+=ce.text(Me.text);break}case"html":{me+=ce.html(Me.text);break}case"link":{me+=ce.link(Me.href,Me.title,this.parseInline(Me.tokens,ce));break}case"image":{me+=ce.image(Me.href,Me.title,Me.text);break}case"strong":{me+=ce.strong(this.parseInline(Me.tokens,ce));break}case"em":{me+=ce.em(this.parseInline(Me.tokens,ce));break}case"codespan":{me+=ce.codespan(Me.text);break}case"br":{me+=ce.br();break}case"del":{me+=ce.del(this.parseInline(Me.tokens,ce));break}case"text":{me+=ce.text(Me.text);break}default:{var Ie='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return me},_}();function re(_,ne,le){if(typeof _>"u"||_===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");if(typeof ne=="function"&&(le=ne,ne=null),ne=D({},re.defaults,ne||{}),v(ne),le){var J=ne.highlight,ce;try{ce=W.lex(_,ne)}catch(ke){return le(ke)}var me=function(Ie){var Ce;if(!Ie)try{ne.walkTokens&&re.walkTokens(ce,ne.walkTokens),Ce=ee.parse(ce,ne)}catch(U){Ie=U}return ne.highlight=J,Ie?le(Ie):le(null,Ce)};if(!J||J.length<3||(delete ne.highlight,!ce.length))return me();var we=0;re.walkTokens(ce,function(ke){ke.type==="code"&&(we++,setTimeout(function(){J(ke.text,ke.lang,function(Ie,Ce){if(Ie)return me(Ie);Ce!=null&&Ce!==ke.text&&(ke.text=Ce,ke.escaped=!0),we--,we===0&&me()})},0))}),we===0&&me();return}function Me(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+w(ke.message+"",!0)+"</pre>";throw ke}try{var qe=W.lex(_,ne);if(ne.walkTokens){if(ne.async)return Promise.all(re.walkTokens(qe,ne.walkTokens)).then(function(){return ee.parse(qe,ne)}).catch(Me);re.walkTokens(qe,ne.walkTokens)}return ee.parse(qe,ne)}catch(ke){Me(ke)}}re.options=re.setOptions=function(_){return D(re.defaults,_),R(re.defaults),re},re.getDefaults=O,re.defaults=ie.defaults,re.use=function(){for(var _=arguments.length,ne=new Array(_),le=0;le<_;le++)ne[le]=arguments[le];var J=D.apply(void 0,[{}].concat(ne)),ce=re.defaults.extensions||{renderers:{},childTokens:{}},me;ne.forEach(function(we){if(we.extensions&&(me=!0,we.extensions.forEach(function(qe){if(!qe.name)throw new Error("extension name required");if(qe.renderer){var ke=ce.renderers?ce.renderers[qe.name]:null;ke?ce.renderers[qe.name]=function(){for(var Ie=arguments.length,Ce=new Array(Ie),U=0;U<Ie;U++)Ce[U]=arguments[U];var V=qe.renderer.apply(this,Ce);return V===!1&&(V=ke.apply(this,Ce)),V}:ce.renderers[qe.name]=qe.renderer}if(qe.tokenizer){if(!qe.level||qe.level!=="block"&&qe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[qe.level]?ce[qe.level].unshift(qe.tokenizer):ce[qe.level]=[qe.tokenizer],qe.start&&(qe.level==="block"?ce.startBlock?ce.startBlock.push(qe.start):ce.startBlock=[qe.start]:qe.level==="inline"&&(ce.startInline?ce.startInline.push(qe.start):ce.startInline=[qe.start]))}qe.childTokens&&(ce.childTokens[qe.name]=qe.childTokens)})),we.renderer&&function(){var qe=re.defaults.renderer||new ae,ke=function(U){var V=qe[U];qe[U]=function(){for(var X=arguments.length,x=new Array(X),de=0;de<X;de++)x[de]=arguments[de];var ve=we.renderer[U].apply(qe,x);return ve===!1&&(ve=V.apply(qe,x)),ve}};for(var Ie in we.renderer)ke(Ie);J.renderer=qe}(),we.tokenizer&&function(){var qe=re.defaults.tokenizer||new j,ke=function(U){var V=qe[U];qe[U]=function(){for(var X=arguments.length,x=new Array(X),de=0;de<X;de++)x[de]=arguments[de];var ve=we.tokenizer[U].apply(qe,x);return ve===!1&&(ve=V.apply(qe,x)),ve}};for(var Ie in we.tokenizer)ke(Ie);J.tokenizer=qe}(),we.walkTokens){var Me=re.defaults.walkTokens;J.walkTokens=function(qe){var ke=[];return ke.push(we.walkTokens.call(this,qe)),Me&&(ke=ke.concat(Me.call(this,qe))),ke}}me&&(J.extensions=ce),re.setOptions(J)})},re.walkTokens=function(_,ne){for(var le=[],J=function(){var Me=me.value;switch(le=le.concat(ne.call(re,Me)),Me.type){case"table":{for(var qe=A(Me.header),ke;!(ke=qe()).done;){var Ie=ke.value;le=le.concat(re.walkTokens(Ie.tokens,ne))}for(var Ce=A(Me.rows),U;!(U=Ce()).done;)for(var V=U.value,X=A(V),x;!(x=X()).done;){var de=x.value;le=le.concat(re.walkTokens(de.tokens,ne))}break}case"list":{le=le.concat(re.walkTokens(Me.items,ne));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[Me.type]?re.defaults.extensions.childTokens[Me.type].forEach(function(ve){le=le.concat(re.walkTokens(Me[ve],ne))}):Me.tokens&&(le=le.concat(re.walkTokens(Me.tokens,ne)))}},ce=A(_),me;!(me=ce()).done;)J();return le},re.parseInline=function(_,ne){if(typeof _>"u"||_===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");ne=D({},re.defaults,ne||{}),v(ne);try{var le=W.lexInline(_,ne);return ne.walkTokens&&re.walkTokens(le,ne.walkTokens),ee.parseInline(le,ne)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+w(J.message+"",!0)+"</pre>";throw J}},re.Parser=ee,re.parser=ee.parse,re.Renderer=ae,re.TextRenderer=q,re.Lexer=W,re.lexer=W.lex,re.Tokenizer=j,re.Slugger=K,re.parse=re;var ge=re.options,Z=re.setOptions,$e=re.use,fe=re.walkTokens,oe=re.parseInline,H=re,ue=ee.parse,te=W.lex;ie.Lexer=W,ie.Parser=ee,ie.Renderer=ae,ie.Slugger=K,ie.TextRenderer=q,ie.Tokenizer=j,ie.getDefaults=O,ie.lexer=te,ie.marked=re,ie.options=ge,ie.parse=H,ie.parseInline=oe,ie.parser=ue,ie.setOptions=Z,ie.use=$e,ie.walkTokens=fe,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Se[41],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(Se[179],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=r;function r(l){const m=A(l);if(m&&m.length>0)return new Uint32Array(m)}let a=0;const k=new Uint32Array(10);function A(l){if(a=0,O(l,S,p.InitialConsonant),a>0||(O(l,h,p.Vowel),a>0)||(O(l,P,p.FinalConsonant),a>0)||(O(l,w,p.CompatibilityJamo),a))return k.subarray(0,a);if(l>=44032&&l<=55203){const m=l-44032,g=m%588,$=Math.floor(m/588),n=Math.floor(g/28),o=g%28-1;if($<S.length?O($,S,0):p.InitialConsonant+$-p.CompatibilityJamo<w.length&&O(p.InitialConsonant+$,w,p.CompatibilityJamo),n<h.length?O(n,h,0):p.Vowel+n-p.CompatibilityJamo<w.length&&O(p.Vowel+n-p.CompatibilityJamo,w,p.CompatibilityJamo),o>=0&&(o<P.length?O(o,P,0):p.FinalConsonant+o-p.CompatibilityJamo<w.length&&O(p.FinalConsonant+o-p.CompatibilityJamo,w,p.CompatibilityJamo)),a>0)return k.subarray(0,a)}}function O(l,m,g){l>=g&&l<g+m.length&&R(m[l-g])}function R(l){l!==c.NUL&&(k[a++]=l&255,l>>8&&(k[a++]=l>>8&255),l>>16&&(k[a++]=l>>16&255))}var p;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var c;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(c||(c={}));var I;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(I||(I={}));const S=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),h=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l]),P=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,I.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),w=new Uint16Array([c.r,c.R,I.rt,c.s,I.sw,I.sg,c.e,c.E,c.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,c.a,c.q,c.Q,I.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,I.hk,I.ho,I.hl,c.y,c.n,I.nj,I.np,I.nl,c.b,c.m,I.ml,c.l])}),define(Se[82],De([1,0,29]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=void 0,e.$nm=k,e.$om=O;const a=new r.$Gc(1e4);function k(c){return p(c,"NFC",a)}const A=new r.$Gc(1e4);function O(c){return p(c,"NFD",A)}const R=/[^\u0000-\u0080]/;function p(c,I,S){if(!c)return c;const h=S.get(c);if(h)return h;let P;return R.test(c)?P=c.normalize(I):P=c,S.set(c,P),P}e.$pm=function(){const c=/[\u0300-\u036f]/g;return function(I){return O(I).replace(c,"")}}()}),define(Se[135],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=r,e.rot=a,e.$Qm=R;function r(p,c,I){return Math.min(Math.max(p,c),I)}function a(p,c){return(c+p%c)%c}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=k;class A{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=A;class O{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const I=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=O;function R(p,c,I,S,h,P,w,l){const m=w-I,g=l-S,$=h-I,n=P-S,o=p-I,t=c-S,i=m*m+g*g,s=m*$+g*n,d=m*o+g*t,u=$*$+n*n,b=$*o+n*t,E=1/(i*u-s*s),D=(u*d-s*b)*E,y=(i*b-s*d)*E;return D>=0&&y>=0&&D+y<1}}),define(Se[180],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=A,e.$fd=h;class r{constructor(w,l,m){this.owner=w,this.debugNameSource=l,this.referenceFn=m}getDebugName(w){return A(w,this)}}e.$dd=r;const a=new Map,k=new WeakMap;function A(P,w){const l=k.get(P);if(l)return l;const m=O(P,w);if(m){let g=a.get(m)??0;g++,a.set(m,g);const $=g===1?m:`${m}#${g}`;return k.set(P,$),$}}function O(P,w){const l=k.get(P);if(l)return l;const m=w.owner?I(w.owner)+".":"";let g;const $=w.debugNameSource;if($!==void 0)if(typeof $=="function"){if(g=$(),g!==void 0)return m+g}else return m+$;const n=w.referenceFn;if(n!==void 0&&(g=h(n),g!==void 0))return m+g;if(w.owner!==void 0){const o=R(w.owner,P);if(o!==void 0)return m+o}}function R(P,w){for(const l in P)if(P[l]===w)return l}const p=new Map,c=new WeakMap;function I(P){const w=c.get(P);if(w)return w;const l=S(P);let m=p.get(l)??0;m++,p.set(l,m);const g=m===1?l:`${l}#${m}`;return c.set(P,g),g}function S(P){const w=P.constructor;return w?w.name:"Object"}function h(P){const w=P.toString(),m=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(m?m[1]:void 0)?.trim()}}),define(Se[181],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Md=a,e.$Nd=k;let r;function a(l){r=l}function k(){return r}class A{constructor(){this.a=0,this.d=new WeakMap}b(m){return O([R(P("|  ",this.a)),m])}c(m){return m.hadValue?m.didChange?[R(" "),c(I(m.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),c(I(m.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),c(I(m.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(m,g){console.log(...this.b([p("observable value changed"),c(m.debugName,{color:"BlueViolet"}),...this.c(g)]))}formatChanges(m){if(m.size!==0)return c(" (changed deps: "+[...m].map(g=>g.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(m){const g=m.handleChange;this.d.set(m,new Set),m.handleChange=($,n)=>(this.d.get(m).add($),g.apply(m,[$,n]))}handleDerivedRecomputed(m,g){const $=this.d.get(m);console.log(...this.b([p("derived recomputed"),c(m.debugName,{color:"BlueViolet"}),...this.c(g),this.formatChanges($),{data:[{fn:m._debugNameData.referenceFn??m._computeFn}]}])),$.clear()}handleFromEventObservableTriggered(m,g){console.log(...this.b([p("observable from event triggered"),c(m.debugName,{color:"BlueViolet"}),...this.c(g),{data:[{fn:m._getValue}]}]))}handleAutorunCreated(m){const g=m.handleChange;this.d.set(m,new Set),m.handleChange=($,n)=>(this.d.get(m).add($),g.apply(m,[$,n]))}handleAutorunTriggered(m){const g=this.d.get(m);console.log(...this.b([p("autorun"),c(m.debugName,{color:"BlueViolet"}),this.formatChanges(g),{data:[{fn:m._debugNameData.referenceFn??m._runFn}]}])),g.clear(),this.a++}handleAutorunFinished(m){this.a--}handleBeginTransaction(m){let g=m.getDebugName();g===void 0&&(g=""),console.log(...this.b([p("transaction"),c(g,{color:"BlueViolet"}),{data:[{fn:m._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Od=A;function O(l){const m=new Array,g=[];let $="";function n(t){if("length"in t)for(const i of t)i&&n(i);else"text"in t?($+=`%c${t.text}`,m.push(t.style),t.data&&g.push(...t.data)):"data"in t&&g.push(...t.data)}n(l);const o=[$,...m];return o.push(...g),o}function R(l){return c(l,{color:"black"})}function p(l){return c(w(`${l}: `,10),{color:"black",bold:!0})}function c(l,m={color:"black"}){function g(n){return Object.entries(n).reduce((o,[t,i])=>`${o}${t}:${i};`,"")}const $={color:m.color};return m.strikeThrough&&($["text-decoration"]="line-through"),m.bold&&($["font-weight"]="bold"),{text:l,style:g($)}}function I(l,m){switch(typeof l){case"number":return""+l;case"string":return l.length+2<=m?`"${l}"`:`"${l.substr(0,m-7)}"+...`;case"boolean":return l?"true":"false";case"undefined":return"undefined";case"object":return l===null?"null":Array.isArray(l)?S(l,m):h(l,m);case"symbol":return l.toString();case"function":return`[[Function${l.name?" "+l.name:""}]]`;default:return""+l}}function S(l,m){let g="[ ",$=!0;for(const n of l){if($||(g+=", "),g.length-5>m){g+="...";break}$=!1,g+=`${I(n,m-g.length)}`}return g+=" ]",g}function h(l,m){let g="{ ",$=!0;for(const[n,o]of Object.entries(l)){if($||(g+=", "),g.length-5>m){g+="...";break}$=!1,g+=`${n}: ${I(o,m-g.length)}`}return g+=" }",g}function P(l,m){let g="";for(let $=1;$<=m;$++)g+=l;return g}function w(l,m){for(;l.length<m;)l+=" ";return l}}),define(Se[182],De([1,0,176,180,181]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$9d=e.$7d=e.$2d=e.$1d=void 0,e.$Xd=O,e.$Yd=p,e.$Zd=I,e.$3d=P,e.$4d=l,e.$5d=m,e.$6d=g,e.$8d=n,e.$0d=t;let A;function O(s){A=s}let R;function p(s){R=s}let c;function I(s){c=s}class S{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,u){const b=u===void 0?void 0:d,E=u===void 0?d:u;return c({owner:b,debugName:()=>{const D=(0,a.$fd)(E);if(D!==void 0)return D;const T=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(T)return`${this.debugName}.${T[2]}`;if(!b)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}recomputeInitiallyAndOnChange(d,u){return d.add(A(this,u)),this}keepObserved(d){return d.add(R(this)),this}get a(){return this.get()}}e.$1d=S;class h extends S{constructor(){super(...arguments),this.b=new Set}addObserver(d){const u=this.b.size;this.b.add(d),u===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$2d=h;function P(s,d){const u=new $(s,d);try{s(u)}finally{u.finish()}}let w;function l(s){if(w)s(w);else{const d=new $(s,void 0);w=d;try{s(d)}finally{d.finish(),w=void 0}}}async function m(s,d){const u=new $(s,d);try{await s(u)}finally{u.finish()}}function g(s,d,u){s?d(s):P(d,u)}class ${constructor(d,u){this._fn=d,this.b=u,this.a=[],(0,k.$Nd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,a.$fd)(this._fn)}updateObserver(d,u){this.a.push({observer:d,observable:u}),d.beginUpdate(u)}finish(){const d=this.a;for(let u=0;u<d.length;u++){const{observer:b,observable:E}=d[u];b.endUpdate(E)}this.a=null,(0,k.$Nd)()?.handleEndTransaction()}}e.$7d=$;function n(s,d){let u;return typeof s=="string"?u=new a.$dd(void 0,s,void 0):u=new a.$dd(s,void 0,void 0),new o(u,d,r.$9c)}class o extends h{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,u,b){super(),this.e=d,this.g=b,this.d=u}get(){return this.d}set(d,u,b){if(b===void 0&&this.g(this.d,d))return;let E;u||(u=E=new $(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(d),(0,k.$Nd)()?.handleObservableChanged(this,{oldValue:D,newValue:d,change:b,didChange:!0,hadValue:!0});for(const y of this.b)u.updateObserver(y,this),y.handleChange(this,b)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$9d=o;function t(s,d){let u;return typeof s=="string"?u=new a.$dd(void 0,s,void 0):u=new a.$dd(s,void 0,void 0),new i(u,d,r.$9c)}class i extends o{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$$d=i}),function(){function ie(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function O(p){A.push(p,Date.now())}function R(){const p=[];for(let c=0;c<A.length;c+=2)p.push({name:A[c],startTime:A[c+1]});return p}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(k+O.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function r(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=r(a))}(),define(Se[11],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=i,e.$x=D,e.$D=y,e.$a="en";let r=!1,a=!1,k=!1,A=!1,O=!1,R=!1,p=!1,c=!1,I=!1,S=!1,h,P=e.$a,w=e.$a,l,m;const g=globalThis;let $;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?$=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const n=typeof $?.versions?.electron=="string",o=n&&$?.type==="renderer";if(typeof $=="object"){r=$.platform==="win32",a=$.platform==="darwin",k=$.platform==="linux",A=k&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=n,I=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$a,P=e.$a;const T=$.env.VSCODE_NLS_CONFIG;if(T)try{const C=JSON.parse(T),v=C.availableLanguages["*"];h=C.locale,w=C.osLocale,P=v||e.$a,l=C._translationsConfigFile}catch{}O=!0}else if(typeof navigator=="object"&&!o){m=navigator.userAgent,r=m.indexOf("Windows")>=0,a=m.indexOf("Macintosh")>=0,c=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=m.indexOf("Linux")>=0,S=m?.indexOf("Mobi")>=0,R=!0,h=e.$a,P=h,w=navigator.language;const T=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),C=T&&T.getAttribute("data-settings");if(C)try{const v=JSON.parse(C),f=v.availableLanguages["*"];h=v.locale,w=v.osLocale,P=f||e.$a,l=v._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var t;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(t||(e.Platform=t={}));function i(T){switch(T){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let s=t.Web;a?s=t.Mac:r?s=t.Windows:k&&(s=t.Linux),e.$c=r,e.$d=a,e.$e=k,e.$f=A,e.$g=O,e.$h=p,e.$i=R,e.$j=R&&typeof g.importScripts=="function",e.$k=e.$j?g.origin:void 0,e.$l=c,e.$m=S,e.$n=I,e.$o=s,e.$p=m,e.$q=P;var d;(function(T){function C(){return e.$q}T.value=C;function v(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}T.isDefaultVariant=v;function f(){return e.$q==="en"}T.isDefault=f})(d||(e.Language=d={})),e.$r=h,e.$s=w,e.$t=l,e.$u=typeof g.postMessage=="function"&&!g.importScripts,e.$v=(()=>{if(e.$u){const T=[];g.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let f=0,N=T.length;f<N;f++){const F=T[f];if(F.id===v.data.vscodeScheduleAsyncWork){T.splice(f,1),F.callback();return}}});let C=0;return v=>{const f=++C;T.push({id:f,callback:v}),g.postMessage({vscodeScheduleAsyncWork:f},"*")}}return T=>setTimeout(T)})();var u;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=a||c?u.Macintosh:r?u.Windows:u.Linux;let b=!0,E=!1;function D(){if(!E){E=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,b=new Uint16Array(T.buffer)[0]===513}return b}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function y(T){return parseFloat(T)>=20}}),define(Se[183],De([1,0,40]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=void 0;const a=Symbol("unset");class k{constructor(){this.a=new O,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}insert(p,c,I){this.d(p,S=>S._value=c,I)}mutate(p,c){this.d(p,I=>I._value=c(I._value===a?void 0:I._value))}mutatePath(p,c){this.d(p,()=>{},I=>c(I))}delete(p){const c=this.c(p);if(!c)return;let I=c.length-1;const S=c[I].node._value;if(S!==a){for(this.b--,c[I].node._value=a;I>0;I--){const{node:h,part:P}=c[I];if(h.children?.size||h._value!==a)break;c[I-1].node.children.delete(P)}return S}}*deleteRecursive(p){const c=this.c(p);if(!c)return;const I=c[c.length-1].node;for(let S=c.length-1;S>0;S--){const h=c[S-1];if(h.node.children.delete(c[S].part),h.node.children.size>0||h.node._value!==a)break}for(const S of A(I))S._value!==a&&(this.b--,yield S._value)}find(p){let c=this.a;for(const I of p){const S=c.children?.get(I);if(!S)return;c=S}return c._value===a?void 0:c._value}hasKeyOrParent(p){let c=this.a;for(const I of p){const S=c.children?.get(I);if(!S)return!1;if(S._value!==a)return!0;c=S}return!1}hasKeyOrChildren(p){let c=this.a;for(const I of p){const S=c.children?.get(I);if(!S)return!1;c=S}return!0}hasKey(p){let c=this.a;for(const I of p){const S=c.children?.get(I);if(!S)return!1;c=S}return c._value!==a}c(p){const c=[{part:"",node:this.a}];let I=0;for(const S of p){const h=c[I].node.children?.get(S);if(!h)return;c.push({part:S,node:h}),I++}return c}d(p,c,I){let S=this.a;for(const w of p){if(S.children)if(S.children.has(w))S=S.children.get(w);else{const l=new O;S.children.set(w,l),S=l}else{const l=new O;S.children=new Map([[w,l]]),S=l}I?.(S)}const h=S._value===a?0:1;c(S);const P=S._value===a?0:1;this.b+=P-h}*values(){for(const{_value:p}of A(this.a))p!==a&&(yield p)}}e.$TI=k;function*A(R){const p=[R];for(;p.length>0;){const c=p.pop();if(yield c,c.children)for(const I of c.children.values())p.push(I)}}class O{constructor(){this._value=a}get value(){return this._value===a?void 0:this._value}set value(p){this._value=p===void 0?a:p}}}),define(Se[54],De([1,0,11]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hc=e.$gc=e.env=e.cwd=void 0;let a;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const A=k.process;a={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return r.$c?"win32":r.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$gc=a.platform,e.$hc=a.arch}),define(Se[17],De([1,0,54]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.sep=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=void 0,r=Ue(r);const a=65,k=97,A=90,O=122,R=46,p=47,c=92,I=58,S=63;class h extends Error{constructor(s,d,u){let b;typeof d=="string"&&d.indexOf("not ")===0?(b="must not be",d=d.replace(/^not /,"")):b="must be";const E=s.indexOf(".")!==-1?"property":"argument";let D=`The "${s}" ${E} ${b} of type ${d}`;D+=`. Received type ${typeof u}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function P(i,s){if(i===null||typeof i!="object")throw new h(s,"Object",i)}function w(i,s){if(typeof i!="string")throw new h(s,"string",i)}const l=r.$gc==="win32";function m(i){return i===p||i===c}function g(i){return i===p}function $(i){return i>=a&&i<=A||i>=k&&i<=O}function n(i,s,d,u){let b="",E=0,D=-1,y=0,T=0;for(let C=0;C<=i.length;++C){if(C<i.length)T=i.charCodeAt(C);else{if(u(T))break;T=p}if(u(T)){if(!(D===C-1||y===1))if(y===2){if(b.length<2||E!==2||b.charCodeAt(b.length-1)!==R||b.charCodeAt(b.length-2)!==R){if(b.length>2){const v=b.lastIndexOf(d);v===-1?(b="",E=0):(b=b.slice(0,v),E=b.length-1-b.lastIndexOf(d)),D=C,y=0;continue}else if(b.length!==0){b="",E=0,D=C,y=0;continue}}s&&(b+=b.length>0?`${d}..`:"..",E=2)}else b.length>0?b+=`${d}${i.slice(D+1,C)}`:b=i.slice(D+1,C),E=C-D-1;D=C,y=0}else T===R&&y!==-1?++y:y=-1}return b}function o(i,s){P(s,"pathObject");const d=s.dir||s.root,u=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${u}`:`${d}${i}${u}`:u}e.$ic={resolve(...i){let s="",d="",u=!1;for(let b=i.length-1;b>=-1;b--){let E;if(b>=0){if(E=i[b],w(E,"path"),E.length===0)continue}else s.length===0?E=r.cwd():(E=r.env[`=${s}`]||r.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==s.toLowerCase()&&E.charCodeAt(2)===c)&&(E=`${s}\\`));const D=E.length;let y=0,T="",C=!1;const v=E.charCodeAt(0);if(D===1)m(v)&&(y=1,C=!0);else if(m(v))if(C=!0,m(E.charCodeAt(1))){let f=2,N=f;for(;f<D&&!m(E.charCodeAt(f));)f++;if(f<D&&f!==N){const F=E.slice(N,f);for(N=f;f<D&&m(E.charCodeAt(f));)f++;if(f<D&&f!==N){for(N=f;f<D&&!m(E.charCodeAt(f));)f++;(f===D||f!==N)&&(T=`\\\\${F}\\${E.slice(N,f)}`,y=f)}}}else y=1;else $(v)&&E.charCodeAt(1)===I&&(T=E.slice(0,2),y=2,D>2&&m(E.charCodeAt(2))&&(C=!0,y=3));if(T.length>0)if(s.length>0){if(T.toLowerCase()!==s.toLowerCase())continue}else s=T;if(u){if(s.length>0)break}else if(d=`${E.slice(y)}\\${d}`,u=C,C&&s.length>0)break}return d=n(d,!u,"\\",m),u?`${s}\\${d}`:`${s}${d}`||"."},normalize(i){w(i,"path");const s=i.length;if(s===0)return".";let d=0,u,b=!1;const E=i.charCodeAt(0);if(s===1)return g(E)?"\\":i;if(m(E))if(b=!0,m(i.charCodeAt(1))){let y=2,T=y;for(;y<s&&!m(i.charCodeAt(y));)y++;if(y<s&&y!==T){const C=i.slice(T,y);for(T=y;y<s&&m(i.charCodeAt(y));)y++;if(y<s&&y!==T){for(T=y;y<s&&!m(i.charCodeAt(y));)y++;if(y===s)return`\\\\${C}\\${i.slice(T)}\\`;y!==T&&(u=`\\\\${C}\\${i.slice(T,y)}`,d=y)}}}else d=1;else $(E)&&i.charCodeAt(1)===I&&(u=i.slice(0,2),d=2,s>2&&m(i.charCodeAt(2))&&(b=!0,d=3));let D=d<s?n(i.slice(d),!b,"\\",m):"";return D.length===0&&!b&&(D="."),D.length>0&&m(i.charCodeAt(s-1))&&(D+="\\"),u===void 0?b?`\\${D}`:D:b?`${u}\\${D}`:`${u}${D}`},isAbsolute(i){w(i,"path");const s=i.length;if(s===0)return!1;const d=i.charCodeAt(0);return m(d)||s>2&&$(d)&&i.charCodeAt(1)===I&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,d;for(let E=0;E<i.length;++E){const D=i[E];w(D,"path"),D.length>0&&(s===void 0?s=d=D:s+=`\\${D}`)}if(s===void 0)return".";let u=!0,b=0;if(typeof d=="string"&&m(d.charCodeAt(0))){++b;const E=d.length;E>1&&m(d.charCodeAt(1))&&(++b,E>2&&(m(d.charCodeAt(2))?++b:u=!1))}if(u){for(;b<s.length&&m(s.charCodeAt(b));)b++;b>=2&&(s=`\\${s.slice(b)}`)}return e.$ic.normalize(s)},relative(i,s){if(w(i,"from"),w(s,"to"),i===s)return"";const d=e.$ic.resolve(i),u=e.$ic.resolve(s);if(d===u||(i=d.toLowerCase(),s=u.toLowerCase(),i===s))return"";let b=0;for(;b<i.length&&i.charCodeAt(b)===c;)b++;let E=i.length;for(;E-1>b&&i.charCodeAt(E-1)===c;)E--;const D=E-b;let y=0;for(;y<s.length&&s.charCodeAt(y)===c;)y++;let T=s.length;for(;T-1>y&&s.charCodeAt(T-1)===c;)T--;const C=T-y,v=D<C?D:C;let f=-1,N=0;for(;N<v;N++){const j=i.charCodeAt(b+N);if(j!==s.charCodeAt(y+N))break;j===c&&(f=N)}if(N!==v){if(f===-1)return u}else{if(C>v){if(s.charCodeAt(y+N)===c)return u.slice(y+N+1);if(N===2)return u.slice(y+N)}D>v&&(i.charCodeAt(b+N)===c?f=N:N===2&&(f=3)),f===-1&&(f=0)}let F="";for(N=b+f+1;N<=E;++N)(N===E||i.charCodeAt(N)===c)&&(F+=F.length===0?"..":"\\..");return y+=f,F.length>0?`${F}${u.slice(y,T)}`:(u.charCodeAt(y)===c&&++y,u.slice(y,T))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.$ic.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===c){if(s.charCodeAt(1)===c){const d=s.charCodeAt(2);if(d!==S&&d!==R)return`\\\\?\\UNC\\${s.slice(2)}`}}else if($(s.charCodeAt(0))&&s.charCodeAt(1)===I&&s.charCodeAt(2)===c)return`\\\\?\\${s}`;return i},dirname(i){w(i,"path");const s=i.length;if(s===0)return".";let d=-1,u=0;const b=i.charCodeAt(0);if(s===1)return m(b)?i:".";if(m(b)){if(d=u=1,m(i.charCodeAt(1))){let y=2,T=y;for(;y<s&&!m(i.charCodeAt(y));)y++;if(y<s&&y!==T){for(T=y;y<s&&m(i.charCodeAt(y));)y++;if(y<s&&y!==T){for(T=y;y<s&&!m(i.charCodeAt(y));)y++;if(y===s)return i;y!==T&&(d=u=y+1)}}}}else $(b)&&i.charCodeAt(1)===I&&(d=s>2&&m(i.charCodeAt(2))?3:2,u=d);let E=-1,D=!0;for(let y=s-1;y>=u;--y)if(m(i.charCodeAt(y))){if(!D){E=y;break}}else D=!1;if(E===-1){if(d===-1)return".";E=d}return i.slice(0,E)},basename(i,s){s!==void 0&&w(s,"ext"),w(i,"path");let d=0,u=-1,b=!0,E;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(d=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let D=s.length-1,y=-1;for(E=i.length-1;E>=d;--E){const T=i.charCodeAt(E);if(m(T)){if(!b){d=E+1;break}}else y===-1&&(b=!1,y=E+1),D>=0&&(T===s.charCodeAt(D)?--D===-1&&(u=E):(D=-1,u=y))}return d===u?u=y:u===-1&&(u=i.length),i.slice(d,u)}for(E=i.length-1;E>=d;--E)if(m(i.charCodeAt(E))){if(!b){d=E+1;break}}else u===-1&&(b=!1,u=E+1);return u===-1?"":i.slice(d,u)},extname(i){w(i,"path");let s=0,d=-1,u=0,b=-1,E=!0,D=0;i.length>=2&&i.charCodeAt(1)===I&&$(i.charCodeAt(0))&&(s=u=2);for(let y=i.length-1;y>=s;--y){const T=i.charCodeAt(y);if(m(T)){if(!E){u=y+1;break}continue}b===-1&&(E=!1,b=y+1),T===R?d===-1?d=y:D!==1&&(D=1):d!==-1&&(D=-1)}return d===-1||b===-1||D===0||D===1&&d===b-1&&d===u+1?"":i.slice(d,b)},format:o.bind(null,"\\"),parse(i){w(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const d=i.length;let u=0,b=i.charCodeAt(0);if(d===1)return m(b)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(m(b)){if(u=1,m(i.charCodeAt(1))){let f=2,N=f;for(;f<d&&!m(i.charCodeAt(f));)f++;if(f<d&&f!==N){for(N=f;f<d&&m(i.charCodeAt(f));)f++;if(f<d&&f!==N){for(N=f;f<d&&!m(i.charCodeAt(f));)f++;f===d?u=f:f!==N&&(u=f+1)}}}}else if($(b)&&i.charCodeAt(1)===I){if(d<=2)return s.root=s.dir=i,s;if(u=2,m(i.charCodeAt(2))){if(d===3)return s.root=s.dir=i,s;u=3}}u>0&&(s.root=i.slice(0,u));let E=-1,D=u,y=-1,T=!0,C=i.length-1,v=0;for(;C>=u;--C){if(b=i.charCodeAt(C),m(b)){if(!T){D=C+1;break}continue}y===-1&&(T=!1,y=C+1),b===R?E===-1?E=C:v!==1&&(v=1):E!==-1&&(v=-1)}return y!==-1&&(E===-1||v===0||v===1&&E===y-1&&E===D+1?s.base=s.name=i.slice(D,y):(s.name=i.slice(D,E),s.base=i.slice(D,y),s.ext=i.slice(E,y))),D>0&&D!==u?s.dir=i.slice(0,D-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(l){const i=/\\/g;return()=>{const s=r.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>r.cwd()})();e.$jc={resolve(...i){let s="",d=!1;for(let u=i.length-1;u>=-1&&!d;u--){const b=u>=0?i[u]:t();w(b,"path"),b.length!==0&&(s=`${b}/${s}`,d=b.charCodeAt(0)===p)}return s=n(s,!d,"/",g),d?`/${s}`:s.length>0?s:"."},normalize(i){if(w(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===p,d=i.charCodeAt(i.length-1)===p;return i=n(i,!s,"/",g),i.length===0?s?"/":d?"./":".":(d&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return w(i,"path"),i.length>0&&i.charCodeAt(0)===p},join(...i){if(i.length===0)return".";let s;for(let d=0;d<i.length;++d){const u=i[d];w(u,"path"),u.length>0&&(s===void 0?s=u:s+=`/${u}`)}return s===void 0?".":e.$jc.normalize(s)},relative(i,s){if(w(i,"from"),w(s,"to"),i===s||(i=e.$jc.resolve(i),s=e.$jc.resolve(s),i===s))return"";const d=1,u=i.length,b=u-d,E=1,D=s.length-E,y=b<D?b:D;let T=-1,C=0;for(;C<y;C++){const f=i.charCodeAt(d+C);if(f!==s.charCodeAt(E+C))break;f===p&&(T=C)}if(C===y)if(D>y){if(s.charCodeAt(E+C)===p)return s.slice(E+C+1);if(C===0)return s.slice(E+C)}else b>y&&(i.charCodeAt(d+C)===p?T=C:C===0&&(T=0));let v="";for(C=d+T+1;C<=u;++C)(C===u||i.charCodeAt(C)===p)&&(v+=v.length===0?"..":"/..");return`${v}${s.slice(E+T)}`},toNamespacedPath(i){return i},dirname(i){if(w(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===p;let d=-1,u=!0;for(let b=i.length-1;b>=1;--b)if(i.charCodeAt(b)===p){if(!u){d=b;break}}else u=!1;return d===-1?s?"/":".":s&&d===1?"//":i.slice(0,d)},basename(i,s){s!==void 0&&w(s,"ext"),w(i,"path");let d=0,u=-1,b=!0,E;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let D=s.length-1,y=-1;for(E=i.length-1;E>=0;--E){const T=i.charCodeAt(E);if(T===p){if(!b){d=E+1;break}}else y===-1&&(b=!1,y=E+1),D>=0&&(T===s.charCodeAt(D)?--D===-1&&(u=E):(D=-1,u=y))}return d===u?u=y:u===-1&&(u=i.length),i.slice(d,u)}for(E=i.length-1;E>=0;--E)if(i.charCodeAt(E)===p){if(!b){d=E+1;break}}else u===-1&&(b=!1,u=E+1);return u===-1?"":i.slice(d,u)},extname(i){w(i,"path");let s=-1,d=0,u=-1,b=!0,E=0;for(let D=i.length-1;D>=0;--D){const y=i.charCodeAt(D);if(y===p){if(!b){d=D+1;break}continue}u===-1&&(b=!1,u=D+1),y===R?s===-1?s=D:E!==1&&(E=1):s!==-1&&(E=-1)}return s===-1||u===-1||E===0||E===1&&s===u-1&&s===d+1?"":i.slice(s,u)},format:o.bind(null,"/"),parse(i){w(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const d=i.charCodeAt(0)===p;let u;d?(s.root="/",u=1):u=0;let b=-1,E=0,D=-1,y=!0,T=i.length-1,C=0;for(;T>=u;--T){const v=i.charCodeAt(T);if(v===p){if(!y){E=T+1;break}continue}D===-1&&(y=!1,D=T+1),v===R?b===-1?b=T:C!==1&&(C=1):b!==-1&&(C=-1)}if(D!==-1){const v=E===0&&d?1:E;b===-1||C===0||C===1&&b===D-1&&b===E+1?s.base=s.name=i.slice(v,D):(s.name=i.slice(v,b),s.base=i.slice(v,D),s.ext=i.slice(b,D))}return E>0?s.dir=i.slice(0,E-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$jc.win32=e.$ic.win32=e.$ic,e.$jc.posix=e.$ic.posix=e.$jc,e.$kc=l?e.$ic.normalize:e.$jc.normalize,e.$lc=l?e.$ic.isAbsolute:e.$jc.isAbsolute,e.$mc=l?e.$ic.join:e.$jc.join,e.$nc=l?e.$ic.resolve:e.$jc.resolve,e.$oc=l?e.$ic.relative:e.$jc.relative,e.$pc=l?e.$ic.dirname:e.$jc.dirname,e.$qc=l?e.$ic.basename:e.$jc.basename,e.$rc=l?e.$ic.extname:e.$jc.extname,e.$sc=l?e.$ic.format:e.$jc.format,e.$tc=l?e.$ic.parse:e.$jc.parse,e.$uc=l?e.$ic.toNamespacedPath:e.$jc.toNamespacedPath,e.sep=l?e.$ic.sep:e.$jc.sep,e.$wc=l?e.$ic.delimiter:e.$jc.delimiter}),define(Se[136],De([1,0,49,17]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=R,e.$Ar=p,e.$Br=c,e.$Cr=I,e.$Dr=S,e.$Er=h,e.$Fr=P,e.$Gr=w,e.$Hr=l,e.$Ir=m,e.$Jr=b,e.$Kr=E,e.$Lr=D;const k=new r.$X(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),A=new r.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),O=new r.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(y,T,C=!1){const v=y||"",f=T||"",N=k.value.collator.compare(v,f);return k.value.collatorIsNumeric&&N===0&&v!==f?v<f?-1:1:N}function p(y,T){const C=A.value.collator;return y=y||"",T=T||"",o(C,y,T)}function c(y,T){const C=A.value.collator;return y=y||"",T=T||"",d(y,T)||o(C,y,T)}function I(y,T){const C=A.value.collator;return y=y||"",T=T||"",s(y,T)||o(C,y,T)}function S(y,T){return y=y||"",T=T||"",y===T?0:y<T?-1:1}function h(y,T){const[C,v]=$(y),[f,N]=$(T);let F=k.value.collator.compare(v,N);if(F===0){if(k.value.collatorIsNumeric&&v!==N)return v<N?-1:1;if(F=k.value.collator.compare(C,f),k.value.collatorIsNumeric&&F===0&&C!==f)return C<f?-1:1}return F}function P(y,T){y=y||"",T=T||"";const C=n(y),v=n(T),f=A.value.collator,N=O.value.collator;return o(N,C,v)||o(f,y,T)}function w(y,T){y=y||"",T=T||"";const C=n(y),v=n(T),f=A.value.collator,N=O.value.collator;return o(N,C,v)||d(y,T)||o(f,y,T)}function l(y,T){y=y||"",T=T||"";const C=n(y),v=n(T),f=A.value.collator,N=O.value.collator;return o(N,C,v)||s(y,T)||o(f,y,T)}function m(y,T){y=y||"",T=T||"";const C=n(y).toLowerCase(),v=n(T).toLowerCase();return C!==v?C<v?-1:1:y!==T?y<T?-1:1:0}const g=/^(.*?)(\.([^.]*))?$/;function $(y,T=!1){const C=y?g.exec(y):[];let v=[C&&C[1]||"",C&&C[3]||""];return T&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function n(y){const T=y?g.exec(y):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function o(y,T,C){const v=y.compare(T,C);return v!==0?v:T.length!==C.length?T.length<C.length?-1:1:0}function t(y){const T=y.charAt(0);return T.toLocaleUpperCase()!==T}function i(y){const T=y.charAt(0);return T.toLocaleLowerCase()!==T}function s(y,T){return t(y)&&i(T)?-1:i(y)&&t(T)?1:0}function d(y,T){return i(y)&&t(T)?-1:t(y)&&i(T)?1:0}function u(y,T,C=!1){return C||(y=y&&y.toLowerCase(),T=T&&T.toLowerCase()),y===T?0:y<T?-1:1}function b(y,T,C=!1){const v=y.split(a.sep),f=T.split(a.sep),N=v.length-1,F=f.length-1;let j,z;for(let M=0;;M++){if(j=N===M,z=F===M,j&&z)return R(v[M],f[M],C);if(j)return-1;if(z)return 1;const L=u(v[M],f[M],C);if(L!==0)return L}}function E(y,T,C){const v=y.toLowerCase(),f=T.toLowerCase(),N=D(y,T,C);if(N)return N;const F=v.endsWith(C),j=f.endsWith(C);if(F!==j)return F?-1:1;const z=R(v,f);return z!==0?z:v.localeCompare(f)}function D(y,T,C){const v=y.toLowerCase(),f=T.toLowerCase(),N=v.startsWith(C),F=f.startsWith(C);if(N!==F)return N?-1:1;if(N&&F){if(v.length<f.length)return-1;if(v.length>f.length)return 1}return 0}}),define(Se[104],De([1,0,17]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$$s=A,e.$_s=O,e.$at=R,e.$bt=c,e.$0s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const S=(0,r.$rc)(I),h=a[S.toLowerCase()];return h!==void 0?h:O(I)}function O(I){const S=(0,r.$rc)(I);return k[S.toLowerCase()]}function R(I){for(const S in k)if(k[S]===I)return S}const p=/^(.+)\/(.+?)(;.+)?$/;function c(I,S){const h=p.exec(I);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:S?void 0:I}}),define(Se[105],De([1,0,11]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=A,e.$mm=O;var a;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(a||(e.Source=a={}));var k;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(R,...p){const c=p.reduce((h,P)=>(h[P]=!0,h),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(R).filter(h=>!c[h]).forEach(h=>{for(let P=0;P<I.length;P++)if(h.search(I[P])!==-1){delete R[h];break}})}function O(R){R&&(delete R.DEBUG,r.$d&&delete R.DYLD_LIBRARY_PATH,r.$e&&delete R.LD_PRELOAD)}}),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var a in r)(typeof exports=="object"?exports:ie)[a]=r[a]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function r(a){if(e[a])return e[a].exports;var k=e[a]={i:a,l:!1,exports:{}};return ie[a].call(k.exports,k,k.exports,r),k.l=!0,k.exports}return r.m=ie,r.c=e,r.d=function(a,k,A){r.o(a,k)||Object.defineProperty(a,k,{enumerable:!0,get:A})},r.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},r.t=function(a,k){if(1&k&&(a=r(a)),8&k||4&k&&typeof a=="object"&&a&&a.__esModule)return a;var A=Object.create(null);if(r.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:a}),2&k&&typeof a!="string")for(var O in a)r.d(A,O,function(R){return a[R]}.bind(null,O));return A},r.n=function(a){var k=a&&a.__esModule?function(){return a.default}:function(){return a};return r.d(k,"a",k),k},r.o=function(a,k){return Object.prototype.hasOwnProperty.call(a,k)},r.p="",r(r.s=0)}([function(ie,e,r){(function(a){var k;e=ie.exports=$e,k=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],p=e.src=[],c=0,I=c++;p[I]="0|[1-9]\\d*";var S=c++;p[S]="[0-9]+";var h=c++;p[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=c++;p[P]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var w=c++;p[w]="("+p[S]+")\\.("+p[S]+")\\.("+p[S]+")";var l=c++;p[l]="(?:"+p[I]+"|"+p[h]+")";var m=c++;p[m]="(?:"+p[S]+"|"+p[h]+")";var g=c++;p[g]="(?:-("+p[l]+"(?:\\."+p[l]+")*))";var $=c++;p[$]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var n=c++;p[n]="[0-9A-Za-z-]+";var o=c++;p[o]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var t=c++,i="v?"+p[P]+p[g]+"?"+p[o]+"?";p[t]="^"+i+"$";var s="[v=\\s]*"+p[w]+p[$]+"?"+p[o]+"?",d=c++;p[d]="^"+s+"$";var u=c++;p[u]="((?:<|>)?=?)";var b=c++;p[b]=p[S]+"|x|X|\\*";var E=c++;p[E]=p[I]+"|x|X|\\*";var D=c++;p[D]="[v=\\s]*("+p[E]+")(?:\\.("+p[E]+")(?:\\.("+p[E]+")(?:"+p[g]+")?"+p[o]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[b]+")(?:\\.("+p[b]+")(?:\\.("+p[b]+")(?:"+p[$]+")?"+p[o]+"?)?)?";var T=c++;p[T]="^"+p[u]+"\\s*"+p[D]+"$";var C=c++;p[C]="^"+p[u]+"\\s*"+p[y]+"$";var v=c++;p[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var f=c++;p[f]="(?:~>?)";var N=c++;p[N]="(\\s*)"+p[f]+"\\s+",R[N]=new RegExp(p[N],"g");var F=c++;p[F]="^"+p[f]+p[D]+"$";var j=c++;p[j]="^"+p[f]+p[y]+"$";var z=c++;p[z]="(?:\\^)";var M=c++;p[M]="(\\s*)"+p[z]+"\\s+",R[M]=new RegExp(p[M],"g");var L=c++;p[L]="^"+p[z]+p[D]+"$";var B=c++;p[B]="^"+p[z]+p[y]+"$";var W=c++;p[W]="^"+p[u]+"\\s*("+s+")$|^$";var ae=c++;p[ae]="^"+p[u]+"\\s*("+i+")$|^$";var q=c++;p[q]="(\\s*)"+p[u]+"\\s*("+s+"|"+p[D]+")",R[q]=new RegExp(p[q],"g");var K=c++;p[K]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var ee=c++;p[ee]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var re=c++;p[re]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)k(ge,p[ge]),R[ge]||(R[ge]=new RegExp(p[ge]));function Z(V,X){if(V instanceof $e)return V;if(typeof V!="string"||V.length>A||!(X?R[d]:R[t]).test(V))return null;try{return new $e(V,X)}catch{return null}}function $e(V,X){if(V instanceof $e){if(V.loose===X)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof $e))return new $e(V,X);k("SemVer",V,X),this.loose=X;var x=V.trim().match(X?R[d]:R[t]);if(!x)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var ve=+de;if(ve>=0&&ve<O)return ve}return de}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=Z,e.valid=function(V,X){var x=Z(V,X);return x?x.version:null},e.clean=function(V,X){var x=Z(V.trim().replace(/^[=v]+/,""),X);return x?x.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(V){return k("SemVer.compare",this.version,this.loose,V),V instanceof $e||(V=new $e(V,this.loose)),this.compareMain(V)||this.comparePre(V)},$e.prototype.compareMain=function(V){return V instanceof $e||(V=new $e(V,this.loose)),oe(this.major,V.major)||oe(this.minor,V.minor)||oe(this.patch,V.patch)},$e.prototype.comparePre=function(V){if(V instanceof $e||(V=new $e(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var X=0;do{var x=this.prerelease[X],de=V.prerelease[X];if(k("prerelease compare",X,x,de),x===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(x===void 0)return-1;if(x!==de)return oe(x,de)}while(++X)},$e.prototype.inc=function(V,X){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,X,x,de){typeof x=="string"&&(de=x,x=void 0);try{return new $e(V,x).inc(X,de).version}catch{return null}},e.diff=function(V,X){if(_(V,X))return null;var x=Z(V),de=Z(X);if(x.prerelease.length||de.prerelease.length){for(var ve in x)if((ve==="major"||ve==="minor"||ve==="patch")&&x[ve]!==de[ve])return"pre"+ve;return"prerelease"}for(var ve in x)if((ve==="major"||ve==="minor"||ve==="patch")&&x[ve]!==de[ve])return ve},e.compareIdentifiers=oe;var fe=/^[0-9]+$/;function oe(V,X){var x=fe.test(V),de=fe.test(X);return x&&de&&(V=+V,X=+X),x&&!de?-1:de&&!x?1:V<X?-1:V>X?1:0}function H(V,X,x){return new $e(V,x).compare(new $e(X,x))}function ue(V,X,x){return H(V,X,x)>0}function te(V,X,x){return H(V,X,x)<0}function _(V,X,x){return H(V,X,x)===0}function ne(V,X,x){return H(V,X,x)!==0}function le(V,X,x){return H(V,X,x)>=0}function J(V,X,x){return H(V,X,x)<=0}function ce(V,X,x,de){var ve;switch(X){case"===":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ve=V===x;break;case"!==":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),ve=V!==x;break;case"":case"=":case"==":ve=_(V,x,de);break;case"!=":ve=ne(V,x,de);break;case">":ve=ue(V,x,de);break;case">=":ve=le(V,x,de);break;case"<":ve=te(V,x,de);break;case"<=":ve=J(V,x,de);break;default:throw new TypeError("Invalid operator: "+X)}return ve}function me(V,X){if(V instanceof me){if(V.loose===X)return V;V=V.value}if(!(this instanceof me))return new me(V,X);k("comparator",V,X),this.loose=X,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(V,X){return oe(X,V)},e.major=function(V,X){return new $e(V,X).major},e.minor=function(V,X){return new $e(V,X).minor},e.patch=function(V,X){return new $e(V,X).patch},e.compare=H,e.compareLoose=function(V,X){return H(V,X,!0)},e.rcompare=function(V,X,x){return H(X,V,x)},e.sort=function(V,X){return V.sort(function(x,de){return e.compare(x,de,X)})},e.rsort=function(V,X){return V.sort(function(x,de){return e.rcompare(x,de,X)})},e.gt=ue,e.lt=te,e.eq=_,e.neq=ne,e.gte=le,e.lte=J,e.cmp=ce,e.Comparator=me;var we={};function Me(V,X){if(V instanceof Me)return V.loose===X?V:new Me(V.raw,X);if(V instanceof me)return new Me(V.value,X);if(!(this instanceof Me))return new Me(V,X);if(this.loose=X,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function qe(V){return!V||V.toLowerCase()==="x"||V==="*"}function ke(V,X,x,de,ve,Fe,Ge,Xe,Qe,nt,ct,rt,lt){return((X=qe(x)?"":qe(de)?">="+x+".0.0":qe(ve)?">="+x+"."+de+".0":">="+X)+" "+(Xe=qe(Qe)?"":qe(nt)?"<"+(+Qe+1)+".0.0":qe(ct)?"<"+Qe+"."+(+nt+1)+".0":rt?"<="+Qe+"."+nt+"."+ct+"-"+rt:"<="+Xe)).trim()}function Ie(V,X){for(var x=0;x<V.length;x++)if(!V[x].test(X))return!1;if(X.prerelease.length){for(x=0;x<V.length;x++)if(k(V[x].semver),V[x].semver!==we&&V[x].semver.prerelease.length>0){var de=V[x].semver;if(de.major===X.major&&de.minor===X.minor&&de.patch===X.patch)return!0}return!1}return!0}function Ce(V,X,x){try{X=new Me(X,x)}catch{return!1}return X.test(V)}function U(V,X,x,de){var ve,Fe,Ge,Xe,Qe;switch(V=new $e(V,de),X=new Me(X,de),x){case">":ve=ue,Fe=J,Ge=te,Xe=">",Qe=">=";break;case"<":ve=te,Fe=le,Ge=ue,Xe="<",Qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(V,X,de))return!1;for(var nt=0;nt<X.set.length;++nt){var ct=X.set[nt],rt=null,lt=null;if(ct.forEach(function(bt){bt.semver===we&&(bt=new me(">=0.0.0")),rt=rt||bt,lt=lt||bt,ve(bt.semver,rt.semver,de)?rt=bt:Ge(bt.semver,lt.semver,de)&&(lt=bt)}),rt.operator===Xe||rt.operator===Qe||(!lt.operator||lt.operator===Xe)&&Fe(V,lt.semver)||lt.operator===Qe&&Ge(V,lt.semver))return!1}return!0}me.prototype.parse=function(V){var X=this.loose?R[W]:R[ae],x=V.match(X);if(!x)throw new TypeError("Invalid comparator: "+V);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new $e(x[2],this.loose):this.semver=we},me.prototype.toString=function(){return this.value},me.prototype.test=function(V){return k("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new $e(V,this.loose)),ce(V,this.operator,this.semver,this.loose))},me.prototype.intersects=function(V,X){if(!(V instanceof me))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Me(V.value,X),Ce(this.value,x,X);if(V.operator==="")return x=new Me(this.value,X),Ce(V.semver,x,X);var de=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Fe=this.semver.version===V.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Xe=ce(this.semver,"<",V.semver,X)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Qe=ce(this.semver,">",V.semver,X)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return de||ve||Fe&&Ge||Xe||Qe},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(V){var X=this.loose;V=V.trim(),k("range",V,X);var x=X?R[ee]:R[K];V=V.replace(x,ke),k("hyphen replace",V),V=V.replace(R[q],"$1$2$3"),k("comparator trim",V,R[q]),V=(V=(V=V.replace(R[N],"$1~")).replace(R[M],"$1^")).split(/\s+/).join(" ");var de=X?R[W]:R[ae],ve=V.split(" ").map(function(Fe){return function(Ge,Xe){return k("comp",Ge),Ge=function(Qe,nt){return Qe.trim().split(/\s+/).map(function(ct){return function(rt,lt){k("caret",rt,lt);var bt=lt?R[B]:R[L];return rt.replace(bt,function(ft,at,dt,Pe,ze){var Re;return k("caret",rt,ft,at,dt,Pe,ze),qe(at)?Re="":qe(dt)?Re=">="+at+".0.0 <"+(+at+1)+".0.0":qe(Pe)?Re=at==="0"?">="+at+"."+dt+".0 <"+at+"."+(+dt+1)+".0":">="+at+"."+dt+".0 <"+(+at+1)+".0.0":ze?(k("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Re=at==="0"?dt==="0"?">="+at+"."+dt+"."+Pe+ze+" <"+at+"."+dt+"."+(+Pe+1):">="+at+"."+dt+"."+Pe+ze+" <"+at+"."+(+dt+1)+".0":">="+at+"."+dt+"."+Pe+ze+" <"+(+at+1)+".0.0"):(k("no pr"),Re=at==="0"?dt==="0"?">="+at+"."+dt+"."+Pe+" <"+at+"."+dt+"."+(+Pe+1):">="+at+"."+dt+"."+Pe+" <"+at+"."+(+dt+1)+".0":">="+at+"."+dt+"."+Pe+" <"+(+at+1)+".0.0"),k("caret return",Re),Re})}(ct,nt)}).join(" ")}(Ge,Xe),k("caret",Ge),Ge=function(Qe,nt){return Qe.trim().split(/\s+/).map(function(ct){return function(rt,lt){var bt=lt?R[j]:R[F];return rt.replace(bt,function(ft,at,dt,Pe,ze){var Re;return k("tilde",rt,ft,at,dt,Pe,ze),qe(at)?Re="":qe(dt)?Re=">="+at+".0.0 <"+(+at+1)+".0.0":qe(Pe)?Re=">="+at+"."+dt+".0 <"+at+"."+(+dt+1)+".0":ze?(k("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Re=">="+at+"."+dt+"."+Pe+ze+" <"+at+"."+(+dt+1)+".0"):Re=">="+at+"."+dt+"."+Pe+" <"+at+"."+(+dt+1)+".0",k("tilde return",Re),Re})}(ct,nt)}).join(" ")}(Ge,Xe),k("tildes",Ge),Ge=function(Qe,nt){return k("replaceXRanges",Qe,nt),Qe.split(/\s+/).map(function(ct){return function(rt,lt){rt=rt.trim();var bt=lt?R[C]:R[T];return rt.replace(bt,function(ft,at,dt,Pe,ze,Re){k("xRange",rt,ft,at,dt,Pe,ze,Re);var Ne=qe(dt),he=Ne||qe(Pe),Y=he||qe(ze);return at==="="&&Y&&(at=""),Ne?ft=at===">"||at==="<"?"<0.0.0":"*":at&&Y?(he&&(Pe=0),Y&&(ze=0),at===">"?(at=">=",he?(dt=+dt+1,Pe=0,ze=0):Y&&(Pe=+Pe+1,ze=0)):at==="<="&&(at="<",he?dt=+dt+1:Pe=+Pe+1),ft=at+dt+"."+Pe+"."+ze):he?ft=">="+dt+".0.0 <"+(+dt+1)+".0.0":Y&&(ft=">="+dt+"."+Pe+".0 <"+dt+"."+(+Pe+1)+".0"),k("xRange return",ft),ft})}(ct,nt)}).join(" ")}(Ge,Xe),k("xrange",Ge),Ge=function(Qe,nt){return k("replaceStars",Qe,nt),Qe.trim().replace(R[re],"")}(Ge,Xe),k("stars",Ge),Ge}(Fe,X)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Fe){return!!Fe.match(de)})),ve=ve.map(function(Fe){return new me(Fe,X)})},Me.prototype.intersects=function(V,X){if(!(V instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(de){return V.set.some(function(ve){return ve.every(function(Fe){return de.intersects(Fe,X)})})})})},e.toComparators=function(V,X){return new Me(V,X).set.map(function(x){return x.map(function(de){return de.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new $e(V,this.loose));for(var X=0;X<this.set.length;X++)if(Ie(this.set[X],V))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(V,X,x){var de=null,ve=null;try{var Fe=new Me(X,x)}catch{return null}return V.forEach(function(Ge){Fe.test(Ge)&&(de&&ve.compare(Ge)!==-1||(ve=new $e(de=Ge,x)))}),de},e.minSatisfying=function(V,X,x){var de=null,ve=null;try{var Fe=new Me(X,x)}catch{return null}return V.forEach(function(Ge){Fe.test(Ge)&&(de&&ve.compare(Ge)!==1||(ve=new $e(de=Ge,x)))}),de},e.validRange=function(V,X){try{return new Me(V,X).range||"*"}catch{return null}},e.ltr=function(V,X,x){return U(V,X,"<",x)},e.gtr=function(V,X,x){return U(V,X,">",x)},e.outside=U,e.prerelease=function(V,X){var x=Z(V,X);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(V,X,x){return V=new Me(V,x),X=new Me(X,x),V.intersects(X)},e.coerce=function(V){if(V instanceof $e)return V;if(typeof V!="string")return null;var X=V.match(R[v]);return X==null?null:Z((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,r(1))},function(ie,e){var r,a,k=ie.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(m){if(r===setTimeout)return setTimeout(m,0);if((r===A||!r)&&setTimeout)return r=setTimeout,setTimeout(m,0);try{return r(m,0)}catch{try{return r.call(null,m,0)}catch{return r.call(this,m,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:A}catch{r=A}try{a=typeof clearTimeout=="function"?clearTimeout:O}catch{a=O}})();var p,c=[],I=!1,S=-1;function h(){I&&p&&(I=!1,p.length?c=p.concat(c):S=-1,c.length&&P())}function P(){if(!I){var m=R(h);I=!0;for(var g=c.length;g;){for(p=c,c=[];++S<g;)p&&p[S].run();S=-1,g=c.length}p=null,I=!1,function($){if(a===clearTimeout)return clearTimeout($);if((a===O||!a)&&clearTimeout)return a=clearTimeout,clearTimeout($);try{a($)}catch{try{return a.call(null,$)}catch{return a.call(this,$)}}}(m)}}function w(m,g){this.fun=m,this.array=g}function l(){}k.nextTick=function(m){var g=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)g[$-1]=arguments[$];c.push(new w(m,g)),c.length!==1||I||R(P)},w.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=l,k.addListener=l,k.once=l,k.off=l,k.removeListener=l,k.removeAllListeners=l,k.emit=l,k.prependListener=l,k.prependOnceListener=l,k.listeners=function(m){return[]},k.binding=function(m){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(m){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Se[44],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(A){return new a(A)}constructor(A){this.c=r&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$he=a}),define(Se[4],De([1,0,14,80,3,81,44]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$je=e.Event=void 0,e.$ke=P;const R=!1,p=!1,c=!1;var I;(function(j){j.None=()=>k.$Xc.None;function z(ke){if(c){const{onDidAddListener:Ie}=ke,Ce=l.create();let U=0;ke.onDidAddListener=()=>{++U===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ce.print()),Ie?.()}}}function M(ke,Ie){return Z(ke,()=>{},0,void 0,!0,void 0,Ie)}j.defer=M;function L(ke){return(Ie,Ce=null,U)=>{let V=!1,X;return X=ke(x=>{if(!V)return X?X.dispose():V=!0,Ie.call(Ce,x)},null,U),V&&X.dispose(),X}}j.once=L;function B(ke,Ie,Ce){return re((U,V=null,X)=>ke(x=>U.call(V,Ie(x)),null,X),Ce)}j.map=B;function W(ke,Ie,Ce){return re((U,V=null,X)=>ke(x=>{Ie(x),U.call(V,x)},null,X),Ce)}j.forEach=W;function ae(ke,Ie,Ce){return re((U,V=null,X)=>ke(x=>Ie(x)&&U.call(V,x),null,X),Ce)}j.filter=ae;function q(ke){return ke}j.signal=q;function K(...ke){return(Ie,Ce=null,U)=>{const V=(0,k.$Uc)(...ke.map(X=>X(x=>Ie.call(Ce,x))));return ge(V,U)}}j.any=K;function ee(ke,Ie,Ce,U){let V=Ce;return B(ke,X=>(V=Ie(V,X),V),U)}j.reduce=ee;function re(ke,Ie){let Ce;const U={onWillAddFirstListener(){Ce=ke(V.fire,V)},onDidRemoveLastListener(){Ce?.dispose()}};Ie||z(U);const V=new s(U);return Ie?.add(V),V.event}function ge(ke,Ie){return Ie instanceof Array?Ie.push(ke):Ie&&Ie.add(ke),ke}function Z(ke,Ie,Ce=100,U=!1,V=!1,X,x){let de,ve,Fe,Ge=0,Xe;const Qe={leakWarningThreshold:X,onWillAddFirstListener(){de=ke(ct=>{Ge++,ve=Ie(ve,ct),U&&!Fe&&(nt.fire(ve),ve=void 0),Xe=()=>{const rt=ve;ve=void 0,Fe=void 0,(!U||Ge>1)&&nt.fire(rt),Ge=0},typeof Ce=="number"?(clearTimeout(Fe),Fe=setTimeout(Xe,Ce)):Fe===void 0&&(Fe=0,queueMicrotask(Xe))})},onWillRemoveListener(){V&&Ge>0&&Xe?.()},onDidRemoveLastListener(){Xe=void 0,de.dispose()}};x||z(Qe);const nt=new s(Qe);return x?.add(nt),nt.event}j.debounce=Z;function $e(ke,Ie=0,Ce){return j.debounce(ke,(U,V)=>U?(U.push(V),U):[V],Ie,void 0,!0,void 0,Ce)}j.accumulate=$e;function fe(ke,Ie=(U,V)=>U===V,Ce){let U=!0,V;return ae(ke,X=>{const x=U||!Ie(X,V);return U=!1,V=X,x},Ce)}j.latch=fe;function oe(ke,Ie,Ce){return[j.filter(ke,Ie,Ce),j.filter(ke,U=>!Ie(U),Ce)]}j.split=oe;function H(ke,Ie=!1,Ce=[],U){let V=Ce.slice(),X=ke(ve=>{V?V.push(ve):de.fire(ve)});U&&U.add(X);const x=()=>{V?.forEach(ve=>de.fire(ve)),V=null},de=new s({onWillAddFirstListener(){X||(X=ke(ve=>de.fire(ve)),U&&U.add(X))},onDidAddFirstListener(){V&&(Ie?setTimeout(x):x())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return U&&U.add(de),de.event}j.buffer=H;function ue(ke,Ie){return(U,V,X)=>{const x=Ie(new _);return ke(function(de){const ve=x.evaluate(de);ve!==te&&U.call(V,ve)},void 0,X)}}j.chain=ue;const te=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(Ie){return this.f.push(Ie),this}forEach(Ie){return this.f.push(Ce=>(Ie(Ce),Ce)),this}filter(Ie){return this.f.push(Ce=>Ie(Ce)?Ce:te),this}reduce(Ie,Ce){let U=Ce;return this.f.push(V=>(U=Ie(U,V),U)),this}latch(Ie=(Ce,U)=>Ce===U){let Ce=!0,U;return this.f.push(V=>{const X=Ce||!Ie(V,U);return Ce=!1,U=V,X?V:te}),this}evaluate(Ie){for(const Ce of this.f)if(Ie=Ce(Ie),Ie===te)break;return Ie}}function ne(ke,Ie,Ce=U=>U){const U=(...de)=>x.fire(Ce(...de)),V=()=>ke.on(Ie,U),X=()=>ke.removeListener(Ie,U),x=new s({onWillAddFirstListener:V,onDidRemoveLastListener:X});return x.event}j.fromNodeEventEmitter=ne;function le(ke,Ie,Ce=U=>U){const U=(...de)=>x.fire(Ce(...de)),V=()=>ke.addEventListener(Ie,U),X=()=>ke.removeEventListener(Ie,U),x=new s({onWillAddFirstListener:V,onDidRemoveLastListener:X});return x.event}j.fromDOMEventEmitter=le;function J(ke){return new Promise(Ie=>L(ke)(Ie))}j.toPromise=J;function ce(ke){const Ie=new s;return ke.then(Ce=>{Ie.fire(Ce)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}j.fromPromise=ce;function me(ke,Ie,Ce){return Ie(Ce),ke(U=>Ie(U))}j.runAndSubscribe=me;class we{constructor(Ie,Ce){this._observable=Ie,this.f=0,this.g=!1;const U={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Ce||z(U),this.emitter=new s(U),Ce&&Ce.add(this.emitter)}beginUpdate(Ie){this.f++}handlePossibleChange(Ie){}handleChange(Ie,Ce){this.g=!0}endUpdate(Ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Me(ke,Ie){return new we(ke,Ie).emitter.event}j.fromObservable=Me;function qe(ke){return(Ie,Ce,U)=>{let V=0,X=!1;const x={beginUpdate(){V++},endUpdate(){V--,V===0&&(ke.reportChanges(),X&&(X=!1,Ie.call(Ce)))},handlePossibleChange(){},handleChange(){X=!0}};ke.addObserver(x),ke.reportChanges();const de={dispose(){ke.removeObserver(x)}};return U instanceof k.$Wc?U.add(de):Array.isArray(U)&&U.push(de),de}}j.fromObservableLight=qe})(I||(e.Event=I={}));class S{constructor(z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${z}_${S.f++}`,S.all.add(this)}start(z){this.g=new O.$he,this.listenerCount=z}stop(){if(this.g){const z=this.g.elapsed();this.durations.push(z),this.elapsedOverall+=z,this.invocationCount+=1,this.g=void 0}}}e.$je=S,S.all=new Set,S.f=0;let h=-1;function P(j){const z=h;return h=j,{dispose(){h=z}}}class w{constructor(z,M,L=(w.f++).toString(16).padStart(3,"0")){this.j=z,this.threshold=M,this.name=L,this.h=0}dispose(){this.g?.clear()}check(z,M){const L=this.threshold;if(L<=0||M<L)return;this.g||(this.g=new Map);const B=this.g.get(z.value)||0;if(this.g.set(z.value,B+1),this.h-=1,this.h<=0){this.h=L*.5;const[W,ae]=this.getMostFrequentStack(),q=`[${this.name}] potential listener LEAK detected, having ${M} listeners already. MOST frequent listener (${ae}):`;console.warn(q),console.warn(W);const K=new m(q,W);this.j(K)}return()=>{const W=this.g.get(z.value)||0;this.g.set(z.value,W-1)}}getMostFrequentStack(){if(!this.g)return;let z,M=0;for(const[L,B]of this.g)(!z||M<B)&&(z=[L,B],M=B);return z}}w.f=1;class l{static create(){const z=new Error;return new l(z.stack??"")}constructor(z){this.value=z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m extends Error{constructor(z,M){super(z),this.name="ListenerLeakError",this.stack=M}}e.$le=m;class g extends Error{constructor(z,M){super(z),this.name="ListenerRefusalError",this.stack=M}}e.$me=g;let $=0;class n{constructor(z){this.value=z,this.id=$++}}const o=2,t=(j,z)=>{if(j instanceof n)z(j);else for(let M=0;M<j.length;M++){const L=j[M];L&&z(L)}};let i;if(R){const j=[];setInterval(()=>{j.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(j.join(`
`)),j.length=0)},3e3),i=new FinalizationRegistry(z=>{typeof z=="string"&&j.push(z)})}class s{constructor(z){this.z=0,this.f=z,this.g=h>0||this.f?.leakWarningThreshold?new w(z?.onListenerError??r.$3,this.f?.leakWarningThreshold??h):void 0,this.j=this.f?._profName?new S(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(p){const z=this.u;queueMicrotask(()=>{t(z,M=>M.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(z,M,L)=>{if(this.g&&this.z>this.g.threshold**2){const K=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(K);const ee=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],re=new g(`${K}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this.f?.onListenerError||r.$3)(re),k.$Xc.None}if(this.m)return k.$Xc.None;M&&(z=z.bind(M));const B=new n(z);let W,ae;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(B.stack=l.create(),W=this.g.check(B.stack,this.z+1)),p&&(B.stack=ae??l.create()),this.u?this.u instanceof n?(this.w??(this.w=new u),this.u=[this.u,B]):this.u.push(B):(this.f?.onWillAddFirstListener?.(this),this.u=B,this.f?.onDidAddFirstListener?.(this)),this.z++;const q=(0,k.$Vc)(()=>{i?.unregister(q),W?.(),this.A(B)});if(L instanceof k.$Wc?L.add(q):Array.isArray(L)&&L.push(q),i){const K=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ee=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(K);i.register(q,ee?.[2]??K,q)}return q}),this.q}A(z){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const M=this.u,L=M.indexOf(z);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,M[L]=void 0;const B=this.w.current===this;if(this.z*o<=M.length){let W=0;for(let ae=0;ae<M.length;ae++)M[ae]?M[W++]=M[ae]:B&&(this.w.end--,W<this.w.i&&this.w.i--);M.length=W}}B(z,M){if(!z)return;const L=this.f?.onListenerError||r.$3;if(!L){z.value(M);return}try{z.value(M)}catch(B){L(B)}}C(z){const M=z.current.u;for(;z.i<z.end;)this.B(M[z.i++],z.value);z.reset()}fire(z){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof n)this.B(this.u,z);else{const M=this.w;M.enqueue(this,z,this.u.length),this.C(M)}this.j?.stop()}hasListeners(){return this.z>0}}e.$ne=s;const d=()=>new u;e.$oe=d;class u{constructor(){this.i=-1,this.end=0}enqueue(z,M,L){this.i=0,this.end=L,this.current=z,this.value=M}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class b extends s{async fireAsync(z,M,L){if(this.u)for(this.h||(this.h=new A.$8c),t(this.u,B=>this.h.push([B.value,z]));this.h.size>0&&!M.isCancellationRequested;){const[B,W]=this.h.shift(),ae=[],q={...W,token:M,waitUntil:K=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");L&&(K=L(K,B)),ae.push(K)}};try{B(q)}catch(K){(0,r.$3)(K);continue}Object.freeze(ae),await Promise.allSettled(ae).then(K=>{for(const ee of K)ee.status==="rejected"&&(0,r.$3)(ee.reason)})}}}e.$pe=b;class E extends s{get isPaused(){return this.h!==0}constructor(z){super(z),this.h=0,this.s=new A.$8c,this.t=z?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const z=Array.from(this.s);this.s.clear(),super.fire(this.t(z))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(z){this.z&&(this.h!==0?this.s.push(z):super.fire(z))}}e.$qe=E;class D extends E{constructor(z){super(z),this.k=z.delay??100}fire(z){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(z)}}e.$re=D;class y extends s{constructor(z){super(z),this.h=[],this.k=z?.merge}fire(z){this.hasListeners()&&(this.h.push(z),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(M=>super.fire(M)),this.h=[]}))}}e.$se=y;class T{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(z){const M={event:z,listener:null};this.h.push(M),this.g&&this.m(M);const L=()=>{this.g&&this.o(M);const B=this.h.indexOf(M);this.h.splice(B,1)};return(0,k.$Vc)((0,a.$gb)(L))}j(){this.g=!0,this.h.forEach(z=>this.m(z))}k(){this.g=!1,this.h.forEach(z=>this.o(z))}m(z){z.listener=z.event(M=>this.f.fire(M))}o(z){z.listener?.dispose(),z.listener=null}dispose(){this.f.dispose();for(const z of this.h)z.listener?.dispose();this.h=[]}}e.$te=T;class C{constructor(z,M,L,B){this.f=new k.$Wc;const W=this.f.add(new T),ae=this.f.add(new k.$7c);function q(K){ae.set(K,W.add(B(K)))}for(const K of z)q(K);this.f.add(M(K=>{q(K)})),this.f.add(L(K=>{ae.deleteAndDispose(K)})),this.event=W.event}dispose(){this.f.dispose()}}e.$ue=C;class v{constructor(){this.f=[]}wrapEvent(z,M,L){return(B,W,ae)=>z(q=>{const K=this.f[this.f.length-1];if(!M){K?K.buffers.push(()=>B.call(W,q)):B.call(W,q);return}const ee=K;if(!ee){B.call(W,M(L,q));return}ee.items??(ee.items=[]),ee.items.push(q),ee.buffers.length===0&&K.buffers.push(()=>{ee.reducedResult??(ee.reducedResult=L?ee.items.reduce(M,L):ee.items.reduce(M)),B.call(W,ee.reducedResult)})},void 0,ae)}bufferEvents(z){const M={buffers:new Array};this.f.push(M);const L=z();return this.f.pop(),M.buffers.forEach(B=>B()),L}}e.$ve=v;class f{constructor(){this.f=!1,this.g=I.None,this.h=k.$Xc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(z){this.g=z,this.f&&(this.h.dispose(),this.h=z(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$we=f;class N{static const(z){return new F(z)}constructor(z){this.g=z,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(z){z!==this.g&&(this.g=z,this.f.fire(void 0))}}e.$xe=N;class F{constructor(z){this.value=z,this.onDidChange=I.None}}}),define(Se[21],De([1,0,4]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.CancellationToken=void 0,e.$ze=R;const a=Object.freeze(function(p,c){const I=setTimeout(p.bind(c),0);return{dispose(){clearTimeout(I)}}});var k;(function(p){function c(I){return I===p.None||I===p.Cancelled||I instanceof A?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}p.isCancellationToken=c,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(k||(e.CancellationToken=k={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new r.$ne),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=k.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=k.None}}e.$ye=O;function R(p){const c=new O;return p.add({dispose(){c.cancel()}}),c.token}}),define(Se[184],De([1,0,21]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bf=e.$af=e.$$e=void 0,e.$_e=k;class a{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new r.$ye,c=this.b(p.token);return this.a={promise:c,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$$e=a;function k(R){return R}class A{constructor(p,c){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=k):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);return this.b!==c&&(this.b=c,this.a=this.c(p)),this.a}}e.$af=A;class O{get cachedValues(){return this.a}constructor(p,c){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=k):(this.c=c,this.d=p.getCacheKey)}get(p){const c=this.d(p);if(this.b.has(c))return this.b.get(c);const I=this.c(p);return this.a.set(p,I),this.b.set(c,I),I}}e.$bf=O}),define(Se[185],De([1,0,4,3]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=e.$ct=e.ScrollbarVisibility=void 0;var k;(function(P){P[P.Auto=1]="Auto",P[P.Hidden=2]="Hidden",P[P.Visible=3]="Visible"})(k||(e.ScrollbarVisibility=k={}));class A{constructor(w,l,m,g,$,n,o){this.c=w,this._scrollStateBrand=void 0,this.c&&(l=l|0,m=m|0,g=g|0,$=$|0,n=n|0,o=o|0),this.rawScrollLeft=g,this.rawScrollTop=o,l<0&&(l=0),g+l>m&&(g=m-l),g<0&&(g=0),$<0&&($=0),o+$>n&&(o=n-$),o<0&&(o=0),this.width=l,this.scrollWidth=m,this.scrollLeft=g,this.height=$,this.scrollHeight=n,this.scrollTop=o}equals(w){return this.rawScrollLeft===w.rawScrollLeft&&this.rawScrollTop===w.rawScrollTop&&this.width===w.width&&this.scrollWidth===w.scrollWidth&&this.scrollLeft===w.scrollLeft&&this.height===w.height&&this.scrollHeight===w.scrollHeight&&this.scrollTop===w.scrollTop}withScrollDimensions(w,l){return new A(this.c,typeof w.width<"u"?w.width:this.width,typeof w.scrollWidth<"u"?w.scrollWidth:this.scrollWidth,l?this.rawScrollLeft:this.scrollLeft,typeof w.height<"u"?w.height:this.height,typeof w.scrollHeight<"u"?w.scrollHeight:this.scrollHeight,l?this.rawScrollTop:this.scrollTop)}withScrollPosition(w){return new A(this.c,this.width,this.scrollWidth,typeof w.scrollLeft<"u"?w.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof w.scrollTop<"u"?w.scrollTop:this.rawScrollTop)}createScrollEvent(w,l){const m=this.width!==w.width,g=this.scrollWidth!==w.scrollWidth,$=this.scrollLeft!==w.scrollLeft,n=this.height!==w.height,o=this.scrollHeight!==w.scrollHeight,t=this.scrollTop!==w.scrollTop;return{inSmoothScrolling:l,oldWidth:w.width,oldScrollWidth:w.scrollWidth,oldScrollLeft:w.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:w.height,oldScrollHeight:w.scrollHeight,oldScrollTop:w.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:g,scrollLeftChanged:$,heightChanged:n,scrollHeightChanged:o,scrollTopChanged:t}}}e.$ct=A;class O extends a.$Xc{constructor(w){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$ne),this.onScroll=this.j.event,this.c=w.smoothScrollDuration,this.f=w.scheduleAtNextAnimationFrame,this.g=new A(w.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(w){this.c=w}validateScrollPosition(w){return this.g.withScrollPosition(w)}getScrollDimensions(){return this.g}setScrollDimensions(w,l){const m=this.g.withScrollDimensions(w,l);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(w){const l=this.g.withScrollPosition(w);this.h&&(this.h.dispose(),this.h=null),this.n(l,!1)}setScrollPositionSmooth(w,l){if(this.c===0)return this.setScrollPositionNow(w);if(this.h){w={scrollLeft:typeof w.scrollLeft>"u"?this.h.to.scrollLeft:w.scrollLeft,scrollTop:typeof w.scrollTop>"u"?this.h.to.scrollTop:w.scrollTop};const m=this.g.withScrollPosition(w);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let g;l?g=new I(this.h.from,m,this.h.startTime,this.h.duration):g=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=g}else{const m=this.g.withScrollPosition(w);this.h=I.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const w=this.h.tick(),l=this.g.withScrollPosition(w);if(this.n(l,!0),!!this.h){if(w.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(w,l){const m=this.g;m.equals(w)||(this.g=w,this.j.fire(this.g.createScrollEvent(m,l)))}}e.$dt=O;class R{constructor(w,l,m){this.scrollLeft=w,this.scrollTop=l,this.isDone=m}}e.$et=R;function p(P,w){const l=w-P;return function(m){return P+l*h(m)}}function c(P,w,l){return function(m){return m<l?P(m/l):w((m-l)/(1-l))}}class I{constructor(w,l,m,g){this.from=w,this.to=l,this.duration=g,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(w,l,m){if(Math.abs(w-l)>2.5*m){let $,n;return w<l?($=w+.75*m,n=l-.75*m):($=w-.75*m,n=l+.75*m),c(p(w,$),p(n,l),.33)}return p(w,l)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(w){this.to=w.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(w){const l=(w-this.startTime)/this.duration;if(l<1){const m=this.c(l),g=this.d(l);return new R(m,g,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(w,l,m){return I.start(w,l,m)}static start(w,l,m){m=m+10;const g=Date.now()-10;return new I(w,l,g,m)}}e.$ft=I;function S(P){return Math.pow(P,3)}function h(P){return 1-S(1-P)}}),define(Se[106],De([1,0,14,3]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=k,e.$Be=A,e.$Ce=O,e.$De=R,e.$Ee=c,e.$Fe=I,e.$Ge=S,e.$He=h,e.$Ie=P,e.$Je=w,e.$Ke=l,e.$Le=m,e.$Me=g,e.$Ne=$,e.$Oe=n;function k(o){const t=o;return t?typeof t.read=="function":!1}function A(o){const t=o;return t?[t.on,t.pause,t.resume,t.destroy].every(i=>typeof i=="function"):!1}function O(o){const t=o;return t?A(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function R(o,t){return new p(o,t)}class p{constructor(t,i){this.e=t,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(i=>i(t))}h(t){this.c.error.length===0?(0,r.$3)(t):this.c.error.slice(0).forEach(i=>i(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,i){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(t,i){if(this.a.destroyed)return;let s;switch(t){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const d=s.indexOf(i);d>=0&&s.splice(d,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(o,t){const i=[];let s;for(;(s=o.read())!==null;)i.push(s);return t(i)}function I(o,t,i){const s=[];let d;for(;(d=o.read())!==null&&s.length<i;)s.push(d);return d===null&&s.length>0?t(s):{read:()=>{if(s.length>0)return s.shift();if(typeof d<"u"){const u=d;return d=void 0,u}return o.read()}}}function S(o,t){return new Promise((i,s)=>{const d=[];h(o,{onData:u=>{t&&d.push(u)},onError:u=>{t?s(u):i(void 0)},onEnd:()=>{i(t?t(d):void 0)}})})}function h(o,t,i){o.on("error",s=>{i?.isCancellationRequested||t.onError(s)}),o.on("end",()=>{i?.isCancellationRequested||t.onEnd()}),o.on("data",s=>{i?.isCancellationRequested||t.onData(s)})}function P(o,t){return new Promise((i,s)=>{const d=new a.$Wc,u=[],b=y=>{if(u.push(y),u.length>t)return d.dispose(),o.pause(),i({stream:o,buffer:u,ended:!1})},E=y=>(d.dispose(),s(y)),D=()=>(d.dispose(),i({stream:o,buffer:u,ended:!0}));d.add((0,a.$Vc)(()=>o.removeListener("error",E))),o.on("error",E),d.add((0,a.$Vc)(()=>o.removeListener("end",D))),o.on("end",D),d.add((0,a.$Vc)(()=>o.removeListener("data",b))),o.on("data",b)})}function w(o,t){const i=R(t);return i.end(o),i}function l(){const o=R(()=>{throw new Error("not supported")});return o.end(),o}function m(o){let t=!1;return{read:()=>t?null:(t=!0,o)}}function g(o,t,i){const s=R(i);return h(o,{onData:d=>s.write(t.data(d)),onError:d=>s.error(t.error?t.error(d):d),onEnd:()=>s.end()}),s}function $(o,t,i){let s=!1;return{read:()=>{const d=t.read();return s?d:(s=!0,d!==null?i([o,d]):o)}}}function n(o,t,i){let s=!1;const d=R(i);return h(t,{onData:u=>s?d.write(u):(s=!0,d.write(i([o,u]))),onError:u=>d.error(u),onEnd:()=>{s||(s=!0,d.write(o)),d.end()}}),d}}),define(Se[22],De([1,0,49,106]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=c,e.$Re=I,e.$Se=S,e.$Te=h,e.$Ue=P,e.$Ve=w,e.$We=l,e.$Xe=m,e.$Ye=g,e.$Ze=$,e.$1e=n,e.$2e=o,e.$3e=t,e.$4e=i,e.$5e=s,e.$6e=d,e.$7e=u,e.$8e=b,e.$9e=E,e.$0e=T,a=Ue(a);const k=typeof Buffer<"u",A=new r.$X(()=>new Uint8Array(256));let O,R;class p{static alloc(v){return k?new p(Buffer.allocUnsafe(v)):new p(new Uint8Array(v))}static wrap(v){return k&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new p(v)}static fromString(v,f){return!(f?.dontUseNodeBuffer||!1)&&k?new p(Buffer.from(v)):(O||(O=new TextEncoder),new p(O.encode(v)))}static fromByteArray(v){const f=p.alloc(v.length);for(let N=0,F=v.length;N<F;N++)f.buffer[N]=v[N];return f}static concat(v,f){if(typeof f>"u"){f=0;for(let j=0,z=v.length;j<z;j++)f+=v[j].byteLength}const N=p.alloc(f);let F=0;for(let j=0,z=v.length;j<z;j++){const M=v[j];N.set(M,F),F+=M.byteLength}return N}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=p.alloc(this.byteLength);return v.set(this),v}toString(){return k?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(v,f){return new p(this.buffer.subarray(v,f))}set(v,f){if(v instanceof p)this.buffer.set(v.buffer,f);else if(v instanceof Uint8Array)this.buffer.set(v,f);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),f);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return h(this.buffer,v)}writeUInt32BE(v,f){P(this.buffer,v,f)}readUInt32LE(v){return w(this.buffer,v)}writeUInt32LE(v,f){l(this.buffer,v,f)}readUInt8(v){return m(this.buffer,v)}writeUInt8(v,f){g(this.buffer,v,f)}indexOf(v,f=0){return c(this.buffer,v instanceof p?v.buffer:v,f)}}e.$Pe=p;function c(C,v,f=0){const N=v.byteLength,F=C.byteLength;if(N===0)return 0;if(N===1)return C.indexOf(v[0]);if(N>F-f)return-1;const j=A.value;j.fill(v.length);for(let B=0;B<v.length;B++)j[v[B]]=v.length-B-1;let z=f+v.length-1,M=z,L=-1;for(;z<F;)if(C[z]===v[M]){if(M===0){L=z;break}z--,M--}else z+=Math.max(v.length-M,j[C[z]]),M=v.length-1;return L}function I(C,v){return C[v+0]<<0>>>0|C[v+1]<<8>>>0}function S(C,v,f){C[f+0]=v&255,v=v>>>8,C[f+1]=v&255}function h(C,v){return C[v]*2**24+C[v+1]*2**16+C[v+2]*2**8+C[v+3]}function P(C,v,f){C[f+3]=v,v=v>>>8,C[f+2]=v,v=v>>>8,C[f+1]=v,v=v>>>8,C[f]=v}function w(C,v){return C[v+0]<<0>>>0|C[v+1]<<8>>>0|C[v+2]<<16>>>0|C[v+3]<<24>>>0}function l(C,v,f){C[f+0]=v&255,v=v>>>8,C[f+1]=v&255,v=v>>>8,C[f+2]=v&255,v=v>>>8,C[f+3]=v&255}function m(C,v){return C[v]}function g(C,v,f){C[f]=v}function $(C){return a.$Ee(C,v=>p.concat(v))}function n(C){return a.$Le(C)}function o(C){return a.$Ge(C,v=>p.concat(v))}async function t(C){return C.ended?p.concat(C.buffer):p.concat([...C.buffer,await o(C.stream)])}function i(C){return a.$Je(C,v=>p.concat(v))}function s(C){return a.$Me(C,{data:v=>typeof v=="string"?p.fromString(v):p.wrap(v)},v=>p.concat(v))}function d(C){return a.$De(v=>p.concat(v),C)}function u(C,v){return a.$Ne(C,v,f=>p.concat(f))}function b(C,v){return a.$Oe(C,v,f=>p.concat(f))}function E(C){let v=0,f=0,N=0;const F=new Uint8Array(Math.floor(C.length/4*3)),j=M=>{switch(f){case 3:F[N++]=v|M,f=0;break;case 2:F[N++]=v|M>>>2,v=M<<6,f=3;break;case 1:F[N++]=v|M>>>4,v=M<<4,f=2;break;default:v=M<<2,f=1}};for(let M=0;M<C.length;M++){const L=C.charCodeAt(M);if(L>=65&&L<=90)j(L-65);else if(L>=97&&L<=122)j(L-97+26);else if(L>=48&&L<=57)j(L-48+52);else if(L===43||L===45)j(62);else if(L===47||L===95)j(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${C[M]}`)}}const z=N;for(;f>0;)j(0);return p.wrap(F).slice(0,z)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function T({buffer:C},v=!0,f=!1){const N=f?y:D;let F="";const j=C.byteLength%3;let z=0;for(;z<C.byteLength-j;z+=3){const M=C[z+0],L=C[z+1],B=C[z+2];F+=N[M>>>2],F+=N[(M<<4|L>>>4)&63],F+=N[(L<<2|B>>>6)&63],F+=N[B&63]}if(j===1){const M=C[z+0];F+=N[M>>>2],F+=N[M<<4&63],v&&(F+="==")}else if(j===2){const M=C[z+0],L=C[z+1];F+=N[M>>>2],F+=N[(M<<4|L>>>4)&63],F+=N[L<<2&63],v&&(F+="=")}return F}}),define(Se[186],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(Se[18],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=r,e.$hg=a,e.$ig=k,e.$jg=A,e.$kg=O,e.$lg=R,e.$mg=p,e.$ng=c,e.$og=I,e.$pg=S,e.$qg=h,e.$rg=P,e.$sg=w,e.$tg=m,e.$ug=g,e.$vg=$,e.$wg=n,e.$xg=o;function r(t){return typeof t=="string"}function a(t){return Array.isArray(t)&&t.every(i=>r(i))}function k(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function A(t){const i=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof i}function O(t){return typeof t=="number"&&!isNaN(t)}function R(t){return!!t&&typeof t[Symbol.iterator]=="function"}function p(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function I(t){return!S(t)}function S(t){return c(t)||t===null}function h(t,i){if(!t)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}function P(t){if(S(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function w(...t){const i=[];for(let s=0;s<t.length;s++){const d=t[s];if(S(d))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);i.push(d)}return i}const l=Object.prototype.hasOwnProperty;function m(t){if(!k(t))return!1;for(const i in t)if(l.call(t,i))return!1;return!0}function g(t){return typeof t=="function"}function $(...t){return t.length>0&&t.every(g)}function n(t,i){const s=Math.min(t.length,i.length);for(let d=0;d<s;d++)o(t[d],i[d])}function o(t,i){if(r(i)){if(typeof t!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(t instanceof i)return}catch{}if(!S(t)&&t.constructor===i||i.length===1&&i.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Se[107],De([1,0,18]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=k,e.$2j=A;const a=Object.create(null);function k(O,R){if((0,r.$gg)(R)){const p=a[R];if(p===void 0)throw new Error(`${O} references an unknown codicon: ${R}`);R=p}return a[O]=R,{id:O}}function A(){return a}}),define(Se[187],De([1,0,107]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=void 0,e.$3j={add:(0,r.$1j)("add",6e4),plus:(0,r.$1j)("plus",6e4),gistNew:(0,r.$1j)("gist-new",6e4),repoCreate:(0,r.$1j)("repo-create",6e4),lightbulb:(0,r.$1j)("lightbulb",60001),lightBulb:(0,r.$1j)("light-bulb",60001),repo:(0,r.$1j)("repo",60002),repoDelete:(0,r.$1j)("repo-delete",60002),gistFork:(0,r.$1j)("gist-fork",60003),repoForked:(0,r.$1j)("repo-forked",60003),gitPullRequest:(0,r.$1j)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$1j)("git-pull-request-abandoned",60004),recordKeys:(0,r.$1j)("record-keys",60005),keyboard:(0,r.$1j)("keyboard",60005),tag:(0,r.$1j)("tag",60006),gitPullRequestLabel:(0,r.$1j)("git-pull-request-label",60006),tagAdd:(0,r.$1j)("tag-add",60006),tagRemove:(0,r.$1j)("tag-remove",60006),person:(0,r.$1j)("person",60007),personFollow:(0,r.$1j)("person-follow",60007),personOutline:(0,r.$1j)("person-outline",60007),personFilled:(0,r.$1j)("person-filled",60007),gitBranch:(0,r.$1j)("git-branch",60008),gitBranchCreate:(0,r.$1j)("git-branch-create",60008),gitBranchDelete:(0,r.$1j)("git-branch-delete",60008),sourceControl:(0,r.$1j)("source-control",60008),mirror:(0,r.$1j)("mirror",60009),mirrorPublic:(0,r.$1j)("mirror-public",60009),star:(0,r.$1j)("star",60010),starAdd:(0,r.$1j)("star-add",60010),starDelete:(0,r.$1j)("star-delete",60010),starEmpty:(0,r.$1j)("star-empty",60010),comment:(0,r.$1j)("comment",60011),commentAdd:(0,r.$1j)("comment-add",60011),alert:(0,r.$1j)("alert",60012),warning:(0,r.$1j)("warning",60012),search:(0,r.$1j)("search",60013),searchSave:(0,r.$1j)("search-save",60013),logOut:(0,r.$1j)("log-out",60014),signOut:(0,r.$1j)("sign-out",60014),logIn:(0,r.$1j)("log-in",60015),signIn:(0,r.$1j)("sign-in",60015),eye:(0,r.$1j)("eye",60016),eyeUnwatch:(0,r.$1j)("eye-unwatch",60016),eyeWatch:(0,r.$1j)("eye-watch",60016),circleFilled:(0,r.$1j)("circle-filled",60017),primitiveDot:(0,r.$1j)("primitive-dot",60017),closeDirty:(0,r.$1j)("close-dirty",60017),debugBreakpoint:(0,r.$1j)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$1j)("debug-breakpoint-disabled",60017),debugHint:(0,r.$1j)("debug-hint",60017),terminalDecorationSuccess:(0,r.$1j)("terminal-decoration-success",60017),primitiveSquare:(0,r.$1j)("primitive-square",60018),edit:(0,r.$1j)("edit",60019),pencil:(0,r.$1j)("pencil",60019),info:(0,r.$1j)("info",60020),issueOpened:(0,r.$1j)("issue-opened",60020),gistPrivate:(0,r.$1j)("gist-private",60021),gitForkPrivate:(0,r.$1j)("git-fork-private",60021),lock:(0,r.$1j)("lock",60021),mirrorPrivate:(0,r.$1j)("mirror-private",60021),close:(0,r.$1j)("close",60022),removeClose:(0,r.$1j)("remove-close",60022),x:(0,r.$1j)("x",60022),repoSync:(0,r.$1j)("repo-sync",60023),sync:(0,r.$1j)("sync",60023),clone:(0,r.$1j)("clone",60024),desktopDownload:(0,r.$1j)("desktop-download",60024),beaker:(0,r.$1j)("beaker",60025),microscope:(0,r.$1j)("microscope",60025),vm:(0,r.$1j)("vm",60026),deviceDesktop:(0,r.$1j)("device-desktop",60026),file:(0,r.$1j)("file",60027),fileText:(0,r.$1j)("file-text",60027),more:(0,r.$1j)("more",60028),ellipsis:(0,r.$1j)("ellipsis",60028),kebabHorizontal:(0,r.$1j)("kebab-horizontal",60028),mailReply:(0,r.$1j)("mail-reply",60029),reply:(0,r.$1j)("reply",60029),organization:(0,r.$1j)("organization",60030),organizationFilled:(0,r.$1j)("organization-filled",60030),organizationOutline:(0,r.$1j)("organization-outline",60030),newFile:(0,r.$1j)("new-file",60031),fileAdd:(0,r.$1j)("file-add",60031),newFolder:(0,r.$1j)("new-folder",60032),fileDirectoryCreate:(0,r.$1j)("file-directory-create",60032),trash:(0,r.$1j)("trash",60033),trashcan:(0,r.$1j)("trashcan",60033),history:(0,r.$1j)("history",60034),clock:(0,r.$1j)("clock",60034),folder:(0,r.$1j)("folder",60035),fileDirectory:(0,r.$1j)("file-directory",60035),symbolFolder:(0,r.$1j)("symbol-folder",60035),logoGithub:(0,r.$1j)("logo-github",60036),markGithub:(0,r.$1j)("mark-github",60036),github:(0,r.$1j)("github",60036),terminal:(0,r.$1j)("terminal",60037),console:(0,r.$1j)("console",60037),repl:(0,r.$1j)("repl",60037),zap:(0,r.$1j)("zap",60038),symbolEvent:(0,r.$1j)("symbol-event",60038),error:(0,r.$1j)("error",60039),stop:(0,r.$1j)("stop",60039),variable:(0,r.$1j)("variable",60040),symbolVariable:(0,r.$1j)("symbol-variable",60040),array:(0,r.$1j)("array",60042),symbolArray:(0,r.$1j)("symbol-array",60042),symbolModule:(0,r.$1j)("symbol-module",60043),symbolPackage:(0,r.$1j)("symbol-package",60043),symbolNamespace:(0,r.$1j)("symbol-namespace",60043),symbolObject:(0,r.$1j)("symbol-object",60043),symbolMethod:(0,r.$1j)("symbol-method",60044),symbolFunction:(0,r.$1j)("symbol-function",60044),symbolConstructor:(0,r.$1j)("symbol-constructor",60044),symbolBoolean:(0,r.$1j)("symbol-boolean",60047),symbolNull:(0,r.$1j)("symbol-null",60047),symbolNumeric:(0,r.$1j)("symbol-numeric",60048),symbolNumber:(0,r.$1j)("symbol-number",60048),symbolStructure:(0,r.$1j)("symbol-structure",60049),symbolStruct:(0,r.$1j)("symbol-struct",60049),symbolParameter:(0,r.$1j)("symbol-parameter",60050),symbolTypeParameter:(0,r.$1j)("symbol-type-parameter",60050),symbolKey:(0,r.$1j)("symbol-key",60051),symbolText:(0,r.$1j)("symbol-text",60051),symbolReference:(0,r.$1j)("symbol-reference",60052),goToFile:(0,r.$1j)("go-to-file",60052),symbolEnum:(0,r.$1j)("symbol-enum",60053),symbolValue:(0,r.$1j)("symbol-value",60053),symbolRuler:(0,r.$1j)("symbol-ruler",60054),symbolUnit:(0,r.$1j)("symbol-unit",60054),activateBreakpoints:(0,r.$1j)("activate-breakpoints",60055),archive:(0,r.$1j)("archive",60056),arrowBoth:(0,r.$1j)("arrow-both",60057),arrowDown:(0,r.$1j)("arrow-down",60058),arrowLeft:(0,r.$1j)("arrow-left",60059),arrowRight:(0,r.$1j)("arrow-right",60060),arrowSmallDown:(0,r.$1j)("arrow-small-down",60061),arrowSmallLeft:(0,r.$1j)("arrow-small-left",60062),arrowSmallRight:(0,r.$1j)("arrow-small-right",60063),arrowSmallUp:(0,r.$1j)("arrow-small-up",60064),arrowUp:(0,r.$1j)("arrow-up",60065),bell:(0,r.$1j)("bell",60066),bold:(0,r.$1j)("bold",60067),book:(0,r.$1j)("book",60068),bookmark:(0,r.$1j)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$1j)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$1j)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$1j)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$1j)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$1j)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$1j)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$1j)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$1j)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$1j)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$1j)("briefcase",60076),broadcast:(0,r.$1j)("broadcast",60077),browser:(0,r.$1j)("browser",60078),bug:(0,r.$1j)("bug",60079),calendar:(0,r.$1j)("calendar",60080),caseSensitive:(0,r.$1j)("case-sensitive",60081),check:(0,r.$1j)("check",60082),checklist:(0,r.$1j)("checklist",60083),chevronDown:(0,r.$1j)("chevron-down",60084),chevronLeft:(0,r.$1j)("chevron-left",60085),chevronRight:(0,r.$1j)("chevron-right",60086),chevronUp:(0,r.$1j)("chevron-up",60087),chromeClose:(0,r.$1j)("chrome-close",60088),chromeMaximize:(0,r.$1j)("chrome-maximize",60089),chromeMinimize:(0,r.$1j)("chrome-minimize",60090),chromeRestore:(0,r.$1j)("chrome-restore",60091),circleOutline:(0,r.$1j)("circle-outline",60092),circle:(0,r.$1j)("circle",60092),debugBreakpointUnverified:(0,r.$1j)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$1j)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$1j)("circle-slash",60093),circuitBoard:(0,r.$1j)("circuit-board",60094),clearAll:(0,r.$1j)("clear-all",60095),clippy:(0,r.$1j)("clippy",60096),closeAll:(0,r.$1j)("close-all",60097),cloudDownload:(0,r.$1j)("cloud-download",60098),cloudUpload:(0,r.$1j)("cloud-upload",60099),code:(0,r.$1j)("code",60100),collapseAll:(0,r.$1j)("collapse-all",60101),colorMode:(0,r.$1j)("color-mode",60102),commentDiscussion:(0,r.$1j)("comment-discussion",60103),creditCard:(0,r.$1j)("credit-card",60105),dash:(0,r.$1j)("dash",60108),dashboard:(0,r.$1j)("dashboard",60109),database:(0,r.$1j)("database",60110),debugContinue:(0,r.$1j)("debug-continue",60111),debugDisconnect:(0,r.$1j)("debug-disconnect",60112),debugPause:(0,r.$1j)("debug-pause",60113),debugRestart:(0,r.$1j)("debug-restart",60114),debugStart:(0,r.$1j)("debug-start",60115),debugStepInto:(0,r.$1j)("debug-step-into",60116),debugStepOut:(0,r.$1j)("debug-step-out",60117),debugStepOver:(0,r.$1j)("debug-step-over",60118),debugStop:(0,r.$1j)("debug-stop",60119),debug:(0,r.$1j)("debug",60120),deviceCameraVideo:(0,r.$1j)("device-camera-video",60121),deviceCamera:(0,r.$1j)("device-camera",60122),deviceMobile:(0,r.$1j)("device-mobile",60123),diffAdded:(0,r.$1j)("diff-added",60124),diffIgnored:(0,r.$1j)("diff-ignored",60125),diffModified:(0,r.$1j)("diff-modified",60126),diffRemoved:(0,r.$1j)("diff-removed",60127),diffRenamed:(0,r.$1j)("diff-renamed",60128),diff:(0,r.$1j)("diff",60129),diffSidebyside:(0,r.$1j)("diff-sidebyside",60129),discard:(0,r.$1j)("discard",60130),editorLayout:(0,r.$1j)("editor-layout",60131),emptyWindow:(0,r.$1j)("empty-window",60132),exclude:(0,r.$1j)("exclude",60133),extensions:(0,r.$1j)("extensions",60134),eyeClosed:(0,r.$1j)("eye-closed",60135),fileBinary:(0,r.$1j)("file-binary",60136),fileCode:(0,r.$1j)("file-code",60137),fileMedia:(0,r.$1j)("file-media",60138),filePdf:(0,r.$1j)("file-pdf",60139),fileSubmodule:(0,r.$1j)("file-submodule",60140),fileSymlinkDirectory:(0,r.$1j)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$1j)("file-symlink-file",60142),fileZip:(0,r.$1j)("file-zip",60143),files:(0,r.$1j)("files",60144),filter:(0,r.$1j)("filter",60145),flame:(0,r.$1j)("flame",60146),foldDown:(0,r.$1j)("fold-down",60147),foldUp:(0,r.$1j)("fold-up",60148),fold:(0,r.$1j)("fold",60149),folderActive:(0,r.$1j)("folder-active",60150),folderOpened:(0,r.$1j)("folder-opened",60151),gear:(0,r.$1j)("gear",60152),gift:(0,r.$1j)("gift",60153),gistSecret:(0,r.$1j)("gist-secret",60154),gist:(0,r.$1j)("gist",60155),gitCommit:(0,r.$1j)("git-commit",60156),gitCompare:(0,r.$1j)("git-compare",60157),compareChanges:(0,r.$1j)("compare-changes",60157),gitMerge:(0,r.$1j)("git-merge",60158),githubAction:(0,r.$1j)("github-action",60159),githubAlt:(0,r.$1j)("github-alt",60160),globe:(0,r.$1j)("globe",60161),grabber:(0,r.$1j)("grabber",60162),graph:(0,r.$1j)("graph",60163),gripper:(0,r.$1j)("gripper",60164),heart:(0,r.$1j)("heart",60165),home:(0,r.$1j)("home",60166),horizontalRule:(0,r.$1j)("horizontal-rule",60167),hubot:(0,r.$1j)("hubot",60168),inbox:(0,r.$1j)("inbox",60169),issueReopened:(0,r.$1j)("issue-reopened",60171),issues:(0,r.$1j)("issues",60172),italic:(0,r.$1j)("italic",60173),jersey:(0,r.$1j)("jersey",60174),json:(0,r.$1j)("json",60175),kebabVertical:(0,r.$1j)("kebab-vertical",60176),key:(0,r.$1j)("key",60177),law:(0,r.$1j)("law",60178),lightbulbAutofix:(0,r.$1j)("lightbulb-autofix",60179),linkExternal:(0,r.$1j)("link-external",60180),link:(0,r.$1j)("link",60181),listOrdered:(0,r.$1j)("list-ordered",60182),listUnordered:(0,r.$1j)("list-unordered",60183),liveShare:(0,r.$1j)("live-share",60184),loading:(0,r.$1j)("loading",60185),location:(0,r.$1j)("location",60186),mailRead:(0,r.$1j)("mail-read",60187),mail:(0,r.$1j)("mail",60188),markdown:(0,r.$1j)("markdown",60189),megaphone:(0,r.$1j)("megaphone",60190),mention:(0,r.$1j)("mention",60191),milestone:(0,r.$1j)("milestone",60192),gitPullRequestMilestone:(0,r.$1j)("git-pull-request-milestone",60192),mortarBoard:(0,r.$1j)("mortar-board",60193),move:(0,r.$1j)("move",60194),multipleWindows:(0,r.$1j)("multiple-windows",60195),mute:(0,r.$1j)("mute",60196),noNewline:(0,r.$1j)("no-newline",60197),note:(0,r.$1j)("note",60198),octoface:(0,r.$1j)("octoface",60199),openPreview:(0,r.$1j)("open-preview",60200),package:(0,r.$1j)("package",60201),paintcan:(0,r.$1j)("paintcan",60202),pin:(0,r.$1j)("pin",60203),play:(0,r.$1j)("play",60204),run:(0,r.$1j)("run",60204),plug:(0,r.$1j)("plug",60205),preserveCase:(0,r.$1j)("preserve-case",60206),preview:(0,r.$1j)("preview",60207),project:(0,r.$1j)("project",60208),pulse:(0,r.$1j)("pulse",60209),question:(0,r.$1j)("question",60210),quote:(0,r.$1j)("quote",60211),radioTower:(0,r.$1j)("radio-tower",60212),reactions:(0,r.$1j)("reactions",60213),references:(0,r.$1j)("references",60214),refresh:(0,r.$1j)("refresh",60215),regex:(0,r.$1j)("regex",60216),remoteExplorer:(0,r.$1j)("remote-explorer",60217),remote:(0,r.$1j)("remote",60218),remove:(0,r.$1j)("remove",60219),replaceAll:(0,r.$1j)("replace-all",60220),replace:(0,r.$1j)("replace",60221),repoClone:(0,r.$1j)("repo-clone",60222),repoForcePush:(0,r.$1j)("repo-force-push",60223),repoPull:(0,r.$1j)("repo-pull",60224),repoPush:(0,r.$1j)("repo-push",60225),report:(0,r.$1j)("report",60226),requestChanges:(0,r.$1j)("request-changes",60227),rocket:(0,r.$1j)("rocket",60228),rootFolderOpened:(0,r.$1j)("root-folder-opened",60229),rootFolder:(0,r.$1j)("root-folder",60230),rss:(0,r.$1j)("rss",60231),ruby:(0,r.$1j)("ruby",60232),saveAll:(0,r.$1j)("save-all",60233),saveAs:(0,r.$1j)("save-as",60234),save:(0,r.$1j)("save",60235),screenFull:(0,r.$1j)("screen-full",60236),screenNormal:(0,r.$1j)("screen-normal",60237),searchStop:(0,r.$1j)("search-stop",60238),server:(0,r.$1j)("server",60240),settingsGear:(0,r.$1j)("settings-gear",60241),settings:(0,r.$1j)("settings",60242),shield:(0,r.$1j)("shield",60243),smiley:(0,r.$1j)("smiley",60244),sortPrecedence:(0,r.$1j)("sort-precedence",60245),splitHorizontal:(0,r.$1j)("split-horizontal",60246),splitVertical:(0,r.$1j)("split-vertical",60247),squirrel:(0,r.$1j)("squirrel",60248),starFull:(0,r.$1j)("star-full",60249),starHalf:(0,r.$1j)("star-half",60250),symbolClass:(0,r.$1j)("symbol-class",60251),symbolColor:(0,r.$1j)("symbol-color",60252),symbolConstant:(0,r.$1j)("symbol-constant",60253),symbolEnumMember:(0,r.$1j)("symbol-enum-member",60254),symbolField:(0,r.$1j)("symbol-field",60255),symbolFile:(0,r.$1j)("symbol-file",60256),symbolInterface:(0,r.$1j)("symbol-interface",60257),symbolKeyword:(0,r.$1j)("symbol-keyword",60258),symbolMisc:(0,r.$1j)("symbol-misc",60259),symbolOperator:(0,r.$1j)("symbol-operator",60260),symbolProperty:(0,r.$1j)("symbol-property",60261),wrench:(0,r.$1j)("wrench",60261),wrenchSubaction:(0,r.$1j)("wrench-subaction",60261),symbolSnippet:(0,r.$1j)("symbol-snippet",60262),tasklist:(0,r.$1j)("tasklist",60263),telescope:(0,r.$1j)("telescope",60264),textSize:(0,r.$1j)("text-size",60265),threeBars:(0,r.$1j)("three-bars",60266),thumbsdown:(0,r.$1j)("thumbsdown",60267),thumbsup:(0,r.$1j)("thumbsup",60268),tools:(0,r.$1j)("tools",60269),triangleDown:(0,r.$1j)("triangle-down",60270),triangleLeft:(0,r.$1j)("triangle-left",60271),triangleRight:(0,r.$1j)("triangle-right",60272),triangleUp:(0,r.$1j)("triangle-up",60273),twitter:(0,r.$1j)("twitter",60274),unfold:(0,r.$1j)("unfold",60275),unlock:(0,r.$1j)("unlock",60276),unmute:(0,r.$1j)("unmute",60277),unverified:(0,r.$1j)("unverified",60278),verified:(0,r.$1j)("verified",60279),versions:(0,r.$1j)("versions",60280),vmActive:(0,r.$1j)("vm-active",60281),vmOutline:(0,r.$1j)("vm-outline",60282),vmRunning:(0,r.$1j)("vm-running",60283),watch:(0,r.$1j)("watch",60284),whitespace:(0,r.$1j)("whitespace",60285),wholeWord:(0,r.$1j)("whole-word",60286),window:(0,r.$1j)("window",60287),wordWrap:(0,r.$1j)("word-wrap",60288),zoomIn:(0,r.$1j)("zoom-in",60289),zoomOut:(0,r.$1j)("zoom-out",60290),listFilter:(0,r.$1j)("list-filter",60291),listFlat:(0,r.$1j)("list-flat",60292),listSelection:(0,r.$1j)("list-selection",60293),selection:(0,r.$1j)("selection",60293),listTree:(0,r.$1j)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$1j)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$1j)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$1j)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$1j)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$1j)("circle-small-filled",60298),debugStackframeDot:(0,r.$1j)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$1j)("terminal-decoration-mark",60298),debugStackframe:(0,r.$1j)("debug-stackframe",60299),debugStackframeFocused:(0,r.$1j)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$1j)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$1j)("symbol-string",60301),debugReverseContinue:(0,r.$1j)("debug-reverse-continue",60302),debugStepBack:(0,r.$1j)("debug-step-back",60303),debugRestartFrame:(0,r.$1j)("debug-restart-frame",60304),debugAlt:(0,r.$1j)("debug-alt",60305),callIncoming:(0,r.$1j)("call-incoming",60306),callOutgoing:(0,r.$1j)("call-outgoing",60307),menu:(0,r.$1j)("menu",60308),expandAll:(0,r.$1j)("expand-all",60309),feedback:(0,r.$1j)("feedback",60310),gitPullRequestReviewer:(0,r.$1j)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$1j)("group-by-ref-type",60311),ungroupByRefType:(0,r.$1j)("ungroup-by-ref-type",60312),account:(0,r.$1j)("account",60313),gitPullRequestAssignee:(0,r.$1j)("git-pull-request-assignee",60313),bellDot:(0,r.$1j)("bell-dot",60314),debugConsole:(0,r.$1j)("debug-console",60315),library:(0,r.$1j)("library",60316),output:(0,r.$1j)("output",60317),runAll:(0,r.$1j)("run-all",60318),syncIgnored:(0,r.$1j)("sync-ignored",60319),pinned:(0,r.$1j)("pinned",60320),githubInverted:(0,r.$1j)("github-inverted",60321),serverProcess:(0,r.$1j)("server-process",60322),serverEnvironment:(0,r.$1j)("server-environment",60323),pass:(0,r.$1j)("pass",60324),issueClosed:(0,r.$1j)("issue-closed",60324),stopCircle:(0,r.$1j)("stop-circle",60325),playCircle:(0,r.$1j)("play-circle",60326),record:(0,r.$1j)("record",60327),debugAltSmall:(0,r.$1j)("debug-alt-small",60328),vmConnect:(0,r.$1j)("vm-connect",60329),cloud:(0,r.$1j)("cloud",60330),merge:(0,r.$1j)("merge",60331),export:(0,r.$1j)("export",60332),graphLeft:(0,r.$1j)("graph-left",60333),magnet:(0,r.$1j)("magnet",60334),notebook:(0,r.$1j)("notebook",60335),redo:(0,r.$1j)("redo",60336),checkAll:(0,r.$1j)("check-all",60337),pinnedDirty:(0,r.$1j)("pinned-dirty",60338),passFilled:(0,r.$1j)("pass-filled",60339),circleLargeFilled:(0,r.$1j)("circle-large-filled",60340),circleLarge:(0,r.$1j)("circle-large",60341),circleLargeOutline:(0,r.$1j)("circle-large-outline",60341),combine:(0,r.$1j)("combine",60342),gather:(0,r.$1j)("gather",60342),table:(0,r.$1j)("table",60343),variableGroup:(0,r.$1j)("variable-group",60344),typeHierarchy:(0,r.$1j)("type-hierarchy",60345),typeHierarchySub:(0,r.$1j)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$1j)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$1j)("git-pull-request-create",60348),runAbove:(0,r.$1j)("run-above",60349),runBelow:(0,r.$1j)("run-below",60350),notebookTemplate:(0,r.$1j)("notebook-template",60351),debugRerun:(0,r.$1j)("debug-rerun",60352),workspaceTrusted:(0,r.$1j)("workspace-trusted",60353),workspaceUntrusted:(0,r.$1j)("workspace-untrusted",60354),workspaceUnknown:(0,r.$1j)("workspace-unknown",60355),terminalCmd:(0,r.$1j)("terminal-cmd",60356),terminalDebian:(0,r.$1j)("terminal-debian",60357),terminalLinux:(0,r.$1j)("terminal-linux",60358),terminalPowershell:(0,r.$1j)("terminal-powershell",60359),terminalTmux:(0,r.$1j)("terminal-tmux",60360),terminalUbuntu:(0,r.$1j)("terminal-ubuntu",60361),terminalBash:(0,r.$1j)("terminal-bash",60362),arrowSwap:(0,r.$1j)("arrow-swap",60363),copy:(0,r.$1j)("copy",60364),personAdd:(0,r.$1j)("person-add",60365),filterFilled:(0,r.$1j)("filter-filled",60366),wand:(0,r.$1j)("wand",60367),debugLineByLine:(0,r.$1j)("debug-line-by-line",60368),inspect:(0,r.$1j)("inspect",60369),layers:(0,r.$1j)("layers",60370),layersDot:(0,r.$1j)("layers-dot",60371),layersActive:(0,r.$1j)("layers-active",60372),compass:(0,r.$1j)("compass",60373),compassDot:(0,r.$1j)("compass-dot",60374),compassActive:(0,r.$1j)("compass-active",60375),azure:(0,r.$1j)("azure",60376),issueDraft:(0,r.$1j)("issue-draft",60377),gitPullRequestClosed:(0,r.$1j)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$1j)("git-pull-request-draft",60379),debugAll:(0,r.$1j)("debug-all",60380),debugCoverage:(0,r.$1j)("debug-coverage",60381),runErrors:(0,r.$1j)("run-errors",60382),folderLibrary:(0,r.$1j)("folder-library",60383),debugContinueSmall:(0,r.$1j)("debug-continue-small",60384),beakerStop:(0,r.$1j)("beaker-stop",60385),graphLine:(0,r.$1j)("graph-line",60386),graphScatter:(0,r.$1j)("graph-scatter",60387),pieChart:(0,r.$1j)("pie-chart",60388),bracket:(0,r.$1j)("bracket",60175),bracketDot:(0,r.$1j)("bracket-dot",60389),bracketError:(0,r.$1j)("bracket-error",60390),lockSmall:(0,r.$1j)("lock-small",60391),azureDevops:(0,r.$1j)("azure-devops",60392),verifiedFilled:(0,r.$1j)("verified-filled",60393),newline:(0,r.$1j)("newline",60394),layout:(0,r.$1j)("layout",60395),layoutActivitybarLeft:(0,r.$1j)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$1j)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$1j)("layout-panel-left",60398),layoutPanelCenter:(0,r.$1j)("layout-panel-center",60399),layoutPanelJustify:(0,r.$1j)("layout-panel-justify",60400),layoutPanelRight:(0,r.$1j)("layout-panel-right",60401),layoutPanel:(0,r.$1j)("layout-panel",60402),layoutSidebarLeft:(0,r.$1j)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$1j)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$1j)("layout-statusbar",60405),layoutMenubar:(0,r.$1j)("layout-menubar",60406),layoutCentered:(0,r.$1j)("layout-centered",60407),target:(0,r.$1j)("target",60408),indent:(0,r.$1j)("indent",60409),recordSmall:(0,r.$1j)("record-small",60410),errorSmall:(0,r.$1j)("error-small",60411),terminalDecorationError:(0,r.$1j)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$1j)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$1j)("arrow-circle-left",60413),arrowCircleRight:(0,r.$1j)("arrow-circle-right",60414),arrowCircleUp:(0,r.$1j)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$1j)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$1j)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$1j)("layout-sidebar-left-off",60418),blank:(0,r.$1j)("blank",60419),heartFilled:(0,r.$1j)("heart-filled",60420),map:(0,r.$1j)("map",60421),mapHorizontal:(0,r.$1j)("map-horizontal",60421),foldHorizontal:(0,r.$1j)("fold-horizontal",60421),mapFilled:(0,r.$1j)("map-filled",60422),mapHorizontalFilled:(0,r.$1j)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$1j)("fold-horizontal-filled",60422),circleSmall:(0,r.$1j)("circle-small",60423),bellSlash:(0,r.$1j)("bell-slash",60424),bellSlashDot:(0,r.$1j)("bell-slash-dot",60425),commentUnresolved:(0,r.$1j)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$1j)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$1j)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$1j)("search-fuzzy",60429),commentDraft:(0,r.$1j)("comment-draft",60430),send:(0,r.$1j)("send",60431),sparkle:(0,r.$1j)("sparkle",60432),insert:(0,r.$1j)("insert",60433),mic:(0,r.$1j)("mic",60434),thumbsdownFilled:(0,r.$1j)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$1j)("thumbsup-filled",60436),coffee:(0,r.$1j)("coffee",60437),snake:(0,r.$1j)("snake",60438),game:(0,r.$1j)("game",60439),vr:(0,r.$1j)("vr",60440),chip:(0,r.$1j)("chip",60441),piano:(0,r.$1j)("piano",60442),music:(0,r.$1j)("music",60443),micFilled:(0,r.$1j)("mic-filled",60444),repoFetch:(0,r.$1j)("repo-fetch",60445),copilot:(0,r.$1j)("copilot",60446),lightbulbSparkle:(0,r.$1j)("lightbulb-sparkle",60447),robot:(0,r.$1j)("robot",60448),sparkleFilled:(0,r.$1j)("sparkle-filled",60449),diffSingle:(0,r.$1j)("diff-single",60450),diffMultiple:(0,r.$1j)("diff-multiple",60451),surroundWith:(0,r.$1j)("surround-with",60452),share:(0,r.$1j)("share",60453),gitStash:(0,r.$1j)("git-stash",60454),gitStashApply:(0,r.$1j)("git-stash-apply",60455),gitStashPop:(0,r.$1j)("git-stash-pop",60456),vscode:(0,r.$1j)("vscode",60457),vscodeInsiders:(0,r.$1j)("vscode-insiders",60458),codeOss:(0,r.$1j)("code-oss",60459),runCoverage:(0,r.$1j)("run-coverage",60460),runAllCoverage:(0,r.$1j)("run-all-coverage",60461),coverage:(0,r.$1j)("coverage",60462),githubProject:(0,r.$1j)("github-project",60463),mapVertical:(0,r.$1j)("map-vertical",60464),foldVertical:(0,r.$1j)("fold-vertical",60464),mapVerticalFilled:(0,r.$1j)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$1j)("fold-vertical-filled",60465),goToSearch:(0,r.$1j)("go-to-search",60466),percentage:(0,r.$1j)("percentage",60467),sortPercentage:(0,r.$1j)("sort-percentage",60467),attach:(0,r.$1j)("attach",60468)}}),define(Se[83],De([1,0,107,187]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=void 0,e.$4j=k;function k(){return Object.values(e.$6j)}e.$5j={dialogError:(0,r.$1j)("dialog-error","error"),dialogWarning:(0,r.$1j)("dialog-warning","warning"),dialogInfo:(0,r.$1j)("dialog-info","info"),dialogClose:(0,r.$1j)("dialog-close","close"),treeItemExpanded:(0,r.$1j)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$1j)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$1j)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$1j)("tree-filter-clear","close"),treeItemLoading:(0,r.$1j)("tree-item-loading","loading"),menuSelection:(0,r.$1j)("menu-selection","check"),menuSubmenu:(0,r.$1j)("menu-submenu","chevron-right"),menuBarMore:(0,r.$1j)("menubar-more","more"),scrollbarButtonLeft:(0,r.$1j)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$1j)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$1j)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$1j)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$1j)("toolbar-more","more"),quickInputBack:(0,r.$1j)("quick-input-back","arrow-left"),dropDownButton:(0,r.$1j)("drop-down-button",60084),symbolCustomColor:(0,r.$1j)("symbol-customcolor",60252),exportIcon:(0,r.$1j)("export",60332),workspaceUnspecified:(0,r.$1j)("workspace-unspecified",60355),newLine:(0,r.$1j)("newline",60394),thumbsDownFilled:(0,r.$1j)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$1j)("thumbsup-filled",60436),gitFetch:(0,r.$1j)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$1j)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$1j)("debug-breakpoint-pending",60377)},e.$6j={...a.$3j,...e.$5j}}),define(Se[25],De([1,0,18]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=a,e.$go=k,e.$ho=O,e.$io=p,e.$jo=c,e.$ko=I,e.$lo=S,e.$mo=h,e.$no=P,e.$oo=w,e.$po=l,e.$qo=m,e.$ro=g;function a($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const n=Array.isArray($)?[]:{};return Object.entries($).forEach(([o,t])=>{n[o]=t&&typeof t=="object"?a(t):t}),n}function k($){if(!$||typeof $!="object")return $;const n=[$];for(;n.length>0;){const o=n.shift();Object.freeze(o);for(const t in o)if(A.call(o,t)){const i=o[t];typeof i=="object"&&!Object.isFrozen(i)&&!(0,r.$jg)(i)&&n.push(i)}}return $}const A=Object.prototype.hasOwnProperty;function O($,n){return R($,n,new Set)}function R($,n,o){if((0,r.$pg)($))return $;const t=n($);if(typeof t<"u")return t;if(Array.isArray($)){const i=[];for(const s of $)i.push(R(s,n,o));return i}if((0,r.$ig)($)){if(o.has($))throw new Error("Cannot clone recursive data-structure");o.add($);const i={};for(const s in $)A.call($,s)&&(i[s]=R($[s],n,o));return o.delete($),i}return $}function p($,n,o=!0){return(0,r.$ig)($)?((0,r.$ig)(n)&&Object.keys(n).forEach(t=>{t in $?o&&((0,r.$ig)($[t])&&(0,r.$ig)(n[t])?p($[t],n[t],o):$[t]=n[t]):$[t]=n[t]}),$):n}function c($,n){if($===n)return!0;if($==null||n===null||n===void 0||typeof $!=typeof n||typeof $!="object"||Array.isArray($)!==Array.isArray(n))return!1;let o,t;if(Array.isArray($)){if($.length!==n.length)return!1;for(o=0;o<$.length;o++)if(!c($[o],n[o]))return!1}else{const i=[];for(t in $)i.push(t);i.sort();const s=[];for(t in n)s.push(t);if(s.sort(),!c(i,s))return!1;for(o=0;o<i.length;o++)if(!c($[i[o]],n[i[o]]))return!1}return!0}function I($){const n=new Set;return JSON.stringify($,(o,t)=>{if((0,r.$ig)(t)||Array.isArray(t)){if(n.has(t))return"[Circular]";n.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function S($,n){const o=Object.create(null);return!$||!n||Object.keys(n).forEach(i=>{const s=$[i],d=n[i];c(s,d)||(o[i]=d)}),o}function h($,n){const o=n.toLowerCase(),t=Object.keys($).find(i=>i.toLowerCase()===o);return t?$[t]:$[n]}function P($,n){const o=Object.create(null);for(const[t,i]of Object.entries($))n(t,i)&&(o[t]=i);return o}function w($){let n=[];for(;Object.prototype!==$;)n=n.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return n}function l($){const n=[];for(const o of w($))typeof $[o]=="function"&&n.push(o);return n}function m($,n){const o=i=>function(){const s=Array.prototype.slice.call(arguments,0);return n(i,s)},t={};for(const i of $)t[i]=o(i);return t}function g($,n){const o={};for(const[t,i]of Object.entries($))o[t]=n(i,t);return o}}),define(Se[50],De([1,0,83]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=k;var a;(function(O){function R(p){return p&&typeof p=="object"&&typeof p.id=="string"}O.isThemeColor=R})(a||(e.ThemeColor=a={}));function k(O){return{id:O}}var A;(function(O){O.iconNameSegment="[A-Za-z0-9]+",O.iconNameExpression="[A-Za-z0-9-]+",O.iconModifierExpression="~[A-Za-z]+",O.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${O.iconNameExpression})(${O.iconModifierExpression})?$`);function p($){const n=R.exec($.id);if(!n)return p(r.$6j.error);const[,o,t]=n,i=["codicon","codicon-"+o];return t&&i.push("codicon-modifier-"+t.substring(1)),i}O.asClassNameArray=p;function c($){return p($).join(" ")}O.asClassName=c;function I($){return"."+p($).join(".")}O.asCSSSelector=I;function S($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||a.isThemeColor($.color))}O.isThemeIcon=S;const h=new RegExp(`^\\$\\((${O.iconNameExpression}(?:${O.iconModifierExpression})?)\\)$`);function P($){const n=h.exec($);if(!n)return;const[,o]=n;return{id:o}}O.fromString=P;function w($){return{id:$}}O.fromId=w;function l($,n){let o=$.id;const t=o.lastIndexOf("~");return t!==-1&&(o=o.substring(0,t)),n&&(o=`${o}~${n}`),{id:o}}O.modify=l;function m($){const n=$.id.lastIndexOf("~");if(n!==-1)return $.id.substring(n+1)}O.getModifier=m;function g($,n){return $.id===n.id&&$.color?.id===n.color?.id}O.isEqual=g})(A||(e.ThemeIcon=A={}))}),define(Se[84],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$cf=a,e.$df=k;var r;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function a(A){return A<0?0:A>r.MAX_UINT_8?r.MAX_UINT_8:A|0}function k(A){return A<0?0:A>r.MAX_UINT_32?r.MAX_UINT_32:A|0}}),define(Se[13],De([1,0,184,27,49,84]),function(ie,e,r,a,k,A){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.GraphemeBreakType=e.$6f=e.$Xf=e.$Qf=e.$Pf=void 0,e.$ef=R,e.$ff=c,e.$gf=S,e.$hf=h,e.$if=P,e.$jf=w,e.$kf=l,e.$lf=m,e.$mf=g,e.$nf=$,e.$of=n,e.$pf=o,e.$qf=t,e.$rf=i,e.$sf=s,e.$tf=d,e.$uf=u,e.$vf=b,e.$wf=E,e.$xf=D,e.$yf=y,e.$zf=T,e.$Af=C,e.$Bf=v,e.$Cf=f,e.$Df=N,e.$Ef=F,e.$Ff=j,e.$Gf=z,e.$Hf=M,e.$If=L,e.$Jf=B,e.$Kf=W,e.$Lf=ae,e.$Mf=q,e.$Nf=K,e.$Of=ee,e.$Rf=$e,e.$Sf=fe,e.$Tf=oe,e.$Uf=H,e.$Vf=_,e.$Wf=le,e.$Yf=J,e.$Zf=ce,e.$1f=me,e.$2f=we,e.$3f=qe,e.$4f=ke,e.$5f=Ce,e.$7f=U,e.$8f=V,e.$9f=X,e.$0f=x,e.$$f=de,e.$_f=ve,e.$ag=Fe,e.$bg=Ge,e.$cg=rt;function R(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const p=/{(\d+)}/g;function c(Pe,...ze){return ze.length===0?Pe:Pe.replace(p,function(Re,Ne){const he=parseInt(Ne,10);return isNaN(he)||he<0||he>=ze.length?Re:ze[he]})}const I=/{([^}]+)}/g;function S(Pe,ze){return Object.keys(ze).length===0?Pe:Pe.replace(I,(Re,Ne)=>ze[Ne]??Re)}function h(Pe){return Pe.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}function P(Pe){return Pe.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}function w(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(Pe,ze){let Re=0,Ne=Pe.indexOf(ze);for(;Ne!==-1;)Re++,Ne=Pe.indexOf(ze,Ne+ze.length);return Re}function m(Pe,ze,Re="\u2026"){return Pe.length<=ze?Pe:`${Pe.substr(0,ze)}${Re}`}function g(Pe,ze,Re="\u2026"){if(Pe.length<=ze)return Pe;const Ne=Math.ceil(ze/2)-Re.length/2,he=Math.floor(ze/2)-Re.length/2;return`${Pe.substr(0,Ne)}${Re}${Pe.substr(Pe.length-he)}`}function $(Pe,ze=" "){const Re=n(Pe,ze);return o(Re,ze)}function n(Pe,ze){if(!Pe||!ze)return Pe;const Re=ze.length;if(Re===0||Pe.length===0)return Pe;let Ne=0;for(;Pe.indexOf(ze,Ne)===Ne;)Ne=Ne+Re;return Pe.substring(Ne)}function o(Pe,ze){if(!Pe||!ze)return Pe;const Re=ze.length,Ne=Pe.length;if(Re===0||Ne===0)return Pe;let he=Ne,Y=-1;for(;Y=Pe.lastIndexOf(ze,he-1),!(Y===-1||Y+Re!==he);){if(Y===0)return"";he=Y}return Pe.substring(0,he)}function t(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Pe){return Pe.replace(/\*/g,"")}function s(Pe,ze,Re={}){if(!Pe)throw new Error("Cannot create regex from empty string");ze||(Pe=w(Pe)),Re.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Ne="";return Re.global&&(Ne+="g"),Re.matchCase||(Ne+="i"),Re.multiline&&(Ne+="m"),Re.unicode&&(Ne+="u"),new RegExp(Pe,Ne)}function d(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function u(Pe){return Pe.split(/\r\n|\r|\n/)}function b(Pe){const ze=[],Re=Pe.split(/(\r\n|\r|\n)/);for(let Ne=0;Ne<Math.ceil(Re.length/2);Ne++)ze.push(Re[2*Ne]+(Re[2*Ne+1]??""));return ze}function E(Pe){for(let ze=0,Re=Pe.length;ze<Re;ze++){const Ne=Pe.charCodeAt(ze);if(Ne!==a.CharCode.Space&&Ne!==a.CharCode.Tab)return ze}return-1}function D(Pe,ze=0,Re=Pe.length){for(let Ne=ze;Ne<Re;Ne++){const he=Pe.charCodeAt(Ne);if(he!==a.CharCode.Space&&he!==a.CharCode.Tab)return Pe.substring(ze,Ne)}return Pe.substring(ze,Re)}function y(Pe,ze=Pe.length-1){for(let Re=ze;Re>=0;Re--){const Ne=Pe.charCodeAt(Re);if(Ne!==a.CharCode.Space&&Ne!==a.CharCode.Tab)return Re}return-1}function T(Pe,ze,Re){const Ne=[];let he=0;for(const Y of Pe.matchAll(ze)){if(Ne.push(Pe.slice(he,Y.index)),Y.index===void 0)throw new Error("match.index should be defined");he=Y.index+Y[0].length,Ne.push(Re(Y[0],...Y.slice(1),Y.index,Pe,Y.groups))}return Ne.push(Pe.slice(he)),Promise.all(Ne).then(Y=>Y.join(""))}function C(Pe,ze){return Pe<ze?-1:Pe>ze?1:0}function v(Pe,ze,Re=0,Ne=Pe.length,he=0,Y=ze.length){for(;Re<Ne&&he<Y;Re++,he++){const et=Pe.charCodeAt(Re),ut=ze.charCodeAt(he);if(et<ut)return-1;if(et>ut)return 1}const Ae=Ne-Re,Ze=Y-he;return Ae<Ze?-1:Ae>Ze?1:0}function f(Pe,ze){return N(Pe,ze,0,Pe.length,0,ze.length)}function N(Pe,ze,Re=0,Ne=Pe.length,he=0,Y=ze.length){for(;Re<Ne&&he<Y;Re++,he++){let et=Pe.charCodeAt(Re),ut=ze.charCodeAt(he);if(et===ut)continue;if(et>=128||ut>=128)return v(Pe.toLowerCase(),ze.toLowerCase(),Re,Ne,he,Y);j(et)&&(et-=32),j(ut)&&(ut-=32);const mt=et-ut;if(mt!==0)return mt}const Ae=Ne-Re,Ze=Y-he;return Ae<Ze?-1:Ae>Ze?1:0}function F(Pe){return Pe>=a.CharCode.Digit0&&Pe<=a.CharCode.Digit9}function j(Pe){return Pe>=a.CharCode.a&&Pe<=a.CharCode.z}function z(Pe){return Pe>=a.CharCode.A&&Pe<=a.CharCode.Z}function M(Pe,ze){return Pe.length===ze.length&&N(Pe,ze)===0}function L(Pe,ze){const Re=ze.length;return ze.length>Pe.length?!1:N(Pe,ze,0,Re)===0}function B(Pe,ze){const Re=Math.min(Pe.length,ze.length);let Ne;for(Ne=0;Ne<Re;Ne++)if(Pe.charCodeAt(Ne)!==ze.charCodeAt(Ne))return Ne;return Re}function W(Pe,ze){const Re=Math.min(Pe.length,ze.length);let Ne;const he=Pe.length-1,Y=ze.length-1;for(Ne=0;Ne<Re;Ne++)if(Pe.charCodeAt(he-Ne)!==ze.charCodeAt(Y-Ne))return Ne;return Re}function ae(Pe){return 55296<=Pe&&Pe<=56319}function q(Pe){return 56320<=Pe&&Pe<=57343}function K(Pe,ze){return(Pe-55296<<10)+(ze-56320)+65536}function ee(Pe,ze,Re){const Ne=Pe.charCodeAt(Re);if(ae(Ne)&&Re+1<ze){const he=Pe.charCodeAt(Re+1);if(q(he))return K(Ne,he)}return Ne}function re(Pe,ze){const Re=Pe.charCodeAt(ze-1);if(q(Re)&&ze>1){const Ne=Pe.charCodeAt(ze-2);if(ae(Ne))return K(Ne,Re)}return Re}class ge{get offset(){return this.e}constructor(ze,Re=0){this.c=ze,this.d=ze.length,this.e=Re}setOffset(ze){this.e=ze}prevCodePoint(){const ze=re(this.c,this.e);return this.e-=ze>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}nextCodePoint(){const ze=ee(this.c,this.d,this.e);return this.e+=ze>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}eol(){return this.e>=this.d}}e.$Pf=ge;class Z{get offset(){return this.c.offset}constructor(ze,Re=0){this.c=new ge(ze,Re)}nextGraphemeLength(){const ze=nt.getInstance(),Re=this.c,Ne=Re.offset;let he=ze.getGraphemeBreakType(Re.nextCodePoint());for(;!Re.eol();){const Y=Re.offset,Ae=ze.getGraphemeBreakType(Re.nextCodePoint());if(Xe(he,Ae)){Re.setOffset(Y);break}he=Ae}return Re.offset-Ne}prevGraphemeLength(){const ze=nt.getInstance(),Re=this.c,Ne=Re.offset;let he=ze.getGraphemeBreakType(Re.prevCodePoint());for(;Re.offset>0;){const Y=Re.offset,Ae=ze.getGraphemeBreakType(Re.prevCodePoint());if(Xe(Ae,he)){Re.setOffset(Y);break}he=Ae}return Ne-Re.offset}eol(){return this.c.eol()}}e.$Qf=Z;function $e(Pe,ze){return new Z(Pe,ze).nextGraphemeLength()}function fe(Pe,ze){return new Z(Pe,ze).prevGraphemeLength()}function oe(Pe,ze){ze>0&&q(Pe.charCodeAt(ze))&&ze--;const Re=ze+$e(Pe,ze);return[Re-fe(Pe,Re),Re]}function H(Pe){const ze=new Z(Pe);let Re=0;for(;!ze.eol();)Re++,ze.nextGraphemeLength();return Re}let ue;function te(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(Pe){return ue||(ue=te()),ue.test(Pe)}const ne=/^[\t\n\r\x20-\x7E]*$/;function le(Pe){return ne.test(Pe)}e.$Xf=/[\u2028\u2029]/;function J(Pe){return e.$Xf.test(Pe)}function ce(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function me(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function we(Pe,ze,Re=""){const Ne=Pe.trimStart();if(Ne.length<ze)return Ne;const he=/\b/g;let Y=0;for(;he.test(Ne)&&!(Ne.length-he.lastIndex<ze);)Y=he.lastIndex,he.lastIndex+=1;return Y===0?Ne:Re+Ne.substring(Y).trimStart()}const Me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*qe(Pe){let ze=0;for(const Re of Pe.matchAll(Me))ze!==Re.index&&(yield{isCode:!1,str:Pe.substring(ze,Re.index)}),yield{isCode:!0,str:Re[0]},ze=Re.index+Re[0].length;ze!==Pe.length&&(yield{isCode:!1,str:Pe.substring(ze)})}function ke(Pe){return Pe&&(Pe=Pe.replace(Me,"")),Pe}const Ie=/\\\[.*?\\\]/g;function Ce(Pe){return ke(Pe).replace(Ie,"")}e.$6f=String.fromCharCode(a.CharCode.UTF8_BOM);function U(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===a.CharCode.UTF8_BOM)}function V(Pe){return U(Pe)?Pe.substr(1):Pe}function X(Pe,ze){if(!Pe||!ze||Pe.length<ze.length)return!1;const Re=ze.length,Ne=Pe.toLowerCase();let he=0,Y=-1;for(;he<Re;){const Ae=Ne.indexOf(ze[he],Y+1);if(Ae<0)return!1;Y=Ae,he++}return!0}function x(Pe,ze=!1){return Pe?(ze&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function de(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function ve(Pe,ze=1){if(ze===0)return"";let Re=-1;do Re=Pe.indexOf(`
`,Re+1),ze--;while(ze>0&&Re>=0);return Re===-1?Pe:(Pe[Re-1]==="\r"&&Re--,Pe.substr(0,Re))}function Fe(Pe){const ze=a.CharCode.Z-a.CharCode.A+1;return Pe=Pe%(2*ze),Pe<ze?String.fromCharCode(a.CharCode.a+Pe):String.fromCharCode(a.CharCode.A+Pe-ze)}function Ge(Pe){return nt.getInstance().getGraphemeBreakType(Pe)}function Xe(Pe,ze){return Pe===Qe.Other?ze!==Qe.Extend&&ze!==Qe.SpacingMark:Pe===Qe.CR&&ze===Qe.LF?!1:Pe===Qe.Control||Pe===Qe.CR||Pe===Qe.LF||ze===Qe.Control||ze===Qe.CR||ze===Qe.LF?!0:!(Pe===Qe.L&&(ze===Qe.L||ze===Qe.V||ze===Qe.LV||ze===Qe.LVT)||(Pe===Qe.LV||Pe===Qe.V)&&(ze===Qe.V||ze===Qe.T)||(Pe===Qe.LVT||Pe===Qe.T)&&ze===Qe.T||ze===Qe.Extend||ze===Qe.ZWJ||ze===Qe.SpacingMark||Pe===Qe.Prepend||Pe===Qe.ZWJ&&ze===Qe.Extended_Pictographic||Pe===Qe.Regional_Indicator&&ze===Qe.Regional_Indicator)}var Qe;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Qe||(e.GraphemeBreakType=Qe={}));class nt{static getInstance(){return nt.c||(nt.c=new nt),nt.c}constructor(){this.d=ct()}getGraphemeBreakType(ze){if(ze<32)return ze===a.CharCode.LineFeed?Qe.LF:ze===a.CharCode.CarriageReturn?Qe.CR:Qe.Control;if(ze<127)return Qe.Other;const Re=this.d,Ne=Re.length/3;let he=1;for(;he<=Ne;)if(ze<Re[3*he])he=2*he;else if(ze>Re[3*he+1])he=2*he+1;else return Re[3*he+2];return Qe.Other}}nt.c=null;function ct(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function rt(Pe,ze){if(Pe===0)return 0;const Re=lt(Pe,ze);if(Re!==void 0)return Re;const Ne=new ge(ze,Pe);return Ne.prevCodePoint(),Ne.offset}function lt(Pe,ze){const Re=new ge(ze,Pe);let Ne=Re.prevCodePoint();for(;bt(Ne)||Ne===ft.emojiVariantSelector||Ne===ft.enclosingKeyCap;){if(Re.offset===0)return;Ne=Re.prevCodePoint()}if(!me(Ne))return;let he=Re.offset;return he>0&&Re.prevCodePoint()===ft.zwj&&(he=Re.offset),he}function bt(Pe){return 127995<=Pe&&Pe<=127999}var ft;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(ft||(ft={})),e.$dg="\xA0";class at{static getInstance(ze){return O.d.get(Array.from(ze))}static getLocales(){return O.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}containsAmbiguousCharacter(ze){for(let Re=0;Re<ze.length;Re++){const Ne=ze.codePointAt(Re);if(typeof Ne=="number"&&this.isAmbiguous(Ne))return!0}return!1}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$eg=at,O=at,at.c=new k.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),at.d=new r.$af({getCacheKey:JSON.stringify},Pe=>{function ze(ut){const mt=new Map;for(let Dt=0;Dt<ut.length;Dt+=2)mt.set(ut[Dt],ut[Dt+1]);return mt}function Re(ut,mt){const Dt=new Map(ut);for(const[Ft,Kt]of mt)Dt.set(Ft,Kt);return Dt}function Ne(ut,mt){if(!ut)return mt;const Dt=new Map;for(const[Ft,Kt]of ut)mt.has(Ft)&&Dt.set(Ft,Kt);return Dt}const he=O.c.value;let Y=Pe.filter(ut=>!ut.startsWith("_")&&ut in he);Y.length===0&&(Y=["_default"]);let Ae;for(const ut of Y){const mt=ze(he[ut]);Ae=Ne(Ae,mt)}const Ze=ze(he._common),et=Re(Ze,Ae);return new O(et)}),at.e=new k.$X(()=>Object.keys(O.c.value).filter(Pe=>!Pe.startsWith("_")));class dt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(dt.c())),this.d}static isInvisibleCharacter(ze){return dt.e().has(ze)}static containsInvisibleCharacter(ze){for(let Re=0;Re<ze.length;Re++){const Ne=ze.codePointAt(Re);if(typeof Ne=="number"&&dt.isInvisibleCharacter(Ne))return!0}return!1}static get codePoints(){return dt.e()}}e.$fg=dt,dt.d=void 0}),define(Se[32],De([1,0,27,17,11,13,18]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=R,e.$zg=p,e.$Ag=c,e.$Bg=I,e.$Cg=S,e.$Dg=l,e.$Eg=m,e.$Fg=g,e.$Gg=$,e.$Hg=n,e.$Ig=o,e.$Jg=t,e.$Kg=i,e.$Lg=s,e.$Mg=d,e.$Ng=u,e.$Og=D;function R(y){return y===r.CharCode.Slash||y===r.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,a.$jc.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function I(y,T=a.$jc.sep){if(!y)return"";const C=y.length,v=y.charCodeAt(0);if(R(v)){if(R(y.charCodeAt(1))&&!R(y.charCodeAt(2))){let N=3;const F=N;for(;N<C&&!R(y.charCodeAt(N));N++);if(F!==N&&!R(y.charCodeAt(N+1))){for(N+=1;N<C;N++)if(R(y.charCodeAt(N)))return y.slice(0,N+1).replace(/[\\/]/g,T)}}return T}else if($(v)&&y.charCodeAt(1)===r.CharCode.Colon)return R(y.charCodeAt(2))?y.slice(0,2)+T:y.slice(0,2);let f=y.indexOf("://");if(f!==-1){for(f+=3;f<C;f++)if(R(y.charCodeAt(f)))return y.slice(0,f+1)}return""}function S(y){if(!k.$c||!y||y.length<5)return!1;let T=y.charCodeAt(0);if(T!==r.CharCode.Backslash||(T=y.charCodeAt(1),T!==r.CharCode.Backslash))return!1;let C=2;const v=C;for(;C<y.length&&(T=y.charCodeAt(C),T!==r.CharCode.Backslash);C++);return!(v===C||(T=y.charCodeAt(C+1),isNaN(T)||T===r.CharCode.Backslash))}const h=/[\\/:\*\?"<>\|]/g,P=/[/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(y,T=k.$c){const C=T?h:P;return!(!y||y.length===0||/^\s+$/.test(y)||(C.lastIndex=0,C.test(y))||T&&w.test(y)||y==="."||y===".."||T&&y[y.length-1]==="."||T&&y.length!==y.trim().length||y.length>255)}function m(y,T,C){const v=y===T;return!C||v?v:!y||!T?!1:(0,A.$Hf)(y,T)}function g(y,T,C,v=a.sep){if(y===T)return!0;if(!y||!T||T.length>y.length)return!1;if(C){if(!(0,A.$If)(y,T))return!1;if(T.length===y.length)return!0;let N=T.length;return T.charAt(T.length-1)===v&&N--,y.charAt(N)===v}return T.charAt(T.length-1)!==v&&(T+=v),y.indexOf(T)===0}function $(y){return y>=r.CharCode.A&&y<=r.CharCode.Z||y>=r.CharCode.a&&y<=r.CharCode.z}function n(y,T){return k.$c&&y.endsWith(":")&&(y+=a.sep),(0,a.$lc)(y)||(y=(0,a.$mc)(T,y)),y=(0,a.$kc)(y),o(y)}function o(y){return k.$c?(y=(0,A.$pf)(y,a.sep),y.endsWith(":")&&(y+=a.sep)):(y=(0,A.$pf)(y,a.sep),y||(y=a.sep)),y}function t(y){const T=(0,a.$kc)(y);return k.$c?y.length>3?!1:i(T)&&(y.length===2||T.charCodeAt(2)===r.CharCode.Backslash):T===a.$jc.sep}function i(y,T=k.$c){return T?$(y.charCodeAt(0))&&y.charCodeAt(1)===r.CharCode.Colon:!1}function s(y,T=k.$c){return i(y,T)?y[0]:void 0}function d(y,T,C){return T.length>y.length?-1:y===T?0:(C&&(y=y.toLowerCase(),T=T.toLowerCase()),y.indexOf(T))}function u(y){const T=y.split(":");let C,v,f;for(const N of T){const F=Number(N);(0,O.$kg)(F)?v===void 0?v=F:f===void 0&&(f=F):C=C?[C,N].join(":"):N}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:v!==void 0?v:void 0,column:f!==void 0?f:v!==void 0?1:void 0}}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,T,C=8){let v="";for(let N=0;N<C;N++){let F;N===0&&k.$c&&!T&&(C===3||C===4)?F=E:F=b,v+=F.charAt(Math.floor(Math.random()*F.length))}let f;return T?f=`${T}-${v}`:f=v,y?(0,a.$mc)(y,f):f}}),define(Se[137],De([1,0,27,29,179,13]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.FuzzyScore=e.$Ik=e.$Hk=void 0,e.or=O,e.$Jk=p,e.$Kk=c,e.$Lk=h,e.$Mk=D,e.$Nk=y,e.$Ok=F,e.$Pk=j,e.$Qk=z,e.$Rk=M,e.$Sk=ue,e.$Uk=le,e.$Vk=me,e.$Wk=we,A=Ue(A);function O(...ke){return function(Ie,Ce){for(let U=0,V=ke.length;U<V;U++){const X=ke[U](Ie,Ce);if(X)return X}return null}}e.$Hk=R.bind(void 0,!1),e.$Ik=R.bind(void 0,!0);function R(ke,Ie,Ce){if(!Ce||Ce.length<Ie.length)return null;let U;return ke?U=A.$If(Ce,Ie):U=Ce.indexOf(Ie)===0,U?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function p(ke,Ie){const Ce=Ie.toLowerCase().indexOf(ke.toLowerCase());return Ce===-1?null:[{start:Ce,end:Ce+ke.length}]}function c(ke,Ie){return I(ke.toLowerCase(),Ie.toLowerCase(),0,0)}function I(ke,Ie,Ce,U){if(Ce===ke.length)return[];if(U===Ie.length)return null;if(ke[Ce]===Ie[U]){let V=null;return(V=I(ke,Ie,Ce+1,U+1))?t({start:U,end:U+1},V):null}return I(ke,Ie,Ce,U+1)}function S(ke){return r.CharCode.a<=ke&&ke<=r.CharCode.z}function h(ke){return r.CharCode.A<=ke&&ke<=r.CharCode.Z}function P(ke){return r.CharCode.Digit0<=ke&&ke<=r.CharCode.Digit9}function w(ke){return ke===r.CharCode.Space||ke===r.CharCode.Tab||ke===r.CharCode.LineFeed||ke===r.CharCode.CarriageReturn}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>l.add(ke.charCodeAt(0)));function m(ke){return w(ke)||l.has(ke)}function g(ke,Ie){return ke===Ie||m(ke)&&m(Ie)}const $=new Map;function n(ke){if($.has(ke))return $.get(ke);let Ie;const Ce=(0,k.$Fk)(ke);return Ce&&(Ie=Ce),$.set(ke,Ie),Ie}function o(ke){return S(ke)||h(ke)||P(ke)}function t(ke,Ie){return Ie.length===0?Ie=[ke]:ke.end===Ie[0].start?Ie[0].start=ke.start:Ie.unshift(ke),Ie}function i(ke,Ie){for(let Ce=Ie;Ce<ke.length;Ce++){const U=ke.charCodeAt(Ce);if(h(U)||P(U)||Ce>0&&!o(ke.charCodeAt(Ce-1)))return Ce}return ke.length}function s(ke,Ie,Ce,U){if(Ce===ke.length)return[];if(U===Ie.length)return null;if(ke[Ce]!==Ie[U].toLowerCase())return null;{let V=null,X=U+1;for(V=s(ke,Ie,Ce+1,U+1);!V&&(X=i(Ie,X))<Ie.length;)V=s(ke,Ie,Ce+1,X),X++;return V===null?null:t({start:U,end:U+1},V)}}function d(ke){let Ie=0,Ce=0,U=0,V=0,X=0;for(let Ge=0;Ge<ke.length;Ge++)X=ke.charCodeAt(Ge),h(X)&&Ie++,S(X)&&Ce++,o(X)&&U++,P(X)&&V++;const x=Ie/ke.length,de=Ce/ke.length,ve=U/ke.length,Fe=V/ke.length;return{upperPercent:x,lowerPercent:de,alphaPercent:ve,numericPercent:Fe}}function u(ke){const{upperPercent:Ie,lowerPercent:Ce}=ke;return Ce===0&&Ie>.6}function b(ke){const{upperPercent:Ie,lowerPercent:Ce,alphaPercent:U,numericPercent:V}=ke;return Ce>.2&&Ie<.8&&U>.6&&V<.2}function E(ke){let Ie=0,Ce=0,U=0,V=0;for(let X=0;X<ke.length;X++)U=ke.charCodeAt(X),h(U)&&Ie++,S(U)&&Ce++,w(U)&&V++;return(Ie===0||Ce===0)&&V===0?ke.length<=30:Ie<=5}function D(ke,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!E(ke))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Ce=d(Ie);if(!b(Ce)){if(!u(Ce))return null;Ie=Ie.toLowerCase()}let U=null,V=0;for(ke=ke.toLowerCase();V<Ie.length&&(U=s(ke,Ie,0,V))===null;)V=i(Ie,V+1);return U}function y(ke,Ie,Ce=!1){if(!Ie||Ie.length===0)return null;let U=null,V=0;for(ke=ke.toLowerCase(),Ie=Ie.toLowerCase();V<Ie.length&&(U=T(ke,Ie,0,V,Ce),U===null);)V=C(Ie,V+1);return U}function T(ke,Ie,Ce,U,V){let X=0;if(Ce===ke.length)return[];if(U===Ie.length)return null;if(!g(ke.charCodeAt(Ce),Ie.charCodeAt(U))){const ve=n(ke.charCodeAt(Ce));if(!ve)return null;for(let Fe=0;Fe<ve.length;Fe++)if(!g(ve[Fe],Ie.charCodeAt(U+Fe)))return null;X+=ve.length-1}let x=null,de=U+X+1;if(x=T(ke,Ie,Ce+1,de,V),!V)for(;!x&&(de=C(Ie,de))<Ie.length;)x=T(ke,Ie,Ce+1,de,V),de++;if(!x)return null;if(ke.charCodeAt(Ce)!==Ie.charCodeAt(U)){const ve=n(ke.charCodeAt(Ce));if(!ve)return x;for(let Fe=0;Fe<ve.length;Fe++)if(ve[Fe]!==Ie.charCodeAt(U+Fe))return x}return t({start:U,end:U+X+1},x)}function C(ke,Ie){for(let Ce=Ie;Ce<ke.length;Ce++)if(m(ke.charCodeAt(Ce))||Ce>0&&m(ke.charCodeAt(Ce-1)))return Ce;return ke.length}const v=O(e.$Ik,D,p),f=O(e.$Ik,D,c),N=new a.$Gc(1e4);function F(ke,Ie,Ce=!1){if(typeof ke!="string"||typeof Ie!="string")return null;let U=N.get(ke);U||(U=new RegExp(A.$qf(ke),"i"),N.set(ke,U));const V=U.exec(Ie);return V?[{start:V.index,end:V.index+V[0].length}]:Ce?f(ke,Ie):v(ke,Ie)}function j(ke,Ie){const Ce=le(ke,ke.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ce?M(Ce):null}function z(ke,Ie,Ce,U,V,X){const x=Math.min(13,ke.length);for(;Ce<x;Ce++){const de=le(ke,Ie,Ce,U,V,X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,X]}function M(ke){if(typeof ke>"u")return[];const Ie=[],Ce=ke[1];for(let U=ke.length-1;U>1;U--){const V=ke[U]+Ce,X=Ie[Ie.length-1];X&&X.end===V?X.end=V+1:Ie.push({start:V,end:V+1})}return Ie}const L=128;function B(){const ke=[],Ie=[];for(let Ce=0;Ce<=L;Ce++)Ie[Ce]=0;for(let Ce=0;Ce<=L;Ce++)ke.push(Ie.slice(0));return ke}function W(ke){const Ie=[];for(let Ce=0;Ce<=ke;Ce++)Ie[Ce]=0;return Ie}const ae=W(2*L),q=W(2*L),K=B(),ee=B(),re=B(),ge=!1;function Z(ke,Ie,Ce,U,V){function X(de,ve,Fe=" "){for(;de.length<ve;)de=Fe+de;return de}let x=` |   |${U.split("").map(de=>X(de,3)).join("|")}
`;for(let de=0;de<=Ce;de++)de===0?x+=" |":x+=`${Ie[de-1]}|`,x+=ke[de].slice(0,V+1).map(ve=>X(ve.toString(),3)).join("|")+`
`;return x}function $e(ke,Ie,Ce,U){ke=ke.substr(Ie),Ce=Ce.substr(U),console.log(Z(ee,ke,ke.length,Ce,Ce.length)),console.log(Z(re,ke,ke.length,Ce,Ce.length)),console.log(Z(K,ke,ke.length,Ce,Ce.length))}function fe(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;const Ce=ke.codePointAt(Ie);switch(Ce){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!A.$1f(Ce)}}function oe(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;switch(ke.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function H(ke,Ie,Ce){return Ie[ke]!==Ce[ke]}function ue(ke,Ie,Ce,U,V,X,x=!1){for(;Ie<Ce&&V<X;)ke[Ie]===U[V]&&(x&&(ae[Ie]=V),Ie+=1),V+=1;return Ie===Ce}var te;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(te||(te={}));var _;(function(ke){ke.Default=[-100,0];function Ie(Ce){return!Ce||Ce.length===2&&Ce[0]===-100&&Ce[1]===0}ke.isDefault=Ie})(_||(e.FuzzyScore=_={}));class ne{constructor(Ie,Ce){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Ce}}e.$Tk=ne,ne.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function le(ke,Ie,Ce,U,V,X,x=ne.default){const de=ke.length>L?L:ke.length,ve=U.length>L?L:U.length;if(Ce>=de||X>=ve||de-Ce>ve-X||!ue(Ie,Ce,de,V,X,ve,!0))return;J(de,ve,Ce,X,Ie,V);let Fe=1,Ge=1,Xe=Ce,Qe=X;const nt=[!1];for(Fe=1,Xe=Ce;Xe<de;Fe++,Xe++){const ft=ae[Xe],at=q[Xe],dt=Xe+1<de?q[Xe+1]:ve;for(Ge=ft-X+1,Qe=ft;Qe<dt;Ge++,Qe++){let Pe=Number.MIN_SAFE_INTEGER,ze=!1;Qe<=at&&(Pe=ce(ke,Ie,Xe,Ce,U,V,Qe,ve,X,K[Fe-1][Ge-1]===0,nt));let Re=0;Pe!==Number.MAX_SAFE_INTEGER&&(ze=!0,Re=Pe+ee[Fe-1][Ge-1]);const Ne=Qe>ft,he=Ne?ee[Fe][Ge-1]+(K[Fe][Ge-1]>0?-5:0):0,Y=Qe>ft+1&&K[Fe][Ge-1]>0,Ae=Y?ee[Fe][Ge-2]+(K[Fe][Ge-2]>0?-5:0):0;if(Y&&(!Ne||Ae>=he)&&(!ze||Ae>=Re))ee[Fe][Ge]=Ae,re[Fe][Ge]=te.LeftLeft,K[Fe][Ge]=0;else if(Ne&&(!ze||he>=Re))ee[Fe][Ge]=he,re[Fe][Ge]=te.Left,K[Fe][Ge]=0;else if(ze)ee[Fe][Ge]=Re,re[Fe][Ge]=te.Diag,K[Fe][Ge]=K[Fe-1][Ge-1]+1;else throw new Error("not possible")}}if(ge&&$e(ke,Ce,U,X),!nt[0]&&!x.firstMatchCanBeWeak)return;Fe--,Ge--;const ct=[ee[Fe][Ge],X];let rt=0,lt=0;for(;Fe>=1;){let ft=Ge;do{const at=re[Fe][ft];if(at===te.LeftLeft)ft=ft-2;else if(at===te.Left)ft=ft-1;else break}while(ft>=1);rt>1&&Ie[Ce+Fe-1]===V[X+Ge-1]&&!H(ft+X-1,U,V)&&rt+1>K[Fe][ft]&&(ft=Ge),ft===Ge?rt++:rt=1,lt||(lt=ft),Fe--,Ge=ft-1,ct.push(Ge)}ve-X===de&&x.boostFullMatch&&(ct[0]+=2);const bt=lt-de;return ct[0]-=bt,ct}function J(ke,Ie,Ce,U,V,X){let x=ke-1,de=Ie-1;for(;x>=Ce&&de>=U;)V[x]===X[de]&&(q[x]=de,x--),de--}function ce(ke,Ie,Ce,U,V,X,x,de,ve,Fe,Ge){if(Ie[Ce]!==X[x])return Number.MIN_SAFE_INTEGER;let Xe=1,Qe=!1;return x===Ce-U?Xe=ke[Ce]===V[x]?7:5:H(x,V,X)&&(x===0||!H(x-1,V,X))?(Xe=ke[Ce]===V[x]?7:5,Qe=!0):fe(X,x)&&(x===0||!fe(X,x-1))?Xe=5:(fe(X,x-1)||oe(X,x-1))&&(Xe=5,Qe=!0),Xe>1&&Ce===U&&(Ge[0]=!0),Qe||(Qe=H(x,V,X)||fe(X,x-1)||oe(X,x-1)),Ce===U?x>ve&&(Xe-=Qe?3:5):Fe?Xe+=Qe?2:0:Xe+=Qe?0:1,x+1===de&&(Xe-=Qe?3:5),Xe}function me(ke,Ie,Ce,U,V,X,x){return Me(ke,Ie,Ce,U,V,X,!0,x)}function we(ke,Ie,Ce,U,V,X,x){return Me(ke,Ie,Ce,U,V,X,!1,x)}function Me(ke,Ie,Ce,U,V,X,x,de){let ve=le(ke,Ie,Ce,U,V,X,de);if(ve&&!x)return ve;if(ke.length>=3){const Fe=Math.min(7,ke.length-1);for(let Ge=Ce+1;Ge<Fe;Ge++){const Xe=qe(ke,Ge);if(Xe){const Qe=le(Xe,Xe.toLowerCase(),Ce,U,V,X,de);Qe&&(Qe[0]-=3,(!ve||Qe[0]>ve[0])&&(ve=Qe))}}}return ve}function qe(ke,Ie){if(Ie+1>=ke.length)return;const Ce=ke[Ie],U=ke[Ie+1];if(Ce!==U)return ke.slice(0,Ie)+U+Ce+ke.slice(Ie+2)}}),define(Se[60],De([1,0,13]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$yj=void 0,e.$uj=a,e.$vj=k,e.$wj=A,e.$xj=R,e.$zj=l,r=Ue(r);function a(g){return k(g,0)}function k(g,$){switch(typeof g){case"object":return g===null?A(349,$):Array.isArray(g)?p(g,$):c(g,$);case"string":return R(g,$);case"boolean":return O(g,$);case"number":return A(g,$);case"undefined":return A(937,$);default:return A(617,$)}}function A(g,$){return($<<5)-$+g|0}function O(g,$){return A(g?433:863,$)}function R(g,$){$=A(149417,$);for(let n=0,o=g.length;n<o;n++)$=A(g.charCodeAt(n),$);return $}function p(g,$){return $=A(104579,$),g.reduce((n,o)=>k(o,n),$)}function c(g,$){return $=A(181387,$),Object.keys(g).sort().reduce((n,o)=>(n=R(o,n),k(g[o],n)),$)}class I{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=k($,this.g),this.g}}e.$yj=I;var S;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function h(g,$,n=32){const o=n-$,t=~((1<<o)-1);return(g<<$|(t&g)>>>o)>>>0}function P(g,$=0,n=g.byteLength,o=0){for(let t=0;t<n;t++)g[$+t]=o}function w(g,$,n="0"){for(;g.length<$;)g=n+g;return g}function l(g,$=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(n=>n.toString(16).padStart(2,"0")).join(""):w((g>>>0).toString(16),$/4)}class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(S.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const n=$.length;if(n===0)return;const o=this.p;let t=this.r,i=this.u,s,d;for(i!==0?(s=i,d=-1,i=0):(s=$.charCodeAt(0),d=0);;){let u=s;if(r.$Lf(s))if(d+1<n){const b=$.charCodeAt(d+1);r.$Mf(b)?(d++,u=r.$Nf(s,b)):u=S.UNICODE_REPLACEMENT}else{i=s;break}else r.$Mf(s)&&(u=S.UNICODE_REPLACEMENT);if(t=this.w(o,t,u),d++,d<n)s=$.charCodeAt(d);else break}this.r=t,this.u=i}w($,n,o){return o<128?$[n++]=o:o<2048?($[n++]=192|(o&1984)>>>6,$[n++]=128|(o&63)>>>0):o<65536?($[n++]=224|(o&61440)>>>12,$[n++]=128|(o&4032)>>>6,$[n++]=128|(o&63)>>>0):($[n++]=240|(o&1835008)>>>18,$[n++]=128|(o&258048)>>>12,$[n++]=128|(o&4032)>>>6,$[n++]=128|(o&63)>>>0),n>=S.BLOCK_SIZE&&(this.y(),n-=S.BLOCK_SIZE,this.t+=S.BLOCK_SIZE,$[0]=$[S.BLOCK_SIZE+0],$[1]=$[S.BLOCK_SIZE+1],$[2]=$[S.BLOCK_SIZE+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,S.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,P(this.p,this.r),this.r>56&&(this.y(),P(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=m.g,n=this.q;for(let D=0;D<64;D+=4)$.setUint32(D,n.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)$.setUint32(D,h($.getUint32(D-12,!1)^$.getUint32(D-32,!1)^$.getUint32(D-56,!1)^$.getUint32(D-64,!1),1),!1);let o=this.h,t=this.l,i=this.m,s=this.n,d=this.o,u,b,E;for(let D=0;D<80;D++)D<20?(u=t&i|~t&s,b=1518500249):D<40?(u=t^i^s,b=1859775393):D<60?(u=t&i|t&s|i&s,b=2400959708):(u=t^i^s,b=3395469782),E=h(o,5)+u+d+b+$.getUint32(D*4,!1)&4294967295,d=s,s=i,i=h(t,30),t=o,o=E;this.h=this.h+o&4294967295,this.l=this.l+t&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}e.$Aj=m,m.g=new DataView(new ArrayBuffer(320))}),define(Se[138],De([1,0,27,136,137,60,17,11,13]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=S,e.$Nr=g,e.$Or=u,e.$Pr=v,e.$Qr=M,e.$Rr=B;const c=0,I=[c,[]];function S(W,ae,q,K){if(!W||!ae)return I;const ee=W.length,re=ae.length;if(ee<re)return I;const ge=W.toLowerCase();return h(ae,q,re,W,ge,ee,K)}function h(W,ae,q,K,ee,re,ge){const Z=[],$e=[];for(let ue=0;ue<q;ue++){const te=ue*re,_=te-re,ne=ue>0,le=W[ue],J=ae[ue];for(let ce=0;ce<re;ce++){const me=ce>0,we=te+ce,Me=we-1,qe=_+ce-1,ke=me?Z[Me]:0,Ie=ne&&me?Z[qe]:0,Ce=ne&&me?$e[qe]:0;let U;!Ie&&ne?U=0:U=P(le,J,K,ee,ce,Ce),U&&Ie+U>=ke&&(ge||ne||ee.startsWith(ae,ce))?($e[we]=Ce+1,Z[we]=Ie+U):($e[we]=c,Z[we]=ke)}}const fe=[];let oe=q-1,H=re-1;for(;oe>=0&&H>=0;){const ue=oe*re+H;$e[ue]===c||(fe.push(H),oe--),H--}return[Z[q*re-1],fe.reverse()]}function P(W,ae,q,K,ee,re){let ge=0;if(!w(ae,K[ee]))return ge;if(ge+=1,re>0&&(ge+=re*5),W===q[ee]&&(ge+=1),ee===0)ge+=8;else{const Z=l(q.charCodeAt(ee-1));Z?ge+=Z:(0,k.$Lk)(q.charCodeAt(ee))&&re===0&&(ge+=2)}return ge}function w(W,ae){return W===ae?!0:W==="/"||W==="\\"?ae==="/"||ae==="\\":!1}function l(W){switch(W){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const m=[void 0,[]];function g(W,ae,q=0,K=0){const ee=ae;return ee.values&&ee.values.length>1?$(W,ee.values,q,K):n(W,ae,q,K)}function $(W,ae,q,K){let ee=0;const re=[];for(const ge of ae){const[Z,$e]=n(W,ge,q,K);if(typeof Z!="number")return m;ee+=Z,re.push(...$e)}return[ee,T(re)]}function n(W,ae,q,K){const ee=(0,k.$Uk)(ae.original,ae.originalLowercase,q,W,W.toLowerCase(),K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ee?[ee[0],(0,k.$Rk)(ee)]:m}const o=Object.freeze({score:0}),t=1<<18,i=1<<17,s=65536;function d(W,ae,q,K){const ee=K.values?K.values:[K];return(0,A.$uj)({[K.normalized]:{values:ee.map(ge=>({value:ge.normalized,expectContiguousMatch:ge.expectContiguousMatch})),label:W,description:ae,allowNonContiguousMatches:q}})}function u(W,ae,q,K,ee){if(!W||!ae.normalized)return o;const re=K.getItemLabel(W);if(!re)return o;const ge=K.getItemDescription(W),Z=d(re,ge,q,ae),$e=ee[Z];if($e)return $e;const fe=b(re,ge,K.getItemPath(W),ae,q);return ee[Z]=fe,fe}function b(W,ae,q,K,ee){const re=!q||!K.containsPathSeparator;return q&&(R.$e?K.pathNormalized===q:(0,p.$Hf)(K.pathNormalized,q))?{score:t,labelMatch:[{start:0,end:W.length}],descriptionMatch:ae?[{start:0,end:ae.length}]:void 0}:K.values&&K.values.length>1?E(W,ae,q,K.values,re,ee):D(W,ae,q,K,re,ee)}function E(W,ae,q,K,ee,re){let ge=0;const Z=[],$e=[];for(const fe of K){const{score:oe,labelMatch:H,descriptionMatch:ue}=D(W,ae,q,fe,ee,re);if(oe===c)return o;ge+=oe,H&&Z.push(...H),ue&&$e.push(...ue)}return{score:ge,labelMatch:T(Z),descriptionMatch:T($e)}}function D(W,ae,q,K,ee,re){if(ee||!ae){const[ge,Z]=S(W,K.normalized,K.normalizedLowercase,re&&!K.expectContiguousMatch);if(ge){const $e=(0,k.$Ik)(K.normalized,W);let fe;if($e){fe=i;const oe=Math.round(K.normalized.length/W.length*100);fe+=oe}else fe=s;return{score:fe+ge,labelMatch:$e||y(Z)}}}if(ae){let ge=ae;q&&(ge=`${ae}${O.sep}`);const Z=ge.length,$e=`${ge}${W}`,[fe,oe]=S($e,K.normalized,K.normalizedLowercase,re&&!K.expectContiguousMatch);if(fe){const H=y(oe),ue=[],te=[];return H.forEach(_=>{_.start<Z&&_.end>Z?(ue.push({start:0,end:_.end-Z}),te.push({start:_.start,end:Z})):_.start>=Z?ue.push({start:_.start-Z,end:_.end-Z}):te.push(_)}),{score:fe,labelMatch:ue,descriptionMatch:te}}}return o}function y(W){const ae=[];if(!W)return ae;let q;for(const K of W)q&&q.end===K?q.end+=1:(q={start:K,end:K+1},ae.push(q));return ae}function T(W){const ae=W.sort((ee,re)=>ee.start-re.start),q=[];let K;for(const ee of ae)!K||!C(K,ee)?(K=ee,q.push(ee)):(K.start=Math.min(K.start,ee.start),K.end=Math.max(K.end,ee.end));return q}function C(W,ae){return!(W.end<ae.start||ae.end<W.start)}function v(W,ae,q,K,ee,re){const ge=u(W,q,K,ee,re),Z=u(ae,q,K,ee,re),$e=ge.score,fe=Z.score;if(($e===t||fe===t)&&$e!==fe)return $e===t?-1:1;if($e>s||fe>s){if($e!==fe)return $e>fe?-1:1;if($e<i&&fe<i){const le=N(ge.labelMatch,Z.labelMatch);if(le!==0)return le}const _=ee.getItemLabel(W)||"",ne=ee.getItemLabel(ae)||"";if(_.length!==ne.length)return _.length-ne.length}if($e!==fe)return $e>fe?-1:1;const oe=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0,H=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0;if(oe&&!H)return-1;if(H&&!oe)return 1;const ue=f(W,ge,ee),te=f(ae,Z,ee);return ue&&te&&ue!==te?te>ue?-1:1:F(W,ae,q,ee)}function f(W,ae,q){let K=-1,ee=-1;if(ae.descriptionMatch&&ae.descriptionMatch.length?K=ae.descriptionMatch[0].start:ae.labelMatch&&ae.labelMatch.length&&(K=ae.labelMatch[0].start),ae.labelMatch&&ae.labelMatch.length){if(ee=ae.labelMatch[ae.labelMatch.length-1].end,ae.descriptionMatch&&ae.descriptionMatch.length){const re=q.getItemDescription(W);re&&(ee+=re.length)}}else ae.descriptionMatch&&ae.descriptionMatch.length&&(ee=ae.descriptionMatch[ae.descriptionMatch.length-1].end);return ee-K}function N(W,ae){if(!W&&!ae||(!W||!W.length)&&(!ae||!ae.length))return 0;if(!ae||!ae.length)return-1;if(!W||!W.length)return 1;const q=W[0].start,ee=W[W.length-1].end-q,re=ae[0].start,Z=ae[ae.length-1].end-re;return ee===Z?0:Z<ee?1:-1}function F(W,ae,q,K){const ee=K.getItemLabel(W)||"",re=K.getItemLabel(ae)||"",ge=K.getItemDescription(W),Z=K.getItemDescription(ae),$e=ee.length+(ge?ge.length:0),fe=re.length+(Z?Z.length:0);if($e!==fe)return $e-fe;const oe=K.getItemPath(W),H=K.getItemPath(ae);return oe&&H&&oe.length!==H.length?oe.length-H.length:ee!==re?(0,a.$Kr)(ee,re,q.normalized):ge&&Z&&ge!==Z?(0,a.$Kr)(ge,Z,q.normalized):oe&&H&&oe!==H?(0,a.$Kr)(oe,H,q.normalized):0}function j(W){return W.startsWith('"')&&W.endsWith('"')}const z=" ";function M(W){typeof W!="string"&&(W="");const ae=W.toLowerCase(),{pathNormalized:q,normalized:K,normalizedLowercase:ee}=L(W),re=q.indexOf(O.sep)>=0,ge=j(W);let Z;const $e=W.split(z);if($e.length>1)for(const fe of $e){const oe=j(fe),{pathNormalized:H,normalized:ue,normalizedLowercase:te}=L(fe);ue&&(Z||(Z=[]),Z.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:H,normalized:ue,normalizedLowercase:te,expectContiguousMatch:oe}))}return{original:W,originalLowercase:ae,pathNormalized:q,normalized:K,normalizedLowercase:ee,values:Z,containsPathSeparator:re,expectContiguousMatch:ge}}function L(W){let ae;R.$c?ae=W.replace(/\//g,O.sep):ae=W.replace(/\\/g,O.sep);const q=(0,p.$rf)(ae).replace(/\s|"/g,"");return{pathNormalized:ae,normalized:q,normalizedLowercase:q.toLowerCase()}}function B(W){return Array.isArray(W)?M(W.map(ae=>ae.original).join(z)):M(W.original)}}),define(Se[139],De([1,0,137,13,50]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=p,e.$Yk=I,e.$Zk=h,e.$1k=P,e.$2k=l,e.$3k=m;const A="$(",O=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${O.source}`,"g");function p(g){return g.replace(R,($,n)=>n?$:`\\${$}`)}const c=new RegExp(`\\\\${O.source}`,"g");function I(g){return g.replace(c,$=>`\\${$}`)}const S=new RegExp(`(\\s)?(\\\\)?${O.source}(\\s)?`,"g");function h(g){return g.indexOf(A)===-1?g:g.replace(S,($,n,o,t)=>o?$:n||t||"")}function P(g){return g?g.replace(/\$\((.*?)\)/g,($,n)=>` ${n} `).trim():""}const w=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(g){w.lastIndex=0;let $="";const n=[];let o=0;for(;;){const t=w.lastIndex,i=w.exec(g),s=g.substring(t,i?.index);if(s.length>0){$+=s;for(let d=0;d<s.length;d++)n.push(o)}if(!i)break;o+=i[0].length}return{text:$,iconOffsets:n}}function m(g,$,n=!1){const{text:o,iconOffsets:t}=$;if(!t||t.length===0)return(0,r.$Ok)(g,o,n);const i=(0,a.$of)(o," "),s=o.length-i.length,d=(0,r.$Ok)(g,i,n);if(d)for(const u of d){const b=t[u.start+s]+s;u.start+=b,u.end+=b}return d}}),define(Se[45],De([1,0,13]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ue(r);var a;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(a||(a={})),function(k){const A="error",O="warning",R="warn",p="info",c="ignore";function I(h){return h?r.$Hf(A,h)?k.Error:r.$Hf(O,h)||r.$Hf(R,h)?k.Warning:r.$Hf(p,h)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function S(h){switch(h){case k.Error:return A;case k.Warning:return O;case k.Info:return p;default:return c}}k.toString=S}(a||(a={})),e.default=a}),define(Se[85],De([1,0,19,27,13]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class A{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const l=w.charCodeAt(0),m=this.b.charCodeAt(this.c);return l-m}value(){return this.b[this.c]}}e.$Ii=A;class O{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,k.$Bf)(w,this.b,0,w.length,this.c,this.d):(0,k.$Df)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=O;class R{constructor(w=!0,l=!0){this.f=w,this.g=l}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let l=w.length-1;l>=0;l--,this.c--){const m=this.b.charCodeAt(l);if(!(m===a.CharCode.Slash||this.f&&m===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const l=this.b.charCodeAt(this.e);if(l===a.CharCode.Slash||this.f&&l===a.CharCode.Backslash)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,k.$Bf)(w,this.b,0,w.length,this.d,this.e):(0,k.$Df)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=R;var p;(function(P){P[P.Scheme=1]="Scheme",P[P.Authority=2]="Authority",P[P.Path=3]="Path",P[P.Query=4]="Query",P[P.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(w,l){this.f=w,this.g=l,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new R(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(p.Path)),this.g(w)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===p.Scheme)return(0,k.$Cf)(w,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,k.$Cf)(w,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(w);if(this.d[this.e]===p.Query)return(0,k.$Af)(w,this.c.query);if(this.d[this.e]===p.Fragment)return(0,k.$Af)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Li=c;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(P){P[P.Left=-1]="Left",P[P.Mid=0]="Mid",P[P.Right=1]="Right"})(S||(S={}));class h{static forUris(w=()=>!1,l=()=>!1){return new h(new c(w,l))}static forPaths(w=!1){return new h(new R(void 0,!w))}static forStrings(){return new h(new A)}static forConfigKeys(){return new h(new O)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,l){if(l){const m=l.slice(0);(0,r.$Zb)(m);for(const g of m)this.set(g,w)}else{const m=w.slice(0);(0,r.$Zb)(m);for(const g of m)this.set(g[0],g[1])}}set(w,l){const m=this.b.reset(w);let g;this.c||(this.c=new I,this.c.segment=m.value());const $=[];for(g=this.c;;){const o=m.cmp(g.segment);if(o>0)g.left||(g.left=new I,g.left.segment=m.value()),$.push([S.Left,g]),g=g.left;else if(o<0)g.right||(g.right=new I,g.right.segment=m.value()),$.push([S.Right,g]),g=g.right;else if(m.hasNext())m.next(),g.mid||(g.mid=new I,g.mid.segment=m.value()),$.push([S.Mid,g]),g=g.mid;else break}const n=g.value;g.value=l,g.key=w;for(let o=$.length-1;o>=0;o--){const t=$[o][1];t.updateHeight();const i=t.balanceFactor();if(i<-1||i>1){const s=$[o][0],d=$[o+1][0];if(s===S.Right&&d===S.Right)$[o][1]=t.rotateLeft();else if(s===S.Left&&d===S.Left)$[o][1]=t.rotateRight();else if(s===S.Right&&d===S.Left)t.right=$[o+1][1]=$[o+1][1].rotateRight(),$[o][1]=t.rotateLeft();else if(s===S.Left&&d===S.Right)t.left=$[o+1][1]=$[o+1][1].rotateLeft(),$[o][1]=t.rotateRight();else throw new Error;if(o>0)switch($[o-1][0]){case S.Left:$[o-1][1].left=$[o][1];break;case S.Right:$[o-1][1].right=$[o][1];break;case S.Mid:$[o-1][1].mid=$[o][1];break}else this.c=$[0][1]}}return n}get(w){return this.d(w)?.value}d(w){const l=this.b.reset(w);let m=this.c;for(;m;){const g=l.cmp(m.segment);if(g>0)m=m.left;else if(g<0)m=m.right;else if(l.hasNext())l.next(),m=m.mid;else break}return m}has(w){const l=this.d(w);return!(l?.value===void 0&&l?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,l){const m=this.b.reset(w),g=[];let $=this.c;for(;$;){const n=m.cmp($.segment);if(n>0)g.push([S.Left,$]),$=$.left;else if(n<0)g.push([S.Right,$]),$=$.right;else if(m.hasNext())m.next(),g.push([S.Mid,$]),$=$.mid;else break}if($){if(l?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const n=this.f($.right);if(n.key){const{key:o,value:t,segment:i}=n;this.e(n.key,!1),$.key=o,$.value=t,$.segment=i}}else{const n=$.left??$.right;if(g.length>0){const[o,t]=g[g.length-1];switch(o){case S.Left:t.left=n;break;case S.Mid:t.mid=n;break;case S.Right:t.right=n;break}}else this.c=n}for(let n=g.length-1;n>=0;n--){const o=g[n][1];o.updateHeight();const t=o.balanceFactor();if(t>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),g[n][1]=o.rotateLeft()):t<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),g[n][1]=o.rotateRight()),n>0)switch(g[n-1][0]){case S.Left:g[n-1][1].left=g[n][1];break;case S.Right:g[n-1][1].right=g[n][1];break;case S.Mid:g[n-1][1].mid=g[n][1];break}else this.c=g[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const l=this.b.reset(w);let m=this.c,g;for(;m;){const $=l.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(l.hasNext())l.next(),g=m.value||g,m=m.mid;else break}return m&&m.value||g}findSuperstr(w){return this.g(w,!1)}g(w,l){const m=this.b.reset(w);let g=this.c;for(;g;){const $=m.cmp(g.segment);if($>0)g=g.left;else if($<0)g=g.right;else if(m.hasNext())m.next(),g=g.mid;else return g.mid?this.h(g.mid):l?g.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[l,m]of this)w(m,l)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const l=[];return this.j(w,l),l[Symbol.iterator]()}j(w,l){w&&(w.left&&this.j(w.left,l),w.value&&l.push([w.key,w.value]),w.mid&&this.j(w.mid,l),w.right&&this.j(w.right,l))}_isBalanced(){const w=l=>{if(!l)return!0;const m=l.balanceFactor();return m<-1||m>1?!1:w(l.left)&&w(l.right)};return w(this.c)}}e.$Mi=h}),define(Se[2],De([1,0,27,41,17,11]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$yc=m,e.$zc=i,k=Ue(k);const O=/^\w[\w\d+.-]*$/,R=/^\//,p=/^\/\//;function c(E,D){if(!E.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${E.authority}", path: "${E.path}", query: "${E.query}", fragment: "${E.fragment}"}`);if(E.scheme&&!O.test(E.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(E.path){if(E.authority){if(!R.test(E.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(E.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(E,D){return!E&&!D?"file":E}function S(E,D){switch(E){case"https":case"http":case"file":D?D[0]!==P&&(D=P+D):D=P;break}return D}const h="",P="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(D){return D instanceof l?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,y,T,C,v,f=!1){typeof D=="object"?(this.scheme=D.scheme||h,this.authority=D.authority||h,this.path=D.path||h,this.query=D.query||h,this.fragment=D.fragment||h):(this.scheme=I(D,f),this.authority=y||h,this.path=S(this.scheme,T||h),this.query=C||h,this.fragment=v||h,c(this,f))}get fsPath(){return i(this,!1)}with(D){if(!D)return this;let{scheme:y,authority:T,path:C,query:v,fragment:f}=D;return y===void 0?y=this.scheme:y===null&&(y=h),T===void 0?T=this.authority:T===null&&(T=h),C===void 0?C=this.path:C===null&&(C=h),v===void 0?v=this.query:v===null&&(v=h),f===void 0?f=this.fragment:f===null&&(f=h),y===this.scheme&&T===this.authority&&C===this.path&&v===this.query&&f===this.fragment?this:new $(y,T,C,v,f)}static parse(D,y=!1){const T=w.exec(D);return T?new $(T[2]||h,b(T[4]||h),b(T[5]||h),b(T[7]||h),b(T[9]||h),y):new $(h,h,h,h,h)}static file(D){let y=h;if(A.$c&&(D=D.replace(/\\/g,P)),D[0]===P&&D[1]===P){const T=D.indexOf(P,2);T===-1?(y=D.substring(2),D=P):(y=D.substring(2,T),D=D.substring(T)||P)}return new $("file",y,D,h,h)}static from(D,y){return new $(D.scheme,D.authority,D.path,D.query,D.fragment,y)}static joinPath(D,...y){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let T;return A.$c&&D.scheme==="file"?T=l.file(k.$ic.join(i(D,!0),...y)).path:T=k.$jc.join(D.path,...y),D.with({path:T})}toString(D=!1){return s(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof l)return D;{const y=new $(D);return y._formatted=D.external??null,y._fsPath=D._sep===g?D.fsPath??null:null,y}}else return D}}e.URI=l;function m(E){return!E||typeof E!="object"?!1:typeof E.scheme=="string"&&(typeof E.authority=="string"||typeof E.authority>"u")&&(typeof E.path=="string"||typeof E.path>"u")&&(typeof E.query=="string"||typeof E.query>"u")&&(typeof E.fragment=="string"||typeof E.fragment>"u")}const g=A.$c?1:void 0;class $ extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(D=!1){return D?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const D={$mid:a.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=g),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function o(E,D,y){let T,C=-1;for(let v=0;v<E.length;v++){const f=E.charCodeAt(v);if(f>=r.CharCode.a&&f<=r.CharCode.z||f>=r.CharCode.A&&f<=r.CharCode.Z||f>=r.CharCode.Digit0&&f<=r.CharCode.Digit9||f===r.CharCode.Dash||f===r.CharCode.Period||f===r.CharCode.Underline||f===r.CharCode.Tilde||D&&f===r.CharCode.Slash||y&&f===r.CharCode.OpenSquareBracket||y&&f===r.CharCode.CloseSquareBracket||y&&f===r.CharCode.Colon)C!==-1&&(T+=encodeURIComponent(E.substring(C,v)),C=-1),T!==void 0&&(T+=E.charAt(v));else{T===void 0&&(T=E.substr(0,v));const N=n[f];N!==void 0?(C!==-1&&(T+=encodeURIComponent(E.substring(C,v)),C=-1),T+=N):C===-1&&(C=v)}}return C!==-1&&(T+=encodeURIComponent(E.substring(C))),T!==void 0?T:E}function t(E){let D;for(let y=0;y<E.length;y++){const T=E.charCodeAt(y);T===r.CharCode.Hash||T===r.CharCode.QuestionMark?(D===void 0&&(D=E.substr(0,y)),D+=n[T]):D!==void 0&&(D+=E[y])}return D!==void 0?D:E}function i(E,D){let y;return E.authority&&E.path.length>1&&E.scheme==="file"?y=`//${E.authority}${E.path}`:E.path.charCodeAt(0)===r.CharCode.Slash&&(E.path.charCodeAt(1)>=r.CharCode.A&&E.path.charCodeAt(1)<=r.CharCode.Z||E.path.charCodeAt(1)>=r.CharCode.a&&E.path.charCodeAt(1)<=r.CharCode.z)&&E.path.charCodeAt(2)===r.CharCode.Colon?D?y=E.path.substr(1):y=E.path[1].toLowerCase()+E.path.substr(2):y=E.path,A.$c&&(y=y.replace(/\//g,"\\")),y}function s(E,D){const y=D?t:o;let T="",{scheme:C,authority:v,path:f,query:N,fragment:F}=E;if(C&&(T+=C,T+=":"),(v||C==="file")&&(T+=P,T+=P),v){let j=v.indexOf("@");if(j!==-1){const z=v.substr(0,j);v=v.substr(j+1),j=z.lastIndexOf(":"),j===-1?T+=y(z,!1,!1):(T+=y(z.substr(0,j),!1,!1),T+=":",T+=y(z.substr(j+1),!1,!0)),T+="@"}v=v.toLowerCase(),j=v.lastIndexOf(":"),j===-1?T+=y(v,!1,!0):(T+=y(v.substr(0,j),!1,!0),T+=v.substr(j))}if(f){if(f.length>=3&&f.charCodeAt(0)===r.CharCode.Slash&&f.charCodeAt(2)===r.CharCode.Colon){const j=f.charCodeAt(1);j>=r.CharCode.A&&j<=r.CharCode.Z&&(f=`/${String.fromCharCode(j+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===r.CharCode.Colon){const j=f.charCodeAt(0);j>=r.CharCode.A&&j<=r.CharCode.Z&&(f=`${String.fromCharCode(j+32)}:${f.substr(2)}`)}T+=y(f,!0,!1)}return N&&(T+="?",T+=y(N,!1,!1)),F&&(T+="#",T+=D?F:o(F,!1,!1)),T}function d(E){try{return decodeURIComponent(E)}catch{return E.length>3?E.substr(0,3)+d(E.substr(3)):E}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(E){return E.match(u)?E.replace(u,D=>d(D)):E}}),define(Se[188],De([1,0,2]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=a,e.$dr=k,e.$er=A,e.log=R;function a(c){const I=c;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function k(c){const I=[];let S;try{const h=JSON.parse(c.arguments),P=h[h.length-1];P&&P.__$stack&&(h.pop(),S=P.__$stack),I.push(...h)}catch{I.push("Unable to log remote console arguments",c.arguments)}return{args:I,stack:S}}function A(c){if(typeof c!="string")return A(k(c).stack);const I=c;if(I){const S=O(I),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(h&&h.length===4)return{uri:r.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function O(c){if(!c)return c;const I=c.indexOf(`
`);return I===-1?c:c.substring(0,I)}function R(c,I){const{args:S,stack:h}=k(c),P=typeof S[0]=="string"&&S.length===1;let w=O(h);w&&(w=`(${w.trim()})`);let l=[];if(typeof S[0]=="string"?w&&P?l=[`%c[${I}] %c${S[0]} %c${w}`,p("blue"),p(""),p("grey")]:l=[`%c[${I}] %c${S[0]}`,p("blue"),p(""),...S.slice(1)]:l=[`%c[${I}]%`,p("blue"),...S],w&&!P&&l.push(w),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,l)}function p(c){return`color: ${c}`}}),define(Se[55],De([1,0,22,2,41]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=A,e.$ci=O,e.$di=p;function A(c){return JSON.stringify(c,R)}function O(c){let I=JSON.parse(c);return I=p(I),I}function R(c,I){return I instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(c,I=0){if(!c||I>200)return c;if(typeof c=="object"){switch(c.$mid){case k.MarshalledId.Uri:return a.URI.revive(c);case k.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case k.MarshalledId.Date:return new Date(c.source)}if(c instanceof r.$Pe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let S=0;S<c.length;++S)c[S]=p(c[S],I+1);else for(const S in c)Object.hasOwnProperty.call(c,S)&&(c[S]=p(c[S],I+1))}return c}}),define(Se[15],De([1,0,14,11,13,2,17]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=p,e.$Qg=c,e.$Ug=S,r=Ue(r),a=Ue(a),O=Ue(O);var R;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",w.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(R||(e.Schemas=R={}));function p(w,l){return A.URI.isUri(w)?(0,k.$Hf)(w.scheme,l):(0,k.$If)(w,l+":")}function c(w,...l){return l.some(m=>p(w,m))}e.$Rg="vscode-tkn",e.$Sg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l,m){this.f=S(l,m)}getServerRootPath(){return this.f}get g(){return O.$jc.join(this.f,R.vscodeRemoteResource)}set(l,m,g){this.a[l]=m,this.b[l]=g}setConnectionToken(l,m){this.c[l]=m}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(t){return r.$3(t),l}const m=l.authority;let g=this.a[m];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const $=this.b[m],n=this.c[m];let o=`path=${encodeURIComponent(l.path)}`;return typeof n=="string"&&(o+=`&${e.$Sg}=${encodeURIComponent(n)}`),A.URI.from({scheme:a.$i?this.d:R.vscodeRemoteResource,authority:`${g}:${$}`,path:a.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:o})}}e.$Tg=new I;function S(w,l){return O.$jc.join(l??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class h{asBrowserUri(l){const m=this.b(l,ie);return this.uriToBrowserUri(m)}uriToBrowserUri(l){return l.scheme===R.vscodeRemote?e.$Tg.rewrite(l):l.scheme===R.file&&(a.$g||a.$k===`${R.vscodeFileResource}://${h.a}`)?l.with({scheme:R.vscodeFileResource,authority:l.authority||h.a,query:null,fragment:null}):l}asFileUri(l){const m=this.b(l,ie);return this.uriToFileUri(m)}uriToFileUri(l){return l.scheme===R.vscodeFileResource?l.with({scheme:R.file,authority:l.authority!==h.a?l.authority:null,query:null,fragment:null}):l}b(l,m){return A.URI.isUri(l)?l:A.URI.parse(m.toUrl(l))}}h.a=e.$Zg,e.$1g=new h;var P;(function(w){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(l.get("3"));const m="vscode-coi";function g(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:A.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const t=o?.get(m);if(t)return l.get(t)}w.getHeadersFromQuery=g;function $(n,o,t){if(!globalThis.crossOriginIsolated)return;const i=o&&t?"3":t?"2":"1";n instanceof URLSearchParams?n.set(m,i):n[m]=i}w.addSearchParam=$})(P||(e.COI=P={}))}),define(Se[189],De([1,0,175,15,11,2]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tE=I,k=Ue(k);class O{constructor(h,P,w){this.id=h,this.dependencies=P,this.callback=w}}class R{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,P,w)=>{typeof h!="string"&&(w=P,P=h,h=null),(typeof P!="object"||!Array.isArray(P))&&(w=P,P=null),this.c.push(new O(h,P,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const P=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!P)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(P.dependencies)&&P.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${P.dependencies.join(", ")}`);return typeof P.callback=="function"?P.callback([]):P.callback}h(h){return new Promise((P,w)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const m=()=>{l.removeEventListener("load",g),l.removeEventListener("error",$)},g=n=>{m(),P(this.c.pop())},$=n=>{m(),w(n)};l.addEventListener("load",g),l.addEventListener("error",$),this.f&&(h=this.f.createScriptURL(h)),l.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(h){return new Promise((P,w)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),P(this.c.pop())}catch(l){w(l)}})}async j(h){try{const P=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(h).fsPath,g=P.readFileSync(m).toString(),$=l.wrap(g.replace(/^#!.*/,""));return new w.Script($).runInThisContext().apply(),this.c.pop()}catch(P){throw P}}}R.INSTANCE=new R;const p=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function I(S,h,P){if(r.$V){P===void 0&&(P=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[S]&&(S=c[S]);const w=`${S}/${h}`;if(p.has(w))return p.get(w);let l;if(/^\w[\w\d+.-]*:\/\//.test(w))l=w;else{const n=`${P&&!k.$i?a.$Xg:a.$Wg}/${w}`;l=a.$1g.asBrowserUri(n).toString(!0)}const m=R.INSTANCE.load(l);return p.set(w,m),m}else return await new Promise((w,l)=>{ie([S],w,l)}).then(Ue)}}),define(Se[23],De([1,0,27,32,15,17,11,13,2]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=c,e.$qh=S,e.$rh=P,a=Ue(a),A=Ue(A);function c(w){return(0,p.$zc)(w,!0)}class I{constructor(l){this.a=l}compare(l,m,g=!1){return l===m?0:(0,R.$Af)(this.getComparisonKey(l,g),this.getComparisonKey(m,g))}isEqual(l,m,g=!1){return l===m?!0:!l||!m?!1:this.getComparisonKey(l,g)===this.getComparisonKey(m,g)}getComparisonKey(l,m=!1){return l.with({path:this.a(l)?l.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(l){return this.a(l)}isEqualOrParent(l,m,g=!1){if(l.scheme===m.scheme){if(l.scheme===k.Schemas.file)return a.$Fg(c(l),c(m),this.a(l))&&l.query===m.query&&(g||l.fragment===m.fragment);if((0,e.$mh)(l.authority,m.authority))return a.$Fg(l.path,m.path,this.a(l),"/")&&l.query===m.query&&(g||l.fragment===m.fragment)}return!1}joinPath(l,...m){return p.URI.joinPath(l,...m)}basenameOrAuthority(l){return(0,e.$eh)(l)||l.authority}basename(l){return A.$jc.basename(l.path)}extname(l){return A.$jc.extname(l.path)}dirname(l){if(l.path.length===0)return l;let m;return l.scheme===k.Schemas.file?m=p.URI.file(A.$pc(c(l))).path:(m=A.$jc.dirname(l.path),l.authority&&m.length&&m.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${l.toString})) resulted in a relative path`),m="/")),l.with({path:m})}normalizePath(l){if(!l.path.length)return l;let m;return l.scheme===k.Schemas.file?m=p.URI.file(A.$kc(c(l))).path:m=A.$jc.normalize(l.path),l.with({path:m})}relativePath(l,m){if(l.scheme!==m.scheme||!(0,e.$mh)(l.authority,m.authority))return;if(l.scheme===k.Schemas.file){const n=A.$oc(c(l),c(m));return O.$c?a.$zg(n):n}let g=l.path||"/";const $=m.path||"/";if(this.a(l)){let n=0;for(const o=Math.min(g.length,$.length);n<o&&!(g.charCodeAt(n)!==$.charCodeAt(n)&&g.charAt(n).toLowerCase()!==$.charAt(n).toLowerCase());n++);g=$.substr(0,n)+g.substr(n)}return A.$jc.relative(g,$)}resolvePath(l,m){if(l.scheme===k.Schemas.file){const g=p.URI.file(A.$nc(c(l),m));return l.with({authority:g.authority,path:g.path})}return m=a.$Ag(m),l.with({path:A.$jc.resolve(l.path,m)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,m){return l===m||l!==void 0&&m!==void 0&&(0,R.$Hf)(l,m)}hasTrailingPathSeparator(l,m=A.sep){if(l.scheme===k.Schemas.file){const g=c(l);return g.length>a.$Bg(g).length&&g[g.length-1]===m}else{const g=l.path;return g.length>1&&g.charCodeAt(g.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,m=A.sep){return(0,e.$nh)(l,m)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,m=A.sep){let g=!1;if(l.scheme===k.Schemas.file){const $=c(l);g=$!==void 0&&$.length===a.$Bg($).length&&$[$.length-1]===m}else{m="/";const $=l.path;g=$.length===1&&$.charCodeAt($.length-1)===r.CharCode.Slash}return!g&&!(0,e.$nh)(l,m)?l.with({path:l.path+"/"}):l}}e.$9g=I,e.$0g=new I(()=>!1),e.$$g=new I(w=>w.scheme===k.Schemas.file?!O.$e:!0),e.$_g=new I(w=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function S(w,l){const m=[];for(let g=0;g<w.length;g++){const $=l(w[g]);w.some((n,o)=>o===g?!1:(0,e.$bh)($,l(n)))||m.push(w[g])}return m}var h;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function l(m){const g=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(o=>{const[t,i]=o.split(":");t&&i&&g.set(t,i)});const n=m.path.substring(0,m.path.indexOf(";"));return n&&g.set(w.META_DATA_MIME,n),g}w.parseMetaData=l})(h||(e.DataUri=h={}));function P(w,l,m){if(l){let g=w.path;return g&&g[0]!==A.$jc.sep&&(g=A.$jc.sep+g),w.with({scheme:m,authority:l,path:g})}return w.with({scheme:m})}}),define(Se[7],De([1,0,21,14,4,3,23,11,186,49]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=I,e.$th=S,e.$uh=h,e.$vh=P,e.$wh=w,e.$xh=l,e.$yh=m,e.$zh=g,e.$Hh=E,e.$Ih=D,e.$Jh=y,e.$Kh=T,e.$Lh=C,e.$1h=K,e.$9h=_;function I(le){return!!le&&typeof le.then=="function"}function S(le){const J=new r.$ye,ce=le(J.token),me=new Promise((we,Me)=>{const qe=J.token.onCancellationRequested(()=>{qe.dispose(),Me(new a.$8)});Promise.resolve(ce).then(ke=>{qe.dispose(),J.dispose(),we(ke)},ke=>{qe.dispose(),J.dispose(),Me(ke)})});return new class{cancel(){J.cancel(),J.dispose()}then(we,Me){return me.then(we,Me)}catch(we){return this.then(void 0,we)}finally(we){return me.finally(we)}}}function h(le,J,ce){return new Promise((me,we)=>{const Me=J.onCancellationRequested(()=>{Me.dispose(),me(ce)});le.then(me,we).finally(()=>Me.dispose())})}function P(le,J){return new Promise((ce,me)=>{const we=J.onCancellationRequested(()=>{we.dispose(),me(new a.$8)});le.then(ce,me).finally(()=>we.dispose())})}async function w(le){let J=-1;const ce=le.map((me,we)=>me.then(Me=>(J=we,Me)));try{return await Promise.race(ce)}finally{le.forEach((me,we)=>{we!==J&&me.cancel()})}}function l(le,J,ce){let me;const we=setTimeout(()=>{me?.(void 0),ce?.()},J);return Promise.race([le.finally(()=>clearTimeout(we)),new Promise(Me=>me=Me)])}function m(le){return new Promise((J,ce)=>{const me=le();I(me)?me.then(J,ce):J(me)})}function g(){let le,J;return{promise:new Promise((me,we)=>{le=me,J=we}),resolve:le,reject:J}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const ce=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(ce,ce).then(me)})}return new Promise((ce,me)=>{this.b.then(ce,me)})}return this.a=J(),new Promise((ce,me)=>{this.a.then(we=>{this.a=null,ce(we)},we=>{this.a=null,me(we)})})}dispose(){this.f=!0}}e.$Ah=$;class n{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$Bh=n;class o{constructor(){this.a=new Map}queue(J,ce){const we=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(ce).finally(()=>{this.a.get(J)===we&&this.a.delete(J)});return this.a.set(J,we),we}}e.$Ch=o;const t=(le,J)=>{let ce=!0;const me=setTimeout(()=>{ce=!1,J()},le);return{isTriggered:()=>ce,dispose:()=>{clearTimeout(me),ce=!1}}},i=le=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,le())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class s{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,ce=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((we,Me)=>{this.d=we,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=ce===p.$ie?i(me):t(ce,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=s;class d{constructor(J){this.a=new s(J),this.b=new $}trigger(J,ce){return this.a.trigger(()=>this.b.queue(J),ce)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=d;class u{constructor(){this.a=!1,this.b=new Promise((J,ce)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=u;class b extends u{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Gh=b;function E(le,J){return J?new Promise((ce,me)=>{const we=setTimeout(()=>{Me.dispose(),ce()},le),Me=J.onCancellationRequested(()=>{clearTimeout(we),Me.dispose(),me(new a.$8)})}):S(ce=>E(le,ce))}function D(le,J=0,ce){const me=setTimeout(()=>{le(),ce&&we.dispose()},J),we=(0,A.$Vc)(()=>{clearTimeout(me),ce?.deleteAndLeak(we)});return ce?.add(we),we}function y(le){const J=[];let ce=0;const me=le.length;function we(){return ce<me?le[ce++]():null}function Me(qe){qe!=null&&J.push(qe);const ke=we();return ke?ke.then(Me):Promise.resolve(J)}return Promise.resolve(null).then(Me)}function T(le,J=me=>!!me,ce=null){let me=0;const we=le.length,Me=()=>{if(me>=we)return Promise.resolve(ce);const qe=le[me++];return Promise.resolve(qe()).then(Ie=>J(Ie)?Promise.resolve(Ie):Me())};return Me()}function C(le,J=me=>!!me,ce=null){if(le.length===0)return Promise.resolve(ce);let me=le.length;const we=()=>{me=-1;for(const Me of le)Me.cancel?.()};return new Promise((Me,qe)=>{for(const ke of le)ke.then(Ie=>{--me>=0&&J(Ie)?(we(),Me(Ie)):me===0&&Me(ce)}).catch(Ie=>{--me>=0&&(we(),qe(Ie))})})}class v{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new k.$ne}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ce,me)=>{this.g.push({factory:J,c:ce,e:me}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const ce=J.factory();ce.then(J.c,J.e),ce.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=v;class f extends v{constructor(){super(1)}}e.$Nh=f;class N{constructor(){this.a=new ee,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Oh=N;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new Z;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,ce=O.$0g){const me=ce.getComparisonKey(J);return this.a.get(me)?.size??0}queueFor(J,ce,me=O.$0g){const we=me.getComparisonKey(J);let Me=this.a.get(we);if(!Me){Me=new f;const qe=this.f++,ke=k.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(qe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$7c),this.d.set(qe,ke),this.a.set(we,Me)}return Me.queue(ce)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=F;class j{constructor(J,ce){this.b=!1,this.a=-1,typeof J=="function"&&typeof ce=="number"&&this.setIfNotSet(J,ce)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,ce){if(this.b)throw new a.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},ce)}setIfNotSet(J,ce){if(this.b)throw new a.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},ce))}}e.$Qh=j;class z{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,ce,me=globalThis){if(this.f)throw new a.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const we=me.setInterval(()=>{J()},ce);this.d=(0,A.$Vc)(()=>{me.clearInterval(we),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=z;class M{constructor(J,ce){this.b=-1,this.a=J,this.d=ce,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=M;class L{constructor(J,ce){ce%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ce}ms is not a multiple of 1000ms.`),this.a=J,this.b=ce,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=L;class B extends M{constructor(J,ce){super(J,ce),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Uh=B;class W extends A.$Xc{constructor(J,ce){super(),this.g=J,this.h=ce,this.a=[],this.b=this.B(new A.$Yc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ce of J)this.a.push(ce);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(le,J)=>{(0,R.$v)(()=>{if(ce)return;const me=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ce=!1;return{dispose(){ce||(ce=!0)}}}:e.$Xh=(le,J,ce)=>{const me=le.requestIdleCallback(J,typeof ce=="number"?{timeout:ce}:void 0);let we=!1;return{dispose(){we||(we=!0,le.cancelIdleCallback(me))}}},e.$Wh=le=>(0,e.$Xh)(globalThis,le)}();class ae{constructor(J,ce){this.g=!1,this.d=()=>{try{this.j=ce()}catch(me){this.l=me}finally{this.g=!0}},this.f=(0,e.$Xh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=ae;class q extends ae{constructor(J){super(globalThis,J)}}e.$Zh=q;async function K(le,J,ce){let me;for(let we=0;we<ce;we++)try{return await le()}catch(Me){me=Me,await E(J)}throw me}class ee{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,ce,me){return this.a={taskId:J,cancel:()=>me?.(),promise:ce},ce.then(()=>this.d(J),()=>this.d(J)),ce}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:ce,resolve:me,reject:we}=g();this.b={run:J,promise:ce,promiseResolve:me,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=ee;class re{constructor(J,ce=()=>Date.now()){this.d=J,this.f=ce,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$3h=re;var ge;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(ge||(ge={}));class Z{get isRejected(){return this.d?.outcome===ge.Rejected}get isResolved(){return this.d?.outcome===ge.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ge.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((J,ce)=>{this.a=J,this.b=ce})}complete(J){return new Promise(ce=>{this.a(J),this.d={outcome:ge.Resolved,value:J},ce()})}error(J){return new Promise(ce=>{this.b(J),this.d={outcome:ge.Rejected,value:J},ce()})}cancel(){return this.error(new a.$8)}}e.$4h=Z;var $e;(function(le){async function J(me){let we;const Me=await Promise.all(me.map(qe=>qe.then(ke=>ke,ke=>{we||(we=ke)})));if(typeof we<"u")throw we;return Me}le.settled=J;function ce(me){return new Promise(async(we,Me)=>{try{await me(we,Me)}catch(qe){Me(qe)}})}le.withAsyncBody=ce})($e||(e.Promises=$e={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(ce=>(this.a=ce,this.d=!0,ce),ce=>{throw this.b=ce,this.d=!0,ce})}requireValue(){if(!this.d)throw new a.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=fe;class oe{constructor(J){this.b=J,this.a=new c.$X(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=oe;var H;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(H||(H={}));class ue{static fromArray(J){return new ue(ce=>{ce.emitMany(J)})}static fromPromise(J){return new ue(async ce=>{ce.emitMany(await J)})}static fromPromises(J){return new ue(async ce=>{await Promise.all(J.map(async me=>ce.emitOne(await me)))})}static merge(J){return new ue(async ce=>{await Promise.all(J.map(async me=>{for await(const we of me)ce.emitOne(we)}))})}constructor(J,ce){this.a=H.Initial,this.b=[],this.d=null,this.f=ce,this.g=new k.$ne,queueMicrotask(async()=>{const me={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(J(me)),this.k()}catch(we){this.l(we)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===H.DoneError)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===H.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,ce){return new ue(async me=>{for await(const we of J)me.emitOne(ce(we))})}map(J){return ue.map(this,J)}static filter(J,ce){return new ue(async me=>{for await(const we of J)ce(we)&&me.emitOne(we)})}filter(J){return ue.filter(this,J)}static coalesce(J){return ue.filter(J,ce=>!!ce)}coalesce(){return ue.coalesce(this)}static async toPromise(J){const ce=[];for await(const me of J)ce.push(me);return ce}toPromise(){return ue.toPromise(this)}h(J){this.a===H.Initial&&(this.b.push(J),this.g.fire())}j(J){this.a===H.Initial&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===H.Initial&&(this.a=H.DoneOK,this.g.fire())}l(J){this.a===H.Initial&&(this.a=H.DoneError,this.d=J,this.g.fire())}}e.$7h=ue,ue.EMPTY=ue.fromArray([]);class te extends ue{constructor(J,ce){super(ce),this.m=J}cancel(){this.m.cancel()}}e.$8h=te;function _(le){const J=new r.$ye,ce=le(J.token);return new te(J,async me=>{const we=J.token.onCancellationRequested(()=>{we.dispose(),J.dispose(),me.reject(new a.$8)});try{for await(const Me of ce){if(J.token.isCancellationRequested)return;me.emitOne(Me)}we.dispose(),J.dispose()}catch(Me){we.dispose(),J.dispose(),me.reject(Me)}})}class ne{constructor(J){this.a=new Z,this.b=new ue(we=>{if(ce){we.reject(ce);return}return me&&we.emitMany(me),this.d=Me=>we.reject(Me),this.f=Me=>we.emitOne(Me),this.a.p},J);let ce,me;this.f=we=>{me||(me=[]),me.push(we)},this.d=we=>{ce||(ce=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$0h=ne}),define(Se[39],De([1,0,19,7,27,32,29,17,11,13]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=I,e.$yk=l,e.$zk=N,e.$Ak=F,e.$Bk=j,e.$Ck=z,e.$Dk=M,e.$Ek=ae;function I(){return Object.create(null)}e.$wk="**",e.$xk="/";const S="[/\\\\]",h="[^/\\\\]",P=/\//g;function w(q,K){switch(q){case 0:return"";case 1:return`${h}*?`;default:return`(?:${S}|${h}+${S}${K?`|${S}${h}+`:""})*?`}}function l(q,K){if(!q)return[];const ee=[];let re=!1,ge=!1,Z="";for(const $e of q){switch($e){case K:if(!re&&!ge){ee.push(Z),Z="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ge=!0;break;case"]":ge=!1;break}Z+=$e}return Z&&ee.push(Z),ee}function m(q){if(!q)return"";let K="";const ee=l(q,e.$xk);if(ee.every(re=>re===e.$wk))K=".*";else{let re=!1;ee.forEach((ge,Z)=>{if(ge===e.$wk){if(re)return;K+=w(2,Z===ee.length-1)}else{let $e=!1,fe="",oe=!1,H="";for(const ue of ge){if(ue!=="}"&&$e){fe+=ue;continue}if(oe&&(ue!=="]"||!H)){let te;ue==="-"?te=ue:(ue==="^"||ue==="!")&&!H?te="^":ue===e.$xk?te="":te=(0,c.$jf)(ue),H+=te;continue}switch(ue){case"{":$e=!0;continue;case"[":oe=!0;continue;case"}":{const _=`(?:${l(fe,",").map(ne=>m(ne)).join("|")})`;K+=_,$e=!1,fe="";break}case"]":{K+="["+H+"]",oe=!1,H="";break}case"?":K+=h;continue;case"*":K+=w(1);continue;default:K+=(0,c.$jf)(ue)}}Z<ee.length-1&&(ee[Z+1]!==e.$wk||Z+2<ee.length)&&(K+=S)}re=ge===e.$wk})}return K}const g=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new O.$Gc(1e4),d=function(){return!1},u=function(){return null};function b(q,K){if(!q)return u;let ee;typeof q!="string"?ee=q.pattern:ee=q,ee=ee.trim();const re=`${ee}_${!!K.trimForExclusions}`;let ge=s.get(re);if(ge)return E(ge,q);let Z;return g.test(ee)?ge=y(ee.substr(4),ee):(Z=$.exec(D(ee,K)))?ge=T(Z[1],ee):(K.trimForExclusions?o:n).test(ee)?ge=C(ee,K):(Z=t.exec(D(ee,K)))?ge=v(Z[1].substr(1),ee,!0):(Z=i.exec(D(ee,K)))?ge=v(Z[1],ee,!1):ge=f(ee),s.set(re,ge),E(ge,q)}function E(q,K){if(typeof K=="string")return q;const ee=function(re,ge){return(0,A.$Fg)(re,K.base,!p.$e)?q((0,c.$of)(re.substr(K.base.length),R.sep),ge):null};return ee.allBasenames=q.allBasenames,ee.allPaths=q.allPaths,ee.basenames=q.basenames,ee.patterns=q.patterns,ee}function D(q,K){return K.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function y(q,K){return function(ee,re){return typeof ee=="string"&&ee.endsWith(q)?K:null}}function T(q,K){const ee=`/${q}`,re=`\\${q}`,ge=function($e,fe){return typeof $e!="string"?null:fe?fe===q?K:null:$e===q||$e.endsWith(ee)||$e.endsWith(re)?K:null},Z=[q];return ge.basenames=Z,ge.patterns=[K],ge.allBasenames=Z,ge}function C(q,K){const ee=W(q.slice(1,-1).split(",").map(fe=>b(fe,K)).filter(fe=>fe!==u),q),re=ee.length;if(!re)return u;if(re===1)return ee[0];const ge=function(fe,oe){for(let H=0,ue=ee.length;H<ue;H++)if(ee[H](fe,oe))return q;return null},Z=ee.find(fe=>!!fe.allBasenames);Z&&(ge.allBasenames=Z.allBasenames);const $e=ee.reduce((fe,oe)=>oe.allPaths?fe.concat(oe.allPaths):fe,[]);return $e.length&&(ge.allPaths=$e),ge}function v(q,K,ee){const re=R.sep===R.$jc.sep,ge=re?q:q.replace(P,R.sep),Z=R.sep+ge,$e=R.$jc.sep+q;let fe;return ee?fe=function(oe,H){return typeof oe=="string"&&(oe===ge||oe.endsWith(Z)||!re&&(oe===q||oe.endsWith($e)))?K:null}:fe=function(oe,H){return typeof oe=="string"&&(oe===ge||!re&&oe===q)?K:null},fe.allPaths=[(ee?"*/":"./")+q],fe}function f(q){try{const K=new RegExp(`^${m(q)}$`);return function(ee){return K.lastIndex=0,typeof ee=="string"&&K.test(ee)?q:null}}catch{return u}}function N(q,K,ee){return!q||typeof K!="string"?!1:F(q)(K,void 0,ee)}function F(q,K={}){if(!q)return d;if(typeof q=="string"||j(q)){const ee=b(q,K);if(ee===u)return d;const re=function(ge,Z){return!!ee(ge,Z)};return ee.allBasenames&&(re.allBasenames=ee.allBasenames),ee.allPaths&&(re.allPaths=ee.allPaths),re}return L(q,K)}function j(q){const K=q;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}function z(q){return q.allBasenames||[]}function M(q){return q.allPaths||[]}function L(q,K){const ee=W(Object.getOwnPropertyNames(q).map(fe=>B(fe,q[fe],K)).filter(fe=>fe!==u)),re=ee.length;if(!re)return u;if(!ee.some(fe=>!!fe.requiresSiblings)){if(re===1)return ee[0];const fe=function(ue,te){let _;for(let ne=0,le=ee.length;ne<le;ne++){const J=ee[ne](ue,te);if(typeof J=="string")return J;(0,a.$sh)(J)&&(_||(_=[]),_.push(J))}return _?(async()=>{for(const ne of _){const le=await ne;if(typeof le=="string")return le}return null})():null},oe=ee.find(ue=>!!ue.allBasenames);oe&&(fe.allBasenames=oe.allBasenames);const H=ee.reduce((ue,te)=>te.allPaths?ue.concat(te.allPaths):ue,[]);return H.length&&(fe.allPaths=H),fe}const ge=function(fe,oe,H){let ue,te;for(let _=0,ne=ee.length;_<ne;_++){const le=ee[_];le.requiresSiblings&&H&&(oe||(oe=(0,R.$qc)(fe)),ue||(ue=oe.substr(0,oe.length-(0,R.$rc)(fe).length)));const J=le(fe,oe,ue,H);if(typeof J=="string")return J;(0,a.$sh)(J)&&(te||(te=[]),te.push(J))}return te?(async()=>{for(const _ of te){const ne=await _;if(typeof ne=="string")return ne}return null})():null},Z=ee.find(fe=>!!fe.allBasenames);Z&&(ge.allBasenames=Z.allBasenames);const $e=ee.reduce((fe,oe)=>oe.allPaths?fe.concat(oe.allPaths):fe,[]);return $e.length&&(ge.allPaths=$e),ge}function B(q,K,ee){if(K===!1)return u;const re=b(q,ee);if(re===u)return u;if(typeof K=="boolean")return re;if(K){const ge=K.when;if(typeof ge=="string"){const Z=($e,fe,oe,H)=>{if(!H||!re($e,fe))return null;const ue=ge.replace("$(basename)",()=>oe),te=H(ue);return(0,a.$sh)(te)?te.then(_=>_?q:null):te?q:null};return Z.requiresSiblings=!0,Z}}return re}function W(q,K){const ee=q.filter(fe=>!!fe.basenames);if(ee.length<2)return q;const re=ee.reduce((fe,oe)=>{const H=oe.basenames;return H?fe.concat(H):fe},[]);let ge;if(K){ge=[];for(let fe=0,oe=re.length;fe<oe;fe++)ge.push(K)}else ge=ee.reduce((fe,oe)=>{const H=oe.patterns;return H?fe.concat(H):fe},[]);const Z=function(fe,oe){if(typeof fe!="string")return null;if(!oe){let ue;for(ue=fe.length;ue>0;ue--){const te=fe.charCodeAt(ue-1);if(te===k.CharCode.Slash||te===k.CharCode.Backslash)break}oe=fe.substr(ue)}const H=re.indexOf(oe);return H!==-1?ge[H]:null};Z.basenames=re,Z.patterns=ge,Z.allBasenames=re;const $e=q.filter(fe=>!fe.basenames);return $e.push(Z),$e}function ae(q,K){return(0,r.$xb)(q,K,(ee,re)=>typeof ee=="string"&&typeof re=="string"?ee===re:typeof ee!="string"&&typeof re!="string"?ee.base===re.base&&ee.pattern===re.pattern:!1)}}),define(Se[86],De([1,0,14,139,23,13,2]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.MarkdownStringTextNewlineStyle=void 0,e.$5k=c,e.$6k=I,e.$7k=S,e.$8k=h,e.$9k=P,e.$0k=w,e.$$k=l,e.$_k=m;var R;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class p{constructor($="",n=!1){if(this.value=$,typeof this.value!="string")throw(0,r.$0)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText($,n=R.Paragraph){return this.value+=h(this.supportThemeIcons?(0,a.$Xk)($):$).replace(/([ \t]+)/g,(o,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===R.Break?`\\
`:`

`),this}appendMarkdown($){return this.value+=$,this}appendCodeblock($,n){return this.value+=`
${P(n,$)}
`,this}appendLink($,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String($),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c($,n){const o=new RegExp((0,A.$jf)(n),"g");return $.replace(o,(t,i)=>$.charAt(i-1)!=="\\"?`\\${t}`:t)}}e.$4k=p;function c(g){return I(g)?!g.value:Array.isArray(g)?g.every(c):!0}function I(g){return g instanceof p?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||typeof g.isTrusted=="object"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}function S(g,$){return g===$?!0:!g||!$?!1:g.value===$.value&&g.isTrusted===$.isTrusted&&g.supportThemeIcons===$.supportThemeIcons&&g.supportHtml===$.supportHtml&&(g.baseUri===$.baseUri||!!g.baseUri&&!!$.baseUri&&(0,k.$ah)(O.URI.from(g.baseUri),O.URI.from($.baseUri)))}function h(g){return g.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function P(g,$){const n=g.match(/^`+/gm)?.reduce((t,i)=>t.length>i.length?t:i).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${$}`,g,`${"`".repeat(o)}`].join(`
`)}function w(g){return g.replace(/"/g,"&quot;")}function l(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(g){const $=[],n=g.split("|").map(t=>t.trim());g=n[0];const o=n[1];if(o){const t=/height=(\d+)/.exec(o),i=/width=(\d+)/.exec(o),s=t?t[1]:"",d=i?i[1]:"",u=isFinite(parseInt(d)),b=isFinite(parseInt(s));u&&$.push(`width="${d}"`),b&&$.push(`height="${s}"`)}return{href:g,dimensions:$}}}),define(Se[108],De([1,0,19,32,17,11,23,13]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=p,e.$Yw=I,e.$Zw=h,e.$1w=P,e.$2w=g,e.$3w=n,e.$4w=o,e.$5w=t,e.$6w=i,e.$7w=s;function p(u,b){const{os:E,tildify:D,relative:y}=b;if(y){const v=c(u,y,E);if(typeof v=="string")return v}let T=u.fsPath;if(E===A.OperatingSystem.Windows&&!A.$c?T=T.replace(/\//g,"\\"):E!==A.OperatingSystem.Windows&&A.$c&&(T=T.replace(/\\/g,"/")),E!==A.OperatingSystem.Windows&&D?.userHome){const v=D.userHome.fsPath;let f;u.scheme!==D.userHome.scheme&&u.path[0]===k.$jc.sep&&u.path[1]!==k.$jc.sep?f=D.userHome.with({path:u.path}).fsPath:f=T,T=h(f,v,E)}return(E===A.OperatingSystem.Windows?k.$ic:k.$jc).normalize(I(T,E===A.OperatingSystem.Windows))}function c(u,b,E){const D=E===A.OperatingSystem.Windows?k.$ic:k.$jc,y=E===A.OperatingSystem.Linux?O.$0g:O.$_g,T=b.getWorkspace(),C=(0,r.$Rb)(T.folders);if(!C)return;u.scheme!==C.uri.scheme&&u.path[0]===k.$jc.sep&&u.path[1]!==k.$jc.sep&&(u=C.uri.with({path:u.path}));const v=b.getWorkspaceFolder(u);if(!v)return;let f;if(y.isEqual(v.uri,u)?f="":f=y.relativePath(v.uri,u)??"",f&&(f=D.normalize(f)),T.folders.length>1&&!b.noPrefix){const N=v.name?v.name:y.basenameOrAuthority(v.uri);f=f?`${N} \u2022 ${f}`:N}return f}function I(u,b=A.$c){return(0,a.$Kg)(u,b)?u.charAt(0).toUpperCase()+u.slice(1):u}let S=Object.create(null);function h(u,b,E=A.OS){if(E===A.OperatingSystem.Windows||!u||!b)return u;let D=S.original===b?S.normalized:void 0;D||(D=b,A.$c&&(D=(0,a.$zg)(D)),D=`${(0,R.$pf)(D,k.$jc.sep)}${k.$jc.sep}`,S={original:b,normalized:D});let y=u;return A.$c&&(y=(0,a.$zg)(y)),(E===A.OperatingSystem.Linux?y.startsWith(D):(0,R.$If)(y,D))?`~/${y.substr(D.length)}`:u}function P(u,b){return u.replace(/^~($|\/|\\)/,`${b}$1`)}const w="\u2026",l="\\\\",m="~";function g(u,b=k.sep){const E=new Array(u.length);let D=!1;for(let y=0;y<u.length;y++){const T=u[y];if(T===""){E[y]=`.${b}`;continue}if(!T){E[y]=T;continue}D=!0;let C="",v=T;v.indexOf(l)===0?(C=v.substr(0,v.indexOf(l)+l.length),v=v.substr(v.indexOf(l)+l.length)):v.indexOf(b)===0?(C=v.substr(0,v.indexOf(b)+b.length),v=v.substr(v.indexOf(b)+b.length)):v.indexOf(m)===0&&(C=v.substr(0,v.indexOf(m)+m.length),v=v.substr(v.indexOf(m)+m.length));const f=v.split(b);for(let N=1;D&&N<=f.length;N++)for(let F=f.length-N;D&&F>=0;F--){D=!1;let j=f.slice(F,F+N).join(b);for(let z=0;!D&&z<u.length;z++)if(z!==y&&u[z]&&u[z].indexOf(j)>-1){const M=F+N===f.length,L=F>0&&u[z].indexOf(b)>-1?b+j:j,B=u[z].endsWith(L);D=!M||B}if(!D){let z="";(f[0].endsWith(":")||C!=="")&&(F===1&&(F=0,N++,j=f[0]+b+j),F>0&&(z=f[0]+b),z=C+z),F>0&&(z=z+w+b),z=z+j,F+N<f.length&&(z=z+b+w),E[y]=z}}D&&(E[y]=T)}return E}var $;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})($||($={}));function n(u,b=Object.create(null)){const E=[];let D=!1,y="";for(const T of u)if(T==="$"||D&&T==="{")y&&E.push({value:y,type:$.TEXT}),y="",D=!0;else if(T==="}"&&D){const C=b[y];if(typeof C=="string")C.length&&E.push({value:C,type:$.VARIABLE});else if(C){const v=E[E.length-1];(!v||v.type!==$.SEPARATOR)&&E.push({value:C.label,type:$.SEPARATOR})}y="",D=!1}else y+=T;return y&&!D&&E.push({value:y,type:$.TEXT}),E.filter((T,C)=>{if(T.type===$.SEPARATOR){const v=E[C-1],f=E[C+1];return[v,f].every(N=>N&&(N.type===$.VARIABLE||N.type===$.TEXT)&&N.value.length>0)}return!0}).map(T=>T.value).join("")}function o(u,b){return A.$d||b?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$d?"&":"&&"):u.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(u,b){return A.$d||b?u.replace(/\(&&\w\)|&&/g,""):A.$c?u.replace(/&&|&/g,E=>E==="&"?"&&":"&"):u.replace(/&&/g,"_")}function i(u){return u.replace(/&/g,"&&")}function s(u){if(u.endsWith("]")){const b=u.lastIndexOf(" [",u.length-2);if(b!==-1){const E=d(u.substring(0,b)),D=u.substring(b);return{name:E.name+D,parentPath:E.parentPath}}}return d(u)}function d(u){const b=u.indexOf("/")!==-1?k.$jc:k.$ic,E=b.basename(u),D=b.dirname(u);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(Se[140],De([1,0,22,41,2]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=void 0,e.$Pn=p,e.$Qn=I,e.$Rn=S;function A(h){return h.toJSON()}class O{constructor(P){this.a=P}transformIncoming(P){const w=this.a.transformIncoming(P);return w===P?P:A(k.URI.from(w))}transformOutgoing(P){const w=this.a.transformOutgoing(P);return w===P?P:A(k.URI.from(w))}transformOutgoingURI(P){const w=this.a.transformOutgoing(P);return w===P?P:k.URI.from(w)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.$Nn=O,e.$On=new class{transformIncoming(h){return h}transformOutgoing(h){return h}transformOutgoingURI(h){return h}transformOutgoingScheme(h){return h}};function R(h,P,w){if(!h||w>200)return null;if(typeof h=="object"){if(h instanceof k.URI)return P.transformOutgoing(h);for(const l in h)if(Object.hasOwnProperty.call(h,l)){const m=R(h[l],P,w+1);m!==null&&(h[l]=m)}}return null}function p(h,P){const w=R(h,P,0);return w===null?h:w}function c(h,P,w,l){if(!h||l>200)return null;if(typeof h=="object"){if(h.$mid===a.MarshalledId.Uri)return w?k.URI.revive(P.transformIncoming(h)):P.transformIncoming(h);if(h instanceof r.$Pe)return null;for(const m in h)if(Object.hasOwnProperty.call(h,m)){const g=c(h[m],P,w,l+1);g!==null&&(h[m]=g)}}return null}function I(h,P){const w=c(h,P,!1,0);return w===null?h:w}function S(h,P){const w=c(h,P,!0,0);return w===null?h:w}}),define(Se[33],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=a;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(k){return r.test(k)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(R){for(let p=0;p<R.length;p++)R[p]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let p=0,c="";return c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+="-",c+=O[A[p++]],c+=O[A[p++]],c+="-",c+=O[A[p++]],c+=O[A[p++]],c+="-",c+=O[A[p++]],c+=O[A[p++]],c+="-",c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c+=O[A[p++]],c}}()}),define(Se[190],De([1,0,19,40,33]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.$pu=void 0,e.$nu=A,e.$ou=O,e.$qu=c;function A(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function O(S,h,P){const w={id:(0,k.$3g)(),name:S,uri:h,data:P};return{asString:async()=>"",asFile:()=>w,value:void 0}}class R{constructor(){this.a=new Map}get size(){let h=0;for(const P of this.a)h++;return h}has(h){return this.a.has(this.b(h))}matches(h){const P=[...this.a.keys()];return a.Iterable.some(this,([w,l])=>l.asFile())&&P.push("files"),I(p(h),P)}get(h){return this.a.get(this.b(h))?.[0]}append(h,P){const w=this.a.get(h);w?w.push(P):this.a.set(this.b(h),[P])}replace(h,P){this.a.set(this.b(h),[P])}delete(h){this.a.delete(this.b(h))}*[Symbol.iterator](){for(const[h,P]of this.a)for(const w of P)yield[h,w]}b(h){return p(h)}}e.$pu=R;function p(S){return S.toLowerCase()}function c(S,h){return I(p(S),h.map(p))}function I(S,h){if(S==="*/*")return h.length>0;if(h.includes(S))return!0;const P=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!P)return!1;const[w,l,m]=P;return m==="*"?h.some(g=>g.startsWith(l+"/")):!1}e.$ru=Object.freeze({create:S=>(0,r.$Pb)(S.map(h=>h.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$ru.split(S).filter(h=>!h.startsWith("#"))})}),define(Se[34],De([1,0,61,67,410,7,32,82,17,11,23,2]),function(ie,e,r,a,k,A,O,R,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=n,e.whenDeleted=i,e.configureFlushOnWrite=E,e.writeFileSync=y,r=Ue(r);var h;(function(L){L[L.UNLINK=0]="UNLINK",L[L.MOVE=1]="MOVE"})(h||(e.RimRafMode=h={}));async function P(L,B=h.UNLINK,W){if((0,O.$Jg)(L))throw new Error("rimraf - will refuse to recursively delete root");return B===h.UNLINK?l(L):w(L,W)}async function w(L,B=(0,O.$Og)((0,a.tmpdir)())){try{try{await r.promises.rename(L,B)}catch(W){return W.code==="ENOENT"?void 0:l(L)}l(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function l(L){return r.promises.rm(L,{recursive:!0,force:!0,maxRetries:3})}function m(L){if((0,O.$Jg)(L))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(L,{recursive:!0,force:!0,maxRetries:3})}async function g(L,B){return o(await(B?$(L):r.promises.readdir(L)))}async function $(L){try{return await r.promises.readdir(L,{withFileTypes:!0})}catch(ae){console.warn("[node.js fs] readdir with filetypes failed with error: ",ae)}const B=[],W=await g(L);for(const ae of W){let q=!1,K=!1,ee=!1;try{const re=await e.Promises.lstat((0,p.$mc)(L,ae));q=re.isFile(),K=re.isDirectory(),ee=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}B.push({name:ae,isFile:()=>q,isDirectory:()=>K,isSymbolicLink:()=>ee})}return B}function n(L){return o(r.readdirSync(L))}function o(L){return L.map(B=>typeof B=="string"?c.$d?(0,R.$nm)(B):B:(B.name=c.$d?(0,R.$nm)(B.name):B.name,B))}async function t(L){const B=await g(L),W=[];for(const ae of B)await s.existsDirectory((0,p.$mc)(L,ae))&&W.push(ae);return W}function i(L,B=1e3){return new Promise(W=>{let ae=!1;const q=setInterval(()=>{ae||(ae=!0,r.access(L,K=>{ae=!1,K&&(clearInterval(q),W(void 0))}))},B)})}var s;(function(L){async function B(q){let K;try{if(K=await e.Promises.lstat(q),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(c.$c&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw re}throw ee}}L.stat=B;async function W(q){try{const{stat:K,symbolicLink:ee}=await L.stat(q);return K.isFile()&&ee?.dangling!==!0}catch{}return!1}L.existsFile=W;async function ae(q){try{const{stat:K,symbolicLink:ee}=await L.stat(q);return K.isDirectory()&&ee?.dangling!==!0}catch{}return!1}L.existsDirectory=ae})(s||(e.SymlinkSupport=s={}));const d=new A.$Ph;function u(L,B,W){return d.queueFor(S.URI.file(L),()=>{const ae=T(W);return new Promise((q,K)=>D(L,B,ae,ee=>ee?K(ee):q()))},I.$$g)}let b=!0;function E(L){b=L}function D(L,B,W,ae){if(!b)return r.writeFile(L,B,{mode:W.mode,flag:W.flag},ae);r.open(L,W.flag,W.mode,(q,K)=>{if(q)return ae(q);r.writeFile(K,B,ee=>{if(ee)return r.close(K,()=>ae(ee));r.fdatasync(K,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),E(!1)),r.close(K,ge=>ae(ge))))})})}function y(L,B,W){const ae=T(W);if(!b)return r.writeFileSync(L,B,{mode:ae.mode,flag:ae.flag});const q=r.openSync(L,ae.flag,ae.mode);try{r.writeFileSync(q,B);try{r.fdatasyncSync(q)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),E(!1)}}finally{r.closeSync(q)}}function T(L){return L?{mode:typeof L.mode=="number"?L.mode:438,flag:typeof L.flag=="string"?L.flag:"w"}:{mode:438,flag:"w"}}async function C(L,B,W=6e4){if(L!==B)try{c.$c&&typeof W=="number"?await v(L,B,Date.now(),W):await r.promises.rename(L,B)}catch(ae){if(L.toLowerCase()!==B.toLowerCase()&&ae.code==="EXDEV"||L.endsWith("."))await f(L,B,{preserveSymlinks:!1}),await P(L,h.MOVE);else throw ae}}async function v(L,B,W,ae,q=0){try{return await r.promises.rename(L,B)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-W>=ae)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${K}`),K;if(q===0){let ee=!1;try{const{stat:re}=await s.stat(B);re.isFile()||(ee=!0)}catch{}if(ee)throw K}return await(0,A.$Hh)(Math.min(100,q*10)),v(L,B,W,ae,q+1)}}async function f(L,B,W){return F(L,B,{root:{source:L,target:B},options:W,handledSourcePaths:new Set})}const N=511;async function F(L,B,W){if(W.handledSourcePaths.has(L))return;W.handledSourcePaths.add(L);const{stat:ae,symbolicLink:q}=await s.stat(L);if(q){if(W.options.preserveSymlinks)try{return await M(L,B,W)}catch{}if(q.dangling)return}return ae.isDirectory()?j(L,B,ae.mode&N,W):z(L,B,ae.mode&N)}async function j(L,B,W,ae){await e.Promises.mkdir(B,{recursive:!0,mode:W});const q=await g(L);for(const K of q)await F((0,p.$mc)(L,K),(0,p.$mc)(B,K),ae)}async function z(L,B,W){await e.Promises.copyFile(L,B),await e.Promises.chmod(B,W)}async function M(L,B,W){let ae=await e.Promises.readlink(L);(0,O.$Fg)(ae,W.root.source,!c.$e)&&(ae=(0,p.$mc)(W.root.target,ae.substr(W.root.source.length+1))),await e.Promises.symlink(ae,B)}e.Promises=new class{get access(){return r.promises.access}get stat(){return r.promises.stat}get lstat(){return r.promises.lstat}get utimes(){return r.promises.utimes}get read(){return(L,B,W,ae,q)=>new Promise((K,ee)=>{r.read(L,B,W,ae,q,(re,ge,Z)=>re?ee(re):K({bytesRead:ge,buffer:Z}))})}get readFile(){return r.promises.readFile}get write(){return(L,B,W,ae,q)=>new Promise((K,ee)=>{r.write(L,B,W,ae,q,(re,ge,Z)=>re?ee(re):K({bytesWritten:ge,buffer:Z}))})}get appendFile(){return r.promises.appendFile}get fdatasync(){return(0,k.promisify)(r.fdatasync)}get truncate(){return r.promises.truncate}get copyFile(){return r.promises.copyFile}get open(){return(0,k.promisify)(r.open)}get close(){return(0,k.promisify)(r.close)}get symlink(){return r.promises.symlink}get readlink(){return r.promises.readlink}get chmod(){return r.promises.chmod}get mkdir(){return r.promises.mkdir}get unlink(){return r.promises.unlink}get rmdir(){return r.promises.rmdir}get realpath(){return(0,k.promisify)(r.realpath)}async exists(L){try{return await e.Promises.access(L),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return P}get rename(){return C}get copy(){return f}}}),define(Se[109],De([1,0,61,17,11,13,34]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=R,e.$lr=p,e.$mr=c,e.$nr=I,r=Ue(r);function R(h){if(k.$e)return h;const P=(0,a.$pc)(h);if(h===P)return h;const w=((0,a.$qc)(h)||h).toLowerCase();try{const m=(0,O.readdirSync)(P).filter(g=>g.toLowerCase()===w);if(m.length===1){const g=R(P);if(g)return(0,a.$mc)(g,m[0])}else if(m.length>1){const g=m.indexOf(w);if(g>=0){const $=R(P);if($)return(0,a.$mc)($,m[g])}}}catch{}return null}async function p(h,P){if(k.$e)return h;const w=(0,a.$pc)(h);if(h===w)return h;const l=((0,a.$qc)(h)||h).toLowerCase();try{if(P?.isCancellationRequested)return null;const g=(await O.Promises.readdir(w)).filter($=>$.toLowerCase()===l);if(g.length===1){const $=await p(w,P);if($)return(0,a.$mc)($,g[0])}else if(g.length>1){const $=g.indexOf(l);if($>=0){const n=await p(w,P);if(n)return(0,a.$mc)(n,g[$])}}}catch{}return null}async function c(h){try{return await O.Promises.realpath(h)}catch{const w=S(h);return await O.Promises.access(w,r.constants.R_OK),w}}function I(h){try{return r.realpathSync(h)}catch{const w=S(h);return r.accessSync(w,r.constants.R_OK),w}}function S(h){return(0,A.$pf)((0,a.$kc)(h),a.sep)}}),define(Se[191],De([1,0,68]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=void 0,e.$5g=a,e.$7g=A,r=Ue(r);function a(R,p,c,I=1){let S=!1;return new Promise(h=>{const P=setTimeout(()=>{if(!S)return S=!0,h(0)},c);k(R,p,I,w=>{if(!S)return S=!0,clearTimeout(P),h(w)})})}function k(R,p,c,I){if(p===0)return I(0);const S=new r.Socket;S.once("connect",()=>(O(S),k(R+c,p-1,c,I))),S.once("data",()=>{}),S.once("error",h=>(O(S),h.code!=="ECONNREFUSED"?k(R+c,p-1,c,I):I(R))),S.connect(R,"127.0.0.1")}e.$6g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,p,c,I="127.0.0.1"){let S=!1,h,P=1;const w=r.createServer({pauseOnConnect:!0});function l(m,g){S||(S=!0,w.removeAllListeners(),w.close(),h&&clearTimeout(h),g(m))}return new Promise(m=>{h=setTimeout(()=>{l(0,m)},c),w.on("listening",()=>{l(R,m)}),w.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&P<p?(R++,P++,w.listen(R,I)):l(0,m)}),w.on("close",()=>{l(0,m)}),w.listen(R,I)})}function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(p){console.error(p)}}}),define(Se[110],De([1,0,17,11,54,105,18,34]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$ym=p,e.$zm=c,r=Ue(r),a=Ue(a),k=Ue(k),O=Ue(O),R=Ue(R),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function p(S=k.env){return S.comspec||"cmd.exe"}function c(S){let h=[],P=!1;const w=function(l){if(P){h.push(l);return}(!S.send(l,g=>{if(g&&console.error(g),P=!1,h.length>0){const $=h.slice(0);h=[],$.forEach(n=>w(n))}})||a.$c)&&(P=!0)};return{send:w}}var I;(function(S){async function h(P,w,l){if(r.$lc(P))return P;if(w===void 0&&(w=k.cwd()),r.$pc(P)!=="."||(l===void 0&&O.$gg(k.env.PATH)&&(l=k.env.PATH.split(r.$wc)),l===void 0||l.length===0))return r.$mc(w,P);async function g($){if(await R.Promises.exists($)){let n;try{n=await R.Promises.stat($)}catch(o){o.message.startsWith("EACCES")&&(n=await R.Promises.lstat($))}return n?!n.isDirectory():!1}return!1}for(const $ of l){let n;if(r.$lc($)?n=r.$mc($,P):n=r.$mc(w,$,P),await g(n))return n;let o=n+".com";if(await g(o)||(o=n+".exe",await g(o)))return o}return r.$mc(w,P)}S.findExecutable=h})(I||(e.win32=I={}))});var Ye=this&&this.__decorate||function(ie,e,r,a){var k=arguments.length,A=k<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,r):a,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,r,a);else for(var R=ie.length-1;R>=0;R--)(O=ie[R])&&(A=(k<3?O(A):k>3?O(e,r,A):O(e,r))||A);return k>3&&A&&Object.defineProperty(e,r,A),A};define(Se[87],De([1,0,19,7,22,21,59,14,4,3,55,13,18]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.ProxyChannel=e.$oi=e.$li=e.$ki=e.$ji=e.RequestInitiator=e.$ii=e.$fi=e.$ei=void 0,e.$gi=E,e.$hi=D,e.$mi=N,e.$ni=F,S=Ue(S);var P;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(P||(P={}));function w(q){switch(q){case P.Promise:return"req";case P.PromiseCancel:return"cancel";case P.EventListen:return"subscribe";case P.EventDispose:return"unsubscribe"}}var l;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(l||(l={}));function m(q){switch(q){case l.Initialize:return"init";case l.PromiseSuccess:return"reply:";case l.PromiseError:case l.PromiseErrorObj:return"replyErr:";case l.EventFire:return"event:"}}var g;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(g||(g={}));function $(q){let K=0;for(let ee=0;;ee+=7){const re=q.read(1);if(K|=(re.buffer[0]&127)<<ee,!(re.buffer[0]&128))return K}}const n=d(0);function o(q,K){if(K===0){q.write(n);return}let ee=0;for(let ge=K;ge!==0;ge=ge>>>7)ee++;const re=k.$Pe.alloc(ee);for(let ge=0;K!==0;ge++)re.buffer[ge]=K&127,K=K>>>7,K>0&&(re.buffer[ge]|=128);q.write(re)}class t{constructor(K){this.b=K,this.a=0}read(K){const ee=this.b.slice(this.a,this.a+K);return this.a+=ee.byteLength,ee}}e.$ei=t;class i{constructor(){this.a=[]}get buffer(){return k.$Pe.concat(this.a)}write(K){this.a.push(K)}}e.$fi=i;var s;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(s||(s={}));function d(q){const K=k.$Pe.alloc(1);return K.writeUInt8(q,0),K}const u={Undefined:d(s.Undefined),String:d(s.String),Buffer:d(s.Buffer),VSBuffer:d(s.VSBuffer),Array:d(s.Array),Object:d(s.Object),Uint:d(s.Int)},b=typeof Buffer<"u";function E(q,K){if(typeof K>"u")q.write(u.Undefined);else if(typeof K=="string"){const ee=k.$Pe.fromString(K);q.write(u.String),o(q,ee.byteLength),q.write(ee)}else if(b&&Buffer.isBuffer(K)){const ee=k.$Pe.wrap(K);q.write(u.Buffer),o(q,ee.byteLength),q.write(ee)}else if(K instanceof k.$Pe)q.write(u.VSBuffer),o(q,K.byteLength),q.write(K);else if(Array.isArray(K)){q.write(u.Array),o(q,K.length);for(const ee of K)E(q,ee)}else if(typeof K=="number"&&(K|0)===K)q.write(u.Uint),o(q,K);else{const ee=k.$Pe.fromString(JSON.stringify(K));q.write(u.Object),o(q,ee.byteLength),q.write(ee)}}function D(q){switch(q.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return q.read($(q)).toString();case s.Buffer:return q.read($(q)).buffer;case s.VSBuffer:return q.read($(q));case s.Array:{const ee=$(q),re=[];for(let ge=0;ge<ee;ge++)re.push(D(q));return re}case s.Object:return JSON.parse(q.read($(q)).toString());case s.Int:return $(q)}}class y{constructor(K,ee,re=null,ge=1e3){this.h=K,this.j=ee,this.k=re,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Z=>this.q(Z)),this.m({type:l.Initialize})}registerChannel(K,ee){this.b.set(K,ee),setTimeout(()=>this.w(K),0)}m(K){switch(K.type){case l.Initialize:{const ee=this.o([K.type]);this.k?.logOutgoing(ee,0,T.OtherSide,m(K.type));return}case l.PromiseSuccess:case l.PromiseError:case l.EventFire:case l.PromiseErrorObj:{const ee=this.o([K.type,K.id],K.data);this.k?.logOutgoing(ee,K.id,T.OtherSide,m(K.type),K.data);return}}}o(K,ee=void 0){const re=new i;return E(re,K),E(re,ee),this.p(re.buffer)}p(K){try{return this.h.send(K),K.byteLength}catch{return 0}}q(K){const ee=new t(K),re=D(ee),ge=D(ee),Z=re[0];switch(Z){case P.Promise:return this.k?.logIncoming(K.byteLength,re[1],T.OtherSide,`${w(Z)}: ${re[2]}.${re[3]}`,ge),this.s({type:Z,id:re[1],channelName:re[2],name:re[3],arg:ge});case P.EventListen:return this.k?.logIncoming(K.byteLength,re[1],T.OtherSide,`${w(Z)}: ${re[2]}.${re[3]}`,ge),this.t({type:Z,id:re[1],channelName:re[2],name:re[3],arg:ge});case P.PromiseCancel:return this.k?.logIncoming(K.byteLength,re[1],T.OtherSide,`${w(Z)}`),this.u({type:Z,id:re[1]});case P.EventDispose:return this.k?.logIncoming(K.byteLength,re[1],T.OtherSide,`${w(Z)}`),this.u({type:Z,id:re[1]})}}s(K){const ee=this.b.get(K.channelName);if(!ee){this.v(K);return}const re=new A.$ye;let ge;try{ge=ee.call(this.j,K.name,K.arg,re.token)}catch(fe){ge=Promise.reject(fe)}const Z=K.id;ge.then(fe=>{this.m({id:Z,data:fe,type:l.PromiseSuccess})},fe=>{fe instanceof Error?this.m({id:Z,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split(`
`):void 0},type:l.PromiseError}):this.m({id:Z,data:fe,type:l.PromiseErrorObj})}).finally(()=>{$e.dispose(),this.d.delete(K.id)});const $e=(0,c.$Vc)(()=>re.cancel());this.d.set(K.id,$e)}t(K){const ee=this.b.get(K.channelName);if(!ee){this.v(K);return}const re=K.id,Z=ee.listen(this.j,K.name,K.arg)($e=>this.m({id:re,data:$e,type:l.EventFire}));this.d.set(K.id,Z)}u(K){const ee=this.d.get(K.id);ee&&(ee.dispose(),this.d.delete(K.id))}v(K){let ee=this.g.get(K.channelName);ee||(ee=[],this.g.set(K.channelName,ee));const re=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===P.Promise&&this.m({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.l}ms`,stack:void 0},type:l.PromiseError})},this.l);ee.push({request:K,timeoutTimer:re})}w(K){const ee=this.g.get(K);if(ee){for(const re of ee)switch(clearTimeout(re.timeoutTimer),re.request.type){case P.Promise:this.s(re.request);break;case P.EventListen:this.t(re.request);break}this.g.delete(K)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Sc)(this.d.values()),this.d.clear()}}e.$ii=y;var T;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(T||(e.RequestInitiator=T={}));class C{constructor(K,ee=null){this.l=K,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$ne,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ee}getChannel(K){const ee=this;return{call(re,ge,Z){return ee.a?Promise.reject(new R.$8):ee.m(K,re,ge,Z)},listen(re,ge){return ee.a?p.Event.None:ee.o(K,re,ge)}}}m(K,ee,re,ge=A.CancellationToken.None){const Z=this.g++,$e=P.Promise,fe={id:Z,type:$e,channelName:K,name:ee,arg:re};if(ge.isCancellationRequested)return Promise.reject(new R.$8);let oe;return new Promise((ue,te)=>{if(ge.isCancellationRequested)return te(new R.$8);const _=()=>{const ce=me=>{switch(me.type){case l.PromiseSuccess:this.f.delete(Z),ue(me.data);break;case l.PromiseError:{this.f.delete(Z);const we=new Error(me.data.message);we.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,we.name=me.data.name,te(we);break}case l.PromiseErrorObj:this.f.delete(Z),te(me.data);break}};this.f.set(Z,ce),this.p(fe)};let ne=null;this.b===g.Idle?_():(ne=(0,a.$th)(ce=>this.u()),ne.then(()=>{ne=null,_()}));const le=()=>{ne?(ne.cancel(),ne=null):this.p({id:Z,type:P.PromiseCancel}),te(new R.$8)},J=ge.onCancellationRequested(le);oe=(0,c.$Uc)((0,c.$Vc)(le),J),this.d.add(oe)}).finally(()=>{oe.dispose(),this.d.delete(oe)})}o(K,ee,re){const ge=this.g++,Z=P.EventListen,$e={id:ge,type:Z,channelName:K,name:ee,arg:re};let fe=null;const oe=new p.$ne({onWillAddFirstListener:()=>{fe=(0,a.$th)(ue=>this.u()),fe.then(()=>{fe=null,this.d.add(oe),this.p($e)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(oe),this.p({id:ge,type:P.EventDispose}))}}),H=ue=>oe.fire(ue.data);return this.f.set(ge,H),oe.event}p(K){switch(K.type){case P.Promise:case P.EventListen:{const ee=this.q([K.type,K.id,K.channelName,K.name],K.arg);this.j?.logOutgoing(ee,K.id,T.LocalSide,`${w(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case P.PromiseCancel:case P.EventDispose:{const ee=this.q([K.type,K.id]);this.j?.logOutgoing(ee,K.id,T.LocalSide,w(K.type));return}}}q(K,ee=void 0){const re=new i;return E(re,K),E(re,ee),this.r(re.buffer)}r(K){try{return this.l.send(K),K.byteLength}catch{return 0}}s(K){const ee=new t(K),re=D(ee),ge=D(ee),Z=re[0];switch(Z){case l.Initialize:return this.j?.logIncoming(K.byteLength,0,T.LocalSide,m(Z)),this.t({type:re[0]});case l.PromiseSuccess:case l.PromiseError:case l.EventFire:case l.PromiseErrorObj:return this.j?.logIncoming(K.byteLength,re[1],T.LocalSide,m(Z),ge),this.t({type:re[0],id:re[1],data:ge})}}t(K){if(K.type===l.Initialize){this.b=g.Idle,this.k.fire();return}this.f.get(K.id)?.(K)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Sc)(this.d.values()),this.d.clear()}}e.$ji=C,Ye([O.$$h],C.prototype,"onDidInitializePromise",null);class v{get connections(){const K=[];return this.f.forEach(ee=>K.push(ee)),K}constructor(K,ee,re){this.a=new Map,this.f=new Set,this.g=new p.$ne,this.onDidAddConnection=this.g.event,this.h=new p.$ne,this.onDidRemoveConnection=this.h.event,this.j=new c.$Wc,this.j.add(K(({protocol:ge,onDidClientDisconnect:Z})=>{const $e=p.Event.once(ge.onMessage);this.j.add($e(fe=>{const oe=new t(fe),H=D(oe),ue=new y(ge,H,ee,re),te=new C(ge,ee);this.a.forEach((ne,le)=>ue.registerChannel(le,ne));const _={channelServer:ue,channelClient:te,ctx:H};this.f.add(_),this.g.fire(_),this.j.add(Z(()=>{ue.dispose(),te.dispose(),this.f.delete(_),this.h.fire(_)}))}))}))}getChannel(K,ee){const re=this;return{call(ge,Z,$e){let fe;if((0,h.$ug)(ee)){const H=(0,r.$6b)(re.connections.filter(ee));fe=H?Promise.resolve(H):p.Event.toPromise(p.Event.filter(re.onDidAddConnection,ee))}else fe=ee.routeCall(re,ge,Z);const oe=fe.then(H=>H.channelClient.getChannel(K));return N(oe).call(ge,Z,$e)},listen(ge,Z){if((0,h.$ug)(ee))return re.k(K,ee,ge,Z);const $e=ee.routeEvent(re,ge,Z).then(fe=>fe.channelClient.getChannel(K));return N($e).listen(ge,Z)}}}k(K,ee,re,ge){const Z=this;let $e;const fe=new p.$ne({onWillAddFirstListener:()=>{$e=new c.$Wc;const oe=new p.$te,H=new Map,ue=_=>{const le=_.channelClient.getChannel(K).listen(re,ge),J=oe.add(le);H.set(_,J)},te=_=>{const ne=H.get(_);ne&&(ne.dispose(),H.delete(_))};Z.connections.filter(ee).forEach(ue),p.Event.filter(Z.onDidAddConnection,ee)(ue,void 0,$e),Z.onDidRemoveConnection(te,void 0,$e),oe.event(fe.fire,fe,$e),$e.add(oe)},onDidRemoveLastListener:()=>{$e?.dispose(),$e=void 0}});return fe.event}registerChannel(K,ee){this.a.set(K,ee);for(const re of this.f)re.channelServer.registerChannel(K,ee)}dispose(){this.j.dispose();for(const K of this.f)K.channelClient.dispose(),K.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ki=v;class f{constructor(K,ee,re=null){const ge=new i;E(ge,ee),K.send(ge.buffer),this.a=new C(K,re),this.d=new y(K,ee,re)}getChannel(K){return this.a.getChannel(K)}registerChannel(K,ee){this.d.registerChannel(K,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$li=f;function N(q){return{call(K,ee,re){return q.then(ge=>ge.call(K,ee,re))},listen(K,ee){const re=new p.$we;return q.then(ge=>re.input=ge.listen(K,ee)),re.event}}}function F(q){let K=!1;return{call(ee,re,ge){return K?q.call(ee,re,ge):(0,a.$Hh)(0).then(()=>K=!0).then(()=>q.call(ee,re,ge))},listen(ee,re){if(K)return q.listen(ee,re);const ge=new p.$we;return(0,a.$Hh)(0).then(()=>K=!0).then(()=>ge.input=q.listen(ee,re)),ge.event}}}class j{constructor(K){this.a=K}routeCall(K){return this.b(K)}routeEvent(K){return this.b(K)}async b(K){for(const ee of K.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await p.Event.toPromise(K.onDidAddConnection),await this.b(K)}}e.$oi=j;var z;(function(q){function K(Z,$e,fe){const oe=Z,H=fe&&fe.disableMarshalling,ue=new Map;for(const te in oe)re(te)&&ue.set(te,p.Event.buffer(oe[te],!0,void 0,$e));return new class{listen(te,_,ne){const le=ue.get(_);if(le)return le;const J=oe[_];if(typeof J=="function"){if(ge(_))return J.call(oe,ne);if(re(_))return ue.set(_,p.Event.buffer(oe[_],!0,void 0,$e)),ue.get(_)}throw new R.$eb(`Event not found: ${_}`)}call(te,_,ne){const le=oe[_];if(typeof le=="function"){if(!H&&Array.isArray(ne))for(let ce=0;ce<ne.length;ce++)ne[ce]=(0,I.$di)(ne[ce]);let J=le.apply(oe,ne);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new R.$eb(`Method not found: ${_}`)}}}q.fromService=K;function ee(Z,$e){const fe=$e&&$e.disableMarshalling;return new Proxy({},{get(oe,H){if(typeof H=="string")return $e?.properties?.has(H)?$e.properties.get(H):ge(H)?function(ue){return Z.listen(H,ue)}:re(H)?Z.listen(H):async function(...ue){let te;$e&&!(0,h.$pg)($e.context)?te=[$e.context,...ue]:te=ue;const _=await Z.call(H,te);return fe?_:(0,I.$di)(_)};throw new R.$eb(`Property not found: ${String(H)}`)}})}q.toService=ee;function re(Z){return Z[0]==="o"&&Z[1]==="n"&&S.$Gf(Z.charCodeAt(2))}function ge(Z){return/^onDynamic/.test(Z)&&S.$Gf(Z.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function L(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const K=q.toString();if(K!=="[object Object]")return K}return q}function B(q){return Array.isArray(q)?q.map(L):L(q)}function W(q,K,ee,re,ge,Z,$e){$e=B($e);const fe=M[ge],oe=fe[re%fe.length];let H=[`%c[${q}]%c[${String(K).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${oe}`];/\($/.test(Z)?(H=H.concat($e),H.push(")")):H.push($e),console.log.apply(console,H)}class ae{constructor(K,ee){this.d=K,this.f=ee,this.a=0,this.b=0}logOutgoing(K,ee,re,ge,Z){this.b+=K,W(this.d,this.b,K,ee,re,ge,Z)}logIncoming(K,ee,re,ge,Z){this.a+=K,W(this.f,this.a,K,ee,re,ge,Z)}}e.$pi=ae}),define(Se[69],De([1,0,22,4,3,87]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.ProtocolConstants=e.$qi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(u){u.enableDiagnostics=!1,u.records=[];const b=new WeakMap;let E=0;function D(T,C){if(!b.has(T)){const v=String(++E);b.set(T,v)}return b.get(T)}function y(T,C,v,f){if(!u.enableDiagnostics)return;const N=D(T,C);if(f instanceof r.$Pe||f instanceof Uint8Array||f instanceof ArrayBuffer||ArrayBuffer.isView(f)){const F=r.$Pe.alloc(f.byteLength);F.set(f),u.records.push({timestamp:Date.now(),id:N,label:C,type:v,buff:F})}else u.records.push({timestamp:Date.now(),id:N,label:C,type:v,data:f})}u.traceSocketEvent=y})(R||(e.SocketDiagnostics=R={}));var p;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let c=null;function I(){return c||(c=r.$Pe.alloc(0)),c}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(b){this.a.push(b),this.b+=b.byteLength}read(b){return this.c(b,!0)}peek(b){return this.c(b,!1)}c(b,E){if(b===0)return I();if(b>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===b){const C=this.a[0];return E&&(this.a.shift(),this.b-=b),C}if(this.a[0].byteLength>b){const C=this.a[0].slice(0,b);return E&&(this.a[0]=this.a[0].slice(b),this.b-=b),C}const D=r.$Pe.alloc(b);let y=0,T=0;for(;b>0;){const C=this.a[T];if(C.byteLength>b){const v=C.slice(0,b);D.set(v,y),y+=b,E&&(this.a[T]=C.slice(b),this.b-=b),b-=b}else D.set(C,y),y+=C.byteLength,E?(this.a.shift(),this.b-=C.byteLength):T++,b-=C.byteLength}return D}}e.$qi=S;var h;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(h||(h={}));function P(u){switch(u){case h.None:return"None";case h.Regular:return"Regular";case h.Control:return"Control";case h.Ack:return"Ack";case h.Disconnect:return"Disconnect";case h.ReplayRequest:return"ReplayRequest";case h.Pause:return"PauseWriting";case h.Resume:return"ResumeWriting";case h.KeepAlive:return"KeepAlive"}}var w;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class l{constructor(b,E,D,y){this.type=b,this.id=E,this.ack=D,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends k.$Xc{constructor(b){super(),this.f=this.B(new a.$ne),this.onMessage=this.f.event,this.g={readHead:!0,readLen:w.HeaderLength,messageType:h.None,id:0,ack:0},this.a=b,this.b=!1,this.c=new S,this.B(this.a.onData(E=>this.acceptChunk(E))),this.lastReadTime=Date.now()}acceptChunk(b){if(!(!b||b.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(b);this.c.byteLength>=this.g.readLen;){const E=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=E.readUInt32BE(9),this.g.messageType=E.readUInt8(0),this.g.id=E.readUInt32BE(1),this.g.ack=E.readUInt32BE(5),this.a.traceSocketEvent(O.ProtocolHeaderRead,{messageType:P(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,y=this.g.id,T=this.g.ack;if(this.g.readHead=!0,this.g.readLen=w.HeaderLength,this.g.messageType=h.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(O.ProtocolMessageRead,E),this.f.fire(new l(D,y,T,E)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(b){this.k=null,this.a=!1,this.b=!1,this.c=b,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(b){if(this.a)return;b.writtenTime=Date.now(),this.lastWriteTime=Date.now();const E=r.$Pe.alloc(w.HeaderLength);E.writeUInt8(b.type,0),E.writeUInt32BE(b.id,1),E.writeUInt32BE(b.ack,5),E.writeUInt32BE(b.data.byteLength,9),this.c.traceSocketEvent(O.ProtocolHeaderWrite,{messageType:P(b.type),id:b.id,ack:b.ack,messageSize:b.data.byteLength}),this.c.traceSocketEvent(O.ProtocolMessageWrite,b.data),this.j(E,b.data)}g(b,E){const D=this.f===0;return this.d.push(b,E),this.f+=b.byteLength+E.byteLength,D}h(){const b=r.$Pe.concat(this.d,this.f);return this.d.length=0,this.f=0,b}j(b,E){this.g(b,E)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const b=this.h();this.c.traceSocketEvent(O.ProtocolWrite,{byteLength:b.byteLength}),this.c.write(b)}}class $ extends k.$Xc{constructor(b){super(),this.f=new a.$ne,this.onMessage=this.f.event,this.g=new a.$ne,this.onDidDispose=this.g.event,this.a=b,this.b=this.B(new g(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(E=>{E.type===h.Regular&&this.f.fire(E.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(b){this.b.write(new l(h.Regular,0,0,b))}}e.$ri=$;class n extends A.$li{static fromSocket(b,E){return new n(new $(b),E)}get onDidDispose(){return this.b.onDidDispose}constructor(b,E,D=null){super(b,E,D),this.b=b}dispose(){super.dispose();const b=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),b.end()}}e.$si=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$ne({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(b){this.b?this.d.length>0?this.d.push(b):this.a.fire(b):this.d.push(b)}flushBuffer(){this.d=[]}}e.$ti=o;class t{constructor(b){this.data=b,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let b=0,E=this.a;for(;E;)E=E.next,b++;return b}peek(){return this.a?this.a.data:null}toArray(){const b=[];let E=0,D=this.a;for(;D;)b[E++]=D.data,D=D.next;return b}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(b){const E=new t(b);if(!this.a){this.a=E,this.b=E;return}this.b.next=E,this.b=E}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const b=Date.now();for(let E=0;E<s.a;E++)this.c[E]=b-1e3*E;setInterval(()=>{for(let E=s.a;E>=1;E--)this.c[E]=this.c[E-1];this.c[0]=Date.now()},1e3)}d(){const b=Date.now(),E=(1+s.a)*1e3;let D=0;for(let y=0;y<s.a;y++)b-this.c[y]<=E&&D++;return 1-D/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;class d{get unacknowledgedCount(){return this.c-this.d}constructor(b){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=b.loadEstimator??s.getInstance(),this.t=b.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new k.$Wc,this.o=b.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(E=>this.z(E))),this.r.add(this.o.onClose(E=>this.x.fire(E))),b.initialChunk&&this.q.acceptChunk(b.initialChunk),this.t?this.l=setInterval(()=>{this.D()},w.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const b=new l(h.Disconnect,0,0,I());this.p.write(b),this.p.flush()}sendPause(){const b=new l(h.Pause,0,0,I());this.p.write(b)}sendResume(){const b=new l(h.Resume,0,0,I());this.p.write(b)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(b,E){this.a=!0,this.r.dispose(),this.r=new k.$Wc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=b,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(D=>this.z(D))),this.r.add(this.o.onClose(D=>this.x.fire(D))),this.q.acceptChunk(E)}endAcceptReconnection(){this.a=!1,this.h=this.g;const b=new l(h.Ack,0,this.h,I());this.p.write(b);const E=this.b.toArray();for(let D=0,y=E.length;D<y;D++)this.p.write(E[D]);this.B()}acceptDisconnect(){this.w.fire()}z(b){if(b.ack>this.d){this.d=b.ack;do{const E=this.b.peek();if(E&&E.id<=b.ack)this.b.pop();else break}while(!0)}switch(b.type){case h.None:break;case h.Regular:{if(b.id>this.g)if(b.id!==this.g+1){const E=Date.now();E-this.m>1e4&&(this.m=E,this.p.write(new l(h.ReplayRequest,0,0,I())))}else this.g=b.id,this.j=Date.now(),this.A(),this.v.fire(b.data);break}case h.Control:{this.u.fire(b.data);break}case h.Ack:break;case h.Disconnect:{this.w.fire();break}case h.ReplayRequest:{const E=this.b.toArray();for(let D=0,y=E.length;D<y;D++)this.p.write(E[D]);this.B();break}case h.Pause:{this.p.pause();break}case h.Resume:{this.p.resume();break}case h.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(b){const E=++this.c;this.h=this.g;const D=new l(h.Regular,E,this.h,b);this.b.push(D),this.a||(this.p.write(D),this.B())}sendControl(b){const E=new l(h.Control,0,0,b);this.p.write(E)}A(){if(this.g<=this.h||this.k)return;const b=Date.now()-this.j;if(b>=w.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},w.AcknowledgeTime-b+5)}B(){if(this.c<=this.d||this.f||this.a)return;const b=this.b.peek(),E=Date.now()-b.writtenTime,D=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(E>=w.TimeoutTime&&D>=w.TimeoutTime&&y>=w.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:E,timeSinceLastReceivedSomeData:D});return}const T=Math.max(w.TimeoutTime-E,w.TimeoutTime-D,w.TimeoutTime-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},T)}C(){if(this.g<=this.h)return;this.h=this.g;const b=new l(h.Ack,0,this.h,I());this.p.write(b)}D(){this.h=this.g;const b=new l(h.KeepAlive,0,this.h,I());this.p.write(b)}}e.$ui=d}),define(Se[192],De([1,0,56,7,22,21,188,14,4,3,25,110,105,87]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0,R=Ue(R);class w extends P.$ii{constructor(g){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",$=>k.$Pe.wrap(Buffer.from($,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$gr=w;class l{constructor(g,$){this.i=g,this.j=$,this.c=new Set,this.g=new Map,this.h=new p.$ne,this.onDidProcessExit=this.h.event;const n=$&&$.timeout?$.timeout:6e4;this.b=new a.$Dh(n),this.d=null,this.f=null}getChannel(g){const $=this;return{call(n,o,t){return $.k(g,n,o,t)},listen(n,o){return $.l(g,n,o)}}}k(g,$,n,o=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(R.$9());this.b.cancel();const t=this.n(g),i=(0,a.$th)(u=>t.call($,n,u)),s=o.onCancellationRequested(()=>i.cancel()),d=(0,c.$Vc)(()=>i.cancel());return this.c.add(d),i.finally(()=>{s.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(g,$,n){if(!this.b)return p.Event.None;this.b.cancel();let o;const t=new p.$ne({onWillAddFirstListener:()=>{o=this.n(g).listen($,n)(t.fire,t),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,I.$fo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(E=>!/^--inspect(-brk)?=/.test(E)).filter(E=>!E.startsWith("--vscode-"))),(0,h.$mm)($.env),this.d=(0,r.fork)(this.i,g,$);const n=new p.$ne,t=p.Event.fromNodeEventEmitter(this.d,"message",E=>E)(E=>{if((0,O.$cr)(E)){(0,O.log)(E,`IPC Library: ${this.j.serverName}`);return}n.fire(k.$Pe.wrap(Buffer.from(E,"base64")))}),i=this.j.useQueue?(0,S.$zm)(this.d):this.d,s=E=>this.d&&this.d.connected&&i.send(E.buffer.toString("base64")),d=n.event,u={send:s,onMessage:d};this.f=new P.$ji(u);const b=()=>this.o();process.once("exit",b),this.d.on("error",E=>console.warn('IPC "'+this.j.serverName+'" errored with '+E)),this.d.on("exit",(E,D)=>{process.removeListener("exit",b),t.dispose(),this.c.forEach(y=>(0,c.$Sc)(y)),this.c.clear(),E!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+E+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:E,signal:D})})}return this.f}n(g){let $=this.g.get(g);return $||($=this.m.getChannel(g),this.g.set(g,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$hr=l}),define(Se[193],De([1,0,7,4,3,55,18]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.StorageState=e.StorageHint=void 0,e.$cq=p;var R;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function p(h){const P=h;return P?.changed instanceof Map||P?.deleted instanceof Set}var c;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(c||(e.StorageState=c={}));class I extends k.$Xc{constructor(P,w=Object.create(null)){super(),this.r=P,this.s=w,this.b=this.B(new a.$qe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new r.$Eh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(P=>this.u(P)))}u(P){this.b.pause();try{P.changed?.forEach((w,l)=>this.w(l,w)),P.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(P,w){if(this.c===c.Closed)return;let l=!1;(0,O.$pg)(w)?l=this.f.delete(P):this.f.get(P)!==w&&(this.f.set(P,w),l=!0),l&&this.b.fire({key:P,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(P,w){const l=this.f.get(P);return(0,O.$pg)(l)?w:l}getBoolean(P,w){const l=this.get(P);return(0,O.$pg)(l)?w:l==="true"}getNumber(P,w){const l=this.get(P);return(0,O.$pg)(l)?w:parseInt(l,10)}getObject(P,w){const l=this.get(P);return(0,O.$pg)(l)?w:(0,A.$ci)(l)}async set(P,w,l=!1){if(this.c===c.Closed)return;if((0,O.$pg)(w))return this.delete(P,l);const m=(0,O.$ig)(w)||Array.isArray(w)?(0,A.$bi)(w):String(w);if(this.f.get(P)!==m)return this.f.set(P,m),this.j.set(P,m),this.h.delete(P),this.b.fire({key:P,external:l}),this.D()}async delete(P,w=!1){if(!(this.c===c.Closed||!this.f.delete(P)))return this.h.has(P)||this.h.add(P),this.j.delete(P),this.b.fire({key:P,external:w}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const P={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(P).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(P){if(!(this.c===c.Closed||this.m))return this.D(P)}async D(P){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),P)}async whenFlushed(){if(this.z)return new Promise(P=>this.n.push(P))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$dq=I,I.a=100;class S{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(P){P.insert?.forEach((w,l)=>this.a.set(l,w)),P.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$eq=S}),define(Se[141],De([1,0,84]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gu=e.$fu=void 0;class a{constructor(R){const p=(0,r.$cf)(R);this.c=p,this.a=a.d(p),this.b=new Map}static d(R){const p=new Uint8Array(256);return p.fill(R),p}set(R,p){const c=(0,r.$cf)(p);R>=0&&R<256?this.a[R]=c:this.b.set(R,c)}get(R){return R>=0&&R<256?this.a[R]:this.b.get(R)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$fu=a;var k;(function(O){O[O.False=0]="False",O[O.True=1]="True"})(k||(k={}));class A{constructor(){this.a=new a(k.False)}add(R){this.a.set(R,k.True)}has(R){return this.a.get(R)===k.True}clear(){return this.a.clear()}}e.$gu=A}),define(Se[194],De([1,0,27]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$xu=k;var a;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(a||(e.StringEOL=a={}));function k(A){let O=0,R=0,p=0,c=a.Unknown;for(let I=0,S=A.length;I<S;I++){const h=A.charCodeAt(I);h===r.CharCode.CarriageReturn?(O===0&&(R=I),O++,I+1<S&&A.charCodeAt(I+1)===r.CharCode.LineFeed?(c|=a.CRLF,I++):c|=a.Invalid,p=I+1):h===r.CharCode.LineFeed&&(c|=a.LF,O===0&&(R=I),O++,p=I+1)}return O===0&&(R=A.length),[O,R,A.length-p,c]}}),define(Se[57],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class r{constructor(k,A){this.lineNumber=k,this.column=A}with(k=this.lineNumber,A=this.column){return k===this.lineNumber&&A===this.column?this:new r(k,A)}delta(k=0,A=0){return this.with(this.lineNumber+k,this.column+A)}equals(k){return r.equals(this,k)}static equals(k,A){return!k&&!A?!0:!!k&&!!A&&k.lineNumber===A.lineNumber&&k.column===A.column}isBefore(k){return r.isBefore(this,k)}static isBefore(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<A.column}isBeforeOrEqual(k){return r.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,A){return k.lineNumber<A.lineNumber?!0:A.lineNumber<k.lineNumber?!1:k.column<=A.column}static compare(k,A){const O=k.lineNumber|0,R=A.lineNumber|0;if(O===R){const p=k.column|0,c=A.column|0;return p-c}return O-R}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new r(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Mt=r}),define(Se[31],De([1,0,57]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class a{constructor(A,O,R,p){A>R||A===R&&O>p?(this.startLineNumber=R,this.startColumn=p,this.endLineNumber=A,this.endColumn=O):(this.startLineNumber=A,this.startColumn=O,this.endLineNumber=R,this.endColumn=p)}isEmpty(){return a.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return a.containsPosition(this,A)}static containsPosition(A,O){return!(O.lineNumber<A.startLineNumber||O.lineNumber>A.endLineNumber||O.lineNumber===A.startLineNumber&&O.column<A.startColumn||O.lineNumber===A.endLineNumber&&O.column>A.endColumn)}static strictContainsPosition(A,O){return!(O.lineNumber<A.startLineNumber||O.lineNumber>A.endLineNumber||O.lineNumber===A.startLineNumber&&O.column<=A.startColumn||O.lineNumber===A.endLineNumber&&O.column>=A.endColumn)}containsRange(A){return a.containsRange(this,A)}static containsRange(A,O){return!(O.startLineNumber<A.startLineNumber||O.endLineNumber<A.startLineNumber||O.startLineNumber>A.endLineNumber||O.endLineNumber>A.endLineNumber||O.startLineNumber===A.startLineNumber&&O.startColumn<A.startColumn||O.endLineNumber===A.endLineNumber&&O.endColumn>A.endColumn)}strictContainsRange(A){return a.strictContainsRange(this,A)}static strictContainsRange(A,O){return!(O.startLineNumber<A.startLineNumber||O.endLineNumber<A.startLineNumber||O.startLineNumber>A.endLineNumber||O.endLineNumber>A.endLineNumber||O.startLineNumber===A.startLineNumber&&O.startColumn<=A.startColumn||O.endLineNumber===A.endLineNumber&&O.endColumn>=A.endColumn)}plusRange(A){return a.plusRange(this,A)}static plusRange(A,O){let R,p,c,I;return O.startLineNumber<A.startLineNumber?(R=O.startLineNumber,p=O.startColumn):O.startLineNumber===A.startLineNumber?(R=O.startLineNumber,p=Math.min(O.startColumn,A.startColumn)):(R=A.startLineNumber,p=A.startColumn),O.endLineNumber>A.endLineNumber?(c=O.endLineNumber,I=O.endColumn):O.endLineNumber===A.endLineNumber?(c=O.endLineNumber,I=Math.max(O.endColumn,A.endColumn)):(c=A.endLineNumber,I=A.endColumn),new a(R,p,c,I)}intersectRanges(A){return a.intersectRanges(this,A)}static intersectRanges(A,O){let R=A.startLineNumber,p=A.startColumn,c=A.endLineNumber,I=A.endColumn;const S=O.startLineNumber,h=O.startColumn,P=O.endLineNumber,w=O.endColumn;return R<S?(R=S,p=h):R===S&&(p=Math.max(p,h)),c>P?(c=P,I=w):c===P&&(I=Math.min(I,w)),R>c||R===c&&p>I?null:new a(R,p,c,I)}equalsRange(A){return a.equalsRange(this,A)}static equalsRange(A,O){return!A&&!O?!0:!!A&&!!O&&A.startLineNumber===O.startLineNumber&&A.startColumn===O.startColumn&&A.endLineNumber===O.endLineNumber&&A.endColumn===O.endColumn}getEndPosition(){return a.getEndPosition(this)}static getEndPosition(A){return new r.$Mt(A.endLineNumber,A.endColumn)}getStartPosition(){return a.getStartPosition(this)}static getStartPosition(A){return new r.$Mt(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,O){return new a(this.startLineNumber,this.startColumn,A,O)}setStartPosition(A,O){return new a(A,O,this.endLineNumber,this.endColumn)}collapseToStart(){return a.collapseToStart(this)}static collapseToStart(A){return new a(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return a.collapseToEnd(this)}static collapseToEnd(A){return new a(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new a(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,O=A){return new a(A.lineNumber,A.column,O.lineNumber,O.column)}static lift(A){return A?new a(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,O){return!(A.endLineNumber<O.startLineNumber||A.endLineNumber===O.startLineNumber&&A.endColumn<O.startColumn||O.endLineNumber<A.startLineNumber||O.endLineNumber===A.startLineNumber&&O.endColumn<A.startColumn)}static areIntersecting(A,O){return!(A.endLineNumber<O.startLineNumber||A.endLineNumber===O.startLineNumber&&A.endColumn<=O.startColumn||O.endLineNumber<A.startLineNumber||O.endLineNumber===A.startLineNumber&&O.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,O){if(A&&O){const c=A.startLineNumber|0,I=O.startLineNumber|0;if(c===I){const S=A.startColumn|0,h=O.startColumn|0;if(S===h){const P=A.endLineNumber|0,w=O.endLineNumber|0;if(P===w){const l=A.endColumn|0,m=O.endColumn|0;return l-m}return P-w}return S-h}return c-I}return(A?1:0)-(O?1:0)}static compareRangesUsingEnds(A,O){return A.endLineNumber===O.endLineNumber?A.endColumn===O.endColumn?A.startLineNumber===O.startLineNumber?A.startColumn-O.startColumn:A.startLineNumber-O.startLineNumber:A.endColumn-O.endColumn:A.endLineNumber-O.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$Nt=a}),define(Se[195],De([1,0,31]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class a{static insert(A,O){return{range:new r.$Nt(A.lineNumber,A.column,A.lineNumber,A.column),text:O,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,O){return{range:A,text:O}}static replaceMove(A,O){return{range:A,text:O,forceMoveMarkers:!0}}}e.$Ot=a}),define(Se[196],De([1,0,57,31]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=e.SelectionDirection=void 0;var k;(function(O){O[O.LTR=0]="LTR",O[O.RTL=1]="RTL"})(k||(e.SelectionDirection=k={}));class A extends a.$Nt{constructor(R,p,c,I){super(R,p,c,I),this.selectionStartLineNumber=R,this.selectionStartColumn=p,this.positionLineNumber=c,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(R){return A.selectionsEqual(this,R)}static selectionsEqual(R,p){return R.selectionStartLineNumber===p.selectionStartLineNumber&&R.selectionStartColumn===p.selectionStartColumn&&R.positionLineNumber===p.positionLineNumber&&R.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?k.LTR:k.RTL}setEndPosition(R,p){return this.getDirection()===k.LTR?new A(this.startLineNumber,this.startColumn,R,p):new A(R,p,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Mt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Mt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(R,p){return this.getDirection()===k.LTR?new A(R,p,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,R,p)}static fromPositions(R,p=R){return new A(R.lineNumber,R.column,p.lineNumber,p.column)}static fromRange(R,p){return p===k.LTR?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):new A(R.endLineNumber,R.endColumn,R.startLineNumber,R.startColumn)}static liftSelection(R){return new A(R.selectionStartLineNumber,R.selectionStartColumn,R.positionLineNumber,R.positionColumn)}static selectionsArrEqual(R,p){if(R&&!p||!R&&p)return!1;if(!R&&!p)return!0;if(R.length!==p.length)return!1;for(let c=0,I=R.length;c<I;c++)if(!this.selectionsEqual(R[c],p[c]))return!1;return!0}static isISelection(R){return R&&typeof R.selectionStartLineNumber=="number"&&typeof R.selectionStartColumn=="number"&&typeof R.positionLineNumber=="number"&&typeof R.positionColumn=="number"}static createWithDirection(R,p,c,I,S){return S===k.LTR?new A(R,p,c,I):new A(c,I,R,p)}}e.$Pt=A}),define(Se[197],De([1,0,13,11,22]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=void 0,e.$au=I,e.$bu=S,r=Ue(r),a=Ue(a),k=Ue(k);let A;function O(){return A||(A=new TextDecoder("UTF-16LE")),A}let R;function p(){return R||(R=new TextDecoder("UTF-16BE")),R}let c;function I(){return c||(c=a.$x()?O():p()),c}function S(w,l,m){const g=new Uint16Array(w.buffer,l,m);return m>0&&(g[0]===65279||g[0]===65534)?h(w,l,m):O().decode(g)}function h(w,l,m){const g=[];let $=0;for(let n=0;n<m;n++){const o=k.$Re(w,l);l+=2,g[$++]=String.fromCharCode(o)}return g.join("")}class P{constructor(l){this.a=l|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const l=new Uint16Array(this.b.buffer,0,this.d);return I().decode(l)}f(){const l=this.e();this.d=0,this.c===null?this.c=[l]:this.c[this.c.length]=l}appendCharCode(l){const m=this.a-this.d;m<=1&&(m===0||r.$Lf(l))&&this.f(),this.b[this.d++]=l}appendASCIICharCode(l){this.d===this.a&&this.f(),this.b[this.d++]=l}appendString(l){const m=l.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=l;return}for(let g=0;g<m;g++)this.b[this.d++]=l.charCodeAt(g)}}e.$cu=P}),define(Se[198],De([1,0,22,197]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=void 0,e.$eu=O,r=Ue(r);function k(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,I,S,h){this.oldPosition=c,this.oldText=I,this.newPosition=S,this.newText=h}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${k(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${k(this.oldText)}")`:`(replace@${this.oldPosition} "${k(this.oldText)}" with "${k(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,I,S){const h=I.length;r.$Ue(c,h,S),S+=4;for(let P=0;P<h;P++)r.$Se(c,I.charCodeAt(P),S),S+=2;return S}static d(c,I){const S=r.$Te(c,I);return I+=4,(0,a.$bu)(c,I,S)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(c,I){return r.$Ue(c,this.oldPosition,I),I+=4,r.$Ue(c,this.newPosition,I),I+=4,I=A.c(c,this.oldText,I),I=A.c(c,this.newText,I),I}static read(c,I,S){const h=r.$Te(c,I);I+=4;const P=r.$Te(c,I);I+=4;const w=A.d(c,I);I+=A.a(w);const l=A.d(c,I);return I+=A.a(l),S.push(new A(h,w,P,l)),I}}e.$du=A;function O(p,c){return p===null||p.length===0?c:new R(p,c).compress()}class R{constructor(c,I){this.a=c,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,I=0,S=this.n(c),h=this.l(I);for(;c<this.f||I<this.h;){if(S===null){this.k(h),h=this.l(++I);continue}if(h===null){this.m(S),S=this.n(++c);continue}if(h.oldEnd<=S.newPosition){this.k(h),h=this.l(++I);continue}if(S.newEnd<=h.oldPosition){this.m(S),S=this.n(++c);continue}if(h.oldPosition<S.newPosition){const[g,$]=R.r(h,S.newPosition-h.oldPosition);this.k(g),h=$;continue}if(S.newPosition<h.oldPosition){const[g,$]=R.q(S,h.oldPosition-S.newPosition);this.m(g),S=$;continue}let l,m;if(h.oldEnd===S.newEnd)l=S,m=h,S=this.n(++c),h=this.l(++I);else if(h.oldEnd<S.newEnd){const[g,$]=R.q(S,h.oldLength);l=g,m=h,S=$,h=this.l(++I)}else{const[g,$]=R.r(h,S.newLength);l=S,m=g,S=this.n(++c),h=$}this.d[this.e++]=new A(l.oldPosition,l.oldText,m.newPosition,m.newText),this.g+=l.newLength-l.oldLength,this.j+=m.newLength-m.oldLength}const P=R.s(this.d);return R.t(P)}k(c){this.d[this.e++]=R.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=R.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,I){return new A(I.oldPosition-c,I.oldText,I.newPosition,I.newText)}static p(c,I){return new A(I.oldPosition,I.oldText,I.newPosition+c,I.newText)}static q(c,I){const S=c.newText.substr(0,I),h=c.newText.substr(I);return[new A(c.oldPosition,c.oldText,c.newPosition,S),new A(c.oldEnd,"",c.newPosition+I,h)]}static r(c,I){const S=c.oldText.substr(0,I),h=c.oldText.substr(I);return[new A(c.oldPosition,S,c.newPosition,c.newText),new A(c.oldPosition+I,h,c.newEnd,"")]}static s(c){if(c.length===0)return c;const I=[];let S=0,h=c[0];for(let P=1;P<c.length;P++){const w=c[P];h.oldEnd===w.oldPosition?h=new A(h.oldPosition,h.oldText+w.oldText,h.newPosition,h.newText+w.newText):(I[S++]=h,h=w)}return I[S++]=h,I}static t(c){if(c.length===0)return c;const I=[];let S=0;for(let h=0;h<c.length;h++){const P=c[h];P.oldText!==P.newText&&(I[S++]=P)}return I}}}),define(Se[199],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0,e.$kt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[200],De([1,0,27,29,141]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hu=e.WordCharacterClass=void 0,e.$iu=p;var A;(function(c){c[c.Regular=0]="Regular",c[c.Whitespace=1]="Whitespace",c[c.WordSeparator=2]="WordSeparator"})(A||(e.WordCharacterClass=A={}));class O extends k.$fu{constructor(I,S){super(A.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=S,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let h=0,P=I.length;h<P;h++)this.set(I.charCodeAt(h),A.WordSeparator);this.set(r.CharCode.Space,A.Whitespace),this.set(r.CharCode.Tab,A.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,S){let h=null;for(const P of this.h(I)){if(P.index>S)break;h=P}return h}findNextIntlWordAtOrAfterOffset(I,S){for(const h of this.h(I))if(!(h.index<S))return h;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const S=[];for(const h of I)this.k(h)&&S.push(h);return S}k(I){return!!I.isWordLike}}e.$hu=O;const R=new a.$Gc(10);function p(c,I){const S=`${c}/${I.join(",")}`;let h=R.get(S);return h||(h=new O(c,I),R.set(S,h)),h}}),define(Se[142],De([1,0,40,3,81]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.$lt=void 0,e.$nt=O,e.$ot=p,e.$pt=c,e.$lt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(S=""){let h="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.$lt)S.indexOf(P)>=0||(h+="\\"+P);return h+="\\s]+)",new RegExp(h,"g")}e.$mt=A();function O(S){let h=e.$mt;if(S&&S instanceof RegExp)if(S.global)h=S;else{let P="g";S.ignoreCase&&(P+="i"),S.multiline&&(P+="m"),S.unicode&&(P+="u"),h=new RegExp(S.source,P)}return h.lastIndex=0,h}const R=new k.$8c;R.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(S){const h=R.unshift(S);return(0,a.$Vc)(h)}function c(S,h,P,w,l){if(h=O(h),l||(l=r.Iterable.first(R)),P.length>l.maxLen){let o=S-l.maxLen/2;return o<0?o=0:w+=o,P=P.substring(o,S+l.maxLen/2),c(S,h,P,w,l)}const m=Date.now(),g=S-1-w;let $=-1,n=null;for(let o=1;!(Date.now()-m>=l.timeBudget);o++){const t=g-l.windowSize*o;h.lastIndex=Math.max(0,t);const i=I(h,P,g,$);if(!i&&n||(n=i,t<=0))break;$=t}if(n){const o={word:n[0],startColumn:w+1+n.index,endColumn:w+1+n.index+n[0].length};return h.lastIndex=0,o}return null}function I(S,h,P,w){let l;for(;l=S.exec(h);){const m=l.index||0;if(m<=P&&S.lastIndex>=P)return l;if(w>0&&m>w)return null}return null}}),define(Se[111],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var a;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline",p[p.Strikethrough=8]="Strikethrough"})(a||(e.FontStyle=a={}));var k;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var A;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=3]="RegEx"})(A||(e.StandardTokenType=A={}));var O;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",p[p.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",p[p.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",p[p.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(O||(e.MetadataConsts=O={}));class R{static getLanguageId(c){return(c&O.LANGUAGEID_MASK)>>>O.LANGUAGEID_OFFSET}static getTokenType(c){return(c&O.TOKEN_TYPE_MASK)>>>O.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(c){return(c&O.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(c){return(c&O.FONT_STYLE_MASK)>>>O.FONT_STYLE_OFFSET}static getForeground(c){return(c&O.FOREGROUND_MASK)>>>O.FOREGROUND_OFFSET}static getBackground(c){return(c&O.BACKGROUND_MASK)>>>O.BACKGROUND_OFFSET}static getClassNameFromMetadata(c){let S="mtk"+this.getForeground(c);const h=this.getFontStyle(c);return h&a.Italic&&(S+=" mtki"),h&a.Bold&&(S+=" mtkb"),h&a.Underline&&(S+=" mtku"),h&a.Strikethrough&&(S+=" mtks"),S}static getInlineStyleFromMetadata(c,I){const S=this.getForeground(c),h=this.getFontStyle(c);let P=`color: ${I[S]};`;h&a.Italic&&(P+="font-style: italic;"),h&a.Bold&&(P+="font-weight: bold;");let w="";return h&a.Underline&&(w+=" underline"),h&a.Strikethrough&&(w+=" line-through"),w&&(P+=`text-decoration:${w};`),P}static getPresentationFromMetadata(c){const I=this.getForeground(c),S=this.getFontStyle(c);return{foreground:I,italic:!!(S&a.Italic),bold:!!(S&a.Bold),underline:!!(S&a.Underline),strikethrough:!!(S&a.Strikethrough)}}}e.$tu=R}),define(Se[201],De([1,0,39,17]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uu=k,e.$vu=A;function k(O,R,p,c,I,S){if(Array.isArray(O)){let h=0;for(const P of O){const w=k(P,R,p,c,I,S);if(w===10)return w;w>h&&(h=w)}return h}else{if(typeof O=="string")return c?O==="*"?5:O===p?10:0:0;if(O){const{language:h,pattern:P,scheme:w,hasAccessToAllModels:l,notebookType:m}=O;if(!c&&!l)return 0;m&&I&&(R=I);let g=0;if(w)if(w===R.scheme)g=10;else if(w==="*")g=5;else return 0;if(h)if(h===p)g=10;else if(h==="*")g=Math.max(g,5);else return 0;if(m)if(m===S)g=10;else if(m==="*"&&S!==void 0)g=Math.max(g,5);else return 0;if(P){let $;if(typeof P=="string"?$=P:$={...P,base:(0,a.$kc)(P.base)},$===R.fsPath||(0,r.$zk)($,R.fsPath))g=10;else return 0}return g}else return 0}}function A(O){return typeof O=="string"?!1:Array.isArray(O)?O.some(A):!!O.notebookType}}),define(Se[202],De([1,0,27,111]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.IndentAction=void 0;var k;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(k||(e.IndentAction=k={}));class A{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let I=0,S=c.notIn.length;I<S;I++)switch(c.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case a.StandardTokenType.Other:return!0;case a.StandardTokenType.Comment:return this.c;case a.StandardTokenType.String:return this.b;case a.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,I){if(c.getTokenCount()===0)return!0;const S=c.findTokenIndexAtOffset(I-2),h=c.getStandardTokenType(S);return this.isOK(h)}g(c,I){for(let S=c;S<=I;S++){const h=String.fromCharCode(S);if(!this.open.includes(h)&&!this.close.includes(h))return h}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Uu=A;class O{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of c)R(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),R(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),R(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),R(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&R(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Vu=O;function R(p,c,I){p.has(c)?p.get(c).push(I):p.set(c,[I])}}),define(Se[203],De([1,0,27,141]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w4=e.$v4=e.State=void 0,e.$x4=P;var k;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(k||(e.State=k={}));class A{constructor(l,m,g){const $=new Uint8Array(l*m);for(let n=0,o=l*m;n<o;n++)$[n]=g;this.a=$,this.rows=l,this.cols=m}get(l,m){return this.a[l*this.cols+m]}set(l,m,g){this.a[l*this.cols+m]=g}}class O{constructor(l){let m=0,g=k.Invalid;for(let n=0,o=l.length;n<o;n++){const[t,i,s]=l[n];i>m&&(m=i),t>g&&(g=t),s>g&&(g=s)}m++,g++;const $=new A(g,m,k.Invalid);for(let n=0,o=l.length;n<o;n++){const[t,i,s]=l[n];$.set(t,i,s)}this.a=$,this.b=m}nextState(l,m){return m<0||m>=this.b?k.Invalid:this.a.get(l,m)}}e.$v4=O;let R=null;function p(){return R===null&&(R=new O([[k.Start,r.CharCode.h,k.H],[k.Start,r.CharCode.H,k.H],[k.Start,r.CharCode.f,k.F],[k.Start,r.CharCode.F,k.F],[k.H,r.CharCode.t,k.HT],[k.H,r.CharCode.T,k.HT],[k.HT,r.CharCode.t,k.HTT],[k.HT,r.CharCode.T,k.HTT],[k.HTT,r.CharCode.p,k.HTTP],[k.HTT,r.CharCode.P,k.HTTP],[k.HTTP,r.CharCode.s,k.BeforeColon],[k.HTTP,r.CharCode.S,k.BeforeColon],[k.HTTP,r.CharCode.Colon,k.AfterColon],[k.F,r.CharCode.i,k.FI],[k.F,r.CharCode.I,k.FI],[k.FI,r.CharCode.l,k.FIL],[k.FI,r.CharCode.L,k.FIL],[k.FIL,r.CharCode.e,k.BeforeColon],[k.FIL,r.CharCode.E,k.BeforeColon],[k.BeforeColon,r.CharCode.Colon,k.AfterColon],[k.AfterColon,r.CharCode.Slash,k.AlmostThere],[k.AlmostThere,r.CharCode.Slash,k.End]])),R}var c;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(c||(c={}));let I=null;function S(){if(I===null){I=new a.$fu(c.None);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<w.length;m++)I.set(w.charCodeAt(m),c.ForceTermination);const l=".,;:";for(let m=0;m<l.length;m++)I.set(l.charCodeAt(m),c.CannotEndIn)}return I}class h{static a(l,m,g,$,n){let o=n-1;do{const t=m.charCodeAt(o);if(l.get(t)!==c.CannotEndIn)break;o--}while(o>$);if($>0){const t=m.charCodeAt($-1),i=m.charCodeAt(o);(t===r.CharCode.OpenParen&&i===r.CharCode.CloseParen||t===r.CharCode.OpenSquareBracket&&i===r.CharCode.CloseSquareBracket||t===r.CharCode.OpenCurlyBrace&&i===r.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:g,startColumn:$+1,endLineNumber:g,endColumn:o+2},url:m.substring($,o+1)}}static computeLinks(l,m=p()){const g=S(),$=[];for(let n=1,o=l.getLineCount();n<=o;n++){const t=l.getLineContent(n),i=t.length;let s=0,d=0,u=0,b=k.Start,E=!1,D=!1,y=!1,T=!1;for(;s<i;){let C=!1;const v=t.charCodeAt(s);if(b===k.Accept){let f;switch(v){case r.CharCode.OpenParen:E=!0,f=c.None;break;case r.CharCode.CloseParen:f=E?c.None:c.ForceTermination;break;case r.CharCode.OpenSquareBracket:y=!0,D=!0,f=c.None;break;case r.CharCode.CloseSquareBracket:y=!1,f=D?c.None:c.ForceTermination;break;case r.CharCode.OpenCurlyBrace:T=!0,f=c.None;break;case r.CharCode.CloseCurlyBrace:f=T?c.None:c.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:u===v?f=c.ForceTermination:u===r.CharCode.SingleQuote||u===r.CharCode.DoubleQuote||u===r.CharCode.BackTick?f=c.None:f=c.ForceTermination;break;case r.CharCode.Asterisk:f=u===r.CharCode.Asterisk?c.ForceTermination:c.None;break;case r.CharCode.Pipe:f=u===r.CharCode.Pipe?c.ForceTermination:c.None;break;case r.CharCode.Space:f=y?c.None:c.ForceTermination;break;default:f=g.get(v)}f===c.ForceTermination&&($.push(h.a(g,t,n,d,s)),C=!0)}else if(b===k.End){let f;v===r.CharCode.OpenSquareBracket?(D=!0,f=c.None):f=g.get(v),f===c.ForceTermination?C=!0:b=k.Accept}else b=m.nextState(b,v),b===k.Invalid&&(C=!0);C&&(b=k.Start,E=!1,D=!1,T=!1,d=s+1,u=v),s++}b===k.Accept&&$.push(h.a(g,t,n,d,i))}return $}}e.$w4=h;function P(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:h.computeLinks(w)}}),define(Se[58],De([1,0,25]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$ew=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$cw=e.$bw=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$dw=w,e.$hw=o;var a;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(a||(e.OverviewRulerLane=a={}));var k;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=3]="Right"})(k||(e.GlyphMarginLane=k={}));var A;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var O;(function(t){t[t.Normal=1]="Normal",t[t.Underlined=2]="Underlined"})(O||(e.MinimapSectionHeaderStyle=O={}));var R;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var p;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var c;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(e.DefaultEndOfLine=c={}));var I;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class S{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(i){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,i.tabSize|0),i.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,i.indentSize|0),this.a=!1),this.insertSpaces=!!i.insertSpaces,this.defaultEOL=i.defaultEOL|0,this.trimAutoWhitespace=!!i.trimAutoWhitespace,this.bracketPairColorizationOptions=i.bracketPairColorizationOptions}equals(i){return this.tabSize===i.tabSize&&this.a===i.a&&this.indentSize===i.indentSize&&this.insertSpaces===i.insertSpaces&&this.defaultEOL===i.defaultEOL&&this.trimAutoWhitespace===i.trimAutoWhitespace&&(0,r.$jo)(this.bracketPairColorizationOptions,i.bracketPairColorizationOptions)}createChangeEvent(i){return{tabSize:this.tabSize!==i.tabSize,indentSize:this.indentSize!==i.indentSize,insertSpaces:this.insertSpaces!==i.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==i.trimAutoWhitespace}}}e.$bw=S;class h{constructor(i,s){this._findMatchBrand=void 0,this.range=i,this.matches=s}}e.$cw=h;var P;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P||(e.TrackedRangeStickiness=P={}));function w(t){return t&&typeof t.read=="function"}var l;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(l||(e.PositionAffinity=l={}));var m;(function(t){t[t.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class g{constructor(i,s,d,u,b,E){this.identifier=i,this.range=s,this.text=d,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=b,this._isTracked=E}}e.$ew=g;class ${constructor(i,s,d){this.regex=i,this.wordSeparators=s,this.simpleSearch=d}}e.$fw=$;class n{constructor(i,s,d){this.reverseEdits=i,this.changes=s,this.trimAutoWhitespaceLineNumbers=d}}e.$gw=n;function o(t){return!t.isTooLargeForSyncing()&&!t.isForSimpleWidget}}),define(Se[204],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=e.NodeColor=e.$4C=void 0,e.$6C=k,e.$7C=A,e.$8C=c,e.$9C=I,e.$0C=S,e.$$C=h,e.$_C=P,e.$aD=w;class r{constructor(m,g){this.piece=m,this.color=g,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$5C)return k(this.right);let m=this;for(;m.parent!==e.$5C&&m.parent.left!==m;)m=m.parent;return m.parent===e.$5C?e.$5C:m.parent}prev(){if(this.left!==e.$5C)return A(this.left);let m=this;for(;m.parent!==e.$5C&&m.parent.right!==m;)m=m.parent;return m.parent===e.$5C?e.$5C:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$4C=r;var a;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(a||(e.NodeColor=a={})),e.$5C=new r(null,a.Black),e.$5C.parent=e.$5C,e.$5C.left=e.$5C,e.$5C.right=e.$5C,e.$5C.color=a.Black;function k(l){for(;l.left!==e.$5C;)l=l.left;return l}function A(l){for(;l.right!==e.$5C;)l=l.right;return l}function O(l){return l===e.$5C?0:l.size_left+l.piece.length+O(l.right)}function R(l){return l===e.$5C?0:l.lf_left+l.piece.lineFeedCnt+R(l.right)}function p(){e.$5C.parent=e.$5C}function c(l,m){const g=m.right;g.size_left+=m.size_left+(m.piece?m.piece.length:0),g.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=g.left,g.left!==e.$5C&&(g.left.parent=m),g.parent=m.parent,m.parent===e.$5C?l.root=g:m.parent.left===m?m.parent.left=g:m.parent.right=g,g.left=m,m.parent=g}function I(l,m){const g=m.left;m.left=g.right,g.right!==e.$5C&&(g.right.parent=m),g.parent=m.parent,m.size_left-=g.size_left+(g.piece?g.piece.length:0),m.lf_left-=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),m.parent===e.$5C?l.root=g:m===m.parent.right?m.parent.right=g:m.parent.left=g,g.right=m,m.parent=g}function S(l,m){let g,$;if(m.left===e.$5C?($=m,g=$.right):m.right===e.$5C?($=m,g=$.left):($=k(m.right),g=$.right),$===l.root){l.root=g,g.color=a.Black,m.detach(),p(),l.root.parent=e.$5C;return}const n=$.color===a.Red;if($===$.parent.left?$.parent.left=g:$.parent.right=g,$===m?(g.parent=$.parent,w(l,g)):($.parent===m?g.parent=$:g.parent=$.parent,w(l,g),$.left=m.left,$.right=m.right,$.parent=m.parent,$.color=m.color,m===l.root?l.root=$:m===m.parent.left?m.parent.left=$:m.parent.right=$,$.left!==e.$5C&&($.left.parent=$),$.right!==e.$5C&&($.right.parent=$),$.size_left=m.size_left,$.lf_left=m.lf_left,w(l,$)),m.detach(),g.parent.left===g){const t=O(g),i=R(g);if(t!==g.parent.size_left||i!==g.parent.lf_left){const s=t-g.parent.size_left,d=i-g.parent.lf_left;g.parent.size_left=t,g.parent.lf_left=i,P(l,g.parent,s,d)}}if(w(l,g.parent),n){p();return}let o;for(;g!==l.root&&g.color===a.Black;)g===g.parent.left?(o=g.parent.right,o.color===a.Red&&(o.color=a.Black,g.parent.color=a.Red,c(l,g.parent),o=g.parent.right),o.left.color===a.Black&&o.right.color===a.Black?(o.color=a.Red,g=g.parent):(o.right.color===a.Black&&(o.left.color=a.Black,o.color=a.Red,I(l,o),o=g.parent.right),o.color=g.parent.color,g.parent.color=a.Black,o.right.color=a.Black,c(l,g.parent),g=l.root)):(o=g.parent.left,o.color===a.Red&&(o.color=a.Black,g.parent.color=a.Red,I(l,g.parent),o=g.parent.left),o.left.color===a.Black&&o.right.color===a.Black?(o.color=a.Red,g=g.parent):(o.left.color===a.Black&&(o.right.color=a.Black,o.color=a.Red,c(l,o),o=g.parent.left),o.color=g.parent.color,g.parent.color=a.Black,o.left.color=a.Black,I(l,g.parent),g=l.root));g.color=a.Black,p()}function h(l,m){for(w(l,m);m!==l.root&&m.parent.color===a.Red;)if(m.parent===m.parent.parent.left){const g=m.parent.parent.right;g.color===a.Red?(m.parent.color=a.Black,g.color=a.Black,m.parent.parent.color=a.Red,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,c(l,m)),m.parent.color=a.Black,m.parent.parent.color=a.Red,I(l,m.parent.parent))}else{const g=m.parent.parent.left;g.color===a.Red?(m.parent.color=a.Black,g.color=a.Black,m.parent.parent.color=a.Red,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,I(l,m)),m.parent.color=a.Black,m.parent.parent.color=a.Red,c(l,m.parent.parent))}l.root.color=a.Black}function P(l,m,g,$){for(;m!==l.root&&m!==e.$5C;)m.parent.left===m&&(m.parent.size_left+=g,m.parent.lf_left+=$),m=m.parent}function w(l,m){let g=0,$=0;if(m!==l.root){for(;m!==l.root&&m===m.parent.right;)m=m.parent;if(m!==l.root)for(m=m.parent,g=O(m.left)-m.size_left,$=R(m.left)-m.lf_left,m.size_left+=g,m.lf_left+=$;m!==l.root&&(g!==0||$!==0);)m.parent.left===m&&(m.parent.size_left+=g,m.parent.lf_left+=$),m=m.parent}}}),define(Se[205],De([1,0,19,84]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$kw=void 0;class k{constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,c){p=(0,a.$df)(p);const I=this.a,S=this.b,h=c.length;return h===0?!1:(this.a=new Uint32Array(I.length+h),this.a.set(I.subarray(0,p),0),this.a.set(I.subarray(p),p+h),this.a.set(c,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}setValue(p,c){return p=(0,a.$df)(p),c=(0,a.$df)(c),this.a[p]===c?!1:(this.a[p]=c,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,c){p=(0,a.$df)(p),c=(0,a.$df)(c);const I=this.a,S=this.b;if(p>=I.length)return!1;const h=I.length-p;return c>=h&&(c=h),c===0?!1:(this.a=new Uint32Array(I.length-c),this.a.set(I.subarray(0,p),0),this.a.set(I.subarray(p+c),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(S.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,a.$df)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let c=this.c[0]+1;c===0&&(this.b[0]=this.a[0],c++),p>=this.a.length&&(p=this.a.length-1);for(let I=c;I<=p;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let c=0,I=this.a.length-1,S=0,h=0,P=0;for(;c<=I;)if(S=c+(I-c)/2|0,h=this.b[S],P=h-this.a[S],p<P)I=S-1;else if(p>=h)c=S+1;else break;return new O(S,p-P)}}e.$kw=k;class A{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const c=this.e[p],I=c>0?this.d[c-1]:0;return new O(c,p-I)}removeValues(p,c){this.a.splice(p,c),this.f(p)}insertValues(p,c){this.a=(0,r.$Yb)(this.a,p,c),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,c=this.a.length;p<c;p++){const I=this.a[p],S=p>0?this.d[p-1]:0;this.d[p]=S+I;for(let h=0;h<I;h++)this.e[S+h]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,c){this.a[p]!==c&&(this.a[p]=c,this.f(p))}}e.$lw=A;class O{constructor(p,c){this.index=p,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=c}}e.$mw=O}),define(Se[206],De([1,0,13,57,205]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=void 0;class A{constructor(R,p,c,I){this.d=R,this.f=p,this.g=c,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(R){R.eol&&R.eol!==this.g&&(this.g=R.eol,this.j=null);const p=R.changes;for(const c of p)this.o(c.range),this.p(new a.$Mt(c.range.startLineNumber,c.range.startColumn),c.text);this.h=R.versionId,this.k=null}l(){if(!this.j){const R=this.g.length,p=this.f.length,c=new Uint32Array(p);for(let I=0;I<p;I++)c[I]=this.f[I].length+R;this.j=new k.$kw(c)}}n(R,p){this.f[R]=p,this.j&&this.j.setValue(R,this.f[R].length+this.g.length)}o(R){if(R.startLineNumber===R.endLineNumber){if(R.startColumn===R.endColumn)return;this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.startLineNumber-1].substring(R.endColumn-1));return}this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.endLineNumber-1].substring(R.endColumn-1)),this.f.splice(R.startLineNumber,R.endLineNumber-R.startLineNumber),this.j&&this.j.removeValues(R.startLineNumber,R.endLineNumber-R.startLineNumber)}p(R,p){if(p.length===0)return;const c=(0,r.$uf)(p);if(c.length===1){this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+c[0]+this.f[R.lineNumber-1].substring(R.column-1));return}c[c.length-1]+=this.f[R.lineNumber-1].substring(R.column-1),this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+c[0]);const I=new Uint32Array(c.length-1);for(let S=1;S<c.length;S++)this.f.splice(R.lineNumber+S-1,0,c[S]),I[S-1]=c[S].length+this.g.length;this.j&&this.j.insertValues(R.lineNumber,I)}}e.$nw=A}),define(Se[112],De([1,0,27,13,200,57,31,58]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=e.$eD=e.$bD=void 0,e.$cD=I,e.$dD=S,e.$fD=m,a=Ue(a);const p=999;class c{constructor(n,o,t,i){this.searchString=n,this.isRegex=o,this.matchCase=t,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=I(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=a.$sf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!o)return null;let t=!this.isRegex&&!n;return t&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(t=this.matchCase),new R.$fw(o,this.wordSeparators?(0,k.$iu)(this.wordSeparators,[]):null,t?this.searchString:null)}}e.$bD=c;function I($){if(!$||$.length===0)return!1;for(let n=0,o=$.length;n<o;n++){const t=$.charCodeAt(n);if(t===r.CharCode.LineFeed)return!0;if(t===r.CharCode.Backslash){if(n++,n>=o)break;const i=$.charCodeAt(n);if(i===r.CharCode.n||i===r.CharCode.r||i===r.CharCode.W)return!0}}return!1}function S($,n,o){if(!o)return new R.$cw($,null);const t=[];for(let i=0,s=n.length;i<s;i++)t[i]=n[i];return new R.$cw($,t)}class h{constructor(n){const o=[];let t=0;for(let i=0,s=n.length;i<s;i++)n.charCodeAt(i)===r.CharCode.LineFeed&&(o[t++]=i);this.a=o}findLineFeedCountBeforeOffset(n){const o=this.a;let t=0,i=o.length-1;if(i===-1||n<=o[0])return 0;for(;t<i;){const s=t+((i-t)/2>>0);o[s]>=n?i=s-1:o[s+1]>=n?(t=s,i=s):t=s+1}return t+1}}class P{static findMatches(n,o,t,i,s){const d=o.parseSearchRequest();return d?d.regex.multiline?this.b(n,t,new g(d.wordSeparators,d.regex),i,s):this.c(n,t,d,i,s):[]}static a(n,o,t,i,s,d){let u,b=0;i?(b=i.findLineFeedCountBeforeOffset(s),u=o+s+b):u=o+s;let E;if(i){const C=i.findLineFeedCountBeforeOffset(s+d.length)-b;E=u+d.length+C}else E=u+d.length;const D=n.getPositionAt(u),y=n.getPositionAt(E);return new O.$Nt(D.lineNumber,D.column,y.lineNumber,y.column)}static b(n,o,t,i,s){const d=n.getOffsetAt(o.getStartPosition()),u=n.getValueInRange(o,R.EndOfLinePreference.LF),b=n.getEOL()===`\r
`?new h(u):null,E=[];let D=0,y;for(t.reset(0);y=t.next(u);)if(E[D++]=S(this.a(n,d,u,b,y.index,y[0]),y,i),D>=s)return E;return E}static c(n,o,t,i,s){const d=[];let u=0;if(o.startLineNumber===o.endLineNumber){const E=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return u=this.d(t,E,o.startLineNumber,o.startColumn-1,u,d,i,s),d}const b=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);u=this.d(t,b,o.startLineNumber,o.startColumn-1,u,d,i,s);for(let E=o.startLineNumber+1;E<o.endLineNumber&&u<s;E++)u=this.d(t,n.getLineContent(E),E,0,u,d,i,s);if(u<s){const E=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);u=this.d(t,E,o.endLineNumber,0,u,d,i,s)}return d}static d(n,o,t,i,s,d,u,b){const E=n.wordSeparators;if(!u&&n.simpleSearch){const T=n.simpleSearch,C=T.length,v=o.length;let f=-C;for(;(f=o.indexOf(T,f+C))!==-1;)if((!E||m(E,o,v,f,C))&&(d[s++]=new R.$cw(new O.$Nt(t,f+1+i,t,f+1+C+i),null),s>=b))return s;return s}const D=new g(n.wordSeparators,n.regex);let y;D.reset(0);do if(y=D.next(o),y&&(d[s++]=S(new O.$Nt(t,y.index+1+i,t,y.index+1+y[0].length+i),y,u),s>=b))return s;while(y);return s}static findNextMatch(n,o,t,i){const s=o.parseSearchRequest();if(!s)return null;const d=new g(s.wordSeparators,s.regex);return s.regex.multiline?this.e(n,t,d,i):this.f(n,t,d,i)}static e(n,o,t,i){const s=new A.$Mt(o.lineNumber,1),d=n.getOffsetAt(s),u=n.getLineCount(),b=n.getValueInRange(new O.$Nt(s.lineNumber,s.column,u,n.getLineMaxColumn(u)),R.EndOfLinePreference.LF),E=n.getEOL()===`\r
`?new h(b):null;t.reset(o.column-1);const D=t.next(b);return D?S(this.a(n,d,b,E,D.index,D[0]),D,i):o.lineNumber!==1||o.column!==1?this.e(n,new A.$Mt(1,1),t,i):null}static f(n,o,t,i){const s=n.getLineCount(),d=o.lineNumber,u=n.getLineContent(d),b=this.g(t,u,d,o.column,i);if(b)return b;for(let E=1;E<=s;E++){const D=(d+E-1)%s,y=n.getLineContent(D+1),T=this.g(t,y,D+1,1,i);if(T)return T}return null}static g(n,o,t,i,s){n.reset(i-1);const d=n.next(o);return d?S(new O.$Nt(t,d.index+1,t,d.index+1+d[0].length),d,s):null}static findPreviousMatch(n,o,t,i){const s=o.parseSearchRequest();if(!s)return null;const d=new g(s.wordSeparators,s.regex);return s.regex.multiline?this.h(n,t,d,i):this.j(n,t,d,i)}static h(n,o,t,i){const s=this.b(n,new O.$Nt(1,1,o.lineNumber,o.column),t,i,10*p);if(s.length>0)return s[s.length-1];const d=n.getLineCount();return o.lineNumber!==d||o.column!==n.getLineMaxColumn(d)?this.h(n,new A.$Mt(d,n.getLineMaxColumn(d)),t,i):null}static j(n,o,t,i){const s=n.getLineCount(),d=o.lineNumber,u=n.getLineContent(d).substring(0,o.column-1),b=this.k(t,u,d,i);if(b)return b;for(let E=1;E<=s;E++){const D=(s+d-E-1)%s,y=n.getLineContent(D+1),T=this.k(t,y,D+1,i);if(T)return T}return null}static k(n,o,t,i){let s=null,d;for(n.reset(0);d=n.next(o);)s=S(new O.$Nt(t,d.index+1,t,d.index+1+d[0].length),d,i);return s}}e.$eD=P;function w($,n,o,t,i){if(t===0)return!0;const s=n.charCodeAt(t-1);if($.get(s)!==k.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(i>0){const d=n.charCodeAt(t);if($.get(d)!==k.WordCharacterClass.Regular)return!0}return!1}function l($,n,o,t,i){if(t+i===o)return!0;const s=n.charCodeAt(t+i);if($.get(s)!==k.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(i>0){const d=n.charCodeAt(t+i-1);if($.get(d)!==k.WordCharacterClass.Regular)return!0}return!1}function m($,n,o,t,i){return w($,n,o,t,i)&&l($,n,o,t,i)}class g{constructor(n,o){this._wordSeparators=n,this.a=o,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const o=n.length;let t;do{if(this.b+this.c===o||(t=this.a.exec(n),!t))return null;const i=t.index,s=t[0].length;if(i===this.b&&s===this.c){if(s===0){a.$Of(n,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=i,this.c=s,!this._wordSeparators||m(this._wordSeparators,n,o,i,s))return t}while(t);return null}}e.$gD=g}),define(Se[143],De([1,0,27,57,31,58,204,112]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=e.$kD=e.$jD=void 0,e.$hD=S,e.$iD=h;const p=65535;function c($){let n;return $[$.length-1]<65536?n=new Uint16Array($.length):n=new Uint32Array($.length),n.set($,0),n}class I{constructor(n,o,t,i,s){this.lineStarts=n,this.cr=o,this.lf=t,this.crlf=i,this.isBasicASCII=s}}function S($,n=!0){const o=[0];let t=1;for(let i=0,s=$.length;i<s;i++){const d=$.charCodeAt(i);d===r.CharCode.CarriageReturn?i+1<s&&$.charCodeAt(i+1)===r.CharCode.LineFeed?(o[t++]=i+2,i++):o[t++]=i+1:d===r.CharCode.LineFeed&&(o[t++]=i+1)}return n?c(o):o}function h($,n){$.length=0,$[0]=0;let o=1,t=0,i=0,s=0,d=!0;for(let b=0,E=n.length;b<E;b++){const D=n.charCodeAt(b);D===r.CharCode.CarriageReturn?b+1<E&&n.charCodeAt(b+1)===r.CharCode.LineFeed?(s++,$[o++]=b+2,b++):(t++,$[o++]=b+1):D===r.CharCode.LineFeed?(i++,$[o++]=b+1):d&&D!==r.CharCode.Tab&&(D<32||D>126)&&(d=!1)}const u=new I(c($),t,i,s,d);return $.length=0,u}class P{constructor(n,o,t,i,s){this.bufferIndex=n,this.start=o,this.end=t,this.lineFeedCnt=i,this.length=s}}e.$jD=P;class w{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$kD=w;class l{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==O.$5C&&n.iterate(n.root,t=>(t!==O.$5C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class m{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartOffset<=n&&t.nodeStartOffset+t.node.piece.length>=n)return t}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const t=this.b[o];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<n&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=n)return t}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const t=this.b;for(let i=0;i<t.length;i++){const s=t[i];if(s.node.parent===null||s.nodeStartOffset>=n){t[i]=null,o=!0;continue}}if(o){const i=[];for(const s of t)s!==null&&i.push(s);this.b=i}}}class g{constructor(n,o,t){this.create(n,o,t)}create(n,o,t){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=O.$5C,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=t;let i=null;for(let s=0,d=n.length;s<d;s++)if(n[s].buffer.length>0){n[s].lineStarts||(n[s].lineStarts=S(n[s].buffer));const u=new P(s+1,{line:0,column:0},{line:n[s].lineStarts.length-1,column:n[s].buffer.length-n[s].lineStarts[n[s].lineStarts.length-1]},n[s].lineStarts.length-1,n[s].buffer.length);this.a.push(n[s]),i=this.S(i,u)}this.h=new m(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=p,t=o-Math.floor(o/3),i=t*2;let s="",d=0;const u=[];if(this.iterate(this.root,b=>{const E=this.R(b),D=E.length;if(d<=t||d+D<i)return s+=E,d+=D,!0;const y=s.replace(/\r\n|\r|\n/g,n);return u.push(new w(y,S(y))),s=E,d=D,!0}),d>0){const b=s.replace(/\r\n|\r|\n/g,n);u.push(new w(b,S(b)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new l(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,i=>{if(i===O.$5C)return!0;const s=this.R(i),d=s.length,u=n.G(o),b=n.G(o+d),E=n.getValueInRange2(u,b);return o+=d,s===E})}getOffsetAt(n,o){let t=0,i=this.root;for(;i!==O.$5C;)if(i.left!==O.$5C&&i.lf_left+1>=n)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt+1>=n){t+=i.size_left;const s=this.B(i,n-i.lf_left-2);return t+=s+o-1}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;return t}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,t=0;const i=n;for(;o!==O.$5C;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const s=this.A(o,n-o.size_left);if(t+=o.lf_left+s.index,s.index===0){const d=this.getOffsetAt(t+1,1),u=i-d;return new a.$Mt(t+1,u+1)}return new a.$Mt(t+1,s.remainder+1)}else if(n-=o.size_left+o.piece.length,t+=o.lf_left+o.piece.lineFeedCnt,o.right===O.$5C){const s=this.getOffsetAt(t+1,1),d=i-n-s;return new a.$Mt(t+1,d+1)}else o=o.right;return new a.$Mt(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const t=this.H(n.startLineNumber,n.startColumn),i=this.H(n.endLineNumber,n.endColumn),s=this.getValueInRange2(t,i);return o?o!==this.d||!this.f?s.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?s:s.replace(/\r\n|\r|\n/g,o):s}getValueInRange2(n,o){if(n.node===o.node){const u=n.node,b=this.a[u.piece.bufferIndex].buffer,E=this.u(u.piece.bufferIndex,u.piece.start);return b.substring(E+n.remainder,E+o.remainder)}let t=n.node;const i=this.a[t.piece.bufferIndex].buffer,s=this.u(t.piece.bufferIndex,t.piece.start);let d=i.substring(s+n.remainder,s+t.piece.length);for(t=t.next();t!==O.$5C;){const u=this.a[t.piece.bufferIndex].buffer,b=this.u(t.piece.bufferIndex,t.piece.start);if(t===o.node){d+=u.substring(b,b+o.remainder);break}else d+=u.substr(b,t.piece.length);t=t.next()}return d}getLinesContent(){const n=[];let o=0,t="",i=!1;return this.iterate(this.root,s=>{if(s===O.$5C)return!0;const d=s.piece;let u=d.length;if(u===0)return!0;const b=this.a[d.bufferIndex].buffer,E=this.a[d.bufferIndex].lineStarts,D=d.start.line,y=d.end.line;let T=E[D]+d.start.column;if(i&&(b.charCodeAt(T)===r.CharCode.LineFeed&&(T++,u--),n[o++]=t,t="",i=!1,u===0))return!0;if(D===y)return!this.f&&b.charCodeAt(T+u-1)===r.CharCode.CarriageReturn?(i=!0,t+=b.substr(T,u-1)):t+=b.substr(T,u),!0;t+=this.f?b.substring(T,Math.max(T,E[D+1]-this.e)):b.substring(T,E[D+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;for(let C=D+1;C<y;C++)t=this.f?b.substring(E[C],E[C+1]-this.e):b.substring(E[C],E[C+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=t;return!this.f&&b.charCodeAt(E[y]+d.end.column-1)===r.CharCode.CarriageReturn?(i=!0,d.end.column===0?o--:t=b.substr(E[y],d.end.column-1)):t=b.substr(E[y],d.end.column),!0}),i&&(n[o++]=t,t=""),n[o++]=t,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const t=this.a[o.piece.bufferIndex],i=this.u(o.piece.bufferIndex,o.piece.start);return t.buffer.charCodeAt(i)}else{const o=this.a[n.node.piece.bufferIndex],i=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(i)}}getLineCharCode(n,o){const t=this.H(n,o+1);return this.l(t)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}getNearestChunk(n){const o=this.G(n);if(o.remainder===o.node.piece.length){const t=o.node.next();if(!t||t===O.$5C)return"";const i=this.a[t.piece.bufferIndex],s=this.u(t.piece.bufferIndex,t.piece.start);return i.buffer.substring(s,s+t.piece.length)}else{const t=this.a[o.node.piece.bufferIndex],i=this.u(o.node.piece.bufferIndex,o.node.piece.start),s=i+o.remainder,d=i+o.node.piece.length;return t.buffer.substring(s,d)}}findMatchesInNode(n,o,t,i,s,d,u,b,E,D,y){const T=this.a[n.piece.bufferIndex],C=this.u(n.piece.bufferIndex,n.piece.start),v=this.u(n.piece.bufferIndex,s),f=this.u(n.piece.bufferIndex,d);let N;const F={line:0,column:0};let j,z;o._wordSeparators?(j=T.buffer.substring(v,f),z=M=>M+v,o.reset(0)):(j=T.buffer,z=M=>M,o.reset(v));do if(N=o.next(j),N){if(z(N.index)>=f)return D;this.s(n,z(N.index)-C,F);const M=this.t(n.piece.bufferIndex,s,F),L=F.line===s.line?F.column-s.column+i:F.column+1,B=L+N[0].length;if(y[D++]=(0,R.$dD)(new k.$Nt(t+M,L,t+M,B),N,b),z(N.index)+N[0].length>=f||D>=E)return D}while(N);return D}findMatchesLineByLine(n,o,t,i){const s=[];let d=0;const u=new R.$gD(o.wordSeparators,o.regex);let b=this.H(n.startLineNumber,n.startColumn);if(b===null)return[];const E=this.H(n.endLineNumber,n.endColumn);if(E===null)return[];let D=this.s(b.node,b.remainder);const y=this.s(E.node,E.remainder);if(b.node===E.node)return this.findMatchesInNode(b.node,u,n.startLineNumber,n.startColumn,D,y,o,t,i,d,s),s;let T=n.startLineNumber,C=b.node;for(;C!==E.node;){const f=this.t(C.piece.bufferIndex,D,C.piece.end);if(f>=1){const F=this.a[C.piece.bufferIndex].lineStarts,j=this.u(C.piece.bufferIndex,C.piece.start),z=F[D.line+f],M=T===n.startLineNumber?n.startColumn:1;if(d=this.findMatchesInNode(C,u,T,M,D,this.s(C,z-j),o,t,i,d,s),d>=i)return s;T+=f}const N=T===n.startLineNumber?n.startColumn-1:0;if(T===n.endLineNumber){const F=this.getLineContent(T).substring(N,n.endColumn-1);return d=this.n(o,u,F,n.endLineNumber,N,d,s,t,i),s}if(d=this.n(o,u,this.getLineContent(T).substr(N),T,N,d,s,t,i),d>=i)return s;T++,b=this.H(T,1),C=b.node,D=this.s(b.node,b.remainder)}if(T===n.endLineNumber){const f=T===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(T).substring(f,n.endColumn-1);return d=this.n(o,u,N,n.endLineNumber,f,d,s,t,i),s}const v=T===n.startLineNumber?n.startColumn:1;return d=this.findMatchesInNode(E.node,u,T,v,D,y,o,t,i,d,s),s}n(n,o,t,i,s,d,u,b,E){const D=n.wordSeparators;if(!b&&n.simpleSearch){const T=n.simpleSearch,C=T.length,v=t.length;let f=-C;for(;(f=t.indexOf(T,f+C))!==-1;)if((!D||(0,R.$fD)(D,t,v,f,C))&&(u[d++]=new A.$cw(new k.$Nt(i,f+1+s,i,f+1+C+s),null),d>=E))return d;return d}let y;o.reset(0);do if(y=o.next(t),y&&(u[d++]=(0,R.$dD)(new k.$Nt(i,y.index+1+s,i,y.index+1+y[0].length+s),y,b),d>=E))return d;while(y);return d}insert(n,o,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==O.$5C){const{node:i,remainder:s,nodeStartOffset:d}=this.G(n),u=i.piece,b=u.bufferIndex,E=this.s(i,s);if(i.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&d+u.length===n&&o.length<p){this.F(i,o),this.y();return}if(d===n)this.o(o,i),this.h.validate(n);else if(d+i.piece.length>n){const D=[];let y=new P(u.bufferIndex,E,u.end,this.t(u.bufferIndex,E,u.end),this.u(b,u.end)-this.u(b,E));if(this.K()&&this.M(o)&&this.I(i,s)===10){const f={line:y.start.line+1,column:0};y=new P(y.bufferIndex,f,y.end,this.t(y.bufferIndex,f,y.end),y.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(i,s-1)===13){const f=this.s(i,s-1);this.C(i,f),o="\r"+o,i.piece.length===0&&D.push(i)}else this.C(i,E);else this.C(i,E);const T=this.w(o);y.length>0&&this.S(i,y);let C=i;for(let v=0;v<T.length;v++)C=this.S(C,T[v]);this.v(D)}else this.q(o,i)}else{const i=this.w(o);let s=this.T(null,i[0]);for(let d=1;d<i.length;d++)s=this.S(s,i[d])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===O.$5C)return;const t=this.G(n),i=this.G(n+o),s=t.node,d=i.node;if(s===d){const T=this.s(s,t.remainder),C=this.s(s,i.remainder);if(t.nodeStartOffset===n){if(o===s.piece.length){const v=s.next();(0,O.$0C)(this,s),this.N(v),this.y();return}this.D(s,C),this.h.validate(n),this.N(s),this.y();return}if(t.nodeStartOffset+s.piece.length===n+o){this.C(s,T),this.O(s),this.y();return}this.E(s,T,C),this.y();return}const u=[],b=this.s(s,t.remainder);this.C(s,b),this.h.validate(n),s.piece.length===0&&u.push(s);const E=this.s(d,i.remainder);this.D(d,E),d.piece.length===0&&u.push(d);const D=s.next();for(let T=D;T!==O.$5C&&T!==d;T=T.next())u.push(T);const y=s.piece.length===0?s.prev():s;this.v(u),this.O(y),this.y()}o(n,o){const t=[];if(this.K()&&this.M(n)&&this.L(o)){const d=o.piece,u={line:d.start.line+1,column:0},b=new P(d.bufferIndex,u,d.end,this.t(d.bufferIndex,u,d.end),d.length-1);o.piece=b,n+=`
`,(0,O.$_C)(this,o,-1,-1),o.piece.length===0&&t.push(o)}const i=this.w(n);let s=this.T(o,i[i.length-1]);for(let d=i.length-2;d>=0;d--)s=this.T(s,i[d]);this.N(s),this.v(t)}q(n,o){this.Q(n,o)&&(n+=`
`);const t=this.w(n),i=this.S(o,t[0]);let s=i;for(let d=1;d<t.length;d++)s=this.S(s,t[d]);this.N(i)}s(n,o,t){const i=n.piece,s=n.piece.bufferIndex,d=this.a[s].lineStarts,b=d[i.start.line]+i.start.column+o;let E=i.start.line,D=i.end.line,y=0,T=0,C=0;for(;E<=D&&(y=E+(D-E)/2|0,C=d[y],y!==D);)if(T=d[y+1],b<C)D=y-1;else if(b>=T)E=y+1;else break;return t?(t.line=y,t.column=b-C,null):{line:y,column:b-C}}t(n,o,t){if(t.column===0)return t.line-o.line;const i=this.a[n].lineStarts;if(t.line===i.length-1)return t.line-o.line;const s=i[t.line+1],d=i[t.line]+t.column;if(s>d+1)return t.line-o.line;const u=d-1;return this.a[n].buffer.charCodeAt(u)===13?t.line-o.line+1:t.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,O.$0C)(this,n[o])}w(n){if(n.length>p){const D=[];for(;n.length>p;){const T=n.charCodeAt(p-1);let C;T===r.CharCode.CarriageReturn||T>=55296&&T<=56319?(C=n.substring(0,p-1),n=n.substring(p-1)):(C=n.substring(0,p),n=n.substring(p));const v=S(C);D.push(new P(this.a.length,{line:0,column:0},{line:v.length-1,column:C.length-v[v.length-1]},v.length-1,C.length)),this.a.push(new w(C,v))}const y=S(n);return D.push(new P(this.a.length,{line:0,column:0},{line:y.length-1,column:n.length-y[y.length-1]},y.length-1,n.length)),this.a.push(new w(n,y)),D}let o=this.a[0].buffer.length;const t=S(n,!1);let i=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},i=this.g;for(let D=0;D<t.length;D++)t[D]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let D=0;D<t.length;D++)t[D]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=n}const s=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,u=s-this.a[0].lineStarts[d],b={line:d,column:u},E=new P(0,i,b,this.t(0,i,b),s-o);return this.g=b,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let t=this.root,i="";const s=this.h.get2(n);if(s){t=s.node;const d=this.B(t,n-s.nodeStartLineNumber-1),u=this.a[t.piece.bufferIndex].buffer,b=this.u(t.piece.bufferIndex,t.piece.start);if(s.nodeStartLineNumber+t.piece.lineFeedCnt===n)i=u.substring(b+d,b+t.piece.length);else{const E=this.B(t,n-s.nodeStartLineNumber);return u.substring(b+d,b+E-o)}}else{let d=0;const u=n;for(;t!==O.$5C;)if(t.left!==O.$5C&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const b=this.B(t,n-t.lf_left-2),E=this.B(t,n-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,y=this.u(t.piece.bufferIndex,t.piece.start);return d+=t.size_left,this.h.set({node:t,nodeStartOffset:d,nodeStartLineNumber:u-(n-1-t.lf_left)}),D.substring(y+b,y+E-o)}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const b=this.B(t,n-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);i=E.substring(D+b,D+t.piece.length);break}else n-=t.lf_left+t.piece.lineFeedCnt,d+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==O.$5C;){const d=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const u=this.B(t,0),b=this.u(t.piece.bufferIndex,t.piece.start);return i+=d.substring(b,b+u-o),i}else{const u=this.u(t.piece.bufferIndex,t.piece.start);i+=d.substr(u,t.piece.length)}t=t.next()}return i}y(){let n=this.root,o=1,t=0;for(;n!==O.$5C;)o+=n.lf_left+n.piece.lineFeedCnt,t+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=t,this.h.validate(this.c)}A(n,o){const t=n.piece,i=this.s(n,o),s=i.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===o){const d=this.t(n.piece.bufferIndex,t.start,i);if(d!==s)return{index:d,remainder:0}}return{index:s,remainder:i.column}}B(n,o){if(o<0)return 0;const t=n.piece,i=this.a[t.bufferIndex].lineStarts,s=t.start.line+o+1;return s>t.end.line?i[t.end.line]+t.end.column-i[t.start.line]-t.start.column:i[s]-i[t.start.line]-t.start.column}C(n,o){const t=n.piece,i=t.lineFeedCnt,s=this.u(t.bufferIndex,t.end),d=o,u=this.u(t.bufferIndex,d),b=this.t(t.bufferIndex,t.start,d),E=b-i,D=u-s,y=t.length+D;n.piece=new P(t.bufferIndex,t.start,d,b,y),(0,O.$_C)(this,n,D,E)}D(n,o){const t=n.piece,i=t.lineFeedCnt,s=this.u(t.bufferIndex,t.start),d=o,u=this.t(t.bufferIndex,d,t.end),b=this.u(t.bufferIndex,d),E=u-i,D=s-b,y=t.length+D;n.piece=new P(t.bufferIndex,d,t.end,u,y),(0,O.$_C)(this,n,D,E)}E(n,o,t){const i=n.piece,s=i.start,d=i.end,u=i.length,b=i.lineFeedCnt,E=o,D=this.t(i.bufferIndex,i.start,E),y=this.u(i.bufferIndex,o)-this.u(i.bufferIndex,s);n.piece=new P(i.bufferIndex,i.start,E,D,y),(0,O.$_C)(this,n,y-u,D-b);const T=new P(i.bufferIndex,t,d,this.t(i.bufferIndex,t,d),this.u(i.bufferIndex,d)-this.u(i.bufferIndex,t)),C=this.S(n,T);this.N(C)}F(n,o){this.Q(o,n)&&(o+=`
`);const t=this.K()&&this.L(o)&&this.M(n),i=this.a[0].buffer.length;this.a[0].buffer+=o;const s=S(o,!1);for(let C=0;C<s.length;C++)s[C]+=i;if(t){const C=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:i-C}}this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1));const d=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[d],b={line:d,column:u},E=n.piece.length+o.length,D=n.piece.lineFeedCnt,y=this.t(0,n.piece.start,b),T=y-D;n.piece=new P(n.piece.bufferIndex,n.piece.start,b,y,E),this.g=b,(0,O.$_C)(this,n,o.length,T)}G(n){let o=this.root;const t=this.h.get(n);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:n-t.nodeStartOffset};let i=0;for(;o!==O.$5C;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){i+=o.size_left;const s={node:o,remainder:n-o.size_left,nodeStartOffset:i};return this.h.set(s),s}else n-=o.size_left+o.piece.length,i+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let t=this.root,i=0;for(;t!==O.$5C;)if(t.left!==O.$5C&&t.lf_left>=n-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>n-1){const s=this.B(t,n-t.lf_left-2),d=this.B(t,n-t.lf_left-1);return i+=t.size_left,{node:t,remainder:Math.min(s+o-1,d),nodeStartOffset:i}}else if(t.lf_left+t.piece.lineFeedCnt===n-1){const s=this.B(t,n-t.lf_left-2);if(s+o-1<=t.piece.length)return{node:t,remainder:s+o-1,nodeStartOffset:i};o-=t.piece.length-s;break}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==O.$5C;){if(t.piece.lineFeedCnt>0){const s=this.B(t,0),d=this.J(t);return{node:t,remainder:Math.min(o-1,s),nodeStartOffset:d}}else if(t.piece.length>=o-1){const s=this.J(t);return{node:t,remainder:o-1,nodeStartOffset:s}}else o-=t.piece.length;t=t.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const t=this.a[n.piece.bufferIndex],i=this.u(n.piece.bufferIndex,n.piece.start)+o;return t.buffer.charCodeAt(i)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===O.$5C||n.piece.lineFeedCnt===0)return!1;const o=n.piece,t=this.a[o.bufferIndex].lineStarts,i=o.start.line,s=t[i]+o.start.column;return i===t.length-1||t[i+1]>s+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(s)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===O.$5C||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const t=[],i=this.a[n.piece.bufferIndex].lineStarts;let s;n.piece.end.column===0?s={line:n.piece.end.line-1,column:i[n.piece.end.line]-i[n.piece.end.line-1]-1}:s={line:n.piece.end.line,column:n.piece.end.column-1};const d=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new P(n.piece.bufferIndex,n.piece.start,s,u,d),(0,O.$_C)(this,n,-1,-1),n.piece.length===0&&t.push(n);const b={line:o.piece.start.line+1,column:0},E=o.piece.length-1,D=this.t(o.piece.bufferIndex,b,o.piece.end);o.piece=new P(o.piece.bufferIndex,b,o.piece.end,D,E),(0,O.$_C)(this,o,-1,-1),o.piece.length===0&&t.push(o);const y=this.w(`\r
`);this.S(n,y[0]);for(let T=0;T<t.length;T++)(0,O.$0C)(this,t[T])}Q(n,o){if(this.K()&&this.M(n)){const t=o.next();if(this.L(t)){if(n+=`
`,t.piece.length===1)(0,O.$0C)(this,t);else{const i=t.piece,s={line:i.start.line+1,column:0},d=i.length-1,u=this.t(i.bufferIndex,s,i.end);t.piece=new P(i.bufferIndex,s,i.end,u,d),(0,O.$_C)(this,t,-1,-1)}return!0}}return!1}iterate(n,o){if(n===O.$5C)return o(O.$5C);const t=this.iterate(n.left,o);return t&&o(n)&&this.iterate(n.right,o)}R(n){if(n===O.$5C)return"";const o=this.a[n.piece.bufferIndex],t=n.piece,i=this.u(t.bufferIndex,t.start),s=this.u(t.bufferIndex,t.end);return o.buffer.substring(i,s)}getPieceContent(n){const o=this.a[n.bufferIndex],t=this.u(n.bufferIndex,n.start),i=this.u(n.bufferIndex,n.end);return o.buffer.substring(t,i)}S(n,o){const t=new O.$4C(o,O.NodeColor.Red);if(t.left=O.$5C,t.right=O.$5C,t.parent=O.$5C,t.size_left=0,t.lf_left=0,this.root===O.$5C)this.root=t,t.color=O.NodeColor.Black;else if(n.right===O.$5C)n.right=t,t.parent=n;else{const s=(0,O.$6C)(n.right);s.left=t,t.parent=s}return(0,O.$$C)(this,t),t}T(n,o){const t=new O.$4C(o,O.NodeColor.Red);if(t.left=O.$5C,t.right=O.$5C,t.parent=O.$5C,t.size_left=0,t.lf_left=0,this.root===O.$5C)this.root=t,t.color=O.NodeColor.Black;else if(n.left===O.$5C)n.left=t,t.parent=n;else{const i=(0,O.$7C)(n.left);i.right=t,t.parent=i}return(0,O.$$C)(this,t),t}U(n){let o="";return this.iterate(n,t=>(o+=this.R(t),!0)),o}}e.$lD=g}),define(Se[207],De([1,0,4,13,31,58,143,194,198,3]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0,a=Ue(a);class I extends c.$Xc{constructor(h,P,w,l,m,g,$){super(),this.m=this.B(new r.$ne),this.onDidChangeContent=this.m.event,this.f=P,this.j=!g,this.g=l,this.h=m,this.c=new O.$lD(h,w,$)}equals(h){return!(h instanceof I)||this.f!==h.f||this.getEOL()!==h.getEOL()?!1:this.c.equal(h.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(h){return this.c.createSnapshot(h?this.f:"")}getOffsetAt(h,P){return this.c.getOffsetAt(h,P)}getPositionAt(h){return this.c.getPositionAt(h)}getRangeAt(h,P){const w=h+P,l=this.getPositionAt(h),m=this.getPositionAt(w);return new k.$Nt(l.lineNumber,l.column,m.lineNumber,m.column)}getValueInRange(h,P=A.EndOfLinePreference.TextDefined){if(h.isEmpty())return"";const w=this.n(P);return this.c.getValueInRange(h,w)}getValueLengthInRange(h,P=A.EndOfLinePreference.TextDefined){if(h.isEmpty())return 0;if(h.startLineNumber===h.endLineNumber)return h.endColumn-h.startColumn;const w=this.getOffsetAt(h.startLineNumber,h.startColumn),l=this.getOffsetAt(h.endLineNumber,h.endColumn);let m=0;const g=this.n(P),$=this.getEOL();if(g.length!==$.length){const n=g.length-$.length,o=h.endLineNumber-h.startLineNumber;m=n*o}return l-w+m}getCharacterCountInRange(h,P=A.EndOfLinePreference.TextDefined){if(this.j){let w=0;const l=h.startLineNumber,m=h.endLineNumber;for(let g=l;g<=m;g++){const $=this.getLineContent(g),n=g===l?h.startColumn-1:0,o=g===m?h.endColumn-1:$.length;for(let t=n;t<o;t++)a.$Lf($.charCodeAt(t))?(w=w+1,t=t+1):w=w+1}return w+=this.n(P).length*(m-l),w}return this.getValueLengthInRange(h,P)}getNearestChunk(h){return this.c.getNearestChunk(h)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(h){return this.c.getLineContent(h)}getLineCharCode(h,P){return this.c.getLineCharCode(h,P)}getCharCode(h){return this.c.getCharCode(h)}getLineLength(h){return this.c.getLineLength(h)}getLineMinColumn(h){return 1}getLineMaxColumn(h){return this.getLineLength(h)+1}getLineFirstNonWhitespaceColumn(h){const P=a.$wf(this.getLineContent(h));return P===-1?0:P+1}getLineLastNonWhitespaceColumn(h){const P=a.$yf(this.getLineContent(h));return P===-1?0:P+2}n(h){switch(h){case A.EndOfLinePreference.LF:return`
`;case A.EndOfLinePreference.CRLF:return`\r
`;case A.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(h){this.c.setEOL(h)}applyEdits(h,P,w){let l=this.g,m=this.h,g=this.j,$=!0,n=[];for(let b=0;b<h.length;b++){const E=h[b];$&&E._isTracked&&($=!1);const D=E.range;if(E.text){let f=!0;g||(f=!a.$Wf(E.text),g=f),!l&&f&&(l=a.$Vf(E.text)),!m&&f&&(m=a.$Yf(E.text))}let y="",T=0,C=0,v=0;if(E.text){let f;[T,C,v,f]=(0,R.$xu)(E.text);const N=this.getEOL(),F=N===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;f===R.StringEOL.Unknown||f===F?y=E.text:y=E.text.replace(/\r\n|\r|\n/g,N)}n[b]={sortIndex:b,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:T,firstLineLength:C,lastLineLength:v,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}n.sort(I.u);let o=!1;for(let b=0,E=n.length-1;b<E;b++){const D=n[b].range.getEndPosition(),y=n[b+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");o=!0}}$&&(n=this.s(n));const t=w||P?I._getInverseEditRanges(n):[],i=[];if(P)for(let b=0;b<n.length;b++){const E=n[b],D=t[b];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let T="";y===D.startLineNumber&&(T=this.getLineContent(E.range.startLineNumber),a.$wf(T)!==-1)||i.push({lineNumber:y,oldContent:T})}}let s=null;if(w){let b=0;s=[];for(let E=0;E<n.length;E++){const D=n[E],y=t[E],T=this.getValueInRange(D.range),C=D.rangeOffset+b;b+=D.text.length-T.length,s[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:T,textChange:new p.$du(D.rangeOffset,T,C,D.text)}}o||s.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=l,this.h=m,this.j=g;const d=this.t(n);let u=null;if(P&&i.length>0){i.sort((b,E)=>E.lineNumber-b.lineNumber),u=[];for(let b=0,E=i.length;b<E;b++){const D=i[b].lineNumber;if(b>0&&i[b-1].lineNumber===D)continue;const y=i[b].oldContent,T=this.getLineContent(D);T.length===0||T===y||a.$wf(T)!==-1||u.push(D)}}return this.m.fire(),new A.$gw(s,d,u)}s(h){return h.length<1e3?h:[this._toSingleEditOperation(h)]}_toSingleEditOperation(h){let P=!1;const w=h[0].range,l=h[h.length-1].range,m=new k.$Nt(w.startLineNumber,w.startColumn,l.endLineNumber,l.endColumn);let g=w.startLineNumber,$=w.startColumn;const n=[];for(let d=0,u=h.length;d<u;d++){const b=h[d],E=b.range;P=P||b.forceMoveMarkers,n.push(this.getValueInRange(new k.$Nt(g,$,E.startLineNumber,E.startColumn))),b.text.length>0&&n.push(b.text),g=E.endLineNumber,$=E.endColumn}const o=n.join(""),[t,i,s]=(0,R.$xu)(o);return{sortIndex:0,identifier:h[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,A.EndOfLinePreference.TextDefined),text:o,eolCount:t,firstLineLength:i,lastLineLength:s,forceMoveMarkers:P,isAutoWhitespaceEdit:!1}}t(h){h.sort(I.w);const P=[];for(let w=0;w<h.length;w++){const l=h[w],m=l.range.startLineNumber,g=l.range.startColumn,$=l.range.endLineNumber,n=l.range.endColumn;if(m===$&&g===n&&l.text.length===0)continue;l.text?(this.c.delete(l.rangeOffset,l.rangeLength),this.c.insert(l.rangeOffset,l.text,!0)):this.c.delete(l.rangeOffset,l.rangeLength);const o=new k.$Nt(m,g,$,n);P.push({range:o,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return P}findMatchesLineByLine(h,P,w,l){return this.c.findMatchesLineByLine(h,P,w,l)}getPieceTree(){return this.c}static _getInverseEditRange(h,P){const w=h.startLineNumber,l=h.startColumn,[m,g,$]=(0,R.$xu)(P);let n;if(P.length>0){const o=m+1;o===1?n=new k.$Nt(w,l,w,l+g):n=new k.$Nt(w,l,w+o-1,$+1)}else n=new k.$Nt(w,l,w,l);return n}static _getInverseEditRanges(h){const P=[];let w=0,l=0,m=null;for(let g=0,$=h.length;g<$;g++){const n=h[g];let o,t;m?m.range.endLineNumber===n.range.startLineNumber?(o=w,t=l+(n.range.startColumn-m.range.endColumn)):(o=w+(n.range.startLineNumber-m.range.endLineNumber),t=n.range.startColumn):(o=n.range.startLineNumber,t=n.range.startColumn);let i;if(n.text.length>0){const s=n.eolCount+1;s===1?i=new k.$Nt(o,t,o,t+n.firstLineLength):i=new k.$Nt(o,t,o+s-1,n.lastLineLength+1)}else i=new k.$Nt(o,t,o,t);w=i.endLineNumber,l=i.endColumn,P.push(i),m=n}return P}static u(h,P){const w=k.$Nt.compareRangesUsingEnds(h.range,P.range);return w===0?h.sortIndex-P.sortIndex:w}static w(h,P){const w=k.$Nt.compareRangesUsingEnds(h.range,P.range);return w===0?P.sortIndex-h.sortIndex:-w}}e.$mD=I}),define(Se[208],De([1,0,27,13,58,143,207]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nD=void 0,a=Ue(a);class R{constructor(I,S,h,P,w,l,m,g,$){this.a=I,this.b=S,this.c=h,this.d=P,this.e=w,this.f=l,this.g=m,this.h=g,this.j=$}k(I){const S=this.c+this.d+this.e,h=this.c+this.e;return S===0?I===k.DefaultEndOfLine.LF?`
`:`\r
`:h>S/2?`\r
`:`
`}create(I){const S=this.k(I),h=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let w=0,l=h.length;w<l;w++){const m=h[w].buffer.replace(/\r\n|\r|\n/g,S),g=(0,A.$hD)(m);h[w]=new A.$kD(m,g)}const P=new O.$mD(h,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&a.$7f(I)&&(this.b=a.$6f,I=I.substr(1));const S=I.charCodeAt(I.length-1);S===r.CharCode.CarriageReturn||S>=55296&&S<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=S):(this.m(I,!1),this.c=!1,this.d=S)}m(I,S){!S&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const S=(0,A.$iD)(this.e,I);this.a.push(new A.$kD(I,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=a.$Vf(I)),this.k||(this.k=a.$Yf(I)))}finish(I=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const S=(0,A.$hD)(I.buffer);I.lineStarts=S,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$nD=p}),define(Se[144],De([1,0,22,11]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdb=p,e.$Ndb=I,a=Ue(a);var k;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(k||(k={}));function A(S){for(let h=0,P=S.length;h<P;h+=4){const w=S[h+0],l=S[h+1],m=S[h+2],g=S[h+3];S[h+0]=g,S[h+1]=m,S[h+2]=l,S[h+3]=w}}function O(S){const h=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return a.$x()||A(h),r.$Pe.wrap(h)}function R(S){const h=S.buffer;if(a.$x()||A(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const P=new Uint8Array(h.byteLength);return P.set(h),new Uint32Array(P.buffer,P.byteOffset,P.length/4)}}function p(S){const h=new Uint32Array(c(S));let P=0;if(h[P++]=S.id,S.type==="full")h[P++]=k.Full,h[P++]=S.data.length,h.set(S.data,P),P+=S.data.length;else{h[P++]=k.Delta,h[P++]=S.deltas.length;for(const w of S.deltas)h[P++]=w.start,h[P++]=w.deleteCount,w.data?(h[P++]=w.data.length,h.set(w.data,P),P+=w.data.length):h[P++]=0}return O(h)}function c(S){let h=0;if(h+=2,S.type==="full")h+=1+S.data.length;else{h+=1,h+=3*S.deltas.length;for(const P of S.deltas)P.data&&(h+=P.data.length)}return h}function I(S){const h=R(S);let P=0;const w=h[P++];if(h[P++]===k.Full){const $=h[P++],n=h.subarray(P,P+$);return P+=$,{id:w,type:"full",data:n}}const m=h[P++],g=[];for(let $=0;$<m;$++){const n=h[P++],o=h[P++],t=h[P++];let i;t>0&&(i=h.subarray(P,P+t),P+=t),g[$]={start:n,deleteCount:o,data:i}}return{id:w,type:"delta",deltas:g}}}),define(Se[209],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_=e.$C_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const O=this.a.get(A);return this.a.delete(A),O}}addDragOperationTransfer(A,O){this.a.set(A,O)}}e.$C_=r;class a{constructor(A){this.identifier=A}}e.$D_=a}),define(Se[210],De([1,0,4,3,111]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wu=void 0;class A{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$ne,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,c){return this.a.set(p,c),this.handleChange([p]),(0,a.$Vc)(()=>{this.a.get(p)===c&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,c){this.b.get(p)?.dispose();const I=new O(this,p,c);return this.b.set(p,I),(0,a.$Vc)(()=>{const S=this.b.get(p);!S||S!==I||(this.b.delete(p),S.dispose())})}async getOrCreate(p){const c=this.get(p);if(c)return c;const I=this.b.get(p);return!I||I.isResolved?null:(await I.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const I=this.b.get(p);return!!(!I||I.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>k.ColorId.DefaultBackground?this.d[k.ColorId.DefaultBackground]:null}}e.$wu=A;class O extends a.$Xc{get isResolved(){return this.c}constructor(p,c,I){super(),this.f=p,this.g=c,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(Se[211],De([9,10]),function(ie,e){return ie.create("vs/base/common/actions",e)}),define(Se[212],De([1,0,4,3,211]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0,e.$qj=I,k=Ue(k);class A extends a.$Xc{constructor(h,P="",w="",l=!0,m){super(),this.j=this.B(new r.$ne),this.onDidChange=this.j.event,this.z=!0,this.m=h,this.n=P,this.w=w,this.z=l,this.D=m}get id(){return this.m}get label(){return this.n}set label(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.j.fire({label:h}))}get tooltip(){return this.u||""}set tooltip(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.j.fire({tooltip:h}))}get class(){return this.w}set class(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.j.fire({class:h}))}get enabled(){return this.z}set enabled(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.j.fire({enabled:h}))}get checked(){return this.C}set checked(h){this.J(h)}J(h){this.C!==h&&(this.C=h,this.j.fire({checked:h}))}async run(h,P){this.D&&await this.D(h)}}e.$lj=A;class O extends a.$Xc{constructor(){super(...arguments),this.f=this.B(new r.$ne),this.onWillRun=this.f.event,this.m=this.B(new r.$ne),this.onDidRun=this.m.event}async run(h,P){if(!h.enabled)return;this.f.fire({action:h});let w;try{await this.u(h,P)}catch(l){w=l}this.m.fire({action:h,error:w})}async u(h,P){await h.run(P)}}e.$mj=O;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let P=[];for(const w of h)w.length&&(P.length?P=[...P,new R,...w]:P=w);return P}async run(){}}e.$nj=R,R.ID="vs.actions.separator";class p{get actions(){return this.a}constructor(h,P,w,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=P,this.class=l,this.a=w}async run(){}}e.$oj=p;class c extends A{constructor(){super(c.ID,k.localize(0,null),void 0,!1)}}e.$pj=c,c.ID="vs.actions.empty";function I(S){return{id:S.id,label:S.label,tooltip:S.tooltip??S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...h)=>S.run(...h)}}}),define(Se[213],De([9,10]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Se[214],De([1,0,213]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=c,e.$4m=I,e.$5m=S;const a=60,k=a*60,A=k*24,O=A*7,R=A*30,p=A*365;function c(h,P,w,l){typeof h!="number"&&(h=h.getTime());const m=Math.round((new Date().getTime()-h)/1e3);if(m<-30)return(0,r.localize)(0,null,c(new Date().getTime()+m*1e3,!1));if(!l&&m<30)return(0,r.localize)(1,null);let g;return m<a?(g=m,P?g===1?w?(0,r.localize)(2,null,g):(0,r.localize)(3,null,g):w?(0,r.localize)(4,null,g):(0,r.localize)(5,null,g):g===1?w?(0,r.localize)(6,null,g):(0,r.localize)(7,null,g):w?(0,r.localize)(8,null,g):(0,r.localize)(9,null,g)):m<k?(g=Math.floor(m/a),P?g===1?w?(0,r.localize)(10,null,g):(0,r.localize)(11,null,g):w?(0,r.localize)(12,null,g):(0,r.localize)(13,null,g):g===1?w?(0,r.localize)(14,null,g):(0,r.localize)(15,null,g):w?(0,r.localize)(16,null,g):(0,r.localize)(17,null,g)):m<A?(g=Math.floor(m/k),P?g===1?w?(0,r.localize)(18,null,g):(0,r.localize)(19,null,g):w?(0,r.localize)(20,null,g):(0,r.localize)(21,null,g):g===1?w?(0,r.localize)(22,null,g):(0,r.localize)(23,null,g):w?(0,r.localize)(24,null,g):(0,r.localize)(25,null,g)):m<O?(g=Math.floor(m/A),P?g===1?(0,r.localize)(26,null,g):(0,r.localize)(27,null,g):g===1?(0,r.localize)(28,null,g):(0,r.localize)(29,null,g)):m<R?(g=Math.floor(m/O),P?g===1?w?(0,r.localize)(30,null,g):(0,r.localize)(31,null,g):w?(0,r.localize)(32,null,g):(0,r.localize)(33,null,g):g===1?w?(0,r.localize)(34,null,g):(0,r.localize)(35,null,g):w?(0,r.localize)(36,null,g):(0,r.localize)(37,null,g)):m<p?(g=Math.floor(m/R),P?g===1?w?(0,r.localize)(38,null,g):(0,r.localize)(39,null,g):w?(0,r.localize)(40,null,g):(0,r.localize)(41,null,g):g===1?w?(0,r.localize)(42,null,g):(0,r.localize)(43,null,g):w?(0,r.localize)(44,null,g):(0,r.localize)(45,null,g)):(g=Math.floor(m/p),P?g===1?w?(0,r.localize)(46,null,g):(0,r.localize)(47,null,g):w?(0,r.localize)(48,null,g):(0,r.localize)(49,null,g):g===1?w?(0,r.localize)(50,null,g):(0,r.localize)(51,null,g):w?(0,r.localize)(52,null,g):(0,r.localize)(53,null,g))}function I(h,P){const w=Math.abs(h/1e3);return w<1?P?(0,r.localize)(54,null,h):(0,r.localize)(55,null,h):w<a?P?(0,r.localize)(56,null,Math.round(h)/1e3):(0,r.localize)(57,null,Math.round(h)/1e3):w<k?P?(0,r.localize)(58,null,Math.round(h/(1e3*a))):(0,r.localize)(59,null,Math.round(h/(1e3*a))):w<A?P?(0,r.localize)(60,null,Math.round(h/(1e3*k))):(0,r.localize)(61,null,Math.round(h/(1e3*k))):(0,r.localize)(62,null,Math.round(h/(1e3*A)))}function S(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[215],De([9,10]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Se[51],De([1,0,19,18,215]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=p,e.$sj=c,e.$tj=I,r=Ue(r),a=Ue(a),k=Ue(k);function A(S,h){return h&&(S.stack||S.stacktrace)?k.localize(0,null,R(S),O(S.stack)||O(S.stacktrace)):R(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?k.localize(1,null,S.message):S.message||k.localize(2,null)}function p(S=null,h=!1){if(!S)return k.localize(3,null);if(Array.isArray(S)){const P=r.$Kb(S),w=p(P[0],h);return P.length>1?k.localize(4,null,w,P.length):w}if(a.$gg(S))return S;if(S.detail){const P=S.detail;if(P.error)return A(P.error,h);if(P.exception)return A(P.exception,h)}return S.stack?A(S,h):S.message?S.message:k.localize(5,null)}function c(S){const h=S;return h instanceof Error&&Array.isArray(h.actions)}function I(S,h){let P;return typeof S=="string"?P=new Error(S):P=S,P.actions=h,P}}),define(Se[216],De([9,10]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Se[217],De([9,10]),function(ie,e){return ie.create("vs/editor/common/languages",e)}),define(Se[88],De([1,0,83,2,195,31,210,217]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Pu=e.$Ou=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Nu=e.$Mu=e.SymbolKinds=e.SymbolTag=e.$Ku=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Iu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Hu=e.$Gu=e.$Fu=void 0,e.$Ju=d,e.$Lu=b;class p{constructor(K,ee,re){this.offset=K,this.type=ee,this.language=re,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Fu=p;class c{constructor(K,ee){this.tokens=K,this.endState=ee,this._tokenizationResultBrand=void 0}}e.$Gu=c;class I{constructor(K,ee){this.tokens=K,this.endState=ee,this._encodedTokenizationResultBrand=void 0}}e.$Hu=I;var S;(function(q){q[q.Increase=0]="Increase",q[q.Decrease=1]="Decrease"})(S||(e.HoverVerbosityAction=S={}));var h;(function(q){q[q.Method=0]="Method",q[q.Function=1]="Function",q[q.Constructor=2]="Constructor",q[q.Field=3]="Field",q[q.Variable=4]="Variable",q[q.Class=5]="Class",q[q.Struct=6]="Struct",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Event=10]="Event",q[q.Operator=11]="Operator",q[q.Unit=12]="Unit",q[q.Value=13]="Value",q[q.Constant=14]="Constant",q[q.Enum=15]="Enum",q[q.EnumMember=16]="EnumMember",q[q.Keyword=17]="Keyword",q[q.Text=18]="Text",q[q.Color=19]="Color",q[q.File=20]="File",q[q.Reference=21]="Reference",q[q.Customcolor=22]="Customcolor",q[q.Folder=23]="Folder",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue",q[q.Snippet=27]="Snippet"})(h||(e.CompletionItemKind=h={}));var P;(function(q){const K=new Map;K.set(h.Method,r.$6j.symbolMethod),K.set(h.Function,r.$6j.symbolFunction),K.set(h.Constructor,r.$6j.symbolConstructor),K.set(h.Field,r.$6j.symbolField),K.set(h.Variable,r.$6j.symbolVariable),K.set(h.Class,r.$6j.symbolClass),K.set(h.Struct,r.$6j.symbolStruct),K.set(h.Interface,r.$6j.symbolInterface),K.set(h.Module,r.$6j.symbolModule),K.set(h.Property,r.$6j.symbolProperty),K.set(h.Event,r.$6j.symbolEvent),K.set(h.Operator,r.$6j.symbolOperator),K.set(h.Unit,r.$6j.symbolUnit),K.set(h.Value,r.$6j.symbolValue),K.set(h.Enum,r.$6j.symbolEnum),K.set(h.Constant,r.$6j.symbolConstant),K.set(h.Enum,r.$6j.symbolEnum),K.set(h.EnumMember,r.$6j.symbolEnumMember),K.set(h.Keyword,r.$6j.symbolKeyword),K.set(h.Snippet,r.$6j.symbolSnippet),K.set(h.Text,r.$6j.symbolText),K.set(h.Color,r.$6j.symbolColor),K.set(h.File,r.$6j.symbolFile),K.set(h.Reference,r.$6j.symbolReference),K.set(h.Customcolor,r.$6j.symbolCustomColor),K.set(h.Folder,r.$6j.symbolFolder),K.set(h.TypeParameter,r.$6j.symbolTypeParameter),K.set(h.User,r.$6j.account),K.set(h.Issue,r.$6j.issues);function ee(Z){let $e=K.get(Z);return $e||(console.info("No codicon found for CompletionItemKind "+Z),$e=r.$6j.symbolProperty),$e}q.toIcon=ee;const re=new Map;re.set("method",h.Method),re.set("function",h.Function),re.set("constructor",h.Constructor),re.set("field",h.Field),re.set("variable",h.Variable),re.set("class",h.Class),re.set("struct",h.Struct),re.set("interface",h.Interface),re.set("module",h.Module),re.set("property",h.Property),re.set("event",h.Event),re.set("operator",h.Operator),re.set("unit",h.Unit),re.set("value",h.Value),re.set("constant",h.Constant),re.set("enum",h.Enum),re.set("enum-member",h.EnumMember),re.set("enumMember",h.EnumMember),re.set("keyword",h.Keyword),re.set("snippet",h.Snippet),re.set("text",h.Text),re.set("color",h.Color),re.set("file",h.File),re.set("reference",h.Reference),re.set("customcolor",h.Customcolor),re.set("folder",h.Folder),re.set("type-parameter",h.TypeParameter),re.set("typeParameter",h.TypeParameter),re.set("account",h.User),re.set("issue",h.Issue);function ge(Z,$e){let fe=re.get(Z);return typeof fe>"u"&&!$e&&(fe=h.Property),fe}q.fromString=ge})(P||(e.CompletionItemKinds=P={}));var w;(function(q){q[q.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var l;(function(q){q[q.None=0]="None",q[q.KeepWhitespace=1]="KeepWhitespace",q[q.InsertAsSnippet=4]="InsertAsSnippet"})(l||(e.CompletionItemInsertTextRule=l={}));var m;(function(q){q[q.Word=0]="Word",q[q.Line=1]="Line",q[q.Suggest=2]="Suggest"})(m||(e.PartialAcceptTriggerKind=m={}));var g;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var $;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})($||(e.InlineCompletionTriggerKind=$={}));class n{constructor(K,ee,re,ge){this.range=K,this.text=ee,this.completionKind=re,this.isSnippetText=ge}equals(K){return A.$Nt.lift(this.range).equalsRange(K.range)&&this.text===K.text&&this.completionKind===K.completionKind&&this.isSnippetText===K.isSnippetText}}e.$Iu=n;var o;(function(q){q[q.Invoke=1]="Invoke",q[q.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var t;(function(q){q[q.Automatic=0]="Automatic",q[q.PasteAs=1]="PasteAs"})(t||(e.DocumentPasteTriggerKind=t={}));var i;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(i||(e.SignatureHelpTriggerKind=i={}));var s;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function d(q){return q&&a.URI.isUri(q.uri)&&A.$Nt.isIRange(q.range)&&(A.$Nt.isIRange(q.originSelectionRange)||A.$Nt.isIRange(q.targetSelectionRange))}var u;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(u||(e.SymbolKind=u={})),e.$Ku={[u.Array]:(0,R.localize)(0,null),[u.Boolean]:(0,R.localize)(1,null),[u.Class]:(0,R.localize)(2,null),[u.Constant]:(0,R.localize)(3,null),[u.Constructor]:(0,R.localize)(4,null),[u.Enum]:(0,R.localize)(5,null),[u.EnumMember]:(0,R.localize)(6,null),[u.Event]:(0,R.localize)(7,null),[u.Field]:(0,R.localize)(8,null),[u.File]:(0,R.localize)(9,null),[u.Function]:(0,R.localize)(10,null),[u.Interface]:(0,R.localize)(11,null),[u.Key]:(0,R.localize)(12,null),[u.Method]:(0,R.localize)(13,null),[u.Module]:(0,R.localize)(14,null),[u.Namespace]:(0,R.localize)(15,null),[u.Null]:(0,R.localize)(16,null),[u.Number]:(0,R.localize)(17,null),[u.Object]:(0,R.localize)(18,null),[u.Operator]:(0,R.localize)(19,null),[u.Package]:(0,R.localize)(20,null),[u.Property]:(0,R.localize)(21,null),[u.String]:(0,R.localize)(22,null),[u.Struct]:(0,R.localize)(23,null),[u.TypeParameter]:(0,R.localize)(24,null),[u.Variable]:(0,R.localize)(25,null)};function b(q,K){return(0,R.localize)(26,null,q,e.$Ku[K])}var E;(function(q){q[q.Deprecated=1]="Deprecated"})(E||(e.SymbolTag=E={}));var D;(function(q){const K=new Map;K.set(u.File,r.$6j.symbolFile),K.set(u.Module,r.$6j.symbolModule),K.set(u.Namespace,r.$6j.symbolNamespace),K.set(u.Package,r.$6j.symbolPackage),K.set(u.Class,r.$6j.symbolClass),K.set(u.Method,r.$6j.symbolMethod),K.set(u.Property,r.$6j.symbolProperty),K.set(u.Field,r.$6j.symbolField),K.set(u.Constructor,r.$6j.symbolConstructor),K.set(u.Enum,r.$6j.symbolEnum),K.set(u.Interface,r.$6j.symbolInterface),K.set(u.Function,r.$6j.symbolFunction),K.set(u.Variable,r.$6j.symbolVariable),K.set(u.Constant,r.$6j.symbolConstant),K.set(u.String,r.$6j.symbolString),K.set(u.Number,r.$6j.symbolNumber),K.set(u.Boolean,r.$6j.symbolBoolean),K.set(u.Array,r.$6j.symbolArray),K.set(u.Object,r.$6j.symbolObject),K.set(u.Key,r.$6j.symbolKey),K.set(u.Null,r.$6j.symbolNull),K.set(u.EnumMember,r.$6j.symbolEnumMember),K.set(u.Struct,r.$6j.symbolStruct),K.set(u.Event,r.$6j.symbolEvent),K.set(u.Operator,r.$6j.symbolOperator),K.set(u.TypeParameter,r.$6j.symbolTypeParameter);function ee(re){let ge=K.get(re);return ge||(console.info("No codicon found for SymbolKind "+re),ge=r.$6j.symbolProperty),ge}q.toIcon=ee})(D||(e.SymbolKinds=D={}));class y{static asEditOperation(K){return k.$Ot.replace(A.$Nt.lift(K.range),K.text)}}e.$Mu=y;class T{static fromValue(K){switch(K){case"comment":return T.Comment;case"imports":return T.Imports;case"region":return T.Region}return new T(K)}constructor(K){this.value=K}}e.$Nu=T,T.Comment=new T("comment"),T.Imports=new T("imports"),T.Region=new T("region");var C;(function(q){q[q.AIGenerated=1]="AIGenerated"})(C||(e.NewSymbolNameTag=C={}));var v;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(v||(e.NewSymbolNameTriggerKind=v={}));var f;(function(q){function K(ee){return!ee||typeof ee!="object"?!1:typeof ee.id=="string"&&typeof ee.title=="string"}q.is=K})(f||(e.Command=f={}));var N;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(N||(e.CommentThreadCollapsibleState=N={}));var F;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(F||(e.CommentThreadState=F={}));var j;(function(q){q[q.Current=0]="Current",q[q.Outdated=1]="Outdated"})(j||(e.CommentThreadApplicability=j={}));var z;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var M;(function(q){q[q.Published=0]="Published",q[q.Draft=1]="Draft"})(M||(e.CommentState=M={}));var L;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class B{constructor(K){this.b=K,this.a=null}dispose(){this.a&&this.a.then(K=>{K&&K.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Ou=B,e.$Pu=new O.$wu;var W;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(W||(e.ExternalUriOpenerPriority=W={}));var ae;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})(ae||(e.InlineEditTriggerKind=ae={}))}),define(Se[218],De([9,10]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[219],De([9,10]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[220],De([9,10]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(Se[221],De([9,10]),function(ie,e){return ie.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[222],De([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[223],De([9,10]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[224],De([9,10]),function(ie,e){return ie.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[225],De([9,10]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Se[226],De([9,10]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(Se[227],De([9,10]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[228],De([9,10]),function(ie,e){return ie.create("vs/platform/log/common/log",e)}),define(Se[229],De([9,10]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Se[230],De([9,10]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(Se[231],De([9,10]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[232],De([9,10]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[233],De([9,10]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Se[234],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[235],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[236],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[237],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[238],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[239],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[240],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[241],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[242],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[243],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[244],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[245],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[246],De([9,10]),function(ie,e){return ie.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[247],De([9,10]),function(ie,e){return ie.create("vs/workbench/common/configuration",e)}),define(Se[248],De([9,10]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Se[249],De([9,10]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(Se[250],De([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[251],De([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Se[252],De([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[253],De([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[254],De([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[255],De([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[256],De([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[257],De([9,10]),function(ie,e){return ie.create("vs/workbench/contrib/testing/common/constants",e)}),define(Se[258],De([9,10]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[259],De([9,10]),function(ie,e){return ie.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[260],De([9,10]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[261],De([9,10]),function(ie,e){return ie.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[262],De([9,10]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[263],De([1,0,27,14,220]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var A;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...I){switch(I.length){case 1:return(0,k.localize)(0,null,I[0]);case 2:return(0,k.localize)(1,null,I[0],I[1]);case 3:return(0,k.localize)(2,null,I[0],I[1],I[2]);default:return}}const R=(0,k.localize)(3,null),p=(0,k.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(S){switch(S.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return S.isTripleEq?"===":"==";case A.NotEq:return S.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return S.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return S.lexeme;case A.QuotedStr:return S.lexeme;case A.Error:return S.lexeme;case A.EOF:return"EOF";default:throw(0,a.$$)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(A.LParen);break;case r.CharCode.CloseParen:this.k(A.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const h=this.h(r.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:h})}else this.k(A.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const h=this.h(r.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:h})}else this.h(r.CharCode.Tilde)?this.k(A.RegexOp):this.l(O("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?A.LtEq:A.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?A.GtEq:A.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(A.And):this.l(O("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(A.Or):this.l(O("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(S){const h=this.d,P=this.c.substring(this.d,this.e),w={type:A.Error,offset:this.d,lexeme:P};this.g.push({offset:h,lexeme:P,additionalInfo:S}),this.f.push(w)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const h=this.c.substring(this.d,this.e),P=c.b.get(h);P?this.k(P):this.f.push({type:A.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,h=!1,P=!1;for(;;){if(S>=this.c.length){this.e=S,this.l(p);return}const l=this.c.charCodeAt(S);if(h)h=!1;else if(l===r.CharCode.Slash&&!P){S++;break}else l===r.CharCode.OpenSquareBracket?P=!0:l===r.CharCode.Backslash?h=!0:l===r.CharCode.CloseSquareBracket&&(P=!1);S++}for(;S<this.c.length&&c.a.has(this.c.charCodeAt(S));)S++;this.e=S;const w=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=c,c.a=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0))),c.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}),define(Se[145],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const r={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(r)}),define(Se[113],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class r{constructor(k,A=[],O=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$Di=r}),define(Se[89],De([1,0,113]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Qs=A,e.$Rs=O;const a=[];var k;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(R,p,c){p instanceof r.$Di||(p=new r.$Di(p,[],!!c)),a.push([R,p])}function O(){return a}}),define(Se[264],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;class r{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$tr=r;class a{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const R=this.lookupOrInsertNode(A),p=this.lookupOrInsertNode(O);R.outgoing.set(p.key,p),p.incoming.set(R.key,R)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let R=this.a.get(O);return R||(R=new r(O,A),this.a.set(O,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,R]of this.a)A.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const R=new Set([A]),p=this.c(O,R);if(p)return p}}c(A,O){for(const[R,p]of A.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const c=this.c(p,O);if(c)return c;O.delete(R)}}}e.$ur=a}),define(Se[5],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=k,e.$Hi=A;var r;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(p){return p[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(r||(e._util=r={})),e.$Fi=k("instantiationService");function a(O,R,p){R[r.DI_TARGET]===R?R[r.DI_DEPENDENCIES].push({id:O,index:p}):(R[r.DI_DEPENDENCIES]=[{id:O,index:p}],R[r.DI_TARGET]=R)}function k(O){if(r.serviceIds.has(O))return r.serviceIds.get(O);const R=function(p,c,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(R,p,I)};return R.toString=()=>O,r.serviceIds.set(O,R),R}function A(O){return O}}),define(Se[46],De([1,0,18,2,5]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=A,e.$cj=O,e.$dj=p,e.$ej=c,e.$fj=I,e.$gj=S,e.$hj=h,e.$ij=w,e.$jj=l,e.$kj=m,r=Ue(r),e.$aj=(0,k.$Gi)("configurationService");function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof a.URI)}function O(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof a.URI)}var R;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function p(g){switch(g){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function c(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function I(g,$){const n=Object.create(null);for(const o in g)S(n,o,g[o],$);return n}function S(g,$,n,o){const t=$.split("."),i=t.pop();let s=g;for(let d=0;d<t.length;d++){const u=t[d];let b=s[u];switch(typeof b){case"undefined":b=s[u]=Object.create(null);break;case"object":if(b===null){o(`Ignoring ${$} as ${t.slice(0,d+1).join(".")} is null`);return}break;default:o(`Ignoring ${$} as ${t.slice(0,d+1).join(".")} is ${JSON.stringify(b)}`);return}s=b}if(typeof s=="object"&&s!==null)try{s[i]=n}catch{o(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(s)}`)}function h(g,$){const n=$.split(".");P(g,n)}function P(g,$){const n=$.shift();if($.length===0){delete g[n];return}if(Object.keys(g).indexOf(n)!==-1){const o=g[n];typeof o=="object"&&!Array.isArray(o)&&(P(o,$),Object.keys(o).length===0&&delete g[n])}}function w(g,$,n){function o(s,d){let u=s;for(const b of d){if(typeof u!="object"||u===null)return;u=u[b]}return u}const t=$.split("."),i=o(g,t);return typeof i>"u"?n:i}function l(g,$,n){Object.keys($).forEach(o=>{o!=="__proto__"&&(o in g?r.$ig(g[o])&&r.$ig($[o])?l(g[o],$[o],n):n&&(g[o]=$[o]):g[o]=$[o])})}function m(g){return g.replace(/[\[\]]/g,"")}}),define(Se[36],De([1,0,27,11,13,263,5,219,14]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=I,e.$Fj=d,e.$Gj=u,e.$Zj=Z;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",a.$d),c.set("isLinux",a.$e),c.set("isWindows",a.$c),c.set("isWeb",a.$i),c.set("isMacNative",a.$d&&!a.$i),c.set("isEdge",a.$B),c.set("isFirefox",a.$z),c.set("isChrome",a.$y),c.set("isSafari",a.$A);function I(oe,H){if(c.get(oe)!==void 0)throw(0,p.$0)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(oe,H)}const S=Object.prototype.hasOwnProperty;var h;(function(oe){oe[oe.False=0]="False",oe[oe.True=1]="True",oe[oe.Defined=2]="Defined",oe[oe.Not=3]="Not",oe[oe.Equals=4]="Equals",oe[oe.NotEquals=5]="NotEquals",oe[oe.And=6]="And",oe[oe.Regex=7]="Regex",oe[oe.NotRegex=8]="NotRegex",oe[oe.Or=9]="Or",oe[oe.In=10]="In",oe[oe.NotIn=11]="NotIn",oe[oe.Greater=12]="Greater",oe[oe.GreaterEquals=13]="GreaterEquals",oe[oe.Smaller=14]="Smaller",oe[oe.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const P={regexParsingWithErrorRecovery:!0},w=(0,R.localize)(0,null),l=(0,R.localize)(1,null),m=(0,R.localize)(2,null),g=(0,R.localize)(3,null),$=(0,R.localize)(4,null),n=(0,R.localize)(5,null),o=(0,R.localize)(6,null),t=(0,R.localize)(7,null);class i{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(H=P){this.k=H,this.d=new A.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(H){if(H===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:l});return}this.f=this.d.reset(H).scan(),this.g=0,this.h=[];try{const ue=this.l();if(!this.E()){const te=this.D(),_=te.type===A.TokenType.Str?n:void 0;throw this.h.push({message:$,offset:te.offset,lexeme:A.$Bj.getLexeme(te),additionalInfo:_}),i.c}return ue}catch(ue){if(ue!==i.c)throw ue;return}}l(){return this.m()}m(){const H=[this.o()];for(;this.y(A.TokenType.Or);){const ue=this.o();H.push(ue)}return H.length===1?H[0]:s.or(...H)}o(){const H=[this.s()];for(;this.y(A.TokenType.And);){const ue=this.s();H.push(ue)}return H.length===1?H[0]:s.and(...H)}s(){if(this.y(A.TokenType.Neg)){const H=this.D();switch(H.type){case A.TokenType.True:return this.z(),E.INSTANCE;case A.TokenType.False:return this.z(),D.INSTANCE;case A.TokenType.LParen:{this.z();const ue=this.l();return this.A(A.TokenType.RParen,g),ue?.negate()}case A.TokenType.Str:return this.z(),N.create(H.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",H)}}return this.t()}t(){const H=this.D();switch(H.type){case A.TokenType.True:return this.z(),s.true();case A.TokenType.False:return this.z(),s.false();case A.TokenType.LParen:{this.z();const ue=this.l();return this.A(A.TokenType.RParen,g),ue}case A.TokenType.Str:{const ue=H.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const _=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),_.type!==A.TokenType.RegexStr)throw this.B("REGEX",_);const ne=_.lexeme,le=ne.lastIndexOf("/"),J=le===ne.length-1?void 0:this.w(ne.substring(le+1));let ce;try{ce=new RegExp(ne.substring(1,le),J)}catch{throw this.B("REGEX",_)}return B.create(ue,ce)}switch(_.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const ne=[_.lexeme];this.z();let le=this.D(),J=0;for(let qe=0;qe<_.lexeme.length;qe++)_.lexeme.charCodeAt(qe)===r.CharCode.OpenParen?J++:_.lexeme.charCodeAt(qe)===r.CharCode.CloseParen&&J--;for(;!this.E()&&le.type!==A.TokenType.And&&le.type!==A.TokenType.Or;){switch(le.type){case A.TokenType.LParen:J++;break;case A.TokenType.RParen:J--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let qe=0;qe<le.lexeme.length;qe++)le.lexeme.charCodeAt(qe)===r.CharCode.OpenParen?J++:_.lexeme.charCodeAt(qe)===r.CharCode.CloseParen&&J--}if(J<0)break;ne.push(A.$Bj.getLexeme(le)),this.z(),le=this.D()}const ce=ne.join(""),me=ce.lastIndexOf("/"),we=me===ce.length-1?void 0:this.w(ce.substring(me+1));let Me;try{Me=new RegExp(ce.substring(1,me),we)}catch{throw this.B("REGEX",_)}return s.regex(ue,Me)}case A.TokenType.QuotedStr:{const ne=_.lexeme;this.z();let le=null;if(!(0,k.$ef)(ne)){const J=ne.indexOf("/"),ce=ne.lastIndexOf("/");if(J!==ce&&J>=0){const me=ne.slice(J+1,ce),we=ne[ce+1]==="i"?"i":"";try{le=new RegExp(me,we)}catch{throw this.B("REGEX",_)}}}if(le===null)throw this.B("REGEX",_);return B.create(ue,le)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,m);const _=this.u();return s.notIn(ue,_)}switch(this.D().type){case A.TokenType.Eq:{this.z();const _=this.u();if(this.x().type===A.TokenType.QuotedStr)return s.equals(ue,_);switch(_){case"true":return s.has(ue);case"false":return s.not(ue);default:return s.equals(ue,_)}}case A.TokenType.NotEq:{this.z();const _=this.u();if(this.x().type===A.TokenType.QuotedStr)return s.notEquals(ue,_);switch(_){case"true":return s.not(ue);case"false":return s.has(ue);default:return s.notEquals(ue,_)}}case A.TokenType.Lt:return this.z(),M.create(ue,this.u());case A.TokenType.LtEq:return this.z(),L.create(ue,this.u());case A.TokenType.Gt:return this.z(),j.create(ue,this.u());case A.TokenType.GtEq:return this.z(),z.create(ue,this.u());case A.TokenType.In:return this.z(),s.in(ue,this.u());default:return s.has(ue)}}case A.TokenType.EOF:throw this.h.push({message:o,offset:H.offset,lexeme:"",additionalInfo:t}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const H=this.D();switch(H.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),H.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(H){return H.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(H){return this.C(H)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(H,ue){if(this.C(H))return this.z();throw this.B(ue,this.D())}B(H,ue,te){const _=(0,R.localize)(8,null,H,A.$Bj.getLexeme(ue)),ne=ue.offset,le=A.$Bj.getLexeme(ue);return this.h.push({message:_,offset:ne,lexeme:le,additionalInfo:te}),i.c}C(H){return this.D().type===H}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$Dj=i,i.c=new Error;class s{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(H){return y.create(H)}static equals(H,ue){return T.create(H,ue)}static notEquals(H,ue){return f.create(H,ue)}static regex(H,ue){return B.create(H,ue)}static in(H,ue){return C.create(H,ue)}static notIn(H,ue){return v.create(H,ue)}static not(H){return N.create(H)}static and(...H){return q.create(H,null,!0)}static or(...H){return K.create(H,null,!0)}static greater(H,ue){return j.create(H,ue)}static greaterEquals(H,ue){return z.create(H,ue)}static smaller(H,ue){return M.create(H,ue)}static smallerEquals(H,ue){return L.create(H,ue)}static deserialize(H){return H==null?void 0:this.c.parse(H)}}e.$Ej=s,s.c=new i({regexParsingWithErrorRecovery:!1});function d(oe){const H=new i({regexParsingWithErrorRecovery:!1});return oe.map(ue=>(H.parse(ue),H.lexingErrors.length>0?H.lexingErrors.map(te=>({errorMessage:te.additionalInfo?(0,R.localize)(9,null,te.additionalInfo):(0,R.localize)(10,null),offset:te.offset,length:te.lexeme.length})):H.parsingErrors.length>0?H.parsingErrors.map(te=>({errorMessage:te.additionalInfo?`${te.message}. ${te.additionalInfo}`:te.message,offset:te.offset,length:te.lexeme.length})):[]))}function u(oe,H){const ue=oe?oe.substituteConstants():void 0,te=H?H.substituteConstants():void 0;return!ue&&!te?!0:!ue||!te?!1:ue.equals(te)}function b(oe,H){return oe.cmp(H)}class E{constructor(){this.type=h.False}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!1}serialize(){return"false"}keys(){return[]}map(H){return this}negate(){return D.INSTANCE}}e.$Hj=E,E.INSTANCE=new E;class D{constructor(){this.type=h.True}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!0}serialize(){return"true"}keys(){return[]}map(H){return this}negate(){return E.INSTANCE}}e.$Ij=D,D.INSTANCE=new D;class y{static create(H,ue=null){const te=c.get(H);return typeof te=="boolean"?te?D.INSTANCE:E.INSTANCE:new y(H,ue)}constructor(H,ue){this.key=H,this.c=ue,this.type=h.Defined}cmp(H){return H.type!==this.type?this.type-H.type:re(this.key,H.key)}equals(H){return H.type===this.type?this.key===H.key:!1}substituteConstants(){const H=c.get(this.key);return typeof H=="boolean"?H?D.INSTANCE:E.INSTANCE:this}evaluate(H){return!!H.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(H){return H.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Jj=y;class T{static create(H,ue,te=null){if(typeof ue=="boolean")return ue?y.create(H,te):N.create(H,te);const _=c.get(H);return typeof _=="boolean"?ue===(_?"true":"false")?D.INSTANCE:E.INSTANCE:new T(H,ue,te)}constructor(H,ue,te){this.c=H,this.d=ue,this.f=te,this.type=h.Equals}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=c.get(this.c);if(typeof H=="boolean"){const ue=H?"true":"false";return this.d===ue?D.INSTANCE:E.INSTANCE}return this}evaluate(H){return H.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(H){return H.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.$Kj=T;class C{static create(H,ue){return new C(H,ue)}constructor(H,ue){this.d=H,this.f=ue,this.type=h.In,this.c=null}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.d,this.f,H.d,H.f)}equals(H){return H.type===this.type?this.d===H.d&&this.f===H.f:!1}substituteConstants(){return this}evaluate(H){const ue=H.getValue(this.f),te=H.getValue(this.d);return Array.isArray(ue)?ue.includes(te):typeof te=="string"&&typeof ue=="object"&&ue!==null?S.call(ue,te):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(H){return H.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Lj=C;class v{static create(H,ue){return new v(H,ue)}constructor(H,ue){this.d=H,this.f=ue,this.type=h.NotIn,this.c=C.create(H,ue)}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(H){return H.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=v;class f{static create(H,ue,te=null){if(typeof ue=="boolean")return ue?N.create(H,te):y.create(H,te);const _=c.get(H);return typeof _=="boolean"?ue===(_?"true":"false")?E.INSTANCE:D.INSTANCE:new f(H,ue,te)}constructor(H,ue,te){this.c=H,this.d=ue,this.f=te,this.type=h.NotEquals}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=c.get(this.c);if(typeof H=="boolean"){const ue=H?"true":"false";return this.d===ue?E.INSTANCE:D.INSTANCE}return this}evaluate(H){return H.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(H){return H.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Nj=f;class N{static create(H,ue=null){const te=c.get(H);return typeof te=="boolean"?te?E.INSTANCE:D.INSTANCE:new N(H,ue)}constructor(H,ue){this.c=H,this.d=ue,this.type=h.Not}cmp(H){return H.type!==this.type?this.type-H.type:re(this.c,H.c)}equals(H){return H.type===this.type?this.c===H.c:!1}substituteConstants(){const H=c.get(this.c);return typeof H=="boolean"?H?E.INSTANCE:D.INSTANCE:this}evaluate(H){return!H.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(H){return H.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Oj=N;function F(oe,H){if(typeof oe=="string"){const ue=parseFloat(oe);isNaN(ue)||(oe=ue)}return typeof oe=="string"||typeof oe=="number"?H(oe):E.INSTANCE}class j{static create(H,ue,te=null){return F(ue,_=>new j(H,_,te))}constructor(H,ue,te){this.c=H,this.d=ue,this.f=te,this.type=h.Greater}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Pj=j;class z{static create(H,ue,te=null){return F(ue,_=>new z(H,_,te))}constructor(H,ue,te){this.c=H,this.d=ue,this.f=te,this.type=h.GreaterEquals}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Qj=z;class M{static create(H,ue,te=null){return F(ue,_=>new M(H,_,te))}constructor(H,ue,te){this.c=H,this.d=ue,this.f=te,this.type=h.Smaller}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Rj=M;class L{static create(H,ue,te=null){return F(ue,_=>new L(H,_,te))}constructor(H,ue,te){this.c=H,this.d=ue,this.f=te,this.type=h.SmallerEquals}cmp(H){return H.type!==this.type?this.type-H.type:ge(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Sj=L;class B{static create(H,ue){return new B(H,ue)}constructor(H,ue){this.d=H,this.f=ue,this.type=h.Regex,this.c=null}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.d<H.d)return-1;if(this.d>H.d)return 1;const ue=this.f?this.f.source:"",te=H.f?H.f.source:"";return ue<te?-1:ue>te?1:0}equals(H){if(H.type===this.type){const ue=this.f?this.f.source:"",te=H.f?H.f.source:"";return this.d===H.d&&ue===te}return!1}substituteConstants(){return this}evaluate(H){const ue=H.getValue(this.d);return this.f?this.f.test(ue):!1}serialize(){const H=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${H}`}keys(){return[this.d]}map(H){return H.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$Tj=B;class W{static create(H){return new W(H)}constructor(H){this.c=H,this.type=h.NotRegex}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(H){return new W(this.c.map(H))}negate(){return this.c}}e.$Uj=W;function ae(oe){let H=null;for(let ue=0,te=oe.length;ue<te;ue++){const _=oe[ue].substituteConstants();if(oe[ue]!==_&&H===null){H=[];for(let ne=0;ne<ue;ne++)H[ne]=oe[ne]}H!==null&&(H[ue]=_)}return H===null?oe:H}class q{static create(H,ue,te){return q.d(H,ue,te)}constructor(H,ue){this.expr=H,this.c=ue,this.type=h.And}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let ue=0,te=this.expr.length;ue<te;ue++){const _=b(this.expr[ue],H.expr[ue]);if(_!==0)return _}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let ue=0,te=this.expr.length;ue<te;ue++)if(!this.expr[ue].equals(H.expr[ue]))return!1;return!0}return!1}substituteConstants(){const H=ae(this.expr);return H===this.expr?this:q.create(H,this.c,!1)}evaluate(H){for(let ue=0,te=this.expr.length;ue<te;ue++)if(!this.expr[ue].evaluate(H))return!1;return!0}static d(H,ue,te){const _=[];let ne=!1;for(const le of H)if(le){if(le.type===h.True){ne=!0;continue}if(le.type===h.False)return E.INSTANCE;if(le.type===h.And){_.push(...le.expr);continue}_.push(le)}if(_.length===0&&ne)return D.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(b);for(let le=1;le<_.length;le++)_[le-1].equals(_[le])&&(_.splice(le,1),le--);if(_.length===1)return _[0];for(;_.length>1;){const le=_[_.length-1];if(le.type!==h.Or)break;_.pop();const J=_.pop(),ce=_.length===0,me=K.create(le.expr.map(we=>q.create([we,J],null,te)),null,ce);me&&(_.push(me),_.sort(b))}if(_.length===1)return _[0];if(te){for(let le=0;le<_.length;le++)for(let J=le+1;J<_.length;J++)if(_[le].negate().equals(_[J]))return E.INSTANCE;if(_.length===1)return _[0]}return new q(_,ue)}}serialize(){return this.expr.map(H=>H.serialize()).join(" && ")}keys(){const H=[];for(const ue of this.expr)H.push(...ue.keys());return H}map(H){return new q(this.expr.map(ue=>ue.map(H)),null)}negate(){if(!this.c){const H=[];for(const ue of this.expr)H.push(ue.negate());this.c=K.create(H,this,!0)}return this.c}}e.$Vj=q;class K{static create(H,ue,te){return K.d(H,ue,te)}constructor(H,ue){this.expr=H,this.c=ue,this.type=h.Or}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let ue=0,te=this.expr.length;ue<te;ue++){const _=b(this.expr[ue],H.expr[ue]);if(_!==0)return _}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let ue=0,te=this.expr.length;ue<te;ue++)if(!this.expr[ue].equals(H.expr[ue]))return!1;return!0}return!1}substituteConstants(){const H=ae(this.expr);return H===this.expr?this:K.create(H,this.c,!1)}evaluate(H){for(let ue=0,te=this.expr.length;ue<te;ue++)if(this.expr[ue].evaluate(H))return!0;return!1}static d(H,ue,te){let _=[],ne=!1;if(H){for(let le=0,J=H.length;le<J;le++){const ce=H[le];if(ce){if(ce.type===h.False){ne=!0;continue}if(ce.type===h.True)return D.INSTANCE;if(ce.type===h.Or){_=_.concat(ce.expr);continue}_.push(ce)}}if(_.length===0&&ne)return E.INSTANCE;_.sort(b)}if(_.length!==0){if(_.length===1)return _[0];for(let le=1;le<_.length;le++)_[le-1].equals(_[le])&&(_.splice(le,1),le--);if(_.length===1)return _[0];if(te){for(let le=0;le<_.length;le++)for(let J=le+1;J<_.length;J++)if(_[le].negate().equals(_[J]))return D.INSTANCE;if(_.length===1)return _[0]}return new K(_,ue)}}serialize(){return this.expr.map(H=>H.serialize()).join(" || ")}keys(){const H=[];for(const ue of this.expr)H.push(...ue.keys());return H}map(H){return new K(this.expr.map(ue=>ue.map(H)),null)}negate(){if(!this.c){const H=[];for(const ue of this.expr)H.push(ue.negate());for(;H.length>1;){const ue=H.shift(),te=H.shift(),_=[];for(const ne of fe(ue))for(const le of fe(te))_.push(q.create([ne,le],null,!1));H.unshift(K.create(_,null,!1))}this.c=K.create(H,this,!0)}return this.c}}e.$Wj=K;class ee extends y{static all(){return ee.d.values()}constructor(H,ue,te){super(H,null),this.f=ue,typeof te=="object"?ee.d.push({...te,key:H}):te!==!0&&ee.d.push({key:H,description:te,type:ue!=null?typeof ue:void 0})}bindTo(H){return H.createKey(this.key,this.f)}getValue(H){return H.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(H){return T.create(this.key,H)}notEqualsTo(H){return f.create(this.key,H)}}e.$Xj=ee,ee.d=[],e.$Yj=(0,O.$Gi)("contextKeyService");function re(oe,H){return oe<H?-1:oe>H?1:0}function ge(oe,H,ue,te){return oe<ue?-1:oe>ue?1:H<te?-1:H>te?1:0}function Z(oe,H){if(oe.type===h.False||H.type===h.True)return!0;if(oe.type===h.Or)return H.type===h.Or?$e(oe.expr,H.expr):!1;if(H.type===h.Or){for(const ue of H.expr)if(Z(oe,ue))return!0;return!1}if(oe.type===h.And){if(H.type===h.And)return $e(H.expr,oe.expr);for(const ue of oe.expr)if(Z(ue,H))return!0;return!1}return oe.equals(H)}function $e(oe,H){let ue=0,te=0;for(;ue<oe.length&&te<H.length;){const _=oe[ue].cmp(H[te]);if(_<0)return!1;_===0&&ue++,te++}return ue===oe.length}function fe(oe){return oe.type===h.Or?oe.expr:[oe]}}),define(Se[265],De([1,0,36,5]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$rt=e.AccessibilitySupport=e.$qt=void 0,e.$st=A,e.$qt=(0,a.$Gi)("accessibilityService");var k;(function(O){O[O.Unknown=0]="Unknown",O[O.Disabled=1]="Disabled",O[O.Enabled=2]="Enabled"})(k||(e.AccessibilitySupport=k={})),e.$rt=new r.$Xj("accessibilityModeEnabled",!1);function A(O){return O&&typeof O=="object"&&typeof O.label=="string"&&(typeof O.role>"u"||typeof O.role=="string")}e.$tt="ACCESSIBLE_VIEW_SHOWN_"}),define(Se[114],De([1,0,19,25,11,185,84,199,142,216,265]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=t,e.clampedFloat=s,e.stringSet=b,e.cursorStyleToString=F,e.filterValidationDecorations=Ie,r=Ue(r),a=Ue(a),k=Ue(k),c=Ue(c);var S;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class h{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=h;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class w{constructor(Y,Ae,Ze,et){this.id=Y,this.name=Ae,this.defaultValue=Ze,this.schema=et}applyUpdate(Y,Ae){return m(Y,Ae)}compute(Y,Ae,Ze){return Ze}}class l{constructor(Y,Ae){this.newValue=Y,this.didChange=Ae}}e.ApplyUpdateResult=l;function m(he,Y){if(typeof he!="object"||typeof Y!="object"||!he||!Y)return new l(Y,he!==Y);if(Array.isArray(he)||Array.isArray(Y)){const Ze=Array.isArray(he)&&Array.isArray(Y)&&r.$xb(he,Y);return new l(Y,!Ze)}let Ae=!1;for(const Ze in Y)if(Y.hasOwnProperty(Ze)){const et=m(he[Ze],Y[Ze]);et.didChange&&(he[Ze]=et.newValue,Ae=!0)}return new l(he,Ae)}class g{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,Ae){return m(Y,Ae)}validate(Y){return this.defaultValue}}class ${constructor(Y,Ae,Ze,et){this.id=Y,this.name=Ae,this.defaultValue=Ze,this.schema=et}applyUpdate(Y,Ae){return m(Y,Ae)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,Ae,Ze){return Ze}}function n(he,Y){return typeof he>"u"?Y:he==="false"?!1:!!he}class o extends ${constructor(Y,Ae,Ze,et=void 0){typeof et<"u"&&(et.type="boolean",et.default=Ze),super(Y,Ae,Ze,et)}validate(Y){return n(Y,this.defaultValue)}}function t(he,Y,Ae,Ze){if(typeof he>"u")return Y;let et=parseInt(he,10);return isNaN(et)?Y:(et=Math.max(Ae,et),et=Math.min(Ze,et),et|0)}class i extends ${static clampedInt(Y,Ae,Ze,et){return t(Y,Ae,Ze,et)}constructor(Y,Ae,Ze,et,ut,mt=void 0){typeof mt<"u"&&(mt.type="integer",mt.default=Ze,mt.minimum=et,mt.maximum=ut),super(Y,Ae,Ze,mt),this.minimum=et,this.maximum=ut}validate(Y){return i.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function s(he,Y,Ae,Ze){if(typeof he>"u")return Y;const et=d.float(he,Y);return d.clamp(et,Ae,Ze)}class d extends ${static clamp(Y,Ae,Ze){return Y<Ae?Ae:Y>Ze?Ze:Y}static float(Y,Ae){if(typeof Y=="number")return Y;if(typeof Y>"u")return Ae;const Ze=parseFloat(Y);return isNaN(Ze)?Ae:Ze}constructor(Y,Ae,Ze,et,ut){typeof ut<"u"&&(ut.type="number",ut.default=Ze),super(Y,Ae,Ze,ut),this.validationFn=et}validate(Y){return this.validationFn(d.float(Y,this.defaultValue))}}class u extends ${static string(Y,Ae){return typeof Y!="string"?Ae:Y}constructor(Y,Ae,Ze,et=void 0){typeof et<"u"&&(et.type="string",et.default=Ze),super(Y,Ae,Ze,et)}validate(Y){return u.string(Y,this.defaultValue)}}function b(he,Y,Ae,Ze){return typeof he!="string"?Y:Ze&&he in Ze?Ze[he]:Ae.indexOf(he)===-1?Y:he}class E extends ${constructor(Y,Ae,Ze,et,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=et,ut.default=Ze),super(Y,Ae,Ze,ut),this.c=et}validate(Y){return b(Y,this.defaultValue,this.c)}}class D extends w{constructor(Y,Ae,Ze,et,ut,mt,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=ut,Dt.default=et),super(Y,Ae,Ze,Dt),this.c=ut,this.d=mt}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function y(he){switch(he){case"none":return S.None;case"keep":return S.Keep;case"brackets":return S.Brackets;case"advanced":return S.Advanced;case"full":return S.Full}}class T extends w{constructor(){super(Ne.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(Y){switch(Y){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(Y,Ae,Ze){return Ze===I.AccessibilitySupport.Unknown?Y.accessibilitySupport:Ze}}class C extends w{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(Ne.comments,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:c.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{insertSpace:n(Ae.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ae.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var v;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(v||(e.TextEditorCursorBlinkingStyle=v={}));function f(he){switch(he){case"blink":return v.Blink;case"smooth":return v.Smooth;case"phase":return v.Phase;case"expand":return v.Expand;case"solid":return v.Solid}}var N;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function F(he){switch(he){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function j(he){switch(he){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class z extends g{constructor(){super(Ne.editorClassName)}compute(Y,Ae,Ze){const et=["monaco-editor"];return Ae.get(Ne.extraEditorClassName)&&et.push(Ae.get(Ne.extraEditorClassName)),Y.extraEditorClassName&&et.push(Y.extraEditorClassName),Ae.get(Ne.mouseStyle)==="default"?et.push("mouse-default"):Ae.get(Ne.mouseStyle)==="copy"&&et.push("mouse-copy"),Ae.get(Ne.showUnused)&&et.push("showUnused"),Ae.get(Ne.showDeprecated)&&et.push("showDeprecated"),et.join(" ")}}class M extends o{constructor(){super(Ne.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(Y,Ae,Ze){return Ze&&Y.emptySelectionClipboard}}class L extends w{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ne.find,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:c.localize(16,null),included:k.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:c.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{cursorMoveOnType:n(Ae.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":b(Ae.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":b(Ae.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ae.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ae.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ae.loop,this.defaultValue.loop)}}}class B extends w{constructor(){super(Ne.fontLigatures,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"||Y.length===0?B.OFF:Y==="true"?B.ON:Y:Y?B.ON:B.OFF}}e.EditorFontLigatures=B,B.OFF='"liga" off, "calt" off',B.ON='"liga" on, "calt" on';class W extends w{constructor(){super(Ne.fontVariations,"fontVariations",W.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?W.OFF:Y==="true"?W.TRANSLATE:Y:Y?W.TRANSLATE:W.OFF}compute(Y,Ae,Ze){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=W,W.OFF="normal",W.TRANSLATE="translate";class ae extends g{constructor(){super(Ne.fontInfo)}compute(Y,Ae,Ze){return Y.fontInfo}}class q extends ${constructor(){super(Ne.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(Y){const Ae=d.float(Y,this.defaultValue);return Ae===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Ae,6,100)}compute(Y,Ae,Ze){return Y.fontInfo.fontSize}}class K extends w{constructor(){super(Ne.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(i.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}K.c=["normal","bold","100","200","300","400","500","600","700","800","900"],K.d=1,K.e=1e3;class ee extends w{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ae={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ne.gotoLocation,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...Ae},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...Ae},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...Ae},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...Ae},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...Ae},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:Ze,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:Ze,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:Ze,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:Ze,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:Ze,description:c.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{multiple:b(Ae.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ae.multipleDefinitions??b(Ae.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ae.multipleTypeDefinitions??b(Ae.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ae.multipleDeclarations??b(Ae.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ae.multipleImplementations??b(Ae.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ae.multipleReferences??b(Ae.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(Ae.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(Ae.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(Ae.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(Ae.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(Ae.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class re extends w{constructor(){const Y={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ne.hover,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Y.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:c.localize(46,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{enabled:n(Ae.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ae.delay,this.defaultValue.delay,0,1e4),sticky:n(Ae.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ae.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Ae.above,this.defaultValue.above)}}}var ge;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(ge||(e.RenderMinimap=ge={}));class Z extends g{constructor(){super(Ne.layoutInfo)}compute(Y,Ae,Ze){return Z.computeLayout(Ae,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const Ae=Y.height/Y.lineHeight,Ze=Math.floor(Y.paddingTop/Y.lineHeight);let et=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(et=Math.max(et,Ae-1));const ut=(Ze+Y.viewLineCount+et)/(Y.pixelRatio*Y.height),mt=Math.floor(Y.viewLineCount/ut);return{typicalViewportLineCount:Ae,extraLinesBeforeFirstLine:Ze,extraLinesBeyondLastLine:et,desiredRatio:ut,minimapLineCount:mt}}static c(Y,Ae){const Ze=Y.outerWidth,et=Y.outerHeight,ut=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:ge.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const mt=Ae.stableMinimapLayoutInput,Dt=mt&&Y.outerHeight===mt.outerHeight&&Y.lineHeight===mt.lineHeight&&Y.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===mt.pixelRatio&&Y.scrollBeyondLastLine===mt.scrollBeyondLastLine&&Y.paddingTop===mt.paddingTop&&Y.paddingBottom===mt.paddingBottom&&Y.minimap.enabled===mt.minimap.enabled&&Y.minimap.side===mt.minimap.side&&Y.minimap.size===mt.minimap.size&&Y.minimap.showSlider===mt.minimap.showSlider&&Y.minimap.renderCharacters===mt.minimap.renderCharacters&&Y.minimap.maxColumn===mt.minimap.maxColumn&&Y.minimap.scale===mt.minimap.scale&&Y.verticalScrollbarWidth===mt.verticalScrollbarWidth&&Y.isViewportWrapping===mt.isViewportWrapping,Ft=Y.lineHeight,Kt=Y.typicalHalfwidthCharacterWidth,li=Y.scrollBeyondLastLine,fi=Y.minimap.renderCharacters;let tt=ut>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const xt=Y.minimap.maxColumn,Jt=Y.minimap.size,wt=Y.minimap.side,kt=Y.verticalScrollbarWidth,si=Y.viewLineCount,_t=Y.remainingWidth,Wt=Y.isViewportWrapping,vt=fi?2:3;let Tt=Math.floor(ut*et);const ei=Tt/ut;let Vt=!1,_e=!1,ti=vt*tt,oi=tt/ut,gi=1;if(Jt==="fill"||Jt==="fit"){const{typicalViewportLineCount:ui,extraLinesBeforeFirstLine:jt,extraLinesBeyondLastLine:Xt,desiredRatio:ni,minimapLineCount:Ot}=Z.computeContainedMinimapLineCount({viewLineCount:si,scrollBeyondLastLine:li,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:et,lineHeight:Ft,pixelRatio:ut});if(si/Ot>1)Vt=!0,_e=!0,tt=1,ti=1,oi=tt/ut;else{let Et=!1,ri=tt+1;if(Jt==="fit"){const yt=Math.ceil((jt+si+Xt)*ti);Wt&&Dt&&_t<=Ae.stableFitRemainingWidth?(Et=!0,ri=Ae.stableFitMaxMinimapScale):Et=yt>Tt}if(Jt==="fill"||Et){Vt=!0;const yt=tt;ti=Math.min(Ft*ut,Math.max(1,Math.floor(1/ni))),Wt&&Dt&&_t<=Ae.stableFitRemainingWidth&&(ri=Ae.stableFitMaxMinimapScale),tt=Math.min(ri,Math.max(1,Math.floor(ti/vt))),tt>yt&&(gi=Math.min(2,tt/yt)),oi=tt/ut/gi,Tt=Math.ceil(Math.max(ui,jt+si+Xt)*ti),Wt?(Ae.stableMinimapLayoutInput=Y,Ae.stableFitRemainingWidth=_t,Ae.stableFitMaxMinimapScale=tt):(Ae.stableMinimapLayoutInput=null,Ae.stableFitRemainingWidth=0)}}}const Ct=Math.floor(xt*oi),Gt=Math.min(Ct,Math.max(0,Math.floor((_t-kt-2)*oi/(Kt+oi)))+e.MINIMAP_GUTTER_WIDTH);let Mt=Math.floor(ut*Gt);const Ht=Mt/ut;Mt=Math.floor(Mt*gi);const $i=fi?ge.Text:ge.Blocks,ii=wt==="left"?0:Ze-Gt-kt;return{renderMinimap:$i,minimapLeft:ii,minimapWidth:Gt,minimapHeightIsEditorHeight:Vt,minimapIsSampling:_e,minimapScale:tt,minimapLineHeight:ti,minimapCanvasInnerWidth:Mt,minimapCanvasInnerHeight:Tt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:ei}}static computeLayout(Y,Ae){const Ze=Ae.outerWidth|0,et=Ae.outerHeight|0,ut=Ae.lineHeight|0,mt=Ae.lineNumbersDigitCount|0,Dt=Ae.typicalHalfwidthCharacterWidth,Ft=Ae.maxDigitWidth,Kt=Ae.pixelRatio,li=Ae.viewLineCount,fi=Y.get(Ne.wordWrapOverride2),tt=fi==="inherit"?Y.get(Ne.wordWrapOverride1):fi,xt=tt==="inherit"?Y.get(Ne.wordWrap):tt,Jt=Y.get(Ne.wordWrapColumn),wt=Ae.isDominatedByLongLines,kt=Y.get(Ne.glyphMargin),si=Y.get(Ne.lineNumbers).renderType!==qe.Off,_t=Y.get(Ne.lineNumbersMinChars),Wt=Y.get(Ne.scrollBeyondLastLine),vt=Y.get(Ne.padding),Tt=Y.get(Ne.minimap),ei=Y.get(Ne.scrollbar),Vt=ei.verticalScrollbarSize,_e=ei.verticalHasArrows,ti=ei.arrowSize,oi=ei.horizontalScrollbarSize,gi=Y.get(Ne.folding),Ct=Y.get(Ne.showFoldingControls)!=="never";let Gt=Y.get(Ne.lineDecorationsWidth);gi&&Ct&&(Gt+=16);let Mt=0;if(si){const Qt=Math.max(mt,_t);Mt=Math.round(Qt*Ft)}let Ht=0;kt&&(Ht=ut*Ae.glyphMarginDecorationLaneCount);let $i=0,ii=$i+Ht,ui=ii+Mt,jt=ui+Gt;const Xt=Ze-Ht-Mt-Gt;let ni=!1,Ot=!1,At=-1;tt==="inherit"&&wt?(ni=!0,Ot=!0):xt==="on"||xt==="bounded"?Ot=!0:xt==="wordWrapColumn"&&(At=Jt);const Et=Z.c({outerWidth:Ze,outerHeight:et,lineHeight:ut,typicalHalfwidthCharacterWidth:Dt,pixelRatio:Kt,scrollBeyondLastLine:Wt,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:Tt,verticalScrollbarWidth:Vt,viewLineCount:li,remainingWidth:Xt,isViewportWrapping:Ot},Ae.memory||new P);Et.renderMinimap!==ge.None&&Et.minimapLeft===0&&($i+=Et.minimapWidth,ii+=Et.minimapWidth,ui+=Et.minimapWidth,jt+=Et.minimapWidth);const ri=Xt-Et.minimapWidth,yt=Math.max(1,Math.floor((ri-Vt-2)/Dt)),ai=_e?ti:0;return Ot&&(At=Math.max(1,yt),xt==="bounded"&&(At=Math.min(At,Jt))),{width:Ze,height:et,glyphMarginLeft:$i,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:Ae.glyphMarginDecorationLaneCount,lineNumbersLeft:ii,lineNumbersWidth:Mt,decorationsLeft:ui,decorationsWidth:Gt,contentLeft:jt,contentWidth:ri,minimap:Et,viewportColumn:yt,isWordWrapMinified:ni,isViewportWrapping:Ot,wrappingColumn:At,verticalScrollbarWidth:Vt,horizontalScrollbarHeight:oi,overviewRuler:{top:ai,width:Vt,height:et-2*ai,right:0}}}}e.EditorLayoutInfoComputer=Z;class $e extends w{constructor(){super(Ne.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(Y){return b(Y,"simple",["simple","advanced"])}compute(Y,Ae,Ze){return Ae.get(Ne.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Ze}}var fe;(function(he){he.Off="off",he.OnCode="onCode",he.On="on"})(fe||(e.ShowLightbulbIconMode=fe={}));class oe extends w{constructor(){const Y={enabled:fe.On};super(Ne.lightbulb,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[fe.Off,fe.OnCode,fe.On],default:Y.enabled,enumDescriptions:[c.localize(50,null),c.localize(51,null),c.localize(52,null)],description:c.localize(53,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:b(Y.enabled,this.defaultValue.enabled,[fe.Off,fe.OnCode,fe.On])}}}class H extends w{constructor(){const Y={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ne.stickyScroll,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:c.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:20,description:c.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:c.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:c.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{enabled:n(Ae.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ae.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b(Ae.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ae.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ue extends w{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ne.inlayHints,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:c.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(59,null),c.localize(60,null,k.$d?"Ctrl+Option":"Ctrl+Alt"),c.localize(61,null,k.$d?"Ctrl+Option":"Ctrl+Alt"),c.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:c.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:c.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:c.localize(65,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return typeof Ae.enabled=="boolean"&&(Ae.enabled=Ae.enabled?"on":"off"),{enabled:b(Ae.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ae.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(Ae.fontFamily,this.defaultValue.fontFamily),padding:n(Ae.padding,this.defaultValue.padding)}}}class te extends w{constructor(){super(Ne.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):i.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,Ae,Ze){return Ze<0?i.clampedInt(-Ze*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ze}}class _ extends d{constructor(){super(Ne.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>d.clamp(Y,0,150),{markdownDescription:c.localize(66,null)})}compute(Y,Ae,Ze){return Y.fontInfo.lineHeight}}class ne extends w{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ne.minimap,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:c.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:c.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(69,null),c.localize(70,null),c.localize(71,null)],default:Y.size,description:c.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:c.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:c.localize(74,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:c.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:c.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Y.showRegionSectionHeaders,description:c.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Y.showMarkSectionHeaders,description:c.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Y.sectionHeaderFontSize,description:c.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:Y.sectionHeaderLetterSpacing,description:c.localize(81,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{enabled:n(Ae.enabled,this.defaultValue.enabled),autohide:n(Ae.autohide,this.defaultValue.autohide),size:b(Ae.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(Ae.side,this.defaultValue.side,["right","left"]),showSlider:b(Ae.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ae.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ae.scale,1,1,3),maxColumn:i.clampedInt(Ae.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Ae.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Ae.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(Ae.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(Ae.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function le(he){return he==="ctrlCmd"?k.$d?"metaKey":"ctrlKey":"altKey"}class J extends w{constructor(){super(Ne.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(83,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{top:i.clampedInt(Ae.top,0,0,1e3),bottom:i.clampedInt(Ae.bottom,0,0,1e3)}}}class ce extends w{constructor(){const Y={enabled:!0,cycle:!0};super(Ne.parameterHints,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:c.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:c.localize(85,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{enabled:n(Ae.enabled,this.defaultValue.enabled),cycle:n(Ae.cycle,this.defaultValue.cycle)}}}class me extends g{constructor(){super(Ne.pixelRatio)}compute(Y,Ae,Ze){return Y.pixelRatio}}class we extends w{constructor(){super(Ne.placeholder,"placeholder",void 0)}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y:this.defaultValue}}class Me extends w{constructor(){const Y={other:"on",comments:"off",strings:"off"},Ae=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null)]}];super(Ne.quickSuggestions,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ae,default:Y.strings,description:c.localize(89,null)},comments:{anyOf:Ae,default:Y.comments,description:c.localize(90,null)},other:{anyOf:Ae,default:Y.other,description:c.localize(91,null)}},default:Y,markdownDescription:c.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Kt=Y?"on":"off";return{comments:Kt,strings:Kt,other:Kt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:Ae,comments:Ze,strings:et}=Y,ut=["on","inline","off"];let mt,Dt,Ft;return typeof Ae=="boolean"?mt=Ae?"on":"off":mt=b(Ae,this.defaultValue.other,ut),typeof Ze=="boolean"?Dt=Ze?"on":"off":Dt=b(Ze,this.defaultValue.comments,ut),typeof et=="boolean"?Ft=et?"on":"off":Ft=b(et,this.defaultValue.strings,ut),{other:mt,comments:Dt,strings:Ft}}}var qe;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(qe||(e.RenderLineNumbersType=qe={}));class ke extends w{constructor(){super(Ne.lineNumbers,"lineNumbers",{renderType:qe.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(93,null),c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"on",description:c.localize(97,null)})}validate(Y){let Ae=this.defaultValue.renderType,Ze=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(Ae=qe.Custom,Ze=Y):Y==="interval"?Ae=qe.Interval:Y==="relative"?Ae=qe.Relative:Y==="on"?Ae=qe.On:Ae=qe.Off),{renderType:Ae,renderFn:Ze}}}function Ie(he){const Y=he.get(Ne.renderValidationDecorations);return Y==="editable"?he.get(Ne.readOnly):Y!=="on"}class Ce extends w{constructor(){const Y=[],Ae={type:"number",description:c.localize(98,null)};super(Ne.rulers,"rulers",Y,{type:"array",items:{anyOf:[Ae,{type:["object"],properties:{column:Ae,color:{type:"string",description:c.localize(99,null),format:"color-hex"}}}]},default:Y,description:c.localize(100,null)})}validate(Y){if(Array.isArray(Y)){const Ae=[];for(const Ze of Y)if(typeof Ze=="number")Ae.push({column:i.clampedInt(Ze,0,0,1e4),color:null});else if(Ze&&typeof Ze=="object"){const et=Ze;Ae.push({column:i.clampedInt(et.column,0,0,1e4),color:et.color})}return Ae.sort((Ze,et)=>Ze.column-et.column),Ae}return this.defaultValue}}class U extends w{constructor(){super(Ne.readOnlyMessage,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function V(he,Y){if(typeof he!="string")return Y;switch(he){case"hidden":return A.ScrollbarVisibility.Hidden;case"visible":return A.ScrollbarVisibility.Visible;default:return A.ScrollbarVisibility.Auto}}class X extends w{constructor(){const Y={vertical:A.ScrollbarVisibility.Auto,horizontal:A.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ne.scrollbar,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(101,null),c.localize(102,null),c.localize(103,null)],default:"auto",description:c.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(105,null),c.localize(106,null),c.localize(107,null)],default:"auto",description:c.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:c.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:c.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:c.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Y.ignoreHorizontalScrollbarInContentHeight,description:c.localize(112,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y,Ze=i.clampedInt(Ae.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=i.clampedInt(Ae.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ae.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(Ae.vertical,this.defaultValue.vertical),horizontal:V(Ae.horizontal,this.defaultValue.horizontal),useShadows:n(Ae.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ae.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ae.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ae.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ae.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ze,horizontalSliderSize:i.clampedInt(Ae.horizontalSliderSize,Ze,0,1e3),verticalScrollbarSize:et,verticalSliderSize:i.clampedInt(Ae.verticalSliderSize,et,0,1e3),scrollByPage:n(Ae.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Ae.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends w{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ne.unicodeHighlighting,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:c.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:c.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:c.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:c.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:c.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:c.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:c.localize(119,null)}})}applyUpdate(Y,Ae){let Ze=!1;Ae.allowedCharacters&&Y&&(a.$jo(Y.allowedCharacters,Ae.allowedCharacters)||(Y={...Y,allowedCharacters:Ae.allowedCharacters},Ze=!0)),Ae.allowedLocales&&Y&&(a.$jo(Y.allowedLocales,Ae.allowedLocales)||(Y={...Y,allowedLocales:Ae.allowedLocales},Ze=!0));const et=super.applyUpdate(Y,Ae);return Ze?new l(et.newValue,!0):et}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{nonBasicASCII:Xe(Ae.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ae.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ae.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Xe(Ae.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Xe(Ae.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,Ae){if(typeof Y!="object"||!Y)return Ae;const Ze={};for(const[et,ut]of Object.entries(Y))ut===!0&&(Ze[et]=!0);return Ze}}class de extends w{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ne.inlineSuggest,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:c.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],description:c.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:c.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Y.fontFamily,description:c.localize(126,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{enabled:n(Ae.enabled,this.defaultValue.enabled),mode:b(Ae.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b(Ae.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Ae.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ae.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:u.string(Ae.fontFamily,this.defaultValue.fontFamily)}}}class ve extends w{constructor(){const Y={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Ne.inlineEdit,"experimentalInlineEdit",Y,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Y.enabled,description:c.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(128,null),c.localize(129,null),c.localize(130,null)],description:c.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Y.fontFamily,description:c.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Y.backgroundColoring,description:c.localize(133,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{enabled:n(Ae.enabled,this.defaultValue.enabled),showToolbar:b(Ae.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:u.string(Ae.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Ae.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Ae.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Fe extends w{constructor(){const Y={enabled:R.$kt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$kt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ne.bracketPairColorization,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:c.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:c.localize(135,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{enabled:n(Ae.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ae.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ge extends w{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ne.guides,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:Y.bracketPairs,description:c.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null)],default:Y.bracketPairsHorizontal,description:c.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:c.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:c.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(146,null),c.localize(147,null),c.localize(148,null)],default:Y.highlightActiveIndentation,description:c.localize(149,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{bracketPairs:Xe(Ae.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Xe(Ae.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ae.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ae.indentation,this.defaultValue.indentation),highlightActiveIndentation:Xe(Ae.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Xe(he,Y,Ae){const Ze=Ae.indexOf(he);return Ze===-1?Y:Ae[Ze]}class Qe extends w{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ne.suggest,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(150,null),c.localize(151,null)],default:Y.insertMode,description:c.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:c.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:c.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:c.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null)],default:Y.selectionMode,markdownDescription:c.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:c.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:c.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:c.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:c.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:c.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(197,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{insertMode:b(Ae.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ae.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ae.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ae.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ae.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b(Ae.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ae.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ae.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ae.preview,this.defaultValue.preview),previewMode:b(Ae.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ae.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ae.showMethods,this.defaultValue.showMethods),showFunctions:n(Ae.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ae.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ae.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ae.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ae.showFields,this.defaultValue.showFields),showVariables:n(Ae.showVariables,this.defaultValue.showVariables),showClasses:n(Ae.showClasses,this.defaultValue.showClasses),showStructs:n(Ae.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ae.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ae.showModules,this.defaultValue.showModules),showProperties:n(Ae.showProperties,this.defaultValue.showProperties),showEvents:n(Ae.showEvents,this.defaultValue.showEvents),showOperators:n(Ae.showOperators,this.defaultValue.showOperators),showUnits:n(Ae.showUnits,this.defaultValue.showUnits),showValues:n(Ae.showValues,this.defaultValue.showValues),showConstants:n(Ae.showConstants,this.defaultValue.showConstants),showEnums:n(Ae.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ae.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ae.showKeywords,this.defaultValue.showKeywords),showWords:n(Ae.showWords,this.defaultValue.showWords),showColors:n(Ae.showColors,this.defaultValue.showColors),showFiles:n(Ae.showFiles,this.defaultValue.showFiles),showReferences:n(Ae.showReferences,this.defaultValue.showReferences),showFolders:n(Ae.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ae.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ae.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ae.showUsers,this.defaultValue.showUsers),showIssues:n(Ae.showIssues,this.defaultValue.showIssues)}}}class nt extends w{constructor(){super(Ne.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(199,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(Y.selectSubwords,this.defaultValue.selectSubwords)}}}class ct extends w{constructor(){const Y=[];super(Ne.wordSegmenterLocales,"wordSegmenterLocales",Y,{anyOf:[{description:c.localize(200,null),type:"string"},{description:c.localize(201,null),type:"array",items:{type:"string"}}]})}validate(Y){if(typeof Y=="string"&&(Y=[Y]),Array.isArray(Y)){const Ae=[];for(const Ze of Y)if(typeof Ze=="string")try{Intl.Segmenter.supportedLocalesOf(Ze).length>0&&Ae.push(Ze)}catch{}return Ae}return this.defaultValue}}var rt;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(rt||(e.WrappingIndent=rt={}));class lt extends w{constructor(){super(Ne.wrappingIndent,"wrappingIndent",rt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),c.localize(205,null)],description:c.localize(206,null),default:"same"}})}validate(Y){switch(Y){case"none":return rt.None;case"same":return rt.Same;case"indent":return rt.Indent;case"deepIndent":return rt.DeepIndent}return rt.Same}compute(Y,Ae,Ze){return Ae.get(Ne.accessibilitySupport)===I.AccessibilitySupport.Enabled?rt.None:Ze}}class bt extends g{constructor(){super(Ne.wrappingInfo)}compute(Y,Ae,Ze){const et=Ae.get(Ne.layoutInfo);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}class ft extends w{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(Ne.dropIntoEditor,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:c.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(209,null),c.localize(210,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{enabled:n(Ae.enabled,this.defaultValue.enabled),showDropSelector:b(Ae.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends w{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(Ne.pasteAs,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:c.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(213,null),c.localize(214,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const Ae=Y;return{enabled:n(Ae.enabled,this.defaultValue.enabled),showPasteSelector:b(Ae.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const dt="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.$d?Pe:k.$e?ze:dt,fontWeight:"normal",fontSize:k.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(he){return e.editorOptionsRegistry[he.id]=he,he}var Ne;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.inlineEdit=63]="inlineEdit",he[he.letterSpacing=64]="letterSpacing",he[he.lightbulb=65]="lightbulb",he[he.lineDecorationsWidth=66]="lineDecorationsWidth",he[he.lineHeight=67]="lineHeight",he[he.lineNumbers=68]="lineNumbers",he[he.lineNumbersMinChars=69]="lineNumbersMinChars",he[he.linkedEditing=70]="linkedEditing",he[he.links=71]="links",he[he.matchBrackets=72]="matchBrackets",he[he.minimap=73]="minimap",he[he.mouseStyle=74]="mouseStyle",he[he.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=76]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",he[he.multiCursorModifier=78]="multiCursorModifier",he[he.multiCursorPaste=79]="multiCursorPaste",he[he.multiCursorLimit=80]="multiCursorLimit",he[he.occurrencesHighlight=81]="occurrencesHighlight",he[he.overviewRulerBorder=82]="overviewRulerBorder",he[he.overviewRulerLanes=83]="overviewRulerLanes",he[he.padding=84]="padding",he[he.pasteAs=85]="pasteAs",he[he.parameterHints=86]="parameterHints",he[he.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",he[he.placeholder=88]="placeholder",he[he.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",he[he.quickSuggestions=90]="quickSuggestions",he[he.quickSuggestionsDelay=91]="quickSuggestionsDelay",he[he.readOnly=92]="readOnly",he[he.readOnlyMessage=93]="readOnlyMessage",he[he.renameOnType=94]="renameOnType",he[he.renderControlCharacters=95]="renderControlCharacters",he[he.renderFinalNewline=96]="renderFinalNewline",he[he.renderLineHighlight=97]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=99]="renderValidationDecorations",he[he.renderWhitespace=100]="renderWhitespace",he[he.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",he[he.roundedSelection=102]="roundedSelection",he[he.rulers=103]="rulers",he[he.scrollbar=104]="scrollbar",he[he.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=106]="scrollBeyondLastLine",he[he.scrollPredominantAxis=107]="scrollPredominantAxis",he[he.selectionClipboard=108]="selectionClipboard",he[he.selectionHighlight=109]="selectionHighlight",he[he.selectOnLineNumbers=110]="selectOnLineNumbers",he[he.showFoldingControls=111]="showFoldingControls",he[he.showUnused=112]="showUnused",he[he.snippetSuggestions=113]="snippetSuggestions",he[he.smartSelect=114]="smartSelect",he[he.smoothScrolling=115]="smoothScrolling",he[he.stickyScroll=116]="stickyScroll",he[he.stickyTabStops=117]="stickyTabStops",he[he.stopRenderingLineAfter=118]="stopRenderingLineAfter",he[he.suggest=119]="suggest",he[he.suggestFontSize=120]="suggestFontSize",he[he.suggestLineHeight=121]="suggestLineHeight",he[he.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",he[he.suggestSelection=123]="suggestSelection",he[he.tabCompletion=124]="tabCompletion",he[he.tabIndex=125]="tabIndex",he[he.unicodeHighlighting=126]="unicodeHighlighting",he[he.unusualLineTerminators=127]="unusualLineTerminators",he[he.useShadowDOM=128]="useShadowDOM",he[he.useTabStops=129]="useTabStops",he[he.wordBreak=130]="wordBreak",he[he.wordSegmenterLocales=131]="wordSegmenterLocales",he[he.wordSeparators=132]="wordSeparators",he[he.wordWrap=133]="wordWrap",he[he.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=136]="wordWrapColumn",he[he.wordWrapOverride1=137]="wordWrapOverride1",he[he.wordWrapOverride2=138]="wordWrapOverride2",he[he.wrappingIndent=139]="wrappingIndent",he[he.wrappingStrategy=140]="wrappingStrategy",he[he.showDeprecated=141]="showDeprecated",he[he.inlayHints=142]="inlayHints",he[he.editorClassName=143]="editorClassName",he[he.pixelRatio=144]="pixelRatio",he[he.tabFocusMode=145]="tabFocusMode",he[he.layoutInfo=146]="layoutInfo",he[he.wrappingInfo=147]="wrappingInfo",he[he.defaultColorDecorators=148]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Ne||(e.EditorOption=Ne={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new o(Ne.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(215,null)})),acceptSuggestionOnEnter:Re(new E(Ne.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(216,null),""],markdownDescription:c.localize(217,null)})),accessibilitySupport:Re(new T),accessibilityPageSize:Re(new i(Ne.accessibilityPageSize,"accessibilityPageSize",10,1,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(218,null),tags:["accessibility"]})),ariaLabel:Re(new u(Ne.ariaLabel,"ariaLabel",c.localize(219,null))),ariaRequired:Re(new o(Ne.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new o(Ne.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Re(new E(Ne.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),autoClosingComments:Re(new E(Ne.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(224,null),c.localize(225,null),""],description:c.localize(226,null)})),autoClosingDelete:Re(new E(Ne.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(227,null),""],description:c.localize(228,null)})),autoClosingOvertype:Re(new E(Ne.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(229,null),""],description:c.localize(230,null)})),autoClosingQuotes:Re(new E(Ne.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(231,null),c.localize(232,null),""],description:c.localize(233,null)})),autoIndent:Re(new D(Ne.autoIndent,"autoIndent",S.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(234,null),c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),automaticLayout:Re(new o(Ne.automaticLayout,"automaticLayout",!1)),autoSurround:Re(new E(Ne.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(240,null),c.localize(241,null),c.localize(242,null),""],description:c.localize(243,null)})),bracketPairColorization:Re(new Fe),bracketPairGuides:Re(new Ge),stickyTabStops:Re(new o(Ne.stickyTabStops,"stickyTabStops",!1,{description:c.localize(244,null)})),codeLens:Re(new o(Ne.codeLens,"codeLens",!0,{description:c.localize(245,null)})),codeLensFontFamily:Re(new u(Ne.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(246,null)})),codeLensFontSize:Re(new i(Ne.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(247,null)})),colorDecorators:Re(new o(Ne.colorDecorators,"colorDecorators",!0,{description:c.localize(248,null)})),colorDecoratorActivatedOn:Re(new E(Ne.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(249,null),c.localize(250,null),c.localize(251,null)],description:c.localize(252,null)})),colorDecoratorsLimit:Re(new i(Ne.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(253,null)})),columnSelection:Re(new o(Ne.columnSelection,"columnSelection",!1,{description:c.localize(254,null)})),comments:Re(new C),contextmenu:Re(new o(Ne.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new o(Ne.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(255,null)})),cursorBlinking:Re(new D(Ne.cursorBlinking,"cursorBlinking",v.Blink,"blink",["blink","smooth","phase","expand","solid"],f,{description:c.localize(256,null)})),cursorSmoothCaretAnimation:Re(new E(Ne.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),cursorStyle:Re(new D(Ne.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],j,{description:c.localize(261,null)})),cursorSurroundingLines:Re(new i(Ne.cursorSurroundingLines,"cursorSurroundingLines",0,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(262,null)})),cursorSurroundingLinesStyle:Re(new E(Ne.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],markdownDescription:c.localize(265,null)})),cursorWidth:Re(new i(Ne.cursorWidth,"cursorWidth",0,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(266,null)})),disableLayerHinting:Re(new o(Ne.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new o(Ne.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new o(Ne.domReadOnly,"domReadOnly",!1)),dragAndDrop:Re(new o(Ne.dragAndDrop,"dragAndDrop",!0,{description:c.localize(267,null)})),emptySelectionClipboard:Re(new M),dropIntoEditor:Re(new ft),stickyScroll:Re(new H),experimentalWhitespaceRendering:Re(new E(Ne.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(268,null),c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),extraEditorClassName:Re(new u(Ne.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Re(new d(Ne.fastScrollSensitivity,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:c.localize(272,null)})),find:Re(new L),fixedOverflowWidgets:Re(new o(Ne.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Re(new o(Ne.folding,"folding",!0,{description:c.localize(273,null)})),foldingStrategy:Re(new E(Ne.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(274,null),c.localize(275,null)],description:c.localize(276,null)})),foldingHighlight:Re(new o(Ne.foldingHighlight,"foldingHighlight",!0,{description:c.localize(277,null)})),foldingImportsByDefault:Re(new o(Ne.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(278,null)})),foldingMaximumRegions:Re(new i(Ne.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(279,null)})),unfoldOnClickAfterEndOfLine:Re(new o(Ne.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(280,null)})),fontFamily:Re(new u(Ne.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(281,null)})),fontInfo:Re(new ae),fontLigatures2:Re(new B),fontSize:Re(new q),fontWeight:Re(new K),fontVariations:Re(new W),formatOnPaste:Re(new o(Ne.formatOnPaste,"formatOnPaste",!1,{description:c.localize(282,null)})),formatOnType:Re(new o(Ne.formatOnType,"formatOnType",!1,{description:c.localize(283,null)})),glyphMargin:Re(new o(Ne.glyphMargin,"glyphMargin",!0,{description:c.localize(284,null)})),gotoLocation:Re(new ee),hideCursorInOverviewRuler:Re(new o(Ne.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(285,null)})),hover:Re(new re),inDiffEditor:Re(new o(Ne.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Re(new d(Ne.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>d.clamp(he,-5,20),{description:c.localize(286,null)})),lightbulb:Re(new oe),lineDecorationsWidth:Re(new te),lineHeight:Re(new _),lineNumbers:Re(new ke),lineNumbersMinChars:Re(new i(Ne.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new o(Ne.linkedEditing,"linkedEditing",!1,{description:c.localize(287,null)})),links:Re(new o(Ne.links,"links",!0,{description:c.localize(288,null)})),matchBrackets:Re(new E(Ne.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(289,null)})),minimap:Re(new ne),mouseStyle:Re(new E(Ne.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new d(Ne.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:c.localize(290,null)})),mouseWheelZoom:Re(new o(Ne.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:k.$d?c.localize(291,null):c.localize(292,null)})),multiCursorMergeOverlapping:Re(new o(Ne.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(293,null)})),multiCursorModifier:Re(new D(Ne.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null)],markdownDescription:c.localize(296,null)})),multiCursorPaste:Re(new E(Ne.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],markdownDescription:c.localize(299,null)})),multiCursorLimit:Re(new i(Ne.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(300,null)})),occurrencesHighlight:Re(new E(Ne.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],markdownDescription:c.localize(304,null)})),overviewRulerBorder:Re(new o(Ne.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(305,null)})),overviewRulerLanes:Re(new i(Ne.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Re(new J),pasteAs:Re(new at),parameterHints:Re(new ce),peekWidgetDefaultFocus:Re(new E(Ne.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),placeholder:Re(new we),definitionLinkOpensInPeek:Re(new o(Ne.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(309,null)})),quickSuggestions:Re(new Me),quickSuggestionsDelay:Re(new i(Ne.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(310,null)})),readOnly:Re(new o(Ne.readOnly,"readOnly",!1)),readOnlyMessage:Re(new U),renameOnType:Re(new o(Ne.renameOnType,"renameOnType",!1,{description:c.localize(311,null),markdownDeprecationMessage:c.localize(312,null)})),renderControlCharacters:Re(new o(Ne.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(313,null),restricted:!0})),renderFinalNewline:Re(new E(Ne.renderFinalNewline,"renderFinalNewline",k.$e?"dimmed":"on",["off","on","dimmed"],{description:c.localize(314,null)})),renderLineHighlight:Re(new E(Ne.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(315,null)],description:c.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Re(new o(Ne.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(317,null)})),renderValidationDecorations:Re(new E(Ne.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new E(Ne.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(318,null),c.localize(319,null),c.localize(320,null),""],description:c.localize(321,null)})),revealHorizontalRightPadding:Re(new i(Ne.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new o(Ne.roundedSelection,"roundedSelection",!0,{description:c.localize(322,null)})),rulers:Re(new Ce),scrollbar:Re(new X),scrollBeyondLastColumn:Re(new i(Ne.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,O.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(323,null)})),scrollBeyondLastLine:Re(new o(Ne.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(324,null)})),scrollPredominantAxis:Re(new o(Ne.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(325,null)})),selectionClipboard:Re(new o(Ne.selectionClipboard,"selectionClipboard",!0,{description:c.localize(326,null),included:k.$e})),selectionHighlight:Re(new o(Ne.selectionHighlight,"selectionHighlight",!0,{description:c.localize(327,null)})),selectOnLineNumbers:Re(new o(Ne.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Re(new E(Ne.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),showUnused:Re(new o(Ne.showUnused,"showUnused",!0,{description:c.localize(332,null)})),showDeprecated:Re(new o(Ne.showDeprecated,"showDeprecated",!0,{description:c.localize(333,null)})),inlayHints:Re(new ue),snippetSuggestions:Re(new E(Ne.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(334,null),c.localize(335,null),c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),smartSelect:Re(new nt),smoothScrolling:Re(new o(Ne.smoothScrolling,"smoothScrolling",!1,{description:c.localize(339,null)})),stopRenderingLineAfter:Re(new i(Ne.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,O.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Re(new Qe),inlineSuggest:Re(new de),inlineEdit:Re(new ve),inlineCompletionsAccessibilityVerbose:Re(new o(Ne.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(340,null)})),suggestFontSize:Re(new i(Ne.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new i(Ne.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new o(Ne.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(343,null)})),suggestSelection:Re(new E(Ne.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(344,null),c.localize(345,null),c.localize(346,null)],description:c.localize(347,null)})),tabCompletion:Re(new E(Ne.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(348,null),c.localize(349,null),c.localize(350,null)],description:c.localize(351,null)})),tabIndex:Re(new i(Ne.tabIndex,"tabIndex",0,-1,O.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Re(new x),unusualLineTerminators:Re(new E(Ne.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)})),useShadowDOM:Re(new o(Ne.useShadowDOM,"useShadowDOM",!0)),useTabStops:Re(new o(Ne.useTabStops,"useTabStops",!0,{description:c.localize(356,null)})),wordBreak:Re(new E(Ne.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(357,null),c.localize(358,null)],description:c.localize(359,null)})),wordSegmenterLocales:Re(new ct),wordSeparators:Re(new u(Ne.wordSeparators,"wordSeparators",p.$lt,{description:c.localize(360,null)})),wordWrap:Re(new E(Ne.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null),c.localize(363,null),c.localize(364,null)],description:c.localize(365,null)})),wordWrapBreakAfterCharacters:Re(new u(Ne.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new u(Ne.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new i(Ne.wordWrapColumn,"wordWrapColumn",80,1,O.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(366,null)})),wordWrapOverride1:Re(new E(Ne.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new E(Ne.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new z),defaultColorDecorators:Re(new o(Ne.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(367,null)})),pixelRatio:Re(new me),tabFocusMode:Re(new o(Ne.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(368,null)})),layoutInfo:Re(new Z),wrappingInfo:Re(new bt),wrappingIndent:Re(new lt),wrappingStrategy:Re(new $e)}});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[266],De([1,0,23,45,221,5,108,11,25]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$0w=e.$9w=e.$8w=void 0,e.$$w=P,e.$_w=w,a=qt(a),e.$8w=(0,A.$Gi)("dialogService");var c;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(c||(c={}));class I{a(m){return this.d(m,c.Confirmation)}b(m){return this.d(m,c.Prompt)}c(m){return this.d(m,c.Input)}d(m,g){const $=[];switch(g){case c.Confirmation:{const n=m;n.primaryButton?$.push(n.primaryButton):$.push((0,k.localize)(0,null)),n.cancelButton?$.push(n.cancelButton):$.push((0,k.localize)(1,null));break}case c.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&$.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?$.push((0,k.localize)(2,null)):typeof n.cancelButton=="string"?$.push(n.cancelButton):n.cancelButton.label?$.push(n.cancelButton.label):$.push((0,k.localize)(3,null))),$.length===0&&$.push((0,k.localize)(4,null));break}case c.Input:{const n=m;n.primaryButton?$.push(n.primaryButton):$.push((0,k.localize)(5,null)),n.cancelButton?$.push(n.cancelButton):$.push((0,k.localize)(6,null));break}}return $}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===a.default.Info?"info":m===a.default.Error?"error":m===a.default.Warning?"warning":"none"}f(m,g,$){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let o=n[g]?.run({checkboxChecked:$});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:$}}}e.$9w=I,e.$0w=(0,A.$Gi)("fileDialogService");var S;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(S||(e.ConfirmResult=S={}));const h=10;function P(l){const m=[];return m.push(...l.slice(0,h).map(g=>typeof g=="string"?g:(0,r.$eh)(g))),l.length>h&&(l.length-h===1?m.push((0,k.localize)(7,null)):m.push((0,k.localize)(8,null,l.length-h))),m.push(""),m.join(`
`)}function w(l,m){const g=(0,p.$fo)(l);let $=(g.buttons??[]).map(i=>(0,O.$5w)(i)),n=(l.buttons||[]).map((i,s)=>s),o=0,t=g.cancelId??$.length-1;if($.length>1){const i=typeof t=="number"?$[t]:void 0;if(R.$e||R.$d){if(typeof i=="string"&&$.length>1&&t!==1){$.splice(t,1),$.splice(1,0,i);const s=n[t];n.splice(t,1),n.splice(1,0,s),t=1}R.$e&&$.length>1&&($=$.reverse(),n=n.reverse(),o=$.length-1,typeof i=="string"&&(t=o-1))}else if(R.$c&&typeof i=="string"&&$.length>1&&t!==$.length-1){$.splice(t,1),$.push(i);const s=n[t];n.splice(t,1),n.push(s),t=$.length-1}}return g.buttons=$,g.defaultId=o,g.cancelId=t,g.noLink=!0,g.title=g.title||m.nameLong,{options:g,buttonIndeces:n}}}),define(Se[146],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,r.$Gi)("environmentService"),e.$Oi=(0,r.$Hi)(e.$Ni)}),define(Se[267],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=e.$Z9b=void 0,e.$Z9b=(0,r.$Gi)("externalTerminal"),e.$19b="Terminal.app"}),define(Se[268],De([1,0,56,59,15,17,11,105,34,110,224,267]),function(ie,e,r,a,k,A,O,R,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=e.$Nfc=void 0,r=Ue(r),A=Ue(A),O=Ue(O),p=Ue(p),c=Ue(c),I=Ue(I);const h=I.localize(0,null);class P{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends P{openTerminal(t,i){return this.spawnTerminal(r,t,c.$ym(),i)}spawnTerminal(t,i,s,d){const u=i.windowsExec||w.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const b=A.$qc(u,".exe").toLowerCase();if(b==="cmder")return t.spawn(u,d?[d]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return u.indexOf(" ")>=0&&E.push('""'),E.push(u),b==="wt"&&E.push("-d ."),new Promise((D,y)=>{const T=g(process),C=t.spawn(s,E,{cwd:d,env:T,detached:!0});C.on("error",y),C.on("exit",()=>D())})}async runInTerminal(t,i,s,d,u){const b="windowsExec"in u&&u.windowsExec?u.windowsExec:w.getDefaultTerminalWindows(),E=await w.f();return new Promise((D,y)=>{const T=`"${i} - ${h}"`,C=`"${s.join('" "')}" & pause`,v=Object.assign({},g(process),d);Object.keys(v).filter(z=>v[z]===null).forEach(z=>delete v[z]);const f={cwd:i,env:v,windowsVerbatimArguments:!0};let N,F;A.$qc(b,".exe")==="wt"?(N=b,F=["-d",".",w.b,"/c",C]):E?(N=E,F=["-d",".",b,"/c",C]):(N=w.b,F=["/c","start",T,"/wait",b,"/c",`"${C}"`]),r.spawn(N,F,f).on("error",z=>{y($(z))}),D(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await p.Promises.exists(t)?t:void 0}catch{return}}}e.$Nfc=w,w.b="cmd.exe",Ye([a.$$h],w,"f",null);class l extends P{openTerminal(t,i){return this.spawnTerminal(r,t,i)}runInTerminal(t,i,s,d,u){const b=u.osxExec||S.$19b;return new Promise((E,D)=>{if(b===S.$19b||b==="iTerm.app"){const y=b===S.$19b?"TerminalHelper":"iTermHelper",C=[k.$1g.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||h,"-w",i];for(const N of s)C.push("-a"),C.push(N);if(d){const N=Object.assign({},g(process),d);for(const F in N){const j=N[F];j===null?(C.push("-u"),C.push(F)):(C.push("-e"),C.push(`${F}=${j}`))}}let v="";const f=r.spawn(l.b,C);f.on("error",N=>{D($(N))}),f.stderr.on("data",N=>{v+=N.toString()}),f.on("exit",N=>{if(N===0)E(void 0);else if(v){const F=v.split(`
`,1);D(new Error(F[0]))}else D(new Error(I.localize(1,null,y,N)))})}else D(new Error(I.localize(2,null,b)))})}spawnTerminal(t,i,s){const d=i.osxExec||S.$19b;return new Promise((u,b)=>{const E=["-a",d];s&&E.push(s);const D=g(process),y=t.spawn("/usr/bin/open",E,{cwd:s,env:D});y.on("error",b),y.on("exit",()=>u())})}}e.$Ofc=l,l.b="/usr/bin/osascript";class m extends P{openTerminal(t,i){return this.spawnTerminal(r,t,i)}runInTerminal(t,i,s,d,u){const b=u.linuxExec?Promise.resolve(u.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((E,D)=>{const y=[];b.then(T=>{T.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const C=`${n(s)}; echo; read -p "${m.b}" -n1;`;y.push(`''${C}''`);const v=Object.assign({},g(process),d);Object.keys(v).filter(j=>v[j]===null).forEach(j=>delete v[j]);const f={cwd:i,env:v};let N="";const F=r.spawn(T,y,f);F.on("error",j=>{D($(j))}),F.stderr.on("data",j=>{N+=j.toString()}),F.on("exit",j=>{if(j===0)E(void 0);else if(N){const z=N.split(`
`,1);D(new Error(z[0]))}else D(new Error(I.localize(4,null,T,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!O.$e)m.d=Promise.resolve("xterm");else{const t=await p.Promises.exists("/etc/debian_version");m.d=new Promise(i=>{t?i("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?i("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?i("konsole"):process.env.COLORTERM?i(process.env.COLORTERM):process.env.TERM?i(process.env.TERM):i("xterm")})}return m.d}spawnTerminal(t,i,s){const d=i.linuxExec?Promise.resolve(i.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,b)=>{d.then(E=>{const D=g(process),y=t.spawn(E,[],{cwd:s,env:D});y.on("error",b),y.on("exit",()=>u())})})}}e.$Pfc=m,m.b=I.localize(3,null);function g(o){const t={...o.env};return(0,R.$lm)(t),t}function $(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(5,null,o.path)):o}function n(o){let t="";for(const i of o)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}}),define(Se[28],De([1,0,85,17,13,18,2,225,5,11,15,49]),function(ie,e,r,a,k,A,O,R,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=h,e.$cl=m,e.$dl=$,e.$el=n,e.$fl=o,e.$gl=t,e.$hl=i,e.$il=s,e.$jl=d,e.$kl=u,e.$ll=b,e.$nl=y,e.$ol=T,e.$pl=C,e.$ql=v,e.$rl=f,e.$ul=M,e.$Gl=K,e.$Hl=ee,e.$Jl=ge,e.$al=(0,p.$Gi)("fileService");function h(Z){return Z.create===!0}var P;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(P||(e.FileType=P={}));var w;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var l;(function(Z){Z[Z.UPDATED=2]="UPDATED",Z[Z.ADDED=4]="ADDED",Z[Z.DELETED=8]="DELETED"})(l||(e.FileChangeFilter=l={}));function m(Z){const $e=Z;return!!$e&&typeof $e.onDidChange=="function"}var g;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function $(Z){return!!(Z.capabilities&g.FileReadWrite)}function n(Z){return!!(Z.capabilities&g.FileFolderCopy)}function o(Z){return!!(Z.capabilities&g.FileClone)}function t(Z){return!!(Z.capabilities&g.FileOpenReadWriteClose)}function i(Z){return!!(Z.capabilities&g.FileReadStream)}function s(Z){return $(Z)?!!(Z.capabilities&g.FileAtomicRead):!1}function d(Z){return $(Z)?!!(Z.capabilities&g.FileAtomicWrite):!1}function u(Z){return!!(Z.capabilities&g.FileAtomicDelete)}function b(Z){return!!(Z.capabilities&g.Readonly)}var E;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create($e,fe){const oe=new D($e.toString(),fe);return C(oe,fe),oe}constructor($e,fe){super($e),this.code=fe}}e.$ml=D;function y(Z,$e){return D.create(Z,$e)}function T(Z){return Z||y((0,R.localize)(0,null),E.Unknown)}function C(Z,$e){return Z.name=$e?`${$e} (FileSystemError)`:"FileSystemError",Z}function v(Z){if(!Z)return E.Unknown;if(Z instanceof D)return Z.code;const $e=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!$e)return E.Unknown;switch($e[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function f(Z){if(Z instanceof L)return Z.fileOperationResult;switch(v(Z)){case E.FileNotFound:return ae.FILE_NOT_FOUND;case E.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case E.NoPermissions:return ae.FILE_PERMISSION_DENIED;case E.FileExists:return ae.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var N;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class F{constructor($e,fe,oe){this.resource=$e,this.operation=fe,this.target=oe}isOperation($e){return this.operation===$e}}e.$sl=F;var j;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class z{constructor($e,fe){this.c=fe,this.b=void 0,this.d=new S.$X(()=>{const oe=r.$Mi.forUris(()=>this.c);return oe.fill(this.rawAdded.map(H=>[H,!0])),oe}),this.f=new S.$X(()=>{const oe=r.$Mi.forUris(()=>this.c);return oe.fill(this.rawUpdated.map(H=>[H,!0])),oe}),this.g=new S.$X(()=>{const oe=r.$Mi.forUris(()=>this.c);return oe.fill(this.rawDeleted.map(H=>[H,!0])),oe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const oe of $e){switch(oe.type){case j.ADDED:this.rawAdded.push(oe.resource);break;case j.UPDATED:this.rawUpdated.push(oe.resource);break;case j.DELETED:this.rawDeleted.push(oe.resource);break}this.b!==z.a&&(typeof oe.cId=="number"?this.b===void 0?this.b=oe.cId:this.b!==oe.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains($e,...fe){return this.h($e,{includeChildren:!1},...fe)}affects($e,...fe){return this.h($e,{includeChildren:!0},...fe)}h($e,fe,...oe){if(!$e)return!1;const H=oe.length>0;return!!((!H||oe.includes(j.ADDED))&&(this.d.value.get($e)||fe.includeChildren&&this.d.value.findSuperstr($e))||(!H||oe.includes(j.UPDATED))&&(this.f.value.get($e)||fe.includeChildren&&this.f.value.findSuperstr($e))||(!H||oe.includes(j.DELETED))&&(this.g.value.findSubstr($e)||fe.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$tl=z,z.a=null;function M(Z,$e,fe){return!Z||!$e||Z===$e||$e.length>Z.length?!1:($e.charAt($e.length-1)!==a.sep&&($e+=a.sep),fe?(0,k.$If)(Z,$e):Z.indexOf($e)===0)}class L extends Error{constructor($e,fe,oe){super($e),this.fileOperationResult=fe,this.options=oe}}e.$vl=L;class B extends L{constructor($e,fe,oe,H){super($e,fe,H),this.fileOperationResult=fe,this.size=oe}}e.$wl=B;class W extends L{constructor($e,fe,oe){super($e,ae.FILE_NOT_MODIFIED_SINCE,oe),this.stat=fe}}e.$xl=W;var ae;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var q;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$Fl="";function K(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}async function ee(Z,$e){if(!$e.hasProvider(O.URI.from({scheme:Z.scheme})))return new Promise(fe=>{const oe=$e.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===Z.scheme&&H.added&&(oe.dispose(),fe())})})}class re{static formatSize($e){return(0,A.$kg)($e)||($e=0),$e<re.KB?(0,R.localize)(1,null,$e.toFixed(0)):$e<re.MB?(0,R.localize)(2,null,($e/re.KB).toFixed(2)):$e<re.GB?(0,R.localize)(3,null,($e/re.MB).toFixed(2)):$e<re.TB?(0,R.localize)(4,null,($e/re.GB).toFixed(2)):(0,R.localize)(5,null,($e/re.TB).toFixed(2))}}e.$Il=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;function ge(Z){const $e=typeof Z=="string"||Z?.scheme===I.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===I.Schemas.file?1024*re.MB:$e?10*re.MB:c.$i?50*re.MB:1024*re.MB}}),define(Se[269],De([1,0,22,14,226,28]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=O;async function O(I,S,h,P,w,l){let m;try{await R(I,S,h,P,w,l)}catch(g){m=g}finally{m&&w.errorTransformer&&(m=w.errorTransformer(m)),typeof m<"u"&&h.error(m),h.end()}}async function R(I,S,h,P,w,l){p(l);const m=await I.open(S,{create:!1});try{p(l);let g=0,$=0,n=w&&typeof w.length=="number"?w.length:void 0,o=r.$Pe.alloc(Math.min(w.bufferSize,typeof n=="number"?n:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,i=0;do $=await I.read(m,t,o.buffer,i,o.byteLength-i),t+=$,i+=$,g+=$,typeof n=="number"&&(n-=$),i===o.byteLength&&(await h.write(P(o)),o=r.$Pe.alloc(Math.min(w.bufferSize,typeof n=="number"?n:w.bufferSize)),i=0);while($>0&&(typeof n!="number"||n>0)&&p(l)&&c(g,w));if(i>0){let s=i;typeof n=="number"&&(s=Math.min(i,n)),h.write(P(o.slice(0,s)))}}catch(g){throw(0,A.$ol)(g)}finally{await I.close(m)}}function p(I){if(I.isCancellationRequested)throw(0,a.$9)();return!0}function c(I,S){if(typeof S?.limits?.size=="number"&&I>S.limits.size)throw(0,A.$nl)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[70],De([1,0,39,3,17,11,2,28]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0,e.$3q=p,e.$4q=c,e.$8q=P,e.$9q=w,e.$0q=l,e.$$q=m,e.$_q=$,e.$ar=n;function p(o){return typeof o.correlationId=="number"}function c(o){return o.recursive===!0}class I extends a.$Xc{constructor(t,i,s,d){super(),this.h=t,this.j=i,this.m=s,this.n=d,this.c=this.B(new a.$Yc),this.f=void 0,this.g=0}s(){const t=new a.$Wc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(i=>this.h(i))),t.add(this.b.onDidLogMessage(i=>this.j(i))),t.add(this.b.onDidError(i=>this.t(i.error,i.request)))}t(t,i){this.u(t,i)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,i){return!(!this.n.restartOnError||i||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$5q=I,I.a=5;class S extends I{constructor(t,i,s){super(t,i,s,{type:"node.js",restartOnError:!1})}}e.$6q=S;class h extends I{constructor(t,i,s){super(t,i,s,{type:"universal",restartOnError:!0})}}e.$7q=h;function P(o){return o.map(t=>({type:t.type,resource:O.URI.revive(t.resource),cId:t.cId}))}function w(o){const t=new g;for(const i of o)t.processEvent(i);return t.coalesce()}function l(o,t){return typeof t=="string"&&!t.startsWith(r.$wk)&&!(0,k.$lc)(t)?{base:o,pattern:t}:t}function m(o,t){const i=[];for(const s of t)i.push((0,r.$Ak)(l(o,s)));return i}class g{constructor(){this.a=new Set,this.b=new Map}c(t){return A.$e?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const i=this.b.get(this.c(t));let s=!1;if(i){const d=i.type,u=t.type;i.resource.fsPath!==t.resource.fsPath&&(t.type===R.FileChangeType.DELETED||t.type===R.FileChangeType.ADDED)?s=!0:d===R.FileChangeType.ADDED&&u===R.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(i)):d===R.FileChangeType.DELETED&&u===R.FileChangeType.ADDED?i.type=R.FileChangeType.UPDATED:d===R.FileChangeType.ADDED&&u===R.FileChangeType.UPDATED||(i.type=u)}else s=!0;s&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],i=[];return Array.from(this.a).filter(s=>s.type!==R.FileChangeType.DELETED?(t.push(s),!1):!0).sort((s,d)=>s.resource.fsPath.length-d.resource.fsPath.length).filter(s=>i.some(d=>(0,R.$ul)(s.resource.fsPath,d,!A.$e))?!1:(i.push(s.resource.fsPath),!0)).concat(t)}}function $(o,t){if(typeof t=="number")switch(o.type){case R.FileChangeType.ADDED:return(t&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(t&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(t&R.FileChangeFilter.UPDATED)===0}return!1}function n(o){if(typeof o=="number"){const t=[];return o&R.FileChangeFilter.ADDED&&t.push("Added"),o&R.FileChangeFilter.DELETED&&t.push("Deleted"),o&R.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(Se[270],De([1,0,61,3,70,4,28,2,7]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class c extends a.$Xc{constructor(){super(),this.a=this.B(new A.$ne),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$ne),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$ne),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$7c),this.m=new Set,this.n=this.B(new p.$Eh(this.y())),this.r=5007,this.s=new p.$4h,this.R=!1,this.B(this.f(S=>this.t(S)))}t(S){this.u(S)&&this.z(S)}u(S){return(0,k.$3q)(S)}async watch(S){this.s.isSettled||this.s.complete(),this.s=new p.$4h;try{this.h.clear(),this.g.clear();for(const h of S)this.u(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.w(!1)}finally{this.s.complete()}}w(S){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))]),S?this.y():0)}y(){return 800}isSuspended(S){return typeof S.correlationId!="number"?!1:this.m.has(S.correlationId)?"polling":this.j.has(S.correlationId)}async z(S){if(this.j.has(S.correlationId))return;const h=new a.$Wc;this.j.set(S.correlationId,h),await this.s.p,!h.isDisposed&&(this.D(S,h),this.w(!0))}C(S){this.j.deleteAndDispose(S.correlationId),this.m.delete(S.correlationId),this.w(!1)}D(S,h){this.F(S,h)?(this.P(`reusing an existing recursive watcher to monitor ${S.path}`),this.m.delete(S.correlationId)):(this.G(S,h),this.m.add(S.correlationId))}F(S,h){const P=this.O?.subscribe(S.path,(w,l)=>{h.isDisposed||(w?this.D(S,h):l?.type===O.FileChangeType.ADDED&&this.H(S))});return P?(h.add(P),!0):!1}G(S,h){let P=!1;const w=(l,m)=>{if(h.isDisposed)return;const g=this.I(l),$=this.I(m),n=P;P=g,!g&&($||n)&&this.H(S)};this.P(`starting fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.watchFile)(S.path,{persistent:!1,interval:this.r},w)}catch(l){this.Q(`fs.watchFile() failed with error ${l} on path ${S.path} (correlationId: ${S.correlationId})`)}h.add((0,a.$Vc)(()=>{this.P(`stopping fs.watchFile() on ${S.path} (correlationId: ${S.correlationId})`);try{(0,r.unwatchFile)(S.path,w)}catch(l){this.Q(`fs.unwatchFile() failed with error ${l} on path ${S.path} (correlationId: ${S.correlationId})`)}}))}H(S){this.P(`detected ${S.path} exists again, resuming watcher (correlationId: ${S.correlationId})`);const h={resource:R.URI.file(S.path),type:O.FileChangeType.ADDED,cId:S.correlationId};this.a.fire([h]),this.J(h,S),this.C(S)}I(S){return S.ctimeMs===0&&S.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(S,h){if(this.R){const P=` >> normalized ${S.type===O.FileChangeType.ADDED?"[ADDED]":S.type===O.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${S.resource.fsPath}`;this.L(P,h)}}L(S,h){this.R&&this.P(`${S}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}M(S){return`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, filter: ${(0,k.$ar)(S.filter)}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`}async setVerboseLogging(S){this.R=S}}e.$jr=c}),define(Se[271],De([1,0,61,7,21,32,3,82,17,11,23,2,109,34,28,70]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0,e.$pr=g;class m extends O.$Xc{get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,o,t,i,s,d){super(),this.s=n,this.t=o,this.u=t,this.w=i,this.y=s,this.z=d,this.c=this.B(new a.$Vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.u(u))),this.f=this.B(new a.$Uh(u=>this.M(u),m.b)),this.g=(0,l.$$q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,l.$$q)(this.s.path,this.s.includes):void 0,this.j=(0,l.$3q)(this.s)?this.s.filter:void 0,this.m=new k.$ye,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await P.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let o=n.path;try{o=await P.Promises.realpath(n.path),n.path===o&&(o=await(0,h.$lr)(n.path,this.m.token)??n.path),n.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async G(n,o){const t=new O.$Wc;return this.H(n,o,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,o,t)),t}H(n,o,t){if(o)return!1;const i=S.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(d,u)=>{if(!t.isDisposed)if(d){const b=await this.G(n,o);t.isDisposed?b.dispose():t.add(b)}else u&&(typeof u.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:i,type:u.type,cId:this.s.correlationId},!0)});return s?(t.add(s),!0):!1}async I(n,o,t){if(c.$d&&(0,A.$Fg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const i=new k.$ye(this.m.token);t.add((0,O.$Vc)(()=>i.dispose(!0)));const s=new O.$Wc;t.add(s);try{const d=S.URI.file(this.s.path),u=(0,p.$qc)(n),b=(0,r.watch)(n);s.add((0,O.$Vc)(()=>{b.removeAllListeners(),b.close()})),this.Q(`Started watching: '${n}'`);const E=new Set;if(o)try{for(const y of await P.Promises.readdir(n))E.add(y)}catch(y){this.O(y)}if(i.token.isCancellationRequested)return;const D=new Map;s.add((0,O.$Vc)(()=>{for(const[,y]of D)y.dispose();D.clear()})),b.on("error",(y,T)=>{i.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${y}, ${T})`),this.D())}),b.on("change",(y,T)=>{if(i.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${T}`);let C="";if(T&&(C=T.toString(),c.$d&&(C=(0,R.$nm)(C))),!(!C||y!=="change"&&y!=="rename"))if(o)if(y==="rename"){D.get(C)?.dispose();const v=setTimeout(async()=>{if(D.delete(C),C===u&&!await P.Promises.exists(n)){this.J(d);return}if(i.token.isCancellationRequested)return;const f=await this.N((0,p.$mc)(n,C));if(i.token.isCancellationRequested)return;let N;f?E.has(C)?N=w.FileChangeType.UPDATED:(N=w.FileChangeType.ADDED,E.add(C)):(E.delete(C),N=w.FileChangeType.DELETED),this.L({resource:(0,I.$hh)(d,C),type:N,cId:this.s.correlationId})},m.a);D.set(C,(0,O.$Vc)(()=>clearTimeout(v)))}else{let v;E.has(C)?v=w.FileChangeType.UPDATED:(v=w.FileChangeType.ADDED,E.add(C)),this.L({resource:(0,I.$hh)(d,C),type:v,cId:this.s.correlationId})}else if(y==="rename"||C!==u){const v=setTimeout(async()=>{const f=await P.Promises.exists(n);i.token.isCancellationRequested||(f?(this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(n,!1))):this.J(d))},m.a);s.clear(),s.add((0,O.$Vc)(()=>clearTimeout(v)))}else this.L({resource:d,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){i.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${d.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:w.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===w.FileChangeType.ADDED?"[ADDED]":n.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!o&&this.g.some(t=>t(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(t=>t(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const o=(0,l.$9q)(n),t=[];for(const s of o){if((0,l.$_q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}t.push(s)}if(t.length===0)return;if(this.z)for(const s of t)this.R(` >> normalized ${s.type===w.FileChangeType.ADDED?"[ADDED]":s.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(c.$e)return P.Promises.exists(n);try{const o=(0,p.$qc)(n);return(await P.Promises.readdir((0,p.$pc)(n))).some(i=>i===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$or=m,m.a=100,m.b=75;async function g($,n,o,t,i=512){const s=await P.Promises.open($,"r"),d=Buffer.allocUnsafe(i),u=new k.$ye(t);let b,E=!1;const D={path:$,excludes:[],recursive:!1},y=new m(D,void 0,T=>{(async()=>{for(const{type:C}of T)if(C===w.FileChangeType.UPDATED){if(E)return;E=!0;try{for(;!u.token.isCancellationRequested;){const{bytesRead:v}=await P.Promises.read(s,d,0,i,null);if(!v||u.token.isCancellationRequested)break;n(d.slice(0,v))}}catch(v){b=new Error(v),u.dispose(!0)}finally{E=!1}}})()});return await y.ready,o(),new Promise((T,C)=>{u.token.onCancellationRequested(async()=>{y.dispose();try{await P.Promises.close(s)}catch(v){b=new Error(v)}b?C(b):T()})})}}),define(Se[272],De([1,0,4,39,270,11,271,32]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class p extends k.$jr{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const S=[],h=new Set(Array.from(this.watchers));for(const P of I){const w=this.W(P);w&&(0,a.$Ek)(w.request.excludes,P.excludes)&&(0,a.$Ek)(w.request.includes,P.includes)?h.delete(w):S.push(P)}S.length&&this.P(`Request to start watching: ${S.map(P=>this.M(P)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map(P=>this.M(P.request)).join(",")}`);for(const P of h)this.Y(P);for(const P of S)this.X(P)}W(I){for(const S of this.watchers)if(typeof I.correlationId=="number"||typeof S.request.correlationId=="number"){if(S.request.correlationId===I.correlationId)return S}else if((0,R.$Eg)(S.request.path,I.path,!A.$e))return S}X(I){const S=new O.$or(I,this.O,P=>this.a.fire(P),()=>this.c.fire(I),P=>this.b.fire(P),this.R),h={request:I,instance:S};this.watchers.add(h)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const S=new Map;for(const h of I){const P=A.$e?h.path:h.path.toLowerCase();let w=S.get(h.correlationId);w||(w=new Map,S.set(h.correlationId,w)),w.has(P)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(h)}`),w.set(P,h)}return Array.from(S.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const S of this.watchers)S.instance.setVerboseLogging(I)}P(I,S){this.R&&this.b.fire({type:"trace",message:this.bb(I,S)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,S){return S?`[File Watcher (node.js)] ${I} (${this.M(S.request)})`:`[File Watcher (node.js)] ${I}`}}e.$qr=p}),define(Se[273],De([1,0,70,272]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class k extends r.$6q{constructor(O,R,p){super(O,R,p),this.s()}r(O){return O.add(new a.$qr(void 0))}}e.$rr=k}),define(Se[274],De([1,0,15,87,192,70]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class O extends A.$7q{constructor(p,c,I){super(p,c,I),this.s()}r(p){const c=p.add(new k.$hr(r.$1g.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(c.onDidProcessExit(({code:I,signal:S})=>this.t(`terminated by itself with code ${I}, signal: ${S} (ETERM)`))),a.ProxyChannel.toService((0,a.$ni)(c.getChannel("watcher")))}}e.$ir=O}),define(Se[115],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class r{constructor(...k){this.a=new Map;for(const[A,O]of k)this.set(A,O)}set(k,A){const O=this.a.get(k);return this.a.set(k,A),O}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$Ei=r}),define(Se[275],De([1,0,7,14,3,113,264,5,115,81]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;const I=!1;class S extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class h{constructor(m=new p.$Ei,g=!1,$,n=I){this.i=m,this.j=g,this.k=$,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$Fi,this),this._globalGraph=n?$?._globalGraph??new O.$ur(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Sc)(this.h),this.h.clear();for(const m of this.g)(0,k.$Rc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m,g){this.m();const $=this,n=new class extends h{dispose(){$.h.delete(n),super.dispose()}}(m,this.j,this,this.l);return this.h.add(n),g?.add(n),n}invokeFunction(m,...g){this.m();const $=w.traceInvocation(this.l,m);let n=!1;try{return m({get:t=>{if(n)throw(0,a.$$)("service accessor is only valid during the invocation of its target method");const i=this.s(t,$);if(!i)throw new Error(`[invokeFunction] unknown service '${t}'`);return i}},...g)}finally{n=!0,$.stop()}}createInstance(m,...g){this.m();let $,n;return m instanceof A.$Di?($=w.traceCreation(this.l,m.ctor),n=this.o(m.ctor,m.staticArguments.concat(g),$)):($=w.traceCreation(this.l,m),n=this.o(m,g,$)),$.stop(),n}o(m,g=[],$){const n=R._util.getServiceDependencies(m).sort((i,s)=>i.index-s.index),o=[];for(const i of n){const s=this.s(i.id,$);s||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),o.push(s)}const t=n.length>0?n[0].index:g.length;if(g.length!==t){console.trace(`[createInstance] First service dependency of ${m.name} at position ${t+1} conflicts with ${g.length} static arguments`);const i=t-g.length;i>0?g=g.concat(new Array(i)):g=g.slice(0,t)}return Reflect.construct(m,g.concat(o))}q(m,g){if(this.i.get(m)instanceof A.$Di)this.i.set(m,g);else if(this.k)this.k.q(m,g);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const g=this.i.get(m);return!g&&this.k?this.k.r(m):g}s(m,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const $=this.r(m);return $ instanceof A.$Di?this.u(m,$,g.branch(m,!0)):(g.branch(m,!1),$)}u(m,g,$){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,g,$)}finally{this.t.delete(m)}}v(m,g,$){const n=new O.$ur(i=>i.id.toString());let o=0;const t=[{id:m,desc:g,_trace:$}];for(;t.length;){const i=t.pop();if(n.lookupOrInsertNode(i),o++>1e3)throw new S(n);for(const s of R._util.getServiceDependencies(i.desc.ctor)){const d=this.r(s.id);if(d||this.y(`[createInstance] ${m} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),d instanceof A.$Di){const u={id:s.id,desc:d,_trace:i._trace.branch(s.id,!0)};n.insertEdge(i,u),t.push(u)}}}for(;;){const i=n.roots();if(i.length===0){if(!n.isEmpty())throw new S(n);break}for(const{data:s}of i){if(this.r(s.id)instanceof A.$Di){const u=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,u)}n.removeNode(s)}}return this.r(m)}w(m,g,$=[],n,o){if(this.i.get(m)instanceof A.$Di)return this.x(m,g,$,n,o,this.g);if(this.k)return this.k.w(m,g,$,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}x(m,g,$=[],n,o,t){if(n){const i=new h(void 0,this.j,this,this.l);i.c=String(m);const s=new Map,d=new r.$Zh(()=>{const u=i.o(g,$,o);for(const[b,E]of s){const D=u[b];if(typeof D=="function")for(const y of E)y.disposable=D.apply(u,y.listener)}return s.clear(),t.add(u),u});return new Proxy(Object.create(null),{get(u,b){if(!d.isInitialized&&typeof b=="string"&&(b.startsWith("onDid")||b.startsWith("onWill"))){let y=s.get(b);return y||(y=new c.$8c,s.set(b,y)),(C,v,f)=>{if(d.isInitialized)return d.value[b](C,v,f);{const N={listener:[C,v,f],disposable:void 0},F=y.push(N);return(0,k.$Vc)(()=>{F(),N.disposable?.dispose()})}}}if(b in u)return u[b];const E=d.value;let D=E[b];return typeof D!="function"||(D=D.bind(E),u[b]=D),D},set(u,b,E){return d.value[b]=E,!0},getPrototypeOf(u){return g.prototype}})}else{const i=this.o(g,$,o);return t.add(i),i}}y(m,g){if(g&&console.warn(m),this.j)throw new Error(m)}}e.$vr=h;var P;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(P||(P={}));class w{static traceInvocation(m,g){return m?new w(P.Invocation,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(m,g){return m?new w(P.Creation,g.name):w.c}constructor(m,g){this.type=m,this.name=g,this.g=Date.now(),this.h=[]}branch(m,g){const $=new w(P.Branch,m.toString());return this.h.push([m,g,$]),$}stop(){const m=Date.now()-this.g;w.f+=m;let g=!1;function $(o,t){const i=[],s=new Array(o+1).join("	");for(const[d,u,b]of t.h)if(u&&b){g=!0,i.push(`${s}CREATES -> ${d}`);const E=$(o+1,b);E&&i.push(E)}else i.push(`${s}uses -> ${d}`);return i.join(`
`)}const n=[`${this.type===P.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(m>2||g)&&w.all.add(n.join(`
`))}}e.$wr=w,w.all=new Set,w.c=new class extends w{constructor(){super(P.None,null)}stop(){}branch(){return this}},w.f=0}),define(Se[12],De([1,0,228,51,4,60,3,29,11,23,18,2,36,5]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=l,e.log=g,e.$ok=D,e.$pk=y,e.$qk=T,e.$rk=C,r=Ue(r),e.$ak=(0,P.$Gi)("logService"),e.$bk=(0,P.$Gi)("loggerService");function w(){return new Date().toISOString()}function l(v){return(0,I.$kg)(v)}var m;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$dk=m.Info;function g(v,f,N){switch(f){case m.Trace:v.trace(N);break;case m.Debug:v.debug(N);break;case m.Info:v.info(N);break;case m.Warning:v.warn(N);break;case m.Error:v.error(N);break;case m.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function $(v,f=!1){let N="";for(let F=0;F<v.length;F++){let j=v[F];if(j instanceof Error&&(j=(0,a.$rj)(j,f)),typeof j=="object")try{j=JSON.stringify(j)}catch{}N+=(F>0?" ":"")+j}return N}class n extends O.$Xc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new k.$ne),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==m.Off&&this.b<=f}}e.$fk=n;class o extends n{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...N){this.f(m.Trace)&&this.g(m.Trace,$([f,...N],!0))}debug(f,...N){this.f(m.Debug)&&this.g(m.Debug,$([f,...N]))}info(f,...N){this.f(m.Info)&&this.g(m.Info,$([f,...N]))}warn(f,...N){this.f(m.Warning)&&this.g(m.Warning,$([f,...N]))}error(f,...N){if(this.f(m.Error))if(f instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=f.stack,this.g(m.Error,$(F))}else this.g(m.Error,$([f,...N]))}flush(){}}e.$gk=o;class t extends n{constructor(f=e.$dk){super(),this.setLevel(f),this.g=!p.$c}trace(f,...N){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,f,...N):console.log(`[main ${w()}]`,f,...N))}debug(f,...N){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,f,...N):console.log(`[main ${w()}]`,f,...N))}info(f,...N){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,f,...N):console.log(`[main ${w()}]`,f,...N))}warn(f,...N){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,f,...N):console.warn(`[main ${w()}]`,f,...N))}error(f,...N){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,f,...N):console.error(`[main ${w()}]`,f,...N))}flush(){}}e.$hk=t;class i extends n{constructor(f=e.$dk,N=!0){super(),this.g=N,this.setLevel(f)}trace(f,...N){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...N):console.log(f,...N))}debug(f,...N){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...N):console.log(f,...N))}info(f,...N){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...N):console.log(f,...N))}warn(f,...N){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...N):console.log(f,...N))}error(f,...N){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...N):console.error(f,...N))}flush(){}}e.$ik=i;class s extends n{constructor(f,N=e.$dk){super(),this.g=f,this.setLevel(N)}trace(f,...N){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(f),...N])}debug(f,...N){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(f),...N])}info(f,...N){this.f(m.Info)&&this.g.log(m.Info,[this.h(f),...N])}warn(f,...N){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(f),...N])}error(f,...N){this.f(m.Error)&&this.g.log(m.Error,[this.h(f),...N])}h(f){return typeof f=="string"?f:(0,a.$rj)(f,this.f(m.Trace))}flush(){}}e.$jk=s;class d extends n{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const N of this.g)N.setLevel(f);super.setLevel(f)}trace(f,...N){for(const F of this.g)F.trace(f,...N)}debug(f,...N){for(const F of this.g)F.debug(f,...N)}info(f,...N){for(const F of this.g)F.info(f,...N)}warn(f,...N){for(const F of this.g)F.warn(f,...N)}error(f,...N){for(const F of this.g)F.error(f,...N)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose();super.dispose()}}e.$kk=d;class u extends O.$Xc{constructor(f,N,F){if(super(),this.h=f,this.j=N,this.b=new R.$Dc,this.c=this.B(new k.$ne),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$ne),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$ne),this.onDidChangeVisibility=this.g.event,F)for(const j of F)this.b.set(j.resource,{logger:void 0,info:j})}m(f){return(0,I.$gg)(f)?[...this.b.values()].find(N=>N.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,N){const F=this.n(f),j=(0,I.$gg)(f)?f:N?.id??(0,A.$uj)(F.toString()).toString(16);let z=this.b.get(F)?.logger;const M=N?.logLevel==="always"?m.Trace:N?.logLevel;z||(z=this.s(F,M??this.getLogLevel(F)??this.h,{...N,id:j}));const L={logger:z,info:{resource:F,id:j,logLevel:M,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(L.info),this.b.set(F,L),z}n(f){return(0,I.$gg)(f)?(0,c.$hh)(this.j,`${f}.log`):f}setLogLevel(f,N){if(S.URI.isUri(f)){const F=f,j=N,z=this.b.get(F);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([F,j]))}else{this.h=f;for(const[F,j]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,N){const F=this.m(f);F&&N!==!F.info.hidden&&(F.info.hidden=!N,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,N]))}getLogLevel(f){let N;return f&&(N=this.b.get(f)?.info.logLevel),N??this.h}registerLogger(f){const N=this.b.get(f.resource);N?N.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const N=this.b.get(f);N&&(N.logger&&N.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=u;class b{constructor(){this.onDidChangeLogLevel=new k.$ne().event}setLevel(f){}getLevel(){return m.Info}trace(f,...N){}debug(f,...N){}info(f,...N){}warn(f,...N){}error(f,...N){}critical(f,...N){}dispose(){}flush(){}}e.$mk=b;class E extends b{}e.$nk=E;function D(v){if(v.verbose)return m.Trace;if(typeof v.logLevel=="string"){const f=C(v.logLevel.toLowerCase());if(f!==void 0)return f}return e.$dk}function y(v){switch(v){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function T(v){switch(v){case m.Trace:return{original:"Trace",value:r.localize(0,null)};case m.Debug:return{original:"Debug",value:r.localize(1,null)};case m.Info:return{original:"Info",value:r.localize(2,null)};case m.Warning:return{original:"Warning",value:r.localize(3,null)};case m.Error:return{original:"Error",value:r.localize(4,null)};case m.Off:return{original:"Off",value:r.localize(5,null)}}}function C(v){switch(v){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$sk=new h.$Xj("logLevel",y(m.Info))}),define(Se[276],De([1,0,19,7,14,4,32,3,17,70,12]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class S extends R.$Xc{constructor(P,w){super(),this.a=P,this.b=w,this.c=this.B(new A.$ne),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$ne),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$Eh(0)),this.w=[],this.y=this.B(new a.$Eh(0))}watch(P,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(P,w):this.z(P,w)}n(P,w){const l={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Wb)(this.j,l);return this.r(),(0,R.$Vc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(P=>(0,k.$3)(P))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,c.$8q)(w)),w=>this.G(w),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const P=this.b?.watcher?.recursive?.usePolling;if(P===!0)for(const w of this.j)(0,c.$4q)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(P))for(const w of this.j)(0,c.$4q)(w)&&P.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(P,w){const l={path:this.J(P),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},m=(0,r.$Wb)(this.w,l);return this.C(),(0,R.$Vc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(P=>(0,k.$3)(P))}D(){return this.u||(this.u=this.B(this.F(P=>this.c.fire((0,c.$8q)(P)),P=>this.G(P),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(P){P.type==="error"&&this.g.fire(P.message),this.H(P)}H(P){this.a[P.type](P.message)}I(P){return(0,p.$kc)(P.fsPath)}J(P){const w=this.I(P);return(0,O.$Ig)(w)}}e.$br=S}),define(Se[277],De([1,0,7,29,22,4,32,3,17,11,23,106,34,227,28,269,276,274,273]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class n extends m.$br{constructor(t,i){super(t,i),this.onDidChangeCapabilities=A.Event.None,this.P=new a.$Dc(s=>I.$$g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=w.FileSystemProviderCapabilities.FileReadWrite|w.FileSystemProviderCapabilities.FileOpenReadWriteClose|w.FileSystemProviderCapabilities.FileReadStream|w.FileSystemProviderCapabilities.FileFolderCopy|w.FileSystemProviderCapabilities.FileWriteUnlock|w.FileSystemProviderCapabilities.FileAtomicRead|w.FileSystemProviderCapabilities.FileAtomicWrite|w.FileSystemProviderCapabilities.FileAtomicDelete|w.FileSystemProviderCapabilities.FileClone,c.$e&&(this.M|=w.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(t){try{const{stat:i,symbolicLink:s}=await h.SymlinkSupport.stat(this.I(t));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await h.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async d=>{try{let u;d.isSymbolicLink()?u=(await this.stat((0,I.$hh)(t,d.name))).type:u=this.O(d),s.push([d.name,u])}catch(u){this.a.trace(u)}})),s}catch(i){throw this.hb(i)}}O(t,i){let s;return i?.dangling?s=w.FileType.Unknown:t.isFile()?s=w.FileType.File:t.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,i&&(s|=w.FileType.SymbolicLink),s}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const d=new r.$Fh;return this.P.set(t,d),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,R.$Vc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===d&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),d.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.Q(t));const d=this.I(t);return await h.Promises.readFile(d)}catch(d){throw this.hb(d)}finally{s?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,s){const d=(0,S.$De)(u=>k.$Pe.concat(u.map(b=>k.$Pe.wrap(b))).buffer);return(0,l.$1q)(this,t,d,u=>u.buffer,{...i,bufferSize:256*1024},s),d}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(t)?this.U(t,(0,I.$hh)((0,I.$gh)(t),`${(0,I.$eh)(t)}${s.atomic.postfix}`),i,s):this.W(t,i,s)}async S(t){try{const i=this.I(t),{symbolicLink:s}=await h.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(t,i,s,d){const u=new R.$Wc;try{u.add(await this.Q(t)),u.add(await this.Q(i)),await this.W(i,s,d,!0);try{await this.rename(i,t,{overwrite:!0})}catch(b){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw b}}finally{u.dispose()}}async W(t,i,s,d){let u;try{const b=this.I(t);if(!s.create||!s.overwrite){if(await h.Promises.exists(b)){if(!s.overwrite)throw(0,w.$nl)((0,P.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.$nl)((0,P.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:s.unlock},d),await this.write(u,0,i,0,i.byteLength)}catch(b){throw await this.ib(t,b)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(t){n.$=t}async open(t,i,s){const d=this.I(t);let u;(0,w.$bl)(i)&&!s&&(u=await this.Q(t));let b;try{if((0,w.$bl)(i)&&i.unlock)try{const{stat:D}=await h.SymlinkSupport.stat(d);D.mode&128||await h.Promises.chmod(d,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let E;if((0,w.$bl)(i)){if(c.$c)try{await h.Promises.truncate(d,0),E="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}E||(E="w")}else E="r";b=await h.Promises.open(d,E)}catch(E){throw u?.dispose(),(0,w.$bl)(i)?await this.ib(t,E):this.hb(E)}if(this.X.set(b,0),(0,w.$bl)(i)&&this.Z.set(b,t),u){const E=this.Y.get(b);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${b} (${d})`),this.Y.set(b,u),E&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${b} (${d})`),E.dispose())}return b}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await h.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await h.Promises.close(t)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,d,u){const b=this.ab(t,i);let E=null;try{E=(await h.Promises.read(t,s,d,u,b)).bytesRead}catch(D){throw this.hb(D)}finally{this.bb(t,b,E)}return E}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,s){const d=this.X.get(t);typeof d=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(t,d+s):this.X.delete(t)))}async write(t,i,s,d,u){return(0,r.$1h)(()=>this.cb(t,i,s,d,u),100,3)}async cb(t,i,s,d,u){const b=this.ab(t,i);let E=null;try{E=(await h.Promises.write(t,s,d,u,b)).bytesWritten}catch(D){throw await this.ib(this.Z.get(t),D)}finally{this.bb(t,b,E)}return E}async mkdir(t){try{await h.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const s=this.I(t);if(i.recursive){let d;i?.atomic!==!1&&i.atomic.postfix&&(d=(0,p.$mc)((0,p.$pc)(s),`${(0,p.$qc)(s)}${i.atomic.postfix}`)),await h.Promises.rm(s,h.RimRafMode.MOVE,d)}else try{await h.Promises.unlink(s)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let u=!1;try{const{stat:b,symbolicLink:E}=await h.SymlinkSupport.stat(s);u=b.isDirectory()&&!E}catch{}if(u)await h.Promises.rmdir(s);else throw d}else throw d}}catch(s){throw this.hb(s)}}async rename(t,i,s){const d=this.I(t),u=this.I(i);if(d!==u)try{await this.db(t,i,"move",s.overwrite),await h.Promises.rename(d,u)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,P.localize)(2,null,(0,p.$qc)(d),(0,p.$qc)((0,p.$pc)(u)),b.toString()))),this.hb(b)}}async copy(t,i,s){const d=this.I(t),u=this.I(i);if(d!==u)try{await this.db(t,i,"copy",s.overwrite),await h.Promises.copy(d,u,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,P.localize)(3,null,(0,p.$qc)(d),(0,p.$qc)((0,p.$pc)(u)),b.toString()))),this.hb(b)}}async db(t,i,s,d){const u=this.I(t),b=this.I(i);let E=!1;if(!!(this.capabilities&w.FileSystemProviderCapabilities.PathCaseSensitive)||(E=(0,O.$Eg)(u,b,!0)),E){if(s==="copy")throw(0,w.$nl)((0,P.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const y=await this.N(t);if(!y)throw(0,w.$nl)((0,P.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(i);if(T){if(!d)throw(0,w.$nl)((0,P.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);y.type&w.FileType.File&&T.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,s){const d=this.I(t),u=this.I(i),b=!!(this.capabilities&w.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Eg)(d,u,!b))return;const E=new R.$Wc;try{E.add(await this.Q(t)),E.add(await this.Q(i)),s&&await h.Promises.mkdir((0,p.$pc)(u),{recursive:!0}),await h.Promises.copyFile(d,u)}catch(D){if(D.code==="ENOENT"&&!s)return this.eb(t,i,!0);throw this.hb(D)}finally{E.dispose()}}t(t,i,s){return new g.$ir(d=>t(d),d=>i(d),s)}F(t,i,s){return new $.$rr(d=>t(d),d=>i(d),s)}hb(t){if(t instanceof w.$ml)return t;let i=t,s;switch(t.code){case"ENOENT":s=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=w.FileSystemProviderErrorCode.Unknown;break;default:s=w.FileSystemProviderErrorCode.Unknown}return(0,w.$nl)(i,s)}async ib(t,i){let s=this.hb(i);if(t&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await h.SymlinkSupport.stat(this.I(t));d.mode&128||(s=(0,w.$nl)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return s}}e.$sr=n,n.L=!1,n.$=!0}),define(Se[278],De([1,0,3,12]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qR=void 0;class k extends r.$Xc{constructor(O,R=[]){super(),this.a=new a.$kk([O,...R]),this.B(O.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$qR=k}),define(Se[279],De([1,0,28,12]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fR=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function A(c,I,S,h,P){try{const w=await new Promise((m,g)=>{ie(["@vscode/spdlog"],m,g)}).then(Ue);w.setFlushOn(k.Trace);const l=await w.createAsyncRotatingLogger(c,I,S,h);return P?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(w){console.error(w)}return null}function O(c,I,S){switch(I){case a.LogLevel.Trace:c.trace(S);break;case a.LogLevel.Debug:c.debug(S);break;case a.LogLevel.Info:c.info(S);break;case a.LogLevel.Warning:c.warn(S);break;case a.LogLevel.Error:c.error(S);break;case a.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function R(c,I){switch(I){case a.LogLevel.Trace:c.setLevel(k.Trace);break;case a.LogLevel.Debug:c.setLevel(k.Debug);break;case a.LogLevel.Info:c.setLevel(k.Info);break;case a.LogLevel.Warning:c.setLevel(k.Warning);break;case a.LogLevel.Error:c.setLevel(k.Error);break;case a.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class p extends a.$gk{constructor(I,S,h,P,w){super(),this.m=[],this.setLevel(w),this.n=this.s(I,S,h,P),this.B(this.onDidChangeLogLevel(l=>{this.r&&R(this.r,l)}))}async s(I,S,h,P){const w=h?6:1,l=30/w*r.$Il.MB,m=await A(I,S,l,w,P);if(m){this.r=m,R(this.r,this.getLevel());for(const{level:g,message:$}of this.m)O(this.r,g,$);this.m=[]}}g(I,S){this.r?O(this.r,I,S):this.getLevel()<=I&&this.m.push({level:I,message:S})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$fR=p});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[147],De([1,0,45,229,5]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=qt(r);var A;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var O;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(O||(e.MarkerSeverity=O={})),function(p){function c(w,l){return l-w}p.compare=c;const I=Object.create(null);I[p.Error]=(0,a.localize)(0,null),I[p.Warning]=(0,a.localize)(1,null),I[p.Info]=(0,a.localize)(2,null);function S(w){return I[w]||""}p.toString=S;function h(w){switch(w){case r.default.Error:return p.Error;case r.default.Warning:return p.Warning;case r.default.Info:return p.Info;case r.default.Ignore:return p.Hint}}p.fromSeverity=h;function P(w){switch(w){case p.Error:return r.default.Error;case p.Warning:return r.default.Warning;case p.Info:return r.default.Info;case p.Hint:return r.default.Ignore}}p.toSeverity=P}(O||(e.MarkerSeverity=O={}));var R;(function(p){const c="";function I(h){return S(h,!0)}p.makeKey=I;function S(h,P){const w=[c];return h.source?w.push(h.source.replace("\xA6","\\\xA6")):w.push(c),h.code?typeof h.code=="string"?w.push(h.code.replace("\xA6","\\\xA6")):w.push(h.code.value.replace("\xA6","\\\xA6")):w.push(c),h.severity!==void 0&&h.severity!==null?w.push(O.toString(h.severity)):w.push(c),h.message&&P?w.push(h.message.replace("\xA6","\\\xA6")):w.push(c),h.startLineNumber!==void 0&&h.startLineNumber!==null?w.push(h.startLineNumber.toString()):w.push(c),h.startColumn!==void 0&&h.startColumn!==null?w.push(h.startColumn.toString()):w.push(c),h.endLineNumber!==void 0&&h.endLineNumber!==null?w.push(h.endLineNumber.toString()):w.push(c),h.endColumn!==void 0&&h.endColumn!==null?w.push(h.endColumn.toString()):w.push(c),w.push(c),w.join("\xA6")}p.makeKeyOptionalMessage=S})(R||(e.IMarkerData=R={})),e.$Eu=(0,k.$Gi)("markerService")});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[280],De([1,0,4,45,5]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uw=e.$tw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$rw=e.Severity=void 0,e.$sw=R,a=qt(a),e.Severity=a.default,e.$rw=(0,k.$Gi)("notificationService");var A;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var O;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(O||(e.NeverShowAgainScope=O={}));function R(S){if(S){const h=S;return typeof h.id=="string"&&typeof h.label=="string"}return!1}var p;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class c{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(h){}updateMessage(h){}updateActions(h){}close(){}}e.$tw=c;class I{infinite(){}done(){}total(h){}worked(h){}}e.$uw=I}),define(Se[281],De([1,0,54]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const A=k.context.configuration();if(A)a=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:A.version})}Object.assign(a,{extensionsGallery:r.env.EXTENSIONS_GALLERY?JSON.parse(r.env.EXTENSIONS_GALLERY):a.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""},telemetryEndpoint:r.env.CS_TELEMETRY_URL||a.telemetryEndpoint||"https://v1.telemetry.coder.com/track"})}else a={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.91.0",sha256:"53b99146c7fa280f00c74414e09721530c622bf3e5eac2c967ddfb9906b51c80",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.91.0",commit:"090e0fad76152d6a0c10903a3bbf8a83d09e93d0",date:"2024-07-08T22:14:43.429Z"},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(Se[116],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,r.$Gi)("productService"),e.$uk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(ie,e){return function(r,a){e(r,a,ie)}};define(Se[90],De([1,0,7,21,3,5]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.ProgressLocation=e.$vw=void 0,e.$vw=(0,A.$Gi)("progressService");var O;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(O||(e.ProgressLocation=O={})),e.$ww=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(h){this.b=h}report(h){this.a=h,this.b(this.a)}}e.$xw=R,R.None=Object.freeze({report(){}});class p{get value(){return this.a}constructor(h){this.e=h}report(h){this.b?this.b.push(h):this.b=[h],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const h=this.b.shift();this.a=h,await this.e(this.a)}}finally{this.c=!1;const h=this.d;this.d=void 0,h?.()}}drain(){return this.c?new Promise(h=>{const P=this.d;this.d=()=>{P?.(),h()}}):Promise.resolve()}}e.$yw=p;let c=class extends k.$Xc{constructor(h,P){super(),this.a=new r.$4h,P.withProgress(h,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,k.$Vc)(()=>this.a.complete()))}report(h){this.b?this.b.report(h):this.c=h}};e.$zw=c,e.$zw=c=Ye([Ve(1,e.$vw)],c);class I extends k.$Xc{constructor(h){super(),this.g=h,this.a=0,this.b=this.B(new k.$Wc)}start(h){this.stop();const P=++this.a,w=new a.$ye;return this.f=setTimeout(()=>{P===this.a&&(this.c=this.g.show(!0))},h),this.b.add((0,k.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,k.$Vc)(()=>w.cancel())),this.b.add((0,k.$Vc)(()=>this.c?this.c.done():void 0)),{id:P,token:w.token,stop:()=>this.h(P),isCurrent:()=>this.a===P}}stop(){this.h(this.a)}h(h){this.a===h&&this.b.clear()}}e.$Aw=I,e.$Bw=(0,A.$Gi)("editorProgressService")}),define(Se[37],De([1,0,66,18]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,r=Ue(r),a=Ue(a);class k{constructor(){this.a=new Map}add(O,R){r.ok(a.$gg(O)),r.ok(a.$ig(R)),r.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$so=new k}),define(Se[117],De([1,0,4,37]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,a=Ue(a),e.$to={JSONContribution:"base.contributions.json"};function k(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new r.$ne,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,c){this.a[k(p)]=c,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;a.$so.add(e.$to.JSONContribution,O)}),define(Se[71],De([1,0,19,4,18,218,46,117,37]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ConfigurationScope=e.$xo=e.EditPresentationTypes=void 0,e.$Io=l,e.$Jo=m,e.$Ko=g,e.$Lo=n,e.$Mo=o,k=Ue(k),A=Ue(A);var c;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$xo={Configuration:"base.contributions.configuration"};var I;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo="vscode://schemas/settings/resourceLanguage",e.$Fo="vscode://schemas/settings/configurationDefaults";const S=p.$so.as(R.$to.JSONContribution);class h{constructor(){this.h=new Set,this.i=new a.$ne,this.onDidSchemaChange=this.i.event,this.j=new a.$ne,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$Eo,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const d=new Set;this.n(i,s,d),S.registerSchema(e.$Eo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(i){const s=new Set;this.o(i,s),S.registerSchema(e.$Eo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const d=new Set;this.o(s,d),this.n(i,!1,d),S.registerSchema(e.$Eo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const d=[];for(const{overrides:u,source:b}of i)for(const E in u)if(s.add(E),e.$Ho.test(E)){const D=this.a.get(E),y=D?.valuesSources??new Map,T=D?.value||{};for(const f of Object.keys(u[E])){const N=u[E][f];if(k.$ig(N)&&(k.$ng(T[f])||k.$ig(T[f]))){if(T[f]={...T[f]??{},...N},b){let j=y.get(f);if(j||(j=new Map,y.set(f,j)),!(j instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const z in N)j.set(z,b)}}else T[f]=N,b&&y.set(f,b)}this.a.set(E,{source:b,value:T,valuesSources:y});const C=(0,O.$kj)(E),v={type:"object",default:T,description:A.localize(1,null,C),$ref:e.$Eo,defaultDefaultValue:T,source:k.$gg(b)?void 0:b,defaultValueSource:b};d.push(...l(E)),this.d[E]=v,this.b.properties[E]=v}else{const D=this.d[E],y=this.a.get(E);let T=y?.value??D?.defaultDefaultValue,C=u[E],v=b;if(k.$ig(C)&&(D!==void 0&&D.type==="object"||D===void 0&&(k.$ng(T)||k.$ig(T)))){if(k.$ig(T)||(T={}),C={...T,...C},v=y?.source??new Map,!(v instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const N in u[E])b?v.set(N,b):v.delete(N)}this.a.set(E,{value:C,source:v}),D&&(this.w(E,D),this.r(E,D))}this.m(d)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:d,source:u}of i)for(const b in d){const E=k.$gg(u)?u:u?.id,D=this.a.get(b);if(D){if(e.$Ho.test(b)){for(const T of Object.keys(d[b])){const C=d[b][T];if(k.$ig(C)){const v=D.valuesSources?.get(T);for(const f of Object.keys(C)){const N=v?.get(f);(k.$gg(N)?N:N?.id)===E&&(v?.delete(f),delete D.value[T][f])}Object.keys(D.value[T]).length===0&&(delete D.value[T],D.valuesSources?.delete(T))}else{const v=D.valuesSources?.get(T);(k.$gg(v)?v:v?.id)===E&&(D.valuesSources?.delete(T),delete D.value[T])}}const y=this.a.get(b);y&&Object.keys(y.value).length===0&&(this.a.delete(b),delete this.d[b],delete this.b.properties[b])}else{if(D.source instanceof Map){const T=D.source;for(const C in d[b]){const v=T.get(C);(k.$gg(v)?v:v?.id)===E&&(T.delete(C),delete D.value[C])}T.size===0&&this.a.delete(b)}else{const T=k.$gg(D.source)?D.source:D.source?.id;if(E!==T)continue;this.a.delete(b)}const y=this.d[b];y&&(this.w(b,y),this.r(b,y))}s.add(b)}}this.u()}deltaConfiguration(i){let s=!1;const d=new Set;i.removedDefaults&&(this.l(i.removedDefaults,d),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,d),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,d),i.addedConfigurations&&this.n(i.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,d){i.forEach(u=>{this.p(u,s,u.extensionInfo,u.restrictedProperties,void 0,d),this.c.push(u),this.q(u)})}o(i,s){const d=u=>{if(u.properties)for(const b in u.properties){s.add(b);const E=this.d[b];E?.policy?.name&&this.e.delete(E.policy.name),delete this.d[b],this.s(b,u.properties[b])}u.allOf?.forEach(b=>d(b))};for(const u of i){d(u);const b=this.c.indexOf(u);b!==-1&&this.c.splice(b,1)}}p(i,s=!0,d,u,b=I.WINDOW,E){b=k.$pg(i.scope)?b:i.scope;const D=i.properties;if(D)for(const T in D){const C=D[T];if(s&&n(T,C)){delete D[T];continue}if(C.source=d,C.defaultDefaultValue=D[T].default,this.w(T,C),e.$Ho.test(T)?C.scope=void 0:(C.scope=k.$pg(C.scope)?b:C.scope,C.restricted=k.$pg(C.restricted)?!!u?.includes(T):C.restricted),D[T].hasOwnProperty("included")&&!D[T].included){this.f[T]=D[T],delete D[T];continue}else this.d[T]=D[T],D[T].policy?.name&&this.e.set(D[T].policy.name,T);!D[T].deprecationMessage&&D[T].markdownDeprecationMessage&&(D[T].deprecationMessage=D[T].markdownDeprecationMessage),E.add(T)}const y=i.allOf;if(y)for(const T of y)this.p(T,s,d,u,b,E)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=d=>{const u=d.properties;if(u)for(const E in u)this.r(E,u[E]);d.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$yo.properties[i]=s,s.scope){case I.APPLICATION:e.$zo.properties[i]=s;break;case I.MACHINE:e.$Ao.properties[i]=s;break;case I.MACHINE_OVERRIDABLE:e.$Bo.properties[i]=s;break;case I.WINDOW:e.$Co.properties[i]=s;break;case I.RESOURCE:e.$Do.properties[i]=s;break;case I.LANGUAGE_OVERRIDABLE:e.$Do.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$yo.properties[i],s.scope){case I.APPLICATION:delete e.$zo.properties[i];break;case I.MACHINE:delete e.$Ao.properties[i];break;case I.MACHINE_OVERRIDABLE:delete e.$Bo.properties[i];break;case I.WINDOW:delete e.$Co.properties[i];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Do.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,d={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$Eo};this.w(s,d),e.$yo.properties[s]=d,e.$zo.properties[s]=d,e.$Ao.properties[s]=d,e.$Bo.properties[s]=d,e.$Co.properties[s]=d,e.$Do.properties[s]=d}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$Eo};e.$yo.patternProperties[e.$Go]=i,e.$zo.patternProperties[e.$Go]=i,e.$Ao.patternProperties[e.$Go]=i,e.$Bo.patternProperties[e.$Go]=i,e.$Co.patternProperties[e.$Go]=i,e.$Do.patternProperties[e.$Go]=i,this.i.fire()}w(i,s){const d=this.a.get(i);let u=d?.value,b=d?.source;k.$ng(u)&&(u=s.defaultDefaultValue,b=void 0),k.$ng(u)&&(u=g(s.type)),s.default=u,s.defaultValueSource=b}}const P="\\[([^\\]]+)\\]",w=new RegExp(P,"g");e.$Go=`^(${P})+$`,e.$Ho=new RegExp(e.$Go);function l(t){const i=[];if(e.$Ho.test(t)){let s=w.exec(t);for(;s?.length;){const d=s[1].trim();d&&i.push(d),s=w.exec(t)}}return(0,r.$Pb)(i)}function m(t){return t.reduce((i,s)=>`${i}[${s}]`,"")}function g(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new h;p.$so.add(e.$xo.Configuration,$);function n(t,i){return t.trim()?e.$Ho.test(t)?A.localize(7,null,t):$.getConfigurationProperties()[t]!==void 0?A.localize(8,null,t):i.policy?.name&&$.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,t,i.policy?.name,$.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}function o(){const t=[],i=$.getConfigurationProperties();for(const s of Object.keys(i))t.push([s,i[s].scope]);return t.push(["launch",I.RESOURCE]),t.push(["task",I.RESOURCE]),t}}),define(Se[282],De([1,0,19,4,177,3,29,25,18,2,46,71,28,37]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$Ro=o,r=Ue(r),k=Ue(k),R=Ue(R),p=Ue(p);function w(d){return Object.isFrozen(d)?d:R.$go(d)}class l{static createEmptyModel(u){return new l({},[],[],void 0,u)}constructor(u,b,E,D,y){this.b=u,this.c=b,this.d=E,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const u=this.raw.map(b=>{if(b instanceof l)return b;const E=new m("",this.f);return E.parseRaw(b),E.configurationModel});this.g=u.reduce((b,E)=>E===b?E:b.merge(E),u[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,I.$ij)(this.contents,u):this.contents}inspect(u,b){const E=this;return{get value(){return w(E.rawConfiguration.getValue(u))},get override(){return b?w(E.rawConfiguration.getOverrideValue(u,b)):void 0},get merged(){return w(b?E.rawConfiguration.override(b).getValue(u):E.rawConfiguration.getValue(u))},get overrides(){const D=[];for(const{contents:y,identifiers:T,keys:C}of E.rawConfiguration.overrides){const v=new l(y,C,[],void 0,E.f).getValue(u);v!==void 0&&D.push({identifiers:T,value:v})}return D.length?w(D):void 0}}}getOverrideValue(u,b){const E=this.j(b);return E?u?(0,I.$ij)(E,u):E:void 0}getKeysForOverrideIdentifier(u){const b=[];for(const E of this.overrides)E.identifiers.includes(u)&&b.push(...E.keys);return r.$Pb(b)}getAllOverrideIdentifiers(){const u=[];for(const b of this.overrides)u.push(...b.identifiers);return r.$Pb(u)}override(u){let b=this.a.get(u);return b||(b=this.h(u),this.a.set(u,b)),b}merge(...u){const b=R.$fo(this.contents),E=R.$fo(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const T of u)if(y.push(...T.raw?.length?T.raw:[T]),!T.isEmpty()){this.i(b,T.contents);for(const C of T.overrides){const[v]=E.filter(f=>r.$xb(f.identifiers,C.identifiers));v?(this.i(v.contents,C.contents),v.keys.push(...C.keys),v.keys=r.$Pb(v.keys)):E.push(R.$fo(C))}for(const C of T.keys)D.indexOf(C)===-1&&D.push(C)}return new l(b,D,E,y.every(T=>T instanceof l)?void 0:y,this.f)}h(u){const b=this.j(u);if(!b||typeof b!="object"||!Object.keys(b).length)return this;const E={};for(const D of r.$Pb([...Object.keys(this.contents),...Object.keys(b)])){let y=this.contents[D];const T=b[D];T&&(typeof y=="object"&&typeof T=="object"?(y=R.$fo(y),this.i(y,T)):y=T),E[D]=y}return new l(E,this.keys,this.overrides,void 0,this.f)}i(u,b){for(const E of Object.keys(b)){if(E in u&&p.$ig(u[E])&&p.$ig(b[E])){this.i(u[E],b[E]);continue}u[E]=R.$fo(b[E])}}j(u){let b=null,E=null;const D=y=>{y&&(E?this.i(E,y):E=R.$fo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===u?b=y.contents:y.identifiers.includes(u)&&D(y.contents);return D(b),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,b){this.k(u,b,!0)}setValue(u,b){this.k(u,b,!1)}removeValue(u){const b=this.keys.indexOf(u);b!==-1&&(this.keys.splice(b,1),(0,I.$hj)(this.contents,u),S.$Ho.test(u)&&this.overrides.splice(this.overrides.findIndex(E=>r.$xb(E.identifiers,(0,S.$Io)(u))),1))}k(u,b,E){(0,I.$gj)(this.contents,u,b,D=>this.f.error(D)),E=E||this.keys.indexOf(u)===-1,E&&this.keys.push(u),S.$Ho.test(u)&&this.overrides.push({identifiers:(0,S.$Io)(u),keys:Object.keys(this.contents[u]),contents:(0,I.$fj)(this.contents[u],D=>this.f.error(D))})}}e.$No=l;class m{constructor(u,b){this.f=u,this.g=b,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||l.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,b){if(!p.$pg(u)){const E=this.h(u);this.parseRaw(E,b)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,b){this.a=u;const{contents:E,keys:D,overrides:y,restricted:T,hasExcludedProperties:C}=this.i(u,b);this.b=new l(E,D,y,C?[u]:void 0,this.g),this.c=T||[]}h(u){let b={},E=null,D=[];const y=[],T=[];function C(f){Array.isArray(D)?D.push(f):E!==null&&(D[E]=f)}const v={onObjectBegin:()=>{const f={};C(f),y.push(D),D=f,E=null},onObjectProperty:f=>{E=f},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const f=[];C(f),y.push(D),D=f,E=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:C,onError:(f,N,F)=>{T.push({error:f,offset:N,length:F})}};if(u)try{k.$7n(u,v),b=D[0]||{}}catch(f){this.g.error(`Error while parsing settings file ${this.f}: ${f}`),this.d=[f]}return b}i(u,b){const E=P.$so.as(S.$xo.Configuration).getConfigurationProperties(),D=this.j(u,E,!0,b);u=D.raw;const y=(0,I.$fj)(u,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`)),T=Object.keys(u),C=this.l(u,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:y,keys:T,overrides:C,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(u,b,E,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:y};const T={},C=[];for(const v in u)if(S.$Ho.test(v)&&E){const f=this.j(u[v],b,!1,D);T[v]=f.raw,y=y||f.hasExcludedProperties,C.push(...f.restricted)}else{const f=b[v],N=f?typeof f.scope<"u"?f.scope:S.ConfigurationScope.WINDOW:void 0;f?.restricted&&C.push(v),!D.exclude?.includes(v)&&(D.include?.includes(v)||(N===void 0||D.scopes===void 0||D.scopes.includes(N))&&!(D.skipRestricted&&f?.restricted))?T[v]=u[v]:y=!0}return{raw:T,restricted:C,hasExcludedProperties:y}}l(u,b){const E=[];for(const D of Object.keys(u))if(S.$Ho.test(D)){const y={};for(const T in u[D])y[T]=u[D][T];E.push({identifiers:(0,S.$Io)(D),keys:Object.keys(y),contents:(0,I.$fj)(y,b)})}return E}}e.$Oo=m;class g extends A.$Xc{constructor(u,b,E,D,y){super(),this.c=u,this.f=b,this.g=D,this.h=y,this.b=this.B(new a.$ne),this.onDidChange=this.b.event,this.a=new m(this.c.toString(),y),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,T=>T.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,T=>(T.isOperation(h.FileOperation.CREATE)||T.isOperation(h.FileOperation.COPY)||T.isOperation(h.FileOperation.DELETE)||T.isOperation(h.FileOperation.WRITE))&&E.isEqual(T.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return l.createEmptyModel(this.h)}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Po=g;class ${constructor(u,b,E,D,y,T,C,v,f,N,F,j,z){this.a=u,this.b=b,this.c=E,this.overrideIdentifiers=D,this.d=y,this.f=T,this.g=C,this.h=v,this.i=f,this.j=N,this.k=F,this.l=j,this.m=z}get value(){return w(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(u,b,E,D,y,T,C,v,f,N){this.j=u,this.l=b,this.m=E,this.n=D,this.p=y,this.q=T,this.r=C,this.s=v,this.t=f,this.u=N,this.h=null,this.i=new O.$Dc,this.v=null}getValue(u,b,E){return this.w(u,b,E).getValue(u)}updateValue(u,b,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=l.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,b===void 0?D.removeValue(u):D.setValue(u,b),E.resource||(this.h=null)}inspect(u,b,E){const D=this.w(u,b,E),y=this.A(b.resource,E),T=b.resource?this.t.get(b.resource)||this.s:this.s,C=new Set;for(const v of D.overrides)for(const f of v.identifiers)D.getOverrideValue(u,f)!==void 0&&C.add(f);return new $(u,b,D.getValue(u),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,y||void 0,T)}keys(u){const b=this.A(void 0,u);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:b?b.keys.slice(0):[]}}updateDefaultConfiguration(u){this.j=u,this.h=null,this.i.clear()}updatePolicyConfiguration(u){this.l=u}updateApplicationConfiguration(u){this.m=u,this.h=null,this.i.clear()}updateLocalUserConfiguration(u){this.n=u,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(u){this.p=u,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(u){this.q=u,this.h=null,this.i.clear()}updateFolderConfiguration(u,b){this.r.set(u,b),this.i.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.i.delete(u)}compareAndUpdateDefaultConfiguration(u,b){const E=[];if(!b){const{added:D,updated:y,removed:T}=i(this.j,u);b=[...D,...y,...T]}for(const D of b)for(const y of(0,S.$Io)(D)){const T=this.j.getKeysForOverrideIdentifier(y),C=u.getKeysForOverrideIdentifier(y),v=[...C.filter(f=>T.indexOf(f)===-1),...T.filter(f=>C.indexOf(f)===-1),...T.filter(f=>!R.$jo(this.j.override(y).getValue(f),u.override(y).getValue(f)))];E.push([y,v])}return this.updateDefaultConfiguration(u),{keys:b,overrides:E}}compareAndUpdatePolicyConfiguration(u){const{added:b,updated:E,removed:D}=i(this.l,u),y=[...b,...E,...D];return y.length&&this.updatePolicyConfiguration(u),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:b,updated:E,removed:D,overrides:y}=i(this.applicationConfiguration,u),T=[...b,...E,...D];return T.length&&this.updateApplicationConfiguration(u),{keys:T,overrides:y}}compareAndUpdateLocalUserConfiguration(u){const{added:b,updated:E,removed:D,overrides:y}=i(this.localUserConfiguration,u),T=[...b,...E,...D];return T.length&&this.updateLocalUserConfiguration(u),{keys:T,overrides:y}}compareAndUpdateRemoteUserConfiguration(u){const{added:b,updated:E,removed:D,overrides:y}=i(this.remoteUserConfiguration,u),T=[...b,...E,...D];return T.length&&this.updateRemoteUserConfiguration(u),{keys:T,overrides:y}}compareAndUpdateWorkspaceConfiguration(u){const{added:b,updated:E,removed:D,overrides:y}=i(this.workspaceConfiguration,u),T=[...b,...E,...D];return T.length&&this.updateWorkspaceConfiguration(u),{keys:T,overrides:y}}compareAndUpdateFolderConfiguration(u,b){const E=this.folderConfigurations.get(u),{added:D,updated:y,removed:T,overrides:C}=i(E,b),v=[...D,...y,...T];return(v.length||!E)&&this.updateFolderConfiguration(u,b),{keys:v,overrides:C}}compareAndDeleteFolderConfiguration(u){const b=this.folderConfigurations.get(u);if(!b)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:E,updated:D,removed:y,overrides:T}=i(b,void 0);return{keys:[...E,...D,...y],overrides:T}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(u,b,E){let D=this.x(b,E);return b.overrideIdentifier&&(D=D.override(b.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(u)!==void 0&&(D=D.merge(this.l)),D}x({resource:u},b){let E=this.y();if(b&&u){const D=b.getFolder(u);D&&(E=this.z(D.uri)||E);const y=this.t.get(u);y&&(E=E.merge(y))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(u){let b=this.i.get(u);if(!b){const E=this.y(),D=this.r.get(u);D?(b=E.merge(D),this.i.set(u,b)):b=E}return b}A(u,b){if(b&&u){const E=b.getFolder(u);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((u,b)=>{const{contents:E,overrides:D,keys:y}=this.r.get(b);return u.push([b,{contents:E,overrides:D,keys:y}]),u},[])}}allKeys(){const u=new Set;return this.j.keys.forEach(b=>u.add(b)),this.userConfiguration.keys.forEach(b=>u.add(b)),this.q.keys.forEach(b=>u.add(b)),this.r.forEach(b=>b.keys.forEach(E=>u.add(E))),[...u.values()]}B(){const u=new Set;return this.j.getAllOverrideIdentifiers().forEach(b=>u.add(b)),this.userConfiguration.getAllOverrideIdentifiers().forEach(b=>u.add(b)),this.q.getAllOverrideIdentifiers().forEach(b=>u.add(b)),this.r.forEach(b=>b.getAllOverrideIdentifiers().forEach(E=>u.add(E))),[...u.values()]}D(u){const b=new Set;return this.j.getKeysForOverrideIdentifier(u).forEach(E=>b.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(E=>b.add(E)),this.q.getKeysForOverrideIdentifier(u).forEach(E=>b.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(u).forEach(D=>b.add(D))),[...b.values()]}static parse(u,b){const E=this.E(u.defaults,b),D=this.E(u.policy,b),y=this.E(u.application,b),T=this.E(u.user,b),C=this.E(u.workspace,b),v=u.folders.reduce((f,N)=>(f.set(c.URI.revive(N[0]),this.E(N[1],b)),f),new O.$Dc);return new n(E,D,y,T,l.createEmptyModel(b),C,v,l.createEmptyModel(b),new O.$Dc,b)}static E(u,b){return new l(u.contents,u.keys,u.overrides,void 0,b)}}e.$Qo=n;function o(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const u=new Set,b=new Map;for(const D of d)D.keys.forEach(y=>u.add(y)),D.overrides.forEach(([y,T])=>{const C=(0,O.$Ac)(b,y,new Set);T.forEach(v=>C.add(v))});const E=[];return b.forEach((D,y)=>E.push([y,[...D.values()]])),{keys:[...u.values()],overrides:E}}class t{constructor(u,b,E,D,y){this.change=u,this.f=b,this.g=E,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const T of u.keys)this.affectedKeys.add(T);for(const[,T]of u.overrides)for(const C of T)this.affectedKeys.add(C);this.d=this.a;for(const T of this.affectedKeys)this.d+=T+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(u,b){const E=this.a+u,D=this.d.indexOf(E);if(D<0)return!1;const y=D+E.length;if(y>=this.d.length)return!1;const T=this.d.charCodeAt(y);if(T!==this.b&&T!==this.c)return!1;if(b){const C=this.previousConfiguration?this.previousConfiguration.getValue(u,b,this.f?.workspace):void 0,v=this.g.getValue(u,b,this.h);return!R.$jo(C,v)}return!0}}e.$So=t;function i(d,u){const{added:b,removed:E,updated:D}=s(u?.rawConfiguration,d?.rawConfiguration),y=[],T=d?.getAllOverrideIdentifiers()||[],C=u?.getAllOverrideIdentifiers()||[];if(u){const v=C.filter(f=>!T.includes(f));for(const f of v)y.push([f,u.getKeysForOverrideIdentifier(f)])}if(d){const v=T.filter(f=>!C.includes(f));for(const f of v)y.push([f,d.getKeysForOverrideIdentifier(f)])}if(u&&d){for(const v of T)if(C.includes(v)){const f=s({contents:d.getOverrideValue(void 0,v)||{},keys:d.getKeysForOverrideIdentifier(v)},{contents:u.getOverrideValue(void 0,v)||{},keys:u.getKeysForOverrideIdentifier(v)});y.push([v,[...f.added,...f.removed,...f.updated]])}}return{added:b,removed:E,updated:D,overrides:y}}function s(d,u){const b=d?u?d.keys.filter(y=>u.keys.indexOf(y)===-1):[...d.keys]:[],E=u?d?u.keys.filter(y=>d.keys.indexOf(y)===-1):[...u.keys]:[],D=[];if(d&&u){for(const y of u.keys)if(d.keys.indexOf(y)!==-1){const T=(0,I.$ij)(u.contents,y),C=(0,I.$ij)(d.contents,y);R.$jo(T,C)||D.push(y)}}return{added:b,removed:E,updated:D}}}),define(Se[283],De([1,0,22,4,3,69]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rxb=e.$pxb=e.$oxb=void 0,e.$qxb=R;const O=(c,I,S)=>{const h=new Uint8Array(16);for(let l=0;l<16;l++)h[l]=Math.round(Math.random()*256);const P=(0,r.$0e)(r.$Pe.wrap(h));return[`GET ws://localhost${c}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`].join(`\r
`)+`\r
\r
`};e.$oxb=O,e.$pxb=r.$Pe.fromString(`\r
\r
`);async function R(c,I,S,h,P){c.write(r.$Pe.fromString((0,e.$oxb)(I,S,h)));const w=new k.$Wc;try{return await new Promise((l,m)=>{let g;w.add(c.onData($=>{g?g=r.$Pe.concat([g,$],g.byteLength+$.byteLength):g=$;const n=g.indexOf(e.$pxb);if(n===-1)return;l(c),c.pauseData();const o=g.slice(n+e.$pxb.byteLength);o.byteLength&&P.onData.fire(o)})),w.add(c.onClose($=>m($??new Error("socket closed")))),w.add(c.onEnd(()=>m(new Error("socket ended"))))})}catch(l){throw c.dispose(),l}finally{w.dispose()}}class p extends k.$Xc{constructor(I,S){super(),this.g=I,this.a=this.B(new a.$qe),this.onData=(...h)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...h)),this.b=this.B(new a.$ne),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(h=>this.a.fire(h))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,S){A.SocketDiagnostics.traceSocketEvent(this,this.g,I,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$rxb=p}),define(Se[72],De([1,0,14,5]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=c,e.$Rl=(0,a.$Gi)("remoteAuthorityResolverService");var k;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class A{constructor(S){this.id=S,this.type=k.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=A;class O{constructor(S,h){this.host=S,this.port=h,this.type=k.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=O;var R;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class p extends r.$eb{static isNotAvailable(S){return S instanceof p&&S._code===R.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof p&&S._code===R.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof p&&S._code===R.NoResolverFound}static isInvalidAuthority(S){return S instanceof p&&S._code===R.InvalidAuthority}static isHandled(S){return S instanceof p&&S.isHandled}constructor(S,h=R.Unknown,P){super(S),this._message=S,this._code=h,this._detail=P,this.isHandled=h===R.NotAvailable&&P===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ul=p;function c(I){const S=I.indexOf("+");return S===-1?I:I.substring(0,S)}}),define(Se[284],De([1,0,7,22,21,14,4,3,15,62,44,33,69,72]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$1l=y,e.$2l=T,e.$3l=v,c=Ue(c);const w=30*1e3;var l;(function(fe){fe[fe.Management=1]="Management",fe[fe.ExtensionHost=2]="ExtensionHost",fe[fe.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function m(fe){switch(fe){case l.Management:return"Management";case l.ExtensionHost:return"ExtensionHost";case l.Tunnel:return"Tunnel"}}function g(fe){const oe=new k.$ye;return setTimeout(()=>oe.cancel(),fe),oe.token}function $(fe,oe){if(fe.isCancellationRequested||oe.isCancellationRequested)return k.CancellationToken.Cancelled;const H=new k.$ye;return fe.onCancellationRequested(()=>H.cancel()),oe.onCancellationRequested(()=>H.cancel()),H.token}class n{get didTimeout(){return this.c==="timedout"}constructor(oe){this.c="pending",this.d=new R.$Wc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$zh)(),oe.isCancellationRequested?this.h():this.d.add(oe.onCancellationRequested(()=>this.h()))}registerDisposable(oe){this.c==="pending"?this.d.add(oe):oe.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const oe=new Error("Time limit reached");return oe.code="ETIMEDOUT",oe.syscall="connect",oe}resolve(oe){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(oe))}reject(oe){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(oe))}}function o(fe,oe){const H=new n(oe);return H.registerDisposable(fe.onControlMessage(ue=>{const te=JSON.parse(ue.toString()),_=K(te);_?H.reject(_):H.resolve(te)})),H.promise}function t(fe,oe,H,ue,te,_,ne,le){const J=new n(le),ce=I.$he.create(!1);return fe.info(`Creating a socket (${ne})...`),c.mark(`code/willCreateSocket/${_}`),oe.connect(H,ue,te,ne).then(me=>{J.didTimeout?(c.mark(`code/didCreateSocketError/${_}`),fe.info(`Creating a socket (${ne}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),me?.dispose()):(c.mark(`code/didCreateSocketOK/${_}`),fe.info(`Creating a socket (${ne}) was successful after ${ce.elapsed()} ms.`),J.resolve(me))},me=>{c.mark(`code/didCreateSocketError/${_}`),fe.info(`Creating a socket (${ne}) returned an error after ${ce.elapsed()} ms.`),fe.error(me),J.reject(me)}),J.promise}function i(fe,oe){const H=new n(oe);return fe.then(ue=>{H.didTimeout||H.resolve(ue)},ue=>{H.didTimeout||H.reject(ue)}),H.promise}async function s(fe,oe,H,ue){const te=Z(fe,oe);fe.logService.trace(`${te} 1/6. invoking socketFactory.connect().`);let _;try{_=await t(fe.logService,fe.remoteSocketFactoryService,fe.connectTo,p.$Tg.getServerRootPath(),`reconnectionToken=${fe.reconnectionToken}&reconnection=${fe.reconnectionProtocol?"true":"false"}`,m(oe),`renderer-${m(oe)}-${fe.reconnectionToken}`,ue)}catch(me){throw fe.logService.error(`${te} socketFactory.connect() failed or timed out. Error:`),fe.logService.error(me),me}fe.logService.trace(`${te} 2/6. socketFactory.connect() was successful.`);let ne,le;fe.reconnectionProtocol?(fe.reconnectionProtocol.beginAcceptReconnection(_,null),ne=fe.reconnectionProtocol,le=!1):(ne=new h.$ui({socket:_}),le=!0),fe.logService.trace(`${te} 3/6. sending AuthRequest control message.`);const J=await i(fe.signService.createNewMessage((0,S.$3g)()),ue),ce={type:"auth",auth:fe.connectionToken||"00000000000000000000",data:J.data};ne.sendControl(a.$Pe.fromString(JSON.stringify(ce)));try{const me=await o(ne,$(ue,g(1e4)));if(me.type!=="sign"||typeof me.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(fe.logService.trace(`${te} 4/6. received SignRequest control message.`),!await i(fe.signService.validate(J,me.signedData),ue)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Me=await i(fe.signService.sign(me.data),ue),qe={type:"connectionType",commit:fe.commit,signedData:Me,desiredConnectionType:oe};return H&&(qe.args=H),fe.logService.trace(`${te} 5/6. sending ConnectionTypeRequest control message.`),ne.sendControl(a.$Pe.fromString(JSON.stringify(qe))),{protocol:ne,ownsProtocol:le}}catch(me){throw me&&me.code==="ETIMEDOUT"&&(fe.logService.error(`${te} the handshake timed out. Error:`),fe.logService.error(me)),me&&me.code==="VSCODE_CONNECTION_ERROR"&&(fe.logService.error(`${te} received error control message when negotiating connection. Error:`),fe.logService.error(me)),le&&q(ne),me}}async function d(fe,oe,H,ue){const te=Date.now(),_=Z(fe,oe),{protocol:ne,ownsProtocol:le}=await s(fe,oe,H,ue),J=new n(ue);return J.registerDisposable(ne.onControlMessage(ce=>{const me=JSON.parse(ce.toString()),we=K(me);we?(fe.logService.error(`${_} received error control message when negotiating connection. Error:`),fe.logService.error(we),le&&q(ne),J.reject(we)):(fe.reconnectionProtocol?.endAcceptReconnection(),fe.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${$e(te)}!`),J.resolve({protocol:ne,firstMessage:me}))})),J.promise}async function u(fe,oe){const{protocol:H}=await d(fe,l.Management,void 0,oe);return{protocol:H}}async function b(fe,oe,H){const{protocol:ue,firstMessage:te}=await d(fe,l.ExtensionHost,oe,H),_=te&&te.debugPort;return{protocol:ue,debugPort:_}}async function E(fe,oe,H){const ue=Date.now(),te=Z(fe,l.Tunnel),{protocol:_}=await s(fe,l.Tunnel,oe,H);return fe.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${$e(ue)}!`),_}async function D(fe,oe,H){const{connectTo:ue,connectionToken:te}=await fe.addressProvider.getAddress();return{commit:fe.commit,quality:fe.quality,connectTo:ue,connectionToken:te,reconnectionToken:oe,reconnectionProtocol:H,remoteSocketFactoryService:fe.remoteSocketFactoryService,signService:fe.signService,logService:fe.logService}}async function y(fe,oe,H){return C(fe,async ue=>{const{protocol:te}=await u(ue,k.CancellationToken.None);return new W(fe,oe,H,ue.reconnectionToken,te)})}async function T(fe,oe){return C(fe,async H=>{const{protocol:ue,debugPort:te}=await b(H,oe,k.CancellationToken.None);return new ae(fe,oe,H.reconnectionToken,ue,te)})}async function C(fe,oe){for(let ue=1;;ue++)try{const te=(0,S.$3g)(),_=await D(fe,te,null);return await oe(_)}catch(te){if(ue<5)fe.logService.error(`[remote-connection][attempt ${ue}] An error occurred in initial connection! Will retry... Error:`),fe.logService.error(te);else throw fe.logService.error(`[remote-connection][attempt ${ue}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),fe.logService.error(te),B.triggerPermanentFailure(0,0,P.$Ul.isHandled(te)),te}}async function v(fe,oe,H){const ue=await D(fe,(0,S.$3g)(),null);return await E(ue,{host:oe,port:H},k.CancellationToken.None)}function f(fe){return(0,r.$th)(oe=>new Promise((H,ue)=>{const te=setTimeout(H,fe*1e3);oe.onCancellationRequested(()=>{clearTimeout(te),H()})}))}var N;(function(fe){fe[fe.ConnectionLost=0]="ConnectionLost",fe[fe.ReconnectionWait=1]="ReconnectionWait",fe[fe.ReconnectionRunning=2]="ReconnectionRunning",fe[fe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",fe[fe.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(oe,H){this.reconnectionToken=oe,this.millisSinceLastIncomingData=H,this.type=N.ConnectionLost}}e.$4l=F;class j{constructor(oe,H,ue,te){this.reconnectionToken=oe,this.millisSinceLastIncomingData=H,this.durationSeconds=ue,this.c=te,this.type=N.ReconnectionWait}skipWait(){this.c.cancel()}}e.$5l=j;class z{constructor(oe,H,ue){this.reconnectionToken=oe,this.millisSinceLastIncomingData=H,this.attempt=ue,this.type=N.ReconnectionRunning}}e.$6l=z;class M{constructor(oe,H,ue){this.reconnectionToken=oe,this.millisSinceLastIncomingData=H,this.attempt=ue,this.type=N.ConnectionGain}}e.$7l=M;class L{constructor(oe,H,ue,te){this.reconnectionToken=oe,this.millisSinceLastIncomingData=H,this.attempt=ue,this.handled=te,this.type=N.ReconnectionPermanentFailure}}e.$8l=L;class B extends R.$Xc{static triggerPermanentFailure(oe,H,ue){this._permanentFailure=!0,this.f=oe,this.g=H,this.h=ue,this.j.forEach(te=>te.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(oe=>oe.y())}static debugPauseSocketWriting(){this.j.forEach(oe=>oe.F())}get n(){return this.c||B._permanentFailure}constructor(oe,H,ue,te,_){super(),this.t=oe,this.u=H,this.reconnectionToken=ue,this.protocol=te,this.w=_,this.m=this.B(new O.$ne),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(te.onSocketClose(ne=>{const le=ge(this.t,this.reconnectionToken,!0);ne?ne.type===h.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${le} received socket close event (hadError: ${ne.hadError}).`),ne.error&&this.u.logService.error(ne.error)):(this.u.logService.info(`${le} received socket close event (wasClean: ${ne.wasClean}, code: ${ne.code}, reason: ${ne.reason}).`),ne.event&&this.u.logService.error(ne.event)):this.u.logService.info(`${le} received socket close event.`),this.y()})),this.B(te.onSocketTimeout(ne=>{const le=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ne.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ne.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ne.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,R.$Vc)(()=>{const ne=B.j.indexOf(this);ne>=0&&B.j.splice(ne,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const oe=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const H=[0,5,5,10,10,10,10,10,30];let ue=-1;do{ue++;const te=ue<H.length?H[ue]:H[H.length-1];try{if(te>0){const ne=f(te);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),te,ne)),this.u.logService.info(`${oe} waiting for ${te} seconds before reconnecting...`);try{await ne}catch{}}if(this.n){this.u.logService.error(`${oe} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ue+1)),this.u.logService.info(`${oe} resolving connection...`);const _=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${oe} connecting to ${_.connectTo}...`),await this.G(_,g(w)),this.u.logService.info(`${oe} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ue+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${oe} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),ue+1,!1);break}if(ue>360){this.u.logService.error(`${oe} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),ue+1,!1);break}if(P.$Ul.isTemporarilyNotAvailable(_)){this.u.logService.info(`${oe} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.u.logService.info(`${oe} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((0,A.$7)(_)){this.u.logService.info(`${oe} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if(_ instanceof P.$Ul){this.u.logService.error(`${oe} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),ue+1,P.$Ul.isHandled(_));break}this.u.logService.error(`${oe} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),ue+1,!1);break}}while(!this.n&&!this.s)}C(oe,H,ue){this.w?B.triggerPermanentFailure(oe,H,ue):this.D(oe,H,ue)}D(oe,H,ue){this.m.fire(new L(this.reconnectionToken,oe,H,ue)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$9l=B,B._permanentFailure=!1,B.f=0,B.g=0,B.h=!1,B.j=[];class W extends B{constructor(oe,H,ue,te,_){super(l.Management,oe,te,_,!0),this.client=this.B(new h.$si(_,{remoteAuthority:H,clientId:ue},oe.ipcLogger))}async G(oe,H){await u(oe,H)}}e.$0l=W;class ae extends B{constructor(oe,H,ue,te,_){super(l.ExtensionHost,oe,ue,te,!1),this.H=H,this.debugPort=_}async G(oe,H){await b(oe,this.H,H)}}e.$$l=ae;function q(fe){try{fe.acceptDisconnect();const oe=fe.getSocket();fe.dispose(),oe.dispose()}catch(oe){(0,A.$3)(oe)}}function K(fe){if(fe&&fe.type==="error"){const oe=new Error(`Connection error: ${fe.reason}`);return oe.code="VSCODE_CONNECTION_ERROR",oe}return null}function ee(fe,oe){for(;fe.length<oe;)fe+=" ";return fe}function re(fe,oe){return`[remote-connection][${ee(m(fe),13)}][${oe.substr(0,5)}\u2026]`}function ge(fe,oe,H){return`${re(fe,oe)}[${H?"reconnect":"initial"}]`}function Z(fe,oe){return`${ge(oe,fe.reconnectionToken,!!fe.reconnectionProtocol)}[${fe.connectTo}]`}function $e(fe){return`${Date.now()-fe} ms`}}),define(Se[91],De([1,0,15]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=a,e.$jn=k,e.$kn=A,e.$ln=O;function a(p){return p.scheme===r.Schemas.vscodeRemote?p.authority:void 0}function k(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function A(p){const{host:c,port:I}=R(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:I}}function O(p,c){let{host:I,port:S}=R(p);return typeof S>"u"&&(S=c),{host:I,port:S}}function R(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const S=p.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:p,port:void 0}}}),define(Se[24],De([1,0,13,5,91]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$un=e.$tn=e.$sn=e.TargetPlatform=e.ExtensionType=e.$rn=e.$pn=e.$on=e.$nn=e.$mn=void 0,e.$qn=A,e.$vn=S,e.$wn=h,e.$xn=P,e.$yn=w,e.$zn=l,e.$An=m,r=Ue(r),e.$mn="extensions.user.cache",e.$nn="extensions.builtin.cache",e.$on="undefined_publisher",e.$pn=["ui","workspace","web"];function A(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$rn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class p{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,n){if(typeof $>"u"||$===null)return typeof n>"u"||n===null;if(typeof n>"u"||n===null)return!1;if(typeof $=="string"||typeof n=="string"){const o=typeof $=="string"?$:$.value,t=typeof n=="string"?n:n.value;return r.$Hf(o,t)}return $._lower===n._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$sn=p;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const n of $)this.add(n)}add($){this.c.add(p.toKey($))}delete($){return this.c.delete(p.toKey($))}has($){return this.c.has(p.toKey($))}}e.$tn=c;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(p.toKey($))}get($){return this.c.get(p.toKey($))}has($){return this.c.has(p.toKey($))}set($,n){this.c.set(p.toKey($),n)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$un=I;function S(g){return h(g)}function h(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}function P(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}function w(g,$){if($){const n=`onResolveRemoteAuthority:${(0,k.$jn)($)}`;return!!g.activationEvents?.includes(n)}return!1}function l(g){return g.map($=>{const[n,o]=$.split("@");return{proposalName:n,version:o?parseInt(o):void 0}})}function m(g){return g.map($=>$.split("@")[0])}e.$Bn=(0,a.$Gi)("IBuiltinExtensionsScannerService")}),define(Se[148],De([1,0,11,222,24,5]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.ExtensionManagementErrorCode=e.$lp=e.ExtensionGalleryErrorCode=e.$kp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0,e.$ep=R,e.$fp=p,e.$gp=c,e.$hp=I,e.$ip=S,e.$jp=h,e.$0o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$o=new RegExp(e.$0o),e.$_o="__web_extension",e.$ap="skipWalkthrough",e.$bp="extensionInstallSource",e.$cp="dependecyOrPackExtensionInstall",e.$dp="clientTargetPlatform";var O;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(O||(e.ExtensionInstallSource=O={}));function R(t){switch(t){case k.TargetPlatform.WIN32_X64:return"Windows 64 bit";case k.TargetPlatform.WIN32_ARM64:return"Windows ARM";case k.TargetPlatform.LINUX_X64:return"Linux 64 bit";case k.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case k.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case k.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case k.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case k.TargetPlatform.DARWIN_X64:return"Mac";case k.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case k.TargetPlatform.WEB:return"Web";case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;case k.TargetPlatform.UNKNOWN:return k.TargetPlatform.UNKNOWN;case k.TargetPlatform.UNDEFINED:return k.TargetPlatform.UNDEFINED}}function p(t){switch(t){case k.TargetPlatform.WIN32_X64:return k.TargetPlatform.WIN32_X64;case k.TargetPlatform.WIN32_ARM64:return k.TargetPlatform.WIN32_ARM64;case k.TargetPlatform.LINUX_X64:return k.TargetPlatform.LINUX_X64;case k.TargetPlatform.LINUX_ARM64:return k.TargetPlatform.LINUX_ARM64;case k.TargetPlatform.LINUX_ARMHF:return k.TargetPlatform.LINUX_ARMHF;case k.TargetPlatform.ALPINE_X64:return k.TargetPlatform.ALPINE_X64;case k.TargetPlatform.ALPINE_ARM64:return k.TargetPlatform.ALPINE_ARM64;case k.TargetPlatform.DARWIN_X64:return k.TargetPlatform.DARWIN_X64;case k.TargetPlatform.DARWIN_ARM64:return k.TargetPlatform.DARWIN_ARM64;case k.TargetPlatform.WEB:return k.TargetPlatform.WEB;case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;default:return k.TargetPlatform.UNKNOWN}}function c(t,i){switch(t){case r.Platform.Windows:return i==="x64"?k.TargetPlatform.WIN32_X64:i==="arm64"?k.TargetPlatform.WIN32_ARM64:k.TargetPlatform.UNKNOWN;case r.Platform.Linux:return i==="x64"?k.TargetPlatform.LINUX_X64:i==="arm64"?k.TargetPlatform.LINUX_ARM64:i==="arm"?k.TargetPlatform.LINUX_ARMHF:k.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?k.TargetPlatform.ALPINE_X64:i==="arm64"?k.TargetPlatform.ALPINE_ARM64:k.TargetPlatform.UNKNOWN;case r.Platform.Mac:return i==="x64"?k.TargetPlatform.DARWIN_X64:i==="arm64"?k.TargetPlatform.DARWIN_ARM64:k.TargetPlatform.UNKNOWN;case r.Platform.Web:return k.TargetPlatform.WEB}}function I(t,i){return i===k.TargetPlatform.WEB&&!t.includes(k.TargetPlatform.WEB)}function S(t,i,s){return I(i,s)?!1:t===k.TargetPlatform.UNDEFINED||t===k.TargetPlatform.UNIVERSAL?!0:t===k.TargetPlatform.UNKNOWN?!1:t===s}function h(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var P;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var w;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var m;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$kp=(0,A.$Gi)("extensionGalleryService");var g;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(g||(e.ExtensionGalleryErrorCode=g={}));class $ extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$lp=$;var n;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class o extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$mp=o,e.$np=(0,A.$Gi)("extensionManagementService"),e.$op="extensionsIdentifiers/disabled",e.$pp="extensionsIdentifiers/enabled",e.$qp=(0,A.$Gi)("IGlobalExtensionEnablementService"),e.$rp=(0,A.$Gi)("IExtensionTipsService"),e.$sp=(0,a.localize2)(0,"Extensions"),e.$tp=(0,a.localize2)(1,"Preferences")}),define(Se[149],De([1,0,14,24]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NG=e.$MG=void 0;class k{constructor(){this.a=new Map,this.b=new WeakMap}register(O,R){this.a.set(O,R)}readActivationEvents(O){return this.b.has(O)||this.b.set(O,this.c(O)),this.b.get(O)}createActivationEventsMap(O){const R=Object.create(null);for(const p of O){const c=this.readActivationEvents(p);c.length>0&&(R[a.$sn.toKey(p.identifier)]=c)}return R}c(O){if(typeof O.main>"u"&&typeof O.browser>"u")return[];const R=Array.isArray(O.activationEvents)?O.activationEvents.slice(0):[];for(let p=0;p<R.length;p++)R[p]==="onUri"&&(R[p]=`onUri:${a.$sn.toKey(O.identifier)}`);if(!O.contributes)return R;for(const p in O.contributes){const c=this.a.get(p);if(!c)continue;const I=O.contributes[p],S=Array.isArray(I)?I:[I];try{c(S,R)}catch(h){(0,r.$3)(h)}}return R}}e.$MG=k,e.$NG=new k});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[285],De([1,0,23,45,223,411,24,145]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=I,e.$Zp=S,e.$1p=h,e.$2p=P,e.$3p=w,e.$4p=l,e.$5p=m,e.$6p=g,a=qt(a),k=Ue(k),A=Ue(A);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function I(o){return o=o.trim(),o==="*"||p.test(o)}function S(o){if(!I(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=o.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function h(o){if(!o)return null;const t=o.majorBase,i=o.majorMustEqual,s=o.minorBase;let d=o.minorMustEqual;const u=o.patchBase;let b=o.patchMustEqual;o.hasCaret&&(t===0||(d=!1),b=!1);let E=0;if(o.preRelease){const D=c.exec(o.preRelease);if(D){const[,y,T,C]=D;E=Date.UTC(Number(y),Number(T)-1,Number(C))}}return{majorBase:t,majorMustEqual:i,minorBase:s,minorMustEqual:d,patchBase:u,patchMustEqual:b,isMinimum:o.hasGreaterEquals,notBefore:E}}function P(o,t,i){let s;typeof o=="string"?s=h(S(o)):s=o;let d;t instanceof Date?d=t.getTime():typeof t=="string"&&(d=new Date(t).getTime());let u;if(typeof i=="string"?u=h(S(i)):u=i,!s||!u)return!1;const b=s.majorBase,E=s.minorBase,D=s.patchBase;let y=u.majorBase,T=u.minorBase,C=u.patchBase;const v=u.notBefore;let f=u.majorMustEqual,N=u.minorMustEqual,F=u.patchMustEqual;return u.isMinimum?b>y?!0:b<y?!1:E>T?!0:E<T||d&&d<v?!1:D>=C:(b===1&&y===0&&(!f||!N||!F)&&(y=1,T=0,C=0,f=!0,N=!1,F=!1),b<y?!1:b>y?!f:E<T?!1:E>T?!N:D<C?!1:D>C?!F:!(d&&d<v))}function w(o,t,i,s,d,u){const b=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return b.push([a.default.Error,k.localize(0,null)]),b;if(typeof s.name!="string")return b.push([a.default.Error,k.localize(1,null,"name")]),b;if(typeof s.version!="string")return b.push([a.default.Error,k.localize(2,null,"version")]),b;if(!s.engines)return b.push([a.default.Error,k.localize(3,null,"engines")]),b;if(typeof s.engines.vscode!="string")return b.push([a.default.Error,k.localize(4,null,"engines.vscode")]),b;if(typeof s.extensionDependencies<"u"&&!n(s.extensionDependencies))return b.push([a.default.Error,k.localize(5,null,"extensionDependencies")]),b;if(typeof s.activationEvents<"u"){if(!n(s.activationEvents))return b.push([a.default.Error,k.localize(6,null,"activationEvents")]),b;if(typeof s.main>"u"&&typeof s.browser>"u")return b.push([a.default.Error,k.localize(7,null,"activationEvents","main","browser")]),b}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&b.push([a.default.Warning,k.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return b.push([a.default.Error,k.localize(9,null,"main")]),b;{const y=(0,r.$hh)(i,s.main);(0,r.$bh)(y,i)||b.push([a.default.Warning,k.localize(10,null,y.path,i.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return b.push([a.default.Error,k.localize(11,null,"browser")]),b;{const y=(0,r.$hh)(i,s.browser);(0,r.$bh)(y,i)||b.push([a.default.Warning,k.localize(12,null,y.path,i.path)])}}if(!A.valid(s.version))return b.push([a.default.Error,k.localize(13,null)]),b;const E=[];if(!l(o,t,s,d,E))for(const y of E)b.push([a.default.Error,y]);if(u&&s.enabledApiProposals?.length){const y=[];if(!g([...s.enabledApiProposals],y))for(const T of y)b.push([a.default.Error,T])}return b}function l(o,t,i,s,d){return s||typeof i.main>"u"&&typeof i.browser>"u"?!0:$(o,t,i.engines.vscode,d)}function m(o,t,i){return o==="*"||$(t,i,o)}function g(o,t){if(o.length===0)return!0;const i=Array.isArray(t)?t:void 0,s=(i?void 0:t)??R.allApiProposals,d=[],u=(0,O.$zn)(o);for(const{proposalName:b,version:E}of u){const D=s[b];D&&E&&D.version!==E&&d.push(k.localize(14,null,b))}return i?.push(...d),d.length===0}function $(o,t,i,s=[]){const d=h(S(i));if(!d)return s.push(k.localize(15,null,i)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return s.push(k.localize(16,null,i)),!1}else if(!d.majorMustEqual)return s.push(k.localize(17,null,i)),!1;return P(o,t,d)?!0:(s.push(k.localize(18,null,o,i)),!1)}function n(o){if(!Array.isArray(o))return!1;for(let t=0,i=o.length;t<i;t++)if(typeof o[t]!="string")return!1;return!0}}),define(Se[286],De([1,0,3,5]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=void 0,e.$Wl=(0,a.$Gi)("remoteSocketFactoryService");class k{constructor(){this.a={}}register(O,R){var p;return(p=this.a)[O]??(p[O]=[]),this.a[O].push(R),(0,r.$Vc)(()=>{const c=this.a[O]?.indexOf(R);typeof c=="number"&&c>=0&&this.a[O]?.splice(c,1)})}b(O){return(this.a[O.type]||[]).find(p=>p.supports(O))}connect(O,R,p,c){const I=this.b(O);if(!I)throw new Error(`No socket factory found for ${O}`);return I.connect(O,R,p,c)}}e.$Xl=k}),define(Se[287],De([1,0,22,14,3,230,71,5,12,37]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$9p=h,e.$0p=P,e.$$p=w,e.$_p=l,e.$aq=m,e.$bq=g,e.$7p=(0,R.$Gi)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?t[i]="*****":t[i]=this.b[i];this.a=t}return this.a}}class S extends k.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,A.localize)(0,null),when:p.$sk.isEqualTo((0,p.$pk)(p.LogLevel.Trace)).serialize()})}async c(t,i,s){const d=`${t} #${++this.b}: ${i.url}`;this.a.trace(`${d} - begin`,i.type,new I(i.headers??{}));try{const u=await s();return this.a.trace(`${d} - end`,i.type,u.res.statusCode,u.res.headers),u}catch(u){throw this.a.error(`${d} - error`,i.type,(0,a.$ab)(u)),u}}}e.$8p=S;function h(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function P(o){return o.res.statusCode===204}async function w(o){return P(o)?null:(await(0,r.$2e)(o.stream)).toString()}async function l(o){if(!h(o))throw new Error("Server returned "+o.res.statusCode);return w(o)}async function m(o){if(!h(o))throw new Error("Server returned "+o.res.statusCode);if(P(o))return null;const i=(await(0,r.$2e)(o.stream)).toString();try{return JSON.parse(i)}catch(s){throw s.message+=`:
`+i,s}}function g(o){n(o)}let $;function n(o){const t=c.$so.as(O.$xo.Configuration),i=$;$={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null),(0,A.localize)(10,null)],default:"override",description:(0,A.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[$],remove:i?[i]:[]})}n(O.ConfigurationScope.APPLICATION)}),define(Se[288],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=void 0;class r{constructor(){this.b=new Map}async createNewMessage(k){try{const A=await this.c();if(A){const O=String(r.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,A){if(!k.id)return!0;const O=this.b.get(k.id);if(!O)return!1;this.b.delete(k.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(k){try{return await this.d(k)}catch{}return k}}e.$Zbc=r,r.a=1}),define(Se[118],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=void 0,e.$Yl="signService",e.$Zl=(0,r.$Gi)(e.$Yl)}),define(Se[150],De([1,0,288]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;class a extends r.$Zbc{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>ie(["vsda"],A,O))}}e.$6gc=a}),define(Se[289],De([1,0,11,54,33]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=O,e.$vp=R;function A(p){if(r.$o===r.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function O(p,c,I,S,h,P,w,l,m,g){const $=Object.create(null);$["common.machineId"]=P,$["common.sqmId"]=w,$["common.devDeviceId"]=l,$.sessionID=(0,k.$3g)()+Date.now(),$.commitHash=S,$.version=h,$["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,r.$b)(r.$o),$["common.nodePlatform"]=a.$gc,$["common.nodeArch"]=I,$["common.product"]=g||"desktop",m&&($["common.msftInternal"]=m);let n=0;const o=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),r.$f&&($["common.snap"]="true");const t=A(c);return t&&($["common.platformDetail"]=t),$}function R(p){const c=a.env.USERDNSDOMAIN;if(!c)return!1;const I=c.toLowerCase();return p.some(S=>I===S)}}),define(Se[151],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,r.$Gi)("telemetryService"),e.$am=(0,r.$Gi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var a;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(Se[92],De([1,0,25,18,91,289,151]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$Dp=I,e.$Ep=S,e.$Fp=h,e.$Gp=P,e.$Hp=l,e.$Ip=g,e.$Jp=$,e.$Kp=t;class R{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$wp=R;class p{constructor(){this.telemetryLevel=O.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xp=p,e.$yp=new p;class c{async publicLog(s,d,u){}async publicLogError(s,d,u){}}e.$zp=c,e.$Ap="telemetry",e.$Bp="extensionTelemetryLog",e.$Cp={log:()=>null,flush:()=>Promise.resolve(null)};function I(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}function S(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function h(i){const s=i.getValue(O.$im),d=i.getValue(O.$jm);if(i.getValue(O.$km)===!1||d===!1)return O.TelemetryLevel.NONE;switch(s??O.TelemetryConfiguration.ON){case O.TelemetryConfiguration.ON:return O.TelemetryLevel.USAGE;case O.TelemetryConfiguration.ERROR:return O.TelemetryLevel.ERROR;case O.TelemetryConfiguration.CRASH:return O.TelemetryLevel.CRASH;case O.TelemetryConfiguration.OFF:return O.TelemetryLevel.NONE}}function P(i){const s={},d={},u={};m(i,u);for(let b in u){b=b.length>150?b.substr(b.length-149):b;const E=u[b];typeof E=="number"?d[b]=E:typeof E=="boolean"?d[b]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${E.length}`),s[b]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(s[b]=E)}return{properties:s,measurements:d}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(i){if(!i)return"none";const s=(0,k.$jn)(i);return w.has(s)?s:"other"}function m(i,s,d=0,u){if(i)for(const b of Object.getOwnPropertyNames(i)){const E=i[b],D=u?u+b:b;Array.isArray(E)?s[D]=(0,r.$ko)(E):E instanceof Date?s[D]=E.toISOString():(0,a.$ig)(E)?d<2?m(E,s,d+1,D+"."):s[D]=(0,r.$ko)(E):s[D]=E}}function g(i,s){const d=i.msftInternalDomains||[],u=s.getValue("telemetry.internalTesting");return(0,A.$vp)(d)||u}function $(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function n(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let d=i;const u=[];for(const y of s)for(;;){const T=y.exec(i);if(!T)break;u.push([T.index,y.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(d="";;){const y=E.exec(i);if(!y)break;const T=u.some(([C,v])=>y.index<v&&C<E.lastIndex);!b.test(y[0])&&!T&&(d+=i.substring(D,y.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<i.length&&(d+=i.substr(D)),d}function o(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of s)if(d.regex.test(i))return`<REDACTED: ${d.label}>`;return i}function t(i,s){return(0,r.$ho)(i,d=>{if(d instanceof R||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let u=d.replaceAll("%20"," ");u=n(u,s);for(const b of s)u=u.replace(b,"");return u=o(u),u}})}}),define(Se[290],De([1,0,13,148,24,11,2,14,54,92]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Mp=void 0,e.$Lp=I,e.$Np=w,e.$Op=l,e.$Pp=m,e.$Qp=g,e.$Rp=$,e.$Sp=n,e.$Tp=o,e.$Vp=t,e.$Wp=s;function I(d,u){return d.uuid&&u.uuid?d.uuid===u.uuid:d.id===u.id?!0:(0,r.$Cf)(d.id,u.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(u){const b=u.manifest?u.manifest.version:u.version,E=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new h(u.identifier,b,E)}static parse(u){const b=S.exec(u);return b&&b[1]&&b[2]?new h({id:b[1]},b[2],b[4]||void 0):null}constructor(u,b,E=k.TargetPlatform.UNDEFINED){this.identifier=u,this.version=b,this.targetPlatform=E,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==k.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof h?I(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Mp=h;const P=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(d){const u=P.exec(d);return u&&u[1]?[m(u[1]),u[2]]:[m(d),void 0]}function l(d,u){return`${d}.${u}`}function m(d){return d.toLowerCase()}function g(d,u){return m(l(d??k.$on,u))}function $(d,u){const b=[],E=D=>{for(const y of b)if(y.some(T=>I(u(T),u(D))))return y;return null};for(const D of d){const y=E(D);y?y.push(D):b.push([D])}return b}function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function o(d){return{id:new c.$wp(d.identifier.id),name:new c.$wp(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Up=new k.$sn("pprice.better-merge");function t(d,u){const b=[],E=u.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&b.every(y=>!I(y.identifier,{id:D}))){const y=d.filter(T=>I(T.identifier,{id:D}));y.length===1&&(b.push(y[0]),E.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}async function i(d,u){if(!A.$e)return!1;let b;try{b=(await d.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await d.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){u.debug("Error while getting the os-release file.",(0,R.$ab)(D))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(d,u){const b=await i(d,u),E=(0,a.$gp)(b?"alpine":A.$o,p.$hc);return u.debug("ComputeTargetPlatform:",E),E}}),define(Se[291],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=r,e.$Fs=a,e.$Gs=k,e.$Hs=A,e.$Is=O,e.$Js=R;function r(p){return[...p.entries()]}function a(p){return p?[...p.entries()]:[]}function k(p){return new Map(p)}function A(p){return new Map(p??[])}function O(p){return Array.from(p.entries()).map(c=>[c[0],r(c[1].map),a(c[1].descriptionMap)])}function R(p){return new Map(p.map(c=>[c[0],{map:k(c[1]),descriptionMap:A(c[2])}]))}}),define(Se[292],De([1,0,5,36,37]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$os=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ns=void 0,e.$ns=new a.$Xj("terminalTabFocusMode",!1,!0);var A;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var O;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(O||(e.TerminalSettingId=O={}));var R;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(R||(e.PosixShellType=R={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var S;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(S||(e.ProcessPropertyType=S={})),e.$os=(0,r.$Gi)("ptyService");var h;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(h||(e.HeartbeatConstants=h={}));var P;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(P||(e.TerminalLocation=P={}));var w;(function(t){t.TerminalView="view",t.Editor="editor"})(w||(e.TerminalLocationString=w={}));var l;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(l||(e.LocalReconnectConstants=l={}));var m;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var g;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var $;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})($||(e.ShellIntegrationStatus=$={}));var n;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$ps={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const s=this.b(i.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}k.$so.add(e.$ps.Backend,new o),e.$qs=(0,r.$Gi)("localPtyService"),e.$rs=(0,r.$Gi)("terminalLogService")}),define(Se[293],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jxb=void 0;class r{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,A,O=5){const R=A(p=>{const c=typeof p=="string"?p:p.data;let I=this.a.get(k);if(I){I.data.push(c);return}const S=setTimeout(()=>this.flushBuffer(k),O);I={data:[c],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(k),R.dispose()}},this.a.set(k,I)});return R}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const A=this.a.get(k);A&&(this.a.delete(k),this.b(k,A.data.join("")))}}e.$Jxb=r}),define(Se[294],De([1,0,7,83,107,50,4,18,2,231,117,37]),function(ie,e,r,a,k,A,O,R,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gx=e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.IconFontDefinition=e.IconContribution=e.$yx=void 0,e.$zx=m,e.$Ax=g,S=Ue(S),e.$yx={IconContribution:"base.contributions.icons"};var h;(function(t){function i(s,d){let u=s.defaults;for(;A.ThemeIcon.isThemeIcon(u);){const b=l.getIcon(u.id);if(!b)return;u=b.defaults}return u}t.getDefinition=i})(h||(e.IconContribution=h={}));var P;(function(t){function i(d){return{weight:d.weight,style:d.style,src:d.src.map(u=>({format:u.format,location:u.location.toString()}))}}t.toJSONObject=i;function s(d){const u=b=>(0,R.$gg)(b)?b:void 0;if(d&&Array.isArray(d.src)&&d.src.every(b=>(0,R.$gg)(b.format)&&(0,R.$gg)(b.location)))return{weight:u(d.weight),style:u(d.style),src:d.src.map(b=>({format:b.format,location:p.URI.parse(b.location)}))}}t.fromJSONObject=s})(P||(e.IconFontDefinition=P={}));class w{constructor(){this.a=new O.$ne,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,s,d,u){const b=this.b[i];if(b){if(d&&!b.description){b.description=d,this.d.properties[i].markdownDescription=`${d} $(${i})`;const y=this.e.enum.indexOf(i);y!==-1&&(this.e.enumDescriptions[y]=d),this.a.fire()}return b}const E={id:i,description:d,defaults:s,deprecationMessage:u};this.b[i]=E;const D={$ref:"#/definitions/icons"};return u&&(D.deprecationMessage=u),d&&(D.markdownDescription=`${d}: $(${i})`),this.d.properties[i]=D,this.e.enum.push(i),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const s=this.e.enum.indexOf(i);s!==-1&&(this.e.enum.splice(s,1),this.e.enumDescriptions.splice(s,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,s){const d=this.f[i];return d||(this.f[i]=s,this.a.fire(),s)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(b,E)=>b.id.localeCompare(E.id),s=b=>{for(;A.ThemeIcon.isThemeIcon(b.defaults);)b=this.b[b.defaults.id];return`codicon codicon-${b?b.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(b=>this.b[b]);for(const b of u.filter(E=>!!E.description).sort(i))d.push(`|<i class="${s(b)}"></i>|${b.id}|${A.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const b of u.filter(E=>!A.ThemeIcon.isThemeIcon(E.defaults)).sort(i))d.push(`|<i class="${s(b)}"></i>|${b.id}|`);return d.join(`
`)}}const l=new w;S.$so.add(e.$yx.IconContribution,l);function m(t,i,s,d){return l.registerIcon(t,i,s,d)}function g(){return l}function $(){const t=(0,k.$2j)();for(const i in t){const s="\\"+t[i].toString(16);l.registerIcon(i,{fontCharacter:s})}}$(),e.$Bx="vscode://schemas/icons";const n=S.$so.as(I.$to.JSONContribution);n.registerSchema(e.$Bx,l.getIconSchema());const o=new r.$Sh(()=>n.notifySchemaChanged(e.$Bx),200);l.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Cx=m("widget-close",a.$6j.close,(0,c.localize)(2,null)),e.$Dx=m("goto-previous-location",a.$6j.arrowUp,(0,c.localize)(3,null)),e.$Ex=m("goto-next-location",a.$6j.arrowDown,(0,c.localize)(4,null)),e.$Fx=A.ThemeIcon.modify(a.$6j.sync,"spin"),e.$Gx=A.ThemeIcon.modify(a.$6j.loading,"spin")}),define(Se[93],De([1,0,4,3,11,2,46,5,12]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Mw=e.$Jw=e.$Hw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dw=e.$Cw=void 0,e.$Ew=S,e.$Fw=P,e.$Gw=w,e.$Iw=l,e.$Kw=m,e.$Lw=g,e.$Cw=(0,R.$Gi)("tunnelService"),e.$Dw=(0,R.$Gi)("sharedTunnelsService");var c;(function(o){o.Http="http",o.Https="https"})(c||(e.TunnelProtocol=c={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I||(e.TunnelPrivacyId=I={}));function S(o){return!!o.forwardPort}var h;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function P(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}function w(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const t=o.query.split("&");for(const i of t){const s=i.split("=")[1];if(/^https?:/.exec(s)){const d=P(A.URI.parse(s));if(d)return d}}}e.$Hw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(o){return e.$Hw.indexOf(o)>=0}e.$Jw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(o){return e.$Jw.indexOf(o)>=0}function g(o,t,i,s){if(i===k.OperatingSystem.Windows)return!1;if(i===k.OperatingSystem.Macintosh&&m(t)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(d?.length===4&&parseInt(d[1])>=18)return!1}return o<1024}class ${constructor(t,i,s){this.remoteAddress=t,this.localAddress=i,this.b=s,this.a=new r.$ne,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mw=$;let n=class extends a.$Xc{constructor(t,i){super(),this.r=t,this.s=i,this.a=new r.$ne,this.onTunnelOpened=this.a.event,this.b=new r.$ne,this.onTunnelClosed=this.b.event,this.c=new r.$ne,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],i=Array.from(this.f.values());for(const s of i){const d=Array.from(s.values());for(const u of d){const b=await u.value;b&&typeof b!="string"&&t.push(b)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:i}of t.values())await i.then(s=>typeof s!="string"?s?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,i,s,d,u){this.z(t,i,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:i,localAddress:s,privacy:d,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,i){(m(t)||l(t))&&(t=e.$Hw[0]);const s=this.D(t,i);if(s)return++s.refcount,s.value}openTunnel(t,i,s,d,u,b=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${s} on local port ${u}.`);const y=this.g??t;if(!y)return;if(i||(i="localhost"),d||(d=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const T=this.F(y,i,s,d,u,b,E,D);return T?T.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(i,s),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(i,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.w(C);return(C.tunnelRemoteHost!==i||C.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&C.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),T)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const i=this.f.get(t.tunnelRemoteHost);if(i){const s=i.get(t.tunnelRemotePort);s&&(s.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,s))}}}}async y(t,i,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${i}.`);const d=s.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(i),d}}async closeTunnel(t,i){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${i} `);const s=this.f.get(t);if(s&&s.has(i)){const d=s.get(i);d.refcount=0,await this.y(t,i,d)}}z(t,i,s){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(i,{refcount:1,value:s})}async C(t,i){const s=this.f.get(t);if(s){const d=s.get(i),u=d?await d.value:void 0;(!u||typeof u=="string")&&s.delete(i),s.size===0&&this.f.delete(t)}}D(t,i){const s=[t];l(t)?(s.push(...e.$Hw),s.push(...e.$Jw)):m(t)&&s.push(...e.$Jw);const d=s.map(u=>this.f.get(u));for(const u of d){const b=u?.get(i);if(b)return b}}canTunnel(t){return!!P(t)}G(t,i,s,d,u,b,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${s} on local port ${d}.`);const D=s;this.n.add(D);const y=d===void 0?s:d,T={elevationRequired:u?this.isPortPrivileged(y):!1},C={remoteAddress:{host:i,port:s},localAddressPort:d,privacy:b,public:b?b!==I.Private:void 0,protocol:E},v=t.forwardPort(C,T);return v?(this.z(i,s,v),v.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),v}};e.$Nw=n,e.$Nw=n=Ye([Ve(0,p.$ak),Ve(1,O.$aj)],n)}),define(Se[295],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,r.$Gi)("IUriIdentityService")}),define(Se[296],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Ow=void 0,e.$Ow=(0,r.$Gi)("editSessionIdentityService");var a;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(a||(e.EditSessionIdentityMatch=a={}))}),define(Se[297],De([1,0,15]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=a,e.$6M=k,e.$7M=A,e.$8M=O,e.$9M=R;function a(p){return p.scheme!==r.Schemas.file&&p.scheme!==r.Schemas.vscodeRemote}function k(p){if(p.folders.length)return p.folders.every(c=>a(c.uri))?p.folders[0].uri:void 0;if(p.configuration&&a(p.configuration))return p.configuration}function A(p){return k(p)?.scheme}function O(p){return k(p)?.authority}function R(p){return k(p)!==void 0}}),define(Se[47],De([1,0,233,17,85,23,2,5,15]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=c,e.$Ri=I,e.$Ui=S,e.$Vi=h,e.$Wi=P,e.$Xi=l,e.$Yi=m,e.$2i=n,e.$7i=o,e.$8i=t,e.$0i=i,e.$$i=s,e.$_i=d,e.$Pi=(0,R.$Gi)("contextService");function c(u){const b=u;return typeof b?.id=="string"&&O.URI.isUri(b.uri)}function I(u){return typeof u?.id=="string"&&!c(u)&&!h(u)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function S(u,b){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,a.$qc)(u)}:b?e.$Si:e.$Ti;const E=u;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function h(u){const b=u;return typeof b?.id=="string"&&O.URI.isUri(b.configPath)}function P(u){const b=u;if(b?.uri)return{id:b.id,uri:O.URI.revive(b.uri)};const E=u;if(E?.configPath)return{id:E.id,configPath:O.URI.revive(E.configPath)};if(u?.id)return{id:u.id}}var w;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function l(u){const b=u;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}function m(u){const b=u;return!!(b&&typeof b=="object"&&O.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}class g{constructor(b,E,D,y,T){this.h=b,this.j=D,this.k=y,this.l=T,this.c=k.$Mi.forUris(this.l,()=>!0),this.folders=E}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=k.$Mi.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=g;class ${constructor(b,E){this.raw=E,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,A.$hh)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=$;function n(u){return new $({uri:u,index:0,name:(0,A.$dh)(u)},{uri:u.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,r.localize)(0,null),extensions:[e.$3i]}],e.$6i="workspace.json";function o(u,b){return A.$$g.isEqualOrParent(u,b.untitledWorkspacesHome)}function t(u){let b;return O.URI.isUri(u)?b=u:b=u.configuration,b?.scheme===p.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(u){return u.id===e.$9i}function s(u,b){return!o(u,b)&&!t(u)}function d(u){return(typeof u=="string"?(0,a.$rc)(u):(0,A.$fh)(u))===e.$4i}}),define(Se[152],De([1,0,60,4,3,23,2,232,146,28,5,12,47,29,295,7,33,13,18]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=o,e.$Nl=t,e.$Ol=i;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const b=u;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&typeof b.isDefault=="boolean"&&typeof b.name=="string"&&O.URI.isUri(b.location)&&O.URI.isUri(b.globalStorageHome)&&O.URI.isUri(b.settingsResource)&&O.URI.isUri(b.keybindingsResource)&&O.URI.isUri(b.tasksResource)&&O.URI.isUri(b.snippetsHome)&&O.URI.isUri(b.extensionsResource))}e.$Ml=(0,I.$Gi)("IUserDataProfilesService");function t(u,b){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:O.URI.revive(u.location).with({scheme:b}),globalStorageHome:O.URI.revive(u.globalStorageHome).with({scheme:b}),settingsResource:O.URI.revive(u.settingsResource).with({scheme:b}),keybindingsResource:O.URI.revive(u.keybindingsResource).with({scheme:b}),tasksResource:O.URI.revive(u.tasksResource).with({scheme:b}),snippetsHome:O.URI.revive(u.snippetsHome).with({scheme:b}),extensionsResource:O.URI.revive(u.extensionsResource).with({scheme:b}),cacheHome:O.URI.revive(u.cacheHome).with({scheme:b}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}function i(u,b,E,D,y,T){return{id:u,name:b,location:E,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:T&&y?.useDefaultFlags?.globalState?T.globalStorageHome:(0,A.$hh)(E,"globalStorage"),settingsResource:T&&y?.useDefaultFlags?.settings?T.settingsResource:(0,A.$hh)(E,"settings.json"),keybindingsResource:T&&y?.useDefaultFlags?.keybindings?T.keybindingsResource:(0,A.$hh)(E,"keybindings.json"),tasksResource:T&&y?.useDefaultFlags?.tasks?T.tasksResource:(0,A.$hh)(E,"tasks.json"),snippetsHome:T&&y?.useDefaultFlags?.snippets?T.snippetsHome:(0,A.$hh)(E,"snippets"),extensionsResource:T&&y?.useDefaultFlags?.extensions?T.extensionsResource:(0,A.$hh)(E,"extensions.json"),cacheHome:(0,A.$hh)(D,u),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let s=class extends k.$Xc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(b,E,D,y){super(),this.t=b,this.u=E,this.w=D,this.y=y,this.f=!0,this.h=this.B(new a.$ne),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$ne),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$ne),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$ne),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new P.$Dc,workspaces:new P.$Dc,emptyWindows:new Map},this.profilesHome=(0,A.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(b){this.f!==b&&(this.z=void 0,this.f=b)}isEnabled(){return this.f}get C(){if(!this.z){const b=this.D(),E=[b];if(this.f)try{for(const T of this.O()){if(!T.name||!(0,$.$gg)(T.name)||!T.location){this.y.warn("Skipping the invalid stored profile",T.location||T.name);continue}E.push(i((0,A.$eh)(T.location),T.name,T.location,this.g,{shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags},b))}}catch(T){this.y.error(T)}const D=new P.$Dc,y=new Map;if(E.length)try{const T=this.Q();if(T.workspaces)for(const[C,v]of Object.entries(T.workspaces)){const f=O.URI.parse(C),N=E.find(F=>F.id===v);N&&D.set(f,N)}if(T.emptyWindows)for(const[C,v]of Object.entries(T.emptyWindows)){const f=E.find(N=>N.id===v);f&&y.set(C,f)}}catch(T){this.y.error(T)}this.z={profiles:E,workspaces:D,emptyWindows:y}}return this.z}D(){const b=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...b,extensionsResource:this.S()??b.extensionsResource,isDefault:!0}}async createTransientProfile(b){const E="Temp",D=new RegExp(`${(0,g.$jf)(E)}\\s(\\d+)`);let y=0;for(const C of this.profiles){const v=D.exec(C.name),f=v?parseInt(v[1]):0;y=f>y?f:y}const T=`${E} ${y+1}`;return this.createProfile((0,r.$uj)((0,m.$3g)()).toString(16),T,{transient:!0},b)}async createNamedProfile(b,E,D){return this.createProfile((0,r.$uj)((0,m.$3g)()).toString(16),b,E,D)}async createProfile(b,E,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const T=await this.F(b,E,D);return y&&await this.setProfileForWorkspace(y,T),T}async F(b,E,D){if(!(0,$.$gg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(E);return y||(y=(async()=>{try{if(this.profiles.find(f=>f.name===E||f.id===b))throw new Error(`Profile with ${E} name already exists`);const C=i(b,E,(0,A.$hh)(this.profilesHome,b),this.g,D,this.defaultProfile);await this.u.createFolder(C.location);const v=[];return this.j.fire({profile:C,join(f){v.push(f)}}),await l.Promises.settled(v),this.I([C],[],[]),C}finally{this.r.delete(E)}})(),this.r.set(E,y)),y}async updateProfile(b,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===b.id);if(!D)throw new Error(`Profile '${b.name}' does not exist`);return D=i(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(b.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(y=>y.id===b.id);if(!E)throw new Error(`Profile '${b.name}' does not exist`);const D=[];this.m.fire({profile:E,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(y){(0,c.$rl)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(b,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(b,D)}unsetWorkspace(b,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(b,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const b=await this.u.resolve(this.profilesHome);await Promise.all((b.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const b=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(b.map(E=>this.removeProfile(E)))}getProfileForWorkspace(b){const E=this.G(b),D=O.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,h.$Qi)(b)?this.s.folders.get(b.uri):(0,h.$Vi)(b)?this.s.workspaces.get(b.configPath):this.s.emptyWindows.get(b.id))}G(b){return(0,h.$Qi)(b)?b.uri:(0,h.$Vi)(b)?b.configPath:b.id}H(b){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,b.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,b.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,b.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,b.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,b.location)))}I(b,E,D){const y=[...this.profiles,...b],T=[],C=this.s.profiles;this.s.profiles=[];for(let v of y){if(v.isDefault||E.some(N=>v.id===N.id))continue;v=D.find(N=>v.id===N.id)??v;const f=C.find(N=>v.id===N.id);if(v.isTransient)this.s.profiles.push(v);else{if(f){for(const[N,F]of this.s.emptyWindows.entries())if(v.id===F.id){this.L({id:N},v);break}for(const[N,F]of this.s.workspaces.entries())if(v.id===F.id){this.L({id:"",configPath:N},v);break}for(const[N,F]of this.s.folders.entries())if(v.id===F.id){this.L({id:"",uri:N},v);break}}T.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags})}}this.P(T),this.z=void 0,this.J(b,E,D)}J(b,E,D){this.h.fire({added:b,removed:E,updated:D,all:this.profiles})}L(b,E,D){if(D=E?.isTransient?!0:D,D)(0,h.$Qi)(b)?(this.s.folders.delete(b.uri),E&&this.s.folders.set(b.uri,E)):(0,h.$Vi)(b)?(this.s.workspaces.delete(b.configPath),E&&this.s.workspaces.set(b.configPath,E)):(this.s.emptyWindows.delete(b.id),E&&this.s.emptyWindows.set(b.id,E));else{this.L(b,void 0,!0);const y=this.G(b);O.URI.isUri(y)?(this.C.workspaces.delete(y),E&&this.C.workspaces.set(y,E)):(this.C.emptyWindows.delete(y),E&&this.C.emptyWindows.set(y,E)),this.M()}}M(){const b={};for(const[D,y]of this.C.workspaces.entries())b[D.toString()]=y.id;const E={};for(const[D,y]of this.C.emptyWindows.entries())E[D.toString()]=y.id;this.R({workspaces:b,emptyWindows:E}),this.z=void 0}N(b){const E={},D=this.D();if(b.workspaces)for(const[T,C]of Object.entries(b.workspaces)){const v=O.URI.parse(C);E[T]=this.w.extUri.isEqual(v,D.location)?D.id:this.w.extUri.basename(v)}const y={};if(b.emptyWindows)for(const[T,C]of Object.entries(b.emptyWindows)){const v=O.URI.parse(C);y[T]=this.w.extUri.isEqual(v,D.location)?D.id:this.w.extUri.basename(v)}return{workspaces:E,emptyWindows:y}}O(){return[]}P(b){throw new Error("not implemented")}Q(){return{}}R(b){throw new Error("not implemented")}S(){}};e.$Pl=s,s.b="userDataProfiles",s.c="profileAssociations",e.$Pl=s=Ye([Ve(0,p.$Ni),Ve(1,c.$al),Ve(2,w.$Kl),Ve(3,S.$ak)],s);class d extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(b){this.a=b}Q(){return this.X}R(b){this.X=b}}e.$Ql=d}),define(Se[153],De([1,0,7,4,3,62,18,193,5,152]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$jq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hq=e.$gq=e.$fq=void 0,e.$iq=P,e.$kq=l,e.$mq=g,e.$fq="__$__isNewStorageMarker",e.$gq="__$__targetStorageMarker",e.$hq=(0,p.$Gi)("storageService");var I;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var S;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var h;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function P($){const n=$.get(e.$gq);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class w extends k.$Xc{constructor(n={flushInterval:w.a}){super(),this.m=n,this.b=this.B(new a.$qe),this.c=this.B(new a.$qe),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$ne),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,t){return a.Event.filter(this.b.event,i=>i.scope===n&&(o===void 0||i.key===o),t)}n(){this.j.value=(0,r.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:t,external:i}=o;if(t===e.$gq){switch(n){case S.APPLICATION:this.H=void 0;break;case S.PROFILE:this.F=void 0;break;case S.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:t,target:this.J(n)[t],external:i})}w(n){this.f.fire({reason:n})}get(n,o,t){return this.P(o)?.get(n,t)}getBoolean(n,o,t){return this.P(o)?.getBoolean(n,t)}getNumber(n,o,t){return this.P(o)?.getNumber(n,t)}getObject(n,o,t){return this.P(o)?.getObject(n,t)}storeAll(n,o){this.y(()=>{for(const t of n)this.store(t.key,t.value,t.scope,t.target,o)})}store(n,o,t,i,s=!1){if((0,O.$pg)(o)){this.remove(n,t,s);return}this.y(()=>{this.z(n,t,i),this.P(t)?.set(n,o,s)})}remove(n,o,t=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,t)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const t=[],i=this.J(n);for(const s of Object.keys(i))i[s]===o&&t.push(s);return t}z(n,o,t,i=!1){const s=this.J(o);typeof t=="number"?s[n]!==t&&(s[n]=t,this.P(o)?.set(e.$gq,JSON.stringify(s),i)):typeof s[n]=="number"&&(delete s[n],this.P(o)?.set(e.$gq,JSON.stringify(s),i))}get D(){return this.C||(this.C=this.L(S.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(S.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(S.APPLICATION)),this.H}J(n){switch(n){case S.APPLICATION:return this.I;case S.PROFILE:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?P(o):Object.create(null)}isNew(n){return this.getBoolean(e.$fq,n)===!0}async flush(n=I.NONE){this.f.fire({reason:n});const o=this.P(S.APPLICATION),t=this.P(S.PROFILE),i=this.P(S.WORKSPACE);switch(n){case I.NONE:await r.Promises.settled([o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(S.APPLICATION)?.items??new Map,o=this.P(S.PROFILE)?.items??new Map,t=this.P(S.WORKSPACE)?.items??new Map;return g(n,o,t,this.Q(S.APPLICATION)??"",this.Q(S.PROFILE)??"",this.Q(S.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(I.NONE),(0,c.$Ll)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||l(o)&&l(n))}N(n,o,t){this.y(()=>{const i=new Set;for(const[s,d]of n)i.add(s),o.get(s)!==d&&this.u(t,{key:s,external:!0});for(const[s]of o.items)i.has(s)||this.u(t,{key:s,external:!0})})}}e.$jq=w,w.a=60*1e3;function l($){return $.isDefault||!!$.useDefaultFlags?.globalState}class m extends w{constructor(){super(),this.U=this.B(new R.$dq(new R.$eq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$dq(new R.$eq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$dq(new R.$eq,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(S.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(S.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(S.APPLICATION,n)))}P(n){switch(n){case S.APPLICATION:return this.U;case S.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case S.APPLICATION:return"inMemory (application)";case S.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$lq=m;async function g($,n,o,t,i,s){const d=f=>{try{return JSON.parse(f)}catch{return f}},u=new Map,b=new Map;$.forEach((f,N)=>{u.set(N,f),b.set(N,d(f))});const E=new Map,D=new Map;n.forEach((f,N)=>{E.set(N,f),D.set(N,d(f))});const y=new Map,T=new Map;o.forEach((f,N)=>{y.set(N,f),T.set(N,d(f))}),console.group(t!==i?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const C=[];if(u.forEach((f,N)=>{C.push({key:N,value:f})}),console.table(C),console.groupEnd(),console.log(b),t!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const f=[];E.forEach((N,F)=>{f.push({key:F,value:N})}),console.table(f),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${s})`);const v=[];y.forEach((f,N)=>{v.push({key:N,value:f})}),console.table(v),console.groupEnd(),console.log(T)}}),define(Se[119],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;class r{constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const A=this.c++;return this.b.set(A,k),this.e(),A}get(k,A){return this.b.has(k)?this.b.get(k)[A]:void 0}delete(k){this.b.delete(k),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$voc=r,r.a=!1}),define(Se[63],De([1,0,15,23,28,5]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=e.$Aoc=void 0;class O{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new a.$9g(p=>{const c=this.b.get(p.scheme);return!(c===void 0||c&k.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,c){c===null?this.b.delete(p.scheme):this.b.set(p.scheme,c)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Aoc=O,e.$Boc=(0,A.$Gi)("IExtHostFileSystemInfo")}),define(Se[30],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0,e.$fQ=(0,r.$Gi)("IExtHostInitDataService")}),define(Se[298],De([1,0,238,12,278,30]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=void 0;let O=class extends k.$qR{constructor(p,c,I){const S=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",h=I.remote.isRemote?(0,r.localize)(0,null):p?(0,r.localize)(1,null):(0,r.localize)(2,null);super(c.createLogger(S,{name:h}))}};e.$Jqc=O,e.$Jqc=O=Ye([Ve(1,a.$bk),Ve(2,A.$fQ)],O)}),define(Se[299],De([1,0,7]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=e.$gpc=void 0;class a{constructor(O,R,p){this.h=new Map,this.a=O,this.b=R,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new r.$Sh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of c.values())I.complete()}catch(I){for(const S of c.values())S.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,O])=>O!==void 0).map(([O])=>O)}get whenReady(){return this.d}get(O,R){let p=this.f[O];return typeof p>"u"&&(p=R),p}update(O,R){this.f[O]=R;const p=this.h.get(O);if(p!==void 0)return p.p;const c=new r.$4h;return this.h.set(O,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$gpc=a;class k extends a{setKeysForSync(O){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},O)}constructor(O,R){super(O.identifier.value,!0,R),this.j=O}}e.$hpc=k}),define(Se[300],De([1,0,4,2]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=void 0;class k{constructor(O){this.c=O,this.a=new r.$ne,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$ne,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(O,R,p,c){const S=this.c.getNotebookDocument(a.URI.revive(O)).acceptModelChanged(R.value,p,c);this.b.fire(S)}$acceptDirtyStateChanged(O,R){this.c.getNotebookDocument(a.URI.revive(O)).acceptDirty(R)}$acceptModelSaved(O){const R=this.c.getNotebookDocument(a.URI.revive(O));this.a.fire(R.apiNotebook)}}e.$bqc=k}),define(Se[20],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.$2P=void 0,e.$2P=(0,r.$Gi)("IExtHostRpcService");class a{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$3P=a});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[301],De([1,0,24,4,3]),function(ie,e,r,a,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=void 0;class O{constructor(p,c){A.set(this,void 0),this.disposables=new k.$Wc,this.a=r.$sn.toKey(p.identifier),ot(this,A,c,"f"),this.onDidChange=a.Event.map(a.Event.filter(He(this,A,"f").onDidChangePassword,I=>I.extensionId===this.a),I=>({key:I.key}),this.disposables)}dispose(){this.disposables.dispose()}get(p){return He(this,A,"f").get(this.a,p)}store(p,c){return He(this,A,"f").store(this.a,p,c)}delete(p){return He(this,A,"f").delete(this.a,p)}}e.$qpc=O,A=new WeakMap}),define(Se[73],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=e.$Qoc=void 0,e.$Qoc=(0,r.$Gi)("IURITransformerService");class a{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=O=>O,this.transformOutgoing=O=>O,this.transformOutgoingURI=O=>O,this.transformOutgoingScheme=O=>O)}}e.$Roc=a}),define(Se[302],De([1,0,120,412,413,68,2,12,414]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=I,r=Ue(r),a=Ue(a),k=Ue(k),A=Ue(A);const c=!1;function I(n,o,t,i,s,d){const u=d.environment.useHostProxy,b=typeof u=="boolean"?u:!d.remote.isRemote,E={resolveProxy:T=>n.resolveProxy(T),lookupProxyAuthorization:m.bind(void 0,i,s,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",getNoProxyConfig:()=>o.getConfiguration("http").get("noProxy")||[],addCertificatesV1:()=>h(o),addCertificatesV2:()=>P(o),log:i,getLogLevel:()=>{const T=i.getLevel();switch(T){case R.LogLevel.Trace:return p.LogLevel.Trace;case R.LogLevel.Debug:return p.LogLevel.Debug;case R.LogLevel.Info:return p.LogLevel.Info;case R.LogLevel.Warning:return p.LogLevel.Warning;case R.LogLevel.Error:return p.LogLevel.Error;case R.LogLevel.Off:return p.LogLevel.Off;default:return C(T)}function C(v){return i.error("Unknown log level",v),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:b,loadAdditionalCertificates:async()=>{const T=[];if(d.remote.isRemote&&T.push((0,p.loadSystemCertificates)({log:i})),b){i.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const C=n.loadCertificates();C.then(v=>i.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",v.length)),T.push(C)}return d.environment.extensionTestsLocationURI&&a.globalAgent.testCertificates?.length&&(i.trace("ProxyResolver#loadAdditionalCertificates: Loading test certificates"),T.push(Promise.resolve(a.globalAgent.testCertificates))),(await Promise.all(T)).flat()},env:process.env},D=(0,p.createProxyResolver)(E),y=S(E,D);return l(t,y)}function S(n,o){function t(i,s){return Object.assign(i.default||i,s)}return{http:t(r,(0,p.createHttpPatch)(n,r,o)),https:t(a,(0,p.createHttpPatch)(n,a,o)),net:t(A,(0,p.createNetPatch)(n,A)),tls:t(k,(0,p.createTlsPatch)(n,k))}}function h(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",c)&&!!o.get("systemCertificates")}function P(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",c)&&!!o.get("systemCertificates")}const w=new Map;function l(n,o){return n.getExtensionPathIndex().then(t=>{const i=globalThis._VSCODE_NODE_MODULES.module,s=i._load;i._load=function(u,b,E){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return s.apply(this,arguments);const D=t.findSubstr(O.URI.file(b.filename));let y=w.get(D);if(y||w.set(D,y={}),!y[u]){const T=o[u];y[u]={...T}}return y[u]}})}async function m(n,o,t,i,s,d,u,b){const E=i[d];u&&(i[d]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${E}`);const D=u||E,y=Array.isArray(D)?D:typeof D=="string"?[D]:[];if($(o,y,s),y.some(T=>/^(Negotiate|Kerberos)( |$)/i.test(T))&&!b.kerberosRequested)try{b.kerberosRequested=!0;const T=await new Promise((F,j)=>{ie(["kerberos"],F,j)}).then(Ue),C=new URL(d),v=t.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${C.hostname}`:`HTTP@${C.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${v}`),"Negotiate "+await(await T.initializeClient(v)).step("")}catch(T){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",T)}}let g=!1;function $(n,o,t){g||!o.length||(g=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(i=>i.split(" ")[0]).join(","),extensionHostType:t?"remote":"local"}))}}),define(Se[303],De([1,0,140]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=k;function a(A){return{transformIncoming:O=>O.scheme==="vscode-remote"?{scheme:"file",path:O.path,query:O.query,fragment:O.fragment}:O.scheme==="file"?{scheme:"vscode-local",path:O.path,query:O.query,fragment:O.fragment}:O,transformOutgoing:O=>O.scheme==="file"?{scheme:"vscode-remote",authority:A,path:O.path,query:O.query,fragment:O.fragment}:O.scheme==="vscode-local"?{scheme:"file",path:O.path,query:O.query,fragment:O.fragment}:O,transformOutgoingScheme:O=>O==="file"?"vscode-remote":O==="vscode-local"?"file":O}}function k(A){return new r.$Nn(a(A))}});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[154],De([1,0,248,18,2,3,5,37,28,15,51,212,45]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$fG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$8F=e.EditorInputCapabilities=e.$7F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0,e.$XF=l,e.$YF=m,e.$ZF=g,e.$1F=$,e.$2F=n,e.$3F=o,e.$4F=t,e.$5F=i,e.$6F=s,e.$9F=y,e.$0F=C,e.$$F=v,e.$_F=f,e.$aG=N,e.$bG=F,e.$cG=j,e.$dG=z,e.$eG=q,e.$gG=re,e.$hG=Z,e.$iG=$e,e.$jG=fe,h=qt(h),e.$SF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TF={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.$UF="workbench.editor.sidebysideEditor",e.$VF="workbench.editors.textDiffEditor",e.$WF="workbench.editors.binaryResourceDiffEditor";var P;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(P||(e.EditorPaneSelectionChangeReason=P={}));var w;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function l(oe){const H=oe;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}function m(oe){const H=oe;return!!H&&typeof H.getScrollPosition=="function"&&typeof H.setScrollPosition=="function"&&!!H.onDidChangeScroll}function g(oe,H,ue){for(const te of ue.visibleEditorPanes)if(te.group.id===H&&oe.matches(te.input))return te.getViewState()}function $(oe){if(y(oe))return!1;const H=oe;return k.URI.isUri(H?.resource)}function n(oe){if(y(oe))return!1;const H=oe;return H?.original!==void 0&&H.modified!==void 0}function o(oe){if(y(oe))return!1;const H=oe;return!H||H.resources&&!Array.isArray(H.resources)?!1:!!H.resources||!!H.multiDiffSource}function t(oe){if(y(oe)||n(oe))return!1;const H=oe;return H?.primary!==void 0&&H.secondary!==void 0}function i(oe){if(y(oe))return!1;const H=oe;return H?H.resource===void 0||H.resource.scheme===c.Schemas.untitled||H.forceUntitled===!0:!1}function s(oe){if(y(oe))return!1;const H=oe;return k.URI.isUri(H?.base?.resource)&&k.URI.isUri(H?.input1?.resource)&&k.URI.isUri(H?.input2?.resource)&&k.URI.isUri(H?.result?.resource)}var d;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var u;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class b{constructor(){this.a=new Map}registerSource(H,ue){let te=this.a.get(H);return te||(te={source:H,label:ue},this.a.set(H,te)),te.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.$7F=new b;var E;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends A.$Xc{}e.$8F=D;function y(oe){return oe instanceof D}function T(oe){const H=oe;return k.URI.isUri(H?.preferredResource)}function C(oe){const H=oe;return y(H?.primary)&&y(H?.secondary)}function v(oe){const H=oe;return y(H?.modified)&&y(H?.original)}function f(oe,H,ue,te,_){return fe(te,[(0,S.$qj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const ne={...ue,limits:{size:Number.MAX_VALUE}};oe.openEditor(H,ne)}}),(0,S.$qj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>_.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}function N(oe){return y(oe?.editor)}function F(oe){const H=oe;return N(oe)&&H?.group!==void 0}function j(oe){const H=oe;return typeof H?.groupId=="number"&&y(H.editor)}function z(oe){return typeof oe?.groupId=="number"}var M;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var L;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITORS_SELECTION=4]="EDITORS_SELECTION",oe[oe.EDITOR_OPEN=5]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=6]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=7]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=9]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=11]="EDITOR_PIN",oe[oe.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",oe[oe.EDITOR_STICKY=13]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=14]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var B;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class W{getOriginalUri(H,ue){if(!H)return;if(s(H))return e.$fG.getOriginalUri(H.result,ue);if(ue?.supportSideBySide){const{primary:_,secondary:ne}=this.a(H);if(_&&ne){if(ue?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(_,{filterByScheme:ue.filterByScheme}),secondary:this.getOriginalUri(ne,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===B.ANY)return this.getOriginalUri(_,{filterByScheme:ue.filterByScheme})??this.getOriginalUri(ne,{filterByScheme:ue.filterByScheme});H=ue.supportSideBySide===B.PRIMARY?_:ne}}if(n(H)||o(H)||t(H)||s(H))return;const te=T(H)?H.preferredResource:H.resource;return!te||!ue||!ue.filterByScheme?te:this.b(te,ue.filterByScheme)}a(H){return C(H)||t(H)?{primary:H.primary,secondary:H.secondary}:v(H)||n(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,ue){if(!H)return;if(s(H))return e.$fG.getCanonicalUri(H.result,ue);if(ue?.supportSideBySide){const{primary:_,secondary:ne}=this.a(H);if(_&&ne){if(ue?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(_,{filterByScheme:ue.filterByScheme}),secondary:this.getCanonicalUri(ne,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===B.ANY)return this.getCanonicalUri(_,{filterByScheme:ue.filterByScheme})??this.getCanonicalUri(ne,{filterByScheme:ue.filterByScheme});H=ue.supportSideBySide===B.PRIMARY?_:ne}}if(n(H)||o(H)||t(H)||s(H))return;const te=H.resource;return!te||!ue||!ue.filterByScheme?te:this.b(te,ue.filterByScheme)}b(H,ue){if(Array.isArray(ue)){if(ue.some(te=>H.scheme===te))return H}else if(ue===H.scheme)return H}}var ae;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(ae||(e.EditorCloseMethod=ae={}));function q(oe,H,ue,te){if(!oe.isSticky(H))return!1;switch(te.preventPinnedEditorClose){case"keyboardAndMouse":return ue===ae.MOUSE||ue===ae.KEYBOARD;case"mouse":return ue===ae.MOUSE;case"keyboard":return ue===ae.KEYBOARD}return!1}e.$fG=new W;var K;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class ee{constructor(){this.c=new Map,this.d=new Map}start(H){const ue=this.a=H.get(O.$Fi);for(const[te,_]of this.c)this.e(te,_,ue);this.c.clear()}e(H,ue,te){const _=te.createInstance(ue);this.d.set(H,_)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,a.$rg)(this.b)}registerEditorSerializer(H,ue){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,ue,this.a):this.c.set(H,ue),(0,A.$Vc)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}R.$so.add(e.$SF.EditorFactory,new ee);async function re(oe,H,ue){return!oe||!oe.length?[]:await Promise.all(oe.map(async te=>{const _=k.URI.revive(te.fileUri);if(!_){ue.info("Cannot resolve the path because it is not valid.",te);return}if(!await H.canHandleResource(_)){ue.info("Cannot resolve the path because it cannot be handled",te);return}let le=te.exists,J=te.type;if(typeof le!="boolean"||typeof J!="number")try{J=(await H.stat(_)).isDirectory?p.FileType.Directory:p.FileType.Unknown,le=!0}catch(me){ue.error(me),le=!1}if(!le&&te.openOnlyIfExists){ue.info("Cannot resolve the path because it does not exist",te);return}if(J===p.FileType.Directory){ue.info("Cannot resolve the path because it is a directory",te);return}const ce={...te.options,pinned:!0};return le?{resource:_,options:ce}:{resource:_,options:ce,forceUntitled:!0}}))}var ge;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(ge||(e.EditorsOrder=ge={}));function Z(oe){const H=oe;if(!H)return!1;const ue=H;if(ue.modified)return Z(ue.modified);const te=H;return!!(te.contributionsState&&te.viewState&&Array.isArray(te.cursorState))}function $e(oe){return(0,I.$sj)(oe)}function fe(oe,H,ue){const te=(0,I.$tj)(oe,H);return te.forceMessage=ue?.forceMessage,te.forceSeverity=ue?.forceSeverity,te.allowDialog=ue?.allowDialog,te}}),define(Se[304],De([1,0,4,249,5,3,29,37,25,83,294]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$pG=e.ViewContentGroups=e.$nG=e.ViewContainerLocation=e.Extensions=e.$mG=e.$lG=e.$kG=void 0,e.$oG=P,e.$kG="views",e.$lG=(0,a.localize)(0,null),e.$mG=(0,I.$zx)("default-view-icon",c.$6j.window,(0,a.localize)(1,null));var S;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var h;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(h||(e.ViewContainerLocation=h={})),e.$nG=[h.Sidebar,h.Panel,h.AuxiliaryBar];function P(i){switch(i){case h.Sidebar:return"sidebar";case h.Panel:return"panel";case h.AuxiliaryBar:return"auxiliarybar"}}class w extends A.$Xc{constructor(){super(...arguments),this.c=this.B(new r.$ne),this.onDidRegister=this.c.event,this.f=this.B(new r.$ne),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(s,d,u){const b=this.get(s.id);if(b)return b;const E=s;return E.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,O.$Ac)(this.g,d,[]).push(E),u?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:d}),E}deregisterViewContainer(s){for(const d of this.g.keys()){const u=this.g.get(d),b=u?.indexOf(s);if(b!==-1){u?.splice(b,1),u.length===0&&this.g.delete(d),this.f.fire({viewContainer:s,viewContainerLocation:d});return}}}get(s){return this.all.filter(d=>d.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(u=>u?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(d=>this.getViewContainerLocation(d)===s)}}R.$so.add(S.ViewContainersRegistry,new w);var l;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(l||(e.ViewContentGroups=l={}));function m(i,s){const d=i.group??l.More,u=s.group??l.More;return d!==u?d.localeCompare(u):(i.order??5)-(s.order??5)}class g extends A.$Xc{constructor(){super(...arguments),this.c=this.B(new r.$ne),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$ne),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$ne),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$ne),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new O.$Kc}registerViews(s,d){this.registerViews2([{views:s,viewContainer:d}])}registerViews2(s){s.forEach(({views:d,viewContainer:u})=>this.r(d,u)),this.c.fire(s)}deregisterViews(s,d){const u=this.s(s,d);u.length&&this.f.fire({views:u,viewContainer:d})}moveViews(s,d){for(const u of this.m.keys())if(u!==d){const b=this.s(s,u);b.length&&(this.r(b,d),this.g.fire({views:b,from:u,to:d}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const d of this.j){const u=(this.m.get(d)||[]).filter(b=>b.id===s)[0];if(u)return u}return null}getViewContainer(s){for(const d of this.j)if((this.m.get(d)||[]).filter(b=>b.id===s)[0])return d;return null}registerViewWelcomeContent(s,d){return this.n.add(s,d),this.h.fire(s),(0,A.$Vc)(()=>{this.n.delete(s,d),this.h.fire(s)})}registerViewWelcomeContent2(s,d){const u=new Map;for(const[b,E]of d)this.n.add(s,E),u.set(b,(0,A.$Vc)(()=>{this.n.delete(s,E),this.h.fire(s)}));return this.h.fire(s),u}getViewWelcomeContent(s){const d=[];return this.n.forEach(s,u=>d.push(u)),d.sort(m)}r(s,d){let u=this.m.get(d);u||(u=[],this.m.set(d,u),this.j.push(d));for(const b of s){if(this.getView(b.id)!==null)throw new Error((0,a.localize)(2,null,b.id));u.push(b)}}s(s,d){const u=this.m.get(d);if(!u)return[];const b=[],E=[];for(const D of u)s.includes(D)?b.push(D):E.push(D);return b.length&&(E.length?this.m.set(d,E):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),b}}R.$so.add(S.ViewsRegistry,new g),e.$pG=(0,k.$Gi)("viewDescriptorService");var $;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})($||(e.ViewVisibilityState=$={}));var n;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,d){this.c=!1,this.d=!1,(0,p.$io)(this,s),this.d=!!d,this.resolve=async u=>{if(d&&!this.c){const b=await d(u);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$qG=o;class t extends Error{constructor(s){super((0,a.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$rG=t}),define(Se[305],De([1,0,250,36]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=void 0,e.$vG=new a.$Xj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.$wG=new a.$Xj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.$xG=new a.$Xj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.$yG=new a.$Xj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.$zG=new a.$Xj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.$AG=new a.$Xj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.$BG=new a.$Xj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.$CG=new a.$Xj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.$DG=new a.$Xj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.$EG=new a.$Xj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.$FG=new a.$Xj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.$GG=new a.$Xj("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.$HG=new a.$Xj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.$IG=new a.$Xj("chatCursorAtTop",!1),e.$JG=new a.$Xj("chatInputHasAgent",!1),e.$KG=new a.$Xj("chatLocation",void 0),e.$LG=new a.$Xj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(Se[306],De([1,0,133,7,21,4,40,3,55,182,13,36,24,5,12,116,287,153,305]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.ChatAgentLocation=void 0,e.$PH=d,e.$QH=u;var o;(function(b){b.Panel="panel",b.Terminal="terminal",b.Notebook="notebook",b.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(b){function E(D){switch(D){case"panel":return b.Panel;case"terminal":return b.Terminal;case"notebook":return b.Notebook;case"editor":return b.Editor}return b.Panel}b.fromRaw=E}(o||(e.ChatAgentLocation=o={})),e.$KH=(0,P.$Gi)("chatAgentService");let t=class{constructor(E){this.f=E,this.b=new Map,this.d=new A.$ne,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=$.$HG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const T=this,C=D.slashCommands;D={...D,get slashCommands(){return C.filter(f=>!f.when||T.f.contextMatchesRules(S.$Ej.deserialize(f.when)))}};const v={data:D};return this.b.set(E,v),(0,R.$Vc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const y=this.b.get(E);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new i(y.data,D)),(0,R.$Vc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const y={data:E,impl:D};return this.b.set(E.id,y),this.d.fire(new i(E,D)),(0,R.$Vc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,y){return await this.g.get(E)?.(D,y)??[]}updateAgent(E,D){const y=this.b.get(E);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new i(y.data,y.impl))}getDefaultAgent(E){return(0,r.$ib)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return O.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(S.$Ej.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=O.Iterable.find(this.b.values(),y=>d(y.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new i(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(y=>y.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,y,T,C){const v=this.b.get(E);if(!v?.impl)throw new Error(`No activated agent with id "${E}"`);return await v.impl.invoke(D,y,T,C)}async getFollowups(E,D,y,T,C){const v=this.b.get(E);if(!v?.impl)throw new Error(`No activated agent with id "${E}"`);return v.impl?.provideFollowups?v.impl.provideFollowups(D,y,T,C):[]}};e.$LH=t,t.AGENT_LEADER="@",e.$LH=t=Ye([Ve(0,S.$Yj)],t);class i{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(E,D,y,T){return this.d.invoke(E,D,y,T)}async provideFollowups(E,D,y,T){return this.d.provideFollowups?this.d.provideFollowups(E,D,y,T):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$MH=i,e.$NH=(0,P.$Gi)("chatAgentNameService");let s=n=class{constructor(E,D,y,T){if(this.g=D,this.h=y,this.i=T,this.e=(0,c.$8d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const C=T.get(n.b,g.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{T.remove(n.b,g.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,a.$Hh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},k.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,m.$aq)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(n.b,JSON.stringify(y),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),y=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&y}l(E,D){return this.e.map(T=>T[E.toLowerCase()]).map(T=>T?T.some(C=>(0,I.$Hf)(C,C.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$OH=s,s.b="chat.participantNameRegistry",e.$OH=s=n=Ye([Ve(0,l.$tk),Ve(1,m.$7p),Ve(2,w.$ak),Ve(3,g.$hq)],s);function d(b){return`${b.extensionId.value}.${b.id}`}function u(b){const E="name"in b?b:{...b,name:b.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new h.$sn("")),(0,p.$di)(E)}}),define(Se[307],De([1,0,2,31,5]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jH=e.$iH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$gH=A,e.$hH=O;function A(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof r.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(a.$Nt.isIRange)}function O(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(A)}var R;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(R||(e.ChatAgentVoteDirection=R={}));var p;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$iH=(0,k.$Gi)("IChatService"),e.$jH="accessibility.voice.keywordActivation"}),define(Se[155],De([1,0,4,7,252]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vtb=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new r.$ne,this.o=new r.$ne,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(R){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=R}onEvent(R){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=R}onRequest(R){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.u("response",R)}sendRequest(R,p,c,I){const S={command:R};if(p&&Object.keys(p).length>0&&(S.arguments=p),this.u("request",S),typeof I=="number"){const h=setTimeout(()=>{clearTimeout(h);const P=this.f.get(S.seq);if(P){this.f.delete(S.seq);const w={type:"response",seq:0,request_seq:S.seq,success:!1,command:R,message:(0,k.localize)(0,null,I,R)};P(w)}},I)}return c&&this.f.set(S.seq,c),S.seq}acceptMessage(R){this.k?this.k(R):(this.m.push(R),this.m.length===1&&this.s())}q(R,p){return R.type!=="event"||p.type!=="event"}async s(){let R;for(;this.m.length;){if((!R||this.q(this.m[0],R))&&await(0,a.$Hh)(0),R=this.m.shift(),!R)return;switch(R.type){case"event":this.j?.(R);break;case"request":this.g?.(R);break;case"response":{const p=R,c=this.f.get(p.request_seq);c&&(this.f.delete(p.request_seq),c(p));break}}}}u(R,p){p.type=R,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((p,c)=>R.set(c,p)),await(0,a.$Hh)(500),R.forEach((p,c)=>{p({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Vtb=A}),define(Se[121],De([1,0,2,253,36,5]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$DK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$BK=e.MemoryRangeType=e.State=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=void 0,e.$AK=p,e.$CK=I,a=Ue(a),e.$oJ="workbench.view.debug",e.$pJ="workbench.debug.variablesView",e.$qJ="workbench.debug.watchExpressionsView",e.$rJ="workbench.debug.callStackView",e.$sJ="workbench.debug.loadedScriptsView",e.$tJ="workbench.debug.breakPointsView",e.$uJ="workbench.debug.disassemblyView",e.$vJ="workbench.panel.repl",e.$wJ="workbench.panel.repl.view",e.$xJ=new k.$Xj("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.$yJ=new k.$Xj("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.$zJ=new k.$Xj("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.$AJ="debugUx",e.$BJ=new k.$Xj(e.$AJ,"default",{type:"string",description:a.localize(3,null)}),e.$CJ=new k.$Xj("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.$DJ=new k.$Xj("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.$EJ=new k.$Xj("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.$FJ=new k.$Xj("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.$GJ=new k.$Xj("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.$HJ=new k.$Xj("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.$IJ=new k.$Xj("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.$JJ=new k.$Xj("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.$KJ=new k.$Xj("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.$LJ=new k.$Xj("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.$MJ=new k.$Xj("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.$NJ=new k.$Xj("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.$OJ=new k.$Xj("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.$PJ=new k.$Xj("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.$QJ=new k.$Xj("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.$RJ=new k.$Xj("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.$SJ=new k.$Xj("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.$TJ=new k.$Xj("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.$UJ=new k.$Xj("breakpointItemBytes",void 0,{type:"boolean",description:a.localize(22,null)}),e.$VJ=new k.$Xj("breakpointHasModes",!1,{type:"boolean",description:a.localize(23,null)}),e.$WJ=new k.$Xj("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(24,null)}),e.$XJ=new k.$Xj("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(25,null)}),e.$YJ=new k.$Xj("loadedScriptsItemType",void 0,{type:"string",description:a.localize(26,null)}),e.$ZJ=new k.$Xj("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(27,null)}),e.$1J=new k.$Xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:a.localize(28,null)}),e.$2J=new k.$Xj("stepBackSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.$3J=new k.$Xj("restartFrameSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.$4J=new k.$Xj("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(31,null)}),e.$5J=new k.$Xj("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(32,null)}),e.$6J=new k.$Xj("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(33,null)}),e.$7J=new k.$Xj("breakpointsExist",!1,{type:"boolean",description:a.localize(34,null)}),e.$8J=new k.$Xj("debuggersAvailable",!1,{type:"boolean",description:a.localize(35,null)}),e.$9J=new k.$Xj("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(36,null)}),e.$0J=new k.$Xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(37,null)}),e.$$J=new k.$Xj("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.$_J=new k.$Xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.$aK=new k.$Xj("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.$bK=new k.$Xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.$cK=new k.$Xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(42,null)}),e.$dK=new k.$Xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(43,null)}),e.$eK=new k.$Xj("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(44,null)}),e.$fK=new k.$Xj("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(45,null)}),e.$gK=new k.$Xj("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(46,null)}),e.$hK=new k.$Xj("variableIsReadonly",!1,{type:"boolean",description:a.localize(47,null)}),e.$iK=new k.$Xj("variableValue",!1,{type:"string",description:a.localize(48,null)}),e.$jK=new k.$Xj("variableType",!1,{type:"string",description:a.localize(49,null)}),e.$kK=new k.$Xj("variableInterfaces",!1,{type:"array",description:a.localize(50,null)}),e.$lK=new k.$Xj("variableName",!1,{type:"string",description:a.localize(51,null)}),e.$mK=new k.$Xj("variableLanguage",!1,{type:"string",description:a.localize(52,null)}),e.$nK=new k.$Xj("variableExtensionId",!1,{type:"string",description:a.localize(53,null)}),e.$oK=new k.$Xj("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(54,null)}),e.$pK=new k.$Xj("multiSessionRepl",!1,{type:"boolean",description:a.localize(55,null)}),e.$qK=new k.$Xj("multiSessionDebug",!1,{type:"boolean",description:a.localize(56,null)}),e.$rK=new k.$Xj("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(57,null)}),e.$sK=new k.$Xj("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(58,null)}),e.$tK=new k.$Xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(59,null)}),e.$uK=new k.$Xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(60,null)});const O=n=>a.localize(61,null,n);e.$vK=O,e.$wK="editor.contrib.debug",e.$xK="editor.contrib.breakpoint",e.$yK="debug",e.$zK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(62,null)};var R;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(R||(e.State=R={}));function p(n){switch(n){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var c;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$BK="vscode-debug-memory";function I(n){const o=n.presentationHint??n.source.presentationHint;return o==="deemphasize"||o==="subtle"}var S;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var h;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(h||(e.DebugConfigurationProviderTriggerKind=h={}));var P;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$DK=(0,A.$Gi)("debugService");var w;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var l;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(l||(e.DebugVisualizationType=l={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var g;(function(n){n.deserialize=o=>o,n.serialize=o=>o})(g||(e.IDebugVisualizationTreeItem=g={}));var $;(function(n){n.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:r.URI.revive(o.iconPath.light),dark:r.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),n.serialize=o=>o})($||(e.IDebugVisualization=$={}))}),define(Se[308],De([1,0,13,2,17,25,15,31,21,19]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8H=void 0,e.$VH=S,e.$WH=h,e.$XH=P,e.$YH=w,e.$ZH=l,e.$1H=m,e.$2H=g,e.$3H=n,e.$4H=i,e.$5H=s,e.$6H=u,e.$7H=E;const I=/{([^}]+)}/g;function S(y,T,C){return y.replace(I,function(v,f){return T&&f.length>0&&f[0]!=="_"?v:C&&C.hasOwnProperty(f)?C[f]:v})}function h(y){const T={};for(const C of Object.keys(y))C.startsWith("!")||(T[C]=y[C]);return T}function P(y){return y.configuration.request==="attach"&&!w(y)&&(!y.parentSession||P(y.parentSession))}function w(y){let T=y.configuration.type;if(T)return T==="vslsShare"&&(T=y.configuration.adapterProxy.configuration.type),(0,r.$Hf)(T,"extensionhost")||(0,r.$Hf)(T,"pwa-extensionhost")?y:y.parentSession?w(y.parentSession):void 0}function l(y){return y.type&&(y.label||y.program||y.runtime)}function m(y,T,C){let v,f=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=N.exec(y);){const j=F.index+1,z=j+F[0].length;if(j<=T&&z>=C){v=F[0],f=j;break}}if(v){const j=/\w+/g;let z=null;for(;(z=j.exec(v))&&!(z.index+1+f+z[0].length>=C););z&&(v=v.substring(0,j.lastIndex))}return v?{start:f,end:f+v.length-1}:{start:0,end:0}}async function g(y,T,C,v){if(y.evaluatableExpressionProvider.has(T)){const f=y.evaluatableExpressionProvider.ordered(T),N=(0,c.$Kb)(await Promise.all(f.map(async F=>{try{return await F.provideEvaluatableExpression(T,C,v??p.CancellationToken.None)}catch{return}})));if(N.length>0){let F=N[0].expression;const j=N[0].range;return F||(F=T.getLineContent(C.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:F}}}else{const f=T.getLineContent(C.lineNumber),{start:N,end:F}=m(f,C.column,C.column),j=f.substring(N-1,F);return{matchingExpression:j,range:new R.$Nt(C.lineNumber,N,C.lineNumber,N+j.length)}}return null}const $=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(y){return!!(y&&y.match($))}function o(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(n(y.path))return a.URI.parse(y.path);if((0,k.$lc)(y.path))return a.URI.file(y.path)}return y.path}function t(y){if(typeof y.path=="object"){const T=a.URI.revive(y.path);if(T)return T.scheme===O.Schemas.file?T.fsPath:T.toString()}return y.path}function i(y,T){const C=T?o:t,v=(0,A.$fo)(y);return d(v,(f,N)=>{f&&N&&(N.path=C(N))}),v}function s(y,T){const C=T?o:t,v=(0,A.$fo)(y);return d(v,(f,N)=>{!f&&N&&(N.path=C(N))}),v}function d(y,T){switch(y.type){case"event":{const C=y;switch(C.event){case"output":T(!1,C.body.source);break;case"loadedSource":T(!1,C.body.source);break;case"breakpoint":T(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=y;switch(C.command){case"setBreakpoints":T(!0,C.arguments.source);break;case"breakpointLocations":T(!0,C.arguments.source);break;case"source":T(!0,C.arguments.source);break;case"gotoTargets":T(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(v=>T(!1,v));break;default:break}break}case"response":{const C=y;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(v=>T(!1,v.source));break;case"loadedSources":C.body.sources.forEach(v=>T(!1,v));break;case"scopes":C.body.scopes.forEach(v=>T(!1,v.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(v=>T(!1,v.source));break;case"setBreakpoints":C.body.breakpoints.forEach(v=>T(!1,v.source));break;case"disassemble":C.body?.instructions.forEach(f=>T(!1,f.location));break;default:break}break}}}function u(y){return y.filter(T=>!T.presentation?.hidden).sort((T,C)=>T.presentation?C.presentation?T.presentation.group?C.presentation.group?T.presentation.group!==C.presentation.group?T.presentation.group.localeCompare(C.presentation.group):b(T.presentation.order,C.presentation.order):-1:C.presentation.group?1:b(T.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function b(y,T){return typeof y!="number"?typeof T!="number"?0:1:typeof T!="number"?-1:y-T}async function E(y,T){const C=y.getValue("debug.saveBeforeStart",{overrideIdentifier:T.activeTextEditorLanguageId});if(C!=="none"&&(await T.saveAll(),C==="allEditorsInActiveGroup")){const v=T.activeEditorPane;v&&v.input.resource?.scheme===O.Schemas.untitled&&await T.save({editor:v.input,groupId:v.group.id})}await y.reloadConfiguration()}const D=(y,T)=>!y||!T?y===T:y.name===T.name&&y.path===T.path&&y.sourceReference===T.sourceReference;e.$8H=D}),define(Se[309],De([1,0,56,68,25,17,11,13,34,254,155]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tqc=e.$Sqc=e.$Rqc=e.$Qqc=e.$Pqc=void 0,r=Ue(r),a=Ue(a),k=Ue(k),A=Ue(A),O=Ue(O),R=Ue(R),c=Ue(c);class S extends I.$Vtb{constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(g,$){this.l=$,this.p=Buffer.allocUnsafe(0),this.r=-1,g.on("data",n=>this.v(n))}sendMessage(g){if(this.l){const $=JSON.stringify(g);this.l.write(`Content-Length: ${Buffer.byteLength($,"utf8")}${S.a}${$}`,"utf8")}}v(g){for(this.p=Buffer.concat([this.p,g]);;){if(this.r>=0){if(this.p.length>=this.r){const $=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,$.length>0)try{this.acceptMessage(JSON.parse($))}catch(n){this.n.fire(new Error((n.message||n)+`
`+$))}continue}}else{const $=this.p.indexOf(S.a);if($!==-1){const o=this.p.toString("utf8",0,$).split(S.b);for(const t of o){const i=t.split(S.i);i[0]==="Content-Length"&&(this.r=Number(i[1]))}this.p=this.p.slice($+S.a.length);continue}}break}}}e.$Pqc=S,S.a=`\r
\r
`,S.b=/\r?\n/,S.i=/: */;class h extends S{startSession(){return new Promise((g,$)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),g(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):$(new Error("connection closed"))}),this.x.on("error",o=>{n?this.n.fire(o):$(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Qqc=h;class P extends h{constructor(g){super(),this.z=g}y(g){return a.createConnection(this.z.port,this.z.host||"127.0.0.1",g)}}e.$Rqc=P;class w extends h{constructor(g){super(),this.z=g}y(g){return a.createConnection(this.z.path,g)}}e.$Sqc=w;class l extends S{constructor(g,$){super(),this.y=g,this.z=$}async startSession(){const g=this.y.command,$=this.y.args,n=this.y.options||{};try{if(g)if(A.$lc(g)){if(!await p.Promises.exists(g))throw new Error(c.localize(0,null,g))}else g.indexOf("/")<0&&g.indexOf("\\")<0;else throw new Error(c.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=k.$io(k.$fo(process.env),n.env)),g==="node")if(Array.isArray($)&&$.length>0){const t=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:o,execArgv:t?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(i.cwd=n.cwd);const s=r.fork($[0],$.slice(1),i);if(!s.pid)throw new Error(c.localize(2,null,$[0]));this.x=s}else throw new Error(c.localize(3,null));else{const t={env:o};n.cwd&&(t.cwd=n.cwd),this.x=r.spawn(g,$,t)}this.x.on("error",t=>{this.n.fire(t)}),this.x.on("exit",(t,i)=>{this.o.fire(t)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",t=>{this.n.fire(t)}),this.x.stdin.on("error",t=>{this.n.fire(t)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),O.$c?new Promise((g,$)=>{const n=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,t,i){if(o)return $(o)});n.on("exit",g),n.on("error",$)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(g,$){if(!g)return;const n=Object.create(null);g.runtime&&(g.runtime.indexOf("./")===0?n.runtime=A.$mc($,g.runtime):n.runtime=g.runtime),g.runtimeArgs&&(n.runtimeArgs=g.runtimeArgs),g.program&&(A.$lc(g.program)?n.program=g.program:n.program=A.$mc($,g.program)),g.args&&(n.args=g.args);const o=g;return o.win&&(n.win=l.A(o.win,$)),o.winx86&&(n.winx86=l.A(o.winx86,$)),o.windows&&(n.windows=l.A(o.windows,$)),o.osx&&(n.osx=l.A(o.osx,$)),o.linux&&(n.linux=l.A(o.linux,$)),n}static platformAdapterExecutable(g,$){let n=Object.create(null);$=$.toLowerCase();for(const u of g)if(u.contributes){const b=u.contributes.debuggers;b&&b.length>0&&b.filter(E=>typeof E.type=="string"&&R.$Hf(E.type,$)).forEach(E=>{const D=l.A(E,u.extensionLocation.fsPath);n=k.$io(n,D,u.isBuiltin)})}let o;O.$c&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:O.$c?o=n.win||n.windows:O.$d?o=n.osx:O.$e&&(o=n.linux),o=o||n;const t=o.program||n.program,i=o.args||n.args,s=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(d||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.$Tqc=l}),define(Se[310],De([1,0,56,32,11]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=O,e.$Vqc=p,r=Ue(r),k=Ue(k);function A(c,I){return new Promise((S,h)=>{let P="";const w=r.spawn(c,I);w.pid&&w.stdout.on("data",l=>{P+=l.toString()}),w.on("error",l=>{h(l)}),w.on("close",l=>{S(P)})})}async function O(c){if(c)if(k.$c){const I=await new Promise((S,h)=>{ie(["@vscode/windows-process-tree"],S,h)}).then(Ue);return new Promise(S=>{I.getProcessTree(c,h=>{S(!!h&&h.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(c)]).then(I=>{const S=I.trim();return!(S.length===0||S.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var R;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(R||(R={}));function p(c,I,S,h,P){c=c.trim().toLowerCase();let w;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?w=R.powershell:c.indexOf("cmd.exe")>=0?w=R.cmd:c.indexOf("bash")>=0?w=R.bash:k.$c?w=R.cmd:w=R.bash;let l,m=" ";switch(w){case R.powershell:if(l=g=>(g=g.replace(/\'/g,"''"),g.length>0&&g.charAt(g.length-1)==="\\"?`'${g}\\'`:`'${g}'`),h){const g=(0,a.$Lg)(h);g&&(m+=`${g}:; `),m+=`cd ${l(h)}; `}if(P)for(const g in P){const $=P[g];$===null?m+=`Remove-Item env:${g}; `:m+=`\${env:${g}}='${$}'; `}if(I.length>0){const g=I.shift(),$=S?g:l(g);m+=$[0]==="'"?`& ${$} `:`${$} `;for(const n of I)m+=n==="<"||n===">"||S?n:l(n),m+=" "}break;case R.cmd:if(l=g=>(g=g.replace(/\"/g,'""'),g=g.replace(/([><!^&|])/g,"^$1"),' "'.split("").some($=>g.includes($))||g.length===0?`"${g}"`:g),h){const g=(0,a.$Lg)(h);g&&(m+=`${g}: && `),m+=`cd ${l(h)} && `}if(P){m+='cmd /C "';for(const g in P){let $=P[g];$===null?m+=`set "${g}=" && `:($=$.replace(/[&^|<>]/g,n=>`^${n}`),m+=`set "${g}=${$}" && `)}}for(const g of I)m+=g==="<"||g===">"||S?g:l(g),m+=" ";P&&(m+='"');break;case R.bash:{l=$=>($=$.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),$.length===0?'""':$);const g=$=>/[^\w@%\/+=,.:^-]/.test($)?`'${$.replace(/'/g,"'\\''")}'`:$;if(h&&(m+=`cd ${l(h)} ; `),P){m+="/usr/bin/env";for(const $ in P){const n=P[$];n===null?m+=` -u ${g($)}`:m+=` ${g(`${$}=${n}`)}`}m+=" "}for(const $ of I)m+=$==="<"||$===">"||S?$:l($),m+=" ";break}}return m}}),define(Se[311],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.CellExecutionUpdateType=void 0;var a;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(a||(e.CellExecutionUpdateType=a={})),e.$LK=(0,r.$Gi)("INotebookExecutionService")}),define(Se[312],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$OK=e.ProxyKernelState=e.$NK=void 0,e.$NK=100;var a;(function(k){k[k.Disconnected=1]="Disconnected",k[k.Connected=2]="Connected",k[k.Initializing=3]="Initializing"})(a||(e.ProxyKernelState=a={})),e.$OK=(0,r.$Gi)("INotebookKernelService"),e.$PK=(0,r.$Gi)("INotebookKernelHistoryService")}),define(Se[313],De([1,0,3,31,58,208,112]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LZb=void 0;class R extends r.$Xc{constructor(c,I,S){super(),this._source=c,this.b=I,this.c=S,this.a=void 0}f(c){const I=c.getLineCount();return new a.$Nt(1,1,I,this.g(c,I))}g(c,I){if(I<1||I>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const c=new A.$nD;c.acceptChunk(this._source);const I=c.finish(!0),{textBuffer:S,disposable:h}=I.create(k.DefaultEndOfLine.LF);this.b=S,this.B(h)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const I=new A.$nD;I.acceptChunk(c);const S=I.finish(!0),{textBuffer:h,disposable:P}=S.create(k.DefaultEndOfLine.LF);return this.B(P),h})),this.a}findInInputs(c){const S=new O.$bD(c,!1,!1,null).parseSearchRequest();if(!S)return[];const h=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(h,S,!0,5e3)}findInOutputs(c){const S=new O.$bD(c,!1,!1,null).parseSearchRequest();return S?this.outputTextBuffers.map(h=>{const P=h.findMatchesLineByLine(this.f(h),S,!0,5e3);if(P.length!==0)return{textBuffer:h,matches:P}}).filter(h=>!!h):[]}}e.$LZb=R}),define(Se[74],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(A){A.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var a;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(a||(e.TestPosition=a={}));class k{static fromExtHostTestItem(O,R,p=O.parent){if(O._isRoot)return new k([R]);const c=[O.id];for(let I=p;I&&I.id!==R;I=I.parent)c.push(I.id);return c.push(R),new k(c.reverse())}static isRoot(O){return!O.includes(r.Delimiter)}static root(O){const R=O.indexOf(r.Delimiter);return R===-1?O:O.slice(0,R)}static fromString(O){return new k(O.split(r.Delimiter))}static join(O,R){return new k([...O.path,R])}static joinToString(O,R){return O.toString()+r.Delimiter+R}static parentId(O){const R=O.lastIndexOf(r.Delimiter);return R===-1?void 0:O.slice(0,R)}static localId(O){const R=O.lastIndexOf(r.Delimiter);return R===-1?O:O.slice(R+r.Delimiter.length)}static isChild(O,R){return R.startsWith(O)&&R[O.length]===r.Delimiter}static compare(O,R){return O===R?a.IsSame:k.isChild(O,R)?a.IsChild:k.isChild(R,O)?a.IsParent:a.Disconnected}static getLengthOfCommonPrefix(O,R){if(O===0)return 0;let p=0;for(;p<O-1;){for(let c=1;c<O;c++){const I=R(c-1),S=R(c);if(I.path[p]!==S.path[p])return p}p++}return p}constructor(O,R=O.length){if(this.path=O,this.d=R,O.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new k(this.path,1)}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let O=1;O<=this.d;O++)yield new k(this.path,O)}*idsToRoot(){for(let O=this.d;O>0;O--)yield new k(this.path,O)}compare(O){if(typeof O=="string")return k.compare(this.toString(),O);for(let R=0;R<O.d&&R<this.d;R++)if(O.path[R]!==this.path[R])return a.Disconnected;return O.d>this.d?a.IsChild:O.d<this.d?a.IsParent:a.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let O=1;O<this.d;O++)this.c+=r.Delimiter,this.c+=this.path[O]}return this.c}}e.$UI=k}),define(Se[75],De([1,0,2,57,31,74]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$3I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$2I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$1I=e.$ZI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$YI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$XI=e.$WI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$VI=e.TestResultState=void 0;var O;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(O||(e.TestResultState=O={})),e.$VI={[O.Unset]:"unset",[O.Queued]:"queued",[O.Running]:"running",[O.Passed]:"passed",[O.Failed]:"failed",[O.Skipped]:"skipped",[O.Errored]:"errored"};var R;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var p;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$WI=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const c=M=>"runId"in M;e.$XI=c;var I;(function(M){M.serialize=L=>({range:L.range.toJSON(),uri:L.uri.toJSON()}),M.deserialize=(L,B)=>({range:k.$Nt.lift(B.range),uri:L.asCanonicalUri(r.URI.revive(B.uri))})})(I||(e.IRichLocation=I={}));var S;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(S||(e.TestMessageType=S={}));var h;(function(M){M.serialize=L=>({message:L.message,type:S.Error,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&I.serialize(L.location)}),M.deserialize=(L,B)=>({message:B.message,type:S.Error,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&I.deserialize(L,B.location)})})(h||(e.ITestErrorMessage=h={}));const P=(M,L)=>`${L?"s":"e"}${M}`;e.$YI=P;var w;(function(M){M.serialize=L=>({message:L.message,type:S.Output,offset:L.offset,length:L.length,location:L.location&&I.serialize(L.location)}),M.deserialize=(L,B)=>({message:B.message,type:S.Output,offset:B.offset,length:B.length,location:B.location&&I.deserialize(L,B.location)})})(w||(e.ITestOutputMessage=w={}));var l;(function(M){M.serialize=L=>L.type===S.Error?h.serialize(L):w.serialize(L),M.deserialize=(L,B)=>B.type===S.Error?h.deserialize(L,B):w.deserialize(L,B)})(l||(e.ITestMessage=l={}));var m;(function(M){M.serializeWithoutMessages=L=>({state:L.state,duration:L.duration,messages:[]}),M.serialize=L=>({state:L.state,duration:L.duration,messages:L.messages.map(l.serialize)}),M.deserialize=(L,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>l.deserialize(L,W))})})(m||(e.ITestTaskState=m={}));const g="\0",$=(M,L)=>M+g+L;e.$ZI=$;const n=M=>{const L=M.indexOf(g);return{ctrlId:M.slice(0,L),tagId:M.slice(L+1)}};e.$1I=n;var o;(function(M){M.serialize=L=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?.toJSON(),range:L.range?.toJSON()||null,description:L.description,error:L.error,sortText:L.sortText}),M.deserialize=(L,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?L.asCanonicalUri(r.URI.revive(B.uri)):void 0,range:B.range?k.$Nt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(o||(e.ITestItem=o={}));var t;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var i;(function(M){M.serialize=L=>({expand:L.expand,item:o.serialize(L.item)}),M.deserialize=(L,B)=>({controllerId:A.$UI.root(B.item.extId),expand:B.expand,item:o.deserialize(L,B.item)})})(i||(e.InternalTestItem=i={}));var s;(function(M){M.serialize=L=>{let B;return L.item&&(B={},L.item.label!==void 0&&(B.label=L.item.label),L.item.tags!==void 0&&(B.tags=L.item.tags),L.item.busy!==void 0&&(B.busy=L.item.busy),L.item.uri!==void 0&&(B.uri=L.item.uri?.toJSON()),L.item.range!==void 0&&(B.range=L.item.range?.toJSON()),L.item.description!==void 0&&(B.description=L.item.description),L.item.error!==void 0&&(B.error=L.item.error),L.item.sortText!==void 0&&(B.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:B}},M.deserialize=L=>{let B;return L.item&&(B={},L.item.label!==void 0&&(B.label=L.item.label),L.item.tags!==void 0&&(B.tags=L.item.tags),L.item.busy!==void 0&&(B.busy=L.item.busy),L.item.range!==void 0&&(B.range=L.item.range?k.$Nt.lift(L.item.range):null),L.item.description!==void 0&&(B.description=L.item.description),L.item.error!==void 0&&(B.error=L.item.error),L.item.sortText!==void 0&&(B.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:B}}})(s||(e.ITestItemUpdate=s={}));const d=(M,L)=>{L.expand!==void 0&&(M.expand=L.expand),L.item!==void 0&&(M.item=M.item?Object.assign(M.item,L.item):L.item)};e.$2I=d;var u;(function(M){M.serializeWithoutMessages=L=>({...i.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(m.serializeWithoutMessages)}),M.serialize=L=>({...i.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(m.serialize)}),M.deserialize=(L,B)=>({...i.deserialize(L,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>m.deserialize(L,W)),retired:!0})})(u||(e.TestResultItem=u={}));var b;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(L,B)=>{L.covered+=B.covered,L.total+=B.total}})(b||(e.ICoverageCount=b={}));var E;(function(M){M.serialize=L=>({id:L.id,statement:L.statement,branch:L.branch,declaration:L.declaration,testIds:L.testIds,uri:L.uri.toJSON()}),M.deserialize=(L,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testIds:B.testIds,uri:L.asCanonicalUri(r.URI.revive(B.uri))}),M.empty=(L,B)=>({id:L,uri:B,statement:b.empty()})})(E||(e.IFileCoverage=E={}));function D(M){return{...M,location:M.location?.toJSON()}}function y(M){return M.location=M.location?a.$Mt.isIPosition(M.location)?a.$Mt.lift(M.location):k.$Nt.lift(M.location):void 0,M}e.$3I=3;var T;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(T||(e.DetailType=T={}));var C;(function(M){M.serialize=L=>L.type===T.Declaration?f.serialize(L):N.serialize(L),M.deserialize=L=>L.type===T.Declaration?f.deserialize(L):N.deserialize(L)})(C||(e.CoverageDetails=C={}));var v;(function(M){M.serialize=D,M.deserialize=y})(v||(e.IBranchCoverage=v={}));var f;(function(M){M.serialize=D,M.deserialize=y})(f||(e.IDeclarationCoverage=f={}));var N;(function(M){M.serialize=L=>({...D(L),branches:L.branches?.map(v.serialize)}),M.deserialize=L=>({...y(L),branches:L.branches?.map(v.deserialize)})})(N||(e.IStatementCoverage=N={}));var F;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var j;(function(M){M.deserialize=(L,B)=>B.op===F.Add?{op:B.op,item:i.deserialize(L,B.item)}:B.op===F.Update?{op:B.op,item:s.deserialize(B.item)}:B.op===F.DocumentSynced?{op:B.op,uri:L.asCanonicalUri(r.URI.revive(B.uri)),docv:B.docv}:B,M.serialize=L=>L.op===F.Add?{op:L.op,item:i.serialize(L.item)}:L.op===F.Update?{op:L.op,item:s.serialize(L.item)}:L})(j||(e.TestsDiffOp=j={}));class z{constructor(L){this.k=L,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(L){const B=this.w();for(const W of L)switch(W.op){case F.Add:this.l(i.deserialize(this.k,W.item),B);break;case F.Update:this.p(s.deserialize(W.item),B);break;case F.Remove:this.q(W.itemId,B);break;case F.Retire:this.v(W.itemId);break;case F.IncrementPendingExtHosts:this.updatePendingRoots(W.amount);break;case F.AddTag:this.c.set(W.tag.id,W.tag);break;case F.RemoveTag:this.c.delete(W.id);break}B.complete?.()}l(L,B){const W=A.$UI.parentId(L.item.extId)?.toString();let ae;if(!W)ae=this.x(L),this.g.add(ae),this.f.set(L.item.extId,ae);else if(this.f.has(W)){const q=this.f.get(W);q.children.add(L.item.extId),ae=this.x(L,q),this.f.set(L.item.extId,ae)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(L)}`);return}return B.add?.(ae),L.expand===t.BusyExpanding&&this.h++,ae}p(L,B){const W=this.f.get(L.extId);if(W)return L.expand!==void 0&&(W.expand===t.BusyExpanding&&this.h--,L.expand===t.BusyExpanding&&this.h++),(0,e.$2I)(W,L),B.update?.(W),W}q(L,B){const W=this.f.get(L);if(!W)return;const ae=A.$UI.parentId(W.item.extId)?.toString();ae?this.f.get(ae).children.delete(W.item.extId):this.g.delete(W);const q=[[L]];for(;q.length;)for(const K of q.pop()){const ee=this.f.get(K);ee&&(q.push(ee.children),this.f.delete(K),B.remove?.(ee,ee!==W),ee.expand===t.BusyExpanding&&this.h--)}}v(L){}updatePendingRoots(L){this.j+=L}w(){return{}}}e.$4I=z}),define(Se[314],De([1,0,139,257,75]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$CGb=e.$BGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var A;(function(S){S.ViewletId="workbench.view.extension.test",S.ExplorerViewId="workbench.view.testing",S.OutputPeekContributionId="editor.contrib.testingOutputPeek",S.DecorationsContributionId="editor.contrib.testingDecorations",S.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",S.CoverageViewId="workbench.view.testCoverage",S.ResultsPanelId="workbench.panel.testResults",S.ResultsViewId="workbench.panel.testResults.view",S.MessageLanguageId="vscodeInternalTestMessage"})(A||(e.Testing=A={}));var O;(function(S){S.List="list",S.Tree="true"})(O||(e.TestExplorerViewMode=O={}));var R;(function(S){S.ByLocation="location",S.ByStatus="status",S.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const p={[k.TestResultState.Errored]:(0,a.localize)(0,null),[k.TestResultState.Failed]:(0,a.localize)(1,null),[k.TestResultState.Passed]:(0,a.localize)(2,null),[k.TestResultState.Queued]:(0,a.localize)(3,null),[k.TestResultState.Running]:(0,a.localize)(4,null),[k.TestResultState.Skipped]:(0,a.localize)(5,null),[k.TestResultState.Unset]:(0,a.localize)(6,null)},c=(S,h)=>(0,a.localize)(7,null,(0,r.$Zk)(S),p[h]);e.$BGb=c,e.$CGb={[k.TestRunProfileBitset.Debug]:(0,a.localize)(8,null),[k.TestRunProfileBitset.Run]:(0,a.localize)(9,null),[k.TestRunProfileBitset.Coverage]:(0,a.localize)(10,null)};var I;(function(S){S.CancelTestRefreshAction="testing.cancelTestRefresh",S.CancelTestRunAction="testing.cancelRun",S.ClearTestResultsAction="testing.clearTestResults",S.CollapseAllAction="testing.collapseAll",S.ConfigureTestProfilesAction="testing.configureProfile",S.ContinousRunUsingForTest="testing.continuousRunUsingForTest",S.CoverageAtCursor="testing.coverageAtCursor",S.CoverageByUri="testing.coverage.uri",S.CoverageClear="testing.coverage.close",S.CoverageCurrentFile="testing.coverageCurrentFile",S.CoverageFilterToTest="testing.coverageFilterToTest",S.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",S.CoverageLastRun="testing.coverageLastRun",S.CoverageSelectedAction="testing.coverageSelected",S.CoverageToggleToolbar="testing.coverageToggleToolbar",S.CoverageViewChangeSorting="testing.coverageViewChangeSorting",S.DebugAction="testing.debug",S.DebugAllAction="testing.debugAll",S.DebugAtCursor="testing.debugAtCursor",S.DebugByUri="testing.debug.uri",S.DebugCurrentFile="testing.debugCurrentFile",S.DebugFailedTests="testing.debugFailTests",S.DebugLastRun="testing.debugLastRun",S.DebugSelectedAction="testing.debugSelected",S.FilterAction="workbench.actions.treeView.testExplorer.filter",S.GetExplorerSelection="_testing.getExplorerSelection",S.GetSelectedProfiles="testing.getSelectedProfiles",S.GoToTest="testing.editFocusedTest",S.HideTestAction="testing.hideTest",S.OpenCoverage="testing.openCoverage",S.OpenOutputPeek="testing.openOutputPeek",S.RefreshTestsAction="testing.refreshTests",S.ReRunFailedTests="testing.reRunFailTests",S.ReRunLastRun="testing.reRunLastRun",S.RunAction="testing.run",S.RunAllAction="testing.runAll",S.RunAllWithCoverageAction="testing.coverageAll",S.RunAtCursor="testing.runAtCursor",S.RunByUri="testing.run.uri",S.RunCurrentFile="testing.runCurrentFile",S.RunSelectedAction="testing.runSelected",S.RunUsingProfileAction="testing.runUsing",S.RunWithCoverageAction="testing.coverage",S.SearchForTestExtension="testing.searchForTestExtension",S.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",S.ShowMostRecentOutputAction="testing.showMostRecentOutput",S.StartContinousRun="testing.startContinuousRun",S.StopContinousRun="testing.stopContinuousRun",S.TestingSortByDurationAction="testing.sortByDuration",S.TestingSortByLocationAction="testing.sortByLocation",S.TestingSortByStatusAction="testing.sortByStatus",S.TestingViewAsListAction="testing.viewAsList",S.TestingViewAsTreeAction="testing.viewAsTree",S.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",S.ToggleInlineTestOutput="testing.toggleInlineTestOutput",S.UnhideAllTestsAction="testing.unhideAllTests",S.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Se[122],De([1,0,7,4,3,66,75,74]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.TestItemEventOp=void 0;var p;(function($){$[$.Upsert=0]="Upsert",$[$.SetTags=1]="SetTags",$[$.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",$[$.RemoveChild=3]="RemoveChild",$[$.SetProp=4]="SetProp",$[$.Bulk=5]="Bulk",$[$.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const c=($,n)=>$===n,S=Object.entries({range:($,n)=>$===n?!0:!$||!n?!1:$.equalsRange(n),busy:c,label:c,description:c,error:c,sortText:c,tags:($,n)=>!($.length!==n.length||$.some(o=>!n.includes(o)))}),h=($,n)=>{let o;for(const[t,i]of S)i($[t],n[t])||(o?o[t]=n[t]:o={[t]:n[t]});return o};class P extends k.$Xc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new r.$Sh(()=>this.flushDiff(),200)),this.g=this.B(new a.$ne),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case O.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===O.TestDiffOpType.DocumentSynced&&o.uri===n.uri){o.docv=n.docv;return}break}case O.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===O.TestDiffOpType.Update&&o.item.extId===n.item.extId){(0,O.$2I)(o.item,n.item);return}if(o.op===O.TestDiffOpType.Add&&o.item.item.extId===n.item.extId){(0,O.$2I)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const t=this.tree.get(n);if(t){if((t.expandLevels===void 0||o>t.expandLevels)&&(t.expandLevels=o),t.expand===O.TestItemExpandState.Expandable){const i=this.M(t);return i.isOpen()?this.L(t,o-1):i.wait().then(()=>this.L(t,o-1))}else if(t.expand===O.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,o-1)):this.L(t,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case p.RemoveChild:this.O(R.$UI.joinToString(n.fullId,o.id));break;case p.Upsert:this.z(o.item,n);break;case p.Bulk:for(const t of o.ops)this.w(n,t);break;case p.SetTags:this.C(o.new,o.old,n.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(n);break;case p.SetProp:this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:o.update}});break;case p.DocumentSynced:this.y(n.actual.uri);break;default:(0,A.$hd)(o)}}y(n){n&&this.pushDiff({op:O.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const t=R.$UI.fromExtHostTestItem(n,this.root.id,o?.actual),i=this.s.getApiFor(n);i.parent&&i.parent!==o?.actual&&this.s.getChildren(i.parent).delete(n.id);let s=this.tree.get(t.toString());if(!s){s={fullId:t,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:O.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(n,o),this.pushDiff({op:O.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.I(n,s,o);return}if(s.actual===n){this.H(n,s,o);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.O(t.toString()),this.z(n,o);const d=this.s.getChildren(s.actual),u=s.actual,b=h(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,s.actual=n,s.resolveBarrier=void 0,s.expand=O.TestItemExpandState.NotExpandable,b&&(b.hasOwnProperty("tags")&&(this.C(n.tags,u.tags,t.toString()),delete b.tags),this.w(s,{op:p.SetProp,update:b})),this.I(n,s,o);for(const[D,y]of d)this.s.getChildren(n).get(y.id)||this.O(R.$UI.joinToString(t,y.id));const E=s.expandLevels;E!==void 0&&queueMicrotask(()=>{s.expand===O.TestItemExpandState.Expandable&&(s.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(s.actual.uri)}C(n,o,t){const i=new Set(o.map(s=>s.id));for(const s of n)i.delete(s.id)||this.D(s);this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:t,item:{tags:n.map(s=>(0,O.$ZI)(this.s.controllerId,s.id))}}}),i.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:O.TestDiffOpType.AddTag,tag:{id:(0,O.$ZI)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:O.TestDiffOpType.RemoveTag,id:(0,O.$ZI)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,t){this.G(n,t);const i=this.s.getApiFor(n);i.parent=t?.actual,i.listener=s=>this.w(o,s),this.J(o)}I(n,o,t){this.H(n,o,t);for(const[i,s]of this.s.getChildren(n))this.z(s,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?O.TestItemExpandState.Expanded:O.TestItemExpandState.BusyExpanding:o=n.actual.canResolveChildren?O.TestItemExpandState.Expandable:O.TestItemExpandState.NotExpandable:o=O.TestItemExpandState.NotExpandable,o!==n.expand&&(n.expand=o,this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:o}}),o===O.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const t=[];for(const[i,s]of this.s.getChildren(n.actual)){const d=this.expand(R.$UI.joinToString(n.fullId,s.id),o);(0,r.$sh)(d)&&t.push(d)}if(t.length)return Promise.all(t).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new r.$Fh;return s.open(),s}n.expand=O.TestItemExpandState.BusyExpanding,this.N(n);const o=n.resolveBarrier=new r.$Fh,t=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(n.actual===this.root?void 0:n.actual)}catch(s){t(s)}return(0,r.$sh)(i)?i.catch(t).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:O.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:O.TestDiffOpType.Remove,itemId:n});const t=[o];for(;t.length;){const i=t.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.F(s.id);this.tree.delete(i.fullId.toString());for(const[s,d]of this.s.getChildren(i.actual))t.push(this.tree.get(R.$UI.joinToString(i.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$RP=P;class w extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$SP=w;class l extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$TP=l;class m extends Error{constructor(n,o,t){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${t}".`)}}e.$UP=m;const g=($,n,o)=>{let t=new Map;return{get size(){return t.size},forEach(i,s){for(const d of t.values())i.call(s,d,this)},[Symbol.iterator](){return t.entries()},replace(i){const s=new Map,d=new Set(t.keys()),u={op:p.Bulk,ops:[]};for(const b of i){if(!(b instanceof o))throw new l(b.id);const E=n(b).controllerId;if(E!==$.controllerId)throw new m(b.id,E,$.controllerId);if(s.has(b.id))throw new w(b.id);s.set(b.id,b),d.delete(b.id),u.ops.push({op:p.Upsert,item:b})}for(const b of d.keys())u.ops.push({op:p.RemoveChild,id:b});$.listener?.(u),t=s},add(i){if(!(i instanceof o))throw new l(i.id);t.set(i.id,i),$.listener?.({op:p.Upsert,item:i})},delete(i){t.delete(i)&&$.listener?.({op:p.RemoveChild,id:i})},get(i){return t.get(i)},toJSON(){return Array.from(t.values())}}};e.$VP=g}),define(Se[156],De([1,0,122]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=void 0;const a=new WeakMap,k=(O,R)=>{const p={controllerId:R};return a.set(O,p),p};e.$WP=k;const A=O=>{const R=a.get(O);if(!R)throw new r.$TP(O?.id||"<unknown>");return R};e.$XP=A}),define(Se[123],De([1,0,27,15,2]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pDb=e.$oDb=e.$nDb=void 0,e.$qDb=A,e.$rDb=R,e.$nDb="vscode-cdn.net",e.$oDb=`vscode-resource.${e.$nDb}`,e.$pDb=`'self' https://*.${e.$nDb}`;function A(p,c){return p.scheme===a.Schemas.http||p.scheme===a.Schemas.https?p:(c&&c.authority&&c.isRemote&&p.scheme===a.Schemas.file&&(p=k.URI.from({scheme:a.Schemas.vscodeRemote,authority:c.authority,path:p.path})),k.URI.from({scheme:a.Schemas.https,authority:`${p.scheme}+${O(p.authority)}.${e.$oDb}`,path:p.path,fragment:p.fragment,query:p.query}))}function O(p){return p.replace(/./g,c=>{const I=c.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?c:"-"+I.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,(c,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Se[315],De([1,0,4,3,123]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0;class A{constructor(R,p,c){this.d=R,this.e=p,this.f=c,this.a=0,this.b=new a.$Wc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const S of this.c.values())I.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,p,c,I,S){let h;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===R){h=n;break}if(!h)throw new Error("not a visible editor");const P=this,w=this.a++,l=new r.$ne,m=new r.$ne,g=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,k.$qDb)(n,P.f)}get cspSource(){return k.$pDb}set options(n){this.b=n,P.d.$setOptions(w,n)}get options(){return this.b}set html(n){this.a=n,P.d.$setHtml(w,n)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(n){return P.d.$postMessage(w,n)}},$=new class{constructor(){this.editor=R,this.line=p,this.height=c,this.webview=g,this.onDidDispose=m.event}dispose(){P.c.has(w)&&(P.c.delete(w),P.d.$disposeEditorInset(w),m.fire(),m.dispose(),l.dispose())}};return this.d.$createEditorInset(w,h.id,h.value.document.uri,p+1,c,I||{},S.identifier,S.extensionLocation),this.c.set(w,{editor:R,inset:$,onDidReceiveMessage:l}),$}$onDidDispose(R){const p=this.c.get(R);p&&p.inset.dispose()}$onDidReceiveMessage(R,p){this.c.get(R)?.onDidReceiveMessage.fire(p)}}e.$Ooc=A}),define(Se[157],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=e.$yM=e.$xM=void 0,e.$xM="__",e.$yM=(0,r.$Gi)("IAuthenticationService"),e.$zM=(0,r.$Gi)("IAuthenticationExtensionsService")}),define(Se[316],De([1,0,5]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QQ=e.VariableKind=e.$PQ=void 0,e.$PQ=(0,r.$Gi)("configurationResolverService");var a;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(a||(e.VariableKind=a={}));class k extends Error{constructor(O,R){super(R),this.variable=O}}e.$QQ=k}),define(Se[317],De([1,0,17,54,18,25,11,108,258,316,13]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Q=void 0,r=Ue(r),a=Ue(a),k=Ue(k),A=Ue(A);class S{constructor(P,w,l,m){this.h=new Map,this.a=P,this.b=w,this.g=l,m&&(this.c=m.then(g=>this.i(g)))}i(P){if(O.$c){const w=Object.create(null);return Object.keys(P).forEach(l=>{w[l.toLowerCase()]=P[l]}),w}return P}resolveWithEnvironment(P,w,l){return this.l({env:this.i(P),userHome:void 0},w?w.uri:void 0,l)}async resolveAsync(P,w){const l={env:await this.c,userHome:await this.g};return this.l(l,P?P.uri:void 0,w)}async j(P,w,l,m){const g=A.$fo(w);O.$c&&g.windows?Object.keys(g.windows).forEach(n=>g[n]=g.windows[n]):O.$d&&g.osx?Object.keys(g.osx).forEach(n=>g[n]=g.osx[n]):O.$e&&g.linux&&Object.keys(g.linux).forEach(n=>g[n]=g.linux[n]),delete g.windows,delete g.osx,delete g.linux;const $={env:await this.c,userHome:await this.g};return this.l($,P?P.uri:void 0,g,l,m)}async resolveAnyAsync(P,w,l){return this.j(P,w,l)}async resolveAnyMap(P,w,l){const m=new Map;return{newConfig:await this.j(P,w,l,m),resolvedVariables:m}}resolveWithInteractionReplace(P,w,l,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,w,l,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,w){if(this.h.has(P))throw new Error("Variable "+P+" is contributed twice.");this.h.set(P,w)}async l(P,w,l,m,g){if(k.$gg(l))return this.m(P,w,l,m,g);if(Array.isArray(l))return Promise.all(l.map($=>this.l(P,w,$,m,g)));if(k.$ig(l)){const $=Object.create(null),n=await Promise.all(Object.keys(l).map(async o=>[await this.m(P,w,o,m,g),await this.l(P,w,l[o],m,g)]));for(const[o,t]of n)$[o]=t;return $}return l}m(P,w,l,m,g){return(0,I.$zf)(l,S.VARIABLE_REGEXP,async($,n)=>{if(n.includes(S.VARIABLE_LHS))return $;let o=await this.o(P,$,n,w,m);return g?.set(n,o),o!==$&&k.$gg(o)&&o.match(S.VARIABLE_REGEXP)&&(o=await this.m(P,w,o,m,g)),o})}n(P){return this.b?this.b.getUriLabel(P,{noPrefix:!0}):P.fsPath}async o(P,w,l,m,g){let $;const n=l.split(":");n.length>1&&(l=n[0],$=n[1]);const o=s=>{const d=this.a.getFilePath();if(d)return(0,R.$Yw)(d);throw new c.$QQ(s,(0,p.localize)(0,null,w))},t=s=>{const d=o(s);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,R.$Yw)(u)}throw new c.$QQ(s,(0,p.localize)(1,null,w,r.$qc(d)))},i=s=>{if($){const d=this.a.getFolderUri($);if(d)return d;throw new c.$QQ(s,(0,p.localize)(2,null,w,$))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new c.$QQ(s,(0,p.localize)(3,null,w)):new c.$QQ(s,(0,p.localize)(4,null,w))};switch(l){case"env":if($){if(P.env){const s=P.env[O.$c?$.toLowerCase():$];if(k.$gg(s))return s}return""}throw new c.$QQ(c.VariableKind.Env,(0,p.localize)(5,null,w));case"config":if($){const s=this.a.getConfigurationValue(m,$);if(k.$pg(s))throw new c.$QQ(c.VariableKind.Config,(0,p.localize)(6,null,w,$));if(k.$ig(s))throw new c.$QQ(c.VariableKind.Config,(0,p.localize)(7,null,w,$));return s}throw new c.$QQ(c.VariableKind.Config,(0,p.localize)(8,null,w));case"command":return this.p(c.VariableKind.Command,w,$,g,"command");case"input":return this.p(c.VariableKind.Input,w,$,g,"input");case"extensionInstallFolder":if($){const s=await this.a.getExtension($);if(!s)throw new c.$QQ(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,w,$));return this.n(s.extensionLocation)}throw new c.$QQ(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,w));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,R.$Yw)(this.n(i(c.VariableKind.WorkspaceFolder)));case"cwd":return m||$?(0,R.$Yw)(this.n(i(c.VariableKind.Cwd))):a.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.$Yw)(r.$qc(this.n(i(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(P.userHome)return P.userHome;throw new c.$QQ(c.VariableKind.UserHome,(0,p.localize)(11,null,w))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new c.$QQ(c.VariableKind.LineNumber,(0,p.localize)(12,null,w))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new c.$QQ(c.VariableKind.SelectedText,(0,p.localize)(13,null,w))}case"file":return o(c.VariableKind.File);case"fileWorkspaceFolder":return t(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$qc(t(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||$?r.$oc(this.n(i(c.VariableKind.RelativeFile)),o(c.VariableKind.RelativeFile)):o(c.VariableKind.RelativeFile);case"relativeFileDirname":{const s=r.$pc(o(c.VariableKind.RelativeFileDirname));if(m||$){const d=r.$oc(this.n(i(c.VariableKind.RelativeFileDirname)),s);return d.length===0?".":d}return s}case"fileDirname":return r.$pc(o(c.VariableKind.FileDirname));case"fileExtname":return r.$rc(o(c.VariableKind.FileExtname));case"fileBasename":return r.$qc(o(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=r.$qc(o(c.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-r.$rc(s).length)}case"fileDirnameBasename":return r.$qc(r.$pc(o(c.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||w}case"execInstallFolder":{const s=this.a.getAppRoot();return s||w}case"pathSeparator":case"/":return r.sep;default:try{const s=$?`${l}:${$}`:l;return this.p(c.VariableKind.Unknown,w,s,g,void 0)}catch{return w}}}}p(P,w,l,m,g){if(l&&m){const $=g===void 0?m[l]:m[g+":"+l];if(typeof $=="string")return $;throw new c.$QQ(P,(0,p.localize)(14,null,w))}return w}}e.$6Q=S,S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[158],De([1,0,5,154]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$kE=void 0,e.$lE=c,e.$mE=h,e.$nE=P,e.$kE=(0,r.$Gi)("editorGroupsService");var k;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(k||(e.GroupDirection=k={}));var A;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var O;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(O||(e.GroupLocation=O={}));var R;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var p;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function c(w){const l=w;return(0,a.$9F)(l?.editor)&&(0,a.$9F)(l?.replacement)}var I;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var S;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function h(w){const l=w;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}function P(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?k.DOWN:k.RIGHT}}),define(Se[318],De([1,0,5,158]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rE=e.$qE=e.$pE=e.$oE=void 0,e.$sE=k,e.$oE=(0,r.$Gi)("editorService"),e.$pE=-1,e.$qE=-2,e.$rE=-3;function k(A){const O=A;return typeof A=="number"||(0,a.$mE)(O)}}),define(Se[159],De([1,0,5,146]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=void 0,e.$SM=(0,r.$Hi)(a.$Ni)}),define(Se[160],De([1,0,24,4,17,3,7]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=e.$3cc=e.$2cc=e.$1cc=e.$Zcc=void 0,k=Ue(k);class R{constructor($,n){this.versionId=$,this.removedDueToLooping=n}}e.$Zcc=R;class p{static isHostExtension($,n,o){if(n.getExtensionDescription($))return!1;const t=o.getExtensionDescription($);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor($,n){this.j=$,this.c=new a.$ne,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(l),this.f=new r.$un,this.g=[],this.h=new Map;for(const $ of this.e){if(this.f.has($.identifier)){console.error("Extension `"+$.identifier.value+"` is already registered");continue}this.f.set($.identifier,$),this.g.push($);const n=this.j.readActivationEvents($);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push($)}}set($){return this.e=$,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions($,n){this.e=m(this.e,n),this.e=this.e.concat($);const o=p.l(this.e);return this.e=m(this.e,o.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,o)}static l($){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,u){this.addNode(d),this.addNode(u),this.c.has(d)?this.c.get(d).push(u):this.c.set(d,[u])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,u){const b=n.getArcs(d);for(let E=0;E<b.length;E++)if(!u.has(b[E]))return!1;return!0}getNodes(){return this.e}},o=new r.$un;for(const d of $)if(o.set(d.identifier,d),d.extensionDependencies)for(const u of d.extensionDependencies)n.addArc(r.$sn.toKey(d.identifier),r.$sn.toKey(u));const t=new Set;n.getNodes().filter(d=>n.getArcs(d).length===0).forEach(d=>t.add(d));const i=n.getNodes().filter(d=>!t.has(d));let s;do{s=!1;for(let d=0;d<i.length;d++){const u=i[d];n.hasOnlyGoodArcs(u,t)&&(i.splice(d,1),d--,t.add(u),s=!0)}}while(s);return i.map(d=>o.get(d))}containsActivationEvent($){return this.h.has($)}containsExtension($){return this.f.has($)}getExtensionDescriptionsForActivationEvent($){const n=this.h.get($);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription($){const n=this.f.get($);return n||void 0}getExtensionDescriptionByUUID($){for(const n of this.g)if(n.uuid===$)return n}getExtensionDescriptionByIdOrUUID($,n){return this.getExtensionDescription($)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$1cc=p;class c{constructor($,n){this.versionId=$,this.extensions=n}}e.$2cc=c;class I{constructor($){this.d=new P,this.c=new p($,[])}async acquireLock($){const n=await this.d.acquire($);return new S(this,n)}deltaExtensions($,n,o){if(!$.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent($){return this.c.containsActivationEvent($)}containsExtension($){return this.c.containsExtension($)}getExtensionDescriptionsForActivationEvent($){return this.c.getExtensionDescriptionsForActivationEvent($)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription($){return this.c.getExtensionDescription($)}getExtensionDescriptionByUUID($){return this.c.getExtensionDescriptionByUUID($)}getExtensionDescriptionByIdOrUUID($,n){return this.c.getExtensionDescriptionByIdOrUUID($,n)}}e.$3cc=I;class S extends A.$Xc{constructor($,n){super(),this.f=$,this.c=!1,this.B(n)}isAcquiredFor($){return!this.c&&this.f===$}}e.$4cc=S;class h{constructor($){this.name=$;const n=(0,O.$zh)();this.promise=n.promise,this.c=n.resolve}resolve($){this.c($)}}class P{constructor(){this.c=[],this.d=!1}async acquire($){const n=new h($);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const $=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${$.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};$.resolve((0,A.$Vc)(t))}}var w;(function(g){g[g.Builtin=0]="Builtin",g[g.User=1]="User",g[g.Dev=2]="Dev"})(w||(w={}));function l(g,$){const n=g.isBuiltin?w.Builtin:g.isUnderDevelopment?w.Dev:w.User,o=$.isBuiltin?w.Builtin:$.isUnderDevelopment?w.Dev:w.User;if(n!==o)return n-o;const t=k.$jc.basename(g.extensionLocation.path),i=k.$jc.basename($.extensionLocation.path);return t<i?-1:t>i?1:0}function m(g,$){const n=new r.$tn($);return g.filter(o=>!n.has(o.identifier))}}),define(Se[319],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.ExtHostConnectionType=void 0,e.$gn=R,e.$hn=p;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class a{constructor(S){this.pipeName=S,this.type=r.IPC}serialize(S){S[a.ENV_KEY]=this.pipeName}}e.$dn=a,a.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class k{constructor(){this.type=r.Socket}serialize(S){S[k.ENV_KEY]="1"}}e.$en=k,k.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=r.MessagePort}serialize(S){S[A.ENV_KEY]="1"}}e.$fn=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function O(I){delete I[a.ENV_KEY],delete I[k.ENV_KEY],delete I[A.ENV_KEY]}function R(I,S){O(S),I.serialize(S)}function p(I){if(I[a.ENV_KEY])return c(I,new a(I[a.ENV_KEY]));if(I[k.ENV_KEY])return c(I,new k);if(I[A.ENV_KEY])return c(I,new A);throw new Error("No connection information defined in environment!")}function c(I,S){return O(I),S}}),define(Se[94],De([1,0,22]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Cn=O,e.$Dn=R;var a;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(a||(e.UIKind=a={}));var k;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(k||(e.ExtensionHostExitCode=k={}));var A;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function O(c){const I=r.$Pe.alloc(1);switch(c){case A.Initialized:I.writeUInt8(1,0);break;case A.Ready:I.writeUInt8(2,0);break;case A.Terminate:I.writeUInt8(3,0);break}return I}function R(c,I){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return I===A.Initialized;case 2:return I===A.Ready;case 3:return I===A.Terminate;default:return!1}}var p;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Se[95],De([1,0,5,4,151,12,30,94,91,92,25,2,3,241]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.$hQ=e.$gQ=void 0,e.$iQ=m;let w=class extends h.$Xc{constructor($,n){super(),this.s=$,this.t=n,this.a=this.B(new a.$ne),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new a.$ne),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=k.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=S.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:c.$Bp,name:(0,P.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,A.$ck)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===k.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=k.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=k.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=k.TelemetryLevel.USAGE:!1}}instantiateLogger($,n,o){const t=this.getTelemetryDetails(),i=new l(n,o,$,this.n,this.j,this.getBuiltInCommonProperties($),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),s=this.r.get($.identifier.value)??[];return this.r.set($.identifier.value,[...s,i]),i.apiTelemetryLogger}$initializeTelemetryLevel($,n,o){this.f=$,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties($){const n=Object.create(null);switch(n["common.extname"]=`${$.publisher}.${$.name}`,n["common.extversion"]=$.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$jn)((0,c.$Hp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel($){this.h=this.getTelemetryConfiguration(),this.f=$;const n=this.getTelemetryDetails();this.r.forEach((o,t)=>{const i=o.filter(s=>!s.isDisposed);i.length===0?this.r.delete(t):this.r.set(t,i)}),this.r.forEach(o=>{for(const t of o)t.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError($,n){const t=this.r.get($.value)?.filter(s=>!s.isDisposed);if(!t)return this.r.delete($.value),!1;let i=!1;for(const s of t)s.ignoreUnhandledExtHostErrors||(s.logError(n),i=!0);return i}};e.$gQ=w,e.$gQ=w=Ye([Ve(0,O.$fQ),Ve(1,A.$bk)],w);class l{static validateSender($){if(typeof $!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof $.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof $.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof $.flush<"u"&&typeof $.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor($,n,o,t,i,s,d){this.g=o,this.h=t,this.i=i,this.j=s,this.a=new a.$ne,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=$,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements($,n){this.e&&(this.d={isUsageEnabled:$,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData($){let n="properties"in $?$.properties??{}:$;return n=(0,c.$Kp)(n,[]),this.c&&(n=(0,I.$io)(n,this.c)),this.b||(n=(0,I.$io)(n,this.j)),"properties"in $?$.properties=n:$=n,$}k($,n){this.f&&(this.g.publisher==="vscode"?$=this.g.name+"/"+$:$=this.g.identifier.value+"/"+$,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData($,n),this.h.trace($,n))}logUsage($,n){this.d.isUsageEnabled&&this.k($,n)}logError($,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof $=="string")this.k($,n);else{const o={name:$.name,message:$.message,stack:$.stack,cause:$.cause},t=(0,c.$Kp)(o,[]),i=new Error(t.message,{cause:t.cause});i.stack=t.stack,i.name=t.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(i,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const $=this,n={logUsage:$.logUsage.bind($),get isUsageEnabled(){return $.d.isUsageEnabled},get isErrorsEnabled(){return $.d.isErrorsEnabled},logError:$.logError.bind($),dispose:$.dispose.bind($),onDidChangeEnableStates:$.a.event.bind($)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let $=this.f;this.f=void 0,Promise.resolve($.flush()).then($=void 0),this.e=void 0}else this.f=void 0}}e.$hQ=l;function m(g){const $=Date.now()-new Date(g).getTime();return isNaN($)?!1:$<1e3*60*60*24}e.$jQ=(0,r.$Gi)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,290,149,24,5]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.ActivationKind=e.$0G=e.$9G=e.$6G=e.ExtensionHostStartup=e.$5G=e.$4G=e.$3G=e.$2G=void 0,e.$7G=h,e.$8G=P,e.$$G=g,e.$_G=$,e.$2G=Object.freeze({identifier:new O.$sn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:a.URI.parse("void:location"),isBuiltin:!1,targetPlatform:O.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$3G="extensions.webWorker",e.$4G=(0,R.$Gi)("extensionService");class p{constructor(t){this.dependency=t}}e.$5G=p;var c;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,i,s){this.c=t,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$NG.createActivationEventsMap(this.d)}}set(t,i,s){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const d=[],u=[],b=[],E=[],D=S(this.d),y=S(i),T=(F,j)=>F.extensionLocation.toString()===j.extensionLocation.toString()||F.isBuiltin===j.isBuiltin||F.isUserBuiltin===j.isUserBuiltin||F.isUnderDevelopment===j.isUnderDevelopment;for(const F of this.d){const j=y.get(F.identifier);if(!j){d.push(F.identifier),D.delete(F.identifier);continue}if(!T(F,j)){d.push(F.identifier),D.delete(F.identifier);continue}}for(const F of i){const j=D.get(F.identifier);if(!j){u.push(F);continue}if(!T(j,F)){d.push(j.identifier),D.delete(j.identifier);continue}}const C=new O.$tn(this.e),v=new O.$tn(s);for(const F of this.e)v.has(F)||b.push(F);for(const F of s)C.has(F)||E.push(F);const f=A.$NG.createActivationEventsMap(u),N={versionId:t,toRemove:d,toAdd:u,addActivationEvents:f,myToRemove:b,myToAdd:E};return this.delta(N),N}delta(t){if(this.c>=t.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:d,myToAdd:u}=t,b=new O.$tn(i),E=new O.$tn(d);for(let D=0;D<this.d.length;D++)b.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of s)this.d.push(D);for(const D of u)this.e.push(D);return this.f=null,t}containsExtension(t){for(const i of this.e)if(O.$sn.equals(i,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=A.$NG.readActivationEvents(i);for(const d of s)t.add(d)}return t}}e.$6G=I;function S(o){const t=new O.$un;for(const i of o)t.set(i.identifier,i);return t}function h(o,t){return!0}function P(o,t){if(!h(o,t))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class w{constructor(t,i,s,d){this.codeLoadingTime=t,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=d}}e.$9G=w;class l{constructor(t,i){this.description=t,this.value=i}}e.$0G=l;var m;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function g(o){return{type:o.isBuiltin?O.ExtensionType.System:O.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,k.$Qp)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function $(o,t){const i=(0,k.$Op)(o.manifest.publisher,o.manifest.name);return{id:i,identifier:new O.$sn(i),isBuiltin:o.type===O.ExtensionType.System,isUserBuiltin:o.type===O.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!t,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,i){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$aH=n}),define(Se[320],De([1,0,14,160,24,26,12,7]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=e.$cpc=e.$bpc=e.$apc=e.$_oc=e.$$oc=void 0,r=Ue(r);class p{constructor(g,$,n,o){this.startup=g,this.codeLoadingTime=$,this.activateCallTime=n,this.activateResolvedTime=o}}e.$$oc=p,p.NONE=new p(!1,-1,-1,-1);class c{constructor(g){this.a=g,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(g,$){return g===-1||$===-1?-1:$-g}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$_oc=c;class I{constructor(g,$,n,o,t,i){this.activationFailed=g,this.activationFailedError=$,this.activationTimes=n,this.module=o,this.exports=t,this.subscriptions=i}}e.$apc=I;class S extends I{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.$bpc=S;class h extends I{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$cpc=h;class P extends I{constructor(g){super(!0,g,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(g,$,n,o){this.g=o,this.a=g,this.b=$,this.c=n,this.d=new k.$un,this.f=Object.create(null)}dispose(){for(const[g,$]of this.d)$.dispose()}async waitForActivatingExtensions(){const g=[];for(const[$,n]of this.d)g.push(n.wait());await Promise.all(g)}isActivated(g){const $=this.d.get(g);return!!($&&$.value)}getActivatedExtension(g){const $=this.d.get(g);if(!$||!$.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return $.value}async activateByEvent(g,$){if(this.f[g])return;const n=this.a.getExtensionDescriptionsForActivationEvent(g);await this.h(n.map(o=>({id:o.identifier,reason:{startup:$,extensionId:o.identifier,activationEvent:g}}))),this.f[g]=!0}activateById(g,$){const n=this.a.getExtensionDescription(g);if(!n)throw new Error(`Extension '${g.value}' is not known`);return this.h([{id:n.identifier,reason:$}])}async h(g){const $=g.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all($.map(n=>n.wait()))}j(g){if(this.d.has(g.id))return this.d.get(g.id);if(this.l(g.id))return this.k(g,null,[],null);const $=this.a.getExtensionDescription(g.id);if(!$){const t=new Error(`Cannot activate unknown extension '${g.id.value}'`),i=this.k(g,null,[],new P(t));return this.c.onExtensionActivationError(g.id,t,new A.$5G(g.id.value)),i}const n=[],o=typeof $.extensionDependencies>"u"?[]:$.extensionDependencies;for(const t of o){if(this.m(t))continue;const i=this.d.get(t);if(i){n.push(i);continue}if(this.l(t)){n.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:g.reason}));continue}const s=this.a.getExtensionDescription(t);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:g.reason}));continue}const d=$.displayName||$.identifier.value,u=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${t}'`),b=this.k(g,$.displayName,[],new P(u));return this.c.onExtensionActivationError($.identifier,u,new A.$5G(t)),b}return this.k(g,$.displayName,n,null)}k(g,$,n,o){const t=new l(g.id,$,g.reason,n,o,this.c,this.g);return this.d.set(g.id,t),t}l(g){return a.$1cc.isHostExtension(g,this.a,this.b)}m(g){const $=this.b.getExtensionDescription(g);return $?!$.main&&!$.browser:!1}};e.$dpc=w,e.$dpc=w=Ye([Ve(3,O.$ak)],w);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(g,$,n,o,t,i,s){this.c=g,this.d=$,this.f=n,this.g=o,this.h=t,this.j=i,this.k=s,this.a=new R.$Fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let g=0;g<this.g.length;g++){const $=this.g[g];if($.value&&!$.value.activationFailed){this.g.splice(g,1),g--;continue}if($.value&&$.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${$.friendlyName}' failed to activate`);n.detail=$.value.activationFailedError,this.h=new P(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(g=>g.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(g){const $=new Error;if(g&&g.name&&($.name=g.name),g&&g.message?$.message=`Activating extension '${this.c.value}' failed: ${g.message}.`:$.message=`Activating extension '${this.c.value}' failed: ${g}.`,g&&g.stack&&($.stack=g.stack),this.h=new P($),this.b&&r.$7(g))return;this.j.onExtensionActivationError(this.c,$,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(g)}}};l=Ye([Ve(6,O.$ak)],l)});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[161],De([1,0,260,14,45,148,117,37,24,116,149,145]),function(ie,e,r,a,k,A,O,R,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=void 0,r=Ue(r),k=qt(k);const h=R.$so.as(O.$to.JSONContribution);class P{constructor(t,i,s){this.a=t,this.b=i,this.c=s}d(t,i){this.a({type:t,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(k.default.Error,t)}warn(t){this.d(k.default.Warning,t)}info(t){this.d(k.default.Info,t)}}e.$VG=P;class w{static a(t){const i=new p.$tn;for(let s=0,d=t.length;s<d;s++)i.add(t[s].description.identifier);return i}static compute(t,i){if(!t||!t.length)return new w(i,[]);if(!i||!i.length)return new w([],t);const s=this.a(t),d=this.a(i),u=i.filter(E=>!s.has(E.description.identifier)),b=t.filter(E=>!d.has(E.description.identifier));return new w(u,b)}constructor(t,i){this.added=t,this.removed=i}}e.$WG=w;class l{constructor(t,i){this.name=t,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=w.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,a.$3)(t)}}}e.$XG=l;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.$YG={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$rn},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals).map(o=>o),markdownEnumDescriptions:Object.values(S.allApiProposals).map(o=>o.proposal)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:r.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:r.localize(44,null)},{label:"*",description:r.localize(45,null),body:"*"}]}},badges:{type:"array",description:r.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(47,null)},href:{type:"string",description:r.localize(48,null)},description:{type:"string",description:r.localize(49,null)}}}},markdown:{type:"string",description:r.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$0o}},extensionPack:{description:r.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$0o}},extensionKind:{description:r.localize(54,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(55,null)},{body:["workspace"],description:r.localize(56,null)},{body:["ui","workspace"],description:r.localize(57,null)},{body:["workspace","ui"],description:r.localize(58,null)},{body:[],description:r.localize(59,null)}]},capabilities:{description:r.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(63,null),r.localize(64,null),r.localize(65,null)]},description:{type:"string",markdownDescription:r.localize(66,null)}}},untrustedWorkspaces:{description:r.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(69,null),r.localize(70,null),r.localize(71,null)]},restrictedConfigurations:{description:r.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(73,null)}}}}},sponsor:{description:r.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(76,null),type:"string"},"vscode:uninstall":{description:r.localize(77,null),type:"string"}}},icon:{type:"string",description:r.localize(78,null)},l10n:{type:"string",description:r.localize(79,null)},pricing:{type:"string",markdownDescription:r.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class ${constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const i=new l(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,i),t.activationEventsGenerator&&I.$NG.register(t.extensionPoint,t.activationEventsGenerator),e.$YG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,h.registerSchema(g,e.$YG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$ZG=$;const n={ExtensionsRegistry:"ExtensionsRegistry"};R.$so.add(n.ExtensionsRegistry,new $),e.$1G=R.$so.as(n.ExtensionsRegistry),h.registerSchema(g,e.$YG),h.registerSchema(c.$uk,{properties:{extensionEnabledApiProposals:{description:r.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals).map(o=>o.proposal)}}]}}}})}),define(Se[321],De([1,0,4,40,3,13,251,24,5,12,26,161]),function(ie,e,r,a,k,A,O,R,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=e.$cH=e.$bH=e.ChatMessageRole=void 0;var h;(function(l){l[l.System=0]="System",l[l.User=1]="User",l[l.Assistant=2]="Assistant"})(h||(e.ChatMessageRole=h={})),e.$bH=(0,p.$Gi)("ILanguageModelsService");const P={type:"object",properties:{vendor:{type:"string",description:(0,O.localize)(0,null)}}};e.$cH=S.$1G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,O.localize)(1,null),oneOf:[P,{type:"array",items:P}]},activationEventsGenerator:(l,m)=>{for(const g of l)m.push(`onLanguageModelChat:${g.vendor}`)}});let w=class{constructor(m,g){this.e=m,this.f=g,this.a=new k.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$ne),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$cH.setHandler($=>{this.c.clear();for(const o of $){if(!(0,I.$7G)(o.description,"chatProvider")){o.collector.error((0,O.localize)(2,null));continue}for(const t of a.Iterable.wrap(o.value)){if(this.c.has(t.vendor)){o.collector.error((0,O.localize)(3,null,t.vendor));continue}if((0,A.$ef)(t.vendor)){o.collector.error((0,O.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){o.collector.error((0,O.localize)(5,null));continue}this.c.add(t.vendor)}}const n=[];for(const[o,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(o),n.push(o));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(m){return this.b.get(m)?.metadata}async selectLanguageModels(m){if(m.vendor)await this.e.activateByEvent(`onLanguageModelChat:${m.vendor}}`);else{const $=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all($)}const g=[];for(const[$,n]of this.b)(m.vendor===void 0||n.metadata.vendor===m.vendor)&&(m.family===void 0||n.metadata.family===m.family)&&(m.version===void 0||n.metadata.version===m.version)&&(m.identifier===void 0||n.metadata.id===m.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(o=>R.$sn.equals(o,m.extension)))&&g.push($);return this.f.trace("[LM] selected language models",m,g),g}registerLanguageModelChat(m,g){if(this.f.trace("[LM] registering language model chat",m,g.metadata),!this.c.has(g.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${g.metadata.vendor}.`);if(this.b.has(m))throw new Error(`Chat response provider with identifier ${m} is already registered.`);return this.b.set(m,g),this.d.fire({added:[{identifier:m,metadata:g.metadata}]}),(0,k.$Vc)(()=>{this.b.delete(m)&&(this.d.fire({removed:[m]}),this.f.trace("[LM] UNregistered language model chat",m,g.metadata))})}async sendChatRequest(m,g,$,n,o){const t=this.b.get(m);if(!t)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return t.sendChatRequest($,g,n,o)}computeTokenLength(m,g,$){const n=this.b.get(m);if(!n)throw new Error(`Chat response provider with identifier ${m} is not registered.`);return n.provideTokenCount(g,$)}};e.$dH=w,e.$dH=w=Ye([Ve(0,I.$4G),Ve(1,c.$ak)],w)}),define(Se[322],De([1,0,255,18,25,161,36,4]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$II=void 0,r=Ue(r),a=Ue(a),k=Ue(k);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var c;(function(h){function P(w,l,m){if(!w)return;const g=a.$gg(w.type)?w.type:void 0;if(!g||g.length===0){m.error(r.localize(3,null));return}const $=[];if(Array.isArray(w.required))for(const n of w.required)a.$gg(n)&&$.push(n);return{extensionId:l.value,taskType:g,required:$,properties:w.properties?k.$fo(w.properties):{},when:w.when?O.$Ej.deserialize(w.when):void 0}}h.from=P})(c||(c={}));const I=A.$1G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,P)=>{for(const w of h)w.type&&P.push(`onTaskType:${w.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:p}});class S{constructor(){this.d=new R.$ne,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((P,w)=>{I.setHandler((l,m)=>{this.c=void 0;try{for(const g of m.removed){const $=g.value;for(const n of $)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const g of m.added){const $=g.value;for(const n of $){const o=c.from(n,g.description.identifier,g.collector);o&&(this.a[o.taskType]=o)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}P(void 0)})})}onReady(){return this.b}get(P){return this.a[P]}all(){return Object.keys(this.a).map(P=>this.a[P])}getJsonSchema(){if(this.c===void 0){const P=[];for(const w of this.all()){const l={type:"object",additionalProperties:!1};w.required.length>0&&(l.required=w.required.slice(0)),w.properties!==void 0?l.properties=k.$fo(w.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[w.taskType]},P.push(l)}this.c={oneOf:P}}return this.c}}e.$II=new S}),define(Se[323],De([1,0,256,18,23,25,36,322,46]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$SI=e.JsonSchemaVersion=e.ExecutionEngine=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$MI=e.ShellQuoting=e.$LI=e.$KI=e.$JI=void 0,r=Ue(r),a=Ue(a),k=Ue(k),A=Ue(A),e.$JI="settings",e.$KI=new O.$Xj("taskRunning",!1,r.localize(0,null)),e.$LI=r.localize2(2,"Tasks");var c;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$MI="$customized",function(L){function B(W){if(!W)return L.Strong;switch(W.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=B}(c||(e.ShellQuoting=c={}));var I;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var S;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(S||(e.RevealKind=S={})),function(L){function B(W){switch(W.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=B}(S||(e.RevealKind=S={}));var h;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(h||(e.RevealProblemKind=h={})),function(L){function B(W){switch(W.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=B}(h||(e.RevealProblemKind=h={}));var P;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(P||(e.PanelKind=P={})),function(L){function B(W){switch(W.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=B}(P||(e.PanelKind=P={}));var w;(function(L){L.defaults={echo:!0,reveal:S.Always,revealProblems:h.Never,focus:!1,panel:P.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var l;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(l||(e.RuntimeType=l={})),function(L){function B(ae){switch(ae.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=B;function W(ae){switch(ae){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=W}(l||(e.RuntimeType=l={}));var m;(function(L){function B(W){return a.$gg(W)?W:W.value}L.value=B})(m||(e.CommandString=m={}));var g;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function B(ae){return ae===L.Clean._id||ae===L.Build._id||ae===L.Rebuild._id||ae===L.Test._id}L.is=B;function W(ae){if(ae!==void 0)return a.$gg(ae)?B(ae)?{_id:ae,isDefault:!1}:void 0:ae}L.from=W})(g||(e.TaskGroup=g={}));var $;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})($||(e.TaskScope=$={}));var n;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function B(W){switch(W){case L.User:return p.ConfigurationTarget.USER;case L.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}L.toConfigurationTarget=B})(n||(e.TaskSourceKind=n={}));var o;(function(L){L.parallel="parallel",L.sequence="sequence"})(o||(e.DependsOrder=o={}));var t;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var i;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(i||(e.RunOptions=i={}));class s{constructor(B,W,ae,q,K,ee){this._label="",this._id=B,W&&(this._label=W),ae&&(this.type=ae),this.runOptions=q,this.configurationProperties=K,this._source=ee}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,W=!1){if(B===void 0)return!1;if(a.$gg(B))return B===this._label||B===this.configurationProperties.identifier||W&&B===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$NI=s;class d extends s{constructor(B,W,ae,q,K,ee,re,ge){super(B,ae,void 0,re,ge,W),this.command={},this._source=W,this.hasDefinedMatchers=ee,K&&(this.command=K)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case l.Shell:W="shell";break;case l.Process:W="process";break;case l.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(B){return B instanceof d}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$JI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let W=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(W+=this._source.kind);const ae={type:e.$MI,folder:B,id:W};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.$eh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new d(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$OI=d;class u extends s{constructor(B,W,ae,q,K,ee,re){super(B,ae,q,ee,re,W),this._source=W,this.configures=K}static is(B){return B instanceof u}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.$eh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$JI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let W=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(W+=this._source.kind);const ae={type:e.$MI,folder:B,id:W};return JSON.stringify(ae)}}e.$PI=u;class b extends s{constructor(B,W,ae,q,K,ee,re,ge,Z){super(B,ae,q,ge,Z,W),this.defines=K,this.hasDefinedMatchers=re,this.command=ee,this.icon=Z.icon,this.hide=Z.hide}clone(){return new b(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof b}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===$.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new b(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$QI=b;class E extends s{constructor(B,W,ae,q,K,ee){super(B,ae,q,K,ee,W),this._source=W}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new E(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$RI=E;var D;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(L){L._default=L.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class T{constructor(B){this.c=new Map;for(let W=0;W<B.length;W++)this.c.set(B[W].uri.toString(),W)}compare(B,W){const ae=B.getWorkspaceFolder(),q=W.getWorkspaceFolder();if(ae&&q){let K=this.c.get(ae.uri.toString());K=K===void 0?0:K+1;let ee=this.c.get(q.uri.toString());return ee=ee===void 0?0:ee+1,K===ee?B._label.localeCompare(W._label):K-ee}else return!ae&&q?-1:ae&&!q?1:0}}e.$SI=T;var C;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(C||(e.TaskEventKind=C={}));var v;(function(L){L.SingleRun="singleRun",L.Background="background"})(v||(e.TaskRunType=v={}));var f;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var N;(function(L){function B(ge){return{taskId:ge._id,taskName:ge.configurationProperties.name,runType:ge.configurationProperties.isBackground?v.Background:v.SingleRun,group:ge.configurationProperties.group,__task:ge}}function W(ge,Z,$e){return{...B(ge),kind:C.Start,terminalId:Z,resolvedVariables:$e}}L.start=W;function ae(ge,Z,$e){return{...B(ge),kind:C.ProcessStarted,terminalId:Z,processId:$e}}L.processStarted=ae;function q(ge,Z,$e){return{...B(ge),kind:C.ProcessEnded,terminalId:Z,exitCode:$e}}L.processEnded=q;function K(ge,Z,$e){return{...B(ge),kind:C.Terminated,exitReason:$e,terminalId:Z}}L.terminated=K;function ee(ge,Z,$e){return{...B(Z),kind:ge,terminalId:$e}}L.general=ee;function re(){return{kind:C.Changed}}L.changed=re})(N||(e.TaskEvent=N={}));var F;(function(L){function B(ae){const q=Object.keys(ae).sort();let K="";for(const ee of q){let re=ae[ee];re instanceof Object?re=B(re):typeof re=="string"&&(re=re.replace(/,/g,",,")),K+=ee+","+re+","}return K}function W(ae){const K={_key:B(ae),type:ae.taskType};return Object.assign(K,ae),K}L.create=W})(F||(e.KeyedTaskIdentifier=F={}));var j;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var z;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var M;(function(L){function B(W,ae){const q=R.$II.get(W.type);if(q===void 0){const ge=A.$fo(W);return delete ge._key,F.create(ge)}const K=Object.create(null);K.type=q.taskType;const ee=new Set;q.required.forEach(ge=>ee.add(ge));const re=q.properties;for(const ge of Object.keys(re)){const Z=W[ge];if(Z!=null)K[ge]=Z;else if(ee.has(ge)){const $e=re[ge];if($e.default!==void 0)K[ge]=A.$fo($e.default);else switch($e.type){case"boolean":K[ge]=!1;break;case"number":case"integer":K[ge]=0;break;case"string":K[ge]="";break;default:ae.error(r.localize(1,null,JSON.stringify(W,void 0,0),ge));return}}}return F.create(K)}L.createTaskIdentifier=B})(M||(e.TaskDefinition=M={}))}),define(Se[324],De([1,0,14]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=void 0;class a{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((O,R)=>{this.b=O,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(O){this.f||this.h||(this.f=!0,this.g=O,this.a&&this.b(O))}resolveErr(O){this.f||this.h||(this.h=!0,this.i=O,this.a?this.d(O):(0,r.$3)(O))}then(O,R){return this.j().then(O,R)}catch(O){return this.j().then(void 0,O)}finally(O){return this.j().finally(O)}}e.$5cc=a;class k extends a{constructor(){super(),this.h=!0,this.i=new r.$8}}e.$6cc=k}),define(Se[52],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=e.$Sw=void 0,e.$Tw=k,e.$Uw=A;class r{constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++r.count}}e.$Sw=r,r.count=0;const a=[];function k(R){const p=new r(R);return a[p.nid]=p,p}function A(R){return a[R].sid}class O{constructor(p){this.value=p}}e.$Vw=O}),define(Se[6],De([1,0,52]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$uN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var a;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(a||(e.TextEditorRevealType=a={}));var k;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput",l[l.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(k||(e.TabInputKind=k={}));var A;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var O;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(O||(e.WebviewEditorCapabilities=O={}));var R;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var p;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var c;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output",l[l.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class S{static mixin(m){return m._id=S.a++,m}}e.$uN=S,S.a=0;var h;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(h||(e.ISuggestDataDtoField=h={}));var P;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(P||(e.ISuggestResultDtoField=P={}));var w;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$vN={MainThreadAuthentication:(0,r.$Tw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Tw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Tw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Tw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Tw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Tw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,r.$Tw)("MainThreadChatSkills"),MainThreadClipboard:(0,r.$Tw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Tw)("MainThreadCommands"),MainThreadComments:(0,r.$Tw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Tw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Tw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Tw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Tw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Tw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Tw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Tw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Tw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Tw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Tw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Tw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Tw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Tw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Tw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Tw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Tw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Tw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Tw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Tw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Tw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Tw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Tw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Tw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Tw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Tw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Tw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Tw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Tw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Tw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Tw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Tw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Tw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Tw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Tw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Tw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Tw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Tw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Tw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Tw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Tw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Tw)("MainThreadSCM"),MainThreadSearch:(0,r.$Tw)("MainThreadSearch"),MainThreadShare:(0,r.$Tw)("MainThreadShare"),MainThreadTask:(0,r.$Tw)("MainThreadTask"),MainThreadWindow:(0,r.$Tw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Tw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Tw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Tw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Tw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Tw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Tw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Tw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Tw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Tw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Tw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Tw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Tw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Tw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Tw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Tw)("MainThreadAiEmbeddingVector")},e.$wN={ExtHostCommands:(0,r.$Tw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Tw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Tw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Tw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Tw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Tw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Tw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Tw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Tw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Tw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Tw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Tw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Tw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Tw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Tw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Tw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Tw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Tw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Tw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Tw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Tw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Tw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Tw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Tw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Tw)("ExtHostSCM"),ExtHostSearch:(0,r.$Tw)("ExtHostSearch"),ExtHostTask:(0,r.$Tw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Tw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Tw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Tw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Tw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Tw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Tw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Tw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Tw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Tw)("ExtHostProgress"),ExtHostComments:(0,r.$Tw)("ExtHostComments"),ExtHostSecretState:(0,r.$Tw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Tw)("ExtHostStorage"),ExtHostUrls:(0,r.$Tw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Tw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Tw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Tw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Tw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Tw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Tw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Tw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Tw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Tw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Tw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Tw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Tw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Tw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,r.$Tw)("ExtHostChatSkills"),ExtHostChatProvider:(0,r.$Tw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Tw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Tw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Tw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Tw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Tw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Tw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Tw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Tw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Tw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Tw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Tw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Tw)("ExtHostLocalization")}}),define(Se[96],De([1,0,5,12,6,20]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=e.$yoc=e.$xoc=void 0,k=Ue(k),e.$xoc=(0,r.$Gi)("IExtHostApiDeprecationService");let O=class{constructor(p,c){this.c=c,this.a=new Set,this.b=p.getProxy(k.$vN.MainThreadTelemetry)}report(p,c,I){const S=this.d(p,c);this.a.has(S)||(this.a.add(S),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:p}))}d(p,c){return`${p}-${c.identifier.value}`}};e.$yoc=O,e.$yoc=O=Ye([Ve(0,A.$2P),Ve(1,a.$ak)],O),e.$zoc=Object.freeze(new class{report(R,p,c){}})}),define(Se[325],De([1,0,6]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class a{constructor(A){const O=A.getProxy(r.$vN.MainThreadClipboard);this.value=Object.freeze({readText(){return O.$readText()},writeText(R){return O.$writeText(R)}})}}e.$Moc=a}),define(Se[326],De([1,0,25,6,30,20]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0;let O=class{constructor(I,S){this.a=I.getProxy(a.$vN.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,S){const h=this,P=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){h.e(I,S,P,arguments)}})}e(I,S,h,P){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:p(P,this.b)}),this.c&&this.f(I,h,P)}};e.$Iqc=O,e.$Iqc=O=Ye([Ve(0,A.$2P),Ve(1,k.$fQ)],O);const R=1e5;function p(c,I){const S=[];if(c.length)for(let h=0;h<c.length;h++){let P=c[h];if(typeof P>"u")P="undefined";else if(P instanceof Error){const w=P;w.stack?P=w.stack:P=w.toString()}S.push(P)}if(I){const h=new Error().stack;h&&S.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,r.$ko)(S);return h.length>R?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Se[327],De([1,0,2,6,26]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=void 0;class A{constructor(R){this.a=R.getProxy(a.$vN.MainThreadDialogs)}showOpenDialog(R,p){return p?.allowUIResources&&(0,k.$8G)(R,"showLocal"),this.a.$showOpenDialog(p).then(c=>c?c.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(R){return this.a.$showSaveDialog(R).then(p=>p?r.URI.revive(p):void 0)}}e.$Opc=A}),define(Se[328],De([1,0,21,4,3,6]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=void 0;class O{constructor(p){this.b=new Map,this.c=new a.$ne,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(A.$vN.MainThreadEmbeddings)}registerEmbeddingsProvider(p,c,I){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,c),this.b.set(S,{id:c,provider:I}),(0,k.$Vc)(()=>{this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(p,c,I){I??(I=r.CancellationToken.None);let S=!1;typeof c=="string"&&(c=[c],S=!0);const h=await this.a.$computeEmbeddings(p,c,I);if(h.length!==c.length)throw new Error;if(S){if(h.length!==1)throw new Error;return h[0]}return h}async $provideEmbeddings(p,c,I){const S=this.b.get(p);if(!S)return[];const h=await S.provider.provideEmbeddings(c,I);return h||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Rpc=O}),define(Se[329],De([1,0,3,6]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=void 0;class k{constructor(O){this.b=0,this.a=O.getProxy(a.$vN.MainThreadLabelService)}$registerResourceLabelFormatter(O){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,O),(0,r.$Vc)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.$9pc=k}),define(Se[124],De([1,0,11,13,2,5,12,6,30,20]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=e.$rpc=void 0;let I=class{constructor(h,P,w){this.f=w,this.d=new Map,this.a=P.getProxy(R.$vN.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===r.$a}getMessage(h,P){const{message:w,args:l,comment:m}=P;if(this.c)return(0,a.$gf)(w,l??{});let g=w;m&&m.length>0&&(g+=`/${Array.isArray(m)?m.join(""):m}`);const $=this.d.get(h)?.contents[g];return $||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${g}`),(0,a.$gf)($??w,l??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let P;const w=await this.g(h);if(!w){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(w),m=JSON.parse(l);P=h.isBuiltin?m.contents?.bundle:m}catch(l){this.f.error(`Failed to load translations for ${h.identifier.value} from ${w}: ${l.message}`);return}P&&this.d.set(h.identifier.value,{contents:P,uri:w})}async g(h){if(h.isBuiltin){const P=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return k.URI.revive(P)}return h.l10n?k.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$rpc=I,e.$rpc=I=Ye([Ve(0,p.$fQ),Ve(1,c.$2P),Ve(2,O.$ak)],I),e.$spc=(0,A.$Gi)("IExtHostLocalizationService")}),define(Se[162],De([1,0,12,6,30,20,2,55]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=void 0;let p=class extends r.$lk{constructor(S,h){super(h.logLevel,h.logsLocation,h.loggers.map(P=>(0,R.$di)(P))),this.r=S.getProxy(a.$vN.MainThreadLogger)}$setLogLevel(S,h){h?this.setLogLevel(O.URI.revive(h),S):this.setLogLevel(S)}setVisibility(S,h){super.setVisibility(S,h),this.r.$setVisibility(S,h)}s(S,h,P){return new c(this.r,S,h,P)}};e.$Hqc=p,e.$Hqc=p=Ye([Ve(0,A.$2P),Ve(1,k.$fQ)],p);class c extends r.$gk{constructor(S,h,P,w){super(w?.logLevel==="always"),this.r=S,this.s=h,this.m=!1,this.n=[],this.setLevel(P),this.r.$createLogger(h,w).then(()=>{this.u(this.n),this.m=!0})}g(S,h){const P=[[S,h]];this.m?this.u(P):this.n.push(...P)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Se[125],De([1,0,6,5,3,20,22]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=e.$tpc=void 0,e.$tpc=(0,a.$Gi)("IExtHostManagedSockets");let R=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(r.$vN.MainThreadManagedSockets)}setFactory(S,h){for(const P of this.d.values())P.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(S,h),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const h=++this.b,P=await this.c.makeConnection(),w=new k.$Wc;return this.d.set(h,new c(h,P,w)),w.add((0,k.$Vc)(()=>this.d.delete(h))),w.add(P.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(h),w.dispose()})),w.add(P.onDidClose(l=>{this.a.$onDidManagedSocketClose(h,l?.stack??l?.message),w.dispose()})),w.add(P.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(h,O.$Pe.wrap(l)))),h}$remoteSocketWrite(S,h){this.d.get(S)?.actual.send(h.buffer)}$remoteSocketEnd(S){const h=this.d.get(S);h&&(h.actual.end(),h.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$upc=R,e.$upc=R=Ye([Ve(0,A.$2P)],R);class p{constructor(S,h){this.socketFactoryId=S,this.makeConnection=h}}class c extends k.$Xc{constructor(S,h,P){super(),this.socketId=S,this.actual=h,this.B(P)}}}),define(Se[330],De([1,0,6,12,26]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;function A(R){return R&&R.title}let O=class{constructor(p,c){this.b=c,this.a=p.getProxy(r.$vN.MainThreadMessageService)}showMessage(p,c,I,S,h){const P={source:{identifier:p.identifier,label:p.displayName||p.name}};let w;typeof S=="string"||A(S)?w=[S,...h]:(P.modal=S?.modal,P.useCustom=S?.useCustom,P.detail=S?.detail,w=h),P.useCustom&&(0,k.$8G)(p,"resolvers");const l=[];let m=!1;for(let g=0;g<w.length;g++){const $=w[g];if(typeof $=="string")l.push({title:$,handle:g,isCloseAffordance:!1});else if(typeof $=="object"){const{title:n,isCloseAffordance:o}=$;l.push({title:n,isCloseAffordance:!!o,handle:g}),o&&(m?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,$):m=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,$)}return this.a.$showMessage(c,I,P,l).then(g=>{if(typeof g=="number")return w[g]})}};e.$_pc=O,e.$_pc=O=Ye([Ve(1,a.$ak)],O)}),define(Se[331],De([1,0,3,18,2,26,6]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=void 0;class R{constructor(c){this.b=new Map,this.a=c.getProxy(O.$vN.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,I,S){if((0,A.$8G)(c,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,S),this.a.$registerProfileContentHandler(I,S.name,S.description,c.identifier.value),(0,r.$Vc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(c,I,S,h){const P=this.b.get(c);if(!P)throw new Error(`Unknown handler with id: ${c}`);return P.saveProfile(I,S,h)}async $readProfile(c,I,S){const h=this.b.get(c);if(!h)throw new Error(`Unknown handler with id: ${c}`);return h.readProfile((0,a.$gg)(I)?I:k.URI.revive(I),S)}}e.$iqc=R}),define(Se[126],De([1,0,6,4,5]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=void 0;class A{constructor(R){this.b=new a.$ne,this.onDidChangePassword=this.b.event,this.a=R.getProxy(r.$vN.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,p){return this.a.$getPassword(R,p)}store(R,p,c){return this.a.$setPassword(R,p,c)}delete(R,p){return this.a.$deletePassword(R,p)}}e.$opc=A,e.$ppc=(0,k.$Gi)("IExtHostSecretState")}),define(Se[332],De([1,0,21,3,6]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=void 0;class A{constructor(R){this.c=new Map,this.d=new Map,this.f=new Map,this.b=R.getProxy(k.$vN.MainThreadSpeech)}async $createSpeechToTextSession(R,p,c){const I=this.c.get(R);if(!I)return;const S=new a.$Wc,h=new r.$ye;this.d.set(p,h);const P=await I.provideSpeechToTextSession(h.token,c?{language:c}:void 0);P&&(S.add(P.onDidChange(w=>{h.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,w)})),S.add(h.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}async $createTextToSpeechSession(R,p,c){const I=this.c.get(R);if(!I)return;const S=new a.$Wc,h=new r.$ye;this.d.set(p,h);const P=await I.provideTextToSpeechSession(h.token,c?{language:c}:void 0);P&&(this.f.set(p,P),S.add(P.onDidChange(w=>{h.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,w)})),S.add(h.token.onCancellationRequested(()=>S.dispose())))}async $synthesizeSpeech(R,p){this.f.get(R)?.synthesize(p)}async $cancelTextToSpeechSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R),this.f.delete(R)}async $createKeywordRecognitionSession(R,p){const c=this.c.get(R);if(!c)return;const I=new a.$Wc,S=new r.$ye;this.d.set(p,S);const h=await c.provideKeywordRecognitionSession(S.token);h&&(I.add(h.onDidChange(P=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,P)})),I.add(S.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}registerProvider(R,p,c){const I=A.a++;return this.c.set(I,c),this.b.$registerProvider(I,p,{extension:R,displayName:R.value}),(0,a.$Vc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$pqc=A,A.a=1}),define(Se[127],De([1,0,6,4,5]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0;class A{constructor(R,p){this.c=p,this.b=new a.$ne,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(r.$vN.MainThreadStorage)}registerExtensionStorageKeysToSync(R,p){this.a.$registerExtensionStorageKeysToSync(R,p)}async initializeExtensionStorage(R,p,c){const I=await this.a.$initializeExtensionStorage(R,p);let S;return I&&(S=this.d(R,p,I)),S||c}setValue(R,p,c){return this.a.$setValue(R,p,c)}$acceptValue(R,p,c){const I=this.d(R,p,c);I&&this.b.fire({shared:R,key:p,value:I})}d(R,p,c){try{return JSON.parse(c)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${R}): ${I}`)}}}e.$epc=A,e.$fpc=(0,k.$Gi)("IExtHostStorage")}),define(Se[333],De([1,0,3,15,2,6]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=void 0;class O{constructor(p){this.c=new Map,this.b=p.getProxy(A.$vN.MainThreadUriOpeners)}registerExternalUriOpener(p,c,I,S){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const h=S.schemes.find(P=>!O.a.has(P));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(c,I),this.b.$registerUriOpener(c,S.schemes,p,S.label),(0,r.$Vc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(p,c,I){const S=this.c.get(p);if(!S)throw new Error(`Unknown opener with id: ${p}`);const h=k.URI.revive(c);return S.canOpenExternalUri(h,I)}async $openUri(p,c,I){const S=this.c.get(p);if(!S)throw new Error(`Unknown opener id: '${p}'`);return S.openExternalUri(k.URI.revive(c.resolvedUri),{sourceUri:k.URI.revive(c.sourceUri)},I)}}e.$Bqc=O,O.a=new Set([a.Schemas.http,a.Schemas.https])}),define(Se[334],De([1,0,6,2,3,14,24]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0;class R{constructor(c){this.c=new O.$tn,this.d=new Map,this.b=c.getProxy(r.$vN.MainThreadUrls)}registerUriHandler(c,I){const S=c.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const h=R.a++;return this.c.add(S),this.d.set(h,I),this.b.$registerUriHandler(h,S,c.displayName||c.name),(0,k.$Vc)(()=>{this.c.delete(S),this.d.delete(h),this.b.$unregisterUriHandler(h)})}$handleExternalUri(c,I){const S=this.d.get(c);if(!S)return Promise.resolve(void 0);try{S.handleUri(a.URI.revive(I))}catch(h){(0,A.$3)(h)}return Promise.resolve(void 0)}async createAppUri(c){return a.URI.revive(await this.b.$createAppUri(c))}}e.$Cqc=R,R.a=0}),define(Se[335],De([1,0,22,6]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Itb=A,e.$Jtb=R,a=Ue(a);class k{constructor(){this.buffers=[]}add(c){let I=this.buffers.indexOf(c);return I<0&&(I=this.buffers.length,this.buffers.push(c)),I}}function A(p,c){if(c.serializeBuffersForPostMessage){const I=new k,h=JSON.stringify(p,(w,l)=>{if(l instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(l)};if(ArrayBuffer.isView(l)){const m=O(l);if(m)return{$$vscode_array_buffer_reference$$:!0,index:I.add(l.buffer),view:{type:m,byteLength:l.byteLength,byteOffset:l.byteOffset}}}return l}),P=I.buffers.map(w=>{const l=new Uint8Array(w);return r.$Pe.wrap(l)});return{message:h,buffers:P}}else return{message:JSON.stringify(p),buffers:[]}}function O(p){switch(p.constructor.name){case"Int8Array":return a.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return a.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return a.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return a.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return a.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return a.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return a.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return a.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return a.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return a.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return a.WebviewMessageArrayBufferViewType.BigUint64Array}}function R(p,c){const I=c.map(P=>{const w=new ArrayBuffer(P.byteLength);return new Uint8Array(w).set(P.buffer),w}),S=c.length?(P,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const l=w,{index:m}=l,g=I[m];if(l.view)switch(l.view.type){case a.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(g,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(g,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(g,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(g,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(g,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(g,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(g,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(g,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(g,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(g,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case a.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(g,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return w}:void 0;return{message:JSON.parse(p,S),arrayBuffers:I}}});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[97],De([1,0,4,3,15,25,2,285,335,123,6]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";var S,h,P,w,l,m,g,$,n,o,t,i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=e.$2oc=void 0,e.$3oc=u,e.$5oc=D,e.$6oc=y,A=Ue(A),I=Ue(I);class d{constructor(f,N,F,j,z,M,L){S.set(this,void 0),h.set(this,void 0),P.set(this,void 0),w.set(this,void 0),l.set(this,void 0),m.set(this,void 0),g.set(this,""),$.set(this,void 0),n.set(this,!1),o.set(this,!1),t.set(this,void 0),i.set(this,void 0),this._onMessageEmitter=new r.$ne,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new r.$ne),this._onDidDispose=He(this,s,"f").event,ot(this,S,f,"f"),ot(this,h,N,"f"),ot(this,$,F,"f"),ot(this,w,j,"f"),ot(this,l,z,"f"),ot(this,m,M,"f"),ot(this,t,u(M),"f"),ot(this,i,b(M),"f"),ot(this,P,L,"f")}dispose(){ot(this,n,!0,"f"),He(this,s,"f").fire(),He(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return ot(this,o,!0,"f"),(0,c.$qDb)(f,He(this,w,"f"))}get cspSource(){const f=He(this,m,"f").extensionLocation;if(f.scheme===k.Schemas.https||f.scheme===k.Schemas.http){let N=f.toString();return N.endsWith("/")||(N+="/"),N+" "+c.$pDb}return c.$pDb}get html(){return this.a(),He(this,g,"f")}set html(f){this.a(),He(this,g,"f")!==f&&(ot(this,g,f,"f"),He(this,i,"f")&&!He(this,o,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(ot(this,o,!0,"f"),He(this,P,"f").report("Webview vscode-resource: uris",He(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),He(this,h,"f").$setHtml(He(this,S,"f"),this.b(f)))}get options(){return this.a(),He(this,$,"f")}set options(f){this.a(),A.$jo(He(this,$,"f"),f)||He(this,h,"f").$setOptions(He(this,S,"f"),y(He(this,m,"f"),He(this,l,"f"),f)),ot(this,$,f,"f")}async postMessage(f){if(He(this,n,"f"))return!1;const N=(0,p.$Itb)(f,{serializeBuffersForPostMessage:He(this,t,"f")});return He(this,h,"f").$postMessage(He(this,S,"f"),N.message,...N.buffers)}a(){if(He(this,n,"f"))throw new Error("Webview is disposed")}b(f){if(!He(this,i,"f"))return f;const N=He(this,m,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,F=He(this,m,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?He(this,m,"f").extensionLocation.authority:void 0;return f.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,z,M,L,B,W)=>{const ae=O.URI.from({scheme:L||"file",path:decodeURIComponent(B)}),q=(0,c.$qDb)(ae,{isRemote:N,authority:F}).toString();return`${z}${q}${W}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(j,z,M,L,B,W)=>{const ae=O.URI.from({scheme:L||"file",path:decodeURIComponent(B)}),q=(0,c.$qDb)(ae,{isRemote:N,authority:F}).toString();return`${z}${q}${W}`})}}e.$2oc=d,S=new WeakMap,h=new WeakMap,P=new WeakMap,w=new WeakMap,l=new WeakMap,m=new WeakMap,g=new WeakMap,$=new WeakMap,n=new WeakMap,o=new WeakMap,t=new WeakMap,i=new WeakMap,s=new WeakMap;function u(v){try{const f=(0,R.$1p)((0,R.$Zp)(v.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}function b(v){try{const f=(0,R.$1p)((0,R.$Zp)(v.engines.vscode));return f?f.majorBase<1||f.majorBase===1&&f.minorBase<60:!1}catch{return!1}}class E extends a.$Xc{constructor(f,N,F,j,z){super(),this.c=N,this.f=F,this.g=j,this.h=z,this.b=new Map,this.a=f.getProxy(I.$vN.MainThreadWebviews)}dispose(){super.dispose();for(const f of this.b.values())f.dispose();this.b.clear()}$onMessage(f,N,F){const j=this.j(f);if(j){const{message:z}=(0,p.$Jtb)(N,F.value);j._onMessageEmitter.fire(z)}}$onMissingCsp(f,N){this.g.warn(`${N} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,N,F){const j=new d(f,this.a,T(N),this.c,this.f,F,this.h);this.b.set(f,j);const z=j._onDidDispose(()=>{z.dispose(),this.deleteWebview(f)});return j}deleteWebview(f){this.b.delete(f)}j(f){return this.b.get(f)}}e.$4oc=E;function D(v){return{id:v.identifier,location:v.extensionLocation}}function y(v,f,N){return{enableCommandUris:N.enableCommandUris,enableScripts:N.enableScripts,enableForms:N.enableForms,portMapping:N.portMapping,localResourceRoots:N.localResourceRoots||C(v,f)}}function T(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(f=>O.URI.from(f))}}function C(v,f){return[...(f?.getWorkspaceFolders()||[]).map(N=>N.uri),v.extensionLocation]}}),define(Se[163],De([1,0,4,15,13,2,5,20,6]),function(ie,e,r,a,k,A,O,R,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=e.$Eqc=void 0;let I=c=class{getState(){const h=this.d;return{get focused(){return h.focused},get active(){return h.active}}}constructor(h){this.c=new r.$ne,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=h.getProxy(p.$vN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:P,isActive:w})=>{this.onDidChangeWindowProperty("focused",P),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(h){this.onDidChangeWindowProperty("focused",h)}$onDidChangeWindowActive(h){this.onDidChangeWindowProperty("active",h)}onDidChangeWindowProperty(h,P){P!==this.d[h]&&(this.d={...this.d,[h]:P},this.c.fire(this.d))}openUri(h,P){let w;if(typeof h=="string"){w=h;try{h=A.URI.parse(h)}catch{return Promise.reject(`Invalid uri - '${h}'`)}}return(0,k.$ef)(h.scheme)?Promise.reject("Invalid scheme - cannot be empty"):h.scheme===a.Schemas.command?Promise.reject(`Invalid scheme '${h.scheme}'`):this.b.$openUri(h,w,P)}async asExternalUri(h,P){if((0,k.$ef)(h.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(h,P);return A.URI.from(w)}};e.$Eqc=I,I.a={focused:!0,active:!0},e.$Eqc=I=c=Ye([Ve(0,R.$2P)],I),e.$Fqc=(0,O.$Gi)("IExtHostWindow")}),define(Se[336],De([1,0,326,30,20,94]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=void 0;const O=1024*1024;let R=class extends r.$Iqc{constructor(c,I){super(c,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(c,I,S){const h=c==="error"||c==="warn"?process.stderr:process.stdout;this.g=!0,h.write(`
${A.NativeLogMarkers.Start}
`),I.apply(console,S),h.write(`
${A.NativeLogMarkers.End}
`),this.g=!1}j(c,I){const S=process[c],h=S.write;let P="";Object.defineProperty(S,"write",{set:()=>{},get:()=>(w,l,m)=>{if(!this.g){P+=w.toString(l);const g=P.length>O?P.length:P.lastIndexOf(`
`);g!==-1&&(console[I](P.slice(0,g)),P=P.slice(g+1))}h.call(S,w,l,m)}})}};e.$hrc=R,e.$hrc=R=Ye([Ve(0,k.$2P),Ve(1,a.$fQ)],R)}),define(Se[337],De([1,0,162,15,279,33]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=void 0;class O extends r.$Hqc{s(p,c,I){return p.scheme===a.Schemas.file?new k.$fR(I?.name||(0,A.$3g)(),p.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,c):super.s(p,c,I)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$trc=O}),define(Se[338],De([1,0,7,22,21,27,14,4,3,41,140,324,52]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.ResponsiveState=e.RequestInitiator=void 0,e.$7cc=$,e.$8cc=n,O=Ue(O);function w(N,F){try{return JSON.stringify(N,F)}catch{return"null"}}const l="$$ref$$",m={[l]:-1};class g{constructor(F,j){this.jsonString=F,this.referencedBuffers=j}}function $(N,F=null,j=!1){const z=[];return{jsonString:(j?w:JSON.stringify)(N,(L,B)=>{if(typeof B>"u")return m;if(typeof B=="object"){if(B instanceof a.$Pe){const W=z.push(B)-1;return{[l]:W}}if(F)return F(L,B)}return B}),referencedBuffers:z}}function n(N,F,j){return JSON.parse(N,(z,M)=>{if(M){const L=M[l];if(typeof L=="number")return F[L];if(j&&M.$mid===c.MarshalledId.Uri)return j.transformIncoming(M)}return M})}function o(N,F){return JSON.stringify(N,F)}function t(N){return N?(F,j)=>j&&j.$mid===c.MarshalledId.Uri?N.transformOutgoing(j):j:null}var i;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(i||(e.RequestInitiator=i={}));var s;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const d=()=>{},u=Symbol.for("rpcProtocol"),b=Symbol.for("rpcProxy");class E extends p.$Xc{constructor(F,j=null,z=null){super(),this[P]=!0,this.b=this.B(new R.$ne),this.onDidChangeResponsiveState=this.b.event,this.c=F,this.f=j,this.g=z,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,L=h.$Sw.count;M<L;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=s.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Sh(()=>this.H(),1e3)),this.B(this.c.onMessage(M=>this.L(M)))}dispose(){this.j=!0,Object.keys(this.w).forEach(F=>{const j=this.w[F];delete this.w[F],j.resolveErr(O.$9())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(F){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(F){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(s.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(s.Unresponsive):this.D.schedule())}I(F){this.y!==F&&(this.y=F,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(F){return this.g?(0,I.$Qn)(F,this.g):F}getProxy(F){const{nid:j,sid:z}=F;return this.s[j]||(this.s[j]=this.J(j,z)),this.s[j]}J(F,j){const z={get:(M,L)=>(typeof L=="string"&&!M[L]&&L.charCodeAt(0)===A.CharCode.DollarSign&&(M[L]=(...B)=>this.U(F,L,B)),L===b?j:M[L])};return new Proxy(Object.create(null),z)}set(F,j){return this.m[F.nid]=j,j}assertRegistered(F){for(let j=0,z=F.length;j<z;j++){const M=F[j];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(F){if(this.j)return;const j=F.byteLength,z=y.read(F,0),M=z.readUInt8(),L=z.readUInt32();switch(M){case v.RequestJSONArgs:case v.RequestJSONArgsWithCancellation:{let{rpcId:B,method:W,args:ae}=C.deserializeRequestJSONArgs(z);this.g&&(ae=(0,I.$Qn)(ae,this.g)),this.M(j,L,B,W,ae,M===v.RequestJSONArgsWithCancellation);break}case v.RequestMixedArgs:case v.RequestMixedArgsWithCancellation:{let{rpcId:B,method:W,args:ae}=C.deserializeRequestMixedArgs(z);this.g&&(ae=(0,I.$Qn)(ae,this.g)),this.M(j,L,B,W,ae,M===v.RequestMixedArgsWithCancellation);break}case v.Acknowledged:{this.f?.logIncoming(j,L,i.LocalSide,"ack"),this.G(L);break}case v.Cancel:{this.N(j,L);break}case v.ReplyOKEmpty:{this.O(j,L,void 0);break}case v.ReplyOKJSON:{let B=C.deserializeReplyOKJSON(z);this.g&&(B=(0,I.$Qn)(B,this.g)),this.O(j,L,B);break}case v.ReplyOKJSONWithBuffers:{const B=C.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(j,L,B);break}case v.ReplyOKVSBuffer:{const B=C.deserializeReplyOKVSBuffer(z);this.O(j,L,B);break}case v.ReplyErrError:{let B=C.deserializeReplyErrError(z);this.g&&(B=(0,I.$Qn)(B,this.g)),this.P(j,L,B);break}case v.ReplyErrEmpty:{this.P(j,L,void 0);break}default:console.error("received unexpected message"),console.error(F)}}M(F,j,z,M,L,B){this.f?.logIncoming(F,j,i.OtherSide,`receiveRequest ${(0,h.$Uw)(z)}.${M}(`,L);const W=String(j);let ae,q;if(B){const ee=new k.$ye;L.push(ee.token),ae=this.Q(z,M,L),q=()=>ee.cancel()}else ae=this.Q(z,M,L),q=d;this.u[W]=q;const K=C.serializeAcknowledged(j);this.f?.logOutgoing(K.byteLength,j,i.OtherSide,"ack"),this.c.send(K),ae.then(ee=>{delete this.u[W];const re=C.serializeReplyOK(j,ee,this.h);this.f?.logOutgoing(re.byteLength,j,i.OtherSide,"reply:",ee),this.c.send(re)},ee=>{delete this.u[W];const re=C.serializeReplyErr(j,ee);this.f?.logOutgoing(re.byteLength,j,i.OtherSide,"replyErr:",ee),this.c.send(re)})}N(F,j){this.f?.logIncoming(F,j,i.OtherSide,"receiveCancel");const z=String(j);this.u[z]?.()}O(F,j,z){this.f?.logIncoming(F,j,i.LocalSide,"receiveReply:",z);const M=String(j);if(!this.w.hasOwnProperty(M))return;const L=this.w[M];delete this.w[M],L.resolveOk(z)}P(F,j,z){this.f?.logIncoming(F,j,i.LocalSide,"receiveReplyErr:",z);const M=String(j);if(!this.w.hasOwnProperty(M))return;const L=this.w[M];delete this.w[M];let B;z&&(z.$isError?(B=new Error,B.name=z.name,B.message=z.message,B.stack=z.stack):B=z),L.resolveErr(B)}Q(F,j,z){try{return Promise.resolve(this.S(F,j,z))}catch(M){return Promise.reject(M)}}S(F,j,z){const M=this.m[F];if(!M)throw new Error("Unknown actor "+(0,h.$Uw)(F));const L=M[j];if(typeof L!="function")throw new Error("Unknown method "+j+" on actor "+(0,h.$Uw)(F));return L.apply(M,z)}U(F,j,z){if(this.j)return new S.$6cc;let M=null;if(z.length>0&&k.CancellationToken.isCancellationToken(z[z.length-1])&&(M=z.pop()),M&&M.isCancellationRequested)return Promise.reject(O.$9());const L=C.serializeRequestArguments(z,this.h),B=++this.t,W=String(B),ae=new S.$5cc,q=new p.$Wc;M&&q.add(M.onCancellationRequested(()=>{const ee=C.serializeCancel(B);this.f?.logOutgoing(ee.byteLength,B,i.LocalSide,"cancel"),this.c.send(C.serializeCancel(B))})),this.w[W]=new D(ae,q),this.F(B);const K=C.serializeRequest(B,F,j,L,!!M);return this.f?.logOutgoing(K.byteLength,B,i.LocalSide,`request: ${(0,h.$Uw)(F)}.${j}(`,z),this.c.send(K),ae}}e.$9cc=E,P=u,E.a=3*1e3;class D{constructor(F,j){this.a=F,this.b=j}resolveOk(F){this.a.resolveOk(F),this.b.dispose()}resolveErr(F){this.a.resolveErr(F),this.b.dispose()}}class y{static alloc(F,j,z){const M=new y(a.$Pe.alloc(z+1+4),0);return M.writeUInt8(F),M.writeUInt32(j),M}static read(F,j){return new y(F,j)}get buffer(){return this.a}constructor(F,j){this.a=F,this.b=j}static sizeUInt8(){return 1}writeUInt8(F){this.a.writeUInt8(F,this.b),this.b+=1}readUInt8(){const F=this.a.readUInt8(this.b);return this.b+=1,F}writeUInt32(F){this.a.writeUInt32BE(F,this.b),this.b+=4}readUInt32(){const F=this.a.readUInt32BE(this.b);return this.b+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this.a.writeUInt8(F.byteLength,this.b),this.b+=1,this.a.set(F,this.b),this.b+=F.byteLength}readShortString(){const F=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+F).toString();return this.b+=F,z}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readLongString(){const F=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+F).toString();return this.b+=F,z}writeBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readVSBuffer(){const F=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+F);return this.b+=F,j}static sizeMixedArray(F){let j=0;j+=1;for(let z=0,M=F.length;z<M;z++){const L=F[z];switch(j+=1,L.type){case f.String:j+=this.sizeLongString(L.value);break;case f.VSBuffer:j+=this.sizeVSBuffer(L.value);break;case f.SerializedObjectWithBuffers:j+=this.sizeUInt32,j+=this.sizeLongString(L.value);for(let B=0;B<L.buffers.length;++B)j+=this.sizeVSBuffer(L.buffers[B]);break;case f.Undefined:break}}return j}writeMixedArray(F){this.a.writeUInt8(F.length,this.b),this.b+=1;for(let j=0,z=F.length;j<z;j++){const M=F[j];switch(M.type){case f.String:this.writeUInt8(f.String),this.writeLongString(M.value);break;case f.VSBuffer:this.writeUInt8(f.VSBuffer),this.writeVSBuffer(M.value);break;case f.SerializedObjectWithBuffers:this.writeUInt8(f.SerializedObjectWithBuffers),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let L=0;L<M.buffers.length;++L)this.writeBuffer(M.buffers[L]);break;case f.Undefined:this.writeUInt8(f.Undefined);break}}}readMixedArray(){const F=this.a.readUInt8(this.b);this.b+=1;const j=new Array(F);for(let z=0;z<F;z++)switch(this.readUInt8()){case f.String:j[z]=this.readLongString();break;case f.VSBuffer:j[z]=this.readVSBuffer();break;case f.SerializedObjectWithBuffers:{const L=this.readUInt32(),B=this.readLongString(),W=[];for(let ae=0;ae<L;++ae)W.push(this.readVSBuffer());j[z]=new h.$Vw(n(B,W,null));break}case f.Undefined:j[z]=void 0;break}return j}}y.sizeUInt32=4;var T;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(T||(T={}));class C{static a(F){for(let j=0,z=F.length;j<z;j++)if(F[j]instanceof a.$Pe||F[j]instanceof h.$Vw||typeof F[j]>"u")return!0;return!1}static serializeRequestArguments(F,j){if(this.a(F)){const z=[];for(let M=0,L=F.length;M<L;M++){const B=F[M];if(B instanceof a.$Pe)z[M]={type:f.VSBuffer,value:B};else if(typeof B>"u")z[M]={type:f.Undefined};else if(B instanceof h.$Vw){const{jsonString:W,referencedBuffers:ae}=$(B.value,j);z[M]={type:f.SerializedObjectWithBuffers,value:a.$Pe.fromString(W),buffers:ae}}else z[M]={type:f.String,value:a.$Pe.fromString(o(B,j))}}return{type:T.Mixed,args:z}}return{type:T.Simple,args:o(F,j)}}static serializeRequest(F,j,z,M,L){switch(M.type){case T.Simple:return this.b(F,j,z,M.args,L);case T.Mixed:return this.c(F,j,z,M.args,L)}}static b(F,j,z,M,L){const B=a.$Pe.fromString(z),W=a.$Pe.fromString(M);let ae=0;ae+=y.sizeUInt8(),ae+=y.sizeShortString(B),ae+=y.sizeLongString(W);const q=y.alloc(L?v.RequestJSONArgsWithCancellation:v.RequestJSONArgs,F,ae);return q.writeUInt8(j),q.writeShortString(B),q.writeLongString(W),q.buffer}static deserializeRequestJSONArgs(F){const j=F.readUInt8(),z=F.readShortString(),M=F.readLongString();return{rpcId:j,method:z,args:JSON.parse(M)}}static c(F,j,z,M,L){const B=a.$Pe.fromString(z);let W=0;W+=y.sizeUInt8(),W+=y.sizeShortString(B),W+=y.sizeMixedArray(M);const ae=y.alloc(L?v.RequestMixedArgsWithCancellation:v.RequestMixedArgs,F,W);return ae.writeUInt8(j),ae.writeShortString(B),ae.writeMixedArray(M),ae.buffer}static deserializeRequestMixedArgs(F){const j=F.readUInt8(),z=F.readShortString(),M=F.readMixedArray(),L=new Array(M.length);for(let B=0,W=M.length;B<W;B++){const ae=M[B];typeof ae=="string"?L[B]=JSON.parse(ae):L[B]=ae}return{rpcId:j,method:z,args:L}}static serializeAcknowledged(F){return y.alloc(v.Acknowledged,F,0).buffer}static serializeCancel(F){return y.alloc(v.Cancel,F,0).buffer}static serializeReplyOK(F,j,z){if(typeof j>"u")return this.d(F);if(j instanceof a.$Pe)return this.e(F,j);if(j instanceof h.$Vw){const{jsonString:M,referencedBuffers:L}=$(j.value,z,!0);return this.g(F,M,L)}else return this.f(F,w(j,z))}static d(F){return y.alloc(v.ReplyOKEmpty,F,0).buffer}static e(F,j){let z=0;z+=y.sizeVSBuffer(j);const M=y.alloc(v.ReplyOKVSBuffer,F,z);return M.writeVSBuffer(j),M.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static f(F,j){const z=a.$Pe.fromString(j);let M=0;M+=y.sizeLongString(z);const L=y.alloc(v.ReplyOKJSON,F,M);return L.writeLongString(z),L.buffer}static g(F,j,z){const M=a.$Pe.fromString(j);let L=0;L+=y.sizeUInt32,L+=y.sizeLongString(M);for(const W of z)L+=y.sizeVSBuffer(W);const B=y.alloc(v.ReplyOKJSONWithBuffers,F,L);B.writeUInt32(z.length),B.writeLongString(M);for(const W of z)B.writeBuffer(W);return B.buffer}static deserializeReplyOKJSON(F){const j=F.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(F,j){const z=F.readUInt32(),M=F.readLongString(),L=[];for(let B=0;B<z;++B)L.push(F.readVSBuffer());return new h.$Vw(n(M,L,j))}static serializeReplyErr(F,j){const z=j?w(O.$5(j),null):void 0;if(typeof z!="string")return this.h(F);const M=a.$Pe.fromString(z);let L=0;L+=y.sizeLongString(M);const B=y.alloc(v.ReplyErrError,F,L);return B.writeLongString(M),B.buffer}static deserializeReplyErrError(F){const j=F.readLongString();return JSON.parse(j)}static h(F){return y.alloc(v.ReplyErrEmpty,F,0).buffer}}var v;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var f;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(f||(f={}))}),define(Se[339],De([1,0,22,29,15,89,5]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.$fL=void 0,e.$gL=I,e.$hL=S,e.$fL=(0,O.$Gi)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${R.join("")}]+`),c=7;function I(P){if(P.scheme!==k.Schemas.vscodeNotebookCell)return;const w=P.fragment.indexOf("s");if(w<0)return;const l=parseInt(P.fragment.substring(0,w).replace(p,""),c),m=(0,r.$9e)(P.fragment.substring(w+1)).toString();if(!isNaN(l))return{handle:l,notebook:P.with({scheme:m,fragment:null})}}function S(P,w){const l=w.toString(c),g=`${l.length<R.length?R[l.length-1]:"z"}${l}s${(0,r.$0e)(r.$Pe.fromString(P.scheme),!0,!0)}`;return P.with({scheme:k.Schemas.vscodeNotebookCell,fragment:g})}class h{constructor(){this.a=new a.$Dc}getNotebook(w){if(w.scheme===k.Schemas.vscodeNotebookCell){const l=I(w);if(l){const m=this.a.get(l.notebook);if(m)return m}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$iL=h,(0,A.$Qs)(e.$fL,h,A.InstantiationType.Delayed)}),define(Se[128],De([1,0,22,39,40,104,15,17,11,36,339]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$zL=e.CellStatusbarAlignment=e.$yL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$vL=e.$uL=e.$sL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$rL=e.$qL=e.$pL=e.$oL=e.CellKind=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=void 0,e.$tL=s,e.$wL=b,e.$xL=E,e.$AL=T,e.$BL=v,a=Ue(a),e.$jL="workbench.editor.notebook",e.$kL="workbench.editor.notebookTextDiffEditor",e.$lL="workbench.editor.interactive",e.$mL="workbench.editor.repl",e.$nL="replNotebook.input.execute";var S;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(S||(e.CellKind=S={})),e.$oL=["application/json","application/javascript","text/html","image/svg+xml",A.$0s.latex,A.$0s.markdown,"image/png","image/jpeg",A.$0s.text],e.$pL=[A.$0s.latex,A.$0s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$0s.text],e.$qL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$rL="_notAvailable";var h;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(h||(e.NotebookRunState=h={}));var P;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(P||(e.NotebookCellExecutionState=P={}));var w;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var l;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(l||(e.NotebookRendererMatch=l={}));var m;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var g;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(g||(e.NotebookCellsChangeType=g={}));var $;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})($||(e.SelectionStateType=$={}));var n;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(W){W.scheme=O.Schemas.vscodeNotebookCell;function ae(Z,$e){return(0,I.$hL)(Z,$e)}W.generate=ae;function q(Z){return(0,I.$gL)(Z)}W.parse=q;function K(Z,$e){return Z.with({scheme:O.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${Z.scheme!==O.Schemas.file?Z.scheme:""}`})}W.generateCellOutputUri=K;function ee(Z){if(Z.scheme!==O.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Z.fragment);if(!$e)return;const fe=$e[1]&&$e[1]!==""?$e[1]:void 0,oe=$e[2];return{outputId:fe,notebook:Z.with({scheme:oe||O.Schemas.file,fragment:null})}}W.parseCellOutputUri=ee;function re(Z,$e,fe){return W.generate(Z,$e).with({scheme:fe})}W.generateCellPropertyUri=re;function ge(Z,$e){if(Z.scheme===$e)return W.parse(Z.with({scheme:W.scheme}))}W.parseCellPropertyUri=ge})(o||(e.CellUri=o={}));const t=W=>p.$c?W.replace(/\//g,"\\"):W;class i{constructor(ae=[],q=e.$oL){this.e=q,this.d=[...new Set(ae)].map(K=>({pattern:K,matches:a.$Ak(t(K))}))}sort(ae){const q=new Map(k.Iterable.map(ae,ee=>[ee,t(ee)]));let K=[];for(const{matches:ee}of this.d)for(const[re,ge]of q)if(ee(ge)){K.push(re),q.delete(re);break}return q.size&&(K=K.concat([...q.keys()].sort((ee,re)=>this.e.indexOf(ee)-this.e.indexOf(re)))),K}prioritize(ae,q){const K=this.f(ae);if(K===-1){this.d.unshift({pattern:ae,matches:a.$Ak(t(ae))});return}const ee=new Set(q.map(ge=>this.f(ge,K)));ee.delete(-1);const re=Array.from(ee).sort();this.d.splice(K+1,0,...re.map(ge=>this.d[ge]));for(let ge=re.length-1;ge>=0;ge--)this.d.splice(re[ge],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,q=this.d.length){const K=t(ae);for(let ee=0;ee<q;ee++)if(this.d[ee].matches(K))return ee;return-1}}e.$sL=i;function s(W,ae,q,K=(ee,re)=>ee===re){const ee=[];function re($e,fe,oe){if(fe===0&&oe.length===0)return;const H=ee[ee.length-1];H&&H.start+H.deleteCount===$e?(H.deleteCount+=fe,H.toInsert.push(...oe)):ee.push({start:$e,deleteCount:fe,toInsert:oe})}let ge=0,Z=0;for(;;){if(ge===W.length){re(ge,0,ae.slice(Z));break}if(Z===ae.length){re(ge,W.length-ge,[]);break}const $e=W[ge],fe=ae[Z];if(K($e,fe)){ge+=1,Z+=1;continue}q(fe)?(re(ge,1,[]),ge+=1):(re(ge,0,[fe]),Z+=1)}return ee}e.$uL=new c.$Xj("notebookEditorCursorAtBoundary","none"),e.$vL=new c.$Xj("notebookEditorCursorAtLineBoundary","none");var d;(function(W){W.default="default",W.option="option"})(d||(e.NotebookEditorPriority=d={}));var u;(function(W){W.Cells="cells",W.Text="text",W.None="none"})(u||(e.NotebookFindScopeType=u={}));function b(W){const ae=W;return!!((typeof ae.include=="string"||a.$Bk(ae.include))&&(typeof ae.exclude=="string"||a.$Bk(ae.exclude)))}function E(W,ae,q){if(Array.isArray(W.viewType)&&W.viewType.indexOf(ae)>=0||W.viewType===ae)return!0;if(W.filenamePattern){const K=b(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,ee=b(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(a.$zk(K,(0,R.$qc)(q.fsPath).toLowerCase()))return!(ee&&a.$zk(ee,(0,R.$qc)(q.fsPath).toLowerCase()))}return!1}e.$yL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class y{static create(ae){return`${y.d}${ae}`}static parse(ae){if(ae.startsWith(y.d))return ae.substring(y.d.length)}}e.$zL=y,y.d="notebook/";function T(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}const C=new TextDecoder;function v(W){const ae=[];let q=!1;for(const ge of W)(ae.length===0||q)&&(ae.push(ge),q=!0);let K=F(ae);const ee=r.$Pe.concat(ae.map(ge=>r.$Pe.wrap(ge))),re=B(ee);return K=K||re.byteLength!==ee.byteLength,{data:re,didCompression:K}}e.$CL="\x1B[A";const f=e.$CL.split("").map(W=>W.charCodeAt(0)),N=10;function F(W){let ae=!1;return W.forEach((q,K)=>{if(K===0||q.length<e.$CL.length)return;const ee=W[K-1],re=q.subarray(0,e.$CL.length);if(re[0]===f[0]&&re[1]===f[1]&&re[2]===f[2]){const ge=ee.lastIndexOf(N);if(ge===-1)return;ae=!0,W[K-1]=ee.subarray(0,ge),W[K]=q.subarray(e.$CL.length)}}),ae}function j(W){let ae=W;do W=ae,ae=W.replace(/[^\n]\x08/gm,"");while(ae.length<W.length);return W}function z(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const ae=W.match(/^(.*)\r+/m)[1];let q=W.match(/\r+(.*)$/m)[1];q=q+ae.slice(q.length,ae.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return W}const M=8,L=13;function B(W){return!W.buffer.includes(M)&&!W.buffer.includes(L)?W:r.$Pe.fromString(z(j(C.decode(W.buffer))))}});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[8],De([1,0,19,14,86,29,104,13,18,2,33,24,28,72,128]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w){"use strict";var l,m,g,$,n,o,t,i,s,d,u,b,E,D,y,T,C,v,f,N,F,j,z,M,L;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$QP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$tP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$sP=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$gP=e.$fP=e.$eP=e.$dP=e.$bP=e.$aP=e.$_O=e.$$O=e.TestRunProfileKind=e.TestResultState=e.$0O=e.$9O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$8O=e.NotebookVariablesRequestKind=e.$7O=e.$6O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$5O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.ColorThemeKind=e.$YO=e.$XO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$WO=e.$VO=e.DebugConsoleMode=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PO=e.$OO=e.FileChangeType=e.$NO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$MO=e.$LO=e.$KO=e.$JO=e.InlineCompletionTriggerKind=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$wO=e.ConfigurationTarget=e.$vO=e.$uO=e.$tO=e.$sO=e.DocumentPasteTriggerKind=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$lO=e.ViewBadge=e.ProgressLocation=e.$kO=e.$jO=e.TaskScope=e.ShellQuoting=e.$iO=e.$hO=e.$gO=e.TaskPanelKind=e.TaskRevealKind=e.$fO=e.TerminalLocation=e.$eO=e.$dO=e.$cO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$bO=e.$aO=e.$_N=e.$$N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$9N=e.$8N=e.$7N=e.$6N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$5N=e.$4N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.LanguageStatusSeverity=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.CodeActionTriggerKind=e.$RN=e.$QN=e.SymbolTag=e.SymbolKind=e.$PN=e.$ON=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.DiagnosticSeverity=e.DiagnosticTag=e.$IN=e.$HN=e.FileEditType=e.$GN=e.$FN=e.$EN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$0N=tt,e.$xO=Oe,e.$cP=Nn;function B(Q){return Object.assign(Q,{apply:function(...be){if(be.length===0)return Reflect.construct(Q,[]);{const Le=be.length===1?[]:be[1];return Reflect.construct(Q,Le,be[0].constructor)}},call:function(...be){if(be.length===0)return Reflect.construct(Q,[]);{const[Le,...xe]=be;return Reflect.construct(Q,xe,Le.constructor)}}})}var W;(function(Q){Q[Q.Top=0]="Top",Q[Q.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var ae;(function(Q){Q[Q.TerminalCommand=0]="TerminalCommand",Q[Q.Opener=1]="Opener",Q[Q.Command=3]="Command"})(ae||(e.TerminalQuickFixType=ae={}));let q=s=class{static from(...G){let be=G;return new s(function(){if(be){for(const Le of be)Le&&typeof Le.dispose=="function"&&Le.dispose();be=void 0}})}constructor(G){l.set(this,void 0),ot(this,l,G,"f")}dispose(){typeof He(this,l,"f")=="function"&&(He(this,l,"f").call(this),ot(this,l,void 0,"f"))}};e.$xN=q,l=new WeakMap,e.$xN=q=s=Ye([B],q);let K=d=class{static Min(...G){if(G.length===0)throw new TypeError;let be=G[0];for(let Le=1;Le<G.length;Le++){const xe=G[Le];xe.isBefore(be)&&(be=xe)}return be}static Max(...G){if(G.length===0)throw new TypeError;let be=G[0];for(let Le=1;Le<G.length;Le++){const xe=G[Le];xe.isAfter(be)&&(be=xe)}return be}static isPosition(G){if(!G)return!1;if(G instanceof d)return!0;const{line:be,character:Le}=G;return typeof be=="number"&&typeof Le=="number"}static of(G){if(G instanceof d)return G;if(this.isPosition(G))return new d(G.line,G.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(G,be){if(G<0)throw(0,a.$0)("line must be non-negative");if(be<0)throw(0,a.$0)("character must be non-negative");this.c=G,this.e=be}isBefore(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<G.e}isBeforeOrEqual(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<=G.e}isAfter(G){return!this.isBeforeOrEqual(G)}isAfterOrEqual(G){return!this.isBefore(G)}isEqual(G){return this.c===G.c&&this.e===G.e}compareTo(G){return this.c<G.c?-1:this.c>G.line?1:this.e<G.e?-1:this.e>G.e?1:0}translate(G,be=0){if(G===null||be===null)throw(0,a.$0)();let Le;return typeof G>"u"?Le=0:typeof G=="number"?Le=G:(Le=typeof G.lineDelta=="number"?G.lineDelta:0,be=typeof G.characterDelta=="number"?G.characterDelta:0),Le===0&&be===0?this:new d(this.line+Le,this.character+be)}with(G,be=this.character){if(G===null||be===null)throw(0,a.$0)();let Le;return typeof G>"u"?Le=this.line:typeof G=="number"?Le=G:(Le=typeof G.line=="number"?G.line:this.line,be=typeof G.character=="number"?G.character:this.character),Le===this.line&&be===this.character?this:new d(Le,be)}toJSON(){return{line:this.line,character:this.character}}};e.$yN=K,e.$yN=K=d=Ye([B],K);let ee=u=class{static isRange(G){return G instanceof u?!0:G?K.isPosition(G.start)&&K.isPosition(G.end):!1}static of(G){if(G instanceof u)return G;if(this.isRange(G))return new u(G.start,G.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(G,be,Le,xe){let st,pt;if(typeof G=="number"&&typeof be=="number"&&typeof Le=="number"&&typeof xe=="number"?(st=new K(G,be),pt=new K(Le,xe)):K.isPosition(G)&&K.isPosition(be)&&(st=K.of(G),pt=K.of(be)),!st||!pt)throw new Error("Invalid arguments");st.isBefore(pt)?(this.c=st,this.e=pt):(this.c=pt,this.e=st)}contains(G){return u.isRange(G)?this.contains(G.start)&&this.contains(G.end):K.isPosition(G)?!(K.of(G).isBefore(this.c)||this.e.isBefore(G)):!1}isEqual(G){return this.c.isEqual(G.c)&&this.e.isEqual(G.e)}intersection(G){const be=K.Max(G.start,this.c),Le=K.Min(G.end,this.e);if(!be.isAfter(Le))return new u(be,Le)}union(G){if(this.contains(G))return this;if(G.contains(this))return G;const be=K.Min(G.start,this.c),Le=K.Max(G.end,this.end);return new u(be,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(G,be=this.end){if(G===null||be===null)throw(0,a.$0)();let Le;return G?K.isPosition(G)?Le=G:(Le=G.start||this.start,be=G.end||this.end):Le=this.start,Le.isEqual(this.c)&&be.isEqual(this.end)?this:new u(Le,be)}toJSON(){return[this.start,this.end]}};e.$zN=ee,e.$zN=ee=u=Ye([B],ee);let re=b=class extends ee{static isSelection(G){return G instanceof b?!0:G?ee.isRange(G)&&K.isPosition(G.anchor)&&K.isPosition(G.active)&&typeof G.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(G,be,Le,xe){let st,pt;if(typeof G=="number"&&typeof be=="number"&&typeof Le=="number"&&typeof xe=="number"?(st=new K(G,be),pt=new K(Le,xe)):K.isPosition(G)&&K.isPosition(be)&&(st=K.of(G),pt=K.of(be)),!st||!pt)throw new Error("Invalid arguments");super(st,pt),this.f=st,this.g=pt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$AN=re,e.$AN=re=b=Ye([B],re);const ge=Q=>{if(typeof Q!="string"||Q.length===0||!/^[0-9A-Za-z_\-]+$/.test(Q))throw(0,a.$0)("connectionToken")};class Z{static isResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.host=="string"&&typeof G.port=="number"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,be,Le){if(typeof G!="string"||G.length===0)throw(0,a.$0)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,a.$0)("port");typeof Le<"u"&&ge(Le),this.host=G,this.port=Math.round(be),this.connectionToken=Le}}e.$BN=Z;class $e{static isManagedResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.makeConnection=="function"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,be){this.makeConnection=G,this.connectionToken=be,typeof be<"u"&&ge(be)}}e.$CN=$e;class fe extends Error{static NotAvailable(G,be){return new fe(G,P.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable(G){return new fe(G,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(G,be=P.RemoteAuthorityResolverErrorCode.Unknown,Le){super(G),this._message=G,this._code=be,this._detail=Le,Object.setPrototypeOf(this,fe.prototype)}}e.$DN=fe;var oe;(function(Q){Q[Q.LF=1]="LF",Q[Q.CRLF=2]="CRLF"})(oe||(e.EndOfLine=oe={}));var H;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Append=2]="Append",Q[Q.Prepend=3]="Prepend"})(H||(e.EnvironmentVariableMutatorType=H={}));let ue=E=class{static isTextEdit(G){return G instanceof E?!0:G?ee.isRange(G)&&typeof G.newText=="string":!1}static replace(G,be){return new E(G,be)}static insert(G,be){return E.replace(new ee(G,G),be)}static delete(G){return E.replace(G,"")}static setEndOfLine(G){const be=new E(new ee(new K(0,0),new K(0,0)),"");return be.newEol=G,be}get range(){return this.c}set range(G){if(G&&!ee.isRange(G))throw(0,a.$0)("range");this.c=G}get newText(){return this.e||""}set newText(G){if(G&&typeof G!="string")throw(0,a.$0)("newText");this.e=G}get newEol(){return this.f}set newEol(G){if(G&&typeof G!="number")throw(0,a.$0)("newEol");this.f=G}constructor(G,be){this.c=G,this.e=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$EN=ue,e.$EN=ue=E=Ye([B],ue);let te=D=class{static isNotebookCellEdit(G){return G instanceof D?!0:G?Di.isNotebookRange(G)&&Array.isArray(G.newCells):!1}static replaceCells(G,be){return new D(G,be)}static insertCells(G,be){return new D(new Di(G,G),be)}static deleteCells(G){return new D(G,[])}static updateCellMetadata(G,be){const Le=new D(new Di(G,G),[]);return Le.newCellMetadata=be,Le}static updateNotebookMetadata(G){const be=new D(new Di(0,0),[]);return be.newNotebookMetadata=G,be}constructor(G,be){this.range=G,this.newCells=be}};e.$FN=te,e.$FN=te=D=Ye([B],te);class _{static isSnippetTextEdit(G){return G instanceof _?!0:G?ee.isRange(G.range)&&J.isSnippetString(G.snippet):!1}static replace(G,be){return new _(G,be)}static insert(G,be){return _.replace(new ee(G,G),be)}constructor(G,be){this.range=G,this.snippet=be}}e.$GN=_;var ne;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.Cell=3]="Cell",Q[Q.CellReplace=5]="CellReplace",Q[Q.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let le=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(G,be,Le,xe){this.c.push({_type:ne.File,from:G,to:be,options:Le,metadata:xe})}createFile(G,be,Le){this.c.push({_type:ne.File,from:void 0,to:G,options:be,metadata:Le})}deleteFile(G,be,Le){this.c.push({_type:ne.File,from:G,to:void 0,options:be,metadata:Le})}e(G,be,Le){this.c.push({_type:ne.Cell,metadata:Le,uri:G,edit:{editType:w.CellEditType.DocumentMetadata,metadata:be},notebookMetadata:be})}f(G,be,Le,xe){const st=be.start,pt=be.end;(st!==pt||Le.length>0)&&this.c.push({_type:ne.CellReplace,uri:G,index:st,count:pt-st,cells:Le,metadata:xe})}g(G,be,Le,xe){this.c.push({_type:ne.Cell,metadata:xe,uri:G,edit:{editType:w.CellEditType.Metadata,index:be,metadata:Le}})}replace(G,be,Le,xe){this.c.push({_type:ne.Text,uri:G,edit:new ue(be,Le),metadata:xe})}insert(G,be,Le,xe){this.replace(G,new ee(be,be),Le,xe)}delete(G,be,Le){this.replace(G,be,"",Le)}has(G){return this.c.some(be=>be._type===ne.Text&&be.uri.toString()===G.toString())}set(G,be){if(be)for(const Le of be){if(!Le)continue;let xe,st;Array.isArray(Le)?(xe=Le[0],st=Le[1]):xe=Le,te.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(G,xe.range.start,xe.newCellMetadata,st):xe.newNotebookMetadata?this.e(G,xe.newNotebookMetadata,st):this.f(G,xe.range,xe.newCells,st):_.isSnippetTextEdit(xe)?this.c.push({_type:ne.Snippet,uri:G,range:xe.range,edit:xe.snippet,metadata:st}):this.c.push({_type:ne.Text,uri:G,edit:xe,metadata:st})}else{for(let Le=0;Le<this.c.length;Le++){const xe=this.c[Le];switch(xe._type){case ne.Text:case ne.Snippet:case ne.Cell:case ne.CellReplace:xe.uri.toString()===G.toString()&&(this.c[Le]=void 0);break}}(0,r.$Lb)(this.c)}}get(G){const be=[];for(const Le of this.c)Le._type===ne.Text&&Le.uri.toString()===G.toString()&&be.push(Le.edit);return be}entries(){const G=new A.$Dc;for(const be of this.c)if(be._type===ne.Text){let Le=G.get(be.uri);Le||(Le=[be.uri,[]],G.set(be.uri,Le)),Le[1].push(be.edit)}return[...G.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$HN=le,e.$HN=le=Ye([B],le);let J=y=class{static isSnippetString(G){return G instanceof y?!0:G?typeof G.value=="string":!1}static c(G){return G.replace(/\$|}|\\/g,"\\$&")}constructor(G){this.e=1,this.value=G||""}appendText(G){return this.value+=y.c(G),this}appendTabstop(G=this.e++){return this.value+="$",this.value+=G,this}appendPlaceholder(G,be=this.e++){if(typeof G=="function"){const Le=new y;Le.e=this.e,G(Le),this.e=Le.e,G=Le.value}else G=y.c(G);return this.value+="${",this.value+=be,this.value+=":",this.value+=G,this.value+="}",this}appendChoice(G,be=this.e++){const Le=G.map(xe=>xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(G,be){if(typeof be=="function"){const Le=new y;Le.e=this.e,be(Le),this.e=Le.e,be=Le.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=G,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.$IN=J,e.$IN=J=y=Ye([B],J);var ce;(function(Q){Q[Q.Unnecessary=1]="Unnecessary",Q[Q.Deprecated=2]="Deprecated"})(ce||(e.DiagnosticTag=ce={}));var me;(function(Q){Q[Q.Hint=3]="Hint",Q[Q.Information=2]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=0]="Error"})(me||(e.DiagnosticSeverity=me={}));let we=T=class{static isLocation(G){return G instanceof T?!0:G?ee.isRange(G.range)&&c.URI.isUri(G.uri):!1}constructor(G,be){if(this.uri=G,be)if(ee.isRange(be))this.range=ee.of(be);else if(K.isPosition(be))this.range=new ee(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$JN=we,e.$JN=we=T=Ye([B],we);let Me=class{static is(G){return G?typeof G.message=="string"&&G.location&&ee.isRange(G.location.range)&&c.URI.isUri(G.location.uri):!1}constructor(G,be){this.location=G,this.message=be}static isEqual(G,be){return G===be?!0:!G||!be?!1:G.message===be.message&&G.location.range.isEqual(be.location.range)&&G.location.uri.toString()===be.location.uri.toString()}};e.$KN=Me,e.$KN=Me=Ye([B],Me);let qe=class{constructor(G,be,Le=me.Error){if(!ee.isRange(G))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=G,this.message=be,this.severity=Le}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(G,be){return G===be?!0:!G||!be?!1:G.message===be.message&&G.severity===be.severity&&G.code===be.code&&G.severity===be.severity&&G.source===be.source&&G.range.isEqual(be.range)&&(0,r.$xb)(G.tags,be.tags)&&(0,r.$xb)(G.relatedInformation,be.relatedInformation,Me.isEqual)}};e.$LN=qe,e.$LN=qe=Ye([B],qe);let ke=class{constructor(G,be){if(!G)throw new Error("Illegal argument, contents must be defined");Array.isArray(G)?this.contents=G:this.contents=[G],this.range=be}};e.$MN=ke,e.$MN=ke=Ye([B],ke);let Ie=class extends ke{constructor(G,be,Le,xe){super(G,be),this.canIncreaseHover=Le,this.canDecreaseHover=xe}};e.$NN=Ie,e.$NN=Ie=Ye([B],Ie);var Ce;(function(Q){Q[Q.Increase=0]="Increase",Q[Q.Decrease=1]="Decrease"})(Ce||(e.HoverVerbosityAction=Ce={}));var U;(function(Q){Q[Q.Text=0]="Text",Q[Q.Read=1]="Read",Q[Q.Write=2]="Write"})(U||(e.DocumentHighlightKind=U={}));let V=class{constructor(G,be=U.Text){this.range=G,this.kind=be}toJSON(){return{range:this.range,kind:U[this.kind]}}};e.$ON=V,e.$ON=V=Ye([B],V);let X=class{constructor(G,be){this.uri=G,this.highlights=be}toJSON(){return{uri:this.uri,highlights:this.highlights.map(G=>G.toJSON())}}};e.$PN=X,e.$PN=X=Ye([B],X);var x;(function(Q){Q[Q.File=0]="File",Q[Q.Module=1]="Module",Q[Q.Namespace=2]="Namespace",Q[Q.Package=3]="Package",Q[Q.Class=4]="Class",Q[Q.Method=5]="Method",Q[Q.Property=6]="Property",Q[Q.Field=7]="Field",Q[Q.Constructor=8]="Constructor",Q[Q.Enum=9]="Enum",Q[Q.Interface=10]="Interface",Q[Q.Function=11]="Function",Q[Q.Variable=12]="Variable",Q[Q.Constant=13]="Constant",Q[Q.String=14]="String",Q[Q.Number=15]="Number",Q[Q.Boolean=16]="Boolean",Q[Q.Array=17]="Array",Q[Q.Object=18]="Object",Q[Q.Key=19]="Key",Q[Q.Null=20]="Null",Q[Q.EnumMember=21]="EnumMember",Q[Q.Struct=22]="Struct",Q[Q.Event=23]="Event",Q[Q.Operator=24]="Operator",Q[Q.TypeParameter=25]="TypeParameter"})(x||(e.SymbolKind=x={}));var de;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let ve=C=class{static validate(G){if(!G.name)throw new Error("name must not be falsy")}constructor(G,be,Le,xe,st){this.name=G,this.kind=be,this.containerName=st,typeof Le=="string"&&(this.containerName=Le),xe instanceof we?this.location=xe:Le instanceof ee&&(this.location=new we(xe,Le)),C.validate(this)}toJSON(){return{name:this.name,kind:x[this.kind],location:this.location,containerName:this.containerName}}};e.$QN=ve,e.$QN=ve=C=Ye([B],ve);let Fe=v=class{static validate(G){if(!G.name)throw new Error("name must not be falsy");if(!G.range.contains(G.selectionRange))throw new Error("selectionRange must be contained in fullRange");G.children?.forEach(v.validate)}constructor(G,be,Le,xe,st){this.name=G,this.detail=be,this.kind=Le,this.range=xe,this.selectionRange=st,this.children=[],v.validate(this)}};e.$RN=Fe,e.$RN=Fe=v=Ye([B],Fe);var Ge;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.Automatic=2]="Automatic"})(Ge||(e.CodeActionTriggerKind=Ge={}));let Xe=class{constructor(G,be){this.title=G,this.kind=be}};e.$SN=Xe,e.$SN=Xe=Ye([B],Xe);let Qe=f=class{constructor(G){this.value=G}append(G){return new f(this.value?this.value+f.c+G:G)}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+f.c)}};e.$TN=Qe,Qe.c=".",e.$TN=Qe=f=Ye([B],Qe),Qe.Empty=new Qe(""),Qe.QuickFix=Qe.Empty.append("quickfix"),Qe.Refactor=Qe.Empty.append("refactor"),Qe.RefactorExtract=Qe.Refactor.append("extract"),Qe.RefactorInline=Qe.Refactor.append("inline"),Qe.RefactorMove=Qe.Refactor.append("move"),Qe.RefactorRewrite=Qe.Refactor.append("rewrite"),Qe.Source=Qe.Empty.append("source"),Qe.SourceOrganizeImports=Qe.Source.append("organizeImports"),Qe.SourceFixAll=Qe.Source.append("fixAll"),Qe.Notebook=Qe.Empty.append("notebook");let nt=class{constructor(G,be){if(this.range=G,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$UN=nt,e.$UN=nt=Ye([B],nt);class ct{constructor(G,be,Le,xe,st,pt){this.kind=G,this.name=be,this.detail=Le,this.uri=xe,this.range=st,this.selectionRange=pt}}e.$VN=ct;class rt{constructor(G,be){this.fromRanges=be,this.from=G}}e.$WN=rt;class lt{constructor(G,be){this.fromRanges=be,this.to=G}}e.$XN=lt;var bt;(function(Q){Q[Q.Information=0]="Information",Q[Q.Warning=1]="Warning",Q[Q.Error=2]="Error"})(bt||(e.LanguageStatusSeverity=bt={}));let ft=class{constructor(G,be){this.range=G,this.command=be}get isResolved(){return!!this.command}};e.$YN=ft,e.$YN=ft=Ye([B],ft);let at=N=class{static isMarkdownString(G){return G instanceof N?!0:G&&G.appendCodeblock&&G.appendMarkdown&&G.appendText&&G.value!==void 0}constructor(G,be=!1){m.set(this,void 0),ot(this,m,new k.$4k(G,{supportThemeIcons:be}),"f")}get value(){return He(this,m,"f").value}set value(G){He(this,m,"f").value=G}get isTrusted(){return He(this,m,"f").isTrusted}set isTrusted(G){He(this,m,"f").isTrusted=G}get supportThemeIcons(){return He(this,m,"f").supportThemeIcons}set supportThemeIcons(G){He(this,m,"f").supportThemeIcons=G}get supportHtml(){return He(this,m,"f").supportHtml}set supportHtml(G){He(this,m,"f").supportHtml=G}get baseUri(){return He(this,m,"f").baseUri}set baseUri(G){He(this,m,"f").baseUri=G}appendText(G){return He(this,m,"f").appendText(G),this}appendMarkdown(G){return He(this,m,"f").appendMarkdown(G),this}appendCodeblock(G,be){return He(this,m,"f").appendCodeblock(be??"",G),this}};e.$ZN=at,m=new WeakMap,e.$ZN=at=N=Ye([B],at);let dt=class{constructor(G,be){this.label=G,this.documentation=be}};e.$1N=dt,e.$1N=dt=Ye([B],dt);let Pe=class{constructor(G,be){this.label=G,this.documentation=be,this.parameters=[]}};e.$2N=Pe,e.$2N=Pe=Ye([B],Pe);let ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$3N=ze,e.$3N=ze=Ye([B],ze);var Re;(function(Q){Q[Q.Invoke=1]="Invoke",Q[Q.TriggerCharacter=2]="TriggerCharacter",Q[Q.ContentChange=3]="ContentChange"})(Re||(e.SignatureHelpTriggerKind=Re={}));var Ne;(function(Q){Q[Q.Type=1]="Type",Q[Q.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let he=class{constructor(G){this.value=G}};e.$4N=he,e.$4N=he=Ye([B],he);let Y=class{constructor(G,be,Le){this.position=G,this.label=be,this.kind=Le}};e.$5N=Y,e.$5N=Y=Ye([B],Y);var Ae;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.TriggerCharacter=1]="TriggerCharacter",Q[Q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae||(e.CompletionTriggerKind=Ae={}));var Ze;(function(Q){Q[Q.Text=0]="Text",Q[Q.Method=1]="Method",Q[Q.Function=2]="Function",Q[Q.Constructor=3]="Constructor",Q[Q.Field=4]="Field",Q[Q.Variable=5]="Variable",Q[Q.Class=6]="Class",Q[Q.Interface=7]="Interface",Q[Q.Module=8]="Module",Q[Q.Property=9]="Property",Q[Q.Unit=10]="Unit",Q[Q.Value=11]="Value",Q[Q.Enum=12]="Enum",Q[Q.Keyword=13]="Keyword",Q[Q.Snippet=14]="Snippet",Q[Q.Color=15]="Color",Q[Q.File=16]="File",Q[Q.Reference=17]="Reference",Q[Q.Folder=18]="Folder",Q[Q.EnumMember=19]="EnumMember",Q[Q.Constant=20]="Constant",Q[Q.Struct=21]="Struct",Q[Q.Event=22]="Event",Q[Q.Operator=23]="Operator",Q[Q.TypeParameter=24]="TypeParameter",Q[Q.User=25]="User",Q[Q.Issue=26]="Issue"})(Ze||(e.CompletionItemKind=Ze={}));var et;(function(Q){Q[Q.Deprecated=1]="Deprecated"})(et||(e.CompletionItemTag=et={}));let ut=class{constructor(G,be){this.label=G,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&Ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$6N=ut,e.$6N=ut=Ye([B],ut);let mt=class{constructor(G=[],be=!1){this.items=G,this.isIncomplete=be}};e.$7N=mt,e.$7N=mt=Ye([B],mt);let Dt=class{constructor(G,be,Le){this.insertText=G,this.range=be,this.command=Le}};e.$8N=Dt,e.$8N=Dt=Ye([B],Dt);let Ft=class{constructor(G){this.commands=void 0,this.suppressSuggestions=void 0,this.items=G}};e.$9N=Ft,e.$9N=Ft=Ye([B],Ft);var Kt;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Word=1]="Word",Q[Q.Line=2]="Line",Q[Q.Suggest=3]="Suggest"})(Kt||(e.PartialAcceptTriggerKind=Kt={}));var li;(function(Q){Q[Q.Active=-1]="Active",Q[Q.Beside=-2]="Beside",Q[Q.One=1]="One",Q[Q.Two=2]="Two",Q[Q.Three=3]="Three",Q[Q.Four=4]="Four",Q[Q.Five=5]="Five",Q[Q.Six=6]="Six",Q[Q.Seven=7]="Seven",Q[Q.Eight=8]="Eight",Q[Q.Nine=9]="Nine"})(li||(e.ViewColumn=li={}));var fi;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(fi||(e.StatusBarAlignment=fi={}));function tt(Q,G){return`${S.$sn.toKey(Q)}.${G}`}var xt;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval"})(xt||(e.TextEditorLineNumbersStyle=xt={}));var Jt;(function(Q){Q[Q.Manual=1]="Manual",Q[Q.AfterDelay=2]="AfterDelay",Q[Q.FocusOut=3]="FocusOut"})(Jt||(e.TextDocumentSaveReason=Jt={}));var wt;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var kt;(function(Q){Q[Q.Keyboard=1]="Keyboard",Q[Q.Mouse=2]="Mouse",Q[Q.Command=3]="Command"})(kt||(e.TextEditorSelectionChangeKind=kt={}));var si;(function(Q){Q[Q.Undo=1]="Undo",Q[Q.Redo=2]="Redo"})(si||(e.TextDocumentChangeReason=si={}));var _t;(function(Q){Q[Q.OpenOpen=0]="OpenOpen",Q[Q.ClosedClosed=1]="ClosedClosed",Q[Q.OpenClosed=2]="OpenClosed",Q[Q.ClosedOpen=3]="ClosedOpen"})(_t||(e.DecorationRangeBehavior=_t={})),function(Q){function G(be){switch(be){case"keyboard":return Q.Keyboard;case"mouse":return Q.Mouse;case"api":return Q.Command}}Q.fromValue=G}(kt||(e.TextEditorSelectionChangeKind=kt={}));var Wt;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(Q){function G(be){switch(be){case Q.Other:return"other";case Q.Comment:return"comment";case Q.String:return"string";case Q.RegEx:return"regex"}return"other"}Q.toString=G}(Wt||(e.SyntaxTokenType=Wt={}));let vt=class{constructor(G,be){if(be&&!c.URI.isUri(be))throw(0,a.$0)("target");if(!ee.isRange(G)||G.isEmpty)throw(0,a.$0)("range");this.range=G,this.target=be}};e.$$N=vt,e.$$N=vt=Ye([B],vt);let Tt=class{constructor(G,be,Le,xe){this.red=G,this.green=be,this.blue=Le,this.alpha=xe}};e.$_N=Tt,e.$_N=Tt=Ye([B],Tt);let ei=class{constructor(G,be){if(be&&!(be instanceof Tt))throw(0,a.$0)("color");if(!ee.isRange(G)||G.isEmpty)throw(0,a.$0)("range");this.range=G,this.color=be}};e.$aO=ei,e.$aO=ei=Ye([B],ei);let Vt=class{constructor(G){if(!G||typeof G!="string")throw(0,a.$0)("label");this.label=G}};e.$bO=Vt,e.$bO=Vt=Ye([B],Vt);var _e;(function(Q){Q[Q.RGB=0]="RGB",Q[Q.HEX=1]="HEX",Q[Q.HSL=2]="HSL"})(_e||(e.ColorFormat=_e={}));var ti;(function(Q){Q[Q.Error=0]="Error",Q[Q.Warning=1]="Warning",Q[Q.Information=2]="Information"})(ti||(e.SourceControlInputBoxValidationType=ti={}));var oi;(function(Q){Q[Q.Unknown=0]="Unknown",Q[Q.Shutdown=1]="Shutdown",Q[Q.Process=2]="Process",Q[Q.User=3]="User",Q[Q.Extension=4]="Extension"})(oi||(e.TerminalExitReason=oi={}));var gi;(function(Q){Q[Q.Low=0]="Low",Q[Q.Medium=1]="Medium",Q[Q.High=2]="High"})(gi||(e.TerminalShellExecutionCommandLineConfidence=gi={}));class Ct{constructor(G,be,Le){if(this.startIndex=G,this.length=be,this.tooltip=Le,typeof G!="number"||G<0)throw(0,a.$0)("startIndex");if(typeof be!="number"||be<1)throw(0,a.$0)("length");if(Le!==void 0&&typeof Le!="string")throw(0,a.$0)("tooltip")}}e.$cO=Ct;class Gt{constructor(G){this.uri=G}}e.$dO=Gt;class Mt{constructor(G){this.terminalCommand=G}}e.$eO=Mt;var Ht;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Editor=2]="Editor"})(Ht||(e.TerminalLocation=Ht={}));class $i{constructor(G){if(this.options=G,typeof G!="object")throw(0,a.$0)("options")}}e.$fO=$i;var ii;(function(Q){Q[Q.Always=1]="Always",Q[Q.Silent=2]="Silent",Q[Q.Never=3]="Never"})(ii||(e.TaskRevealKind=ii={}));var ui;(function(Q){Q[Q.Shared=1]="Shared",Q[Q.Dedicated=2]="Dedicated",Q[Q.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let jt=F=class{static from(G){switch(G){case"clean":return F.Clean;case"build":return F.Build;case"rebuild":return F.Rebuild;case"test":return F.Test;default:return}}constructor(G,be){if(this.label=be,typeof G!="string"||typeof be!="string")throw(0,a.$0)("name");this.c=G}get id(){return this.c}};e.$gO=jt,jt.Clean=new F("clean","Clean"),jt.Build=new F("build","Build"),jt.Rebuild=new F("rebuild","Rebuild"),jt.Test=new F("test","Test"),e.$gO=jt=F=Ye([B],jt);function Xt(Q){let G="";for(let be=0;be<Q.length;be++)G+=Q[be].replace(/,/g,",,")+",";return G}let ni=class{constructor(G,be,Le){if(typeof G!="string")throw(0,a.$0)("process");this.e=[],this.c=G,be!==void 0&&(Array.isArray(be)?(this.e=be,this.f=Le):this.f=be)}get process(){return this.c}set process(G){if(typeof G!="string")throw(0,a.$0)("process");this.c=G}get args(){return this.e}set args(G){Array.isArray(G)||(G=[]),this.e=G}get options(){return this.f}set options(G){this.f=G}computeId(){const G=[];if(G.push("process"),this.c!==void 0&&G.push(this.c),this.e&&this.e.length>0)for(const be of this.e)G.push(be);return Xt(G)}};e.$hO=ni,e.$hO=ni=Ye([B],ni);let Ot=class{constructor(G,be,Le){if(this.f=[],Array.isArray(be)){if(!G)throw(0,a.$0)("command can't be undefined or null");if(typeof G!="string"&&typeof G.value!="string")throw(0,a.$0)("command");this.e=G,this.f=be,this.g=Le}else{if(typeof G!="string")throw(0,a.$0)("commandLine");this.c=G,this.g=be}}get commandLine(){return this.c}set commandLine(G){if(typeof G!="string")throw(0,a.$0)("commandLine");this.c=G}get command(){return this.e?this.e:""}set command(G){if(typeof G!="string"&&typeof G.value!="string")throw(0,a.$0)("command");this.e=G}get args(){return this.f}set args(G){this.f=G||[]}get options(){return this.g}set options(G){this.g=G}computeId(){const G=[];if(G.push("shell"),this.c!==void 0&&G.push(this.c),this.e!==void 0&&G.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const be of this.f)G.push(typeof be=="string"?be:be.value);return Xt(G)}};e.$iO=Ot,e.$iO=Ot=Ye([B],Ot);var At;(function(Q){Q[Q.Escape=1]="Escape",Q[Q.Strong=2]="Strong",Q[Q.Weak=3]="Weak"})(At||(e.ShellQuoting=At={}));var Et;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace"})(Et||(e.TaskScope=Et={}));class ri{constructor(G){this.c=G}computeId(){return"customExecution"+(0,I.$3g)()}set callback(G){this.c=G}get callback(){return this.c}}e.$jO=ri;let yt=j=class{constructor(G,be,Le,xe,st,pt){this.k=!1,this.l=this.definition=G;let St;typeof be=="string"?(this.o=this.name=be,this.w=this.source=Le,this.execution=xe,St=st,this.k=!0):be===Et.Global||be===Et.Workspace?(this.target=be,this.o=this.name=Le,this.w=this.source=xe,this.execution=st,St=pt):(this.target=be,this.o=this.name=Le,this.w=this.source=xe,this.execution=st,St=pt),typeof St=="string"?(this.r=[St],this.t=!0):Array.isArray(St)?(this.r=St,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(G){this.j=G}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof ni?this.l={type:j.e,id:this.q.computeId()}:this.q instanceof Ot?this.l={type:j.f,id:this.q.computeId()}:this.q instanceof ri?this.l={type:j.c,id:this.q.computeId()}:this.l={type:j.g,id:(0,I.$3g)()}}get definition(){return this.l}set definition(G){if(G==null)throw(0,a.$0)("Kind can't be undefined or null");this.B(),this.l=G}get scope(){return this.m}set target(G){this.B(),this.m=G}get name(){return this.o}set name(G){if(typeof G!="string")throw(0,a.$0)("name");this.B(),this.o=G}get execution(){return this.q}set execution(G){G===null&&(G=void 0),this.B(),this.q=G;const be=this.l.type;(j.g===be||j.e===be||j.f===be||j.c===be)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(G){if(Array.isArray(G))this.B(),this.r=G,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(G){G!==!0&&G!==!1&&(G=!1),this.B(),this.u=G}get source(){return this.w}set source(G){if(typeof G!="string"||G.length===0)throw(0,a.$0)("source must be a string of length > 0");this.B(),this.w=G}get group(){return this.x}set group(G){G===null&&(G=void 0),this.B(),this.x=G}get detail(){return this.A}set detail(G){G===null&&(G=void 0),this.A=G}get presentationOptions(){return this.y}set presentationOptions(G){G==null&&(G=Object.create(null)),this.B(),this.y=G}get runOptions(){return this.z}set runOptions(G){G==null&&(G=Object.create(null)),this.B(),this.z=G}};e.$kO=yt,yt.c="customExecution",yt.e="process",yt.f="shell",yt.g="$empty",e.$kO=yt=j=Ye([B],yt);var ai;(function(Q){Q[Q.SourceControl=1]="SourceControl",Q[Q.Window=10]="Window",Q[Q.Notification=15]="Notification"})(ai||(e.ProgressLocation=ai={}));var Qt;(function(Q){function G(be){const Le=be;return(0,p.$kg)(Le.value)?Le.tooltip&&!(0,p.$gg)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}Q.isViewBadge=G})(Qt||(e.ViewBadge=Qt={}));let wi=z=class{static isTreeItem(G,be){const Le=G;if(Le.checkboxState!==void 0){const xe=(0,p.$kg)(Le.checkboxState)?Le.checkboxState:(0,p.$ig)(Le.checkboxState)&&(0,p.$kg)(Le.checkboxState.state)?Le.checkboxState.state:void 0,st=!(0,p.$kg)(Le.checkboxState)&&(0,p.$ig)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(xe===void 0||xe!==vi.Checked&&xe!==vi.Unchecked||st!==void 0&&!(0,p.$gg)(st))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(G instanceof z)return!0;if(Le.label!==void 0&&!(0,p.$gg)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,p.$gg)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,p.$gg)(Le.iconPath)&&!c.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,p.$gg)(Le.iconPath.id))){const xe=Le.iconPath;if(!xe||!(0,p.$gg)(xe.light)&&!c.URI.isUri(xe.light)&&!(0,p.$gg)(xe.dark)&&!c.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,p.$gg)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!c.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,p.$gg)(Le.tooltip)&&!(Le.tooltip instanceof at)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<mi.None&&Le.collapsibleState>mi.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,p.$gg)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(G,be=mi.None){this.collapsibleState=be,c.URI.isUri(G)?this.resourceUri=G:this.label=G}};e.$lO=wi,e.$lO=wi=z=Ye([B],wi);var mi;(function(Q){Q[Q.None=0]="None",Q[Q.Collapsed=1]="Collapsed",Q[Q.Expanded=2]="Expanded"})(mi||(e.TreeItemCollapsibleState=mi={}));var vi;(function(Q){Q[Q.Unchecked=0]="Unchecked",Q[Q.Checked=1]="Checked"})(vi||(e.TreeItemCheckboxState=vi={}));let Bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(G){this.value=G}};e.$mO=Bt,e.$mO=Bt=Ye([B],Bt);class Ai extends Bt{}e.$nO=Ai;class Mi extends Ai{constructor(G){super(""),g.set(this,void 0),ot(this,g,G,"f")}asFile(){return He(this,g,"f")}}e.$oO=Mi,g=new WeakMap;class Lt{constructor(G,be,Le,xe){this.name=G,this.uri=be,this._itemId=Le,this.c=xe}data(){return this.c()}}e.$pO=Lt;let Ii=class{constructor(G){$.add(this),n.set(this,new Map);for(const[be,Le]of G??[]){const xe=He(this,n,"f").get(He(this,$,"m",o).call(this,be));xe?xe.push(Le):He(this,n,"f").set(He(this,$,"m",o).call(this,be),[Le])}}get(G){return He(this,n,"f").get(He(this,$,"m",o).call(this,G))?.[0]}set(G,be){He(this,n,"f").set(He(this,$,"m",o).call(this,G),[be])}forEach(G,be){for(const[Le,xe]of He(this,n,"f"))for(const st of xe)G.call(be,st,Le,this)}*[(n=new WeakMap,$=new WeakSet,Symbol.iterator)](){for(const[G,be]of He(this,n,"f"))for(const Le of be)yield[G,Le]}};e.$qO=Ii,o=function(G){return G.toLowerCase()},e.$qO=Ii=Ye([B],Ii);let Pi=class{constructor(G,be,Le){this.insertText=G,this.title=be,this.kind=Le}};e.$rO=Pi,e.$rO=Pi=Ye([B],Pi);var yi;(function(Q){Q[Q.Automatic=0]="Automatic",Q[Q.PasteAs=1]="PasteAs"})(yi||(e.DocumentPasteTriggerKind=yi={}));class hi{constructor(G){this.value=G}append(...G){return new hi((this.value?[this.value,...G]:G).join(hi.c))}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+hi.c)}}e.$sO=hi,hi.c=".",hi.Empty=new hi("");class ji{constructor(G,be,Le){this.title=be,this.insertText=G,this.kind=Le}}e.$tO=ji;let Nt=class{constructor(G,be){this.id=G,this.color=be}static isThemeIcon(G){return typeof G.id!="string"?(console.log("INVALID ThemeIcon, invalid id",G.id),!1):!0}};e.$uO=Nt,e.$uO=Nt=Ye([B],Nt),Nt.File=new Nt("file"),Nt.Folder=new Nt("folder");let Te=class{constructor(G){this.id=G}};e.$vO=Te,e.$vO=Te=Ye([B],Te);var je;(function(Q){Q[Q.Global=1]="Global",Q[Q.Workspace=2]="Workspace",Q[Q.WorkspaceFolder=3]="WorkspaceFolder"})(je||(e.ConfigurationTarget=je={}));let ye=class{get base(){return this.c}set base(G){this.c=G,this.e=c.URI.file(G)}get baseUri(){return this.e}set baseUri(G){this.e=G,this.c=G.fsPath}constructor(G,be){if(typeof G!="string"&&(!G||!c.URI.isUri(G)&&!c.URI.isUri(G.uri)))throw(0,a.$0)("base");if(typeof be!="string")throw(0,a.$0)("pattern");typeof G=="string"?this.baseUri=c.URI.file(G):c.URI.isUri(G)?this.baseUri=G:this.baseUri=G.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wO=ye,e.$wO=ye=Ye([B],ye);const se=new WeakMap;function Oe(Q,G){se.set(Q,G)}let Ke=class{constructor(G,be,Le,xe,st){this.enabled=typeof G=="boolean"?G:!0,typeof be=="string"&&(this.condition=be),typeof Le=="string"&&(this.hitCondition=Le),typeof xe=="string"&&(this.logMessage=xe),typeof st=="string"&&(this.mode=st)}get id(){return this.c||(this.c=se.get(this)??(0,I.$3g)()),this.c}};e.$yO=Ke,e.$yO=Ke=Ye([B],Ke);let it=class extends Ke{constructor(G,be,Le,xe,st,pt){if(super(be,Le,xe,st,pt),G===null)throw(0,a.$0)("location");this.location=G}};e.$zO=it,e.$zO=it=Ye([B],it);let Je=class extends Ke{constructor(G,be,Le,xe,st,pt){super(be,Le,xe,st,pt),this.functionName=G}};e.$AO=Je,e.$AO=Je=Ye([B],Je);let $t=class extends Ke{constructor(G,be,Le,xe,st,pt,St,Zt){if(super(xe,st,pt,St,Zt),!be)throw(0,a.$0)("dataId");this.label=G,this.dataId=be,this.canPersist=Le}};e.$BO=$t,e.$BO=$t=Ye([B],$t);let Rt=class{constructor(G,be,Le){this.command=G,this.args=be||[],this.options=Le}};e.$CO=Rt,e.$CO=Rt=Ye([B],Rt);let Yt=class{constructor(G,be){this.port=G,this.host=be}};e.$DO=Yt,e.$DO=Yt=Ye([B],Yt);let ci=class{constructor(G){this.path=G}};e.$EO=ci,e.$EO=ci=Ye([B],ci);let Ut=class{constructor(G){this.implementation=G}};e.$FO=Ut,e.$FO=Ut=Ye([B],Ut);class di{constructor(G,be,Le){this.session=G,this.threadId=be,this.frameId=Le}}e.$GO=di;class en{constructor(G,be){this.session=G,this.threadId=be}}e.$HO=en;let Gi=class{constructor(G,be){this.range=G,this.expression=be}};e.$IO=Gi,e.$IO=Gi=Ye([B],Gi);var zi;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(zi||(e.InlineCompletionTriggerKind=zi={}));let Oi=class{constructor(G,be){this.range=G,this.text=be}};e.$JO=Oi,e.$JO=Oi=Ye([B],Oi);let Hi=class{constructor(G,be,Le=!0){this.range=G,this.variableName=be,this.caseSensitiveLookup=Le}};e.$KO=Hi,e.$KO=Hi=Ye([B],Hi);let Ki=class{constructor(G,be){this.range=G,this.expression=be}};e.$LO=Ki,e.$LO=Ki=Ye([B],Ki);let Ei=class{constructor(G,be){this.frameId=G,this.stoppedLocation=be}};e.$MO=Ei,e.$MO=Ei=Ye([B],Ei);var tn;(function(Q){Q[Q.AIGenerated=1]="AIGenerated"})(tn||(e.NewSymbolNameTag=tn={}));var nn;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(nn||(e.NewSymbolNameTriggerKind=nn={}));class Qi{constructor(G,be){this.newSymbolName=G,this.tags=be}}e.$NO=Qi;var rn;(function(Q){Q[Q.Changed=1]="Changed",Q[Q.Created=2]="Created",Q[Q.Deleted=3]="Deleted"})(rn||(e.FileChangeType=rn={}));let Li=M=class extends Error{static FileExists(G){return new M(G,h.FileSystemProviderErrorCode.FileExists,M.FileExists)}static FileNotFound(G){return new M(G,h.FileSystemProviderErrorCode.FileNotFound,M.FileNotFound)}static FileNotADirectory(G){return new M(G,h.FileSystemProviderErrorCode.FileNotADirectory,M.FileNotADirectory)}static FileIsADirectory(G){return new M(G,h.FileSystemProviderErrorCode.FileIsADirectory,M.FileIsADirectory)}static NoPermissions(G){return new M(G,h.FileSystemProviderErrorCode.NoPermissions,M.NoPermissions)}static Unavailable(G){return new M(G,h.FileSystemProviderErrorCode.Unavailable,M.Unavailable)}constructor(G,be=h.FileSystemProviderErrorCode.Unknown,Le){super(c.URI.isUri(G)?G.toString(!0):G),this.code=Le?.name??"Unknown",(0,h.$pl)(this,be),Object.setPrototypeOf(this,M.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$OO=Li,e.$OO=Li=M=Ye([B],Li);let Bi=class{constructor(G,be,Le){this.start=G,this.end=be,this.kind=Le}};e.$PO=Bi,e.$PO=Bi=Ye([B],Bi);var sn;(function(Q){Q[Q.Comment=1]="Comment",Q[Q.Imports=2]="Imports",Q[Q.Region=3]="Region"})(sn||(e.FoldingRangeKind=sn={}));var Ji;(function(Q){Q[Q.Collapsed=0]="Collapsed",Q[Q.Expanded=1]="Expanded"})(Ji||(e.CommentThreadCollapsibleState=Ji={}));var on;(function(Q){Q[Q.Editing=0]="Editing",Q[Q.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var Ri;(function(Q){Q[Q.Published=0]="Published",Q[Q.Draft=1]="Draft"})(Ri||(e.CommentState=Ri={}));var an;(function(Q){Q[Q.Unresolved=0]="Unresolved",Q[Q.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var cn;(function(Q){Q[Q.Current=0]="Current",Q[Q.Outdated=1]="Outdated"})(cn||(e.CommentThreadApplicability=cn={}));class Sn{constructor(G,be=[]){this.tokenTypes=G,this.tokenModifiers=be}}e.$QO=Sn;function Xi(Q){return typeof Q>"u"||(0,p.$hg)(Q)}class Ui{constructor(G){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,G){this.m=!0;for(let be=0,Le=G.tokenTypes.length;be<Le;be++)this.k.set(G.tokenTypes[be],be);for(let be=0,Le=G.tokenModifiers.length;be<Le;be++)this.l.set(G.tokenModifiers[be],be)}}push(G,be,Le,xe,st){if(typeof G=="number"&&typeof be=="number"&&typeof Le=="number"&&typeof xe=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this.q(G,be,Le,xe,st);if(ee.isRange(G)&&typeof be=="string"&&Xi(Le))return this.o(G,be,Le);throw(0,a.$0)()}o(G,be,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(G.start.line!==G.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(be))throw new Error("`tokenType` is not in the provided legend");const xe=G.start.line,st=G.start.character,pt=G.end.character-G.start.character,St=this.k.get(be);let Zt=0;if(Le)for(const pi of Le){if(!this.l.has(pi))throw new Error("`tokenModifier` is not in the provided legend");const bi=this.l.get(pi);Zt|=1<<bi>>>0}this.q(xe,st,pt,St,Zt)}q(G,be,Le,xe,st){if(this.f&&(G<this.c||G===this.c&&be<this.e)){this.f=!1;const Zt=this.g.length/5|0;let pi=0,bi=0;for(let ki=0;ki<Zt;ki++){let Ci=this.g[5*ki],xi=this.g[5*ki+1];Ci===0?(Ci=pi,xi+=bi):Ci+=pi,this.g[5*ki]=Ci,this.g[5*ki+1]=xi,pi=Ci,bi=xi}}let pt=G,St=be;this.f&&this.j>0&&(pt-=this.c,pt===0&&(St-=this.e)),this.g[this.j++]=pt,this.g[this.j++]=St,this.g[this.j++]=Le,this.g[this.j++]=xe,this.g[this.j++]=st,this.c=G,this.e=be}static r(G){const be=[],Le=G.length/5|0;for(let St=0;St<Le;St++)be[St]=St;be.sort((St,Zt)=>{const pi=G[5*St],bi=G[5*Zt];if(pi===bi){const ki=G[5*St+1],Ci=G[5*Zt+1];return ki-Ci}return pi-bi});const xe=new Uint32Array(G.length);let st=0,pt=0;for(let St=0;St<Le;St++){const Zt=5*be[St],pi=G[Zt+0],bi=G[Zt+1],ki=G[Zt+2],Ci=G[Zt+3],xi=G[Zt+4],Xn=pi-st,Fr=Xn===0?bi-pt:bi,_i=5*St;xe[_i+0]=Xn,xe[_i+1]=Fr,xe[_i+2]=ki,xe[_i+3]=Ci,xe[_i+4]=xi,st=pi,pt=bi}return xe}build(G){return this.f?new We(new Uint32Array(this.g),G):new We(Ui.r(this.g),G)}}e.$RO=Ui;class We{constructor(G,be){this.resultId=be,this.data=G}}e.$SO=We;class Si{constructor(G,be,Le){this.start=G,this.deleteCount=be,this.data=Le}}e.$TO=Si;class ln{constructor(G,be){this.resultId=be,this.edits=G}}e.$UO=ln;var ht;(function(Q){Q[Q.Separate=0]="Separate",Q[Q.MergeWithParent=1]="MergeWithParent"})(ht||(e.DebugConsoleMode=ht={}));class Pt{constructor(G){this.name=G}}e.$VO=Pt;let Wi=class{constructor(){}};e.$WO=Wi,Wi.Back={iconPath:new Nt("arrow-left")},e.$WO=Wi=Ye([B],Wi);var un;(function(Q){Q[Q.Separator=-1]="Separator",Q[Q.Default=0]="Default"})(un||(e.QuickPickItemKind=un={}));var Yi;(function(Q){Q[Q.Info=1]="Info",Q[Q.Warning=2]="Warning",Q[Q.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var hn;(function(Q){Q[Q.UI=1]="UI",Q[Q.Workspace=2]="Workspace"})(hn||(e.ExtensionKind=hn={}));class qi{static validate(G){if(typeof G.badge=="string"){let be=(0,R.$Rf)(G.badge,0);if(be<G.badge.length&&(be+=(0,R.$Rf)(G.badge,be)),G.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if(G.badge&&!Nt.isThemeIcon(G.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!G.color&&!G.badge&&!G.tooltip)throw new Error("The decoration is empty");return!0}constructor(G,be,Le){this.badge=G,this.tooltip=be,this.color=Le}}e.$XO=qi;let Zi=class{constructor(G){this.kind=G}};e.$YO=Zi,e.$YO=Zi=Ye([B],Zi);var dn;(function(Q){Q[Q.Light=1]="Light",Q[Q.Dark=2]="Dark",Q[Q.HighContrast=3]="HighContrast",Q[Q.HighContrastLight=4]="HighContrastLight"})(dn||(e.ColorThemeKind=dn={}));class Di{static isNotebookRange(G){return G instanceof Di?!0:G?typeof G.start=="number"&&typeof G.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(G,be){if(G<0)throw(0,a.$0)("start must be positive");if(be<0)throw(0,a.$0)("end must be positive");G<=be?(this.c=G,this.e=be):(this.c=be,this.e=G)}with(G){let be=this.c,Le=this.e;return G.start!==void 0&&(be=G.start),G.end!==void 0&&(Le=G.end),be===this.c&&Le===this.e?this:new Di(be,Le)}}e.$ZO=Di;class Ni{static validate(G){if(typeof G.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof G.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof G.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(G){return Array.isArray(G)&&G.every(be=>Ni.isNotebookCellData(be))}static isNotebookCellData(G){return!0}constructor(G,be,Le,xe,st,pt,St){this.kind=G,this.value=be,this.languageId=Le,this.mime=xe,this.outputs=st??[],this.metadata=pt,this.executionSummary=St,Ni.validate(this)}}e.$1O=Ni;class Dn{constructor(G){this.cells=G}}e.$2O=Dn;class fn{static isNotebookCellOutputItem(G){return G instanceof t?!0:G?typeof G.mime=="string"&&G.data instanceof Uint8Array:!1}static error(G){const be={name:G.name,message:G.message,stack:G.stack};return t.json(be,"application/vnd.code.notebook.error")}static stdout(G){return t.text(G,"application/vnd.code.notebook.stdout")}static stderr(G){return t.text(G,"application/vnd.code.notebook.stderr")}static bytes(G,be="application/octet-stream"){return new t(G,be)}static text(G,be=O.$0s.text){const Le=He(t,t,"f",i).encode(String(G));return new t(Le,be)}static json(G,be="text/x-json"){const Le=JSON.stringify(G,void 0,"	");return t.text(Le,be)}constructor(G,be){this.data=G,this.mime=be;const Le=(0,O.$bt)(be,!0);if(!Le)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$3O=fn,t=fn,i={value:new TextEncoder};class Vi{static isNotebookCellOutput(G){return G instanceof Vi?!0:!G||typeof G!="object"?!1:typeof G.id=="string"&&Array.isArray(G.items)}static ensureUniqueMimeTypes(G,be=!1){const Le=new Set,xe=new Set;for(let st=0;st<G.length;st++){const pt=G[st],St=(0,O.$bt)(pt.mime);if(!Le.has(St)||(0,w.$AL)(St)){Le.add(St);continue}xe.add(st),be&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return xe.size===0?G:G.filter((st,pt)=>!xe.has(pt))}constructor(G,be,Le){this.items=Vi.ensureUniqueMimeTypes(G,!0),typeof be=="string"?(this.id=be,this.metadata=Le):(this.id=(0,I.$3g)(),this.metadata=be??Le)}}e.$4O=Vi;var gn;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(gn||(e.NotebookCellKind=gn={}));var mn;(function(Q){Q[Q.Idle=1]="Idle",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(mn||(e.NotebookCellExecutionState=mn={}));var $n;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})($n||(e.NotebookCellStatusBarAlignment=$n={}));var pn;(function(Q){Q[Q.Default=0]="Default",Q[Q.InCenter=1]="InCenter",Q[Q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Q[Q.AtTop=3]="AtTop"})(pn||(e.NotebookEditorRevealType=pn={}));class kn{constructor(G,be){this.text=G,this.alignment=be}}e.$5O=kn;var bn;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred"})(bn||(e.NotebookControllerAffinity=bn={}));var wn;(function(Q){Q[Q.Default=1]="Default",Q[Q.Preferred=2]="Preferred",Q[Q.Hidden=-1]="Hidden"})(wn||(e.NotebookControllerAffinity2=wn={}));class In{constructor(G,be=[]){this.uri=G,this.provides=(0,r.$5b)(be)}}e.$6O=In;class pe{constructor(G){this.label=G}}e.$7O=pe;var Ee;(function(Q){Q[Q.Named=1]="Named",Q[Q.Indexed=2]="Indexed"})(Ee||(e.NotebookVariablesRequestKind=Ee={}));let Be=class{constructor(G,be){this.label=G,this.timestamp=be}};e.$8O=Be,e.$8O=Be=Ye([B],Be);var gt;(function(Q){Q[Q.Production=1]="Production",Q[Q.Development=2]="Development",Q[Q.Test=3]="Test"})(gt||(e.ExtensionMode=gt={}));var It;(function(Q){Q[Q.Node=1]="Node",Q[Q.Webworker=2]="Webworker"})(It||(e.ExtensionRuntime=It={}));var zt;(function(Q){Q[Q.Other=0]="Other",Q[Q.Comment=1]="Comment",Q[Q.String=2]="String",Q[Q.RegEx=3]="RegEx"})(zt||(e.StandardTokenType=zt={}));class Fi{constructor(G,be){this.ranges=G,this.wordPattern=be}}e.$9O=Fi;class Pn{constructor(G){this.c=G}get autoForwardAction(){return this.c}}e.$0O=Pn;var On;(function(Q){Q[Q.Queued=1]="Queued",Q[Q.Running=2]="Running",Q[Q.Passed=3]="Passed",Q[Q.Failed=4]="Failed",Q[Q.Skipped=5]="Skipped",Q[Q.Errored=6]="Errored"})(On||(e.TestResultState=On={}));var Ln;(function(Q){Q[Q.Run=1]="Run",Q[Q.Debug=2]="Debug",Q[Q.Coverage=3]="Coverage"})(Ln||(e.TestRunProfileKind=Ln={}));let Cn=class{constructor(G=void 0,be=void 0,Le=void 0,xe=!1,st=!0){this.include=G,this.exclude=be,this.profile=Le,this.continuous=xe,this.preserveFocus=st}};e.$$O=Cn,e.$$O=Cn=Ye([B],Cn);let An=L=class{static diff(G,be,Le){const xe=new L(G);return xe.expectedOutput=be,xe.actualOutput=Le,xe}constructor(G){this.message=G}};e.$_O=An,e.$_O=An=L=Ye([B],An);let Rn=class{constructor(G){this.id=G}};e.$aP=Rn,e.$aP=Rn=Ye([B],Rn);class vn{constructor(G,be){this.covered=G,this.total=be,Nn(this)}}e.$bP=vn;function Nn(Q){if(Q){if(Q.covered>Q.total)throw new Error(`The total number of covered items (${Q.covered}) cannot be greater than the total (${Q.total})`);if(Q.total<0)throw new Error(`The number of covered items (${Q.total}) cannot be negative`)}}class Tn{static fromDetails(G,be){const Le=new vn(0,0),xe=new vn(0,0),st=new vn(0,0);for(const St of be)if("branches"in St){Le.total+=1,Le.covered+=St.executed?1:0;for(const Zt of St.branches)xe.total+=1,xe.covered+=Zt.executed?1:0}else st.total+=1,st.covered+=St.executed?1:0;const pt=new Tn(G,Le,xe.total>0?xe:void 0,st.total>0?st:void 0);return pt.detailedCoverage=be,pt}constructor(G,be,Le,xe,st=[]){this.uri=G,this.statementCoverage=be,this.branchCoverage=Le,this.declarationCoverage=xe,this.fromTests=st}}e.$dP=Tn;class xn{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,be,Le=[]){this.executed=G,this.location=be,this.branches=Le}}e.$eP=xn;class _n{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,be,Le){this.executed=G,this.location=be,this.label=Le}}e.$fP=_n;class er{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,be,Le){this.name=G,this.executed=be,this.location=Le}}e.$gP=er;var Fn;(function(Q){Q[Q.None=0]="None",Q[Q.Option=1]="Option",Q[Q.Default=2]="Default",Q[Q.Preferred=3]="Preferred"})(Fn||(e.ExternalUriOpenerPriority=Fn={}));var Mn;(function(Q){Q[Q.Untrusted=0]="Untrusted",Q[Q.Trusted=1]="Trusted",Q[Q.Unspecified=2]="Unspecified"})(Mn||(e.WorkspaceTrustState=Mn={}));var jn;(function(Q){Q[Q.Notify=1]="Notify",Q[Q.OpenBrowser=2]="OpenBrowser",Q[Q.OpenPreview=3]="OpenPreview",Q[Q.Silent=4]="Silent",Q[Q.Ignore=5]="Ignore",Q[Q.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn||(e.PortAutoForwardAction=jn={}));class tr{constructor(G,be,Le,xe,st,pt){this.kind=G,this.name=be,this.detail=Le,this.uri=xe,this.range=st,this.selectionRange=pt}}e.$hP=tr;class ir{constructor(G){this.uri=G}}e.$iP=ir;class nr{constructor(G,be){this.original=G,this.modified=be}}e.$jP=nr;class rr{constructor(G,be,Le,xe){this.base=G,this.input1=be,this.input2=Le,this.result=xe}}e.$kP=rr;class sr{constructor(G,be){this.uri=G,this.viewType=be}}e.$lP=sr;class or{constructor(G){this.viewType=G}}e.$mP=or;class ar{constructor(G,be){this.uri=G,this.notebookType=be}}e.$nP=ar;class cr{constructor(G,be,Le){this.original=G,this.modified=be,this.notebookType=Le}}e.$oP=cr;class lr{constructor(){}}e.$pP=lr;class ur{constructor(G,be){this.uri=G,this.inputBoxUri=be}}e.$qP=ur;class hr{constructor(){}}e.$rP=hr;class dr{constructor(G){this.textDiffs=G}}e.$sP=dr;var zn;(function(Q){Q[Q.Down=0]="Down",Q[Q.Up=1]="Up"})(zn||(e.InteractiveSessionVoteDirection=zn={}));var Bn;(function(Q){Q[Q.Action=1]="Action",Q[Q.Toolbar=2]="Toolbar"})(Bn||(e.ChatCopyKind=Bn={}));var Un;(function(Q){Q[Q.Short=1]="Short",Q[Q.Medium=2]="Medium",Q[Q.Full=3]="Full"})(Un||(e.ChatVariableLevel=Un={}));class fr{constructor(G,be,Le){this.id=G,this.label=be,this.values=Le}}e.$tP=fr;var Wn;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful",Q[Q.Undone=2]="Undone",Q[Q.Accepted=3]="Accepted",Q[Q.Bug=4]="Bug"})(Wn||(e.InteractiveEditorResponseFeedbackKind=Wn={}));var qn;(function(Q){Q[Q.Unhelpful=0]="Unhelpful",Q[Q.Helpful=1]="Helpful"})(qn||(e.ChatResultFeedbackKind=qn={}));class gr{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new at(G):G}}e.$uP=gr;class mr{constructor(G,be){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new at(G):G,this.vulnerabilities=be}}e.$vP=mr;class $r{constructor(G,be){this.participant=G,this.command=be}}e.$wP=$r;class pr{constructor(G,be,Le){this.title=G,this.message=be,this.data=Le}}e.$xP=pr;class br{constructor(G,be){this.value=G,this.baseUri=be}}e.$yP=br;class wr{constructor(G,be){this.value=G,this.title=be}}e.$zP=wr;class vr{constructor(G){this.value=G}}e.$AP=vr;class yr{constructor(G,be){this.value=G,this.task=be}}e.$BP=yr;class Er{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new at(G):G}}e.$CP=Er;class Sr{constructor(G){this.value=G}}e.$DP=Sr;class Dr{constructor(G,be){this.value=G,this.iconPath=be}}e.$EP=Dr;class kr{constructor(G,be){this.uri=G,this.edits=Array.isArray(be)?be:[be]}}e.$FP=kr;class Ir{constructor(G,be,Le,xe){this.prompt=G,this.command=be,this.references=Le,this.participant=xe}}e.$GP=Ir;class Pr{constructor(G,be,Le,xe){this.response=G,this.result=be,this.participant=Le,this.command=xe}}e.$HP=Pr;var Vn;(function(Q){Q[Q.Panel=1]="Panel",Q[Q.Terminal=2]="Terminal",Q[Q.Notebook=3]="Notebook",Q[Q.Editor=4]="Editor"})(Vn||(e.ChatLocation=Vn={}));var yn;(function(Q){Q[Q.User=1]="User",Q[Q.Assistant=2]="Assistant",Q[Q.System=3]="System"})(yn||(e.LanguageModelChatMessageRole=yn={}));class Cr{constructor(G,be,Le){this.name=G,this.content=be,this.isError=Le??!1}}e.$IP=Cr;class En{static User(G,be){const Le=new En(yn.User,typeof G=="string"?G:"",be);return Le.content2=G,Le}static Assistant(G,be){return new En(yn.Assistant,G,be)}constructor(G,be,Le){this.role=G,this.content=be,this.content2=be,this.name=Le}}e.$JP=En;class Ar{constructor(G,be){this.name=G,this.parameters=be}}e.$KP=Ar;class Rr{constructor(G){this.value=G}}e.$LP=Rr;class Tr{constructor(G){this.content=G}}e.$MP=Tr;class Or{constructor(G,be){this.content=G,this.name=be}}e.$NP=Or;class Lr{constructor(G,be){this.content=G,this.name=be}}e.$OP=Lr;class Ti extends Error{static NotFound(G){return new Ti(G,Ti.NotFound.name)}static NoPermissions(G){return new Ti(G,Ti.NoPermissions.name)}static Blocked(G){return new Ti(G,Ti.Blocked.name)}constructor(G,be,Le){super(G,{cause:Le}),this.name="LanguageModelError",this.code=be??""}}e.$PP=Ti;var Gn;(function(Q){Q[Q.SymbolInformation=1]="SymbolInformation",Q[Q.CommandInformation=2]="CommandInformation",Q[Q.SearchInformation=3]="SearchInformation",Q[Q.SettingInformation=4]="SettingInformation"})(Gn||(e.RelatedInformationType=Gn={}));var Hn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Recognizing=2]="Recognizing",Q[Q.Recognized=3]="Recognized",Q[Q.Stopped=4]="Stopped",Q[Q.Error=5]="Error"})(Hn||(e.SpeechToTextStatus=Hn={}));var Kn;(function(Q){Q[Q.Started=1]="Started",Q[Q.Stopped=2]="Stopped",Q[Q.Error=3]="Error"})(Kn||(e.TextToSpeechStatus=Kn={}));var Qn;(function(Q){Q[Q.Recognized=1]="Recognized",Q[Q.Stopped=2]="Stopped"})(Qn||(e.KeywordRecognitionStatus=Qn={}));class Nr{constructor(G,be){this.text=G,this.range=be}}e.$QP=Nr;var Jn;(function(Q){Q[Q.Invoke=0]="Invoke",Q[Q.Automatic=1]="Automatic"})(Jn||(e.InlineEditTriggerKind=Jn={}))}),define(Se[340],De([1,0,6,8]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0;class k{constructor(O){this.a=new Map,this.b=0,this.c=O.getProxy(r.$vN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(O,R,p){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(O);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(R,p)??[]}getRelatedInformation(O,R,p){return this.c.$getAiRelatedInformation(R,p)}registerRelatedInformationProvider(O,R,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiRelatedInformationProvider(c,R),new a.$xN(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$woc=k}),define(Se[129],De([1,0,4,6,8,24,157,5,20]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=e.$Hoc=void 0,e.$Hoc=(0,R.$Gi)("IExtHostAuthentication");let c=class{constructor(h){this.b=new Map,this.c=new r.$ne,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=h.getProxy(a.$vN.MainThreadAuthentication)}async getSession(h,P,w,l={}){const m=A.$sn.toKey(h.identifier),g=[...w].sort().join(" ");return await this.d.getOrCreate(`${m} ${P} ${g}`,async()=>{await this.a.$ensureProvider(P);const $=h.displayName||h.name;return this.a.$getSession(P,w,m,$,l)})}async getAccounts(h){return await this.a.$ensureProvider(h),await this.a.$getAccounts(h)}async removeSession(h,P){const w=this.b.get(h);return w?w.provider.removeSession(P):this.a.$removeSession(h,P)}registerAuthenticationProvider(h,P,w,l){if(this.b.get(h))throw new Error(`An authentication provider with id '${h}' is already registered.`);this.b.set(h,{label:P,provider:w,options:l??{supportsMultipleAccounts:!1}});const m=w.onDidChangeSessions(g=>this.a.$sendDidChangeSessions(h,g));return this.a.$registerAuthenticationProvider(h,P,l?.supportsMultipleAccounts??!1),new k.$xN(()=>{m.dispose(),this.b.delete(h),this.a.$unregisterAuthenticationProvider(h)})}async $createSession(h,P,w){const l=this.b.get(h);if(l)return await l.provider.createSession(P,w);throw new Error(`Unable to find authentication provider with handle: ${h}`)}async $removeSession(h,P){const w=this.b.get(h);if(w)return await w.provider.removeSession(P);throw new Error(`Unable to find authentication provider with handle: ${h}`)}async $getSessions(h,P,w){const l=this.b.get(h);if(l)return await l.provider.getSessions(P,w);throw new Error(`Unable to find authentication provider with handle: ${h}`)}$onDidChangeAuthenticationSessions(h,P){return h.startsWith(O.$xM)||this.c.fire({provider:{id:h,label:P}}),Promise.resolve()}};e.$Ioc=c,e.$Ioc=c=Ye([Ve(0,p.$2P)],c);class I{constructor(){this.a=new Map}getOrCreate(h,P){const w=this.a.get(h);if(w)return w;const l=P().finally(()=>this.a.delete(h));return this.a.set(h,l),l}}}),define(Se[164],De([1,0,2,6,8,5,20,12,19,13,17,26]),function(ie,e,r,a,k,A,O,R,p,c,I,S){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=e.$Mpc=void 0;let P=h=class{constructor(l,m){this.h=m,this.f=new Map,this.g=l.getProxy(a.$vN.MainThreadDecorations)}registerFileDecorationProvider(l,m){const g=h.c++;this.f.set(g,{provider:l,extensionDescription:m}),this.g.$registerDecorationProvider(g,m.identifier.value);const $=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(g,null);return}const o=(0,p.$5b)(n);if(o.length<=h.d){this.g.$onDidChange(g,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,o.length);const t=o.map(d=>({uri:d,rank:(0,c.$kf)(d.path,"/")})),i=(0,p.$Cb)(t,(d,u)=>d.rank-u.rank||(0,c.$Af)(d.uri.path,u.uri.path)),s=[];e:for(const d of i){let u;for(const b of d){const E=(0,I.$pc)(b.uri.path);if(u!==E&&(u=E,s.push(b.uri)>=h.d))break e}}this.g.$onDidChange(g,s)});return new k.$xN(()=>{$?.dispose(),this.g.$unregisterDecorationProvider(g),this.f.delete(g)})}async $provideDecorations(l,m,g){if(!this.f.has(l))return Object.create(null);const $=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(l);return await Promise.all(m.map(async t=>{try{const{uri:i,id:s}=t,d=await Promise.resolve(n.provideFileDecoration(r.URI.revive(i),g));if(!d)return;try{k.$XO.validate(d),d.badge&&typeof d.badge!="string"&&(0,S.$8G)(o,"codiconDecoration"),$[s]=[d.propagate,d.tooltip,d.badge,d.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(i){this.h.error(i)}})),$}};e.$Mpc=P,P.c=0,P.d=250,e.$Mpc=P=h=Ye([Ve(0,O.$2P),Ve(1,R.$ak)],P),e.$Npc=(0,A.$Gi)("IExtHostDecorations")}),define(Se[341],De([1,0,14,2,8,6,15,21,13]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0;class c{constructor(S,h,P){this.d=h,this.e=P,this.b=new Map,this.c=S.getProxy(A.$vN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,h){if(Object.keys(O.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const P=c.a++;this.b.set(P,h),this.c.$registerTextContentProvider(P,S);let w;if(typeof h.onDidChange=="function"){let l;w=h.onDidChange(async m=>{if(m.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;l&&await l;const g=this.$provideTextDocumentContent(P,m).then(async $=>{if(!$&&typeof $!="string")return;const n=this.d.getDocument(m);if(!n)return;const o=(0,p.$uf)($);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(m,$)}).catch(r.$3).finally(()=>{l===g&&(l=void 0)});l=g})}return new k.$xN(()=>{this.b.delete(P)&&this.c.$unregisterTextContentProvider(P),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(S,h){const P=this.b.get(S);return P?Promise.resolve(P.provideTextDocumentContent(a.URI.revive(h),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.$Ppc=c,c.a=0}),define(Se[165],De([1,0,66,15,13,206,142,8,19]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=void 0,e.$4P=I;const c=new Map;function I(w,l){l?c.set(w,l):c.delete(w)}function S(w){return c.get(w)}class h extends A.$nw{constructor(l,m,g,$,n,o,t){super(m,g,$,n),this.c=l,this.m=o,this.q=t,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,p.$xb)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===a.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(m){return m?l.s(m):l.getText()},get eol(){return l.g===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(m){return l.t(m)},offsetAt(m){return l.u(m)},positionAt(m){return l.v(m)},validateRange(m){return l.w(m)},validatePosition(m){return l.x(m)},getWordRangeAtPosition(m,g){return l.y(m,g)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,r.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,r.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const m=this.w(l);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const g=this.g,$=m.start.line,n=m.end.line,o=[];o.push(this.f[$].substring(m.start.character));for(let t=$+1;t<n;t++)o.push(this.f[t]);return o.push(this.f[n].substring(0,m.end.character)),o.join(g)}t(l){let m;if(l instanceof R.$yN?m=l.line:typeof l=="number"&&(m=l),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new P(m,this.f[m],m===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const m=this.j.getIndexOf(l),g=this.f[m.index].length;return new R.$yN(m.index,Math.min(m.remainder,g))}w(l){if(!(l instanceof R.$zN))throw new Error("Invalid argument");const m=this.x(l.start),g=this.x(l.end);return m===l.start&&g===l.end?l:new R.$zN(m.line,m.character,g.line,g.character)}x(l){if(!(l instanceof R.$yN))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:m,character:g}=l,$=!1;if(m<0)m=0,g=0,$=!0;else if(m>=this.f.length)m=this.f.length-1,g=this.f[m].length,$=!0;else{const n=this.f[m].length;g<0?(g=0,$=!0):g>n&&(g=n,$=!0)}return $?new R.$yN(m,g):l}y(l,m){const g=this.x(l);if(!m)m=S(this.m);else if((0,k.$tf)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const $=(0,O.$pt)(g.character+1,(0,O.$nt)(m),this.f[g.line],0);if($)return new R.$zN(g.line,$.startColumn-1,g.line,$.endColumn-1)}}e.$5P=h;class P{constructor(l,m,g){this.a=l,this.b=m,this.c=g}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.$zN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.$zN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$6P=P}),define(Se[342],De([1,0,6,8]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0;class k{constructor(O){this.a=new Map,this.b=0,this.c=O.getProxy(r.$vN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(O,R,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(O);if(!c)throw new Error("Embedding vector provider not found");const I=await c.provideEmbeddingVector(R,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(O,R,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiEmbeddingVectorProvider(R,c),new a.$xN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$Spc=k}),define(Se[76],De([1,0,6,28,8,22,5,20,63,3,7,23,15]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=e.$Xoc=void 0,a=Ue(a);let w=P=class{constructor(m,g){this.b=new Map,this.c=new I.$Ph,this.a=m.getProxy(r.$vN.MainThreadFileSystem);const $=this;this.value=Object.freeze({async stat(n){try{let o;const t=$.b.get(n.scheme);return t?(await $.a.$ensureActivation(n.scheme),o=await t.impl.stat(n)):o=await $.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===a.FilePermission.Readonly?1:void 0}}catch(o){P.e(o)}},async readDirectory(n){try{const o=$.b.get(n.scheme);return o?(await $.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await $.a.$readdir(n)}catch(o){return P.e(o)}},async createDirectory(n){try{const o=$.b.get(n.scheme);return o&&!o.isReadonly?(await $.a.$ensureActivation(n.scheme),await $.d(o.impl,o.extUri,n)):await $.a.$mkdir(n)}catch(o){return P.e(o)}},async readFile(n){try{const o=$.b.get(n.scheme);return o?(await $.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await $.a.$readFile(n)).buffer}catch(o){return P.e(o)}},async writeFile(n,o){try{const t=$.b.get(n.scheme);return t&&!t.isReadonly?(await $.a.$ensureActivation(n.scheme),await $.d(t.impl,t.extUri,t.extUri.dirname(n)),await $.c.queueFor(n,()=>Promise.resolve(t.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await $.a.$writeFile(n,A.$Pe.wrap(o))}catch(t){return P.e(t)}},async delete(n,o){try{const t=$.b.get(n.scheme);return t&&!t.isReadonly&&!o?.useTrash?(await $.a.$ensureActivation(n.scheme),await t.impl.delete(n,{recursive:!1,...o})):await $.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(t){return P.e(t)}},async rename(n,o,t){try{return await $.a.$rename(n,o,{overwrite:!1,...t})}catch(i){return P.e(i)}},async copy(n,o,t){try{return await $.a.$copy(n,o,{overwrite:!1,...t})}catch(i){return P.e(i)}},isWritableFileSystem(n){const o=g.getCapabilities(n);if(typeof o=="number")return!(o&a.FileSystemProviderCapabilities.Readonly)}})}async d(m,g,$){const n=[];for(;!g.isEqual($,g.dirname($));)try{if(!((await m.stat($)).type&a.FileType.Directory))throw k.$OO.FileExists(`Unable to create folder '${$.scheme===h.Schemas.file?$.fsPath:$.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(a.$ql(o)!==a.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(g.basename($)),$=g.dirname($)}for(let o=n.length-1;o>=0;o--){$=g.joinPath($,n[o]);try{await m.createDirectory($)}catch(t){if(a.$ql(t)!==a.FileSystemProviderErrorCode.FileExists)throw t}}}static e(m){if(m instanceof k.$OO)throw m;if(m instanceof a.$ml)switch(m.code){case a.FileSystemProviderErrorCode.FileExists:throw k.$OO.FileExists(m.message);case a.FileSystemProviderErrorCode.FileNotFound:throw k.$OO.FileNotFound(m.message);case a.FileSystemProviderErrorCode.FileNotADirectory:throw k.$OO.FileNotADirectory(m.message);case a.FileSystemProviderErrorCode.FileIsADirectory:throw k.$OO.FileIsADirectory(m.message);case a.FileSystemProviderErrorCode.NoPermissions:throw k.$OO.NoPermissions(m.message);case a.FileSystemProviderErrorCode.Unavailable:throw k.$OO.Unavailable(m.message);default:throw new k.$OO(m.message,m.name)}if(!(m instanceof Error))throw new k.$OO(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw k.$OO.Unavailable(m.message);switch(m.name){case a.FileSystemProviderErrorCode.FileExists:throw k.$OO.FileExists(m.message);case a.FileSystemProviderErrorCode.FileNotFound:throw k.$OO.FileNotFound(m.message);case a.FileSystemProviderErrorCode.FileNotADirectory:throw k.$OO.FileNotADirectory(m.message);case a.FileSystemProviderErrorCode.FileIsADirectory:throw k.$OO.FileIsADirectory(m.message);case a.FileSystemProviderErrorCode.NoPermissions:throw k.$OO.NoPermissions(m.message);case a.FileSystemProviderErrorCode.Unavailable:throw k.$OO.Unavailable(m.message);default:throw new k.$OO(m.message,m.name)}}addFileSystemProvider(m,g,$){return this.b.set(m,{impl:g,extUri:$?.isCaseSensitive?S.$0g:S.$_g,isReadonly:!!$?.isReadonly}),(0,c.$Vc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??S.$0g}};e.$Xoc=w,e.$Xoc=w=P=Ye([Ve(0,R.$2P),Ve(1,p.$Boc)],w),e.$Yoc=(0,O.$Gi)("IExtHostConsumerFileSystem")}),define(Se[98],De([1,0,5,30,12,76,2]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=e.$Zoc=void 0,e.$Zoc=(0,r.$Gi)("IExtensionStoragePaths");let R=class{constructor(c,I,S){this.d=I,this.f=S,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(c){return O.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,I=await this.g(c);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(O.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:O.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(c){if(this.c)return O.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return O.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$1oc=R,e.$1oc=R=Ye([Ve(0,a.$fQ),Ve(1,k.$ak),Ve(2,A.$Yoc)],R)}),define(Se[343],De([1,0,8,20,4]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;let A=class{constructor(R){this.a=new r.$YO(r.ColorThemeKind.Dark),this.b=new k.$ne}get activeColorTheme(){return this.a}$onColorThemeChange(R){let p;switch(R){case"light":p=r.ColorThemeKind.Light;break;case"hcDark":p=r.ColorThemeKind.HighContrast;break;case"hcLight":p=r.ColorThemeKind.HighContrastLight;break;default:p=r.ColorThemeKind.Dark}this.a=new r.$YO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$xqc=A,e.$xqc=A=Ye([Ve(0,a.$2P)],A)}),define(Se[77],De([1,0,21,4,3,244,5,12,93,6,30,20,8]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aGb=e.$_Fb=e.TunnelDtoConverter=void 0,A=Ue(A),h=Ue(h);class P extends p.$Mw{}var w;(function(m){function g(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=g;function $(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=$})(w||(e.TunnelDtoConverter=w={})),e.$_Fb=(0,O.$Gi)("IExtHostTunnelService");let l=class extends k.$Xc{constructor(g,$,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new a.$ne,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=g.getProxy(c.$vN.MainThreadTunnelService)}async openTunnel(g,$){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${$.remoteAddress.host}:${$.remoteAddress.port}.`);const n=await this.a.$openTunnel($,g.displayName);if(n){const o=new P(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(g,$){g.portRange===void 0&&g.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:g,provider:$}),this.a.$registerPortsAttributesProvider(g,n),new h.$xN(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(g,$,n,o,t){const i=[];for(const d of g){const u=this.r.get(d);if(!u)return[];i.push(...await Promise.all($.map(async b=>{let E;try{E=await u.provider.providePortAttributes({port:b,pid:n,commandLine:o},t)}catch{E=await u.provider.providePortAttributes(b,n,o,t)}return{providedAttributes:E,port:b}})))}const s=i.filter(d=>!!d.providedAttributes);return s.length>0?s.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(g){}registerTunnelProvider(g,$){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,t)=>await g.provideTunnel(o,t,r.CancellationToken.None)??void 0;const n=$.tunnelFeatures?{elevation:!!$.tunnelFeatures?.elevation,privacyOptions:$.tunnelFeatures?.privacyOptions,protocol:$.tunnelFeatures.protocol===void 0?!0:$.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,k.$Vc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(g,$){if(g){g.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this.f=g.showCandidatePort,this.a.$setCandidateFilter());const n=g.tunnelFactory??($?this.w($):void 0);if(n){this.b=n;let o=g.tunnelFeatures?.privacyOptions??[];g.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const t=g.tunnelFeatures?{elevation:!!g.tunnelFeatures?.elevation,public:!!g.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,k.$Vc)(()=>{this.b=void 0})}w(g){}async $closeTunnel(g,$){if(this.g.has(g.host)){const n=this.g.get(g.host);n.has(g.port)&&($&&n.get(g.port).disposeListener.dispose(),await n.get(g.port).tunnel.dispose(),n.delete(g.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(g,$){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(g,$);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(g.remoteAddress.host)||this.g.set(g.remoteAddress.host,new Map);const t=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:o,disposeListener:t}),w.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(g){const $=await Promise.all(g.map(o=>this.f(o.host,o.port,o.detail??""))),n=g.filter((o,t)=>$[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$aGb=l,e.$aGb=l=Ye([Ve(0,S.$2P),Ve(1,I.$fQ),Ve(2,R.$ak)],l)}),define(Se[16],De([1,0,19,22,190,80,86,29,178,55,104,25,183,23,50,18,2,114,31,111,88,58,147,90,156,154,306,321,121,128,74,75,318,8]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s,d,u,b,E,D,y,T,C,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$YP=re,e.$ZP=Z,e.$1P=$e,O=Ue(O),$=Ue($),n=Ue(n),o=Ue(o),E=Ue(E),y=Ue(y),f=Ue(f);var N;(function(Te){function je(se){const{selectionStartLineNumber:Oe,selectionStartColumn:Ke,positionLineNumber:it,positionColumn:Je}=se,$t=new f.$yN(Oe-1,Ke-1),Rt=new f.$yN(it-1,Je-1);return new f.$AN($t,Rt)}Te.to=je;function ye(se){const{anchor:Oe,active:Ke}=se;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Te.from=ye})(N||(e.Selection=N={}));var F;(function(Te){function je(se){if(!se)return;const{start:Oe,end:Ke}=se;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Te.from=je;function ye(se){if(!se)return;const{startLineNumber:Oe,startColumn:Ke,endLineNumber:it,endColumn:Je}=se;return new f.$zN(Oe-1,Ke-1,it-1,Je-1)}Te.to=ye})(F||(e.Range=F={}));var j;(function(Te){function je(se){return{uri:se.uri,range:F.from(se.range)}}Te.from=je;function ye(se){return new f.$JN(m.URI.revive(se.uri),F.to(se.range))}Te.to=ye})(j||(e.Location=j={}));var z;(function(Te){function je(ye){switch(ye){case n.StandardTokenType.Comment:return f.StandardTokenType.Comment;case n.StandardTokenType.Other:return f.StandardTokenType.Other;case n.StandardTokenType.RegEx:return f.StandardTokenType.RegEx;case n.StandardTokenType.String:return f.StandardTokenType.String}}Te.to=je})(z||(e.TokenType=z={}));var M;(function(Te){function je(se){return new f.$yN(se.lineNumber-1,se.column-1)}Te.to=je;function ye(se){return{lineNumber:se.line+1,column:se.character+1}}Te.from=ye})(M||(e.Position=M={}));var L;(function(Te){function je(Oe,Ke,it){return(0,r.$Kb)((0,r.$5b)(Oe).map(Je=>ye(Je,Ke,it)))}Te.from=je;function ye(Oe,Ke,it){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:it?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:se(Oe.scheme,Ke),pattern:et.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:it?.isBuiltin}}function se(Oe,Ke){return Ke&&typeof Oe=="string"?Ke.transformOutgoingScheme(Oe):Oe}})(L||(e.DocumentSelector=L={}));var B;(function(Te){function je(se){switch(se){case f.DiagnosticTag.Unnecessary:return i.MarkerTag.Unnecessary;case f.DiagnosticTag.Deprecated:return i.MarkerTag.Deprecated}}Te.from=je;function ye(se){switch(se){case i.MarkerTag.Unnecessary:return f.DiagnosticTag.Unnecessary;case i.MarkerTag.Deprecated:return f.DiagnosticTag.Deprecated;default:return}}Te.to=ye})(B||(e.DiagnosticTag=B={}));var W;(function(Te){function je(se){let Oe;return se.code&&((0,l.$gg)(se.code)||(0,l.$kg)(se.code)?Oe=String(se.code):Oe={value:String(se.code.value),target:se.code.target}),{...F.from(se.range),message:se.message,source:se.source,code:Oe,severity:q.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(ae.from),tags:Array.isArray(se.tags)?(0,r.$Kb)(se.tags.map(B.from)):void 0}}Te.from=je;function ye(se){const Oe=new f.$LN(F.to(se),se.message,q.to(se.severity));return Oe.source=se.source,Oe.code=(0,l.$gg)(se.code)?se.code:se.code?.value,Oe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(ae.to),Oe.tags=se.tags&&(0,r.$Kb)(se.tags.map(B.to)),Oe}Te.to=ye})(W||(e.Diagnostic=W={}));var ae;(function(Te){function je(se){return{...F.from(se.location.range),message:se.message,resource:se.location.uri}}Te.from=je;function ye(se){return new f.$KN(new f.$JN(se.resource,F.to(se)),se.message)}Te.to=ye})(ae||(e.DiagnosticRelatedInformation=ae={}));var q;(function(Te){function je(se){switch(se){case f.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Te.from=je;function ye(se){switch(se){case i.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}Te.to=ye})(q||(e.DiagnosticSeverity=q={}));var K;(function(Te){function je(se){return typeof se=="number"&&se>=f.ViewColumn.One?se-1:se===f.ViewColumn.Beside?v.$qE:v.$pE}Te.from=je;function ye(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=ye})(K||(e.ViewColumn=K={}));function ee(Te){return typeof Te.range<"u"}function re(Te){return Te.length===0?!0:!!ee(Te[0])}var ge;(function(Te){function je(Je){return Je.map(Te.from)}Te.fromMany=je;function ye(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function se(Je){let $t;if(ye(Je)){const{language:Ut,value:di}=Je;$t={value:"```"+Ut+`
`+di+"\n```\n"}}else f.$ZN.isMarkdownString(Je)?$t={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?$t={value:Je}:$t={value:""};const Rt=Object.create(null);$t.uris=Rt;const Yt=Ut=>{try{let di=m.URI.parse(Ut,!0);di=di.with({query:Oe(di.query,Rt)}),Rt[Ut]=di}catch{}return""},ci=new p.marked.Renderer;return ci.link=Yt,ci.image=Ut=>typeof Ut=="string"?Yt(O.$_k(Ut).href):"",(0,p.marked)($t.value,{renderer:ci}),$t}Te.from=se;function Oe(Je,$t){if(!Je)return Je;let Rt;try{Rt=(0,c.$ci)(Je)}catch{}if(!Rt)return Je;let Yt=!1;return Rt=(0,S.$ho)(Rt,ci=>{if(m.URI.isUri(ci)){const Ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return $t[Ut]=ci,Yt=!0,Ut}else return}),Yt?JSON.stringify(Rt):Je}function Ke(Je){const $t=new f.$ZN(Je.value,Je.supportThemeIcons);return $t.isTrusted=Je.isTrusted,$t.supportHtml=Je.supportHtml,$t.baseUri=Je.baseUri?m.URI.from(Je.baseUri):void 0,$t}Te.to=Ke;function it(Je){if(Je)return typeof Je=="string"?Je:Te.from(Je)}Te.fromStrict=it})(ge||(e.MarkdownString=ge={}));function Z(Te){return re(Te)?Te.map(je=>({range:F.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?ge.fromMany(je.hoverMessage):je.hoverMessage?ge.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Te.map(je=>({range:F.from(je)}))}function $e(Te){return typeof Te>"u"?Te:typeof Te=="string"?m.URI.file(Te):Te}var fe;(function(Te){function je(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?$e(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Te.from=je})(fe||(e.ThemableDecorationAttachmentRenderOptions=fe={}));var oe;(function(Te){function je(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?$e(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?fe.from(ye.before):void 0,after:ye.after?fe.from(ye.after):void 0}}Te.from=je})(oe||(e.ThemableDecorationRenderOptions=oe={}));var H;(function(Te){function je(ye){if(typeof ye>"u")return ye;switch(ye){case f.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case f.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case f.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case f.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Te.from=je})(H||(e.DecorationRangeBehavior=H={}));var ue;(function(Te){function je(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?H.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?oe.from(ye.light):void 0,dark:ye.dark?oe.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?$e(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?fe.from(ye.before):void 0,after:ye.after?fe.from(ye.after):void 0}}Te.from=je})(ue||(e.DecorationRenderOptions=ue={}));var te;(function(Te){function je(se){return{text:se.newText,eol:se.newEol&&Ne.from(se.newEol),range:F.from(se.range)}}Te.from=je;function ye(se){const Oe=new f.$EN(F.to(se.range),se.text);return Oe.newEol=typeof se.eol>"u"?void 0:Ne.to(se.eol),Oe}Te.to=ye})(te||(e.TextEdit=te={}));var _;(function(Te){function je(se,Oe){const Ke={edits:[]};if(se instanceof f.$HN){const it=new R.$Ec;for(const Je of se._allEntries())Je._type===f.FileEditType.File&&m.URI.isUri(Je.to)&&Je.from===void 0&&it.add(Je.to);for(const Je of se._allEntries())if(Je._type===f.FileEditType.File){let $t;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?$t={type:"base64",value:(0,a.$0e)(a.$Pe.wrap(Je.options.contents))}:$t={type:"dataTransferItem",id:Je.options.contents._itemId}),Ke.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:$t},metadata:Je.metadata})}else Je._type===f.FileEditType.Text?Ke.edits.push({resource:Je.uri,textEdit:te.from(Je.edit),versionId:it.has(Je.uri)?void 0:Oe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===f.FileEditType.Snippet?Ke.edits.push({resource:Je.uri,textEdit:{range:F.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:it.has(Je.uri)?void 0:Oe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===f.FileEditType.Cell?Ke.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Je.uri)}):Je._type===f.FileEditType.CellReplace&&Ke.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:y.CellEditType.Replace,index:Je.index,count:Je.count,cells:Je.cells.map(tt.from)}})}return Ke}Te.from=je;function ye(se){const Oe=new f.$HN,Ke=new R.$Dc;for(const it of se.edits)if(it.textEdit){const Je=it,$t=m.URI.revive(Je.resource),Rt=F.to(Je.textEdit.range),Yt=Je.textEdit.text,ci=Je.textEdit.insertAsSnippet;let Ut;ci?Ut=f.$GN.replace(Rt,new f.$IN(Yt)):Ut=f.$EN.replace(Rt,Yt);const di=Ke.get($t);di?di.push(Ut):Ke.set($t,[Ut])}else Oe.renameFile(m.URI.revive(it.oldResource),m.URI.revive(it.newResource),it.options);for(const[it,Je]of Ke)Oe.set(it,Je);return Oe}Te.to=ye})(_||(e.WorkspaceEdit=_={}));var ne;(function(Te){const je=Object.create(null);je[f.SymbolKind.File]=o.SymbolKind.File,je[f.SymbolKind.Module]=o.SymbolKind.Module,je[f.SymbolKind.Namespace]=o.SymbolKind.Namespace,je[f.SymbolKind.Package]=o.SymbolKind.Package,je[f.SymbolKind.Class]=o.SymbolKind.Class,je[f.SymbolKind.Method]=o.SymbolKind.Method,je[f.SymbolKind.Property]=o.SymbolKind.Property,je[f.SymbolKind.Field]=o.SymbolKind.Field,je[f.SymbolKind.Constructor]=o.SymbolKind.Constructor,je[f.SymbolKind.Enum]=o.SymbolKind.Enum,je[f.SymbolKind.Interface]=o.SymbolKind.Interface,je[f.SymbolKind.Function]=o.SymbolKind.Function,je[f.SymbolKind.Variable]=o.SymbolKind.Variable,je[f.SymbolKind.Constant]=o.SymbolKind.Constant,je[f.SymbolKind.String]=o.SymbolKind.String,je[f.SymbolKind.Number]=o.SymbolKind.Number,je[f.SymbolKind.Boolean]=o.SymbolKind.Boolean,je[f.SymbolKind.Array]=o.SymbolKind.Array,je[f.SymbolKind.Object]=o.SymbolKind.Object,je[f.SymbolKind.Key]=o.SymbolKind.Key,je[f.SymbolKind.Null]=o.SymbolKind.Null,je[f.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,je[f.SymbolKind.Struct]=o.SymbolKind.Struct,je[f.SymbolKind.Event]=o.SymbolKind.Event,je[f.SymbolKind.Operator]=o.SymbolKind.Operator,je[f.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function ye(Oe){return typeof je[Oe]=="number"?je[Oe]:o.SymbolKind.Property}Te.from=ye;function se(Oe){for(const Ke in je)if(je[Ke]===Oe)return Number(Ke);return f.SymbolKind.Property}Te.to=se})(ne||(e.SymbolKind=ne={}));var le;(function(Te){function je(se){switch(se){case f.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Te.from=je;function ye(se){switch(se){case o.SymbolTag.Deprecated:return f.SymbolTag.Deprecated}}Te.to=ye})(le||(e.SymbolTag=le={}));var J;(function(Te){function je(se){return{name:se.name,kind:ne.from(se.kind),tags:se.tags&&se.tags.map(le.from),containerName:se.containerName,location:qe.from(se.location)}}Te.from=je;function ye(se){const Oe=new f.$QN(se.name,ne.to(se.kind),se.containerName,qe.to(se.location));return Oe.tags=se.tags&&se.tags.map(le.to),Oe}Te.to=ye})(J||(e.WorkspaceSymbol=J={}));var ce;(function(Te){function je(se){const Oe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:F.from(se.range),selectionRange:F.from(se.selectionRange),kind:ne.from(se.kind),tags:se.tags?.map(le.from)??[]};return se.children&&(Oe.children=se.children.map(je)),Oe}Te.from=je;function ye(se){const Oe=new f.$RN(se.name,se.detail,ne.to(se.kind),F.to(se.range),F.to(se.selectionRange));return(0,r.$Ob)(se.tags)&&(Oe.tags=se.tags.map(le.to)),se.children&&(Oe.children=se.children.map(ye)),Oe}Te.to=ye})(ce||(e.DocumentSymbol=ce={}));var me;(function(Te){function je(se){const Oe=new f.$VN(ne.to(se.kind),se.name,se.detail||"",m.URI.revive(se.uri),F.to(se.range),F.to(se.selectionRange));return Oe._sessionId=se._sessionId,Oe._itemId=se._itemId,Oe}Te.to=je;function ye(se,Oe,Ke){if(Oe=Oe??se._sessionId,Ke=Ke??se._itemId,Oe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ke,name:se.name,detail:se.detail,kind:ne.from(se.kind),uri:se.uri,range:F.from(se.range),selectionRange:F.from(se.selectionRange),tags:se.tags?.map(le.from)}}Te.from=ye})(me||(e.CallHierarchyItem=me={}));var we;(function(Te){function je(ye){return new f.$WN(me.to(ye.from),ye.fromRanges.map(se=>F.to(se)))}Te.to=je})(we||(e.CallHierarchyIncomingCall=we={}));var Me;(function(Te){function je(ye){return new f.$XN(me.to(ye.to),ye.fromRanges.map(se=>F.to(se)))}Te.to=je})(Me||(e.CallHierarchyOutgoingCall=Me={}));var qe;(function(Te){function je(se){return{range:se.range&&F.from(se.range),uri:se.uri}}Te.from=je;function ye(se){return new f.$JN(m.URI.revive(se.uri),F.to(se.range))}Te.to=ye})(qe||(e.location=qe={}));var ke;(function(Te){function je(se){const Oe=se,Ke=se;return{originSelectionRange:Oe.originSelectionRange?F.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ke.uri,range:F.from(Oe.targetRange?Oe.targetRange:Ke.range),targetSelectionRange:Oe.targetSelectionRange?F.from(Oe.targetSelectionRange):void 0}}Te.from=je;function ye(se){return{targetUri:m.URI.revive(se.uri),targetRange:F.to(se.range),targetSelectionRange:se.targetSelectionRange?F.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?F.to(se.originSelectionRange):void 0}}Te.to=ye})(ke||(e.DefinitionLink=ke={}));var Ie;(function(Te){function je(se){return{range:F.from(se.range),contents:ge.fromMany(se.contents),canIncreaseVerbosity:se.canIncreaseVerbosity,canDecreaseVerbosity:se.canDecreaseVerbosity}}Te.from=je;function ye(se){const Oe=se.contents.map(ge.to),Ke=F.to(se.range),it=se.canIncreaseVerbosity,Je=se.canDecreaseVerbosity;return new f.$NN(Oe,Ke,it,Je)}Te.to=ye})(Ie||(e.Hover=Ie={}));var Ce;(function(Te){function je(se){return{range:F.from(se.range),expression:se.expression}}Te.from=je;function ye(se){return new f.$IO(F.to(se.range),se.expression)}Te.to=ye})(Ce||(e.EvaluatableExpression=Ce={}));var U;(function(Te){function je(se){if(se instanceof f.$JO)return{type:"text",range:F.from(se.range),text:se.text};if(se instanceof f.$KO)return{type:"variable",range:F.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof f.$LO)return{type:"expression",range:F.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=je;function ye(se){switch(se.type){case"text":return{range:F.to(se.range),text:se.text};case"variable":return{range:F.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:F.to(se.range),expression:se.expression}}}Te.to=ye})(U||(e.InlineValue=U={}));var V;(function(Te){function je(se){return{frameId:se.frameId,stoppedLocation:F.from(se.stoppedLocation)}}Te.from=je;function ye(se){return new f.$MO(se.frameId,F.to(se.stoppedLocation))}Te.to=ye})(V||(e.InlineValueContext=V={}));var X;(function(Te){function je(se){return{range:F.from(se.range),kind:se.kind}}Te.from=je;function ye(se){return new f.$ON(F.to(se.range),se.kind)}Te.to=ye})(X||(e.DocumentHighlight=X={}));var x;(function(Te){function je(se){return{uri:se.uri,highlights:se.highlights.map(X.from)}}Te.from=je;function ye(se){return new f.$PN(m.URI.revive(se.uri),se.highlights.map(X.to))}Te.to=ye})(x||(e.MultiDocumentHighlight=x={}));var de;(function(Te){function je(ye){switch(ye){case o.CompletionTriggerKind.TriggerCharacter:return f.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return f.CompletionTriggerKind.Invoke}}Te.to=je})(de||(e.CompletionTriggerKind=de={}));var ve;(function(Te){function je(ye){return{triggerKind:de.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Te.to=je})(ve||(e.CompletionContext=ve={}));var Fe;(function(Te){function je(se){switch(se){case f.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Te.from=je;function ye(se){switch(se){case o.CompletionItemTag.Deprecated:return f.CompletionItemTag.Deprecated}}Te.to=ye})(Fe||(e.CompletionItemTag=Fe={}));var Ge;(function(Te){const je=new Map([[f.CompletionItemKind.Method,o.CompletionItemKind.Method],[f.CompletionItemKind.Function,o.CompletionItemKind.Function],[f.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[f.CompletionItemKind.Field,o.CompletionItemKind.Field],[f.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[f.CompletionItemKind.Class,o.CompletionItemKind.Class],[f.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[f.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[f.CompletionItemKind.Module,o.CompletionItemKind.Module],[f.CompletionItemKind.Property,o.CompletionItemKind.Property],[f.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[f.CompletionItemKind.Value,o.CompletionItemKind.Value],[f.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[f.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[f.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[f.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[f.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[f.CompletionItemKind.Text,o.CompletionItemKind.Text],[f.CompletionItemKind.Color,o.CompletionItemKind.Color],[f.CompletionItemKind.File,o.CompletionItemKind.File],[f.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[f.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[f.CompletionItemKind.Event,o.CompletionItemKind.Event],[f.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[f.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[f.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[f.CompletionItemKind.User,o.CompletionItemKind.User]]);function ye(Ke){return je.get(Ke)??o.CompletionItemKind.Property}Te.from=ye;const se=new Map([[o.CompletionItemKind.Method,f.CompletionItemKind.Method],[o.CompletionItemKind.Function,f.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,f.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,f.CompletionItemKind.Field],[o.CompletionItemKind.Variable,f.CompletionItemKind.Variable],[o.CompletionItemKind.Class,f.CompletionItemKind.Class],[o.CompletionItemKind.Interface,f.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,f.CompletionItemKind.Struct],[o.CompletionItemKind.Module,f.CompletionItemKind.Module],[o.CompletionItemKind.Property,f.CompletionItemKind.Property],[o.CompletionItemKind.Unit,f.CompletionItemKind.Unit],[o.CompletionItemKind.Value,f.CompletionItemKind.Value],[o.CompletionItemKind.Constant,f.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,f.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,f.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,f.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,f.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,f.CompletionItemKind.Text],[o.CompletionItemKind.Color,f.CompletionItemKind.Color],[o.CompletionItemKind.File,f.CompletionItemKind.File],[o.CompletionItemKind.Reference,f.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,f.CompletionItemKind.Folder],[o.CompletionItemKind.Event,f.CompletionItemKind.Event],[o.CompletionItemKind.Operator,f.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,f.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,f.CompletionItemKind.User],[o.CompletionItemKind.Issue,f.CompletionItemKind.Issue]]);function Oe(Ke){return se.get(Ke)??f.CompletionItemKind.Property}Te.to=Oe})(Ge||(e.CompletionItemKind=Ge={}));var Xe;(function(Te){function je(ye,se){const Oe=new f.$6N(ye.label);return Oe.insertText=ye.insertText,Oe.kind=Ge.to(ye.kind),Oe.tags=ye.tags?.map(Fe.to),Oe.detail=ye.detail,Oe.documentation=O.$6k(ye.documentation)?ge.to(ye.documentation):ye.documentation,Oe.sortText=ye.sortText,Oe.filterText=ye.filterText,Oe.preselect=ye.preselect,Oe.commitCharacters=ye.commitCharacters,$.$Nt.isIRange(ye.range)?Oe.range=F.to(ye.range):typeof ye.range=="object"&&(Oe.range={inserting:F.to(ye.range.insert),replacing:F.to(ye.range.replace)}),Oe.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof ye.insertTextRules<"u"&&ye.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Oe.insertText=new f.$IN(ye.insertText):(Oe.insertText=ye.insertText,Oe.textEdit=Oe.range instanceof f.$zN?new f.$EN(Oe.range,Oe.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ye.additionalTextEdits.map(Ke=>te.to(Ke))),Oe.command=se&&ye.command?se.fromInternal(ye.command):void 0,Oe}Te.to=je})(Xe||(e.CompletionItem=Xe={}));var Qe;(function(Te){function je(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:ge.fromStrict(se.documentation)}}Te.from=je;function ye(se){return{label:se.label,documentation:O.$6k(se.documentation)?ge.to(se.documentation):se.documentation}}Te.to=ye})(Qe||(e.ParameterInformation=Qe={}));var nt;(function(Te){function je(se){return{label:se.label,documentation:ge.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Qe.from):[],activeParameter:se.activeParameter}}Te.from=je;function ye(se){return{label:se.label,documentation:O.$6k(se.documentation)?ge.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Qe.to):[],activeParameter:se.activeParameter}}Te.to=ye})(nt||(e.SignatureInformation=nt={}));var ct;(function(Te){function je(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(nt.from):[]}}Te.from=je;function ye(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(nt.to):[]}}Te.to=ye})(ct||(e.SignatureHelp=ct={}));var rt;(function(Te){function je(ye,se){const Oe=new f.$5N(M.to(se.position),typeof se.label=="string"?se.label:se.label.map(lt.to.bind(void 0,ye)),se.kind&&bt.to(se.kind));return Oe.textEdits=se.textEdits&&se.textEdits.map(te.to),Oe.tooltip=O.$6k(se.tooltip)?ge.to(se.tooltip):se.tooltip,Oe.paddingLeft=se.paddingLeft,Oe.paddingRight=se.paddingRight,Oe}Te.to=je})(rt||(e.InlayHint=rt={}));var lt;(function(Te){function je(ye,se){const Oe=new f.$4N(se.label);return Oe.tooltip=O.$6k(se.tooltip)?ge.to(se.tooltip):se.tooltip,o.Command.is(se.command)&&(Oe.command=ye.fromInternal(se.command)),se.location&&(Oe.location=qe.to(se.location)),Oe}Te.to=je})(lt||(e.InlayHintLabelPart=lt={}));var bt;(function(Te){function je(se){return se}Te.from=je;function ye(se){return se}Te.to=ye})(bt||(e.InlayHintKind=bt={}));var ft;(function(Te){function je(se){return{range:F.from(se.range),url:se.target,tooltip:se.tooltip}}Te.from=je;function ye(se){let Oe;if(se.url)try{Oe=typeof se.url=="string"?m.URI.parse(se.url,!0):m.URI.revive(se.url)}catch{}const Ke=new f.$$N(F.to(se.range),Oe);return Ke.tooltip=se.tooltip,Ke}Te.to=ye})(ft||(e.DocumentLink=ft={}));var at;(function(Te){function je(se){const Oe=new f.$bO(se.label);return se.textEdit&&(Oe.textEdit=te.to(se.textEdit)),se.additionalTextEdits&&(Oe.additionalTextEdits=se.additionalTextEdits.map(Ke=>te.to(Ke))),Oe}Te.to=je;function ye(se){return{label:se.label,textEdit:se.textEdit?te.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Oe=>te.from(Oe)):void 0}}Te.from=ye})(at||(e.ColorPresentation=at={}));var dt;(function(Te){function je(se){return new f.$_N(se[0],se[1],se[2],se[3])}Te.to=je;function ye(se){return[se.red,se.green,se.blue,se.alpha]}Te.from=ye})(dt||(e.Color=dt={}));var Pe;(function(Te){function je(se){return{range:F.from(se.range)}}Te.from=je;function ye(se){return new f.$UN(F.to(se.range))}Te.to=ye})(Pe||(e.SelectionRange=Pe={}));var ze;(function(Te){function je(ye){switch(ye){case u.SaveReason.AUTO:return f.TextDocumentSaveReason.AfterDelay;case u.SaveReason.EXPLICIT:return f.TextDocumentSaveReason.Manual;case u.SaveReason.FOCUS_CHANGE:case u.SaveReason.WINDOW_CHANGE:return f.TextDocumentSaveReason.FocusOut}}Te.to=je})(ze||(e.TextDocumentSaveReason=ze={}));var Re;(function(Te){function je(se){switch(se){case f.TextEditorLineNumbersStyle.Off:return g.RenderLineNumbersType.Off;case f.TextEditorLineNumbersStyle.Relative:return g.RenderLineNumbersType.Relative;case f.TextEditorLineNumbersStyle.Interval:return g.RenderLineNumbersType.Interval;case f.TextEditorLineNumbersStyle.On:default:return g.RenderLineNumbersType.On}}Te.from=je;function ye(se){switch(se){case g.RenderLineNumbersType.Off:return f.TextEditorLineNumbersStyle.Off;case g.RenderLineNumbersType.Relative:return f.TextEditorLineNumbersStyle.Relative;case g.RenderLineNumbersType.Interval:return f.TextEditorLineNumbersStyle.Interval;case g.RenderLineNumbersType.On:default:return f.TextEditorLineNumbersStyle.On}}Te.to=ye})(Re||(e.TextEditorLineNumbersStyle=Re={}));var Ne;(function(Te){function je(se){if(se===f.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(se===f.EndOfLine.LF)return t.EndOfLineSequence.LF}Te.from=je;function ye(se){if(se===t.EndOfLineSequence.CRLF)return f.EndOfLine.CRLF;if(se===t.EndOfLineSequence.LF)return f.EndOfLine.LF}Te.to=ye})(Ne||(e.EndOfLine=Ne={}));var he;(function(Te){function je(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case f.ProgressLocation.SourceControl:return s.ProgressLocation.Scm;case f.ProgressLocation.Window:return s.ProgressLocation.Window;case f.ProgressLocation.Notification:return s.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Te.from=je})(he||(e.ProgressLocation=he={}));var Y;(function(Te){function je(se){const Oe={start:se.start+1,end:se.end+1};return se.kind&&(Oe.kind=Ae.from(se.kind)),Oe}Te.from=je;function ye(se){const Oe={start:se.start-1,end:se.end-1};return se.kind&&(Oe.kind=Ae.to(se.kind)),Oe}Te.to=ye})(Y||(e.FoldingRange=Y={}));var Ae;(function(Te){function je(se){if(se)switch(se){case f.FoldingRangeKind.Comment:return o.$Nu.Comment;case f.FoldingRangeKind.Imports:return o.$Nu.Imports;case f.FoldingRangeKind.Region:return o.$Nu.Region}}Te.from=je;function ye(se){if(se)switch(se.value){case o.$Nu.Comment.value:return f.FoldingRangeKind.Comment;case o.$Nu.Imports.value:return f.FoldingRangeKind.Imports;case o.$Nu.Region.value:return f.FoldingRangeKind.Region}}Te.to=ye})(Ae||(e.FoldingRangeKind=Ae={}));var Ze;(function(Te){function je(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?F.from(ye.selection):void 0,override:typeof ye.override=="boolean"?u.$TF.id:void 0}}Te.from=je})(Ze||(e.TextEditorOpenOptions=Ze={}));var et;(function(Te){function je(Ke){return Ke instanceof f.$wO?Ke.toJSON():typeof Ke=="string"?Ke:ye(Ke)||se(Ke)?new f.$wO(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Te.from=je;function ye(Ke){const it=Ke;return it?m.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function se(Ke){const it=Ke;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Oe(Ke){return typeof Ke=="string"?Ke:new f.$wO(m.URI.revive(Ke.baseUri),Ke.pattern)}Te.to=Oe})(et||(e.GlobPattern=et={}));var ut;(function(Te){function je(ye){if(ye){if(Array.isArray(ye))return ye.map(je);if(typeof ye=="string")return ye;{const se=ye;return{language:se.language,scheme:se.scheme,pattern:et.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Te.from=je})(ut||(e.LanguageSelector=ut={}));var mt;(function(Te){function je(se){return!!se&&typeof se=="object"&&"documents"in se&&Array.isArray(se.documents)&&se.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&m.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(it=>it instanceof f.$zN)))}Te.is=je;function ye(se){return{documents:se.documents.map(Oe=>Oe.map(Ke=>({uri:m.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(it=>F.from(it))})))}}Te.from=ye})(mt||(e.MappedEditsContext=mt={}));var Dt;(function(Te){function je(se){return{start:se.start,end:se.end}}Te.from=je;function ye(se){return new f.$ZO(se.start,se.end)}Te.to=ye})(Dt||(e.NotebookRange=Dt={}));var Ft;(function(Te){function je(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Te.to=je;function ye(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Te.from=ye})(Ft||(e.NotebookCellExecutionSummary=Ft={}));var Kt;(function(Te){function je(ye){if(ye===y.NotebookCellExecutionState.Unconfirmed)return f.NotebookCellExecutionState.Pending;if(ye===y.NotebookCellExecutionState.Pending)return;if(ye===y.NotebookCellExecutionState.Executing)return f.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Te.to=je})(Kt||(e.NotebookCellExecutionState=Kt={}));var li;(function(Te){function je(se){switch(se){case f.NotebookCellKind.Markup:return y.CellKind.Markup;case f.NotebookCellKind.Code:default:return y.CellKind.Code}}Te.from=je;function ye(se){switch(se){case y.CellKind.Markup:return f.NotebookCellKind.Markup;case y.CellKind.Code:default:return f.NotebookCellKind.Code}}Te.to=ye})(li||(e.NotebookCellKind=li={}));var fi;(function(Te){function je(se){const Oe={metadata:se.metadata??Object.create(null),cells:[]};for(const Ke of se.cells)f.$1O.validate(Ke),Oe.cells.push(tt.from(Ke));return Oe}Te.from=je;function ye(se){const Oe=new f.$2O(se.cells.map(tt.to));return(0,l.$tg)(se.metadata)||(Oe.metadata=se.metadata),Oe}Te.to=ye})(fi||(e.NotebookData=fi={}));var tt;(function(Te){function je(se){return{cellKind:li.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Ft.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(Jt.from):[]}}Te.from=je;function ye(se){return new f.$1O(li.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(Jt.to):void 0,se.metadata,se.internalMetadata?Ft.to(se.internalMetadata):void 0)}Te.to=ye})(tt||(e.NotebookCellData=tt={}));var xt;(function(Te){function je(se){return{mime:se.mime,valueBytes:a.$Pe.wrap(se.data)}}Te.from=je;function ye(se){return new f.$3O(se.valueBytes.buffer,se.mime)}Te.to=ye})(xt||(e.NotebookCellOutputItem=xt={}));var Jt;(function(Te){function je(se){return{outputId:se.id,items:se.items.map(xt.from),metadata:se.metadata}}Te.from=je;function ye(se){const Oe=se.items.map(xt.to);return new f.$4O(Oe,se.outputId,se.metadata)}Te.to=ye})(Jt||(e.NotebookCellOutput=Jt={}));var wt;(function(Te){function je(Oe){return se(Oe)?{include:et.from(Oe.include)??void 0,exclude:et.from(Oe.exclude)??void 0}:et.from(Oe)??void 0}Te.from=je;function ye(Oe){return se(Oe)?{include:et.to(Oe.include),exclude:et.to(Oe.exclude)}:et.to(Oe)}Te.to=ye;function se(Oe){const Ke=Oe;return Ke?!(0,l.$pg)(Ke.include)&&!(0,l.$pg)(Ke.exclude):!1}})(wt||(e.NotebookExclusiveDocumentPattern=wt={}));var kt;(function(Te){function je(ye,se,Oe){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===f.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:se.toInternal(Ke,Oe),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Te.from=je})(kt||(e.NotebookStatusBarItem=kt={}));var si;(function(Te){function je(ye,se,Oe){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:se.toInternal(Ke,Oe),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Te.from=je})(si||(e.NotebookKernelSourceAction=si={}));var _t;(function(Te){function je(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Te.from=je})(_t||(e.NotebookDocumentContentOptions=_t={}));var Wt;(function(Te){function je(se){return{uri:se.uri,provides:se.provides}}Te.from=je;function ye(se){return new f.$6O(m.URI.revive(se.uri),se.provides)}Te.to=ye})(Wt||(e.NotebookRendererScript=Wt={}));var vt;(function(Te){function je(se){return{message:ge.fromStrict(se.message)||"",type:C.TestMessageType.Error,expected:se.expectedOutput,actual:se.actualOutput,contextValue:se.contextValue,location:se.location&&{range:F.from(se.location.range),uri:se.location.uri}}}Te.from=je;function ye(se){const Oe=new f.$_O(typeof se.message=="string"?se.message:ge.to(se.message));return Oe.actualOutput=se.actual,Oe.expectedOutput=se.expected,Oe.contextValue=se.contextValue,Oe.location=se.location?qe.to(se.location):void 0,Oe}Te.to=ye})(vt||(e.TestMessage=vt={}));var Tt;(function(Te){Te.namespace=C.$ZI,Te.denamespace=C.$1I})(Tt||(e.TestTag=Tt={}));var ei;(function(Te){function je(se){const Oe=(0,d.$XP)(se).controllerId;return{extId:T.$UI.fromExtHostTestItem(se,Oe).toString(),label:se.label,uri:m.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(Ke=>Tt.namespace(Oe,Ke.id)),range:$.$Nt.lift(F.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&ge.fromStrict(se.error)||null}}Te.from=je;function ye(se){return{parent:void 0,error:void 0,id:T.$UI.fromString(se.extId).localId,label:se.label,uri:m.URI.revive(se.uri),tags:(se.tags||[]).map(Oe=>{const{tagId:Ke}=Tt.denamespace(Oe);return new f.$aP(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:F.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Te.toPlain=ye})(ei||(e.TestItem=ei={})),function(Te){function je(se){return{id:se.id}}Te.from=je;function ye(se){return new f.$aP(se.id)}Te.to=ye}(Tt||(e.TestTag=Tt={}));var Vt;(function(Te){const je=(se,Oe)=>{const Ke=se.value;if(!Ke)return;const it={...ei.toPlain(Ke.item),parent:Oe,taskStates:Ke.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter($t=>$t.type===C.TestMessageType.Error).map(vt.to)})),children:[]};if(se.children)for(const Je of se.children.values()){const $t=je(Je,it);$t&&it.children.push($t)}return it};function ye(se){const Oe=new h.$TI;for(const Je of se.items)Oe.insert(T.$UI.fromString(Je.item.extId).path,Je);const Ke=[Oe.nodes],it=[];for(;Ke.length;)for(const Je of Ke.pop())Je.value?it.push(Je):Je.children&&Ke.push(Je.children.values());return{completedAt:se.completedAt,results:it.map(Je=>je(Je)).filter(l.$og)}}Te.to=ye})(Vt||(e.TestResults=Vt={}));var _e;(function(Te){function je(Ke){return{covered:Ke.covered,total:Ke.total}}function ye(Ke){return"line"in Ke?M.from(Ke):F.from(Ke)}function se(Ke){if(typeof Ke.executed=="number"&&Ke.executed<0)throw new Error(`Invalid coverage count ${Ke.executed}`);return"branches"in Ke?{count:Ke.executed,location:ye(Ke.location),type:C.DetailType.Statement,branches:Ke.branches.length?Ke.branches.map(it=>({count:it.executed,location:it.location&&ye(it.location),label:it.label})):void 0}:{type:C.DetailType.Declaration,name:Ke.name,count:Ke.executed,location:ye(Ke.location)}}Te.fromDetails=se;function Oe(Ke,it,Je){return f.$cP(Je.statementCoverage),f.$cP(Je.branchCoverage),f.$cP(Je.declarationCoverage),{id:it,uri:Je.uri,statement:je(Je.statementCoverage),branch:Je.branchCoverage&&je(Je.branchCoverage),declaration:Je.declarationCoverage&&je(Je.declarationCoverage),testIds:Je instanceof f.$dP&&Je.fromTests.length?Je.fromTests.map($t=>T.$UI.fromExtHostTestItem($t,Ke).toString()):void 0}}Te.fromFile=Oe})(_e||(e.TestCoverage=_e={}));var ti;(function(Te){function je(ye){switch(ye){case o.CodeActionTriggerType.Invoke:return f.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return f.CodeActionTriggerKind.Automatic}}Te.to=je})(ti||(e.CodeActionTriggerKind=ti={}));var oi;(function(Te){function je(se){const Oe=new f.$hP(ne.to(se.kind),se.name,se.detail||"",m.URI.revive(se.uri),F.to(se.range),F.to(se.selectionRange));return Oe._sessionId=se._sessionId,Oe._itemId=se._itemId,Oe}Te.to=je;function ye(se,Oe,Ke){if(Oe=Oe??se._sessionId,Ke=Ke??se._itemId,Oe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ke,kind:ne.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:F.from(se.range),selectionRange:F.from(se.selectionRange),tags:se.tags?.map(le.from)}}Te.from=ye})(oi||(e.TypeHierarchyItem=oi={}));var gi;(function(Te){function je(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Te.from=je})(gi||(e.ViewBadge=gi={}));var Ct;(function(Te){function je(Ke,it,Je){const $t=it.fileData;return $t?new f.$oO(new f.$pO($t.name,m.URI.revive($t.uri),$t.id,(0,A.$gb)(()=>Je($t.id)))):Ke===I.$0s.uriList&&it.uriListData?new f.$nO(Oe(it.uriListData)):new f.$nO(it.asString)}Te.to=je;async function ye(Ke,it){const Je=await it.asString();if(Ke===I.$0s.uriList)return{asString:Je,fileData:void 0,uriListData:se(Je)};const $t=it.asFile();return{asString:Je,fileData:$t?{name:$t.name,uri:$t.uri,id:$t._itemId??$t.id}:void 0}}Te.from=ye;function se(Ke){return k.$ru.split(Ke).map(it=>{if(it.startsWith("#"))return it;try{return m.URI.parse(it)}catch{}return it})}function Oe(Ke){return k.$ru.create(Ke.map(it=>typeof it=="string"?it:m.URI.revive(it)))}})(Ct||(e.DataTransferItem=Ct={}));var Gt;(function(Te){function je(se,Oe){const Ke=se.items.map(([it,Je])=>[it,Ct.to(it,Je,Oe)]);return new f.$qO(Ke)}Te.toDataTransfer=je;async function ye(se){const Oe={items:[]},Ke=[];for(const[it,Je]of se)Ke.push((async()=>{Oe.items.push([it,await Ct.from(it,Je)])})());return await Promise.all(Ke),Oe}Te.from=ye})(Gt||(e.DataTransfer=Gt={}));var Mt;(function(Te){function je(se,Oe){return{kind:"reply",agentId:se.participant??Oe?.agentId??"",subCommand:se.command??Oe?.command,message:se.prompt,title:se.label}}Te.from=je;function ye(se){return{prompt:se.message,label:se.title,participant:se.agentId,command:se.subCommand}}Te.to=ye})(Mt||(e.ChatFollowup=Mt={}));var Ht;(function(Te){function je(se){switch(se){case E.ChatMessageRole.System:return f.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return f.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return f.LanguageModelChatMessageRole.Assistant}}Te.to=je;function ye(se){switch(se){case f.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case f.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case f.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}Te.from=ye})(Ht||(e.LanguageModelChatMessageRole=Ht={}));var $i;(function(Te){function je(se){let Oe="",Ke;se.content.type==="text"?Oe=se.content.value:Ke=new f.$IP(se.content.name,se.content.value,se.content.isError);const it=Ht.to(se.role),Je=new f.$JP(it,Oe,se.name);return Ke!==void 0&&(Je.content2=Ke),Je}Te.to=je;function ye(se){const Oe=Ht.from(se.role),Ke=se.name;let it;return se.content2 instanceof f.$IP?it={type:"function_result",name:se.content2.name,value:se.content2.content,isError:se.content2.isError}:it={type:"text",value:se.content},{role:Oe,name:Ke,content:it}}Te.from=ye})($i||(e.LanguageModelChatMessage=$i={}));var ii;(function(Te){function je(se){return{kind:"markdownContent",content:ge.from(se.value)}}Te.from=je;function ye(se){return new f.$uP(ge.to(se.content))}Te.to=ye})(ii||(e.ChatResponseMarkdownPart=ii={}));var ui;(function(Te){function je(se){return{kind:"markdownVuln",content:ge.from(se.value),vulnerabilities:se.vulnerabilities}}Te.from=je;function ye(se){return new f.$vP(ge.to(se.content),se.vulnerabilities)}Te.to=ye})(ui||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ui={}));var jt;(function(Te){function je(se){return{kind:"agentDetection",agentId:se.participant,command:se.command}}Te.from=je;function ye(se){return new f.$wP(se.agentId,se.command)}Te.to=ye})(jt||(e.ChatResponseDetectedParticipantPart=jt={}));var Xt;(function(Te){function je(ye){return{kind:"confirmation",title:ye.title,message:ye.message,data:ye.data}}Te.from=je})(Xt||(e.ChatResponseConfirmationPart=Xt={}));var ni;(function(Te){function je(se){const{value:Oe,baseUri:Ke}=se;function it(Je,$t){return Je.map(Rt=>{const Yt=m.URI.joinPath($t,Rt.name);return{label:Rt.name,uri:Yt,children:Rt.children&&it(Rt.children,Yt)}})}return{kind:"treeData",treeData:{label:(0,P.$eh)(Ke),uri:Ke,children:it(Oe,Ke)}}}Te.from=je;function ye(se){const Oe=(0,c.$di)(se.treeData);function Ke($t){return $t.map(Rt=>({name:Rt.label,children:Rt.children&&Ke(Rt.children)}))}const it=Oe.uri,Je=Oe.children?Ke(Oe.children):[];return new f.$yP(Je,it)}Te.to=ye})(ni||(e.ChatResponseFilesPart=ni={}));var Ot;(function(Te){function je(se){const Oe=Ke=>m.URI.isUri(Ke);return{kind:"inlineReference",name:se.title,inlineReference:Oe(se.value)?se.value:j.from(se.value)}}Te.from=je;function ye(se){const Oe=(0,c.$di)(se);return new f.$zP(m.URI.isUri(Oe.inlineReference)?Oe.inlineReference:j.to(Oe.inlineReference),se.name)}Te.to=ye})(Ot||(e.ChatResponseAnchorPart=Ot={}));var At;(function(Te){function je(se){return{kind:"progressMessage",content:ge.from(se.value)}}Te.from=je;function ye(se){return new f.$AP(se.content.value)}Te.to=ye})(At||(e.ChatResponseProgressPart=At={}));var Et;(function(Te){function je(se){return{kind:"warning",content:ge.from(se.value)}}Te.from=je;function ye(se){return new f.$CP(se.content.value)}Te.to=ye})(Et||(e.ChatResponseWarningPart=Et={}));var ri;(function(Te){function je(ye){return{kind:"progressTask",content:ge.from(ye.value)}}Te.from=je})(ri||(e.ChatTask=ri={}));var yt;(function(Te){function je(ye){return{kind:"progressTaskResult",content:typeof ye=="string"?ge.from(ye):void 0}}Te.from=je})(yt||(e.ChatTaskResult=yt={}));var ai;(function(Te){function je(se,Oe,Ke){return{kind:"command",command:Oe.toInternal(se.value,Ke)??{command:se.value.command,title:se.value.title}}}Te.from=je;function ye(se,Oe){return new f.$DP(Oe.fromInternal(se.command)??{command:se.command.id,title:se.command.title})}Te.to=ye})(ai||(e.ChatResponseCommandButtonPart=ai={}));var Qt;(function(Te){function je(se){return{kind:"textEdit",uri:se.uri,edits:se.edits.map(Oe=>te.from(Oe))}}Te.from=je;function ye(se){return new f.$FP(m.URI.revive(se.uri),se.edits.map(Oe=>te.to(Oe)))}Te.to=ye})(Qt||(e.ChatResponseTextEditPart=Qt={}));var wi;(function(Te){function je(se){const Oe=w.ThemeIcon.isThemeIcon(se.iconPath)?se.iconPath:m.URI.isUri(se.iconPath)?{light:m.URI.revive(se.iconPath)}:se.iconPath&&"light"in se.iconPath&&"dark"in se.iconPath&&m.URI.isUri(se.iconPath.light)&&m.URI.isUri(se.iconPath.dark)?{light:m.URI.revive(se.iconPath.light),dark:m.URI.revive(se.iconPath.dark)}:void 0;return"variableName"in se.value?{kind:"reference",reference:{variableName:se.value.variableName,value:m.URI.isUri(se.value.value)||!se.value.value?se.value.value:j.from(se.value.value)},iconPath:Oe}:{kind:"reference",reference:m.URI.isUri(se.value)?se.value:j.from(se.value),iconPath:Oe}}Te.from=je;function ye(se){const Oe=(0,c.$di)(se),Ke=it=>m.URI.isUri(it)?it:j.to(it);return new f.$EP("variableName"in Oe.reference?{variableName:Oe.reference.variableName,value:Oe.reference.value&&Ke(Oe.reference.value)}:Ke(Oe.reference))}Te.to=ye})(wi||(e.ChatResponseReferencePart=wi={}));var mi;(function(Te){function je(Oe,Ke,it){return Oe instanceof f.$uP?ii.from(Oe):Oe instanceof f.$zP?Ot.from(Oe):Oe instanceof f.$EP?wi.from(Oe):Oe instanceof f.$AP?At.from(Oe):Oe instanceof f.$yP?ni.from(Oe):Oe instanceof f.$DP?ai.from(Oe,Ke,it):Oe instanceof f.$FP?Qt.from(Oe):Oe instanceof f.$vP?ui.from(Oe):Oe instanceof f.$wP?jt.from(Oe):Oe instanceof f.$CP?Et.from(Oe):{kind:"markdownContent",content:ge.from("")}}Te.from=je;function ye(Oe,Ke){switch(Oe.kind){case"reference":return wi.to(Oe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return se(Oe,Ke)}}Te.to=ye;function se(Oe,Ke){switch(Oe.kind){case"markdownContent":return ii.to(Oe);case"inlineReference":return Ot.to(Oe);case"progressMessage":return;case"treeData":return ni.to(Oe);case"command":return ai.to(Oe,Ke)}}Te.toContent=se})(mi||(e.ChatResponsePart=mi={}));var vi;(function(Te){function je(ye){return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,references:ye.variables.variables.map(Ai.to),location:Bt.to(ye.location),acceptedConfirmationData:ye.acceptedConfirmationData,rejectedConfirmationData:ye.rejectedConfirmationData}}Te.to=je})(vi||(e.ChatAgentRequest=vi={}));var Bt;(function(Te){function je(se){switch(se){case b.ChatAgentLocation.Notebook:return f.ChatLocation.Notebook;case b.ChatAgentLocation.Terminal:return f.ChatLocation.Terminal;case b.ChatAgentLocation.Panel:return f.ChatLocation.Panel;case b.ChatAgentLocation.Editor:return f.ChatLocation.Editor}}Te.to=je;function ye(se){switch(se){case f.ChatLocation.Notebook:return b.ChatAgentLocation.Notebook;case f.ChatLocation.Terminal:return b.ChatAgentLocation.Terminal;case f.ChatLocation.Panel:return b.ChatAgentLocation.Panel;case f.ChatLocation.Editor:return b.ChatAgentLocation.Editor}}Te.from=ye})(Bt||(e.ChatLocation=Bt={}));var Ai;(function(Te){function je(ye){const se=ye.value;if(!se)throw new Error("Invalid value reference");return{id:ye.id,name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],value:(0,m.$yc)(se)?m.URI.revive(se):se&&typeof se=="object"&&"uri"in se&&"range"in se&&(0,m.$yc)(se.uri)?j.to((0,c.$di)(se)):se,modelDescription:ye.modelDescription}}Te.to=je})(Ai||(e.ChatAgentValueReference=Ai={}));var Mi;(function(Te){function je(ye,se,Oe){return{id:ye.id,label:ye.label,fullName:ye.fullName,icon:ye.icon?.id,value:ye.values[0].value,insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation,command:se.toInternal(ye.command,Oe)}}Te.from=je})(Mi||(e.ChatAgentCompletionItem=Mi={}));var Lt;(function(Te){function je(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Te.to=je})(Lt||(e.ChatAgentResult=Lt={}));var Ii;(function(Te){function je(ye,se,Oe){if(se.action.kind==="vote")return;const Ke=Lt.to(ye);if(se.action.kind==="command"){const it=se.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Oe.fromInternal(it)??{command:it.id,title:it.title}}},result:Ke}}else return se.action.kind==="followUp"?{action:{kind:"followUp",followup:Mt.to(se.action.followup)},result:Ke}:se.action.kind==="inlineChat"?{action:{kind:"editor",accepted:se.action.action==="accepted"},result:Ke}:{action:se.action,result:Ke}}Te.to=je})(Ii||(e.ChatAgentUserActionEvent=Ii={}));var Pi;(function(Te){function je(ye,se,Oe){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:se.toInternal(ye,Oe)}Te.from=je})(Pi||(e.TerminalQuickFix=Pi={}));var yi;(function(Te){function je(ye){return{kind:hi.to(ye.kind)}}Te.to=je})(yi||(e.PartialAcceptInfo=yi={}));var hi;(function(Te){function je(ye){switch(ye){case o.PartialAcceptTriggerKind.Word:return f.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return f.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return f.PartialAcceptTriggerKind.Suggest;default:return f.PartialAcceptTriggerKind.Unknown}}Te.to=je})(hi||(e.PartialAcceptTriggerKind=hi={}));var ji;(function(Te){function je(ye,se){return{id:se,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ye.contextValue}}Te.from=je})(ji||(e.DebugTreeItem=ji={}));var Nt;(function(Te){function je(ye){return{name:ye.name,description:ye.description,parametersSchema:ye.parametersSchema}}Te.to=je})(Nt||(e.LanguageModelToolDescription=Nt={}))}),define(Se[344],De([1,0,6,20,16,52]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;let O=class{constructor(p,c){this.a=p.getProxy(r.$vN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>c.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,c,I){const S=new A.$Vw(k.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,I?.isRefactoring??!1)}};e.$Joc=O,e.$Joc=O=Ye([Ve(0,a.$2P)],O)}),define(Se[345],De([1,0,19,7,51,4,40,3,44,18,2,24,6,16,8,307,26]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=void 0,P=Ue(P),w=Ue(w);class g{constructor(t,i,s,d,u){this.j=t,this.k=i,this.l=s,this.m=d,this.n=u,this.b=p.$he.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(d){if(t.c){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,d),u}};const t=this;this.b.reset();const s=(d,u)=>{if(typeof this.d>"u"&&"content"in d&&(this.d=this.b.elapsed()),u){const b=this.l.$handleProgressChunk(this.k.requestId,d),E={report:D=>{b?.then(y=>{y&&(w.$ZN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseWarningPart.from(D),y):this.l.$handleProgressChunk(this.k.requestId,P.ChatResponseReferencePart.from(D),y))})}};Promise.all([b,u?.(E)]).then(([D,y])=>{D!==void 0&&y!==void 0&&this.l.$handleProgressChunk(this.k.requestId,P.ChatTaskResult.from(y),D)})}else this.l.$handleProgressChunk(this.k.requestId,d)};this.g={markdown(d){i(this.markdown);const u=new w.$uP(d),b=P.ChatResponseMarkdownPart.from(u);return s(b),this},markdownWithVulnerabilities(d,u){i(this.markdown),u&&(0,m.$8G)(t.j,"chatParticipantAdditions");const b=new w.$vP(d,u),E=P.ChatResponseMarkdownWithVulnerabilitiesPart.from(b);return s(E),this},filetree(d,u){i(this.filetree);const b=new w.$yP(d,u),E=P.ChatResponseFilesPart.from(b);return s(E),this},anchor(d,u){i(this.anchor);const b=new w.$zP(d,u),E=P.ChatResponseAnchorPart.from(b);return s(E),this},button(d){i(this.anchor);const u=new w.$DP(d),b=P.ChatResponseCommandButtonPart.from(u,t.m,t.n);return s(b),this},progress(d,u){i(this.progress);const b=new w.$BP(d,u),E=u?P.ChatTask.from(b):P.ChatResponseProgressPart.from(b);return s(E,u),this},warning(d){i(this.progress),(0,m.$8G)(t.j,"chatParticipantAdditions");const u=new w.$CP(d),b=P.ChatResponseWarningPart.from(u);return s(b),this},reference(d,u){if(i(this.reference),"variableName"in d&&(0,m.$8G)(t.j,"chatParticipantAdditions"),"variableName"in d&&!d.value){const b=t.k.variables.variables.find(E=>E.name===d.variableName);if(b){let E;if(b.references?.length)E=b.references.map(D=>({kind:"reference",reference:{variableName:d.variableName,value:D.reference}}));else{const D=new w.$EP(d,u);E=[P.ChatResponseReferencePart.from(D)]}return E.forEach(D=>s(D)),this}}else{const b=new w.$EP(d,u),E=P.ChatResponseReferencePart.from(b);s(E)}return this},textEdit(d,u){i(this.textEdit),(0,m.$8G)(t.j,"chatParticipantAdditions");const b=new w.$FP(d,u),E=P.ChatResponseTextEditPart.from(b);return s(E),this},detectedParticipant(d,u){i(this.detectedParticipant),(0,m.$8G)(t.j,"chatParticipantAdditions");const b=new w.$wP(d,u),E=P.ChatResponseDetectedParticipantPart.from(b);return s(E),this},confirmation(d,u,b){i(this.confirmation),(0,m.$8G)(t.j,"chatParticipantAdditions");const E=new w.$xP(d,u,b),D=P.ChatResponseConfirmationPart.from(E);return s(D),this},push(d){if(i(this.push),(d instanceof w.$FP||d instanceof w.$vP||d instanceof w.$wP||d instanceof w.$CP||d instanceof w.$xP)&&(0,m.$8G)(t.j,"chatParticipantAdditions"),d instanceof w.$EP)this.reference(d.value,d.iconPath);else{const u=P.ChatResponsePart.from(d,t.m,t.n);s(u)}return this}}}return this.g}}class $ extends R.$Xc{constructor(t,i,s){super(),this.n=i,this.s=s,this.c=new Map,this.j=this.B(new R.$7c),this.m=this.B(new R.$7c),this.g=t.getProxy(h.$vN.MainThreadChatAgents2)}transferActiveChat(t){this.g.$transferActiveChatSession(t)}createChatAgent(t,i,s){const d=$.b++,u=new n(t,i,this.g,d,s);return this.c.set(d,u),this.g.$registerAgent(d,t.identifier,i,{},void 0),u.apiAgent}createDynamicChatAgent(t,i,s,d){const u=$.b++,b=new n(t,i,this.g,u,d);return this.c.set(u,b),this.g.$registerAgent(u,t.identifier,i,{isSticky:!0},s),b.apiAgent}async $invokeAgent(t,i,s,d){const u=this.c.get(t);if(!u)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let b=this.j.get(i.sessionId);b||(b=new R.$Wc,this.j.set(i.sessionId,b));const E=new g(u.extension,i,this.g,this.s.converter,b);try{const D=await this.t(i.agentId,s),y=u.invoke(P.ChatAgentRequest.to(i),{history:D},E.apiObject,d);return await(0,a.$uh)(Promise.resolve(y).then(T=>{if(T?.metadata)try{JSON.stringify(T.metadata)}catch(v){const f=`result.metadata MUST be JSON.stringify-able. Got error: ${v.message}`;return this.n.error(`[${u.extension.identifier.value}] [@${u.id}] ${f}`,u.extension),{errorDetails:{message:f},timings:E.timings}}let C;return T?.errorDetails&&(C={...T.errorDetails,responseIsIncomplete:!0}),C?.responseIsRedacted&&(0,m.$8G)(u.extension,"chatParticipantPrivate"),{errorDetails:C,timings:E.timings,metadata:T?.metadata}}),d)}catch(D){return this.n.error(D,u.extension),D instanceof w.$PP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,k.$rj)(D),responseIsIncomplete:!0}}}finally{E.close()}}async t(t,i){const s=[];for(const d of i.history){const u=P.ChatAgentResult.to(d.result),b=t===d.request.agentId?u:{...u,metadata:void 0};s.push(new w.$GP(d.request.message,d.request.command,d.request.variables.variables.map(P.ChatAgentValueReference.to),d.request.agentId));const E=(0,r.$Kb)(d.response.map(D=>P.ChatResponsePart.toContent(D,this.s.converter)));s.push(new w.$HP(E,b,d.request.agentId,d.request.command))}return s}$releaseSession(t){this.j.deleteAndDispose(t)}async $provideFollowups(t,i,s,d,u){const b=this.c.get(i);if(!b)return Promise.resolve([]);const E=await this.t(b.id,d),D=P.ChatAgentResult.to(s);return(await b.provideFollowups(D,{history:E},u)).filter(y=>{const T=!y.participant||O.Iterable.some(this.c.values(),C=>C.id===y.participant&&S.$sn.equals(C.extension.identifier,b.extension.identifier));return T||this.n.warn(`[@${b.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),T}).map(y=>P.ChatFollowup.from(y,t))}$acceptFeedback(t,i,s,d){const u=this.c.get(t);if(!u)return;const b=P.ChatAgentResult.to(i);let E;switch(s){case l.ChatAgentVoteDirection.Down:E=w.ChatResultFeedbackKind.Unhelpful;break;case l.ChatAgentVoteDirection.Up:E=w.ChatResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(d?{result:b,kind:E,reportIssue:d}:{result:b,kind:E}))}$acceptAction(t,i,s){const d=this.c.get(t);if(!d||s.action.kind==="vote")return;const u=P.ChatAgentUserActionEvent.to(i,s,this.s.converter);u&&d.acceptAction(Object.freeze(u))}async $invokeCompletionProvider(t,i,s){const d=this.c.get(t);if(!d)return[];let u=this.m.get(t);return u?u.clear():(u=new R.$Wc,this.m.set(t,u)),(await d.invokeCompletionProvider(i,s)).map(E=>P.ChatAgentCompletionItem.from(E,this.s.converter,u))}async $provideWelcomeMessage(t,i,s){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(P.ChatLocation.to(i),s)}async $provideSampleQuestions(t,i,s){const d=this.c.get(t);if(d)return(await d.provideSampleQuestions(P.ChatLocation.to(i),s)).map(u=>P.ChatFollowup.from(u,void 0))}}e.$Koc=$,$.b=0;class n{constructor(t,i,s,d,u){this.extension=t,this.id=i,this.w=s,this.x=d,this.y=u,this.m=new A.$ne,this.n=new A.$ne}acceptFeedback(t){this.m.fire(t)}acceptAction(t){this.n.fire(t)}async invokeCompletionProvider(t,i){return this.q?await this.q.provider.provideCompletionItems(t,i)??[]:[]}async provideFollowups(t,i,s){if(!this.b)return[];const d=await this.b.provideFollowups(t,i,s);return d?d.filter(u=>!(u&&"commandId"in u)).filter(u=>!(u&&"message"in u)):[]}async provideWelcomeMessage(t,i){if(!this.s)return[];const s=await this.s.provideWelcomeMessage(t,i);return s?s.map(d=>typeof d=="string"?d:P.MarkdownString.from(d)):[]}async provideSampleQuestions(t,i){if(!this.s||!this.s.provideSampleQuestions)return[];const s=await this.s.provideSampleQuestions(t,i);return s||[]}get apiAgent(){let t=!1,i=!1;const s=()=>{t||i||(i=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof I.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof w.$uO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:P.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:P.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:P.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),i=!1}))},d=this;return{get id(){return d.id},get iconPath(){return d.c},set iconPath(u){d.c=u,s()},get requestHandler(){return d.y},set requestHandler(u){(0,c.$qg)(typeof u=="function","Invalid request handler"),d.y=u},get followupProvider(){return d.b},set followupProvider(u){d.b=u,s()},get isDefault(){return(0,m.$8G)(d.extension,"defaultChatParticipant"),d.d},set isDefault(u){(0,m.$8G)(d.extension,"defaultChatParticipant"),d.d=u,s()},get helpTextPrefix(){return(0,m.$8G)(d.extension,"defaultChatParticipant"),d.g},set helpTextPrefix(u){(0,m.$8G)(d.extension,"defaultChatParticipant"),d.g=u,s()},get helpTextVariablesPrefix(){return(0,m.$8G)(d.extension,"defaultChatParticipant"),d.j},set helpTextVariablesPrefix(u){(0,m.$8G)(d.extension,"defaultChatParticipant"),d.j=u,s()},get helpTextPostfix(){return(0,m.$8G)(d.extension,"defaultChatParticipant"),d.k},set helpTextPostfix(u){(0,m.$8G)(d.extension,"defaultChatParticipant"),d.k=u,s()},get isSecondary(){return(0,m.$8G)(d.extension,"defaultChatParticipant"),d.l},set isSecondary(u){(0,m.$8G)(d.extension,"defaultChatParticipant"),d.l=u,s()},get supportIssueReporting(){return(0,m.$8G)(d.extension,"chatParticipantPrivate"),d.o},set supportIssueReporting(u){(0,m.$8G)(d.extension,"chatParticipantPrivate"),d.o=u,s()},get onDidReceiveFeedback(){return d.m.event},set participantVariableProvider(u){if((0,m.$8G)(d.extension,"chatParticipantAdditions"),d.q=u,u){if(!u.triggerCharacters.length)throw new Error("triggerCharacters are required");d.w.$registerAgentCompletionsProvider(d.x,d.id,u.triggerCharacters)}else d.w.$unregisterAgentCompletionsProvider(d.x,d.id)},get participantVariableProvider(){return(0,m.$8G)(d.extension,"chatParticipantAdditions"),d.q},set welcomeMessageProvider(u){(0,m.$8G)(d.extension,"defaultChatParticipant"),d.s=u,s()},get welcomeMessageProvider(){return(0,m.$8G)(d.extension,"defaultChatParticipant"),d.s},onDidPerformAction:(0,m.$7G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(u){d.t=u,s()},get requester(){return d.t},set supportsSlowReferences(u){(0,m.$8G)(d.extension,"chatParticipantPrivate"),d.u=u,s()},get supportsSlowReferences(){return(0,m.$8G)(d.extension,"chatParticipantPrivate"),d.u},dispose(){t=!0,d.b=void 0,d.m.dispose(),d.w.$unregisterAgent(d.x)}}}invoke(t,i,s,d){return this.y(t,i,s,d)}}}),define(Se[346],De([1,0,14,3,50,6,16,8,26]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0,O=Ue(O),R=Ue(R);class c{constructor(h){this.b=new Map,this.c=h.getProxy(A.$vN.MainThreadChatVariables)}async $resolveVariable(h,P,w,l){const m=this.b.get(h);if(m)try{if(m.resolver.resolve2){(0,p.$8G)(m.extension,"chatParticipantAdditions");const g=new I(P,this.c),$=await m.resolver.resolve2(m.data.name,{prompt:w},g.apiObject,l);if($&&$[0])return $[0].value}else{const g=await m.resolver.resolve(m.data.name,{prompt:w},l);if(g&&g[0])return g[0].value}}catch(g){(0,r.$4)(g)}}registerVariableResolver(h,P,w,l,m,g,$,n,o){const t=c.a++,i=o?k.ThemeIcon.fromId(o):void 0;return this.b.set(t,{extension:h,data:{id:P,name:w,description:l,modelDescription:m,icon:i},resolver:$}),this.c.$registerVariable(t,{id:P,name:w,description:l,modelDescription:m,isSlow:g,fullName:n,icon:i}),(0,a.$Vc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Loc=c,c.a=0;class I{constructor(h,P){this.c=h,this.d=P,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let P=function(l){if(h.a){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,l),m}};const h=this,w=l=>{this.d.$handleProgressChunk(this.c,l)};this.b={progress(l){P(this.progress);const m=new R.$AP(l),g=O.ChatResponseProgressPart.from(m);return w(g),this},reference(l){P(this.reference);const m=new R.$EP(l),g=O.ChatResponseReferencePart.from(m);return w(g),this},push(l){return P(this.push),l instanceof R.$EP?w(O.ChatResponseReferencePart.from(l)):l instanceof R.$AP&&w(O.ChatResponseProgressPart.from(l)),this}}}return this.b}}}),define(Se[347],De([1,0,7,59,4,3,41,2,88,24,16,8,6,26]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=w,p=Ue(p),I=Ue(I),S=Ue(S);function w(l,m,g){const $=l.getProxy(h.$vN.MainThreadComments);class n{constructor(){this.b=new Map,this.c=new c.$un,m.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===O.MarshalledId.CommentController){const T=this.b.get(y.handle);return T?T.value:y}else if(y&&y.$mid===O.MarshalledId.CommentThread){const T=y,C=this.b.get(T.commentControlHandle);if(!C)return T;const v=C.getCommentThread(T.commentThreadHandle);return v?v.value:T}else if(y&&(y.$mid===O.MarshalledId.CommentThreadReply||y.$mid===O.MarshalledId.CommentThreadInstance)){const T=this.b.get(y.thread.commentControlHandle);if(!T)return y;const C=T.getCommentThread(y.thread.commentThreadHandle);return C?y.$mid===O.MarshalledId.CommentThreadInstance?C.value:{thread:C.value,text:y.text}:y}else if(y&&y.$mid===O.MarshalledId.CommentNode){const T=this.b.get(y.thread.commentControlHandle);if(!T)return y;const C=T.getCommentThread(y.thread.commentThreadHandle);if(!C)return y;const v=y.commentUniqueId,f=C.getCommentByUniqueId(v);return f||y}else if(y&&y.$mid===O.MarshalledId.CommentThreadNode){const T=this.b.get(y.thread.commentControlHandle);if(!T)return y;const C=T.getCommentThread(y.thread.commentThreadHandle);if(!C)return y;const v=y.text,f=y.commentUniqueId,N=C.getCommentByUniqueId(f);return N?(typeof N.body=="string"?N.body=v:N.body=new S.$ZN(v),N):y}return y}})}createCommentController(y,T,C){const v=n.a++,f=new t(y,v,T,C);this.b.set(f.handle,f);const N=this.c.get(y.identifier)||[];return N.push(f),this.c.set(y.identifier,N),f.value}async $createCommentThreadTemplate(y,T,C,v){const f=this.b.get(y);f&&f.$createCommentThreadTemplate(T,C,v)}async $setActiveComment(y,T){const C=this.b.get(y);C&&C.$setActiveComment(T??void 0)}async $updateCommentThreadTemplate(y,T,C){const v=this.b.get(y);v&&v.$updateCommentThreadTemplate(T,C)}$deleteCommentThread(y,T){this.b.get(y)?.$deleteCommentThread(T)}async $provideCommentingRanges(y,T,C){const v=this.b.get(y);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const f=await g.ensureDocumentData(R.URI.revive(T));return(0,r.$yh)(async()=>{const N=await v.commentingRangeProvider.provideCommentingRanges(f.document,C);let F;return Array.isArray(N)?F={ranges:N,fileComments:!1}:N?F={ranges:N.ranges||[],fileComments:N.enableFileComments||!1}:F=N??void 0,F}).then(N=>{let F;return N&&(F={ranges:N.ranges.map(j=>I.Range.from(j)),fileComments:N.fileComments}),F})}$toggleReaction(y,T,C,v,f){const N=this.b.get(y);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,r.$yh)(()=>{const F=N.getCommentThread(T);if(F){const j=F.getCommentByUniqueId(v.uniqueIdInThread);if(N!==void 0&&j&&N.reactionHandler)return N.reactionHandler(j,d(f))}return Promise.resolve(void 0)})}}n.a=0;class o{set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,P.$8G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,T,C,v,f,N,F,j,z){this.m=T,this.n=C,this.o=v,this.p=f,this.q=N,this.extensionDescription=F,this.r=j,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.$ne,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Yc,this.l.value=new A.$Wc,this.n===void 0&&(this.n=`${y}.${this.handle}`),$.$createCommentThread(T,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(L=>i(this,L,this.k,this.extensionDescription)),F.identifier,this.r,z),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{$.$deleteCommentThread(T,this.handle)}});const M=this;this.value={get uri(){return M.uri},get range(){return M.range},set range(L){M.range=L},get comments(){return M.comments},set comments(L){M.comments=L},get collapsibleState(){return M.collapsibleState},set collapsibleState(L){M.collapsibleState=L},get canReply(){return M.canReply},set canReply(L){M.canReply=L},get contextValue(){return M.contextValue},set contextValue(L){M.contextValue=L},get label(){return M.label},set label(L){M.label=L},get state(){return M.state},set state(L){M.state=L},reveal:L=>M.reveal(L),dispose:()=>{M.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Wc);const y=C=>Object.prototype.hasOwnProperty.call(this.b,C),T={};y("range")&&(T.range=I.Range.from(this.p)),y("label")&&(T.label=this.label),y("contextValue")&&(T.contextValue=this.contextValue??null),y("comments")&&(T.comments=this.q.map(C=>i(this,C,this.k,this.extensionDescription))),y("collapsibleState")&&(T.collapseState=u(this.g)),y("canReply")&&(T.canReply=this.canReply),y("state")&&(T.state=b(this.h)),y("applicability")&&(T.applicability=E(this.h)),y("isTemplate")&&(T.isTemplate=this.r),this.b={},$.$updateCommentThread(this.m,this.handle,this.n,this.o,T)}getCommentByUniqueId(y){for(const T of this.k){const C=T[0],v=T[1];if(y===v)return C}}async reveal(y){return(0,P.$8G)(this.extensionDescription,"commentReveal"),$.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...y})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}o.a=0,Ye([(0,a.$_h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,P.$8G)(this.h,"commentingRangeHint"),$.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,$.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,$.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,P.$8G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,P.$8G)(this.h,"activeComment"),this.f}constructor(y,T,C,v){this.h=y,this.i=T,this.j=C,this.k=v,this.a=new Map,$.$registerCommentController(this.handle,C,v,this.h.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(N){f.options=N},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(N){f.commentingRangeProvider=N},get reactionHandler(){return f.reactionHandler},set reactionHandler(N){f.reactionHandler=N},get activeCommentThread(){return f.activeCommentThread},createCommentThread(N,F,j){return f.createCommentThread(N,F,j).value},dispose:()=>{f.dispose()}}),this.g=[],this.g.push({dispose:()=>{$.$unregisterCommentController(this.handle)}})}createCommentThread(y,T,C){T===void 0&&(0,P.$8G)(this.h,"fileComments");const v=new o(this.id,this.handle,void 0,y,T,C,this.h,!1);return this.a.set(v.handle,v),v}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const T=this.a.get(y.commentThreadHandle);T&&(this.e=y.uniqueIdInThread?T.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=T)}$createCommentThreadTemplate(y,T,C){const v=new o(this.id,this.handle,void 0,R.URI.revive(y),I.Range.to(T),[],this.h,!0,C);return v.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(v.handle,v),v}$updateCommentThreadTemplate(y,T){const C=this.a.get(y);C&&(C.range=I.Range.to(T))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function i(D,y,T,C){let v=T.get(y);return v||(v=++D.commentHandle,T.set(y,v)),y.state!==void 0&&(0,P.$8G)(C,"commentsDraftState"),y.reactions?.some(f=>f.reactors!==void 0)&&(0,P.$8G)(C,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:v,body:typeof y.body=="string"?y.body:I.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(f=>s(f)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function s(D){return{label:D.label,iconPath:D.iconPath?I.$1P(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function d(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?R.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function u(D){if(D!==void 0)switch(D){case S.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case S.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function b(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case S.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case S.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function E(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case S.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case S.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Se[348],De([1,0,21,60,3,15,23,2,16,97,119,6,8]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=void 0,p=Ue(p),S=Ue(S),h=Ue(h);class P{constructor(s,d){this.document=s,this.b=d,this.a=1,this.c=new I.$voc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,d){await this.f(s).undo(),d||this.disposeBackup()}async redo(s,d){await this.f(s).redo(),d||this.disposeBackup()}disposeEdits(s){for(const d of s)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=t(this.document.uri)+this.a++;return(0,O.$hh)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const d=this.c.get(s,0);if(!d)throw new Error("No edit found");return d}}class w{constructor(){this.a=new Map}get(s,d){return this.a.get(this.b(s,d))}add(s,d,u){const b=this.b(s,d.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${s} resource:${d.uri}`);const E=new P(d,u);return this.a.set(b,E),E}delete(s,d){const u=this.b(s,d.uri);this.a.delete(u)}b(s,d){return`${s}@@@${d}`}}var l;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(l||(l={}));class m{constructor(){this.a=new Map}addTextProvider(s,d,u){return this.b(s,{type:l.Text,extension:d,provider:u})}addCustomProvider(s,d,u){return this.b(s,{type:l.Custom,extension:d,provider:u})}get(s){return this.a.get(s)}b(s,d){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,d),new h.$xN(()=>this.a.delete(s))}}class g{constructor(s,d,u,b,E){this.d=d,this.f=u,this.g=b,this.h=E,this.b=new m,this.c=new w,this.a=s.getProxy(S.$vN.MainThreadCustomEditors)}registerCustomEditorProvider(s,d,u,b){const E=new k.$Wc;return n(u)?(E.add(this.b.addTextProvider(d,s,u)),this.a.$registerTextEditorProvider((0,c.$5oc)(s),d,b.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,c.$3oc)(s))):(E.add(this.b.addCustomProvider(d,s,u)),$(u)&&E.add(u.onDidChangeCustomDocument(D=>{const y=this.i(d,D.document.uri);if(o(D)){const T=y.addEdit(D);this.a.$onDidEdit(D.document.uri,d,T,D.label)}else this.a.$onContentChange(D.document.uri,d)})),this.a.$registerCustomEditorProvider((0,c.$5oc)(s),d,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,c.$3oc)(s))),h.$xN.from(E,new h.$xN(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(s,d,u,b,E){const D=this.b.get(d);if(!D)throw new Error(`No provider found for '${d}'`);if(D.type!==l.Custom)throw new Error(`Invalid provide type for '${d}'`);const y=R.URI.revive(s),T=await D.provider.openCustomDocument(y,{backupId:u,untitledDocumentData:b?.buffer},E);let C;return $(D.provider)&&this.f&&(C=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(d,T,C),{editable:$(D.provider)}}async $disposeCustomDocument(s,d){const u=this.b.get(d);if(!u)throw new Error(`No provider found for '${d}'`);if(u.type!==l.Custom)throw new Error(`Invalid provider type for '${d}'`);const b=R.URI.revive(s),{document:E}=this.i(d,b);this.c.delete(d,E),E.dispose()}async $resolveCustomEditor(s,d,u,b,E,D){const y=this.b.get(u);if(!y)throw new Error(`No provider found for '${u}'`);const T=p.ViewColumn.to(E),C=this.g.createNewWebview(d,b.contentOptions,y.extension),v=this.h.createNewWebviewPanel(d,u,b.title,T,b.options,C,b.active),f=R.URI.revive(s);switch(y.type){case l.Custom:{const{document:N}=this.i(u,f);return y.provider.resolveCustomEditor(N,v,D)}case l.Text:{const N=this.d.getDocument(f);return y.provider.resolveCustomTextEditor(N,v,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,d,u){this.i(d,s).disposeEdits(u)}async $onMoveCustomEditor(s,d,u){const b=this.b.get(u);if(!b)throw new Error(`No provider found for '${u}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const E=this.h.getWebviewPanel(s);if(!E)throw new Error("No webview found");const D=R.URI.revive(d),y=this.d.getDocument(D);await b.provider.moveCustomTextEditor(y,E,r.CancellationToken.None)}async $undo(s,d,u,b){return this.i(d,s).undo(u,b)}async $redo(s,d,u,b){return this.i(d,s).redo(u,b)}async $revert(s,d,u){const b=this.i(d,s);await this.j(d).revertCustomDocument(b.document,u),b.disposeBackup()}async $onSave(s,d,u){const b=this.i(d,s);await this.j(d).saveCustomDocument(b.document,u),b.disposeBackup()}async $onSaveAs(s,d,u,b){const E=this.i(d,s);return this.j(d).saveCustomDocumentAs(E.document,R.URI.revive(u),b)}async $backup(s,d,u){const b=this.i(d,s),D=await this.j(d).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},u);return b.updateBackup(D),D.id}i(s,d){const u=this.c.get(s,R.URI.revive(d));if(!u)throw new Error("No custom document found");return u}j(s){const u=this.b.get(s)?.provider;if(!u||!$(u))throw new Error("Custom document is not editable");return u}}e.$8oc=g;function $(i){return!!i.onDidChangeCustomDocument}function n(i){return typeof i.resolveCustomTextEditor=="function"}function o(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function t(i){const s=i.scheme===A.Schemas.file||i.scheme===A.Schemas.untitled?i.fsPath:i.toString();return(0,a.$uj)(s)+""}});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[349],De([1,0,234,147,2,6,8,16,4,12,29,63]),function(ie,e,r,a,k,A,O,R,p,c,I,S){"use strict";var h,P,w,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0,R=Ue(R);class m{constructor(n,o,t,i,s,d,u,b){this.d=n,this.e=o,this.f=t,this.g=i,this.h=s,h.set(this,void 0),P.set(this,void 0),w.set(this,void 0),this.c=!1,this.f=Math.max(i,t),ot(this,w,new I.$Dc(E=>d.getComparisonKey(E)),"f"),ot(this,h,u,"f"),ot(this,P,b,"f")}dispose(){this.c||(He(this,P,"f").fire([...He(this,w,"f").keys()]),He(this,h,"f")?.$clear(this.e),He(this,w,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(n,o){if(!n){this.clear();return}this.j();let t=[];if(k.URI.isUri(n)){if(!o){this.delete(n);return}He(this,w,"f").set(n,o.slice()),t=[n]}else if(Array.isArray(n)){t=[];let d;n=[...n].sort(m.k);for(const u of n){const[b,E]=u;if((!d||b.toString()!==d.toString())&&(d&&He(this,w,"f").get(d).length===0&&He(this,w,"f").delete(d),d=b,t.push(b),He(this,w,"f").set(b,[])),E)He(this,w,"f").get(b)?.push(...E);else{const D=He(this,w,"f").get(b);D&&(D.length=0)}}}if(He(this,P,"f").fire(t),!He(this,h,"f"))return;const i=[];let s=0;for(const d of t){let u=[];const b=He(this,w,"f").get(d);if(b)if(b.length>this.g){u=[];const E=[O.DiagnosticSeverity.Error,O.DiagnosticSeverity.Warning,O.DiagnosticSeverity.Information,O.DiagnosticSeverity.Hint];e:for(let D=0;D<4;D++)for(const y of b)if(y.severity===E[D]&&u.push({...R.Diagnostic.from(y),modelVersionId:this.h(d)})===this.g)break e;u.push({severity:a.MarkerSeverity.Info,message:(0,r.localize)(0,null,b.length-this.g),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=b.map(E=>({...R.Diagnostic.from(E),modelVersionId:this.h(d)}));if(i.push([d,u]),s+=u.length,s>this.f)break}He(this,h,"f").$changeMany(this.e,i)}delete(n){this.j(),He(this,P,"f").fire([n]),He(this,w,"f").delete(n),He(this,h,"f")?.$changeMany(this.e,[[n,void 0]])}clear(){this.j(),He(this,P,"f").fire([...He(this,w,"f").keys()]),He(this,w,"f").clear(),He(this,h,"f")?.$clear(this.e)}forEach(n,o){this.j();for(const[t,i]of this)n.call(o,t,i,this)}*[(h=new WeakMap,P=new WeakMap,w=new WeakMap,Symbol.iterator)](){this.j();for(const n of He(this,w,"f").keys())yield[n,this.get(n)]}get(n){this.j();const o=He(this,w,"f").get(n);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(n){return this.j(),Array.isArray(He(this,w,"f").get(n))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(n,o){return n[0].toString()<o[0].toString()?-1:n[0].toString()>o[0].toString()?1:0}}e.$Coc=m;let g=l=class{static _mapper(n){const o=new I.$Dc;for(const t of n)o.set(t,t);return{uris:Object.freeze(Array.from(o.values()))}}constructor(n,o,t,i){this.j=o,this.k=t,this.l=i,this.g=new Map,this.h=new p.$re({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,l._mapper),this.f=n.getProxy(A.$vN.MainThreadDiagnostics)}createDiagnosticCollection(n,o){const{g:t,f:i,h:s,j:d,k:u,l:b}=this,E=new class{$changeMany(T,C){i.$changeMany(T,C),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",n.value,T,C.length===0?"CLEARING":C)}$clear(T){i.$clear(T),d.trace("[DiagnosticCollection] remove all (extension, owner)",n.value,T)}dispose(){i.dispose()}};let D;if(!o)o="_generated_diagnostic_collection_name_#"+l.c++,D=o;else if(!t.has(o))D=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do D=o+l.c++;while(t.has(D))}return new class extends m{constructor(){super(o,D,l.e,l.d,T=>b.getDocument(T)?.version,u.extUri,E,s),t.set(D,this)}dispose(){super.dispose(),t.delete(D)}}}getDiagnostics(n){if(n)return this.m(n);{const o=new Map,t=[];for(const i of this.g.values())i.forEach((s,d)=>{let u=o.get(s.toString());typeof u>"u"&&(u=t.length,o.set(s.toString(),u),t.push([s,[]])),t[u][1]=t[u][1].concat(...d)});return t}}m(n){let o=[];for(const t of this.g.values())t.has(n)&&(o=o.concat(t.get(n)));return o}$acceptMarkersChange(n){if(!this.n){const o="_generated_mirror",t=new m(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,t),this.n=t}for(const[o,t]of n)this.n.set(k.URI.revive(o),t.map(R.Diagnostic.to))}};e.$Doc=g,g.c=0,g.d=1e3,g.e=1.1*l.d,e.$Doc=g=l=Ye([Ve(1,c.$ak),Ve(2,S.$Boc)],g)}),define(Se[350],De([1,0,2,14,8,16,81,52]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0;class p{constructor(I,S,h,P={timeout:1500,errors:3}){this.c=I,this.d=S,this.f=h,this.g=P,this.a=new O.$8c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(S,h,P)=>{const l={dispose:this.a.push([S,h,I])};return Array.isArray(P)&&P.push(l),l}}async $participateInSave(I,S){const h=r.URI.revive(I);let P=!1;const w=setTimeout(()=>P=!0,this.g.timeout),l=[];try{for(const m of[...this.a]){if(P)break;const g=this.d.getDocument(h),$=await this.h(m,{document:g,reason:A.TextDocumentSaveReason.to(S)});l.push($)}}finally{clearTimeout(w)}return l}h([I,S,h],P){const w=this.b.get(I);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(h,I,S,P).then(()=>!0,l=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' threw ERROR`),this.c.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const m=this.b.get(I);this.b.set(I,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,S,h,P){const w=[],l=Date.now(),{document:m,reason:g}=P,{version:$}=m,n=Object.freeze({document:m,reason:g,waitUntil(o){if(Object.isFrozen(w))throw(0,a.$$)("waitUntil can not be called async");w.push(Promise.resolve(o))}});try{S.apply(h,[n])}catch(o){return Promise.reject(o)}return Object.freeze(w),new Promise((o,t)=>{const i=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(w).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(i),o(s)}).catch(s=>{clearTimeout(i),t(s)})}).then(o=>{const t={edits:[]};for(const i of o)if(Array.isArray(i)&&i.every(s=>s instanceof k.$EN))for(const{newText:s,newEol:d,range:u}of i)t.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:u&&A.Range.from(u),text:s,eol:d&&A.EndOfLine.from(d)}});if(t.edits.length!==0)return $===m.version?this.f.$tryApplyWorkspaceEdit(new R.$Vw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Qpc=p}),define(Se[351],De([1,0,4,3,2,6,165,16,18,25,8]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0,R=Ue(R);class S{constructor(P,w){this.a=new r.$ne,this.b=new r.$ne,this.c=new r.$ne,this.d=new r.$ne,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new a.$Wc,this.h=new Map,this.f=P.getProxy(A.$vN.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(l=>{for(const m of l)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const m of l)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(P){if(!P)return;const w=this.g.getDocument(P);if(w)return w}getDocument(P){const w=this.getDocumentData(P);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${P}'`);return w.document}ensureDocumentData(P){const w=this.g.getDocument(P);if(w)return Promise.resolve(w);let l=this.h.get(P.toString());return l||(l=this.f.$tryOpenDocument(P).then(m=>{this.h.delete(P.toString());const g=k.URI.revive(m);return(0,p.$rg)(this.g.getDocument(g))},m=>(this.h.delete(P.toString()),Promise.reject(m))),this.h.set(P.toString(),l)),l}createDocumentData(P){return this.f.$tryCreateDocument(P).then(w=>k.URI.revive(w))}$acceptModelLanguageChanged(P,w){const l=k.URI.revive(P),m=this.g.getDocument(l);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(w),this.a.fire(m.document)}$acceptModelSaved(P){const w=k.URI.revive(P),l=this.g.getDocument(w);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(P,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(P,w){const l=k.URI.revive(P),m=this.g.getDocument(l);if(!m)throw new Error("unknown document");m._acceptIsDirty(w),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(P,w,l){const m=k.URI.revive(P),g=this.g.getDocument(m);if(!g)throw new Error("unknown document");g._acceptIsDirty(l),g.onEvents(w);let $;w.isUndoing?$=I.TextDocumentChangeReason.Undo:w.isRedoing&&($=I.TextDocumentChangeReason.Redo),this.c.fire((0,c.$go)({document:g.document,contentChanges:w.changes.map(n=>({range:R.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:$}))}setWordDefinitionFor(P,w){(0,O.$4P)(P,w)}}e.$Eoc=S}),define(Se[78],De([1,0,79,4,18,2,5,6,20,16,8]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=void 0,c=Ue(c),e.$9oc=(0,O.$Gi)("IExtHostEditorTabs");class S{constructor(m,g,$){this.e=$,this.d=g,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,g={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(g)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case R.TabInputKind.TextInput:return new I.$iP(A.URI.revive(this.b.input.uri));case R.TabInputKind.TextDiffInput:return new I.$jP(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case R.TabInputKind.TextMergeInput:return new I.$kP(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case R.TabInputKind.CustomEditorInput:return new I.$lP(A.URI.revive(this.b.input.uri),this.b.input.viewType);case R.TabInputKind.WebviewEditorInput:return new I.$mP(this.b.input.viewType);case R.TabInputKind.NotebookInput:return new I.$nP(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new I.$oP(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new I.$pP;case R.TabInputKind.InteractiveEditorInput:return new I.$qP(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new I.$rP;case R.TabInputKind.MultiDiffEditorInput:return new I.$sP(this.b.input.diffEditors.map(m=>new I.$jP(A.URI.revive(m.original),A.URI.revive(m.modified))));default:return}}}class h{constructor(m,g){this.c=[],this.d="",this.b=m,this.e=g;for(const $ of m.tabs)$.isActive&&(this.d=$.id),this.c.push(new S($,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,g={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return c.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find($=>$.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map($=>$.apiObject))}};this.a=Object.freeze(g)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===R.TabModelOperationKind.TAB_OPEN){const $=new S(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,$),m.tabDto.isActive&&(this.d=$.tabId),$}else if(m.kind===R.TabModelOperationKind.TAB_CLOSE){const $=this.c.splice(m.index,1)[0];if(!$)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return $.tabId===this.d&&(this.d=""),$}else if(m.kind===R.TabModelOperationKind.TAB_MOVE){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const $=this.c.splice(m.oldIndex,1)[0];if(!$)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,$),$}const g=this.c.find($=>$.tabId===m.tabDto.id);if(!g)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),g.acceptDtoUpdate(m.tabDto),g}activeTabId(){return this.d}}let P=class{constructor(m){this.b=new a.$ne,this.c=new a.$ne,this.e=[],this.a=m.getProxy(R.$vN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,g={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map($=>$.apiObject))},get activeTabGroup(){const $=m.d;return(0,k.$rg)(m.e.find(o=>o.groupId===$)?.apiObject)},close:async($,n)=>{const o=Array.isArray($)?$:[$];return o.length?w(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(g)}return this.f}$acceptEditorTabModel(m){const g=new Set(this.e.map(d=>d.groupId)),$=new Set(m.map(d=>d.groupId)),n=(0,r.$F)(g,$),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),t=[],i=[];this.e=m.map(d=>{const u=new h(d,()=>this.d);return n.added.includes(u.groupId)?t.push(u.apiObject):i.push(u.apiObject),u});const s=(0,k.$rg)(m.find(d=>d.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:t,closed:o,changed:i}))}$acceptTabGroupUpdate(m){const g=this.e.find($=>$.groupId===m.groupId);if(!g)throw new Error("Update Group IPC call received before group creation.");g.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[g.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const g=this.e.find(n=>n.groupId===m.groupId);if(!g)throw new Error("Update Tabs IPC call received before group creation.");const $=g.acceptTabOperation(m);switch(m.kind){case R.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[$.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[$.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[$.apiObject]}));return}}g(m){for(const g of this.e)for(const $ of g.tabs)if($.apiObject===m)return $}h(m){return this.e.find(g=>g.apiObject===m)}async i(m,g){const $=[];for(const n of m){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");$.push(o.tabId)}return this.a.$closeTab($,g)}async j(m,g){const $=[];for(const n of m){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");$.push(o.groupId)}return this.a.$closeGroup($,g)}};e.$0oc=P,e.$0oc=P=Ye([Ve(0,p.$2P)],P);function w(l){return l.tabs!==void 0}}),define(Se[352],De([1,0,2,6,28,3,8,16,203,13,27,22,26,86]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=void 0,k=Ue(k),R=Ue(R);class w{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const $=this.a.indexOf(g);$>=0&&(this.a.splice($,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),$=[];let n,o,t=p.State.LastKnownState,i=p.State.LastKnownState;for(const s of g){let d=n?(0,c.$Jf)(n,s):0;for(d===0?o=p.State.Start:o=i;d<s.length;d++)d+1===s.length?(t=i,i=p.State.BeforeColon):i+=1,$.push([o,s.toUpperCase().charCodeAt(d),i]),$.push([o,s.toLowerCase().charCodeAt(d),i]),o=i;n=s,i=t}$.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),$.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this.b=new p.$v4($)}}provideDocumentLinks(g){this.c();const $=[],n=p.$w4.computeLinks({getLineContent(o){return g.lineAt(o-1).text},getLineCount(){return g.lineCount}},this.b);for(const o of n){const t=R.DocumentLink.to(o);t.target&&$.push(t)}return $}}class l{constructor(g,$){this.i=$,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(a.$vN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,$,n,o={}){if(l.j(n),this.d.has($))throw new Error(`a provider for the scheme '${$}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const t=this.h++;this.b.add($),this.d.add($),this.c.set(t,n);let i=k.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(i+=k.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(i+=k.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(i+=k.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,h.$8G)(g,"fsChunks"),i+=k.FileSystemProviderCapabilities.FileOpenReadWriteClose);let s;o.isReadonly&&(0,P.$6k)(o.isReadonly)&&o.isReadonly.value!==""&&(s={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(t,$,i,s).catch(u=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${$}`),console.error(u)});const d=n.onDidChangeFile(u=>{const b=[];for(const E of u){const{uri:D,type:y}=E;if(D.scheme!==$)continue;let T;switch(y){case O.FileChangeType.Changed:T=k.FileChangeType.UPDATED;break;case O.FileChangeType.Created:T=k.FileChangeType.ADDED;break;case O.FileChangeType.Deleted:T=k.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}b.push({resource:D,type:T})}this.a.$onFileSystemChange(t,b)});return(0,A.$Vc)(()=>{d.dispose(),this.b.delete($),this.d.delete($),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:$,ctime:n,mtime:o,size:t,permissions:i}=g;return{type:$,ctime:n,mtime:o,size:t,permissions:i}}$stat(g,$){return Promise.resolve(this.l(g).stat(r.URI.revive($))).then(n=>l.k(n))}$readdir(g,$){return Promise.resolve(this.l(g).readDirectory(r.URI.revive($)))}$readFile(g,$){return Promise.resolve(this.l(g).readFile(r.URI.revive($))).then(n=>S.$Pe.wrap(n))}$writeFile(g,$,n,o){return Promise.resolve(this.l(g).writeFile(r.URI.revive($),n.buffer,o))}$delete(g,$,n){return Promise.resolve(this.l(g).delete(r.URI.revive($),n))}$rename(g,$,n,o){return Promise.resolve(this.l(g).rename(r.URI.revive($),r.URI.revive(n),o))}$copy(g,$,n,o){const t=this.l(g);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(r.URI.revive($),r.URI.revive(n),o))}$mkdir(g,$){return Promise.resolve(this.l(g).createDirectory(r.URI.revive($)))}$watch(g,$,n,o){const t=this.l(g).watch(r.URI.revive(n),o);this.f.set($,t)}$unwatch(g,$){const n=this.f.get($);n&&(n.dispose(),this.f.delete($))}$open(g,$,n){const o=this.l(g);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(r.URI.revive($),n))}$close(g,$){const n=this.l(g);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close($))}$read(g,$,n,o){const t=this.l(g);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const i=S.$Pe.alloc(o);return Promise.resolve(t.read($,n,i.buffer,0,o)).then(s=>i.slice(0,s))}$write(g,$,n,o){const t=this.l(g);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write($,n,o.buffer,0,o.byteLength))}l(g){const $=this.c.get(g);if(!$){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return $}}e.$Tpc=l}),define(Se[353],De([1,0,4,39,2,6,16,8,28,49]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=void 0,O=Ue(O);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,l,m,g,$,n){this.a=Math.random(),this.b=new r.$ne,this.c=new r.$ne,this.d=new r.$ne,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,a.$Ak)($),t=typeof $=="string",i=n?.correlate,s=g(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(i&&typeof d.session>"u")){if(!n?.ignoreCreateEvents)for(const u of d.created){const b=k.URI.revive(u);o(b.fsPath)&&(!t||l.getWorkspaceFolder(b))&&this.b.fire(b)}if(!n?.ignoreChangeEvents)for(const u of d.changed){const b=k.URI.revive(u);o(b.fsPath)&&(!t||l.getWorkspaceFolder(b))&&this.c.fire(b)}if(!n?.ignoreDeleteEvents)for(const u of d.deleted){const b=k.URI.revive(u);o(b.fsPath)&&(!t||l.getWorkspaceFolder(b))&&this.d.fire(b)}}});this.g=R.$xN.from(this.i(w,m,$,n,n?.correlate),this.b,this.c,this.d,s)}i(w,l,m,g,$){const n=R.$xN.from();if(typeof m=="string"||g?.ignoreChangeEvents&&g?.ignoreCreateEvents&&g?.ignoreDeleteEvents)return n;const o=w.getProxy(A.$vN.MainThreadFileSystemEventService);let t=!1;(m.pattern.includes(a.$wk)||m.pattern.includes(a.$xk))&&(t=!0);let i;return $&&(g?.ignoreChangeEvents||g?.ignoreCreateEvents||g?.ignoreDeleteEvents)&&(i=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,g?.ignoreChangeEvents&&(i&=~p.FileChangeFilter.UPDATED),g?.ignoreCreateEvents&&(i&=~p.FileChangeFilter.ADDED),g?.ignoreDeleteEvents&&(i&=~p.FileChangeFilter.DELETED)),o.$watch(l.identifier.value,this.a,m.baseUri,{recursive:t,excludes:g?.excludes??[],filter:i},!!$),R.$xN.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class S{constructor(w){this.a=w,this.session=this.a.session,this.b=new c.$X(()=>this.a.created.map(k.URI.revive)),this.c=new c.$X(()=>this.a.changed.map(k.URI.revive)),this.d=new c.$X(()=>this.a.deleted.map(k.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class h{constructor(w,l,m){this.j=w,this.k=l,this.l=m,this.a=new r.$ne,this.b=new r.$ne,this.c=new r.$ne,this.d=new r.$ne,this.g=new r.$pe,this.h=new r.$pe,this.i=new r.$pe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,l,m,g){return new I(this.j,w,l,this.a.event,O.GlobPattern.from(m),g)}$onFileEvent(w){this.a.fire(new S(w))}$onDidRunFileOperation(w,l){switch(w){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:l.map(m=>({oldUri:k.URI.revive(m.source),newUri:k.URI.revive(m.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:l.map(m=>k.URI.revive(m.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:l.map(m=>k.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,l){return(m,g,$)=>{const n=function(t){m.call(g,t)};return n.extension=w,l.event(n,void 0,$)}}async $onWillRunFileOperation(w,l,m,g){switch(w){case p.FileOperation.MOVE:return await this.n(this.g,{files:l.map($=>({oldUri:k.URI.revive($.source),newUri:k.URI.revive($.target)}))},m,g);case p.FileOperation.DELETE:return await this.n(this.i,{files:l.map($=>k.URI.revive($.target))},m,g);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:l.map($=>k.URI.revive($.target))},m,g)}}async n(w,l,m,g){const $=new Set,n=[];if(await w.fireAsync(l,g,async(t,i)=>{const s=Date.now(),d=await Promise.resolve(t);d instanceof R.$HN&&(n.push([i.extension,d]),$.add(i.extension.displayName??i.extension.identifier.value)),Date.now()-s>m&&this.k.warn("SLOW file-participant",i.extension.identifier)}),g.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,t]of n){const{edits:i}=O.WorkspaceEdit.from(t,{getTextDocumentVersion:s=>this.l.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(i)}return{edit:o,extensionNames:Array.from($)}}}e.$Upc=h}),define(Se[354],De([1,0,19,7,21,14,134,3,25,44,13,18,2,31,196,88,144,236,24,16,8,26,119,6]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=void 0,l=Ue(l),n=Ue(n),s=Ue(s);class d{constructor(U,V){this.d=U,this.e=V}async provideDocumentSymbols(U,V){const X=this.d.getDocument(U),x=await this.e.provideDocumentSymbols(X,V);if(!(0,r.$Nb)(x))return x[0]instanceof o.$RN?x.map(n.DocumentSymbol.from):d.f(x)}static f(U){U=U.slice(0).sort((x,de)=>{let ve=x.location.range.start.compareTo(de.location.range.start);return ve===0&&(ve=de.location.range.end.compareTo(x.location.range.end)),ve});const V=[],X=[];for(const x of U){const de={name:x.name||"!!MISSING: name!!",kind:n.SymbolKind.from(x.kind),tags:x.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:n.Range.from(x.location.range),selectionRange:n.Range.from(x.location.range),children:[]};for(;;){if(X.length===0){X.push(de),V.push(de);break}const ve=X[X.length-1];if(P.$Nt.containsRange(ve.range,de.range)&&!P.$Nt.equalsRange(ve.range,de.range)){ve.children?.push(de),X.push(de);break}X.pop()}}return V}}class u{constructor(U,V,X,x,de,ve){this.f=U,this.g=V,this.h=X,this.j=x,this.k=de,this.l=ve,this.d=new i.$voc("CodeLens"),this.e=new Map}async provideCodeLenses(U,V){const X=this.f.getDocument(U),x=await this.h.provideCodeLenses(X,V);if(!x||V.isCancellationRequested)return;const de=this.d.add(x),ve=new R.$Wc;this.e.set(de,ve);const Fe={cacheId:de,lenses:[]};for(let Ge=0;Ge<x.length;Ge++)Fe.lenses.push({cacheId:[de,Ge],range:n.Range.from(x[Ge].range),command:this.g.toInternal(x[Ge].command,ve)});return Fe}async resolveCodeLens(U,V){const X=U.cacheId&&this.d.get(...U.cacheId);if(!X)return;let x;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?x=X:x=await this.h.resolveCodeLens(X,V),x||(x=X),V.isCancellationRequested)return;const de=U.cacheId&&this.e.get(U.cacheId[0]);if(de){if(!x.command){const ve=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ve),this.l.error(ve);return}return U.command=this.g.toInternal(x.command,de),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function b(Ce){return Array.isArray(Ce)?Ce.map(n.DefinitionLink.from):Ce?[n.DefinitionLink.from(Ce)]:[]}class E{constructor(U,V){this.d=U,this.e=V}async provideDefinition(U,V,X){const x=this.d.getDocument(U),de=n.Position.to(V),ve=await this.e.provideDefinition(x,de,X);return b(ve)}}class D{constructor(U,V){this.d=U,this.e=V}async provideDeclaration(U,V,X){const x=this.d.getDocument(U),de=n.Position.to(V),ve=await this.e.provideDeclaration(x,de,X);return b(ve)}}class y{constructor(U,V){this.d=U,this.e=V}async provideImplementation(U,V,X){const x=this.d.getDocument(U),de=n.Position.to(V),ve=await this.e.provideImplementation(x,de,X);return b(ve)}}class T{constructor(U,V){this.d=U,this.e=V}async provideTypeDefinition(U,V,X){const x=this.d.getDocument(U),de=n.Position.to(V),ve=await this.e.provideTypeDefinition(x,de,X);return b(ve)}}class C{constructor(U,V){this.g=U,this.h=V,this.d=0,this.e=new Map}async provideHover(U,V,X,x){const de=this.g.getDocument(U),ve=n.Position.to(V);let Fe;if(X&&X.verbosityRequest){const nt=X.verbosityRequest.previousHover.id,ct=this.e.get(nt);if(!ct)throw new Error(`Hover with id ${nt} not found`);const rt={verbosityDelta:X.verbosityRequest.verbosityDelta,previousHover:ct};Fe=await this.h.provideHover(de,ve,x,rt)}else Fe=await this.h.provideHover(de,ve,x);if(!Fe||(0,r.$Nb)(Fe.contents))return;Fe.range||(Fe.range=de.getWordRangeAtPosition(ve)),Fe.range||(Fe.range=new o.$zN(ve,ve));const Ge=n.Hover.from(Fe),Xe=this.d;if(this.e.size===C.f){const nt=Math.min(...this.e.keys());this.e.delete(nt)}return this.e.set(Xe,Fe),this.d+=1,{...Ge,id:Xe}}releaseHover(U){this.e.delete(U)}}C.f=10;class v{constructor(U,V){this.d=U,this.e=V}async provideEvaluatableExpression(U,V,X){const x=this.d.getDocument(U),de=n.Position.to(V),ve=await this.e.provideEvaluatableExpression(x,de,X);if(ve)return n.EvaluatableExpression.from(ve)}}class f{constructor(U,V){this.d=U,this.e=V}async provideInlineValues(U,V,X,x){const de=this.d.getDocument(U),ve=await this.e.provideInlineValues(de,n.Range.to(V),n.InlineValueContext.to(X),x);if(Array.isArray(ve))return ve.map(Fe=>n.InlineValue.from(Fe))}}class N{constructor(U,V){this.d=U,this.e=V}async provideDocumentHighlights(U,V,X){const x=this.d.getDocument(U),de=n.Position.to(V),ve=await this.e.provideDocumentHighlights(x,de,X);if(Array.isArray(ve))return ve.map(n.DocumentHighlight.from)}}class F{constructor(U,V){this.d=U,this.e=V}async provideMultiDocumentHighlights(U,V,X,x){const de=this.d.getDocument(U),ve=X.map(Xe=>this.d.getDocument(Xe)),Fe=n.Position.to(V),Ge=await this.e.provideMultiDocumentHighlights(de,Fe,ve,x);if(Array.isArray(Ge))return Ge.map(n.MultiDocumentHighlight.from)}}class j{constructor(U,V){this.d=U,this.e=V}async provideLinkedEditingRanges(U,V,X){const x=this.d.getDocument(U),de=n.Position.to(V),ve=await this.e.provideLinkedEditingRanges(x,de,X);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,r.$Kb)(ve.ranges.map(n.Range.from)),wordPattern:ve.wordPattern}}}class z{constructor(U,V){this.d=U,this.e=V}async provideReferences(U,V,X,x){const de=this.d.getDocument(U),ve=n.Position.to(V),Fe=await this.e.provideReferences(de,ve,X,x);if(Array.isArray(Fe))return Fe.map(n.location.from)}}class M{constructor(U,V,X,x,de,ve,Fe){this.g=U,this.h=V,this.j=X,this.k=x,this.l=de,this.m=ve,this.n=Fe,this.e=new i.$voc("CodeAction"),this.f=new Map}async provideCodeActions(U,V,X,x){const de=this.g.getDocument(U),ve=w.$Pt.isISelection(V)?n.Selection.to(V):n.Range.to(V),Fe=[];for(const rt of this.j.getDiagnostics(U))if(ve.intersection(rt.range)&&Fe.push(rt)>M.d)break;const Ge={diagnostics:Fe,only:X.only?new o.$TN(X.only):void 0,triggerKind:n.CodeActionTriggerKind.to(X.trigger)},Xe=await this.k.provideCodeActions(de,ve,Ge,x);if(!(0,r.$Ob)(Xe)||x.isCancellationRequested)return;const Qe=this.e.add(Xe),nt=new R.$Wc;this.f.set(Qe,nt);const ct=[];for(let rt=0;rt<Xe.length;rt++){const lt=Xe[rt];if(lt)if(M.o(lt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:lt.title,command:this.h.toInternal(lt,nt)});else{Ge.only&&(lt.kind?Ge.only.contains(lt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action is of kind '${lt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const bt=lt.ranges??[];ct.push({cacheId:[Qe,rt],title:lt.title,command:lt.command&&this.h.toInternal(lt.command,nt),diagnostics:lt.diagnostics&&lt.diagnostics.map(n.Diagnostic.from),edit:lt.edit&&n.WorkspaceEdit.from(lt.edit,void 0),kind:lt.kind&&lt.kind.value,isPreferred:lt.isPreferred,isAI:(0,t.$7G)(this.m,"codeActionAI")?lt.isAI:!1,ranges:(0,t.$7G)(this.m,"codeActionRanges")?(0,r.$Kb)(bt.map(n.Range.from)):void 0,disabled:lt.disabled?.reason})}}return{cacheId:Qe,actions:ct}}async resolveCodeAction(U,V){const[X,x]=U,de=this.e.get(X,x);if(!de||M.o(de))return{};if(!this.k.resolveCodeAction)return{};const ve=await this.k.resolveCodeAction(de,V)??de;let Fe;ve.edit&&(Fe=n.WorkspaceEdit.from(ve.edit,void 0));let Ge;if(ve.command){const Xe=this.f.get(X);Xe&&(Ge=this.h.toInternal(ve.command,Xe))}return{edit:Fe,command:Ge}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}M.d=1e3;class L{constructor(U,V,X,x,de){this.e=U,this.f=V,this.g=X,this.h=x,this.j=de,this.d=new i.$voc("DocumentPasteEdit")}async prepareDocumentPaste(U,V,X,x){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(U),ve=V.map(Xe=>n.Range.to(Xe)),Fe=n.DataTransfer.toDataTransfer(X,()=>{throw new A.$bb});if(await this.g.prepareDocumentPaste(de,ve,Fe,x),x.isCancellationRequested)return;const Ge=Array.from(Fe).filter(([,Xe])=>!(Xe instanceof o.$nO));return n.DataTransfer.from(Ge)}async providePasteEdits(U,V,X,x,de,ve){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(V),Ge=X.map(ct=>n.Range.to(ct)),Xe=n.DataTransfer.toDataTransfer(x,async ct=>(await this.e.$resolvePasteFileData(this.h,U,ct)).buffer),Qe=await this.g.provideDocumentPasteEdits(Fe,Ge,Xe,{only:de.only?new o.$sO(de.only):void 0,triggerKind:de.triggerKind},ve);if(!Qe||ve.isCancellationRequested)return[];const nt=this.d.add(Qe);return Qe.map((ct,rt)=>({_cacheId:[nt,rt],title:ct.title??(0,g.localize)(0,null,this.j.displayName||this.j.name),kind:ct.kind,yieldTo:ct.yieldTo?.map(lt=>lt.value),insertText:typeof ct.insertText=="string"?ct.insertText:{snippet:ct.insertText.value},additionalEdit:ct.additionalEdit?n.WorkspaceEdit.from(ct.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,V){const[X,x]=U,de=this.d.get(X,x);if(!de||!this.g.resolveDocumentPasteEdit)return{};const ve=await this.g.resolveDocumentPasteEdit(de,V)??de;return{additionalEdit:ve.additionalEdit?n.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class B{constructor(U,V){this.d=U,this.e=V}async provideDocumentFormattingEdits(U,V,X){const x=this.d.getDocument(U),de=await this.e.provideDocumentFormattingEdits(x,V,X);if(Array.isArray(de))return de.map(n.TextEdit.from)}}class W{constructor(U,V){this.d=U,this.e=V}async provideDocumentRangeFormattingEdits(U,V,X,x){const de=this.d.getDocument(U),ve=n.Range.to(V),Fe=await this.e.provideDocumentRangeFormattingEdits(de,ve,X,x);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,V,X,x){(0,S.$qg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(U),ve=V.map(n.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(de,ve,X,x);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}}class ae{constructor(U,V){this.d=U,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,V,X,x,de){const ve=this.d.getDocument(U),Fe=n.Position.to(V),Ge=await this.e.provideOnTypeFormattingEdits(ve,Fe,X,x,de);if(Array.isArray(Ge))return Ge.map(n.TextEdit.from)}}class q{constructor(U,V){this.e=U,this.f=V,this.d=new i.$voc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,V){const X=await this.e.provideWorkspaceSymbols(U,V);if(!(0,r.$Ob)(X))return{symbols:[]};const x=this.d.add(X),de={cacheId:x,symbols:[]};for(let ve=0;ve<X.length;ve++){const Fe=X[ve];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}de.symbols.push({...n.WorkspaceSymbol.from(Fe),cacheId:[x,ve]})}return de}async resolveWorkspaceSymbol(U,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const X=this.d.get(...U.cacheId);if(X){const x=await this.e.resolveWorkspaceSymbol(X,V);return x&&(0,p.$io)(U,n.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class K{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,V,X){this.d=U,this.e=V,this.f=X}async provideRenameEdits(U,V,X,x){const de=this.d.getDocument(U),ve=n.Position.to(V);try{const Fe=await this.e.provideRenameEdits(de,ve,X,x);return Fe?n.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Ge=K.g(Fe);return Ge?{rejectReason:Ge,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(U,V,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(U),de=n.Position.to(V);try{const ve=await this.e.prepareRename(x,de,X);let Fe,Ge;if(o.$zN.isRange(ve)?(Fe=ve,Ge=x.getText(ve)):(0,S.$ig)(ve)&&(Fe=ve.range,Ge=ve.placeholder),!Fe||!Ge)return;if(Fe.start.line>de.line||Fe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Fe),text:Ge}}catch(ve){const Fe=K.g(ve);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(ve)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ee{constructor(U,V,X){this.e=U,this.f=V,this.g=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,V,X,x){const de=this.e.getDocument(U),ve=n.Range.to(V);try{const Fe=ee.d[X],Ge=await this.f.provideNewSymbolNames(de,ve,Fe,x);return Ge?Ge.map(Xe=>typeof Xe=="string"?{newSymbolName:Xe}:{newSymbolName:Xe.newSymbolName,tags:Xe.tags}):void 0}catch(Fe){this.g.error(ee.h(Fe)??JSON.stringify(Fe,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}ee.d={[l.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[l.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic};class re{constructor(U,V){this.resultId=U,this.tokens=V}}class ge{constructor(U,V){this.f=U,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,V,X){const x=this.f.getDocument(U),de=V!==0?this.d.get(V):null;let ve=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,de.resultId,X):await this.g.provideDocumentSemanticTokens(x,X);return de&&this.d.delete(V),ve?(ve=ge.h(ve),this.o(ge.n(de,ve),ve)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return ge.j(U)?ge.k(U)?U:new o.$SO(new Uint32Array(U.data),U.resultId):ge.l(U)?ge.m(U)?U:new o.$UO(U.edits.map(V=>new o.$TO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const V of U.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(U,V){if(!ge.j(V)||!U||!U.tokens)return V;const X=U.tokens,x=X.length,de=V.data,ve=de.length;let Fe=0;const Ge=Math.min(x,ve);for(;Fe<Ge&&X[Fe]===de[Fe];)Fe++;if(Fe===x&&Fe===ve)return new o.$UO([],V.resultId);let Xe=0;const Qe=Ge-Fe;for(;Xe<Qe&&X[x-Xe-1]===de[ve-Xe-1];)Xe++;return new o.$UO([{start:Fe,deleteCount:x-Fe-Xe,data:de.subarray(Fe,ve-Xe)}],V.resultId)}o(U,V){if(ge.j(U)){const X=this.e++;return this.d.set(X,new re(U.resultId,U.data)),(0,m.$Mdb)({id:X,type:"full",data:U.data})}if(ge.l(U)){const X=this.e++;return ge.j(V)?this.d.set(X,new re(V.resultId,V.data)):this.d.set(X,new re(U.resultId)),(0,m.$Mdb)({id:X,type:"delta",deltas:(U.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class Z{constructor(U,V){this.d=U,this.e=V}async provideDocumentRangeSemanticTokens(U,V,X){const x=this.d.getDocument(U),de=await this.e.provideDocumentRangeSemanticTokens(x,n.Range.to(V),X);return de?this.f(de):null}f(U){return(0,m.$Mdb)({id:0,type:"full",data:U.data})}}class $e{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,V,X,x,de){this.f=U,this.g=V,this.h=X,this.j=x,this.k=de,this.d=new i.$voc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,V,X,x){const de=this.f.getDocument(U),ve=n.Position.to(V),Fe=de.getWordRangeAtPosition(ve)||new o.$zN(ve,ve),Ge=Fe.with({end:ve}),Xe=new c.$he,Qe=await this.h.provideCompletionItems(de,ve,x,n.CompletionContext.to(X));if(!Qe||x.isCancellationRequested)return;const nt=Array.isArray(Qe)?new o.$7N(Qe):Qe,ct=$e.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),rt=new R.$Wc;this.e.set(ct,rt);const lt=[],bt={x:ct,[s.ISuggestResultDtoField.completions]:lt,[s.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Fe),insert:n.Range.from(Ge)},[s.ISuggestResultDtoField.isIncomplete]:nt.isIncomplete||void 0,[s.ISuggestResultDtoField.duration]:Xe.elapsed()};for(let ft=0;ft<nt.items.length;ft++){const at=nt.items[ft],dt=this.l(at,[ct,ft],Ge,Fe);lt.push(dt)}return bt}async resolveCompletionItem(U,V){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...U);if(!X)return;const x=this.l(X,U),de=await this.h.resolveCompletionItem(X,V);if(!de)return;const ve=this.l(de,U);return(x[s.ISuggestDataDtoField.insertText]!==ve[s.ISuggestDataDtoField.insertText]||x[s.ISuggestDataDtoField.insertTextRules]!==ve[s.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[s.ISuggestDataDtoField.commandIdent]!==ve[s.ISuggestDataDtoField.commandIdent]||x[s.ISuggestDataDtoField.commandId]!==ve[s.ISuggestDataDtoField.commandId]||!(0,p.$jo)(x[s.ISuggestDataDtoField.commandArguments],ve[s.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[s.ISuggestDataDtoField.documentation]:ve[s.ISuggestDataDtoField.documentation],[s.ISuggestDataDtoField.detail]:ve[s.ISuggestDataDtoField.detail],[s.ISuggestDataDtoField.additionalTextEdits]:ve[s.ISuggestDataDtoField.additionalTextEdits],[s.ISuggestDataDtoField.insertText]:ve[s.ISuggestDataDtoField.insertText],[s.ISuggestDataDtoField.insertTextRules]:ve[s.ISuggestDataDtoField.insertTextRules],[s.ISuggestDataDtoField.commandIdent]:ve[s.ISuggestDataDtoField.commandIdent],[s.ISuggestDataDtoField.commandId]:ve[s.ISuggestDataDtoField.commandId],[s.ISuggestDataDtoField.commandArguments]:ve[s.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,V,X,x){const de=this.e.get(V[0]);if(!de)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(U.command,de),Fe={x:V,[s.ISuggestDataDtoField.label]:U.label,[s.ISuggestDataDtoField.kind]:U.kind!==void 0?n.CompletionItemKind.from(U.kind):void 0,[s.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(n.CompletionItemTag.from),[s.ISuggestDataDtoField.detail]:U.detail,[s.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:n.MarkdownString.fromStrict(U.documentation),[s.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[s.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[s.ISuggestDataDtoField.preselect]:U.preselect||void 0,[s.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?l.CompletionItemInsertTextRule.KeepWhitespace:l.CompletionItemInsertTextRule.None,[s.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[s.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(n.TextEdit.from),[s.ISuggestDataDtoField.commandIdent]:ve?.$ident,[s.ISuggestDataDtoField.commandId]:ve?.id,[s.ISuggestDataDtoField.commandArguments]:ve?.$ident?void 0:ve?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe[s.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Fe[s.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof o.$IN&&(Fe[s.ISuggestDataDtoField.insertText]=U.insertText.value,Fe[s.ISuggestDataDtoField.insertTextRules]|=l.CompletionItemInsertTextRule.InsertAsSnippet);let Ge;return U.textEdit?Ge=U.textEdit.range:U.range&&(Ge=U.range),o.$zN.isRange(Ge)?Fe[s.ISuggestDataDtoField.range]=n.Range.from(Ge):Ge&&(!X?.isEqual(Ge.inserting)||!x?.isEqual(Ge.replacing))&&(Fe[s.ISuggestDataDtoField.range]={insert:n.Range.from(Ge.inserting),replace:n.Range.from(Ge.replacing)}),Fe}}class fe{async provideInlineCompletions(U,V,X,x){}async provideInlineEdits(U,V,X,x){}disposeCompletions(U){}handleDidShowCompletionItem(U,V,X){}handlePartialAccept(U,V,X,x){}}class oe extends fe{constructor(U,V,X,x){super(),this.f=U,this.g=V,this.h=X,this.j=x,this.d=new ue,this.e=(0,t.$7G)(this.f,"inlineCompletionsAdditions"),this.k={[l.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[l.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$7G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,V,X,x){const de=this.g.getDocument(U),ve=n.Position.to(V),Fe=await this.h.provideInlineCompletionItems(de,ve,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:n.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},x);if(!Fe||x.isCancellationRequested)return;const Ge=Array.isArray(Fe)?Fe:Fe.items,Xe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],Qe=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:Ge}),items:Ge.map((rt,lt)=>{let bt;rt.command&&(nt||(nt=new R.$Wc),bt=this.j.toInternal(rt.command,nt));const ft=rt.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:bt,idx:lt,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Xe.map(rt=>(nt||(nt=new R.$Wc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:Qe}}async provideInlineEdits(U,V,X,x){if(!this.h.provideInlineEdits)return;(0,t.$8G)(this.f,"inlineCompletionsAdditions");const de=this.g.getDocument(U),ve=n.Range.to(V),Fe=await this.h.provideInlineEdits(de,ve,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:n.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind],userPrompt:X.userPrompt},x);if(!Fe||x.isCancellationRequested)return;const Ge=Array.isArray(Fe)?Fe:Fe.items,Xe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],Qe=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:Ge}),items:Ge.map((rt,lt)=>{let bt;rt.command&&(nt||(nt=new R.$Wc),bt=this.j.toInternal(rt.command,nt));const ft=rt.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:bt,idx:lt,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Xe.map(rt=>(nt||(nt=new R.$Wc),this.j.toInternal(rt,nt))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,V,X){const x=this.d.get(U)?.items[V];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,X)}handlePartialAccept(U,V,X,x){const de=this.d.get(U)?.items[V];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,X),this.h.handleDidPartiallyAcceptCompletionItem(de,n.PartialAcceptInfo.to(x)))}}class H{async provideInlineEdits(U,V,X){const x=this.f.getDocument(U),de=await this.g.provideInlineEdit(x,{triggerKind:this.e[V.triggerKind]},X);if(!de||X.isCancellationRequested)return;let ve;const Fe=this.d.createReferenceId({dispose(){ve?.dispose()},item:de});let Ge;de.accepted&&(ve||(ve=new R.$Wc),Ge=this.h.toInternal(de.accepted,ve));let Xe;return de.rejected&&(ve||(ve=new R.$Wc),Xe=this.h.toInternal(de.rejected,ve)),{pid:Fe,text:de.text,range:n.Range.from(de.range),accepted:Ge,rejected:Xe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,V,X,x){this.f=V,this.g=X,this.h=x,this.d=new ue,this.e={[l.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[l.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class ue{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const V=this.e++;return this.d.set(V,U),V}disposeReferenceId(U){const V=this.d.get(U);return this.d.delete(U),V}get(U){return this.d.get(U)}}class te{constructor(U,V){this.e=U,this.f=V,this.d=new i.$voc("SignatureHelp")}async provideSignatureHelp(U,V,X,x){const de=this.e.getDocument(U),ve=n.Position.to(V),Fe=this.g(X),Ge=await this.f.provideSignatureHelp(de,ve,x,Fe);if(Ge){const Xe=this.d.add([Ge]);return{...n.SignatureHelp.from(Ge),id:Xe}}}g(U){let V;if(U.activeSignatureHelp){const X=n.SignatureHelp.to(U.activeSignatureHelp),x=this.d.get(U.activeSignatureHelp.id,0);x?(V=x,V.activeSignature=X.activeSignature,V.activeParameter=X.activeParameter):V=X}return{...U,activeSignatureHelp:V}}releaseSignatureHelp(U){this.d.delete(U)}}class _{constructor(U,V,X,x,de){this.f=U,this.g=V,this.h=X,this.j=x,this.k=de,this.d=new i.$voc("InlayHints"),this.e=new Map}async provideInlayHints(U,V,X){const x=this.f.getDocument(U),de=n.Range.to(V),ve=await this.h.provideInlayHints(x,de,X);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(X.isCancellationRequested)return;const Fe=this.d.add(ve);this.e.set(Fe,new R.$Wc);const Ge={hints:[],cacheId:Fe};for(let Xe=0;Xe<ve.length;Xe++)this.l(ve[Xe],de)&&Ge.hints.push(this.m(ve[Xe],[Fe,Xe]));return this.j.trace(`[InlayHints] ${Ge.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ge}async resolveInlayHint(U,V){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...U);if(!X)return;const x=await this.h.resolveInlayHint(X,V);if(x&&this.l(x))return this.m(x,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,V){return U.label.length===0||Array.isArray(U.label)&&U.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(V&&!V.contains(U.position))}m(U,V){const X=this.e.get(V[0]);if(!X)throw Error("DisposableStore is missing...");const x={label:"",cacheId:V,tooltip:n.MarkdownString.fromStrict(U.tooltip),position:n.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(n.TextEdit.from),kind:U.kind&&n.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")x.label=U.label;else{const de=[];x.label=de;for(const ve of U.label){if(!ve.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:ve.value,tooltip:n.MarkdownString.fromStrict(ve.tooltip)};o.$JN.isLocation(ve.location)&&(Fe.location=n.location.from(ve.location)),ve.command&&(Fe.command=this.g.toInternal(ve.command,X)),de.push(Fe)}}return x}}class ne{constructor(U,V){this.e=U,this.f=V,this.d=new i.$voc("DocumentLink")}async provideLinks(U,V){const X=this.e.getDocument(U),x=await this.f.provideDocumentLinks(X,V);if(!(!Array.isArray(x)||x.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(ne.g).map(n.DocumentLink.from)};{const de=this.d.add(x),ve={links:[],cacheId:de};for(let Fe=0;Fe<x.length;Fe++){if(!ne.g(x[Fe]))continue;const Ge=n.DocumentLink.from(x[Fe]);Ge.cacheId=[de,Fe],ve.links.push(Ge)}return ve}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,V){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...U);if(!X)return;const x=await this.f.resolveDocumentLink(X,V);if(!(!x||!ne.g(x)))return n.DocumentLink.from(x)}releaseLinks(U){this.d.delete(U)}}class le{constructor(U,V){this.d=U,this.e=V}async provideColors(U,V){const X=this.d.getDocument(U),x=await this.e.provideDocumentColors(X,V);return Array.isArray(x)?x.map(ve=>({color:n.Color.from(ve.color),range:n.Range.from(ve.range)})):[]}async provideColorPresentations(U,V,X){const x=this.d.getDocument(U),de=n.Range.to(V.range),ve=n.Color.to(V.color),Fe=await this.e.provideColorPresentations(ve,{document:x,range:de},X);if(Array.isArray(Fe))return Fe.map(n.ColorPresentation.from)}}class J{constructor(U,V){this.d=U,this.e=V}async provideFoldingRanges(U,V,X){const x=this.d.getDocument(U),de=await this.e.provideFoldingRanges(x,V,X);if(Array.isArray(de))return de.map(n.FoldingRange.from)}}class ce{constructor(U,V,X){this.d=U,this.e=V,this.f=X}async provideSelectionRanges(U,V,X){const x=this.d.getDocument(U),de=V.map(n.Position.to),ve=await this.e.provideSelectionRanges(x,de,X);if(!(0,r.$Ob)(ve))return[];if(ve.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Ge=0;Ge<de.length;Ge++){const Xe=[];Fe.push(Xe);let Qe=de[Ge],nt=ve[Ge];for(;;){if(!nt.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(n.SelectionRange.from(nt)),!nt.parent)break;Qe=nt.range,nt=nt.parent}}return Fe}}class me{constructor(U,V){this.f=U,this.g=V,this.d=new O.$7P(""),this.e=new Map}async prepareSession(U,V,X){const x=this.f.getDocument(U),de=n.Position.to(V),ve=await this.g.prepareCallHierarchy(x,de,X);if(!ve)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(ve)?ve.map(Ge=>this.h(Fe,Ge)):[this.h(Fe,ve)]}async provideCallsTo(U,V,X){const x=this.j(U,V);if(!x)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(x,X);if(de)return de.map(ve=>({from:this.h(U,ve.from),fromRanges:ve.fromRanges.map(Fe=>n.Range.from(Fe))}))}async provideCallsFrom(U,V,X){const x=this.j(U,V);if(!x)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(x,X);if(de)return de.map(ve=>({to:this.h(U,ve.to),fromRanges:ve.fromRanges.map(Fe=>n.Range.from(Fe))}))}releaseSession(U){this.e.delete(U)}h(U,V){const X=this.e.get(U),x=n.CallHierarchyItem.from(V,U,X.size.toString(36));return X.set(x._itemId,V),x}j(U,V){return this.e.get(U)?.get(V)}}class we{constructor(U,V){this.f=U,this.g=V,this.d=new O.$7P(""),this.e=new Map}async prepareSession(U,V,X){const x=this.f.getDocument(U),de=n.Position.to(V),ve=await this.g.prepareTypeHierarchy(x,de,X);if(!ve)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(ve)?ve.map(Ge=>this.h(Fe,Ge)):[this.h(Fe,ve)]}async provideSupertypes(U,V,X){const x=this.j(U,V);if(!x)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(x,X);if(de)return de.map(ve=>this.h(U,ve))}async provideSubtypes(U,V,X){const x=this.j(U,V);if(!x)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(x,X);if(de)return de.map(ve=>this.h(U,ve))}releaseSession(U){this.e.delete(U)}h(U,V){const X=this.e.get(U),x=n.TypeHierarchyItem.from(V,U,X.size.toString(36));return X.set(x._itemId,V),x}j(U,V){return this.e.get(U)?.get(V)}}class Me{constructor(U,V,X,x,de){this.e=U,this.f=V,this.g=X,this.h=x,this.j=de,this.d=new i.$voc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,V,X,x,de){const ve=this.f.getDocument(V),Fe=n.Position.to(X),Ge=n.DataTransfer.toDataTransfer(x,async ct=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,ct)).buffer),Xe=await this.g.provideDocumentDropEdits(ve,Fe,Ge,de);if(!Xe)return;const Qe=(0,r.$5b)(Xe),nt=this.d.add(Qe);return Qe.map((ct,rt)=>({_cacheId:[nt,rt],title:ct.title??(0,g.localize)(1,null,this.j.displayName||this.j.name),kind:ct.kind?.value,yieldTo:ct.yieldTo?.map(lt=>lt.value),insertText:typeof ct.insertText=="string"?ct.insertText:{snippet:ct.insertText.value},additionalEdit:ct.additionalEdit?n.WorkspaceEdit.from(ct.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,V){const[X,x]=U,de=this.d.get(X,x);if(!de||!this.g.resolveDocumentDropEdit)return{};const ve=await this.g.resolveDocumentDropEdit(de,V)??de;return{additionalEdit:ve.additionalEdit?n.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class qe{constructor(U,V){this.d=U,this.e=V}async provideMappedEdits(U,V,X,x){const de=h.URI.revive(U),ve=this.d.getDocument(de),Fe=X.documents.map(Qe=>Qe.map(nt=>({uri:h.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(ct=>n.Range.to(ct))}))),Ge={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(ve,V,Ge,x);return Xe?n.WorkspaceEdit.from(Xe):null}}class ke{constructor(U,V){this.adapter=U,this.extension=V}}class Ie{constructor(U,V,X,x,de,ve,Fe,Ge){this.g=V,this.h=X,this.j=x,this.k=de,this.l=ve,this.m=Fe,this.n=Ge,this.f=new Map,this.e=U.getProxy(s.$vN.MainThreadLanguageFeatures)}o(U,V){return n.DocumentSelector.from(U,this.g,V)}p(U){return new o.$xN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Ie.d++}async s(U,V,X,x,de,ve=!1){const Fe=this.f.get(U);if(!Fe||!(Fe.adapter instanceof V))return x;const Ge=Date.now();ve||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Xe=X(Fe.adapter,Fe.extension);return Promise.resolve(Xe).catch(Qe=>{(0,A.$7)(Qe)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(Fe.extension.identifier,Qe))}).finally(()=>{ve||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Ge}ms`)}),k.CancellationToken.isCancellationToken(de)?(0,a.$vh)(Xe,de):Xe}t(U,V){const X=this.q();return this.f.set(X,new ke(U,V)),X}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,V,X,x){const de=this.t(new d(this.h,X),U),ve=x&&x.label||Ie.u(U);return this.e.$registerDocumentSymbolProvider(de,this.o(V,U),ve),this.p(de)}$provideDocumentSymbols(U,V,X){return this.s(U,d,x=>x.provideDocumentSymbols(h.URI.revive(V),X),void 0,X)}registerCodeLensProvider(U,V,X){const x=this.q(),de=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new ke(new u(this.h,this.j.converter,X,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(x,this.o(V,U),de);let ve=this.p(x);if(de!==void 0){const Fe=X.onDidChangeCodeLenses(Ge=>this.e.$emitCodeLensEvent(de));ve=o.$xN.from(ve,Fe)}return ve}$provideCodeLenses(U,V,X){return this.s(U,u,x=>x.provideCodeLenses(h.URI.revive(V),X),void 0,X)}$resolveCodeLens(U,V,X){return this.s(U,u,x=>x.resolveCodeLens(V,X),void 0,void 0)}$releaseCodeLenses(U,V){this.s(U,u,X=>Promise.resolve(X.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(U,V,X){const x=this.t(new E(this.h,X),U);return this.e.$registerDefinitionSupport(x,this.o(V,U)),this.p(x)}$provideDefinition(U,V,X,x){return this.s(U,E,de=>de.provideDefinition(h.URI.revive(V),X,x),[],x)}registerDeclarationProvider(U,V,X){const x=this.t(new D(this.h,X),U);return this.e.$registerDeclarationSupport(x,this.o(V,U)),this.p(x)}$provideDeclaration(U,V,X,x){return this.s(U,D,de=>de.provideDeclaration(h.URI.revive(V),X,x),[],x)}registerImplementationProvider(U,V,X){const x=this.t(new y(this.h,X),U);return this.e.$registerImplementationSupport(x,this.o(V,U)),this.p(x)}$provideImplementation(U,V,X,x){return this.s(U,y,de=>de.provideImplementation(h.URI.revive(V),X,x),[],x)}registerTypeDefinitionProvider(U,V,X){const x=this.t(new T(this.h,X),U);return this.e.$registerTypeDefinitionSupport(x,this.o(V,U)),this.p(x)}$provideTypeDefinition(U,V,X,x){return this.s(U,T,de=>de.provideTypeDefinition(h.URI.revive(V),X,x),[],x)}registerHoverProvider(U,V,X,x){const de=this.t(new C(this.h,X),U);return this.e.$registerHoverProvider(de,this.o(V,U)),this.p(de)}$provideHover(U,V,X,x,de){return this.s(U,C,ve=>ve.provideHover(h.URI.revive(V),X,x,de),void 0,de)}$releaseHover(U,V){this.s(U,C,X=>Promise.resolve(X.releaseHover(V)),void 0,void 0)}registerEvaluatableExpressionProvider(U,V,X,x){const de=this.t(new v(this.h,X),U);return this.e.$registerEvaluatableExpressionProvider(de,this.o(V,U)),this.p(de)}$provideEvaluatableExpression(U,V,X,x){return this.s(U,v,de=>de.provideEvaluatableExpression(h.URI.revive(V),X,x),void 0,x)}registerInlineValuesProvider(U,V,X,x){const de=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new f(this.h,X),U);this.e.$registerInlineValuesProvider(ve,this.o(V,U),de);let Fe=this.p(ve);if(de!==void 0){const Ge=X.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(de));Fe=o.$xN.from(Fe,Ge)}return Fe}$provideInlineValues(U,V,X,x,de){return this.s(U,f,ve=>ve.provideInlineValues(h.URI.revive(V),X,x,de),void 0,de)}registerDocumentHighlightProvider(U,V,X){const x=this.t(new N(this.h,X),U);return this.e.$registerDocumentHighlightProvider(x,this.o(V,U)),this.p(x)}registerMultiDocumentHighlightProvider(U,V,X){const x=this.t(new F(this.h,X),U);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(V,U)),this.p(x)}$provideDocumentHighlights(U,V,X,x){return this.s(U,N,de=>de.provideDocumentHighlights(h.URI.revive(V),X,x),void 0,x)}$provideMultiDocumentHighlights(U,V,X,x,de){return this.s(U,F,ve=>ve.provideMultiDocumentHighlights(h.URI.revive(V),X,x.map(Fe=>h.URI.revive(Fe)),de),void 0,de)}registerLinkedEditingRangeProvider(U,V,X){const x=this.t(new j(this.h,X),U);return this.e.$registerLinkedEditingRangeProvider(x,this.o(V,U)),this.p(x)}$provideLinkedEditingRanges(U,V,X,x){return this.s(U,j,async de=>{const ve=await de.provideLinkedEditingRanges(h.URI.revive(V),X,x);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?Ie.y(ve.wordPattern):void 0}},void 0,x)}registerReferenceProvider(U,V,X){const x=this.t(new z(this.h,X),U);return this.e.$registerReferenceSupport(x,this.o(V,U)),this.p(x)}$provideReferences(U,V,X,x,de){return this.s(U,z,ve=>ve.provideReferences(h.URI.revive(V),X,x,de),void 0,de)}registerCodeActionProvider(U,V,X,x){const de=new R.$Wc,ve=this.t(new M(this.h,this.j.converter,this.k,X,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(ve,this.o(V,U),{providedKinds:x?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:x?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,de)}))},Ie.u(U),Ie.w(U),!!X.resolveCodeAction),de.add(this.p(ve)),de}$provideCodeActions(U,V,X,x,de){return this.s(U,M,ve=>ve.provideCodeActions(h.URI.revive(V),X,x,de),void 0,de)}$resolveCodeAction(U,V,X){return this.s(U,M,x=>x.resolveCodeAction(V,X),{},void 0)}$releaseCodeActions(U,V){this.s(U,M,X=>Promise.resolve(X.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(U,V,X){const x=this.t(new B(this.h,X),U);return this.e.$registerDocumentFormattingSupport(x,this.o(V,U),U.identifier,U.displayName||U.name),this.p(x)}$provideDocumentFormattingEdits(U,V,X,x){return this.s(U,B,de=>de.provideDocumentFormattingEdits(h.URI.revive(V),X,x),void 0,x)}registerDocumentRangeFormattingEditProvider(U,V,X){const x=typeof X.provideDocumentRangesFormattingEdits=="function",de=this.t(new W(this.h,X),U);return this.e.$registerRangeFormattingSupport(de,this.o(V,U),U.identifier,U.displayName||U.name,x),this.p(de)}$provideDocumentRangeFormattingEdits(U,V,X,x,de){return this.s(U,W,ve=>ve.provideDocumentRangeFormattingEdits(h.URI.revive(V),X,x,de),void 0,de)}$provideDocumentRangesFormattingEdits(U,V,X,x,de){return this.s(U,W,ve=>ve.provideDocumentRangesFormattingEdits(h.URI.revive(V),X,x,de),void 0,de)}registerOnTypeFormattingEditProvider(U,V,X,x){const de=this.t(new ae(this.h,X),U);return this.e.$registerOnTypeFormattingSupport(de,this.o(V,U),x,U.identifier),this.p(de)}$provideOnTypeFormattingEdits(U,V,X,x,de,ve){return this.s(U,ae,Fe=>Fe.provideOnTypeFormattingEdits(h.URI.revive(V),X,x,de,ve),void 0,ve)}registerWorkspaceSymbolProvider(U,V){const X=this.t(new q(V,this.l),U);return this.e.$registerNavigateTypeSupport(X,typeof V.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(U,V,X){return this.s(U,q,x=>x.provideWorkspaceSymbols(V,X),{symbols:[]},X)}$resolveWorkspaceSymbol(U,V,X){return this.s(U,q,x=>x.resolveWorkspaceSymbol(V,X),void 0,void 0)}$releaseWorkspaceSymbols(U,V){this.s(U,q,X=>X.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(U,V,X){const x=this.t(new K(this.h,X,this.l),U);return this.e.$registerRenameSupport(x,this.o(V,U),K.supportsResolving(X)),this.p(x)}$provideRenameEdits(U,V,X,x,de){return this.s(U,K,ve=>ve.provideRenameEdits(h.URI.revive(V),X,x,de),void 0,de)}$resolveRenameLocation(U,V,X,x){return this.s(U,K,de=>de.resolveRenameLocation(h.URI.revive(V),X,x),void 0,x)}registerNewSymbolNamesProvider(U,V,X){const x=this.t(new ee(this.h,X,this.l),U);return this.e.$registerNewSymbolNamesProvider(x,this.o(V,U)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,ee,V=>V.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,V,X,x,de){return this.s(U,ee,ve=>ve.provideNewSymbolNames(h.URI.revive(V),X,x,de),void 0,de)}registerDocumentSemanticTokensProvider(U,V,X,x){const de=this.t(new ge(this.h,X),U),ve=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(V,U),x,ve);let Fe=this.p(de);if(ve){const Ge=X.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(ve));Fe=o.$xN.from(Fe,Ge)}return Fe}$provideDocumentSemanticTokens(U,V,X,x){return this.s(U,ge,de=>de.provideDocumentSemanticTokens(h.URI.revive(V),X,x),null,x)}$releaseDocumentSemanticTokens(U,V){this.s(U,ge,X=>X.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,V,X,x){const de=this.t(new Z(this.h,X),U);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(V,U),x),this.p(de)}$provideDocumentRangeSemanticTokens(U,V,X,x){return this.s(U,Z,de=>de.provideDocumentRangeSemanticTokens(h.URI.revive(V),X,x),null,x)}registerCompletionItemProvider(U,V,X,x){const de=this.t(new $e(this.h,this.j.converter,X,this.m,U),U);return this.e.$registerCompletionsProvider(de,this.o(V,U),x,$e.supportsResolving(X),U.identifier),this.p(de)}$provideCompletionItems(U,V,X,x,de){return this.s(U,$e,ve=>ve.provideCompletionItems(h.URI.revive(V),X,x,de),void 0,de)}$resolveCompletionItem(U,V,X){return this.s(U,$e,x=>x.resolveCompletionItem(V,X),void 0,X)}$releaseCompletionItems(U,V){this.s(U,$e,X=>X.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(U,V,X,x){const de=new oe(U,this.h,X,this.j.converter),ve=this.t(de,U);return this.e.$registerInlineCompletionsSupport(ve,this.o(V,U),de.supportsHandleEvents,$.$sn.toKey(U.identifier.value),x?.yieldTo?.map(Fe=>$.$sn.toKey(Fe))||[]),this.p(ve)}$provideInlineCompletions(U,V,X,x,de){return this.s(U,fe,ve=>ve.provideInlineCompletions(h.URI.revive(V),X,x,de),void 0,de)}$provideInlineEdits(U,V,X,x,de){return this.s(U,fe,ve=>ve.provideInlineEdits(h.URI.revive(V),X,x,de),void 0,de)}$handleInlineCompletionDidShow(U,V,X,x){this.s(U,fe,async de=>{de.handleDidShowCompletionItem(V,X,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,V,X,x,de){this.s(U,fe,async ve=>{ve.handlePartialAccept(V,X,x,de)},void 0,void 0)}$freeInlineCompletionsList(U,V){this.s(U,fe,async X=>{X.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(U,V,X){const x=new H(U,this.h,X,this.j.converter),de=this.t(x,U);return this.e.$registerInlineEditProvider(de,this.o(V,U),U.identifier),this.p(de)}$provideInlineEdit(U,V,X,x){return this.s(U,H,de=>de.provideInlineEdits(h.URI.revive(V),X,x),void 0,x)}$freeInlineEdit(U,V){this.s(U,H,async X=>{X.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(U,V,X,x){const de=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,ve=this.t(new te(this.h,X),U);return this.e.$registerSignatureHelpProvider(ve,this.o(V,U),de),this.p(ve)}$provideSignatureHelp(U,V,X,x,de){return this.s(U,te,ve=>ve.provideSignatureHelp(h.URI.revive(V),X,x,de),void 0,de)}$releaseSignatureHelp(U,V){this.s(U,te,X=>X.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(U,V,X){const x=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new _(this.h,this.j.converter,X,this.l,U),U);this.e.$registerInlayHintsProvider(de,this.o(V,U),typeof X.resolveInlayHint=="function",x,Ie.u(U));let ve=this.p(de);if(x!==void 0){const Fe=X.onDidChangeInlayHints(Ge=>this.e.$emitInlayHintsEvent(x));ve=o.$xN.from(ve,Fe)}return ve}$provideInlayHints(U,V,X,x){return this.s(U,_,de=>de.provideInlayHints(h.URI.revive(V),X,x),void 0,x)}$resolveInlayHint(U,V,X){return this.s(U,_,x=>x.resolveInlayHint(V,X),void 0,X)}$releaseInlayHints(U,V){this.s(U,_,X=>X.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(U,V,X){const x=this.t(new ne(this.h,X),U);return this.e.$registerDocumentLinkProvider(x,this.o(V,U),typeof X.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(U,V,X){return this.s(U,ne,x=>x.provideLinks(h.URI.revive(V),X),void 0,X,V.scheme==="output")}$resolveDocumentLink(U,V,X){return this.s(U,ne,x=>x.resolveLink(V,X),void 0,void 0,!0)}$releaseDocumentLinks(U,V){this.s(U,ne,X=>X.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(U,V,X){const x=this.t(new le(this.h,X),U);return this.e.$registerDocumentColorProvider(x,this.o(V,U)),this.p(x)}$provideDocumentColors(U,V,X){return this.s(U,le,x=>x.provideColors(h.URI.revive(V),X),[],X)}$provideColorPresentations(U,V,X,x){return this.s(U,le,de=>de.provideColorPresentations(h.URI.revive(V),X,x),void 0,x)}registerFoldingRangeProvider(U,V,X){const x=this.q(),de=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new ke(new J(this.h,X),U)),this.e.$registerFoldingRangeProvider(x,this.o(V,U),U.identifier,de);let ve=this.p(x);if(de!==void 0){const Fe=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));ve=o.$xN.from(ve,Fe)}return ve}$provideFoldingRanges(U,V,X,x){return this.s(U,J,de=>de.provideFoldingRanges(h.URI.revive(V),X,x),void 0,x)}registerSelectionRangeProvider(U,V,X){const x=this.t(new ce(this.h,X,this.l),U);return this.e.$registerSelectionRangeProvider(x,this.o(V,U)),this.p(x)}$provideSelectionRanges(U,V,X,x){return this.s(U,ce,de=>de.provideSelectionRanges(h.URI.revive(V),X,x),[],x)}registerCallHierarchyProvider(U,V,X){const x=this.t(new me(this.h,X),U);return this.e.$registerCallHierarchyProvider(x,this.o(V,U)),this.p(x)}$prepareCallHierarchy(U,V,X,x){return this.s(U,me,de=>Promise.resolve(de.prepareSession(h.URI.revive(V),X,x)),void 0,x)}$provideCallHierarchyIncomingCalls(U,V,X,x){return this.s(U,me,de=>de.provideCallsTo(V,X,x),void 0,x)}$provideCallHierarchyOutgoingCalls(U,V,X,x){return this.s(U,me,de=>de.provideCallsFrom(V,X,x),void 0,x)}$releaseCallHierarchy(U,V){this.s(U,me,X=>Promise.resolve(X.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(U,V,X){const x=this.t(new we(this.h,X),U);return this.e.$registerTypeHierarchyProvider(x,this.o(V,U)),this.p(x)}$prepareTypeHierarchy(U,V,X,x){return this.s(U,we,de=>Promise.resolve(de.prepareSession(h.URI.revive(V),X,x)),void 0,x)}$provideTypeHierarchySupertypes(U,V,X,x){return this.s(U,we,de=>de.provideSupertypes(V,X,x),void 0,x)}$provideTypeHierarchySubtypes(U,V,X,x){return this.s(U,we,de=>de.provideSubtypes(V,X,x),void 0,x)}$releaseTypeHierarchy(U,V){this.s(U,we,X=>Promise.resolve(X.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(U,V,X,x){const de=this.q();return this.f.set(de,new ke(new Me(this.e,this.h,X,de,U),U)),this.e.$registerDocumentOnDropEditProvider(de,this.o(V,U),(0,t.$7G)(U,"documentPaste")&&x?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(U,V,X,x,de,ve){return this.s(U,Me,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(V,h.URI.revive(X),x,de,ve)),void 0,void 0)}$resolveDropEdit(U,V,X){return this.s(U,Me,x=>x.resolveDropEdit(V,X),{},void 0)}$releaseDocumentOnDropEdits(U,V){this.s(U,Me,X=>Promise.resolve(X.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(U,V,X){const x=this.t(new qe(this.h,X),U);return this.e.$registerMappedEditsProvider(x,this.o(V,U)),this.p(x)}$provideMappedEdits(U,V,X,x,de){return this.s(U,qe,ve=>Promise.resolve(ve.provideMappedEdits(V,X,x,de)),null,de)}registerDocumentPasteEditProvider(U,V,X,x){const de=this.q();return this.f.set(de,new ke(new L(this.e,this.h,X,de,U),U)),this.e.$registerPasteEditProvider(de,this.o(V,U),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(ve=>ve.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(U,V,X,x,de){return this.s(U,L,ve=>ve.prepareDocumentPaste(h.URI.revive(V),X,x,de),void 0,de)}$providePasteEdits(U,V,X,x,de,ve,Fe){return this.s(U,L,Ge=>Ge.providePasteEdits(V,h.URI.revive(X),x,de,ve,Fe),void 0,Fe)}$resolvePasteEdit(U,V,X){return this.s(U,L,x=>x.resolvePasteEdit(V,X),{},void 0)}$releasePasteEdits(U,V){this.s(U,L,X=>Promise.resolve(X.releasePasteEdits(V)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:Ie.y(U.decreaseIndentPattern),increaseIndentPattern:Ie.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ie.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ie.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:Ie.y(U.beforeText),afterText:U.afterText?Ie.y(U.afterText):void 0,previousLineText:U.previousLineText?Ie.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(Ie.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(V=>o.SyntaxTokenType.toString(V)):void 0}}static E(U){return U.map(Ie.D)}setLanguageConfiguration(U,V,X){const{wordPattern:x}=X;if(x&&(0,I.$tf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(V,x):this.h.setWordDefinitionFor(V,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const de=this.q(),ve={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ie.y(X.wordPattern):void 0,indentationRules:X.indentationRules?Ie.z(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ie.C(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Ie.E(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,V,ve),this.p(de)}$setWordDefinitions(U){for(const V of U)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$Foc=Ie,Ie.d=0}),define(Se[355],De([1,0,3,6,16]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=void 0,k=Ue(k);class A{constructor(R){this.a=new Map,this.c=new Map,this.b=R.getProxy(a.$vN.MainThreadLanguageModelTools),this.b.$getTools().then(p=>{for(const c of p)this.c.set(c.name,c)})}async invokeTool(R,p,c){return await this.b.$invokeTool(R,p,c)}async $acceptToolDelta(R){R.added&&this.c.set(R.added.name,R.added),R.removed&&this.c.delete(R.removed)}get tools(){return Array.from(this.c.values()).map(R=>k.LanguageModelToolDescription.to(R))}async $invokeTool(R,p,c){const I=this.a.get(R);if(!I)throw new Error(`Unknown tool ${R}`);return await I.tool.invoke(p,c)}registerTool(R,p,c){return this.a.set(p,{extension:R,tool:c}),this.b.$registerTool(p),(0,r.$Vc)(()=>{this.a.delete(p),this.b.$unregisterTool(p)})}}e.$0pc=A}),define(Se[130],De([1,0,7,21,51,14,4,40,3,237,24,5,12,90,6,129,20,16,8,157,26]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=e.$mpc=void 0,g=Ue(g),$=Ue($),e.$mpc=(0,S.$Gi)("IExtHostLanguageModels");class i{constructor(b,E){this.option=b,this.stream=new r.$0h,this.stream=E??new r.$0h}}class s{constructor(){this.a=new Map,this.b=new r.$0h,this.c=!1;const b=this;this.apiObject={get stream(){return b.b.asyncIterable},get text(){return r.$7h.map(b.b.asyncIterable,E=>{if(E instanceof $.$LP)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,b]of this.a)yield b.stream;else yield this.b}handleFragment(b){if(this.c)return;let E=this.a.get(b.index);E||(this.a.size===0?E=new i(b.index,this.b):E=new i(b.index),this.a.set(b.index,E));let D;b.part.type==="text"?D=new $.$LP(b.part.value):D=new $.$KP(b.part.name,b.part.parameters),E.stream.emitOne(D)}reject(b){this.c=!0;for(const E of this.d())E.reject(b)}resolve(){this.c=!0;for(const b of this.d())b.resolve()}}let d=t=class{constructor(b,E,D){this.j=E,this.k=D,this.c=new O.$ne,this.d=new O.$ne,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$un,this.i=new Map,this.s=new Set,this.b=b.getProxy(w.$vN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(b,E,D,y){const T=t.a++;this.f.set(T,{extension:b.identifier,provider:D,languageModelId:E});let C;y.auth&&(C={providerLabel:b.displayName||b.name,accountLabel:typeof y.auth=="object"?y.auth.label:void 0}),this.b.$registerLanguageModelProvider(T,`${I.$sn.toKey(b.identifier)}/${T}/${E}`,{extension:b.identifier,id:E,vendor:y.vendor??I.$sn.toKey(b.identifier),name:y.name??"",family:y.family??"",version:y.version,maxInputTokens:y.maxInputTokens,maxOutputTokens:y.maxOutputTokens,auth:C,targetExtensions:y.extensions});const v=D.onDidReceiveLanguageModelResponse2?.(({extensionId:f,participant:N,tokenCount:F})=>{this.b.$whenLanguageModelChatRequestMade(E,new I.$sn(f),N,F)});return(0,p.$Vc)(()=>{this.f.delete(T),this.b.$unregisterProvider(T),v?.dispose()})}async $startChatRequest(b,E,D,y,T,C){const v=this.f.get(b);if(!v)throw new Error("Provider not found");const f=new P.$xw(async F=>{if(C.isCancellationRequested){this.j.warn(`[CHAT](${v.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let j;if(F.part instanceof $.$KP?j={type:"function_use",name:F.part.name,parameters:F.part.parameters}:F.part instanceof $.$LP&&(j={type:"text",value:F.part.value}),!j){this.j.warn(`[CHAT](${v.extension.value}) UNKNOWN part ${JSON.stringify(F)}`);return}this.b.$reportResponsePart(E,{index:F.index,part:j})});let N;if(v.provider.provideLanguageModelResponse2)N=Promise.resolve(v.provider.provideLanguageModelResponse2(y.map(g.LanguageModelChatMessage.to),T,I.$sn.toKey(D),f,C));else{const F=new P.$xw(async j=>{f.report({index:j.index,part:new $.$LP(j.part)})});N=Promise.resolve(v.provider.provideLanguageModelResponse(y.map(g.LanguageModelChatMessage.to),T?.modelOptions??{},I.$sn.toKey(D),F,C))}N.then(()=>{this.b.$reportResponseDone(E,void 0)},F=>{this.b.$reportResponseDone(E,(0,A.$5)(F))})}$provideTokenLength(b,E,D){const y=this.f.get(b);return y?Promise.resolve(y.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(b){if(b.added)for(const{identifier:E,metadata:D}of b.added)this.g.set(E,{metadata:D,apiObjects:new I.$un});if(b.removed)for(const E of b.removed){this.g.delete(E);for(const[D,y]of this.i)y.languageModelId===E&&(y.res.reject(new A.$8),this.i.delete(D))}b.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(b,E){const D=await this.b.$selectChatModels({...E,extension:b.identifier}),y=[],T=this;for(const C of D){const v=this.g.get(C);if(!v)continue;this.o(b.identifier,v.metadata)&&await this.q(v.metadata);let f=v.apiObjects.get(b.identifier);f||(f={id:C,vendor:v.metadata.vendor,family:v.metadata.family,version:v.metadata.version,name:v.metadata.name,maxInputTokens:v.metadata.maxInputTokens,countTokens(N,F){if(!T.g.has(C))throw $.$PP.NotFound(C);return T.r(C,N,F??a.CancellationToken.None)},sendRequest(N,F,j){if(!T.g.has(C))throw $.$PP.NotFound(C);return T.l(b,C,N,F??{},j??a.CancellationToken.None)}},Object.freeze(f),v.apiObjects.set(b.identifier,f)),y.push(f)}return y}async l(b,E,D,y,T){const C=this.m(b,D),v=b.identifier,f=this.g.get(E)?.metadata;if(!f||!this.g.has(E))throw $.$PP.NotFound(`Language model '${E}' is unknown.`);if(this.o(v,f)&&(!await this.n(b,{identifier:f.extension,displayName:f.auth.providerLabel},y.justification,!1)||!this.h.get(v)?.has(f.extension)))throw $.$PP.NoPermissions(`Language model '${E}' cannot be used by '${v.value}'.`);try{const N=Math.random()*1e6|0,F=new s;this.i.set(N,{languageModelId:E,res:F});try{await this.b.$tryStartChatRequest(v,E,N,C,y,T)}catch(j){throw this.i.delete(N),j}return F.apiObject}catch(N){throw N.name===$.$PP.name?N:new $.$PP(`Language model '${E}' errored: ${(0,k.$rj)(N)}`,"Unknown",N)}}m(b,E){const D=[];for(const y of E)y.role===$.LanguageModelChatMessageRole.System&&(0,o.$8G)(b,"languageModelSystem"),y.content2 instanceof $.$IP&&(0,o.$8G)(b,"lmTools"),D.push(g.LanguageModelChatMessage.from(y));return D}async $acceptResponsePart(b,E){const D=this.i.get(b);D&&D.res.handleFragment(E)}async $acceptResponseDone(b,E){const D=this.i.get(b);D&&(this.i.delete(b),E?D.res.reject((0,A.$6)(E)):D.res.resolve())}async n(b,E,D,y){const T=n.$xM+E.identifier.value;if(await this.k.getSession(b,T,[],{silent:!0}))return this.$updateModelAccesslist([{from:b.identifier,to:E.identifier,enabled:!0}]),!0;if(y)return!1;try{const v=D?(0,c.localize)(0,null,E.displayName,D):void 0;return await this.k.getSession(b,T,[],{forceNewSession:{detail:v}}),this.$updateModelAccesslist([{from:b.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(b,E){return!!E.auth&&!I.$sn.equals(E.extension,b)}async q(b){if(b.auth)for(const E of this.s)try{await this.n(E,{identifier:b.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(b,E,D){if(!this.g.get(b))throw $.$PP.NotFound(`Language model '${b}' is unknown.`);const T=R.Iterable.find(this.f.values(),C=>C.languageModelId===b);return T?T.provider.provideTokenCount(E,D):this.b.$countTokens(b,typeof E=="string"?E:g.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(b){const E=new Array;for(const{from:D,to:y,enabled:T}of b){const C=this.h.get(D)??new I.$tn;if(C.has(y)!==T){T?C.add(y):C.delete(y),this.h.set(D,C);const f={from:D,to:y};E.push(f),this.c.fire(f)}}}createLanguageModelAccessInformation(b){this.s.add(b);const E=this,D=O.Event.signal(O.Event.filter(this.c.event,T=>I.$sn.equals(T.from,b.identifier))),y=O.Event.signal(this.d.event);return{get onDidChange(){return O.Event.any(D,y)},canSendRequest(T){let C;e:for(const[f,N]of E.g)for(const F of N.apiObjects.values())if(F===T){C=N.metadata;break e}if(!C)return;if(!E.o(b.identifier,C))return!0;const v=E.h.get(b.identifier);if(v)return v.has(C.extension)}}}};e.$npc=d,d.a=1,e.$npc=d=t=Ye([Ve(0,m.$2P),Ve(1,h.$ak),Ve(2,l.$Hoc)],d)});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[356],De([1,0,6,16,8,45,7,3,26]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=void 0,a=Ue(a),A=qt(A);class c{constructor(S,h,P,w){this.c=h,this.d=P,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(r.$vN.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,h){await this.a.$changeLanguage(S,h);const P=this.c.getDocumentData(S);if(!P)throw new Error(`document '${S.toString()}' NOT found`);return P.document}async tokenAtPosition(S,h){const P=S.version,w=a.Position.from(h),l=await this.a.$tokensAtPosition(S.uri,w),m={type:k.StandardTokenType.Other,range:S.getWordRangeAtPosition(h)??new k.$zN(h.line,h.character,h.line,h.character)};if(!l)return m;const g={range:a.Range.to(l.range),type:a.TokenType.to(l.type)};return!g.range.contains(h)||P!==S.version?m:g}createLanguageStatusItem(S,h,P){const w=this.f++,l=this.a,m=this.g,g=`${S.identifier.value}/${h}`;if(m.has(g))throw new Error(`LanguageStatusItem with id '${h}' ALREADY exists`);m.add(g);const $={selector:P,id:h,name:S.displayName??S.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new R.$Wc,t=()=>{if(n?.dispose(),!m.has(g)){console.warn(`LanguageStatusItem (${h}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,O.$Ih)(()=>{o.clear(),this.a.$setLanguageStatus(w,{id:g,name:$.name??S.displayName??S.name,source:S.displayName??S.name,selector:a.DocumentSelector.from($.selector,this.e),label:$.text,detail:$.detail??"",severity:$.severity===k.LanguageStatusSeverity.Error?A.default.Error:$.severity===k.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:$.command&&this.d.toInternal($.command,o),accessibilityInfo:$.accessibilityInformation,busy:$.busy})},0)},i={dispose(){o.dispose(),n?.dispose(),l.$removeLanguageStatus(w),m.delete(g)},get id(){return $.id},get name(){return $.name},set name(s){$.name=s,t()},get selector(){return $.selector},set selector(s){$.selector=s,t()},get text(){return $.text},set text(s){$.text=s,t()},set text2(s){(0,p.$8G)(S,"languageStatusText"),$.text=s,t()},get text2(){return(0,p.$8G)(S,"languageStatusText"),$.text},get detail(){return $.detail},set detail(s){$.detail=s,t()},get severity(){return $.severity},set severity(s){$.severity=s,t()},get accessibilityInformation(){return $.accessibilityInformation},set accessibilityInformation(s){$.accessibilityInformation=s,t()},get command(){return $.command},set command(s){$.command=s,t()},get busy(){return $.busy},set busy(s){$.busy=s,t()}};return t(),i}}e.$$pc=c}),define(Se[357],De([1,0,15,2,16,8,128]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=e.$Vpc=void 0,k=Ue(k),O=Ue(O);class R{constructor(S,h,P,w){this.start=S,this.deletedCount=h,this.deletedItems=P,this.items=w}asApiEvent(){return{range:new A.$ZO(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,h,P){this.notebook=S,this.h=h,this.j=P,this.handle=P.handle,this.uri=a.URI.revive(P.uri),this.cellKind=P.cellKind,this.a=P.outputs.map(k.NotebookCellOutput.to),this.e=P.internalMetadata??{},this.b=Object.freeze(P.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(P.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const P={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return S.g},set mime(w){S.g=w},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(P)}return this.f}setOutputs(S){this.a=S.map(k.NotebookCellOutput.to)}setOutputItems(S,h,P){const w=P.map(k.NotebookCellOutputItem.to),l=this.a.find(m=>m.id===S);if(l&&(h||(l.items.length=0),l.items.push(...w),l.items.length>1&&l.items.every(m=>O.$AL(m.mime)))){const m=new Map,g=[];l.items.forEach($=>{let n;m.has($.mime)?n=m.get($.mime):(n=[],m.set($.mime,n),g.push($.mime)),n.push($.data)}),l.items.length=0,g.forEach($=>{const n=O.$BL(m.get($));l.items.push({mime:$,data:n.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$Vpc=p;class c{constructor(S,h,P,w,l){this.k=S,this.l=h,this.m=P,this.uri=w,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,h={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===r.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(P){return P=S.n(P),S.b[P].apiCell},getCells(P){return(P?S.p(P):S.b).map(l=>l.apiCell)},save(){return S.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,h,P){this.g=S.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:P});const w={notebook:this.apiNotebook,metadata:P,cellChanges:[],contentChanges:[]},l=[];for(const g of S.rawEvents)g.kind===O.NotebookCellsChangeType.ModelChange?this.r(g.changes,!1,w.contentChanges):g.kind===O.NotebookCellsChangeType.Move?this.s(g.index,g.length,g.newIdx,w.contentChanges):g.kind===O.NotebookCellsChangeType.Output?(this.t(g.index,g.outputs),l.push({cell:this.b[g.index].apiCell,outputs:this.b[g.index].apiCell.outputs})):g.kind===O.NotebookCellsChangeType.OutputItem?(this.u(g.index,g.outputId,g.append,g.outputItems),l.push({cell:this.b[g.index].apiCell,outputs:this.b[g.index].apiCell.outputs})):g.kind===O.NotebookCellsChangeType.ChangeCellLanguage?(this.v(g.index,g.language),l.push({cell:this.b[g.index].apiCell,document:this.b[g.index].apiCell.document})):g.kind===O.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[g.index].apiCell,document:this.b[g.index].apiCell.document}):g.kind===O.NotebookCellsChangeType.ChangeCellMime?this.w(g.index,g.mime):g.kind===O.NotebookCellsChangeType.ChangeCellMetadata?(this.x(g.index,g.metadata),l.push({cell:this.b[g.index].apiCell,metadata:this.b[g.index].apiCell.metadata})):g.kind===O.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(g.index,g.internalMetadata),l.push({cell:this.b[g.index].apiCell,executionSummary:this.b[g.index].apiCell.executionSummary}));const m=new Map;for(let g=0;g<l.length;g++){const $=l[g],n=m.get($.cell);if(n===void 0){const o=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...$});m.set($.cell,o-1)}else w.cellChanges[n]={...w.cellChanges[n],...$}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let h=S.start|0,P=S.end|0;return h<0&&(h=0),P>this.b.length&&(P=this.b.length),S.with({start:h,end:P})}p(S){S=this.o(S);const h=[];for(let P=S.start;P<S.end;P++)h.push(this.b[P]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,h,P){if(this.j)return;const w=[],l=[],m=[];if(S.reverse().forEach(g=>{const n=g[2].map(i=>{const s=new p(this,this.l,i);return h||l.push(p.asModelAddData(i)),s}),o=new R(g[0],g[1],[],n),t=this.b.splice(g[0],g[1],...n);for(const i of t)m.push(i.uri),o.deletedItems.push(i.apiCell);w.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:m}),P)for(const g of w)P.push(g.asApiEvent())}s(S,h,P,w){const l=this.b.splice(S,h);this.b.splice(P,0,...l);const m=[new R(S,h,l.map(g=>g.apiCell),[]),new R(P,0,[],l)];for(const g of m)w.push(g.asApiEvent())}t(S,h){this.b[S].setOutputs(h)}u(S,h,P,w){this.b[S].setOutputItems(h,P,w)}v(S,h){const P=this.b[S];P.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(P.uri,h)}w(S,h){const P=this.b[S];P.apiCell.mime=h}x(S,h){this.b[S].setMetadata(h)}y(S,h){this.b[S].setInternalMetadata(h)}getCellFromApiCell(S){return this.b.find(h=>h.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(h=>h.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$Wpc=c,c.a=0}),define(Se[358],De([1,0,4,2,16,8,52]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class R{constructor(c,I,S,h={timeout:1500,errors:3}){this.b=c,this.c=I,this.d=S,this.f=h,this.a=new r.$pe}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(I,S,h)=>{const P=function(l){I.call(S,l)};return P.extension=c,this.a.event(P,void 0,h)}}async $participateInSave(c,I,S){const h=a.URI.revive(c),P=this.c.getNotebookDocument(h);if(!P)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:P.apiNotebook,reason:k.TextDocumentSaveReason.to(I)},S,async(m,g)=>{const $=Date.now(),n=await await Promise.resolve(m);Date.now()-$>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier),!S.isCancellationRequested&&n&&(n instanceof A.$HN?w.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(w.length===0)return!0;const l={edits:[]};for(const m of w){const{edits:g}=k.WorkspaceEdit.from(m);l.edits=l.edits.concat(g)}return this.d.$tryApplyWorkspaceEdit(new O.$Vw(l))}}e.$aqc=R}),define(Se[166],De([1,0,14,16,8]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0,a=Ue(a),k=Ue(k);class A{constructor(R,p,c,I,S,h){this.id=R,this.f=p,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=I,this.c=h}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(p){this.selections=[p]},get selections(){return R.a},set selections(p){if(!Array.isArray(p)||!p.every(k.$ZO.isNotebookRange))throw(0,r.$0)("selections");R.a=p,R.g(p)},get visibleRanges(){return R.b},revealRange(p,c){R.f.$tryRevealRange(R.id,a.NotebookRange.from(p),c??k.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(a.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.$Xpc=A,A.apiEditorsToExtHost=new WeakMap}),define(Se[359],De([1,0,4,12,16]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=void 0,k=Ue(k);let A=class{constructor(R,p){this.c=R,this.d=p,this.a=new r.$ne,this.b=new r.$ne,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,p);const c=this.d.getEditorById(R);p.visibleRanges&&c._acceptVisibleRanges(p.visibleRanges.ranges.map(k.NotebookRange.to)),p.selections&&c._acceptSelections(p.selections.selections.map(k.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const p in R)this.d.getEditorById(p)._acceptViewColumn(k.ViewColumn.to(R[p]))}};e.$cqc=A,e.$cqc=A=Ye([Ve(0,a.$ak)],A)}),define(Se[360],De([1,0,4,6,166]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=void 0;class A{constructor(R,p){this.c=p,this.a=new Map,this.b=R.getProxy(a.$vN.MainThreadNotebookRenderers)}$postRendererMessage(R,p,c){const I=this.c.getEditorById(R);this.a.get(p)?.fire({editor:I.apiEditor,message:c})}createRendererMessaging(R,p){if(!R.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,S,h)=>this.d(p).event(I,S,h),postMessage:(I,S)=>{k.$Xpc.apiEditorsToExtHost.has(I)&&([I,S]=[S,I]);const h=S&&k.$Xpc.apiEditorsToExtHost.get(S);return this.b.$postMessage(h?.id,p,I)}}}d(R){let p=this.a.get(R);return p||(p=new r.$ne({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(R)}}),this.a.set(R,p),p)}}e.$fqc=A}),define(Se[361],De([1,0,16,90,21,59,14]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=void 0;class R{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,h,P){const w=this.b++,{title:l,location:m,cancellable:g}=h,$={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(w,{location:r.ProgressLocation.from(m),title:l,source:$,cancellable:g},S.isUnderDevelopment?void 0:S.identifier.value).catch(O.$4),this.d(w,P,!!g)}d(S,h,P){let w;P&&(w=new k.$ye,this.c.set(S,w));const l=g=>{this.a.$progressEnd(g),this.c.delete(g),w?.dispose()};let m;try{m=h(new c(this.a,S),P&&w?w.token:k.CancellationToken.None)}catch(g){throw l(S),g}return m.then(g=>l(S),g=>l(S)),m}$acceptProgressCanceled(S){const h=this.c.get(S);h&&(h.cancel(),this.c.delete(S))}}e.$jqc=R;function p(I,S){return I.message=S.message,typeof S.increment=="number"&&(typeof I.increment=="number"?I.increment+=S.increment:I.increment=S.increment),I}class c extends a.$xw{constructor(S,h){super(P=>this.throttledReport(P)),this.c=S,this.d=h}throttledReport(S){this.c.$progressReport(this.d,S)}}Ye([(0,A.$ai)(100,(I,S)=>p(I,S),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(Se[362],De([1,0,2,6,7,16]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=void 0;class O{constructor(p,c){this.d=c,this.c=new Map,this.b=p.getProxy(a.$vN.MainThreadQuickDiff)}$provideOriginalResource(p,c,I){const S=r.URI.revive(c),h=this.c.get(p);return h?(0,k.$yh)(()=>h.provideOriginalResource(S,I)).then(P=>P||null):Promise.resolve(null)}registerQuickDiffProvider(p,c,I,S){const h=O.a++;return this.c.set(h,c),this.b.$registerQuickDiffProvider(h,A.DocumentSelector.from(p,this.d),I,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}e.$kqc=O,O.a=0});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[363],De([1,0,21,4,3,6,2,8,14,19,45,50,26,16]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=w,I=qt(I);function w(l,m,g){const $=l.getProxy(A.$vN.MainThreadQuickOpen);class n{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,T,C=r.CancellationToken.None){this.c=void 0;const v=Promise.resolve(y),f=++this.f,N=$.$show(f,{title:T?.title,placeHolder:T?.placeHolder,matchOnDescription:T?.matchOnDescription,matchOnDetail:T?.matchOnDetail,ignoreFocusLost:T?.ignoreFocusOut,canPickMany:T?.canPickMany},C),F={},j=N.then(()=>F);return Promise.race([j,v]).then(z=>{if(z===F)return;const M=(0,h.$7G)(D,"quickPickItemTooltip");return v.then(L=>{const B=[];for(let W=0;W<L.length;W++){const ae=L[W];if(typeof ae=="string")B.push({label:ae,handle:W});else if(ae.kind===R.QuickPickItemKind.Separator)B.push({type:"separator",label:ae.label});else{ae.tooltip&&!M&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const q=ae.iconPath?d(ae.iconPath):void 0;B.push({label:ae.label,iconPath:q?.iconPath,iconClass:q?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:M?P.MarkdownString.fromStrict(ae.tooltip):void 0,handle:W})}}return T&&typeof T.onDidSelectItem=="function"&&(this.c=W=>{T.onDidSelectItem(L[W])}),$.$setItems(f,B),N.then(W=>{if(typeof W=="number")return L[W];if(Array.isArray(W))return W.map(ae=>L[ae])})})}).then(void 0,z=>{if(!(0,p.$7)(z))return $.$setError(f,z),Promise.reject(z)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=r.CancellationToken.None){return this.d=D?.validateInput,$.$input(D,typeof this.d=="function",y).then(void 0,T=>{if(!(0,p.$7)(T))return Promise.reject(T)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let T;switch(y.severity){case R.InputBoxValidationSeverity.Info:T=I.default.Info;break;case R.InputBoxValidationSeverity.Warning:T=I.default.Warning;break;case R.InputBoxValidationSeverity.Error:T=I.default.Error;break;default:T=y.message?I.default.Error:I.default.Ignore;break}return{content:y.message,severity:T}}async showWorkspaceFolderPick(D,y=r.CancellationToken.None){const T=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!T)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(v=>v.uri.toString()===T.uri.toString())}createQuickPick(D){const y=new u(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new b(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const T=this.e.get(D);T instanceof u&&T._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const T=this.e.get(D);T instanceof u&&T._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,T){const C=this.e.get(D);C instanceof u&&C._fireDidTriggerItemButton(y,T)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class o{constructor(D,y){this.x=D,this.y=y,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new a.$ne,this.q=new a.$ne,this.r=new a.$ne,this.s=new a.$ne,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((y,T)=>{const C=y===R.$WO.Back?-1:T;this.o.set(C,y)}),this.z({buttons:D.map((y,T)=>({...d(y.iconPath),tooltip:y.tooltip,handle:y===R.$WO.Back?-1:T}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.$Sc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),$.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const T=D[y];this.u[y]=T===void 0?null:T}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){$.$createOrUpdate(this.u),this.u={id:this._id}}}o.a=1;function t(E){if(E instanceof R.$uO)return{id:E.id};const D=s(E),y=i(E);return{dark:typeof D=="string"?O.URI.file(D):D,light:typeof y=="string"?O.URI.file(y):y}}function i(E){return typeof E=="object"&&"light"in E?E.light:E}function s(E){return typeof E=="object"&&"dark"in E?E.dark:E}function d(E){const D=t(E);let y,T;return"id"in D?T=S.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:T}}class u extends o{constructor(D,y){super(D.identifier,y),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new a.$ne,this.L=[],this.M=new a.$ne,this.N=new a.$ne,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((C,v)=>{this.C.set(v,C),this.D.set(C,v)});const y=(0,h.$7G)(this.O,"quickPickItemTooltip"),T=[];for(let C=0;C<D.length;C++){const v=D[C];if(v.kind===R.QuickPickItemKind.Separator)T.push({type:"separator",label:v.label});else{v.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const f=v.iconPath?d(v.iconPath):void 0;T.push({handle:C,label:v.label,iconPath:f?.iconPath,iconClass:f?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:y?P.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((N,F)=>({...d(N.iconPath),tooltip:N.tooltip,handle:F}))})}}this.z({items:T})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,c.$Kb)(D.map(T=>this.C.get(T)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,c.$Kb)(D.map(T=>this.C.get(T)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const T=this.C.get(D);if(!T||!T.buttons||!T.buttons.length)return;const C=T.buttons[y];C&&this.N.fire({button:C,item:T})}}class b extends o{constructor(D,y){super(D.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:I.default.Error}):this.z({validationMessage:D.message,severity:D.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new n(m,g)}});var He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)},ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r};define(Se[364],De([1,0,2,4,59,3,7,6,19,136,12,24,41,50,16,26,15,11]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g){"use strict";var $,n,o,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=e.$mqc=void 0;function i(M){return M instanceof r.URI}function s(M,L){return M.scheme===m.Schemas.file&&L.scheme===m.Schemas.file&&g.$e?M.toString()===L.toString():M.toString().toLowerCase()===L.toString().toLowerCase()}function d(M){if(M)return typeof M.iconPath=="string"?r.URI.file(M.iconPath):r.URI.isUri(M.iconPath)||P.ThemeIcon.isThemeIcon(M.iconPath)?M.iconPath:void 0}function u(M){if(M){if(r.URI.isUri(M))return M;if(P.ThemeIcon.isThemeIcon(M))return M;{const L=M;return{light:L.light,dark:L.dark}}}else return}function b(M){const L=u(M.icon),B=M.labels?.map(W=>({title:W.title,icon:u(W.icon)}));return{...M,icon:L,labels:B}}function E(M,L){if(!M.iconPath&&!L.iconPath)return 0;if(M.iconPath){if(!L.iconPath)return 1}else return-1;const B=typeof M.iconPath=="string"?M.iconPath:r.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id,W=typeof L.iconPath=="string"?L.iconPath:r.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,c.$Jr)(B,W)}function D(M,L){let B=0;if(M.strikeThrough!==L.strikeThrough)return M.strikeThrough?1:-1;if(M.faded!==L.faded)return M.faded?1:-1;if(M.tooltip!==L.tooltip)return(M.tooltip||"").localeCompare(L.tooltip||"");if(B=E(M,L),B!==0)return B;if(M.light&&L.light)B=E(M.light,L.light);else{if(M.light)return 1;if(L.light)return-1}if(B!==0)return B;if(M.dark&&L.dark)B=E(M.dark,L.dark);else{if(M.dark)return 1;if(L.dark)return-1}return B}function y(M,L){if(M.command!==L.command)return M.command<L.command?-1:1;if(M.title!==L.title)return M.title<L.title?-1:1;if(M.tooltip!==L.tooltip){if(M.tooltip!==void 0&&L.tooltip!==void 0)return M.tooltip<L.tooltip?-1:1;if(M.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(M.arguments===L.arguments)return 0;if(M.arguments)if(L.arguments){if(M.arguments.length!==L.arguments.length)return M.arguments.length-L.arguments.length}else return 1;else return-1;for(let B=0;B<M.arguments.length;B++){const W=M.arguments[B],ae=L.arguments[B];if(W!==ae&&!(i(W)&&i(ae)&&s(W,ae)))return W<ae?-1:1}return 0}function T(M,L){let B=(0,c.$Jr)(M.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(B!==0)return B;if(M.command&&L.command)B=y(M.command,L.command);else{if(M.command)return 1;if(L.command)return-1}if(B!==0)return B;if(M.decorations&&L.decorations)B=D(M.decorations,L.decorations);else{if(M.decorations)return 1;if(L.decorations)return-1}if(M.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)B=(0,c.$Jr)(M.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(M.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(M.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)B=(0,c.$Jr)(M.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(M.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return B}function C(M,L){for(let B=0;B<M.length;B++)if(M[B]!==L[B])return!1;return!0}function v(M,L){return M.command===L.command&&M.title===L.title&&M.tooltip===L.tooltip&&(M.arguments&&L.arguments?C(M.arguments,L.arguments):M.arguments===L.arguments)}function f(M,L){return(0,p.$xb)(M,L,v)}class N{get value(){return this.d}set value(L){L=L??"",He(this,$,"f").$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){He(this,$,"f").$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,l.$8G)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,l.$8G)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,He(this,$,"f").$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,He(this,$,"f").$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,He(this,$,"f").$setInputBoxVisibility(this.m,L))}get document(){return(0,l.$8G)(this.k,"scmTextDocument"),He(this,n,"f").getDocument(this.n)}constructor(L,B,W,ae,q){this.k=L,this.m=ae,this.n=q,$.set(this,void 0),n.set(this,void 0),this.d="",this.e=new a.$ne,this.f="",this.h=!0,this.j=!0,ot(this,n,B,"f"),ot(this,$,W,"f")}showValidationMessage(L,B){(0,l.$8G)(this.k,"scmValidation"),He(this,$,"f").$showValidationMessage(this.m,L,B)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$mqc=N,$=new WeakMap,n=new WeakMap;class F{get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,B,W,ae,q,K,ee){this.s=L,this.t=B,this.u=W,this.v=ae,this.w=q,this.multiDiffEditorEnableViewChanges=K,this.x=ee,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new a.$ne,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new a.$ne,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=F.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,B){const W=this.h.get(L);return W?(0,O.$yh)(()=>this.t.executeCommand(W.command,...W.arguments||[],B)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(T),W=(0,p.$Gb)(this.p,L,T).map(K=>{const ee=K.toInsert.map(re=>{const ge=this.e++;this.g.set(ge,re);const Z=re.resourceUri;let $e;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const Me=new A.$Wc;$e=this.t.converter.toInternal(re.command,Me),this.j.set(ge,Me)}else this.h.set(ge,re.command);const fe=(0,l.$7G)(this.x,"scmMultiDiffEditor"),oe=fe?re.multiDiffEditorOriginalUri:void 0,H=fe?re.multiFileDiffEditorModifiedUri:void 0,ue=d(re.decorations),te=re.decorations&&d(re.decorations.light)||ue,_=re.decorations&&d(re.decorations.dark)||ue,ne=[te,_],le=re.decorations&&re.decorations.tooltip||"",J=re.decorations&&!!re.decorations.strikeThrough,ce=re.decorations&&!!re.decorations.faded,me=re.contextValue||"";return{rawResource:[ge,Z,ne,le,J,ce,me,$e,oe,H],handle:ge}});return{start:K.start,deleteCount:K.deleteCount,toInsert:ee}}),ae=W.map(({start:K,deleteCount:ee,toInsert:re})=>[K,ee,re.map(ge=>ge.rawResource)]),q=W.reverse();for(const{start:K,deleteCount:ee,toInsert:re}of q){const ge=re.map($e=>$e.handle),Z=this.o.splice(K,ee,...ge);for(const $e of Z)this.g.delete($e),this.h.delete($e),this.j.get($e)?.dispose(),this.j.delete($e)}return this.p=L,ae}dispose(){this.m=!0,this.n.fire()}}F.d=0;class j{get id(){return this.B}get label(){return this.C}get rootUri(){return this.D}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,He(this,o,"f").$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let B;(0,l.$7G)(this.y,"quickDiffProvider")&&(B=L?.label),He(this,o,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:B})}get historyProvider(){return(0,l.$8G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,l.$8G)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new A.$Wc,He(this,o,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,He(this,o,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,He(this,o,"f").$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new A.$Wc,this.p=L;const B=this.z.converter.toInternal(L,this.o.value);He(this,o,"f").$updateSourceControl(this.x,{acceptInputCommand:B})}get actionButton(){return(0,l.$8G)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,l.$8G)(this.y,"scmActionButton"),this.q.value=new A.$Wc,this.s=L;const B=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(W=>W.map(ae=>this.z.converter.toInternal(ae,this.q.value))),description:L.description,enabled:L.enabled}:void 0;He(this,o,"f").$updateSourceControl(this.x,{actionButton:B??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.A.trace("ExtHostSourceControl#statusBarCommands",(L??[]).map(W=>W.command).join(", ")),this.u&&L&&f(this.u,L)){this.A.trace("ExtHostSourceControl#statusBarCommands are equal");return}this.t.value=new A.$Wc,this.u=L;const B=(L||[]).map(W=>this.z.converter.toInternal(W,this.t.value));He(this,o,"f").$updateSourceControl(this.x,{statusBarCommands:B})}get selected(){return this.v}constructor(L,B,W,ae,q,K,ee,re){this.y=L,this.z=ae,this.A=q,this.B=K,this.C=ee,this.D=re,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Yc,this.n=void 0,this.o=new A.$Yc,this.p=void 0,this.q=new A.$Yc,this.t=new A.$Yc,this.u=void 0,this.v=!1,this.w=new a.$ne,this.onDidChangeSelection=this.w.event,this.x=j.d++,this.E=new Map,this.F=new Set,ot(this,o,W,"f");const ge=r.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${K}/scm${this.x}/input`,query:re?`rootUri=${encodeURIComponent(re.toString())}`:void 0});this.f=new N(L,B,He(this,o,"f"),this.x,ge),He(this,o,"f").$registerSourceControl(this.x,K,ee,re,ge)}createResourceGroup(L,B,W){const ae=(0,l.$7G)(this.y,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,q=new F(He(this,o,"f"),this.z,this.x,L,B,ae,this.y),K=a.Event.once(q.onDidDispose)(()=>this.E.delete(q));return this.E.set(q,K),this.eventuallyAddResourceGroups(),q}eventuallyAddResourceGroups(){const L=[],B=[];for(const[W,ae]of this.E){ae.dispose();const q=W.onDidUpdateResourceStates(()=>{this.F.add(W),this.eventuallyUpdateResourceStates()});a.Event.once(W.onDidDispose)(()=>{this.F.delete(W),q.dispose(),this.e.delete(W.handle),He(this,o,"f").$unregisterGroup(this.x,W.handle)}),L.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const K=W._takeResourceStateSnapshot();K.length>0&&B.push([W.handle,K]),this.e.set(W.handle,W)}He(this,o,"f").$registerGroups(this.x,L,B),this.E.clear()}eventuallyUpdateResourceStates(){const L=[];this.F.forEach(B=>{const W=B._takeResourceStateSnapshot();W.length!==0&&L.push([B.handle,W])}),L.length>0&&He(this,o,"f").$spliceResourceStates(this.x,L),this.F.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),He(this,o,"f").$unregisterSourceControl(this.x)}}o=new WeakMap,j.d=0,Ye([(0,k.$_h)(100)],j.prototype,"eventuallyAddResourceGroups",null),Ye([(0,k.$_h)(100)],j.prototype,"eventuallyUpdateResourceStates",null);let z=t=class{get onDidChangeActiveProvider(){return this.j.event}constructor(L,B,W,ae){this.m=B,this.n=W,this.o=ae,this.g=new Map,this.h=new S.$un,this.j=new a.$ne,this.e=L.getProxy(R.$vN.MainThreadSCM),this.f=L.getProxy(R.$vN.MainThreadTelemetry),B.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===h.MarshalledId.ScmResource){const K=this.g.get(q.sourceControlHandle);if(!K)return q;const ee=K.getResourceGroup(q.groupHandle);return ee?ee.getResourceState(q.handle):q}else if(q&&q.$mid===h.MarshalledId.ScmResourceGroup){const K=this.g.get(q.sourceControlHandle);return K?K.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===h.MarshalledId.ScmProvider){const K=this.g.get(q.handle);return K||q}return q}})}createSourceControl(L,B,W,ae){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,B,W,ae),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const q=t.d++,K=new j(L,this.n,this.e,this.m,this.o,B,W,ae);this.g.set(q,K);const ee=this.h.get(L.identifier)||[];return ee.push(K),this.h.set(L.identifier,ee),K}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const B=this.h.get(L.identifier),W=B&&B[B.length-1];return W&&W.inputBox}$provideOriginalResource(L,B,W){const ae=r.URI.revive(B);this.o.trace("ExtHostSCM#$provideOriginalResource",L,ae.toString());const q=this.g.get(L);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,O.$yh)(()=>q.quickDiffProvider.provideOriginalResource(ae,W)).then(K=>K||null)}$onInputBoxValueChange(L,B){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const W=this.g.get(L);return W&&W.inputBox.$onInputBoxValueChange(B),Promise.resolve(void 0)}$executeResourceCommand(L,B,W,ae){this.o.trace("ExtHostSCM#$executeResourceCommand",L,B,W);const q=this.g.get(L);if(!q)return Promise.resolve(void 0);const K=q.getResourceGroup(B);return K?K.$executeResourceCommand(W,ae):Promise.resolve(void 0)}$validateInput(L,B,W){this.o.trace("ExtHostSCM#$validateInput",L);const ae=this.g.get(L);return!ae||!ae.inputBox.validateInput?Promise.resolve(void 0):(0,O.$yh)(()=>ae.inputBox.validateInput(B,W)).then(q=>{if(!q)return Promise.resolve(void 0);const K=w.MarkdownString.fromStrict(q.message);return K?Promise.resolve([K,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,B,W,ae){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(B,W,ae)??void 0}async $provideHistoryItems(L,B,W,ae){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(B,W,ae))?.map(ee=>b(ee))??void 0}async $provideHistoryItems2(L,B,W){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(B,W))?.map(K=>b(K))??void 0}async $provideHistoryItemSummary(L,B,W,ae){const q=this.g.get(L)?.historyProvider;if(typeof q?.provideHistoryItemSummary!="function")return;const K=await q.provideHistoryItemSummary(B,W,ae);return K?b(K):void 0}async $provideHistoryItemChanges(L,B,W,ae){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(B,W,ae)??void 0}};e.$nqc=z,z.d=0,e.$nqc=z=t=Ye([Ve(3,I.$ak)],z)}),define(Se[365],De([1,0,6,16,2]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=void 0;class A{constructor(R,p){this.d=p,this.c=new Map,this.b=R.getProxy(r.$vN.MainThreadShare)}async $provideShare(R,p,c){return await this.c.get(R)?.provideShare({selection:a.Range.to(p.selection),resourceUri:k.URI.revive(p.resourceUri)},c)??void 0}registerShareProvider(R,p){const c=A.a++;return this.c.set(c,p),this.b.$registerShareProvider(c,a.DocumentSelector.from(R,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$oqc=A,A.a=0});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[366],De([1,0,8,6,240,3,16,18]),function(ie,e,r,a,k,A,O,R){"use strict";var p,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=e.$qqc=void 0;class I{constructor(w,l,m,g,$,n=r.StatusBarAlignment.Left,o){if(p.set(this,void 0),c.set(this,void 0),this.i=!1,this.k="",this.q=new A.$Wc,ot(this,p,w,"f"),ot(this,c,l,"f"),$&&g){this.c=(0,r.$0N)(g.identifier,$);const t=m.get(this.c);t&&(n=t.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,o=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String(I.a++);this.e=g,this.f=$,this.g=n,this.h=this.u(o)}u(w){if((0,R.$kg)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!I.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new A.$Wc,typeof w=="string"?this.r={fromApi:w,internal:He(this,c,"f").toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:He(this,c,"f").toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,He(this,p,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let l;this.m?l=this.m:l=(0,k.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=I.b.get(this.o.id));const g=O.MarkdownString.fromStrict(this.l);He(this,p,"f").$setEntry(this.c,w,this.e?.identifier.value,l,this.k,g,this.r?.internal,m,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$qqc=I,p=new WeakMap,c=new WeakMap,I.a=0,I.b=new Map([["statusBarItem.errorBackground",new r.$vO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$vO("statusBarItem.warningForeground")]]);class S{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const l={message:w};return this.b.unshift(l),this.c(),new r.$xN(()=>{const m=this.b.indexOf(l);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class h{constructor(w,l){this.e=new Map,this.a=w.getProxy(a.$vN.MainThreadStatusBar),this.b=l,this.c=new S(this)}$acceptStaticEntries(w){for(const l of w)this.e.set(l.entryId,l)}createStatusBarEntry(w,l,m,g){return new I(this.a,this.b,this.e,w,l,m,g)}setStatusBarMessage(w,l){const m=this.c.setMessage(w);let g;return typeof l=="number"?g=setTimeout(()=>m.dispose(),l):typeof l<"u"&&l.then(()=>m.dispose(),()=>m.dispose()),new r.$xN(()=>{m.dispose(),clearTimeout(g)})}}e.$rqc=h}),define(Se[167],De([1,0,31,156,74,122,75,16,2]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=e.$cQ=e.$bQ=void 0,r=Ue(r),R=Ue(R);const c=(n,o,t,i)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(d){if(!t(s,d)){const u=s;s=d,n.listener?.(i(d,u))}}}},I=(n,o)=>n===o,S={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(n,o)=>!(n.length!==o.length||n.some(t=>!o.find(i=>t.id===i.id)))},h=n=>o=>({op:A.TestItemEventOp.SetProp,update:n(o)}),P=(n,o)=>({range:(()=>{let t;const i=h(s=>({range:r.$Nt.lift(R.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return t},set(s){n.listener?.({op:A.TestItemEventOp.DocumentSynced}),S.range(t,s)||(t=s,n.listener?.(i(s)))}}})(),label:c(n,o,S.label,h(t=>({label:t}))),description:c(n,void 0,S.description,h(t=>({description:t}))),sortText:c(n,void 0,S.sortText,h(t=>({sortText:t}))),canResolveChildren:c(n,!1,S.canResolveChildren,t=>({op:A.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:c(n,!1,S.busy,h(t=>({busy:t}))),error:c(n,void 0,S.error,h(t=>({error:R.MarkdownString.fromStrict(t)||null}))),tags:c(n,[],S.tags,(t,i)=>({op:A.TestItemEventOp.SetTags,new:t.map(R.TestTag.from),old:i.map(R.TestTag.from)}))}),w=n=>{const o=k.$UI.fromString(n.extId),t=new m(o.controllerId,o.localId,n.label,p.URI.revive(n.uri)||void 0);return t.range=R.Range.to(n.range||void 0),t.description=n.description||void 0,t.sortText=n.sortText||void 0,t.tags=n.tags.map(i=>R.TestTag.to({id:(0,O.$1I)(i).tagId})),t},l=n=>{let o;for(const t of n.tests){const i=w(t.item);(0,a.$XP)(i).parent=o,o=i}return o};e.$bQ=l;class m{constructor(o,t,i,s){if(t.includes(k.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const d=(0,a.$WP)(this,o);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof g?void 0:d.parent}},children:{value:(0,A.$VP)(d,a.$XP,m),enumerable:!0,writable:!1},...P(d,i)})}}e.$cQ=m;class g extends m{constructor(o,t){super(o,o,t,void 0),this._isRoot=!0}}e.$dQ=g;class $ extends A.$RP{constructor(o,t,i){super({controllerId:o,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:a.$XP,getChildren:s=>s.children,root:new g(o,t),toITestItem:R.TestItem.from})}}e.$eQ=$});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[35],De([1,0,18,8,16,25,6,19,12,55,31,57,2,3,5,20,167,22,52,51,44,92,95,33]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s){"use strict";var d,u,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=void 0,a=Ue(a),k=Ue(k);let E=class{constructor(f,N,F){d.set(this,void 0),this.b=new Map,this.c=new Map,u.set(this,void 0),b.set(this,void 0),ot(this,d,f.getProxy(O.$vN.MainThreadCommands),"f"),this.d=N,ot(this,b,F,"f"),ot(this,u,f.getProxy(O.$vN.MainThreadTelemetry),"f"),this.converter=new D(this,j=>{const z=this.c.get(j);return z?.result===T.Void?z:void 0},N),this.f=[{processArgument(j){return(0,c.$di)(j)}},{processArgument(j){return(0,A.$ho)(j,function(z){if(I.$Nt.isIRange(z))return k.Range.to(z);if(S.$Mt.isIPosition(z))return k.Position.to(z);if(I.$Nt.isIRange(z.range)&&h.URI.isUri(z.uri))return k.location.to(z);if(z instanceof g.$Pe)return z.buffer.buffer;if(!Array.isArray(z))return z})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const N=this.registerCommand(!1,f.id,async(...F)=>{const j=f.args.map((M,L)=>{if(!M.validate(F[L]))throw new Error(`Invalid argument '${M.name}' when running '${f.id}', received: ${typeof F[L]=="object"?JSON.stringify(F[L],null,"	"):F[L]} `);return M.convert(F[L])}),z=await this.executeCommand(f.internalId,...j);return f.result.convert(z,F,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new a.$xN(()=>{N.dispose(),this.c.delete(f.id)})}registerCommand(f,N,F,j,z,M){if(this.d.trace("ExtHostCommands#registerCommand",N),!N.trim().length)throw new Error("invalid id");if(this.b.has(N))throw new Error(`command '${N}' already exists`);return this.b.set(N,{callback:F,thisArg:j,metadata:z,extension:M}),f&&He(this,d,"f").$registerCommand(N),new a.$xN(()=>{this.b.delete(N)&&f&&He(this,d,"f").$unregisterCommand(N)})}executeCommand(f,...N){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,N,!0)}async g(f,N,F){if(this.b.has(f))return He(this,d,"f").$fireCommandActivationEvent(f),this.h(f,N,!1);{let j=!1;const z=(0,A.$ho)(N,function(M){if(M instanceof a.$yN)return k.Position.from(M);if(M instanceof a.$zN)return k.Range.from(M);if(M instanceof a.$JN)return k.location.from(M);if(a.$ZO.isNotebookRange(M))return k.NotebookRange.from(M);if(M instanceof ArrayBuffer)return j=!0,g.$Pe.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return j=!0,g.$Pe.wrap(M);if(M instanceof g.$Pe)return j=!0,M;if(!Array.isArray(M))return M});try{const M=await He(this,d,"f").$executeCommand(f,j?new $.$Vw(z):z,F);return(0,c.$di)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this.g(f,N,!1);throw M}}}async h(f,N,F){const j=this.b.get(f);if(!j)throw new Error("Unknown command");const{callback:z,thisArg:M,metadata:L}=j;if(L?.args)for(let W=0;W<L.args.length;W++)try{(0,r.$xg)(N[W],L.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${L.args[W].name}' - ${L.args[W].description}`)}const B=o.$he.create();try{return await z.apply(M,N)}catch(W){if(f===this.converter.delegatingCommandId){const ae=this.converter.getActualCommand(...N);ae&&(f=ae.command)}if(this.d.error(W,f,j.extension?.identifier),!F)throw W;if(j.extension?.identifier){const ae=He(this,b,"f").onExtensionError(j.extension.identifier,W);this.d.trace("forwarded error to extension?",ae,j.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$rj)(W)),this.id=f,this.source=j.extension?.displayName??j.extension?.name}}}finally{this.j(j,f,B.elapsed())}}j(f,N,F){f.extension&&He(this,u,"f").$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new t.$wp(N),duration:F})}$executeContributedCommand(f,...N){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const F=this.b.get(f);return F?(N=N.map(j=>this.f.reduce((z,M)=>M.processArgument(z,F.extension?.identifier),j)),this.h(f,N,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),He(this,d,"f").$getCommands().then(N=>(f&&(N=N.filter(F=>F[0]!=="_")),N))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[N,F]of this.b){const{metadata:j}=F;j&&(f[N]=j)}return Promise.resolve(f)}};e.$kQ=E,d=new WeakMap,u=new WeakMap,b=new WeakMap,e.$kQ=E=Ye([Ve(0,l.$2P),Ve(1,p.$ak),Ve(2,i.$jQ)],E),e.$lQ=(0,w.$Gi)("IExtHostCommands");class D{constructor(f,N,F){this.d=f,this.f=N,this.g=F,this.delegatingCommandId=`__vsc${(0,s.$3g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,N){if(!f)return;const F={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return F;const j=this.f(f.command);if(j)F.id=j.internalId,F.arguments=j.args.map((z,M)=>z.convert(f.arguments&&f.arguments[M]));else if((0,R.$Ob)(f.arguments)){const z=`${f.command} /${++this.c}`;this.b.set(z,f),N.add((0,P.$Vc)(()=>{this.b.delete(z),this.g.trace("CommandsConverter#DISPOSE",z)})),F.$ident=z,F.id=this.delegatingCommandId,F.arguments=[z],this.g.trace("CommandsConverter#CREATE",f.command,z)}return F}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const N=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],N?N.command:"MISSING"),N?this.d.executeCommand(N.command,...N.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$mQ=D;class y{static Arr(f){return new y(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,N=>Array.isArray(N)&&N.every(F=>f.validate(F)),N=>N.map(F=>f.convert(F)))}constructor(f,N,F,j){this.name=f,this.description=N,this.validate=F,this.convert=j}optional(){return new y(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,N){return new y(f??this.name,N??this.description,this.validate,this.convert)}}e.$nQ=y,y.Uri=new y("uri","Uri of a text document",v=>h.URI.isUri(v),v=>v),y.Position=new y("position","A position in a text document",v=>a.$yN.isPosition(v),k.Position.from),y.Range=new y("range","A range in a text document",v=>a.$zN.isRange(v),k.Range.from),y.Selection=new y("selection","A selection in a text document",v=>a.$AN.isSelection(v),k.Selection.from),y.Number=new y("number","",v=>typeof v=="number",v=>v),y.String=new y("string","",v=>typeof v=="string",v=>v),y.StringArray=y.Arr(y.String),y.CallHierarchyItem=new y("item","A call hierarchy item",v=>v instanceof a.$VN,k.CallHierarchyItem.from),y.TypeHierarchyItem=new y("item","A type hierarchy item",v=>v instanceof a.$hP,k.TypeHierarchyItem.from),y.TestItem=new y("testItem","A VS Code TestItem",v=>v instanceof m.$cQ,k.TestItem.from);class T{constructor(f,N){this.description=f,this.convert=N}}e.$oQ=T,T.Void=new T("no result",v=>v);class C{constructor(f,N,F,j,z){this.id=f,this.internalId=N,this.description=F,this.args=j,this.result=z}}e.$pQ=C}),define(Se[367],De([1,0,19,15,2,88,144,36,35,16,8]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=void 0,A=Ue(A),c=Ue(c),I=Ue(I);const S=[new p.$pQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to an array of DocumentHighlight-instances.",P(c.DocumentHighlight.to))),new p.$pQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$nQ.Uri],new p.$oQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,m)=>{if((0,r.$Nb)(l))return;class g extends I.$QN{static to(n){const o=new g(n.name,c.SymbolKind.to(n.kind),n.containerName||"",new I.$JN(m[0],c.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=c.Range.to(n.selectionRange),o.children=n.children?n.children.map(g.to):[],o}}return l.map(g.to)})),new p.$pQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$nQ.Uri,new p.$nQ("options","Formatting options",l=>!0,l=>l)],new p.$oQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$pQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$nQ.Uri,p.$nQ.Range,new p.$nQ("options","Formatting options",l=>!0,l=>l)],new p.$oQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$pQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$nQ.Uri,p.$nQ.Position,new p.$nQ("ch","Trigger character",l=>typeof l=="string",l=>l),new p.$nQ("options","Formatting options",l=>!0,l=>l)],new p.$oQ("A promise that resolves to an array of TextEdits.",P(c.TextEdit.to))),new p.$pQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$pQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$pQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$pQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$pQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to an array of Location-instances.",P(c.location.to))),new p.$pQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to an array of Hover-instances.",P(c.Hover.to))),new p.$pQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$nQ.Uri,new p.$nQ("position","A position in a text document",l=>Array.isArray(l)&&l.every(m=>I.$yN.isPosition(m)),l=>l.map(c.Position.from))],new p.$oQ("A promise that resolves to an array of ranges.",l=>l.map(m=>{let g;for(const $ of m.reverse())g=new I.$UN(c.Range.to($),g);return g}))),new p.$pQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$nQ.String.with("query","Search string")],new p.$oQ("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(c.WorkspaceSymbol.to))),new p.$pQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(c.CallHierarchyItem.to))),new p.$pQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$nQ.CallHierarchyItem],new p.$oQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(c.CallHierarchyIncomingCall.to))),new p.$pQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$nQ.CallHierarchyItem],new p.$oQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(c.CallHierarchyOutgoingCall.to))),new p.$pQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:c.Range.to(l.range),placeholder:l.text}})),new p.$pQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$nQ.Uri,p.$nQ.Position,p.$nQ.String.with("newName","The new symbol name")],new p.$oQ("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return c.WorkspaceEdit.to(l)}})),new p.$pQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$nQ.Uri,p.$nQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$oQ("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(c.DocumentLink.to))),new p.$pQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$nQ.Uri],new p.$oQ("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.$QO(l.tokenTypes,l.tokenModifiers)})),new p.$pQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$nQ.Uri],new p.$oQ("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const m=(0,O.$Ndb)(l);if(m.type==="full")return new I.$SO(m.data,void 0)})),new p.$pQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$nQ.Uri,p.$nQ.Range.optional()],new p.$oQ("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.$QO(l.tokenTypes,l.tokenModifiers)})),new p.$pQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$nQ.Uri,p.$nQ.Range],new p.$oQ("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const m=(0,O.$Ndb)(l);if(m.type==="full")return new I.$SO(m.data,void 0)})),new p.$pQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$nQ.Uri,p.$nQ.Position,p.$nQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$nQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$oQ("A promise that resolves to a CompletionList-instance.",(l,m,g)=>{if(!l)return new I.$7N([]);const $=l.suggestions.map(n=>c.CompletionItem.to(n,g));return new I.$7N($,l.incomplete)})),new p.$pQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$nQ.Uri,p.$nQ.Position,p.$nQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$oQ("A promise that resolves to SignatureHelp.",l=>{if(l)return c.SignatureHelp.to(l)})),new p.$pQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$nQ.Uri,p.$nQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$oQ("A promise that resolves to an array of CodeLens-instances.",(l,m,g)=>P($=>new I.$YN(c.Range.to($.range),$.command&&g.fromInternal($.command)))(l))),new p.$pQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$nQ.Uri,new p.$nQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>I.$zN.isRange(l),l=>I.$AN.isSelection(l)?c.Selection.from(l):c.Range.from(l)),p.$nQ.String.with("kind","Code action kind to return code actions for").optional(),p.$nQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$oQ("A promise that resolves to an array of Command-instances.",(l,m,g)=>P($=>{if($._isSynthetic){if(!$.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal($.command)}else{const n=new I.$SN($.title,$.kind?new I.$TN($.kind):void 0);return $.edit&&(n.edit=c.WorkspaceEdit.to($.edit)),$.command&&(n.command=g.fromInternal($.command)),n.isPreferred=$.isPreferred,n}})(l))),new p.$pQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$nQ.Uri],new p.$oQ("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(m=>new I.$aO(c.Range.to(m.range),c.Color.to(m.color))):[])),new p.$pQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$nQ("color","The color to show and insert",l=>l instanceof I.$_N,c.Color.from),new p.$nQ("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:c.Range.from(l.range)}))],new p.$oQ("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(c.ColorPresentation.to):[])),new p.$pQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$nQ.Uri,p.$nQ.Range],new p.$oQ("A promise that resolves to an array of Inlay objects",(l,m,g)=>l.map(c.InlayHint.to.bind(void 0,g)))),new p.$pQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$nQ.Uri],new p.$oQ("A promise that resolves to an array of FoldingRange objects",(l,m)=>{if(l)return l.map(c.FoldingRange.to)})),new p.$pQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$oQ("A promise that resolves to an array of NotebookContentProvider static info objects.",P(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(m=>c.NotebookExclusiveDocumentPattern.to(m))})))),new p.$pQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$nQ.Uri,p.$nQ.Range,new p.$nQ("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof I.$zN,l=>c.InlineValueContext.from(l))],new p.$oQ("A promise that resolves to an array of InlineValue objects",l=>l.map(c.InlineValue.to))),new p.$pQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$nQ("uriOrString","Uri-instance or string (only http/https)",l=>k.URI.isUri(l)||typeof l=="string"&&(0,a.$Qg)(l,a.Schemas.http,a.Schemas.https),l=>l),new p.$nQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[c.ViewColumn.from(l),void 0]:[c.ViewColumn.from(l.viewColumn),c.TextEditorOpenOptions.from(l)])).optional(),p.$nQ.String.with("label","").optional()],p.$oQ.Void),new p.$pQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$nQ.Uri.with("resource","Resource to open"),p.$nQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$nQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[c.ViewColumn.from(l),void 0]:[c.ViewColumn.from(l.viewColumn),c.TextEditorOpenOptions.from(l)])).optional()],p.$oQ.Void),new p.$pQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$nQ.Uri.with("left","Left-hand side resource of the diff editor"),p.$nQ.Uri.with("right","Right-hand side resource of the diff editor"),p.$nQ.String.with("title","Human readable title for the diff editor").optional(),new p.$nQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[c.ViewColumn.from(l.viewColumn),c.TextEditorOpenOptions.from(l)]).optional()],p.$oQ.Void),new p.$pQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$nQ.String.with("title","Human readable title for the changes editor"),new p.$nQ("resourceList","List of resources to compare",l=>{for(const m of l){if(m.length!==3)return!1;const[g,$,n]=m;if(!k.URI.isUri(g)||!k.URI.isUri($)&&$!==void 0&&$!==null||!k.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},l=>l)],p.$oQ.Void),new p.$pQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$nQ.Uri,p.$nQ.Position],new p.$oQ("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(c.TypeHierarchyItem.to))),new p.$pQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$nQ.TypeHierarchyItem],new p.$oQ("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(c.TypeHierarchyItem.to))),new p.$pQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$nQ.TypeHierarchyItem],new p.$oQ("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(c.TypeHierarchyItem.to))),new p.$pQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$nQ.TestItem],p.$oQ.Void),new p.$pQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$nQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$oQ.Void),new p.$pQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$nQ.String.with("name","The context key name"),new p.$nQ("value","The context key value",()=>!0,l=>l)],p.$oQ.Void),new p.$pQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$nQ.Uri,p.$nQ.StringArray,new p.$nQ("MappedEditsContext","Mapped Edits Context",l=>c.MappedEditsContext.is(l),l=>c.MappedEditsContext.from(l))],new p.$oQ("A promise that resolves to a workspace edit or null",l=>l?c.WorkspaceEdit.to(l):null)),new p.$pQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$nQ("Run arguments","",l=>!0,l=>{if(l)return{initialRange:l.initialRange?c.Range.from(l.initialRange):void 0,initialSelection:I.$AN.isSelection(l.initialSelection)?c.Selection.from(l.initialSelection):void 0,message:l.message,autoSend:l.autoSend,position:l.position?c.Position.from(l.position):void 0}})],p.$oQ.Void)];class h{static register(m){S.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",R.$Fj)}}e.$Goc=h;function P(l){return m=>{if(Array.isArray(m))return m.map(l)}}function w(l){if(!Array.isArray(l))return;const m=[];for(const g of l)A.$Ju(g)?m.push(c.DefinitionLink.to(g)):m.push(c.location.to(g));return m}}),define(Se[368],De([1,0,2,35]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;class k{constructor(O,R,p,c,I){this.a=R,this.b=p,this.c=c;const S=new a.$pQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new a.$nQ("showOptions","Show Options",h=>!0,h=>h),new a.$nQ("resource","Interactive resource Uri",h=>!0,h=>h),new a.$nQ("controllerId","Notebook controller Id",h=>!0,h=>h),new a.$nQ("title","Interactive editor title",h=>!0,h=>h)],new a.$oQ("Notebook and input URI",h=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const P=this.a.getEditorById(h.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",P.id),{notebookUri:r.URI.revive(h.notebookUri),inputUri:r.URI.revive(h.inputUri),notebookEditor:P.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:r.URI.revive(h.notebookUri),inputUri:r.URI.revive(h.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(O,R,p,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:p,uri:O,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(O,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[O]})}}e.$8pc=k}),define(Se[369],De([1,0,19,7,21,4,3,29,2,24,12,6,35,16,8,123,311,26,52,312]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=void 0,e.$eqc=b,P=Ue(P);let o=class{constructor(D,y,T,C,v){this.m=y,this.n=T,this.o=C,this.q=v,this.b=new R.$Dc,this.c=new R.$Dc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$ne,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(S.$vN.MainThreadNotebookKernels);const f=new h.$pQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new h.$nQ("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const j=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:j}}else if(F&&"notebookEditor"in F){const j=this.n.getIdByEditor(F.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return F})],h.$oQ.Void),N=new h.$pQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[h.$nQ.Uri],new h.$oQ("A promise that resolves to an array of variables",(F,j)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(f),this.o.registerApiCommand(N)}createNotebookController(D,y,T,C,v,f){for(const Z of this.j.values())if(Z.controller.id===y&&c.$sn.equals(D.identifier,Z.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const N=this.k++,F=this;this.q.trace(`NotebookController[${N}], CREATED by ${D.identifier.value}, ${y}`);const j=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${D.identifier}'`);let z=!1;const M=new A.$ne,L=new A.$ne,B={id:b(D.identifier,y),notebookType:T,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:C||D.identifier.value,preloads:f?f.map(P.NotebookRendererScript.from):[]};let W=v??j,ae,q;this.a.$addKernel(N,B).catch(Z=>{console.log(Z),z=!0});let K=0;const ee=()=>{if(z)return;const Z=++K;Promise.resolve().then(()=>{Z===K&&this.a.$updateKernel(N,B)})},re=new R.$Dc,ge={get id(){return y},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return B.label},set label(Z){B.label=Z??D.displayName??D.name,ee()},get detail(){return B.detail??""},set detail(Z){B.detail=Z,ee()},get description(){return B.description??""},set description(Z){B.description=Z,ee()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(Z){B.supportedLanguages=Z,ee()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){B.supportsExecutionOrder=Z,ee()},get rendererScripts(){return B.preloads?B.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(Z){W=Z??j},get interruptHandler(){return ae},set interruptHandler(Z){ae=Z,B.supportsInterrupt=!!Z,ee()},set variableProvider(Z){(0,g.$8G)(D,"notebookVariableProvider"),q=Z,B.hasVariableProvider=!!Z,Z?.onDidChangeVariables($e=>F.a.$variablesUpdated($e.uri)),ee()},get variableProvider(){return q},createNotebookCellExecution(Z){if(z)throw new Error("notebook controller is DISPOSED");if(!re.has(Z.notebook.uri))throw F.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return F._createNotebookCellExecution(Z,b(D.identifier,this.id))},createNotebookExecution(Z){if((0,g.$8G)(D,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!re.has(Z.uri))throw F.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.uri.toString()}`);return F._createNotebookExecution(Z,b(D.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${N}], DISPOSED`),z=!0,this.j.delete(N),M.dispose(),L.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(Z,$e){$e===w.NotebookControllerAffinity2.Hidden&&(0,g.$8G)(D,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(N,Z.uri,$e)},onDidReceiveMessage:L.event,postMessage(Z,$e){return(0,g.$8G)(D,"notebookMessaging"),F.a.$postMessage(N,$e&&F.n.getIdByEditor($e),Z)},asWebviewUri(Z){return(0,g.$8G)(D,"notebookMessaging"),(0,l.$qDb)(Z,F.m.remote)}};return this.j.set(N,{extensionId:D.identifier,controller:ge,onDidReceiveMessage:L,onDidChangeSelection:M,associatedNotebooks:re}),ge}getIdByController(D){for(const[y,T]of this.j)if(T.controller===D)return b(T.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const T=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${T}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(T,y);const v={dispose:()=>{this.f.delete(T),C.a.$removeKernelDetectionTask(T)}};return this.f.set(T,v),v}registerKernelSourceActionProvider(D,y,T){const C=this.i++,v=typeof T.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,f=this;this.h.set(C,T),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,y);let N;return v!==void 0&&(N=T.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.h.delete(C),f.a.$removeKernelSourceActionProvider(C,C),N?.dispose()}}}async $provideKernelSourceActions(D,y){const T=this.h.get(D);if(T){const C=new O.$Wc;return(await T.provideNotebookKernelSourceActions(y)??[]).map(f=>P.NotebookKernelSourceAction.from(f,this.o.converter,C))}return[]}$acceptNotebookAssociation(D,y,T){const C=this.j.get(D);if(C){const v=this.n.getNotebookDocument(p.URI.revive(y));T?C.associatedNotebooks.set(v.uri,!0):C.associatedNotebooks.delete(v.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,v.uri.toString(),T),C.onDidChangeSelection.fire({selected:T,notebook:v.apiNotebook})}}async $executeCells(D,y,T){const C=this.j.get(D);if(!C)return;const v=this.n.getNotebookDocument(p.URI.revive(y)),f=[];for(const N of T){const F=v.getCell(N);F&&f.push(F.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,v.uri.toString(),f.length),await C.controller.executeHandler.call(C.controller,f,v.apiNotebook,C.controller)}catch(N){this.q.error(`NotebookController[${D}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(D,y,T){const C=this.j.get(D);if(!C)return;const v=this.n.getNotebookDocument(p.URI.revive(y));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,v.apiNotebook);else for(const f of T){const N=v.getCell(f);N&&this.b.get(N.uri)?.cancel()}if(C.controller.interruptHandler){const f=this.c.get(v.uri);this.c.delete(v.uri),T.length&&Array.isArray(f)&&f.length&&f.forEach(N=>N.dispose())}}async $provideVariables(D,y,T,C,v,f,N){const F=this.j.get(D);if(!F)return;const j=this.n.getNotebookDocument(p.URI.revive(T)),z=F.controller.variableProvider;if(!z)return;let M;if(C!==void 0){if(M=this.s[C],!M)return}else this.s={};const L=v==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(j.apiNotebook,M,L,f,N);let W=0;for await(const ae of B){if(N.isCancellationRequested)return;const q={id:this.r++,name:ae.variable.name,value:ae.variable.value,type:ae.variable.type,interfaces:ae.variable.interfaces,language:ae.variable.language,expression:ae.variable.expression,hasNamedChildren:ae.hasNamedChildren,indexedChildrenCount:ae.indexedChildrenCount,extensionId:F.extensionId.value};if(this.s[q.id]=ae.variable,this.a.$receiveVariable(y,q),W++>=n.$NK)return}}$acceptKernelMessageFromRenderer(D,y,T){const C=this.j.get(D);if(!C)return;const v=this.n.getEditorById(y);C.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:T}))}$cellExecutionChanged(D,y,T){const v=this.n.getNotebookDocument(p.URI.revive(D)).getCell(y);if(v){const f=T?P.NotebookCellExecutionState.to(T):w.NotebookCellExecutionState.Idle;f!==void 0&&this.l.fire({cell:v.apiCell,state:f})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const v=new i(y,C,this.a);this.b.set(C.uri,v);const f=v.onDidChangeState(()=>{v.state===t.Resolved&&(v.dispose(),f.dispose(),this.b.delete(C.uri))});return v.asApiObject()}_createNotebookExecution(D,y){const T=this.n.getNotebookDocument(D.uri),C=D.getCells().find(N=>{const F=T.getCellFromApiCell(N);return F&&this.b.has(F.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(T.uri))throw new Error(`duplicate notebook execution for ${T.uri}`);const v=new d(y,T,this.a),f=v.onDidChangeState(()=>{v.state===s.Resolved&&(v.dispose(),f.dispose(),this.c.delete(T.uri))});return this.c.set(T.uri,[v,f]),v.asApiObject()}};e.$dqc=o,e.$dqc=o=Ye([Ve(4,I.$ak)],o);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class i extends O.$Xc{get state(){return this.f}constructor(D,y,T){super(),this.m=y,this.n=T,this.b=i.a++,this.c=new A.$ne,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new k.$ye),this.h=new u(10,C=>this.s(C)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new $.$Vw(y))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const T=w.$4O.ensureUniqueMimeTypes(y.items,!0);return T===y.items?P.NotebookCellOutput.from(y):P.NotebookCellOutput.from({items:T,id:y.id,metadata:y.metadata})})}async z(D,y,T){const C=this.w(y),v=this.y((0,r.$5b)(D));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:C,append:T,outputs:v})}async C(D,y,T){return D=w.$4O.ensureUniqueMimeTypes((0,r.$5b)(D),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:D.map(P.NotebookCellOutputItem.from),outputId:y.id,append:T})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(T){D.j=T,D.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(T){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:T})},end(T,C,v){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const f=v?{message:v.message,stack:v.stack,location:v?.location?{startLineNumber:v.location.start.line,startColumn:v.location.start.character,endLineNumber:v.location.end.line,endColumn:v.location.end.character}:void 0,uri:v.uri}:void 0;D.n.$completeExecution(D.b,new $.$Vw({runEndTime:C,lastRunSuccess:T,error:f}))},clearOutput(T){return D.t(),D.z([],T,!1)},appendOutput(T,C){return D.t(),D.z(T,C,!0)},replaceOutput(T,C){return D.t(),D.z(T,C,!1)},appendOutputItems(T,C){return D.t(),D.C(T,C,!0)},replaceOutputItems(T,C){return D.t(),D.C(T,C,!1)}})}}i.a=0;var s;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(s||(s={}));class d extends O.$Xc{get state(){return this.f}constructor(D,y,T){super(),this.h=y,this.j=T,this.b=d.a++,this.c=new A.$ne,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new k.$ye),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}d.a=0;class u{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new a.$4h,this.b=Date.now(),(0,a.$Hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function b(E,D){return`${E.value}/${D}`}}),define(Se[48],De([1,0,4,6,5,2,20,3,8,242,14,291,21,33,292,293,50,7,16,35,41]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=e.$kpc=e.$jpc=e.$ipc=void 0,e.$ipc=(0,k.$Gi)("IExtHostTerminalService");class t extends R.$Xc{constructor(v,f,N,F){super(),this.u=v,this._id=f,this.w=N,this.y=F,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$ne),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(z=>this.g=z);const j=this;this.value={get name(){return j.y||""},get processId(){return j.b},get creationOptions(){return j.w},get exitStatus(){return j.j},get state(){return j.m},get selection(){return j.n},get shellIntegration(){return j.shellIntegration},sendText(z,M=!0){j.C(),j.u.$sendText(j._id,z,M)},show(z){j.C(),j.u.$show(j._id,z)},hide(){j.C(),j.u.$hide(j._id)},dispose(){j.a||(j.a=!0,j.u.$dispose(j._id))},get dimensions(){if(!(j.f===void 0||j.h===void 0))return{columns:j.f,rows:j.h}}}}dispose(){this.s.fire(),super.dispose()}async create(v,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??f?.cwd??void 0,env:v.env??void 0,icon:D(v.iconPath)??void 0,color:m.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,forceShellIntegration:f?.forceShellIntegration??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.z(v.location,f?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,f,N,F,j){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:F,color:m.ThemeColor.isThemeColor(j)?j.id:void 0,location:f?.location||this.z(v,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(v,f){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in v?{viewColumn:$.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.y=v}setExitStatus(v,f){this.j=Object.freeze({code:v,reason:f})}setDimensions(v,f){return v===this.f&&f===this.h||v===0||f===0?!1:(this.f=v,this.h=f,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(v){this.n=v}_setProcessId(v){this.g?(this.g(v),this.g=void 0):this.b.then(f=>{f!==v&&(this.b=Promise.resolve(v))})}}e.$jpc=t;class i{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new r.$ne,this.onProcessData=this.a.event,this.b=new r.$ne,this.d=new r.$ne,this.onDidChangeProperty=this.d.event,this.f=new r.$ne,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,f){this.g.setDimensions?.({columns:v,rows:f})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:w.ProcessPropertyType.OverrideDimensions,value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:w.ProcessPropertyType.Title,value:f})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,d=class extends R.$Xc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,f,N){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new R.$Yc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$ne,this.onDidCloseTerminal=this.H.event,this.I=new r.$ne,this.onDidOpenTerminal=this.I.event,this.J=new r.$ne,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$ne,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$ne,this.onDidChangeTerminalState=this.M.event,this.N=new r.$ne,this.onDidChangeShell=this.N.event,this.O=new r.$ne({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$ne({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=N.getProxy(a.$vN.MainThreadTerminalService),this.y=new l.$Jxb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:F=>{const j=z=>{const M=z;return this.getTerminalById(M.instanceId)?.value};switch(F?.$mid){case o.MarshalledId.TerminalContext:return j(F);default:{if(Array.isArray(F))for(let z=0;z<F.length&&F[z].$mid===o.MarshalledId.TerminalContext;z++)F[z]=j(F[z]);return F}}}}),this.B({dispose:()=>{for(const[F,j]of this.g)j.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,f){const N=new t(this.a,(0,P.$3g)(),v,v.name),F=new i(v.pty);return N.createExtensionTerminal(v.location,f,this.R(v,f).resolvedExtHostIdentifier,D(v.iconPath),y(v.color)).then(j=>{const z=this.S(j,F);this.h[j]=z}),this.f.push(N),N.value}R(v,f){if(f=f||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const N=v.location.parentTerminal;if(N){const F=this.f.find(j=>j.value===N);F&&(f.resolvedExtHostIdentifier=F._id)}}else v.location&&typeof v.location!="object"?f.location=v.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(v,f){if(!this.getTerminalById(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const F=new i(f),j=this.S(v,F);this.h[v]=j}async $acceptActiveTerminalChanged(v){const f=this.b;if(v===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const N=this.getTerminalById(v);N&&(this.b=N,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,f){const N=this.getTerminalById(v);N&&this.O.fire({terminal:N.value,data:f})}async $acceptTerminalDimensions(v,f,N){const F=this.getTerminalById(v);F&&F.setDimensions(f,N)&&this.L.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptDidExecuteCommand(v,f){const N=this.getTerminalById(v);N&&this.P.fire({terminal:N.value,...f})}async $acceptTerminalMaximumDimensions(v,f,N){this.g.get(v)?.resize(f,N)}async $acceptTerminalTitleChange(v,f){const N=this.getTerminalById(v);N&&(N.name=f)}async $acceptTerminalClosed(v,f,N){const F=this.X(this.f,v);if(F!==null){const j=this.f.splice(F,1)[0];j.setExitStatus(f,N),this.H.fire(j.value)}}$acceptTerminalOpened(v,f,N,F){if(f){const M=this.X(this.f,f);if(M!==null){this.f[M]._id=v,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const j={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:A.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},z=new t(this.a,v,j,N);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(v,f){this.getTerminalById(v)?._setProcessId(f)}async $startExtensionTerminal(v,f){const N=this.getTerminalById(v);if(!N)return{message:(0,c.localize)(0,null,v)};N.isOpen||await new Promise(j=>{const z=this.onDidOpenTerminal(async M=>{M===N.value&&(z.dispose(),j())})});const F=this.g.get(v);F?F.startSendingEvents(f):this.j[v]={initialDimensions:f}}S(v,f){const N=new R.$Wc;N.add(f.onProcessReady(j=>this.a.$sendProcessReady(v,j.pid,j.cwd,j.windowsPty))),N.add(f.onDidChangeProperty(j=>this.a.$sendProcessProperty(v,j))),this.y.startBuffering(v,f.onProcessData),N.add(f.onProcessExit(j=>this.U(v,j))),this.g.set(v,f);const F=this.j[v];return F&&f instanceof i&&(f.startSendingEvents(F.initialDimensions),delete this.j[v]),N}$acceptProcessAckDataEvent(v,f){this.g.get(v)?.acknowledgeDataEvent(f)}$acceptProcessInput(v,f){this.g.get(v)?.input(f)}$acceptTerminalInteraction(v){const f=this.getTerminalById(v);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection(v,f){this.getTerminalById(v)?.setSelection(f)}$acceptProcessResize(v,f,N){try{this.g.get(v)?.resize(f,N)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(v,f){this.g.get(v)?.shutdown(f)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(v,{type:w.ProcessPropertyType.InitialCwd,value:f}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(f=>this.a.$sendProcessProperty(v,{type:w.ProcessPropertyType.Cwd,value:f}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new p.$xN(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,f,N){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,N),this.a.$registerProfileProvider(f,v.identifier.value),new p.$xN(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(v,f,N){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,N),this.a.$registerQuickFixProvider(v,f),new p.$xN(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,f){const N=new h.$ye().token;if(N.isCancellationRequested)return;const F=this.D.get(v);if(!F)return;const j=await F.provideTerminalQuickFixes(f,N);if(j===null||Array.isArray(j)&&j.length===0)return;const z=new R.$Wc;if(this.w.value=z,!Array.isArray(j))return j?$.TerminalQuickFix.from(j,this.Q.converter,z):void 0;const M=[];for(const L of j){const B=$.TerminalQuickFix.from(L,this.Q.converter,z);B&&M.push(B)}return M}async $createContributedProfileTerminal(v,f){const N=new h.$ye().token;let F=await this.C.get(v)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,f);return}this.createTerminalFromOptions(F.options,f)}}async $provideLinks(v,f){const N=this.getTerminalById(v);if(!N)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const j=new h.$ye;this.G.set(v,j);const z=[],M={terminal:N.value,line:f},L=[];for(const ae of this.z)L.push(g.Promises.withAsyncBody(async q=>{j.token.onCancellationRequested(()=>q({provider:ae,links:[]}));const K=await ae.provideTerminalLinks(M,j.token)||[];j.token.isCancellationRequested||q({provider:ae,links:K})}));const B=await Promise.all(L);if(j.token.isCancellationRequested)return[];const W=new Map;for(const ae of B)ae&&ae.links.length>0&&z.push(...ae.links.map(q=>{const K={id:s++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return W.set(K.id,{provider:ae.provider,link:q}),K}));return this.F.set(v,W),z}$activateLink(v,f){const N=this.F.get(v)?.get(f);N&&N.provider.handleTerminalLink(N.link)}U(v,f){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const N=this.h[v];N&&(N.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,f)}getTerminalById(v){return this.W(this.f,v)}getTerminalIdByApiObject(v){const f=this.f.findIndex(N=>N.value===v);return f>=0?f:null}W(v,f){const N=this.X(v,f);return N!==null?v[N]:null}X(v,f){const N=v.findIndex(F=>F._id===f);return N>=0?N:null}getEnvironmentVariableCollection(v){let f=this.n.get(v.identifier.value);return f||(f=this.B(new u),this.Z(v.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Y(v,f){const N=(0,S.$Es)(f.map),F=(0,S.$Fs)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(v,f.persistent,N.length===0?void 0:N,F)}$initEnvironmentVariableCollections(v){v.forEach(f=>{const N=f[0],F=this.B(new u(f[1]));this.Z(N,F)})}$acceptDefaultProfile(v,f){const N=this.s;this.s=v,this.u=f,N?.path!==v.path&&this.N.fire(v.path)}Z(v,f){this.n.set(v,f),this.B(f.onDidChangeCollection(()=>{this.Y(v,f)}))}};e.$kpc=d,e.$kpc=d=Ye([Ve(1,n.$lQ),Ve(2,O.$2P)],d);class u extends R.$Xc{get persistent(){return this.b}set persistent(v){this.b=v,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(v){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$ne,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const f=this.j(v);let N=this.a.get(f);return N||(N=new b(this,v),this.a.set(f,N),this.B(N.onDidChangeCollection(()=>this.f.fire()))),N}replace(v,f,N,F){this.g(v,{value:f,type:p.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:F})}append(v,f,N,F){this.g(v,{value:f,type:p.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:F})}prepend(v,f,N,F){this.g(v,{value:f,type:p.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:F})}g(v,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.h(v,f.scope),F=this.map.get(N),j=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!F||F.value!==f.value||F.type!==f.type||F.options?.applyAtProcessCreation!==j.applyAtProcessCreation||F.options?.applyAtShellIntegration!==j.applyAtShellIntegration||F.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const z=this.h(v,f.scope),M={variable:v,...f,options:j};this.map.set(z,M),this.f.fire()}}get(v,f){const N=this.h(v,f),F=this.map.get(N);return F?T(F):void 0}h(v,f){const N=this.j(f);return N.length?`${v}:::${N}`:v}j(v){return this.m(v?.workspaceFolder)??""}m(v){return v?v.uri.toString():void 0}getVariableMap(v){const f=new Map;for(const[N,F]of this.map)this.j(F.scope)===this.j(v)&&f.set(F.variable,T(F));return f}delete(v,f){const N=this.h(v,f);this.map.delete(N),this.f.fire()}clear(v){if(v?.workspaceFolder){for(const[f,N]of this.map)N.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(f);this.n(v)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(v,f){const N=this.j(f),F=this.descriptionMap.get(N);if(!F||F.description!==v){let j;typeof v=="string"?j=v:j=v?.value.split(`

`)[0];const z={description:j,scope:f};this.descriptionMap.set(N,z),this.f.fire()}}getDescription(v){const f=this.j(v);return this.descriptionMap.get(f)?.description}n(v){const f=this.j(v);this.descriptionMap.delete(f)}}class b{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,f){this.b=v,this.d=f,this.a=new r.$ne}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,f,N){this.b.replace(v,f,N,this.d)}append(v,f,N){this.b.append(v,f,N,this.d)}prepend(v,f,N){this.b.prepend(v,f,N,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,f){this.b.getVariableMap(this.d).forEach((N,F)=>v.call(f,F,N,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends d{constructor(v,f){super(!1,v,f)}createTerminal(v,f,N){throw new I.$cb}createTerminalFromOptions(v,f){throw new I.$cb}};e.$lpc=E,e.$lpc=E=Ye([Ve(0,n.$lQ),Ve(1,O.$2P)],E);function D(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function y(C){return m.ThemeColor.isThemeColor(C)?C:void 0}function T(C){const v={...C};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Se[168],De([1,0,8,3,5,6,20,48,4,2,7]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=e.$vqc=void 0,e.$vqc=(0,k.$Gi)("IExtHostTerminalShellIntegration");let S=class extends a.$Xc{constructor(m,g){super(),this.h=g,this.b=new Map,this.c=new p.$ne,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$ne,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$ne,this.onDidEndTerminalShellExecution=this.g.event,this.a=m.getProxy(A.$vN.MainThreadTerminalShellIntegration),this.B((0,a.$Vc)(()=>{for(const[$,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(m){const g=this.h.getTerminalById(m);if(!g)return;const $=g.value;let n=this.b.get(m);n||(n=new h(g.value,this.f),this.b.set(m,n),n.store.add(g.onWillDispose(()=>this.b.get(m)?.dispose())),n.store.add(n.onDidRequestShellExecution(o=>this.a.$executeCommand(m,o))),n.store.add(n.onDidRequestEndExecution(o=>this.g.fire(o))),n.store.add(n.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),g.shellIntegration=n.value),this.c.fire({terminal:$,shellIntegration:n.value})}$shellExecutionStart(m,g,$,n,o){this.b.has(m)||this.$shellIntegrationChange(m);const t={value:g,confidence:$,isTrusted:n};this.b.get(m)?.startShellExecution(t,o)}$shellExecutionEnd(m,g,$,n,o){const t={value:g,confidence:$,isTrusted:n};this.b.get(m)?.endShellExecution(t,o)}$shellExecutionData(m,g){this.b.get(m)?.emitData(g)}$cwdChange(m,g){this.b.get(m)?.setCwd((0,c.$yc)(g)?c.URI.revive(g):g)}$closeTerminal(m){this.b.get(m)?.dispose(),this.b.delete(m)}};e.$wqc=S,e.$wqc=S=Ye([Ve(0,O.$2P),Ve(1,R.$ipc)],S);class h extends a.$Xc{get currentExecution(){return this.a}constructor(m,g){super(),this.j=m,this.m=g,this.b=!1,this.store=this.B(new a.$Wc),this.f=this.B(new p.$ne),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$ne),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$ne),this.onDidRequestEndExecution=this.h.event;const $=this;this.value={get cwd(){return $.c},executeCommand(n,o){let t=n;o&&(t+=` "${o.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),$.g.fire(t);const i={value:t,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},s=$.startShellExecution(i,$.c,!0).value;return $.b=!0,s}}}startShellExecution(m,g,$){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new P(m,g);$?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(m){this.currentExecution?.emitData(m)}endShellExecution(m,g){this.a&&(this.a.endExecution(m),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:g}),this.a=void 0)}setCwd(m){let g=!1;c.URI.isUri(this.c)?g=!c.URI.isUri(m)||this.c.toString()!==m.toString():this.c!==m&&(g=!0),g&&(this.c=m,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class P{constructor(m,g){this.c=m,this.cwd=g,this.b=!1;const $=this;this.value={get commandLine(){return $.c},get cwd(){return $.cwd},read(){return $.d()}}}d(){if(!this.a){if(this.b)return I.$7h.EMPTY;this.a=new w}return this.a.createIterable()}emitData(m){this.a?.emitData(m)}endExecution(m){m&&(this.c=m),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends a.$Xc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Fh);const m=this.a;return new I.$7h(async $=>{this.b.push($),await m.wait()})}emitData(m){for(const g of this.b)g.emitOne(m)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[169],De([1,0,66,14,134,16,8]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=e.$9P=void 0,A=Ue(A);class R{constructor(h,P,w){const l=R.c.nextId();h.$registerTextEditorDecorationType(P.identifier,l,A.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:l,dispose(){h.$removeTextEditorDecorationType(l)}})}}e.$9P=R,R.c=new k.$7P("TextEditorDecorationType");class p{constructor(h,P){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=P.undoStopBefore,this.f=P.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,P){this.k();let w=null;if(h instanceof O.$yN)w=new O.$zN(h,h);else if(h instanceof O.$zN)w=h;else throw new Error("Unrecognized location");this.l(w,P,!1)}insert(h,P){this.k(),this.l(new O.$zN(h,h),P,!0)}delete(h){this.k();let P=null;if(h instanceof O.$zN)P=h;else throw new Error("Unrecognized location");this.l(P,null,!0)}l(h,P,w){const l=this.c.validateRange(h);this.g.push({range:l,text:P,forceMoveMarkers:w})}setEndOfLine(h){if(this.k(),h!==O.EndOfLine.LF&&h!==O.EndOfLine.CRLF)throw(0,a.$0)("endOfLine");this.h=h}}class c{constructor(h,P,w,l){this.c=h,this.d=P,this._accept(w),this.e=l;const m=this;this.value={get tabSize(){return m.f},set tabSize(g){m.n(g)},get indentSize(){return m.g},set indentSize(g){m.p(g)},get insertSpaces(){return m.j},set insertSpaces(g){m.s(g)},get cursorStyle(){return m.k},set cursorStyle(g){m.t(g)},get lineNumbers(){return m.l},set lineNumbers(g){m.u(g)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.originalIndentSize,this.j=h.insertSpaces,this.k=h.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(h.lineNumbers)}m(h){if(h==="auto")return"auto";if(typeof h=="number"){const P=Math.floor(h);return P>0?P:null}if(typeof h=="string"){const P=parseInt(h,10);return isNaN(P)?null:P>0?P:null}return null}n(h){const P=this.m(h);if(P!==null){if(typeof P=="number"){if(this.f===P)return;this.f=P}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:P}))}}o(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const P=Math.floor(h);return P>0?P:null}if(typeof h=="string"){const P=parseInt(h,10);return isNaN(P)?null:P>0?P:null}return null}p(h){const P=this.o(h);if(P!==null){if(typeof P=="number"){if(this.h===P)return;this.g=P,this.h=P}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:P}))}}q(h){return h==="auto"?"auto":h==="false"?!1:!!h}s(h){const P=this.q(h);if(typeof P=="boolean"){if(this.j===P)return;this.j=P}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:P}))}t(h){this.k!==h&&(this.k=h,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}u(h){this.l!==h&&(this.l=h,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(h)})))}assign(h){const P={};let w=!1;if(typeof h.tabSize<"u"){const l=this.m(h.tabSize);l==="auto"?(w=!0,P.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,w=!0,P.tabSize=l)}if(typeof h.indentSize<"u"){const l=this.o(h.indentSize);l==="tabSize"?(w=!0,P.indentSize=l):typeof l=="number"&&this.h!==l&&(this.g=l,this.h=l,w=!0,P.indentSize=l)}if(typeof h.insertSpaces<"u"){const l=this.q(h.insertSpaces);l==="auto"?(w=!0,P.insertSpaces=l):this.j!==l&&(this.j=l,w=!0,P.insertSpaces=l)}typeof h.cursorStyle<"u"&&this.k!==h.cursorStyle&&(this.k=h.cursorStyle,w=!0,P.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.l!==h.lineNumbers&&(this.l=h.lineNumbers,w=!0,P.lineNumbers=A.TextEditorLineNumbersStyle.from(h.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,P))}v(h,P){P.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(w)})}}e.$0P=c;class I{constructor(h,P,w,l,m,g,$,n){this.id=h,this.j=P,this.k=w,this.g=!1,this.h=new Set,this.c=m,this.d=new c(this.j,this.id,g,w),this.e=$,this.f=n;const o=this;this.value=Object.freeze({get document(){return l.value},set document(t){throw new a.$_("document")},get selection(){return o.c&&o.c[0]},set selection(t){if(!(t instanceof O.$AN))throw(0,a.$0)("selection");o.c=[t],o.l()},get selections(){return o.c},set selections(t){if(!Array.isArray(t)||t.some(i=>!(i instanceof O.$AN)))throw(0,a.$0)("selections");o.c=t,o.l()},get visibleRanges(){return o.e},set visibleRanges(t){throw new a.$_("visibleRanges")},get options(){return o.d.value},set options(t){o.g||o.d.assign(t)},get viewColumn(){return o.f},set viewColumn(t){throw new a.$_("viewColumn")},edit(t,i={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new p(l.value,i);return t(s),o.m(s)},insertSnippet(t,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!i||Array.isArray(i)&&i.length===0)d=o.c.map(u=>A.Range.from(u));else if(i instanceof O.$yN){const{lineNumber:u,column:b}=A.Position.from(i);d=[{startLineNumber:u,startColumn:b,endLineNumber:u,endColumn:b}]}else if(i instanceof O.$zN)d=[A.Range.from(i)];else{d=[];for(const u of i)if(u instanceof O.$zN)d.push(A.Range.from(u));else{const{lineNumber:b,column:E}=A.Position.from(u);d.push({startLineNumber:b,startColumn:E,endLineNumber:b,endColumn:E})}}return P.$tryInsertSnippet(h,l.value.version,t.value,d,s)},setDecorations(t,i){const s=i.length===0;s&&!o.h.has(t.key)||(s?o.h.delete(t.key):o.h.add(t.key),o.n(()=>{if(A.$YP(i))return P.$trySetDecorations(h,t.key,A.$ZP(i));{const d=new Array(4*i.length);for(let u=0,b=i.length;u<b;u++){const E=i[u];d[4*u]=E.start.line+1,d[4*u+1]=E.start.character+1,d[4*u+2]=E.end.line+1,d[4*u+3]=E.end.character+1}return P.$trySetDecorationsFast(h,t.key,d)}}))},revealRange(t,i){o.n(()=>P.$tryRevealRange(h,A.Range.from(t),i||O.TextEditorRevealType.Default))},show(t){P.$tryShowEditor(h,A.ViewColumn.from(t))},hide(){P.$tryHideEditor(h)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,r.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,r.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,r.ok)(!this.g),this.f=h}_acceptSelections(h){(0,r.ok)(!this.g),this.c=h}async l(){const h=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const P=h.finalize();if(P.edits.length===0&&!P.setEndOfLine)return Promise.resolve(!0);const w=P.edits.map(m=>m.range);w.sort((m,g)=>m.end.line===g.end.line?m.end.character===g.end.character?m.start.line===g.start.line?m.start.character-g.start.character:m.start.line-g.start.line:m.end.character-g.end.character:m.end.line-g.end.line);for(let m=0,g=w.length-1;m<g;m++){const $=w[m].end;if(w[m+1].start.isBefore($))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=P.edits.map(m=>({range:A.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,P.documentVersionId,l,{setEndOfLine:typeof P.setEndOfLine=="number"?A.EndOfLine.from(P.setEndOfLine):void 0,undoStopBefore:P.undoStopBefore,undoStopAfter:P.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,P=>(P instanceof Error&&P.name==="DISPOSED"||this.k.warn(P),null))}}e.$$P=I}),define(Se[64],De([1,0,66,4,3,2,5,6,165,20,169,16,12,29,15,40,49]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=e.$_P=void 0,r=Ue(r),S=Ue(S);class g{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let $=class{constructor(o,t){this.h=o,this.i=t,this.a=null,this.b=new Map,this.c=new P.$Dc,this.d=new a.$ne,this.e=new a.$ne,this.f=new a.$ne,this.g=new a.$ne,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const t=[],i=[],s=[];if(o.removedDocuments)for(const d of o.removedDocuments){const u=A.URI.revive(d),b=this.c.get(u);b?.unref()&&(this.c.delete(u),t.push(b.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const u=A.URI.revive(d.uri);let b=this.c.get(u);if(b&&u.scheme!==w.Schemas.vscodeNotebookCell&&u.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);b||(b=new g(new p.$5P(this.h.getProxy(R.$vN.MainThreadDocuments),u,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(u,b),i.push(b.value)),b.ref()}if(o.removedEditors)for(const d of o.removedEditors){const u=this.b.get(d);this.b.delete(d),u&&s.push(u)}if(o.addedEditors)for(const d of o.addedEditors){const u=A.URI.revive(d.documentUri);r.ok(this.c.has(u),`document '${u}' does not exist`),r.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const b=this.c.get(u).value,E=new I.$$P(d.id,this.h.getProxy(R.$vN.MainThreadTextEditors),this.i,new m.$X(()=>b.document),d.selections.map(S.Selection.to),d.options,d.visibleRanges.map(D=>S.Range.to(D)),typeof d.editorPosition=="number"?S.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,E)}o.newActiveEditor!==void 0&&(r.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,k.$Sc)(t),(0,k.$Sc)(s),o.removedDocuments&&this.e.fire(t),o.addedDocuments&&this.d.fire(i),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return l.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const t=this.b.get(this.a);return o?t:t?.value}allEditors(){return[...this.b.values()]}};e.$_P=$,e.$_P=$=Ye([Ve(0,c.$2P),Ve(1,h.$ak)],$),e.$aQ=(0,O.$Gi)("IExtHostDocumentsAndEditors")});var He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)},ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r};define(Se[99],De([1,0,7,22,21,4,80,60,3,41,18,33,5,12,6,35,64,20,167,16,8,314,74,122,75,26]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s,d,u){"use strict";var b,E,D,y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=e.$Fpc=e.$Epc=e.$Dpc=e.$Cpc=void 0,n=Ue(n);let C=0;const v=new WeakMap;e.$Cpc=(0,h.$Gi)("IExtHostTesting");let f=class extends p.$Xc{constructor(Z,$e,fe,oe){super(),this.C=$e,this.D=fe,this.F=oe,this.f=this.B(new A.$ne),this.g=new Map,this.w=this.B(new A.$ne),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=Z.getProxy(w.$vN.MainThreadTesting),this.m=new ae(this.h),this.j=new z(this.h,$e),fe.registerArgumentProcessor({processArgument:H=>{switch(H?.$mid){case c.MarshalledId.TestItemContext:{const ue=H,te=ue.tests[ue.tests.length-1].item.extId;return this.g.get(i.$UI.root(te))?.collection.tree.get(te)?.actual??(0,$.$bQ)(H)}case c.MarshalledId.TestMessageMenuArgs:{const{test:ue,message:te}=H,_=ue.item.extId;return{test:this.g.get(i.$UI.root(_))?.collection.tree.get(_)?.actual??(0,$.$bQ)({$mid:c.MarshalledId.TestItemContext,tests:[ue]}),message:n.TestMessage.to(te)}}default:return H}}}),fe.registerCommand(!1,"testing.getExplorerSelection",async()=>{const H=await fe.executeCommand(t.TestCommandId.GetExplorerSelection),ue=te=>{const _=this.g.get(i.$UI.root(te));if(_)return i.$UI.isRoot(te)?_.controller:_.collection.tree.get(te)?.actual};return{include:H?.include.map(ue).filter(I.$og)||[],exclude:H?.exclude.map(ue).filter(I.$og)||[]}})}createTestController(Z,$e,fe,oe){if(this.g.has($e))throw new Error(`Attempt to insert a duplicate controller with ID "${$e}"`);const H=new p.$Wc,ue=H.add(new $.$eQ($e,fe,this.F));ue.root.label=fe;const te=new Map,_=new Set,ne=this.h,le={items:ue.root.children,get label(){return fe},set label(ce){fe=ce,ue.root.label=ce,ne.$updateController($e,{label:fe})},get refreshHandler(){return oe},set refreshHandler(ce){oe=ce,ne.$updateController($e,{canRefresh:!!ce})},get id(){return $e},createRunProfile:(ce,me,we,Me,qe,ke)=>{let Ie=(0,R.$uj)(ce);for(;te.has(Ie);)Ie++;return new K(this.h,te,_,this.w.event,$e,Ie,ce,me,we,Me,qe,ke)},createTestItem(ce,me,we){return new $.$cQ($e,ce,me,we)},createTestRun:(ce,me,we=!0)=>this.j.createTestRun(Z,$e,ue,ce,me,we),invalidateTestResults:ce=>{if(ce===void 0)this.h.$markTestRetired(void 0);else{const me=ce instanceof Array?ce:[ce];this.h.$markTestRetired(me.map(we=>i.$UI.fromExtHostTestItem(we,$e).toString()))}},set resolveHandler(ce){ue.resolveHandler=ce},get resolveHandler(){return ue.resolveHandler},dispose:()=>{H.dispose()}};ne.$registerTestController($e,fe,!!oe),H.add((0,p.$Vc)(()=>ne.$unregisterTestController($e)));const J={controller:le,collection:ue,profiles:te,extension:Z,activeProfiles:_};return this.g.set($e,J),H.add((0,p.$Vc)(()=>this.g.delete($e))),H.add(ue.onDidGenerateDiff(ce=>ne.$publishDiff($e,ce.map(d.TestsDiffOp.serialize)))),le}createTestObserver(){return this.m.checkout()}async runTests(Z,$e=k.CancellationToken.None){const fe=M(Z);if(!fe)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const oe=this.g.get(fe.controllerId);if(!oe)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:Z.preserveFocus??!0,group:ee[fe.kind],targets:[{testIds:Z.include?.map(H=>i.$UI.fromExtHostTestItem(H,oe.collection.root.id).toString())??[oe.collection.root.id],profileId:fe.profileId,controllerId:fe.controllerId}],exclude:Z.exclude?.map(H=>H.id)},$e)}registerTestFollowupProvider(Z){return this.y.add(Z),{dispose:()=>{this.y.delete(Z)}}}$syncTests(){for(const{collection:Z}of this.g.values())Z.flushDiff();return Promise.resolve()}async $getCoverageDetails(Z,$e,fe){return(await this.j.getCoverageDetails(Z,$e,fe))?.map(n.TestCoverage.fromDetails)}async $disposeRun(Z){this.j.disposeTestRun(Z)}$configureRunProfile(Z,$e){this.g.get(Z)?.profiles.get($e)?.configureHandler?.()}$setDefaultRunProfiles(Z){const $e=new Map;for(const[fe,oe]of Object.entries(Z)){const H=this.g.get(fe);if(!H)continue;const ue=new Map,te=oe.filter(ne=>!H.activeProfiles.has(ne)),_=[...H.activeProfiles].filter(ne=>!oe.includes(ne));for(const ne of te)ue.set(ne,!0),H.activeProfiles.add(ne);for(const ne of _)ue.set(ne,!1),H.activeProfiles.delete(ne);ue.size&&$e.set(fe,ue)}this.w.fire($e)}async $refreshTests(Z,$e){await this.g.get(Z)?.controller.refreshHandler?.($e)}$publishTestResults(Z){this.results=Object.freeze(Z.map($e=>{const fe=n.TestResults.to($e);return v.set(fe,$e.id),fe}).concat(this.results).sort(($e,fe)=>fe.completedAt-$e.completedAt).slice(0,32)),this.f.fire()}async $expandTest(Z,$e){const fe=this.g.get(i.$UI.fromString(Z).controllerId)?.collection;fe&&(await fe.expand(Z,$e<0?1/0:$e),fe.flushDiff())}$acceptDiff(Z){this.m.applyDiff(Z.map($e=>d.TestsDiffOp.deserialize({asCanonicalUri:fe=>fe},$e)))}async $runControllerTests(Z,$e){return Promise.all(Z.map(fe=>this.G(fe,!1,$e)))}async $startContinuousRun(Z,$e){const fe=new k.$ye($e),oe=await Promise.all(Z.map(H=>this.G(H,!0,fe.token)));return!$e.isCancellationRequested&&!oe.some(H=>H.error)&&await new Promise(H=>$e.onCancellationRequested(H)),fe.dispose(!0),oe}async $provideTestFollowups(Z,$e){const fe=this.results.find(ue=>v.get(ue)===Z.resultId),oe=fe&&re(i.$UI.fromString(Z.extId),fe?.results);if(!oe)return[];let H=[];return await Promise.all([...this.y].map(async ue=>{try{const te=await ue.provideFollowup(fe,oe,Z.taskIndex,Z.messageIndex,$e);te&&(H=H.concat(te))}catch(te){this.C.error("Error thrown while providing followup for test message",te)}})),$e.isCancellationRequested?[]:H.map(ue=>{const te=C++;return this.z.set(te,ue),{title:ue.title,id:te}})}$disposeTestFollowups(Z){for(const $e of Z)this.z.delete($e)}$executeTestFollowup(Z){const $e=this.z.get(Z);return $e?this.D.executeCommand($e.command,...$e.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(Z){Z===void 0?this.j.cancelAllRuns():this.j.cancelRunById(Z)}getMetadataForRun(Z){for(const $e of this.j.trackers){const fe=$e.getTaskIdForRun(Z);if(fe)return{taskId:fe,runId:$e.id}}}async G(Z,$e,fe){const oe=this.g.get(Z.controllerId);if(!oe)return{};const{collection:H,profiles:ue,extension:te}=oe,_=ue.get(Z.profileId);if(!_)return{};const ne=Z.testIds.map(me=>H.tree.get(me)).filter(I.$og),le=Z.excludeExtIds.map(me=>oe.collection.tree.get(me)).filter(I.$og).filter(me=>ne.some(we=>we.fullId.compare(me.fullId)===i.TestPosition.IsChild));if(!ne.length)return{};const J=new o.$$O(ne.some(me=>me.actual instanceof $.$dQ)?void 0:ne.map(me=>me.actual),le.map(me=>me.actual),_,$e),ce=(0,d.$XI)(Z)&&this.j.prepareForMainThreadTestRun(te,J,L.fromInternal(Z,oe.collection),_,fe);try{return await _.runHandler(J,fe),{}}catch(me){return{error:String(me)}}finally{ce&&ce.hasRunningTasks&&!fe.isCancellationRequested&&await A.Event.toPromise(ce.onEnd)}}};e.$Dpc=f,e.$Dpc=f=Ye([Ve(0,g.$2P),Ve(1,P.$ak),Ve(2,l.$lQ),Ve(3,m.$aQ)],f);const N=1e4;var F;(function(ge){ge[ge.Running=0]="Running",ge[ge.Cancelling=1]="Cancelling",ge[ge.Ended=2]="Ended"})(F||(F={}));class j extends p.$Xc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(Z,$e,fe,oe,H,ue){super(),this.z=Z,this.C=$e,this.D=fe,this.F=oe,this.G=H,this.c=F.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$ne),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new k.$ye(ue));const te=this.B(new r.$Sh(()=>this.H(),N));this.B(this.j.token.onCancellationRequested(()=>te.schedule()));const _=new A.$ne;this.w=_.event,this.B((0,p.$Vc)(()=>{_.fire(),_.dispose()}))}getTaskIdForRun(Z){for(const[$e,{run:fe}]of this.g)if(fe===Z)return $e}cancel(){this.c===F.Running?(this.j.cancel(),this.c=F.Cancelling):this.c===F.Cancelling&&this.H()}async getCoverageDetails(Z,$e,fe){const[,oe]=i.$UI.fromString(Z).path,H=this.y.get(Z);if(!H)return[];const{report:ue,extIds:te}=H,_=this.g.get(oe);if(!_)throw new Error("unreachable: run task was not found");let ne;if($e&&ue instanceof o.$dP){const J=te.indexOf($e);if(J===-1)return[];ne=ue.fromTests[J]}return await(ne?this.F?.loadDetailedCoverageForTest?.(_.run,ue,ne,fe):this.F?.loadDetailedCoverage?.(_.run,ue,fe))??[]}createRun(Z){const $e=this.z.id,fe=this.z.controllerId,oe=(0,S.$3g)(),H=ne=>(le,...J)=>{if(te){this.D.warn(`Setting the state of test "${le.id}" is a no-op after the run ends.`);return}this.J(le),ne(le,...J)},ue=(ne,le)=>{const J=le instanceof Array?le.map(n.TestMessage.from):[n.TestMessage.from(le)];if(ne.uri&&ne.range){const ce={range:n.Range.from(ne.range),uri:ne.uri};for(const me of J)me.location=me.location||ce}this.C.$appendTestMessagesInRun($e,oe,i.$UI.fromExtHostTestItem(ne,fe).toString(),J)};let te=!1;const _={isPersisted:this.z.isPersisted,token:this.j.token,name:Z,onDidDispose:this.w,addCoverage:ne=>{if(te)return;const le=ne instanceof o.$dP?ne.fromTests:[];if(le.length){(0,u.$8G)(this.G,"attributableCoverage");for(const me of le)this.J(me)}const J=ne.uri.toString(),ce=new i.$UI([$e,oe,J]).toString();this.y.set(ce,{report:ne,extIds:le.map(me=>i.$UI.fromExtHostTestItem(me,fe).toString())}),this.C.$appendCoverage($e,oe,n.TestCoverage.fromFile(fe,ce,ne))},enqueued:H(ne=>{this.C.$updateTestStateInRun($e,oe,i.$UI.fromExtHostTestItem(ne,fe).toString(),d.TestResultState.Queued)}),skipped:H(ne=>{this.C.$updateTestStateInRun($e,oe,i.$UI.fromExtHostTestItem(ne,fe).toString(),d.TestResultState.Skipped)}),started:H(ne=>{this.C.$updateTestStateInRun($e,oe,i.$UI.fromExtHostTestItem(ne,fe).toString(),d.TestResultState.Running)}),errored:H((ne,le,J)=>{ue(ne,le),this.C.$updateTestStateInRun($e,oe,i.$UI.fromExtHostTestItem(ne,fe).toString(),d.TestResultState.Errored,J)}),failed:H((ne,le,J)=>{ue(ne,le),this.C.$updateTestStateInRun($e,oe,i.$UI.fromExtHostTestItem(ne,fe).toString(),d.TestResultState.Failed,J)}),passed:H((ne,le)=>{this.C.$updateTestStateInRun($e,oe,i.$UI.fromExtHostTestItem(ne,this.z.controllerId).toString(),d.TestResultState.Passed,le)}),appendOutput:(ne,le,J)=>{te||(J&&this.J(J),this.C.$appendOutputToRun($e,oe,a.$Pe.fromString(ne),le&&n.location.from(le),J&&i.$UI.fromExtHostTestItem(J,fe).toString()))},end:()=>{te||(te=!0,this.C.$finishedTestRunTask($e,oe),--this.f||this.I())}};return this.f++,this.g.set(oe,{run:_}),this.C.$startedTestRunTask($e,{id:oe,name:Z,running:!0}),_}H(){for(const{run:Z}of this.g.values())Z.end()}I(){this.c!==F.Ended&&(this.c=F.Ended,this.m.fire())}J(Z){if(!(Z instanceof $.$cQ))throw new s.$TP(Z.id);if(this.h.has(i.$UI.fromExtHostTestItem(Z,this.z.controllerId).toString()))return;const $e=[],fe=this.z.colllection.root;for(;;){const oe=n.TestItem.from(Z);if($e.unshift(oe),this.h.has(oe.extId)||(this.h.add(oe.extId),Z===fe))break;Z=Z.parent||fe}this.C.$addTestsToRun(this.z.controllerId,this.z.id,$e)}dispose(){this.I(),super.dispose()}}class z{get trackers(){return this.c.values()}constructor(Z,$e){this.g=Z,this.h=$e,this.c=new Map,this.f=new Map}getCoverageDetails(Z,$e,fe){const oe=i.$UI.root(Z);return this.f.get(oe)?.getCoverageDetails(Z,$e,fe)||[]}disposeTestRun(Z){this.f.get(Z)?.dispose(),this.f.delete(Z);for(const[$e,{id:fe}]of this.c)fe===Z&&this.c.delete($e)}prepareForMainThreadTestRun(Z,$e,fe,oe,H){return this.j($e,fe,oe,Z,H)}cancelRunById(Z){this.f.get(Z)?.cancel()}cancelAllRuns(){for(const Z of this.c.values())Z.cancel()}createTestRun(Z,$e,fe,oe,H,ue){const te=this.c.get(oe);if(te)return te.createRun(H);const _=L.fromPublic($e,fe,oe,ue),ne=M(oe);this.g.$startedExtensionTestRun({controllerId:$e,continuous:!!oe.continuous,profile:ne&&{group:ee[ne.kind],id:ne.profileId},exclude:oe.exclude?.map(J=>i.$UI.fromExtHostTestItem(J,fe.root.id).toString())??[],id:_.id,include:oe.include?.map(J=>i.$UI.fromExtHostTestItem(J,fe.root.id).toString())??[fe.root.id],preserveFocus:oe.preserveFocus??!0,persist:ue});const le=this.j(oe,_,oe.profile,Z);return A.Event.once(le.onEnd)(()=>{this.g.$finishedExtensionTestRun(_.id)}),le.createRun(H)}j(Z,$e,fe,oe,H){const ue=new j($e,this.g,this.h,fe,oe,H);return this.c.set(Z,ue),this.f.set(ue.id,ue),ue}}e.$Epc=z;const M=ge=>{if(ge.profile){if(!(ge.profile instanceof K))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ge.profile}};class L{static fromPublic(Z,$e,fe,oe){return new L(Z,(0,S.$3g)(),oe,$e)}static fromInternal(Z,$e){return new L(Z.controllerId,Z.runId,!0,$e)}constructor(Z,$e,fe,oe){this.controllerId=Z,this.id=$e,this.isPersisted=fe,this.colllection=oe}}e.$Fpc=L;class B{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(Z){this.j=Z,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(Z){this.c.add(Z)}update(Z){Object.assign(Z.revived,n.TestItem.toPlain(Z.item)),this.c.has(Z)||this.f.add(Z)}remove(Z){if(this.c.has(Z)){this.c.delete(Z);return}this.f.delete(Z);const $e=i.$UI.parentId(Z.item.extId);if($e&&this.h.has($e.toString())){this.h.add(Z.item.extId);return}this.g.add(Z)}getChangeEvent(){const{c:Z,f:$e,g:fe}=this;return{get added(){return[...Z].map(oe=>oe.revived)},get updated(){return[...$e].map(oe=>oe.revived)},get removed(){return[...fe].map(oe=>oe.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class W extends d.$4I{constructor(){super(...arguments),this.y=new A.$ne,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(Z){return this.f.get(Z)}getMirroredTestDataByReference(Z){return this.f.get(Z.id)}x(Z,$e){return{...Z,revived:n.TestItem.toPlain(Z.item),depth:$e?$e.depth+1:0,children:new Set}}w(){return new B(this.y)}}class ae{constructor(Z){this.f=Z}checkout(){this.c||(this.c=this.g());const Z=this.c;return Z.observers++,{onDidChangeTest:Z.tests.onDidChangeTests,get tests(){return[...Z.tests.rootTests].map($e=>$e.revived)},dispose:(0,O.$gb)(()=>{--Z.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(Z){return this.c?.tests.getMirroredTestDataByReference(Z)}applyDiff(Z){this.c?.tests.apply(Z)}g(){const Z=new W({asCanonicalUri:$e=>$e});return this.f.$subscribeToDiffs(),{observers:0,tests:Z}}}const q=(ge,Z,$e,fe)=>{$e?Object.assign($e,fe):Z.$updateTestRunConfig(ge.controllerId,ge.profileId,fe)};class K{get label(){return this.f}set label(Z){Z!==this.f&&(this.f=Z,q(this,He(this,b,"f"),He(this,y,"f"),{label:Z}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(Z){Z!==this.g&&(this.g=Z,q(this,He(this,b,"f"),He(this,y,"f"),{supportsContinuousRun:Z}))}get isDefault(){return He(this,E,"f").has(this.profileId)}set isDefault(Z){Z!==this.isDefault&&(Z?He(this,E,"f").add(this.profileId):He(this,E,"f").delete(this.profileId),q(this,He(this,b,"f"),He(this,y,"f"),{isDefault:Z}))}get tag(){return this._tag}set tag(Z){Z?.id!==this._tag?.id&&(this._tag=Z,q(this,He(this,b,"f"),He(this,y,"f"),{tag:Z?n.TestTag.namespace(this.controllerId,Z.id):null}))}get configureHandler(){return this.c}set configureHandler(Z){Z!==this.c&&(this.c=Z,q(this,He(this,b,"f"),He(this,y,"f"),{hasConfigurationHandler:!!Z}))}get onDidChangeDefault(){return A.Event.chain(He(this,D,"f"),Z=>Z.map($e=>$e.get(this.controllerId)?.get(this.profileId)).filter(I.$og))}constructor(Z,$e,fe,oe,H,ue,te,_,ne,le=!1,J=void 0,ce=!1){this.controllerId=H,this.profileId=ue,this.f=te,this.kind=_,this.runHandler=ne,this._tag=J,this.g=ce,b.set(this,void 0),E.set(this,void 0),D.set(this,void 0),y.set(this,void 0),T.set(this,void 0),ot(this,b,Z,"f"),ot(this,T,$e,"f"),ot(this,E,fe,"f"),ot(this,D,oe,"f"),$e.set(ue,this);const me=ee[_];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${_}`);le&&fe.add(ue),ot(this,y,{profileId:ue,controllerId:H,tag:J?n.TestTag.namespace(this.controllerId,J.id):null,label:te,group:me,isDefault:le,hasConfigurationHandler:!1,supportsContinuousRun:ce},"f"),queueMicrotask(()=>{He(this,y,"f")&&(He(this,b,"f").$publishTestRunProfile(He(this,y,"f")),ot(this,y,void 0,"f"))})}dispose(){He(this,T,"f")?.delete(this.profileId)&&(ot(this,T,void 0,"f"),He(this,b,"f").$removeTestProfile(this.controllerId,this.profileId)),ot(this,y,void 0,"f")}}e.$Gpc=K,b=new WeakMap,E=new WeakMap,D=new WeakMap,y=new WeakMap,T=new WeakMap;const ee={[o.TestRunProfileKind.Coverage]:d.TestRunProfileBitset.Coverage,[o.TestRunProfileKind.Debug]:d.TestRunProfileBitset.Debug,[o.TestRunProfileKind.Run]:d.TestRunProfileBitset.Run};function re(ge,Z){for(let $e=0;$e<ge.path.length;$e++){const fe=Z.find(oe=>oe.id===ge.path[$e]);if(!fe)return;if($e===ge.path.length-1)return fe;Z=fe.children}}}),define(Se[370],De([1,0,19,4,3,6,169,16,8]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0,r=Ue(r),R=Ue(R);class c extends k.$Xc{constructor(S,h){super(),this.m=h,this.a=new a.$ne,this.b=new a.$ne,this.c=new a.$ne,this.f=new a.$ne,this.g=new a.$ne,this.h=new a.$ne,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=S.getProxy(A.$vN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(P=>this.h.fire(P))),this.B(this.m.onDidChangeActiveTextEditor(P=>this.g.fire(P)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(S){const h=this.m.allEditors();return S?h:h.map(P=>P.value)}async showTextDocument(S,h,P){let w;typeof h=="number"?w={position:R.ViewColumn.from(h),preserveFocus:P}:typeof h=="object"?w={position:R.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selection:typeof h.selection=="object"?R.Range.from(h.selection):void 0,pinned:typeof h.preview=="boolean"?!h.preview:void 0}:w={preserveFocus:!1};const l=await this.j.$tryShowTextDocument(S.uri,w),m=l&&this.m.getEditor(l);if(m)return m.value;throw l?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,h){return new O.$9P(this.j,S,h).value}$acceptEditorPropertiesChanged(S,h){const P=this.m.getEditor(S);if(!P)throw new Error("unknown text editor");if(h.options&&P._acceptOptions(h.options),h.selections){const w=h.selections.selections.map(R.Selection.to);P._acceptSelections(w)}if(h.visibleRanges){const w=r.$Kb(h.visibleRanges.map(R.Range.to));P._acceptVisibleRanges(w)}if(h.options&&this.b.fire({textEditor:P.value,options:{...h.options,lineNumbers:R.TextEditorLineNumbersStyle.to(h.options.lineNumbers)}}),h.selections){const w=p.TextEditorSelectionChangeKind.fromValue(h.selections.source),l=h.selections.selections.map(R.Selection.to);this.a.fire({textEditor:P.value,selections:l,kind:w})}if(h.visibleRanges){const w=r.$Kb(h.visibleRanges.map(R.Range.to));this.c.fire({textEditor:P.value,visibleRanges:w})}}$acceptEditorPositionData(S){for(const h in S){const P=this.m.getEditor(h);if(!P)throw new Error("Unknown text editor");const w=R.ViewColumn.to(S[h]);P.value.viewColumn!==w&&(P._acceptViewColumn(w),this.f.fire({textEditor:P.value,viewColumn:w}))}}getDiffInformation(S){return Promise.resolve(this.j.$getDiffInformation(S))}}e.$Noc=c}),define(Se[371],De([1,0,2,5,6,3,8,16,24,41,18]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=e.$yqc=void 0,e.$yqc=(0,a.$Gi)("IExtHostTimeline");class S{constructor(w,l){this.b=new Map,this.c=new Map,this.a=w.getProxy(k.$vN.MainThreadTimeline),l.registerArgumentProcessor({processArgument:(m,g)=>{if(m&&m.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(m.source)&&p.$sn.equals(g,this.b.get(m.source)?.extension)){const $=m.uri===void 0?void 0:r.URI.revive(m.uri);return this.c.get(m.source)?.get(h($))?.get(m.handle)}else return;return m}})}async $getTimeline(w,l,m,g){return this.b.get(w)?.provider.provideTimeline(r.URI.revive(l),m,g)}registerTimelineProvider(w,l,m,g){const $=new A.$Wc,n=this.d(l.id,g,$).bind(this);let o;l.onDidChange&&(o=l.onDidChange(i=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...i,id:l.id}),this));const t=this.c;return this.f({...l,scheme:w,onDidChange:void 0,async provideTimeline(i,s,d){s?.resetCache&&($.clear(),t.get(l.id)?.clear());const u=await l.provideTimeline(i,s,d);if(u==null)return;const b=n(i,s);return{...u,source:l.id,items:u.items.map(b)}},dispose(){for(const i of t.values())i.get(l.id)?.clear();o?.dispose(),$.dispose()}},m)}d(w,l,m){return(g,$)=>{let n;if($?.cacheResults){let o=this.c.get(w);o===void 0&&(o=new Map,this.c.set(w,o));const t=h(g);n=o.get(t),n===void 0&&(n=new Map,o.set(t,n))}return o=>{const{iconPath:t,...i}=o,s=`${w}|${o.id??o.timestamp}`;n?.set(s,o);let d,u,b;o.iconPath&&(t instanceof O.$uO?b={id:t.id,color:t.color}:r.URI.isUri(t)?(d=t,u=t):{light:d,dark:u}=t);let E;return O.$ZN.isMarkdownString(i.tooltip)?E=R.MarkdownString.from(i.tooltip):(0,I.$gg)(i.tooltip)?E=i.tooltip:O.$ZN.isMarkdownString(i.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=R.MarkdownString.from(i.detail)):(0,I.$gg)(i.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=i.detail),{...i,id:i.id??void 0,handle:s,source:w,command:o.command?l.toInternal(o.command,m):void 0,icon:d,iconDark:u,themeIcon:b,tooltip:E,accessibilityInformation:o.accessibilityInformation}}}}f(w,l){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:l}),(0,A.$Vc)(()=>{for(const g of this.c.values())g.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$zqc=S;function h(P){return P?.toString()}}),define(Se[372],De([1,0,243,23,2,4,3,304,7,8,18,19,16,86,21,209,26]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0,c=Ue(c);function g(o,t){if((0,I.$gg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let i;return Array.isArray(o.highlights)&&(i=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:o.label,highlights:i}}}class $ extends O.$Xc{constructor(t,i,s){super(),this.f=t,this.g=i,this.h=s,this.a=new Map,this.b=new l.$C_;function d(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:u=>d(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(b=>d(b)?this.r(b):b):u})}registerTreeDataProvider(t,i,s){const d=this.createTreeView(t,{treeDataProvider:i},s);return{dispose:()=>d.dispose()}}createTreeView(t,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=i.dragAndDropController?.dropMimeTypes??[],u=i.dragAndDropController?.dragMimeTypes??[],b=!!i.dragAndDropController?.handleDrag,E=!!i.dragAndDropController?.handleDrop,D=this.m(t,i,s),y={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:d,dragMimeTypes:u,hasHandleDrag:b,hasHandleDrop:E,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},T=this.f.$registerTreeViewDataProvider(t,y),C={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,m.$8G)(s,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,m.$8G)(s,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(v){(0,P.$6k)(v)&&(0,m.$8G)(s,"treeViewMarkdownMessage"),D.message=v},get title(){return D.title},set title(v){D.title=v},get description(){return D.description},set description(v){D.description=v},get badge(){return D.badge},set badge(v){v!==void 0&&c.ViewBadge.isViewBadge(v)?D.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(D.badge=void 0)},reveal:(v,f)=>D.reveal(v,f),dispose:async()=>{await T,this.a.delete(t),D.dispose()}};return this.B(C),C}$getChildren(t,i){const s=this.a.get(t);return s?s.getChildren(i):Promise.reject(new R.$rG(t))}async $handleDrop(t,i,s,d,u,b,E,D){const y=this.a.get(t);if(!y)return Promise.reject(new R.$rG(t));const T=h.DataTransfer.toDataTransfer(s,async C=>(await this.f.$resolveDropFileData(t,i,C)).buffer);return E===t&&D&&await this.j(T,y,D,u,b),y.onDrop(T,d,u)}async j(t,i,s,d,u){const b=this.b.removeDragOperationTransfer(u);if(b)(await b)?.forEach((E,D)=>{E&&t.set(D,E)});else if(u&&i.handleDrag){const E=i.handleDrag(s,t,d);this.b.addDragOperationTransfer(u,E),await E}return t}async $handleDrag(t,i,s,d){const u=this.a.get(t);if(!u)return Promise.reject(new R.$rG(t));const b=await this.j(new c.$qO,u,i,d,s);if(!(!b||d.isCancellationRequested))return h.DataTransfer.from(b)}async $hasResolve(t){const i=this.a.get(t);if(!i)throw new R.$rG(t);return i.hasResolve}$resolve(t,i,s){const d=this.a.get(t);if(!d)throw new R.$rG(t);return d.resolveTreeItem(i,s)}$setExpanded(t,i,s){const d=this.a.get(t);if(!d)throw new R.$rG(t);d.setExpanded(i,s)}$setSelectionAndFocus(t,i,s){const d=this.a.get(t);if(!d)throw new R.$rG(t);d.setSelectionAndFocus(i,s)}$setVisible(t,i){const s=this.a.get(t);if(!s){if(!i)return;throw new R.$rG(t)}s.setVisible(i)}$changeCheckboxState(t,i){const s=this.a.get(t);if(!s)throw new R.$rG(t);s.setCheckboxState(i)}m(t,i,s){const d=this.B(new n(t,i,this.f,this.g.converter,this.h,s));return this.a.set(t,d),d}r(t){const i=this.a.get(t.$treeViewId);return i&&"$treeItemHandle"in t?i.getExtensionElement(t.$treeItemHandle):i&&"$focusedTreeItem"in t&&t.$focusedTreeItem?i.focusedElement:null}}e.$Aqc=$;class n extends O.$Xc{get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$pg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,i,s,d,u,b){if(super(),this.I=t,this.J=s,this.L=d,this.M=u,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$ne),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$ne),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$ne),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$ne),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$ne),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$ne),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$ne),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$ye,b.contributes&&b.contributes.views)for(const T in b.contributes.views)for(const C of b.contributes.views[T])C.id===t&&(this.P=C.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(T=>{Array.isArray(T)&&T.length===0||this.F.fire({message:!1,element:T})}));let E,D;const y=A.Event.debounce(this.F.event,(T,C)=>(T||(T={message:!1,elements:[]}),C.element!==!1&&(E||(E=new Promise(v=>D=v),this.G=this.G.then(()=>E)),Array.isArray(C.element)?T.elements.push(...C.element):T.elements.push(C.element)),C.message&&(T.message=!0),T),200,!0);this.B(y(({message:T,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const v=D;return E=null,this.$(C).then(()=>v())})),T&&this.J.$setMessage(this.I,h.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const i=t?this.getExtensionElement(t):void 0;if(t&&!i)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let s=this.X(t);return s||(s=await this.Y(i)),s?s.map(d=>d.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,i){i=i||{select:!0,focus:!1};const s=(0,I.$pg)(i.select)?!0:i.select,d=(0,I.$pg)(i.focus)?!1:i.focus,u=(0,I.$pg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(b=>this.W(t,b[b.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:b.map(D=>D.item)},{select:s,focus:d,expand:u})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:s,focus:d,expand:u})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=h.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,i){const s=this.getExtensionElement(t);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(t,i){const s=!(0,S.$xb)(this.s,t);this.s=t;const d=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const i=(await Promise.all(t.map(async s=>{const d=this.getExtensionElement(s.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:s.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(t,i,s){const d=[];for(const u of t){const b=this.getExtensionElement(u);b&&d.push(b)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,i,s){const d=i?this.getExtensionElement(i):void 0;if(!(!d&&i||!this.g?.handleDrop))return(0,p.$yh)(()=>this.g?.handleDrop?this.g.handleDrop(d,t,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(t);if(s){const d=this.m.get(s);if(d){const u=await this.f.resolveTreeItem(d.extensionItem,s,i)??d.extensionItem;return this.hb(u),d.item.tooltip=this.eb(u.tooltip),d.item.command=this.fb(d.disposableStore,u.command),d.item}}}S(t){return this.U(t).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(d=>(s.push(d),s))):Promise.resolve([]))}U(t){const i=this.m.get(t);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,p.$yh)(()=>this.f.getParent(t))}W(t,i){const s=this.m.get(t);return s?Promise.resolve(s):(0,p.$yh)(()=>this.f.getTreeItem(t)).then(d=>this.kb(t,d,i,!0)).then(d=>this.getChildren(i?i.item.handle:void 0).then(()=>{const u=this.getExtensionElement(d);if(u){const b=this.m.get(u);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let i;if(typeof t=="string"){const s=this.getExtensionElement(t);i=s?this.m.get(s):void 0}else i=t;return i&&i.children||void 0}return this.h}async Y(t){this.rb(t);const i=new w.$ye(this.Z.token);try{const s=t?this.m.get(t):void 0,d=await this.f.getChildren(t);if(i.token.isCancellationRequested)return;const u=(0,S.$Kb)(d||[]),b=await Promise.all((0,S.$Kb)(u).map(D=>this.f.getTreeItem(D)));if(i.token.isCancellationRequested)return;const E=b.map((D,y)=>D?this.db(u[y],D,s):null);return(0,S.$Kb)(E)}finally{i.dispose()}}$(t){if(t.some(s=>!s))return this.Z.dispose(!0),this.Z=new w.$ye,this.tb(),this.J.$refresh(this.I);{const s=this.ab(t);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(t){const i=new Set,s=t.map(u=>this.m.get(u));for(const u of s)if(u&&!i.has(u.item.handle)){let b=u;for(;b&&b.parent&&s.findIndex(E=>b&&b.parent&&E&&E.item.handle===b.parent.item.handle)===-1;){const E=this.j.get(b.parent.item.handle);b=E?this.m.get(E):void 0}b&&!b.parent&&i.add(u.item.handle)}const d=[];return i.forEach(u=>{const b=this.j.get(u);if(b){const E=this.m.get(b);E&&(!E.parent||!i.has(E.parent.item.handle))&&d.push(u)}}),d}bb(t){const i={};return Promise.all(t.map(s=>this.cb(s).then(d=>{d&&(i[s]=d.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(t){const i=this.getExtensionElement(t);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,p.$yh)(()=>this.f.getTreeItem(i)).then(d=>{if(d){const u=this.ib(i,d,s.parent);return this.pb(i,u,s,s.parent),s.dispose(),u}return null})}return Promise.resolve(null)}db(t,i,s){const d=this.ib(t,i,s);if(i.id&&this.j.has(d.item.handle))throw new Error((0,r.localize)(0,null,i.id));return this.ob(t,d),this.qb(d,s),d}eb(t){return c.$ZN.isMarkdownString(t)?h.MarkdownString.from(t):t}fb(t,i){return i?{...this.L.toInternal(i,t),originalId:i.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let i,s,d;return typeof t.checkboxState=="number"?i=t.checkboxState:(i=t.checkboxState.state,s=t.checkboxState.tooltip,d=t.checkboxState.accessibilityInformation),{isChecked:i===c.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:d}}hb(t){if(!c.$lO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,i,s){this.hb(i);const d=this.B(new O.$Wc),u=this.kb(t,i,s),b=this.lb(i);return{item:{handle:u,parentHandle:s?s.item.handle:void 0,label:g(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(d,i.command),contextValue:i.contextValue,icon:b,iconDark:this.mb(i)||b,themeIcon:this.jb(i),collapsibleState:(0,I.$pg)(i.collapsibleState)?c.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(t){return t.iconPath instanceof c.$uO?t.iconPath:void 0}kb(t,{id:i,label:s,resourceUri:d},u,b){if(i)return`${n.b}/${i}`;const E=g(s,this.N),D=u?u.item.handle:n.a;let y=E?E.label:d?(0,a.$eh)(d):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const T=this.m.has(t)?this.m.get(t).item.handle:void 0,C=this.X(u)||[];let v,f=0;do{if(v=`${D}/${f}:${y}`,b||!this.j.has(v)||T===v)break;f++}while(f<=C.length);return v}lb(t){if(t.iconPath&&!(t.iconPath instanceof c.$uO))return typeof t.iconPath=="string"||k.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof c.$uO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return k.URI.isUri(t)?t:k.URI.file(t)}ob(t,i){this.j.set(i.item.handle,t),this.m.set(t,i)}pb(t,i,s,d){this.j.delete(i.item.handle),this.m.delete(t),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(t,i);const u=this.X(d)||[],b=u.filter(E=>E.item.handle===s.item.handle)[0];b&&u.splice(u.indexOf(b),1,i)}qb(t,i){i?(i.children||(i.children=[]),i.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const i=this.m.get(t);if(i){if(i.children)for(const s of i.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}i.children=void 0}}else this.tb()}sb(t){const i=this.m.get(t);if(i){if(i.children)for(const s of i.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}this.m.delete(t),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}n.a="0",n.b="1"});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[373],De([1,0,4,3,2,33,16,97,6,8]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";var I,S,h,P,w,l,m,g,$,n,o,t,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$7oc=void 0,O=Ue(O),p=Ue(p),c=Ue(c);class s extends a.$Xc{constructor(E,D,y,T){super(),I.set(this,void 0),S.set(this,void 0),h.set(this,void 0),P.set(this,void 0),w.set(this,void 0),l.set(this,void 0),m.set(this,void 0),g.set(this,void 0),$.set(this,!0),n.set(this,void 0),o.set(this,!1),t.set(this,this.B(new r.$ne)),this.onDidDispose=He(this,t,"f").event,i.set(this,this.B(new r.$ne)),this.onDidChangeViewState=He(this,i,"f").event,ot(this,I,E,"f"),ot(this,S,D,"f"),ot(this,P,y,"f"),ot(this,h,T.viewType,"f"),ot(this,w,T.panelOptions,"f"),ot(this,g,T.viewColumn,"f"),ot(this,l,T.title,"f"),ot(this,n,T.active,"f")}dispose(){He(this,o,"f")||(ot(this,o,!0,"f"),He(this,t,"f").fire(),He(this,S,"f").$disposeWebview(He(this,I,"f")),He(this,P,"f").dispose(),super.dispose())}get webview(){return this.c(),He(this,P,"f")}get viewType(){return this.c(),He(this,h,"f")}get title(){return this.c(),He(this,l,"f")}set title(E){this.c(),He(this,l,"f")!==E&&(ot(this,l,E,"f"),He(this,S,"f").$setTitle(He(this,I,"f"),E))}get iconPath(){return this.c(),He(this,m,"f")}set iconPath(E){this.c(),He(this,m,"f")!==E&&(ot(this,m,E,"f"),He(this,S,"f").$setIconPath(He(this,I,"f"),k.URI.isUri(E)?{light:E,dark:E}:E))}get options(){return He(this,w,"f")}get viewColumn(){if(this.c(),!(typeof He(this,g,"f")=="number"&&He(this,g,"f")<0))return He(this,g,"f")}get active(){return this.c(),He(this,n,"f")}get visible(){return this.c(),He(this,$,"f")}_updateViewState(E){He(this,o,"f")||(this.active!==E.active||this.visible!==E.visible||this.viewColumn!==E.viewColumn)&&(ot(this,n,E.active,"f"),ot(this,$,E.visible,"f"),ot(this,g,E.viewColumn,"f"),He(this,i,"f").fire({webviewPanel:this}))}reveal(E,D){this.c(),He(this,S,"f").$reveal(He(this,I,"f"),{viewColumn:typeof E>"u"?void 0:O.ViewColumn.from(E),preserveFocus:!!D})}c(){if(He(this,o,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,S=new WeakMap,h=new WeakMap,P=new WeakMap,w=new WeakMap,l=new WeakMap,m=new WeakMap,g=new WeakMap,$=new WeakMap,n=new WeakMap,o=new WeakMap,t=new WeakMap,i=new WeakMap;class d extends a.$Xc{static c(){return(0,A.$3g)()}constructor(E,D,y){super(),this.j=D,this.m=y,this.g=new Map,this.h=new Map,this.f=E.getProxy(p.$vN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(E=>E.dispose()),this.g.clear()}createWebviewPanel(E,D,y,T,C={}){const v=typeof T=="object"?T.viewColumn:T,f={viewColumn:O.ViewColumn.from(v),preserveFocus:typeof T=="object"&&!!T.preserveFocus},N=(0,R.$3oc)(E),F=d.c();this.f.$createWebviewPanel((0,R.$5oc)(E),F,D,{title:y,panelOptions:u(C),webviewOptions:(0,R.$6oc)(E,this.m,C),serializeBuffersForPostMessage:N},f);const j=this.j.createNewWebview(F,C,E);return this.createNewWebviewPanel(F,D,y,v,C,j,!0)}$onDidChangeWebviewPanelViewStates(E){const D=Object.keys(E);D.sort((y,T)=>{const C=E[y],v=E[T];return C.active?1:v.active?-1:+C.visible-+v.visible});for(const y of D){const T=this.getWebviewPanel(y);if(!T)continue;const C=E[y];T._updateViewState({active:C.active,visible:C.visible,viewColumn:O.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(E){this.getWebviewPanel(E)?.dispose(),this.g.delete(E),this.j.deleteWebview(E)}registerWebviewPanelSerializer(E,D,y){if(this.h.has(D))throw new Error(`Serializer for '${D}' already registered`);return this.h.set(D,{serializer:y,extension:E}),this.f.$registerSerializer(D,{serializeBuffersForPostMessage:(0,R.$3oc)(E)}),new c.$xN(()=>{this.h.delete(D),this.f.$unregisterSerializer(D)})}async $deserializeWebviewPanel(E,D,y,T){const C=this.h.get(D);if(!C)throw new Error(`No serializer found for '${D}'`);const{serializer:v,extension:f}=C,N=this.j.createNewWebview(E,y.webviewOptions,f),F=this.createNewWebviewPanel(E,D,y.title,T,y.panelOptions,N,y.active);await v.deserializeWebviewPanel(F,y.state)}createNewWebviewPanel(E,D,y,T,C,v,f){const N=new s(E,this.f,v,{viewType:D,title:y,viewColumn:T,panelOptions:C,active:f});return this.g.set(E,N),N}getWebviewPanel(E){return this.g.get(E)}}e.$7oc=d;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[374],De([1,0,4,3,97,16,6,8]),function(ie,e,r,a,k,A,O,R){"use strict";var p,c,I,S,h,P,w,l,m,g,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0,O=Ue(O),R=Ue(R);class n extends a.$Xc{constructor(i,s,d,u,b,E){super(),p.set(this,void 0),c.set(this,void 0),I.set(this,void 0),S.set(this,void 0),h.set(this,!1),P.set(this,void 0),w.set(this,void 0),l.set(this,void 0),m.set(this,void 0),g.set(this,this.B(new r.$ne)),this.onDidChangeVisibility=He(this,g,"f").event,$.set(this,this.B(new r.$ne)),this.onDidDispose=He(this,$,"f").event,ot(this,I,d,"f"),ot(this,w,u,"f"),ot(this,p,i,"f"),ot(this,c,s,"f"),ot(this,S,b,"f"),ot(this,P,E,"f")}dispose(){He(this,h,"f")||(ot(this,h,!0,"f"),He(this,$,"f").fire(),He(this,S,"f").dispose(),super.dispose())}get title(){return this.a(),He(this,w,"f")}set title(i){this.a(),He(this,w,"f")!==i&&(ot(this,w,i,"f"),He(this,c,"f").$setWebviewViewTitle(He(this,p,"f"),i))}get description(){return this.a(),He(this,l,"f")}set description(i){this.a(),He(this,l,"f")!==i&&(ot(this,l,i,"f"),He(this,c,"f").$setWebviewViewDescription(He(this,p,"f"),i))}get visible(){return He(this,P,"f")}get webview(){return He(this,S,"f")}get viewType(){return He(this,I,"f")}_setVisible(i){i===He(this,P,"f")||He(this,h,"f")||(ot(this,P,i,"f"),He(this,g,"f").fire())}get badge(){return this.a(),He(this,m,"f")}set badge(i){this.a(),!(i?.value===He(this,m,"f")?.value&&i?.tooltip===He(this,m,"f")?.tooltip)&&(ot(this,m,A.ViewBadge.from(i),"f"),He(this,c,"f").$setWebviewViewBadge(He(this,p,"f"),i))}show(i){this.a(),He(this,c,"f").$show(He(this,p,"f"),!!i)}a(){if(He(this,h,"f"))throw new Error("Webview is disposed")}}p=new WeakMap,c=new WeakMap,I=new WeakMap,S=new WeakMap,h=new WeakMap,P=new WeakMap,w=new WeakMap,l=new WeakMap,m=new WeakMap,g=new WeakMap,$=new WeakMap;class o{constructor(i,s){this.d=s,this.b=new Map,this.c=new Map,this.a=i.getProxy(O.$vN.MainThreadWebviewViews)}registerWebviewViewProvider(i,s,d,u){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:d,extension:i}),this.a.$registerWebviewViewProvider((0,k.$5oc)(i),s,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.$3oc)(i)}),new R.$xN(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(i,s,d,u,b){const E=this.b.get(s);if(!E)throw new Error(`No view provider found for '${s}'`);const{provider:D,extension:y}=E,T=this.d.createNewWebview(i,{},y),C=new n(i,this.a,s,d,T,!0);this.c.set(i,C),await D.resolveWebviewView(C,{state:u},b)}async $onDidChangeWebviewViewVisibility(i,s){this.e(i)._setVisible(s)}async $disposeWebviewView(i){const s=this.e(i);this.c.delete(i),s.dispose(),this.d.deleteWebview(i)}e(i){const s=this.c.get(i);if(!s)throw new Error("No webview found");return s}}e.$Dqc=o}),define(Se[375],De([1,0,76,15,12,277,28,11]),function(ie,e,r,a,k,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$irc=void 0;let p=class{constructor(S,h){S.addFileSystemProvider(a.Schemas.file,new c(h),{isCaseSensitive:R.$e})}};e.$irc=p,e.$irc=p=Ye([Ve(0,r.$Yoc),Ve(1,k.$ak)],p);class c{constructor(S){this.b=S,this.a=new A.$sr(this.b)}async stat(S){const h=await this.a.stat(S);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions===O.FilePermission.Readonly?1:void 0}}readDirectory(S){return this.a.readdir(S)}createDirectory(S){return this.a.mkdir(S)}readFile(S){return this.a.readFile(S)}writeFile(S,h,P){return this.a.writeFile(S,h,{...P,unlock:!1,atomic:!1})}delete(S,h){return this.a.delete(S,{...h,useTrash:!1,atomic:!1})}rename(S,h,P){return this.a.rename(S,h,P)}copy(S,h,P){return this.a.copy(S,h,P)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(S,h){throw new Error("Method not implemented.")}}}),define(Se[376],De([1,0,17,67,33,35,3,6,2,20]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$grc=void 0;let I=class extends O.$Xc{constructor(h,P){super();const w=h.getProxy(R.$vN.MainThreadDownloadService);P.registerCommand(!1,"_workbench.downloadResource",async l=>{const m=p.URI.file((0,r.$mc)((0,a.tmpdir)(),(0,k.$3g)()));return await w.$download(l,m),m})}};e.$grc=I,e.$grc=I=Ye([Ve(0,c.$2P),Ve(1,A.$lQ)],I)}),define(Se[377],De([1,0,61,17,2,98,3,15,7,34]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0,r=Ue(r),a=Ue(a);class I extends A.$1oc{constructor(){super(...arguments),this.i=null}async g(i){const s=await super.g(i);if(s.scheme!==R.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const d=s.fsPath;let u=0;do{let b;u===0?b=d:b=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${u}`:`${d}-${u}`,await S(b);const E=a.$mc(b,"vscode.lock"),D=await l(this.d,E,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),k.URI.file(b);u++}while(u<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$src=I;async function S(t){try{await c.Promises.stat(t);return}catch{}try{await c.Promises.mkdir(t,{recursive:!0})}catch{}}const h=1e3,P=10*60*1e3;class w extends O.$Xc{constructor(i,s){super(),this.b=i,this.c=s,this.a=this.B(new p.$Rh),this.a.cancelAndSet(async()=>{const d=await m(i,s);(!d||d.pid!==process.pid)&&(i.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await c.Promises.utimes(s,new Date,new Date)}catch(u){i.error(u),i.info(`Lock '${s}': Could not update mtime.`)}},h)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+i};await c.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function l(t,i,s){try{const u={pid:process.pid,willReleaseAt:0};await c.Promises.writeFile(i,JSON.stringify(u),{flag:"wx"})}catch(u){t.error(u)}const d=await m(t,i);return!d||d.pid!==process.pid?s?(t.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(t.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),n(t,i)):(t.info(`Lock '${i}': Lock acquired.`),new w(t,i))}async function m(t,i){let s;try{s=await c.Promises.readFile(i)}catch(d){return t.error(d),null}try{return JSON.parse(String(s))}catch(d){return t.error(d),null}}async function g(t,i){let s;try{s=await c.Promises.stat(i)}catch(d){return t.error(d),0}return s.mtime.getTime()}function $(t){try{return process.kill(t,0),!0}catch{return!1}}async function n(t,i){const s=await m(t,i);if(!s)return t.info(`Lock '${i}': Could not read pid of lock holder.`),o(t,i);if(s.willReleaseAt){let D=s.willReleaseAt-Date.now();if(D<5e3){for(D>0?t.info(`Lock '${i}': The lockfile is scheduled to be released in ${D} ms.`):t.info(`Lock '${i}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,p.$Hh)(Math.min(100,D)),await g(t,i)===0)return o(t,i);D=s.willReleaseAt-Date.now()}return o(t,i)}}if(!$(s.pid))return t.info(`Lock '${i}': The pid ${s.pid} appears to be gone.`),o(t,i);const d=await g(t,i),u=Date.now()-d;if(u<=P)return t.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;t.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,p.$Hh)(2e3);const b=await g(t,i),E=Date.now()-b;return E<=P?(t.info(`Lock '${i}': The lock does not look stale, elapsed: ${E} ms, giving up.`),null):(t.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),o(t,i))}async function o(t,i){t.info(`Lock '${i}': Deleting a stale lock.`);try{await c.Promises.unlink(i)}catch{}return l(t,i,!0)}}),define(Se[378],De([1,0,33,20,48,35]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=void 0;let O=class extends k.$kpc{constructor(p,c){super(!0,p,c)}createTerminal(p,c,I){return this.createTerminalFromOptions({name:p,shellPath:c,shellArgs:I})}createTerminalFromOptions(p,c){const I=new k.$jpc(this.a,(0,r.$3g)(),p,p.name);return this.f.push(I),I.create(p,this.R(p,c)),I.value}};e.$Nqc=O,e.$Nqc=O=Ye([Ve(0,A.$lQ),Ve(1,a.$2P)],O)}),define(Se[379],De([1,0,4,37,36,5]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.OutputChannelUpdateMode=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=void 0,e.$DM="text/x-code-output",e.$EM="output",e.$FM="Log",e.$GM="text/x-code-log-output",e.$HM="log",e.$IM="workbench.panel.output",e.$JM=new k.$Xj("inOutput",!1),e.$KM=new k.$Xj("activeLogOutput",!1),e.$LM=new k.$Xj("activeLogOutput.levelSettable",!1),e.$MM=new k.$Xj("activeLogOutput.level",""),e.$NM=new k.$Xj("activeLogOutput.levelIsDefault",!1),e.$OM=new k.$Xj("outputView.scrollLock",!1),e.$PM=(0,A.$Gi)("outputService");var O;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(O||(e.OutputChannelUpdateMode=O={})),e.$QM={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new r.$ne,this.onDidRegisterChannel=this.b.event,this.c=new r.$ne,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(I=>c.push(I)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}a.$so.add(e.$QM.OutputChannels,new R),e.$RM=new k.$Xj("activeOutputChannel","")}),define(Se[170],De([1,0,6,5,20,24,12,379,76,30,63,214,22,18,28,4,3]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=e.$gqc=void 0;class g extends O.$gk{get disposed(){return this.n}constructor(t,i,s,d,u){super(),this.id=t,this.name=i,this.r=s,this.s=d,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Clear,t)}replace(t){const i=this.m;this.info(t),this.s.$update(this.id,R.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(t,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:i))}hide(){this.s.$close(this.id)}g(t,i){this.m+=h.$Pe.fromString(i).byteLength,(0,O.log)(this.r,t,i),this.visible&&(this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class $ extends g{appendLine(t){this.append(t)}}let n=class{constructor(t,i,s,d,u,b){this.i=i,this.j=s,this.k=d,this.l=u,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(r.$vN.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(t,i,s){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const d=typeof i=="object"&&i.log,u=(0,P.$gg)(i)?i:void 0;if((0,P.$gg)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const E=this.i.environment.extensionLogLevel?.find(([y])=>A.$sn.equals(s.identifier,y))?.[1];E&&(b=(0,O.$rk)(E));const D=d?this.o(t,b,s):this.n(t,u,s);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),d?this.r(t,b??this.m.getLevel(),D):this.q(t,D)}async n(t,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,u=this.k.extUri.joinPath(d,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,u,i,s.identifier.value);return new g(E,t,b,this.a,s)}async o(t,i,s){const d=await this.p(s),u=t.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(d,`${u}.log`),E=`${s.identifier.value}.${u}`,D=this.l.createLogger(b,{id:E,name:t,logLevel:i,extensionId:s.identifier.value});return new $(E,t,D,this.a,s)}p(t){let i=this.d.get(t.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(d){if((0,w.$ql)(d)!==w.FileSystemProviderErrorCode.FileExists)throw d}return s})())}return i}q(t,i){let s=!1;const d=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return t},append(u){d(),i.then(b=>b.append(u))},appendLine(u){d(),i.then(b=>b.appendLine(u))},clear(){d(),i.then(u=>u.clear())},replace(u){d(),i.then(b=>b.replace(u))},show(u,b){d(),i.then(E=>E.show(u,b))},hide(){d(),i.then(u=>u.hide())},dispose(){s=!0,i.then(u=>u.dispose())}}}r(t,i,s){const d=new m.$Wc,u=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},b=d.add(new l.$ne);function E(D){i=D,b.fire(D)}return s.then(D=>{d.add(D),D.logLevel!==i&&E(D.logLevel),d.add(D.onDidChangeLogLevel(y=>E(y)))}),{...this.q(t,s),get logLevel(){return i},onDidChangeLogLevel:b.event,trace(D,...y){u(),s.then(T=>T.trace(D,...y))},debug(D,...y){u(),s.then(T=>T.debug(D,...y))},info(D,...y){u(),s.then(T=>T.info(D,...y))},warn(D,...y){u(),s.then(T=>T.warn(D,...y))},error(D,...y){u(),s.then(T=>T.error(D,...y))},dispose(){d.dispose()}}}};e.$gqc=n,e.$gqc=n=Ye([Ve(0,k.$2P),Ve(1,c.$fQ),Ve(2,p.$Yoc),Ve(3,I.$Boc),Ve(4,O.$bk),Ve(5,O.$ak)],n),e.$hqc=(0,a.$Gi)("IExtHostOutputService")}),define(Se[171],De([1,0,5,7]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=void 0,e.$Wm=(0,r.$Gi)("remoteAgentService"),e.$Xm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(k){let A=1/0;for(let R=0;R<this.maxSampleCount;R++){const p=await k.getRoundTripTime();if(p===void 0)return;A=Math.min(A,p/2),await(0,a.$Hh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let O;return this.initial.length<this.maxInitialCount?this.initial.push(A):O=this.initial.reduce((R,p)=>R+p,0)/this.initial.length,this.lastMeasurement={initial:O,current:A,average:this.average.reduce((R,p)=>R+p,0)/this.average.length,high:typeof O>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>O*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[380],De([1,0,247,71,37,47,46,3,4,171,11,25,7,152]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=void 0,e.$4K=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.$5K=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.$6K=Object.freeze({id:"security",scope:a.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.$7K=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.$8K=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.$9K={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new p.$ne,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const l=new w;k.$so.add(e.$9K.ConfigurationMigration,l);let m=class extends R.$Xc{constructor(o,t){super(),this.a=o,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async i=>{for(const s of i.added)await this.f(s,l.migrations)})),this.c(l.migrations),this.B(l.onDidRegisterConfigurationMigration(i=>this.c(i)))}async c(o){await this.f(void 0,o);for(const t of this.b.getWorkspace().folders)await this.f(t,o)}async f(o,t){await Promise.all([t.map(i=>this.g(i,o?.uri))])}async g(o,t){const i=this.a.inspect(o.key,{resource:t}),s=this.b.getWorkbenchState()===A.WorkbenchState.WORKSPACE?[["user",O.ConfigurationTarget.USER],["userLocal",O.ConfigurationTarget.USER_LOCAL],["userRemote",O.ConfigurationTarget.USER_REMOTE],["workspace",O.ConfigurationTarget.WORKSPACE],["workspaceFolder",O.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",O.ConfigurationTarget.USER],["userLocal",O.ConfigurationTarget.USER_LOCAL],["userRemote",O.ConfigurationTarget.USER_REMOTE],["workspace",O.ConfigurationTarget.WORKSPACE]];for(const[d,u]of s){const b=i[d];if(!b)continue;const E=[];if(b.value!==void 0){const D=await this.h(o,d,b.value,t,void 0);for(const y of D??[])E.push([y,[]])}for(const{identifiers:D,value:y}of b.overrides??[])if(y!==void 0){const T=await this.h(o,d,y,t,D);for(const C of T??[])E.push([C,D])}E.length&&await Promise.allSettled(E.map(async([[D,y],T])=>this.a.updateValue(D,y.value,{resource:t,overrideIdentifiers:T},u)))}}async h(o,t,i,s,d){const u=E=>{const y=this.a.inspect(E,{resource:s})[t];if(y)return d?y.overrides?.find(({identifiers:T})=>(0,S.$jo)(T,d))?.value:y.value},b=await o.migrateFn(i,u);return Array.isArray(b)?b:[[o.key,b]]}};e.$0K=m,m.ID="workbench.contrib.configurationMigration",e.$0K=m=Ye([Ve(0,O.$aj),Ve(1,A.$Pi)],m);let g=class extends R.$Xc{constructor(o){super(),this.b=o,this.a=new h.$4h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$c&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;k.$so.as(a.$xo.Configuration).registerConfiguration({...e.$6K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:a.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:a.ConfigurationScope.MACHINE}}})}};e.$$K=g,g.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$$K=g=Ye([Ve(0,c.$Wm)],g),e.$_K="window.newWindowProfile";let $=class extends R.$Xc{constructor(o,t){super(),this.c=o,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(i=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(i=>{i.source!==O.ConfigurationTarget.DEFAULT&&i.affectsConfiguration(e.$_K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=k.$so.as(a.$xo.Configuration),t={...e.$8K,properties:{[e.$_K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(i=>i.name),null],enumItemLabels:[...this.c.profiles.map(i=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:a.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[t],remove:[this.a]}):o.registerConfiguration(t),this.a=t}h(){const o=this.f.getValue(e.$_K);this.b=o?this.c.profiles.find(t=>t.name===o):void 0}j(){const o=this.f.getValue(e.$_K);if(!o)return;const t=this.b?this.c.profiles.find(i=>i.id===this.b.id):void 0;o!==t?.name&&this.f.updateValue(e.$_K,t?.name)}};e.$aL=$,$.ID="workbench.contrib.dynamicWindowConfiguration",e.$aL=$=Ye([Ve(0,P.$Ml),Ve(1,O.$aj)],$)}),define(Se[381],De([1,0,39,15,17,23,259,380,71,5,37]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$cL=e.$bL=void 0,e.$dL=l,e.$eL=m,r=Ue(r),e.$bL=(0,c.$Gi)("editorResolverService"),e.$cL="workbench.editorAssociations";const S=I.$so.as(p.$xo.Configuration),h={...R.$5K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,O.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(h);var P;(function(g){g.builtin="builtin",g.option="option",g.exclusive="exclusive",g.default="default"})(P||(e.RegisteredEditorPriority=P={}));var w;(function(g){g[g.ABORT=1]="ABORT",g[g.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function l(g){switch(g){case P.exclusive:return 5;case P.default:return 4;case P.builtin:return 3;case P.option:default:return 1}}function m(g,$){if(new Set([a.Schemas.extension,a.Schemas.webviewPanel,a.Schemas.vscodeWorkspaceTrust,a.Schemas.vscodeSettings]).has($.scheme))return!1;const t=typeof g=="string"&&g.indexOf(k.$jc.sep)>=0?`${$.scheme}:${$.path}`:(0,A.$eh)($);return r.$zk(typeof g=="string"?g.toLowerCase():g,t.toLowerCase())}}),define(Se[382],De([1,0,32,15,17,11,23,2,5,297,47,159,171]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=void 0,e.$0M=(0,p.$Gi)("pathService");let w=P=class{constructor(m,g,$,n){this.d=m,this.e=g,this.f=$,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??m})()}hasValidBasename(m,g,$){return typeof g=="string"||typeof g>"u"?this.a.then(n=>this.h(m,n,g)):this.h(m,g,$)}h(m,g,$){return m.scheme===a.Schemas.file||m.scheme===a.Schemas.vscodeRemote?(0,r.$Dg)($??(0,O.$eh)(m),g===A.OperatingSystem.Windows):!0}get defaultUriScheme(){return P.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,g){if(m.remoteAuthority)return a.Schemas.vscodeRemote;const $=(0,c.$7M)(g.getWorkspace());if($)return $;const n=g.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=g.getWorkspace().configuration;return o?o.scheme:a.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===A.OperatingSystem.Windows?k.$ic:k.$jc)}async fileURI(m){let g="";if(await this.a===A.OperatingSystem.Windows&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(g=m.substring(2),m="/"):(g=m.substring(2,n),m=m.substring(n)||"/")}return R.URI.from({scheme:a.Schemas.file,authority:g,path:m,query:"",fragment:""})}};e.$$M=w,e.$$M=w=P=Ye([Ve(1,h.$Wm),Ve(2,S.$SM),Ve(3,I.$Pi)],w)}),define(Se[383],De([1,0,261,59,4,60,3,2,46,266,12,72,153,93,47,159,26,21,18,25,36]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=e.OnPortForward=e.$XM=e.$WM=e.TunnelSource=e.TunnelCloseReason=e.$UM=e.$TM=void 0,e.$VM=u,e.$YM=D,e.$ZM=y,e.$1M=T,e.$2M=v,r=Ue(r);const t=10*1e3,i="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$TM="onTunnel",e.$UM=new o.$Xj("forwardedPortsViewEnabled",!1,r.localize(0,null));function u(F){const j=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(j)return{host:j[1]?.substring(0,j[1].length-1)||"localhost",port:Number(j[2])}}var b;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(b||(e.TunnelCloseReason=b={}));var E;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(E||(e.TunnelSource=E={})),e.$WM={source:E.User,description:r.localize(1,null)},e.$XM={source:E.Auto,description:r.localize(2,null)};function D(F,j,z){const M=F.get(T(j,z));if(M)return M;if((0,P.$Iw)(j))for(const L of P.$Hw){const B=T(L,z);if(F.has(B))return F.get(B)}else if((0,P.$Kw)(j))for(const L of P.$Jw){const B=T(L,z);if(F.has(B))return F.get(B)}}function y(F,j,z){const M=D(F,j,z);if(M)return M;const L=(0,P.$Kw)(j)?"localhost":(0,P.$Iw)(j)?"0.0.0.0":void 0;if(L)return D(F,L,z)}function T(F,j){return F+":"+j}var C;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(C||(e.OnPortForward=C={}));function v(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}class f extends O.$Xc{constructor(j){super(),this.r=j,this.j=[],this.n=new k.$ne,this.onDidChangeAttributes=this.n.event,this.B(j.onDidChangeConfiguration(z=>{(z.affectsConfiguration(f.c)||z.affectsConfiguration(f.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(j,z,M){let L=this.w(j,z,M,this.j,0);const B={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;L>=0;){const W=this.j[L];W.key===j?(B.onAutoForward=W.onAutoForward??B.onAutoForward,B.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:B.elevateIfNeeded,B.label=W.label??B.label,B.requireLocalPort=W.requireLocalPort,B.protocol=W.protocol):(B.onAutoForward=B.onAutoForward??W.onAutoForward,B.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:W.elevateIfNeeded,B.label=B.label??W.label,B.requireLocalPort=B.requireLocalPort!==void 0?B.requireLocalPort:void 0,B.protocol=B.protocol??W.protocol),L=this.w(j,z,M,this.j,L+1)}return B.onAutoForward!==void 0||B.elevateIfNeeded!==void 0||B.label!==void 0||B.requireLocalPort!==void 0||B.protocol!==void 0?B:this.C()}t(j){return j.start!==void 0&&j.end!==void 0}u(j){return j.host!==void 0&&j.port!==void 0&&(0,$.$gg)(j.host)&&(0,$.$kg)(j.port)}w(j,z,M,L,B){if(B>=L.length)return-1;const W=!(0,P.$Iw)(z)&&!(0,P.$Kw)(z),q=L.slice(B).findIndex(K=>(0,$.$kg)(K.key)?W?!1:K.key===j:this.t(K.key)?W?!1:j>=K.key.start&&j<=K.key.end:this.u(K.key)?j===K.key.port&&z===K.key.host:M?K.key.test(M):!1);return q>=0?q+B:-1}y(){const j=this.r.getValue(f.c);if(!j||!(0,$.$ig)(j))return[];const z=[];for(const L in j){if(L===void 0)continue;const B=j[L];let W;if(Number(L))W=Number(L);else if((0,$.$gg)(L))if(f.g.test(L)){const ae=L.match(f.g);W={start:Number(ae[1]),end:Number(ae[2])}}else if(f.h.test(L)){const ae=L.match(f.h);W={host:ae[1],port:Number(ae[2])}}else{let ae;try{ae=RegExp(L)}catch{}ae&&(W=ae)}W&&z.push({key:W,elevateIfNeeded:B.elevateIfNeeded,onAutoForward:B.onAutoForward,label:B.label,requireLocalPort:B.requireLocalPort,protocol:B.protocol})}const M=this.r.getValue(f.f);return M&&(this.m={elevateIfNeeded:M.elevateIfNeeded,label:M.label,onAutoForward:M.onAutoForward,requireLocalPort:M.requireLocalPort,protocol:M.protocol}),this.z(z)}z(j){function z(M,L){return(0,$.$kg)(M.key)?M.key:L.t(M.key)?M.key.start:L.u(M.key)?M.key.port:Number.MAX_VALUE}return j.sort((M,L)=>z(M,this)-z(L,this))}C(){return this.m}static providedActionToAction(j){switch(j){case P.ProvidedOnAutoForward.Notify:return C.Notify;case P.ProvidedOnAutoForward.OpenBrowser:return C.OpenBrowser;case P.ProvidedOnAutoForward.OpenBrowserOnce:return C.OpenBrowserOnce;case P.ProvidedOnAutoForward.OpenPreview:return C.OpenPreview;case P.ProvidedOnAutoForward.Silent:return C.Silent;case P.ProvidedOnAutoForward.Ignore:return C.Ignore;default:return}}async addAttributes(j,z,M){const B=this.r.inspect(f.c).userRemoteValue;let W;!B||!(0,$.$ig)(B)?W={}:W=(0,n.$fo)(B),W[`${j}`]||(W[`${j}`]={});for(const ae in z)W[`${j}`][ae]=z[ae];return this.r.updateValue(f.c,W,M)}}e.$3M=f,f.c="remote.portsAttributes",f.f="remote.otherPortsAttributes",f.g=/^(\d+)\-(\d+)$/,f.h=/^([a-z0-9\-]+):(\d{1,5})$/;let N=class extends O.$Xc{constructor(j,z,M,L,B,W,ae,q,K,ee){super(),this.H=j,this.I=z,this.J=M,this.L=L,this.M=B,this.N=W,this.O=ae,this.P=q,this.Q=K,this.R=ee,this.c=new Map,this.g=new k.$ne,this.onForwardPort=this.g.event,this.h=new k.$ne,this.onClosePort=this.h.event,this.j=new k.$ne,this.onPortName=this.j.event,this.n=new k.$ne,this.onCandidatesChanged=this.n.event,this.t=new k.$ne,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new k.$ne,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new f(M),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async re=>{const ge=await this.getAttributes(re.map(Z=>({port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost})));for(const Z of re)if(Z.localAddress){const $e=T(Z.tunnelRemoteHost,Z.tunnelRemotePort),fe=y(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort);this.forwarded.set($e,{remotePort:Z.tunnelRemotePort,remoteHost:Z.tunnelRemoteHost,localAddress:Z.localAddress,protocol:ge?.get(Z.tunnelRemotePort)?.protocol??P.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,ge?.get(Z.tunnelRemotePort)),localPort:Z.tunnelLocalPort,runningProcess:fe?.detail,hasRunningProcess:!!fe,pid:fe?.pid,privacy:Z.privacy,source:e.$WM}),this.f.set($e,Z)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async re=>{const ge=T(re.tunnelRemoteHost,re.tunnelRemotePort);if(!y(this.forwarded,re.tunnelRemoteHost,re.tunnelRemotePort)&&!y(this.detected,re.tunnelRemoteHost,re.tunnelRemotePort)&&!y(this.c,re.tunnelRemoteHost,re.tunnelRemotePort)&&re.localAddress){const Z=y(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort),$e=(await this.getAttributes([{port:re.tunnelRemotePort,host:re.tunnelRemoteHost}]))?.get(re.tunnelRemotePort);this.forwarded.set(ge,{remoteHost:re.tunnelRemoteHost,remotePort:re.tunnelRemotePort,localAddress:re.localAddress,protocol:$e?.protocol??P.TunnelProtocol.Http,localUri:await this.X(re.localAddress,$e),localPort:re.tunnelLocalPort,closeable:!0,runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,privacy:re.privacy,source:e.$WM})}await this.cb(),this.f.set(ge,re),this.g.fire(this.forwarded.get(ge))})),this.B(this.H.onTunnelClosed(re=>this.W(re,b.Other))),this.U()}S(){return this.Q.extensions.find(j=>j.activationEvents?.includes(e.$TM))?(this.R.createKey(e.$UM.key,!0),!0):!1}U(){if(this.S())return;const j=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&j.dispose()}))}async W(j,z){const M=T(j.host,j.port);this.forwarded.has(M)&&(this.forwarded.delete(M),await this.cb(),this.h.fire(j))}X(j,z){if(j.startsWith("http"))return R.URI.parse(j);const M=z?.protocol??"http";return R.URI.parse(`${M}://${j}`)}async Y(j){const z=this.N.getWorkspace(),M=z.configuration?(0,A.$uj)(z.configuration.path):z.folders.length>0?(0,A.$uj)(z.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${j}.${this.L.remoteAuthority}.${M}`}async Z(){return this.Y(i)}async $(){return this.Y(s)}async ab(){const j=this.I.get(i,h.StorageScope.WORKSPACE);if(j)return this.I.remove(i,h.StorageScope.WORKSPACE),await this.cb(),j;const z=await this.Z();if(z)return this.I.get(z,h.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const j=await this.s;if(j&&j!==this.y){const z=JSON.parse(j)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${z.map(M=>M.remotePort).join(", ")}`);for(const M of z){const L=y(this.detected,M.remoteHost,M.remotePort);M.source.source!==E.Extension&&!L||M.source.source===E.Extension&&L?await this.fb({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,elevateIfNeeded:!0,source:M.source}):M.source.source===E.Extension&&!L&&this.D.set(T(M.remoteHost,M.remotePort),M)}}}if(this.z=!0,this.C.fire(),!this.w){const j=await this.Z();this.w=this.B(new O.$Wc),this.w.add(this.I.onDidChangeValue(h.StorageScope.PROFILE,void 0,this.w)(async z=>{z.key===j&&(this.s=Promise.resolve(this.I.get(j,h.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const j=this.I.keys(h.StorageScope.PROFILE,h.StorageTarget.USER).filter(z=>z.startsWith(s));for(const z of j){const M=this.I.getNumber(z,h.StorageScope.PROFILE);if(M&&M<Date.now()){this.s=Promise.resolve(void 0);const L=z.replace(s,i);this.I.remove(z,h.StorageScope.PROFILE),this.I.remove(L,h.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=Array.from(this.forwarded.values()),z=j.map(W=>({remoteHost:W.remoteHost,remotePort:W.remotePort,localPort:W.localPort,name:W.name,localAddress:W.localAddress,localUri:W.localUri,protocol:W.protocol,source:W.source}));let M;j.length>0&&(M=JSON.stringify(z));const L=await this.Z(),B=await this.$();!M&&L&&B?(this.I.remove(L,h.StorageScope.PROFILE),this.I.remove(B,h.StorageScope.PROFILE)):M!==this.y&&L&&B&&(this.I.store(L,M,h.StorageScope.PROFILE,h.StorageTarget.USER),this.I.store(B,Date.now()+d,h.StorageScope.PROFILE,h.StorageTarget.USER)),this.y=M}}async eb(j,z,M){if(!j.tunnelLocalPort||!M?.requireLocalPort||j.tunnelLocalPort===z)return;const L=new Date;if(this.db.getTime()+t>L.getTime())return;this.db=L;const B=r.localize(3,null,z,j.tunnelRemotePort,j.tunnelLocalPort);return this.P.info(B)}async forward(j,z){return!this.z&&this.L.remoteAuthority&&await k.Event.toPromise(this.C.event),this.fb(j,z)}async fb(j,z){await this.Q.activateByEvent(e.$TM);const M=y(this.forwarded,j.remote.host,j.remote.port);z=z??(z!==null?(await this.getAttributes([j.remote]))?.get(j.remote.port):void 0);const L=j.local!==void 0?j.local:j.remote.port;let B;if(M)return this.hb(M,j,z);{const W=this.L.remoteAuthority,ae=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,q=T(j.remote.host,j.remote.port);this.c.set(q,!0),j=this.gb(q,j);const K=await this.H.openTunnel(ae,j.remote.host,j.remote.port,void 0,L,j.elevateIfNeeded?j.elevateIfNeeded:z?.elevateIfNeeded,j.privacy,z?.protocol);if(typeof K=="string")B=K;else if(K&&K.localAddress){const ee=y(this.m??new Map,j.remote.host,j.remote.port),re=K.protocol?K.protocol===P.TunnelProtocol.Https?P.TunnelProtocol.Https:P.TunnelProtocol.Http:z?.protocol??P.TunnelProtocol.Http,ge={remoteHost:K.tunnelRemoteHost,remotePort:K.tunnelRemotePort,localPort:K.tunnelLocalPort,name:z?.label??j.name,closeable:!0,localAddress:K.localAddress,protocol:re,localUri:await this.X(K.localAddress,z),runningProcess:ee?.detail,hasRunningProcess:!!ee,pid:ee?.pid,source:j.source??e.$WM,privacy:K.privacy};return this.forwarded.set(q,ge),this.f.set(q,K),this.c.delete(q),await this.cb(),await this.eb(K,L,z),this.g.fire(ge),K}this.c.delete(q)}return B}gb(j,z){const M=this.D.has(j)?this.D:this.F.has(j)?this.F:void 0;if(M){const L=M.get(j);M.delete(j),L&&(z.name=L.name??z.name,z.local=("local"in L?L.local:"localPort"in L?L.localPort:void 0)??z.local,z.privacy=z.privacy)}return z}async hb(j,z,M){const L=M?.label??z.name;let B;(function(ae){ae[ae.None=0]="None",ae[ae.Fire=1]="Fire",ae[ae.Reopen=2]="Reopen"})(B||(B={}));let W=B.None;switch(L!==j.name&&(j.name=L,W=B.Fire),(M?.protocol||j.protocol!==P.TunnelProtocol.Http)&&M?.protocol!==j.protocol&&(z.source=j.source,W=B.Reopen),z.privacy&&j.privacy!==z.privacy&&(W=B.Reopen),W){case B.Fire:{this.g.fire();break}case B.Reopen:await this.close(j.remoteHost,j.remotePort,b.User),await this.fb(z,M)}return y(this.f,z.remote.host,z.remote.port)}async name(j,z,M){const L=y(this.forwarded,j,z),B=T(j,z);if(L){L.name=M,await this.cb(),this.j.fire({host:j,port:z});return}else this.detected.has(B)&&(this.detected.get(B).name=M,this.j.fire({host:j,port:z}))}async close(j,z,M){const L=T(j,z),B=this.forwarded.get(L);return M===b.AutoForwardEnd&&B&&B.source.source===E.Auto&&this.F.set(L,{local:B.localPort,name:B.name,privacy:B.privacy}),await this.H.closeTunnel(j,z),this.W({host:j,port:z},M)}address(j,z){const M=T(j,z);return(this.forwarded.get(M)||this.detected.get(M))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(j){if(j)for(const z of j){const M=y(this.m??new Map,z.remoteAddress.host,z.remoteAddress.port),L=typeof z.localAddress=="string"?z.localAddress:T(z.localAddress.host,z.localAddress.port);this.detected.set(T(z.remoteAddress.host,z.remoteAddress.port),{remoteHost:z.remoteAddress.host,remotePort:z.remoteAddress.port,localAddress:L,protocol:P.TunnelProtocol.Http,localUri:this.X(L),closeable:!1,runningProcess:M?.detail,hasRunningProcess:!!M,pid:M?.pid,privacy:P.TunnelPrivacyId.ConstantPrivate,source:{source:E.Extension,description:r.localize(4,null)}}),this.H.setEnvironmentTunnel(z.remoteAddress.host,z.remoteAddress.port,L,P.TunnelPrivacyId.ConstantPrivate,P.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(j){this.r=j}async setCandidates(j){let z=j;this.r&&(z=await this.r(j));const M=this.ib(z);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(M.values()).map(L=>L.port).join(", ")}`),this.n.fire(M)}ib(j){const z=this.m??new Map,M=new Map;return this.m=M,j.forEach(L=>{const B=T(L.host,L.port);M.set(B,{host:L.host,port:L.port,detail:L.detail,pid:L.pid}),z.has(B)&&z.delete(B);const W=y(this.forwarded,L.host,L.port);W&&(W.runningProcess=L.detail,W.hasRunningProcess=!0,W.pid=L.pid)}),z.forEach((L,B)=>{const W=u(B);if(!W)return;const ae=y(this.forwarded,W.host,W.port);ae&&(ae.runningProcess=void 0,ae.hasRunningProcess=!1,ae.pid=void 0);const q=y(this.detected,W.host,W.port);q&&(q.runningProcess=void 0,q.hasRunningProcess=!1,q.pid=void 0)}),z}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const j=Array.from(this.forwarded.values()),z=await this.getAttributes(j.map(M=>({port:M.remotePort,host:M.remoteHost})),!1);if(z)for(const M of j){const L=z.get(M.remotePort);(L?.protocol||M.protocol!==P.TunnelProtocol.Http)&&L?.protocol!==M.protocol&&await this.fb({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,source:M.source},L),L&&L.label&&L.label!==M.name&&await this.name(M.remoteHost,M.remotePort,L.label)}}async getAttributes(j,z=!0){const M=new Map,L=new Map;j.forEach(K=>{const ee=y(this.m??new Map,P.$Hw[0],K.port)??K;if(ee){M.set(K.port,ee);const re=v(ee)?ee.pid:void 0;L.has(re)||L.set(re,[]),L.get(re)?.push(K.port)}});const B=new Map;if(j.forEach(K=>{const ee=this.configPortsAttributes.getAttributes(K.port,K.host,M.get(K.port)?.detail);ee&&B.set(K.port,ee)}),this.G.length===0||!z)return B.size>0?B:void 0;const W=await Promise.all(this.G.flatMap(K=>Array.from(L.entries()).map(ee=>{const re=ee[1],ge=M.get(re[0]);return K.providePortAttributes(re,ge?.pid,ge?.detail,g.CancellationToken.None)}))),ae=new Map;if(W.forEach(K=>K.forEach(ee=>{ee&&ae.set(ee.port,ee)})),!B&&!ae)return;const q=new Map;return j.forEach(K=>{const ee=B.get(K.port),re=ae.get(K.port);q.set(K.port,{elevateIfNeeded:ee?.elevateIfNeeded,label:ee?.label,onAutoForward:ee?.onAutoForward??f.providedActionToAction(re?.autoForwardAction),requireLocalPort:ee?.requireLocalPort,protocol:ee?.protocol})}),q}addAttributesProvider(j){this.G.push(j)}};e.$4M=N,Ye([(0,a.$_h)(1e3)],N.prototype,"cb",null),e.$4M=N=Ye([Ve(0,P.$Cw),Ve(1,h.$hq),Ve(2,p.$aj),Ve(3,l.$SM),Ve(4,S.$Rl),Ve(5,w.$Pi),Ve(6,I.$ak),Ve(7,c.$8w),Ve(8,m.$4G),Ve(9,o.$Yj)],N)}),define(Se[100],De([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$LL=e.$KL=void 0;class r{constructor(O,R){this.line=O,this.character=R}isBefore(O){return!1}isBeforeOrEqual(O){return!1}isAfter(O){return!1}isAfterOrEqual(O){return!1}isEqual(O){return!1}compareTo(O){return 0}translate(O,R){return new r(0,0)}with(O){return new r(0,0)}}e.$KL=r;class a{constructor(O,R,p,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(O,R),this.end=new r(p,c)}contains(O){return!1}isEqual(O){return!1}intersection(O){}union(O){return new a(0,0,0,0)}with(O){return new a(0,0,0,0)}}e.$LL=a;var k;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(k||(e.TextSearchCompleteMessageType=k={}))}),define(Se[38],De([1,0,19,39,25,32,13,5,17,14,100,7]),function(ie,e,r,a,k,A,O,R,p,c,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$0L=e.$3L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$ZL=e.$YL=e.$XL=e.$WL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.TextSearchCompleteMessageType=void 0,e.$TL=g,e.$UL=$,e.$VL=n,e.$1L=D,e.$2L=y,e.$4L=v,e.$5L=f,e.$6L=N,e.$7L=F,e.$8L=j,e.$9L=z,e.$$L=L,e.$aM=ae,e.$bM=q,a=Ue(a),k=Ue(k),A=Ue(A),p=Ue(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$ML="workbench.view.search",e.$NL="workbench.panel.search",e.$OL="workbench.view.search",e.$PL="search-result",e.$QL="search.exclude",e.$RL=2e4;const h="\u27EA ",P=" characters skipped \u27EB",w=(h.length+P.length+5)*2;e.$SL=(0,R.$Gi)("searchService");var l;(function(ee){ee[ee.file=0]="file",ee[ee.text=1]="text",ee[ee.aiText=2]="aiText"})(l||(e.SearchProviderType=l={}));var m;(function(ee){ee[ee.File=1]="File",ee[ee.Text=2]="Text",ee[ee.aiText=3]="aiText"})(m||(e.QueryType=m={}));function g(ee){return!!ee.preview}function $(ee){return!!ee.resource}function n(ee){return!!ee.message}var o;(function(ee){ee[ee.Normal=0]="Normal",ee[ee.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class t{constructor(re){this.resource=re,this.results=[]}}e.$WL=t;class i{constructor(re,ge,Z,$e){this.ranges=ge,this.webviewIndex=$e;const fe=Array.isArray(ge)?ge:[ge];if(Z&&Z.matchLines===1&&s(fe)){re=(0,O.$_f)(re,Z.matchLines);let oe="",H=0,ue=0;const te=Math.floor(Z.charsPerLine/5),_=[];for(const ne of fe){const le=Math.max(ne.startColumn-te,0),J=ne.startColumn+Z.charsPerLine;if(le>ue+te+w){const ce=h+(le-ue)+P;oe+=ce+re.slice(le,J),H+=le-(ue+ce.length)}else oe+=re.slice(ue,J);_.push(new u(0,ne.startColumn-H,ne.endColumn-H)),ue=J}this.preview={text:oe,matches:Array.isArray(this.ranges)?_:_[0]}}else{const oe=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:re,matches:(0,r.$4b)(ge,H=>new d(H.startLineNumber-oe,H.startColumn,H.endLineNumber-oe,H.endColumn))}}}}e.$XL=i;function s(ee){const re=ee[0].startLineNumber;for(const ge of ee)if(ge.startLineNumber!==re||ge.endLineNumber!==re)return!1;return!0}class d{constructor(re,ge,Z,$e){this.startLineNumber=re,this.startColumn=ge,this.endLineNumber=Z,this.endColumn=$e}}e.$YL=d;class u extends d{constructor(re,ge,Z){super(re,ge,re,Z)}}e.$ZL=u;var b;(function(ee){ee.List="list",ee.Tree="tree"})(b||(e.ViewMode=b={}));var E;(function(ee){ee.Default="default",ee.FileNames="fileNames",ee.Type="type",ee.Modified="modified",ee.CountDescending="countDescending",ee.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(ee,re=!0){const ge=ee&&ee.files&&ee.files.exclude,Z=re&&ee&&ee.search&&ee.search.exclude;if(!ge&&!Z)return;if(!ge||!Z)return ge||Z;let $e=Object.create(null);return $e=k.$io($e,k.$fo(ge)),$e=k.$io($e,k.$fo(Z),!0),$e}function y(ee,re){return ee.excludePattern&&a.$zk(ee.excludePattern,re)?!1:ee.includePattern||ee.usingSearchPaths?ee.includePattern&&a.$zk(ee.includePattern,re)?!0:ee.usingSearchPaths?!!ee.folderQueries&&ee.folderQueries.some(ge=>{const Z=ge.folder.fsPath;if(A.$Fg(re,Z)){const $e=p.$oc(Z,re);return!ge.includePattern||!!a.$zk(ge.includePattern,$e)}else return!1}):!1:!0}var T;(function(ee){ee[ee.unknownEncoding=1]="unknownEncoding",ee[ee.regexParseError=2]="regexParseError",ee[ee.globParseError=3]="globParseError",ee[ee.invalidLiteral=4]="invalidLiteral",ee[ee.rgProcessError=5]="rgProcessError",ee[ee.other=6]="other",ee[ee.canceled=7]="canceled"})(T||(e.SearchErrorCode=T={}));class C extends Error{constructor(re,ge){super(re),this.code=ge}}e.$3L=C;function v(ee){const re=ee.message;if((0,c.$7)(ee))return new C(re,T.canceled);try{const ge=JSON.parse(re);return new C(ge.message,ge.code)}catch{return new C(re,T.other)}}function f(ee){const re={message:ee.message,code:ee.code};return new Error(JSON.stringify(re))}function N(ee){return ee.type==="error"?!0:ee.type==="success"}function F(ee){return ee.type==="success"}function j(ee){return!!ee.path}function z(ee,re,ge=!0){const Z=ee.searchPath?ee.searchPath:ee.relativePath;return ge?(0,O.$9f)(Z,re):a.$zk(re,Z)}class M{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$0L=M;function L(ee,re){const ge={...ee||{},...re||{}};return Object.keys(ge).filter(Z=>{const $e=ge[Z];return typeof $e=="boolean"&&$e})}class B{constructor(re,ge){this.c=null,this.a={...re.excludePattern||{},...ge.excludePattern||{}},this.b=a.$Ak(this.a);let Z=re.includePattern;ge.includePattern&&(Z?Z={...Z,...ge.includePattern}:Z=ge.includePattern),Z&&(this.c=a.$Ak(Z))}matchesExcludesSync(re,ge,Z){return!!(this.b&&this.b(re,ge,Z))}includedInQuerySync(re,ge,Z){return!(this.b&&this.b(re,ge,Z)||this.c&&!this.c(re,ge,Z))}includedInQuery(re,ge,Z){const $e=this.b(re,ge,Z),fe=()=>this.c?!!this.c(re,ge,Z):!0;return(0,S.$sh)($e)?$e.then(oe=>oe?!1:fe()):fe()}hasSiblingExcludeClauses(){return W(this.a)}}e.$_L=B;function W(ee){for(const re in ee)if(typeof ee[re]!="boolean")return!0;return!1}function ae(ee){if(!ee)return;let re;return ge=>(re||(re=(ee()||Promise.resolve([])).then(Z=>Z?K(Z):{})),re.then(Z=>!!Z[ge]))}function q(ee){if(!ee)return;let re;return ge=>{if(!re){const Z=ee();re=Z?K(Z):{}}return!!re[ge]}}function K(ee){const re={};for(const ge of ee)re[ge]=!0;return re}}),define(Se[42],De([1,0,19,7,21,4,3,85,15,135,23,13,2,245,28,5,12,280,47,63,30,20,16,8,73,38,6,55]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s,d,u,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=e.$Soc=void 0;function D(j,z,M){return new I.$9g(L=>v(L,M)).isEqual(j,z)}function y(j,z,M){return D(j.uri,z.uri,M)?0:(0,S.$Af)(j.uri.toString(),z.uri.toString())}function T(j,z,M){return j.index!==z.index?j.index<z.index?-1:1:D(j.uri,z.uri,M)?(0,S.$Af)(j.name,z.name):(0,S.$Af)(j.uri.toString(),z.uri.toString())}function C(j,z,M,L){const B=j.slice(0).sort((ae,q)=>M(ae,q,L)),W=z.slice(0).sort((ae,q)=>M(ae,q,L));return(0,r.$Hb)(B,W,(ae,q)=>M(ae,q,L))}function v(j,z){const M=z.getCapabilities(j.scheme);return!(M&&M&w.FileSystemProviderCapabilities.PathCaseSensitive)}class f extends $.$Zi{static toExtHostWorkspace(z,M,L,B){if(!z)return{workspace:null,added:[],removed:[]};const{id:W,name:ae,folders:q,configuration:K,transient:ee,isUntitled:re}=z,ge=[],Z=M;M?q.forEach((H,ue)=>{const te=h.URI.revive(H.uri),_=f.o(L||M,te,B);_?(_.name=H.name,_.index=H.index,ge.push(_)):ge.push({uri:te,name:H.name,index:ue})}):ge.push(...q.map(({uri:H,name:ue,index:te})=>({uri:h.URI.revive(H),name:ue,index:te}))),ge.sort((H,ue)=>H.index<ue.index?-1:1);const $e=new f(W,ae,ge,!!ee,K?h.URI.revive(K):null,!!re,H=>v(H,B)),{added:fe,removed:oe}=C(Z?Z.workspaceFolders:[],$e.workspaceFolders,y,B);return{workspace:$e,added:fe,removed:oe}}static o(z,M,L){for(let B=0;B<z.folders.length;B++){const W=z.workspaceFolders[B];if(D(W.uri,M,L))return W}}constructor(z,M,L,B,W,ae,q){super(z,L.map(K=>new $.$1i(K)),B,W,q),this.t=M,this.u=ae,this.q=[],this.s=R.$Mi.forUris(q,()=>!0),L.forEach(K=>{this.q.push(K),this.s.set(K.uri,K)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,M){return M&&this.s.get(z)&&(z=(0,I.$gh)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let N=class{constructor(z,M,L,B,W){this.c=new A.$ne,this.onDidChangeWorkspace=this.c.event,this.g=new A.$ne,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$pe,this.C=new Map,this.h=B,this.s=L,this.t=W,this.j=new c.$Nm,this.k=new a.$Fh,this.o=z.getProxy(b.$vN.MainThreadWorkspace),this.q=z.getProxy(b.$vN.MainThreadMessageService);const ae=M.workspace;this.l=ae?new f(ae.id,ae.name,[],!!ae.transient,ae.configuration?h.URI.revive(ae.configuration):null,!!ae.isUntitled,q=>v(q,L)):void 0}$initializeWorkspace(z,M){this.v=M,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?h.URI.from({scheme:p.Schemas.untitled,path:(0,I.$eh)((0,I.$gh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,M,L,...B){const W=[];if(Array.isArray(B)&&B.forEach(re=>{h.URI.isUri(re.uri)&&!W.some(ge=>D(ge.uri,re.uri,this.s))&&W.push({uri:re.uri,name:re.name||(0,I.$dh)(re.uri)})}),this.n||[M,L].some(re=>typeof re!="number"||re<0)||L===0&&W.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(M+L>ae.length)return!1;const q=ae.slice(0);q.splice(M,L,...W.map(re=>({uri:re.uri,name:re.name||(0,I.$dh)(re.uri),index:void 0})));for(let re=0;re<q.length;re++){const ge=q[re];if(q.some((Z,$e)=>$e!==re&&D(ge.uri,Z.uri,this.s)))return!1}q.forEach((re,ge)=>re.index=ge);const{added:K,removed:ee}=C(ae,q,T,this.s);if(K.length===0&&ee.length===0)return!1;if(this.o){const re=z.displayName||z.name;this.o.$updateWorkspaceFolders(re,M,L,W).then(void 0,ge=>{this.n=void 0;const Z={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(g.Severity.Error,(0,P.localize)(0,null,re,ge.toString()),Z,[])})}return this.y(q),!0}getWorkspaceFolder(z,M){if(this.x)return this.x.getWorkspaceFolder(z,M)}async getWorkspaceFolder2(z,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,M)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,M){let L,B="";if(typeof z=="string"?(L=h.URI.file(z),B=z):typeof z<"u"&&(L=z,B=z.fsPath),!L)return B;const W=this.getWorkspaceFolder(L,!0);if(!W)return B;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let ae=(0,I.$jh)(W.uri,L);return M&&W.name&&(ae=`${W.name}/${ae}`),ae}y(z){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:M,added:L,removed:B}=f.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:B}))}findFiles(z,M,L,B,W=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let ae="",q=!0;return M===null?q=!1:M!==void 0&&(typeof M=="string"?ae=M:ae=M.pattern),this.z(z,void 0,{exclude:ae,maxResults:L,useDefaultExcludes:q,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},W)}findFiles2(z,M={},L,B=k.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${L.value}, entryPoint: findFiles2`),this.z(void 0,z,M,B)}async z(z,M,L,B=k.CancellationToken.None){if(B&&B.isCancellationRequested)return Promise.resolve([]);const W=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,ae={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof L.useDefaultSearchExcludes=="boolean"?!L.useDefaultSearchExcludes:!1,maxResults:L.maxResults,excludePattern:W,shouldGlobSearch:typeof L.fuzzy=="boolean"?!L.fuzzy:!0,_reason:"startFileSearch"};let q;if(z){const{includePattern:K,folder:ee}=F(i.GlobPattern.from(z));q=ee,ae.includePattern=K}else{const{includePattern:K,folder:ee}=F(i.GlobPattern.from(M));q=ee,ae.filePattern=K}return this.o.$startFileSearch(q??null,ae,B).then(K=>Array.isArray(K)?K.map(ee=>h.URI.revive(ee)):[])}async findTextInFiles(z,M,L,B,W=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),q=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:K,folder:ee}=F(i.GlobPattern.from(M.include)),re=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ge={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:q,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:K,excludePattern:re},Z=!1;if(this.u[ae]=$e=>{if(Z)return;const fe=h.URI.revive($e.resource);$e.results.forEach(oe=>{const H=(0,E.$di)(oe);(0,u.$TL)(H)?L({uri:fe,preview:{text:H.preview.text,matches:(0,r.$4b)(H.preview.matches,ue=>new s.$zN(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))},ranges:(0,r.$4b)(H.ranges,ue=>new s.$zN(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))}):L({uri:fe,text:H.text,lineNumber:H.lineNumber})})},W.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(z,ee??null,ge,ae,W);return delete this.u[ae],$e||{}}catch($e){throw delete this.u[ae],$e}}$handleTextSearchResult(z,M){this.u[M]?.(z)}async save(z){const M=await this.o.$save(z,{saveAs:!1});return h.URI.revive(M)}async saveAs(z){const M=await this.o.$save(z,{saveAs:!0});return h.URI.revive(M)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,M){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,M);const L=this.t.transformOutgoingScheme(z),B=this.A++;return this.o.$registerEditSessionIdentityProvider(B,L),(0,O.$Vc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(z,M){this.h.info("Getting edit session identifier for workspaceFolder",z);const L=await this.resolveWorkspaceFolder(h.URI.revive(z));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const B=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!B),!B)return;const W=await B.provideEditSessionIdentity(L,M);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(z,M,L,B){this.h.info("Getting edit session identifier for workspaceFolder",z);const W=await this.resolveWorkspaceFolder(h.URI.revive(z));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const ae=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!ae),!ae)return;const q=await ae.provideEditSessionIdentityMatch?.(M,L,B);if(this.h.info("Provider returned edit session identifier match result: ",q),!!q)return q}getOnWillCreateEditSessionIdentityEvent(z){return(M,L,B)=>{const W=function(q){M.call(L,q)};return W.extension=z,this.B.event(W,void 0,B)}}async $onWillCreateEditSessionIdentity(z,M,L){const B=await this.resolveWorkspaceFolder(h.URI.revive(z));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:B},M,async(W,ae)=>{const q=Date.now();await Promise.resolve(W),Date.now()-q>L&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(z,M){if(this.C.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.C.set(z,M);const L=this.t.transformOutgoingScheme(z),B=this.A++;return this.o.$registerCanonicalUriProvider(B,L),(0,O.$Vc)(()=>{this.C.delete(z),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(z,M,L){const B=this.C.get(z.scheme);if(!B)return;const W=await B.provideCanonicalUri?.(h.URI.revive(z),M,L);if(W)return W}async $provideCanonicalUri(z,M,L){return this.provideCanonicalUri(h.URI.revive(z),{targetScheme:M},L)}};e.$Soc=N,e.$Soc=N=Ye([Ve(0,t.$2P),Ve(1,o.$fQ),Ve(2,n.$Boc),Ve(3,m.$ak),Ve(4,d.$Qoc)],N),e.$Toc=(0,l.$Gi)("IExtHostWorkspace");function F(j){let z,M;return j&&(typeof j=="string"?z=j:(z=j.pattern,M=h.URI.revive(j.baseUri))),{includePattern:z,folder:M}}}),define(Se[43],De([1,0,25,4,42,6,8,46,282,71,18,7,5,20,12,2]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=e.$Voc=e.$Uoc=void 0;function m(d,u){if(u){const b=u.split(".");let E=d;for(let D=0;E&&D<b.length;D++)E=E[b[D]];return E}}function g(d){return d instanceof l.URI}function $(d){return d&&d.uri instanceof l.URI&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function o(d){return d&&d.uri instanceof l.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function t(d){if(g(d))return{resource:d};if($(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(n(d))return{overrideIdentifier:d.languageId};if(o(d))return{resource:d.uri};if(d===null)return{resource:null}}let i=class{constructor(u,b,E){this.a=u.getProxy(A.$vN.MainThreadConfiguration),this.c=b,this.b=E,this.d=new S.$Fh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new s(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,b){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(u,b))}};e.$Uoc=i,e.$Uoc=i=Ye([Ve(0,P.$2P),Ve(1,k.$Toc),Ve(2,w.$ak)],i);class s{constructor(u,b,E,D){this.a=new a.$ne,this.b=u,this.f=D,this.c=b,this.e=p.$Qo.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,b){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Qo.parse(u,this.f),this.d=this.k(u.configurationScopes),this.a.fire(this.j(b,E))}getConfiguration(u,b,E){const D=t(b)||{},y=this.g(u?m(this.e.getValue(void 0,D,this.c.workspace),u):this.e.getValue(void 0,D,this.c.workspace));u&&this.h(u,D,E?.identifier);function T(v){if(v==null)return null;if(typeof v=="boolean")return v?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(v){case O.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case O.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case O.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const C={has(v){return typeof m(y,v)<"u"},get:(v,f)=>{this.h(u?`${u}.${v}`:v,D,E?.identifier);let N=m(y,v);if(typeof N>"u")N=f;else{let F;const j=(z,M)=>{if((0,I.$ig)(z)){let L;const B=()=>{F=F||(0,r.$fo)(y),L=L||m(F,M)};return new Proxy(z,{get:(W,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return B(),()=>L;if(F)return L=L||m(F,M),L[ae];const q=W[ae];return typeof ae=="string"?j(q,`${M}.${ae}`):q},set:(W,ae,q)=>(B(),L&&(L[ae]=q),!0),deleteProperty:(W,ae)=>(B(),L&&delete L[ae],!0),defineProperty:(W,ae,q)=>(B(),L&&Object.defineProperty(L,ae,q),!0)})}return Array.isArray(z)?(0,r.$fo)(z):z};N=j(N,v)}return N},update:(v,f,N,F)=>{v=u?`${u}.${v}`:v;const j=T(N);return f!==void 0?this.b.$updateConfigurationOption(j,v,f,D,F):this.b.$removeConfigurationOption(j,v,D,F)},inspect:v=>{v=u?`${u}.${v}`:v;const f=this.e.inspect(v,D,this.c.workspace);if(f)return{key:v,defaultValue:(0,r.$fo)(f.policy?.value??f.default?.value),globalValue:(0,r.$fo)(f.user?.value??f.application?.value),workspaceValue:(0,r.$fo)(f.workspace?.value),workspaceFolderValue:(0,r.$fo)(f.workspaceFolder?.value),defaultLanguageValue:(0,r.$fo)(f.default?.override),globalLanguageValue:(0,r.$fo)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,r.$fo)(f.workspace?.override),workspaceFolderLanguageValue:(0,r.$fo)(f.workspaceFolder?.override),languageIds:(0,r.$fo)(f.overrideIdentifiers)}}};return typeof y=="object"&&(0,r.$io)(C,y,!1),Object.freeze(C)}g(u){const b=E=>(0,I.$ig)(E)?new Proxy(E,{get:(D,y)=>b(D[y]),set:(D,y,T)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return b(u)}h(u,b,E){const D=c.$Ho.test(u)?c.ConfigurationScope.RESOURCE:this.d.get(u),y=E?`[${E.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof b?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){b?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,b){const E=new p.$So(u,b,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>E.affectsConfiguration(D,t(y))})}k(u){return u.reduce((b,E)=>(b.set(E[0],E[1]),b),new Map)}}e.$Voc=s,e.$Woc=(0,h.$Gi)("IExtHostConfiguration")});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[101],De([1,0,2,7,4,6,8,42,64,43,21,48,20,30,5,15,11,12,96,323,14]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=e.$tqc=e.$sqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,O=Ue(O),m=Ue(m);var i;(function(j){function z(L){if(L!=null)return L}j.from=z;function M(L){if(L!=null)return L}j.to=M})(i||(i={}));var s;(function(j){function z(L){if(L!=null)return L}j.from=z;function M(L){if(L!=null)return L}j.to=M})(s||(s={}));var d;(function(j){function z(L){if(L!=null)return L}j.from=z;function M(L){if(L!=null)return L}j.to=M})(d||(d={}));var u;(function(j){function z(B){if(B){const W=B;return W&&!!W.process}else return!1}j.is=z;function M(B){if(B==null)return;const W={process:B.process,args:B.args};return B.options&&(W.options=d.from(B.options)),W}j.from=M;function L(B){if(B!=null)return new O.$hO(B.process,B.args,B.options)}j.to=L})(u||(u={}));var b;(function(j){function z(L){if(L!=null)return L}j.from=z;function M(L){if(L!=null)return L}j.to=M})(b||(b={}));var E;(function(j){function z(B){if(B){const W=B;return W&&(!!W.commandLine||!!W.command)}else return!1}j.is=z;function M(B){if(B==null)return;const W={};return B.commandLine!==void 0?W.commandLine=B.commandLine:(W.command=B.command,W.args=B.args),B.options&&(W.options=b.from(B.options)),W}j.from=M;function L(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new O.$iO(B.commandLine,B.options):new O.$iO(B.command,B.args?B.args:[],B.options)}j.to=L})(E||(E={}));var D;(function(j){function z(B){if(B){const W=B;return W&&W.customExecution==="customExecution"}else return!1}j.is=z;function M(B){return{customExecution:"customExecution"}}j.from=M;function L(B,W){return W.get(B)}j.to=L})(D||(e.CustomExecutionDTO=D={}));var y;(function(j){function z(M,L){let B;return M.scope!==void 0&&typeof M.scope!="number"?B=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===O.TaskScope.Workspace&&L&&L.workspaceFile?B=L.workspaceFile:B=n.$JI),{id:M._id,workspaceFolder:B}}j.from=z})(y||(e.TaskHandleDTO=y={}));var T;(function(j){function z(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}j.from=z})(T||(T={}));var C;(function(j){function z(B,W){if(B==null)return[];const ae=[];for(const q of B){const K=M(q,W);K&&ae.push(K)}return ae}j.fromMany=z;function M(B,W){if(B==null)return;let ae;B.execution instanceof O.$hO?ae=u.from(B.execution):B.execution instanceof O.$iO?ae=E.from(B.execution):B.execution&&B.execution instanceof O.$jO&&(ae=D.from(B.execution));const q=i.from(B.definition);let K;return B.scope?typeof B.scope=="number"?K=B.scope:K=B.scope.uri:K=O.TaskScope.Workspace,!q||!K?void 0:{_id:B._id,definition:q,name:B.name,source:{extensionId:W.identifier.value,label:B.source,scope:K},execution:ae,isBackground:B.isBackground,group:T.from(B.group),presentationOptions:s.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}j.from=M;async function L(B,W,ae){if(B==null)return;let q;u.is(B.execution)?q=u.to(B.execution):E.is(B.execution)?q=E.to(B.execution):D.is(B.execution)&&(q=D.to(B._id,ae));const K=i.to(B.definition);let ee;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ee=B.source.scope:ee=await W.resolveWorkspaceFolder(r.URI.revive(B.source.scope)):ee=O.TaskScope.Workspace),!K||!ee)return;const re=new O.$kO(K,ee,B.name,B.source.label,q,B.problemMatchers);return B.isBackground!==void 0&&(re.isBackground=B.isBackground),B.group!==void 0&&(re.group=O.$gO.from(B.group._id),re.group&&B.group.isDefault&&(re.group=new O.$gO(re.group.id,re.group.label),B.group.isDefault===!0&&(re.group.isDefault=B.group.isDefault))),B.presentationOptions&&(re.presentationOptions=s.to(B.presentationOptions)),B._id&&(re._id=B._id),B.detail&&(re.detail=B.detail),re}j.to=L})(C||(e.TaskDTO=C={}));var v;(function(j){function z(L){return L}j.from=z;function M(L){if(L)return Object.assign(Object.create(null),L)}j.to=M})(v||(v={}));class f{constructor(z,M,L){this._id=M,this.a=L,t.set(this,void 0),ot(this,t,z,"f")}get task(){return this.a}terminate(){He(this,t,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}t=new WeakMap;let N=class{constructor(z,M,L,B,W,ae,q,K){this.q=new k.$ne,this.r=new k.$ne,this.s=new k.$ne,this.u=new k.$ne,this.a=z.getProxy(A.$vN.MainThreadTask),this.b=L,this.c=B,this.d=W,this.e=ae,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=q,this.g=K,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,M,L){if(!L)return new O.$xN(()=>{});const B=this.x();return this.j.set(B,{type:M,provider:L,extension:z}),this.a.$registerTaskProvider(B,M),new O.$xN(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem(z,M){this.a.$registerTaskSystem(z,M)}fetchTasks(z){return this.a.$fetchTasks(v.from(z)).then(async M=>{const L=[];for(const B of M){const W=await C.to(B,this.b,this.m);W&&L.push(W)}return L})}get taskExecutions(){const z=[];return this.k.forEach(M=>z.push(M)),z}terminateTask(z){if(!(z instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,M,L){const B=this.m.get(z.id);B&&(this.o.set(z.id,B),this.e.attachPtyToTerminal(M,await B.callback(L))),this.p=z.id,this.q.fire({execution:await this.z(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){if(!this.l.has(z.id))return;const M=await this.z(z);this.l.delete(z.id),this.k.delete(z.id),this.B(z),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const M=await this.z(z.id);this.s.fire({execution:M,processId:z.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(z){const M=await this.z(z.id);this.u.fire({execution:M,exitCode:z.exitCode})}$provideTasks(z,M){const L=this.j.get(z);if(!L)return Promise.reject(new Error("no handler found"));const B=[],W=(0,a.$yh)(()=>L.provider.provideTasks(I.CancellationToken.None)).then(ae=>this.v(M,B,L,ae));return new Promise(ae=>{W.then(q=>{Promise.all(B).then(()=>{ae(q)})})})}async $resolveTask(z,M){const L=this.j.get(z);if(!L)return Promise.reject(new Error("no handler found"));if(M.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${L.type}].`);const B=await C.to(M,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const W=await L.provider.resolveTask(B,I.CancellationToken.None);if(!W)return;this.A(W,L);const ae=C.from(W,L.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(ae.execution)&&await this.y(ae,W,!0),await this.w(ae)}x(){return this.h++}async y(z,M,L){const B=await this.a.$createTaskId(z);!L&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,M.execution)),this.m.set(B,M.execution)}async z(z,M){if(typeof z=="string"){const W=this.l.get(z);if(!W)throw new o.$eb("Unexpected: The specified task is missing an execution");return W}const L=this.l.get(z.id);if(L)return L;let B;return M?B=Promise.resolve(new f(this,z.id,M)):B=C.to(z.task,this.b,this.m).then(W=>{if(!W)throw new o.$eb("Unexpected: Task does not exist.");return new f(this,z.id,W)}),this.l.set(z.id,B),B.then(W=>(this.k.set(z.id,W),W))}A(z,M){z._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}B(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const L=this.n.values();let B=L.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=L.next()}};e.$sqc=N,e.$sqc=N=Ye([Ve(0,h.$2P),Ve(1,P.$fQ),Ve(2,R.$Toc),Ve(3,p.$aQ),Ve(4,c.$Woc),Ve(5,S.$ipc),Ve(6,g.$ak),Ve(7,$.$xoc)],N);let F=class extends N{constructor(z,M,L,B,W,ae,q,K){super(z,M,L,B,W,ae,q,K),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:m.$b(m.Platform.Web)})}async executeTask(z,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const L=C.from(M,z);if(L===void 0)throw new Error("Task is not valid");if(D.is(L.execution))await this.y(L,M,!1);else throw new o.$cb;const B=await this.z(await this.a.$getTaskExecution(L),M);return this.a.$executeTask(L).catch(W=>{throw new Error(W)}),B}v(z,M,L,B){const W=[];if(B)for(const ae of B){if(this.A(ae,L),!ae.definition||!z[ae.definition.type]){const K=ae.source?ae.source:"No task source";this.f.warn(`The task [${K}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`)}const q=C.from(ae,L.extension);q&&D.is(q.execution)?(W.push(q),M.push(this.y(q,ae,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:L.extension}}async w(z){if(D.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,M,L){}};e.$tqc=F,e.$tqc=F=Ye([Ve(0,h.$2P),Ve(1,P.$fQ),Ve(2,R.$Toc),Ve(3,p.$aQ),Ve(4,c.$Woc),Ve(5,S.$ipc),Ve(6,g.$ak),Ve(7,$.$xoc)],F),e.$uqc=(0,w.$Gi)("IExtHostTask")}),define(Se[384],De([1,0,38,31]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=void 0,e.$hM=k,e.$jM=A;function k(O){return"cellResults"in O}e.$iM="rawCell#";function A(O,R){let p=-1;const c=[];let I=[];return O.forEach(h=>{h.range.startLineNumber!==p&&I.length>0&&(c.push([...I]),I=[]),I.push(h),p=h.range.endLineNumber}),I.length>0&&c.push([...I]),c.map(h=>{const P=[],w=h[0].range.startLineNumber,l=h[h.length-1].range.endLineNumber;for(let m=w;m<=l;m++)P.push(R.getLineContent(m));return new r.$XL(P.join(`
`)+`
`,h.map(m=>new a.$Nt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(Se[385],De([1,0,239,22,4,3,29,41,13,18,2,28,119,6,35,16,8,52,357,166,25,15,38,313,384,381]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0,S=Ue(S),l=Ue(l),m=Ue(m);class b{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,T,C,v,f,N){this.q=T,this.r=C,this.s=v,this.t=f,this.u=N,this.f=new Map,this.g=new O.$Dc,this.h=new Map,this.j=new k.$ne,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.$ne,this.onDidOpenNotebookDocument=this.m.event,this.n=new k.$ne,this.onDidCloseNotebookDocument=this.n.event,this.o=new k.$ne,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new h.$voc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(P.$vN.MainThreadNotebook),this.c=D.getProxy(P.$vN.MainThreadNotebookDocuments),this.d=D.getProxy(P.$vN.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===R.MarshalledId.NotebookCellActionContext){const j=F.notebookEditor?.notebookUri,z=F.cell.handle,L=this.g.get(j)?.getCell(z);if(L)return L.apiCell}if(F&&F.$mid===R.MarshalledId.NotebookActionContext){const j=F.uri,z=this.g.get(j);if(z)return z.apiNotebook}return F}}),b.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,T]of this.h)if(T.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const T=this.g.get(D);if(!T&&!y)throw new Error(`NO notebook document for '${D}'`);return T}static w(D,y){if(!y)return;const T=y.filenamePattern.map(C=>l.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(y.filenamePattern&&!T){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:T,priority:y.exclusive?u.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,y,T){const C=b.a++,v=typeof T.onDidChangeCellStatusBarItems=="function"?b.a++:void 0;this.f.set(C,T),this.b.$registerNotebookCellStatusBarItemProvider(C,v,y);let f;return v!==void 0&&(f=T.onDidChangeCellStatusBarItems(N=>this.b.$emitCellStatusBarEvent(v))),new m.$xN(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,v),f?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&l.NotebookData.from(D.content)});return I.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const T=await this.c.$tryOpenNotebook(D),C=this.g.get(I.URI.revive(T));return(0,c.$rg)(C?.apiNotebook)}async showNotebookDocument(D,y){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let T;typeof y=="object"?T={position:l.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(l.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:T={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,T),v=C&&this.h.get(C)?.apiEditor;if(v)return v;throw C?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,T,C){const v=this.f.get(D),f=I.URI.revive(y),N=this.g.get(f);if(!N||!v)return;const F=N.getCellFromIndex(T);if(!F)return;const j=await v.provideCellStatusBarItems(F.apiCell,C);if(!j)return;const z=new A.$Wc,M=this.p.add([z]),B=(Array.isArray(j)?j:[j]).map(W=>l.NotebookStatusBarItem.from(W,this.i,z));return{cacheId:M,items:B}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,T,C,v){if((0,p.$ef)(y))throw new Error("viewType cannot be empty or just whitespace");const f=this.x++;return this.y.set(f,{viewType:y,serializer:T,options:C}),this.b.$registerNotebookSerializer(f,{id:D.identifier,location:D.extensionLocation},y,l.NotebookDocumentContentOptions.from(C),b.w(D,v)),(0,A.$Vc)(()=>{this.b.$unregisterNotebookSerializer(f)})}async $dataToNotebook(D,y,T){const C=this.y.get(D);if(!C)throw new Error("NO serializer found");const v=await C.serializer.deserializeNotebook(y.buffer,T);return new g.$Vw(l.NotebookData.from(v))}async $notebookToData(D,y,T){const C=this.y.get(D);if(!C)throw new Error("NO serializer found");const v=await C.serializer.serializeNotebook(l.NotebookData.to(y.value),T);return a.$Pe.wrap(v)}async $saveNotebook(D,y,T,C,v){const f=I.URI.revive(y),N=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${T}, ${f.toString()})`),!N)throw new Error("NO serializer found");const F=this.g.get(f);if(!F)throw new Error("Document NOT found");if(F.versionId!==T)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(f.scheme))throw new S.$vl((0,r.localize)(0,null,this.A(f)),S.FileOperationResult.FILE_PERMISSION_DENIED);const j={metadata:(0,o.$no)(F.apiNotebook.metadata,W=>!(N.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of F.apiNotebook.getCells()){const ae=new m.$1O(W.kind,W.document.getText(),W.document.languageId,W.mime,N.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);ae.metadata=(0,o.$no)(W.metadata,q=>!(N.options?.transientCellMetadata??{})[q]),j.cells.push(ae)}if(await this.z(f,C),v.isCancellationRequested)throw new Error("canceled");const z=await N.serializer.serializeNotebook(j,v);if(v.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${T} ${f.toString()}`),await this.s.value.writeFile(f,z),this.D(`Finished write versionId: ${T} ${f.toString()}`);const M=this.s.getFileSystemProviderExtUri(f.scheme),L=await this.s.value.stat(f),B={name:M.basename(f),isFile:(L.type&S.FileType.File)!==0,isDirectory:(L.type&S.FileType.Directory)!==0,isSymbolicLink:(L.type&S.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&S.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(f.scheme),locked:!!((L.permissions??0)&S.FilePermission.Locked),etag:S.$Gl({mtime:L.mtime,size:L.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${T}, ${f.toString()})`),B}async $searchInNotebooks(D,y,T,C,v){const f=this.y.get(D)?.serializer;if(!f)return{limitHit:!1,results:[]};const N=new O.$Ec;await(async(L,B,W)=>{await Promise.all(L.map(async ae=>await Promise.all(ae.filenamePatterns.map(q=>{const K={_reason:W._reason,folderQueries:W.folderQueries,includePattern:W.includePattern,excludePattern:W.excludePattern,maxResults:W.maxResults,type:i.QueryType.File,filePattern:q};return this.t.doInternalFileSearchWithCustomCallback(K,B,ee=>{ee.forEach(re=>{N.has(re)||C.some(Z=>ae.isFromSettings&&!Z.isFromSettings?!1:Z.filenamePatterns.some($e=>(0,u.$eL)($e,re)))||N.add(re)})}).catch(ee=>{if(ee.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ee})}))))})(T,v,y);const j=new O.$Dc;let z=!1;const M=Array.from(N).map(async L=>{const B=[];try{if(v.isCancellationRequested)return;if(y.maxResults&&[...j.values()].reduce((K,ee)=>K+ee.cellResults.length,0)>y.maxResults){z=!0;return}const W=[],ae=this.g.get(L);if(ae)ae.apiNotebook.getCells().forEach(ee=>W.push({input:ee.document.getText(),outputs:ee.outputs.flatMap(re=>re.items.map(ge=>ge.data.toString()))}));else{const K=await this.s.value.readFile(L),ee=a.$Pe.fromString(K.toString()),re=await f.deserializeNotebook(ee.buffer,v);if(v.isCancellationRequested)return;l.NotebookData.from(re).cells.forEach(Z=>W.push({input:Z.source,outputs:Z.outputs.flatMap($e=>$e.items.map(fe=>fe.valueBytes.toString()))}))}if(v.isCancellationRequested)return;W.forEach((K,ee)=>{const re=y.contentPattern.pattern,ge=new s.$LZb(K.input,void 0,K.outputs),Z=ge.findInInputs(re),$e=ge.findInOutputs(re),fe=$e.flatMap(oe=>(0,d.$jM)(oe.matches,oe.textBuffer)).map((oe,H)=>(oe.webviewIndex=H,oe));if(Z.length>0||$e.length>0){const oe={index:ee,contentResults:(0,d.$jM)(Z,ge.inputTextBuffer),webviewResults:fe};B.push(oe)}});const q={resource:L,cellResults:B};j.set(L,q);return}catch{return}});return await Promise.all(M),{limitHit:z,results:[...j.values()]}}async z(D,y){const T=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==S.$Fl&&typeof T.mtime=="number"&&typeof T.size=="number"&&y.mtime<T.mtime&&y.etag!==S.$Gl({mtime:y.mtime,size:T.size}))throw new S.$vl((0,r.localize)(1,null),S.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,y,T){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const C=new n.$Xpc(y,this.d,D,T.visibleRanges.map(l.NotebookRange.to),T.selections.map(l.NotebookRange.to),typeof T.viewColumn=="number"?l.ViewColumn.to(T.viewColumn):void 0);this.h.set(y,C)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const T of D.value.removedDocuments){const C=I.URI.revive(T),v=this.g.get(C);v&&(v.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(f=>f.document.uri)}),this.n.fire(v.apiNotebook));for(const f of this.h.values())f.notebookData.uri.toString()===C.toString()&&this.h.delete(f.id)}if(D.value.addedDocuments){const T=[];for(const C of D.value.addedDocuments){const v=I.URI.revive(C.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const f=new $.$Wpc(this.c,this.q,this.r,v,C);T.push(...C.cells.map(N=>$.$Vpc.asModelAddData(N))),this.g.get(v)?.dispose(),this.g.set(v,f),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:T}),this.m.fire(f.apiNotebook)}}if(D.value.addedEditors)for(const T of D.value.addedEditors){if(this.h.has(T.id))return;const C=I.URI.revive(T.documentUri),v=this.g.get(C);v&&this.B(v,T.id,T)}const y=[];if(D.value.removedEditors)for(const T of D.value.removedEditors){const C=this.h.get(T);C&&(this.h.delete(T),this.k?.id===C.id&&(this.k=void 0),y.push(C))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const T=new Set;this.l.forEach(C=>T.add(C.id));for(const C of this.h.values()){const v=T.has(C.id);C._acceptVisibility(v)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=w.$nQ.String.with("notebookType","A notebook type"),T=new w.$pQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new w.$nQ("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>a.$Pe.wrap(v))],new w.$oQ("Notebook Data",v=>l.NotebookData.to(v.value))),C=new w.$pQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new w.$nQ("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new g.$Vw(l.NotebookData.from(v)))],new w.$oQ("Bytes",v=>v.buffer));D.registerApiCommand(T),D.registerApiCommand(C)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$7pc=b,b.a=0}),define(Se[386],De([1,0,17,21,51,39,23,44,38]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0,r=Ue(r),A=Ue(A),O=Ue(O);class c{constructor(h,P,w){this.k=h,this.l=P,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&A.$Ak(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&A.$Ak(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const P=this.k.folderQueries||[];return new Promise((w,l)=>{const m=g=>{this.f++,h(g)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(g=>{const $=g.toString(),n=r.$qc($);this.j&&this.j($,n)||this.v(m,{base:g,basename:n})}),Promise.all(P.map(g=>this.p(g,m))).then(g=>{w({limitHit:this.e,stats:g[0]||void 0})},g=>{l(new Error((0,k.$rj)(g)))})})}async p(h,P){const w=new a.$ye,l=this.q(h),m=this.r(),g=new p.$_L(this.k,h),$=!g.hasSiblingExcludeClauses();let n;try{this.h.add(w),n=R.$he.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,w.token),t=n.elapsed(),i=R.$he.create();return this.g&&!this.e||(o&&o.forEach(s=>{const d=r.$jc.relative(h.folder.path,s.path);if($){const u=r.$qc(s.path);this.v(P,{base:h.folder,relativePath:d,basename:u});return}this.s(m,h.folder,d,P)}),this.g&&!this.e)?null:(this.u(m,g,P),{providerTime:t,postProcessTime:i.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(h){const P=(0,p.$$L)(this.k.includePattern,h.includePattern),w=(0,p.$$L)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:w,includes:P,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},P,w,l){if(w===this.a){const g=r.$qc(this.a);this.v(l,{base:P,relativePath:this.a,basename:g})}function m(g){const $=r.$qc(g),n=r.$pc(g);let o=h[n];o||(o=h[n]=[],m(n)),o.push({base:P,relativePath:g,basename:$})}m(w)}u({rootEntries:h,pathToEntries:P},w,l){const m=this,g=this.a;function $(n){const o=(0,p.$bM)(()=>n.map(t=>t.basename));for(let t=0,i=n.length;t<i;t++){const s=n[t],{relativePath:d,basename:u}=s;if(w.matchesExcludesSync(d,u,g!==u?o:void 0))continue;const b=P[d];if(b)$(b);else{if(d===g)continue;m.v(l,s)}if(m.e)break}}$(h)}v(h,P){(!this.b||P.relativePath&&this.b(P.relativePath,P.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(P))}}class I{constructor(){this.b=new Map}fileSearch(h,P,w,l){const m=this.c(h.cacheKey),g=new c(h,P,m&&m.token);let $=0;const n=o=>{$+=o.length,w(o.map(t=>this.d(t)))};return this.e(g,I.a,n,l).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:$,detailStats:o.stats}:void 0,messages:[]}))}clearCache(h){this.c(h)?.cancel()}c(h){if(h)return this.b.has(h)||this.b.set(h,new a.$ye),this.b.get(h)}d(h){return h.relativePath?{resource:O.$hh(h.base,h.relativePath)}:{resource:h.base}}e(h,P,w,l){const m=l.onCancellationRequested(()=>{h.cancel()}),g=n=>{n&&($.push(n),P>0&&$.length>=P&&(w($),$=[]))};let $=[];return h.search(g).then(n=>($.length&&w($),m.dispose(),n),n=>($.length&&w($),m.dispose(),Promise.reject(n)))}}e.$Ypc=I,I.a=512}),define(Se[387],De([1,0,19,79,39,108,29,15,17,23,13,18,2,112,262,46,12,47,158,382,38]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0,e.$aN=y,r=Ue(r),a=Ue(a),k=Ue(k),p=Ue(p),I=Ue(I),w=Ue(w);let t=class{constructor(C,v,f,N,F){this.a=C,this.b=v,this.c=f,this.d=N,this.e=F}text(C,v,f={}){C=this.f(C,f);const N=this.a.getValue(),F=v&&v.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(v?.map(g.$2i),f),type:o.QueryType.Text,contentPattern:C,previewOptions:f.previewOptions,maxFileSize:f.maxFileSize,usePCRE2:N.search.usePCRE2||F||!1,beforeContext:f.beforeContext,afterContext:f.afterContext,userDisabledExcludesAndIgnoreFiles:f.disregardExcludeSettings&&f.disregardIgnoreFiles}}f(C,v){const f=this.a.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const N={...C,wordSeparators:f.editor.wordSeparators};return this.j(C,v)&&(N.isCaseSensitive=!0),this.k(C)&&(N.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),N}file(C,v={}){return{...this.h(C,v),type:o.QueryType.File,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey,shouldGlobMatchFilePattern:v.shouldGlobSearch}}g(C,v){return C?(C=Array.isArray(C)?C.map(b):b(C),v?this.parseSearchPaths(C):{pattern:s(...Array.isArray(C)?C:[C])}):{}}h(C=[],v={}){const f=this.g(v.includePattern,v.expandPatterns),N=this.g(v.excludePattern,v.expandPatterns),F=C.length>1,j=(f.searchPaths&&f.searchPaths.length?f.searchPaths.map(L=>this.q(L,v,N)):C.map(L=>this.r(L,v,N,F))).filter(L=>!!L),z={_reason:v._reason,folderQueries:j,usingSearchPaths:!!(f.searchPaths&&f.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:N.pattern,includePattern:f.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const L=r.$Kb(this.c.groups.flatMap(ae=>ae.editors.map(q=>q.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const B=L.filter(ae=>(0,o.$2L)(z,ae.fsPath)),W=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const M=v.extraFileResources&&v.extraFileResources.filter(L=>(0,o.$2L)(z,L.fsPath));return z.extraFileResources=M&&M.length?M:void 0,z}i(C){const v=[],f=new O.$Dc,N={};let F=!1;return C.forEach(j=>{if(j.scheme===R.Schemas.walkThrough)return;if((0,c.$lh)(j)){const M=this.b.getWorkspaceFolder(j)?.uri??j.with({path:p.$pc(j.fsPath)});let L=f.get(M);L||(F=!0,L={folder:M,includePattern:{}},v.push(L),f.set(M,L));const B=p.$oc(M.fsPath,j.fsPath);(0,S.$rg)(L.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&(F=!0,N[j.fsPath]=!0)}),{folderQueries:v,includePattern:N,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(C,v){if(v.isSmartCase){if(C.isRegExp){if(I.$0f(C.pattern,!0))return!0}else if(I.$0f(C.pattern))return!0}return!!C.isCaseSensitive}k(C){return C.isMultiline||C.isRegExp&&(0,P.$cD)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const v=W=>p.$lc(W)||/^\.\.?([\/\\]|$)/.test(W),N=(Array.isArray(C)?C:d(C)).map(W=>{const ae=this.e.resolvedUserHome;return ae?(0,A.$1w)(W,ae.scheme===R.Schemas.file?ae.fsPath:ae.path):W}),F=a.$E(N,W=>v(W)?"searchPaths":"exprSegments"),j=(F.exprSegments||[]).map(W=>I.$pf(W,"/")).map(W=>I.$pf(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),u(W))),z={},M=this.m(F.searchPaths||[]);M&&M.length&&(z.searchPaths=M);const L=j.flat(),B=s(...L);return B&&(z.pattern=B),z}l(C,v){return v.disregardExcludeSettings?void 0:(0,o.$1L)(C,!v.disregardSearchExcludeSettings)}m(C){if(!C||!C.length)return[];const v=C.flatMap(N=>{let{pathPortion:F,globPortion:j}=i(N);return j&&(j=E(j)),this.n(F).flatMap(M=>this.o(M,j))}),f=new Map;return v.forEach(N=>{const F=N.searchPath.toString(),j=f.get(F);j?N.pattern&&(j.pattern=j.pattern||{},j.pattern[N.pattern]=!0):f.set(F,{searchPath:N.searchPath,pattern:N.pattern?s(N.pattern):void 0})}),Array.from(f.values())}n(C){if(p.$lc(C)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==R.Schemas.file?[{searchPath:v[0].uri.with({path:C})}]:[{searchPath:h.URI.file(p.$kc(C))}]}if(this.b.getWorkbenchState()===g.WorkbenchState.FOLDER){const v=this.b.getWorkspace().folders[0].uri;if(C=b(C),C.startsWith("../")||C===".."){const N=p.$jc.resolve(v.path,C);return[{searchPath:v.with({path:N})}]}const f=E(C);return[{searchPath:v,pattern:f}]}else{if(C==="./"||C===".\\")return[];{const v=C.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(F=>{const j=v.match(new RegExp(`^${I.$jf(F.name)}(?:/(.*)|$)`));return j?{match:j,folder:F}:null}).filter(S.$og);if(N.length)return N.map(F=>{const j=F.match[1];return{searchPath:F.folder.uri,pattern:j&&E(j)}});{const F=C.match(/\.[\/\\](.+)[\/\\]?/),j=F?F[1]:C,z=w.localize(0,null,j);throw new Error(z)}}}}o(C,v){const f=C.pattern&&v?`${C.pattern}/${v}`:C.pattern||v,N=[{searchPath:C.searchPath,pattern:f}];return f&&!f.endsWith("**")&&N.push({searchPath:C.searchPath,pattern:f+"/**"}),N}q(C,v,f){const N=this.r((0,g.$2i)(C.searchPath),v,f,!1);return N?{...N,includePattern:C.pattern}:null}r(C,v,f,N){let F;const j=h.URI.isUri(C)?C:C.uri;if(f.searchPaths){const W=f.searchPaths.filter(ae=>(0,c.$ah)(ae.searchPath,j))[0];if(W&&!W.pattern)return null;W&&(F=W.pattern)}const z=this.a.getValue({resource:j}),L={...this.l(z,v)||{},...F||{}},B=h.URI.isUri(C)?(0,c.$eh)(C):C.name;return{folder:j,folderName:N?B:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!z.search.followSymlinks}}};e.$_M=t,e.$_M=t=Ye([Ve(0,l.$aj),Ve(1,g.$Pi),Ve(2,$.$kE),Ve(3,m.$ak),Ve(4,n.$0M)],t);function i(T){const C=T.match(/[\*\{\}\(\)\[\]\?]/);if(C){const v=C.index,f=T.substr(0,v).match(/[/|\\][^/\\]*$/);if(f){let N=T.substr(0,f.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:T.substr((f.index||0)+1)}}}return{pathPortion:T}}function s(...T){return T.length?T.reduce((C,v)=>(C[v]=!0,C),Object.create(null)):void 0}function d(T){return k.$yk(T,",").map(C=>C.trim()).filter(C=>!!C.length)}function u(T){return[`**/${T}/**`,`**/${T}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function b(T){return T.replace(/\\/g,"/")}function E(T){return b(T).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(T){return T.replace(/([?*[\]])/g,"[$1]")}function y(T,C){T=r.$Pb(T,N=>N.toString());const v=[],f=C.getWorkspace();return T&&T.forEach(N=>{let F;if(C.getWorkbenchState()===g.WorkbenchState.FOLDER)F=(0,c.$jh)(f.folders[0].uri,N),F&&F!=="."&&(F="./"+F);else{const j=C.getWorkspaceFolder(N);if(j){const z=j.name;if(f.folders.filter(L=>L.name===z).length===1){const L=(0,c.$jh)(j.uri,N);L===""?F=`./${j.name}`:F=`./${j.name}/${L}`}else F=N.fsPath}}F&&v.push(D(F))}),v}}),define(Se[388],De([1,0,23,2,21,14,5,387,38,47,7]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pyb=h,e.$qyb=l,r=Ue(r),A=Ue(A);const S=7e3;function h(m,g){const $=g.activationEvents;if(!$)return Promise.resolve(void 0);const n=[],o=[];for(const b of $)if(/^workspaceContains:/.test(b)){const E=b.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||m.forceUsingSearch?o.push(E):n.push(E)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:t,resolve:i}=(0,I.$zh)(),s=b=>i({activationEvent:b}),d=Promise.all(n.map(b=>P(m,b,s))).then(()=>{}),u=w(m,g.identifier,o,s);return Promise.all([d,u]).then(()=>{i(void 0)}),t}async function P(m,g,$){for(const n of m.folders)if(await m.exists(r.$hh(a.URI.revive(n),g))){$(`workspaceContains:${g}`);return}}async function w(m,g,$,n){if($.length===0)return Promise.resolve(void 0);const o=new k.$ye,t=m.checkExists(m.folders,$,o.token),i=setTimeout(async()=>{o.cancel(),m.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${$.join(",")}`)},S);let s=!1;try{s=await t}catch(d){A.$7(d)||A.$3(d)}o.dispose(),clearTimeout(i),s&&n(`workspaceContains:${$.join(",")}`)}function l(m,g,$,n){const o=m.get(O.$Fi),t=m.get(p.$SL),s=o.createInstance(R.$_M).file(g.map(d=>(0,c.$2i)(a.URI.revive(d))),{_reason:"checkExists",includePattern:$,exists:!0});return t.fileSearch(s,n).then(d=>!!d.limitHit,d=>A.$7(d)?!1:Promise.reject(d))}});var ot=this&&this.__classPrivateFieldSet||function(ie,e,r,a,k){if(a==="m")throw new TypeError("Private method is not writable");if(a==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return a==="a"?k.call(ie,r):k?k.value=r:e.set(ie,r),r},He=this&&this.__classPrivateFieldGet||function(ie,e,r,a){if(r==="a"&&!a)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!a:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?a:r==="a"?a.call(ie):a?a.value:e.get(ie)};define(Se[53],De([1,0,235,17,62,23,7,3,85,2,12,6,43,320,127,42,26,160,14,24,22,299,8,72,5,30,98,20,115,77,48,130,4,388,126,301,15,124,44,11,125]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s,d,u,b,E,D,y,T,C,v,f,N,F,j,z,M,L,B){"use strict";var W,ae,q,K;Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=e.$ypc=e.$xpc=e.$wpc=e.$vpc=void 0,r=Ue(r),a=Ue(a),k=Ue(k),$=Ue($),e.$vpc=(0,d.$Gi)("IHostUtils");let ee=K=class extends R.$Xc{constructor(te,_,ne,le,J,ce,me,we,Me,qe,ke,Ie,Ce){super(),this.Y=Ie,this.Z=Ce,this.a=this.B(new v.$ne),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=_,this.g=ne,this.f=me,this.j=le,this.m=J,this.s=ce,this.t=Me,this.u=qe,this.w=ke,this.y=this.g.getProxy(S.$vN.MainThreadWorkspace),this.z=this.g.getProxy(S.$vN.MainThreadTelemetry),this.C=this.g.getProxy(S.$vN.MainThreadExtensionService),this.D=new O.$Fh,this.F=new O.$Fh,this.G=new O.$Fh,this.H=new O.$Fh,this.I=new H(this.f.extensions.activationEvents),this.L=new g.$1cc(this.I,this.f.extensions.allExtensions);const U=new n.$tn(this.f.extensions.myExtensions);this.J=new g.$1cc(this.I,fe(this.L,U)),L.$n&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new w.$epc(this.g,this.s),this.N=new N.$opc(this.g),this.O=we,this.h=te.createChild(new D.$Ei([w.$fpc,this.M],[N.$ppc,this.N])),this.P=this.B(new P.$dpc(this.J,this.L,{onExtensionActivationError:(V,X,x)=>{this.C.$onExtensionActivationError(V,$.$5(X),x)},actualActivateExtension:async(V,X)=>{if(g.$1cc.isHostExtension(V,this.J,this.L))return await this.C.$activateExtension(V,X),new P.$cpc;const x=this.J.getExtensionDescription(V);return this.fb(x,X)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(te){$.$3(te)}}async $(){this.O.onWillDeactivateAll();let te=[];try{te=this.J.getAllExtensionDescriptions().map(J=>J.identifier).filter(J=>this.isActivated(J)).map(J=>this.eb(J))}catch{}await Promise.all(te)}terminate(te,_=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${te}`),this.s.flush(),this.u.dispose(),this.P.dispose(),$.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const ne=this.$();Promise.race([(0,O.$Hh)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(te){return this.G.isOpen()?this.P.isActivated(te):!1}async getExtension(te){const _=await this.C.$getExtension(te);return _&&{..._,identifier:new n.$sn(_.identifier.value),extensionLocation:c.URI.revive(_.extensionLocation)}}ab(te,_){return this.P.activateByEvent(te,_)}bb(te,_){return this.P.activateById(te,_)}activateByIdWithErrors(te,_){return this.bb(te,_).then(()=>{const ne=this.P.getActivatedExtension(te);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(te=>this.J)}getExtensionExports(te){if(this.G.isOpen())return this.P.getActivatedExtension(te).exports;try{return this.P.getActivatedExtension(te).exports}catch{return null}}async cb(te){if(te.scheme===j.Schemas.file&&this.c.fsRealpath){const _=te.fsPath;this.R.has(_)||this.R.set(_,this.c.fsRealpath(_));const ne=await this.R.get(_);return c.URI.file(ne)}return te}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(te=>new oe(te))),this.Q}async db(te){const _=p.$Mi.forUris(ne=>A.$$g.ignorePathCasing(ne));return await Promise.all(te.map(async ne=>{if(this.wb(ne)){const le=await this.cb(ne.extensionLocation);_.set(le,ne)}})),_}eb(te){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(te))return _;const ne=this.P.getActivatedExtension(te);if(!ne)return _;try{typeof ne.module.deactivate=="function"&&(_=Promise.resolve(ne.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${te.value}':`),this.s.error(le)}try{(0,R.$Sc)(ne.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.s.error(le)}return _}async fb(te,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(te.identifier):await this.C.$onWillActivateExtension(te.identifier),this.hb(te,_).then(ne=>{const le=ne.activationTimes;return this.C.$onDidActivateExtension(te.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,_),this.gb(te,_,"success",le),ne},ne=>{throw this.gb(te,_,"failure"),ne})}gb(te,_,ne,le){const J=ge(te,_);this.z.$publicLog2("extensionActivationTimes",{...J,...le||{},outcome:ne})}hb(te,_){const ne=ge(te,_);this.z.$publicLog2("activatePlugin",ne);const le=this.wb(te);if(!le)return Promise.resolve(new P.$bpc(P.$$oc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${te.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const J=new P.$_oc(_.startup);return Promise.all([this.xb(te,(0,A.$hh)(te.extensionLocation,le),J),this.ib(te)]).then(ce=>(k.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),K.jb(this.s,te.identifier,ce[0],ce[1],J))).then(ce=>(k.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ce))}ib(te){const _=this.Z.createLanguageModelAccessInformation(te),ne=this.B(new t.$hpc(te,this.M)),le=this.B(new t.$gpc(te.identifier.value,!1,this.M)),J=this.B(new F.$qpc(te,this.N)),ce=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,me=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([ne.whenReady,le.whenReady,this.O.whenReady]).then(()=>{const we=this;let Me,qe;const ke=(0,m.$7G)(te,"ipc")?this.f.messagePorts?.get(n.$sn.toKey(te.identifier)):void 0;return Object.freeze({globalState:ne,workspaceState:le,secrets:J,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(Ie){return a.$mc(te.extensionLocation.fsPath,Ie)},get storagePath(){return we.O.workspaceValue(te)?.fsPath},get globalStoragePath(){return we.O.globalValue(te).fsPath},get logPath(){return a.$mc(we.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return c.URI.joinPath(we.f.logsLocation,te.identifier.value)},get storageUri(){return we.O.workspaceValue(te)},get globalStorageUri(){return we.O.globalValue(te)},get extensionMode(){return ce},get extension(){return Me===void 0&&(Me=new $e(we,te.identifier,te,me,!1)),Me},get extensionRuntime(){return(0,m.$8G)(te,"extensionRuntime"),we.extensionRuntime},get environmentVariableCollection(){return we.u.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!qe){if(!ke)return;const Ie=v.Event.buffer(v.Event.fromDOMEventEmitter(ke,"message",Ce=>Ce.data));ke.start(),qe={onDidReceiveMessage:Ie,postMessage:ke.postMessage.bind(ke)}}return qe}})})}static jb(te,_,ne,le,J){return ne=ne||{activate:void 0,deactivate:void 0},this.kb(te,_,ne,le,J).then(ce=>new P.$apc(!1,null,J.build(),ne,ce,le.subscriptions))}static kb(te,_,ne,le,J){if(typeof ne.activate=="function")try{J.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${_.value}`);const ce=typeof global=="object"?global:self,me=ne.activate.apply(ce,[le]);return J.activateCallStop(),J.activateResolveStart(),Promise.resolve(me).then(we=>(J.activateResolveStop(),we))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(ne)}lb(te,_){this.bb(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:_}).then(void 0,ne=>{this.s.error(ne)})}mb(te,_=0){const le=Date.now();(0,L.$v)(()=>{for(let J=_;J<te.length;J+=1){const ce=te[J];for(const me of ce.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-le>50){this.mb(te,J);break}else this.lb(ce,me)}})}nb(){this.C.$setPerformanceMarks(k.getMarks()),this.m.getConfigProvider().then(te=>{const _=te.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(_)this.mb(ne);else for(const le of ne)if(le.activationEvents)for(const J of le.activationEvents)J==="onStartupFinished"&&this.lb(le,J)})}ob(){const te=this.ab("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.pb(ce.added)));const _=this.j.workspace?this.j.workspace.folders:[],ne=this.pb(_),le=this.rb(),J=Promise.all([le,te,ne]).then(()=>{});return Promise.race([J,(0,O.$Hh)(1e4)]).then(()=>{this.nb()}),J}pb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.qb(te,_))).then(()=>{})}async qb(te,_){if(this.isActivated(_.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:te.map(ce=>ce.uri),forceUsingSearch:ne||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,me,we)=>this.y.$checkExists(ce,me,we)},J=await(0,f.$pyb)(le,_);if(J)return this.bb(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:J.activationEvent}).then(void 0,ce=>this.s.error(ce))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(te){throw console.error(te),te}}async sb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:_}=this.f.environment;if(!te||!_)throw new Error(r.localize(0,null));const ne=await this.xb(null,_,new P.$_oc(!1));if(!ne||typeof ne.run!="function")throw new Error(r.localize(1,null,_.toString()));return new Promise((le,J)=>{const ce=(Me,qe)=>{Me?(L.$n&&this.s.error("Test runner called back with error",Me),J(Me)):(L.$n&&(qe?this.s.info(`Test runner called back with ${qe} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof qe=="number"&&qe>0?1:0))},me=(0,A.$8g)(_),we=ne.run(me,ce);we&&we.then&&we.then(()=>{L.$n&&this.s.info("Test runner finished successfully."),le(0)}).catch(Me=>{L.$n&&this.s.error("Test runner finished with error",Me),J(Me instanceof Error&&Me.stack?Me.stack:String(Me))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,O.$Hh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,_){return this.S[te]=_,(0,R.$Vc)(()=>{delete this.S[te]})}async getRemoteExecServer(te){const{resolver:_}=await this.ub(te);return _?.resolveExecServer?.(te,{resolveAttempt:0})}async ub(te){const _=te.indexOf("+");if(_===-1)throw new i.$DN("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=te.substr(0,_);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.S[ne]}}async $resolveAuthority(te,_){const ne=M.$he.create(!1),le=()=>`[resolveAuthority(${(0,s.$Vl)(te)},${_})][${ne.elapsed()}ms] `,J=de=>this.s.info(`${le()}${de}`),ce=de=>this.s.warn(`${le()}${de}`),me=(de,ve=void 0)=>this.s.error(`${le()}${de}`,ve),we=de=>{if(de instanceof i.$DN)return{type:"error",error:{code:de._code,message:de._message,detail:de._detail}};throw de},Me=async de=>{J(`activating resolver for ${de}...`);const{resolver:ve,authorityPrefix:Fe}=await this.ub(de);if(!ve)throw me(`no resolver for ${Fe}`),new i.$DN(`No remote extension installed to resolve ${Fe}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:ve,authorityPrefix:Fe,remoteAuthority:de}},qe=te.split(/@|%40/g).reverse();J(`activating remote resolvers ${qe.join(" -> ")}`);let ke;try{ke=await Promise.all(qe.map(Me)).catch(async de=>{if(!(de instanceof i.$DN)||de._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw de;return ce(`resolving nested authorities failed: ${de.message}`),[await Me(te)]})}catch(de){return we(de)}const Ie=new O.$Rh;Ie.cancelAndSet(()=>J("waiting..."),1e3);let Ce,U;for(const[de,{authorityPrefix:ve,resolver:Fe,remoteAuthority:Ge}]of ke.entries())try{if(de===ke.length-1)J("invoking final resolve()..."),k.mark(`code/extHost/willResolveAuthority/${ve}`),Ce=await Fe.resolve(Ge,{resolveAttempt:_,execServer:U}),k.mark(`code/extHost/didResolveAuthorityOK/${ve}`),J("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Fe,i.$CN.isManagedResolvedAuthority(Ce)?Ce:void 0));else{if(J(`invoking resolveExecServer() for ${Ge}`),k.mark(`code/extHost/willResolveExecServer/${ve}`),U=await Fe.resolveExecServer?.(Ge,{resolveAttempt:_,execServer:U}),!U)throw new i.$DN(`Exec server was not available for ${Ge}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);k.mark(`code/extHost/didResolveExecServerOK/${ve}`)}}catch(Xe){return k.mark(`code/extHost/didResolveAuthorityError/${ve}`),me("returned an error",Xe),Ie.dispose(),we(Xe)}Ie.dispose();const V={environmentTunnels:Ce.environmentTunnels,features:Ce.tunnelFeatures?{elevation:Ce.tunnelFeatures.elevation,privacyOptions:Ce.tunnelFeatures.privacyOptions,protocol:Ce.tunnelFeatures.protocol===void 0?!0:Ce.tunnelFeatures.protocol}:void 0},X={extensionHostEnv:Ce.extensionHostEnv,isTrusted:Ce.isTrusted,authenticationSession:Ce.authenticationSessionForInitializingExtensions?{id:Ce.authenticationSessionForInitializingExtensions.id,providerId:Ce.authenticationSessionForInitializingExtensions.providerId}:void 0};J(`returned ${i.$CN.isManagedResolvedAuthority(Ce)?"managed authority":`${Ce.host}:${Ce.port}`}`);let x;if(i.$CN.isManagedResolvedAuthority(Ce)){const de=_;this.Y.setFactory(de,Ce.makeConnection),x={authority:te,connectTo:new s.$Sl(de),connectionToken:Ce.connectionToken}}else x={authority:te,connectTo:new s.$Tl(Ce.host,Ce.port),connectionToken:Ce.connectionToken};return{type:"ok",value:{authority:x,options:X,tunnelInformation:V}}}async $getCanonicalURI(te,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Vl)(te)})`);const{resolver:ne}=await this.ub(te);if(!ne)return null;const le=c.URI.revive(_);if(typeof ne.getCanonicalURI>"u")return le;const J=await(0,O.$yh)(()=>ne.getCanonicalURI(le));return J||le}async $startExtensionHost(te){te.toAdd.forEach(ce=>ce.extensionLocation=c.URI.revive(ce.extensionLocation));const{globalRegistry:_,myExtensions:ne}=re(this.I,this.L,this.J,te),le=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(_.getAllExtensionDescriptions()),this.J.set(ne),L.$n&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.tb()}$activateByEvent(te,_){return _===m.ActivationKind.Immediate?this.D.wait().then(ne=>this.ab(te,!1)):this.G.wait().then(ne=>this.ab(te,!1))}async $activate(te,_){return await this.G.wait(),this.J.getExtensionDescription(te)?(await this.bb(te,_),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(ce=>ce.extensionLocation=c.URI.revive(ce.extensionLocation));const{globalRegistry:_,myExtensions:ne}=re(this.I,this.L,this.J,te),le=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(_.getAllExtensionDescriptions()),this.J.set(ne),L.$n&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const _=o.$Pe.alloc(te),ne=Math.random()%256;for(let le=0;le<te;le++)_.writeUInt8(ne,le);return _}async $updateRemoteConnectionData(te){this.X=te,this.a.fire()}};e.$wpc=ee,e.$wpc=ee=K=Ye([Ve(0,d.$Fi),Ve(1,e.$vpc),Ve(2,E.$2P),Ve(3,l.$Toc),Ve(4,h.$Woc),Ve(5,I.$ak),Ve(6,u.$fQ),Ve(7,b.$Zoc),Ve(8,y.$_Fb),Ve(9,T.$ipc),Ve(10,z.$spc),Ve(11,B.$tpc),Ve(12,C.$mpc)],ee);function re(ue,te,_,ne){ue.addActivationEvents(ne.addActivationEvents);const le=new g.$1cc(ue,te.getAllExtensionDescriptions());le.deltaExtensions(ne.toAdd,ne.toRemove);const J=new n.$tn(_.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of ne.myToRemove)J.delete(me);for(const me of ne.myToAdd)J.add(me);const ce=fe(le,J);return{globalRegistry:le,myExtensions:ce}}function ge(ue,te){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}function Z(ue){return ue.getAllExtensionDescriptions().map(te=>te.identifier.value).join(",")}e.$xpc=(0,d.$Gi)("IExtHostExtensionService");class $e{constructor(te,_,ne,le,J){W.set(this,void 0),ae.set(this,void 0),q.set(this,void 0),ot(this,W,te,"f"),ot(this,ae,_,"f"),ot(this,q,ne.identifier,"f"),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=a.$kc((0,A.$8g)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=le,this.isFromDifferentExtensionHost=J}get isActive(){return He(this,W,"f").isActivated(He(this,q,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return He(this,W,"f").getExtensionExports(He(this,q,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await He(this,W,"f").activateByIdWithErrors(He(this,q,"f"),{startup:!1,extensionId:He(this,ae,"f"),activationEvent:"api"}),this.exports}}e.$ypc=$e,W=new WeakMap,ae=new WeakMap,q=new WeakMap;function fe(ue,te){return ue.getAllExtensionDescriptions().filter(_=>te.has(_.identifier))}class oe{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.$zpc=oe;class H{constructor(te){this.a=new n.$un,this.addActivationEvents(te)}readActivationEvents(te){return this.a.get(te.identifier)??[]}addActivationEvents(te){for(const _ of Object.keys(te))this.a.set(_,te[_])}}}),define(Se[389],De([1,0,62,2,6,43,26,24,20,30,5,53,12,13]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=void 0,r=Ue(r);let l=class{constructor(o,t,i,s,d,u,b){this.c=o,this.d=t,this.f=i,this.g=s,this.h=d,this.i=u,this.j=b,this.a=new Map,this.b=[]}async install(){this.k(),r.mark("code/extHost/willWaitForConfig");const o=await this.g.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this.h.getExtensionPathIndex();this.register(new g(this.c,t,this.d,o,this.j)),this.register(this.f.createInstance(m)),this.i.remote.isRemote&&this.register(this.f.createInstance($,t,this.i.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const t of o.nodeModuleName)this.a.set(t,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(t=>o.alternativeModuleName(t))}};e.$Kqc=l,e.$Kqc=l=Ye([Ve(2,I.$Fi),Ve(3,A.$Woc),Ve(4,S.$xpc),Ve(5,c.$fQ),Ve(6,h.$ak)],l);let m=w=class{constructor(o){if(o.environment.appRoot&&w.a.size){const t=(0,P.$jf)(this.c(o.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${d}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const t=this.b.exec(this.c(o));if(!t)return;const[,i,s,d]=t,u=w.a.get(s);if(u!==void 0)return console.warn(`${s} as been renamed to ${u}, please update your imports`),i+u+d}c(o){return o.replace(/\\/g,"/")}};m.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),m=w=Ye([Ve(0,c.$fQ)],m);class g{constructor(o,t,i,s,d){this.c=o,this.d=t,this.e=i,this.f=s,this.g=d,this.nodeModuleName="vscode",this.a=new R.$un}load(o,t){const i=this.d.findSubstr(t);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((d,u)=>s+=`	${u} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${s}`),this.b=this.c(O.$2G,this.e,this.f)}return this.b}}let $=class{constructor(o,t,i){this.e=o,this.f=t,this.nodeModuleName=["open","opn"],this.d=i.getProxy(k.$vN.MainThreadTelemetry);const s=i.getProxy(k.$vN.MainThreadWindow);this.c=(d,u)=>{const b=a.URI.parse(d);return u?this.g(d,u):b.scheme==="http"||b.scheme==="https"?s.$openUri(b,d,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?s.$openUri(b,d,{}):this.g(d,u)}}load(o,t,i){const s=this.e.findSubstr(t);return s&&(this.a=s.identifier.value,this.h()),this.b=i(o),this.c}g(o,t){return this.i(),this.b(o,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};$=Ye([Ve(2,p.$2P)],$)}),define(Se[65],De([1,0,49,3,17,54,5,64,78,53,8,42,317,43]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=e.$Apc=void 0,k=Ue(k),A=Ue(A),e.$Apc=(0,O.$Gi)("IExtHostVariableResolverProvider");class w extends h.$6Q{constructor(g,$,n,o,t,i,s){function d(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const b=o.tabGroups.all.find(E=>E.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof I.$jP||b.input instanceof I.$oP)return b.input.modified;if(b.input instanceof I.$iP||b.input instanceof I.$nP||b.input instanceof I.$lP)return b.input.uri}}}super({getFolderUri:u=>{const b=i.folders.filter(E=>E.name===u);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(u,b)=>t.getConfiguration(void 0,u).get(b),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=d();if(u)return k.$kc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if($){const u=d();if(u){const b=$.getWorkspaceFolder(u);if(b)return k.$kc(b.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>g.getExtension(u)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(A.env))}}let l=class extends a.$Xc{constructor(g,$,n,o,t){super(),this.b=g,this.c=$,this.g=n,this.h=o,this.j=t,this.a=new r.$X(async()=>{const i=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,i,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Bpc=l,e.$Bpc=l=Ye([Ve(0,c.$xpc),Ve(1,S.$Toc),Ve(2,R.$aQ),Ve(3,P.$Woc),Ve(4,p.$9oc)],l)}),define(Se[102],De([1,0,7,4,2,3,24,5,6,78,53,20,8,42,155,121,308,43,65,50,35,16,19,99]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=e.$Kpc=e.$Jpc=e.$Ipc=e.$Hpc=void 0,t=Ue(t),e.$Hpc=(0,R.$Gi)("IExtHostDebugService");let d=class extends A.$Xc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(C,v,f,N,F,j,z,M){super(),this.Y=v,this.Z=f,this.$=N,this.ab=F,this.bb=j,this.cb=z,this.db=M,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new a.$ne),this.z=this.B(new a.$ne),this.C=this.B(new a.$ne),this.F=this.B(new a.$ne),this.u=C.getProxy(p.$vN.MainThreadDebugService),this.I=this.B(new a.$ne),this.L=this.B(new a.$ne),this.G=new b(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(L=>{this.B(L.onDidChange(B=>{this.fb(L)})),this.fb(L)})}async $getVisualizerTreeItem(C,v){const f=this.gb(v);if(!f)return;const N=await this.Q.get(C)?.getTreeItem?.(f);return N?this.eb(C,N):void 0}registerDebugVisualizationTree(C,v,f){const N=O.$sn.toKey(C.identifier),F=this.ub(N,v);if(this.P.has(F))throw new Error(`A debug visualization provider with id '${v}' is already registered`);return this.Q.set(F,f),this.u.$registerDebugVisualizerTree(F,!!f.editItem),(0,A.$Vc)(()=>{this.u.$unregisterDebugVisualizerTree(F),this.Q.delete(v)})}async $getVisualizerTreeItemChildren(C,v){const f=this.S.get(v)?.item;return f?(await this.Q.get(C)?.getChildren?.(f))?.map(F=>this.eb(C,F))||[]:[]}async $editVisualizerTreeItem(C,v){const f=this.S.get(C);if(!f)return;const N=await this.Q.get(f.provider)?.editItem?.(f.item,v);return this.eb(f.provider,N||f.item)}$disposeVisualizedTree(C){const v=this.S.get(C);if(!v)return;const f=[v.children];for(const N of f)if(N)for(const F of N)f.push(this.S.get(F)?.children),this.S.delete(F)}eb(C,v){let f=this.R.get(v);return f||(f=this.O++,this.R.set(v,f),this.S.set(f,{provider:C,item:v})),t.DebugTreeItem.from(v,f)}asDebugSourceUri(C,v){const f=C;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let N=`debug:${encodeURIComponent(f.path||"")}`,F="?";return v&&(N+=`${F}session=${encodeURIComponent(v.id)}`,F="&"),N+=`${F}ref=${f.sourceReference}`,k.URI.parse(N)}else{if(f.path)return k.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(C){const v=[];for(const f of C.getAllExtensionDescriptions())if(f.contributes){const N=f.contributes.debuggers;if(N&&N.length>0)for(const F of N)(0,m.$ZH)(F)&&v.push(F.type)}this.u.$registerDebugTypes(v)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const C=[];return this.H.forEach(v=>C.push(v)),C}async $resolveDebugVisualizer(C,v){const f=this.W.get(C);if(!f)throw new Error(`No debug visualizer found with id '${C}'`);let{v:N,provider:F,extensionId:j}=f;if(N.visualization||(N=await F.resolveDebugVisualization?.(N,v)||N,f.v=N),!N.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${F}'`);return this.vb(j,N.visualization)}async $executeDebugVisualizerCommand(C){const v=this.W.get(C);if(!v)throw new Error(`No debug visualizer found with id '${C}'`);const f=v.v.visualization;f&&"command"in f&&this.cb.executeCommand(f.command,...f.arguments||[])}gb(C){const v=this.w.get(C.sessionId);return v&&{session:v.api,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId}}async $provideDebugVisualizers(C,v,f,N){const F=this.gb(f),j=this.ub(C,v),z=this.P.get(j);if(!F||!z)return[];const M=await z.provideDebugVisualization(F,N);return M?M.map(L=>{const B=++this.X;this.W.set(B,{v:L,provider:z,extensionId:C});const W=L.iconPath?this.wb(L.iconPath):void 0;return{id:B,name:L.name,iconClass:W?.iconClass,iconPath:W?.iconPath,visualization:this.vb(C,L.visualization)}}):[]}$disposeDebugVisualizers(C){for(const v of C)this.W.delete(v)}registerDebugVisualizationProvider(C,v,f){if(!C.contributes?.debugVisualizers?.some(j=>j.id===v))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${v})`);const N=O.$sn.toKey(C.identifier),F=this.ub(N,v);if(this.P.has(F))throw new Error(`A debug visualization provider with id '${v}' is already registered`);return this.P.set(F,f),this.u.$registerDebugVisualizer(N,v),(0,A.$Vc)(()=>{this.u.$unregisterDebugVisualizer(N,v),this.P.delete(v)})}addBreakpoints(C){const v=C.filter(F=>{const j=F.id;return this.H.has(j)?!1:(this.H.set(j,F),!0)});this.rb(v,[],[]);const f=[],N=new Map;for(const F of v)if(F instanceof h.$zO){let j=N.get(F.location.uri.toString());j||(j={type:"sourceMulti",uri:F.location.uri,lines:[]},N.set(F.location.uri.toString(),j),f.push(j)),j.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character,mode:F.mode})}else F instanceof h.$AO&&f.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName,mode:F.mode});return this.u.$registerBreakpoints(f)}removeBreakpoints(C){const v=C.filter(j=>this.H.delete(j.id));this.rb([],v,[]);const f=v.filter(j=>j instanceof h.$zO).map(j=>j.id),N=v.filter(j=>j instanceof h.$AO).map(j=>j.id),F=v.filter(j=>j instanceof h.$BO).map(j=>j.id);return this.u.$unregisterBreakpoints(f,N,F)}startDebugging(C,v,f){const N=f.testRun&&this.db.getMetadataForRun(f.testRun);return this.u.$startDebugging(C?C.uri:void 0,v,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===h.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,testRun:N&&{runId:N.runId,taskId:N.taskId},suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(C){return this.u.$stopDebugging(C?C.id:void 0)}registerDebugConfigurationProvider(C,v,f){if(!v)return new h.$xN(()=>{});const N=this.f++;return this.g.push({type:C,handle:N,provider:v}),this.u.$registerDebugConfigurationProvider(C,f,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,N),new h.$xN(()=>{this.g=this.g.filter(F=>F.provider!==v),this.u.$unregisterDebugConfigurationProvider(N)})}registerDebugAdapterDescriptorFactory(C,v,f){if(!f)return new h.$xN(()=>{});if(!this.nb(C,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.kb(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const N=this.h++;return this.j.push({type:v,handle:N,factory:f}),this.u.$registerDebugAdapterDescriptorFactory(v,N),new h.$xN(()=>{this.j=this.j.filter(F=>F.factory!==f),this.u.$unregisterDebugAdapterDescriptorFactory(N)})}registerDebugAdapterTrackerFactory(C,v){if(!v)return new h.$xN(()=>{});const f=this.m++;return this.n.push({type:C,handle:f,factory:v}),new h.$xN(()=>{this.n=this.n.filter(N=>N.factory!==v)})}async $runInTerminal(C,v){return Promise.resolve(void 0)}async $substituteVariables(C,v){let f;const N=await this.tb(C);return N&&(f={uri:N.uri,name:N.name,index:N.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(f,v)}hb(C,v){if(C.type==="implementation")return new D(C.implementation)}ib(){}async $startDASession(C,v){const f=this,N=await this.sb(v);return this.pb(this.kb(N.type),N).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}' (extension might have failed to activate)`);const j=this.jb(F),z=this.hb(j,N);if(!z)throw new Error(`Couldn't create a debug adapter for type '${N.type}'.`);const M=z;return this.M.set(C,M),this.ob(N).then(L=>(L&&this.N.set(C,L),M.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const W=B,ae={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const q=await this.U.sign(W.arguments.value);ae.body={signature:q},M.sendResponse(ae)}else throw new Error("no signer")}catch(q){ae.success=!1,ae.message=q.message,M.sendResponse(ae)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(B),B=(0,m.$5H)(B,!0),f.u.$acceptDAMessage(C,B)}),M.onError(B=>{L&&L.onError&&L.onError(B),this.u.$acceptDAError(C,B.name,B.message,B.stack)}),M.onExit(B=>{L&&L.onExit&&L.onExit(B??void 0,void 0),this.u.$acceptDAExit(C,B??void 0,void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),M.startSession()))})}$sendDAMessage(C,v){v=(0,m.$4H)(v,!1);const f=this.N.get(C);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(v),this.M.get(C)?.sendMessage(v)}$stopDASession(C){const v=this.N.get(C);this.N.delete(C),v&&v.onWillStopSession&&v.onWillStopSession();const f=this.M.get(C);return this.M.delete(C),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(C){const v=[],f=[],N=[];if(C.added)for(const F of C.added){const j=F.id;if(j&&!this.H.has(j)){let z;if(F.type==="function")z=new h.$AO(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage,F.mode);else if(F.type==="data")z=new h.$BO(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage,F.mode);else{const M=k.URI.revive(F.uri);z=new h.$zO(new h.$JN(M,new h.$yN(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage,F.mode)}(0,h.$xO)(z,j),this.H.set(j,z),v.push(z)}}if(C.removed)for(const F of C.removed){const j=this.H.get(F);j&&(this.H.delete(F),f.push(j))}if(C.changed){for(const F of C.changed)if(F.id){const j=this.H.get(F.id);if(j){if(j instanceof h.$AO&&F.type==="function"){const z=j;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.functionName=F.functionName}else if(j instanceof h.$zO&&F.type==="source"){const z=j;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.location=new h.$JN(k.URI.revive(F.uri),new h.$yN(F.line,F.character))}N.push(j)}}}this.rb(v,f,N)}async $acceptStackFrameFocus(C){let v;if(C){const f=await this.sb(C.sessionId);C.kind==="thread"?v=new h.$HO(f.api,C.threadId):v=new h.$GO(f.api,C.threadId,C.frameId)}this.J=v,this.L.fire(this.J)}$provideDebugConfigurations(C,v,f){return(0,r.$yh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.tb(v);return N.provideDebugConfigurations(F,f)}).then(N=>{if(!N)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return N})}$resolveDebugConfiguration(C,v,f,N){return(0,r.$yh)(async()=>{const F=this.mb(C);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const j=await this.tb(v);return F.resolveDebugConfiguration(j,f,N)})}$resolveDebugConfigurationWithSubstitutedVariables(C,v,f,N){return(0,r.$yh)(async()=>{const F=this.mb(C);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const j=await this.tb(v);return F.resolveDebugConfigurationWithSubstitutedVariables(j,f,N)})}async $provideDebugAdapter(C,v){const f=this.lb(C);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const N=await this.sb(v);return this.pb(f,N).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}'`);return this.jb(F)})}async $acceptDebugSessionStarted(C){const v=await this.sb(C);this.y.fire(v.api)}async $acceptDebugSessionTerminated(C){const v=await this.sb(C);v&&(this.z.fire(v.api),this.w.delete(v.id))}async $acceptDebugSessionActiveChanged(C){this.D=C?await this.sb(C):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(C,v){(await this.sb(C))?._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(C,v){const N={session:(await this.sb(C)).api,event:v.event,body:v.body};this.F.fire(N)}jb(C){if(C instanceof h.$CO)return{type:"executable",command:C.command,args:C.args,options:C.options};if(C instanceof h.$DO)return{type:"server",port:C.port,host:C.host};if(C instanceof h.$EO)return{type:"pipeServer",path:C.path};if(C instanceof h.$FO)return{type:"implementation",implementation:C.implementation};throw new Error("convertToDto unexpected type")}kb(C){const v=this.j.filter(f=>f.type===C);if(v.length>0)return v[0].factory}lb(C){const v=this.j.filter(f=>f.handle===C);if(v.length>0)return v[0].factory}mb(C){const v=this.g.filter(f=>f.handle===C);if(v.length>0)return v[0].provider}nb(C,v){if(C.contributes){const f=C.contributes.debuggers;if(f&&f.length>0){for(const N of f)if(N.label&&N.type&&N.type===v)return!0}}return!1}ob(C){const f=C.configuration.type,N=this.n.filter(F=>F.type===f||F.type==="*").map(F=>(0,r.$yh)(()=>F.factory.createDebugAdapterTracker(C.api)).then(j=>j,j=>null));return Promise.race([Promise.all(N).then(F=>{const j=(0,i.$Kb)(F);if(j.length>0)return new E(j)}),new Promise(F=>setTimeout(()=>F(void 0),1e3))]).catch(F=>{})}async pb(C,v){const f=v.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new h.$DO(f));if(C){const F=await this.Z.getExtensionRegistry();return(0,r.$yh)(()=>C.createDebugAdapterDescriptor(v.api,this.qb(v,F))).then(j=>{if(j)return j})}const N=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(v,N))}qb(C,v){}rb(C,v,f){(C.length>0||v.length>0||f.length>0)&&this.I.fire(Object.freeze({added:C,removed:v,changed:f}))}async sb(C){if(C)if(typeof C=="string"){const v=this.w.get(C);if(v)return v}else{let v=this.w.get(C.id);if(!v){const f=await this.tb(C.folderUri),N=C.parent?this.w.get(C.parent):void 0;v=new u(this.u,C.id,C.type,C.name,f,C.configuration,N?.api),this.w.set(v.id,v),this.u.$sessionCached(v.id)}return v}throw new Error("cannot find session")}tb(C){if(C){const v=k.URI.revive(C);return this.Y.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}ub(C,v){return`${C}\0${v}`}vb(C,v){if(v){if("title"in v&&"command"in v)return{type:l.DebugVisualizationType.Command};if("treeId"in v)return{type:l.DebugVisualizationType.Tree,id:`${C}\0${v.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(C){const v=this.xb(C);let f,N;return"id"in v?N=n.ThemeIcon.asClassName(v):f=v,{iconPath:f,iconClass:N}}xb(C){if(C instanceof h.$uO)return{id:C.id};const v=typeof C=="object"&&"dark"in C?C.dark:C,f=typeof C=="object"&&"light"in C?C.light:C;return{dark:typeof v=="string"?k.URI.file(v):v,light:typeof f=="string"?k.URI.file(f):f}}};e.$Ipc=d,e.$Ipc=d=Ye([Ve(0,S.$2P),Ve(1,P.$Toc),Ve(2,I.$xpc),Ve(3,g.$Woc),Ve(4,c.$9oc),Ve(5,$.$Apc),Ve(6,o.$lQ),Ve(7,s.$Cpc)],d);class u{constructor(C,v,f,N,F,j,z){this.f=C,this.g=v,this.h=f,this.j=N,this.k=F,this.l=j,this.m=z}get api(){const C=this;return this.d??(this.d=Object.freeze({id:C.g,type:C.h,get name(){return C.j},set name(v){C.j=v,C.f.$setDebugSessionName(C.g,v)},parentSession:C.m,workspaceFolder:C.k,configuration:C.l,customRequest(v,f){return C.f.$customDebugAdapterRequest(C.g,v,f)},getDebugProtocolBreakpoint(v){return C.f.$getDebugProtocolBreakpoint(C.g,v.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(C){this.j=C}get configuration(){return this.l}}e.$Jpc=u;class b{constructor(C){this.value=Object.freeze({append(v){C.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.$Kpc=b;class E{constructor(C){this.d=C}onWillStartSession(){this.d.forEach(C=>C.onWillStartSession?C.onWillStartSession():void 0)}onWillReceiveMessage(C){this.d.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(C):void 0)}onDidSendMessage(C){this.d.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(C):void 0)}onWillStopSession(){this.d.forEach(C=>C.onWillStopSession?C.onWillStopSession():void 0)}onError(C){this.d.forEach(v=>v.onError?v.onError(C):void 0)}onExit(C,v){this.d.forEach(f=>f.onExit?f.onExit(C,v):void 0)}}class D extends w.$Vtb{constructor(C){super(),this.h=C,C.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(C){this.h.handleMessage(C)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends d{constructor(C,v,f,N,F,j,z,M){super(C,v,f,N,F,j,z,M)}};e.$Lpc=y,e.$Lpc=y=Ye([Ve(0,S.$2P),Ve(1,P.$Toc),Ve(2,I.$xpc),Ve(3,g.$Woc),Ve(4,c.$9oc),Ve(5,$.$Apc),Ve(6,o.$lQ),Ve(7,s.$Cpc)],y)}),define(Se[390],De([1,0,14,62,2,6,338,12,89,115,30,275,20,73,53,95]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=e.$Lqc=void 0,r=Ue(r),a=Ue(a);class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(R.$ak),i=n.get(h.$2P).getProxy(A.$vN.MainThreadErrors);r.setUnexpectedErrorHandler(s=>{o.error(s);const d=r.$5(s);i.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(R.$ak),t=n.get(h.$2P),i=n.get(w.$xpc),s=n.get(l.$jQ),d=t.getProxy(A.$vN.MainThreadExtensionService),u=t.getProxy(A.$vN.MainThreadErrors),b=await i.getExtensionPathIndex(),E=new WeakMap;function D(C,v){if(E.has(C))return E.get(C).stack;let f="",N,F;for(const z of v)f+=`
	at ${z.toString()}`,F=z.getFileName(),!N&&F&&(N=b.findSubstr(k.URI.file(F)));const j=`${C.name||"Error"}: ${C.message||""}${f}`;return E.set(C,{extensionIdentifier:N?.identifier,stack:j}),j}const y=Symbol("prepareStackTrace wrapped");let T=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return T},set(C){if(C===D||!C||C[y]){T=C||D;return}T=function(v,f){return D(v,f),C.call(Error,v,f)},Object.assign(T,{[y]:!0})}}),r.setUnexpectedErrorHandler(C=>{o.error(C);const v=r.$5(C),f=E.get(C);if(!f?.extensionIdentifier){u.$onUnexpectedError(v);return}d.$onExtensionRuntimeError(f.extensionIdentifier,v);const N=s.onExtensionError(f.extensionIdentifier,C);o.trace("forwarded error to extension?",N,f)})}}e.$Lqc=m;class g{constructor(n,o,t,i,s){this.a=t,this.b=new O.$9cc(n,null,i),o=g.e(o,this.b);const d=new c.$Ei(...(0,p.$Rs)());d.set(I.$fQ,{_serviceBrand:void 0,...o,messagePorts:s}),d.set(h.$2P,new h.$3P(this.b)),d.set(P.$Qoc,new P.$Roc(i)),d.set(w.$vpc,t);const u=new S.$vr(d,!0);u.invokeFunction(m.installEarlyHandler),this.d=u.invokeFunction(b=>b.get(R.$ak)),a.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(b=>b.get(w.$xpc)),this.c.initialize(),u.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(A.$vN.MainThreadExtensionService);return k.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(i=>{i.extensionLocation=k.URI.revive(o.transformIncomingURIs(i.extensionLocation))}),n.environment.appRoot=k.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const t=n.environment.extensionDevelopmentLocationURI;return t&&(n.environment.extensionDevelopmentLocationURI=t.map(i=>k.URI.revive(o.transformIncomingURIs(i)))),n.environment.extensionTestsLocationURI=k.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=k.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=k.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=k.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=k.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=k.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$Mqc=g}),define(Se[391],De([1,0,7,11,246,268,150,102,78,53,20,48,8,65,42,309,310,43,35,99]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=void 0,a=Ue(a),k=Ue(k);let o=class extends R.$Ipc{constructor(u,b,E,D,y,T,C,v,f){super(u,b,E,D,T,C,v,f),this.Ab=y,this.yb=new s}hb(u,b){switch(u.type){case"server":return new l.$Rqc(u);case"pipeServer":return new l.$Sqc(u);case"executable":return new l.$Tqc(u,b.type)}return super.hb(u,b)}qb(u,b){const E=l.$Tqc.platformAdapterExecutable(b.getAllExtensionDescriptions(),u.type);if(E)return new h.$CO(E.command,E.args,E.options)}ib(){return new O.$6gc}async $runInTerminal(u,b){if(u.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(M=>{this.yb.onTerminalClosed(M)})));const E=await this.$.getConfigProvider(),D=this.Ab.getDefaultShell(!0),y=this.Ab.getDefaultShellArgs(!0),T=u.title||k.localize(0,null),C=JSON.stringify({shell:D,shellArgs:y});let v=await this.yb.checkout(C,T),f,N=!1;if(v)f=u.cwd;else{const M={shellPath:D,shellArgs:y,cwd:u.cwd,name:T,iconPath:new h.$uO("debug")};N=!0,v=this.Ab.createTerminalFromOptions(M,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(v,C)}v.show(!0);const F=await v.processId;N?await new Promise(M=>setTimeout(M,1e3)):(v.state.isInteractedWith&&(v.sendText(""),await(0,r.$Hh)(200)),E.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?v.sendText("cls"):D.indexOf("bash")>=0?v.sendText("clear"):a.$c?v.sendText("cls"):v.sendText("clear")));const j=(0,m.$Vqc)(D,u.args,!!u.argsCanBeInterpretedByShell,f,u.env);v.sendText(j);const z=this.onDidTerminateDebugSession(M=>{M.id===b&&(this.yb.free(v),z.dispose())});return F}else if(u.kind==="external")return i(u,await this.$.getConfigProvider());return super.$runInTerminal(u,b)}};e.$Wqc=o,e.$Wqc=o=Ye([Ve(0,I.$2P),Ve(1,w.$Toc),Ve(2,c.$xpc),Ve(3,g.$Woc),Ve(4,S.$ipc),Ve(5,p.$9oc),Ve(6,P.$Apc),Ve(7,$.$lQ),Ve(8,n.$Cpc)],o);let t;function i(d,u){if(!t)if(a.$c)t=new A.$Nfc;else if(a.$d)t=new A.$Ofc;else if(a.$e)t=new A.$Pfc;else throw new Error("external terminals not supported on this platform");const b=u.getConfiguration("terminal");return t.runInTerminal(d.title,d.cwd,d.args,d.env||{},b.external||{})}class s{constructor(){this.b=new Map}async checkout(u,b,E=!1){const y=[...this.b.entries()].map(([T,C])=>(0,r.$th)(async v=>{if(T.name!==b||C.lastUsedAt!==-1&&await(0,m.$Uqc)(await T.processId))return null;const f=Date.now();return C.lastUsedAt+s.a>f||v.isCancellationRequested?null:C.config!==u?(E&&T.dispose(),null):(C.lastUsedAt=f,T)}));return await(0,r.$Lh)(y,T=>!!T)}insert(u,b){this.b.set(u,{lastUsedAt:Date.now(),config:b})}free(u){const b=this.b.get(u);b&&(b.lastUsedAt=-1)}onTerminalClosed(u){this.b.delete(u)}}s.a=1e3}),define(Se[392],De([1,0,17,2,110,42,64,43,47,48,20,30,101,15,12,96,23,67,65]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0,r=Ue(r),m=Ue(m);let n=class extends h.$sqc{constructor(t,i,s,d,u,b,E,D,y){super(t,i,s,d,u,b,E,D),this.C=s,this.D=y,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(P.Schemas.vscodeRemote,{scheme:P.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(P.Schemas.file,{scheme:P.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,i){const s=i;if(!i.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const d=h.TaskHandleDTO.from(s,this.C),u=await this.a.$getTaskExecution(d);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const b=await this.z(u,i);return this.a.$executeTask(d).catch(()=>{}),b}else{const d=h.TaskDTO.from(i,t);if(d===void 0)return Promise.reject(new Error("Task is not valid"));h.CustomExecutionDTO.is(d.execution)&&await this.y(d,i,!1);const u=await this.z(await this.a.$getTaskExecution(d),i);return this.a.$executeTask(d).catch(()=>{}),u}}v(t,i,s,d){const u=[];if(d)for(const b of d){this.A(b,s),(!b.definition||!t[b.definition.type])&&this.f.warn(`The task [${b.source}, ${b.name}] uses an undefined task type. The task will be ignored in the future.`);const E=h.TaskDTO.from(b,s.extension);E&&(u.push(E),h.CustomExecutionDTO.is(E.execution)&&i.push(this.y(E,b,!0)))}return{tasks:u,extension:s.extension}}async w(t){return t}async G(t){let i=t&&t.length>0?t[0]:void 0;if(!i){const s=a.URI.file((0,g.homedir)());i=new p.$1i({uri:s,name:m.$eh(s),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,i){const s=a.URI.revive(t),d={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(s),b=await this.b.getWorkspaceFolders2()??[],E=await this.D.getResolver(),D=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(b);for(const y of i.variables)d.variables[y]=await E.resolveAsync(D,y);if(i.process!==void 0){let y;if(i.process.path!==void 0){y=i.process.path.split(r.$wc);for(let T=0;T<y.length;T++)y[T]=await E.resolveAsync(D,y[T])}d.process=await k.win32.findExecutable(await E.resolveAsync(D,i.process.name),i.process.cwd!==void 0?await E.resolveAsync(D,i.process.cwd):void 0,y)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(t,i,s){return k.win32.findExecutable(t,i,s)}};e.$Oqc=n,e.$Oqc=n=Ye([Ve(0,I.$2P),Ve(1,S.$fQ),Ve(2,A.$Toc),Ve(3,O.$aQ),Ve(4,R.$Woc),Ve(5,c.$ipc),Ve(6,w.$ak),Ve(7,l.$xoc),Ve(8,$.$Apc)],n)}),define(Se[393],De([1,0,67,65]),function(ie,e,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$urc=void 0;class k extends a.$Bpc{m(){return(0,r.homedir)()}}e.$urc=k}),define(Se[172],De([1,0,19,7,21,51,15,17,23,2,38]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=e.$1pc=e.$Zpc=void 0,e.$2pc=l,R=Ue(R),p=Ue(p);class S{constructor($,n,o){this.d=$,this.e=n,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search($,n){const o=this.g.folderQueries||[],t=new k.$ye(n);return new Promise((i,s)=>{this.a=new P($);let d=!1;const u=(b,E)=>{if(!d&&!this.b){const D=this.h(b);l(b)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,d=!0,t.cancel(),b=this.j(b,this.g.maxResults-this.c));const y=this.h(b);this.c+=y,(y>0||!l(b))&&this.a.add(b,E)}};Promise.all(o.map((b,E)=>this.k(b,D=>u(D,E),t.token))).then(b=>{t.dispose(),this.a.flush();const E=b.some(D=>!!D&&!!D.limitHit);i({limitHit:this.b||E,messages:b.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},b=>{t.dispose();const E=(0,A.$rj)(b);s(new Error(E))})})}h($){return l($)?Array.isArray($.ranges)?$.ranges.length:1:0}j($,n){const o=Array.isArray($.ranges)?$.ranges:[$.ranges],t=Array.isArray($.preview.matches)?$.preview.matches:[$.preview.matches];return{ranges:o.slice(0,n),preview:{matches:t.slice(0,n),text:$.preview.text},uri:$.uri}}async k($,n,o){const t=new I.$_L(this.g,$),i=[],s={report:b=>{if(!this.l(b))return;const E=$.folder.scheme===O.Schemas.file?(0,I.$aM)(()=>this.e.readdir(p.$gh(b.uri))):void 0,D=p.$jh($.folder,b.uri);if(D){const y=t.includedInQuery(D,R.$qc(D),E);(0,a.$sh)(y)?i.push(y.then(T=>{T&&n(b)})):y&&n(b)}}},d=this.n($);let u;return this.d.query.type===I.QueryType.aiText?u=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,s,o):u=await this.d.provider.provideTextSearchResults(h(this.d.query.contentPattern),d,s,o),i.length&&await Promise.all(i),u}l($){if(l($)){if(Array.isArray($.ranges)){if(!Array.isArray($.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if($.preview.matches.length!==$.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray($.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n($){const n=(0,I.$$L)(this.g.includePattern,$.includePattern),o=(0,I.$$L)(this.g.excludePattern,$.excludePattern),t={folder:c.URI.from($.folder),excludes:o,includes:n,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,encoding:$.fileEncoding&&this.e.toCanonicalName($.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$RL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Zpc=S;function h(g){return{isCaseSensitive:g.isCaseSensitive||!1,isRegExp:g.isRegExp||!1,isWordMatch:g.isWordMatch||!1,isMultiline:g.isMultiline||!1,pattern:g.pattern}}class P{constructor($){this.e=$,this.b=-1,this.d=null,this.a=new m(512,n=>this.g(n))}add($,n){this.d&&(this.b!==n||!p.$ah(this.c,$.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:$.uri,results:[]}),this.d.results.push(w($))}f(){const $=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,$)}flush(){this.f(),this.a.flush()}g($){this.e($)}}e.$1pc=P;function w(g){return l(g)?{preview:{matches:(0,r.$4b)(g.preview.matches,$=>({startLineNumber:$.start.line,startColumn:$.start.character,endLineNumber:$.end.line,endColumn:$.end.character})),text:g.preview.text},ranges:(0,r.$4b)(g.ranges,$=>({startLineNumber:$.start.line,startColumn:$.start.character,endLineNumber:$.end.line,endColumn:$.end.character}))}:{text:g.text,lineNumber:g.lineNumber}}function l(g){return!!g.preview}class m{constructor($,n){this.g=$,this.h=n,this.c=0,this.d=[],this.e=0}addItem($,n){$&&this.j($,n)}addItems($,n){$&&this.k($,n)}j($,n){this.d.push($),this.e+=n,this.l()}k($,n){this.d=this.d.concat($),this.e+=n,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$3pc=m,m.a=4e3,m.b=50}),define(Se[103],De([1,0,3,6,5,386,20,73,12,2,172]),function(ie,e,r,a,k,A,O,R,p,c,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=e.$4pc=void 0,e.$6pc=h,e.$4pc=(0,k.$Gi)("IExtHostSearch");let S=class{constructor(l,m,g){this.n=l,this.o=m,this.q=g,this.c=this.n.getProxy(a.$vN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$Ypc}s(l){return this.o.transformOutgoingScheme(l)}registerTextSearchProvider(l,m){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const g=this.d++;return this.e.set(g,m),this.c.$registerTextSearchProvider(g,this.s(l)),(0,r.$Vc)(()=>{this.g.delete(l),this.e.delete(g),this.c.$unregisterProvider(g)})}registerAITextSearchProvider(l,m){if(this.i.has(l))throw new Error(`an AI text search provider for the scheme '${l}'is already registered`);this.i.add(l);const g=this.d++;return this.h.set(g,m),this.c.$registerAITextSearchProvider(g,this.s(l)),(0,r.$Vc)(()=>{this.i.delete(l),this.h.delete(g),this.c.$unregisterProvider(g)})}registerFileSearchProvider(l,m){if(this.k.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.k.add(l);const g=this.d++;return this.j.set(g,m),this.c.$registerFileSearchProvider(g,this.s(l)),(0,r.$Vc)(()=>{this.k.delete(l),this.j.delete(g),this.c.$unregisterProvider(g)})}$provideFileSearchResults(l,m,g,$){const n=h(g),o=this.j.get(l);if(o)return this.l.fileSearch(n,o,t=>{this.c.$handleFileMatch(l,m,t.map(i=>i.resource))},$);throw new Error("3 unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,m,g){return{messages:[]}}$clearCache(l){return this.l.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,m,g,$){const n=this.e.get(l);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${l}`);const o=h(g);return this.t(o,n).search(i=>this.c.$handleTextMatch(l,m,i),$)}$provideAITextSearchResults(l,m,g,$){const n=this.h.get(l);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${l}`);const o=h(g);return this.v(o,n).search(i=>this.c.$handleTextMatch(l,m,i),$)}$enableExtensionHostSearch(){}t(l,m){return new I.$Zpc({query:l,provider:m},{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g},"textSearchProvider")}v(l,m){return new I.$Zpc({query:l,provider:m},{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g},"aiTextSearchProvider")}};e.$5pc=S,e.$5pc=S=Ye([Ve(0,O.$2P),Ve(1,R.$Qoc),Ve(2,p.$ak)],S);function h(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(P),extraFileResources:w.extraFileResources&&w.extraFileResources.map(l=>c.URI.revive(l))}}function P(w){return{...w,folder:c.URI.revive(w.folder)}}});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[394],De([1,0,21,14,4,3,15,45,2,114,201,202,58,24,28,12,91,92,296,6,340,367,96,129,344,345,346,325,315,35,347,43,348,102,164,349,327,341,350,351,64,78,328,342,53,352,76,353,63,30,368,329,354,355,130,356,124,125,330,385,358,300,359,369,360,170,331,361,362,363,20,364,103,126,365,332,366,127,98,101,95,48,168,99,370,343,371,372,77,16,8,333,73,334,97,373,374,163,42,121,94,26,100]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s,d,u,b,E,D,y,T,C,v,f,N,F,j,z,M,L,B,W,ae,q,K,ee,re,ge,Z,$e,fe,oe,H,ue,te,_,ne,le,J,ce,me,we,Me,qe,ke,Ie,Ce,U,V,X,x,de,ve,Fe,Ge,Xe,Qe,nt,ct,rt,lt,bt,ft,at,dt,Pe,ze,Re,Ne,he,Y,Ae,Ze,et,ut,mt,Dt,Ft,Kt,li,fi,tt,xt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=Jt,a=Ue(a),R=qt(R),S=Ue(S),w=Ue(w),he=Ue(he),Y=Ue(Y);function Jt(wt){const kt=wt.get($e.$fQ),si=wt.get(Z.$Boc),_t=wt.get(re.$Yoc),Wt=wt.get(K.$xpc),vt=wt.get(Kt.$Toc),Tt=wt.get(lt.$jQ),ei=wt.get(C.$Woc),Vt=wt.get(Ze.$Qoc),_e=wt.get(x.$2P),ti=wt.get(nt.$fpc),oi=wt.get(ct.$Zoc),gi=wt.get(l.$bk),Ct=wt.get(l.$ak),Gt=wt.get(Ne.$_Fb),Mt=wt.get(i.$xoc),Ht=wt.get(Ft.$Fqc),$i=wt.get(Fe.$ppc),ii=wt.get(W.$9oc),ui=wt.get(le.$tpc),jt=wt.get(s.$Hoc),Xt=wt.get(te.$mpc);_e.set(n.$wN.ExtHostFileSystemInfo,si),_e.set(n.$wN.ExtHostLogLevelServiceShape,gi),_e.set(n.$wN.ExtHostWorkspace,vt),_e.set(n.$wN.ExtHostConfiguration,ei),_e.set(n.$wN.ExtHostExtensionService,Wt),_e.set(n.$wN.ExtHostStorage,ti),_e.set(n.$wN.ExtHostTunnelService,Gt),_e.set(n.$wN.ExtHostWindow,Ht),_e.set(n.$wN.ExtHostSecretState,$i),_e.set(n.$wN.ExtHostTelemetry,Tt),_e.set(n.$wN.ExtHostEditorTabs,ii),_e.set(n.$wN.ExtHostManagedSockets,ui),_e.set(n.$wN.ExtHostAuthentication,jt),_e.set(n.$wN.ExtHostChatProvider,Xt);const ni=_e.set(n.$wN.ExtHostDecorations,wt.get(N.$Npc)),Ot=_e.set(n.$wN.ExtHostDocumentsAndEditors,wt.get(B.$aQ)),At=_e.set(n.$wN.ExtHostCommands,wt.get(y.$lQ)),Et=_e.set(n.$wN.ExtHostTerminalService,wt.get(bt.$ipc)),ri=_e.set(n.$wN.ExtHostTerminalShellIntegration,wt.get(ft.$vqc)),yt=_e.set(n.$wN.ExtHostDebugService,wt.get(f.$Hpc)),ai=_e.set(n.$wN.ExtHostSearch,wt.get(ve.$4pc)),Qt=_e.set(n.$wN.ExtHostTask,wt.get(rt.$uqc)),wi=_e.set(n.$wN.ExtHostOutputService,wt.get(Ie.$hqc)),mi=_e.set(n.$wN.ExtHostLocalization,wt.get(ne.$spc)),vi=_e.set(n.$wN.ExtHostUrls,new et.$Cqc(_e)),Bt=_e.set(n.$wN.ExtHostDocuments,new L.$Eoc(_e,Ot)),Ai=_e.set(n.$wN.ExtHostDocumentContentProviders,new z.$Ppc(_e,Ot,Ct)),Mi=_e.set(n.$wN.ExtHostDocumentSaveParticipant,new M.$Qpc(Ct,Bt,_e.getProxy(n.$vN.MainThreadBulkEdits))),Lt=_e.set(n.$wN.ExtHostNotebook,new ce.$7pc(_e,At,Ot,Bt,_t,ai,Ct)),Ii=_e.set(n.$wN.ExtHostNotebookDocuments,new we.$bqc(Lt)),Pi=_e.set(n.$wN.ExtHostNotebookEditors,new Me.$cqc(Ct,Lt)),yi=_e.set(n.$wN.ExtHostNotebookKernels,new qe.$dqc(_e,kt,Lt,At,Ct)),hi=_e.set(n.$wN.ExtHostNotebookRenderers,new ke.$fqc(_e,Lt)),ji=_e.set(n.$wN.ExtHostNotebookDocumentSaveParticipant,new me.$aqc(Ct,Lt,_e.getProxy(n.$vN.MainThreadBulkEdits))),Nt=_e.set(n.$wN.ExtHostEditors,new dt.$Noc(_e,Ot)),Te=_e.set(n.$wN.ExtHostTreeViews,new Re.$Aqc(_e.getProxy(n.$vN.MainThreadTreeViews),At,Ct)),je=_e.set(n.$wN.ExtHostEditorInsets,new D.$Ooc(_e.getProxy(n.$vN.MainThreadEditorInsets),Nt,kt.remote)),ye=_e.set(n.$wN.ExtHostDiagnostics,new F.$Doc(_e,Ct,si,Ot)),se=_e.set(n.$wN.ExtHostLanguages,new _.$$pc(_e,Bt,At.converter,Vt)),Oe=_e.set(n.$wN.ExtHostLanguageFeatures,new H.$Foc(_e,Vt,Bt,At,ye,Ct,Mt,Tt)),Ke=_e.set(n.$wN.ExtHostFileSystem,new ee.$Tpc(_e,Oe)),it=_e.set(n.$wN.ExtHostFileSystemEventService,new ge.$Upc(_e,Ct,Ot)),Je=_e.set(n.$wN.ExtHostQuickOpen,(0,X.$lqc)(_e,vt,At)),$t=_e.set(n.$wN.ExtHostSCM,new de.$nqc(_e,At,Bt,Ct)),Rt=_e.set(n.$wN.ExtHostQuickDiff,new V.$kqc(_e,Vt)),Yt=_e.set(n.$wN.ExtHostShare,new Ge.$oqc(_e,Vt)),ci=_e.set(n.$wN.ExtHostComments,(0,T.$Poc)(_e,At,Bt)),Ut=_e.set(n.$wN.ExtHostProgress,new U.$jqc(_e.getProxy(n.$vN.MainThreadProgress))),di=_e.set(n.$wN.ExtHostLabelService,new oe.$9pc(_e)),en=_e.set(n.$wN.ExtHostTheming,new Pe.$xqc(_e)),Gi=_e.set(n.$wN.ExtHostTimeline,new ze.$zqc(_e,At)),zi=_e.set(n.$wN.ExtHostWebviews,new ut.$4oc(_e,kt.remote,vt,Ct,Mt)),Oi=_e.set(n.$wN.ExtHostWebviewPanels,new mt.$7oc(_e,zi,vt)),Hi=_e.set(n.$wN.ExtHostCustomEditors,new v.$8oc(_e,Bt,oi,zi,Oi)),Ki=_e.set(n.$wN.ExtHostWebviewViews,new Dt.$Dqc(_e,zi)),Ei=_e.set(n.$wN.ExtHostTesting,wt.get(at.$Cpc)),tn=_e.set(n.$wN.ExtHostUriOpeners,new Ae.$Bqc(_e)),nn=_e.set(n.$wN.ExtHostProfileContentHandlers,new Ce.$iqc(_e));_e.set(n.$wN.ExtHostInteractive,new fe.$8pc(_e,Lt,Ot,At,Ct));const Qi=_e.set(n.$wN.ExtHostChatAgents2,new u.$Koc(_e,Ct,At)),rn=_e.set(n.$wN.ExtHostChatVariables,new b.$Loc(_e)),Li=_e.set(n.$wN.ExtHostLanguageModelTools,new ue.$0pc(_e)),Bi=_e.set(n.$wN.ExtHostAiRelatedInformation,new o.$woc(_e)),sn=_e.set(n.$wN.ExtHostAiEmbeddingVector,new q.$Spc(_e)),Ji=_e.set(n.$wN.ExtHostStatusBar,new Qe.$rqc(_e,At.converter)),on=_e.set(n.$wN.ExtHostSpeech,new Xe.$pqc(_e)),Ri=_e.set(n.$wN.ExtHostEmbeddings,new ae.$Rpc(_e)),an=Object.values(n.$wN);_e.assertRegistered(an);const cn=new d.$Joc(_e,Ot),Sn=new E.$Moc(_e),Xi=new J.$_pc(_e,Ct),Ui=new j.$Opc(_e);return t.$Goc.register(At),function(We,Si,ln){function ht(pe){return(Ee,Be,gt)=>{const It=pe(zt=>{try{Ee.call(Be,zt)}catch(Fi){a.$4(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Fi.toString()}`,{cause:Fi})),Tt.onExtensionError(We.identifier,Fi)}});return gt?.push(It),It}}const Pt=function(){let pe=!We.isUnderDevelopment;function Ee(){pe||(Ct.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Be(gt){if(Array.isArray(gt))gt.forEach(Be);else if(typeof gt=="string")Ee();else{const It=gt;typeof It.scheme>"u"&&Ee(),typeof It.exclusive=="boolean"&&(0,tt.$8G)(We,"documentFiltersExclusive")}return gt}}(),Wi={getSession(pe,Ee,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,tt.$8G)(We,"authLearnMore"),Be?.account&&(0,tt.$8G)(We,"authGetSessions"),jt.getSession(We,pe,Ee,Be)},getAccounts(pe){return(0,tt.$8G)(We,"authGetSessions"),jt.getAccounts(pe)},async hasSession(pe,Ee){return(0,tt.$8G)(We,"authSession"),!!await jt.getSession(We,pe,Ee,{silent:!0})},get onDidChangeSessions(){return ht(jt.onDidChangeSessions)},registerAuthenticationProvider(pe,Ee,Be,gt){return jt.registerAuthenticationProvider(pe,Ee,Be,gt)}},un={registerCommand(pe,Ee,Be){return At.registerCommand(!0,pe,Ee,Be,void 0,We)},registerTextEditorCommand(pe,Ee,Be){return At.registerCommand(!0,pe,(...gt)=>{const It=Nt.getActiveTextEditor();if(!It){Ct.warn("Cannot execute "+pe+" because there is no active text editor.");return}return It.edit(zt=>{Ee.apply(Be,[It,zt,...gt])}).then(zt=>{zt||Ct.warn("Edits from command "+pe+" were not applied.")},zt=>{Ct.warn("An error occurred while running command "+pe,zt)})},void 0,void 0,We)},registerDiffInformationCommand:(pe,Ee,Be)=>((0,tt.$8G)(We,"diffCommand"),At.registerCommand(!0,pe,async(...gt)=>{const It=Ot.activeEditor(!0);if(!It){Ct.warn("Cannot execute "+pe+" because there is no active text editor.");return}const zt=await Nt.getDiffInformation(It.id);Ee.apply(Be,[zt,...gt])},void 0,void 0,We)),executeCommand(pe,...Ee){return At.executeCommand(pe,...Ee)},getCommands(pe=!1){return At.getCommands(pe)}},Yi={get machineId(){return kt.telemetryInfo.machineId},get sessionId(){return kt.telemetryInfo.sessionId},get language(){return kt.environment.appLanguage},get appName(){return kt.environment.appName},get appRoot(){return kt.environment.appRoot?.fsPath??""},get appHost(){return kt.environment.appHost},get uriScheme(){return kt.environment.appUriScheme},get clipboard(){return Sn.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return ht(Et.onDidChangeShell)},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ht(Tt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$8G)(We,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$8G)(We,"telemetry"),ht(Tt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,lt.$iQ)(kt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,Ee){return lt.$hQ.validateSender(pe),Tt.instantiateLogger(We,pe,Ee)},openExternal(pe,Ee){return Ht.openUri(pe,{allowTunneling:!!kt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===kt.environment.appUriScheme)return vi.createAppUri(pe);try{return await Ht.asExternalUri(pe,{allowTunneling:!!kt.remote.authority})}catch(Ee){if((0,O.$Pg)(pe,O.Schemas.http)||(0,O.$Pg)(pe,O.Schemas.https))return pe;throw Ee}},get remoteName(){return(0,m.$jn)(kt.remote.authority)},get remoteAuthority(){return(0,tt.$8G)(We,"resolvers"),kt.remote.authority},get uiKind(){return kt.uiKind},get logLevel(){return Ct.getLevel()},get onDidChangeLogLevel(){return ht(Ct.onDidChangeLogLevel)},get appQuality(){return(0,tt.$8G)(We,"resolvers"),kt.quality},get appCommit(){return(0,tt.$8G)(We,"resolvers"),kt.commit}};kt.environment.extensionTestsLocationURI||Object.freeze(Yi);const hn={createTestController(pe,Ee,Be){return Ei.createTestController(We,pe,Ee,Be)},createTestObserver(){return(0,tt.$8G)(We,"testObserver"),Ei.createTestObserver()},runTests(pe){return(0,tt.$8G)(We,"testObserver"),Ei.runTests(pe)},registerTestFollowupProvider(pe){return(0,tt.$8G)(We,"testObserver"),Ei.registerTestFollowupProvider(pe)},get onDidChangeTestResults(){return(0,tt.$8G)(We,"testObserver"),ht(Ei.onResultsChanged)},get testResults(){return(0,tt.$8G)(We,"testObserver"),Ei.results}},qi=kt.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,Zi={getExtension(pe,Ee){(0,tt.$7G)(We,"extensionsAny")||(Ee=!1);const Be=Si.mine.getExtensionDescription(pe);if(Be)return new K.$ypc(Wt,We.identifier,Be,qi,!1);if(Ee){const gt=Si.all.getExtensionDescription(pe);if(gt)return new K.$ypc(Wt,We.identifier,gt,qi,!0)}},get all(){const pe=[];for(const Ee of Si.mine.getAllExtensionDescriptions())pe.push(new K.$ypc(Wt,We.identifier,Ee,qi,!1));return pe},get allAcrossExtensionHosts(){(0,tt.$8G)(We,"extensionsAny");const pe=new P.$tn(Si.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Ee=[];for(const Be of Si.all.getAllExtensionDescriptions()){const gt=!pe.has(Be.identifier);Ee.push(new K.$ypc(Wt,We.identifier,Be,qi,gt))}return Ee},get onDidChange(){return(0,tt.$7G)(We,"extensionsAny")?ht(k.Event.any(Si.mine.onDidChange,Si.all.onDidChange)):ht(Si.mine.onDidChange)}},dn={createDiagnosticCollection(pe){return ye.createDiagnosticCollection(We.identifier,pe)},get onDidChangeDiagnostics(){return ht(ye.onDidChangeDiagnostics)},getDiagnostics:pe=>ye.getDiagnostics(pe),getLanguages(){return se.getLanguages()},setTextDocumentLanguage(pe,Ee){return se.changeLanguage(pe.uri,Ee)},match(pe,Ee){const Be=he.LanguageSelector.from(pe);let gt;return(0,I.$vu)(Be)&&(gt=Lt.notebookDocuments.find(It=>It.apiNotebook.getCells().find(zt=>zt.document===Ee))?.apiNotebook),(0,I.$uu)(Be,Ee.uri,Ee.languageId,!0,gt?.uri,gt?.notebookType)},registerCodeActionsProvider(pe,Ee,Be){return Oe.registerCodeActionProvider(We,Pt(pe),Ee,Be)},registerDocumentPasteEditProvider(pe,Ee,Be){return(0,tt.$8G)(We,"documentPaste"),Oe.registerDocumentPasteEditProvider(We,Pt(pe),Ee,Be)},registerCodeLensProvider(pe,Ee){return Oe.registerCodeLensProvider(We,Pt(pe),Ee)},registerDefinitionProvider(pe,Ee){return Oe.registerDefinitionProvider(We,Pt(pe),Ee)},registerDeclarationProvider(pe,Ee){return Oe.registerDeclarationProvider(We,Pt(pe),Ee)},registerImplementationProvider(pe,Ee){return Oe.registerImplementationProvider(We,Pt(pe),Ee)},registerTypeDefinitionProvider(pe,Ee){return Oe.registerTypeDefinitionProvider(We,Pt(pe),Ee)},registerHoverProvider(pe,Ee){return Oe.registerHoverProvider(We,Pt(pe),Ee,We.identifier)},registerEvaluatableExpressionProvider(pe,Ee){return Oe.registerEvaluatableExpressionProvider(We,Pt(pe),Ee,We.identifier)},registerInlineValuesProvider(pe,Ee){return Oe.registerInlineValuesProvider(We,Pt(pe),Ee,We.identifier)},registerDocumentHighlightProvider(pe,Ee){return Oe.registerDocumentHighlightProvider(We,Pt(pe),Ee)},registerMultiDocumentHighlightProvider(pe,Ee){return Oe.registerMultiDocumentHighlightProvider(We,Pt(pe),Ee)},registerLinkedEditingRangeProvider(pe,Ee){return Oe.registerLinkedEditingRangeProvider(We,Pt(pe),Ee)},registerReferenceProvider(pe,Ee){return Oe.registerReferenceProvider(We,Pt(pe),Ee)},registerRenameProvider(pe,Ee){return Oe.registerRenameProvider(We,Pt(pe),Ee)},registerNewSymbolNamesProvider(pe,Ee){return(0,tt.$8G)(We,"newSymbolNamesProvider"),Oe.registerNewSymbolNamesProvider(We,Pt(pe),Ee)},registerDocumentSymbolProvider(pe,Ee,Be){return Oe.registerDocumentSymbolProvider(We,Pt(pe),Ee,Be)},registerWorkspaceSymbolProvider(pe){return Oe.registerWorkspaceSymbolProvider(We,pe)},registerDocumentFormattingEditProvider(pe,Ee){return Oe.registerDocumentFormattingEditProvider(We,Pt(pe),Ee)},registerDocumentRangeFormattingEditProvider(pe,Ee){return Oe.registerDocumentRangeFormattingEditProvider(We,Pt(pe),Ee)},registerOnTypeFormattingEditProvider(pe,Ee,Be,...gt){return Oe.registerOnTypeFormattingEditProvider(We,Pt(pe),Ee,[Be].concat(gt))},registerDocumentSemanticTokensProvider(pe,Ee,Be){return Oe.registerDocumentSemanticTokensProvider(We,Pt(pe),Ee,Be)},registerDocumentRangeSemanticTokensProvider(pe,Ee,Be){return Oe.registerDocumentRangeSemanticTokensProvider(We,Pt(pe),Ee,Be)},registerSignatureHelpProvider(pe,Ee,Be,...gt){return typeof Be=="object"?Oe.registerSignatureHelpProvider(We,Pt(pe),Ee,Be):Oe.registerSignatureHelpProvider(We,Pt(pe),Ee,typeof Be>"u"?[]:[Be,...gt])},registerCompletionItemProvider(pe,Ee,...Be){return Oe.registerCompletionItemProvider(We,Pt(pe),Ee,Be)},registerInlineCompletionItemProvider(pe,Ee,Be){return Ee.handleDidShowCompletionItem&&(0,tt.$8G)(We,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,tt.$8G)(We,"inlineCompletionsAdditions"),Be&&(0,tt.$8G)(We,"inlineCompletionsAdditions"),Oe.registerInlineCompletionsProvider(We,Pt(pe),Ee,Be)},registerInlineEditProvider(pe,Ee){return(0,tt.$8G)(We,"inlineEdit"),Oe.registerInlineEditProvider(We,Pt(pe),Ee)},registerDocumentLinkProvider(pe,Ee){return Oe.registerDocumentLinkProvider(We,Pt(pe),Ee)},registerColorProvider(pe,Ee){return Oe.registerColorProvider(We,Pt(pe),Ee)},registerFoldingRangeProvider(pe,Ee){return Oe.registerFoldingRangeProvider(We,Pt(pe),Ee)},registerSelectionRangeProvider(pe,Ee){return Oe.registerSelectionRangeProvider(We,pe,Ee)},registerCallHierarchyProvider(pe,Ee){return Oe.registerCallHierarchyProvider(We,pe,Ee)},registerTypeHierarchyProvider(pe,Ee){return Oe.registerTypeHierarchyProvider(We,pe,Ee)},setLanguageConfiguration:(pe,Ee)=>Oe.setLanguageConfiguration(We,pe,Ee),getTokenInformationAtPosition(pe,Ee){return(0,tt.$8G)(We,"tokenInformation"),se.tokenAtPosition(pe,Ee)},registerInlayHintsProvider(pe,Ee){return Oe.registerInlayHintsProvider(We,pe,Ee)},createLanguageStatusItem(pe,Ee){return se.createLanguageStatusItem(We,pe,Ee)},registerDocumentDropEditProvider(pe,Ee,Be){return Oe.registerDocumentOnDropEditProvider(We,pe,Ee,(0,tt.$7G)(We,"documentPaste")?Be:void 0)}},Di={get activeTextEditor(){return Nt.getActiveTextEditor()},get visibleTextEditors(){return Nt.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(pe,Ee,Be){p.URI.isUri(pe)&&pe.scheme===O.Schemas.vscodeRemote&&!pe.authority&&Mt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const gt=await(p.URI.isUri(pe)?Promise.resolve(Ni.openTextDocument(pe)):Promise.resolve(pe));return Nt.showTextDocument(gt,Ee,Be)},createTextEditorDecorationType(pe){return Nt.createTextEditorDecorationType(We,pe)},onDidChangeActiveTextEditor(pe,Ee,Be){return ht(Nt.onDidChangeActiveTextEditor)(pe,Ee,Be)},onDidChangeVisibleTextEditors(pe,Ee,Be){return ht(Nt.onDidChangeVisibleTextEditors)(pe,Ee,Be)},onDidChangeTextEditorSelection(pe,Ee,Be){return ht(Nt.onDidChangeTextEditorSelection)(pe,Ee,Be)},onDidChangeTextEditorOptions(pe,Ee,Be){return ht(Nt.onDidChangeTextEditorOptions)(pe,Ee,Be)},onDidChangeTextEditorVisibleRanges(pe,Ee,Be){return ht(Nt.onDidChangeTextEditorVisibleRanges)(pe,Ee,Be)},onDidChangeTextEditorViewColumn(pe,Ee,Be){return ht(Nt.onDidChangeTextEditorViewColumn)(pe,Ee,Be)},onDidCloseTerminal(pe,Ee,Be){return ht(Et.onDidCloseTerminal)(pe,Ee,Be)},onDidOpenTerminal(pe,Ee,Be){return ht(Et.onDidOpenTerminal)(pe,Ee,Be)},onDidChangeActiveTerminal(pe,Ee,Be){return ht(Et.onDidChangeActiveTerminal)(pe,Ee,Be)},onDidChangeTerminalDimensions(pe,Ee,Be){return(0,tt.$8G)(We,"terminalDimensions"),ht(Et.onDidChangeTerminalDimensions)(pe,Ee,Be)},onDidChangeTerminalState(pe,Ee,Be){return ht(Et.onDidChangeTerminalState)(pe,Ee,Be)},onDidWriteTerminalData(pe,Ee,Be){return(0,tt.$8G)(We,"terminalDataWriteEvent"),ht(Et.onDidWriteTerminalData)(pe,Ee,Be)},onDidExecuteTerminalCommand(pe,Ee,Be){return(0,tt.$8G)(We,"terminalExecuteCommandEvent"),ht(Et.onDidExecuteTerminalCommand)(pe,Ee,Be)},onDidChangeTerminalShellIntegration(pe,Ee,Be){return(0,tt.$8G)(We,"terminalShellIntegration"),ht(ri.onDidChangeTerminalShellIntegration)(pe,Ee,Be)},onDidStartTerminalShellExecution(pe,Ee,Be){return(0,tt.$8G)(We,"terminalShellIntegration"),ht(ri.onDidStartTerminalShellExecution)(pe,Ee,Be)},onDidEndTerminalShellExecution(pe,Ee,Be){return(0,tt.$8G)(We,"terminalShellIntegration"),ht(ri.onDidEndTerminalShellExecution)(pe,Ee,Be)},get state(){return Ht.getState()},onDidChangeWindowState(pe,Ee,Be){return ht(Ht.onDidChangeWindowState)(pe,Ee,Be)},showInformationMessage(pe,...Ee){return Xi.showMessage(We,R.default.Info,pe,Ee[0],Ee.slice(1))},showWarningMessage(pe,...Ee){return Xi.showMessage(We,R.default.Warning,pe,Ee[0],Ee.slice(1))},showErrorMessage(pe,...Ee){return Xi.showMessage(We,R.default.Error,pe,Ee[0],Ee.slice(1))},showQuickPick(pe,Ee,Be){return Je.showQuickPick(We,pe,Ee,Be)},showWorkspaceFolderPick(pe){return Je.showWorkspaceFolderPick(pe)},showInputBox(pe,Ee){return Je.showInput(pe,Ee)},showOpenDialog(pe){return Ui.showOpenDialog(We,pe)},showSaveDialog(pe){return Ui.showSaveDialog(pe)},createStatusBarItem(pe,Ee,Be){let gt,It,zt;return typeof pe=="string"?(gt=pe,It=Ee,zt=Be):(It=pe,zt=Ee),Ji.createStatusBarEntry(We,gt,It,zt)},setStatusBarMessage(pe,Ee){return Ji.setStatusBarMessage(pe,Ee)},withScmProgress(pe){return Mt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Ut.withProgress(We,{location:Y.ProgressLocation.SourceControl},(Ee,Be)=>pe({report(gt){}}))},withProgress(pe,Ee){return Ut.withProgress(We,pe,Ee)},createOutputChannel(pe,Ee){return wi.createOutputChannel(pe,Ee,We)},createWebviewPanel(pe,Ee,Be,gt){return Oi.createWebviewPanel(We,pe,Ee,Be,gt)},createWebviewTextEditorInset(pe,Ee,Be,gt){return(0,tt.$8G)(We,"editorInsets"),je.createWebviewEditorInset(pe,Ee,Be,gt,We)},createTerminal(pe,Ee,Be){return typeof pe=="object"?"pty"in pe?Et.createExtensionTerminal(pe):Et.createTerminalFromOptions(pe):Et.createTerminal(pe,Ee,Be)},registerTerminalLinkProvider(pe){return Et.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,Ee){return Et.registerProfileProvider(We,pe,Ee)},registerTerminalQuickFixProvider(pe,Ee){return(0,tt.$8G)(We,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(pe,We.identifier.value,Ee)},registerTreeDataProvider(pe,Ee){return Te.registerTreeDataProvider(pe,Ee,We)},createTreeView(pe,Ee){return Te.createTreeView(pe,Ee,We)},registerWebviewPanelSerializer:(pe,Ee)=>Oi.registerWebviewPanelSerializer(We,pe,Ee),registerCustomEditorProvider:(pe,Ee,Be={})=>Hi.registerCustomEditorProvider(We,pe,Ee,Be),registerFileDecorationProvider(pe){return ni.registerFileDecorationProvider(pe,We)},registerUriHandler(pe){return vi.registerUriHandler(We,pe)},createQuickPick(){return Je.createQuickPick(We)},createInputBox(){return Je.createInputBox(We)},get activeColorTheme(){return en.activeColorTheme},onDidChangeActiveColorTheme(pe,Ee,Be){return ht(en.onDidChangeActiveColorTheme)(pe,Ee,Be)},registerWebviewViewProvider(pe,Ee,Be){return Ki.registerWebviewViewProvider(We,pe,Ee,Be?.webviewOptions)},get activeNotebookEditor(){return Lt.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,Ee,Be){return ht(Lt.onDidChangeActiveNotebookEditor)(pe,Ee,Be)},get visibleNotebookEditors(){return Lt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ht(Lt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(pe,Ee,Be){return ht(Pi.onDidChangeNotebookEditorSelection)(pe,Ee,Be)},onDidChangeNotebookEditorVisibleRanges(pe,Ee,Be){return ht(Pi.onDidChangeNotebookEditorVisibleRanges)(pe,Ee,Be)},showNotebookDocument(pe,Ee){return Lt.showNotebookDocument(pe,Ee)},registerExternalUriOpener(pe,Ee,Be){return(0,tt.$8G)(We,"externalUriOpener"),tn.registerExternalUriOpener(We.identifier,pe,Ee,Be)},registerProfileContentHandler(pe,Ee){return(0,tt.$8G)(We,"profileContentHandlers"),nn.registerProfileContentHandler(We,pe,Ee)},registerQuickDiffProvider(pe,Ee,Be,gt){return(0,tt.$8G)(We,"quickDiffProvider"),Rt.registerQuickDiffProvider(Pt(pe),Ee,Be,gt)},get tabGroups(){return ii.tabGroups},registerShareProvider(pe,Ee){return(0,tt.$8G)(We,"shareProvider"),Yt.registerShareProvider(Pt(pe),Ee)}},Ni={get rootPath(){return Mt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),vt.getPath()},set rootPath(pe){throw new a.$_("rootPath")},getWorkspaceFolder(pe){return vt.getWorkspaceFolder(pe)},get workspaceFolders(){return vt.getWorkspaceFolders()},get name(){return vt.name},set name(pe){throw new a.$_("name")},get workspaceFile(){return vt.workspaceFile},set workspaceFile(pe){throw new a.$_("workspaceFile")},updateWorkspaceFolders:(pe,Ee,...Be)=>vt.updateWorkspaceFolders(We,pe,Ee||0,...Be),onDidChangeWorkspaceFolders:function(pe,Ee,Be){return ht(vt.onDidChangeWorkspace)(pe,Ee,Be)},asRelativePath:(pe,Ee)=>vt.getRelativePath(pe,Ee),findFiles:(pe,Ee,Be,gt)=>vt.findFiles(pe,Ee,Be,We.identifier,gt),findFiles2:(pe,Ee,Be)=>((0,tt.$8G)(We,"findFiles2"),vt.findFiles2(pe,Ee,We.identifier,Be)),findTextInFiles:(pe,Ee,Be,gt)=>{(0,tt.$8G)(We,"findTextInFiles");let It,zt;return typeof Ee=="object"?(It=Ee,zt=Be):(It={},zt=Ee,gt=Be),vt.findTextInFiles(pe,It||{},zt,We.identifier,gt)},save:pe=>vt.save(pe),saveAs:pe=>vt.saveAs(pe),saveAll:pe=>vt.saveAll(pe),applyEdit(pe,Ee){return cn.applyWorkspaceEdit(pe,We,Ee)},createFileSystemWatcher:(pe,Ee,Be,gt)=>{let It;return typeof Ee=="boolean"?It={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!gt,correlate:!1}:Ee&&((0,tt.$8G)(We,"createFileSystemWatcher"),It={...Ee,correlate:!0}),it.createFileSystemWatcher(vt,We,pe,It)},get textDocuments(){return Bt.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new a.$_("textDocuments")},openTextDocument(pe){let Ee;const Be=pe;if(typeof pe=="string")Ee=Promise.resolve(p.URI.file(pe));else if(p.URI.isUri(pe))Ee=Promise.resolve(pe);else if(!Be||typeof Be=="object")Ee=Bt.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(gt=>(gt.scheme===O.Schemas.vscodeRemote&&!gt.authority&&Mt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Bt.ensureDocumentData(gt).then(It=>It.document)))},onDidOpenTextDocument:(pe,Ee,Be)=>ht(Bt.onDidAddDocument)(pe,Ee,Be),onDidCloseTextDocument:(pe,Ee,Be)=>ht(Bt.onDidRemoveDocument)(pe,Ee,Be),onDidChangeTextDocument:(pe,Ee,Be)=>ht(Bt.onDidChangeDocument)(pe,Ee,Be),onDidSaveTextDocument:(pe,Ee,Be)=>ht(Bt.onDidSaveDocument)(pe,Ee,Be),onWillSaveTextDocument:(pe,Ee,Be)=>ht(Mi.getOnWillSaveTextDocumentEvent(We))(pe,Ee,Be),get notebookDocuments(){return Lt.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,Ee){let Be;if(p.URI.isUri(pe))Be=pe,await Lt.openNotebookDocument(pe);else if(typeof pe=="string")Be=p.URI.revive(await Lt.createNotebookDocument({viewType:pe,content:Ee}));else throw new Error("Invalid arguments");return Lt.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(pe,Ee,Be){return ht(Ii.onDidSaveNotebookDocument)(pe,Ee,Be)},onDidChangeNotebookDocument(pe,Ee,Be){return ht(Ii.onDidChangeNotebookDocument)(pe,Ee,Be)},onWillSaveNotebookDocument(pe,Ee,Be){return ht(ji.getOnWillSaveNotebookDocumentEvent(We))(pe,Ee,Be)},get onDidOpenNotebookDocument(){return ht(Lt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ht(Lt.onDidCloseNotebookDocument)},registerNotebookSerializer(pe,Ee,Be,gt){return Lt.registerNotebookSerializer(We,pe,Ee,Be,(0,tt.$7G)(We,"notebookLiveShare")?gt:void 0)},onDidChangeConfiguration:(pe,Ee,Be)=>ht(ln.onDidChangeConfiguration)(pe,Ee,Be),getConfiguration(pe,Ee){return Ee=arguments.length===1?void 0:Ee,ln.getConfiguration(pe,Ee,We)},registerTextDocumentContentProvider(pe,Ee){return Ai.registerTextDocumentContentProvider(pe,Ee)},registerTaskProvider:(pe,Ee)=>(Mt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(We,pe,Ee)),registerFileSystemProvider(pe,Ee,Be){return(0,A.$Uc)(Ke.registerFileSystemProvider(We,pe,Ee,Be),_t.addFileSystemProvider(pe,Ee,Be))},get fs(){return _t.value},registerFileSearchProvider:(pe,Ee)=>((0,tt.$8G)(We,"fileSearchProvider"),ai.registerFileSearchProvider(pe,Ee)),registerTextSearchProvider:(pe,Ee)=>((0,tt.$8G)(We,"textSearchProvider"),ai.registerTextSearchProvider(pe,Ee)),registerAITextSearchProvider:(pe,Ee)=>((0,tt.$8G)(We,"aiTextSearchProvider"),(0,tt.$8G)(We,"textSearchProvider"),ai.registerAITextSearchProvider(pe,Ee)),registerRemoteAuthorityResolver:(pe,Ee)=>((0,tt.$8G)(We,"resolvers"),Wt.registerRemoteAuthorityResolver(pe,Ee)),registerResourceLabelFormatter:pe=>((0,tt.$8G)(We,"resolvers"),di.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,tt.$8G)(We,"resolvers"),Wt.getRemoteExecServer(pe)),onDidCreateFiles:(pe,Ee,Be)=>ht(it.onDidCreateFile)(pe,Ee,Be),onDidDeleteFiles:(pe,Ee,Be)=>ht(it.onDidDeleteFile)(pe,Ee,Be),onDidRenameFiles:(pe,Ee,Be)=>ht(it.onDidRenameFile)(pe,Ee,Be),onWillCreateFiles:(pe,Ee,Be)=>ht(it.getOnWillCreateFileEvent(We))(pe,Ee,Be),onWillDeleteFiles:(pe,Ee,Be)=>ht(it.getOnWillDeleteFileEvent(We))(pe,Ee,Be),onWillRenameFiles:(pe,Ee,Be)=>ht(it.getOnWillRenameFileEvent(We))(pe,Ee,Be),openTunnel:pe=>((0,tt.$8G)(We,"tunnels"),Gt.openTunnel(We,pe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,tt.$8G)(We,"tunnels"),Gt.getTunnels()},onDidChangeTunnels:(pe,Ee,Be)=>((0,tt.$8G)(We,"tunnels"),ht(Gt.onDidChangeTunnels)(pe,Ee,Be)),registerPortAttributesProvider:(pe,Ee)=>((0,tt.$8G)(We,"portsAttributes"),Gt.registerPortsAttributesProvider(pe,Ee)),registerTunnelProvider:(pe,Ee)=>((0,tt.$8G)(We,"tunnelFactory"),Gt.registerTunnelProvider(pe,Ee)),registerTimelineProvider:(pe,Ee)=>((0,tt.$8G)(We,"timeline"),Gi.registerTimelineProvider(pe,Ee,We.identifier,At.converter)),get isTrusted(){return vt.trusted},requestWorkspaceTrust:pe=>((0,tt.$8G)(We,"workspaceTrust"),vt.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,Ee,Be)=>ht(vt.onDidGrantWorkspaceTrust)(pe,Ee,Be),registerEditSessionIdentityProvider:(pe,Ee)=>((0,tt.$8G)(We,"editSessionIdentityProvider"),vt.registerEditSessionIdentityProvider(pe,Ee)),onWillCreateEditSessionIdentity:(pe,Ee,Be)=>((0,tt.$8G)(We,"editSessionIdentityProvider"),ht(vt.getOnWillCreateEditSessionIdentityEvent(We))(pe,Ee,Be)),registerCanonicalUriProvider:(pe,Ee)=>((0,tt.$8G)(We,"canonicalUriProvider"),vt.registerCanonicalUriProvider(pe,Ee)),getCanonicalUri:(pe,Ee,Be)=>((0,tt.$8G)(We,"canonicalUriProvider"),vt.provideCanonicalUri(pe,Ee,Be))},Dn={get inputBox(){return Mt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),$t.getLastInputBox(We)},createSourceControl(pe,Ee,Be){return $t.createSourceControl(We,pe,Ee,Be)}},fn={createCommentController(pe,Ee){return ci.createCommentController(We,pe,Ee)}},Vi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){return yt.activeStackItem},registerDebugVisualizationProvider(pe,Ee){return(0,tt.$8G)(We,"debugVisualization"),yt.registerDebugVisualizationProvider(We,pe,Ee)},registerDebugVisualizationTreeProvider(pe,Ee){return(0,tt.$8G)(We,"debugVisualization"),yt.registerDebugVisualizationTree(We,pe,Ee)},onDidStartDebugSession(pe,Ee,Be){return ht(yt.onDidStartDebugSession)(pe,Ee,Be)},onDidTerminateDebugSession(pe,Ee,Be){return ht(yt.onDidTerminateDebugSession)(pe,Ee,Be)},onDidChangeActiveDebugSession(pe,Ee,Be){return ht(yt.onDidChangeActiveDebugSession)(pe,Ee,Be)},onDidReceiveDebugSessionCustomEvent(pe,Ee,Be){return ht(yt.onDidReceiveDebugSessionCustomEvent)(pe,Ee,Be)},onDidChangeBreakpoints(pe,Ee,Be){return ht(yt.onDidChangeBreakpoints)(pe,Ee,Be)},onDidChangeActiveStackItem(pe,Ee,Be){return ht(yt.onDidChangeActiveStackItem)(pe,Ee,Be)},registerDebugConfigurationProvider(pe,Ee,Be){return yt.registerDebugConfigurationProvider(pe,Ee,Be||li.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,Ee){return yt.registerDebugAdapterDescriptorFactory(We,pe,Ee)},registerDebugAdapterTrackerFactory(pe,Ee){return yt.registerDebugAdapterTrackerFactory(pe,Ee)},startDebugging(pe,Ee,Be){return!Be||typeof Be=="object"&&"configuration"in Be?yt.startDebugging(pe,Ee,{parentSession:Be}):yt.startDebugging(pe,Ee,Be||{})},stopDebugging(pe){return yt.stopDebugging(pe)},addBreakpoints(pe){return yt.addBreakpoints(pe)},removeBreakpoints(pe){return yt.removeBreakpoints(pe)},asDebugSourceUri(pe,Ee){return yt.asDebugSourceUri(pe,Ee)}},gn={registerTaskProvider:(pe,Ee)=>Qt.registerTaskProvider(We,pe,Ee),fetchTasks:pe=>Qt.fetchTasks(pe),executeTask:pe=>Qt.executeTask(We,pe),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(pe,Ee,Be)=>ht(Qt.onDidStartTask)(pe,Ee,Be),onDidEndTask:(pe,Ee,Be)=>ht(Qt.onDidEndTask)(pe,Ee,Be),onDidStartTaskProcess:(pe,Ee,Be)=>ht(Qt.onDidStartTaskProcess)(pe,Ee,Be),onDidEndTaskProcess:(pe,Ee,Be)=>ht(Qt.onDidEndTaskProcess)(pe,Ee,Be)},mn={createNotebookController(pe,Ee,Be,gt,It){return yi.createNotebookController(We,pe,Ee,Be,gt,(0,tt.$7G)(We,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(pe,Ee)=>Lt.registerNotebookCellStatusBarItemProvider(We,pe,Ee),createRendererMessaging(pe){return hi.createRendererMessaging(We,pe)},createNotebookControllerDetectionTask(pe){return(0,tt.$8G)(We,"notebookKernelSource"),yi.createNotebookControllerDetectionTask(We,pe)},registerKernelSourceActionProvider(pe,Ee){return(0,tt.$8G)(We,"notebookKernelSource"),yi.registerKernelSourceActionProvider(We,pe,Ee)},onDidChangeNotebookCellExecutionState(pe,Ee,Be){return(0,tt.$8G)(We,"notebookCellExecutionState"),ht(yi.onDidChangeNotebookCellExecutionState)(pe,Ee,Be)}},$n={t(...pe){if(typeof pe[0]=="string"){const Ee=pe.shift(),Be=!pe||typeof pe[0]!="object"?pe:pe[0];return mi.getMessage(We.identifier.value,{message:Ee,args:Be})}return mi.getMessage(We.identifier.value,pe[0])},get bundle(){return mi.getBundle(We.identifier.value)},get uri(){return mi.getBundleUri(We.identifier.value)}},pn={_version:1,transferActiveChat(pe){return(0,tt.$8G)(We,"interactive"),Qi.transferActiveChat(pe)}},kn={getRelatedInformation(pe,Ee){return(0,tt.$8G)(We,"aiRelatedInformation"),Bi.getRelatedInformation(We,pe,Ee)},registerRelatedInformationProvider(pe,Ee){return(0,tt.$8G)(We,"aiRelatedInformation"),Bi.registerRelatedInformationProvider(We,pe,Ee)},registerEmbeddingVectorProvider(pe,Ee){return(0,tt.$8G)(We,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(We,pe,Ee)}},bn={_version:1,registerChatResponseProvider(pe,Ee,Be){return(0,tt.$8G)(We,"chatProvider"),Xt.registerLanguageModel(We,pe,Ee,Be)},registerChatVariableResolver(pe,Ee,Be,gt,It,zt,Fi,Pn){return(0,tt.$8G)(We,"chatVariableResolver"),rn.registerVariableResolver(We,pe,Ee,Be,gt,It,zt,Fi,Pn?.id)},registerMappedEditsProvider(pe,Ee){return(0,tt.$8G)(We,"mappedEditsProvider"),Oe.registerMappedEditsProvider(We,pe,Ee)},createChatParticipant(pe,Ee){return Qi.createChatAgent(We,pe,Ee)},createDynamicChatParticipant(pe,Ee,Be){return(0,tt.$8G)(We,"chatParticipantPrivate"),Qi.createDynamicChatAgent(We,pe,Ee,Be)}},wn={selectChatModels:pe=>Xt.selectLanguageModels(We,pe??{}),onDidChangeChatModels:(pe,Ee,Be)=>Xt.onDidChangeProviders(pe,Ee,Be),registerChatModelProvider:(pe,Ee,Be)=>((0,tt.$8G)(We,"chatProvider"),Xt.registerLanguageModel(We,pe,Ee,Be)),get embeddingModels(){return(0,tt.$8G)(We,"embeddings"),Ri.embeddingsModels},onDidChangeEmbeddingModels:(pe,Ee,Be)=>((0,tt.$8G)(We,"embeddings"),Ri.onDidChange(pe,Ee,Be)),registerEmbeddingsProvider(pe,Ee){return(0,tt.$8G)(We,"embeddings"),Ri.registerEmbeddingsProvider(We,pe,Ee)},async computeEmbeddings(pe,Ee,Be){return(0,tt.$8G)(We,"embeddings"),Ri.computeEmbeddings(pe,Ee,Be)},registerTool(pe,Ee){return(0,tt.$8G)(We,"lmTools"),Li.registerTool(We,pe,Ee)},invokeTool(pe,Ee,Be){return(0,tt.$8G)(We,"lmTools"),Li.invokeTool(pe,Ee,Be)},get tools(){return(0,tt.$8G)(We,"lmTools"),Li.tools}},In={registerSpeechProvider(pe,Ee){return(0,tt.$8G)(We,"speech"),on.registerProvider(We.identifier,pe,Ee)}};return{version:kt.version,ai:kn,authentication:Wi,commands:un,comments:fn,chat:bn,debug:Vi,env:Yi,extensions:Zi,interactive:pn,l10n:$n,languages:dn,lm:wn,notebooks:mn,scm:Dn,speech:In,tasks:gn,tests:hn,window:Di,workspace:Ni,Breakpoint:Y.$yO,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatResultFeedbackKind:Y.ChatResultFeedbackKind,ChatVariableLevel:Y.ChatVariableLevel,ChatCompletionItem:Y.$tP,CallHierarchyIncomingCall:Y.$WN,CallHierarchyItem:Y.$VN,CallHierarchyOutgoingCall:Y.$XN,CancellationError:a.$8,CancellationTokenSource:r.$ye,CandidatePortSource:n.CandidatePortSource,CodeAction:Y.$SN,CodeActionKind:Y.$TN,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$YN,Color:Y.$_N,ColorInformation:Y.$aO,ColorPresentation:Y.$bO,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CommentThreadApplicability:Y.CommentThreadApplicability,CompletionItem:Y.$6N,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$7N,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$jO,DebugAdapterExecutable:Y.$CO,DebugAdapterInlineImplementation:Y.$FO,DebugAdapterNamedPipeServer:Y.$EO,DebugAdapterServer:Y.$DO,DebugConfigurationProviderTriggerKind:li.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DebugVisualization:Y.$VO,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$LN,DiagnosticRelatedInformation:Y.$KN,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$xN,DocumentHighlight:Y.$ON,DocumentHighlightKind:Y.DocumentHighlightKind,MultiDocumentHighlight:Y.$PN,DocumentLink:Y.$$N,DocumentSymbol:Y.$RN,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$IO,InlineValueText:Y.$JO,InlineValueVariableLookup:Y.$KO,InlineValueEvaluatableExpression:Y.$LO,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:k.$ne,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$XO,FileDecoration2:Y.$XO,FileSystemError:Y.$OO,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Y.$PO,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$AO,InlineCompletionItem:Y.$8N,InlineCompletionList:Y.$9N,Hover:Y.$MN,VerboseHover:Y.$NN,HoverVerbosityAction:Y.HoverVerbosityAction,IndentAction:S.IndentAction,Location:Y.$JN,MarkdownString:Y.$ZN,OverviewRulerLane:h.OverviewRulerLane,ParameterInformation:Y.$1N,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$yN,ProcessExecution:Y.$hO,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$WO,Range:Y.$zN,RelativePattern:Y.$wO,Selection:Y.$AN,SelectionRange:Y.$UN,SemanticTokens:Y.$SO,SemanticTokensBuilder:Y.$RO,SemanticTokensEdit:Y.$TO,SemanticTokensEdits:Y.$UO,SemanticTokensLegend:Y.$QO,ShellExecution:Y.$iO,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$3N,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$2N,SnippetString:Y.$IN,SourceBreakpoint:Y.$zO,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$QN,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$kO,TaskGroup:Y.$gO,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$cO,TerminalQuickFixTerminalCommand:Y.$eO,TerminalQuickFixOpener:Y.$dO,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$fO,TerminalExitReason:Y.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Y.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$EN,SnippetTextEdit:Y.$GN,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$vO,ThemeIcon:Y.$uO,TreeItem:Y.$lO,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$hP,UIKind:fi.UIKind,Uri:p.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$HN,DocumentPasteTriggerKind:Y.DocumentPasteTriggerKind,DocumentDropEdit:Y.$rO,DocumentDropOrPasteEditKind:Y.$sO,DocumentPasteEdit:Y.$tO,InlayHint:Y.$5N,InlayHintLabelPart:Y.$4N,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$DN,ResolvedAuthority:Y.$BN,ManagedResolvedAuthority:Y.$CN,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$8O,NotebookRange:Y.$ZO,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$1O,NotebookData:Y.$2O,NotebookRendererScript:Y.$6O,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$4O,NotebookCellOutputItem:Y.$3O,NotebookCellStatusBarItem:Y.$5O,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$FN,NotebookKernelSourceAction:Y.$7O,NotebookVariablesRequestKind:Y.NotebookVariablesRequestKind,PortAttributes:Y.$0O,LinkedEditingRanges:Y.$9O,TestResultState:Y.TestResultState,TestRunRequest:Y.$$O,TestMessage:Y.$_O,TestTag:Y.$aP,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:xt.TextSearchCompleteMessageType,DataTransfer:Y.$qO,DataTransferItem:Y.$mO,TestCoverageCount:Y.$bP,FileCoverage:Y.$dP,FileCoverage2:Y.$dP,StatementCoverage:Y.$eP,BranchCoverage:Y.$fP,DeclarationCoverage:Y.$gP,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$iP,TabInputTextDiff:Y.$jP,TabInputTextMerge:Y.$kP,TabInputCustom:Y.$lP,TabInputNotebook:Y.$nP,TabInputNotebookDiff:Y.$oP,TabInputWebview:Y.$mP,TabInputTerminal:Y.$pP,TabInputInteractiveWindow:Y.$qP,TabInputChat:Y.$rP,TabInputTextMultiDiff:Y.$sP,TelemetryTrustedValue:g.$wp,LogLevel:l.LogLevel,EditSessionIdentityMatch:$.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,ChatCopyKind:Y.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Y.$GO,DebugThread:Y.$HO,RelatedInformationType:Y.RelatedInformationType,SpeechToTextStatus:Y.SpeechToTextStatus,TextToSpeechStatus:Y.TextToSpeechStatus,PartialAcceptTriggerKind:Y.PartialAcceptTriggerKind,KeywordRecognitionStatus:Y.KeywordRecognitionStatus,ChatResponseMarkdownPart:Y.$uP,ChatResponseFileTreePart:Y.$yP,ChatResponseAnchorPart:Y.$zP,ChatResponseProgressPart:Y.$AP,ChatResponseProgressPart2:Y.$BP,ChatResponseReferencePart:Y.$EP,ChatResponseWarningPart:Y.$CP,ChatResponseTextEditPart:Y.$FP,ChatResponseMarkdownWithVulnerabilitiesPart:Y.$vP,ChatResponseCommandButtonPart:Y.$DP,ChatResponseDetectedParticipantPart:Y.$wP,ChatResponseConfirmationPart:Y.$xP,ChatRequestTurn:Y.$GP,ChatResponseTurn:Y.$HP,ChatLocation:Y.ChatLocation,LanguageModelChatMessageRole:Y.LanguageModelChatMessageRole,LanguageModelChatMessage:Y.$JP,LanguageModelChatMessageFunctionResultPart:Y.$IP,LanguageModelChatResponseTextPart:Y.$LP,LanguageModelChatResponseFunctionUsePart:Y.$KP,LanguageModelChatMessage2:Y.$JP,LanguageModelChatSystemMessage:Y.$MP,LanguageModelChatUserMessage:Y.$NP,LanguageModelChatAssistantMessage:Y.$OP,LanguageModelError:Y.$PP,NewSymbolName:Y.$NO,NewSymbolNameTag:Y.NewSymbolNameTag,NewSymbolNameTriggerKind:Y.NewSymbolNameTriggerKind,InlineEdit:Y.$QP,InlineEditTriggerKind:Y.InlineEditTriggerKind}}}}),define(Se[395],De([1,0,89,170,42,164,43,35,64,48,101,102,103,127,77,96,163,76,63,126,95,78,162,12,65,124,125,129,130,168,99]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s,d,u,b,E,D,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Qs)(u.$spc,u.$rpc,r.InstantiationType.Delayed),(0,r.$Qs)(s.$bk,i.$Hqc,r.InstantiationType.Delayed),(0,r.$Qs)(l.$xoc,l.$yoc,r.InstantiationType.Delayed),(0,r.$Qs)(R.$lQ,R.$kQ,r.InstantiationType.Eager),(0,r.$Qs)(E.$Hoc,E.$Ioc,r.InstantiationType.Eager),(0,r.$Qs)(D.$mpc,D.$npc,r.InstantiationType.Eager),(0,r.$Qs)(O.$Woc,O.$Uoc,r.InstantiationType.Eager),(0,r.$Qs)(g.$Yoc,g.$Xoc,r.InstantiationType.Eager),(0,r.$Qs)(T.$Cpc,T.$Dpc,r.InstantiationType.Eager),(0,r.$Qs)(S.$Hpc,S.$Lpc,r.InstantiationType.Eager),(0,r.$Qs)(A.$Npc,A.$Mpc,r.InstantiationType.Eager),(0,r.$Qs)(p.$aQ,p.$_P,r.InstantiationType.Eager),(0,r.$Qs)(b.$tpc,b.$upc,r.InstantiationType.Eager),(0,r.$Qs)($.$Boc,$.$Aoc,r.InstantiationType.Eager),(0,r.$Qs)(a.$hqc,a.$gqc,r.InstantiationType.Delayed),(0,r.$Qs)(h.$4pc,h.$5pc,r.InstantiationType.Eager),(0,r.$Qs)(P.$fpc,P.$epc,r.InstantiationType.Eager),(0,r.$Qs)(I.$uqc,I.$tqc,r.InstantiationType.Eager),(0,r.$Qs)(c.$ipc,c.$lpc,r.InstantiationType.Eager),(0,r.$Qs)(y.$vqc,y.$wqc,r.InstantiationType.Eager),(0,r.$Qs)(w.$_Fb,w.$aGb,r.InstantiationType.Eager),(0,r.$Qs)(m.$Fqc,m.$Eqc,r.InstantiationType.Eager),(0,r.$Qs)(k.$Toc,k.$Soc,r.InstantiationType.Eager),(0,r.$Qs)(n.$ppc,n.$opc,r.InstantiationType.Eager),(0,r.$Qs)(o.$jQ,o.$gQ,r.InstantiationType.Eager),(0,r.$Qs)(t.$9oc,t.$0oc,r.InstantiationType.Eager),(0,r.$Qs)(d.$Apc,d.$Bpc,r.InstantiationType.Eager)}),define(Se[131],De([1,0,19,12,38,100]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=void 0,e.$Xqc=O,e.$Yqc=R,A=Ue(A);function O(S){return S.startsWith("**")||S.startsWith("/")?S:`/${S}`}function R(S,h,P,w){const l=(0,r.$4b)(P,p),m=new k.$XL(h,l,w),g=m.preview.matches;return{ranges:(0,r.$4b)(l,c),uri:S,preview:{text:m.preview.text,matches:(0,r.$4b)(g,c)}}}function p(S){return new k.$YL(S.start.line,S.start.character,S.end.line,S.end.character)}function c(S){return new A.$LL(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn)}let I=class{constructor(h,P){this.a=h,this.b=P}appendLine(h){this.b.debug(`${this.a}#search`,h)}};e.$Zqc=I,e.$Zqc=I=Ye([Ve(1,a.$ak)],I)}),define(Se[396],De([1,0,56,17,82,32,11,13,131,397]),function(ie,e,r,a,k,A,O,R,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=S,e.$2qc=m,e.$3qc=$,r=Ue(r),a=Ue(a),A=Ue(A),R=Ue(R);const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function S(n,o,t,i,s){const d=h(n,o,t,i,s),u=o.folder.fsPath;return{cmd:r.spawn(I,d.args,{cwd:u}),rgDiskPath:I,siblingClauses:d.siblingClauses,rgArgs:d,cwd:u}}function h(n,o,t,i,s){const d=["--files","--hidden","--case-sensitive","--no-require-git"];w([o],t,!1).forEach(b=>{const E=(0,p.$Xqc)(b);if(d.push("-g",E),O.$d){const D=(0,k.$om)(E);D!==E&&d.push("-g",D)}});const u=P([o],i,void 0,!1);return u.globArgs.forEach(b=>{const E=`!${(0,p.$Xqc)(b)}`;if(d.push("-g",E),O.$d){const D=(0,k.$om)(E);D!==E&&d.push("-g",D)}}),o.disregardIgnoreFiles!==!1?d.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),o.ignoreSymlinks||d.push("--follow"),n.exists&&d.push("--quiet"),s&&d.push("--threads",`${s}`),d.push("--no-config"),o.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:u.siblingClauses}}function P(n,o,t,i=!0){const s=[];let d={};return n.forEach(u=>{const b=Object.assign({},u.excludePattern||{},o||{}),E=l(b,i?u.folder.fsPath:void 0,t);s.push(...E.globArgs),E.siblingClauses&&(d=Object.assign(d,E.siblingClauses))}),{globArgs:s,siblingClauses:d}}function w(n,o,t=!0){const i=[];return n.forEach(s=>{const d=Object.assign({},o||{},s.includePattern||{}),u=l(d,t?s.folder.fsPath:void 0);i.push(...u.globArgs)}),i}function l(n,o,t){const i=[],s={};return Object.keys(n).forEach(d=>{if(t&&t.has(d)||!d)return;const u=n[d];d=g(o?m(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof u=="boolean"&&u?(d.startsWith("\\\\")&&(d+="**"),i.push($(d))):u&&u.when&&(s[d]=u)}),{globArgs:i,siblingClauses:s}}function m(n,o){return a.$lc(o)?o:a.$mc(n,o)}function g(n){return n=R.$pf(n,"\\"),R.$pf(n,"/")}function $(n){return A.$Bg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(Se[398],De([1,0,56,61,17,399,19,51,39,82,32,11,44,13,18,34,38,396,138]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=e.$4qc=void 0,r=Ue(r),a=Ue(a),k=Ue(k),O=Ue(O),p=Ue(p),c=Ue(c),S=Ue(S),P=Ue(P),w=Ue(w);const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&p.$Ak(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=u.shouldGlobMatchFilePattern?null:(0,$.$Qr)(this.b).normalizedLowercase),this.u=u.excludePattern&&p.$Ak(u.excludePattern),this.t=new Map,u.folderQueries.forEach(b=>{const E=Object.assign({},b.excludePattern||{},this.a.excludePattern||{}),D=b.folder.fsPath;u.folderQueries.map(y=>y.folder.fsPath).filter(y=>y!==D).forEach(y=>{(0,I.$Fg)(y,D)&&(E[k.$oc(D,y)]=!0)}),this.t.set(D,new i(E,D))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,b,E,D,y,T){if(this.m=h.$he.create(!1),this.l)return T(null,this.j);b.forEach(C=>{const v=k.$qc(C.fsPath);this.u&&this.u(C.fsPath,v)||this.J(D,{relativePath:C.fsPath,searchPath:void 0})}),this.r=h.$he.create(!1),this.w(u,(C,v)=>{this.x(this.y,this,C,E,D,y,f=>{if(f){const N=(0,R.$rj)(f);console.error(N),this.q.push(N),v(f,void 0)}else v(null,void 0)})},(C,v)=>{this.m.stop();const f=C?O.$Kb(C)[0]:null;T(f,this.j)})}w(u,b,E){const D=new Array(u.length),y=new Array(u.length);let T=!1,C=0;if(u.length===0)return E(null,[]);u.forEach((v,f)=>{b(v,(N,F)=>{if(N?(T=!0,D[f]=null,y[f]=N):(D[f]=F,y[f]=null),++C===u.length)return E(T?y:null,D)})})}x(u,b,...E){try{u.apply(b,E)}catch(D){E[E.length-1](D)}}y(u,b,E,D,y){const T=u.folder.fsPath,C=S.$d,v=()=>z&&z.kill();n.add(v);let f=W=>{n.delete(v),f=()=>{},y(W)},N="";const F=this.D(),j=(0,g.$1qc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression,b),z=j.cmd,M=!Object.keys(j.siblingClauses).length,L=j.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let B=`${j.rgDiskPath} ${L}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),D({message:B}),this.s=0,this.z(z,"utf8",D,(W,ae,q)=>{if(W){f(W);return}if(this.j){f();return}const ee=(N+(C?c.$nm(ae||""):ae)).split(`
`);if(q){const re=ee.length;ee[re-1]=ee[re-1].trim(),ee[re-1]||ee.pop()}else N=ee.pop()||"";if(ee.length&&ee[0].indexOf(`
`)!==-1){f(new Error("Splitting up files failed"));return}if(this.s+=ee.length,M){for(const re of ee)if(this.J(E,{base:T,relativePath:re,searchPath:this.N(u,re)}),this.j){v();break}(q||this.j)&&f();return}this.G(u,F,T,ee,E),q&&(this.H(F,T,E),f())})}spawnFindCmd(u){const b=this.t.get(u.folder.fsPath),E=b.getBasenameTerms(),D=b.getPathTerms(),y=["-L","."];if(E.length||D.length){y.push("-not","(","(");for(const T of E)y.push("-name",T),y.push("-o");for(const T of D)y.push("-path",T),y.push("-o");y.pop(),y.push(")","-prune",")")}return y.push("-type","f"),r.spawn("find",y,{cwd:u.folder.fsPath})}readStdout(u,b,E){let D="";this.z(u,b,()=>{},(y,T,C)=>{if(y){E(y);return}D+=T,C&&E(null,D)})}z(u,b,E,D){let y=(v,f,N)=>{(v||N)&&(y=()=>{},this.r?.stop()),D(v,f,N)},T=!1;u.stdout?(this.A(u.stdout,b,y),u.stdout.once("data",()=>T=!0)):E({message:"stdout is null"});let C;u.stderr?C=this.B(u.stderr):E({message:"stderr is null"}),u.on("error",v=>{y(v)}),u.on("close",v=>{let f;!T&&(f=this.C(C,b))&&s(f)?y(new Error(`command failed with error code ${v}: ${this.C(C,b)}`)):(this.g&&v===0&&(this.j=!0),y(null,"",!0))})}A(u,b,E){const D=new A.StringDecoder(b);return u.on("data",y=>{E(null,D.write(y))}),D}B(u){const b=[];return u.on("data",E=>{b.push(E)}),b}C(u,b){const E=new A.StringDecoder(b);return u.map(D=>E.write(D)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:b},E,D,y){D.indexOf(this.b)!==-1&&this.J(y,{base:E,relativePath:this.b,searchPath:this.N(u,this.b)});const T=C=>{const v=k.$qc(C),f=k.$pc(C);let N=b[f];N||(N=b[f]=[],T(f)),N.push({base:E,relativePath:C,basename:v,searchPath:this.N(u,C)})};D.forEach(T)}H({rootEntries:u,pathToEntries:b},E,D){const y=this,T=this.t.get(E),C=this.b;function v(f){y.o++;const N=(0,m.$bM)(()=>f.map(F=>F.basename));for(let F=0,j=f.length;F<j;F++){const z=f[F],{relativePath:M,basename:L}=z;if(T.test(M,L,C!==L?N:void 0))continue;const B=b[M];if(B)v(B);else{if(y.p++,M===C)continue;y.J(D,z)}if(y.j)break}}v(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,b,E,D,y){const T=u.folder,C=(0,m.$bM)(()=>E);this.w(E,(v,f)=>{if(this.l||this.j)return f(null);const N=b?[b,v].join(k.sep):v;if(this.t.get(u.folder.fsPath).test(N,v,this.a.filePattern!==v?C:void 0))return f(null);const F=[T.fsPath,N].join(k.sep);a.lstat(F,(j,z)=>{if(j||this.l||this.j)return f(null);this.L(F,z,(M,L)=>M||this.l||this.j?f(null):L.isDirectory()?(this.o++,this.M(F,z,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?f(null):(this.v[W]=!0,l.Promises.readdir(F).then(ae=>{if(this.l||this.j)return f(null);this.I(u,N,ae,D,q=>f(q||null))},ae=>{f(null)})))):(this.p++,N===this.b||this.h&&w.$kg(L.size)&&L.size>this.h||this.J(D,{base:T.fsPath,relativePath:N,searchPath:this.N(u,N)}),f(null,void 0)))})},v=>{const f=v&&O.$Kb(v);return y(f&&f.length>0?f[0]:void 0)})}J(u,b){this.K(b)&&(!this.d||this.d(b.relativePath,k.$qc(b.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(b))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$9L)(u,this.c);if(this.b)return(0,m.$9L)(u,this.b,!1)}return!0}L(u,b,E){return b.isSymbolicLink()?a.stat(u,E):E(null,b)}M(u,b,E){return b.isSymbolicLink()?a.realpath(u,(D,y)=>D?E(D):E(null,y)):E(null,u)}N(u,b){return u.folderName?k.$mc(u.folderName,b):b}}e.$4qc=o;class t{constructor(u,b){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.d=b,this.c=new o(u)}search(u,b,E){this.c.walk(this.a,this.b,this.d,u,b,(D,y)=>{E(D,{limitHit:y,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$5qc=t;class i{constructor(u,b){this.expression=u,this.c=b,this.d(u)}d(u){let b,E;Object.keys(u).filter(D=>u[D]).forEach(D=>{k.$lc(D)?(b=b||p.$vk(),b[D]=u[D]):(E=E||p.$vk(),E[D]=u[D])}),this.a=b&&p.$Ak(b,{trimForExclusions:!0}),this.b=E&&p.$Ak(E,{trimForExclusions:!0})}test(u,b,E){return this.b&&this.b(u,b,E)||this.a&&this.a(k.$mc(this.c,u),b,E)}getBasenameTerms(){const u=[];return this.a&&u.push(...p.$Ck(this.a)),this.b&&u.push(...p.$Ck(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...p.$Dk(this.a)),this.b&&u.push(...p.$Dk(this.b)),u}}function s(d){const u=d.trim().split(`
`),b=u[0].trim();if(b.startsWith("Error parsing regex"))return b;if(b.startsWith("regex parse error"))return P.$$f(u[u.length-1].trim());if(b.startsWith("error parsing glob")||b.startsWith("unsupported encoding"))return b.charAt(0).toUpperCase()+b.substr(1);if(b==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(b.startsWith("Literal "))return b}}),define(Se[400],De([1,0,106,22,189,21,19]),function(ie,e,r,a,k,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=e.$KE=e.$CE=e.DecodeStreamErrorKind=e.$BE=e.$AE=e.$zE=e.$xE=e.$wE=e.$vE=e.$uE=void 0,e.$yE=R,e.$DE=l,e.$EE=m,e.$FE=g,e.$GE=$,e.$HE=n,e.$IE=E,e.$JE=D,e.$uE="utf8",e.$vE="utf8bom",e.$wE="utf16be",e.$xE="utf16le";function R(y){return[e.$uE,e.$vE,e.$wE,e.$xE].some(T=>T===y)}e.$zE=[254,255],e.$AE=[255,254],e.$BE=[239,187,191];const p=512,c=512,I=512*8,S=512*128;var h;(function(y){y[y.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(h||(e.DecodeStreamErrorKind=h={}));class P extends Error{constructor(T,C){super(T),this.decodeStreamErrorKind=C}}e.$CE=P;class w{static async create(T){let C;if(T!==e.$uE)C=(await(0,k.$tE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder($(T));else{const v=new TextDecoder;C={write(f){return v.decode(f,{stream:!0})},end(){return v.decode()}}}return new w(C)}constructor(T){this.a=T}write(T){return this.a.write(T)}end(){return this.a.end()}}function l(y,T){const C=T.minBytesRequiredForDetection??T.guessEncoding?I:c;return new Promise((v,f)=>{const N=(0,r.$De)(B=>B.join("")),F=[];let j=0,z;const M=new A.$ye,L=async()=>{try{const B=await D({buffer:a.$Pe.concat(F),bytesRead:j},T.guessEncoding,T.candidateGuessEncodings);if(B.seemsBinary&&T.acceptTextOnly)throw new P("Stream is binary but only text is accepted for decoding",h.STREAM_IS_BINARY);B.encoding=await T.overwriteEncoding(B.encoding),z=await w.create(B.encoding);const W=z.write(a.$Pe.concat(F).buffer);N.write(W),F.length=0,j=0,v({stream:N,detected:B})}catch(B){M.cancel(),N.destroy(),f(B)}};(0,r.$He)(y,{onData:async B=>{z?N.write(z.write(B.buffer)):(F.push(B),j+=B.byteLength,j>=C&&(y.pause(),await L(),setTimeout(()=>y.resume())))},onError:B=>N.error(B),onEnd:async()=>{z||await L(),N.end(z?.end())}},M.token)})}async function m(y,T,C){const f=(await(0,k.$tE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder($(T),C);let N=!1,F=!1;return{read(){if(F)return null;const j=y.read();if(typeof j!="string"){if(F=!0,!N&&C?.addBOM)switch(T){case e.$uE:case e.$vE:return a.$Pe.wrap(Uint8Array.from(e.$BE));case e.$wE:return a.$Pe.wrap(Uint8Array.from(e.$zE));case e.$xE:return a.$Pe.wrap(Uint8Array.from(e.$AE))}const z=f.end();return z&&z.length>0?(N=!0,a.$Pe.wrap(z)):null}return N=!0,a.$Pe.wrap(f.write(j))}}}async function g(y){return(await(0,k.$tE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists($(y))}function $(y){return y===e.$vE||y===null?e.$uE:y}function n(y,T){if(!y||T<e.$zE.length)return null;const C=y.readUInt8(0),v=y.readUInt8(1);if(C===e.$zE[0]&&v===e.$zE[1])return e.$wE;if(C===e.$AE[0]&&v===e.$AE[1])return e.$xE;if(T<e.$BE.length)return null;const f=y.readUInt8(2);return C===e.$BE[0]&&v===e.$BE[1]&&f===e.$BE[2]?e.$vE:null}const o=["ascii","utf-16","utf-32"];async function t(y,T){const C=await(0,k.$tE)("jschardet","dist/jschardet.min.js"),v=y.slice(0,S),f=b(v.buffer);T&&(T=(0,O.$Kb)(T.map(j=>u(j))),T.length===0&&(T=void 0));const N=C.detect(f,T?{detectEncodings:T}:void 0);if(!N||!N.encoding)return null;const F=N.encoding.toLowerCase();return 0<=o.indexOf(F)?null:d(N.encoding)}const i={ibm866:"cp866",big5:"cp950"};function s(y){return y.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function d(y){const T=s(y);return i[T]||T}function u(y){const T=s(y);return e.$LE[T].guessableName}function b(y){let T="";for(let C=0;C<y.length;C++)T+=String.fromCharCode(y[C]);return T}function E(y){switch(y){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const T=y.match(/windows(\d+)/);return T?"windows-"+T[1]:y}}}function D({buffer:y,bytesRead:T},C,v){let f=n(y,T),N=!1;if(f!==e.$wE&&f!==e.$xE&&y){let F=!0,j=!0,z=!1;for(let M=0;M<T&&M<p;M++){const L=M%2===1,B=y.readUInt8(M)===0;if(B&&(z=!0),F&&(L&&!B||!L&&B)&&(F=!1),j&&(L&&B||!L&&!B)&&(j=!1),B&&!F&&!j)break}z&&(F?f=e.$xE:j?f=e.$wE:N=!0)}return C&&!N&&!f&&y?t(y.slice(0,T),v).then(F=>({seemsBinary:!1,encoding:F})):{seemsBinary:N,encoding:f}}e.$KE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$LE=(()=>{const y={};for(const T in e.$KE)e.$KE[T].guessableName&&(y[T]=e.$KE[T]);return y})()}),define(Se[173],De([1,0,400,34,172]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=void 0,a=Ue(a);class A extends k.$Zpc{constructor(R,p,c=a,I="searchProcess"){super({query:R,provider:p},{readdir:S=>c.Promises.readdir(S.fsPath),toCanonicalName:S=>(0,r.$IE)(S)},I)}}e.$arc=A}),define(Se[174],De([1,0,56,415,399,19,79,39,13,2,38,100,416,397,131]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qc=e.$6qc=void 0,e.$8qc=i,e.$9qc=d,e.$0qc=b,e.$$qc=E,e.$_qc=y,r=Ue(r);const l=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(C,v){this.a=C,this.b=v}provideTextSearchResults(C,v,f,N){return this.a.appendLine(`provideTextSearchResults ${C.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((F,j)=>{N.onCancellationRequested(()=>ee());const z={...v,numThreads:this.b},M=i(C,z),L=v.folder.fsPath,B=M.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.a.appendLine(`${l} ${B}
 - cwd: ${L}`);let W=r.spawn(l,M,{cwd:L});W.on("error",fe=>{console.error(fe),this.a.appendLine("Error: "+(fe&&fe.message)),j((0,I.$5L)(new I.$3L(fe&&fe.message,I.SearchErrorCode.rgProcessError)))});let ae=!1;const q=new n(v.maxResults,v.folder,v.previewOptions);q.on("result",fe=>{ae=!0,ge="",f.report(fe)});let K=!1;const ee=()=>{K=!0,W?.kill(),q?.cancel()};let re=!1;q.on("hitLimit",()=>{re=!0,ee()});let ge="";W.stdout.on("data",fe=>{q.handleData(fe),ae||(ge+=fe)});let Z=!1;W.stdout.once("data",()=>Z=!0);let $e="";W.stderr.on("data",fe=>{const oe=fe.toString();this.a.appendLine(oe),$e.length+oe.length<1e6&&($e+=oe)}),W.on("close",()=>{if(this.a.appendLine(Z?"Got data from stdout":"No data from stdout"),this.a.appendLine(ae?"Got result from parser":"No result from parser"),ge&&this.a.appendLine(`Got data without result: ${ge}`),this.a.appendLine(""),K)F({limitHit:re});else{q.flush(),W=null;let fe;$e&&!Z&&(fe=g($e))?j((0,I.$5L)(new I.$3L(fe.message,fe.code))):F({limitHit:re})}})})}}e.$6qc=m;function g(T){const C=T.split(`
`),v=C[0].trim();if(C.some(N=>N.startsWith("regex parse error")))return new I.$3L($(C),I.SearchErrorCode.regexParseError);const f=v.match(/grep config error: unknown encoding: (.*)/);if(f)return new I.$3L(`Unknown encoding: ${f[1]}`,I.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new I.$3L(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new I.$3L(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new I.$3L(v,I.SearchErrorCode.regexParseError)}function $(T){const C=["Regex parse error"],v=T.filter(f=>f.startsWith("PCRE2:"));if(v.length>=1){const f=v[0].replace("PCRE2:","");if(f.indexOf(":")!==-1&&f.split(":").length>=2){const N=f.split(":")[1];C.push(":"+N)}}return C.join("")}class n extends a.EventEmitter{constructor(C,v,f){super(),this.g=C,this.h=v,this.j=f,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new k.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(C,v){return super.on(C,v),this}handleData(C){if(this.b)return;const v=typeof C=="string"?C:this.d.write(C);this.k(v)}k(C){let v=C.indexOf(`
`);const f=this.a+C;if(v>=0)v+=this.a.length;else{this.a=f;return}let N=0;for(;v>=0;)this.m(f.substring(N,v).trim()),N=v+1,v=f.indexOf(`
`,N);this.a=f.substring(N)}m(C){if(this.b||!C)return;let v;try{v=JSON.parse(C)}catch{throw new Error(`malformed line from rg: ${C}`)}if(v.type==="match"){const f=o(v.data.path),N=c.URI.joinPath(this.h,f),F=this.n(v.data,N);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const f=o(v.data.path),N=c.URI.joinPath(this.h,f);this.o(v.data,N).forEach(j=>this.p(j))}}n(C,v){const f=C.line_number-1,N=o(C.lines),F=Buffer.from(N);let j=0,z=0,M=f;C.submatches.length===0&&C.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const L=(0,A.$Kb)(C.submatches.map((B,W)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ae=o(B.match),q=F.slice(j,B.start).toString(),K=t(q),ee=K.numLines>0?K.lastLineLength:K.lastLineLength+z,re=t(ae),ge=K.numLines+M,Z=re.numLines+ge,$e=re.numLines>0?re.lastLineLength:re.lastLineLength+ee;return j=B.end,z=$e,M=Z,new S.$LL(ge,ee,Z,$e)}));return(0,w.$Yqc)(v,N,L,this.j)}o(C,v){const f=o(C.lines),N=C.line_number;return f.replace(/\r?\n$/,"").split(`
`).map((F,j)=>({text:F,uri:v,lineNumber:N+j}))}p(C){this.emit("result",C)}}e.$7qc=n;function o(T){return T.bytes?Buffer.from(T.bytes,"base64").toString():T.text}function t(T){const C=/\n/g;let v=0,f=-1,N;for(;N=C.exec(T);)v++,f=N.index;const F=f>=0?T.length-f-1:T.length;return{numLines:v,lastLineLength:F}}function i(T,C){const v=["--hidden","--no-require-git"];v.push(T.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:f,otherIncludes:N}=(0,O.$E)(C.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const j=new Set;N.forEach(z=>{j.add(z)}),v.push("-g","!*"),j.forEach(z=>{s(z).map(w.$Xqc).forEach(M=>{v.push("-g",M)})})}f&&f.length&&f.forEach(j=>{v.push("-g",j)}),C.excludes.map(w.$Xqc).forEach(j=>v.push("-g",`!${j}`)),C.maxFileSize&&v.push("--max-filesize",C.maxFileSize+""),C.useIgnoreFiles?C.useParentIgnoreFiles||v.push("--no-ignore-parent"):v.push("--no-ignore"),C.followSymlinks&&v.push("--follow"),C.encoding&&C.encoding!=="utf8"&&v.push("--encoding",C.encoding),C.numThreads&&v.push("--threads",`${C.numThreads}`),T.pattern==="--"&&(T.isRegExp=!0,T.pattern="\\-\\-"),T.isMultiline&&!T.isRegExp&&(T.pattern=(0,p.$jf)(T.pattern),T.isRegExp=!0),C.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),T.isRegExp&&(T.pattern=d(T.pattern),v.push("--engine","auto"));let F;if(T.isWordMatch){const z=(0,p.$sf)(T.pattern,!!T.isRegExp,{wholeWord:T.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",z)}else if(T.isRegExp){let j=b(T.pattern);j=E(j),v.push("--regexp",j)}else F=T.pattern,v.push("--fixed-strings");return v.push("--no-config"),C.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),T.isMultiline&&v.push("--multiline"),C.beforeContext&&v.push("--before-context",C.beforeContext+""),C.afterContext&&v.push("--after-context",C.afterContext+""),v.push("--"),F&&v.push(F),v.push("."),v}function s(T){return y(T).flatMap(v=>{const f=(0,R.$yk)(v,"/");return f.map((N,F)=>f.slice(0,F+1).join("/"))})}function d(T){const C=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;T.match(C);)T=T.replace(C,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;T.match(v);)T=T.replace(v,"$1\\x{$2}");return T}const u=T=>T.type==="Assertion"&&T.kind==="lookbehind";function b(T){let C;try{C=new h.RegExpParser().parsePattern(T)}catch{return T}let v="",f=0;const N=(z,M,L)=>{v+=T.slice(f,z)+L,f=M},F=[];return new h.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const M=F[0];if(!M)N(z.start,z.end,"\\r?\\n");else if(!F.some(u))if(M.type==="CharacterClass")if(M.negate){const L=T.slice(M.start+2,z.start)+T.slice(z.end,M.end-1);M.parent?.type==="Quantifier"?N(M.start,M.end,L?`[^${L}]`:"."):N(M.start,M.end,"(?!\\r?\\n"+(L?`|[${L}]`:"")+")")}else{const L=T.slice(M.start+1,z.start)+T.slice(z.end,M.end-1);N(M.start,M.end,L===""?"\\r?\\n":`(?:[${L}]|\\r?\\n)`)}else M.type==="Quantifier"&&N(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){u(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(C),v+=T.slice(f),v}function E(T){return T.replace(/\n/g,"\\r?\\n")}function D(T){let C=!1,v=!1,f="",N="";for(let F=0;F<T.length;F++){const j=T[F];switch(j){case"\\":v?(C?N+="\\"+j:f+="\\"+j,v=!1):v=!0;break;case"{":if(v)C?N+=j:f+=j,v=!1;else{if(C)return{strInBraces:f+"{"+N+"{"+T.substring(F+1)};C=!0}break;case"}":if(v)C?N+=j:f+=j,v=!1;else{if(C)return{fixedStart:f,strInBraces:N,fixedEnd:T.substring(F+1)};f+=j}break;default:C?N+=(v?"\\":"")+j:f+=(v?"\\":"")+j,v=!1;break}}return{strInBraces:f+(C?"{"+N:"")}}function y(T){const{fixedStart:C,strInBraces:v,fixedEnd:f}=D(T);if(C===void 0||f===void 0)return[v];let N=(0,R.$yk)(v,",");N.length||(N=[""]);const F=y(f);return N.flatMap(j=>{const z=C+j;return F.map(M=>z+M)})}}),define(Se[401],De([1,0,21,174,90,15]),function(ie,e,r,a,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=void 0;class O{constructor(c,I){this.b=c,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(c,I,S,h){const P=await this.c(),w=new a.$6qc(this.b,P),l={...I,numThreads:P};if(I.folder.scheme===A.Schemas.vscodeUserData){const m={...l,folder:I.folder.with({scheme:A.Schemas.file})},g=new k.$xw($=>S.report({...$,uri:$.uri.with({scheme:I.folder.scheme})}));return this.d(h,$=>w.provideTextSearchResults(c,m,g,$))}else return this.d(h,m=>w.provideTextSearchResults(c,l,S,m))}async d(c,I){const S=R(c);this.a.add(S);const h=await I(S.token);return this.a.delete(S),h}e(){this.a.forEach(c=>c.cancel())}}e.$drc=O;function R(p){const c=new r.$ye;return p.onCancellationRequested(()=>c.cancel()),c}}),define(Se[402],De([1,0,34,174,173]),function(ie,e,r,a,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=void 0,r=Ue(r);class A{constructor(p,c){this.a=p,this.b=c}search(p,c,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const S={appendLine(P){I({message:P})}},h=new k.$arc(this.a,new a.$6qc(S,this.b),r);return new Promise((P,w)=>h.search(l=>{c(l.map(O))},p).then(l=>P({limitHit:l.limitHit??!1,type:"success",stats:l.stats,messages:[]}),w))}}e.$brc=A;function O(R){return{path:R.resource&&R.resource.fsPath,results:R.results,numMatches:(R.results||[]).reduce((p,c)=>{if(c.ranges){const I=c;return p+(Array.isArray(I.ranges)?I.ranges.length:1)}else return p+1},0)}}}),define(Se[403],De([1,0,19,7,14,4,138,17,44,2,28,38,398,402]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crc=void 0,r=Ue(r);class w{constructor(o="searchProcess",t){this.d=o,this.f=t,this.b=Object.create(null)}fileSearch(o){let t;const i=g(o),s=new A.$ne({onDidAddFirstListener:()=>{t=(0,a.$th)(async d=>{const u=await this.f?.();return this.doFileSearchWithEngine(h.$5qc,i,b=>s.fire(b),d,w.a,u)}),t.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return s.event}textSearch(o){let t;const i=g(o),s=new A.$ne({onDidAddFirstListener:()=>{t=(0,a.$th)(d=>this.g(i,u=>s.fire(u),d)),t.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{t.cancel()}});return s.event}async g(o,t,i){o.maxFileSize=this.h().maxFileSize;const s=await this.f?.();return new P.$brc(o,s).search(i,t,t)}h(){return{maxFileSize:16*I.$Il.GB}}doFileSearch(o,t,i,s){return this.doFileSearchWithEngine(h.$5qc,o,i,s,w.a,t)}doFileSearchWithEngine(o,t,i,s,d=w.a,u){let b=0;const E=y=>{Array.isArray(y)?(b+=y.length,i(y.map(T=>this.j(T)))):y.relativePath?(b++,i(this.j(y))):i(y)};if(t.sortByScore){let y=this.n(t,E,s);if(!y){const T=t.maxResults?Object.assign({},t,{maxResults:null}):t,C=new o(T,u);y=this.k(C,t,i,E,s)}return new Promise((T,C)=>{y.then(([v,f])=>{const N=f.map(F=>this.j(F));this.q(N,i,d),T(v)},C)})}const D=new o(t,u);return this.s(D,E,d,s).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:this.d,fromCache:!1,resultCount:b,sortingTime:void 0},messages:[]}))}j(o){return{path:o.base?(0,R.$mc)(o.base,o.relativePath):o.relativePath}}k(o,t,i,s,d){const u=new A.$ne;let b=(0,a.$th)(D=>{let y=[];const T=C=>{Array.isArray(C)?y=C:(s(C),u.fire(C))};return this.s(o,T,-1,D).then(C=>[C,y])}),E;if(t.cacheKey){E=this.l(t.cacheKey);const D={promise:b,event:u.event,resolved:!1};E.resultsToSearchCache[t.filePattern||""]=D,b.then(()=>{D.resolved=!0},y=>{delete E.resultsToSearchCache[t.filePattern||""]}),b=this.t(b)}return b.then(([D,y])=>{const T=E?E.scorerCache:Object.create(null),C=(typeof t.maxResults!="number"||t.maxResults>0)&&p.$he.create(!1);return this.o(t,y,T,d).then(v=>{const f=C?C.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:f,fromCache:!1,type:this.d,resultCount:v.length},messages:D.messages,limitHit:D.limitHit||typeof t.maxResults=="number"&&y.length>t.maxResults},v]})})}l(o){const t=this.b[o];return t||(this.b[o]=new l)}n(o,t,i){const s=o.cacheKey&&this.b[o.cacheKey];if(!s)return;const d=this.r(s,o.filePattern||"",t,i);if(d)return d.then(([u,b,E])=>{const D=p.$he.create(!1);return this.o(o,b,s.scorerCache,i).then(y=>{const T=D.elapsed(),C={fromCache:!0,detailStats:E,type:this.d,resultCount:b.length,sortingTime:T};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&b.length>o.maxResults,stats:C,messages:[]},y]})})}o(o,t,i,s){const d=(0,O.$Qr)(o.filePattern||""),u=(E,D)=>(0,O.$Pr)(E,D,d,!0,m,i),b=typeof o.maxResults=="number"?o.maxResults:S.$RL;return r.$Jb(t,u,b,1e4,s)}q(o,t,i){if(i&&i>0)for(let s=0;s<o.length;s+=i)t(o.slice(s,s+i));else t(o)}r(o,t,i,s){const d=p.$he.create(!1),u=t.indexOf(R.sep)>=0;let b;for(const T in o.resultsToSearchCache)if(t.startsWith(T)){if(u&&T.indexOf(R.sep)<0&&T!=="")continue;const C=o.resultsToSearchCache[T];b={promise:this.t(C.promise),event:C.event,resolved:C.resolved};break}if(!b)return null;const E=d.elapsed(),D=p.$he.create(!1),y=b.event(i);return s&&s.onCancellationRequested(()=>{y.dispose()}),b.promise.then(([T,C])=>{if(s&&s.isCancellationRequested)throw(0,k.$9)();const v=[],f=(0,O.$Qr)(t).normalizedLowercase;for(const N of C)(0,S.$9L)(N,f)&&v.push(N);return[T,v,{cacheWasResolved:b.resolved,cacheLookupTime:E,cacheFilterTime:D.elapsed(),cacheEntryCount:C.length}]})}s(o,t,i,s){return new Promise((d,u)=>{let b=[];s?.onCancellationRequested(()=>o.cancel()),o.search(E=>{E&&(i?(b.push(E),i>0&&b.length>=i&&(t(b),b=[])):t(E))},E=>{t(E)},(E,D)=>{b.length&&t(b),E?(t({message:"Search finished. Error: "+E.message}),u(E)):(t({message:"Search finished. Stats: "+JSON.stringify(D.stats)}),d(D))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}t(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,i){return o.then(t,i)}catch(t){return this.then(void 0,t)}finally(t){return o.finally(t)}}}}e.$crc=w,w.a=512;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,R.$qc)(n.relativePath)}getItemDescription(n){return(0,R.$pc)(n.relativePath)}getItemPath(n){return n.relativePath}};function g(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map($),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>c.URI.revive(o))}}function $(n){return{...n,folder:c.URI.revive(n.folder)}}}),define(Se[404],De([1,0,3,15,2,34,12,43,30,20,103,73,38,403,401,131,173]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erc=void 0,A=Ue(A);let g=class extends I.$5pc{constructor(n,o,t,i,s){super(n,t,s),this.D=i,this.w=A,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Wc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const d=new l.$Zqc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(a.Schemas.vscodeUserData,new w.$drc(d,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this.F(),i.getConfigProvider().then(u=>{this.C||this.B.add(u.onDidChangeConfiguration(this.E))})}E(n){n.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const n=new l.$Zqc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(a.Schemas.file,new w.$drc(n,this.getNumThreadsCached))),this.B.add(this.G(a.Schemas.file,new P.$crc("fileSearchProvider",this.getNumThreadsCached)))}G(n,o){const t=this.d++;return this.y=o,this.x=t,this.c.$registerFileSearchProvider(t,this.s(n)),(0,r.$Vc)(()=>{this.y=null,this.c.$unregisterProvider(t)})}$provideFileSearchResults(n,o,t,i){const s=(0,I.$6pc)(t);if(n===this.x){const d=Date.now();return this.H(n,o,s,i).then(u=>{const b=Date.now()-d;return this.q.debug(`Ext host file search time: ${b}ms`),u})}return super.$provideFileSearchResults(n,o,t,i)}async doInternalFileSearchWithCustomCallback(n,o,t){const i=d=>{if((0,h.$8L)(d)&&(d=[d]),Array.isArray(d)){t(d.map(u=>k.URI.file(u.path)));return}d.message&&this.q.debug("ExtHostSearch",d.message)};if(!this.y)throw new Error("No internal file search handler");const s=await this.getNumThreadsCached();return this.y.doFileSearch(n,s,i,o)}async H(n,o,t,i){return this.doInternalFileSearchWithCustomCallback(t,i,s=>{this.c.$handleFileMatch(n,o,s)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,o){return new m.$arc(n,o,void 0,"textSearchProvider")}};e.$erc=g,e.$erc=g=Ye([Ve(0,c.$2P),Ve(1,p.$fQ),Ve(2,S.$Qoc),Ve(3,R.$Woc),Ve(4,O.$ak)],g)}),define(Se[132],De([1,0,417,68,67,418,22,14,4,3,17,11,33,87,69]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$xi=e.$wi=e.$vi=void 0,e.$yi=u,e.$zi=b,e.$Bi=y,e.$Ci=T;const l=3e4;class m{traceSocketEvent(v,f){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,f)}constructor(v,f=""){this.f=!0,this.debugLabel=f,this.socket=v,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent(w.SocketDiagnosticsEventType.Error,{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,R.$3)(F)}},this.socket.on("error",this.a);let N;this.b=F=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Close,{hadError:F}),this.f=!1,N&&clearTimeout(N)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,N=setTimeout(()=>v.destroy(),l)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const f=N=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Read,N),v(O.$Pe.wrap(N))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(v){const f=N=>{v({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:N,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(v){const f=()=>{v()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(w.SocketDiagnosticsEventType.Write,v),this.socket.write(v.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,R.$3)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,R.$3)(f)}}end(){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((v,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),v();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),v()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.$vi=m;var g;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var $;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})($||($={}));class n extends c.$Xc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,f){this.socket.traceSocketEvent(v,f)}constructor(v,f,N,F){super(),this.f=this.B(new p.$ne),this.g=this.B(new p.$ne),this.h=!1,this.j={state:$.PeekHeader,readLen:g.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:N?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new o(this,f,N,F,this.f,(j,z)=>this.m(j,z))),this.B(this.a.onError(j=>{console.error(j),(0,R.$3)(j),this.g.fire({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:j})})),this.b=new w.$qi,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let f=0;for(;f<v.byteLength;)this.a.writeMessage(v.slice(f,Math.min(f+g.MaxWebSocketMessageLength,v.byteLength)),{compressed:!0,opcode:2}),f+=g.MaxWebSocketMessageLength}m(v,{compressed:f,opcode:N}){if(this.h)return;this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,v);let F=g.MinHeaderByteSize;v.byteLength<126?F+=0:v.byteLength<2**16?F+=2:F+=8;const j=O.$Pe.alloc(F),z=f?64:0,M=N&15;if(j.writeUInt8(128|z|M,0),v.byteLength<126)j.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){j.writeUInt8(126,1);let L=1;j.writeUInt8(v.byteLength>>>8&255,++L),j.writeUInt8(v.byteLength>>>0&255,++L)}else{j.writeUInt8(127,1);let L=1;j.writeUInt8(0,++L),j.writeUInt8(0,++L),j.writeUInt8(0,++L),j.writeUInt8(0,++L),j.writeUInt8(v.byteLength>>>24&255,++L),j.writeUInt8(v.byteLength>>>16&255,++L),j.writeUInt8(v.byteLength>>>8&255,++L),j.writeUInt8(v.byteLength>>>0&255,++L)}this.socket.write(O.$Pe.concat([j,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===$.PeekHeader){const f=this.b.peek(this.j.readLen),N=f.readUInt8(0),F=(N&128)>>>7,j=(N&64)>>>6,z=N&15,M=f.readUInt8(1),L=(M&128)>>>7,B=M&127;this.j.state=$.ReadHeader,this.j.readLen=g.MinHeaderByteSize+(L?4:0)+(B===126?2:0)+(B===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===$.ReadHeader){const f=this.b.read(this.j.readLen),N=f.readUInt8(1),F=(N&128)>>>7;let j=N&127,z=1;j===126?j=f.readUInt8(++z)*2**8+f.readUInt8(++z):j===127&&(j=f.readUInt8(++z)*0+f.readUInt8(++z)*0+f.readUInt8(++z)*0+f.readUInt8(++z)*0+f.readUInt8(++z)*2**24+f.readUInt8(++z)*2**16+f.readUInt8(++z)*2**8+f.readUInt8(++z));let M=0;F&&(M=f.readUInt8(++z)*2**24+f.readUInt8(++z)*2**16+f.readUInt8(++z)*2**8+f.readUInt8(++z)),this.j.state=$.ReadBody,this.j.readLen=j,this.j.mask=M,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===$.ReadBody){const f=this.b.read(this.j.readLen);this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,f),s(f,this.j.mask),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,f),this.j.state=$.PeekHeader,this.j.readLen=g.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(f,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(f,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$wi=n;class o extends c.$Xc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$Pe.alloc(0)}constructor(v,f,N,F,j,z){super(),this.n=v,this.r=j,this.s=z,this.a=this.B(new p.$ne),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$ne),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$ne),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,f?(this.b=this.B(new t(this.n,F,N,{windowBits:15})),this.f=this.B(new i(this.n,{windowBits:15})),this.B(this.b.onError(M=>this.a.fire(M))),this.B(this.f.onError(M=>this.a.fire(M)))):(this.b=null,this.f=null)}writeMessage(v,f){this.g.push({data:v,options:f}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:f}=this.g.shift();if(this.f&&f.compressed){const N=await this.w(this.f,v);this.s(N,f)}else this.s(v,{...f,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,f){return new Promise((N,F)=>{v.write(f),v.flush(j=>N(j))})}acceptFrame(v,f,N){this.h.push({data:v,isCompressed:f,isLastFrameOfMessage:N}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const f=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(f)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,f,N){return new Promise((F,j)=>{v.write(f),N&&v.write(O.$Pe.fromByteArray([0,0,255,255])),v.flush(z=>F(z))})}}class t extends c.$Xc{get recordedInflateBytes(){return this.j?O.$Pe.concat(this.f):O.$Pe.alloc(0)}constructor(v,f,N,F){super(),this.h=v,this.j=f,this.a=this.B(new p.$ne),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(F),this.b.on("error",j=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateError,{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateData,j),this.g.push(O.$Pe.wrap(j))}),N&&(this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialWrite,N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateWrite,v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateFlushFired);const f=O.$Pe.concat(this.g);this.g.length=0,v(f)})}}class i extends c.$Xc{constructor(v,f){super(),this.g=v,this.a=this.B(new p.$ne),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateError,{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateData,N),this.f.push(O.$Pe.wrap(N))})}write(v){this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateWrite,v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateFlushFired);let f=O.$Pe.concat(this.f);this.f.length=0,f=f.slice(0,f.byteLength-4),v(f)})}}function s(C,v){if(v===0)return;const f=C.byteLength>>>2;for(let L=0;L<f;L++){const B=C.readUInt32BE(L*4);C.writeUInt32BE(B^v,L*4)}const N=f*4,F=C.byteLength-N,j=v>>>24&255,z=v>>>16&255,M=v>>>8&255;F>=1&&C.writeUInt8(C.readUInt8(N)^j,N),F>=2&&C.writeUInt8(C.readUInt8(N+1)^z,N+1),F>=3&&C.writeUInt8(C.readUInt8(N+2)^M,N+2)}e.$xi=process.env.XDG_RUNTIME_DIR;const d={[S.Platform.Linux]:107,[S.Platform.Mac]:103};function u(){const C=(0,h.$3g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const v=process.platform!=="darwin"&&e.$xi?e.$xi:(0,k.tmpdir)(),f=(0,I.$mc)(v,`vscode-ipc-${C}.sock`);return E(f),f}function b(C,v,f){const F=(0,r.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${f}-${v}-sock`;const j=f.substr(0,4),z=v.substr(0,6);let M;return process.platform!=="darwin"&&e.$xi&&!process.env.VSCODE_PORTABLE?M=(0,I.$mc)(e.$xi,`vscode-${F}-${j}-${z}.sock`):M=(0,I.$mc)(C,`${j}-${z}.sock`),E(M),M}function E(C){const v=d[S.$o];typeof v=="number"&&C.length>=v&&console.warn(`WARNING: IPC handle "${C}" is longer than ${v} chars, try a shorter --user-data-dir`)}class D extends P.$ki{static b(v){const f=p.Event.fromNodeEventEmitter(v,"connection");return p.Event.map(f,N=>({protocol:new w.$ri(new m(N,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(N,"close"))}))}constructor(v){super(D.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ai=D;function y(C){return new Promise((v,f)=>{const N=(0,a.createServer)();N.on("error",f),N.listen(C,()=>{N.removeListener("error",f),v(new D(N))})})}function T(C,v){return new Promise((f,N)=>{const F=(0,a.createConnection)(C,()=>{F.removeListener("error",N),f(w.$si.fromSocket(new m(F,`ipc-client${v}`),v))});F.once("error",N)})}}),define(Se[405],De([1,0,68,67,191,132,7,3,11,46,12,116,284,286,118,93,22]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=e.$2gc=e.$1gc=void 0,r=Ue(r),a=Ue(a);async function g(i,s,d,u,b){let E;for(let D=3;D&&(E?.dispose(),E=await new $(i,s,d,u,b).waitForReady(),!(b&&k.$6g[b]||!k.$6g[E.tunnelLocalPort]));D--);return E}class $ extends R.$Xc{constructor(s,d,u,b,E){super(),this.m=d,this.n=E,this.privacy=l.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=r.createServer(),this.c=new O.$Fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=b,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,d=(0,l.$Kw)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,k.$7g)(s,2,1e3,d),b=null;return this.b.listen(u,this.m),await this.c.wait(),b=this.b.address(),b||(u=0,this.b.listen(u,this.m),await this.c.wait(),b=this.b.address()),this.tunnelLocalPort=b.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${b.port}`,this}async r(s){s.pause();const d=(0,l.$Iw)(this.tunnelRemoteHost)||(0,l.$Kw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,h.$3l)(this.a,d,this.tunnelRemotePort),b=u.getSocket(),E=u.readEntireBuffer();u.dispose(),E.byteLength>0&&s.write(E.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),b.end()}),s.on("close",()=>b.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),b instanceof A.$vi?b.socket.destroy():b.end()}),b instanceof A.$vi?this.t(s,b):this.s(s,b),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),b.end()})}s(s,d){d.onClose(()=>s.destroy()),d.onEnd(()=>s.end()),d.onData(u=>s.write(u.buffer)),s.on("data",u=>d.write(m.$Pe.wrap(u))),s.resume()}t(s,d){const u=d.socket;u.on("end",()=>s.end()),u.on("close",()=>s.end()),u.on("error",()=>{s.destroy()}),u.pipe(s),s.pipe(u)}}e.$1gc=$;let n=class extends l.$Nw{constructor(s,d,u,b,E){super(d,E),this.H=s,this.I=u,this.J=b}isPortPrivileged(s){return(0,l.$Lw)(s,this.t,p.OS,a.release())}F(s,d,u,b,E,D,y,T){const C=this.D(d,u);if(C)return++C.refcount,C.value;if((0,l.$Ew)(s))return this.G(s,d,u,E,D,y,T);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${u} on local port ${E}.`);const v={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},f=g(v,b,d,u,E);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(d,u,f),f}}};e.$2gc=n,e.$2gc=n=Ye([Ve(0,P.$Wl),Ve(1,I.$ak),Ve(2,w.$Zl),Ve(3,S.$tk),Ve(4,c.$aj)],n);let o=class extends n{constructor(s,d,u,b,E){super(s,d,u,b,E)}};e.$3gc=o,e.$3gc=o=Ye([Ve(0,P.$Wl),Ve(1,I.$ak),Ve(2,w.$Zl),Ve(3,S.$tk),Ve(4,c.$aj)],o);let t=class extends R.$Xc{constructor(s,d,u,b,E){super(),this.b=s,this.c=d,this.f=u,this.g=b,this.h=E,this.a=new Map}async openTunnel(s,d,u,b,E,D,y,T,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${b} on local port ${D}.`),!this.a.has(s)){const v=new o(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(s,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(d,u,b,E,D,y,T,C)}};e.$4gc=t,e.$4gc=t=Ye([Ve(0,P.$Wl),Ve(1,I.$ak),Ve(2,S.$tk),Ve(3,w.$Zl),Ve(4,c.$aj)],t)}),define(Se[406],De([1,0,132,120,61,35,2,12,47]),function(ie,e,r,a,k,A,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rQ=e.$qQ=void 0,a=Ue(a),k=Ue(k);class c{constructor(h,P,w){this.b=h,this.c=P,this.f=w,this.a=a.createServer((l,m)=>this.h(l,m)),this.g().catch(l=>(P.error(l),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",h=>this.c.error(h))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(h,P){const w=(m,g)=>{P.writeHead(m,{"content-type":"application/json"}),P.end(JSON.stringify(g||null),$=>$&&this.c.error($))},l=[];h.setEncoding("utf8"),h.on("data",m=>l.push(m)),h.on("end",async()=>{try{const m=JSON.parse(l.join(""));let g;switch(m.type){case"open":g=await this.i(m);break;case"openExternal":g=await this.j(m);break;case"status":g=await this.l(m);break;case"extensionManagement":g=await this.k(m);break;case"clipboard":g=await this.m(m);break;default:w(404,`Unknown message type: ${m.type}`);break}w(200,g)}catch(m){const g=m instanceof Error?m.message:JSON.stringify(m);w(500,g),this.c.error("Error while processing pipe request",m)}})}async i(h){const{fileURIs:P,folderURIs:w,forceNewWindow:l,diffMode:m,mergeMode:g,addMode:$,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:t,remoteAuthority:i}=h,s=[];if(Array.isArray(w))for(const E of w)try{s.push({folderUri:O.URI.parse(E)})}catch{}if(Array.isArray(P))for(const E of P)try{(0,p.$_i)(E)?s.push({workspaceUri:O.URI.parse(E)}):s.push({fileUri:O.URI.parse(E)})}catch{}const d=t?O.URI.file(t):void 0,b={forceNewWindow:l,diffMode:m,mergeMode:g,addMode:$,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!$,waitMarkerFileURI:d,remoteAuthority:i};this.b.executeCommand("_remoteCLI.windowOpen",s,b)}async j(h){for(const P of h.uris){const w=O.URI.parse(P),l=w.scheme==="file"?w:P;await this.b.executeCommand("_remoteCLI.openExternal",l)}}async k(h){const P=l=>l?.map(m=>/\.vsix$/i.test(m)?O.URI.parse(m):m),w={list:h.list,install:P(h.install),uninstall:P(h.uninstall),force:h.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(h){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}async m(h){return await this.b.executeCommand("_remoteCLI.setClipboard",h.content)}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&k.existsSync(this.f)&&k.unlinkSync(this.f)}}e.$qQ=c;let I=class extends c{constructor(h,P){super(h,P,(0,r.$yi)())}};e.$rQ=I,e.$rQ=I=Ye([Ve(0,A.$lQ),Ve(1,R.$ak)],I)}),define(Se[407],De([1,0,120,62,394,389,302,53,376,2,15,8,406,109,336,42,375]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jrc=void 0,r=Ue(r),a=Ue(a);class g extends A.$Kqc{k(){const o=this,t=globalThis._VSCODE_NODE_MODULES.module,i=t._load;t._load=function(b,E,D){return b=d(b),o.a.has(b)?o.a.get(b).load(b,c.URI.file((0,P.$nr)(E.filename)),y=>i.apply(this,[y,E,D])):i.apply(this,arguments)};const s=t._resolveLookupPaths;t._resolveLookupPaths=(u,b)=>s.call(this,d(u),b);const d=u=>{for(const b of o.b){const E=b(u);if(E){u=E;break}}return u}}}class $ extends R.$wpc{constructor(){super(...arguments),this.extensionRuntime=S.ExtensionRuntime.Node}async vb(){this.h.createInstance(w.$hrc);const o=this.h.invokeFunction(k.$Gqc);if(this.h.createInstance(p.$grc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(h.$rQ);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(m.$irc),await this.h.createInstance(g,o,{mine:this.J,all:this.L}).install(),a.mark("code/extHost/didInitAPI"),(async()=>{const s=process.env.VSCODE_IPC_HOOK_CLI,d=process.env.CODE_SERVER_SESSION_SOCKET;if(!s||!d)return;const b={workspace:this.h.invokeFunction(D=>D.get(l.$Toc).workspace),socketPath:s},E=JSON.stringify({entry:b});await new Promise((D,y)=>{const T={path:"/add-session",socketPath:d,method:"POST",headers:{"content-type":"application/json"}},C=r.request(T,v=>{v.on("error",y),v.on("end",()=>{try{v.statusCode===200?D():y(new Error("Unexpected status code: "+v.statusCode))}catch(f){y(f)}})});C.on("error",y),C.write(E),C.end()})})().catch(s=>{this.s.error(s)});const i=await this.m.getConfigProvider();await(0,O.$frc)(this.j,i,this,this.s,this.z,this.f),a.mark("code/extHost/didInitProxyResolver")}wb(o){return o.main}async xb(o,t,i){if(t.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${t}', must be of file-scheme`);let s=null;i.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${t.toString(!0)}`),this.s.flush();const d=o?.identifier.value;o&&await this.w.initializeLocalizedMessages(o);try{d&&a.mark(`code/extHost/willLoadExtensionCode/${d}`),s=ie.__$__nodeRequire(t.fsPath)}finally{d&&a.mark(`code/extHost/didLoadExtensionCode/${d}`),i.codeLoadingStop()}return s}async $setRemoteEnvironment(o){if(this.f.remote.isRemote)for(const t in o){const i=o[t];i===null?delete process.env[t]:process.env[t]=i}}}e.$jrc=$}),define(Se[408],De([1,0,56,22,4,3,135,11,23,2,34,69,12,283,72,118,93,405,30,20,77,383]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=void 0,e.$krc=i,e.$lrc=s,e.$mrc=d,e.$nrc=u,e.$orc=E,e.$prc=D,e.$qrc=y,p=Ue(p),I=Ue(I);function i(v){const f=v.trim().split(`
`),N=[];return f.forEach(j=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);z&&z.length>=3&&N.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),N.reduce((j,z)=>(j[z.socket]=z,j),{})}function s(...v){const f=[].concat(...v.map(u));return[...new Map(f.filter(N=>N.st==="0A").map(N=>{const F=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:d(F[0]),port:parseInt(F[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function d(v){let f="";if(v.length===8)for(let N=v.length-2;N>=0;N-=2)f+=parseInt(v.substr(N,2),16),N!==0&&(f+=".");else for(let N=0;N<v.length;N+=8){const F=v.substring(N,N+8);let j="";for(let z=8;z>=2;z-=2)j+=F.substring(z-2,z),(z===6||z===2)&&(j=parseInt(j,16).toString(16),f+=`${j}`,j="",N+z!==v.length-6&&(f+=":"))}return f}function u(v){const f=v.trim().split(`
`),N=f.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return f.map(j=>j.trim().split(/\s+/).reduce((z,M,L)=>(z[N[L]||L]=M,z),{}))}function b(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function E(v){const f=v.trim().split(`
`),N=[];return f.forEach(F=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(F);j&&j.length>=4&&N.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),N}async function D(v,f,N){const F=N.reduce((z,M)=>(z[M.pid]=M,z),{}),j=[];return v.forEach(({socket:z,ip:M,port:L})=>{const B=f[z]?f[z].pid:void 0,W=B?F[B]?.cmd:void 0;B&&W&&!b(W)&&j.push({host:M,port:L,detail:W,pid:B})}),j}function y(v,f,N){const F=new Map,j=E(f);for(const z of v){const M=N.get(z.port);if(M){F.set(z.port,M);continue}const L=j.find(B=>B.cmd.includes(`${z.port}`));if(L){let B=L,W;do W=j.find(ae=>ae.ppid===B.pid),W&&(B=W);while(W);F.set(z.port,{host:z.ip,port:z.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else F.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return F}let T=class extends o.$aGb{constructor(f,N,F,j){super(f,N,F),this.D=N,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,R.$e&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(f){if(f&&this.C)return;this.C=f;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const F=new O.$Om;let j=0;for(;this.C;){const z=new Date().getTime(),M=(await this.I()).filter(W=>(0,m.$Iw)(W.host)||(0,m.$Kw)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(W=>W.port).join(", ")}`);const L=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${L} ms.`),j++>3&&F.update(L),(!N||JSON.stringify(N)!==JSON.stringify(M))&&(N=M,await this.a.$onFoundNewCandidates(N));const B=this.G(F.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${B} ms.`),await new Promise(W=>setTimeout(()=>W(),B))}}G(f){return Math.max(f*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(f=>f.port).join(", ")}`)}async I(){let f="",N="";try{f=await I.Promises.readFile("/proc/net/tcp","utf8"),N=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const F=s(f,N),j=await new Promise(K=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(ee,re,ge)=>{K(re)})}),z=i(j),M=await I.Promises.readdir("/proc"),L=[];for(const K of M)try{const ee=Number(K),re=p.$hh(c.URI.file("/proc"),K);if((await I.Promises.stat(re.fsPath)).isDirectory()&&!isNaN(ee)){const Z=await I.Promises.readlink(p.$hh(re,"cwd").fsPath),$e=await I.Promises.readFile(p.$hh(re,"cmdline").fsPath,"utf8");L.push({pid:ee,cwd:Z,cmd:$e})}}catch{}const B=[],W=F.filter(K=>{const ee=z[K.socket];return ee||B.push(K),ee}),ae=D(W,z,L);let q;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const K=await new Promise(ee=>{(0,r.exec)("ps -F -A -l | grep root",(re,ge,Z)=>{ee(ge)})});this.z=y(B,K,this.z),q=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${q.map(ee=>ee.port).join(", ")}`)}return ae.then(K=>q?K.concat(q):K)}w(f){return async N=>{const F=new g.$1gc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,M,L,B){const W=await f.makeConnection();return C.connect(W,M,L,B)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new w.$Sl(0),connectionToken:f.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await F.waitForReady();const j=new k.$ne;return{localAddress:(0,t.$VM)(F.localAddress)??F.localAddress,remoteAddress:{port:F.tunnelRemotePort,host:F.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{F.dispose(),j.fire(),j.dispose()}}}}};e.$rrc=T,e.$rrc=T=Ye([Ve(0,n.$2P),Ve(1,$.$fQ),Ve(2,h.$ak),Ve(3,l.$Zl)],T);class C extends P.$rxb{static connect(f,N,F,j){const z=new A.$Wc,M={onClose:z.add(new k.$ne),onData:z.add(new k.$ne),onEnd:z.add(new k.$ne)};z.add(f.onDidReceiveMessage(B=>M.onData.fire(a.$Pe.wrap(B)))),z.add(f.onDidEnd(()=>M.onEnd.fire())),z.add(f.onDidClose(B=>M.onClose.fire({type:S.SocketCloseEventType.NodeSocketCloseEvent,error:B,hadError:!!B})));const L=new C(f,j,M);return L.B(z),(0,P.$qxb)(L,N,F,j,M)}constructor(f,N,F){super(N,F),this.n=f}write(f){this.n.send(f.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[409],De([1,0,89,378,392,391,404,407,408,102,53,103,101,48,77,98,377,337,12,393,65,298,113,118,150]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$,n,o,t,i,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Qs)(I.$xpc,R.$jrc,r.InstantiationType.Eager),(0,r.$Qs)($.$bk,g.$trc,r.InstantiationType.Delayed),(0,r.$Qs)($.$ak,new i.$Di(t.$Jqc,[!1],!0)),(0,r.$Qs)(s.$Zl,d.$6gc,r.InstantiationType.Delayed),(0,r.$Qs)(l.$Zoc,m.$src,r.InstantiationType.Eager),(0,r.$Qs)(c.$Hpc,A.$Wqc,r.InstantiationType.Eager),(0,r.$Qs)(S.$4pc,O.$erc,r.InstantiationType.Eager),(0,r.$Qs)(h.$uqc,k.$Oqc,r.InstantiationType.Eager),(0,r.$Qs)(P.$ipc,a.$Nqc,r.InstantiationType.Eager),(0,r.$Qs)(w.$_Fb,p.$rrc,r.InstantiationType.Eager),(0,r.$Qs)(o.$Apc,n.$urc,r.InstantiationType.Eager)});var qt=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(Se[419],De([1,0,120,420,68,7,22,14,62,109,34,69,132,114,281,390,303,319,94,395,409]),function(ie,e,r,a,k,A,O,R,p,c,I,S,h,P,w,l,m,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ue(r),a=qt(a),k=Ue(k),p=Ue(p),w=qt(w),function(){for(let y=0;y<process.execArgv.length;y++)process.execArgv[y]==="--inspect-port=0"&&(process.execArgv.splice(y,1),y--)}();const n=(0,a.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const D=globalThis._VSCODE_NODE_MODULES.module,y=D._load;D._load=function(T){if(T==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return y.apply(this,arguments)}})();const o=process.exit.bind(process),t=process.on.bind(process);function i(D){process.exit=function(y){if(D)o(y);else{const T=new Error("An extension called process.exit() and this was prevented.");console.warn(T.stack)}},process.crash=function(){const y=new Error("An extension called process.crash() and this was prevented.");console.warn(y.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(y,T){y==="uncaughtException"&&(T=function(){try{return T.call(void 0,arguments)}catch{}}),t(y,T)}}let s=function(D){o()};function d(){const D=(0,g.$hn)(process.env);if(D.type===g.ExtHostConnectionType.MessagePort)return new Promise((y,T)=>{const C=v=>{const f=v[0],N=new S.$ti;f.on("message",F=>N.fire(O.$Pe.wrap(F.data))),f.on("close",()=>{s("renderer closed the MessagePort")}),f.start(),y({onMessage:N.event,send:F=>f.postMessage(F.buffer)})};process.parentPort.on("message",v=>C(v.ports))});if(D.type===g.ExtHostConnectionType.Socket)return new Promise((y,T)=>{let C=null;const v=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),f=S.ProtocolConstants.ReconnectionGraceTime,N=S.ProtocolConstants.ReconnectionShortGraceTime,F=new A.$Th(()=>s("renderer disconnected for too long (1)"),f),j=new A.$Th(()=>s("renderer disconnected for too long (2)"),N);process.on("message",(M,L)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){L.setNoDelay(!0);const B=O.$Pe.wrap(Buffer.from(M.initialDataChunk,"base64"));let W;if(M.skipWebSocketFrames)W=new h.$vi(L,"extHost-socket");else{const ae=O.$Pe.wrap(Buffer.from(M.inflateBytes,"base64"));W=new h.$wi(new h.$vi(L,"extHost-socket"),M.permessageDeflate,ae,!1)}C?(F.cancel(),j.cancel(),C.beginAcceptReconnection(W,B),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(v),C=new S.$ui({socket:W,initialChunk:B}),C.sendResume(),C.onDidDispose(()=>s("renderer disconnected")),y(C),C.onSocketClose(()=>{F.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;F.isScheduled()&&j.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const y=D.pipeName;return new Promise((T,C)=>{const v=k.createConnection(y,()=>{v.removeListener("error",C);const f=new S.$ui({socket:new h.$vi(v,"extHost-renderer")});f.sendResume(),T(f)});v.once("error",C),v.on("close",()=>{s("renderer closed the socket")})})}}async function u(){const D=await d();return new class{constructor(){this.a=new S.$ti,this.onMessage=this.a.event,this.b=!1,this.d=D.onMessage(y=>{(0,$.$Dn)(y,$.MessageType.Terminate)?(this.b=!0,this.d.dispose(),s("received terminate message from renderer")):this.a.fire(y)})}send(y){this.b||D.send(y)}async drain(){if(D.drain)return D.drain()}}}function b(D){return new Promise(y=>{const T=D.onMessage(C=>{T.dispose();const v=JSON.parse(C.toString()),f=v.commit,N=w.default.commit;if(f&&N&&f!==N&&o($.ExtensionHostExitCode.VersionMismatch),v.parentPid){let F=0;setInterval(function(){try{process.kill(v.parentPid,0),F=0}catch(z){z&&z.code==="EPERM"?(F++,F>=3&&s(`parent process ${v.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):s(`parent process ${v.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(v.parentPid)}catch(z){(0,R.$3)(z)}}D.send((0,$.$Cn)($.MessageType.Initialized)),y({protocol:D,initData:v})});D.send((0,$.$Cn)($.MessageType.Ready))})}async function E(){const D=[];process.on("unhandledRejection",(F,j)=>{D.push(j),setTimeout(()=>{const z=D.indexOf(j);z>=0&&j.catch(M=>{D.splice(z,1),(0,R.$7)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),F&&(0,R.$3)(F))})},1e3)}),process.on("rejectionHandled",F=>{const j=D.indexOf(F);j>=0&&D.splice(j,1)}),process.on("uncaughtException",function(F){(0,R.$2)(F)||(0,R.$3)(F)}),p.mark("code/extHost/willConnectToRenderer");const y=await u();p.mark("code/extHost/didConnectToRenderer");const T=await b(y);p.mark("code/extHost/didWaitForInitData");const{initData:C}=T;i(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,P.boolean)(n.skipWorkspaceStorageLock,!1);const v=new class{constructor(){this.pid=process.pid}exit(j){o(j)}fsExists(j){return I.Promises.exists(j)}fsRealpath(j){return(0,c.$mr)(j)}};let f=null;C.remote.authority&&n.transformURIs&&(f=(0,m.$Us)(C.remote.authority));const N=new l.$Mqc(T.protocol,C,v,f);s=F=>{N.terminate(F);const j=process.env.VSCODE_IPC_HOOK_CLI,z=process.env.CODE_SERVER_SESSION_SOCKET;if(!j||!z)return;const M=JSON.stringify({socketPath:j}),L={path:"/delete-session",socketPath:z,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},B=r.request(L);B.write(M),B.end()}}E().catch(D=>console.log(D))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
