"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Pe=function(_){for(var e=[],w=0,y=_.length;w<y;w++)e[w]=Ie[_[w]];return e};define(Ie[72],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=y,e.$_h=k,e.$ai=O;function w(R){return(N,v,s)=>{let I=null,E=null;if(typeof s.value=="function"?(I="value",E=s.value):typeof s.get=="function"&&(I="get",E=s.get),!E)throw new Error("not supported");s[I]=R(E,v)}}function y(R,N,v){let s=null,I=null;if(typeof v.value=="function"?(s="value",I=v.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(s="get",I=v.get),!I)throw new Error("not supported");const E=`$memoize$${N}`;v[s]=function(...u){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[E]}}function k(R,N,v){return w((s,I)=>{const E=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...C){this[u]||(this[u]=v?v():void 0),clearTimeout(this[E]),N&&(this[u]=N(this[u],...C),C=[this[u]]),this[E]=setTimeout(()=>{s.apply(this,C),this[u]=v?v():void 0},R)}})}function O(R,N,v){return w((s,I)=>{const E=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,C=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...n){if(this[u]||(this[u]=v?v():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),N&&(this[u]=N(this[u],...n)),this[d])return;const o=this[C]+R;o<=Date.now()?(this[C]=Date.now(),s.apply(this,[this[u]]),this[u]=v?v():void 0):(this[d]=!0,this[E]=setTimeout(()=>{this[d]=!1,this[C]=Date.now(),s.apply(this,[this[u]]),this[u]=v?v():void 0},o-Date.now()))}})}});var Zn=this&&this.__createBinding||(Object.create?function(_,e,w,y){y===void 0&&(y=w);var k=Object.getOwnPropertyDescriptor(e,w);(!k||("get"in k?!e.__esModule:k.writable||k.configurable))&&(k={enumerable:!0,get:function(){return e[w]}}),Object.defineProperty(_,y,k)}:function(_,e,w,y){y===void 0&&(y=w),_[y]=e[w]}),Yn=this&&this.__setModuleDefault||(Object.create?function(_,e){Object.defineProperty(_,"default",{enumerable:!0,value:e})}:function(_,e){_.default=e}),Ve=this&&this.__importStar||function(_){if(_&&_.__esModule)return _;var e={};if(_!=null)for(var w in _)w!=="default"&&Object.prototype.hasOwnProperty.call(_,w)&&Zn(e,_,w);return Yn(e,_),e};define(Ie[135],Pe([1,0,18]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=void 0,e.$0c=k,e.$$c=O,e.$_c=R,e.$ad=N,e.$bd=v,e.$cd=s,w=Ve(w);const y=(C,d)=>C===d;e.$9c=y;function k(C=e.$9c){return(d,n)=>w.$xb(d,n,C)}function O(){return(C,d)=>JSON.stringify(C)===JSON.stringify(d)}function R(){return(C,d)=>C.equals(d)}function N(C,d,n){if(n!==void 0){const o=C;return o==null||d===void 0||d===null?d===o:n(o,d)}else{const o=C;return(c,h)=>c==null||h===void 0||h===null?h===c:o(c,h)}}function v(C,d){if(C===d)return!0;if(Array.isArray(C)&&Array.isArray(d)){if(C.length!==d.length)return!1;for(let n=0;n<C.length;n++)if(!v(C[n],d[n]))return!1;return!0}if(C&&typeof C=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(C)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const n=C,o=d,c=Object.keys(n),h=Object.keys(o),i=new Set(h);if(c.length!==h.length)return!1;for(const r of c)if(!i.has(r)||!v(n[r],o[r]))return!1;return!0}return!1}function s(C){return JSON.stringify(u(C))}let I=0;const E=new WeakMap;function u(C){if(Array.isArray(C))return C.map(u);if(C&&typeof C=="object")if(Object.getPrototypeOf(C)===Object.prototype){const d=C,n=Object.create(null);for(const o of Object.keys(d).sort())n[o]=u(d[o]);return n}else{let d=E.get(C);return d===void 0&&(d=I++,E.set(C,d)),d+"----2b76a038c20c4bcc"}return C}}),define(Ie[97],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=e.$7P=void 0;class w{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.$7P=w,e.$8P=new w("id#")}),define(Ie[136],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Xn=R,e.$Yn=E,e.$Zn=u,e.$1n=C,e.$2n=d,e.$3n=n,e.$4n=o,e.$5n=c,e.$6n=h,e.$7n=i,e.$8n=r;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var y;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(y||(e.SyntaxKind=y={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function R(t,a=!1){let l=0;const g=t.length;let m="",$=0,S=y.Unknown,D=w.None;function b(K){let J=0,z=0;for(;J<K;){const A=t.charCodeAt(l);if(A>=I._0&&A<=I._9)z=z*16+A-I._0;else if(A>=I.A&&A<=I.F)z=z*16+A-I.A+10;else if(A>=I.a&&A<=I.f)z=z*16+A-I.a+10;else break;l++,J++}return J<K&&(z=-1),z}function T(K){l=K,m="",$=0,S=y.Unknown,D=w.None}function P(){const K=l;if(t.charCodeAt(l)===I._0)l++;else for(l++;l<t.length&&s(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===I.dot)if(l++,l<t.length&&s(t.charCodeAt(l)))for(l++;l<t.length&&s(t.charCodeAt(l));)l++;else return D=w.UnexpectedEndOfNumber,t.substring(K,l);let J=l;if(l<t.length&&(t.charCodeAt(l)===I.E||t.charCodeAt(l)===I.e))if(l++,(l<t.length&&t.charCodeAt(l)===I.plus||t.charCodeAt(l)===I.minus)&&l++,l<t.length&&s(t.charCodeAt(l))){for(l++;l<t.length&&s(t.charCodeAt(l));)l++;J=l}else D=w.UnexpectedEndOfNumber;return t.substring(K,J)}function p(){let K="",J=l;for(;;){if(l>=g){K+=t.substring(J,l),D=w.UnexpectedEndOfString;break}const z=t.charCodeAt(l);if(z===I.doubleQuote){K+=t.substring(J,l),l++;break}if(z===I.backslash){if(K+=t.substring(J,l),l++,l>=g){D=w.UnexpectedEndOfString;break}switch(t.charCodeAt(l++)){case I.doubleQuote:K+='"';break;case I.backslash:K+="\\";break;case I.slash:K+="/";break;case I.b:K+="\b";break;case I.f:K+="\f";break;case I.n:K+=`
`;break;case I.r:K+="\r";break;case I.t:K+="	";break;case I.u:{const W=b(4);W>=0?K+=String.fromCharCode(W):D=w.InvalidUnicode;break}default:D=w.InvalidEscapeCharacter}J=l;continue}if(z>=0&&z<=31)if(v(z)){K+=t.substring(J,l),D=w.UnexpectedEndOfString;break}else D=w.InvalidCharacter;l++}return K}function f(){if(m="",D=w.None,$=l,l>=g)return $=g,S=y.EOF;let K=t.charCodeAt(l);if(N(K)){do l++,m+=String.fromCharCode(K),K=t.charCodeAt(l);while(N(K));return S=y.Trivia}if(v(K))return l++,m+=String.fromCharCode(K),K===I.carriageReturn&&t.charCodeAt(l)===I.lineFeed&&(l++,m+=`
`),S=y.LineBreakTrivia;switch(K){case I.openBrace:return l++,S=y.OpenBraceToken;case I.closeBrace:return l++,S=y.CloseBraceToken;case I.openBracket:return l++,S=y.OpenBracketToken;case I.closeBracket:return l++,S=y.CloseBracketToken;case I.colon:return l++,S=y.ColonToken;case I.comma:return l++,S=y.CommaToken;case I.doubleQuote:return l++,m=p(),S=y.StringLiteral;case I.slash:{const J=l-1;if(t.charCodeAt(l+1)===I.slash){for(l+=2;l<g&&!v(t.charCodeAt(l));)l++;return m=t.substring(J,l),S=y.LineCommentTrivia}if(t.charCodeAt(l+1)===I.asterisk){l+=2;const z=g-1;let A=!1;for(;l<z;){if(t.charCodeAt(l)===I.asterisk&&t.charCodeAt(l+1)===I.slash){l+=2,A=!0;break}l++}return A||(l++,D=w.UnexpectedEndOfComment),m=t.substring(J,l),S=y.BlockCommentTrivia}return m+=String.fromCharCode(K),l++,S=y.Unknown}case I.minus:if(m+=String.fromCharCode(K),l++,l===g||!s(t.charCodeAt(l)))return S=y.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return m+=P(),S=y.NumericLiteral;default:for(;l<g&&M(K);)l++,K=t.charCodeAt(l);if($!==l){switch(m=t.substring($,l),m){case"true":return S=y.TrueKeyword;case"false":return S=y.FalseKeyword;case"null":return S=y.NullKeyword}return S=y.Unknown}return m+=String.fromCharCode(K),l++,S=y.Unknown}}function M(K){if(N(K)||v(K))return!1;switch(K){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function L(){let K;do K=f();while(K>=y.LineCommentTrivia&&K<=y.Trivia);return K}return{setPosition:T,getPosition:()=>l,scan:a?L:f,getToken:()=>S,getTokenValue:()=>m,getTokenOffset:()=>$,getTokenLength:()=>l-$,getTokenError:()=>D}}function N(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function v(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function s(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function E(t,a){const l=[],g=new Object;let m;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(b,T,P,p){$.value=b,$.offset=T,$.length=P,$.type=p,$.colonOffset=void 0,m=$}try{i(t,{onObjectBegin:(b,T)=>{if(a<=b)throw g;m=void 0,S=a>b,l.push("")},onObjectProperty:(b,T,P)=>{if(a<T||(D(b,T,P,"property"),l[l.length-1]=b,a<=T+P))throw g},onObjectEnd:(b,T)=>{if(a<=b)throw g;m=void 0,l.pop()},onArrayBegin:(b,T)=>{if(a<=b)throw g;m=void 0,l.push(0)},onArrayEnd:(b,T)=>{if(a<=b)throw g;m=void 0,l.pop()},onLiteralValue:(b,T,P)=>{if(a<T||(D(b,T,P,r(b)),a<=T+P))throw g},onSeparator:(b,T,P)=>{if(a<=T)throw g;if(b===":"&&m&&m.type==="property")m.colonOffset=T,S=!1,m=void 0;else if(b===","){const p=l[l.length-1];typeof p=="number"?l[l.length-1]=p+1:(S=!0,l[l.length-1]=""),m=void 0}}})}catch(b){if(b!==g)throw b}return{path:l,previousNode:m,isAtPropertyKey:S,matches:b=>{let T=0;for(let P=0;T<b.length&&P<l.length;P++)if(b[T]===l[P]||b[T]==="*")T++;else if(b[T]!=="**")return!1;return T===b.length}}}function u(t,a=[],l=O.DEFAULT){let g=null,m=[];const $=[];function S(b){Array.isArray(m)?m.push(b):g!==null&&(m[g]=b)}return i(t,{onObjectBegin:()=>{const b={};S(b),$.push(m),m=b,g=null},onObjectProperty:b=>{g=b},onObjectEnd:()=>{m=$.pop()},onArrayBegin:()=>{const b=[];S(b),$.push(m),m=b,g=null},onArrayEnd:()=>{m=$.pop()},onLiteralValue:S,onError:(b,T,P)=>{a.push({error:b,offset:T,length:P})}},l),m[0]}function C(t,a=[],l=O.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(b){g.type==="property"&&(g.length=b-g.offset,g=g.parent)}function $(b){return g.children.push(b),b}i(t,{onObjectBegin:b=>{g=$({type:"object",offset:b,length:-1,parent:g,children:[]})},onObjectProperty:(b,T,P)=>{g=$({type:"property",offset:T,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:b,offset:T,length:P,parent:g})},onObjectEnd:(b,T)=>{g.length=b+T-g.offset,g=g.parent,m(b+T)},onArrayBegin:(b,T)=>{g=$({type:"array",offset:b,length:-1,parent:g,children:[]})},onArrayEnd:(b,T)=>{g.length=b+T-g.offset,g=g.parent,m(b+T)},onLiteralValue:(b,T,P)=>{$({type:r(b),offset:T,length:P,parent:g,value:b}),m(T+P)},onSeparator:(b,T,P)=>{g.type==="property"&&(b===":"?g.colonOffset=T:b===","&&m(T))},onError:(b,T,P)=>{a.push({error:b,offset:T,length:P})}},l);const D=g.children[0];return D&&delete D.parent,D}function d(t,a){if(!t)return;let l=t;for(const g of a)if(typeof g=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let m=!1;for(const $ of l.children)if(Array.isArray($.children)&&$.children[0].value===g){l=$.children[1],m=!0;break}if(!m)return}else{const m=g;if(l.type!=="array"||m<0||!Array.isArray(l.children)||m>=l.children.length)return;l=l.children[m]}return l}function n(t){if(!t.parent||!t.parent.children)return[];const a=n(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;a.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&a.push(l)}return a}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const a=Object.create(null);for(const l of t.children){const g=l.children[1];g&&(a[l.children[0].value]=o(g))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,a,l=!1){return a>=t.offset&&a<t.offset+t.length||l&&a===t.offset+t.length}function h(t,a,l=!1){if(c(t,a,l)){const g=t.children;if(Array.isArray(g))for(let m=0;m<g.length&&g[m].offset<=a;m++){const $=h(g[m],a,l);if($)return $}return t}}function i(t,a,l=O.DEFAULT){const g=R(t,!1);function m($e){return $e?()=>$e(g.getTokenOffset(),g.getTokenLength()):()=>!0}function $($e){return $e?ye=>$e(ye,g.getTokenOffset(),g.getTokenLength()):()=>!0}const S=m(a.onObjectBegin),D=$(a.onObjectProperty),b=m(a.onObjectEnd),T=m(a.onArrayBegin),P=m(a.onArrayEnd),p=$(a.onLiteralValue),f=$(a.onSeparator),M=m(a.onComment),L=$(a.onError),K=l&&l.disallowComments,J=l&&l.allowTrailingComma;function z(){for(;;){const $e=g.scan();switch(g.getTokenError()){case w.InvalidUnicode:A(k.InvalidUnicode);break;case w.InvalidEscapeCharacter:A(k.InvalidEscapeCharacter);break;case w.UnexpectedEndOfNumber:A(k.UnexpectedEndOfNumber);break;case w.UnexpectedEndOfComment:K||A(k.UnexpectedEndOfComment);break;case w.UnexpectedEndOfString:A(k.UnexpectedEndOfString);break;case w.InvalidCharacter:A(k.InvalidCharacter);break}switch($e){case y.LineCommentTrivia:case y.BlockCommentTrivia:K?A(k.InvalidCommentToken):M();break;case y.Unknown:A(k.InvalidSymbol);break;case y.Trivia:case y.LineBreakTrivia:break;default:return $e}}}function A($e,ye=[],Y=[]){if(L($e),ye.length+Y.length>0){let we=g.getToken();for(;we!==y.EOF;){if(ye.indexOf(we)!==-1){z();break}else if(Y.indexOf(we)!==-1)break;we=z()}}}function W($e){const ye=g.getTokenValue();return $e?p(ye):D(ye),z(),!0}function Z(){switch(g.getToken()){case y.NumericLiteral:{let $e=0;try{$e=JSON.parse(g.getTokenValue()),typeof $e!="number"&&(A(k.InvalidNumberFormat),$e=0)}catch{A(k.InvalidNumberFormat)}p($e);break}case y.NullKeyword:p(null);break;case y.TrueKeyword:p(!0);break;case y.FalseKeyword:p(!1);break;default:return!1}return z(),!0}function he(){return g.getToken()!==y.StringLiteral?(A(k.PropertyNameExpected,[],[y.CloseBraceToken,y.CommaToken]),!1):(W(!1),g.getToken()===y.ColonToken?(f(":"),z(),de()||A(k.ValueExpected,[],[y.CloseBraceToken,y.CommaToken])):A(k.ColonExpected,[],[y.CloseBraceToken,y.CommaToken]),!0)}function ve(){S(),z();let $e=!1;for(;g.getToken()!==y.CloseBraceToken&&g.getToken()!==y.EOF;){if(g.getToken()===y.CommaToken){if($e||A(k.ValueExpected,[],[]),f(","),z(),g.getToken()===y.CloseBraceToken&&J)break}else $e&&A(k.CommaExpected,[],[]);he()||A(k.ValueExpected,[],[y.CloseBraceToken,y.CommaToken]),$e=!0}return b(),g.getToken()!==y.CloseBraceToken?A(k.CloseBraceExpected,[y.CloseBraceToken],[]):z(),!0}function be(){T(),z();let $e=!1;for(;g.getToken()!==y.CloseBracketToken&&g.getToken()!==y.EOF;){if(g.getToken()===y.CommaToken){if($e||A(k.ValueExpected,[],[]),f(","),z(),g.getToken()===y.CloseBracketToken&&J)break}else $e&&A(k.CommaExpected,[],[]);de()||A(k.ValueExpected,[],[y.CloseBracketToken,y.CommaToken]),$e=!0}return P(),g.getToken()!==y.CloseBracketToken?A(k.CloseBracketExpected,[y.CloseBracketToken],[]):z(),!0}function de(){switch(g.getToken()){case y.OpenBracketToken:return be();case y.OpenBraceToken:return ve();case y.StringLiteral:return W(!0);default:return Z()}}return z(),g.getToken()===y.EOF?l.allowEmptyContent?!0:(A(k.ValueExpected,[],[]),!1):de()?(g.getToken()!==y.EOF&&A(k.EndOfFileExpected,[],[]),!0):(A(k.ValueExpected,[],[]),!1)}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(_,e){typeof define=="function"&&define.amd?define(Ie[137],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(_=typeof globalThis<"u"?globalThis:_||self,e(_.marked={}))}(this,function(_){"use strict";function e(ne,ce){for(var oe=0;oe<ce.length;oe++){var H=ce[oe];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(ne,H.key,H)}}function w(ne,ce,oe){return ce&&e(ne.prototype,ce),oe&&e(ne,oe),Object.defineProperty(ne,"prototype",{writable:!1}),ne}function y(ne,ce){if(ne){if(typeof ne=="string")return k(ne,ce);var oe=Object.prototype.toString.call(ne).slice(8,-1);if(oe==="Object"&&ne.constructor&&(oe=ne.constructor.name),oe==="Map"||oe==="Set")return Array.from(ne);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return k(ne,ce)}}function k(ne,ce){(ce==null||ce>ne.length)&&(ce=ne.length);for(var oe=0,H=new Array(ce);oe<ce;oe++)H[oe]=ne[oe];return H}function O(ne,ce){var oe=typeof Symbol<"u"&&ne[Symbol.iterator]||ne["@@iterator"];if(oe)return(oe=oe.call(ne)).next.bind(oe);if(Array.isArray(ne)||(oe=y(ne))||ce&&ne&&typeof ne.length=="number"){oe&&(ne=oe);var H=0;return function(){return H>=ne.length?{done:!0}:{done:!1,value:ne[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}_.defaults=R();function N(ne){_.defaults=ne}var v=/[&<>"']/,s=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ce){return u[ce]};function d(ne,ce){if(ce){if(v.test(ne))return ne.replace(s,C)}else if(I.test(ne))return ne.replace(E,C);return ne}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ne){return ne.replace(n,function(ce,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var c=/(^|[^\[])\^/g;function h(ne,ce){ne=typeof ne=="string"?ne:ne.source,ce=ce||"";var oe={replace:function(x,ue){return ue=ue.source||ue,ue=ue.replace(c,"$1"),ne=ne.replace(x,ue),oe},getRegex:function(){return new RegExp(ne,ce)}};return oe}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(ne,ce,oe){if(ne){var H;try{H=decodeURIComponent(o(oe)).replace(i,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}ce&&!r.test(oe)&&(oe=$(ce,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var a={},l=/^[^:]+:\/*[^/]*$/,g=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ne,ce){a[" "+ne]||(l.test(ne)?a[" "+ne]=ne+"/":a[" "+ne]=T(ne,"/",!0)),ne=a[" "+ne];var oe=ne.indexOf(":")===-1;return ce.substring(0,2)==="//"?oe?ce:ne.replace(g,"$1")+ce:ce.charAt(0)==="/"?oe?ce:ne.replace(m,"$1")+ce:ne+ce}var S={exec:function(){}};function D(ne){for(var ce=1,oe,H;ce<arguments.length;ce++){oe=arguments[ce];for(H in oe)Object.prototype.hasOwnProperty.call(oe,H)&&(ne[H]=oe[H])}return ne}function b(ne,ce){var oe=ne.replace(/\|/g,function(ue,me,Oe){for(var je=!1,ke=me;--ke>=0&&Oe[ke]==="\\";)je=!je;return je?"|":" |"}),H=oe.split(/ \|/),x=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>ce)H.splice(ce);else for(;H.length<ce;)H.push("");for(;x<H.length;x++)H[x]=H[x].trim().replace(/\\\|/g,"|");return H}function T(ne,ce,oe){var H=ne.length;if(H===0)return"";for(var x=0;x<H;){var ue=ne.charAt(H-x-1);if(ue===ce&&!oe)x++;else if(ue!==ce&&oe)x++;else break}return ne.slice(0,H-x)}function P(ne,ce){if(ne.indexOf(ce[1])===-1)return-1;for(var oe=ne.length,H=0,x=0;x<oe;x++)if(ne[x]==="\\")x++;else if(ne[x]===ce[0])H++;else if(ne[x]===ce[1]&&(H--,H<0))return x;return-1}function p(ne){ne&&ne.sanitize&&!ne.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function f(ne,ce){if(ce<1)return"";for(var oe="";ce>1;)ce&1&&(oe+=ne),ce>>=1,ne+=ne;return oe+ne}function M(ne,ce,oe,H){var x=ce.href,ue=ce.title?d(ce.title):null,me=ne[1].replace(/\\([\[\]])/g,"$1");if(ne[0].charAt(0)!=="!"){H.state.inLink=!0;var Oe={type:"link",raw:oe,href:x,title:ue,text:me,tokens:H.inlineTokens(me)};return H.state.inLink=!1,Oe}return{type:"image",raw:oe,href:x,title:ue,text:d(me)}}function L(ne,ce){var oe=ne.match(/^(\s+)(?:```)/);if(oe===null)return ce;var H=oe[1];return ce.split(`
`).map(function(x){var ue=x.match(/^\s+/);if(ue===null)return x;var me=ue[0];return me.length>=H.length?x.slice(H.length):x}).join(`
`)}var K=function(){function ne(oe){this.options=oe||_.defaults}var ce=ne.prototype;return ce.space=function(H){var x=this.rules.block.newline.exec(H);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},ce.code=function(H){var x=this.rules.block.code.exec(H);if(x){var ue=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:T(ue,`
`)}}},ce.fences=function(H){var x=this.rules.block.fences.exec(H);if(x){var ue=x[0],me=L(ue,x[3]||"");return{type:"code",raw:ue,lang:x[2]?x[2].trim():x[2],text:me}}},ce.heading=function(H){var x=this.rules.block.heading.exec(H);if(x){var ue=x[2].trim();if(/#$/.test(ue)){var me=T(ue,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ue=me.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:ue,tokens:this.lexer.inline(ue)}}},ce.hr=function(H){var x=this.rules.block.hr.exec(H);if(x)return{type:"hr",raw:x[0]}},ce.blockquote=function(H){var x=this.rules.block.blockquote.exec(H);if(x){var ue=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},ce.list=function(H){var x=this.rules.block.list.exec(H);if(x){var ue,me,Oe,je,ke,Ae,Ne,U,B,G,Q,ee,fe=x[1].trim(),Re=fe.length>1,Ue={type:"list",raw:"",ordered:Re,start:Re?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Re?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Re?fe:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(ee=!1,!(!(x=Qe.exec(H))||this.rules.block.hr.test(H)));){if(ue=x[0],H=H.substring(ue.length),U=x[2].split(`
`,1)[0],B=H.split(`
`,1)[0],this.options.pedantic?(je=2,Q=U.trimLeft()):(je=x[2].search(/[^ ]/),je=je>4?1:je,Q=U.slice(je),je+=x[1].length),Ae=!1,!U&&/^ *$/.test(B)&&(ue+=B+`
`,H=H.substring(B.length+1),ee=!0),!ee)for(var Ye=new RegExp("^ {0,"+Math.min(3,je-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,je-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,je-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,je-1)+"}#");H&&(G=H.split(`
`,1)[0],U=G,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(U)||tt.test(U)||Ye.test(U)||it.test(H)));){if(U.search(/[^ ]/)>=je||!U.trim())Q+=`
`+U.slice(je);else if(!Ae)Q+=`
`+U;else break;!Ae&&!U.trim()&&(Ae=!0),ue+=G+`
`,H=H.substring(G.length+1)}Ue.loose||(Ne?Ue.loose=!0:/\n *\n *$/.test(ue)&&(Ne=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(Q),me&&(Oe=me[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:ue,task:!!me,checked:Oe,loose:!1,text:Q}),Ue.raw+=ue}Ue.items[Ue.items.length-1].raw=ue.trimRight(),Ue.items[Ue.items.length-1].text=Q.trimRight(),Ue.raw=Ue.raw.trimRight();var at=Ue.items.length;for(ke=0;ke<at;ke++){this.lexer.state.top=!1,Ue.items[ke].tokens=this.lexer.blockTokens(Ue.items[ke].text,[]);var pt=Ue.items[ke].tokens.filter(function(st){return st.type==="space"}),ut=pt.every(function(st){for(var ht=st.raw.split(""),mt=0,wt=O(ht),qe;!(qe=wt()).done;){var Be=qe.value;if(Be===`
`&&(mt+=1),mt>1)return!0}return!1});!Ue.loose&&pt.length&&ut&&(Ue.loose=!0,Ue.items[ke].loose=!0)}return Ue}},ce.html=function(H){var x=this.rules.block.html.exec(H);if(x){var ue={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var me=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);ue.type="paragraph",ue.text=me,ue.tokens=this.lexer.inline(me)}return ue}},ce.def=function(H){var x=this.rules.block.def.exec(H);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var ue=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:x[0],href:x[2],title:x[3]}}},ce.table=function(H){var x=this.rules.block.table.exec(H);if(x){var ue={type:"table",header:b(x[1]).map(function(Ne){return{text:Ne}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=x[0];var me=ue.align.length,Oe,je,ke,Ae;for(Oe=0;Oe<me;Oe++)/^ *-+: *$/.test(ue.align[Oe])?ue.align[Oe]="right":/^ *:-+: *$/.test(ue.align[Oe])?ue.align[Oe]="center":/^ *:-+ *$/.test(ue.align[Oe])?ue.align[Oe]="left":ue.align[Oe]=null;for(me=ue.rows.length,Oe=0;Oe<me;Oe++)ue.rows[Oe]=b(ue.rows[Oe],ue.header.length).map(function(Ne){return{text:Ne}});for(me=ue.header.length,je=0;je<me;je++)ue.header[je].tokens=this.lexer.inline(ue.header[je].text);for(me=ue.rows.length,je=0;je<me;je++)for(Ae=ue.rows[je],ke=0;ke<Ae.length;ke++)Ae[ke].tokens=this.lexer.inline(Ae[ke].text);return ue}}},ce.lheading=function(H){var x=this.rules.block.lheading.exec(H);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},ce.paragraph=function(H){var x=this.rules.block.paragraph.exec(H);if(x){var ue=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:ue,tokens:this.lexer.inline(ue)}}},ce.text=function(H){var x=this.rules.block.text.exec(H);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},ce.escape=function(H){var x=this.rules.inline.escape.exec(H);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},ce.tag=function(H){var x=this.rules.inline.tag.exec(H);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},ce.link=function(H){var x=this.rules.inline.link.exec(H);if(x){var ue=x[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var me=T(ue.slice(0,-1),"\\");if((ue.length-me.length)%2===0)return}else{var Oe=P(x[2],"()");if(Oe>-1){var je=x[0].indexOf("!")===0?5:4,ke=je+x[1].length+Oe;x[2]=x[2].substring(0,Oe),x[0]=x[0].substring(0,ke).trim(),x[3]=""}}var Ae=x[2],Ne="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);U&&(Ae=U[1],Ne=U[3])}else Ne=x[3]?x[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ue)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),M(x,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},ce.reflink=function(H,x){var ue;if((ue=this.rules.inline.reflink.exec(H))||(ue=this.rules.inline.nolink.exec(H))){var me=(ue[2]||ue[1]).replace(/\s+/g," ");if(me=x[me.toLowerCase()],!me||!me.href){var Oe=ue[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return M(ue,me,ue[0],this.lexer)}},ce.emStrong=function(H,x,ue){ue===void 0&&(ue="");var me=this.rules.inline.emStrong.lDelim.exec(H);if(me&&!(me[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=me[1]||me[2]||"";if(!Oe||Oe&&(ue===""||this.rules.inline.punctuation.exec(ue))){var je=me[0].length-1,ke,Ae,Ne=je,U=0,B=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,x=x.slice(-1*H.length+je);(me=B.exec(x))!=null;)if(ke=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!ke){if(Ae=ke.length,me[3]||me[4]){Ne+=Ae;continue}else if((me[5]||me[6])&&je%3&&!((je+Ae)%3)){U+=Ae;continue}if(Ne-=Ae,!(Ne>0)){if(Ae=Math.min(Ae,Ae+Ne+U),Math.min(je,Ae)%2){var G=H.slice(1,je+me.index+Ae);return{type:"em",raw:H.slice(0,je+me.index+Ae+1),text:G,tokens:this.lexer.inlineTokens(G)}}var Q=H.slice(2,je+me.index+Ae-1);return{type:"strong",raw:H.slice(0,je+me.index+Ae+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},ce.codespan=function(H){var x=this.rules.inline.code.exec(H);if(x){var ue=x[2].replace(/\n/g," "),me=/[^ ]/.test(ue),Oe=/^ /.test(ue)&&/ $/.test(ue);return me&&Oe&&(ue=ue.substring(1,ue.length-1)),ue=d(ue,!0),{type:"codespan",raw:x[0],text:ue}}},ce.br=function(H){var x=this.rules.inline.br.exec(H);if(x)return{type:"br",raw:x[0]}},ce.del=function(H){var x=this.rules.inline.del.exec(H);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},ce.autolink=function(H,x){var ue=this.rules.inline.autolink.exec(H);if(ue){var me,Oe;return ue[2]==="@"?(me=d(this.options.mangle?x(ue[1]):ue[1]),Oe="mailto:"+me):(me=d(ue[1]),Oe=me),{type:"link",raw:ue[0],text:me,href:Oe,tokens:[{type:"text",raw:me,text:me}]}}},ce.url=function(H,x){var ue;if(ue=this.rules.inline.url.exec(H)){var me,Oe;if(ue[2]==="@")me=d(this.options.mangle?x(ue[0]):ue[0]),Oe="mailto:"+me;else{var je;do je=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(je!==ue[0]);me=d(ue[0]),ue[1]==="www."?Oe="http://"+me:Oe=me}return{type:"link",raw:ue[0],text:me,href:Oe,tokens:[{type:"text",raw:me,text:me}]}}},ce.inlineText=function(H,x){var ue=this.rules.inline.text.exec(H);if(ue){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):d(ue[0]):ue[0]:me=d(this.options.smartypants?x(ue[0]):ue[0]),{type:"text",raw:ue[0],text:me}}},ne}(),J={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};J._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,J._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,J.def=h(J.def).replace("label",J._label).replace("title",J._title).getRegex(),J.bullet=/(?:[*+-]|\d{1,9}[.)])/,J.listItemStart=h(/^( *)(bull) */).replace("bull",J.bullet).getRegex(),J.list=h(J.list).replace(/bull/g,J.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+J.def.source+")").getRegex(),J._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",J._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,J.html=h(J.html,"i").replace("comment",J._comment).replace("tag",J._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),J.paragraph=h(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",J._tag).getRegex(),J.blockquote=h(J.blockquote).replace("paragraph",J.paragraph).getRegex(),J.normal=D({},J),J.gfm=D({},J.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),J.gfm.table=h(J.gfm.table).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",J._tag).getRegex(),J.gfm.paragraph=h(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",J.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",J._tag).getRegex(),J.pedantic=D({},J.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",J._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:h(J.normal._paragraph).replace("hr",J.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",J.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=h(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=h(J._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=h(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=h(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=h(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=h(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=h(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=h(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=h(z.reflink).replace("label",z._label).replace("ref",J._label).getRegex(),z.nolink=h(z.nolink).replace("ref",J._label).getRegex(),z.reflinkSearch=h(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=D({},z),z.pedantic=D({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=D({},z.normal,{escape:h(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=h(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=D({},z.gfm,{br:h(z.br).replace("{2,}","*").getRegex(),text:h(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function A(ne){return ne.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ne){var ce="",oe,H,x=ne.length;for(oe=0;oe<x;oe++)H=ne.charCodeAt(oe),Math.random()>.5&&(H="x"+H.toString(16)),ce+="&#"+H+";";return ce}var Z=function(){function ne(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||_.defaults,this.options.tokenizer=this.options.tokenizer||new K,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:J.normal,inline:z.normal};this.options.pedantic?(H.block=J.pedantic,H.inline=z.pedantic):this.options.gfm&&(H.block=J.gfm,this.options.breaks?H.inline=z.breaks:H.inline=z.gfm),this.tokenizer.rules=H}ne.lex=function(H,x){var ue=new ne(x);return ue.lex(H)},ne.lexInline=function(H,x){var ue=new ne(x);return ue.inlineTokens(H)};var ce=ne.prototype;return ce.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},ce.blockTokens=function(H,x){var ue=this;x===void 0&&(x=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(Ne,U,B){return U+"    ".repeat(B.length)});for(var me,Oe,je,ke;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(me=Ne.call({lexer:ue},H,x))?(H=H.substring(me.raw.length),x.push(me),!0):!1}))){if(me=this.tokenizer.space(H)){H=H.substring(me.raw.length),me.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(me);continue}if(me=this.tokenizer.code(H)){H=H.substring(me.raw.length),Oe=x[x.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+me.raw,Oe.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):x.push(me);continue}if(me=this.tokenizer.fences(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.heading(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.hr(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.blockquote(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.list(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.html(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.def(H)){H=H.substring(me.raw.length),Oe=x[x.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+me.raw,Oe.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.lheading(H)){H=H.substring(me.raw.length),x.push(me);continue}if(je=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,U=H.slice(1),B=void 0;ue.options.extensions.startBlock.forEach(function(G){B=G.call({lexer:this},U),typeof B=="number"&&B>=0&&(Ne=Math.min(Ne,B))}),Ne<1/0&&Ne>=0&&(je=H.substring(0,Ne+1))}(),this.state.top&&(me=this.tokenizer.paragraph(je))){Oe=x[x.length-1],ke&&Oe.type==="paragraph"?(Oe.raw+=`
`+me.raw,Oe.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):x.push(me),ke=je.length!==H.length,H=H.substring(me.raw.length);continue}if(me=this.tokenizer.text(H)){H=H.substring(me.raw.length),Oe=x[x.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+me.raw,Oe.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):x.push(me);continue}if(H){var Ae="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,x},ce.inline=function(H,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:H,tokens:x}),x},ce.inlineTokens=function(H,x){var ue=this;x===void 0&&(x=[]);var me,Oe,je,ke=H,Ae,Ne,U;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)B.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ae.index)+"["+f("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"["+f("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(Ne||(U=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(me=Q.call({lexer:ue},H,x))?(H=H.substring(me.raw.length),x.push(me),!0):!1}))){if(me=this.tokenizer.escape(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.tag(H)){H=H.substring(me.raw.length),Oe=x[x.length-1],Oe&&me.type==="text"&&Oe.type==="text"?(Oe.raw+=me.raw,Oe.text+=me.text):x.push(me);continue}if(me=this.tokenizer.link(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(me.raw.length),Oe=x[x.length-1],Oe&&me.type==="text"&&Oe.type==="text"?(Oe.raw+=me.raw,Oe.text+=me.text):x.push(me);continue}if(me=this.tokenizer.emStrong(H,ke,U)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.codespan(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.br(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.del(H)){H=H.substring(me.raw.length),x.push(me);continue}if(me=this.tokenizer.autolink(H,W)){H=H.substring(me.raw.length),x.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(H,W))){H=H.substring(me.raw.length),x.push(me);continue}if(je=H,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,ee=H.slice(1),fe=void 0;ue.options.extensions.startInline.forEach(function(Re){fe=Re.call({lexer:this},ee),typeof fe=="number"&&fe>=0&&(Q=Math.min(Q,fe))}),Q<1/0&&Q>=0&&(je=H.substring(0,Q+1))}(),me=this.tokenizer.inlineText(je,A)){H=H.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(U=me.raw.slice(-1)),Ne=!0,Oe=x[x.length-1],Oe&&Oe.type==="text"?(Oe.raw+=me.raw,Oe.text+=me.text):x.push(me);continue}if(H){var G="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return x},w(ne,null,[{key:"rules",get:function(){return{block:J,inline:z}}}]),ne}(),he=function(){function ne(oe){this.options=oe||_.defaults}var ce=ne.prototype;return ce.code=function(H,x,ue){var me=(x||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(H,me);Oe!=null&&Oe!==H&&(ue=!0,H=Oe)}return H=H.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+d(me,!0)+'">'+(ue?H:d(H,!0))+`</code></pre>
`:"<pre><code>"+(ue?H:d(H,!0))+`</code></pre>
`},ce.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},ce.html=function(H){return H},ce.heading=function(H,x,ue,me){if(this.options.headerIds){var Oe=this.options.headerPrefix+me.slug(ue);return"<h"+x+' id="'+Oe+'">'+H+"</h"+x+`>
`}return"<h"+x+">"+H+"</h"+x+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(H,x,ue){var me=x?"ol":"ul",Oe=x&&ue!==1?' start="'+ue+'"':"";return"<"+me+Oe+`>
`+H+"</"+me+`>
`},ce.listitem=function(H){return"<li>"+H+`</li>
`},ce.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(H){return"<p>"+H+`</p>
`},ce.table=function(H,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+x+`</table>
`},ce.tablerow=function(H){return`<tr>
`+H+`</tr>
`},ce.tablecell=function(H,x){var ue=x.header?"th":"td",me=x.align?"<"+ue+' align="'+x.align+'">':"<"+ue+">";return me+H+("</"+ue+`>
`)},ce.strong=function(H){return"<strong>"+H+"</strong>"},ce.em=function(H){return"<em>"+H+"</em>"},ce.codespan=function(H){return"<code>"+H+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(H){return"<del>"+H+"</del>"},ce.link=function(H,x,ue){if(H=t(this.options.sanitize,this.options.baseUrl,H),H===null)return ue;var me='<a href="'+d(H)+'"';return x&&(me+=' title="'+x+'"'),me+=">"+ue+"</a>",me},ce.image=function(H,x,ue){if(H=t(this.options.sanitize,this.options.baseUrl,H),H===null)return ue;var me='<img src="'+H+'" alt="'+ue+'"';return x&&(me+=' title="'+x+'"'),me+=this.options.xhtml?"/>":">",me},ce.text=function(H){return H},ne}(),ve=function(){function ne(){}var ce=ne.prototype;return ce.strong=function(H){return H},ce.em=function(H){return H},ce.codespan=function(H){return H},ce.del=function(H){return H},ce.html=function(H){return H},ce.text=function(H){return H},ce.link=function(H,x,ue){return""+ue},ce.image=function(H,x,ue){return""+ue},ce.br=function(){return""},ne}(),be=function(){function ne(){this.seen={}}var ce=ne.prototype;return ce.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(H,x){var ue=H,me=0;if(this.seen.hasOwnProperty(ue)){me=this.seen[H];do me++,ue=H+"-"+me;while(this.seen.hasOwnProperty(ue))}return x||(this.seen[H]=me,this.seen[ue]=0),ue},ce.slug=function(H,x){x===void 0&&(x={});var ue=this.serialize(H);return this.getNextSafeSlug(ue,x.dryrun)},ne}(),de=function(){function ne(oe){this.options=oe||_.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new be}ne.parse=function(H,x){var ue=new ne(x);return ue.parse(H)},ne.parseInline=function(H,x){var ue=new ne(x);return ue.parseInline(H)};var ce=ne.prototype;return ce.parse=function(H,x){x===void 0&&(x=!0);var ue="",me,Oe,je,ke,Ae,Ne,U,B,G,Q,ee,fe,Re,Ue,Qe,Ye,it,ot,tt,at=H.length;for(me=0;me<at;me++){if(Q=H[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(tt=this.options.extensions.renderers[Q.type].call({parser:this},Q),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){ue+=tt||"";continue}switch(Q.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,o(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(B="",U="",ke=Q.header.length,Oe=0;Oe<ke;Oe++)U+=this.renderer.tablecell(this.parseInline(Q.header[Oe].tokens),{header:!0,align:Q.align[Oe]});for(B+=this.renderer.tablerow(U),G="",ke=Q.rows.length,Oe=0;Oe<ke;Oe++){for(Ne=Q.rows[Oe],U="",Ae=Ne.length,je=0;je<Ae;je++)U+=this.renderer.tablecell(this.parseInline(Ne[je].tokens),{header:!1,align:Q.align[je]});G+=this.renderer.tablerow(U)}ue+=this.renderer.table(B,G);continue}case"blockquote":{G=this.parse(Q.tokens),ue+=this.renderer.blockquote(G);continue}case"list":{for(ee=Q.ordered,fe=Q.start,Re=Q.loose,ke=Q.items.length,G="",Oe=0;Oe<ke;Oe++)Qe=Q.items[Oe],Ye=Qe.checked,it=Qe.task,Ue="",Qe.task&&(ot=this.renderer.checkbox(Ye),Re?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=ot+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=ot+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:ot}):Ue+=ot),Ue+=this.parse(Qe.tokens,Re),G+=this.renderer.listitem(Ue,it,Ye);ue+=this.renderer.list(G,ee,fe);continue}case"html":{ue+=this.renderer.html(Q.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(G=Q.tokens?this.parseInline(Q.tokens):Q.text;me+1<at&&H[me+1].type==="text";)Q=H[++me],G+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);ue+=x?this.renderer.paragraph(G):G;continue}default:{var pt='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return ue},ce.parseInline=function(H,x){x=x||this.renderer;var ue="",me,Oe,je,ke=H.length;for(me=0;me<ke;me++){if(Oe=H[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(je=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),je!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){ue+=je||"";continue}switch(Oe.type){case"escape":{ue+=x.text(Oe.text);break}case"html":{ue+=x.html(Oe.text);break}case"link":{ue+=x.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,x));break}case"image":{ue+=x.image(Oe.href,Oe.title,Oe.text);break}case"strong":{ue+=x.strong(this.parseInline(Oe.tokens,x));break}case"em":{ue+=x.em(this.parseInline(Oe.tokens,x));break}case"codespan":{ue+=x.codespan(Oe.text);break}case"br":{ue+=x.br();break}case"del":{ue+=x.del(this.parseInline(Oe.tokens,x));break}case"text":{ue+=x.text(Oe.text);break}default:{var Ae='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ue},ne}();function $e(ne,ce,oe){if(typeof ne>"u"||ne===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");if(typeof ce=="function"&&(oe=ce,ce=null),ce=D({},$e.defaults,ce||{}),p(ce),oe){var H=ce.highlight,x;try{x=Z.lex(ne,ce)}catch(ke){return oe(ke)}var ue=function(Ae){var Ne;if(!Ae)try{ce.walkTokens&&$e.walkTokens(x,ce.walkTokens),Ne=de.parse(x,ce)}catch(U){Ae=U}return ce.highlight=H,Ae?oe(Ae):oe(null,Ne)};if(!H||H.length<3||(delete ce.highlight,!x.length))return ue();var me=0;$e.walkTokens(x,function(ke){ke.type==="code"&&(me++,setTimeout(function(){H(ke.text,ke.lang,function(Ae,Ne){if(Ae)return ue(Ae);Ne!=null&&Ne!==ke.text&&(ke.text=Ne,ke.escaped=!0),me--,me===0&&ue()})},0))}),me===0&&ue();return}function Oe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var je=Z.lex(ne,ce);if(ce.walkTokens){if(ce.async)return Promise.all($e.walkTokens(je,ce.walkTokens)).then(function(){return de.parse(je,ce)}).catch(Oe);$e.walkTokens(je,ce.walkTokens)}return de.parse(je,ce)}catch(ke){Oe(ke)}}$e.options=$e.setOptions=function(ne){return D($e.defaults,ne),N($e.defaults),$e},$e.getDefaults=R,$e.defaults=_.defaults,$e.use=function(){for(var ne=arguments.length,ce=new Array(ne),oe=0;oe<ne;oe++)ce[oe]=arguments[oe];var H=D.apply(void 0,[{}].concat(ce)),x=$e.defaults.extensions||{renderers:{},childTokens:{}},ue;ce.forEach(function(me){if(me.extensions&&(ue=!0,me.extensions.forEach(function(je){if(!je.name)throw new Error("extension name required");if(je.renderer){var ke=x.renderers?x.renderers[je.name]:null;ke?x.renderers[je.name]=function(){for(var Ae=arguments.length,Ne=new Array(Ae),U=0;U<Ae;U++)Ne[U]=arguments[U];var B=je.renderer.apply(this,Ne);return B===!1&&(B=ke.apply(this,Ne)),B}:x.renderers[je.name]=je.renderer}if(je.tokenizer){if(!je.level||je.level!=="block"&&je.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[je.level]?x[je.level].unshift(je.tokenizer):x[je.level]=[je.tokenizer],je.start&&(je.level==="block"?x.startBlock?x.startBlock.push(je.start):x.startBlock=[je.start]:je.level==="inline"&&(x.startInline?x.startInline.push(je.start):x.startInline=[je.start]))}je.childTokens&&(x.childTokens[je.name]=je.childTokens)})),me.renderer&&function(){var je=$e.defaults.renderer||new he,ke=function(U){var B=je[U];je[U]=function(){for(var G=arguments.length,Q=new Array(G),ee=0;ee<G;ee++)Q[ee]=arguments[ee];var fe=me.renderer[U].apply(je,Q);return fe===!1&&(fe=B.apply(je,Q)),fe}};for(var Ae in me.renderer)ke(Ae);H.renderer=je}(),me.tokenizer&&function(){var je=$e.defaults.tokenizer||new K,ke=function(U){var B=je[U];je[U]=function(){for(var G=arguments.length,Q=new Array(G),ee=0;ee<G;ee++)Q[ee]=arguments[ee];var fe=me.tokenizer[U].apply(je,Q);return fe===!1&&(fe=B.apply(je,Q)),fe}};for(var Ae in me.tokenizer)ke(Ae);H.tokenizer=je}(),me.walkTokens){var Oe=$e.defaults.walkTokens;H.walkTokens=function(je){var ke=[];return ke.push(me.walkTokens.call(this,je)),Oe&&(ke=ke.concat(Oe.call(this,je))),ke}}ue&&(H.extensions=x),$e.setOptions(H)})},$e.walkTokens=function(ne,ce){for(var oe=[],H=function(){var Oe=ue.value;switch(oe=oe.concat(ce.call($e,Oe)),Oe.type){case"table":{for(var je=O(Oe.header),ke;!(ke=je()).done;){var Ae=ke.value;oe=oe.concat($e.walkTokens(Ae.tokens,ce))}for(var Ne=O(Oe.rows),U;!(U=Ne()).done;)for(var B=U.value,G=O(B),Q;!(Q=G()).done;){var ee=Q.value;oe=oe.concat($e.walkTokens(ee.tokens,ce))}break}case"list":{oe=oe.concat($e.walkTokens(Oe.items,ce));break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[Oe.type]?$e.defaults.extensions.childTokens[Oe.type].forEach(function(fe){oe=oe.concat($e.walkTokens(Oe[fe],ce))}):Oe.tokens&&(oe=oe.concat($e.walkTokens(Oe.tokens,ce)))}},x=O(ne),ue;!(ue=x()).done;)H();return oe},$e.parseInline=function(ne,ce){if(typeof ne>"u"||ne===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");ce=D({},$e.defaults,ce||{}),p(ce);try{var oe=Z.lexInline(ne,ce);return ce.walkTokens&&$e.walkTokens(oe,ce.walkTokens),de.parseInline(oe,ce)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+d(H.message+"",!0)+"</pre>";throw H}},$e.Parser=de,$e.parser=de.parse,$e.Renderer=he,$e.TextRenderer=ve,$e.Lexer=Z,$e.lexer=Z.lex,$e.Tokenizer=K,$e.Slugger=be,$e.parse=$e;var ye=$e.options,Y=$e.setOptions,we=$e.use,Te=$e.walkTokens,re=$e.parseInline,q=$e,ae=de.parse,le=Z.lex;_.Lexer=Z,_.Parser=de,_.Renderer=he,_.Slugger=be,_.TextRenderer=ve,_.Tokenizer=K,_.getDefaults=R,_.lexer=le,_.marked=$e,_.options=ye,_.parse=q,_.parseInline=re,_.parser=ae,_.setOptions=Y,_.use=we,_.walkTokens=Te,Object.defineProperty(_,"__esModule",{value:!0})}),define(Ie[138],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=w;function w(n){const o=O(n);if(o&&o.length>0)return new Uint32Array(o)}let y=0;const k=new Uint32Array(10);function O(n){if(y=0,R(n,E,v.InitialConsonant),y>0||(R(n,u,v.Vowel),y>0)||(R(n,C,v.FinalConsonant),y>0)||(R(n,d,v.CompatibilityJamo),y))return k.subarray(0,y);if(n>=44032&&n<=55203){const o=n-44032,c=o%588,h=Math.floor(o/588),i=Math.floor(c/28),r=c%28-1;if(h<E.length?R(h,E,0):v.InitialConsonant+h-v.CompatibilityJamo<d.length&&R(v.InitialConsonant+h,d,v.CompatibilityJamo),i<u.length?R(i,u,0):v.Vowel+i-v.CompatibilityJamo<d.length&&R(v.Vowel+i-v.CompatibilityJamo,d,v.CompatibilityJamo),r>=0&&(r<C.length?R(r,C,0):v.FinalConsonant+r-v.CompatibilityJamo<d.length&&R(v.FinalConsonant+r-v.CompatibilityJamo,d,v.CompatibilityJamo)),y>0)return k.subarray(0,y)}}function R(n,o,c){n>=c&&n<c+o.length&&N(o[n-c])}function N(n){n!==s.NUL&&(k[y++]=n&255,n>>8&&(k[y++]=n>>8&255),n>>16&&(k[y++]=n>>16&255))}var v;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var s;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(s||(s={}));var I;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(I||(I={}));const E=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),u=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l]),C=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,I.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),d=new Uint16Array([s.r,s.R,I.rt,s.s,I.sw,I.sg,s.e,s.E,s.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,s.a,s.q,s.Q,I.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,I.hk,I.ho,I.hl,s.y,s.n,I.nj,I.np,I.nl,s.b,s.m,I.ml,s.l])}),define(Ie[139],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=void 0,e.$Lm=w,e.rot=y,e.$Qm=N;function w(v,s,I){return Math.min(Math.max(v,s),I)}function y(v,s){return(s+v%s)%s}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Nm=k;class O{constructor(){this.a=1,this.b=0}update(s){return this.b=this.b+(s-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Om=O;class R{constructor(s){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(s),this.c.fill(0,0,s)}update(s){const I=this.c[this.d];return this.c[this.d]=s,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=s,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pm=R;function N(v,s,I,E,u,C,d,n){const o=d-I,c=n-E,h=u-I,i=C-E,r=v-I,t=s-E,a=o*o+c*c,l=o*h+c*i,g=o*r+c*t,m=h*h+i*i,$=h*r+i*t,S=1/(a*m-l*l),D=(m*g-l*$)*S,b=(a*$-l*g)*S;return D>=0&&b>=0&&D+b<1}}),define(Ie[140],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=void 0,e.$ed=O,e.$fd=u;class w{constructor(d,n,o){this.owner=d,this.debugNameSource=n,this.referenceFn=o}getDebugName(d){return O(d,this)}}e.$dd=w;const y=new Map,k=new WeakMap;function O(C,d){const n=k.get(C);if(n)return n;const o=R(C,d);if(o){let c=y.get(o)??0;c++,y.set(o,c);const h=c===1?o:`${o}#${c}`;return k.set(C,h),h}}function R(C,d){const n=k.get(C);if(n)return n;const o=d.owner?I(d.owner)+".":"";let c;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(c=h(),c!==void 0)return o+c}else return o+h;const i=d.referenceFn;if(i!==void 0&&(c=u(i),c!==void 0))return o+c;if(d.owner!==void 0){const r=N(d.owner,C);if(r!==void 0)return o+r}}function N(C,d){for(const n in C)if(C[n]===d)return n}const v=new Map,s=new WeakMap;function I(C){const d=s.get(C);if(d)return d;const n=E(C);let o=v.get(n)??0;o++,v.set(n,o);const c=o===1?n:`${n}#${o}`;return s.set(C,c),c}function E(C){const d=C.constructor;return d?d.name:"Object"}function u(C){const d=C.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(Ie[141],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Md=y,e.$Nd=k;let w;function y(n){w=n}function k(){return w}class O{constructor(){this.a=0,this.d=new WeakMap}b(o){return R([N(C("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[N(" "),s(I(o.oldValue,70),{color:"red",strikeThrough:!0}),N(" "),s(I(o.newValue,60),{color:"green"})]:[N(" (unchanged)")]:[N(" "),s(I(o.newValue,60),{color:"green"}),N(" (initial)")]}handleObservableChanged(o,c){console.log(...this.b([v("observable value changed"),s(o.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(o){if(o.size!==0)return s(" (changed deps: "+[...o].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,i)=>(this.d.get(o).add(h),c.apply(o,[h,i]))}handleDerivedRecomputed(o,c){const h=this.d.get(o);console.log(...this.b([v("derived recomputed"),s(o.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(h),{data:[{fn:o._debugNameData.referenceFn??o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,c){console.log(...this.b([v("observable from event triggered"),s(o.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,i)=>(this.d.get(o).add(h),c.apply(o,[h,i]))}handleAutorunTriggered(o){const c=this.d.get(o);console.log(...this.b([v("autorun"),s(o.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:o._debugNameData.referenceFn??o._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let c=o.getDebugName();c===void 0&&(c=""),console.log(...this.b([v("transaction"),s(c,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Od=O;function R(n){const o=new Array,c=[];let h="";function i(t){if("length"in t)for(const a of t)a&&i(a);else"text"in t?(h+=`%c${t.text}`,o.push(t.style),t.data&&c.push(...t.data)):"data"in t&&c.push(...t.data)}i(n);const r=[h,...o];return r.push(...c),r}function N(n){return s(n,{color:"black"})}function v(n){return s(d(`${n}: `,10),{color:"black",bold:!0})}function s(n,o={color:"black"}){function c(i){return Object.entries(i).reduce((r,[t,a])=>`${r}${t}:${a};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:n,style:c(h)}}function I(n,o){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=o?`"${n}"`:`"${n.substr(0,o-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?E(n,o):u(n,o);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function E(n,o){let c="[ ",h=!0;for(const i of n){if(h||(c+=", "),c.length-5>o){c+="...";break}h=!1,c+=`${I(i,o-c.length)}`}return c+=" ]",c}function u(n,o){let c="{ ",h=!0;for(const[i,r]of Object.entries(n)){if(h||(c+=", "),c.length-5>o){c+="...";break}h=!1,c+=`${i}: ${I(r,o-c.length)}`}return c+=" }",c}function C(n,o){let c="";for(let h=1;h<=o;h++)c+=n;return c}function d(n,o){for(;n.length<o;)n+=" ";return n}}),define(Ie[142],Pe([1,0,135,140,141]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$9d=e.$7d=e.$2d=e.$1d=void 0,e.$Xd=R,e.$Yd=v,e.$Zd=I,e.$3d=C,e.$4d=n,e.$5d=o,e.$6d=c,e.$8d=i,e.$0d=t;let O;function R(l){O=l}let N;function v(l){N=l}let s;function I(l){s=l}class E{get TChange(){return null}reportChanges(){this.get()}read(g){return g?g.readObservable(this):this.get()}map(g,m){const $=m===void 0?void 0:g,S=m===void 0?g:m;return s({owner:$,debugName:()=>{const D=(0,y.$fd)(S);if(D!==void 0)return D;const T=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(T)return`${this.debugName}.${T[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:S},D=>S(this.read(D),D))}recomputeInitiallyAndOnChange(g,m){return g.add(O(this,m)),this}keepObserved(g){return g.add(N(this)),this}get a(){return this.get()}}e.$1d=E;class u extends E{constructor(){super(...arguments),this.b=new Set}addObserver(g){const m=this.b.size;this.b.add(g),m===0&&this.c()}removeObserver(g){this.b.delete(g)&&this.b.size===0&&this.f()}c(){}f(){}}e.$2d=u;function C(l,g){const m=new h(l,g);try{l(m)}finally{m.finish()}}let d;function n(l){if(d)l(d);else{const g=new h(l,void 0);d=g;try{l(g)}finally{g.finish(),d=void 0}}}async function o(l,g){const m=new h(l,g);try{await l(m)}finally{m.finish()}}function c(l,g,m){l?g(l):C(g,m)}class h{constructor(g,m){this._fn=g,this.b=m,this.a=[],(0,k.$Nd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,y.$fd)(this._fn)}updateObserver(g,m){this.a.push({observer:g,observable:m}),g.beginUpdate(m)}finish(){const g=this.a;for(let m=0;m<g.length;m++){const{observer:$,observable:S}=g[m];$.endUpdate(S)}this.a=null,(0,k.$Nd)()?.handleEndTransaction()}}e.$7d=h;function i(l,g){let m;return typeof l=="string"?m=new y.$dd(void 0,l,void 0):m=new y.$dd(l,void 0,void 0),new r(m,g,w.$9c)}class r extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(g,m,$){super(),this.e=g,this.g=$,this.d=m}get(){return this.d}set(g,m,$){if($===void 0&&this.g(this.d,g))return;let S;m||(m=S=new h(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(g),(0,k.$Nd)()?.handleObservableChanged(this,{oldValue:D,newValue:g,change:$,didChange:!0,hadValue:!0});for(const b of this.b)m.updateObserver(b,this),b.handleChange(this,$)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(g){this.d=g}}e.$9d=r;function t(l,g){let m;return typeof l=="string"?m=new y.$dd(void 0,l,void 0):m=new y.$dd(l,void 0,void 0),new a(m,g,w.$9c)}class a extends r{h(g){this.d!==g&&(this.d&&this.d.dispose(),this.d=g)}dispose(){this.d?.dispose()}}e.$$d=a}),function(){function _(k){const O=[];typeof k=="number"&&O.push("code/timeOrigin",k);function R(v){O.push(v,Date.now())}function N(){const v=[];for(let s=0;s<O.length;s+=2)v.push({name:O[s],startTime:O[s+1]});return v}return{mark:R,getMarks:N}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const R of performance.getEntriesByType("mark"))O.push({name:R.name,startTime:Math.round(k+R.startTime)});return O}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var y;typeof global=="object"?y=global:typeof self=="object"?y=self:y={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(y)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(y):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),y.perf=w(y))}(),define(Ie[143],Pe([1,0,40]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=void 0;const y=Symbol("unset");class k{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||w.Iterable.empty()}insert(v,s,I){this.d(v,E=>E._value=s,I)}mutate(v,s){this.d(v,I=>I._value=s(I._value===y?void 0:I._value))}mutatePath(v,s){this.d(v,()=>{},I=>s(I))}delete(v){const s=this.c(v);if(!s)return;let I=s.length-1;const E=s[I].node._value;if(E!==y){for(this.b--,s[I].node._value=y;I>0;I--){const{node:u,part:C}=s[I];if(u.children?.size||u._value!==y)break;s[I-1].node.children.delete(C)}return E}}*deleteRecursive(v){const s=this.c(v);if(!s)return;const I=s[s.length-1].node;for(let E=s.length-1;E>0;E--){const u=s[E-1];if(u.node.children.delete(s[E].part),u.node.children.size>0||u.node._value!==y)break}for(const E of O(I))E._value!==y&&(this.b--,yield E._value)}find(v){let s=this.a;for(const I of v){const E=s.children?.get(I);if(!E)return;s=E}return s._value===y?void 0:s._value}hasKeyOrParent(v){let s=this.a;for(const I of v){const E=s.children?.get(I);if(!E)return!1;if(E._value!==y)return!0;s=E}return!1}hasKeyOrChildren(v){let s=this.a;for(const I of v){const E=s.children?.get(I);if(!E)return!1;s=E}return!0}hasKey(v){let s=this.a;for(const I of v){const E=s.children?.get(I);if(!E)return!1;s=E}return s._value!==y}c(v){const s=[{part:"",node:this.a}];let I=0;for(const E of v){const u=s[I].node.children?.get(E);if(!u)return;s.push({part:E,node:u}),I++}return s}d(v,s,I){let E=this.a;for(const d of v){if(E.children)if(E.children.has(d))E=E.children.get(d);else{const n=new R;E.children.set(d,n),E=n}else{const n=new R;E.children=new Map([[d,n]]),E=n}I?.(E)}const u=E._value===y?0:1;s(E);const C=E._value===y?0:1;this.b+=C-u}*values(){for(const{_value:v}of O(this.a))v!==y&&(yield v)}}e.$TI=k;function*O(N){const v=[N];for(;v.length>0;){const s=v.pop();if(yield s,s.children)for(const I of s.children.values())v.push(I)}}class R{constructor(){this._value=y}get value(){return this._value===y?void 0:this._value}set value(v){this._value=v===void 0?y:v}}}),define(Ie[144],Pe([1,0,48,20]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=N,e.$Ar=v,e.$Br=s,e.$Cr=I,e.$Dr=E,e.$Er=u,e.$Fr=C,e.$Gr=d,e.$Hr=n,e.$Ir=o,e.$Jr=$,e.$Kr=S,e.$Lr=D;const k=new w.$X(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),O=new w.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new w.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function N(b,T,P=!1){const p=b||"",f=T||"",M=k.value.collator.compare(p,f);return k.value.collatorIsNumeric&&M===0&&p!==f?p<f?-1:1:M}function v(b,T){const P=O.value.collator;return b=b||"",T=T||"",r(P,b,T)}function s(b,T){const P=O.value.collator;return b=b||"",T=T||"",g(b,T)||r(P,b,T)}function I(b,T){const P=O.value.collator;return b=b||"",T=T||"",l(b,T)||r(P,b,T)}function E(b,T){return b=b||"",T=T||"",b===T?0:b<T?-1:1}function u(b,T){const[P,p]=h(b),[f,M]=h(T);let L=k.value.collator.compare(p,M);if(L===0){if(k.value.collatorIsNumeric&&p!==M)return p<M?-1:1;if(L=k.value.collator.compare(P,f),k.value.collatorIsNumeric&&L===0&&P!==f)return P<f?-1:1}return L}function C(b,T){b=b||"",T=T||"";const P=i(b),p=i(T),f=O.value.collator,M=R.value.collator;return r(M,P,p)||r(f,b,T)}function d(b,T){b=b||"",T=T||"";const P=i(b),p=i(T),f=O.value.collator,M=R.value.collator;return r(M,P,p)||g(b,T)||r(f,b,T)}function n(b,T){b=b||"",T=T||"";const P=i(b),p=i(T),f=O.value.collator,M=R.value.collator;return r(M,P,p)||l(b,T)||r(f,b,T)}function o(b,T){b=b||"",T=T||"";const P=i(b).toLowerCase(),p=i(T).toLowerCase();return P!==p?P<p?-1:1:b!==T?b<T?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function h(b,T=!1){const P=b?c.exec(b):[];let p=[P&&P[1]||"",P&&P[3]||""];return T&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function i(b){const T=b?c.exec(b):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function r(b,T,P){const p=b.compare(T,P);return p!==0?p:T.length!==P.length?T.length<P.length?-1:1:0}function t(b){const T=b.charAt(0);return T.toLocaleUpperCase()!==T}function a(b){const T=b.charAt(0);return T.toLocaleLowerCase()!==T}function l(b,T){return t(b)&&a(T)?-1:a(b)&&t(T)?1:0}function g(b,T){return a(b)&&t(T)?-1:t(b)&&a(T)?1:0}function m(b,T,P=!1){return P||(b=b&&b.toLowerCase(),T=T&&T.toLowerCase()),b===T?0:b<T?-1:1}function $(b,T,P=!1){const p=b.split(y.sep),f=T.split(y.sep),M=p.length-1,L=f.length-1;let K,J;for(let z=0;;z++){if(K=M===z,J=L===z,K&&J)return N(p[z],f[z],P);if(K)return-1;if(J)return 1;const A=m(p[z],f[z],P);if(A!==0)return A}}function S(b,T,P){const p=b.toLowerCase(),f=T.toLowerCase(),M=D(b,T,P);if(M)return M;const L=p.endsWith(P),K=f.endsWith(P);if(L!==K)return L?-1:1;const J=N(p,f);return J!==0?J:p.localeCompare(f)}function D(b,T,P){const p=b.toLowerCase(),f=T.toLowerCase(),M=p.startsWith(P),L=f.startsWith(P);if(M!==L)return M?-1:1;if(M&&L){if(p.length<f.length)return-1;if(p.length>f.length)return 1}return 0}}),define(Ie[73],Pe([1,0,20]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$$s=O,e.$_s=R,e.$at=N,e.$bt=s,e.$0s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(I){const E=(0,w.$rc)(I),u=y[E.toLowerCase()];return u!==void 0?u:R(I)}function R(I){const E=(0,w.$rc)(I);return k[E.toLowerCase()]}function N(I){for(const E in k)if(k[E]===I)return E}const v=/^(.+)\/(.+?)(;.+)?$/;function s(I,E){const u=v.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:E?void 0:I}}),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var y in w)(typeof exports=="object"?exports:_)[y]=w[y]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function w(y){if(e[y])return e[y].exports;var k=e[y]={i:y,l:!1,exports:{}};return _[y].call(k.exports,k,k.exports,w),k.l=!0,k.exports}return w.m=_,w.c=e,w.d=function(y,k,O){w.o(y,k)||Object.defineProperty(y,k,{enumerable:!0,get:O})},w.r=function(y){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(y,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(y,"__esModule",{value:!0})},w.t=function(y,k){if(1&k&&(y=w(y)),8&k||4&k&&typeof y=="object"&&y&&y.__esModule)return y;var O=Object.create(null);if(w.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:y}),2&k&&typeof y!="string")for(var R in y)w.d(O,R,function(N){return y[N]}.bind(null,R));return O},w.n=function(y){var k=y&&y.__esModule?function(){return y.default}:function(){return y};return w.d(k,"a",k),k},w.o=function(y,k){return Object.prototype.hasOwnProperty.call(y,k)},w.p="",w(w.s=0)}([function(_,e,w){(function(y){var k;e=_.exports=we,k=typeof y=="object"&&y.env&&y.env.NODE_DEBUG&&/\bsemver\b/i.test(y.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,N=e.re=[],v=e.src=[],s=0,I=s++;v[I]="0|[1-9]\\d*";var E=s++;v[E]="[0-9]+";var u=s++;v[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=s++;v[C]="("+v[I]+")\\.("+v[I]+")\\.("+v[I]+")";var d=s++;v[d]="("+v[E]+")\\.("+v[E]+")\\.("+v[E]+")";var n=s++;v[n]="(?:"+v[I]+"|"+v[u]+")";var o=s++;v[o]="(?:"+v[E]+"|"+v[u]+")";var c=s++;v[c]="(?:-("+v[n]+"(?:\\."+v[n]+")*))";var h=s++;v[h]="(?:-?("+v[o]+"(?:\\."+v[o]+")*))";var i=s++;v[i]="[0-9A-Za-z-]+";var r=s++;v[r]="(?:\\+("+v[i]+"(?:\\."+v[i]+")*))";var t=s++,a="v?"+v[C]+v[c]+"?"+v[r]+"?";v[t]="^"+a+"$";var l="[v=\\s]*"+v[d]+v[h]+"?"+v[r]+"?",g=s++;v[g]="^"+l+"$";var m=s++;v[m]="((?:<|>)?=?)";var $=s++;v[$]=v[E]+"|x|X|\\*";var S=s++;v[S]=v[I]+"|x|X|\\*";var D=s++;v[D]="[v=\\s]*("+v[S]+")(?:\\.("+v[S]+")(?:\\.("+v[S]+")(?:"+v[c]+")?"+v[r]+"?)?)?";var b=s++;v[b]="[v=\\s]*("+v[$]+")(?:\\.("+v[$]+")(?:\\.("+v[$]+")(?:"+v[h]+")?"+v[r]+"?)?)?";var T=s++;v[T]="^"+v[m]+"\\s*"+v[D]+"$";var P=s++;v[P]="^"+v[m]+"\\s*"+v[b]+"$";var p=s++;v[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var f=s++;v[f]="(?:~>?)";var M=s++;v[M]="(\\s*)"+v[f]+"\\s+",N[M]=new RegExp(v[M],"g");var L=s++;v[L]="^"+v[f]+v[D]+"$";var K=s++;v[K]="^"+v[f]+v[b]+"$";var J=s++;v[J]="(?:\\^)";var z=s++;v[z]="(\\s*)"+v[J]+"\\s+",N[z]=new RegExp(v[z],"g");var A=s++;v[A]="^"+v[J]+v[D]+"$";var W=s++;v[W]="^"+v[J]+v[b]+"$";var Z=s++;v[Z]="^"+v[m]+"\\s*("+l+")$|^$";var he=s++;v[he]="^"+v[m]+"\\s*("+a+")$|^$";var ve=s++;v[ve]="(\\s*)"+v[m]+"\\s*("+l+"|"+v[D]+")",N[ve]=new RegExp(v[ve],"g");var be=s++;v[be]="^\\s*("+v[D]+")\\s+-\\s+("+v[D]+")\\s*$";var de=s++;v[de]="^\\s*("+v[b]+")\\s+-\\s+("+v[b]+")\\s*$";var $e=s++;v[$e]="(<|>)?=?\\s*\\*";for(var ye=0;ye<35;ye++)k(ye,v[ye]),N[ye]||(N[ye]=new RegExp(v[ye]));function Y(B,G){if(B instanceof we)return B;if(typeof B!="string"||B.length>O||!(G?N[g]:N[t]).test(B))return null;try{return new we(B,G)}catch{return null}}function we(B,G){if(B instanceof we){if(B.loose===G)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof we))return new we(B,G);k("SemVer",B,G),this.loose=G;var Q=B.trim().match(G?N[g]:N[t]);if(!Q)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var fe=+ee;if(fe>=0&&fe<R)return fe}return ee}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=Y,e.valid=function(B,G){var Q=Y(B,G);return Q?Q.version:null},e.clean=function(B,G){var Q=Y(B.trim().replace(/^[=v]+/,""),G);return Q?Q.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(B){return k("SemVer.compare",this.version,this.loose,B),B instanceof we||(B=new we(B,this.loose)),this.compareMain(B)||this.comparePre(B)},we.prototype.compareMain=function(B){return B instanceof we||(B=new we(B,this.loose)),re(this.major,B.major)||re(this.minor,B.minor)||re(this.patch,B.patch)},we.prototype.comparePre=function(B){if(B instanceof we||(B=new we(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var G=0;do{var Q=this.prerelease[G],ee=B.prerelease[G];if(k("prerelease compare",G,Q,ee),Q===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(Q===void 0)return-1;if(Q!==ee)return re(Q,ee)}while(++G)},we.prototype.inc=function(B,G){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,G,Q,ee){typeof Q=="string"&&(ee=Q,Q=void 0);try{return new we(B,Q).inc(G,ee).version}catch{return null}},e.diff=function(B,G){if(ne(B,G))return null;var Q=Y(B),ee=Y(G);if(Q.prerelease.length||ee.prerelease.length){for(var fe in Q)if((fe==="major"||fe==="minor"||fe==="patch")&&Q[fe]!==ee[fe])return"pre"+fe;return"prerelease"}for(var fe in Q)if((fe==="major"||fe==="minor"||fe==="patch")&&Q[fe]!==ee[fe])return fe},e.compareIdentifiers=re;var Te=/^[0-9]+$/;function re(B,G){var Q=Te.test(B),ee=Te.test(G);return Q&&ee&&(B=+B,G=+G),Q&&!ee?-1:ee&&!Q?1:B<G?-1:B>G?1:0}function q(B,G,Q){return new we(B,Q).compare(new we(G,Q))}function ae(B,G,Q){return q(B,G,Q)>0}function le(B,G,Q){return q(B,G,Q)<0}function ne(B,G,Q){return q(B,G,Q)===0}function ce(B,G,Q){return q(B,G,Q)!==0}function oe(B,G,Q){return q(B,G,Q)>=0}function H(B,G,Q){return q(B,G,Q)<=0}function x(B,G,Q,ee){var fe;switch(G){case"===":typeof B=="object"&&(B=B.version),typeof Q=="object"&&(Q=Q.version),fe=B===Q;break;case"!==":typeof B=="object"&&(B=B.version),typeof Q=="object"&&(Q=Q.version),fe=B!==Q;break;case"":case"=":case"==":fe=ne(B,Q,ee);break;case"!=":fe=ce(B,Q,ee);break;case">":fe=ae(B,Q,ee);break;case">=":fe=oe(B,Q,ee);break;case"<":fe=le(B,Q,ee);break;case"<=":fe=H(B,Q,ee);break;default:throw new TypeError("Invalid operator: "+G)}return fe}function ue(B,G){if(B instanceof ue){if(B.loose===G)return B;B=B.value}if(!(this instanceof ue))return new ue(B,G);k("comparator",B,G),this.loose=G,this.parse(B),this.semver===me?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(B,G){return re(G,B)},e.major=function(B,G){return new we(B,G).major},e.minor=function(B,G){return new we(B,G).minor},e.patch=function(B,G){return new we(B,G).patch},e.compare=q,e.compareLoose=function(B,G){return q(B,G,!0)},e.rcompare=function(B,G,Q){return q(G,B,Q)},e.sort=function(B,G){return B.sort(function(Q,ee){return e.compare(Q,ee,G)})},e.rsort=function(B,G){return B.sort(function(Q,ee){return e.rcompare(Q,ee,G)})},e.gt=ae,e.lt=le,e.eq=ne,e.neq=ce,e.gte=oe,e.lte=H,e.cmp=x,e.Comparator=ue;var me={};function Oe(B,G){if(B instanceof Oe)return B.loose===G?B:new Oe(B.raw,G);if(B instanceof ue)return new Oe(B.value,G);if(!(this instanceof Oe))return new Oe(B,G);if(this.loose=G,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function je(B){return!B||B.toLowerCase()==="x"||B==="*"}function ke(B,G,Q,ee,fe,Re,Ue,Qe,Ye,it,ot,tt,at){return((G=je(Q)?"":je(ee)?">="+Q+".0.0":je(fe)?">="+Q+"."+ee+".0":">="+G)+" "+(Qe=je(Ye)?"":je(it)?"<"+(+Ye+1)+".0.0":je(ot)?"<"+Ye+"."+(+it+1)+".0":tt?"<="+Ye+"."+it+"."+ot+"-"+tt:"<="+Qe)).trim()}function Ae(B,G){for(var Q=0;Q<B.length;Q++)if(!B[Q].test(G))return!1;if(G.prerelease.length){for(Q=0;Q<B.length;Q++)if(k(B[Q].semver),B[Q].semver!==me&&B[Q].semver.prerelease.length>0){var ee=B[Q].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function Ne(B,G,Q){try{G=new Oe(G,Q)}catch{return!1}return G.test(B)}function U(B,G,Q,ee){var fe,Re,Ue,Qe,Ye;switch(B=new we(B,ee),G=new Oe(G,ee),Q){case">":fe=ae,Re=H,Ue=le,Qe=">",Ye=">=";break;case"<":fe=le,Re=oe,Ue=ae,Qe="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(B,G,ee))return!1;for(var it=0;it<G.set.length;++it){var ot=G.set[it],tt=null,at=null;if(ot.forEach(function(pt){pt.semver===me&&(pt=new ue(">=0.0.0")),tt=tt||pt,at=at||pt,fe(pt.semver,tt.semver,ee)?tt=pt:Ue(pt.semver,at.semver,ee)&&(at=pt)}),tt.operator===Qe||tt.operator===Ye||(!at.operator||at.operator===Qe)&&Re(B,at.semver)||at.operator===Ye&&Ue(B,at.semver))return!1}return!0}ue.prototype.parse=function(B){var G=this.loose?N[Z]:N[he],Q=B.match(G);if(!Q)throw new TypeError("Invalid comparator: "+B);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new we(Q[2],this.loose):this.semver=me},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(B){return k("Comparator.test",B,this.loose),this.semver===me||(typeof B=="string"&&(B=new we(B,this.loose)),x(B,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(B,G){if(!(B instanceof ue))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Oe(B.value,G),Ne(this.value,Q,G);if(B.operator==="")return Q=new Oe(this.value,G),Ne(B.semver,Q,G);var ee=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Re=this.semver.version===B.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Qe=x(this.semver,"<",B.semver,G)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Ye=x(this.semver,">",B.semver,G)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ee||fe||Re&&Ue||Qe||Ye},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(B){var G=this.loose;B=B.trim(),k("range",B,G);var Q=G?N[de]:N[be];B=B.replace(Q,ke),k("hyphen replace",B),B=B.replace(N[ve],"$1$2$3"),k("comparator trim",B,N[ve]),B=(B=(B=B.replace(N[M],"$1~")).replace(N[z],"$1^")).split(/\s+/).join(" ");var ee=G?N[Z]:N[he],fe=B.split(" ").map(function(Re){return function(Ue,Qe){return k("comp",Ue),Ue=function(Ye,it){return Ye.trim().split(/\s+/).map(function(ot){return function(tt,at){k("caret",tt,at);var pt=at?N[W]:N[A];return tt.replace(pt,function(ut,st,ht,mt,wt){var qe;return k("caret",tt,ut,st,ht,mt,wt),je(st)?qe="":je(ht)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":je(mt)?qe=st==="0"?">="+st+"."+ht+".0 <"+st+"."+(+ht+1)+".0":">="+st+"."+ht+".0 <"+(+st+1)+".0.0":wt?(k("replaceCaret pr",wt),wt.charAt(0)!=="-"&&(wt="-"+wt),qe=st==="0"?ht==="0"?">="+st+"."+ht+"."+mt+wt+" <"+st+"."+ht+"."+(+mt+1):">="+st+"."+ht+"."+mt+wt+" <"+st+"."+(+ht+1)+".0":">="+st+"."+ht+"."+mt+wt+" <"+(+st+1)+".0.0"):(k("no pr"),qe=st==="0"?ht==="0"?">="+st+"."+ht+"."+mt+" <"+st+"."+ht+"."+(+mt+1):">="+st+"."+ht+"."+mt+" <"+st+"."+(+ht+1)+".0":">="+st+"."+ht+"."+mt+" <"+(+st+1)+".0.0"),k("caret return",qe),qe})}(ot,it)}).join(" ")}(Ue,Qe),k("caret",Ue),Ue=function(Ye,it){return Ye.trim().split(/\s+/).map(function(ot){return function(tt,at){var pt=at?N[K]:N[L];return tt.replace(pt,function(ut,st,ht,mt,wt){var qe;return k("tilde",tt,ut,st,ht,mt,wt),je(st)?qe="":je(ht)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":je(mt)?qe=">="+st+"."+ht+".0 <"+st+"."+(+ht+1)+".0":wt?(k("replaceTilde pr",wt),wt.charAt(0)!=="-"&&(wt="-"+wt),qe=">="+st+"."+ht+"."+mt+wt+" <"+st+"."+(+ht+1)+".0"):qe=">="+st+"."+ht+"."+mt+" <"+st+"."+(+ht+1)+".0",k("tilde return",qe),qe})}(ot,it)}).join(" ")}(Ue,Qe),k("tildes",Ue),Ue=function(Ye,it){return k("replaceXRanges",Ye,it),Ye.split(/\s+/).map(function(ot){return function(tt,at){tt=tt.trim();var pt=at?N[P]:N[T];return tt.replace(pt,function(ut,st,ht,mt,wt,qe){k("xRange",tt,ut,st,ht,mt,wt,qe);var Be=je(ht),te=Be||je(mt),V=te||je(wt);return st==="="&&V&&(st=""),Be?ut=st===">"||st==="<"?"<0.0.0":"*":st&&V?(te&&(mt=0),V&&(wt=0),st===">"?(st=">=",te?(ht=+ht+1,mt=0,wt=0):V&&(mt=+mt+1,wt=0)):st==="<="&&(st="<",te?ht=+ht+1:mt=+mt+1),ut=st+ht+"."+mt+"."+wt):te?ut=">="+ht+".0.0 <"+(+ht+1)+".0.0":V&&(ut=">="+ht+"."+mt+".0 <"+ht+"."+(+mt+1)+".0"),k("xRange return",ut),ut})}(ot,it)}).join(" ")}(Ue,Qe),k("xrange",Ue),Ue=function(Ye,it){return k("replaceStars",Ye,it),Ye.trim().replace(N[$e],"")}(Ue,Qe),k("stars",Ue),Ue}(Re,G)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Re){return!!Re.match(ee)})),fe=fe.map(function(Re){return new ue(Re,G)})},Oe.prototype.intersects=function(B,G){if(!(B instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(ee){return B.set.some(function(fe){return fe.every(function(Re){return ee.intersects(Re,G)})})})})},e.toComparators=function(B,G){return new Oe(B,G).set.map(function(Q){return Q.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new we(B,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],B))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(B,G,Q){var ee=null,fe=null;try{var Re=new Oe(G,Q)}catch{return null}return B.forEach(function(Ue){Re.test(Ue)&&(ee&&fe.compare(Ue)!==-1||(fe=new we(ee=Ue,Q)))}),ee},e.minSatisfying=function(B,G,Q){var ee=null,fe=null;try{var Re=new Oe(G,Q)}catch{return null}return B.forEach(function(Ue){Re.test(Ue)&&(ee&&fe.compare(Ue)!==1||(fe=new we(ee=Ue,Q)))}),ee},e.validRange=function(B,G){try{return new Oe(B,G).range||"*"}catch{return null}},e.ltr=function(B,G,Q){return U(B,G,"<",Q)},e.gtr=function(B,G,Q){return U(B,G,">",Q)},e.outside=U,e.prerelease=function(B,G){var Q=Y(B,G);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(B,G,Q){return B=new Oe(B,Q),G=new Oe(G,Q),B.intersects(G)},e.coerce=function(B){if(B instanceof we)return B;if(typeof B!="string")return null;var G=B.match(N[p]);return G==null?null:Y((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,w(1))},function(_,e){var w,y,k=_.exports={};function O(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function N(o){if(w===setTimeout)return setTimeout(o,0);if((w===O||!w)&&setTimeout)return w=setTimeout,setTimeout(o,0);try{return w(o,0)}catch{try{return w.call(null,o,0)}catch{return w.call(this,o,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:O}catch{w=O}try{y=typeof clearTimeout=="function"?clearTimeout:R}catch{y=R}})();var v,s=[],I=!1,E=-1;function u(){I&&v&&(I=!1,v.length?s=v.concat(s):E=-1,s.length&&C())}function C(){if(!I){var o=N(u);I=!0;for(var c=s.length;c;){for(v=s,s=[];++E<c;)v&&v[E].run();E=-1,c=s.length}v=null,I=!1,function(h){if(y===clearTimeout)return clearTimeout(h);if((y===R||!y)&&clearTimeout)return y=clearTimeout,clearTimeout(h);try{y(h)}catch{try{return y.call(null,h)}catch{return y.call(this,h)}}}(o)}}function d(o,c){this.fun=o,this.array=c}function n(){}k.nextTick=function(o){var c=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)c[h-1]=arguments[h];s.push(new d(o,c)),s.length!==1||I||N(C)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=n,k.addListener=n,k.once=n,k.off=n,k.removeListener=n,k.removeAllListeners=n,k.emit=n,k.prependListener=n,k.prependOnceListener=n,k.listeners=function(o){return[]},k.binding=function(o){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(o){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Ie[145],Pe([1,0,6,4]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=e.$ct=e.ScrollbarVisibility=void 0;var k;(function(C){C[C.Auto=1]="Auto",C[C.Hidden=2]="Hidden",C[C.Visible=3]="Visible"})(k||(e.ScrollbarVisibility=k={}));class O{constructor(d,n,o,c,h,i,r){this.c=d,this._scrollStateBrand=void 0,this.c&&(n=n|0,o=o|0,c=c|0,h=h|0,i=i|0,r=r|0),this.rawScrollLeft=c,this.rawScrollTop=r,n<0&&(n=0),c+n>o&&(c=o-n),c<0&&(c=0),h<0&&(h=0),r+h>i&&(r=i-h),r<0&&(r=0),this.width=n,this.scrollWidth=o,this.scrollLeft=c,this.height=h,this.scrollHeight=i,this.scrollTop=r}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,n){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,n){const o=this.width!==d.width,c=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,r=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:n,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:c,scrollLeftChanged:h,heightChanged:i,scrollHeightChanged:r,scrollTopChanged:t}}}e.$ct=O;class R extends y.$Xc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new w.$ne),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,n){const o=this.g.withScrollDimensions(d,n);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const n=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(d,n){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let c;n?c=new I(this.h.from,o,this.h.startTime,this.h.duration):c=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=c}else{const o=this.g.withScrollPosition(d);this.h=I.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),n=this.g.withScrollPosition(d);if(this.n(n,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,n){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,n)))}}e.$dt=R;class N{constructor(d,n,o){this.scrollLeft=d,this.scrollTop=n,this.isDone=o}}e.$et=N;function v(C,d){const n=d-C;return function(o){return C+n*u(o)}}function s(C,d,n){return function(o){return o<n?C(o/n):d((o-n)/(1-n))}}class I{constructor(d,n,o,c){this.from=d,this.to=n,this.duration=c,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,n,o){if(Math.abs(d-n)>2.5*o){let h,i;return d<n?(h=d+.75*o,i=n-.75*o):(h=d-.75*o,i=n+.75*o),s(v(d,h),v(i,n),.33)}return v(d,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const n=(d-this.startTime)/this.duration;if(n<1){const o=this.c(n),c=this.d(n);return new N(o,c,!1)}return new N(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,n,o){return I.start(d,n,o)}static start(d,n,o){o=o+10;const c=Date.now()-10;return new I(d,n,c,o)}}e.$ft=I;function E(C){return Math.pow(C,3)}function u(C){return 1-E(1-C)}}),define(Ie[146],Pe([1,0,14,4]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=k,e.$Be=O,e.$Ce=R,e.$De=N,e.$Ee=s,e.$Fe=I,e.$Ge=E,e.$He=u,e.$Ie=C,e.$Je=d,e.$Ke=n,e.$Le=o,e.$Me=c,e.$Ne=h,e.$Oe=i;function k(r){const t=r;return t?typeof t.read=="function":!1}function O(r){const t=r;return t?[t.on,t.pause,t.resume,t.destroy].every(a=>typeof a=="function"):!1}function R(r){const t=r;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function N(r,t){return new v(r,t)}class v{constructor(t,a){this.e=t,this.f=a,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(a=>this.d.push(a))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(a=>a(t))}h(t){this.c.error.length===0?(0,w.$3)(t):this.c.error.slice(0).forEach(a=>a(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,a){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(a),this.resume();break;case"end":this.c.end.push(a),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(a),this.a.flowing&&this.k();break}}removeListener(t,a){if(this.a.destroyed)return;let l;switch(t){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const g=l.indexOf(a);g>=0&&l.splice(g,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const a=[...this.d];this.d.length=0,a.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(r,t){const a=[];let l;for(;(l=r.read())!==null;)a.push(l);return t(a)}function I(r,t,a){const l=[];let g;for(;(g=r.read())!==null&&l.length<a;)l.push(g);return g===null&&l.length>0?t(l):{read:()=>{if(l.length>0)return l.shift();if(typeof g<"u"){const m=g;return g=void 0,m}return r.read()}}}function E(r,t){return new Promise((a,l)=>{const g=[];u(r,{onData:m=>{t&&g.push(m)},onError:m=>{t?l(m):a(void 0)},onEnd:()=>{a(t?t(g):void 0)}})})}function u(r,t,a){r.on("error",l=>{a?.isCancellationRequested||t.onError(l)}),r.on("end",()=>{a?.isCancellationRequested||t.onEnd()}),r.on("data",l=>{a?.isCancellationRequested||t.onData(l)})}function C(r,t){return new Promise((a,l)=>{const g=new y.$Wc,m=[],$=b=>{if(m.push(b),m.length>t)return g.dispose(),r.pause(),a({stream:r,buffer:m,ended:!1})},S=b=>(g.dispose(),l(b)),D=()=>(g.dispose(),a({stream:r,buffer:m,ended:!0}));g.add((0,y.$Vc)(()=>r.removeListener("error",S))),r.on("error",S),g.add((0,y.$Vc)(()=>r.removeListener("end",D))),r.on("end",D),g.add((0,y.$Vc)(()=>r.removeListener("data",$))),r.on("data",$)})}function d(r,t){const a=N(t);return a.end(r),a}function n(){const r=N(()=>{throw new Error("not supported")});return r.end(),r}function o(r){let t=!1;return{read:()=>t?null:(t=!0,r)}}function c(r,t,a){const l=N(a);return u(r,{onData:g=>l.write(t.data(g)),onError:g=>l.error(t.error?t.error(g):g),onEnd:()=>l.end()}),l}function h(r,t,a){let l=!1;return{read:()=>{const g=t.read();return l?g:(l=!0,g!==null?a([r,g]):r)}}}function i(r,t,a){let l=!1;const g=N(a);return u(t,{onData:m=>l?g.write(m):(l=!0,g.write(a([r,m]))),onError:m=>g.error(m),onEnd:()=>{l||(l=!0,g.write(r)),g.end()}}),g}}),define(Ie[23],Pe([1,0,48,146]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=void 0,e.$Qe=s,e.$Re=I,e.$Se=E,e.$Te=u,e.$Ue=C,e.$Ve=d,e.$We=n,e.$Xe=o,e.$Ye=c,e.$Ze=h,e.$1e=i,e.$2e=r,e.$3e=t,e.$4e=a,e.$5e=l,e.$6e=g,e.$7e=m,e.$8e=$,e.$9e=S,e.$0e=T,y=Ve(y);const k=typeof Buffer<"u",O=new w.$X(()=>new Uint8Array(256));let R,N;class v{static alloc(p){return k?new v(Buffer.allocUnsafe(p)):new v(new Uint8Array(p))}static wrap(p){return k&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new v(p)}static fromString(p,f){return!(f?.dontUseNodeBuffer||!1)&&k?new v(Buffer.from(p)):(R||(R=new TextEncoder),new v(R.encode(p)))}static fromByteArray(p){const f=v.alloc(p.length);for(let M=0,L=p.length;M<L;M++)f.buffer[M]=p[M];return f}static concat(p,f){if(typeof f>"u"){f=0;for(let K=0,J=p.length;K<J;K++)f+=p[K].byteLength}const M=v.alloc(f);let L=0;for(let K=0,J=p.length;K<J;K++){const z=p[K];M.set(z,L),L+=z.byteLength}return M}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=v.alloc(this.byteLength);return p.set(this),p}toString(){return k?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(p,f){return new v(this.buffer.subarray(p,f))}set(p,f){if(p instanceof v)this.buffer.set(p.buffer,f);else if(p instanceof Uint8Array)this.buffer.set(p,f);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),f);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,f){C(this.buffer,p,f)}readUInt32LE(p){return d(this.buffer,p)}writeUInt32LE(p,f){n(this.buffer,p,f)}readUInt8(p){return o(this.buffer,p)}writeUInt8(p,f){c(this.buffer,p,f)}indexOf(p,f=0){return s(this.buffer,p instanceof v?p.buffer:p,f)}}e.$Pe=v;function s(P,p,f=0){const M=p.byteLength,L=P.byteLength;if(M===0)return 0;if(M===1)return P.indexOf(p[0]);if(M>L-f)return-1;const K=O.value;K.fill(p.length);for(let W=0;W<p.length;W++)K[p[W]]=p.length-W-1;let J=f+p.length-1,z=J,A=-1;for(;J<L;)if(P[J]===p[z]){if(z===0){A=J;break}J--,z--}else J+=Math.max(p.length-z,K[P[J]]),z=p.length-1;return A}function I(P,p){return P[p+0]<<0>>>0|P[p+1]<<8>>>0}function E(P,p,f){P[f+0]=p&255,p=p>>>8,P[f+1]=p&255}function u(P,p){return P[p]*2**24+P[p+1]*2**16+P[p+2]*2**8+P[p+3]}function C(P,p,f){P[f+3]=p,p=p>>>8,P[f+2]=p,p=p>>>8,P[f+1]=p,p=p>>>8,P[f]=p}function d(P,p){return P[p+0]<<0>>>0|P[p+1]<<8>>>0|P[p+2]<<16>>>0|P[p+3]<<24>>>0}function n(P,p,f){P[f+0]=p&255,p=p>>>8,P[f+1]=p&255,p=p>>>8,P[f+2]=p&255,p=p>>>8,P[f+3]=p&255}function o(P,p){return P[p]}function c(P,p,f){P[f]=p}function h(P){return y.$Ee(P,p=>v.concat(p))}function i(P){return y.$Le(P)}function r(P){return y.$Ge(P,p=>v.concat(p))}async function t(P){return P.ended?v.concat(P.buffer):v.concat([...P.buffer,await r(P.stream)])}function a(P){return y.$Je(P,p=>v.concat(p))}function l(P){return y.$Me(P,{data:p=>typeof p=="string"?v.fromString(p):v.wrap(p)},p=>v.concat(p))}function g(P){return y.$De(p=>v.concat(p),P)}function m(P,p){return y.$Ne(P,p,f=>v.concat(f))}function $(P,p){return y.$Oe(P,p,f=>v.concat(f))}function S(P){let p=0,f=0,M=0;const L=new Uint8Array(Math.floor(P.length/4*3)),K=z=>{switch(f){case 3:L[M++]=p|z,f=0;break;case 2:L[M++]=p|z>>>2,p=z<<6,f=3;break;case 1:L[M++]=p|z>>>4,p=z<<4,f=2;break;default:p=z<<2,f=1}};for(let z=0;z<P.length;z++){const A=P.charCodeAt(z);if(A>=65&&A<=90)K(A-65);else if(A>=97&&A<=122)K(A-97+26);else if(A>=48&&A<=57)K(A-48+52);else if(A===43||A===45)K(62);else if(A===47||A===95)K(63);else{if(A===61)break;throw new SyntaxError(`Unexpected base64 character ${P[z]}`)}}const J=M;for(;f>0;)K(0);return v.wrap(L).slice(0,J)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function T({buffer:P},p=!0,f=!1){const M=f?b:D;let L="";const K=P.byteLength%3;let J=0;for(;J<P.byteLength-K;J+=3){const z=P[J+0],A=P[J+1],W=P[J+2];L+=M[z>>>2],L+=M[(z<<4|A>>>4)&63],L+=M[(A<<2|W>>>6)&63],L+=M[W&63]}if(K===1){const z=P[J+0];L+=M[z>>>2],L+=M[z<<4&63],p&&(L+="==")}else if(K===2){const z=P[J+0],A=P[J+1];L+=M[z>>>2],L+=M[(z<<4|A>>>4)&63],L+=M[A<<2&63],p&&(L+="=")}return L}}),define(Ie[147],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=void 0,e.$ie=Symbol("MicrotaskDelay")}),define(Ie[35],Pe([1,0,98]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$7j=k;var y;(function(R){function N(v){return v&&typeof v=="object"&&typeof v.id=="string"}R.isThemeColor=N})(y||(e.ThemeColor=y={}));function k(R){return{id:R}}var O;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const N=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function v(h){const i=N.exec(h.id);if(!i)return v(w.$6j.error);const[,r,t]=i,a=["codicon","codicon-"+r];return t&&a.push("codicon-modifier-"+t.substring(1)),a}R.asClassNameArray=v;function s(h){return v(h).join(" ")}R.asClassName=s;function I(h){return"."+v(h).join(".")}R.asCSSSelector=I;function E(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||y.isThemeColor(h.color))}R.isThemeIcon=E;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function C(h){const i=u.exec(h);if(!i)return;const[,r]=i;return{id:r}}R.fromString=C;function d(h){return{id:h}}R.fromId=d;function n(h,i){let r=h.id;const t=r.lastIndexOf("~");return t!==-1&&(r=r.substring(0,t)),i&&(r=`${r}~${i}`),{id:r}}R.modify=n;function o(h){const i=h.id.lastIndexOf("~");if(i!==-1)return h.id.substring(i+1)}R.getModifier=o;function c(h,i){return h.id===i.id&&h.color?.id===i.color?.id}R.isEqual=c})(O||(e.ThemeIcon=O={}))}),define(Ie[52],Pe([1,0,28,20,21,13,15]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=N,e.$zg=v,e.$Ag=s,e.$Bg=I,e.$Cg=E,e.$Dg=n,e.$Eg=o,e.$Fg=c,e.$Gg=h,e.$Hg=i,e.$Ig=r,e.$Jg=t,e.$Kg=a,e.$Lg=l,e.$Mg=g,e.$Ng=m,e.$Og=D;function N(b){return b===w.CharCode.Slash||b===w.CharCode.Backslash}function v(b){return b.replace(/[\\/]/g,y.$jc.sep)}function s(b){return b.indexOf("/")===-1&&(b=v(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function I(b,T=y.$jc.sep){if(!b)return"";const P=b.length,p=b.charCodeAt(0);if(N(p)){if(N(b.charCodeAt(1))&&!N(b.charCodeAt(2))){let M=3;const L=M;for(;M<P&&!N(b.charCodeAt(M));M++);if(L!==M&&!N(b.charCodeAt(M+1))){for(M+=1;M<P;M++)if(N(b.charCodeAt(M)))return b.slice(0,M+1).replace(/[\\/]/g,T)}}return T}else if(h(p)&&b.charCodeAt(1)===w.CharCode.Colon)return N(b.charCodeAt(2))?b.slice(0,2)+T:b.slice(0,2);let f=b.indexOf("://");if(f!==-1){for(f+=3;f<P;f++)if(N(b.charCodeAt(f)))return b.slice(0,f+1)}return""}function E(b){if(!k.$c||!b||b.length<5)return!1;let T=b.charCodeAt(0);if(T!==w.CharCode.Backslash||(T=b.charCodeAt(1),T!==w.CharCode.Backslash))return!1;let P=2;const p=P;for(;P<b.length&&(T=b.charCodeAt(P),T!==w.CharCode.Backslash);P++);return!(p===P||(T=b.charCodeAt(P+1),isNaN(T)||T===w.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,C=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(b,T=k.$c){const P=T?u:C;return!(!b||b.length===0||/^\s+$/.test(b)||(P.lastIndex=0,P.test(b))||T&&d.test(b)||b==="."||b===".."||T&&b[b.length-1]==="."||T&&b.length!==b.trim().length||b.length>255)}function o(b,T,P){const p=b===T;return!P||p?p:!b||!T?!1:(0,O.$Hf)(b,T)}function c(b,T,P,p=y.sep){if(b===T)return!0;if(!b||!T||T.length>b.length)return!1;if(P){if(!(0,O.$If)(b,T))return!1;if(T.length===b.length)return!0;let M=T.length;return T.charAt(T.length-1)===p&&M--,b.charAt(M)===p}return T.charAt(T.length-1)!==p&&(T+=p),b.indexOf(T)===0}function h(b){return b>=w.CharCode.A&&b<=w.CharCode.Z||b>=w.CharCode.a&&b<=w.CharCode.z}function i(b,T){return k.$c&&b.endsWith(":")&&(b+=y.sep),(0,y.$lc)(b)||(b=(0,y.$mc)(T,b)),b=(0,y.$kc)(b),r(b)}function r(b){return k.$c?(b=(0,O.$pf)(b,y.sep),b.endsWith(":")&&(b+=y.sep)):(b=(0,O.$pf)(b,y.sep),b||(b=y.sep)),b}function t(b){const T=(0,y.$kc)(b);return k.$c?b.length>3?!1:a(T)&&(b.length===2||T.charCodeAt(2)===w.CharCode.Backslash):T===y.$jc.sep}function a(b,T=k.$c){return T?h(b.charCodeAt(0))&&b.charCodeAt(1)===w.CharCode.Colon:!1}function l(b,T=k.$c){return a(b,T)?b[0]:void 0}function g(b,T,P){return T.length>b.length?-1:b===T?0:(P&&(b=b.toLowerCase(),T=T.toLowerCase()),b.indexOf(T))}function m(b){const T=b.split(":");let P,p,f;for(const M of T){const L=Number(M);(0,R.$kg)(L)?p===void 0?p=L:f===void 0&&(f=L):P=P?[P,M].join(":"):M}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:p!==void 0?p:void 0,column:f!==void 0?f:p!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",S="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(b,T,P=8){let p="";for(let M=0;M<P;M++){let L;M===0&&k.$c&&!T&&(P===3||P===4)?L=S:L=$,p+=L.charAt(Math.floor(Math.random()*L.length))}let f;return T?f=`${T}-${p}`:f=p,b?(0,y.$mc)(b,f):f}}),define(Ie[148],Pe([1,0,28,29,138,13]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.FuzzyScore=e.$Ik=e.$Hk=void 0,e.or=R,e.$Jk=v,e.$Kk=s,e.$Lk=u,e.$Mk=D,e.$Nk=b,e.$Ok=L,e.$Pk=K,e.$Qk=J,e.$Rk=z,e.$Sk=ae,e.$Uk=oe,e.$Vk=ue,e.$Wk=me,O=Ve(O);function R(...ke){return function(Ae,Ne){for(let U=0,B=ke.length;U<B;U++){const G=ke[U](Ae,Ne);if(G)return G}return null}}e.$Hk=N.bind(void 0,!1),e.$Ik=N.bind(void 0,!0);function N(ke,Ae,Ne){if(!Ne||Ne.length<Ae.length)return null;let U;return ke?U=O.$If(Ne,Ae):U=Ne.indexOf(Ae)===0,U?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function v(ke,Ae){const Ne=Ae.toLowerCase().indexOf(ke.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+ke.length}]}function s(ke,Ae){return I(ke.toLowerCase(),Ae.toLowerCase(),0,0)}function I(ke,Ae,Ne,U){if(Ne===ke.length)return[];if(U===Ae.length)return null;if(ke[Ne]===Ae[U]){let B=null;return(B=I(ke,Ae,Ne+1,U+1))?t({start:U,end:U+1},B):null}return I(ke,Ae,Ne,U+1)}function E(ke){return w.CharCode.a<=ke&&ke<=w.CharCode.z}function u(ke){return w.CharCode.A<=ke&&ke<=w.CharCode.Z}function C(ke){return w.CharCode.Digit0<=ke&&ke<=w.CharCode.Digit9}function d(ke){return ke===w.CharCode.Space||ke===w.CharCode.Tab||ke===w.CharCode.LineFeed||ke===w.CharCode.CarriageReturn}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>n.add(ke.charCodeAt(0)));function o(ke){return d(ke)||n.has(ke)}function c(ke,Ae){return ke===Ae||o(ke)&&o(Ae)}const h=new Map;function i(ke){if(h.has(ke))return h.get(ke);let Ae;const Ne=(0,k.$Fk)(ke);return Ne&&(Ae=Ne),h.set(ke,Ae),Ae}function r(ke){return E(ke)||u(ke)||C(ke)}function t(ke,Ae){return Ae.length===0?Ae=[ke]:ke.end===Ae[0].start?Ae[0].start=ke.start:Ae.unshift(ke),Ae}function a(ke,Ae){for(let Ne=Ae;Ne<ke.length;Ne++){const U=ke.charCodeAt(Ne);if(u(U)||C(U)||Ne>0&&!r(ke.charCodeAt(Ne-1)))return Ne}return ke.length}function l(ke,Ae,Ne,U){if(Ne===ke.length)return[];if(U===Ae.length)return null;if(ke[Ne]!==Ae[U].toLowerCase())return null;{let B=null,G=U+1;for(B=l(ke,Ae,Ne+1,U+1);!B&&(G=a(Ae,G))<Ae.length;)B=l(ke,Ae,Ne+1,G),G++;return B===null?null:t({start:U,end:U+1},B)}}function g(ke){let Ae=0,Ne=0,U=0,B=0,G=0;for(let Ue=0;Ue<ke.length;Ue++)G=ke.charCodeAt(Ue),u(G)&&Ae++,E(G)&&Ne++,r(G)&&U++,C(G)&&B++;const Q=Ae/ke.length,ee=Ne/ke.length,fe=U/ke.length,Re=B/ke.length;return{upperPercent:Q,lowerPercent:ee,alphaPercent:fe,numericPercent:Re}}function m(ke){const{upperPercent:Ae,lowerPercent:Ne}=ke;return Ne===0&&Ae>.6}function $(ke){const{upperPercent:Ae,lowerPercent:Ne,alphaPercent:U,numericPercent:B}=ke;return Ne>.2&&Ae<.8&&U>.6&&B<.2}function S(ke){let Ae=0,Ne=0,U=0,B=0;for(let G=0;G<ke.length;G++)U=ke.charCodeAt(G),u(U)&&Ae++,E(U)&&Ne++,d(U)&&B++;return(Ae===0||Ne===0)&&B===0?ke.length<=30:Ae<=5}function D(ke,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!S(ke))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Ne=g(Ae);if(!$(Ne)){if(!m(Ne))return null;Ae=Ae.toLowerCase()}let U=null,B=0;for(ke=ke.toLowerCase();B<Ae.length&&(U=l(ke,Ae,0,B))===null;)B=a(Ae,B+1);return U}function b(ke,Ae,Ne=!1){if(!Ae||Ae.length===0)return null;let U=null,B=0;for(ke=ke.toLowerCase(),Ae=Ae.toLowerCase();B<Ae.length&&(U=T(ke,Ae,0,B,Ne),U===null);)B=P(Ae,B+1);return U}function T(ke,Ae,Ne,U,B){let G=0;if(Ne===ke.length)return[];if(U===Ae.length)return null;if(!c(ke.charCodeAt(Ne),Ae.charCodeAt(U))){const fe=i(ke.charCodeAt(Ne));if(!fe)return null;for(let Re=0;Re<fe.length;Re++)if(!c(fe[Re],Ae.charCodeAt(U+Re)))return null;G+=fe.length-1}let Q=null,ee=U+G+1;if(Q=T(ke,Ae,Ne+1,ee,B),!B)for(;!Q&&(ee=P(Ae,ee))<Ae.length;)Q=T(ke,Ae,Ne+1,ee,B),ee++;if(!Q)return null;if(ke.charCodeAt(Ne)!==Ae.charCodeAt(U)){const fe=i(ke.charCodeAt(Ne));if(!fe)return Q;for(let Re=0;Re<fe.length;Re++)if(fe[Re]!==Ae.charCodeAt(U+Re))return Q}return t({start:U,end:U+G+1},Q)}function P(ke,Ae){for(let Ne=Ae;Ne<ke.length;Ne++)if(o(ke.charCodeAt(Ne))||Ne>0&&o(ke.charCodeAt(Ne-1)))return Ne;return ke.length}const p=R(e.$Ik,D,v),f=R(e.$Ik,D,s),M=new y.$Gc(1e4);function L(ke,Ae,Ne=!1){if(typeof ke!="string"||typeof Ae!="string")return null;let U=M.get(ke);U||(U=new RegExp(O.$qf(ke),"i"),M.set(ke,U));const B=U.exec(Ae);return B?[{start:B.index,end:B.index+B[0].length}]:Ne?f(ke,Ae):p(ke,Ae)}function K(ke,Ae){const Ne=oe(ke,ke.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?z(Ne):null}function J(ke,Ae,Ne,U,B,G){const Q=Math.min(13,ke.length);for(;Ne<Q;Ne++){const ee=oe(ke,Ae,Ne,U,B,G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ee)return ee}return[0,G]}function z(ke){if(typeof ke>"u")return[];const Ae=[],Ne=ke[1];for(let U=ke.length-1;U>1;U--){const B=ke[U]+Ne,G=Ae[Ae.length-1];G&&G.end===B?G.end=B+1:Ae.push({start:B,end:B+1})}return Ae}const A=128;function W(){const ke=[],Ae=[];for(let Ne=0;Ne<=A;Ne++)Ae[Ne]=0;for(let Ne=0;Ne<=A;Ne++)ke.push(Ae.slice(0));return ke}function Z(ke){const Ae=[];for(let Ne=0;Ne<=ke;Ne++)Ae[Ne]=0;return Ae}const he=Z(2*A),ve=Z(2*A),be=W(),de=W(),$e=W(),ye=!1;function Y(ke,Ae,Ne,U,B){function G(ee,fe,Re=" "){for(;ee.length<fe;)ee=Re+ee;return ee}let Q=` |   |${U.split("").map(ee=>G(ee,3)).join("|")}
`;for(let ee=0;ee<=Ne;ee++)ee===0?Q+=" |":Q+=`${Ae[ee-1]}|`,Q+=ke[ee].slice(0,B+1).map(fe=>G(fe.toString(),3)).join("|")+`
`;return Q}function we(ke,Ae,Ne,U){ke=ke.substr(Ae),Ne=Ne.substr(U),console.log(Y(de,ke,ke.length,Ne,Ne.length)),console.log(Y($e,ke,ke.length,Ne,Ne.length)),console.log(Y(be,ke,ke.length,Ne,Ne.length))}function Te(ke,Ae){if(Ae<0||Ae>=ke.length)return!1;const Ne=ke.codePointAt(Ae);switch(Ne){case w.CharCode.Underline:case w.CharCode.Dash:case w.CharCode.Period:case w.CharCode.Space:case w.CharCode.Slash:case w.CharCode.Backslash:case w.CharCode.SingleQuote:case w.CharCode.DoubleQuote:case w.CharCode.Colon:case w.CharCode.DollarSign:case w.CharCode.LessThan:case w.CharCode.GreaterThan:case w.CharCode.OpenParen:case w.CharCode.CloseParen:case w.CharCode.OpenSquareBracket:case w.CharCode.CloseSquareBracket:case w.CharCode.OpenCurlyBrace:case w.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$1f(Ne)}}function re(ke,Ae){if(Ae<0||Ae>=ke.length)return!1;switch(ke.charCodeAt(Ae)){case w.CharCode.Space:case w.CharCode.Tab:return!0;default:return!1}}function q(ke,Ae,Ne){return Ae[ke]!==Ne[ke]}function ae(ke,Ae,Ne,U,B,G,Q=!1){for(;Ae<Ne&&B<G;)ke[Ae]===U[B]&&(Q&&(he[Ae]=B),Ae+=1),B+=1;return Ae===Ne}var le;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(le||(le={}));var ne;(function(ke){ke.Default=[-100,0];function Ae(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}ke.isDefault=Ae})(ne||(e.FuzzyScore=ne={}));class ce{constructor(Ae,Ne){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Ne}}e.$Tk=ce,ce.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function oe(ke,Ae,Ne,U,B,G,Q=ce.default){const ee=ke.length>A?A:ke.length,fe=U.length>A?A:U.length;if(Ne>=ee||G>=fe||ee-Ne>fe-G||!ae(Ae,Ne,ee,B,G,fe,!0))return;H(ee,fe,Ne,G,Ae,B);let Re=1,Ue=1,Qe=Ne,Ye=G;const it=[!1];for(Re=1,Qe=Ne;Qe<ee;Re++,Qe++){const ut=he[Qe],st=ve[Qe],ht=Qe+1<ee?ve[Qe+1]:fe;for(Ue=ut-G+1,Ye=ut;Ye<ht;Ue++,Ye++){let mt=Number.MIN_SAFE_INTEGER,wt=!1;Ye<=st&&(mt=x(ke,Ae,Qe,Ne,U,B,Ye,fe,G,be[Re-1][Ue-1]===0,it));let qe=0;mt!==Number.MAX_SAFE_INTEGER&&(wt=!0,qe=mt+de[Re-1][Ue-1]);const Be=Ye>ut,te=Be?de[Re][Ue-1]+(be[Re][Ue-1]>0?-5:0):0,V=Ye>ut+1&&be[Re][Ue-1]>0,Se=V?de[Re][Ue-2]+(be[Re][Ue-2]>0?-5:0):0;if(V&&(!Be||Se>=te)&&(!wt||Se>=qe))de[Re][Ue]=Se,$e[Re][Ue]=le.LeftLeft,be[Re][Ue]=0;else if(Be&&(!wt||te>=qe))de[Re][Ue]=te,$e[Re][Ue]=le.Left,be[Re][Ue]=0;else if(wt)de[Re][Ue]=qe,$e[Re][Ue]=le.Diag,be[Re][Ue]=be[Re-1][Ue-1]+1;else throw new Error("not possible")}}if(ye&&we(ke,Ne,U,G),!it[0]&&!Q.firstMatchCanBeWeak)return;Re--,Ue--;const ot=[de[Re][Ue],G];let tt=0,at=0;for(;Re>=1;){let ut=Ue;do{const st=$e[Re][ut];if(st===le.LeftLeft)ut=ut-2;else if(st===le.Left)ut=ut-1;else break}while(ut>=1);tt>1&&Ae[Ne+Re-1]===B[G+Ue-1]&&!q(ut+G-1,U,B)&&tt+1>be[Re][ut]&&(ut=Ue),ut===Ue?tt++:tt=1,at||(at=ut),Re--,Ue=ut-1,ot.push(Ue)}fe-G===ee&&Q.boostFullMatch&&(ot[0]+=2);const pt=at-ee;return ot[0]-=pt,ot}function H(ke,Ae,Ne,U,B,G){let Q=ke-1,ee=Ae-1;for(;Q>=Ne&&ee>=U;)B[Q]===G[ee]&&(ve[Q]=ee,Q--),ee--}function x(ke,Ae,Ne,U,B,G,Q,ee,fe,Re,Ue){if(Ae[Ne]!==G[Q])return Number.MIN_SAFE_INTEGER;let Qe=1,Ye=!1;return Q===Ne-U?Qe=ke[Ne]===B[Q]?7:5:q(Q,B,G)&&(Q===0||!q(Q-1,B,G))?(Qe=ke[Ne]===B[Q]?7:5,Ye=!0):Te(G,Q)&&(Q===0||!Te(G,Q-1))?Qe=5:(Te(G,Q-1)||re(G,Q-1))&&(Qe=5,Ye=!0),Qe>1&&Ne===U&&(Ue[0]=!0),Ye||(Ye=q(Q,B,G)||Te(G,Q-1)||re(G,Q-1)),Ne===U?Q>fe&&(Qe-=Ye?3:5):Re?Qe+=Ye?2:0:Qe+=Ye?0:1,Q+1===ee&&(Qe-=Ye?3:5),Qe}function ue(ke,Ae,Ne,U,B,G,Q){return Oe(ke,Ae,Ne,U,B,G,!0,Q)}function me(ke,Ae,Ne,U,B,G,Q){return Oe(ke,Ae,Ne,U,B,G,!1,Q)}function Oe(ke,Ae,Ne,U,B,G,Q,ee){let fe=oe(ke,Ae,Ne,U,B,G,ee);if(fe&&!Q)return fe;if(ke.length>=3){const Re=Math.min(7,ke.length-1);for(let Ue=Ne+1;Ue<Re;Ue++){const Qe=je(ke,Ue);if(Qe){const Ye=oe(Qe,Qe.toLowerCase(),Ne,U,B,G,ee);Ye&&(Ye[0]-=3,(!fe||Ye[0]>fe[0])&&(fe=Ye))}}}return fe}function je(ke,Ae){if(Ae+1>=ke.length)return;const Ne=ke[Ae],U=ke[Ae+1];if(Ne!==U)return ke.slice(0,Ae)+U+Ne+ke.slice(Ae+2)}}),define(Ie[99],Pe([1,0,148,13,35]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=v,e.$Yk=I,e.$Zk=u,e.$1k=C,e.$2k=n,e.$3k=o;const O="$(",R=new RegExp(`\\$\\(${k.ThemeIcon.iconNameExpression}(?:${k.ThemeIcon.iconModifierExpression})?\\)`,"g"),N=new RegExp(`(\\\\)?${R.source}`,"g");function v(c){return c.replace(N,(h,i)=>i?h:`\\${h}`)}const s=new RegExp(`\\\\${R.source}`,"g");function I(c){return c.replace(s,h=>`\\${h}`)}const E=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(c){return c.indexOf(O)===-1?c:c.replace(E,(h,i,r,t)=>r?h:i||t||"")}function C(c){return c?c.replace(/\$\((.*?)\)/g,(h,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${k.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(c){d.lastIndex=0;let h="";const i=[];let r=0;for(;;){const t=d.lastIndex,a=d.exec(c),l=c.substring(t,a?.index);if(l.length>0){h+=l;for(let g=0;g<l.length;g++)i.push(r)}if(!a)break;r+=a[0].length}return{text:h,iconOffsets:i}}function o(c,h,i=!1){const{text:r,iconOffsets:t}=h;if(!t||t.length===0)return(0,w.$Ok)(c,r,i);const a=(0,y.$of)(r," "),l=r.length-a.length,g=(0,w.$Ok)(c,a,i);if(g)for(const m of g){const $=t[m.start+l]+l;m.start+=$,m.end+=$}return g}}),define(Ie[36],Pe([1,0,13]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w=Ve(w);var y;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(y||(y={})),function(k){const O="error",R="warning",N="warn",v="info",s="ignore";function I(u){return u?w.$Hf(O,u)?k.Error:w.$Hf(R,u)||w.$Hf(N,u)?k.Warning:w.$Hf(v,u)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function E(u){switch(u){case k.Error:return O;case k.Warning:return R;case k.Info:return v;default:return s}}k.toString=E}(y||(y={})),e.default=y}),define(Ie[59],Pe([1,0,18,28,13]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const n=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return n-o}value(){return this.b[this.c]}}e.$Ii=O;class R{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===y.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,k.$Bf)(d,this.b,0,d.length,this.c,this.d):(0,k.$Df)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ji=R;class N{constructor(d=!0,n=!0){this.f=d,this.g=n}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let n=d.length-1;n>=0;n--,this.c--){const o=this.b.charCodeAt(n);if(!(o===y.CharCode.Slash||this.f&&o===y.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const n=this.b.charCodeAt(this.e);if(n===y.CharCode.Slash||this.f&&n===y.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,k.$Bf)(d,this.b,0,d.length,this.d,this.e):(0,k.$Df)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ki=N;var v;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(v||(v={}));class s{constructor(d,n){this.f=d,this.g=n,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(v.Scheme),this.c.authority&&this.d.push(v.Authority),this.c.path&&(this.b=new N(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(v.Path)),this.g(d)||(this.c.query&&this.d.push(v.Query),this.c.fragment&&this.d.push(v.Fragment)),this.e=0,this}next(){return this.d[this.e]===v.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===v.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===v.Scheme)return(0,k.$Cf)(d,this.c.scheme);if(this.d[this.e]===v.Authority)return(0,k.$Cf)(d,this.c.authority);if(this.d[this.e]===v.Path)return this.b.cmp(d);if(this.d[this.e]===v.Query)return(0,k.$Af)(d,this.c.query);if(this.d[this.e]===v.Fragment)return(0,k.$Af)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===v.Scheme)return this.c.scheme;if(this.d[this.e]===v.Authority)return this.c.authority;if(this.d[this.e]===v.Path)return this.b.value();if(this.d[this.e]===v.Query)return this.c.query;if(this.d[this.e]===v.Fragment)return this.c.fragment;throw new Error}}e.$Li=s;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(E||(E={}));class u{static forUris(d=()=>!1,n=()=>!1){return new u(new s(d,n))}static forPaths(d=!1){return new u(new N(void 0,!d))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new R)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,n){if(n){const o=n.slice(0);(0,w.$Zb)(o);for(const c of o)this.set(c,d)}else{const o=d.slice(0);(0,w.$Zb)(o);for(const c of o)this.set(c[0],c[1])}}set(d,n){const o=this.b.reset(d);let c;this.c||(this.c=new I,this.c.segment=o.value());const h=[];for(c=this.c;;){const r=o.cmp(c.segment);if(r>0)c.left||(c.left=new I,c.left.segment=o.value()),h.push([E.Left,c]),c=c.left;else if(r<0)c.right||(c.right=new I,c.right.segment=o.value()),h.push([E.Right,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new I,c.mid.segment=o.value()),h.push([E.Mid,c]),c=c.mid;else break}const i=c.value;c.value=n,c.key=d;for(let r=h.length-1;r>=0;r--){const t=h[r][1];t.updateHeight();const a=t.balanceFactor();if(a<-1||a>1){const l=h[r][0],g=h[r+1][0];if(l===E.Right&&g===E.Right)h[r][1]=t.rotateLeft();else if(l===E.Left&&g===E.Left)h[r][1]=t.rotateRight();else if(l===E.Right&&g===E.Left)t.right=h[r+1][1]=h[r+1][1].rotateRight(),h[r][1]=t.rotateLeft();else if(l===E.Left&&g===E.Right)t.left=h[r+1][1]=h[r+1][1].rotateLeft(),h[r][1]=t.rotateRight();else throw new Error;if(r>0)switch(h[r-1][0]){case E.Left:h[r-1][1].left=h[r][1];break;case E.Right:h[r-1][1].right=h[r][1];break;case E.Mid:h[r-1][1].mid=h[r][1];break}else this.c=h[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const n=this.b.reset(d);let o=this.c;for(;o;){const c=n.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(d){const n=this.d(d);return!(n?.value===void 0&&n?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,n){const o=this.b.reset(d),c=[];let h=this.c;for(;h;){const i=o.cmp(h.segment);if(i>0)c.push([E.Left,h]),h=h.left;else if(i<0)c.push([E.Right,h]),h=h.right;else if(o.hasNext())o.next(),c.push([E.Mid,h]),h=h.mid;else break}if(h){if(n?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const i=this.f(h.right);if(i.key){const{key:r,value:t,segment:a}=i;this.e(i.key,!1),h.key=r,h.value=t,h.segment=a}}else{const i=h.left??h.right;if(c.length>0){const[r,t]=c[c.length-1];switch(r){case E.Left:t.left=i;break;case E.Mid:t.mid=i;break;case E.Right:t.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const r=c[i][1];r.updateHeight();const t=r.balanceFactor();if(t>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),c[i][1]=r.rotateLeft()):t<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),c[i][1]=r.rotateRight()),i>0)switch(c[i-1][0]){case E.Left:c[i-1][1].left=c[i][1];break;case E.Right:c[i-1][1].right=c[i][1];break;case E.Mid:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const n=this.b.reset(d);let o=this.c,c;for(;o;){const h=n.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(n.hasNext())n.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(d){return this.g(d,!1)}g(d,n){const o=this.b.reset(d);let c=this.c;for(;c;){const h=o.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this.h(c.mid):n?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[n,o]of this)d(o,n)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const n=[];return this.j(d,n),n[Symbol.iterator]()}j(d,n){d&&(d.left&&this.j(d.left,n),d.value&&n.push([d.key,d.value]),d.mid&&this.j(d.mid,n),d.right&&this.j(d.right,n))}_isBalanced(){const d=n=>{if(!n)return!0;const o=n.balanceFactor();return o<-1||o>1?!1:d(n.left)&&d(n.right)};return d(this.c)}}e.$Mi=u}),define(Ie[49],Pe([1,0,23,2,37]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=O,e.$ci=R,e.$di=v;function O(s){return JSON.stringify(s,N)}function R(s){let I=JSON.parse(s);return I=v(I),I}function N(s,I){return I instanceof RegExp?{$mid:k.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function v(s,I=0){if(!s||I>200)return s;if(typeof s=="object"){switch(s.$mid){case k.MarshalledId.Uri:return y.URI.revive(s);case k.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case k.MarshalledId.Date:return new Date(s.source)}if(s instanceof w.$Pe||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let E=0;E<s.length;++E)s[E]=v(s[E],I+1);else for(const E in s)Object.hasOwnProperty.call(s,E)&&(s[E]=v(s[E],I+1))}return s}}),define(Ie[16],Pe([1,0,14,21,13,2,20]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Tg=e.$Sg=e.$Rg=e.Schemas=void 0,e.$Pg=v,e.$Qg=s,e.$Ug=E,w=Ve(w),y=Ve(y),R=Ve(R);var N;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(N||(e.Schemas=N={}));function v(d,n){return O.URI.isUri(d)?(0,k.$Hf)(d.scheme,n):(0,k.$If)(d,n+":")}function s(d,...n){return n.some(o=>v(d,o))}e.$Rg="vscode-tkn",e.$Sg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=E(n,o)}getServerRootPath(){return this.f}get g(){return R.$jc.join(this.f,N.vscodeRemoteResource)}set(n,o,c){this.a[n]=o,this.b[n]=c}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(t){return w.$3(t),n}const o=n.authority;let c=this.a[o];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const h=this.b[o],i=this.c[o];let r=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(r+=`&${e.$Sg}=${encodeURIComponent(i)}`),O.URI.from({scheme:y.$i?this.d:N.vscodeRemoteResource,authority:`${c}:${h}`,path:y.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:r})}}e.$Tg=new I;function E(d,n){return R.$jc.join(n??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Vg="vs/../../extensions",e.$Wg="vs/../../node_modules",e.$Xg="vs/../../node_modules.asar",e.$Yg="vs/../../node_modules.asar.unpacked",e.$Zg="vscode-app";class u{asBrowserUri(n){const o=this.b(n,_);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===N.vscodeRemote?e.$Tg.rewrite(n):n.scheme===N.file&&(y.$g||y.$k===`${N.vscodeFileResource}://${u.a}`)?n.with({scheme:N.vscodeFileResource,authority:n.authority||u.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,_);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===N.vscodeFileResource?n.with({scheme:N.file,authority:n.authority!==u.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return O.URI.isUri(n)?n:O.URI.parse(o.toUrl(n))}}u.a=e.$Zg,e.$1g=new u;var C;(function(d){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function c(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:O.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const t=r?.get(o);if(t)return n.get(t)}d.getHeadersFromQuery=c;function h(i,r,t){if(!globalThis.crossOriginIsolated)return;const a=r&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(o,a):i[o]=a}d.addSearchParam=h})(C||(e.COI=C={}))}),define(Ie[24],Pe([1,0,28,52,16,20,21,13,2]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=void 0,e.$8g=s,e.$qh=E,e.$rh=C,y=Ve(y),O=Ve(O);function s(d){return(0,v.$zc)(d,!0)}class I{constructor(n){this.a=n}compare(n,o,c=!1){return n===o?0:(0,N.$Af)(this.getComparisonKey(n,c),this.getComparisonKey(o,c))}isEqual(n,o,c=!1){return n===o?!0:!n||!o?!1:this.getComparisonKey(n,c)===this.getComparisonKey(o,c)}getComparisonKey(n,o=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,o,c=!1){if(n.scheme===o.scheme){if(n.scheme===k.Schemas.file)return y.$Fg(s(n),s(o),this.a(n))&&n.query===o.query&&(c||n.fragment===o.fragment);if((0,e.$mh)(n.authority,o.authority))return y.$Fg(n.path,o.path,this.a(n),"/")&&n.query===o.query&&(c||n.fragment===o.fragment)}return!1}joinPath(n,...o){return v.URI.joinPath(n,...o)}basenameOrAuthority(n){return(0,e.$eh)(n)||n.authority}basename(n){return O.$jc.basename(n.path)}extname(n){return O.$jc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let o;return n.scheme===k.Schemas.file?o=v.URI.file(O.$pc(s(n))).path:(o=O.$jc.dirname(n.path),n.authority&&o.length&&o.charCodeAt(0)!==w.CharCode.Slash&&(console.error(`dirname("${n.toString})) resulted in a relative path`),o="/")),n.with({path:o})}normalizePath(n){if(!n.path.length)return n;let o;return n.scheme===k.Schemas.file?o=v.URI.file(O.$kc(s(n))).path:o=O.$jc.normalize(n.path),n.with({path:o})}relativePath(n,o){if(n.scheme!==o.scheme||!(0,e.$mh)(n.authority,o.authority))return;if(n.scheme===k.Schemas.file){const i=O.$oc(s(n),s(o));return R.$c?y.$zg(i):i}let c=n.path||"/";const h=o.path||"/";if(this.a(n)){let i=0;for(const r=Math.min(c.length,h.length);i<r&&!(c.charCodeAt(i)!==h.charCodeAt(i)&&c.charAt(i).toLowerCase()!==h.charAt(i).toLowerCase());i++);c=h.substr(0,i)+c.substr(i)}return O.$jc.relative(c,h)}resolvePath(n,o){if(n.scheme===k.Schemas.file){const c=v.URI.file(O.$nc(s(n),o));return n.with({authority:c.authority,path:c.path})}return o=y.$Ag(o),n.with({path:O.$jc.resolve(n.path,o)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,o){return n===o||n!==void 0&&o!==void 0&&(0,N.$Hf)(n,o)}hasTrailingPathSeparator(n,o=O.sep){if(n.scheme===k.Schemas.file){const c=s(n);return c.length>y.$Bg(c).length&&c[c.length-1]===o}else{const c=n.path;return c.length>1&&c.charCodeAt(c.length-1)===w.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,o=O.sep){return(0,e.$nh)(n,o)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,o=O.sep){let c=!1;if(n.scheme===k.Schemas.file){const h=s(n);c=h!==void 0&&h.length===y.$Bg(h).length&&h[h.length-1]===o}else{o="/";const h=n.path;c=h.length===1&&h.charCodeAt(h.length-1)===w.CharCode.Slash}return!c&&!(0,e.$nh)(n,o)?n.with({path:n.path+"/"}):n}}e.$9g=I,e.$0g=new I(()=>!1),e.$$g=new I(d=>d.scheme===k.Schemas.file?!R.$e:!0),e.$_g=new I(d=>!0),e.$ah=e.$0g.isEqual.bind(e.$0g),e.$bh=e.$0g.isEqualOrParent.bind(e.$0g),e.$ch=e.$0g.getComparisonKey.bind(e.$0g),e.$dh=e.$0g.basenameOrAuthority.bind(e.$0g),e.$eh=e.$0g.basename.bind(e.$0g),e.$fh=e.$0g.extname.bind(e.$0g),e.$gh=e.$0g.dirname.bind(e.$0g),e.$hh=e.$0g.joinPath.bind(e.$0g),e.$ih=e.$0g.normalizePath.bind(e.$0g),e.$jh=e.$0g.relativePath.bind(e.$0g),e.$kh=e.$0g.resolvePath.bind(e.$0g),e.$lh=e.$0g.isAbsolutePath.bind(e.$0g),e.$mh=e.$0g.isEqualAuthority.bind(e.$0g),e.$nh=e.$0g.hasTrailingPathSeparator.bind(e.$0g),e.$oh=e.$0g.removeTrailingPathSeparator.bind(e.$0g),e.$ph=e.$0g.addTrailingPathSeparator.bind(e.$0g);function E(d,n){const o=[];for(let c=0;c<d.length;c++){const h=n(d[c]);d.some((i,r)=>r===c?!1:(0,e.$bh)(h,n(i)))||o.push(d[c])}return o}var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function n(o){const c=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(r=>{const[t,a]=r.split(":");t&&a&&c.set(t,a)});const i=o.path.substring(0,o.path.indexOf(";"));return i&&c.set(d.META_DATA_MIME,i),c}d.parseMetaData=n})(u||(e.DataUri=u={}));function C(d,n,o){if(n){let c=d.path;return c&&c[0]!==O.$jc.sep&&(c=O.$jc.sep+c),d.with({scheme:o,authority:n,path:c})}return d.with({scheme:o})}}),define(Ie[11],Pe([1,0,22,14,6,4,24,21,147,48]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$8h=e.$7h=e.$6h=e.$5h=e.Promises=e.$4h=e.$3h=e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0,e.$sh=I,e.$th=E,e.$uh=u,e.$vh=C,e.$wh=d,e.$xh=n,e.$yh=o,e.$zh=c,e.$Hh=S,e.$Ih=D,e.$Jh=b,e.$Kh=T,e.$Lh=P,e.$1h=be,e.$9h=ne;function I(oe){return!!oe&&typeof oe.then=="function"}function E(oe){const H=new w.$ye,x=oe(H.token),ue=new Promise((me,Oe)=>{const je=H.token.onCancellationRequested(()=>{je.dispose(),Oe(new y.$8)});Promise.resolve(x).then(ke=>{je.dispose(),H.dispose(),me(ke)},ke=>{je.dispose(),H.dispose(),Oe(ke)})});return new class{cancel(){H.cancel(),H.dispose()}then(me,Oe){return ue.then(me,Oe)}catch(me){return this.then(void 0,me)}finally(me){return ue.finally(me)}}}function u(oe,H,x){return new Promise((ue,me)=>{const Oe=H.onCancellationRequested(()=>{Oe.dispose(),ue(x)});oe.then(ue,me).finally(()=>Oe.dispose())})}function C(oe,H){return new Promise((x,ue)=>{const me=H.onCancellationRequested(()=>{me.dispose(),ue(new y.$8)});oe.then(x,ue).finally(()=>me.dispose())})}async function d(oe){let H=-1;const x=oe.map((ue,me)=>ue.then(Oe=>(H=me,Oe)));try{return await Promise.race(x)}finally{oe.forEach((ue,me)=>{me!==H&&ue.cancel()})}}function n(oe,H,x){let ue;const me=setTimeout(()=>{ue?.(void 0),x?.()},H);return Promise.race([oe.finally(()=>clearTimeout(me)),new Promise(Oe=>ue=Oe)])}function o(oe){return new Promise((H,x)=>{const ue=oe();I(ue)?ue.then(H,x):H(ue)})}function c(){let oe,H;return{promise:new Promise((ue,me)=>{oe=ue,H=me}),resolve:oe,reject:H}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const x=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(x,x).then(ue)})}return new Promise((x,ue)=>{this.b.then(x,ue)})}return this.a=H(),new Promise((x,ue)=>{this.a.then(me=>{this.a=null,x(me)},me=>{this.a=null,ue(me)})})}dispose(){this.f=!0}}e.$Ah=h;class i{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Bh=i;class r{constructor(){this.a=new Map}queue(H,x){const me=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(H)===me&&this.a.delete(H)});return this.a.set(H,me),me}}e.$Ch=r;const t=(oe,H)=>{let x=!0;const ue=setTimeout(()=>{x=!1,H()},oe);return{isTriggered:()=>x,dispose:()=>{clearTimeout(ue),x=!1}}},a=oe=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,oe())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class l{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,x=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((me,Oe)=>{this.d=me,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=x===v.$ie?a(ue):t(x,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new y.$8),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dh=l;class g{constructor(H){this.a=new l(H),this.b=new h}trigger(H,x){return this.a.trigger(()=>this.b.queue(H),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eh=g;class m{constructor(){this.a=!1,this.b=new Promise((H,x)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fh=m;class $ extends m{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Gh=$;function S(oe,H){return H?new Promise((x,ue)=>{const me=setTimeout(()=>{Oe.dispose(),x()},oe),Oe=H.onCancellationRequested(()=>{clearTimeout(me),Oe.dispose(),ue(new y.$8)})}):E(x=>S(oe,x))}function D(oe,H=0,x){const ue=setTimeout(()=>{oe(),x&&me.dispose()},H),me=(0,O.$Vc)(()=>{clearTimeout(ue),x?.deleteAndLeak(me)});return x?.add(me),me}function b(oe){const H=[];let x=0;const ue=oe.length;function me(){return x<ue?oe[x++]():null}function Oe(je){je!=null&&H.push(je);const ke=me();return ke?ke.then(Oe):Promise.resolve(H)}return Promise.resolve(null).then(Oe)}function T(oe,H=ue=>!!ue,x=null){let ue=0;const me=oe.length,Oe=()=>{if(ue>=me)return Promise.resolve(x);const je=oe[ue++];return Promise.resolve(je()).then(Ae=>H(Ae)?Promise.resolve(Ae):Oe())};return Oe()}function P(oe,H=ue=>!!ue,x=null){if(oe.length===0)return Promise.resolve(x);let ue=oe.length;const me=()=>{ue=-1;for(const Oe of oe)Oe.cancel?.()};return new Promise((Oe,je)=>{for(const ke of oe)ke.then(Ae=>{--ue>=0&&H(Ae)?(me(),Oe(Ae)):ue===0&&Oe(x)}).catch(Ae=>{--ue>=0&&(me(),je(Ae))})})}class p{constructor(H){this.a=0,this.b=!1,this.f=H,this.g=[],this.d=0,this.h=new k.$ne}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(H){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,ue)=>{this.g.push({factory:H,c:x,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const H=this.g.shift();this.d++;const x=H.factory();x.then(H.c,H.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Mh=p;class f extends p{constructor(){super(1)}}e.$Nh=f;class M{constructor(){this.a=new de,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$Oh=M;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new Y;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueSize(H,x=R.$0g){const ue=x.getComparisonKey(H);return this.a.get(ue)?.size??0}queueFor(H,x,ue=R.$0g){const me=ue.getComparisonKey(H);let Oe=this.a.get(me);if(!Oe){Oe=new f;const je=this.f++,ke=k.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(je),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$7c),this.d.set(je,ke),this.a.set(me,Oe)}return Oe.queue(x)}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ph=L;class K{constructor(H,x){this.b=!1,this.a=-1,typeof H=="function"&&typeof x=="number"&&this.setIfNotSet(H,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,x){if(this.b)throw new y.$fb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},x)}setIfNotSet(H,x){if(this.b)throw new y.$fb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},x))}}e.$Qh=K;class J{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,x,ue=globalThis){if(this.f)throw new y.$fb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=ue.setInterval(()=>{H()},x);this.d=(0,O.$Vc)(()=>{ue.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Rh=J;class z{constructor(H,x){this.b=-1,this.a=H,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sh=z;class A{constructor(H,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=H,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Th=A;class W extends z{constructor(H,x){super(H,x),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$Uh=W;class Z extends O.$Xc{constructor(H,x){super(),this.g=H,this.h=x,this.a=[],this.b=this.B(new O.$Yc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of H)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vh=Z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Xh=(oe,H)=>{(0,N.$v)(()=>{if(x)return;const ue=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Xh=(oe,H,x)=>{const ue=oe.requestIdleCallback(H,typeof x=="number"?{timeout:x}:void 0);let me=!1;return{dispose(){me||(me=!0,oe.cancelIdleCallback(ue))}}},e.$Wh=oe=>(0,e.$Xh)(globalThis,oe)}();class he{constructor(H,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Xh)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Yh=he;class ve extends he{constructor(H){super(globalThis,H)}}e.$Zh=ve;async function be(oe,H,x){let ue;for(let me=0;me<x;me++)try{return await oe()}catch(Oe){ue=Oe,await S(H)}throw ue}class de{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,x,ue){return this.a={taskId:H,cancel:()=>ue?.(),promise:x},x.then(()=>this.d(H),()=>this.d(H)),x}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{const{promise:x,resolve:ue,reject:me}=c();this.b={run:H,promise:x,promiseResolve:ue,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$2h=de;class $e{constructor(H,x=()=>Date.now()){this.d=H,this.f=x,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$3h=$e;var ye;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(ye||(ye={}));class Y{get isRejected(){return this.d?.outcome===ye.Rejected}get isResolved(){return this.d?.outcome===ye.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ye.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((H,x)=>{this.a=H,this.b=x})}complete(H){return new Promise(x=>{this.a(H),this.d={outcome:ye.Resolved,value:H},x()})}error(H){return new Promise(x=>{this.b(H),this.d={outcome:ye.Rejected,value:H},x()})}cancel(){return this.error(new y.$8)}}e.$4h=Y;var we;(function(oe){async function H(ue){let me;const Oe=await Promise.all(ue.map(je=>je.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return Oe}oe.settled=H;function x(ue){return new Promise(async(me,Oe)=>{try{await ue(me,Oe)}catch(je){Oe(je)}})}oe.withAsyncBody=x})(we||(e.Promises=we={}));class Te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new y.$fb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$5h=Te;class re{constructor(H){this.b=H,this.a=new s.$X(()=>new Te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$6h=re;var q;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(q||(q={}));class ae{static fromArray(H){return new ae(x=>{x.emitMany(H)})}static fromPromise(H){return new ae(async x=>{x.emitMany(await H)})}static fromPromises(H){return new ae(async x=>{await Promise.all(H.map(async ue=>x.emitOne(await ue)))})}static merge(H){return new ae(async x=>{await Promise.all(H.map(async ue=>{for await(const me of ue)x.emitOne(me)}))})}constructor(H,x){this.a=q.Initial,this.b=[],this.d=null,this.f=x,this.g=new k.$ne,queueMicrotask(async()=>{const ue={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(H(ue)),this.k()}catch(me){this.l(me)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===q.DoneError)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===q.DoneOK)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(H,x){return new ae(async ue=>{for await(const me of H)ue.emitOne(x(me))})}map(H){return ae.map(this,H)}static filter(H,x){return new ae(async ue=>{for await(const me of H)x(me)&&ue.emitOne(me)})}filter(H){return ae.filter(this,H)}static coalesce(H){return ae.filter(H,x=>!!x)}coalesce(){return ae.coalesce(this)}static async toPromise(H){const x=[];for await(const ue of H)x.push(ue);return x}toPromise(){return ae.toPromise(this)}h(H){this.a===q.Initial&&(this.b.push(H),this.g.fire())}j(H){this.a===q.Initial&&(this.b=this.b.concat(H),this.g.fire())}k(){this.a===q.Initial&&(this.a=q.DoneOK,this.g.fire())}l(H){this.a===q.Initial&&(this.a=q.DoneError,this.d=H,this.g.fire())}}e.$7h=ae,ae.EMPTY=ae.fromArray([]);class le extends ae{constructor(H,x){super(x),this.m=H}cancel(){this.m.cancel()}}e.$8h=le;function ne(oe){const H=new w.$ye,x=oe(H.token);return new le(H,async ue=>{const me=H.token.onCancellationRequested(()=>{me.dispose(),H.dispose(),ue.reject(new y.$8)});try{for await(const Oe of x){if(H.token.isCancellationRequested)return;ue.emitOne(Oe)}me.dispose(),H.dispose()}catch(Oe){me.dispose(),H.dispose(),ue.reject(Oe)}})}class ce{constructor(H){this.a=new Y,this.b=new ae(me=>{if(x){me.reject(x);return}return ue&&me.emitMany(ue),this.d=Oe=>me.reject(Oe),this.f=Oe=>me.emitOne(Oe),this.a.p},H);let x,ue;this.f=me=>{ue||(ue=[]),ue.push(me)},this.d=me=>{x||(x=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$0h=ce}),define(Ie[41],Pe([1,0,18,11,28,52,29,20,21,13]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=e.$wk=void 0,e.$vk=I,e.$yk=n,e.$zk=M,e.$Ak=L,e.$Bk=K,e.$Ck=J,e.$Dk=z,e.$Ek=he;function I(){return Object.create(null)}e.$wk="**",e.$xk="/";const E="[/\\\\]",u="[^/\\\\]",C=/\//g;function d(ve,be){switch(ve){case 0:return"";case 1:return`${u}*?`;default:return`(?:${E}|${u}+${E}${be?`|${E}${u}+`:""})*?`}}function n(ve,be){if(!ve)return[];const de=[];let $e=!1,ye=!1,Y="";for(const we of ve){switch(we){case be:if(!$e&&!ye){de.push(Y),Y="";continue}break;case"{":$e=!0;break;case"}":$e=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}Y+=we}return Y&&de.push(Y),de}function o(ve){if(!ve)return"";let be="";const de=n(ve,e.$xk);if(de.every($e=>$e===e.$wk))be=".*";else{let $e=!1;de.forEach((ye,Y)=>{if(ye===e.$wk){if($e)return;be+=d(2,Y===de.length-1)}else{let we=!1,Te="",re=!1,q="";for(const ae of ye){if(ae!=="}"&&we){Te+=ae;continue}if(re&&(ae!=="]"||!q)){let le;ae==="-"?le=ae:(ae==="^"||ae==="!")&&!q?le="^":ae===e.$xk?le="":le=(0,s.$jf)(ae),q+=le;continue}switch(ae){case"{":we=!0;continue;case"[":re=!0;continue;case"}":{const ne=`(?:${n(Te,",").map(ce=>o(ce)).join("|")})`;be+=ne,we=!1,Te="";break}case"]":{be+="["+q+"]",re=!1,q="";break}case"?":be+=u;continue;case"*":be+=d(1);continue;default:be+=(0,s.$jf)(ae)}}Y<de.length-1&&(de[Y+1]!==e.$wk||Y+2<de.length)&&(be+=E)}$e=ye===e.$wk})}return be}const c=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new R.$Gc(1e4),g=function(){return!1},m=function(){return null};function $(ve,be){if(!ve)return m;let de;typeof ve!="string"?de=ve.pattern:de=ve,de=de.trim();const $e=`${de}_${!!be.trimForExclusions}`;let ye=l.get($e);if(ye)return S(ye,ve);let Y;return c.test(de)?ye=b(de.substr(4),de):(Y=h.exec(D(de,be)))?ye=T(Y[1],de):(be.trimForExclusions?r:i).test(de)?ye=P(de,be):(Y=t.exec(D(de,be)))?ye=p(Y[1].substr(1),de,!0):(Y=a.exec(D(de,be)))?ye=p(Y[1],de,!1):ye=f(de),l.set($e,ye),S(ye,ve)}function S(ve,be){if(typeof be=="string")return ve;const de=function($e,ye){return(0,O.$Fg)($e,be.base,!v.$e)?ve((0,s.$of)($e.substr(be.base.length),N.sep),ye):null};return de.allBasenames=ve.allBasenames,de.allPaths=ve.allPaths,de.basenames=ve.basenames,de.patterns=ve.patterns,de}function D(ve,be){return be.trimForExclusions&&ve.endsWith("/**")?ve.substr(0,ve.length-2):ve}function b(ve,be){return function(de,$e){return typeof de=="string"&&de.endsWith(ve)?be:null}}function T(ve,be){const de=`/${ve}`,$e=`\\${ve}`,ye=function(we,Te){return typeof we!="string"?null:Te?Te===ve?be:null:we===ve||we.endsWith(de)||we.endsWith($e)?be:null},Y=[ve];return ye.basenames=Y,ye.patterns=[be],ye.allBasenames=Y,ye}function P(ve,be){const de=Z(ve.slice(1,-1).split(",").map(Te=>$(Te,be)).filter(Te=>Te!==m),ve),$e=de.length;if(!$e)return m;if($e===1)return de[0];const ye=function(Te,re){for(let q=0,ae=de.length;q<ae;q++)if(de[q](Te,re))return ve;return null},Y=de.find(Te=>!!Te.allBasenames);Y&&(ye.allBasenames=Y.allBasenames);const we=de.reduce((Te,re)=>re.allPaths?Te.concat(re.allPaths):Te,[]);return we.length&&(ye.allPaths=we),ye}function p(ve,be,de){const $e=N.sep===N.$jc.sep,ye=$e?ve:ve.replace(C,N.sep),Y=N.sep+ye,we=N.$jc.sep+ve;let Te;return de?Te=function(re,q){return typeof re=="string"&&(re===ye||re.endsWith(Y)||!$e&&(re===ve||re.endsWith(we)))?be:null}:Te=function(re,q){return typeof re=="string"&&(re===ye||!$e&&re===ve)?be:null},Te.allPaths=[(de?"*/":"./")+ve],Te}function f(ve){try{const be=new RegExp(`^${o(ve)}$`);return function(de){return be.lastIndex=0,typeof de=="string"&&be.test(de)?ve:null}}catch{return m}}function M(ve,be,de){return!ve||typeof be!="string"?!1:L(ve)(be,void 0,de)}function L(ve,be={}){if(!ve)return g;if(typeof ve=="string"||K(ve)){const de=$(ve,be);if(de===m)return g;const $e=function(ye,Y){return!!de(ye,Y)};return de.allBasenames&&($e.allBasenames=de.allBasenames),de.allPaths&&($e.allPaths=de.allPaths),$e}return A(ve,be)}function K(ve){const be=ve;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}function J(ve){return ve.allBasenames||[]}function z(ve){return ve.allPaths||[]}function A(ve,be){const de=Z(Object.getOwnPropertyNames(ve).map(Te=>W(Te,ve[Te],be)).filter(Te=>Te!==m)),$e=de.length;if(!$e)return m;if(!de.some(Te=>!!Te.requiresSiblings)){if($e===1)return de[0];const Te=function(ae,le){let ne;for(let ce=0,oe=de.length;ce<oe;ce++){const H=de[ce](ae,le);if(typeof H=="string")return H;(0,y.$sh)(H)&&(ne||(ne=[]),ne.push(H))}return ne?(async()=>{for(const ce of ne){const oe=await ce;if(typeof oe=="string")return oe}return null})():null},re=de.find(ae=>!!ae.allBasenames);re&&(Te.allBasenames=re.allBasenames);const q=de.reduce((ae,le)=>le.allPaths?ae.concat(le.allPaths):ae,[]);return q.length&&(Te.allPaths=q),Te}const ye=function(Te,re,q){let ae,le;for(let ne=0,ce=de.length;ne<ce;ne++){const oe=de[ne];oe.requiresSiblings&&q&&(re||(re=(0,N.$qc)(Te)),ae||(ae=re.substr(0,re.length-(0,N.$rc)(Te).length)));const H=oe(Te,re,ae,q);if(typeof H=="string")return H;(0,y.$sh)(H)&&(le||(le=[]),le.push(H))}return le?(async()=>{for(const ne of le){const ce=await ne;if(typeof ce=="string")return ce}return null})():null},Y=de.find(Te=>!!Te.allBasenames);Y&&(ye.allBasenames=Y.allBasenames);const we=de.reduce((Te,re)=>re.allPaths?Te.concat(re.allPaths):Te,[]);return we.length&&(ye.allPaths=we),ye}function W(ve,be,de){if(be===!1)return m;const $e=$(ve,de);if($e===m)return m;if(typeof be=="boolean")return $e;if(be){const ye=be.when;if(typeof ye=="string"){const Y=(we,Te,re,q)=>{if(!q||!$e(we,Te))return null;const ae=ye.replace("$(basename)",()=>re),le=q(ae);return(0,y.$sh)(le)?le.then(ne=>ne?ve:null):le?ve:null};return Y.requiresSiblings=!0,Y}}return $e}function Z(ve,be){const de=ve.filter(Te=>!!Te.basenames);if(de.length<2)return ve;const $e=de.reduce((Te,re)=>{const q=re.basenames;return q?Te.concat(q):Te},[]);let ye;if(be){ye=[];for(let Te=0,re=$e.length;Te<re;Te++)ye.push(be)}else ye=de.reduce((Te,re)=>{const q=re.patterns;return q?Te.concat(q):Te},[]);const Y=function(Te,re){if(typeof Te!="string")return null;if(!re){let ae;for(ae=Te.length;ae>0;ae--){const le=Te.charCodeAt(ae-1);if(le===k.CharCode.Slash||le===k.CharCode.Backslash)break}re=Te.substr(ae)}const q=$e.indexOf(re);return q!==-1?ye[q]:null};Y.basenames=$e,Y.patterns=ye,Y.allBasenames=$e;const we=ve.filter(Te=>!Te.basenames);return we.push(Y),we}function he(ve,be){return(0,w.$xb)(ve,be,(de,$e)=>typeof de=="string"&&typeof $e=="string"?de===$e:typeof de!="string"&&typeof $e!="string"?de.base===$e.base&&de.pattern===$e.pattern:!1)}}),define(Ie[60],Pe([1,0,14,99,24,13,2]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.MarkdownStringTextNewlineStyle=void 0,e.$5k=s,e.$6k=I,e.$7k=E,e.$8k=u,e.$9k=C,e.$0k=d,e.$$k=n,e.$_k=o;var N;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(N||(e.MarkdownStringTextNewlineStyle=N={}));class v{constructor(h="",i=!1){if(this.value=h,typeof this.value!="string")throw(0,w.$0)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(h,i=N.Paragraph){return this.value+=u(this.supportThemeIcons?(0,y.$Xk)(h):h).replace(/([ \t]+)/g,(r,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===N.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,i){return this.value+=`
${C(i,h)}
`,this}appendLink(h,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(h),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(h,i){const r=new RegExp((0,O.$jf)(i),"g");return h.replace(r,(t,a)=>h.charAt(a-1)!=="\\"?`\\${t}`:t)}}e.$4k=v;function s(c){return I(c)?!c.value:Array.isArray(c)?c.every(s):!0}function I(c){return c instanceof v?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function E(c,h){return c===h?!0:!c||!h?!1:c.value===h.value&&c.isTrusted===h.isTrusted&&c.supportThemeIcons===h.supportThemeIcons&&c.supportHtml===h.supportHtml&&(c.baseUri===h.baseUri||!!c.baseUri&&!!h.baseUri&&(0,k.$ah)(R.URI.from(c.baseUri),R.URI.from(h.baseUri)))}function u(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function C(c,h){const i=c.match(/^`+/gm)?.reduce((t,a)=>t.length>a.length?t:a).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${h}`,c,`${"`".repeat(r)}`].join(`
`)}function d(c){return c.replace(/"/g,"&quot;")}function n(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(c){const h=[],i=c.split("|").map(t=>t.trim());c=i[0];const r=i[1];if(r){const t=/height=(\d+)/.exec(r),a=/width=(\d+)/.exec(r),l=t?t[1]:"",g=a?a[1]:"",m=isFinite(parseInt(g)),$=isFinite(parseInt(l));m&&h.push(`width="${g}"`),$&&h.push(`height="${l}"`)}return{href:c,dimensions:h}}}),define(Ie[100],Pe([1,0,18,52,20,21,24,13]),function(_,e,w,y,k,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xw=v,e.$Yw=I,e.$Zw=u,e.$1w=C,e.$2w=c,e.$3w=i,e.$4w=r,e.$5w=t,e.$6w=a,e.$7w=l;function v(m,$){const{os:S,tildify:D,relative:b}=$;if(b){const p=s(m,b,S);if(typeof p=="string")return p}let T=m.fsPath;if(S===O.OperatingSystem.Windows&&!O.$c?T=T.replace(/\//g,"\\"):S!==O.OperatingSystem.Windows&&O.$c&&(T=T.replace(/\\/g,"/")),S!==O.OperatingSystem.Windows&&D?.userHome){const p=D.userHome.fsPath;let f;m.scheme!==D.userHome.scheme&&m.path[0]===k.$jc.sep&&m.path[1]!==k.$jc.sep?f=D.userHome.with({path:m.path}).fsPath:f=T,T=u(f,p,S)}return(S===O.OperatingSystem.Windows?k.$ic:k.$jc).normalize(I(T,S===O.OperatingSystem.Windows))}function s(m,$,S){const D=S===O.OperatingSystem.Windows?k.$ic:k.$jc,b=S===O.OperatingSystem.Linux?R.$0g:R.$_g,T=$.getWorkspace(),P=(0,w.$Rb)(T.folders);if(!P)return;m.scheme!==P.uri.scheme&&m.path[0]===k.$jc.sep&&m.path[1]!==k.$jc.sep&&(m=P.uri.with({path:m.path}));const p=$.getWorkspaceFolder(m);if(!p)return;let f;if(b.isEqual(p.uri,m)?f="":f=b.relativePath(p.uri,m)??"",f&&(f=D.normalize(f)),T.folders.length>1&&!$.noPrefix){const M=p.name?p.name:b.basenameOrAuthority(p.uri);f=f?`${M} \u2022 ${f}`:M}return f}function I(m,$=O.$c){return(0,y.$Kg)(m,$)?m.charAt(0).toUpperCase()+m.slice(1):m}let E=Object.create(null);function u(m,$,S=O.OS){if(S===O.OperatingSystem.Windows||!m||!$)return m;let D=E.original===$?E.normalized:void 0;D||(D=$,O.$c&&(D=(0,y.$zg)(D)),D=`${(0,N.$pf)(D,k.$jc.sep)}${k.$jc.sep}`,E={original:$,normalized:D});let b=m;return O.$c&&(b=(0,y.$zg)(b)),(S===O.OperatingSystem.Linux?b.startsWith(D):(0,N.$If)(b,D))?`~/${b.substr(D.length)}`:m}function C(m,$){return m.replace(/^~($|\/|\\)/,`${$}$1`)}const d="\u2026",n="\\\\",o="~";function c(m,$=k.sep){const S=new Array(m.length);let D=!1;for(let b=0;b<m.length;b++){const T=m[b];if(T===""){S[b]=`.${$}`;continue}if(!T){S[b]=T;continue}D=!0;let P="",p=T;p.indexOf(n)===0?(P=p.substr(0,p.indexOf(n)+n.length),p=p.substr(p.indexOf(n)+n.length)):p.indexOf($)===0?(P=p.substr(0,p.indexOf($)+$.length),p=p.substr(p.indexOf($)+$.length)):p.indexOf(o)===0&&(P=p.substr(0,p.indexOf(o)+o.length),p=p.substr(p.indexOf(o)+o.length));const f=p.split($);for(let M=1;D&&M<=f.length;M++)for(let L=f.length-M;D&&L>=0;L--){D=!1;let K=f.slice(L,L+M).join($);for(let J=0;!D&&J<m.length;J++)if(J!==b&&m[J]&&m[J].indexOf(K)>-1){const z=L+M===f.length,A=L>0&&m[J].indexOf($)>-1?$+K:K,W=m[J].endsWith(A);D=!z||W}if(!D){let J="";(f[0].endsWith(":")||P!=="")&&(L===1&&(L=0,M++,K=f[0]+$+K),L>0&&(J=f[0]+$),J=P+J),L>0&&(J=J+d+$),J=J+K,L+M<f.length&&(J=J+$+d),S[b]=J}}D&&(S[b]=T)}return S}var h;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function i(m,$=Object.create(null)){const S=[];let D=!1,b="";for(const T of m)if(T==="$"||D&&T==="{")b&&S.push({value:b,type:h.TEXT}),b="",D=!0;else if(T==="}"&&D){const P=$[b];if(typeof P=="string")P.length&&S.push({value:P,type:h.VARIABLE});else if(P){const p=S[S.length-1];(!p||p.type!==h.SEPARATOR)&&S.push({value:P.label,type:h.SEPARATOR})}b="",D=!1}else b+=T;return b&&!D&&S.push({value:b,type:h.TEXT}),S.filter((T,P)=>{if(T.type===h.SEPARATOR){const p=S[P-1],f=S[P+1];return[p,f].every(M=>M&&(M.type===h.VARIABLE||M.type===h.TEXT)&&M.value.length>0)}return!0}).map(T=>T.value).join("")}function r(m,$){return O.$d||$?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$d?"&":"&&"):m.replace(/&&|&/g,S=>S==="&"?"&&":"&")}function t(m,$){return O.$d||$?m.replace(/\(&&\w\)|&&/g,""):O.$c?m.replace(/&&|&/g,S=>S==="&"?"&&":"&"):m.replace(/&&/g,"_")}function a(m){return m.replace(/&/g,"&&")}function l(m){if(m.endsWith("]")){const $=m.lastIndexOf(" [",m.length-2);if($!==-1){const S=g(m.substring(0,$)),D=m.substring($);return{name:S.name+D,parentPath:S.parentPath}}}return g(m)}function g(m){const $=m.indexOf("/")!==-1?k.$jc:k.$ic,S=$.basename(m),D=$.dirname(m);return S.length?{name:S,parentPath:D}:{name:D,parentPath:""}}}),define(Ie[149],Pe([1,0,23,37,2]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=void 0,e.$Pn=v,e.$Qn=I,e.$Rn=E;function O(u){return u.toJSON()}class R{constructor(C){this.a=C}transformIncoming(C){const d=this.a.transformIncoming(C);return d===C?C:O(k.URI.from(d))}transformOutgoing(C){const d=this.a.transformOutgoing(C);return d===C?C:O(k.URI.from(d))}transformOutgoingURI(C){const d=this.a.transformOutgoing(C);return d===C?C:k.URI.from(d)}transformOutgoingScheme(C){return this.a.transformOutgoingScheme(C)}}e.$Nn=R,e.$On=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function N(u,C,d){if(!u||d>200)return null;if(typeof u=="object"){if(u instanceof k.URI)return C.transformOutgoing(u);for(const n in u)if(Object.hasOwnProperty.call(u,n)){const o=N(u[n],C,d+1);o!==null&&(u[n]=o)}}return null}function v(u,C){const d=N(u,C,0);return d===null?u:d}function s(u,C,d,n){if(!u||n>200)return null;if(typeof u=="object"){if(u.$mid===y.MarshalledId.Uri)return d?k.URI.revive(C.transformIncoming(u)):C.transformIncoming(u);if(u instanceof w.$Pe)return null;for(const o in u)if(Object.hasOwnProperty.call(u,o)){const c=s(u[o],C,d,n+1);c!==null&&(u[o]=c)}}return null}function I(u,C){const d=s(u,C,!1,0);return d===null?u:d}function E(u,C){const d=s(u,C,!0,0);return d===null?u:d}}),define(Ie[38],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=void 0,e.$2g=y;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function y(k){return w.test(k)}e.$3g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(N){for(let v=0;v<N.length;v++)N[v]=Math.floor(Math.random()*256);return N};const O=new Uint8Array(16),R=[];for(let N=0;N<256;N++)R.push(N.toString(16).padStart(2,"0"));return function(){k(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let v=0,s="";return s+=R[O[v++]],s+=R[O[v++]],s+=R[O[v++]],s+=R[O[v++]],s+="-",s+=R[O[v++]],s+=R[O[v++]],s+="-",s+=R[O[v++]],s+=R[O[v++]],s+="-",s+=R[O[v++]],s+=R[O[v++]],s+="-",s+=R[O[v++]],s+=R[O[v++]],s+=R[O[v++]],s+=R[O[v++]],s+=R[O[v++]],s+=R[O[v++]],s}}()}),define(Ie[150],Pe([1,0,18,40,38]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=e.$pu=void 0,e.$nu=O,e.$ou=R,e.$qu=s;function O(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function R(E,u,C){const d={id:(0,k.$3g)(),name:E,uri:u,data:C};return{asString:async()=>"",asFile:()=>d,value:void 0}}class N{constructor(){this.a=new Map}get size(){let u=0;for(const C of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const C=[...this.a.keys()];return y.Iterable.some(this,([d,n])=>n.asFile())&&C.push("files"),I(v(u),C)}get(u){return this.a.get(this.b(u))?.[0]}append(u,C){const d=this.a.get(u);d?d.push(C):this.a.set(this.b(u),[C])}replace(u,C){this.a.set(this.b(u),[C])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,C]of this.a)for(const d of C)yield[u,d]}b(u){return v(u)}}e.$pu=N;function v(E){return E.toLowerCase()}function s(E,u){return I(v(E),u.map(v))}function I(E,u){if(E==="*/*")return u.length>0;if(u.includes(E))return!0;const C=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!C)return!1;const[d,n,o]=C;return o==="*"?u.some(c=>c.startsWith(n+"/")):!1}e.$ru=Object.freeze({create:E=>(0,w.$Pb)(E.map(u=>u.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$ru.split(E).filter(u=>!u.startsWith("#"))})}),define(Ie[151],Pe([1,0,11,6,4,49,15]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.StorageState=e.StorageHint=void 0,e.$cq=v;var N;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N||(e.StorageHint=N={}));function v(u){const C=u;return C?.changed instanceof Map||C?.deleted instanceof Set}var s;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(s||(e.StorageState=s={}));class I extends k.$Xc{constructor(C,d=Object.create(null)){super(),this.r=C,this.s=d,this.b=this.B(new y.$qe),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new w.$Eh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(C=>this.u(C)))}u(C){this.b.pause();try{C.changed?.forEach((d,n)=>this.w(n,d)),C.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(C,d){if(this.c===s.Closed)return;let n=!1;(0,R.$pg)(d)?n=this.f.delete(C):this.f.get(C)!==d&&(this.f.set(C,d),n=!0),n&&this.b.fire({key:C,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(C,d){const n=this.f.get(C);return(0,R.$pg)(n)?d:n}getBoolean(C,d){const n=this.get(C);return(0,R.$pg)(n)?d:n==="true"}getNumber(C,d){const n=this.get(C);return(0,R.$pg)(n)?d:parseInt(n,10)}getObject(C,d){const n=this.get(C);return(0,R.$pg)(n)?d:(0,O.$ci)(n)}async set(C,d,n=!1){if(this.c===s.Closed)return;if((0,R.$pg)(d))return this.delete(C,n);const o=(0,R.$ig)(d)||Array.isArray(d)?(0,O.$bi)(d):String(d);if(this.f.get(C)!==o)return this.f.set(C,o),this.j.set(C,o),this.h.delete(C),this.b.fire({key:C,external:n}),this.D()}async delete(C,d=!1){if(!(this.c===s.Closed||!this.f.delete(C)))return this.h.has(C)||this.h.add(C),this.j.delete(C),this.b.fire({key:C,external:d}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const C={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(C).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(C){if(!(this.c===s.Closed||this.m))return this.D(C)}async D(C){return this.s.hint===N.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),C)}async whenFlushed(){if(this.z)return new Promise(C=>this.n.push(C))}isInMemory(){return this.s.hint===N.STORAGE_IN_MEMORY}}e.$dq=I,I.a=100;class E{constructor(){this.onDidChangeItemsExternal=y.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(C){C.insert?.forEach((d,n)=>this.a.set(n,d)),C.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$eq=E}),define(Ie[152],Pe([1,0,28]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$xu=k;var y;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function k(O){let R=0,N=0,v=0,s=y.Unknown;for(let I=0,E=O.length;I<E;I++){const u=O.charCodeAt(I);u===w.CharCode.CarriageReturn?(R===0&&(N=I),R++,I+1<E&&O.charCodeAt(I+1)===w.CharCode.LineFeed?(s|=y.CRLF,I++):s|=y.Invalid,v=I+1):u===w.CharCode.LineFeed&&(s|=y.LF,R===0&&(N=I),R++,v=I+1)}return R===0&&(N=O.length),[R,N,O.length-v,s]}}),define(Ie[153],Pe([1,0,13,21,23]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=void 0,e.$au=I,e.$bu=E,w=Ve(w),y=Ve(y),k=Ve(k);let O;function R(){return O||(O=new TextDecoder("UTF-16LE")),O}let N;function v(){return N||(N=new TextDecoder("UTF-16BE")),N}let s;function I(){return s||(s=y.$x()?R():v()),s}function E(d,n,o){const c=new Uint16Array(d.buffer,n,o);return o>0&&(c[0]===65279||c[0]===65534)?u(d,n,o):R().decode(c)}function u(d,n,o){const c=[];let h=0;for(let i=0;i<o;i++){const r=k.$Re(d,n);n+=2,c[h++]=String.fromCharCode(r)}return c.join("")}class C{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return I().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||w.$Lf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let c=0;c<o;c++)this.b[this.d++]=n.charCodeAt(c)}}e.$cu=C}),define(Ie[154],Pe([1,0,23,153]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=void 0,e.$eu=R,w=Ve(w);function k(v){return v.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(s,I,E,u){this.oldPosition=s,this.oldText=I,this.newPosition=E,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${k(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${k(this.oldText)}")`:`(replace@${this.oldPosition} "${k(this.oldText)}" with "${k(this.newText)}")`}static a(s){return 4+2*s.length}static c(s,I,E){const u=I.length;w.$Ue(s,u,E),E+=4;for(let C=0;C<u;C++)w.$Se(s,I.charCodeAt(C),E),E+=2;return E}static d(s,I){const E=w.$Te(s,I);return I+=4,(0,y.$bu)(s,I,E)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(s,I){return w.$Ue(s,this.oldPosition,I),I+=4,w.$Ue(s,this.newPosition,I),I+=4,I=O.c(s,this.oldText,I),I=O.c(s,this.newText,I),I}static read(s,I,E){const u=w.$Te(s,I);I+=4;const C=w.$Te(s,I);I+=4;const d=O.d(s,I);I+=O.a(d);const n=O.d(s,I);return I+=O.a(n),E.push(new O(u,d,C,n)),I}}e.$du=O;function R(v,s){return v===null||v.length===0?s:new N(v,s).compress()}class N{constructor(s,I){this.a=s,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let s=0,I=0,E=this.n(s),u=this.l(I);for(;s<this.f||I<this.h;){if(E===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(E),E=this.n(++s);continue}if(u.oldEnd<=E.newPosition){this.k(u),u=this.l(++I);continue}if(E.newEnd<=u.oldPosition){this.m(E),E=this.n(++s);continue}if(u.oldPosition<E.newPosition){const[c,h]=N.r(u,E.newPosition-u.oldPosition);this.k(c),u=h;continue}if(E.newPosition<u.oldPosition){const[c,h]=N.q(E,u.oldPosition-E.newPosition);this.m(c),E=h;continue}let n,o;if(u.oldEnd===E.newEnd)n=E,o=u,E=this.n(++s),u=this.l(++I);else if(u.oldEnd<E.newEnd){const[c,h]=N.q(E,u.oldLength);n=c,o=u,E=h,u=this.l(++I)}else{const[c,h]=N.r(u,E.newLength);n=E,o=c,E=this.n(++s),u=h}this.d[this.e++]=new O(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const C=N.s(this.d);return N.t(C)}k(s){this.d[this.e++]=N.o(this.g,s),this.j+=s.newLength-s.oldLength}l(s){return s<this.h?this.c[s]:null}m(s){this.d[this.e++]=N.p(this.j,s),this.g+=s.newLength-s.oldLength}n(s){return s<this.f?this.a[s]:null}static o(s,I){return new O(I.oldPosition-s,I.oldText,I.newPosition,I.newText)}static p(s,I){return new O(I.oldPosition,I.oldText,I.newPosition+s,I.newText)}static q(s,I){const E=s.newText.substr(0,I),u=s.newText.substr(I);return[new O(s.oldPosition,s.oldText,s.newPosition,E),new O(s.oldEnd,"",s.newPosition+I,u)]}static r(s,I){const E=s.oldText.substr(0,I),u=s.oldText.substr(I);return[new O(s.oldPosition,E,s.newPosition,s.newText),new O(s.oldPosition+I,u,s.newEnd,"")]}static s(s){if(s.length===0)return s;const I=[];let E=0,u=s[0];for(let C=1;C<s.length;C++){const d=s[C];u.oldEnd===d.oldPosition?u=new O(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(I[E++]=u,u=d)}return I[E++]=u,I}static t(s){if(s.length===0)return s;const I=[];let E=0;for(let u=0;u<s.length;u++){const C=s[u];C.oldText!==C.newText&&(I[E++]=C)}return I}}}),define(Ie[155],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0,e.$kt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[156],Pe([1,0,41,20]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uu=k,e.$vu=O;function k(R,N,v,s,I,E){if(Array.isArray(R)){let u=0;for(const C of R){const d=k(C,N,v,s,I,E);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof R=="string")return s?R==="*"?5:R===v?10:0:0;if(R){const{language:u,pattern:C,scheme:d,hasAccessToAllModels:n,notebookType:o}=R;if(!s&&!n)return 0;o&&I&&(N=I);let c=0;if(d)if(d===N.scheme)c=10;else if(d==="*")c=5;else return 0;if(u)if(u===v)c=10;else if(u==="*")c=Math.max(c,5);else return 0;if(o)if(o===E)c=10;else if(o==="*"&&E!==void 0)c=Math.max(c,5);else return 0;if(C){let h;if(typeof C=="string"?h=C:h={...C,base:(0,y.$kc)(C.base)},h===N.fsPath||(0,w.$zk)(h,N.fsPath))c=10;else return 0}return c}else return 0}}function O(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(O):!!R.notebookType}}),define(Ie[157],Pe([1,0,28,158]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.IndentAction=void 0;var k;(function(v){v[v.None=0]="None",v[v.Indent=1]="Indent",v[v.IndentOutdent=2]="IndentOutdent",v[v.Outdent=3]="Outdent"})(k||(e.IndentAction=k={}));class O{constructor(s){if(this.e=null,this.f=!1,this.open=s.open,this.close=s.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(s.notIn))for(let I=0,E=s.notIn.length;I<E;I++)switch(s.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(s){switch(s){case y.StandardTokenType.Other:return!0;case y.StandardTokenType.Comment:return this.c;case y.StandardTokenType.String:return this.b;case y.StandardTokenType.RegEx:return this.d}}shouldAutoClose(s,I){if(s.getTokenCount()===0)return!0;const E=s.findTokenIndexAtOffset(I-2),u=s.getStandardTokenType(E);return this.isOK(u)}g(s,I){for(let E=s;E<=I;E++){const u=String.fromCharCode(E);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(w.CharCode.Digit0,w.CharCode.Digit9)),this.e||(this.e=this.g(w.CharCode.a,w.CharCode.z)),this.e||(this.e=this.g(w.CharCode.A,w.CharCode.Z))),this.e}}e.$Uu=O;class R{constructor(s){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of s)N(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),N(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),N(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),N(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&N(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Vu=R;function N(v,s,I){v.has(s)?v.get(s).push(I):v.set(s,[I])}}),define(Ie[159],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=e.NodeColor=e.$4C=void 0,e.$6C=k,e.$7C=O,e.$8C=s,e.$9C=I,e.$0C=E,e.$$C=u,e.$_C=C,e.$aD=d;class w{constructor(o,c){this.piece=o,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$5C)return k(this.right);let o=this;for(;o.parent!==e.$5C&&o.parent.left!==o;)o=o.parent;return o.parent===e.$5C?e.$5C:o.parent}prev(){if(this.left!==e.$5C)return O(this.left);let o=this;for(;o.parent!==e.$5C&&o.parent.right!==o;)o=o.parent;return o.parent===e.$5C?e.$5C:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$4C=w;var y;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(y||(e.NodeColor=y={})),e.$5C=new w(null,y.Black),e.$5C.parent=e.$5C,e.$5C.left=e.$5C,e.$5C.right=e.$5C,e.$5C.color=y.Black;function k(n){for(;n.left!==e.$5C;)n=n.left;return n}function O(n){for(;n.right!==e.$5C;)n=n.right;return n}function R(n){return n===e.$5C?0:n.size_left+n.piece.length+R(n.right)}function N(n){return n===e.$5C?0:n.lf_left+n.piece.lineFeedCnt+N(n.right)}function v(){e.$5C.parent=e.$5C}function s(n,o){const c=o.right;c.size_left+=o.size_left+(o.piece?o.piece.length:0),c.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=c.left,c.left!==e.$5C&&(c.left.parent=o),c.parent=o.parent,o.parent===e.$5C?n.root=c:o.parent.left===o?o.parent.left=c:o.parent.right=c,c.left=o,o.parent=c}function I(n,o){const c=o.left;o.left=c.right,c.right!==e.$5C&&(c.right.parent=o),c.parent=o.parent,o.size_left-=c.size_left+(c.piece?c.piece.length:0),o.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),o.parent===e.$5C?n.root=c:o===o.parent.right?o.parent.right=c:o.parent.left=c,c.right=o,o.parent=c}function E(n,o){let c,h;if(o.left===e.$5C?(h=o,c=h.right):o.right===e.$5C?(h=o,c=h.left):(h=k(o.right),c=h.right),h===n.root){n.root=c,c.color=y.Black,o.detach(),v(),n.root.parent=e.$5C;return}const i=h.color===y.Red;if(h===h.parent.left?h.parent.left=c:h.parent.right=c,h===o?(c.parent=h.parent,d(n,c)):(h.parent===o?c.parent=h:c.parent=h.parent,d(n,c),h.left=o.left,h.right=o.right,h.parent=o.parent,h.color=o.color,o===n.root?n.root=h:o===o.parent.left?o.parent.left=h:o.parent.right=h,h.left!==e.$5C&&(h.left.parent=h),h.right!==e.$5C&&(h.right.parent=h),h.size_left=o.size_left,h.lf_left=o.lf_left,d(n,h)),o.detach(),c.parent.left===c){const t=R(c),a=N(c);if(t!==c.parent.size_left||a!==c.parent.lf_left){const l=t-c.parent.size_left,g=a-c.parent.lf_left;c.parent.size_left=t,c.parent.lf_left=a,C(n,c.parent,l,g)}}if(d(n,c.parent),i){v();return}let r;for(;c!==n.root&&c.color===y.Black;)c===c.parent.left?(r=c.parent.right,r.color===y.Red&&(r.color=y.Black,c.parent.color=y.Red,s(n,c.parent),r=c.parent.right),r.left.color===y.Black&&r.right.color===y.Black?(r.color=y.Red,c=c.parent):(r.right.color===y.Black&&(r.left.color=y.Black,r.color=y.Red,I(n,r),r=c.parent.right),r.color=c.parent.color,c.parent.color=y.Black,r.right.color=y.Black,s(n,c.parent),c=n.root)):(r=c.parent.left,r.color===y.Red&&(r.color=y.Black,c.parent.color=y.Red,I(n,c.parent),r=c.parent.left),r.left.color===y.Black&&r.right.color===y.Black?(r.color=y.Red,c=c.parent):(r.left.color===y.Black&&(r.right.color=y.Black,r.color=y.Red,s(n,r),r=c.parent.left),r.color=c.parent.color,c.parent.color=y.Black,r.left.color=y.Black,I(n,c.parent),c=n.root));c.color=y.Black,v()}function u(n,o){for(d(n,o);o!==n.root&&o.parent.color===y.Red;)if(o.parent===o.parent.parent.left){const c=o.parent.parent.right;c.color===y.Red?(o.parent.color=y.Black,c.color=y.Black,o.parent.parent.color=y.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,s(n,o)),o.parent.color=y.Black,o.parent.parent.color=y.Red,I(n,o.parent.parent))}else{const c=o.parent.parent.left;c.color===y.Red?(o.parent.color=y.Black,c.color=y.Black,o.parent.parent.color=y.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,I(n,o)),o.parent.color=y.Black,o.parent.parent.color=y.Red,s(n,o.parent.parent))}n.root.color=y.Black}function C(n,o,c,h){for(;o!==n.root&&o!==e.$5C;)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=h),o=o.parent}function d(n,o){let c=0,h=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,c=R(o.left)-o.size_left,h=N(o.left)-o.lf_left,o.size_left+=c,o.lf_left+=h;o!==n.root&&(c!==0||h!==0);)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=h),o=o.parent}}}),define(Ie[101],Pe([1,0,28,102,33,53,159,103]),function(_,e,w,y,k,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=e.$kD=e.$jD=void 0,e.$hD=E,e.$iD=u;const v=65535;function s(h){let i;return h[h.length-1]<65536?i=new Uint16Array(h.length):i=new Uint32Array(h.length),i.set(h,0),i}class I{constructor(i,r,t,a,l){this.lineStarts=i,this.cr=r,this.lf=t,this.crlf=a,this.isBasicASCII=l}}function E(h,i=!0){const r=[0];let t=1;for(let a=0,l=h.length;a<l;a++){const g=h.charCodeAt(a);g===w.CharCode.CarriageReturn?a+1<l&&h.charCodeAt(a+1)===w.CharCode.LineFeed?(r[t++]=a+2,a++):r[t++]=a+1:g===w.CharCode.LineFeed&&(r[t++]=a+1)}return i?s(r):r}function u(h,i){h.length=0,h[0]=0;let r=1,t=0,a=0,l=0,g=!0;for(let $=0,S=i.length;$<S;$++){const D=i.charCodeAt($);D===w.CharCode.CarriageReturn?$+1<S&&i.charCodeAt($+1)===w.CharCode.LineFeed?(l++,h[r++]=$+2,$++):(t++,h[r++]=$+1):D===w.CharCode.LineFeed?(a++,h[r++]=$+1):g&&D!==w.CharCode.Tab&&(D<32||D>126)&&(g=!1)}const m=new I(s(h),t,a,l,g);return h.length=0,m}class C{constructor(i,r,t,a,l){this.bufferIndex=i,this.start=r,this.end=t,this.lineFeedCnt=a,this.length=l}}e.$jD=C;class d{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$kD=d;class n{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==R.$5C&&i.iterate(i.root,t=>(t!==R.$5C&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const t=this.b[r];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const t=this.b;for(let a=0;a<t.length;a++){const l=t[a];if(l.node.parent===null||l.nodeStartOffset>=i){t[a]=null,r=!0;continue}}if(r){const a=[];for(const l of t)l!==null&&a.push(l);this.b=a}}}class c{constructor(i,r,t){this.create(i,r,t)}create(i,r,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=R.$5C,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=t;let a=null;for(let l=0,g=i.length;l<g;l++)if(i[l].buffer.length>0){i[l].lineStarts||(i[l].lineStarts=E(i[l].buffer));const m=new C(l+1,{line:0,column:0},{line:i[l].lineStarts.length-1,column:i[l].buffer.length-i[l].lineStarts[i[l].lineStarts.length-1]},i[l].lineStarts.length-1,i[l].buffer.length);this.a.push(i[l]),a=this.S(a,m)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=v,t=r-Math.floor(r/3),a=t*2;let l="",g=0;const m=[];if(this.iterate(this.root,$=>{const S=this.R($),D=S.length;if(g<=t||g+D<a)return l+=S,g+=D,!0;const b=l.replace(/\r\n|\r|\n/g,i);return m.push(new d(b,E(b))),l=S,g=D,!0}),g>0){const $=l.replace(/\r\n|\r|\n/g,i);m.push(new d($,E($)))}this.create(m,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new n(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,a=>{if(a===R.$5C)return!0;const l=this.R(a),g=l.length,m=i.G(r),$=i.G(r+g),S=i.getValueInRange2(m,$);return r+=g,l===S})}getOffsetAt(i,r){let t=0,a=this.root;for(;a!==R.$5C;)if(a.left!==R.$5C&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){t+=a.size_left;const l=this.B(a,i-a.lf_left-2);return t+=l+r-1}else i-=a.lf_left+a.piece.lineFeedCnt,t+=a.size_left+a.piece.length,a=a.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,t=0;const a=i;for(;r!==R.$5C;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const l=this.A(r,i-r.size_left);if(t+=r.lf_left+l.index,l.index===0){const g=this.getOffsetAt(t+1,1),m=a-g;return new y.$Mt(t+1,m+1)}return new y.$Mt(t+1,l.remainder+1)}else if(i-=r.size_left+r.piece.length,t+=r.lf_left+r.piece.lineFeedCnt,r.right===R.$5C){const l=this.getOffsetAt(t+1,1),g=a-i-l;return new y.$Mt(t+1,g+1)}else r=r.right;return new y.$Mt(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),l=this.getValueInRange2(t,a);return r?r!==this.d||!this.f?l.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?l:l.replace(/\r\n|\r|\n/g,r):l}getValueInRange2(i,r){if(i.node===r.node){const m=i.node,$=this.a[m.piece.bufferIndex].buffer,S=this.u(m.piece.bufferIndex,m.piece.start);return $.substring(S+i.remainder,S+r.remainder)}let t=i.node;const a=this.a[t.piece.bufferIndex].buffer,l=this.u(t.piece.bufferIndex,t.piece.start);let g=a.substring(l+i.remainder,l+t.piece.length);for(t=t.next();t!==R.$5C;){const m=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(t===r.node){g+=m.substring($,$+r.remainder);break}else g+=m.substr($,t.piece.length);t=t.next()}return g}getLinesContent(){const i=[];let r=0,t="",a=!1;return this.iterate(this.root,l=>{if(l===R.$5C)return!0;const g=l.piece;let m=g.length;if(m===0)return!0;const $=this.a[g.bufferIndex].buffer,S=this.a[g.bufferIndex].lineStarts,D=g.start.line,b=g.end.line;let T=S[D]+g.start.column;if(a&&($.charCodeAt(T)===w.CharCode.LineFeed&&(T++,m--),i[r++]=t,t="",a=!1,m===0))return!0;if(D===b)return!this.f&&$.charCodeAt(T+m-1)===w.CharCode.CarriageReturn?(a=!0,t+=$.substr(T,m-1)):t+=$.substr(T,m),!0;t+=this.f?$.substring(T,Math.max(T,S[D+1]-this.e)):$.substring(T,S[D+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;for(let P=D+1;P<b;P++)t=this.f?$.substring(S[P],S[P+1]-this.e):$.substring(S[P],S[P+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=t;return!this.f&&$.charCodeAt(S[b]+g.end.column-1)===w.CharCode.CarriageReturn?(a=!0,g.end.column===0?r--:t=$.substr(S[b],g.end.column-1)):t=$.substr(S[b],g.end.column),!0}),a&&(i[r++]=t,t=""),i[r++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const t=this.a[r.piece.bufferIndex],a=this.u(r.piece.bufferIndex,r.piece.start);return t.buffer.charCodeAt(a)}else{const r=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(a)}}getLineCharCode(i,r){const t=this.H(i,r+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}getNearestChunk(i){const r=this.G(i);if(r.remainder===r.node.piece.length){const t=r.node.next();if(!t||t===R.$5C)return"";const a=this.a[t.piece.bufferIndex],l=this.u(t.piece.bufferIndex,t.piece.start);return a.buffer.substring(l,l+t.piece.length)}else{const t=this.a[r.node.piece.bufferIndex],a=this.u(r.node.piece.bufferIndex,r.node.piece.start),l=a+r.remainder,g=a+r.node.piece.length;return t.buffer.substring(l,g)}}findMatchesInNode(i,r,t,a,l,g,m,$,S,D,b){const T=this.a[i.piece.bufferIndex],P=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,l),f=this.u(i.piece.bufferIndex,g);let M;const L={line:0,column:0};let K,J;r._wordSeparators?(K=T.buffer.substring(p,f),J=z=>z+p,r.reset(0)):(K=T.buffer,J=z=>z,r.reset(p));do if(M=r.next(K),M){if(J(M.index)>=f)return D;this.s(i,J(M.index)-P,L);const z=this.t(i.piece.bufferIndex,l,L),A=L.line===l.line?L.column-l.column+a:L.column+1,W=A+M[0].length;if(b[D++]=(0,N.$dD)(new k.$Nt(t+z,A,t+z,W),M,$),J(M.index)+M[0].length>=f||D>=S)return D}while(M);return D}findMatchesLineByLine(i,r,t,a){const l=[];let g=0;const m=new N.$gD(r.wordSeparators,r.regex);let $=this.H(i.startLineNumber,i.startColumn);if($===null)return[];const S=this.H(i.endLineNumber,i.endColumn);if(S===null)return[];let D=this.s($.node,$.remainder);const b=this.s(S.node,S.remainder);if($.node===S.node)return this.findMatchesInNode($.node,m,i.startLineNumber,i.startColumn,D,b,r,t,a,g,l),l;let T=i.startLineNumber,P=$.node;for(;P!==S.node;){const f=this.t(P.piece.bufferIndex,D,P.piece.end);if(f>=1){const L=this.a[P.piece.bufferIndex].lineStarts,K=this.u(P.piece.bufferIndex,P.piece.start),J=L[D.line+f],z=T===i.startLineNumber?i.startColumn:1;if(g=this.findMatchesInNode(P,m,T,z,D,this.s(P,J-K),r,t,a,g,l),g>=a)return l;T+=f}const M=T===i.startLineNumber?i.startColumn-1:0;if(T===i.endLineNumber){const L=this.getLineContent(T).substring(M,i.endColumn-1);return g=this.n(r,m,L,i.endLineNumber,M,g,l,t,a),l}if(g=this.n(r,m,this.getLineContent(T).substr(M),T,M,g,l,t,a),g>=a)return l;T++,$=this.H(T,1),P=$.node,D=this.s($.node,$.remainder)}if(T===i.endLineNumber){const f=T===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(T).substring(f,i.endColumn-1);return g=this.n(r,m,M,i.endLineNumber,f,g,l,t,a),l}const p=T===i.startLineNumber?i.startColumn:1;return g=this.findMatchesInNode(S.node,m,T,p,D,b,r,t,a,g,l),l}n(i,r,t,a,l,g,m,$,S){const D=i.wordSeparators;if(!$&&i.simpleSearch){const T=i.simpleSearch,P=T.length,p=t.length;let f=-P;for(;(f=t.indexOf(T,f+P))!==-1;)if((!D||(0,N.$fD)(D,t,p,f,P))&&(m[g++]=new O.$cw(new k.$Nt(a,f+1+l,a,f+1+P+l),null),g>=S))return g;return g}let b;r.reset(0);do if(b=r.next(t),b&&(m[g++]=(0,N.$dD)(new k.$Nt(a,b.index+1+l,a,b.index+1+b[0].length+l),b,$),g>=S))return g;while(b);return g}insert(i,r,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==R.$5C){const{node:a,remainder:l,nodeStartOffset:g}=this.G(i),m=a.piece,$=m.bufferIndex,S=this.s(a,l);if(a.piece.bufferIndex===0&&m.end.line===this.g.line&&m.end.column===this.g.column&&g+m.length===i&&r.length<v){this.F(a,r),this.y();return}if(g===i)this.o(r,a),this.h.validate(i);else if(g+a.piece.length>i){const D=[];let b=new C(m.bufferIndex,S,m.end,this.t(m.bufferIndex,S,m.end),this.u($,m.end)-this.u($,S));if(this.K()&&this.M(r)&&this.I(a,l)===10){const f={line:b.start.line+1,column:0};b=new C(b.bufferIndex,f,b.end,this.t(b.bufferIndex,f,b.end),b.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(a,l-1)===13){const f=this.s(a,l-1);this.C(a,f),r="\r"+r,a.piece.length===0&&D.push(a)}else this.C(a,S);else this.C(a,S);const T=this.w(r);b.length>0&&this.S(a,b);let P=a;for(let p=0;p<T.length;p++)P=this.S(P,T[p]);this.v(D)}else this.q(r,a)}else{const a=this.w(r);let l=this.T(null,a[0]);for(let g=1;g<a.length;g++)l=this.S(l,a[g])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===R.$5C)return;const t=this.G(i),a=this.G(i+r),l=t.node,g=a.node;if(l===g){const T=this.s(l,t.remainder),P=this.s(l,a.remainder);if(t.nodeStartOffset===i){if(r===l.piece.length){const p=l.next();(0,R.$0C)(this,l),this.N(p),this.y();return}this.D(l,P),this.h.validate(i),this.N(l),this.y();return}if(t.nodeStartOffset+l.piece.length===i+r){this.C(l,T),this.O(l),this.y();return}this.E(l,T,P),this.y();return}const m=[],$=this.s(l,t.remainder);this.C(l,$),this.h.validate(i),l.piece.length===0&&m.push(l);const S=this.s(g,a.remainder);this.D(g,S),g.piece.length===0&&m.push(g);const D=l.next();for(let T=D;T!==R.$5C&&T!==g;T=T.next())m.push(T);const b=l.piece.length===0?l.prev():l;this.v(m),this.O(b),this.y()}o(i,r){const t=[];if(this.K()&&this.M(i)&&this.L(r)){const g=r.piece,m={line:g.start.line+1,column:0},$=new C(g.bufferIndex,m,g.end,this.t(g.bufferIndex,m,g.end),g.length-1);r.piece=$,i+=`
`,(0,R.$_C)(this,r,-1,-1),r.piece.length===0&&t.push(r)}const a=this.w(i);let l=this.T(r,a[a.length-1]);for(let g=a.length-2;g>=0;g--)l=this.T(l,a[g]);this.N(l),this.v(t)}q(i,r){this.Q(i,r)&&(i+=`
`);const t=this.w(i),a=this.S(r,t[0]);let l=a;for(let g=1;g<t.length;g++)l=this.S(l,t[g]);this.N(a)}s(i,r,t){const a=i.piece,l=i.piece.bufferIndex,g=this.a[l].lineStarts,$=g[a.start.line]+a.start.column+r;let S=a.start.line,D=a.end.line,b=0,T=0,P=0;for(;S<=D&&(b=S+(D-S)/2|0,P=g[b],b!==D);)if(T=g[b+1],$<P)D=b-1;else if($>=T)S=b+1;else break;return t?(t.line=b,t.column=$-P,null):{line:b,column:$-P}}t(i,r,t){if(t.column===0)return t.line-r.line;const a=this.a[i].lineStarts;if(t.line===a.length-1)return t.line-r.line;const l=a[t.line+1],g=a[t.line]+t.column;if(l>g+1)return t.line-r.line;const m=g-1;return this.a[i].buffer.charCodeAt(m)===13?t.line-r.line+1:t.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,R.$0C)(this,i[r])}w(i){if(i.length>v){const D=[];for(;i.length>v;){const T=i.charCodeAt(v-1);let P;T===w.CharCode.CarriageReturn||T>=55296&&T<=56319?(P=i.substring(0,v-1),i=i.substring(v-1)):(P=i.substring(0,v),i=i.substring(v));const p=E(P);D.push(new C(this.a.length,{line:0,column:0},{line:p.length-1,column:P.length-p[p.length-1]},p.length-1,P.length)),this.a.push(new d(P,p))}const b=E(i);return D.push(new C(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new d(i,b)),D}let r=this.a[0].buffer.length;const t=E(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let D=0;D<t.length;D++)t[D]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let D=0;D<t.length;D++)t[D]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const l=this.a[0].buffer.length,g=this.a[0].lineStarts.length-1,m=l-this.a[0].lineStarts[g],$={line:g,column:m},S=new C(0,a,$,this.t(0,a,$),l-r);return this.g=$,[S]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let t=this.root,a="";const l=this.h.get2(i);if(l){t=l.node;const g=this.B(t,i-l.nodeStartLineNumber-1),m=this.a[t.piece.bufferIndex].buffer,$=this.u(t.piece.bufferIndex,t.piece.start);if(l.nodeStartLineNumber+t.piece.lineFeedCnt===i)a=m.substring($+g,$+t.piece.length);else{const S=this.B(t,i-l.nodeStartLineNumber);return m.substring($+g,$+S-r)}}else{let g=0;const m=i;for(;t!==R.$5C;)if(t.left!==R.$5C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const $=this.B(t,i-t.lf_left-2),S=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,b=this.u(t.piece.bufferIndex,t.piece.start);return g+=t.size_left,this.h.set({node:t,nodeStartOffset:g,nodeStartLineNumber:m-(i-1-t.lf_left)}),D.substring(b+$,b+S-r)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const $=this.B(t,i-t.lf_left-2),S=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);a=S.substring(D+$,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==R.$5C;){const g=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.B(t,0),$=this.u(t.piece.bufferIndex,t.piece.start);return a+=g.substring($,$+m-r),a}else{const m=this.u(t.piece.bufferIndex,t.piece.start);a+=g.substr(m,t.piece.length)}t=t.next()}return a}y(){let i=this.root,r=1,t=0;for(;i!==R.$5C;)r+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=t,this.h.validate(this.c)}A(i,r){const t=i.piece,a=this.s(i,r),l=a.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===r){const g=this.t(i.piece.bufferIndex,t.start,a);if(g!==l)return{index:g,remainder:0}}return{index:l,remainder:a.column}}B(i,r){if(r<0)return 0;const t=i.piece,a=this.a[t.bufferIndex].lineStarts,l=t.start.line+r+1;return l>t.end.line?a[t.end.line]+t.end.column-a[t.start.line]-t.start.column:a[l]-a[t.start.line]-t.start.column}C(i,r){const t=i.piece,a=t.lineFeedCnt,l=this.u(t.bufferIndex,t.end),g=r,m=this.u(t.bufferIndex,g),$=this.t(t.bufferIndex,t.start,g),S=$-a,D=m-l,b=t.length+D;i.piece=new C(t.bufferIndex,t.start,g,$,b),(0,R.$_C)(this,i,D,S)}D(i,r){const t=i.piece,a=t.lineFeedCnt,l=this.u(t.bufferIndex,t.start),g=r,m=this.t(t.bufferIndex,g,t.end),$=this.u(t.bufferIndex,g),S=m-a,D=l-$,b=t.length+D;i.piece=new C(t.bufferIndex,g,t.end,m,b),(0,R.$_C)(this,i,D,S)}E(i,r,t){const a=i.piece,l=a.start,g=a.end,m=a.length,$=a.lineFeedCnt,S=r,D=this.t(a.bufferIndex,a.start,S),b=this.u(a.bufferIndex,r)-this.u(a.bufferIndex,l);i.piece=new C(a.bufferIndex,a.start,S,D,b),(0,R.$_C)(this,i,b-m,D-$);const T=new C(a.bufferIndex,t,g,this.t(a.bufferIndex,t,g),this.u(a.bufferIndex,g)-this.u(a.bufferIndex,t)),P=this.S(i,T);this.N(P)}F(i,r){this.Q(r,i)&&(r+=`
`);const t=this.K()&&this.L(r)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=r;const l=E(r,!1);for(let P=0;P<l.length;P++)l[P]+=a;if(t){const P=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-P}}this.a[0].lineStarts=this.a[0].lineStarts.concat(l.slice(1));const g=this.a[0].lineStarts.length-1,m=this.a[0].buffer.length-this.a[0].lineStarts[g],$={line:g,column:m},S=i.piece.length+r.length,D=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,$),T=b-D;i.piece=new C(i.piece.bufferIndex,i.piece.start,$,b,S),this.g=$,(0,R.$_C)(this,i,r.length,T)}G(i){let r=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let a=0;for(;r!==R.$5C;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){a+=r.size_left;const l={node:r,remainder:i-r.size_left,nodeStartOffset:a};return this.h.set(l),l}else i-=r.size_left+r.piece.length,a+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let t=this.root,a=0;for(;t!==R.$5C;)if(t.left!==R.$5C&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const l=this.B(t,i-t.lf_left-2),g=this.B(t,i-t.lf_left-1);return a+=t.size_left,{node:t,remainder:Math.min(l+r-1,g),nodeStartOffset:a}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const l=this.B(t,i-t.lf_left-2);if(l+r-1<=t.piece.length)return{node:t,remainder:l+r-1,nodeStartOffset:a};r-=t.piece.length-l;break}else i-=t.lf_left+t.piece.lineFeedCnt,a+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==R.$5C;){if(t.piece.lineFeedCnt>0){const l=this.B(t,0),g=this.J(t);return{node:t,remainder:Math.min(r-1,l),nodeStartOffset:g}}else if(t.piece.length>=r-1){const l=this.J(t);return{node:t,remainder:r-1,nodeStartOffset:l}}else r-=t.piece.length;t=t.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+r;return t.buffer.charCodeAt(a)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$5C||i.piece.lineFeedCnt===0)return!1;const r=i.piece,t=this.a[r.bufferIndex].lineStarts,a=r.start.line,l=t[a]+r.start.column;return a===t.length-1||t[a+1]>l+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(l)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$5C||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const t=[],a=this.a[i.piece.bufferIndex].lineStarts;let l;i.piece.end.column===0?l={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:l={line:i.piece.end.line,column:i.piece.end.column-1};const g=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new C(i.piece.bufferIndex,i.piece.start,l,m,g),(0,R.$_C)(this,i,-1,-1),i.piece.length===0&&t.push(i);const $={line:r.piece.start.line+1,column:0},S=r.piece.length-1,D=this.t(r.piece.bufferIndex,$,r.piece.end);r.piece=new C(r.piece.bufferIndex,$,r.piece.end,D,S),(0,R.$_C)(this,r,-1,-1),r.piece.length===0&&t.push(r);const b=this.w(`\r
`);this.S(i,b[0]);for(let T=0;T<t.length;T++)(0,R.$0C)(this,t[T])}Q(i,r){if(this.K()&&this.M(i)){const t=r.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,R.$0C)(this,t);else{const a=t.piece,l={line:a.start.line+1,column:0},g=a.length-1,m=this.t(a.bufferIndex,l,a.end);t.piece=new C(a.bufferIndex,l,a.end,m,g),(0,R.$_C)(this,t,-1,-1)}return!0}}return!1}iterate(i,r){if(i===R.$5C)return r(R.$5C);const t=this.iterate(i.left,r);return t&&r(i)&&this.iterate(i.right,r)}R(i){if(i===R.$5C)return"";const r=this.a[i.piece.bufferIndex],t=i.piece,a=this.u(t.bufferIndex,t.start),l=this.u(t.bufferIndex,t.end);return r.buffer.substring(a,l)}getPieceContent(i){const r=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return r.buffer.substring(t,a)}S(i,r){const t=new R.$4C(r,R.NodeColor.Red);if(t.left=R.$5C,t.right=R.$5C,t.parent=R.$5C,t.size_left=0,t.lf_left=0,this.root===R.$5C)this.root=t,t.color=R.NodeColor.Black;else if(i.right===R.$5C)i.right=t,t.parent=i;else{const l=(0,R.$6C)(i.right);l.left=t,t.parent=l}return(0,R.$$C)(this,t),t}T(i,r){const t=new R.$4C(r,R.NodeColor.Red);if(t.left=R.$5C,t.right=R.$5C,t.parent=R.$5C,t.size_left=0,t.lf_left=0,this.root===R.$5C)this.root=t,t.color=R.NodeColor.Black;else if(i.left===R.$5C)i.left=t,t.parent=i;else{const a=(0,R.$7C)(i.left);a.right=t,t.parent=a}return(0,R.$$C)(this,t),t}U(i){let r="";return this.iterate(i,t=>(r+=this.R(t),!0)),r}}e.$lD=c}),define(Ie[160],Pe([1,0,6,13,33,53,101,152,154,4]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0,y=Ve(y);class I extends s.$Xc{constructor(u,C,d,n,o,c,h){super(),this.m=this.B(new w.$ne),this.onDidChangeContent=this.m.event,this.f=C,this.j=!c,this.g=n,this.h=o,this.c=new R.$lD(u,d,h)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,C){return this.c.getOffsetAt(u,C)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,C){const d=u+C,n=this.getPositionAt(u),o=this.getPositionAt(d);return new k.$Nt(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(u,C=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const d=this.n(C);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,C=O.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),n=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const c=this.n(C),h=this.getEOL();if(c.length!==h.length){const i=c.length-h.length,r=u.endLineNumber-u.startLineNumber;o=i*r}return n-d+o}getCharacterCountInRange(u,C=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const n=u.startLineNumber,o=u.endLineNumber;for(let c=n;c<=o;c++){const h=this.getLineContent(c),i=c===n?u.startColumn-1:0,r=c===o?u.endColumn-1:h.length;for(let t=i;t<r;t++)y.$Lf(h.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(C).length*(o-n),d}return this.getValueLengthInRange(u,C)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,C){return this.c.getLineCharCode(u,C)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const C=y.$wf(this.getLineContent(u));return C===-1?0:C+1}getLineLastNonWhitespaceColumn(u){const C=y.$yf(this.getLineContent(u));return C===-1?0:C+2}n(u){switch(u){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,C,d){let n=this.g,o=this.h,c=this.j,h=!0,i=[];for(let $=0;$<u.length;$++){const S=u[$];h&&S._isTracked&&(h=!1);const D=S.range;if(S.text){let f=!0;c||(f=!y.$Wf(S.text),c=f),!n&&f&&(n=y.$Vf(S.text)),!o&&f&&(o=y.$Yf(S.text))}let b="",T=0,P=0,p=0;if(S.text){let f;[T,P,p,f]=(0,N.$xu)(S.text);const M=this.getEOL(),L=M===`\r
`?N.StringEOL.CRLF:N.StringEOL.LF;f===N.StringEOL.Unknown||f===L?b=S.text:b=S.text.replace(/\r\n|\r|\n/g,M)}i[$]={sortIndex:$,identifier:S.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:b,eolCount:T,firstLineLength:P,lastLineLength:p,forceMoveMarkers:!!S.forceMoveMarkers,isAutoWhitespaceEdit:S.isAutoWhitespaceEdit||!1}}i.sort(I.u);let r=!1;for(let $=0,S=i.length-1;$<S;$++){const D=i[$].range.getEndPosition(),b=i[$+1].range.getStartPosition();if(b.isBeforeOrEqual(D)){if(b.isBefore(D))throw new Error("Overlapping ranges are not allowed!");r=!0}}h&&(i=this.s(i));const t=d||C?I._getInverseEditRanges(i):[],a=[];if(C)for(let $=0;$<i.length;$++){const S=i[$],D=t[$];if(S.isAutoWhitespaceEdit&&S.range.isEmpty())for(let b=D.startLineNumber;b<=D.endLineNumber;b++){let T="";b===D.startLineNumber&&(T=this.getLineContent(S.range.startLineNumber),y.$wf(T)!==-1)||a.push({lineNumber:b,oldContent:T})}}let l=null;if(d){let $=0;l=[];for(let S=0;S<i.length;S++){const D=i[S],b=t[S],T=this.getValueInRange(D.range),P=D.rangeOffset+$;$+=D.text.length-T.length,l[S]={sortIndex:D.sortIndex,identifier:D.identifier,range:b,text:T,textChange:new v.$du(D.rangeOffset,T,P,D.text)}}r||l.sort((S,D)=>S.sortIndex-D.sortIndex)}this.g=n,this.h=o,this.j=c;const g=this.t(i);let m=null;if(C&&a.length>0){a.sort(($,S)=>S.lineNumber-$.lineNumber),m=[];for(let $=0,S=a.length;$<S;$++){const D=a[$].lineNumber;if($>0&&a[$-1].lineNumber===D)continue;const b=a[$].oldContent,T=this.getLineContent(D);T.length===0||T===b||y.$wf(T)!==-1||m.push(D)}}return this.m.fire(),new O.$gw(l,g,m)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let C=!1;const d=u[0].range,n=u[u.length-1].range,o=new k.$Nt(d.startLineNumber,d.startColumn,n.endLineNumber,n.endColumn);let c=d.startLineNumber,h=d.startColumn;const i=[];for(let g=0,m=u.length;g<m;g++){const $=u[g],S=$.range;C=C||$.forceMoveMarkers,i.push(this.getValueInRange(new k.$Nt(c,h,S.startLineNumber,S.startColumn))),$.text.length>0&&i.push($.text),c=S.endLineNumber,h=S.endColumn}const r=i.join(""),[t,a,l]=(0,N.$xu)(r);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,O.EndOfLinePreference.TextDefined),text:r,eolCount:t,firstLineLength:a,lastLineLength:l,forceMoveMarkers:C,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const C=[];for(let d=0;d<u.length;d++){const n=u[d],o=n.range.startLineNumber,c=n.range.startColumn,h=n.range.endLineNumber,i=n.range.endColumn;if(o===h&&c===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const r=new k.$Nt(o,c,h,i);C.push({range:r,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return C}findMatchesLineByLine(u,C,d,n){return this.c.findMatchesLineByLine(u,C,d,n)}getPieceTree(){return this.c}static _getInverseEditRange(u,C){const d=u.startLineNumber,n=u.startColumn,[o,c,h]=(0,N.$xu)(C);let i;if(C.length>0){const r=o+1;r===1?i=new k.$Nt(d,n,d,n+c):i=new k.$Nt(d,n,d+r-1,h+1)}else i=new k.$Nt(d,n,d,n);return i}static _getInverseEditRanges(u){const C=[];let d=0,n=0,o=null;for(let c=0,h=u.length;c<h;c++){const i=u[c];let r,t;o?o.range.endLineNumber===i.range.startLineNumber?(r=d,t=n+(i.range.startColumn-o.range.endColumn)):(r=d+(i.range.startLineNumber-o.range.endLineNumber),t=i.range.startColumn):(r=i.range.startLineNumber,t=i.range.startColumn);let a;if(i.text.length>0){const l=i.eolCount+1;l===1?a=new k.$Nt(r,t,r,t+i.firstLineLength):a=new k.$Nt(r,t,r+l-1,i.lastLineLength+1)}else a=new k.$Nt(r,t,r,t);d=a.endLineNumber,n=a.endColumn,C.push(a),o=i}return C}static u(u,C){const d=k.$Nt.compareRangesUsingEnds(u.range,C.range);return d===0?u.sortIndex-C.sortIndex:d}static w(u,C){const d=k.$Nt.compareRangesUsingEnds(u.range,C.range);return d===0?C.sortIndex-u.sortIndex:-d}}e.$mD=I}),define(Ie[161],Pe([1,0,28,13,53,101,160]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nD=void 0,y=Ve(y);class N{constructor(I,E,u,C,d,n,o,c,h){this.a=I,this.b=E,this.c=u,this.d=C,this.e=d,this.f=n,this.g=o,this.h=c,this.j=h}k(I){const E=this.c+this.d+this.e,u=this.c+this.e;return E===0?I===k.DefaultEndOfLine.LF?`
`:`\r
`:u>E/2?`\r
`:`
`}create(I){const E=this.k(I),u=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let d=0,n=u.length;d<n;d++){const o=u[d].buffer.replace(/\r\n|\r|\n/g,E),c=(0,O.$hD)(o);u[d]=new O.$kD(o,c)}const C=new R.$mD(u,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class v{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&y.$7f(I)&&(this.b=y.$6f,I=I.substr(1));const E=I.charCodeAt(I.length-1);E===w.CharCode.CarriageReturn||E>=55296&&E<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=E):(this.m(I,!1),this.c=!1,this.d=E)}m(I,E){!E&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const E=(0,O.$iD)(this.e,I);this.a.push(new O.$kD(I,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=y.$Vf(I)),this.k||(this.k=y.$Yf(I)))}finish(I=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const E=(0,O.$hD)(I.buffer);I.lineStarts=E,this.d===w.CharCode.CarriageReturn&&this.f++}}}e.$nD=v}),define(Ie[104],Pe([1,0,23,21]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdb=v,e.$Ndb=I,y=Ve(y);var k;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(k||(k={}));function O(E){for(let u=0,C=E.length;u<C;u+=4){const d=E[u+0],n=E[u+1],o=E[u+2],c=E[u+3];E[u+0]=c,E[u+1]=o,E[u+2]=n,E[u+3]=d}}function R(E){const u=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return y.$x()||O(u),w.$Pe.wrap(u)}function N(E){const u=E.buffer;if(y.$x()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const C=new Uint8Array(u.byteLength);return C.set(u),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function v(E){const u=new Uint32Array(s(E));let C=0;if(u[C++]=E.id,E.type==="full")u[C++]=k.Full,u[C++]=E.data.length,u.set(E.data,C),C+=E.data.length;else{u[C++]=k.Delta,u[C++]=E.deltas.length;for(const d of E.deltas)u[C++]=d.start,u[C++]=d.deleteCount,d.data?(u[C++]=d.data.length,u.set(d.data,C),C+=d.data.length):u[C++]=0}return R(u)}function s(E){let u=0;if(u+=2,E.type==="full")u+=1+E.data.length;else{u+=1,u+=3*E.deltas.length;for(const C of E.deltas)C.data&&(u+=C.data.length)}return u}function I(E){const u=N(E);let C=0;const d=u[C++];if(u[C++]===k.Full){const h=u[C++],i=u.subarray(C,C+h);return C+=h,{id:d,type:"full",data:i}}const o=u[C++],c=[];for(let h=0;h<o;h++){const i=u[C++],r=u[C++],t=u[C++];let a;t>0&&(a=u.subarray(C,C+t),C+=t),c[h]={start:i,deleteCount:r,data:a}}return{id:d,type:"delta",deltas:c}}}),define(Ie[162],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_=e.$C_=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const R=this.a.get(O);return this.a.delete(O),R}}addDragOperationTransfer(O,R){this.a.set(O,R)}}e.$C_=w;class y{constructor(O){this.identifier=O}}e.$D_=y}),define(Ie[163],Pe([9,10]),function(_,e){return _.create("vs/base/common/actions",e)}),define(Ie[164],Pe([1,0,6,4,163]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0,e.$qj=I,k=Ve(k);class O extends y.$Xc{constructor(u,C="",d="",n=!0,o){super(),this.j=this.B(new w.$ne),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=C,this.w=d,this.z=n,this.D=o}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,C){this.D&&await this.D(u)}}e.$lj=O;class R extends y.$Xc{constructor(){super(...arguments),this.f=this.B(new w.$ne),this.onWillRun=this.f.event,this.m=this.B(new w.$ne),this.onDidRun=this.m.event}async run(u,C){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,C)}catch(n){d=n}this.m.fire({action:u,error:d})}async u(u,C){await u.run(C)}}e.$mj=R;class N{constructor(){this.id=N.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let C=[];for(const d of u)d.length&&(C.length?C=[...C,new N,...d]:C=d);return C}async run(){}}e.$nj=N,N.ID="vs.actions.separator";class v{get actions(){return this.a}constructor(u,C,d,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=C,this.class=n,this.a=d}async run(){}}e.$oj=v;class s extends O{constructor(){super(s.ID,k.localize(0,null),void 0,!1)}}e.$pj=s,s.ID="vs.actions.empty";function I(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...u)=>E.run(...u)}}}),define(Ie[165],Pe([9,10]),function(_,e){return _.create("vs/base/common/date",e)}),define(Ie[166],Pe([1,0,165]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=s,e.$4m=I,e.$5m=E;const y=60,k=y*60,O=k*24,R=O*7,N=O*30,v=O*365;function s(u,C,d,n){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,w.localize)(0,null,s(new Date().getTime()+o*1e3,!1));if(!n&&o<30)return(0,w.localize)(1,null);let c;return o<y?(c=o,C?c===1?d?(0,w.localize)(2,null,c):(0,w.localize)(3,null,c):d?(0,w.localize)(4,null,c):(0,w.localize)(5,null,c):c===1?d?(0,w.localize)(6,null,c):(0,w.localize)(7,null,c):d?(0,w.localize)(8,null,c):(0,w.localize)(9,null,c)):o<k?(c=Math.floor(o/y),C?c===1?d?(0,w.localize)(10,null,c):(0,w.localize)(11,null,c):d?(0,w.localize)(12,null,c):(0,w.localize)(13,null,c):c===1?d?(0,w.localize)(14,null,c):(0,w.localize)(15,null,c):d?(0,w.localize)(16,null,c):(0,w.localize)(17,null,c)):o<O?(c=Math.floor(o/k),C?c===1?d?(0,w.localize)(18,null,c):(0,w.localize)(19,null,c):d?(0,w.localize)(20,null,c):(0,w.localize)(21,null,c):c===1?d?(0,w.localize)(22,null,c):(0,w.localize)(23,null,c):d?(0,w.localize)(24,null,c):(0,w.localize)(25,null,c)):o<R?(c=Math.floor(o/O),C?c===1?(0,w.localize)(26,null,c):(0,w.localize)(27,null,c):c===1?(0,w.localize)(28,null,c):(0,w.localize)(29,null,c)):o<N?(c=Math.floor(o/R),C?c===1?d?(0,w.localize)(30,null,c):(0,w.localize)(31,null,c):d?(0,w.localize)(32,null,c):(0,w.localize)(33,null,c):c===1?d?(0,w.localize)(34,null,c):(0,w.localize)(35,null,c):d?(0,w.localize)(36,null,c):(0,w.localize)(37,null,c)):o<v?(c=Math.floor(o/N),C?c===1?d?(0,w.localize)(38,null,c):(0,w.localize)(39,null,c):d?(0,w.localize)(40,null,c):(0,w.localize)(41,null,c):c===1?d?(0,w.localize)(42,null,c):(0,w.localize)(43,null,c):d?(0,w.localize)(44,null,c):(0,w.localize)(45,null,c)):(c=Math.floor(o/v),C?c===1?d?(0,w.localize)(46,null,c):(0,w.localize)(47,null,c):d?(0,w.localize)(48,null,c):(0,w.localize)(49,null,c):c===1?d?(0,w.localize)(50,null,c):(0,w.localize)(51,null,c):d?(0,w.localize)(52,null,c):(0,w.localize)(53,null,c))}function I(u,C){const d=Math.abs(u/1e3);return d<1?C?(0,w.localize)(54,null,u):(0,w.localize)(55,null,u):d<y?C?(0,w.localize)(56,null,Math.round(u)/1e3):(0,w.localize)(57,null,Math.round(u)/1e3):d<k?C?(0,w.localize)(58,null,Math.round(u/(1e3*y))):(0,w.localize)(59,null,Math.round(u/(1e3*y))):d<O?C?(0,w.localize)(60,null,Math.round(u/(1e3*k))):(0,w.localize)(61,null,Math.round(u/(1e3*k))):(0,w.localize)(62,null,Math.round(u/(1e3*O)))}function E(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ie[167],Pe([9,10]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(Ie[42],Pe([1,0,18,15,167]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=v,e.$sj=s,e.$tj=I,w=Ve(w),y=Ve(y),k=Ve(k);function O(E,u){return u&&(E.stack||E.stacktrace)?k.localize(0,null,N(E),R(E.stack)||R(E.stacktrace)):N(E)}function R(E){return Array.isArray(E)?E.join(`
`):E}function N(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?k.localize(1,null,E.message):E.message||k.localize(2,null)}function v(E=null,u=!1){if(!E)return k.localize(3,null);if(Array.isArray(E)){const C=w.$Kb(E),d=v(C[0],u);return C.length>1?k.localize(4,null,d,C.length):d}if(y.$gg(E))return E;if(E.detail){const C=E.detail;if(C.error)return O(C.error,u);if(C.exception)return O(C.exception,u)}return E.stack?O(E,u):E.message?E.message:k.localize(5,null)}function s(E){const u=E;return u instanceof Error&&Array.isArray(u.actions)}function I(E,u){let C;return typeof E=="string"?C=new Error(E):C=E,C.actions=u,C}}),define(Ie[168],Pe([9,10]),function(_,e){return _.create("vs/editor/common/config/editorOptions",e)}),define(Ie[169],Pe([9,10]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[170],Pe([9,10]),function(_,e){return _.create("vs/platform/contextkey/common/contextkey",e)}),define(Ie[171],Pe([9,10]),function(_,e){return _.create("vs/platform/contextkey/common/scanner",e)}),define(Ie[172],Pe([9,10]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[173],Pe([9,10]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[174],Pe([9,10]),function(_,e){return _.create("vs/platform/files/common/files",e)}),define(Ie[175],Pe([9,10]),function(_,e){return _.create("vs/platform/log/common/log",e)}),define(Ie[176],Pe([9,10]),function(_,e){return _.create("vs/platform/markers/common/markers",e)}),define(Ie[177],Pe([9,10]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(Ie[178],Pe([9,10]),function(_,e){return _.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[179],Pe([9,10]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ie[180],Pe([9,10]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(Ie[181],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[182],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[183],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ie[184],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ie[185],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostLogService",e)}),define(Ie[186],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ie[187],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[188],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ie[189],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[190],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[191],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ie[192],Pe([9,10]),function(_,e){return _.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[193],Pe([9,10]),function(_,e){return _.create("vs/workbench/common/configuration",e)}),define(Ie[194],Pe([9,10]),function(_,e){return _.create("vs/workbench/common/editor",e)}),define(Ie[195],Pe([9,10]),function(_,e){return _.create("vs/workbench/common/views",e)}),define(Ie[196],Pe([9,10]),function(_,e){return _.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ie[197],Pe([9,10]),function(_,e){return _.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ie[198],Pe([9,10]),function(_,e){return _.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[199],Pe([9,10]),function(_,e){return _.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[200],Pe([9,10]),function(_,e){return _.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[201],Pe([9,10]),function(_,e){return _.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[202],Pe([9,10]),function(_,e){return _.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ie[203],Pe([9,10]),function(_,e){return _.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[204],Pe([9,10]),function(_,e){return _.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ie[205],Pe([9,10]),function(_,e){return _.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[206],Pe([9,10]),function(_,e){return _.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[207],Pe([1,0,28,14,171]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.TokenType=void 0;var O;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(O||(e.TokenType=O={}));function R(...I){switch(I.length){case 1:return(0,k.localize)(0,null,I[0]);case 2:return(0,k.localize)(1,null,I[0],I[1]);case 3:return(0,k.localize)(2,null,I[0],I[1],I[2]);default:return}}const N=(0,k.localize)(3,null),v=(0,k.localize)(4,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return E.isTripleEq?"===":"==";case O.NotEq:return E.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return E.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return E.lexeme;case O.QuotedStr:return E.lexeme;case O.Error:return E.lexeme;case O.EOF:return"EOF";default:throw(0,y.$$)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case w.CharCode.OpenParen:this.k(O.LParen);break;case w.CharCode.CloseParen:this.k(O.RParen);break;case w.CharCode.ExclamationMark:if(this.h(w.CharCode.Equals)){const u=this.h(w.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:u})}else this.k(O.Neg);break;case w.CharCode.SingleQuote:this.o();break;case w.CharCode.Slash:this.q();break;case w.CharCode.Equals:if(this.h(w.CharCode.Equals)){const u=this.h(w.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:u})}else this.h(w.CharCode.Tilde)?this.k(O.RegexOp):this.l(R("==","=~"));break;case w.CharCode.LessThan:this.k(this.h(w.CharCode.Equals)?O.LtEq:O.Lt);break;case w.CharCode.GreaterThan:this.k(this.h(w.CharCode.Equals)?O.GtEq:O.Gt);break;case w.CharCode.Ampersand:this.h(w.CharCode.Ampersand)?this.k(O.And):this.l(R("&&"));break;case w.CharCode.Pipe:this.h(w.CharCode.Pipe)?this.k(O.Or):this.l(R("||"));break;case w.CharCode.Space:case w.CharCode.CarriageReturn:case w.CharCode.Tab:case w.CharCode.LineFeed:case w.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?w.CharCode.Null:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const u=this.d,C=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:C};this.g.push({offset:u,lexeme:C,additionalInfo:E}),this.f.push(d)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const u=this.c.substring(this.d,this.e),C=s.b.get(u);C?this.k(C):this.f.push({type:O.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==w.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,u=!1,C=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(v);return}const n=this.c.charCodeAt(E);if(u)u=!1;else if(n===w.CharCode.Slash&&!C){E++;break}else n===w.CharCode.OpenSquareBracket?C=!0:n===w.CharCode.Backslash?u=!0:n===w.CharCode.CloseSquareBracket&&(C=!1);E++}for(;E<this.c.length&&s.a.has(this.c.charCodeAt(E));)E++;this.e=E;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Bj=s,s.a=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0))),s.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}),define(Ie[105],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const w={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts"},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(w)}),define(Ie[74],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class w{constructor(k,O=[],R=!1){this.ctor=k,this.staticArguments=O,this.supportsDelayedInstantiation=R}}e.$Di=w}),define(Ie[61],Pe([1,0,74]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Qs=O,e.$Rs=R;const y=[];var k;(function(N){N[N.Eager=0]="Eager",N[N.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function O(N,v,s){v instanceof w.$Di||(v=new w.$Di(v,[],!!s)),y.push([N,v])}function R(){return y}}),define(Ie[208],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;class w{constructor(O,R){this.key=O,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$tr=w;class y{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const R of this.a.values())R.outgoing.size===0&&O.push(R);return O}insertEdge(O,R){const N=this.lookupOrInsertNode(O),v=this.lookupOrInsertNode(R);N.outgoing.set(v.key,v),v.incoming.set(N.key,N)}removeNode(O){const R=this.b(O);this.a.delete(R);for(const N of this.a.values())N.outgoing.delete(R),N.incoming.delete(R)}lookupOrInsertNode(O){const R=this.b(O);let N=this.a.get(R);return N||(N=new w(R,O),this.a.set(R,N)),N}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[R,N]of this.a)O.push(`${R}
	(-> incoming)[${[...N.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...N.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,R]of this.a){const N=new Set([O]),v=this.c(R,N);if(v)return v}}c(O,R){for(const[N,v]of O.outgoing){if(R.has(N))return[...R,N].join(" -> ");R.add(N);const s=this.c(v,R);if(s)return s;R.delete(N)}}}e.$ur=y}),define(Ie[3],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e._util=void 0,e.$Gi=k,e.$Hi=O;var w;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function N(v){return v[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=N})(w||(e._util=w={})),e.$Fi=k("instantiationService");function y(R,N,v){N[w.DI_TARGET]===N?N[w.DI_DEPENDENCIES].push({id:R,index:v}):(N[w.DI_DEPENDENCIES]=[{id:R,index:v}],N[w.DI_TARGET]=N)}function k(R){if(w.serviceIds.has(R))return w.serviceIds.get(R);const N=function(v,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");y(N,v,I)};return N.toString=()=>R,w.serviceIds.set(R,N),N}function O(R){return R}}),define(Ie[43],Pe([1,0,15,2,3]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$aj=void 0,e.$bj=O,e.$cj=R,e.$dj=v,e.$ej=s,e.$fj=I,e.$gj=E,e.$hj=u,e.$ij=d,e.$jj=n,e.$kj=o,w=Ve(w),e.$aj=(0,k.$Gi)("configurationService");function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof y.URI)}function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof y.URI)}var N;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(N||(e.ConfigurationTarget=N={}));function v(c){switch(c){case N.APPLICATION:return"APPLICATION";case N.USER:return"USER";case N.USER_LOCAL:return"USER_LOCAL";case N.USER_REMOTE:return"USER_REMOTE";case N.WORKSPACE:return"WORKSPACE";case N.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case N.DEFAULT:return"DEFAULT";case N.MEMORY:return"MEMORY"}}function s(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function I(c,h){const i=Object.create(null);for(const r in c)E(i,r,c[r],h);return i}function E(c,h,i,r){const t=h.split("."),a=t.pop();let l=c;for(let g=0;g<t.length;g++){const m=t[g];let $=l[m];switch(typeof $){case"undefined":$=l[m]=Object.create(null);break;case"object":if($===null){r(`Ignoring ${h} as ${t.slice(0,g+1).join(".")} is null`);return}break;default:r(`Ignoring ${h} as ${t.slice(0,g+1).join(".")} is ${JSON.stringify($)}`);return}l=$}if(typeof l=="object"&&l!==null)try{l[a]=i}catch{r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}else r(`Ignoring ${h} as ${t.join(".")} is ${JSON.stringify(l)}`)}function u(c,h){const i=h.split(".");C(c,i)}function C(c,h){const i=h.shift();if(h.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const r=c[i];typeof r=="object"&&!Array.isArray(r)&&(C(r,h),Object.keys(r).length===0&&delete c[i])}}function d(c,h,i){function r(l,g){let m=l;for(const $ of g){if(typeof m!="object"||m===null)return;m=m[$]}return m}const t=h.split("."),a=r(c,t);return typeof a>"u"?i:a}function n(c,h,i){Object.keys(h).forEach(r=>{r!=="__proto__"&&(r in c?w.$ig(c[r])&&w.$ig(h[r])?n(c[r],h[r],i):i&&(c[r]=h[r]):c[r]=h[r])})}function o(c){return c.replace(/[\[\]]/g,"")}}),define(Ie[32],Pe([1,0,28,21,13,207,3,170,14]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Ej=e.$Dj=e.ContextKeyExprType=void 0,e.$Cj=I,e.$Fj=g,e.$Gj=m,e.$Zj=Y;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",y.$d),s.set("isLinux",y.$e),s.set("isWindows",y.$c),s.set("isWeb",y.$i),s.set("isMacNative",y.$d&&!y.$i),s.set("isEdge",y.$B),s.set("isFirefox",y.$z),s.set("isChrome",y.$y),s.set("isSafari",y.$A);function I(re,q){if(s.get(re)!==void 0)throw(0,v.$0)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(re,q)}const E=Object.prototype.hasOwnProperty;var u;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const C={regexParsingWithErrorRecovery:!0},d=(0,N.localize)(0,null),n=(0,N.localize)(1,null),o=(0,N.localize)(2,null),c=(0,N.localize)(3,null),h=(0,N.localize)(4,null),i=(0,N.localize)(5,null),r=(0,N.localize)(6,null),t=(0,N.localize)(7,null);class a{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=C){this.k=q,this.d=new O.$Bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:n});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ae=this.l();if(!this.E()){const le=this.D(),ne=le.type===O.TokenType.Str?i:void 0;throw this.h.push({message:h,offset:le.offset,lexeme:O.$Bj.getLexeme(le),additionalInfo:ne}),a.c}return ae}catch(ae){if(ae!==a.c)throw ae;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(O.TokenType.Or);){const ae=this.o();q.push(ae)}return q.length===1?q[0]:l.or(...q)}o(){const q=[this.s()];for(;this.y(O.TokenType.And);){const ae=this.s();q.push(ae)}return q.length===1?q[0]:l.and(...q)}s(){if(this.y(O.TokenType.Neg)){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),S.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const ae=this.l();return this.A(O.TokenType.RParen,c),ae?.negate()}case O.TokenType.Str:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case O.TokenType.True:return this.z(),l.true();case O.TokenType.False:return this.z(),l.false();case O.TokenType.LParen:{this.z();const ae=this.l();return this.A(O.TokenType.RParen,c),ae}case O.TokenType.Str:{const ae=q.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==O.TokenType.RegexStr)throw this.B("REGEX",ne);const ce=ne.lexeme,oe=ce.lastIndexOf("/"),H=oe===ce.length-1?void 0:this.w(ce.substring(oe+1));let x;try{x=new RegExp(ce.substring(1,oe),H)}catch{throw this.B("REGEX",ne)}return W.create(ae,x)}switch(ne.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const ce=[ne.lexeme];this.z();let oe=this.D(),H=0;for(let je=0;je<ne.lexeme.length;je++)ne.lexeme.charCodeAt(je)===w.CharCode.OpenParen?H++:ne.lexeme.charCodeAt(je)===w.CharCode.CloseParen&&H--;for(;!this.E()&&oe.type!==O.TokenType.And&&oe.type!==O.TokenType.Or;){switch(oe.type){case O.TokenType.LParen:H++;break;case O.TokenType.RParen:H--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let je=0;je<oe.lexeme.length;je++)oe.lexeme.charCodeAt(je)===w.CharCode.OpenParen?H++:ne.lexeme.charCodeAt(je)===w.CharCode.CloseParen&&H--}if(H<0)break;ce.push(O.$Bj.getLexeme(oe)),this.z(),oe=this.D()}const x=ce.join(""),ue=x.lastIndexOf("/"),me=ue===x.length-1?void 0:this.w(x.substring(ue+1));let Oe;try{Oe=new RegExp(x.substring(1,ue),me)}catch{throw this.B("REGEX",ne)}return l.regex(ae,Oe)}case O.TokenType.QuotedStr:{const ce=ne.lexeme;this.z();let oe=null;if(!(0,k.$ef)(ce)){const H=ce.indexOf("/"),x=ce.lastIndexOf("/");if(H!==x&&H>=0){const ue=ce.slice(H+1,x),me=ce[x+1]==="i"?"i":"";try{oe=new RegExp(ue,me)}catch{throw this.B("REGEX",ne)}}}if(oe===null)throw this.B("REGEX",ne);return W.create(ae,oe)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,o);const ne=this.u();return l.notIn(ae,ne)}switch(this.D().type){case O.TokenType.Eq:{this.z();const ne=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.equals(ae,ne);switch(ne){case"true":return l.has(ae);case"false":return l.not(ae);default:return l.equals(ae,ne)}}case O.TokenType.NotEq:{this.z();const ne=this.u();if(this.x().type===O.TokenType.QuotedStr)return l.notEquals(ae,ne);switch(ne){case"true":return l.not(ae);case"false":return l.has(ae);default:return l.notEquals(ae,ne)}}case O.TokenType.Lt:return this.z(),z.create(ae,this.u());case O.TokenType.LtEq:return this.z(),A.create(ae,this.u());case O.TokenType.Gt:return this.z(),K.create(ae,this.u());case O.TokenType.GtEq:return this.z(),J.create(ae,this.u());case O.TokenType.In:return this.z(),l.in(ae,this.u());default:return l.has(ae)}}case O.TokenType.EOF:throw this.h.push({message:r,offset:q.offset,lexeme:"",additionalInfo:t}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),q.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ae){if(this.C(q))return this.z();throw this.B(ae,this.D())}B(q,ae,le){const ne=(0,N.localize)(8,null,q,O.$Bj.getLexeme(ae)),ce=ae.offset,oe=O.$Bj.getLexeme(ae);return this.h.push({message:ne,offset:ce,lexeme:oe,additionalInfo:le}),a.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Dj=a,a.c=new Error;class l{static false(){return S.INSTANCE}static true(){return D.INSTANCE}static has(q){return b.create(q)}static equals(q,ae){return T.create(q,ae)}static notEquals(q,ae){return f.create(q,ae)}static regex(q,ae){return W.create(q,ae)}static in(q,ae){return P.create(q,ae)}static notIn(q,ae){return p.create(q,ae)}static not(q){return M.create(q)}static and(...q){return ve.create(q,null,!0)}static or(...q){return be.create(q,null,!0)}static greater(q,ae){return K.create(q,ae)}static greaterEquals(q,ae){return J.create(q,ae)}static smaller(q,ae){return z.create(q,ae)}static smallerEquals(q,ae){return A.create(q,ae)}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$Ej=l,l.c=new a({regexParsingWithErrorRecovery:!1});function g(re){const q=new a({regexParsingWithErrorRecovery:!1});return re.map(ae=>(q.parse(ae),q.lexingErrors.length>0?q.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,N.localize)(9,null,le.additionalInfo):(0,N.localize)(10,null),offset:le.offset,length:le.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}function m(re,q){const ae=re?re.substituteConstants():void 0,le=q?q.substituteConstants():void 0;return!ae&&!le?!0:!ae||!le?!1:ae.equals(le)}function $(re,q){return re.cmp(q)}class S{constructor(){this.type=u.False}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return D.INSTANCE}}e.$Hj=S,S.INSTANCE=new S;class D{constructor(){this.type=u.True}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return S.INSTANCE}}e.$Ij=D,D.INSTANCE=new D;class b{static create(q,ae=null){const le=s.get(q);return typeof le=="boolean"?le?D.INSTANCE:S.INSTANCE:new b(q,ae)}constructor(q,ae){this.key=q,this.c=ae,this.type=u.Defined}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=s.get(this.key);return typeof q=="boolean"?q?D.INSTANCE:S.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Jj=b;class T{static create(q,ae,le=null){if(typeof ae=="boolean")return ae?b.create(q,le):M.create(q,le);const ne=s.get(q);return typeof ne=="boolean"?ae===(ne?"true":"false")?D.INSTANCE:S.INSTANCE:new T(q,ae,le)}constructor(q,ae,le){this.c=q,this.d=ae,this.f=le,this.type=u.Equals}cmp(q){return q.type!==this.type?this.type-q.type:ye(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const ae=q?"true":"false";return this.d===ae?D.INSTANCE:S.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.$Kj=T;class P{static create(q,ae){return new P(q,ae)}constructor(q,ae){this.d=q,this.f=ae,this.type=u.In,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:ye(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ae=q.getValue(this.f),le=q.getValue(this.d);return Array.isArray(ae)?ae.includes(le):typeof le=="string"&&typeof ae=="object"&&ae!==null?E.call(ae,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Lj=P;class p{static create(q,ae){return new p(q,ae)}constructor(q,ae){this.d=q,this.f=ae,this.type=u.NotIn,this.c=P.create(q,ae)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Mj=p;class f{static create(q,ae,le=null){if(typeof ae=="boolean")return ae?M.create(q,le):b.create(q,le);const ne=s.get(q);return typeof ne=="boolean"?ae===(ne?"true":"false")?S.INSTANCE:D.INSTANCE:new f(q,ae,le)}constructor(q,ae,le){this.c=q,this.d=ae,this.f=le,this.type=u.NotEquals}cmp(q){return q.type!==this.type?this.type-q.type:ye(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=s.get(this.c);if(typeof q=="boolean"){const ae=q?"true":"false";return this.d===ae?S.INSTANCE:D.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Nj=f;class M{static create(q,ae=null){const le=s.get(q);return typeof le=="boolean"?le?S.INSTANCE:D.INSTANCE:new M(q,ae)}constructor(q,ae){this.c=q,this.d=ae,this.type=u.Not}cmp(q){return q.type!==this.type?this.type-q.type:$e(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=s.get(this.c);return typeof q=="boolean"?q?S.INSTANCE:D.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Oj=M;function L(re,q){if(typeof re=="string"){const ae=parseFloat(re);isNaN(ae)||(re=ae)}return typeof re=="string"||typeof re=="number"?q(re):S.INSTANCE}class K{static create(q,ae,le=null){return L(ae,ne=>new K(q,ne,le))}constructor(q,ae,le){this.c=q,this.d=ae,this.f=le,this.type=u.Greater}cmp(q){return q.type!==this.type?this.type-q.type:ye(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Pj=K;class J{static create(q,ae,le=null){return L(ae,ne=>new J(q,ne,le))}constructor(q,ae,le){this.c=q,this.d=ae,this.f=le,this.type=u.GreaterEquals}cmp(q){return q.type!==this.type?this.type-q.type:ye(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Qj=J;class z{static create(q,ae,le=null){return L(ae,ne=>new z(q,ne,le))}constructor(q,ae,le){this.c=q,this.d=ae,this.f=le,this.type=u.Smaller}cmp(q){return q.type!==this.type?this.type-q.type:ye(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Rj=z;class A{static create(q,ae,le=null){return L(ae,ne=>new A(q,ne,le))}constructor(q,ae,le){this.c=q,this.d=ae,this.f=le,this.type=u.SmallerEquals}cmp(q){return q.type!==this.type?this.type-q.type:ye(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Sj=A;class W{static create(q,ae){return new W(q,ae)}constructor(q,ae){this.d=q,this.f=ae,this.type=u.Regex,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ae=this.f?this.f.source:"",le=q.f?q.f.source:"";return ae<le?-1:ae>le?1:0}equals(q){if(q.type===this.type){const ae=this.f?this.f.source:"",le=q.f?q.f.source:"";return this.d===q.d&&ae===le}return!1}substituteConstants(){return this}evaluate(q){const ae=q.getValue(this.d);return this.f?this.f.test(ae):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Tj=W;class Z{static create(q){return new Z(q)}constructor(q){this.c=q,this.type=u.NotRegex}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new Z(this.c.map(q))}negate(){return this.c}}e.$Uj=Z;function he(re){let q=null;for(let ae=0,le=re.length;ae<le;ae++){const ne=re[ae].substituteConstants();if(re[ae]!==ne&&q===null){q=[];for(let ce=0;ce<ae;ce++)q[ce]=re[ce]}q!==null&&(q[ae]=ne)}return q===null?re:q}class ve{static create(q,ae,le){return ve.d(q,ae,le)}constructor(q,ae){this.expr=q,this.c=ae,this.type=u.And}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ae=0,le=this.expr.length;ae<le;ae++){const ne=$(this.expr[ae],q.expr[ae]);if(ne!==0)return ne}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ae=0,le=this.expr.length;ae<le;ae++)if(!this.expr[ae].equals(q.expr[ae]))return!1;return!0}return!1}substituteConstants(){const q=he(this.expr);return q===this.expr?this:ve.create(q,this.c,!1)}evaluate(q){for(let ae=0,le=this.expr.length;ae<le;ae++)if(!this.expr[ae].evaluate(q))return!1;return!0}static d(q,ae,le){const ne=[];let ce=!1;for(const oe of q)if(oe){if(oe.type===u.True){ce=!0;continue}if(oe.type===u.False)return S.INSTANCE;if(oe.type===u.And){ne.push(...oe.expr);continue}ne.push(oe)}if(ne.length===0&&ce)return D.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort($);for(let oe=1;oe<ne.length;oe++)ne[oe-1].equals(ne[oe])&&(ne.splice(oe,1),oe--);if(ne.length===1)return ne[0];for(;ne.length>1;){const oe=ne[ne.length-1];if(oe.type!==u.Or)break;ne.pop();const H=ne.pop(),x=ne.length===0,ue=be.create(oe.expr.map(me=>ve.create([me,H],null,le)),null,x);ue&&(ne.push(ue),ne.sort($))}if(ne.length===1)return ne[0];if(le){for(let oe=0;oe<ne.length;oe++)for(let H=oe+1;H<ne.length;H++)if(ne[oe].negate().equals(ne[H]))return S.INSTANCE;if(ne.length===1)return ne[0]}return new ve(ne,ae)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ae of this.expr)q.push(...ae.keys());return q}map(q){return new ve(this.expr.map(ae=>ae.map(q)),null)}negate(){if(!this.c){const q=[];for(const ae of this.expr)q.push(ae.negate());this.c=be.create(q,this,!0)}return this.c}}e.$Vj=ve;class be{static create(q,ae,le){return be.d(q,ae,le)}constructor(q,ae){this.expr=q,this.c=ae,this.type=u.Or}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ae=0,le=this.expr.length;ae<le;ae++){const ne=$(this.expr[ae],q.expr[ae]);if(ne!==0)return ne}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ae=0,le=this.expr.length;ae<le;ae++)if(!this.expr[ae].equals(q.expr[ae]))return!1;return!0}return!1}substituteConstants(){const q=he(this.expr);return q===this.expr?this:be.create(q,this.c,!1)}evaluate(q){for(let ae=0,le=this.expr.length;ae<le;ae++)if(this.expr[ae].evaluate(q))return!0;return!1}static d(q,ae,le){let ne=[],ce=!1;if(q){for(let oe=0,H=q.length;oe<H;oe++){const x=q[oe];if(x){if(x.type===u.False){ce=!0;continue}if(x.type===u.True)return D.INSTANCE;if(x.type===u.Or){ne=ne.concat(x.expr);continue}ne.push(x)}}if(ne.length===0&&ce)return S.INSTANCE;ne.sort($)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let oe=1;oe<ne.length;oe++)ne[oe-1].equals(ne[oe])&&(ne.splice(oe,1),oe--);if(ne.length===1)return ne[0];if(le){for(let oe=0;oe<ne.length;oe++)for(let H=oe+1;H<ne.length;H++)if(ne[oe].negate().equals(ne[H]))return D.INSTANCE;if(ne.length===1)return ne[0]}return new be(ne,ae)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ae of this.expr)q.push(...ae.keys());return q}map(q){return new be(this.expr.map(ae=>ae.map(q)),null)}negate(){if(!this.c){const q=[];for(const ae of this.expr)q.push(ae.negate());for(;q.length>1;){const ae=q.shift(),le=q.shift(),ne=[];for(const ce of Te(ae))for(const oe of Te(le))ne.push(ve.create([ce,oe],null,!1));q.unshift(be.create(ne,null,!1))}this.c=be.create(q,this,!0)}return this.c}}e.$Wj=be;class de extends b{static all(){return de.d.values()}constructor(q,ae,le){super(q,null),this.f=ae,typeof le=="object"?de.d.push({...le,key:q}):le!==!0&&de.d.push({key:q,description:le,type:ae!=null?typeof ae:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return T.create(this.key,q)}notEqualsTo(q){return f.create(this.key,q)}}e.$Xj=de,de.d=[],e.$Yj=(0,R.$Gi)("contextKeyService");function $e(re,q){return re<q?-1:re>q?1:0}function ye(re,q,ae,le){return re<ae?-1:re>ae?1:q<le?-1:q>le?1:0}function Y(re,q){if(re.type===u.False||q.type===u.True)return!0;if(re.type===u.Or)return q.type===u.Or?we(re.expr,q.expr):!1;if(q.type===u.Or){for(const ae of q.expr)if(Y(re,ae))return!0;return!1}if(re.type===u.And){if(q.type===u.And)return we(q.expr,re.expr);for(const ae of re.expr)if(Y(ae,q))return!0;return!1}return re.equals(q)}function we(re,q){let ae=0,le=0;for(;ae<re.length&&le<q.length;){const ne=re[ae].cmp(q[le]);if(ne<0)return!1;ne===0&&ae++,le++}return ae===re.length}function Te(re){return re.type===u.Or?re.expr:[re]}}),define(Ie[209],Pe([1,0,32,3]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$rt=e.AccessibilitySupport=e.$qt=void 0,e.$st=O,e.$qt=(0,y.$Gi)("accessibilityService");var k;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(k||(e.AccessibilitySupport=k={})),e.$rt=new w.$Xj("accessibilityModeEnabled",!1);function O(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$tt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ie[106],Pe([1,0,18,26,21,145,322,155,210,168,209]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=l,e.stringSet=$,e.cursorStyleToString=L,e.filterValidationDecorations=Ae,w=Ve(w),y=Ve(y),k=Ve(k),s=Ve(s);var E;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(V){this.c=V}hasChanged(V){return this.c[V]}}e.ConfigurationChangedEvent=u;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class d{constructor(V,Se,Xe,et){this.id=V,this.name=Se,this.defaultValue=Xe,this.schema=et}applyUpdate(V,Se){return o(V,Se)}compute(V,Se,Xe){return Xe}}class n{constructor(V,Se){this.newValue=V,this.didChange=Se}}e.ApplyUpdateResult=n;function o(te,V){if(typeof te!="object"||typeof V!="object"||!te||!V)return new n(V,te!==V);if(Array.isArray(te)||Array.isArray(V)){const Xe=Array.isArray(te)&&Array.isArray(V)&&w.$xb(te,V);return new n(V,!Xe)}let Se=!1;for(const Xe in V)if(V.hasOwnProperty(Xe)){const et=o(te[Xe],V[Xe]);et.didChange&&(te[Xe]=et.newValue,Se=!0)}return new n(te,Se)}class c{constructor(V){this.schema=void 0,this.id=V,this.name="_never_",this.defaultValue=void 0}applyUpdate(V,Se){return o(V,Se)}validate(V){return this.defaultValue}}class h{constructor(V,Se,Xe,et){this.id=V,this.name=Se,this.defaultValue=Xe,this.schema=et}applyUpdate(V,Se){return o(V,Se)}validate(V){return typeof V>"u"?this.defaultValue:V}compute(V,Se,Xe){return Xe}}function i(te,V){return typeof te>"u"?V:te==="false"?!1:!!te}class r extends h{constructor(V,Se,Xe,et=void 0){typeof et<"u"&&(et.type="boolean",et.default=Xe),super(V,Se,Xe,et)}validate(V){return i(V,this.defaultValue)}}function t(te,V,Se,Xe){if(typeof te>"u")return V;let et=parseInt(te,10);return isNaN(et)?V:(et=Math.max(Se,et),et=Math.min(Xe,et),et|0)}class a extends h{static clampedInt(V,Se,Xe,et){return t(V,Se,Xe,et)}constructor(V,Se,Xe,et,ft,$t=void 0){typeof $t<"u"&&($t.type="integer",$t.default=Xe,$t.minimum=et,$t.maximum=ft),super(V,Se,Xe,$t),this.minimum=et,this.maximum=ft}validate(V){return a.clampedInt(V,this.defaultValue,this.minimum,this.maximum)}}function l(te,V,Se,Xe){if(typeof te>"u")return V;const et=g.float(te,V);return g.clamp(et,Se,Xe)}class g extends h{static clamp(V,Se,Xe){return V<Se?Se:V>Xe?Xe:V}static float(V,Se){if(typeof V=="number")return V;if(typeof V>"u")return Se;const Xe=parseFloat(V);return isNaN(Xe)?Se:Xe}constructor(V,Se,Xe,et,ft){typeof ft<"u"&&(ft.type="number",ft.default=Xe),super(V,Se,Xe,ft),this.validationFn=et}validate(V){return this.validationFn(g.float(V,this.defaultValue))}}class m extends h{static string(V,Se){return typeof V!="string"?Se:V}constructor(V,Se,Xe,et=void 0){typeof et<"u"&&(et.type="string",et.default=Xe),super(V,Se,Xe,et)}validate(V){return m.string(V,this.defaultValue)}}function $(te,V,Se,Xe){return typeof te!="string"?V:Xe&&te in Xe?Xe[te]:Se.indexOf(te)===-1?V:te}class S extends h{constructor(V,Se,Xe,et,ft=void 0){typeof ft<"u"&&(ft.type="string",ft.enum=et,ft.default=Xe),super(V,Se,Xe,ft),this.c=et}validate(V){return $(V,this.defaultValue,this.c)}}class D extends d{constructor(V,Se,Xe,et,ft,$t,Mt=void 0){typeof Mt<"u"&&(Mt.type="string",Mt.enum=ft,Mt.default=et),super(V,Se,Xe,Mt),this.c=ft,this.d=$t}validate(V){return typeof V!="string"?this.defaultValue:this.c.indexOf(V)===-1?this.defaultValue:this.d(V)}}function b(te){switch(te){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class T extends d{constructor(){super(Be.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",tags:["accessibility"],description:s.localize(3,null)})}validate(V){switch(V){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(V,Se,Xe){return Xe===I.AccessibilitySupport.Unknown?V.accessibilitySupport:Xe}}class P extends d{constructor(){const V={insertSpace:!0,ignoreEmptyLines:!0};super(Be.comments,"comments",V,{"editor.comments.insertSpace":{type:"boolean",default:V.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:V.ignoreEmptyLines,description:s.localize(5,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{insertSpace:i(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function f(te){switch(te){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var M;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function L(te){switch(te){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function K(te){switch(te){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class J extends c{constructor(){super(Be.editorClassName)}compute(V,Se,Xe){const et=["monaco-editor"];return Se.get(Be.extraEditorClassName)&&et.push(Se.get(Be.extraEditorClassName)),V.extraEditorClassName&&et.push(V.extraEditorClassName),Se.get(Be.mouseStyle)==="default"?et.push("mouse-default"):Se.get(Be.mouseStyle)==="copy"&&et.push("mouse-copy"),Se.get(Be.showUnused)&&et.push("showUnused"),Se.get(Be.showDeprecated)&&et.push("showDeprecated"),et.join(" ")}}class z extends r{constructor(){super(Be.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(V,Se,Xe){return Xe&&V.emptySelectionClipboard}}class A extends d{constructor(){const V={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Be.find,"find",V,{"editor.find.cursorMoveOnType":{type:"boolean",default:V.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:V.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:V.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:V.globalFindClipboard,description:s.localize(16,null),included:k.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:V.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:V.loop,description:s.localize(18,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{cursorMoveOnType:i(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof V.seedSearchStringFromSelection=="boolean"?V.seedSearchStringFromSelection?"always":"never":$(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof V.autoFindInSelection=="boolean"?V.autoFindInSelection?"always":"never":$(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Se.loop,this.defaultValue.loop)}}}class W extends d{constructor(){super(Be.fontLigatures,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(V){return typeof V>"u"?this.defaultValue:typeof V=="string"?V==="false"||V.length===0?W.OFF:V==="true"?W.ON:V:V?W.ON:W.OFF}}e.EditorFontLigatures=W,W.OFF='"liga" off, "calt" off',W.ON='"liga" on, "calt" on';class Z extends d{constructor(){super(Be.fontVariations,"fontVariations",Z.OFF,{anyOf:[{type:"boolean",description:s.localize(22,null)},{type:"string",description:s.localize(23,null)}],description:s.localize(24,null),default:!1})}validate(V){return typeof V>"u"?this.defaultValue:typeof V=="string"?V==="false"?Z.OFF:V==="true"?Z.TRANSLATE:V:V?Z.TRANSLATE:Z.OFF}compute(V,Se,Xe){return V.fontInfo.fontVariationSettings}}e.EditorFontVariations=Z,Z.OFF="normal",Z.TRANSLATE="translate";class he extends c{constructor(){super(Be.fontInfo)}compute(V,Se,Xe){return V.fontInfo}}class ve extends h{constructor(){super(Be.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(25,null)})}validate(V){const Se=g.float(V,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(Se,6,100)}compute(V,Se,Xe){return V.fontInfo.fontSize}}class be extends d{constructor(){super(Be.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:be.d,maximum:be.e,errorMessage:s.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:be.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(27,null)})}validate(V){return V==="normal"||V==="bold"?V:String(a.clampedInt(V,e.EDITOR_FONT_DEFAULTS.fontWeight,be.d,be.e))}}be.c=["normal","bold","100","200","300","400","500","600","700","800","900"],be.d=1,be.e=1e3;class de extends d{constructor(){const V={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:V.multiple,enumDescriptions:[s.localize(28,null),s.localize(29,null),s.localize(30,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Be.gotoLocation,"gotoLocation",V,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(32,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(33,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:s.localize(34,null),...Se},"editor.gotoLocation.multipleImplementations":{description:s.localize(35,null),...Se},"editor.gotoLocation.multipleReferences":{description:s.localize(36,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:V.alternativeDefinitionCommand,enum:Xe,description:s.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:V.alternativeTypeDefinitionCommand,enum:Xe,description:s.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:V.alternativeDeclarationCommand,enum:Xe,description:s.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:V.alternativeImplementationCommand,enum:Xe,description:s.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:V.alternativeReferenceCommand,enum:Xe,description:s.localize(41,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{multiple:$(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??$(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??$(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??$(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??$(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??$(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $e extends d{constructor(){const V={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Be.hover,"hover",V,{"editor.hover.enabled":{type:"boolean",default:V.enabled,description:s.localize(42,null)},"editor.hover.delay":{type:"number",default:V.delay,minimum:0,maximum:1e4,description:s.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:V.sticky,description:s.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:V.hidingDelay,description:s.localize(45,null)},"editor.hover.above":{type:"boolean",default:V.above,description:s.localize(46,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{enabled:i(Se.enabled,this.defaultValue.enabled),delay:a.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:i(Se.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt(Se.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Se.above,this.defaultValue.above)}}}var ye;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(ye||(e.RenderMinimap=ye={}));class Y extends c{constructor(){super(Be.layoutInfo)}compute(V,Se,Xe){return Y.computeLayout(Se,{memory:V.memory,outerWidth:V.outerWidth,outerHeight:V.outerHeight,isDominatedByLongLines:V.isDominatedByLongLines,lineHeight:V.fontInfo.lineHeight,viewLineCount:V.viewLineCount,lineNumbersDigitCount:V.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:V.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:V.fontInfo.maxDigitWidth,pixelRatio:V.pixelRatio,glyphMarginDecorationLaneCount:V.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(V){const Se=V.height/V.lineHeight,Xe=Math.floor(V.paddingTop/V.lineHeight);let et=Math.floor(V.paddingBottom/V.lineHeight);V.scrollBeyondLastLine&&(et=Math.max(et,Se-1));const ft=(Xe+V.viewLineCount+et)/(V.pixelRatio*V.height),$t=Math.floor(V.viewLineCount/ft);return{typicalViewportLineCount:Se,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:et,desiredRatio:ft,minimapLineCount:$t}}static c(V,Se){const Xe=V.outerWidth,et=V.outerHeight,ft=V.pixelRatio;if(!V.minimap.enabled)return{renderMinimap:ye.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ft*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const $t=Se.stableMinimapLayoutInput,Mt=$t&&V.outerHeight===$t.outerHeight&&V.lineHeight===$t.lineHeight&&V.typicalHalfwidthCharacterWidth===$t.typicalHalfwidthCharacterWidth&&V.pixelRatio===$t.pixelRatio&&V.scrollBeyondLastLine===$t.scrollBeyondLastLine&&V.paddingTop===$t.paddingTop&&V.paddingBottom===$t.paddingBottom&&V.minimap.enabled===$t.minimap.enabled&&V.minimap.side===$t.minimap.side&&V.minimap.size===$t.minimap.size&&V.minimap.showSlider===$t.minimap.showSlider&&V.minimap.renderCharacters===$t.minimap.renderCharacters&&V.minimap.maxColumn===$t.minimap.maxColumn&&V.minimap.scale===$t.minimap.scale&&V.verticalScrollbarWidth===$t.verticalScrollbarWidth&&V.isViewportWrapping===$t.isViewportWrapping,Gt=V.lineHeight,ri=V.typicalHalfwidthCharacterWidth,li=V.scrollBeyondLastLine,fi=V.minimap.renderCharacters;let xe=ft>=2?Math.round(V.minimap.scale*2):V.minimap.scale;const Zt=V.minimap.maxColumn,Qt=V.minimap.size,vt=V.minimap.side,St=V.verticalScrollbarWidth,si=V.viewLineCount,Yt=V.remainingWidth,Bt=V.isViewportWrapping,bt=fi?2:3;let At=Math.floor(ft*et);const xt=At/ft;let Wt=!1,Ze=!1,_t=bt*xe,oi=xe/ft,gi=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:ui,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Ht,desiredRatio:ti,minimapLineCount:Tt}=Y.computeContainedMinimapLineCount({viewLineCount:si,scrollBeyondLastLine:li,paddingTop:V.paddingTop,paddingBottom:V.paddingBottom,height:et,lineHeight:Gt,pixelRatio:ft});if(si/Tt>1)Wt=!0,Ze=!0,xe=1,_t=1,oi=xe/ft;else{let Et=!1,ii=xe+1;if(Qt==="fit"){const yt=Math.ceil((Ft+si+Ht)*_t);Bt&&Mt&&Yt<=Se.stableFitRemainingWidth?(Et=!0,ii=Se.stableFitMaxMinimapScale):Et=yt>At}if(Qt==="fill"||Et){Wt=!0;const yt=xe;_t=Math.min(Gt*ft,Math.max(1,Math.floor(1/ti))),Bt&&Mt&&Yt<=Se.stableFitRemainingWidth&&(ii=Se.stableFitMaxMinimapScale),xe=Math.min(ii,Math.max(1,Math.floor(_t/bt))),xe>yt&&(gi=Math.min(2,xe/yt)),oi=xe/ft/gi,At=Math.ceil(Math.max(ui,Ft+si+Ht)*_t),Bt?(Se.stableMinimapLayoutInput=V,Se.stableFitRemainingWidth=Yt,Se.stableFitMaxMinimapScale=xe):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const It=Math.floor(Zt*oi),qt=Math.min(It,Math.max(0,Math.floor((Yt-St-2)*oi/(ri+oi)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(ft*qt);const Vt=Lt/ft;Lt=Math.floor(Lt*gi);const pi=fi?ye.Text:ye.Blocks,ei=vt==="left"?0:Xe-qt-St;return{renderMinimap:pi,minimapLeft:ei,minimapWidth:qt,minimapHeightIsEditorHeight:Wt,minimapIsSampling:Ze,minimapScale:xe,minimapLineHeight:_t,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Vt,minimapCanvasOuterHeight:xt}}static computeLayout(V,Se){const Xe=Se.outerWidth|0,et=Se.outerHeight|0,ft=Se.lineHeight|0,$t=Se.lineNumbersDigitCount|0,Mt=Se.typicalHalfwidthCharacterWidth,Gt=Se.maxDigitWidth,ri=Se.pixelRatio,li=Se.viewLineCount,fi=V.get(Be.wordWrapOverride2),xe=fi==="inherit"?V.get(Be.wordWrapOverride1):fi,Zt=xe==="inherit"?V.get(Be.wordWrap):xe,Qt=V.get(Be.wordWrapColumn),vt=Se.isDominatedByLongLines,St=V.get(Be.glyphMargin),si=V.get(Be.lineNumbers).renderType!==je.Off,Yt=V.get(Be.lineNumbersMinChars),Bt=V.get(Be.scrollBeyondLastLine),bt=V.get(Be.padding),At=V.get(Be.minimap),xt=V.get(Be.scrollbar),Wt=xt.verticalScrollbarSize,Ze=xt.verticalHasArrows,_t=xt.arrowSize,oi=xt.horizontalScrollbarSize,gi=V.get(Be.folding),It=V.get(Be.showFoldingControls)!=="never";let qt=V.get(Be.lineDecorationsWidth);gi&&It&&(qt+=16);let Lt=0;if(si){const Kt=Math.max($t,Yt);Lt=Math.round(Kt*Gt)}let Vt=0;St&&(Vt=ft*Se.glyphMarginDecorationLaneCount);let pi=0,ei=pi+Vt,ui=ei+Lt,Ft=ui+qt;const Ht=Xe-Vt-Lt-qt;let ti=!1,Tt=!1,Pt=-1;xe==="inherit"&&vt?(ti=!0,Tt=!0):Zt==="on"||Zt==="bounded"?Tt=!0:Zt==="wordWrapColumn"&&(Pt=Qt);const Et=Y.c({outerWidth:Xe,outerHeight:et,lineHeight:ft,typicalHalfwidthCharacterWidth:Mt,pixelRatio:ri,scrollBeyondLastLine:Bt,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:At,verticalScrollbarWidth:Wt,viewLineCount:li,remainingWidth:Ht,isViewportWrapping:Tt},Se.memory||new C);Et.renderMinimap!==ye.None&&Et.minimapLeft===0&&(pi+=Et.minimapWidth,ei+=Et.minimapWidth,ui+=Et.minimapWidth,Ft+=Et.minimapWidth);const ii=Ht-Et.minimapWidth,yt=Math.max(1,Math.floor((ii-Wt-2)/Mt)),ai=Ze?_t:0;return Tt&&(Pt=Math.max(1,yt),Zt==="bounded"&&(Pt=Math.min(Pt,Qt))),{width:Xe,height:et,glyphMarginLeft:pi,glyphMarginWidth:Vt,glyphMarginDecorationLaneCount:Se.glyphMarginDecorationLaneCount,lineNumbersLeft:ei,lineNumbersWidth:Lt,decorationsLeft:ui,decorationsWidth:qt,contentLeft:Ft,contentWidth:ii,minimap:Et,viewportColumn:yt,isWordWrapMinified:ti,isViewportWrapping:Tt,wrappingColumn:Pt,verticalScrollbarWidth:Wt,horizontalScrollbarHeight:oi,overviewRuler:{top:ai,width:Wt,height:et-2*ai,right:0}}}}e.EditorLayoutInfoComputer=Y;class we extends d{constructor(){super(Be.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(47,null),s.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(49,null)}})}validate(V){return $(V,"simple",["simple","advanced"])}compute(V,Se,Xe){return Se.get(Be.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var Te;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(Te||(e.ShowLightbulbIconMode=Te={}));class re extends d{constructor(){const V={enabled:Te.On};super(Be.lightbulb,"lightbulb",V,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Te.Off,Te.OnCode,Te.On],default:V.enabled,enumDescriptions:[s.localize(50,null),s.localize(51,null),s.localize(52,null)],description:s.localize(53,null)}})}validate(V){return!V||typeof V!="object"?this.defaultValue:{enabled:$(V.enabled,this.defaultValue.enabled,[Te.Off,Te.OnCode,Te.On])}}}class q extends d{constructor(){const V={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Be.stickyScroll,"stickyScroll",V,{"editor.stickyScroll.enabled":{type:"boolean",default:V.enabled,description:s.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:V.maxLineCount,minimum:1,maximum:20,description:s.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:V.defaultModel,description:s.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:V.scrollWithEditor,description:s.localize(57,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{enabled:i(Se.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(Se.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Se.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ae extends d{constructor(){const V={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Be.inlayHints,"inlayHints",V,{"editor.inlayHints.enabled":{type:"string",default:V.enabled,description:s.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(59,null),s.localize(60,null,k.$d?"Ctrl+Option":"Ctrl+Alt"),s.localize(61,null,k.$d?"Ctrl+Option":"Ctrl+Alt"),s.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:V.fontSize,markdownDescription:s.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:V.fontFamily,markdownDescription:s.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:V.padding,description:s.localize(65,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:$(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily),padding:i(Se.padding,this.defaultValue.padding)}}}class le extends d{constructor(){super(Be.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(V){return typeof V=="string"&&/^\d+(\.\d+)?ch$/.test(V)?-parseFloat(V.substring(0,V.length-2)):a.clampedInt(V,this.defaultValue,0,1e3)}compute(V,Se,Xe){return Xe<0?a.clampedInt(-Xe*V.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class ne extends g{constructor(){super(Be.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,V=>g.clamp(V,0,150),{markdownDescription:s.localize(66,null)})}compute(V,Se,Xe){return V.fontInfo.lineHeight}}class ce extends d{constructor(){const V={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Be.minimap,"minimap",V,{"editor.minimap.enabled":{type:"boolean",default:V.enabled,description:s.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:V.autohide,description:s.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(69,null),s.localize(70,null),s.localize(71,null)],default:V.size,description:s.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:V.side,description:s.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:V.showSlider,description:s.localize(74,null)},"editor.minimap.scale":{type:"number",default:V.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:V.renderCharacters,description:s.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:V.maxColumn,description:s.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:V.showRegionSectionHeaders,description:s.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:V.showMarkSectionHeaders,description:s.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:V.sectionHeaderFontSize,description:s.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:V.sectionHeaderLetterSpacing,description:s.localize(81,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{enabled:i(Se.enabled,this.defaultValue.enabled),autohide:i(Se.autohide,this.defaultValue.autohide),size:$(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(Se.side,this.defaultValue.side,["right","left"]),showSlider:$(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Se.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(Se.scale,1,1,3),maxColumn:a.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Se.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Se.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:g.clamp(Se.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:g.clamp(Se.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function oe(te){return te==="ctrlCmd"?k.$d?"metaKey":"ctrlKey":"altKey"}class H extends d{constructor(){super(Be.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(83,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{top:a.clampedInt(Se.top,0,0,1e3),bottom:a.clampedInt(Se.bottom,0,0,1e3)}}}class x extends d{constructor(){const V={enabled:!0,cycle:!0};super(Be.parameterHints,"parameterHints",V,{"editor.parameterHints.enabled":{type:"boolean",default:V.enabled,description:s.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:V.cycle,description:s.localize(85,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{enabled:i(Se.enabled,this.defaultValue.enabled),cycle:i(Se.cycle,this.defaultValue.cycle)}}}class ue extends c{constructor(){super(Be.pixelRatio)}compute(V,Se,Xe){return V.pixelRatio}}class me extends d{constructor(){super(Be.placeholder,"placeholder",void 0)}validate(V){return typeof V>"u"?this.defaultValue:typeof V=="string"?V:this.defaultValue}}class Oe extends d{constructor(){const V={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(86,null),s.localize(87,null),s.localize(88,null)]}];super(Be.quickSuggestions,"quickSuggestions",V,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:V.strings,description:s.localize(89,null)},comments:{anyOf:Se,default:V.comments,description:s.localize(90,null)},other:{anyOf:Se,default:V.other,description:s.localize(91,null)}},default:V,markdownDescription:s.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=V}validate(V){if(typeof V=="boolean"){const ri=V?"on":"off";return{comments:ri,strings:ri,other:ri}}if(!V||typeof V!="object")return this.defaultValue;const{other:Se,comments:Xe,strings:et}=V,ft=["on","inline","off"];let $t,Mt,Gt;return typeof Se=="boolean"?$t=Se?"on":"off":$t=$(Se,this.defaultValue.other,ft),typeof Xe=="boolean"?Mt=Xe?"on":"off":Mt=$(Xe,this.defaultValue.comments,ft),typeof et=="boolean"?Gt=et?"on":"off":Gt=$(et,this.defaultValue.strings,ft),{other:$t,comments:Mt,strings:Gt}}}var je;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(je||(e.RenderLineNumbersType=je={}));class ke extends d{constructor(){super(Be.lineNumbers,"lineNumbers",{renderType:je.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(93,null),s.localize(94,null),s.localize(95,null),s.localize(96,null)],default:"on",description:s.localize(97,null)})}validate(V){let Se=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof V<"u"&&(typeof V=="function"?(Se=je.Custom,Xe=V):V==="interval"?Se=je.Interval:V==="relative"?Se=je.Relative:V==="on"?Se=je.On:Se=je.Off),{renderType:Se,renderFn:Xe}}}function Ae(te){const V=te.get(Be.renderValidationDecorations);return V==="editable"?te.get(Be.readOnly):V!=="on"}class Ne extends d{constructor(){const V=[],Se={type:"number",description:s.localize(98,null)};super(Be.rulers,"rulers",V,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:s.localize(99,null),format:"color-hex"}}}]},default:V,description:s.localize(100,null)})}validate(V){if(Array.isArray(V)){const Se=[];for(const Xe of V)if(typeof Xe=="number")Se.push({column:a.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const et=Xe;Se.push({column:a.clampedInt(et.column,0,0,1e4),color:et.color})}return Se.sort((Xe,et)=>Xe.column-et.column),Se}return this.defaultValue}}class U extends d{constructor(){super(Be.readOnlyMessage,"readOnlyMessage",void 0)}validate(V){return!V||typeof V!="object"?this.defaultValue:V}}function B(te,V){if(typeof te!="string")return V;switch(te){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class G extends d{constructor(){const V={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Be.scrollbar,"scrollbar",V,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(101,null),s.localize(102,null),s.localize(103,null)],default:"auto",description:s.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(105,null),s.localize(106,null),s.localize(107,null)],default:"auto",description:s.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:V.verticalScrollbarSize,description:s.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:V.horizontalScrollbarSize,description:s.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:V.scrollByPage,description:s.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:V.ignoreHorizontalScrollbarInContentHeight,description:s.localize(112,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V,Xe=a.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=a.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(Se.vertical,this.defaultValue.vertical),horizontal:B(Se.horizontal,this.defaultValue.horizontal),useShadows:i(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:a.clampedInt(Se.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:a.clampedInt(Se.verticalSliderSize,et,0,1e3),scrollByPage:i(Se.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Se.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends d{constructor(){const V={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Be.unicodeHighlighting,"unicodeHighlight",V,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:V.nonBasicASCII,description:s.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:V.invisibleCharacters,description:s.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:V.ambiguousCharacters,description:s.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:V.includeComments,description:s.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:V.includeStrings,description:s.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:V.allowedCharacters,description:s.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:V.allowedLocales,description:s.localize(119,null)}})}applyUpdate(V,Se){let Xe=!1;Se.allowedCharacters&&V&&(y.$jo(V.allowedCharacters,Se.allowedCharacters)||(V={...V,allowedCharacters:Se.allowedCharacters},Xe=!0)),Se.allowedLocales&&V&&(y.$jo(V.allowedLocales,Se.allowedLocales)||(V={...V,allowedLocales:Se.allowedLocales},Xe=!0));const et=super.applyUpdate(V,Se);return Xe?new n(et.newValue,!0):et}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{nonBasicASCII:Qe(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Qe(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Qe(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(V.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(V.allowedLocales,this.defaultValue.allowedLocales)}}c(V,Se){if(typeof V!="object"||!V)return Se;const Xe={};for(const[et,ft]of Object.entries(V))ft===!0&&(Xe[et]=!0);return Xe}}class ee extends d{constructor(){const V={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Be.inlineSuggest,"inlineSuggest",V,{"editor.inlineSuggest.enabled":{type:"boolean",default:V.enabled,description:s.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:V.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(121,null),s.localize(122,null),s.localize(123,null)],description:s.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:V.suppressSuggestions,description:s.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:V.fontFamily,description:s.localize(126,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{enabled:i(Se.enabled,this.defaultValue.enabled),mode:$(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Se.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Se.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){const V={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Be.inlineEdit,"experimentalInlineEdit",V,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:V.enabled,description:s.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:V.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(128,null),s.localize(129,null),s.localize(130,null)],description:s.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:V.fontFamily,description:s.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:V.backgroundColoring,description:s.localize(133,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{enabled:i(Se.enabled,this.defaultValue.enabled),showToolbar:$(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(Se.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Se.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(Se.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Re extends d{constructor(){const V={enabled:N.$kt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$kt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Be.bracketPairColorization,"bracketPairColorization",V,{"editor.bracketPairColorization.enabled":{type:"boolean",default:V.enabled,markdownDescription:s.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:V.independentColorPoolPerBracketType,description:s.localize(135,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{enabled:i(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends d{constructor(){const V={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Be.guides,"guides",V,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(136,null),s.localize(137,null),s.localize(138,null)],default:V.bracketPairs,description:s.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(140,null),s.localize(141,null),s.localize(142,null)],default:V.bracketPairsHorizontal,description:s.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:V.highlightActiveBracketPair,description:s.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:V.indentation,description:s.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(146,null),s.localize(147,null),s.localize(148,null)],default:V.highlightActiveIndentation,description:s.localize(149,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{bracketPairs:Qe(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Qe(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:Qe(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Qe(te,V,Se){const Xe=Se.indexOf(te);return Xe===-1?V:Se[Xe]}class Ye extends d{constructor(){const V={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Be.suggest,"suggest",V,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(150,null),s.localize(151,null)],default:V.insertMode,description:s.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:V.filterGraceful,description:s.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:V.localityBonus,description:s.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:V.shareSuggestSelections,markdownDescription:s.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(156,null),s.localize(157,null),s.localize(158,null),s.localize(159,null)],default:V.selectionMode,markdownDescription:s.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:V.snippetsPreventQuickSuggestions,description:s.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:V.showIcons,description:s.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:V.showStatusBar,description:s.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:V.preview,description:s.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:V.showInlineDetails,description:s.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(197,null)}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{insertMode:$(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(Se.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Se.showIcons,this.defaultValue.showIcons),showStatusBar:i(Se.showStatusBar,this.defaultValue.showStatusBar),preview:i(Se.preview,this.defaultValue.preview),previewMode:$(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Se.showMethods,this.defaultValue.showMethods),showFunctions:i(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Se.showFields,this.defaultValue.showFields),showVariables:i(Se.showVariables,this.defaultValue.showVariables),showClasses:i(Se.showClasses,this.defaultValue.showClasses),showStructs:i(Se.showStructs,this.defaultValue.showStructs),showInterfaces:i(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Se.showModules,this.defaultValue.showModules),showProperties:i(Se.showProperties,this.defaultValue.showProperties),showEvents:i(Se.showEvents,this.defaultValue.showEvents),showOperators:i(Se.showOperators,this.defaultValue.showOperators),showUnits:i(Se.showUnits,this.defaultValue.showUnits),showValues:i(Se.showValues,this.defaultValue.showValues),showConstants:i(Se.showConstants,this.defaultValue.showConstants),showEnums:i(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Se.showKeywords,this.defaultValue.showKeywords),showWords:i(Se.showWords,this.defaultValue.showWords),showColors:i(Se.showColors,this.defaultValue.showColors),showFiles:i(Se.showFiles,this.defaultValue.showFiles),showReferences:i(Se.showReferences,this.defaultValue.showReferences),showFolders:i(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Se.showSnippets,this.defaultValue.showSnippets),showUsers:i(Se.showUsers,this.defaultValue.showUsers),showIssues:i(Se.showIssues,this.defaultValue.showIssues)}}}class it extends d{constructor(){super(Be.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(199,null),default:!0,type:"boolean"}})}validate(V){return!V||typeof V!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(V.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(V.selectSubwords,this.defaultValue.selectSubwords)}}}class ot extends d{constructor(){const V=[];super(Be.wordSegmenterLocales,"wordSegmenterLocales",V,{anyOf:[{description:s.localize(200,null),type:"string"},{description:s.localize(201,null),type:"array",items:{type:"string"}}]})}validate(V){if(typeof V=="string"&&(V=[V]),Array.isArray(V)){const Se=[];for(const Xe of V)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Se.push(Xe)}catch{}return Se}return this.defaultValue}}var tt;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(tt||(e.WrappingIndent=tt={}));class at extends d{constructor(){super(Be.wrappingIndent,"wrappingIndent",tt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(202,null),s.localize(203,null),s.localize(204,null),s.localize(205,null)],description:s.localize(206,null),default:"same"}})}validate(V){switch(V){case"none":return tt.None;case"same":return tt.Same;case"indent":return tt.Indent;case"deepIndent":return tt.DeepIndent}return tt.Same}compute(V,Se,Xe){return Se.get(Be.accessibilitySupport)===I.AccessibilitySupport.Enabled?tt.None:Xe}}class pt extends c{constructor(){super(Be.wrappingInfo)}compute(V,Se,Xe){const et=Se.get(Be.layoutInfo);return{isDominatedByLongLines:V.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}class ut extends d{constructor(){const V={enabled:!0,showDropSelector:"afterDrop"};super(Be.dropIntoEditor,"dropIntoEditor",V,{"editor.dropIntoEditor.enabled":{type:"boolean",default:V.enabled,markdownDescription:s.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(209,null),s.localize(210,null)],default:"afterDrop"}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{enabled:i(Se.enabled,this.defaultValue.enabled),showDropSelector:$(Se.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const V={enabled:!0,showPasteSelector:"afterPaste"};super(Be.pasteAs,"pasteAs",V,{"editor.pasteAs.enabled":{type:"boolean",default:V.enabled,markdownDescription:s.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(213,null),s.localize(214,null)],default:"afterPaste"}})}validate(V){if(!V||typeof V!="object")return this.defaultValue;const Se=V;return{enabled:i(Se.enabled,this.defaultValue.enabled),showPasteSelector:$(Se.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ht="Consolas, 'Courier New', monospace",mt="Menlo, Monaco, 'Courier New', monospace",wt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.$d?mt:k.$e?wt:ht,fontWeight:"normal",fontSize:k.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function qe(te){return e.editorOptionsRegistry[te.id]=te,te}var Be;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.placeholder=88]="placeholder",te[te.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",te[te.quickSuggestions=90]="quickSuggestions",te[te.quickSuggestionsDelay=91]="quickSuggestionsDelay",te[te.readOnly=92]="readOnly",te[te.readOnlyMessage=93]="readOnlyMessage",te[te.renameOnType=94]="renameOnType",te[te.renderControlCharacters=95]="renderControlCharacters",te[te.renderFinalNewline=96]="renderFinalNewline",te[te.renderLineHighlight=97]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=99]="renderValidationDecorations",te[te.renderWhitespace=100]="renderWhitespace",te[te.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",te[te.roundedSelection=102]="roundedSelection",te[te.rulers=103]="rulers",te[te.scrollbar=104]="scrollbar",te[te.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=106]="scrollBeyondLastLine",te[te.scrollPredominantAxis=107]="scrollPredominantAxis",te[te.selectionClipboard=108]="selectionClipboard",te[te.selectionHighlight=109]="selectionHighlight",te[te.selectOnLineNumbers=110]="selectOnLineNumbers",te[te.showFoldingControls=111]="showFoldingControls",te[te.showUnused=112]="showUnused",te[te.snippetSuggestions=113]="snippetSuggestions",te[te.smartSelect=114]="smartSelect",te[te.smoothScrolling=115]="smoothScrolling",te[te.stickyScroll=116]="stickyScroll",te[te.stickyTabStops=117]="stickyTabStops",te[te.stopRenderingLineAfter=118]="stopRenderingLineAfter",te[te.suggest=119]="suggest",te[te.suggestFontSize=120]="suggestFontSize",te[te.suggestLineHeight=121]="suggestLineHeight",te[te.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",te[te.suggestSelection=123]="suggestSelection",te[te.tabCompletion=124]="tabCompletion",te[te.tabIndex=125]="tabIndex",te[te.unicodeHighlighting=126]="unicodeHighlighting",te[te.unusualLineTerminators=127]="unusualLineTerminators",te[te.useShadowDOM=128]="useShadowDOM",te[te.useTabStops=129]="useTabStops",te[te.wordBreak=130]="wordBreak",te[te.wordSegmenterLocales=131]="wordSegmenterLocales",te[te.wordSeparators=132]="wordSeparators",te[te.wordWrap=133]="wordWrap",te[te.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=136]="wordWrapColumn",te[te.wordWrapOverride1=137]="wordWrapOverride1",te[te.wordWrapOverride2=138]="wordWrapOverride2",te[te.wrappingIndent=139]="wrappingIndent",te[te.wrappingStrategy=140]="wrappingStrategy",te[te.showDeprecated=141]="showDeprecated",te[te.inlayHints=142]="inlayHints",te[te.editorClassName=143]="editorClassName",te[te.pixelRatio=144]="pixelRatio",te[te.tabFocusMode=145]="tabFocusMode",te[te.layoutInfo=146]="layoutInfo",te[te.wrappingInfo=147]="wrappingInfo",te[te.defaultColorDecorators=148]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Be||(e.EditorOption=Be={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:qe(new r(Be.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(215,null)})),acceptSuggestionOnEnter:qe(new S(Be.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(216,null),""],markdownDescription:s.localize(217,null)})),accessibilitySupport:qe(new T),accessibilityPageSize:qe(new a(Be.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(218,null),tags:["accessibility"]})),ariaLabel:qe(new m(Be.ariaLabel,"ariaLabel",s.localize(219,null))),ariaRequired:qe(new r(Be.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:qe(new r(Be.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:qe(new S(Be.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(221,null),s.localize(222,null),""],description:s.localize(223,null)})),autoClosingComments:qe(new S(Be.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(224,null),s.localize(225,null),""],description:s.localize(226,null)})),autoClosingDelete:qe(new S(Be.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(227,null),""],description:s.localize(228,null)})),autoClosingOvertype:qe(new S(Be.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(229,null),""],description:s.localize(230,null)})),autoClosingQuotes:qe(new S(Be.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(231,null),s.localize(232,null),""],description:s.localize(233,null)})),autoIndent:qe(new D(Be.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[s.localize(234,null),s.localize(235,null),s.localize(236,null),s.localize(237,null),s.localize(238,null)],description:s.localize(239,null)})),automaticLayout:qe(new r(Be.automaticLayout,"automaticLayout",!1)),autoSurround:qe(new S(Be.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(240,null),s.localize(241,null),s.localize(242,null),""],description:s.localize(243,null)})),bracketPairColorization:qe(new Re),bracketPairGuides:qe(new Ue),stickyTabStops:qe(new r(Be.stickyTabStops,"stickyTabStops",!1,{description:s.localize(244,null)})),codeLens:qe(new r(Be.codeLens,"codeLens",!0,{description:s.localize(245,null)})),codeLensFontFamily:qe(new m(Be.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(246,null)})),codeLensFontSize:qe(new a(Be.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(247,null)})),colorDecorators:qe(new r(Be.colorDecorators,"colorDecorators",!0,{description:s.localize(248,null)})),colorDecoratorActivatedOn:qe(new S(Be.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(249,null),s.localize(250,null),s.localize(251,null)],description:s.localize(252,null)})),colorDecoratorsLimit:qe(new a(Be.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(253,null)})),columnSelection:qe(new r(Be.columnSelection,"columnSelection",!1,{description:s.localize(254,null)})),comments:qe(new P),contextmenu:qe(new r(Be.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:qe(new r(Be.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(255,null)})),cursorBlinking:qe(new D(Be.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],f,{description:s.localize(256,null)})),cursorSmoothCaretAnimation:qe(new S(Be.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null)],description:s.localize(260,null)})),cursorStyle:qe(new D(Be.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],K,{description:s.localize(261,null)})),cursorSurroundingLines:qe(new a(Be.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(262,null)})),cursorSurroundingLinesStyle:qe(new S(Be.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(263,null),s.localize(264,null)],markdownDescription:s.localize(265,null)})),cursorWidth:qe(new a(Be.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(266,null)})),disableLayerHinting:qe(new r(Be.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:qe(new r(Be.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:qe(new r(Be.domReadOnly,"domReadOnly",!1)),dragAndDrop:qe(new r(Be.dragAndDrop,"dragAndDrop",!0,{description:s.localize(267,null)})),emptySelectionClipboard:qe(new z),dropIntoEditor:qe(new ut),stickyScroll:qe(new q),experimentalWhitespaceRendering:qe(new S(Be.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(268,null),s.localize(269,null),s.localize(270,null)],description:s.localize(271,null)})),extraEditorClassName:qe(new m(Be.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:qe(new g(Be.fastScrollSensitivity,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:s.localize(272,null)})),find:qe(new A),fixedOverflowWidgets:qe(new r(Be.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:qe(new r(Be.folding,"folding",!0,{description:s.localize(273,null)})),foldingStrategy:qe(new S(Be.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(274,null),s.localize(275,null)],description:s.localize(276,null)})),foldingHighlight:qe(new r(Be.foldingHighlight,"foldingHighlight",!0,{description:s.localize(277,null)})),foldingImportsByDefault:qe(new r(Be.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(278,null)})),foldingMaximumRegions:qe(new a(Be.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(279,null)})),unfoldOnClickAfterEndOfLine:qe(new r(Be.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(280,null)})),fontFamily:qe(new m(Be.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(281,null)})),fontInfo:qe(new he),fontLigatures2:qe(new W),fontSize:qe(new ve),fontWeight:qe(new be),fontVariations:qe(new Z),formatOnPaste:qe(new r(Be.formatOnPaste,"formatOnPaste",!1,{description:s.localize(282,null)})),formatOnType:qe(new r(Be.formatOnType,"formatOnType",!1,{description:s.localize(283,null)})),glyphMargin:qe(new r(Be.glyphMargin,"glyphMargin",!0,{description:s.localize(284,null)})),gotoLocation:qe(new de),hideCursorInOverviewRuler:qe(new r(Be.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(285,null)})),hover:qe(new $e),inDiffEditor:qe(new r(Be.inDiffEditor,"inDiffEditor",!1)),letterSpacing:qe(new g(Be.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>g.clamp(te,-5,20),{description:s.localize(286,null)})),lightbulb:qe(new re),lineDecorationsWidth:qe(new le),lineHeight:qe(new ne),lineNumbers:qe(new ke),lineNumbersMinChars:qe(new a(Be.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:qe(new r(Be.linkedEditing,"linkedEditing",!1,{description:s.localize(287,null)})),links:qe(new r(Be.links,"links",!0,{description:s.localize(288,null)})),matchBrackets:qe(new S(Be.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(289,null)})),minimap:qe(new ce),mouseStyle:qe(new S(Be.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:qe(new g(Be.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:s.localize(290,null)})),mouseWheelZoom:qe(new r(Be.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:k.$d?s.localize(291,null):s.localize(292,null)})),multiCursorMergeOverlapping:qe(new r(Be.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(293,null)})),multiCursorModifier:qe(new D(Be.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],oe,{markdownEnumDescriptions:[s.localize(294,null),s.localize(295,null)],markdownDescription:s.localize(296,null)})),multiCursorPaste:qe(new S(Be.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(297,null),s.localize(298,null)],markdownDescription:s.localize(299,null)})),multiCursorLimit:qe(new a(Be.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(300,null)})),occurrencesHighlight:qe(new S(Be.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(301,null),s.localize(302,null),s.localize(303,null)],markdownDescription:s.localize(304,null)})),overviewRulerBorder:qe(new r(Be.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(305,null)})),overviewRulerLanes:qe(new a(Be.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:qe(new H),pasteAs:qe(new st),parameterHints:qe(new x),peekWidgetDefaultFocus:qe(new S(Be.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(306,null),s.localize(307,null)],description:s.localize(308,null)})),placeholder:qe(new me),definitionLinkOpensInPeek:qe(new r(Be.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(309,null)})),quickSuggestions:qe(new Oe),quickSuggestionsDelay:qe(new a(Be.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(310,null)})),readOnly:qe(new r(Be.readOnly,"readOnly",!1)),readOnlyMessage:qe(new U),renameOnType:qe(new r(Be.renameOnType,"renameOnType",!1,{description:s.localize(311,null),markdownDeprecationMessage:s.localize(312,null)})),renderControlCharacters:qe(new r(Be.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(313,null),restricted:!0})),renderFinalNewline:qe(new S(Be.renderFinalNewline,"renderFinalNewline",k.$e?"dimmed":"on",["off","on","dimmed"],{description:s.localize(314,null)})),renderLineHighlight:qe(new S(Be.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(315,null)],description:s.localize(316,null)})),renderLineHighlightOnlyWhenFocus:qe(new r(Be.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(317,null)})),renderValidationDecorations:qe(new S(Be.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:qe(new S(Be.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(318,null),s.localize(319,null),s.localize(320,null),""],description:s.localize(321,null)})),revealHorizontalRightPadding:qe(new a(Be.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:qe(new r(Be.roundedSelection,"roundedSelection",!0,{description:s.localize(322,null)})),rulers:qe(new Ne),scrollbar:qe(new G),scrollBeyondLastColumn:qe(new a(Be.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(323,null)})),scrollBeyondLastLine:qe(new r(Be.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(324,null)})),scrollPredominantAxis:qe(new r(Be.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(325,null)})),selectionClipboard:qe(new r(Be.selectionClipboard,"selectionClipboard",!0,{description:s.localize(326,null),included:k.$e})),selectionHighlight:qe(new r(Be.selectionHighlight,"selectionHighlight",!0,{description:s.localize(327,null)})),selectOnLineNumbers:qe(new r(Be.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:qe(new S(Be.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(328,null),s.localize(329,null),s.localize(330,null)],description:s.localize(331,null)})),showUnused:qe(new r(Be.showUnused,"showUnused",!0,{description:s.localize(332,null)})),showDeprecated:qe(new r(Be.showDeprecated,"showDeprecated",!0,{description:s.localize(333,null)})),inlayHints:qe(new ae),snippetSuggestions:qe(new S(Be.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(334,null),s.localize(335,null),s.localize(336,null),s.localize(337,null)],description:s.localize(338,null)})),smartSelect:qe(new it),smoothScrolling:qe(new r(Be.smoothScrolling,"smoothScrolling",!1,{description:s.localize(339,null)})),stopRenderingLineAfter:qe(new a(Be.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:qe(new Ye),inlineSuggest:qe(new ee),inlineEdit:qe(new fe),inlineCompletionsAccessibilityVerbose:qe(new r(Be.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(340,null)})),suggestFontSize:qe(new a(Be.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:qe(new a(Be.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:qe(new r(Be.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(343,null)})),suggestSelection:qe(new S(Be.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(344,null),s.localize(345,null),s.localize(346,null)],description:s.localize(347,null)})),tabCompletion:qe(new S(Be.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(348,null),s.localize(349,null),s.localize(350,null)],description:s.localize(351,null)})),tabIndex:qe(new a(Be.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:qe(new Q),unusualLineTerminators:qe(new S(Be.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)})),useShadowDOM:qe(new r(Be.useShadowDOM,"useShadowDOM",!0)),useTabStops:qe(new r(Be.useTabStops,"useTabStops",!0,{description:s.localize(356,null)})),wordBreak:qe(new S(Be.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(357,null),s.localize(358,null)],description:s.localize(359,null)})),wordSegmenterLocales:qe(new ot),wordSeparators:qe(new m(Be.wordSeparators,"wordSeparators",v.$lt,{description:s.localize(360,null)})),wordWrap:qe(new S(Be.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null),s.localize(363,null),s.localize(364,null)],description:s.localize(365,null)})),wordWrapBreakAfterCharacters:qe(new m(Be.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:qe(new m(Be.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:qe(new a(Be.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(366,null)})),wordWrapOverride1:qe(new S(Be.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:qe(new S(Be.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:qe(new J),defaultColorDecorators:qe(new r(Be.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(367,null)})),pixelRatio:qe(new ue),tabFocusMode:qe(new r(Be.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(368,null)})),layoutInfo:qe(new Y),wrappingInfo:qe(new pt),wrappingIndent:qe(new at),wrappingStrategy:qe(new we)}}),define(Ie[107],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=void 0,e.$Ni=(0,w.$Gi)("environmentService"),e.$Oi=(0,w.$Hi)(e.$Ni)}),define(Ie[30],Pe([1,0,59,20,13,15,2,174,3,21,16,48]),function(_,e,w,y,k,O,R,N,v,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Fl=e.FileKind=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.FileOperationResult=e.$xl=e.$wl=e.$vl=e.$tl=e.FileChangeType=e.$sl=e.FileOperation=e.$ml=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$al=void 0,e.$bl=u,e.$cl=o,e.$dl=h,e.$el=i,e.$fl=r,e.$gl=t,e.$hl=a,e.$il=l,e.$jl=g,e.$kl=m,e.$ll=$,e.$nl=b,e.$ol=T,e.$pl=P,e.$ql=p,e.$rl=f,e.$ul=z,e.$Gl=be,e.$Hl=de,e.$Jl=ye,e.$al=(0,v.$Gi)("fileService");function u(Y){return Y.create===!0}var C;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(C||(e.FileType=C={}));var d;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var n;(function(Y){Y[Y.UPDATED=2]="UPDATED",Y[Y.ADDED=4]="ADDED",Y[Y.DELETED=8]="DELETED"})(n||(e.FileChangeFilter=n={}));function o(Y){const we=Y;return!!we&&typeof we.onDidChange=="function"}var c;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function h(Y){return!!(Y.capabilities&c.FileReadWrite)}function i(Y){return!!(Y.capabilities&c.FileFolderCopy)}function r(Y){return!!(Y.capabilities&c.FileClone)}function t(Y){return!!(Y.capabilities&c.FileOpenReadWriteClose)}function a(Y){return!!(Y.capabilities&c.FileReadStream)}function l(Y){return h(Y)?!!(Y.capabilities&c.FileAtomicRead):!1}function g(Y){return h(Y)?!!(Y.capabilities&c.FileAtomicWrite):!1}function m(Y){return!!(Y.capabilities&c.FileAtomicDelete)}function $(Y){return!!(Y.capabilities&c.Readonly)}var S;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class D extends Error{static create(we,Te){const re=new D(we.toString(),Te);return P(re,Te),re}constructor(we,Te){super(we),this.code=Te}}e.$ml=D;function b(Y,we){return D.create(Y,we)}function T(Y){return Y||b((0,N.localize)(0,null),S.Unknown)}function P(Y,we){return Y.name=we?`${we} (FileSystemError)`:"FileSystemError",Y}function p(Y){if(!Y)return S.Unknown;if(Y instanceof D)return Y.code;const we=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!we)return S.Unknown;switch(we[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function f(Y){if(Y instanceof A)return Y.fileOperationResult;switch(p(Y)){case S.FileNotFound:return he.FILE_NOT_FOUND;case S.FileIsADirectory:return he.FILE_IS_DIRECTORY;case S.FileNotADirectory:return he.FILE_NOT_DIRECTORY;case S.FileWriteLocked:return he.FILE_WRITE_LOCKED;case S.NoPermissions:return he.FILE_PERMISSION_DENIED;case S.FileExists:return he.FILE_MOVE_CONFLICT;case S.FileTooLarge:return he.FILE_TOO_LARGE;default:return he.FILE_OTHER_ERROR}}var M;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class L{constructor(we,Te,re){this.resource=we,this.operation=Te,this.target=re}isOperation(we){return this.operation===we}}e.$sl=L;var K;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(K||(e.FileChangeType=K={}));class J{constructor(we,Te){this.c=Te,this.b=void 0,this.d=new E.$X(()=>{const re=w.$Mi.forUris(()=>this.c);return re.fill(this.rawAdded.map(q=>[q,!0])),re}),this.f=new E.$X(()=>{const re=w.$Mi.forUris(()=>this.c);return re.fill(this.rawUpdated.map(q=>[q,!0])),re}),this.g=new E.$X(()=>{const re=w.$Mi.forUris(()=>this.c);return re.fill(this.rawDeleted.map(q=>[q,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of we){switch(re.type){case K.ADDED:this.rawAdded.push(re.resource);break;case K.UPDATED:this.rawUpdated.push(re.resource);break;case K.DELETED:this.rawDeleted.push(re.resource);break}this.b!==J.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=J.a):this.b!==void 0&&(this.b=J.a))}}contains(we,...Te){return this.h(we,{includeChildren:!1},...Te)}affects(we,...Te){return this.h(we,{includeChildren:!0},...Te)}h(we,Te,...re){if(!we)return!1;const q=re.length>0;return!!((!q||re.includes(K.ADDED))&&(this.d.value.get(we)||Te.includeChildren&&this.d.value.findSuperstr(we))||(!q||re.includes(K.UPDATED))&&(this.f.value.get(we)||Te.includeChildren&&this.f.value.findSuperstr(we))||(!q||re.includes(K.DELETED))&&(this.g.value.findSubstr(we)||Te.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$tl=J,J.a=null;function z(Y,we,Te){return!Y||!we||Y===we||we.length>Y.length?!1:(we.charAt(we.length-1)!==y.sep&&(we+=y.sep),Te?(0,k.$If)(Y,we):Y.indexOf(we)===0)}class A extends Error{constructor(we,Te,re){super(we),this.fileOperationResult=Te,this.options=re}}e.$vl=A;class W extends A{constructor(we,Te,re,q){super(we,Te,q),this.fileOperationResult=Te,this.size=re}}e.$wl=W;class Z extends A{constructor(we,Te,re){super(we,he.FILE_NOT_MODIFIED_SINCE,re),this.stat=Te}}e.$xl=Z;var he;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(he||(e.FileOperationResult=he={})),e.$yl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$zl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Al="files.associations",e.$Bl="files.exclude",e.$Cl="files.readonlyInclude",e.$Dl="files.readonlyExclude",e.$El="files.readonlyFromPermissions";var ve;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(ve||(e.FileKind=ve={})),e.$Fl="";function be(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}async function de(Y,we){if(!we.hasProvider(R.URI.from({scheme:Y.scheme})))return new Promise(Te=>{const re=we.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===Y.scheme&&q.added&&(re.dispose(),Te())})})}class $e{static formatSize(we){return(0,O.$kg)(we)||(we=0),we<$e.KB?(0,N.localize)(1,null,we.toFixed(0)):we<$e.MB?(0,N.localize)(2,null,(we/$e.KB).toFixed(2)):we<$e.GB?(0,N.localize)(3,null,(we/$e.MB).toFixed(2)):we<$e.TB?(0,N.localize)(4,null,(we/$e.GB).toFixed(2)):(0,N.localize)(5,null,(we/$e.TB).toFixed(2))}}e.$Il=$e,$e.KB=1024,$e.MB=$e.KB*$e.KB,$e.GB=$e.MB*$e.KB,$e.TB=$e.GB*$e.KB;function ye(Y){const we=typeof Y=="string"||Y?.scheme===I.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===I.Schemas.file?1024*$e.MB:we?10*$e.MB:s.$i?50*$e.MB:1024*$e.MB}}),define(Ie[75],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=void 0;class w{constructor(...k){this.a=new Map;for(const[O,R]of k)this.set(O,R)}set(k,O){const R=this.a.get(k);return this.a.set(k,O),R}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$Ei=w}),define(Ie[211],Pe([1,0,11,14,4,74,208,3,75,212]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;const I=!1;class E extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new v.$Ei,c=!1,h,i=I){this.i=o,this.j=c,this.k=h,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(N.$Fi,this),this._globalGraph=i?h?._globalGraph??new R.$ur(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Sc)(this.h),this.h.clear();for(const o of this.g)(0,k.$Rc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,c){this.m();const h=this,i=new class extends u{dispose(){h.h.delete(i),super.dispose()}}(o,this.j,this,this.l);return this.h.add(i),c?.add(i),i}invokeFunction(o,...c){this.m();const h=d.traceInvocation(this.l,o);let i=!1;try{return o({get:t=>{if(i)throw(0,y.$$)("service accessor is only valid during the invocation of its target method");const a=this.s(t,h);if(!a)throw new Error(`[invokeFunction] unknown service '${t}'`);return a}},...c)}finally{i=!0,h.stop()}}createInstance(o,...c){this.m();let h,i;return o instanceof O.$Di?(h=d.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(c),h)):(h=d.traceCreation(this.l,o),i=this.o(o,c,h)),h.stop(),i}o(o,c=[],h){const i=N._util.getServiceDependencies(o).sort((a,l)=>a.index-l.index),r=[];for(const a of i){const l=this.s(a.id,h);l||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${a.id}.`,!1),r.push(l)}const t=i.length>0?i[0].index:c.length;if(c.length!==t){console.trace(`[createInstance] First service dependency of ${o.name} at position ${t+1} conflicts with ${c.length} static arguments`);const a=t-c.length;a>0?c=c.concat(new Array(a)):c=c.slice(0,t)}return Reflect.construct(o,c.concat(r))}q(o,c){if(this.i.get(o)instanceof O.$Di)this.i.set(o,c);else if(this.k)this.k.q(o,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const c=this.i.get(o);return!c&&this.k?this.k.r(o):c}s(o,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const h=this.r(o);return h instanceof O.$Di?this.u(o,h,c.branch(o,!0)):(c.branch(o,!1),h)}u(o,c,h){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,c,h)}finally{this.t.delete(o)}}v(o,c,h){const i=new R.$ur(a=>a.id.toString());let r=0;const t=[{id:o,desc:c,_trace:h}];for(;t.length;){const a=t.pop();if(i.lookupOrInsertNode(a),r++>1e3)throw new E(i);for(const l of N._util.getServiceDependencies(a.desc.ctor)){const g=this.r(l.id);if(g||this.y(`[createInstance] ${o} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(a.id),String(l.id)),g instanceof O.$Di){const m={id:l.id,desc:g,_trace:a._trace.branch(l.id,!0)};i.insertEdge(a,m),t.push(m)}}}for(;;){const a=i.roots();if(a.length===0){if(!i.isEmpty())throw new E(i);break}for(const{data:l}of a){if(this.r(l.id)instanceof O.$Di){const m=this.w(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.q(l.id,m)}i.removeNode(l)}}return this.r(o)}w(o,c,h=[],i,r){if(this.i.get(o)instanceof O.$Di)return this.x(o,c,h,i,r,this.g);if(this.k)return this.k.w(o,c,h,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(o,c,h=[],i,r,t){if(i){const a=new u(void 0,this.j,this,this.l);a.c=String(o);const l=new Map,g=new w.$Zh(()=>{const m=a.o(c,h,r);for(const[$,S]of l){const D=m[$];if(typeof D=="function")for(const b of S)b.disposable=D.apply(m,b.listener)}return l.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,$){if(!g.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let b=l.get($);return b||(b=new s.$8c,l.set($,b)),(P,p,f)=>{if(g.isInitialized)return g.value[$](P,p,f);{const M={listener:[P,p,f],disposable:void 0},L=b.push(M);return(0,k.$Vc)(()=>{L(),M.disposable?.dispose()})}}}if($ in m)return m[$];const S=g.value;let D=S[$];return typeof D!="function"||(D=D.bind(S),m[$]=D),D},set(m,$,S){return g.value[$]=S,!0},getPrototypeOf(m){return c.prototype}})}else{const a=this.o(c,h,r);return t.add(a),a}}y(o,c){if(c&&console.warn(o),this.j)throw new Error(o)}}e.$vr=u;var C;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(C||(C={}));class d{static traceInvocation(o,c){return o?new d(C.Invocation,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,c){return o?new d(C.Creation,c.name):d.c}constructor(o,c){this.type=o,this.name=c,this.g=Date.now(),this.h=[]}branch(o,c){const h=new d(C.Branch,o.toString());return this.h.push([o,c,h]),h}stop(){const o=Date.now()-this.g;d.f+=o;let c=!1;function h(r,t){const a=[],l=new Array(r+1).join("	");for(const[g,m,$]of t.h)if(m&&$){c=!0,a.push(`${l}CREATES -> ${g}`);const S=h(r+1,$);S&&a.push(S)}else a.push(`${l}uses -> ${g}`);return a.join(`
`)}const i=[`${this.type===C.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||c)&&d.all.add(i.join(`
`))}}e.$wr=d,d.all=new Set,d.c=new class extends d{constructor(){super(C.None,null)}stop(){}branch(){return this}},d.f=0}),define(Ie[12],Pe([1,0,175,42,6,76,4,29,21,24,15,2,32,3]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$dk=e.LogLevel=e.$bk=e.$ak=void 0,e.$ck=n,e.log=c,e.$ok=D,e.$pk=b,e.$qk=T,e.$rk=P,w=Ve(w),e.$ak=(0,C.$Gi)("logService"),e.$bk=(0,C.$Gi)("loggerService");function d(){return new Date().toISOString()}function n(p){return(0,I.$kg)(p)}var o;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$dk=o.Info;function c(p,f,M){switch(f){case o.Trace:p.trace(M);break;case o.Debug:p.debug(M);break;case o.Info:p.info(M);break;case o.Warning:p.warn(M);break;case o.Error:p.error(M);break;case o.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function h(p,f=!1){let M="";for(let L=0;L<p.length;L++){let K=p[L];if(K instanceof Error&&(K=(0,y.$rj)(K,f)),typeof K=="object")try{K=JSON.stringify(K)}catch{}M+=(L>0?" ":"")+K}return M}class i extends R.$Xc{constructor(){super(...arguments),this.b=e.$dk,this.c=this.B(new k.$ne),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==o.Off&&this.b<=f}}e.$fk=i;class r extends i{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...M){this.f(o.Trace)&&this.g(o.Trace,h([f,...M],!0))}debug(f,...M){this.f(o.Debug)&&this.g(o.Debug,h([f,...M]))}info(f,...M){this.f(o.Info)&&this.g(o.Info,h([f,...M]))}warn(f,...M){this.f(o.Warning)&&this.g(o.Warning,h([f,...M]))}error(f,...M){if(this.f(o.Error))if(f instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=f.stack,this.g(o.Error,h(L))}else this.g(o.Error,h([f,...M]))}flush(){}}e.$gk=r;class t extends i{constructor(f=e.$dk){super(),this.setLevel(f),this.g=!v.$c}trace(f,...M){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,f,...M):console.log(`[main ${d()}]`,f,...M))}debug(f,...M){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,f,...M):console.log(`[main ${d()}]`,f,...M))}info(f,...M){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,f,...M):console.log(`[main ${d()}]`,f,...M))}warn(f,...M){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,f,...M):console.warn(`[main ${d()}]`,f,...M))}error(f,...M){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,f,...M):console.error(`[main ${d()}]`,f,...M))}flush(){}}e.$hk=t;class a extends i{constructor(f=e.$dk,M=!0){super(),this.g=M,this.setLevel(f)}trace(f,...M){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...M):console.log(f,...M))}debug(f,...M){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...M):console.log(f,...M))}info(f,...M){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...M):console.log(f,...M))}warn(f,...M){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...M):console.log(f,...M))}error(f,...M){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...M):console.error(f,...M))}flush(){}}e.$ik=a;class l extends i{constructor(f,M=e.$dk){super(),this.g=f,this.setLevel(M)}trace(f,...M){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(f),...M])}debug(f,...M){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(f),...M])}info(f,...M){this.f(o.Info)&&this.g.log(o.Info,[this.h(f),...M])}warn(f,...M){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(f),...M])}error(f,...M){this.f(o.Error)&&this.g.log(o.Error,[this.h(f),...M])}h(f){return typeof f=="string"?f:(0,y.$rj)(f,this.f(o.Trace))}flush(){}}e.$jk=l;class g extends i{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const M of this.g)M.setLevel(f);super.setLevel(f)}trace(f,...M){for(const L of this.g)L.trace(f,...M)}debug(f,...M){for(const L of this.g)L.debug(f,...M)}info(f,...M){for(const L of this.g)L.info(f,...M)}warn(f,...M){for(const L of this.g)L.warn(f,...M)}error(f,...M){for(const L of this.g)L.error(f,...M)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose();super.dispose()}}e.$kk=g;class m extends R.$Xc{constructor(f,M,L){if(super(),this.h=f,this.j=M,this.b=new N.$Dc,this.c=this.B(new k.$ne),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$ne),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$ne),this.onDidChangeVisibility=this.g.event,L)for(const K of L)this.b.set(K.resource,{logger:void 0,info:K})}m(f){return(0,I.$gg)(f)?[...this.b.values()].find(M=>M.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,M){const L=this.n(f),K=(0,I.$gg)(f)?f:M?.id??(0,O.$uj)(L.toString()).toString(16);let J=this.b.get(L)?.logger;const z=M?.logLevel==="always"?o.Trace:M?.logLevel;J||(J=this.s(L,z??this.getLogLevel(L)??this.h,{...M,id:K}));const A={logger:J,info:{resource:L,id:K,logLevel:z,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(A.info),this.b.set(L,A),J}n(f){return(0,I.$gg)(f)?(0,s.$hh)(this.j,`${f}.log`):f}setLogLevel(f,M){if(E.URI.isUri(f)){const L=f,K=M,J=this.b.get(L);J&&K!==J.info.logLevel&&(J.info.logLevel=K===this.h?void 0:K,J.logger?.setLevel(K),this.b.set(J.info.resource,J),this.f.fire([L,K]))}else{this.h=f;for(const[L,K]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&K.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,M){const L=this.m(f);L&&M!==!L.info.hidden&&(L.info.hidden=!M,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,M]))}getLogLevel(f){let M;return f&&(M=this.b.get(f)?.info.logLevel),M??this.h}registerLogger(f){const M=this.b.get(f.resource);M?M.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const M=this.b.get(f);M&&(M.logger&&M.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$lk=m;class ${constructor(){this.onDidChangeLogLevel=new k.$ne().event}setLevel(f){}getLevel(){return o.Info}trace(f,...M){}debug(f,...M){}info(f,...M){}warn(f,...M){}error(f,...M){}critical(f,...M){}dispose(){}flush(){}}e.$mk=$;class S extends ${}e.$nk=S;function D(p){if(p.verbose)return o.Trace;if(typeof p.logLevel=="string"){const f=P(p.logLevel.toLowerCase());if(f!==void 0)return f}return e.$dk}function b(p){switch(p){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function T(p){switch(p){case o.Trace:return{original:"Trace",value:w.localize(0,null)};case o.Debug:return{original:"Debug",value:w.localize(1,null)};case o.Info:return{original:"Info",value:w.localize(2,null)};case o.Warning:return{original:"Warning",value:w.localize(3,null)};case o.Error:return{original:"Error",value:w.localize(4,null)};case o.Off:return{original:"Off",value:w.localize(5,null)}}}function P(p){switch(p){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$sk=new u.$Xj("logLevel",b(o.Info))}),define(Ie[213],Pe([1,0,4,12]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qR=void 0;class k extends w.$Xc{constructor(R,N=[]){super(),this.a=new y.$kk([R,...N]),this.B(R.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...N){this.a.trace(R,...N)}debug(R,...N){this.a.debug(R,...N)}info(R,...N){this.a.info(R,...N)}warn(R,...N){this.a.warn(R,...N)}error(R,...N){this.a.error(R,...N)}flush(){this.a.flush()}}e.$qR=k});var ni=this&&this.__importDefault||function(_){return _&&_.__esModule?_:{default:_}};define(Ie[108],Pe([1,0,36,176,3]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,w=ni(w);var O;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var R;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(v){function s(d,n){return n-d}v.compare=s;const I=Object.create(null);I[v.Error]=(0,y.localize)(0,null),I[v.Warning]=(0,y.localize)(1,null),I[v.Info]=(0,y.localize)(2,null);function E(d){return I[d]||""}v.toString=E;function u(d){switch(d){case w.default.Error:return v.Error;case w.default.Warning:return v.Warning;case w.default.Info:return v.Info;case w.default.Ignore:return v.Hint}}v.fromSeverity=u;function C(d){switch(d){case v.Error:return w.default.Error;case v.Warning:return w.default.Warning;case v.Info:return w.default.Info;case v.Hint:return w.default.Ignore}}v.toSeverity=C}(R||(e.MarkerSeverity=R={}));var N;(function(v){const s="";function I(u){return E(u,!0)}v.makeKey=I;function E(u,C){const d=[s];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(s),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(s),u.severity!==void 0&&u.severity!==null?d.push(R.toString(u.severity)):d.push(s),u.message&&C?d.push(u.message.replace("\xA6","\\\xA6")):d.push(s),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(s),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(s),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(s),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(s),d.push(s),d.join("\xA6")}v.makeKeyOptionalMessage=E})(N||(e.IMarkerData=N={})),e.$Eu=(0,k.$Gi)("markerService")});var ni=this&&this.__importDefault||function(_){return _&&_.__esModule?_:{default:_}};define(Ie[214],Pe([1,0,6,36,3]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uw=e.$tw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$rw=e.Severity=void 0,e.$sw=N,y=ni(y),e.Severity=y.default,e.$rw=(0,k.$Gi)("notificationService");var O;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var R;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function N(E){if(E){const u=E;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var v;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})(v||(e.NotificationsFilter=v={}));class s{constructor(){this.progress=new I,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$tw=s;class I{infinite(){}done(){}total(u){}worked(u){}}e.$uw=I}),define(Ie[109],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$tk=(0,w.$Gi)("productService"),e.$uk="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(_,e,w,y){var k=arguments.length,O=k<3?e:y===null?y=Object.getOwnPropertyDescriptor(e,w):y,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(_,e,w,y);else for(var N=_.length-1;N>=0;N--)(R=_[N])&&(O=(k<3?R(O):k>3?R(e,w,O):R(e,w))||O);return k>3&&O&&Object.defineProperty(e,w,O),O},Ge=this&&this.__param||function(_,e){return function(w,y){e(w,y,_)}};define(Ie[77],Pe([1,0,11,22,4,3]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.$ww=e.ProgressLocation=e.$vw=void 0,e.$vw=(0,O.$Gi)("progressService");var R;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$ww=Object.freeze({total(){},worked(){},done(){}});class N{get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$xw=N,N.None=Object.freeze({report(){}});class v{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const C=this.d;this.d=()=>{C?.(),u()}}):Promise.resolve()}}e.$yw=v;let s=class extends k.$Xc{constructor(u,C){super(),this.a=new w.$4h,C.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,k.$Vc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$zw=s,e.$zw=s=He([Ge(1,e.$vw)],s);class I extends k.$Xc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new k.$Wc)}start(u){this.stop();const C=++this.a,d=new y.$ye;return this.f=setTimeout(()=>{C===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,k.$Vc)(()=>clearTimeout(this.f))),this.b.add((0,k.$Vc)(()=>d.cancel())),this.b.add((0,k.$Vc)(()=>this.c?this.c.done():void 0)),{id:C,token:d.token,stop:()=>this.h(C),isCurrent:()=>this.a===C}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Aw=I,e.$Bw=(0,O.$Gi)("editorProgressService")}),define(Ie[31],Pe([1,0,62,15]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0,w=Ve(w),y=Ve(y);class k{constructor(){this.a=new Map}add(R,N){w.ok(y.$gg(R)),w.ok(y.$ig(N)),w.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,N)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$so=new k}),define(Ie[78],Pe([1,0,6,31]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=void 0,y=Ve(y),e.$to={JSONContribution:"base.contributions.json"};function k(N){return N.length>0&&N.charAt(N.length-1)==="#"?N.substring(0,N.length-1):N}class O{constructor(){this.b=new w.$ne,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,s){this.a[k(v)]=s,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const R=new O;y.$so.add(e.$to.JSONContribution,R)}),define(Ie[54],Pe([1,0,18,6,15,169,43,78,31]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.ConfigurationScope=e.$xo=e.EditPresentationTypes=void 0,e.$Io=n,e.$Jo=o,e.$Ko=c,e.$Lo=i,e.$Mo=r,k=Ve(k),O=Ve(O);var s;(function(t){t.Multiline="multilineText",t.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$xo={Configuration:"base.contributions.configuration"};var I;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.MACHINE=2]="MACHINE",t[t.WINDOW=3]="WINDOW",t[t.RESOURCE=4]="RESOURCE",t[t.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",t[t.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co={properties:{},patternProperties:{}},e.$Do={properties:{},patternProperties:{}},e.$Eo="vscode://schemas/settings/resourceLanguage",e.$Fo="vscode://schemas/settings/configurationDefaults";const E=v.$so.as(N.$to.JSONContribution);class u{constructor(){this.h=new Set,this.i=new y.$ne,this.onDidSchemaChange=this.i.event,this.j=new y.$ne,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Eo,this.g),this.v()}registerConfiguration(a,l=!0){this.registerConfigurations([a],l)}registerConfigurations(a,l=!0){const g=new Set;this.n(a,l,g),E.registerSchema(e.$Eo,this.g),this.i.fire(),this.j.fire({properties:g})}deregisterConfigurations(a){const l=new Set;this.o(a,l),E.registerSchema(e.$Eo,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:a,remove:l}){const g=new Set;this.o(l,g),this.n(a,!1,g),E.registerSchema(e.$Eo,this.g),this.i.fire(),this.j.fire({properties:g})}registerDefaultConfigurations(a){const l=new Set;this.k(a,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(a,l){const g=[];for(const{overrides:m,source:$}of a)for(const S in m)if(l.add(S),e.$Ho.test(S)){const D=this.a.get(S),b=D?.valuesSources??new Map,T=D?.value||{};for(const f of Object.keys(m[S])){const M=m[S][f];if(k.$ig(M)&&(k.$ng(T[f])||k.$ig(T[f]))){if(T[f]={...T[f]??{},...M},$){let K=b.get(f);if(K||(K=new Map,b.set(f,K)),!(K instanceof Map)){console.error("objectConfigurationSources is not a Map");continue}for(const J in M)K.set(J,$)}}else T[f]=M,$&&b.set(f,$)}this.a.set(S,{source:$,value:T,valuesSources:b});const P=(0,R.$kj)(S),p={type:"object",default:T,description:O.localize(1,null,P),$ref:e.$Eo,defaultDefaultValue:T,source:k.$gg($)?void 0:$,defaultValueSource:$};g.push(...n(S)),this.d[S]=p,this.b.properties[S]=p}else{const D=this.d[S],b=this.a.get(S);let T=b?.value??D?.defaultDefaultValue,P=m[S],p=$;if(k.$ig(P)&&(D!==void 0&&D.type==="object"||D===void 0&&(k.$ng(T)||k.$ig(T)))){if(k.$ig(T)||(T={}),P={...T,...P},p=b?.source??new Map,!(p instanceof Map)){console.error("defaultValueSource is not a Map");continue}for(const M in m[S])$?p.set(M,$):p.delete(M)}this.a.set(S,{value:P,source:p}),D&&(this.w(S,D),this.r(S,D))}this.m(g)}deregisterDefaultConfigurations(a){const l=new Set;this.l(a,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(a,l){for(const{overrides:g,source:m}of a)for(const $ in g){const S=k.$gg(m)?m:m?.id,D=this.a.get($);if(D){if(e.$Ho.test($)){for(const T of Object.keys(g[$])){const P=g[$][T];if(k.$ig(P)){const p=D.valuesSources?.get(T);for(const f of Object.keys(P)){const M=p?.get(f);(k.$gg(M)?M:M?.id)===S&&(p?.delete(f),delete D.value[T][f])}Object.keys(D.value[T]).length===0&&(delete D.value[T],D.valuesSources?.delete(T))}else{const p=D.valuesSources?.get(T);(k.$gg(p)?p:p?.id)===S&&(D.valuesSources?.delete(T),delete D.value[T])}}const b=this.a.get($);b&&Object.keys(b.value).length===0&&(this.a.delete($),delete this.d[$],delete this.b.properties[$])}else{if(D.source instanceof Map){const T=D.source;for(const P in g[$]){const p=T.get(P);(k.$gg(p)?p:p?.id)===S&&(T.delete(P),delete D.value[P])}T.size===0&&this.a.delete($)}else{const T=k.$gg(D.source)?D.source:D.source?.id;if(S!==T)continue;this.a.delete($)}const b=this.d[$];b&&(this.w($,b),this.r($,b))}l.add($)}}this.u()}deltaConfiguration(a){let l=!1;const g=new Set;a.removedDefaults&&(this.l(a.removedDefaults,g),l=!0),a.addedDefaults&&(this.k(a.addedDefaults,g),l=!0),a.removedConfigurations&&this.o(a.removedConfigurations,g),a.addedConfigurations&&this.n(a.addedConfigurations,!1,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...a){this.i.fire()}registerOverrideIdentifiers(a){this.m(a),this.i.fire()}m(a){for(const l of a)this.h.add(l);this.u()}n(a,l,g){a.forEach(m=>{this.p(m,l,m.extensionInfo,m.restrictedProperties,void 0,g),this.c.push(m),this.q(m)})}o(a,l){const g=m=>{if(m.properties)for(const $ in m.properties){l.add($);const S=this.d[$];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[$],this.s($,m.properties[$])}m.allOf?.forEach($=>g($))};for(const m of a){g(m);const $=this.c.indexOf(m);$!==-1&&this.c.splice($,1)}}p(a,l=!0,g,m,$=I.WINDOW,S){$=k.$pg(a.scope)?$:a.scope;const D=a.properties;if(D)for(const T in D){const P=D[T];if(l&&i(T,P)){delete D[T];continue}if(P.source=g,P.defaultDefaultValue=D[T].default,this.w(T,P),e.$Ho.test(T)?P.scope=void 0:(P.scope=k.$pg(P.scope)?$:P.scope,P.restricted=k.$pg(P.restricted)?!!m?.includes(T):P.restricted),D[T].hasOwnProperty("included")&&!D[T].included){this.f[T]=D[T],delete D[T];continue}else this.d[T]=D[T],D[T].policy?.name&&this.e.set(D[T].policy.name,T);!D[T].deprecationMessage&&D[T].markdownDeprecationMessage&&(D[T].deprecationMessage=D[T].markdownDeprecationMessage),S.add(T)}const b=a.allOf;if(b)for(const T of b)this.p(T,l,g,m,$,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(a){const l=g=>{const m=g.properties;if(m)for(const S in m)this.r(S,m[S]);g.allOf?.forEach(l)};l(a)}r(a,l){switch(e.$yo.properties[a]=l,l.scope){case I.APPLICATION:e.$zo.properties[a]=l;break;case I.MACHINE:e.$Ao.properties[a]=l;break;case I.MACHINE_OVERRIDABLE:e.$Bo.properties[a]=l;break;case I.WINDOW:e.$Co.properties[a]=l;break;case I.RESOURCE:e.$Do.properties[a]=l;break;case I.LANGUAGE_OVERRIDABLE:e.$Do.properties[a]=l,this.g.properties[a]=l;break}}s(a,l){switch(delete e.$yo.properties[a],l.scope){case I.APPLICATION:delete e.$zo.properties[a];break;case I.MACHINE:delete e.$Ao.properties[a];break;case I.MACHINE_OVERRIDABLE:delete e.$Bo.properties[a];break;case I.WINDOW:delete e.$Co.properties[a];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Do.properties[a],delete this.g.properties[a];break}}u(){for(const a of this.h.values()){const l=`[${a}]`,g={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$Eo};this.w(l,g),e.$yo.properties[l]=g,e.$zo.properties[l]=g,e.$Ao.properties[l]=g,e.$Bo.properties[l]=g,e.$Co.properties[l]=g,e.$Do.properties[l]=g}}v(){const a={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$Eo};e.$yo.patternProperties[e.$Go]=a,e.$zo.patternProperties[e.$Go]=a,e.$Ao.patternProperties[e.$Go]=a,e.$Bo.patternProperties[e.$Go]=a,e.$Co.patternProperties[e.$Go]=a,e.$Do.patternProperties[e.$Go]=a,this.i.fire()}w(a,l){const g=this.a.get(a);let m=g?.value,$=g?.source;k.$ng(m)&&(m=l.defaultDefaultValue,$=void 0),k.$ng(m)&&(m=c(l.type)),l.default=m,l.defaultValueSource=$}}const C="\\[([^\\]]+)\\]",d=new RegExp(C,"g");e.$Go=`^(${C})+$`,e.$Ho=new RegExp(e.$Go);function n(t){const a=[];if(e.$Ho.test(t)){let l=d.exec(t);for(;l?.length;){const g=l[1].trim();g&&a.push(g),l=d.exec(t)}}return(0,w.$Pb)(a)}function o(t){return t.reduce((a,l)=>`${a}[${l}]`,"")}function c(t){switch(Array.isArray(t)?t[0]:t){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;v.$so.add(e.$xo.Configuration,h);function i(t,a){return t.trim()?e.$Ho.test(t)?O.localize(7,null,t):h.getConfigurationProperties()[t]!==void 0?O.localize(8,null,t):a.policy?.name&&h.getPolicyConfigurations().get(a.policy?.name)!==void 0?O.localize(9,null,t,a.policy?.name,h.getPolicyConfigurations().get(a.policy?.name)):null:O.localize(6,null)}function r(){const t=[],a=h.getConfigurationProperties();for(const l of Object.keys(a))t.push([l,a[l].scope]);return t.push(["launch",I.RESOURCE]),t.push(["task",I.RESOURCE]),t}}),define(Ie[215],Pe([1,0,18,6,136,4,29,26,15,2,43,54,30,31]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$Ro=r,w=Ve(w),k=Ve(k),N=Ve(N),v=Ve(v);function d(g){return Object.isFrozen(g)?g:N.$go(g)}class n{static createEmptyModel(m){return new n({},[],[],void 0,m)}constructor(m,$,S,D,b){this.b=m,this.c=$,this.d=S,this.raw=D,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const m=this.raw.map($=>{if($ instanceof n)return $;const S=new o("",this.f);return S.parseRaw($),S.configurationModel});this.g=m.reduce(($,S)=>S===$?S:$.merge(S),m[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(m){return m?(0,I.$ij)(this.contents,m):this.contents}inspect(m,$){const S=this;return{get value(){return d(S.rawConfiguration.getValue(m))},get override(){return $?d(S.rawConfiguration.getOverrideValue(m,$)):void 0},get merged(){return d($?S.rawConfiguration.override($).getValue(m):S.rawConfiguration.getValue(m))},get overrides(){const D=[];for(const{contents:b,identifiers:T,keys:P}of S.rawConfiguration.overrides){const p=new n(b,P,[],void 0,S.f).getValue(m);p!==void 0&&D.push({identifiers:T,value:p})}return D.length?d(D):void 0}}}getOverrideValue(m,$){const S=this.j($);return S?m?(0,I.$ij)(S,m):S:void 0}getKeysForOverrideIdentifier(m){const $=[];for(const S of this.overrides)S.identifiers.includes(m)&&$.push(...S.keys);return w.$Pb($)}getAllOverrideIdentifiers(){const m=[];for(const $ of this.overrides)m.push(...$.identifiers);return w.$Pb(m)}override(m){let $=this.a.get(m);return $||($=this.h(m),this.a.set(m,$)),$}merge(...m){const $=N.$fo(this.contents),S=N.$fo(this.overrides),D=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const T of m)if(b.push(...T.raw?.length?T.raw:[T]),!T.isEmpty()){this.i($,T.contents);for(const P of T.overrides){const[p]=S.filter(f=>w.$xb(f.identifiers,P.identifiers));p?(this.i(p.contents,P.contents),p.keys.push(...P.keys),p.keys=w.$Pb(p.keys)):S.push(N.$fo(P))}for(const P of T.keys)D.indexOf(P)===-1&&D.push(P)}return new n($,D,S,b.every(T=>T instanceof n)?void 0:b,this.f)}h(m){const $=this.j(m);if(!$||typeof $!="object"||!Object.keys($).length)return this;const S={};for(const D of w.$Pb([...Object.keys(this.contents),...Object.keys($)])){let b=this.contents[D];const T=$[D];T&&(typeof b=="object"&&typeof T=="object"?(b=N.$fo(b),this.i(b,T)):b=T),S[D]=b}return new n(S,this.keys,this.overrides,void 0,this.f)}i(m,$){for(const S of Object.keys($)){if(S in m&&v.$ig(m[S])&&v.$ig($[S])){this.i(m[S],$[S]);continue}m[S]=N.$fo($[S])}}j(m){let $=null,S=null;const D=b=>{b&&(S?this.i(S,b):S=N.$fo(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===m?$=b.contents:b.identifiers.includes(m)&&D(b.contents);return D($),S}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,$){this.k(m,$,!0)}setValue(m,$){this.k(m,$,!1)}removeValue(m){const $=this.keys.indexOf(m);$!==-1&&(this.keys.splice($,1),(0,I.$hj)(this.contents,m),E.$Ho.test(m)&&this.overrides.splice(this.overrides.findIndex(S=>w.$xb(S.identifiers,(0,E.$Io)(m))),1))}k(m,$,S){(0,I.$gj)(this.contents,m,$,D=>this.f.error(D)),S=S||this.keys.indexOf(m)===-1,S&&this.keys.push(m),E.$Ho.test(m)&&this.overrides.push({identifiers:(0,E.$Io)(m),keys:Object.keys(this.contents[m]),contents:(0,I.$fj)(this.contents[m],D=>this.f.error(D))})}}e.$No=n;class o{constructor(m,$){this.f=m,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||n.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(m,$){if(!v.$pg(m)){const S=this.h(m);this.parseRaw(S,$)}}reparse(m){this.a&&this.parseRaw(this.a,m)}parseRaw(m,$){this.a=m;const{contents:S,keys:D,overrides:b,restricted:T,hasExcludedProperties:P}=this.i(m,$);this.b=new n(S,D,b,P?[m]:void 0,this.g),this.c=T||[]}h(m){let $={},S=null,D=[];const b=[],T=[];function P(f){Array.isArray(D)?D.push(f):S!==null&&(D[S]=f)}const p={onObjectBegin:()=>{const f={};P(f),b.push(D),D=f,S=null},onObjectProperty:f=>{S=f},onObjectEnd:()=>{D=b.pop()},onArrayBegin:()=>{const f=[];P(f),b.push(D),D=f,S=null},onArrayEnd:()=>{D=b.pop()},onLiteralValue:P,onError:(f,M,L)=>{T.push({error:f,offset:M,length:L})}};if(m)try{k.$7n(m,p),$=D[0]||{}}catch(f){this.g.error(`Error while parsing settings file ${this.f}: ${f}`),this.d=[f]}return $}i(m,$){const S=C.$so.as(E.$xo.Configuration).getConfigurationProperties(),D=this.j(m,S,!0,$);m=D.raw;const b=(0,I.$fj)(m,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),T=Object.keys(m),P=this.l(m,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:b,keys:T,overrides:P,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(m,$,S,D){let b=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:b};const T={},P=[];for(const p in m)if(E.$Ho.test(p)&&S){const f=this.j(m[p],$,!1,D);T[p]=f.raw,b=b||f.hasExcludedProperties,P.push(...f.restricted)}else{const f=$[p],M=f?typeof f.scope<"u"?f.scope:E.ConfigurationScope.WINDOW:void 0;f?.restricted&&P.push(p),!D.exclude?.includes(p)&&(D.include?.includes(p)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&f?.restricted))?T[p]=m[p]:b=!0}return{raw:T,restricted:P,hasExcludedProperties:b}}l(m,$){const S=[];for(const D of Object.keys(m))if(E.$Ho.test(D)){const b={};for(const T in m[D])b[T]=m[D][T];S.push({identifiers:(0,E.$Io)(D),keys:Object.keys(b),contents:(0,I.$fj)(b,$)})}return S}}e.$Oo=o;class c extends O.$Xc{constructor(m,$,S,D,b){super(),this.c=m,this.f=$,this.g=D,this.h=b,this.b=this.B(new y.$ne),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),b),this.B(this.g.watch(S.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(y.Event.any(y.Event.filter(this.g.onDidFilesChange,T=>T.contains(this.c)),y.Event.filter(this.g.onDidRunOperation,T=>(T.isOperation(u.FileOperation.CREATE)||T.isOperation(u.FileOperation.COPY)||T.isOperation(u.FileOperation.DELETE)||T.isOperation(u.FileOperation.WRITE))&&S.isEqual(T.resource,m)))(()=>this.b.fire()))}async loadConfiguration(){try{const m=await this.g.readFile(this.c);return this.a.parse(m.value.toString()||"{}",this.f),this.a.configurationModel}catch{return n.createEmptyModel(this.h)}}reparse(m){return m&&(this.f=m),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Po=c;class h{constructor(m,$,S,D,b,T,P,p,f,M,L,K,J){this.a=m,this.b=$,this.c=S,this.overrideIdentifiers=D,this.d=b,this.f=T,this.g=P,this.h=p,this.i=f,this.j=M,this.k=L,this.l=K,this.m=J}get value(){return d(this.c)}n(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(m,$,S,D,b,T,P,p,f,M){this.j=m,this.l=$,this.m=S,this.n=D,this.p=b,this.q=T,this.r=P,this.s=p,this.t=f,this.u=M,this.h=null,this.i=new R.$Dc,this.v=null}getValue(m,$,S){return this.w(m,$,S).getValue(m)}updateValue(m,$,S={}){let D;S.resource?(D=this.t.get(S.resource),D||(D=n.createEmptyModel(this.u),this.t.set(S.resource,D))):D=this.s,$===void 0?D.removeValue(m):D.setValue(m,$),S.resource||(this.h=null)}inspect(m,$,S){const D=this.w(m,$,S),b=this.A($.resource,S),T=$.resource?this.t.get($.resource)||this.s:this.s,P=new Set;for(const p of D.overrides)for(const f of p.identifiers)D.getOverrideValue(m,f)!==void 0&&P.add(f);return new h(m,$,D.getValue(m),P.size?[...P]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,S?this.q:void 0,b||void 0,T)}keys(m){const $=this.A(void 0,m);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(m){this.j=m,this.h=null,this.i.clear()}updatePolicyConfiguration(m){this.l=m}updateApplicationConfiguration(m){this.m=m,this.h=null,this.i.clear()}updateLocalUserConfiguration(m){this.n=m,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(m){this.p=m,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(m){this.q=m,this.h=null,this.i.clear()}updateFolderConfiguration(m,$){this.r.set(m,$),this.i.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this.i.delete(m)}compareAndUpdateDefaultConfiguration(m,$){const S=[];if(!$){const{added:D,updated:b,removed:T}=a(this.j,m);$=[...D,...b,...T]}for(const D of $)for(const b of(0,E.$Io)(D)){const T=this.j.getKeysForOverrideIdentifier(b),P=m.getKeysForOverrideIdentifier(b),p=[...P.filter(f=>T.indexOf(f)===-1),...T.filter(f=>P.indexOf(f)===-1),...T.filter(f=>!N.$jo(this.j.override(b).getValue(f),m.override(b).getValue(f)))];S.push([b,p])}return this.updateDefaultConfiguration(m),{keys:$,overrides:S}}compareAndUpdatePolicyConfiguration(m){const{added:$,updated:S,removed:D}=a(this.l,m),b=[...$,...S,...D];return b.length&&this.updatePolicyConfiguration(m),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:$,updated:S,removed:D,overrides:b}=a(this.applicationConfiguration,m),T=[...$,...S,...D];return T.length&&this.updateApplicationConfiguration(m),{keys:T,overrides:b}}compareAndUpdateLocalUserConfiguration(m){const{added:$,updated:S,removed:D,overrides:b}=a(this.localUserConfiguration,m),T=[...$,...S,...D];return T.length&&this.updateLocalUserConfiguration(m),{keys:T,overrides:b}}compareAndUpdateRemoteUserConfiguration(m){const{added:$,updated:S,removed:D,overrides:b}=a(this.remoteUserConfiguration,m),T=[...$,...S,...D];return T.length&&this.updateRemoteUserConfiguration(m),{keys:T,overrides:b}}compareAndUpdateWorkspaceConfiguration(m){const{added:$,updated:S,removed:D,overrides:b}=a(this.workspaceConfiguration,m),T=[...$,...S,...D];return T.length&&this.updateWorkspaceConfiguration(m),{keys:T,overrides:b}}compareAndUpdateFolderConfiguration(m,$){const S=this.folderConfigurations.get(m),{added:D,updated:b,removed:T,overrides:P}=a(S,$),p=[...D,...b,...T];return(p.length||!S)&&this.updateFolderConfiguration(m,$),{keys:p,overrides:P}}compareAndDeleteFolderConfiguration(m){const $=this.folderConfigurations.get(m);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:S,updated:D,removed:b,overrides:T}=a($,void 0);return{keys:[...S,...D,...b],overrides:T}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(m,$,S){let D=this.x($,S);return $.overrideIdentifier&&(D=D.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(m)!==void 0&&(D=D.merge(this.l)),D}x({resource:m},$){let S=this.y();if($&&m){const D=$.getFolder(m);D&&(S=this.z(D.uri)||S);const b=this.t.get(m);b&&(S=S.merge(b))}return S}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(m){let $=this.i.get(m);if(!$){const S=this.y(),D=this.r.get(m);D?($=S.merge(D),this.i.set(m,$)):$=S}return $}A(m,$){if($&&m){const S=$.getFolder(m);if(S)return this.r.get(S.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((m,$)=>{const{contents:S,overrides:D,keys:b}=this.r.get($);return m.push([$,{contents:S,overrides:D,keys:b}]),m},[])}}allKeys(){const m=new Set;return this.j.keys.forEach($=>m.add($)),this.userConfiguration.keys.forEach($=>m.add($)),this.q.keys.forEach($=>m.add($)),this.r.forEach($=>$.keys.forEach(S=>m.add(S))),[...m.values()]}B(){const m=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>m.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>m.add($)),this.q.getAllOverrideIdentifiers().forEach($=>m.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(S=>m.add(S))),[...m.values()]}D(m){const $=new Set;return this.j.getKeysForOverrideIdentifier(m).forEach(S=>$.add(S)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(S=>$.add(S)),this.q.getKeysForOverrideIdentifier(m).forEach(S=>$.add(S)),this.r.forEach(S=>S.getKeysForOverrideIdentifier(m).forEach(D=>$.add(D))),[...$.values()]}static parse(m,$){const S=this.E(m.defaults,$),D=this.E(m.policy,$),b=this.E(m.application,$),T=this.E(m.user,$),P=this.E(m.workspace,$),p=m.folders.reduce((f,M)=>(f.set(s.URI.revive(M[0]),this.E(M[1],$)),f),new R.$Dc);return new i(S,D,b,T,n.createEmptyModel($),P,p,n.createEmptyModel($),new R.$Dc,$)}static E(m,$){return new n(m.contents,m.keys,m.overrides,void 0,$)}}e.$Qo=i;function r(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const m=new Set,$=new Map;for(const D of g)D.keys.forEach(b=>m.add(b)),D.overrides.forEach(([b,T])=>{const P=(0,R.$Ac)($,b,new Set);T.forEach(p=>P.add(p))});const S=[];return $.forEach((D,b)=>S.push([b,[...D.values()]])),{keys:[...m.values()],overrides:S}}class t{constructor(m,$,S,D,b){this.change=m,this.f=$,this.g=S,this.h=D,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const T of m.keys)this.affectedKeys.add(T);for(const[,T]of m.overrides)for(const P of T)this.affectedKeys.add(P);this.d=this.a;for(const T of this.affectedKeys)this.d+=T+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(m,$){const S=this.a+m,D=this.d.indexOf(S);if(D<0)return!1;const b=D+S.length;if(b>=this.d.length)return!1;const T=this.d.charCodeAt(b);if(T!==this.b&&T!==this.c)return!1;if($){const P=this.previousConfiguration?this.previousConfiguration.getValue(m,$,this.f?.workspace):void 0,p=this.g.getValue(m,$,this.h);return!N.$jo(P,p)}return!0}}e.$So=t;function a(g,m){const{added:$,removed:S,updated:D}=l(m?.rawConfiguration,g?.rawConfiguration),b=[],T=g?.getAllOverrideIdentifiers()||[],P=m?.getAllOverrideIdentifiers()||[];if(m){const p=P.filter(f=>!T.includes(f));for(const f of p)b.push([f,m.getKeysForOverrideIdentifier(f)])}if(g){const p=T.filter(f=>!P.includes(f));for(const f of p)b.push([f,g.getKeysForOverrideIdentifier(f)])}if(m&&g){for(const p of T)if(P.includes(p)){const f=l({contents:g.getOverrideValue(void 0,p)||{},keys:g.getKeysForOverrideIdentifier(p)},{contents:m.getOverrideValue(void 0,p)||{},keys:m.getKeysForOverrideIdentifier(p)});b.push([p,[...f.added,...f.removed,...f.updated]])}}return{added:$,removed:S,updated:D,overrides:b}}function l(g,m){const $=g?m?g.keys.filter(b=>m.keys.indexOf(b)===-1):[...g.keys]:[],S=m?g?m.keys.filter(b=>g.keys.indexOf(b)===-1):[...m.keys]:[],D=[];if(g&&m){for(const b of m.keys)if(g.keys.indexOf(b)!==-1){const T=(0,I.$ij)(m.contents,b),P=(0,I.$ij)(g.contents,b);N.$jo(T,P)||D.push(b)}}return{added:$,removed:S,updated:D}}}),define(Ie[110],Pe([1,0,14,3]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.RemoteAuthorityResolverErrorCode=e.$Tl=e.$Sl=e.RemoteConnectionType=e.$Rl=void 0,e.$Vl=s,e.$Rl=(0,y.$Gi)("remoteAuthorityResolverService");var k;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class O{constructor(E){this.id=E,this.type=k.Managed}toString(){return`Managed(${this.id})`}}e.$Sl=O;class R{constructor(E,u){this.host=E,this.port=u,this.type=k.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Tl=R;var N;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(N||(e.RemoteAuthorityResolverErrorCode=N={}));class v extends w.$eb{static isNotAvailable(E){return E instanceof v&&E._code===N.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof v&&E._code===N.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof v&&E._code===N.NoResolverFound}static isInvalidAuthority(E){return E instanceof v&&E._code===N.InvalidAuthority}static isHandled(E){return E instanceof v&&E.isHandled}constructor(E,u=N.Unknown,C){super(E),this._message=E,this._code=u,this._detail=C,this.isHandled=u===N.NotAvailable&&C===!0,Object.setPrototypeOf(this,v.prototype)}}e.$Ul=v;function s(I){const E=I.indexOf("+");return E===-1?I:I.substring(0,E)}}),define(Ie[63],Pe([1,0,16]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=y,e.$jn=k,e.$kn=O,e.$ln=R;function y(v){return v.scheme===w.Schemas.vscodeRemote?v.authority:void 0}function k(v){if(!v)return;const s=v.indexOf("+");return s<0?v:v.substr(0,s)}function O(v){const{host:s,port:I}=N(v);if(typeof I>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:I}}function R(v,s){let{host:I,port:E}=N(v);return typeof E>"u"&&(E=s),{host:I,port:E}}function N(v){const s=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const I=v.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=v.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:v,port:void 0}}}),define(Ie[19],Pe([1,0,13,3,63]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$un=e.$tn=e.$sn=e.TargetPlatform=e.ExtensionType=e.$rn=e.$pn=e.$on=e.$nn=e.$mn=void 0,e.$qn=O,e.$vn=E,e.$wn=u,e.$xn=C,e.$yn=d,e.$zn=n,e.$An=o,w=Ve(w),e.$mn="extensions.user.cache",e.$nn="extensions.builtin.cache",e.$on="undefined_publisher",e.$pn=["ui","workspace","web"];function O(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$rn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(R||(e.ExtensionType=R={}));var N;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(N||(e.TargetPlatform=N={}));class v{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,i){if(typeof h>"u"||h===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof h=="string"||typeof i=="string"){const r=typeof h=="string"?h:h.value,t=typeof i=="string"?i:i.value;return w.$Hf(r,t)}return h._lower===i._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$sn=v;class s{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const i of h)this.add(i)}add(h){this.c.add(v.toKey(h))}delete(h){return this.c.delete(v.toKey(h))}has(h){return this.c.has(v.toKey(h))}}e.$tn=s;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(v.toKey(h))}get(h){return this.c.get(v.toKey(h))}has(h){return this.c.has(v.toKey(h))}set(h,i){this.c.set(v.toKey(h),i)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$un=I;function E(c){return u(c)}function u(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function C(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function d(c,h){if(h){const i=`onResolveRemoteAuthority:${(0,k.$jn)(h)}`;return!!c.activationEvents?.includes(i)}return!1}function n(c){return c.map(h=>{const[i,r]=h.split("@");return{proposalName:i,version:r?parseInt(r):void 0}})}function o(c){return c.map(h=>h.split("@")[0])}e.$Bn=(0,y.$Gi)("IBuiltinExtensionsScannerService")}),define(Ie[111],Pe([1,0,21,172,19,3]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.ExtensionManagementErrorCode=e.$lp=e.ExtensionGalleryErrorCode=e.$kp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0,e.$ep=N,e.$fp=v,e.$gp=s,e.$hp=I,e.$ip=E,e.$jp=u,e.$0o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$o=new RegExp(e.$0o),e.$_o="__web_extension",e.$ap="skipWalkthrough",e.$bp="extensionInstallSource",e.$cp="dependecyOrPackExtensionInstall",e.$dp="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function N(t){switch(t){case k.TargetPlatform.WIN32_X64:return"Windows 64 bit";case k.TargetPlatform.WIN32_ARM64:return"Windows ARM";case k.TargetPlatform.LINUX_X64:return"Linux 64 bit";case k.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case k.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case k.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case k.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case k.TargetPlatform.DARWIN_X64:return"Mac";case k.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case k.TargetPlatform.WEB:return"Web";case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;case k.TargetPlatform.UNKNOWN:return k.TargetPlatform.UNKNOWN;case k.TargetPlatform.UNDEFINED:return k.TargetPlatform.UNDEFINED}}function v(t){switch(t){case k.TargetPlatform.WIN32_X64:return k.TargetPlatform.WIN32_X64;case k.TargetPlatform.WIN32_ARM64:return k.TargetPlatform.WIN32_ARM64;case k.TargetPlatform.LINUX_X64:return k.TargetPlatform.LINUX_X64;case k.TargetPlatform.LINUX_ARM64:return k.TargetPlatform.LINUX_ARM64;case k.TargetPlatform.LINUX_ARMHF:return k.TargetPlatform.LINUX_ARMHF;case k.TargetPlatform.ALPINE_X64:return k.TargetPlatform.ALPINE_X64;case k.TargetPlatform.ALPINE_ARM64:return k.TargetPlatform.ALPINE_ARM64;case k.TargetPlatform.DARWIN_X64:return k.TargetPlatform.DARWIN_X64;case k.TargetPlatform.DARWIN_ARM64:return k.TargetPlatform.DARWIN_ARM64;case k.TargetPlatform.WEB:return k.TargetPlatform.WEB;case k.TargetPlatform.UNIVERSAL:return k.TargetPlatform.UNIVERSAL;default:return k.TargetPlatform.UNKNOWN}}function s(t,a){switch(t){case w.Platform.Windows:return a==="x64"?k.TargetPlatform.WIN32_X64:a==="arm64"?k.TargetPlatform.WIN32_ARM64:k.TargetPlatform.UNKNOWN;case w.Platform.Linux:return a==="x64"?k.TargetPlatform.LINUX_X64:a==="arm64"?k.TargetPlatform.LINUX_ARM64:a==="arm"?k.TargetPlatform.LINUX_ARMHF:k.TargetPlatform.UNKNOWN;case"alpine":return a==="x64"?k.TargetPlatform.ALPINE_X64:a==="arm64"?k.TargetPlatform.ALPINE_ARM64:k.TargetPlatform.UNKNOWN;case w.Platform.Mac:return a==="x64"?k.TargetPlatform.DARWIN_X64:a==="arm64"?k.TargetPlatform.DARWIN_ARM64:k.TargetPlatform.UNKNOWN;case w.Platform.Web:return k.TargetPlatform.WEB}}function I(t,a){return a===k.TargetPlatform.WEB&&!t.includes(k.TargetPlatform.WEB)}function E(t,a,l){return I(a,l)?!1:t===k.TargetPlatform.UNDEFINED||t===k.TargetPlatform.UNIVERSAL?!0:t===k.TargetPlatform.UNKNOWN?!1:t===l}function u(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var C;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var n;(function(t){t.Install="install",t.Uninstall="uninstall"})(n||(e.StatisticType=n={}));var o;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$kp=(0,O.$Gi)("extensionGalleryService");var c;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(c||(e.ExtensionGalleryErrorCode=c={}));class h extends Error{constructor(a,l){super(a),this.code=l,this.name=l}}e.$lp=h;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class r extends Error{constructor(a,l){super(a),this.code=l,this.name=l}}e.$mp=r,e.$np=(0,O.$Gi)("extensionManagementService"),e.$op="extensionsIdentifiers/disabled",e.$pp="extensionsIdentifiers/enabled",e.$qp=(0,O.$Gi)("IGlobalExtensionEnablementService"),e.$rp=(0,O.$Gi)("IExtensionTipsService"),e.$sp=(0,y.localize2)(0,"Extensions"),e.$tp=(0,y.localize2)(1,"Preferences")}),define(Ie[112],Pe([1,0,14,19]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NG=e.$MG=void 0;class k{constructor(){this.a=new Map,this.b=new WeakMap}register(R,N){this.a.set(R,N)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const N=Object.create(null);for(const v of R){const s=this.readActivationEvents(v);s.length>0&&(N[y.$sn.toKey(v.identifier)]=s)}return N}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const N=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let v=0;v<N.length;v++)N[v]==="onUri"&&(N[v]=`onUri:${y.$sn.toKey(R.identifier)}`);if(!R.contributes)return N;for(const v in R.contributes){const s=this.a.get(v);if(!s)continue;const I=R.contributes[v],E=Array.isArray(I)?I:[I];try{s(E,N)}catch(u){(0,w.$3)(u)}}return N}}e.$MG=k,e.$NG=new k});var ni=this&&this.__importDefault||function(_){return _&&_.__esModule?_:{default:_}};define(Ie[216],Pe([1,0,24,36,173,323,19,105]),function(_,e,w,y,k,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=I,e.$Zp=E,e.$1p=u,e.$2p=C,e.$3p=d,e.$4p=n,e.$5p=o,e.$6p=c,y=ni(y),k=Ve(k),O=Ve(O);const v=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,s=/^-(\d{4})(\d{2})(\d{2})$/;function I(r){return r=r.trim(),r==="*"||v.test(r)}function E(r){if(!I(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match(v);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function u(r){if(!r)return null;const t=r.majorBase,a=r.majorMustEqual,l=r.minorBase;let g=r.minorMustEqual;const m=r.patchBase;let $=r.patchMustEqual;r.hasCaret&&(t===0||(g=!1),$=!1);let S=0;if(r.preRelease){const D=s.exec(r.preRelease);if(D){const[,b,T,P]=D;S=Date.UTC(Number(b),Number(T)-1,Number(P))}}return{majorBase:t,majorMustEqual:a,minorBase:l,minorMustEqual:g,patchBase:m,patchMustEqual:$,isMinimum:r.hasGreaterEquals,notBefore:S}}function C(r,t,a){let l;typeof r=="string"?l=u(E(r)):l=r;let g;t instanceof Date?g=t.getTime():typeof t=="string"&&(g=new Date(t).getTime());let m;if(typeof a=="string"?m=u(E(a)):m=a,!l||!m)return!1;const $=l.majorBase,S=l.minorBase,D=l.patchBase;let b=m.majorBase,T=m.minorBase,P=m.patchBase;const p=m.notBefore;let f=m.majorMustEqual,M=m.minorMustEqual,L=m.patchMustEqual;return m.isMinimum?$>b?!0:$<b?!1:S>T?!0:S<T||g&&g<p?!1:D>=P:($===1&&b===0&&(!f||!M||!L)&&(b=1,T=0,P=0,f=!0,M=!1,L=!1),$<b?!1:$>b?!f:S<T?!1:S>T?!M:D<P?!1:D>P?!L:!(g&&g<p))}function d(r,t,a,l,g,m){const $=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return $.push([y.default.Error,k.localize(0,null)]),$;if(typeof l.name!="string")return $.push([y.default.Error,k.localize(1,null,"name")]),$;if(typeof l.version!="string")return $.push([y.default.Error,k.localize(2,null,"version")]),$;if(!l.engines)return $.push([y.default.Error,k.localize(3,null,"engines")]),$;if(typeof l.engines.vscode!="string")return $.push([y.default.Error,k.localize(4,null,"engines.vscode")]),$;if(typeof l.extensionDependencies<"u"&&!i(l.extensionDependencies))return $.push([y.default.Error,k.localize(5,null,"extensionDependencies")]),$;if(typeof l.activationEvents<"u"){if(!i(l.activationEvents))return $.push([y.default.Error,k.localize(6,null,"activationEvents")]),$;if(typeof l.main>"u"&&typeof l.browser>"u")return $.push([y.default.Error,k.localize(7,null,"activationEvents","main","browser")]),$}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&$.push([y.default.Warning,k.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return $.push([y.default.Error,k.localize(9,null,"main")]),$;{const b=(0,w.$hh)(a,l.main);(0,w.$bh)(b,a)||$.push([y.default.Warning,k.localize(10,null,b.path,a.path)])}}if(typeof l.browser<"u"){if(typeof l.browser!="string")return $.push([y.default.Error,k.localize(11,null,"browser")]),$;{const b=(0,w.$hh)(a,l.browser);(0,w.$bh)(b,a)||$.push([y.default.Warning,k.localize(12,null,b.path,a.path)])}}if(!O.valid(l.version))return $.push([y.default.Error,k.localize(13,null)]),$;const S=[];if(!n(r,t,l,g,S))for(const b of S)$.push([y.default.Error,b]);if(m&&l.enabledApiProposals?.length){const b=[];if(!c([...l.enabledApiProposals],b))for(const T of b)$.push([y.default.Error,T])}return $}function n(r,t,a,l,g){return l||typeof a.main>"u"&&typeof a.browser>"u"?!0:h(r,t,a.engines.vscode,g)}function o(r,t,a){return r==="*"||h(t,a,r)}function c(r,t){if(r.length===0)return!0;const a=Array.isArray(t)?t:void 0,l=(a?void 0:t)??N.allApiProposals,g=[],m=(0,R.$zn)(r);for(const{proposalName:$,version:S}of m){const D=l[$];D&&S&&D.version!==S&&g.push(k.localize(14,null,$))}return a?.push(...g),g.length===0}function h(r,t,a,l=[]){const g=u(E(a));if(!g)return l.push(k.localize(15,null,a)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return l.push(k.localize(16,null,a)),!1}else if(!g.majorMustEqual)return l.push(k.localize(17,null,a)),!1;return C(r,t,g)?!0:(l.push(k.localize(18,null,r,a)),!1)}function i(r){if(!Array.isArray(r))return!1;for(let t=0,a=r.length;t<a;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Ie[217],Pe([1,0,23,14,4,177,54,3,12,31]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$9p=u,e.$0p=C,e.$$p=d,e.$_p=n,e.$aq=o,e.$bq=c,e.$7p=(0,N.$Gi)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const a in this.b)a.toLowerCase()==="authorization"||a.toLowerCase()==="proxy-authorization"?t[a]="*****":t[a]=this.b[a];this.a=t}return this.a}}class E extends k.$Xc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(0,null),when:v.$sk.isEqualTo((0,v.$pk)(v.LogLevel.Trace)).serialize()})}async c(t,a,l){const g=`${t} #${++this.b}: ${a.url}`;this.a.trace(`${g} - begin`,a.type,new I(a.headers??{}));try{const m=await l();return this.a.trace(`${g} - end`,a.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.a.error(`${g} - error`,a.type,(0,y.$ab)(m)),m}}}e.$8p=E;function u(r){return r.res.statusCode&&r.res.statusCode>=200&&r.res.statusCode<300||r.res.statusCode===1223}function C(r){return r.res.statusCode===204}async function d(r){return C(r)?null:(await(0,w.$2e)(r.stream)).toString()}async function n(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);return d(r)}async function o(r){if(!u(r))throw new Error("Server returned "+r.res.statusCode);if(C(r))return null;const a=(await(0,w.$2e)(r.stream)).toString();try{return JSON.parse(a)}catch(l){throw l.message+=`:
`+a,l}}function c(r){i(r)}let h;function i(r){const t=s.$so.as(R.$xo.Configuration),a=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:r,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(6,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null),(0,O.localize)(10,null)],default:"override",description:(0,O.localize)(11,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(12,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(13,null),restricted:!0}}},t.updateConfigurations({add:[h],remove:a?[a]:[]})}i(R.ConfigurationScope.APPLICATION)}),define(Ie[218],Pe([1,0,21,79,38]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=R,e.$vp=N;function O(v){if(w.$o===w.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function R(v,s,I,E,u,C,d,n,o,c){const h=Object.create(null);h["common.machineId"]=C,h["common.sqmId"]=d,h["common.devDeviceId"]=n,h.sessionID=(0,k.$3g)()+Date.now(),h.commitHash=E,h.version=u,h["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,w.$b)(w.$o),h["common.nodePlatform"]=y.$gc,h["common.nodeArch"]=I,h["common.product"]=c||"desktop",o&&(h["common.msftInternal"]=o);let i=0;const r=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.$f&&(h["common.snap"]="true");const t=O(s);return t&&(h["common.platformDetail"]=t),h}function N(v){const s=y.env.USERDNSDOMAIN;if(!s)return!1;const I=s.toLowerCase();return v.some(E=>I===E)}}),define(Ie[113],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=void 0,e.$_l=(0,w.$Gi)("telemetryService"),e.$am=(0,w.$Gi)("customEndpointTelemetryService"),e.$bm="telemetry.currentSessionDate",e.$cm="telemetry.firstSessionDate",e.$dm="telemetry.lastSessionDate",e.$em="telemetry.machineId",e.$fm="telemetry.sqmId",e.$gm="telemetry.devDeviceId",e.$hm="telemetry",e.$im="telemetry.telemetryLevel",e.$jm="telemetry.enableCrashReporter",e.$km="telemetry.enableTelemetry";var y;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(y||(e.TelemetryLevel=y={}));var k;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(Ie[64],Pe([1,0,26,15,63,218,113]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$Dp=I,e.$Ep=E,e.$Fp=u,e.$Gp=C,e.$Hp=n,e.$Ip=c,e.$Jp=h,e.$Kp=t;class N{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$wp=N;class v{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xp=v,e.$yp=new v;class s{async publicLog(l,g,m){}async publicLogError(l,g,m){}}e.$zp=s,e.$Ap="telemetry",e.$Bp="extensionTelemetryLog",e.$Cp={log:()=>null,flush:()=>Promise.resolve(null)};function I(a,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!a.enableTelemetry)}function E(a,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}function u(a){const l=a.getValue(R.$im),g=a.getValue(R.$jm);if(a.getValue(R.$km)===!1||g===!1)return R.TelemetryLevel.NONE;switch(l??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function C(a){const l={},g={},m={};o(a,m);for(let $ in m){$=$.length>150?$.substr($.length-149):$;const S=m[$];typeof S=="number"?g[$]=S:typeof S=="boolean"?g[$]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${S.length}`),l[$]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(l[$]=S)}return{properties:l,measurements:g}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(a){if(!a)return"none";const l=(0,k.$jn)(a);return d.has(l)?l:"other"}function o(a,l,g=0,m){if(a)for(const $ of Object.getOwnPropertyNames(a)){const S=a[$],D=m?m+$:$;Array.isArray(S)?l[D]=(0,w.$ko)(S):S instanceof Date?l[D]=S.toISOString():(0,y.$ig)(S)?g<2?o(S,l,g+1,D+"."):l[D]=(0,w.$ko)(S):l[D]=S}}function c(a,l){const g=a.msftInternalDomains||[],m=l.getValue("telemetry.internalTesting");return(0,O.$vp)(g)||m}function h(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}function i(a,l){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let g=a;const m=[];for(const b of l)for(;;){const T=b.exec(a);if(!T)break;m.push([T.index,b.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(g="";;){const b=S.exec(a);if(!b)break;const T=m.some(([P,p])=>b.index<p&&P<S.lastIndex);!$.test(b[0])&&!T&&(g+=a.substring(D,b.index)+"<REDACTED: user-file-path>",D=S.lastIndex)}return D<a.length&&(g+=a.substr(D)),g}function r(a){if(!a)return a;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of l)if(g.regex.test(a))return`<REDACTED: ${g.label}>`;return a}function t(a,l){return(0,w.$ho)(a,g=>{if(g instanceof N||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let m=g.replaceAll("%20"," ");m=i(m,l);for(const $ of l)m=m.replace($,"");return m=r(m),m}})}}),define(Ie[219],Pe([1,0,13,111,19,21,2,14,79,64]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Mp=void 0,e.$Lp=I,e.$Np=d,e.$Op=n,e.$Pp=o,e.$Qp=c,e.$Rp=h,e.$Sp=i,e.$Tp=r,e.$Vp=t,e.$Wp=l;function I(g,m){return g.uuid&&m.uuid?g.uuid===m.uuid:g.id===m.id?!0:(0,w.$Cf)(g.id,m.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(m){const $=m.manifest?m.manifest.version:m.version,S=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new u(m.identifier,$,S)}static parse(m){const $=E.exec(m);return $&&$[1]&&$[2]?new u({id:$[1]},$[2],$[4]||void 0):null}constructor(m,$,S=k.TargetPlatform.UNDEFINED){this.identifier=m,this.version=$,this.targetPlatform=S,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==k.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof u?I(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$Mp=u;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(g){const m=C.exec(g);return m&&m[1]?[o(m[1]),m[2]]:[o(g),void 0]}function n(g,m){return`${g}.${m}`}function o(g){return g.toLowerCase()}function c(g,m){return o(n(g??k.$on,m))}function h(g,m){const $=[],S=D=>{for(const b of $)if(b.some(T=>I(m(T),m(D))))return b;return null};for(const D of g){const b=S(D);b?b.push(D):$.push([D])}return $}function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}function r(g){return{id:new s.$wp(g.identifier.id),name:new s.$wp(g.name),version:g.version,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),isSigned:g.isSigned,...g.telemetryData}}e.$Up=new k.$sn("pprice.better-merge");function t(g,m){const $=[],S=m.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const D=S.shift();if(D&&$.every(b=>!I(b.identifier,{id:D}))){const b=g.filter(T=>I(T.identifier,{id:D}));b.length===1&&($.push(b[0]),S.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function a(g,m){if(!O.$e)return!1;let $;try{$=(await g.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await g.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){m.debug("Error while getting the os-release file.",(0,N.$ab)(D))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(g,m){const $=await a(g,m),S=(0,y.$gp)($?"alpine":O.$o,v.$hc);return m.debug("ComputeTargetPlatform:",S),S}}),define(Ie[220],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=w,e.$Fs=y,e.$Gs=k,e.$Hs=O,e.$Is=R,e.$Js=N;function w(v){return[...v.entries()]}function y(v){return v?[...v.entries()]:[]}function k(v){return new Map(v)}function O(v){return new Map(v??[])}function R(v){return Array.from(v.entries()).map(s=>[s[0],w(s[1].map),y(s[1].descriptionMap)])}function N(v){return new Map(v.map(s=>[s[0],{map:k(s[1]),descriptionMap:O(s[2])}]))}}),define(Ie[221],Pe([1,0,3,32,31]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$os=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ns=void 0,e.$ns=new y.$Xj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var R;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var N;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(N||(e.PosixShellType=N={}));var v;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(v||(e.WindowsShellType=v={}));var s;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(s||(e.TitleEventSource=s={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var E;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$os=(0,w.$Gi)("ptyService");var u;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var C;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(C||(e.TerminalLocation=C={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var n;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(n||(e.LocalReconnectConstants=n={}));var o;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var c;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var h;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ps={Backend:"workbench.contributions.terminal.processBackend"};class r{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(a){const l=this.b(a.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,a)}getTerminalBackend(a){return this.a.get(this.b(a))}b(a){return a?.toLowerCase()??""}}k.$so.add(e.$ps.Backend,new r),e.$qs=(0,w.$Gi)("localPtyService"),e.$rs=(0,w.$Gi)("terminalLogService")}),define(Ie[222],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jxb=void 0;class w{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,O,R=5){const N=O(v=>{const s=typeof v=="string"?v:v.data;let I=this.a.get(k);if(I){I.data.push(s);return}const E=setTimeout(()=>this.flushBuffer(k),R);I={data:[s],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(k),N.dispose()}},this.a.set(k,I)});return N}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const O=this.a.get(k);O&&(this.a.delete(k),this.b(k,O.data.join("")))}}e.$Jxb=w}),define(Ie[223],Pe([1,0,11,98,324,35,6,15,2,178,78,31]),function(_,e,w,y,k,O,R,N,v,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gx=e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.$Bx=e.IconFontDefinition=e.IconContribution=e.$yx=void 0,e.$zx=o,e.$Ax=c,E=Ve(E),e.$yx={IconContribution:"base.contributions.icons"};var u;(function(t){function a(l,g){let m=l.defaults;for(;O.ThemeIcon.isThemeIcon(m);){const $=n.getIcon(m.id);if(!$)return;m=$.defaults}return m}t.getDefinition=a})(u||(e.IconContribution=u={}));var C;(function(t){function a(g){return{weight:g.weight,style:g.style,src:g.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=a;function l(g){const m=$=>(0,N.$gg)($)?$:void 0;if(g&&Array.isArray(g.src)&&g.src.every($=>(0,N.$gg)($.format)&&(0,N.$gg)($.location)))return{weight:m(g.weight),style:m(g.style),src:g.src.map($=>({format:$.format,location:v.URI.parse($.location)}))}}t.fromJSONObject=l})(C||(e.IconFontDefinition=C={}));class d{constructor(){this.a=new R.$ne,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,s.localize)(0,null)},fontCharacter:{type:"string",description:(0,s.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,l,g,m){const $=this.b[a];if($){if(g&&!$.description){$.description=g,this.d.properties[a].markdownDescription=`${g} $(${a})`;const b=this.e.enum.indexOf(a);b!==-1&&(this.e.enumDescriptions[b]=g),this.a.fire()}return $}const S={id:a,description:g,defaults:l,deprecationMessage:m};this.b[a]=S;const D={$ref:"#/definitions/icons"};return m&&(D.deprecationMessage=m),g&&(D.markdownDescription=`${g}: $(${a})`),this.d.properties[a]=D,this.e.enum.push(a),this.e.enumDescriptions.push(g||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const l=this.e.enum.indexOf(a);l!==-1&&(this.e.enum.splice(l,1),this.e.enumDescriptions.splice(l,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,l){const g=this.f[a];return g||(this.f[a]=l,this.a.fire(),l)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=($,S)=>$.id.localeCompare(S.id),l=$=>{for(;O.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},g=[];g.push("| preview     | identifier                        | default codicon ID                | description"),g.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map($=>this.b[$]);for(const $ of m.filter(S=>!!S.description).sort(a))g.push(`|<i class="${l($)}"></i>|${$.id}|${O.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);g.push("| preview     | identifier                        "),g.push("| ----------- | --------------------------------- |");for(const $ of m.filter(S=>!O.ThemeIcon.isThemeIcon(S.defaults)).sort(a))g.push(`|<i class="${l($)}"></i>|${$.id}|`);return g.join(`
`)}}const n=new d;E.$so.add(e.$yx.IconContribution,n);function o(t,a,l,g){return n.registerIcon(t,a,l,g)}function c(){return n}function h(){const t=(0,k.$2j)();for(const a in t){const l="\\"+t[a].toString(16);n.registerIcon(a,{fontCharacter:l})}}h(),e.$Bx="vscode://schemas/icons";const i=E.$so.as(I.$to.JSONContribution);i.registerSchema(e.$Bx,n.getIconSchema());const r=new w.$Sh(()=>i.notifySchemaChanged(e.$Bx),200);n.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Cx=o("widget-close",y.$6j.close,(0,s.localize)(2,null)),e.$Dx=o("goto-previous-location",y.$6j.arrowUp,(0,s.localize)(3,null)),e.$Ex=o("goto-next-location",y.$6j.arrowDown,(0,s.localize)(4,null)),e.$Fx=O.ThemeIcon.modify(y.$6j.sync,"spin"),e.$Gx=O.ThemeIcon.modify(y.$6j.loading,"spin")}),define(Ie[224],Pe([1,0,6,4,21,2,43,3,12]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Mw=e.$Jw=e.$Hw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dw=e.$Cw=void 0,e.$Ew=E,e.$Fw=C,e.$Gw=d,e.$Iw=n,e.$Kw=o,e.$Lw=c,e.$Cw=(0,N.$Gi)("tunnelService"),e.$Dw=(0,N.$Gi)("sharedTunnelsService");var s;(function(r){r.Http="http",r.Https="https"})(s||(e.TunnelProtocol=s={}));var I;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(I||(e.TunnelPrivacyId=I={}));function E(r){return!!r.forwardPort}var u;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function C(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(t)return{address:t[1],port:+t[2]}}function d(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const t=r.query.split("&");for(const a of t){const l=a.split("=")[1];if(/^https?:/.exec(l)){const g=C(O.URI.parse(l));if(g)return g}}}e.$Hw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(r){return e.$Hw.indexOf(r)>=0}e.$Jw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(r){return e.$Jw.indexOf(r)>=0}function c(r,t,a,l){if(a===k.OperatingSystem.Windows)return!1;if(a===k.OperatingSystem.Macintosh&&o(t)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(g?.length===4&&parseInt(g[1])>=18)return!1}return r<1024}class h{constructor(t,a,l){this.remoteAddress=t,this.localAddress=a,this.b=l,this.a=new w.$ne,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mw=h;let i=class extends y.$Xc{constructor(t,a){super(),this.r=t,this.s=a,this.a=new w.$ne,this.onTunnelOpened=this.a.event,this.b=new w.$ne,this.onTunnelClosed=this.b.event,this.c=new w.$ne,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],a=Array.from(this.f.values());for(const l of a){const g=Array.from(l.values());for(const m of g){const $=await m.value;$&&typeof $!="string"&&t.push($)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:a}of t.values())await a.then(l=>typeof l!="string"?l?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,a,l,g,m){this.z(t,a,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:a,localAddress:l,privacy:g,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,a){(o(t)||n(t))&&(t=e.$Hw[0]);const l=this.D(t,a);if(l)return++l.refcount,l.value}openTunnel(t,a,l,g,m,$=!1,S,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${l} on local port ${m}.`);const b=this.g??t;if(!b)return;if(a||(a="localhost"),g||(g=this.t),this.g&&this.n.has(l)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const T=this.F(b,a,l,g,m,$,S,D);return T?T.then(P=>{if(P){if(typeof P=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(a,l),P}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(a,l);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(P);return(P.tunnelRemoteHost!==a||P.tunnelRemotePort!==l)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),S&&P.privacy!==S&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),T)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const a=this.f.get(t.tunnelRemoteHost);if(a){const l=a.get(t.tunnelRemotePort);l&&(l.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,l))}}}}async y(t,a,l){if(l.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${a}.`);const g=l.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(a),g}}async closeTunnel(t,a){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${a} `);const l=this.f.get(t);if(l&&l.has(a)){const g=l.get(a);g.refcount=0,await this.y(t,a,g)}}z(t,a,l){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(a,{refcount:1,value:l})}async C(t,a){const l=this.f.get(t);if(l){const g=l.get(a),m=g?await g.value:void 0;(!m||typeof m=="string")&&l.delete(a),l.size===0&&this.f.delete(t)}}D(t,a){const l=[t];n(t)?(l.push(...e.$Hw),l.push(...e.$Jw)):o(t)&&l.push(...e.$Jw);const g=l.map(m=>this.f.get(m));for(const m of g){const $=m?.get(a);if($)return $}}canTunnel(t){return!!C(t)}G(t,a,l,g,m,$,S){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${l} on local port ${g}.`);const D=l;this.n.add(D);const b=g===void 0?l:g,T={elevationRequired:m?this.isPortPrivileged(b):!1},P={remoteAddress:{host:a,port:l},localAddressPort:g,privacy:$,public:$?$!==I.Private:void 0,protocol:S},p=t.forwardPort(P,T);return p?(this.z(a,l,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),p}};e.$Nw=i,e.$Nw=i=He([Ge(0,v.$ak),Ge(1,R.$aj)],i)}),define(Ie[225],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=void 0,e.$Kl=(0,w.$Gi)("IUriIdentityService")}),define(Ie[226],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Ow=void 0,e.$Ow=(0,w.$Gi)("editSessionIdentityService");var y;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(y||(e.EditSessionIdentityMatch=y={}))}),define(Ie[227],Pe([1,0,16]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5M=y,e.$6M=k,e.$7M=O,e.$8M=R,e.$9M=N;function y(v){return v.scheme!==w.Schemas.file&&v.scheme!==w.Schemas.vscodeRemote}function k(v){if(v.folders.length)return v.folders.every(s=>y(s.uri))?v.folders[0].uri:void 0;if(v.configuration&&y(v.configuration))return v.configuration}function O(v){return k(v)?.scheme}function R(v){return k(v)?.authority}function N(v){return k(v)!==void 0}}),define(Ie[50],Pe([1,0,180,20,59,24,2,3,16]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$6i=e.$5i=e.$4i=e.$3i=e.$1i=e.$Zi=e.WorkbenchState=e.$Ti=e.$Si=e.$Pi=void 0,e.$Qi=s,e.$Ri=I,e.$Ui=E,e.$Vi=u,e.$Wi=C,e.$Xi=n,e.$Yi=o,e.$2i=i,e.$7i=r,e.$8i=t,e.$0i=a,e.$$i=l,e.$_i=g,e.$Pi=(0,N.$Gi)("contextService");function s(m){const $=m;return typeof $?.id=="string"&&R.URI.isUri($.uri)}function I(m){return typeof m?.id=="string"&&!s(m)&&!u(m)}e.$Si={id:"ext-dev"},e.$Ti={id:"empty-window"};function E(m,$){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,y.$qc)(m)}:$?e.$Si:e.$Ti;const S=m;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}function u(m){const $=m;return typeof $?.id=="string"&&R.URI.isUri($.configPath)}function C(m){const $=m;if($?.uri)return{id:$.id,uri:R.URI.revive($.uri)};const S=m;if(S?.configPath)return{id:S.id,configPath:R.URI.revive(S.configPath)};if(m?.id)return{id:m.id}}var d;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function n(m){const $=m;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function o(m){const $=m;return!!($&&typeof $=="object"&&R.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class c{constructor($,S,D,b,T){this.h=$,this.j=D,this.k=b,this.l=T,this.c=k.$Mi.forUris(this.l,()=>!0),this.folders=S}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=k.$Mi.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Zi=c;class h{constructor($,S){this.raw=S,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,O.$hh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$1i=h;function i(m){return new h({uri:m,index:0,name:(0,O.$dh)(m)},{uri:m.toString()})}e.$3i="code-workspace",e.$4i=`.${e.$3i}`,e.$5i=[{name:(0,w.localize)(0,null),extensions:[e.$3i]}],e.$6i="workspace.json";function r(m,$){return O.$$g.isEqualOrParent(m,$.untitledWorkspacesHome)}function t(m){let $;return R.URI.isUri(m)?$=m:$=m.configuration,$?.scheme===v.Schemas.tmp}e.$9i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function a(m){return m.id===e.$9i}function l(m,$){return!r(m,$)&&!t(m)}function g(m){return(typeof m=="string"?(0,y.$rc)(m):(0,O.$fh)(m))===e.$4i}}),define(Ie[114],Pe([1,0,76,6,4,24,2,179,107,30,3,12,50,29,225,11,38,13,15]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ml=e.ProfileResourceType=void 0,e.$Ll=r,e.$Nl=t,e.$Ol=a;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(m){const $=m;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&R.URI.isUri($.location)&&R.URI.isUri($.globalStorageHome)&&R.URI.isUri($.settingsResource)&&R.URI.isUri($.keybindingsResource)&&R.URI.isUri($.tasksResource)&&R.URI.isUri($.snippetsHome)&&R.URI.isUri($.extensionsResource))}e.$Ml=(0,I.$Gi)("IUserDataProfilesService");function t(m,$){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:R.URI.revive(m.location).with({scheme:$}),globalStorageHome:R.URI.revive(m.globalStorageHome).with({scheme:$}),settingsResource:R.URI.revive(m.settingsResource).with({scheme:$}),keybindingsResource:R.URI.revive(m.keybindingsResource).with({scheme:$}),tasksResource:R.URI.revive(m.tasksResource).with({scheme:$}),snippetsHome:R.URI.revive(m.snippetsHome).with({scheme:$}),extensionsResource:R.URI.revive(m.extensionsResource).with({scheme:$}),cacheHome:R.URI.revive(m.cacheHome).with({scheme:$}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function a(m,$,S,D,b,T){return{id:m,name:$,location:S,isDefault:!1,shortName:b?.shortName,icon:b?.icon,globalStorageHome:T&&b?.useDefaultFlags?.globalState?T.globalStorageHome:(0,O.$hh)(S,"globalStorage"),settingsResource:T&&b?.useDefaultFlags?.settings?T.settingsResource:(0,O.$hh)(S,"settings.json"),keybindingsResource:T&&b?.useDefaultFlags?.keybindings?T.keybindingsResource:(0,O.$hh)(S,"keybindings.json"),tasksResource:T&&b?.useDefaultFlags?.tasks?T.tasksResource:(0,O.$hh)(S,"tasks.json"),snippetsHome:T&&b?.useDefaultFlags?.snippets?T.snippetsHome:(0,O.$hh)(S,"snippets"),extensionsResource:T&&b?.useDefaultFlags?.extensions?T.extensionsResource:(0,O.$hh)(S,"extensions.json"),cacheHome:(0,O.$hh)(D,m),useDefaultFlags:b?.useDefaultFlags,isTransient:b?.transient}}let l=class extends k.$Xc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,S,D,b){super(),this.t=$,this.u=S,this.w=D,this.y=b,this.f=!0,this.h=this.B(new y.$ne),this.onDidChangeProfiles=this.h.event,this.j=this.B(new y.$ne),this.onWillCreateProfile=this.j.event,this.m=this.B(new y.$ne),this.onWillRemoveProfile=this.m.event,this.n=this.B(new y.$ne),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new C.$Dc,workspaces:new C.$Dc,emptyWindows:new Map},this.profilesHome=(0,O.$hh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$hh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),S=[$];if(this.f)try{for(const T of this.O()){if(!T.name||!(0,h.$gg)(T.name)||!T.location){this.y.warn("Skipping the invalid stored profile",T.location||T.name);continue}S.push(a((0,O.$eh)(T.location),T.name,T.location,this.g,{shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags},$))}}catch(T){this.y.error(T)}const D=new C.$Dc,b=new Map;if(S.length)try{const T=this.Q();if(T.workspaces)for(const[P,p]of Object.entries(T.workspaces)){const f=R.URI.parse(P),M=S.find(L=>L.id===p);M&&D.set(f,M)}if(T.emptyWindows)for(const[P,p]of Object.entries(T.emptyWindows)){const f=S.find(M=>M.id===p);f&&b.set(P,f)}}catch(T){this.y.error(T)}this.z={profiles:S,workspaces:D,emptyWindows:b}}return this.z}D(){const $=a("__default__profile__",(0,N.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const S="Temp",D=new RegExp(`${(0,c.$jf)(S)}\\s(\\d+)`);let b=0;for(const P of this.profiles){const p=D.exec(P.name),f=p?parseInt(p[1]):0;b=f>b?f:b}const T=`${S} ${b+1}`;return this.createProfile((0,w.$uj)((0,o.$3g)()).toString(16),T,{transient:!0},$)}async createNamedProfile($,S,D){return this.createProfile((0,w.$uj)((0,o.$3g)()).toString(16),$,S,D)}async createProfile($,S,D,b){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const T=await this.F($,S,D);return b&&await this.setProfileForWorkspace(b,T),T}async F($,S,D){if(!(0,h.$gg)(S)||!S)throw new Error("Name of the profile is mandatory and must be of type `string`");let b=this.r.get(S);return b||(b=(async()=>{try{if(this.profiles.find(f=>f.name===S||f.id===$))throw new Error(`Profile with ${S} name already exists`);const P=a($,S,(0,O.$hh)(this.profilesHome,$),this.g,D,this.defaultProfile);await this.u.createFolder(P.location);const p=[];return this.j.fire({profile:P,join(f){p.push(f)}}),await n.Promises.settled(p),this.I([P],[],[]),P}finally{this.r.delete(S)}})(),this.r.set(S,b)),b}async updateProfile($,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(b=>b.id===$.id);if(!D)throw new Error(`Profile '${$.name}' does not exist`);return D=a(D.id,S.name??D.name,D.location,this.g,{shortName:S.shortName??D.shortName,icon:S.icon===null?void 0:S.icon??D.icon,transient:S.transient??D.isTransient,useDefaultFlags:S.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const S=this.profiles.find(b=>b.id===$.id);if(!S)throw new Error(`Profile '${$.name}' does not exist`);const D=[];this.m.fire({profile:S,join(b){D.push(b)}});try{await Promise.allSettled(D)}catch(b){this.y.error(b)}for(const b of[...this.C.emptyWindows.keys()])S.id===this.C.emptyWindows.get(b)?.id&&this.C.emptyWindows.delete(b);for(const b of[...this.C.workspaces.keys()])S.id===this.C.workspaces.get(b)?.id&&this.C.workspaces.delete(b);this.M(),this.I([],[S],[]);try{await this.u.del(S.cacheHome,{recursive:!0})}catch(b){(0,s.$rl)(b)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(b)}}async setProfileForWorkspace($,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(b=>b.id===S.id);if(!D)throw new Error(`Profile '${S.name}' does not exist`);this.L($,D)}unsetWorkspace($,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,S)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(S=>S.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,S.resource))).map(S=>this.u.del(S.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(S=>!this.H(S));await Promise.allSettled($.map(S=>this.removeProfile(S)))}getProfileForWorkspace($){const S=this.G($),D=R.URI.isUri(S)?this.C.workspaces.get(S):this.C.emptyWindows.get(S);return D||((0,u.$Qi)($)?this.s.folders.get($.uri):(0,u.$Vi)($)?this.s.workspaces.get($.configPath):this.s.emptyWindows.get($.id))}G($){return(0,u.$Qi)($)?$.uri:(0,u.$Vi)($)?$.configPath:$.id}H($){return!!([...this.C.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,$.location))||[...this.C.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,$.location))||[...this.s.emptyWindows.values()].some(S=>this.w.extUri.isEqual(S.location,$.location))||[...this.s.workspaces.values()].some(S=>this.w.extUri.isEqual(S.location,$.location))||[...this.s.folders.values()].some(S=>this.w.extUri.isEqual(S.location,$.location)))}I($,S,D){const b=[...this.profiles,...$],T=[],P=this.s.profiles;this.s.profiles=[];for(let p of b){if(p.isDefault||S.some(M=>p.id===M.id))continue;p=D.find(M=>p.id===M.id)??p;const f=P.find(M=>p.id===M.id);if(p.isTransient)this.s.profiles.push(p);else{if(f){for(const[M,L]of this.s.emptyWindows.entries())if(p.id===L.id){this.L({id:M},p);break}for(const[M,L]of this.s.workspaces.entries())if(p.id===L.id){this.L({id:"",configPath:M},p);break}for(const[M,L]of this.s.folders.entries())if(p.id===L.id){this.L({id:"",uri:M},p);break}}T.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(T),this.z=void 0,this.J($,S,D)}J($,S,D){this.h.fire({added:$,removed:S,updated:D,all:this.profiles})}L($,S,D){if(D=S?.isTransient?!0:D,D)(0,u.$Qi)($)?(this.s.folders.delete($.uri),S&&this.s.folders.set($.uri,S)):(0,u.$Vi)($)?(this.s.workspaces.delete($.configPath),S&&this.s.workspaces.set($.configPath,S)):(this.s.emptyWindows.delete($.id),S&&this.s.emptyWindows.set($.id,S));else{this.L($,void 0,!0);const b=this.G($);R.URI.isUri(b)?(this.C.workspaces.delete(b),S&&this.C.workspaces.set(b,S)):(this.C.emptyWindows.delete(b),S&&this.C.emptyWindows.set(b,S)),this.M()}}M(){const $={};for(const[D,b]of this.C.workspaces.entries())$[D.toString()]=b.id;const S={};for(const[D,b]of this.C.emptyWindows.entries())S[D.toString()]=b.id;this.R({workspaces:$,emptyWindows:S}),this.z=void 0}N($){const S={},D=this.D();if($.workspaces)for(const[T,P]of Object.entries($.workspaces)){const p=R.URI.parse(P);S[T]=this.w.extUri.isEqual(p,D.location)?D.id:this.w.extUri.basename(p)}const b={};if($.emptyWindows)for(const[T,P]of Object.entries($.emptyWindows)){const p=R.URI.parse(P);b[T]=this.w.extUri.isEqual(p,D.location)?D.id:this.w.extUri.basename(p)}return{workspaces:S,emptyWindows:b}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Pl=l,l.b="userDataProfiles",l.c="profileAssociations",e.$Pl=l=He([Ge(0,v.$Ni),Ge(1,s.$al),Ge(2,d.$Kl),Ge(3,E.$ak)],l);class g extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Ql=g}),define(Ie[228],Pe([1,0,11,6,4,65,15,151,3,114]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$jq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hq=e.$gq=e.$fq=void 0,e.$iq=C,e.$kq=n,e.$mq=c,e.$fq="__$__isNewStorageMarker",e.$gq="__$__targetStorageMarker",e.$hq=(0,v.$Gi)("storageService");var I;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var E;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function C(h){const i=h.get(e.$gq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends k.$Xc{constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new y.$qe),this.c=this.B(new y.$qe),this.onDidChangeTarget=this.c.event,this.f=this.B(new y.$ne),this.onWillSaveState=this.f.event,this.h=this.B(new w.$Sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Yc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,t){return y.Event.filter(this.b.event,a=>a.scope===i&&(r===void 0||a.key===r),t)}n(){this.j.value=(0,w.$Wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Sc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:t,external:a}=r;if(t===e.$gq){switch(i){case E.APPLICATION:this.H=void 0;break;case E.PROFILE:this.F=void 0;break;case E.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:a})}w(i){this.f.fire({reason:i})}get(i,r,t){return this.P(r)?.get(i,t)}getBoolean(i,r,t){return this.P(r)?.getBoolean(i,t)}getNumber(i,r,t){return this.P(r)?.getNumber(i,t)}getObject(i,r,t){return this.P(r)?.getObject(i,t)}storeAll(i,r){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,r)})}store(i,r,t,a,l=!1){if((0,R.$pg)(r)){this.remove(i,t,l);return}this.y(()=>{this.z(i,t,a),this.P(t)?.set(i,r,l)})}remove(i,r,t=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const t=[],a=this.J(i);for(const l of Object.keys(a))a[l]===r&&t.push(l);return t}z(i,r,t,a=!1){const l=this.J(r);typeof t=="number"?l[i]!==t&&(l[i]=t,this.P(r)?.set(e.$gq,JSON.stringify(l),a)):typeof l[i]=="number"&&(delete l[i],this.P(r)?.set(e.$gq,JSON.stringify(l),a))}get D(){return this.C||(this.C=this.L(E.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(E.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(E.APPLICATION)),this.H}J(i){switch(i){case E.APPLICATION:return this.I;case E.PROFILE:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?C(r):Object.create(null)}isNew(i){return this.getBoolean(e.$fq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const r=this.P(E.APPLICATION),t=this.P(E.PROFILE),a=this.P(E.WORKSPACE);switch(i){case I.NONE:await w.Promises.settled([r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await w.Promises.settled([r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(E.APPLICATION)?.items??new Map,r=this.P(E.PROFILE)?.items??new Map,t=this.P(E.WORKSPACE)?.items??new Map;return c(i,r,t,this.Q(E.APPLICATION)??"",this.Q(E.PROFILE)??"",this.Q(E.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(I.NONE),(0,s.$Ll)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||n(r)&&n(i))}N(i,r,t){this.y(()=>{const a=new Set;for(const[l,g]of i)a.add(l),r.get(l)!==g&&this.u(t,{key:l,external:!0});for(const[l]of r.items)a.has(l)||this.u(t,{key:l,external:!0})})}}e.$jq=d,d.a=60*1e3;function n(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new N.$dq(new N.$eq,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new N.$dq(new N.$eq,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new N.$dq(new N.$eq,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(E.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(E.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(E.APPLICATION,i)))}P(i){switch(i){case E.APPLICATION:return this.U;case E.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$lq=o;async function c(h,i,r,t,a,l){const g=f=>{try{return JSON.parse(f)}catch{return f}},m=new Map,$=new Map;h.forEach((f,M)=>{m.set(M,f),$.set(M,g(f))});const S=new Map,D=new Map;i.forEach((f,M)=>{S.set(M,f),D.set(M,g(f))});const b=new Map,T=new Map;r.forEach((f,M)=>{b.set(M,f),T.set(M,g(f))}),console.group(t!==a?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const P=[];if(m.forEach((f,M)=>{P.push({key:M,value:f})}),console.table(P),console.groupEnd(),console.log($),t!==a){console.group(`Storage: Profile (path: ${a}, profile specific)`);const f=[];S.forEach((M,L)=>{f.push({key:L,value:M})}),console.table(f),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${l})`);const p=[];b.forEach((f,M)=>{p.push({key:M,value:f})}),console.table(p),console.groupEnd(),console.log(T)}}),define(Ie[80],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=void 0;class w{constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const O=this.c++;return this.b.set(O,k),this.e(),O}get(k,O){return this.b.has(k)?this.b.get(k)[O]:void 0}delete(k){this.b.delete(k),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$voc=w,w.a=!1}),define(Ie[51],Pe([1,0,16,24,30,3]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Boc=e.$Aoc=void 0;class R{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new y.$9g(v=>{const s=this.b.get(v.scheme);return!(s===void 0||s&k.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(v,s){s===null?this.b.delete(v.scheme):this.b.set(v.scheme,s)}isFreeScheme(v){return!this.b.has(v)&&!this.a.has(v)}getCapabilities(v){return this.b.get(v)}}e.$Aoc=R,e.$Boc=(0,O.$Gi)("IExtHostFileSystemInfo")}),define(Ie[27],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0,e.$fQ=(0,w.$Gi)("IExtHostInitDataService")}),define(Ie[229],Pe([1,0,185,12,213,27]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=void 0;let R=class extends k.$qR{constructor(v,s,I){const E=I.remote.isRemote?"remoteexthost":v?"workerexthost":"exthost",u=I.remote.isRemote?(0,w.localize)(0,null):v?(0,w.localize)(1,null):(0,w.localize)(2,null);super(s.createLogger(E,{name:u}))}};e.$Jqc=R,e.$Jqc=R=He([Ge(1,y.$bk),Ge(2,O.$fQ)],R)}),define(Ie[230],Pe([1,0,11]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=e.$gpc=void 0;class y{constructor(R,N,v){this.h=new Map,this.a=R,this.b=N,this.c=v,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(s=>(this.f=s,this)),this.g=this.c.onDidChangeStorage(s=>{s.shared===this.b&&s.key===this.a&&(this.f=s.value)}),this.i=new w.$Sh(()=>{const s=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of s.values())I.complete()}catch(I){for(const E of s.values())E.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,N){let v=this.f[R];return typeof v>"u"&&(v=N),v}update(R,N){this.f[R]=N;const v=this.h.get(R);if(v!==void 0)return v.p;const s=new w.$4h;return this.h.set(R,s),this.i.isScheduled()||this.i.schedule(),s.p}dispose(){this.g.dispose()}}e.$gpc=y;class k extends y{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,N){super(R.identifier.value,!0,N),this.j=R}}e.$hpc=k}),define(Ie[231],Pe([1,0,6,2]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=void 0;class k{constructor(R){this.c=R,this.a=new w.$ne,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$ne,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,N,v,s){const E=this.c.getNotebookDocument(y.URI.revive(R)).acceptModelChanged(N.value,v,s);this.b.fire(E)}$acceptDirtyStateChanged(R,N){this.c.getNotebookDocument(y.URI.revive(R)).acceptDirty(N)}$acceptModelSaved(R){const N=this.c.getNotebookDocument(y.URI.revive(R));this.a.fire(N.apiNotebook)}}e.$bqc=k}),define(Ie[17],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.$2P=void 0,e.$2P=(0,w.$Gi)("IExtHostRpcService");class y{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$3P=y});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[232],Pe([1,0,19,6,4]),function(_,e,w,y,k){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=void 0;class R{constructor(v,s){O.set(this,void 0),this.disposables=new k.$Wc,this.a=w.$sn.toKey(v.identifier),rt(this,O,s,"f"),this.onDidChange=y.Event.map(y.Event.filter(ze(this,O,"f").onDidChangePassword,I=>I.extensionId===this.a),I=>({key:I.key}),this.disposables)}dispose(){this.disposables.dispose()}get(v){return ze(this,O,"f").get(this.a,v)}store(v,s){return ze(this,O,"f").store(this.a,v,s)}delete(v){return ze(this,O,"f").delete(this.a,v)}}e.$qpc=R,O=new WeakMap}),define(Ie[66],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=e.$Qoc=void 0,e.$Qoc=(0,w.$Gi)("IURITransformerService");class y{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Roc=y});var ni=this&&this.__importDefault||function(_){return _&&_.__esModule?_:{default:_}};define(Ie[115],Pe([1,0,194,15,2,4,3,31,30,16,42,164,36]),function(_,e,w,y,k,O,R,N,v,s,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$fG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$8F=e.EditorInputCapabilities=e.$7F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0,e.$XF=n,e.$YF=o,e.$ZF=c,e.$1F=h,e.$2F=i,e.$3F=r,e.$4F=t,e.$5F=a,e.$6F=l,e.$9F=b,e.$0F=P,e.$$F=p,e.$_F=f,e.$aG=M,e.$bG=L,e.$cG=K,e.$dG=J,e.$eG=ve,e.$gG=$e,e.$hG=Y,e.$iG=we,e.$jG=Te,u=ni(u),e.$SF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$TF={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$UF="workbench.editor.sidebysideEditor",e.$VF="workbench.editors.textDiffEditor",e.$WF="workbench.editors.binaryResourceDiffEditor";var C;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(C||(e.EditorPaneSelectionChangeReason=C={}));var d;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function n(re){const q=re;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}function o(re){const q=re;return!!q&&typeof q.getScrollPosition=="function"&&typeof q.setScrollPosition=="function"&&!!q.onDidChangeScroll}function c(re,q,ae){for(const le of ae.visibleEditorPanes)if(le.group.id===q&&re.matches(le.input))return le.getViewState()}function h(re){if(b(re))return!1;const q=re;return k.URI.isUri(q?.resource)}function i(re){if(b(re))return!1;const q=re;return q?.original!==void 0&&q.modified!==void 0}function r(re){if(b(re))return!1;const q=re;return!q||q.resources&&!Array.isArray(q.resources)?!1:!!q.resources||!!q.multiDiffSource}function t(re){if(b(re)||i(re))return!1;const q=re;return q?.primary!==void 0&&q.secondary!==void 0}function a(re){if(b(re))return!1;const q=re;return q?q.resource===void 0||q.resource.scheme===s.Schemas.untitled||q.forceUntitled===!0:!1}function l(re){if(b(re))return!1;const q=re;return k.URI.isUri(q?.base?.resource)&&k.URI.isUri(q?.input1?.resource)&&k.URI.isUri(q?.input2?.resource)&&k.URI.isUri(q?.result?.resource)}var g;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(g||(e.Verbosity=g={}));var m;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class ${constructor(){this.a=new Map}registerSource(q,ae){let le=this.a.get(q);return le||(le={source:q,label:ae},this.a.set(q,le)),le.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$7F=new $;var S;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad"})(S||(e.EditorInputCapabilities=S={}));class D extends O.$Xc{}e.$8F=D;function b(re){return re instanceof D}function T(re){const q=re;return k.URI.isUri(q?.preferredResource)}function P(re){const q=re;return b(q?.primary)&&b(q?.secondary)}function p(re){const q=re;return b(q?.modified)&&b(q?.original)}function f(re,q,ae,le,ne){return Te(le,[(0,E.$qj)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ce={...ae,limits:{size:Number.MAX_VALUE}};re.openEditor(q,ce)}}),(0,E.$qj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>ne.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function M(re){return b(re?.editor)}function L(re){const q=re;return M(re)&&q?.group!==void 0}function K(re){const q=re;return typeof q?.groupId=="number"&&b(q.editor)}function J(re){return typeof re?.groupId=="number"}var z;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var A;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITORS_SELECTION=4]="EDITORS_SELECTION",re[re.EDITOR_OPEN=5]="EDITOR_OPEN",re[re.EDITOR_CLOSE=6]="EDITOR_CLOSE",re[re.EDITOR_MOVE=7]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=9]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=11]="EDITOR_PIN",re[re.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",re[re.EDITOR_STICKY=13]="EDITOR_STICKY",re[re.EDITOR_DIRTY=14]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var W;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(W||(e.SideBySideEditor=W={}));class Z{getOriginalUri(q,ae){if(!q)return;if(l(q))return e.$fG.getOriginalUri(q.result,ae);if(ae?.supportSideBySide){const{primary:ne,secondary:ce}=this.a(q);if(ne&&ce){if(ae?.supportSideBySide===W.BOTH)return{primary:this.getOriginalUri(ne,{filterByScheme:ae.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:ae.filterByScheme})};if(ae?.supportSideBySide===W.ANY)return this.getOriginalUri(ne,{filterByScheme:ae.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:ae.filterByScheme});q=ae.supportSideBySide===W.PRIMARY?ne:ce}}if(i(q)||r(q)||t(q)||l(q))return;const le=T(q)?q.preferredResource:q.resource;return!le||!ae||!ae.filterByScheme?le:this.b(le,ae.filterByScheme)}a(q){return P(q)||t(q)?{primary:q.primary,secondary:q.secondary}:p(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,ae){if(!q)return;if(l(q))return e.$fG.getCanonicalUri(q.result,ae);if(ae?.supportSideBySide){const{primary:ne,secondary:ce}=this.a(q);if(ne&&ce){if(ae?.supportSideBySide===W.BOTH)return{primary:this.getCanonicalUri(ne,{filterByScheme:ae.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:ae.filterByScheme})};if(ae?.supportSideBySide===W.ANY)return this.getCanonicalUri(ne,{filterByScheme:ae.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:ae.filterByScheme});q=ae.supportSideBySide===W.PRIMARY?ne:ce}}if(i(q)||r(q)||t(q)||l(q))return;const le=q.resource;return!le||!ae||!ae.filterByScheme?le:this.b(le,ae.filterByScheme)}b(q,ae){if(Array.isArray(ae)){if(ae.some(le=>q.scheme===le))return q}else if(ae===q.scheme)return q}}var he;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(he||(e.EditorCloseMethod=he={}));function ve(re,q,ae,le){if(!re.isSticky(q))return!1;switch(le.preventPinnedEditorClose){case"keyboardAndMouse":return ae===he.MOUSE||ae===he.KEYBOARD;case"mouse":return ae===he.MOUSE;case"keyboard":return ae===he.KEYBOARD}return!1}e.$fG=new Z;var be;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(be||(e.CloseDirection=be={}));class de{constructor(){this.c=new Map,this.d=new Map}start(q){const ae=this.a=q.get(R.$Fi);for(const[le,ne]of this.c)this.e(le,ne,ae);this.c.clear()}e(q,ae,le){const ne=le.createInstance(ae);this.d.set(q,ne)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,y.$rg)(this.b)}registerEditorSerializer(q,ae){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,ae,this.a):this.c.set(q,ae),(0,O.$Vc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}N.$so.add(e.$SF.EditorFactory,new de);async function $e(re,q,ae){return!re||!re.length?[]:await Promise.all(re.map(async le=>{const ne=k.URI.revive(le.fileUri);if(!ne){ae.info("Cannot resolve the path because it is not valid.",le);return}if(!await q.canHandleResource(ne)){ae.info("Cannot resolve the path because it cannot be handled",le);return}let oe=le.exists,H=le.type;if(typeof oe!="boolean"||typeof H!="number")try{H=(await q.stat(ne)).isDirectory?v.FileType.Directory:v.FileType.Unknown,oe=!0}catch(ue){ae.error(ue),oe=!1}if(!oe&&le.openOnlyIfExists){ae.info("Cannot resolve the path because it does not exist",le);return}if(H===v.FileType.Directory){ae.info("Cannot resolve the path because it is a directory",le);return}const x={...le.options,pinned:!0};return oe?{resource:ne,options:x}:{resource:ne,options:x,forceUntitled:!0}}))}var ye;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(ye||(e.EditorsOrder=ye={}));function Y(re){const q=re;if(!q)return!1;const ae=q;if(ae.modified)return Y(ae.modified);const le=q;return!!(le.contributionsState&&le.viewState&&Array.isArray(le.cursorState))}function we(re){return(0,I.$sj)(re)}function Te(re,q,ae){const le=(0,I.$tj)(re,q);return le.forceMessage=ae?.forceMessage,le.forceSeverity=ae?.forceSeverity,le.allowDialog=ae?.allowDialog,le}}),define(Ie[233],Pe([1,0,6,195,3,4,29,31,26,98,223]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$pG=e.ViewContentGroups=e.$nG=e.ViewContainerLocation=e.Extensions=e.$mG=e.$lG=e.$kG=void 0,e.$oG=C,e.$kG="views",e.$lG=(0,y.localize)(0,null),e.$mG=(0,I.$zx)("default-view-icon",s.$6j.window,(0,y.localize)(1,null));var E;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var u;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel",a[a.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$nG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function C(a){switch(a){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Xc{constructor(){super(...arguments),this.c=this.B(new w.$ne),this.onDidRegister=this.c.event,this.f=this.B(new w.$ne),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(l,g,m){const $=this.get(l.id);if($)return $;const S=l;return S.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$Ac)(this.g,g,[]).push(S),m?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:g}),S}deregisterViewContainer(l){for(const g of this.g.keys()){const m=this.g.get(g),$=m?.indexOf(l);if($!==-1){m?.splice($,1),m.length===0&&this.g.delete(g),this.f.fire({viewContainer:l,viewContainerLocation:g});return}}}get(l){return this.all.filter(g=>g.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(m=>m?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(g=>this.getViewContainerLocation(g)===l)}}N.$so.add(E.ViewContainersRegistry,new d);var n;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(n||(e.ViewContentGroups=n={}));function o(a,l){const g=a.group??n.More,m=l.group??n.More;return g!==m?g.localeCompare(m):(a.order??5)-(l.order??5)}class c extends O.$Xc{constructor(){super(...arguments),this.c=this.B(new w.$ne),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$ne),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$ne),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$ne),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Kc}registerViews(l,g){this.registerViews2([{views:l,viewContainer:g}])}registerViews2(l){l.forEach(({views:g,viewContainer:m})=>this.r(g,m)),this.c.fire(l)}deregisterViews(l,g){const m=this.s(l,g);m.length&&this.f.fire({views:m,viewContainer:g})}moveViews(l,g){for(const m of this.m.keys())if(m!==g){const $=this.s(l,m);$.length&&(this.r($,g),this.g.fire({views:$,from:m,to:g}))}}getViews(l){return this.m.get(l)||[]}getView(l){for(const g of this.j){const m=(this.m.get(g)||[]).filter($=>$.id===l)[0];if(m)return m}return null}getViewContainer(l){for(const g of this.j)if((this.m.get(g)||[]).filter($=>$.id===l)[0])return g;return null}registerViewWelcomeContent(l,g){return this.n.add(l,g),this.h.fire(l),(0,O.$Vc)(()=>{this.n.delete(l,g),this.h.fire(l)})}registerViewWelcomeContent2(l,g){const m=new Map;for(const[$,S]of g)this.n.add(l,S),m.set($,(0,O.$Vc)(()=>{this.n.delete(l,S),this.h.fire(l)}));return this.h.fire(l),m}getViewWelcomeContent(l){const g=[];return this.n.forEach(l,m=>g.push(m)),g.sort(o)}r(l,g){let m=this.m.get(g);m||(m=[],this.m.set(g,m),this.j.push(g));for(const $ of l){if(this.getView($.id)!==null)throw new Error((0,y.localize)(2,null,$.id));m.push($)}}s(l,g){const m=this.m.get(g);if(!m)return[];const $=[],S=[];for(const D of m)l.includes(D)?$.push(D):S.push(D);return $.length&&(S.length?this.m.set(g,S):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),$}}N.$so.add(E.ViewsRegistry,new c),e.$pG=(0,k.$Gi)("viewDescriptorService");var h;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var i;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class r{constructor(l,g){this.c=!1,this.d=!1,(0,v.$io)(this,l),this.d=!!g,this.resolve=async m=>{if(g&&!this.c){const $=await g(m);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$qG=r;class t extends Error{constructor(l){super((0,y.localize)(3,null,l)),this.name="NoTreeViewError"}static is(l){return l.name==="NoTreeViewError"}}e.$rG=t}),define(Ie[234],Pe([1,0,196,32]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=void 0,e.$vG=new y.$Xj("chatSessionResponseVote","",{type:"string",description:(0,w.localize)(0,null)}),e.$wG=new y.$Xj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,w.localize)(1,null)}),e.$xG=new y.$Xj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,w.localize)(2,null)}),e.$yG=new y.$Xj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,w.localize)(3,null)}),e.$zG=new y.$Xj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,w.localize)(4,null)}),e.$AG=new y.$Xj("chatResponse",!1,{type:"boolean",description:(0,w.localize)(5,null)}),e.$BG=new y.$Xj("chatRequest",!1,{type:"boolean",description:(0,w.localize)(6,null)}),e.$CG=new y.$Xj("chatEditApplied",!1,{type:"boolean",description:(0,w.localize)(7,null)}),e.$DG=new y.$Xj("chatInputHasText",!1,{type:"boolean",description:(0,w.localize)(8,null)}),e.$EG=new y.$Xj("chatInputHasFocus",!1,{type:"boolean",description:(0,w.localize)(9,null)}),e.$FG=new y.$Xj("inChatInput",!1,{type:"boolean",description:(0,w.localize)(10,null)}),e.$GG=new y.$Xj("inChat",!1,{type:"boolean",description:(0,w.localize)(11,null)}),e.$HG=new y.$Xj("chatIsEnabled",!1,{type:"boolean",description:(0,w.localize)(12,null)}),e.$IG=new y.$Xj("chatCursorAtTop",!1),e.$JG=new y.$Xj("chatInputHasAgent",!1),e.$KG=new y.$Xj("chatLocation",void 0),e.$LG=new y.$Xj("quickChatHasFocus",!1,{type:"boolean",description:(0,w.localize)(13,null)})}),define(Ie[235],Pe([1,0,325,11,22,6,40,4,49,142,13,32,19,3,12,109,217,228,234]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.ChatAgentLocation=void 0,e.$PH=g,e.$QH=m;var r;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(r||(e.ChatAgentLocation=r={})),function($){function S(D){switch(D){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=S}(r||(e.ChatAgentLocation=r={})),e.$KH=(0,C.$Gi)("chatAgentService");let t=class{constructor(S){this.f=S,this.b=new Map,this.d=new O.$ne,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$HG.bindTo(this.f)}registerAgent(S,D){if(this.getAgent(S))throw new Error(`Agent already registered: ${JSON.stringify(S)}`);const T=this,P=D.slashCommands;D={...D,get slashCommands(){return P.filter(f=>!f.when||T.f.contextMatchesRules(E.$Ej.deserialize(f.when)))}};const p={data:D};return this.b.set(S,p),(0,N.$Vc)(()=>{this.b.delete(S),this.d.fire(void 0)})}registerAgentImplementation(S,D){const b=this.b.get(S);if(!b)throw new Error(`Unknown agent: ${JSON.stringify(S)}`);if(b.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(S)}`);return b.data.isDefault&&this.e.set(!0),b.impl=D,this.d.fire(new a(b.data,D)),(0,N.$Vc)(()=>{b.impl=void 0,this.d.fire(void 0),b.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(S,D){S.isDynamic=!0;const b={data:S,impl:D};return this.b.set(S.id,b),this.d.fire(new a(S,D)),(0,N.$Vc)(()=>{this.b.delete(S.id),this.d.fire(void 0)})}registerAgentCompletionProvider(S,D){return this.g.set(S,D),{dispose:()=>{this.g.delete(S)}}}async getAgentCompletionItems(S,D,b){return await this.g.get(S)?.(D,b)??[]}updateAgent(S,D){const b=this.b.get(S);if(!b?.impl)throw new Error(`No activated agent with id ${JSON.stringify(S)} registered`);b.data.metadata={...b.data.metadata,...D},this.d.fire(new a(b.data,b.impl))}getDefaultAgent(S){return(0,w.$ib)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(S))}getContributedDefaultAgent(S){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(S))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),S=>!!S.data.metadata.isSecondary)?.data}getAgent(S){if(this.h(S))return this.b.get(S)?.data}h(S){const D=this.b.get(S);return!D?.data.when||this.f.contextMatchesRules(E.$Ej.deserialize(D.data.when))}getAgentByFullyQualifiedId(S){const D=R.Iterable.find(this.b.values(),b=>g(b.data)===S)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(S=>S.data).filter(S=>this.h(S.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(S=>!!S.impl).filter(S=>this.h(S.data.id)).map(S=>new a(S.data,S.impl))}getAgentsByName(S){return this.getAgents().filter(D=>D.name===S)}agentHasDupeName(S){const D=this.getAgent(S);return D?this.getAgentsByName(D.name).filter(b=>b.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(S,D,b,T,P){const p=this.b.get(S);if(!p?.impl)throw new Error(`No activated agent with id "${S}"`);return await p.impl.invoke(D,b,T,P)}async getFollowups(S,D,b,T,P){const p=this.b.get(S);if(!p?.impl)throw new Error(`No activated agent with id "${S}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(D,b,T,P):[]}};e.$LH=t,t.AGENT_LEADER="@",e.$LH=t=He([Ge(0,E.$Yj)],t);class a{constructor(S,D){this.b=S,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(S,D,b,T){return this.d.invoke(S,D,b,T)}async provideFollowups(S,D,b,T){return this.d.provideFollowups?this.d.provideFollowups(S,D,b,T):[]}provideWelcomeMessage(S,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(S,D)}provideSampleQuestions(S,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(S,D)}}e.$MH=a,e.$NH=(0,C.$Gi)("chatAgentNameService");let l=i=class{constructor(S,D,b,T){if(this.g=D,this.h=b,this.i=T,this.e=(0,s.$8d)(this,Object.create(null)),this.f=!1,!S.chatParticipantRegistry)return;this.d=S.chatParticipantRegistry;const P=T.get(i.b,c.StorageScope.APPLICATION);try{this.e.set(JSON.parse(P??"{}"),void 0)}catch{T.remove(i.b,c.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(S=>this.h.warn("Failed to fetch chat participant registry",S)).then(()=>(0,y.$Hh)(5*60*1e3)).then(()=>this.j())}async k(){const S=await this.g.request({type:"GET",url:this.d},k.CancellationToken.None);if(S.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,o.$aq)(S);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const b=D.restrictedChatParticipants;this.e.set(b,void 0),this.i.store(i.b,JSON.stringify(b),c.StorageScope.APPLICATION,c.StorageTarget.MACHINE)}getAgentNameRestriction(S){const D=this.l(S.name,S).get(),b=!S.fullName||this.l(S.fullName.replace(/\s/g,""),S).get();return D&&b}l(S,D){return this.e.map(T=>T[S.toLowerCase()]).map(T=>T?T.some(P=>(0,I.$Hf)(P,P.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$OH=l,l.b="chat.participantNameRegistry",e.$OH=l=i=He([Ge(0,n.$tk),Ge(1,o.$7p),Ge(2,d.$ak),Ge(3,c.$hq)],l);function g($){return`${$.extensionId.value}.${$.id}`}function m($){const S="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in S||(S.extensionPublisherId=S.extensionPublisher??""),"extensionDisplayName"in S||(S.extensionDisplayName=""),"extensionId"in S||(S.extensionId=new u.$sn("")),(0,v.$di)(S)}}),define(Ie[236],Pe([1,0,2,33,3]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jH=e.$iH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$gH=O,e.$hH=R;function O(s){return!!s&&typeof s=="object"&&"uri"in s&&s.uri instanceof w.URI&&"version"in s&&typeof s.version=="number"&&"ranges"in s&&Array.isArray(s.ranges)&&s.ranges.every(y.$Nt.isIRange)}function R(s){return!!s&&typeof s=="object"&&"documents"in s&&Array.isArray(s.documents)&&s.documents.every(O)}var N;(function(s){s[s.Down=0]="Down",s[s.Up=1]="Up"})(N||(e.ChatAgentVoteDirection=N={}));var v;(function(s){s[s.Action=1]="Action",s[s.Toolbar=2]="Toolbar"})(v||(e.ChatCopyKind=v={})),e.$iH=(0,k.$Gi)("IChatService"),e.$jH="accessibility.voice.keywordActivation"}),define(Ie[237],Pe([1,0,6,11,198]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vtb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new w.$ne,this.o=new w.$ne,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(N){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=N}onEvent(N){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=N}onRequest(N){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=N}sendResponse(N){N.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${N.command}`)):this.u("response",N)}sendRequest(N,v,s,I){const E={command:N};if(v&&Object.keys(v).length>0&&(E.arguments=v),this.u("request",E),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const C=this.f.get(E.seq);if(C){this.f.delete(E.seq);const d={type:"response",seq:0,request_seq:E.seq,success:!1,command:N,message:(0,k.localize)(0,null,I,N)};C(d)}},I)}return s&&this.f.set(E.seq,s),E.seq}acceptMessage(N){this.k?this.k(N):(this.m.push(N),this.m.length===1&&this.s())}q(N,v){return N.type!=="event"||v.type!=="event"}async s(){let N;for(;this.m.length;){if((!N||this.q(this.m[0],N))&&await(0,y.$Hh)(0),N=this.m.shift(),!N)return;switch(N.type){case"event":this.j?.(N);break;case"request":this.g?.(N);break;case"response":{const v=N,s=this.f.get(v.request_seq);s&&(this.f.delete(v.request_seq),s(v));break}}}}u(N,v){v.type=N,v.seq=this.d++,this.sendMessage(v)}async w(){if(this.f.size===0)return Promise.resolve();const N=new Map;this.f.forEach((v,s)=>N.set(s,v)),await(0,y.$Hh)(500),N.forEach((v,s)=>{v({type:"response",seq:0,request_seq:s,success:!1,command:"canceled",message:"canceled"}),this.f.delete(s)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Vtb=O}),define(Ie[81],Pe([1,0,2,199,32,3]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$DK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$BK=e.MemoryRangeType=e.State=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=void 0,e.$AK=v,e.$CK=I,y=Ve(y),e.$oJ="workbench.view.debug",e.$pJ="workbench.debug.variablesView",e.$qJ="workbench.debug.watchExpressionsView",e.$rJ="workbench.debug.callStackView",e.$sJ="workbench.debug.loadedScriptsView",e.$tJ="workbench.debug.breakPointsView",e.$uJ="workbench.debug.disassemblyView",e.$vJ="workbench.panel.repl",e.$wJ="workbench.panel.repl.view",e.$xJ=new k.$Xj("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$yJ=new k.$Xj("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$zJ=new k.$Xj("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$AJ="debugUx",e.$BJ=new k.$Xj(e.$AJ,"default",{type:"string",description:y.localize(3,null)}),e.$CJ=new k.$Xj("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$DJ=new k.$Xj("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$EJ=new k.$Xj("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$FJ=new k.$Xj("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$GJ=new k.$Xj("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$HJ=new k.$Xj("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$IJ=new k.$Xj("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$JJ=new k.$Xj("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$KJ=new k.$Xj("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$LJ=new k.$Xj("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$MJ=new k.$Xj("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$NJ=new k.$Xj("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$OJ=new k.$Xj("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$PJ=new k.$Xj("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$QJ=new k.$Xj("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$RJ=new k.$Xj("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$SJ=new k.$Xj("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$TJ=new k.$Xj("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$UJ=new k.$Xj("breakpointItemBytes",void 0,{type:"boolean",description:y.localize(22,null)}),e.$VJ=new k.$Xj("breakpointHasModes",!1,{type:"boolean",description:y.localize(23,null)}),e.$WJ=new k.$Xj("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(24,null)}),e.$XJ=new k.$Xj("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(25,null)}),e.$YJ=new k.$Xj("loadedScriptsItemType",void 0,{type:"string",description:y.localize(26,null)}),e.$ZJ=new k.$Xj("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(27,null)}),e.$1J=new k.$Xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:y.localize(28,null)}),e.$2J=new k.$Xj("stepBackSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$3J=new k.$Xj("restartFrameSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$4J=new k.$Xj("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(31,null)}),e.$5J=new k.$Xj("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(32,null)}),e.$6J=new k.$Xj("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(33,null)}),e.$7J=new k.$Xj("breakpointsExist",!1,{type:"boolean",description:y.localize(34,null)}),e.$8J=new k.$Xj("debuggersAvailable",!1,{type:"boolean",description:y.localize(35,null)}),e.$9J=new k.$Xj("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(36,null)}),e.$0J=new k.$Xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(37,null)}),e.$$J=new k.$Xj("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$_J=new k.$Xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$aK=new k.$Xj("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$bK=new k.$Xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$cK=new k.$Xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(42,null)}),e.$dK=new k.$Xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(43,null)}),e.$eK=new k.$Xj("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(44,null)}),e.$fK=new k.$Xj("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(45,null)}),e.$gK=new k.$Xj("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(46,null)}),e.$hK=new k.$Xj("variableIsReadonly",!1,{type:"boolean",description:y.localize(47,null)}),e.$iK=new k.$Xj("variableValue",!1,{type:"string",description:y.localize(48,null)}),e.$jK=new k.$Xj("variableType",!1,{type:"string",description:y.localize(49,null)}),e.$kK=new k.$Xj("variableInterfaces",!1,{type:"array",description:y.localize(50,null)}),e.$lK=new k.$Xj("variableName",!1,{type:"string",description:y.localize(51,null)}),e.$mK=new k.$Xj("variableLanguage",!1,{type:"string",description:y.localize(52,null)}),e.$nK=new k.$Xj("variableExtensionId",!1,{type:"string",description:y.localize(53,null)}),e.$oK=new k.$Xj("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(54,null)}),e.$pK=new k.$Xj("multiSessionRepl",!1,{type:"boolean",description:y.localize(55,null)}),e.$qK=new k.$Xj("multiSessionDebug",!1,{type:"boolean",description:y.localize(56,null)}),e.$rK=new k.$Xj("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(57,null)}),e.$sK=new k.$Xj("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(58,null)}),e.$tK=new k.$Xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(59,null)}),e.$uK=new k.$Xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(60,null)});const R=i=>y.localize(61,null,i);e.$vK=R,e.$wK="editor.contrib.debug",e.$xK="editor.contrib.breakpoint",e.$yK="debug",e.$zK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(62,null)};var N;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(N||(e.State=N={}));function v(i){switch(i){case N.Initializing:return"initializing";case N.Stopped:return"stopped";case N.Running:return"running";default:return"inactive"}}var s;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$BK="vscode-debug-memory";function I(i){const r=i.presentationHint??i.source.presentationHint;return r==="deemphasize"||r==="subtle"}var E;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var C;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$DK=(0,O.$Gi)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var c;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(c||(e.IDebugVisualizationTreeItem=c={}));var h;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:w.URI.revive(r.iconPath.light),dark:w.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(h||(e.IDebugVisualization=h={}))}),define(Ie[238],Pe([1,0,13,2,20,26,16,33,22,18]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8H=void 0,e.$VH=E,e.$WH=u,e.$XH=C,e.$YH=d,e.$ZH=n,e.$1H=o,e.$2H=c,e.$3H=i,e.$4H=a,e.$5H=l,e.$6H=m,e.$7H=S;const I=/{([^}]+)}/g;function E(b,T,P){return b.replace(I,function(p,f){return T&&f.length>0&&f[0]!=="_"?p:P&&P.hasOwnProperty(f)?P[f]:p})}function u(b){const T={};for(const P of Object.keys(b))P.startsWith("!")||(T[P]=b[P]);return T}function C(b){return b.configuration.request==="attach"&&!d(b)&&(!b.parentSession||C(b.parentSession))}function d(b){let T=b.configuration.type;if(T)return T==="vslsShare"&&(T=b.configuration.adapterProxy.configuration.type),(0,w.$Hf)(T,"extensionhost")||(0,w.$Hf)(T,"pwa-extensionhost")?b:b.parentSession?d(b.parentSession):void 0}function n(b){return b.type&&(b.label||b.program||b.runtime)}function o(b,T,P){let p,f=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let L=null;for(;L=M.exec(b);){const K=L.index+1,J=K+L[0].length;if(K<=T&&J>=P){p=L[0],f=K;break}}if(p){const K=/\w+/g;let J=null;for(;(J=K.exec(p))&&!(J.index+1+f+J[0].length>=P););J&&(p=p.substring(0,K.lastIndex))}return p?{start:f,end:f+p.length-1}:{start:0,end:0}}async function c(b,T,P,p){if(b.evaluatableExpressionProvider.has(T)){const f=b.evaluatableExpressionProvider.ordered(T),M=(0,s.$Kb)(await Promise.all(f.map(async L=>{try{return await L.provideEvaluatableExpression(T,P,p??v.CancellationToken.None)}catch{return}})));if(M.length>0){let L=M[0].expression;const K=M[0].range;return L||(L=T.getLineContent(P.lineNumber).substring(K.startColumn-1,K.endColumn-1)),{range:K,matchingExpression:L}}}else{const f=T.getLineContent(P.lineNumber),{start:M,end:L}=o(f,P.column,P.column),K=f.substring(M-1,L);return{matchingExpression:K,range:new N.$Nt(P.lineNumber,M,P.lineNumber,M+K.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(b){return!!(b&&b.match(h))}function r(b){if(typeof b.path=="string"&&!(typeof b.sourceReference=="number"&&b.sourceReference>0)){if(i(b.path))return y.URI.parse(b.path);if((0,k.$lc)(b.path))return y.URI.file(b.path)}return b.path}function t(b){if(typeof b.path=="object"){const T=y.URI.revive(b.path);if(T)return T.scheme===R.Schemas.file?T.fsPath:T.toString()}return b.path}function a(b,T){const P=T?r:t,p=(0,O.$fo)(b);return g(p,(f,M)=>{f&&M&&(M.path=P(M))}),p}function l(b,T){const P=T?r:t,p=(0,O.$fo)(b);return g(p,(f,M)=>{!f&&M&&(M.path=P(M))}),p}function g(b,T){switch(b.type){case"event":{const P=b;switch(P.event){case"output":T(!1,P.body.source);break;case"loadedSource":T(!1,P.body.source);break;case"breakpoint":T(!1,P.body.breakpoint.source);break;default:break}break}case"request":{const P=b;switch(P.command){case"setBreakpoints":T(!0,P.arguments.source);break;case"breakpointLocations":T(!0,P.arguments.source);break;case"source":T(!0,P.arguments.source);break;case"gotoTargets":T(!0,P.arguments.source);break;case"launchVSCode":P.arguments.args.forEach(p=>T(!1,p));break;default:break}break}case"response":{const P=b;if(P.success&&P.body)switch(P.command){case"stackTrace":P.body.stackFrames.forEach(p=>T(!1,p.source));break;case"loadedSources":P.body.sources.forEach(p=>T(!1,p));break;case"scopes":P.body.scopes.forEach(p=>T(!1,p.source));break;case"setFunctionBreakpoints":P.body.breakpoints.forEach(p=>T(!1,p.source));break;case"setBreakpoints":P.body.breakpoints.forEach(p=>T(!1,p.source));break;case"disassemble":P.body?.instructions.forEach(f=>T(!1,f.location));break;default:break}break}}}function m(b){return b.filter(T=>!T.presentation?.hidden).sort((T,P)=>T.presentation?P.presentation?T.presentation.group?P.presentation.group?T.presentation.group!==P.presentation.group?T.presentation.group.localeCompare(P.presentation.group):$(T.presentation.order,P.presentation.order):-1:P.presentation.group?1:$(T.presentation.order,P.presentation.order):-1:P.presentation?1:0)}function $(b,T){return typeof b!="number"?typeof T!="number"?0:1:typeof T!="number"?-1:b-T}async function S(b,T){const P=b.getValue("debug.saveBeforeStart",{overrideIdentifier:T.activeTextEditorLanguageId});if(P!=="none"&&(await T.saveAll(),P==="allEditorsInActiveGroup")){const p=T.activeEditorPane;p&&p.input.resource?.scheme===R.Schemas.untitled&&await T.save({editor:p.input,groupId:p.group.id})}await b.reloadConfiguration()}const D=(b,T)=>!b||!T?b===T:b.name===T.name&&b.path===T.path&&b.sourceReference===T.sourceReference;e.$8H=D}),define(Ie[239],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.CellExecutionUpdateType=void 0;var y;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(y||(e.CellExecutionUpdateType=y={})),e.$LK=(0,w.$Gi)("INotebookExecutionService")}),define(Ie[240],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$OK=e.ProxyKernelState=e.$NK=void 0,e.$NK=100;var y;(function(k){k[k.Disconnected=1]="Disconnected",k[k.Connected=2]="Connected",k[k.Initializing=3]="Initializing"})(y||(e.ProxyKernelState=y={})),e.$OK=(0,w.$Gi)("INotebookKernelService"),e.$PK=(0,w.$Gi)("INotebookKernelHistoryService")}),define(Ie[241],Pe([1,0,4,33,53,161,103]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LZb=void 0;class N extends w.$Xc{constructor(s,I,E){super(),this._source=s,this.b=I,this.c=E,this.a=void 0}f(s){const I=s.getLineCount();return new y.$Nt(1,1,I,this.g(s,I))}g(s,I){if(I<1||I>s.getLineCount())throw new Error("Illegal value for lineNumber");return s.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const s=new O.$nD;s.acceptChunk(this._source);const I=s.finish(!0),{textBuffer:E,disposable:u}=I.create(k.DefaultEndOfLine.LF);this.b=E,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(s=>{const I=new O.$nD;I.acceptChunk(s);const E=I.finish(!0),{textBuffer:u,disposable:C}=E.create(k.DefaultEndOfLine.LF);return this.B(C),u})),this.a}findInInputs(s){const E=new R.$bD(s,!1,!1,null).parseSearchRequest();if(!E)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,E,!0,5e3)}findInOutputs(s){const E=new R.$bD(s,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(u=>{const C=u.findMatchesLineByLine(this.f(u),E,!0,5e3);if(C.length!==0)return{textBuffer:u,matches:C}}).filter(u=>!!u):[]}}e.$LZb=N}),define(Ie[55],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(O){O.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var y;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(y||(e.TestPosition=y={}));class k{static fromExtHostTestItem(R,N,v=R.parent){if(R._isRoot)return new k([N]);const s=[R.id];for(let I=v;I&&I.id!==N;I=I.parent)s.push(I.id);return s.push(N),new k(s.reverse())}static isRoot(R){return!R.includes(w.Delimiter)}static root(R){const N=R.indexOf(w.Delimiter);return N===-1?R:R.slice(0,N)}static fromString(R){return new k(R.split(w.Delimiter))}static join(R,N){return new k([...R.path,N])}static joinToString(R,N){return R.toString()+w.Delimiter+N}static parentId(R){const N=R.lastIndexOf(w.Delimiter);return N===-1?void 0:R.slice(0,N)}static localId(R){const N=R.lastIndexOf(w.Delimiter);return N===-1?R:R.slice(N+w.Delimiter.length)}static isChild(R,N){return N.startsWith(R)&&N[R.length]===w.Delimiter}static compare(R,N){return R===N?y.IsSame:k.isChild(R,N)?y.IsChild:k.isChild(N,R)?y.IsParent:y.Disconnected}static getLengthOfCommonPrefix(R,N){if(R===0)return 0;let v=0;for(;v<R-1;){for(let s=1;s<R;s++){const I=N(s-1),E=N(s);if(I.path[v]!==E.path[v])return v}v++}return v}constructor(R,N=R.length){if(this.path=R,this.d=N,R.length===0||N<1)throw new Error("cannot create test with empty path")}get rootId(){return new k(this.path,1)}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new k(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new k(this.path,R)}compare(R){if(typeof R=="string")return k.compare(this.toString(),R);for(let N=0;N<R.d&&N<this.d;N++)if(R.path[N]!==this.path[N])return y.Disconnected;return R.d>this.d?y.IsChild:R.d<this.d?y.IsParent:y.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=w.Delimiter,this.c+=this.path[R]}return this.c}}e.$UI=k}),define(Ie[56],Pe([1,0,2,102,33,55]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$3I=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$2I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$1I=e.$ZI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$YI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$XI=e.$WI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$VI=e.TestResultState=void 0;var R;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$VI={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var N;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(N||(e.ExtTestRunProfileKind=N={}));var v;(function(z){z[z.Run=2]="Run",z[z.Debug=4]="Debug",z[z.Coverage=8]="Coverage",z[z.HasNonDefaultProfile=16]="HasNonDefaultProfile",z[z.HasConfigurable=32]="HasConfigurable",z[z.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.$WI=[v.Run,v.Debug,v.Coverage,v.HasNonDefaultProfile,v.HasConfigurable,v.SupportsContinuousRun];const s=z=>"runId"in z;e.$XI=s;var I;(function(z){z.serialize=A=>({range:A.range.toJSON(),uri:A.uri.toJSON()}),z.deserialize=(A,W)=>({range:k.$Nt.lift(W.range),uri:A.asCanonicalUri(w.URI.revive(W.uri))})})(I||(e.IRichLocation=I={}));var E;(function(z){z[z.Error=0]="Error",z[z.Output=1]="Output"})(E||(e.TestMessageType=E={}));var u;(function(z){z.serialize=A=>({message:A.message,type:E.Error,expected:A.expected,actual:A.actual,contextValue:A.contextValue,location:A.location&&I.serialize(A.location)}),z.deserialize=(A,W)=>({message:W.message,type:E.Error,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&I.deserialize(A,W.location)})})(u||(e.ITestErrorMessage=u={}));const C=(z,A)=>`${A?"s":"e"}${z}`;e.$YI=C;var d;(function(z){z.serialize=A=>({message:A.message,type:E.Output,offset:A.offset,length:A.length,location:A.location&&I.serialize(A.location)}),z.deserialize=(A,W)=>({message:W.message,type:E.Output,offset:W.offset,length:W.length,location:W.location&&I.deserialize(A,W.location)})})(d||(e.ITestOutputMessage=d={}));var n;(function(z){z.serialize=A=>A.type===E.Error?u.serialize(A):d.serialize(A),z.deserialize=(A,W)=>W.type===E.Error?u.deserialize(A,W):d.deserialize(A,W)})(n||(e.ITestMessage=n={}));var o;(function(z){z.serializeWithoutMessages=A=>({state:A.state,duration:A.duration,messages:[]}),z.serialize=A=>({state:A.state,duration:A.duration,messages:A.messages.map(n.serialize)}),z.deserialize=(A,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(Z=>n.deserialize(A,Z))})})(o||(e.ITestTaskState=o={}));const c="\0",h=(z,A)=>z+c+A;e.$ZI=h;const i=z=>{const A=z.indexOf(c);return{ctrlId:z.slice(0,A),tagId:z.slice(A+1)}};e.$1I=i;var r;(function(z){z.serialize=A=>({extId:A.extId,label:A.label,tags:A.tags,busy:A.busy,children:void 0,uri:A.uri?.toJSON(),range:A.range?.toJSON()||null,description:A.description,error:A.error,sortText:A.sortText}),z.deserialize=(A,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?A.asCanonicalUri(w.URI.revive(W.uri)):void 0,range:W.range?k.$Nt.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(r||(e.ITestItem=r={}));var t;(function(z){z[z.NotExpandable=0]="NotExpandable",z[z.Expandable=1]="Expandable",z[z.BusyExpanding=2]="BusyExpanding",z[z.Expanded=3]="Expanded"})(t||(e.TestItemExpandState=t={}));var a;(function(z){z.serialize=A=>({expand:A.expand,item:r.serialize(A.item)}),z.deserialize=(A,W)=>({controllerId:O.$UI.root(W.item.extId),expand:W.expand,item:r.deserialize(A,W.item)})})(a||(e.InternalTestItem=a={}));var l;(function(z){z.serialize=A=>{let W;return A.item&&(W={},A.item.label!==void 0&&(W.label=A.item.label),A.item.tags!==void 0&&(W.tags=A.item.tags),A.item.busy!==void 0&&(W.busy=A.item.busy),A.item.uri!==void 0&&(W.uri=A.item.uri?.toJSON()),A.item.range!==void 0&&(W.range=A.item.range?.toJSON()),A.item.description!==void 0&&(W.description=A.item.description),A.item.error!==void 0&&(W.error=A.item.error),A.item.sortText!==void 0&&(W.sortText=A.item.sortText)),{extId:A.extId,expand:A.expand,item:W}},z.deserialize=A=>{let W;return A.item&&(W={},A.item.label!==void 0&&(W.label=A.item.label),A.item.tags!==void 0&&(W.tags=A.item.tags),A.item.busy!==void 0&&(W.busy=A.item.busy),A.item.range!==void 0&&(W.range=A.item.range?k.$Nt.lift(A.item.range):null),A.item.description!==void 0&&(W.description=A.item.description),A.item.error!==void 0&&(W.error=A.item.error),A.item.sortText!==void 0&&(W.sortText=A.item.sortText)),{extId:A.extId,expand:A.expand,item:W}}})(l||(e.ITestItemUpdate=l={}));const g=(z,A)=>{A.expand!==void 0&&(z.expand=A.expand),A.item!==void 0&&(z.item=z.item?Object.assign(z.item,A.item):A.item)};e.$2I=g;var m;(function(z){z.serializeWithoutMessages=A=>({...a.serialize(A),ownComputedState:A.ownComputedState,computedState:A.computedState,tasks:A.tasks.map(o.serializeWithoutMessages)}),z.serialize=A=>({...a.serialize(A),ownComputedState:A.ownComputedState,computedState:A.computedState,tasks:A.tasks.map(o.serialize)}),z.deserialize=(A,W)=>({...a.deserialize(A,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(Z=>o.deserialize(A,Z)),retired:!0})})(m||(e.TestResultItem=m={}));var $;(function(z){z.empty=()=>({covered:0,total:0}),z.sum=(A,W)=>{A.covered+=W.covered,A.total+=W.total}})($||(e.ICoverageCount=$={}));var S;(function(z){z.serialize=A=>({id:A.id,statement:A.statement,branch:A.branch,declaration:A.declaration,testIds:A.testIds,uri:A.uri.toJSON()}),z.deserialize=(A,W)=>({id:W.id,statement:W.statement,branch:W.branch,declaration:W.declaration,testIds:W.testIds,uri:A.asCanonicalUri(w.URI.revive(W.uri))}),z.empty=(A,W)=>({id:A,uri:W,statement:$.empty()})})(S||(e.IFileCoverage=S={}));function D(z){return{...z,location:z.location?.toJSON()}}function b(z){return z.location=z.location?y.$Mt.isIPosition(z.location)?y.$Mt.lift(z.location):k.$Nt.lift(z.location):void 0,z}e.$3I=3;var T;(function(z){z[z.Declaration=0]="Declaration",z[z.Statement=1]="Statement",z[z.Branch=2]="Branch"})(T||(e.DetailType=T={}));var P;(function(z){z.serialize=A=>A.type===T.Declaration?f.serialize(A):M.serialize(A),z.deserialize=A=>A.type===T.Declaration?f.deserialize(A):M.deserialize(A)})(P||(e.CoverageDetails=P={}));var p;(function(z){z.serialize=D,z.deserialize=b})(p||(e.IBranchCoverage=p={}));var f;(function(z){z.serialize=D,z.deserialize=b})(f||(e.IDeclarationCoverage=f={}));var M;(function(z){z.serialize=A=>({...D(A),branches:A.branches?.map(p.serialize)}),z.deserialize=A=>({...b(A),branches:A.branches?.map(p.deserialize)})})(M||(e.IStatementCoverage=M={}));var L;(function(z){z[z.Add=0]="Add",z[z.Update=1]="Update",z[z.DocumentSynced=2]="DocumentSynced",z[z.Remove=3]="Remove",z[z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",z[z.Retire=5]="Retire",z[z.AddTag=6]="AddTag",z[z.RemoveTag=7]="RemoveTag"})(L||(e.TestDiffOpType=L={}));var K;(function(z){z.deserialize=(A,W)=>W.op===L.Add?{op:W.op,item:a.deserialize(A,W.item)}:W.op===L.Update?{op:W.op,item:l.deserialize(W.item)}:W.op===L.DocumentSynced?{op:W.op,uri:A.asCanonicalUri(w.URI.revive(W.uri)),docv:W.docv}:W,z.serialize=A=>A.op===L.Add?{op:A.op,item:a.serialize(A.item)}:A.op===L.Update?{op:A.op,item:l.serialize(A.item)}:A})(K||(e.TestsDiffOp=K={}));class J{constructor(A){this.k=A,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(A){const W=this.w();for(const Z of A)switch(Z.op){case L.Add:this.l(a.deserialize(this.k,Z.item),W);break;case L.Update:this.p(l.deserialize(Z.item),W);break;case L.Remove:this.q(Z.itemId,W);break;case L.Retire:this.v(Z.itemId);break;case L.IncrementPendingExtHosts:this.updatePendingRoots(Z.amount);break;case L.AddTag:this.c.set(Z.tag.id,Z.tag);break;case L.RemoveTag:this.c.delete(Z.id);break}W.complete?.()}l(A,W){const Z=O.$UI.parentId(A.item.extId)?.toString();let he;if(!Z)he=this.x(A),this.g.add(he),this.f.set(A.item.extId,he);else if(this.f.has(Z)){const ve=this.f.get(Z);ve.children.add(A.item.extId),he=this.x(A,ve),this.f.set(A.item.extId,he)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(A)}`);return}return W.add?.(he),A.expand===t.BusyExpanding&&this.h++,he}p(A,W){const Z=this.f.get(A.extId);if(Z)return A.expand!==void 0&&(Z.expand===t.BusyExpanding&&this.h--,A.expand===t.BusyExpanding&&this.h++),(0,e.$2I)(Z,A),W.update?.(Z),Z}q(A,W){const Z=this.f.get(A);if(!Z)return;const he=O.$UI.parentId(Z.item.extId)?.toString();he?this.f.get(he).children.delete(Z.item.extId):this.g.delete(Z);const ve=[[A]];for(;ve.length;)for(const be of ve.pop()){const de=this.f.get(be);de&&(ve.push(de.children),this.f.delete(be),W.remove?.(de,de!==Z),de.expand===t.BusyExpanding&&this.h--)}}v(A){}updatePendingRoots(A){this.j+=A}w(){return{}}}e.$4I=J}),define(Ie[242],Pe([1,0,99,202,56]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$CGb=e.$BGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var R;(function(E){E.List="list",E.Tree="true"})(R||(e.TestExplorerViewMode=R={}));var N;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(N||(e.TestExplorerViewSorting=N={}));const v={[k.TestResultState.Errored]:(0,y.localize)(0,null),[k.TestResultState.Failed]:(0,y.localize)(1,null),[k.TestResultState.Passed]:(0,y.localize)(2,null),[k.TestResultState.Queued]:(0,y.localize)(3,null),[k.TestResultState.Running]:(0,y.localize)(4,null),[k.TestResultState.Skipped]:(0,y.localize)(5,null),[k.TestResultState.Unset]:(0,y.localize)(6,null)},s=(E,u)=>(0,y.localize)(7,null,(0,w.$Zk)(E),v[u]);e.$BGb=s,e.$CGb={[k.TestRunProfileBitset.Debug]:(0,y.localize)(8,null),[k.TestRunProfileBitset.Run]:(0,y.localize)(9,null),[k.TestRunProfileBitset.Coverage]:(0,y.localize)(10,null)};var I;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Ie[82],Pe([1,0,11,6,4,62,56,55]),function(_,e,w,y,k,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.TestItemEventOp=void 0;var v;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const s=(h,i)=>h===i,E=Object.entries({range:(h,i)=>h===i?!0:!h||!i?!1:h.equalsRange(i),busy:s,label:s,description:s,error:s,sortText:s,tags:(h,i)=>!(h.length!==i.length||h.some(r=>!i.includes(r)))}),u=(h,i)=>{let r;for(const[t,a]of E)a(h[t],i[t])||(r?r[t]=i[t]:r={[t]:i[t]});return r};class C extends k.$Xc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new w.$Sh(()=>this.flushDiff(),200)),this.g=this.B(new y.$ne),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case R.TestDiffOpType.DocumentSynced:{for(const r of this.m)if(r.op===R.TestDiffOpType.DocumentSynced&&r.uri===i.uri){r.docv=i.docv;return}break}case R.TestDiffOpType.Update:{const r=this.m[this.m.length-1];if(r){if(r.op===R.TestDiffOpType.Update&&r.item.extId===i.item.extId){(0,R.$2I)(r.item,i.item);return}if(r.op===R.TestDiffOpType.Add&&r.item.item.extId===i.item.extId){(0,R.$2I)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||r>t.expandLevels)&&(t.expandLevels=r),t.expand===R.TestItemExpandState.Expandable){const a=this.M(t);return a.isOpen()?this.L(t,r-1):a.wait().then(()=>this.L(t,r-1))}else if(t.expand===R.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,r-1)):this.L(t,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case v.RemoveChild:this.O(N.$UI.joinToString(i.fullId,r.id));break;case v.Upsert:this.z(r.item,i);break;case v.Bulk:for(const t of r.ops)this.w(i,t);break;case v.SetTags:this.C(r.new,r.old,i.fullId.toString());break;case v.UpdateCanResolveChildren:this.J(i);break;case v.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:r.update}});break;case v.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$hd)(r)}}y(i){i&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const t=N.$UI.fromExtHostTestItem(i,this.root.id,r?.actual),a=this.s.getApiFor(i);a.parent&&a.parent!==r?.actual&&this.s.getChildren(a.parent).delete(i.id);let l=this.tree.get(t.toString());if(!l){l={fullId:t,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(l.fullId.toString(),l),this.G(i,r),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:l.expand,item:this.s.toITestItem(i)}}),this.I(i,l,r);return}if(l.actual===i){this.H(i,l,r);return}if(l.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,r);const g=this.s.getChildren(l.actual),m=l.actual,$=u(this.s.toITestItem(m),this.s.toITestItem(i));this.s.getApiFor(m).listener=void 0,l.actual=i,l.resolveBarrier=void 0,l.expand=R.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(i.tags,m.tags,t.toString()),delete $.tags),this.w(l,{op:v.SetProp,update:$})),this.I(i,l,r);for(const[D,b]of g)this.s.getChildren(i).get(b.id)||this.O(N.$UI.joinToString(t,b.id));const S=l.expandLevels;S!==void 0&&queueMicrotask(()=>{l.expand===R.TestItemExpandState.Expandable&&(l.expandLevels=void 0,this.expand(t.toString(),S))}),this.y(l.actual.uri)}C(i,r,t){const a=new Set(r.map(l=>l.id));for(const l of i)a.delete(l.id)||this.D(l);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(l=>(0,R.$ZI)(this.s.controllerId,l.id))}}}),a.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$ZI)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$ZI)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,t){this.G(i,t);const a=this.s.getApiFor(i);a.parent=t?.actual,a.listener=l=>this.w(r,l),this.J(r)}I(i,r,t){this.H(i,r,t);for(const[a,l]of this.s.getChildren(i))this.z(l,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:r=i.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:r=R.TestItemExpandState.NotExpandable,r!==i.expand&&(i.expand=r,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:r}}),r===R.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const t=[];for(const[a,l]of this.s.getChildren(i.actual)){const g=this.expand(N.$UI.joinToString(i.fullId,l.id),r);(0,w.$sh)(g)&&t.push(g)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const l=new w.$Fh;return l.open(),l}i.expand=R.TestItemExpandState.BusyExpanding,this.N(i);const r=i.resolveBarrier=new w.$Fh,t=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,l)};let a;try{a=this.h(i.actual===this.root?void 0:i.actual)}catch(l){t(l)}return(0,w.$sh)(a)?a.catch(t).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:i});const t=[r];for(;t.length;){const a=t.pop();if(a){this.s.getApiFor(a.actual).listener=void 0;for(const l of a.actual.tags)this.F(l.id);this.tree.delete(a.fullId.toString());for(const[l,g]of this.s.getChildren(a.actual))t.push(this.tree.get(N.$UI.joinToString(a.fullId,g.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$RP=C;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$SP=d;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$TP=n;class o extends Error{constructor(i,r,t){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${t}".`)}}e.$UP=o;const c=(h,i,r)=>{let t=new Map;return{get size(){return t.size},forEach(a,l){for(const g of t.values())a.call(l,g,this)},[Symbol.iterator](){return t.entries()},replace(a){const l=new Map,g=new Set(t.keys()),m={op:v.Bulk,ops:[]};for(const $ of a){if(!($ instanceof r))throw new n($.id);const S=i($).controllerId;if(S!==h.controllerId)throw new o($.id,S,h.controllerId);if(l.has($.id))throw new d($.id);l.set($.id,$),g.delete($.id),m.ops.push({op:v.Upsert,item:$})}for(const $ of g.keys())m.ops.push({op:v.RemoveChild,id:$});h.listener?.(m),t=l},add(a){if(!(a instanceof r))throw new n(a.id);t.set(a.id,a),h.listener?.({op:v.Upsert,item:a})},delete(a){t.delete(a)&&h.listener?.({op:v.RemoveChild,id:a})},get(a){return t.get(a)},toJSON(){return Array.from(t.values())}}};e.$VP=c}),define(Ie[116],Pe([1,0,82]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=void 0;const y=new WeakMap,k=(R,N)=>{const v={controllerId:N};return y.set(R,v),v};e.$WP=k;const O=R=>{const N=y.get(R);if(!N)throw new w.$TP(R?.id||"<unknown>");return N};e.$XP=O}),define(Ie[83],Pe([1,0,28,16,2]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pDb=e.$oDb=e.$nDb=void 0,e.$qDb=O,e.$rDb=N,e.$nDb="vscode-cdn.net",e.$oDb=`vscode-resource.${e.$nDb}`,e.$pDb=`'self' https://*.${e.$nDb}`;function O(v,s){return v.scheme===y.Schemas.http||v.scheme===y.Schemas.https?v:(s&&s.authority&&s.isRemote&&v.scheme===y.Schemas.file&&(v=k.URI.from({scheme:y.Schemas.vscodeRemote,authority:s.authority,path:v.path})),k.URI.from({scheme:y.Schemas.https,authority:`${v.scheme}+${R(v.authority)}.${e.$oDb}`,path:v.path,fragment:v.fragment,query:v.query}))}function R(v){return v.replace(/./g,s=>{const I=s.charCodeAt(0);return I>=w.CharCode.a&&I<=w.CharCode.z||I>=w.CharCode.A&&I<=w.CharCode.Z||I>=w.CharCode.Digit0&&I<=w.CharCode.Digit9?s:"-"+I.toString(16).padStart(4,"0")})}function N(v){return v.replace(/-([0-9a-f]{4})/g,(s,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Ie[243],Pe([1,0,6,4,83]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=void 0;class O{constructor(N,v,s){this.d=N,this.e=v,this.f=s,this.a=0,this.b=new y.$Wc,this.c=new Map,this.b.add(v.onDidChangeVisibleTextEditors(()=>{const I=v.getVisibleTextEditors();for(const E of this.c.values())I.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(N=>N.inset.dispose()),this.b.dispose()}createWebviewEditorInset(N,v,s,I,E){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===N){u=i;break}if(!u)throw new Error("not a visible editor");const C=this,d=this.a++,n=new w.$ne,o=new w.$ne,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,k.$qDb)(i,C.f)}get cspSource(){return k.$pDb}set options(i){this.b=i,C.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,C.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return C.d.$postMessage(d,i)}},h=new class{constructor(){this.editor=N,this.line=v,this.height=s,this.webview=c,this.onDidDispose=o.event}dispose(){C.c.has(d)&&(C.c.delete(d),C.d.$disposeEditorInset(d),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,v+1,s,I||{},E.identifier,E.extensionLocation),this.c.set(d,{editor:N,inset:h,onDidReceiveMessage:n}),h}$onDidDispose(N){const v=this.c.get(N);v&&v.inset.dispose()}$onDidReceiveMessage(N,v){this.c.get(N)?.onDidReceiveMessage.fire(v)}}e.$Ooc=O}),define(Ie[117],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=e.$yM=e.$xM=void 0,e.$xM="__",e.$yM=(0,w.$Gi)("IAuthenticationService"),e.$zM=(0,w.$Gi)("IAuthenticationExtensionsService")}),define(Ie[244],Pe([1,0,3]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QQ=e.VariableKind=e.$PQ=void 0,e.$PQ=(0,w.$Gi)("configurationResolverService");var y;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(y||(e.VariableKind=y={}));class k extends Error{constructor(R,N){super(N),this.variable=R}}e.$QQ=k}),define(Ie[245],Pe([1,0,20,79,15,26,21,100,203,244,13]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Q=void 0,w=Ve(w),y=Ve(y),k=Ve(k),O=Ve(O);class E{constructor(C,d,n,o){this.h=new Map,this.a=C,this.b=d,this.g=n,o&&(this.c=o.then(c=>this.i(c)))}i(C){if(R.$c){const d=Object.create(null);return Object.keys(C).forEach(n=>{d[n.toLowerCase()]=C[n]}),d}return C}resolveWithEnvironment(C,d,n){return this.l({env:this.i(C),userHome:void 0},d?d.uri:void 0,n)}async resolveAsync(C,d){const n={env:await this.c,userHome:await this.g};return this.l(n,C?C.uri:void 0,d)}async j(C,d,n,o){const c=O.$fo(d);R.$c&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):R.$d&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):R.$e&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,C?C.uri:void 0,c,n,o)}async resolveAnyAsync(C,d,n){return this.j(C,d,n)}async resolveAnyMap(C,d,n){const o=new Map;return{newConfig:await this.j(C,d,n,o),resolvedVariables:o}}resolveWithInteractionReplace(C,d,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,d,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,d){if(this.h.has(C))throw new Error("Variable "+C+" is contributed twice.");this.h.set(C,d)}async l(C,d,n,o,c){if(k.$gg(n))return this.m(C,d,n,o,c);if(Array.isArray(n))return Promise.all(n.map(h=>this.l(C,d,h,o,c)));if(k.$ig(n)){const h=Object.create(null),i=await Promise.all(Object.keys(n).map(async r=>[await this.m(C,d,r,o,c),await this.l(C,d,n[r],o,c)]));for(const[r,t]of i)h[r]=t;return h}return n}m(C,d,n,o,c){return(0,I.$zf)(n,E.VARIABLE_REGEXP,async(h,i)=>{if(i.includes(E.VARIABLE_LHS))return h;let r=await this.o(C,h,i,d,o);return c?.set(i,r),r!==h&&k.$gg(r)&&r.match(E.VARIABLE_REGEXP)&&(r=await this.m(C,d,r,o,c)),r})}n(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async o(C,d,n,o,c){let h;const i=n.split(":");i.length>1&&(n=i[0],h=i[1]);const r=l=>{const g=this.a.getFilePath();if(g)return(0,N.$Yw)(g);throw new s.$QQ(l,(0,v.localize)(0,null,d))},t=l=>{const g=r(l);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,N.$Yw)(m)}throw new s.$QQ(l,(0,v.localize)(1,null,d,w.$qc(g)))},a=l=>{if(h){const g=this.a.getFolderUri(h);if(g)return g;throw new s.$QQ(l,(0,v.localize)(2,null,d,h))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new s.$QQ(l,(0,v.localize)(3,null,d)):new s.$QQ(l,(0,v.localize)(4,null,d))};switch(n){case"env":if(h){if(C.env){const l=C.env[R.$c?h.toLowerCase():h];if(k.$gg(l))return l}return""}throw new s.$QQ(s.VariableKind.Env,(0,v.localize)(5,null,d));case"config":if(h){const l=this.a.getConfigurationValue(o,h);if(k.$pg(l))throw new s.$QQ(s.VariableKind.Config,(0,v.localize)(6,null,d,h));if(k.$ig(l))throw new s.$QQ(s.VariableKind.Config,(0,v.localize)(7,null,d,h));return l}throw new s.$QQ(s.VariableKind.Config,(0,v.localize)(8,null,d));case"command":return this.p(s.VariableKind.Command,d,h,c,"command");case"input":return this.p(s.VariableKind.Input,d,h,c,"input");case"extensionInstallFolder":if(h){const l=await this.a.getExtension(h);if(!l)throw new s.$QQ(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,d,h));return this.n(l.extensionLocation)}throw new s.$QQ(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,d));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,N.$Yw)(this.n(a(s.VariableKind.WorkspaceFolder)));case"cwd":return o||h?(0,N.$Yw)(this.n(a(s.VariableKind.Cwd))):y.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,N.$Yw)(w.$qc(this.n(a(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new s.$QQ(s.VariableKind.UserHome,(0,v.localize)(11,null,d))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new s.$QQ(s.VariableKind.LineNumber,(0,v.localize)(12,null,d))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new s.$QQ(s.VariableKind.SelectedText,(0,v.localize)(13,null,d))}case"file":return r(s.VariableKind.File);case"fileWorkspaceFolder":return t(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return w.$qc(t(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||h?w.$oc(this.n(a(s.VariableKind.RelativeFile)),r(s.VariableKind.RelativeFile)):r(s.VariableKind.RelativeFile);case"relativeFileDirname":{const l=w.$pc(r(s.VariableKind.RelativeFileDirname));if(o||h){const g=w.$oc(this.n(a(s.VariableKind.RelativeFileDirname)),l);return g.length===0?".":g}return l}case"fileDirname":return w.$pc(r(s.VariableKind.FileDirname));case"fileExtname":return w.$rc(r(s.VariableKind.FileExtname));case"fileBasename":return w.$qc(r(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=w.$qc(r(s.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-w.$rc(l).length)}case"fileDirnameBasename":return w.$qc(w.$pc(r(s.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||d}case"execInstallFolder":{const l=this.a.getAppRoot();return l||d}case"pathSeparator":case"/":return w.sep;default:try{const l=h?`${n}:${h}`:n;return this.p(s.VariableKind.Unknown,d,l,c,void 0)}catch{return d}}}}p(C,d,n,o,c){if(n&&o){const h=c===void 0?o[n]:o[c+":"+n];if(typeof h=="string")return h;throw new s.$QQ(C,(0,v.localize)(14,null,d))}return d}}e.$6Q=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[118],Pe([1,0,3,115]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$kE=void 0,e.$lE=s,e.$mE=u,e.$nE=C,e.$kE=(0,w.$Gi)("editorGroupsService");var k;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(k||(e.GroupDirection=k={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var R;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var N;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(N||(e.GroupsArrangement=N={}));var v;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function s(d){const n=d;return(0,y.$9F)(n?.editor)&&(0,y.$9F)(n?.replacement)}var I;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var E;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function u(d){const n=d;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function C(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?k.DOWN:k.RIGHT}}),define(Ie[246],Pe([1,0,3,118]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rE=e.$qE=e.$pE=e.$oE=void 0,e.$sE=k,e.$oE=(0,w.$Gi)("editorService"),e.$pE=-1,e.$qE=-2,e.$rE=-3;function k(O){const R=O;return typeof O=="number"||(0,y.$mE)(R)}}),define(Ie[247],Pe([1,0,3,107]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=void 0,e.$SM=(0,w.$Hi)(y.$Ni)}),define(Ie[119],Pe([1,0,19,6,20,4,11]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=e.$3cc=e.$2cc=e.$1cc=e.$Zcc=void 0,k=Ve(k);class N{constructor(h,i){this.versionId=h,this.removedDueToLooping=i}}e.$Zcc=N;class v{static isHostExtension(h,i,r){if(i.getExtensionDescription(h))return!1;const t=r.getExtensionDescription(h);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(h,i){this.j=h,this.c=new y.$ne,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new w.$un,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const i=this.j.readActivationEvents(h);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,i){this.e=o(this.e,i),this.e=this.e.concat(h);const r=v.l(this.e);return this.e=o(this.e,r.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new N(this.d,r)}static l(h){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(g){this.d.has(g)||(this.d.add(g),this.e.push(g))}addArc(g,m){this.addNode(g),this.addNode(m),this.c.has(g)?this.c.get(g).push(m):this.c.set(g,[m])}getArcs(g){return this.c.has(g)?this.c.get(g):[]}hasOnlyGoodArcs(g,m){const $=i.getArcs(g);for(let S=0;S<$.length;S++)if(!m.has($[S]))return!1;return!0}getNodes(){return this.e}},r=new w.$un;for(const g of h)if(r.set(g.identifier,g),g.extensionDependencies)for(const m of g.extensionDependencies)i.addArc(w.$sn.toKey(g.identifier),w.$sn.toKey(m));const t=new Set;i.getNodes().filter(g=>i.getArcs(g).length===0).forEach(g=>t.add(g));const a=i.getNodes().filter(g=>!t.has(g));let l;do{l=!1;for(let g=0;g<a.length;g++){const m=a[g];i.hasOnlyGoodArcs(m,t)&&(a.splice(g,1),g--,t.add(m),l=!0)}}while(l);return a.map(g=>r.get(g))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const i=this.h.get(h);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new s(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const i=this.f.get(h);return i||void 0}getExtensionDescriptionByUUID(h){for(const i of this.g)if(i.uuid===h)return i}getExtensionDescriptionByIdOrUUID(h,i){return this.getExtensionDescription(h)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$1cc=v;class s{constructor(h,i){this.versionId=h,this.extensions=i}}e.$2cc=s;class I{constructor(h){this.d=new C,this.c=new v(h,[])}async acquireLock(h){const i=await this.d.acquire(h);return new E(this,i)}deltaExtensions(h,i,r){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,i){return this.c.getExtensionDescriptionByIdOrUUID(h,i)}}e.$3cc=I;class E extends O.$Xc{constructor(h,i){super(),this.f=h,this.c=!1,this.B(i)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$4cc=E;class u{constructor(h){this.name=h;const i=(0,R.$zh)();this.promise=i.promise,this.c=i.resolve}resolve(h){this.c(h)}}class C{constructor(){this.c=[],this.d=!1}async acquire(h){const i=new u(h);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};h.resolve((0,O.$Vc)(t))}}var d;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(d||(d={}));function n(c,h){const i=c.isBuiltin?d.Builtin:c.isUnderDevelopment?d.Dev:d.User,r=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(i!==r)return i-r;const t=k.$jc.basename(c.extensionLocation.path),a=k.$jc.basename(h.extensionLocation.path);return t<a?-1:t>a?1:0}function o(c,h){const i=new w.$tn(h);return c.filter(r=>!i.has(r.identifier))}}),define(Ie[84],Pe([1,0,23]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Cn=R,e.$Dn=N;var y;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(y||(e.UIKind=y={}));var k;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(k||(e.ExtensionHostExitCode=k={}));var O;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function R(s){const I=w.$Pe.alloc(1);switch(s){case O.Initialized:I.writeUInt8(1,0);break;case O.Ready:I.writeUInt8(2,0);break;case O.Terminate:I.writeUInt8(3,0);break}return I}function N(s,I){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return I===O.Initialized;case 2:return I===O.Ready;case 3:return I===O.Terminate;default:return!1}}var v;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Ie[67],Pe([1,0,3,6,113,12,27,84,63,64,26,2,4,188]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.$hQ=e.$gQ=void 0,e.$iQ=o;let d=class extends u.$Xc{constructor(h,i){super(),this.s=h,this.t=i,this.a=this.B(new y.$ne),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new y.$ne),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=k.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:s.$Bp,name:(0,C.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,O.$ck)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===k.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=k.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=k.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=k.TelemetryLevel.USAGE:!1}}instantiateLogger(h,i,r){const t=this.getTelemetryDetails(),a=new n(i,r,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),l=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...l,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(h,i,r){this.f=h,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const i=Object.create(null);switch(i["common.extname"]=`${h.publisher}.${h.name}`,i["common.extversion"]=h.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case N.UIKind.Web:i["common.uikind"]="web";break;case N.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.$jn)((0,s.$Hp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const i=this.getTelemetryDetails();this.r.forEach((r,t)=>{const a=r.filter(l=>!l.isDisposed);a.length===0?this.r.delete(t):this.r.set(t,a)}),this.r.forEach(r=>{for(const t of r)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,i){const t=this.r.get(h.value)?.filter(l=>!l.isDisposed);if(!t)return this.r.delete(h.value),!1;let a=!1;for(const l of t)l.ignoreUnhandledExtHostErrors||(l.logError(i),a=!0);return a}};e.$gQ=d,e.$gQ=d=He([Ge(0,R.$fQ),Ge(1,O.$bk)],d);class n{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,i,r,t,a,l,g){this.g=r,this.h=t,this.i=a,this.j=l,this.a=new y.$ne,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(h,i){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let i="properties"in h?h.properties??{}:h;return i=(0,s.$Kp)(i,[]),this.c&&(i=(0,I.$io)(i,this.c)),this.b||(i=(0,I.$io)(i,this.j)),"properties"in h?h.properties=i:h=i,h}k(h,i){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(h,i),this.h.trace(h,i))}logUsage(h,i){this.d.isUsageEnabled&&this.k(h,i)}logError(h,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,i);else{const r={name:h.name,message:h.message,stack:h.stack,cause:h.cause},t=(0,s.$Kp)(r,[]),a=new Error(t.message,{cause:t.cause});a.stack=t.stack,a.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const h=this,i={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$hQ=n;function o(c){const h=Date.now()-new Date(c).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$jQ=(0,w.$Gi)("IExtHostTelemetry")}),define(Ie[25],Pe([1,0,6,2,219,112,19,3]),function(_,e,w,y,k,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.ActivationKind=e.$0G=e.$9G=e.$6G=e.ExtensionHostStartup=e.$5G=e.$4G=e.$3G=e.$2G=void 0,e.$7G=u,e.$8G=C,e.$$G=c,e.$_G=h,e.$2G=Object.freeze({identifier:new R.$sn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:y.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$3G="extensions.webWorker",e.$4G=(0,N.$Gi)("extensionService");class v{constructor(t){this.dependency=t}}e.$5G=v;var s;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,a,l){this.c=t,this.d=a.slice(0),this.e=l.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$NG.createActivationEventsMap(this.d)}}set(t,a,l){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const g=[],m=[],$=[],S=[],D=E(this.d),b=E(a),T=(L,K)=>L.extensionLocation.toString()===K.extensionLocation.toString()||L.isBuiltin===K.isBuiltin||L.isUserBuiltin===K.isUserBuiltin||L.isUnderDevelopment===K.isUnderDevelopment;for(const L of this.d){const K=b.get(L.identifier);if(!K){g.push(L.identifier),D.delete(L.identifier);continue}if(!T(L,K)){g.push(L.identifier),D.delete(L.identifier);continue}}for(const L of a){const K=D.get(L.identifier);if(!K){m.push(L);continue}if(!T(K,L)){g.push(K.identifier),D.delete(K.identifier);continue}}const P=new R.$tn(this.e),p=new R.$tn(l);for(const L of this.e)p.has(L)||$.push(L);for(const L of l)P.has(L)||S.push(L);const f=O.$NG.createActivationEventsMap(m),M={versionId:t,toRemove:g,toAdd:m,addActivationEvents:f,myToRemove:$,myToAdd:S};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:a,toAdd:l,myToRemove:g,myToAdd:m}=t,$=new R.$tn(a),S=new R.$tn(g);for(let D=0;D<this.d.length;D++)$.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)S.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of l)this.d.push(D);for(const D of m)this.e.push(D);return this.f=null,t}containsExtension(t){for(const a of this.e)if(R.$sn.equals(a,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const a of this.d){if(!this.containsExtension(a.identifier))continue;const l=O.$NG.readActivationEvents(a);for(const g of l)t.add(g)}return t}}e.$6G=I;function E(r){const t=new R.$un;for(const a of r)t.set(a.identifier,a);return t}function u(r,t){return!0}function C(r,t){if(!u(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class d{constructor(t,a,l,g){this.codeLoadingTime=t,this.activateCallTime=a,this.activateResolvedTime=l,this.activationReason=g}}e.$9G=d;class n{constructor(t,a){this.description=t,this.value=a}}e.$0G=n;var o;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function c(r){return{type:r.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,k.$Qp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function h(r,t){const a=(0,k.$Op)(r.manifest.publisher,r.manifest.name);return{id:a,identifier:new R.$sn(a),isBuiltin:r.type===R.ExtensionType.System,isUserBuiltin:r.type===R.ExtensionType.User&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,publisherDisplayName:r.publisherDisplayName,...r.manifest}}class i{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,a){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,a){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$aH=i}),define(Ie[248],Pe([1,0,14,119,19,25,12,11]),function(_,e,w,y,k,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=e.$cpc=e.$bpc=e.$apc=e.$_oc=e.$$oc=void 0,w=Ve(w);class v{constructor(c,h,i,r){this.startup=c,this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=r}}e.$$oc=v,v.NONE=new v(!1,-1,-1,-1);class s{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,h){return c===-1||h===-1?-1:h-c}build(){return new v(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$_oc=s;class I{constructor(c,h,i,r,t,a){this.activationFailed=c,this.activationFailedError=h,this.activationTimes=i,this.module=r,this.exports=t,this.subscriptions=a}}e.$apc=I;class E extends I{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$bpc=E;class u extends I{constructor(){super(!1,null,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$cpc=u;class C extends I{constructor(c){super(!0,c,v.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(c,h,i,r){this.g=r,this.a=c,this.b=h,this.c=i,this.d=new k.$un,this.f=Object.create(null)}dispose(){for(const[c,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const c=[];for(const[h,i]of this.d)c.push(i.wait());await Promise.all(c)}isActivated(c){const h=this.d.get(c);return!!(h&&h.value)}getActivatedExtension(c){const h=this.d.get(c);if(!h||!h.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return h.value}async activateByEvent(c,h){if(this.f[c])return;const i=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(i.map(r=>({id:r.identifier,reason:{startup:h,extensionId:r.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,h){const i=this.a.getExtensionDescription(c);if(!i)throw new Error(`Extension '${c.value}' is not known`);return this.h([{id:i.identifier,reason:h}])}async h(c){const h=c.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(h.map(i=>i.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const h=this.a.getExtensionDescription(c.id);if(!h){const t=new Error(`Cannot activate unknown extension '${c.id.value}'`),a=this.k(c,null,[],new C(t));return this.c.onExtensionActivationError(c.id,t,new O.$5G(c.id.value)),a}const i=[],r=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const t of r){if(this.m(t))continue;const a=this.d.get(t);if(a){i.push(a);continue}if(this.l(t)){i.push(this.j({id:this.b.getExtensionDescription(t).identifier,reason:c.reason}));continue}const l=this.a.getExtensionDescription(t);if(l){if(!l.main&&!l.browser)continue;i.push(this.j({id:l.identifier,reason:c.reason}));continue}const g=h.displayName||h.identifier.value,m=new Error(`Cannot activate the '${g}' extension because it depends on unknown extension '${t}'`),$=this.k(c,h.displayName,[],new C(m));return this.c.onExtensionActivationError(h.identifier,m,new O.$5G(t)),$}return this.k(c,h.displayName,i,null)}k(c,h,i,r){const t=new n(c.id,h,c.reason,i,r,this.c,this.g);return this.d.set(c.id,t),t}l(c){return y.$1cc.isHostExtension(c,this.a,this.b)}m(c){const h=this.b.getExtensionDescription(c);return h?!h.main&&!h.browser:!1}};e.$dpc=d,e.$dpc=d=He([Ge(3,R.$ak)],d);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,h,i,r,t,a,l){this.c=c,this.d=h,this.f=i,this.g=r,this.h=t,this.j=a,this.k=l,this.a=new N.$Fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const h=this.g[c];if(h.value&&!h.value.activationFailed){this.g.splice(c,1),c--;continue}if(h.value&&h.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);i.detail=h.value.activationFailedError,this.h=new C(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const h=new Error;if(c&&c.name&&(h.name=c.name),c&&c.message?h.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(h.stack=c.stack),this.h=new C(h),this.b&&w.$7(c))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};n=He([Ge(6,R.$ak)],n)});var ni=this&&this.__importDefault||function(_){return _&&_.__esModule?_:{default:_}};define(Ie[120],Pe([1,0,205,14,36,111,78,31,19,109,112,105]),function(_,e,w,y,k,O,R,N,v,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=void 0,w=Ve(w),k=ni(k);const u=N.$so.as(R.$to.JSONContribution);class C{constructor(t,a,l){this.a=t,this.b=a,this.c=l}d(t,a){this.a({type:t,message:a,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(k.default.Error,t)}warn(t){this.d(k.default.Warning,t)}info(t){this.d(k.default.Info,t)}}e.$VG=C;class d{static a(t){const a=new v.$tn;for(let l=0,g=t.length;l<g;l++)a.add(t[l].description.identifier);return a}static compute(t,a){if(!t||!t.length)return new d(a,[]);if(!a||!a.length)return new d([],t);const l=this.a(t),g=this.a(a),m=a.filter(S=>!l.has(S.description.identifier)),$=t.filter(S=>!g.has(S.description.identifier));return new d(m,$)}constructor(t,a){this.added=t,this.removed=a}}e.$WG=d;class n{constructor(t,a){this.name=t,this.defaultExtensionKind=a,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,y.$3)(t)}}}e.$XG=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$YG={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.$rn},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals).map(r=>r),markdownEnumDescriptions:Object.values(E.allApiProposals).map(r=>r.proposal)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:w.localize(42,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:w.localize(43,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:w.localize(44,null)},{label:"*",description:w.localize(45,null),body:"*"}]}},badges:{type:"array",description:w.localize(46,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(47,null)},href:{type:"string",description:w.localize(48,null)},description:{type:"string",description:w.localize(49,null)}}}},markdown:{type:"string",description:w.localize(50,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(51,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(52,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$0o}},extensionPack:{description:w.localize(53,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$0o}},extensionKind:{description:w.localize(54,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(55,null)},{body:["workspace"],description:w.localize(56,null)},{body:["ui","workspace"],description:w.localize(57,null)},{body:["workspace","ui"],description:w.localize(58,null)},{body:[],description:w.localize(59,null)}]},capabilities:{description:w.localize(60,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(61,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(63,null),w.localize(64,null),w.localize(65,null)]},description:{type:"string",markdownDescription:w.localize(66,null)}}},untrustedWorkspaces:{description:w.localize(67,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(68,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)]},restrictedConfigurations:{description:w.localize(72,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(73,null)}}}}},sponsor:{description:w.localize(74,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(75,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(76,null),type:"string"},"vscode:uninstall":{description:w.localize(77,null),type:"string"}}},icon:{type:"string",description:w.localize(78,null)},l10n:{type:"string",description:w.localize(79,null)},pricing:{type:"string",markdownDescription:w.localize(80,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const a=new n(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,a),t.activationEventsGenerator&&I.$NG.register(t.extensionPoint,t.activationEventsGenerator),e.$YG.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,u.registerSchema(c,e.$YG),a}getExtensionPoints(){return Array.from(this.a.values())}}e.$ZG=h;const i={ExtensionsRegistry:"ExtensionsRegistry"};N.$so.add(i.ExtensionsRegistry,new h),e.$1G=N.$so.as(i.ExtensionsRegistry),u.registerSchema(c,e.$YG),u.registerSchema(s.$uk,{properties:{extensionEnabledApiProposals:{description:w.localize(81,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals).map(r=>r.proposal)}}]}}}})}),define(Ie[249],Pe([1,0,6,40,4,13,197,19,3,12,25,120]),function(_,e,w,y,k,O,R,N,v,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dH=e.$cH=e.$bH=e.ChatMessageRole=void 0;var u;(function(n){n[n.System=0]="System",n[n.User=1]="User",n[n.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$bH=(0,v.$Gi)("ILanguageModelsService");const C={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(0,null)}}};e.$cH=E.$1G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(1,null),oneOf:[C,{type:"array",items:C}]},activationEventsGenerator:(n,o)=>{for(const c of n)o.push(`onLanguageModelChat:${c.vendor}`)}});let d=class{constructor(o,c){this.e=o,this.f=c,this.a=new k.$Wc,this.b=new Map,this.c=new Set,this.d=this.a.add(new w.$ne),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$cH.setHandler(h=>{this.c.clear();for(const r of h){if(!(0,I.$7G)(r.description,"chatProvider")){r.collector.error((0,R.localize)(2,null));continue}for(const t of y.Iterable.wrap(r.value)){if(this.c.has(t.vendor)){r.collector.error((0,R.localize)(3,null,t.vendor));continue}if((0,O.$ef)(t.vendor)){r.collector.error((0,R.localize)(4,null));continue}if(t.vendor.trim()!==t.vendor){r.collector.error((0,R.localize)(5,null));continue}this.c.add(t.vendor)}}const i=[];for(const[r,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(r),i.push(r));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const h=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(h)}const c=[];for(const[h,i]of this.b)(o.vendor===void 0||i.metadata.vendor===o.vendor)&&(o.family===void 0||i.metadata.family===o.family)&&(o.version===void 0||i.metadata.version===o.version)&&(o.identifier===void 0||i.metadata.id===o.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(r=>N.$sn.equals(r,o.extension)))&&c.push(h);return this.f.trace("[LM] selected language models",o,c),c}registerLanguageModelChat(o,c){if(this.f.trace("[LM] registering language model chat",o,c.metadata),!this.c.has(c.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${c.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,c),this.d.fire({added:[{identifier:o,metadata:c.metadata}]}),(0,k.$Vc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,c.metadata))})}async sendChatRequest(o,c,h,i,r){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.sendChatRequest(h,c,i,r)}computeTokenLength(o,c,h){const i=this.b.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideTokenCount(c,h)}};e.$dH=d,e.$dH=d=He([Ge(0,I.$4G),Ge(1,s.$ak)],d)}),define(Ie[250],Pe([1,0,200,15,26,120,32,6]),function(_,e,w,y,k,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$II=void 0,w=Ve(w),y=Ve(y),k=Ve(k);const v={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var s;(function(u){function C(d,n,o){if(!d)return;const c=y.$gg(d.type)?d.type:void 0;if(!c||c.length===0){o.error(w.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const i of d.required)y.$gg(i)&&h.push(i);return{extensionId:n.value,taskType:c,required:h,properties:d.properties?k.$fo(d.properties):{},when:d.when?R.$Ej.deserialize(d.when):void 0}}u.from=C})(s||(s={}));const I=O.$1G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,C)=>{for(const d of u)d.type&&C.push(`onTaskType:${d.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:v}});class E{constructor(){this.d=new N.$ne,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,d)=>{I.setHandler((n,o)=>{this.c=void 0;try{for(const c of o.removed){const h=c.value;for(const i of h)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of o.added){const h=c.value;for(const i of h){const r=s.from(i,c.description.identifier,c.collector);r&&(this.a[r.taskType]=r)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const d of this.all()){const n={type:"object",additionalProperties:!1};d.required.length>0&&(n.required=d.required.slice(0)),d.properties!==void 0?n.properties=k.$fo(d.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[d.taskType]},C.push(n)}this.c={oneOf:C}}return this.c}}e.$II=new E}),define(Ie[251],Pe([1,0,201,15,24,26,32,250,43]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$SI=e.JsonSchemaVersion=e.ExecutionEngine=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$MI=e.ShellQuoting=e.$LI=e.$KI=e.$JI=void 0,w=Ve(w),y=Ve(y),k=Ve(k),O=Ve(O),e.$JI="settings",e.$KI=new R.$Xj("taskRunning",!1,w.localize(0,null)),e.$LI=w.localize2(2,"Tasks");var s;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(s||(e.ShellQuoting=s={})),e.$MI="$customized",function(A){function W(Z){if(!Z)return A.Strong;switch(Z.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=W}(s||(e.ShellQuoting=s={}));var I;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var E;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(E||(e.RevealKind=E={})),function(A){function W(Z){switch(Z.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=W}(E||(e.RevealKind=E={}));var u;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(A){function W(Z){switch(Z.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=W}(u||(e.RevealProblemKind=u={}));var C;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(C||(e.PanelKind=C={})),function(A){function W(Z){switch(Z.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=W}(C||(e.PanelKind=C={}));var d;(function(A){A.defaults={echo:!0,reveal:E.Always,revealProblems:u.Never,focus:!1,panel:C.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var n;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(n||(e.RuntimeType=n={})),function(A){function W(he){switch(he.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=W;function Z(he){switch(he){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=Z}(n||(e.RuntimeType=n={}));var o;(function(A){function W(Z){return y.$gg(Z)?Z:Z.value}A.value=W})(o||(e.CommandString=o={}));var c;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function W(he){return he===A.Clean._id||he===A.Build._id||he===A.Rebuild._id||he===A.Test._id}A.is=W;function Z(he){if(he!==void 0)return y.$gg(he)?W(he)?{_id:he,isDefault:!1}:void 0:he}A.from=Z})(c||(e.TaskGroup=c={}));var h;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var i;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function W(Z){switch(Z){case A.User:return v.ConfigurationTarget.USER;case A.WorkspaceFile:return v.ConfigurationTarget.WORKSPACE;default:return v.ConfigurationTarget.WORKSPACE_FOLDER}}A.toConfigurationTarget=W})(i||(e.TaskSourceKind=i={}));var r;(function(A){A.parallel="parallel",A.sequence="sequence"})(r||(e.DependsOrder=r={}));var t;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var a;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class l{constructor(W,Z,he,ve,be,de){this._label="",this._id=W,Z&&(this._label=Z),he&&(this.type=he),this.runOptions=ve,this.configurationProperties=be,this._source=de}getDefinition(W){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const W={folder:this.d(),id:this._id};return JSON.stringify(W)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(W,Z=!1){if(W===void 0)return!1;if(y.$gg(W))return W===this._label||W===this.configurationProperties.identifier||Z&&W===this._id;const he=this.getDefinition(!0);return he!==void 0&&he._key===W._key}getQualifiedLabel(){const W=this.getWorkspaceFolder();return W?`${this._label} (${W.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(W){this.c===void 0&&(this.c=[]),W&&(this.c=this.c.concat(W))}get taskLoadMessages(){return this.c}}e.$NI=l;class g extends l{constructor(W,Z,he,ve,be,de,$e,ye){super(W,he,void 0,$e,ye,Z),this.command={},this._source=Z,this.hasDefinedMatchers=de,be&&(this.command=be)}clone(){return new g(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(W=!1){if(W&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case n.Shell:Z="shell";break;case n.Process:Z="process";break;case n.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(W){return W instanceof g}getMapKey(){const W=this._source.config.workspaceFolder;return W?`${W.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$JI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const W=this.d();if(!W)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const he={type:e.$MI,folder:W,id:Z};return JSON.stringify(he)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.$eh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(W){return new g(W._id,W._source,W._label,W.type,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$OI=g;class m extends l{constructor(W,Z,he,ve,be,de,$e){super(W,he,ve,de,$e,Z),this._source=Z,this.configures=be}static is(W){return W instanceof m}f(W){return W}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.$eh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$JI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const W=this.d();if(!W)return;let Z=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Z+=this._source.kind);const he={type:e.$MI,folder:W,id:Z};return JSON.stringify(he)}}e.$PI=m;class $ extends l{constructor(W,Z,he,ve,be,de,$e,ye,Y){super(W,he,ve,ye,Y,Z),this.defines=be,this.hasDefinedMatchers=$e,this.command=de,this.icon=Y.icon,this.hide=Y.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(W){return W instanceof $}getMapKey(){const W=this._source.workspaceFolder;return W?`${this._source.scope.toString()}|${W.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const W={type:"contributed",scope:this._source.scope,id:this._id};return W.folder=this.d(),JSON.stringify(W)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(W){return new $(W._id,W._source,W._label,W.type,W.defines,W.command,W.hasDefinedMatchers,W.runOptions,W.configurationProperties)}}e.$QI=$;class S extends l{constructor(W,Z,he,ve,be,de){super(W,he,ve,be,de,Z),this._source=Z}clone(){return new S(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(W){return W instanceof S}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(W){return new S(W._id,W._source,W._label,W.type,W.runOptions,W.configurationProperties)}}e.$RI=S;var D;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(A){A._default=A.Terminal}(D||(e.ExecutionEngine=D={}));var b;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class T{constructor(W){this.c=new Map;for(let Z=0;Z<W.length;Z++)this.c.set(W[Z].uri.toString(),Z)}compare(W,Z){const he=W.getWorkspaceFolder(),ve=Z.getWorkspaceFolder();if(he&&ve){let be=this.c.get(he.uri.toString());be=be===void 0?0:be+1;let de=this.c.get(ve.uri.toString());return de=de===void 0?0:de+1,be===de?W._label.localeCompare(Z._label):be-de}else return!he&&ve?-1:he&&!ve?1:0}}e.$SI=T;var P;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(P||(e.TaskEventKind=P={}));var p;(function(A){A.SingleRun="singleRun",A.Background="background"})(p||(e.TaskRunType=p={}));var f;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var M;(function(A){function W(ye){return{taskId:ye._id,taskName:ye.configurationProperties.name,runType:ye.configurationProperties.isBackground?p.Background:p.SingleRun,group:ye.configurationProperties.group,__task:ye}}function Z(ye,Y,we){return{...W(ye),kind:P.Start,terminalId:Y,resolvedVariables:we}}A.start=Z;function he(ye,Y,we){return{...W(ye),kind:P.ProcessStarted,terminalId:Y,processId:we}}A.processStarted=he;function ve(ye,Y,we){return{...W(ye),kind:P.ProcessEnded,terminalId:Y,exitCode:we}}A.processEnded=ve;function be(ye,Y,we){return{...W(ye),kind:P.Terminated,exitReason:we,terminalId:Y}}A.terminated=be;function de(ye,Y,we){return{...W(Y),kind:ye,terminalId:we}}A.general=de;function $e(){return{kind:P.Changed}}A.changed=$e})(M||(e.TaskEvent=M={}));var L;(function(A){function W(he){const ve=Object.keys(he).sort();let be="";for(const de of ve){let $e=he[de];$e instanceof Object?$e=W($e):typeof $e=="string"&&($e=$e.replace(/,/g,",,")),be+=de+","+$e+","}return be}function Z(he){const be={_key:W(he),type:he.taskType};return Object.assign(be,he),be}A.create=Z})(L||(e.KeyedTaskIdentifier=L={}));var K;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(K||(e.TaskSettingId=K={}));var J;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(J||(e.TasksSchemaProperties=J={}));var z;(function(A){function W(Z,he){const ve=N.$II.get(Z.type);if(ve===void 0){const ye=O.$fo(Z);return delete ye._key,L.create(ye)}const be=Object.create(null);be.type=ve.taskType;const de=new Set;ve.required.forEach(ye=>de.add(ye));const $e=ve.properties;for(const ye of Object.keys($e)){const Y=Z[ye];if(Y!=null)be[ye]=Y;else if(de.has(ye)){const we=$e[ye];if(we.default!==void 0)be[ye]=O.$fo(we.default);else switch(we.type){case"boolean":be[ye]=!1;break;case"number":case"integer":be[ye]=0;break;case"string":be[ye]="";break;default:he.error(w.localize(1,null,JSON.stringify(Z,void 0,0),ye));return}}}return L.create(be)}A.createTaskIdentifier=W})(z||(e.TaskDefinition=z={}))}),define(Ie[252],Pe([1,0,14]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=void 0;class y{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,N)=>{this.b=R,this.d=N,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,w.$3)(R))}then(R,N){return this.j().then(R,N)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$5cc=y;class k extends y{constructor(){super(),this.h=!0,this.i=new w.$8}}e.$6cc=k}),define(Ie[39],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vw=e.$Sw=void 0,e.$Tw=k,e.$Uw=O;class w{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++w.count}}e.$Sw=w,w.count=0;const y=[];function k(N){const v=new w(N);return y[v.nid]=v,v}function O(N){return y[N].sid}class R{constructor(v){this.value=v}}e.$Vw=R}),define(Ie[5],Pe([1,0,39]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$uN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var y;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(y||(e.TextEditorRevealType=y={}));var k;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(k||(e.TabInputKind=k={}));var O;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var R;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var N;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(N||(e.WebviewMessageArrayBufferViewType=N={}));var v;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var s;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var I;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output",n[n.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class E{static mixin(o){return o._id=E.a++,o}}e.$uN=E,E.a=0;var u;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var C;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(C||(e.ISuggestResultDtoField=C={}));var d;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$vN={MainThreadAuthentication:(0,w.$Tw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$Tw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,w.$Tw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,w.$Tw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,w.$Tw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,w.$Tw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,w.$Tw)("MainThreadChatSkills"),MainThreadClipboard:(0,w.$Tw)("MainThreadClipboard"),MainThreadCommands:(0,w.$Tw)("MainThreadCommands"),MainThreadComments:(0,w.$Tw)("MainThreadComments"),MainThreadConfiguration:(0,w.$Tw)("MainThreadConfiguration"),MainThreadConsole:(0,w.$Tw)("MainThreadConsole"),MainThreadDebugService:(0,w.$Tw)("MainThreadDebugService"),MainThreadDecorations:(0,w.$Tw)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$Tw)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$Tw)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$Tw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$Tw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$Tw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$Tw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$Tw)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$Tw)("MainThreadErrors"),MainThreadTreeViews:(0,w.$Tw)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$Tw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$Tw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$Tw)("MainThreadLanguages"),MainThreadLogger:(0,w.$Tw)("MainThreadLogger"),MainThreadMessageService:(0,w.$Tw)("MainThreadMessageService"),MainThreadOutputService:(0,w.$Tw)("MainThreadOutputService"),MainThreadProgress:(0,w.$Tw)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$Tw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$Tw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$Tw)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$Tw)("MainThreadSecretState"),MainThreadStorage:(0,w.$Tw)("MainThreadStorage"),MainThreadSpeech:(0,w.$Tw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,w.$Tw)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$Tw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,w.$Tw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,w.$Tw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$Tw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$Tw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$Tw)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$Tw)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$Tw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$Tw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$Tw)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$Tw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,w.$Tw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,w.$Tw)("MainThreadExtensionService"),MainThreadSCM:(0,w.$Tw)("MainThreadSCM"),MainThreadSearch:(0,w.$Tw)("MainThreadSearch"),MainThreadShare:(0,w.$Tw)("MainThreadShare"),MainThreadTask:(0,w.$Tw)("MainThreadTask"),MainThreadWindow:(0,w.$Tw)("MainThreadWindow"),MainThreadLabelService:(0,w.$Tw)("MainThreadLabelService"),MainThreadNotebook:(0,w.$Tw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$Tw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$Tw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$Tw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$Tw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$Tw)("MainThreadInteractive"),MainThreadTheming:(0,w.$Tw)("MainThreadTheming"),MainThreadTunnelService:(0,w.$Tw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$Tw)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$Tw)("MainThreadTimeline"),MainThreadTesting:(0,w.$Tw)("MainThreadTesting"),MainThreadLocalization:(0,w.$Tw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$Tw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$Tw)("MainThreadAiEmbeddingVector")},e.$wN={ExtHostCommands:(0,w.$Tw)("ExtHostCommands"),ExtHostConfiguration:(0,w.$Tw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$Tw)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$Tw)("ExtHostDebugService"),ExtHostDecorations:(0,w.$Tw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$Tw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$Tw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$Tw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$Tw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$Tw)("ExtHostEditors"),ExtHostTreeViews:(0,w.$Tw)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$Tw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$Tw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$Tw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$Tw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$Tw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$Tw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$Tw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$Tw)("ExtHostStatusBar"),ExtHostShare:(0,w.$Tw)("ExtHostShare"),ExtHostExtensionService:(0,w.$Tw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$Tw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$Tw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,w.$Tw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,w.$Tw)("ExtHostSCM"),ExtHostSearch:(0,w.$Tw)("ExtHostSearch"),ExtHostTask:(0,w.$Tw)("ExtHostTask"),ExtHostWorkspace:(0,w.$Tw)("ExtHostWorkspace"),ExtHostWindow:(0,w.$Tw)("ExtHostWindow"),ExtHostWebviews:(0,w.$Tw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$Tw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$Tw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$Tw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$Tw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$Tw)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$Tw)("ExtHostProgress"),ExtHostComments:(0,w.$Tw)("ExtHostComments"),ExtHostSecretState:(0,w.$Tw)("ExtHostSecretState"),ExtHostStorage:(0,w.$Tw)("ExtHostStorage"),ExtHostUrls:(0,w.$Tw)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$Tw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$Tw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$Tw)("ExtHostOutputService"),ExtHostLabelService:(0,w.$Tw)("ExtHostLabelService"),ExtHostNotebook:(0,w.$Tw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$Tw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$Tw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$Tw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$Tw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$Tw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$Tw)("ExtHostInteractive"),ExtHostChatAgents2:(0,w.$Tw)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$Tw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,w.$Tw)("ExtHostChatSkills"),ExtHostChatProvider:(0,w.$Tw)("ExtHostChatProvider"),ExtHostSpeech:(0,w.$Tw)("ExtHostSpeech"),ExtHostEmbeddings:(0,w.$Tw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,w.$Tw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$Tw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$Tw)("ExtHostTheming"),ExtHostTunnelService:(0,w.$Tw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$Tw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$Tw)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$Tw)("ExtHostTimeline"),ExtHostTesting:(0,w.$Tw)("ExtHostTesting"),ExtHostTelemetry:(0,w.$Tw)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$Tw)("ExtHostLocalization")}}),define(Ie[85],Pe([1,0,3,12,5,17]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=e.$yoc=e.$xoc=void 0,k=Ve(k),e.$xoc=(0,w.$Gi)("IExtHostApiDeprecationService");let R=class{constructor(v,s){this.c=s,this.a=new Set,this.b=v.getProxy(k.$vN.MainThreadTelemetry)}report(v,s,I){const E=this.d(v,s);this.a.has(E)||(this.a.add(E),s.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${v}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:s.identifier.value,apiId:v}))}d(v,s){return`${v}-${s.identifier.value}`}};e.$yoc=R,e.$yoc=R=He([Ge(0,O.$2P),Ge(1,y.$ak)],R),e.$zoc=Object.freeze(new class{report(N,v,s){}})}),define(Ie[253],Pe([1,0,5]),function(_,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class y{constructor(O){const R=O.getProxy(w.$vN.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(N){return R.$writeText(N)}})}}e.$Moc=y}),define(Ie[254],Pe([1,0,26,5,27,17]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0;let R=class{constructor(I,E){this.a=I.getProxy(y.$vN.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,E){const u=this,C=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,E,C,arguments)}})}e(I,E,u,C){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:v(C,this.b)}),this.c&&this.f(I,u,C)}};e.$Iqc=R,e.$Iqc=R=He([Ge(0,O.$2P),Ge(1,k.$fQ)],R);const N=1e5;function v(s,I){const E=[];if(s.length)for(let u=0;u<s.length;u++){let C=s[u];if(typeof C>"u")C="undefined";else if(C instanceof Error){const d=C;d.stack?C=d.stack:C=d.toString()}E.push(C)}if(I){const u=new Error().stack;u&&E.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,w.$ko)(E);return u.length>N?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ie[255],Pe([1,0,2,5,25]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=void 0;class O{constructor(N){this.a=N.getProxy(y.$vN.MainThreadDialogs)}showOpenDialog(N,v){return v?.allowUIResources&&(0,k.$8G)(N,"showLocal"),this.a.$showOpenDialog(v).then(s=>s?s.map(I=>w.URI.revive(I)):void 0)}showSaveDialog(N){return this.a.$showSaveDialog(N).then(v=>v?w.URI.revive(v):void 0)}}e.$Opc=O}),define(Ie[256],Pe([1,0,22,6,4,5]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpc=void 0;class R{constructor(v){this.b=new Map,this.c=new y.$ne,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=v.getProxy(O.$vN.MainThreadEmbeddings)}registerEmbeddingsProvider(v,s,I){if(this.d.has(s))throw new Error("An embeddings provider for this model is already registered");const E=this.e++;return this.a.$registerEmbeddingProvider(E,s),this.b.set(E,{id:s,provider:I}),(0,k.$Vc)(()=>{this.a.$unregisterEmbeddingProvider(E),this.b.delete(E)})}async computeEmbeddings(v,s,I){I??(I=w.CancellationToken.None);let E=!1;typeof s=="string"&&(s=[s],E=!0);const u=await this.a.$computeEmbeddings(v,s,I);if(u.length!==s.length)throw new Error;if(E){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(v,s,I){const E=this.b.get(v);if(!E)return[];const u=await E.provider.provideEmbeddings(s,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(v){this.d=new Set(v),this.c.fire()}}e.$Rpc=R}),define(Ie[257],Pe([1,0,4,5]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=void 0;class k{constructor(R){this.b=0,this.a=R.getProxy(y.$vN.MainThreadLabelService)}$registerResourceLabelFormatter(R){const N=this.b++;return this.a.$registerResourceLabelFormatter(N,R),(0,w.$Vc)(()=>{this.a.$unregisterResourceLabelFormatter(N)})}}e.$9pc=k}),define(Ie[86],Pe([1,0,21,13,2,3,12,5,27,17]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$spc=e.$rpc=void 0;let I=class{constructor(u,C,d){this.f=d,this.d=new Map,this.a=C.getProxy(N.$vN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===w.$a}getMessage(u,C){const{message:d,args:n,comment:o}=C;if(this.c)return(0,y.$gf)(d,n??{});let c=d;o&&o.length>0&&(c+=`/${Array.isArray(o)?o.join(""):o}`);const h=this.d.get(u)?.contents[c];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,y.$gf)(h??d,n??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let C;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(d),o=JSON.parse(n);C=u.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${n.message}`);return}C&&this.d.set(u.identifier.value,{contents:C,uri:d})}async g(u){if(u.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return k.URI.revive(C)}return u.l10n?k.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$rpc=I,e.$rpc=I=He([Ge(0,v.$fQ),Ge(1,s.$2P),Ge(2,R.$ak)],I),e.$spc=(0,O.$Gi)("IExtHostLocalizationService")}),define(Ie[258],Pe([1,0,12,5,27,17,2,49]),function(_,e,w,y,k,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=void 0;let v=class extends w.$lk{constructor(E,u){super(u.logLevel,u.logsLocation,u.loggers.map(C=>(0,N.$di)(C))),this.r=E.getProxy(y.$vN.MainThreadLogger)}$setLogLevel(E,u){u?this.setLogLevel(R.URI.revive(u),E):this.setLogLevel(E)}setVisibility(E,u){super.setVisibility(E,u),this.r.$setVisibility(E,u)}s(E,u,C){return new s(this.r,E,u,C)}};e.$Hqc=v,e.$Hqc=v=He([Ge(0,O.$2P),Ge(1,k.$fQ)],v);class s extends w.$gk{constructor(E,u,C,d){super(d?.logLevel==="always"),this.r=E,this.s=u,this.m=!1,this.n=[],this.setLevel(C),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(E,u){const C=[[E,u]];this.m?this.u(C):this.n.push(...C)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Ie[87],Pe([1,0,5,3,4,17,23]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=e.$tpc=void 0,e.$tpc=(0,y.$Gi)("IExtHostManagedSockets");let N=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(w.$vN.MainThreadManagedSockets)}setFactory(E,u){for(const C of this.d.values())C.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new v(E,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const u=++this.b,C=await this.c.makeConnection(),d=new k.$Wc;return this.d.set(u,new s(u,C,d)),d.add((0,k.$Vc)(()=>this.d.delete(u))),d.add(C.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(C.onDidClose(n=>{this.a.$onDidManagedSocketClose(u,n?.stack??n?.message),d.dispose()})),d.add(C.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(u,R.$Pe.wrap(n)))),u}$remoteSocketWrite(E,u){this.d.get(E)?.actual.send(u.buffer)}$remoteSocketEnd(E){const u=this.d.get(E);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$upc=N,e.$upc=N=He([Ge(0,O.$2P)],N);class v{constructor(E,u){this.socketFactoryId=E,this.makeConnection=u}}class s extends k.$Xc{constructor(E,u,C){super(),this.socketId=E,this.actual=u,this.B(C)}}}),define(Ie[259],Pe([1,0,5,12,25]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pc=void 0;function O(N){return N&&N.title}let R=class{constructor(v,s){this.b=s,this.a=v.getProxy(w.$vN.MainThreadMessageService)}showMessage(v,s,I,E,u){const C={source:{identifier:v.identifier,label:v.displayName||v.name}};let d;typeof E=="string"||O(E)?d=[E,...u]:(C.modal=E?.modal,C.useCustom=E?.useCustom,C.detail=E?.detail,d=u),C.useCustom&&(0,k.$8G)(v,"resolvers");const n=[];let o=!1;for(let c=0;c<d.length;c++){const h=d[c];if(typeof h=="string")n.push({title:h,handle:c,isCloseAffordance:!1});else if(typeof h=="object"){const{title:i,isCloseAffordance:r}=h;n.push({title:i,isCloseAffordance:!!r,handle:c}),r&&(o?this.b.warn(`[${v.identifier}] Only one message item can have 'isCloseAffordance':`,h):o=!0)}else this.b.warn(`[${v.identifier}] Invalid message item:`,h)}return this.a.$showMessage(s,I,C,n).then(c=>{if(typeof c=="number")return d[c]})}};e.$_pc=R,e.$_pc=R=He([Ge(1,y.$ak)],R)}),define(Ie[260],Pe([1,0,4,15,2,25,5]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=void 0;class N{constructor(s){this.b=new Map,this.a=s.getProxy(R.$vN.MainThreadProfileContentHandlers)}registerProfileContentHandler(s,I,E){if((0,O.$8G)(s,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,E),this.a.$registerProfileContentHandler(I,E.name,E.description,s.identifier.value),(0,w.$Vc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(s,I,E,u){const C=this.b.get(s);if(!C)throw new Error(`Unknown handler with id: ${s}`);return C.saveProfile(I,E,u)}async $readProfile(s,I,E){const u=this.b.get(s);if(!u)throw new Error(`Unknown handler with id: ${s}`);return u.readProfile((0,y.$gg)(I)?I:k.URI.revive(I),E)}}e.$iqc=N}),define(Ie[88],Pe([1,0,5,6,3]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=void 0;class O{constructor(N){this.b=new y.$ne,this.onDidChangePassword=this.b.event,this.a=N.getProxy(w.$vN.MainThreadSecretState)}async $onDidChangePassword(N){this.b.fire(N)}get(N,v){return this.a.$getPassword(N,v)}store(N,v,s){return this.a.$setPassword(N,v,s)}delete(N,v){return this.a.$deletePassword(N,v)}}e.$opc=O,e.$ppc=(0,k.$Gi)("IExtHostSecretState")}),define(Ie[261],Pe([1,0,22,4,5]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=void 0;class O{constructor(N){this.c=new Map,this.d=new Map,this.f=new Map,this.b=N.getProxy(k.$vN.MainThreadSpeech)}async $createSpeechToTextSession(N,v,s){const I=this.c.get(N);if(!I)return;const E=new y.$Wc,u=new w.$ye;this.d.set(v,u);const C=await I.provideSpeechToTextSession(u.token,s?{language:s}:void 0);C&&(E.add(C.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(v,d)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N)}async $createTextToSpeechSession(N,v,s){const I=this.c.get(N);if(!I)return;const E=new y.$Wc,u=new w.$ye;this.d.set(v,u);const C=await I.provideTextToSpeechSession(u.token,s?{language:s}:void 0);C&&(this.f.set(v,C),E.add(C.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(v,d)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(N,v){this.f.get(N)?.synthesize(v)}async $cancelTextToSpeechSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N),this.f.delete(N)}async $createKeywordRecognitionSession(N,v){const s=this.c.get(N);if(!s)return;const I=new y.$Wc,E=new w.$ye;this.d.set(v,E);const u=await s.provideKeywordRecognitionSession(E.token);u&&(I.add(u.onDidChange(C=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(v,C)})),I.add(E.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N)}registerProvider(N,v,s){const I=O.a++;return this.c.set(I,s),this.b.$registerProvider(I,v,{extension:N,displayName:N.value}),(0,y.$Vc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$pqc=O,O.a=1}),define(Ie[89],Pe([1,0,5,6,3]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=e.$epc=void 0;class O{constructor(N,v){this.c=v,this.b=new y.$ne,this.onDidChangeStorage=this.b.event,this.a=N.getProxy(w.$vN.MainThreadStorage)}registerExtensionStorageKeysToSync(N,v){this.a.$registerExtensionStorageKeysToSync(N,v)}async initializeExtensionStorage(N,v,s){const I=await this.a.$initializeExtensionStorage(N,v);let E;return I&&(E=this.d(N,v,I)),E||s}setValue(N,v,s){return this.a.$setValue(N,v,s)}$acceptValue(N,v,s){const I=this.d(N,v,s);I&&this.b.fire({shared:N,key:v,value:I})}d(N,v,s){try{return JSON.parse(s)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${N}): ${I}`)}}}e.$epc=O,e.$fpc=(0,k.$Gi)("IExtHostStorage")}),define(Ie[262],Pe([1,0,4,16,2,5]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=void 0;class R{constructor(v){this.c=new Map,this.b=v.getProxy(O.$vN.MainThreadUriOpeners)}registerExternalUriOpener(v,s,I,E){if(this.c.has(s))throw new Error(`Opener with id '${s}' already registered`);const u=E.schemes.find(C=>!R.a.has(C));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(s,I),this.b.$registerUriOpener(s,E.schemes,v,E.label),(0,w.$Vc)(()=>{this.c.delete(s),this.b.$unregisterUriOpener(s)})}async $canOpenUri(v,s,I){const E=this.c.get(v);if(!E)throw new Error(`Unknown opener with id: ${v}`);const u=k.URI.revive(s);return E.canOpenExternalUri(u,I)}async $openUri(v,s,I){const E=this.c.get(v);if(!E)throw new Error(`Unknown opener id: '${v}'`);return E.openExternalUri(k.URI.revive(s.resolvedUri),{sourceUri:k.URI.revive(s.sourceUri)},I)}}e.$Bqc=R,R.a=new Set([y.Schemas.http,y.Schemas.https])}),define(Ie[263],Pe([1,0,5,2,4,14,19]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cqc=void 0;class N{constructor(s){this.c=new R.$tn,this.d=new Map,this.b=s.getProxy(w.$vN.MainThreadUrls)}registerUriHandler(s,I){const E=s.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const u=N.a++;return this.c.add(E),this.d.set(u,I),this.b.$registerUriHandler(u,E,s.displayName||s.name),(0,k.$Vc)(()=>{this.c.delete(E),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(s,I){const E=this.d.get(s);if(!E)return Promise.resolve(void 0);try{E.handleUri(y.URI.revive(I))}catch(u){(0,O.$3)(u)}return Promise.resolve(void 0)}async createAppUri(s){return y.URI.revive(await this.b.$createAppUri(s))}}e.$Cqc=N,N.a=0}),define(Ie[264],Pe([1,0,23,5]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Itb=O,e.$Jtb=N,y=Ve(y);class k{constructor(){this.buffers=[]}add(s){let I=this.buffers.indexOf(s);return I<0&&(I=this.buffers.length,this.buffers.push(s)),I}}function O(v,s){if(s.serializeBuffersForPostMessage){const I=new k,u=JSON.stringify(v,(d,n)=>{if(n instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(n)};if(ArrayBuffer.isView(n)){const o=R(n);if(o)return{$$vscode_array_buffer_reference$$:!0,index:I.add(n.buffer),view:{type:o,byteLength:n.byteLength,byteOffset:n.byteOffset}}}return n}),C=I.buffers.map(d=>{const n=new Uint8Array(d);return w.$Pe.wrap(n)});return{message:u,buffers:C}}else return{message:JSON.stringify(v),buffers:[]}}function R(v){switch(v.constructor.name){case"Int8Array":return y.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return y.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return y.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return y.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return y.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return y.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return y.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return y.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return y.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return y.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return y.WebviewMessageArrayBufferViewType.BigUint64Array}}function N(v,s){const I=s.map(C=>{const d=new ArrayBuffer(C.byteLength);return new Uint8Array(d).set(C.buffer),d}),E=s.length?(C,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const n=d,{index:o}=n,c=I[o];if(n.view)switch(n.view.type){case y.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(c,n.view.byteOffset,n.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(c,n.view.byteOffset,n.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(c,n.view.byteOffset,n.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(c,n.view.byteOffset,n.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(c,n.view.byteOffset,n.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(c,n.view.byteOffset,n.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(c,n.view.byteOffset,n.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(c,n.view.byteOffset,n.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(c,n.view.byteOffset,n.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(c,n.view.byteOffset,n.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case y.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(c,n.view.byteOffset,n.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return d}:void 0;return{message:JSON.parse(v,E),arrayBuffers:I}}});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[68],Pe([1,0,6,4,16,26,2,216,264,83,5]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";var E,u,C,d,n,o,c,h,i,r,t,a,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=e.$2oc=void 0,e.$3oc=m,e.$5oc=D,e.$6oc=b,O=Ve(O),I=Ve(I);class g{constructor(f,M,L,K,J,z,A){E.set(this,void 0),u.set(this,void 0),C.set(this,void 0),d.set(this,void 0),n.set(this,void 0),o.set(this,void 0),c.set(this,""),h.set(this,void 0),i.set(this,!1),r.set(this,!1),t.set(this,void 0),a.set(this,void 0),this._onMessageEmitter=new w.$ne,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new w.$ne),this._onDidDispose=ze(this,l,"f").event,rt(this,E,f,"f"),rt(this,u,M,"f"),rt(this,h,L,"f"),rt(this,d,K,"f"),rt(this,n,J,"f"),rt(this,o,z,"f"),rt(this,t,m(z),"f"),rt(this,a,$(z),"f"),rt(this,C,A,"f")}dispose(){rt(this,i,!0,"f"),ze(this,l,"f").fire(),ze(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return rt(this,r,!0,"f"),(0,s.$qDb)(f,ze(this,d,"f"))}get cspSource(){const f=ze(this,o,"f").extensionLocation;if(f.scheme===k.Schemas.https||f.scheme===k.Schemas.http){let M=f.toString();return M.endsWith("/")||(M+="/"),M+" "+s.$pDb}return s.$pDb}get html(){return this.a(),ze(this,c,"f")}set html(f){this.a(),ze(this,c,"f")!==f&&(rt(this,c,f,"f"),ze(this,a,"f")&&!ze(this,r,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(rt(this,r,!0,"f"),ze(this,C,"f").report("Webview vscode-resource: uris",ze(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),ze(this,u,"f").$setHtml(ze(this,E,"f"),this.b(f)))}get options(){return this.a(),ze(this,h,"f")}set options(f){this.a(),O.$jo(ze(this,h,"f"),f)||ze(this,u,"f").$setOptions(ze(this,E,"f"),b(ze(this,o,"f"),ze(this,n,"f"),f)),rt(this,h,f,"f")}async postMessage(f){if(ze(this,i,"f"))return!1;const M=(0,v.$Itb)(f,{serializeBuffersForPostMessage:ze(this,t,"f")});return ze(this,u,"f").$postMessage(ze(this,E,"f"),M.message,...M.buffers)}a(){if(ze(this,i,"f"))throw new Error("Webview is disposed")}b(f){if(!ze(this,a,"f"))return f;const M=ze(this,o,"f").extensionLocation?.scheme===k.Schemas.vscodeRemote,L=ze(this,o,"f").extensionLocation.scheme===k.Schemas.vscodeRemote?ze(this,o,"f").extensionLocation.authority:void 0;return f.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,J,z,A,W,Z)=>{const he=R.URI.from({scheme:A||"file",path:decodeURIComponent(W)}),ve=(0,s.$qDb)(he,{isRemote:M,authority:L}).toString();return`${J}${ve}${Z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,J,z,A,W,Z)=>{const he=R.URI.from({scheme:A||"file",path:decodeURIComponent(W)}),ve=(0,s.$qDb)(he,{isRemote:M,authority:L}).toString();return`${J}${ve}${Z}`})}}e.$2oc=g,E=new WeakMap,u=new WeakMap,C=new WeakMap,d=new WeakMap,n=new WeakMap,o=new WeakMap,c=new WeakMap,h=new WeakMap,i=new WeakMap,r=new WeakMap,t=new WeakMap,a=new WeakMap,l=new WeakMap;function m(p){try{const f=(0,N.$1p)((0,N.$Zp)(p.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}function $(p){try{const f=(0,N.$1p)((0,N.$Zp)(p.engines.vscode));return f?f.majorBase<1||f.majorBase===1&&f.minorBase<60:!1}catch{return!1}}class S extends y.$Xc{constructor(f,M,L,K,J){super(),this.c=M,this.f=L,this.g=K,this.h=J,this.b=new Map,this.a=f.getProxy(I.$vN.MainThreadWebviews)}dispose(){super.dispose();for(const f of this.b.values())f.dispose();this.b.clear()}$onMessage(f,M,L){const K=this.j(f);if(K){const{message:J}=(0,v.$Jtb)(M,L.value);K._onMessageEmitter.fire(J)}}$onMissingCsp(f,M){this.g.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,M,L){const K=new g(f,this.a,T(M),this.c,this.f,L,this.h);this.b.set(f,K);const J=K._onDidDispose(()=>{J.dispose(),this.deleteWebview(f)});return K}deleteWebview(f){this.b.delete(f)}j(f){return this.b.get(f)}}e.$4oc=S;function D(p){return{id:p.identifier,location:p.extensionLocation}}function b(p,f,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||P(p,f)}}function T(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(f=>R.URI.from(f))}}function P(p,f){return[...(f?.getWorkspaceFolders()||[]).map(M=>M.uri),p.extensionLocation]}}),define(Ie[121],Pe([1,0,6,16,13,2,3,17,5]),function(_,e,w,y,k,O,R,N,v){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=e.$Eqc=void 0;let I=s=class{getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new w.$ne,this.onDidChangeWindowState=this.c.event,this.d=s.a,this.b=u.getProxy(v.$vN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:C,isActive:d})=>{this.onDidChangeWindowProperty("focused",C),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,C){C!==this.d[u]&&(this.d={...this.d,[u]:C},this.c.fire(this.d))}openUri(u,C){let d;if(typeof u=="string"){d=u;try{u=O.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,k.$ef)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,d,C)}async asExternalUri(u,C){if((0,k.$ef)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(u,C);return O.URI.from(d)}};e.$Eqc=I,I.a={focused:!0,active:!0},e.$Eqc=I=s=He([Ge(0,N.$2P)],I),e.$Fqc=(0,R.$Gi)("IExtHostWindow")}),define(Ie[265],Pe([1,0,254,27,17]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ssc=void 0;let O=class extends w.$Iqc{constructor(N,v){super(N,v)}f(N,v,s){v.apply(console,s)}};e.$Ssc=O,e.$Ssc=O=He([Ge(0,k.$2P),Ge(1,y.$fQ)],O)}),define(Ie[266],Pe([1,0,11,23,22,28,14,6,4,37,149,252,39]),function(_,e,w,y,k,O,R,N,v,s,I,E,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.ResponsiveState=e.RequestInitiator=void 0,e.$7cc=h,e.$8cc=i,R=Ve(R);function d(M,L){try{return JSON.stringify(M,L)}catch{return"null"}}const n="$$ref$$",o={[n]:-1};class c{constructor(L,K){this.jsonString=L,this.referencedBuffers=K}}function h(M,L=null,K=!1){const J=[];return{jsonString:(K?d:JSON.stringify)(M,(A,W)=>{if(typeof W>"u")return o;if(typeof W=="object"){if(W instanceof y.$Pe){const Z=J.push(W)-1;return{[n]:Z}}if(L)return L(A,W)}return W}),referencedBuffers:J}}function i(M,L,K){return JSON.parse(M,(J,z)=>{if(z){const A=z[n];if(typeof A=="number")return L[A];if(K&&z.$mid===s.MarshalledId.Uri)return K.transformIncoming(z)}return z})}function r(M,L){return JSON.stringify(M,L)}function t(M){return M?(L,K)=>K&&K.$mid===s.MarshalledId.Uri?M.transformOutgoing(K):K:null}var a;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var l;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const g=()=>{},m=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class S extends v.$Xc{constructor(L,K=null,J=null){super(),this[C]=!0,this.b=this.B(new N.$ne),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=K,this.g=J,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,A=u.$Sw.count;z<A;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=l.Responsive,this.z=0,this.C=0,this.D=this.B(new w.$Sh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const K=this.w[L];delete this.w[L],K.resolveErr(R.$9())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+S.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+S.a,this.z--,this.z===0&&this.D.cancel(),this.I(l.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(l.Unresponsive):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,I.$Qn)(L,this.g):L}getProxy(L){const{nid:K,sid:J}=L;return this.s[K]||(this.s[K]=this.J(K,J)),this.s[K]}J(L,K){const J={get:(z,A)=>(typeof A=="string"&&!z[A]&&A.charCodeAt(0)===O.CharCode.DollarSign&&(z[A]=(...W)=>this.U(L,A,W)),A===$?K:z[A])};return new Proxy(Object.create(null),J)}set(L,K){return this.m[L.nid]=K,K}assertRegistered(L){for(let K=0,J=L.length;K<J;K++){const z=L[K];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(L){if(this.j)return;const K=L.byteLength,J=b.read(L,0),z=J.readUInt8(),A=J.readUInt32();switch(z){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:W,method:Z,args:he}=P.deserializeRequestJSONArgs(J);this.g&&(he=(0,I.$Qn)(he,this.g)),this.M(K,A,W,Z,he,z===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:W,method:Z,args:he}=P.deserializeRequestMixedArgs(J);this.g&&(he=(0,I.$Qn)(he,this.g)),this.M(K,A,W,Z,he,z===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(K,A,a.LocalSide,"ack"),this.G(A);break}case p.Cancel:{this.N(K,A);break}case p.ReplyOKEmpty:{this.O(K,A,void 0);break}case p.ReplyOKJSON:{let W=P.deserializeReplyOKJSON(J);this.g&&(W=(0,I.$Qn)(W,this.g)),this.O(K,A,W);break}case p.ReplyOKJSONWithBuffers:{const W=P.deserializeReplyOKJSONWithBuffers(J,this.g);this.O(K,A,W);break}case p.ReplyOKVSBuffer:{const W=P.deserializeReplyOKVSBuffer(J);this.O(K,A,W);break}case p.ReplyErrError:{let W=P.deserializeReplyErrError(J);this.g&&(W=(0,I.$Qn)(W,this.g)),this.P(K,A,W);break}case p.ReplyErrEmpty:{this.P(K,A,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,K,J,z,A,W){this.f?.logIncoming(L,K,a.OtherSide,`receiveRequest ${(0,u.$Uw)(J)}.${z}(`,A);const Z=String(K);let he,ve;if(W){const de=new k.$ye;A.push(de.token),he=this.Q(J,z,A),ve=()=>de.cancel()}else he=this.Q(J,z,A),ve=g;this.u[Z]=ve;const be=P.serializeAcknowledged(K);this.f?.logOutgoing(be.byteLength,K,a.OtherSide,"ack"),this.c.send(be),he.then(de=>{delete this.u[Z];const $e=P.serializeReplyOK(K,de,this.h);this.f?.logOutgoing($e.byteLength,K,a.OtherSide,"reply:",de),this.c.send($e)},de=>{delete this.u[Z];const $e=P.serializeReplyErr(K,de);this.f?.logOutgoing($e.byteLength,K,a.OtherSide,"replyErr:",de),this.c.send($e)})}N(L,K){this.f?.logIncoming(L,K,a.OtherSide,"receiveCancel");const J=String(K);this.u[J]?.()}O(L,K,J){this.f?.logIncoming(L,K,a.LocalSide,"receiveReply:",J);const z=String(K);if(!this.w.hasOwnProperty(z))return;const A=this.w[z];delete this.w[z],A.resolveOk(J)}P(L,K,J){this.f?.logIncoming(L,K,a.LocalSide,"receiveReplyErr:",J);const z=String(K);if(!this.w.hasOwnProperty(z))return;const A=this.w[z];delete this.w[z];let W;J&&(J.$isError?(W=new Error,W.name=J.name,W.message=J.message,W.stack=J.stack):W=J),A.resolveErr(W)}Q(L,K,J){try{return Promise.resolve(this.S(L,K,J))}catch(z){return Promise.reject(z)}}S(L,K,J){const z=this.m[L];if(!z)throw new Error("Unknown actor "+(0,u.$Uw)(L));const A=z[K];if(typeof A!="function")throw new Error("Unknown method "+K+" on actor "+(0,u.$Uw)(L));return A.apply(z,J)}U(L,K,J){if(this.j)return new E.$6cc;let z=null;if(J.length>0&&k.CancellationToken.isCancellationToken(J[J.length-1])&&(z=J.pop()),z&&z.isCancellationRequested)return Promise.reject(R.$9());const A=P.serializeRequestArguments(J,this.h),W=++this.t,Z=String(W),he=new E.$5cc,ve=new v.$Wc;z&&ve.add(z.onCancellationRequested(()=>{const de=P.serializeCancel(W);this.f?.logOutgoing(de.byteLength,W,a.LocalSide,"cancel"),this.c.send(P.serializeCancel(W))})),this.w[Z]=new D(he,ve),this.F(W);const be=P.serializeRequest(W,L,K,A,!!z);return this.f?.logOutgoing(be.byteLength,W,a.LocalSide,`request: ${(0,u.$Uw)(L)}.${K}(`,J),this.c.send(be),he}}e.$9cc=S,C=m,S.a=3*1e3;class D{constructor(L,K){this.a=L,this.b=K}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class b{static alloc(L,K,J){const z=new b(y.$Pe.alloc(J+1+4),0);return z.writeUInt8(L),z.writeUInt32(K),z}static read(L,K){return new b(L,K)}get buffer(){return this.a}constructor(L,K){this.a=L,this.b=K}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+L).toString();return this.b+=L,J}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+L).toString();return this.b+=L,J}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+L);return this.b+=L,K}static sizeMixedArray(L){let K=0;K+=1;for(let J=0,z=L.length;J<z;J++){const A=L[J];switch(K+=1,A.type){case f.String:K+=this.sizeLongString(A.value);break;case f.VSBuffer:K+=this.sizeVSBuffer(A.value);break;case f.SerializedObjectWithBuffers:K+=this.sizeUInt32,K+=this.sizeLongString(A.value);for(let W=0;W<A.buffers.length;++W)K+=this.sizeVSBuffer(A.buffers[W]);break;case f.Undefined:break}}return K}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let K=0,J=L.length;K<J;K++){const z=L[K];switch(z.type){case f.String:this.writeUInt8(f.String),this.writeLongString(z.value);break;case f.VSBuffer:this.writeUInt8(f.VSBuffer),this.writeVSBuffer(z.value);break;case f.SerializedObjectWithBuffers:this.writeUInt8(f.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let A=0;A<z.buffers.length;++A)this.writeBuffer(z.buffers[A]);break;case f.Undefined:this.writeUInt8(f.Undefined);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const K=new Array(L);for(let J=0;J<L;J++)switch(this.readUInt8()){case f.String:K[J]=this.readLongString();break;case f.VSBuffer:K[J]=this.readVSBuffer();break;case f.SerializedObjectWithBuffers:{const A=this.readUInt32(),W=this.readLongString(),Z=[];for(let he=0;he<A;++he)Z.push(this.readVSBuffer());K[J]=new u.$Vw(i(W,Z,null));break}case f.Undefined:K[J]=void 0;break}return K}}b.sizeUInt32=4;var T;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(T||(T={}));class P{static a(L){for(let K=0,J=L.length;K<J;K++)if(L[K]instanceof y.$Pe||L[K]instanceof u.$Vw||typeof L[K]>"u")return!0;return!1}static serializeRequestArguments(L,K){if(this.a(L)){const J=[];for(let z=0,A=L.length;z<A;z++){const W=L[z];if(W instanceof y.$Pe)J[z]={type:f.VSBuffer,value:W};else if(typeof W>"u")J[z]={type:f.Undefined};else if(W instanceof u.$Vw){const{jsonString:Z,referencedBuffers:he}=h(W.value,K);J[z]={type:f.SerializedObjectWithBuffers,value:y.$Pe.fromString(Z),buffers:he}}else J[z]={type:f.String,value:y.$Pe.fromString(r(W,K))}}return{type:T.Mixed,args:J}}return{type:T.Simple,args:r(L,K)}}static serializeRequest(L,K,J,z,A){switch(z.type){case T.Simple:return this.b(L,K,J,z.args,A);case T.Mixed:return this.c(L,K,J,z.args,A)}}static b(L,K,J,z,A){const W=y.$Pe.fromString(J),Z=y.$Pe.fromString(z);let he=0;he+=b.sizeUInt8(),he+=b.sizeShortString(W),he+=b.sizeLongString(Z);const ve=b.alloc(A?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,L,he);return ve.writeUInt8(K),ve.writeShortString(W),ve.writeLongString(Z),ve.buffer}static deserializeRequestJSONArgs(L){const K=L.readUInt8(),J=L.readShortString(),z=L.readLongString();return{rpcId:K,method:J,args:JSON.parse(z)}}static c(L,K,J,z,A){const W=y.$Pe.fromString(J);let Z=0;Z+=b.sizeUInt8(),Z+=b.sizeShortString(W),Z+=b.sizeMixedArray(z);const he=b.alloc(A?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,L,Z);return he.writeUInt8(K),he.writeShortString(W),he.writeMixedArray(z),he.buffer}static deserializeRequestMixedArgs(L){const K=L.readUInt8(),J=L.readShortString(),z=L.readMixedArray(),A=new Array(z.length);for(let W=0,Z=z.length;W<Z;W++){const he=z[W];typeof he=="string"?A[W]=JSON.parse(he):A[W]=he}return{rpcId:K,method:J,args:A}}static serializeAcknowledged(L){return b.alloc(p.Acknowledged,L,0).buffer}static serializeCancel(L){return b.alloc(p.Cancel,L,0).buffer}static serializeReplyOK(L,K,J){if(typeof K>"u")return this.d(L);if(K instanceof y.$Pe)return this.e(L,K);if(K instanceof u.$Vw){const{jsonString:z,referencedBuffers:A}=h(K.value,J,!0);return this.g(L,z,A)}else return this.f(L,d(K,J))}static d(L){return b.alloc(p.ReplyOKEmpty,L,0).buffer}static e(L,K){let J=0;J+=b.sizeVSBuffer(K);const z=b.alloc(p.ReplyOKVSBuffer,L,J);return z.writeVSBuffer(K),z.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,K){const J=y.$Pe.fromString(K);let z=0;z+=b.sizeLongString(J);const A=b.alloc(p.ReplyOKJSON,L,z);return A.writeLongString(J),A.buffer}static g(L,K,J){const z=y.$Pe.fromString(K);let A=0;A+=b.sizeUInt32,A+=b.sizeLongString(z);for(const Z of J)A+=b.sizeVSBuffer(Z);const W=b.alloc(p.ReplyOKJSONWithBuffers,L,A);W.writeUInt32(J.length),W.writeLongString(z);for(const Z of J)W.writeBuffer(Z);return W.buffer}static deserializeReplyOKJSON(L){const K=L.readLongString();return JSON.parse(K)}static deserializeReplyOKJSONWithBuffers(L,K){const J=L.readUInt32(),z=L.readLongString(),A=[];for(let W=0;W<J;++W)A.push(L.readVSBuffer());return new u.$Vw(i(z,A,K))}static serializeReplyErr(L,K){const J=K?d(R.$5(K),null):void 0;if(typeof J!="string")return this.h(L);const z=y.$Pe.fromString(J);let A=0;A+=b.sizeLongString(z);const W=b.alloc(p.ReplyErrError,L,A);return W.writeLongString(z),W.buffer}static deserializeReplyErrError(L){const K=L.readLongString();return JSON.parse(K)}static h(L){return b.alloc(p.ReplyErrEmpty,L,0).buffer}}var p;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var f;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(f||(f={}))}),define(Ie[267],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Usc=void 0;const w=function(O){const R=N=>{globalThis.removeEventListener("message",R);const v=N.data;Object.defineProperties(globalThis,{postMessage:{value(s,I){v.postMessage(s,I)}},onmessage:{get(){return v.onmessage},set(s){v.onmessage=s}}}),v.addEventListener("message",s=>{globalThis.dispatchEvent(new MessageEvent("message",{data:s.data,ports:s.ports?[...s.ports]:void 0}))}),v.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",R)}.toString();class y extends EventTarget{constructor(O,R,N){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const v=`((${w})('${R}'))`,s=new Blob([v],{type:"application/javascript"}),I=URL.createObjectURL(s),E=new MessageChannel,u=I,C={type:"_newWorker",id:u,port:E.port2,url:I,options:N};O(C,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(I),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(d){E.port1.onmessage=d}},onmessageerror:{get(){return E.port1.onmessageerror},set(d){E.port1.onmessageerror=d}}}),E.port1.addEventListener("messageerror",d=>{const n=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(n)}),E.port1.addEventListener("message",d=>{const n=new MessageEvent("message",{data:d.data});this.dispatchEvent(n)}),E.port1.start()}}e.$Usc=y}),define(Ie[268],Pe([1,0,23,29,16,61,3]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.$fL=void 0,e.$gL=I,e.$hL=E,e.$fL=(0,R.$Gi)("notebookDocumentService");const N=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${N.join("")}]+`),s=7;function I(C){if(C.scheme!==k.Schemas.vscodeNotebookCell)return;const d=C.fragment.indexOf("s");if(d<0)return;const n=parseInt(C.fragment.substring(0,d).replace(v,""),s),o=(0,w.$9e)(C.fragment.substring(d+1)).toString();if(!isNaN(n))return{handle:n,notebook:C.with({scheme:o,fragment:null})}}function E(C,d){const n=d.toString(s),c=`${n.length<N.length?N[n.length-1]:"z"}${n}s${(0,w.$0e)(w.$Pe.fromString(C.scheme),!0,!0)}`;return C.with({scheme:k.Schemas.vscodeNotebookCell,fragment:c})}class u{constructor(){this.a=new y.$Dc}getNotebook(d){if(d.scheme===k.Schemas.vscodeNotebookCell){const n=I(d);if(n){const o=this.a.get(n.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$iL=u,(0,O.$Qs)(e.$fL,u,O.InstantiationType.Delayed)}),define(Ie[90],Pe([1,0,23,41,40,73,16,20,21,32,268]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=e.$zL=e.CellStatusbarAlignment=e.$yL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$vL=e.$uL=e.$sL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$rL=e.$qL=e.$pL=e.$oL=e.CellKind=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=void 0,e.$tL=l,e.$wL=$,e.$xL=S,e.$AL=T,e.$BL=p,y=Ve(y),e.$jL="workbench.editor.notebook",e.$kL="workbench.editor.notebookTextDiffEditor",e.$lL="workbench.editor.interactive",e.$mL="workbench.editor.repl",e.$nL="replNotebook.input.execute";var E;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(E||(e.CellKind=E={})),e.$oL=["application/json","application/javascript","text/html","image/svg+xml",O.$0s.latex,O.$0s.markdown,"image/png","image/jpeg",O.$0s.text],e.$pL=[O.$0s.latex,O.$0s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$0s.text],e.$qL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$rL="_notAvailable";var u;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var C;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(C||(e.NotebookCellExecutionState=C={}));var d;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var n;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var o;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var c;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var h;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var i;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(Z){Z.scheme=R.Schemas.vscodeNotebookCell;function he(Y,we){return(0,I.$hL)(Y,we)}Z.generate=he;function ve(Y){return(0,I.$gL)(Y)}Z.parse=ve;function be(Y,we){return Y.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${we??""},${Y.scheme!==R.Schemas.file?Y.scheme:""}`})}Z.generateCellOutputUri=be;function de(Y){if(Y.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const we=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!we)return;const Te=we[1]&&we[1]!==""?we[1]:void 0,re=we[2];return{outputId:Te,notebook:Y.with({scheme:re||R.Schemas.file,fragment:null})}}Z.parseCellOutputUri=de;function $e(Y,we,Te){return Z.generate(Y,we).with({scheme:Te})}Z.generateCellPropertyUri=$e;function ye(Y,we){if(Y.scheme===we)return Z.parse(Y.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=ye})(r||(e.CellUri=r={}));const t=Z=>v.$c?Z.replace(/\//g,"\\"):Z;class a{constructor(he=[],ve=e.$oL){this.e=ve,this.d=[...new Set(he)].map(be=>({pattern:be,matches:y.$Ak(t(be))}))}sort(he){const ve=new Map(k.Iterable.map(he,de=>[de,t(de)]));let be=[];for(const{matches:de}of this.d)for(const[$e,ye]of ve)if(de(ye)){be.push($e),ve.delete($e);break}return ve.size&&(be=be.concat([...ve.keys()].sort((de,$e)=>this.e.indexOf(de)-this.e.indexOf($e)))),be}prioritize(he,ve){const be=this.f(he);if(be===-1){this.d.unshift({pattern:he,matches:y.$Ak(t(he))});return}const de=new Set(ve.map(ye=>this.f(ye,be)));de.delete(-1);const $e=Array.from(de).sort();this.d.splice(be+1,0,...$e.map(ye=>this.d[ye]));for(let ye=$e.length-1;ye>=0;ye--)this.d.splice($e[ye],1)}toArray(){return this.d.map(he=>he.pattern)}f(he,ve=this.d.length){const be=t(he);for(let de=0;de<ve;de++)if(this.d[de].matches(be))return de;return-1}}e.$sL=a;function l(Z,he,ve,be=(de,$e)=>de===$e){const de=[];function $e(we,Te,re){if(Te===0&&re.length===0)return;const q=de[de.length-1];q&&q.start+q.deleteCount===we?(q.deleteCount+=Te,q.toInsert.push(...re)):de.push({start:we,deleteCount:Te,toInsert:re})}let ye=0,Y=0;for(;;){if(ye===Z.length){$e(ye,0,he.slice(Y));break}if(Y===he.length){$e(ye,Z.length-ye,[]);break}const we=Z[ye],Te=he[Y];if(be(we,Te)){ye+=1,Y+=1;continue}ve(Te)?($e(ye,1,[]),ye+=1):($e(ye,0,[Te]),Y+=1)}return de}e.$uL=new s.$Xj("notebookEditorCursorAtBoundary","none"),e.$vL=new s.$Xj("notebookEditorCursorAtLineBoundary","none");var g;(function(Z){Z.default="default",Z.option="option"})(g||(e.NotebookEditorPriority=g={}));var m;(function(Z){Z.Cells="cells",Z.Text="text",Z.None="none"})(m||(e.NotebookFindScopeType=m={}));function $(Z){const he=Z;return!!((typeof he.include=="string"||y.$Bk(he.include))&&(typeof he.exclude=="string"||y.$Bk(he.exclude)))}function S(Z,he,ve){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(he)>=0||Z.viewType===he)return!0;if(Z.filenamePattern){const be=$(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,de=$(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(y.$zk(be,(0,N.$qc)(ve.fsPath).toLowerCase()))return!(de&&y.$zk(de,(0,N.$qc)(ve.fsPath).toLowerCase()))}return!1}e.$yL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class b{static create(he){return`${b.d}${he}`}static parse(he){if(he.startsWith(b.d))return he.substring(b.d.length)}}e.$zL=b,b.d="notebook/";function T(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}const P=new TextDecoder;function p(Z){const he=[];let ve=!1;for(const ye of Z)(he.length===0||ve)&&(he.push(ye),ve=!0);let be=L(he);const de=w.$Pe.concat(he.map(ye=>w.$Pe.wrap(ye))),$e=W(de);return be=be||$e.byteLength!==de.byteLength,{data:$e,didCompression:be}}e.$CL="\x1B[A";const f=e.$CL.split("").map(Z=>Z.charCodeAt(0)),M=10;function L(Z){let he=!1;return Z.forEach((ve,be)=>{if(be===0||ve.length<e.$CL.length)return;const de=Z[be-1],$e=ve.subarray(0,e.$CL.length);if($e[0]===f[0]&&$e[1]===f[1]&&$e[2]===f[2]){const ye=de.lastIndexOf(M);if(ye===-1)return;he=!0,Z[be-1]=de.subarray(0,ye),Z[be]=ve.subarray(e.$CL.length)}}),he}function K(Z){let he=Z;do Z=he,he=Z.replace(/[^\n]\x08/gm,"");while(he.length<Z.length);return Z}function J(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const he=Z.match(/^(.*)\r+/m)[1];let ve=Z.match(/\r+(.*)$/m)[1];ve=ve+he.slice(ve.length,he.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ve)}return Z}const z=8,A=13;function W(Z){return!Z.buffer.includes(z)&&!Z.buffer.includes(A)?Z:w.$Pe.fromString(J(K(P.decode(Z.buffer))))}});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[7],Pe([1,0,18,14,60,29,73,13,15,2,38,19,30,110,90]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d){"use strict";var n,o,c,h,i,r,t,a,l,g,m,$,S,D,b,T,P,p,f,M,L,K,J,z,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$QP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=e.$KP=e.$JP=e.$IP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$tP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$sP=e.$rP=e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$gP=e.$fP=e.$eP=e.$dP=e.$bP=e.$aP=e.$_O=e.$$O=e.TestRunProfileKind=e.TestResultState=e.$0O=e.$9O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$8O=e.NotebookVariablesRequestKind=e.$7O=e.$6O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$5O=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.ColorThemeKind=e.$YO=e.$XO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$WO=e.$VO=e.DebugConsoleMode=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PO=e.$OO=e.FileChangeType=e.$NO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$MO=e.$LO=e.$KO=e.$JO=e.InlineCompletionTriggerKind=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$wO=e.ConfigurationTarget=e.$vO=e.$uO=e.$tO=e.$sO=e.DocumentPasteTriggerKind=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$lO=e.ViewBadge=e.ProgressLocation=e.$kO=e.$jO=e.TaskScope=e.ShellQuoting=e.$iO=e.$hO=e.$gO=e.TaskPanelKind=e.TaskRevealKind=e.$fO=e.TerminalLocation=e.$eO=e.$dO=e.$cO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$bO=e.$aO=e.$_N=e.$$N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$9N=e.$8N=e.$7N=e.$6N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$5N=e.$4N=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.LanguageStatusSeverity=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.CodeActionTriggerKind=e.$RN=e.$QN=e.SymbolTag=e.SymbolKind=e.$PN=e.$ON=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.DiagnosticSeverity=e.DiagnosticTag=e.$IN=e.$HN=e.FileEditType=e.$GN=e.$FN=e.$EN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$0N=xe,e.$xO=De,e.$cP=Mn;function W(j){return Object.assign(j,{apply:function(...se){if(se.length===0)return Reflect.construct(j,[]);{const Ce=se.length===1?[]:se[1];return Reflect.construct(j,Ce,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(j,[]);{const[Ce,...Je]=se;return Reflect.construct(j,Je,Ce.constructor)}}})}var Z;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(Z||(e.TerminalOutputAnchor=Z={}));var he;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(he||(e.TerminalQuickFixType=he={}));let ve=l=class{static from(...F){let se=F;return new l(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}constructor(F){n.set(this,void 0),rt(this,n,F,"f")}dispose(){typeof ze(this,n,"f")=="function"&&(ze(this,n,"f").call(this),rt(this,n,void 0,"f"))}};e.$xN=ve,n=new WeakMap,e.$xN=ve=l=He([W],ve);let be=g=class{static Min(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let Ce=1;Ce<F.length;Ce++){const Je=F[Ce];Je.isBefore(se)&&(se=Je)}return se}static Max(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let Ce=1;Ce<F.length;Ce++){const Je=F[Ce];Je.isAfter(se)&&(se=Je)}return se}static isPosition(F){if(!F)return!1;if(F instanceof g)return!0;const{line:se,character:Ce}=F;return typeof se=="number"&&typeof Ce=="number"}static of(F){if(F instanceof g)return F;if(this.isPosition(F))return new g(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,se){if(F<0)throw(0,y.$0)("line must be non-negative");if(se<0)throw(0,y.$0)("character must be non-negative");this.c=F,this.e=se}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,se=0){if(F===null||se===null)throw(0,y.$0)();let Ce;return typeof F>"u"?Ce=0:typeof F=="number"?Ce=F:(Ce=typeof F.lineDelta=="number"?F.lineDelta:0,se=typeof F.characterDelta=="number"?F.characterDelta:0),Ce===0&&se===0?this:new g(this.line+Ce,this.character+se)}with(F,se=this.character){if(F===null||se===null)throw(0,y.$0)();let Ce;return typeof F>"u"?Ce=this.line:typeof F=="number"?Ce=F:(Ce=typeof F.line=="number"?F.line:this.line,se=typeof F.character=="number"?F.character:this.character),Ce===this.line&&se===this.character?this:new g(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};e.$yN=be,e.$yN=be=g=He([W],be);let de=m=class{static isRange(F){return F instanceof m?!0:F?be.isPosition(F.start)&&be.isPosition(F.end):!1}static of(F){if(F instanceof m)return F;if(this.isRange(F))return new m(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,se,Ce,Je){let nt,gt;if(typeof F=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Je=="number"?(nt=new be(F,se),gt=new be(Ce,Je)):be.isPosition(F)&&be.isPosition(se)&&(nt=be.of(F),gt=be.of(se)),!nt||!gt)throw new Error("Invalid arguments");nt.isBefore(gt)?(this.c=nt,this.e=gt):(this.c=gt,this.e=nt)}contains(F){return m.isRange(F)?this.contains(F.start)&&this.contains(F.end):be.isPosition(F)?!(be.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const se=be.Max(F.start,this.c),Ce=be.Min(F.end,this.e);if(!se.isAfter(Ce))return new m(se,Ce)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const se=be.Min(F.start,this.c),Ce=be.Max(F.end,this.end);return new m(se,Ce)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,se=this.end){if(F===null||se===null)throw(0,y.$0)();let Ce;return F?be.isPosition(F)?Ce=F:(Ce=F.start||this.start,se=F.end||this.end):Ce=this.start,Ce.isEqual(this.c)&&se.isEqual(this.end)?this:new m(Ce,se)}toJSON(){return[this.start,this.end]}};e.$zN=de,e.$zN=de=m=He([W],de);let $e=$=class extends de{static isSelection(F){return F instanceof $?!0:F?de.isRange(F)&&be.isPosition(F.anchor)&&be.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,se,Ce,Je){let nt,gt;if(typeof F=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Je=="number"?(nt=new be(F,se),gt=new be(Ce,Je)):be.isPosition(F)&&be.isPosition(se)&&(nt=be.of(F),gt=be.of(se)),!nt||!gt)throw new Error("Invalid arguments");super(nt,gt),this.f=nt,this.g=gt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$AN=$e,e.$AN=$e=$=He([W],$e);const ye=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,y.$0)("connectionToken")};class Y{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se,Ce){if(typeof F!="string"||F.length===0)throw(0,y.$0)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,y.$0)("port");typeof Ce<"u"&&ye(Ce),this.host=F,this.port=Math.round(se),this.connectionToken=Ce}}e.$BN=Y;class we{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se){this.makeConnection=F,this.connectionToken=se,typeof se<"u"&&ye(se)}}e.$CN=we;class Te extends Error{static NotAvailable(F,se){return new Te(F,C.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(F){return new Te(F,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,se=C.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(F),this._message=F,this._code=se,this._detail=Ce,Object.setPrototypeOf(this,Te.prototype)}}e.$DN=Te;var re;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(re||(e.EndOfLine=re={}));var q;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(q||(e.EnvironmentVariableMutatorType=q={}));let ae=S=class{static isTextEdit(F){return F instanceof S?!0:F?de.isRange(F)&&typeof F.newText=="string":!1}static replace(F,se){return new S(F,se)}static insert(F,se){return S.replace(new de(F,F),se)}static delete(F){return S.replace(F,"")}static setEndOfLine(F){const se=new S(new de(new be(0,0),new be(0,0)),"");return se.newEol=F,se}get range(){return this.c}set range(F){if(F&&!de.isRange(F))throw(0,y.$0)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,y.$0)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,y.$0)("newEol");this.f=F}constructor(F,se){this.c=F,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$EN=ae,e.$EN=ae=S=He([W],ae);let le=D=class{static isNotebookCellEdit(F){return F instanceof D?!0:F?Si.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,se){return new D(F,se)}static insertCells(F,se){return new D(new Si(F,F),se)}static deleteCells(F){return new D(F,[])}static updateCellMetadata(F,se){const Ce=new D(new Si(F,F),[]);return Ce.newCellMetadata=se,Ce}static updateNotebookMetadata(F){const se=new D(new Si(0,0),[]);return se.newNotebookMetadata=F,se}constructor(F,se){this.range=F,this.newCells=se}};e.$FN=le,e.$FN=le=D=He([W],le);class ne{static isSnippetTextEdit(F){return F instanceof ne?!0:F?de.isRange(F.range)&&H.isSnippetString(F.snippet):!1}static replace(F,se){return new ne(F,se)}static insert(F,se){return ne.replace(new de(F,F),se)}constructor(F,se){this.range=F,this.snippet=se}}e.$GN=ne;var ce;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ce||(e.FileEditType=ce={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,se,Ce,Je){this.c.push({_type:ce.File,from:F,to:se,options:Ce,metadata:Je})}createFile(F,se,Ce){this.c.push({_type:ce.File,from:void 0,to:F,options:se,metadata:Ce})}deleteFile(F,se,Ce){this.c.push({_type:ce.File,from:F,to:void 0,options:se,metadata:Ce})}e(F,se,Ce){this.c.push({_type:ce.Cell,metadata:Ce,uri:F,edit:{editType:d.CellEditType.DocumentMetadata,metadata:se},notebookMetadata:se})}f(F,se,Ce,Je){const nt=se.start,gt=se.end;(nt!==gt||Ce.length>0)&&this.c.push({_type:ce.CellReplace,uri:F,index:nt,count:gt-nt,cells:Ce,metadata:Je})}g(F,se,Ce,Je){this.c.push({_type:ce.Cell,metadata:Je,uri:F,edit:{editType:d.CellEditType.Metadata,index:se,metadata:Ce}})}replace(F,se,Ce,Je){this.c.push({_type:ce.Text,uri:F,edit:new ae(se,Ce),metadata:Je})}insert(F,se,Ce,Je){this.replace(F,new de(se,se),Ce,Je)}delete(F,se,Ce){this.replace(F,se,"",Ce)}has(F){return this.c.some(se=>se._type===ce.Text&&se.uri.toString()===F.toString())}set(F,se){if(se)for(const Ce of se){if(!Ce)continue;let Je,nt;Array.isArray(Ce)?(Je=Ce[0],nt=Ce[1]):Je=Ce,le.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(F,Je.range.start,Je.newCellMetadata,nt):Je.newNotebookMetadata?this.e(F,Je.newNotebookMetadata,nt):this.f(F,Je.range,Je.newCells,nt):ne.isSnippetTextEdit(Je)?this.c.push({_type:ce.Snippet,uri:F,range:Je.range,edit:Je.snippet,metadata:nt}):this.c.push({_type:ce.Text,uri:F,edit:Je,metadata:nt})}else{for(let Ce=0;Ce<this.c.length;Ce++){const Je=this.c[Ce];switch(Je._type){case ce.Text:case ce.Snippet:case ce.Cell:case ce.CellReplace:Je.uri.toString()===F.toString()&&(this.c[Ce]=void 0);break}}(0,w.$Lb)(this.c)}}get(F){const se=[];for(const Ce of this.c)Ce._type===ce.Text&&Ce.uri.toString()===F.toString()&&se.push(Ce.edit);return se}entries(){const F=new O.$Dc;for(const se of this.c)if(se._type===ce.Text){let Ce=F.get(se.uri);Ce||(Ce=[se.uri,[]],F.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$HN=oe,e.$HN=oe=He([W],oe);let H=b=class{static isSnippetString(F){return F instanceof b?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=b.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,se=this.e++){if(typeof F=="function"){const Ce=new b;Ce.e=this.e,F(Ce),this.e=Ce.e,F=Ce.value}else F=b.c(F);return this.value+="${",this.value+=se,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,se=this.e++){const Ce=F.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(F,se){if(typeof se=="function"){const Ce=new b;Ce.e=this.e,se(Ce),this.e=Ce.e,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$IN=H,e.$IN=H=b=He([W],H);var x;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(x||(e.DiagnosticTag=x={}));var ue;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ue||(e.DiagnosticSeverity=ue={}));let me=T=class{static isLocation(F){return F instanceof T?!0:F?de.isRange(F.range)&&s.URI.isUri(F.uri):!1}constructor(F,se){if(this.uri=F,se)if(de.isRange(se))this.range=de.of(se);else if(be.isPosition(se))this.range=new de(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$JN=me,e.$JN=me=T=He([W],me);let Oe=class{static is(F){return F?typeof F.message=="string"&&F.location&&de.isRange(F.location.range)&&s.URI.isUri(F.location.uri):!1}constructor(F,se){this.location=F,this.message=se}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.location.range.isEqual(se.location.range)&&F.location.uri.toString()===se.location.uri.toString()}};e.$KN=Oe,e.$KN=Oe=He([W],Oe);let je=class{constructor(F,se,Ce=ue.Error){if(!de.isRange(F))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=F,this.message=se,this.severity=Ce}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.severity===se.severity&&F.code===se.code&&F.severity===se.severity&&F.source===se.source&&F.range.isEqual(se.range)&&(0,w.$xb)(F.tags,se.tags)&&(0,w.$xb)(F.relatedInformation,se.relatedInformation,Oe.isEqual)}};e.$LN=je,e.$LN=je=He([W],je);let ke=class{constructor(F,se){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=se}};e.$MN=ke,e.$MN=ke=He([W],ke);let Ae=class extends ke{constructor(F,se,Ce,Je){super(F,se),this.canIncreaseHover=Ce,this.canDecreaseHover=Je}};e.$NN=Ae,e.$NN=Ae=He([W],Ae);var Ne;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Ne||(e.HoverVerbosityAction=Ne={}));var U;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(U||(e.DocumentHighlightKind=U={}));let B=class{constructor(F,se=U.Text){this.range=F,this.kind=se}toJSON(){return{range:this.range,kind:U[this.kind]}}};e.$ON=B,e.$ON=B=He([W],B);let G=class{constructor(F,se){this.uri=F,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$PN=G,e.$PN=G=He([W],G);var Q;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Q||(e.SymbolKind=Q={}));var ee;(function(j){j[j.Deprecated=1]="Deprecated"})(ee||(e.SymbolTag=ee={}));let fe=P=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,se,Ce,Je,nt){this.name=F,this.kind=se,this.containerName=nt,typeof Ce=="string"&&(this.containerName=Ce),Je instanceof me?this.location=Je:Ce instanceof de&&(this.location=new me(Je,Ce)),P.validate(this)}toJSON(){return{name:this.name,kind:Q[this.kind],location:this.location,containerName:this.containerName}}};e.$QN=fe,e.$QN=fe=P=He([W],fe);let Re=p=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(p.validate)}constructor(F,se,Ce,Je,nt){this.name=F,this.detail=se,this.kind=Ce,this.range=Je,this.selectionRange=nt,this.children=[],p.validate(this)}};e.$RN=Re,e.$RN=Re=p=He([W],Re);var Ue;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Ue||(e.CodeActionTriggerKind=Ue={}));let Qe=class{constructor(F,se){this.title=F,this.kind=se}};e.$SN=Qe,e.$SN=Qe=He([W],Qe);let Ye=f=class{constructor(F){this.value=F}append(F){return new f(this.value?this.value+f.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+f.c)}};e.$TN=Ye,Ye.c=".",e.$TN=Ye=f=He([W],Ye),Ye.Empty=new Ye(""),Ye.QuickFix=Ye.Empty.append("quickfix"),Ye.Refactor=Ye.Empty.append("refactor"),Ye.RefactorExtract=Ye.Refactor.append("extract"),Ye.RefactorInline=Ye.Refactor.append("inline"),Ye.RefactorMove=Ye.Refactor.append("move"),Ye.RefactorRewrite=Ye.Refactor.append("rewrite"),Ye.Source=Ye.Empty.append("source"),Ye.SourceOrganizeImports=Ye.Source.append("organizeImports"),Ye.SourceFixAll=Ye.Source.append("fixAll"),Ye.Notebook=Ye.Empty.append("notebook");let it=class{constructor(F,se){if(this.range=F,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$UN=it,e.$UN=it=He([W],it);class ot{constructor(F,se,Ce,Je,nt,gt){this.kind=F,this.name=se,this.detail=Ce,this.uri=Je,this.range=nt,this.selectionRange=gt}}e.$VN=ot;class tt{constructor(F,se){this.fromRanges=se,this.from=F}}e.$WN=tt;class at{constructor(F,se){this.fromRanges=se,this.to=F}}e.$XN=at;var pt;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(pt||(e.LanguageStatusSeverity=pt={}));let ut=class{constructor(F,se){this.range=F,this.command=se}get isResolved(){return!!this.command}};e.$YN=ut,e.$YN=ut=He([W],ut);let st=M=class{static isMarkdownString(F){return F instanceof M?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,se=!1){o.set(this,void 0),rt(this,o,new k.$4k(F,{supportThemeIcons:se}),"f")}get value(){return ze(this,o,"f").value}set value(F){ze(this,o,"f").value=F}get isTrusted(){return ze(this,o,"f").isTrusted}set isTrusted(F){ze(this,o,"f").isTrusted=F}get supportThemeIcons(){return ze(this,o,"f").supportThemeIcons}set supportThemeIcons(F){ze(this,o,"f").supportThemeIcons=F}get supportHtml(){return ze(this,o,"f").supportHtml}set supportHtml(F){ze(this,o,"f").supportHtml=F}get baseUri(){return ze(this,o,"f").baseUri}set baseUri(F){ze(this,o,"f").baseUri=F}appendText(F){return ze(this,o,"f").appendText(F),this}appendMarkdown(F){return ze(this,o,"f").appendMarkdown(F),this}appendCodeblock(F,se){return ze(this,o,"f").appendCodeblock(se??"",F),this}};e.$ZN=st,o=new WeakMap,e.$ZN=st=M=He([W],st);let ht=class{constructor(F,se){this.label=F,this.documentation=se}};e.$1N=ht,e.$1N=ht=He([W],ht);let mt=class{constructor(F,se){this.label=F,this.documentation=se,this.parameters=[]}};e.$2N=mt,e.$2N=mt=He([W],mt);let wt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$3N=wt,e.$3N=wt=He([W],wt);var qe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(qe||(e.SignatureHelpTriggerKind=qe={}));var Be;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Be||(e.InlayHintKind=Be={}));let te=class{constructor(F){this.value=F}};e.$4N=te,e.$4N=te=He([W],te);let V=class{constructor(F,se,Ce){this.position=F,this.label=se,this.kind=Ce}};e.$5N=V,e.$5N=V=He([W],V);var Se;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se||(e.CompletionTriggerKind=Se={}));var Xe;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Xe||(e.CompletionItemKind=Xe={}));var et;(function(j){j[j.Deprecated=1]="Deprecated"})(et||(e.CompletionItemTag=et={}));let ft=class{constructor(F,se){this.label=F,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Xe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$6N=ft,e.$6N=ft=He([W],ft);let $t=class{constructor(F=[],se=!1){this.items=F,this.isIncomplete=se}};e.$7N=$t,e.$7N=$t=He([W],$t);let Mt=class{constructor(F,se,Ce){this.insertText=F,this.range=se,this.command=Ce}};e.$8N=Mt,e.$8N=Mt=He([W],Mt);let Gt=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$9N=Gt,e.$9N=Gt=He([W],Gt);var ri;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(ri||(e.PartialAcceptTriggerKind=ri={}));var li;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(li||(e.ViewColumn=li={}));var fi;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(fi||(e.StatusBarAlignment=fi={}));function xe(j,F){return`${E.$sn.toKey(j)}.${F}`}var Zt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Zt||(e.TextEditorLineNumbersStyle=Zt={}));var Qt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var vt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(vt||(e.TextEditorRevealType=vt={}));var St;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(St||(e.TextEditorSelectionChangeKind=St={}));var si;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(si||(e.TextDocumentChangeReason=si={}));var Yt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(j){function F(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=F}(St||(e.TextEditorSelectionChangeKind=St={}));var Bt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(j){function F(se){switch(se){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=F}(Bt||(e.SyntaxTokenType=Bt={}));let bt=class{constructor(F,se){if(se&&!s.URI.isUri(se))throw(0,y.$0)("target");if(!de.isRange(F)||F.isEmpty)throw(0,y.$0)("range");this.range=F,this.target=se}};e.$$N=bt,e.$$N=bt=He([W],bt);let At=class{constructor(F,se,Ce,Je){this.red=F,this.green=se,this.blue=Ce,this.alpha=Je}};e.$_N=At,e.$_N=At=He([W],At);let xt=class{constructor(F,se){if(se&&!(se instanceof At))throw(0,y.$0)("color");if(!de.isRange(F)||F.isEmpty)throw(0,y.$0)("range");this.range=F,this.color=se}};e.$aO=xt,e.$aO=xt=He([W],xt);let Wt=class{constructor(F){if(!F||typeof F!="string")throw(0,y.$0)("label");this.label=F}};e.$bO=Wt,e.$bO=Wt=He([W],Wt);var Ze;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ze||(e.ColorFormat=Ze={}));var _t;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(_t||(e.SourceControlInputBoxValidationType=_t={}));var oi;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(oi||(e.TerminalExitReason=oi={}));var gi;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(gi||(e.TerminalShellExecutionCommandLineConfidence=gi={}));class It{constructor(F,se,Ce){if(this.startIndex=F,this.length=se,this.tooltip=Ce,typeof F!="number"||F<0)throw(0,y.$0)("startIndex");if(typeof se!="number"||se<1)throw(0,y.$0)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,y.$0)("tooltip")}}e.$cO=It;class qt{constructor(F){this.uri=F}}e.$dO=qt;class Lt{constructor(F){this.terminalCommand=F}}e.$eO=Lt;var Vt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Vt||(e.TerminalLocation=Vt={}));class pi{constructor(F){if(this.options=F,typeof F!="object")throw(0,y.$0)("options")}}e.$fO=pi;var ei;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ei||(e.TaskRevealKind=ei={}));var ui;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Ft=L=class{static from(F){switch(F){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(F,se){if(this.label=se,typeof F!="string"||typeof se!="string")throw(0,y.$0)("name");this.c=F}get id(){return this.c}};e.$gO=Ft,Ft.Clean=new L("clean","Clean"),Ft.Build=new L("build","Build"),Ft.Rebuild=new L("rebuild","Rebuild"),Ft.Test=new L("test","Test"),e.$gO=Ft=L=He([W],Ft);function Ht(j){let F="";for(let se=0;se<j.length;se++)F+=j[se].replace(/,/g,",,")+",";return F}let ti=class{constructor(F,se,Ce){if(typeof F!="string")throw(0,y.$0)("process");this.e=[],this.c=F,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=Ce):this.f=se)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,y.$0)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const se of this.e)F.push(se);return Ht(F)}};e.$hO=ti,e.$hO=ti=He([W],ti);let Tt=class{constructor(F,se,Ce){if(this.f=[],Array.isArray(se)){if(!F)throw(0,y.$0)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,y.$0)("command");this.e=F,this.f=se,this.g=Ce}else{if(typeof F!="string")throw(0,y.$0)("commandLine");this.c=F,this.g=se}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,y.$0)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,y.$0)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)F.push(typeof se=="string"?se:se.value);return Ht(F)}};e.$iO=Tt,e.$iO=Tt=He([W],Tt);var Pt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Pt||(e.ShellQuoting=Pt={}));var Et;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Et||(e.TaskScope=Et={}));class ii{constructor(F){this.c=F}computeId(){return"customExecution"+(0,I.$3g)()}set callback(F){this.c=F}get callback(){return this.c}}e.$jO=ii;let yt=K=class{constructor(F,se,Ce,Je,nt,gt){this.k=!1,this.l=this.definition=F;let Dt;typeof se=="string"?(this.o=this.name=se,this.w=this.source=Ce,this.execution=Je,Dt=nt,this.k=!0):se===Et.Global||se===Et.Workspace?(this.target=se,this.o=this.name=Ce,this.w=this.source=Je,this.execution=nt,Dt=gt):(this.target=se,this.o=this.name=Ce,this.w=this.source=Je,this.execution=nt,Dt=gt),typeof Dt=="string"?(this.r=[Dt],this.t=!0):Array.isArray(Dt)?(this.r=Dt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof ti?this.l={type:K.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:K.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:K.c,id:this.q.computeId()}:this.l={type:K.g,id:(0,I.$3g)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,y.$0)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,y.$0)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const se=this.l.type;(K.g===se||K.e===se||K.f===se||K.c===se)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,y.$0)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$kO=yt,yt.c="customExecution",yt.e="process",yt.f="shell",yt.g="$empty",e.$kO=yt=K=He([W],yt);var ai;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(ai||(e.ProgressLocation=ai={}));var Kt;(function(j){function F(se){const Ce=se;return(0,v.$kg)(Ce.value)?Ce.tooltip&&!(0,v.$gg)(Ce.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ce.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ce.value),!1)}j.isViewBadge=F})(Kt||(e.ViewBadge=Kt={}));let vi=J=class{static isTreeItem(F,se){const Ce=F;if(Ce.checkboxState!==void 0){const Je=(0,v.$kg)(Ce.checkboxState)?Ce.checkboxState:(0,v.$ig)(Ce.checkboxState)&&(0,v.$kg)(Ce.checkboxState.state)?Ce.checkboxState.state:void 0,nt=!(0,v.$kg)(Ce.checkboxState)&&(0,v.$ig)(Ce.checkboxState)?Ce.checkboxState.tooltip:void 0;if(Je===void 0||Je!==bi.Checked&&Je!==bi.Unchecked||nt!==void 0&&!(0,v.$gg)(nt))return console.log("INVALID tree item, invalid checkboxState",Ce.checkboxState),!1}if(F instanceof J)return!0;if(Ce.label!==void 0&&!(0,v.$gg)(Ce.label)&&!Ce.label?.label)return console.log("INVALID tree item, invalid label",Ce.label),!1;if(Ce.id!==void 0&&!(0,v.$gg)(Ce.id))return console.log("INVALID tree item, invalid id",Ce.id),!1;if(Ce.iconPath!==void 0&&!(0,v.$gg)(Ce.iconPath)&&!s.URI.isUri(Ce.iconPath)&&(!Ce.iconPath||!(0,v.$gg)(Ce.iconPath.id))){const Je=Ce.iconPath;if(!Je||!(0,v.$gg)(Je.light)&&!s.URI.isUri(Je.light)&&!(0,v.$gg)(Je.dark)&&!s.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Ce.iconPath),!1}return Ce.description!==void 0&&!(0,v.$gg)(Ce.description)&&typeof Ce.description!="boolean"?(console.log("INVALID tree item, invalid description",Ce.description),!1):Ce.resourceUri!==void 0&&!s.URI.isUri(Ce.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ce.resourceUri),!1):Ce.tooltip!==void 0&&!(0,v.$gg)(Ce.tooltip)&&!(Ce.tooltip instanceof st)?(console.log("INVALID tree item, invalid tooltip",Ce.tooltip),!1):Ce.command!==void 0&&!Ce.command.command?(console.log("INVALID tree item, invalid command",Ce.command),!1):Ce.collapsibleState!==void 0&&Ce.collapsibleState<mi.None&&Ce.collapsibleState>mi.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ce.collapsibleState),!1):Ce.contextValue!==void 0&&!(0,v.$gg)(Ce.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ce.contextValue),!1):Ce.accessibilityInformation!==void 0&&!Ce.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ce.accessibilityInformation),!1):!0}constructor(F,se=mi.None){this.collapsibleState=se,s.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$lO=vi,e.$lO=vi=J=He([W],vi);var mi;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(mi||(e.TreeItemCollapsibleState=mi={}));var bi;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(bi||(e.TreeItemCheckboxState=bi={}));let Ut=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$mO=Ut,e.$mO=Ut=He([W],Ut);class Ri extends Ut{}e.$nO=Ri;class Fi extends Ri{constructor(F){super(""),c.set(this,void 0),rt(this,c,F,"f")}asFile(){return ze(this,c,"f")}}e.$oO=Fi,c=new WeakMap;class Nt{constructor(F,se,Ce,Je){this.name=F,this.uri=se,this._itemId=Ce,this.c=Je}data(){return this.c()}}e.$pO=Nt;let Ci=class{constructor(F){h.add(this),i.set(this,new Map);for(const[se,Ce]of F??[]){const Je=ze(this,i,"f").get(ze(this,h,"m",r).call(this,se));Je?Je.push(Ce):ze(this,i,"f").set(ze(this,h,"m",r).call(this,se),[Ce])}}get(F){return ze(this,i,"f").get(ze(this,h,"m",r).call(this,F))?.[0]}set(F,se){ze(this,i,"f").set(ze(this,h,"m",r).call(this,F),[se])}forEach(F,se){for(const[Ce,Je]of ze(this,i,"f"))for(const nt of Je)F.call(se,nt,Ce,this)}*[(i=new WeakMap,h=new WeakSet,Symbol.iterator)](){for(const[F,se]of ze(this,i,"f"))for(const Ce of se)yield[F,Ce]}};e.$qO=Ci,r=function(F){return F.toLowerCase()},e.$qO=Ci=He([W],Ci);let Ii=class{constructor(F,se,Ce){this.insertText=F,this.title=se,this.kind=Ce}};e.$rO=Ii,e.$rO=Ii=He([W],Ii);var yi;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(yi||(e.DocumentPasteTriggerKind=yi={}));class hi{constructor(F){this.value=F}append(...F){return new hi((this.value?[this.value,...F]:F).join(hi.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+hi.c)}}e.$sO=hi,hi.c=".",hi.Empty=new hi("");class zi{constructor(F,se,Ce){this.title=se,this.insertText=F,this.kind=Ce}}e.$tO=zi;let Ot=class{constructor(F,se){this.id=F,this.color=se}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$uO=Ot,e.$uO=Ot=He([W],Ot),Ot.File=new Ot("file"),Ot.Folder=new Ot("folder");let Ee=class{constructor(F){this.id=F}};e.$vO=Ee,e.$vO=Ee=He([W],Ee);var Me;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Me||(e.ConfigurationTarget=Me={}));let ge=class{get base(){return this.c}set base(F){this.c=F,this.e=s.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,se){if(typeof F!="string"&&(!F||!s.URI.isUri(F)&&!s.URI.isUri(F.uri)))throw(0,y.$0)("base");if(typeof se!="string")throw(0,y.$0)("pattern");typeof F=="string"?this.baseUri=s.URI.file(F):s.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wO=ge,e.$wO=ge=He([W],ge);const X=new WeakMap;function De(j,F){X.set(j,F)}let We=class{constructor(F,se,Ce,Je,nt){this.enabled=typeof F=="boolean"?F:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Je=="string"&&(this.logMessage=Je),typeof nt=="string"&&(this.mode=nt)}get id(){return this.c||(this.c=X.get(this)??(0,I.$3g)()),this.c}};e.$yO=We,e.$yO=We=He([W],We);let _e=class extends We{constructor(F,se,Ce,Je,nt,gt){if(super(se,Ce,Je,nt,gt),F===null)throw(0,y.$0)("location");this.location=F}};e.$zO=_e,e.$zO=_e=He([W],_e);let Ke=class extends We{constructor(F,se,Ce,Je,nt,gt){super(se,Ce,Je,nt,gt),this.functionName=F}};e.$AO=Ke,e.$AO=Ke=He([W],Ke);let dt=class extends We{constructor(F,se,Ce,Je,nt,gt,Dt,Xt){if(super(Je,nt,gt,Dt,Xt),!se)throw(0,y.$0)("dataId");this.label=F,this.dataId=se,this.canPersist=Ce}};e.$BO=dt,e.$BO=dt=He([W],dt);let Rt=class{constructor(F,se,Ce){this.command=F,this.args=se||[],this.options=Ce}};e.$CO=Rt,e.$CO=Rt=He([W],Rt);let Jt=class{constructor(F,se){this.port=F,this.host=se}};e.$DO=Jt,e.$DO=Jt=He([W],Jt);let ci=class{constructor(F){this.path=F}};e.$EO=ci,e.$EO=ci=He([W],ci);let jt=class{constructor(F){this.implementation=F}};e.$FO=jt,e.$FO=jt=He([W],jt);class di{constructor(F,se,Ce){this.session=F,this.threadId=se,this.frameId=Ce}}e.$GO=di;class en{constructor(F,se){this.session=F,this.threadId=se}}e.$HO=en;let Gi=class{constructor(F,se){this.range=F,this.expression=se}};e.$IO=Gi,e.$IO=Gi=He([W],Gi);var Ui;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ui||(e.InlineCompletionTriggerKind=Ui={}));let Ni=class{constructor(F,se){this.range=F,this.text=se}};e.$JO=Ni,e.$JO=Ni=He([W],Ni);let Ki=class{constructor(F,se,Ce=!0){this.range=F,this.variableName=se,this.caseSensitiveLookup=Ce}};e.$KO=Ki,e.$KO=Ki=He([W],Ki);let Qi=class{constructor(F,se){this.range=F,this.expression=se}};e.$LO=Qi,e.$LO=Qi=He([W],Qi);let Ei=class{constructor(F,se){this.frameId=F,this.stoppedLocation=se}};e.$MO=Ei,e.$MO=Ei=He([W],Ei);var tn;(function(j){j[j.AIGenerated=1]="AIGenerated"})(tn||(e.NewSymbolNameTag=tn={}));var nn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(nn||(e.NewSymbolNameTriggerKind=nn={}));class Hi{constructor(F,se){this.newSymbolName=F,this.tags=se}}e.$NO=Hi;var rn;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(rn||(e.FileChangeType=rn={}));let Oi=z=class extends Error{static FileExists(F){return new z(F,u.FileSystemProviderErrorCode.FileExists,z.FileExists)}static FileNotFound(F){return new z(F,u.FileSystemProviderErrorCode.FileNotFound,z.FileNotFound)}static FileNotADirectory(F){return new z(F,u.FileSystemProviderErrorCode.FileNotADirectory,z.FileNotADirectory)}static FileIsADirectory(F){return new z(F,u.FileSystemProviderErrorCode.FileIsADirectory,z.FileIsADirectory)}static NoPermissions(F){return new z(F,u.FileSystemProviderErrorCode.NoPermissions,z.NoPermissions)}static Unavailable(F){return new z(F,u.FileSystemProviderErrorCode.Unavailable,z.Unavailable)}constructor(F,se=u.FileSystemProviderErrorCode.Unknown,Ce){super(s.URI.isUri(F)?F.toString(!0):F),this.code=Ce?.name??"Unknown",(0,u.$pl)(this,se),Object.setPrototypeOf(this,z.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}};e.$OO=Oi,e.$OO=Oi=z=He([W],Oi);let ji=class{constructor(F,se,Ce){this.start=F,this.end=se,this.kind=Ce}};e.$PO=ji,e.$PO=ji=He([W],ji);var sn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(sn||(e.FoldingRangeKind=sn={}));var Ji;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ji||(e.CommentThreadCollapsibleState=Ji={}));var on;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var Ai;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Ai||(e.CommentState=Ai={}));var an;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var cn;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(cn||(e.CommentThreadApplicability=cn={}));class Dn{constructor(F,se=[]){this.tokenTypes=F,this.tokenModifiers=se}}e.$QO=Dn;function Xi(j){return typeof j>"u"||(0,v.$hg)(j)}class Bi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let se=0,Ce=F.tokenTypes.length;se<Ce;se++)this.k.set(F.tokenTypes[se],se);for(let se=0,Ce=F.tokenModifiers.length;se<Ce;se++)this.l.set(F.tokenModifiers[se],se)}}push(F,se,Ce,Je,nt){if(typeof F=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Je=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.q(F,se,Ce,Je,nt);if(de.isRange(F)&&typeof se=="string"&&Xi(Ce))return this.o(F,se,Ce);throw(0,y.$0)()}o(F,se,Ce){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Je=F.start.line,nt=F.start.character,gt=F.end.character-F.start.character,Dt=this.k.get(se);let Xt=0;if(Ce)for(const $i of Ce){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get($i);Xt|=1<<wi>>>0}this.q(Je,nt,gt,Dt,Xt)}q(F,se,Ce,Je,nt){if(this.f&&(F<this.c||F===this.c&&se<this.e)){this.f=!1;const Xt=this.g.length/5|0;let $i=0,wi=0;for(let ki=0;ki<Xt;ki++){let Pi=this.g[5*ki],xi=this.g[5*ki+1];Pi===0?(Pi=$i,xi+=wi):Pi+=$i,this.g[5*ki]=Pi,this.g[5*ki+1]=xi,$i=Pi,wi=xi}}let gt=F,Dt=se;this.f&&this.j>0&&(gt-=this.c,gt===0&&(Dt-=this.e)),this.g[this.j++]=gt,this.g[this.j++]=Dt,this.g[this.j++]=Ce,this.g[this.j++]=Je,this.g[this.j++]=nt,this.c=F,this.e=se}static r(F){const se=[],Ce=F.length/5|0;for(let Dt=0;Dt<Ce;Dt++)se[Dt]=Dt;se.sort((Dt,Xt)=>{const $i=F[5*Dt],wi=F[5*Xt];if($i===wi){const ki=F[5*Dt+1],Pi=F[5*Xt+1];return ki-Pi}return $i-wi});const Je=new Uint32Array(F.length);let nt=0,gt=0;for(let Dt=0;Dt<Ce;Dt++){const Xt=5*se[Dt],$i=F[Xt+0],wi=F[Xt+1],ki=F[Xt+2],Pi=F[Xt+3],xi=F[Xt+4],Xn=$i-nt,Lr=Xn===0?wi-gt:wi,_i=5*Dt;Je[_i+0]=Xn,Je[_i+1]=Lr,Je[_i+2]=ki,Je[_i+3]=Pi,Je[_i+4]=xi,nt=$i,gt=wi}return Je}build(F){return this.f?new Fe(new Uint32Array(this.g),F):new Fe(Bi.r(this.g),F)}}e.$RO=Bi;class Fe{constructor(F,se){this.resultId=se,this.data=F}}e.$SO=Fe;class Di{constructor(F,se,Ce){this.start=F,this.deleteCount=se,this.data=Ce}}e.$TO=Di;class ln{constructor(F,se){this.resultId=se,this.edits=F}}e.$UO=ln;var ct;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(ct||(e.DebugConsoleMode=ct={}));class Ct{constructor(F){this.name=F}}e.$VO=Ct;let Wi=class{constructor(){}};e.$WO=Wi,Wi.Back={iconPath:new Ot("arrow-left")},e.$WO=Wi=He([W],Wi);var un;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(un||(e.QuickPickItemKind=un={}));var Zi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var hn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(hn||(e.ExtensionKind=hn={}));class qi{static validate(F){if(typeof F.badge=="string"){let se=(0,N.$Rf)(F.badge,0);if(se<F.badge.length&&(se+=(0,N.$Rf)(F.badge,se)),F.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Ot.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,se,Ce){this.badge=F,this.tooltip=se,this.color=Ce}}e.$XO=qi;let Yi=class{constructor(F){this.kind=F}};e.$YO=Yi,e.$YO=Yi=He([W],Yi);var dn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(dn||(e.ColorThemeKind=dn={}));class Si{static isNotebookRange(F){return F instanceof Si?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,se){if(F<0)throw(0,y.$0)("start must be positive");if(se<0)throw(0,y.$0)("end must be positive");F<=se?(this.c=F,this.e=se):(this.c=se,this.e=F)}with(F){let se=this.c,Ce=this.e;return F.start!==void 0&&(se=F.start),F.end!==void 0&&(Ce=F.end),se===this.c&&Ce===this.e?this:new Si(se,Ce)}}e.$ZO=Si;class Mi{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(se=>Mi.isNotebookCellData(se))}static isNotebookCellData(F){return!0}constructor(F,se,Ce,Je,nt,gt,Dt){this.kind=F,this.value=se,this.languageId=Ce,this.mime=Je,this.outputs=nt??[],this.metadata=gt,this.executionSummary=Dt,Mi.validate(this)}}e.$1O=Mi;class Sn{constructor(F){this.cells=F}}e.$2O=Sn;class fn{static isNotebookCellOutputItem(F){return F instanceof t?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const se={name:F.name,message:F.message,stack:F.stack};return t.json(se,"application/vnd.code.notebook.error")}static stdout(F){return t.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return t.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,se="application/octet-stream"){return new t(F,se)}static text(F,se=R.$0s.text){const Ce=ze(t,t,"f",a).encode(String(F));return new t(Ce,se)}static json(F,se="text/x-json"){const Ce=JSON.stringify(F,void 0,"	");return t.text(Ce,se)}constructor(F,se){this.data=F,this.mime=se;const Ce=(0,R.$bt)(se,!0);if(!Ce)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}}e.$3O=fn,t=fn,a={value:new TextEncoder};class Vi{static isNotebookCellOutput(F){return F instanceof Vi?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,se=!1){const Ce=new Set,Je=new Set;for(let nt=0;nt<F.length;nt++){const gt=F[nt],Dt=(0,R.$bt)(gt.mime);if(!Ce.has(Dt)||(0,d.$AL)(Dt)){Ce.add(Dt);continue}Je.add(nt),se&&console.warn(`DUPLICATED mime type '${gt.mime}' will be dropped`)}return Je.size===0?F:F.filter((nt,gt)=>!Je.has(gt))}constructor(F,se,Ce){this.items=Vi.ensureUniqueMimeTypes(F,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=(0,I.$3g)(),this.metadata=se??Ce)}}e.$4O=Vi;var gn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(gn||(e.NotebookCellKind=gn={}));var mn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(mn||(e.NotebookCellExecutionState=mn={}));var pn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(pn||(e.NotebookCellStatusBarAlignment=pn={}));var $n;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})($n||(e.NotebookEditorRevealType=$n={}));class kn{constructor(F,se){this.text=F,this.alignment=se}}e.$5O=kn;var wn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(wn||(e.NotebookControllerAffinity=wn={}));var vn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(vn||(e.NotebookControllerAffinity2=vn={}));class Cn{constructor(F,se=[]){this.uri=F,this.provides=(0,w.$5b)(se)}}e.$6O=Cn;class ie{constructor(F){this.label=F}}e.$7O=ie;var pe;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(pe||(e.NotebookVariablesRequestKind=pe={}));let Le=class{constructor(F,se){this.label=F,this.timestamp=se}};e.$8O=Le,e.$8O=Le=He([W],Le);var lt;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(lt||(e.ExtensionMode=lt={}));var kt;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(kt||(e.ExtensionRuntime=kt={}));var zt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(zt||(e.StandardTokenType=zt={}));class Li{constructor(F,se){this.ranges=F,this.wordPattern=se}}e.$9O=Li;class In{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$0O=In;var Nn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Nn||(e.TestResultState=Nn={}));var On;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(On||(e.TestRunProfileKind=On={}));let Pn=class{constructor(F=void 0,se=void 0,Ce=void 0,Je=!1,nt=!0){this.include=F,this.exclude=se,this.profile=Ce,this.continuous=Je,this.preserveFocus=nt}};e.$$O=Pn,e.$$O=Pn=He([W],Pn);let Rn=A=class{static diff(F,se,Ce){const Je=new A(F);return Je.expectedOutput=se,Je.actualOutput=Ce,Je}constructor(F){this.message=F}};e.$_O=Rn,e.$_O=Rn=A=He([W],Rn);let An=class{constructor(F){this.id=F}};e.$aP=An,e.$aP=An=He([W],An);class bn{constructor(F,se){this.covered=F,this.total=se,Mn(this)}}e.$bP=bn;function Mn(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class Tn{static fromDetails(F,se){const Ce=new bn(0,0),Je=new bn(0,0),nt=new bn(0,0);for(const Dt of se)if("branches"in Dt){Ce.total+=1,Ce.covered+=Dt.executed?1:0;for(const Xt of Dt.branches)Je.total+=1,Je.covered+=Xt.executed?1:0}else nt.total+=1,nt.covered+=Dt.executed?1:0;const gt=new Tn(F,Ce,Je.total>0?Je:void 0,nt.total>0?nt:void 0);return gt.detailedCoverage=se,gt}constructor(F,se,Ce,Je,nt=[]){this.uri=F,this.statementCoverage=se,this.branchCoverage=Ce,this.declarationCoverage=Je,this.fromTests=nt}}e.$dP=Tn;class xn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,Ce=[]){this.executed=F,this.location=se,this.branches=Ce}}e.$eP=xn;class _n{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,Ce){this.executed=F,this.location=se,this.label=Ce}}e.$fP=_n;class er{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,Ce){this.name=F,this.executed=se,this.location=Ce}}e.$gP=er;var Ln;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Ln||(e.ExternalUriOpenerPriority=Ln={}));var Fn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Fn||(e.WorkspaceTrustState=Fn={}));var zn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(zn||(e.PortAutoForwardAction=zn={}));class tr{constructor(F,se,Ce,Je,nt,gt){this.kind=F,this.name=se,this.detail=Ce,this.uri=Je,this.range=nt,this.selectionRange=gt}}e.$hP=tr;class ir{constructor(F){this.uri=F}}e.$iP=ir;class nr{constructor(F,se){this.original=F,this.modified=se}}e.$jP=nr;class rr{constructor(F,se,Ce,Je){this.base=F,this.input1=se,this.input2=Ce,this.result=Je}}e.$kP=rr;class sr{constructor(F,se){this.uri=F,this.viewType=se}}e.$lP=sr;class or{constructor(F){this.viewType=F}}e.$mP=or;class ar{constructor(F,se){this.uri=F,this.notebookType=se}}e.$nP=ar;class cr{constructor(F,se,Ce){this.original=F,this.modified=se,this.notebookType=Ce}}e.$oP=cr;class lr{constructor(){}}e.$pP=lr;class ur{constructor(F,se){this.uri=F,this.inputBoxUri=se}}e.$qP=ur;class hr{constructor(){}}e.$rP=hr;class dr{constructor(F){this.textDiffs=F}}e.$sP=dr;var Un;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(Un||(e.InteractiveSessionVoteDirection=Un={}));var jn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(jn||(e.ChatCopyKind=jn={}));var Bn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Bn||(e.ChatVariableLevel=Bn={}));class fr{constructor(F,se,Ce){this.id=F,this.label=se,this.values=Ce}}e.$tP=fr;var Wn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(Wn||(e.InteractiveEditorResponseFeedbackKind=Wn={}));var qn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(qn||(e.ChatResultFeedbackKind=qn={}));class gr{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new st(F):F}}e.$uP=gr;class mr{constructor(F,se){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new st(F):F,this.vulnerabilities=se}}e.$vP=mr;class pr{constructor(F,se){this.participant=F,this.command=se}}e.$wP=pr;class $r{constructor(F,se,Ce){this.title=F,this.message=se,this.data=Ce}}e.$xP=$r;class wr{constructor(F,se){this.value=F,this.baseUri=se}}e.$yP=wr;class vr{constructor(F,se){this.value=F,this.title=se}}e.$zP=vr;class br{constructor(F){this.value=F}}e.$AP=br;class yr{constructor(F,se){this.value=F,this.task=se}}e.$BP=yr;class Er{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new st(F):F}}e.$CP=Er;class Dr{constructor(F){this.value=F}}e.$DP=Dr;class Sr{constructor(F,se){this.value=F,this.iconPath=se}}e.$EP=Sr;class kr{constructor(F,se){this.uri=F,this.edits=Array.isArray(se)?se:[se]}}e.$FP=kr;class Cr{constructor(F,se,Ce,Je){this.prompt=F,this.command=se,this.references=Ce,this.participant=Je}}e.$GP=Cr;class Ir{constructor(F,se,Ce,Je){this.response=F,this.result=se,this.participant=Ce,this.command=Je}}e.$HP=Ir;var Vn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(Vn||(e.ChatLocation=Vn={}));var yn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(yn||(e.LanguageModelChatMessageRole=yn={}));class Pr{constructor(F,se,Ce){this.name=F,this.content=se,this.isError=Ce??!1}}e.$IP=Pr;class En{static User(F,se){const Ce=new En(yn.User,typeof F=="string"?F:"",se);return Ce.content2=F,Ce}static Assistant(F,se){return new En(yn.Assistant,F,se)}constructor(F,se,Ce){this.role=F,this.content=se,this.content2=se,this.name=Ce}}e.$JP=En;class Rr{constructor(F,se){this.name=F,this.parameters=se}}e.$KP=Rr;class Ar{constructor(F){this.value=F}}e.$LP=Ar;class Tr{constructor(F){this.content=F}}e.$MP=Tr;class Nr{constructor(F,se){this.content=F,this.name=se}}e.$NP=Nr;class Or{constructor(F,se){this.content=F,this.name=se}}e.$OP=Or;class Ti extends Error{static NotFound(F){return new Ti(F,Ti.NotFound.name)}static NoPermissions(F){return new Ti(F,Ti.NoPermissions.name)}static Blocked(F){return new Ti(F,Ti.Blocked.name)}constructor(F,se,Ce){super(F,{cause:Ce}),this.name="LanguageModelError",this.code=se??""}}e.$PP=Ti;var Gn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Gn||(e.RelatedInformationType=Gn={}));var Kn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Kn||(e.SpeechToTextStatus=Kn={}));var Qn;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Qn||(e.TextToSpeechStatus=Qn={}));var Hn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Hn||(e.KeywordRecognitionStatus=Hn={}));class Mr{constructor(F,se){this.text=F,this.range=se}}e.$QP=Mr;var Jn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Jn||(e.InlineEditTriggerKind=Jn={}))}),define(Ie[269],Pe([1,0,5,7]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=void 0;class k{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(w.$vN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,N,v){if(this.a.size===0)throw new Error("No related information providers registered");const s=this.a.get(R);if(!s)throw new Error("related information provider not found");return await s.provideRelatedInformation(N,v)??[]}getRelatedInformation(R,N,v){return this.c.$getAiRelatedInformation(N,v)}registerRelatedInformationProvider(R,N,v){const s=this.b;return this.b++,this.a.set(s,v),this.c.$registerAiRelatedInformationProvider(s,N),new y.$xN(()=>{this.c.$unregisterAiRelatedInformationProvider(s),this.a.delete(s)})}}e.$woc=k}),define(Ie[91],Pe([1,0,6,5,7,19,117,3,17]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=e.$Hoc=void 0,e.$Hoc=(0,N.$Gi)("IExtHostAuthentication");let s=class{constructor(u){this.b=new Map,this.c=new w.$ne,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=u.getProxy(y.$vN.MainThreadAuthentication)}async getSession(u,C,d,n={}){const o=O.$sn.toKey(u.identifier),c=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${C} ${c}`,async()=>{await this.a.$ensureProvider(C);const h=u.displayName||u.name;return this.a.$getSession(C,d,o,h,n)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,C){const d=this.b.get(u);return d?d.provider.removeSession(C):this.a.$removeSession(u,C)}registerAuthenticationProvider(u,C,d,n){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:C,provider:d,options:n??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(u,c));return this.a.$registerAuthenticationProvider(u,C,n?.supportsMultipleAccounts??!1),new k.$xN(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,C,d){const n=this.b.get(u);if(n)return await n.provider.createSession(C,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,C){const d=this.b.get(u);if(d)return await d.provider.removeSession(C);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,C,d){const n=this.b.get(u);if(n)return await n.provider.getSessions(C,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,C){return u.startsWith(R.$xM)||this.c.fire({provider:{id:u,label:C}}),Promise.resolve()}};e.$Ioc=s,e.$Ioc=s=He([Ge(0,v.$2P)],s);class I{constructor(){this.a=new Map}getOrCreate(u,C){const d=this.a.get(u);if(d)return d;const n=C().finally(()=>this.a.delete(u));return this.a.set(u,n),n}}}),define(Ie[122],Pe([1,0,2,5,7,3,17,12,18,13,20,25]),function(_,e,w,y,k,O,R,N,v,s,I,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=e.$Mpc=void 0;let C=u=class{constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(y.$vN.MainThreadDecorations)}registerFileDecorationProvider(n,o){const c=u.c++;this.f.set(c,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(c,o.identifier.value);const h=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const r=(0,v.$5b)(i);if(r.length<=u.d){this.g.$onDidChange(c,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,r.length);const t=r.map(g=>({uri:g,rank:(0,s.$kf)(g.path,"/")})),a=(0,v.$Cb)(t,(g,m)=>g.rank-m.rank||(0,s.$Af)(g.uri.path,m.uri.path)),l=[];e:for(const g of a){let m;for(const $ of g){const S=(0,I.$pc)($.uri.path);if(m!==S&&(m=S,l.push($.uri)>=u.d))break e}}this.g.$onDidChange(c,l)});return new k.$xN(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(n,o,c){if(!this.f.has(n))return Object.create(null);const h=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(n);return await Promise.all(o.map(async t=>{try{const{uri:a,id:l}=t,g=await Promise.resolve(i.provideFileDecoration(w.URI.revive(a),c));if(!g)return;try{k.$XO.validate(g),g.badge&&typeof g.badge!="string"&&(0,E.$8G)(r,"codiconDecoration"),h[l]=[g.propagate,g.tooltip,g.badge,g.color]}catch(m){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${m}`)}}catch(a){this.h.error(a)}})),h}};e.$Mpc=C,C.c=0,C.d=250,e.$Mpc=C=u=He([Ge(0,R.$2P),Ge(1,N.$ak)],C),e.$Npc=(0,O.$Gi)("IExtHostDecorations")}),define(Ie[270],Pe([1,0,14,2,7,5,16,22,13]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0;class s{constructor(E,u,C){this.d=u,this.e=C,this.b=new Map,this.c=E.getProxy(O.$vN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,u){if(Object.keys(R.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const C=s.a++;this.b.set(C,u),this.c.$registerTextContentProvider(C,E);let d;if(typeof u.onDidChange=="function"){let n;d=u.onDidChange(async o=>{if(o.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;n&&await n;const c=this.$provideTextDocumentContent(C,o).then(async h=>{if(!h&&typeof h!="string")return;const i=this.d.getDocument(o);if(!i)return;const r=(0,v.$uf)(h);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(o,h)}).catch(w.$3).finally(()=>{n===c&&(n=void 0)});n=c})}return new k.$xN(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(E,u){const C=this.b.get(E);return C?Promise.resolve(C.provideTextDocumentContent(y.URI.revive(u),N.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Ppc=s,s.a=0}),define(Ie[123],Pe([1,0,62,16,13,326,210,7,18]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=void 0,e.$4P=I;const s=new Map;function I(d,n){n?s.set(d,n):s.delete(d)}function E(d){return s.get(d)}class u extends O.$nw{constructor(n,o,c,h,i,r,t){super(o,c,h,i),this.c=n,this.m=r,this.q=t,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,v.$xb)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===y.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?N.EndOfLine.LF:N.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,c){return n.y(o,c)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,w.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,w.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const c=this.g,h=o.start.line,i=o.end.line,r=[];r.push(this.f[h].substring(o.start.character));for(let t=h+1;t<i;t++)r.push(this.f[t]);return r.push(this.f[i].substring(0,o.end.character)),r.join(c)}t(n){let o;if(n instanceof N.$yN?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new C(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),c=this.f[o.index].length;return new N.$yN(o.index,Math.min(o.remainder,c))}w(n){if(!(n instanceof N.$zN))throw new Error("Invalid argument");const o=this.x(n.start),c=this.x(n.end);return o===n.start&&c===n.end?n:new N.$zN(o.line,o.character,c.line,c.character)}x(n){if(!(n instanceof N.$yN))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:c}=n,h=!1;if(o<0)o=0,c=0,h=!0;else if(o>=this.f.length)o=this.f.length-1,c=this.f[o].length,h=!0;else{const i=this.f[o].length;c<0?(c=0,h=!0):c>i&&(c=i,h=!0)}return h?new N.$yN(o,c):n}y(n,o){const c=this.x(n);if(!o)o=E(this.m);else if((0,k.$tf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const h=(0,R.$pt)(c.character+1,(0,R.$nt)(o),this.f[c.line],0);if(h)return new N.$zN(c.line,h.startColumn-1,c.line,h.endColumn-1)}}e.$5P=u;class C{constructor(n,o,c){this.a=n,this.b=o,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new N.$zN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new N.$zN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$6P=C}),define(Ie[271],Pe([1,0,5,7]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Spc=void 0;class k{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(w.$vN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,N,v){if(this.a.size===0)throw new Error("No embedding vector providers registered");const s=this.a.get(R);if(!s)throw new Error("Embedding vector provider not found");const I=await s.provideEmbeddingVector(N,v);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(R,N,v){const s=this.b;return this.b++,this.a.set(s,v),this.c.$registerAiEmbeddingVectorProvider(N,s),new y.$xN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(s),this.a.delete(s)})}}e.$Spc=k}),define(Ie[69],Pe([1,0,5,30,7,23,3,17,51,4,11,24,16]),function(_,e,w,y,k,O,R,N,v,s,I,E,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=e.$Xoc=void 0,y=Ve(y);let d=C=class{constructor(o,c){this.b=new Map,this.c=new I.$Ph,this.a=o.getProxy(w.$vN.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(i){try{let r;const t=h.b.get(i.scheme);return t?(await h.a.$ensureActivation(i.scheme),r=await t.impl.stat(i)):r=await h.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===y.FilePermission.Readonly?1:void 0}}catch(r){C.e(r)}},async readDirectory(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await h.a.$readdir(i)}catch(r){return C.e(r)}},async createDirectory(i){try{const r=h.b.get(i.scheme);return r&&!r.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(r.impl,r.extUri,i)):await h.a.$mkdir(i)}catch(r){return C.e(r)}},async readFile(i){try{const r=h.b.get(i.scheme);return r?(await h.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await h.a.$readFile(i)).buffer}catch(r){return C.e(r)}},async writeFile(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly?(await h.a.$ensureActivation(i.scheme),await h.d(t.impl,t.extUri,t.extUri.dirname(i)),await h.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await h.a.$writeFile(i,O.$Pe.wrap(r))}catch(t){return C.e(t)}},async delete(i,r){try{const t=h.b.get(i.scheme);return t&&!t.isReadonly&&!r?.useTrash?(await h.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...r})):await h.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(t){return C.e(t)}},async rename(i,r,t){try{return await h.a.$rename(i,r,{overwrite:!1,...t})}catch(a){return C.e(a)}},async copy(i,r,t){try{return await h.a.$copy(i,r,{overwrite:!1,...t})}catch(a){return C.e(a)}},isWritableFileSystem(i){const r=c.getCapabilities(i);if(typeof r=="number")return!(r&y.FileSystemProviderCapabilities.Readonly)}})}async d(o,c,h){const i=[];for(;!c.isEqual(h,c.dirname(h));)try{if(!((await o.stat(h)).type&y.FileType.Directory))throw k.$OO.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(y.$ql(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(c.basename(h)),h=c.dirname(h)}for(let r=i.length-1;r>=0;r--){h=c.joinPath(h,i[r]);try{await o.createDirectory(h)}catch(t){if(y.$ql(t)!==y.FileSystemProviderErrorCode.FileExists)throw t}}}static e(o){if(o instanceof k.$OO)throw o;if(o instanceof y.$ml)switch(o.code){case y.FileSystemProviderErrorCode.FileExists:throw k.$OO.FileExists(o.message);case y.FileSystemProviderErrorCode.FileNotFound:throw k.$OO.FileNotFound(o.message);case y.FileSystemProviderErrorCode.FileNotADirectory:throw k.$OO.FileNotADirectory(o.message);case y.FileSystemProviderErrorCode.FileIsADirectory:throw k.$OO.FileIsADirectory(o.message);case y.FileSystemProviderErrorCode.NoPermissions:throw k.$OO.NoPermissions(o.message);case y.FileSystemProviderErrorCode.Unavailable:throw k.$OO.Unavailable(o.message);default:throw new k.$OO(o.message,o.name)}if(!(o instanceof Error))throw new k.$OO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw k.$OO.Unavailable(o.message);switch(o.name){case y.FileSystemProviderErrorCode.FileExists:throw k.$OO.FileExists(o.message);case y.FileSystemProviderErrorCode.FileNotFound:throw k.$OO.FileNotFound(o.message);case y.FileSystemProviderErrorCode.FileNotADirectory:throw k.$OO.FileNotADirectory(o.message);case y.FileSystemProviderErrorCode.FileIsADirectory:throw k.$OO.FileIsADirectory(o.message);case y.FileSystemProviderErrorCode.NoPermissions:throw k.$OO.NoPermissions(o.message);case y.FileSystemProviderErrorCode.Unavailable:throw k.$OO.Unavailable(o.message);default:throw new k.$OO(o.message,o.name)}}addFileSystemProvider(o,c,h){return this.b.set(o,{impl:c,extUri:h?.isCaseSensitive?E.$0g:E.$_g,isReadonly:!!h?.isReadonly}),(0,s.$Vc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??E.$0g}};e.$Xoc=d,e.$Xoc=d=C=He([Ge(0,N.$2P),Ge(1,v.$Boc)],d),e.$Yoc=(0,R.$Gi)("IExtHostConsumerFileSystem")}),define(Ie[92],Pe([1,0,3,27,12,69,2]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=e.$Zoc=void 0,e.$Zoc=(0,w.$Gi)("IExtensionStoragePaths");let N=class{constructor(s,I,E){this.d=I,this.f=E,this.a=s.workspace??void 0,this.b=s.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(s){return R.URI.joinPath(this.b.workspaceStorageHome,s)}async h(){if(!this.a)return Promise.resolve(void 0);const s=this.a.id,I=await this.g(s);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(R.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(s){if(this.c)return R.URI.joinPath(this.c,s.identifier.value)}globalValue(s){return R.URI.joinPath(this.b.globalStorageHome,s.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$1oc=N,e.$1oc=N=He([Ge(0,y.$fQ),Ge(1,k.$ak),Ge(2,O.$Yoc)],N)}),define(Ie[272],Pe([1,0,7,17,6]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;let O=class{constructor(N){this.a=new w.$YO(w.ColorThemeKind.Dark),this.b=new k.$ne}get activeColorTheme(){return this.a}$onColorThemeChange(N){let v;switch(N){case"light":v=w.ColorThemeKind.Light;break;case"hcDark":v=w.ColorThemeKind.HighContrast;break;case"hcLight":v=w.ColorThemeKind.HighContrastLight;break;default:v=w.ColorThemeKind.Dark}this.a=new w.$YO(v),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$xqc=O,e.$xqc=O=He([Ge(0,y.$2P)],O)}),define(Ie[93],Pe([1,0,22,6,4,191,3,12,224,5,27,17,7]),function(_,e,w,y,k,O,R,N,v,s,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aGb=e.$_Fb=e.TunnelDtoConverter=void 0,O=Ve(O),u=Ve(u);class C extends v.$Mw{}var d;(function(o){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?v.TunnelPrivacyId.Public:v.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=c;function h(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==v.TunnelPrivacyId.ConstantPrivate&&i.privacy!==v.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$_Fb=(0,R.$Gi)("IExtHostTunnelService");let n=class extends k.$Xc{constructor(c,h,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new y.$ne,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(s.$vN.MainThreadTunnelService)}async openTunnel(c,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const i=await this.a.$openTunnel(h,c.displayName);if(i){const r=new C(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,h){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:h}),this.a.$registerPortsAttributesProvider(c,i),new u.$xN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,h,i,r,t){const a=[];for(const g of c){const m=this.r.get(g);if(!m)return[];a.push(...await Promise.all(h.map(async $=>{let S;try{S=await m.provider.providePortAttributes({port:$,pid:i,commandLine:r},t)}catch{S=await m.provider.providePortAttributes($,i,r,t)}return{providedAttributes:S,port:$}})))}const l=a.filter(g=>!!g.providedAttributes);return l.length>0?l.map(g=>({autoForwardAction:g.providedAttributes.autoForwardAction,port:g.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,t)=>await c.provideTunnel(r,t,w.CancellationToken.None)??void 0;const i=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,k.$Vc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,h){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(h?this.w(h):void 0);if(i){this.b=i;let r=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const t=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,k.$Vc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,h){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(h&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const t=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:r,disposeListener:t}),d.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const h=await Promise.all(c.map(r=>this.f(r.host,r.port,r.detail??""))),i=c.filter((r,t)=>h[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$aGb=n,e.$aGb=n=He([Ge(0,E.$2P),Ge(1,I.$fQ),Ge(2,N.$ak)],n)}),define(Ie[8],Pe([1,0,18,23,150,273,60,29,137,49,73,26,143,24,35,15,2,106,33,158,94,53,108,77,116,115,235,249,81,90,55,56,246,7]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l,g,m,$,S,D,b,T,P,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$YP=$e,e.$ZP=Y,e.$1P=we,R=Ve(R),h=Ve(h),i=Ve(i),r=Ve(r),S=Ve(S),b=Ve(b),f=Ve(f);var M;(function(Ee){function Me(X){const{selectionStartLineNumber:De,selectionStartColumn:We,positionLineNumber:_e,positionColumn:Ke}=X,dt=new f.$yN(De-1,We-1),Rt=new f.$yN(_e-1,Ke-1);return new f.$AN(dt,Rt)}Ee.to=Me;function ge(X){const{anchor:De,active:We}=X;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Ee.from=ge})(M||(e.Selection=M={}));var L;(function(Ee){function Me(X){if(!X)return;const{start:De,end:We}=X;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Ee.from=Me;function ge(X){if(!X)return;const{startLineNumber:De,startColumn:We,endLineNumber:_e,endColumn:Ke}=X;return new f.$zN(De-1,We-1,_e-1,Ke-1)}Ee.to=ge})(L||(e.Range=L={}));var K;(function(Ee){function Me(X){return{uri:X.uri,range:L.from(X.range)}}Ee.from=Me;function ge(X){return new f.$JN(o.URI.revive(X.uri),L.to(X.range))}Ee.to=ge})(K||(e.Location=K={}));var J;(function(Ee){function Me(ge){switch(ge){case i.StandardTokenType.Comment:return f.StandardTokenType.Comment;case i.StandardTokenType.Other:return f.StandardTokenType.Other;case i.StandardTokenType.RegEx:return f.StandardTokenType.RegEx;case i.StandardTokenType.String:return f.StandardTokenType.String}}Ee.to=Me})(J||(e.TokenType=J={}));var z;(function(Ee){function Me(X){return new f.$yN(X.lineNumber-1,X.column-1)}Ee.to=Me;function ge(X){return{lineNumber:X.line+1,column:X.character+1}}Ee.from=ge})(z||(e.Position=z={}));var A;(function(Ee){function Me(De,We,_e){return(0,w.$Kb)((0,w.$5b)(De).map(Ke=>ge(Ke,We,_e)))}Ee.from=Me;function ge(De,We,_e){if(typeof De=="string")return{$serialized:!0,language:De,isBuiltin:_e?.isBuiltin};if(De)return{$serialized:!0,language:De.language,scheme:X(De.scheme,We),pattern:et.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType,isBuiltin:_e?.isBuiltin}}function X(De,We){return We&&typeof De=="string"?We.transformOutgoingScheme(De):De}})(A||(e.DocumentSelector=A={}));var W;(function(Ee){function Me(X){switch(X){case f.DiagnosticTag.Unnecessary:return a.MarkerTag.Unnecessary;case f.DiagnosticTag.Deprecated:return a.MarkerTag.Deprecated}}Ee.from=Me;function ge(X){switch(X){case a.MarkerTag.Unnecessary:return f.DiagnosticTag.Unnecessary;case a.MarkerTag.Deprecated:return f.DiagnosticTag.Deprecated;default:return}}Ee.to=ge})(W||(e.DiagnosticTag=W={}));var Z;(function(Ee){function Me(X){let De;return X.code&&((0,n.$gg)(X.code)||(0,n.$kg)(X.code)?De=String(X.code):De={value:String(X.code.value),target:X.code.target}),{...L.from(X.range),message:X.message,source:X.source,code:De,severity:ve.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(he.from),tags:Array.isArray(X.tags)?(0,w.$Kb)(X.tags.map(W.from)):void 0}}Ee.from=Me;function ge(X){const De=new f.$LN(L.to(X),X.message,ve.to(X.severity));return De.source=X.source,De.code=(0,n.$gg)(X.code)?X.code:X.code?.value,De.relatedInformation=X.relatedInformation&&X.relatedInformation.map(he.to),De.tags=X.tags&&(0,w.$Kb)(X.tags.map(W.to)),De}Ee.to=ge})(Z||(e.Diagnostic=Z={}));var he;(function(Ee){function Me(X){return{...L.from(X.location.range),message:X.message,resource:X.location.uri}}Ee.from=Me;function ge(X){return new f.$KN(new f.$JN(X.resource,L.to(X)),X.message)}Ee.to=ge})(he||(e.DiagnosticRelatedInformation=he={}));var ve;(function(Ee){function Me(X){switch(X){case f.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}Ee.from=Me;function ge(X){switch(X){case a.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}Ee.to=ge})(ve||(e.DiagnosticSeverity=ve={}));var be;(function(Ee){function Me(X){return typeof X=="number"&&X>=f.ViewColumn.One?X-1:X===f.ViewColumn.Beside?p.$qE:p.$pE}Ee.from=Me;function ge(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ge})(be||(e.ViewColumn=be={}));function de(Ee){return typeof Ee.range<"u"}function $e(Ee){return Ee.length===0?!0:!!de(Ee[0])}var ye;(function(Ee){function Me(Ke){return Ke.map(Ee.from)}Ee.fromMany=Me;function ge(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function X(Ke){let dt;if(ge(Ke)){const{language:jt,value:di}=Ke;dt={value:"```"+jt+`
`+di+"\n```\n"}}else f.$ZN.isMarkdownString(Ke)?dt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?dt={value:Ke}:dt={value:""};const Rt=Object.create(null);dt.uris=Rt;const Jt=jt=>{try{let di=o.URI.parse(jt,!0);di=di.with({query:De(di.query,Rt)}),Rt[jt]=di}catch{}return""},ci=new v.marked.Renderer;return ci.link=Jt,ci.image=jt=>typeof jt=="string"?Jt(R.$_k(jt).href):"",(0,v.marked)(dt.value,{renderer:ci}),dt}Ee.from=X;function De(Ke,dt){if(!Ke)return Ke;let Rt;try{Rt=(0,s.$ci)(Ke)}catch{}if(!Rt)return Ke;let Jt=!1;return Rt=(0,E.$ho)(Rt,ci=>{if(o.URI.isUri(ci)){const jt=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[jt]=ci,Jt=!0,jt}else return}),Jt?JSON.stringify(Rt):Ke}function We(Ke){const dt=new f.$ZN(Ke.value,Ke.supportThemeIcons);return dt.isTrusted=Ke.isTrusted,dt.supportHtml=Ke.supportHtml,dt.baseUri=Ke.baseUri?o.URI.from(Ke.baseUri):void 0,dt}Ee.to=We;function _e(Ke){if(Ke)return typeof Ke=="string"?Ke:Ee.from(Ke)}Ee.fromStrict=_e})(ye||(e.MarkdownString=ye={}));function Y(Ee){return $e(Ee)?Ee.map(Me=>({range:L.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?ye.fromMany(Me.hoverMessage):Me.hoverMessage?ye.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ee.map(Me=>({range:L.from(Me)}))}function we(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?o.URI.file(Ee):Ee}var Te;(function(Ee){function Me(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?we(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ee.from=Me})(Te||(e.ThemableDecorationAttachmentRenderOptions=Te={}));var re;(function(Ee){function Me(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?we(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?Te.from(ge.before):void 0,after:ge.after?Te.from(ge.after):void 0}}Ee.from=Me})(re||(e.ThemableDecorationRenderOptions=re={}));var q;(function(Ee){function Me(ge){if(typeof ge>"u")return ge;switch(ge){case f.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case f.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case f.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case f.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ee.from=Me})(q||(e.DecorationRangeBehavior=q={}));var ae;(function(Ee){function Me(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?q.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?re.from(ge.light):void 0,dark:ge.dark?re.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?we(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?Te.from(ge.before):void 0,after:ge.after?Te.from(ge.after):void 0}}Ee.from=Me})(ae||(e.DecorationRenderOptions=ae={}));var le;(function(Ee){function Me(X){return{text:X.newText,eol:X.newEol&&Be.from(X.newEol),range:L.from(X.range)}}Ee.from=Me;function ge(X){const De=new f.$EN(L.to(X.range),X.text);return De.newEol=typeof X.eol>"u"?void 0:Be.to(X.eol),De}Ee.to=ge})(le||(e.TextEdit=le={}));var ne;(function(Ee){function Me(X,De){const We={edits:[]};if(X instanceof f.$HN){const _e=new N.$Ec;for(const Ke of X._allEntries())Ke._type===f.FileEditType.File&&o.URI.isUri(Ke.to)&&Ke.from===void 0&&_e.add(Ke.to);for(const Ke of X._allEntries())if(Ke._type===f.FileEditType.File){let dt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?dt={type:"base64",value:(0,y.$0e)(y.$Pe.wrap(Ke.options.contents))}:dt={type:"dataTransferItem",id:Ke.options.contents._itemId}),We.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:dt},metadata:Ke.metadata})}else Ke._type===f.FileEditType.Text?We.edits.push({resource:Ke.uri,textEdit:le.from(Ke.edit),versionId:_e.has(Ke.uri)?void 0:De?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===f.FileEditType.Snippet?We.edits.push({resource:Ke.uri,textEdit:{range:L.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:_e.has(Ke.uri)?void 0:De?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===f.FileEditType.Cell?We.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===f.FileEditType.CellReplace&&We.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:De?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:b.CellEditType.Replace,index:Ke.index,count:Ke.count,cells:Ke.cells.map(xe.from)}})}return We}Ee.from=Me;function ge(X){const De=new f.$HN,We=new N.$Dc;for(const _e of X.edits)if(_e.textEdit){const Ke=_e,dt=o.URI.revive(Ke.resource),Rt=L.to(Ke.textEdit.range),Jt=Ke.textEdit.text,ci=Ke.textEdit.insertAsSnippet;let jt;ci?jt=f.$GN.replace(Rt,new f.$IN(Jt)):jt=f.$EN.replace(Rt,Jt);const di=We.get(dt);di?di.push(jt):We.set(dt,[jt])}else De.renameFile(o.URI.revive(_e.oldResource),o.URI.revive(_e.newResource),_e.options);for(const[_e,Ke]of We)De.set(_e,Ke);return De}Ee.to=ge})(ne||(e.WorkspaceEdit=ne={}));var ce;(function(Ee){const Me=Object.create(null);Me[f.SymbolKind.File]=r.SymbolKind.File,Me[f.SymbolKind.Module]=r.SymbolKind.Module,Me[f.SymbolKind.Namespace]=r.SymbolKind.Namespace,Me[f.SymbolKind.Package]=r.SymbolKind.Package,Me[f.SymbolKind.Class]=r.SymbolKind.Class,Me[f.SymbolKind.Method]=r.SymbolKind.Method,Me[f.SymbolKind.Property]=r.SymbolKind.Property,Me[f.SymbolKind.Field]=r.SymbolKind.Field,Me[f.SymbolKind.Constructor]=r.SymbolKind.Constructor,Me[f.SymbolKind.Enum]=r.SymbolKind.Enum,Me[f.SymbolKind.Interface]=r.SymbolKind.Interface,Me[f.SymbolKind.Function]=r.SymbolKind.Function,Me[f.SymbolKind.Variable]=r.SymbolKind.Variable,Me[f.SymbolKind.Constant]=r.SymbolKind.Constant,Me[f.SymbolKind.String]=r.SymbolKind.String,Me[f.SymbolKind.Number]=r.SymbolKind.Number,Me[f.SymbolKind.Boolean]=r.SymbolKind.Boolean,Me[f.SymbolKind.Array]=r.SymbolKind.Array,Me[f.SymbolKind.Object]=r.SymbolKind.Object,Me[f.SymbolKind.Key]=r.SymbolKind.Key,Me[f.SymbolKind.Null]=r.SymbolKind.Null,Me[f.SymbolKind.EnumMember]=r.SymbolKind.EnumMember,Me[f.SymbolKind.Struct]=r.SymbolKind.Struct,Me[f.SymbolKind.Event]=r.SymbolKind.Event,Me[f.SymbolKind.Operator]=r.SymbolKind.Operator,Me[f.SymbolKind.TypeParameter]=r.SymbolKind.TypeParameter;function ge(De){return typeof Me[De]=="number"?Me[De]:r.SymbolKind.Property}Ee.from=ge;function X(De){for(const We in Me)if(Me[We]===De)return Number(We);return f.SymbolKind.Property}Ee.to=X})(ce||(e.SymbolKind=ce={}));var oe;(function(Ee){function Me(X){switch(X){case f.SymbolTag.Deprecated:return r.SymbolTag.Deprecated}}Ee.from=Me;function ge(X){switch(X){case r.SymbolTag.Deprecated:return f.SymbolTag.Deprecated}}Ee.to=ge})(oe||(e.SymbolTag=oe={}));var H;(function(Ee){function Me(X){return{name:X.name,kind:ce.from(X.kind),tags:X.tags&&X.tags.map(oe.from),containerName:X.containerName,location:je.from(X.location)}}Ee.from=Me;function ge(X){const De=new f.$QN(X.name,ce.to(X.kind),X.containerName,je.to(X.location));return De.tags=X.tags&&X.tags.map(oe.to),De}Ee.to=ge})(H||(e.WorkspaceSymbol=H={}));var x;(function(Ee){function Me(X){const De={name:X.name||"!!MISSING: name!!",detail:X.detail,range:L.from(X.range),selectionRange:L.from(X.selectionRange),kind:ce.from(X.kind),tags:X.tags?.map(oe.from)??[]};return X.children&&(De.children=X.children.map(Me)),De}Ee.from=Me;function ge(X){const De=new f.$RN(X.name,X.detail,ce.to(X.kind),L.to(X.range),L.to(X.selectionRange));return(0,w.$Ob)(X.tags)&&(De.tags=X.tags.map(oe.to)),X.children&&(De.children=X.children.map(ge)),De}Ee.to=ge})(x||(e.DocumentSymbol=x={}));var ue;(function(Ee){function Me(X){const De=new f.$VN(ce.to(X.kind),X.name,X.detail||"",o.URI.revive(X.uri),L.to(X.range),L.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}Ee.to=Me;function ge(X,De,We){if(De=De??X._sessionId,We=We??X._itemId,De===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:We,name:X.name,detail:X.detail,kind:ce.from(X.kind),uri:X.uri,range:L.from(X.range),selectionRange:L.from(X.selectionRange),tags:X.tags?.map(oe.from)}}Ee.from=ge})(ue||(e.CallHierarchyItem=ue={}));var me;(function(Ee){function Me(ge){return new f.$WN(ue.to(ge.from),ge.fromRanges.map(X=>L.to(X)))}Ee.to=Me})(me||(e.CallHierarchyIncomingCall=me={}));var Oe;(function(Ee){function Me(ge){return new f.$XN(ue.to(ge.to),ge.fromRanges.map(X=>L.to(X)))}Ee.to=Me})(Oe||(e.CallHierarchyOutgoingCall=Oe={}));var je;(function(Ee){function Me(X){return{range:X.range&&L.from(X.range),uri:X.uri}}Ee.from=Me;function ge(X){return new f.$JN(o.URI.revive(X.uri),L.to(X.range))}Ee.to=ge})(je||(e.location=je={}));var ke;(function(Ee){function Me(X){const De=X,We=X;return{originSelectionRange:De.originSelectionRange?L.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:We.uri,range:L.from(De.targetRange?De.targetRange:We.range),targetSelectionRange:De.targetSelectionRange?L.from(De.targetSelectionRange):void 0}}Ee.from=Me;function ge(X){return{targetUri:o.URI.revive(X.uri),targetRange:L.to(X.range),targetSelectionRange:X.targetSelectionRange?L.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?L.to(X.originSelectionRange):void 0}}Ee.to=ge})(ke||(e.DefinitionLink=ke={}));var Ae;(function(Ee){function Me(X){return{range:L.from(X.range),contents:ye.fromMany(X.contents),canIncreaseVerbosity:X.canIncreaseVerbosity,canDecreaseVerbosity:X.canDecreaseVerbosity}}Ee.from=Me;function ge(X){const De=X.contents.map(ye.to),We=L.to(X.range),_e=X.canIncreaseVerbosity,Ke=X.canDecreaseVerbosity;return new f.$NN(De,We,_e,Ke)}Ee.to=ge})(Ae||(e.Hover=Ae={}));var Ne;(function(Ee){function Me(X){return{range:L.from(X.range),expression:X.expression}}Ee.from=Me;function ge(X){return new f.$IO(L.to(X.range),X.expression)}Ee.to=ge})(Ne||(e.EvaluatableExpression=Ne={}));var U;(function(Ee){function Me(X){if(X instanceof f.$JO)return{type:"text",range:L.from(X.range),text:X.text};if(X instanceof f.$KO)return{type:"variable",range:L.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof f.$LO)return{type:"expression",range:L.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Me;function ge(X){switch(X.type){case"text":return{range:L.to(X.range),text:X.text};case"variable":return{range:L.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:L.to(X.range),expression:X.expression}}}Ee.to=ge})(U||(e.InlineValue=U={}));var B;(function(Ee){function Me(X){return{frameId:X.frameId,stoppedLocation:L.from(X.stoppedLocation)}}Ee.from=Me;function ge(X){return new f.$MO(X.frameId,L.to(X.stoppedLocation))}Ee.to=ge})(B||(e.InlineValueContext=B={}));var G;(function(Ee){function Me(X){return{range:L.from(X.range),kind:X.kind}}Ee.from=Me;function ge(X){return new f.$ON(L.to(X.range),X.kind)}Ee.to=ge})(G||(e.DocumentHighlight=G={}));var Q;(function(Ee){function Me(X){return{uri:X.uri,highlights:X.highlights.map(G.from)}}Ee.from=Me;function ge(X){return new f.$PN(o.URI.revive(X.uri),X.highlights.map(G.to))}Ee.to=ge})(Q||(e.MultiDocumentHighlight=Q={}));var ee;(function(Ee){function Me(ge){switch(ge){case r.CompletionTriggerKind.TriggerCharacter:return f.CompletionTriggerKind.TriggerCharacter;case r.CompletionTriggerKind.TriggerForIncompleteCompletions:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case r.CompletionTriggerKind.Invoke:default:return f.CompletionTriggerKind.Invoke}}Ee.to=Me})(ee||(e.CompletionTriggerKind=ee={}));var fe;(function(Ee){function Me(ge){return{triggerKind:ee.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ee.to=Me})(fe||(e.CompletionContext=fe={}));var Re;(function(Ee){function Me(X){switch(X){case f.CompletionItemTag.Deprecated:return r.CompletionItemTag.Deprecated}}Ee.from=Me;function ge(X){switch(X){case r.CompletionItemTag.Deprecated:return f.CompletionItemTag.Deprecated}}Ee.to=ge})(Re||(e.CompletionItemTag=Re={}));var Ue;(function(Ee){const Me=new Map([[f.CompletionItemKind.Method,r.CompletionItemKind.Method],[f.CompletionItemKind.Function,r.CompletionItemKind.Function],[f.CompletionItemKind.Constructor,r.CompletionItemKind.Constructor],[f.CompletionItemKind.Field,r.CompletionItemKind.Field],[f.CompletionItemKind.Variable,r.CompletionItemKind.Variable],[f.CompletionItemKind.Class,r.CompletionItemKind.Class],[f.CompletionItemKind.Interface,r.CompletionItemKind.Interface],[f.CompletionItemKind.Struct,r.CompletionItemKind.Struct],[f.CompletionItemKind.Module,r.CompletionItemKind.Module],[f.CompletionItemKind.Property,r.CompletionItemKind.Property],[f.CompletionItemKind.Unit,r.CompletionItemKind.Unit],[f.CompletionItemKind.Value,r.CompletionItemKind.Value],[f.CompletionItemKind.Constant,r.CompletionItemKind.Constant],[f.CompletionItemKind.Enum,r.CompletionItemKind.Enum],[f.CompletionItemKind.EnumMember,r.CompletionItemKind.EnumMember],[f.CompletionItemKind.Keyword,r.CompletionItemKind.Keyword],[f.CompletionItemKind.Snippet,r.CompletionItemKind.Snippet],[f.CompletionItemKind.Text,r.CompletionItemKind.Text],[f.CompletionItemKind.Color,r.CompletionItemKind.Color],[f.CompletionItemKind.File,r.CompletionItemKind.File],[f.CompletionItemKind.Reference,r.CompletionItemKind.Reference],[f.CompletionItemKind.Folder,r.CompletionItemKind.Folder],[f.CompletionItemKind.Event,r.CompletionItemKind.Event],[f.CompletionItemKind.Operator,r.CompletionItemKind.Operator],[f.CompletionItemKind.TypeParameter,r.CompletionItemKind.TypeParameter],[f.CompletionItemKind.Issue,r.CompletionItemKind.Issue],[f.CompletionItemKind.User,r.CompletionItemKind.User]]);function ge(We){return Me.get(We)??r.CompletionItemKind.Property}Ee.from=ge;const X=new Map([[r.CompletionItemKind.Method,f.CompletionItemKind.Method],[r.CompletionItemKind.Function,f.CompletionItemKind.Function],[r.CompletionItemKind.Constructor,f.CompletionItemKind.Constructor],[r.CompletionItemKind.Field,f.CompletionItemKind.Field],[r.CompletionItemKind.Variable,f.CompletionItemKind.Variable],[r.CompletionItemKind.Class,f.CompletionItemKind.Class],[r.CompletionItemKind.Interface,f.CompletionItemKind.Interface],[r.CompletionItemKind.Struct,f.CompletionItemKind.Struct],[r.CompletionItemKind.Module,f.CompletionItemKind.Module],[r.CompletionItemKind.Property,f.CompletionItemKind.Property],[r.CompletionItemKind.Unit,f.CompletionItemKind.Unit],[r.CompletionItemKind.Value,f.CompletionItemKind.Value],[r.CompletionItemKind.Constant,f.CompletionItemKind.Constant],[r.CompletionItemKind.Enum,f.CompletionItemKind.Enum],[r.CompletionItemKind.EnumMember,f.CompletionItemKind.EnumMember],[r.CompletionItemKind.Keyword,f.CompletionItemKind.Keyword],[r.CompletionItemKind.Snippet,f.CompletionItemKind.Snippet],[r.CompletionItemKind.Text,f.CompletionItemKind.Text],[r.CompletionItemKind.Color,f.CompletionItemKind.Color],[r.CompletionItemKind.File,f.CompletionItemKind.File],[r.CompletionItemKind.Reference,f.CompletionItemKind.Reference],[r.CompletionItemKind.Folder,f.CompletionItemKind.Folder],[r.CompletionItemKind.Event,f.CompletionItemKind.Event],[r.CompletionItemKind.Operator,f.CompletionItemKind.Operator],[r.CompletionItemKind.TypeParameter,f.CompletionItemKind.TypeParameter],[r.CompletionItemKind.User,f.CompletionItemKind.User],[r.CompletionItemKind.Issue,f.CompletionItemKind.Issue]]);function De(We){return X.get(We)??f.CompletionItemKind.Property}Ee.to=De})(Ue||(e.CompletionItemKind=Ue={}));var Qe;(function(Ee){function Me(ge,X){const De=new f.$6N(ge.label);return De.insertText=ge.insertText,De.kind=Ue.to(ge.kind),De.tags=ge.tags?.map(Re.to),De.detail=ge.detail,De.documentation=R.$6k(ge.documentation)?ye.to(ge.documentation):ge.documentation,De.sortText=ge.sortText,De.filterText=ge.filterText,De.preselect=ge.preselect,De.commitCharacters=ge.commitCharacters,h.$Nt.isIRange(ge.range)?De.range=L.to(ge.range):typeof ge.range=="object"&&(De.range={inserting:L.to(ge.range.insert),replacing:L.to(ge.range.replace)}),De.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&r.CompletionItemInsertTextRule.KeepWhitespace),typeof ge.insertTextRules<"u"&&ge.insertTextRules&r.CompletionItemInsertTextRule.InsertAsSnippet?De.insertText=new f.$IN(ge.insertText):(De.insertText=ge.insertText,De.textEdit=De.range instanceof f.$zN?new f.$EN(De.range,De.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(De.additionalTextEdits=ge.additionalTextEdits.map(We=>le.to(We))),De.command=X&&ge.command?X.fromInternal(ge.command):void 0,De}Ee.to=Me})(Qe||(e.CompletionItem=Qe={}));var Ye;(function(Ee){function Me(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:ye.fromStrict(X.documentation)}}Ee.from=Me;function ge(X){return{label:X.label,documentation:R.$6k(X.documentation)?ye.to(X.documentation):X.documentation}}Ee.to=ge})(Ye||(e.ParameterInformation=Ye={}));var it;(function(Ee){function Me(X){return{label:X.label,documentation:ye.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(Ye.from):[],activeParameter:X.activeParameter}}Ee.from=Me;function ge(X){return{label:X.label,documentation:R.$6k(X.documentation)?ye.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(Ye.to):[],activeParameter:X.activeParameter}}Ee.to=ge})(it||(e.SignatureInformation=it={}));var ot;(function(Ee){function Me(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(it.from):[]}}Ee.from=Me;function ge(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(it.to):[]}}Ee.to=ge})(ot||(e.SignatureHelp=ot={}));var tt;(function(Ee){function Me(ge,X){const De=new f.$5N(z.to(X.position),typeof X.label=="string"?X.label:X.label.map(at.to.bind(void 0,ge)),X.kind&&pt.to(X.kind));return De.textEdits=X.textEdits&&X.textEdits.map(le.to),De.tooltip=R.$6k(X.tooltip)?ye.to(X.tooltip):X.tooltip,De.paddingLeft=X.paddingLeft,De.paddingRight=X.paddingRight,De}Ee.to=Me})(tt||(e.InlayHint=tt={}));var at;(function(Ee){function Me(ge,X){const De=new f.$4N(X.label);return De.tooltip=R.$6k(X.tooltip)?ye.to(X.tooltip):X.tooltip,r.Command.is(X.command)&&(De.command=ge.fromInternal(X.command)),X.location&&(De.location=je.to(X.location)),De}Ee.to=Me})(at||(e.InlayHintLabelPart=at={}));var pt;(function(Ee){function Me(X){return X}Ee.from=Me;function ge(X){return X}Ee.to=ge})(pt||(e.InlayHintKind=pt={}));var ut;(function(Ee){function Me(X){return{range:L.from(X.range),url:X.target,tooltip:X.tooltip}}Ee.from=Me;function ge(X){let De;if(X.url)try{De=typeof X.url=="string"?o.URI.parse(X.url,!0):o.URI.revive(X.url)}catch{}const We=new f.$$N(L.to(X.range),De);return We.tooltip=X.tooltip,We}Ee.to=ge})(ut||(e.DocumentLink=ut={}));var st;(function(Ee){function Me(X){const De=new f.$bO(X.label);return X.textEdit&&(De.textEdit=le.to(X.textEdit)),X.additionalTextEdits&&(De.additionalTextEdits=X.additionalTextEdits.map(We=>le.to(We))),De}Ee.to=Me;function ge(X){return{label:X.label,textEdit:X.textEdit?le.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(De=>le.from(De)):void 0}}Ee.from=ge})(st||(e.ColorPresentation=st={}));var ht;(function(Ee){function Me(X){return new f.$_N(X[0],X[1],X[2],X[3])}Ee.to=Me;function ge(X){return[X.red,X.green,X.blue,X.alpha]}Ee.from=ge})(ht||(e.Color=ht={}));var mt;(function(Ee){function Me(X){return{range:L.from(X.range)}}Ee.from=Me;function ge(X){return new f.$UN(L.to(X.range))}Ee.to=ge})(mt||(e.SelectionRange=mt={}));var wt;(function(Ee){function Me(ge){switch(ge){case m.SaveReason.AUTO:return f.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return f.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return f.TextDocumentSaveReason.FocusOut}}Ee.to=Me})(wt||(e.TextDocumentSaveReason=wt={}));var qe;(function(Ee){function Me(X){switch(X){case f.TextEditorLineNumbersStyle.Off:return c.RenderLineNumbersType.Off;case f.TextEditorLineNumbersStyle.Relative:return c.RenderLineNumbersType.Relative;case f.TextEditorLineNumbersStyle.Interval:return c.RenderLineNumbersType.Interval;case f.TextEditorLineNumbersStyle.On:default:return c.RenderLineNumbersType.On}}Ee.from=Me;function ge(X){switch(X){case c.RenderLineNumbersType.Off:return f.TextEditorLineNumbersStyle.Off;case c.RenderLineNumbersType.Relative:return f.TextEditorLineNumbersStyle.Relative;case c.RenderLineNumbersType.Interval:return f.TextEditorLineNumbersStyle.Interval;case c.RenderLineNumbersType.On:default:return f.TextEditorLineNumbersStyle.On}}Ee.to=ge})(qe||(e.TextEditorLineNumbersStyle=qe={}));var Be;(function(Ee){function Me(X){if(X===f.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(X===f.EndOfLine.LF)return t.EndOfLineSequence.LF}Ee.from=Me;function ge(X){if(X===t.EndOfLineSequence.CRLF)return f.EndOfLine.CRLF;if(X===t.EndOfLineSequence.LF)return f.EndOfLine.LF}Ee.to=ge})(Be||(e.EndOfLine=Be={}));var te;(function(Ee){function Me(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case f.ProgressLocation.SourceControl:return l.ProgressLocation.Scm;case f.ProgressLocation.Window:return l.ProgressLocation.Window;case f.ProgressLocation.Notification:return l.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Me})(te||(e.ProgressLocation=te={}));var V;(function(Ee){function Me(X){const De={start:X.start+1,end:X.end+1};return X.kind&&(De.kind=Se.from(X.kind)),De}Ee.from=Me;function ge(X){const De={start:X.start-1,end:X.end-1};return X.kind&&(De.kind=Se.to(X.kind)),De}Ee.to=ge})(V||(e.FoldingRange=V={}));var Se;(function(Ee){function Me(X){if(X)switch(X){case f.FoldingRangeKind.Comment:return r.$Nu.Comment;case f.FoldingRangeKind.Imports:return r.$Nu.Imports;case f.FoldingRangeKind.Region:return r.$Nu.Region}}Ee.from=Me;function ge(X){if(X)switch(X.value){case r.$Nu.Comment.value:return f.FoldingRangeKind.Comment;case r.$Nu.Imports.value:return f.FoldingRangeKind.Imports;case r.$Nu.Region.value:return f.FoldingRangeKind.Region}}Ee.to=ge})(Se||(e.FoldingRangeKind=Se={}));var Xe;(function(Ee){function Me(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?L.from(ge.selection):void 0,override:typeof ge.override=="boolean"?m.$TF.id:void 0}}Ee.from=Me})(Xe||(e.TextEditorOpenOptions=Xe={}));var et;(function(Ee){function Me(We){return We instanceof f.$wO?We.toJSON():typeof We=="string"?We:ge(We)||X(We)?new f.$wO(We.baseUri??We.base,We.pattern).toJSON():We}Ee.from=Me;function ge(We){const _e=We;return _e?o.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function X(We){const _e=We;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function De(We){return typeof We=="string"?We:new f.$wO(o.URI.revive(We.baseUri),We.pattern)}Ee.to=De})(et||(e.GlobPattern=et={}));var ft;(function(Ee){function Me(ge){if(ge){if(Array.isArray(ge))return ge.map(Me);if(typeof ge=="string")return ge;{const X=ge;return{language:X.language,scheme:X.scheme,pattern:et.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}Ee.from=Me})(ft||(e.LanguageSelector=ft={}));var $t;(function(Ee){function Me(X){return!!X&&typeof X=="object"&&"documents"in X&&Array.isArray(X.documents)&&X.documents.every(De=>Array.isArray(De)&&De.every(We=>We&&typeof We=="object"&&"uri"in We&&o.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(_e=>_e instanceof f.$zN)))}Ee.is=Me;function ge(X){return{documents:X.documents.map(De=>De.map(We=>({uri:o.URI.from(We.uri),version:We.version,ranges:We.ranges.map(_e=>L.from(_e))})))}}Ee.from=ge})($t||(e.MappedEditsContext=$t={}));var Mt;(function(Ee){function Me(X){return{start:X.start,end:X.end}}Ee.from=Me;function ge(X){return new f.$ZO(X.start,X.end)}Ee.to=ge})(Mt||(e.NotebookRange=Mt={}));var Gt;(function(Ee){function Me(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}Ee.to=Me;function ge(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}Ee.from=ge})(Gt||(e.NotebookCellExecutionSummary=Gt={}));var ri;(function(Ee){function Me(ge){if(ge===b.NotebookCellExecutionState.Unconfirmed)return f.NotebookCellExecutionState.Pending;if(ge===b.NotebookCellExecutionState.Pending)return;if(ge===b.NotebookCellExecutionState.Executing)return f.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ee.to=Me})(ri||(e.NotebookCellExecutionState=ri={}));var li;(function(Ee){function Me(X){switch(X){case f.NotebookCellKind.Markup:return b.CellKind.Markup;case f.NotebookCellKind.Code:default:return b.CellKind.Code}}Ee.from=Me;function ge(X){switch(X){case b.CellKind.Markup:return f.NotebookCellKind.Markup;case b.CellKind.Code:default:return f.NotebookCellKind.Code}}Ee.to=ge})(li||(e.NotebookCellKind=li={}));var fi;(function(Ee){function Me(X){const De={metadata:X.metadata??Object.create(null),cells:[]};for(const We of X.cells)f.$1O.validate(We),De.cells.push(xe.from(We));return De}Ee.from=Me;function ge(X){const De=new f.$2O(X.cells.map(xe.to));return(0,n.$tg)(X.metadata)||(De.metadata=X.metadata),De}Ee.to=ge})(fi||(e.NotebookData=fi={}));var xe;(function(Ee){function Me(X){return{cellKind:li.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:Gt.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Qt.from):[]}}Ee.from=Me;function ge(X){return new f.$1O(li.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Qt.to):void 0,X.metadata,X.internalMetadata?Gt.to(X.internalMetadata):void 0)}Ee.to=ge})(xe||(e.NotebookCellData=xe={}));var Zt;(function(Ee){function Me(X){return{mime:X.mime,valueBytes:y.$Pe.wrap(X.data)}}Ee.from=Me;function ge(X){return new f.$3O(X.valueBytes.buffer,X.mime)}Ee.to=ge})(Zt||(e.NotebookCellOutputItem=Zt={}));var Qt;(function(Ee){function Me(X){return{outputId:X.id,items:X.items.map(Zt.from),metadata:X.metadata}}Ee.from=Me;function ge(X){const De=X.items.map(Zt.to);return new f.$4O(De,X.outputId,X.metadata)}Ee.to=ge})(Qt||(e.NotebookCellOutput=Qt={}));var vt;(function(Ee){function Me(De){return X(De)?{include:et.from(De.include)??void 0,exclude:et.from(De.exclude)??void 0}:et.from(De)??void 0}Ee.from=Me;function ge(De){return X(De)?{include:et.to(De.include),exclude:et.to(De.exclude)}:et.to(De)}Ee.to=ge;function X(De){const We=De;return We?!(0,n.$pg)(We.include)&&!(0,n.$pg)(We.exclude):!1}})(vt||(e.NotebookExclusiveDocumentPattern=vt={}));var St;(function(Ee){function Me(ge,X,De){const We=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===f.NotebookCellStatusBarAlignment.Left?b.CellStatusbarAlignment.Left:b.CellStatusbarAlignment.Right,command:X.toInternal(We,De),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ee.from=Me})(St||(e.NotebookStatusBarItem=St={}));var si;(function(Ee){function Me(ge,X,De){const We=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:X.toInternal(We,De),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ee.from=Me})(si||(e.NotebookKernelSourceAction=si={}));var Yt;(function(Ee){function Me(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ee.from=Me})(Yt||(e.NotebookDocumentContentOptions=Yt={}));var Bt;(function(Ee){function Me(X){return{uri:X.uri,provides:X.provides}}Ee.from=Me;function ge(X){return new f.$6O(o.URI.revive(X.uri),X.provides)}Ee.to=ge})(Bt||(e.NotebookRendererScript=Bt={}));var bt;(function(Ee){function Me(X){return{message:ye.fromStrict(X.message)||"",type:P.TestMessageType.Error,expected:X.expectedOutput,actual:X.actualOutput,contextValue:X.contextValue,location:X.location&&{range:L.from(X.location.range),uri:X.location.uri}}}Ee.from=Me;function ge(X){const De=new f.$_O(typeof X.message=="string"?X.message:ye.to(X.message));return De.actualOutput=X.actual,De.expectedOutput=X.expected,De.contextValue=X.contextValue,De.location=X.location?je.to(X.location):void 0,De}Ee.to=ge})(bt||(e.TestMessage=bt={}));var At;(function(Ee){Ee.namespace=P.$ZI,Ee.denamespace=P.$1I})(At||(e.TestTag=At={}));var xt;(function(Ee){function Me(X){const De=(0,g.$XP)(X).controllerId;return{extId:T.$UI.fromExtHostTestItem(X,De).toString(),label:X.label,uri:o.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(We=>At.namespace(De,We.id)),range:h.$Nt.lift(L.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&ye.fromStrict(X.error)||null}}Ee.from=Me;function ge(X){return{parent:void 0,error:void 0,id:T.$UI.fromString(X.extId).localId,label:X.label,uri:o.URI.revive(X.uri),tags:(X.tags||[]).map(De=>{const{tagId:We}=At.denamespace(De);return new f.$aP(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:L.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}Ee.toPlain=ge})(xt||(e.TestItem=xt={})),function(Ee){function Me(X){return{id:X.id}}Ee.from=Me;function ge(X){return new f.$aP(X.id)}Ee.to=ge}(At||(e.TestTag=At={}));var Wt;(function(Ee){const Me=(X,De)=>{const We=X.value;if(!We)return;const _e={...xt.toPlain(We.item),parent:De,taskStates:We.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(dt=>dt.type===P.TestMessageType.Error).map(bt.to)})),children:[]};if(X.children)for(const Ke of X.children.values()){const dt=Me(Ke,_e);dt&&_e.children.push(dt)}return _e};function ge(X){const De=new u.$TI;for(const Ke of X.items)De.insert(T.$UI.fromString(Ke.item.extId).path,Ke);const We=[De.nodes],_e=[];for(;We.length;)for(const Ke of We.pop())Ke.value?_e.push(Ke):Ke.children&&We.push(Ke.children.values());return{completedAt:X.completedAt,results:_e.map(Ke=>Me(Ke)).filter(n.$og)}}Ee.to=ge})(Wt||(e.TestResults=Wt={}));var Ze;(function(Ee){function Me(We){return{covered:We.covered,total:We.total}}function ge(We){return"line"in We?z.from(We):L.from(We)}function X(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ge(We.location),type:P.DetailType.Statement,branches:We.branches.length?We.branches.map(_e=>({count:_e.executed,location:_e.location&&ge(_e.location),label:_e.label})):void 0}:{type:P.DetailType.Declaration,name:We.name,count:We.executed,location:ge(We.location)}}Ee.fromDetails=X;function De(We,_e,Ke){return f.$cP(Ke.statementCoverage),f.$cP(Ke.branchCoverage),f.$cP(Ke.declarationCoverage),{id:_e,uri:Ke.uri,statement:Me(Ke.statementCoverage),branch:Ke.branchCoverage&&Me(Ke.branchCoverage),declaration:Ke.declarationCoverage&&Me(Ke.declarationCoverage),testIds:Ke instanceof f.$dP&&Ke.fromTests.length?Ke.fromTests.map(dt=>T.$UI.fromExtHostTestItem(dt,We).toString()):void 0}}Ee.fromFile=De})(Ze||(e.TestCoverage=Ze={}));var _t;(function(Ee){function Me(ge){switch(ge){case r.CodeActionTriggerType.Invoke:return f.CodeActionTriggerKind.Invoke;case r.CodeActionTriggerType.Auto:return f.CodeActionTriggerKind.Automatic}}Ee.to=Me})(_t||(e.CodeActionTriggerKind=_t={}));var oi;(function(Ee){function Me(X){const De=new f.$hP(ce.to(X.kind),X.name,X.detail||"",o.URI.revive(X.uri),L.to(X.range),L.to(X.selectionRange));return De._sessionId=X._sessionId,De._itemId=X._itemId,De}Ee.to=Me;function ge(X,De,We){if(De=De??X._sessionId,We=We??X._itemId,De===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:We,kind:ce.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:L.from(X.range),selectionRange:L.from(X.selectionRange),tags:X.tags?.map(oe.from)}}Ee.from=ge})(oi||(e.TypeHierarchyItem=oi={}));var gi;(function(Ee){function Me(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ee.from=Me})(gi||(e.ViewBadge=gi={}));var It;(function(Ee){function Me(We,_e,Ke){const dt=_e.fileData;return dt?new f.$oO(new f.$pO(dt.name,o.URI.revive(dt.uri),dt.id,(0,O.$gb)(()=>Ke(dt.id)))):We===I.$0s.uriList&&_e.uriListData?new f.$nO(De(_e.uriListData)):new f.$nO(_e.asString)}Ee.to=Me;async function ge(We,_e){const Ke=await _e.asString();if(We===I.$0s.uriList)return{asString:Ke,fileData:void 0,uriListData:X(Ke)};const dt=_e.asFile();return{asString:Ke,fileData:dt?{name:dt.name,uri:dt.uri,id:dt._itemId??dt.id}:void 0}}Ee.from=ge;function X(We){return k.$ru.split(We).map(_e=>{if(_e.startsWith("#"))return _e;try{return o.URI.parse(_e)}catch{}return _e})}function De(We){return k.$ru.create(We.map(_e=>typeof _e=="string"?_e:o.URI.revive(_e)))}})(It||(e.DataTransferItem=It={}));var qt;(function(Ee){function Me(X,De){const We=X.items.map(([_e,Ke])=>[_e,It.to(_e,Ke,De)]);return new f.$qO(We)}Ee.toDataTransfer=Me;async function ge(X){const De={items:[]},We=[];for(const[_e,Ke]of X)We.push((async()=>{De.items.push([_e,await It.from(_e,Ke)])})());return await Promise.all(We),De}Ee.from=ge})(qt||(e.DataTransfer=qt={}));var Lt;(function(Ee){function Me(X,De){return{kind:"reply",agentId:X.participant??De?.agentId??"",subCommand:X.command??De?.command,message:X.prompt,title:X.label}}Ee.from=Me;function ge(X){return{prompt:X.message,label:X.title,participant:X.agentId,command:X.subCommand}}Ee.to=ge})(Lt||(e.ChatFollowup=Lt={}));var Vt;(function(Ee){function Me(X){switch(X){case S.ChatMessageRole.System:return f.LanguageModelChatMessageRole.System;case S.ChatMessageRole.User:return f.LanguageModelChatMessageRole.User;case S.ChatMessageRole.Assistant:return f.LanguageModelChatMessageRole.Assistant}}Ee.to=Me;function ge(X){switch(X){case f.LanguageModelChatMessageRole.System:return S.ChatMessageRole.System;case f.LanguageModelChatMessageRole.User:return S.ChatMessageRole.User;case f.LanguageModelChatMessageRole.Assistant:return S.ChatMessageRole.Assistant}return S.ChatMessageRole.User}Ee.from=ge})(Vt||(e.LanguageModelChatMessageRole=Vt={}));var pi;(function(Ee){function Me(X){let De="",We;X.content.type==="text"?De=X.content.value:We=new f.$IP(X.content.name,X.content.value,X.content.isError);const _e=Vt.to(X.role),Ke=new f.$JP(_e,De,X.name);return We!==void 0&&(Ke.content2=We),Ke}Ee.to=Me;function ge(X){const De=Vt.from(X.role),We=X.name;let _e;return X.content2 instanceof f.$IP?_e={type:"function_result",name:X.content2.name,value:X.content2.content,isError:X.content2.isError}:_e={type:"text",value:X.content},{role:De,name:We,content:_e}}Ee.from=ge})(pi||(e.LanguageModelChatMessage=pi={}));var ei;(function(Ee){function Me(X){return{kind:"markdownContent",content:ye.from(X.value)}}Ee.from=Me;function ge(X){return new f.$uP(ye.to(X.content))}Ee.to=ge})(ei||(e.ChatResponseMarkdownPart=ei={}));var ui;(function(Ee){function Me(X){return{kind:"markdownVuln",content:ye.from(X.value),vulnerabilities:X.vulnerabilities}}Ee.from=Me;function ge(X){return new f.$vP(ye.to(X.content),X.vulnerabilities)}Ee.to=ge})(ui||(e.ChatResponseMarkdownWithVulnerabilitiesPart=ui={}));var Ft;(function(Ee){function Me(X){return{kind:"agentDetection",agentId:X.participant,command:X.command}}Ee.from=Me;function ge(X){return new f.$wP(X.agentId,X.command)}Ee.to=ge})(Ft||(e.ChatResponseDetectedParticipantPart=Ft={}));var Ht;(function(Ee){function Me(ge){return{kind:"confirmation",title:ge.title,message:ge.message,data:ge.data}}Ee.from=Me})(Ht||(e.ChatResponseConfirmationPart=Ht={}));var ti;(function(Ee){function Me(X){const{value:De,baseUri:We}=X;function _e(Ke,dt){return Ke.map(Rt=>{const Jt=o.URI.joinPath(dt,Rt.name);return{label:Rt.name,uri:Jt,children:Rt.children&&_e(Rt.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,C.$eh)(We),uri:We,children:_e(De,We)}}}Ee.from=Me;function ge(X){const De=(0,s.$di)(X.treeData);function We(dt){return dt.map(Rt=>({name:Rt.label,children:Rt.children&&We(Rt.children)}))}const _e=De.uri,Ke=De.children?We(De.children):[];return new f.$yP(Ke,_e)}Ee.to=ge})(ti||(e.ChatResponseFilesPart=ti={}));var Tt;(function(Ee){function Me(X){const De=We=>o.URI.isUri(We);return{kind:"inlineReference",name:X.title,inlineReference:De(X.value)?X.value:K.from(X.value)}}Ee.from=Me;function ge(X){const De=(0,s.$di)(X);return new f.$zP(o.URI.isUri(De.inlineReference)?De.inlineReference:K.to(De.inlineReference),X.name)}Ee.to=ge})(Tt||(e.ChatResponseAnchorPart=Tt={}));var Pt;(function(Ee){function Me(X){return{kind:"progressMessage",content:ye.from(X.value)}}Ee.from=Me;function ge(X){return new f.$AP(X.content.value)}Ee.to=ge})(Pt||(e.ChatResponseProgressPart=Pt={}));var Et;(function(Ee){function Me(X){return{kind:"warning",content:ye.from(X.value)}}Ee.from=Me;function ge(X){return new f.$CP(X.content.value)}Ee.to=ge})(Et||(e.ChatResponseWarningPart=Et={}));var ii;(function(Ee){function Me(ge){return{kind:"progressTask",content:ye.from(ge.value)}}Ee.from=Me})(ii||(e.ChatTask=ii={}));var yt;(function(Ee){function Me(ge){return{kind:"progressTaskResult",content:typeof ge=="string"?ye.from(ge):void 0}}Ee.from=Me})(yt||(e.ChatTaskResult=yt={}));var ai;(function(Ee){function Me(X,De,We){return{kind:"command",command:De.toInternal(X.value,We)??{command:X.value.command,title:X.value.title}}}Ee.from=Me;function ge(X,De){return new f.$DP(De.fromInternal(X.command)??{command:X.command.id,title:X.command.title})}Ee.to=ge})(ai||(e.ChatResponseCommandButtonPart=ai={}));var Kt;(function(Ee){function Me(X){return{kind:"textEdit",uri:X.uri,edits:X.edits.map(De=>le.from(De))}}Ee.from=Me;function ge(X){return new f.$FP(o.URI.revive(X.uri),X.edits.map(De=>le.to(De)))}Ee.to=ge})(Kt||(e.ChatResponseTextEditPart=Kt={}));var vi;(function(Ee){function Me(X){const De=d.ThemeIcon.isThemeIcon(X.iconPath)?X.iconPath:o.URI.isUri(X.iconPath)?{light:o.URI.revive(X.iconPath)}:X.iconPath&&"light"in X.iconPath&&"dark"in X.iconPath&&o.URI.isUri(X.iconPath.light)&&o.URI.isUri(X.iconPath.dark)?{light:o.URI.revive(X.iconPath.light),dark:o.URI.revive(X.iconPath.dark)}:void 0;return"variableName"in X.value?{kind:"reference",reference:{variableName:X.value.variableName,value:o.URI.isUri(X.value.value)||!X.value.value?X.value.value:K.from(X.value.value)},iconPath:De}:{kind:"reference",reference:o.URI.isUri(X.value)?X.value:K.from(X.value),iconPath:De}}Ee.from=Me;function ge(X){const De=(0,s.$di)(X),We=_e=>o.URI.isUri(_e)?_e:K.to(_e);return new f.$EP("variableName"in De.reference?{variableName:De.reference.variableName,value:De.reference.value&&We(De.reference.value)}:We(De.reference))}Ee.to=ge})(vi||(e.ChatResponseReferencePart=vi={}));var mi;(function(Ee){function Me(De,We,_e){return De instanceof f.$uP?ei.from(De):De instanceof f.$zP?Tt.from(De):De instanceof f.$EP?vi.from(De):De instanceof f.$AP?Pt.from(De):De instanceof f.$yP?ti.from(De):De instanceof f.$DP?ai.from(De,We,_e):De instanceof f.$FP?Kt.from(De):De instanceof f.$vP?ui.from(De):De instanceof f.$wP?Ft.from(De):De instanceof f.$CP?Et.from(De):{kind:"markdownContent",content:ye.from("")}}Ee.from=Me;function ge(De,We){switch(De.kind){case"reference":return vi.to(De);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return X(De,We)}}Ee.to=ge;function X(De,We){switch(De.kind){case"markdownContent":return ei.to(De);case"inlineReference":return Tt.to(De);case"progressMessage":return;case"treeData":return ti.to(De);case"command":return ai.to(De,We)}}Ee.toContent=X})(mi||(e.ChatResponsePart=mi={}));var bi;(function(Ee){function Me(ge){return{prompt:ge.message,command:ge.command,attempt:ge.attempt??0,enableCommandDetection:ge.enableCommandDetection??!0,references:ge.variables.variables.map(Ri.to),location:Ut.to(ge.location),acceptedConfirmationData:ge.acceptedConfirmationData,rejectedConfirmationData:ge.rejectedConfirmationData}}Ee.to=Me})(bi||(e.ChatAgentRequest=bi={}));var Ut;(function(Ee){function Me(X){switch(X){case $.ChatAgentLocation.Notebook:return f.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return f.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return f.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return f.ChatLocation.Editor}}Ee.to=Me;function ge(X){switch(X){case f.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case f.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case f.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case f.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}Ee.from=ge})(Ut||(e.ChatLocation=Ut={}));var Ri;(function(Ee){function Me(ge){const X=ge.value;if(!X)throw new Error("Invalid value reference");return{id:ge.id,name:ge.name,range:ge.range&&[ge.range.start,ge.range.endExclusive],value:(0,o.$yc)(X)?o.URI.revive(X):X&&typeof X=="object"&&"uri"in X&&"range"in X&&(0,o.$yc)(X.uri)?K.to((0,s.$di)(X)):X,modelDescription:ge.modelDescription}}Ee.to=Me})(Ri||(e.ChatAgentValueReference=Ri={}));var Fi;(function(Ee){function Me(ge,X,De){return{id:ge.id,label:ge.label,fullName:ge.fullName,icon:ge.icon?.id,value:ge.values[0].value,insertText:ge.insertText,detail:ge.detail,documentation:ge.documentation,command:X.toInternal(ge.command,De)}}Ee.from=Me})(Fi||(e.ChatAgentCompletionItem=Fi={}));var Nt;(function(Ee){function Me(ge){return{errorDetails:ge.errorDetails,metadata:ge.metadata}}Ee.to=Me})(Nt||(e.ChatAgentResult=Nt={}));var Ci;(function(Ee){function Me(ge,X,De){if(X.action.kind==="vote")return;const We=Nt.to(ge);if(X.action.kind==="command"){const _e=X.action.commandButton.command;return{action:{kind:"command",commandButton:{command:De.fromInternal(_e)??{command:_e.id,title:_e.title}}},result:We}}else return X.action.kind==="followUp"?{action:{kind:"followUp",followup:Lt.to(X.action.followup)},result:We}:X.action.kind==="inlineChat"?{action:{kind:"editor",accepted:X.action.action==="accepted"},result:We}:{action:X.action,result:We}}Ee.to=Me})(Ci||(e.ChatAgentUserActionEvent=Ci={}));var Ii;(function(Ee){function Me(ge,X,De){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand,shouldExecute:ge.shouldExecute}:"uri"in ge?{uri:ge.uri}:X.toInternal(ge,De)}Ee.from=Me})(Ii||(e.TerminalQuickFix=Ii={}));var yi;(function(Ee){function Me(ge){return{kind:hi.to(ge.kind)}}Ee.to=Me})(yi||(e.PartialAcceptInfo=yi={}));var hi;(function(Ee){function Me(ge){switch(ge){case r.PartialAcceptTriggerKind.Word:return f.PartialAcceptTriggerKind.Word;case r.PartialAcceptTriggerKind.Line:return f.PartialAcceptTriggerKind.Line;case r.PartialAcceptTriggerKind.Suggest:return f.PartialAcceptTriggerKind.Suggest;default:return f.PartialAcceptTriggerKind.Unknown}}Ee.to=Me})(hi||(e.PartialAcceptTriggerKind=hi={}));var zi;(function(Ee){function Me(ge,X){return{id:X,label:ge.label,description:ge.description,canEdit:ge.canEdit,collapsibleState:ge.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ge.contextValue}}Ee.from=Me})(zi||(e.DebugTreeItem=zi={}));var Ot;(function(Ee){function Me(ge){return{name:ge.name,description:ge.description,parametersSchema:ge.parametersSchema}}Ee.to=Me})(Ot||(e.LanguageModelToolDescription=Ot={}))}),define(Ie[274],Pe([1,0,5,17,8,39]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;let R=class{constructor(v,s){this.a=v.getProxy(w.$vN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>s.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,s,I){const E=new O.$Vw(k.WorkspaceEdit.from(v,this.b));return this.a.$tryApplyWorkspaceEdit(E,void 0,I?.isRefactoring??!1)}};e.$Joc=R,e.$Joc=R=He([Ge(0,y.$2P)],R)}),define(Ie[275],Pe([1,0,18,11,42,6,40,4,70,15,2,19,5,8,7,236,25]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=void 0,C=Ve(C),d=Ve(d);class c{constructor(t,a,l,g,m){this.j=t,this.k=a,this.l=l,this.m=g,this.n=m,this.b=v.$he.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let a=function(g){if(t.c){const m=new Error("Response stream has been closed");throw Error.captureStackTrace(m,g),m}};const t=this;this.b.reset();const l=(g,m)=>{if(typeof this.d>"u"&&"content"in g&&(this.d=this.b.elapsed()),m){const $=this.l.$handleProgressChunk(this.k.requestId,g),S={report:D=>{$?.then(b=>{b&&(d.$ZN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,C.ChatResponseWarningPart.from(D),b):this.l.$handleProgressChunk(this.k.requestId,C.ChatResponseReferencePart.from(D),b))})}};Promise.all([$,m?.(S)]).then(([D,b])=>{D!==void 0&&b!==void 0&&this.l.$handleProgressChunk(this.k.requestId,C.ChatTaskResult.from(b),D)})}else this.l.$handleProgressChunk(this.k.requestId,g)};this.g={markdown(g){a(this.markdown);const m=new d.$uP(g),$=C.ChatResponseMarkdownPart.from(m);return l($),this},markdownWithVulnerabilities(g,m){a(this.markdown),m&&(0,o.$8G)(t.j,"chatParticipantAdditions");const $=new d.$vP(g,m),S=C.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return l(S),this},filetree(g,m){a(this.filetree);const $=new d.$yP(g,m),S=C.ChatResponseFilesPart.from($);return l(S),this},anchor(g,m){a(this.anchor);const $=new d.$zP(g,m),S=C.ChatResponseAnchorPart.from($);return l(S),this},button(g){a(this.anchor);const m=new d.$DP(g),$=C.ChatResponseCommandButtonPart.from(m,t.m,t.n);return l($),this},progress(g,m){a(this.progress);const $=new d.$BP(g,m),S=m?C.ChatTask.from($):C.ChatResponseProgressPart.from($);return l(S,m),this},warning(g){a(this.progress),(0,o.$8G)(t.j,"chatParticipantAdditions");const m=new d.$CP(g),$=C.ChatResponseWarningPart.from(m);return l($),this},reference(g,m){if(a(this.reference),"variableName"in g&&(0,o.$8G)(t.j,"chatParticipantAdditions"),"variableName"in g&&!g.value){const $=t.k.variables.variables.find(S=>S.name===g.variableName);if($){let S;if($.references?.length)S=$.references.map(D=>({kind:"reference",reference:{variableName:g.variableName,value:D.reference}}));else{const D=new d.$EP(g,m);S=[C.ChatResponseReferencePart.from(D)]}return S.forEach(D=>l(D)),this}}else{const $=new d.$EP(g,m),S=C.ChatResponseReferencePart.from($);l(S)}return this},textEdit(g,m){a(this.textEdit),(0,o.$8G)(t.j,"chatParticipantAdditions");const $=new d.$FP(g,m),S=C.ChatResponseTextEditPart.from($);return l(S),this},detectedParticipant(g,m){a(this.detectedParticipant),(0,o.$8G)(t.j,"chatParticipantAdditions");const $=new d.$wP(g,m),S=C.ChatResponseDetectedParticipantPart.from($);return l(S),this},confirmation(g,m,$){a(this.confirmation),(0,o.$8G)(t.j,"chatParticipantAdditions");const S=new d.$xP(g,m,$),D=C.ChatResponseConfirmationPart.from(S);return l(D),this},push(g){if(a(this.push),(g instanceof d.$FP||g instanceof d.$vP||g instanceof d.$wP||g instanceof d.$CP||g instanceof d.$xP)&&(0,o.$8G)(t.j,"chatParticipantAdditions"),g instanceof d.$EP)this.reference(g.value,g.iconPath);else{const m=C.ChatResponsePart.from(g,t.m,t.n);l(m)}return this}}}return this.g}}class h extends N.$Xc{constructor(t,a,l){super(),this.n=a,this.s=l,this.c=new Map,this.j=this.B(new N.$7c),this.m=this.B(new N.$7c),this.g=t.getProxy(u.$vN.MainThreadChatAgents2)}transferActiveChat(t){this.g.$transferActiveChatSession(t)}createChatAgent(t,a,l){const g=h.b++,m=new i(t,a,this.g,g,l);return this.c.set(g,m),this.g.$registerAgent(g,t.identifier,a,{},void 0),m.apiAgent}createDynamicChatAgent(t,a,l,g){const m=h.b++,$=new i(t,a,this.g,m,g);return this.c.set(m,$),this.g.$registerAgent(m,t.identifier,a,{isSticky:!0},l),$.apiAgent}async $invokeAgent(t,a,l,g){const m=this.c.get(t);if(!m)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(a.sessionId);$||($=new N.$Wc,this.j.set(a.sessionId,$));const S=new c(m.extension,a,this.g,this.s.converter,$);try{const D=await this.t(a.agentId,l),b=m.invoke(C.ChatAgentRequest.to(a),{history:D},S.apiObject,g);return await(0,y.$uh)(Promise.resolve(b).then(T=>{if(T?.metadata)try{JSON.stringify(T.metadata)}catch(p){const f=`result.metadata MUST be JSON.stringify-able. Got error: ${p.message}`;return this.n.error(`[${m.extension.identifier.value}] [@${m.id}] ${f}`,m.extension),{errorDetails:{message:f},timings:S.timings}}let P;return T?.errorDetails&&(P={...T.errorDetails,responseIsIncomplete:!0}),P?.responseIsRedacted&&(0,o.$8G)(m.extension,"chatParticipantPrivate"),{errorDetails:P,timings:S.timings,metadata:T?.metadata}}),g)}catch(D){return this.n.error(D,m.extension),D instanceof d.$PP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,k.$rj)(D),responseIsIncomplete:!0}}}finally{S.close()}}async t(t,a){const l=[];for(const g of a.history){const m=C.ChatAgentResult.to(g.result),$=t===g.request.agentId?m:{...m,metadata:void 0};l.push(new d.$GP(g.request.message,g.request.command,g.request.variables.variables.map(C.ChatAgentValueReference.to),g.request.agentId));const S=(0,w.$Kb)(g.response.map(D=>C.ChatResponsePart.toContent(D,this.s.converter)));l.push(new d.$HP(S,$,g.request.agentId,g.request.command))}return l}$releaseSession(t){this.j.deleteAndDispose(t)}async $provideFollowups(t,a,l,g,m){const $=this.c.get(a);if(!$)return Promise.resolve([]);const S=await this.t($.id,g),D=C.ChatAgentResult.to(l);return(await $.provideFollowups(D,{history:S},m)).filter(b=>{const T=!b.participant||R.Iterable.some(this.c.values(),P=>P.id===b.participant&&E.$sn.equals(P.extension.identifier,$.extension.identifier));return T||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${b.participant}`),T}).map(b=>C.ChatFollowup.from(b,t))}$acceptFeedback(t,a,l,g){const m=this.c.get(t);if(!m)return;const $=C.ChatAgentResult.to(a);let S;switch(l){case n.ChatAgentVoteDirection.Down:S=d.ChatResultFeedbackKind.Unhelpful;break;case n.ChatAgentVoteDirection.Up:S=d.ChatResultFeedbackKind.Helpful;break}m.acceptFeedback(Object.freeze(g?{result:$,kind:S,reportIssue:g}:{result:$,kind:S}))}$acceptAction(t,a,l){const g=this.c.get(t);if(!g||l.action.kind==="vote")return;const m=C.ChatAgentUserActionEvent.to(a,l,this.s.converter);m&&g.acceptAction(Object.freeze(m))}async $invokeCompletionProvider(t,a,l){const g=this.c.get(t);if(!g)return[];let m=this.m.get(t);return m?m.clear():(m=new N.$Wc,this.m.set(t,m)),(await g.invokeCompletionProvider(a,l)).map(S=>C.ChatAgentCompletionItem.from(S,this.s.converter,m))}async $provideWelcomeMessage(t,a,l){const g=this.c.get(t);if(g)return await g.provideWelcomeMessage(C.ChatLocation.to(a),l)}async $provideSampleQuestions(t,a,l){const g=this.c.get(t);if(g)return(await g.provideSampleQuestions(C.ChatLocation.to(a),l)).map(m=>C.ChatFollowup.from(m,void 0))}}e.$Koc=h,h.b=0;class i{constructor(t,a,l,g,m){this.extension=t,this.id=a,this.w=l,this.x=g,this.y=m,this.m=new O.$ne,this.n=new O.$ne}acceptFeedback(t){this.m.fire(t)}acceptAction(t){this.n.fire(t)}async invokeCompletionProvider(t,a){return this.q?await this.q.provider.provideCompletionItems(t,a)??[]:[]}async provideFollowups(t,a,l){if(!this.b)return[];const g=await this.b.provideFollowups(t,a,l);return g?g.filter(m=>!(m&&"commandId"in m)).filter(m=>!(m&&"message"in m)):[]}async provideWelcomeMessage(t,a){if(!this.s)return[];const l=await this.s.provideWelcomeMessage(t,a);return l?l.map(g=>typeof g=="string"?g:C.MarkdownString.from(g)):[]}async provideSampleQuestions(t,a){if(!this.s||!this.s.provideSampleQuestions)return[];const l=await this.s.provideSampleQuestions(t,a);return l||[]}get apiAgent(){let t=!1,a=!1;const l=()=>{t||a||(a=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof I.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$uO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:C.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:C.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:C.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),a=!1}))},g=this;return{get id(){return g.id},get iconPath(){return g.c},set iconPath(m){g.c=m,l()},get requestHandler(){return g.y},set requestHandler(m){(0,s.$qg)(typeof m=="function","Invalid request handler"),g.y=m},get followupProvider(){return g.b},set followupProvider(m){g.b=m,l()},get isDefault(){return(0,o.$8G)(g.extension,"defaultChatParticipant"),g.d},set isDefault(m){(0,o.$8G)(g.extension,"defaultChatParticipant"),g.d=m,l()},get helpTextPrefix(){return(0,o.$8G)(g.extension,"defaultChatParticipant"),g.g},set helpTextPrefix(m){(0,o.$8G)(g.extension,"defaultChatParticipant"),g.g=m,l()},get helpTextVariablesPrefix(){return(0,o.$8G)(g.extension,"defaultChatParticipant"),g.j},set helpTextVariablesPrefix(m){(0,o.$8G)(g.extension,"defaultChatParticipant"),g.j=m,l()},get helpTextPostfix(){return(0,o.$8G)(g.extension,"defaultChatParticipant"),g.k},set helpTextPostfix(m){(0,o.$8G)(g.extension,"defaultChatParticipant"),g.k=m,l()},get isSecondary(){return(0,o.$8G)(g.extension,"defaultChatParticipant"),g.l},set isSecondary(m){(0,o.$8G)(g.extension,"defaultChatParticipant"),g.l=m,l()},get supportIssueReporting(){return(0,o.$8G)(g.extension,"chatParticipantPrivate"),g.o},set supportIssueReporting(m){(0,o.$8G)(g.extension,"chatParticipantPrivate"),g.o=m,l()},get onDidReceiveFeedback(){return g.m.event},set participantVariableProvider(m){if((0,o.$8G)(g.extension,"chatParticipantAdditions"),g.q=m,m){if(!m.triggerCharacters.length)throw new Error("triggerCharacters are required");g.w.$registerAgentCompletionsProvider(g.x,g.id,m.triggerCharacters)}else g.w.$unregisterAgentCompletionsProvider(g.x,g.id)},get participantVariableProvider(){return(0,o.$8G)(g.extension,"chatParticipantAdditions"),g.q},set welcomeMessageProvider(m){(0,o.$8G)(g.extension,"defaultChatParticipant"),g.s=m,l()},get welcomeMessageProvider(){return(0,o.$8G)(g.extension,"defaultChatParticipant"),g.s},onDidPerformAction:(0,o.$7G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(m){g.t=m,l()},get requester(){return g.t},set supportsSlowReferences(m){(0,o.$8G)(g.extension,"chatParticipantPrivate"),g.u=m,l()},get supportsSlowReferences(){return(0,o.$8G)(g.extension,"chatParticipantPrivate"),g.u},dispose(){t=!0,g.b=void 0,g.m.dispose(),g.w.$unregisterAgent(g.x)}}}invoke(t,a,l,g){return this.y(t,a,l,g)}}}),define(Ie[276],Pe([1,0,14,4,35,5,8,7,25]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0,R=Ve(R),N=Ve(N);class s{constructor(u){this.b=new Map,this.c=u.getProxy(O.$vN.MainThreadChatVariables)}async $resolveVariable(u,C,d,n){const o=this.b.get(u);if(o)try{if(o.resolver.resolve2){(0,v.$8G)(o.extension,"chatParticipantAdditions");const c=new I(C,this.c),h=await o.resolver.resolve2(o.data.name,{prompt:d},c.apiObject,n);if(h&&h[0])return h[0].value}else{const c=await o.resolver.resolve(o.data.name,{prompt:d},n);if(c&&c[0])return c[0].value}}catch(c){(0,w.$4)(c)}}registerVariableResolver(u,C,d,n,o,c,h,i,r){const t=s.a++,a=r?k.ThemeIcon.fromId(r):void 0;return this.b.set(t,{extension:u,data:{id:C,name:d,description:n,modelDescription:o,icon:a},resolver:h}),this.c.$registerVariable(t,{id:C,name:d,description:n,modelDescription:o,isSlow:c,fullName:i,icon:a}),(0,y.$Vc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Loc=s,s.a=0;class I{constructor(u,C){this.c=u,this.d=C,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let C=function(n){if(u.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,n),o}};const u=this,d=n=>{this.d.$handleProgressChunk(this.c,n)};this.b={progress(n){C(this.progress);const o=new N.$AP(n),c=R.ChatResponseProgressPart.from(o);return d(c),this},reference(n){C(this.reference);const o=new N.$EP(n),c=R.ChatResponseReferencePart.from(o);return d(c),this},push(n){return C(this.push),n instanceof N.$EP?d(R.ChatResponseReferencePart.from(n)):n instanceof N.$AP&&d(R.ChatResponseProgressPart.from(n)),this}}}return this.b}}}),define(Ie[277],Pe([1,0,11,72,6,4,37,2,94,19,8,7,5,25]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=d,v=Ve(v),I=Ve(I),E=Ve(E);function d(n,o,c){const h=n.getProxy(u.$vN.MainThreadComments);class i{constructor(){this.b=new Map,this.c=new s.$un,o.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===R.MarshalledId.CommentController){const T=this.b.get(b.handle);return T?T.value:b}else if(b&&b.$mid===R.MarshalledId.CommentThread){const T=b,P=this.b.get(T.commentControlHandle);if(!P)return T;const p=P.getCommentThread(T.commentThreadHandle);return p?p.value:T}else if(b&&(b.$mid===R.MarshalledId.CommentThreadReply||b.$mid===R.MarshalledId.CommentThreadInstance)){const T=this.b.get(b.thread.commentControlHandle);if(!T)return b;const P=T.getCommentThread(b.thread.commentThreadHandle);return P?b.$mid===R.MarshalledId.CommentThreadInstance?P.value:{thread:P.value,text:b.text}:b}else if(b&&b.$mid===R.MarshalledId.CommentNode){const T=this.b.get(b.thread.commentControlHandle);if(!T)return b;const P=T.getCommentThread(b.thread.commentThreadHandle);if(!P)return b;const p=b.commentUniqueId,f=P.getCommentByUniqueId(p);return f||b}else if(b&&b.$mid===R.MarshalledId.CommentThreadNode){const T=this.b.get(b.thread.commentControlHandle);if(!T)return b;const P=T.getCommentThread(b.thread.commentThreadHandle);if(!P)return b;const p=b.text,f=b.commentUniqueId,M=P.getCommentByUniqueId(f);return M?(typeof M.body=="string"?M.body=p:M.body=new E.$ZN(p),M):b}return b}})}createCommentController(b,T,P){const p=i.a++,f=new t(b,p,T,P);this.b.set(f.handle,f);const M=this.c.get(b.identifier)||[];return M.push(f),this.c.set(b.identifier,M),f.value}async $createCommentThreadTemplate(b,T,P,p){const f=this.b.get(b);f&&f.$createCommentThreadTemplate(T,P,p)}async $setActiveComment(b,T){const P=this.b.get(b);P&&P.$setActiveComment(T??void 0)}async $updateCommentThreadTemplate(b,T,P){const p=this.b.get(b);p&&p.$updateCommentThreadTemplate(T,P)}$deleteCommentThread(b,T){this.b.get(b)?.$deleteCommentThread(T)}async $provideCommentingRanges(b,T,P){const p=this.b.get(b);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const f=await c.ensureDocumentData(N.URI.revive(T));return(0,w.$yh)(async()=>{const M=await p.commentingRangeProvider.provideCommentingRanges(f.document,P);let L;return Array.isArray(M)?L={ranges:M,fileComments:!1}:M?L={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:L=M??void 0,L}).then(M=>{let L;return M&&(L={ranges:M.ranges.map(K=>I.Range.from(K)),fileComments:M.fileComments}),L})}$toggleReaction(b,T,P,p,f){const M=this.b.get(b);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,w.$yh)(()=>{const L=M.getCommentThread(T);if(L){const K=L.getCommentByUniqueId(p.uniqueIdInThread);if(M!==void 0&&K&&M.reactionHandler)return M.reactionHandler(K,g(f))}return Promise.resolve(void 0)})}}i.a=0;class r{set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,C.$8G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,T,P,p,f,M,L,K,J){this.m=T,this.n=P,this.o=p,this.p=f,this.q=M,this.extensionDescription=L,this.r=K,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.$ne,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Yc,this.l.value=new O.$Wc,this.n===void 0&&(this.n=`${b}.${this.handle}`),h.$createCommentThread(T,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(A=>a(this,A,this.k,this.extensionDescription)),L.identifier,this.r,J),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{h.$deleteCommentThread(T,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(A){z.range=A},get comments(){return z.comments},set comments(A){z.comments=A},get collapsibleState(){return z.collapsibleState},set collapsibleState(A){z.collapsibleState=A},get canReply(){return z.canReply},set canReply(A){z.canReply=A},get contextValue(){return z.contextValue},set contextValue(A){z.contextValue=A},get label(){return z.label},set label(A){z.label=A},get state(){return z.state},set state(A){z.state=A},reveal:A=>z.reveal(A),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Wc);const b=P=>Object.prototype.hasOwnProperty.call(this.b,P),T={};b("range")&&(T.range=I.Range.from(this.p)),b("label")&&(T.label=this.label),b("contextValue")&&(T.contextValue=this.contextValue??null),b("comments")&&(T.comments=this.q.map(P=>a(this,P,this.k,this.extensionDescription))),b("collapsibleState")&&(T.collapseState=m(this.g)),b("canReply")&&(T.canReply=this.canReply),b("state")&&(T.state=$(this.h)),b("applicability")&&(T.applicability=S(this.h)),b("isTemplate")&&(T.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,T)}getCommentByUniqueId(b){for(const T of this.k){const P=T[0],p=T[1];if(b===p)return P}}async reveal(b){return(0,C.$8G)(this.extensionDescription,"commentReveal"),h.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...b})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}r.a=0,He([(0,y.$_h)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,C.$8G)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,C.$8G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,C.$8G)(this.h,"activeComment"),this.f}constructor(b,T,P,p){this.h=b,this.i=T,this.j=P,this.k=p,this.a=new Map,h.$registerCommentController(this.handle,P,p,this.h.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(M){f.options=M},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(M){f.commentingRangeProvider=M},get reactionHandler(){return f.reactionHandler},set reactionHandler(M){f.reactionHandler=M},get activeCommentThread(){return f.activeCommentThread},createCommentThread(M,L,K){return f.createCommentThread(M,L,K).value},dispose:()=>{f.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(b,T,P){T===void 0&&(0,C.$8G)(this.h,"fileComments");const p=new r(this.id,this.handle,void 0,b,T,P,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const T=this.a.get(b.commentThreadHandle);T&&(this.e=b.uniqueIdInThread?T.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=T)}$createCommentThreadTemplate(b,T,P){const p=new r(this.id,this.handle,void 0,N.URI.revive(b),I.Range.to(T),[],this.h,!0,P);return p.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(b,T){const P=this.a.get(b);P&&(P.range=I.Range.to(T))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function a(D,b,T,P){let p=T.get(b);return p||(p=++D.commentHandle,T.set(b,p)),b.state!==void 0&&(0,C.$8G)(P,"commentsDraftState"),b.reactions?.some(f=>f.reactors!==void 0)&&(0,C.$8G)(P,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:p,body:typeof b.body=="string"?b.body:I.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(f=>l(f)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function l(D){return{label:D.label,iconPath:D.iconPath?I.$1P(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(b=>b.name):D.reactors}}function g(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?N.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(b=>({name:b}))}}function m(D){if(D!==void 0)switch(D){case E.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function $(D){let b;if(typeof D=="object"?b=D.resolved:b=D,b!==void 0)switch(b){case E.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}function S(D){let b;if(typeof D=="object"&&(b=D.applicability),b!==void 0)switch(b){case E.CommentThreadApplicability.Current:return v.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return v.CommentThreadApplicability.Outdated}return v.CommentThreadApplicability.Current}return new i}}),define(Ie[278],Pe([1,0,22,76,4,16,24,2,8,68,80,5,7]),function(_,e,w,y,k,O,R,N,v,s,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=void 0,v=Ve(v),E=Ve(E),u=Ve(u);class C{constructor(l,g){this.document=l,this.b=g,this.a=1,this.c=new I.$voc("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,g){await this.f(l).undo(),g||this.disposeBackup()}async redo(l,g){await this.f(l).redo(),g||this.disposeBackup()}disposeEdits(l){for(const g of l)this.c.delete(g)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=t(this.document.uri)+this.a++;return(0,R.$hh)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const g=this.c.get(l,0);if(!g)throw new Error("No edit found");return g}}class d{constructor(){this.a=new Map}get(l,g){return this.a.get(this.b(l,g))}add(l,g,m){const $=this.b(l,g.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${l} resource:${g.uri}`);const S=new C(g,m);return this.a.set($,S),S}delete(l,g){const m=this.b(l,g.uri);this.a.delete(m)}b(l,g){return`${l}@@@${g}`}}var n;(function(a){a[a.Text=0]="Text",a[a.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(l,g,m){return this.b(l,{type:n.Text,extension:g,provider:m})}addCustomProvider(l,g,m){return this.b(l,{type:n.Custom,extension:g,provider:m})}get(l){return this.a.get(l)}b(l,g){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,g),new u.$xN(()=>this.a.delete(l))}}class c{constructor(l,g,m,$,S){this.d=g,this.f=m,this.g=$,this.h=S,this.b=new o,this.c=new d,this.a=l.getProxy(E.$vN.MainThreadCustomEditors)}registerCustomEditorProvider(l,g,m,$){const S=new k.$Wc;return i(m)?(S.add(this.b.addTextProvider(g,l,m)),this.a.$registerTextEditorProvider((0,s.$5oc)(l),g,$.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,s.$3oc)(l))):(S.add(this.b.addCustomProvider(g,l,m)),h(m)&&S.add(m.onDidChangeCustomDocument(D=>{const b=this.i(g,D.document.uri);if(r(D)){const T=b.addEdit(D);this.a.$onDidEdit(D.document.uri,g,T,D.label)}else this.a.$onContentChange(D.document.uri,g)})),this.a.$registerCustomEditorProvider((0,s.$5oc)(l),g,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,s.$3oc)(l))),u.$xN.from(S,new u.$xN(()=>{this.a.$unregisterEditorProvider(g)}))}async $createCustomDocument(l,g,m,$,S){const D=this.b.get(g);if(!D)throw new Error(`No provider found for '${g}'`);if(D.type!==n.Custom)throw new Error(`Invalid provide type for '${g}'`);const b=N.URI.revive(l),T=await D.provider.openCustomDocument(b,{backupId:m,untitledDocumentData:$?.buffer},S);let P;return h(D.provider)&&this.f&&(P=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(g,T,P),{editable:h(D.provider)}}async $disposeCustomDocument(l,g){const m=this.b.get(g);if(!m)throw new Error(`No provider found for '${g}'`);if(m.type!==n.Custom)throw new Error(`Invalid provider type for '${g}'`);const $=N.URI.revive(l),{document:S}=this.i(g,$);this.c.delete(g,S),S.dispose()}async $resolveCustomEditor(l,g,m,$,S,D){const b=this.b.get(m);if(!b)throw new Error(`No provider found for '${m}'`);const T=v.ViewColumn.to(S),P=this.g.createNewWebview(g,$.contentOptions,b.extension),p=this.h.createNewWebviewPanel(g,m,$.title,T,$.options,P,$.active),f=N.URI.revive(l);switch(b.type){case n.Custom:{const{document:M}=this.i(m,f);return b.provider.resolveCustomEditor(M,p,D)}case n.Text:{const M=this.d.getDocument(f);return b.provider.resolveCustomTextEditor(M,p,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,g,m){this.i(g,l).disposeEdits(m)}async $onMoveCustomEditor(l,g,m){const $=this.b.get(m);if(!$)throw new Error(`No provider found for '${m}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const S=this.h.getWebviewPanel(l);if(!S)throw new Error("No webview found");const D=N.URI.revive(g),b=this.d.getDocument(D);await $.provider.moveCustomTextEditor(b,S,w.CancellationToken.None)}async $undo(l,g,m,$){return this.i(g,l).undo(m,$)}async $redo(l,g,m,$){return this.i(g,l).redo(m,$)}async $revert(l,g,m){const $=this.i(g,l);await this.j(g).revertCustomDocument($.document,m),$.disposeBackup()}async $onSave(l,g,m){const $=this.i(g,l);await this.j(g).saveCustomDocument($.document,m),$.disposeBackup()}async $onSaveAs(l,g,m,$){const S=this.i(g,l);return this.j(g).saveCustomDocumentAs(S.document,N.URI.revive(m),$)}async $backup(l,g,m){const $=this.i(g,l),D=await this.j(g).backupCustomDocument($.document,{destination:$.getNewBackupUri()},m);return $.updateBackup(D),D.id}i(l,g){const m=this.c.get(l,N.URI.revive(g));if(!m)throw new Error("No custom document found");return m}j(l){const m=this.b.get(l)?.provider;if(!m||!h(m))throw new Error("Custom document is not editable");return m}}e.$8oc=c;function h(a){return!!a.onDidChangeCustomDocument}function i(a){return typeof a.resolveCustomTextEditor=="function"}function r(a){return typeof a.undo=="function"&&typeof a.redo=="function"}function t(a){const l=a.scheme===O.Schemas.file||a.scheme===O.Schemas.untitled?a.fsPath:a.toString();return(0,y.$uj)(l)+""}});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[279],Pe([1,0,181,108,2,5,7,8,6,12,29,51]),function(_,e,w,y,k,O,R,N,v,s,I,E){"use strict";var u,C,d,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=e.$Coc=void 0,N=Ve(N);class o{constructor(i,r,t,a,l,g,m,$){this.d=i,this.e=r,this.f=t,this.g=a,this.h=l,u.set(this,void 0),C.set(this,void 0),d.set(this,void 0),this.c=!1,this.f=Math.max(a,t),rt(this,d,new I.$Dc(S=>g.getComparisonKey(S)),"f"),rt(this,u,m,"f"),rt(this,C,$,"f")}dispose(){this.c||(ze(this,C,"f").fire([...ze(this,d,"f").keys()]),ze(this,u,"f")?.$clear(this.e),ze(this,d,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(i,r){if(!i){this.clear();return}this.j();let t=[];if(k.URI.isUri(i)){if(!r){this.delete(i);return}ze(this,d,"f").set(i,r.slice()),t=[i]}else if(Array.isArray(i)){t=[];let g;i=[...i].sort(o.k);for(const m of i){const[$,S]=m;if((!g||$.toString()!==g.toString())&&(g&&ze(this,d,"f").get(g).length===0&&ze(this,d,"f").delete(g),g=$,t.push($),ze(this,d,"f").set($,[])),S)ze(this,d,"f").get($)?.push(...S);else{const D=ze(this,d,"f").get($);D&&(D.length=0)}}}if(ze(this,C,"f").fire(t),!ze(this,u,"f"))return;const a=[];let l=0;for(const g of t){let m=[];const $=ze(this,d,"f").get(g);if($)if($.length>this.g){m=[];const S=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let D=0;D<4;D++)for(const b of $)if(b.severity===S[D]&&m.push({...N.Diagnostic.from(b),modelVersionId:this.h(g)})===this.g)break e;m.push({severity:y.MarkerSeverity.Info,message:(0,w.localize)(0,null,$.length-this.g),startLineNumber:m[m.length-1].startLineNumber,startColumn:m[m.length-1].startColumn,endLineNumber:m[m.length-1].endLineNumber,endColumn:m[m.length-1].endColumn})}else m=$.map(S=>({...N.Diagnostic.from(S),modelVersionId:this.h(g)}));if(a.push([g,m]),l+=m.length,l>this.f)break}ze(this,u,"f").$changeMany(this.e,a)}delete(i){this.j(),ze(this,C,"f").fire([i]),ze(this,d,"f").delete(i),ze(this,u,"f")?.$changeMany(this.e,[[i,void 0]])}clear(){this.j(),ze(this,C,"f").fire([...ze(this,d,"f").keys()]),ze(this,d,"f").clear(),ze(this,u,"f")?.$clear(this.e)}forEach(i,r){this.j();for(const[t,a]of this)i.call(r,t,a,this)}*[(u=new WeakMap,C=new WeakMap,d=new WeakMap,Symbol.iterator)](){this.j();for(const i of ze(this,d,"f").keys())yield[i,this.get(i)]}get(i){this.j();const r=ze(this,d,"f").get(i);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(i){return this.j(),Array.isArray(ze(this,d,"f").get(i))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(i,r){return i[0].toString()<r[0].toString()?-1:i[0].toString()>r[0].toString()?1:0}}e.$Coc=o;let c=n=class{static _mapper(i){const r=new I.$Dc;for(const t of i)r.set(t,t);return{uris:Object.freeze(Array.from(r.values()))}}constructor(i,r,t,a){this.j=r,this.k=t,this.l=a,this.g=new Map,this.h=new v.$re({merge:l=>l.flat(),delay:50}),this.onDidChangeDiagnostics=v.Event.map(this.h.event,n._mapper),this.f=i.getProxy(O.$vN.MainThreadDiagnostics)}createDiagnosticCollection(i,r){const{g:t,f:a,h:l,j:g,k:m,l:$}=this,S=new class{$changeMany(T,P){a.$changeMany(T,P),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,T,P.length===0?"CLEARING":P)}$clear(T){a.$clear(T),g.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,T)}dispose(){a.dispose()}};let D;if(!r)r="_generated_diagnostic_collection_name_#"+n.c++,D=r;else if(!t.has(r))D=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do D=r+n.c++;while(t.has(D))}return new class extends o{constructor(){super(r,D,n.e,n.d,T=>$.getDocument(T)?.version,m.extUri,S,l),t.set(D,this)}dispose(){super.dispose(),t.delete(D)}}}getDiagnostics(i){if(i)return this.m(i);{const r=new Map,t=[];for(const a of this.g.values())a.forEach((l,g)=>{let m=r.get(l.toString());typeof m>"u"&&(m=t.length,r.set(l.toString(),m),t.push([l,[]])),t[m][1]=t[m][1].concat(...g)});return t}}m(i){let r=[];for(const t of this.g.values())t.has(i)&&(r=r.concat(t.get(i)));return r}$acceptMarkersChange(i){if(!this.n){const r="_generated_mirror",t=new o(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(r,t),this.n=t}for(const[r,t]of i)this.n.set(k.URI.revive(r),t.map(N.Diagnostic.to))}};e.$Doc=c,c.c=0,c.d=1e3,c.e=1.1*n.d,e.$Doc=c=n=He([Ge(1,s.$ak),Ge(2,E.$Boc)],c)}),define(Ie[280],Pe([1,0,2,14,7,8,212,39]),function(_,e,w,y,k,O,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0;class v{constructor(I,E,u,C={timeout:1500,errors:3}){this.c=I,this.d=E,this.f=u,this.g=C,this.a=new R.$8c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(E,u,C)=>{const n={dispose:this.a.push([E,u,I])};return Array.isArray(C)&&C.push(n),n}}async $participateInSave(I,E){const u=w.URI.revive(I);let C=!1;const d=setTimeout(()=>C=!0,this.g.timeout),n=[];try{for(const o of[...this.a]){if(C)break;const c=this.d.getDocument(u),h=await this.h(o,{document:c,reason:O.TextDocumentSaveReason.to(E)});n.push(h)}}finally{clearTimeout(d)}return n}h([I,E,u],C){const d=this.b.get(I);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,I,E,C).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const o=this.b.get(I);this.b.set(I,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,E,u,C){const d=[],n=Date.now(),{document:o,reason:c}=C,{version:h}=o,i=Object.freeze({document:o,reason:c,waitUntil(r){if(Object.isFrozen(d))throw(0,y.$$)("waitUntil can not be called async");d.push(Promise.resolve(r))}});try{E.apply(u,[i])}catch(r){return Promise.reject(r)}return Object.freeze(d),new Promise((r,t)=>{const a=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(l=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(a),r(l)}).catch(l=>{clearTimeout(a),t(l)})}).then(r=>{const t={edits:[]};for(const a of r)if(Array.isArray(a)&&a.every(l=>l instanceof k.$EN))for(const{newText:l,newEol:g,range:m}of a)t.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:m&&O.Range.from(m),text:l,eol:g&&O.EndOfLine.from(g)}});if(t.edits.length!==0)return h===o.version?this.f.$tryApplyWorkspaceEdit(new N.$Vw(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Qpc=v}),define(Ie[281],Pe([1,0,6,4,2,5,123,8,15,26,7]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0,N=Ve(N);class E{constructor(C,d){this.a=new w.$ne,this.b=new w.$ne,this.c=new w.$ne,this.d=new w.$ne,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new y.$Wc,this.h=new Map,this.f=C.getProxy(O.$vN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const d=this.g.getDocument(C);if(d)return d}getDocument(C){const d=this.getDocumentData(C);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return d.document}ensureDocumentData(C){const d=this.g.getDocument(C);if(d)return Promise.resolve(d);let n=this.h.get(C.toString());return n||(n=this.f.$tryOpenDocument(C).then(o=>{this.h.delete(C.toString());const c=k.URI.revive(o);return(0,v.$rg)(this.g.getDocument(c))},o=>(this.h.delete(C.toString()),Promise.reject(o))),this.h.set(C.toString(),n)),n}createDocumentData(C){return this.f.$tryCreateDocument(C).then(d=>k.URI.revive(d))}$acceptModelLanguageChanged(C,d){const n=k.URI.revive(C),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(C){const d=k.URI.revive(C),n=this.g.getDocument(d);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(C,d){const n=k.URI.revive(C),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,d,n){const o=k.URI.revive(C),c=this.g.getDocument(o);if(!c)throw new Error("unknown document");c._acceptIsDirty(n),c.onEvents(d);let h;d.isUndoing?h=I.TextDocumentChangeReason.Undo:d.isRedoing&&(h=I.TextDocumentChangeReason.Redo),this.c.fire((0,s.$go)({document:c.document,contentChanges:d.changes.map(i=>({range:N.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:h}))}setWordDefinitionFor(C,d){(0,R.$4P)(C,d)}}e.$Eoc=E}),define(Ie[71],Pe([1,0,282,6,15,2,3,5,17,8,7]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=e.$9oc=void 0,s=Ve(s),e.$9oc=(0,R.$Gi)("IExtHostEditorTabs");class E{constructor(o,c,h){this.e=h,this.d=c,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case N.TabInputKind.TextInput:return new I.$iP(O.URI.revive(this.b.input.uri));case N.TabInputKind.TextDiffInput:return new I.$jP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case N.TabInputKind.TextMergeInput:return new I.$kP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case N.TabInputKind.CustomEditorInput:return new I.$lP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case N.TabInputKind.WebviewEditorInput:return new I.$mP(this.b.input.viewType);case N.TabInputKind.NotebookInput:return new I.$nP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case N.TabInputKind.NotebookDiffInput:return new I.$oP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case N.TabInputKind.TerminalEditorInput:return new I.$pP;case N.TabInputKind.InteractiveEditorInput:return new I.$qP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case N.TabInputKind.ChatEditorInput:return new I.$rP;case N.TabInputKind.MultiDiffEditorInput:return new I.$sP(this.b.input.diffEditors.map(o=>new I.$jP(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class u{constructor(o,c){this.c=[],this.d="",this.b=o,this.e=c;for(const h of o.tabs)h.isActive&&(this.d=h.id),this.c.push(new E(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return s.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(h=>h.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(h=>h.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===N.TabModelOperationKind.TAB_OPEN){const h=new E(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,h),o.tabDto.isActive&&(this.d=h.tabId),h}else if(o.kind===N.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(o.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(o.kind===N.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(o.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,h),h}const c=this.c.find(h=>h.tabId===o.tabDto.id);if(!c)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(o.tabDto),c}activeTabId(){return this.d}}let C=class{constructor(o){this.b=new y.$ne,this.c=new y.$ne,this.e=[],this.a=o.getProxy(N.$vN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,c={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(h=>h.apiObject))},get activeTabGroup(){const h=o.d;return(0,k.$rg)(o.e.find(r=>r.groupId===h)?.apiObject)},close:async(h,i)=>{const r=Array.isArray(h)?h:[h];return r.length?d(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(o){const c=new Set(this.e.map(g=>g.groupId)),h=new Set(o.map(g=>g.groupId)),i=(0,w.$F)(c,h),r=this.e.filter(g=>i.removed.includes(g.groupId)).map(g=>g.apiObject),t=[],a=[];this.e=o.map(g=>{const m=new u(g,()=>this.d);return i.added.includes(m.groupId)?t.push(m.apiObject):a.push(m.apiObject),m});const l=(0,k.$rg)(o.find(g=>g.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:t,closed:r,changed:a}))}$acceptTabGroupUpdate(o){const c=this.e.find(h=>h.groupId===o.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const c=this.e.find(i=>i.groupId===o.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const h=c.acceptTabOperation(o);switch(o.kind){case N.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case N.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case N.TabModelOperationKind.TAB_MOVE:case N.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(o){for(const c of this.e)for(const h of c.tabs)if(h.apiObject===o)return h}h(o){return this.e.find(c=>c.apiObject===o)}async i(o,c){const h=[];for(const i of o){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");h.push(r.tabId)}return this.a.$closeTab(h,c)}async j(o,c){const h=[];for(const i of o){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");h.push(r.groupId)}return this.a.$closeGroup(h,c)}};e.$0oc=C,e.$0oc=C=He([Ge(0,v.$2P)],C);function d(n){return n.tabs!==void 0}}),define(Ie[283],Pe([1,0,2,5,30,4,7,8,327,13,28,23,25,60]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=void 0,k=Ve(k),N=Ve(N);class d{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const h=this.a.indexOf(c);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),h=[];let i,r,t=v.State.LastKnownState,a=v.State.LastKnownState;for(const l of c){let g=i?(0,s.$Jf)(i,l):0;for(g===0?r=v.State.Start:r=a;g<l.length;g++)g+1===l.length?(t=a,a=v.State.BeforeColon):a+=1,h.push([r,l.toUpperCase().charCodeAt(g),a]),h.push([r,l.toLowerCase().charCodeAt(g),a]),r=a;i=l,a=t}h.push([v.State.BeforeColon,I.CharCode.Colon,v.State.AfterColon]),h.push([v.State.AfterColon,I.CharCode.Slash,v.State.End]),this.b=new v.$v4(h)}}provideDocumentLinks(c){this.c();const h=[],i=v.$w4.computeLinks({getLineContent(r){return c.lineAt(r-1).text},getLineCount(){return c.lineCount}},this.b);for(const r of i){const t=N.DocumentLink.to(r);t.target&&h.push(t)}return h}}class n{constructor(c,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(y.$vN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,h,i,r={}){if(n.j(i),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const t=this.h++;this.b.add(h),this.d.add(h),this.c.set(t,i);let a=k.FileSystemProviderCapabilities.FileReadWrite;r.isCaseSensitive&&(a+=k.FileSystemProviderCapabilities.PathCaseSensitive),r.isReadonly&&(a+=k.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(a+=k.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,u.$8G)(c,"fsChunks"),a+=k.FileSystemProviderCapabilities.FileOpenReadWriteClose);let l;r.isReadonly&&(0,C.$6k)(r.isReadonly)&&r.isReadonly.value!==""&&(l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(t,h,a,l).catch(m=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${h}`),console.error(m)});const g=i.onDidChangeFile(m=>{const $=[];for(const S of m){const{uri:D,type:b}=S;if(D.scheme!==h)continue;let T;switch(b){case R.FileChangeType.Changed:T=k.FileChangeType.UPDATED;break;case R.FileChangeType.Created:T=k.FileChangeType.ADDED;break;case R.FileChangeType.Deleted:T=k.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:D,type:T})}this.a.$onFileSystemChange(t,$)});return(0,O.$Vc)(()=>{g.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:h,ctime:i,mtime:r,size:t,permissions:a}=c;return{type:h,ctime:i,mtime:r,size:t,permissions:a}}$stat(c,h){return Promise.resolve(this.l(c).stat(w.URI.revive(h))).then(i=>n.k(i))}$readdir(c,h){return Promise.resolve(this.l(c).readDirectory(w.URI.revive(h)))}$readFile(c,h){return Promise.resolve(this.l(c).readFile(w.URI.revive(h))).then(i=>E.$Pe.wrap(i))}$writeFile(c,h,i,r){return Promise.resolve(this.l(c).writeFile(w.URI.revive(h),i.buffer,r))}$delete(c,h,i){return Promise.resolve(this.l(c).delete(w.URI.revive(h),i))}$rename(c,h,i,r){return Promise.resolve(this.l(c).rename(w.URI.revive(h),w.URI.revive(i),r))}$copy(c,h,i,r){const t=this.l(c);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(w.URI.revive(h),w.URI.revive(i),r))}$mkdir(c,h){return Promise.resolve(this.l(c).createDirectory(w.URI.revive(h)))}$watch(c,h,i,r){const t=this.l(c).watch(w.URI.revive(i),r);this.f.set(h,t)}$unwatch(c,h){const i=this.f.get(h);i&&(i.dispose(),this.f.delete(h))}$open(c,h,i){const r=this.l(c);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(w.URI.revive(h),i))}$close(c,h){const i=this.l(c);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(h))}$read(c,h,i,r){const t=this.l(c);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const a=E.$Pe.alloc(r);return Promise.resolve(t.read(h,i,a.buffer,0,r)).then(l=>a.slice(0,l))}$write(c,h,i,r){const t=this.l(c);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(h,i,r.buffer,0,r.byteLength))}l(c){const h=this.c.get(c);if(!h){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return h}}e.$Tpc=n}),define(Ie[284],Pe([1,0,6,41,2,5,8,7,30,48]),function(_,e,w,y,k,O,R,N,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upc=void 0,R=Ve(R);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,n,o,c,h,i){this.a=Math.random(),this.b=new w.$ne,this.c=new w.$ne,this.d=new w.$ne,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,y.$Ak)(h),t=typeof h=="string",a=i?.correlate,l=c(g=>{if(!(typeof g.session=="number"&&g.session!==this.a)&&!(a&&typeof g.session>"u")){if(!i?.ignoreCreateEvents)for(const m of g.created){const $=k.URI.revive(m);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.b.fire($)}if(!i?.ignoreChangeEvents)for(const m of g.changed){const $=k.URI.revive(m);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.c.fire($)}if(!i?.ignoreDeleteEvents)for(const m of g.deleted){const $=k.URI.revive(m);r($.fsPath)&&(!t||n.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=N.$xN.from(this.i(d,o,h,i,i?.correlate),this.b,this.c,this.d,l)}i(d,n,o,c,h){const i=N.$xN.from();if(typeof o=="string"||c?.ignoreChangeEvents&&c?.ignoreCreateEvents&&c?.ignoreDeleteEvents)return i;const r=d.getProxy(O.$vN.MainThreadFileSystemEventService);let t=!1;(o.pattern.includes(y.$wk)||o.pattern.includes(y.$xk))&&(t=!0);let a;return h&&(c?.ignoreChangeEvents||c?.ignoreCreateEvents||c?.ignoreDeleteEvents)&&(a=v.FileChangeFilter.UPDATED|v.FileChangeFilter.ADDED|v.FileChangeFilter.DELETED,c?.ignoreChangeEvents&&(a&=~v.FileChangeFilter.UPDATED),c?.ignoreCreateEvents&&(a&=~v.FileChangeFilter.ADDED),c?.ignoreDeleteEvents&&(a&=~v.FileChangeFilter.DELETED)),r.$watch(n.identifier.value,this.a,o.baseUri,{recursive:t,excludes:c?.excludes??[],filter:a},!!h),N.$xN.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class E{constructor(d){this.a=d,this.session=this.a.session,this.b=new s.$X(()=>this.a.created.map(k.URI.revive)),this.c=new s.$X(()=>this.a.changed.map(k.URI.revive)),this.d=new s.$X(()=>this.a.deleted.map(k.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(d,n,o){this.j=d,this.k=n,this.l=o,this.a=new w.$ne,this.b=new w.$ne,this.c=new w.$ne,this.d=new w.$ne,this.g=new w.$pe,this.h=new w.$pe,this.i=new w.$pe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,n,o,c){return new I(this.j,d,n,this.a.event,R.GlobPattern.from(o),c)}$onFileEvent(d){this.a.fire(new E(d))}$onDidRunFileOperation(d,n){switch(d){case v.FileOperation.MOVE:this.b.fire(Object.freeze({files:n.map(o=>({oldUri:k.URI.revive(o.source),newUri:k.URI.revive(o.target)}))}));break;case v.FileOperation.DELETE:this.d.fire(Object.freeze({files:n.map(o=>k.URI.revive(o.target))}));break;case v.FileOperation.CREATE:case v.FileOperation.COPY:this.c.fire(Object.freeze({files:n.map(o=>k.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,n){return(o,c,h)=>{const i=function(t){o.call(c,t)};return i.extension=d,n.event(i,void 0,h)}}async $onWillRunFileOperation(d,n,o,c){switch(d){case v.FileOperation.MOVE:return await this.n(this.g,{files:n.map(h=>({oldUri:k.URI.revive(h.source),newUri:k.URI.revive(h.target)}))},o,c);case v.FileOperation.DELETE:return await this.n(this.i,{files:n.map(h=>k.URI.revive(h.target))},o,c);case v.FileOperation.CREATE:case v.FileOperation.COPY:return await this.n(this.h,{files:n.map(h=>k.URI.revive(h.target))},o,c)}}async n(d,n,o,c){const h=new Set,i=[];if(await d.fireAsync(n,c,async(t,a)=>{const l=Date.now(),g=await Promise.resolve(t);g instanceof N.$HN&&(i.push([a.extension,g]),h.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-l>o&&this.k.warn("SLOW file-participant",a.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,t]of i){const{edits:a}=R.WorkspaceEdit.from(t,{getTextDocumentVersion:l=>this.l.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(a)}return{edit:r,extensionNames:Array.from(h)}}}e.$Upc=u}),define(Ie[285],Pe([1,0,18,11,22,14,97,4,26,70,13,15,2,33,328,94,104,183,19,8,7,25,80,5]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=void 0,n=Ve(n),i=Ve(i),l=Ve(l);class g{constructor(U,B){this.d=U,this.e=B}async provideDocumentSymbols(U,B){const G=this.d.getDocument(U),Q=await this.e.provideDocumentSymbols(G,B);if(!(0,w.$Nb)(Q))return Q[0]instanceof r.$RN?Q.map(i.DocumentSymbol.from):g.f(Q)}static f(U){U=U.slice(0).sort((Q,ee)=>{let fe=Q.location.range.start.compareTo(ee.location.range.start);return fe===0&&(fe=ee.location.range.end.compareTo(Q.location.range.end)),fe});const B=[],G=[];for(const Q of U){const ee={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),B.push(ee);break}const fe=G[G.length-1];if(C.$Nt.containsRange(fe.range,ee.range)&&!C.$Nt.equalsRange(fe.range,ee.range)){fe.children?.push(ee),G.push(ee);break}G.pop()}}return B}}class m{constructor(U,B,G,Q,ee,fe){this.f=U,this.g=B,this.h=G,this.j=Q,this.k=ee,this.l=fe,this.d=new a.$voc("CodeLens"),this.e=new Map}async provideCodeLenses(U,B){const G=this.f.getDocument(U),Q=await this.h.provideCodeLenses(G,B);if(!Q||B.isCancellationRequested)return;const ee=this.d.add(Q),fe=new N.$Wc;this.e.set(ee,fe);const Re={cacheId:ee,lenses:[]};for(let Ue=0;Ue<Q.length;Ue++)Re.lenses.push({cacheId:[ee,Ue],range:i.Range.from(Q[Ue].range),command:this.g.toInternal(Q[Ue].command,fe)});return Re}async resolveCodeLens(U,B){const G=U.cacheId&&this.d.get(...U.cacheId);if(!G)return;let Q;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.h.resolveCodeLens(G,B),Q||(Q=G),B.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!Q.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return U.command=this.g.toInternal(Q.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function $(Ne){return Array.isArray(Ne)?Ne.map(i.DefinitionLink.from):Ne?[i.DefinitionLink.from(Ne)]:[]}class S{constructor(U,B){this.d=U,this.e=B}async provideDefinition(U,B,G){const Q=this.d.getDocument(U),ee=i.Position.to(B),fe=await this.e.provideDefinition(Q,ee,G);return $(fe)}}class D{constructor(U,B){this.d=U,this.e=B}async provideDeclaration(U,B,G){const Q=this.d.getDocument(U),ee=i.Position.to(B),fe=await this.e.provideDeclaration(Q,ee,G);return $(fe)}}class b{constructor(U,B){this.d=U,this.e=B}async provideImplementation(U,B,G){const Q=this.d.getDocument(U),ee=i.Position.to(B),fe=await this.e.provideImplementation(Q,ee,G);return $(fe)}}class T{constructor(U,B){this.d=U,this.e=B}async provideTypeDefinition(U,B,G){const Q=this.d.getDocument(U),ee=i.Position.to(B),fe=await this.e.provideTypeDefinition(Q,ee,G);return $(fe)}}class P{constructor(U,B){this.g=U,this.h=B,this.d=0,this.e=new Map}async provideHover(U,B,G,Q){const ee=this.g.getDocument(U),fe=i.Position.to(B);let Re;if(G&&G.verbosityRequest){const it=G.verbosityRequest.previousHover.id,ot=this.e.get(it);if(!ot)throw new Error(`Hover with id ${it} not found`);const tt={verbosityDelta:G.verbosityRequest.verbosityDelta,previousHover:ot};Re=await this.h.provideHover(ee,fe,Q,tt)}else Re=await this.h.provideHover(ee,fe,Q);if(!Re||(0,w.$Nb)(Re.contents))return;Re.range||(Re.range=ee.getWordRangeAtPosition(fe)),Re.range||(Re.range=new r.$zN(fe,fe));const Ue=i.Hover.from(Re),Qe=this.d;if(this.e.size===P.f){const it=Math.min(...this.e.keys());this.e.delete(it)}return this.e.set(Qe,Re),this.d+=1,{...Ue,id:Qe}}releaseHover(U){this.e.delete(U)}}P.f=10;class p{constructor(U,B){this.d=U,this.e=B}async provideEvaluatableExpression(U,B,G){const Q=this.d.getDocument(U),ee=i.Position.to(B),fe=await this.e.provideEvaluatableExpression(Q,ee,G);if(fe)return i.EvaluatableExpression.from(fe)}}class f{constructor(U,B){this.d=U,this.e=B}async provideInlineValues(U,B,G,Q){const ee=this.d.getDocument(U),fe=await this.e.provideInlineValues(ee,i.Range.to(B),i.InlineValueContext.to(G),Q);if(Array.isArray(fe))return fe.map(Re=>i.InlineValue.from(Re))}}class M{constructor(U,B){this.d=U,this.e=B}async provideDocumentHighlights(U,B,G){const Q=this.d.getDocument(U),ee=i.Position.to(B),fe=await this.e.provideDocumentHighlights(Q,ee,G);if(Array.isArray(fe))return fe.map(i.DocumentHighlight.from)}}class L{constructor(U,B){this.d=U,this.e=B}async provideMultiDocumentHighlights(U,B,G,Q){const ee=this.d.getDocument(U),fe=G.map(Qe=>this.d.getDocument(Qe)),Re=i.Position.to(B),Ue=await this.e.provideMultiDocumentHighlights(ee,Re,fe,Q);if(Array.isArray(Ue))return Ue.map(i.MultiDocumentHighlight.from)}}class K{constructor(U,B){this.d=U,this.e=B}async provideLinkedEditingRanges(U,B,G){const Q=this.d.getDocument(U),ee=i.Position.to(B),fe=await this.e.provideLinkedEditingRanges(Q,ee,G);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,w.$Kb)(fe.ranges.map(i.Range.from)),wordPattern:fe.wordPattern}}}class J{constructor(U,B){this.d=U,this.e=B}async provideReferences(U,B,G,Q){const ee=this.d.getDocument(U),fe=i.Position.to(B),Re=await this.e.provideReferences(ee,fe,G,Q);if(Array.isArray(Re))return Re.map(i.location.from)}}class z{constructor(U,B,G,Q,ee,fe,Re){this.g=U,this.h=B,this.j=G,this.k=Q,this.l=ee,this.m=fe,this.n=Re,this.e=new a.$voc("CodeAction"),this.f=new Map}async provideCodeActions(U,B,G,Q){const ee=this.g.getDocument(U),fe=d.$Pt.isISelection(B)?i.Selection.to(B):i.Range.to(B),Re=[];for(const tt of this.j.getDiagnostics(U))if(fe.intersection(tt.range)&&Re.push(tt)>z.d)break;const Ue={diagnostics:Re,only:G.only?new r.$TN(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(ee,fe,Ue,Q);if(!(0,w.$Ob)(Qe)||Q.isCancellationRequested)return;const Ye=this.e.add(Qe),it=new N.$Wc;this.f.set(Ye,it);const ot=[];for(let tt=0;tt<Qe.length;tt++){const at=Qe[tt];if(at)if(z.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,it)});else{Ue.only&&(at.kind?Ue.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const pt=at.ranges??[];ot.push({cacheId:[Ye,tt],title:at.title,command:at.command&&this.h.toInternal(at.command,it),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,t.$7G)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,t.$7G)(this.m,"codeActionRanges")?(0,w.$Kb)(pt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:Ye,actions:ot}}async resolveCodeAction(U,B){const[G,Q]=U,ee=this.e.get(G,Q);if(!ee||z.o(ee))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ee,B)??ee;let Re;fe.edit&&(Re=i.WorkspaceEdit.from(fe.edit,void 0));let Ue;if(fe.command){const Qe=this.f.get(G);Qe&&(Ue=this.h.toInternal(fe.command,Qe))}return{edit:Re,command:Ue}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}z.d=1e3;class A{constructor(U,B,G,Q,ee){this.e=U,this.f=B,this.g=G,this.h=Q,this.j=ee,this.d=new a.$voc("DocumentPasteEdit")}async prepareDocumentPaste(U,B,G,Q){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),fe=B.map(Qe=>i.Range.to(Qe)),Re=i.DataTransfer.toDataTransfer(G,()=>{throw new O.$bb});if(await this.g.prepareDocumentPaste(ee,fe,Re,Q),Q.isCancellationRequested)return;const Ue=Array.from(Re).filter(([,Qe])=>!(Qe instanceof r.$nO));return i.DataTransfer.from(Ue)}async providePasteEdits(U,B,G,Q,ee,fe){if(!this.g.provideDocumentPasteEdits)return[];const Re=this.f.getDocument(B),Ue=G.map(ot=>i.Range.to(ot)),Qe=i.DataTransfer.toDataTransfer(Q,async ot=>(await this.e.$resolvePasteFileData(this.h,U,ot)).buffer),Ye=await this.g.provideDocumentPasteEdits(Re,Ue,Qe,{only:ee.only?new r.$sO(ee.only):void 0,triggerKind:ee.triggerKind},fe);if(!Ye||fe.isCancellationRequested)return[];const it=this.d.add(Ye);return Ye.map((ot,tt)=>({_cacheId:[it,tt],title:ot.title??(0,c.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(at=>at.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?i.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,B){const[G,Q]=U,ee=this.d.get(G,Q);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ee,B)??ee;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class W{constructor(U,B){this.d=U,this.e=B}async provideDocumentFormattingEdits(U,B,G){const Q=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(Q,B,G);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class Z{constructor(U,B){this.d=U,this.e=B}async provideDocumentRangeFormattingEdits(U,B,G,Q){const ee=this.d.getDocument(U),fe=i.Range.to(B),Re=await this.e.provideDocumentRangeFormattingEdits(ee,fe,G,Q);if(Array.isArray(Re))return Re.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,B,G,Q){(0,E.$qg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),fe=B.map(i.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ee,fe,G,Q);if(Array.isArray(Re))return Re.map(i.TextEdit.from)}}class he{constructor(U,B){this.d=U,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,B,G,Q,ee){const fe=this.d.getDocument(U),Re=i.Position.to(B),Ue=await this.e.provideOnTypeFormattingEdits(fe,Re,G,Q,ee);if(Array.isArray(Ue))return Ue.map(i.TextEdit.from)}}class ve{constructor(U,B){this.e=U,this.f=B,this.d=new a.$voc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,B){const G=await this.e.provideWorkspaceSymbols(U,B);if(!(0,w.$Ob)(G))return{symbols:[]};const Q=this.d.add(G),ee={cacheId:Q,symbols:[]};for(let fe=0;fe<G.length;fe++){const Re=G[fe];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Re),cacheId:[Q,fe]})}return ee}async resolveWorkspaceSymbol(U,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const G=this.d.get(...U.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,B);return Q&&(0,v.$io)(U,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class be{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,B,G){this.d=U,this.e=B,this.f=G}async provideRenameEdits(U,B,G,Q){const ee=this.d.getDocument(U),fe=i.Position.to(B);try{const Re=await this.e.provideRenameEdits(ee,fe,G,Q);return Re?i.WorkspaceEdit.from(Re):void 0}catch(Re){const Ue=be.g(Re);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(U,B,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(U),ee=i.Position.to(B);try{const fe=await this.e.prepareRename(Q,ee,G);let Re,Ue;if(r.$zN.isRange(fe)?(Re=fe,Ue=Q.getText(fe)):(0,E.$ig)(fe)&&(Re=fe.range,Ue=fe.placeholder),!Re||!Ue)return;if(Re.start.line>ee.line||Re.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Re),text:Ue}}catch(fe){const Re=be.g(fe);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(fe)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class de{constructor(U,B,G){this.e=U,this.f=B,this.g=G}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,B,G,Q){const ee=this.e.getDocument(U),fe=i.Range.to(B);try{const Re=de.d[G],Ue=await this.f.provideNewSymbolNames(ee,fe,Re,Q);return Ue?Ue.map(Qe=>typeof Qe=="string"?{newSymbolName:Qe}:{newSymbolName:Qe.newSymbolName,tags:Qe.tags}):void 0}catch(Re){this.g.error(de.h(Re)??JSON.stringify(Re,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}de.d={[n.NewSymbolNameTriggerKind.Invoke]:r.NewSymbolNameTriggerKind.Invoke,[n.NewSymbolNameTriggerKind.Automatic]:r.NewSymbolNameTriggerKind.Automatic};class $e{constructor(U,B){this.resultId=U,this.tokens=B}}class ye{constructor(U,B){this.f=U,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,B,G){const Q=this.f.getDocument(U),ee=B!==0?this.d.get(B):null;let fe=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,ee.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return ee&&this.d.delete(B),fe?(fe=ye.h(fe),this.o(ye.n(ee,fe),fe)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return ye.j(U)?ye.k(U)?U:new r.$SO(new Uint32Array(U.data),U.resultId):ye.l(U)?ye.m(U)?U:new r.$UO(U.edits.map(B=>new r.$TO(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const B of U.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(U,B){if(!ye.j(B)||!U||!U.tokens)return B;const G=U.tokens,Q=G.length,ee=B.data,fe=ee.length;let Re=0;const Ue=Math.min(Q,fe);for(;Re<Ue&&G[Re]===ee[Re];)Re++;if(Re===Q&&Re===fe)return new r.$UO([],B.resultId);let Qe=0;const Ye=Ue-Re;for(;Qe<Ye&&G[Q-Qe-1]===ee[fe-Qe-1];)Qe++;return new r.$UO([{start:Re,deleteCount:Q-Re-Qe,data:ee.subarray(Re,fe-Qe)}],B.resultId)}o(U,B){if(ye.j(U)){const G=this.e++;return this.d.set(G,new $e(U.resultId,U.data)),(0,o.$Mdb)({id:G,type:"full",data:U.data})}if(ye.l(U)){const G=this.e++;return ye.j(B)?this.d.set(G,new $e(B.resultId,B.data)):this.d.set(G,new $e(U.resultId)),(0,o.$Mdb)({id:G,type:"delta",deltas:(U.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class Y{constructor(U,B){this.d=U,this.e=B}async provideDocumentRangeSemanticTokens(U,B,G){const Q=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(B),G);return ee?this.f(ee):null}f(U){return(0,o.$Mdb)({id:0,type:"full",data:U.data})}}class we{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,B,G,Q,ee){this.f=U,this.g=B,this.h=G,this.j=Q,this.k=ee,this.d=new a.$voc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,B,G,Q){const ee=this.f.getDocument(U),fe=i.Position.to(B),Re=ee.getWordRangeAtPosition(fe)||new r.$zN(fe,fe),Ue=Re.with({end:fe}),Qe=new s.$he,Ye=await this.h.provideCompletionItems(ee,fe,Q,i.CompletionContext.to(G));if(!Ye||Q.isCancellationRequested)return;const it=Array.isArray(Ye)?new r.$7N(Ye):Ye,ot=we.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),tt=new N.$Wc;this.e.set(ot,tt);const at=[],pt={x:ot,[l.ISuggestResultDtoField.completions]:at,[l.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Re),insert:i.Range.from(Ue)},[l.ISuggestResultDtoField.isIncomplete]:it.isIncomplete||void 0,[l.ISuggestResultDtoField.duration]:Qe.elapsed()};for(let ut=0;ut<it.items.length;ut++){const st=it.items[ut],ht=this.l(st,[ot,ut],Ue,Re);at.push(ht)}return pt}async resolveCompletionItem(U,B){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...U);if(!G)return;const Q=this.l(G,U),ee=await this.h.resolveCompletionItem(G,B);if(!ee)return;const fe=this.l(ee,U);return(Q[l.ISuggestDataDtoField.insertText]!==fe[l.ISuggestDataDtoField.insertText]||Q[l.ISuggestDataDtoField.insertTextRules]!==fe[l.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q[l.ISuggestDataDtoField.commandIdent]!==fe[l.ISuggestDataDtoField.commandIdent]||Q[l.ISuggestDataDtoField.commandId]!==fe[l.ISuggestDataDtoField.commandId]||!(0,v.$jo)(Q[l.ISuggestDataDtoField.commandArguments],fe[l.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,[l.ISuggestDataDtoField.documentation]:fe[l.ISuggestDataDtoField.documentation],[l.ISuggestDataDtoField.detail]:fe[l.ISuggestDataDtoField.detail],[l.ISuggestDataDtoField.additionalTextEdits]:fe[l.ISuggestDataDtoField.additionalTextEdits],[l.ISuggestDataDtoField.insertText]:fe[l.ISuggestDataDtoField.insertText],[l.ISuggestDataDtoField.insertTextRules]:fe[l.ISuggestDataDtoField.insertTextRules],[l.ISuggestDataDtoField.commandIdent]:fe[l.ISuggestDataDtoField.commandIdent],[l.ISuggestDataDtoField.commandId]:fe[l.ISuggestDataDtoField.commandId],[l.ISuggestDataDtoField.commandArguments]:fe[l.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,B,G,Q){const ee=this.e.get(B[0]);if(!ee)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(U.command,ee),Re={x:B,[l.ISuggestDataDtoField.label]:U.label,[l.ISuggestDataDtoField.kind]:U.kind!==void 0?i.CompletionItemKind.from(U.kind):void 0,[l.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(i.CompletionItemTag.from),[l.ISuggestDataDtoField.detail]:U.detail,[l.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:i.MarkdownString.fromStrict(U.documentation),[l.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[l.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[l.ISuggestDataDtoField.preselect]:U.preselect||void 0,[l.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?n.CompletionItemInsertTextRule.KeepWhitespace:n.CompletionItemInsertTextRule.None,[l.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[l.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(i.TextEdit.from),[l.ISuggestDataDtoField.commandIdent]:fe?.$ident,[l.ISuggestDataDtoField.commandId]:fe?.id,[l.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re[l.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Re[l.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof r.$IN&&(Re[l.ISuggestDataDtoField.insertText]=U.insertText.value,Re[l.ISuggestDataDtoField.insertTextRules]|=n.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return U.textEdit?Ue=U.textEdit.range:U.range&&(Ue=U.range),r.$zN.isRange(Ue)?Re[l.ISuggestDataDtoField.range]=i.Range.from(Ue):Ue&&(!G?.isEqual(Ue.inserting)||!Q?.isEqual(Ue.replacing))&&(Re[l.ISuggestDataDtoField.range]={insert:i.Range.from(Ue.inserting),replace:i.Range.from(Ue.replacing)}),Re}}class Te{async provideInlineCompletions(U,B,G,Q){}async provideInlineEdits(U,B,G,Q){}disposeCompletions(U){}handleDidShowCompletionItem(U,B,G){}handlePartialAccept(U,B,G,Q){}}class re extends Te{constructor(U,B,G,Q){super(),this.f=U,this.g=B,this.h=G,this.j=Q,this.d=new ae,this.e=(0,t.$7G)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$7G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,B,G,Q){const ee=this.g.getDocument(U),fe=i.Position.to(B),Re=await this.h.provideInlineCompletionItems(ee,fe,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!Re||Q.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Qe=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Ye=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:Ue}),items:Ue.map((tt,at)=>{let pt;tt.command&&(it||(it=new N.$Wc),pt=this.j.toInternal(tt.command,it));const ut=tt.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:tt.filterText,range:tt.range?i.Range.from(tt.range):void 0,command:pt,idx:at,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Qe.map(tt=>(it||(it=new N.$Wc),this.j.toInternal(tt,it))),suppressSuggestions:!1,enableForwardStability:Ye}}async provideInlineEdits(U,B,G,Q){if(!this.h.provideInlineEdits)return;(0,t.$8G)(this.f,"inlineCompletionsAdditions");const ee=this.g.getDocument(U),fe=i.Range.to(B),Re=await this.h.provideInlineEdits(ee,fe,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind],userPrompt:G.userPrompt},Q);if(!Re||Q.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Qe=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Ye=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:Ue}),items:Ue.map((tt,at)=>{let pt;tt.command&&(it||(it=new N.$Wc),pt=this.j.toInternal(tt.command,it));const ut=tt.insertText;return{insertText:typeof ut=="string"?ut:{snippet:ut.value},filterText:tt.filterText,range:tt.range?i.Range.from(tt.range):void 0,command:pt,idx:at,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Qe.map(tt=>(it||(it=new N.$Wc),this.j.toInternal(tt,it))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,B,G){const Q=this.d.get(U)?.items[B];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(U,B,G,Q){const ee=this.d.get(U)?.items[B];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(Q)))}}class q{async provideInlineEdits(U,B,G){const Q=this.f.getDocument(U),ee=await this.g.provideInlineEdit(Q,{triggerKind:this.e[B.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let fe;const Re=this.d.createReferenceId({dispose(){fe?.dispose()},item:ee});let Ue;ee.accepted&&(fe||(fe=new N.$Wc),Ue=this.h.toInternal(ee.accepted,fe));let Qe;return ee.rejected&&(fe||(fe=new N.$Wc),Qe=this.h.toInternal(ee.rejected,fe)),{pid:Re,text:ee.text,range:i.Range.from(ee.range),accepted:Ue,rejected:Qe}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,B,G,Q){this.f=B,this.g=G,this.h=Q,this.d=new ae,this.e={[n.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class ae{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const B=this.e++;return this.d.set(B,U),B}disposeReferenceId(U){const B=this.d.get(U);return this.d.delete(U),B}get(U){return this.d.get(U)}}class le{constructor(U,B){this.e=U,this.f=B,this.d=new a.$voc("SignatureHelp")}async provideSignatureHelp(U,B,G,Q){const ee=this.e.getDocument(U),fe=i.Position.to(B),Re=this.g(G),Ue=await this.f.provideSignatureHelp(ee,fe,Q,Re);if(Ue){const Qe=this.d.add([Ue]);return{...i.SignatureHelp.from(Ue),id:Qe}}}g(U){let B;if(U.activeSignatureHelp){const G=i.SignatureHelp.to(U.activeSignatureHelp),Q=this.d.get(U.activeSignatureHelp.id,0);Q?(B=Q,B.activeSignature=G.activeSignature,B.activeParameter=G.activeParameter):B=G}return{...U,activeSignatureHelp:B}}releaseSignatureHelp(U){this.d.delete(U)}}class ne{constructor(U,B,G,Q,ee){this.f=U,this.g=B,this.h=G,this.j=Q,this.k=ee,this.d=new a.$voc("InlayHints"),this.e=new Map}async provideInlayHints(U,B,G){const Q=this.f.getDocument(U),ee=i.Range.to(B),fe=await this.h.provideInlayHints(Q,ee,G);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`);return}if(G.isCancellationRequested)return;const Re=this.d.add(fe);this.e.set(Re,new N.$Wc);const Ue={hints:[],cacheId:Re};for(let Qe=0;Qe<fe.length;Qe++)this.l(fe[Qe],ee)&&Ue.hints.push(this.m(fe[Qe],[Re,Qe]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(B)}`),Ue}async resolveInlayHint(U,B){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...U);if(!G)return;const Q=await this.h.resolveInlayHint(G,B);if(Q&&this.l(Q))return this.m(Q,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,B){return U.label.length===0||Array.isArray(U.label)&&U.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(B&&!B.contains(U.position))}m(U,B){const G=this.e.get(B[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:B,tooltip:i.MarkdownString.fromStrict(U.tooltip),position:i.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(i.TextEdit.from),kind:U.kind&&i.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")Q.label=U.label;else{const ee=[];Q.label=ee;for(const fe of U.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:fe.value,tooltip:i.MarkdownString.fromStrict(fe.tooltip)};r.$JN.isLocation(fe.location)&&(Re.location=i.location.from(fe.location)),fe.command&&(Re.command=this.g.toInternal(fe.command,G)),ee.push(Re)}}return Q}}class ce{constructor(U,B){this.e=U,this.f=B,this.d=new a.$voc("DocumentLink")}async provideLinks(U,B){const G=this.e.getDocument(U),Q=await this.f.provideDocumentLinks(G,B);if(!(!Array.isArray(Q)||Q.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ce.g).map(i.DocumentLink.from)};{const ee=this.d.add(Q),fe={links:[],cacheId:ee};for(let Re=0;Re<Q.length;Re++){if(!ce.g(Q[Re]))continue;const Ue=i.DocumentLink.from(Q[Re]);Ue.cacheId=[ee,Re],fe.links.push(Ue)}return fe}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,B){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...U);if(!G)return;const Q=await this.f.resolveDocumentLink(G,B);if(!(!Q||!ce.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(U){this.d.delete(U)}}class oe{constructor(U,B){this.d=U,this.e=B}async provideColors(U,B){const G=this.d.getDocument(U),Q=await this.e.provideDocumentColors(G,B);return Array.isArray(Q)?Q.map(fe=>({color:i.Color.from(fe.color),range:i.Range.from(fe.range)})):[]}async provideColorPresentations(U,B,G){const Q=this.d.getDocument(U),ee=i.Range.to(B.range),fe=i.Color.to(B.color),Re=await this.e.provideColorPresentations(fe,{document:Q,range:ee},G);if(Array.isArray(Re))return Re.map(i.ColorPresentation.from)}}class H{constructor(U,B){this.d=U,this.e=B}async provideFoldingRanges(U,B,G){const Q=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(Q,B,G);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class x{constructor(U,B,G){this.d=U,this.e=B,this.f=G}async provideSelectionRanges(U,B,G){const Q=this.d.getDocument(U),ee=B.map(i.Position.to),fe=await this.e.provideSelectionRanges(Q,ee,G);if(!(0,w.$Ob)(fe))return[];if(fe.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Ue=0;Ue<ee.length;Ue++){const Qe=[];Re.push(Qe);let Ye=ee[Ue],it=fe[Ue];for(;;){if(!it.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(it)),!it.parent)break;Ye=it.range,it=it.parent}}return Re}}class ue{constructor(U,B){this.f=U,this.g=B,this.d=new R.$7P(""),this.e=new Map}async prepareSession(U,B,G){const Q=this.f.getDocument(U),ee=i.Position.to(B),fe=await this.g.prepareCallHierarchy(Q,ee,G);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Re,Ue)):[this.h(Re,fe)]}async provideCallsTo(U,B,G){const Q=this.j(U,B);if(!Q)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(ee)return ee.map(fe=>({from:this.h(U,fe.from),fromRanges:fe.fromRanges.map(Re=>i.Range.from(Re))}))}async provideCallsFrom(U,B,G){const Q=this.j(U,B);if(!Q)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(ee)return ee.map(fe=>({to:this.h(U,fe.to),fromRanges:fe.fromRanges.map(Re=>i.Range.from(Re))}))}releaseSession(U){this.e.delete(U)}h(U,B){const G=this.e.get(U),Q=i.CallHierarchyItem.from(B,U,G.size.toString(36));return G.set(Q._itemId,B),Q}j(U,B){return this.e.get(U)?.get(B)}}class me{constructor(U,B){this.f=U,this.g=B,this.d=new R.$7P(""),this.e=new Map}async prepareSession(U,B,G){const Q=this.f.getDocument(U),ee=i.Position.to(B),fe=await this.g.prepareTypeHierarchy(Q,ee,G);if(!fe)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Re,Ue)):[this.h(Re,fe)]}async provideSupertypes(U,B,G){const Q=this.j(U,B);if(!Q)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(Q,G);if(ee)return ee.map(fe=>this.h(U,fe))}async provideSubtypes(U,B,G){const Q=this.j(U,B);if(!Q)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(Q,G);if(ee)return ee.map(fe=>this.h(U,fe))}releaseSession(U){this.e.delete(U)}h(U,B){const G=this.e.get(U),Q=i.TypeHierarchyItem.from(B,U,G.size.toString(36));return G.set(Q._itemId,B),Q}j(U,B){return this.e.get(U)?.get(B)}}class Oe{constructor(U,B,G,Q,ee){this.e=U,this.f=B,this.g=G,this.h=Q,this.j=ee,this.d=new a.$voc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,B,G,Q,ee){const fe=this.f.getDocument(B),Re=i.Position.to(G),Ue=i.DataTransfer.toDataTransfer(Q,async ot=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,ot)).buffer),Qe=await this.g.provideDocumentDropEdits(fe,Re,Ue,ee);if(!Qe)return;const Ye=(0,w.$5b)(Qe),it=this.d.add(Ye);return Ye.map((ot,tt)=>({_cacheId:[it,tt],title:ot.title??(0,c.localize)(1,null,this.j.displayName||this.j.name),kind:ot.kind?.value,yieldTo:ot.yieldTo?.map(at=>at.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?i.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,B){const[G,Q]=U,ee=this.d.get(G,Q);if(!ee||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ee,B)??ee;return{additionalEdit:fe.additionalEdit?i.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class je{constructor(U,B){this.d=U,this.e=B}async provideMappedEdits(U,B,G,Q){const ee=u.URI.revive(U),fe=this.d.getDocument(ee),Re=G.documents.map(Ye=>Ye.map(it=>({uri:u.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(ot=>i.Range.to(ot))}))),Ue={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(fe,B,Ue,Q);return Qe?i.WorkspaceEdit.from(Qe):null}}class ke{constructor(U,B){this.adapter=U,this.extension=B}}class Ae{constructor(U,B,G,Q,ee,fe,Re,Ue){this.g=B,this.h=G,this.j=Q,this.k=ee,this.l=fe,this.m=Re,this.n=Ue,this.f=new Map,this.e=U.getProxy(l.$vN.MainThreadLanguageFeatures)}o(U,B){return i.DocumentSelector.from(U,this.g,B)}p(U){return new r.$xN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Ae.d++}async s(U,B,G,Q,ee,fe=!1){const Re=this.f.get(U);if(!Re||!(Re.adapter instanceof B))return Q;const Ue=Date.now();fe||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Re.adapter,Re.extension);return Promise.resolve(Qe).catch(Ye=>{(0,O.$7)(Ye)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(Re.extension.identifier,Ye))}).finally(()=>{fe||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),k.CancellationToken.isCancellationToken(ee)?(0,y.$vh)(Qe,ee):Qe}t(U,B){const G=this.q();return this.f.set(G,new ke(U,B)),G}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,B,G,Q){const ee=this.t(new g(this.h,G),U),fe=Q&&Q.label||Ae.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(B,U),fe),this.p(ee)}$provideDocumentSymbols(U,B,G){return this.s(U,g,Q=>Q.provideDocumentSymbols(u.URI.revive(B),G),void 0,G)}registerCodeLensProvider(U,B,G){const Q=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new ke(new m(this.h,this.j.converter,G,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(Q,this.o(B,U),ee);let fe=this.p(Q);if(ee!==void 0){const Re=G.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(ee));fe=r.$xN.from(fe,Re)}return fe}$provideCodeLenses(U,B,G){return this.s(U,m,Q=>Q.provideCodeLenses(u.URI.revive(B),G),void 0,G)}$resolveCodeLens(U,B,G){return this.s(U,m,Q=>Q.resolveCodeLens(B,G),void 0,void 0)}$releaseCodeLenses(U,B){this.s(U,m,G=>Promise.resolve(G.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(U,B,G){const Q=this.t(new S(this.h,G),U);return this.e.$registerDefinitionSupport(Q,this.o(B,U)),this.p(Q)}$provideDefinition(U,B,G,Q){return this.s(U,S,ee=>ee.provideDefinition(u.URI.revive(B),G,Q),[],Q)}registerDeclarationProvider(U,B,G){const Q=this.t(new D(this.h,G),U);return this.e.$registerDeclarationSupport(Q,this.o(B,U)),this.p(Q)}$provideDeclaration(U,B,G,Q){return this.s(U,D,ee=>ee.provideDeclaration(u.URI.revive(B),G,Q),[],Q)}registerImplementationProvider(U,B,G){const Q=this.t(new b(this.h,G),U);return this.e.$registerImplementationSupport(Q,this.o(B,U)),this.p(Q)}$provideImplementation(U,B,G,Q){return this.s(U,b,ee=>ee.provideImplementation(u.URI.revive(B),G,Q),[],Q)}registerTypeDefinitionProvider(U,B,G){const Q=this.t(new T(this.h,G),U);return this.e.$registerTypeDefinitionSupport(Q,this.o(B,U)),this.p(Q)}$provideTypeDefinition(U,B,G,Q){return this.s(U,T,ee=>ee.provideTypeDefinition(u.URI.revive(B),G,Q),[],Q)}registerHoverProvider(U,B,G,Q){const ee=this.t(new P(this.h,G),U);return this.e.$registerHoverProvider(ee,this.o(B,U)),this.p(ee)}$provideHover(U,B,G,Q,ee){return this.s(U,P,fe=>fe.provideHover(u.URI.revive(B),G,Q,ee),void 0,ee)}$releaseHover(U,B){this.s(U,P,G=>Promise.resolve(G.releaseHover(B)),void 0,void 0)}registerEvaluatableExpressionProvider(U,B,G,Q){const ee=this.t(new p(this.h,G),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(B,U)),this.p(ee)}$provideEvaluatableExpression(U,B,G,Q){return this.s(U,p,ee=>ee.provideEvaluatableExpression(u.URI.revive(B),G,Q),void 0,Q)}registerInlineValuesProvider(U,B,G,Q){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new f(this.h,G),U);this.e.$registerInlineValuesProvider(fe,this.o(B,U),ee);let Re=this.p(fe);if(ee!==void 0){const Ue=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Re=r.$xN.from(Re,Ue)}return Re}$provideInlineValues(U,B,G,Q,ee){return this.s(U,f,fe=>fe.provideInlineValues(u.URI.revive(B),G,Q,ee),void 0,ee)}registerDocumentHighlightProvider(U,B,G){const Q=this.t(new M(this.h,G),U);return this.e.$registerDocumentHighlightProvider(Q,this.o(B,U)),this.p(Q)}registerMultiDocumentHighlightProvider(U,B,G){const Q=this.t(new L(this.h,G),U);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(B,U)),this.p(Q)}$provideDocumentHighlights(U,B,G,Q){return this.s(U,M,ee=>ee.provideDocumentHighlights(u.URI.revive(B),G,Q),void 0,Q)}$provideMultiDocumentHighlights(U,B,G,Q,ee){return this.s(U,L,fe=>fe.provideMultiDocumentHighlights(u.URI.revive(B),G,Q.map(Re=>u.URI.revive(Re)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,B,G){const Q=this.t(new K(this.h,G),U);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(B,U)),this.p(Q)}$provideLinkedEditingRanges(U,B,G,Q){return this.s(U,K,async ee=>{const fe=await ee.provideLinkedEditingRanges(u.URI.revive(B),G,Q);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Ae.y(fe.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(U,B,G){const Q=this.t(new J(this.h,G),U);return this.e.$registerReferenceSupport(Q,this.o(B,U)),this.p(Q)}$provideReferences(U,B,G,Q,ee){return this.s(U,J,fe=>fe.provideReferences(u.URI.revive(B),G,Q,ee),void 0,ee)}registerCodeActionProvider(U,B,G,Q){const ee=new N.$Wc,fe=this.t(new z(this.h,this.j.converter,this.k,G,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(fe,this.o(B,U),{providedKinds:Q?.providedCodeActionKinds?.map(Re=>Re.value),documentation:Q?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ee)}))},Ae.u(U),Ae.w(U),!!G.resolveCodeAction),ee.add(this.p(fe)),ee}$provideCodeActions(U,B,G,Q,ee){return this.s(U,z,fe=>fe.provideCodeActions(u.URI.revive(B),G,Q,ee),void 0,ee)}$resolveCodeAction(U,B,G){return this.s(U,z,Q=>Q.resolveCodeAction(B,G),{},void 0)}$releaseCodeActions(U,B){this.s(U,z,G=>Promise.resolve(G.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(U,B,G){const Q=this.t(new W(this.h,G),U);return this.e.$registerDocumentFormattingSupport(Q,this.o(B,U),U.identifier,U.displayName||U.name),this.p(Q)}$provideDocumentFormattingEdits(U,B,G,Q){return this.s(U,W,ee=>ee.provideDocumentFormattingEdits(u.URI.revive(B),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(U,B,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new Z(this.h,G),U);return this.e.$registerRangeFormattingSupport(ee,this.o(B,U),U.identifier,U.displayName||U.name,Q),this.p(ee)}$provideDocumentRangeFormattingEdits(U,B,G,Q,ee){return this.s(U,Z,fe=>fe.provideDocumentRangeFormattingEdits(u.URI.revive(B),G,Q,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,B,G,Q,ee){return this.s(U,Z,fe=>fe.provideDocumentRangesFormattingEdits(u.URI.revive(B),G,Q,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,B,G,Q){const ee=this.t(new he(this.h,G),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(B,U),Q,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,B,G,Q,ee,fe){return this.s(U,he,Re=>Re.provideOnTypeFormattingEdits(u.URI.revive(B),G,Q,ee,fe),void 0,fe)}registerWorkspaceSymbolProvider(U,B){const G=this.t(new ve(B,this.l),U);return this.e.$registerNavigateTypeSupport(G,typeof B.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(U,B,G){return this.s(U,ve,Q=>Q.provideWorkspaceSymbols(B,G),{symbols:[]},G)}$resolveWorkspaceSymbol(U,B,G){return this.s(U,ve,Q=>Q.resolveWorkspaceSymbol(B,G),void 0,void 0)}$releaseWorkspaceSymbols(U,B){this.s(U,ve,G=>G.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(U,B,G){const Q=this.t(new be(this.h,G,this.l),U);return this.e.$registerRenameSupport(Q,this.o(B,U),be.supportsResolving(G)),this.p(Q)}$provideRenameEdits(U,B,G,Q,ee){return this.s(U,be,fe=>fe.provideRenameEdits(u.URI.revive(B),G,Q,ee),void 0,ee)}$resolveRenameLocation(U,B,G,Q){return this.s(U,be,ee=>ee.resolveRenameLocation(u.URI.revive(B),G,Q),void 0,Q)}registerNewSymbolNamesProvider(U,B,G){const Q=this.t(new de(this.h,G,this.l),U);return this.e.$registerNewSymbolNamesProvider(Q,this.o(B,U)),this.p(Q)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,de,B=>B.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,B,G,Q,ee){return this.s(U,de,fe=>fe.provideNewSymbolNames(u.URI.revive(B),G,Q,ee),void 0,ee)}registerDocumentSemanticTokensProvider(U,B,G,Q){const ee=this.t(new ye(this.h,G),U),fe=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(B,U),Q,fe);let Re=this.p(ee);if(fe){const Ue=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(fe));Re=r.$xN.from(Re,Ue)}return Re}$provideDocumentSemanticTokens(U,B,G,Q){return this.s(U,ye,ee=>ee.provideDocumentSemanticTokens(u.URI.revive(B),G,Q),null,Q)}$releaseDocumentSemanticTokens(U,B){this.s(U,ye,G=>G.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,B,G,Q){const ee=this.t(new Y(this.h,G),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(B,U),Q),this.p(ee)}$provideDocumentRangeSemanticTokens(U,B,G,Q){return this.s(U,Y,ee=>ee.provideDocumentRangeSemanticTokens(u.URI.revive(B),G,Q),null,Q)}registerCompletionItemProvider(U,B,G,Q){const ee=this.t(new we(this.h,this.j.converter,G,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(B,U),Q,we.supportsResolving(G),U.identifier),this.p(ee)}$provideCompletionItems(U,B,G,Q,ee){return this.s(U,we,fe=>fe.provideCompletionItems(u.URI.revive(B),G,Q,ee),void 0,ee)}$resolveCompletionItem(U,B,G){return this.s(U,we,Q=>Q.resolveCompletionItem(B,G),void 0,G)}$releaseCompletionItems(U,B){this.s(U,we,G=>G.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(U,B,G,Q){const ee=new re(U,this.h,G,this.j.converter),fe=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(fe,this.o(B,U),ee.supportsHandleEvents,h.$sn.toKey(U.identifier.value),Q?.yieldTo?.map(Re=>h.$sn.toKey(Re))||[]),this.p(fe)}$provideInlineCompletions(U,B,G,Q,ee){return this.s(U,Te,fe=>fe.provideInlineCompletions(u.URI.revive(B),G,Q,ee),void 0,ee)}$provideInlineEdits(U,B,G,Q,ee){return this.s(U,Te,fe=>fe.provideInlineEdits(u.URI.revive(B),G,Q,ee),void 0,ee)}$handleInlineCompletionDidShow(U,B,G,Q){this.s(U,Te,async ee=>{ee.handleDidShowCompletionItem(B,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,B,G,Q,ee){this.s(U,Te,async fe=>{fe.handlePartialAccept(B,G,Q,ee)},void 0,void 0)}$freeInlineCompletionsList(U,B){this.s(U,Te,async G=>{G.disposeCompletions(B)},void 0,void 0)}registerInlineEditProvider(U,B,G){const Q=new q(U,this.h,G,this.j.converter),ee=this.t(Q,U);return this.e.$registerInlineEditProvider(ee,this.o(B,U),U.identifier),this.p(ee)}$provideInlineEdit(U,B,G,Q){return this.s(U,q,ee=>ee.provideInlineEdits(u.URI.revive(B),G,Q),void 0,Q)}$freeInlineEdit(U,B){this.s(U,q,async G=>{G.disposeEdit(B)},void 0,void 0)}registerSignatureHelpProvider(U,B,G,Q){const ee=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,fe=this.t(new le(this.h,G),U);return this.e.$registerSignatureHelpProvider(fe,this.o(B,U),ee),this.p(fe)}$provideSignatureHelp(U,B,G,Q,ee){return this.s(U,le,fe=>fe.provideSignatureHelp(u.URI.revive(B),G,Q,ee),void 0,ee)}$releaseSignatureHelp(U,B){this.s(U,le,G=>G.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(U,B,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ne(this.h,this.j.converter,G,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(B,U),typeof G.resolveInlayHint=="function",Q,Ae.u(U));let fe=this.p(ee);if(Q!==void 0){const Re=G.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(Q));fe=r.$xN.from(fe,Re)}return fe}$provideInlayHints(U,B,G,Q){return this.s(U,ne,ee=>ee.provideInlayHints(u.URI.revive(B),G,Q),void 0,Q)}$resolveInlayHint(U,B,G){return this.s(U,ne,Q=>Q.resolveInlayHint(B,G),void 0,G)}$releaseInlayHints(U,B){this.s(U,ne,G=>G.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(U,B,G){const Q=this.t(new ce(this.h,G),U);return this.e.$registerDocumentLinkProvider(Q,this.o(B,U),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(U,B,G){return this.s(U,ce,Q=>Q.provideLinks(u.URI.revive(B),G),void 0,G,B.scheme==="output")}$resolveDocumentLink(U,B,G){return this.s(U,ce,Q=>Q.resolveLink(B,G),void 0,void 0,!0)}$releaseDocumentLinks(U,B){this.s(U,ce,G=>G.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(U,B,G){const Q=this.t(new oe(this.h,G),U);return this.e.$registerDocumentColorProvider(Q,this.o(B,U)),this.p(Q)}$provideDocumentColors(U,B,G){return this.s(U,oe,Q=>Q.provideColors(u.URI.revive(B),G),[],G)}$provideColorPresentations(U,B,G,Q){return this.s(U,oe,ee=>ee.provideColorPresentations(u.URI.revive(B),G,Q),void 0,Q)}registerFoldingRangeProvider(U,B,G){const Q=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new ke(new H(this.h,G),U)),this.e.$registerFoldingRangeProvider(Q,this.o(B,U),U.identifier,ee);let fe=this.p(Q);if(ee!==void 0){const Re=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));fe=r.$xN.from(fe,Re)}return fe}$provideFoldingRanges(U,B,G,Q){return this.s(U,H,ee=>ee.provideFoldingRanges(u.URI.revive(B),G,Q),void 0,Q)}registerSelectionRangeProvider(U,B,G){const Q=this.t(new x(this.h,G,this.l),U);return this.e.$registerSelectionRangeProvider(Q,this.o(B,U)),this.p(Q)}$provideSelectionRanges(U,B,G,Q){return this.s(U,x,ee=>ee.provideSelectionRanges(u.URI.revive(B),G,Q),[],Q)}registerCallHierarchyProvider(U,B,G){const Q=this.t(new ue(this.h,G),U);return this.e.$registerCallHierarchyProvider(Q,this.o(B,U)),this.p(Q)}$prepareCallHierarchy(U,B,G,Q){return this.s(U,ue,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(B),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(U,B,G,Q){return this.s(U,ue,ee=>ee.provideCallsTo(B,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(U,B,G,Q){return this.s(U,ue,ee=>ee.provideCallsFrom(B,G,Q),void 0,Q)}$releaseCallHierarchy(U,B){this.s(U,ue,G=>Promise.resolve(G.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(U,B,G){const Q=this.t(new me(this.h,G),U);return this.e.$registerTypeHierarchyProvider(Q,this.o(B,U)),this.p(Q)}$prepareTypeHierarchy(U,B,G,Q){return this.s(U,me,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(B),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(U,B,G,Q){return this.s(U,me,ee=>ee.provideSupertypes(B,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(U,B,G,Q){return this.s(U,me,ee=>ee.provideSubtypes(B,G,Q),void 0,Q)}$releaseTypeHierarchy(U,B){this.s(U,me,G=>Promise.resolve(G.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(U,B,G,Q){const ee=this.q();return this.f.set(ee,new ke(new Oe(this.e,this.h,G,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(B,U),(0,t.$7G)(U,"documentPaste")&&Q?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,B,G,Q,ee,fe){return this.s(U,Oe,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(B,u.URI.revive(G),Q,ee,fe)),void 0,void 0)}$resolveDropEdit(U,B,G){return this.s(U,Oe,Q=>Q.resolveDropEdit(B,G),{},void 0)}$releaseDocumentOnDropEdits(U,B){this.s(U,Oe,G=>Promise.resolve(G.releaseDropEdits(B)),void 0,void 0)}registerMappedEditsProvider(U,B,G){const Q=this.t(new je(this.h,G),U);return this.e.$registerMappedEditsProvider(Q,this.o(B,U)),this.p(Q)}$provideMappedEdits(U,B,G,Q,ee){return this.s(U,je,fe=>Promise.resolve(fe.provideMappedEdits(B,G,Q,ee)),null,ee)}registerDocumentPasteEditProvider(U,B,G,Q){const ee=this.q();return this.f.set(ee,new ke(new A(this.e,this.h,G,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(B,U),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,B,G,Q,ee){return this.s(U,A,fe=>fe.prepareDocumentPaste(u.URI.revive(B),G,Q,ee),void 0,ee)}$providePasteEdits(U,B,G,Q,ee,fe,Re){return this.s(U,A,Ue=>Ue.providePasteEdits(B,u.URI.revive(G),Q,ee,fe,Re),void 0,Re)}$resolvePasteEdit(U,B,G){return this.s(U,A,Q=>Q.resolvePasteEdit(B,G),{},void 0)}$releasePasteEdits(U,B){this.s(U,A,G=>Promise.resolve(G.releasePasteEdits(B)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:Ae.y(U.decreaseIndentPattern),increaseIndentPattern:Ae.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ae.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ae.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:Ae.y(U.beforeText),afterText:U.afterText?Ae.y(U.afterText):void 0,previousLineText:U.previousLineText?Ae.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(Ae.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(B=>r.SyntaxTokenType.toString(B)):void 0}}static E(U){return U.map(Ae.D)}setLanguageConfiguration(U,B,G){const{wordPattern:Q}=G;if(Q&&(0,I.$tf)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(B,Q):this.h.setWordDefinitionFor(B,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),fe={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ae.y(G.wordPattern):void 0,indentationRules:G.indentationRules?Ae.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ae.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ae.E(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,B,fe),this.p(ee)}$setWordDefinitions(U){for(const B of U)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.$Foc=Ae,Ae.d=0}),define(Ie[286],Pe([1,0,4,5,8]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=void 0,k=Ve(k);class O{constructor(N){this.a=new Map,this.c=new Map,this.b=N.getProxy(y.$vN.MainThreadLanguageModelTools),this.b.$getTools().then(v=>{for(const s of v)this.c.set(s.name,s)})}async invokeTool(N,v,s){return await this.b.$invokeTool(N,v,s)}async $acceptToolDelta(N){N.added&&this.c.set(N.added.name,N.added),N.removed&&this.c.delete(N.removed)}get tools(){return Array.from(this.c.values()).map(N=>k.LanguageModelToolDescription.to(N))}async $invokeTool(N,v,s){const I=this.a.get(N);if(!I)throw new Error(`Unknown tool ${N}`);return await I.tool.invoke(v,s)}registerTool(N,v,s){return this.a.set(v,{extension:N,tool:s}),this.b.$registerTool(v),(0,w.$Vc)(()=>{this.a.delete(v),this.b.$unregisterTool(v)})}}e.$0pc=O}),define(Ie[95],Pe([1,0,11,22,42,14,6,40,4,184,19,3,12,77,5,91,17,8,7,117,25]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=e.$mpc=void 0,c=Ve(c),h=Ve(h),e.$mpc=(0,E.$Gi)("IExtHostLanguageModels");class a{constructor($,S){this.option=$,this.stream=new w.$0h,this.stream=S??new w.$0h}}class l{constructor(){this.a=new Map,this.b=new w.$0h,this.c=!1;const $=this;this.apiObject={get stream(){return $.b.asyncIterable},get text(){return w.$7h.map($.b.asyncIterable,S=>{if(S instanceof h.$LP)return S.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,$]of this.a)yield $.stream;else yield this.b}handleFragment($){if(this.c)return;let S=this.a.get($.index);S||(this.a.size===0?S=new a($.index,this.b):S=new a($.index),this.a.set($.index,S));let D;$.part.type==="text"?D=new h.$LP($.part.value):D=new h.$KP($.part.name,$.part.parameters),S.stream.emitOne(D)}reject($){this.c=!0;for(const S of this.d())S.reject($)}resolve(){this.c=!0;for(const $ of this.d())$.resolve()}}let g=t=class{constructor($,S,D){this.j=S,this.k=D,this.c=new R.$ne,this.d=new R.$ne,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$un,this.i=new Map,this.s=new Set,this.b=$.getProxy(d.$vN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel($,S,D,b){const T=t.a++;this.f.set(T,{extension:$.identifier,provider:D,languageModelId:S});let P;b.auth&&(P={providerLabel:$.displayName||$.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this.b.$registerLanguageModelProvider(T,`${I.$sn.toKey($.identifier)}/${T}/${S}`,{extension:$.identifier,id:S,vendor:b.vendor??I.$sn.toKey($.identifier),name:b.name??"",family:b.family??"",version:b.version,maxInputTokens:b.maxInputTokens,maxOutputTokens:b.maxOutputTokens,auth:P,targetExtensions:b.extensions});const p=D.onDidReceiveLanguageModelResponse2?.(({extensionId:f,participant:M,tokenCount:L})=>{this.b.$whenLanguageModelChatRequestMade(S,new I.$sn(f),M,L)});return(0,v.$Vc)(()=>{this.f.delete(T),this.b.$unregisterProvider(T),p?.dispose()})}async $startChatRequest($,S,D,b,T,P){const p=this.f.get($);if(!p)throw new Error("Provider not found");const f=new C.$xw(async L=>{if(P.isCancellationRequested){this.j.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let K;if(L.part instanceof h.$KP?K={type:"function_use",name:L.part.name,parameters:L.part.parameters}:L.part instanceof h.$LP&&(K={type:"text",value:L.part.value}),!K){this.j.warn(`[CHAT](${p.extension.value}) UNKNOWN part ${JSON.stringify(L)}`);return}this.b.$reportResponsePart(S,{index:L.index,part:K})});let M;if(p.provider.provideLanguageModelResponse2)M=Promise.resolve(p.provider.provideLanguageModelResponse2(b.map(c.LanguageModelChatMessage.to),T,I.$sn.toKey(D),f,P));else{const L=new C.$xw(async K=>{f.report({index:K.index,part:new h.$LP(K.part)})});M=Promise.resolve(p.provider.provideLanguageModelResponse(b.map(c.LanguageModelChatMessage.to),T?.modelOptions??{},I.$sn.toKey(D),L,P))}M.then(()=>{this.b.$reportResponseDone(S,void 0)},L=>{this.b.$reportResponseDone(S,(0,O.$5)(L))})}$provideTokenLength($,S,D){const b=this.f.get($);return b?Promise.resolve(b.provider.provideTokenCount(S,D)):Promise.resolve(0)}$acceptChatModelMetadata($){if($.added)for(const{identifier:S,metadata:D}of $.added)this.g.set(S,{metadata:D,apiObjects:new I.$un});if($.removed)for(const S of $.removed){this.g.delete(S);for(const[D,b]of this.i)b.languageModelId===S&&(b.res.reject(new O.$8),this.i.delete(D))}$.added?.forEach(S=>this.q(S.metadata)),this.d.fire(void 0)}async selectLanguageModels($,S){const D=await this.b.$selectChatModels({...S,extension:$.identifier}),b=[],T=this;for(const P of D){const p=this.g.get(P);if(!p)continue;this.o($.identifier,p.metadata)&&await this.q(p.metadata);let f=p.apiObjects.get($.identifier);f||(f={id:P,vendor:p.metadata.vendor,family:p.metadata.family,version:p.metadata.version,name:p.metadata.name,maxInputTokens:p.metadata.maxInputTokens,countTokens(M,L){if(!T.g.has(P))throw h.$PP.NotFound(P);return T.r(P,M,L??y.CancellationToken.None)},sendRequest(M,L,K){if(!T.g.has(P))throw h.$PP.NotFound(P);return T.l($,P,M,L??{},K??y.CancellationToken.None)}},Object.freeze(f),p.apiObjects.set($.identifier,f)),b.push(f)}return b}async l($,S,D,b,T){const P=this.m($,D),p=$.identifier,f=this.g.get(S)?.metadata;if(!f||!this.g.has(S))throw h.$PP.NotFound(`Language model '${S}' is unknown.`);if(this.o(p,f)&&(!await this.n($,{identifier:f.extension,displayName:f.auth.providerLabel},b.justification,!1)||!this.h.get(p)?.has(f.extension)))throw h.$PP.NoPermissions(`Language model '${S}' cannot be used by '${p.value}'.`);try{const M=Math.random()*1e6|0,L=new l;this.i.set(M,{languageModelId:S,res:L});try{await this.b.$tryStartChatRequest(p,S,M,P,b,T)}catch(K){throw this.i.delete(M),K}return L.apiObject}catch(M){throw M.name===h.$PP.name?M:new h.$PP(`Language model '${S}' errored: ${(0,k.$rj)(M)}`,"Unknown",M)}}m($,S){const D=[];for(const b of S)b.role===h.LanguageModelChatMessageRole.System&&(0,r.$8G)($,"languageModelSystem"),b.content2 instanceof h.$IP&&(0,r.$8G)($,"lmTools"),D.push(c.LanguageModelChatMessage.from(b));return D}async $acceptResponsePart($,S){const D=this.i.get($);D&&D.res.handleFragment(S)}async $acceptResponseDone($,S){const D=this.i.get($);D&&(this.i.delete($),S?D.res.reject((0,O.$6)(S)):D.res.resolve())}async n($,S,D,b){const T=i.$xM+S.identifier.value;if(await this.k.getSession($,T,[],{silent:!0}))return this.$updateModelAccesslist([{from:$.identifier,to:S.identifier,enabled:!0}]),!0;if(b)return!1;try{const p=D?(0,s.localize)(0,null,S.displayName,D):void 0;return await this.k.getSession($,T,[],{forceNewSession:{detail:p}}),this.$updateModelAccesslist([{from:$.identifier,to:S.identifier,enabled:!0}]),!0}catch{return!1}}o($,S){return!!S.auth&&!I.$sn.equals(S.extension,$)}async q($){if($.auth)for(const S of this.s)try{await this.n(S,{identifier:$.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r($,S,D){if(!this.g.get($))throw h.$PP.NotFound(`Language model '${$}' is unknown.`);const T=N.Iterable.find(this.f.values(),P=>P.languageModelId===$);return T?T.provider.provideTokenCount(S,D):this.b.$countTokens($,typeof S=="string"?S:c.LanguageModelChatMessage.from(S),D)}$updateModelAccesslist($){const S=new Array;for(const{from:D,to:b,enabled:T}of $){const P=this.h.get(D)??new I.$tn;if(P.has(b)!==T){T?P.add(b):P.delete(b),this.h.set(D,P);const f={from:D,to:b};S.push(f),this.c.fire(f)}}}createLanguageModelAccessInformation($){this.s.add($);const S=this,D=R.Event.signal(R.Event.filter(this.c.event,T=>I.$sn.equals(T.from,$.identifier))),b=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(D,b)},canSendRequest(T){let P;e:for(const[f,M]of S.g)for(const L of M.apiObjects.values())if(L===T){P=M.metadata;break e}if(!P)return;if(!S.o($.identifier,P))return!0;const p=S.h.get($.identifier);if(p)return p.has(P.extension)}}}};e.$npc=g,g.a=1,e.$npc=g=t=He([Ge(0,o.$2P),Ge(1,u.$ak),Ge(2,n.$Hoc)],g)});var ni=this&&this.__importDefault||function(_){return _&&_.__esModule?_:{default:_}};define(Ie[287],Pe([1,0,5,8,7,36,11,4,25]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$pc=void 0,y=Ve(y),O=ni(O);class s{constructor(E,u,C,d){this.c=u,this.d=C,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(w.$vN.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,u){await this.a.$changeLanguage(E,u);const C=this.c.getDocumentData(E);if(!C)throw new Error(`document '${E.toString()}' NOT found`);return C.document}async tokenAtPosition(E,u){const C=E.version,d=y.Position.from(u),n=await this.a.$tokensAtPosition(E.uri,d),o={type:k.StandardTokenType.Other,range:E.getWordRangeAtPosition(u)??new k.$zN(u.line,u.character,u.line,u.character)};if(!n)return o;const c={range:y.Range.to(n.range),type:y.TokenType.to(n.type)};return!c.range.contains(u)||C!==E.version?o:c}createLanguageStatusItem(E,u,C){const d=this.f++,n=this.a,o=this.g,c=`${E.identifier.value}/${u}`;if(o.has(c))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(c);const h={selector:C,id:u,name:E.displayName??E.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new N.$Wc,t=()=>{if(i?.dispose(),!o.has(c)){console.warn(`LanguageStatusItem (${u}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$Ih)(()=>{r.clear(),this.a.$setLanguageStatus(d,{id:c,name:h.name??E.displayName??E.name,source:E.displayName??E.name,selector:y.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===k.LanguageStatusSeverity.Error?O.default.Error:h.severity===k.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:h.command&&this.d.toInternal(h.command,r),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},a={dispose(){r.dispose(),i?.dispose(),n.$removeLanguageStatus(d),o.delete(c)},get id(){return h.id},get name(){return h.name},set name(l){h.name=l,t()},get selector(){return h.selector},set selector(l){h.selector=l,t()},get text(){return h.text},set text(l){h.text=l,t()},set text2(l){(0,v.$8G)(E,"languageStatusText"),h.text=l,t()},get text2(){return(0,v.$8G)(E,"languageStatusText"),h.text},get detail(){return h.detail},set detail(l){h.detail=l,t()},get severity(){return h.severity},set severity(l){h.severity=l,t()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(l){h.accessibilityInformation=l,t()},get command(){return h.command},set command(l){h.command=l,t()},get busy(){return h.busy},set busy(l){h.busy=l,t()}};return t(),a}}e.$$pc=s}),define(Ie[288],Pe([1,0,16,2,8,7,90]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=e.$Vpc=void 0,k=Ve(k),R=Ve(R);class N{constructor(E,u,C,d){this.start=E,this.deletedCount=u,this.deletedItems=C,this.items=d}asApiEvent(){return{range:new O.$ZO(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class v{static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,u,C){this.notebook=E,this.h=u,this.j=C,this.handle=C.handle,this.uri=y.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(k.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return E.g},set mime(d){E.g=d},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(C)}return this.f}setOutputs(E){this.a=E.map(k.NotebookCellOutput.to)}setOutputItems(E,u,C){const d=C.map(k.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===E);if(n&&(u||(n.items.length=0),n.items.push(...d),n.items.length>1&&n.items.every(o=>R.$AL(o.mime)))){const o=new Map,c=[];n.items.forEach(h=>{let i;o.has(h.mime)?i=o.get(h.mime):(i=[],o.set(h.mime,i),c.push(h.mime)),i.push(h.data)}),n.items.length=0,c.forEach(h=>{const i=R.$BL(o.get(h));n.items.push({mime:h,data:i.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$Vpc=v;class s{constructor(E,u,C,d,n){this.k=E,this.l=u,this.m=C,this.uri=d,this.handle=s.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,u={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===w.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(C){return C=E.n(C),E.b[C].apiCell},getCells(C){return(C?E.p(C):E.b).map(n=>n.apiCell)},save(){return E.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,u,C){this.g=E.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:C});const d={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},n=[];for(const c of E.rawEvents)c.kind===R.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,d.contentChanges):c.kind===R.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,d.contentChanges):c.kind===R.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),n.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),n.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),n.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===R.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),n.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),n.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const o=new Map;for(let c=0;c<n.length;c++){const h=n[c],i=o.get(h.cell);if(i===void 0){const r=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});o.set(h.cell,r-1)}else d.cellChanges[i]={...d.cellChanges[i],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let u=E.start|0,C=E.end|0;return u<0&&(u=0),C>this.b.length&&(C=this.b.length),E.with({start:u,end:C})}p(E){E=this.o(E);const u=[];for(let C=E.start;C<E.end;C++)u.push(this.b[C]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,u,C){if(this.j)return;const d=[],n=[],o=[];if(E.reverse().forEach(c=>{const i=c[2].map(a=>{const l=new v(this,this.l,a);return u||n.push(v.asModelAddData(a)),l}),r=new N(c[0],c[1],[],i),t=this.b.splice(c[0],c[1],...i);for(const a of t)o.push(a.uri),r.deletedItems.push(a.apiCell);d.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),C)for(const c of d)C.push(c.asApiEvent())}s(E,u,C,d){const n=this.b.splice(E,u);this.b.splice(C,0,...n);const o=[new N(E,u,n.map(c=>c.apiCell),[]),new N(C,0,[],n)];for(const c of o)d.push(c.asApiEvent())}t(E,u){this.b[E].setOutputs(u)}u(E,u,C,d){this.b[E].setOutputItems(u,C,d)}v(E,u){const C=this.b[E];C.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(C.uri,u)}w(E,u){const C=this.b[E];C.apiCell.mime=u}x(E,u){this.b[E].setMetadata(u)}y(E,u){this.b[E].setInternalMetadata(u)}getCellFromApiCell(E){return this.b.find(u=>u.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(u=>u.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$Wpc=s,s.a=0}),define(Ie[289],Pe([1,0,6,2,8,7,39]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aqc=void 0;class N{constructor(s,I,E,u={timeout:1500,errors:3}){this.b=s,this.c=I,this.d=E,this.f=u,this.a=new w.$pe}dispose(){}getOnWillSaveNotebookDocumentEvent(s){return(I,E,u)=>{const C=function(n){I.call(E,n)};return C.extension=s,this.a.event(C,void 0,u)}}async $participateInSave(s,I,E){const u=y.URI.revive(s),C=this.c.getNotebookDocument(u);if(!C)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:C.apiNotebook,reason:k.TextDocumentSaveReason.to(I)},E,async(o,c)=>{const h=Date.now(),i=await await Promise.resolve(o);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!E.isCancellationRequested&&i&&(i instanceof O.$HN?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(d.length===0)return!0;const n={edits:[]};for(const o of d){const{edits:c}=k.WorkspaceEdit.from(o);n.edits=n.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new R.$Vw(n))}}e.$aqc=N}),define(Ie[124],Pe([1,0,14,8,7]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0,y=Ve(y),k=Ve(k);class O{constructor(N,v,s,I,E,u){this.id=N,this.f=v,this.notebookData=s,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=I,this.c=u}get apiEditor(){if(!this.e){const N=this;this.e={get notebook(){return N.notebookData.apiNotebook},get selection(){return N.a[0]},set selection(v){this.selections=[v]},get selections(){return N.a},set selections(v){if(!Array.isArray(v)||!v.every(k.$ZO.isNotebookRange))throw(0,w.$0)("selections");N.a=v,N.g(v)},get visibleRanges(){return N.b},revealRange(v,s){N.f.$tryRevealRange(N.id,y.NotebookRange.from(v),s??k.NotebookEditorRevealType.Default)},get viewColumn(){return N.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(N){this.d=N}_acceptVisibleRanges(N){this.b=N}_acceptSelections(N){this.a=N}g(N){this.f.$trySetSelections(this.id,N.map(y.NotebookRange.from))}_acceptViewColumn(N){this.c=N}}e.$Xpc=O,O.apiEditorsToExtHost=new WeakMap}),define(Ie[290],Pe([1,0,6,12,8]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=void 0,k=Ve(k);let O=class{constructor(N,v){this.c=N,this.d=v,this.a=new w.$ne,this.b=new w.$ne,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(N,v){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",N,v);const s=this.d.getEditorById(N);v.visibleRanges&&s._acceptVisibleRanges(v.visibleRanges.ranges.map(k.NotebookRange.to)),v.selections&&s._acceptSelections(v.selections.selections.map(k.NotebookRange.to)),v.visibleRanges&&this.b.fire({notebookEditor:s.apiEditor,visibleRanges:s.apiEditor.visibleRanges}),v.selections&&this.a.fire(Object.freeze({notebookEditor:s.apiEditor,selections:s.apiEditor.selections}))}$acceptEditorViewColumns(N){for(const v in N)this.d.getEditorById(v)._acceptViewColumn(k.ViewColumn.to(N[v]))}};e.$cqc=O,e.$cqc=O=He([Ge(0,y.$ak)],O)}),define(Ie[291],Pe([1,0,6,5,124]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=void 0;class O{constructor(N,v){this.c=v,this.a=new Map,this.b=N.getProxy(y.$vN.MainThreadNotebookRenderers)}$postRendererMessage(N,v,s){const I=this.c.getEditorById(N);this.a.get(v)?.fire({editor:I.apiEditor,message:s})}createRendererMessaging(N,v){if(!N.contributes?.notebookRenderer?.some(I=>I.id===v))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${v})`);return{onDidReceiveMessage:(I,E,u)=>this.d(v).event(I,E,u),postMessage:(I,E)=>{k.$Xpc.apiEditorsToExtHost.has(I)&&([I,E]=[E,I]);const u=E&&k.$Xpc.apiEditorsToExtHost.get(E);return this.b.$postMessage(u?.id,v,I)}}}d(N){let v=this.a.get(N);return v||(v=new w.$ne({onDidRemoveLastListener:()=>{v?.dispose(),this.a.delete(N)}}),this.a.set(N,v),v)}}e.$fqc=O}),define(Ie[292],Pe([1,0,8,77,22,72,14]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=void 0;class N{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,u,C){const d=this.b++,{title:n,location:o,cancellable:c}=u,h={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(d,{location:w.ProgressLocation.from(o),title:n,source:h,cancellable:c},E.isUnderDevelopment?void 0:E.identifier.value).catch(R.$4),this.d(d,C,!!c)}d(E,u,C){let d;C&&(d=new k.$ye,this.c.set(E,d));const n=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let o;try{o=u(new s(this.a,E),C&&d?d.token:k.CancellationToken.None)}catch(c){throw n(E),c}return o.then(c=>n(E),c=>n(E)),o}$acceptProgressCanceled(E){const u=this.c.get(E);u&&(u.cancel(),this.c.delete(E))}}e.$jqc=N;function v(I,E){return I.message=E.message,typeof E.increment=="number"&&(typeof I.increment=="number"?I.increment+=E.increment:I.increment=E.increment),I}class s extends y.$xw{constructor(E,u){super(C=>this.throttledReport(C)),this.c=E,this.d=u}throttledReport(E){this.c.$progressReport(this.d,E)}}He([(0,O.$ai)(100,(I,E)=>v(I,E),()=>Object.create(null))],s.prototype,"throttledReport",null)}),define(Ie[293],Pe([1,0,2,5,11,8]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=void 0;class R{constructor(v,s){this.d=s,this.c=new Map,this.b=v.getProxy(y.$vN.MainThreadQuickDiff)}$provideOriginalResource(v,s,I){const E=w.URI.revive(s),u=this.c.get(v);return u?(0,k.$yh)(()=>u.provideOriginalResource(E,I)).then(C=>C||null):Promise.resolve(null)}registerQuickDiffProvider(v,s,I,E){const u=R.a++;return this.c.set(u,s),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from(v,this.d),I,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$kqc=R,R.a=0});var ni=this&&this.__importDefault||function(_){return _&&_.__esModule?_:{default:_}};define(Ie[294],Pe([1,0,22,6,4,5,2,7,14,18,36,35,25,8]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=d,I=ni(I);function d(n,o,c){const h=n.getProxy(O.$vN.MainThreadQuickOpen);class i{constructor(D,b){this.e=new Map,this.f=0,this.a=D,this.b=b}showQuickPick(D,b,T,P=w.CancellationToken.None){this.c=void 0;const p=Promise.resolve(b),f=++this.f,M=h.$show(f,{title:T?.title,placeHolder:T?.placeHolder,matchOnDescription:T?.matchOnDescription,matchOnDetail:T?.matchOnDetail,ignoreFocusLost:T?.ignoreFocusOut,canPickMany:T?.canPickMany},P),L={},K=M.then(()=>L);return Promise.race([K,p]).then(J=>{if(J===L)return;const z=(0,u.$7G)(D,"quickPickItemTooltip");return p.then(A=>{const W=[];for(let Z=0;Z<A.length;Z++){const he=A[Z];if(typeof he=="string")W.push({label:he,handle:Z});else if(he.kind===N.QuickPickItemKind.Separator)W.push({type:"separator",label:he.label});else{he.tooltip&&!z&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const ve=he.iconPath?g(he.iconPath):void 0;W.push({label:he.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:z?C.MarkdownString.fromStrict(he.tooltip):void 0,handle:Z})}}return T&&typeof T.onDidSelectItem=="function"&&(this.c=Z=>{T.onDidSelectItem(A[Z])}),h.$setItems(f,W),M.then(Z=>{if(typeof Z=="number")return A[Z];if(Array.isArray(Z))return Z.map(he=>A[he])})})}).then(void 0,J=>{if(!(0,v.$7)(J))return h.$setError(f,J),Promise.reject(J)})}$onItemSelected(D){this.c?.(D)}showInput(D,b=w.CancellationToken.None){return this.d=D?.validateInput,h.$input(D,typeof this.d=="function",b).then(void 0,T=>{if(!(0,v.$7)(T))return Promise.reject(T)})}async $validateInput(D){if(!this.d)return;const b=await this.d(D);if(!b||typeof b=="string")return b;let T;switch(b.severity){case N.InputBoxValidationSeverity.Info:T=I.default.Info;break;case N.InputBoxValidationSeverity.Warning:T=I.default.Warning;break;case N.InputBoxValidationSeverity.Error:T=I.default.Error;break;default:T=b.message?I.default.Error:I.default.Ignore;break}return{content:b.message,severity:T}}async showWorkspaceFolderPick(D,b=w.CancellationToken.None){const T=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!T)return;const P=await this.a.getWorkspaceFolders2();if(P)return P.find(p=>p.uri.toString()===T.uri.toString())}createQuickPick(D){const b=new m(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}createInputBox(D){const b=new $(D,()=>this.e.delete(b._id));return this.e.set(b._id,b),b}$onDidChangeValue(D,b){this.e.get(D)?._fireDidChangeValue(b)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,b){const T=this.e.get(D);T instanceof m&&T._fireDidChangeActive(b)}$onDidChangeSelection(D,b){const T=this.e.get(D);T instanceof m&&T._fireDidChangeSelection(b)}$onDidTriggerButton(D,b){this.e.get(D)?._fireDidTriggerButton(b)}$onDidTriggerItemButton(D,b,T){const P=this.e.get(D);P instanceof m&&P._fireDidTriggerItemButton(b,T)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class r{constructor(D,b){this.x=D,this.y=b,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new y.$ne,this.q=new y.$ne,this.r=new y.$ne,this.s=new y.$ne,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((b,T)=>{const P=b===N.$WO.Back?-1:T;this.o.set(P,b)}),this.z({buttons:D.map((b,T)=>({...g(b.iconPath),tooltip:b.tooltip,handle:b===N.$WO.Back?-1:T}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const b=this.o.get(D);b&&this.r.fire(b)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.$Sc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(D){if(!this.v){for(const b of Object.keys(D)){const T=D[b];this.u[b]=T===void 0?null:T}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}r.a=1;function t(S){if(S instanceof N.$uO)return{id:S.id};const D=l(S),b=a(S);return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof b=="string"?R.URI.file(b):b}}function a(S){return typeof S=="object"&&"light"in S?S.light:S}function l(S){return typeof S=="object"&&"dark"in S?S.dark:S}function g(S){const D=t(S);let b,T;return"id"in D?T=E.ThemeIcon.asClassName(D):b=D,{iconPath:b,iconClass:T}}class m extends r{constructor(D,b){super(D.identifier,b),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new y.$ne,this.L=[],this.M=new y.$ne,this.N=new y.$ne,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((P,p)=>{this.C.set(p,P),this.D.set(P,p)});const b=(0,u.$7G)(this.O,"quickPickItemTooltip"),T=[];for(let P=0;P<D.length;P++){const p=D[P];if(p.kind===N.QuickPickItemKind.Separator)T.push({type:"separator",label:p.label});else{p.tooltip&&!b&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const f=p.iconPath?g(p.iconPath):void 0;T.push({handle:P,label:p.label,iconPath:f?.iconPath,iconClass:f?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:b?C.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((M,L)=>({...g(M.iconPath),tooltip:M.tooltip,handle:L}))})}}this.z({items:T})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(b=>this.D.has(b)),this.z({activeItems:this.J.map(b=>this.D.get(b))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(b=>this.D.has(b)),this.z({selectedItems:this.L.map(b=>this.D.get(b))})}_fireDidChangeActive(D){const b=(0,s.$Kb)(D.map(T=>this.C.get(T)));this.J=b,this.K.fire(b)}_fireDidChangeSelection(D){const b=(0,s.$Kb)(D.map(T=>this.C.get(T)));this.L=b,this.M.fire(b)}_fireDidTriggerItemButton(D,b){const T=this.C.get(D);if(!T||!T.buttons||!T.buttons.length)return;const P=T.buttons[b];P&&this.N.fire({button:P,item:T})}}class $ extends r{constructor(D,b){super(D.identifier,b),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:I.default.Error}):this.z({validationMessage:D.message,severity:D.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(o,c)}});var ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)},rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w};define(Ie[295],Pe([1,0,2,6,72,4,11,5,18,144,12,19,37,35,8,25,16,21]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c){"use strict";var h,i,r,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=e.$mqc=void 0;function a(z){return z instanceof w.URI}function l(z,A){return z.scheme===o.Schemas.file&&A.scheme===o.Schemas.file&&c.$e?z.toString()===A.toString():z.toString().toLowerCase()===A.toString().toLowerCase()}function g(z){if(z)return typeof z.iconPath=="string"?w.URI.file(z.iconPath):w.URI.isUri(z.iconPath)||C.ThemeIcon.isThemeIcon(z.iconPath)?z.iconPath:void 0}function m(z){if(z){if(w.URI.isUri(z))return z;if(C.ThemeIcon.isThemeIcon(z))return z;{const A=z;return{light:A.light,dark:A.dark}}}else return}function $(z){const A=m(z.icon),W=z.labels?.map(Z=>({title:Z.title,icon:m(Z.icon)}));return{...z,icon:A,labels:W}}function S(z,A){if(!z.iconPath&&!A.iconPath)return 0;if(z.iconPath){if(!A.iconPath)return 1}else return-1;const W=typeof z.iconPath=="string"?z.iconPath:w.URI.isUri(z.iconPath)?z.iconPath.fsPath:z.iconPath.id,Z=typeof A.iconPath=="string"?A.iconPath:w.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id;return(0,s.$Jr)(W,Z)}function D(z,A){let W=0;if(z.strikeThrough!==A.strikeThrough)return z.strikeThrough?1:-1;if(z.faded!==A.faded)return z.faded?1:-1;if(z.tooltip!==A.tooltip)return(z.tooltip||"").localeCompare(A.tooltip||"");if(W=S(z,A),W!==0)return W;if(z.light&&A.light)W=S(z.light,A.light);else{if(z.light)return 1;if(A.light)return-1}if(W!==0)return W;if(z.dark&&A.dark)W=S(z.dark,A.dark);else{if(z.dark)return 1;if(A.dark)return-1}return W}function b(z,A){if(z.command!==A.command)return z.command<A.command?-1:1;if(z.title!==A.title)return z.title<A.title?-1:1;if(z.tooltip!==A.tooltip){if(z.tooltip!==void 0&&A.tooltip!==void 0)return z.tooltip<A.tooltip?-1:1;if(z.tooltip!==void 0)return 1;if(A.tooltip!==void 0)return-1}if(z.arguments===A.arguments)return 0;if(z.arguments)if(A.arguments){if(z.arguments.length!==A.arguments.length)return z.arguments.length-A.arguments.length}else return 1;else return-1;for(let W=0;W<z.arguments.length;W++){const Z=z.arguments[W],he=A.arguments[W];if(Z!==he&&!(a(Z)&&a(he)&&l(Z,he)))return Z<he?-1:1}return 0}function T(z,A){let W=(0,s.$Jr)(z.resourceUri.fsPath,A.resourceUri.fsPath,!0);if(W!==0)return W;if(z.command&&A.command)W=b(z.command,A.command);else{if(z.command)return 1;if(A.command)return-1}if(W!==0)return W;if(z.decorations&&A.decorations)W=D(z.decorations,A.decorations);else{if(z.decorations)return 1;if(A.decorations)return-1}if(z.multiFileDiffEditorModifiedUri&&A.multiFileDiffEditorModifiedUri)W=(0,s.$Jr)(z.multiFileDiffEditorModifiedUri.fsPath,A.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(z.multiFileDiffEditorModifiedUri)return 1;if(A.multiFileDiffEditorModifiedUri)return-1}if(z.multiDiffEditorOriginalUri&&A.multiDiffEditorOriginalUri)W=(0,s.$Jr)(z.multiDiffEditorOriginalUri.fsPath,A.multiDiffEditorOriginalUri.fsPath,!0);else{if(z.multiDiffEditorOriginalUri)return 1;if(A.multiDiffEditorOriginalUri)return-1}return W}function P(z,A){for(let W=0;W<z.length;W++)if(z[W]!==A[W])return!1;return!0}function p(z,A){return z.command===A.command&&z.title===A.title&&z.tooltip===A.tooltip&&(z.arguments&&A.arguments?P(z.arguments,A.arguments):z.arguments===A.arguments)}function f(z,A){return(0,v.$xb)(z,A,p)}class M{get value(){return this.d}set value(A){A=A??"",ze(this,h,"f").$setInputBoxValue(this.m,A),this.o(A)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(A){ze(this,h,"f").$setInputBoxPlaceholder(this.m,A),this.f=A}get validateInput(){return(0,n.$8G)(this.k,"scmValidation"),this.g}set validateInput(A){if((0,n.$8G)(this.k,"scmValidation"),A&&typeof A!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=A,ze(this,h,"f").$setValidationProviderIsEnabled(this.m,!!A)}get enabled(){return this.h}set enabled(A){A=!!A,this.h!==A&&(this.h=A,ze(this,h,"f").$setInputBoxEnablement(this.m,A))}get visible(){return this.j}set visible(A){A=!!A,this.j!==A&&(this.j=A,ze(this,h,"f").$setInputBoxVisibility(this.m,A))}get document(){return(0,n.$8G)(this.k,"scmTextDocument"),ze(this,i,"f").getDocument(this.n)}constructor(A,W,Z,he,ve){this.k=A,this.m=he,this.n=ve,h.set(this,void 0),i.set(this,void 0),this.d="",this.e=new y.$ne,this.f="",this.h=!0,this.j=!0,rt(this,i,W,"f"),rt(this,h,Z,"f")}showValidationMessage(A,W){(0,n.$8G)(this.k,"scmValidation"),ze(this,h,"f").$showValidationMessage(this.m,A,W)}$onInputBoxValueChange(A){this.o(A)}o(A){this.d=A,this.e.fire(A)}}e.$mqc=M,h=new WeakMap,i=new WeakMap;class L{get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(A){this.w=A,this.s.$updateGroupLabel(this.u,this.handle,A)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(A){this.q=A,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(A){this.f=[...A],this.k.fire()}constructor(A,W,Z,he,ve,be,de){this.s=A,this.t=W,this.u=Z,this.v=he,this.w=ve,this.multiDiffEditorEnableViewChanges=be,this.x=de,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new y.$ne,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new y.$ne,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=L.d++}getResourceState(A){return this.g.get(A)}$executeResourceCommand(A,W){const Z=this.h.get(A);return Z?(0,R.$yh)(()=>this.t.executeCommand(Z.command,...Z.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const A=[...this.f].sort(T),Z=(0,v.$Gb)(this.p,A,T).map(be=>{const de=be.toInsert.map($e=>{const ye=this.e++;this.g.set(ye,$e);const Y=$e.resourceUri;let we;if($e.command)if($e.command.command==="vscode.open"||$e.command.command==="vscode.diff"||$e.command.command==="vscode.changes"){const Oe=new O.$Wc;we=this.t.converter.toInternal($e.command,Oe),this.j.set(ye,Oe)}else this.h.set(ye,$e.command);const Te=(0,n.$7G)(this.x,"scmMultiDiffEditor"),re=Te?$e.multiDiffEditorOriginalUri:void 0,q=Te?$e.multiFileDiffEditorModifiedUri:void 0,ae=g($e.decorations),le=$e.decorations&&g($e.decorations.light)||ae,ne=$e.decorations&&g($e.decorations.dark)||ae,ce=[le,ne],oe=$e.decorations&&$e.decorations.tooltip||"",H=$e.decorations&&!!$e.decorations.strikeThrough,x=$e.decorations&&!!$e.decorations.faded,ue=$e.contextValue||"";return{rawResource:[ye,Y,ce,oe,H,x,ue,we,re,q],handle:ye}});return{start:be.start,deleteCount:be.deleteCount,toInsert:de}}),he=Z.map(({start:be,deleteCount:de,toInsert:$e})=>[be,de,$e.map(ye=>ye.rawResource)]),ve=Z.reverse();for(const{start:be,deleteCount:de,toInsert:$e}of ve){const ye=$e.map(we=>we.handle),Y=this.o.splice(be,de,...ye);for(const we of Y)this.g.delete(we),this.h.delete(we),this.j.get(we)?.dispose(),this.j.delete(we)}return this.p=A,he}dispose(){this.m=!0,this.n.fire()}}L.d=0;class K{get id(){return this.B}get label(){return this.C}get rootUri(){return this.D}get inputBox(){return this.f}get count(){return this.g}set count(A){this.g!==A&&(this.g=A,ze(this,r,"f").$updateSourceControl(this.x,{count:A}))}get quickDiffProvider(){return this.h}set quickDiffProvider(A){this.h=A;let W;(0,n.$7G)(this.y,"quickDiffProvider")&&(W=A?.label),ze(this,r,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!A,quickDiffLabel:W})}get historyProvider(){return(0,n.$8G)(this.y,"scmHistoryProvider"),this.j}set historyProvider(A){(0,n.$8G)(this.y,"scmHistoryProvider"),this.j=A,this.k.value=new O.$Wc,ze(this,r,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!A}),A&&this.k.value.add(A.onDidChangeCurrentHistoryItemGroup(()=>{this.m=A?.currentHistoryItemGroup,ze(this,r,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(A){A!==this.n&&(this.n=A,ze(this,r,"f").$updateSourceControl(this.x,{commitTemplate:A}))}get acceptInputCommand(){return this.p}set acceptInputCommand(A){this.o.value=new O.$Wc,this.p=A;const W=this.z.converter.toInternal(A,this.o.value);ze(this,r,"f").$updateSourceControl(this.x,{acceptInputCommand:W})}get actionButton(){return(0,n.$8G)(this.y,"scmActionButton"),this.s}set actionButton(A){(0,n.$8G)(this.y,"scmActionButton"),this.q.value=new O.$Wc,this.s=A;const W=A!==void 0?{command:this.z.converter.toInternal(A.command,this.q.value),secondaryCommands:A.secondaryCommands?.map(Z=>Z.map(he=>this.z.converter.toInternal(he,this.q.value))),description:A.description,enabled:A.enabled}:void 0;ze(this,r,"f").$updateSourceControl(this.x,{actionButton:W??null})}get statusBarCommands(){return this.u}set statusBarCommands(A){if(this.A.trace("ExtHostSourceControl#statusBarCommands",(A??[]).map(Z=>Z.command).join(", ")),this.u&&A&&f(this.u,A)){this.A.trace("ExtHostSourceControl#statusBarCommands are equal");return}this.t.value=new O.$Wc,this.u=A;const W=(A||[]).map(Z=>this.z.converter.toInternal(Z,this.t.value));ze(this,r,"f").$updateSourceControl(this.x,{statusBarCommands:W})}get selected(){return this.v}constructor(A,W,Z,he,ve,be,de,$e){this.y=A,this.z=he,this.A=ve,this.B=be,this.C=de,this.D=$e,r.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Yc,this.n=void 0,this.o=new O.$Yc,this.p=void 0,this.q=new O.$Yc,this.t=new O.$Yc,this.u=void 0,this.v=!1,this.w=new y.$ne,this.onDidChangeSelection=this.w.event,this.x=K.d++,this.E=new Map,this.F=new Set,rt(this,r,Z,"f");const ye=w.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${be}/scm${this.x}/input`,query:$e?`rootUri=${encodeURIComponent($e.toString())}`:void 0});this.f=new M(A,W,ze(this,r,"f"),this.x,ye),ze(this,r,"f").$registerSourceControl(this.x,be,de,$e,ye)}createResourceGroup(A,W,Z){const he=(0,n.$7G)(this.y,"scmMultiDiffEditor")&&Z?.multiDiffEditorEnableViewChanges===!0,ve=new L(ze(this,r,"f"),this.z,this.x,A,W,he,this.y),be=y.Event.once(ve.onDidDispose)(()=>this.E.delete(ve));return this.E.set(ve,be),this.eventuallyAddResourceGroups(),ve}eventuallyAddResourceGroups(){const A=[],W=[];for(const[Z,he]of this.E){he.dispose();const ve=Z.onDidUpdateResourceStates(()=>{this.F.add(Z),this.eventuallyUpdateResourceStates()});y.Event.once(Z.onDidDispose)(()=>{this.F.delete(Z),ve.dispose(),this.e.delete(Z.handle),ze(this,r,"f").$unregisterGroup(this.x,Z.handle)}),A.push([Z.handle,Z.id,Z.label,Z.features,Z.multiDiffEditorEnableViewChanges]);const be=Z._takeResourceStateSnapshot();be.length>0&&W.push([Z.handle,be]),this.e.set(Z.handle,Z)}ze(this,r,"f").$registerGroups(this.x,A,W),this.E.clear()}eventuallyUpdateResourceStates(){const A=[];this.F.forEach(W=>{const Z=W._takeResourceStateSnapshot();Z.length!==0&&A.push([W.handle,Z])}),A.length>0&&ze(this,r,"f").$spliceResourceStates(this.x,A),this.F.clear()}getResourceGroup(A){return this.e.get(A)}setSelectionState(A){this.v=A,this.w.fire(A)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(A=>A.dispose()),ze(this,r,"f").$unregisterSourceControl(this.x)}}r=new WeakMap,K.d=0,He([(0,k.$_h)(100)],K.prototype,"eventuallyAddResourceGroups",null),He([(0,k.$_h)(100)],K.prototype,"eventuallyUpdateResourceStates",null);let J=t=class{get onDidChangeActiveProvider(){return this.j.event}constructor(A,W,Z,he){this.m=W,this.n=Z,this.o=he,this.g=new Map,this.h=new E.$un,this.j=new y.$ne,this.e=A.getProxy(N.$vN.MainThreadSCM),this.f=A.getProxy(N.$vN.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:ve=>{if(ve&&ve.$mid===u.MarshalledId.ScmResource){const be=this.g.get(ve.sourceControlHandle);if(!be)return ve;const de=be.getResourceGroup(ve.groupHandle);return de?de.getResourceState(ve.handle):ve}else if(ve&&ve.$mid===u.MarshalledId.ScmResourceGroup){const be=this.g.get(ve.sourceControlHandle);return be?be.getResourceGroup(ve.groupHandle):ve}else if(ve&&ve.$mid===u.MarshalledId.ScmProvider){const be=this.g.get(ve.handle);return be||ve}return ve}})}createSourceControl(A,W,Z,he){this.o.trace("ExtHostSCM#createSourceControl",A.identifier.value,W,Z,he),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:A.identifier.value});const ve=t.d++,be=new K(A,this.n,this.e,this.m,this.o,W,Z,he);this.g.set(ve,be);const de=this.h.get(A.identifier)||[];return de.push(be),this.h.set(A.identifier,de),be}getLastInputBox(A){this.o.trace("ExtHostSCM#getLastInputBox",A.identifier.value);const W=this.h.get(A.identifier),Z=W&&W[W.length-1];return Z&&Z.inputBox}$provideOriginalResource(A,W,Z){const he=w.URI.revive(W);this.o.trace("ExtHostSCM#$provideOriginalResource",A,he.toString());const ve=this.g.get(A);return!ve||!ve.quickDiffProvider||!ve.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$yh)(()=>ve.quickDiffProvider.provideOriginalResource(he,Z)).then(be=>be||null)}$onInputBoxValueChange(A,W){this.o.trace("ExtHostSCM#$onInputBoxValueChange",A);const Z=this.g.get(A);return Z&&Z.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(A,W,Z,he){this.o.trace("ExtHostSCM#$executeResourceCommand",A,W,Z);const ve=this.g.get(A);if(!ve)return Promise.resolve(void 0);const be=ve.getResourceGroup(W);return be?be.$executeResourceCommand(Z,he):Promise.resolve(void 0)}$validateInput(A,W,Z){this.o.trace("ExtHostSCM#$validateInput",A);const he=this.g.get(A);return!he||!he.inputBox.validateInput?Promise.resolve(void 0):(0,R.$yh)(()=>he.inputBox.validateInput(W,Z)).then(ve=>{if(!ve)return Promise.resolve(void 0);const be=d.MarkdownString.fromStrict(ve.message);return be?Promise.resolve([be,ve.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(A){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",A),A!==void 0&&this.g.get(A)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=A,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(A,W,Z,he){return await this.g.get(A)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,Z,he)??void 0}async $provideHistoryItems(A,W,Z,he){return(await this.g.get(A)?.historyProvider?.provideHistoryItems(W,Z,he))?.map(de=>$(de))??void 0}async $provideHistoryItems2(A,W,Z){return(await this.g.get(A)?.historyProvider?.provideHistoryItems2(W,Z))?.map(be=>$(be))??void 0}async $provideHistoryItemSummary(A,W,Z,he){const ve=this.g.get(A)?.historyProvider;if(typeof ve?.provideHistoryItemSummary!="function")return;const be=await ve.provideHistoryItemSummary(W,Z,he);return be?$(be):void 0}async $provideHistoryItemChanges(A,W,Z,he){return await this.g.get(A)?.historyProvider?.provideHistoryItemChanges(W,Z,he)??void 0}};e.$nqc=J,J.d=0,e.$nqc=J=t=He([Ge(3,I.$ak)],J)}),define(Ie[296],Pe([1,0,5,8,2]),function(_,e,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=void 0;class O{constructor(N,v){this.d=v,this.c=new Map,this.b=N.getProxy(w.$vN.MainThreadShare)}async $provideShare(N,v,s){return await this.c.get(N)?.provideShare({selection:y.Range.to(v.selection),resourceUri:k.URI.revive(v.resourceUri)},s)??void 0}registerShareProvider(N,v){const s=O.a++;return this.c.set(s,v),this.b.$registerShareProvider(s,y.DocumentSelector.from(N,this.d),v.id,v.label,v.priority),{dispose:()=>{this.b.$unregisterShareProvider(s),this.c.delete(s)}}}}e.$oqc=O,O.a=0});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[297],Pe([1,0,7,5,187,4,8,15]),function(_,e,w,y,k,O,R,N){"use strict";var v,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=e.$qqc=void 0;class I{constructor(d,n,o,c,h,i=w.StatusBarAlignment.Left,r){if(v.set(this,void 0),s.set(this,void 0),this.i=!1,this.k="",this.q=new O.$Wc,rt(this,v,d,"f"),rt(this,s,n,"f"),h&&c){this.c=(0,w.$0N)(c.identifier,h);const t=o.get(this.c);t&&(i=t.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,r=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String(I.a++);this.e=c,this.f=h,this.g=i,this.h=this.u(r)}u(d){if((0,N.$kg)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(d){this.k=d,this.v()}set name(d){this.m=d,this.v()}set tooltip(d){this.l=d,this.v()}set color(d){this.n=d,this.v()}set backgroundColor(d){d&&!I.b.has(d.id)&&(d=void 0),this.o=d,this.v()}set command(d){this.r?.fromApi!==d&&(this.p&&this.q.add(this.p),this.p=new O.$Wc,typeof d=="string"?this.r={fromApi:d,internal:ze(this,s,"f").toInternal({title:"",command:d},this.p)}:d?this.r={fromApi:d,internal:ze(this,s,"f").toInternal(d,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(d){this.t=d,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,ze(this,v,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let d;this.e?this.f?d=`${this.e.identifier.value}.${this.f}`:d=this.e.identifier.value:d=this.f;let n;this.m?n=this.m:n=(0,k.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=I.b.get(this.o.id));const c=R.MarkdownString.fromStrict(this.l);ze(this,v,"f").$setEntry(this.c,d,this.e?.identifier.value,n,this.k,c,this.r?.internal,o,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$qqc=I,v=new WeakMap,s=new WeakMap,I.a=0,I.b=new Map([["statusBarItem.errorBackground",new w.$vO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$vO("statusBarItem.warningForeground")]]);class E{constructor(d){this.b=[],this.a=d.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(d){const n={message:d};return this.b.unshift(n),this.c(),new w.$xN(()=>{const o=this.b.indexOf(n);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class u{constructor(d,n){this.e=new Map,this.a=d.getProxy(y.$vN.MainThreadStatusBar),this.b=n,this.c=new E(this)}$acceptStaticEntries(d){for(const n of d)this.e.set(n.entryId,n)}createStatusBarEntry(d,n,o,c){return new I(this.a,this.b,this.e,d,n,o,c)}setStatusBarMessage(d,n){const o=this.c.setMessage(d);let c;return typeof n=="number"?c=setTimeout(()=>o.dispose(),n):typeof n<"u"&&n.then(()=>o.dispose(),()=>o.dispose()),new w.$xN(()=>{o.dispose(),clearTimeout(c)})}}e.$rqc=u}),define(Ie[125],Pe([1,0,33,116,55,82,56,8,2]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$dQ=e.$cQ=e.$bQ=void 0,w=Ve(w),N=Ve(N);const s=(i,r,t,a)=>{let l=r;return{enumerable:!0,configurable:!1,get(){return l},set(g){if(!t(l,g)){const m=l;l=g,i.listener?.(a(g,m))}}}},I=(i,r)=>i===r,E={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,r)=>!(i.length!==r.length||i.some(t=>!r.find(a=>t.id===a.id)))},u=i=>r=>({op:O.TestItemEventOp.SetProp,update:i(r)}),C=(i,r)=>({range:(()=>{let t;const a=u(l=>({range:w.$Nt.lift(N.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return t},set(l){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),E.range(t,l)||(t=l,i.listener?.(a(l)))}}})(),label:s(i,r,E.label,u(t=>({label:t}))),description:s(i,void 0,E.description,u(t=>({description:t}))),sortText:s(i,void 0,E.sortText,u(t=>({sortText:t}))),canResolveChildren:s(i,!1,E.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:s(i,!1,E.busy,u(t=>({busy:t}))),error:s(i,void 0,E.error,u(t=>({error:N.MarkdownString.fromStrict(t)||null}))),tags:s(i,[],E.tags,(t,a)=>({op:O.TestItemEventOp.SetTags,new:t.map(N.TestTag.from),old:a.map(N.TestTag.from)}))}),d=i=>{const r=k.$UI.fromString(i.extId),t=new o(r.controllerId,r.localId,i.label,v.URI.revive(i.uri)||void 0);return t.range=N.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(a=>N.TestTag.to({id:(0,R.$1I)(a).tagId})),t},n=i=>{let r;for(const t of i.tests){const a=d(t.item);(0,y.$XP)(a).parent=r,r=a}return r};e.$bQ=n;class o{constructor(r,t,a,l){if(t.includes(k.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const g=(0,y.$WP)(this,r);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return g.parent instanceof c?void 0:g.parent}},children:{value:(0,O.$VP)(g,y.$XP,o),enumerable:!0,writable:!1},...C(g,a)})}}e.$cQ=o;class c extends o{constructor(r,t){super(r,r,t,void 0),this._isRoot=!0}}e.$dQ=c;class h extends O.$RP{constructor(r,t,a){super({controllerId:r,getDocumentVersion:l=>l&&a.getDocument(l)?.version,getApiFor:y.$XP,getChildren:l=>l.children,root:new c(r,t),toITestItem:N.TestItem.from})}}e.$eQ=h});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[34],Pe([1,0,15,7,8,26,5,18,12,49,33,102,2,4,3,17,125,23,39,42,70,64,67,38]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l){"use strict";var g,m,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=e.$oQ=e.$nQ=e.$mQ=e.$lQ=e.$kQ=void 0,y=Ve(y),k=Ve(k);let S=class{constructor(f,M,L){g.set(this,void 0),this.b=new Map,this.c=new Map,m.set(this,void 0),$.set(this,void 0),rt(this,g,f.getProxy(R.$vN.MainThreadCommands),"f"),this.d=M,rt(this,$,L,"f"),rt(this,m,f.getProxy(R.$vN.MainThreadTelemetry),"f"),this.converter=new D(this,K=>{const J=this.c.get(K);return J?.result===T.Void?J:void 0},M),this.f=[{processArgument(K){return(0,s.$di)(K)}},{processArgument(K){return(0,O.$ho)(K,function(J){if(I.$Nt.isIRange(J))return k.Range.to(J);if(E.$Mt.isIPosition(J))return k.Position.to(J);if(I.$Nt.isIRange(J.range)&&u.URI.isUri(J.uri))return k.location.to(J);if(J instanceof c.$Pe)return J.buffer.buffer;if(!Array.isArray(J))return J})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const M=this.registerCommand(!1,f.id,async(...L)=>{const K=f.args.map((z,A)=>{if(!z.validate(L[A]))throw new Error(`Invalid argument '${z.name}' when running '${f.id}', received: ${typeof L[A]=="object"?JSON.stringify(L[A],null,"	"):L[A]} `);return z.convert(L[A])}),J=await this.executeCommand(f.internalId,...K);return f.result.convert(J,L,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new y.$xN(()=>{M.dispose(),this.c.delete(f.id)})}registerCommand(f,M,L,K,J,z){if(this.d.trace("ExtHostCommands#registerCommand",M),!M.trim().length)throw new Error("invalid id");if(this.b.has(M))throw new Error(`command '${M}' already exists`);return this.b.set(M,{callback:L,thisArg:K,metadata:J,extension:z}),f&&ze(this,g,"f").$registerCommand(M),new y.$xN(()=>{this.b.delete(M)&&f&&ze(this,g,"f").$unregisterCommand(M)})}executeCommand(f,...M){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,M,!0)}async g(f,M,L){if(this.b.has(f))return ze(this,g,"f").$fireCommandActivationEvent(f),this.h(f,M,!1);{let K=!1;const J=(0,O.$ho)(M,function(z){if(z instanceof y.$yN)return k.Position.from(z);if(z instanceof y.$zN)return k.Range.from(z);if(z instanceof y.$JN)return k.location.from(z);if(y.$ZO.isNotebookRange(z))return k.NotebookRange.from(z);if(z instanceof ArrayBuffer)return K=!0,c.$Pe.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return K=!0,c.$Pe.wrap(z);if(z instanceof c.$Pe)return K=!0,z;if(!Array.isArray(z))return z});try{const z=await ze(this,g,"f").$executeCommand(f,K?new h.$Vw(J):J,L);return(0,s.$di)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(f,M,!1);throw z}}}async h(f,M,L){const K=this.b.get(f);if(!K)throw new Error("Unknown command");const{callback:J,thisArg:z,metadata:A}=K;if(A?.args)for(let Z=0;Z<A.args.length;Z++)try{(0,w.$xg)(M[Z],A.args[Z].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${A.args[Z].name}' - ${A.args[Z].description}`)}const W=r.$he.create();try{return await J.apply(z,M)}catch(Z){if(f===this.converter.delegatingCommandId){const he=this.converter.getActualCommand(...M);he&&(f=he.command)}if(this.d.error(Z,f,K.extension?.identifier),!L)throw Z;if(K.extension?.identifier){const he=ze(this,$,"f").onExtensionError(K.extension.identifier,Z);this.d.trace("forwarded error to extension?",he,K.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$rj)(Z)),this.id=f,this.source=K.extension?.displayName??K.extension?.name}}}finally{this.j(K,f,W.elapsed())}}j(f,M,L){f.extension&&ze(this,m,"f").$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new t.$wp(M),duration:L})}$executeContributedCommand(f,...M){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const L=this.b.get(f);return L?(M=M.map(K=>this.f.reduce((J,z)=>z.processArgument(J,L.extension?.identifier),K)),this.h(f,M,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),ze(this,g,"f").$getCommands().then(M=>(f&&(M=M.filter(L=>L[0]!=="_")),M))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[M,L]of this.b){const{metadata:K}=L;K&&(f[M]=K)}return Promise.resolve(f)}};e.$kQ=S,g=new WeakMap,m=new WeakMap,$=new WeakMap,e.$kQ=S=He([Ge(0,n.$2P),Ge(1,v.$ak),Ge(2,a.$jQ)],S),e.$lQ=(0,d.$Gi)("IExtHostCommands");class D{constructor(f,M,L){this.d=f,this.f=M,this.g=L,this.delegatingCommandId=`__vsc${(0,l.$3g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,M){if(!f)return;const L={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return L;const K=this.f(f.command);if(K)L.id=K.internalId,L.arguments=K.args.map((J,z)=>J.convert(f.arguments&&f.arguments[z]));else if((0,N.$Ob)(f.arguments)){const J=`${f.command} /${++this.c}`;this.b.set(J,f),M.add((0,C.$Vc)(()=>{this.b.delete(J),this.g.trace("CommandsConverter#DISPOSE",J)})),L.$ident=J,L.id=this.delegatingCommandId,L.arguments=[J],this.g.trace("CommandsConverter#CREATE",f.command,J)}return L}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const M=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],M?M.command:"MISSING"),M?this.d.executeCommand(M.command,...M.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$mQ=D;class b{static Arr(f){return new b(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,M=>Array.isArray(M)&&M.every(L=>f.validate(L)),M=>M.map(L=>f.convert(L)))}constructor(f,M,L,K){this.name=f,this.description=M,this.validate=L,this.convert=K}optional(){return new b(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,M){return new b(f??this.name,M??this.description,this.validate,this.convert)}}e.$nQ=b,b.Uri=new b("uri","Uri of a text document",p=>u.URI.isUri(p),p=>p),b.Position=new b("position","A position in a text document",p=>y.$yN.isPosition(p),k.Position.from),b.Range=new b("range","A range in a text document",p=>y.$zN.isRange(p),k.Range.from),b.Selection=new b("selection","A selection in a text document",p=>y.$AN.isSelection(p),k.Selection.from),b.Number=new b("number","",p=>typeof p=="number",p=>p),b.String=new b("string","",p=>typeof p=="string",p=>p),b.StringArray=b.Arr(b.String),b.CallHierarchyItem=new b("item","A call hierarchy item",p=>p instanceof y.$VN,k.CallHierarchyItem.from),b.TypeHierarchyItem=new b("item","A type hierarchy item",p=>p instanceof y.$hP,k.TypeHierarchyItem.from),b.TestItem=new b("testItem","A VS Code TestItem",p=>p instanceof o.$cQ,k.TestItem.from);class T{constructor(f,M){this.description=f,this.convert=M}}e.$oQ=T,T.Void=new T("no result",p=>p);class P{constructor(f,M,L,K,J){this.id=f,this.internalId=M,this.description=L,this.args=K,this.result=J}}e.$pQ=P}),define(Ie[298],Pe([1,0,18,16,2,94,104,32,34,8,7]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=void 0,O=Ve(O),s=Ve(s),I=Ve(I);const E=[new v.$pQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to an array of DocumentHighlight-instances.",C(s.DocumentHighlight.to))),new v.$pQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.$nQ.Uri],new v.$oQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,w.$Nb)(n))return;class c extends I.$QN{static to(i){const r=new c(i.name,s.SymbolKind.to(i.kind),i.containerName||"",new I.$JN(o[0],s.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=s.Range.to(i.selectionRange),r.children=i.children?i.children.map(c.to):[],r}}return n.map(c.to)})),new v.$pQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.$nQ.Uri,new v.$nQ("options","Formatting options",n=>!0,n=>n)],new v.$oQ("A promise that resolves to an array of TextEdits.",C(s.TextEdit.to))),new v.$pQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.$nQ.Uri,v.$nQ.Range,new v.$nQ("options","Formatting options",n=>!0,n=>n)],new v.$oQ("A promise that resolves to an array of TextEdits.",C(s.TextEdit.to))),new v.$pQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.$nQ.Uri,v.$nQ.Position,new v.$nQ("ch","Trigger character",n=>typeof n=="string",n=>n),new v.$nQ("options","Formatting options",n=>!0,n=>n)],new v.$oQ("A promise that resolves to an array of TextEdits.",C(s.TextEdit.to))),new v.$pQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new v.$pQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new v.$pQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new v.$pQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new v.$pQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to an array of Location-instances.",C(s.location.to))),new v.$pQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to an array of Hover-instances.",C(s.Hover.to))),new v.$pQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.$nQ.Uri,new v.$nQ("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>I.$yN.isPosition(o)),n=>n.map(s.Position.from))],new v.$oQ("A promise that resolves to an array of ranges.",n=>n.map(o=>{let c;for(const h of o.reverse())c=new I.$UN(s.Range.to(h),c);return c}))),new v.$pQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.$nQ.String.with("query","Search string")],new v.$oQ("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(s.WorkspaceSymbol.to))),new v.$pQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(s.CallHierarchyItem.to))),new v.$pQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.$nQ.CallHierarchyItem],new v.$oQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(s.CallHierarchyIncomingCall.to))),new v.$pQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.$nQ.CallHierarchyItem],new v.$oQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(s.CallHierarchyOutgoingCall.to))),new v.$pQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:s.Range.to(n.range),placeholder:n.text}})),new v.$pQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.$nQ.Uri,v.$nQ.Position,v.$nQ.String.with("newName","The new symbol name")],new v.$oQ("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return s.WorkspaceEdit.to(n)}})),new v.$pQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.$nQ.Uri,v.$nQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.$oQ("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(s.DocumentLink.to))),new v.$pQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.$nQ.Uri],new v.$oQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new I.$QO(n.tokenTypes,n.tokenModifiers)})),new v.$pQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.$nQ.Uri],new v.$oQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,R.$Ndb)(n);if(o.type==="full")return new I.$SO(o.data,void 0)})),new v.$pQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.$nQ.Uri,v.$nQ.Range.optional()],new v.$oQ("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new I.$QO(n.tokenTypes,n.tokenModifiers)})),new v.$pQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.$nQ.Uri,v.$nQ.Range],new v.$oQ("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,R.$Ndb)(n);if(o.type==="full")return new I.$SO(o.data,void 0)})),new v.$pQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.$nQ.Uri,v.$nQ.Position,v.$nQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.$nQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.$oQ("A promise that resolves to a CompletionList-instance.",(n,o,c)=>{if(!n)return new I.$7N([]);const h=n.suggestions.map(i=>s.CompletionItem.to(i,c));return new I.$7N(h,n.incomplete)})),new v.$pQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.$nQ.Uri,v.$nQ.Position,v.$nQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.$oQ("A promise that resolves to SignatureHelp.",n=>{if(n)return s.SignatureHelp.to(n)})),new v.$pQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.$nQ.Uri,v.$nQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.$oQ("A promise that resolves to an array of CodeLens-instances.",(n,o,c)=>C(h=>new I.$YN(s.Range.to(h.range),h.command&&c.fromInternal(h.command)))(n))),new v.$pQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.$nQ.Uri,new v.$nQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>I.$zN.isRange(n),n=>I.$AN.isSelection(n)?s.Selection.from(n):s.Range.from(n)),v.$nQ.String.with("kind","Code action kind to return code actions for").optional(),v.$nQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.$oQ("A promise that resolves to an array of Command-instances.",(n,o,c)=>C(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(h.command)}else{const i=new I.$SN(h.title,h.kind?new I.$TN(h.kind):void 0);return h.edit&&(i.edit=s.WorkspaceEdit.to(h.edit)),h.command&&(i.command=c.fromInternal(h.command)),i.isPreferred=h.isPreferred,i}})(n))),new v.$pQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.$nQ.Uri],new v.$oQ("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new I.$aO(s.Range.to(o.range),s.Color.to(o.color))):[])),new v.$pQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.$nQ("color","The color to show and insert",n=>n instanceof I.$_N,s.Color.from),new v.$nQ("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:s.Range.from(n.range)}))],new v.$oQ("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(s.ColorPresentation.to):[])),new v.$pQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.$nQ.Uri,v.$nQ.Range],new v.$oQ("A promise that resolves to an array of Inlay objects",(n,o,c)=>n.map(s.InlayHint.to.bind(void 0,c)))),new v.$pQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.$nQ.Uri],new v.$oQ("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(s.FoldingRange.to)})),new v.$pQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.$oQ("A promise that resolves to an array of NotebookContentProvider static info objects.",C(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>s.NotebookExclusiveDocumentPattern.to(o))})))),new v.$pQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.$nQ.Uri,v.$nQ.Range,new v.$nQ("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof I.$zN,n=>s.InlineValueContext.from(n))],new v.$oQ("A promise that resolves to an array of InlineValue objects",n=>n.map(s.InlineValue.to))),new v.$pQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.$nQ("uriOrString","Uri-instance or string (only http/https)",n=>k.URI.isUri(n)||typeof n=="string"&&(0,y.$Qg)(n,y.Schemas.http,y.Schemas.https),n=>n),new v.$nQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[s.ViewColumn.from(n),void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional(),v.$nQ.String.with("label","").optional()],v.$oQ.Void),new v.$pQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.$nQ.Uri.with("resource","Resource to open"),v.$nQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new v.$nQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[s.ViewColumn.from(n),void 0]:[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)])).optional()],v.$oQ.Void),new v.$pQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.$nQ.Uri.with("left","Left-hand side resource of the diff editor"),v.$nQ.Uri.with("right","Right-hand side resource of the diff editor"),v.$nQ.String.with("title","Human readable title for the diff editor").optional(),new v.$nQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[s.ViewColumn.from(n.viewColumn),s.TextEditorOpenOptions.from(n)]).optional()],v.$oQ.Void),new v.$pQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[v.$nQ.String.with("title","Human readable title for the changes editor"),new v.$nQ("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[c,h,i]=o;if(!k.URI.isUri(c)||!k.URI.isUri(h)&&h!==void 0&&h!==null||!k.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],v.$oQ.Void),new v.$pQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.$nQ.Uri,v.$nQ.Position],new v.$oQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(s.TypeHierarchyItem.to))),new v.$pQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.$nQ.TypeHierarchyItem],new v.$oQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(s.TypeHierarchyItem.to))),new v.$pQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.$nQ.TypeHierarchyItem],new v.$oQ("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(s.TypeHierarchyItem.to))),new v.$pQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.$nQ.TestItem],v.$oQ.Void),new v.$pQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.$nQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.$oQ.Void),new v.$pQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.$nQ.String.with("name","The context key name"),new v.$nQ("value","The context key value",()=>!0,n=>n)],v.$oQ.Void),new v.$pQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.$nQ.Uri,v.$nQ.StringArray,new v.$nQ("MappedEditsContext","Mapped Edits Context",n=>s.MappedEditsContext.is(n),n=>s.MappedEditsContext.from(n))],new v.$oQ("A promise that resolves to a workspace edit or null",n=>n?s.WorkspaceEdit.to(n):null)),new v.$pQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.$nQ("Run arguments","",n=>!0,n=>{if(n)return{initialRange:n.initialRange?s.Range.from(n.initialRange):void 0,initialSelection:I.$AN.isSelection(n.initialSelection)?s.Selection.from(n.initialSelection):void 0,message:n.message,autoSend:n.autoSend,position:n.position?s.Position.from(n.position):void 0}})],v.$oQ.Void)];class u{static register(o){E.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",N.$Fj)}}e.$Goc=u;function C(n){return o=>{if(Array.isArray(o))return o.map(n)}}function d(n){if(!Array.isArray(n))return;const o=[];for(const c of n)O.$Ju(c)?o.push(s.DefinitionLink.to(c)):o.push(s.location.to(c));return o}}),define(Ie[299],Pe([1,0,2,34]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=void 0;class k{constructor(R,N,v,s,I){this.a=N,this.b=v,this.c=s;const E=new y.$pQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new y.$nQ("showOptions","Show Options",u=>!0,u=>u),new y.$nQ("resource","Interactive resource Uri",u=>!0,u=>u),new y.$nQ("controllerId","Notebook controller Id",u=>!0,u=>u),new y.$nQ("title","Interactive editor title",u=>!0,u=>u)],new y.$oQ("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const C=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri),notebookEditor:C.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(R,N,v,s){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:N,lines:[""],languageId:v,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,N){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$8pc=k}),define(Ie[300],Pe([1,0,18,11,22,6,4,29,2,19,12,5,34,8,7,83,239,25,39,240]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=void 0,e.$eqc=$,C=Ve(C);let r=class{constructor(D,b,T,P,p){this.m=b,this.n=T,this.o=P,this.q=p,this.b=new N.$Dc,this.c=new N.$Dc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$ne,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(E.$vN.MainThreadNotebookKernels);const f=new u.$pQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$nQ("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const K=this.n.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:K}}else if(L&&"notebookEditor"in L){const K=this.n.getIdByEditor(L.notebookEditor);if(K===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:K}}return L})],u.$oQ.Void),M=new u.$pQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$nQ.Uri],new u.$oQ("A promise that resolves to an array of variables",(L,K)=>L.map(J=>({variable:{name:J.name,value:J.value,expression:J.expression,type:J.type,language:J.language},hasNamedChildren:J.hasNamedChildren,indexedChildrenCount:J.indexedChildrenCount}))));this.o.registerApiCommand(f),this.o.registerApiCommand(M)}createNotebookController(D,b,T,P,p,f){for(const Y of this.j.values())if(Y.controller.id===b&&s.$sn.equals(D.identifier,Y.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const M=this.k++,L=this;this.q.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${b}`);const K=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${D.identifier}'`);let J=!1;const z=new O.$ne,A=new O.$ne,W={id:$(D.identifier,b),notebookType:T,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:P||D.identifier.value,preloads:f?f.map(C.NotebookRendererScript.from):[]};let Z=p??K,he,ve;this.a.$addKernel(M,W).catch(Y=>{console.log(Y),J=!0});let be=0;const de=()=>{if(J)return;const Y=++be;Promise.resolve().then(()=>{Y===be&&this.a.$updateKernel(M,W)})},$e=new N.$Dc,ye={get id(){return b},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return W.label},set label(Y){W.label=Y??D.displayName??D.name,de()},get detail(){return W.detail??""},set detail(Y){W.detail=Y,de()},get description(){return W.description??""},set description(Y){W.description=Y,de()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(Y){W.supportedLanguages=Y,de()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){W.supportsExecutionOrder=Y,de()},get rendererScripts(){return W.preloads?W.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(Y){Z=Y??K},get interruptHandler(){return he},set interruptHandler(Y){he=Y,W.supportsInterrupt=!!Y,de()},set variableProvider(Y){(0,c.$8G)(D,"notebookVariableProvider"),ve=Y,W.hasVariableProvider=!!Y,Y?.onDidChangeVariables(we=>L.a.$variablesUpdated(we.uri)),de()},get variableProvider(){return ve},createNotebookCellExecution(Y){if(J)throw new Error("notebook controller is DISPOSED");if(!$e.has(Y.notebook.uri))throw L.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return L._createNotebookCellExecution(Y,$(D.identifier,this.id))},createNotebookExecution(Y){if((0,c.$8G)(D,"notebookExecution"),J)throw new Error("notebook controller is DISPOSED");if(!$e.has(Y.uri))throw L.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($e.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.uri.toString()}`);return L._createNotebookExecution(Y,$(D.identifier,this.id))},dispose:()=>{J||(this.q.trace(`NotebookController[${M}], DISPOSED`),J=!0,this.j.delete(M),z.dispose(),A.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(Y,we){we===d.NotebookControllerAffinity2.Hidden&&(0,c.$8G)(D,"notebookControllerAffinityHidden"),L.a.$updateNotebookPriority(M,Y.uri,we)},onDidReceiveMessage:A.event,postMessage(Y,we){return(0,c.$8G)(D,"notebookMessaging"),L.a.$postMessage(M,we&&L.n.getIdByEditor(we),Y)},asWebviewUri(Y){return(0,c.$8G)(D,"notebookMessaging"),(0,n.$qDb)(Y,L.m.remote)}};return this.j.set(M,{extensionId:D.identifier,controller:ye,onDidReceiveMessage:A,onDidChangeSelection:z,associatedNotebooks:$e}),ye}getIdByController(D){for(const[b,T]of this.j)if(T.controller===D)return $(T.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,b){const T=this.g++,P=this;this.q.trace(`NotebookControllerDetectionTask[${T}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(T,b);const p={dispose:()=>{this.f.delete(T),P.a.$removeKernelDetectionTask(T)}};return this.f.set(T,p),p}registerKernelSourceActionProvider(D,b,T){const P=this.i++,p=typeof T.onDidChangeNotebookKernelSourceActions=="function"?P:void 0,f=this;this.h.set(P,T),this.q.trace(`NotebookKernelSourceActionProvider[${P}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(P,P,b);let M;return p!==void 0&&(M=T.onDidChangeNotebookKernelSourceActions(L=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(P),f.a.$removeKernelSourceActionProvider(P,P),M?.dispose()}}}async $provideKernelSourceActions(D,b){const T=this.h.get(D);if(T){const P=new R.$Wc;return(await T.provideNotebookKernelSourceActions(b)??[]).map(f=>C.NotebookKernelSourceAction.from(f,this.o.converter,P))}return[]}$acceptNotebookAssociation(D,b,T){const P=this.j.get(D);if(P){const p=this.n.getNotebookDocument(v.URI.revive(b));T?P.associatedNotebooks.set(p.uri,!0):P.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,p.uri.toString(),T),P.onDidChangeSelection.fire({selected:T,notebook:p.apiNotebook})}}async $executeCells(D,b,T){const P=this.j.get(D);if(!P)return;const p=this.n.getNotebookDocument(v.URI.revive(b)),f=[];for(const M of T){const L=p.getCell(M);L&&f.push(L.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,p.uri.toString(),f.length),await P.controller.executeHandler.call(P.controller,f,p.apiNotebook,P.controller)}catch(M){this.q.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,b,T){const P=this.j.get(D);if(!P)return;const p=this.n.getNotebookDocument(v.URI.revive(b));if(P.controller.interruptHandler)await P.controller.interruptHandler.call(P.controller,p.apiNotebook);else for(const f of T){const M=p.getCell(f);M&&this.b.get(M.uri)?.cancel()}if(P.controller.interruptHandler){const f=this.c.get(p.uri);this.c.delete(p.uri),T.length&&Array.isArray(f)&&f.length&&f.forEach(M=>M.dispose())}}async $provideVariables(D,b,T,P,p,f,M){const L=this.j.get(D);if(!L)return;const K=this.n.getNotebookDocument(v.URI.revive(T)),J=L.controller.variableProvider;if(!J)return;let z;if(P!==void 0){if(z=this.s[P],!z)return}else this.s={};const A=p==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,W=J.provideVariables(K.apiNotebook,z,A,f,M);let Z=0;for await(const he of W){if(M.isCancellationRequested)return;const ve={id:this.r++,name:he.variable.name,value:he.variable.value,type:he.variable.type,interfaces:he.variable.interfaces,language:he.variable.language,expression:he.variable.expression,hasNamedChildren:he.hasNamedChildren,indexedChildrenCount:he.indexedChildrenCount,extensionId:L.extensionId.value};if(this.s[ve.id]=he.variable,this.a.$receiveVariable(b,ve),Z++>=i.$NK)return}}$acceptKernelMessageFromRenderer(D,b,T){const P=this.j.get(D);if(!P)return;const p=this.n.getEditorById(b);P.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:T}))}$cellExecutionChanged(D,b,T){const p=this.n.getNotebookDocument(v.URI.revive(D)).getCell(b);if(p){const f=T?C.NotebookCellExecutionState.to(T):d.NotebookCellExecutionState.Idle;f!==void 0&&this.l.fire({cell:p.apiCell,state:f})}}_createNotebookCellExecution(D,b){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const P=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!P)throw new Error("invalid cell");if(this.b.has(P.uri))throw new Error(`duplicate execution for ${P.uri}`);const p=new a(b,P,this.a);this.b.set(P.uri,p);const f=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),f.dispose(),this.b.delete(P.uri))});return p.asApiObject()}_createNotebookExecution(D,b){const T=this.n.getNotebookDocument(D.uri),P=D.getCells().find(M=>{const L=T.getCellFromApiCell(M);return L&&this.b.has(L.uri)});if(P)throw new Error(`duplicate cell execution for ${P.document.uri}`);if(this.c.has(T.uri))throw new Error(`duplicate notebook execution for ${T.uri}`);const p=new g(b,T,this.a),f=p.onDidChangeState(()=>{p.state===l.Resolved&&(p.dispose(),f.dispose(),this.c.delete(T.uri))});return this.c.set(T.uri,[p,f]),p.asApiObject()}};e.$dqc=r,e.$dqc=r=He([Ge(4,I.$ak)],r);var t;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(t||(t={}));class a extends R.$Xc{get state(){return this.f}constructor(D,b,T){super(),this.m=b,this.n=T,this.b=a.a++,this.c=new O.$ne,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new k.$ye),this.h=new m(10,P=>this.s(P)),this.j=b.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const b=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new h.$Vw(b))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let b=this.m;if(D&&(b=this.m.notebook.getCellFromApiCell(D)),!b)throw new Error("INVALID cell");return b.handle}y(D){return D.map(b=>{const T=d.$4O.ensureUniqueMimeTypes(b.items,!0);return T===b.items?C.NotebookCellOutput.from(b):C.NotebookCellOutput.from({items:T,id:b.id,metadata:b.metadata})})}async z(D,b,T){const P=this.w(b),p=this.y((0,w.$5b)(D));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:P,append:T,outputs:p})}async C(D,b,T){return D=d.$4O.ensureUniqueMimeTypes((0,w.$5b)(D),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:D.map(C.NotebookCellOutputItem.from),outputId:b.id,append:T})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(T){D.j=T,D.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(T){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:T})},end(T,P,p){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const f=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;D.n.$completeExecution(D.b,new h.$Vw({runEndTime:P,lastRunSuccess:T,error:f}))},clearOutput(T){return D.t(),D.z([],T,!1)},appendOutput(T,P){return D.t(),D.z(T,P,!0)},replaceOutput(T,P){return D.t(),D.z(T,P,!1)},appendOutputItems(T,P){return D.t(),D.C(T,P,!0)},replaceOutputItems(T,P){return D.t(),D.C(T,P,!1)}})}}a.a=0;var l;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(l||(l={}));class g extends R.$Xc{get state(){return this.f}constructor(D,b,T){super(),this.h=b,this.j=T,this.b=g.a++,this.c=new O.$ne,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new k.$ye),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===l.Resolved||this.f===l.Started)throw new Error("Cannot call start again");this.f=l.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===l.Resolved)throw new Error("Cannot call resolve twice");this.f=l.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}g.a=0;class m{constructor(D,b){this.f=D,this.g=b,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new y.$4h,this.b=Date.now(),(0,y.$Hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const b=this.a;return this.a=[],this.g(b).finally(()=>D.complete())}}function $(S,D){return`${S.value}/${D}`}}),define(Ie[57],Pe([1,0,6,5,3,2,17,4,7,189,14,220,22,38,221,222,35,11,8,34,37]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=e.$kpc=e.$jpc=e.$ipc=void 0,e.$ipc=(0,k.$Gi)("IExtHostTerminalService");class t extends N.$Xc{constructor(p,f,M,L){super(),this.u=p,this._id=f,this.w=M,this.y=L,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new w.$ne),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(J=>this.g=J);const K=this;this.value={get name(){return K.y||""},get processId(){return K.b},get creationOptions(){return K.w},get exitStatus(){return K.j},get state(){return K.m},get selection(){return K.n},get shellIntegration(){return K.shellIntegration},sendText(J,z=!0){K.C(),K.u.$sendText(K._id,J,z)},show(J){K.C(),K.u.$show(K._id,J)},hide(){K.C(),K.u.$hide(K._id)},dispose(){K.a||(K.a=!0,K.u.$dispose(K._id))},get dimensions(){if(!(K.f===void 0||K.h===void 0))return{columns:K.f,rows:K.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??f?.cwd??void 0,env:p.env??void 0,icon:D(p.iconPath)??void 0,color:o.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:f?.forceShellIntegration??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.z(p.location,f?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,f,M,L,K){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:L,color:o.ThemeColor.isThemeColor(K)?K.id:void 0,location:f?.location||this.z(p,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,f){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in p?{viewColumn:h.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,f){this.j=Object.freeze({code:p,reason:f})}setDimensions(p,f){return p===this.f&&f===this.h||p===0||f===0?!1:(this.f=p,this.h=f,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(f=>{f!==p&&(this.b=Promise.resolve(p))})}}e.$jpc=t;class a{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new w.$ne,this.onProcessData=this.a.event,this.b=new w.$ne,this.d=new w.$ne,this.onDidChangeProperty=this.d.event,this.f=new w.$ne,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,f){this.g.setDimensions?.({columns:p,rows:f})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:d.ProcessPropertyType.Title,value:f})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,g=class extends N.$Xc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,f,M){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new N.$Yc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$ne,this.onDidCloseTerminal=this.H.event,this.I=new w.$ne,this.onDidOpenTerminal=this.I.event,this.J=new w.$ne,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$ne,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$ne,this.onDidChangeTerminalState=this.M.event,this.N=new w.$ne,this.onDidChangeShell=this.N.event,this.O=new w.$ne({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$ne({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(y.$vN.MainThreadTerminalService),this.y=new n.$Jxb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:L=>{const K=J=>{const z=J;return this.getTerminalById(z.instanceId)?.value};switch(L?.$mid){case r.MarshalledId.TerminalContext:return K(L);default:{if(Array.isArray(L))for(let J=0;J<L.length&&L[J].$mid===r.MarshalledId.TerminalContext;J++)L[J]=K(L[J]);return L}}}}),this.B({dispose:()=>{for(const[L,K]of this.g)K.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,f){const M=new t(this.a,(0,C.$3g)(),p,p.name),L=new a(p.pty);return M.createExtensionTerminal(p.location,f,this.R(p,f).resolvedExtHostIdentifier,D(p.iconPath),b(p.color)).then(K=>{const J=this.S(K,L);this.h[K]=J}),this.f.push(M),M.value}R(p,f){if(f=f||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const M=p.location.parentTerminal;if(M){const L=this.f.find(K=>K.value===M);L&&(f.resolvedExtHostIdentifier=L._id)}}else p.location&&typeof p.location!="object"?f.location=p.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(p,f){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const L=new a(f),K=this.S(p,L);this.h[p]=K}async $acceptActiveTerminalChanged(p){const f=this.b;if(p===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(p);M&&(this.b=M,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,f){const M=this.getTerminalById(p);M&&this.O.fire({terminal:M.value,data:f})}async $acceptTerminalDimensions(p,f,M){const L=this.getTerminalById(p);L&&L.setDimensions(f,M)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(p,f){const M=this.getTerminalById(p);M&&this.P.fire({terminal:M.value,...f})}async $acceptTerminalMaximumDimensions(p,f,M){this.g.get(p)?.resize(f,M)}async $acceptTerminalTitleChange(p,f){const M=this.getTerminalById(p);M&&(M.name=f)}async $acceptTerminalClosed(p,f,M){const L=this.X(this.f,p);if(L!==null){const K=this.f.splice(L,1)[0];K.setExitStatus(f,M),this.H.fire(K.value)}}$acceptTerminalOpened(p,f,M,L){if(f){const z=this.X(this.f,f);if(z!==null){this.f[z]._id=p,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const K={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:O.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},J=new t(this.a,p,K,M);this.f.push(J),this.I.fire(J.value),J.isOpen=!0}async $acceptTerminalProcessId(p,f){this.getTerminalById(p)?._setProcessId(f)}async $startExtensionTerminal(p,f){const M=this.getTerminalById(p);if(!M)return{message:(0,s.localize)(0,null,p)};M.isOpen||await new Promise(K=>{const J=this.onDidOpenTerminal(async z=>{z===M.value&&(J.dispose(),K())})});const L=this.g.get(p);L?L.startSendingEvents(f):this.j[p]={initialDimensions:f}}S(p,f){const M=new N.$Wc;M.add(f.onProcessReady(K=>this.a.$sendProcessReady(p,K.pid,K.cwd,K.windowsPty))),M.add(f.onDidChangeProperty(K=>this.a.$sendProcessProperty(p,K))),this.y.startBuffering(p,f.onProcessData),M.add(f.onProcessExit(K=>this.U(p,K))),this.g.set(p,f);const L=this.j[p];return L&&f instanceof a&&(f.startSendingEvents(L.initialDimensions),delete this.j[p]),M}$acceptProcessAckDataEvent(p,f){this.g.get(p)?.acknowledgeDataEvent(f)}$acceptProcessInput(p,f){this.g.get(p)?.input(f)}$acceptTerminalInteraction(p){const f=this.getTerminalById(p);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection(p,f){this.getTerminalById(p)?.setSelection(f)}$acceptProcessResize(p,f,M){try{this.g.get(p)?.resize(f,M)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(p,f){this.g.get(p)?.shutdown(f)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(p,{type:d.ProcessPropertyType.InitialCwd,value:f}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(f=>this.a.$sendProcessProperty(p,{type:d.ProcessPropertyType.Cwd,value:f}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new v.$xN(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,f,M){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,M),this.a.$registerProfileProvider(f,p.identifier.value),new v.$xN(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(p,f,M){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,M),this.a.$registerQuickFixProvider(p,f),new v.$xN(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,f){const M=new u.$ye().token;if(M.isCancellationRequested)return;const L=this.D.get(p);if(!L)return;const K=await L.provideTerminalQuickFixes(f,M);if(K===null||Array.isArray(K)&&K.length===0)return;const J=new N.$Wc;if(this.w.value=J,!Array.isArray(K))return K?h.TerminalQuickFix.from(K,this.Q.converter,J):void 0;const z=[];for(const A of K){const W=h.TerminalQuickFix.from(A,this.Q.converter,J);W&&z.push(W)}return z}async $createContributedProfileTerminal(p,f){const M=new u.$ye().token;let L=await this.C.get(p)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,f);return}this.createTerminalFromOptions(L.options,f)}}async $provideLinks(p,f){const M=this.getTerminalById(p);if(!M)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const K=new u.$ye;this.G.set(p,K);const J=[],z={terminal:M.value,line:f},A=[];for(const he of this.z)A.push(c.Promises.withAsyncBody(async ve=>{K.token.onCancellationRequested(()=>ve({provider:he,links:[]}));const be=await he.provideTerminalLinks(z,K.token)||[];K.token.isCancellationRequested||ve({provider:he,links:be})}));const W=await Promise.all(A);if(K.token.isCancellationRequested)return[];const Z=new Map;for(const he of W)he&&he.links.length>0&&J.push(...he.links.map(ve=>{const be={id:l++,startIndex:ve.startIndex,length:ve.length,label:ve.tooltip};return Z.set(be.id,{provider:he.provider,link:ve}),be}));return this.F.set(p,Z),J}$activateLink(p,f){const M=this.F.get(p)?.get(f);M&&M.provider.handleTerminalLink(M.link)}U(p,f){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const M=this.h[p];M&&(M.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,f)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const f=this.f.findIndex(M=>M.value===p);return f>=0?f:null}W(p,f){const M=this.X(p,f);return M!==null?p[M]:null}X(p,f){const M=p.findIndex(L=>L._id===f);return M>=0?M:null}getEnvironmentVariableCollection(p){let f=this.n.get(p.identifier.value);return f||(f=this.B(new m),this.Z(p.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Y(p,f){const M=(0,E.$Es)(f.map),L=(0,E.$Fs)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(p,f.persistent,M.length===0?void 0:M,L)}$initEnvironmentVariableCollections(p){p.forEach(f=>{const M=f[0],L=this.B(new m(f[1]));this.Z(M,L)})}$acceptDefaultProfile(p,f){const M=this.s;this.s=p,this.u=f,M?.path!==p.path&&this.N.fire(p.path)}Z(p,f){this.n.set(p,f),this.B(f.onDidChangeCollection(()=>{this.Y(p,f)}))}};e.$kpc=g,e.$kpc=g=He([Ge(1,i.$lQ),Ge(2,R.$2P)],g);class m extends N.$Xc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new w.$ne,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const f=this.j(p);let M=this.a.get(f);return M||(M=new $(this,p),this.a.set(f,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(p,f,M,L){this.g(p,{value:f,type:v.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:L})}append(p,f,M,L){this.g(p,{value:f,type:v.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:L})}prepend(p,f,M,L){this.g(p,{value:f,type:v.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:L})}g(p,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(p,f.scope),L=this.map.get(M),K=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==f.value||L.type!==f.type||L.options?.applyAtProcessCreation!==K.applyAtProcessCreation||L.options?.applyAtShellIntegration!==K.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const J=this.h(p,f.scope),z={variable:p,...f,options:K};this.map.set(J,z),this.f.fire()}}get(p,f){const M=this.h(p,f),L=this.map.get(M);return L?T(L):void 0}h(p,f){const M=this.j(f);return M.length?`${p}:::${M}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const f=new Map;for(const[M,L]of this.map)this.j(L.scope)===this.j(p)&&f.set(L.variable,T(L));return f}delete(p,f){const M=this.h(p,f);this.map.delete(M),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[f,M]of this.map)M.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(f);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,f){const M=this.j(f),L=this.descriptionMap.get(M);if(!L||L.description!==p){let K;typeof p=="string"?K=p:K=p?.value.split(`

`)[0];const J={description:K,scope:f};this.descriptionMap.set(M,J),this.f.fire()}}getDescription(p){const f=this.j(p);return this.descriptionMap.get(f)?.description}n(p){const f=this.j(p);this.descriptionMap.delete(f)}}class ${get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,f){this.b=p,this.d=f,this.a=new w.$ne}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,f,M){this.b.replace(p,f,M,this.d)}append(p,f,M){this.b.append(p,f,M,this.d)}prepend(p,f,M){this.b.prepend(p,f,M,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,f){this.b.getVariableMap(this.d).forEach((M,L)=>p.call(f,L,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let S=class extends g{constructor(p,f){super(!1,p,f)}createTerminal(p,f,M){throw new I.$cb}createTerminalFromOptions(p,f){throw new I.$cb}};e.$lpc=S,e.$lpc=S=He([Ge(0,i.$lQ),Ge(1,R.$2P)],S);function D(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function b(P){return o.ThemeColor.isThemeColor(P)?P:void 0}function T(P){const p={...P};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Ie[126],Pe([1,0,7,4,3,5,17,57,6,2,11]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=e.$vqc=void 0,e.$vqc=(0,k.$Gi)("IExtHostTerminalShellIntegration");let E=class extends y.$Xc{constructor(o,c){super(),this.h=c,this.b=new Map,this.c=new v.$ne,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new v.$ne,this.onDidStartTerminalShellExecution=this.f.event,this.g=new v.$ne,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$vN.MainThreadTerminalShellIntegration),this.B((0,y.$Vc)(()=>{for(const[h,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(o){const c=this.h.getTerminalById(o);if(!c)return;const h=c.value;let i=this.b.get(o);i||(i=new u(c.value,this.f),this.b.set(o,i),i.store.add(c.onWillDispose(()=>this.b.get(o)?.dispose())),i.store.add(i.onDidRequestShellExecution(r=>this.a.$executeCommand(o,r))),i.store.add(i.onDidRequestEndExecution(r=>this.g.fire(r))),i.store.add(i.onDidRequestChangeShellIntegration(r=>this.c.fire(r))),c.shellIntegration=i.value),this.c.fire({terminal:h,shellIntegration:i.value})}$shellExecutionStart(o,c,h,i,r){this.b.has(o)||this.$shellIntegrationChange(o);const t={value:c,confidence:h,isTrusted:i};this.b.get(o)?.startShellExecution(t,r)}$shellExecutionEnd(o,c,h,i,r){const t={value:c,confidence:h,isTrusted:i};this.b.get(o)?.endShellExecution(t,r)}$shellExecutionData(o,c){this.b.get(o)?.emitData(c)}$cwdChange(o,c){this.b.get(o)?.setCwd((0,s.$yc)(c)?s.URI.revive(c):c)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$wqc=E,e.$wqc=E=He([Ge(0,R.$2P),Ge(1,N.$ipc)],E);class u extends y.$Xc{get currentExecution(){return this.a}constructor(o,c){super(),this.j=o,this.m=c,this.b=!1,this.store=this.B(new y.$Wc),this.f=this.B(new v.$ne),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new v.$ne),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new v.$ne),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(i,r){let t=i;r&&(t+=` "${r.map(g=>`${g.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(t);const a={value:t,confidence:w.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},l=h.startShellExecution(a,h.c,!0).value;return h.b=!0,l}}}startShellExecution(o,c,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new C(o,c);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,c){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(o){let c=!1;s.URI.isUri(this.c)?c=!s.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(c=!0),c&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class C{constructor(o,c){this.c=o,this.cwd=c,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return I.$7h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends y.$Xc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Fh);const o=this.a;return new I.$7h(async h=>{this.b.push(h),await o.wait()})}emitData(o){for(const c of this.b)c.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ie[127],Pe([1,0,62,14,97,8,7]),function(_,e,w,y,k,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=e.$9P=void 0,O=Ve(O);class N{constructor(u,C,d){const n=N.c.nextId();u.$registerTextEditorDecorationType(C.identifier,n,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.$9P=N,N.c=new k.$7P("TextEditorDecorationType");class v{constructor(u,C){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,C){this.k();let d=null;if(u instanceof R.$yN)d=new R.$zN(u,u);else if(u instanceof R.$zN)d=u;else throw new Error("Unrecognized location");this.l(d,C,!1)}insert(u,C){this.k(),this.l(new R.$zN(u,u),C,!0)}delete(u){this.k();let C=null;if(u instanceof R.$zN)C=u;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(u,C,d){const n=this.c.validateRange(u);this.g.push({range:n,text:C,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,y.$0)("endOfLine");this.h=u}}class s{constructor(u,C,d,n){this.c=u,this.d=C,this._accept(d),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(c){o.n(c)},get indentSize(){return o.g},set indentSize(c){o.p(c)},get insertSpaces(){return o.j},set insertSpaces(c){o.s(c)},get cursorStyle(){return o.k},set cursorStyle(c){o.t(c)},get lineNumbers(){return o.l},set lineNumbers(c){o.u(c)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const C=Math.floor(u);return C>0?C:null}if(typeof u=="string"){const C=parseInt(u,10);return isNaN(C)?null:C>0?C:null}return null}n(u){const C=this.m(u);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const C=Math.floor(u);return C>0?C:null}if(typeof u=="string"){const C=parseInt(u,10);return isNaN(C)?null:C>0?C:null}return null}p(u){const C=this.o(u);if(C!==null){if(typeof C=="number"){if(this.h===C)return;this.g=C,this.h=C}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const C=this.q(u);if(typeof C=="boolean"){if(this.j===C)return;this.j=C}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const C={};let d=!1;if(typeof u.tabSize<"u"){const n=this.m(u.tabSize);n==="auto"?(d=!0,C.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,d=!0,C.tabSize=n)}if(typeof u.indentSize<"u"){const n=this.o(u.indentSize);n==="tabSize"?(d=!0,C.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,d=!0,C.indentSize=n)}if(typeof u.insertSpaces<"u"){const n=this.q(u.insertSpaces);n==="auto"?(d=!0,C.insertSpaces=n):this.j!==n&&(this.j=n,d=!0,C.insertSpaces=n)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,C.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,C.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,C))}v(u,C){C.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$0P=s;class I{constructor(u,C,d,n,o,c,h,i){this.id=u,this.j=C,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new s(this.j,this.id,c,d),this.e=h,this.f=i;const r=this;this.value=Object.freeze({get document(){return n.value},set document(t){throw new y.$_("document")},get selection(){return r.c&&r.c[0]},set selection(t){if(!(t instanceof R.$AN))throw(0,y.$0)("selection");r.c=[t],r.l()},get selections(){return r.c},set selections(t){if(!Array.isArray(t)||t.some(a=>!(a instanceof R.$AN)))throw(0,y.$0)("selections");r.c=t,r.l()},get visibleRanges(){return r.e},set visibleRanges(t){throw new y.$_("visibleRanges")},get options(){return r.d.value},set options(t){r.g||r.d.assign(t)},get viewColumn(){return r.f},set viewColumn(t){throw new y.$_("viewColumn")},edit(t,a={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new v(n.value,a);return t(l),r.m(l)},insertSnippet(t,a,l={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let g;if(!a||Array.isArray(a)&&a.length===0)g=r.c.map(m=>O.Range.from(m));else if(a instanceof R.$yN){const{lineNumber:m,column:$}=O.Position.from(a);g=[{startLineNumber:m,startColumn:$,endLineNumber:m,endColumn:$}]}else if(a instanceof R.$zN)g=[O.Range.from(a)];else{g=[];for(const m of a)if(m instanceof R.$zN)g.push(O.Range.from(m));else{const{lineNumber:$,column:S}=O.Position.from(m);g.push({startLineNumber:$,startColumn:S,endLineNumber:$,endColumn:S})}}return C.$tryInsertSnippet(u,n.value.version,t.value,g,l)},setDecorations(t,a){const l=a.length===0;l&&!r.h.has(t.key)||(l?r.h.delete(t.key):r.h.add(t.key),r.n(()=>{if(O.$YP(a))return C.$trySetDecorations(u,t.key,O.$ZP(a));{const g=new Array(4*a.length);for(let m=0,$=a.length;m<$;m++){const S=a[m];g[4*m]=S.start.line+1,g[4*m+1]=S.start.character+1,g[4*m+2]=S.end.line+1,g[4*m+3]=S.end.character+1}return C.$trySetDecorationsFast(u,t.key,g)}}))},revealRange(t,a){r.n(()=>C.$tryRevealRange(u,O.Range.from(t),a||R.TextEditorRevealType.Default))},show(t){C.$tryShowEditor(u,O.ViewColumn.from(t))},hide(){C.$tryHideEditor(u)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,w.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,w.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,w.ok)(!this.g),this.f=u}_acceptSelections(u){(0,w.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const C=u.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const d=C.edits.map(o=>o.range);d.sort((o,c)=>o.end.line===c.end.line?o.end.character===c.end.character?o.start.line===c.start.line?o.start.character-c.start.character:o.start.line-c.start.line:o.end.character-c.end.character:o.end.line-c.end.line);for(let o=0,c=d.length-1;o<c;o++){const h=d[o].end;if(d[o+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=C.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,n,{setEndOfLine:typeof C.setEndOfLine=="number"?O.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.$$P=I}),define(Ie[58],Pe([1,0,62,6,4,2,3,5,123,17,127,8,12,29,16,40,48]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=e.$_P=void 0,w=Ve(w),E=Ve(E);class c{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(r,t){this.h=r,this.i=t,this.a=null,this.b=new Map,this.c=new C.$Dc,this.d=new y.$ne,this.e=new y.$ne,this.f=new y.$ne,this.g=new y.$ne,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const t=[],a=[],l=[];if(r.removedDocuments)for(const g of r.removedDocuments){const m=O.URI.revive(g),$=this.c.get(m);$?.unref()&&(this.c.delete(m),t.push($.value))}if(r.addedDocuments)for(const g of r.addedDocuments){const m=O.URI.revive(g.uri);let $=this.c.get(m);if($&&m.scheme!==d.Schemas.vscodeNotebookCell&&m.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);$||($=new c(new v.$5P(this.h.getProxy(N.$vN.MainThreadDocuments),m,g.lines,g.EOL,g.versionId,g.languageId,g.isDirty)),this.c.set(m,$),a.push($.value)),$.ref()}if(r.removedEditors)for(const g of r.removedEditors){const m=this.b.get(g);this.b.delete(g),m&&l.push(m)}if(r.addedEditors)for(const g of r.addedEditors){const m=O.URI.revive(g.documentUri);w.ok(this.c.has(m),`document '${m}' does not exist`),w.ok(!this.b.has(g.id),`editor '${g.id}' already exists!`);const $=this.c.get(m).value,S=new I.$$P(g.id,this.h.getProxy(N.$vN.MainThreadTextEditors),this.i,new o.$X(()=>$.document),g.selections.map(E.Selection.to),g.options,g.visibleRanges.map(D=>E.Range.to(D)),typeof g.editorPosition=="number"?E.ViewColumn.to(g.editorPosition):void 0);this.b.set(g.id,S)}r.newActiveEditor!==void 0&&(w.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,k.$Sc)(t),(0,k.$Sc)(l),r.removedDocuments&&this.e.fire(t),r.addedDocuments&&this.d.fire(a),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(g=>g.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return n.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const t=this.b.get(this.a);return r?t:t?.value}allEditors(){return[...this.b.values()]}};e.$_P=h,e.$_P=h=He([Ge(0,s.$2P),Ge(1,u.$ak)],h),e.$aQ=(0,R.$Gi)("IExtHostDocumentsAndEditors")});var ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)},rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w};define(Ie[96],Pe([1,0,11,23,22,6,273,76,4,37,15,38,3,12,5,34,58,17,125,8,7,242,55,82,56,25]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l,g,m){"use strict";var $,S,D,b,T;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gpc=e.$Fpc=e.$Epc=e.$Dpc=e.$Cpc=void 0,i=Ve(i);let P=0;const p=new WeakMap;e.$Cpc=(0,u.$Gi)("IExtHostTesting");let f=class extends v.$Xc{constructor(Y,we,Te,re){super(),this.C=we,this.D=Te,this.F=re,this.f=this.B(new O.$ne),this.g=new Map,this.w=this.B(new O.$ne),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=Y.getProxy(d.$vN.MainThreadTesting),this.m=new he(this.h),this.j=new J(this.h,we),Te.registerArgumentProcessor({processArgument:q=>{switch(q?.$mid){case s.MarshalledId.TestItemContext:{const ae=q,le=ae.tests[ae.tests.length-1].item.extId;return this.g.get(a.$UI.root(le))?.collection.tree.get(le)?.actual??(0,h.$bQ)(q)}case s.MarshalledId.TestMessageMenuArgs:{const{test:ae,message:le}=q,ne=ae.item.extId;return{test:this.g.get(a.$UI.root(ne))?.collection.tree.get(ne)?.actual??(0,h.$bQ)({$mid:s.MarshalledId.TestItemContext,tests:[ae]}),message:i.TestMessage.to(le)}}default:return q}}}),Te.registerCommand(!1,"testing.getExplorerSelection",async()=>{const q=await Te.executeCommand(t.TestCommandId.GetExplorerSelection),ae=le=>{const ne=this.g.get(a.$UI.root(le));if(ne)return a.$UI.isRoot(le)?ne.controller:ne.collection.tree.get(le)?.actual};return{include:q?.include.map(ae).filter(I.$og)||[],exclude:q?.exclude.map(ae).filter(I.$og)||[]}})}createTestController(Y,we,Te,re){if(this.g.has(we))throw new Error(`Attempt to insert a duplicate controller with ID "${we}"`);const q=new v.$Wc,ae=q.add(new h.$eQ(we,Te,this.F));ae.root.label=Te;const le=new Map,ne=new Set,ce=this.h,oe={items:ae.root.children,get label(){return Te},set label(x){Te=x,ae.root.label=x,ce.$updateController(we,{label:Te})},get refreshHandler(){return re},set refreshHandler(x){re=x,ce.$updateController(we,{canRefresh:!!x})},get id(){return we},createRunProfile:(x,ue,me,Oe,je,ke)=>{let Ae=(0,N.$uj)(x);for(;le.has(Ae);)Ae++;return new be(this.h,le,ne,this.w.event,we,Ae,x,ue,me,Oe,je,ke)},createTestItem(x,ue,me){return new h.$cQ(we,x,ue,me)},createTestRun:(x,ue,me=!0)=>this.j.createTestRun(Y,we,ae,x,ue,me),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const ue=x instanceof Array?x:[x];this.h.$markTestRetired(ue.map(me=>a.$UI.fromExtHostTestItem(me,we).toString()))}},set resolveHandler(x){ae.resolveHandler=x},get resolveHandler(){return ae.resolveHandler},dispose:()=>{q.dispose()}};ce.$registerTestController(we,Te,!!re),q.add((0,v.$Vc)(()=>ce.$unregisterTestController(we)));const H={controller:oe,collection:ae,profiles:le,extension:Y,activeProfiles:ne};return this.g.set(we,H),q.add((0,v.$Vc)(()=>this.g.delete(we))),q.add(ae.onDidGenerateDiff(x=>ce.$publishDiff(we,x.map(g.TestsDiffOp.serialize)))),oe}createTestObserver(){return this.m.checkout()}async runTests(Y,we=k.CancellationToken.None){const Te=z(Y);if(!Te)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const re=this.g.get(Te.controllerId);if(!re)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:Y.preserveFocus??!0,group:de[Te.kind],targets:[{testIds:Y.include?.map(q=>a.$UI.fromExtHostTestItem(q,re.collection.root.id).toString())??[re.collection.root.id],profileId:Te.profileId,controllerId:Te.controllerId}],exclude:Y.exclude?.map(q=>q.id)},we)}registerTestFollowupProvider(Y){return this.y.add(Y),{dispose:()=>{this.y.delete(Y)}}}$syncTests(){for(const{collection:Y}of this.g.values())Y.flushDiff();return Promise.resolve()}async $getCoverageDetails(Y,we,Te){return(await this.j.getCoverageDetails(Y,we,Te))?.map(i.TestCoverage.fromDetails)}async $disposeRun(Y){this.j.disposeTestRun(Y)}$configureRunProfile(Y,we){this.g.get(Y)?.profiles.get(we)?.configureHandler?.()}$setDefaultRunProfiles(Y){const we=new Map;for(const[Te,re]of Object.entries(Y)){const q=this.g.get(Te);if(!q)continue;const ae=new Map,le=re.filter(ce=>!q.activeProfiles.has(ce)),ne=[...q.activeProfiles].filter(ce=>!re.includes(ce));for(const ce of le)ae.set(ce,!0),q.activeProfiles.add(ce);for(const ce of ne)ae.set(ce,!1),q.activeProfiles.delete(ce);ae.size&&we.set(Te,ae)}this.w.fire(we)}async $refreshTests(Y,we){await this.g.get(Y)?.controller.refreshHandler?.(we)}$publishTestResults(Y){this.results=Object.freeze(Y.map(we=>{const Te=i.TestResults.to(we);return p.set(Te,we.id),Te}).concat(this.results).sort((we,Te)=>Te.completedAt-we.completedAt).slice(0,32)),this.f.fire()}async $expandTest(Y,we){const Te=this.g.get(a.$UI.fromString(Y).controllerId)?.collection;Te&&(await Te.expand(Y,we<0?1/0:we),Te.flushDiff())}$acceptDiff(Y){this.m.applyDiff(Y.map(we=>g.TestsDiffOp.deserialize({asCanonicalUri:Te=>Te},we)))}async $runControllerTests(Y,we){return Promise.all(Y.map(Te=>this.G(Te,!1,we)))}async $startContinuousRun(Y,we){const Te=new k.$ye(we),re=await Promise.all(Y.map(q=>this.G(q,!0,Te.token)));return!we.isCancellationRequested&&!re.some(q=>q.error)&&await new Promise(q=>we.onCancellationRequested(q)),Te.dispose(!0),re}async $provideTestFollowups(Y,we){const Te=this.results.find(ae=>p.get(ae)===Y.resultId),re=Te&&$e(a.$UI.fromString(Y.extId),Te?.results);if(!re)return[];let q=[];return await Promise.all([...this.y].map(async ae=>{try{const le=await ae.provideFollowup(Te,re,Y.taskIndex,Y.messageIndex,we);le&&(q=q.concat(le))}catch(le){this.C.error("Error thrown while providing followup for test message",le)}})),we.isCancellationRequested?[]:q.map(ae=>{const le=P++;return this.z.set(le,ae),{title:ae.title,id:le}})}$disposeTestFollowups(Y){for(const we of Y)this.z.delete(we)}$executeTestFollowup(Y){const we=this.z.get(Y);return we?this.D.executeCommand(we.command,...we.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(Y){Y===void 0?this.j.cancelAllRuns():this.j.cancelRunById(Y)}getMetadataForRun(Y){for(const we of this.j.trackers){const Te=we.getTaskIdForRun(Y);if(Te)return{taskId:Te,runId:we.id}}}async G(Y,we,Te){const re=this.g.get(Y.controllerId);if(!re)return{};const{collection:q,profiles:ae,extension:le}=re,ne=ae.get(Y.profileId);if(!ne)return{};const ce=Y.testIds.map(ue=>q.tree.get(ue)).filter(I.$og),oe=Y.excludeExtIds.map(ue=>re.collection.tree.get(ue)).filter(I.$og).filter(ue=>ce.some(me=>me.fullId.compare(ue.fullId)===a.TestPosition.IsChild));if(!ce.length)return{};const H=new r.$$O(ce.some(ue=>ue.actual instanceof h.$dQ)?void 0:ce.map(ue=>ue.actual),oe.map(ue=>ue.actual),ne,we),x=(0,g.$XI)(Y)&&this.j.prepareForMainThreadTestRun(le,H,A.fromInternal(Y,re.collection),ne,Te);try{return await ne.runHandler(H,Te),{}}catch(ue){return{error:String(ue)}}finally{x&&x.hasRunningTasks&&!Te.isCancellationRequested&&await O.Event.toPromise(x.onEnd)}}};e.$Dpc=f,e.$Dpc=f=He([Ge(0,c.$2P),Ge(1,C.$ak),Ge(2,n.$lQ),Ge(3,o.$aQ)],f);const M=1e4;var L;(function(ye){ye[ye.Running=0]="Running",ye[ye.Cancelling=1]="Cancelling",ye[ye.Ended=2]="Ended"})(L||(L={}));class K extends v.$Xc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(Y,we,Te,re,q,ae){super(),this.z=Y,this.C=we,this.D=Te,this.F=re,this.G=q,this.c=L.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$ne),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new k.$ye(ae));const le=this.B(new w.$Sh(()=>this.H(),M));this.B(this.j.token.onCancellationRequested(()=>le.schedule()));const ne=new O.$ne;this.w=ne.event,this.B((0,v.$Vc)(()=>{ne.fire(),ne.dispose()}))}getTaskIdForRun(Y){for(const[we,{run:Te}]of this.g)if(Te===Y)return we}cancel(){this.c===L.Running?(this.j.cancel(),this.c=L.Cancelling):this.c===L.Cancelling&&this.H()}async getCoverageDetails(Y,we,Te){const[,re]=a.$UI.fromString(Y).path,q=this.y.get(Y);if(!q)return[];const{report:ae,extIds:le}=q,ne=this.g.get(re);if(!ne)throw new Error("unreachable: run task was not found");let ce;if(we&&ae instanceof r.$dP){const H=le.indexOf(we);if(H===-1)return[];ce=ae.fromTests[H]}return await(ce?this.F?.loadDetailedCoverageForTest?.(ne.run,ae,ce,Te):this.F?.loadDetailedCoverage?.(ne.run,ae,Te))??[]}createRun(Y){const we=this.z.id,Te=this.z.controllerId,re=(0,E.$3g)(),q=ce=>(oe,...H)=>{if(le){this.D.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.J(oe),ce(oe,...H)},ae=(ce,oe)=>{const H=oe instanceof Array?oe.map(i.TestMessage.from):[i.TestMessage.from(oe)];if(ce.uri&&ce.range){const x={range:i.Range.from(ce.range),uri:ce.uri};for(const ue of H)ue.location=ue.location||x}this.C.$appendTestMessagesInRun(we,re,a.$UI.fromExtHostTestItem(ce,Te).toString(),H)};let le=!1;const ne={isPersisted:this.z.isPersisted,token:this.j.token,name:Y,onDidDispose:this.w,addCoverage:ce=>{if(le)return;const oe=ce instanceof r.$dP?ce.fromTests:[];if(oe.length){(0,m.$8G)(this.G,"attributableCoverage");for(const ue of oe)this.J(ue)}const H=ce.uri.toString(),x=new a.$UI([we,re,H]).toString();this.y.set(x,{report:ce,extIds:oe.map(ue=>a.$UI.fromExtHostTestItem(ue,Te).toString())}),this.C.$appendCoverage(we,re,i.TestCoverage.fromFile(Te,x,ce))},enqueued:q(ce=>{this.C.$updateTestStateInRun(we,re,a.$UI.fromExtHostTestItem(ce,Te).toString(),g.TestResultState.Queued)}),skipped:q(ce=>{this.C.$updateTestStateInRun(we,re,a.$UI.fromExtHostTestItem(ce,Te).toString(),g.TestResultState.Skipped)}),started:q(ce=>{this.C.$updateTestStateInRun(we,re,a.$UI.fromExtHostTestItem(ce,Te).toString(),g.TestResultState.Running)}),errored:q((ce,oe,H)=>{ae(ce,oe),this.C.$updateTestStateInRun(we,re,a.$UI.fromExtHostTestItem(ce,Te).toString(),g.TestResultState.Errored,H)}),failed:q((ce,oe,H)=>{ae(ce,oe),this.C.$updateTestStateInRun(we,re,a.$UI.fromExtHostTestItem(ce,Te).toString(),g.TestResultState.Failed,H)}),passed:q((ce,oe)=>{this.C.$updateTestStateInRun(we,re,a.$UI.fromExtHostTestItem(ce,this.z.controllerId).toString(),g.TestResultState.Passed,oe)}),appendOutput:(ce,oe,H)=>{le||(H&&this.J(H),this.C.$appendOutputToRun(we,re,y.$Pe.fromString(ce),oe&&i.location.from(oe),H&&a.$UI.fromExtHostTestItem(H,Te).toString()))},end:()=>{le||(le=!0,this.C.$finishedTestRunTask(we,re),--this.f||this.I())}};return this.f++,this.g.set(re,{run:ne}),this.C.$startedTestRunTask(we,{id:re,name:Y,running:!0}),ne}H(){for(const{run:Y}of this.g.values())Y.end()}I(){this.c!==L.Ended&&(this.c=L.Ended,this.m.fire())}J(Y){if(!(Y instanceof h.$cQ))throw new l.$TP(Y.id);if(this.h.has(a.$UI.fromExtHostTestItem(Y,this.z.controllerId).toString()))return;const we=[],Te=this.z.colllection.root;for(;;){const re=i.TestItem.from(Y);if(we.unshift(re),this.h.has(re.extId)||(this.h.add(re.extId),Y===Te))break;Y=Y.parent||Te}this.C.$addTestsToRun(this.z.controllerId,this.z.id,we)}dispose(){this.I(),super.dispose()}}class J{get trackers(){return this.c.values()}constructor(Y,we){this.g=Y,this.h=we,this.c=new Map,this.f=new Map}getCoverageDetails(Y,we,Te){const re=a.$UI.root(Y);return this.f.get(re)?.getCoverageDetails(Y,we,Te)||[]}disposeTestRun(Y){this.f.get(Y)?.dispose(),this.f.delete(Y);for(const[we,{id:Te}]of this.c)Te===Y&&this.c.delete(we)}prepareForMainThreadTestRun(Y,we,Te,re,q){return this.j(we,Te,re,Y,q)}cancelRunById(Y){this.f.get(Y)?.cancel()}cancelAllRuns(){for(const Y of this.c.values())Y.cancel()}createTestRun(Y,we,Te,re,q,ae){const le=this.c.get(re);if(le)return le.createRun(q);const ne=A.fromPublic(we,Te,re,ae),ce=z(re);this.g.$startedExtensionTestRun({controllerId:we,continuous:!!re.continuous,profile:ce&&{group:de[ce.kind],id:ce.profileId},exclude:re.exclude?.map(H=>a.$UI.fromExtHostTestItem(H,Te.root.id).toString())??[],id:ne.id,include:re.include?.map(H=>a.$UI.fromExtHostTestItem(H,Te.root.id).toString())??[Te.root.id],preserveFocus:re.preserveFocus??!0,persist:ae});const oe=this.j(re,ne,re.profile,Y);return O.Event.once(oe.onEnd)(()=>{this.g.$finishedExtensionTestRun(ne.id)}),oe.createRun(q)}j(Y,we,Te,re,q){const ae=new K(we,this.g,this.h,Te,re,q);return this.c.set(Y,ae),this.f.set(ae.id,ae),ae}}e.$Epc=J;const z=ye=>{if(ye.profile){if(!(ye.profile instanceof be))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ye.profile}};class A{static fromPublic(Y,we,Te,re){return new A(Y,(0,E.$3g)(),re,we)}static fromInternal(Y,we){return new A(Y.controllerId,Y.runId,!0,we)}constructor(Y,we,Te,re){this.controllerId=Y,this.id=we,this.isPersisted=Te,this.colllection=re}}e.$Fpc=A;class W{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(Y){this.j=Y,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(Y){this.c.add(Y)}update(Y){Object.assign(Y.revived,i.TestItem.toPlain(Y.item)),this.c.has(Y)||this.f.add(Y)}remove(Y){if(this.c.has(Y)){this.c.delete(Y);return}this.f.delete(Y);const we=a.$UI.parentId(Y.item.extId);if(we&&this.h.has(we.toString())){this.h.add(Y.item.extId);return}this.g.add(Y)}getChangeEvent(){const{c:Y,f:we,g:Te}=this;return{get added(){return[...Y].map(re=>re.revived)},get updated(){return[...we].map(re=>re.revived)},get removed(){return[...Te].map(re=>re.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class Z extends g.$4I{constructor(){super(...arguments),this.y=new O.$ne,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(Y){return this.f.get(Y)}getMirroredTestDataByReference(Y){return this.f.get(Y.id)}x(Y,we){return{...Y,revived:i.TestItem.toPlain(Y.item),depth:we?we.depth+1:0,children:new Set}}w(){return new W(this.y)}}class he{constructor(Y){this.f=Y}checkout(){this.c||(this.c=this.g());const Y=this.c;return Y.observers++,{onDidChangeTest:Y.tests.onDidChangeTests,get tests(){return[...Y.tests.rootTests].map(we=>we.revived)},dispose:(0,R.$gb)(()=>{--Y.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(Y){return this.c?.tests.getMirroredTestDataByReference(Y)}applyDiff(Y){this.c?.tests.apply(Y)}g(){const Y=new Z({asCanonicalUri:we=>we});return this.f.$subscribeToDiffs(),{observers:0,tests:Y}}}const ve=(ye,Y,we,Te)=>{we?Object.assign(we,Te):Y.$updateTestRunConfig(ye.controllerId,ye.profileId,Te)};class be{get label(){return this.f}set label(Y){Y!==this.f&&(this.f=Y,ve(this,ze(this,$,"f"),ze(this,b,"f"),{label:Y}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(Y){Y!==this.g&&(this.g=Y,ve(this,ze(this,$,"f"),ze(this,b,"f"),{supportsContinuousRun:Y}))}get isDefault(){return ze(this,S,"f").has(this.profileId)}set isDefault(Y){Y!==this.isDefault&&(Y?ze(this,S,"f").add(this.profileId):ze(this,S,"f").delete(this.profileId),ve(this,ze(this,$,"f"),ze(this,b,"f"),{isDefault:Y}))}get tag(){return this._tag}set tag(Y){Y?.id!==this._tag?.id&&(this._tag=Y,ve(this,ze(this,$,"f"),ze(this,b,"f"),{tag:Y?i.TestTag.namespace(this.controllerId,Y.id):null}))}get configureHandler(){return this.c}set configureHandler(Y){Y!==this.c&&(this.c=Y,ve(this,ze(this,$,"f"),ze(this,b,"f"),{hasConfigurationHandler:!!Y}))}get onDidChangeDefault(){return O.Event.chain(ze(this,D,"f"),Y=>Y.map(we=>we.get(this.controllerId)?.get(this.profileId)).filter(I.$og))}constructor(Y,we,Te,re,q,ae,le,ne,ce,oe=!1,H=void 0,x=!1){this.controllerId=q,this.profileId=ae,this.f=le,this.kind=ne,this.runHandler=ce,this._tag=H,this.g=x,$.set(this,void 0),S.set(this,void 0),D.set(this,void 0),b.set(this,void 0),T.set(this,void 0),rt(this,$,Y,"f"),rt(this,T,we,"f"),rt(this,S,Te,"f"),rt(this,D,re,"f"),we.set(ae,this);const ue=de[ne];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${ne}`);oe&&Te.add(ae),rt(this,b,{profileId:ae,controllerId:q,tag:H?i.TestTag.namespace(this.controllerId,H.id):null,label:le,group:ue,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:x},"f"),queueMicrotask(()=>{ze(this,b,"f")&&(ze(this,$,"f").$publishTestRunProfile(ze(this,b,"f")),rt(this,b,void 0,"f"))})}dispose(){ze(this,T,"f")?.delete(this.profileId)&&(rt(this,T,void 0,"f"),ze(this,$,"f").$removeTestProfile(this.controllerId,this.profileId)),rt(this,b,void 0,"f")}}e.$Gpc=be,$=new WeakMap,S=new WeakMap,D=new WeakMap,b=new WeakMap,T=new WeakMap;const de={[r.TestRunProfileKind.Coverage]:g.TestRunProfileBitset.Coverage,[r.TestRunProfileKind.Debug]:g.TestRunProfileBitset.Debug,[r.TestRunProfileKind.Run]:g.TestRunProfileBitset.Run};function $e(ye,Y){for(let we=0;we<ye.path.length;we++){const Te=Y.find(re=>re.id===ye.path[we]);if(!Te)return;if(we===ye.path.length-1)return Te;Y=Te.children}}}),define(Ie[301],Pe([1,0,18,6,4,5,127,8,7]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Noc=void 0,w=Ve(w),N=Ve(N);class s extends k.$Xc{constructor(E,u){super(),this.m=u,this.a=new y.$ne,this.b=new y.$ne,this.c=new y.$ne,this.f=new y.$ne,this.g=new y.$ne,this.h=new y.$ne,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=E.getProxy(O.$vN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(C=>this.h.fire(C))),this.B(this.m.onDidChangeActiveTextEditor(C=>this.g.fire(C)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(E){const u=this.m.allEditors();return E?u:u.map(C=>C.value)}async showTextDocument(E,u,C){let d;typeof u=="number"?d={position:N.ViewColumn.from(u),preserveFocus:C}:typeof u=="object"?d={position:N.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?N.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:d={preserveFocus:!1};const n=await this.j.$tryShowTextDocument(E.uri,d),o=n&&this.m.getEditor(n);if(o)return o.value;throw n?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,u){return new R.$9P(this.j,E,u).value}$acceptEditorPropertiesChanged(E,u){const C=this.m.getEditor(E);if(!C)throw new Error("unknown text editor");if(u.options&&C._acceptOptions(u.options),u.selections){const d=u.selections.selections.map(N.Selection.to);C._acceptSelections(d)}if(u.visibleRanges){const d=w.$Kb(u.visibleRanges.map(N.Range.to));C._acceptVisibleRanges(d)}if(u.options&&this.b.fire({textEditor:C.value,options:{...u.options,lineNumbers:N.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const d=v.TextEditorSelectionChangeKind.fromValue(u.selections.source),n=u.selections.selections.map(N.Selection.to);this.a.fire({textEditor:C.value,selections:n,kind:d})}if(u.visibleRanges){const d=w.$Kb(u.visibleRanges.map(N.Range.to));this.c.fire({textEditor:C.value,visibleRanges:d})}}$acceptEditorPositionData(E){for(const u in E){const C=this.m.getEditor(u);if(!C)throw new Error("Unknown text editor");const d=N.ViewColumn.to(E[u]);C.value.viewColumn!==d&&(C._acceptViewColumn(d),this.f.fire({textEditor:C.value,viewColumn:d}))}}getDiffInformation(E){return Promise.resolve(this.j.$getDiffInformation(E))}}e.$Noc=s}),define(Ie[302],Pe([1,0,2,3,5,4,7,8,19,37,15]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zqc=e.$yqc=void 0,e.$yqc=(0,y.$Gi)("IExtHostTimeline");class E{constructor(d,n){this.b=new Map,this.c=new Map,this.a=d.getProxy(k.$vN.MainThreadTimeline),n.registerArgumentProcessor({processArgument:(o,c)=>{if(o&&o.$mid===s.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&v.$sn.equals(c,this.b.get(o.source)?.extension)){const h=o.uri===void 0?void 0:w.URI.revive(o.uri);return this.c.get(o.source)?.get(u(h))?.get(o.handle)}else return;return o}})}async $getTimeline(d,n,o,c){return this.b.get(d)?.provider.provideTimeline(w.URI.revive(n),o,c)}registerTimelineProvider(d,n,o,c){const h=new O.$Wc,i=this.d(n.id,c,h).bind(this);let r;n.onDidChange&&(r=n.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:n.id}),this));const t=this.c;return this.f({...n,scheme:d,onDidChange:void 0,async provideTimeline(a,l,g){l?.resetCache&&(h.clear(),t.get(n.id)?.clear());const m=await n.provideTimeline(a,l,g);if(m==null)return;const $=i(a,l);return{...m,source:n.id,items:m.items.map($)}},dispose(){for(const a of t.values())a.get(n.id)?.clear();r?.dispose(),h.dispose()}},o)}d(d,n,o){return(c,h)=>{let i;if(h?.cacheResults){let r=this.c.get(d);r===void 0&&(r=new Map,this.c.set(d,r));const t=u(c);i=r.get(t),i===void 0&&(i=new Map,r.set(t,i))}return r=>{const{iconPath:t,...a}=r,l=`${d}|${r.id??r.timestamp}`;i?.set(l,r);let g,m,$;r.iconPath&&(t instanceof R.$uO?$={id:t.id,color:t.color}:w.URI.isUri(t)?(g=t,m=t):{light:g,dark:m}=t);let S;return R.$ZN.isMarkdownString(a.tooltip)?S=N.MarkdownString.from(a.tooltip):(0,I.$gg)(a.tooltip)?S=a.tooltip:R.$ZN.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=N.MarkdownString.from(a.detail)):(0,I.$gg)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),S=a.detail),{...a,id:a.id??void 0,handle:l,source:d,command:r.command?n.toInternal(r.command,o):void 0,icon:g,iconDark:m,themeIcon:$,tooltip:S,accessibilityInformation:r.accessibilityInformation}}}}f(d,n){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:n}),(0,O.$Vc)(()=>{for(const c of this.c.values())c.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$zqc=E;function u(C){return C?.toString()}}),define(Ie[303],Pe([1,0,190,24,2,6,4,233,11,7,15,18,8,60,22,162,25]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aqc=void 0,s=Ve(s);function c(r,t){if((0,I.$gg)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let a;return Array.isArray(r.highlights)&&(a=r.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),a=a.length?a:void 0),{label:r.label,highlights:a}}}class h extends R.$Xc{constructor(t,a,l){super(),this.f=t,this.g=a,this.h=l,this.a=new Map,this.b=new n.$C_;function g(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}a.registerArgumentProcessor({processArgument:m=>g(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map($=>g($)?this.r($):$):m})}registerTreeDataProvider(t,a,l){const g=this.createTreeView(t,{treeDataProvider:a},l);return{dispose:()=>g.dispose()}}createTreeView(t,a,l){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=a.dragAndDropController?.dropMimeTypes??[],m=a.dragAndDropController?.dragMimeTypes??[],$=!!a.dragAndDropController?.handleDrag,S=!!a.dragAndDropController?.handleDrop,D=this.m(t,a,l),b={showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,dropMimeTypes:g,dragMimeTypes:m,hasHandleDrag:$,hasHandleDrop:S,manuallyManageCheckboxes:!!a.manageCheckboxStateManually},T=this.f.$registerTreeViewDataProvider(t,b),P={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$8G)(l,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$8G)(l,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(p){(0,C.$6k)(p)&&(0,o.$8G)(l,"treeViewMarkdownMessage"),D.message=p},get title(){return D.title},set title(p){D.title=p},get description(){return D.description},set description(p){D.description=p},get badge(){return D.badge},set badge(p){p!==void 0&&s.ViewBadge.isViewBadge(p)?D.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(D.badge=void 0)},reveal:(p,f)=>D.reveal(p,f),dispose:async()=>{await T,this.a.delete(t),D.dispose()}};return this.B(P),P}$getChildren(t,a){const l=this.a.get(t);return l?l.getChildren(a):Promise.reject(new N.$rG(t))}async $handleDrop(t,a,l,g,m,$,S,D){const b=this.a.get(t);if(!b)return Promise.reject(new N.$rG(t));const T=u.DataTransfer.toDataTransfer(l,async P=>(await this.f.$resolveDropFileData(t,a,P)).buffer);return S===t&&D&&await this.j(T,b,D,m,$),b.onDrop(T,g,m)}async j(t,a,l,g,m){const $=this.b.removeDragOperationTransfer(m);if($)(await $)?.forEach((S,D)=>{S&&t.set(D,S)});else if(m&&a.handleDrag){const S=a.handleDrag(l,t,g);this.b.addDragOperationTransfer(m,S),await S}return t}async $handleDrag(t,a,l,g){const m=this.a.get(t);if(!m)return Promise.reject(new N.$rG(t));const $=await this.j(new s.$qO,m,a,g,l);if(!(!$||g.isCancellationRequested))return u.DataTransfer.from($)}async $hasResolve(t){const a=this.a.get(t);if(!a)throw new N.$rG(t);return a.hasResolve}$resolve(t,a,l){const g=this.a.get(t);if(!g)throw new N.$rG(t);return g.resolveTreeItem(a,l)}$setExpanded(t,a,l){const g=this.a.get(t);if(!g)throw new N.$rG(t);g.setExpanded(a,l)}$setSelectionAndFocus(t,a,l){const g=this.a.get(t);if(!g)throw new N.$rG(t);g.setSelectionAndFocus(a,l)}$setVisible(t,a){const l=this.a.get(t);if(!l){if(!a)return;throw new N.$rG(t)}l.setVisible(a)}$changeCheckboxState(t,a){const l=this.a.get(t);if(!l)throw new N.$rG(t);l.setCheckboxState(a)}m(t,a,l){const g=this.B(new i(t,a,this.f,this.g.converter,this.h,l));return this.a.set(t,g),g}r(t){const a=this.a.get(t.$treeViewId);return a&&"$treeItemHandle"in t?a.getExtensionElement(t.$treeItemHandle):a&&"$focusedTreeItem"in t&&t.$focusedTreeItem?a.focusedElement:null}}e.$Aqc=h;class i extends R.$Xc{get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$pg)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,a,l,g,m,$){if(super(),this.I=t,this.J=l,this.L=g,this.M=m,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$ne),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$ne),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$ne),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$ne),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$ne),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$ne),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$ne),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$ye,$.contributes&&$.contributes.views)for(const T in $.contributes.views)for(const P of $.contributes.views[T])P.id===t&&(this.P=P.name);this.f=a.treeDataProvider,this.g=a.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(T=>{Array.isArray(T)&&T.length===0||this.F.fire({message:!1,element:T})}));let S,D;const b=O.Event.debounce(this.F.event,(T,P)=>(T||(T={message:!1,elements:[]}),P.element!==!1&&(S||(S=new Promise(p=>D=p),this.G=this.G.then(()=>S)),Array.isArray(P.element)?T.elements.push(...P.element):T.elements.push(P.element)),P.message&&(T.message=!0),T),200,!0);this.B(b(({message:T,elements:P})=>{P.length&&(this.H=this.H.then(()=>{const p=D;return S=null,this.$(P).then(()=>p())})),T&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const a=t?this.getExtensionElement(t):void 0;if(t&&!a)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let l=this.X(t);return l||(l=await this.Y(a)),l?l.map(g=>g.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,a){a=a||{select:!0,focus:!1};const l=(0,I.$pg)(a.select)?!0:a.select,g=(0,I.$pg)(a.focus)?!1:a.focus,m=(0,I.$pg)(a.expand)?!1:a.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then($=>this.W(t,$[$.length-1]).then(S=>this.J.$reveal(this.I,{item:S.item,parentChain:$.map(D=>D.item)},{select:l,focus:g,expand:m})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:l,focus:g,expand:m})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=u.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,a){const l=this.getExtensionElement(t);l&&(a?this.u.fire(Object.freeze({element:l})):this.w.fire(Object.freeze({element:l})))}setSelectionAndFocus(t,a){const l=!(0,E.$xb)(this.s,t);this.s=t;const g=this.t!==a;this.t=a,l&&this.y.fire(Object.freeze({selection:this.selectedElements})),g&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const a=(await Promise.all(t.map(async l=>{const g=this.getExtensionElement(l.treeItemHandle);return g?{extensionItem:g,treeItem:await this.f.getTreeItem(g),newState:l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);a.forEach(l=>{l.treeItem.checkboxState=l.newState?s.TreeItemCheckboxState.Checked:s.TreeItemCheckboxState.Unchecked}),this.D.fire({items:a.map(l=>[l.extensionItem,l.newState])})}async handleDrag(t,a,l){const g=[];for(const m of t){const $=this.getExtensionElement(m);$&&g.push($)}if(!(!this.g?.handleDrag||g.length===0))return await this.g.handleDrag(g,a,l),a}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,a,l){const g=a?this.getExtensionElement(a):void 0;if(!(!g&&a||!this.g?.handleDrop))return(0,v.$yh)(()=>this.g?.handleDrop?this.g.handleDrop(g,t,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,a){if(!this.f.resolveTreeItem)return;const l=this.j.get(t);if(l){const g=this.m.get(l);if(g){const m=await this.f.resolveTreeItem(g.extensionItem,l,a)??g.extensionItem;return this.hb(m),g.item.tooltip=this.eb(m.tooltip),g.item.command=this.fb(g.disposableStore,m.command),g.item}}}S(t){return this.U(t).then(a=>a?this.S(a).then(l=>this.W(a,l[l.length-1]).then(g=>(l.push(g),l))):Promise.resolve([]))}U(t){const a=this.m.get(t);return a?Promise.resolve(a.parent?this.j.get(a.parent.item.handle):void 0):(0,v.$yh)(()=>this.f.getParent(t))}W(t,a){const l=this.m.get(t);return l?Promise.resolve(l):(0,v.$yh)(()=>this.f.getTreeItem(t)).then(g=>this.kb(t,g,a,!0)).then(g=>this.getChildren(a?a.item.handle:void 0).then(()=>{const m=this.getExtensionElement(g);if(m){const $=this.m.get(m);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${g} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let a;if(typeof t=="string"){const l=this.getExtensionElement(t);a=l?this.m.get(l):void 0}else a=t;return a&&a.children||void 0}return this.h}async Y(t){this.rb(t);const a=new d.$ye(this.Z.token);try{const l=t?this.m.get(t):void 0,g=await this.f.getChildren(t);if(a.token.isCancellationRequested)return;const m=(0,E.$Kb)(g||[]),$=await Promise.all((0,E.$Kb)(m).map(D=>this.f.getTreeItem(D)));if(a.token.isCancellationRequested)return;const S=$.map((D,b)=>D?this.db(m[b],D,l):null);return(0,E.$Kb)(S)}finally{a.dispose()}}$(t){if(t.some(l=>!l))return this.Z.dispose(!0),this.Z=new d.$ye,this.tb(),this.J.$refresh(this.I);{const l=this.ab(t);if(l.length)return this.bb(l)}return Promise.resolve(void 0)}ab(t){const a=new Set,l=t.map(m=>this.m.get(m));for(const m of l)if(m&&!a.has(m.item.handle)){let $=m;for(;$&&$.parent&&l.findIndex(S=>$&&$.parent&&S&&S.item.handle===$.parent.item.handle)===-1;){const S=this.j.get($.parent.item.handle);$=S?this.m.get(S):void 0}$&&!$.parent&&a.add(m.item.handle)}const g=[];return a.forEach(m=>{const $=this.j.get(m);if($){const S=this.m.get($);S&&(!S.parent||!a.has(S.parent.item.handle))&&g.push(m)}}),g}bb(t){const a={};return Promise.all(t.map(l=>this.cb(l).then(g=>{g&&(a[l]=g.item)}))).then(()=>Object.keys(a).length?this.J.$refresh(this.I,a):void 0)}cb(t){const a=this.getExtensionElement(t);if(a){const l=this.m.get(a);if(l)return this.rb(a),(0,v.$yh)(()=>this.f.getTreeItem(a)).then(g=>{if(g){const m=this.ib(a,g,l.parent);return this.pb(a,m,l,l.parent),l.dispose(),m}return null})}return Promise.resolve(null)}db(t,a,l){const g=this.ib(t,a,l);if(a.id&&this.j.has(g.item.handle))throw new Error((0,w.localize)(0,null,a.id));return this.ob(t,g),this.qb(g,l),g}eb(t){return s.$ZN.isMarkdownString(t)?u.MarkdownString.from(t):t}fb(t,a){return a?{...this.L.toInternal(a,t),originalId:a.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let a,l,g;return typeof t.checkboxState=="number"?a=t.checkboxState:(a=t.checkboxState.state,l=t.checkboxState.tooltip,g=t.checkboxState.accessibilityInformation),{isChecked:a===s.TreeItemCheckboxState.Checked,tooltip:l,accessibilityInformation:g}}hb(t){if(!s.$lO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,a,l){this.hb(a);const g=this.B(new R.$Wc),m=this.kb(t,a,l),$=this.lb(a);return{item:{handle:m,parentHandle:l?l.item.handle:void 0,label:c(a.label,this.N),description:a.description,resourceUri:a.resourceUri,tooltip:this.eb(a.tooltip),command:this.fb(g,a.command),contextValue:a.contextValue,icon:$,iconDark:this.mb(a)||$,themeIcon:this.jb(a),collapsibleState:(0,I.$pg)(a.collapsibleState)?s.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation,checkbox:this.gb(a)},extensionItem:a,parent:l,children:void 0,disposableStore:g,dispose(){g.dispose()}}}jb(t){return t.iconPath instanceof s.$uO?t.iconPath:void 0}kb(t,{id:a,label:l,resourceUri:g},m,$){if(a)return`${i.b}/${a}`;const S=c(l,this.N),D=m?m.item.handle:i.a;let b=S?S.label:g?(0,y.$eh)(g):"";b=b.indexOf("/")!==-1?b.replace("/","//"):b;const T=this.m.has(t)?this.m.get(t).item.handle:void 0,P=this.X(m)||[];let p,f=0;do{if(p=`${D}/${f}:${b}`,$||!this.j.has(p)||T===p)break;f++}while(f<=P.length);return p}lb(t){if(t.iconPath&&!(t.iconPath instanceof s.$uO))return typeof t.iconPath=="string"||k.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof s.$uO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return k.URI.isUri(t)?t:k.URI.file(t)}ob(t,a){this.j.set(a.item.handle,t),this.m.set(t,a)}pb(t,a,l,g){this.j.delete(a.item.handle),this.m.delete(t),a.item.handle!==l.item.handle&&this.j.delete(l.item.handle),this.ob(t,a);const m=this.X(g)||[],$=m.filter(S=>S.item.handle===l.item.handle)[0];$&&m.splice(m.indexOf($),1,a)}qb(t,a){a?(a.children||(a.children=[]),a.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const a=this.m.get(t);if(a){if(a.children)for(const l of a.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}a.children=void 0}}else this.tb()}sb(t){const a=this.m.get(t);if(a){if(a.children)for(const l of a.children){const g=this.j.get(l.item.handle);g&&this.sb(g)}this.m.delete(t),this.j.delete(a.item.handle),a.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}i.a="0",i.b="1"});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[304],Pe([1,0,6,4,2,38,8,68,5,7]),function(_,e,w,y,k,O,R,N,v,s){"use strict";var I,E,u,C,d,n,o,c,h,i,r,t,a;Object.defineProperty(e,"__esModule",{value:!0}),e.$7oc=void 0,R=Ve(R),v=Ve(v),s=Ve(s);class l extends y.$Xc{constructor(S,D,b,T){super(),I.set(this,void 0),E.set(this,void 0),u.set(this,void 0),C.set(this,void 0),d.set(this,void 0),n.set(this,void 0),o.set(this,void 0),c.set(this,void 0),h.set(this,!0),i.set(this,void 0),r.set(this,!1),t.set(this,this.B(new w.$ne)),this.onDidDispose=ze(this,t,"f").event,a.set(this,this.B(new w.$ne)),this.onDidChangeViewState=ze(this,a,"f").event,rt(this,I,S,"f"),rt(this,E,D,"f"),rt(this,C,b,"f"),rt(this,u,T.viewType,"f"),rt(this,d,T.panelOptions,"f"),rt(this,c,T.viewColumn,"f"),rt(this,n,T.title,"f"),rt(this,i,T.active,"f")}dispose(){ze(this,r,"f")||(rt(this,r,!0,"f"),ze(this,t,"f").fire(),ze(this,E,"f").$disposeWebview(ze(this,I,"f")),ze(this,C,"f").dispose(),super.dispose())}get webview(){return this.c(),ze(this,C,"f")}get viewType(){return this.c(),ze(this,u,"f")}get title(){return this.c(),ze(this,n,"f")}set title(S){this.c(),ze(this,n,"f")!==S&&(rt(this,n,S,"f"),ze(this,E,"f").$setTitle(ze(this,I,"f"),S))}get iconPath(){return this.c(),ze(this,o,"f")}set iconPath(S){this.c(),ze(this,o,"f")!==S&&(rt(this,o,S,"f"),ze(this,E,"f").$setIconPath(ze(this,I,"f"),k.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return ze(this,d,"f")}get viewColumn(){if(this.c(),!(typeof ze(this,c,"f")=="number"&&ze(this,c,"f")<0))return ze(this,c,"f")}get active(){return this.c(),ze(this,i,"f")}get visible(){return this.c(),ze(this,h,"f")}_updateViewState(S){ze(this,r,"f")||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(rt(this,i,S.active,"f"),rt(this,h,S.visible,"f"),rt(this,c,S.viewColumn,"f"),ze(this,a,"f").fire({webviewPanel:this}))}reveal(S,D){this.c(),ze(this,E,"f").$reveal(ze(this,I,"f"),{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!D})}c(){if(ze(this,r,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,E=new WeakMap,u=new WeakMap,C=new WeakMap,d=new WeakMap,n=new WeakMap,o=new WeakMap,c=new WeakMap,h=new WeakMap,i=new WeakMap,r=new WeakMap,t=new WeakMap,a=new WeakMap;class g extends y.$Xc{static c(){return(0,O.$3g)()}constructor(S,D,b){super(),this.j=D,this.m=b,this.g=new Map,this.h=new Map,this.f=S.getProxy(v.$vN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,D,b,T,P={}){const p=typeof T=="object"?T.viewColumn:T,f={viewColumn:R.ViewColumn.from(p),preserveFocus:typeof T=="object"&&!!T.preserveFocus},M=(0,N.$3oc)(S),L=g.c();this.f.$createWebviewPanel((0,N.$5oc)(S),L,D,{title:b,panelOptions:m(P),webviewOptions:(0,N.$6oc)(S,this.m,P),serializeBuffersForPostMessage:M},f);const K=this.j.createNewWebview(L,P,S);return this.createNewWebviewPanel(L,D,b,p,P,K,!0)}$onDidChangeWebviewPanelViewStates(S){const D=Object.keys(S);D.sort((b,T)=>{const P=S[b],p=S[T];return P.active?1:p.active?-1:+P.visible-+p.visible});for(const b of D){const T=this.getWebviewPanel(b);if(!T)continue;const P=S[b];T._updateViewState({active:P.active,visible:P.visible,viewColumn:R.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,D,b){if(this.h.has(D))throw new Error(`Serializer for '${D}' already registered`);return this.h.set(D,{serializer:b,extension:S}),this.f.$registerSerializer(D,{serializeBuffersForPostMessage:(0,N.$3oc)(S)}),new s.$xN(()=>{this.h.delete(D),this.f.$unregisterSerializer(D)})}async $deserializeWebviewPanel(S,D,b,T){const P=this.h.get(D);if(!P)throw new Error(`No serializer found for '${D}'`);const{serializer:p,extension:f}=P,M=this.j.createNewWebview(S,b.webviewOptions,f),L=this.createNewWebviewPanel(S,D,b.title,T,b.panelOptions,M,b.active);await p.deserializeWebviewPanel(L,b.state)}createNewWebviewPanel(S,D,b,T,P,p,f){const M=new l(S,this.f,p,{viewType:D,title:b,viewColumn:T,panelOptions:P,active:f});return this.g.set(S,M),M}getWebviewPanel(S){return this.g.get(S)}}e.$7oc=g;function m($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[305],Pe([1,0,6,4,68,8,5,7]),function(_,e,w,y,k,O,R,N){"use strict";var v,s,I,E,u,C,d,n,o,c,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=void 0,R=Ve(R),N=Ve(N);class i extends y.$Xc{constructor(a,l,g,m,$,S){super(),v.set(this,void 0),s.set(this,void 0),I.set(this,void 0),E.set(this,void 0),u.set(this,!1),C.set(this,void 0),d.set(this,void 0),n.set(this,void 0),o.set(this,void 0),c.set(this,this.B(new w.$ne)),this.onDidChangeVisibility=ze(this,c,"f").event,h.set(this,this.B(new w.$ne)),this.onDidDispose=ze(this,h,"f").event,rt(this,I,g,"f"),rt(this,d,m,"f"),rt(this,v,a,"f"),rt(this,s,l,"f"),rt(this,E,$,"f"),rt(this,C,S,"f")}dispose(){ze(this,u,"f")||(rt(this,u,!0,"f"),ze(this,h,"f").fire(),ze(this,E,"f").dispose(),super.dispose())}get title(){return this.a(),ze(this,d,"f")}set title(a){this.a(),ze(this,d,"f")!==a&&(rt(this,d,a,"f"),ze(this,s,"f").$setWebviewViewTitle(ze(this,v,"f"),a))}get description(){return this.a(),ze(this,n,"f")}set description(a){this.a(),ze(this,n,"f")!==a&&(rt(this,n,a,"f"),ze(this,s,"f").$setWebviewViewDescription(ze(this,v,"f"),a))}get visible(){return ze(this,C,"f")}get webview(){return ze(this,E,"f")}get viewType(){return ze(this,I,"f")}_setVisible(a){a===ze(this,C,"f")||ze(this,u,"f")||(rt(this,C,a,"f"),ze(this,c,"f").fire())}get badge(){return this.a(),ze(this,o,"f")}set badge(a){this.a(),!(a?.value===ze(this,o,"f")?.value&&a?.tooltip===ze(this,o,"f")?.tooltip)&&(rt(this,o,O.ViewBadge.from(a),"f"),ze(this,s,"f").$setWebviewViewBadge(ze(this,v,"f"),a))}show(a){this.a(),ze(this,s,"f").$show(ze(this,v,"f"),!!a)}a(){if(ze(this,u,"f"))throw new Error("Webview is disposed")}}v=new WeakMap,s=new WeakMap,I=new WeakMap,E=new WeakMap,u=new WeakMap,C=new WeakMap,d=new WeakMap,n=new WeakMap,o=new WeakMap,c=new WeakMap,h=new WeakMap;class r{constructor(a,l){this.d=l,this.b=new Map,this.c=new Map,this.a=a.getProxy(R.$vN.MainThreadWebviewViews)}registerWebviewViewProvider(a,l,g,m){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:g,extension:a}),this.a.$registerWebviewViewProvider((0,k.$5oc)(a),l,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.$3oc)(a)}),new N.$xN(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(a,l,g,m,$){const S=this.b.get(l);if(!S)throw new Error(`No view provider found for '${l}'`);const{provider:D,extension:b}=S,T=this.d.createNewWebview(a,{},b),P=new i(a,this.a,l,g,T,!0);this.c.set(a,P),await D.resolveWebviewView(P,{state:m},$)}async $onDidChangeWebviewViewVisibility(a,l){this.e(a)._setVisible(l)}async $disposeWebviewView(a){const l=this.e(a);this.c.delete(a),l.dispose(),this.d.deleteWebview(a)}e(a){const l=this.c.get(a);if(!l)throw new Error("No webview found");return l}}e.$Dqc=r}),define(Ie[306],Pe([1,0,6,31,32,3]),function(_,e,w,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.OutputChannelUpdateMode=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=void 0,e.$DM="text/x-code-output",e.$EM="output",e.$FM="Log",e.$GM="text/x-code-log-output",e.$HM="log",e.$IM="workbench.panel.output",e.$JM=new k.$Xj("inOutput",!1),e.$KM=new k.$Xj("activeLogOutput",!1),e.$LM=new k.$Xj("activeLogOutput.levelSettable",!1),e.$MM=new k.$Xj("activeLogOutput.level",""),e.$NM=new k.$Xj("activeLogOutput.levelIsDefault",!1),e.$OM=new k.$Xj("outputView.scrollLock",!1),e.$PM=(0,O.$Gi)("outputService");var R;(function(v){v[v.Append=1]="Append",v[v.Replace=2]="Replace",v[v.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$QM={OutputChannels:"workbench.contributions.outputChannels"};class N{constructor(){this.a=new Map,this.b=new w.$ne,this.onDidRegisterChannel=this.b.event,this.c=new w.$ne,this.onDidRemoveChannel=this.c.event}registerChannel(s){this.a.has(s.id)||(this.a.set(s.id,s),this.b.fire(s.id))}getChannels(){const s=[];return this.a.forEach(I=>s.push(I)),s}getChannel(s){return this.a.get(s)}removeChannel(s){this.a.delete(s),this.c.fire(s)}}y.$so.add(e.$QM.OutputChannels,new N),e.$RM=new k.$Xj("activeOutputChannel","")}),define(Ie[128],Pe([1,0,5,3,17,19,12,306,69,27,51,166,23,15,30,6,4]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=e.$gqc=void 0;class c extends R.$gk{get disposed(){return this.n}constructor(t,a,l,g,m){super(),this.id=t,this.name=a,this.r=l,this.s=g,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,N.OutputChannelUpdateMode.Clear,t)}replace(t){const a=this.m;this.info(t),this.s.$update(this.id,N.OutputChannelUpdateMode.Replace,a),this.visible&&this.r.flush()}show(t,a){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:a))}hide(){this.s.$close(this.id)}g(t,a){this.m+=u.$Pe.fromString(a).byteLength,(0,R.log)(this.r,t,a),this.visible&&(this.r.flush(),this.s.$update(this.id,N.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends c{appendLine(t){this.append(t)}}let i=class{constructor(t,a,l,g,m,$){this.i=a,this.j=l,this.k=g,this.l=m,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(w.$vN.MainThreadOutputService),this.b=this.k.extUri.joinPath(a.logsLocation,`output_logging_${(0,E.$5m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[a,l]of this.g)l.visible=a===this.h}createOutputChannel(t,a,l){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const g=typeof a=="object"&&a.log,m=(0,C.$gg)(a)?a:void 0;if((0,C.$gg)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const S=this.i.environment.extensionLogLevel?.find(([b])=>O.$sn.equals(l.identifier,b))?.[1];S&&($=(0,R.$rk)(S));const D=g?this.o(t,$,l):this.n(t,m,l);return D.then(b=>{this.g.set(b.id,b),b.visible=b.id===this.h}),g?this.r(t,$??this.m.getLevel(),D):this.q(t,D)}async n(t,a,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const g=await this.c,m=this.k.extUri.joinPath(g,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(t,m,a,l.identifier.value);return new c(S,t,$,this.a,l)}async o(t,a,l){const g=await this.p(l),m=t.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(g,`${m}.log`),S=`${l.identifier.value}.${m}`,D=this.l.createLogger($,{id:S,name:t,logLevel:a,extensionId:l.identifier.value});return new h(S,t,D,this.a,l)}p(t){let a=this.d.get(t.identifier.value);if(!a){const l=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,a=(async()=>{try{await this.j.value.createDirectory(l)}catch(g){if((0,d.$ql)(g)!==d.FileSystemProviderErrorCode.FileExists)throw g}return l})())}return a}q(t,a){let l=!1;const g=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return t},append(m){g(),a.then($=>$.append(m))},appendLine(m){g(),a.then($=>$.appendLine(m))},clear(){g(),a.then(m=>m.clear())},replace(m){g(),a.then($=>$.replace(m))},show(m,$){g(),a.then(S=>S.show(m,$))},hide(){g(),a.then(m=>m.hide())},dispose(){l=!0,a.then(m=>m.dispose())}}}r(t,a,l){const g=new o.$Wc,m=()=>{if(g.isDisposed)throw new Error("Channel has been closed")},$=g.add(new n.$ne);function S(D){a=D,$.fire(D)}return l.then(D=>{g.add(D),D.logLevel!==a&&S(D.logLevel),g.add(D.onDidChangeLogLevel(b=>S(b)))}),{...this.q(t,l),get logLevel(){return a},onDidChangeLogLevel:$.event,trace(D,...b){m(),l.then(T=>T.trace(D,...b))},debug(D,...b){m(),l.then(T=>T.debug(D,...b))},info(D,...b){m(),l.then(T=>T.info(D,...b))},warn(D,...b){m(),l.then(T=>T.warn(D,...b))},error(D,...b){m(),l.then(T=>T.error(D,...b))},dispose(){g.dispose()}}}};e.$gqc=i,e.$gqc=i=He([Ge(0,k.$2P),Ge(1,s.$fQ),Ge(2,v.$Yoc),Ge(3,I.$Boc),Ge(4,R.$bk),Ge(5,R.$ak)],i),e.$hqc=(0,y.$Gi)("IExtHostOutputService")}),define(Ie[129],Pe([1,0,3,11]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=void 0,e.$Wm=(0,w.$Gi)("remoteAgentService"),e.$Xm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(k){let O=1/0;for(let N=0;N<this.maxSampleCount;N++){const v=await k.getRoundTripTime();if(v===void 0)return;O=Math.min(O,v/2),await(0,y.$Hh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(O):R=this.initial.reduce((N,v)=>N+v,0)/this.initial.length,this.lastMeasurement={initial:R,current:O,average:this.average.reduce((N,v)=>N+v,0)/this.average.length,high:typeof R>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ie[307],Pe([1,0,193,54,31,50,43,4,6,129,21,26,11,114]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=void 0,e.$4K=Object.freeze({id:"application",order:100,title:(0,w.localize)(0,null),type:"object"}),e.$5K=Object.freeze({id:"workbench",order:7,title:(0,w.localize)(1,null),type:"object"}),e.$6K=Object.freeze({id:"security",scope:y.ConfigurationScope.APPLICATION,title:(0,w.localize)(2,null),type:"object",order:7}),e.$7K=Object.freeze({id:"problems",title:(0,w.localize)(3,null),type:"object",order:101}),e.$8K=Object.freeze({id:"window",order:8,title:(0,w.localize)(4,null),type:"object"}),e.$9K={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new v.$ne,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const n=new d;k.$so.add(e.$9K.ConfigurationMigration,n);let o=class extends N.$Xc{constructor(r,t){super(),this.a=r,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const l of a.added)await this.f(l,n.migrations)})),this.c(n.migrations),this.B(n.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(r){await this.f(void 0,r);for(const t of this.b.getWorkspace().folders)await this.f(t,r)}async f(r,t){await Promise.all([t.map(a=>this.g(a,r?.uri))])}async g(r,t){const a=this.a.inspect(r.key,{resource:t}),l=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE],["workspaceFolder",R.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",R.ConfigurationTarget.USER],["userLocal",R.ConfigurationTarget.USER_LOCAL],["userRemote",R.ConfigurationTarget.USER_REMOTE],["workspace",R.ConfigurationTarget.WORKSPACE]];for(const[g,m]of l){const $=a[g];if(!$)continue;const S=[];if($.value!==void 0){const D=await this.h(r,g,$.value,t,void 0);for(const b of D??[])S.push([b,[]])}for(const{identifiers:D,value:b}of $.overrides??[])if(b!==void 0){const T=await this.h(r,g,b,t,D);for(const P of T??[])S.push([P,D])}S.length&&await Promise.allSettled(S.map(async([[D,b],T])=>this.a.updateValue(D,b.value,{resource:t,overrideIdentifiers:T},m)))}}async h(r,t,a,l,g){const m=S=>{const b=this.a.inspect(S,{resource:l})[t];if(b)return g?b.overrides?.find(({identifiers:T})=>(0,E.$jo)(T,g))?.value:b.value},$=await r.migrateFn(a,m);return Array.isArray($)?$:[[r.key,$]]}};e.$0K=o,o.ID="workbench.contrib.configurationMigration",e.$0K=o=He([Ge(0,R.$aj),Ge(1,O.$Pi)],o);let c=class extends N.$Xc{constructor(r){super(),this.b=r,this.a=new u.$4h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$c&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;k.$so.as(y.$xo.Configuration).registerConfiguration({...e.$6K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,w.localize)(5,null)},default:[],markdownDescription:(0,w.localize)(6,null),scope:y.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,w.localize)(7,null),scope:y.ConfigurationScope.MACHINE}}})}};e.$$K=c,c.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$$K=c=He([Ge(0,s.$Wm)],c),e.$_K="window.newWindowProfile";let h=class extends N.$Xc{constructor(r,t){super(),this.c=r,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(a=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(a=>{a.source!==R.ConfigurationTarget.DEFAULT&&a.affectsConfiguration(e.$_K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const r=k.$so.as(y.$xo.Configuration),t={...e.$8K,properties:{[e.$_K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(a=>a.name),null],enumItemLabels:[...this.c.profiles.map(a=>""),(0,w.localize)(8,null)],description:(0,w.localize)(9,null),scope:y.ConfigurationScope.APPLICATION}}};this.a?r.updateConfigurations({add:[t],remove:[this.a]}):r.registerConfiguration(t),this.a=t}h(){const r=this.f.getValue(e.$_K);this.b=r?this.c.profiles.find(t=>t.name===r):void 0}j(){const r=this.f.getValue(e.$_K);if(!r)return;const t=this.b?this.c.profiles.find(a=>a.id===this.b.id):void 0;r!==t?.name&&this.f.updateValue(e.$_K,t?.name)}};e.$aL=h,h.ID="workbench.contrib.dynamicWindowConfiguration",e.$aL=h=He([Ge(0,C.$Ml),Ge(1,R.$aj)],h)}),define(Ie[308],Pe([1,0,41,16,20,24,204,307,54,3,31]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$cL=e.$bL=void 0,e.$dL=n,e.$eL=o,w=Ve(w),e.$bL=(0,s.$Gi)("editorResolverService"),e.$cL="workbench.editorAssociations";const E=I.$so.as(v.$xo.Configuration),u={...N.$5K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(u);var C;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(C||(e.RegisteredEditorPriority=C={}));var d;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function n(c){switch(c){case C.exclusive:return 5;case C.default:return 4;case C.builtin:return 3;case C.option:default:return 1}}function o(c,h){if(new Set([y.Schemas.extension,y.Schemas.webviewPanel,y.Schemas.vscodeWorkspaceTrust,y.Schemas.vscodeSettings]).has(h.scheme))return!1;const t=typeof c=="string"&&c.indexOf(k.$jc.sep)>=0?`${h.scheme}:${h.path}`:(0,O.$eh)(h);return w.$zk(typeof c=="string"?c.toLowerCase():c,t.toLowerCase())}}),define(Ie[309],Pe([1,0,52,16,20,21,24,2,3,227,50,247,129]),function(_,e,w,y,k,O,R,N,v,s,I,E,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=void 0,e.$0M=(0,v.$Gi)("pathService");let d=C=class{constructor(o,c,h,i){this.d=o,this.e=c,this.f=h,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??o})()}hasValidBasename(o,c,h){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(o,i,c)):this.h(o,c,h)}h(o,c,h){return o.scheme===y.Schemas.file||o.scheme===y.Schemas.vscodeRemote?(0,w.$Dg)(h??(0,R.$eh)(o),c===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return C.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,c){if(o.remoteAuthority)return y.Schemas.vscodeRemote;const h=(0,s.$7M)(c.getWorkspace());if(h)return h;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=c.getWorkspace().configuration;return r?r.scheme:y.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===O.OperatingSystem.Windows?k.$ic:k.$jc)}async fileURI(o){let c="";if(await this.a===O.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(c=o.substring(2),o="/"):(c=o.substring(2,i),o=o.substring(i)||"/")}return N.URI.from({scheme:y.Schemas.file,authority:c,path:o,query:"",fragment:""})}};e.$$M=d,e.$$M=d=C=He([Ge(1,u.$Wm),Ge(2,E.$SM),Ge(3,I.$Pi)],d)}),define(Ie[130],Pe([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$LL=e.$KL=void 0;class w{constructor(R,N){this.line=R,this.character=N}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,N){return new w(0,0)}with(R){return new w(0,0)}}e.$KL=w;class y{constructor(R,N,v,s){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(R,N),this.end=new w(v,s)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new y(0,0,0,0)}with(R){return new y(0,0,0,0)}}e.$LL=y;var k;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(k||(e.TextSearchCompleteMessageType=k={}))}),define(Ie[44],Pe([1,0,18,41,26,52,13,3,20,14,130,11]),function(_,e,w,y,k,O,R,N,v,s,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$0L=e.$3L=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$ZL=e.$YL=e.$XL=e.$WL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.TextSearchCompleteMessageType=void 0,e.$TL=c,e.$UL=h,e.$VL=i,e.$1L=D,e.$2L=b,e.$4L=p,e.$5L=f,e.$6L=M,e.$7L=L,e.$8L=K,e.$9L=J,e.$$L=A,e.$aM=he,e.$bM=ve,y=Ve(y),k=Ve(k),O=Ve(O),v=Ve(v),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$ML="workbench.view.search",e.$NL="workbench.panel.search",e.$OL="workbench.view.search",e.$PL="search-result",e.$QL="search.exclude",e.$RL=2e4;const u="\u27EA ",C=" characters skipped \u27EB",d=(u.length+C.length+5)*2;e.$SL=(0,N.$Gi)("searchService");var n;(function(de){de[de.file=0]="file",de[de.text=1]="text",de[de.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var o;(function(de){de[de.File=1]="File",de[de.Text=2]="Text",de[de.aiText=3]="aiText"})(o||(e.QueryType=o={}));function c(de){return!!de.preview}function h(de){return!!de.resource}function i(de){return!!de.message}var r;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class t{constructor($e){this.resource=$e,this.results=[]}}e.$WL=t;class a{constructor($e,ye,Y,we){this.ranges=ye,this.webviewIndex=we;const Te=Array.isArray(ye)?ye:[ye];if(Y&&Y.matchLines===1&&l(Te)){$e=(0,R.$_f)($e,Y.matchLines);let re="",q=0,ae=0;const le=Math.floor(Y.charsPerLine/5),ne=[];for(const ce of Te){const oe=Math.max(ce.startColumn-le,0),H=ce.startColumn+Y.charsPerLine;if(oe>ae+le+d){const x=u+(oe-ae)+C;re+=x+$e.slice(oe,H),q+=oe-(ae+x.length)}else re+=$e.slice(ae,H);ne.push(new m(0,ce.startColumn-q,ce.endColumn-q)),ae=H}this.preview={text:re,matches:Array.isArray(this.ranges)?ne:ne[0]}}else{const re=Array.isArray(ye)?ye[0].startLineNumber:ye.startLineNumber;this.preview={text:$e,matches:(0,w.$4b)(ye,q=>new g(q.startLineNumber-re,q.startColumn,q.endLineNumber-re,q.endColumn))}}}}e.$XL=a;function l(de){const $e=de[0].startLineNumber;for(const ye of de)if(ye.startLineNumber!==$e||ye.endLineNumber!==$e)return!1;return!0}class g{constructor($e,ye,Y,we){this.startLineNumber=$e,this.startColumn=ye,this.endLineNumber=Y,this.endColumn=we}}e.$YL=g;class m extends g{constructor($e,ye,Y){super($e,ye,$e,Y)}}e.$ZL=m;var $;(function(de){de.List="list",de.Tree="tree"})($||(e.ViewMode=$={}));var S;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function D(de,$e=!0){const ye=de&&de.files&&de.files.exclude,Y=$e&&de&&de.search&&de.search.exclude;if(!ye&&!Y)return;if(!ye||!Y)return ye||Y;let we=Object.create(null);return we=k.$io(we,k.$fo(ye)),we=k.$io(we,k.$fo(Y),!0),we}function b(de,$e){return de.excludePattern&&y.$zk(de.excludePattern,$e)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&y.$zk(de.includePattern,$e)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(ye=>{const Y=ye.folder.fsPath;if(O.$Fg($e,Y)){const we=v.$oc(Y,$e);return!ye.includePattern||!!y.$zk(ye.includePattern,we)}else return!1}):!1:!0}var T;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(T||(e.SearchErrorCode=T={}));class P extends Error{constructor($e,ye){super($e),this.code=ye}}e.$3L=P;function p(de){const $e=de.message;if((0,s.$7)(de))return new P($e,T.canceled);try{const ye=JSON.parse($e);return new P(ye.message,ye.code)}catch{return new P($e,T.other)}}function f(de){const $e={message:de.message,code:de.code};return new Error(JSON.stringify($e))}function M(de){return de.type==="error"?!0:de.type==="success"}function L(de){return de.type==="success"}function K(de){return!!de.path}function J(de,$e,ye=!0){const Y=de.searchPath?de.searchPath:de.relativePath;return ye?(0,R.$9f)(Y,$e):y.$zk($e,Y)}class z{constructor($e){this.path=$e,this.results=[]}addMatch($e){this.results.push($e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$0L=z;function A(de,$e){const ye={...de||{},...$e||{}};return Object.keys(ye).filter(Y=>{const we=ye[Y];return typeof we=="boolean"&&we})}class W{constructor($e,ye){this.c=null,this.a={...$e.excludePattern||{},...ye.excludePattern||{}},this.b=y.$Ak(this.a);let Y=$e.includePattern;ye.includePattern&&(Y?Y={...Y,...ye.includePattern}:Y=ye.includePattern),Y&&(this.c=y.$Ak(Y))}matchesExcludesSync($e,ye,Y){return!!(this.b&&this.b($e,ye,Y))}includedInQuerySync($e,ye,Y){return!(this.b&&this.b($e,ye,Y)||this.c&&!this.c($e,ye,Y))}includedInQuery($e,ye,Y){const we=this.b($e,ye,Y),Te=()=>this.c?!!this.c($e,ye,Y):!0;return(0,E.$sh)(we)?we.then(re=>re?!1:Te()):Te()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$_L=W;function Z(de){for(const $e in de)if(typeof de[$e]!="boolean")return!0;return!1}function he(de){if(!de)return;let $e;return ye=>($e||($e=(de()||Promise.resolve([])).then(Y=>Y?be(Y):{})),$e.then(Y=>!!Y[ye]))}function ve(de){if(!de)return;let $e;return ye=>{if(!$e){const Y=de();$e=Y?be(Y):{}}return!!$e[ye]}}function be(de){const $e={};for(const ye of de)$e[ye]=!0;return $e}}),define(Ie[45],Pe([1,0,18,11,22,6,4,59,16,139,24,13,2,192,30,3,12,214,50,51,27,17,8,7,66,44,5,49]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l,g,m,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=e.$Soc=void 0;function D(K,J,z){return new I.$9g(A=>p(A,z)).isEqual(K,J)}function b(K,J,z){return D(K.uri,J.uri,z)?0:(0,E.$Af)(K.uri.toString(),J.uri.toString())}function T(K,J,z){return K.index!==J.index?K.index<J.index?-1:1:D(K.uri,J.uri,z)?(0,E.$Af)(K.name,J.name):(0,E.$Af)(K.uri.toString(),J.uri.toString())}function P(K,J,z,A){const W=K.slice(0).sort((he,ve)=>z(he,ve,A)),Z=J.slice(0).sort((he,ve)=>z(he,ve,A));return(0,w.$Hb)(W,Z,(he,ve)=>z(he,ve,A))}function p(K,J){const z=J.getCapabilities(K.scheme);return!(z&&z&d.FileSystemProviderCapabilities.PathCaseSensitive)}class f extends h.$Zi{static toExtHostWorkspace(J,z,A,W){if(!J)return{workspace:null,added:[],removed:[]};const{id:Z,name:he,folders:ve,configuration:be,transient:de,isUntitled:$e}=J,ye=[],Y=z;z?ve.forEach((q,ae)=>{const le=u.URI.revive(q.uri),ne=f.o(A||z,le,W);ne?(ne.name=q.name,ne.index=q.index,ye.push(ne)):ye.push({uri:le,name:q.name,index:ae})}):ye.push(...ve.map(({uri:q,name:ae,index:le})=>({uri:u.URI.revive(q),name:ae,index:le}))),ye.sort((q,ae)=>q.index<ae.index?-1:1);const we=new f(Z,he,ye,!!de,be?u.URI.revive(be):null,!!$e,q=>p(q,W)),{added:Te,removed:re}=P(Y?Y.workspaceFolders:[],we.workspaceFolders,b,W);return{workspace:we,added:Te,removed:re}}static o(J,z,A){for(let W=0;W<J.folders.length;W++){const Z=J.workspaceFolders[W];if(D(Z.uri,z,A))return Z}}constructor(J,z,A,W,Z,he,ve){super(J,A.map(be=>new h.$1i(be)),W,Z,ve),this.t=z,this.u=he,this.q=[],this.s=N.$Mi.forUris(ve,()=>!0),A.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(J,z){return z&&this.s.get(J)&&(J=(0,I.$gh)(J)),this.s.findSubstr(J)}resolveWorkspaceFolder(J){return this.s.get(J)}}let M=class{constructor(J,z,A,W,Z){this.c=new O.$ne,this.onDidChangeWorkspace=this.c.event,this.g=new O.$ne,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$pe,this.C=new Map,this.h=W,this.s=A,this.t=Z,this.j=new s.$Nm,this.k=new y.$Fh,this.o=J.getProxy($.$vN.MainThreadWorkspace),this.q=J.getProxy($.$vN.MainThreadMessageService);const he=z.workspace;this.l=he?new f(he.id,he.name,[],!!he.transient,he.configuration?u.URI.revive(he.configuration):null,!!he.isUntitled,ve=>p(ve,A)):void 0}$initializeWorkspace(J,z){this.v=z,this.$acceptWorkspaceData(J),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:v.Schemas.untitled,path:(0,I.$eh)((0,I.$gh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(J,z,A,...W){const Z=[];if(Array.isArray(W)&&W.forEach($e=>{u.URI.isUri($e.uri)&&!Z.some(ye=>D(ye.uri,$e.uri,this.s))&&Z.push({uri:$e.uri,name:$e.name||(0,I.$dh)($e.uri)})}),this.n||[z,A].some($e=>typeof $e!="number"||$e<0)||A===0&&Z.length===0)return!1;const he=this.x?this.x.workspaceFolders:[];if(z+A>he.length)return!1;const ve=he.slice(0);ve.splice(z,A,...Z.map($e=>({uri:$e.uri,name:$e.name||(0,I.$dh)($e.uri),index:void 0})));for(let $e=0;$e<ve.length;$e++){const ye=ve[$e];if(ve.some((Y,we)=>we!==$e&&D(ye.uri,Y.uri,this.s)))return!1}ve.forEach(($e,ye)=>$e.index=ye);const{added:be,removed:de}=P(he,ve,T,this.s);if(be.length===0&&de.length===0)return!1;if(this.o){const $e=J.displayName||J.name;this.o.$updateWorkspaceFolders($e,z,A,Z).then(void 0,ye=>{this.n=void 0;const Y={source:{identifier:J.identifier,label:J.displayName||J.name}};this.q.$showMessage(c.Severity.Error,(0,C.localize)(0,null,$e,ye.toString()),Y,[])})}return this.y(ve),!0}getWorkspaceFolder(J,z){if(this.x)return this.x.getWorkspaceFolder(J,z)}async getWorkspaceFolder2(J,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(J,z)}async resolveWorkspaceFolder(J){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(J)}getPath(){if(!this.x)return;const{folders:J}=this.x;if(J.length!==0)return J[0].uri.fsPath}getRelativePath(J,z){let A,W="";if(typeof J=="string"?(A=u.URI.file(J),W=J):typeof J<"u"&&(A=J,W=J.fsPath),!A)return W;const Z=this.getWorkspaceFolder(A,!0);if(!Z)return W;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let he=(0,I.$jh)(Z.uri,A);return z&&Z.name&&(he=`${Z.name}/${he}`),he}y(J){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:J,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(J){const{workspace:z,added:A,removed:W}=f.toExtHostWorkspace(J,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:W}))}findFiles(J,z,A,W,Z=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let he="",ve=!0;return z===null?ve=!1:z!==void 0&&(typeof z=="string"?he=z:he=z.pattern),this.z(J,void 0,{exclude:he,maxResults:A,useDefaultExcludes:ve,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Z)}findFiles2(J,z={},A,W=k.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,J,z,W)}async z(J,z,A,W=k.CancellationToken.None){if(W&&W.isCancellationRequested)return Promise.resolve([]);const Z=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,he={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:Z,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ve;if(J){const{includePattern:be,folder:de}=L(a.GlobPattern.from(J));ve=de,he.includePattern=be}else{const{includePattern:be,folder:de}=L(a.GlobPattern.from(z));ve=de,he.filePattern=be}return this.o.$startFileSearch(ve??null,he,W).then(be=>Array.isArray(be)?be.map(de=>u.URI.revive(de)):[])}async findTextInFiles(J,z,A,W,Z=k.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const he=this.j.getNext(),ve=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:be,folder:de}=L(a.GlobPattern.from(z.include)),$e=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ye={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:ve,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:be,excludePattern:$e},Y=!1;if(this.u[he]=we=>{if(Y)return;const Te=u.URI.revive(we.resource);we.results.forEach(re=>{const q=(0,S.$di)(re);(0,m.$TL)(q)?A({uri:Te,preview:{text:q.preview.text,matches:(0,w.$4b)(q.preview.matches,ae=>new l.$zN(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))},ranges:(0,w.$4b)(q.ranges,ae=>new l.$zN(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))}):A({uri:Te,text:q.text,lineNumber:q.lineNumber})})},Z.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(J,de??null,ye,he,Z);return delete this.u[he],we||{}}catch(we){throw delete this.u[he],we}}$handleTextSearchResult(J,z){this.u[z]?.(J)}async save(J){const z=await this.o.$save(J,{saveAs:!1});return u.URI.revive(z)}async saveAs(J){const z=await this.o.$save(J,{saveAs:!0});return u.URI.revive(z)}saveAll(J){return this.o.$saveAll(J)}resolveProxy(J){return this.o.$resolveProxy(J)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(J){return this.o.$requestWorkspaceTrust(J)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(J,z){if(this.w.has(J))throw new Error(`A provider has already been registered for scheme ${J}`);this.w.set(J,z);const A=this.t.transformOutgoingScheme(J),W=this.A++;return this.o.$registerEditSessionIdentityProvider(W,A),(0,R.$Vc)(()=>{this.w.delete(J),this.o.$unregisterEditSessionIdentityProvider(W)})}async $getEditSessionIdentifier(J,z){this.h.info("Getting edit session identifier for workspaceFolder",J);const A=await this.resolveWorkspaceFolder(u.URI.revive(J));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const W=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!W),!W)return;const Z=await W.provideEditSessionIdentity(A,z);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(J,z,A,W){this.h.info("Getting edit session identifier for workspaceFolder",J);const Z=await this.resolveWorkspaceFolder(u.URI.revive(J));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const he=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!he),!he)return;const ve=await he.provideEditSessionIdentityMatch?.(z,A,W);if(this.h.info("Provider returned edit session identifier match result: ",ve),!!ve)return ve}getOnWillCreateEditSessionIdentityEvent(J){return(z,A,W)=>{const Z=function(ve){z.call(A,ve)};return Z.extension=J,this.B.event(Z,void 0,W)}}async $onWillCreateEditSessionIdentity(J,z,A){const W=await this.resolveWorkspaceFolder(u.URI.revive(J));if(W===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:W},z,async(Z,he)=>{const ve=Date.now();await Promise.resolve(Z),Date.now()-ve>A&&this.h.warn("SLOW edit session create-participant",he.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(J,z){if(this.C.has(J))throw new Error(`A provider has already been registered for scheme ${J}`);this.C.set(J,z);const A=this.t.transformOutgoingScheme(J),W=this.A++;return this.o.$registerCanonicalUriProvider(W,A),(0,R.$Vc)(()=>{this.C.delete(J),this.o.$unregisterCanonicalUriProvider(W)})}async provideCanonicalUri(J,z,A){const W=this.C.get(J.scheme);if(!W)return;const Z=await W.provideCanonicalUri?.(u.URI.revive(J),z,A);if(Z)return Z}async $provideCanonicalUri(J,z,A){return this.provideCanonicalUri(u.URI.revive(J),{targetScheme:z},A)}};e.$Soc=M,e.$Soc=M=He([Ge(0,t.$2P),Ge(1,r.$fQ),Ge(2,i.$Boc),Ge(3,o.$ak),Ge(4,g.$Qoc)],M),e.$Toc=(0,n.$Gi)("IExtHostWorkspace");function L(K){let J,z;return K&&(typeof K=="string"?J=K:(J=K.pattern,z=u.URI.revive(K.baseUri))),{includePattern:J,folder:z}}}),define(Ie[46],Pe([1,0,26,6,45,5,7,43,215,54,15,11,3,17,12,2]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=e.$Voc=e.$Uoc=void 0;function o(g,m){if(m){const $=m.split(".");let S=g;for(let D=0;S&&D<$.length;D++)S=S[$[D]];return S}}function c(g){return g instanceof n.URI}function h(g){return g&&g.uri instanceof n.URI&&g.languageId&&typeof g.languageId=="string"}function i(g){return g&&!g.uri&&g.languageId&&typeof g.languageId=="string"}function r(g){return g&&g.uri instanceof n.URI&&(!g.name||typeof g.name=="string")&&(!g.index||typeof g.index=="number")}function t(g){if(c(g))return{resource:g};if(h(g))return{resource:g.uri,overrideIdentifier:g.languageId};if(i(g))return{overrideIdentifier:g.languageId};if(r(g))return{resource:g.uri};if(g===null)return{resource:null}}let a=class{constructor(m,$,S){this.a=m.getProxy(O.$vN.MainThreadConfiguration),this.c=$,this.b=S,this.d=new E.$Fh,this.e=null}getConfigProvider(){return this.d.wait().then(m=>this.e)}$initializeConfiguration(m){this.e=new l(this.a,this.c,m,this.b),this.d.open()}$acceptConfigurationChanged(m,$){this.getConfigProvider().then(S=>S.$acceptConfigurationChanged(m,$))}};e.$Uoc=a,e.$Uoc=a=He([Ge(0,C.$2P),Ge(1,k.$Toc),Ge(2,d.$ak)],a);class l{constructor(m,$,S,D){this.a=new y.$ne,this.b=m,this.f=D,this.c=$,this.e=v.$Qo.parse(S,D),this.d=this.k(S.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(m,$){const S={data:this.e.toData(),workspace:this.c.workspace};this.e=v.$Qo.parse(m,this.f),this.d=this.k(m.configurationScopes),this.a.fire(this.j($,S))}getConfiguration(m,$,S){const D=t($)||{},b=this.g(m?o(this.e.getValue(void 0,D,this.c.workspace),m):this.e.getValue(void 0,D,this.c.workspace));m&&this.h(m,D,S?.identifier);function T(p){if(p==null)return null;if(typeof p=="boolean")return p?N.ConfigurationTarget.USER:N.ConfigurationTarget.WORKSPACE;switch(p){case R.ConfigurationTarget.Global:return N.ConfigurationTarget.USER;case R.ConfigurationTarget.Workspace:return N.ConfigurationTarget.WORKSPACE;case R.ConfigurationTarget.WorkspaceFolder:return N.ConfigurationTarget.WORKSPACE_FOLDER}}const P={has(p){return typeof o(b,p)<"u"},get:(p,f)=>{this.h(m?`${m}.${p}`:p,D,S?.identifier);let M=o(b,p);if(typeof M>"u")M=f;else{let L;const K=(J,z)=>{if((0,I.$ig)(J)){let A;const W=()=>{L=L||(0,w.$fo)(b),A=A||o(L,z)};return new Proxy(J,{get:(Z,he)=>{if(typeof he=="string"&&he.toLowerCase()==="tojson")return W(),()=>A;if(L)return A=A||o(L,z),A[he];const ve=Z[he];return typeof he=="string"?K(ve,`${z}.${he}`):ve},set:(Z,he,ve)=>(W(),A&&(A[he]=ve),!0),deleteProperty:(Z,he)=>(W(),A&&delete A[he],!0),defineProperty:(Z,he,ve)=>(W(),A&&Object.defineProperty(A,he,ve),!0)})}return Array.isArray(J)?(0,w.$fo)(J):J};M=K(M,p)}return M},update:(p,f,M,L)=>{p=m?`${m}.${p}`:p;const K=T(M);return f!==void 0?this.b.$updateConfigurationOption(K,p,f,D,L):this.b.$removeConfigurationOption(K,p,D,L)},inspect:p=>{p=m?`${m}.${p}`:p;const f=this.e.inspect(p,D,this.c.workspace);if(f)return{key:p,defaultValue:(0,w.$fo)(f.policy?.value??f.default?.value),globalValue:(0,w.$fo)(f.user?.value??f.application?.value),workspaceValue:(0,w.$fo)(f.workspace?.value),workspaceFolderValue:(0,w.$fo)(f.workspaceFolder?.value),defaultLanguageValue:(0,w.$fo)(f.default?.override),globalLanguageValue:(0,w.$fo)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,w.$fo)(f.workspace?.override),workspaceFolderLanguageValue:(0,w.$fo)(f.workspaceFolder?.override),languageIds:(0,w.$fo)(f.overrideIdentifiers)}}};return typeof b=="object"&&(0,w.$io)(P,b,!1),Object.freeze(P)}g(m){const $=S=>(0,I.$ig)(S)?new Proxy(S,{get:(D,b)=>$(D[b]),set:(D,b,T)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(D,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(D,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):S;return $(m)}h(m,$,S){const D=s.$Ho.test(m)?s.ConfigurationScope.RESOURCE:this.d.get(m),b=S?`[${S.value}] `:"";if(s.ConfigurationScope.RESOURCE===D){typeof $?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(s.ConfigurationScope.WINDOW===D){$?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(m,$){const S=new v.$So(m,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,b)=>S.affectsConfiguration(D,t(b))})}k(m){return m.reduce(($,S)=>($.set(S[0],S[1]),$),new Map)}}e.$Voc=l,e.$Woc=(0,u.$Gi)("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[131],Pe([1,0,2,11,6,5,7,45,58,46,22,57,17,27,3,16,21,12,85,251,14]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=e.$tqc=e.$sqc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,R=Ve(R),o=Ve(o);var a;(function(K){function J(A){if(A!=null)return A}K.from=J;function z(A){if(A!=null)return A}K.to=z})(a||(a={}));var l;(function(K){function J(A){if(A!=null)return A}K.from=J;function z(A){if(A!=null)return A}K.to=z})(l||(l={}));var g;(function(K){function J(A){if(A!=null)return A}K.from=J;function z(A){if(A!=null)return A}K.to=z})(g||(g={}));var m;(function(K){function J(W){if(W){const Z=W;return Z&&!!Z.process}else return!1}K.is=J;function z(W){if(W==null)return;const Z={process:W.process,args:W.args};return W.options&&(Z.options=g.from(W.options)),Z}K.from=z;function A(W){if(W!=null)return new R.$hO(W.process,W.args,W.options)}K.to=A})(m||(m={}));var $;(function(K){function J(A){if(A!=null)return A}K.from=J;function z(A){if(A!=null)return A}K.to=z})($||($={}));var S;(function(K){function J(W){if(W){const Z=W;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}K.is=J;function z(W){if(W==null)return;const Z={};return W.commandLine!==void 0?Z.commandLine=W.commandLine:(Z.command=W.command,Z.args=W.args),W.options&&(Z.options=$.from(W.options)),Z}K.from=z;function A(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new R.$iO(W.commandLine,W.options):new R.$iO(W.command,W.args?W.args:[],W.options)}K.to=A})(S||(S={}));var D;(function(K){function J(W){if(W){const Z=W;return Z&&Z.customExecution==="customExecution"}else return!1}K.is=J;function z(W){return{customExecution:"customExecution"}}K.from=z;function A(W,Z){return Z.get(W)}K.to=A})(D||(e.CustomExecutionDTO=D={}));var b;(function(K){function J(z,A){let W;return z.scope!==void 0&&typeof z.scope!="number"?W=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&A&&A.workspaceFile?W=A.workspaceFile:W=i.$JI),{id:z._id,workspaceFolder:W}}K.from=J})(b||(e.TaskHandleDTO=b={}));var T;(function(K){function J(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}K.from=J})(T||(T={}));var P;(function(K){function J(W,Z){if(W==null)return[];const he=[];for(const ve of W){const be=z(ve,Z);be&&he.push(be)}return he}K.fromMany=J;function z(W,Z){if(W==null)return;let he;W.execution instanceof R.$hO?he=m.from(W.execution):W.execution instanceof R.$iO?he=S.from(W.execution):W.execution&&W.execution instanceof R.$jO&&(he=D.from(W.execution));const ve=a.from(W.definition);let be;return W.scope?typeof W.scope=="number"?be=W.scope:be=W.scope.uri:be=R.TaskScope.Workspace,!ve||!be?void 0:{_id:W._id,definition:ve,name:W.name,source:{extensionId:Z.identifier.value,label:W.source,scope:be},execution:he,isBackground:W.isBackground,group:T.from(W.group),presentationOptions:l.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}K.from=z;async function A(W,Z,he){if(W==null)return;let ve;m.is(W.execution)?ve=m.to(W.execution):S.is(W.execution)?ve=S.to(W.execution):D.is(W.execution)&&(ve=D.to(W._id,he));const be=a.to(W.definition);let de;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?de=W.source.scope:de=await Z.resolveWorkspaceFolder(w.URI.revive(W.source.scope)):de=R.TaskScope.Workspace),!be||!de)return;const $e=new R.$kO(be,de,W.name,W.source.label,ve,W.problemMatchers);return W.isBackground!==void 0&&($e.isBackground=W.isBackground),W.group!==void 0&&($e.group=R.$gO.from(W.group._id),$e.group&&W.group.isDefault&&($e.group=new R.$gO($e.group.id,$e.group.label),W.group.isDefault===!0&&($e.group.isDefault=W.group.isDefault))),W.presentationOptions&&($e.presentationOptions=l.to(W.presentationOptions)),W._id&&($e._id=W._id),W.detail&&($e.detail=W.detail),$e}K.to=A})(P||(e.TaskDTO=P={}));var p;(function(K){function J(A){return A}K.from=J;function z(A){if(A)return Object.assign(Object.create(null),A)}K.to=z})(p||(p={}));class f{constructor(J,z,A){this._id=z,this.a=A,t.set(this,void 0),rt(this,t,J,"f")}get task(){return this.a}terminate(){ze(this,t,"f").terminateTask(this)}fireDidStartProcess(J){}fireDidEndProcess(J){}}t=new WeakMap;let M=class{constructor(J,z,A,W,Z,he,ve,be){this.q=new k.$ne,this.r=new k.$ne,this.s=new k.$ne,this.u=new k.$ne,this.a=J.getProxy(O.$vN.MainThreadTask),this.b=A,this.c=W,this.d=Z,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ve,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(J,z,A){if(!A)return new R.$xN(()=>{});const W=this.x();return this.j.set(W,{type:z,provider:A,extension:J}),this.a.$registerTaskProvider(W,z),new R.$xN(()=>{this.j.delete(W),this.a.$unregisterTaskProvider(W)})}registerTaskSystem(J,z){this.a.$registerTaskSystem(J,z)}fetchTasks(J){return this.a.$fetchTasks(p.from(J)).then(async z=>{const A=[];for(const W of z){const Z=await P.to(W,this.b,this.m);Z&&A.push(Z)}return A})}get taskExecutions(){const J=[];return this.k.forEach(z=>J.push(z)),J}terminateTask(J){if(!(J instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(J._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(J,z,A){const W=this.m.get(J.id);W&&(this.o.set(J.id,W),this.e.attachPtyToTerminal(z,await W.callback(A))),this.p=J.id,this.q.fire({execution:await this.z(J)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(J){if(!this.l.has(J.id))return;const z=await this.z(J);this.l.delete(J.id),this.k.delete(J.id),this.B(J),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(J){const z=await this.z(J.id);this.s.fire({execution:z,processId:J.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(J){const z=await this.z(J.id);this.u.fire({execution:z,exitCode:J.exitCode})}$provideTasks(J,z){const A=this.j.get(J);if(!A)return Promise.reject(new Error("no handler found"));const W=[],Z=(0,y.$yh)(()=>A.provider.provideTasks(I.CancellationToken.None)).then(he=>this.v(z,W,A,he));return new Promise(he=>{Z.then(ve=>{Promise.all(W).then(()=>{he(ve)})})})}async $resolveTask(J,z){const A=this.j.get(J);if(!A)return Promise.reject(new Error("no handler found"));if(z.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${A.type}].`);const W=await P.to(z,this.b,this.m);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const Z=await A.provider.resolveTask(W,I.CancellationToken.None);if(!Z)return;this.A(Z,A);const he=P.from(Z,A.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(he.execution)&&await this.y(he,Z,!0),await this.w(he)}x(){return this.h++}async y(J,z,A){const W=await this.a.$createTaskId(J);!A&&!this.m.has(W)&&(this.n.add(W),this.o.set(W,z.execution)),this.m.set(W,z.execution)}async z(J,z){if(typeof J=="string"){const Z=this.l.get(J);if(!Z)throw new r.$eb("Unexpected: The specified task is missing an execution");return Z}const A=this.l.get(J.id);if(A)return A;let W;return z?W=Promise.resolve(new f(this,J.id,z)):W=P.to(J.task,this.b,this.m).then(Z=>{if(!Z)throw new r.$eb("Unexpected: Task does not exist.");return new f(this,J.id,Z)}),this.l.set(J.id,W),W.then(Z=>(this.k.set(J.id,Z),Z))}A(J,z){J._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(J){this.o.get(J.id)&&this.o.delete(J.id),this.n.has(J.id)&&this.p!==J.id&&(this.m.delete(J.id),this.n.delete(J.id));const A=this.n.values();let W=A.next();for(;!W.done;)!this.o.has(W.value)&&this.p!==W.value&&(this.m.delete(W.value),this.n.delete(W.value)),W=A.next()}};e.$sqc=M,e.$sqc=M=He([Ge(0,u.$2P),Ge(1,C.$fQ),Ge(2,N.$Toc),Ge(3,v.$aQ),Ge(4,s.$Woc),Ge(5,E.$ipc),Ge(6,c.$ak),Ge(7,h.$xoc)],M);let L=class extends M{constructor(J,z,A,W,Z,he,ve,be){super(J,z,A,W,Z,he,ve,be),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$b(o.Platform.Web)})}async executeTask(J,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const A=P.from(z,J);if(A===void 0)throw new Error("Task is not valid");if(D.is(A.execution))await this.y(A,z,!1);else throw new r.$cb;const W=await this.z(await this.a.$getTaskExecution(A),z);return this.a.$executeTask(A).catch(Z=>{throw new Error(Z)}),W}v(J,z,A,W){const Z=[];if(W)for(const he of W){if(this.A(he,A),!he.definition||!J[he.definition.type]){const be=he.source?he.source:"No task source";this.f.warn(`The task [${be}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`)}const ve=P.from(he,A.extension);ve&&D.is(ve.execution)?(Z.push(ve),z.push(this.y(ve,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:A.extension}}async w(J){if(D.is(J.execution))return J;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(J,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(J,z,A){}};e.$tqc=L,e.$tqc=L=He([Ge(0,u.$2P),Ge(1,C.$fQ),Ge(2,N.$Toc),Ge(3,v.$aQ),Ge(4,s.$Woc),Ge(5,E.$ipc),Ge(6,c.$ak),Ge(7,h.$xoc)],L),e.$uqc=(0,d.$Gi)("IExtHostTask")}),define(Ie[310],Pe([1,0,44,33]),function(_,e,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=void 0,e.$hM=k,e.$jM=O;function k(R){return"cellResults"in R}e.$iM="rawCell#";function O(R,N){let v=-1;const s=[];let I=[];return R.forEach(u=>{u.range.startLineNumber!==v&&I.length>0&&(s.push([...I]),I=[]),I.push(u),v=u.range.endLineNumber}),I.length>0&&s.push([...I]),s.map(u=>{const C=[],d=u[0].range.startLineNumber,n=u[u.length-1].range.endLineNumber;for(let o=d;o<=n;o++)C.push(N.getLineContent(o));return new w.$XL(C.join(`
`)+`
`,u.map(o=>new y.$Nt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ie[311],Pe([1,0,186,23,6,4,29,37,13,15,2,30,80,5,34,8,7,39,288,124,26,16,44,241,310,308]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=void 0,E=Ve(E),n=Ve(n),o=Ve(o);class ${get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,b,T,P,p,f,M){this.q=T,this.r=P,this.s=p,this.t=f,this.u=M,this.f=new Map,this.g=new R.$Dc,this.h=new Map,this.j=new k.$ne,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new k.$ne,this.onDidOpenNotebookDocument=this.m.event,this.n=new k.$ne,this.onDidCloseNotebookDocument=this.n.event,this.o=new k.$ne,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$voc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(C.$vN.MainThreadNotebook),this.c=D.getProxy(C.$vN.MainThreadNotebookDocuments),this.d=D.getProxy(C.$vN.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===N.MarshalledId.NotebookCellActionContext){const K=L.notebookEditor?.notebookUri,J=L.cell.handle,A=this.g.get(K)?.getCell(J);if(A)return A.apiCell}if(L&&L.$mid===N.MarshalledId.NotebookActionContext){const K=L.uri,J=this.g.get(K);if(J)return J.apiNotebook}return L}}),$.C(b)}getEditorById(D){const b=this.h.get(D);if(!b)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(D){for(const[b,T]of this.h)if(T.apiEditor===D)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,b){const T=this.g.get(D);if(!T&&!b)throw new Error(`NO notebook document for '${D}'`);return T}static w(D,b){if(!b)return;const T=b.filenamePattern.map(P=>n.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(b.filenamePattern&&!T){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:b.displayName,filenamePattern:T,priority:b.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,b,T){const P=$.a++,p=typeof T.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(P,T),this.b.$registerNotebookCellStatusBarItemProvider(P,p,b);let f;return p!==void 0&&(f=T.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(p))),new o.$xN(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,p),f?.dispose()})}async createNotebookDocument(D){const b=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&n.NotebookData.from(D.content)});return I.URI.revive(b)}async openNotebookDocument(D){const b=this.g.get(D);if(b)return b.apiNotebook;const T=await this.c.$tryOpenNotebook(D),P=this.g.get(I.URI.revive(T));return(0,s.$rg)(P?.apiNotebook)}async showNotebookDocument(D,b){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let T;typeof b=="object"?T={position:n.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(n.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:T={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,T),p=P&&this.h.get(P)?.apiEditor;if(p)return p;throw P?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,b,T,P){const p=this.f.get(D),f=I.URI.revive(b),M=this.g.get(f);if(!M||!p)return;const L=M.getCellFromIndex(T);if(!L)return;const K=await p.provideCellStatusBarItems(L.apiCell,P);if(!K)return;const J=new O.$Wc,z=this.p.add([J]),W=(Array.isArray(K)?K:[K]).map(Z=>n.NotebookStatusBarItem.from(Z,this.i,J));return{cacheId:z,items:W}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,b,T,P,p){if((0,v.$ef)(b))throw new Error("viewType cannot be empty or just whitespace");const f=this.x++;return this.y.set(f,{viewType:b,serializer:T,options:P}),this.b.$registerNotebookSerializer(f,{id:D.identifier,location:D.extensionLocation},b,n.NotebookDocumentContentOptions.from(P),$.w(D,p)),(0,O.$Vc)(()=>{this.b.$unregisterNotebookSerializer(f)})}async $dataToNotebook(D,b,T){const P=this.y.get(D);if(!P)throw new Error("NO serializer found");const p=await P.serializer.deserializeNotebook(b.buffer,T);return new c.$Vw(n.NotebookData.from(p))}async $notebookToData(D,b,T){const P=this.y.get(D);if(!P)throw new Error("NO serializer found");const p=await P.serializer.serializeNotebook(n.NotebookData.to(b.value),T);return y.$Pe.wrap(p)}async $saveNotebook(D,b,T,P,p){const f=I.URI.revive(b),M=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${T}, ${f.toString()})`),!M)throw new Error("NO serializer found");const L=this.g.get(f);if(!L)throw new Error("Document NOT found");if(L.versionId!==T)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(f.scheme))throw new E.$vl((0,w.localize)(0,null,this.A(f)),E.FileOperationResult.FILE_PERMISSION_DENIED);const K={metadata:(0,r.$no)(L.apiNotebook.metadata,Z=>!(M.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of L.apiNotebook.getCells()){const he=new o.$1O(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,M.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);he.metadata=(0,r.$no)(Z.metadata,ve=>!(M.options?.transientCellMetadata??{})[ve]),K.cells.push(he)}if(await this.z(f,P),p.isCancellationRequested)throw new Error("canceled");const J=await M.serializer.serializeNotebook(K,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${T} ${f.toString()}`),await this.s.value.writeFile(f,J),this.D(`Finished write versionId: ${T} ${f.toString()}`);const z=this.s.getFileSystemProviderExtUri(f.scheme),A=await this.s.value.stat(f),W={name:z.basename(f),isFile:(A.type&E.FileType.File)!==0,isDirectory:(A.type&E.FileType.Directory)!==0,isSymbolicLink:(A.type&E.FileType.SymbolicLink)!==0,mtime:A.mtime,ctime:A.ctime,size:A.size,readonly:!!((A.permissions??0)&E.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(f.scheme),locked:!!((A.permissions??0)&E.FilePermission.Locked),etag:E.$Gl({mtime:A.mtime,size:A.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${T}, ${f.toString()})`),W}async $searchInNotebooks(D,b,T,P,p){const f=this.y.get(D)?.serializer;if(!f)return{limitHit:!1,results:[]};const M=new R.$Ec;await(async(A,W,Z)=>{await Promise.all(A.map(async he=>await Promise.all(he.filenamePatterns.map(ve=>{const be={_reason:Z._reason,folderQueries:Z.folderQueries,includePattern:Z.includePattern,excludePattern:Z.excludePattern,maxResults:Z.maxResults,type:a.QueryType.File,filePattern:ve};return this.t.doInternalFileSearchWithCustomCallback(be,W,de=>{de.forEach($e=>{M.has($e)||P.some(Y=>he.isFromSettings&&!Y.isFromSettings?!1:Y.filenamePatterns.some(we=>(0,m.$eL)(we,$e)))||M.add($e)})}).catch(de=>{if(de.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw de})}))))})(T,p,b);const K=new R.$Dc;let J=!1;const z=Array.from(M).map(async A=>{const W=[];try{if(p.isCancellationRequested)return;if(b.maxResults&&[...K.values()].reduce((be,de)=>be+de.cellResults.length,0)>b.maxResults){J=!0;return}const Z=[],he=this.g.get(A);if(he)he.apiNotebook.getCells().forEach(de=>Z.push({input:de.document.getText(),outputs:de.outputs.flatMap($e=>$e.items.map(ye=>ye.data.toString()))}));else{const be=await this.s.value.readFile(A),de=y.$Pe.fromString(be.toString()),$e=await f.deserializeNotebook(de.buffer,p);if(p.isCancellationRequested)return;n.NotebookData.from($e).cells.forEach(Y=>Z.push({input:Y.source,outputs:Y.outputs.flatMap(we=>we.items.map(Te=>Te.valueBytes.toString()))}))}if(p.isCancellationRequested)return;Z.forEach((be,de)=>{const $e=b.contentPattern.pattern,ye=new l.$LZb(be.input,void 0,be.outputs),Y=ye.findInInputs($e),we=ye.findInOutputs($e),Te=we.flatMap(re=>(0,g.$jM)(re.matches,re.textBuffer)).map((re,q)=>(re.webviewIndex=q,re));if(Y.length>0||we.length>0){const re={index:de,contentResults:(0,g.$jM)(Y,ye.inputTextBuffer),webviewResults:Te};W.push(re)}});const ve={resource:A,cellResults:W};K.set(A,ve);return}catch{return}});return await Promise.all(z),{limitHit:J,results:[...K.values()]}}async z(D,b){const T=await this.s.value.stat(D);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==E.$Fl&&typeof T.mtime=="number"&&typeof T.size=="number"&&b.mtime<T.mtime&&b.etag!==E.$Gl({mtime:b.mtime,size:T.size}))throw new E.$vl((0,w.localize)(1,null),E.FileOperationResult.FILE_MODIFIED_SINCE,b)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,b,T){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const P=new i.$Xpc(b,this.d,D,T.visibleRanges.map(n.NotebookRange.to),T.selections.map(n.NotebookRange.to),typeof T.viewColumn=="number"?n.ViewColumn.to(T.viewColumn):void 0);this.h.set(b,P)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const T of D.value.removedDocuments){const P=I.URI.revive(T),p=this.g.get(P);p&&(p.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(f=>f.document.uri)}),this.n.fire(p.apiNotebook));for(const f of this.h.values())f.notebookData.uri.toString()===P.toString()&&this.h.delete(f.id)}if(D.value.addedDocuments){const T=[];for(const P of D.value.addedDocuments){const p=I.URI.revive(P.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const f=new h.$Wpc(this.c,this.q,this.r,p,P);T.push(...P.cells.map(M=>h.$Vpc.asModelAddData(M))),this.g.get(p)?.dispose(),this.g.set(p,f),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:T}),this.m.fire(f.apiNotebook)}}if(D.value.addedEditors)for(const T of D.value.addedEditors){if(this.h.has(T.id))return;const P=I.URI.revive(T.documentUri),p=this.g.get(P);p&&this.B(p,T.id,T)}const b=[];if(D.value.removedEditors)for(const T of D.value.removedEditors){const P=this.h.get(T);P&&(this.h.delete(T),this.k?.id===P.id&&(this.k=void 0),b.push(P))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const T=new Set;this.l.forEach(P=>T.add(P.id));for(const P of this.h.values()){const p=T.has(P.id);P._acceptVisibility(p)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const b=d.$nQ.String.with("notebookType","A notebook type"),T=new d.$pQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new d.$nQ("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>y.$Pe.wrap(p))],new d.$oQ("Notebook Data",p=>n.NotebookData.to(p.value))),P=new d.$pQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new d.$nQ("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new c.$Vw(n.NotebookData.from(p)))],new d.$oQ("Bytes",p=>p.buffer));D.registerApiCommand(T),D.registerApiCommand(P)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$7pc=$,$.a=0}),define(Ie[312],Pe([1,0,20,22,42,41,24,70,44]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0,w=Ve(w),O=Ve(O),R=Ve(R);class s{constructor(u,C,d){this.k=u,this.l=C,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$Ak(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$Ak(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const C=this.k.folderQueries||[];return new Promise((d,n)=>{const o=c=>{this.f++,u(c)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const h=c.toString(),i=w.$qc(h);this.j&&this.j(h,i)||this.v(o,{base:c,basename:i})}),Promise.all(C.map(c=>this.p(c,o))).then(c=>{d({limitHit:this.e,stats:c[0]||void 0})},c=>{n(new Error((0,k.$rj)(c)))})})}async p(u,C){const d=new y.$ye,n=this.q(u),o=this.r(),c=new v.$_L(this.k,u),h=!c.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=N.$he.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,d.token),t=i.elapsed(),a=N.$he.create();return this.g&&!this.e||(r&&r.forEach(l=>{const g=w.$jc.relative(u.folder.path,l.path);if(h){const m=w.$qc(l.path);this.v(C,{base:u.folder,relativePath:g,basename:m});return}this.s(o,u.folder,g,C)}),this.g&&!this.e)?null:(this.u(o,c,C),{providerTime:t,postProcessTime:a.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const C=(0,v.$$L)(this.k.includePattern,u.includePattern),d=(0,v.$$L)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:C,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},C,d,n){if(d===this.a){const c=w.$qc(this.a);this.v(n,{base:C,relativePath:this.a,basename:c})}function o(c){const h=w.$qc(c),i=w.$pc(c);let r=u[i];r||(r=u[i]=[],o(i)),r.push({base:C,relativePath:c,basename:h})}o(d)}u({rootEntries:u,pathToEntries:C},d,n){const o=this,c=this.a;function h(i){const r=(0,v.$bM)(()=>i.map(t=>t.basename));for(let t=0,a=i.length;t<a;t++){const l=i[t],{relativePath:g,basename:m}=l;if(d.matchesExcludesSync(g,m,c!==m?r:void 0))continue;const $=C[g];if($)h($);else{if(g===c)continue;o.v(n,l)}if(o.e)break}}h(u)}v(u,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(C))}}class I{constructor(){this.b=new Map}fileSearch(u,C,d,n){const o=this.c(u.cacheKey),c=new s(u,C,o&&o.token);let h=0;const i=r=>{h+=r.length,d(r.map(t=>this.d(t)))};return this.e(c,I.a,i,n).then(r=>({limitHit:r.limitHit,stats:r.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:r.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new y.$ye),this.b.get(u)}d(u){return u.relativePath?{resource:R.$hh(u.base,u.relativePath)}:{resource:u.base}}e(u,C,d,n){const o=n.onCancellationRequested(()=>{u.cancel()}),c=i=>{i&&(h.push(i),C>0&&h.length>=C&&(d(h),h=[]))};let h=[];return u.search(c).then(i=>(h.length&&d(h),o.dispose(),i),i=>(h.length&&d(h),o.dispose(),Promise.reject(i)))}}e.$Ypc=I,I.a=512}),define(Ie[313],Pe([1,0,18,282,41,100,29,16,20,24,13,15,2,103,206,43,12,50,118,309,44]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0,e.$aN=b,w=Ve(w),y=Ve(y),k=Ve(k),v=Ve(v),I=Ve(I),d=Ve(d);let t=class{constructor(P,p,f,M,L){this.a=P,this.b=p,this.c=f,this.d=M,this.e=L}text(P,p,f={}){P=this.f(P,f);const M=this.a.getValue(),L=p&&p.some(J=>!this.a.getValue({resource:J}).search.useRipgrep);return{...this.h(p?.map(c.$2i),f),type:r.QueryType.Text,contentPattern:P,previewOptions:f.previewOptions,maxFileSize:f.maxFileSize,usePCRE2:M.search.usePCRE2||L||!1,beforeContext:f.beforeContext,afterContext:f.afterContext,userDisabledExcludesAndIgnoreFiles:f.disregardExcludeSettings&&f.disregardIgnoreFiles}}f(P,p){const f=this.a.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const M={...P,wordSeparators:f.editor.wordSeparators};return this.j(P,p)&&(M.isCaseSensitive=!0),this.k(P)&&(M.isMultiline=!0),p.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=p.notebookSearchConfig.includeMarkupInput),p.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=p.notebookSearchConfig.includeMarkupPreview),p.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=p.notebookSearchConfig.includeCodeInput),p.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=p.notebookSearchConfig.includeOutput),M}file(P,p={}){return{...this.h(P,p),type:r.QueryType.File,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey,shouldGlobMatchFilePattern:p.shouldGlobSearch}}g(P,p){return P?(P=Array.isArray(P)?P.map($):$(P),p?this.parseSearchPaths(P):{pattern:l(...Array.isArray(P)?P:[P])}):{}}h(P=[],p={}){const f=this.g(p.includePattern,p.expandPatterns),M=this.g(p.excludePattern,p.expandPatterns),L=P.length>1,K=(f.searchPaths&&f.searchPaths.length?f.searchPaths.map(A=>this.q(A,p,M)):P.map(A=>this.r(A,p,M,L))).filter(A=>!!A),J={_reason:p._reason,folderQueries:K,usingSearchPaths:!!(f.searchPaths&&f.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:M.pattern,includePattern:f.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const A=w.$Kb(this.c.groups.flatMap(he=>he.editors.map(ve=>ve.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(A));const W=A.filter(he=>(0,r.$2L)(J,he.fsPath)),Z=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...J,...Z}}const z=p.extraFileResources&&p.extraFileResources.filter(A=>(0,r.$2L)(J,A.fsPath));return J.extraFileResources=z&&z.length?z:void 0,J}i(P){const p=[],f=new R.$Dc,M={};let L=!1;return P.forEach(K=>{if(K.scheme===N.Schemas.walkThrough)return;if((0,s.$lh)(K)){const z=this.b.getWorkspaceFolder(K)?.uri??K.with({path:v.$pc(K.fsPath)});let A=f.get(z);A||(L=!0,A={folder:z,includePattern:{}},p.push(A),f.set(z,A));const W=v.$oc(z.fsPath,K.fsPath);(0,E.$rg)(A.includePattern)[W.replace(/\\/g,"/")]=!0}else K.fsPath&&(L=!0,M[K.fsPath]=!0)}),{folderQueries:p,includePattern:M,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}j(P,p){if(p.isSmartCase){if(P.isRegExp){if(I.$0f(P.pattern,!0))return!0}else if(I.$0f(P.pattern))return!0}return!!P.isCaseSensitive}k(P){return P.isMultiline||P.isRegExp&&(0,C.$cD)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const p=Z=>v.$lc(Z)||/^\.\.?([\/\\]|$)/.test(Z),M=(Array.isArray(P)?P:g(P)).map(Z=>{const he=this.e.resolvedUserHome;return he?(0,O.$1w)(Z,he.scheme===N.Schemas.file?he.fsPath:he.path):Z}),L=y.$E(M,Z=>p(Z)?"searchPaths":"exprSegments"),K=(L.exprSegments||[]).map(Z=>I.$pf(Z,"/")).map(Z=>I.$pf(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),m(Z))),J={},z=this.m(L.searchPaths||[]);z&&z.length&&(J.searchPaths=z);const A=K.flat(),W=l(...A);return W&&(J.pattern=W),J}l(P,p){return p.disregardExcludeSettings?void 0:(0,r.$1L)(P,!p.disregardSearchExcludeSettings)}m(P){if(!P||!P.length)return[];const p=P.flatMap(M=>{let{pathPortion:L,globPortion:K}=a(M);return K&&(K=S(K)),this.n(L).flatMap(z=>this.o(z,K))}),f=new Map;return p.forEach(M=>{const L=M.searchPath.toString(),K=f.get(L);K?M.pattern&&(K.pattern=K.pattern||{},K.pattern[M.pattern]=!0):f.set(L,{searchPath:M.searchPath,pattern:M.pattern?l(M.pattern):void 0})}),Array.from(f.values())}n(P){if(v.$lc(P)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==N.Schemas.file?[{searchPath:p[0].uri.with({path:P})}]:[{searchPath:u.URI.file(v.$kc(P))}]}if(this.b.getWorkbenchState()===c.WorkbenchState.FOLDER){const p=this.b.getWorkspace().folders[0].uri;if(P=$(P),P.startsWith("../")||P===".."){const M=v.$jc.resolve(p.path,P);return[{searchPath:p.with({path:M})}]}const f=S(P);return[{searchPath:p,pattern:f}]}else{if(P==="./"||P===".\\")return[];{const p=P.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(L=>{const K=p.match(new RegExp(`^${I.$jf(L.name)}(?:/(.*)|$)`));return K?{match:K,folder:L}:null}).filter(E.$og);if(M.length)return M.map(L=>{const K=L.match[1];return{searchPath:L.folder.uri,pattern:K&&S(K)}});{const L=P.match(/\.[\/\\](.+)[\/\\]?/),K=L?L[1]:P,J=d.localize(0,null,K);throw new Error(J)}}}}o(P,p){const f=P.pattern&&p?`${P.pattern}/${p}`:P.pattern||p,M=[{searchPath:P.searchPath,pattern:f}];return f&&!f.endsWith("**")&&M.push({searchPath:P.searchPath,pattern:f+"/**"}),M}q(P,p,f){const M=this.r((0,c.$2i)(P.searchPath),p,f,!1);return M?{...M,includePattern:P.pattern}:null}r(P,p,f,M){let L;const K=u.URI.isUri(P)?P:P.uri;if(f.searchPaths){const Z=f.searchPaths.filter(he=>(0,s.$ah)(he.searchPath,K))[0];if(Z&&!Z.pattern)return null;Z&&(L=Z.pattern)}const J=this.a.getValue({resource:K}),A={...this.l(J,p)||{},...L||{}},W=u.URI.isUri(P)?(0,s.$eh)(P):P.name;return{folder:K,folderName:M?W:void 0,excludePattern:Object.keys(A).length>0?A:void 0,fileEncoding:J.files&&J.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!J.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!J.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!J.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!J.search.followSymlinks}}};e.$_M=t,e.$_M=t=He([Ge(0,n.$aj),Ge(1,c.$Pi),Ge(2,h.$kE),Ge(3,o.$ak),Ge(4,i.$0M)],t);function a(T){const P=T.match(/[\*\{\}\(\)\[\]\?]/);if(P){const p=P.index,f=T.substr(0,p).match(/[/|\\][^/\\]*$/);if(f){let M=T.substr(0,f.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:T.substr((f.index||0)+1)}}}return{pathPortion:T}}function l(...T){return T.length?T.reduce((P,p)=>(P[p]=!0,P),Object.create(null)):void 0}function g(T){return k.$yk(T,",").map(P=>P.trim()).filter(P=>!!P.length)}function m(T){return[`**/${T}/**`,`**/${T}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function $(T){return T.replace(/\\/g,"/")}function S(T){return $(T).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(T){return T.replace(/([?*[\]])/g,"[$1]")}function b(T,P){T=w.$Pb(T,M=>M.toString());const p=[],f=P.getWorkspace();return T&&T.forEach(M=>{let L;if(P.getWorkbenchState()===c.WorkbenchState.FOLDER)L=(0,s.$jh)(f.folders[0].uri,M),L&&L!=="."&&(L="./"+L);else{const K=P.getWorkspaceFolder(M);if(K){const J=K.name;if(f.folders.filter(A=>A.name===J).length===1){const A=(0,s.$jh)(K.uri,M);A===""?L=`./${K.name}`:L=`./${K.name}/${A}`}else L=M.fsPath}}L&&p.push(D(L))}),p}}),define(Ie[314],Pe([1,0,24,2,22,14,3,313,44,50,11]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pyb=u,e.$qyb=n,w=Ve(w),O=Ve(O);const E=7e3;function u(o,c){const h=c.activationEvents;if(!h)return Promise.resolve(void 0);const i=[],r=[];for(const $ of h)if(/^workspaceContains:/.test($)){const S=$.substr(18);S.indexOf("*")>=0||S.indexOf("?")>=0||o.forceUsingSearch?r.push(S):i.push(S)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:t,resolve:a}=(0,I.$zh)(),l=$=>a({activationEvent:$}),g=Promise.all(i.map($=>C(o,$,l))).then(()=>{}),m=d(o,c.identifier,r,l);return Promise.all([g,m]).then(()=>{a(void 0)}),t}async function C(o,c,h){for(const i of o.folders)if(await o.exists(w.$hh(y.URI.revive(i),c))){h(`workspaceContains:${c}`);return}}async function d(o,c,h,i){if(h.length===0)return Promise.resolve(void 0);const r=new k.$ye,t=o.checkExists(o.folders,h,r.token),a=setTimeout(async()=>{r.cancel(),o.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},E);let l=!1;try{l=await t}catch(g){O.$7(g)||O.$3(g)}r.dispose(),clearTimeout(a),l&&i(`workspaceContains:${h.join(",")}`)}function n(o,c,h,i){const r=o.get(R.$Fi),t=o.get(v.$SL),l=r.createInstance(N.$_M).file(c.map(g=>(0,s.$2i)(y.URI.revive(g))),{_reason:"checkExists",includePattern:h,exists:!0});return t.fileSearch(l,i).then(g=>!!g.limitHit,g=>O.$7(g)?!1:Promise.reject(g))}});var rt=this&&this.__classPrivateFieldSet||function(_,e,w,y,k){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!k:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?k.call(_,w):k?k.value=w:e.set(_,w),w},ze=this&&this.__classPrivateFieldGet||function(_,e,w,y){if(w==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!y:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?y:w==="a"?y.call(_):y?y.value:e.get(_)};define(Ie[47],Pe([1,0,182,20,65,24,11,4,59,2,12,5,46,248,89,45,25,119,14,19,23,230,7,110,3,27,92,17,75,93,57,95,6,314,88,232,16,86,70,21,87]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l,g,m,$,S,D,b,T,P,p,f,M,L,K,J,z,A,W){"use strict";var Z,he,ve,be;Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=e.$ypc=e.$xpc=e.$wpc=e.$vpc=void 0,w=Ve(w),y=Ve(y),k=Ve(k),h=Ve(h),e.$vpc=(0,g.$Gi)("IHostUtils");let de=be=class extends N.$Xc{constructor(le,ne,ce,oe,H,x,ue,me,Oe,je,ke,Ae,Ne){super(),this.Y=Ae,this.Z=Ne,this.a=this.B(new p.$ne),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ne,this.g=ce,this.f=ue,this.j=oe,this.m=H,this.s=x,this.t=Oe,this.u=je,this.w=ke,this.y=this.g.getProxy(E.$vN.MainThreadWorkspace),this.z=this.g.getProxy(E.$vN.MainThreadTelemetry),this.C=this.g.getProxy(E.$vN.MainThreadExtensionService),this.D=new R.$Fh,this.F=new R.$Fh,this.G=new R.$Fh,this.H=new R.$Fh,this.I=new q(this.f.extensions.activationEvents),this.L=new c.$1cc(this.I,this.f.extensions.allExtensions);const U=new i.$tn(this.f.extensions.myExtensions);this.J=new c.$1cc(this.I,Te(this.L,U)),A.$n&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new d.$epc(this.g,this.s),this.N=new M.$opc(this.g),this.O=me,this.h=le.createChild(new D.$Ei([d.$fpc,this.M],[M.$ppc,this.N])),this.P=this.B(new C.$dpc(this.J,this.L,{onExtensionActivationError:(B,G,Q)=>{this.C.$onExtensionActivationError(B,h.$5(G),Q)},actualActivateExtension:async(B,G)=>{if(c.$1cc.isHostExtension(B,this.J,this.L))return await this.C.$activateExtension(B,G),new C.$cpc;const Q=this.J.getExtensionDescription(B);return this.fb(Q,G)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(le){h.$3(le)}}async $(){this.O.onWillDeactivateAll();let le=[];try{le=this.J.getAllExtensionDescriptions().map(H=>H.identifier).filter(H=>this.isActivated(H)).map(H=>this.eb(H))}catch{}await Promise.all(le)}terminate(le,ne=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${le}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(oe=>{this.s.error(oe)}),this.g.dispose();const ce=this.$();Promise.race([(0,R.$Hh)(5e3),ce]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ne}`):this.s.info(`Extension host exiting with code ${ne}`),this.s.flush(),this.s.dispose(),this.c.exit(ne)})}isActivated(le){return this.G.isOpen()?this.P.isActivated(le):!1}async getExtension(le){const ne=await this.C.$getExtension(le);return ne&&{...ne,identifier:new i.$sn(ne.identifier.value),extensionLocation:s.URI.revive(ne.extensionLocation)}}ab(le,ne){return this.P.activateByEvent(le,ne)}bb(le,ne){return this.P.activateById(le,ne)}activateByIdWithErrors(le,ne){return this.bb(le,ne).then(()=>{const ce=this.P.getActivatedExtension(le);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(le=>this.J)}getExtensionExports(le){if(this.G.isOpen())return this.P.getActivatedExtension(le).exports;try{return this.P.getActivatedExtension(le).exports}catch{return null}}async cb(le){if(le.scheme===K.Schemas.file&&this.c.fsRealpath){const ne=le.fsPath;this.R.has(ne)||this.R.set(ne,this.c.fsRealpath(ne));const ce=await this.R.get(ne);return s.URI.file(ce)}return le}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(le=>new re(le))),this.Q}async db(le){const ne=v.$Mi.forUris(ce=>O.$$g.ignorePathCasing(ce));return await Promise.all(le.map(async ce=>{if(this.wb(ce)){const oe=await this.cb(ce.extensionLocation);ne.set(oe,ce)}})),ne}eb(le){let ne=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(le))return ne;const ce=this.P.getActivatedExtension(le);if(!ce)return ne;try{typeof ce.module.deactivate=="function"&&(ne=Promise.resolve(ce.module.deactivate()).then(void 0,oe=>(this.s.error(oe),Promise.resolve(void 0))))}catch(oe){this.s.error(`An error occurred when deactivating the extension '${le.value}':`),this.s.error(oe)}try{(0,N.$Sc)(ce.subscriptions)}catch(oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${le.value}':`),this.s.error(oe)}return ne}async fb(le,ne){return this.f.remote.isRemote?this.C.$onWillActivateExtension(le.identifier):await this.C.$onWillActivateExtension(le.identifier),this.hb(le,ne).then(ce=>{const oe=ce.activationTimes;return this.C.$onDidActivateExtension(le.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,ne),this.gb(le,ne,"success",oe),ce},ce=>{throw this.gb(le,ne,"failure"),ce})}gb(le,ne,ce,oe){const H=ye(le,ne);this.z.$publicLog2("extensionActivationTimes",{...H,...oe||{},outcome:ce})}hb(le,ne){const ce=ye(le,ne);this.z.$publicLog2("activatePlugin",ce);const oe=this.wb(le);if(!oe)return Promise.resolve(new C.$bpc(C.$$oc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${le.identifier.value}, startup: ${ne.startup}, activationEvent: '${ne.activationEvent}'${le.identifier.value!==ne.extensionId.value?`, root cause: ${ne.extensionId.value}`:""}`),this.s.flush();const H=new C.$_oc(ne.startup);return Promise.all([this.xb(le,(0,O.$hh)(le.extensionLocation,oe),H),this.ib(le)]).then(x=>(k.mark(`code/extHost/willActivateExtension/${le.identifier.value}`),be.jb(this.s,le.identifier,x[0],x[1],H))).then(x=>(k.mark(`code/extHost/didActivateExtension/${le.identifier.value}`),x))}ib(le){const ne=this.Z.createLanguageModelAccessInformation(le),ce=this.B(new t.$hpc(le,this.M)),oe=this.B(new t.$gpc(le.identifier.value,!1,this.M)),H=this.B(new L.$qpc(le,this.N)),x=le.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,ue=this.f.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${le.identifier.value}`),Promise.all([ce.whenReady,oe.whenReady,this.O.whenReady]).then(()=>{const me=this;let Oe,je;const ke=(0,o.$7G)(le,"ipc")?this.f.messagePorts?.get(i.$sn.toKey(le.identifier)):void 0;return Object.freeze({globalState:ce,workspaceState:oe,secrets:H,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return le.extensionLocation},get extensionPath(){return le.extensionLocation.fsPath},asAbsolutePath(Ae){return y.$mc(le.extensionLocation.fsPath,Ae)},get storagePath(){return me.O.workspaceValue(le)?.fsPath},get globalStoragePath(){return me.O.globalValue(le).fsPath},get logPath(){return y.$mc(me.f.logsLocation.fsPath,le.identifier.value)},get logUri(){return s.URI.joinPath(me.f.logsLocation,le.identifier.value)},get storageUri(){return me.O.workspaceValue(le)},get globalStorageUri(){return me.O.globalValue(le)},get extensionMode(){return x},get extension(){return Oe===void 0&&(Oe=new we(me,le.identifier,le,ue,!1)),Oe},get extensionRuntime(){return(0,o.$8G)(le,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me.u.getEnvironmentVariableCollection(le)},get messagePassingProtocol(){if(!je){if(!ke)return;const Ae=p.Event.buffer(p.Event.fromDOMEventEmitter(ke,"message",Ne=>Ne.data));ke.start(),je={onDidReceiveMessage:Ae,postMessage:ke.postMessage.bind(ke)}}return je}})})}static jb(le,ne,ce,oe,H){return ce=ce||{activate:void 0,deactivate:void 0},this.kb(le,ne,ce,oe,H).then(x=>new C.$apc(!1,null,H.build(),ce,x,oe.subscriptions))}static kb(le,ne,ce,oe,H){if(typeof ce.activate=="function")try{H.activateCallStart(),le.trace(`ExtensionService#_callActivateOptional ${ne.value}`);const x=typeof global=="object"?global:self,ue=ce.activate.apply(x,[oe]);return H.activateCallStop(),H.activateResolveStart(),Promise.resolve(ue).then(me=>(H.activateResolveStop(),me))}catch(x){return Promise.reject(x)}else return Promise.resolve(ce)}lb(le,ne){this.bb(le.identifier,{startup:!1,extensionId:le.identifier,activationEvent:ne}).then(void 0,ce=>{this.s.error(ce)})}mb(le,ne=0){const oe=Date.now();(0,A.$v)(()=>{for(let H=ne;H<le.length;H+=1){const x=le[H];for(const ue of x.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-oe>50){this.mb(le,H);break}else this.lb(x,ue)}})}nb(){this.C.$setPerformanceMarks(k.getMarks()),this.m.getConfigProvider().then(le=>{const ne=le.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ce=this.J.getAllExtensionDescriptions();if(ne)this.mb(ce);else for(const oe of ce)if(oe.activationEvents)for(const H of oe.activationEvents)H==="onStartupFinished"&&this.lb(oe,H)})}ob(){const le=this.ab("*",!0).then(void 0,x=>{this.s.error(x)});this.B(this.j.onDidChangeWorkspace(x=>this.pb(x.added)));const ne=this.j.workspace?this.j.workspace.folders:[],ce=this.pb(ne),oe=this.rb(),H=Promise.all([oe,le,ce]).then(()=>{});return Promise.race([H,(0,R.$Hh)(1e4)]).then(()=>{this.nb()}),H}pb(le){return le.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ne=>this.qb(le,ne))).then(()=>{})}async qb(le,ne){if(this.isActivated(ne.identifier))return;const ce=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.s,folders:le.map(x=>x.uri),forceUsingSearch:ce||!this.c.fsExists,exists:x=>this.c.fsExists(x.fsPath),checkExists:(x,ue,me)=>this.y.$checkExists(x,ue,me)},H=await(0,f.$pyb)(oe,ne);if(H)return this.bb(ne.identifier,{startup:!0,extensionId:ne.identifier,activationEvent:H.activationEvent}).then(void 0,x=>this.s.error(x))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(le){throw console.error(le),le}}async sb(){const{extensionDevelopmentLocationURI:le,extensionTestsLocationURI:ne}=this.f.environment;if(!le||!ne)throw new Error(w.localize(0,null));const ce=await this.xb(null,ne,new C.$_oc(!1));if(!ce||typeof ce.run!="function")throw new Error(w.localize(1,null,ne.toString()));return new Promise((oe,H)=>{const x=(Oe,je)=>{Oe?(A.$n&&this.s.error("Test runner called back with error",Oe),H(Oe)):(A.$n&&(je?this.s.info(`Test runner called back with ${je} failures.`):this.s.info("Test runner called back with successful outcome.")),oe(typeof je=="number"&&je>0?1:0))},ue=(0,O.$8g)(ne),me=ce.run(ue,x);me&&me.then&&me.then(()=>{A.$n&&this.s.info("Test runner finished successfully."),oe(0)}).catch(Oe=>{A.$n&&this.s.error("Test runner finished with error",Oe),H(Oe instanceof Error&&Oe.stack?Oe.stack:String(Oe))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Hh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(le,ne){return this.S[le]=ne,(0,N.$Vc)(()=>{delete this.S[le]})}async getRemoteExecServer(le){const{resolver:ne}=await this.ub(le);return ne?.resolveExecServer?.(le,{resolveAttempt:0})}async ub(le){const ne=le.indexOf("+");if(ne===-1)throw new a.$DN("Not an authority that can be resolved!",l.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ce=le.substr(0,ne);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this.S[ce]}}async $resolveAuthority(le,ne){const ce=z.$he.create(!1),oe=()=>`[resolveAuthority(${(0,l.$Vl)(le)},${ne})][${ce.elapsed()}ms] `,H=ee=>this.s.info(`${oe()}${ee}`),x=ee=>this.s.warn(`${oe()}${ee}`),ue=(ee,fe=void 0)=>this.s.error(`${oe()}${ee}`,fe),me=ee=>{if(ee instanceof a.$DN)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},Oe=async ee=>{H(`activating resolver for ${ee}...`);const{resolver:fe,authorityPrefix:Re}=await this.ub(ee);if(!fe)throw ue(`no resolver for ${Re}`),new a.$DN(`No remote extension installed to resolve ${Re}.`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:fe,authorityPrefix:Re,remoteAuthority:ee}},je=le.split(/@|%40/g).reverse();H(`activating remote resolvers ${je.join(" -> ")}`);let ke;try{ke=await Promise.all(je.map(Oe)).catch(async ee=>{if(!(ee instanceof a.$DN)||ee._code!==l.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return x(`resolving nested authorities failed: ${ee.message}`),[await Oe(le)]})}catch(ee){return me(ee)}const Ae=new R.$Rh;Ae.cancelAndSet(()=>H("waiting..."),1e3);let Ne,U;for(const[ee,{authorityPrefix:fe,resolver:Re,remoteAuthority:Ue}]of ke.entries())try{if(ee===ke.length-1)H("invoking final resolve()..."),k.mark(`code/extHost/willResolveAuthority/${fe}`),Ne=await Re.resolve(Ue,{resolveAttempt:ne,execServer:U}),k.mark(`code/extHost/didResolveAuthorityOK/${fe}`),H("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Re,a.$CN.isManagedResolvedAuthority(Ne)?Ne:void 0));else{if(H(`invoking resolveExecServer() for ${Ue}`),k.mark(`code/extHost/willResolveExecServer/${fe}`),U=await Re.resolveExecServer?.(Ue,{resolveAttempt:ne,execServer:U}),!U)throw new a.$DN(`Exec server was not available for ${Ue}`,l.RemoteAuthorityResolverErrorCode.NoResolverFound);k.mark(`code/extHost/didResolveExecServerOK/${fe}`)}}catch(Qe){return k.mark(`code/extHost/didResolveAuthorityError/${fe}`),ue("returned an error",Qe),Ae.dispose(),me(Qe)}Ae.dispose();const B={environmentTunnels:Ne.environmentTunnels,features:Ne.tunnelFeatures?{elevation:Ne.tunnelFeatures.elevation,privacyOptions:Ne.tunnelFeatures.privacyOptions,protocol:Ne.tunnelFeatures.protocol===void 0?!0:Ne.tunnelFeatures.protocol}:void 0},G={extensionHostEnv:Ne.extensionHostEnv,isTrusted:Ne.isTrusted,authenticationSession:Ne.authenticationSessionForInitializingExtensions?{id:Ne.authenticationSessionForInitializingExtensions.id,providerId:Ne.authenticationSessionForInitializingExtensions.providerId}:void 0};H(`returned ${a.$CN.isManagedResolvedAuthority(Ne)?"managed authority":`${Ne.host}:${Ne.port}`}`);let Q;if(a.$CN.isManagedResolvedAuthority(Ne)){const ee=ne;this.Y.setFactory(ee,Ne.makeConnection),Q={authority:le,connectTo:new l.$Sl(ee),connectionToken:Ne.connectionToken}}else Q={authority:le,connectTo:new l.$Tl(Ne.host,Ne.port),connectionToken:Ne.connectionToken};return{type:"ok",value:{authority:Q,options:G,tunnelInformation:B}}}async $getCanonicalURI(le,ne){this.s.info(`$getCanonicalURI invoked for authority (${(0,l.$Vl)(le)})`);const{resolver:ce}=await this.ub(le);if(!ce)return null;const oe=s.URI.revive(ne);if(typeof ce.getCanonicalURI>"u")return oe;const H=await(0,R.$yh)(()=>ce.getCanonicalURI(oe));return H||oe}async $startExtensionHost(le){le.toAdd.forEach(x=>x.extensionLocation=s.URI.revive(x.extensionLocation));const{globalRegistry:ne,myExtensions:ce}=$e(this.I,this.L,this.J,le),oe=await this.db(ce);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(ne.getAllExtensionDescriptions()),this.J.set(ce),A.$n&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.tb()}$activateByEvent(le,ne){return ne===o.ActivationKind.Immediate?this.D.wait().then(ce=>this.ab(le,!1)):this.G.wait().then(ce=>this.ab(le,!1))}async $activate(le,ne){return await this.G.wait(),this.J.getExtensionDescription(le)?(await this.bb(le,ne),!0):!1}async $deltaExtensions(le){le.toAdd.forEach(x=>x.extensionLocation=s.URI.revive(x.extensionLocation));const{globalRegistry:ne,myExtensions:ce}=$e(this.I,this.L,this.J,le),oe=await this.db(ce);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(ne.getAllExtensionDescriptions()),this.J.set(ce),A.$n&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(le){return le}async $test_up(le){return le.byteLength}async $test_down(le){const ne=r.$Pe.alloc(le),ce=Math.random()%256;for(let oe=0;oe<le;oe++)ne.writeUInt8(ce,oe);return ne}async $updateRemoteConnectionData(le){this.X=le,this.a.fire()}};e.$wpc=de,e.$wpc=de=be=He([Ge(0,g.$Fi),Ge(1,e.$vpc),Ge(2,S.$2P),Ge(3,n.$Toc),Ge(4,u.$Woc),Ge(5,I.$ak),Ge(6,m.$fQ),Ge(7,$.$Zoc),Ge(8,b.$_Fb),Ge(9,T.$ipc),Ge(10,J.$spc),Ge(11,W.$tpc),Ge(12,P.$mpc)],de);function $e(ae,le,ne,ce){ae.addActivationEvents(ce.addActivationEvents);const oe=new c.$1cc(ae,le.getAllExtensionDescriptions());oe.deltaExtensions(ce.toAdd,ce.toRemove);const H=new i.$tn(ne.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of ce.myToRemove)H.delete(ue);for(const ue of ce.myToAdd)H.add(ue);const x=Te(oe,H);return{globalRegistry:oe,myExtensions:x}}function ye(ae,le){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:le.activationEvent,reasonId:le.extensionId.value}}function Y(ae){return ae.getAllExtensionDescriptions().map(le=>le.identifier.value).join(",")}e.$xpc=(0,g.$Gi)("IExtHostExtensionService");class we{constructor(le,ne,ce,oe,H){Z.set(this,void 0),he.set(this,void 0),ve.set(this,void 0),rt(this,Z,le,"f"),rt(this,he,ne,"f"),rt(this,ve,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=y.$kc((0,O.$8g)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=oe,this.isFromDifferentExtensionHost=H}get isActive(){return ze(this,Z,"f").isActivated(ze(this,ve,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return ze(this,Z,"f").getExtensionExports(ze(this,ve,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await ze(this,Z,"f").activateByIdWithErrors(ze(this,ve,"f"),{startup:!1,extensionId:ze(this,he,"f"),activationEvent:"api"}),this.exports}}e.$ypc=we,Z=new WeakMap,he=new WeakMap,ve=new WeakMap;function Te(ae,le){return ae.getAllExtensionDescriptions().filter(ne=>le.has(ne.identifier))}class re{constructor(le){this.a=le}setSearchTree(le){this.a=le}findSubstr(le){return this.a.findSubstr(le)}forEach(le){return this.a.forEach(le)}}e.$zpc=re;class q{constructor(le){this.a=new i.$un,this.addActivationEvents(le)}readActivationEvents(le){return this.a.get(le.identifier)??[]}addActivationEvents(le){for(const ne of Object.keys(le))this.a.set(ne,le[ne])}}}),define(Ie[315],Pe([1,0,65,2,5,46,25,19,17,27,3,47,12,13]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=void 0,w=Ve(w);let n=class{constructor(r,t,a,l,g,m,$){this.c=r,this.d=t,this.f=a,this.g=l,this.h=g,this.i=m,this.j=$,this.a=new Map,this.b=[]}async install(){this.k(),w.mark("code/extHost/willWaitForConfig");const r=await this.g.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const t=await this.h.getExtensionPathIndex();this.register(new c(this.c,t,this.d,r,this.j)),this.register(this.f.createInstance(o)),this.i.remote.isRemote&&this.register(this.f.createInstance(h,t,this.i.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const t of r.nodeModuleName)this.a.set(t,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(t=>r.alternativeModuleName(t))}};e.$Kqc=n,e.$Kqc=n=He([Ge(2,I.$Fi),Ge(3,O.$Woc),Ge(4,E.$xpc),Ge(5,s.$fQ),Ge(6,u.$ak)],n);let o=d=class{constructor(r){if(r.environment.appRoot&&d.a.size){const t=(0,C.$jf)(this.c(r.environment.appRoot.fsPath)),a="[a-z0-9_.-]",l=`@${a}+\\/${a}+|${a}+`,g="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${g}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const t=this.b.exec(this.c(r));if(!t)return;const[,a,l,g]=t,m=d.a.get(l);if(m!==void 0)return console.warn(`${l} as been renamed to ${m}, please update your imports`),a+m+g}c(r){return r.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=d=He([Ge(0,s.$fQ)],o);class c{constructor(r,t,a,l,g){this.c=r,this.d=t,this.e=a,this.f=l,this.g=g,this.nodeModuleName="vscode",this.a=new N.$un}load(r,t){const a=this.d.findSubstr(t);if(a){let l=this.a.get(a.identifier);return l||(l=this.c(a,this.e,this.f),this.a.set(a.identifier,l)),l}if(!this.b){let l="";this.d.forEach((g,m)=>l+=`	${m} -> ${g.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${l}`),this.b=this.c(R.$2G,this.e,this.f)}return this.b}}let h=class{constructor(r,t,a){this.e=r,this.f=t,this.nodeModuleName=["open","opn"],this.d=a.getProxy(k.$vN.MainThreadTelemetry);const l=a.getProxy(k.$vN.MainThreadWindow);this.c=(g,m)=>{const $=y.URI.parse(g);return m?this.g(g,m):$.scheme==="http"||$.scheme==="https"?l.$openUri($,g,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?l.$openUri($,g,{}):this.g(g,m)}}load(r,t,a){const l=this.e.findSubstr(t);return l&&(this.a=l.identifier.value,this.h()),this.b=a(r),this.c}g(r,t){return this.i(),this.b(r,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=He([Ge(2,v.$2P)],h)}),define(Ie[132],Pe([1,0,48,4,20,79,3,58,71,47,7,45,245,46]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=e.$Apc=void 0,k=Ve(k),O=Ve(O),e.$Apc=(0,R.$Gi)("IExtHostVariableResolverProvider");class d extends u.$6Q{constructor(c,h,i,r,t,a,l){function g(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const $=r.tabGroups.all.find(S=>S.isActive)?.activeTab;if($!==void 0){if($.input instanceof I.$jP||$.input instanceof I.$oP)return $.input.modified;if($.input instanceof I.$iP||$.input instanceof I.$nP||$.input instanceof I.$lP)return $.input.uri}}}super({getFolderUri:m=>{const $=a.folders.filter(S=>S.name===m);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>a.folders.length,getConfigurationValue:(m,$)=>t.getConfiguration(void 0,m).get($),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=g();if(m)return k.$kc(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const m=g();if(m){const $=h.getWorkspaceFolder(m);if($)return k.$kc($.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>c.getExtension(m)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(O.env))}}let n=class extends y.$Xc{constructor(c,h,i,r,t){super(),this.b=c,this.c=h,this.g=i,this.h=r,this.j=t,this.a=new w.$X(async()=>{const a=await this.h.getConfigProvider(),g={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{g.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,a,g,this.m())})}getResolver(){return this.a.value}m(){}};e.$Bpc=n,e.$Bpc=n=He([Ge(0,s.$xpc),Ge(1,E.$Toc),Ge(2,N.$aQ),Ge(3,C.$Woc),Ge(4,v.$9oc)],n)}),define(Ie[133],Pe([1,0,11,6,2,4,19,3,5,71,47,17,7,45,237,81,238,46,132,35,34,8,18,96]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=e.$Kpc=e.$Jpc=e.$Ipc=e.$Hpc=void 0,t=Ve(t),e.$Hpc=(0,N.$Gi)("IExtHostDebugService");let g=class extends O.$Xc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(P,p,f,M,L,K,J,z){super(),this.Y=p,this.Z=f,this.$=M,this.ab=L,this.bb=K,this.cb=J,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new y.$ne),this.z=this.B(new y.$ne),this.C=this.B(new y.$ne),this.F=this.B(new y.$ne),this.u=P.getProxy(v.$vN.MainThreadDebugService),this.I=this.B(new y.$ne),this.L=this.B(new y.$ne),this.G=new $(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(A=>{this.B(A.onDidChange(W=>{this.fb(A)})),this.fb(A)})}async $getVisualizerTreeItem(P,p){const f=this.gb(p);if(!f)return;const M=await this.Q.get(P)?.getTreeItem?.(f);return M?this.eb(P,M):void 0}registerDebugVisualizationTree(P,p,f){const M=R.$sn.toKey(P.identifier),L=this.ub(M,p);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(L,f),this.u.$registerDebugVisualizerTree(L,!!f.editItem),(0,O.$Vc)(()=>{this.u.$unregisterDebugVisualizerTree(L),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(P,p){const f=this.S.get(p)?.item;return f?(await this.Q.get(P)?.getChildren?.(f))?.map(L=>this.eb(P,L))||[]:[]}async $editVisualizerTreeItem(P,p){const f=this.S.get(P);if(!f)return;const M=await this.Q.get(f.provider)?.editItem?.(f.item,p);return this.eb(f.provider,M||f.item)}$disposeVisualizedTree(P){const p=this.S.get(P);if(!p)return;const f=[p.children];for(const M of f)if(M)for(const L of M)f.push(this.S.get(L)?.children),this.S.delete(L)}eb(P,p){let f=this.R.get(p);return f||(f=this.O++,this.R.set(p,f),this.S.set(f,{provider:P,item:p})),t.DebugTreeItem.from(p,f)}asDebugSourceUri(P,p){const f=P;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let M=`debug:${encodeURIComponent(f.path||"")}`,L="?";return p&&(M+=`${L}session=${encodeURIComponent(p.id)}`,L="&"),M+=`${L}ref=${f.sourceReference}`,k.URI.parse(M)}else{if(f.path)return k.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(P){const p=[];for(const f of P.getAllExtensionDescriptions())if(f.contributes){const M=f.contributes.debuggers;if(M&&M.length>0)for(const L of M)(0,o.$ZH)(L)&&p.push(L.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const P=[];return this.H.forEach(p=>P.push(p)),P}async $resolveDebugVisualizer(P,p){const f=this.W.get(P);if(!f)throw new Error(`No debug visualizer found with id '${P}'`);let{v:M,provider:L,extensionId:K}=f;if(M.visualization||(M=await L.resolveDebugVisualization?.(M,p)||M,f.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${L}'`);return this.vb(K,M.visualization)}async $executeDebugVisualizerCommand(P){const p=this.W.get(P);if(!p)throw new Error(`No debug visualizer found with id '${P}'`);const f=p.v.visualization;f&&"command"in f&&this.cb.executeCommand(f.command,...f.arguments||[])}gb(P){const p=this.w.get(P.sessionId);return p&&{session:p.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId}}async $provideDebugVisualizers(P,p,f,M){const L=this.gb(f),K=this.ub(P,p),J=this.P.get(K);if(!L||!J)return[];const z=await J.provideDebugVisualization(L,M);return z?z.map(A=>{const W=++this.X;this.W.set(W,{v:A,provider:J,extensionId:P});const Z=A.iconPath?this.wb(A.iconPath):void 0;return{id:W,name:A.name,iconClass:Z?.iconClass,iconPath:Z?.iconPath,visualization:this.vb(P,A.visualization)}}):[]}$disposeDebugVisualizers(P){for(const p of P)this.W.delete(p)}registerDebugVisualizationProvider(P,p,f){if(!P.contributes?.debugVisualizers?.some(K=>K.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const M=R.$sn.toKey(P.identifier),L=this.ub(M,p);if(this.P.has(L))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(L,f),this.u.$registerDebugVisualizer(M,p),(0,O.$Vc)(()=>{this.u.$unregisterDebugVisualizer(M,p),this.P.delete(p)})}addBreakpoints(P){const p=P.filter(L=>{const K=L.id;return this.H.has(K)?!1:(this.H.set(K,L),!0)});this.rb(p,[],[]);const f=[],M=new Map;for(const L of p)if(L instanceof u.$zO){let K=M.get(L.location.uri.toString());K||(K={type:"sourceMulti",uri:L.location.uri,lines:[]},M.set(L.location.uri.toString(),K),f.push(K)),K.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character,mode:L.mode})}else L instanceof u.$AO&&f.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName,mode:L.mode});return this.u.$registerBreakpoints(f)}removeBreakpoints(P){const p=P.filter(K=>this.H.delete(K.id));this.rb([],p,[]);const f=p.filter(K=>K instanceof u.$zO).map(K=>K.id),M=p.filter(K=>K instanceof u.$AO).map(K=>K.id),L=p.filter(K=>K instanceof u.$BO).map(K=>K.id);return this.u.$unregisterBreakpoints(f,M,L)}startDebugging(P,p,f){const M=f.testRun&&this.db.getMetadataForRun(f.testRun);return this.u.$startDebugging(P?P.uri:void 0,p,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(P){return this.u.$stopDebugging(P?P.id:void 0)}registerDebugConfigurationProvider(P,p,f){if(!p)return new u.$xN(()=>{});const M=this.f++;return this.g.push({type:P,handle:M,provider:p}),this.u.$registerDebugConfigurationProvider(P,f,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,M),new u.$xN(()=>{this.g=this.g.filter(L=>L.provider!==p),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(P,p,f){if(!f)return new u.$xN(()=>{});if(!this.nb(P,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:p,handle:M,factory:f}),this.u.$registerDebugAdapterDescriptorFactory(p,M),new u.$xN(()=>{this.j=this.j.filter(L=>L.factory!==f),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(P,p){if(!p)return new u.$xN(()=>{});const f=this.m++;return this.n.push({type:P,handle:f,factory:p}),new u.$xN(()=>{this.n=this.n.filter(M=>M.factory!==p)})}async $runInTerminal(P,p){return Promise.resolve(void 0)}async $substituteVariables(P,p){let f;const M=await this.tb(P);return M&&(f={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(f,p)}hb(P,p){if(P.type==="implementation")return new D(P.implementation)}ib(){}async $startDASession(P,p){const f=this,M=await this.sb(p);return this.pb(this.kb(M.type),M).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const K=this.jb(L),J=this.hb(K,M);if(!J)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const z=J;return this.M.set(P,z),this.ob(M).then(A=>(A&&this.N.set(P,A),z.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const Z=W,he={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const ve=await this.U.sign(Z.arguments.value);he.body={signature:ve},z.sendResponse(he)}else throw new Error("no signer")}catch(ve){he.success=!1,he.message=ve.message,z.sendResponse(he)}}else A&&A.onDidSendMessage&&A.onDidSendMessage(W),W=(0,o.$5H)(W,!0),f.u.$acceptDAMessage(P,W)}),z.onError(W=>{A&&A.onError&&A.onError(W),this.u.$acceptDAError(P,W.name,W.message,W.stack)}),z.onExit(W=>{A&&A.onExit&&A.onExit(W??void 0,void 0),this.u.$acceptDAExit(P,W??void 0,void 0)}),A&&A.onWillStartSession&&A.onWillStartSession(),z.startSession()))})}$sendDAMessage(P,p){p=(0,o.$4H)(p,!1);const f=this.N.get(P);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(p),this.M.get(P)?.sendMessage(p)}$stopDASession(P){const p=this.N.get(P);this.N.delete(P),p&&p.onWillStopSession&&p.onWillStopSession();const f=this.M.get(P);return this.M.delete(P),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(P){const p=[],f=[],M=[];if(P.added)for(const L of P.added){const K=L.id;if(K&&!this.H.has(K)){let J;if(L.type==="function")J=new u.$AO(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode);else if(L.type==="data")J=new u.$BO(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage,L.mode);else{const z=k.URI.revive(L.uri);J=new u.$zO(new u.$JN(z,new u.$yN(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage,L.mode)}(0,u.$xO)(J,K),this.H.set(K,J),p.push(J)}}if(P.removed)for(const L of P.removed){const K=this.H.get(L);K&&(this.H.delete(L),f.push(K))}if(P.changed){for(const L of P.changed)if(L.id){const K=this.H.get(L.id);if(K){if(K instanceof u.$AO&&L.type==="function"){const J=K;J.enabled=L.enabled,J.condition=L.condition,J.hitCondition=L.hitCondition,J.logMessage=L.logMessage,J.functionName=L.functionName}else if(K instanceof u.$zO&&L.type==="source"){const J=K;J.enabled=L.enabled,J.condition=L.condition,J.hitCondition=L.hitCondition,J.logMessage=L.logMessage,J.location=new u.$JN(k.URI.revive(L.uri),new u.$yN(L.line,L.character))}M.push(K)}}}this.rb(p,f,M)}async $acceptStackFrameFocus(P){let p;if(P){const f=await this.sb(P.sessionId);P.kind==="thread"?p=new u.$HO(f.api,P.threadId):p=new u.$GO(f.api,P.threadId,P.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(P,p,f){return(0,w.$yh)(async()=>{const M=this.mb(P);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.tb(p);return M.provideDebugConfigurations(L,f)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(P,p,f,M){return(0,w.$yh)(async()=>{const L=this.mb(P);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const K=await this.tb(p);return L.resolveDebugConfiguration(K,f,M)})}$resolveDebugConfigurationWithSubstitutedVariables(P,p,f,M){return(0,w.$yh)(async()=>{const L=this.mb(P);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const K=await this.tb(p);return L.resolveDebugConfigurationWithSubstitutedVariables(K,f,M)})}async $provideDebugAdapter(P,p){const f=this.lb(P);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(p);return this.pb(f,M).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(L)})}async $acceptDebugSessionStarted(P){const p=await this.sb(P);this.y.fire(p.api)}async $acceptDebugSessionTerminated(P){const p=await this.sb(P);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(P){this.D=P?await this.sb(P):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(P,p){(await this.sb(P))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(P,p){const M={session:(await this.sb(P)).api,event:p.event,body:p.body};this.F.fire(M)}jb(P){if(P instanceof u.$CO)return{type:"executable",command:P.command,args:P.args,options:P.options};if(P instanceof u.$DO)return{type:"server",port:P.port,host:P.host};if(P instanceof u.$EO)return{type:"pipeServer",path:P.path};if(P instanceof u.$FO)return{type:"implementation",implementation:P.implementation};throw new Error("convertToDto unexpected type")}kb(P){const p=this.j.filter(f=>f.type===P);if(p.length>0)return p[0].factory}lb(P){const p=this.j.filter(f=>f.handle===P);if(p.length>0)return p[0].factory}mb(P){const p=this.g.filter(f=>f.handle===P);if(p.length>0)return p[0].provider}nb(P,p){if(P.contributes){const f=P.contributes.debuggers;if(f&&f.length>0){for(const M of f)if(M.label&&M.type&&M.type===p)return!0}}return!1}ob(P){const f=P.configuration.type,M=this.n.filter(L=>L.type===f||L.type==="*").map(L=>(0,w.$yh)(()=>L.factory.createDebugAdapterTracker(P.api)).then(K=>K,K=>null));return Promise.race([Promise.all(M).then(L=>{const K=(0,a.$Kb)(L);if(K.length>0)return new S(K)}),new Promise(L=>setTimeout(()=>L(void 0),1e3))]).catch(L=>{})}async pb(P,p){const f=p.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new u.$DO(f));if(P){const L=await this.Z.getExtensionRegistry();return(0,w.$yh)(()=>P.createDebugAdapterDescriptor(p.api,this.qb(p,L))).then(K=>{if(K)return K})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,M))}qb(P,p){}rb(P,p,f){(P.length>0||p.length>0||f.length>0)&&this.I.fire(Object.freeze({added:P,removed:p,changed:f}))}async sb(P){if(P)if(typeof P=="string"){const p=this.w.get(P);if(p)return p}else{let p=this.w.get(P.id);if(!p){const f=await this.tb(P.folderUri),M=P.parent?this.w.get(P.parent):void 0;p=new m(this.u,P.id,P.type,P.name,f,P.configuration,M?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(P){if(P){const p=k.URI.revive(P);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(P,p){return`${P}\0${p}`}vb(P,p){if(p){if("title"in p&&"command"in p)return{type:n.DebugVisualizationType.Command};if("treeId"in p)return{type:n.DebugVisualizationType.Tree,id:`${P}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(P){const p=this.xb(P);let f,M;return"id"in p?M=i.ThemeIcon.asClassName(p):f=p,{iconPath:f,iconClass:M}}xb(P){if(P instanceof u.$uO)return{id:P.id};const p=typeof P=="object"&&"dark"in P?P.dark:P,f=typeof P=="object"&&"light"in P?P.light:P;return{dark:typeof p=="string"?k.URI.file(p):p,light:typeof f=="string"?k.URI.file(f):f}}};e.$Ipc=g,e.$Ipc=g=He([Ge(0,E.$2P),Ge(1,C.$Toc),Ge(2,I.$xpc),Ge(3,c.$Woc),Ge(4,s.$9oc),Ge(5,h.$Apc),Ge(6,r.$lQ),Ge(7,l.$Cpc)],g);class m{constructor(P,p,f,M,L,K,J){this.f=P,this.g=p,this.h=f,this.j=M,this.k=L,this.l=K,this.m=J}get api(){const P=this;return this.d??(this.d=Object.freeze({id:P.g,type:P.h,get name(){return P.j},set name(p){P.j=p,P.f.$setDebugSessionName(P.g,p)},parentSession:P.m,workspaceFolder:P.k,configuration:P.l,customRequest(p,f){return P.f.$customDebugAdapterRequest(P.g,p,f)},getDebugProtocolBreakpoint(p){return P.f.$getDebugProtocolBreakpoint(P.g,p.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(P){this.j=P}get configuration(){return this.l}}e.$Jpc=m;class ${constructor(P){this.value=Object.freeze({append(p){P.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$Kpc=$;class S{constructor(P){this.d=P}onWillStartSession(){this.d.forEach(P=>P.onWillStartSession?P.onWillStartSession():void 0)}onWillReceiveMessage(P){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(P):void 0)}onDidSendMessage(P){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(P):void 0)}onWillStopSession(){this.d.forEach(P=>P.onWillStopSession?P.onWillStopSession():void 0)}onError(P){this.d.forEach(p=>p.onError?p.onError(P):void 0)}onExit(P,p){this.d.forEach(f=>f.onExit?f.onExit(P,p):void 0)}}class D extends d.$Vtb{constructor(P){super(),this.h=P,P.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(P){this.h.handleMessage(P)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let b=class extends g{constructor(P,p,f,M,L,K,J,z){super(P,p,f,M,L,K,J,z)}};e.$Lpc=b,e.$Lpc=b=He([Ge(0,E.$2P),Ge(1,C.$Toc),Ge(2,I.$xpc),Ge(3,c.$Woc),Ge(4,s.$9oc),Ge(5,h.$Apc),Ge(6,r.$lQ),Ge(7,l.$Cpc)],b)}),define(Ie[316],Pe([1,0,14,65,2,5,266,12,61,75,27,211,17,66,47,67]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=e.$Lqc=void 0,w=Ve(w),y=Ve(y);class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(N.$ak),a=i.get(u.$2P).getProxy(O.$vN.MainThreadErrors);w.setUnexpectedErrorHandler(l=>{r.error(l);const g=w.$5(l);a.$onUnexpectedError(g)})}static async installFullHandler(i){const r=i.get(N.$ak),t=i.get(u.$2P),a=i.get(d.$xpc),l=i.get(n.$jQ),g=t.getProxy(O.$vN.MainThreadExtensionService),m=t.getProxy(O.$vN.MainThreadErrors),$=await a.getExtensionPathIndex(),S=new WeakMap;function D(P,p){if(S.has(P))return S.get(P).stack;let f="",M,L;for(const J of p)f+=`
	at ${J.toString()}`,L=J.getFileName(),!M&&L&&(M=$.findSubstr(k.URI.file(L)));const K=`${P.name||"Error"}: ${P.message||""}${f}`;return S.set(P,{extensionIdentifier:M?.identifier,stack:K}),K}const b=Symbol("prepareStackTrace wrapped");let T=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return T},set(P){if(P===D||!P||P[b]){T=P||D;return}T=function(p,f){return D(p,f),P.call(Error,p,f)},Object.assign(T,{[b]:!0})}}),w.setUnexpectedErrorHandler(P=>{r.error(P);const p=w.$5(P),f=S.get(P);if(!f?.extensionIdentifier){m.$onUnexpectedError(p);return}g.$onExtensionRuntimeError(f.extensionIdentifier,p);const M=l.onExtensionError(f.extensionIdentifier,P);r.trace("forwarded error to extension?",M,f)})}}e.$Lqc=o;class c{constructor(i,r,t,a,l){this.a=t,this.b=new R.$9cc(i,null,a),r=c.e(r,this.b);const g=new s.$Ei(...(0,v.$Rs)());g.set(I.$fQ,{_serviceBrand:void 0,...r,messagePorts:l}),g.set(u.$2P,new u.$3P(this.b)),g.set(C.$Qoc,new C.$Roc(a)),g.set(d.$vpc,t);const m=new E.$vr(g,!0);m.invokeFunction(o.installEarlyHandler),this.d=m.invokeFunction($=>$.get(N.$ak)),y.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=m.invokeFunction($=>$.get(d.$xpc)),this.c.initialize(),m.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(O.$vN.MainThreadExtensionService);return k.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(a=>{a.extensionLocation=k.URI.revive(r.transformIncomingURIs(a.extensionLocation))}),i.environment.appRoot=k.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(a=>k.URI.revive(r.transformIncomingURIs(a)))),i.environment.extensionTestsLocationURI=k.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=k.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=k.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=k.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=k.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=k.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$Mqc=c}),define(Ie[317],Pe([1,0,18,11,22,42,16,20,24,2,44]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=e.$1pc=e.$Zpc=void 0,e.$2pc=n,N=Ve(N),v=Ve(v);class E{constructor(h,i,r){this.d=h,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,i){const r=this.g.folderQueries||[],t=new k.$ye(i);return new Promise((a,l)=>{this.a=new C(h);let g=!1;const m=($,S)=>{if(!g&&!this.b){const D=this.h($);n($)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,g=!0,t.cancel(),$=this.j($,this.g.maxResults-this.c));const b=this.h($);this.c+=b,(b>0||!n($))&&this.a.add($,S)}};Promise.all(r.map(($,S)=>this.k($,D=>m(D,S),t.token))).then($=>{t.dispose(),this.a.flush();const S=$.some(D=>!!D&&!!D.limitHit);a({limitHit:this.b||S,messages:$.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},$=>{t.dispose();const S=(0,O.$rj)($);l(new Error(S))})})}h(h){return n(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,i){const r=Array.isArray(h.ranges)?h.ranges:[h.ranges],t=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:r.slice(0,i),preview:{matches:t.slice(0,i),text:h.preview.text},uri:h.uri}}async k(h,i,r){const t=new I.$_L(this.g,h),a=[],l={report:$=>{if(!this.l($))return;const S=h.folder.scheme===R.Schemas.file?(0,I.$aM)(()=>this.e.readdir(v.$gh($.uri))):void 0,D=v.$jh(h.folder,$.uri);if(D){const b=t.includedInQuery(D,N.$qc(D),S);(0,y.$sh)(b)?a.push(b.then(T=>{T&&i($)})):b&&i($)}}},g=this.n(h);let m;return this.d.query.type===I.QueryType.aiText?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,g,l,r):m=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),g,l,r),a.length&&await Promise.all(a),m}l(h){if(n(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const i=(0,I.$$L)(this.g.includePattern,h.includePattern),r=(0,I.$$L)(this.g.excludePattern,h.excludePattern),t={folder:s.URI.from(h.folder),excludes:r,includes:i,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$RL,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Zpc=E;function u(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class C{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(h,i){this.d&&(this.b!==i||!v.$ah(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$1pc=C;function d(c){return n(c)?{preview:{matches:(0,w.$4b)(c.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:c.preview.text},ranges:(0,w.$4b)(c.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function n(c){return!!c.preview}class o{constructor(h,i){this.g=h,this.h=i,this.c=0,this.d=[],this.e=0}addItem(h,i){h&&this.j(h,i)}addItems(h,i){h&&this.k(h,i)}j(h,i){this.d.push(h),this.e+=i,this.l()}k(h,i){this.d=this.d.concat(h),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$3pc=o,o.a=4e3,o.b=50}),define(Ie[134],Pe([1,0,4,5,3,312,17,66,12,2,317]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5pc=e.$4pc=void 0,e.$6pc=u,e.$4pc=(0,k.$Gi)("IExtHostSearch");let E=class{constructor(n,o,c){this.n=n,this.o=o,this.q=c,this.c=this.n.getProxy(y.$vN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Ypc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const c=this.d++;return this.e.set(c,o),this.c.$registerTextSearchProvider(c,this.s(n)),(0,w.$Vc)(()=>{this.g.delete(n),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(n,o){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const c=this.d++;return this.h.set(c,o),this.c.$registerAITextSearchProvider(c,this.s(n)),(0,w.$Vc)(()=>{this.i.delete(n),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(n,o){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const c=this.d++;return this.j.set(c,o),this.c.$registerFileSearchProvider(c,this.s(n)),(0,w.$Vc)(()=>{this.k.delete(n),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(n,o,c,h){const i=u(c),r=this.j.get(n);if(r)return this.l.fileSearch(i,r,t=>{this.c.$handleFileMatch(n,o,t.map(a=>a.resource))},h);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,c){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,c,h){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${n}`);const r=u(c);return this.t(r,i).search(a=>this.c.$handleTextMatch(n,o,a),h)}$provideAITextSearchResults(n,o,c,h){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${n}`);const r=u(c);return this.v(r,i).search(a=>this.c.$handleTextMatch(n,o,a),h)}$enableExtensionHostSearch(){}t(n,o){return new I.$Zpc({query:n,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(n,o){return new I.$Zpc({query:n,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$5pc=E,e.$5pc=E=He([Ge(0,R.$2P),Ge(1,N.$Qoc),Ge(2,v.$ak)],E);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(C),extraFileResources:d.extraFileResources&&d.extraFileResources.map(n=>s.URI.revive(n))}}function C(d){return{...d,folder:s.URI.revive(d.folder)}}});var ni=this&&this.__importDefault||function(_){return _&&_.__esModule?_:{default:_}};define(Ie[318],Pe([1,0,22,14,6,4,16,36,2,106,156,157,53,19,30,12,63,64,226,5,269,298,85,91,274,275,276,253,243,34,277,46,278,133,122,279,255,270,280,281,58,71,256,271,47,283,69,284,51,27,299,257,285,286,95,287,86,87,259,311,289,231,290,300,291,128,260,292,293,294,17,295,134,88,296,261,297,89,92,131,67,57,126,96,301,272,302,303,93,8,7,262,66,263,68,304,305,121,45,81,84,25,130]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l,g,m,$,S,D,b,T,P,p,f,M,L,K,J,z,A,W,Z,he,ve,be,de,$e,ye,Y,we,Te,re,q,ae,le,ne,ce,oe,H,x,ue,me,Oe,je,ke,Ae,Ne,U,B,G,Q,ee,fe,Re,Ue,Qe,Ye,it,ot,tt,at,pt,ut,st,ht,mt,wt,qe,Be,te,V,Se,Xe,et,ft,$t,Mt,Gt,ri,li,fi,xe,Zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=Qt,y=Ve(y),N=ni(N),E=Ve(E),d=Ve(d),te=Ve(te),V=Ve(V);function Qt(vt){const St=vt.get(we.$fQ),si=vt.get(Y.$Boc),Yt=vt.get($e.$Yoc),Bt=vt.get(be.$xpc),bt=vt.get(ri.$Toc),At=vt.get(at.$jQ),xt=vt.get(P.$Woc),Wt=vt.get(Xe.$Qoc),Ze=vt.get(Q.$2P),_t=vt.get(it.$fpc),oi=vt.get(ot.$Zoc),gi=vt.get(n.$bk),It=vt.get(n.$ak),qt=vt.get(Be.$_Fb),Lt=vt.get(a.$xoc),Vt=vt.get(Gt.$Fqc),pi=vt.get(Re.$ppc),ei=vt.get(Z.$9oc),ui=vt.get(oe.$tpc),Ft=vt.get(l.$Hoc),Ht=vt.get(le.$mpc);Ze.set(i.$wN.ExtHostFileSystemInfo,si),Ze.set(i.$wN.ExtHostLogLevelServiceShape,gi),Ze.set(i.$wN.ExtHostWorkspace,bt),Ze.set(i.$wN.ExtHostConfiguration,xt),Ze.set(i.$wN.ExtHostExtensionService,Bt),Ze.set(i.$wN.ExtHostStorage,_t),Ze.set(i.$wN.ExtHostTunnelService,qt),Ze.set(i.$wN.ExtHostWindow,Vt),Ze.set(i.$wN.ExtHostSecretState,pi),Ze.set(i.$wN.ExtHostTelemetry,At),Ze.set(i.$wN.ExtHostEditorTabs,ei),Ze.set(i.$wN.ExtHostManagedSockets,ui),Ze.set(i.$wN.ExtHostAuthentication,Ft),Ze.set(i.$wN.ExtHostChatProvider,Ht);const ti=Ze.set(i.$wN.ExtHostDecorations,vt.get(M.$Npc)),Tt=Ze.set(i.$wN.ExtHostDocumentsAndEditors,vt.get(W.$aQ)),Pt=Ze.set(i.$wN.ExtHostCommands,vt.get(b.$lQ)),Et=Ze.set(i.$wN.ExtHostTerminalService,vt.get(pt.$ipc)),ii=Ze.set(i.$wN.ExtHostTerminalShellIntegration,vt.get(ut.$vqc)),yt=Ze.set(i.$wN.ExtHostDebugService,vt.get(f.$Hpc)),ai=Ze.set(i.$wN.ExtHostSearch,vt.get(fe.$4pc)),Kt=Ze.set(i.$wN.ExtHostTask,vt.get(tt.$uqc)),vi=Ze.set(i.$wN.ExtHostOutputService,vt.get(Ae.$hqc)),mi=Ze.set(i.$wN.ExtHostLocalization,vt.get(ce.$spc)),bi=Ze.set(i.$wN.ExtHostUrls,new et.$Cqc(Ze)),Ut=Ze.set(i.$wN.ExtHostDocuments,new A.$Eoc(Ze,Tt)),Ri=Ze.set(i.$wN.ExtHostDocumentContentProviders,new J.$Ppc(Ze,Tt,It)),Fi=Ze.set(i.$wN.ExtHostDocumentSaveParticipant,new z.$Qpc(It,Ut,Ze.getProxy(i.$vN.MainThreadBulkEdits))),Nt=Ze.set(i.$wN.ExtHostNotebook,new x.$7pc(Ze,Pt,Tt,Ut,Yt,ai,It)),Ci=Ze.set(i.$wN.ExtHostNotebookDocuments,new me.$bqc(Nt)),Ii=Ze.set(i.$wN.ExtHostNotebookEditors,new Oe.$cqc(It,Nt)),yi=Ze.set(i.$wN.ExtHostNotebookKernels,new je.$dqc(Ze,St,Nt,Pt,It)),hi=Ze.set(i.$wN.ExtHostNotebookRenderers,new ke.$fqc(Ze,Nt)),zi=Ze.set(i.$wN.ExtHostNotebookDocumentSaveParticipant,new ue.$aqc(It,Nt,Ze.getProxy(i.$vN.MainThreadBulkEdits))),Ot=Ze.set(i.$wN.ExtHostEditors,new ht.$Noc(Ze,Tt)),Ee=Ze.set(i.$wN.ExtHostTreeViews,new qe.$Aqc(Ze.getProxy(i.$vN.MainThreadTreeViews),Pt,It)),Me=Ze.set(i.$wN.ExtHostEditorInsets,new D.$Ooc(Ze.getProxy(i.$vN.MainThreadEditorInsets),Ot,St.remote)),ge=Ze.set(i.$wN.ExtHostDiagnostics,new L.$Doc(Ze,It,si,Tt)),X=Ze.set(i.$wN.ExtHostLanguages,new ne.$$pc(Ze,Ut,Pt.converter,Wt)),De=Ze.set(i.$wN.ExtHostLanguageFeatures,new q.$Foc(Ze,Wt,Ut,Pt,ge,It,Lt,At)),We=Ze.set(i.$wN.ExtHostFileSystem,new de.$Tpc(Ze,De)),_e=Ze.set(i.$wN.ExtHostFileSystemEventService,new ye.$Upc(Ze,It,Tt)),Ke=Ze.set(i.$wN.ExtHostQuickOpen,(0,G.$lqc)(Ze,bt,Pt)),dt=Ze.set(i.$wN.ExtHostSCM,new ee.$nqc(Ze,Pt,Ut,It)),Rt=Ze.set(i.$wN.ExtHostQuickDiff,new B.$kqc(Ze,Wt)),Jt=Ze.set(i.$wN.ExtHostShare,new Ue.$oqc(Ze,Wt)),ci=Ze.set(i.$wN.ExtHostComments,(0,T.$Poc)(Ze,Pt,Ut)),jt=Ze.set(i.$wN.ExtHostProgress,new U.$jqc(Ze.getProxy(i.$vN.MainThreadProgress))),di=Ze.set(i.$wN.ExtHostLabelService,new re.$9pc(Ze)),en=Ze.set(i.$wN.ExtHostTheming,new mt.$xqc(Ze)),Gi=Ze.set(i.$wN.ExtHostTimeline,new wt.$zqc(Ze,Pt)),Ui=Ze.set(i.$wN.ExtHostWebviews,new ft.$4oc(Ze,St.remote,bt,It,Lt)),Ni=Ze.set(i.$wN.ExtHostWebviewPanels,new $t.$7oc(Ze,Ui,bt)),Ki=Ze.set(i.$wN.ExtHostCustomEditors,new p.$8oc(Ze,Ut,oi,Ui,Ni)),Qi=Ze.set(i.$wN.ExtHostWebviewViews,new Mt.$Dqc(Ze,Ui)),Ei=Ze.set(i.$wN.ExtHostTesting,vt.get(st.$Cpc)),tn=Ze.set(i.$wN.ExtHostUriOpeners,new Se.$Bqc(Ze)),nn=Ze.set(i.$wN.ExtHostProfileContentHandlers,new Ne.$iqc(Ze));Ze.set(i.$wN.ExtHostInteractive,new Te.$8pc(Ze,Nt,Tt,Pt,It));const Hi=Ze.set(i.$wN.ExtHostChatAgents2,new m.$Koc(Ze,It,Pt)),rn=Ze.set(i.$wN.ExtHostChatVariables,new $.$Loc(Ze)),Oi=Ze.set(i.$wN.ExtHostLanguageModelTools,new ae.$0pc(Ze)),ji=Ze.set(i.$wN.ExtHostAiRelatedInformation,new r.$woc(Ze)),sn=Ze.set(i.$wN.ExtHostAiEmbeddingVector,new ve.$Spc(Ze)),Ji=Ze.set(i.$wN.ExtHostStatusBar,new Ye.$rqc(Ze,Pt.converter)),on=Ze.set(i.$wN.ExtHostSpeech,new Qe.$pqc(Ze)),Ai=Ze.set(i.$wN.ExtHostEmbeddings,new he.$Rpc(Ze)),an=Object.values(i.$wN);Ze.assertRegistered(an);const cn=new g.$Joc(Ze,Tt),Dn=new S.$Moc(Ze),Xi=new H.$_pc(Ze,It),Bi=new K.$Opc(Ze);return t.$Goc.register(Pt),function(Fe,Di,ln){function ct(ie){return(pe,Le,lt)=>{const kt=ie(zt=>{try{pe.call(Le,zt)}catch(Li){y.$4(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${Li.toString()}`,{cause:Li})),At.onExtensionError(Fe.identifier,Li)}});return lt?.push(kt),kt}}const Ct=function(){let ie=!Fe.isUnderDevelopment;function pe(){ie||(It.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Le(lt){if(Array.isArray(lt))lt.forEach(Le);else if(typeof lt=="string")pe();else{const kt=lt;typeof kt.scheme>"u"&&pe(),typeof kt.exclusive=="boolean"&&(0,xe.$8G)(Fe,"documentFiltersExclusive")}return lt}}(),Wi={getSession(ie,pe,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,xe.$8G)(Fe,"authLearnMore"),Le?.account&&(0,xe.$8G)(Fe,"authGetSessions"),Ft.getSession(Fe,ie,pe,Le)},getAccounts(ie){return(0,xe.$8G)(Fe,"authGetSessions"),Ft.getAccounts(ie)},async hasSession(ie,pe){return(0,xe.$8G)(Fe,"authSession"),!!await Ft.getSession(Fe,ie,pe,{silent:!0})},get onDidChangeSessions(){return ct(Ft.onDidChangeSessions)},registerAuthenticationProvider(ie,pe,Le,lt){return Ft.registerAuthenticationProvider(ie,pe,Le,lt)}},un={registerCommand(ie,pe,Le){return Pt.registerCommand(!0,ie,pe,Le,void 0,Fe)},registerTextEditorCommand(ie,pe,Le){return Pt.registerCommand(!0,ie,(...lt)=>{const kt=Ot.getActiveTextEditor();if(!kt){It.warn("Cannot execute "+ie+" because there is no active text editor.");return}return kt.edit(zt=>{pe.apply(Le,[kt,zt,...lt])}).then(zt=>{zt||It.warn("Edits from command "+ie+" were not applied.")},zt=>{It.warn("An error occurred while running command "+ie,zt)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ie,pe,Le)=>((0,xe.$8G)(Fe,"diffCommand"),Pt.registerCommand(!0,ie,async(...lt)=>{const kt=Tt.activeEditor(!0);if(!kt){It.warn("Cannot execute "+ie+" because there is no active text editor.");return}const zt=await Ot.getDiffInformation(kt.id);pe.apply(Le,[zt,...lt])},void 0,void 0,Fe)),executeCommand(ie,...pe){return Pt.executeCommand(ie,...pe)},getCommands(ie=!1){return Pt.getCommands(ie)}},Zi={get machineId(){return St.telemetryInfo.machineId},get sessionId(){return St.telemetryInfo.sessionId},get language(){return St.environment.appLanguage},get appName(){return St.environment.appName},get appRoot(){return St.environment.appRoot?.fsPath??""},get appHost(){return St.environment.appHost},get uriScheme(){return St.environment.appUriScheme},get clipboard(){return Dn.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return ct(Et.onDidChangeShell)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ct(At.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$8G)(Fe,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$8G)(Fe,"telemetry"),ct(At.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,at.$iQ)(St.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,pe){return at.$hQ.validateSender(ie),At.instantiateLogger(Fe,ie,pe)},openExternal(ie,pe){return Vt.openUri(ie,{allowTunneling:!!St.remote.authority,allowContributedOpeners:pe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===St.environment.appUriScheme)return bi.createAppUri(ie);try{return await Vt.asExternalUri(ie,{allowTunneling:!!St.remote.authority})}catch(pe){if((0,R.$Pg)(ie,R.Schemas.http)||(0,R.$Pg)(ie,R.Schemas.https))return ie;throw pe}},get remoteName(){return(0,o.$jn)(St.remote.authority)},get remoteAuthority(){return(0,xe.$8G)(Fe,"resolvers"),St.remote.authority},get uiKind(){return St.uiKind},get logLevel(){return It.getLevel()},get onDidChangeLogLevel(){return ct(It.onDidChangeLogLevel)},get appQuality(){return(0,xe.$8G)(Fe,"resolvers"),St.quality},get appCommit(){return(0,xe.$8G)(Fe,"resolvers"),St.commit}};St.environment.extensionTestsLocationURI||Object.freeze(Zi);const hn={createTestController(ie,pe,Le){return Ei.createTestController(Fe,ie,pe,Le)},createTestObserver(){return(0,xe.$8G)(Fe,"testObserver"),Ei.createTestObserver()},runTests(ie){return(0,xe.$8G)(Fe,"testObserver"),Ei.runTests(ie)},registerTestFollowupProvider(ie){return(0,xe.$8G)(Fe,"testObserver"),Ei.registerTestFollowupProvider(ie)},get onDidChangeTestResults(){return(0,xe.$8G)(Fe,"testObserver"),ct(Ei.onResultsChanged)},get testResults(){return(0,xe.$8G)(Fe,"testObserver"),Ei.results}},qi=St.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Yi={getExtension(ie,pe){(0,xe.$7G)(Fe,"extensionsAny")||(pe=!1);const Le=Di.mine.getExtensionDescription(ie);if(Le)return new be.$ypc(Bt,Fe.identifier,Le,qi,!1);if(pe){const lt=Di.all.getExtensionDescription(ie);if(lt)return new be.$ypc(Bt,Fe.identifier,lt,qi,!0)}},get all(){const ie=[];for(const pe of Di.mine.getAllExtensionDescriptions())ie.push(new be.$ypc(Bt,Fe.identifier,pe,qi,!1));return ie},get allAcrossExtensionHosts(){(0,xe.$8G)(Fe,"extensionsAny");const ie=new C.$tn(Di.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),pe=[];for(const Le of Di.all.getAllExtensionDescriptions()){const lt=!ie.has(Le.identifier);pe.push(new be.$ypc(Bt,Fe.identifier,Le,qi,lt))}return pe},get onDidChange(){return(0,xe.$7G)(Fe,"extensionsAny")?ct(k.Event.any(Di.mine.onDidChange,Di.all.onDidChange)):ct(Di.mine.onDidChange)}},dn={createDiagnosticCollection(ie){return ge.createDiagnosticCollection(Fe.identifier,ie)},get onDidChangeDiagnostics(){return ct(ge.onDidChangeDiagnostics)},getDiagnostics:ie=>ge.getDiagnostics(ie),getLanguages(){return X.getLanguages()},setTextDocumentLanguage(ie,pe){return X.changeLanguage(ie.uri,pe)},match(ie,pe){const Le=te.LanguageSelector.from(ie);let lt;return(0,I.$vu)(Le)&&(lt=Nt.notebookDocuments.find(kt=>kt.apiNotebook.getCells().find(zt=>zt.document===pe))?.apiNotebook),(0,I.$uu)(Le,pe.uri,pe.languageId,!0,lt?.uri,lt?.notebookType)},registerCodeActionsProvider(ie,pe,Le){return De.registerCodeActionProvider(Fe,Ct(ie),pe,Le)},registerDocumentPasteEditProvider(ie,pe,Le){return(0,xe.$8G)(Fe,"documentPaste"),De.registerDocumentPasteEditProvider(Fe,Ct(ie),pe,Le)},registerCodeLensProvider(ie,pe){return De.registerCodeLensProvider(Fe,Ct(ie),pe)},registerDefinitionProvider(ie,pe){return De.registerDefinitionProvider(Fe,Ct(ie),pe)},registerDeclarationProvider(ie,pe){return De.registerDeclarationProvider(Fe,Ct(ie),pe)},registerImplementationProvider(ie,pe){return De.registerImplementationProvider(Fe,Ct(ie),pe)},registerTypeDefinitionProvider(ie,pe){return De.registerTypeDefinitionProvider(Fe,Ct(ie),pe)},registerHoverProvider(ie,pe){return De.registerHoverProvider(Fe,Ct(ie),pe,Fe.identifier)},registerEvaluatableExpressionProvider(ie,pe){return De.registerEvaluatableExpressionProvider(Fe,Ct(ie),pe,Fe.identifier)},registerInlineValuesProvider(ie,pe){return De.registerInlineValuesProvider(Fe,Ct(ie),pe,Fe.identifier)},registerDocumentHighlightProvider(ie,pe){return De.registerDocumentHighlightProvider(Fe,Ct(ie),pe)},registerMultiDocumentHighlightProvider(ie,pe){return De.registerMultiDocumentHighlightProvider(Fe,Ct(ie),pe)},registerLinkedEditingRangeProvider(ie,pe){return De.registerLinkedEditingRangeProvider(Fe,Ct(ie),pe)},registerReferenceProvider(ie,pe){return De.registerReferenceProvider(Fe,Ct(ie),pe)},registerRenameProvider(ie,pe){return De.registerRenameProvider(Fe,Ct(ie),pe)},registerNewSymbolNamesProvider(ie,pe){return(0,xe.$8G)(Fe,"newSymbolNamesProvider"),De.registerNewSymbolNamesProvider(Fe,Ct(ie),pe)},registerDocumentSymbolProvider(ie,pe,Le){return De.registerDocumentSymbolProvider(Fe,Ct(ie),pe,Le)},registerWorkspaceSymbolProvider(ie){return De.registerWorkspaceSymbolProvider(Fe,ie)},registerDocumentFormattingEditProvider(ie,pe){return De.registerDocumentFormattingEditProvider(Fe,Ct(ie),pe)},registerDocumentRangeFormattingEditProvider(ie,pe){return De.registerDocumentRangeFormattingEditProvider(Fe,Ct(ie),pe)},registerOnTypeFormattingEditProvider(ie,pe,Le,...lt){return De.registerOnTypeFormattingEditProvider(Fe,Ct(ie),pe,[Le].concat(lt))},registerDocumentSemanticTokensProvider(ie,pe,Le){return De.registerDocumentSemanticTokensProvider(Fe,Ct(ie),pe,Le)},registerDocumentRangeSemanticTokensProvider(ie,pe,Le){return De.registerDocumentRangeSemanticTokensProvider(Fe,Ct(ie),pe,Le)},registerSignatureHelpProvider(ie,pe,Le,...lt){return typeof Le=="object"?De.registerSignatureHelpProvider(Fe,Ct(ie),pe,Le):De.registerSignatureHelpProvider(Fe,Ct(ie),pe,typeof Le>"u"?[]:[Le,...lt])},registerCompletionItemProvider(ie,pe,...Le){return De.registerCompletionItemProvider(Fe,Ct(ie),pe,Le)},registerInlineCompletionItemProvider(ie,pe,Le){return pe.handleDidShowCompletionItem&&(0,xe.$8G)(Fe,"inlineCompletionsAdditions"),pe.handleDidPartiallyAcceptCompletionItem&&(0,xe.$8G)(Fe,"inlineCompletionsAdditions"),Le&&(0,xe.$8G)(Fe,"inlineCompletionsAdditions"),De.registerInlineCompletionsProvider(Fe,Ct(ie),pe,Le)},registerInlineEditProvider(ie,pe){return(0,xe.$8G)(Fe,"inlineEdit"),De.registerInlineEditProvider(Fe,Ct(ie),pe)},registerDocumentLinkProvider(ie,pe){return De.registerDocumentLinkProvider(Fe,Ct(ie),pe)},registerColorProvider(ie,pe){return De.registerColorProvider(Fe,Ct(ie),pe)},registerFoldingRangeProvider(ie,pe){return De.registerFoldingRangeProvider(Fe,Ct(ie),pe)},registerSelectionRangeProvider(ie,pe){return De.registerSelectionRangeProvider(Fe,ie,pe)},registerCallHierarchyProvider(ie,pe){return De.registerCallHierarchyProvider(Fe,ie,pe)},registerTypeHierarchyProvider(ie,pe){return De.registerTypeHierarchyProvider(Fe,ie,pe)},setLanguageConfiguration:(ie,pe)=>De.setLanguageConfiguration(Fe,ie,pe),getTokenInformationAtPosition(ie,pe){return(0,xe.$8G)(Fe,"tokenInformation"),X.tokenAtPosition(ie,pe)},registerInlayHintsProvider(ie,pe){return De.registerInlayHintsProvider(Fe,ie,pe)},createLanguageStatusItem(ie,pe){return X.createLanguageStatusItem(Fe,ie,pe)},registerDocumentDropEditProvider(ie,pe,Le){return De.registerDocumentOnDropEditProvider(Fe,ie,pe,(0,xe.$7G)(Fe,"documentPaste")?Le:void 0)}},Si={get activeTextEditor(){return Ot.getActiveTextEditor()},get visibleTextEditors(){return Ot.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(ie,pe,Le){v.URI.isUri(ie)&&ie.scheme===R.Schemas.vscodeRemote&&!ie.authority&&Lt.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const lt=await(v.URI.isUri(ie)?Promise.resolve(Mi.openTextDocument(ie)):Promise.resolve(ie));return Ot.showTextDocument(lt,pe,Le)},createTextEditorDecorationType(ie){return Ot.createTextEditorDecorationType(Fe,ie)},onDidChangeActiveTextEditor(ie,pe,Le){return ct(Ot.onDidChangeActiveTextEditor)(ie,pe,Le)},onDidChangeVisibleTextEditors(ie,pe,Le){return ct(Ot.onDidChangeVisibleTextEditors)(ie,pe,Le)},onDidChangeTextEditorSelection(ie,pe,Le){return ct(Ot.onDidChangeTextEditorSelection)(ie,pe,Le)},onDidChangeTextEditorOptions(ie,pe,Le){return ct(Ot.onDidChangeTextEditorOptions)(ie,pe,Le)},onDidChangeTextEditorVisibleRanges(ie,pe,Le){return ct(Ot.onDidChangeTextEditorVisibleRanges)(ie,pe,Le)},onDidChangeTextEditorViewColumn(ie,pe,Le){return ct(Ot.onDidChangeTextEditorViewColumn)(ie,pe,Le)},onDidCloseTerminal(ie,pe,Le){return ct(Et.onDidCloseTerminal)(ie,pe,Le)},onDidOpenTerminal(ie,pe,Le){return ct(Et.onDidOpenTerminal)(ie,pe,Le)},onDidChangeActiveTerminal(ie,pe,Le){return ct(Et.onDidChangeActiveTerminal)(ie,pe,Le)},onDidChangeTerminalDimensions(ie,pe,Le){return(0,xe.$8G)(Fe,"terminalDimensions"),ct(Et.onDidChangeTerminalDimensions)(ie,pe,Le)},onDidChangeTerminalState(ie,pe,Le){return ct(Et.onDidChangeTerminalState)(ie,pe,Le)},onDidWriteTerminalData(ie,pe,Le){return(0,xe.$8G)(Fe,"terminalDataWriteEvent"),ct(Et.onDidWriteTerminalData)(ie,pe,Le)},onDidExecuteTerminalCommand(ie,pe,Le){return(0,xe.$8G)(Fe,"terminalExecuteCommandEvent"),ct(Et.onDidExecuteTerminalCommand)(ie,pe,Le)},onDidChangeTerminalShellIntegration(ie,pe,Le){return(0,xe.$8G)(Fe,"terminalShellIntegration"),ct(ii.onDidChangeTerminalShellIntegration)(ie,pe,Le)},onDidStartTerminalShellExecution(ie,pe,Le){return(0,xe.$8G)(Fe,"terminalShellIntegration"),ct(ii.onDidStartTerminalShellExecution)(ie,pe,Le)},onDidEndTerminalShellExecution(ie,pe,Le){return(0,xe.$8G)(Fe,"terminalShellIntegration"),ct(ii.onDidEndTerminalShellExecution)(ie,pe,Le)},get state(){return Vt.getState()},onDidChangeWindowState(ie,pe,Le){return ct(Vt.onDidChangeWindowState)(ie,pe,Le)},showInformationMessage(ie,...pe){return Xi.showMessage(Fe,N.default.Info,ie,pe[0],pe.slice(1))},showWarningMessage(ie,...pe){return Xi.showMessage(Fe,N.default.Warning,ie,pe[0],pe.slice(1))},showErrorMessage(ie,...pe){return Xi.showMessage(Fe,N.default.Error,ie,pe[0],pe.slice(1))},showQuickPick(ie,pe,Le){return Ke.showQuickPick(Fe,ie,pe,Le)},showWorkspaceFolderPick(ie){return Ke.showWorkspaceFolderPick(ie)},showInputBox(ie,pe){return Ke.showInput(ie,pe)},showOpenDialog(ie){return Bi.showOpenDialog(Fe,ie)},showSaveDialog(ie){return Bi.showSaveDialog(ie)},createStatusBarItem(ie,pe,Le){let lt,kt,zt;return typeof ie=="string"?(lt=ie,kt=pe,zt=Le):(kt=ie,zt=pe),Ji.createStatusBarEntry(Fe,lt,kt,zt)},setStatusBarMessage(ie,pe){return Ji.setStatusBarMessage(ie,pe)},withScmProgress(ie){return Lt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),jt.withProgress(Fe,{location:V.ProgressLocation.SourceControl},(pe,Le)=>ie({report(lt){}}))},withProgress(ie,pe){return jt.withProgress(Fe,ie,pe)},createOutputChannel(ie,pe){return vi.createOutputChannel(ie,pe,Fe)},createWebviewPanel(ie,pe,Le,lt){return Ni.createWebviewPanel(Fe,ie,pe,Le,lt)},createWebviewTextEditorInset(ie,pe,Le,lt){return(0,xe.$8G)(Fe,"editorInsets"),Me.createWebviewEditorInset(ie,pe,Le,lt,Fe)},createTerminal(ie,pe,Le){return typeof ie=="object"?"pty"in ie?Et.createExtensionTerminal(ie):Et.createTerminalFromOptions(ie):Et.createTerminal(ie,pe,Le)},registerTerminalLinkProvider(ie){return Et.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,pe){return Et.registerProfileProvider(Fe,ie,pe)},registerTerminalQuickFixProvider(ie,pe){return(0,xe.$8G)(Fe,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(ie,Fe.identifier.value,pe)},registerTreeDataProvider(ie,pe){return Ee.registerTreeDataProvider(ie,pe,Fe)},createTreeView(ie,pe){return Ee.createTreeView(ie,pe,Fe)},registerWebviewPanelSerializer:(ie,pe)=>Ni.registerWebviewPanelSerializer(Fe,ie,pe),registerCustomEditorProvider:(ie,pe,Le={})=>Ki.registerCustomEditorProvider(Fe,ie,pe,Le),registerFileDecorationProvider(ie){return ti.registerFileDecorationProvider(ie,Fe)},registerUriHandler(ie){return bi.registerUriHandler(Fe,ie)},createQuickPick(){return Ke.createQuickPick(Fe)},createInputBox(){return Ke.createInputBox(Fe)},get activeColorTheme(){return en.activeColorTheme},onDidChangeActiveColorTheme(ie,pe,Le){return ct(en.onDidChangeActiveColorTheme)(ie,pe,Le)},registerWebviewViewProvider(ie,pe,Le){return Qi.registerWebviewViewProvider(Fe,ie,pe,Le?.webviewOptions)},get activeNotebookEditor(){return Nt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,pe,Le){return ct(Nt.onDidChangeActiveNotebookEditor)(ie,pe,Le)},get visibleNotebookEditors(){return Nt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ct(Nt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ie,pe,Le){return ct(Ii.onDidChangeNotebookEditorSelection)(ie,pe,Le)},onDidChangeNotebookEditorVisibleRanges(ie,pe,Le){return ct(Ii.onDidChangeNotebookEditorVisibleRanges)(ie,pe,Le)},showNotebookDocument(ie,pe){return Nt.showNotebookDocument(ie,pe)},registerExternalUriOpener(ie,pe,Le){return(0,xe.$8G)(Fe,"externalUriOpener"),tn.registerExternalUriOpener(Fe.identifier,ie,pe,Le)},registerProfileContentHandler(ie,pe){return(0,xe.$8G)(Fe,"profileContentHandlers"),nn.registerProfileContentHandler(Fe,ie,pe)},registerQuickDiffProvider(ie,pe,Le,lt){return(0,xe.$8G)(Fe,"quickDiffProvider"),Rt.registerQuickDiffProvider(Ct(ie),pe,Le,lt)},get tabGroups(){return ei.tabGroups},registerShareProvider(ie,pe){return(0,xe.$8G)(Fe,"shareProvider"),Jt.registerShareProvider(Ct(ie),pe)}},Mi={get rootPath(){return Lt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(ie){throw new y.$_("rootPath")},getWorkspaceFolder(ie){return bt.getWorkspaceFolder(ie)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(ie){throw new y.$_("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(ie){throw new y.$_("workspaceFile")},updateWorkspaceFolders:(ie,pe,...Le)=>bt.updateWorkspaceFolders(Fe,ie,pe||0,...Le),onDidChangeWorkspaceFolders:function(ie,pe,Le){return ct(bt.onDidChangeWorkspace)(ie,pe,Le)},asRelativePath:(ie,pe)=>bt.getRelativePath(ie,pe),findFiles:(ie,pe,Le,lt)=>bt.findFiles(ie,pe,Le,Fe.identifier,lt),findFiles2:(ie,pe,Le)=>((0,xe.$8G)(Fe,"findFiles2"),bt.findFiles2(ie,pe,Fe.identifier,Le)),findTextInFiles:(ie,pe,Le,lt)=>{(0,xe.$8G)(Fe,"findTextInFiles");let kt,zt;return typeof pe=="object"?(kt=pe,zt=Le):(kt={},zt=pe,lt=Le),bt.findTextInFiles(ie,kt||{},zt,Fe.identifier,lt)},save:ie=>bt.save(ie),saveAs:ie=>bt.saveAs(ie),saveAll:ie=>bt.saveAll(ie),applyEdit(ie,pe){return cn.applyWorkspaceEdit(ie,Fe,pe)},createFileSystemWatcher:(ie,pe,Le,lt)=>{let kt;return typeof pe=="boolean"?kt={ignoreCreateEvents:!!pe,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!lt,correlate:!1}:pe&&((0,xe.$8G)(Fe,"createFileSystemWatcher"),kt={...pe,correlate:!0}),_e.createFileSystemWatcher(bt,Fe,ie,kt)},get textDocuments(){return Ut.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw new y.$_("textDocuments")},openTextDocument(ie){let pe;const Le=ie;if(typeof ie=="string")pe=Promise.resolve(v.URI.file(ie));else if(v.URI.isUri(ie))pe=Promise.resolve(ie);else if(!Le||typeof Le=="object")pe=Ut.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return pe.then(lt=>(lt.scheme===R.Schemas.vscodeRemote&&!lt.authority&&Lt.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),Ut.ensureDocumentData(lt).then(kt=>kt.document)))},onDidOpenTextDocument:(ie,pe,Le)=>ct(Ut.onDidAddDocument)(ie,pe,Le),onDidCloseTextDocument:(ie,pe,Le)=>ct(Ut.onDidRemoveDocument)(ie,pe,Le),onDidChangeTextDocument:(ie,pe,Le)=>ct(Ut.onDidChangeDocument)(ie,pe,Le),onDidSaveTextDocument:(ie,pe,Le)=>ct(Ut.onDidSaveDocument)(ie,pe,Le),onWillSaveTextDocument:(ie,pe,Le)=>ct(Fi.getOnWillSaveTextDocumentEvent(Fe))(ie,pe,Le),get notebookDocuments(){return Nt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,pe){let Le;if(v.URI.isUri(ie))Le=ie,await Nt.openNotebookDocument(ie);else if(typeof ie=="string")Le=v.URI.revive(await Nt.createNotebookDocument({viewType:ie,content:pe}));else throw new Error("Invalid arguments");return Nt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(ie,pe,Le){return ct(Ci.onDidSaveNotebookDocument)(ie,pe,Le)},onDidChangeNotebookDocument(ie,pe,Le){return ct(Ci.onDidChangeNotebookDocument)(ie,pe,Le)},onWillSaveNotebookDocument(ie,pe,Le){return ct(zi.getOnWillSaveNotebookDocumentEvent(Fe))(ie,pe,Le)},get onDidOpenNotebookDocument(){return ct(Nt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ct(Nt.onDidCloseNotebookDocument)},registerNotebookSerializer(ie,pe,Le,lt){return Nt.registerNotebookSerializer(Fe,ie,pe,Le,(0,xe.$7G)(Fe,"notebookLiveShare")?lt:void 0)},onDidChangeConfiguration:(ie,pe,Le)=>ct(ln.onDidChangeConfiguration)(ie,pe,Le),getConfiguration(ie,pe){return pe=arguments.length===1?void 0:pe,ln.getConfiguration(ie,pe,Fe)},registerTextDocumentContentProvider(ie,pe){return Ri.registerTextDocumentContentProvider(ie,pe)},registerTaskProvider:(ie,pe)=>(Lt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Fe,ie,pe)),registerFileSystemProvider(ie,pe,Le){return(0,O.$Uc)(We.registerFileSystemProvider(Fe,ie,pe,Le),Yt.addFileSystemProvider(ie,pe,Le))},get fs(){return Yt.value},registerFileSearchProvider:(ie,pe)=>((0,xe.$8G)(Fe,"fileSearchProvider"),ai.registerFileSearchProvider(ie,pe)),registerTextSearchProvider:(ie,pe)=>((0,xe.$8G)(Fe,"textSearchProvider"),ai.registerTextSearchProvider(ie,pe)),registerAITextSearchProvider:(ie,pe)=>((0,xe.$8G)(Fe,"aiTextSearchProvider"),(0,xe.$8G)(Fe,"textSearchProvider"),ai.registerAITextSearchProvider(ie,pe)),registerRemoteAuthorityResolver:(ie,pe)=>((0,xe.$8G)(Fe,"resolvers"),Bt.registerRemoteAuthorityResolver(ie,pe)),registerResourceLabelFormatter:ie=>((0,xe.$8G)(Fe,"resolvers"),di.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,xe.$8G)(Fe,"resolvers"),Bt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,pe,Le)=>ct(_e.onDidCreateFile)(ie,pe,Le),onDidDeleteFiles:(ie,pe,Le)=>ct(_e.onDidDeleteFile)(ie,pe,Le),onDidRenameFiles:(ie,pe,Le)=>ct(_e.onDidRenameFile)(ie,pe,Le),onWillCreateFiles:(ie,pe,Le)=>ct(_e.getOnWillCreateFileEvent(Fe))(ie,pe,Le),onWillDeleteFiles:(ie,pe,Le)=>ct(_e.getOnWillDeleteFileEvent(Fe))(ie,pe,Le),onWillRenameFiles:(ie,pe,Le)=>ct(_e.getOnWillRenameFileEvent(Fe))(ie,pe,Le),openTunnel:ie=>((0,xe.$8G)(Fe,"tunnels"),qt.openTunnel(Fe,ie).then(pe=>{if(!pe)throw new Error("cannot open tunnel");return pe})),get tunnels(){return(0,xe.$8G)(Fe,"tunnels"),qt.getTunnels()},onDidChangeTunnels:(ie,pe,Le)=>((0,xe.$8G)(Fe,"tunnels"),ct(qt.onDidChangeTunnels)(ie,pe,Le)),registerPortAttributesProvider:(ie,pe)=>((0,xe.$8G)(Fe,"portsAttributes"),qt.registerPortsAttributesProvider(ie,pe)),registerTunnelProvider:(ie,pe)=>((0,xe.$8G)(Fe,"tunnelFactory"),qt.registerTunnelProvider(ie,pe)),registerTimelineProvider:(ie,pe)=>((0,xe.$8G)(Fe,"timeline"),Gi.registerTimelineProvider(ie,pe,Fe.identifier,Pt.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:ie=>((0,xe.$8G)(Fe,"workspaceTrust"),bt.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,pe,Le)=>ct(bt.onDidGrantWorkspaceTrust)(ie,pe,Le),registerEditSessionIdentityProvider:(ie,pe)=>((0,xe.$8G)(Fe,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(ie,pe)),onWillCreateEditSessionIdentity:(ie,pe,Le)=>((0,xe.$8G)(Fe,"editSessionIdentityProvider"),ct(bt.getOnWillCreateEditSessionIdentityEvent(Fe))(ie,pe,Le)),registerCanonicalUriProvider:(ie,pe)=>((0,xe.$8G)(Fe,"canonicalUriProvider"),bt.registerCanonicalUriProvider(ie,pe)),getCanonicalUri:(ie,pe,Le)=>((0,xe.$8G)(Fe,"canonicalUriProvider"),bt.provideCanonicalUri(ie,pe,Le))},Sn={get inputBox(){return Lt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),dt.getLastInputBox(Fe)},createSourceControl(ie,pe,Le){return dt.createSourceControl(Fe,ie,pe,Le)}},fn={createCommentController(ie,pe){return ci.createCommentController(Fe,ie,pe)}},Vi={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){return yt.activeStackItem},registerDebugVisualizationProvider(ie,pe){return(0,xe.$8G)(Fe,"debugVisualization"),yt.registerDebugVisualizationProvider(Fe,ie,pe)},registerDebugVisualizationTreeProvider(ie,pe){return(0,xe.$8G)(Fe,"debugVisualization"),yt.registerDebugVisualizationTree(Fe,ie,pe)},onDidStartDebugSession(ie,pe,Le){return ct(yt.onDidStartDebugSession)(ie,pe,Le)},onDidTerminateDebugSession(ie,pe,Le){return ct(yt.onDidTerminateDebugSession)(ie,pe,Le)},onDidChangeActiveDebugSession(ie,pe,Le){return ct(yt.onDidChangeActiveDebugSession)(ie,pe,Le)},onDidReceiveDebugSessionCustomEvent(ie,pe,Le){return ct(yt.onDidReceiveDebugSessionCustomEvent)(ie,pe,Le)},onDidChangeBreakpoints(ie,pe,Le){return ct(yt.onDidChangeBreakpoints)(ie,pe,Le)},onDidChangeActiveStackItem(ie,pe,Le){return ct(yt.onDidChangeActiveStackItem)(ie,pe,Le)},registerDebugConfigurationProvider(ie,pe,Le){return yt.registerDebugConfigurationProvider(ie,pe,Le||li.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,pe){return yt.registerDebugAdapterDescriptorFactory(Fe,ie,pe)},registerDebugAdapterTrackerFactory(ie,pe){return yt.registerDebugAdapterTrackerFactory(ie,pe)},startDebugging(ie,pe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?yt.startDebugging(ie,pe,{parentSession:Le}):yt.startDebugging(ie,pe,Le||{})},stopDebugging(ie){return yt.stopDebugging(ie)},addBreakpoints(ie){return yt.addBreakpoints(ie)},removeBreakpoints(ie){return yt.removeBreakpoints(ie)},asDebugSourceUri(ie,pe){return yt.asDebugSourceUri(ie,pe)}},gn={registerTaskProvider:(ie,pe)=>Kt.registerTaskProvider(Fe,ie,pe),fetchTasks:ie=>Kt.fetchTasks(ie),executeTask:ie=>Kt.executeTask(Fe,ie),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(ie,pe,Le)=>ct(Kt.onDidStartTask)(ie,pe,Le),onDidEndTask:(ie,pe,Le)=>ct(Kt.onDidEndTask)(ie,pe,Le),onDidStartTaskProcess:(ie,pe,Le)=>ct(Kt.onDidStartTaskProcess)(ie,pe,Le),onDidEndTaskProcess:(ie,pe,Le)=>ct(Kt.onDidEndTaskProcess)(ie,pe,Le)},mn={createNotebookController(ie,pe,Le,lt,kt){return yi.createNotebookController(Fe,ie,pe,Le,lt,(0,xe.$7G)(Fe,"notebookMessaging")?kt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,pe)=>Nt.registerNotebookCellStatusBarItemProvider(Fe,ie,pe),createRendererMessaging(ie){return hi.createRendererMessaging(Fe,ie)},createNotebookControllerDetectionTask(ie){return(0,xe.$8G)(Fe,"notebookKernelSource"),yi.createNotebookControllerDetectionTask(Fe,ie)},registerKernelSourceActionProvider(ie,pe){return(0,xe.$8G)(Fe,"notebookKernelSource"),yi.registerKernelSourceActionProvider(Fe,ie,pe)},onDidChangeNotebookCellExecutionState(ie,pe,Le){return(0,xe.$8G)(Fe,"notebookCellExecutionState"),ct(yi.onDidChangeNotebookCellExecutionState)(ie,pe,Le)}},pn={t(...ie){if(typeof ie[0]=="string"){const pe=ie.shift(),Le=!ie||typeof ie[0]!="object"?ie:ie[0];return mi.getMessage(Fe.identifier.value,{message:pe,args:Le})}return mi.getMessage(Fe.identifier.value,ie[0])},get bundle(){return mi.getBundle(Fe.identifier.value)},get uri(){return mi.getBundleUri(Fe.identifier.value)}},$n={_version:1,transferActiveChat(ie){return(0,xe.$8G)(Fe,"interactive"),Hi.transferActiveChat(ie)}},kn={getRelatedInformation(ie,pe){return(0,xe.$8G)(Fe,"aiRelatedInformation"),ji.getRelatedInformation(Fe,ie,pe)},registerRelatedInformationProvider(ie,pe){return(0,xe.$8G)(Fe,"aiRelatedInformation"),ji.registerRelatedInformationProvider(Fe,ie,pe)},registerEmbeddingVectorProvider(ie,pe){return(0,xe.$8G)(Fe,"aiRelatedInformation"),sn.registerEmbeddingVectorProvider(Fe,ie,pe)}},wn={_version:1,registerChatResponseProvider(ie,pe,Le){return(0,xe.$8G)(Fe,"chatProvider"),Ht.registerLanguageModel(Fe,ie,pe,Le)},registerChatVariableResolver(ie,pe,Le,lt,kt,zt,Li,In){return(0,xe.$8G)(Fe,"chatVariableResolver"),rn.registerVariableResolver(Fe,ie,pe,Le,lt,kt,zt,Li,In?.id)},registerMappedEditsProvider(ie,pe){return(0,xe.$8G)(Fe,"mappedEditsProvider"),De.registerMappedEditsProvider(Fe,ie,pe)},createChatParticipant(ie,pe){return Hi.createChatAgent(Fe,ie,pe)},createDynamicChatParticipant(ie,pe,Le){return(0,xe.$8G)(Fe,"chatParticipantPrivate"),Hi.createDynamicChatAgent(Fe,ie,pe,Le)}},vn={selectChatModels:ie=>Ht.selectLanguageModels(Fe,ie??{}),onDidChangeChatModels:(ie,pe,Le)=>Ht.onDidChangeProviders(ie,pe,Le),registerChatModelProvider:(ie,pe,Le)=>((0,xe.$8G)(Fe,"chatProvider"),Ht.registerLanguageModel(Fe,ie,pe,Le)),get embeddingModels(){return(0,xe.$8G)(Fe,"embeddings"),Ai.embeddingsModels},onDidChangeEmbeddingModels:(ie,pe,Le)=>((0,xe.$8G)(Fe,"embeddings"),Ai.onDidChange(ie,pe,Le)),registerEmbeddingsProvider(ie,pe){return(0,xe.$8G)(Fe,"embeddings"),Ai.registerEmbeddingsProvider(Fe,ie,pe)},async computeEmbeddings(ie,pe,Le){return(0,xe.$8G)(Fe,"embeddings"),Ai.computeEmbeddings(ie,pe,Le)},registerTool(ie,pe){return(0,xe.$8G)(Fe,"lmTools"),Oi.registerTool(Fe,ie,pe)},invokeTool(ie,pe,Le){return(0,xe.$8G)(Fe,"lmTools"),Oi.invokeTool(ie,pe,Le)},get tools(){return(0,xe.$8G)(Fe,"lmTools"),Oi.tools}},Cn={registerSpeechProvider(ie,pe){return(0,xe.$8G)(Fe,"speech"),on.registerProvider(Fe.identifier,ie,pe)}};return{version:St.version,ai:kn,authentication:Wi,commands:un,comments:fn,chat:wn,debug:Vi,env:Zi,extensions:Yi,interactive:$n,l10n:pn,languages:dn,lm:vn,notebooks:mn,scm:Sn,speech:Cn,tasks:gn,tests:hn,window:Si,workspace:Mi,Breakpoint:V.$yO,TerminalOutputAnchor:V.TerminalOutputAnchor,ChatResultFeedbackKind:V.ChatResultFeedbackKind,ChatVariableLevel:V.ChatVariableLevel,ChatCompletionItem:V.$tP,CallHierarchyIncomingCall:V.$WN,CallHierarchyItem:V.$VN,CallHierarchyOutgoingCall:V.$XN,CancellationError:y.$8,CancellationTokenSource:w.$ye,CandidatePortSource:i.CandidatePortSource,CodeAction:V.$SN,CodeActionKind:V.$TN,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.$YN,Color:V.$_N,ColorInformation:V.$aO,ColorPresentation:V.$bO,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CommentThreadApplicability:V.CommentThreadApplicability,CompletionItem:V.$6N,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.$7N,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.$jO,DebugAdapterExecutable:V.$CO,DebugAdapterInlineImplementation:V.$FO,DebugAdapterNamedPipeServer:V.$EO,DebugAdapterServer:V.$DO,DebugConfigurationProviderTriggerKind:li.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DebugVisualization:V.$VO,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.$LN,DiagnosticRelatedInformation:V.$KN,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.$xN,DocumentHighlight:V.$ON,DocumentHighlightKind:V.DocumentHighlightKind,MultiDocumentHighlight:V.$PN,DocumentLink:V.$$N,DocumentSymbol:V.$RN,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.$IO,InlineValueText:V.$JO,InlineValueVariableLookup:V.$KO,InlineValueEvaluatableExpression:V.$LO,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:k.$ne,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.$XO,FileDecoration2:V.$XO,FileSystemError:V.$OO,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:V.$PO,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.$AO,InlineCompletionItem:V.$8N,InlineCompletionList:V.$9N,Hover:V.$MN,VerboseHover:V.$NN,HoverVerbosityAction:V.HoverVerbosityAction,IndentAction:E.IndentAction,Location:V.$JN,MarkdownString:V.$ZN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:V.$1N,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.$yN,ProcessExecution:V.$hO,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.$WO,Range:V.$zN,RelativePattern:V.$wO,Selection:V.$AN,SelectionRange:V.$UN,SemanticTokens:V.$SO,SemanticTokensBuilder:V.$RO,SemanticTokensEdit:V.$TO,SemanticTokensEdits:V.$UO,SemanticTokensLegend:V.$QO,ShellExecution:V.$iO,ShellQuoting:V.ShellQuoting,SignatureHelp:V.$3N,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.$2N,SnippetString:V.$IN,SourceBreakpoint:V.$zO,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.$QN,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.$kO,TaskGroup:V.$gO,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.$cO,TerminalQuickFixTerminalCommand:V.$eO,TerminalQuickFixOpener:V.$dO,TerminalLocation:V.TerminalLocation,TerminalProfile:V.$fO,TerminalExitReason:V.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:V.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.$EN,SnippetTextEdit:V.$GN,TextEditorCursorStyle:s.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,SyntaxTokenType:V.SyntaxTokenType,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.$vO,ThemeIcon:V.$uO,TreeItem:V.$lO,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.$hP,UIKind:fi.UIKind,Uri:v.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.$HN,DocumentPasteTriggerKind:V.DocumentPasteTriggerKind,DocumentDropEdit:V.$rO,DocumentDropOrPasteEditKind:V.$sO,DocumentPasteEdit:V.$tO,InlayHint:V.$5N,InlayHintLabelPart:V.$4N,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.$DN,ResolvedAuthority:V.$BN,ManagedResolvedAuthority:V.$CN,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.$8O,NotebookRange:V.$ZO,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.$1O,NotebookData:V.$2O,NotebookRendererScript:V.$6O,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.$4O,NotebookCellOutputItem:V.$3O,NotebookCellStatusBarItem:V.$5O,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.$FN,NotebookKernelSourceAction:V.$7O,NotebookVariablesRequestKind:V.NotebookVariablesRequestKind,PortAttributes:V.$0O,LinkedEditingRanges:V.$9O,TestResultState:V.TestResultState,TestRunRequest:V.$$O,TestMessage:V.$_O,TestTag:V.$aP,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Zt.TextSearchCompleteMessageType,DataTransfer:V.$qO,DataTransferItem:V.$mO,TestCoverageCount:V.$bP,FileCoverage:V.$dP,FileCoverage2:V.$dP,StatementCoverage:V.$eP,BranchCoverage:V.$fP,DeclarationCoverage:V.$gP,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.$iP,TabInputTextDiff:V.$jP,TabInputTextMerge:V.$kP,TabInputCustom:V.$lP,TabInputNotebook:V.$nP,TabInputNotebookDiff:V.$oP,TabInputWebview:V.$mP,TabInputTerminal:V.$pP,TabInputInteractiveWindow:V.$qP,TabInputChat:V.$rP,TabInputTextMultiDiff:V.$sP,TelemetryTrustedValue:c.$wp,LogLevel:n.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,ChatCopyKind:V.ChatCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,DebugStackFrame:V.$GO,DebugThread:V.$HO,RelatedInformationType:V.RelatedInformationType,SpeechToTextStatus:V.SpeechToTextStatus,TextToSpeechStatus:V.TextToSpeechStatus,PartialAcceptTriggerKind:V.PartialAcceptTriggerKind,KeywordRecognitionStatus:V.KeywordRecognitionStatus,ChatResponseMarkdownPart:V.$uP,ChatResponseFileTreePart:V.$yP,ChatResponseAnchorPart:V.$zP,ChatResponseProgressPart:V.$AP,ChatResponseProgressPart2:V.$BP,ChatResponseReferencePart:V.$EP,ChatResponseWarningPart:V.$CP,ChatResponseTextEditPart:V.$FP,ChatResponseMarkdownWithVulnerabilitiesPart:V.$vP,ChatResponseCommandButtonPart:V.$DP,ChatResponseDetectedParticipantPart:V.$wP,ChatResponseConfirmationPart:V.$xP,ChatRequestTurn:V.$GP,ChatResponseTurn:V.$HP,ChatLocation:V.ChatLocation,LanguageModelChatMessageRole:V.LanguageModelChatMessageRole,LanguageModelChatMessage:V.$JP,LanguageModelChatMessageFunctionResultPart:V.$IP,LanguageModelChatResponseTextPart:V.$LP,LanguageModelChatResponseFunctionUsePart:V.$KP,LanguageModelChatMessage2:V.$JP,LanguageModelChatSystemMessage:V.$MP,LanguageModelChatUserMessage:V.$NP,LanguageModelChatAssistantMessage:V.$OP,LanguageModelError:V.$PP,NewSymbolName:V.$NO,NewSymbolNameTag:V.NewSymbolNameTag,NewSymbolNameTriggerKind:V.NewSymbolNameTriggerKind,InlineEdit:V.$QP,InlineEditTriggerKind:V.InlineEditTriggerKind}}}}),define(Ie[319],Pe([1,0,61,128,45,122,46,34,58,57,131,133,134,89,93,85,121,69,51,88,67,71,258,12,132,86,87,91,95,126,96]),function(_,e,w,y,k,O,R,N,v,s,I,E,u,C,d,n,o,c,h,i,r,t,a,l,g,m,$,S,D,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$Qs)(m.$spc,m.$rpc,w.InstantiationType.Delayed),(0,w.$Qs)(l.$bk,a.$Hqc,w.InstantiationType.Delayed),(0,w.$Qs)(n.$xoc,n.$yoc,w.InstantiationType.Delayed),(0,w.$Qs)(N.$lQ,N.$kQ,w.InstantiationType.Eager),(0,w.$Qs)(S.$Hoc,S.$Ioc,w.InstantiationType.Eager),(0,w.$Qs)(D.$mpc,D.$npc,w.InstantiationType.Eager),(0,w.$Qs)(R.$Woc,R.$Uoc,w.InstantiationType.Eager),(0,w.$Qs)(c.$Yoc,c.$Xoc,w.InstantiationType.Eager),(0,w.$Qs)(T.$Cpc,T.$Dpc,w.InstantiationType.Eager),(0,w.$Qs)(E.$Hpc,E.$Lpc,w.InstantiationType.Eager),(0,w.$Qs)(O.$Npc,O.$Mpc,w.InstantiationType.Eager),(0,w.$Qs)(v.$aQ,v.$_P,w.InstantiationType.Eager),(0,w.$Qs)($.$tpc,$.$upc,w.InstantiationType.Eager),(0,w.$Qs)(h.$Boc,h.$Aoc,w.InstantiationType.Eager),(0,w.$Qs)(y.$hqc,y.$gqc,w.InstantiationType.Delayed),(0,w.$Qs)(u.$4pc,u.$5pc,w.InstantiationType.Eager),(0,w.$Qs)(C.$fpc,C.$epc,w.InstantiationType.Eager),(0,w.$Qs)(I.$uqc,I.$tqc,w.InstantiationType.Eager),(0,w.$Qs)(s.$ipc,s.$lpc,w.InstantiationType.Eager),(0,w.$Qs)(b.$vqc,b.$wqc,w.InstantiationType.Eager),(0,w.$Qs)(d.$_Fb,d.$aGb,w.InstantiationType.Eager),(0,w.$Qs)(o.$Fqc,o.$Eqc,w.InstantiationType.Eager),(0,w.$Qs)(k.$Toc,k.$Soc,w.InstantiationType.Eager),(0,w.$Qs)(i.$ppc,i.$opc,w.InstantiationType.Eager),(0,w.$Qs)(r.$jQ,r.$gQ,w.InstantiationType.Eager),(0,w.$Qs)(t.$9oc,t.$0oc,w.InstantiationType.Eager),(0,w.$Qs)(g.$Apc,g.$Bpc,w.InstantiationType.Eager)}),define(Ie[320],Pe([1,0,318,47,2,315,7,11,265]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tsc=void 0;class s extends O.$Kqc{k(){}getModule(C,d){for(const n of this.b){const o=n(C);if(o){C=o;break}}if(this.a.has(C))return this.a.get(C).load(C,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends y.$wpc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(v.$Ssc);const C=this.h.invokeFunction(w.$Gqc);this.r=this.h.createInstance(s,C,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(C){return C.browser}async xb(C,d,n){d=d.with({path:E(d.path,".js")});const o=C?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const c=k.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(c.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),h.status!==200)throw new Error(h.statusText);const i=await h.text(),r=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${r}`;let a;try{a=new Function("module","exports","require",t)}catch($){throw console.error(o?`Loading code for extension ${o} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${d.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}C&&await this.w.initializeLocalizedMessages(C);const l={},g={exports:l},m=$=>{const S=this.r.getModule($,d);if(S===void 0)throw new Error(`Cannot load module '${$}'`);return S};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),a(g,l,m),g.exports!==l?g.exports:l}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(C){}async Bb(C=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+C;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,N.$Hh)(10)}}e.$Tsc=I;function E(u,C){return u.endsWith(C)?u:u+C}}),define(Ie[321],Pe([1,0,74,61,12,47,229,92,320]),function(_,e,w,y,k,O,R,N,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Qs)(k.$ak,new w.$Di(R.$Jqc,[!0],!0)),(0,y.$Qs)(O.$xpc,v.$Tsc,y.InstantiationType.Eager),(0,y.$Qs)(N.$Zoc,N.$1oc,y.InstantiationType.Eager)}),define(Ie[329],Pe([1,0,23,6,84,316,267,20,65,16,2,319,321]),function(_,e,w,y,k,O,R,N,v,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,N=Ve(N),v=Ve(v);const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function C(a){return/^(file|vscode-remote):/i.test(a)}const d=fetch.bind(self);function n(a){self.fetch=async function(l,g){return l instanceof Request||C(String(l))&&(l=(await a(I.URI.parse(String(l)))).toString(!0)),d(l,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,g,m,$,S){(async()=>(C(g.toString())&&(g=(await a(I.URI.parse(g.toString()))).toString(!0)),super.open(l,g,m??!0,$,S)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const a=self.Worker;Worker=function(l,g){if(/^file:/i.test(l.toString()))l=s.$1g.uriToBrowserUri(I.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(T){function P(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const p=fetch.bind(self);self.fetch=function(M,L){return M instanceof Request?p(M,L):p(P(M),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,L,K,J,z){return super.open(M,P(L),K??!0,J,z)}};const f=importScripts.bind(self);self.importScripts=(...M)=>{f(...M.map(P))},f(T)}.toString()}('${l}'))`;g=g||{},g.name=`${name} -> ${g.name||N.$qc(l.toString())}`;const S=new Blob([$],{type:"application/javascript"}),D=URL.createObjectURL(S);return new a(D,g)}}else self.Worker=class extends R.$Usc{constructor(a,l){super(u,a,{name:N.$qc(a.toString()),...l})}};const o=new class{constructor(){this.pid=void 0}exit(a){E()}};class c{constructor(){const l=new MessageChannel,g=new y.$ne;let m=!1;u(l.port2,[l.port2]),l.port1.onmessage=$=>{const{data:S}=$;if(!(S instanceof ArrayBuffer)){console.warn("UNKNOWN data received",S);return}const D=w.$Pe.wrap(new Uint8Array(S,0,S.byteLength));if((0,k.$Dn)(D,k.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}g.fire(D)},this.protocol={onMessage:g.event,send:$=>{if(!m){const S=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);l.port1.postMessage(S,[S])}}}}}function h(a){return new Promise(l=>{const g=a.onMessage(m=>{g.dispose();const $=JSON.parse(m.toString());a.send((0,k.$Cn)(k.MessageType.Initialized)),l({protocol:a,initData:$})});a.send((0,k.$Cn)(k.MessageType.Ready))})}let i=a=>E();function r(a){return!!a&&typeof a=="object"&&a.type==="vscode.init"&&a.data instanceof Map}function t(){v.mark("code/extHost/willConnectToRenderer");const a=new c;return{onmessage(l){r(l)&&h(a.protocol).then(g=>{v.mark("code/extHost/didWaitForInitData");const m=new O.$Mqc(g.protocol,g.initData,o,null,l.data);n($=>m.asBrowserUri($)),i=$=>m.terminate($)})}}}})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
